# phase0\_scripts
Perl/Python/awk scripts bundled with the PHASE/0 program.

# usage

## animate.pl
    Usage: animate.pl modes.data [ control.inp ]  
    Format of control.inp:  

    origin  X Y Z
    vector1 A1x A1y A1z
    vector2 A2x A2y A2z
    vector3 A3x A3y A3z
    max_displacement Umax

## band\_orbital\_proj.pl

    Usage: band_orbital_proj.pl EnergyDataFile KpointFile OrbProjFile -erange=Emin,Emax -einc=dE -with\_fermi -atom\_range=amin,amax -il=L -im=M -tau=TAU -element=X -key=I -score\_range=scmin,scmax -cbrange=Cbmin,Cbmax -circle\_radius=SIZE -window\_width=SIZE -color -print\_format={eps,png} -outfile=AAA 

## band\_unfold.pl
    Usage :
    * Plotting spectral weight 
        band_unfold.pl EnergyDataFile KpointFile SpectralWeightFile -erange=Emin,Emax -einc=dE -window_width=SIZE -with_dispersion -with_fermi -circle_radius=SIZE -color -print_format={eps,png} -outfile=AAA 

    * Plotting spectral function 
        band-unfold.pl EnergyDataFile KpointFile SpectralWeightFile -spectral_func -erange=Emin,Emax -einc=dE -window_width=SIZE -ndiv=VAL -sigma=VAL -line_width=VAL-cbrange=Cbmin,Cbmax -color -print_format={eps,png} -outfile=AAA 

## band.pl

    Usage: band.pl EnergyDataFile KpointFile -erange=Emin,Emax -einc=dE -ptype={solid_circles|lines} -with_fermi -width=SIZE -color

## band\_kpoint.pl
    Usage: band_kpoint.pl InputFile  
    Format of input file:  
    distance  
    b1x b2x b3x  
    b1y b2y b3y  
    b1z b2z b3z  
    k1 k2 k3 denom # X  
    k1 k2 k3 denom # Gamma  
    k1 k2 k3 denom # L  
    ....  

## berry.pl
    Usage : berry.pl control [OPTIONS]  

## conv.py
    atomic configuration converter utility.  
    Copyright (C) the RISS project, The University of Tokyo  
    Usage: conv.py [options]  

    The PHASE I/O utility script. This script will enable you to :  
    1. validate  your PHASE input,  
    2. generate default input file from atomic coordinates and  
    3. convert PHASE input/output data for use with other programs, and vice-versa. refer to the user's manual for details.  

    Options:  
  
    --version             show program's version number and exit  
    -h, --help            show this help message and exit  
    -l LOGLEVEL, --loglevel=LOGLEVEL  
                          specify the log level (one of 0,1,2)  
    --prop=PROPFILE       specify the property file. this will overload the  
                          default settings  
    --ppdir=PPDIR         specify the directory where the pp files reside. if  
                          unspecified, the string specified in the property file  
                          will be used.  
    -b, --batch           specify this option in order to perform this script in  
                          batch mode (for geninp and conv).  
    --input_type=INPUT_TYP  
                          specify the type of the input atomic coordinates  
    --output_type=OUTPUT_TYP  
                          specify the type of the output atomic coordinates  
    --input_file=INPUT_FILE  
                          specify the type of the input atomic coordinate file  
    --output_file=OUTPUT_FILE  
                          specify the type of the output atomic coordinate file  
    -f FRAME_NO, --frameno=FRAME_NO  
                          specify the target frame no. (enter a negative value  
                          in order to output all frames when possible)  
    --ibtype=IBTYPE       specify the type for the babel program (for input)  
    --obtype=OBTYPE       specify the type for the babel program (for output)  
    --babel_opts=BABEL_OPTS  
                          options to be passed to the babel program  
    -a, --all             specify this option if you want to do conversion  
                          against all supported file formats.  
    -p, --pack            specify this option if you want to 'pack' the atomic  
                          coordinates into the unit cell.  
    --na=NA               specify supercell size for the a-axis  
    --nb=NB               specify supercell size for the b-axis  
    --nc=NC               specify supercell size for the c-axis  

## dos.pl
    Version: 3.00

    Usage: dos.pl DosData -erange=Emin,Emax -einc=dE -dosrange=DOSmin,DOSmax -dosinc=dDOS -title=STRING -with_fermi -width=SIZE -font=SIZE -color -mode={total|layer|atom|projected} -epsf={yes|no} -data={yes|no}

## dos.py
    Usage: 
    dos.py [OPTION] 

    Options:
    
    --version             show program's version number and exit
    -h, --help            show this help message and exit
    -i, --interactive     specify this option in order to run this script
                          interactively
    -g, --gui             specify this option in order to boot the GUI
    -l LOGLEVEL, --loglevel=LOGLEVEL
                          specify the loglevel. 1: INFO, 2: DEBUG, 3: WARN;
                          defaults to 1
    -f FILE, --file=FILE  the DOS file [default : dos.data]
    --output000=OUTPUT000
                          the outputxxx file [default : the most recent
                          outputxxx file]
    -m MODE, --mode=MODE  specify the run mode. one of total, atom, layer,
                          projected. multiple     modes can be specified by a
                          comma-separated string. defaults to total.
    -a ACTION, --action=ACTION
                          specify the 'action'. action can be one of analyze,
                          sum, or split. multiple actions may be specified by a
                          comma-seperated string.
    --heatmap             specify this option in order to create a heatmap for
                          the layer DOS.
    -o OUTPUT_ACTION, --output_action=OUTPUT_ACTION
                          specify the output action. one of genfig, storedata or
                          both. defaults to both

    filter options:
      options used to select a subset of the DOS

    --dosid=DOSID       specify the ids of the DOS to sum; for example, 3-5,7
                        will be interpereted as 3,4,5,7. does not make sense
                        when --mode=total ()
    --atomid=ATOMID     specify the atom ids. this is the same as dosid for
                        aldos, but not for pdos.
    --layerid=LAYERID   specify the layer ids. this is the same as dosid for
                        layerdos.
    --elemid=ELEMID     specify the element ids.
    --lid=LID           specify the l ids. can be either an integer or a
                        string; namely 0 or s, 1 or p, 2 or d and 3 or f.
    --mid=MID           specify the m ids.
    --tid=TID           specify the t ids.

    figure options:
      options for configuring the output figure

    -e ERANGE, --erange=ERANGE
                        specify the energy range in the form emin,emax
    --einc=EINC         energy tics
    -d DRANGE, --drange=DRANGE
                        specify the DOS range in the form dmin,dmax
    --dinc=DINC         DOS tics
    --lrange=LRANGE     specify the layer range in the form lmin,lmax
    --arange=ARANGE     specify the atom ID range in the form amin,amax
    --linc=LINC         layer tics
    --with_fermi        specify this option in order to draw a vertical line
                        at the Fermi level
    --title             specify this option in order to set a title in a plot
    --level=LEVEL       specify the contour level for the heatmap
    --cmap=CMAP         specify the color map to be used in the layer dos
                        heatmap plot.    refer to https://matplotlib.org/3.1.1
                        /gallery/color/colormap_reference.html for possible
                        choices
    --imgtype=IMGTYPE   specify the output figure file type. one of : eps, ps,
                        png, jpg, pdf or svg. defaults to eps

## dynm2tr2.pl
    Usage: dynm2tr2.pl nfdynm.data [ control.inp ]  
    Format of control.inp:  

     origin  X Y Z
     vector1 A1x A1y A1z
     vector2 A2x A2y A2z
     vector3 A3x A3y A3z

## freq.pl
    *** A visualization program for vibrational freqencies ***  

    Usage: freq.pl [-width=W] [-height=H] [-nrep=N] {-solid|-mol|-ignored_modes=LIST} mode.data

## geninp.py
    input data generation utility for PHASE  
    Copyright (C) the RISS project, The University of Tokyo  
    Usage: geninp.py [options]  

    The PHASE I/O utility script. This script will enable you to :  
    1. validate  your PHASE input,   
    2. generate default input file from atomic coordinates and  
    3. convert PHASE input/output data for use with other programs, and vice-versa. refer to the user's manual for details.  

    Options:

    --version             show program's version number and exit
    -h, --help            show this help message and exit
    -l LOGLEVEL, --loglevel=LOGLEVEL
                          specify the log level (one of 0,1,2)
    --prop=PROPFILE       specify the property file. this will overload the
                          default settings
    --ppdir=PPDIR         specify the directory where the pp files reside. if
                          unspecified, the string specified in the property file
                          will be used.
    -b, --batch           specify this option in order to perform this script in
                          batch mode (for geninp and conv).
    -i INPUT, --input=INPUT
                          specify the atomic coordinate file
    -t TYPE, --type=TYPE  specify the type of the atomic coordinate file,  ie
                          'phase_input' for PHASE input file
    -f FRAMENO, --frameno=FRAMENO
                          specify the frame number (enter a negative value in
                          order to use the last frame)
    -d RESULT, --dest=RESULT
                          specify the destination directory to where the results
                          are stored. defaults to 'stropt'
    -c PINP_TYPE, --calc_type=PINP_TYPE
                          specify the calculation type of PHASE input.
    --temperature=TEMPERA
                          specify the target temperature in Kelvin units. makes
                          sence only when calc_type is md_nvt or md_nve
    --spin                set this option in order to perform spin-polarized
                          calculations.
    --nosymm              set this option in order to ignore crystal symmetry.
    -v CONVER, --convergence=CONVER
                          specify how aggressive the solvers and mixers should
                          be configured.
    -a ACCURA, --accuracy=ACCURA
                          specify the expected accuracy of the calculation.
    --end0_coord_type=END0COORD_TYPE
                          specify the corodinate type for the initial state (for
                          NEB)
    --end0_coord_file=END0COORD_FILE
                          specify the corodinate file for the initial state (for
                          NEB)
    --end0_frameno=END0FRAMENO
                          specify the frame number for the initial state (for
                          NEB)
    --end1_coord_type=END1COORD_TYPE
                          specify the corodinate type for the final state (for
                          NEB)
    --end1_coord_file=END1COORD_FILE
                          specify the corodinate file for the final state (for
                          NEB)
    --end1_frameno=END1FRAMENO
                          specify the frame number for the final state (for NEB)
    --btype=BTYPE         specify the file type for the Open Babel program
                          (makes sense only when --type=OpenBabel_Interface)

## inpcheck.py
    input data validator utility for PHASE  
    Copyright (C) the RISS project, The University of Tokyo  
    Usage: inpcheck.py [options]  

    The PHASE I/O utility script. This script will enable you to :  
    1. validate  your PHASE input,   
    2. generate default input file from atomic coordinates and  
    3. convert PHASE input/output data for use with other programs, and vice-versa. refer to the user's manual for details.  

    Options:  

    --version             show program's version number and exit
    -h, --help            show this help message and exit
    -l LOGLEVEL, --loglevel=LOGLEVEL
                          specify the log level (one of 0,1,2)
    --prop=PROPFILE       specify the property file. this will overload the
                          default settings
    --ppdir=PPDIR         specify the directory where the pp files reside. if
                          unspecified, the string specified in the property file
                          will be used.
    -b, --batch           specify this option in order to perform this script in
                          batch mode (for geninp and conv).
    -s SPECFILE, --specfile=SPECFILE
                          specify the name of the specification file.
    -r, --recursive       set this option in order to apply inpcheck recusively.

## phonon\_band.pl
    Usage : phonon_band.pl mode.data [OPTIONS]  

    OPTIONS  

    --units   or -u : specify the unit of energy. One of : mHa, meV, THz or cm-1.
    --ptype   or -p : specify the 'plot type'. either line or circle, defaults to line.
    --width   or -w : specify the width of the graph. defaults to 1. 
    --control or -c : specify the control file for the special k-points. defaults to 'bandkpt.in'. 
    --erange  or -e : specify the range of the energy by the form [emin:emax].
    --title   or -t : specify the title of the graph. 
    --font    or -f : specify the fontsize to be used in the graph. defaults to 18.
    --keep    or -k : specify this option in order to keep the intermediate data file.
    --mono    or -m : specify this option in order to create monochrome figures.
    --einc          : specify the tic for the y-axis.

## phonon\_dos.pl
    Usage : phonon_dos.pl phdos.data [OPTIONS]  

    OPTIONS

    --units  or -u : specify the unit of energy. One of : mHa, meV, THz or cm-1.
    --width  or -w : specify the width of the graph. defaults to 1. 
    --erange or -e : specify the range of the energy by the form [emin:emax].
    --drange or -d : specify the range of the DOS by the form [dmin:dmax].
    --title  or -t : specify the title of the graph. 
    --font   or -f : specify the fontsize to be used in the graph. defaults to 18.
    --keep   or -k : specify this option in order to keep the intermediate data file.
    --mono   or -m : specify this option in order to create monochrome figures.
    --dinc         : specify the tic for the y-axis.
    --einc         : specify the tic for the x-axis.

## phonon\_energy.pl
    Usage : phonon_energy.pl mode.data [OPTIONS]  

    OPTIONS  

    --width  or -w : specify the width of the graph. defaults to 1. 
    --trange or -t : specify the range of the temperatur by the form [tmin:tmax].
    --nT     or -n : specify the number of temperature points.
    --font   or -f : specify the fontsize to be used in the graph. defaults to 18.
    --mono   or -m : specify this option in order to create monochrome figures.
    --tinc         : specify the tic for the x-axis.
    --einc         : specify the tic for the y-axis (energy).
    --cinc         : specify the tic for the y-axis (specific heat).

## workfunc.pl
    Usage : workfunc.pl nfvlcr_av.data [OPTIONS]  

## calc\_defect\_formation\_energy.py
    usage: calc_defect_formation_energy.py [-h] [-o OUTFILE] [--de DE] [--emin EMIN] [--emax EMAX] [--vmin VMIN] [--vmax VMAX] [--image_format IMAGE_FORMAT] input

    Caulculte formation energy of a given defect
    
    positional arguments:
      input                 input file

    optional arguments:
      -h, --help            show this help message and exit
      -o OUTFILE, --outfile OUTFILE
                            output file name (default:result)
      --de DE               divisoin of energy scale (default:0.01)
      --emin EMIN           minimum of Fermi energy (default:-1.0)
      --emax EMAX           maximum of Fermi energy (default:6.0)
      --vmin VMIN           minimum of Formation energy (default:-5.0)
      --vmax VMAX           maximum of Formation energy (default:5.0)
      --image_format IMAGE_FORMAT
                            image format of figure (default:png)

## plot\_multiple\_defect\_formation\_energy.py
    usage: plot_multiple_defect_formation_energy.py [-h] [-o OUTFILE] [--emin EMIN] [--emax EMAX] [--vmin VMIN] [--vmax VMAX] [--keypos_h KEYPOS_H] [--keypos_v KEYPOS_V] [--image_format IMAGE_FORMAT] input

    Multiple plot of formation energy of defects

    positional arguments:
      input                 input file

    optional arguments:
      -h, --help            show this help message and exit
      -o OUTFILE, --outfile OUTFILE
                            output file name (default:result_all)
      --emin EMIN           minimum of Fermi energy
      --emax EMAX           maximum of Fermi energy
      --vmin VMIN           minimum of Formation energy
      --vmax VMAX           maximum of Formation energy
      --keypos_h KEYPOS_H   horizontal key position (left/center/right)
      --keypos_v KEYPOS_V   vertical key position (top/center/bottom)
      --image_format IMAGE_FORMAT
                            image format of figure (png/eps, default:png)

pp : pseudopotential

scf-fine : SCF calc.

cutoff_1.0_with_xc : local potential average with xc pot, radius of integration :1.0
cutoff_2.0_with_xc : local potential average with xc pot, radius of integration :2.0

cutoff_1.0_without_xc : local potential average without xc pot, 
                        radius of integration :1.0
cutoff_2.0_without_xc : local potential average without xc pot,
                        radius of integration :2.0

SCF
1. move to "scf" folder
2. do "mpirun ../../../bin/phase &"
3. after 30 minutes, SCF calculation will end.
4. be sure, "nfcharge.data" is generated.

DOS
1. move to "dos" folder
2. do "mpirun ../../../bin/ekcal &"
3. after 30 minutes, DOS calculation will end.
4. be sure, "dos.data" is generated.
5. in order to draw a graph, do
   "../../../tools/bin/dos.pl dos.data 
    -erange=-10,5 -with_fermi"
6. do "ghostview density_of_states.eps"

BAND
1. move to "band" folder
2. do "mpirun ../../../bin/ekcal &"
3. after 30 minutes, BAND calculation will end.
4. be sure, "nfenergy.data" is generated.
5. in order to draw a graph, do
   "../../../tools/bin/band.pl nfenergy.data 
    ../tools/bandkpt_bcc_ghnpgn.in
    -erange=-10,5 -with_fermi"
6. do "ghostview band_structure.eps"

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: Initial_MD_Condition
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Initial_MD_Condition
! $Id: Initial_MD_Condition.F90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Const_Parameters,   only : CONTINUATION, T_CONTROL, BLUEMOON, QUENCHED_CONSTRAINT &
 &                               , COORDINATE_CONTINUATION, INITIAL, FIXED_CHARGE_CONTINUATION
  use m_Files,              only : nfinp, nfcntn, nfout
#ifdef _EMPIRICAL_
  use m_Control_Parameters, only : icond, imdalg
  use m_IterationNumbers,   only : m_Iter_total_increment
#else
  use m_Control_Parameters, only : icond, imdalg, iprimd &
       &                         , m_CtrlP_rd_isolver
#endif
  use m_Total_Energy,       only : m_TE_rd_total_energy
  use m_Ionic_System,       only : m_IS_rd_forcp_etc &
       &                         , m_IS_rd_nrsv, m_IS_natm_can_change
!!$  use m_Ionic_System,       only : m_IS_rd_T_parameters, m_IS_rd_forcp_etc &
!!$       &                         , m_IS_rd_nrsv, m_IS_rd_nrsv_stdin

  implicit none
  if(icond == CONTINUATION.or.icond==COORDINATE_CONTINUATION.or.icond == FIXED_CHARGE_CONTINUATION) then
     call m_TE_rd_total_energy(nfcntn)
     if(iprimd >= 3 ) write(nfout,'(" imdalg = ",i8)') imdalg
     if(imdalg==T_CONTROL.or.imdalg==BLUEMOON.or.imdalg==QUENCHED_CONSTRAINT) then
        if(imdalg /= QUENCHED_CONSTRAINT) call m_IS_rd_nrsv(nfcntn)
        call m_IS_rd_forcp_etc(imdalg,nfcntn)
     end if
#ifndef _EMPIRICAL_
     call m_CtrlP_rd_isolver(nfcntn)
#endif
     if(icond==CONTINUATION.and.m_IS_natm_can_change())then
        icond = INITIAL
     endif
  end if

#ifdef _EMPIRICAL_
  call m_Iter_total_increment()
#endif

end subroutine Initial_MD_Condition

!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
! Functions:  [Identifier: 13.0D]
!                     NEB works with PAW
!
! =============================================================

subroutine do_neb()
  use m_Files,                only : nfneb,nfout
  use m_Const_Parameters, only : OFF,ON,PREPARATION_ONLY,RETURN_AFTER_SYMMCHECK,SKIP_SYMMCHECK
  use m_IterationNumbers, only : iteration,iteration_electronic,iteration_ionic
  use m_Replica
  use m_Parallelization, only : mpi_comm_group, mype, mype_conf, m_Parallel_end_mpi

! ======================== KT_add ================= 13.0D
  use m_Files,         only :  m_Files_open_nfcntn_bin_paw, nfout, nfcntn_bin_paw &
                            ,  m_Files_checkpoint_dir_neb
  use m_PseudoPotential,  only : flg_paw, m_PP_rd_PAW_parameters
  use m_Charge_Density,    only :  m_CD_alloc_chgsoft
! ================================================= 13.0D

  use m_Control_Parameters, only : sw_fcp, cpt_neb_iteration, icond, sw_hubbard
  use m_Fcp, only :  m_Fcp_set_neb_replica_totch, &
     m_Fcp_set_neb_replica_force, m_Fcp_update_neb, m_Fcp_set_neb_parameter, &
     m_Fcp_allreduce_neb_force, m_Fcp_initialize_neb_totch

  implicit none
  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Already_Converged, Positron_bulk
  logical  :: Hubbard_model
  logical  :: Forces_are_Converged, Ending_Time, Ending_Time2, Force_errors_are_tolerable
  logical  :: replica_converged

  integer i, j, itr, ierr
  integer mpi_err
  logical all_conv_flag

  integer prepare_communicator
  logical :: pp_generated

  logical :: dump_checkpoint
  logical :: to_dimer = .false.

  include 'mpif.h'

  call initialize_neb

  !call Initialization(OFF)
  !call InputData_Analysis(OFF) ! rd_cntn_data = ON

  call set_neb_condition
  call create_replica

  itr = 0
  all_conv_flag = all(neb%image(:)%scf_convergence)  ! for restart
  prepare_communicator = ON
  pp_generated=.false.

  do i=1,neb%number_of_images
     call set_neb_replica_parameter(i)
     call set_neb_replica_coordinate(i)
     if(.not.(i==1 .or. i==neb%number_of_images)) call InputData_Analysis_neb()
     call Preparation(RETURN_AFTER_SYMMCHECK)
     call set_sym(i)
     call deallocate_array_partial()
     call remove_annoying_files(nfout)
  enddo
  call m_Replica_resolve_lowest_symmetry(nfneb)
  if(icond == PREPARATION_ONLY)then
     call mpi_barrier(mpi_comm_group,ierr)
     call m_Parallel_end_mpi()
     stop 'The preparation has been done.'
  endif
  NEBIteration: do

     itr = itr + 1
     if(all(neb%image(:)%scf_convergence)) then
        neb%step = neb%step + 1
     end if
     call set_neb_parameter(itr)
     if( sw_fcp == ON ) call m_Fcp_set_neb_parameter(itr)

     MultiReplica: do i = 1, neb%number_of_images
        if(mod(i-1,nrank_r) /= mype_r) then
           neb%image(i)%scf_convergence = .true. 
           cycle
        end if
        call set_lowest_symmetry_op_tau()
        if(neb%cond%condition == 1) then
           if(itr == 1 .and. (.not. all_conv_flag)) then
              if(neb%image(i)%scf_convergence) then
                 !neb%image(i)%energy = neb%image(i)%energy0
                 !neb%image(i)%force = neb%image(i)%force0
                 !neb%image(i)%force_org = neb%image(i)%force0
                 cycle
              end if
           end if
        end if

        if(neb%cond%end0_energy_given .and. i==1)then
            neb%image(1)%energy = neb%image(1)%energy0
            cycle
        endif
        if(neb%cond%end1_energy_given .and. i==neb%number_of_images)then
            neb%image(neb%number_of_images)%energy = neb%image(neb%number_of_images)%energy0
            cycle
        endif
        if(itr > 1 .and. (i==1 .or. i==neb%number_of_images)) then
           neb%image(i)%energy = neb%image(i)%energy0
           neb%image(i)%force = neb%image(i)%force0
           neb%image(i)%force_org = neb%image(i)%force0
           cycle
        end if

!        write(nfneb,*) 'neb: ', neb%step, i, mype
        if (mype==0) write(nfneb,*) 'neb: ', neb%step, i

        call set_neb_replica_parameter(i)
        call set_neb_replica_coordinate(i)

        if(.not.neb%image(i)%scf_convergence) then
           call InputData_Analysis_neb()
        end if

        call Preparation(SKIP_SYMMCHECK)                   ! Basis set, symmetry check etc.
        call Preparation_for_mpi(prepare_communicator)           ! mpi

! ======================== KT_mod ================= 13.0D
!        if (.not.pp_generated) then
!          call PseudoPotential_Construction
!          pp_generated = .true.
!        endif

        if (.not.pp_generated) then
           call PseudoPotential_Construction
           pp_generated = .true.
#ifdef ENABLE_ESM_PACK
           call Preparation_for_ESM()
#endif
        else
           if ( flg_paw ) then
              if ( itr > 1 .or. neb%cond%condition == 1 ) then
                 call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
              endif
              call m_CD_alloc_chgsoft
           endif
        endif
! ================================================= 13.0D

        call Ewald_and_Structure_Factor
        call Initial_Electronic_Structure
        call Initial_MD_Condition

        if( sw_fcp == ON ) then
           call m_Fcp_initialize_neb_totch()
           call m_Fcp_set_neb_replica_totch(i)
        end if

        if(neb%cond%condition == 1 .and. neb%image(i)%scf_convergence) then 
           iteration = 0
           iteration_electronic = 0
           iteration_ionic = 0
        end if
        neb%image(i)%scf_convergence = .true.

        if(.not.Already_Converged()) then
           AtomicConfiguration: do
              ChargeDensity:    do
                 call IterationNumber_Setting
                 call Renewal_of_WaveFunctions
                 call ChargeDensity_Construction(1)
                 call ChargeDensity_Mixing
                 call Renewal_of_Potential
                 if(Hubbard_model()) then
                    call Renewal_of_Hubbard_Potential
                 end if
!                 if(Ending_Time())                 exit ChargeDensity
                 if(Ending_Time()) then
                    neb%image(i)%scf_convergence = .false.
                    exit AtomicConfiguration
                 end if
                 if(TotalEnergy_is_Divergent())    exit ChargeDensity                    
                 if(ChargeDensity_is_Converged())  exit ChargeDensity
              enddo ChargeDensity
#ifdef LIBRARY_BUILD
              call Forces_phase0
#else
              call Forces
#endif
!              if(Forces_are_Converged()) exit AtomicConfiguration
              exit AtomicConfiguration
!!$              if(Force_errors_are_tolerable()) then
!!$                 call Move_Ions
!!$                 call Ewald_and_Structure_Factor
!!$                 call MDIterationNumber_Setting
!!$              end if

           enddo AtomicConfiguration

        end if

!        if(.not.Ending_Time2()) call set_neb_replica_energy_force(i)
        call set_neb_replica_energy_force(i)
        if( sw_fcp == ON ) call m_Fcp_set_neb_replica_force(i)

!!$        if(Positron_bulk()) then
!!$           call Renewal_of_pPotential()
!!$           call Solve_pWaveFunctions()
!!$        end if

!!$        call Postprocessing
        call WriteDownData_onto_Files(.true.)

        call deallocate_array

        if (mype==0) write(nfneb,*) 'scf convergence: ', i, neb%image(i)%scf_convergence

!!        prepare_communicator=OFF
        first_replica_done = .true.
        call flush(nfneb)
     end do MultiReplica

     call allreduce_scf_convergence
     call allreduce_neb_energy_force
     if( sw_fcp == ON ) call m_Fcp_allreduce_neb_force(nrank_r)

     if(.not. all(neb%image(:)%scf_convergence)) then
        if( mype==0) write(nfneb,*) 'scf not convergence...'
        exit NEBIteration
     end if

!     call allreduce_neb_energy_force

     call force_neb
     call atom_update_neb
     if( sw_fcp == ON ) call m_Fcp_update_neb(neb%dt, neb%cond%time_integral)
!     call atom_update_pos_neb

     if(replica_converged()) then
        exit NEBIteration
     end if
     if(neb%max_iteration>0 .and. neb%step >= neb%max_iteration) then
        exit NEBIteration
     end if

     if(dump_checkpoint(itr)) then
        call m_Files_checkpoint_dir_neb()
        call write_down_data_replica(.false.)
     endif

     if(curr_thres < neb%cond%dimer_thres) then
       to_dimer = .true.
       exit NEBIteration
     endif
        
  end do NEBIteration

  call m_Files_checkpoint_dir_neb()
  call write_down_data_replica(.not. to_dimer)

  if(.not. to_dimer) then
    call finalize_neb()
    call mpi_finalize(mpi_err)
  else
    call transition_to_dimer_method()
  endif
end subroutine do_neb

subroutine transition_to_dimer_method()
  use m_Ionic_System, only : cps_end0, cps_end1
  use m_Parallelization, only : mype
  use m_Files, only : nfneb
  use m_dimer, only : m_dm_set_pp_generated, m_dm_set_standard_out_opened, m_dm_do_dimer_method
  use m_Control_Parameters, only : icond
  use m_Replica
  implicit none
  integer :: k, targ, mpi_err
  real(kind=8) :: max_energy
  if(mype==0) write(nfneb, *) 'transitioning to the dimer method'
  max_energy = maxval( neb%image(:)%energy )
  targ = -1
  do k=2,neb%number_of_images-1
     if (neb%image(k)%energy==max_energy) then
        targ = k
        exit
     endif
  enddo
  if (targ<0) then
    if(mype==0) write(nfneb,*) 'failed to find the highest-energy replica'
    call finalize_neb()
    call mpi_finalize(mpi_err)
  else
    if(mype==0) then
      write(nfneb,*) 'create initial dimer from replica ',targ-1,targ+1
    endif
    cps_end0 = neb%image(targ-1)%cps 
    cps_end1 = neb%image(targ+1)%cps 
    icond = 0
!    call m_Files_open_standardout()
    call finalize_neb()
    call m_dm_set_pp_generated(.true.)
    call m_dm_set_standard_out_opened(.false.)
    call m_dm_do_dimer_method()
  endif

end subroutine transition_to_dimer_method

subroutine remove_annoying_files(nf)
  use m_Parallelization, only : mype
  use m_Control_Parameters,  only : ipriparadeb
  implicit none
  integer, intent(in) :: nf
#ifdef NEB_NEW_FILENAMES
  return
#endif
  if ( mype == 0 ) then
     close(nf)
  else if(ipriparadeb == 0) then
     close(nf, status='delete')
  else
     close(nf, status='keep')
  end if
end subroutine remove_annoying_files

subroutine set_sym(i)
  use m_Replica
  use m_Const_Parameters, only : DP
  use m_Crystal_Structure, only : nopr,op,tau
  implicit none
  integer, intent(in) :: i
  neb%image(i)%symmetry%nopr = nopr
  allocate(neb%image(i)%symmetry%op(3,3,nopr))
  allocate(neb%image(i)%symmetry%tau(3,nopr,2))
  neb%image(i)%symmetry%op = op
  neb%image(i)%symmetry%tau = tau
end subroutine set_sym

subroutine set_lowest_symmetry_op_tau()
  use m_Replica
  use m_Crystal_Structure, only : nopr,op,tau
  implicit none
  if(.not.allocated(op)) allocate(op(3,3,nopr_lowest))
  if(.not.allocated(tau)) allocate(tau(3,nopr_lowest,2))
  nopr = nopr_lowest
  op = op_lowest
  tau = tau_lowest
end subroutine set_lowest_symmetry_op_tau

subroutine set_sym_back(i)
  use m_Replica
  use m_Const_Parameters, only : DP
  use m_Crystal_Structure, only : nopr,op,tau
  implicit none
  integer, intent(in) :: i
  integer :: j
  nopr = neb%image(i)%symmetry%nopr
  do j=1,nopr
     op(1:3,1:3,j) = neb%image(i)%symmetry%op(1:3,1:3,j)
     tau(1:3,j,1) = neb%image(i)%symmetry%tau(1:3,j,1)
     tau(1:3,j,2) = neb%image(i)%symmetry%tau(1:3,j,2)
  enddo
end subroutine set_sym_back

logical function dump_checkpoint(itr)
  use m_Control_Parameters, only : cpt_neb_iteration, cpt_time, m_CtrlP_get_elpsd_time
  use m_Const_Parameters, only : DP
  use m_Parallelization, only : mpi_comm_group,mype
  use m_Files, only : nfneb
  implicit none
  integer, intent(in) :: itr
  real(kind=DP), save :: last_time=0.d0
  real(kind=DP) :: curr_time
  integer :: ierr
  logical :: write_chkpnt, lneb, ltime
  write_chkpnt=.false.;lneb = .false.;ltime=.false.
  if(cpt_neb_iteration>0)then
     if(mod(itr,cpt_neb_iteration)==0) then
       write_chkpnt = .true.
       lneb = .true.
     endif
  endif
  curr_time = m_CtrlP_get_elpsd_time()
  if (cpt_time>0 .and. (curr_time-last_time)>cpt_time) then
     write_chkpnt = .true.
     ltime = .true.
     last_time = curr_time
     call mpi_barrier(mpi_comm_group,ierr)
  endif
  if(write_chkpnt) then
     if(mype==0) then
        write(nfneb,'(a)')            '!** dumped checkpoint files because '
        if (lneb)  write(nfneb,'(a)') '!** neb iteration '
        if (ltime) write(nfneb,'(a)') '!** elapsed time '
        write(nfneb,'(a)')            '!** met the criterion'
     endif
  endif
  dump_checkpoint = write_chkpnt
end function dump_checkpoint

!   Nudged Elastic Band Method
!   Nobutaka Nishikawa

subroutine initialize_neb

  use m_Parallelization,      only : mpi_comm_group, nrank_e, nrank_k, nrank_conf, mype_conf
  use m_Files,                only : nfneb, F_NEB_OUT
  use m_Replica

  implicit none
  integer i, j
  integer npes,mype,icolor,ikey,mpi_err
  integer, allocatable ::  new_comm_world(:)
!  integer nrank_r, mype_r
  integer mype_e, npes_e
  integer iargc
  character(100) arg
  character(4) image_name

  include 'mpif.h'

  nrank_r = nrank_conf
  mype_r  = mype_conf
  neb%step = 0

!  write(6,*) 'program start...'
!  write(6,*)
!
!  call mpi_init(mpi_err)
!
!  call mpi_comm_size(mpi_comm_world,npes,mpi_err)
!!  call mpi_comm_rank(mpi_comm_world,mype,mpi_err)
!
!  nrank_r = 0
!  if(mype==0) then
!     do i = 1, iargc()
!        call getarg(i,arg)
!        if( arg(1:3) == 'nr=' ) then
!           read(arg(4:),*) nrank_r
!        end if
!     end do
!  end if
!  if(nrank_r == 0) nrank_r = npes
!  call mpi_bcast(nrank_r,1,mpi_integer,0,mpi_comm_world,mpi_err)
!
!  allocate(new_comm_world(0:nrank_r-1))
!  do i=0,nrank_r-1
!     icolor = 0
!     ikey = 0
!     do j=0, npes/nrank_r-1
!        if(mype == j + (npes/nrank_r)*i ) then
!           icolor = 1
!           ikey = i
!        end if
!     end do
!     call mpi_comm_split( mpi_comm_world, icolor, ikey, new_comm_world(i), mpi_err )
!  end do
!
!  mype_r = mype/(npes/nrank_r)
!  mpi_comm_group = new_comm_world(mype_r)
!
!  call mpi_comm_size(mpi_comm_group,npes_e,mpi_err)
!  call mpi_comm_rank(mpi_comm_group,mype_e,mpi_err)
!
!  write(6,'("mpi: pe=",i4,",  npes=",i4,",  comm=",i20)') mype, npes, mpi_comm_world
!  write(6,'("   neb: ",i4,",  nr=",i4,"    energy: ",i4,",  ne*nk=",i4,",  comm=",i20)') &
!       mype_r, nrank_r, mype_e, npes_e, mpi_comm_group
!  write(6,*)
!
!  neb%step = 0

end subroutine initialize_neb

subroutine initialize_neb_ep

  use m_Parallelization,      only : mpi_comm_group
  use m_Files,                only : nfneb, F_NEB_OUT
  use m_Replica

  implicit none

  integer mype, npes, mpi_err

  include 'mpif.h'

  call mpi_init(mpi_err)

  call mpi_comm_size(mpi_comm_world,npes,mpi_err)
  call mpi_comm_rank(mpi_comm_world,mype,mpi_err)

  mpi_comm_group = mpi_comm_world

  neb%step = 0

  write(6,'(a6,4i5)') ' mpi: ', mype, npes, mpi_comm_world, mpi_comm_group

end subroutine initialize_neb_ep

subroutine set_neb_condition

  use m_Const_Parameters, only : ON
  use m_Control_Parameters, only : icond, multiple_replica_max_iteration, sw_hubbard
  use m_Ionic_System,  only : neb_max_iteration, neb_dt, ci_neb &
                            , sp_k_init, sp_k_min, sp_k_max, sp_k_variable &
                            , penalty_function &
                            , neb_convergence_condition, neb_convergence_threshold &
                            , neb_time_integral,ci_index,ci_thres,sd_factor &
                            , end0_energy_given, end1_energy_given, to_dimer_thres
  use m_Files,         only : F_OUT, F_DYNM, F_ENF, F_CHGT, F_CNTN, F_CNTN_BIN &
                            , F_ZAJ, F_CHR, nfneb, F_NEB_OUT &
                            , nfnebenf, F_NEB_ENF, nfnebdynm, F_NEB_DYNM &
                            , nfdynm, nfenf, nfout
  use m_Parallelization,      only : mpi_comm_group
  use m_Replica

! ======================== KT_add ================= 13.0D
  use m_PseudoPotential,  only : flg_paw
  use m_Files,         only : F_CNTN_BIN_PAW
! ================================================= 13.0D
  use m_Files,         only : F_OCCMAT

! ====== KT_add === 2014/07/20
  use m_Control_parameters, only : ipriparadeb, reuse_nfout_for_nfneb
  use m_Files,         only : F_OUT_BASE, F_CONF_EXTENSION, F_Para_EXTENSION
! ================= 2014/07/20

  use m_dimer,         only : set_dimer_condition

  implicit none

  integer mype, npes, mpi_err
  integer mype_e, npes_e
  character(4) image_name

  logical :: existence

  include 'mpif.h'

  call mpi_comm_size(mpi_comm_world,npes,mpi_err)
  call mpi_comm_rank(mpi_comm_world,mype,mpi_err)
  call mpi_comm_size(mpi_comm_group,npes_e,mpi_err)
  call mpi_comm_rank(mpi_comm_group,mype_e,mpi_err)

! ====== KT_add ======== 2014/07/20
  if ( mype_e == 0 ) then
     close(nfout)
  else if(ipriparadeb == 0) then
     close(nfout, status='delete')
  else
     close(nfout, status='keep')
  end if
! ===================== 2014/07/20

! === KT_mod ========== 2014/07/20
#ifdef NEB_NEW_FILENAMES
  if ( reuse_nfout_for_nfneb == 1 ) then
     neb%file%F_NEB_OUT = trim(F_OUT_BASE) // trim(adjustl(F_CONF_EXTENSION)) &
          &                                // trim(adjustl(F_PARA_EXTENSION))
     if (mype_e==0) then
        open(nfneb,file=neb%file%F_NEB_OUT,status='unknown',position='append')
     endif
  else
!     neb%file%F_NEB_OUT = trim(F_NEB_OUT) // trim(adjustl(F_CONF_EXTENSION)) &
!          &                               // trim(adjustl(F_PARA_EXTENSION))
     neb%file%F_NEB_OUT = trim(F_OUT_BASE) // '_neb' &
          &                                // trim(adjustl(F_CONF_EXTENSION)) &
          &                                // trim(adjustl(F_PARA_EXTENSION))
     if (mype_e==0) open(nfneb,file=neb%file%F_NEB_OUT)
  endif
#else
  if(npes > 1) then
     write(image_name,'(a1,i3.3)') 'p', mype
     neb%file%F_NEB_OUT = trim(F_NEB_OUT)//'_'//image_name
  else
     neb%file%F_NEB_OUT = trim(F_NEB_OUT)
  end if
  open(nfneb,file=neb%file%F_NEB_OUT)
#endif
! ===================== 2014/07/20

  !write(nfneb,'(a6,4i5)') ' mpi: ', mype, npes, mpi_comm_world, mpi_comm_group
  !write(nfneb,'(a6,8i8)') ' mpi: ', mype, npes, mpi_comm_world, &
  !     mype_r, nrank_r, &
  !     mype_e, npes_e, mpi_comm_group

  neb%cond%condition = icond
  if (mype_e==0) write(nfneb,*) 'neb_condition: ', neb%cond%condition

  neb%cond%end0_energy_given = end0_energy_given
  neb%cond%end1_energy_given = end1_energy_given

  !neb%max_iteration = neb_max_iteration
  neb%max_iteration = multiple_replica_max_iteration
  if (mype_e==0) write(nfneb,*) 'max_iteration: ', neb%max_iteration

  neb%dt = neb_dt
  if (mype_e==0) write(nfneb,*) 'dt: ', neb%dt

  neb%cond%sd_factor = sd_factor

  neb%cond%k_spring_init = sp_k_init
  neb%cond%k_spring_min = sp_k_min
  neb%cond%k_spring_max = sp_k_max
  if (mype_e==0) write(nfneb,'(a11,3f10.5)') 'k_spring: ', &
       neb%cond%k_spring_init,neb%cond%k_spring_min,neb%cond%k_spring_max

  select case(sp_k_variable)
  case(0)
     neb%cond%k_variable = .false.
  case(1)
     neb%cond%k_variable = .true.
  end select
  if (mype_e==0) write(nfneb,*) 'sp_k_variable: ', neb%cond%k_variable

  select case(ci_neb)
  case(0)
     neb%cond%climbing_image = .false.
  case(1)
     neb%cond%climbing_image = .true.
  end select
  neb%cond%ci_index = ci_index
  neb%cond%ci_thres = ci_thres
  neb%cond%dimer_thres = to_dimer_thres
  if (mype_e==0) then
    write(nfneb,*) 'ci_neb: ', neb%cond%climbing_image
    if (neb%cond%ci_index>1 .and. neb%cond%ci_index<neb%number_of_images)then
      write(nfneb,*)'ci_index: ',neb%cond%ci_index
    endif
    write(nfneb,*)'ci_thres: ',neb%cond%ci_thres
    if(neb%cond%dimer_thres>0) then
      write(nfneb,'(a,f10.5)') 'switch to the dimer method if convergence is better than ' &
                      , neb%cond%dimer_thres
    endif
  endif

  if(neb%cond%dimer_thres>0) then
    call set_dimer_condition()
  endif

  neb%cond%ci_neb_start = 0
  neb%cond%ci_neb_end = 0

  select case(penalty_function)
  case(0)
     neb%cond%penalty_function = .false.
  case(1)
     neb%cond%penalty_function = .true.
  end select
  if (mype_e==0) write(nfneb,*) 'penalty_function: ', neb%cond%penalty_function

  neb%cond%k_damping = .false.
  neb%cond%k_damping_factor = 1.0d0

  neb%cond%convergence_condition = neb_convergence_condition
  if (mype_e==0) write(nfneb,*) 'convergence_condition: ', neb%cond%convergence_condition
  neb%cond%convergence_threshold = neb_convergence_threshold
  if (mype_e==0) write(nfneb,*) 'convergence_threshold: ', neb%cond%convergence_threshold
  
  !neb%cond%time_integral = 'verlet'
  neb%cond%time_integral = 'velocity_verlet'
  !neb%cond%time_integral = 'steepest_descent'
  select case(neb_time_integral)
  case(2)
     neb%cond%time_integral = 'velocity_verlet'
  case(12)
     neb%cond%time_integral = 'steepest_descent'
  case(20)
     neb%cond%time_integral = 'lbfgs'
  case(16)
     neb%cond%time_integral = 'bfgs'
  case(11)
     neb%cond%time_integral = 'cg'
  case(-7)
     neb%cond%time_integral = 'fire'
  end select
  if (mype_e==0) write(nfneb,*) 'time_integral: ', neb%cond%time_integral

  neb%file%F_OUT = F_OUT
  !neb%file%F_DYNM = F_DYNM
  !neb%file%F_ENF = F_ENF
  neb%file%F_CHGT = F_CHGT
  neb%file%F_CNTN = F_CNTN
  neb%file%F_CNTN_BIN = F_CNTN_BIN
  neb%file%F_ZAJ = F_ZAJ
  neb%file%F_CHR = F_CHR

! ======================== KT_add ================= 13.0D
  neb%file%F_CNTN_BIN_PAW = F_CNTN_BIN_PAW
! ================================================= 13.0D
  neb%file%F_OCCMAT = F_OCCMAT

  if (mype_e==0) then
     write(nfneb,*) 'F_OUT: ', trim(neb%file%F_OUT)
  !write(nfneb,*) 'F_DYNM: ', trim(neb%file%F_DYNM)
  !write(nfneb,*) 'F_ENF: ', trim(neb%file%F_ENF)
     write(nfneb,*) 'F_CHGT: ', trim(neb%file%F_CHGT)
     write(nfneb,*) 'F_CNTN: ', trim(neb%file%F_CNTN)
     write(nfneb,*) 'F_CNTN_BIN: ', trim(neb%file%F_CNTN_BIN)
     write(nfneb,*) 'F_ZAJ: ', trim(neb%file%F_ZAJ)
     write(nfneb,*) 'F_CHR: ', trim(neb%file%F_CHR)

! ======================== KT_add ================= 13.0D
     if ( flg_paw ) then
        write(nfneb,*) 'F_CNTN_BIN_PAW: ', trim(neb%file%F_CNTN_BIN_PAW)
     endif
! ================================================= 13.0D
     if (sw_hubbard==ON)then
        write(nfneb,*) 'F_OCCMAT: ', trim(neb%file%F_OCCMAT)
     endif
  end if

  if(mype == 0) then
     if(neb%cond%condition==1)then
       open(nfnebenf, file=F_NEB_ENF,access='append')
       open(nfnebdynm, file=F_NEB_DYNM,access='append')
     else
       open(nfnebenf, file=F_NEB_ENF)
       open(nfnebdynm, file=F_NEB_DYNM)

       write(nfnebenf,*) '#step  image  image_distance  energy   force_org  force_neb  force_normal'
       write(nfnebdynm,*) '#step  image  atom  cps'
     endif

  end if

end subroutine set_neb_condition

subroutine set_neb_parameter(itr)

  use m_Replica
  use m_Files, only : nfneb

  implicit none
  integer, intent(in) :: itr
  integer i

  do i = 1, neb%number_of_images
     if(itr==1.and.neb%image(i)%scf_convergence.and.neb%cond%condition==1) cycle
     neb%image(i)%energy0 = neb%image(i)%energy
     neb%image(i)%energy = 0.0d0
     neb%image(i)%force0 = neb%image(i)%force
     neb%image(i)%force = 0.0d0
     neb%image(i)%force_org = 0.0d0
!     neb%image(i)%scf_convergence = .true.
  end do

end subroutine set_neb_parameter

subroutine set_neb_replica_parameter(image_id)

  use m_Const_Parameters, only : ON
  use m_Control_parameters, only : icond, ipriparadeb, sw_hubbard
  use m_IterationNumbers, only : iteration,iteration_electronic,iteration_ionic
  use m_Replica
  use m_Files
  use m_Parallelization,  only : mype

! ======================== KT_add ================= 13.0D
  use m_PseudoPotential,  only : flg_paw
! ================================================= 13.0D

  use m_dimer, only : dimvars

  implicit none

  integer image_id
  character(4) image_name

  character(100) :: F_OUT_NEW

  if( neb%step > 1 .and. icond == 0) then
     icond = 1
  end if

  write(image_name,'(a1,i3.3)') 'r', image_id
  
  F_OUT = trim(neb%file%F_OUT)//'_'//image_name

! ===== KT_add === 2014/07/20
#ifdef NEB_NEW_FILENAMES
!  F_OUT = trim(F_OUT_BASE)//'_'//image_name &
!       &              //trim(F_CONF_EXTENSION)//trim(F_PARA_EXTENSION)
  F_OUT = trim(adjustl(F_OUT_BASE)) // '_' //image_name &
       &                             // trim(adjustl(F_PARA_EXTENSION))
! ================ 2014/07/20
#endif

  !F_DYNM = trim(neb%file%F_DYNM)//'_'//image_name
  !F_ENF = trim(neb%file%F_ENF)//'_'//image_name
  F_CHGT = trim(neb%file%F_CHGT)//'_'//image_name
  F_CNTN = trim(neb%file%F_CNTN)//'_'//image_name
  F_CNTN_BIN = trim(neb%file%F_CNTN_BIN)//'_'//image_name
  F_ZAJ = trim(neb%file%F_ZAJ)//'_'//image_name
  F_CHR = trim(neb%file%F_CHR)//'_'//image_name

! ======================== KT_add ================= 13.0D
  F_CNTN_BIN_PAW = trim(neb%file%F_CNTN_BIN_PAW)//'_'//image_name
! ================================================= 13.0D
  F_OCCMAT = trim(neb%file%F_OCCMAT)//'_'//image_name

  F_ZAJ_in      = F_ZAJ
  F_CHGT_in     = F_CHGT
  F_CNTN_BIN_in = F_CNTN_BIN
  F_CNTN_in     = F_CNTN

! ======================== KT_add ================= 13.0D
  F_CNTN_BIN_PAW_in = F_CNTN_BIN_PAW
! ================================================= 13.0D

  if ( mype == 0 ) then
     write(nfneb,*) 'F_OUT: ', trim(F_OUT)
  !write(nfneb,*) 'F_DYNM: ', trim(F_DYNM)
  !write(nfneb,*) 'F_ENF: ', trim(F_ENF)
     write(nfneb,*) 'F_CHGT: ', trim(F_CHGT)
     write(nfneb,*) 'F_CNTN: ', trim(F_CNTN)
     write(nfneb,*) 'F_CNTN_BIN: ', trim(F_CNTN_BIN)
     write(nfneb,*) 'F_ZAJ: ', trim(F_ZAJ)
     write(nfneb,*) 'F_CHR: ', trim(F_CHR)
     
! ======================== KT_add ================= 13.0D
     if ( flg_paw ) write(nfneb,*) 'F_CNTN_BIN_PAW: ', trim(F_CNTN_BIN_PAW)
! ================================================= 13.0D
     if (sw_hubbard==ON) write(nfneb,*) 'F_OCCMAT: ',trim(F_OCCMAT)
  endif

  if( neb%step == 0) then
     close(nfout)
     !close(nfdynm)
     !close(nfenf)
     open(nfout,file=trim(F_OUT))
     !open(nfdynm,file=trim(F_DYNM))
     !open(nfenf,file=trim(F_ENF))
  else
     close(nfout)
     !close(nfdynm)
     !close(nfenf)
     open(nfout,file=trim(F_OUT),position='append')
     !open(nfdynm,file=trim(F_DYNM),position='append')
     !open(nfenf,file=trim(F_ENF),position='append')
  end if

  close(nfcntn)
  close(nfcntn_bin)
  open(nfcntn,file=trim(F_CNTN))
  open(nfcntn_bin,file=trim(F_CNTN_BIN),form='unformatted')

! ======================== KT_add ================= 13.0D
  if ( flg_paw ) then
!     close(nfcntn_bin_paw)
!     open(nfcntn_bin_paw,file=trim(F_CNTN_BIN_PAW),form='unformatted')

     call m_Files_close_nfcntn_bin_paw()
     call m_Files_open_nfcntn_bin_paw()
  endif
! ================================================= 13.0D

  iteration = 0
  iteration_electronic = 0
  iteration_ionic = 0

end subroutine set_neb_replica_parameter

subroutine create_replica

  use m_Ionic_System,  only : number_of_replicas, natm &
                            , pos_end0, pos_end1, cps_end0, cps_end1 &
                            , replica_howtogive_coordinates, replica_endpoints &
                            , pos_image, cps_image &
                            , imdtyp, sw_path_from_dynm, end0_energy, end1_energy
  use m_Files,         only : nfneb, nfnebcntn, F_NEB_CNTN
  use m_Const_Parameters,  only : FILE, PROPORTIONAL, ON, PREPARATION_ONLY
  use m_Replica
  use m_Parallelization,  only : mype
  use m_Control_Parameters, only : sw_fcp, icond
  use m_Fcp,                only : m_Fcp_create_replica, m_Fcp_read_totch_replica

  implicit none

  integer i, j
  integer end0, end1
  character token

  neb%number_of_images = number_of_replicas + 2
  if (mype==0) write(nfneb,*) 'number_of_images: ', neb%number_of_images

  ! temporary
!  allocate(neb%energy(neb%max_iteration,neb%number_of_images))  
!  neb%energy = 0.0d0

  allocate(neb%image(neb%number_of_images))
  do i = 1, neb%number_of_images
     neb%image(i)%num_atom = natm

     neb%image(i)%energy = 0.0d0
     neb%image(i)%energy0 = 0.0d0

     allocate(neb%image(i)%pos(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%pos0(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%cps(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%cps0(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%tau(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%force(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%force0(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%force_org(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%spring_force(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%true_force(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%fix_flag(neb%image(i)%num_atom))
     allocate(neb%image(i)%velocity(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%velocity0(neb%image(i)%num_atom,3))
     neb%image(i)%pos = 0.0d0
     neb%image(i)%pos0 = 0.0d0
     neb%image(i)%cps = 0.0d0
     neb%image(i)%cps0 = 0.0d0
     neb%image(i)%tau = 0.0d0
     neb%image(i)%force = 0.0d0
     neb%image(i)%force0 = 0.0d0
     neb%image(i)%force_org = 0.0d0
     neb%image(i)%spring_force = 0.0d0
     neb%image(i)%true_force = 0.0d0
     neb%image(i)%fix_flag = 0
     neb%image(i)%velocity = 0.0d0
     neb%image(i)%velocity0 = 0.0d0

     neb%image(i)%scf_convergence = .true.
  end do

  end0 = 1
  end1 = neb%number_of_images

  neb%image(end0)%pos = pos_end0
  neb%image(end0)%cps = cps_end0
  neb%image(end1)%pos = pos_end1
  neb%image(end1)%cps = cps_end1

  do i = 2, neb%number_of_images-1
     do j = 1, neb%image(i)%num_atom
        neb%image(i)%cps(j,:) = neb%image(end0)%cps(j,:) &
             + real(i-1) * (neb%image(end1)%cps(j,:) - neb%image(end0)%cps(j,:)) &
             / real(end1-end0)
        neb%image(i)%pos(j,:) = neb%image(end0)%pos(j,:) &
             + real(i-1) * (neb%image(end1)%pos(j,:) - neb%image(end0)%pos(j,:)) &
             / real(end1-end0)
     end do
  end do
        
  do i = 2, neb%number_of_images-1
     if(replica_howtogive_coordinates(i-1) == FILE .or. sw_path_from_dynm==ON) then
        neb%image(i)%pos = pos_image(i-1,:,:)
        neb%image(i)%cps = cps_image(i-1,:,:)
     end if
  end do

  neb%image(1)%fix_flag(:) = 0
  neb%image(neb%number_of_images)%fix_flag(:) = 0
  do i = 2, neb%number_of_images-1
        neb%image(i)%fix_flag(:) = imdtyp(:)
  end do
!  imdtyp = 0

  if( sw_fcp == ON ) call m_Fcp_create_replica(neb%number_of_images)

  if(neb%cond%condition == 1) then
     if (mype==0) write(nfneb,*) 'read data replica...'

     open(nfnebcntn,file=F_NEB_CNTN)
     read(nfnebcntn,*) 
     read(nfnebcntn,*) neb%step
     read(nfnebcntn,*) 
     read(nfnebcntn,*) 

     do i = 1, neb%number_of_images
        read(nfnebcntn,*) 
        read(nfnebcntn,*)
        read(nfnebcntn,*) 
        read(nfnebcntn,*)
        read(nfnebcntn,*)
        do j = 1, neb%image(i)%num_atom
           read(nfnebcntn,*) neb%image(i)%pos(j,1:3)
        end do
        read(nfnebcntn,*) 
        do j = 1, neb%image(i)%num_atom
           read(nfnebcntn,*) neb%image(i)%cps(j,1:3)
        end do
        read(nfnebcntn,*) 
        if(mod(i-1,nrank_r) == mype_r) then
          read(nfnebcntn,*) neb%image(i)%energy
          neb%image(i)%energy0 = neb%image(i)%energy
          read(nfnebcntn,*) 
        else
          read(nfnebcntn,*) 
          read(nfnebcntn,*) 
        endif
        do j = 1, neb%image(i)%num_atom
           read(nfnebcntn,*) neb%image(i)%force_org(j,1:3)
        end do
        neb%image(i)%force = neb%image(i)%force_org
        read(nfnebcntn,*) 
        read(nfnebcntn,*) token
        select case(token)
        case('0')
           if (mype==0) write(nfneb,*) 'image: ', i, '  scf not convegence'
           neb%image(i)%scf_convergence = .false.
        case('1')
           if (mype==0) write(nfneb,*) 'image: ', i, '  scf convegence'
           neb%image(i)%scf_convergence = .true.
        end select
        if( sw_fcp == ON ) call m_Fcp_read_totch_replica(i)
     end do
     read(nfnebcntn,*,err=90,end=90)
     read(nfnebcntn,*,err=90,end=90) changed_to_cineb
90   continue

     close(nfnebcntn)
  end if

  if (mype==0) then
     write(nfneb,*) 'create replica...'
     do i = 1, neb%number_of_images
        write(nfneb,*) 'image: ', i, ' pos, cps'
        do j = 1, neb%image(i)%num_atom
           write(nfneb,'(6f10.5,i3)') neb%image(i)%pos(j,1:3), neb%image(i)%cps(j,1:3), &
                neb%image(i)%fix_flag(j)
        end do
     end do
  endif

  if(neb%cond%end0_energy_given)then
    if(mod(0,nrank_r) == mype_r) then
      neb%image(1)%energy0 = end0_energy
      neb%image(1)%energy = end0_energy
      write(nfneb,*) 'energy for end0 given from the input file : ',end0_energy
    endif
  endif
  if(neb%cond%end1_energy_given)then
    if(mod(neb%number_of_images-1,nrank_r) == mype_r) then
      neb%image(neb%number_of_images)%energy0 = end1_energy
      neb%image(neb%number_of_images)%energy = end1_energy
      write(nfneb,*) 'energy for end1 given from the input file : ',end1_energy
    endif
  endif

  if(neb%cond%condition==0 .or. icond == PREPARATION_ONLY) call write_result(.false.)

end subroutine create_replica

subroutine set_neb_replica_coordinate(image_id)

  use m_Ionic_System, only : pos, cps
  use m_Replica

  implicit none
  integer image_id

  cps = neb%image(image_id)%cps
  pos = neb%image(image_id)%pos

end subroutine set_neb_replica_coordinate

subroutine allreduce_neb_energy_force

  use m_Replica
  use m_Parallelization,      only : mpi_comm_group, mype_conf

  implicit none

  integer i
  integer mype, npes, mpi_err
  real(8),allocatable :: work1(:)
  real(8),allocatable :: work2(:,:)

  include 'mpif.h'

  if (nrank_r.lt.1) return

!  call mpi_comm_rank(mpi_comm_world,mype,mpi_err)
  call mpi_comm_size(mpi_comm_group,npes,mpi_err)

!  write(220+mype,'(i5,5e20.10)') mype, neb%image(:)%energy

  allocate(work1(neb%number_of_images));work1=0.d0
  call mpi_allreduce(neb%image(:)%energy,work1,neb%number_of_images, &
       mpi_double_precision,mpi_sum,mpi_comm_world,mpi_err)
  neb%image(:)%energy = work1
  deallocate(work1)
  do i=1, neb%number_of_images
    allocate(work2(neb%image(i)%num_atom,3))
     work2=0.d0
     call mpi_allreduce(neb%image(i)%force,work2,neb%image(i)%num_atom*3, &
          mpi_double_precision,mpi_sum,mpi_comm_world,mpi_err)
     neb%image(i)%force = work2
     work2=0.d0
     call mpi_allreduce(neb%image(i)%force_org,work2,neb%image(i)%num_atom*3, &
          mpi_double_precision,mpi_sum,mpi_comm_world,mpi_err)
     neb%image(i)%force_org = work2
     deallocate(work2)
  end do
  ! temporary    npes = ne*nk
  neb%image(:)%energy = neb%image(:)%energy/npes
  do i=1, neb%number_of_images
     neb%image(i)%force = neb%image(i)%force/npes
     neb%image(i)%force_org = neb%image(i)%force_org/npes
  end do
  
!  write(230+mype,'(i5,5e20.10)') mype, neb%image(:)%energy
  
end subroutine allreduce_neb_energy_force

subroutine set_neb_replica_energy_force(image_id)

  use m_Force, only : forc_l
  use m_Total_Energy, only : etotal
  use m_Replica
  use m_Files, only : nfneb

  implicit none

  integer image_id

  integer :: i

  neb%image(image_id)%energy = etotal
  neb%image(image_id)%force = forc_l
  neb%image(image_id)%force_org = forc_l

end subroutine set_neb_replica_energy_force

subroutine force_neb

  use m_Files,                only : nfneb
  use m_Replica
  use m_Parallelization,  only : mype

  implicit none

  integer i, j

  if ( mype==0 ) then
     write(nfneb,*) 'force neb...'

     do i = 1, neb%number_of_images
        write(nfneb,*) 'image: ', i, neb%image(i)%energy, &
             neb%image(i)%energy-neb%image(i)%energy0
        write(nfneb,*) ' cps, force '
        do j = 1, neb%image(i)%num_atom
           write(nfneb,'(3f10.5,3e11.3)') neb%image(i)%cps(j,1:3), neb%image(i)%force(j,1:3)
        end do
     end do
  endif

!  do i = 1, neb%number_of_images
!     neb%image(i)%force_org = neb%image(i)%force
!  end do
  
  call elastic_constant
  call local_tangent
  call neb_force

  if ( mype==0 ) then
     do i = 1, neb%number_of_images
        write(nfneb,*) 'image: ', i, neb%image(i)%energy, &
             neb%image(i)%energy-neb%image(i)%energy0
!     write(nfneb,*) ' cps, pos '
!     do j = 1, neb%image(i)%num_atom
!        write(nfneb,'(6f10.5)') neb%image(i)%cps(j,1:3), neb%image(i)%pos(j,1:3)
!     end do
        write(nfneb,*) ' force(neb), force(org), force(neb-org) '
        do j = 1, neb%image(i)%num_atom
           write(nfneb,'(9e11.3)') neb%image(i)%force(j,1:3), neb%image(i)%force_org(j,1:3), &
                neb%image(i)%force(j,1:3)-neb%image(i)%force_org(j,1:3)
        end do
     end do
  endif
end subroutine force_neb

subroutine elastic_constant

  ! elastic constant between images

  use m_Files,                only : nfneb
  use m_Replica
  use m_Parallelization,     only : mype

  implicit none

  integer  i

  real(8)  max_energy, ref_energy, energy

  real(8)  k_spring, k_spring0
  real(8)  k_spring_init, k_spring_max, k_spring_min, k_spring_delta

  if (mype==0) write(nfneb,*) 'elastic constant...'

  max_energy = maxval( neb%image(:)%energy )
  ref_energy = max( neb%image(1)%energy, neb%image(neb%number_of_images)%energy )

  do i = 2, neb%number_of_images

    if( .not. neb%cond%k_variable ) then
       k_spring = neb%cond%k_spring_init
       k_spring0= neb%cond%k_spring_init
    elseif( neb%cond%k_variable ) then
       k_spring_max = neb%cond%k_spring_max
       k_spring_min = neb%cond%k_spring_min
       energy = max( neb%image(i-1)%energy, neb%image(i)%energy )
       k_spring_delta = k_spring_max - k_spring_min
       if( energy > ref_energy ) then
          k_spring = k_spring_max - k_spring_delta &
               * ( max_energy - energy ) / ( max_energy - ref_energy )
          k_spring0 = k_spring
       elseif( energy <= ref_energy ) then
          k_spring = k_spring_max - k_spring_delta
          k_spring0 = k_spring
       end if
    end if

    if( neb%cond%k_damping ) then
       k_spring0 = k_spring
       k_spring = k_spring * neb%cond%k_damping_factor ** ( ( neb%step-1) )
    end if

    neb%image(i-1)%k_spring = k_spring
    neb%image(i-1)%k_spring0= k_spring0

    if (mype==0) write(nfneb,'(i5,a10,2e20.12)') i, '-th spring',  k_spring, k_spring0

 end do
 
 return
end subroutine elastic_constant

subroutine local_tangent

  ! local tangent of minimum energy path

  use m_Files,                only : nfneb
  use m_Replica
  use m_Parallelization,     only : mype

  implicit none

  integer i, j
  integer num_atom
  real(8) distance21
  real(8) distance01, distance20
  real(8) abs_tau2, abs_tau3
  real(8) angle12, angle23, angle31
  real(8) energy0, energy1, energy2
  real(8),allocatable :: tau(:,:)
  real(8),allocatable :: tau1(:,:), tau2(:,:), tau3(:,:)
  real(8) phi
  real(8),allocatable ::  rx0(:), ry0(:), rz0(:)
  real(8),allocatable ::  rx1(:), ry1(:), rz1(:)
  real(8),allocatable ::  rx2(:), ry2(:), rz2(:)
  real(8) :: eps

  if (mype==0) write(nfneb,*) 'local tangent...'

  eps = 1.d-10
  do j = 2, neb%number_of_images-1

     num_atom = neb%image(j)%num_atom

     allocate( tau(num_atom,3) )
     allocate( tau1(num_atom,3) )
     allocate( tau2(num_atom,3) )
     allocate( tau3(num_atom,3) )

     allocate( rx0(num_atom) )
     allocate( ry0(num_atom) )
     allocate( rz0(num_atom) )
     allocate( rx1(num_atom) )
     allocate( ry1(num_atom) )
     allocate( rz1(num_atom) )
     allocate( rx2(num_atom) )
     allocate( ry2(num_atom) )
     allocate( rz2(num_atom) )

     tau1(:,:) = 0.0d0
     tau2(:,:) = 0.0d0
     tau3(:,:) = 0.0d0

     rx0 = neb%image(j)%cps(:,1)
     ry0 = neb%image(j)%cps(:,2)
     rz0 = neb%image(j)%cps(:,3)
     rx1 = neb%image(j-1)%cps(:,1)
     ry1 = neb%image(j-1)%cps(:,2)
     rz1 = neb%image(j-1)%cps(:,3)
     rx2 = neb%image(j+1)%cps(:,1)
     ry2 = neb%image(j+1)%cps(:,2)
     rz2 = neb%image(j+1)%cps(:,3)

     energy0 = neb%image(j)%energy
     energy1 = neb%image(j-1)%energy
     energy2 = neb%image(j+1)%energy

     distance21 = sqrt ( dot_product( rx2 - rx1, rx2 - rx1 ) &
          + dot_product( ry2 - ry1, ry2 - ry1 ) &
          + dot_product( rz2 - rz1, rz2 - rz1 ) )
     distance01 = sqrt ( dot_product( rx0 - rx1, rx0 - rx1 ) &
          + dot_product( ry0 - ry1, ry0 - ry1 ) &
          + dot_product( rz0 - rz1, rz0 - rz1 ) )
     distance20 = sqrt ( dot_product( rx2 - rx0, rx2 - rx0 ) &
          + dot_product( ry2 - ry0, ry2 - ry0 ) &
          + dot_product( rz2 - rz0, rz2 - rz0 ) )

     if( distance21.lt.eps .or. distance01.lt.eps .or. distance20.lt.eps ) cycle

     phi = ( dot_product( rx2 - rx0, rx0 - rx1 ) &
          + dot_product( ry2 - ry0, ry0 - ry1 ) &
          + dot_product( rz2 - rz0, rz0 - rz1 ) ) / ( distance20 * distance01 )

     ! for regure NEB

     do i = 1, num_atom
        tau1(i, 1) = ( rx2(i) - rx1(i)) / distance21
        tau1(i, 2) = ( ry2(i) - ry1(i)) / distance21
        tau1(i, 3) = ( rz2(i) - rz1(i)) / distance21
        tau2(i, 1) = ( rx0(i) - rx1(i)) / distance01 &
             + ( rx2(i) - rx0(i) ) / distance20
        tau2(i, 2) = ( ry0(i) - ry1(i)) / distance01 &
             + ( ry2(i) - ry0(i) ) / distance20
        tau2(i, 3) = ( rz0(i) - rz1(i)) / distance01 &
             + ( rz2(i) - rz0(i) ) / distance20
     end do

     abs_tau2 = sqrt( dot_product(tau2(:,1), tau2(:,1)) &
          + dot_product(tau2(:,2), tau2(:,2)) &
          + dot_product(tau2(:,3), tau2(:,3)))
     if( abs_tau2 /= 0.0d0 ) then
        tau2(:, 1) = tau2(:, 1) /  abs_tau2
        tau2(:, 2) = tau2(:, 2) /  abs_tau2
        tau2(:, 3) = tau2(:, 3) /  abs_tau2
     end if

!       tau(:,:) = tau1(:,:)
!       tau(:,:) = tau2(:,:)

     ! for CI-NEB  ( method of python )

     if( energy2 > energy0 ) then
        if( energy0 > energy1 ) then
           do i = 1, num_atom
              tau3(i, 1) = ( rx2(i) - rx0(i) )
              tau3(i, 2) = ( ry2(i) - ry0(i) )
              tau3(i, 3) = ( rz2(i) - rz0(i) )
           end do
        elseif ( energy0 <= energy1 ) then
           if( energy2 > energy1 ) then
              do i = 1, num_atom
                 tau3(i, 1) = ( rx2(i) - rx0(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rx0(i) - rx1(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 2) = ( ry2(i) - ry0(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( ry0(i) - ry1(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 3) = ( rz2(i) - rz0(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rz0(i) - rz1(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
              end do
           else if( energy2 <= energy1 ) then
              do i = 1, num_atom
                 tau3(i, 1) = ( rx2(i) - rx0(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rx0(i) - rx1(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 2) = ( ry2(i) - ry0(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( ry0(i) - ry1(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 3) = ( rz2(i) - rz0(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rz0(i) - rz1(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
              end do
           end if
        end if
     elseif( energy2 <= energy0 ) then
        if( energy0 < energy1 ) then
           do i = 1, num_atom
              tau3(i, 1) = ( rx0(i) - rx1(i) )
              tau3(i, 2) = ( ry0(i) - ry1(i) )
              tau3(i, 3) = ( rz0(i) - rz1(i) )
           end do
        elseif( energy0 >= energy1 ) then
           if( energy2 > energy1 ) then
              do i = 1, num_atom
                 tau3(i, 1) = ( rx2(i) - rx0(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rx0(i) - rx1(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 2) = ( ry2(i) - ry0(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( ry0(i) - ry1(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 3) = ( rz2(i) - rz0(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rz0(i) - rz1(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
              end do
           elseif( energy2 <= energy1 ) then
              do i = 1, num_atom
                 tau3(i, 1) = ( rx2(i) - rx0(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rx0(i) - rx1(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 2) = ( ry2(i) - ry0(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( ry0(i) - ry1(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 3) = ( rz2(i) - rz0(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rz0(i) - rz1(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
              end do
           end if
        end if
     end if
       
     abs_tau3 = sqrt( dot_product(tau3(:,1), tau3(:,1)) &
          + dot_product(tau3(:,2), tau3(:,2)) &
          + dot_product(tau3(:,3), tau3(:,3)))
     if( abs_tau3 /= 0.0d0 ) then
        tau3(:, 1) = tau3(:, 1) /  abs_tau3
        tau3(:, 2) = tau3(:, 2) /  abs_tau3
        tau3(:, 3) = tau3(:, 3) /  abs_tau3
     end if

     tau(:,:) = tau3(:,:)

     angle12 = ( dot_product( tau1(:,1), tau2(:,1) ) &
          + dot_product( tau1(:,2), tau2(:,2) ) &
          + dot_product( tau1(:,3), tau2(:,3) ) )
     angle23 = ( dot_product( tau2(:,1), tau3(:,1) ) &
          + dot_product( tau2(:,2), tau3(:,2) ) &
          + dot_product( tau2(:,3), tau3(:,3) ) )

     angle31 = ( dot_product( tau3(:,1), tau1(:,1) ) &
          + dot_product( tau3(:,2), tau1(:,2) ) &
          + dot_product( tau3(:,3), tau1(:,3) ) )

     ! output coordinate and local tangent
    
     if (mype==0) then
        write(nfneb,*) 'image : ', j
        write(nfneb,*) 'angle between local tangent'
        write(nfneb,'(a11,e12.5)') ' angle12 : ', angle12
        write(nfneb,'(a11,e12.5)') ' angle23 : ', angle23
        write(nfneb,'(a11,e12.5)') ' angle31 : ', angle31
        write(nfneb,*) ' cps '
        do i = 1, num_atom
           write(nfneb,'(3f10.5)') rx0(i), ry0(i), rz0(i)
        end do
        write(nfneb,*) ' local tangent : tau1, tau2, tau3'
        do i = 1, num_atom
           write(nfneb,'(9e11.3)') tau1(i,1), tau1(i,2), tau1(i,3), &
                tau2(i,1), tau2(i,2), tau2(i,3), &
                tau3(i,1), tau3(i,2), tau3(i,3)
        end do
!     write(nfneb,'(a19,3f15.5)') ' phi, dis01, dis20 ', phi, distance01, distance20
        write(nfneb,*) ''
     endif

     do i = 1, num_atom
        neb%image(j)%tau(i,:) = tau(i,:)
     end do

     deallocate( tau, tau1, tau2, tau3 )
     deallocate( rx0, ry0, rz0, rx1, ry1, rz1, rx2, ry2, rz2 )

  end do

  return
end subroutine local_tangent

subroutine neb_force

  ! constrain force of atoms of CI-NEB method

  use m_Files,                only : nfneb
  use m_Replica
  use m_Const_Parameters, only : PAI
  use m_Parallelization,     only : mype

  implicit none

  integer  num_atom
!  integer, intent(in) :: num_image
  integer  image_id

  real(8) energy
  real(8) max_energy

  real(8),allocatable :: tau(:,:)
  real(8),allocatable :: k_spring(:), k_spring0(:)

  integer i, k, iat

!  integer :: mype
!  integer :: energy_index(num_image)
  integer,allocatable :: update_id(:)
  real(8) :: distance01, distance20
  real(8) :: dot_product_f0_tau
  real(8) :: f_spring_abs
  real(8) :: f_spring_para_sum = 0.0d0
  real(8) :: f_spring_perp_sum = 0.0d0
  real(8) :: f_true_perp_sum = 0.0d0
  real(8) :: f0_perp_sum = 0.0d0, f0_para_sum = 0.0d0, f_sum = 0.0d0
  real(8) :: cosphi, switch = 0.0d0
  real(8), allocatable :: fx_spring(:), fy_spring(:), fz_spring(:)
  real(8), allocatable :: fx0_para(:), fy0_para(:), fz0_para(:)
  real(8), allocatable :: fx0_perp(:), fy0_perp(:), fz0_perp(:)
  real(8), allocatable :: fx_spring_para(:), fy_spring_para(:), fz_spring_para(:)
  real(8), allocatable :: fx_spring_perp(:), fy_spring_perp(:), fz_spring_perp(:)
  real(8), allocatable :: rx0(:), ry0(:), rz0(:)
  real(8), allocatable :: rx1(:), ry1(:), rz1(:)
  real(8), allocatable :: rx2(:), ry2(:), rz2(:)
  real(8), allocatable :: fx0(:), fy0(:), fz0(:)
  real(8), allocatable :: fx1(:), fy1(:), fz1(:)

  integer :: ci_target

  if (mype==0) write(nfneb,*) 'neb force...'

  allocate( k_spring(neb%number_of_images-1) )
  allocate( k_spring0(neb%number_of_images-1) )

  do k = 1, neb%number_of_images-1
     k_spring(k) = neb%image(k)%k_spring
     k_spring0(k) = neb%image(k)%k_spring0
  end do

  max_energy = maxval( neb%image(:)%energy )
  ci_target=0
  if (neb%cond%climbing_image .and. .not. changed_to_cineb) then
    write(nfneb,*) 'curr thres : ',curr_thres
  endif
  if( ( neb%step >= neb%cond%ci_neb_start) .and. ( neb%cond%climbing_image )  &
  &   .and. (curr_thres<neb%cond%ci_thres) .and. .not. changed_to_cineb ) then
     if(.not.changed_to_cineb) write(nfneb,*) 'transitioning to CI-NEB' 
     changed_to_cineb = .true.
  endif
  if(changed_to_cineb) then
     if (neb%cond%ci_index>1 .and. neb%cond%ci_index<neb%number_of_images)then
        ci_target = neb%cond%ci_index
        if(mype==0) write(nfneb,*) 'climbing image : ',ci_target
     else
        do k=2,neb%number_of_images-1
           if (neb%image(k)%energy==max_energy) then
              ci_target=k
              if(mype==0) write(nfneb,*) 'climbing image : ',ci_target
              exit
           endif
        enddo
     endif
  endif

  do k = 2, neb%number_of_images-1

     num_atom = neb%image(k)%num_atom
     image_id = k

     allocate( tau(num_atom,3) )
     allocate( update_id(num_atom) )

     allocate( rx0(num_atom) )
     allocate( ry0(num_atom) )
     allocate( rz0(num_atom) )
     allocate( rx1(num_atom) )
     allocate( ry1(num_atom) )
     allocate( rz1(num_atom) )
     allocate( rx2(num_atom) )
     allocate( ry2(num_atom) )
     allocate( rz2(num_atom) )
     allocate( fx0(num_atom) )
     allocate( fy0(num_atom) )
     allocate( fz0(num_atom) )
     allocate( fx1(num_atom) )
     allocate( fy1(num_atom) )
     allocate( fz1(num_atom) )
     allocate( fx_spring(num_atom) )
     allocate( fy_spring(num_atom) )
     allocate( fz_spring(num_atom) )
     allocate( fx0_para(num_atom) )
     allocate( fy0_para(num_atom) )
     allocate( fz0_para(num_atom) )

     allocate( fx0_perp(num_atom) )
     allocate( fy0_perp(num_atom) )
     allocate( fz0_perp(num_atom) )

     allocate( fx_spring_para(num_atom) )
     allocate( fy_spring_para(num_atom) )
     allocate( fz_spring_para(num_atom) )

     allocate( fx_spring_perp(num_atom) )
     allocate( fy_spring_perp(num_atom) )
     allocate( fz_spring_perp(num_atom) )

     rx0 = neb%image(image_id)%cps(:,1)
     ry0 = neb%image(image_id)%cps(:,2)
     rz0 = neb%image(image_id)%cps(:,3)
     rx1 = neb%image(image_id-1)%cps(:,1)
     ry1 = neb%image(image_id-1)%cps(:,2)
     rz1 = neb%image(image_id-1)%cps(:,3)
     rx2 = neb%image(image_id+1)%cps(:,1)
     ry2 = neb%image(image_id+1)%cps(:,2)
     rz2 = neb%image(image_id+1)%cps(:,3)

     fx0 = neb%image(image_id)%force(:,1)
     fy0 = neb%image(image_id)%force(:,2)
     fz0 = neb%image(image_id)%force(:,3)
     
     tau(:,1) = neb%image(image_id)%tau(:,1)
     tau(:,2) = neb%image(image_id)%tau(:,2)
     tau(:,3) = neb%image(image_id)%tau(:,3)

     update_id = neb%image(image_id)%fix_flag(:)

!    call get_energy_index( energy_index, num_image )

     ! spring force for penalty function

     fx_spring(:) = k_spring0(image_id) * ( rx2(:) - rx0(:) ) &
          + k_spring0(image_id - 1 ) * ( rx1(:) - rx0(:) )
     fy_spring(:) = k_spring0(image_id) * ( ry2(:) - ry0(:) ) &
          + k_spring0(image_id - 1 ) * ( ry1(:) - ry0(:) )
     fz_spring(:) = k_spring0(image_id) * ( rz2(:) - rz0(:) ) &
          + k_spring0(image_id - 1 ) * ( rz1(:) - rz0(:) )

     if(k/=ci_target)then

        ! get true force perpendicular to local tangent 
          
        dot_product_f0_tau &
             = dot_product( fx0(:),  tau(:,1) ) &
             + dot_product( fy0(:),  tau(:,2) ) &
             + dot_product( fz0(:),  tau(:,3) ) 
       
        fx0_perp(:) = fx0(:) - dot_product_f0_tau * tau(:,1)
        fy0_perp(:) = fy0(:) - dot_product_f0_tau * tau(:,2)
        fz0_perp(:) = fz0(:) - dot_product_f0_tau * tau(:,3)

        ! get spring force along local tangent 
          
        distance20 = sqrt( dot_product( rx2 - rx0, rx2 - rx0 ) &
             + dot_product( ry2 - ry0, ry2 - ry0 ) &
             + dot_product( rz2 - rz0, rz2 - rz0 ) )
        distance01 = sqrt( dot_product( rx0 - rx1, rx0 - rx1 ) &
             + dot_product( ry0 - ry1, ry0 - ry1 ) &
             + dot_product( rz0 - rz1, rz0 - rz1 ) )
        f_spring_abs = k_spring0(image_id) *  distance20 &
             - k_spring0(image_id - 1) * distance01 

        fx_spring_para(:) = ( dot_product(fx_spring, tau(:,1)) &
             + dot_product(fy_spring, tau(:,2)) &
             + dot_product(fz_spring, tau(:,3)) ) * tau(:,1)
        fy_spring_para(:) = ( dot_product(fx_spring, tau(:,1)) &
             + dot_product(fy_spring, tau(:,2)) &
             + dot_product(fz_spring, tau(:,3)) ) * tau(:,2)
        fz_spring_para(:) = ( dot_product(fx_spring, tau(:,1)) &
             + dot_product(fy_spring, tau(:,2)) &
             + dot_product(fz_spring, tau(:,3)) ) * tau(:,3)
       
        ! penalty function

        switch=0.d0
        fx_spring_perp=0;fy_spring_perp=0;fz_spring_perp=0;cosphi=0
        if( neb%cond%penalty_function )  then
           fx_spring_perp(:) = ( fx_spring(:) - ( dot_product(fx_spring, tau(:,1)) &
                + dot_product(fy_spring, tau(:,2)) &
                + dot_product(fz_spring, tau(:,3)) ) * tau(:,1) ) &
                * k_spring(image_id-1) / k_spring0(image_id-1)
           fy_spring_perp(:) = ( fy_spring(:) - ( dot_product(fx_spring, tau(:,1)) &
                + dot_product(fy_spring, tau(:,2)) &
                + dot_product(fz_spring, tau(:,3)) ) * tau(:,2) ) &
                * k_spring(image_id-1) / k_spring0(image_id-1)
           fz_spring_perp(:) = ( fz_spring(:) - ( dot_product(fx_spring, tau(:,1)) &
                + dot_product(fy_spring, tau(:,2)) &
                + dot_product(fz_spring, tau(:,3)) ) * tau(:,3) ) &
                * k_spring(image_id-1) / k_spring0(image_id-1)
           cosphi = ( dot_product( rx2 - rx0, rx0 - rx1 ) &
                + dot_product( ry2 - ry0, ry0 - ry1 ) &
                + dot_product( rz2 - rz0, rz0 - rz1 ) ) &
                / ( distance20 * distance01 )

           if( cosphi > 0.0d0 ) then
              switch =  0.5d0 * ( 1.0d0 + cos(PAI*cosphi) )
           else
              switch = 1.0d0
           end if
        end if

        ! for debug 
        f_spring_para_sum = 0.0d0
        f_spring_perp_sum = 0.0d0
        f_true_perp_sum = 0.0d0
        do i = 1, num_atom
           if( update_id(i) ==  1 ) then
              f_spring_para_sum = f_spring_para_sum + fx_spring_para(i) * fx_spring_para(i) & 
                   + fy_spring_para(i) * fy_spring_para(i) + fz_spring_para(i) * fz_spring_para(i)
              f_spring_perp_sum = f_spring_perp_sum + fx_spring_perp(i) * fx_spring_perp(i) &
                   + fy_spring_perp(i) * fy_spring_perp(i) + fz_spring_perp(i) * fz_spring_perp(i)
              f_true_perp_sum = f_true_perp_sum + fx0_perp(i) * fx0_perp(i) &
                   + fy0_perp(i) * fy0_perp(i) + fz0_perp(i) * fz0_perp(i)
           end if
        end do

        ! get constained force

        fx1(:) = fx_spring_para(:) + fx0_perp(:) + switch * fx_spring_perp(:)
        fy1(:) = fy_spring_para(:) + fy0_perp(:) + switch * fy_spring_perp(:)
        fz1(:) = fz_spring_para(:) + fz0_perp(:) + switch * fz_spring_perp(:)

        do i = 1, num_atom
           neb%image(image_id)%spring_force(i,1) = fx_spring_para(i)
           neb%image(image_id)%spring_force(i,2) = fy_spring_para(i)
           neb%image(image_id)%spring_force(i,3) = fz_spring_para(i)

           neb%image(image_id)%true_force(i,1) = fx0_perp(i)
           neb%image(image_id)%true_force(i,2) = fy0_perp(i)
           neb%image(image_id)%true_force(i,3) = fz0_perp(i)
        end do

        f0_perp_sum = 0.0d0
        f_sum = 0.0d0
        do i = 1, num_atom
           if( update_id(i) == 1  ) then
              f0_perp_sum = f0_perp_sum &
                   +  ( fx0_perp(i)+switch*fx_spring_perp(i) ) ** 2 &
                   +  ( fy0_perp(i)+switch*fy_spring_perp(i) ) ** 2 &
                   +  ( fz0_perp(i)+switch*fz_spring_perp(i) ) ** 2 
              f_sum = f_sum +  fx1(i)*fx1(i) +  fy1(i)*fy1(i) + fz1(i)*fz1(i)
           end if
        end do

        f_sum = sqrt( f_sum )
        f_spring_para_sum = sqrt( f_spring_para_sum )
        f_spring_perp_sum = sqrt( f_spring_perp_sum )
        f_true_perp_sum = sqrt( f_true_perp_sum )
        f0_perp_sum = sqrt( f0_perp_sum )


        energy = neb%image(image_id)%energy

        if ( mype==0 ) then
           write(nfneb,*) 'image: ', image_id
           write(nfneb,*) ' energy: ', neb%step, energy
           write(nfneb,'(a31,e20.12)') ' sum of force (neb)         : ', f_sum
           write(nfneb,'(a31,e20.12)') ' sum of spring force (para) : ', f_spring_para_sum
           write(nfneb,'(a31,e20.12)') ' sum of true force (perp)   : ', f0_perp_sum
           write(nfneb,'(a31,3e11.3)') ' max force                  : ', &
                maxval( abs( fx1 ) ), maxval( abs( fy1 ) ), maxval( abs( fz1 ) )
        endif
     else
           
        ! get true force along local tangent 
          
        dot_product_f0_tau &
             = dot_product(fx0(:), tau(:,1)) + dot_product(fy0(:), tau(:,2))&
             + dot_product(fz0(:), tau(:,3))
          
        fx0_para(:) = dot_product_f0_tau * tau(:,1)
        fy0_para(:) = dot_product_f0_tau * tau(:,2)
        fz0_para(:) = dot_product_f0_tau * tau(:,3)
       
        ! get true force perpendicular to local tangent 
       
        fx0_perp(:) = fx0(:) - dot_product_f0_tau * tau(:,1)
        fy0_perp(:) = fy0(:) - dot_product_f0_tau * tau(:,2)
        fz0_perp(:) = fz0(:) - dot_product_f0_tau * tau(:,3)
       
        ! get constained force
       
        fx1(:) = fx0_perp(:) - fx0_para(:)
        fy1(:) = fy0_perp(:) - fy0_para(:)
        fz1(:) = fz0_perp(:) - fz0_para(:)
       
        do i = 1, num_atom
           neb%image(image_id)%spring_force(i,1) = fx0_para(i)
           neb%image(image_id)%spring_force(i,2) = fy0_para(i)
           neb%image(image_id)%spring_force(i,3) = fz0_para(i)

           neb%image(image_id)%true_force(i,1) = fx0_perp(i)
           neb%image(image_id)%true_force(i,2) = fy0_perp(i)
           neb%image(image_id)%true_force(i,3) = fz0_perp(i)
        end do

        f0_para_sum = 0.0d0
        f0_perp_sum = 0.0d0
        f_sum = 0.0d0
        do i = 1, num_atom
           if( update_id(i) == 1 ) then
              f0_para_sum = f0_para_sum +  fx0_para(i) * fx0_para(i) &
                   + fy0_para(i) * fy0_para(i) + fz0_para(i) * fz0_para(i)
              f0_perp_sum = f0_perp_sum +  fx0_perp(i) * fx0_perp(i) &
                   + fy0_perp(i) * fy0_perp(i) + fz0_perp(i) * fz0_perp(i)
              f_sum = fx1(i) * fx1(i) + fy1(i) * fy1(i) + fz1(i) * fz1(i) 
           end if
        end do

        f_sum = sqrt( f_sum )
        f0_para_sum = sqrt( f0_para_sum )
        f0_perp_sum = sqrt( f0_perp_sum )

        energy = neb%image(image_id)%energy

        if ( mype==0 ) then
           write(nfneb,*) 'image: ', image_id
           write(nfneb,*) ' energy: ', neb%step, energy
           write(nfneb,'(a31,e20.12)') ' sum of force (neb)         : ', f_sum
           write(nfneb,'(a31,e20.12)') ' sum of true force (para)   : ', f0_para_sum
           write(nfneb,'(a31,e20.12)') ' sum of true force (perp)   : ', f0_perp_sum
           write(nfneb,'(a31,3e11.3)') ' max force                  : ', &
                maxval( abs( fx1 ) ), maxval( abs( fy1 ) ), maxval( abs( fz1 ) )
        endif
     end if

     ! set force to module

     do i = 1, num_atom
        neb%image(image_id)%force(i,1) = fx1(i)
        neb%image(image_id)%force(i,2) = fy1(i)
        neb%image(image_id)%force(i,3) = fz1(i)
     end do

     deallocate( tau )
     deallocate( update_id )
     deallocate( rx0, ry0, rz0, rx1, ry1, rz1, rx2, ry2, rz2, &
          fx0, fy0, fz0, fx1, fy1, fz1, fx_spring, fy_spring, fz_spring, &
          fx0_para, fy0_para, fz0_para, fx0_perp, fy0_perp, fz0_perp, &
          fx_spring_para, fy_spring_para, fz_spring_para, &
          fx_spring_perp, fy_spring_perp, fz_spring_perp)

  end do

  deallocate( k_spring, k_spring0 )

  return

end subroutine neb_force

function get_energy_sum() result(energy)
  use m_Replica
  implicit none
  integer :: i
  real(kind=DP) :: energy 
  energy = 0.d0
  do i=2,neb%number_of_images-1
     energy = energy + neb%image(i)%energy 
  enddo
  return
end function get_energy_sum

subroutine atom_update_neb

  use m_Control_Parameters, only : kqnmditer_p
  use m_Crystal_Structure,  only : altv, rltv
  use m_Ionic_System,  only : ionic_mass,m_IS_cg2_core,m_IS_fire_core,m_IS_gdiis_alloc &
  &   , m_IS_rot_ncrspd, m_IS_stor_cps_forc, iter_gdiis, ncrspd, m_IS_do_bfgs
  use m_Files,                only : nfneb
  use m_Const_Parameters,      only : PAI2

  use m_Replica
  use m_Parallelization,  only : mype

  implicit none

  integer i, j, k
  real(8) mass
  real(8) dt
  real(8) energy,get_energy_sum
  real(8) r(3), r0(3), r1(3), v(3), v1(3), f(3), f0(3) , unitf(3)
  real(8), allocatable ::  rltv_t(:,:)
  real(kind=DP), save, allocatable, dimension(:) :: x,g,diag,w
  real(kind=DP), allocatable, dimension(:,:) :: cpst,forct,cpdt
  integer, allocatable, dimension(:,:) :: imdtypt
  real(kind=DP) :: ff,eps,xtol,gtol,stpmin,stpmax,sdfac
  integer :: ndim,msave,nwork,lp,mp
  logical :: diagco
  integer :: icount
  integer :: nsum,m,it
  integer :: iprint(2)
  integer, save :: if_allocated=0
  integer, save :: iflag=0
  EXTERNAL LB2
  COMMON /LB3/MP,LP,GTOL,STPMIN,STPMAX

  if (mype==0) write(nfneb,*) 'atom coordinate update...'

  dt = neb%dt
  allocate(rltv_t(3,3))
  rltv_t = transpose(rltv)/PAI2

  energy = get_energy_sum()
#ifdef _L_BFGS_
  if(neb%cond%time_integral == 'lbfgs') then
    msave = 5
    icount = 0
    do i=2,neb%number_of_images-1
       do j=1,neb%image(i)%num_atom 
          if(neb%image(i)%fix_flag(j) == 1) then
             icount = icount+3
          endif
       enddo
    enddo
    ff = energy
    ndim = icount
    nwork = ndim*(2*msave+1)+2*msave
    if(.not.allocated(x)) then
      allocate(x(ndim));x=0.d0
      allocate(g(ndim));g=0.d0
      allocate(diag(ndim));diag=0.d0
      allocate(w(nwork));w=0.d0
    endif
    icount = 0
    do i=2,neb%number_of_images-1
       do j=1,neb%image(i)%num_atom 
          if(neb%image(i)%fix_flag(j) == 1)then
             do k=1,3
                icount = icount+1
                x(icount) = neb%image(i)%cps(j,k)
                g(icount) = -neb%image(i)%force(j,k)
             enddo
          endif
       enddo
    enddo
    iprint(1) = 3
    iprint(2) = 3
    call lbfgs(ndim,msave,x,ff,g,.false.,diag,IPRINT,0.d0,1e-16,w,iflag)
    icount = 0
    do i=2,neb%number_of_images-1
       do j=1,neb%image(i)%num_atom 
          if(neb%image(i)%fix_flag(j) == 1)then
             do k=1,3
                icount = icount+1
                neb%image(i)%cps(j,k) = x(icount)
             enddo
          endif
       enddo
    enddo
    if (iflag<0) then
      write(nfneb,*) 'encountered errors in lbfgs : ',iflag
    endif
  else if (neb%cond%time_integral == 'fire')then
#else
  if (neb%cond%time_integral == 'fire')then
#endif
    ndim = (neb%number_of_images-2)*neb%image(1)%num_atom
    allocate(cpst(ndim,3))
    allocate(cpdt(ndim,3))
    allocate(forct(ndim,3))
    allocate(imdtypt(ndim,3))
    icount = 0
    do i=2,neb%number_of_images-1
       do j=1,neb%image(i)%num_atom 
          icount = icount + 1
          do k=1,3
            cpst(icount,k) = neb%image(i)%cps(j,k)
            cpdt(icount,k) = neb%image(i)%velocity(j,k)
            forct(icount,k) = neb%image(i)%force(j,k)
            imdtypt(icount,k) = neb%image(i)%fix_flag(j)
          enddo
       enddo
    enddo
    call m_IS_fire_core(nfneb,ndim,neb%step,cpst,cpdt,forct,imdtypt)
    icount = 0
    do i=2,neb%number_of_images-1
       do j=1,neb%image(i)%num_atom 
          icount = icount+1
          neb%image(i)%cps(j,:) = cpst(icount,:)
          neb%image(i)%velocity(j,:) = cpdt(icount,:)
       enddo
    enddo
    deallocate(cpst)
    deallocate(cpdt)
    deallocate(forct)
    deallocate(imdtypt)
  else if (neb%cond%time_integral == 'bfgs')then
    ndim = (neb%number_of_images-2)*neb%image(1)%num_atom
    iter_gdiis = iter_gdiis + 1
    if(if_allocated==0) call m_IS_gdiis_alloc(1,if_allocated,ndim)
    m = mod(iter_gdiis,kqnmditer_p)
    if(m == 0) m = kqnmditer_p
    call m_IS_rot_ncrspd(nsum)  ! -> ncrspd, nsum
    it = ncrspd(nsum)
    if(it == 0) it = 1
    allocate(cpst(ndim,3))
    allocate(forct(ndim,3))
    allocate(imdtypt(ndim,3))
    icount = 0
    do i=2,neb%number_of_images-1
       do j=1,neb%image(i)%num_atom 
          icount = icount + 1
          do k=1,3
            cpst(icount,k) = neb%image(i)%cps(j,k)
            forct(icount,k) = neb%image(i)%force(j,k)
            imdtypt(icount,k) = neb%image(i)%fix_flag(j)
          enddo
       enddo
    enddo
    call m_IS_stor_cps_forc(it,ndim,cpst,forct) ! cps,forc_g -> u_l, w_l
    call m_IS_do_bfgs(nfneb,nsum,ndim,get_energy_sum(),imdtypt,cpst,forct)
    icount = 0
    do i=2,neb%number_of_images-1
       do j=1,neb%image(i)%num_atom 
          icount = icount+1
          neb%image(i)%cps(j,:) = cpst(icount,:)
       enddo
    enddo
    deallocate(cpst)
    deallocate(forct)
    deallocate(imdtypt)
  else if (neb%cond%time_integral == 'cg')then
    ndim = (neb%number_of_images-2)*neb%image(1)%num_atom
    allocate(cpst(ndim,3))
    allocate(forct(ndim,3))
    allocate(imdtypt(ndim,3))
    icount = 0
    do i=2,neb%number_of_images-1
       do j=1,neb%image(i)%num_atom 
          icount = icount + 1
          do k=1,3
            cpst(icount,k) = neb%image(i)%cps(j,k)
            forct(icount,k) = neb%image(i)%force(j,k)
            imdtypt(icount,k) = neb%image(i)%fix_flag(j)
          enddo
       enddo
    enddo
    energy = get_energy_sum()
    call m_IS_cg2_core(nfneb,ndim,cpst,forct,imdtypt,energy)
    icount = 0
    do i=2,neb%number_of_images-1
       do j=1,neb%image(i)%num_atom 
          icount = icount+1
          neb%image(i)%cps(j,:) = cpst(icount,:)
       enddo
    enddo
    deallocate(cpst)
    deallocate(forct)
    deallocate(imdtypt)
  else
    do i = 2, neb%number_of_images-1

       neb%image(i)%pos0 = neb%image(i)%pos
       neb%image(i)%cps0 = neb%image(i)%cps

       do j = 1, neb%image(i)%num_atom

          if(neb%image(i)%fix_flag(j) == 1) then

             r = neb%image(i)%cps(j,:)
             r0 = neb%image(i)%cps0(j,:)
             v = neb%image(i)%velocity(j,:)
             f = neb%image(i)%force(j,:)
             f0 = neb%image(i)%force0(j,:)
             energy = neb%image(i)%energy
             mass = ionic_mass(j)

             select case(neb%cond%time_integral)
             case('steepest_descent')
                r1 = r + dt*f/neb%cond%sd_factor
                v = 0.0d0
             case('verlet')
                r1 = 2.0d0*r - r0 + dt*dt*f/mass
                v1 = (r1-r)/(2.0d0*dt)
                v = 0.0d0
                if( dot_product(v1,f) >= 0.0d0) then
                   if( dot_product(f,f) /= 0.0d0 ) then
                      v = f * dot_product(v1,f)/dot_product(f,f)
                   end if
                end if
             case('velocity_verlet')
                v1 = v + 0.5d0*dt*(f0+f)/mass
                v = 0.0d0
                unitf=0.d0
                if(dot_product(f,f)/=0) unitf=f/dsqrt(dot_product(f,f))
                if( dot_product(v1,unitf) >= 0.0d0) then
                  v = unitf * dot_product(v1,unitf)
                else
                   if (mype==0) write(nfneb,'(a,i6)') 'quenched velocity of atom : ',j
                end if
                r1 = r + v*dt + f*dt**2/mass
             end select
  
             neb%image(i)%cps(j,:) = r1
             neb%image(i)%velocity(j,:) = v

          end if

        ! periodic tranformation
        !do k = 1, 3
        !   if( neb%image(i)%pos(j,k) < 0 ) then
        !      neb%image(i)%pos(j,k) = neb%image(i)%pos(j,k) + 1.d0
        !   else if( neb%image(i)%pos(j,k) > 1.d0 ) then
        !      neb%image(i)%pos(j,k) = neb%image(i)%pos(j,k) - 1.d0
        !   end if
        !enddo

        ! pos -> cps
        !do k = 1, 3
        !   neb%image(i)%cps(j,k) = altv(k,1)*neb%image(i)%pos(j,1) &
        !        + altv(k,2)*neb%image(i)%pos(j,2) &
        !        + altv(k,3)*neb%image(i)%pos(j,3)
        !enddo
       end do
    end do
  endif
  do i = 2, neb%number_of_images-1
    do j = 1, neb%image(i)%num_atom
      do k = 1, 3
         neb%image(i)%pos(j,k) = rltv_t(k,1)*neb%image(i)%cps(j,1) &
              + rltv_t(k,2)*neb%image(i)%cps(j,2) &
              + rltv_t(k,3)*neb%image(i)%cps(j,3)
      enddo
    enddo
    if ( mype==0 ) then
      write(nfneb,*) ' image: ', i
      write(nfneb,*) '  cps, cps0, cps-cps0 '
      do j = 1, neb%image(i)%num_atom
         write(nfneb,'(6f10.5,3e11.3)') neb%image(i)%cps(j,1:3), neb%image(i)%cps0(j,1:3), &
              neb%image(i)%cps(j,1:3)-neb%image(i)%cps0(j,1:3)
      end do
    endif
  enddo

  deallocate(rltv_t)

end subroutine atom_update_neb

subroutine atom_update_pos_neb

  use m_Crystal_Structure,  only : altv, rltv
  use m_Ionic_System,  only : ionic_mass
  use m_Files,                only : nfneb
  use m_Const_Parameters,      only : PAI2
  use m_Parallelization,     only : mype

  use m_Replica

  implicit none

  integer i, j, k
  real(8) mass
  real(8) dt
  real(8) r(3), r0(3), r1(3), v(3), v1(3), f(3), f0(3) 

  if (mype==0) write(nfneb,*) 'atom coordinate update... (pos)'

  dt = neb%dt

  do i = 2, neb%number_of_images-1

     neb%image(i)%pos0 = neb%image(i)%pos
     neb%image(i)%cps0 = neb%image(i)%cps

     do j = 1, neb%image(i)%num_atom

        if(neb%image(i)%fix_flag(j) == 1) then

           r = neb%image(i)%pos(j,:)
           r0 = neb%image(i)%pos0(j,:)
           v = neb%image(i)%velocity(j,:)
           f = neb%image(i)%force(j,:)
           f0 = neb%image(i)%force0(j,:)
           mass = ionic_mass(j)

           select case(neb%cond%time_integral)
           case('steepest_descent')
              r1 = r + dt*f
              v = 0.0d0
           case('verlet')
              r1 = 2.0d0*r - r0 + dt*dt*f/mass
              v1 = (r1-r)/(2.0d0*dt)
              v = 0.0d0
              if( dot_product(v1,f) >= 0.0d0) then
                 if( dot_product(f,f) /= 0.0d0 ) then
                    v = f * dot_product(v1,f)/dot_product(f,f)
                 end if
              end if
           case('velocity_verlet')
              v1 = v + 0.5d0*dt*(f0+f)/mass
              v = 0.0d0
              if( dot_product(v1,f) >= 0.0d0) then
                 if( dot_product(f,f) /= 0.0d0 ) then
                    v = f * dot_product(v1,f)/dot_product(f,f)
                 end if
              end if
              r1 = r + v*dt + f*dt**2/mass
           end select

           neb%image(i)%pos(j,:) = r1
           neb%image(i)%velocity(j,:) = v

        end if

        ! periodic tranformation
        !do k = 1, 3
        !   if( neb%image(i)%pos(j,k) < 0 ) then
        !      neb%image(i)%pos(j,k) = neb%image(i)%pos(j,k) + 1.d0
        !   else if( neb%image(i)%pos(j,k) > 1.d0 ) then
        !      neb%image(i)%pos(j,k) = neb%image(i)%pos(j,k) - 1.d0
        !   end if
        !enddo

        ! pos -> cps
        do k = 1, 3
           neb%image(i)%cps(j,k) = altv(k,1)*neb%image(i)%pos(j,1) &
                + altv(k,2)*neb%image(i)%pos(j,2) &
                + altv(k,3)*neb%image(i)%pos(j,3)
        enddo

     end do

     if ( mype==0 ) then
        write(nfneb,*) ' image: ', i
        write(nfneb,*) '  cps, cps0, cps-cps0, velocity '
        do j = 1, neb%image(i)%num_atom
           write(nfneb,'(6f10.5,3e11.3,3f10.5)') neb%image(i)%cps(j,1:3), neb%image(i)%cps0(j,1:3), &
                neb%image(i)%cps(j,1:3)-neb%image(i)%cps0(j,1:3), &
                neb%image(i)%velocity(j,1:3)
        end do
     endif

  end do

end subroutine atom_update_pos_neb

subroutine write_down_data_replica(replace_nfstop)

  use m_Files,                only : nfneb, nfnebcntn, F_NEB_CNTN, nfstop, F_STOP
  use m_Replica
  use m_Parallelization,    only : mype
  use m_Control_Parameters, only : sw_fcp
  use m_Const_Parameters,   only : ON
  use m_Fcp,                only : m_Fcp_write_down_totch_replica

  implicit none
  logical, intent(in) :: replace_nfstop
  integer i,j
  if (mype==0) write(nfneb,*) 'write down data replica...'

!  if(mype_r == 0) then
  if(mype == 0) then

  open(nfnebcntn,file=F_NEB_CNTN)
  write(nfnebcntn,*) 'iteration_neb'
  write(nfnebcntn,*) neb%step
  write(nfnebcntn,*) 'number_of_images'
  write(nfnebcntn,*) neb%number_of_images

  do i = 1, neb%number_of_images
     write(nfnebcntn,*) 'image'
     write(nfnebcntn,*) i
     write(nfnebcntn,*) '(natm)'
     write(nfnebcntn,*) neb%image(i)%num_atom
     write(nfnebcntn,*) '(pos)'
     do j = 1, neb%image(i)%num_atom
        write(nfnebcntn,'(3d24.16)') neb%image(i)%pos(j,1:3)
     end do
     write(nfnebcntn,*) '(cps)'
     do j = 1, neb%image(i)%num_atom
        write(nfnebcntn,'(3d24.16)') neb%image(i)%cps(j,1:3)
     end do
     write(nfnebcntn,*) '(energy)'
     write(nfnebcntn,'(d24.16)') neb%image(i)%energy
     write(nfnebcntn,*) '(force_org)'
     do j = 1, neb%image(i)%num_atom
        write(nfnebcntn,'(3d24.16)') neb%image(i)%force_org(j,1:3)
     end do
     write(nfnebcntn,*) '(convergence)'
     if(neb%image(i)%scf_convergence) then
        write(nfnebcntn,'(i3)')  1
     else 
        write(nfnebcntn,'(i3)')  0
     end if
     if( sw_fcp == ON ) call m_Fcp_write_down_totch_replica(i)
  end do
  write(nfnebcntn,*) '(changed_to_cineb)'
  write(nfnebcntn,'(l1)') changed_to_cineb
  
  close(nfnebcntn)

  if(replace_nfstop)then
    open(nfstop, file=F_STOP, status='replace', form='formatted')
    close(nfstop, status='keep')
  endif

  end if
end subroutine write_down_data_replica

subroutine allreduce_scf_convergence

  use m_Files,   only : nfneb
  use m_Replica
  use m_Parallelization,  only : mype

  implicit none

  integer i, mpi_err
  logical,allocatable :: work(:)

  include 'mpif.h'

  if(nrank_r.ge.1)then
    allocate(work(neb%number_of_images))
    call mpi_allreduce(neb%image(:)%scf_convergence,work,neb%number_of_images, &
         mpi_logical,mpi_land,mpi_comm_world,mpi_err)
    neb%image(:)%scf_convergence = work
    deallocate(work)
  endif

  if ( mype==0 ) then
     write(nfneb,*) 'neb: ', neb%step
     do i=1, neb%number_of_images
        write(nfneb,*) ' image: ', i, ' scf convergence: ', neb%image(i)%scf_convergence
     end do
  endif
end subroutine allreduce_scf_convergence

logical function replica_converged()

  use m_Files,                only : nfneb, nfnebstop, F_NEB_STOP
  use m_Replica
  use m_Parallelization, only : mype
  use m_Control_Parameters, only : sw_fcp
  use m_Const_Parameters, only : ON
  use m_Fcp, only : m_Fcp_replica_Converged

  implicit none

  logical conv
  real(8), allocatable :: force(:)
  integer i, j, istop, id(1)
  real(8) :: fmax, ftmp

  if ( mype==0 ) write(nfneb,*) 'convergence check...', neb%step

  conv = .false.
  if (neb%cond%climbing_image .and. .not. changed_to_cineb) then
    if (mype==0) write(nfneb,*) &
    &  'we have not transitioned to CI-NEB yet, so convergence test will be ignored'
  endif
  select case(neb%cond%convergence_condition)
  
  case(1) ! energy
     curr_thres = maxval(abs(neb%image(:)%energy-neb%image(:)%energy0))
     if( curr_thres < neb%cond%convergence_threshold ) then
        conv = .true.
     end if
     if ( mype==0) then
        write(nfneb,*) ' energy : ', maxval(abs(neb%image(:)%energy-neb%image(:)%energy0)), &
             neb%cond%convergence_threshold, conv
     endif
  case(2) ! force(org)
     fmax = 0
     do i=2,neb%number_of_images-1
       ftmp = get_max_force(neb,i,'org')
       if(ftmp<fmax) fmax=ftmp
     enddo
     if(fmax<neb%cond%convergence_threshold) conv = .true.
     if ( mype==0 ) then
        write(nfneb,*) ' force (org): ', fmax, neb%cond%convergence_threshold, conv
     endif
     curr_thres = fmax
  case(3) ! force(neb)
     fmax = 0
     do i=2, neb%number_of_images-1
       ftmp = get_max_force(neb,i,'neb')
       if(fmax < ftmp) fmax=ftmp
     enddo
     if( fmax < neb%cond%convergence_threshold ) conv = .true.
     if ( mype==0 ) then
        write(nfneb,*) ' force (neb): ', fmax, neb%cond%convergence_threshold, conv
     endif
     curr_thres = fmax
  case(4) ! force(org) of max energy image
     id = maxloc(neb%image(:)%energy);
     fmax = 0
     do i=1,neb%image(id(1))%num_atom
       if(neb%image(id(1))%fix_flag(i)==0)cycle
       ftmp = dsqrt(dot_product(neb%image(id(1))%force(i,:),neb%image(id(1))%force(i,:)))
       if(fmax<ftmp)fmax=ftmp
     enddo
     if(fmax<neb%cond%convergence_threshold) conv=.true.
     if ( mype==0 ) then
        write(nfneb,*) ' force (transition state): ', fmax, &
             neb%cond%convergence_threshold, conv
     endif
     curr_thres = fmax
  case(5) ! true force (normal force)
     fmax=0
     do i=2,neb%number_of_images-1
       ftmp = get_max_force(neb,i,'true')
       if(fmax<ftmp)fmax=ftmp
     enddo
     if(fmax<neb%cond%convergence_threshold) conv=.true.
     if ( mype==0 ) then
        write(nfneb,*) ' force (normal): ', fmax, neb%cond%convergence_threshold, conv
     endif
     curr_thres = fmax
  end select

  if (neb%cond%climbing_image .and. .not. changed_to_cineb) then
    conv = .false.
  endif
  ! check nfnebstop.data
  istop = -1
  open(nfnebstop,file=F_NEB_STOP)
  rewind(nfnebstop)
  read(nfnebstop,*,end=1,err=1) istop
1 continue
  close(nfnebstop,status='keep')
  if(0 <= istop .and. neb%step >= istop) then
     conv = .true.
     if (mype==0) write(nfneb,*) ' nfnebstop.data: ', istop     
  end if

  if(sw_fcp == ON) then
    if(m_Fcp_replica_Converged()) conv = .false.
  end if

  replica_converged = conv

  call write_result(.true.)

end function replica_converged

subroutine write_result(inc_energy)

  use m_Files,                only : nfnebenf, nfnebdynm, nfenf, nfdynm, F_DYNM, F_ENF
  use m_Replica
  use m_Ionic_System,         only : m_IS_wd_speciesname_etc
  use m_IterationNumbers,     only : iteration

  implicit none

  logical, intent(in) :: inc_energy
  integer i, j
  character(20) form
  real(8) d, sum_d
  integer npes,mype,mpi_err
  real(8) :: mforg,mf,mftrue

  include 'mpif.h'

  call mpi_comm_rank(mpi_comm_world,mype,mpi_err)

  if(mype /= 0) return

  ! write energy, force, cps

  open(nfdynm,file=F_DYNM)
  open(nfenf,file=F_ENF)
  call m_IS_wd_speciesname_etc(nfdynm)
  call m_IS_wd_speciesname_etc(nfnebdynm)
  write(nfenf,*) '#step  image  image_distance  energy   force_org  force_neb  force_normal'
  sum_d = 0.0d0
  do i=1, neb%number_of_images
     if(inc_energy)then
     d = 0.0d0
     if(i>1) then
        d = 0.0d0
        do j=1, neb%image(i)%num_atom
           d = d + dot_product(neb%image(i-1)%cps(j,:)-neb%image(i)%cps(j,:), &
                neb%image(i-1)%cps(j,:)-neb%image(i)%cps(j,:))
        end do
        d = sqrt(d)
     end if
     sum_d = sum_d + d
     write(nfnebenf,'(2i5,5e20.10)')  neb%step, i, sum_d, neb%image(i)%energy, &
          get_max_force(neb,i,'org'),get_max_force(neb,i,'neb'),get_max_force(neb,i,'true')
     write(nfenf,'(2i5,5e20.10)')  neb%step, i, sum_d, neb%image(i)%energy, &
          get_max_force(neb,i,'org'),get_max_force(neb,i,'neb'),get_max_force(neb,i,'true')
     endif
     write(nfnebdynm,'(a,i5,i8,a)') ' cps and forc at (nebstep, iter_total=',neb%step,iteration,')'
     write(nfdynm,'(a,i5,i8,a)') ' cps and forc at (nebstep, iter_total=',neb%step,iteration,')'
     do j = 1, neb%image(i)%num_atom
!        write(nfnebdynm,'(3i5,3f20.10)') neb%step, i, j, neb%image(i)%cps(j,1:3)
        write(nfnebdynm,'(" ",i4,3f15.9,3f12.6)') j &
        &, neb%image(i)%cps(j,1),neb%image(i)%cps(j,2),neb%image(i)%cps(j,3) &
        &, neb%image(i)%force(j,1), neb%image(i)%force(j,2), neb%image(i)%force(j,3)
        write(nfdynm,'(" ",i4,3f15.9,3f12.6)') j &
        &, neb%image(i)%cps(j,1),neb%image(i)%cps(j,2),neb%image(i)%cps(j,3) &
        &, neb%image(i)%force(j,1), neb%image(i)%force(j,2), neb%image(i)%force(j,3)
     end do
  end do

  if(inc_energy) write(nfnebenf,*)

  call flush(nfnebdynm)
  call flush(nfnebenf)

  close(nfdynm)
  close(nfenf)
  ! temporary
  !!write(form,'(a4,i5,a7)') '(i5,',neb%number_of_images,'e20.10)'
  !!write(212,form) neb%step, neb%image(:)%energy

  !!neb%energy(neb%step,:) = neb%image(:)%energy
  !!open(213)
  !!write(form,'(a4,i5,a7)') '(i5,',neb%step,'e20.10)'
  !!do i=1, neb%number_of_images
  !!   write(213,form) i, neb%energy(1:neb%step,i)
  !!end do
  !!close(213)

end subroutine write_result

subroutine finalize_neb()
  use m_Replica, only : m_Replica_finalize, nrank_r
  use m_Files, only : nfnebstop, F_NEB_STOP, nfneb, m_Files_close_and_clear_nfstop
  use m_Control_Parameters,  only : ipriparadeb
  use m_Parallelization, only : mype

  implicit none
  include 'mpif.h'

  integer :: mpi_err
  call m_Replica_finalize()

  if(nrank_r.gt.1) call mpi_barrier(mpi_comm_world, mpi_err)
  open(nfnebstop, file=F_NEB_STOP, status='replace', form='formatted')
  close(nfnebstop, status='keep')

! ==== KT_add ===== 2014/07/20
#ifdef NEB_NEW_FILENAMES
  if ( mype == 0 ) close(nfneb)
#else
  if ( mype == 0 ) then
     close(nfneb)
  else if(ipriparadeb == 0) then
     close(nfneb, status='delete')
  else
     close(nfneb, status='keep')
  end if
#endif
! ================= 2014/07/20

  call m_Files_close_and_clear_nfstop()
end subroutine finalize_neb

subroutine deallocate_array_partial
  use m_PlaneWaveBasisSet
  use m_Parallelization
  use m_Kpoints
  implicit none
  call m_pwBS_dealloc()
  call m_Parallel_dealloc(neb_mode=.true.)
  call m_Kp_dealloc
end subroutine deallocate_array_partial

subroutine deallocate_array

  use m_Control_Parameters
  use m_Crystal_Structure
  use m_Ionic_System
  use m_PlaneWaveBasisSet
  use m_Parallelization
  use m_Kpoints
  use m_Force
  use m_Charge_Density
  use m_XC_Potential
  use m_PseudoPotential
  use m_NonLocal_Potential
  use m_Electronic_Structure
  use m_ES_WF_by_SDorCG
  use m_ES_wf_extrpl

!  call m_CtrlP_dealloc

  call m_CS_dealloc(neb_mode=.true.)
  call m_IS_dealloc(neb_mode=.true.)
  call m_pwBS_dealloc
  call m_Parallel_dealloc(neb_mode=.true.)
  call m_Kp_dealloc
  call m_Force_dealloc
  call m_CD_dealloc
  call m_XC_dealloc_vxc
  !call m_PP_dealloc
  !call m_NLP_dealloc
  call m_ES_dealloc
  call m_ESsd_dealloc
  call m_ES_wf_extrpl_dealloc()
  call m_CtrlP_set_init_status(.true.)

end subroutine deallocate_array

#define NEC_TUNE
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 606 $)
!
!  MODULE: m_NonLocal_Potential
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_IODO__
#   define __TIMER_IODO_START(a)   call timer_sta(a)
#   define __TIMER_IODO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_IODO_START(a)
#   define __TIMER_IODO_STOP(a)
#endif
#ifdef __TIMER_IOCOMM__
#   define __TIMER_IOCOMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_IOCOMM_START(a)       call timer_sta(a)
#   define __TIMER_IOCOMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_IOCOMM_START_w_BARRIER(str,a)
#   define __TIMER_IOCOMM_START(a)
#   define __TIMER_IOCOMM_STOP(a)
#endif

module m_NonLocal_Potential
!    ( m_NLP )
!  $Id: m_NonLocal_Potential.F90 606 2020-04-15 06:45:49Z ktagami $
!
!  This module contains following major subroutines
!  1.  m_NLP_alloc_snl
!  2.  m_NLP_wd_snl(nfcntn_bin,kv3)
!  3.  m_NLP_rd_snl(nfcntn_bin,kv3)
!  4.  m_NLP_betar_dot_PWs(nfout,kv3,vkxyz)
!  5.  m_NLP_betar_dot_PWs_diff(nfout,kv3,vkxyz)
!
! The subroutine "m_NLP_betar_dot_WFs" originates from a subroutine "kbint".
! The subroutine "kbint" was coded mainly by Y. Morikawa in 1993 or earlier.
! The subroutine "kbint" has following comments
!!!$C Fourier transformation of function beta(r).
!!$c  #1) gx,gy,gz --> ngabc by T.Yamasaki on 15th Feb. 1995
!!$c  #2) vx,vy,vz --> vkxyz by T.Yamasaki on 15th Feb. 1995
!!$c  #3) betar --> betar_l  by T.Yamasaki on 3rd Mar. 1995
!!$c  #4) snl2 is introduced by Y. Morikawa. 14th May. 1996
!!$c  #5) antiferromagnetic calculation is added on 9th Jul. 1996
!!$c                                          by H.Sawada
!
! The subroutine "m_NLP_betar_dot_PWs_diff" originates from a subroutine
! "kbint_diff" coded by H. Sawada at 8th May 1997.
! This was translated into the subroutine "m_NLP_betar_dot_PWs_diff" using
! fortran90+MPI by H. Sawada and T. Yamasaki in 1999.
!
  use m_PlaneWaveBasisSet,    only : kgp,kg1,ngabc,iba,nbase
  use m_PseudoPotential,      only : wos,radr,betar,nmesh,mmesh,ilmt,xh,rmax,ntau &
       &                           , m_PP_tell_lmtt_l_m_tau,nlmtt &
       &                           , m_PP_tell_lmtt_l_m_tau_phi &
       &                           , m_PP_tell_lmtt_l_m_tau_add &
       &                           , m_PP_tell_lmtt_l_m_tau_pao &
       &                           , phirt,ilmt_phi, nlmtt_phi &
       &                           , betar_add,ilmt_add, nlmtt_add &
       &                           , paor,ilmt_pao, nlmtt_pao &
       &                           , nlmta,lmta,ilmt,lmtt, nloc &
       &                           , qrspspw,m_PP_find_maximum_l &
       &                           , ltp,taup,il2p,nqitg,iqitg,isph, modnrm
  use m_Crystal_Structure,    only : rltv, univol, op, altv
  use m_Ionic_System,         only : ntyp,pos,natm,ityp
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : nspin, ipri, iprisnl, istress &
       &                           , sw_orb_popu, ipriphig, ipripao, iprirs, printable, r0_factor &
       &                           , dq, gamma_factor,gmax, projector_optimization,gmaxp,ipribetar,kimg,qr_optimization &
       &                           , sw_betar_dot_wfs_exp, sw_precalculate_phase_vnonlocal
  use m_Const_Parameters,     only : DP, PAI2, PAI4, BUCS, CRDTYP, ON, DELTA, PREFITTING, MASK_FUNCTION, PAI, GAMMA
  use m_Parallelization,      only : map_k,myrank_k,ista_k,iend_k,mype &
       &                           , myrank_e,nrank_e,mpi_k_world,ierr &
       &                           , ista_snl, iend_snl, mpi_comm_group, npes
  use m_Parallelization,      only : np_g1k,ista_g1k, iend_g1k    &
       &                           , mpi_kg_world,mpi_ke_world 
  use m_PlaneWaveBasisSet,   only : ngabc_kngp_l, ngabc_kngp_B_l,kg

! ================================ added by K. Tagami ============== 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor
! ================================================================== 11.0

  use m_FFT,                  only : fft_box_size_WF

  use m_Realspace,            only : nmesh_rs, nmesh_rs_h, nmesh_rs_max, nmesh_rs_max_h &
  &  ,meshx_rs, meshy_rs, meshz_rs, meshxyz_rs, meshxyz_rs_h, map_h, map_h_i, meshxyz_rs_conjg &
  &  ,rcut_betar, rcut_betar_rs, rcut_qr, rcut_qr_rs, m_RS_R_minus_pos

  use m_Kpoints,              only : k_symmetry
  implicit none
  include 'mpif.h'                              ! MPI
  integer istatus(mpi_status_size)              ! MPI

  real(kind=DP), allocatable,target,dimension(:,:,:)     :: snl  !d(kg1,nlmtt,ista_snl:iend_snl)
  real(kind=DP), allocatable,target,dimension(:,:,:,:,:) :: snld !d(kg1,nlmtt,ista_snl:iend_snl,3)
  real(kind=DP), allocatable,target,dimension(:,:,:,:)   :: i_exp_snl  !d(kg1,nlmtt,ista_snl:iend_snl)
  real(kind=DP), allocatable,target,dimension(:,:,:,:)   :: AtaulmaG,BtaulmaG

  real(kind=DP), allocatable,dimension(:,:,:)     :: snl_add  !d(kg1,nlmtt_add,ista_snl:iend_snl)

  real(kind=DP),private,allocatable,dimension(:) :: qx,qy,qz,vlength,snl2,wka,wkb,ylm
  real(kind=DP),private,allocatable,dimension(:)     :: snl3,wkc,wkd
  real(kind=DP),private,allocatable,dimension(:,:)   :: ylmd,alinvt

  real(kind=DP), allocatable,dimension(:,:,:) :: phig !d(kg1,nlmtt_phi,ista_snl:iend_snl)
  real(kind=DP), allocatable,dimension(:,:) :: norm_phig !d(nlmtt_phi,ista_snl:iend_snl)

  real(kind=DP), allocatable,dimension(:,:,:) :: paog !d(kg1,nlmtt_pao,ista_snl:iend_snl)

  ! rs-related variables
!  integer, allocatable, dimension(:)   :: nmesh_rs
!  integer, allocatable, dimension(:)   :: nmesh_rs_h
!  integer                              :: nmesh_rs_max
!  integer                              :: nmesh_rs_max_h
!  integer, allocatable, dimension(:,:) :: meshx_rs
!  integer, allocatable, dimension(:,:) :: meshy_rs
!  integer, allocatable, dimension(:,:) :: meshz_rs
!  integer, allocatable, dimension(:,:) :: meshxyz_rs
!  integer, allocatable, dimension(:,:) :: meshxyz_rs_h
!  integer, allocatable, dimension(:,:) :: map_h
!  integer, allocatable, dimension(:,:) :: map_h_i
!  integer, allocatable, dimension(:,:) :: meshxyz_rs_conjg
!  integer :: neix=2
!  integer :: neiy=2
!  integer :: neiz=2

  real(kind=DP), allocatable, target, dimension(:,:) :: snl_rs
  real(kind=DP), allocatable, target, dimension(:,:) :: snl_rs_h
  real(kind=DP), allocatable, dimension(:,:,:) :: snld_rs
  real(kind=DP), allocatable, dimension(:,:,:,:) :: betar_optimized
  real(kind=DP), allocatable, dimension(:,:) :: qr_optimized
  logical :: done_optimization = .false.

!  real(kind=DP), allocatable, dimension(:) :: rcut_betar_rs
!  real(kind=DP), allocatable, dimension(:) :: rcut_betar

  real(kind=DP) :: drmask = 0.005d0
  integer, parameter :: nmask=201
  real(kind=DP),dimension(nmask) :: maskr15
  data maskr15 &
  & / 0.10000000E+01, 0.10000000E+01, 0.99948662E+00, 0.99863154E+00, 0.99743557E+00, 0.99589985E+00 &
  &  ,0.99402586E+00, 0.99181538E+00, 0.98927052E+00, 0.98639370E+00, 0.98318766E+00, 0.97965544E+00 &
  &  ,0.97580040E+00, 0.97162618E+00, 0.96713671E+00, 0.96233623E+00, 0.95722924E+00, 0.95182053E+00 &
  &  ,0.94611516E+00, 0.94011842E+00, 0.93383589E+00, 0.92727338E+00, 0.92043693E+00, 0.91333282E+00 &
  &  ,0.90596753E+00, 0.89834777E+00, 0.89048044E+00, 0.88237263E+00, 0.87403161E+00, 0.86546483E+00 &
  &  ,0.85667987E+00, 0.84768450E+00, 0.83848659E+00, 0.82909416E+00, 0.81951535E+00, 0.80975838E+00 &
  &  ,0.79983160E+00, 0.78974340E+00, 0.77950227E+00, 0.76911677E+00, 0.75859548E+00, 0.74794703E+00 &
  &  ,0.73718009E+00, 0.72630334E+00, 0.71532544E+00, 0.70425508E+00, 0.69310092E+00, 0.68187158E+00 &
  &  ,0.67057566E+00, 0.65922170E+00, 0.64781819E+00, 0.63637355E+00, 0.62489612E+00, 0.61339415E+00 &
  &  ,0.60187581E+00, 0.59034914E+00, 0.57882208E+00, 0.56730245E+00, 0.55579794E+00, 0.54431609E+00 &
  &  ,0.53286431E+00, 0.52144984E+00, 0.51007978E+00, 0.49876105E+00, 0.48750040E+00, 0.47630440E+00 &
  &  ,0.46517945E+00, 0.45413176E+00, 0.44316732E+00, 0.43229196E+00, 0.42151128E+00, 0.41083069E+00 &
  &  ,0.40025539E+00, 0.38979038E+00, 0.37944042E+00, 0.36921008E+00, 0.35910371E+00, 0.34912542E+00 &
  &  ,0.33927912E+00, 0.32956851E+00, 0.31999705E+00, 0.31056799E+00, 0.30128436E+00, 0.29214897E+00 &
  &  ,0.28316441E+00, 0.27433307E+00, 0.26565709E+00, 0.25713844E+00, 0.24877886E+00, 0.24057988E+00 &
  &  ,0.23254283E+00, 0.22466884E+00, 0.21695884E+00, 0.20941357E+00, 0.20203357E+00, 0.19481920E+00 &
  &  ,0.18777065E+00, 0.18088790E+00, 0.17417080E+00, 0.16761900E+00, 0.16123200E+00, 0.15500913E+00 &
  &  ,0.14894959E+00, 0.14305240E+00, 0.13731647E+00, 0.13174055E+00, 0.12632327E+00, 0.12106315E+00 &
  &  ,0.11595855E+00, 0.11100775E+00, 0.10620891E+00, 0.10156010E+00, 0.97059268E-01, 0.92704295E-01 &
  &  ,0.88492966E-01, 0.84422989E-01, 0.80492001E-01, 0.76697569E-01, 0.73037197E-01, 0.69508335E-01 &
  &  ,0.66108380E-01, 0.62834685E-01, 0.59684561E-01, 0.56655284E-01, 0.53744102E-01, 0.50948236E-01 &
  &  ,0.48264886E-01, 0.45691239E-01, 0.43224469E-01, 0.40861744E-01, 0.38600231E-01, 0.36437098E-01 & 
  &  ,0.34369520E-01, 0.32394681E-01, 0.30509780E-01, 0.28712032E-01, 0.26998673E-01, 0.25366964E-01 &
  &  ,0.23814193E-01, 0.22337676E-01, 0.20934765E-01, 0.19602844E-01, 0.18339338E-01, 0.17141711E-01 &
  &  ,0.16007467E-01, 0.14934157E-01, 0.13919377E-01, 0.12960772E-01, 0.12056034E-01, 0.11202905E-01 &
  &  ,0.10399183E-01, 0.96427132E-02, 0.89313983E-02, 0.82631938E-02, 0.76361106E-02, 0.70482151E-02 &
  &  ,0.64976294E-02, 0.59825322E-02, 0.55011581E-02, 0.50517982E-02, 0.46327998E-02, 0.42425662E-02 &
  &  ,0.38795566E-02, 0.35422853E-02, 0.32293218E-02, 0.29392897E-02, 0.26708663E-02, 0.24227820E-02 &
  &  ,0.21938194E-02, 0.19828122E-02, 0.17886449E-02, 0.16102512E-02, 0.14466132E-02, 0.12967606E-02 &
  &  ,0.11597692E-02, 0.10347601E-02, 0.92089812E-03, 0.81739110E-03, 0.72348823E-03, 0.63847906E-03 &
  &  ,0.56169212E-03, 0.49249371E-03, 0.43028657E-03, 0.37450862E-03, 0.32463165E-03, 0.28016004E-03 &
  &  ,0.24062948E-03, 0.20560566E-03, 0.17468305E-03, 0.14748362E-03, 0.12365560E-03, 0.10287226E-03 &
  &  ,0.84830727E-04, 0.69250769E-04, 0.55873673E-04, 0.44461100E-04, 0.34793983E-04, 0.26671449E-04 &
  &  ,0.19909778E-04, 0.14341381E-04, 0.98138215E-05 /

contains
  subroutine m_NLP_alloc_snl
!!$    ista_snl = (ista_k + nspin - 1)/nspin
!!$    iend_snl = iend_k/nspin
!!$    print '(" ista_snl = ",i3)',ista_snl
!!$    print '(" iend_snl = ",i3)',iend_snl
    if ( allocated(snl) ) deallocate(snl)
    if ( allocated(i_exp_snl) ) deallocate(i_exp_snl)
    if ( allocated(snld) ) deallocate(snld)
    allocate(snl(maxval(np_g1k),nlmtt,ista_snl:iend_snl)); snl = 0.d0
    if(sw_betar_dot_wfs_exp==ON) then
      allocate(i_exp_snl(maxval(np_g1k),nlmta,ista_snl:iend_snl,2)); i_exp_snl = 0.d0
    endif
    if(istress == ON) then

       allocate(snld(maxval(np_g1k),nlmtt,ista_snl:iend_snl,3,3)); snld = 0.d0
    end if
  end subroutine m_NLP_alloc_snl

  subroutine m_NLP_alloc_taulmaG()
    if(sw_precalculate_phase_vnonlocal==ON) then
      allocate(AtaulmaG(maxval(np_g1k),nlmta,ista_k:iend_k,2));AtaulmaG = 0.d0
      if(modnrm==ON) allocate(BtaulmaG(maxval(np_g1k),nlmta,ista_k:iend_k,2));BtaulmaG = 0.d0
    endif
  end subroutine m_NLP_alloc_taulmaG


  subroutine m_NLP_alloc_phig
    if ( allocated(phig) ) deallocate(phig)
    if ( allocated(norm_phig) ) deallocate(norm_phig)
    if(sw_orb_popu == ON) then
       allocate(phig(maxval(np_g1k),nlmtt_phi,ista_snl:iend_snl)); phig = 0.d0
       allocate(norm_phig(nlmtt_phi,ista_snl:iend_snl)); norm_phig = 1.d0
    end if
  end subroutine m_NLP_alloc_phig
 
  subroutine m_NLP_alloc_snl_add
    if ( allocated(snl_add) ) deallocate(snl_add) 

    allocate(snl_add(maxval(np_g1k),nlmtt_add,ista_snl:iend_snl)); snl_add = 0.d0
  end subroutine m_NLP_alloc_snl_add

  subroutine m_NLP_alloc_paog
    if ( allocated(paog) ) deallocate(paog) 
    allocate(paog(maxval(np_g1k),nlmtt_pao,ista_snl:iend_snl)); paog = 0.d0
  end subroutine m_NLP_alloc_paog


  logical function use_sphr_general( ik, kv3, vkxyz )
    integer,       intent(in)       :: ik, kv3
    real(kind=DP), intent(in)       :: vkxyz(kv3,3,CRDTYP)

    real(kind=DP) :: knorm1, knorm2

    knorm1 = vkxyz(ik,1,BUCS)**2 +vkxyz(ik,2,BUCS)**2 +vkxyz(ik,3,BUCS)**2
    knorm2 = ( vkxyz(ik,1,BUCS) -floor(vkxyz(ik,1,BUCS)) )**2 &
         &  +( vkxyz(ik,2,BUCS) -floor(vkxyz(ik,2,BUCS)) )**2 &
         &  +( vkxyz(ik,3,BUCS) -floor(vkxyz(ik,3,BUCS)) )**2
    knorm1 = sqrt( knorm1 );      knorm2 = sqrt( knorm2 )
    if ( knorm1 > 1.d-20 .and. knorm2 < 1.0D-20 ) then
       use_sphr_general = .true.
    else
       use_sphr_general = .false.
    endif
    return
  end function use_sphr_general
  

    subroutine wd_lmt_l_m_tau_etc(nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher)
    integer, intent(in)  :: nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher
      write(nfout,230) it,lmt1,il1,im1,tau1,lmtt1,nspher
230   format(' ',' it=',i2,' lmt1=',i2,' il1,im1,tau1=',3i2, &
           &                   ' lmtt1=',i3,' nspher=',i3)
    end subroutine wd_lmt_l_m_tau_etc

    subroutine new_radr_and_wos(ik,it)
      integer, intent(in)  :: ik,it
      real(kind=DP), parameter :: delta = 1.d-40
      real(kind=DP)      :: hn
      real(kind=DP),save :: xhn = 0.d0 , rmaxn = 0.d0
      integer,save       :: nmeshn = 0
      if((ik == ista_k .and. it == 1) .or. &            ! MPI
           & (nmeshn /= nmesh(it) .or. dabs(xhn-xh(it)) > delta  .or. &
           &  dabs(rmaxn-rmax(it)) > delta) ) then
         call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
         call coef_simpson_integration(nmesh(it),nmesh(it),xh(it),radr,wos) ! -(b_PP)
         xhn = xh(it); rmaxn = rmax(it); nmeshn = nmesh(it)
      endif
    end subroutine new_radr_and_wos

    subroutine radr_and_wos_p(n1,n2,mtyp,mradr,ip_radr,radr_p,wos_p)
      integer, intent(in) :: n1, n2, mtyp,mradr
      integer, intent(in), dimension(mtyp) :: ip_radr
      real(kind=DP), intent(out), dimension(n1:n2,mradr) :: radr_p, wos_p

      real(kind=DP)      :: hn
      integer :: it, i, ip, ip0
      ip = 0
      do it = 1, ntyp
         if(ntyp > mtyp) cycle
         if(ip_radr(it) /= ip) then
            call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
            call coef_simpson_integration(nmesh(it),nmesh(it),xh(it),radr,wos) ! -(b_PP)
            ip = ip_radr(it)
            do i = n1, n2
               radr_p(i,ip) = radr(i)
               wos_p(i,ip) = wos(i)
            end do
         end if
      end do
    end subroutine radr_and_wos_p

    subroutine find_critical_point(r,n,x,idp)
      real(kind=DP), intent(in) :: r
      integer,  intent(in)      :: n
      real(kind=DP), intent(in), dimension(n) :: x
      integer,  intent(out)     :: idp
      integer :: i
      do i = 1, n
         idp = i
         if(x(i) > r) exit
      end do
    end subroutine find_critical_point


  subroutine m_NLP_dealloc
    if(allocated(snl)) deallocate(snl)
    if(allocated(snl_add)) deallocate(snl_add)          
    if(allocated(i_exp_snl)) deallocate(i_exp_snl)

    if(allocated(paog)) deallocate(paog)          
    if(istress == ON) deallocate(snld)

! =========== KT_add ====== 13.0AS
    if (sw_orb_popu == ON) then
       deallocate(phig);  deallocate(norm_phig)
    end if
! ========================= 13.0AS

  end subroutine m_NLP_dealloc

!===============================================================================
  subroutine m_NLP_betar_dot_PWs_3D(nfout,kv3,vkxyz)
    integer,       intent(in)       :: nfout,kv3
    real(kind=DP), intent(in)       :: vkxyz(kv3,3,CRDTYP)

    real(kind=DP)       :: fac, facr
    integer             :: ik,iksnl,it,n,lmt1,lmtt1,il1,im1,tau1,nspher, ig, n1, n2
    integer             :: i, j, k
    integer             :: id_sname = -1
    real(kind=DP), dimension(:,:), allocatable :: snl2_mpi, snl1

#ifndef _mNLP_no_loop_exchange_
    integer, parameter  :: lcmax = 4
    integer :: ip
    integer :: mil, mp  ! mp = maxval(np)
    integer, dimension(:),     allocatable :: nil  ! d(ntyp)
    integer, dimension(:,:),   allocatable :: nt   ! d(ntyp,mil)
    integer, dimension(:,:,:), allocatable :: tu2p ! d(ntau,ntyp,mil)
    integer, dimension(:),     allocatable :: np   ! d(mil), np=sum_{u=1}^{ntyp}(nt(u,mil))
    integer, dimension(:,:,:), allocatable ::  pm2lmtt1 ! d(mp,2*(mil-1)+1,mil)
    real(kind=DP), dimension(:,:), allocatable :: snl_t, snl_t_mpi ! d(iba(ik),mp)
    real(kind=DP), dimension(:,:), allocatable :: radr_p, wos_p ! d(n1:n2,ntyp)
    integer :: p, mradr_indp 
    logical, dimension(:,:), allocatable :: flag_radr !d(ntyp,mil)
    integer, dimension(:), allocatable   :: ip_radr !d(ntyp)
    real(kind=DP) :: r, w
#endif
                                                  __TIMER_SUB_START(1224)

    call tstatc0_begin('m_NLP_betar_dot_PWs ',id_sname,1)
    call innerPr_allocate_3D()

    fac = PAI4/dsqrt(univol)

#ifndef _mNLP_no_loop_exchange_
!!$    allocate(nil(ntyp)); nil = 0
!!$    allocate(nt(ntyp,lcmax)); allocate(tu2p(ntau,ntyp,lcmax)); allocate(np(lcmax))
!!$    nt = 0; tu2p = 0
!!$    call set_index_arrays1(ntyp,nil,nt,tu2p,mil,mp) ! mil, mp, nil, nt, tu2p, np, pm2lmtt1, contained here
!!$    allocate(pm2lmtt1(mp,2*(mil-1)+1,mil))
!!$    call set_index_arrays2(mp,pm2lmtt1)
    call set_index_arrays() ! mil, mp, nil, nt, tu2p, np, pm2lmtt1, contained here

    n = ceiling(dble(mmesh)/nrank_e)
    if(n == 0) n = 1
    n1 = n*myrank_e + 1
    n2 = n*(myrank_e+1)
    if(n2 > mmesh) n2 = mmesh

    allocate(flag_radr(ntyp,mil))
    allocate(ip_radr(ntyp))
!!$ASASASASAS
    flag_radr = .false.
    ip_radr = 0
!!$ASASASASAS
    call set_flag_radr_and_ip_radr() ! -> mradr_indp,flag_radr, ip_radr

    if(n1 <= n2) then
       allocate(radr_p(n1:n2,mradr_indp))
       allocate(wos_p(n1:n2,mradr_indp))
!!$ASASASASAS
       radr_p = 0; wos_p = 0
!!$ASASASASAS
       call radr_and_wos_p(n1,n2,ntyp,mradr_indp,ip_radr,radr_p,wos_p) ! -> radr_p, wos_p
    end if

    do ik = 1, kv3, nspin
       if(ipri >= 2) write(nfout,'(" ik = ",i8)') ik
       if(map_k(ik) /= myrank_k) cycle                     ! MPI
!!$ASASASASAS
!!$       allocate(snl_t(iba(ik),mp))
!!$       if(nrank_e > 1) allocate(snl_t_mpi(iba(ik),mp))
       allocate(snl_t(np_g1k(ik),mp)); snl_t = 0
       if(nrank_e > 1) then
          allocate(snl_t_mpi(np_g1k(ik),mp)); snl_t_mpi = 0
       endif
!!$ASASASASAS

       if(ipri >= 2) write(nfout,'(" entering k_plus_G_vectors")')
       if(ipri >= 2) then
          write(nfout,'(" iba(ik) = ",i8)') iba(ik)
          write(nfout,'(" vkxyz(ik) = ",3f8.4)') vkxyz(ik,1:3,BUCS)
       end if
       if(.not.allocated(qx)) call phase_error_with_msg(nfout,' qx is not allocated',__LINE__,__FILE__)
       if(.not.allocated(vlength)) call phase_error_with_msg(nfout,' vlength is not allocated',__LINE__,__FILE__)
       if(.not.allocated(nbase)) call phase_error_with_msg(nfout,' nbase is not allocated',__LINE__,__FILE__)
!       call k_plus_G_vectors_3D(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
!            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       iksnl = (ik-1)/nspin + 1

       do il1 = 1, mil
          snl_t = 0.d0
          do n = n1, n2
             do it = 1, ntyp
                if(il1 > nil(it)) cycle
                if(flag_radr(it,il1)) then
                   r = radr_p(n,ip_radr(it))
                   do ig = 1, np_g1k(ik)
                      wka(ig) = vlength(ig)*r
                   end do
                   call dsjnv(il1-1,np_g1k(ik),wka,wkb)     ! -(bottom_Subr.)
                end if

                w = fac * wos_p(n,ip_radr(it)) * radr_p(n,ip_radr(it))
                do tau1 = 1, nt(it,il1)
                   facr = w * betar(n,il1,tau1,it)
                   ip = tu2p(tau1,it,il1)
                   do ig = 1, np_g1k(ik)
                      snl_t(ig,ip) = snl_t(ig,ip) + facr*wkb(ig)
                   end do
                end do
             end do
          end do
          if(nrank_e > 1) then
             call mpi_allreduce(snl_t,snl_t_mpi,np_g1k(ik)*np(il1),mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
             snl_t = snl_t_mpi
          end if

          do im1 = 1, 2*(il1-1)+1
             nspher = (il1-1)**2 + im1
             if ( use_sphr_general(ik,kv3,vkxyz) ) then
                call sphr_general(np_g1k(ik),nspher,qx,qy,qz,ylm)
             else
                call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)
             endif
             do p = 1, np(il1)
                ip = pm2lmtt1(p,im1,il1)
                do ig = 1, np_g1k(ik)
                   snl(ig,ip,iksnl) = snl_t(ig,p)*ylm(ig)
                end do
             end do
          end do
       end do
       if(nrank_e > 1) deallocate(snl_t_mpi)
       deallocate(snl_t)
    end do

    if(n1 <= n2) deallocate(wos_p,radr_p)
    deallocate(ip_radr,flag_radr)
    call dealloc_index_arrays()

#else
    if(nrank_e > 1) then
       allocate(snl1(kg1,nlmtt)); snl1 = 0.d0
       allocate(snl2_mpi(kg1,nlmtt))
!!$ASASASASAS
       snl2_mpi = 0.d0
!!$ASASASASAS
    end if

    do ik = 1, kv3, nspin
       if(map_k(ik) /= myrank_k) cycle                     ! MPI

       call k_plus_G_vectors(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       iksnl = (ik-1)/nspin + 1

       do it=1,ntyp

          n = ceiling(dble(nmesh(it))/nrank_e)
          if(n == 0) n = 1
          n1 = n*myrank_e + 1
          n2 = n*(myrank_e+1)
          if(n2 > nmesh(it)) n2 = nmesh(it)

          call new_radr_and_wos(ik,it)                 ! --> radr, wos
          do lmt1 = 1,ilmt(it)
             call m_PP_tell_lmtt_l_m_tau(lmt1,it,lmtt1,il1,im1,tau1,nspher)
             if ( use_sphr_general(ik,kv3,vkxyz) ) then
                call sphr_general(np_g1k(ik),nspher,qx,qy,qz,ylm)
             else
                call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)
             endif

             if(iprisnl >= 2) call wd_lmt_l_m_tau_etc &
                                (nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher)
             snl2 = 0.d0

             do n = n1, n2
                facr = fac*wos(n)*radr(n)*betar(n,il1,tau1,it)
                do ig = 1, iba(ik)
                   wka(ig) = vlength(ig)*radr(n)
                end do
                call dsjnv(il1-1,iba(ik),wka,wkb)     ! -(bottom_Subr.)
                do ig = 1, iba(ik)
                   snl2(ig) = snl2(ig) + facr*wkb(ig)
                end do
             end do

             if(nrank_e == 1) then
                do ig = 1, iba(ik)
                   snl(ig,lmtt1,iksnl) = snl2(ig)*ylm(ig)
                end do
             else
                do ig = 1, iba(ik)
                   snl1(ig,lmtt1) = snl2(ig)*ylm(ig)
                end do
             end if
          end do
       end do

       if(nrank_e > 1) then
          call mpi_allreduce(snl1, snl2_mpi, kg1*nlmtt,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
          do lmtt1 = 1, nlmtt
             do ig = 1, iba(ik)
                snl(ig,lmtt1,iksnl) = snl2_mpi(ig,lmtt1)
             end do
          end do
       end if
    end do
    if(nrank_e > 1) deallocate(snl2_mpi,snl1)
#endif
    if(iprisnl >= 2) call wd_snl

    call innerPr_deallocate_3D
    call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(1224)
  contains
#ifndef _mNLP_no_loop_exchange_
    subroutine set_flag_radr_and_ip_radr()
      integer :: it, il, ip, it2, is, it1

      mradr_indp = 1
      ip_radr(1) = 1
      do it = 2, ntyp
         is = 0
         search_loop: do it2 = 1, mradr_indp
            ip = ip_radr(it2)
            if((nmesh(ip) == nmesh(it) .and. dabs(xh(ip)-xh(it)) < DELTA .and. &
              & dabs(rmax(ip)-rmax(it)) < DELTA)) then
               is = it2
               exit search_loop
            end if
         end do search_loop
         if(is <= 0 .or. is > mradr_indp) then
            mradr_indp = mradr_indp+1
            is = mradr_indp
         end if
         ip_radr(it) = is
      end do

      if(ipri >= 2) then
         write(nfout,'(" !mNLP : mradr_indp = ", i5)') mradr_indp
         do it = 1, ntyp
            write(nfout,'(" !mNLP : ip_radr(",i5,") = ",i5)') it, ip_radr(it)
         end do
      end if

      do il = 1, mil
         flag_radr(1:ntyp,il) = .true.
         it1 = 0
         do it = 1, ntyp
            if(il > nil(it)) cycle
            it1 = it1+1
            if(it1 == 1) then
               flag_radr(it,il) = .true.
            else if(it1 >= 2) then
               if(ip_radr(ip) /= ip_radr(it)) then
                  flag_radr(it,il) = .true.
               else
                  flag_radr(it,il) = .false.
               end if
            end if
            ip = it
         end do
      end do

      if(ipri >= 2) then
         do il = 1, mil
            do it = 1, ntyp
               write(nfout,'(" !mNLP : flag_radr(",i5,",",i5,") = ",l3)') it,il,flag_radr(it,il)
            end do
         end do
      end if
    end subroutine set_flag_radr_and_ip_radr

    subroutine set_index_arrays()
      integer :: it, lmt1, n, il1, im1

      allocate(nil(ntyp)); nil = 0
      allocate(nt(ntyp,lcmax)); allocate(tu2p(ntau,ntyp,lcmax)); allocate(np(lcmax))
      nt = 0; tu2p = 0
      mil = 0
      if(ipri>=2) write(nfout,'(" !mNLP:    it, lmt1: lmtt1, il1, im1, tau1, nspher")')
      do it=1,ntyp
         do lmt1 = 1, ilmt(it)
            call m_PP_tell_lmtt_l_m_tau(lmt1,it,lmtt1,il1,im1,tau1,nspher)
            if(ipri>=2) write(nfout,'(" !mNLP: ",2i5," : ",5i5)') it,lmt1, lmtt1,il1,im1,tau1,nspher
            if(mil < il1) mil = il1
            if(nil(it) < il1) nil(it) = il1
            if(nt(it,il1) < tau1) nt(it,il1) = tau1
         end do
      end do

      do il1=1,mil
         n = 0
         np(il1) = 0
         do it=1,ntyp
            if(il1 > nil(it)) cycle
            np(il1) = np(il1)+nt(it,il1)
            do tau1=1,nt(it,il1)
               n = n+1
               tu2p(tau1,it,il1)= n
            end do
         end do
      end do

      mp = maxval(np(1:mil))
      allocate(pm2lmtt1(mp,2*(mil-1)+1,mil))
!!$ASASASASAS
      pm2lmtt1 = 0
!!$ASASASASAS
      do it = 1, ntyp
         do lmt1=1,ilmt(it)
            call m_PP_tell_lmtt_l_m_tau(lmt1,it,lmtt1,il1,im1,tau1,nspher)
            n = tu2p(tau1,it,il1)
            pm2lmtt1(n,im1,il1) = lmtt1
         end do
      end do

      if(ipri>=2) then
         write(nfout,'(" !mNLP: mil = ",i5)') mil
         do it = 1, ntyp
            write(nfout,'(" !mNLP: nil(",i3,") = ",i5)') it,nil(it)
         end do
         do it = 1, ntyp
            write(nfout,'(" !mNLP: nt(",i3,", : ) = ",5i5)') it,(nt(it,il1),il1=1,nil(it))
         end do

         write(nfout,'(" !mNLP: mp = ",i5)') mp
         do il1 = 1, mil
            write(nfout,'(" !mNLP: np(",i3,")=",i5)') il1, np(il1)
         end do
         do il1 = 1, mil
            do it = 1, ntyp
               if(il1 > nil(it)) cycle
               do tau1 = 1, nt(it,il1)
                  write(nfout,'(" !mNLP: tu2p(",i3,",",i3,",",i3,") = ",i5)') tau1,it,il1,tu2p(tau1,it,il1)
               end do
            end do
         end do
         do il1 = 1, mil
            do im1 = 1, 2*(il1-1)+1
               do n = 1, np(il1)
                  write(nfout,'(" !mNLP: il1 = ",i3," im1 = ",i3," n = ", i3, " pm2lmtt1 = ",i5)') &
                       & il1,im1, n,pm2lmtt1(n,im1,il1)
               end do
            end do
         end do
      end if
    end subroutine set_index_arrays

    subroutine dealloc_index_arrays()
      deallocate(pm2lmtt1,np,tu2p,nt,nil)
    end subroutine dealloc_index_arrays
#endif
      
    subroutine wd_snl
      integer, parameter :: MSNLSIZE = 20
      integer :: i, ilmtt, ik, j, iksnl, icycle, icolumn, max_elements, istart, iend, ic
      write(nfout,'(" << m_NLP_betar_dot_PWs.wd_snl >>")')
      write(nfout,'(10("(",3i2,")"))') ((ngabc(i,j),j=1,3),i=1,30)
      do ik = 1, kv3, nspin
         if(map_k(ik) /= myrank_k) cycle        ! MPI
         iksnl = (ik-1)/nspin + 1
         write(nfout,'(" ik = ",i5)') iksnl
         write(nfout,'(" nbase(1:8,",i5,")",i8,9i12)') ik,(nbase(i,ik),i=1,8)
         if(iprisnl >= 3) then
            max_elements = iba(ik)
         else
            max_elements = min(MSNLSIZE,iba(ik))
         end if
         icolumn = 10
         icycle = ceiling(dble(min(max_elements,kg1))/icolumn)
         do ilmtt = 1, nlmtt
!!$            write(nfout,'("(ilmtt = ",i5,")",8f10.5,99(/15x,8f10.5))') ilmtt,(snl(i,ilmtt,iksnl),i=1,kg1)
            write(nfout,'(" !nlp (ilmtt = ",i5,")")') ilmtt
            istart = 1
            do ic = 1, icycle
               iend = min(istart+icolumn-1,max_elements,kg1)
               write(nfout,'(" !nlp (nx)    ",10i12)') (ngabc(nbase(i,ik),1),i=istart,iend)
               write(nfout,'(" !nlp (ny)    ",10i12)') (ngabc(nbase(i,ik),2),i=istart,iend)
               write(nfout,'(" !nlp (nz)    ",10i12)') (ngabc(nbase(i,ik),3),i=istart,iend)
               write(nfout,'(" !nlp (snl)   ",10d12.4)') (snl(i,ilmtt,iksnl),i=istart,iend)
               istart = iend + 1
            end do
         end do
      end do
    end subroutine wd_snl
  end subroutine m_NLP_betar_dot_PWs_3D

  subroutine innerPr_allocate_3D
    allocate(qx(maxval(np_g1k))); qx = 0.d0
    allocate(qy(maxval(np_g1k))); qy = 0.d0
    allocate(qz(maxval(np_g1k))); qz = 0.d0
    allocate(vlength(maxval(np_g1k))); vlength = 0.d0
    allocate(snl2(maxval(np_g1k))); snl2 = 0.d0
    allocate(wka(maxval(np_g1k)));  wka  = 0.d0
    allocate(wkb(maxval(np_g1k)));  wkb  = 0.d0
    allocate(ylm(maxval(np_g1k)));  ylm  = 0.d0
  end subroutine innerPr_allocate_3D

  subroutine innerPr_deallocate_3D
    deallocate(ylm)
    deallocate(wkb)
    deallocate(wka)
    deallocate(snl2)
    deallocate(vlength)
    deallocate(qz)
    deallocate(qy)
    deallocate(qx)
  end subroutine innerPr_deallocate_3D

!------
  subroutine innerPr1_allocate_3D
    allocate(qx(maxval(np_g1k))); qx = 0.d0
    allocate(qy(maxval(np_g1k))); qy = 0.d0
    allocate(qz(maxval(np_g1k))); qz = 0.d0
    allocate(vlength(maxval(np_g1k))); vlength = 0.d0
    allocate(snl2(maxval(np_g1k))); snl2 = 0.d0
    allocate(wka(maxval(np_g1k)));  wka  = 0.d0
    allocate(wkb(maxval(np_g1k)));  wkb  = 0.d0
    allocate(wkc(maxval(np_g1k)));  wkc  = 0.d0
    allocate(wkd(maxval(np_g1k)));  wkd  = 0.d0
    allocate(ylm(maxval(np_g1k)));  ylm  = 0.d0
    allocate(snl3(maxval(np_g1k))); snl3 = 0.d0
    allocate(ylmd(maxval(np_g1k),3)); ylmd = 0.d0
    allocate(alinvt(3,3)); alinvt = 0.d0
  end subroutine innerPr1_allocate_3D

  subroutine innerPr1_deallocate_3D
    deallocate(alinvt)
    deallocate(ylmd)
    deallocate(snl3)
    deallocate(ylm)
    deallocate(wkd)
    deallocate(wkc)
    deallocate(wkb)
    deallocate(wka)
    deallocate(snl2)
!!$    deallocate(wos)
!!$    deallocate(radr)
    deallocate(vlength)
    deallocate(qz)
    deallocate(qy)
    deallocate(qx)
  end subroutine innerPr1_deallocate_3D

  subroutine m_NLP_betar_dot_PWs_diff_3D(nfout,kv3,vkxyz)

    integer,       intent(in)       :: nfout,kv3
    real(kind=DP), intent(in)       :: vkxyz(kv3,3,CRDTYP)

    real(kind=DP)       :: fac, facr
    integer             :: ik,iksnl,it,n,lmt1,lmtt1,il1,im1,tau1,nspher,j, ig
    integer             :: id_sname = -1

    call tstatc0_begin('m_NLP_betar_dot_PWs_diff ',id_sname,1)
    if(iprisnl >= 2) write(nfout,*) ' <<< m_NLP_betar_dot_PWs_diff >>>'
    call innerPr1_allocate_3D
    if(iprisnl >= 2) write(nfout,*) ' after innerPr1_allocate'

    alinvt = rltv / PAI2
    fac = PAI4/dsqrt(univol)
    do ik = 1, kv3, nspin
       if(map_k(ik) /= myrank_k) cycle             ! MPI

!       call k_plus_G_vectors_3D(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
!            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)

       iksnl = (ik-1)/nspin + 1
       do it=1,ntyp
          call new_radr_and_wos(ik,it)                 ! --> radr, wos
          do lmt1 = 1,ilmt(it)
             call m_PP_tell_lmtt_l_m_tau(lmt1,it,lmtt1,il1,im1,tau1,nspher)
             ylm = 0.d0; ylmd = 0.d0
             call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)        ! -(bottom_Subr.)
             call sphr_diff(maxval(np_g1k),np_g1k(ik),nspher,qx,qy,qz,ylmd) ! -(bottom_Subr.)
             if(ipri >= 2) call wd_lmt_l_m_tau_etc &
                                (nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher)
             snl2 = 0.d0; snl3 = 0.d0
             wkb = 0.d0; wkc = 0.d0; wkd = 0.d0
!xocl spread do/ind_kmesh
             do n = 1,nmesh(it)
                facr = fac*wos(n)*radr(n)*betar(n,il1,tau1,it)
                wka = vlength*radr(n)
                if(il1-1.ne.0) call dsjnv(il1-2,np_g1k(ik),wka,wkc)
                !                                            -(bottom_Subr.)
                call dsjnv(il1-1,np_g1k(ik),wka,wkb)     ! -(bottom_Subr.)
                call dsjnv(il1  ,np_g1k(ik),wka,wkd)     ! -(bottom_Subr.)
                do ig = 1, np_g1k(ik)
                   snl2(ig) = snl2(ig) + facr*wkb(ig)
                end do
!!$                snl2 = snl2 + facr*wkb
                if(il1-1 == 0) then
                   do ig = 1, np_g1k(ik)
                      snl3(ig) = snl3(ig) - facr*radr(n)/(2.d0*il1-1.d0)*il1*wkd(ig)
                   end do
                else
                   do ig =1, np_g1k(ik)
                      snl3(ig) = snl3(ig) + &
                           &  facr*radr(n)/(2.d0*il1-1.d0)*((il1-1)*wkc(ig)-il1*wkd(ig))
                   end do
                endif
             end do
!xocl end spread sum(snl2,snl3)
             snl(1:np_g1k(ik),lmtt1,iksnl) = snl2(1:np_g1k(ik)) *  &
    &                               ylm(1:np_g1k(ik))
             where( vlength > 1.d-15 )
                snl3 = - snl3 * ylm / vlength
             elsewhere
                snl3 = 0.d0
             end where

             do j = 1,3
                do ig = 1, np_g1k(ik)
                   snld(ig,lmtt1,iksnl,1,j) = &
                        & snl3(ig)*qx(ig)*(qx(ig)*alinvt(1,j) &
                        &                      +qy(ig)*alinvt(2,j) &
                        &                      +qz(ig)*alinvt(3,j)) &
                        & -snl2(ig)*qx(ig)*(ylmd(ig,1)*alinvt(1,j) &
                        &                       +ylmd(ig,2)*alinvt(2,j) &
                        &                       +ylmd(ig,3)*alinvt(3,j)) &
                        & -snl2(ig)*ylm(ig)/2.d0*alinvt(1,j)
                   snld(ig,lmtt1,iksnl,2,j) = &
                        & snl3(ig)*qy(ig)*(qx(ig)*alinvt(1,j) &
                        &                      +qy(ig)*alinvt(2,j) &
                        &                      +qz(ig)*alinvt(3,j)) &
                        & -snl2(ig)*qy(ig)*(ylmd(ig,1)*alinvt(1,j) &
                        &                       +ylmd(ig,2)*alinvt(2,j) &
                        &                       +ylmd(ig,3)*alinvt(3,j)) &
                        & -snl2(ig)*ylm(ig)/2.d0*alinvt(2,j)
                   snld(ig,lmtt1,iksnl,3,j) = &
                        & snl3(ig)*qz(ig)*(qx(ig)*alinvt(1,j) &
                        &                      +qy(ig)*alinvt(2,j) &
                        &                      +qz(ig)*alinvt(3,j)) &
                        & -snl2(ig)*qz(ig)*(ylmd(ig,1)*alinvt(1,j) &
                        &                       +ylmd(ig,2)*alinvt(2,j) &
                        &                       +ylmd(ig,3)*alinvt(3,j)) &
                        & -snl2(ig)*ylm(ig)/2.d0*alinvt(3,j)
                end do
             end do
          end do
       end do
    end do
    if(ipri >= 2) call wd_snld
    call innerPr1_deallocate_3D
    call tstatc0_end(id_sname)

  contains
    subroutine wd_snld
      integer :: i, ilmtt, ik, j, iksnl, k
      write(nfout,'(" << m_NLP_betar_dot_PWs_diff.wd_snl >>")')
      write(nfout,'(10(''('',3i2,'')''))') ((ngabc(i,j),j=1,3),i=1,30)
      do ik = 1, kv3, nspin
         if(map_k(ik) /= myrank_k) cycle   ! MPI
         iksnl = (ik-1)/nspin + 1
         write(nfout,'(" ik = ",i5)') iksnl
         write(nfout,'(8i3)') (nbase(i,ik),i=1,8)
         do ilmtt = 1, nlmtt
	    write(nfout,'('' ilmtt ='',i3)') ilmtt
            write(nfout,'(8f10.5)') (snl(i,ilmtt,iksnl),i=1,8)
              do i = 1,3
              do j = 1,3
              write(nfout,'(8f10.5)') (snld(k,ilmtt,IKSNL,i,j),k=1,8)
              end do
              end do
         end do
      end do
    end subroutine wd_snld
  end subroutine m_NLP_betar_dot_PWs_diff_3D

  subroutine m_NLP_phir_dot_PWs_3D(nfout,kv3,vkxyz)

    integer,       intent(in)       :: nfout,kv3
    real(kind=DP), intent(in)       :: vkxyz(kv3,3,CRDTYP)

    real(kind=DP)       :: fac, facr
    integer             :: ik,ikphig,it,n,lmt1,lmtt1,il1,im1,tau1,nspher
    integer             :: iopr
    integer             :: id_sname = -1

    call tstatc0_begin('m_NLP_phir_dot_PWs ',id_sname,1)
    if(ipriphig >= 2) &
         & write(nfout,*) ' <<< m_NLP_phir_dot_PWs >>> START'
    call innerPr_allocate_3D()

    fac = PAI4/dsqrt(univol)
    do ik = 1, kv3, nspin
       if(map_k(ik) /= myrank_k) cycle                     ! MPI
!!$       write(nfout,*) ' ik = ', ik
!!$       write(nfout,*) ' kgp,kg1,kv3 = ',kgp,kg1,kv3
!!$       write(nfout,*) ' allocated(iba)   = ',allocated(iba)
!!$       write(nfout,*) ' allocated(nbase) = ',allocated(nbase)
!!$       write(nfout,*) ' allocated(ngabc) = ',allocated(ngabc)
!!$       write(nfout,*) ' allocated(qx)    = ',allocated(qx)
!!$       write(nfout,*) ' allocated(vlength)=',allocated(vlength)

!       call k_plus_G_vectors_3D(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
!               &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
               &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       ikphig = (ik-1)/nspin + 1
       do it=1,ntyp
          call new_radr_and_wos(ik,it)                 ! --> radr, wos
          do lmt1 = 1,ilmt_phi(it)
             call m_PP_tell_lmtt_l_m_tau_phi(lmt1,it,lmtt1,il1,im1,tau1,nspher)
             if ( use_sphr_general(ik,kv3,vkxyz) ) then
                call sphr_general(np_g1k(ik),nspher,qx,qy,qz,ylm)
             else
                call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)
             endif
             if(ipri >= 2) call wd_lmt_l_m_tau_etc &
                                (nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher)
             snl2 = 0.d0

             if(.not.allocated(wos)) then
                write(nfout,'(" wos is not allocated")')
                call phase_error_with_msg(nfout,' wos is not allocated',__LINE__,__FILE__)
             end if
             if(.not.allocated(radr)) then
                write(nfout,'(" radr is not allocated")')
                call phase_error_with_msg(nfout,' wos is not allocated',__LINE__,__FILE__)
             end if
             if(ipri>=2) then
                write(nfout,'(" nmesh(it) = ",i8)') nmesh(it)
             end if
             if(.not.allocated(wka)) call phase_error_with_msg(nfout,' wka is not allocated',__LINE__,__FILE__)
             if(.not.allocated(wkb)) call phase_error_with_msg(nfout,' wkb is not allocated',__LINE__,__FILE__)
             if(.not.allocated(phirt)) call phase_error_with_msg(nfout,' phirt is not allocated',__LINE__,__FILE__)
             do n = 1,nmesh(it)
                facr = fac*wos(n)*radr(n)*phirt(n,il1,tau1,it)
                wka = vlength*radr(n)
!!$                call find_critical_point(1.d0,iba(ik),wka,idp)
!!$                call dsjnvn(il1-1,iba(ik),wka,idp,wkb)     ! -(bottom_Subr.)
                call dsjnv(il1-1,np_g1k(ik),wka,wkb)     ! -(bottom_Subr.)
                snl2 = snl2 + facr*wkb*ylm
             end do
             norm_phig(lmtt1,ikphig) = sum(snl2(1:np_g1k(ik))*snl2(1:np_g1k(ik)))
          !   phig(1:np_g1k(ik),lmtt1,ikphig) = snl2(1:np_g1k(ik))/sqrt(norm_phig(lmtt1,ikphig))
             phig(1:np_g1k(ik),lmtt1,ikphig) = snl2(1:np_g1k(ik))
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,norm_phig(1,ikphig),nlmtt_phi,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       do it=1,ntyp
          do lmt1 = 1,ilmt_phi(it)
             call m_PP_tell_lmtt_l_m_tau_phi(lmt1,it,lmtt1,il1,im1,tau1,nspher)
             phig(1:np_g1k(ik),lmtt1,ikphig) = phig(1:np_g1k(ik),lmtt1,ikphig)/sqrt(norm_phig(lmtt1,ikphig))
          enddo
       enddo
    end do

    if(ipriphig >= 2) call wd_phig

    call innerPr_deallocate_3D
    call tstatc0_end(id_sname)

  contains
    subroutine wd_phig
      integer :: i, ilmtt, ik, j, ikphig, iopr
      write(nfout,'(" << m_NLP_phir_dot_PWs.wd_phig >>")')
      write(nfout,'(" nlmtt_phi=",i3)') nlmtt_phi
      write(nfout,'(10("(",3i2,")"))') ((ngabc(i,j),j=1,3),i=1,30)
      do ik = 1, kv3, nspin
         if(map_k(ik) /= myrank_k) cycle        ! MPI
         ikphig = (ik-1)/nspin + 1
         write(nfout,'(" ik = ",i5)') ikphig
         write(nfout,'(" nbase(1:8,",i5,")",8i10)') ik,(nbase(i,ik),i=1,8)
         do ilmtt = 1, nlmtt_phi
            write(nfout,'("(ilmtt = ",i5,")",8f10.5,99(/15x,8f10.5))') ilmtt,(phig(i,ilmtt,ikphig),i=1,np_g1k(ik))
         end do
         do ilmtt = 1, nlmtt_phi
            write(nfout,'("(ilmtt = ",i5,")",f10.5)') ilmtt,norm_phig(ilmtt,ikphig)
         end do
      end do
      write(nfout,'(" << m_NLP_phir_dot_PWs.wd_phig >> END")')
    end subroutine wd_phig
  end subroutine m_NLP_phir_dot_PWs_3D

  subroutine m_NLP_add_betar_dot_PWs_3D(nfout,kv3,vkxyz)

    integer,       intent(in)       :: nfout,kv3
    real(kind=DP), intent(in)       :: vkxyz(kv3,3,CRDTYP)

    real(kind=DP)       :: fac, facr
    integer             :: ik,iksnl,it,n,lmt1,lmtt1,il1,im1,tau1,nspher
    integer             :: id_sname = -1

    call tstatc0_begin('m_NLP_add_betar_dot_PWs ',id_sname,1)
!!$    write(nfout,*) ' <<< m_NLP_add_betar_dot_PWs >>>'
    call innerPr_allocate_3D()

    fac = PAI4/dsqrt(univol)
    do ik = 1, kv3, nspin
       if(map_k(ik) /= myrank_k) cycle                     ! MPI
!!$       write(nfout,*) ' ik = ', ik
!!$       write(nfout,*) ' kgp,kg1,kv3 = ',kgp,kg1,kv3
!!$       write(nfout,*) ' allocated(iba)   = ',allocated(iba)
!!$       write(nfout,*) ' allocated(nbase) = ',allocated(nbase)
!!$       write(nfout,*) ' allocated(ngabc) = ',allocated(ngabc)
!!$       write(nfout,*) ' allocated(qx)    = ',allocated(qx)
!!$       write(nfout,*) ' allocated(vlength)=',allocated(vlength)

!       call k_plus_G_vectors_3D(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
!            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       iksnl = (ik-1)/nspin + 1
       do it=1,ntyp
          call new_radr_and_wos(ik,it)                 ! --> radr, wos
          do lmt1 = 1,ilmt_add(it)
             call m_PP_tell_lmtt_l_m_tau_add(lmt1,it,lmtt1,il1,im1,tau1,nspher)
             if ( use_sphr_general(ik,kv3,vkxyz) ) then
                call sphr_general(np_g1k(ik),nspher,qx,qy,qz,ylm)
             else
                call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)
             endif
             if(ipri >= 2) call wd_lmt_l_m_tau_etc &
                                (nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher)
             snl2 = 0.d0
             do n = 1,nmesh(it)
                facr = fac*wos(n)*radr(n)*betar_add(n,it)
                wka(1:np_g1k(ik)) = vlength(1:np_g1k(ik))*radr(n)
!!$                call find_critical_point(1.d0,np_g1k(ik),wka,idp)
!!$                call dsjnvn(il1-1,np_g1k(ik),wka,idp,wkb)     ! -(bottom_Subr.)
                call dsjnv(il1-1,np_g1k(ik),wka,wkb)     ! -(bottom_Subr.)
                snl2(1:np_g1k(ik)) = snl2(1:np_g1k(ik)) + facr*wkb(1:np_g1k(ik))*ylm(1:np_g1k(ik))
             end do
             snl_add(1:np_g1k(ik),lmtt1,iksnl) = snl2(1:np_g1k(ik))
          end do
       end do
    end do
    if(iprisnl >= 2) call wd_snl_add
    call innerPr_deallocate_3D
    call tstatc0_end(id_sname)

  contains
    subroutine wd_snl_add
      integer :: i, ilmtt, ik, j, iksnl
      write(nfout,'(" << m_NLP_add_betar_dot_PWs.wd_snl_add >>")')
      write(nfout,'(10("(",3i2,")"))') ((ngabc(i,j),j=1,3),i=1,30)
      do ik = 1, kv3, nspin
         if(map_k(ik) /= myrank_k) cycle        ! MPI
         iksnl = (ik-1)/nspin + 1
         write(nfout,'(" ik = ",i5)') iksnl
         write(nfout,'(" nbase(1:8,",i5,")",8i10)') ik,(nbase(i,ik),i=1,8)
         do ilmtt = 1, nlmtt_add
! === DEBUG by tkato 2013/10/30 ================================================
!           write(nfout,'("(ilmtt = ",i5,")",8f10.5,99(/15x,8f10.5))') ilmtt,(snl_add(i,ilmtt,iksnl),i=1,kg1)
            write(nfout,'("(ilmtt = ",i5,")",8f10.5,99(/15x,8f10.5))') ilmtt,(snl_add(i,ilmtt,iksnl),i=1,np_g1k(ik))
! ==============================================================================
         end do
      end do
    end subroutine wd_snl_add
  end subroutine m_NLP_add_betar_dot_PWs_3D

  subroutine m_NLP_paor_dot_PWs_3D(nfout,kv3,vkxyz)
    integer,       intent(in)       :: nfout,kv3
    real(kind=DP), intent(in)       :: vkxyz(kv3,3,CRDTYP)

    real(kind=DP)       :: fac, facr
    integer             :: ik,iksnl,it,n,lmt1,lmtt1,il1,im1,tau1,nspher
    integer             :: n1,n2,ig
    integer             :: id_sname = -1
    real(kind=DP), dimension(:,:), allocatable :: snl2_mpi, snl1

#ifndef _mNLP_no_loop_exchange_
    integer, parameter  :: lcmax = 4
    integer :: ip
    integer :: mil, mp  ! mp = maxval(np)
    integer, dimension(:),     allocatable :: nil  ! d(ntyp)
    integer, dimension(:,:),   allocatable :: nt   ! d(ntyp,mil)
    integer, dimension(:,:,:), allocatable :: tu2p ! d(ntau,ntyp,mil)
    integer, dimension(:),     allocatable :: np   ! d(mil), np=sum_{u=1}^{ntyp}(nt(u,mil))
    integer, dimension(:,:,:), allocatable ::  pm2lmtt1 ! d(mp,2*(mil-1)+1,mil)
    real(kind=DP), dimension(:,:), allocatable :: snl_t ! d(iba(ik),mp)
    real(kind=DP), dimension(:,:), allocatable :: radr_p, wos_p ! d(n1:n2,ntyp)
    integer :: p, mradr_indp 
    logical, dimension(:,:), allocatable :: flag_radr !d(ntyp,mil)
    integer, dimension(:), allocatable   :: ip_radr !d(ntyp)
    real(kind=DP) :: r, w
#endif

    call tstatc0_begin('m_NLP_paor_dot_PWs ',id_sname,1)
!!$    write(nfout,*) ' <<< m_NLP_paor_dot_PWs >>>'
    call innerPr_allocate_3D()

    fac = PAI4/dsqrt(univol)
#ifndef _mNLP_no_loop_exchange_
    call set_index_arrays() ! mil, mp, nil, nt, tu2p, np, pm2lmtt1, contained here

    n = ceiling(dble(mmesh)/nrank_e)
    if(n == 0) n = 1
    n1 = n*myrank_e + 1
    n2 = n*(myrank_e+1)
    if(n2 > mmesh) n2 = mmesh

    allocate(flag_radr(ntyp,mil))
    allocate(ip_radr(ntyp))
!!$ASASASASAS
    flag_radr = .false. ;  ip_radr = 0
!!$ASASASASAS
    call set_flag_radr_and_ip_radr() ! -> mradr_indp,flag_radr, ip_radr

    if(n1 <= n2) then
       allocate(radr_p(n1:n2,mradr_indp))
       allocate(wos_p(n1:n2,mradr_indp))
!!$ASASASASAS
       radr_p = 0; wos_p = 0
!!$ASASASASAS
       call radr_and_wos_p(n1,n2,ntyp,mradr_indp,ip_radr,radr_p,wos_p) ! -> radr_p, wos_p
    end if

    do ik = 1, kv3, nspin
       if(map_k(ik) /= myrank_k) cycle                     ! MPI
!!$ASASASASAS
!!$       allocate(snl_t(iba(ik),mp))
       allocate(snl_t(np_g1k(ik),mp)); snl_t = 0
!!$ASASASASAS

!       call k_plus_G_vectors_3D(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
!            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       iksnl = (ik-1)/nspin + 1

       do il1 = 1, mil
          snl_t = 0.d0
          do n = n1, n2
             do it = 1, ntyp
                if(il1 > nil(it)) cycle
                if(flag_radr(it,il1)) then
                   r = radr_p(n,ip_radr(it))
                   do ig = 1, np_g1k(ik)
                      wka(ig) = vlength(ig)*r
                   end do
                   call dsjnv(il1-1,np_g1k(ik),wka,wkb)     ! -(bottom_Subr.)
                end if

                w = fac * wos_p(n,ip_radr(it)) * radr_p(n,ip_radr(it))
                do tau1 = 1, nt(it,il1)
                   facr = w * paor(n,il1,tau1,it)
                   ip = tu2p(tau1,it,il1)
                   do ig = 1, np_g1k(ik)
                      snl_t(ig,ip) = snl_t(ig,ip) + facr*wkb(ig)
                   end do
                end do
             end do
          end do
          if(nrank_e > 1) then
             call mpi_allreduce(MPI_IN_PLACE,snl_t,np_g1k(ik)*np(il1),mpi_double_precision &
                  &                    ,mpi_sum,mpi_kg_world,ierr)
          end if

          do im1 = 1, 2*(il1-1)+1
             nspher = (il1-1)**2 + im1
             if ( use_sphr_general(ik,kv3,vkxyz) ) then
                call sphr_general(np_g1k(ik),nspher,qx,qy,qz,ylm)
             else
                call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)
             endif
             do p = 1, np(il1)
                ip = pm2lmtt1(p,im1,il1)
                do ig = 1, np_g1k(ik)
                   paog(ig,ip,iksnl) = snl_t(ig,p)*ylm(ig)
                end do
             end do
          end do
       end do
       deallocate(snl_t)
    end do

    if(n1 <= n2) deallocate(wos_p,radr_p)
    deallocate(ip_radr,flag_radr)
    call dealloc_index_arrays()

#else
    if(nrank_e > 1) then
       allocate(snl1(maxval(np_g1k),nlmtt_pao)); snl1 = 0.d0
       allocate(snl2_mpi(maxval(np_g1k),nlmtt_pao))
!!$ASASASASAS
        snl2_mpi = 0.d0
!!$ASASASASAS
    end if

    do ik = 1, kv3, nspin
       if(map_k(ik) /= myrank_k) cycle                     ! MPI

!       call k_plus_G_vectors_3D(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
!            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       iksnl = (ik-1)/nspin + 1

       do it=1,ntyp

          n = ceiling(dble(nmesh(it))/nrank_e)
          if(n == 0) n = 1
          n1 = n*myrank_e + 1
          n2 = n*(myrank_e+1)
          if(n2 > nmesh(it)) n2 = nmesh(it)

          call new_radr_and_wos(ik,it)                 ! --> radr, wos
          do lmt1 = 1,ilmt_pao(it)
             call m_PP_tell_lmtt_l_m_tau_pao(lmt1,it,lmtt1,il1,im1,tau1,nspher)
             if ( use_sphr_general(ik,kv3,vkxyz) ) then
                call sphr_general(np_g1k(ik),nspher,qx,qy,qz,ylm)
             else
                call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)
             endif
             if(ipri >= 2) call wd_lmt_l_m_tau_etc &
                                (nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher)
             snl2 = 0.d0

             do n = n1, n2
                facr = fac*wos(n)*radr(n)*paor(n,il1,tau1,it)
                do ig = 1, np_g1k(ik)
                   wka(ig) = vlength(ig)*radr(n)
                end do
                call dsjnv(il1-1,np_g1k(ik),wka,wkb)     ! -(bottom_Subr.)
                do ig = 1, np_g1k(ik)
                   snl2(ig) = snl2(ig) + facr*wkb(ig)
                end do
             end do

             if(nrank_e == 1) then
                do ig = 1, np_g1k(ik)
                   paog(ig,lmtt1,iksnl) = snl2(ig)*ylm(ig)
                end do
             else
                do ig = 1, np_g1k(ik)
                   snl1(ig,lmtt1) = snl2(ig)*ylm(ig)
                end do
             end if
          end do
       end do

       if(nrank_e > 1) then
          call mpi_allreduce(snl1, snl2_mpi,maxval(np_g1k)*nlmtt_pao,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
          do lmtt1 = 1, nlmtt_pao
             do ig = 1, np_g1k(ik)
                paog(ig,lmtt1,iksnl) = snl2_mpi(ig,lmtt1)
             end do
          end do
       end if
    end do
    if(nrank_e > 1) deallocate(snl2_mpi,snl1)
#endif
    if(ipripao >= 2) call wd_paog
    call innerPr_deallocate_3D
    call tstatc0_end(id_sname)

  contains
#ifndef _mNLP_no_loop_exchange_
    subroutine set_flag_radr_and_ip_radr()
      integer :: it, il, ip, it2, is, it1

      mradr_indp = 1
      ip_radr(1) = 1
      do it = 2, ntyp
         is = 0
         search_loop: do it2 = 1, mradr_indp
            ip = ip_radr(it2)
            if((nmesh(ip) == nmesh(it) .and. dabs(xh(ip)-xh(it)) < DELTA .and. &
              & dabs(rmax(ip)-rmax(it)) < DELTA)) then
               is = it2
               exit search_loop
            end if
         end do search_loop
         if(is <= 0 .or. is > mradr_indp) then
            mradr_indp = mradr_indp+1
            is = mradr_indp
         end if
         ip_radr(it) = is
      end do

      if(ipri >= 2) then
         write(nfout,'(" !mNLP : mradr_indp = ", i5)') mradr_indp
         do it = 1, ntyp
            write(nfout,'(" !mNLP : ip_radr(",i5,") = ",i5)') it, ip_radr(it)
         end do
      end if

      do il = 1, mil
         flag_radr(1:ntyp,il) = .true.
         it1 = 0
         do it = 1, ntyp
            if(il > nil(it)) cycle
            it1 = it1+1
            if(it1 == 1) then
               flag_radr(it,il) = .true.
            else if(it1 >= 2) then
               if(ip_radr(ip) /= ip_radr(it)) then
                  flag_radr(it,il) = .true.
               else
                  flag_radr(it,il) = .false.
               end if
            end if
            ip = it
         end do
      end do

      if(ipri >= 2) then
         do il = 1, mil
            do it = 1, ntyp
               write(nfout,'(" !mNLP : flag_radr(",i5,",",i5,") = ",l3)') it,il,flag_radr(it,il)
            end do
         end do
      end if
    end subroutine set_flag_radr_and_ip_radr

    subroutine set_index_arrays()
      integer :: it, lmt1, n, il1, im1

      allocate(nil(ntyp)); nil = 0
      allocate(nt(ntyp,lcmax)); allocate(tu2p(ntau,ntyp,lcmax)); allocate(np(lcmax))
      nt = 0; tu2p = 0
      mil = 0
      if(ipri>=2) write(nfout,'(" !mNLP:    it, lmt1: lmtt1, il1, im1, tau1, nspher")')
      do it=1,ntyp
         do lmt1 = 1, ilmt_pao(it)
            call m_PP_tell_lmtt_l_m_tau_pao(lmt1,it,lmtt1,il1,im1,tau1,nspher)
            if(ipri>=2) write(nfout,'(" !mNLP: ",2i5," : ",5i5)') it,lmt1, lmtt1,il1,im1,tau1,nspher
            if(mil < il1) mil = il1
            if(nil(it) < il1) nil(it) = il1
            if(nt(it,il1) < tau1) nt(it,il1) = tau1
         end do
      end do

      do il1=1,mil
         n = 0
         np(il1) = 0
         do it=1,ntyp
            if(il1 > nil(it)) cycle
            np(il1) = np(il1)+nt(it,il1)
            do tau1=1,nt(it,il1)
               n = n+1
               tu2p(tau1,it,il1)= n
            end do
         end do
      end do

      mp = maxval(np(1:mil))
      allocate(pm2lmtt1(mp,2*(mil-1)+1,mil))
!!$ASASASASAS
      pm2lmtt1 = 0
!!$ASASASASAS
      do it = 1, ntyp
         do lmt1=1,ilmt_pao(it)
            call m_PP_tell_lmtt_l_m_tau_pao(lmt1,it,lmtt1,il1,im1,tau1,nspher)
            n = tu2p(tau1,it,il1)
            pm2lmtt1(n,im1,il1) = lmtt1
         end do
      end do

      if(ipri>=2) then
         write(nfout,'(" !mNLP: mil = ",i5)') mil
         do it = 1, ntyp
            write(nfout,'(" !mNLP: nil(",i3,") = ",i5)') it,nil(it)
         end do
         do it = 1, ntyp
            write(nfout,'(" !mNLP: nt(",i3,", : ) = ",5i5)') it,(nt(it,il1),il1=1,nil(it))
         end do

         write(nfout,'(" !mNLP: mp = ",i5)') mp
         do il1 = 1, mil
            write(nfout,'(" !mNLP: np(",i3,")=",i5)') il1, np(il1)
         end do
         do il1 = 1, mil
            do it = 1, ntyp
               if(il1 > nil(it)) cycle
               do tau1 = 1, nt(it,il1)
                  write(nfout,'(" !mNLP: tu2p(",i3,",",i3,",",i3,") = ",i5)') tau1,it,il1,tu2p(tau1,it,il1)
               end do
            end do
         end do
         do il1 = 1, mil
            do im1 = 1, 2*(il1-1)+1
               do n = 1, np(il1)
                  write(nfout,'(" !mNLP: il1 = ",i3," im1 = ",i3," n = ", i3, " pm2lmtt1 = ",i5)') &
                       & il1,im1, n,pm2lmtt1(n,im1,il1)
               end do
            end do
         end do
      end if
    end subroutine set_index_arrays

    subroutine dealloc_index_arrays()
      deallocate(pm2lmtt1,np,tu2p,nt,nil)
    end subroutine dealloc_index_arrays
#endif

    subroutine wd_paog
      integer :: i, ilmtt, ik, j, iksnl
      write(nfout,'(" << m_NLP_poor_dot_PWs.wd_paog >>")')
      write(nfout,'(10("(",3i2,")"))') ((ngabc(i,j),j=1,3),i=1,30)
      do ik = 1, kv3, nspin
         if(map_k(ik) /= myrank_k) cycle        ! MPI
         iksnl = (ik-1)/nspin + 1
         write(nfout,'(" ik = ",i5)') iksnl
         write(nfout,'(" nbase(1:8,",i5,")",8i10)') ik,(nbase(i,ik),i=1,8)
         do ilmtt = 1, nlmtt_pao
            write(nfout,'("(ilmtt = ",i5,")",8f10.5,99(/15x,8f10.5))') ilmtt,(paog(i,ilmtt,iksnl),i=1,kg1)
         end do
      end do
    end subroutine wd_paog
  end subroutine m_NLP_paor_dot_PWs_3D
!------
  subroutine m_NLP_wd_snl_3D(nfout,nfcntn_bin,F_CNTN_BIN_partitioned,kv3)
   use m_Parallelization,     only : mpi_ke_world, mpi_kg_world

    integer, intent(in) :: nfout,nfcntn_bin
    logical, intent(in) :: F_CNTN_BIN_partitioned
    integer, intent(in) :: kv3

    integer                                :: i,ik,iksnl,p,q,iend  ! MPI
    integer                                :: i1, i2
    real(kind=DP), allocatable, dimension(:,:) :: snl_wk  ! MPI
    real(kind=DP), allocatable, dimension(:,:) :: snl_mpi  ! MPI
    integer             :: id_sname = -1
                                                  __TIMER_SUB_START(1369)
    call tstatc0_begin('m_NLP_wd_snl ',id_sname)
!f    allocate(snl_wk(kg1,nlmtt))                      ! MPI
!!$ASASASASAS
!f    snl_wk = 0.d0
!!$ASASASASAS
    if(istress == 0) then
       iend = 0
    else 
       iend = 9
    end if
    do i = 0, iend
       if(F_CNTN_BIN_partitioned) then
          allocate(snl_wk(maxval(np_g1k),nlmtt))                      ! MPI
          snl_wk = 0.d0
          do iksnl = ista_snl, iend_snl
             if(i==0) then
                snl_wk = snl(:,:,iksnl)
             else
                p = mod(i,3); if(p == 0) p = 3
                q = (i-p)/3 + 1
                snl_wk = snld(:,:,iksnl,p,q)
             end if
                                                  __TIMER_IODO_START(1399)
             write(nfcntn_bin) snl_wk
                                                  __TIMER_IODO_STOP(1399)
          end do
          deallocate(snl_wk)
       else
          allocate(snl_wk(kg1,nlmtt))                      ! MPI
          allocate(snl_mpi(kg1,nlmtt))                      ! MPI
          snl_wk = 0.d0
          do ik = 1, kv3, nspin                             ! MPI
             if(iprisnl >= 2) write(nfout,'(" ! ik = ",i5," <<m_NLP_wd_snl>>")') ik
             iksnl = (ik-1)/nspin + 1                       ! MPI
             if(map_k(ik) == myrank_k .and. myrank_e == 0 ) then  ! MPI
                if(i==0) then
!f                   snl_wk = snl(:,:,iksnl)                  ! MPI
                                                  __TIMER_IODO_START(1400)
                   do i2 = 1, nlmtt
                     do i1 = ista_g1k(ik), iend_g1k(ik)
                       snl_wk(i1,i2) = snl(i1-ista_g1k(ik)+1,i2,iksnl)
                   enddo; enddo
                                                  __TIMER_IODO_STOP(1400)
                                                  __TIMER_IOCOMM_START_w_BARRIER(mpi_ke_world,1401)
                   call mpi_allreduce(snl_wk,snl_mpi,kg1*nlmtt,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
                                                  __TIMER_IOCOMM_STOP(1401)
                else
                   p = mod(i,3); if(p == 0) p = 3
                   q = (i-p)/3 + 1
!f                   snl_wk = snld(:,:,iksnl,p,q)
                                                  __TIMER_IODO_START(1402)
                   do i2 = 1, nlmtt
                     do i1 = ista_g1k(ik), iend_g1k(ik)
                       snl_wk(i1,i2) = snld(i1-ista_g1k(ik)+1,i2,iksnl,p,q)
                   enddo; enddo
                                                  __TIMER_IODO_STOP(1402)
                                                  __TIMER_IOCOMM_START_w_BARRIER(mpi_ke_world,1403)
                   call mpi_allreduce(snl_wk,snl_mpi,kg1*nlmtt,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
                                                  __TIMER_IOCOMM_STOP(1403)
                end if
!f                if(map_k(ik) /= 0) call mpi_send(snl_mpi,kg1*nlmtt,mpi_double_precision,0,1,mpi_comm_group,ierr)
!f             else if(mype == 0 .and. map_k(ik) /= 0) then   ! MPI
!f                call mpi_recv(snl_wk,kg1*nlmtt,mpi_double_precision,map_k(ik)*nrank_e &
!f                     &            ,1,mpi_comm_group,istatus,ierr) !MPI
             end if                                         ! MPI
!f             if(mype == 0) write(nfcntn_bin) snl_wk         ! MPI
                                                  __TIMER_IODO_START(1404)
             if(mype == 0) write(nfcntn_bin) snl_mpi         ! MPI
                                                  __TIMER_IODO_STOP(1404)
          end do
          deallocate(snl_wk)
          deallocate(snl_mpi)
       end if
    end do
    if(iprisnl >= 2) then
       write(nfout,'(" ! snl is written (m_NLP_wd_snl)")')
       if(F_CNTN_BIN_partitioned) then
          write(nfout,'(" ! snl size = ",i9)') kg1*nlmtt*(iend_snl-ista_snl+1)*8
       else
          write(nfout,'(" ! snl size = ",i9)') kg1*nlmtt*kv3*8
       end if
    end if
!f    deallocate(snl_wk)
    call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(1369)
  end subroutine m_NLP_wd_snl_3D

  subroutine m_NLP_rd_snl_3D(nfout,nfcntn_bin,F_CNTN_BIN_partitioned,kv3)
   use m_Parallelization,     only : mpi_ke_world, mpi_kg_world

    integer, intent(in) :: nfout,nfcntn_bin
    logical, intent(in) :: F_CNTN_BIN_partitioned
    integer, intent(in) :: kv3

    integer                                :: i,ik,iksnl,p,q,iend  ! MPI
    integer                                :: i1, i2
    real(kind=DP), allocatable, dimension(:,:) :: snl_wk  ! MPI
    integer             :: id_sname = -1
                                                  __TIMER_SUB_START(1368)
    call tstatc0_begin('m_NLP_rd_snl ',id_sname)
!f    allocate(snl_wk(kg1,nlmtt))                      ! MPI
!!$ASASASASAS
!f    snl_wk = 0.d0
!!$ASASASASAS
    if(iprisnl >= 2) write(nfout,'(" kg1 = ",i6, " nlmtt = ",i6)') kg1,nlmtt
    if(iprisnl >= 2) write(nfout,'(" ! nfcntn_bin = ", i6)') nfcntn_bin
    if(istress == 0) then
       iend = 0
    else 
       iend = 9
    end if
    do i = 0, iend                                       ! MPI
       if(F_CNTN_BIN_partitioned) then
          allocate(snl_wk(maxval(np_g1k),nlmtt))                      ! MPI
          snl_wk = 0.d0
                                                  __TIMER_IODO_START(1395)
          do iksnl = ista_snl, iend_snl
             if(iprisnl >= 2) write(nfout,'(" iksnl = ",i6, " <<m_NLP_rd_snl>>")') iksnl
             read(nfcntn_bin) snl_wk
             if(i==0) then
                snl(:,:,iksnl) = snl_wk
             else
                p = mod(i,3); if(p == 0) p = 3           ! MPI
                q = (i-p)/3 + 1                          ! MPI
                snld(:,:,iksnl,p,q) = snl_wk             ! MPI
             end if
          end do
                                                  __TIMER_IODO_STOP(1395)
          deallocate(snl_wk)
       else
          allocate(snl_wk(kg1,nlmtt))
          snl_wk = 0.d0
          do ik = 1, kv3, nspin
             if(iprisnl >= 2) write(nfout,'(" ik = ",i6, " <<m_NLP_rd_snl>>")') ik
             iksnl = (ik-1)/nspin + 1
                                                  __TIMER_IODO_START(1396)
             if(mype == 0) read(nfcntn_bin) snl_wk
                                                  __TIMER_IODO_STOP(1396)
             if(iprisnl >= 2) write(nfout,'(" snl_wk is read")')
!f             if(mype == 0 .and. map_k(ik) /= 0) then        ! MPI
!f                call mpi_send(snl_wk,kg1*nlmtt,mpi_double_precision,map_k(ik)*nrank_e,1 &
!f                     &            , mpi_comm_group,ierr)       ! MPI
!f             else if(map_k(ik) /= 0 .and. map_k(ik) == myrank_k .and. myrank_e == 0) then ! MPI
!f                call mpi_recv(snl_wk,kg1*nlmtt,mpi_double_precision,0,1 &
!f                     &            , mpi_comm_group,istatus,ierr) ! MPI
!f             end if
                                                  __TIMER_IOCOMM_START_w_BARRIER(mpi_comm_group,1397)
             call mpi_bcast(snl_wk,kg1*nlmtt,mpi_double_precision,0,mpi_comm_group,ierr)
                                                  __TIMER_IOCOMM_STOP(1397)

             if(map_k(ik) == myrank_k) then
!f                call mpi_bcast(snl_wk,kg1*nlmtt,mpi_double_precision,0,mpi_k_world(myrank_k),ierr)
                                                  __TIMER_IODO_START(1398)
                if(i==0) then
!f                   snl(:,:,iksnl) = snl_wk
                   do i2 = 1, nlmtt
                     do i1 = ista_g1k(ik), iend_g1k(ik)
                       snl(i1-ista_g1k(ik)+1,i2,iksnl) = snl_wk(i1,i2)
                   enddo; enddo
                else
                   p = mod(i,3); if(p == 0) p = 3
                   q = (i-p)/3 + 1
!f                   snld(:,:,iksnl,p,q) = snl_wk
                   do i2 = 1, nlmtt
                     do i1 = ista_g1k(ik), iend_g1k(ik)
                       snld(i1-ista_g1k(ik)+1,i2,iksnl,p,q) = snl_wk(i1,i2)
                   enddo; enddo
                end if
                                                  __TIMER_IODO_STOP(1398)
             end if
          end do
          deallocate(snl_wk)
       end if
    end do
!f    deallocate(snl_wk)
    call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(1368)
  end subroutine m_NLP_rd_snl_3D
! === For epsmain by tkato 2013/11/14 ==========================================
  subroutine m_NLP_epsmain_reallocate()
    if(allocated(snl)) deallocate(snl)
    allocate(snl(maxval(np_g1k),nlmtt,ista_snl:iend_snl)); snl = 0.d0
    if(allocated(snl_add)) deallocate(snl_add)
    allocate(snl_add(maxval(np_g1k),nlmtt_add,ista_snl:iend_snl)); snl_add = 0.d0
  end subroutine m_NLP_epsmain_reallocate
! ==============================================================================

!===============================================================================

  ! snl_rs = betar x Ylm
  ! snld_rs = dbetar x Ylm + betar x dYlm
  ! note: betar is expected to be optimized in some way
  ! this operation must be done every time the atomic coordinate changes
  subroutine m_NLP_build_snl_in_rspace(nfout)
    integer, intent(in) :: nfout
    integer :: ia,it,lmt,lmta1,nma
    integer :: imesh
    real(kind=DP) :: inl,inm,inn
    real(kind=DP) :: bi
    real(kind=DP), allocatable, dimension(:) :: cx,cy,cz,rdiff
    real(kind=DP), allocatable, dimension(:) :: ylm
    real(kind=DP), allocatable, dimension(:,:) :: dylm
    real(kind=DP), allocatable, dimension(:,:,:,:) :: b2
    real(kind=DP), allocatable, dimension(:) :: btmp,b2tmp
    real(kind=DP) :: s,ds,dds,hn
    real(kind=DP) :: rmin
    integer :: ilmtt,il,im,tau,nspher
    integer :: id_sname = -1

    call tstatc0_begin('m_NLP_build_snl_in_rspace ',id_sname,1)

    if(allocated(snl_rs)) deallocate(snl_rs)
    if(allocated(snld_rs)) deallocate(snld_rs)

    allocate(snl_rs(nmesh_rs_max,nlmta))
    allocate(snld_rs(nmesh_rs_max,nlmta,3))

    if(kimg==1)then
       if(allocated(snl_rs_h))then
          deallocate(snl_rs_h)
       endif
    endif
    if(kimg==1) allocate(snl_rs_h(nmesh_rs_max_h,nlmta))

    if(.not.done_optimization)then
       call build_optimized_betar()
       done_optimization = .true.
    endif
    inl = 1.d0/dble(fft_box_size_WF(1,1))
    inm = 1.d0/dble(fft_box_size_WF(2,1))
    inn = 1.d0/dble(fft_box_size_WF(3,1))
    snl_rs = 0.d0
    if(kimg==1) snl_rs_h = 0.d0
    snld_rs = 0.d0
    allocate(cx(nmesh_rs_max));cx=0.d0
    allocate(cy(nmesh_rs_max));cy=0.d0
    allocate(cz(nmesh_rs_max));cz=0.d0
    allocate(rdiff(nmesh_rs_max));rdiff=0.d0
    allocate(ylm(nmesh_rs_max));ylm=0.d0
    allocate(dylm(nmesh_rs_max,3));dylm=0.d0
    allocate(b2(mmesh,nloc,ntau,ntyp));b2=0.d0
    allocate(btmp(mmesh));btmp=0.d0
    allocate(b2tmp(mmesh));b2tmp=0.d0

    do it=1,ntyp
       call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
       do lmt=1,ilmt(it) 
          call m_PP_tell_lmtt_l_m_tau(lmt,it,ilmtt,il,im,tau,nspher)
          call init_cubic_spline( &
        & nmesh(it),radr(1:nmesh(it)),betar_optimized(1:nmesh(it),il,tau,it),b2(1:nmesh(it),il,tau,it))
       enddo
    enddo
!    Loop_atm:do ia=1,natm
!       nma = nmesh_rs(ia)
!       it = ityp(ia)
!       call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
!       call m_RS_R_minus_pos(pos,ia,nma,inl,inm,inn,cx,cy,cz,rdiff,meshx_rs,meshy_rs,meshz_rs)
!    enddo Loop_atm
    do ia=1,natm
       nma = nmesh_rs(ia)
       it = ityp(ia)
       call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
       call m_RS_R_minus_pos(pos,ia,nmesh_rs_max,inl,inm,inn,cx,cy,cz,rdiff,meshx_rs,meshy_rs,meshz_rs)
       do lmt=1,ilmt(it) 
          call m_PP_tell_lmtt_l_m_tau(lmt,it,ilmtt,il,im,tau,nspher)
          call sphr(nma,nspher,cx(1:nma),cy(1:nma),cz(1:nma),ylm(1:nma))
          call sphr_diff(nma,nma,nspher,cx(1:nma),cy(1:nma),cz(1:nma),dylm(1:nma,1:3))
          lmta1 = lmta(lmt,ia)
          btmp(1:nmesh(it)) = betar_optimized(1:nmesh(it),il,tau,it)
          b2tmp(1:nmesh(it)) = b2(1:nmesh(it),il,tau,it)
          do imesh = 1,nma
             if(rdiff(imesh).gt.radr(1))then
                call cubic_spline(nmesh(it),radr,btmp(1:nmesh(it)),b2tmp(1:nmesh(it)),rdiff(imesh),s,ds)
                snl_rs(imesh,lmta1)    = s*ylm(imesh)
                snld_rs(imesh,lmta1,1) = -(ds*cx(imesh)/rdiff(imesh))*ylm(imesh)-s*dylm(imesh,1)
                snld_rs(imesh,lmta1,2) = -(ds*cy(imesh)/rdiff(imesh))*ylm(imesh)-s*dylm(imesh,2)
                snld_rs(imesh,lmta1,3) = -(ds*cz(imesh)/rdiff(imesh))*ylm(imesh)-s*dylm(imesh,3)
             else
                call cubic_spline(nmesh(it),radr,btmp(1:nmesh(it)),b2tmp(1:nmesh(it)),rdiff(imesh),s,ds)
                snl_rs(imesh,lmta1)    = s*ylm(imesh)
             endif
             if(kimg==1)then
               if(map_h_i(imesh,ia)>0) snl_rs_h(map_h_i(imesh,ia),lmta1) = s*ylm(imesh)
             endif
          enddo
       enddo
    enddo
    deallocate(cx,cy,cz,rdiff,ylm,dylm,b2,btmp,b2tmp)

    call tstatc0_end(id_sname)

  end subroutine m_NLP_build_snl_in_rspace

  subroutine build_optimized_betar()
     real(kind=DP) :: gamm
     integer :: id_sname = -1
     call tstatc0_begin('build_optimized_betar ',id_sname,1)
     if(projector_optimization==MASK_FUNCTION)then
        call optimize_betar_by_maskfunction()
     else if (projector_optimization==PREFITTING) then
        call optimize_betar_by_prefitting()
     else
        betar_optimized = betar ! no optimization of the projector; for debugging purposes
     endif
     call tstatc0_end(id_sname)
  end subroutine build_optimized_betar

  subroutine optimize_betar_by_maskfunction()
     integer :: it,imesh,lmt1,imask
     integer :: lmtt1,il1,im1,tau1,nspher,iq,ier
     integer :: nq
     real(kind=DP) :: hn,r
     real(kind=DP),allocatable,dimension(:) :: betar_tmp
     real(kind=DP),allocatable,dimension(:,:) :: mask
     real(kind=DP),allocatable,dimension(:) :: maskr15_2,rmask
     real(kind=DP) :: fac,topi,m1
     real(kind=DP),allocatable,dimension(:) :: ft,q,waq,wbq,wosq,war,wbr
     nq = int((gamma_factor*gmax)/dq)+1
     allocate(betar_tmp(mmesh));betar_tmp=0.d0
     allocate(ft(nq));ft=0.d0
     allocate(q(nq));q=0.d0
     allocate(waq(nq));waq=0.d0
     allocate(wbq(nq));wbq=0.d0
     allocate(wosq(nq));wosq=0.d0
    
     do iq=1,nq
        q(iq) = dq*(iq-1)
     enddo
     topi = 2.d0/PAI
     call set_weight_unif(ier,1,nq,q,wosq)

     allocate(mask(mmesh,ntyp));mask=0.d0
     allocate(maskr15_2(nmask));maskr15_2=0.d0
     allocate(rmask(nmask));rmask=0.d0
     do it=1,ntyp
        call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
        do imask=1,nmask
           rmask(imask) = (imask-1)*rcut_betar_rs(it)*drmask
        enddo
        call init_cubic_spline(nmask,rmask,maskr15,maskr15_2)
        do imesh = 1,nmesh(it)
           r = radr(imesh)
           if(r<=rcut_betar_rs(it)) call cubic_spline(nmask,rmask,maskr15,maskr15_2,r,mask(imesh,it),m1)
        enddo
     enddo
     do it=1,ntyp
        call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
        call coef_simpson_integration(nmesh(it),nmesh(it),xh(it),radr,wos) ! -(b_PP)
        allocate(war(nmesh(it)));war=0.d0
        allocate(wbr(nmesh(it)));wbr=0.d0
        betar_tmp=0.d0
        do lmt1=1,ilmt(it)
           call m_PP_tell_lmtt_l_m_tau(lmt1,it,lmtt1,il1,im1,tau1,nspher)
           betar_tmp(1:nmesh(it)) = betar(1:nmesh(it),il1,tau1,it)
           ! betar' = betar/maskfunction
           do imesh = 1,nmesh(it)
              r = radr(imesh)
              if(ipribetar>=2) write(100+lmt1,*) r,betar(imesh,il1,tau1,it)
              if (r<=rcut_betar(it)) then
                 if(mask(imesh,it).gt.1.e-7) betar_tmp(imesh) = betar_tmp(imesh)/mask(imesh,it)
              endif
           enddo

           ! FT betar'(r) to q-space
           ft = 0.d0
           waq = 0.0d0
           wbq = 0.0d0
           do imesh=1,nmesh(it)
              fac = wos(imesh)*radr(imesh)*betar_tmp(imesh)
              waq(:) = q(:)*radr(imesh)
              call dsjnv(il1-1,nq,waq,wbq)
              ft(:) = ft(:) + fac*wbq(:)
           enddo

           ! FT betar'(q) back to r-space
           betar_tmp = 0.d0 
           war = 0.0d0
           wbr = 0.0d0
           do iq=1,nq
              fac = topi*wosq(iq)*q(iq)*q(iq)*ft(iq)
              war(:) = q(iq)*radr(:)
              call dsjnv(il1-1,nmesh(it),war,wbr)
              betar_tmp(:) = betar_tmp(:) + fac*wbr(:)
           enddo

           ! betar_optimized = betar' * maskfunction
           do imesh = 1,nmesh(it)
              r = radr(imesh)
              betar_optimized(imesh,il1,tau1,it) = betar_tmp(imesh)*mask(imesh,it)
              if(ipribetar>=2) write(200+lmt1,*) r,betar_optimized(imesh,il1,tau1,it)
           enddo

        enddo
        deallocate(war)
        deallocate(wbr)
     enddo
     deallocate(betar_tmp)
     deallocate(ft)
     deallocate(q)
     deallocate(waq)
     deallocate(wbq)
     deallocate(wosq)
     deallocate(mask)
     deallocate(maskr15_2)
     deallocate(rmask)
  end subroutine optimize_betar_by_maskfunction

  subroutine optimize_betar_by_prefitting()
     integer :: i,j,it,lmt1
     integer :: lmtt1,il1,im1,tau1,nspher
     real(kind=DP) :: gamm
     real(kind=DP),allocatable,dimension(:) :: q
     integer :: nq,ngmax
     real(kind=DP) :: hn
     real(kind=DP) :: Aqqp
     real(kind=DP),allocatable,dimension(:) :: wost
     real(kind=DP),allocatable,dimension(:) :: waq,wbq
     real(kind=DP),allocatable,dimension(:) :: war,wbr
     real(kind=DP),allocatable,dimension(:) :: wa,wb,wc,wd
     real(kind=DP),allocatable,dimension(:,:) :: A
     real(kind=DP),allocatable,dimension(:,:) :: B
     real(kind=DP),allocatable,dimension(:) :: betar_q
     real(kind=DP) :: fac
     real(kind=DP) :: topi,pih
     integer,allocatable,dimension(:) :: ipiv
     integer :: info,ier

     gamm = gmax*gamma_factor
     nq = int(gamm/dq)+1
     ngmax = int(gmax/dq)+1
     topi = 2.d0/PAI
     pih  = 0.5d0*PAI
     allocate(q(nq))
     do i=1,nq 
        q(i) = (i-1)*dq
     enddo

     allocate(waq(nq));waq=0.d0
     allocate(wbq(nq));wbq=0.d0
     allocate(wa(nq));wa=0.d0
     allocate(wb(nq));wb=0.d0
     allocate(wc(nq));wc=0.d0
     allocate(wd(nq));wd=0.d0
     allocate(wost(nq));wost=0.d0
     allocate(A(nq-ngmax,nq-ngmax));A=0.d0
     allocate(B(nq-ngmax,1));B=0.d0
     allocate(betar_q(nq));betar_q=0.d0
     allocate(ipiv(nq-ngmax));ipiv=0
     allocate(war(mmesh));war=0.d0
     allocate(wbr(mmesh));wbr=0.d0
     do it=1,ntyp
        call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
        call coef_simpson_integration(nmesh(it),nmesh(it),xh(it),radr,wos) ! -(b_PP)
        wa(:) = rcut_betar_rs(it)*q(:)
        do lmt1=1,ilmt(it)
           call m_PP_tell_lmtt_l_m_tau(lmt1,it,lmtt1,il1,im1,tau1,nspher)

           ! FT to reciprocal space
           betar_q = 0.d0
           do i=1,nmesh(it)
              fac = wos(i)*radr(i)*betar(i,il1,tau1,it)
              waq(:) = q(:)*radr(i)
              call dsjnv(il1-1,nq,waq,wbq)
              betar_q(:) = betar_q(:)+fac*wbq(:)
              if(ipribetar>=2) write(100+lmtt1,'(2f25.15)') radr(i),betar(i,il1,tau1,it)
           enddo

           ! prepare the sph. Bessel functions necessary for the calculation of A(q,q')
           if(il1>=2) then
              call dsjnv(il1-2,nq,wa,wb)
           else
              do i=1,nq
                 wb(i) = dcos(wa(i))/wa(i) ! -n0(x)
              enddo
           endif
           call dsjnv(il1-1,nq,wa,wc)
           call dsjnv(il1,nq,wa,wd)

           call set_weight_unif(ier,1,nq,q,wost)

           ! build the matrix B
           B = 0.d0
           do i=ngmax+1,nq
              do j=1,ngmax
                 call calculate_Aqqp(il1,nq,i,j,q,wb,wc,wd,rcut_betar_rs(it),Aqqp)
                 B(i-ngmax,1) = B(i-ngmax,1)+Aqqp*betar_q(j)*wost(j)
              enddo
           enddo

           ! build the matrix A
           A = 0.d0
           do i=ngmax+1,nq
              do j=ngmax+1,nq
                 call calculate_Aqqp(il1,nq,i,j,q,wb,wc,wd,rcut_betar_rs(it),Aqqp)
                 A(i-ngmax,j-ngmax) = -wost(j)*Aqqp
                 if(i==j) then
                    A(i-ngmax,i-ngmax) = A(i-ngmax,i-ngmax)+pih*q(i)*q(i)
                 endif
              enddo
           enddo

           if(ipribetar>=2)then
              do i=1,nq
                 write(200+lmtt1,'(2f25.15)') q(i),betar_q(i)
              enddo
           endif

           ! solve the linear equation, B = AX;
           call dgesv(nq-ngmax,1,A,nq-ngmax,ipiv,B,nq-ngmax,info)
           do i=ngmax+1,nq
              betar_q(i) = B(i-ngmax,1)
           enddo

           if(ipribetar>=2)then
              do i=1,nq
                 write(300+lmtt1,'(2f25.15)') q(i),betar_q(i)
              enddo
           endif

           ! FT back to Rspace
           betar_optimized(:,il1,tau1,it) = 0.d0 
           war = 0.0d0
           wbr = 0.0d0
           do i=1,nq
              fac = topi*wost(i)*q(i)*q(i)*betar_q(i)
              war(:) = q(i)*radr(:)
              call dsjnv(il1-1,nmesh(it),war,wbr)
              betar_optimized(:,il1,tau1,it) = betar_optimized(:,il1,tau1,it) + fac*wbr(:)
           enddo
           if(ipribetar>=2)then
              do i=1,nmesh(it)
                 write(400+lmtt1,'(2f25.15)') radr(i),betar_optimized(i,il1,tau1,it)
              enddo
           endif
        enddo
     enddo
     deallocate(q)
     deallocate(war)
     deallocate(wbr)
     deallocate(waq,wbq)
     deallocate(wa,wb,wc,wd)
     deallocate(wost)
     deallocate(A)
     deallocate(B)
     deallocate(betar_q)
     deallocate(ipiv)
  end subroutine optimize_betar_by_prefitting

  ! calculate A(q,q') from direct integration; for debugging purposes
  subroutine calculate_Aqqp_directly(n,il,radr,wos,q,qp,R0,Aqqp)
     integer,intent(in) :: n 
     integer,intent(in) :: il
     real(kind=DP),dimension(mmesh),intent(in) :: radr,wos
     real(kind=DP),intent(in) :: q,qp,R0
     real(kind=DP),intent(out) :: Aqqp 
     real(kind=DP),allocatable,dimension(:) :: wa,wb,wc
     integer :: i

     allocate(wa(n))
     allocate(wb(n))
     allocate(wc(n))

     wa(1:n) = q*radr(1:n)
     call dsjnv(il-1,n,wa,wb)
     wa(1:n) = qp*radr(1:n)
     call dsjnv(il-1,n,wa,wc)

     Aqqp = 0.d0
     do i=1,n
        Aqqp = Aqqp+radr(i)*radr(i)*wb(i)*wc(i)*wos(i)
     enddo
     Aqqp = Aqqp*q*q*qp*qp     

     deallocate(wa,wb,wc)
  end subroutine calculate_Aqqp_directly

  ! calculate A(q,q') from an analytical expression
  subroutine calculate_Aqqp(il,n,i,ip,q,jlm1,jl0,jl1,R0,Aqqp)
     integer,intent(in) :: il
     integer,intent(in) :: n
     integer,intent(in) :: i,ip
     real(kind=DP),dimension(n),intent(in) :: q
     real(kind=DP),dimension(n) :: jlm1,jl0,jl1
     real(kind=DP),intent(in) :: R0 
     real(kind=DP),intent(out) :: Aqqp
     real(kind=DP) :: jl,jlp,djl,djlp
     real(kind=DP) :: qq,qqp
     real(kind=DP) :: q2,fac
     qq  = q(i)
     qqp = q(ip)
     jl   = jl0(i)
     jlp  = jl0(ip)
     djl  = (dble(il)/(R0))*jl0(i)-qq*jl1(i)
     djlp = (dble(il)/(R0))*jl0(ip)-qqp*jl1(ip)
     if(i.ne.ip)then
        Aqqp = (R0*R0/(qqp*qqp-qq*qq))*(djl*jlp-djlp*jl)
     else
        Aqqp = 0.5d0*R0*R0*R0*(jl*jl-jl1(i)*jlm1(i))
     endif
     Aqqp = Aqqp*qq*qq*qqp*qqp
  end subroutine calculate_Aqqp

  subroutine m_NLP_alloc_betar_optimized()
     allocate(betar_optimized(mmesh,nloc,ntau,ntyp));betar_optimized=0.d0
     betar_optimized(:,:,:,:) = betar(:,:,:,:)
  end subroutine m_NLP_alloc_betar_optimized

  subroutine m_NLP_alloc_qr_optimized()
     integer :: id_sname = -1
     integer :: it,i,iq
     real(kind=DP) :: rr,hn
     allocate(qr_optimized(mmesh,nqitg));qr_optimized=0.d0
     do it=1,ntyp
        call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
        do iq=1,nqitg
           do i=1,nmesh(it) 
              rr = radr(i)*radr(i)
              qr_optimized(i,iq) = qrspspw(i,iq)/rr
           enddo
        enddo
     enddo
  end subroutine m_NLP_alloc_qr_optimized

  subroutine m_NLP_cal_i_l_exp_snl()
    complex(kind=DP), allocatable, dimension(:,:) :: wkexp
    integer :: ia,it,ig,igg,iksnl,ik,lmt1,lmtt1,lmta1,il1,mil
    complex(kind=DP) :: ctmp,i1=(0.d0,1.d0)
    real(kind=DP) :: fac
    integer :: id_sname = -1
    call tstatc0_begin('m_NLP_cal_i_l_exp_snl ',id_sname,1)
    allocate(wkexp(maxval(np_g1k),natm));wkexp=0.d0
    do iksnl=ista_snl,iend_snl
      ik = (iksnl-1)*nspin+1
      fac = 1.d0
      if(k_symmetry(ik)==GAMMA) fac = 2.d0
      call cal_phase()
      do ia=1,natm
        it = ityp(ia)
        do lmt1 = 1, ilmt(it)
          lmtt1 = lmtt(lmt1,it)
          lmta1 = lmta(lmt1,ia)
          il1   = ltp(lmt1,it)
          mil   = mod(il1-1,4)
          do ig=ista_g1k(ik),iend_g1k(ik)
            igg   = ig-ista_g1k(ik)+1
            ctmp  = (i1**(mil))*wkexp(igg,ia)*snl(igg,lmtt1,iksnl)
            i_exp_snl(igg,lmta1,iksnl,1) = fac *  real(ctmp)
            i_exp_snl(igg,lmta1,iksnl,2) = fac * dimag(ctmp)
            if(k_symmetry(ik)==GAMMA .and. ig==1) then
              if(mil==0 .or. mil==2) then
                i_exp_snl(1,lmta1,iksnl,1) = 0.d0
                i_exp_snl(1,lmta1,iksnl,2) = 0.d0
              else if (mil==1 .or. mil==3) then
                i_exp_snl(1,lmta1,iksnl,1) = 0.5d0*i_exp_snl(1,lmta1,iksnl,1)
                i_exp_snl(1,lmta1,iksnl,2) = 0.d0
              endif
            endif
          enddo
        enddo
      enddo
    enddo

    deallocate(wkexp)
    call tstatc0_end(id_sname)

    contains

    subroutine cal_phase()
      real(kind=DP) :: f1,f2,f3,ph
      integer :: nb
      do ia=1, natm
        f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2
        do ig=ista_g1k(ik),iend_g1k(ik)
          igg = ig-ista_g1k(ik)+1
          nb  = nbase(ig,ik)
          ph  = ngabc(nb,1)*f1+ngabc(nb,2)*f2+ngabc(nb,3)*f3
          wkexp(igg,ia) = dcmplx(dcos(ph),dsin(ph))
        enddo
      enddo
    end subroutine cal_phase

  end subroutine m_NLP_cal_i_l_exp_snl


!  subroutine m_NLP_dealloc_mesh_for_rspace()
!     deallocate(meshx_rs)
!     deallocate(meshy_rs)
!     deallocate(meshz_rs)
!     deallocate(meshxyz_rs)
!     if(kimg==1) then
!        deallocate(meshxyz_rs_h)
!        deallocate(map_h)
!        deallocate(map_h_i)
!        deallocate(meshxyz_rs_conjg)
!        deallocate(snl_rs_h)
!     endif
!     deallocate(snl_rs)
!     deallocate(snld_rs)
!  end subroutine m_NLP_dealloc_mesh_for_rspace
!
!  subroutine m_NLP_resolve_mesh_for_rspace(nfout)
!     integer, intent(in) :: nfout
!     integer :: nl,nm,nn,mm,id,nlhf
!     real(kind=DP) :: inl,inm,inn
!     real(kind=DP) :: ntot
!     integer :: id_sname = -1
!     logical,save :: firstcall=.true.
!     call tstatc0_begin('m_NLP_resolve_mesh_for_rspace ',id_sname,1)
!     if (firstcall) then
!        call resolve_cutoff_of_betar(nfout)
!        if(.not.allocated(nmesh_rs)) allocate(nmesh_rs(natm))
!        if(kimg==1) then
!           if(.not.allocated(nmesh_rs_h)) allocate(nmesh_rs_h(natm))
!        endif
!     endif
!     id = fft_box_size_WF(1,0)
!     mm = fft_box_size_WF(2,0)
!     nl = fft_box_size_WF(1,1);inl = 1.d0/dble(nl)
!     nm = fft_box_size_WF(2,1);inm = 1.d0/dble(nm)
!     nn = fft_box_size_WF(3,1);inn = 1.d0/dble(nn)
!     if(kimg==1)then
!       nlhf = id/2
!     else
!       nlhf = id
!     endif
!     ntot = dble(nl*nm*nn)
!
!     if(.not.firstcall)then
!       call m_NLP_dealloc_mesh_for_rspace()
!     endif
!     nmesh_rs=0 
!     if(kimg==1) nmesh_rs_h=0 
!     call resolve_atom_centered_mesh(prealloc=.true.,maxcount=nmesh_rs_max,maxcount_h=nmesh_rs_max_h)
!     allocate(meshx_rs(nmesh_rs_max,natm));meshx_rs = -1
!     allocate(meshy_rs(nmesh_rs_max,natm));meshy_rs = -1
!     allocate(meshz_rs(nmesh_rs_max,natm));meshz_rs = -1
!     allocate(meshxyz_rs(nmesh_rs_max,natm));meshxyz_rs = -1
!
!     if(kimg==1) then
!        allocate(meshxyz_rs_conjg(nmesh_rs_max,natm));meshxyz_rs_conjg = 1
!        allocate(meshxyz_rs_h(nmesh_rs_max_h,natm));meshxyz_rs_h = -1
!        allocate(map_h(nmesh_rs_max_h,natm));map_h = -1
!        allocate(map_h_i(nmesh_rs_max,natm));map_h_i = -1
!     endif
!     allocate(snl_rs(nmesh_rs_max,nlmta));snl_rs=0.d0
!     if(kimg==1) then
!        allocate(snl_rs_h(nmesh_rs_max_h,nlmta));snl_rs_h=0.d0
!     endif
!     allocate(snld_rs(nmesh_rs_max,nlmta,3));snld_rs=0.d0
!     call resolve_atom_centered_mesh(prealloc=.false.)
!
!     if(iprirs>=2.and.printable)then
!         call print_mesh()
!     endif
!     firstcall = .false.
!
!     call tstatc0_end(id_sname)
!
!     contains
!
!     subroutine resolve_atom_centered_mesh(prealloc,maxcount,maxcount_h)
!        logical, intent(in) :: prealloc
!        integer, optional, intent(out) :: maxcount,maxcount_h
!        real(kind=DP) :: rcut_betar_max,rcut,rcut2,rr,rcutmax
!        real(kind=DP) :: ex,ey,ez
!        integer :: nl_per_atm,nm_per_atm,nn_per_atm
!        integer :: nnx,nny,nnz
!        integer :: it,ia
!        integer :: i1,j1,k1,ii1,jj1,kk1,iil,iim,iin,cl,cm,cn
!        integer :: i1min,i1max,j1min,j1max,k1min,k1max
!        integer :: icount,icounth
!        real(kind=DP) :: fl,fm,fn
!        real(kind=DP) :: dx,dy,dz,r2,r,cx,cy,cz
!        integer :: maxc,maxch
!        integer :: pm
!        logical :: smallx,smally,smallz,tof
!
!        rcut_betar_max = 0.d0
!        do it=1,ntyp 
!           if(rcut_betar_max<rcut_betar_rs(it)) rcut_betar_max = rcut_betar_rs(it)
!        enddo
!
!        ex = neix * dsqrt(altv(1,1)**2+altv(1,2)**2+altv(1,3)**2)
!        ey = neiy * dsqrt(altv(2,1)**2+altv(2,2)**2+altv(2,3)**2)
!        ez = neiz * dsqrt(altv(3,1)**2+altv(3,2)**2+altv(3,3)**2)
! 
!        nnx = floor(ex/rcut_betar_max)
!        nny = floor(ey/rcut_betar_max)
!        nnz = floor(ez/rcut_betar_max)
!        smallx = nnx<2
!        smally = nny<2
!        smallz = nnz<2
!
!        nl_per_atm = floor(dble((2*neix+1)*nl)/dble(nnx))+1
!        nm_per_atm = floor(dble((2*neiy+1)*nm)/dble(nny))+1
!        nn_per_atm = floor(dble((2*neiz+1)*nn)/dble(nnz))+1
!        if(iprirs>=2)then
!          write(nfout,'(a,3i8)') ' !RS number of fft elements surrounding an atom  : ', &
!          & nl_per_atm,nm_per_atm,nn_per_atm
!        endif
!        maxc = 0
!        if(kimg==1) maxch = 0
!        do ia=1,natm
!           if(smallx)then
!              i1min = -nl*neix
!              i1max = +nl*(neix+1)
!           else
!              cl = -neix*nl+floor((2*neix+1)*nl*dble(neix+pos(ia,1))/dble(2*neix+1))
!              i1min = cl-nl_per_atm
!              i1max = cl+nl_per_atm
!           endif
!           if(smally)then
!              j1min = -nm*neiy
!              j1max = +nm*(neiy+1)
!           else
!              cm = -neiy*nm+floor((2*neiy+1)*nm*dble(neiy+pos(ia,2))/dble(2*neiy+1))
!              j1min = cm-nm_per_atm
!              j1max = cm+nm_per_atm
!           endif
!           if(smallz)then
!              k1min = -nn*neiz
!              k1max = +nn*(neiz+1)
!           else
!              cn = -neiz*nn+floor((2*neiz+1)*nn*dble(neiz+pos(ia,3))/dble(2*neiz+1))
!              k1min = cn-nn_per_atm
!              k1max = cn+nn_per_atm
!           endif
!           if(iprirs>=2.and. .not. (smallx.or.smally.or.smallz)) &
!           &  write(nfout,'(a,i8,a,3i8)') ' !RS center of mesh for atom ',ia,':',cl,cm,cn
!           it = ityp(ia)
!           rcut2=rcut_betar_rs(it)*rcut_betar_rs(it)
!           icount = 0
!           if(kimg==1) icounth = 0
!           do i1=i1min,i1max
!           do j1=j1min,j1max
!           do k1=k1min,k1max
!              iil = i1-1
!              iim = j1-1
!              iin = k1-1
!
!              ii1 = mod(iil+(2*neix+1)*nl,nl)+1
!              jj1 = mod(iim+(2*neiy+1)*nm,nm)+1
!              kk1 = mod(iin+(2*neiz+1)*nn,nn)+1
!
!              fl = dble(iil) * inl
!              fm = dble(iim) * inm
!              fn = dble(iin) * inn
!
!              dx = fl-pos(ia,1)
!              dy = fm-pos(ia,2)
!              dz = fn-pos(ia,3)
!
!              cx = altv(1,1)*dx+altv(1,2)*dy+altv(1,3)*dz
!              cy = altv(2,1)*dx+altv(2,2)*dy+altv(2,3)*dz
!              cz = altv(3,1)*dx+altv(3,2)*dy+altv(3,3)*dz
!              r2 = cx*cx+cy*cy+cz*cz
!              if(r2<rcut2)then
!                 tof = .false.
!                 icount = icount+1
!                 if(kimg==1.and.ii1<=nlhf) then
!                    icounth = icounth+1
!                    tof = .true.
!                 endif
!                 if(.not.prealloc)then
!                    meshx_rs(icount,ia) = iil
!                    meshy_rs(icount,ia) = iim
!                    meshz_rs(icount,ia) = iin
!                    if(kimg==1)then
!                       if(ii1>nlhf)then
!                          ii1 = id - ii1
!                          jj1 = nm+2 - jj1
!                          kk1 = nn+2 - kk1
!                          if(jj1>nm) jj1 = jj1-nm
!                          if(jj1.eq.0) jj1=1
!                          if(kk1>nn) kk1 = kk1-nn
!                          if(kk1.eq.0) kk1=1
!                          pm = +1.0d0
!                       else
!                          pm = -1.d0
!                       endif
!                    endif
!                    meshxyz_rs(icount,ia) = nlhf*mm*(kk1-1)+nlhf*(jj1-1)+ii1
!                    if(kimg==1) then
!                       meshxyz_rs_conjg(icount,ia) = pm
!                       if(tof) then
!                          meshxyz_rs_h(icounth,ia) = meshxyz_rs(icount,ia)
!                          map_h(icounth,ia) = icount
!                          map_h_i(icount,ia) = icounth
!                       endif
!                    endif
!                 endif
!              endif
!           enddo
!           enddo
!           enddo
!           if(prealloc)then
!             if(icount>maxc) maxc = icount
!             nmesh_rs(ia) = icount
!             if(kimg==1) then
!                if(icounth>maxch) maxch = icounth
!                nmesh_rs_h(ia) = icounth
!             endif
!           endif
!        enddo
!        if(prealloc.and.present(maxcount))then
!           maxcount = maxc
!        endif
!        if(prealloc.and.kimg==1.and.present(maxcount_h))then
!           maxcount_h = maxch
!        endif
!        
!     end subroutine resolve_atom_centered_mesh
!
!     subroutine print_mesh()
!        integer :: ia,nm
!        integer :: totnmesh
!        totnmesh = 0
!        do ia=1,natm
!           write(nfout,'(a,i0,a,i0)') ' !RS number of mesh points associated to atom ',ia,' : ',nmesh_rs(ia)
!           if(iprirs>=3)then
!             write(nfout,'(a)')              ' !RS associated mesh points ... '
!             do nm = 1,nmesh_rs(ia)
!                 write(nfout,'(a,4i8)')      ' !RS ',meshx_rs(nm,ia),meshy_rs(nm,ia),meshz_rs(nm,ia),meshxyz_rs(nm,ia)
!             enddo
!           endif
!           totnmesh = totnmesh+nmesh_rs(ia)
!        enddo
!        totnmesh = totnmesh/natm
!        write(nfout,'(a,i0,a,i0,a,f10.5)') ' !RS average number of mesh points associated to an atom / total FFT mesh = ' &
!        &     ,totnmesh,'/',int(ntot),' = ',dble(totnmesh)/ntot
!     end subroutine print_mesh
!
!  end subroutine m_NLP_resolve_mesh_for_rspace

end module m_NonLocal_Potential

       module eigen_blacs

       implicit NONE   
!--
          public :: eigen_blacs_init
          public :: eigen_blacs_exit
          public :: eigen_get_blacs_context
          public :: eigen_set_blacs_context
!--
          integer, private :: BLACS_ICONTXT_FOR_EIGEN
!--
       contains
!--
          subroutine eigen_blacs_init( TRD_COMM_WORLD,
     &                                 x_nnod, y_nnod,
     &                                 GRID_major )
          use MPI
          implicit NONE   

          integer, intent(in)       ::  TRD_COMM_WORLD
          integer, intent(in)       ::  x_nnod, y_nnod
          character*(*), intent(in) ::  GRID_major

          integer, pointer ::  tmpgrid(:,:)
          integer, pointer ::  kk0(:), kk1(:)
          integer          ::  group0, group1
          integer          ::  i, j, k, ierr


             call BLACS_GET( 0, 0, BLACS_ICONTXT_FOR_EIGEN )

             allocate( tmpgrid( 1:x_nnod, 1:y_nnod ) )
             allocate( kk0( 1:x_nnod ) )
             allocate( kk1( 1:x_nnod ) )
             call MPI_Comm_group( MPI_COMM_WORLD, group0, ierr )
             call MPI_Comm_group( TRD_COMM_WORLD, group1, ierr )

             if ( Grid_major == 'R' ) then
                do j = 1, y_nnod
                do i = 1, x_nnod
                   kk1(i) = j+(i-1)*y_nnod-1
                enddo
                   k = x_nnod
                   call MPI_Group_translate_ranks( group1, k, kk1,
     $                                             group0, kk0, ierr )
                do i = 1, x_nnod
!Kro               tmpgrid(i, j) = kk0(i)
                   tmpgrid(i, j) = kk1(i)
                end do
                end do
             else
                do j = 1, y_nnod
                do i = 1, x_nnod
                   kk1(i) = i+(j-1)*x_nnod-1
                enddo
                   k = x_nnod
                   call MPI_Group_translate_ranks( group1, k, kk1,
     $                                             group0, kk0, ierr )
                do i = 1, x_nnod
!Kro               tmpgrid(i, j) = kk0(i)
                   tmpgrid(i, j) = kk1(i)
                end do
                end do
             endif

             call BLACS_GRIDMAP( BLACS_ICONTXT_FOR_EIGEN,
     $                           tmpgrid, x_nnod, x_nnod, y_nnod )

             call MPI_Group_free( group0, ierr )
             call MPI_Group_free( group1, ierr )
             deallocate( tmpgrid )
             deallocate( kk0 )
             deallocate( kk1 )


          return
          end subroutine  eigen_blacs_init
*-
          subroutine eigen_blacs_exit( )
          implicit NONE   


             call BLACS_GRIDEXIT( BLACS_ICONTXT_FOR_EIGEN )
             call BLACS_EXIT( 1 )


          return
          end subroutine  eigen_blacs_exit
!--
          subroutine eigen_set_blacs_context( ictxt )
          implicit NONE   
          integer, intent(in)       ::  ictxt


             BLACS_ICONTXT_FOR_EIGEN=ictxt


          return
          end subroutine eigen_set_blacs_context
!--
          integer function eigen_get_blacs_context( )
          implicit NONE   


             eigen_get_blacs_context = BLACS_ICONTXT_FOR_EIGEN


          return
          end function  eigen_get_blacs_context
*-

       end module eigen_blacs

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for tools used in the LR-TDDFT.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_tools

  use m_Const_Parameters,               only : DP, CARTS, BUCS, PAI, PAI2, PAI4,  &
       &                                       ELECTRON, INVERSE, ON, OFF, CMPLDP, &
       &                                       GAMMA

  use m_Files,                          only : nfout
  use m_FFT,                            only : nfft, m_FFT_WF

  use m_Kpoints,                        only : kv3_ek, kv3, vkxyz_ek, qwgt_ek, & 
       &                                       vkxyz, qwgt, &
       &                                       k_symmetry
  use m_Control_Parameters,             only : ipri, nspin, kimg, af, neg, printable

  use m_Parallelization,                only : ista_e,iend_e,istep_e,map_z,np_e, &
    &                                          ista_k, iend_k, map_k, map_ek,  &
    &                                          myrank_k, myrank_e, map_e, npes, & 
    &                                          mpi_comm_group, ierr, mype, istatus  

  use m_Electronic_Structure, only : zaj_l, occup_l, eko_l, eko_ek, neordr, efermi
  use m_PlaneWaveBasisSet,    only : ngabc,igf,kg1,kg, iba, nbase, nbase_gamma
  use m_IterationNumbers,     only : nk_in_the_process, nk_converged

  use m_Timing,                     only : tstatc0_begin, tstatc0_end

!  use m_LinearResponse_Control,     only : Num_Q_Points
  use m_Control_Parameters,     only : Num_Q_Points, sw_LinearResponse

! ----------------------------
  use m_LinearResponse_Control,         only : vqxyz, vec_q, nrd_efermi
  use m_LinearResponse_Control,         only : sw_tddft,  sw_LongWaveLimit
! ------------------- USPP ---
  use m_PseudoPotential,        only : modnrm, nlmta
  use m_Const_Parameters,       only : EXECUT
  use m_Electronic_Structure,    only : fsr_l, fsi_l

  use m_FFT,                    only : nfftp, m_FFT_CD_INVERSE_c
  use m_Parallelization,         only : ista_kngp, iend_kngp, &
       &                                ista_fftp, iend_fftp
  use m_PlaneWaveBasisSet,    only : kgp
! -----------------------------
  Implicit None
  include 'mpif.h'
  
  ! --------------------- temporary work arrays ------------------------
  real(kind=DP), allocatable :: wfn_k(:,:,:,:), wfn_kmq(:,:,:,:)
  integer,  allocatable      :: map_z_k(:), map_z_kmq(:)
  integer,  allocatable      :: nbase_k( :,: ), nbase_kmq(:,:)
  integer,  allocatable      :: igf_k(:), igf_kmq(:), iba_k(:), iba_kmq(:)
  !
  real(kind=DP), allocatable :: occup_k(:,:), occup_kmq(:,:)
  real(kind=DP), allocatable :: eko_k(:,:), eko_kmq(:,:)  
! -------------------- For USPP -------------
  real(kind=DP), allocatable :: fsval_k(:,:,:,:), fsval_kmq(:,:,:,:)
 ! ---------------------------------------------------------

contains

!----------------------------------------------------
!!
!!!         Alloc and Dealloc temporary arrays
!!
!----------------------------------------------------
  subroutine m_LR_alloc_Array_WFns
    if ( sw_LongWaveLimit == OFF ) then
       Allocate( wfn_k  ( kg1, np_e, kv3, kimg) ); wfn_k = 0.0d0
       Allocate( wfn_kmq( kg1, np_e, kv3, kimg) ); wfn_kmq = 0.0d0
    else
       Allocate( wfn_k  ( kg1, np_e, kv3, kimg) ); wfn_k = 0.0d0
    endif
  end subroutine m_LR_alloc_Array_WFns

  subroutine m_LR_dealloc_Array_WFns
    if ( sw_LongWaveLimit == OFF ) then
       Deallocate( wfn_k, wfn_kmq )
    else
       Deallocate( wfn_k )
    endif
  end subroutine m_LR_dealloc_Array_WFns

  subroutine m_LR_alloc_Array_MapFns
    if ( sw_LongWaveLimit == OFF ) then
       Allocate( map_z_k  ( neg ) );      map_z_k = 0
       Allocate( map_z_kmq( neg ) );      map_z_kmq = 0
       Allocate( nbase_k  ( kg1, kv3 ) ); nbase_k = 0
       Allocate( nbase_kmq( kg1, kv3 ) ); nbase_kmq = 0
       Allocate( igf_k  ( kg ) );         igf_k = 0
       Allocate( igf_kmq( kg ) );         igf_kmq = 0
       Allocate( iba_k  ( kv3 ) );        iba_k = 0
       Allocate( iba_kmq( kv3 ) );        iba_kmq = 0
    else
       Allocate( map_z_k  ( neg ) );      map_z_k = 0
       Allocate( nbase_k  ( kg1, kv3 ) ); nbase_k = 0
       Allocate( igf_k  ( kg ) );         igf_k = 0
       Allocate( iba_k  ( kv3 ) );        iba_k = 0
    endif
  end subroutine m_LR_alloc_Array_MapFns

  subroutine m_LR_dealloc_Array_MapFns
    if ( sw_LongWaveLimit == OFF ) then
       Deallocate( map_z_k, map_z_kmq ); Deallocate( nbase_k, nbase_kmq )
       Deallocate( igf_k, igf_kmq );     Deallocate( iba_k, iba_kmq )
    else
       Deallocate( map_z_k );        Deallocate( nbase_k )
       Deallocate( igf_k );          Deallocate( iba_k )
    endif
  end subroutine m_LR_dealloc_Array_MapFns

  subroutine m_LR_alloc_Array_Occups
    if ( sw_LongWaveLimit == OFF ) then
       Allocate( occup_k( neg, ista_k:iend_k) );   occup_k = 0.0d0
       Allocate( occup_kmq( neg, ista_k:iend_k) ); occup_kmq = 0.0d0
    else
       Allocate( occup_k( neg, ista_k:iend_k) ); occup_k = 0.0d0
    endif
  end subroutine m_LR_alloc_Array_Occups

  subroutine m_LR_dealloc_Array_Occups
    if ( sw_LongWaveLimit == OFF ) then
       deallocate( occup_k, occup_kmq )
    else
       deallocate( occup_k )
    endif
  end subroutine m_LR_dealloc_Array_Occups

  subroutine m_LR_alloc_Array_EigenVals
    if ( sw_LongWaveLimit == OFF ) then
    else
       Allocate( eko_k( neg, ista_k:iend_k ) );     eko_k = 0.0d0
    endif
  end subroutine m_LR_alloc_Array_EigenVals

  subroutine m_LR_dealloc_Array_EigenVals
    if ( sw_LongWaveLimit == OFF ) then
    else
       deallocate( eko_k )
    endif
  end subroutine m_LR_dealloc_Array_EigenVals

  subroutine m_LR_alloc_Array_CorePart
    if ( sw_LongWaveLimit == OFF ) then
       Allocate( fsval_k  ( np_e, nlmta, ista_k:iend_k, kimg ) ); fsval_k   = 0.0d0
       Allocate( fsval_kmq( np_e, nlmta, ista_k:iend_k, kimg ) ); fsval_kmq = 0.0d0
    else
       Allocate( fsval_k  ( np_e, nlmta, ista_k:iend_k, kimg ) ); fsval_k   = 0.0d0
    endif
  end subroutine m_LR_alloc_Array_CorePart

  subroutine m_LR_dealloc_Array_CorePart
    if ( sw_LongWaveLimit == OFF ) then
       Deallocate( fsval_k, fsval_kmq )
    else
       Deallocate( fsval_k )
    endif
  end subroutine m_LR_dealloc_Array_CorePart
!-------------------------------------------------------------
!!
!!!      obtain a wavefunction in the real space
!!
!--------------------------------------------------------------
  subroutine Get_WF_in_Rspace( ik, ib, wfn_in, bfft, &
       &                       nbase_in, iba_in, igf_in, map_z_in )
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP), intent(in) :: wfn_in( kg1, np_e, kv3, kimg )

    integer, intent(in) :: ik, ib
    integer, intent(in) :: nbase_in( kg1,kv3 )
    integer, intent(in) :: igf_in( kg )
    integer, intent(in) :: iba_in( kv3 )
    integer, intent(in) :: map_z_in( neg )

    integer :: i,i1, ri, j, i2, ii
! --------------------------------------- start --------------
    bfft = 0.d0
! --------------------------------------- main ---------------
    if ( k_symmetry(ik) == GAMMA ) then
       if ( kimg == 1 ) then
!         write(*,*) 'YYYYYYYYYYYYYYYYYYYYYYYYYYY 7'
          i1 = igf_in(1)
          bfft(i1) = wfn_in(1, ib, ik, 1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba_in(ik)
             i = nbase_in(ii,ik)
             i1 = igf_in(i)
             bfft(i1) = wfn_in(ii, ib, ik, 1)
             j = nbase_gamma(ii,2)
             i2 = igf_in(j)
             bfft(i2) = wfn_in(ii, ib, ik, 2)
          end do
       else ! kimg == 2
!         write(*,*) 'YYYYYYYYYYYYYYYYYYYYYYYYYYY 8'
          i1 = 2*igf_in(1) - 1
          bfft(i1)   = wfn_in(1, ib, ik, 1)
          bfft(i1+1) = wfn_in(1, ib, ik, 2)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba_in(ik)
             i = nbase_in( ii,ik )
             i1 = 2*igf_in(i)-1
             bfft(i1  ) = wfn_in(ii, ib, ik, 1)
             bfft(i1+1) = wfn_in(ii, ib, ik, 2)
             j = nbase_gamma(ii,2)
             i2 = 2*igf_in(j)-1
             bfft(i2  ) =  wfn_in(ii, ib, ik, 1)
             bfft(i2+1) = -wfn_in(ii, ib, ik, 2)
          end do
       end if
    else
      if(kimg == 1) then
!         write(*,*) 'YYYYYYYYYYYYYYYYYYYYYYYYYYY 9'
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
        do i = 1, iba_in(ik)
           i1 = igf_in( nbase_in(i,ik) )
           bfft(i1) = wfn_in( i, ib, ik, 1 )
        end do
      else ! kimg == 2
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
!         write(*,*) 'YYYYYYYYYYYYYYYYYYYYYYYYYYY 10'
        do i = 1, iba_in(ik)
           i1 = 2*igf_in( nbase_in( i,ik ) ) - 1
           bfft(i1) = wfn_in( i, ib, ik, 1 )
           i2 = 2*igf_in( nbase_in(i,ik) )
           bfft(i2) = wfn_in( i, ib, ik, 2 )
        end do
      end if
    end if
! ----------------------
    call m_FFT_WF( ELECTRON,nfout,bfft,INVERSE,OFF )
!p    call m_FFT_WF( ELECTRON,nfout,bfft,INVERSE,ON )
  end subroutine Get_WF_in_Rspace

  subroutine Get_WF_in_Rspace_CD( ik, ib, wfn_in, bfft, &
       &                          nbase_in, iba_in, igfp_LR_in, map_z_in )
! --
    real(kind=DP), intent(in) :: wfn_in( kg1, np_e, ista_k:iend_k, kimg )
    real(kind=DP), intent(inout) :: bfft(ista_fftp:iend_fftp)

    integer, intent(in) :: ik, ib
    integer, intent(in) :: nbase_in( kg1,kv3 )
    integer, intent(in) :: iba_in( kv3 )
    integer, intent(in) :: map_z_in( neg )
    integer, intent(in) :: igfp_LR_in( kgp )

    integer :: i,i1, ri, j, i2, ii
    integer :: jb

    real(kind=DP), allocatable :: bfft_mpi(:)
! -------
    bfft = 0.0d0
    if ( npes > 1 ) then
       allocate( bfft_mpi( nfftp )); bfft_mpi = 0.0d0
       if ( map_e( ib ) == myrank_e ) then
          jb = map_z_in( ib )
          do ri = 1, kimg
             do i = 1, iba_in(ik)
                i1 = kimg *igfp_LR_in( nbase_in(i,ik) ) + (ri - kimg)
                bfft_mpi(i1) = wfn_in( i, jb, ik, ri )   ! MPI
             end do
          end do
       endif
       call mpi_bcast( bfft_mpi, nfftp, MPI_DOUBLE_PRECISION, &
            &          map_e(ib), mpi_comm_group, ierr )
       if ( ierr /= 0 ) write(*,*) 'MPI error ', mype, ierr
       bfft(ista_fftp:iend_fftp) = bfft_mpi(ista_fftp:iend_fftp)

       deallocate( bfft_mpi )
    else
       do ri = 1, kimg
          do i = 1, iba_in(ik)
             i1 = kimg *igfp_LR_in( nbase_in(i,ik) ) + (ri - kimg)
             bfft(i1) = wfn_in( i, ib, ik, ri )   ! MPI
          end do
       end do
    endif
! --
    call m_FFT_CD_inverse_c( nfout, bfft )   ! From G- to R-space

  end subroutine Get_WF_in_Rspace_CD
!--------------------------------------------------------
!!
!!!            Copying tools
!!
!--------------------------------------------------------

  subroutine Copy_Zaj_To( Wfn_target ) 
    real(kind=DP), intent(inout) ::  Wfn_target ( kg1, np_e, ista_k:iend_k, kimg )

! ------------------------------ start -----------
    Wfn_target( 1:kg1, 1:np_e, ista_k:iend_k, 1:kimg ) &
         & = zaj_l( 1:kg1, 1:np_e, ista_k:iend_k, 1:kimg )
! ------------------------------ end -----------
  end subroutine Copy_Zaj_To
    
  subroutine Copy_HardPart_To( fs_target )
    real(kind=DP), intent(inout) :: fs_target( np_e, nlmta, ista_k:iend_k, kimg ) 
! ---------------------------------- main ---------
    fs_target( 1:np_e, 1:nlmta, ista_k:iend_k, 1 ) &
         & = fsr_l( 1:np_e, 1:nlmta, ista_k:iend_k )
    if ( kimg ==2 ) then
       fs_target( 1:np_e, 1:nlmta, ista_k:iend_k, 2 ) &
            & = fsi_l( 1:np_e, 1:nlmta, ista_k:iend_k )
    endif
  end subroutine Copy_HardPart_To

  subroutine Copy_EigenVals_To( Eko_target, occup_tmp )
    real(kind=DP), intent(out)           :: Eko_target( neg, kv3 )
    real(kind=DP), intent(out), optional :: occup_tmp( neg, kv3 )
!
    real(kind=DP), allocatable :: e_mpi(:,:), e2_mpi(:,:)
    integer :: ik, ie
! -------------------------- start -------
    allocate( e_mpi(neg,kv3));   e_mpi = 0.0d0
    allocate(e2_mpi(neg,kv3));  e2_mpi = 0.0d0
! --------------------------- main -------
    Do ik = 1, kv3
       if ( map_k(ik) /= myrank_k ) cycle
       Do ie = 1, neg
          if ( map_e(ie) /= myrank_e ) cycle
          e_mpi( ie,ik ) = eko_l( map_z(ie),ik )
       End do
    End do
    if( npes >= 2 ) then
       call mpi_allreduce(e_mpi,e2_mpi,neg*kv3,mpi_double_precision &
            &               ,mpi_sum,mpi_comm_group,ierr)
    else
       e2_mpi = e_mpi
    end if
!
    Eko_target = e2_mpi
    if ( nrd_efermi==ON ) then
       Call Estimate_Ocuup_Simply( e2_mpi, occup_tmp )
    endif
! ------------------- end ------------
    deallocate( e_mpi, e2_mpi )
  end subroutine Copy_EigenVals_To

  subroutine Copy_MapZ_To( MapFunction )
    integer, intent(inout) :: MapFunction( neg )
    MapFunction  = map_z
  end subroutine Copy_MapZ_To

  subroutine Copy_MapE_To( MapFunction )
    integer, intent(inout) :: MapFunction( neg )
    MapFunction  = map_e
  end subroutine Copy_MapE_To

  subroutine Copy_MapEK_To( MapFunction )
    integer, intent(inout) :: MapFunction( neg, kv3 )
    MapFunction  = map_ek
  end subroutine Copy_MapEK_To

  subroutine Copy_NBase_To( MapFunction )
    integer, intent(inout) :: MapFunction( kg1, kv3 )
    MapFunction  = nbase
  end subroutine Copy_NBase_To

  subroutine Copy_Igf_To( MapFunction )
    integer, intent(inout) :: MapFunction( kg  )
    MapFunction  = igf
  end Subroutine Copy_Igf_To

  subroutine Copy_Iba_To( MapFunction )
    integer, intent(inout) :: MapFunction( kv3 )
    MapFunction  = iba
  end subroutine Copy_Iba_To

  subroutine Copy_Eko_Or_Occ_To( MatA, MatB )
    real(kind=DP), intent(in)    ::  MatA( neg, kv3 )
    real(kind=DP), intent(inout) ::  MatB( neg, kv3_ek )
    integer i, ik

    Do ik=1, kv3
       Do i=1, neg
          MatB( i, ik + nk_in_the_process -1 ) = MatA( i,ik )
       End do
    End do
  end subroutine Copy_Eko_Or_Occ_To

  subroutine Copy_Eko_To( MatA, MatB )
    real(kind=DP), intent(in)    ::  MatA( neg, kv3 )
    real(kind=DP), intent(inout) ::  MatB( neg, kv3_ek )
    integer i, ik

    Do ik=1, kv3
       Do i=1, neg
          MatB( i, ik + nk_in_the_process -1 ) = MatA( i,ik )
       End do
    End do
  end subroutine Copy_Eko_To

  subroutine Copy_EigenVals_To2( Eko_target, Occup_target, occup_tmp )
    real(kind=DP), intent(out)           :: Eko_target( neg, kv3_ek )
    real(kind=DP), intent(out), optional :: Occup_target( neg, kv3_ek )
    real(kind=DP), intent(out), optional :: occup_tmp( neg, kv3 )
!
    real(kind=DP), allocatable :: e_mpi(:,:), e2_mpi(:,:)
    integer ik, ie, i
! -------------------------- start -----------
    allocate( e_mpi(neg,kv3));   e_mpi = 0.0d0
    allocate(e2_mpi(neg,kv3));  e2_mpi = 0.0d0
! -------------------------- main -----------
    Do ik = 1, kv3
       if ( map_k(ik) /= myrank_k ) cycle
       Do ie = 1, neg
          if ( map_e(ie) /= myrank_e ) cycle
          e_mpi( ie,ik ) = eko_l( map_z(ie),ik )
       End do
    End do
    if( npes >= 2 ) then
       call mpi_allreduce(e_mpi,e2_mpi,neg*kv3,mpi_double_precision &
            &               ,mpi_sum,mpi_comm_group,ierr)
    else
       e2_mpi = e_mpi
    end if
!
    Do ik=1, kv3
       Do i=1, neg
          Eko_target( i, ik + nk_in_the_process -1 ) = e2_mpi( i,ik )
       End do
    End do
! -
    if ( nrd_efermi == ON ) then
       Call Estimate_Ocuup_Simply( e2_mpi, occup_tmp )
       Do ik=1, kv3
          Do i=1, neg
             Occup_target( i, ik + nk_in_the_process -1 ) = occup_tmp( i,ik )
          End do
       End do
    endif
! ------------------------- end ---------------------
    deallocate( e_mpi, e2_mpi )
  end subroutine Copy_EigenVals_To2
  
  subroutine Copy_Occups_To( occup_tmp )
    real(kind=DP), intent(out), optional :: occup_tmp( neg, kv3 )
!
    real(kind=DP), allocatable :: e_mpi(:,:), e2_mpi(:,:)
    integer ik, ie, i
! -------------------------- start ----------
    allocate( e_mpi(neg,kv3));   e_mpi = 0.0d0
    allocate(e2_mpi(neg,kv3));  e2_mpi = 0.0d0
! --------------------------- main ----------
    Do ik = 1, kv3
       if ( map_k(ik) /= myrank_k ) cycle
       Do ie = 1, neg
          if ( map_e(ie) /= myrank_e ) cycle
          e_mpi( ie,ik ) = eko_l( map_z(ie),ik )
       End do
    End do
    if( npes >= 2 ) then
       call mpi_allreduce(e_mpi,e2_mpi,neg*kv3,mpi_double_precision &
            &               ,mpi_sum,mpi_comm_group,ierr)
    else
       e2_mpi = e_mpi
    end if
!
    if ( nrd_efermi == ON ) then
       Call Estimate_Ocuup_Simply( e2_mpi, occup_tmp )
    endif
! ------------------------- end --------------
    deallocate( e_mpi, e2_mpi )
  end subroutine Copy_Occups_To
  
  subroutine Estimate_Ocuup_Simply( eko_in, occup_out )
    real(kind=DP), intent(in)  :: eko_in( neg, kv3 )
    real(kind=DP), intent(out) :: occup_out( neg, kv3 )

    integer ik, j

    Do ik=1, kv3
       Do j=1, neg
          if ( eko_in( j,ik) < efermi ) then
             occup_out( j,ik ) = 1.0d0
          else
            occup_out( j,ik ) = 0.0d0
          endif
       End do
    End do
  end subroutine Estimate_Ocuup_Simply

end module m_LinearResponse_tools

      subroutine  tred1_init(a, nm, n,
     &              d_out, e_out,
     &              u_t, v_t, nv)
!$    use omp_lib
      implicit NONE

      integer, intent(in)    ::  nm, n, nv
      real(8), intent(inout) ::  a(1:nm, *)
      real(8), intent(out)   ::  d_out(*)
      real(8), intent(out)   ::  e_out(*)
      real(8), intent(in)    ::  u_t(*), v_t(*)

      integer                ::  i_1, i_2, i_3, i_4
      integer                ::  j_1, j_2, j_3, j_4
      integer                ::  k_1, k_2, k_3
      integer                ::  i, j

      integer                ::  local_size, local_rank

      include 'trd.h'
      include 'trd_au.h'
      include 'CSTAB.h'
      include 'param.h'


      d_out(1:n) = ZERO
      e_out(1:n) = ZERO

      if ( diag_0 > 0 ) then
         i_2 = diag_0
         i_3 = loop_c_end  (n, y_nnod, y_inod)
         if ( i_2 <= i_3 ) then
         i_4 = x_nnod/n_common
         j_2 = diag_1
         j_3 = loop_c_end  (n, x_nnod, x_inod)
         j_4 = y_nnod/n_common
         k_2 = 0
         k_3 = (i_3-i_2)/i_4
         do  k_1 = k_2, k_3
            i_1 = i_2 + k_1 * i_4
            j_1 = j_2 + k_1 * j_4
            j   = (i_1-1)*y_nnod+y_inod
            d_out(j) = a(j_1, i_1)
         end do ! k_1
         end if
      end if

      i_2 = loop_c_start(1, y_nnod, y_inod)
      i_3 = loop_c_end  (n, y_nnod, y_inod)
      do  i_1 = i_2, i_3
         j   = loop_c_l2g_depth(i_1, y_nnod, y_inod)
         j_2 = loop_c_start    (j+1, x_nnod, x_inod)
         if ( j <= n ) then
            a(j_2:nm, i_1) = ZERO
         else
            a(1:nm, i_1) = ZERO
         end if
      end do ! i_1

      local_rank = 0
      local_size = 1
!$    local_rank = omp_get_thread_num()
!$    local_size = omp_get_num_threads()

      if ( local_size > 1 ) then

         allocate(u0_z(nv*local_size+n_columns),
     &            v0_z(nv*local_size+n_columns))
         u0_z = 0.0D0
         v0_z = 0.0D0
         call CSTAB_adjust_base(u0_z(1), u_t(1), offset1)
         call CSTAB_adjust_base(v0_z(1), v_t(1), offset2)

      end if


      return
      end subroutine  tred1_init


      subroutine  tred1_final(a, nm, n, d_out, e_out, u_t)

!$    use omp_lib
      implicit NONE

      integer, intent(in)    ::  nm, n
      real(8), intent(inout) ::  a(1:nm, *)
      real(8), intent(out)   ::  d_out(*)
      real(8), intent(out)   ::  e_out(*)
      real(8), intent(out)   ::  u_t(*)

      integer                ::  x_pos, x_owner_nod
      integer                ::  y_pos, y_owner_nod
      integer                ::  i_1, i_2, i_3, i_4
      integer                ::  j_1, j_2, j_3, j_4
      integer                ::  k_1, k_2, k_3, k_4
      integer                ::  i, j, k, L
      real(8)                ::  t

      integer                ::  local_size, local_rank

      include 'trd.h'
      include 'trd_au.h'
      include 'CSTAB.h'


      if ( n >= 2 ) then
         i = 2; L = i-1
         y_owner_nod = loop_c_node (i, y_nnod, y_inod)
         x_owner_nod = loop_c_node (L, x_nnod, x_inod)
         i_1 = loop_c_g2l_depth(i, y_nnod, y_owner_nod)
         j_1 = loop_c_g2l_depth(L, x_nnod, x_owner_nod)
         if ( y_owner_nod == y_inod
     &         .AND. x_owner_nod == x_inod ) then
            e_out(i)    = -a(j_1, i_1)
            a(j_1, i_1) =2*a(j_1, i_1)
         end if
         j = x_nnod * (y_owner_nod-1) + (x_owner_nod-1) + 1
         call bcast_dbl( e_out(2), 1, j, TRD_COMM_WORLD )
      end if

      if ( diag_0 > 0 ) then
         i_2 = diag_0
         i_3 = loop_c_end  (n, y_nnod, y_inod)
         if ( i_2 <= i_3 ) then
         i_4 = x_nnod/n_common
         j_2 = diag_1
         j_3 = loop_c_end  (n, x_nnod, x_inod)
         j_4 = y_nnod/n_common
         k_2 = 0
         k_3 = (i_3-i_2)/i_4
         do  k_1 = k_2, k_3
            i_1 = i_2 + k_1 * i_4
            j_1 = j_2 + k_1 * j_4
            j   = (i_1-1)*y_nnod+y_inod
            t           = d_out(j)
            d_out(j)    = a(j_1, i_1)
            a(j_1, i_1) = t
         end do ! k_1
         end if
      end if

      call reduce_dbl(d_out(1),   u_t(1), n, 1, TRD_COMM_WORLD)

      local_rank = 0
      local_size = 1
!$    local_rank = omp_get_thread_num()
!$    local_size = omp_get_num_threads()

      if ( local_size > 1 ) then

         deallocate(u0_z,v0_z)

      end if

      return
      end subroutine tred1_final

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  n   : dimension of matrix
!  a   : matrix
!  lda : size of array "a"
!  w   : array for eigen value
!  z   : array for eigen vector
!  ldz : size of array "z"
!  d   : array to store a main diagonal element
!  e   : array to store a sub diagonal element
!  m0  : coefficient of blocking
!  ifl : switch flag ( 0:eigen-value and eigen-vector )
!                    ( 1:eigen-value only )
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine eigen_real_symmetric(n, a, lda, w, z, ldz, m0, ifl)
      implicit none

      integer, intent(in)    :: n, lda, ldz, m0, ifl
      real(8), intent(inout) :: a(lda,*), w(*), z(ldz,*)

      include 'switch_ndim.h'

      if(n<ndim_switch) then
        call eigen_s(n, a, lda, w, z, ldz, m0, ifl)
      else
        call eigen_sx(n, a, lda, w, z, ldz, m0, ifl)
      endif

      end subroutine

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 606 $)
!
!  PROGRAM: EK
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!      Further modification by T. Yamasaki   Feb. 2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
! $Id: ekmain.f90 606 2020-04-15 06:45:49Z ktagami $
!
program EK
! This program was coded by T. Yamasaki(FUJITSU Laboratories Ltd.), 17th Feb. 2003.
!
  implicit none
  logical  :: EigenValues_are_Converged, AllKpoints_are_Calculated
  logical  :: Already_Converged
  logical  :: Ending_Time

  call Initialization_set_ekmode_ON  ! set `ekmode' ON in m_Control_Parameters
  call Initialization(1)             ! Initialization of mpi and file-setting
  call InputData_Analysis
  call Preparation(0)                ! Basis set, symmetry check etc.
  call Preparation_for_mpi(1)        ! mpi
  call PseudoPotential_Construction
#ifdef ENABLE_ESM_PACK
  call Preparation_for_ESM
#endif
  call Ewald_and_Structure_Factor    ! Calculate Structure Factor
  call Initial_Electronic_Structure()! read Charge Density, (lclchh)

  KPOINTS: do
!     call KpointNumber_Setting()
     call KpointNumber_Setting2()
     call Preparation_ek             ! (basnum)
     call Preparation_for_mpi_ek     ! mpi  -> np_g1k, mp_g1k
     call PseudoPotential_ek         ! (kbint)
     call Initial_WaveFunctions_ek   ! (rndzaj|rdzaj),(fsrfsi),(lclchh)
     if(.not.Already_Converged()) then
        SolveWaveFunctions: do
           if(Ending_Time())                 exit KPOINTS
           call IterationNumber_Setting()
           call Renewal_of_WaveFunctions()
           if(EigenValues_are_Converged())   exit SolveWaveFunctions
        enddo SolveWaveFunctions
        call Postprocessing_k()
        if(AllKpoints_are_Calculated())     exit KPOINTS
     else
        exit KPOINTS
     end if
  enddo KPOINTS
!!$  else
!!$     write(6,'(" Already_Converged")')
!!$     call KpointNumber_Setting()
!!$     call Preparation_ek             ! (basnum)
!!$     call PseudoPotential_ek         ! (kbint)
!!$     call Initial_WaveFunctions_ek   ! (rndzaj|rdzaj),(fsrfsi),(lclchh)
!!$  end if

  call Postprocessing(.false.)
  call WriteDownData_onto_Files_ek()
  call Finalization_of_mpi           ! mpi
end program EK

module m_Excitation
!
  use m_Const_Parameters,   only :  ON, OFF, DP, CMPLDP, LOWER, FMAXVALLEN, zi, &
       &                            ELECTRON, DIRECT, BUCS, PAI2, PAI4, Hartree, YES
  use m_Control_Parameters,  only : sw_use_add_proj, kimg, neg, ndim_spinor, nspin, &
       &                            sw_excitation, noncol, ipri
  use m_Files,  only : nfout, nf_excitation_spectra, m_Files_open_nf_xi_spectra

  use m_PseudoPotential,    only :  nlmt, ilmt, nlmt_add, ilmt_add, itau, iloc, &
       &                            radr, wos, mmesh, nmesh, lpsmax, nloc, ntau, &
       &                            psirpw, phirpw, ltp, mtp, taup, ltp_add, mtp_add, &
       &                            nlmta, nlmta_add, lmta, lmta_add
  use m_NonLocal_Potential, only : new_radr_and_wos

  use m_Ionic_System,       only : ntyp, ityp, natm, pos
  use m_Crystal_Structure,   only : nopr, rltv, univol, op, tau
  use m_Kpoints,       only : kv3, vkxyz, qwgt, kv3_fbz, num_star_of_k, star_of_k, &
       &                      iopr_k_fbz_to_ibz, trev_k_fbz_to_ibz

  use m_PlaneWaveBasisSet,   only : kg1, kgp, ttr, ngabc, ngpt_l, iba, nbase, igf
  use m_Parallelization,     only : npes, ista_kngp, iend_kngp, mpi_comm_group, ierr, &
       &                            ista_k, iend_k, np_e, myrank_e, myrank_k, &
       &                            map_e, map_k, map_z, ista_e, iend_e, istep_e, &
       &                            mpi_k_world, mype, map_ek, mpi_e_world, &
       &                            nrank_e, nrank_k

  use m_Electronic_Structure,  only : eko_l, zaj_l, fsr_l, fsi_l, fsr_add_l, fsi_add_l, &
       &                              m_ES_WF_in_Rspace1, m_ES_WF_in_Rspace_kt, &
       &                              efermi, occup_l

  use m_FFT,                    only : nfft, fft_box_size_WF, m_FFT_WF, &
       &                               m_FFT_alloc_WF_work, m_FFT_dealloc_WF_work

  use m_ValenceBand_Spectrum,  only : dipole_dxyz_us, m_VBS_find_ptrans_index_ek

  use m_Corelevel_Spectrum,   only : sw_corelevel_spectrum, atom_to_probe, &
       &                             e_low_cls => e_low, e_high_cls => e_high, &
       &                             e_step_cls => e_step, &
       &                             qnum_n_to_probe, qnum_l_to_probe, &
       &                             psir_core_ae_wfns, &
       &                             dipole_dxyz_core2val, &
       &                             m_CLS_chk_sw_corelevel_spectrum, &
       &                             m_CLS_rd_n_main, &
       &                             m_CLS_find_orb_index_to_probe, &
       &                             m_CLS_find_ptrans_indx_core2val, &
       &                             num_core_states, ene_core_states, &
       &                             psig_core_states, &
       &                             fsr_core_states, fsi_core_states, &
       &                             eshift_corelevel_virtual

  implicit none
  include 'mpif.h'

! -- General --
  character(len("excitation")), private,parameter :: tag_excitation = "excitation"
  character(len("sw_excitation")), private,parameter :: &
       &                              tag_sw_excitation = "sw_excitation"
!
!!!  integer :: sw_excitation = OFF

! --- G expansion --
  character(len("G_expansion")), private,parameter :: &
       &                    tag_G_expansion = "G_expansion"
  character(len("nmax_G")),private,parameter :: tag_nmax_G_given = "nmax_G"
  character(len("sw_spin_decomposition")), parameter ::  &
       &            tag_sw_spin_decomposition = "sw_spin_decomposition"
  character(len("sw_spin_decomp")), parameter ::  &
       &            tag_sw_spin_decomp = "sw_spin_decomp"

  integer :: nmax_G_given = 100
  integer :: sw_spin_decomposition = OFF
!
  integer :: nspin_m
  integer :: nmax_G, nmax_G_spin

! --- Momentum transfer --
  character(len("sw_longwavelimit")),private,parameter :: &
       &           tag_sw_longwavelimit = "sw_longwavelimit"
  integer :: sw_LongWaveLimit = ON
  real(kind=DP) :: qvec(3) = (/0.0d0, 0.0d0, 1.0d-3/)

! -- band gap correction ---
  character(len("band_gap_correction")), parameter :: &
       &                     tag_band_gap_correction = "band_gap_correction"
  character(len("scissor_operator")), parameter ::  tag_scissor  = "scissor_operator"
  character(len("sw_scissor_renormalization")), parameter         :: &
       &           tag_sw_scissor_renormalization   = "sw_scissor_renormalization"
!
  real(kind=DP) :: scissor = 0.0d0
  integer :: sw_scissor_renormalization = OFF

! -- transtion moment ( G=0, q-> 0 )
  real(kind=DP) :: delta_omega = 1.0D-14

! --- Brillouin zone integral
  character(len("BZ_integration")), parameter ::  &
       &                  tag_BZ_integration  = "BZ_integration"
  character(len("method")), parameter ::  tag_method = "method"
  character(len("gaussian")), parameter ::  tag_gaussian = "gaussian"
  character(len("lorentzian")), parameter ::  tag_lorentzian = "lorentzian"

  character(len("g")), parameter ::  tag_g = "g"
  character(len("l")), parameter ::  tag_l = "l"

  character(len("width")), parameter ::  tag_width = "width"
  character(len("extent")), parameter ::  tag_extent = "extent"

  integer, parameter :: GAUSSIAN_B = 1, LORENTZIAN_B = 2
  integer :: way_BZ_integral = GAUSSIAN_B

  real(kind=DP) :: width = 0.0183745D0              ! 0.5 eV
!  real(kind=DP) :: gaussian_extent = 3.893d0
  real(kind=DP) :: gaussian_extent = 4.00d0

! -- Energy range --
  character(len("energy_range")), parameter ::  tag_erange = "energy_range"
  character(len("e_low")), parameter ::  tag_elow = "e_low"
  character(len("e_high")), parameter ::  tag_ehigh = "e_high"
  character(len("e_step")), parameter ::  tag_estep = "e_step"

  integer :: nstep = 500
  real(kind=DP) :: e_low = 0.0d0, e_high = 1.0d0, e_step = 0.002d0

  real(kind=DP), allocatable :: e(:)

! -- Spectrum --
  character(len("spectrum")), parameter ::  tag_spectrum = "spectrum"
  character(len("type")), parameter ::  tag_type = "type"
  character(len("optics")), parameter ::  tag_optics = "optics"
  character(len("eels")), parameter ::  tag_eels = "eels"

  integer, parameter :: OPTICS = 1, EELS = 2

  integer :: spectrum_type = OPTICS
  integer :: sw_calc_epsilon_indep_only = ON

! --- WAVEDERF
  character(len("wavederf")), parameter :: &
       &                     tag_wavederf = "wavederf"
  character(len("sw_write_wavederf_file")), parameter :: &
       &                     tag_sw_write_wavederf_file = "sw_write_wavederf_file"
  character(len("sw_wavederf_full_bz")),private,parameter :: &
       &         tag_sw_wavederf_full_bz = "sw_wavederf_full_bz"
  character(len("split_wavederf_file")),private,parameter :: &
       &        tag_split_wavederf_file  = "split_wavederf_file"
  character(len("num_wavederf_files_once")),private,parameter :: &
       &        tag_num_wavederf_files_once  = "num_wavederf_files_once"
  character(len("wavederf_save_memory_mode")),private,parameter ::  &
       &        tag_wavederf_save_memory_mode  = "wavederf_save_memory_mode"
  character(len("wavederf_sort_kpt")),private,parameter ::  &
       &        tag_wavederf_sort_kpt  = "wavederf_sort_kpt"
  integer :: sw_write_wavederf_file = OFF
  integer :: sw_wavederf_full_bz = OFF
  integer :: split_wavederf_file = OFF
  integer :: num_wavederf_files_once = 8
  integer :: wavederf_save_memory_mode = 0
  integer :: wavederf_sort_kpt = OFF
!
  character(len("wavederf_window_width")),private,parameter ::  &
       &        tag_wavederf_window_width = "wavederf_window_width"
  real(kind=DP) :: wavederf_window_width = -99.0d0

! -- Interaction --
  complex(kind=CMPLDP), allocatable :: Kernel_Coulomb(:)

! -- LR-TDDFT --
  character(len("tddft")), parameter ::  tag_tddft = "tddft"
  character(len("sw_tddft")), parameter ::  tag_sw_tddft = "sw_tddft"
  character(len("sw_nlf")), parameter ::  tag_sw_nlf = "sw_nlf"

  character(len("xc_kernel")), parameter ::  tag_xc_kernel = "xc_kernel"
  character(len("rpa")), parameter ::  tag_rpa = "rpa"
  character(len("lrc")), parameter ::  tag_lrc = "lrc"
  character(len("lrc_scf")), parameter ::  tag_lrc_scf = "lrc_scf"
  character(len("alpha_lrc")), parameter ::  tag_alpha_lrc = "alpha_lrc"
  character(len("bootstrap")), parameter ::  tag_bootstrap = "bootstrap"

  integer :: sw_tddft = OFF
  integer :: sw_nlf = OFF

  integer, parameter :: RPA = 1, LRC = 5, LRC_scf = 6, BOOTSTRAP = 10
  integer :: kernel_xc_type = RPA
  real(kind=DP) :: alpha_LRC = 0.2d0

! -- MBPT Bethe-Salpeter --
  character(len("bse")), parameter ::  tag_bse = "bse"
  character(len("sw_bse")), parameter ::  tag_sw_bse = "sw_bse"

  integer :: sw_bse = OFF

  integer :: num_occ_bands, num_unocc_bands, matsize_bse, ista_matbse, iend_matbse
  complex(kind=CMPLDP), allocatable :: epsinv_omega0(:,:)
  complex(kind=CMPLDP), allocatable :: MatH_bse(:,:)

! -- variables --
! --
! valence <-> valence
!
  integer :: nqitg_XI_vv_sum
  integer, allocatable :: iqitg_XI_vv(:,:,:,:,:,:)
  integer, allocatable :: nqitg_XI_vv(:)
  real(kind=DP), allocatable :: qitg_XI_vv(:,:)
!
  integer, allocatable :: isph_XI_vv(:,:,:,:)
  integer, allocatable :: il2p_XI_vv(:,:,:)
  real(kind=DP), allocatable :: dl2p_XI_vv(:,:,:,:)
!
  real(kind=DP), allocatable :: Mat_dipole_corr_vv(:,:,:,:)
!
  complex(kind=CMPLDP), allocatable :: trm_vv(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: RhoTilde_vv(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: SpectrFn_vv(:,:,:)
  complex(kind=CMPLDP), allocatable :: SpectrTensor_vv(:,:,:,:)

! --
! core <-> valence
!
  integer :: nqitg_XI_vc
  integer, allocatable :: iqitg_XI_vc(:,:,:)
  real(kind=DP), allocatable :: qitg_XI_vc(:,:)
!
  integer, allocatable :: isph_XI_vc(:,:,:)
  integer, allocatable :: il2p_XI_vc(:,:)
  real(kind=DP), allocatable :: dl2p_XI_vc(:,:,:)
!
  real(kind=DP), allocatable :: Mat_dipole_corr_vc(:,:,:)

  complex(kind=CMPLDP), allocatable :: trm_vc(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: RhoTilde_vc(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: SpectrFn_vc(:,:,:)

! --
! core <-> core
!
  integer :: nqitg_XI_cc
  integer, allocatable :: iqitg_XI_cc(:,:,:)
  real(kind=DP), allocatable :: qitg_XI_cc(:,:)
!
  integer, allocatable :: isph_XI_cc(:,:,:)
  integer, allocatable :: il2p_XI_cc(:,:)
  real(kind=DP), allocatable :: dl2p_XI_cc(:,:,:)
!
  complex(kind=CMPLDP), allocatable :: trm_cc(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: RhoTilde_cc(:,:,:,:)

! symmetry
  integer, allocatable :: ngpt_XI(:,:)

! others
  integer :: nlmt_val, nlmt_core
  integer, allocatable :: ilmt_val(:)

  integer, parameter :: lcmax = 4
  integer :: ipriexcitation = 2
  integer :: imple_method = 1       ! 1 : like gpaw, 2 :like yambo
!
contains

! --------------------------------------------------------
!    Parameter setting  
! --------------------------------------------------------
  
  subroutine m_XI_read_input
    integer :: f_selectBlock, f_getStringValue, f_getRealValue, f_getIntValue
    integer :: f_selectParentBlock, f_selectTop
    
    integer :: iret
    real(kind=DP) :: dret
    character(len=FMAXVALLEN) :: rstr
    
    iret = f_selectTop()
    if( f_selectBlock( tag_excitation ) == 0 ) then
       
       if ( f_getIntValue( tag_sw_excitation, iret ) == 0 ) then
          sw_excitation = iret
          write(nfout,*)
          write(nfout,*) "!** XI: sw_excitation is set to ", iret
       endif
       if ( sw_excitation == OFF ) return
       !
       call m_CLS_chk_sw_corelevel_spectrum
       if ( sw_corelevel_spectrum == ON ) call m_CLS_rd_n_main
       
       ! ---
       call set_lr_tddft
       call set_mbpt_bse
       call set_nmax_G_for_expansion
       call set_scissor_operator
       call set_BZ_integration_method
       call set_energy_range
       call set_spectrum_type
       
       if ( f_selectBlock( tag_wavederf ) == 0 ) then
          if ( f_getIntValue( tag_sw_write_wavederf_file, iret ) == 0 ) then
             sw_write_wavederf_file = iret
             write(nfout,*) '!** sw_write_wavederf_file is set to ', iret
          endif
          if ( sw_write_wavederf_file == ON ) then
             if( f_getIntValue(tag_sw_wavederf_full_bz, iret) == 0) then
                sw_wavederf_full_bz = iret
                write(nfout,*) '!** sw_wavederf_full_bz is set to ', &
                     &          sw_wavederf_full_bz
             endif
             if( f_getIntValue(tag_wavederf_save_memory_mode, iret) == 0) then
                wavederf_save_memory_mode = iret
                write(nfout,*) '!** wavederf_save_memory_mode is set to ', &
                     &          wavederf_save_memory_mode
             endif
             if ( f_getIntValue( tag_split_wavederf_file, iret ) == 0 ) then
                split_wavederf_file = iret
                write(nfout,*) '!** split_wavederf_file is set to ', &
                     &          split_wavederf_file
             endif
             if ( f_getIntValue( tag_num_wavederf_files_once, iret ) == 0 ) then
                num_wavederf_files_once = iret
                write(nfout,*) '!** num_wavederf_files_once is set to ', &
                     &          num_wavederf_files_once
             endif
             if( f_getIntValue(tag_wavederf_sort_kpt, iret) == 0) then
                wavederf_sort_kpt = iret
                write(nfout,*) '!** wavederf_sort_kpt is set to ', &
                     &          wavederf_sort_kpt
             endif
             if( f_getRealValue(tag_wavederf_window_width, dret, "hartree" ) == 0) then
                wavederf_window_width = dret
                write(nfout,*) '!** wavederf_window_width is set to ', &
                     &          wavederf_window_width
             endif
          endif
!          write(nfout,*) "!** sw_use_add_proj is turned on"
!          sw_use_add_proj = ON
      endif
      iret = f_selectParentBlock()
   end if

  contains

    subroutine set_nmax_G_for_expansion
      integer :: f_getIntValue

      if ( f_selectBlock( tag_G_expansion ) == 0 ) then
         if ( f_getIntValue( tag_nmax_G_given, iret ) == 0 ) then
            if ( iret > 0 .and. iret < kg1 ) nmax_G_given = iret
         endif
         if ( f_getIntValue( tag_sw_spin_decomposition, iret ) == 0 ) then
            sw_spin_decomposition = iret
         endif
         if ( f_getIntValue( tag_sw_spin_decomp, iret ) == 0 ) then
            sw_spin_decomposition = iret
         endif

         iret = f_selectParentBlock()      
      endif
      write(nfout,*) "!** XI: sw_spin_decomp is set to ", sw_spin_decomposition
    end subroutine set_nmax_G_for_expansion

    subroutine set_scissor_operator
      integer :: f_getRealValue

      if ( f_selectBlock( tag_band_gap_correction ) == 0 ) then
         if ( f_getRealValue( tag_scissor, dret, 'hartree' ) == 0 ) then
            scissor = dret
         endif
         if ( f_getIntValue( tag_sw_scissor_renormalization, iret ) == 0 ) then
            sw_scissor_renormalization = iret
         endif
         iret = f_selectParentBlock()      
      endif
      write(nfout,*) "!** XI: scissor operator is set to ", scissor
      write(nfout,*) "!** XI: sw_scissor_renormalization is set to ", sw_scissor_renormalization
    end subroutine set_scissor_operator

    subroutine set_BZ_integration_method
      integer :: f_getRealValue, f_getStringValue
      logical :: tf

      if ( f_selectBlock(tag_BZ_integration) == 0 ) then
         if ( f_getStringValue( tag_method, rstr, LOWER ) == 0 ) then
            call strncmp0( tag_gaussian, trim(rstr), tf)
            if (tf) way_BZ_integral = Gaussian_B
            call strncmp0( tag_g, trim(rstr), tf)
            if (tf) way_BZ_integral = Gaussian_B

            call strncmp0( tag_lorentzian, trim(rstr), tf)
            if (tf) way_BZ_integral = Lorentzian_B
            call strncmp0( tag_l, trim(rstr), tf)
            if (tf) way_BZ_integral = Lorentzian_B
         endif

         if( f_getRealValue( tag_width, dret, 'hartree' ) == 0) then
            if ( dret > 0.0 ) width = dret
         endif
         if( f_getRealValue( tag_extent, dret, '' ) == 0) then
            if ( dret > 2.0 ) gaussian_extent = dret
         endif
         iret = f_selectParentBlock()      
      end if

      write(nfout,*) "!** XI: BZ integration method is set to ", way_BZ_integral
      write(nfout,*) "!** XI: width is set to ", width
      if ( way_BZ_integral == Gaussian_B ) then
         write(nfout,*) "!** XI: gaussian_extent is set to ", gaussian_extent
      endif

    end subroutine set_BZ_integration_method

    subroutine set_energy_range
      integer :: f_getRealValue

       if ( sw_corelevel_spectrum == ON ) then
          e_low  = e_low_CLS
          e_high = e_high_CLS
          e_step = e_step_CLS
       endif

      if ( f_selectBlock( tag_erange ) == 0 ) then
         if( f_getRealValue( tag_elow, dret, 'hartree' ) == 0) then
            if ( dret > 0.0 ) e_low = dret
         endif
         if( f_getRealValue( tag_ehigh, dret,'hartree' ) == 0) then
            if ( dret > 0.0 .and. dret > e_low ) e_high = dret
         endif
         if( f_getRealValue( tag_estep, dret,'hartree' ) == 0) then
            if ( dret > 0.0 ) e_step = dret
         endif
         iret = f_selectParentBlock()
       end if

       write(nfout,*) "!** XI: e_low  is ", e_low
       write(nfout,*) "!** XI: e_high is ", e_high
       write(nfout,*) "!** XI: e_step is ", e_step

       nstep = nint( ( e_high -e_low ) /e_step )

       write(nfout,*) "!** XI: number of energy steps is ", nstep

    end subroutine set_energy_range

    subroutine set_lr_tddft
      integer :: f_getIntValue, f_getStringValue, f_getRealValue
      logical :: tf

      if ( f_selectBlock( tag_tddft ) == 0 ) then
         if ( f_getIntValue( tag_sw_tddft, iret ) == 0 ) then
            sw_tddft = iret
         endif
         if ( f_getIntValue( tag_sw_nlf, iret ) == 0 ) then
            sw_nlf = iret
         endif
         if ( f_getStringValue( tag_xc_kernel, rstr, LOWER ) == 0 ) then
            call strncmp0( tag_rpa, trim(rstr), tf)
            if (tf) kernel_xc_type = RPA

            if (len_trim(rstr) == len_trim(tag_lrc_scf) ) then
               call strncmp0( tag_lrc_scf, trim(rstr), tf)
               if (tf) kernel_xc_type = LRC_scf
            endif

            if (len_trim(rstr) == len_trim(tag_lrc) ) then
               call strncmp0( tag_lrc, trim(rstr), tf)
               if (tf) kernel_xc_type = LRC
            endif

            call strncmp0( tag_bootstrap, trim(rstr), tf)
            if (tf) kernel_xc_type = BOOTSTRAP
         endif

100      continue

         if( f_getRealValue( tag_alpha_lrc, dret,'' ) == 0) then
            alpha_lrc = dret
         endif

         write(nfout,*) "!** XI: sw_tddft is ", sw_tddft
         if ( sw_tddft == ON ) then
            write(nfout,*) "!** XI: sw_nlf   is ", sw_nlf
            write(nfout,*) "!** XI: kernel_xc_type is ", kernel_xc_type
            if ( kernel_xc_type == LRC ) then
               write(nfout,*) "!** XI: alpha_LRC is ", alpha_LRC
            endif
         endif

         if ( sw_tddft == ON ) sw_calc_epsilon_indep_only = OFF

         iret = f_selectParentBlock()      
      endif
    end subroutine set_lr_tddft

    subroutine set_mbpt_bse
      integer :: f_getIntValue

      if ( f_selectBlock( tag_bse ) == 0 ) then
         if ( f_getIntValue( tag_sw_bse, iret ) == 0 ) then
            sw_bse = iret
         endif

         write(nfout,*) "!** XI: sw_bse is ", sw_bse
         if ( sw_bse == ON ) sw_calc_epsilon_indep_only = OFF

         iret = f_selectParentBlock()      
      endif
    end subroutine set_mbpt_bse

    subroutine set_spectrum_type
      integer :: f_getIntValue, f_getStringValue
      logical :: tf

      if ( f_selectBlock( tag_spectrum ) == 0 ) then
         if ( f_getStringValue( tag_type, rstr, LOWER ) == 0 ) then
            call strncmp0( tag_optics, trim(rstr), tf)
            if (tf) spectrum_type = OPTICS

            call strncmp0( tag_eels, trim(rstr), tf)
            if (tf) spectrum_type = EELS
         endif
         iret = f_selectParentBlock()      
      end if

      write(nfout,*) "!** XI: Spectrum type is set to ", spectrum_type

    end subroutine set_spectrum_type

  end subroutine m_XI_read_input

!  subroutine m_XI_set_value_nmax_G( nmax_G_given, nmax_G )
  subroutine m_XI_set_value_nmax_G
!    integer, intent(in) :: nmax_G_given
!    integer, intent(out) :: nmax_G
    
    integer :: i, count, ispin
    real(kind=DP) :: g1, g1_prev, dg
    
    if ( sw_spin_decomposition == ON ) then
       nspin_m = nspin
    else
       nspin_m = 1
    endif

    if ( sw_calc_epsilon_indep_only == ON ) then
       nmax_G = 1;  nmax_G_spin = nspin_m;  return
    endif

    count = 0
    do i = 1, kgp
       g1 = dsqrt( ttr(1)*ngabc(i,1)*ngabc(i,1) &
            &             + ttr(2)*ngabc(i,2)*ngabc(i,2) &
            &             + ttr(3)*ngabc(i,3)*ngabc(i,3) &
            &             + ttr(4)*ngabc(i,1)*ngabc(i,2) &
            &             + ttr(5)*ngabc(i,2)*ngabc(i,3) &
            &             + ttr(6)*ngabc(i,3)*ngabc(i,1))
       dg = abs( g1 -g1_prev )
       if ( dg < 1.0D-5 ) then
          count = count +1
       else
          if ( count > nmax_G_given ) exit
          count = count +1
       end if
       g1_prev = g1
    enddo
    nmax_G = count
    nmax_G_spin = nmax_G *nspin_m

    write(nfout,*) 
    write(nfout,*) "!** XI: nmax_G is set to ", nmax_G
    write(nfout,*) 

  end subroutine m_XI_set_value_nmax_G

! --------------------------------------------------------
!    Preparation of arrays for treating wfns
! --------------------------------------------------------

  subroutine m_XI_set_ilmt_val
    integer :: it

    allocate( ilmt_val(ntyp) )

    if ( sw_use_add_proj == ON ) then
       nlmt_val = nlmt +nlmt_add
       Do it=1, ntyp
          ilmt_val(it) = ilmt(it) +ilmt_add(it)
       End do
    else
       nlmt_val = nlmt
       Do it=1, ntyp
          ilmt_val(it) = ilmt(it)
       End do
    endif

  end subroutine m_XI_set_ilmt_val

  subroutine m_XI_set_ilmt_core
    nlmt_core = 2 *qnum_l_to_probe +1
  end subroutine m_XI_set_ilmt_core

  subroutine m_XI_set_ngpt_XI
    integer, allocatable :: ngpt_wk(:,:), ngpt_wk2(:,:)

    integer :: i

    allocate( ngpt_XI( nmax_G, nopr) ); ngpt_XI = 0

    if ( npes > 1 ) then
       allocate( ngpt_wk( kgp,nopr) ); ngpt_wk  = 0
       allocate( ngpt_wk2(kgp,nopr) ); ngpt_wk2 = 0
       ngpt_wk(ista_kngp:iend_kngp,:) = ngpt_l(ista_kngp:iend_kngp,:)

       call mpi_allreduce( ngpt_wk, ngpt_wk2, kgp*nopr, mpi_integer, mpi_sum, &
            &              mpi_comm_group, ierr )
       ngpt_XI( 1:nmax_G, 1:nopr ) = ngpt_wk2( 1:nmax_G, 1:nopr )
       deallocate( ngpt_wk ); deallocate( ngpt_wk2 )
    else
       ngpt_XI( 1:nmax_G, 1:nopr ) = ngpt_l( 1:nmax_G, 1:nopr )
    endif

  end subroutine m_XI_set_ngpt_XI

! --------------------------------------------------------
!    Preparation of arrays for transtion moments (val-val)
! --------------------------------------------------------

  subroutine m_XI_set_qitg_XI_vv
    allocate( nqitg_XI_vv(ntyp) ); nqitg_XI_vv = 0
    call set_size_qitg_XI_vv

    if ( ipriexcitation >=2 ) then
       write(nfout,*) '!** XI: nqitg_XI_vv_sum  = ',nqitg_XI_vv_sum
    endif

    allocate( iqitg_XI_vv( nloc, ntau, nloc, ntau, nloc**2, ntyp ) )
    allocate( qitg_XI_vv( nmax_G, nqitg_XI_vv_sum ) )
    iqitg_XI_vv = 0;  qitg_XI_vv = 0.0d0

    call set_array_qitg_XI_vv

  contains

    subroutine set_size_qitg_XI_vv
      integer :: it, il1, il2, tau1, tau2, tmin
      integer :: l3s, l3l, il3, mm_sum, mm

      mm_sum = 0

      Do it=1, ntyp
         mm = 0

         Loop_L1 : do il1 = 1, lpsmax(it)
            Loop_tau1 : do tau1 = 1, itau(il1,it)

               Loop_L2 : do il2 = il1, lpsmax(it)
                  tmin = 1
                  if(il1 == il2) tmin = tau1

                  Loop_tau2 : do tau2 = tmin, itau(il2,it)
                     l3s = abs(il1-il2); l3l = abs(il1+il2) - 2

                     Loop_L3 : do il3 = l3s+1, l3l+1, 2
                        if(il3-1 > lcmax ) cycle
                        mm = mm +1
                     End do Loop_L3

                  End do Loop_tau2
               End do Loop_L2

            End do Loop_tau1
         End do Loop_L1

         nqitg_XI_vv(it) = mm
         mm_sum = mm_sum +mm
      end Do

      nqitg_XI_vv_sum = mm_sum

    end subroutine set_size_qitg_XI_vv

    subroutine set_array_qitg_XI_vv
      integer :: it, il1, il2, tau1, tau2, tmin
      integer :: l3s, l3l, il3, mm_sum, mm
      integer :: i, ir

      real(kind=DP), allocatable :: qrs(:), gr_XI(:), wkx(:), wky(:)

      allocate( qrs( mmesh ) ); qrs = 0.d0
      allocate( wkx( mmesh ) ); wkx = 0.0d0
      allocate( wky( mmesh ) ); wky = 0.0d0
      allocate( gr_XI(nmax_G) ); gr_XI = 0.0d0

      allocate( radr(mmesh) );  allocate( wos(mmesh) )

      do i = 1, nmax_G
         gr_XI(i) =      dsqrt(ttr(1)*ngabc(i,1)*ngabc(i,1) &
              &             + ttr(2)*ngabc(i,2)*ngabc(i,2) &
              &             + ttr(3)*ngabc(i,3)*ngabc(i,3) &
              &             + ttr(4)*ngabc(i,1)*ngabc(i,2) &
              &             + ttr(5)*ngabc(i,2)*ngabc(i,3) &
              &             + ttr(6)*ngabc(i,3)*ngabc(i,1))
      enddo

      mm = 0
      Do it=1, ntyp
         call new_radr_and_wos(ista_k,it)

         Loop_L1 : do il1 = 1, lpsmax(it)
            Loop_tau1 : do tau1 = 1, itau(il1,it)

               Loop_L2 : do il2 = il1, lpsmax(it)
                  tmin = 1
                  if (il1 == il2) tmin = tau1

                  Loop_tau2 : do tau2 = tmin, itau(il2,it)
                     l3s = abs(il1-il2);  l3l = abs(il1+il2) - 2

                     Loop_L3 : do il3 = l3s+1, l3l+1, 2
                        if(il3-1 > lcmax ) cycle
                        mm = mm +1
                        iqitg_XI_vv( il1, tau1, il2, tau2, il3, it ) = mm
                        iqitg_XI_vv( il2, tau2, il1, tau1, il3, it ) = mm  !! ??

                        qrs = 0.0d0
                        Do ir=1, nmesh(it)
                           qrs( ir ) &
                                &   = ( psirpw(ir,il1,tau1,it) *psirpw(ir,il2,tau2,it) &
                                &     - phirpw(ir,il1,tau1,it) *phirpw(ir,il2,tau2,it) )
                        End do

                        call qitgft( 1, nmax_G, mmesh, nqitg_XI_vv_sum, nmesh(it), &
                             &       ipriexcitation, nfout, il3-1, radr, wos, &
                             &       qrs, gr_XI, &
                             &       1.d0, mm, qitg_XI_vv, wkx, wky )

                     End do Loop_L3

                  End do Loop_tau2
               End do Loop_L2

            End do Loop_tau1
         End do Loop_L1
      End Do

      deallocate( radr ); deallocate( wos );  deallocate( wkx ); deallocate( wky )
      deallocate( qrs ); deallocate( gr_XI )

    end subroutine set_array_qitg_XI_vv

  end subroutine m_XI_set_qitg_XI_vv

  subroutine m_XI_set_dl2p_XI_vv
    integer :: it, lmt1, lmt2, il1, im1, il2, im2, itmp
    integer :: nspher1, nspher2, n

    integer, allocatable :: isph2(:,:,:), mmt2(:,:)
    real(kind=DP), allocatable :: cr2(:,:,:)

    allocate( isph_XI_vv( nlmt_val, nlmt_val, 6, ntyp )); isph_XI_vv = 0
    allocate( il2p_XI_vv( nlmt_val, nlmt_val, ntyp ) );   il2p_XI_vv = 0
    allocate( dl2p_XI_vv( nlmt_val, nlmt_val, 6, ntyp));  dl2p_XI_vv = 0

    allocate( cr2(  16,16,6) ); cr2 = 0.0d0
    allocate( isph2(16,16,6) ); isph2 = 0.0d0
    allocate( mmt2( 16,16)   ); mmt2 = 0

    call sphset2( nfout, ipri, lcmax, cr2, isph2, mmt2 )

    Do it=1, ntyp
       Do lmt1=1, ilmt_val(it)
          if ( lmt1 <= ilmt(it) ) then
             il1 = ltp(lmt1,it);  im1 = mtp(lmt1,it)
          else
             itmp = lmt1 -ilmt(it)
             il1 = ltp_add(itmp,it);  im1 = mtp_add(itmp,it)
          endif
          nspher1 = ( il1 -1 )**2 +im1

          Do lmt2=1, ilmt_val(it)
             if ( lmt2 <= ilmt(it) ) then
                il2 = ltp(lmt2,it);  im2 = mtp(lmt2,it)
             else
                itmp = lmt2 -ilmt(it)
                il2 = ltp_add(itmp,it);  im2 = mtp_add(itmp,it)
             endif
             nspher2 = ( il2 -1 )**2 +im2

             il2p_XI_vv( lmt1, lmt2, it ) = mmt2( nspher1, nspher2 )
             Do n=1, il2p_XI_vv(lmt1,lmt2,it)
                isph_XI_vv( lmt1, lmt2, n, it ) = isph2( nspher1, nspher2, n )
                dl2p_XI_vv( lmt1, lmt2, n, it ) = cr2  ( nspher1, nspher2, n )
             End do
          End Do
       End Do
    End Do

  end subroutine m_XI_set_dl2p_XI_vv

  subroutine m_XI_set_mat_dipole_corr_vv
    integer :: it, lmt1, lmt2, il1, il2, im1, im2, tau1, tau2
    integer :: nspher1, nspher2, itmp, ifact, index

    allocate( Mat_Dipole_corr_vv( ntyp, nlmt_val, nlmt_val, 3 ) )
    Mat_Dipole_corr_vv = 0.0d0

    Do it=1, ntyp
       Do lmt1=1, ilmt_val(it)
          if ( lmt1 <= ilmt(it) ) then
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it); tau1 = taup(lmt1,it)
          else
             itmp = lmt1 -ilmt(it)
             il1 = ltp_add(itmp,it); im1 = mtp_add(itmp,it);  tau1 = 1
          endif
          nspher1 = ( il1 -1 )**2 +im1

          Do lmt2=1, ilmt_val(it)
             if ( lmt2 <= ilmt(it) ) then
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it); tau2 = taup(lmt2,it)
             else
                itmp = lmt2 -ilmt(it)
                il2 = ltp_add(itmp,it); im2 = mtp_add(itmp,it);  tau2 = 1
             endif
             nspher2 = ( il2 -1 )**2 +im2

             call m_VBS_find_ptrans_index_ek( it, nspher1, nspher2, tau1, tau2, &
                  &                           index, ifact )

             if ( index /= 0 ) then
                Mat_Dipole_Corr_vv( it, lmt1, lmt2, 1:3 ) &
                     &      = dipole_dxyz_us( it, index, 1:3 ) *ifact
             endif
          End do
       End Do
    End Do

  end subroutine m_XI_set_mat_dipole_corr_vv

! --------------------------------------------------------
!    Preparation of arrays for transtion moments (val-core)
! --------------------------------------------------------

  subroutine m_XI_set_qitg_XI_vc
    nqitg_XI_vc = 0
    call set_size_qitg_XI_vc

    if ( ipriexcitation >= 2 ) then
       write(nfout,*) '** nqitg_XI_vc_sum  = ',nqitg_XI_vc
    endif

    allocate( iqitg_XI_vc( nloc, ntau, nloc**2 ) )
    allocate( qitg_XI_vc( nmax_G, nqitg_XI_vc ) )

    iqitg_XI_vc = 0;  qitg_XI_vc = 0.0d0

    call set_array_qitg_XI_vc

  contains

    subroutine set_size_qitg_XI_vc
      integer :: mm_sum, mm
      integer :: it, il1, il2, tau1, tau2, tmin
      integer :: l3s, l3l, il3, atomtype_to_probe

      mm_sum = 0

      atomtype_to_probe = ityp( atom_to_probe )

      Do it = atomtype_to_probe, atomtype_to_probe
         mm = 0

         Loop_L1 : do il1 = 1, lpsmax(it)
            Loop_tau1 : do tau1 = 1, itau(il1,it)

               Loop_L2 : do il2 = qnum_l_to_probe+1, qnum_l_to_probe+1
                  tmin = 1
                  if(il1 == il2) tmin = tau1

                  Loop_tau2 : do tau2 = 1, 1
                     l3s = abs(il1-il2); l3l = abs(il1+il2) - 2

                     Loop_L3 : do il3 = l3s+1, l3l+1, 2
                        if(il3-1 > lcmax ) cycle
                        mm = mm +1
                     End do Loop_L3

                  End do Loop_tau2
               End do Loop_L2

            End do Loop_tau1
         End do Loop_L1

         nqitg_XI_vc = mm
         mm_sum = mm_sum +mm
      end Do

!      nqitg_XI_vc_sum = mm_sum

    end subroutine set_size_qitg_XI_vc

    subroutine set_array_qitg_XI_vc
      integer :: mm_sum, mm
      integer :: it, il1, il2, tau1, tau2, tmin
      integer :: l3s, l3l, il3
      integer :: i, ir, orb_index, atomtype_to_probe

      real(kind=DP), allocatable :: qrs(:), gr_XI(:), wkx(:), wky(:)

      allocate( qrs( mmesh ) ); qrs = 0.d0
      allocate( wkx( mmesh ) ); wkx = 0.0d0
      allocate( wky( mmesh ) ); wky = 0.0d0
      allocate( gr_XI(nmax_G) ); gr_XI = 0.0d0

      allocate( radr(mmesh) );  allocate( wos(mmesh) )

      do i = 1, nmax_G
         gr_XI(i) =      dsqrt(ttr(1)*ngabc(i,1)*ngabc(i,1) &
              &             + ttr(2)*ngabc(i,2)*ngabc(i,2) &
              &             + ttr(3)*ngabc(i,3)*ngabc(i,3) &
              &             + ttr(4)*ngabc(i,1)*ngabc(i,2) &
              &             + ttr(5)*ngabc(i,2)*ngabc(i,3) &
              &             + ttr(6)*ngabc(i,3)*ngabc(i,1))
      enddo

!      write(*,*) "psircore", allocated( psir_core_ae_wfns )

      orb_index = m_CLS_find_orb_index_to_probe()

      mm = 0

      atomtype_to_probe = ityp( atom_to_probe )

      Do it = atomtype_to_probe, atomtype_to_probe
         call new_radr_and_wos(ista_k,it)

         Loop_L1 : do il1 = 1, lpsmax(it)
            Loop_tau1 : do tau1 = 1, itau(il1,it)

               Loop_L2 : do il2 = qnum_l_to_probe+1, qnum_l_to_probe+1
                  tmin = 1
                  if (il1 == il2) tmin = tau1

                  Loop_tau2 : do tau2 = 1, 1
                     l3s = abs(il1-il2);  l3l = abs(il1+il2) - 2

                     Loop_L3 : do il3 = l3s+1, l3l+1, 2
                        if(il3-1 > lcmax ) cycle
                        mm = mm +1
                        iqitg_XI_vc( il1, tau1, il3 ) = mm

                        qrs = 0.0d0
                        Do ir=1, nmesh(it)
                           qrs( ir ) &
                                &   =  (  psirpw(ir,il1,tau1,it) &
                                &        -phirpw(ir,il1,tau1,it) ) &
                                &          *psir_core_ae_wfns(ir,orb_index)
                        End do

                        call qitgft( 1, nmax_G, mmesh, nqitg_XI_vc, nmesh(it), &
                             &       ipriexcitation, nfout, il3-1, radr, wos, &
                             &       qrs, gr_XI, &
                             &       1.d0, mm, qitg_XI_vc, wkx, wky )

                     End do Loop_L3

                  End do Loop_tau2
               End do Loop_L2

            End do Loop_tau1
         End do Loop_L1
      End Do

      deallocate( radr ); deallocate( wos );  deallocate( wkx ); deallocate( wky )
      deallocate( qrs ); deallocate( gr_XI )

    end subroutine set_array_qitg_XI_vc

  end subroutine m_XI_set_qitg_XI_vc

  subroutine m_XI_set_dl2p_XI_vc
    integer :: it, lmt1, lmt2, il1, im1, il2, im2, itmp
    integer :: nspher1, nspher2, n, atomtype_to_probe

    integer, allocatable :: isph2(:,:,:), mmt2(:,:)
    real(kind=DP), allocatable :: cr2(:,:,:)

    allocate( isph_XI_vc( nlmt_val, nlmt_core, 6 )); isph_XI_vc = 0
    allocate( il2p_XI_vc( nlmt_val, nlmt_core ) );   il2p_XI_vc = 0
    allocate( dl2p_XI_vc( nlmt_val, nlmt_core, 6 )); dl2p_XI_vc = 0

    allocate( cr2(  16,16,6) ); cr2 = 0.0d0
    allocate( isph2(16,16,6) ); isph2 = 0.0d0
    allocate( mmt2( 16,16)   ); mmt2 = 0

    call sphset2( nfout, ipri, lcmax, cr2, isph2, mmt2 )

    atomtype_to_probe = ityp( atom_to_probe )

    Do it = atomtype_to_probe, atomtype_to_probe
       Do lmt1=1, ilmt_val(it)
          if ( lmt1 <= ilmt(it) ) then
             il1 = ltp(lmt1,it);  im1 = mtp(lmt1,it)
          else
             itmp = lmt1 -ilmt(it)
             il1 = ltp_add(itmp,it);  im1 = mtp_add(itmp,it)
          endif
          nspher1 = ( il1 -1 )**2 +im1

          Do lmt2=1, nlmt_core
             il2 = qnum_l_to_probe +1;  im2 = lmt2
             nspher2 = ( il2 -1 )**2 +im2

             il2p_XI_vc( lmt1, lmt2 ) = mmt2( nspher1, nspher2 )
             Do n=1, il2p_XI_vc(lmt1,lmt2)
                isph_XI_vc( lmt1, lmt2, n ) = isph2( nspher1, nspher2, n )
                dl2p_XI_vc( lmt1, lmt2, n ) = cr2  ( nspher1, nspher2, n )
             End do
          End Do
       End Do
    End Do

  end subroutine m_XI_set_dl2p_XI_vc

  subroutine m_XI_set_mat_dipole_corr_vc
    integer :: it, lmt1, lmt2, il1, il2, im1, im2, tau1, tau2
    integer :: nspher1, nspher2, itmp, ifact, index, atomtype_to_probe

    allocate( Mat_Dipole_corr_vc( nlmt_val, nlmt_core, 3 ) )
    Mat_Dipole_corr_vc = 0.0d0

    atomtype_to_probe = ityp( atom_to_probe )

    Do it = atomtype_to_probe, atomtype_to_probe
       Do lmt1=1, ilmt_val(it)
          if ( lmt1 <= ilmt(it) ) then
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it); tau1 = taup(lmt1,it)
          else
             itmp = lmt1 -ilmt(it)
             il1 = ltp_add(itmp,it); im1 = mtp_add(itmp,it);  tau1 = 1
          endif
          nspher1 = ( il1 -1 )**2 +im1

          Do lmt2=1, nlmt_core
             il2 = qnum_l_to_probe +1;  im2 = lmt2;  tau2 = 1
             nspher2 = ( il2 -1 )**2 +im2

             call m_CLS_find_ptrans_indx_core2val( qnum_n_to_probe, nspher2, nspher1, &
                  &                                tau1, index )
             ifact = -1

             if ( index /= 0 ) then
                Mat_Dipole_Corr_vc( lmt1, lmt2, 1:3 ) &
                     &      = dipole_dxyz_core2val( index, 1:3 ) *dble(ifact)
             endif
          End do
       End Do
    End Do

  end subroutine m_XI_set_mat_dipole_corr_vc

! --------------------------------------------------------
!    Calculation of transtion moment/matrix (val-val)
! --------------------------------------------------------

  subroutine m_XI_wd_WAVEDERF
    use m_IterationNumbers, only : nk_in_the_process
    use m_Control_Parameters, only : ekmode
    use m_Kpoints, only : m_Kp_set_star_of_k, kv3_ek
    use m_CS_Magnetic,   only : m_CS_set_inverse_operation, invop, magmom_dir_inversion_opr_flag

    integer :: ib_min, ib_max, ib_num

    if ( allocated( trm_vv ) ) deallocate( trm_vv )
    allocate( trm_vv( np_e, neg, ista_k:iend_k, 3 ) );   trm_vv = 0.0d0

    call set_ib_min_max

    call calc_soft_part
    call calc_hard_part

    if ( sw_wavederf_full_bz == ON ) call m_Kp_set_star_of_k
    if ( noncol ) then
       if ( split_wavederf_file == YES ) then
          call print_wavederf_noncl_split
       else
          select case (wavederf_save_memory_mode)
          case (0)
             if ( sw_wavederf_full_BZ == ON .and. wavederf_sort_kpt == ON  ) then
                call print_wavederf_noncl_fbz_sort
             else
                call print_wavederf_noncl
             endif
          case (1)
             call print_wavederf_noncl2
          end select
       endif
    else
       if ( split_wavederf_file == YES ) then
          call print_wavederf_col_split
       else
          select case (wavederf_save_memory_mode)
          case (0)
             if ( sw_wavederf_full_BZ == ON .and. wavederf_sort_kpt == ON  ) then
                call print_wavederf_col_fbz_sort
             else
                call print_wavederf_col
             endif
          case (1)
             call print_wavederf_col2
          end select
       endif
    endif
    deallocate( trm_vv )

  contains

    subroutine set_ib_min_max
      integer :: ik, ib, ierr
      real(kind=DP) :: emin, emax, ene

      ib_min = 1;   ib_max = neg
      ib_num = ib_max -ib_min +1

      if ( wavederf_window_width < 0.0 ) return

      ib_min = neg;   ib_max = 1
      emin = efermi -wavederf_window_width /2.0d0
      emax = efermi +wavederf_window_width /2.0d0

      Do ik=ista_k, iend_k
         Do ib=ista_e, iend_e, istep_e
            ene = eko_l( map_z(ib),ik )
            if ( ene >= emin .and. ene <=emax ) then
               ib_min = min( ib, ib_min )
               ib_max = max( ib, ib_max )
            endif
         End Do
      End Do
      call mpi_allreduce( mpi_in_place, ib_min, 1, mpi_integer, &
           &              mpi_min, mpi_comm_group, ierr )
      call mpi_allreduce( mpi_in_place, ib_max, 1, mpi_integer, &
           &              mpi_max, mpi_comm_group, ierr )

      ib_num = ib_max -ib_min +1

    end subroutine set_ib_min_max

    subroutine print_wavederf_col_split
      integer :: ik, is, ib1, ib2
      integer :: lun
      integer :: trev, iopr, i, j, nr, ii, jk, num
      real(kind=DP) :: occ1, occ2, weight
      real(kind=DP), allocatable :: eko_wk(:,:), occ_wk(:,:), eko_mpi(:,:), occ_mpi(:,:)
      complex(kind=CMPLDP), allocatable :: zwk(:,:,:,:), zwk_mpi(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk2(:,:,:)
      complex(kind=CMPLDP) :: zvec(3), zvec_rot(3)
      character*4 char1
      character*72 file0, file1

      integer istatus(mpi_status_size)

      allocate( eko_wk( neg,ista_k:iend_k ) ); eko_wk = 0.0d0
      allocate( occ_wk( neg,ista_k:iend_k ) ); occ_wk = 0.0d0

      Do ik=ista_k, iend_k
         Do ib1=ista_e, iend_e, istep_e
            eko_wk(ib1,ik) = eko_l( map_z(ib1),ik )
            occ_wk(ib1,ik) = occup_l( map_z(ib1),ik )
         End do
      End Do
      if ( nrank_e > 1 ) then
         allocate( eko_mpi( neg,ista_k:iend_k ) ); eko_mpi = 0.0d0
         call mpi_allreduce( eko_wk, eko_mpi, neg*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         eko_wk = eko_mpi
         deallocate( eko_mpi )
         allocate( occ_mpi( neg,ista_k:iend_k ) ); occ_mpi = 0.0d0
         call mpi_allreduce( occ_wk, occ_mpi, neg*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         occ_wk = occ_mpi
         deallocate( occ_mpi )
      endif
      
      allocate( zwk( neg, neg, 3, ista_k:iend_k ) );   zwk = 0.0d0

      Do ik=ista_k, iend_k
         Do ib1=ista_e, iend_e, istep_e
            zwk( ib1, 1:neg, 1:3, ik ) &
                 &  = trm_vv( map_z(ib1), 1:neg, ik, 1:3 ) *(-zi)
         End Do
      End Do
      if ( nrank_e > 1 ) then
         allocate( zwk_mpi( neg, neg, 3, ista_k:iend_k ) ); zwk_mpi = 0.0d0
         call mpi_allreduce( zwk, zwk_mpi, neg*neg*3*2*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         zwk = zwk_mpi
         deallocate( zwk_mpi )
      endif

      lun = 10000 +myrank_k
      write(char1,'(I4.4)') myrank_k

      nr = nrank_k /num_wavederf_files_once +1
      num = 0

      iloop: Do i=1, nr
         Do j=1, num_wavederf_files_once
            num = num +1
            if ( num > npes )    goto 200
            if ( num /= myrank_k +1 ) cycle
            if ( myrank_e /= 0 )   cycle
            
            Do is=1, nspin
               if ( nspin == 1 ) then
                  file0 = "WAVEDERF_phase"
               else 
                  if ( is == 1 ) then
                     file0 = "WAVEDERF_phase.up"
                  else
                     file0 = "WAVEDERF_phase.dn"
                  endif
               endif

               file1 = trim(adjustl(file0)) // '.' // char1
               if ( myrank_e == 0 ) then
                  open( lun, file=file1, status="unknown", form="formatted" )
               endif

               if ( mype == 0 .and. is == 1 ) then
                  if ( sw_wavederf_full_bz == ON ) then
                     write(lun,*) nspin, kv3_fbz/nspin, ib_num
                  else
                     write(lun,*) nspin, kv3/nspin, ib_num
                  endif
               endif

               ikloop1: Do ik=ista_k+is-1, iend_k, nspin

                  if ( sw_wavederf_full_bz == ON ) then
                     weight = kv3 *qwgt(ik) /dble(ndim_spinor)
                     
                     Do ii=1, num_star_of_k(ik)
                        jk = star_of_k(ik,ii)
                        iopr = iopr_k_fbz_to_ibz(jk)
                        trev = trev_k_fbz_to_ibz(jk)
                        
                        Do ib1=ib_min, ib_max
                           Do ib2=ib_min, ib_max
                              occ1 = occ_wk(ib1,ik) / weight
                              occ2 = occ_wk(ib2,ik) / weight
                              zvec(1) = zwk(ib1,ib2,1,ik)
                              zvec(2) = zwk(ib1,ib2,2,ik)
                              zvec(3) = zwk(ib1,ib2,3,ik)
                              
                              zvec_rot = matmul( op(:,:,invop(iopr)), zvec(:) ) 

                              if ( trev == 1 ) zvec_rot = conjg( zvec_rot )
#if 1
                              if ( allocated(magmom_dir_inversion_opr_flag) ) then
                                 if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) then
                                    zvec_rot = -conjg(zvec_rot)
                                 endif
                              endif
#endif                              
                              write(lun,'(I5,2F15.8,I5,2F15.8,6F20.14)') &
                                   &    ib1, ( eko_wk(ib1,ik)-efermi )*Hartree, occ1, &
                                   &    ib2, ( eko_wk(ib2,ik)-efermi )*Hartree, occ2, &
                                   &    real(zvec_rot(1)), aimag(zvec_rot(1)), &
                                   &    real(zvec_rot(2)), aimag(zvec_rot(2)), &
                                   &    real(zvec_rot(3)), aimag(zvec_rot(3))
                           End Do
                        End Do
                     End Do
                  else
                     weight = kv3 *qwgt(ik) /dble(ndim_spinor)
                     Do ib1=ib_min, ib_max
                        Do ib2=ib_min, ib_max
                           occ1 = occ_wk(ib1,ik) / weight
                           occ2 = occ_wk(ib2,ik) / weight
                           zvec(1) = zwk(ib1,ib2,1,ik)
                           zvec(2) = zwk(ib1,ib2,2,ik)
                           zvec(3) = zwk(ib1,ib2,3,ik)
                           write(lun,'(I5,2F15.8,I5,2F15.8,6F20.14)') &
                                &    ib1, ( eko_wk(ib1,ik)-efermi )*Hartree, occ1, &
                                &    ib2, ( eko_wk(ib2,ik)-efermi )*Hartree, occ2, &
                                &    real(zvec(1)), aimag(zvec(1)), &
                                &    real(zvec(2)), aimag(zvec(2)), &
                                &    real(zvec(3)), aimag(zvec(3))
                        End Do
                     End Do
                  end if
               End Do ikloop1
               if ( myrank_e == 0 ) close(lun)
            End Do
         End Do
200      continue
         call mpi_barrier( mpi_comm_group, ierr )
      End Do iloop

      deallocate( zwk );    deallocate( eko_wk );   deallocate( occ_wk )
    end subroutine print_wavederf_col_split

    subroutine print_wavederf_col_fbz_sort
      integer :: ik, is, ib1, ib2
      integer :: lun
      integer :: trev, iopr, ii, jk, iktmp, jksnl, iksnl
      complex(kind=CMPLDP) :: zvec(3), zvec_rot(3)
      real(kind=DP) :: occ1, occ2, weight
      real(kind=DP), allocatable :: eko_wk(:,:), occ_wk(:,:), eko_mpi(:,:), occ_mpi(:,:)
      real(kind=DP), allocatable :: eko_wk2(:), occ_wk2(:)
      complex(kind=CMPLDP), allocatable :: zwk(:,:,:,:), zwk_mpi(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk2(:,:,:)

      integer istatus(mpi_status_size)

      lun = 1000
      if ( mype == 0 ) then
         open( lun, file="WAVEDERF_phase", status="unknown", form="formatted" )
         if ( sw_wavederf_full_bz == ON ) then
            write(lun,*) nspin, kv3_fbz/nspin, ib_num
         else
            write(lun,*) nspin, kv3/nspin, ib_num
         endif
      endif

      allocate( eko_wk( neg,ista_k:iend_k ) ); eko_wk = 0.0d0
      allocate( occ_wk( neg,ista_k:iend_k ) ); occ_wk = 0.0d0

      Do ik=ista_k, iend_k
         Do ib1=ista_e, iend_e, istep_e
            eko_wk(ib1,ik) = eko_l( map_z(ib1),ik )
            occ_wk(ib1,ik) = occup_l( map_z(ib1),ik )
         End do
      End Do
      if ( nrank_e > 1 ) then
         allocate( eko_mpi( neg,ista_k:iend_k ) ); eko_mpi = 0.0d0
         call mpi_allreduce( eko_wk, eko_mpi, neg*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         eko_wk = eko_mpi
         deallocate( eko_mpi )
         allocate( occ_mpi( neg,ista_k:iend_k ) ); occ_mpi = 0.0d0
         call mpi_allreduce( occ_wk, occ_mpi, neg*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         occ_wk = occ_mpi
         deallocate( occ_mpi )
      endif
      
      allocate( zwk( neg, neg, 3, ista_k:iend_k ) );   zwk = 0.0d0

      Do ik=ista_k, iend_k
         Do ib1=ista_e, iend_e, istep_e
            zwk( ib1, 1:neg, 1:3, ik ) &
                 &  = trm_vv( map_z(ib1), 1:neg, ik, 1:3 ) *(-zi)
         End Do
      End Do
      if ( nrank_e > 1 ) then
         allocate( zwk_mpi( neg, neg, 3, ista_k:iend_k ) ); zwk_mpi = 0.0d0
         call mpi_allreduce( zwk, zwk_mpi, neg*neg*3*2*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         zwk = zwk_mpi
         deallocate( zwk_mpi )
      endif
!
      if ( mype == 0 ) then
         allocate( eko_wk2(neg) );   allocate( occ_wk2(neg) )
         allocate( zwk2(neg,neg,3) )
      endif

      Do is=1, nspin
         jkloop1: Do jk=is, kv3_fbz, nspin
            if ( myrank_e /= 0 ) cycle

            jksnl = (jk-1)/nspin + 1
            
            iopr = iopr_k_fbz_to_ibz(jk)
            trev = trev_k_fbz_to_ibz(jk)
            ikloop: Do ik=1, kv3, ndim_spinor
               Do ii=1, num_star_of_k(ik)
                  if ( jk == star_of_k(ik,ii) ) then
                     iktmp = ik;  exit ikloop
                  endif
               End Do
            end Do ikloop
            ik = iktmp
            iksnl = (ik-1)/nspin + 1

            if ( mype /= 0 .and. map_k(ik) == myrank_k ) then
               call mpi_send( eko_wk(:,ik), neg, mpi_double_precision, &
                    &         0, 1, &
                    &         mpi_comm_group, ierr )
               call mpi_send( occ_wk(:,ik), neg, mpi_double_precision, &
                    &         0, 2, &
                    &         mpi_comm_group, ierr )
            else if ( mype == 0 ) then
               if ( map_k(ik) == myrank_k ) then
                  eko_wk2(:) = eko_wk(:,ik);     occ_wk2(:) = occ_wk(:,ik)
               else
                  call mpi_recv( eko_wk2(:), neg, mpi_double_precision, &
                       &         map_ek(1,ik), 1, &
                       &         mpi_comm_group, istatus, ierr )
                  call mpi_recv( occ_wk2(:), neg, mpi_double_precision, &
                       &         map_ek(1,ik), 2, &
                       &         mpi_comm_group, istatus, ierr )
               endif
            endif

            if ( mype /= 0 .and. map_k(ik) == myrank_k ) then
               call mpi_send( zwk(:,:,:,ik), 2*neg*neg*3, mpi_double_precision, &
                    &         0, 3, &
                    &         mpi_comm_group, ierr )
            else if ( mype == 0 ) then
               if ( map_k(ik) == myrank_k ) then
                  zwk2(:,:,:) = zwk(:,:,:,ik)
               else
                  call mpi_recv( zwk2(:,:,:), 2*neg*neg*3, mpi_double_precision, &
                       &         map_ek(1,ik), 3, &
                       &         mpi_comm_group, istatus, ierr )
               endif
            endif

            if ( mype == 0 ) then
               weight = kv3 *qwgt(ik) /dble(ndim_spinor)

               Do ib1=ib_min, ib_max
                  Do ib2=ib_min, ib_max
                     occ1 = occ_wk2(ib1) / weight
                     occ2 = occ_wk2(ib2) / weight
                     zvec(1) = zwk2(ib1,ib2,1)
                     zvec(2) = zwk2(ib1,ib2,2)
                     zvec(3) = zwk2(ib1,ib2,3)
                     
                     zvec_rot = matmul( op(:,:,invop(iopr)), zvec(:) ) 
                     
                     if ( trev == 1 ) zvec_rot = conjg( zvec_rot )
#if 1
                     if ( allocated(magmom_dir_inversion_opr_flag) ) then
                        if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) then
                           zvec_rot = -conjg(zvec_rot)
                        endif
                     endif
#endif                              
                     write(lun,'(I5,2F15.8,I5,2F15.8,6F20.14)') &
                          &       ib1, ( eko_wk2(ib1)-efermi )*Hartree, occ1, &
                          &       ib2, ( eko_wk2(ib2)-efermi )*Hartree, occ2, &
                          &       real(zvec_rot(1)), aimag(zvec_rot(1)), &
                          &       real(zvec_rot(2)), aimag(zvec_rot(2)), &
                          &       real(zvec_rot(3)), aimag(zvec_rot(3))
                  End Do
               End Do
            endif
         End Do jkloop1
      End Do

      if ( mype == 0 ) then
         deallocate( zwk2 );   deallocate( eko_wk2 );  deallocate( occ_wk2 )
      endif
      deallocate( zwk );    deallocate( eko_wk );   deallocate( occ_wk )

    end subroutine print_wavederf_col_fbz_sort

    subroutine print_wavederf_col
      integer :: ik, is, ib1, ib2
      integer :: lun
      integer :: trev, iopr, ii, jk
      complex(kind=CMPLDP) :: zvec(3), zvec_rot(3)
      real(kind=DP) :: occ1, occ2, weight
      real(kind=DP), allocatable :: eko_wk(:,:), occ_wk(:,:), eko_mpi(:,:), occ_mpi(:,:)
      real(kind=DP), allocatable :: eko_wk2(:), occ_wk2(:)
      complex(kind=CMPLDP), allocatable :: zwk(:,:,:,:), zwk_mpi(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk2(:,:,:)

      integer istatus(mpi_status_size)

      lun = 1000
      if ( mype == 0 ) then
         open( lun, file="WAVEDERF_phase", status="unknown", form="formatted" )
         if ( sw_wavederf_full_bz == ON ) then
            write(lun,*) nspin, kv3_fbz/nspin, ib_num
         else
            write(lun,*) nspin, kv3/nspin, ib_num
         endif
      endif

      allocate( eko_wk( neg,ista_k:iend_k ) ); eko_wk = 0.0d0
      allocate( occ_wk( neg,ista_k:iend_k ) ); occ_wk = 0.0d0

      Do ik=ista_k, iend_k
         Do ib1=ista_e, iend_e, istep_e
            eko_wk(ib1,ik) = eko_l( map_z(ib1),ik )
            occ_wk(ib1,ik) = occup_l( map_z(ib1),ik )
         End do
      End Do
      if ( nrank_e > 1 ) then
         allocate( eko_mpi( neg,ista_k:iend_k ) ); eko_mpi = 0.0d0
         call mpi_allreduce( eko_wk, eko_mpi, neg*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         eko_wk = eko_mpi
         deallocate( eko_mpi )
         allocate( occ_mpi( neg,ista_k:iend_k ) ); occ_mpi = 0.0d0
         call mpi_allreduce( occ_wk, occ_mpi, neg*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         occ_wk = occ_mpi
         deallocate( occ_mpi )
      endif
      
      allocate( zwk( neg, neg, 3, ista_k:iend_k ) );   zwk = 0.0d0

      Do ik=ista_k, iend_k
         Do ib1=ista_e, iend_e, istep_e
            zwk( ib1, 1:neg, 1:3, ik ) &
                 &  = trm_vv( map_z(ib1), 1:neg, ik, 1:3 ) *(-zi)
         End Do
      End Do
      if ( nrank_e > 1 ) then
         allocate( zwk_mpi( neg, neg, 3, ista_k:iend_k ) ); zwk_mpi = 0.0d0
         call mpi_allreduce( zwk, zwk_mpi, neg*neg*3*2*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         zwk = zwk_mpi
         deallocate( zwk_mpi )
      endif
!
      if ( mype == 0 ) then
         allocate( eko_wk2(neg) );   allocate( occ_wk2(neg) )
         allocate( zwk2(neg,neg,3) )
      endif

      Do is=1, nspin
         ikloop1: Do ik=is, kv3, nspin
            if ( myrank_e /= 0 ) cycle

            if ( mype /= 0 .and. map_k(ik) == myrank_k ) then
               call mpi_send( eko_wk(:,ik), neg, mpi_double_precision, &
                    &         0, 1, &
                    &         mpi_comm_group, ierr )
               call mpi_send( occ_wk(:,ik), neg, mpi_double_precision, &
                    &         0, 2, &
                    &         mpi_comm_group, ierr )
            else if ( mype == 0 ) then
               if ( map_k(ik) == myrank_k ) then
                  eko_wk2(:) = eko_wk(:,ik);     occ_wk2(:) = occ_wk(:,ik)
               else
                  call mpi_recv( eko_wk2(:), neg, mpi_double_precision, &
                       &         map_ek(1,ik), 1, &
                       &         mpi_comm_group, istatus, ierr )
                  call mpi_recv( occ_wk2(:), neg, mpi_double_precision, &
                       &         map_ek(1,ik), 2, &
                       &         mpi_comm_group, istatus, ierr )
               endif
            endif

            if ( mype /= 0 .and. map_k(ik) == myrank_k ) then
               call mpi_send( zwk(:,:,:,ik), 2*neg*neg*3, mpi_double_precision, &
                    &         0, 3, &
                    &         mpi_comm_group, ierr )
            else if ( mype == 0 ) then
               if ( map_k(ik) == myrank_k ) then
                  zwk2(:,:,:) = zwk(:,:,:,ik)
               else
                  call mpi_recv( zwk2(:,:,:), 2*neg*neg*3, mpi_double_precision, &
                       &         map_ek(1,ik), 3, &
                       &         mpi_comm_group, istatus, ierr )
               endif
            endif

            if ( mype == 0 ) then
               if ( sw_wavederf_full_bz == ON ) then
                  weight = kv3 *qwgt(ik) /dble(ndim_spinor)

                  Do ii=1, num_star_of_k(ik)
                     jk = star_of_k(ik,ii)
                     iopr = iopr_k_fbz_to_ibz(jk)
                     trev = trev_k_fbz_to_ibz(jk)

                     Do ib1=ib_min, ib_max
                        Do ib2=ib_min, ib_max
                           occ1 = occ_wk2(ib1) / weight
                           occ2 = occ_wk2(ib2) / weight
                           zvec(1) = zwk2(ib1,ib2,1)
                           zvec(2) = zwk2(ib1,ib2,2)
                           zvec(3) = zwk2(ib1,ib2,3)

                           zvec_rot = matmul( op(:,:,invop(iopr)), zvec(:) ) 

                           if ( trev == 1 ) zvec_rot = conjg( zvec_rot )
#if 1
                           if ( allocated(magmom_dir_inversion_opr_flag) ) then
                              if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) then
                                 zvec_rot = -conjg(zvec_rot)
                              endif
                           endif
#endif                              
                           write(lun,'(I5,2F15.8,I5,2F15.8,6F20.14)') &
                                &       ib1, ( eko_wk2(ib1)-efermi )*Hartree, occ1, &
                                &       ib2, ( eko_wk2(ib2)-efermi )*Hartree, occ2, &
                                &       real(zvec_rot(1)), aimag(zvec_rot(1)), &
                                &       real(zvec_rot(2)), aimag(zvec_rot(2)), &
                                &       real(zvec_rot(3)), aimag(zvec_rot(3))
                        End Do
                     End Do
                  End Do
               else
                  weight = kv3 *qwgt(ik) /dble(ndim_spinor)
                  Do ib1=ib_min, ib_max
                     Do ib2=ib_min, ib_max
                        occ1 = occ_wk2(ib1) / weight
                        occ2 = occ_wk2(ib2) / weight
                        zvec(1) = zwk2(ib1,ib2,1)
                        zvec(2) = zwk2(ib1,ib2,2)
                        zvec(3) = zwk2(ib1,ib2,3)
                        write(lun,'(I5,2F15.8,I5,2F15.8,6F20.14)') &
                             &       ib1, ( eko_wk2(ib1)-efermi )*Hartree, occ1, &
                             &       ib2, ( eko_wk2(ib2)-efermi )*Hartree, occ2, &
                             &       real(zvec(1)), aimag(zvec(1)), &
                             &       real(zvec(2)), aimag(zvec(2)), &
                             &       real(zvec(3)), aimag(zvec(3))
                     End Do
                  End Do
               end if
            endif
         End Do ikloop1
      End Do

      if ( mype == 0 ) then
         deallocate( zwk2 );   deallocate( eko_wk2 );  deallocate( occ_wk2 )
      endif
      deallocate( zwk );    deallocate( eko_wk );   deallocate( occ_wk )

    end subroutine print_wavederf_col

    subroutine print_wavederf_col2    ! save_memory_mode
      integer :: ik, is, ib1, ib2
      integer :: lun
      real(kind=DP) :: occ1, occ2, weight
      real(kind=DP), allocatable :: eko_wk(:), occ_wk(:), eko_mpi(:), occ_mpi(:)
      complex(kind=CMPLDP) :: z1, z2, z3
      complex(kind=CMPLDP), allocatable :: zwk(:,:)

      integer istatus(mpi_status_size)

      lun = 1000
      if ( mype == 0 ) then
         open( lun, file="WAVEDERF_phase", status="unknown", form="formatted" )
         write(lun,*) nspin, kv3/nspin, ib_num
      endif

      allocate( eko_wk( neg ) ); eko_wk = 0.0d0
      allocate( occ_wk( neg ) ); occ_wk = 0.0d0
      
      Do is=1, nspin
         ikloop1: Do ik=is, kv3, nspin
            eko_wk = 0.0d0;     occ_wk = 0.0d0

            if ( map_k(ik) == myrank_k ) then
               Do ib1=ista_e, iend_e, istep_e
                  eko_wk(ib1) = eko_l( map_z(ib1),ik )
                  occ_wk(ib1) = occup_l( map_z(ib1),ik )
               End do
               if ( npes > 1 ) then
                  allocate( eko_mpi( neg ) ); eko_mpi = 0.0d0
                  call mpi_allreduce( eko_wk, eko_mpi, neg, &
                       &              mpi_double_precision, mpi_sum, &
                       &              mpi_k_world(myrank_k), ierr )
                  eko_wk = eko_mpi
                  deallocate( eko_mpi )
                  allocate( occ_mpi( neg ) ); occ_mpi = 0.0d0
                  call mpi_allreduce( occ_wk, occ_mpi, neg, &
                       &              mpi_double_precision, mpi_sum, &
                       &              mpi_k_world(myrank_k), ierr )
                  occ_wk = occ_mpi
                  deallocate( occ_mpi )
               endif
            endif

            if ( map_ek(1,ik) == mype ) then
               if ( mype /= 0 ) then
                  call mpi_send( eko_wk, neg, mpi_double_precision, &
                       &         0, 1, mpi_comm_group, ierr )
                  call mpi_send( occ_wk, neg, mpi_double_precision, &
                       &         0, 2, mpi_comm_group, ierr )
               endif
            else if ( mype == 0 .and. map_ek(1,ik) /= 0 ) then
               call mpi_recv( eko_wk, neg, mpi_double_precision, &
                    &         map_ek(1,ik), 1, &
                    &         mpi_comm_group, istatus, ierr )
               call mpi_recv( occ_wk, neg, mpi_double_precision, &
                    &         map_ek(1,ik), 2, &
                    &         mpi_comm_group, istatus, ierr )
            endif
            
            allocate( zwk( neg, 3 ) )
            weight = kv3 *qwgt(ik) /dble(ndim_spinor)

            Do ib1=ib_min, ib_max
               if ( map_ek(ib1,ik) == mype ) then
                  zwk( 1:neg, 1:3 ) = trm_vv( map_z(ib1), 1:neg, ik, 1:3 ) *(-zi)
                  if ( mype /= 0 ) then
                     call mpi_send( zwk(:,:), 2*neg*3, mpi_double_precision, &
                          &         0, 3, &
                          &         mpi_comm_group, ierr )
                  endif
               else if ( mype == 0 .and. map_ek(ib1,ik) /= 0 ) then
                  call mpi_recv( zwk(:,:), 2*neg*3, mpi_double_precision, &
                       &         map_ek(ib1,ik), 3, &
                       &         mpi_comm_group, istatus, ierr )
               endif
               if ( mype == 0 ) then
                  Do ib2=ib_min, ib_max
                     occ1 = occ_wk(ib1) / weight
                     occ2 = occ_wk(ib2) / weight
                     z1 = zwk(ib2,1)
                     z2 = zwk(ib2,2)
                     z3 = zwk(ib2,3)
                     write(lun,'(I5,2F15.8,I5,2F15.8,6F20.14)') &
                          &       ib1, ( eko_wk(ib1)-efermi )*Hartree, occ1, &
                          &       ib2, ( eko_wk(ib2)-efermi )*Hartree, occ2, &
                          &       real(z1), aimag(z1), real(z2), aimag(z2), &
                          &       real(z3), aimag(z3)
                  End Do
               end if
            End Do
            deallocate( zwk )
         End Do ikloop1
      End Do

      if ( mype == 0 ) close(lun)
      deallocate( eko_wk );   deallocate( occ_wk )

    end subroutine print_wavederf_col2

    subroutine print_wavederf_noncl
      integer :: ik, is, ib1, ib2, iktmp
      integer :: lun, num, j, nr
      integer :: trev, iopr, ii, jk
      real(kind=DP) :: occ1, occ2, weight
      real(kind=DP), allocatable :: eko_wk(:,:), occ_wk(:,:), eko_mpi(:,:), occ_mpi(:,:)
      real(kind=DP), allocatable :: eko_wk2(:), occ_wk2(:)
      complex(kind=CMPLDP) :: zvec(3), zvec_rot(3)
      complex(kind=CMPLDP), allocatable :: zwk(:,:,:,:), zwk_mpi(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk2(:,:,:,:)

      character*72 file0
      integer istatus(mpi_status_size)

      lun = 1000
      file0 = "WAVEDERF_phase"
      if ( mype == 0 ) then
#if 0
         open( lun, file=file0, status="unknown", form="formatted" )
         if ( sw_wavederf_full_bz == ON ) then
            write(lun,*) nspin, kv3_fbz/nspin, ib_num
         else
            write(lun,*) nspin, kv3/nspin, ib_num
         endif
#else
         if ( ekmode == ON ) then
            if ( nk_in_the_process == 1 ) then
               open( lun, file=file0, status="unknown", form="formatted" )
               write(lun,*) nspin, kv3_ek/nspin, neg
            else
               open( lun, file=file0, status="unknown", form="formatted", &
                    &     position = 'append' )
            endif
         else
            open( lun, file=file0, status="unknown", form="formatted" )
            if ( sw_wavederf_full_bz == ON ) then
               write(lun,*) nspin, kv3_fbz/nspin, neg
            else
               write(lun,*) nspin, kv3/nspin, neg
            endif
         endif
#endif
      endif

      allocate( eko_wk( neg,ista_k:iend_k ) ); eko_wk = 0.0d0
      allocate( occ_wk( neg,ista_k:iend_k ) ); occ_wk = 0.0d0
      
      Do ik=ista_k, iend_k
         Do ib1=ista_e, iend_e, istep_e
            eko_wk(ib1,ik) = eko_l( map_z(ib1),ik )
            occ_wk(ib1,ik) = occup_l( map_z(ib1),ik )
         End do
      End Do 
      if ( nrank_e > 1 ) then
         allocate( eko_mpi( neg,ista_k:iend_k ) ); eko_mpi = 0.0d0
         call mpi_allreduce( eko_wk, eko_mpi, neg*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         eko_wk = eko_mpi
         deallocate( eko_mpi )
         allocate( occ_mpi( neg,ista_k:iend_k ) ); occ_mpi = 0.0d0
         call mpi_allreduce( occ_wk, occ_mpi, neg*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         occ_wk = occ_mpi
         deallocate( occ_mpi )
      endif
         
      allocate( zwk( neg, neg, 3, ista_k:iend_k ) );   zwk = 0.0d0

      Do ik=ista_k, iend_k
         Do ib1=ista_e, iend_e, istep_e
            zwk( ib1, 1:neg, 1:3, ik ) &
                 &  = trm_vv( map_z(ib1), 1:neg, ik, 1:3 ) *(-zi)
         End Do
      End Do
      if ( nrank_e > 1 ) then
         allocate( zwk_mpi( neg, neg, 3, ista_k:iend_k ) ); zwk_mpi = 0.0d0
         call mpi_allreduce( zwk, zwk_mpi, neg*neg*3*2*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         zwk = zwk_mpi
         deallocate( zwk_mpi )
      endif
!
      if ( mype == 0 ) then
         allocate( eko_wk2(neg) );   allocate( occ_wk2(neg) )
         allocate( zwk2(neg,neg,3,ndim_spinor) )
      endif

      Do ik=1, kv3, ndim_spinor
         if ( myrank_e /= 0 ) cycle

         if ( mype /= 0 .and. map_k(ik) == myrank_k ) then
            call mpi_send( eko_wk(:,ik), neg, mpi_double_precision, &
                 &         0, 1, &
                 &         mpi_comm_group, ierr )
            call mpi_send( occ_wk(:,ik), neg, mpi_double_precision, &
                 &         0, 2, &
                 &         mpi_comm_group, ierr )
         else if ( mype == 0 ) then
            if ( map_k(ik) == myrank_k ) then
               eko_wk2(:) = eko_wk(:,ik);     occ_wk2(:) = occ_wk(:,ik)
            else
               call mpi_recv( eko_wk2(:), neg, mpi_double_precision, &
                    &         map_ek(1,ik), 1, &
                    &         mpi_comm_group, istatus, ierr )
               call mpi_recv( occ_wk2(:), neg, mpi_double_precision, &
                    &         map_ek(1,ik), 2, &
                    &         mpi_comm_group, istatus, ierr )
            endif
         endif
         Do is=1, ndim_spinor
            if ( mype /= 0 .and. map_k(ik) == myrank_k ) then
               call mpi_send( zwk(:,:,:,ik+is-1), 2*neg*neg*3, mpi_double_precision, &
                    &         0, 3 +is, &
                    &         mpi_comm_group, ierr )
            else if ( mype == 0 ) then
               if ( map_k(ik) == myrank_k ) then
                  zwk2(:,:,:,is) = zwk(:,:,:,ik+is-1)
               else
                  call mpi_recv( zwk2(:,:,:,is), 2*neg*neg*3, mpi_double_precision, &
                       &         map_ek(1,ik), 3+is, &
                       &         mpi_comm_group, istatus, ierr )
               endif
            endif
         End Do
!
         if ( mype == 0 ) then
            if ( sw_wavederf_full_bz == ON ) then
               weight = kv3 *qwgt(ik) /dble(ndim_spinor)
               
               Do ii=1, num_star_of_k(ik)
                  jk = star_of_k(ik,ii)
                  iopr = iopr_k_fbz_to_ibz(jk)
                  trev = trev_k_fbz_to_ibz(jk)

                  Do ib1=ib_min, ib_max
                     Do ib2=ib_min, ib_max
                        occ1 = occ_wk2(ib1) / weight
                        occ2 = occ_wk2(ib2) / weight
                        zvec(1) = zwk2(ib1,ib2,1,1) +zwk2(ib1,ib2,1,2)
                        zvec(2) = zwk2(ib1,ib2,2,1) +zwk2(ib1,ib2,2,2)
                        zvec(3) = zwk2(ib1,ib2,3,1) +zwk2(ib1,ib2,3,2)

                        zvec_rot = matmul( op(:,:,invop(iopr)), zvec(:) ) 

                        if ( trev == 1 ) zvec_rot = conjg( zvec_rot )
                        if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) then
                           zvec_rot = -conjg(zvec_rot)
                        endif

                        write(lun,'(I5,2F15.8,I5,2F15.8,6F20.14)') &
                             &       ib1, ( eko_wk2(ib1)-efermi )*Hartree, occ1, &
                             &       ib2, ( eko_wk2(ib2)-efermi )*Hartree, occ2, &
                             &       real(zvec_rot(1)), aimag(zvec_rot(1)), &
                             &       real(zvec_rot(2)), aimag(zvec_rot(2)), &
                             &       real(zvec_rot(3)), aimag(zvec_rot(3))
                     End Do
                  End Do
               End Do
            else
               weight = kv3 *qwgt(ik) /dble(ndim_spinor)
               Do ib1=ib_min, ib_max
                  Do ib2=ib_min, ib_max
                     occ1 = occ_wk2(ib1) / weight
                     occ2 = occ_wk2(ib2) / weight
                     zvec(1) = zwk2(ib1,ib2,1,1) +zwk2(ib1,ib2,1,2)
                     zvec(2) = zwk2(ib1,ib2,2,1) +zwk2(ib1,ib2,2,2)
                     zvec(3) = zwk2(ib1,ib2,3,1) +zwk2(ib1,ib2,3,2)
                     write(lun,'(I5,2F15.8,I5,2F15.8,6F20.14)') &
                          &       ib1, ( eko_wk2(ib1)-efermi )*Hartree, occ1, &
                          &       ib2, ( eko_wk2(ib2)-efermi )*Hartree, occ2, &
                          &       real(zvec(1)), aimag(zvec(1)), &
                          &       real(zvec(2)), aimag(zvec(2)), &
                          &       real(zvec(3)), aimag(zvec(3))
                  End Do
               End Do
            endif
         end if
      End Do
      if ( mype == 0 ) then
         deallocate( zwk2 );   deallocate( eko_wk2 );  deallocate( occ_wk2 )
      endif
      deallocate( zwk );    deallocate( eko_wk );   deallocate( occ_wk )

    end subroutine print_wavederf_noncl

    subroutine print_wavederf_noncl_fbz_sort
      integer :: ik, is, ib1, ib2, iktmp
      integer :: lun, num, j, nr
      integer :: trev, iopr, ii, jk, jksnl, iksnl
      real(kind=DP) :: occ1, occ2, weight
      real(kind=DP), allocatable :: eko_wk(:,:), occ_wk(:,:), eko_mpi(:,:), occ_mpi(:,:)
      real(kind=DP), allocatable :: eko_wk2(:), occ_wk2(:)
      complex(kind=CMPLDP) :: zvec(3), zvec_rot(3)
      complex(kind=CMPLDP), allocatable :: zwk(:,:,:,:), zwk_mpi(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk2(:,:,:,:)

      character*72 file0
      integer istatus(mpi_status_size)

      lun = 1000
      file0 = "WAVEDERF_phase"
      if ( mype == 0 ) then
         open( lun, file=file0, status="unknown", form="formatted" )
         if ( sw_wavederf_full_bz == ON ) then
            write(lun,*) nspin, kv3_fbz/nspin, ib_num
         else
            write(lun,*) nspin, kv3/nspin, ib_num
         endif
      endif

      allocate( eko_wk( neg,ista_k:iend_k ) ); eko_wk = 0.0d0
      allocate( occ_wk( neg,ista_k:iend_k ) ); occ_wk = 0.0d0
      
      Do ik=ista_k, iend_k
         Do ib1=ista_e, iend_e, istep_e
            eko_wk(ib1,ik) = eko_l( map_z(ib1),ik )
            occ_wk(ib1,ik) = occup_l( map_z(ib1),ik )
         End do
      End Do 
      if ( nrank_e > 1 ) then
         allocate( eko_mpi( neg,ista_k:iend_k ) ); eko_mpi = 0.0d0
         call mpi_allreduce( eko_wk, eko_mpi, neg*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         eko_wk = eko_mpi
         deallocate( eko_mpi )
         allocate( occ_mpi( neg,ista_k:iend_k ) ); occ_mpi = 0.0d0
         call mpi_allreduce( occ_wk, occ_mpi, neg*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         occ_wk = occ_mpi
         deallocate( occ_mpi )
      endif
         
      allocate( zwk( neg, neg, 3, ista_k:iend_k ) );   zwk = 0.0d0

      Do ik=ista_k, iend_k
         Do ib1=ista_e, iend_e, istep_e
            zwk( ib1, 1:neg, 1:3, ik ) &
                 &  = trm_vv( map_z(ib1), 1:neg, ik, 1:3 ) *(-zi)
         End Do
      End Do
      if ( nrank_e > 1 ) then
         allocate( zwk_mpi( neg, neg, 3, ista_k:iend_k ) ); zwk_mpi = 0.0d0
         call mpi_allreduce( zwk, zwk_mpi, neg*neg*3*2*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         zwk = zwk_mpi
         deallocate( zwk_mpi )
      endif
!
      if ( mype == 0 ) then
         allocate( eko_wk2(neg) );   allocate( occ_wk2(neg) )
         allocate( zwk2(neg,neg,3,ndim_spinor) )
      endif

      Do jk=1, kv3_fbz, ndim_spinor
         if ( myrank_e /= 0 ) cycle

         jksnl = (jk-1)/nspin + 1
 
         iopr = iopr_k_fbz_to_ibz(jk)
         trev = trev_k_fbz_to_ibz(jk)
         ikloop: Do ik=1, kv3, ndim_spinor
            Do ii=1, num_star_of_k(ik)
               if ( jk == star_of_k(ik,ii) ) then
                  iktmp = ik;  exit ikloop
               endif
            End Do
         end Do ikloop
         ik = iktmp
         iksnl = (ik-1)/nspin + 1

         if ( mype /= 0 .and. map_k(ik) == myrank_k ) then
            call mpi_send( eko_wk(:,ik), neg, mpi_double_precision, &
                 &         0, 1, &
                 &         mpi_comm_group, ierr )
            call mpi_send( occ_wk(:,ik), neg, mpi_double_precision, &
                 &         0, 2, &
                 &         mpi_comm_group, ierr )
         else if ( mype == 0 ) then
            if ( map_k(ik) == myrank_k ) then
               eko_wk2(:) = eko_wk(:,ik);     occ_wk2(:) = occ_wk(:,ik)
            else
               call mpi_recv( eko_wk2(:), neg, mpi_double_precision, &
                    &         map_ek(1,ik), 1, &
                    &         mpi_comm_group, istatus, ierr )
               call mpi_recv( occ_wk2(:), neg, mpi_double_precision, &
                    &         map_ek(1,ik), 2, &
                    &         mpi_comm_group, istatus, ierr )
            endif
         endif
         Do is=1, ndim_spinor
            if ( mype /= 0 .and. map_k(ik) == myrank_k ) then
               call mpi_send( zwk(:,:,:,ik+is-1), 2*neg*neg*3, mpi_double_precision, &
                    &         0, 3 +is, &
                    &         mpi_comm_group, ierr )
            else if ( mype == 0 ) then
               if ( map_k(ik) == myrank_k ) then
                  zwk2(:,:,:,is) = zwk(:,:,:,ik+is-1)
               else
                  call mpi_recv( zwk2(:,:,:,is), 2*neg*neg*3, mpi_double_precision, &
                       &         map_ek(1,ik), 3+is, &
                       &         mpi_comm_group, istatus, ierr )
               endif
            endif
         End Do
!
         if ( mype == 0 ) then
            weight = kv3 *qwgt(ik) /dble(ndim_spinor)
            Do ib1=ib_min, ib_max
               Do ib2=ib_min, ib_max
                  occ1 = occ_wk2(ib1) / weight
                  occ2 = occ_wk2(ib2) / weight
                  zvec(1) = zwk2(ib1,ib2,1,1) +zwk2(ib1,ib2,1,2)
                  zvec(2) = zwk2(ib1,ib2,2,1) +zwk2(ib1,ib2,2,2)
                  zvec(3) = zwk2(ib1,ib2,3,1) +zwk2(ib1,ib2,3,2)
                  
                  zvec_rot = matmul( op(:,:,invop(iopr)), zvec(:) ) 

                  if ( trev == 1 ) zvec_rot = conjg( zvec_rot )
                  if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) then
                     zvec_rot = -conjg(zvec_rot)
                  endif

                  write(lun,'(I5,2F15.8,I5,2F15.8,6F20.14)') &
                       &       ib1, ( eko_wk2(ib1)-efermi )*Hartree, occ1, &
                       &       ib2, ( eko_wk2(ib2)-efermi )*Hartree, occ2, &
                       &       real(zvec_rot(1)), aimag(zvec_rot(1)), &
                       &       real(zvec_rot(2)), aimag(zvec_rot(2)), &
                       &       real(zvec_rot(3)), aimag(zvec_rot(3))
               End Do
            End Do
         end if
      End Do
      if ( mype == 0 ) then
         deallocate( zwk2 );   deallocate( eko_wk2 );  deallocate( occ_wk2 )
      endif
      deallocate( zwk );    deallocate( eko_wk );   deallocate( occ_wk )

    end subroutine print_wavederf_noncl_fbz_sort

    subroutine print_wavederf_noncl2      ! save_memory_mode: 1
      integer :: ik, is, ib1, ib2, iktmp
      integer :: lun
      real(kind=DP) :: occ1, occ2, weight
      real(kind=DP), allocatable :: eko_wk(:), occ_wk(:), eko_mpi(:), occ_mpi(:)
      complex(kind=CMPLDP) :: z1, z2, z3
      complex(kind=CMPLDP), allocatable :: zwk(:,:,:)

      integer istatus(mpi_status_size)

      lun = 1000
      if ( mype == 0 ) then
         open( lun, file="WAVEDERF_phase", status="unknown", form="formatted" )
         write(lun,*) 1, kv3/nspin, ib_num
      endif

      allocate( eko_wk( neg ) ); eko_wk = 0.0d0
      allocate( occ_wk( neg ) ); occ_wk = 0.0d0
      
      ikloop: Do ik=1, kv3, ndim_spinor
         eko_wk = 0.0d0;     occ_wk = 0.0d0

         if ( map_k(ik) == myrank_k ) then
            Do ib1=ista_e, iend_e, istep_e
               eko_wk(ib1) = eko_l( map_z(ib1),ik )
               occ_wk(ib1) = occup_l( map_z(ib1),ik )
            End do
            if ( npes > 1 ) then
               allocate( eko_mpi( neg ) ); eko_mpi = 0.0d0
               call mpi_allreduce( eko_wk, eko_mpi, neg, mpi_double_precision, mpi_sum, &
                    &              mpi_k_world(myrank_k), ierr )
               eko_wk = eko_mpi
               deallocate( eko_mpi )
               allocate( occ_mpi( neg ) ); occ_mpi = 0.0d0
               call mpi_allreduce( occ_wk, occ_mpi, neg, mpi_double_precision, mpi_sum, &
                    &              mpi_k_world(myrank_k), ierr )
               occ_wk = occ_mpi
               deallocate( occ_mpi )
            endif
         endif
         
         if ( map_ek(1,ik) == mype ) then
            if ( mype /= 0 ) then
               call mpi_send( eko_wk, neg, mpi_double_precision, &
                    &         0, 1, mpi_comm_group, ierr )
               call mpi_send( occ_wk, neg, mpi_double_precision, &
                    &         0, 2, mpi_comm_group, ierr )
            endif
         else if ( mype == 0 .and. map_ek(1,ik) /= 0 ) then
            call mpi_recv( eko_wk, neg, mpi_double_precision, &
                 &         map_ek(1,ik), 1, &
                 &         mpi_comm_group, istatus, ierr )
            call mpi_recv( occ_wk, neg, mpi_double_precision, &
                 &         map_ek(1,ik), 2, &
                 &         mpi_comm_group, istatus, ierr )
         endif

         weight = kv3 *qwgt(ik) /dble(ndim_spinor)
         allocate( zwk( neg, 3, ndim_spinor ) )

         Do ib1=ib_min, ib_max
            zwk = 0.0d0
            Do is=1, ndim_spinor
               iktmp = ik +is -1
               if ( map_ek(ib1,ik) == mype ) then
                  zwk( 1:neg, 1:3, is ) = trm_vv( map_z(ib1), 1:neg, iktmp, 1:3 ) *(-zi)
                  if ( mype /= 0 ) then
                     call mpi_send( zwk(:,:,is), 2*neg*3, mpi_double_precision, &
                          &         0, 3+is, &
                          &         mpi_comm_group, ierr )
                  endif
               else if ( mype == 0 .and. map_ek(ib1,ik) /= 0 ) then
                  call mpi_recv( zwk(:,:,is), 2*neg*3, mpi_double_precision, &
                       &         map_ek(ib1,iktmp), 3+is, &
                       &         mpi_comm_group, istatus, ierr )
               endif
            End Do
            if ( mype == 0 ) then
               Do ib2=ib_min, ib_max
                  occ1 = occ_wk(ib1) / weight
                  occ2 = occ_wk(ib2) / weight
                  z1 = zwk(ib2,1,1) +zwk(ib2,1,2)
                  z2 = zwk(ib2,2,1) +zwk(ib2,2,2)
                  z3 = zwk(ib2,3,1) +zwk(ib2,3,2)
                  write(lun,'(I5,2F15.8,I5,2F15.8,6F20.14)') &
                       &       ib1, ( eko_wk(ib1)-efermi )*Hartree, occ1, &
                       &       ib2, ( eko_wk(ib2)-efermi )*Hartree, occ2, &
                       &       real(z1), aimag(z1), real(z2), aimag(z2), &
                       &       real(z3), aimag(z3)
               End Do
            End if
         End Do
         deallocate( zwk )
      End Do ikloop

      if ( mype == 0 ) close(lun)
      deallocate( eko_wk );   deallocate( occ_wk )

    end subroutine print_wavederf_noncl2

    subroutine print_wavederf_noncl_split
      integer :: ik, is, ib1, ib2, iktmp
      integer :: lun, num, i, j, nr, ii, jk, iopr, trev
      real(kind=DP) :: occ1, occ2, weight
      complex(kind=CMPLDP) :: zvec(3), zvec_rot(3)
      real(kind=DP), allocatable :: eko_wk(:,:), occ_wk(:,:), eko_mpi(:,:), occ_mpi(:,:)
      complex(kind=CMPLDP), allocatable :: zwk(:,:,:,:), zwk_mpi(:,:,:,:)

      character*4 char1
      character*72 file0, file1
      integer istatus(mpi_status_size)

      allocate( eko_wk( neg,ista_k:iend_k ) ); eko_wk = 0.0d0
      allocate( occ_wk( neg,ista_k:iend_k ) ); occ_wk = 0.0d0
      
      Do ik=ista_k, iend_k
         Do ib1=ista_e, iend_e, istep_e
            eko_wk(ib1,ik) = eko_l( map_z(ib1),ik )
            occ_wk(ib1,ik) = occup_l( map_z(ib1),ik )
         End do
      End Do 
      if ( nrank_e > 1 ) then
         allocate( eko_mpi( neg,ista_k:iend_k ) ); eko_mpi = 0.0d0
         call mpi_allreduce( eko_wk, eko_mpi, neg*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         eko_wk = eko_mpi
         deallocate( eko_mpi )
         allocate( occ_mpi( neg,ista_k:iend_k ) ); occ_mpi = 0.0d0
         call mpi_allreduce( occ_wk, occ_mpi, neg*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         occ_wk = occ_mpi
         deallocate( occ_mpi )
      endif
         
      allocate( zwk( neg, neg, 3, ista_k:iend_k ) )
      zwk = 0.0d0

      Do ik=ista_k, iend_k
         Do ib1=ista_e, iend_e, istep_e
            zwk( ib1, 1:neg, 1:3, ik ) &
                 &  = trm_vv( map_z(ib1), 1:neg, ik, 1:3 ) *(-zi)
         End Do
      End Do
      if ( nrank_e > 1 ) then
         allocate( zwk_mpi( neg, neg, 3, ista_k:iend_k ) ); zwk_mpi = 0.0d0
         call mpi_allreduce( zwk, zwk_mpi, neg*neg*3*2*(iend_k-ista_k+1), &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         zwk = zwk_mpi
         deallocate( zwk_mpi )
      endif

      lun = 10000 +myrank_k
      write(char1,'(I4.4)') myrank_k

      nr = nrank_k /num_wavederf_files_once +1
      num = 0
      
      iloop: Do i=1, nr
         Do j=1, num_wavederf_files_once
            num = num +1
            if ( num > npes )    goto 200
            if ( num /= myrank_k +1 ) cycle
            if ( myrank_e /= 0 )   cycle
            
            file0 = "WAVEDERF_phase"
            file1 = trim(adjustl(file0)) // '.' // char1

            if ( myrank_e == 0 ) then
               open( lun, file=file1, status="unknown", form="formatted" )
            endif
            if ( mype == 0 ) then
               if ( sw_wavederf_full_bz == ON ) then
                  write(lun,*) nspin, kv3_fbz/nspin, ib_num
               else
                  write(lun,*) nspin, kv3/nspin, ib_num
               endif
            endif

            Do ik=ista_k, iend_k, ndim_spinor

               if ( sw_wavederf_full_bz == ON ) then
                  weight = kv3 *qwgt(ik) /dble(ndim_spinor)
                  Do ii=1, num_star_of_k(ik)
                     jk = star_of_k(ik,ii)
                     iopr = iopr_k_fbz_to_ibz(jk)
                     trev = trev_k_fbz_to_ibz(jk)
                     
                     Do ib1=ib_min, ib_max
                        Do ib2=ib_min, ib_max
                           occ1 = occ_wk(ib1,ik) / weight
                           occ2 = occ_wk(ib2,ik) / weight
                           zvec(1) = zwk(ib1,ib2,1,ik) +zwk(ib1,ib2,1,ik+1)
                           zvec(2) = zwk(ib1,ib2,2,ik) +zwk(ib1,ib2,2,ik+1)
                           zvec(3) = zwk(ib1,ib2,3,ik) +zwk(ib1,ib2,3,ik+1)
                           
                           zvec_rot = matmul( op(:,:,invop(iopr)), zvec(:) )

                           if ( trev == 1 ) zvec_rot = conjg( zvec_rot )
                           if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) then
                              zvec_rot = -conjg(zvec_rot)
                           endif

                           write(lun,'(I5,2F15.8,I5,2F15.8,6F20.14)') &
                                &    ib1, ( eko_wk(ib1,ik)-efermi )*Hartree, occ1, &
                                &    ib2, ( eko_wk(ib2,ik)-efermi )*Hartree, occ2, &
                                &    real(zvec_rot(1)), aimag(zvec_rot(1)), &
                                &    real(zvec_rot(2)), aimag(zvec_rot(2)), &
                                &    real(zvec_rot(3)), aimag(zvec_rot(3))
                        End Do
                     End Do
                  End do

               else
                  weight = kv3 *qwgt(ik) /dble(ndim_spinor)
                  Do ib1=ib_min, ib_max
                     Do ib2=ib_min, ib_max
                        occ1 = occ_wk(ib1,ik) / weight
                        occ2 = occ_wk(ib2,ik) / weight
                        zvec(1) = zwk(ib1,ib2,1,ik) +zwk(ib1,ib2,1,ik+1)
                        zvec(2) = zwk(ib1,ib2,2,ik) +zwk(ib1,ib2,2,ik+1)
                        zvec(3) = zwk(ib1,ib2,3,ik) +zwk(ib1,ib2,3,ik+1)
                        write(lun,'(I5,2F15.8,I5,2F15.8,6F20.14)') &
                             &    ib1, ( eko_wk(ib1,ik)-efermi )*Hartree, occ1, &
                             &    ib2, ( eko_wk(ib2,ik)-efermi )*Hartree, occ2, &
                             &    real(zvec(1)), aimag(zvec(1)), &
                             &    real(zvec(2)), aimag(zvec(2)), &
                             &    real(zvec(3)), aimag(zvec(3))
                     End Do
                  End Do
               endif
            End Do

            if ( myrank_e == 0 ) close(lun)
         End Do
200      continue
         call mpi_barrier( mpi_comm_group, ierr )
      End Do iloop

      deallocate( zwk );    deallocate( eko_wk );   deallocate( occ_wk )

    end subroutine print_wavederf_noncl_split

    subroutine calc_soft_part
      integer :: ik, ib1, ib2, ig
      real(kind=DP), allocatable :: qx(:), qy(:), qz(:)
      real(kind=DP), allocatable :: wk_zaj(:,:)
      real(kind=DP) :: c1, c2
      complex(kind=CMPLDP) :: z1, z2, zsum(3)

      allocate( wk_zaj( kg1, kimg ) ); wk_zaj = 0.0d0

      allocate( qx(kg1) );  allocate( qy(kg1) ); allocate( qz(kg1) );
      qx = 0.0d0;  qy = 0.0d0;  qz = 0.0d0

      Do ik=1, kv3
         if ( map_k(ik) /= myrank_k ) cycle

         call k_plus_G_vectors_m( ik, kgp, kg1, kv3, iba, nbase, vkxyz, ngabc, &
              &                   rltv, qx, qy, qz )

         Do ib2=1, neg
            wk_zaj = 0.0d0
            if ( map_e(ib2) == myrank_e ) then
               wk_zaj(1:iba(ik),1:kimg) = zaj_l(1:iba(ik),map_z(ib2),ik,1:kimg)
            endif
            call mpi_bcast( wk_zaj, kg1*kimg, mpi_double_precision, map_e(ib2), &
                 &          mpi_k_world(myrank_k), ierr )

            Do ib1=ista_e, iend_e, istep_e
               zsum = 0.0d0
               if ( kimg == 1 ) then
                  Do ig=1, kg1
                     c1 = zaj_l(ig,map_z(ib1),ik,1)
                     c2 = c1 *wk_zaj(ig,1)
                     zsum(1) = zsum(1) +c2 *qx(ig)
                     zsum(2) = zsum(2) +c2 *qy(ig)
                     zsum(3) = zsum(3) +c2 *qz(ig)
                  End do
               else
                  Do ig=1, kg1
                     z1 = dcmplx( zaj_l(ig,map_z(ib1),ik,1), zaj_l(ig,map_z(ib1),ik,2) )
                     z2 = conjg(z1) *dcmplx( wk_zaj(ig,1), wk_zaj(ig,2) )
                     zsum(1) = zsum(1) +z2 *qx(ig)
                     zsum(2) = zsum(2) +z2 *qy(ig)
                     zsum(3) = zsum(3) +z2 *qz(ig)
                  End do
               endif
               trm_vv( map_z(ib1), ib2, ik, 1:3 ) = zsum(1:3)
            End do
         End do
      End Do

      trm_vv = trm_vv *zi

      deallocate( wk_zaj )
      deallocate( qx ); deallocate( qy ); deallocate( qz )

    end subroutine calc_soft_part

    subroutine calc_hard_part
      integer :: ia, it, ik, ib1, ib2
      integer :: lmt1, lmt2, il1, il2, im1, im2, it1, it2, itmp
      integer :: lmta1, lmta2
      real(kind=DP) :: fac
      complex(kind=CMPLDP) :: z1, z2, wf1, wf2
      complex(kind=CMPLDP), allocatable :: wk_fsri(:)
      complex(kind=CMPLDP), allocatable :: wk_fsri_add(:)

      allocate( wk_fsri(nlmta) ); wk_fsri = 0.0d0
      if ( sw_use_add_proj == ON ) then
         allocate( wk_fsri_add(nlmta_add) ); wk_fsri_add = 0.0d0
      endif

      Do ia=1, natm
         it = ityp(ia)

         Do ik=1, kv3
            if ( map_k(ik) /= myrank_k ) cycle

            Do ib2=1, neg
               wk_fsri = 0.0d0
               if ( map_e(ib2) == myrank_e ) then
                  wk_fsri(:) = dcmplx( fsr_l( map_z(ib2),:,ik ), &
                       &               fsi_l( map_z(ib2),:,ik ) )
               endif
               call mpi_bcast( wk_fsri, 2*nlmta, mpi_double_precision, map_e(ib2), &
                    &          mpi_k_world(myrank_k), ierr )

               if ( sw_use_add_proj == ON ) then
                  wk_fsri_add = 0.0d0
                  if ( map_e(ib2) == myrank_e ) then
                     wk_fsri_add(:) = dcmplx( fsr_add_l( map_z(ib2),:,ik ), &
                          &                   fsi_add_l( map_z(ib2),:,ik ) )
                  endif
                  call mpi_bcast( wk_fsri_add, 2*nlmta_add, mpi_double_precision, &
                       &          map_e(ib2), mpi_k_world(myrank_k), ierr )
               endif

               DO ib1=ista_e, iend_e, istep_e

                  Do lmt1=1, ilmt_val(it)
                     if ( lmt1 <= ilmt(it) ) then
                        il1 = ltp(lmt1,it); it1 = taup(lmt1,it)
                        lmta1 = lmta( lmt1,ia )
                        wf1 = dcmplx( fsr_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_l( map_z(ib1), lmta1, ik ) )
                     else
                        itmp = lmt1 -ilmt(it)

                        il1 = ltp_add(itmp,it); it1 = 1
                        lmta1 = lmta_add( itmp,ia )
                        wf1 = dcmplx( fsr_add_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_add_l( map_z(ib1), lmta1, ik ) )
                     endif

                     Do lmt2=1, ilmt_val(it)
                        fac = 1.0d0

                        if ( lmt2 <= ilmt(it) ) then
                           il2 = ltp(lmt2,it); it2 = taup(lmt2,it)
                           lmta2 = lmta( lmt2,ia )
                           wf2 = wk_fsri(lmta2)
                        else
                           itmp = lmt2 -ilmt(it)

                           il2 = ltp_add( itmp,it); it2 = 1
                           lmta2 = lmta_add( itmp,ia )
                           wf2 = wk_fsri_add(lmta2)
                        endif

                        z1 = conjg(wf1) *wf2

                        trm_vv( map_z(ib1), ib2, ik, 1:3 ) &
                             &  = trm_vv( map_z(ib1), ib2, ik, 1:3 ) &
                             &    + z1 *Mat_Dipole_Corr_vv( it,lmt1,lmt2,1:3 )
                     End do
                  End Do
               End Do
            End DO
         End Do
      End Do

      deallocate( wk_fsri )
      if ( allocated( wk_fsri_add ) ) deallocate( wk_fsri_add )

    end subroutine calc_hard_part

  end subroutine m_XI_wd_WAVEDERF

  subroutine m_XI_calc_transition_moment_vv
    if ( allocated( trm_vv ) ) deallocate( trm_vv )
    allocate( trm_vv( np_e, neg, ista_k:iend_k, 3 ) );   trm_vv = 0.0d0

    call calc_soft_part
    call calc_hard_part
    call multiply_factor

  contains
    
    subroutine multiply_factor
      integer :: ik, ib1, ib2, is
      real(kind=DP) :: ediff
      real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)

      allocate( eko_wk( neg ) ); eko_wk = 0.0d0

      Do ik=1, kv3, ndim_spinor
         if ( map_k(ik) /= myrank_k ) cycle

         eko_wk = 0.0d0
         Do ib1=ista_e, iend_e, istep_e
            eko_wk(ib1) = eko_l( map_z(ib1),ik )
         End do
         if ( npes > 1 ) then
            allocate( eko_mpi( neg ) ); eko_mpi = 0.0d0
            call mpi_allreduce( eko_wk, eko_mpi, neg, mpi_double_precision, mpi_sum, &
                 &              mpi_k_world(myrank_k), ierr )
            eko_wk = eko_mpi
            deallocate( eko_mpi )
         endif

         Do ib2=1, neg
            Do ib1=ista_e, iend_e, istep_e
               ediff = eko_wk(ib2) -eko_l(map_z(ib1),ik)
!
               if ( ib2 == ib1 ) then
                  ediff = delta_omega
               else if ( abs(ediff) < delta_omega ) then
                  if ( ediff >= 0.0 ) then
                     ediff = delta_omega
                  else
                     ediff = -delta_omega
                  endif
               else
                  if ( sw_scissor_renormalization == ON ) then
                     if ( eko_wk(ib2) > efermi .and. eko_l(map_z(ib1),ik ) <= efermi ) then
                        ediff = ediff +scissor
                     endif
                     if ( eko_wk(ib2) <= efermi .and. eko_l(map_z(ib1),ik ) > efermi ) then
                        ediff = ediff -scissor
                     endif
                  endif
               endif

               Do is=1, ndim_spinor
                  trm_vv( map_z(ib1),ib2,ik+is-1,: ) &
                       &   = trm_vv( map_z(ib1),ib2,ik+is-1,: ) /ediff
               End do

            End Do
        End Do
      End Do

      deallocate( eko_wk )

    end subroutine multiply_factor

    subroutine calc_soft_part
      integer :: ik, ib1, ib2, ig
      real(kind=DP), allocatable :: qx(:), qy(:), qz(:)
      real(kind=DP), allocatable :: wk_zaj(:,:)
      real(kind=DP) :: c1, c2
      complex(kind=CMPLDP) :: z1, z2, zsum(3)

      allocate( wk_zaj( kg1, kimg ) ); wk_zaj = 0.0d0

      allocate( qx(kg1) );  allocate( qy(kg1) ); allocate( qz(kg1) );
      qx = 0.0d0;  qy = 0.0d0;  qz = 0.0d0

      Do ik=1, kv3
         if ( map_k(ik) /= myrank_k ) cycle

         call k_plus_G_vectors_m( ik, kgp, kg1, kv3, iba, nbase, vkxyz, ngabc, &
              &                   rltv, qx, qy, qz )

         Do ib2=1, neg
            wk_zaj = 0.0d0
            if ( map_e(ib2) == myrank_e ) then
               wk_zaj(1:iba(ik),1:kimg) = zaj_l(1:iba(ik),map_z(ib2),ik,1:kimg)
            endif
            call mpi_bcast( wk_zaj, kg1*kimg, mpi_double_precision, map_e(ib2), &
                 &          mpi_k_world(myrank_k), ierr )

            Do ib1=ista_e, iend_e, istep_e
               zsum = 0.0d0
               if ( kimg == 1 ) then
                  Do ig=1, kg1
                     c1 = zaj_l(ig,map_z(ib1),ik,1)
                     c2 = c1 *wk_zaj(ig,1)
                     zsum(1) = zsum(1) +c2 *qx(ig)
                     zsum(2) = zsum(2) +c2 *qy(ig)
                     zsum(3) = zsum(3) +c2 *qz(ig)
                  End do
               else
                  Do ig=1, kg1
                     z1 = dcmplx( zaj_l(ig,map_z(ib1),ik,1), zaj_l(ig,map_z(ib1),ik,2) )
                     z2 = conjg(z1) *dcmplx( wk_zaj(ig,1), wk_zaj(ig,2) )
                     zsum(1) = zsum(1) +z2 *qx(ig)
                     zsum(2) = zsum(2) +z2 *qy(ig)
                     zsum(3) = zsum(3) +z2 *qz(ig)
                  End do
               endif
               trm_vv( map_z(ib1), ib2, ik, 1:3 ) = zsum(1:3)
            End do
         End do
      End Do

      trm_vv = trm_vv *zi

      deallocate( wk_zaj )
      deallocate( qx ); deallocate( qy ); deallocate( qz )

    end subroutine calc_soft_part

    subroutine calc_hard_part
      integer :: ia, it, ik, ib1, ib2
      integer :: lmt1, lmt2, il1, il2, im1, im2, it1, it2, itmp
      integer :: lmta1, lmta2
      real(kind=DP) :: fac
      complex(kind=CMPLDP) :: z1, z2, wf1, wf2
      complex(kind=CMPLDP), allocatable :: wk_fsri(:)
      complex(kind=CMPLDP), allocatable :: wk_fsri_add(:)

      allocate( wk_fsri(nlmta) ); wk_fsri = 0.0d0
      if ( sw_use_add_proj == ON ) then
         allocate( wk_fsri_add(nlmta_add) ); wk_fsri_add = 0.0d0
      endif

      Do ia=1, natm
         it = ityp(ia)

         Do ik=1, kv3
            if ( map_k(ik) /= myrank_k ) cycle

            Do ib2=1, neg
               wk_fsri = 0.0d0
               if ( map_e(ib2) == myrank_e ) then
                  wk_fsri(:) = dcmplx( fsr_l( map_z(ib2),:,ik ), &
                       &               fsi_l( map_z(ib2),:,ik ) )
               endif
               call mpi_bcast( wk_fsri, 2*nlmta, mpi_double_precision, map_e(ib2), &
                    &          mpi_k_world(myrank_k), ierr )

               if ( sw_use_add_proj == ON ) then
                  wk_fsri_add = 0.0d0
                  if ( map_e(ib2) == myrank_e ) then
                     wk_fsri_add(:) = dcmplx( fsr_add_l( map_z(ib2),:,ik ), &
                          &                   fsi_add_l( map_z(ib2),:,ik ) )
                  endif
                  call mpi_bcast( wk_fsri_add, 2*nlmta_add, mpi_double_precision, &
                       &          map_e(ib2), mpi_k_world(myrank_k), ierr )
               endif

               DO ib1=ista_e, iend_e, istep_e

                  Do lmt1=1, ilmt_val(it)
                     if ( lmt1 <= ilmt(it) ) then
                        il1 = ltp(lmt1,it); it1 = taup(lmt1,it)
                        lmta1 = lmta( lmt1,ia )
                        wf1 = dcmplx( fsr_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_l( map_z(ib1), lmta1, ik ) )
                     else
                        itmp = lmt1 -ilmt(it)

                        il1 = ltp_add(itmp,it); it1 = 1
                        lmta1 = lmta_add( itmp,ia )
                        wf1 = dcmplx( fsr_add_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_add_l( map_z(ib1), lmta1, ik ) )
                     endif

                     Do lmt2=1, ilmt_val(it)
                        fac = 1.0d0

                        if ( lmt2 <= ilmt(it) ) then
                           il2 = ltp(lmt2,it); it2 = taup(lmt2,it)
                           lmta2 = lmta( lmt2,ia )
                           wf2 = wk_fsri(lmta2)
                        else
                           itmp = lmt2 -ilmt(it)

                           il2 = ltp_add( itmp,it); it2 = 1
                           lmta2 = lmta_add( itmp,ia )
                           wf2 = wk_fsri_add(lmta2)
                        endif

                        z1 = conjg(wf1) *wf2

                        trm_vv( map_z(ib1), ib2, ik, 1:3 ) &
                             &  = trm_vv( map_z(ib1), ib2, ik, 1:3 ) &
                             &    + z1 *Mat_Dipole_Corr_vv( it,lmt1,lmt2,1:3 )
                     End do
                  End Do
               End Do
            End DO
         End Do
      End Do

      deallocate( wk_fsri )
      if ( allocated( wk_fsri_add ) ) deallocate( wk_fsri_add )

    end subroutine calc_hard_part

  end subroutine m_XI_calc_transition_moment_vv

  subroutine m_XI_set_RhoTilde_vv

    allocate( RhoTilde_vv( nmax_G, np_e, neg, ista_k:iend_k ) )
    RhoTilde_vv = 0.0d0

    call calc_soft_part
    call calc_hard_part

  contains

    subroutine calc_soft_part
      integer :: ik, ib1, ib2, i, i1, ngrid
      real(kind=DP), allocatable :: afft(:), bfft(:), cfft(:)
      real(kind=DP), allocatable :: psi_l(:,:,:,:)

      allocate( afft(nfft) ); afft = 0.0d0
      allocate( bfft(nfft) ); bfft = 0.0d0
      allocate( cfft(nfft) ); cfft = 0.0d0

      call m_FFT_alloc_WF_work()
! --
      ngrid = product(fft_box_size_WF(1:3,1))

      Do ik=1, kv3
         if ( map_k(ik) /= myrank_k ) cycle

         allocate( psi_l( kg1, np_e, ik:ik, kimg ) ); psi_l = 0.0d0

         Do ib2=1, neg
            bfft = 0.0d0
            if ( map_e(ib2) == myrank_e ) then
               psi_l(1:iba(ik),map_z(ib2),ik,:) = zaj_l(1:iba(ik),map_z(ib2),ik,:)
               call m_ES_WF_in_Rspace1( ik, ik, ik, ib2, psi_l, bfft )
            endif
            call mpi_bcast( bfft, nfft, mpi_double_precision, map_e(ib2), &
                 &          mpi_k_world(myrank_k), ierr )

            Do ib1=ista_e, iend_e, istep_e
               psi_l(1:iba(ik),map_z(ib1),ik,:) = zaj_l(1:iba(ik),map_z(ib1),ik,:)
               call m_ES_WF_in_Rspace1( ik, ik, ik, ib1, psi_l, afft )

               cfft = 0.0d0
               if ( imple_method == 1 ) then
                  Do i=1, nfft, 2
                     cfft(i)   = afft(i)*bfft(i)   +afft(i+1)*bfft(i+1)
                     cfft(i+1) =-afft(i)*bfft(i+1) +afft(i+1)*bfft(i)
                  End Do
               else
                  Do i=1, nfft, 2
                     cfft(i)   = afft(i)*bfft(i)   +afft(i+1)*bfft(i+1)
                     cfft(i+1) = afft(i)*bfft(i+1) -afft(i+1)*bfft(i)
                  End do
               endif

               call m_FFT_WF( ELECTRON, nfout, cfft, DIRECT, OFF )    ! R-->G
               cfft = cfft /dble(ngrid)

               if ( kimg == 1 ) then
                  Do i=1, nmax_G
                     i1 = igf( nbase(i,ik) )
                     RhoTilde_vv( i, map_z(ib1), ib2, ik ) = cfft(i1)
                  End do
               else
                  if ( imple_method == 2  ) then
                     Do i=1, nmax_G
                        i1 =2*igf( nbase(i,ik) ) -1
                        RhoTilde_vv( i, map_z(ib1), ib2, ik ) &
                             &          = dcmplx( cfft(i1), -cfft(i1+1) )  
                     End do
                  else
                     Do i=1, nmax_G
                        i1 =2*igf( nbase(i,ik) ) -1
                        RhoTilde_vv( i, map_z(ib1), ib2, ik ) &
                             &          = dcmplx( cfft(i1), cfft(i1+1) )   
                     End do
                  endif
               endif
            End Do
         End Do

         deallocate( psi_l )
      End Do

      deallocate( afft ); deallocate( bfft ); deallocate( cfft )
      call m_FFT_dealloc_WF_work()

    end subroutine calc_soft_part

    subroutine calc_hard_part
      integer :: ik, ib1, ib2, ia, it, ig
      integer :: lmt1, lmt2, it1, it2, il1, il2, n
      integer :: lmta1, lmta2, ilm3, l3, iiqitg, mdvdb
      real(kind=DP) :: fac
      complex(kind=CMPLDP) :: wf1, wf2, z1, z2, zph

      integer, allocatable :: il3(:)
      real(kind=DP), allocatable :: zfsin(:), zfcos(:), qx(:), qy(:), qz(:), ylm(:)
      complex(kind=CMPLDP), allocatable :: wk_fsri(:), wk_fsri_add(:)

      integer :: j, itmp

! -- init
      allocate( zfcos( nmax_G ) ); zfcos = 0.0d0
      allocate( zfsin( nmax_G ) ); zfsin = 0.0d0

      n = nloc
      n=(n-1)+(n-1)+1

      allocate(il3(n**2));call substitute_il3(n**2,il3)

      allocate( qx(nmax_G) ); allocate( qy(nmax_G) ); allocate( qz(nmax_G) )
      allocate( ylm(nmax_G) )

      Do ig=1, nmax_G
         qx(ig) = rltv(1,1)*ngabc(ig,1) +rltv(1,2)*ngabc(ig,2) +rltv(1,3)*ngabc(ig,3)
         qy(ig) = rltv(2,1)*ngabc(ig,1) +rltv(2,2)*ngabc(ig,2) +rltv(2,3)*ngabc(ig,3)
         qz(ig) = rltv(3,1)*ngabc(ig,1) +rltv(3,2)*ngabc(ig,2) +rltv(3,3)*ngabc(ig,3)
      End do

      allocate( wk_fsri(nlmta) ); wk_fsri = 0.0d0
      if ( sw_use_add_proj == ON ) then
         allocate( wk_fsri_add(nlmta_add) ); wk_fsri_add = 0.0d0
      endif

! -- start
      Do ia=1, natm
         it = ityp(ia)

         call calc_phase2(natm,pos,ia,kgp,ngabc,1,nmax_G,zfcos,zfsin)

         Do ik=1, kv3
            if ( map_k(ik) /= myrank_k ) cycle

            Do ib2=1, neg
               wk_fsri = 0.0d0
               if ( map_e(ib2) == myrank_e ) then
                  wk_fsri(:) = dcmplx( fsr_l( map_z(ib2),:,ik ), &
                       &               fsi_l( map_z(ib2),:,ik ) )
               endif
               call mpi_bcast( wk_fsri, 2*nlmta, mpi_double_precision, map_e(ib2), &
                    &          mpi_k_world(myrank_k), ierr )

               if ( sw_use_add_proj == ON ) then
                  wk_fsri_add = 0.0d0
                  if ( map_e(ib2) == myrank_e ) then
                     wk_fsri_add(:) = dcmplx( fsr_add_l( map_z(ib2),:,ik ), &
                          &                   fsi_add_l( map_z(ib2),:,ik ) )
                  endif
                  call mpi_bcast( wk_fsri_add, 2*nlmta_add, mpi_double_precision, &
                       &          map_e(ib2), mpi_k_world(myrank_k), ierr )
               endif

               DO ib1=ista_e, iend_e, istep_e

                  Do lmt1=1, ilmt_val(it)
                     if ( lmt1 <= ilmt(it) ) then
                        il1 = ltp(lmt1,it); it1 = taup(lmt1,it)
                        lmta1 = lmta( lmt1,ia )
                        wf1 = dcmplx( fsr_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_l( map_z(ib1), lmta1, ik ) )
                     else
                        itmp = lmt1 -ilmt(it)

                        il1 = ltp_add(itmp,it); it1 = 1
                        lmta1 = lmta_add( itmp,ia )
                        wf1 = dcmplx( fsr_add_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_add_l( map_z(ib1), lmta1, ik ) )
                     endif

!#if 0
!                     Do lmt2=lmt1, ilmt(it)
!#else
                     Do lmt2=1, ilmt_val(it)
!#endif
                        if ( lmt2 <= ilmt(it) ) then
                           il2 = ltp(lmt2,it); it2 = taup(lmt2,it)
                           lmta2 = lmta( lmt2,ia )
                           wf2 = wk_fsri(lmta2)
                        else
                           itmp = lmt2 -ilmt(it)

                           il2 = ltp_add( itmp,it); it2 = 1
                           lmta2 = lmta_add( itmp,ia )
                           wf2 = wk_fsri_add(lmta2)
                        endif

!#if 0
!                        if ( lmt1 == lmt2 ) then
!                           fac = 1.0d0
!                        else
!                           fac = 2.0d0
!                        endif
!#else
                        fac = 1.0d0
!#endif
                        do n=1,il2p_XI_vv(lmt1,lmt2,it)

                           ilm3 = isph_XI_vv(lmt1,lmt2,n,it); l3=il3(ilm3)
                           iiqitg = iqitg_XI_vv(il1,it1,il2,it2,l3+1,it)

                           if(iiqitg == 0) cycle

                           call sphr( nmax_G, ilm3, qx, qy, qz, ylm )

!#if 0
!                           z1 = conjg(wf1) *wf2
!                           z2 = wf1 *conjg(wf2)
!                           z1 = ( z1+z2) /2.0d0 *zi**l3 *dl2p(lmt1,lmt2,n,it)
!#else
                           z1 = conjg(wf1) *wf2 *zi**l3 *dl2p_XI_vv(lmt1,lmt2,n,it)
!#endif
                           if ( imple_method == 1 ) then
                              Do ig=1, nmax_G
                                 z2 = qitg_XI_vv( ig,iiqitg ) *ylm(ig)
                                 zph = dcmplx( zfcos(ig), -zfsin(ig) )   

                                 RhoTilde_vv( ig, map_z(ib1), ib2, ik ) &
                                      & = RhoTilde_vv( ig, map_z(ib1), ib2, ik ) &
                                      &   + fac *z1 *z2 *zph
                              End do
                           else
                              Do ig=1, nmax_G
                                 z2 = qitg_XI_vv( ig,iiqitg ) *ylm(ig)
                                 zph = dcmplx( zfcos(ig), zfsin(ig) )     

                                 RhoTilde_vv( ig, map_z(ib1), ib2, ik ) &
                                      & = RhoTilde_vv( ig, map_z(ib1), ib2, ik ) &
                                      &   + fac *z1 *z2 *zph
                              End do
                           endif

                        End do
                     End do
                 End do
               End do
            End Do
         End DO
      End Do

      deallocate( il3 ); deallocate( ylm )
      deallocate( qx ); deallocate( qy ); deallocate( qz );
      deallocate( zfcos ); deallocate( zfsin )

      deallocate( wk_fsri )
      if ( allocated( wk_fsri_add ) ) deallocate( wk_fsri_add )

    end subroutine calc_hard_part

  end subroutine m_XI_set_RhoTilde_vv

! --------------------------------------------------------
!    Calculation of transtion moment/matrix (val-core)
! --------------------------------------------------------

  subroutine m_XI_calc_transition_moment_vc

    if ( allocated( trm_vc ) ) deallocate( trm_vc )
    allocate( trm_vc( np_e, num_core_states, ista_k:iend_k, 3 ) ); trm_vc = 0.0d0

    call calc_soft_part
    call calc_hard_part
    call multiply_factor

  contains

    subroutine multiply_factor
      integer :: ik, ib1, ib2, is
      real(kind=DP) :: ediff
      real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)

      allocate( eko_wk( num_core_states ) ); eko_wk = 0.0d0

      Do ik=1, kv3, ndim_spinor
         if ( map_k(ik) /= myrank_k ) cycle

         eko_wk = ene_core_states

         Do ib2=1, num_core_states
            Do ib1=ista_e, iend_e, istep_e
               ediff = eko_wk(ib2) -eko_l(map_z(ib1),ik)

               if ( abs(ediff) < delta_omega ) then
                  if ( ediff >= 0.0 ) then
                     ediff = delta_omega
                  else
                     ediff = -delta_omega
                  endif
               else
                  if ( sw_scissor_renormalization == ON ) then
                     if ( eko_l(map_z(ib1),ik ) > efermi ) then
                        ediff = ediff -scissor
                     endif
                  endif
               endif

               Do is=1, ndim_spinor
                  trm_vc( map_z(ib1),ib2,ik+is-1,: ) &
                       &   = trm_vc( map_z(ib1),ib2,ik+is-1,: ) /ediff
               End do

            End Do
         End Do
      End Do

      deallocate( eko_wk )

    end subroutine multiply_factor

    subroutine calc_soft_part
      integer :: ik, ib1, ib2, ig
      real(kind=DP), allocatable :: qx(:), qy(:), qz(:)
      real(kind=DP), allocatable :: wk_zaj(:,:)
      real(kind=DP) :: c1, c2
      complex(kind=CMPLDP) :: z1, z2, zsum(3)

      allocate( wk_zaj( kg1, kimg ) ); wk_zaj = 0.0d0

      allocate( qx(kg1) );  allocate( qy(kg1) ); allocate( qz(kg1) );
      qx = 0.0d0;  qy = 0.0d0;  qz = 0.0d0

      Do ik=1, kv3
         if ( map_k(ik) /= myrank_k ) cycle

         call k_plus_G_vectors_m( ik, kgp, kg1, kv3, iba, nbase, vkxyz, ngabc, &
              &                   rltv, qx, qy, qz )

         Do ib2=1, num_core_states
            wk_zaj(1:iba(ik),1:kimg) = psig_core_states(1:iba(ik),ib2,ik,1:kimg)

            Do ib1=ista_e, iend_e, istep_e
               zsum = 0.0d0
               if ( kimg == 1 ) then
                  Do ig=1, kg1
                     c1 = zaj_l(ig,map_z(ib1),ik,1)
                     c2 = c1 *wk_zaj(ig,1)
                     zsum(1) = zsum(1) +c2 *qx(ig)
                     zsum(2) = zsum(2) +c2 *qy(ig)
                     zsum(3) = zsum(3) +c2 *qz(ig)
                  End do
               else
                  Do ig=1, kg1
                     z1 = dcmplx( zaj_l(ig,map_z(ib1),ik,1), zaj_l(ig,map_z(ib1),ik,2) )
                     z2 = conjg(z1) *dcmplx( wk_zaj(ig,1), wk_zaj(ig,2) )
                     zsum(1) = zsum(1) +z2 *qx(ig)
                     zsum(2) = zsum(2) +z2 *qy(ig)
                     zsum(3) = zsum(3) +z2 *qz(ig)
                  End do
               endif
               trm_vc( map_z(ib1), ib2, ik, 1:3 ) = zsum(1:3)
            End do
         End do
      End Do

      trm_vc = trm_vc *zi

      deallocate( wk_zaj )
      deallocate( qx ); deallocate( qy ); deallocate( qz )

    end subroutine calc_soft_part

    subroutine calc_hard_part
      integer :: ia, it, ik, ib1, ib2
      integer :: lmt1, lmt2, il1, il2, im1, im2, it1, it2, itmp
      integer :: lmta1, lmta2, atomtype_to_probe
      real(kind=DP) :: fac
      complex(kind=CMPLDP) :: z1, z2, wf1, wf2
      complex(kind=CMPLDP), allocatable :: wk_fsri(:)
      complex(kind=CMPLDP), allocatable :: wk_fsri_add(:)

      allocate( wk_fsri(nlmt_core) ); wk_fsri = 0.0d0

      atomtype_to_probe = ityp( atom_to_probe )
      it = atomtype_to_probe

      Do ia = atom_to_probe, atom_to_probe
         it = ityp(ia)

         Do ik=1, kv3
            if ( map_k(ik) /= myrank_k ) cycle

            Do ib2=1, num_core_states
               wk_fsri(:) = dcmplx( fsr_core_states( ib2,:,ik ), &
                    &               fsi_core_states( ib2,:,ik ) )

               DO ib1=ista_e, iend_e, istep_e

                  Do lmt1=1, ilmt_val(it)
                     if ( lmt1 <= ilmt(it) ) then
                        il1 = ltp(lmt1,it); it1 = taup(lmt1,it)
                        lmta1 = lmta( lmt1,ia )
                        wf1 = dcmplx( fsr_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_l( map_z(ib1), lmta1, ik ) )
                     else
                        itmp = lmt1 -ilmt(it)

                        il1 = ltp_add(itmp,it); it1 = 1
                        lmta1 = lmta_add( itmp,ia )
                        wf1 = dcmplx( fsr_add_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_add_l( map_z(ib1), lmta1, ik ) )
                     endif

                     Do lmt2=1, nlmt_core
                        fac = 1.0d0

                        wf2 = wk_fsri(lmt2)
                        z1 = conjg(wf1) *wf2

                        trm_vc( map_z(ib1), ib2, ik, 1:3 ) &
                             &  = trm_vc( map_z(ib1), ib2, ik, 1:3 ) &
                             &    + z1 *Mat_Dipole_Corr_vc( lmt1,lmt2,1:3 )
                     End do
                  End Do
               End Do
            End DO
         End Do
      End Do

      deallocate( wk_fsri )

    end subroutine calc_hard_part

  end subroutine m_XI_calc_transition_moment_vc

  subroutine m_XI_set_RhoTilde_vc

    allocate( RhoTilde_vc( nmax_G, np_e, num_core_states, ista_k:iend_k ) )
    RhoTilde_vc = 0.0d0

    call calc_soft_part
    call calc_hard_part

  contains

    subroutine calc_soft_part
      integer :: ik, ib1, ib2, i, i1, ngrid
      real(kind=DP), allocatable :: afft(:), bfft(:), cfft(:)
      real(kind=DP), allocatable :: psi_l(:,:,:,:)

      allocate( afft(nfft) ); afft = 0.0d0
      allocate( bfft(nfft) ); bfft = 0.0d0
      allocate( cfft(nfft) ); cfft = 0.0d0

      call m_FFT_alloc_WF_work()
! --
      ngrid = product(fft_box_size_WF(1:3,1))

      Do ik=1, kv3
         if ( map_k(ik) /= myrank_k ) cycle

         allocate( psi_l( kg1, 1, ik:ik, kimg ) ); psi_l = 0.0d0

         Do ib2=1, num_core_states
            bfft = 0.0d0
            psi_l(1:iba(ik),1,ik,:) = psig_core_states(1:iba(ik),ib2,ik,:)
            call m_ES_WF_in_Rspace_kt( ik, ik, ik, psi_l, bfft )

            Do ib1=ista_e, iend_e, istep_e
               psi_l(1:iba(ik),1,ik,:) = zaj_l(1:iba(ik),map_z(ib1),ik,:)
               call m_ES_WF_in_Rspace_kt( ik, ik, ik, psi_l, afft )

               cfft = 0.0d0
               if ( imple_method == 1 ) then
                  Do i=1, nfft, 2
                     cfft(i)   = afft(i)*bfft(i)   +afft(i+1)*bfft(i+1)
                     cfft(i+1) =-afft(i)*bfft(i+1) +afft(i+1)*bfft(i)
                  End Do
               else
                  Do i=1, nfft, 2
                     cfft(i)   = afft(i)*bfft(i)   +afft(i+1)*bfft(i+1)
                     cfft(i+1) = afft(i)*bfft(i+1) -afft(i+1)*bfft(i)
                  End do
               endif

               call m_FFT_WF( ELECTRON, nfout, cfft, DIRECT, OFF )    ! R-->G
               cfft = cfft /dble(ngrid)

               if ( kimg == 1 ) then
                  Do i=1, nmax_G
                     i1 = igf( nbase(i,ik) )
                     RhoTilde_vc( i, map_z(ib1), ib2, ik ) = cfft(i1)
                  End do
               else
                  if ( imple_method == 1 ) then
                     Do i=1, nmax_G
                        i1 =2*igf( nbase(i,ik) ) -1
                        RhoTilde_vc( i, map_z(ib1), ib2, ik ) &
                             &          = dcmplx( cfft(i1), -cfft(i1+1) )  ! gpaw
                     End do
                  else
                     Do i=1, nmax_G
                        i1 =2*igf( nbase(i,ik) ) -1
                        RhoTilde_vc( i, map_z(ib1), ib2, ik ) &
                             &          = dcmplx( cfft(i1), cfft(i1+1) )
                     End do
                  endif
               endif
            End Do
         End Do

         deallocate( psi_l )
      End Do

      deallocate( afft ); deallocate( bfft ); deallocate( cfft )
      call m_FFT_dealloc_WF_work()

    end subroutine calc_soft_part

    subroutine calc_hard_part
      integer :: ik, ib1, ib2, ia, it, ig
      integer :: lmt1, lmt2, it1, it2, il1, il2, n
      integer :: lmta1, lmta2, ilm3, l3, iiqitg, mdvdb
      real(kind=DP) :: fac
      complex(kind=CMPLDP) :: wf1, wf2, z1, z2, zph

      integer, allocatable :: il3(:)
      real(kind=DP), allocatable :: zfsin(:), zfcos(:), qx(:), qy(:), qz(:), ylm(:)
      complex(kind=CMPLDP), allocatable :: wk_fsri(:)
      complex(kind=CMPLDP), allocatable :: wk_fsri_add(:)

      integer :: j, itmp

! -- init
      allocate( zfcos( nmax_G ) ); zfcos = 0.0d0
      allocate( zfsin( nmax_G ) ); zfsin = 0.0d0

      n = nloc
      n=(n-1)+(n-1)+1

      allocate(il3(n**2));call substitute_il3(n**2,il3)

      allocate( qx(nmax_G) ); allocate( qy(nmax_G) ); allocate( qz(nmax_G) )
      allocate( ylm(nmax_G) )

      Do ig=1, nmax_G
         qx(ig) = rltv(1,1)*ngabc(ig,1) +rltv(1,2)*ngabc(ig,2) +rltv(1,3)*ngabc(ig,3)
         qy(ig) = rltv(2,1)*ngabc(ig,1) +rltv(2,2)*ngabc(ig,2) +rltv(2,3)*ngabc(ig,3)
         qz(ig) = rltv(3,1)*ngabc(ig,1) +rltv(3,2)*ngabc(ig,2) +rltv(3,3)*ngabc(ig,3)
      End do

      allocate( wk_fsri(nlmt_core) ); wk_fsri = 0.0d0

! -- start
      Do ia=1, natm
         it = ityp(ia)

         call calc_phase2(natm,pos,ia,kgp,ngabc,1,nmax_G,zfcos,zfsin)

         Do ik=1, kv3
            if ( map_k(ik) /= myrank_k ) cycle

            Do ib2=1, num_core_states
               wk_fsri = 0.0d0
               wk_fsri(:) = dcmplx( fsr_core_states( ib2,:,ik ), &
                       &            fsi_core_states( ib2,:,ik ) )
               
               DO ib1=ista_e, iend_e, istep_e

                  Do lmt1=1, ilmt_val(it)
                     if ( lmt1 <= ilmt(it) ) then
                        il1 = ltp(lmt1,it); it1 = taup(lmt1,it)
                        lmta1 = lmta( lmt1,ia )
                        wf1 = dcmplx( fsr_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_l( map_z(ib1), lmta1, ik ) )
                     else
                        itmp = lmt1 -ilmt(it)

                        il1 = ltp_add(itmp,it); it1 = 1
                        lmta1 = lmta_add( itmp,ia )
                        wf1 = dcmplx( fsr_add_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_add_l( map_z(ib1), lmta1, ik ) )
                     endif

                     Do lmt2=1, nlmt_core
                        il2 = qnum_l_to_probe +1; it2 = 1
                        wf2 = wk_fsri(lmt2)

                        fac = 1.0d0

                        do n=1,il2p_XI_vc(lmt1,lmt2)

                           ilm3 = isph_XI_vc(lmt1,lmt2,n); l3=il3(ilm3)
                           iiqitg = iqitg_XI_vc(il1,it1,l3+1)

                           if(iiqitg == 0) cycle

                           call sphr( nmax_G, ilm3, qx, qy, qz, ylm )

!#if 0
!                           z1 = conjg(wf1) *wf2
!                           z2 = wf1 *conjg(wf2)
!                           z1 = ( z1+z2) /2.0d0 *zi**l3 *dl2p(lmt1,lmt2,n,it)
!#else
                           z1 = conjg(wf1) *wf2 *zi**l3 *dl2p_XI_vc(lmt1,lmt2,n)
!#endif
                           if ( imple_method == 1 ) then
                              Do ig=1, nmax_G
                                 z2 = qitg_XI_vc( ig,iiqitg ) *ylm(ig)
                                 zph = dcmplx( zfcos(ig), -zfsin(ig) )

                                 RhoTilde_vc( ig, map_z(ib1), ib2, ik ) &
                                      & = RhoTilde_vc( ig, map_z(ib1), ib2, ik ) &
                                      &   + fac *z1 *z2 *zph
                              End do
                           else
                              Do ig=1, nmax_G
                                 z2 = qitg_XI_vc( ig,iiqitg ) *ylm(ig)
                                 zph = dcmplx( zfcos(ig), zfsin(ig) ) 

                                 RhoTilde_vc( ig, map_z(ib1), ib2, ik ) &
                                      & = RhoTilde_vc( ig, map_z(ib1), ib2, ik ) &
                                      &   + fac *z1 *z2 *zph
                              End do
                           endif

                        End do
                     End do
                  End do
               End do
            End Do
         End DO
      End Do

      deallocate( il3 );  deallocate( ylm )
      deallocate( qx ); deallocate( qy ); deallocate( qz )
      deallocate( zfcos ); deallocate( zfsin )

      deallocate( wk_fsri )

    end subroutine calc_hard_part

  end subroutine m_XI_set_RhoTilde_vc

! --------------------------------------------------------
!    Calculation of transtion moment/matrix (core-core)
! --------------------------------------------------------
  subroutine m_XI_calc_transition_moment_cc
!
    if ( allocated( trm_cc ) ) deallocate( trm_cc )
    allocate( trm_cc( num_core_states, num_core_states, ista_k:iend_k, 3 ) );
    trm_cc = 0.0d0

    call calc_soft_part
    call multiply_factor

  contains

    subroutine multiply_factor
      integer :: ik, ib1, ib2, is
      real(kind=DP) :: ediff
      real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)

      Do ik=1, kv3, ndim_spinor
         if ( map_k(ik) /= myrank_k ) cycle

         Do ib2=1, num_core_states
            Do ib1=1, num_core_states

               ediff = ene_core_states(ib2) -ene_core_states(ib1)

               if ( ib2 == ib1 ) then
                  ediff = delta_omega
               else if ( abs(ediff) < delta_omega ) then
                  if ( ediff >= 0.0 ) then
                     ediff = delta_omega
                  else
                     ediff = -delta_omega
                  endif
               endif

               Do is=1, ndim_spinor
                  trm_cc( ib1,ib2,ik+is-1,: ) &
                       &   = trm_cc( ib1,ib2,ik+is-1,: ) /ediff
               End do

            End Do
         End Do
      End Do

    end subroutine multiply_factor

    subroutine calc_soft_part
      integer :: ik, ib1, ib2, ig
      real(kind=DP), allocatable :: qx(:), qy(:), qz(:)
      real(kind=DP), allocatable :: wk_zaj(:,:)
      real(kind=DP) :: c1, c2
      complex(kind=CMPLDP) :: z1, z2, zsum(3)

      allocate( qx(kg1) );  allocate( qy(kg1) ); allocate( qz(kg1) );
      qx = 0.0d0;  qy = 0.0d0;  qz = 0.0d0

      Do ik=1, kv3
         if ( map_k(ik) /= myrank_k ) cycle

         call k_plus_G_vectors_m( ik, kgp, kg1, kv3, iba, nbase, vkxyz, ngabc, &
              &                   rltv, qx, qy, qz )

         Do ib2=1, num_core_states

            Do ib1=1, num_core_states
               zsum = 0.0d0
               if ( kimg == 1 ) then
                  Do ig=1, kg1
                     c1 = psig_core_states(ig,ib1,ik,1)
                     c2 = c1 *psig_core_states(ig,ib2,ik,1)

                     zsum(1) = zsum(1) +c2 *qx(ig)
                     zsum(2) = zsum(2) +c2 *qy(ig)
                     zsum(3) = zsum(3) +c2 *qz(ig)
                  End do
               else
                  Do ig=1, kg1
                     z1 = dcmplx( psig_core_states(ig,ib1,ik,1), &
                          &       psig_core_states(ig,ib1,ik,2) )
                     z2 = conjg(z1) *dcmplx( psig_core_states(ig,ib2,ik,1), &
                          &                  psig_core_states(ig,ib2,ik,2) )

                     zsum(1) = zsum(1) +z2 *qx(ig)
                     zsum(2) = zsum(2) +z2 *qy(ig)
                     zsum(3) = zsum(3) +z2 *qz(ig)
                  End do
               endif
               trm_cc( ib1, ib2, ik, 1:3 ) = zsum(1:3)
            End do
         End do
      End Do
      trm_cc = trm_cc *zi

      deallocate( qx ); deallocate( qy ); deallocate( qz )

    end subroutine calc_soft_part

  end subroutine m_XI_calc_transition_moment_cc

  subroutine m_XI_set_RhoTilde_cc

    allocate( RhoTilde_cc( nmax_G, num_core_states, num_core_states, ista_k:iend_k ) )
    RhoTilde_cc = 0.0d0

    call calc_soft_part

  contains
    subroutine calc_soft_part
      integer :: ik, ib1, ib2, i, i1, ngrid
      real(kind=DP), allocatable :: afft(:), bfft(:), cfft(:)
      real(kind=DP), allocatable :: psi_l(:,:,:,:)

      allocate( afft(nfft) ); afft = 0.0d0
      allocate( bfft(nfft) ); bfft = 0.0d0
      allocate( cfft(nfft) ); cfft = 0.0d0

      call m_FFT_alloc_WF_work()
! --
      ngrid = product(fft_box_size_WF(1:3,1))

      Do ik=1, kv3
         if ( map_k(ik) /= myrank_k ) cycle

         allocate( psi_l( kg1, 1, ik:ik, kimg ) ); psi_l = 0.0d0

         Do ib2=1, num_core_states
            bfft = 0.0d0
            psi_l(1:iba(ik),1,ik,:) = psig_core_states(1:iba(ik),ib2,ik,:)
            call m_ES_WF_in_Rspace_kt( ik, ik, ik, psi_l, bfft )

            Do ib1=1, num_core_states
               psi_l(1:iba(ik),1,ik,:) = psig_core_states(1:iba(ik),ib1,ik,:)
               call m_ES_WF_in_Rspace_kt( ik, ik, ik, psi_l, afft )

               cfft = 0.0d0
               if ( imple_method == 1 ) then
                  Do i=1, nfft, 2
                     cfft(i)   = afft(i)*bfft(i)   +afft(i+1)*bfft(i+1)
                     cfft(i+1) =-afft(i)*bfft(i+1) +afft(i+1)*bfft(i)
                  End Do
               else
                  Do i=1, nfft, 2
                     cfft(i)   = afft(i)*bfft(i)   +afft(i+1)*bfft(i+1)
                     cfft(i+1) = afft(i)*bfft(i+1) -afft(i+1)*bfft(i)
                  End do
               endif

               call m_FFT_WF( ELECTRON, nfout, cfft, DIRECT, OFF )    ! R-->G
               cfft = cfft /dble(ngrid)

               if ( kimg == 1 ) then
                  Do i=1, nmax_G
                     i1 = igf( nbase(i,ik) )
                     RhoTilde_cc( i, ib1, ib2, ik ) = cfft(i1)
                  End do
               else
                  if ( imple_method == 1 ) then
                     Do i=1, nmax_G
                        i1 =2*igf( nbase(i,ik) ) -1
                        RhoTilde_cc( i, ib1, ib2, ik ) &
                             &          = dcmplx( cfft(i1), -cfft(i1+1) )  ! gpaw
                     End do
                  else
                     Do i=1, nmax_G
                        i1 =2*igf( nbase(i,ik) ) -1
                        RhoTilde_cc( i, ib1, ib2, ik ) &
                             &          = dcmplx( cfft(i1), cfft(i1+1) )
                     End do
                  endif

               endif
            End Do
         End Do

         deallocate( psi_l )
      End Do

      deallocate( afft ); deallocate( bfft ); deallocate( cfft )
      call m_FFT_dealloc_WF_work()

    end subroutine calc_soft_part

  end subroutine m_XI_set_RhoTilde_cc

! --------------------------------------------------------
!    Finalization
! --------------------------------------------------------

  subroutine m_XI_dealloc_arrays
    if ( allocated(ilmt_val) ) deallocate( ilmt_val )
    if ( allocated(ngpt_XI) ) deallocate( ngpt_XI )

! val-val
    if ( allocated( iqitg_XI_vv ) ) deallocate( iqitg_XI_vv )
    if ( allocated( nqitg_XI_vv ) ) deallocate( nqitg_XI_vv )
    if ( allocated(  qitg_XI_vv ) ) deallocate(  qitg_XI_vv )
    if ( allocated(  isph_XI_vv ) ) deallocate(  isph_XI_vv )
    if ( allocated(  il2p_XI_vv ) ) deallocate(  il2p_XI_vv )
    if ( allocated(  dl2p_XI_vv ) ) deallocate(  dl2p_XI_vv )
!
    if ( allocated( Mat_dipole_corr_vv ) ) deallocate( Mat_dipole_corr_vv )

    if ( allocated( trm_vv ) )  deallocate( trm_vv )
    if ( allocated( RhoTilde_vv ) ) deallocate( RhoTilde_vv )
    if ( allocated( SpectrFn_vv ) ) deallocate( SpectrFn_vv )
    if ( allocated( SpectrTensor_vv ) ) deallocate( SpectrTensor_vv )

! val-core
    if ( allocated( iqitg_XI_vc ) ) deallocate( iqitg_XI_vc )
    if ( allocated(  qitg_XI_vc ) ) deallocate(  qitg_XI_vc )
    if ( allocated(  isph_XI_vc ) ) deallocate(  isph_XI_vc )
    if ( allocated(  il2p_XI_vc ) ) deallocate(  il2p_XI_vc )
    if ( allocated(  dl2p_XI_vc ) ) deallocate(  dl2p_XI_vc )
!
    if ( allocated( Mat_dipole_corr_vc ) ) deallocate( Mat_dipole_corr_vc )

    if ( allocated( trm_vc ) )  deallocate( trm_vc )
    if ( allocated( RhoTilde_vc ) ) deallocate( RhoTilde_vc )
    if ( allocated( SpectrFn_vc ) ) deallocate( SpectrFn_vc )
    
! core-core
    if ( allocated( trm_cc ) )  deallocate( trm_cc )
    if ( allocated( RhoTilde_cc ) ) deallocate( RhoTilde_cc )

! Kernel
    if ( allocated( Kernel_Coulomb ) ) deallocate( Kernel_Coulomb )

  end subroutine m_XI_dealloc_arrays

! --------------------------------------------------------
!    Spectrum
! --------------------------------------------------------

  subroutine m_XI_init_spectrum
    real(kind=DP) :: emin

    if ( sw_bse == ON ) then
       allocate( epsinv_omega0( nmax_G, nmax_G ) ) ; epsinv_omega0 = 0.0d0
    endif
    call m_Files_open_nf_xi_spectra()

    if ( sw_corelevel_spectrum == ON ) then
       emin = efermi - maxval( ene_core_states ) +scissor
       e_low  = e_low +emin
       e_high = e_high +emin
    endif

#ifdef USE_ASMS_EXCITATION
    call ASMS_XI_setup( nspin, kv3_fbz, univol, nmax_G, qvec, &
         &              way_BZ_integral, width, gaussian_extent, &
         &              nstep, e_low, e_high, e_step, &
         &              nfout, nf_excitation_spectra, &
         &              npes, mype, mpi_comm_group, &
         &              sw_nlf, kernel_xc_type, alpha_LRC, spectrum_type, &
         &              sw_spin_decomposition )
#endif

  end subroutine m_XI_init_spectrum

! --------------------------------------------------------
!    Calculation of SpectrFn (val-val)
! --------------------------------------------------------

  subroutine m_XI_calc_spectr_fn_vv_spindec
    integer :: i, ik, jk, iopr, trev
    integer :: ig1, ig2, itmp, ib1, ib2, is1, is2, ispin
    complex(kind=CMPLDP), allocatable :: work(:,:,:)
    real(kind=DP) :: qvec_rotated(3), weight

    real(kind=DP) :: ediff, odiff, occ1, occ2, qv2, txyz(3), fp
    complex(kind=CMPLDP) :: zrho1, zrho2, ztmp, z1, zph

    real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)
    real(kind=DP), allocatable :: occ_mpi(:), occ_wk(:)
    complex(kind=CMPLDP), allocatable :: ztrm2(:,:)

    allocate( SpectrFn_vv( nmax_G_spin, nmax_G_spin, nstep ) );  SpectrFn_vv = 0.0d0
    allocate( ztrm2( nmax_G_spin, nmax_G_spin ) ); ztrm2 = 0.0d0

    allocate( eko_wk( neg ) ); eko_wk = 0.0d0
    allocate( occ_wk( neg ) ); occ_wk = 0.0d0

    Do ik=1, kv3, ndim_spinor
       if ( map_k(ik) /= myrank_k ) cycle

       eko_wk = 0.0d0
       Do ib1=ista_e, iend_e, istep_e
          eko_wk(ib1) = eko_l( map_z(ib1),ik )
       End do
       if ( npes > 1 ) then
          allocate( eko_mpi( neg ) ); eko_mpi = 0.0d0
          call mpi_allreduce( eko_wk, eko_mpi, neg, mpi_double_precision, mpi_sum, &
               &              mpi_k_world(myrank_k), ierr )
          eko_wk = eko_mpi
          deallocate( eko_mpi )
       endif

       occ_wk = 0.0d0
       Do ib1=ista_e, iend_e, istep_e
          occ_wk(ib1) = occup_l( map_z(ib1),ik )
       End do
       if ( npes > 1 ) then
          allocate( occ_mpi( neg ) ); occ_mpi = 0.0d0
          call mpi_allreduce( occ_wk, occ_mpi, neg, mpi_double_precision, mpi_sum, &
               &              mpi_k_world(myrank_k), ierr )
          occ_wk = occ_mpi
          deallocate( occ_mpi )
       endif

       weight = kv3 *qwgt(ik) /dble(ndim_spinor)

       ispin = 1
       if ( (.not. noncol) .and. nspin == 2 ) then
          ispin = mod( ik-1, 2 )+1
       endif

       Do i=1, num_star_of_k(ik)
          jk = star_of_k(ik,i)
          iopr = iopr_k_fbz_to_ibz(jk)
          trev = trev_k_fbz_to_ibz(jk)

          qvec_rotated = matmul( op(:,:,iopr), qvec(:) )
          if ( trev == 1 ) qvec_rotated = -qvec_rotated

          txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2

          Do ib1=ista_e, iend_e, istep_e
             if ( eko_l( map_z(ib1),ik ) > efermi ) cycle

             Do ib2=1, neg
                if ( eko_wk(ib2) < efermi ) cycle

                ediff = eko_wk(ib2)   -eko_l(map_z(ib1),ik) +scissor
                occ1 = occup_l(map_z(ib1),ik) / weight
                occ2 = occ_wk(ib2) / weight

                if ( imple_method == 1 ) then
                   odiff = occ1 -occ2    
                else
                   odiff = occ1 *( 1.0d0 -occ2 )
                endif

                if ( ediff < 0.0d0 ) cycle

                Do is1=1, ndim_spinor
                   Do is2=1, ndim_spinor

                      Do ig1=1, nmax_G
                         if ( ig1 == 1 ) then
                            zrho1 = trm_vv( map_z(ib1),ib2,ik+is1-1,1 )*qvec_rotated(1) &
                                 & +trm_vv( map_z(ib1),ib2,ik+is1-1,2 )*qvec_rotated(2) &
                                 &+ trm_vv( map_z(ib1),ib2,ik+is1-1,3 )*qvec_rotated(3)
                            if ( imple_method == 1 ) then
                               zrho1 = -zrho1 *zi
                            else
                               zrho1 = zrho1 *zi
                            endif
                            
                         else
                            itmp = ngpt_XI( ig1, iopr )
                            zrho1 = 0.0d0
                            
                            fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                                 &                     + ngabc(itmp,3)*txyz(3)
                            if ( imple_method == 1 ) then
                               zph = dcmplx( cos(fp), -sin(fp) )
                            else
                               zph = dcmplx( cos(fp), sin(fp) )
                            endif
                            
                            z1 = RhoTilde_vv( itmp, map_z(ib1), ib2, ik+is1-1 )*zph
                            if ( trev == 1 ) then
                               zrho1 = zrho1 + conjg(z1)
                            else
                               zrho1 = zrho1 + z1
                            endif
                         end if

                         Do ig2=1, nmax_G
                            if ( ig2 == 1 ) then
                               zrho2 = trm_vv( map_z(ib1),ib2,ik+is2-1,1 ) &
                                    &                *qvec_rotated(1) &
                                    & +trm_vv( map_z(ib1),ib2,ik+is2-1,2 ) &
                                    &                *qvec_rotated(2) &
                                    & + trm_vv( map_z(ib1),ib2,ik+is2-1,3 ) &
                                    &                *qvec_rotated(3)
                               if ( imple_method == 1 ) then
                                  zrho2 = -zrho2 *zi
                               else
                                  zrho2 = zrho2 *zi
                               endif
                               
                            else
                               itmp = ngpt_XI( ig2, iopr )
                               zrho2 = 0.0d0
                               
                               fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                                    &                     + ngabc(itmp,3)*txyz(3)
                               if ( imple_method == 1 ) then
                                  zph = dcmplx( cos(fp), -sin(fp) )
                               else
                                  zph = dcmplx( cos(fp), sin(fp) )
                               endif
                         
                               z1 = RhoTilde_vv( itmp, map_z(ib1), ib2, ik+is2-1 )*zph
                               if ( trev == 1 ) then
                                  zrho2 = zrho2 + conjg(z1)
                               else
                                  zrho2 = zrho2 + z1
                               endif
                            endif
!
                            if ( noncol ) then
                               ztrm2( nmax_G*(is1-1)+ig1, nmax_G*(is2-1)+ig2 ) &
                                    &           = zrho1 *conjg( zrho2 )
                            else
                               ztrm2( nmax_G*(ispin-1)+ig1, nmax_G*(ispin-1)+ig2 ) &
                                    &           = zrho1 *conjg( zrho2 )
                            endif

                         End do  ! ig2
                      End Do  ! ig1
                   End do
                End Do
#ifdef USE_ASMS_EXCITATION
                call ASMS_XI_add_spectral_function( ediff, odiff, &
                     &                              ztrm2, SpectrFn_vv )
#endif
             End do
          End Do
       End do
    End Do

    if ( npes > 1 ) then
       allocate( work( nmax_G_spin, nmax_G_spin, nstep ) ); work = 0.0d0
       call mpi_allreduce( SpectrFn_vv, work, nmax_G_spin**2 *2 *nstep, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       SpectrFn_vv = work
       deallocate( work )
    endif

    SpectrFn_vv = SpectrFn_vv /dble(kv3_fbz) /univol
    if ( nspin == 1 ) SpectrFn_vv = SpectrFn_vv *2.0d0

#if 0
    Do i=1, nstep
       ztmp = 0.0d0
       Do is1=1, nspin_m
          Do is2=1, nspin_m
             ztmp = ztmp +SpectrFn_vv( nmax_G*(is1-1)+1, nmax_G*(is2-1)+1, i )
          End do
       End Do
       write(2550+mype,*) i*e_step*Hartree, real(ztmp), aimag(ztmp)
    End Do
#endif

  end subroutine m_XI_calc_spectr_fn_vv_spindec

  subroutine m_XI_calc_spectr_fn_vv
    integer :: i, ik, jk, iopr, trev
    integer :: ig1, ig2, itmp, ib1, ib2, is
    complex(kind=CMPLDP), allocatable :: work(:,:,:)
    real(kind=DP) :: qvec_rotated(3), weight

    real(kind=DP) :: ediff, odiff, occ1, occ2, qv2, txyz(3), fp
    complex(kind=CMPLDP) :: zrho1, zrho2, ztmp, z1, zph

    real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)
    real(kind=DP), allocatable :: occ_mpi(:), occ_wk(:)
    complex(kind=CMPLDP), allocatable :: ztrm2(:,:), zrho_work(:)

    allocate( SpectrFn_vv( nmax_G, nmax_G, nstep ) );  SpectrFn_vv = 0.0d0
    allocate( ztrm2(nmax_G,nmax_G) ); ztrm2 = 0.0d0

    allocate( eko_wk( neg ) ); eko_wk = 0.0d0
    allocate( occ_wk( neg ) ); occ_wk = 0.0d0
    allocate( zrho_work( nmax_G ) ); zrho_work = 0.0d0

    Do ik=1, kv3, ndim_spinor
       if ( map_k(ik) /= myrank_k ) cycle

       eko_wk = 0.0d0
       Do ib1=ista_e, iend_e, istep_e
          eko_wk(ib1) = eko_l( map_z(ib1),ik )
       End do
       if ( npes > 1 ) then
          allocate( eko_mpi( neg ) ); eko_mpi = 0.0d0
          call mpi_allreduce( eko_wk, eko_mpi, neg, mpi_double_precision, mpi_sum, &
               &              mpi_k_world(myrank_k), ierr )
          eko_wk = eko_mpi
          deallocate( eko_mpi )
       endif

       occ_wk = 0.0d0
       Do ib1=ista_e, iend_e, istep_e
          occ_wk(ib1) = occup_l( map_z(ib1),ik )
       End do
       if ( npes > 1 ) then
          allocate( occ_mpi( neg ) ); occ_mpi = 0.0d0
          call mpi_allreduce( occ_wk, occ_mpi, neg, mpi_double_precision, mpi_sum, &
               &              mpi_k_world(myrank_k), ierr )
          occ_wk = occ_mpi
          deallocate( occ_mpi )
       endif

       weight = kv3 *qwgt(ik) /dble(ndim_spinor)

       Do i=1, num_star_of_k(ik)
          jk = star_of_k(ik,i)
          iopr = iopr_k_fbz_to_ibz(jk)
          trev = trev_k_fbz_to_ibz(jk)

          qvec_rotated = matmul( op(:,:,iopr), qvec(:) )
          if ( trev == 1 ) qvec_rotated = -qvec_rotated

          txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2

          Do ib1=ista_e, iend_e, istep_e
             if ( eko_l( map_z(ib1),ik ) > efermi ) cycle

             Do ib2=1, neg
                if ( eko_wk(ib2) < efermi ) cycle

                ediff = eko_wk(ib2)   -eko_l(map_z(ib1),ik) +scissor
                occ1 = occup_l(map_z(ib1),ik) / weight
                occ2 = occ_wk(ib2) / weight

                if ( imple_method == 1 ) then
                   odiff = occ1 -occ2    
                else
                   odiff = occ1 *( 1.0d0 -occ2 )
                endif

                if ( ediff < 0.0d0 ) cycle
! -----
                Do ig1=1, nmax_G
                   zrho1 = 0.0d0
                   if ( ig1 == 1 ) then
                      Do is=1, ndim_spinor
                         zrho1 = zrho1 &
                              & + trm_vv( map_z(ib1),ib2,ik+is-1,1 )*qvec_rotated(1) &
                              & + trm_vv( map_z(ib1),ib2,ik+is-1,2 )*qvec_rotated(2) &
                              & + trm_vv( map_z(ib1),ib2,ik+is-1,3 )*qvec_rotated(3)
                      End do
                      if ( imple_method == 1 ) then
                         zrho1 = -zrho1 *zi
                      else
                         zrho1 = zrho1 *zi
                      endif
                   else
                      itmp = ngpt_XI( ig1, iopr )
                      fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                           &                     + ngabc(itmp,3)*txyz(3)
                      if ( imple_method == 1 ) then
                         zph = dcmplx( cos(fp), -sin(fp) )
                      else
                         zph = dcmplx( cos(fp), sin(fp) )
                      endif

                      Do is=1, ndim_spinor
                         z1 = RhoTilde_vv( itmp, map_z(ib1), ib2, ik+is-1 )*zph
                         if ( trev == 1 ) then
                            zrho1 = zrho1 + conjg(z1)
                         else
                            zrho1 = zrho1 + z1
                         endif
                      End do
                   end if
                   zrho_work(ig1) = zrho1
                End Do
! -----
                Do ig1=1, nmax_G
                   zrho1 = zrho_work(ig1)
                   Do ig2=1, nmax_G
                      zrho2 = zrho_work(ig2)
                      ztrm2( ig1, ig2 ) = zrho1 *conjg( zrho2 )
                   End do  ! ig2
                End Do  ! ig1

#ifdef USE_ASMS_EXCITATION
                call ASMS_XI_add_spectral_function( ediff, odiff, ztrm2, &
                     &                              SpectrFn_vv )
#endif
             End do
          End Do
       End do
    End Do

    if ( npes > 1 ) then
       allocate( work(nmax_G, nmax_G, nstep ) ); work = 0.0d0
       call mpi_allreduce( SpectrFn_vv, work, nmax_G**2 *2 *nstep, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       SpectrFn_vv = work
       deallocate( work )
    endif

    deallocate( zrho_work ); deallocate( ztrm2 )
    deallocate( eko_wk ); deallocate( occ_wk )

    SpectrFn_vv = SpectrFn_vv /dble(kv3_fbz/nspin) /univol
    if ( nspin == 1 ) SpectrFn_vv = SpectrFn_vv *2.0d0

#if 0
    Do i=1, nstep
       ztmp = SpectrFn_vv(1,1,i)
       write(2450+mype,*) i*e_step*Hartree, real(ztmp), aimag(ztmp)
    End Do
#endif

  end subroutine m_XI_calc_spectr_fn_vv

  subroutine m_XI_calc_spectr_tensor_vv
    integer :: i, ik, jk, iopr, trev
    integer :: ig1, ig2, itmp, ib1, ib2, is, itns

    real(kind=DP) :: qv, qvec1(3), qvec2(3)
    real(kind=DP) :: qvec1_rotated(3), qvec2_rotated(3), weight
    real(kind=DP) :: ediff, odiff, occ1, occ2, txyz(3), fp
    complex(kind=CMPLDP) :: zrho1, zrho2, ztmp, z1, zph

    real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)
    real(kind=DP), allocatable :: occ_mpi(:), occ_wk(:)
    complex(kind=CMPLDP), allocatable :: work(:,:,:)
    complex(kind=CMPLDP), allocatable :: ztrm2(:,:)

    if ( allocated( SpectrTensor_vv ) ) deallocate( SpectrTensor_vv )
    allocate( SpectrTensor_vv( nmax_G, nmax_G, nstep, 6 ) );  SpectrTensor_vv = 0.0d0

    allocate( ztrm2(nmax_G,nmax_G) ); ztrm2 = 0.0d0
    allocate( eko_wk( neg ) ); eko_wk = 0.0d0
    allocate( occ_wk( neg ) ); occ_wk = 0.0d0
!
    qv = sqrt( qvec(1)**2 +qvec(2)**2 + qvec(3)**2 )

    Do itns=1, 6
       qvec1 = 0.d0;   qvec2 = 0.0d0
       select case (itns)
       case (1)
          qvec1(1) = qv;  qvec2(1) = qv
       case (2)
          qvec1(2) = qv;  qvec2(2) = qv
       case (3)
          qvec1(3) = qv;  qvec2(3) = qv
       case (4)
          qvec1(1) = qv;  qvec2(2) = qv
       case (5)
          qvec1(1) = qv;  qvec2(3) = qv
       case (6)
          qvec1(2) = qv;  qvec2(3) = qv
       end select

       Do ik=1, kv3, ndim_spinor
          if ( map_k(ik) /= myrank_k ) cycle
          
          eko_wk = 0.0d0
          Do ib1=ista_e, iend_e, istep_e
             eko_wk(ib1) = eko_l( map_z(ib1),ik )
          End do
          if ( npes > 1 ) then
             allocate( eko_mpi( neg ) ); eko_mpi = 0.0d0
             call mpi_allreduce( eko_wk, eko_mpi, neg, mpi_double_precision, mpi_sum, &
                  &              mpi_k_world(myrank_k), ierr )
             eko_wk = eko_mpi
             deallocate( eko_mpi )
          endif
          
          occ_wk = 0.0d0
          Do ib1=ista_e, iend_e, istep_e
             occ_wk(ib1) = occup_l( map_z(ib1),ik )
          End do
          if ( npes > 1 ) then
             allocate( occ_mpi( neg ) ); occ_mpi = 0.0d0
             call mpi_allreduce( occ_wk, occ_mpi, neg, mpi_double_precision, mpi_sum, &
                  &              mpi_k_world(myrank_k), ierr )
             occ_wk = occ_mpi
             deallocate( occ_mpi )
          endif

          weight = kv3 *qwgt(ik) /dble(ndim_spinor)

          Do i=1, num_star_of_k(ik)
             jk = star_of_k(ik,i)
             iopr = iopr_k_fbz_to_ibz(jk)
             trev = trev_k_fbz_to_ibz(jk)
             
             qvec1_rotated = matmul( op(:,:,iopr), qvec1(:) )
             qvec2_rotated = matmul( op(:,:,iopr), qvec2(:) )

             if ( trev == 1 ) qvec1_rotated = -qvec1_rotated
             if ( trev == 1 ) qvec2_rotated = -qvec2_rotated

             txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2
             
             Do ib1=ista_e, iend_e, istep_e
                if ( eko_l( map_z(ib1),ik ) > efermi ) cycle
                
                Do ib2=1, neg
                   if ( eko_wk(ib2) < efermi ) cycle
                   
                   ediff = eko_wk(ib2)   -eko_l(map_z(ib1),ik) +scissor
                   occ1 = occup_l(map_z(ib1),ik) / weight
                   occ2 = occ_wk(ib2) / weight
                   
                   if ( imple_method == 1 ) then
                      odiff = occ1 -occ2    
                   else
                      odiff = occ1 *( 1.0d0 -occ2 )
                   endif
                   
                   if ( ediff < 0.0d0 ) cycle
                   
                   Do ig1=1, nmax_G
                      if ( ig1 == 1 ) then
                         zrho1 = 0.0d0
                         Do is=1, ndim_spinor
                            zrho1 = zrho1 &
                                 & + trm_vv(map_z(ib1),ib2,ik+is-1,1)*qvec1_rotated(1) &
                                 & + trm_vv(map_z(ib1),ib2,ik+is-1,2)*qvec1_rotated(2) &
                                 & + trm_vv(map_z(ib1),ib2,ik+is-1,3)*qvec1_rotated(3)
                         End do
                         if ( imple_method == 1 ) then
                            zrho1 = -zrho1 *zi
                         else
                            zrho1 = zrho1 *zi
                         endif
                         
                      else
                         itmp = ngpt_XI( ig1, iopr )
                         zrho1 = 0.0d0
                         
                         fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                              &                     + ngabc(itmp,3)*txyz(3)
                         if ( imple_method == 1 ) then
                            zph = dcmplx( cos(fp), -sin(fp) )
                         else
                            zph = dcmplx( cos(fp), sin(fp) )
                         endif

                         Do is=1, ndim_spinor
                            z1 = RhoTilde_vv( itmp, map_z(ib1), ib2, ik+is-1 )*zph
                            if ( trev == 1 ) then
                               zrho1 = zrho1 + conjg(z1)
                            else
                               zrho1 = zrho1 + z1
                            endif
                         End do
                         
                      endif
                      
                      Do ig2=1, nmax_G
                         if ( ig2 == 1 ) then
                            zrho2 = 0.0d0
                            Do is=1, ndim_spinor
                               zrho2 = zrho2 &
                                    & + trm_vv(map_z(ib1),ib2,ik+is-1,1) &
                                    &                   *qvec2_rotated(1) &
                                    & + trm_vv(map_z(ib1),ib2,ik+is-1,2) &
                                    &                   *qvec2_rotated(2) &
                                    & + trm_vv(map_z(ib1),ib2,ik+is-1,3) &
                                    &                   *qvec2_rotated(3)
                            End do
                            if ( imple_method == 1 ) then
                               zrho2 = -zrho2 *zi
                            else
                               zrho2 = zrho2 *zi
                            endif
                            
                         else
                            itmp = ngpt_XI( ig2, iopr )
                            zrho2 = 0.0d0
                            
                            fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                                 &                     + ngabc(itmp,3)*txyz(3)
                            if ( imple_method == 1 ) then
                               zph = dcmplx( cos(fp), -sin(fp) )
                            else
                               zph = dcmplx( cos(fp), sin(fp) )
                            endif
                            
                            Do is=1, ndim_spinor
                               z1 = RhoTilde_vv( itmp, map_z(ib1), ib2, ik+is-1 )*zph
                               if ( trev == 1 ) then
                                  zrho2 = zrho2 + conjg(z1)
                               else
                                  zrho2 = zrho2 + z1
                               endif
                            End do
                            
                         endif
                         
                         ztrm2( ig1, ig2 ) = zrho1 *conjg( zrho2 )

                      End do  ! ig2
                   End Do  ! ig1

#ifdef USE_ASMS_EXCITATION
                   call ASMS_XI_add_spectral_function( ediff, odiff, ztrm2, &
                        &                              SpectrTensor_vv(:,:,:,itns) )
#endif
                End do
             End Do
          End do
       End Do
       
       if ( npes > 1 ) then
          allocate( work(nmax_G, nmax_G, nstep ) ); work = 0.0d0
          call mpi_allreduce( SpectrTensor_vv(:,:,:,itns), work, nmax_G**2 *2 *nstep, &
               &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
          SpectrTensor_vv(:,:,:,itns) = work(:,:,:)
          deallocate( work )
       endif
    End Do

    SpectrTensor_vv = SpectrTensor_vv /dble(kv3_fbz/nspin) /univol
    if ( nspin == 1 ) SpectrTensor_vv = SpectrTensor_vv *2.0d0

#if 0
    Do i=1, nstep
       ztmp = SpectrTensor_vv(1,1,i,1)
       write(2450+mype,*) i*e_step*Hartree, real(ztmp), aimag(ztmp)
    End Do
#endif

    deallocate( ztrm2 ); deallocate( eko_wk ); deallocate( occ_wk )

  end subroutine m_XI_calc_spectr_tensor_vv

! --------------------------------------------------------
!    Calculation of SpectrFn (val-core)
! --------------------------------------------------------

  subroutine m_XI_calc_spectr_fn_vc
    integer :: i, ik, jk, iopr, trev
    integer :: ig1, ig2, itmp, ib1, ib2, is
    complex(kind=CMPLDP), allocatable :: work(:,:,:)
    real(kind=DP) :: qvec_rotated(3), weight

    real(kind=DP) :: ediff, odiff, occ1, occ2, qv2, txyz(3), fp
    complex(kind=CMPLDP) :: zrho1, zrho2, ztmp, z1, zph
    real(kind=DP) :: Delta03 = 1.0D-3

    real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)
    real(kind=DP), allocatable :: occ_mpi(:), occ_wk(:)
    complex(kind=CMPLDP), allocatable :: ztrm2(:,:)

    write(*,*) "nstep = ", nstep

    allocate( SpectrFn_vc( nmax_G, nmax_G, nstep ) );  SpectrFn_vc = 0.0d0
    allocate( ztrm2(nmax_G,nmax_G) ); ztrm2 = 0.0d0

    allocate( eko_wk( num_core_states ) ); eko_wk = 0.0d0

    Do ik=1, kv3, ndim_spinor
       if ( map_k(ik) /= myrank_k ) cycle

       eko_wk = 0.0d0
       eko_wk(:) = ene_core_states(:)

       weight = kv3 *qwgt(ik) /dble(ndim_spinor)

       Do i=1, num_star_of_k(ik)
          jk = star_of_k(ik,i)
          iopr = iopr_k_fbz_to_ibz(jk)
          trev = trev_k_fbz_to_ibz(jk)

          qvec_rotated = matmul( op(:,:,iopr), qvec(:) )
          if ( trev == 1 ) qvec_rotated = -qvec_rotated

          txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2

          Do ib1=ista_e, iend_e, istep_e
             occ1 = occup_l(map_z(ib1),ik) / weight
             if ( 1.0D0 -occ1 < Delta03 ) cycle

             Do ib2=1, num_core_states

                ediff = eko_wk(ib2)   -eko_l(map_z(ib1),ik) -scissor
                occ2 = 1.0d0

                if ( imple_method == 1 ) then
                   odiff = occ1 -occ2
                else
                   odiff = occ1 *( 1.0d0 -occ2 )
                endif
                ediff = -ediff;    odiff = -odiff

                Do ig1=1, nmax_G
                   if ( ig1 == 1 ) then
                      zrho1 = 0.0d0
                      Do is=1, ndim_spinor
                         zrho1 = zrho1 &
                              & + trm_vc( map_z(ib1),ib2,ik+is-1,1 )*qvec_rotated(1) &
                              & + trm_vc( map_z(ib1),ib2,ik+is-1,2 )*qvec_rotated(2) &
                              & + trm_vc( map_z(ib1),ib2,ik+is-1,3 )*qvec_rotated(3)
                      End do
                      if ( imple_method == 1 ) then
                         zrho1 = -zrho1 *zi
                      else
                         zrho1 = zrho1 *zi
                      endif

                   else
                      itmp = ngpt_XI( ig1, iopr )
                      zrho1 = 0.0d0
                      fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                           &                     + ngabc(itmp,3)*txyz(3)
                      if ( imple_method == 1 ) then
                         zph = dcmplx( cos(fp), -sin(fp) )
                      else
                         zph = dcmplx( cos(fp), sin(fp) )
                      endif
                      Do is=1, ndim_spinor
                         z1 = RhoTilde_vc( itmp, map_z(ib1), ib2, ik+is-1 ) *zph
                         if ( trev == 1 ) then
                            zrho1 = zrho1 + conjg(z1)
                         else
                            zrho1 = zrho1 + z1
                         endif
                      End do
                   endif

                   Do ig2=1, nmax_G
                      if ( ig2 == 1 ) then
                         zrho2 = 0.0d0
                         Do is=1, ndim_spinor
                            zrho2 = zrho2 &
                                 & + trm_vc( map_z(ib1),ib2,ik+is-1,1 )*qvec_rotated(1) &
                                 & + trm_vc( map_z(ib1),ib2,ik+is-1,2 )*qvec_rotated(2) &
                                 & + trm_vc( map_z(ib1),ib2,ik+is-1,3 )*qvec_rotated(3)
                         End do
                         if ( imple_method == 1 ) then
                            zrho2 = -zrho2 *zi
                         else
                            zrho2 = zrho2 *zi
                         endif

                      else
                         itmp = ngpt_XI( ig2, iopr )
                         zrho2 = 0.0d0

                         fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                              &                     + ngabc(itmp,3)*txyz(3)
                         if ( imple_method == 1 ) then
                            zph = dcmplx( cos(fp), -sin(fp) )
                         else
                            zph = dcmplx( cos(fp), sin(fp) )
                         endif

                         Do is=1, ndim_spinor
                            z1 = RhoTilde_vc( itmp, map_z(ib1), ib2, ik+is-1 )*zph
                            if ( trev == 1 ) then
                               zrho2 = zrho2 + conjg(z1)
                            else
                               zrho2 = zrho2 + z1
                            endif

                         End do
                      endif

                      ztrm2( ig1, ig2 ) = zrho1 *conjg( zrho2 )

                   End do  ! ig2
                End Do  ! ig1

#ifdef USE_ASMS_EXCITATION
                call ASMS_XI_add_spectral_function( ediff, odiff, ztrm2, &
                     &                              SpectrFn_vc )
#endif
             End do
          End Do
       End do
    End Do

    if ( npes > 1 ) then
       allocate( work(nmax_G, nmax_G, nstep ) ); work = 0.0d0
       call mpi_allreduce( SpectrFn_vc, work, nmax_G**2 *2 *nstep, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       SpectrFn_vc = work
       deallocate( work )
    endif

    SpectrFn_vc = SpectrFn_vc /dble(kv3_fbz/nspin) /univol
    if ( nspin == 1 ) SpectrFn_vc = SpectrFn_vc *2.0d0

#if 0
    Do i=1, nstep
       ztmp = SpectrFn_vc(1,1,i)
       write(2400+mype,*) e(i)*Hartree, real(ztmp), aimag(ztmp)
    End do
#endif

  end subroutine m_XI_calc_spectr_fn_vc

! --------------------------------------------------------
! Coulomb Kernel
! --------------------------------------------------------
  subroutine m_XI_set_Kernel_Coulomb
    integer :: i
    real(kind=DP) :: g2, qv2

    allocate( Kernel_Coulomb(nmax_G) ); Kernel_Coulomb = 0.0d0

    Do i=2, nmax_G
       g2 = ttr(1)*ngabc(i,1)*ngabc(i,1) &
            &             + ttr(2)*ngabc(i,2)*ngabc(i,2) &
            &             + ttr(3)*ngabc(i,3)*ngabc(i,3) &
            &             + ttr(4)*ngabc(i,1)*ngabc(i,2) &
            &             + ttr(5)*ngabc(i,2)*ngabc(i,3) &
            &             + ttr(6)*ngabc(i,3)*ngabc(i,1)
       Kernel_Coulomb(i) = PAI4 / g2
    End do
    qv2 = qvec(1)**2 +qvec(2)**2 + qvec(3)**2
    Kernel_Coulomb(1) = PAI4 / qv2

  end subroutine m_XI_set_Kernel_Coulomb

  subroutine m_XI_calc_num_occupied_bands
    integer :: ik, ib1
    real(kind=DP) :: weight, c1
    real(kind=DP), allocatable :: occ_mpi(:), occ_wk(:)
    
    allocate( occ_wk( neg ) ); occ_wk = 0.0d0

    Do ik=1, kv3
       if ( map_k(ik) /= myrank_k ) cycle

       occ_wk = 0.0d0
       Do ib1=ista_e, iend_e, istep_e
          occ_wk(ib1) = occup_l( map_z(ib1),ik )
       End do
       if ( npes > 1 ) then
          allocate( occ_mpi( neg ) ); occ_mpi = 0.0d0
          call mpi_allreduce( occ_wk, occ_mpi, neg, mpi_double_precision, mpi_sum, &
               &              mpi_k_world(myrank_k), ierr )
          occ_wk = occ_mpi
          deallocate( occ_mpi )
       endif

       weight = kv3 *qwgt(ik) /dble(ndim_spinor)

       num_occ_bands = 0
       Do ib1=1, neg
          c1 = occ_wk(ib1) /weight
          if ( c1 > 0.5 ) num_occ_bands = num_occ_bands +1
       End do
    End Do

    num_unocc_bands = neg -num_occ_bands

    deallocate( occ_wk )

  end subroutine m_XI_calc_num_occupied_bands
    
  subroutine m_XI_set_matsize_bse
    integer :: i, ista, iend, n1, n2
    integer, allocatable :: matsize_bse_on_pe(:)

    if ( sw_corelevel_spectrum == ON ) then
       matsize_bse = num_core_states *num_unocc_bands *kv3_fbz
    else
       matsize_bse = num_occ_bands *num_unocc_bands *kv3_fbz
    endif
    matsize_bse = matsize_bse /dble(ndim_spinor)

    allocate( matsize_bse_on_pe( npes ) ); matsize_bse_on_pe = 0

    n1 = int( matsize_bse /npes );  n2 = matsize_bse -n1 *npes
    Do i=1, npes
       matsize_bse_on_pe(i) = n1
    End do
    Do i=1, n2
       matsize_bse_on_pe(i) = matsize_bse_on_pe(i) +1
    End do
!
    ista = 0;  iend = 0

    Do i=1, npes
       ista = iend +1
       iend = iend +matsize_bse_on_pe(i)
       if ( mype == i-1 ) then
          ista_matbse = ista;  iend_matbse = iend
       endif
    End Do
    deallocate( matsize_bse_on_pe )

  end subroutine m_XI_set_matsize_bse

  subroutine m_XI_alloc_Hamiltonian_bse
  end subroutine m_XI_alloc_Hamiltonian_bse

  subroutine m_XI_set_Hamiltonian_bse
    integer :: ista_band, jsta_band

    allocate( MatH_bse( ista_matbse:iend_matbse, matsize_bse ) )
    MatH_bse = 0.0d0

    ista_band = num_occ_bands +1
    jsta_band = ista_band

    if ( sw_corelevel_spectrum == ON ) then
       call set_diagonal_part
       call set_exchange_part_core2val
       call set_screened_coulomb_core2val
    else
    endif
  contains

    subroutine set_exchange_part_core2val       ! electron-hole exchange
      integer :: ik, jk, ib1, ib2, jb1, jb2
      integer :: i, j, is, ig
      integer :: ik_fbz, jk_fbz, iopr, jopr, trev_i, trev_j, ipos, jpos
      integer :: itmp1, itmp2, itmp3, jtmp1, jtmp2, jtmp3
      real(kind=DP) :: fp_i, fp_j, txyz_i(3), txyz_j(3)
      complex(kind=CMPLDP) :: zsum, zph_i, zph_j, z1, z2

      complex(kind=CMPLDP), allocatable :: work_i(:,:), work_j(:,:)

      allocate( work_i(nmax_G,num_core_states) ); work_i = 0.0d0
      allocate( work_j(nmax_G,num_core_states) ); work_j = 0.0d0

      Do ik=1, kv3, ndim_spinor
         Do ib1=ista_band, neg
            work_i = 0.0d0
            if ( map_ek(ib1,ik) == mype ) then
               Do ib2=1, num_core_states
                  Do is=1, ndim_spinor
                     work_i(:,ib2) = work_i(:,ib2) &
                          &        + RhoTilde_vc(:,map_z(ib1),ib2,ik+is-1)
                  End Do
               End Do
            endif
            call mpi_bcast( work_i, nmax_G *num_core_states, &
                 &          mpi_double_precision, &
                 &          map_ek(ib1,ik), mpi_comm_group, ierr )

            Do jk=1, kv3, ndim_spinor
               Do jb1=jsta_band, neg
                  work_j = 0.0d0
                  if ( map_ek(jb1,jk) == mype ) then
                     Do jb2=1, num_core_states
                        Do is=1, ndim_spinor
                           work_j(:,jb2) = work_j(:,jb2) &
                                &        + RhoTilde_vc(:,map_z(jb1),jb2,jk+is-1)
                        End Do
                     End Do
                  endif
                  call mpi_bcast( work_j, nmax_G *num_core_states, &
                       &          mpi_double_precision, &
                       &          map_ek(jb1,jk), mpi_comm_group, ierr )

                  Do i=1, num_star_of_k(ik)
                     ik_fbz = star_of_k(ik,i)
                     iopr = iopr_k_fbz_to_ibz(ik_fbz)
                     trev_i = trev_k_fbz_to_ibz(ik_fbz)
                     txyz_i(1:3) = tau(1:3,iopr,BUCS) *PAI2

                     Do j=1, num_star_of_k(jk)
                        jk_fbz = star_of_k(jk,j)
                        jopr = iopr_k_fbz_to_ibz(jk_fbz)
                        trev_j = trev_k_fbz_to_ibz(jk_fbz)
                        txyz_j(1:3) = tau(1:3,jopr,BUCS) *PAI2

                        Do ib2=1, num_core_states
                           Do jb2=1, num_core_states
                              itmp1 = ( neg -ista_band +1 )*num_core_states
                              itmp2 = ( ib1 -ista_band +1 )*num_core_states
                              ipos = ( ik_fbz -1 )*itmp1 +itmp2 +ib2

                              jtmp1 = ( neg -jsta_band +1 )*num_core_states
                              jtmp2 = ( jb1 -jsta_band +1 )*num_core_states
                              jpos = ( jk_fbz -1 )*jtmp1 +jtmp2 +jb2
                              !
                              if ( ipos >= ista_matbse .and. ipos <= iend_matbse ) then
                                 zsum = 0.0d0

                                 Do ig=2, nmax_G         ! assuming sw_longwavelimit
                                    itmp3 = ngpt_XI( ig,iopr )
                                    jtmp3 = ngpt_XI( ig,jopr )
                                    fp_i = ngabc(itmp3,1)*txyz_i(1) &
                                         &   + ngabc(itmp3,2)*txyz_i(2) &
                                         &   + ngabc(itmp3,3)*txyz_i(3)
                                    fp_j = ngabc(jtmp3,1)*txyz_j(1) &
                                         &   + ngabc(jtmp3,2)*txyz_j(2) &
                                         &   + ngabc(jtmp3,3)*txyz_j(3)
                                    
                                    if ( imple_method == 1 ) then
                                       zph_i = dcmplx( cos(fp_i), -sin(fp_i) )
                                       zph_j = dcmplx( cos(fp_j), -sin(fp_j) )
                                    else
                                       zph_i = dcmplx( cos(fp_i), sin(fp_i) )
                                       zph_j = dcmplx( cos(fp_j), sin(fp_j) )
                                    endif
                                    
                                    Do is=1, ndim_spinor
                                       if ( trev_i == 1 ) then
                                          z1 = conjg( work_i(ig,is) *zph_i )
                                       else
                                          z1 = work_i(ig,is) *zph_i
                                       endif
                                       if ( trev_j == 1 ) then
                                          z2 = conjg( work_j(ig,is) *zph_j )
                                       else
                                          z2 = work_j(ig,is) *zph_j
                                       endif
                                       zsum = zsum +z1 *conjg(z2) *kernel_Coulomb(ig)
                                    End Do
                                 End Do
                                 MatH_bse( ipos, jpos ) = MatH_bse( ipos, jpos ) &
                                      &                 + zsum /univol
                              endif
                           End Do
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do

      deallocate( work_i ); deallocate( work_j )

    end subroutine set_exchange_part_core2val

    subroutine set_screened_coulomb_core2val
      integer :: ik, ib1, ib2, jb1, jb2
      integer :: i, is, ik_fbz, iopr, trev
      integer :: itmp1, itmp2, jtmp1, jtmp2, ipos, jpos
      integer :: ig1, ig2, itmp3
      real(kind=DP) :: qvec_rotated(3), txyz(3), fp
      complex(kind=CMPLDP) :: zsum, zrho1, zrho2, zph, z1, z2

      complex(kind=CMPLDP), allocatable :: work1_rho_vv(:,:), work1_trm_vv(:,:)
      complex(kind=CMPLDP), allocatable :: work2_rho_cc(:,:), work2_trm_cc(:,:)

      allocate( work1_rho_vv(nmax_G,neg) ); work1_rho_vv = 0.0d0
      allocate( work1_trm_vv(neg,3) );      work1_trm_vv = 0.0d0
      allocate( work2_rho_cc(nmax_G,num_core_states) ); work2_rho_cc = 0.0d0
      allocate( work2_trm_cc(num_core_states,3) );      work2_trm_cc = 0.0d0

      Do ik=1, kv3, ndim_spinor

         Do ib1=ista_band, neg
            work1_rho_vv = 0.0d0;  work1_trm_vv = 0.0d0
            if ( map_ek(ib1,ik) == mype ) then
               Do jb1=1, neg
                  Do is=1, ndim_spinor
                     work1_rho_vv(:,jb1) = work1_rho_vv(:,jb1) &
                          &              + RhoTilde_vv(:,map_z(ib1),jb1,ik+is-1)
                  End Do
               End Do
               Do jb1=1, neg
                  Do is=1, ndim_spinor
                     work1_trm_vv(jb1,1:3) = work1_trm_vv(jb1,1:3) &
                          &                + trm_vv(map_z(ib1),jb1,ik+is-1,1:3)
                  End Do
               End Do
            endif
            call mpi_bcast( work1_rho_vv, nmax_G *neg, mpi_double_precision, &
                 &          map_ek(ib1,ik), mpi_comm_group, ierr )
            call mpi_bcast( work1_trm_vv, neg*3, mpi_double_precision, &
                 &          map_ek(ib1,ik), mpi_comm_group, ierr )
            
            Do ib2=1, num_core_states
               work2_rho_cc = 0.0d0;    work2_trm_cc = 0.0d0
               if ( map_k(ik) == myrank_k ) then
                  Do jb2=1, num_core_states
                     Do is=1, ndim_spinor
                        work2_rho_cc(:,jb2) = work2_rho_cc(:,ib2) &
                             &                 + RhoTilde_cc(:,ib2,jb2,ik+is-1)
                     End Do
                  End Do
                  Do jb2=1, num_core_states
                     Do is=1, ndim_spinor
                        work2_trm_cc(jb2,1:3) = work2_trm_cc(jb2,1:3) &
                             &                + trm_cc(ib2,jb2,ik+is-1,1:3)
                     End Do
                  End Do
               endif
               call mpi_bcast( work2_rho_cc, nmax_G *num_core_states, &
                    &          mpi_double_precision, &
                    &          map_k(ik), mpi_e_world(myrank_e), ierr )
               call mpi_bcast( work2_trm_cc, num_core_states*3, &
                    &          mpi_double_precision, &
                    &          map_k(ik), mpi_e_world(myrank_e), ierr )
                  
               Do i=1, num_star_of_k(ik)
                  ik_fbz = star_of_k(ik,i)
                  iopr = iopr_k_fbz_to_ibz(ik_fbz)
                  trev = trev_k_fbz_to_ibz(ik_fbz)
                  
                  qvec_rotated = matmul( op(:,:,iopr), qvec(:) )
                  if ( trev == 1 ) qvec_rotated = -qvec_rotated
                  
                  txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2

                  Do jb1=ista_band, neg
                     Do jb2=1, num_core_states
                        itmp1 = ( neg -ista_band +1 )*num_core_states
                        itmp2 = ( ib1 -ista_band +1 )*num_core_states
                        ipos = ( ik_fbz -1 )*itmp1 +itmp2 +ib2
                              !
                        jtmp1 = ( neg -jsta_band +1 )*num_core_states
                        jtmp2 = ( jb1 -jsta_band +1 )*num_core_states
                        jpos = ( ik_fbz -1 )*jtmp1 +jtmp2 +jb2
                              !
                        if ( ipos >= ista_matbse .and. ipos <= iend_matbse ) then
                           zsum = 0.0d0

                           Do ig1=1, nmax_G
                              if ( ig1 == 1 ) then
                                 zrho1 = 0.0d0
                                 Do is=1, ndim_spinor
                                    zrho1 = zrho1 &
                                         & + work1_trm_vv(jb1,1)*qvec_rotated(1) &
                                         & + work1_trm_vv(jb1,2)*qvec_rotated(2) &
                                         & + work1_trm_vv(jb2,3)*qvec_rotated(3)
                                 End do
                                 if ( imple_method == 1 ) then
                                    zrho1 = -zrho1 *zi
                                 else
                                    zrho1 = zrho1 *zi
                                 endif
                              else
                                 itmp3 = ngpt_XI( ig1, iopr )
                                 zrho1 = 0.0d0

                                 fp = ngabc(itmp3,1)*txyz(1) + ngabc(itmp3,2)*txyz(2) &
                                      &                      + ngabc(itmp3,3)*txyz(3)
                                 if ( imple_method == 1 ) then
                                    zph = dcmplx( cos(fp), -sin(fp) )
                                 else
                                    zph = dcmplx( cos(fp), sin(fp) )
                                 endif

                                 z1 = work1_rho_vv(itmp3,jb1) *zph
                                 if ( trev == 1 ) then
                                    zrho1 = zrho1 + conjg(z1)
                                 else
                                    zrho1 = zrho1 + z1
                                 endif
                              endif

                              Do ig2=1, nmax_G
                                 if ( ig2 == 1 ) then
                                    zrho2 = 0.0d0
                                    Do is=1, ndim_spinor
                                       zrho2 = zrho2 &
                                            & + work2_trm_cc(jb2,1)*qvec_rotated(1) &
                                            & + work2_trm_cc(jb2,2)*qvec_rotated(2) &
                                            & + work2_trm_cc(jb2,3)*qvec_rotated(3)
                                    End do
                                    if ( imple_method == 1 ) then
                                       zrho2 = -zrho2 *zi
                                    else
                                       zrho2 = zrho2 *zi
                                    endif
                                 else
                                    itmp3 = ngpt_XI( ig2, iopr )
                                    zrho2 = 0.0d0
                                    fp = ngabc(itmp3,1)*txyz(1) +ngabc(itmp3,2)*txyz(2) &
                                         &                      +ngabc(itmp3,3)*txyz(3)
                                    if ( imple_method == 1 ) then
                                       zph = dcmplx( cos(fp), -sin(fp) )
                                    else
                                       zph = dcmplx( cos(fp), sin(fp) )
                                    endif

                                    z1 = work2_rho_cc(itmp3,jb2) *zph
                                    if ( trev == 1 ) then
                                       zrho2 = zrho2 + conjg(z1)
                                    else
                                       zrho2 = zrho2 + z1
                                    endif
                                 endif
!
                                 zsum = zsum +zrho1 *conjg(zrho2) *kernel_Coulomb(ig1) &
                                      &             *epsinv_omega0(ig1,ig2)
                              End do
                           End Do
                           MatH_bse(ipos,jpos) = MatH_bse(ipos,jpos) &
                                &               - zsum /2.0d0 /univol
                        endif
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do

      deallocate( work1_trm_vv ); deallocate( work1_rho_vv )
      deallocate( work2_trm_cc ); deallocate( work2_rho_cc )

    end subroutine set_screened_coulomb_core2val

    subroutine set_diagonal_part
      integer :: ik, ib1, ib2
      integer :: i, iopr, ik_fbz, trev
      integer :: itmp1, itmp2, ipos
      real(kind=DP) :: work1_eko_v, work1_eko_c, c1

      Do ik=1, kv3, ndim_spinor
         Do ib1=ista_band, neg
            work1_eko_v = 0.0d0
            if ( map_ek(ib1,ik) == mype ) then
               work1_eko_v = eko_l(map_z(ib1),ik)
            endif
            call mpi_bcast( work1_eko_v, 1, mpi_double_precision, &
                 &          map_ek(ib1,ik), mpi_comm_group, ierr )

            Do ib2=1, num_core_states
               work1_eko_c = ene_core_states(ib2)
               
               Do i=1, num_star_of_k(ik)
                  ik_fbz = star_of_k(ik,i)
                  iopr = iopr_k_fbz_to_ibz(ik_fbz)
                  trev = trev_k_fbz_to_ibz(ik_fbz)
               
                  itmp1 = ( neg -ista_band +1 )*num_core_states
                  itmp2 = ( ib1 -ista_band +1 )*num_core_states
                  ipos = ( ik_fbz -1 )*itmp1 +itmp2 +ib2

                  if ( ipos >= ista_matbse .and. ipos <= iend_matbse ) then
                     c1 = work1_eko_v -work1_eko_c
                     MatH_bse(ipos,ipos) = MatH_bse(ipos,ipos) +c1
                  endif
               End Do
            End Do
         End Do
      End Do
                     
    end subroutine set_diagonal_part

  end subroutine m_XI_set_Hamiltonian_bse

end module m_Excitation

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 593 $)
!
!  SUBROUINE: Initialization_Epsilon
!
!  AUTHOR(S): T. Hamada   November/24/2004
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!
!
! $Id: Initialization_Epsilon.f90 593 2019-06-20 03:47:31Z jkoga $
subroutine Initialization_Epsilon(mode)
  use m_Epsilon_ek,           only : initialization_eps_ek
  use m_Control_Parameters,   only : m_CtrlP_set_uvsormode_ON
  use m_Files,                only : m_Files_open_nfeps, m_Files_open_nfepscont

  use m_Control_Parameters,   only : sw_corelevel_spectrum, sw_local_approx_trans_moment
  use m_Const_Parameters,     only : ON

  implicit none
  integer, intent(in) :: mode

  call initialization_eps_ek(mode)

  if ( sw_corelevel_spectrum == ON .and. sw_local_approx_trans_moment == ON ) then
  else
     call m_Files_open_nfeps()
     call m_Files_open_nfepscont
  endif

  call m_CtrlP_set_uvsormode_ON()

end subroutine Initialization_Epsilon

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: skip2number, f_strcpy, skip2RHS, read_LHS_number, read_RHS_number,
!             rewind_to_tag0, f_strncmp, ch4prc, chnnm2, skip2alph, ch4mix, 
!             rd_alpha, rd_cutoff, rd_hownew, rd_nbxmix, rd_istrbr, 
!             check_mix_tag_name, check_decomp, nameck, skip2next, 
!             strncmp2, strncmp0, chchn0, isnumm, isnums, isalph, chnnm,
!             skip_to_subtagname, read_energy_unit, read_itagvalue, read_dtagvalue
!
!  FUNCTION:  skip_to_tagbegin, skip_to_tagbegin2, strncmp3
!
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!                           @(#)b_Words.f90 1.3 03/02/19 00:46:15
!***************************************************************
!
!  Subroutines in this file "b_Words" are all coded by T. Yamasaki
!  in 1993 - 1999
!
! $Id: b_Words.f90 570 2017-04-21 20:34:50Z yamasaki $
logical function skip_to_tagbegin(nfinp,tag)
  integer, intent(in)          :: nfinp
  character(len=*), intent(in) :: tag
      
  integer, parameter :: len_str = 132
  character(len=len_str) :: str
  logical :: tf

  rewind nfinp
1 read(nfinp,'(a132)',end = 1001) str
  call strncmp2(str,len(tag),tag,len(tag),tf)
  if(.not.tf) goto 1
1001 continue

  skip_to_tagbegin = tf

end function skip_to_tagbegin

logical function skip_to_tagbegin2(nfinp,tag)
  integer, intent(in)         :: nfinp
  character(len=*),intent(in) :: tag

  integer :: ip
  integer, parameter :: len_str = 132
  character(len=len_str) :: str

  skip_to_tagbegin2 = .false.
  rewind nfinp
  ip = 0
1 read(nfinp,'(a132)',end=1001) str
  ip = index(str,tag)
!!$      write(6,'(i4,a76)') ip,str(1:76)
  if(ip <= 0) goto 1
1001 continue
  if(ip >= 1) skip_to_tagbegin2 = .true.
  write(6,'(" ip (skip_to_tagbegin2) = ",i4)') ip
end function skip_to_tagbegin2

subroutine read_dtagvalue(nfinp,tag_begin,tag,value)
  use m_Const_Parameters, only : DP
  integer, intent(in)          :: nfinp
  character(len=*), intent(in) :: tag_begin,tag
  real(kind=DP), intent(inout) :: value
      
  logical :: tf, tf2, skip_to_tagbegin
  integer :: nsize
  real(kind=DP), dimension(1) :: work
  
  integer, parameter :: len_str = 132
  character(len=len_str) :: str

  if(.not.skip_to_tagbegin(nfinp,tag_begin)) return

  tf = .false.
1 read(nfinp,'(a132)',end = 1001) str
  call strncmp2(str,3,"end",3,tf2)
  if(tf2) goto 1001
  call strncmp2(str,len_str,tag,len(tag),tf)
  if(.not.tf) goto 1
1001 continue

  if(tf) then
!!$         write(6,'(" -- tag is found -- ",a31)') tag
     call chnnm2(str,len_str,1,work,nsize)
     value = work(1)
  else
     write(6,'(" -- no tag value -- ",a31)') tag
  end if
!!$      write(6,'(20x,a31," = ",d20.12)') tag, value
  write(6,'(3x,a31," = ",d20.12)') tag, value

end subroutine read_dtagvalue

subroutine read_itagvalue(nfinp,tag_begin,tag,value)
  use m_Const_Parameters, only : DP
  integer, intent(in)          :: nfinp
  character(len=*), intent(in) :: tag_begin,tag
  integer, intent(inout)       :: value
      
  logical :: tf, tf2, skip_to_tagbegin
  integer :: nsize

  real(kind=DP), dimension(1)  :: work
  integer, parameter :: len_str = 132
  character(len=len_str) :: str

  if(.not.skip_to_tagbegin(nfinp,tag_begin)) return

  tf = .false.
1 read(nfinp,'(a132)',end = 1001) str
  call strncmp2(str,3,"end",3,tf2)
  if(tf2) goto 1001
  call strncmp2(str,len_str,tag,len(tag),tf)
  if(.not.tf) goto 1
1001 continue

  if(tf) then
     call chnnm2(str,len_str,1,work,nsize)
     value = nint(work(1))
  else
     write(6,'(" -- no tag value -- ",a31,"  default value is set")') tag
  end if
  write(6,'(3x,a31," = ",i8)') tag, value

end subroutine read_itagvalue

subroutine read_energy_unit(nfinp,tag_begin,tag,energy_unit)
  use m_Const_Parameters, only : HR_ENERGY_UNIT, EV_ENERGY_UNIT
  integer, intent(in) ::               nfinp
  character(len=*), intent(in) ::      tag_begin,tag
  integer, intent(out) ::              energy_unit

  logical :: tf
  integer :: ip, strncmp3
  integer, parameter :: len_str = 132
  character(len=len_str) :: str

  call skip_to_subtagname(nfinp, tag_begin,tag,len_str,str,tf)
  if(tf) then
     ip = strncmp3(str,"=")
     if(strncmp3(str(ip+1:len_str),"hartree") >=1 ) then
        energy_unit = HR_ENERGY_UNIT
        write(6,'(" !  energy_unit (dos)= HARTREE")')
     else if(strncmp3(str(ip+1:len_str),"eV") >= 1 ) then
        energy_unit = eV_ENERGY_UNIT
        write(6,'(" !  energy_unit (dos)= eV")')
     end if
  end if
end subroutine read_energy_unit

subroutine skip_to_subtagname(nfinp,tag_begin,tag,len_str,str,tf)
  integer, intent(in) ::               nfinp,len_str
  character(len=*), intent(in) ::      tag_begin,tag
  character(len=len_str),intent(out):: str
  logical, intent(out) ::              tf
      
  logical :: tf1, tf2, skip_to_tagbegin

  if(.not.skip_to_tagbegin(nfinp,tag_begin)) return

  tf1 = .false.
1 read(nfinp,'(a132)',end = 1001) str
  call strncmp2(str,3,"end",3,tf2)
  if(tf2) goto 1001
  call strncmp2(str,len_str,tag,len(tag),tf1)
  if(.not.tf1) goto 1
1001 continue
  tf = tf1
end subroutine skip_to_subtagname

subroutine chnnm(str,len_str,n,wka,incunt)
  use m_Const_Parameters, only : DP
  implicit none
  character(len=*), intent(in) :: str
  integer, intent(in) :: len_str, n
  real(kind=DP), intent(out), dimension(n) :: wka
  integer, intent(out) :: incunt
  
  logical tf
  character(len=1) c
!!$  integer, parameter :: maxclm = 10
  real(kind=DP) :: xnum1
  integer icount
  integer i,ic2
  
  xnum1 = 0.d0
  call rsreal(n,wka)
  icount = 0
  incunt = 0
  
1001 continue
  do i = icount+1, len_str
     icount = i
     c = str(i:i)
     if(c.eq.':') goto 1006
     call isalph(c,tf)
     if(tf) goto 1006
     call isnumm(c,tf)
     if(tf) then
        read(str(i:len_str),*) xnum1
!          call chtonm(str(i:len_str),maxclm,xnum1)
        goto 1002
     endif
  enddo
  goto 1006
1002 continue
  incunt = incunt + 1
  wka(incunt) = xnum1

  if(incunt.eq.n) goto 1006
  
  ic2 = icount + 1
  do i = icount+1, len_str
     if(str(i:i).eq.' ') then
        ic2 = i
        goto 1004
     else if(str(i:i).eq.':') then
        goto 1006
     endif
  enddo
1004 continue
  icount = ic2
  goto 1001
1006 continue
end subroutine chnnm

subroutine isalph(chr,trorfa)
  implicit none
  character, intent(in):: chr
  logical, intent(out) :: trorfa
  if((ichar(chr) >= ichar('a') .and. ichar(chr) <= ichar('z')) &
       &     .or.(ichar(chr) >= ichar('A') .and. ichar(chr) <= ichar('Z')) &
       &     ) then
     trorfa = .true.
  else
     trorfa = .false.
  endif
end subroutine isalph

subroutine isnums(chr,trorfa )
  implicit none
  character, intent(in) :: chr
  logical ,intent(out) :: trorfa

  if(( ichar(chr).ge.ichar('0').and.ichar(chr).le.ichar('9') ) &
       &    .or.chr.eq.'.'.or.chr.eq.'-' &
       &    .or.(chr.eq.'D'.or.chr.eq.'E'.or.chr.eq.'Q') &
       &    ) then
     trorfa = .true.
  else
     trorfa = .false.
  endif
end subroutine isnums

subroutine isnumm(chr,trorfa )
  implicit none
  character, intent(in) :: chr
  logical ,intent(out) :: trorfa
  
  if(( ichar(chr).ge.ichar('0').and.ichar(chr).le.ichar('9') ) &
       &    .or.chr.eq.'.'.or.chr.eq.'-' ) then
     trorfa = .true.
  else
     trorfa = .false.
  endif
end subroutine isnumm

subroutine chchn0(str,len_str,n,name,ns)
  implicit none
  integer, intent(in)         :: len_str,n
  character(len=len_str), intent(in) :: str
  character(len=n), intent(out)  :: name
  integer, intent(out)        :: ns
  
  integer, parameter :: DP = kind(1.d0)
  real(kind=DP) :: xnum1
  integer :: ip, i, icount, ndif
  character c
  logical tf

  ip = 0
  do i = 1, n
     icount = i
     call isalph(str(i:i),tf)
     if(tf) goto 2000
  enddo
  call phase_error_with_msg(6,' >>> Invalid input data <<<',__LINE__,__FILE__)
2000 continue
  do i = icount, icount + n - 1
     icount = i
     if(str(i:i) /= ' '.and.str(i:i) /= ':') then
        ip     = ip + 1
        name(ip:ip) = str(i:i)
     else
        goto 2001
     endif
  enddo
2001 continue

  name(ip+1:n) = ' '
  !      do i = ip+1, n
  !        name(i:i) = ' '
  !      enddo

  ndif = ichar('a') - ichar('A')
  do i = 1, n
     c = name(i:i)
     if(ichar(c) >= ichar('A') .and. ichar(c) <= ichar('Z')) then
        name(i:i) = char(ichar(c) + ndif)
     endif
  enddo

  do i = icount+1, len_str
     icount = i
     c = str(i:i)
     if(c.eq.':') goto 2006
     call isnumm(c,tf)
     if(tf) then
        read(str(i:len_str),*) xnum1
!          call chtonm(str(i:len_str),maxclm,xnum1)
        goto 2002
     endif
  enddo
2002 continue

  do i = icount+1, len_str
     if(str(i:i) == ' ') then
        goto 2004
     else if(str(i:i) == ':') then
        goto 2006
     endif
  enddo
2004 continue
  
2006 continue
  ns   = xnum1
end subroutine chchn0

subroutine strncmp0(str1,str2,tf)
  implicit none
  character(len=*), intent(in) :: str1, str2
  logical, intent(out) ::         tf

  integer :: len1, lencmp
  integer :: ndif, i, icharAcap,icharZcap,ichara,icharz,icharx &
       &   , icharupper, icharlower
!!$  character c
!  ----------
  len1 = len(str1)

  icharAcap = ichar('A')
  icharZcap = ichar('Z')
  ichara    = ichar('a')
  icharz    = ichar('z')

  ndif = ichar('A') - ichar('a')

  lencmp = len(str2)
  if(lencmp > len1) lencmp = len1
  tf = .false.
  do i = 1, lencmp
     icharx = ichar(str2(i:i))
     if(icharAcap <= icharx .and. icharx <= icharZcap) then
        icharupper = icharx
        icharlower = icharx - ndif
     else if(ichara <= icharx .and. icharx <= icharz) then
        icharupper = icharx + ndif
        icharlower = icharx
     else
        icharupper = icharx; icharlower = icharx
     end if
     if(str1(i:i).ne.char(icharupper).and.str1(i:i).ne.char(icharlower)) goto 1000
  enddo
  tf = .true.
1000 continue
end subroutine strncmp0

subroutine strncmp2(str1,len_str,str2,n,tf)
  implicit none
  character(len=*), intent(in) :: str1, str2
  integer, intent(in)       :: len_str, n
  logical, intent(out)      :: tf

  integer :: ndif, istart, i2,i
  character c
!  ----------
  ndif = ichar('A') - ichar('a')

  tf = .false.
  do istart = 1, len_str - n + 1
     i2 = 0
     do i = istart, istart-1+n
        i2 = i2 + 1
        c = char(ichar(str2(i2:i2)) + ndif)
        if(str1(i:i).ne.str2(i2:i2).and.str1(i:i).ne.c) goto 1000
     enddo
     tf = .true.
1000 continue
     if(tf) return
  enddo

end subroutine strncmp2

subroutine strncmp2b(str1,len_str,str2,n,tf)
  implicit none
  character(len=*), intent(in) :: str1, str2
  integer, intent(in)       :: len_str, n
  logical, intent(out)      :: tf

  integer :: ndif, istart, i2,i
  character c
!  ----------
  ndif = ichar('A') - ichar('a')

  tf = .false.
  do istart = 1, len_str - n + 1
     i2 = 0
     do i = istart, istart-1+n
        i2 = i2 + 1
        c = char(ichar(str2(i2:i2)) + ndif)
        if(str1(i:i).ne.str2(i2:i2).and.str1(i:i).ne.c) goto 1000
     enddo
     tf = .true.
1000 continue
     if(tf) then
        if(istart >= 2) then
           c = str1(istart-1:istart-1)
           if(c.ne.' ') tf = .false.
        end if
        if(i <= len_str) then
           c = str1(i:i)
           if(c.ne.' ' .and. c.ne.'=') tf = .false.
        end if
     end if
     if(tf) return
  enddo

end subroutine strncmp2b

integer function strncmp3(str1,str2)
  implicit none
  character(len=*), intent(in) :: str1, str2
!!$  integer, intent(in)       :: len_str

  integer :: ip,n,len1
  logical :: tf
  integer :: ndif, istart, i2,i, icharAcap,icharZcap,ichara,icharz,icharx &
       &   , icharupper, icharlower
!!$  character c
!  ----------
  len1 = len(str1)
  n = len(str2)
  icharAcap = ichar('A')
  icharZcap = ichar('Z')
  ichara    = ichar('a')
  icharz    = ichar('z')

  ndif = ichar('A') - ichar('a')

  tf = .false.
  strncmp3 = 0
  ip = 0
  do istart = 1, len1 - n + 1
     i2 = 0
     do i = istart, istart-1+n
        i2 = i2 + 1
        icharx = ichar(str2(i2:i2))
        if(icharAcap <= icharx .and. icharx <= icharZcap) then
           icharupper = icharx
           icharlower = icharx - ndif
        else if(ichara <= icharx .and. icharx <= icharz) then
           icharupper = icharx + ndif
           icharlower = icharx
        else
           icharupper = icharx; icharlower = icharx
        end if
!!$        c = char(ichar(str2(i2:i2)) + ndif)
!!$        if(str1(i:i).ne.str2(i2:i2).and.str1(i:i).ne.c) goto 1000
        if(str1(i:i).ne.char(icharupper).and.str1(i:i).ne.char(icharlower)) goto 1000
     enddo
     tf = .true.
     ip = istart
     strncmp3 = ip
1000 continue
     if(tf) return
  enddo
end function strncmp3

subroutine skip2next(str,len_str,charc,ic)
  implicit none
  character(len=*), intent(in) :: str
  character,     intent(in)  ::   charc
  integer,       intent(in)  ::   len_str
  integer,       intent(out) ::   ic

  logical ::          tf, flag
  character(len=1) :: c, c0
  integer ::          ndif, i, ipnt, ipnt2

  ndif = ichar('A') - ichar('a')
  c0   = charc
  if(ichar(c0) >= ichar('a') .and. ichar(c0) <= ichar('z')) c0 = char(ichar(c0) + ndif)

  flag = .false.

  do i = 1, len_str
     c = str(i:i)
     call isalph(c,tf)
     if(.not.flag.and.tf) then
        ipnt = i
        if(ichar(c) >= ichar('a') .and. ichar(c) <= ichar('z')) then
           c = char(ichar(c) + ndif)
        endif
        if(c == c0) goto 1001
     endif
     if(tf) then
        flag = .true.
     else
        flag = .false.
     endif
  enddo
  call phase_error_with_msg(6,' no matching character',__LINE__,__FILE__)

1001 continue
  do i = ipnt+1, len_str
     ipnt2 = i
     if(str(i:i) == '=') goto 1002
  enddo
  call phase_error_with_msg(6,' no = character',__LINE__,__FILE__)
  
1002 continue
  do i = ipnt2+1, len_str
     call isnumm(str(i:i),tf)
     if(tf) then
        ic = i
        return
     else
        call isalph(str(i:i),tf)
        if(tf) then
           ic = i
           return
        endif
     endif
  enddo
  call phase_error_with_msg(6,' no alphabet or number',__LINE__,__FILE__)
end subroutine skip2next

subroutine nameck(name,n)
  implicit none
  character(len=*), intent(inout) :: name
  integer, intent(in)          :: n

  integer i, icount

  icount = 0
  do  i = 1, n
     if(name(i:i).eq.' ') then
        icount = i
        goto 2
     endif
  enddo

2 continue
  if(icount.ne.0) then
     do  i = icount+1, n
        name(i:i) = ' '
     enddo
  endif
end subroutine nameck

subroutine ch4mix(str,len_str,waymix,istrbr,nbxmix,hownew &
     & ,cutoff_mix,decomp_into_charge_spin,work,nsize)
  use m_Const_Parameters, only : DP, SIMPLE, BROYD1, BROYD2, DFP, PULAY &
       &, ANEW, RENEW, SMALL, MEDIUM, LARGE
  implicit none
  character(len=*), intent(in)  :: str
  integer, intent(in)        :: len_str
  integer, intent(out)       :: waymix, istrbr, nbxmix, hownew
  integer, intent(out)       :: cutoff_mix
  logical, intent(out)       :: decomp_into_charge_spin
  real(DP), intent(out)      :: work(*)
  integer, intent(out)       :: nsize

  logical       :: tf
  integer       :: ic
  real(kind=DP) :: alpha

  call check_decomp

  call skip2alph(str,len_str,ic)
  if(ic <= 0) then
     call chnnm(str,len_str,5,work,nsize)
     if(nsize < 4) call phase_error_with_msg(6,' shortage of data for mixing ratios(2)',__LINE__,__FILE__)
     waymix = SIMPLE
     return
  end if

  call check_mix_tag_name(ic) ! -> waymix

  if(waymix /= SIMPLE) then
     call rd_istrbr   ! -> istrbr
     call rd_nbxmix   ! -> nbxmix
     call rd_hownew   ! -> hownew
     call rd_alpha    ! -> alpha
     work(1:5) = alpha
     nsize = 5
     call rd_cutoff   ! -> cutoff_mix
  end if

contains
  subroutine check_decomp
    logical :: tf

    call strncmp2(str,len_str,'nodecomp',8,tf)
    if(tf) then
       decomp_into_charge_spin = .false.
    else
       call strncmp2(str,len_str,'decomp',6,tf)
       if(tf) then
          decomp_into_charge_spin = .true.
       else
          decomp_into_charge_spin = .false.
       end if
    end if
  end subroutine check_decomp

  subroutine check_mix_tag_name(ic)
    integer, intent(in) :: ic
    logical :: tf
    call strncmp2(str(ic:len_str),6,'simple',6,tf)
    if(tf) then
       waymix = SIMPLE
       call chnnm2(str,len_str,5,work,nsize)
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),6,'broyd1',6,tf)
       if(tf) waymix = BROYD1
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),8,'broyden1',8,tf)
       if(tf) waymix = BROYD1
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),6,'broyd2',6,tf)
       if(tf) waymix = BROYD2
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),8,'broyden2',8,tf)
       if(tf) waymix = BROYD2
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),8,'dfp',3,tf)
       if(tf) waymix = DFP
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),7,'bluegel',7,tf)
       if(tf) waymix = DFP
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),2,'bl',2,tf)
       if(tf) waymix = DFP
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),5 ,'pulay',5,tf)
       if(tf) waymix = PULAY
    end if

    if(.not.tf)  call phase_error_with_msg(6,' ! no appropriate tag name',__LINE__,__FILE__)
  end subroutine check_mix_tag_name

  subroutine rd_istrbr
    integer :: ic
    call skip2next(str,len_str,'I',ic)
    read(str(ic:len_str),*) istrbr
    if(istrbr <= 0) then
       print *, ' istrbr is reset as to be 1, because istrbr(=',istrbr,') is invalid.'
       istrbr = 1
    endif
  end subroutine rd_istrbr

  subroutine rd_nbxmix
    integer :: ic
     call skip2next(str,len_str,'N',ic)
     read(str(ic:len_str),*) nbxmix
     if(nbxmix <= 0) then
        print *, ' nbxmix is reset as to be 5, because nbxmix(=',nbxmix,') is invalid.'
        nbxmix = 5
     endif
   end subroutine rd_nbxmix

   subroutine rd_hownew
     integer :: ic
     call skip2next(str,len_str,'H',ic)
     call strncmp2(str(ic:len_str),5 ,'renew',5,tf)
     if(tf) hownew = RENEW
     if(.not.tf) then
        call strncmp2(str(ic:len_str),4,'anew',4,tf)
        if(tf) then
           hownew = ANEW
        else
           print *,' hownew is set as to be RENEW, because hownew is not given properly '
           hownew = RENEW
        end if
     end if
   end subroutine rd_hownew

   subroutine rd_cutoff
     logical :: tf
     call strncmp2(str,len_str,'cutoff',6,tf)
     if(tf) call skip2next(str,len_str,'C',ic)
     call strncmp2(str(ic:len_str),5,'small',5,tf)
     if(tf) then
        cutoff_mix = SMALL
        return
     endif

     call strncmp2(str(ic:len_str),6,'medium',6,tf)
     if(tf) then
        cutoff_mix = MEDIUM
        return
     end if

     call strncmp2(str(ic:len_str),5,'large',5,tf)
     if(tf) then
        cutoff_mix = LARGE
        return
     end if
   end subroutine rd_cutoff

   subroutine rd_alpha
     integer :: ic
     call skip2next(str,len_str,'A',ic)
     read(str(ic:len_str),*) alpha
     if(alpha < 0.d0 .or. alpha > 1.0) then
        print *, ' alpha is set as to be 0.3,'&
        &       , ' because alpha(=',alpha,') is not given properly'
        alpha = 0.3d0
     end if
   end subroutine rd_alpha
end subroutine ch4mix

subroutine skip2alph(str,len_str,ic)
  implicit none
  character(len=*), intent(in) :: str
  integer, intent(in)       :: len_str
  integer, intent(out)      :: ic

  integer :: i
  logical :: tf
  ic = 0
  do i = 1, len_str
     ic = i
     call isalph(str(i:i),tf)
     if(str(i:i).eq.':') goto 999
     if(tf) return
  enddo
999 ic = 0
  return
end subroutine skip2alph

subroutine chnnm2(str,len_str,n,wka,incunt)
  use m_Const_Parameters, only : DP
  implicit none
  character(len=*), intent(in) :: str
  integer, intent(in)       :: len_str,n
  real(DP), intent(out),dimension(n) :: wka
  integer, intent(out)      :: incunt

  logical  ::         tf
  character(len=1) :: c
  logical  ::         is_chr
  real(kind=DP) ::    xnum1
  integer  ::         icount, i, ic2

  xnum1 = 0.d0

  wka = 0.d0

  incunt = 0
  icount = 0
  is_chr = .false.
1001 continue
  do i = icount+1, len_str
     icount = i
     c = str(i:i)
     if(c == ':') goto 1006
     call isnumm(c,tf)
     if(.not.is_chr.and.tf) then
        read(str(i:len_str),*) xnum1
        goto 1002
     endif
     if(c == '='.or.c == ' ') then
        is_chr = .false.
     else
        is_chr = .true.
     endif
  end do
  goto 1006
1002 continue
  incunt = incunt + 1
  wka(incunt) = xnum1

  if(incunt == n) goto 1006

  ic2 = icount + 1
  do i = icount+1, len_str
     if(str(i:i) == ' '.or.str(i:i) == ',') then
        ic2 = i
        goto 1004
     else if(str(i:i) == ':') then
        goto 1006
     endif
  end do
1004 continue
  icount = ic2
  is_chr = .false.
  goto 1001

1006 continue
end subroutine chnnm2

subroutine ch4prc(str,len_str,c_precon,amix,bmix,precon_charge_only &
     &,isterm)
  use m_Const_Parameters, only : DP
  implicit none
  character(len=*),intent(in) :: str
  integer,intent(in) ::          len_str
  logical,intent(out) ::         c_precon, precon_charge_only
  real(DP), intent(out) ::       amix, bmix
  logical,intent(out) ::         isterm

  logical  :: tf
  integer  :: i, ic, icc

  c_precon = .false.
  amix = -1.d0
  bmix = -1.d0
  precon_charge_only = .false.
  isterm = .false.

  call skip2alph(str,len_str,ic)
  if(ic <= 0) return

  isterm = .true.
  call strncmp2(str(ic:len_str),2,'cp',2,tf)
  if(tf) then
     c_precon = .true.
  else
     c_precon = .false.
  endif

  if(c_precon) then
     call skip2next(str,len_str,'A',ic)
     read(str(ic:len_str),*) amix
     if(amix > 1.d0) then
        print *,' amix is reset as to be 1.0, because amix (=',amix,') is too large.'
        amix = 1.d0
     endif

     call skip2next(str,len_str,'B',ic)
     read(str(ic:len_str),*) bmix

     do i = ic, len_str
        icc = i
        call isalph(str(i:i),tf)
        if(tf) goto 2000
        if(str(i:i).eq.':') return
     enddo

2000 continue
     ic = icc

     write(6,*) ' !! precon_charge_only = ', precon_charge_only
     if(str(ic:ic).eq.'p'.or.str(ic:ic).eq.'P') then
        call f_strncmp(str(ic:len_str),'precon_charge_only',17,tf)
        if(tf) precon_charge_only = .true.
     endif
  endif
end subroutine ch4prc

subroutine f_strncmp(str1,str2,n,tf)
  implicit none
  character(len=*), intent(in) :: str1, str2
  integer, intent(in) ::          n
  logical, intent(out) ::         tf

  character :: c
  integer   :: ndif, i
  ndif = ichar('A') - ichar('a')

  tf = .false.
  do i = 1, n
     c = char(ichar(str2(i:i)) + ndif)
     if(str1(i:i)/=str2(i:i).and.str1(i:i)/=c) goto 1000
  enddo
  tf = .true.
1000 continue
end subroutine f_strncmp

subroutine rewind_to_tag0(nfinp, len_tag, tag, eof_reach, tag_is_found&
     &, str, len_str)
!                           @(#)b_Words.f90 1.3 98/12/24 02:06:35
  implicit none
  integer, intent(in) ::       nfinp
  integer, intent(in) ::       len_tag
  character(len=*), intent(in) :: tag
  logical, intent(out) ::      eof_reach, tag_is_found
  integer, intent(in) ::       len_str
  character(len=*) ::          str

  tag_is_found = .false.
  rewind(nfinp)
  do while(.not.tag_is_found)
     read(nfinp,'(a132)',end=1001) str
!!$     call strncmp2(str,len_str,tag,len_tag,tag_is_found)
     call strncmp2b(str,len_str,tag,len_tag,tag_is_found)
  enddo
  return
1001 tag_is_found = .false.
  eof_reach = .true.
  return
end subroutine rewind_to_tag0

subroutine read_RHS_number(str,len_str,values,n)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)              :: len_str,n
  character(len=len_str), intent(out) :: str
  real(kind=DP),intent(out)        :: values(n)

  integer ic, incunt

  call skip2RHS(str,len_str,ic)
  call chnnm2(str(ic:len_str),len_str-ic+1,n,values,incunt)
  if(incunt < n) print *,' !D incunt(=',incunt,' < n(= ',n,')'
end subroutine read_RHS_number

subroutine read_LHS_number(str,len_str,values,n)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)              :: len_str,n
  character(len=len_str), intent(out) :: str
  real(kind=DP),intent(out)        :: values(n)

  integer   :: ic, incunt

  call skip2number(str,len_str,ic)
  call chnnm(str(ic:len_str),len_str-ic+1,n,values,incunt)
  if(incunt < n) print *, ' !D incunt(=',incunt,' < n(= ',n,')'
end subroutine read_LHS_number

subroutine skip2RHS(str,len_str,ic)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)       :: len_str
  integer, intent(out)      :: ic
  character(len=*), intent(in) :: str

  logical     ::  tf
  character(len=1) :: charc, c
  data charc/'='/
  integer     :: i, ipnt, ipnt2

  do i = 1, len_str
     c = str(i:i)
     if(c == charc) then
        ipnt = i
        tf = .true.
        goto 1001
     endif
  end do
  call phase_error_with_msg(6,' no matching character',__LINE__,__FILE__)

1001 continue

  ipnt2 = ipnt
  do i = ipnt2+1, len_str
     call isnumm(str(i:i),tf)
     if(tf) then
        ic = i
        return
     else
        call isalph(str(i:i),tf)
        if(tf) then
           ic = i
           return
        endif
     endif
  end do
  call phase_error_with_msg(6,' no alphabet or number',__LINE__,__FILE__)
end subroutine skip2RHS

subroutine f_strcpy(strin,len_strin,strout,len_strout)
  implicit none
  integer, intent(in)      :: len_strin, len_strout
  character(len=len_strin),  intent(in)  :: strin
  character(len=len_strout), intent(out) :: strout

  integer  :: i, len_cp

  if(len_strout < len_strin) then
     len_cp = len_strout
  else
     len_cp = len_strin
  endif

  do i = len_cp + 1, len_strout
     strout(i:i) = ' '
  enddo

  do i = 1, len_cp
     strout(i:i) = strin(i:i)
  enddo

end subroutine f_strcpy

subroutine skip2number(str,len_str,ic)
  implicit none
  integer,         intent(in)  ::    len_str
  integer,         intent(out) ::    ic
  character(len=len_str), intent(in)  :: str

  integer :: i
  logical :: tf
  ic = 0
  do i = 1, len_str
     ic = i
     call isnumm(str(i:i),tf)
     if(str(i:i) == ':') goto 999
     if(tf) return
  enddo
999 ic = 0
end subroutine skip2number

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 606 $)
!
!  MODULE: m_CS_SpaceGroup
!
!  AUTHORS: T. Yamamoto,    October/16/2005
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!
module m_CS_SpaceGroup
!      (m_CS_SG)
! $Id: m_CS_SpaceGroup.f90 606 2020-04-15 06:45:49Z ktagami $
  use m_Const_Parameters,   only : DP, PAI, PAI2, BUCS, CARTS, ANTIFERRO &
       &                         , oh=>oh_symbol, d6h=>d6h_symbol, OFF, CONTINUATION &
       &                         , FIXED_CHARGE_CONTINUATION, COORDINATE_CONTINUATION
  use m_Timing,             only : tstatc0_begin, tstatc0_end, m_Timing_initialize_tmp_timer &
       &                         , m_Timing_get_elapsed_time_tmp, m_Timing_finalize_tmp_timer
  use m_Control_Parameters, only : ipri, af, m_CtrlP_set_af &
       &                         , ipriinputfile, ipri_spg, printable &
       &                         , icond
  use m_Crystal_Structure,  only : altv,rltv,nopr,op,tau,imag &
       &                         , ngen,igen,jgen,iaf,jaf &
       &                         , alloc_igen_jgen,dealloc_igen_jgen &
       &                         , b2pmat,ig01,il,pg_symbol_system &
       &                         , misalignment, p2bmat &
       &                         , m_CS_put_Bravais_lattice &
       &                         , sw_non_symmorphic, cpumax_symsearch &
       &                         , sw_read_symmetry_from_file
  use m_Ionic_System,       only : natm,natm2,ntyp,ityp,pos,iatomn,iwei &
       &                         , m_IS_put_lattice_system &
       &                         , m_IS_put_latconst_len_angle
!!$       &                         , latconst_len,latconst_angle

! ============================ added by K. Tagami ================== 11.0
  use m_Const_Parameters,   only : NONCOLLINEAR, DELTA10, ON
! ================================================================== 11.0

! ============================ added by K. Tagami ================== 11.0
  use m_Control_Parameters,   only : noncol
  use m_Ionic_System,       only : magmom_local_now
  use m_Crystal_Structure,  only : sw_use_magnetic_symmetry
! ================================================================== 11.0

  use m_Parallelization,    only : npes,mype,mpi_comm_group
  use m_Files,              only : m_Files_file_exists, m_Files_open_nfcntn &
       &                         , m_Files_close_nfcntn, nfcntn, F_CNTN
  implicit none
 
  character(len=9), public :: lattice_system

! ========= Added by K. Tagami ========================
   real(kind=DP), dimension(3,3), public :: kt_b2pmat
   real(kind=DP), dimension(3,3), public :: kt_p2bmat
! =========

   real(kind=DP),dimension(3) :: Bravais_lattice_length, Bravais_lattice_angle

   logical, private :: cpumax_reached = .false.
   integer, private :: mnprim, mnsym
   real(kind=DP), private, allocatable, dimension(:,:) :: mtprim, mtau
   logical, private, allocatable, dimension(:) :: mfsym

   integer, private :: mnprim_af, mnsym_af
   real(kind=DP), private, allocatable, dimension(:,:) :: mtprim_af, mtau_af
   logical, private, allocatable, dimension(:) :: mfsym_af

   character(len("symmetry_info")), private, parameter ::    tag_symmetry_info    = "symmetry_info"
   character(len("symmetry_info_af")), private, parameter :: tag_symmetry_info_af = "symmetry_info_af"

   include 'mpif.h'
contains
    subroutine mat3inv(mat,matinv)
    implicit none

    real(kind=DP), intent(in)  :: mat(3,3)
    real(kind=DP), intent(out) :: matinv(3,3)

    ! local variables
    real(kind=DP) :: det
    integer :: i,j,i1,i2,j1,j2

    det=0.d0
    do i=1,3
      do j=1,3
        i1=mod(i,3)+1
        i2=mod(i+1,3)+1
        j1=mod(j,3)+1
        j2=mod(j+1,3)+1
        matinv(j,i)=mat(i1,j1)*mat(i2,j2)-mat(i1,j2)*mat(i2,j1)
      end do
      det=det+mat(i,1)*matinv(1,i)
    end do
    do i=1,3
      do j=1,3
        matinv(i,j)=matinv(i,j)/det
      end do
    end do

    return
    end subroutine mat3inv
 
  subroutine set_lattice_system(system)
    character(len=9), intent(in) :: system
    lattice_system = system
    call m_IS_put_lattice_system(lattice_system)
    pg_symbol_system = system
  end subroutine set_lattice_system

  subroutine set_ig01(iopr,nopr)
    integer, intent(in) :: iopr
    integer, intent(in) :: nopr(49)
    
    ig01(1:iopr) = nopr(1:iopr)
    if(imag==ANTIFERRO) then
       iaf = nopr(iopr+af)
    end if
  end subroutine set_ig01

  subroutine m_CS_SG_auto_gnrt_sym_op(paramset,nfout)
    logical, intent(in) :: paramset
    integer, intent(in) :: nfout
    integer ::             i, j, iopr, ip
    integer ::             af_t
    integer ::             id_sname = -1
    call tstatc0_begin('m_CS_SG_gnrt_symmetry_operations ',id_sname)
! ----- iopr, op, tau

    call autogen_space_group(nfout,ipri_spg,iopr,af_t,paramset) !! defined in this file

    if(printable) write(nfout,'(" !! af_t = ",i10)') af_t
    if(af_t > 1) call phase_error_with_msg(nfout, ' ! illegal af_t value',__LINE__,__FILE__)
    call m_CtrlP_set_af(af_t)
    if(printable) write(nfout,'(" !! af_t (after m_CtrlP_set_af) = " ,i6)') af_t

    if(ipri >= 0 .and. printable) then
       write(nfout,*) ' << rltv, altv >>'
       write(nfout,'(3f8.4,11x,3f8.4)') &
            & ((rltv(i,j),j=1,3),(altv(i,j),j=1,3),i=1,3)
    endif
    if(paramset) then
       nopr = iopr
       goto 1001
    end if

    call tau_in_CARTS()

1001 continue

    call tstatc0_end(id_sname)
  contains
    subroutine tau_in_CARTS
      integer i, no
      do i = 1, 3
         do no = 1, iopr + af
            tau(i,no,CARTS) = altv(i,1)*tau(1,no,BUCS) &
                 &     +      altv(i,2)*tau(2,no,BUCS) &
                 &     +      altv(i,3)*tau(3,no,BUCS)
         enddo
      enddo
    end subroutine tau_in_CARTS
  end subroutine m_CS_SG_auto_gnrt_sym_op

  subroutine autogen_space_group(nfout,ipri,iopr,af,paramset)
    implicit none
    integer, intent(in) :: nfout,ipri
    integer, intent(out) :: iopr,af
    logical, intent(in) :: paramset

    real(kind=DP) :: r(3,3,49),t(3,49)
    real(kind=DP) :: r_af(3,3,49),t_af(3,49)
    real(kind=DP) :: pos2(natm2,3)
    real(kind=DP) :: tprim(3,natm2),tprim_af(3,natm2)
    integer :: nopr(49),nopr_af(49)
    integer :: i,ia
    integer :: ipri_t
    integer :: ityp2(natm2)
    integer :: ityp_af(natm2)
    integer :: iopr_af
    integer :: nprim,nprim_af
    integer, parameter :: DEBUGPRINTLEVEL = 2
    character(len=9) :: system
! =================================== Added by K. Tagami ==========
    integer j,k,l,m,n
    real(kind=DP) :: tmp
!!!!    real(kind=DP) :: bmat(3,3), binv(3,3), p2bmat(3,3)
    real(kind=DP) :: bmat(3,3), binv(3,3)

! ============================== added by K. Tagami ================ 11.0
    real(kind=DP) :: mag_loc(natm2,3)
! ==================================================================== 11.0

! ============================== Added by K. Tagami ==== patch 0.9 =========
       Do j=1, 3
          Do k=1, 3
             kt_b2pmat(j,k) = b2pmat(k,j)
             kt_p2bmat(j,k) = p2bmat(k,j)
          End Do
       End do
!       Call mat3inv( kt_b2pmat, kt_p2bmat )
! =========================================================

    if(ipri>2) then
       ipri_t = 2 
    else if(paramset) then
       ipri_t = 0
    else
       ipri_t = ipri
    endif

    pos2(1:natm,1:3) = pos(1:natm,1:3)
    ityp2(1:natm) = ityp(1:natm)
    i=natm
    do ia=1,natm
       if(iwei(ia)/=1) then
          i = i+1
          pos2(i,1:3) = -pos(ia,1:3)
          ityp2(i) = ityp(ia)
       end if
    end do

    iopr = 48
    call space_group(nfout,ipri_t,altv(1,1),altv(1,2),altv(1,3), &
         &           ntyp,natm2,ityp2,pos2,system,iopr,nopr,r,t, &
         &           nprim,tprim,paramset)

!!!!!!    write(*,*) 'iopr a =', iopr

    if(ipri>=DEBUGPRINTLEVEL) then
       write(nfout,'(" number of symmetry = ",i4)') iopr
       write(nfout,'(" system = ",a)') system
       call wd_operations(nfout,r,t,nopr,iopr)
    end if

    if(imag==ANTIFERRO) then
      do ia=1,natm2
        ityp_af(ia) = nint(iatomn(ityp2(ia)))
      end do
      iopr_af = 48
      call space_group(nfout,0,altv(1,1),altv(1,2),altv(1,3), &
                     & ntyp,natm2,ityp_af,pos2,system,iopr_af,nopr_af,r_af,t_af, &
                     & nprim_af,tprim_af,paramset,af=.true.)
      if(ipri>=DEBUGPRINTLEVEL) then
         write(nfout,'(" number of symmetry when imag=ANTIFERRO = ",i8)') iopr_af
         write(nfout,'(" system = ",a)') system
         call wd_operations(nfout,r_af,t_af,nopr_af,iopr_af)
         write(nfout,'(" nprim_af, nprim = ",2i8)') nprim_af, nprim
      end if
      if(iopr_af.ne.2*iopr.and.nprim_af.le.nprim) then
         write(nfout,*) 'iopr_af=',iopr_af
         write(nfout,*) 'iopr   =',iopr
         write(nfout,*) 'nprim_af=',nprim_af
         write(nfout,*) 'nprim=',nprim
         call phase_error_with_msg(nfout, 'iopr_af .ne. 2*iopr and nprim_af .le. nprim',__LINE__,__FILE__)
      end if
!=========================== Modified by K. Tagami ======= 1.0 ===
!      call set_af_operator(nfout,ipri_t,system,iopr_af,nopr_af,r_af,t_af,nprim_af,tprim_af,iopr,nopr,r,t,nprim,tprim)
      call set_af_operator_kt(nfout,ipri_t,system,iopr_af,nopr_af,r_af,t_af,nprim_af,tprim_af,iopr,nopr,r,t,nprim,tprim)
! =================================================================
      af = 1
    else
      af = 0
    end if

    call print_prim_trans(nfout,ipri_t,nprim,tprim)

! ========================== added by K. Tagami =============================== 11.0
!    if ( noncol .and. sw_use_magnetic_symmetry == ON ) then
!       i = natm
!       mag_loc(1:natm,:) = magmom_local_now(1:natm,:)
!       do ia=1,natm
!          if (iwei(ia)/=1) then
!             i = i+1
!             mag_loc(i,1:3) = magmom_local_now(ia,1:3)
!          end if
!       end do
!       call set_magnetic_symm( natm2, pos2, iopr, nopr, r, t, mag_loc )
!    endif
! ============================================================================ 11.0

    if(.not.paramset) then
! =================================== Added by K. Tagami ==========
!!!!!!!!!!!!!!      op(:,:,:) = r(:,:,1:iopr+af)
! 
!       Call mat3inv( b2pmat, p2bmat )
!       bmat = matmul( altv, p2bmat )
!       Call mat3inv( bmat, binv )

       bmat = matmul( altv, kt_p2bmat )
       Call mat3inv( bmat, binv )
! =============================================================
!
       do i=1, iopr+af
          do n=1,3
            do m=1,3
               tmp = 0.d0
                do k=1,3
                  do l=1,3
                     tmp = tmp  + bmat(m,k) * r(k,l,i) *binv(l,n)
                  end do
               end do
               op(m,n,i) = tmp
            end do
         end do
      end do
! ========================================================================
      do i=1,iopr+af
        tau(1:3,i,BUCS) = t(1:3,i)
      end do
    end if

    call set_tspace_generators(nfout,ipri_t,iopr,nopr,r,t,natm2,nprim,tprim)
    if(ipri_t>0) call write_tspace_generators(nfout,system,nprim)

    call set_lattice_system(system)

    call set_ig01(iopr,nopr)

  end subroutine autogen_space_group

! ================================ added by K. Tagami ================= 11.0
  subroutine set_magnetic_symm( natom, apos, nsym,  nopr, rot, tau, mag_loc )
    implicit none

    integer, intent(in) :: natom
    integer, intent(inout) :: nsym
    integer, intent(out) :: nopr(48)
    real(kind=DP), intent(inout) :: rot(3,3,48), tau(3,48)
    real(kind=DP), intent(in) :: apos(natom,3)
    real(kind=DP), intent(in) :: mag_loc(natom,3)

    real(kind=DP) :: ktrot_pr(3,3,48), ktrot_carts(3,3,48)
    real(kind=DP) :: bmat(3,3), binv(3,3)
    logical :: mag_sym_flag(48)

    integer :: i, ia, ja, ja_found
    integer :: isym, count
    real(kind=DP) :: coord_tmp(3), dcoord(3), dist
    real(kind=DP) :: mag_tmp(3), dmag_p(3), dmag_m(3)
    real(kind=DP) :: c1, c2
!
    real(kind=DP), parameter :: criterion = 1.0D-5
!
    real(kind=DP), allocatable :: apos_t(:,:)
!
    integer :: it
! -- init --
    call set_drot( kt_b2pmat, kt_p2bmat, nsym, rot, ktrot_pr )
    
    Call matrix_product( altv, kt_p2bmat, bmat )
    Call mat3inv( bmat, binv )
    call set_drot( binv, bmat, nsym, rot, ktrot_carts )
    
    mag_sym_flag = .false.
    
    allocate(apos_t(natom,3))
    apos_t(1:natm,1:3) = apos(1:natom,1:3)
    do ia = 1, natom
       do i = 1, 3
          apos_t(ia,i) = apos_t(ia,i) - floor(apos_t(ia,i))
       end do
    end do

! ---
!    Do ia=1, natom
!       write(*,*) 'ia ', ia
!       write(*,*) apos_t(ia,1), apos_t(ia,2), apos_t(ia,3)
!    End do
! ---
!    Do isym=1, nsym
!       write(*,*) 'isym ', isym
!       write(*,*) ktrot_carts(1,1,isym), ktrot_carts(1,2,isym), ktrot_carts(1,3,isym)
!       write(*,*) ktrot_carts(2,1,isym), ktrot_carts(2,2,isym), ktrot_carts(2,3,isym)
!       write(*,*) ktrot_carts(3,1,isym), ktrot_carts(3,2,isym), ktrot_carts(3,3,isym)
!    End do

! -- begin --  
    Do isym=1, nsym
       
       Do it=1, ntyp
          Do ia=1, natom
             if ( ityp(ia) /=it ) cycle

             coord_tmp(1:3) = matmul( ktrot_pr(:,:,isym), apos_t(ia,1:3) ) &
                  &         + tau(1:3,isym)
             coord_tmp(1:3) = coord_tmp(1:3) - floor(coord_tmp(1:3))
          
             ja_found = 0
             Do ja=1, natom
                dcoord(:) = apos_t(ja,1:3) - coord_tmp(:)
                
                dist = dcoord(1)**2 + dcoord(2)**2 + dcoord(3)**2
                dist = sqrt(dist)
                dist = dist - floor( dist +DELTA10 )

!!             write(*,*) 'isym, ia ja, dist =', isym, ia, ja, dist
                if ( dist < criterion ) then
                   ja_found = ja
!                goto 100
                   exit
                endif
             End do

100          continue
!
             if ( ja_found ==0 ) then
                write(*,*) 'kt: Not found symmetry', isym, ia
                !stop
                call phase_error_with_msg(6,'ikt: Not found symmetry',__LINE__,__FILE__)
             endif
          
             mag_tmp(1:3) = matmul( ktrot_carts(:,:,isym), mag_loc(ia,1:3) )
          !
             dmag_m(1:3) = mag_tmp(1:3) - mag_loc(ja_found,1:3)
             dmag_p(1:3) = mag_tmp(1:3) + mag_loc(ja_found,1:3)
          !
             c1 = abs( dmag_m(1) ) +abs( dmag_m(2) ) +abs( dmag_m(3) )
             c2 = abs( dmag_p(1) ) +abs( dmag_p(2) ) +abs( dmag_p(3) )
          !
!!!          if ( c1 < criterion .or. c2 < criterion ) then
             if ( c1 < criterion ) then
                mag_sym_flag(isym) = .true.
                exit
             endif
!
             if ( mag_sym_flag(isym) ) then
                if ( c1 > criterion ) then
                   mag_sym_flag(isym) = .false.
                endif
             endif
          End do
       End do
    End do
! -----
    count = 0
    Do isym=1, nsym
       if ( mag_sym_flag(isym) ) then
          count = count + 1
          nopr(count) = nopr(isym)
          rot(:,:,count) = rot(:,:,isym)
          tau(:,count) = tau(:,isym)
       endif
    End do
    
    nsym = count

    deallocate( apos_t )

  contains

    subroutine set_drot( a,ainv,nsym,rot,drot )
      real(kind=DP), intent(in) :: a(3,3),ainv(3,3)
      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: rot(3,3,nsym)
      real(kind=DP), intent(out) :: drot(3,3,nsym)

      integer :: n
      do n=1,nsym
         drot(1:3,1:3,n) = matmul(ainv,matmul(rot(:,:,n),a))
      end do
    end subroutine set_drot
    
    subroutine matrix_product(a,b,c)
      real(kind=DP), intent(in) :: a(3,3),b(3,3)
      real(kind=DP), intent(out) :: c(3,3)
      
      ! local variables
      integer :: i,j

      do j=1,3
         do i=1,3
            c(i,j) = sum(a(i,1:3)*b(1:3,j))
         end do
      end do

    end subroutine matrix_product

  end subroutine set_magnetic_symm
!=========================================================================== 11.0

  subroutine wd_operations(nfout,r,t,nopr,iopr)
    integer, intent(in) :: nfout, iopr, nopr(iopr)
    real(kind=DP), intent(in) :: r(3,3,iopr),t(3,iopr)
    integer :: n,j, i

    write(nfout,'(" iopr = ",i8," at <<autogen_space_group>> in m_CS_spaceGroup")') iopr
    do n = 1, iopr
       write(nfout,'(" #op = ", i8)') nopr(n)
       do i = 1, 3
          write(nfout,'(4f8.4)') (r(i,j,n),j=1,3),t(i,n)
       end do
    end do
  end subroutine wd_operations

  subroutine space_group(nfout,ipri,a1,a2,a3,ntype,natom &
                      & ,itype,apos,system,nsym,nopr,rot,tau &
                      & ,nprim,tprim,paramset,af)
    implicit none

    integer, intent(in) :: nfout,ipri
    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    integer, intent(in) :: ntype,natom,itype(natom)
    real(kind=DP), intent(in) :: apos(natom,3)
    character(len=9), intent(out) :: system
    integer, intent(out) :: nsym
    integer, intent(out) :: nopr(48)
    real(kind=DP), intent(out) :: rot(3,3,48),tau(3,48)
    integer, intent(out) :: nprim
    real(kind=DP), intent(out) :: tprim(3,natom)
    logical, intent(in) :: paramset
    logical, intent(in), optional :: af

    logical :: flat(48)
    integer :: nlat
    character(len=3) :: pg_name
    character(len=5) :: pg_name_i
    character(len=2) :: bl_name
    character(len=10) :: sg_name_i
    logical :: from_af

    integer :: i,j
    flat = .true.
    from_af = .false.
    if(present(af)) from_af = af

    call determine_crystal_system(a1,a2,a3,system)
    if(system=='cubic')then
       kt_b2pmat=0.d0
       kt_p2bmat=0.d0
       do i=1,3
          kt_b2pmat(i,i) = 1.0d0
          kt_p2bmat(i,i) = 1.0d0
       enddo
    endif
10  continue ! changing system for a monoclinic crystal with a hexagonal cell
    call generate_point_group(system,nsym,rot)
    ! debug
    if(ipri>1) call print_rot(nsym,rot,flat)
    ! end debug
    call determine_lattice_point_group(system,a1,a2,a3,nsym,nlat,nopr,rot,flat)
    call get_point_group_name(nfout,system,nlat,nopr,pg_name,pg_name_i)
    call get_bravais_lattice(nfout,0,a1,a2,a3,system,nopr,pg_name_i,bl_name) ! ipri = 0
    ! debug
    if(ipri>1) then
       write(nfout,'(9x,"Lattice point group: ",a,1x,a)') pg_name,pg_name_i
       write(nfout,'(13x,"Bravais lattice: ",a,1x,a)') bl_name
       write(nfout,'("Elements of the lattice point group:")') 
       call print_rot(nsym,rot,flat)
    end if
    ! end debug
    call determine_space_group(a1,a2,a3,ntype,natom,itype,apos,nsym,nopr,rot,tau,flat,nprim,tprim,paramset,from_af)
    if(system_is_wrong(system,nsym,nopr)) go to 10
    !!$call get_point_group_name(nfout,system,nsym,nopr,pg_name,pg_name_i)
    !!$call get_bravais_lattice(nfout,ipri,a1,a2,a3,system,nopr,pg_name_i,bl_name)
    !!$call get_space_group_name(nfout,system,nsym,nopr,tau,.false.,bl_name,pg_name_i,sg_name_i)
    if(ipri>1) then
   !!$    write(nfout,'(13x,"Bravais lattice: ",a,1x,a)') bl_name
   !!$    write(nfout,'("Crystallographic point group: ",a,1x,a)') pg_name,pg_name_i
   !!$    write(nfout,'(17x,"Space group: ",a)') sg_name_i
   !!$    write(nfout,'("Elements of the space group:")')
       call print_space_group(nfout,system,nsym,nopr,rot,tau)
    end if

  contains

    logical function system_is_wrong(system,nsym,nopr)
      character(len=9), intent(inout) :: system
      integer, intent(in) :: nsym
      integer, intent(in) :: nopr(48)

      logical :: fexist(48)
      integer :: i

      fexist=.false.
      do i=1,nsym
         fexist(nopr(i)) = .true.
      end do
      
      system_is_wrong = .false.
      if(system == 'hexagonal'.and.il>0) then
         if(.not.fexist(3)) then
            ! lattice system is monoclinic if C3+ doesn't exist.
            system_is_wrong = .true.
            system = 'cubic'     
            if(ipri>0) then
               write(nfout,*) 'The lattice system was found monoclinic or orthorhombic, and'
               write(nfout,*) 'system was changed from hexagonal to cubic.'
            end if
         end if
      end if
    end function system_is_wrong

    subroutine determine_crystal_system(a1,a2,a3,system)
    implicit none

    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    character(len=9), intent(out) :: system

    ! local variables
    real(kind=DP) :: length(3),angle(3)
    real(kind=DP) :: eps = 1.d-6
    real(kind=DP) :: pi2,pi3,pi4
    real(kind=DP) :: axis(3),axis_angle
    integer :: i

    pi2 = atan(1.d0)*2.d0
    pi3 = pi2*4.d0/3.d0
    pi4 = pi3*0.5d0
    do i=1,3
       axis(i) = a1(i)+a2(i)+a3(i)
    end do

    call vectors_length_angle(a1,a2,a3,length,angle)
    call get_axis_angle(axis,axis_angle)

    if(ipri>0) then
      write(nfout,'("a1=",f10.5," a2=",f10.5," a3=",f10.5,1x," a.u.")') length(1:3)
      write(nfout,'("a =",f10.5," b =",f10.5," g =",f10.5,1x," deg.")') angle(1:3)/(2.d0*pi2)*180
      write(nfout,'("axis angle",f10.5,1x," deg.")') axis_angle/(2.d0*pi2)*180
    end if

    if(il==0) then
       system = 'hexagonal'
       if(ipri>0) write(nfout,'("System is hexagonal (manual)")')
       return
    else if(il==-1) then
       system = 'hexagonal'
       if(ipri>0) write(nfout,'("System is rhombohedral (manual)")')
       return
    end if

    if(abs(length(1)-length(2)) < eps .and. &
     & abs(angle(1)-angle(2)) < eps) then

      if(abs(length(2)-length(3)) > eps .and. &
       & abs(angle(2)-pi2) < eps .and. &
       & abs(angle(3)-pi3) < eps) then
        system = 'hexagonal'
        if(ipri>0) write(nfout,'("System is hexagonal")')
        return
      else if(abs(length(2)-length(3)) < eps .and. &
            & abs(angle(2)-angle(3)) < eps .and. &
            & abs(angle(3)-pi2) > eps .and. &
            & abs(angle(3)-pi4) > eps .and. &
            & abs(axis_angle) < eps ) then
        system = 'hexagonal'
        if(ipri>0) write(nfout,'("System is rhombohedral")')
        return
      end if

    end if

    system = 'cubic'
    if(ipri>0) write(nfout,'("System is not hexagonal nor rhombohedral")')

    end subroutine determine_crystal_system


    subroutine get_axis_angle(axis,axis_angle)
    implicit none
    real(kind=DP), intent(in) :: axis(3) 
    real(kind=DP), intent(out) :: axis_angle

    axis_angle = sqrt(sum(axis(1:3)**2))
    axis_angle = axis(3)/axis_angle
    axis_angle = acos(axis_angle)

    end subroutine get_axis_angle

    subroutine determine_lattice_point_group(system,a1,a2,a3,nsym,nlat,nopr,rot,flat)
      implicit none
      character(len=9), intent(in) :: system
      integer, intent(in) :: nsym
      integer, intent(out) :: nlat
      integer, intent(out) :: nopr(48)
      real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
      real(kind=DP), intent(in) :: rot(3,3,48)
      logical, intent(out) :: flat(48)

      ! local variables
      real(kind=DP) :: grid(3,16)
      real(kind=DP) :: x(3) 
      integer :: i,j,n,isum
      real(kind=DP), parameter :: eps = 1.d-6
!============================== Added by K. Tagami ==============
      real(kind=DP) :: ktrot(3,3,48)
      real(kind=DP) :: a(3,3),ainv(3,3)
!!!!!!!!!      real(kind=DP) :: bmat(3,3), binv(3,3), p2bmat(3,3)
      real(kind=DP) :: bmat(3,3), binv(3,3)
      integer k, l
!
      a(1:3,1) = a1(1:3)
      a(1:3,2) = a2(1:3)
      a(1:3,3) = a3(1:3)

!      Call mat3inv( b2pmat, p2bmat )
!      Call matrix_product( altv, p2bmat, bmat )
!      Call mat3inv( bmat, binv )
!      call set_drot( binv, bmat, nsym,rot,ktrot )

      Call matrix_product( altv, kt_p2bmat, bmat )
      Call mat3inv( bmat, binv )
      call set_drot( binv, bmat, nsym,rot,ktrot )
!=======================================================================

!      write(900,*) 'DEBUG a =='
!      write(900,*) ktrot(1,1,4), ktrot(1,2,4), ktrot(1,3,4)
!      write(900,*) ktrot(2,1,4), ktrot(2,2,4), ktrot(2,3,4)
!      write(900,*) ktrot(3,1,4), ktrot(3,2,4), ktrot(3,3,4)

! --

      flat = .true.

      grid(1:3,1) = a1(1:3)
      grid(1:3,2) = a2(1:3)
      grid(1:3,3) = a3(1:3)
      do i=1,3
         grid(1:3,i+3) = -grid(1:3,i)
      end do
      grid(1:3,7) = a1(1:3)-a2(1:3)
      grid(1:3,8) = a2(1:3)-a3(1:3)
      grid(1:3,9) = a3(1:3)-a1(1:3)
      do i=7,9
         grid(1:3,i+3) = -grid(1:3,i)
      end do
      grid(1:3,13) = a1(1:3)+a2(1:3)+a3(1:3)
      grid(1:3,14) = -grid(1:3,13)
      grid(1:3,15) = a1(1:3)+a2(1:3)
      grid(1:3,16) = -grid(1:3,15)

      do n=1,nsym
         isum = 0
         LOOP: do i=1,3
! ================================ added by K. Tagami ================
!!            x(1:3) = rot(1:3,1,n)*grid(1,i) &
!!                 & + rot(1:3,2,n)*grid(2,i) &
!!                 & + rot(1:3,3,n)*grid(3,i)
            if ( system == "cubic" ) then
!               x(1:3) = nint(ktrot(1:3,1,n)) *grid(1,i) &
!                    & + nint(ktrot(1:3,2,n)) *grid(2,i) &
!                    & + nint(ktrot(1:3,3,n)) *grid(3,i)
               x(1:3) = ktrot(1:3,1,n) *grid(1,i) &
                    & + ktrot(1:3,2,n) *grid(2,i) &
                    & + ktrot(1:3,3,n) *grid(3,i)
            else               ! hexagonal
               x(1:3) = ktrot(1:3,1,n) *grid(1,i) &
                    & + ktrot(1:3,2,n) *grid(2,i) &
                    & + ktrot(1:3,3,n) *grid(3,i)
            endif
! ====================================================================
            do j=1,16
               if(abs(x(1)-grid(1,j)) < eps .and. &
               &  abs(x(2)-grid(2,j)) < eps .and. &
               &  abs(x(3)-grid(3,j)) < eps ) then
                  isum = isum + i
                  cycle LOOP
! debug
!!               else
!!                 write(*,'("n=",i2,"i=",i2,"j=",i2," X=",3f10.5," G=",3f10.5)') n,i,j,x,grid(1:3,j)
! end debug
               end if
            end do
         end do LOOP
         if(isum/=6) flat(n) = .false.
      end do

      nlat=0
      do n=1,nsym
         if(flat(n)) then
            nlat = nlat+1
            nopr(nlat) = n
         end if
      end do
      
    end subroutine determine_lattice_point_group

    subroutine generate_point_group(system,nsym,rot)
    implicit none

    character(len=9), intent(in) :: system
    integer, intent(out) :: nsym
    real(kind=DP), intent(out) :: rot(3,3,48)

    if(system .eq. 'cubic') then
      call cubic_point_group(nsym,rot)
    else if(system .eq. 'hexagonal') then
! ================================= added by K. Tagami ===
!      call hexagonal_point_group(nsym,rot)
      call hexagonal_point_group_bravais(nsym,rot)
! =======================================================
    else
      if(ipri>0) write(nfout,*) 'generate_point_group: system must be cubic or hexagonal.'
    end if

    end subroutine generate_point_group

    subroutine cubic_point_group(nsym,rot)
    implicit none

    integer, intent(out) :: nsym
    real(kind=DP), intent(out) :: rot(3,3,48)
    real(kind=DP) :: tmprot(3,3,48),ainv(3,3)

    ! local variables
    real(kind=DP) :: one=1.d0, zero=0.d0
    integer :: i,j

    nsym=48

    rot(1:3,1:3,1:nsym)=zero

    ! C31+ = O5
    rot(1,3,5) = one
    rot(2,1,5) = one
    rot(3,2,5) = one

    ! C4x+ = O19
    rot(1,1,19) =  one
    rot(2,3,19) = -one
    rot(3,2,19) =  one

    do i=1,3
      rot(i,i,1) = one  ! E = O1
    end do
    do j=1,3
      do i=1,3
        rot(i,j,22) = rot(j,i,19)  ! C4x- = O22 = O19^t
        rot(i,j,9)  = rot(j,i,5)  ! C31- = O9 = O5^t
      end do
    end do

    call matrix_product(rot(1,1,19),rot(1,1,19),rot(1,1,2)) ! C2x = O2 = O19*O19
    call matrix_product(rot(1,1,5),rot(1,1,19),rot(1,1,13)) ! C2a = O13 = O5*O19
    call matrix_product(rot(1,1,19),rot(1,1,5),rot(1,1,15)) ! C2c = O15 = O19*O5

    call matrix_product(rot(1,1,2),rot(1,1,9),rot(1,1,10))  ! C32- = O10 = O2*O9
    call matrix_product(rot(1,1,13),rot(1,1,15),rot(1,1,11))! C33- = O11 = O13*O15
    call matrix_product(rot(1,1,9),rot(1,1,2),rot(1,1,12))  ! C34- = O12 = O9*O2
    call matrix_product(rot(1,1,2),rot(1,1,5),rot(1,1,8))   ! C34+ = O8 = O2*O5
    call matrix_product(rot(1,1,5),rot(1,1,2),rot(1,1,6))   ! C32+ = O6 = O5*O2
    call matrix_product(rot(1,1,15),rot(1,1,13),rot(1,1,7)) ! C31+ = O7 = O15*O13
    call matrix_product(rot(1,1,13),rot(1,1,2),rot(1,1,21)) ! C4z+ = O21 = O13*O2
    call matrix_product(rot(1,1,2),rot(1,1,13),rot(1,1,24)) ! C4z- = O24 = O2*O13
    call matrix_product(rot(1,1,15),rot(1,1,2),rot(1,1,23)) ! C4y- = O23 = O15*O2
    call matrix_product(rot(1,1,2),rot(1,1,15),rot(1,1,20)) ! C4y+ = O20 = O2*O15

    call matrix_product(rot(1,1,9),rot(1,1,7),rot(1,1,3))  ! C2y = O3 = O9*O7
    call matrix_product(rot(1,1,9),rot(1,1,8),rot(1,1,4))  ! C2z = O4 = O9*O8
    call matrix_product(rot(1,1,15),rot(1,1,6),rot(1,1,14)) ! C2b = O14 = O15*O6
    call matrix_product(rot(1,1,13),rot(1,1,7),rot(1,1,18)) ! C2f = O18 = O13*O7
    call matrix_product(rot(1,1,13),rot(1,1,8),rot(1,1,16)) ! C2d = O16 = O13*O8
    call matrix_product(rot(1,1,7),rot(1,1,24),rot(1,1,17)) ! C2e = O17 = O7*O24

    do i=1,24
      rot(1:3,1:3,i+24) = -rot(1:3,1:3,i) ! add inversion
    end do

!!  to fractional
    call mat3inv(altv,ainv)
    call set_drot(altv,ainv,nsym,rot,tmprot)
    rot = tmprot
    end subroutine cubic_point_group

    subroutine hexagonal_point_group(nsym,rot)
    implicit none

    integer, intent(out) :: nsym
    real(kind=DP), intent(out) :: rot(3,3,48)

    ! local variables
    real(kind=DP) :: one=1.d0, zero=0.d0, half=0.5d0, r32
    integer :: i,j

    r32=sqrt(3.d0)*0.5d0

    nsym=24

    rot(1:3,1:3,1:nsym)=zero

    ! C6+ = O2
    rot(1,1,2) =  half
    rot(1,2,2) = -r32
    rot(2,1,2) =  r32
    rot(2,2,2) =  half
    rot(3,3,2) =  one

    ! C222 = O11
    rot(1,1,11) = -half
    rot(1,2,11) = -r32
    rot(2,1,11) = -r32
    rot(2,2,11) =  half
    rot(3,3,11) = -one


    do i=1,3
      rot(i,i,1) = one  ! E = O1
    end do

    do j=1,3
      do i=1,3
        rot(i,j,6) = rot(j,i,2)  ! C6- = O6 = O2^t
      end do
    end do
    call matrix_product(rot(1,1,2),rot(1,1,2),rot(1,1,3))   ! C3+ = O3 = O2*O2
    call matrix_product(rot(1,1,2),rot(1,1,11),rot(1,1,9))  ! C231 = O9 = O2*O11
    call matrix_product(rot(1,1,11),rot(1,1,2),rot(1,1,7))  ! C211 = O7 = O11*O2

    do j=1,3
      do i=1,3
        rot(i,j,5) = rot(j,i,3)  ! C3- = O5 = O3^t
      end do
    end do
    call matrix_product(rot(1,1,2),rot(1,1,3),rot(1,1,4))  ! C2 = O4 = O2*O3
    call matrix_product(rot(1,1,2),rot(1,1,9),rot(1,1,10)) ! C212 = O10 = O2*O9
    call matrix_product(rot(1,1,7),rot(1,1,3),rot(1,1,8))  ! C221 = O8 = O7*O3
    call matrix_product(rot(1,1,7),rot(1,1,2),rot(1,1,12)) ! C232 = O12 = O7*O2

    do i=1,12
      rot(1:3,1:3,i+12) = -rot(1:3,1:3,i) ! add inversion
    end do

    end subroutine hexagonal_point_group

! ============================== Added by K. Tagami ============
    subroutine hexagonal_point_group_bravais(nsym,rot)  ! in Bravais Lattice
    implicit none

    integer, intent(out) :: nsym
    real(kind=DP), intent(out) :: rot(3,3,48)

    ! local variables
    real(kind=DP) :: one=1.d0, zero=0.d0
    integer :: i,j

    nsym=24

    rot(1:3,1:3,1:nsym)=zero

    do i=1,3
      rot(i,i,1) = one  ! E = O1
    end do

    ! C6+ = O2
    rot(1,1,2) =  one;    rot(1,2,2) = -one
    rot(2,1,2) =  one;    rot(3,3,2) = one

    !C3+ = O3
    rot(1,2,3) = -one;     rot(2,1,3) = one;
    rot(2,2,3) = -one;     rot(3,3,3) = one

    !C2 = O4
    rot(1,1,4) = -one;     rot(2,2,4) = -one;   rot(3,3,4) = one

    !C3- = O5
    rot(1,1,5) = -one;     rot(1,2,5) = one;
    rot(2,1,5) = -one;     rot(3,3,5) = one

    !C6- = O6
    rot(1,2,6) = one;   rot(2,1,6) = -one;
    rot(2,2,6) = one;    rot(3,3,6) = one

    !C211 = O7
    rot(1,1,7) = -one;   rot(1,2,7) = one
    rot(2,2,7) =  one;   rot(3,3,7) = -one

    !C221 = O8
    rot(1,1,8) = one;  rot(2,1,8) = one
    rot(2,2,8) = -one;  rot(3,3,8) = -one

    !C231 = O9
    rot(1,2,9) = -one;  rot(2,1,9) = -one;  rot(3,3,9) = -one

    !C212 = C10
    rot(1,1,10) = one;  rot(1,2,10) = -one
    rot(2,2,10) = -one;  rot(3,3,10) = -one

    !C222 = C11
    rot(1,1,11) = -one;  rot(2,1,11) = -one
    rot(2,2,11) = one;   rot(3,3,11) = -one

    !C232 = C12
    rot(1,2,12) = one;   rot(2,1,12) = one;     rot(3,3,12) = -one

    do i=1,12
      rot(1:3,1:3,i+12) = -rot(1:3,1:3,i) ! add inversion
    end do

    end subroutine hexagonal_point_group_bravais
! ===============================================================

    subroutine matrix_product(a,b,c)
    implicit none

    real(kind=DP), intent(in) :: a(3,3),b(3,3)
    real(kind=DP), intent(out) :: c(3,3)

    ! local variables
    integer :: i,j

    do j=1,3
      do i=1,3
        c(i,j) = sum(a(i,1:3)*b(1:3,j))
      end do
    end do

    return
    end subroutine matrix_product


    subroutine print_rot(nsym,rot,flat)
    implicit none

    integer, intent(in) :: nsym
    real(kind=DP), intent(in) :: rot(3,3,nsym)
    logical, intent(in) :: flat(48)

    !local variables
    integer :: i, n

    n = 0
    do i=1,nsym
      if(.not.flat(i)) cycle
      n = n+1
      write(nfout,'(5x,3(f10.5,1x))')             rot(1,1:3,i)
      write(nfout,'("n=",i2,1x,3(f10.5,1x))') n, rot(2,1:3,i)
      write(nfout,'(5x,3(f10.5,1x))')             rot(3,1:3,i)
      write(nfout,*)
    end do

    end subroutine print_rot

    subroutine determine_space_group(a1,a2,a3,ntype,natom,itype,apos,nsym,nopr,rot,tau,flat,nprim,tprim,paramset,af)
    implicit none

    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    integer, intent(in) :: ntype,natom,itype(natom)
    real(kind=DP), intent(in) :: apos(natom,3)
    integer, intent(inout) :: nsym
    integer, intent(out) :: nopr(48)
    real(kind=DP), intent(inout) :: rot(3,3,48)
    real(kind=DP), intent(out) :: tau(3,48)
    logical, intent(in) :: flat(48)
    integer, intent(out) :: nprim
    real(kind=DP), intent(out) :: tprim(3,natom)
    logical, intent(in) :: paramset
    logical, intent(in), optional :: af

    ! local variables
! ================================= Usami ===========
!    real(kind=DP) :: ft(3,natom,natom,48)  ! fractional trnsformations
!    integer       :: lp(3,natom,natom,48)  ! lattice point vectors
!    integer :: f(natom,48),fi(natom,48),fp0(natom),fp1(natom) ! atom transformations
    real(kind=DP), allocatable :: ft(:,:,:,:)
    integer, allocatable       :: ift(:,:,:,:)
    integer, allocatable       :: itprim(:,:)
    integer      , allocatable :: lp(:,:,:,:)
    integer, allocatable ::   f(:,:),fi(:,:), fp0(:), fp1(:)
! ===================================================
    real(kind=DP) :: sympos(natom,3)
    integer :: i,j,k,l,n,m,npg
    real(kind=DP) :: x(3),y(3),z(3)
    real(kind=DP) :: a(3,3),ainv(3,3)
    real(kind=DP) :: trans(3)
    real(kind=DP) :: r(3,3),t(3),tmp
    real(kind=DP) :: tt(3)
    integer :: ir(3,3)
    integer :: ntrans(3)
    integer :: isum,isum1,isum0
    logical :: fsym(48)
    integer :: icount
    integer :: iptab(48,48)
    integer :: mpos, isym
    logical :: fpos(48)
    integer :: irot(3,3,48)
    
    real(kind=DP) :: eps=1.d-8
    real(kind=DP) :: eps2=1.d-6
    real(kind=DP) :: mis2,d(3)
! ============================ added by K. Tagami ==========
!!!!!!    real(kind=DP) :: ktrot(3,3,48) , p2bmat(3,3)
    real(kind=DP) :: ktrot(3,3,48) 
    real(kind=DP) :: d1
    real(kind=DP) :: c1, c2, c3
    integer :: ierr1, ierr2, ierr3
    real(kind=DP) :: epsi=1.d+6
    integer :: one = 1
    integer :: ierr
    integer :: isatm,ieatm,iwork
    real(kind=DP) :: elapsed_time
    logical :: read_from_file = .false.
    logical :: logica
    character(len=256) :: tmpstr
    integer :: id_sname = -1
    logical             :: tag_is_found, EOF_reach
    integer,      parameter   :: len_str = 132
    character(len=len_str)       :: str
    logical :: from_af
    from_af = .false.
    if(present(af)) from_af = af
! ============================ Usami ============
    allocate( ft(3,natom,natom,48), lp(3,natom,natom,48) )
    allocate( f(natom,48), fi(natom,48),fp0(natom),fp1(natom) )
! =============================================================
    allocate(ift(3,natom,natom,48))
    allocate(itprim(3,natom))

    mis2 = misalignment**2

    a(1:3,1) = a1(1:3)
    a(1:3,2) = a2(1:3)
    a(1:3,3) = a3(1:3)
    call mat3inv(a,ainv)

!================================ added by Katunori Tagami =========
!!    call set_irot(a,ainv,nsym,rot,irot)
!!!!!!!!!!!!!    Call mat3inv( b2pmat, p2bmat )
!!!!!!    call set_drot( b2pmat, p2bmat, nsym,rot,ktrot )
    call set_drot( kt_b2pmat, kt_p2bmat, nsym,rot,ktrot )
!    if ( system == "cubic" ) then
!       ktrot(:,:,:) = nint(ktrot(:,:,:))
!    endif
! ==================================================================

!    write(910,*) 'DEBUG a =='
!    write(910,*) ktrot(1,1,4), ktrot(1,2,4), ktrot(1,3,4)
!    write(910,*) ktrot(2,1,4), ktrot(2,2,4), ktrot(2,3,4)
!    write(910,*) ktrot(3,1,4), ktrot(3,2,4), ktrot(3,3,4)

    ! make fractional trnsformations, ft(), and lattice point vectors, lp()
    do j=1,natom
      !!$y(1:3) = a1(1:3)*apos(j,1) + a2(1:3)*apos(j,2) + a3(1:3)*apos(j,3)
      y = apos(j,1:3)
      do i=1,natom
        !!$x(1:3) = a1(1:3)*apos(i,1) + a2(1:3)*apos(i,2) + a3(1:3)*apos(i,3)
        x = apos(i,1:3)
        do n=1,nsym
          if(.not.flat(n)) cycle

          !!z(1:3) = rot(1:3,1,n)*x(1)+rot(1:3,2,n)*x(2)+rot(1:3,3,n)*x(3)

!================================ added by Katunori Tagami =========
!!          z(1:3) = matmul(irot(:,:,n),x)
          z(1:3) = matmul( ktrot(:,:,n),x)
! ==================================================================
          !!z(1:3) = y(1:3)-z(1:3)

          ! remove primitive transformation
          !!trans(1:3) = ainv(1:3,1)*z(1)+ainv(1:3,2)*z(2)+ainv(1:3,3)*z(3)

          trans(1:3) = y(1:3)-z(1:3)
          ft(1:3,i,j,n) = trans(1:3) ! in the system a1,a2,a3
          call mod1(ft(1,i,j,n))
          lp(1:3,i,j,n) = nint(trans(1:3)-ft(1:3,i,j,n))
        end do
      end do
    end do

    ! debug
    !!write(nfout,*) 'fractional trasformations and lattice point vectors:'
    !!do j=1,natom
    !!  do i=1,natom
    !!    do n=1,nsym
    !!      if(.not.flat(n)) cycle
    !!      write(nfout,'(3(1x,i2),3(1x,f10.5),3(1x,3i))') i,j,n,ft(1:3,i,j,n),lp(1:3,i,j,n)
    !!    end do
    !!  end do
    !!end do
    ! end debug

    !!$write(*,'("max of isum=",i4)') natom*(natom+1)/2

    if((icond==CONTINUATION .or. icond==COORDINATE_CONTINUATION .or. icond==FIXED_CHARGE_CONTINUATION) &
    &  .and. sw_read_symmetry_from_file == ON) then
      if(m_Files_file_exists(F_CNTN)) then
         call m_Files_open_nfcntn()
         if(mype==0) then
           if(.not. from_af) then
             call rewind_to_tag0(nfcntn,len(tag_symmetry_info),tag_symmetry_info, &
            &     EOF_reach, tag_is_found, str,len_str)
           else
             call rewind_to_tag0(nfcntn,len(tag_symmetry_info_af),tag_symmetry_info_af, &
            &     EOF_reach, tag_is_found, str,len_str)
           endif
           if(tag_is_found) then
             read(nfcntn,*,err=50) nprim,nsym
             do i=1,nprim
                read(nfcntn,*,err=50) tprim(1:3,i)
             enddo
             do i=1,nsym
                read(nfcntn,*,err=50) tau(1:3,i),fsym(i)
             enddo
           endif
         endif
         call mpi_bcast(tag_is_found,1,mpi_logical,0,mpi_comm_group,ierr)
         if(tag_is_found) then
           call mpi_bcast(nprim,1,mpi_integer,0,mpi_comm_group,ierr)
           call mpi_bcast(nsym,1,mpi_integer,0,mpi_comm_group,ierr)
           call mpi_bcast(tprim,3*natom,mpi_double_precision,0,mpi_comm_group,ierr)
           call mpi_bcast(tau,3*nsym,mpi_double_precision,0,mpi_comm_group,ierr)
           call mpi_bcast(fsym,nsym,mpi_logical,0,mpi_comm_group,ierr)
           if(printable) write(nfout,'(a)') ' !** successfully read symmetry-info from file'
           read_from_file = .true.
         endif
50       continue
         if(read_from_file .and. .not.paramset)then
           if(.not. from_af) then
             if(allocated(mtprim)) deallocate(mtprim)
             if(allocated(mtau))   deallocate(mtau)
             if(allocated(mfsym))  deallocate(mfsym)
             allocate(mtprim(3,nprim))
             allocate(mtau(3,48))
             allocate(mfsym(48))
             mnprim = nprim;mnsym = nsym
             mtprim(1:3,1:mnprim) = tprim(1:3,1:mnprim)
             mtau(:,:) = tau(:,:)
             mfsym(:) = fsym(:)
           else
             if(allocated(mtprim_af)) deallocate(mtprim_af)
             if(allocated(mtau_af))   deallocate(mtau_af)
             if(allocated(mfsym_af))  deallocate(mfsym_af)
             allocate(mtprim_af(3,nprim))
             allocate(mtau_af(3,48))
             allocate(mfsym_af(48))
             mnprim_af = nprim;mnsym_af = nsym
             mtprim_af(1:3,1:mnprim_af) = tprim(1:3,1:mnprim_af)
             mtau_af(:,:) = tau(:,:)
             mfsym_af(:) = fsym(:)
           endif
         endif
      endif
    endif

    if(sw_non_symmorphic == ON .and. .not. cpumax_reached .and. .not. read_from_file) then
      if(printable) write(nfout,'(a)') &
      ' !** sw_non_symmorphic == ON; all space group will be taken into account'
      npg=0
      fsym(1:nsym)=.false.
      f(1:natom,1:nsym) = 0
      tau(1:3,1:nsym) = 0.d0
      nprim = 0
      ift = nint(ft*epsi)
      itprim = 0
      n=1
      iwork = (natom-1)/npes + 1
      isatm = min(mype*iwork+1, natom+1)
      ieatm = min(isatm+iwork-1,natom)
      call m_Timing_initialize_tmp_timer()
      if(flat(n)) then
        loop_l: do l = 1, natom
          elapsed_time = m_Timing_get_elapsed_time_tmp()    
          if(cpumax_symsearch>0 .and. elapsed_time>cpumax_symsearch) then
             cpumax_reached = .true.
             exit loop_l
          endif
          loop_k: do k = 1, natom
            if(itype(k).ne.itype(l)) cycle loop_k
            do m=1,nprim
              if(sum(abs(ift(1:3,k,l,n)-itprim(1:3,m)))<=one) then
                 cycle loop_k
              end if
            end do
            isum=0
            isum1=0
            loop_j: do j=isatm,ieatm
              loop_i: do i=1,natom
                if(itype(i).ne.itype(j)) cycle loop_i
                if(abs(ift(1,i,j,n)-ift(1,k,l,n)) > one .or. &
                 & abs(ift(2,i,j,n)-ift(2,k,l,n)) > one .or. &
                 & abs(ift(3,i,j,n)-ift(3,k,l,n)) > one ) then
                   cycle loop_i
                end if
                isum = isum + i
              end do loop_i
            end do loop_j
            call mpi_allreduce(isum,isum1,1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
            if(isum1 .eq. natom*(natom+1)/2) then
               nprim = nprim + 1
               tprim (1:3,nprim) = ft (1:3,k,l,n)
               itprim(1:3,nprim) = ift(1:3,k,l,n)
            end if
          enddo loop_k
        enddo loop_l
      endif

      if(.not. cpumax_reached) then
        loop_sym: do n=1,nsym
          if(mod(n-1,npes) /= mype) cycle
          if(.not.flat(n)) cycle
          loop_l2: do l=1,natom
            elapsed_time = m_Timing_get_elapsed_time_tmp()    
            if(cpumax_symsearch>0 .and. elapsed_time>cpumax_symsearch) then
               cpumax_reached = .true.
               exit loop_sym
            endif
            loop_k2: do k=1,natom
              if(itype(k).ne.itype(l)) cycle loop_k2
              isum=0
              loop_j2: do j=1,natom
                loop_i2: do i=1,natom
                  if(itype(i).ne.itype(j)) cycle loop_i2
                  if(abs(ift(1,i,j,n)-ift(1,k,l,n)) > one .or. &
                   & abs(ift(2,i,j,n)-ift(2,k,l,n)) > one .or. &
                   & abs(ift(3,i,j,n)-ift(3,k,l,n)) > one ) then
                     cycle loop_i2
                  end if
                  isum = isum + i
                  if(isum .eq. natom*(natom+1)/2) then
                     fsym(n) = .true.
                     npg = npg + 1
                     tau(1:3,n) = ft(1:3,k,l,n)
                     exit loop_l2
                  end if
                end do loop_i2
              end do loop_j2
            end do loop_k2
          end do loop_l2
        end do loop_sym
        call mpi_allreduce(mpi_in_place,tau,3*nsym,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
        call mpi_allreduce(mpi_in_place,fsym,nsym,mpi_logical,mpi_lor,mpi_comm_group,ierr)
      endif
      call m_Timing_finalize_tmp_timer

      if(.not.paramset) then
        if(.not. from_af) then
          if(allocated(mtprim)) deallocate(mtprim)
          if(allocated(mtau))   deallocate(mtau)
          if(allocated(mfsym))  deallocate(mfsym)
          allocate(mtprim(3,nprim))
          allocate(mtau(3,48))
          allocate(mfsym(48))
          mnprim = nprim;mnsym = nsym
          mtprim(1:3,1:mnprim) = tprim(1:3,1:mnprim)
          mtau(:,:) = tau(:,:)
          mfsym(:) = fsym(:)
        else
          if(allocated(mtprim_af)) deallocate(mtprim_af)
          if(allocated(mtau_af))   deallocate(mtau_af)
          if(allocated(mfsym_af))  deallocate(mfsym_af)
          allocate(mtprim_af(3,nprim))
          allocate(mtau_af(3,48))
          allocate(mfsym_af(48))
          mnprim_af = nprim;mnsym_af = nsym
          mtprim_af(1:3,1:mnprim_af) = tprim(1:3,1:mnprim)
          mtau_af(:,:) = tau(:,:)
          mfsym_af(:) = fsym(:)
        endif
      endif

      do i=1,nprim
         do j=1,3
            tprim(j,i) = rational(tprim(j,i))
         end do
      end do

      if(ipri>=1.and.nprim > 1) then
         write(nfout,'("=== Primitive translations ===")')
         do i=2,nprim
            write(nfout,'(i4,3(1x,f10.5),1x,a)') i-1,tprim(1:3,i),get_lattice_point_name(tprim(1,i))
         end do
      end if

    endif

    if(sw_non_symmorphic == OFF .or. cpumax_reached) then
      fsym  = .false.
      tau   = 0.d0
      tprim = 0.d0
      nprim = 1
      if(printable .and. sw_non_symmorphic==OFF) write(nfout,'(a)') &
      ' !*** sw_non_symmorphic == OFF; only point group will be taken into account'
      do n = 1, nsym
         do j = 1, natom
            if(sum(ft(1:3,1,j,n))<eps2) then
               fsym(n) = .true.
             cycle
            endif
         enddo
      enddo
    endif

    if(cpumax_reached) then
       write(nfout,'(a,f10.2,a)') ' !** the time spent in automatic search of space group symmetry exceeded ', &
                        & cpumax_symsearch,' (s), and will be aborted.'
    endif


    i=0
! =================================== Modified by K. Tagami =========
!    do n=1,nsym
!       if(.not.fsym(n)) cycle
!       i=i+1
!       nopr(i) = n
!       rot(1:3,1:3,i) = rot(1:3,1:3,n)
!       !!$tau(1:3,i) = tau(1:3,n)
!       do j=1,3
!          tau(j,i) = rational(tau(j,n))
!       end do
!    end do
! ================================
    do n=1,nsym
       if(.not.fsym(n)) cycle
!
       call ktrational( tau(1,n), c1, ierr1 )
       call ktrational( tau(2,n), c2, ierr2 )
       call ktrational( tau(3,n), c3, ierr3 )
!
       if ( ierr1+ierr2+ierr3 < 0 ) then
          fsym(n) = .false.
          cycle
       endif
!
       i=i+1
       nopr(i) = n
       rot(1:3,1:3,i) = rot(1:3,1:3,n)

       tau(1,i) = c1;        tau(2,i) = c2;        tau(3,i) = c3
    end do
! =========================================================================
    nsym = i
    if(nsym == 1) return

    call set_product_table(iptab,nprim,tprim)

    loop_0: do i=2,nsym
       fsym(1:nsym) = .false.
       do n=1,nsym
          if(iptab(n,i) > 0) fsym(n) = .true.
       end do
       do n=2,nsym
          if(.not.fsym(n)) cycle
          loop_2: do m=2,nsym
             if(.not.fsym(m)) cycle
             do l=1,nsym
                if(.not.fsym(l)) cycle
                if(l == iptab(n,m)) exit loop_2
             end do
             cycle loop_0
          end do loop_2
       end do
       fpos(i) = .true.
    end do loop_0

    mpos = 0
    do i=2,nsym            
       if(.not.fpos(i)) cycle
       m = 0
       do n=1,nsym
          if(iptab(n,i)>0) m = m + 1
       end do
       if(m>mpos) isym = i
    end do
       
    i=0
    do n=1,nsym
       if(iptab(n,isym)<1) cycle
       i=i+1
       nopr(i) = nopr(n)
       rot(1:3,1:3,i) = rot(1:3,1:3,n)
       do m=1,nprim
          tt(1:3) = tau(1:3,n)-tprim(1:3,m)
          call mod1(tt)
          if(sum(abs(tt(1:3))) < eps2) then
          ! experimental
          !!$d = matmul(altv,tt)
          !!$if(sum(d(1:3)**2) < mis2) then
          ! end experimental
            tau(1:3,i) = 0.d0
          else
            tau(1:3,i) = tau(1:3,n)
          end if
       end do
    end do
    nsym = i

    !!$call set_product_table(iptab,nprim,tprim)
    !!$stop 'determine_space_group: debug'
! =============================================== Usami ==========
    deallocate( ft,lp )
    deallocate( f, fi, fp0, fp1 )
! ==============================================================
    end subroutine determine_space_group
    
    subroutine set_irot(a,ainv,nsym,rot,irot)
      real(kind=DP), intent(in) :: a(3,3),ainv(3,3)
      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: rot(3,3,nsym)
      integer, intent(out) :: irot(3,3,nsym)

      integer :: n
      do n=1,nsym
         irot(1:3,1:3,n) = nint(matmul(ainv,matmul(rot(:,:,n),a)))
      end do
    end subroutine set_irot

! ================================ Added by K. Tagami =========
    subroutine set_drot( a,ainv,nsym,rot,drot )
      real(kind=DP), intent(in) :: a(3,3),ainv(3,3)
      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: rot(3,3,nsym)
      real(kind=DP), intent(out) :: drot(3,3,nsym)

      integer :: n
      do n=1,nsym
         drot(1:3,1:3,n) = matmul(ainv,matmul(rot(:,:,n),a))
      end do
    end subroutine set_drot
! ==============================================================

    subroutine set_product_table(iptab,nprim,tprim)
      integer, intent(out) :: iptab(48,48)
      integer, intent(in)  :: nprim
      real(kind=DP), intent(in) :: tprim(3,natom)

      integer :: i,j,k,l,m,n
! ============================= Added by K. Tagami ==============
!      integer :: irot(3,3,48),ir(3,3)
!!!!!!!!      real(kind=DP) :: drot(3,3,48), dr(3,3),  p2bmat(3,3)
      real(kind=DP) :: drot(3,3,48), dr(3,3)
! ===============================================================
      real(kind=DP) :: t(3),tt(3),tmp

      real(kind=DP), parameter :: eps  = 1.d-8
      real(kind=DP), parameter :: eps2 = 1.d-6
      real(kind=DP) :: mis2,d(3)

      mis2 = misalignment**2

      if(ipri>1) then
! =================================== Added by K. Tagami ======
!         write(nfout,'("irot:")')
         write(nfout,'("drot:")')
! ====================================================================
      end if
! ================================ Added by K. Tagami =========
!!!!!!!!      Call mat3inv( b2pmat, p2bmat )
!!!      call set_drot( b2pmat, p2bmat, nsym,rot, drot )
      call set_drot( kt_b2pmat, kt_p2bmat, nsym,rot, drot )
! ============================================================
      do i=1,nsym
!         do n=1,3
!            do m=1,3
!               tmp = 0.d0
!               do k=1,3
!                  do l=1,3
!                     tmp = tmp + rltv(k,m)*rot(k,l,i)*altv(l,n)
!                  end do
!               end do
!!!               irot(m,n,i) = nint(tmp/PAI2)
!            end do
!         end do
         if(ipri>1) then
! =================================== Added by K. Tagami ======
!            write(nfout,'(10(1x,i2))') i,irot(1:3,1:3,i)
             write(nfout,'(i2,9F8.4)') i, drot(1:3,1:3,i)
! ====================================================================
         end if
      end do

      do j=1,nsym
         LOOP: do i=1,nsym
            do k=1,3
! =================================== Added by K. Tagami ======
!!!!!               t(k) = sum(irot(k,1:3,i)*tau(1:3,j)) + tau(k,i)
               t(k) = sum( drot(k,1:3,i)*tau(1:3,j) ) + tau(k,i)
! ====================================================================
               do l=1,3
! =================================== Added by K. Tagami ======
!!!                  ir(k,l) = sum(irot(k,1:3,i)*irot(1:3,l,j))
                  dr(k,l) = sum( drot(k,1:3,i)*drot(1:3,l,j) )
! ====================================================================
               end do
            end do
            call mod1(t)
            ! debug
            !write(nfout,'(11(1x,i2),3(1x,f10.5))') i,j,ir(1:3,1:3),t(1:3)
            ! end debug
            do k=1,nsym
! =================================== Added by K. Tagami ======
!!!               if(sum(abs(ir(1:3,1:3)-irot(1:3,1:3,k))) < eps2) then
               if ( sum(abs(dr(1:3,1:3)-drot(1:3,1:3,k))) < eps2) then
! ====================================================================
                do l=1,nprim
                   tt(1:3) = t(1:3)-tau(1:3,k)-tprim(1:3,l)
                   call mod1(tt)
                   if(sum(abs(tt(1:3))) < eps2) then
                   ! experimental
                   !!$d = matmul(altv,tt)
                   !!$if(sum(d(1:3)**2) < mis2) then
                   ! end experimental
                      iptab(i,j) = k
                      cycle LOOP
                   end if
                 end do
               end if
            end do
            !!$write(nfout,'("Missing operation?")')
            !!$write(nfout,'(11(1x,i2),3(1x,f10.5))') i,j,ir(1:3,1:3),t(1:3)
            !!$stop 'set_product_table: missing operation'
            iptab(i,j) = 0
         end do LOOP
      end do

      if(ipri>1) then
         write(nfout,'("Product table:")')
         do i=1,nsym
            write(nfout,'(48(1x,i2))') iptab(i,1:nsym)
         end do
      end if
            !!$stop 'set_product_table: debug'
            
    end subroutine set_product_table

    function get_lattice_point_name(tprim) result(name)
      real(kind=DP), intent(in) :: tprim(3)
      character(15) :: name

      real(kind=DP) :: eps = 1.d-6
      real(kind=DP) :: mis2,d(3)

      mis2 = misalignment**2
 
      name = ''
      if(abs(tprim(1)-0.5d0) < eps .and. &
       & abs(tprim(2)-0.5d0) < eps .and. &
       & abs(tprim(3)) < eps ) then 
         name = 'c-face centered'
      else if(abs(tprim(1)-0.5d0) < eps .and. &
       & abs(tprim(2)) < eps .and. &
       & abs(tprim(3)-0.5d0) < eps ) then
         name = 'b-face centered'
      else if(abs(tprim(1)) < eps .and. &
       & abs(tprim(2)-0.5d0) < eps .and. &
       & abs(tprim(3)-0.5d0) < eps ) then
         name = 'a-face centered'
      else if(abs(tprim(1)-0.5d0) < eps .and. &
       & abs(tprim(2)-0.5d0) < eps .and. &
       & abs(tprim(3)-0.5d0) < eps ) then
         name = 'body centered'
      end if

      ! experimental
      !!$name = 'c-face centered'
      !!$d = (/ 0.5d0, 0.5d0, 0.d0 /)
      !!$d = matmul(altv,tprim-d)
      !!$if(sum(d(1:3)**2) < mis2) return
      !!$name = 'b-face centered'
      !!$d = (/ 0.5d0, 0.d0, 0.5d0 /)
      !!$d = matmul(altv,tprim-d)
      !!$if(sum(d(1:3)**2) < mis2) return
      !!$name = 'a-face centered'
      !!$d = (/ 0.d0, 0.5d0, 0.5d0 /)
      !!$d = matmul(altv,tprim-d)
      !!$if(sum(d(1:3)**2) < mis2) return
      !!$name = 'body centered'
      !!$d = (/ 0.5d0, 0.5d0, 0.5d0 /)
      !!$d = matmul(altv,tprim-d)
      !!$if(sum(d(1:3)**2) < mis2) return
      !!$name = ''
      ! end experimental
         
    end function get_lattice_point_name

  end subroutine space_group

  subroutine print_prim_trans(nfout,ipri,nprim,tprim)
    integer, intent(in) :: nfout,ipri,nprim
    real(kind=DP) :: tprim(3,nprim)

    integer :: i

    if(ipri>0 .and. nprim > 1) then
       write(nfout,'("=== Primitive translations ===")')
       do i=2,nprim
          write(nfout,'(i4,3(1x,f10.5),1x,a)') i-1,tprim(1:3,i),get_lattice_point_name(tprim(1,i))
       end do
    end if 
  contains
    function get_lattice_point_name(tprim) result(name)
      real(kind=DP), intent(in) :: tprim(3)
      character(15) :: name

      real(kind=DP) :: eps = 1.d-6
 
      name = ''
      if(abs(tprim(1)-0.5d0) < eps .and. &
       & abs(tprim(2)-0.5d0) < eps .and. &
       & abs(tprim(3)) < eps ) then 
         name = 'c-face centered'
      else if(abs(tprim(1)-0.5d0) < eps .and. &
       & abs(tprim(2)) < eps .and. &
       & abs(tprim(3)-0.5d0) < eps ) then
         name = 'b-face centered'
      else if(abs(tprim(1)) < eps .and. &
       & abs(tprim(2)-0.5d0) < eps .and. &
       & abs(tprim(3)-0.5d0) < eps ) then
         name = 'a-face centered'
      else if(abs(tprim(1)-0.5d0) < eps .and. &
       & abs(tprim(2)-0.5d0) < eps .and. &
       & abs(tprim(3)-0.5d0) < eps ) then
         name = 'body centered'
      end if

    end function get_lattice_point_name

  end subroutine print_prim_trans

  subroutine print_space_group(nfout,system,nsym,nopr,rot,tau)
    implicit none

    integer, intent(in) :: nfout
    character(len=9), intent(in) :: system
    integer, intent(in) :: nsym
    integer, intent(in) :: nopr(nsym)
    real(kind=DP), intent(in) :: rot(3,3,nsym)
    real(kind=DP), intent(in) :: tau(3,nsym)
! ============================ added by K. Tagami =======
    real(kind=DP) :: taub(3,nsym), p2bmat(3,3), c1
! ============================================================

    ! local variables
    integer :: i

    if(.not.printable) return
! ===================================== added by K. Tagami ======
!!!!!!!!!!!!!!    taub = matmul( b2pmat, tau )
    taub = matmul( kt_b2pmat, tau )
! ~==============================================================
    if(system .eq. 'cubic') then
      do i=1,nsym
! ===================================== added by K. Tagami ======
!        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(1,1:3,i),tau(1,i)
!        write(nfout,'(i2,1x,a5,3(1x,f10.5),2x,f10.5)') i,oh(nopr(i)),rot(2,1:3,i),tau(2,i)
!        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(3,1:3,i),tau(3,i)
! ==
        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(1,1:3,i),taub(1,i)
        write(nfout,'(i2,1x,a5,3(1x,f10.5),2x,f10.5)') i,oh(nopr(i)),rot(2,1:3,i),taub(2,i)
        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(3,1:3,i),taub(3,i)
! ========================================================
        write(nfout,*)
      end do
    else
      do i=1,nsym
! ===================================== added by K. Tagami ======
!        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(1,1:3,i),tau(1,i)
!        write(nfout,'(i2,1x,a5,3(1x,f10.5),2x,f10.5)') i,d6h(nopr(i)),rot(2,1:3,i),tau(2,i)
!        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(3,1:3,i),tau(3,i)
!
        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(1,1:3,i),taub(1,i)
        write(nfout,'(i2,1x,a5,3(1x,f10.5),2x,f10.5)') i,d6h(nopr(i)),rot(2,1:3,i),taub(2,i)
        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(3,1:3,i),taub(3,i)
! ===============================================================
        write(nfout,*)
      end do
    end if
  end subroutine print_space_group


  subroutine set_af_operator(nfout,ipri,system &
                            & ,nsym_af,nopr_af,rot_af,tau_af,nprim_af,tprim_af &
                            & ,nsym,nopr,rot,tau,nprim,tprim)
    implicit none
    integer, intent(in) :: nfout,ipri
    character(len=9), intent(in) :: system
    integer, intent(in) :: nsym_af,nsym,nprim_af,nprim
    integer, intent(in) :: nopr_af(48)
    real(kind=DP), intent(in) :: rot_af(3,3,49),tau_af(3,49)
    real(kind=DP), intent(in) :: tprim_af(3,nprim_af),tprim(3,nprim)
    real(kind=DP), intent(inout) :: rot(3,3,48),tau(3,48)
    integer, intent(out) :: nopr(48)

    integer :: i,j,k,iaf,n
    real(kind=DP) :: r(3,3,24),t(3,24)
    logical :: faf(nsym_af),flag(nsym_af)
    real(kind=DP), parameter :: eps=1.d-8

    faf(1:nsym_af) = .true.
    n=0
    do iaf=1,nsym_af
      do i=1,nsym
         if(sum(abs(rot_af(1:3,1:3,iaf)-rot(1:3,1:3,i))) < eps &
           & .and. sum(abs(tau_af(1:3,iaf)-tau(1:3,i))) < eps) then
           n = n + 1
           faf(iaf) = .false.
         end if
      end do
    end do
    if(nsym_af .ne. 2*n) then
       if(nprim_af .gt. nprim) then
          iaf = 1
          do i=1,nprim
             do j=1,nprim_af
                if(sum(abs(tprim(1:3,i)-tprim_af(1:3,j))) > eps) then
                   nopr(nsym+1) = nopr_af(iaf)
                   rot(:,:,nsym+1) = rot_af(:,:,iaf)
                   tau(:,nsym+1) = tprim_af(:,j)
                   go to 1000
                end if
             end do
          end do
          call phase_error_with_msg(nfout, 'AF translation was not found.',__LINE__,__FILE__)
       else
          call phase_error_with_msg(nfout, 'nsym_af .ne. 2*n and nprim_af .le. nprim',__LINE__,__FILE__)
       end if
1000   continue
    else
       LOOP: do iaf=1,nsym_af
          if(faf(iaf)) then
             do i=1,nsym
                do j=1,3
                   do k=1,3
                      r(j,k,i) = sum(rot_af(j,:,iaf)*rot(:,k,i))
                   end do
                   t(j,i) = sum(rot_af(j,:,iaf)*tau(:,i)) + tau_af(j,iaf)
                end do
             end do
             flag(1:nsym_af) = .true.
             do i=1,nsym
                do j=1,nsym_af
                   if(faf(j)) then
                      if(sum(abs(rot_af(1:3,1:3,iaf)-r(1:3,1:3,i))) < eps &
                   & .and. sum(abs(tau_af(1:3,iaf)-t(1:3,i))) < eps) then
                         flag(j) = .false.
                      end if
                   end if
                end do
             end do
             do j=1,nsym_af
                if(faf(j).and.flag(j)) cycle LOOP
             end do
             nopr(nsym+1) = nopr_af(iaf)
             rot(:,:,nsym+1) = rot_af(:,:,iaf)
             tau(:,nsym+1) = tau_af(:,iaf)
             if(ipri>0) then
                write(nfout,'(" af operator is found. iaf = ",i8)') iaf
             end if
             exit LOOP
          end if
       end do LOOP
    end if

    if(ipri>0) then
      write(nfout,'("AF operator:")')
      call print_space_group(nfout,system,1,nopr(nsym+1),rot(1,1,nsym+1),tau(1,nsym+1))
    end if

  end subroutine set_af_operator

! =============================== Added by K. Tagami ==== 1.0 ==
  subroutine set_af_operator_kt(nfout,ipri,system &
                       & ,nsym_af,nopr_af,rot_af,tau_af,nprim_af,tprim_af &
                       & ,nsym,nopr,rot,tau,nprim,tprim )
    implicit none
    integer, intent(in) :: nfout,ipri
    character(len=9), intent(in) :: system
    integer, intent(in) :: nsym_af,nsym,nprim_af,nprim
    integer, intent(in) :: nopr_af(49)
    real(kind=DP), intent(in) :: rot_af(3,3,49),tau_af(3,49)
    real(kind=DP), intent(in) :: tprim_af(3,nprim_af),tprim(3,nprim)
    real(kind=DP), intent(inout) :: rot(3,3,49),tau(3,49)
    integer, intent(out) :: nopr(49)
    integer, parameter :: DEBUGPRINTLEVEL = 2

    integer :: i,j,k,iaf,n
    real(kind=DP) :: r(3,3,24),t(3,24)
    logical :: faf(nsym_af),flag(nsym_af)
    real(kind=DP), parameter :: eps=1.d-8
! ------------------
    integer :: jfound
!!$    real(kind=DP) :: c1, kt_i, kt_j
    integer ::  kt_i, kt_j
! -------------------

    faf(1:nsym_af) = .true.
    n=0
    do iaf=1,nsym_af
      do i=1,nsym
         if(sum(abs(rot_af(1:3,1:3,iaf)-rot(1:3,1:3,i))) < eps &
           & .and. sum(abs(tau_af(1:3,iaf)-tau(1:3,i))) < eps) then
           n = n + 1
           faf(iaf) = .false.
         end if
      end do
    end do
    if(ipri>=DEBUGPRINTLEVEL) then
       do iaf = 1, nsym_af
          if(faf(iaf)) then
             write(nfout,'(" faf(",i3,") = .true.")') iaf
          else
             write(nfout,'(" faf(",i3,") = .false.")') iaf
          end if
       end do
    end if
    if(nsym_af .ne. 2*n) then
       if(nprim_af .gt. nprim) then
          iaf = 1
! ------------------------------------------
          do j=1,nprim_af
             jfound = 0
             do i=1,nprim
                if( abs(tprim(1,i)-tprim_af(1,j)) < eps &
                   .and.abs(tprim(2,i)-tprim_af(2,j)) < eps &
                   .and.abs(tprim(3,i)-tprim_af(3,j)) < eps ) then
                   jfound = 1
                endif
             end do
             if ( jfound == 0 ) then
                nopr(nsym+1) = nopr_af(iaf)
                rot(:,:,nsym+1) = rot_af(:,:,iaf)
                tau(:,nsym+1) = tprim_af(:,j)
                go to 1000
             end if
          end do
! ------------------------------------------
          call phase_error_with_msg(nfout, 'AF translation was not found.',__LINE__,__FILE__)
       else
          call phase_error_with_msg(nfout, 'nsym_af .ne. 2*n and nprim_af .le. nprim',__LINE__,__FILE__)
       end if
1000   continue
    else
! --------------------- first try : E-symmetry ----
      iaf = 1
      do kt_j=1,nprim_af
        jfound = 0
        do kt_i=1,nprim
          if( abs(tprim(1,kt_i)-tprim_af(1,kt_j)) < eps &
              .and.abs(tprim(2,kt_i)-tprim_af(2,kt_j)) < eps &
              .and.abs(tprim(3,kt_i)-tprim_af(3,kt_j)) < eps ) then
            jfound = 1
          endif
        end do
        if ( jfound == 0 ) then
          nopr(nsym+1) = nopr_af(iaf)
          rot(:,:,nsym+1) = rot_af(:,:,iaf)
          tau(:,nsym+1) = tprim_af(:,kt_j)
          goto 2000
        end if
      end do
! ------------------------- next try --------
       LOOP: do iaf=1, nsym_af
          if(faf(iaf)) then
             do i=1, nsym
                do j=1,3
                   do k=1,3
                      r(j,k,i) = sum(rot_af(j,:,iaf)*rot(:,k,i))
                   end do
                   t(j,i) = sum(rot_af(j,:,iaf)*tau(:,i)) + tau_af(j,iaf)
                end do
             end do
             flag(1:nsym_af) = .true.
             do i=1, nsym
                do j=1, nsym_af
                   if(faf(j)) then
                      if(sum(abs(rot_af(1:3,1:3,iaf)-r(1:3,1:3,i))) < eps &
                   & .and. sum(abs(tau_af(1:3,iaf)-t(1:3,i))) < eps) then
                         flag(j) = .false.
                      end if
                   end if
                end do
             end do
             do j=1, nsym_af
                if(faf(j).and.flag(j)) cycle LOOP
             end do
             nopr(nsym+1) = nopr_af(iaf)
             rot(:,:,nsym+1) = rot_af(:,:,iaf)
             tau(:,nsym+1) = tau_af(:,iaf)
             exit LOOP
          end if
       end do LOOP
! ----------------------------------------------
2000  continue
    end if
    if(ipri>0) then
      write(nfout,'("AF operator:")')

      call print_space_group(nfout,system,1,nopr(nsym+1),rot(1,1,nsym+1),tau(1,nsym+1))
    end if

  end subroutine set_af_operator_kt
! =================================================================


  subroutine set_tspace_generators(nfout,ipri,nsym,nopr,rot,tau,natom,nprim,tprim)
    implicit none
    integer, intent(in) :: nfout,ipri
    integer, intent(in) :: nsym,nopr(49)
    real(kind=DP), intent(in) :: rot(3,3,49),tau(3,49)
    integer, intent(in) :: natom,nprim
    real(kind=DP), intent(in) :: tprim(3,natom)

    integer :: iptab(nsym,nsym)
    integer :: ng,ig(3)

    call set_product_table
    call search_generators
    call set_generators
! ============================ K. Tagami ==== Unknown ============
!!!!!    if(nprim>1) call set_translations_zero
! ===========================================================

  contains
    subroutine set_product_table
      integer :: i,j,k,l,m,n
! =============================== Added by K. Tagami ========
!      integer :: irot(3,3,48),ir(3,3)
!!!!!!!!!      real(kind=DP) :: drot(3,3,48),dr(3,3), p2bmat(3,3)
      real(kind=DP) :: drot(3,3,48),dr(3,3)
! ===========================================================
      real(kind=DP) :: t(3),tt(3),tmp
      real(kind=DP), parameter :: eps = 1.d-6

      if(ipri>1) then
! =============================== Added by K. Tagami ========
!         write(nfout,'("irot:")')
         write(nfout,'("drot2:")')
! ===========================================================
      end if
! ============================== Added by K. Tagami ========
!!!!!!!!!!      Call mat3inv( b2pmat, p2bmat )
! =========================================================
      do i=1,nsym
         do n=1,3
            do m=1,3
               tmp = 0.d0
               do k=1,3
                  do l=1,3
! ============================== Added by K. Tagami ===============
!                     tmp = tmp + rltv(k,m)*rot(k,l,i)*altv(l,n)
!!!!!!!!                      tmp = tmp + p2bmat(m,k)*rot(k,l,i)*b2pmat(l,n)
                      tmp = tmp + kt_p2bmat(m,k)*rot(k,l,i)*kt_b2pmat(l,n)
! ================================================================
                  end do
               end do
! ============================== Added by K. Tagami ===============
!!               irot(m,n,i) = nint(tmp/PAI2)
               drot(m,n,i) = tmp
! ================================================================
            end do
         end do
         if(ipri>1) then
! ============================== Added by K. Tagami ===============
!            write(nfout,'(10(1x,i2))') i,irot(1:3,1:3,i)
            write(nfout,'(i2,9F8.4)') i, drot(1:3,1:3,i)
! ================================================================
         end if
      end do

      do j=1,nsym
         LOOP: do i=1,nsym
            do k=1,3
! =============================== Added by K. Tagami ======
!!!               t(k) = sum(irot(k,1:3,i)*tau(1:3,j)) + tau(k,i)
               t(k) = sum( drot(k,1:3,i)*tau(1:3,j) ) + tau(k,i)
! =========================================================
               do l=1,3
! =============================== Added by K. Tagami ======
!!!                  ir(k,l) = sum(irot(k,1:3,i)*irot(1:3,l,j))
                  dr(k,l) = sum( drot(k,1:3,i)*drot(1:3,l,j) )
! =========================================================
               end do
            end do
            call mod1(t)
            ! debug
            !write(nfout,'(11(1x,i2),3(1x,f10.5))') i,j,ir(1:3,1:3),t(1:3)
            ! end debug
            do k=1,nsym
! =============================== Added by K. Tagami ======
!!!               if(sum(abs(ir(1:3,1:3)-irot(1:3,1:3,k))) < eps) then
               if(sum(abs( dr(1:3,1:3)-drot(1:3,1:3,k))) < eps) then
! =========================================================
                do l=1,nprim
                   tt(1:3) = t(1:3)-tau(1:3,k)-tprim(1:3,l)
                   call mod1(tt)
                   if(sum(abs(tt(1:3))) < eps) then
                      iptab(i,j) = k
                      cycle LOOP
                   end if
                 end do
               end if
            end do
            write(nfout,'("Missing operation?")')
! =============================== Added by K. Tagami ======
!            write(nfout,'(11(1x,i2),3(1x,f10.5))') i,j,ir(1:3,1:3),t(1:3)
            write(nfout,'(2(1x,i2),12F8.4)') i,j, dr(1:3,1:3),t(1:3)
! =========================================================
            call phase_error_with_msg(nfout, 'set_product_table: missing operation',__LINE__,__FILE__)
            !!$iptab(i,j) = 0
         end do LOOP
      end do

      if(ipri>1) then
         write(nfout,'("Product table:")')
         do i=1,nsym
            write(nfout,'(48(1x,i2))') iptab(i,1:nsym)
         end do
      end if
            !!$stop 'set_product_table: debug'
            
    end subroutine set_product_table

    subroutine search_generators
      integer :: i,j,k
      logical :: fexist(1:nsym)
      integer :: ii
               ! debug for the function `group_is_the_same'
               !!fexist(1:nsym) = .false.
               !!fexist(5) = .true.
               !!fexist(19) = .true.
               !!fexist(25) = .true.
               !!if(group_is_the_same(fexist)) then
               !!end if
               !!  do ii=1,nsym 
               !!    write(nfout,*) ii,fexist(ii)
               !!  end do
               ! end debug
      ng = 1
      do i=1,nsym
         fexist(1:nsym) = .false.
         fexist(i) = .true.
         if(group_is_the_same(fexist)) then
            ig(ng) = i
            return
         end if
         ! debug
         !!write(nfout,'(3(i2,1x),48l)') i,fexist(1:nsym)
         ! end  debug
      end do
      ng = 2
      do i=2,nsym
         do j=i+1,nsym
            fexist(1:nsym) = .false.
            fexist(i) = .true.
            fexist(j) = .true.
            if(group_is_the_same(fexist)) then
               ig(1)  = i
               ig(ng) = j
               return
            end if
            ! debug
            !!write(nfout,'(3(i2,1x),48l)') i,j,fexist(1:nsym)
            ! end  debug
         end do
      end do
      ng = 3
      do i=2,nsym
         do j=i+1,nsym
            do k=j+1,nsym
               fexist(1:nsym) = .false.
               fexist(i) = .true.
               fexist(j) = .true.
               fexist(k) = .true.
               if(group_is_the_same(fexist)) then
                  ig(1)  = i
                  ig(2)  = j
                  ig(ng) = k
                  return
               end if
               ! debug
               !!!$write(nfout,'(3(i2,1x),48l)') i,j,k,fexist(1:nsym)
               ! end  debug
            end do
         end do
      end do
      call phase_error_with_msg(nfout, 'Set of generators of the space group was not found.',__LINE__,__FILE__)
    end subroutine search_generators

    logical function group_is_the_same(fexist)
      logical, intent(inout) :: fexist(nsym)

      integer :: i,j
      integer :: n,no
      logical :: flag(nsym)

      n=0
      no=-1 
      do while(n > no)
         flag(1:nsym) = .false.
         do j=1,nsym
            do i=1,nsym
               if(fexist(i).and.fexist(j)) flag(iptab(i,j)) = .true.
            end do
         end do
         do i=1,nsym
            if(flag(i)) fexist(i) = .true.
         end do
         no = n
         n = 0
         do i=1,nsym
            if(fexist(i)) n=n+1
         end do
      end do
      if(n==nsym) then
         group_is_the_same = .true.
      else
         group_is_the_same = .false.
      end if

    end function group_is_the_same

    subroutine set_generators
      integer :: i,j,k,n
      real(kind=DP) :: t,r,tb(3)
      real(kind=DP), parameter :: eps = 1.d-4
      ngen = ng
      call dealloc_igen_jgen
      call alloc_igen_jgen
      do i=1,ngen
         igen(i) = nopr(ig(i))
         do j=1,3
           tb(j) = sum(tau(1:3,ig(i))*b2pmat(1:3,j))
         end do
         do j=1,3
            t = tb(j)
            do k=1,20
               r=t*k
               if(abs(nint(r)-r)<eps) then
                  jgen(1,j,i) = nint(r)
                  jgen(2,j,i) = k
                  exit
               end if
            end do
         end do
      end do
      if(af>0) then
         iaf = nopr(nsym+af)
         do j=1,3
           tb(j) = sum(tau(1:3,nsym+af)*b2pmat(1:3,j))
         end do
         do j=1,3
            t = tb(j)
            do k=1,20
               r=t*k
               if(abs(nint(r)-r)<eps) then
                  jaf(1,j) = nint(r)
                  jaf(2,j) = k
                  exit
               end if
            end do
         end do
      end if
      
    end subroutine set_generators

    subroutine set_translations_zero
      integer :: i,j
      do i=1,ngen
         do j=1,3
            jgen(1,j,i) = 0
            jgen(2,j,i) = 1
         end do
      end do
    end subroutine set_translations_zero

  end subroutine set_tspace_generators

  subroutine write_tspace_generators(nfout,system,nprim)
    integer, intent(in) :: nfout
    character(len=9), intent(in) :: system
    integer, intent(in) :: nprim

    integer :: i

    write(nfout,'("TSPACE Generators:")')
    if(nprim>1) write(nfout,'("Translations are invalid.")')
!============================= Modified by K. Tagami =============
!    if(system == 'cubic') then
!      do i=1,ngen
!         write(nfout,'("igen,jgen(2,3)=",i2,"(",a5,")",3(1x,i1,"/",i1))') igen(i),oh(igen(i)),jgen(:,:,i)
!      end do
!      if(af>0) then
!         write(nfout,'("iaf ,jaf (2,3)=",i2,"(",a5,")",3(1x,i1,"/",i1))') iaf,oh(iaf),jaf(:,:)
!      end if
!    else
!      do i=1,ngen
!         write(nfout,'("igen,jgen(2,3)=",i2,"(",a5,")",3(1x,i1,"/",i1))') igen(i),d6h(igen(i)),jgen(:,:,i)
!      end do
!      if(af>0) then
!         write(nfout,'("iaf ,jaf (2,3)=",i2,"(",a5,")",3(1x,i1,"/",i1))') iaf,d6h(iaf),jaf(:,:)
!      end if
!    end if
    if(system == 'cubic') then
      do i=1,ngen
         write(nfout,'("igen,jgen(2,3)=",i2,"(",a5,")",3(3x,i2,"/",i2))') igen(i),oh(igen(i)),jgen(:,:,i)
      end do
      if(af>0) then
         write(nfout,'("iaf ,jaf (2,3)=",i2,"(",a5,")",3(3x,i2,"/",i2))') iaf,oh(iaf),jaf(:,:)
      end if
    else
      do i=1,ngen
         write(nfout,'("igen,jgen(2,3)=",i2,"(",a5,")",3(3x,i2,"/",i2))') igen(i),d6h(igen(i)),jgen(:,:,i)
      end do
      if(af>0) then
         write(nfout,'("iaf ,jaf (2,3)=",i2,"(",a5,")",3(3x,i2,"/",i2))') iaf,d6h(iaf),jaf(:,:)
      end if
    end if
! ==================================================
  end subroutine write_tspace_generators

  subroutine mod1(t)
    real(kind=DP), intent(inout) :: t(3)
    real(kind=DP), parameter :: eps = 1.d-6
    integer :: k
    t(1:3) = mod(t(1:3),1.d0)
    do k=1,3
       if(t(k) < -eps) t(k) = t(k) + 1.d0
       if(t(k) > 1.d0 - eps) t(k) = t(k) - 1.d0
    end do
  end subroutine mod1

  subroutine get_point_group_name(nfout,system,nsym,nopr,pg_name,pg_name_i)
    integer, intent(in) :: nfout
    character(len=9), intent(in) :: system
    integer, intent(in) :: nsym
    integer, intent(in) :: nopr(nsym)
    character(len=3), intent(out) :: pg_name
    character(len=5), intent(out) :: pg_name_i

    logical :: fexist(48)
    integer :: g,i

    fexist(1:48) = .false.
    do i=1,nsym
       fexist(nopr(i)) = .true.
    end do

    pg_name = 'C1 '
    pg_name_i = '1    '
    g = nsym
    if(system == 'cubic') then
       if(fexist(25)) then
       ! IE
          g = g/2
       end if
       if(g==1) then
          if(fexist(25)) then
          ! IE
             pg_name = 'Ci '
             pg_name_i = '-1   '
          else
             pg_name = 'C1 '
             pg_name_i = '1    '
          end if
       else if(g==2) then
          if(fexist(2).or.fexist(3).or.fexist(4).or. &
           & fexist(13).or.fexist(14).or.fexist(15).or. &
           & fexist(16).or.fexist(17).or.fexist(18)) then
          ! C2x or C2y or C2z or
          ! C2a or C2b or C2c or
          ! C2d or C2e or C2f
             if(fexist(25)) then
                ! IE
                pg_name = 'C2h'
                pg_name_i = '2/m  '
             else
                pg_name = 'C2 '
                pg_name_i = '2    '
             end if
          else if(fexist(26).or.fexist(27).or.fexist(28).or. &
                & fexist(37).or.fexist(38).or.fexist(39).or. &
                & fexist(40).or.fexist(41).or.fexist(42)) then
          ! IC2x or IC2y or IC2z or
          ! IC2a or IC2b or IC2c or
          ! IC2d or IC2e or IC2f
             pg_name = 'Cs '
             pg_name_i = 'm    '
          end if
       else if(g==3) then
          if(fexist(25)) then
             ! IE
             pg_name = 'S6 '
             pg_name_i = '-3   '
          else
             pg_name = 'C3 '
             pg_name_i = '3    '
          end if
       else if(g==4) then
          if((fexist(2).and.fexist(3).and.fexist(4)).or.&
           & (fexist(2).and.fexist(16).and.fexist(18)).or.&
           & (fexist(3).and.fexist(15).and.fexist(17)).or.&
           & (fexist(4).and.fexist(13).and.fexist(14))) then
          ! C2x and C2y and C2z or
          ! C2x and C2d and C2f or
          ! C2y and C2c and C2e or
          ! C2z and C2a and C2b
             if(fexist(25)) then
                ! IE
                pg_name = 'D2h'
                pg_name_i = 'mmm  '
             else
                pg_name = 'D2 '
                pg_name_i = '222  '
             end if
          else if(fexist(26).or.fexist(27).or.fexist(28).or. &
                & fexist(37).or.fexist(38).or.fexist(39).or. &
                & fexist(40).or.fexist(41).or.fexist(42).and.&
                & .not.(fexist(19).or.fexist(20).or.fexist(21))) then
                ! IC2x or IC2y or IC2z or
                ! IC2a or IC2b or IC2c or
                ! IC2d or IC2e or IC2f
             pg_name = 'C2v'
             pg_name_i = 'mm2  '
          else if((fexist(19).and.fexist(22)).or. &
                & (fexist(20).and.fexist(23)).or. &
                & (fexist(21).and.fexist(24))) then
                ! (C4x+ and C4x-) or (C4y+ and C4y-) or (C4z+ and C4z-)
             if(fexist(25)) then
                ! IE
                pg_name = 'C4h'
                pg_name_i = '4/m'
             else
                pg_name = 'C4 '
                pg_name_i = '4    '
             end if
          else if((fexist(43).and.fexist(46)).or. &
                & (fexist(44).and.fexist(47)).or. &
                & (fexist(45).and.fexist(48))) then
                ! (IC4x+ and IC4x-) or (IC4y+ and IC4y-) or (IC4z+ and IC4z-)
             pg_name = 'S4 '
             pg_name_i = '-4   '
          end if
       else if(g==6) then
          if((fexist(5).and.fexist(14).and.fexist(17).and.fexist(18)) .or. &
           & (fexist(6).and.fexist(14).and.fexist(15).and.fexist(16)) .or. &
           & (fexist(7).and.fexist(13).and.fexist(15).and.fexist(18)) .or. &
           & (fexist(8).and.fexist(13).and.fexist(16).and.fexist(17))) then
           ! C31+ and C2b and C2e and C2f
           ! C32+ and C2b and C2c and C2d
           ! C33+ and C2a and C2c and C2f
           ! C34+ and C2a and C2d and C2e
             if(fexist(25)) then
             ! IE
                pg_name = 'D3d'
                pg_name_i = '-3m  '
             else
                pg_name = 'D3 '
                pg_name_i = '32   '
             end if
          else
             pg_name = 'C3v'
             pg_name_i = '3m   '
          end if
       else if(g==8) then
          if((fexist(19).and.fexist(22)).or. &
           & (fexist(20).and.fexist(23)).or. &
           & (fexist(21).and.fexist(24))) then
           ! (C4x+ and C4x-) or (C4y+ and C4y-) or (C4z+ and C4z-)
             if(fexist(37).or.fexist(38).or.fexist(39).or. &
              & fexist(40).or.fexist(41).or.fexist(42)) then
              ! IC2a or IC2b or IC2c or IC2d or IC2e or IC2f
                if(fexist(25)) then
                ! IE
                   pg_name = 'D4h'
                   pg_name_i = '4/mmm'
                else
                   pg_name = 'C4v'
                   pg_name_i = '4mm  '
                end if
             else
                pg_name = 'D4 '
                pg_name_i = '422  '
             end if
          else
             pg_name = 'D2d'
             pg_name_i = '-42m '
          end if
       else if(g==12) then
          if(fexist(25)) then
          ! IE
             pg_name = 'Th '
             pg_name_i = 'm-3   '
          else
             pg_name = 'T  '
             pg_name_i = '23   '
          end if
       else if(g==24) then
          if(fexist(19).and.fexist(22).and. &
           & fexist(20).and.fexist(23).and. &
           & fexist(21).and.fexist(24)) then
           ! C4x+ and C4x- and C4y+ and C4y- and C4z+ and C4z-
             if(fexist(25)) then
             ! IE
                pg_name = 'Oh '
                pg_name_i = 'm-3m  '
             else
                pg_name = 'O  '
                pg_name_i = '432  '
             end if
          else
             pg_name = 'Td '
             pg_name_i = '-43m '
          end if
       end if
    else ! hexagonal
       if(fexist(13)) then
       ! IE
          g = g/2
       else if(fexist(16)) then
       ! IC2
          g = g/2
       end if
       if(g==2) then
           if(fexist(7).or.fexist(8).or.fexist(9).or. &
           & fexist(10).or.fexist(11).or.fexist(12).or.fexist(4)) then
           ! C211 or C221 or C231 or C212 or C222 or C232 or C2
             if(fexist(13)) then
                ! IE
                pg_name = 'C2h'
                pg_name_i = '2/m  '
             else
                pg_name = 'C2 '
                pg_name_i = '2    '
             end if
          else if(fexist(19).or.fexist(20).or.fexist(21).or. &
                & fexist(22).or.fexist(23).or.fexist(24).or.fexist(16)) then
                 ! IC211 or IC221 or IC231 or IC212 or IC222 or IC232 or IC2
             pg_name = 'Cs '
             pg_name_i = 'm    '
          end if
       else if(g==3) then
          if(fexist(13)) then
          ! IE
             pg_name = 'S6 '
             pg_name_i = '-3   '
          else if(fexist(16)) then
          ! IC2
             pg_name = 'C3h'
             pg_name_i = '-6   '
          else
             pg_name = 'C3 '
             pg_name_i = '3    '
          end if
       else if(g==4) then
          if(fexist(4).and.( &
            & (fexist(7).and.fexist(10)).or. &
            & (fexist(8).and.fexist(11)).or. &
            & (fexist(9).and.fexist(12)))) then
          ! C2 and ( C211 and C212 ) or ( C221 and C222 ) or ( C231 and C232 ) 
             if(fexist(13)) then
                ! IE
                pg_name = 'D2h'
                pg_name_i = 'mmm  '
             else
                pg_name = 'D2 '
                pg_name_i = '222  '
             end if
          else if( (fexist(4).and.( &
            & (fexist(19).and.fexist(22)).or. &
            & (fexist(20).and.fexist(23)).or. &
            & (fexist(21).and.fexist(24))) ) .or. &
            & (fexist(16).and.( &
            & (fexist(7).and.fexist(22)).or. &
            & (fexist(8).and.fexist(23)).or. &
            & (fexist(9).and.fexist(24)).or. &
            & (fexist(19).and.fexist(10)).or. &
            & (fexist(20).and.fexist(11)).or. &
            & (fexist(21).and.fexist(12))) ) ) then
          ! C2 and (IC211 and IC212) or (IC221 and IC222) or (IC231 and IC232) 
          ! or IC2 and (C211 and IC212) or (C221 and IC222) or (C231 and IC232)
          !         or (IC211 and C212) or (IC221 and C222) or (IC231 and C232)
             pg_name = 'C2v'
             pg_name_i = 'mm2  '
          end if
       else if(g==6) then
          if(fexist(2).and.fexist(6)) then
          ! C6+ and C6-
             if(fexist(13)) then
             ! IE
                pg_name = 'C6h'
                pg_name_i = '6/m  '
             else
                pg_name = 'C6 '
                pg_name_i = '6    '
             end if
          else if((fexist(7).and.fexist(8).and.fexist(9)) .or. &
                & (fexist(10).and.fexist(11).and.fexist(12))) then
                 ! (C211 and C221 and C231) or (C212 and C222 and C232)
             if(fexist(13)) then
             ! IE
                pg_name = 'D3d'
                pg_name_i = '-3m  '
             else if(fexist(16)) then
             ! IC2
                pg_name = 'D3h'
                pg_name_i = '-6m2 '
             else
                pg_name = 'D3 '
                pg_name_i = '32   '
             end if
          else if((fexist(19).and.fexist(20).and.fexist(21)) .or. &
                & (fexist(22).and.fexist(23).and.fexist(24))) then
                 ! (IC211 and IC221 and IC231) or (IC212 and IC222 and IC232)
             pg_name = 'C3v'
             pg_name_i = '3m   '
          end if
       else if(g==12) then
          if(fexist(7).and.fexist(8).and.fexist(9).and. &
           & fexist(10).and.fexist(11).and.fexist(12)) then
          ! C211 and C221 and C231 and C212 and C222 and C232
             if(fexist(13)) then
             ! IE
                pg_name = 'D6h'
                pg_name_i = '6/mmm'
             else
                pg_name = 'D6 '
                pg_name_i = '622  '
             end if
          else if(fexist(19).and.fexist(20).and.fexist(21).and. &
                & fexist(22).and.fexist(23).and.fexist(24)) then
                 ! IC211 and IC221 and IC231 and IC212 and IC222 and IC232
             pg_name = 'C6v'
             pg_name_i = '6mm  '
          end if
       end if
    end if
    if(g>1.and.pg_name=='C1 ') then
      write(nfout,*) 'get_point_group_name: error'
      write(nfout,*) 'system=',system
      write(nfout,*) 'nsym=',nsym
      write(nfout,*) 'g=',g
      write(nfout,*) 'fexist=',fexist
      call phase_error_with_msg(nfout, 'get_point_group_name: error',__LINE__,__FILE__)
    end if
  end subroutine get_point_group_name

  subroutine get_bravais_lattice(nfout,ipri,a1,a2,a3,system,nopr,pg_name_i,bl_name)
    integer, intent(in) :: nfout,ipri
    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    character(len=9), intent(in) :: system
    integer, intent(in) :: nopr(48)
    character(len=5), intent(in) :: pg_name_i
    character(len=2), intent(out) :: bl_name

    real(kind=DP) :: length(3),angle(3)
    real(kind=DP), parameter :: eps = 1.d-3
    real(kind=DP) :: a(3,3),b(3,3)

    a(1:3,1) = a1(1:3)
    a(1:3,2) = a2(1:3)
    a(1:3,3) = a3(1:3)

    call vectors_length_angle(a1,a2,a3,length,angle)
    angle(1:3) = angle(1:3)/PAI*180.d0

    bl_name = 'No'
    select case(pg_name_i)
    case('-1','1') ! Trigonal
       bl_name = 'aP'
    case('2/m','m','2') ! Monoclinic
       if(cell_is_monoclinic(a,length,angle)) then
          bl_name = 'mP'
          go to 100
       end if

       call change_primitive_to_bravais('I',a,b)
       if(cell_is_monoclinic(b,length,angle)) then
          bl_name = 'mI'
          go to 100
       end if

! --- ad hoc ----
       goto 1000

       if(nopr(2)==2 .or. nopr(2)==26) then
          call change_primitive_to_bravais('A',a,b)
          if(cell_is_monoclinic(b,length,angle)) then
             bl_name = 'mA'
             go to 100
          end if

       else if(nopr(2)==3 .or. nopr(2)==27) then
          call change_primitive_to_bravais('B',a,b)
          if(cell_is_monoclinic(b,length,angle)) then
             bl_name = 'mB'
             go to 100
          end if

       else if(nopr(2)==4 .or. nopr(2)==28) then
          call change_primitive_to_bravais('C',a,b)

          if(cell_is_monoclinic(b,length,angle)) then
             bl_name = 'mC'
             go to 100
          end if
       end if
! -----------------------

1000   continue
       call change_primitive_to_bravais('A',a,b)
       if(cell_is_monoclinic(b,length,angle)) then
          bl_name = 'mA'
          go to 100
       end if

       call change_primitive_to_bravais('B',a,b)
       if(cell_is_monoclinic(b,length,angle)) then
          bl_name = 'mB'
          go to 100
       end if
       call change_primitive_to_bravais('C',a,b)
       if(cell_is_monoclinic(b,length,angle)) then
          bl_name = 'mC'
          go to 100
       end if
! ----

       ! Hexagonal or Rhombohedral
       bl_name = 'mP'
       call vectors_length_angle(a1,a2,a3,length,angle)
       angle(1:3) = angle(1:3)/PAI*180.d0
       if(cell_is_rhombohedral(length,angle)) then
          length(1) = sqrt(sum((a2-a1)**2))
          length(2) = sqrt(sum((a3-a2)**2))
          length(3) = sqrt(sum((a1+a2+a3)**2))
       end if
       angle(1:2) = 90.d0
       angle(3) = 120.d0

    case('mmm','mm2','222') ! Orthorhombic
       if(cell_is_orthorhombic(a,length,angle)) then
          bl_name = 'oP'
          go to 100
       end if
       call change_primitive_to_bravais('A',a,b)
       if(cell_is_orthorhombic(b,length,angle)) then
          bl_name = 'oA'
          go to 100
       end if
       call change_primitive_to_bravais('B',a,b)
       if(cell_is_orthorhombic(b,length,angle)) then
          bl_name = 'oB'
          go to 100
       end if
       call change_primitive_to_bravais('C',a,b)
       if(cell_is_orthorhombic(b,length,angle)) then
          bl_name = 'oC'
          go to 100
       end if
       call change_primitive_to_bravais('F',a,b)
       if(cell_is_orthorhombic(b,length,angle)) then
          bl_name = 'oF'
          go to 100
       end if
       call change_primitive_to_bravais('I',a,b)
       if(cell_is_orthorhombic(b,length,angle)) then
          bl_name = 'oI'
          go to 100
       end if
       ! Hexagonal or Rhombohedral
       bl_name = 'oP'
       call vectors_length_angle(a1,a2,a3,length,angle)
       angle(1:3) = angle(1:3)/PAI*180.d0
       if(cell_is_rhombohedral(length,angle)) then
          length(1) = sqrt(sum((a2-a1)**2))
          length(2) = sqrt(sum((a3-a2)**2))
          length(3) = sqrt(sum((a1+a2+a3)**2))
       end if
       length(2) = 0.5d0*sqrt(3.d0)*length(2)
       angle(1:3) = 90.d0
    case('4/mmm','-42m','4mm','422','4/m','-4','4') ! Tetragonal
       if(cell_is_tetragonal(a,length,angle)) then
          bl_name = 'tP'
          go to 100
       end if
       call change_primitive_to_bravais('I',a,b)
       if(cell_is_tetragonal(b,length,angle)) then
          bl_name = 'tI'
          go to 100
       end if
    case('-3m','3m','32','-3','3') ! Trigonal
       bl_name = 'hP'
       !!$if(abs(length(1)-length(2)) < eps .and. &
       !!$ & abs(length(2)-length(3)) < eps .and. &
       !!$ & abs(angle(1)-angle(2)) < eps .and. &
       !!$ & abs(angle(2)-angle(3)) < eps ) then ! cell is Rhombohedral
       if(cell_is_rhombohedral(length,angle)) then
          bl_name = 'hR'
       end if
    case('6/mmm','-6m2','6mm','622','6/m','-6','6') ! Hexagonal
       bl_name = 'hP'
    case('m-3m','-43m','432','m-3','23') ! Cubic
       if(cell_is_cubic(a,length,angle)) then
          bl_name = 'cP'
          go to 100
       end if
       call change_primitive_to_bravais('F',a,b)
       if(cell_is_cubic(b,length,angle)) then
          bl_name = 'cF'
          go to 100
       end if
       call change_primitive_to_bravais('I',a,b)
       if(cell_is_cubic(b,length,angle)) then
          bl_name = 'cI'
          go to 100
       end if
    case default
       bl_name = 'No'
    end select
100 continue
    if(ipri > 0) then
       write(nfout,'("=== Lattice parameters ===")')
       write(nfout,'("a    ,b   ,c     = ",3f15.8," Bohr")') length
       write(nfout,'("alpha,beta,gamma = ",3f15.8," degree")') angle
    end if
    call m_IS_put_latconst_len_angle(length,angle)
    call m_CS_put_Bravais_lattice(length,angle)
!!$    latconst_len = length
!!$    latconst_angle = angle
  contains
    subroutine change_primitive_to_bravais(l,a,b)
      character(len=1), intent(in) :: l
      real(kind=DP), intent(in)    :: a(3,3) ! primitive
      real(kind=DP), intent(out)   :: b(3,3) ! bravais

      integer :: i,j
      real(kind=DP) :: p2b(3,3),tt(3)
      
      p2b = 0.d0
      if(l=='R' .or. l=='P') then
         ! Hexagonal or primitive
         do i=1,3
            p2b(i,i)=1.d0
         end do
      else if(l=='A') then
         ! A-face centered
         p2b(1,1) =  1.d0
         p2b(2,2) =  1.d0
         p2b(3,3) =  1.d0
         p2b(3,2) = -1.d0
         p2b(2,3) =  1.d0
      else if(l=='B') then
         ! B-face centered
         p2b(2,2) =  1.d0
         p2b(1,1) =  1.d0
         p2b(3,3) =  1.d0
         p2b(3,1) = -1.d0
         p2b(1,3) =  1.d0
      else if(l=='C') then
         ! C-face centered
         p2b(3,3) =  1.d0
         p2b(1,1) =  1.d0
         p2b(2,2) =  1.d0
         p2b(2,1) = -1.d0
         p2b(1,2) =  1.d0
      else if(l=='F') then
         ! All-face centered
         p2b(1:3,1:3) =  1.d0
         do i=1,3
            p2b(i,i)=-1.d0
         end do
      else if(l=='I') then
         ! Body centered
         p2b(1:3,1:3) =  1.d0
         do i=1,3
            p2b(i,i)=0.d0
         end do
      end if

      do i=1,3
         b(1:3,i) = 0.d0
         do j=1,3
            b(1:3,i) = b(1:3,i) + p2b(i,j)*a(1:3,j)
         end do
      end do
    end subroutine change_primitive_to_bravais

    logical function cell_is_cubic(b,length,angle)
      real(kind=DP), intent(in) :: b(3,3)
      real(kind=DP), intent(out) :: length(3),angle(3)
      cell_is_cubic = .false.
      call vectors_length_angle(b(1,1),b(1,2),b(1,3),length,angle)
      angle(1:3) = angle(1:3)/PAI*180.d0
      if( abs(length(1)-length(2)) < eps .and. &
        & abs(length(2)-length(3)) < eps .and. &
        & abs(angle(1) - 90.d0) < eps .and. &
        & abs(angle(2) - 90.d0) < eps .and. &
        & abs(angle(3) - 90.d0) < eps) then
        cell_is_cubic = .true.
      end if
    end function cell_is_cubic

    logical function cell_is_tetragonal(b,length,angle)
      real(kind=DP), intent(in) :: b(3,3)
      real(kind=DP), intent(out) :: length(3),angle(3)
      cell_is_tetragonal = .false.
      call vectors_length_angle(b(1,1),b(1,2),b(1,3),length,angle)
      angle(1:3) = angle(1:3)/PAI*180.d0
      if((abs(length(1)-length(2)) < eps .or. &
        & abs(length(2)-length(3)) < eps .or. &
        & abs(length(3)-length(1)) < eps ) .and. &
        & abs(angle(1) - 90.d0) < eps .and. &
        & abs(angle(2) - 90.d0) < eps .and. &
        & abs(angle(3) - 90.d0) < eps) then
        cell_is_tetragonal = .true.
      end if
    end function cell_is_tetragonal

    logical function cell_is_orthorhombic(b,length,angle)
      real(kind=DP), intent(in) :: b(3,3)
      real(kind=DP), intent(out) :: length(3),angle(3)
      cell_is_orthorhombic = .false.
      call vectors_length_angle(b(1,1),b(1,2),b(1,3),length,angle)
      angle(1:3) = angle(1:3)/PAI*180.d0
      !!$if(abs(angle(1) - 90.d0) < eps .and. &
      !!$  & abs(angle(2) - 90.d0) < eps .and. &
      !!$  & abs(angle(3) - 90.d0) < eps ) then
      if(abs(b(1,1))>eps.and.abs(b(2,1))<eps.and.abs(b(3,1))<eps.and.&
       & abs(b(1,2))<eps.and.abs(b(2,2))>eps.and.abs(b(3,2))<eps.and.&
       & abs(b(1,3))<eps.and.abs(b(2,3))<eps.and.abs(b(3,3))>eps) then
        cell_is_orthorhombic = .true.
      end if
    end function cell_is_orthorhombic

    logical function cell_is_monoclinic(b,length,angle)
      real(kind=DP), intent(in) :: b(3,3)
      real(kind=DP), intent(out) :: length(3),angle(3)
      cell_is_monoclinic = .false.
      call vectors_length_angle(b(1,1),b(1,2),b(1,3),length,angle)
      angle(1:3) = angle(1:3)/PAI*180.d0
      if((abs(angle(1) - 90.d0) < eps .and. &
        & abs(angle(1) - angle(2)) < eps) .or. &
        &(abs(angle(2) - 90.d0) < eps .and. &
        & abs(angle(2) - angle(3)) < eps) .or. &
        &(abs(angle(3) - 90.d0) < eps .and. &
        & abs(angle(3) - angle(1)) < eps) ) then
        cell_is_monoclinic = .true.
      end if
    end function cell_is_monoclinic

    logical function cell_is_rhombohedral(length,angle)
      real(kind=DP), intent(in) :: length(3),angle(3)
      cell_is_rhombohedral = .false.
      if(abs(length(1)-length(2)) < eps .and. &
        & abs(length(2)-length(3)) < eps .and. &
        & abs(angle(1)-angle(2)) < eps .and. &
        & abs(angle(2)-angle(3)) < eps ) then ! cell is Rhombohedral
          cell_is_rhombohedral = .true.
       end if
    end function cell_is_rhombohedral

  end subroutine get_bravais_lattice


  subroutine get_bravais_lattice_old(nfout,a1,a2,a3,system,nopr,pg_name_i,bl_name)
    integer, intent(in) :: nfout
    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    character(len=9), intent(in) :: system
    integer, intent(in) :: nopr(48)
    character(len=5), intent(in) :: pg_name_i
    character(len=2), intent(out) :: bl_name

    real(kind=DP) :: length(3),angle(3)
    real(kind=DP), parameter :: eps = 1.d-3

    length(1) = sqrt(sum(a1(1:3)*a1(1:3)))
    length(2) = sqrt(sum(a2(1:3)*a2(1:3)))
    length(3) = sqrt(sum(a3(1:3)*a3(1:3)))
    angle(1) = acos(sum(a2(1:3)*a3(1:3))/(length(2)*length(3)))
    angle(2) = acos(sum(a3(1:3)*a1(1:3))/(length(3)*length(1)))
    angle(3) = acos(sum(a1(1:3)*a2(1:3))/(length(1)*length(2)))

    angle(1:3) = angle(1:3)*180/PAI

    select case(pg_name_i)
    case('-1','1') ! Trigonal
       bl_name = 'aP'
    case('2/m','m','2') ! Monoclinic
       bl_name = 'mP'
       if(nopr(2) == 2) then
       ! C2x -> a-unique setting
          if(abs(angle(3)-90.d0) > eps) then
             if(abs(angle(2)-90.d0) > eps) then
                bl_name = 'mI'
             else
                bl_name = 'mB'
             end if
          else if(abs(angle(1)-90.d0) > eps) then
             bl_name = 'mA'
          end if
       else if(nopr(2) == 3) then
       ! C2y -> b-unique setting
          if(abs(angle(1)-90.d0) > eps) then
             if(abs(angle(3)-90.d0) > eps) then
                bl_name = 'mI'
             else
                bl_name = 'mA'
             end if
          else if(abs(angle(3)-90.d0) > eps) then
             bl_name = 'mC'
          end if
       else if(nopr(2) == 4) then
       ! C2z -> c-unique setting
          if(abs(angle(2)-90.d0) > eps) then
             if(abs(angle(1)-90.d0) > eps) then
                bl_name = 'mI'
             else
                bl_name = 'mC'
             end if
          else if(abs(angle(2)-90.d0) > eps) then
             bl_name = 'mB'
          end if
       end if
    case('mmm','mm2','222') ! Orthorhombic
       bl_name = 'oP'
       if(abs(angle(1)-90.d0) > eps .and. &
        & abs(angle(2)-90.d0) < eps .and. &
        & abs(angle(3)-90.d0) < eps ) then
          if(abs(a1(1))>eps) then
             bl_name = 'oA'
          else if(abs(a1(2))>eps) then
             bl_name = 'oB'
          else if(abs(a1(3))>eps) then
             bl_name = 'oC'
          end if
       else if(abs(angle(2)-90.d0) > eps .and. &
        & abs(angle(3)-90.d0) < eps .and. &
        & abs(angle(1)-90.d0) < eps ) then
          if(abs(a2(1))>eps) then
             bl_name = 'oA'
          else if(abs(a2(2))>eps) then
             bl_name = 'oB'
          else if(abs(a2(3))>eps) then
             bl_name = 'oC'
          end if
       else if(abs(angle(3)-90.d0) > eps .and. &
          & abs(angle(1)-90.d0) < eps .and. &
          & abs(angle(2)-90.d0) < eps ) then
          if(abs(a3(1))>eps) then
             bl_name = 'oA'
          else if(abs(a3(2))>eps) then
             bl_name = 'oB'
          else if(abs(a3(3))>eps) then
             bl_name = 'oC'
          end if
       else if((abs(a1(1)) < eps .and. &
          &  abs(a1(2)) > eps .and. &
          &  abs(a1(3)) > eps) .or. &
          & (abs(a1(2)) < eps .and. &
          &  abs(a1(3)) > eps .and. &
          &  abs(a1(1)) > eps) .or. &
          & (abs(a1(3)) < eps .and. &
          &  abs(a1(1)) > eps .and. &
          &  abs(a1(2)) > eps) ) then
          bl_name = 'oF'
       else if(abs(length(1)-length(2)) < eps .and. &
          & abs(length(2)-length(3)) < eps .and. &
          & ( abs(angle(1)-90.d0) > eps .or. &
          &   abs(angle(2)-90.d0) > eps .or. &
          &   abs(angle(3)-90.d0) > eps ) ) then
          bl_name = 'oI'
       end if
    case('4/mmm','-42m','4mm','422','4/m','-4','4') ! Tetragonal
       bl_name = 'tP'
       if(abs(angle(1)-angle(2)) > eps .or. &
        & abs(angle(2)-angle(3)) > eps ) then
          bl_name = 'tI'
       end if
    case('-3m','3m','32','-3','3') ! Trigonal
       bl_name = 'hP'
       if(abs(length(1)-length(2)) < eps .and. &
        & abs(length(2)-length(3)) < eps .and. &
        & abs(angle(1)-angle(2)) < eps .and. &
        & abs(angle(2)-angle(3)) < eps ) then
          bl_name = 'hR'
       end if
    case('6/mmm','-6m2','6mm','622','6/m','-6','6') ! Hexagonal
       bl_name = 'hP'
    case('m-3m','-43m','432','m-3','23') ! Cubic
       bl_name = 'cP'
       if(abs(angle(1) - 60.d0) < eps) then
          bl_name = 'cF'
       else if(abs(angle(1) - 109.47122d0) < eps) then
          bl_name = 'cI'
       end if
    case default
       bl_name = 'No'
    end select

  end subroutine get_bravais_lattice_old

  subroutine get_space_group_name(nfout,system,nsym,nopr,tau,fbravais,bl_name,pg_name_i,sg_name_i)
    integer, intent(in) :: nfout
    character(len=9), intent(in) :: system
    integer, intent(in) :: nsym
    integer, intent(in) :: nopr(48)
    real(kind=DP), intent(in) :: tau(3,*)
    logical, intent(in) :: fbravais
    character(len=2), intent(in) :: bl_name
    character(len=5), intent(in) :: pg_name_i
    character(len=10), intent(out) :: sg_name_i

    character(len=1) :: s,l,sp
    character(len=2) :: sub
    character(len=9) :: sg_name0
    integer :: i,j
    logical :: fexist(48)
    real(kind=DP) :: t(3,48)
    real(kind=DP), parameter :: eps = 1.d-6

    fexist(1:48) = .false.
    t(1:3,1:48) = 0.d0
    do i=1,nsym
       fexist(nopr(i)) = .true. 
       t(1:3,nopr(i)) = tau(1:3,i)
    end do

    sp=''
    s(1:1) = bl_name(1:1)
    l(1:1) = bl_name(2:2)

    if(.not.fbravais) call get_trans_in_bravais_system(l,t)

    select case(pg_name_i)
    case('1','-1')     ! Triclinic
       sg_name_i = l // trim(pg_name_i)
    case('2')     ! Monoclinic
       sg_name0= trim(pg_name_i)
       if(system == 'cubic') then
          if(fexist(2)) then
          ! C2x
             if(abs(t(1,2)) > eps) sg_name0= trim(pg_name_i) // '_1'
          else if(fexist(3)) then
          ! C2y
             if(abs(t(2,3)) > eps) sg_name0= trim(pg_name_i) // '_1'
          else if(fexist(4)) then
          ! C2z
             if(abs(t(3,4)) > eps) sg_name0= trim(pg_name_i) // '_1'
          end if
       else ! hexagonal
          if(fexist(4)) then
             ! C2
             if(sum(abs(t(1:3,i))) > eps) sg_name0= trim(pg_name_i) // '_1'
          else
             do i=7,12
                if(fexist(i)) then
             ! C211 or C221 or C231 or C212 or C222 or C232
                   if(sum(abs(t(1:3,i))) > eps) sg_name0= trim(pg_name_i) // '_1'
                end if
             end do
          end if
       end if
       sg_name_i = l // trim(sg_name0)
    case('m')     ! Monoclinic
       if(system == 'cubic') then
          do i=0,2
             if(fexist(26+i)) then
             ! IC2x or IC2y or IC2z
               call get_symbol_of_sym_plane(t(1,26+i),sp)
             end if
          end do
       else ! hexagonal
          if(fexist(16)) then
             ! IC2
             call get_symbol_of_sym_plane(t(1,i),sp)
          else
             do i=19,24
                if(fexist(i)) then
             ! IC211 or IC221 or IC231 or IC212 or IC222 or IC232
                   call get_symbol_of_sym_plane(t(1,i),sp)
                end if
             end do
          end if
       end if
       if(sp=='a' .or. sp=='b' .or. sp=='n') then
          sp = 'c'
       end if
       sg_name_i = l // trim(sp)
    case('2/m')   ! Monoclinic
       sg_name0 = '2'
       if(system == 'cubic') then
          do i=0,2
             if(fexist(2+i)) then
             ! C2x or C2y or C2z
                if(sum(abs(t(1:3,2+i))) > eps) sg_name0= trim(sg_name0) // '_1'
                ! IC2x or IC2y or IC2z
                call get_symbol_of_sym_plane(t(1,26+i),sp)
             end if
          end do
          do i=0,5
             if(fexist(13+i)) then
             ! C2a or C2b or C2c or C2d or C2e or C2f
                if(sum(abs(t(1:3,13+i))) > eps) sg_name0= trim(sg_name0) // '_1'
                ! IC2a or IC2b or IC2c or IC2d or IC2e or IC2f
                call get_symbol_of_sym_plane(t(1,37+i),sp)
             end if
          end do
       else ! hexagonal
          if(fexist(4)) then
             ! C2
             if(sum(abs(t(1:3,4))) > eps) sg_name0= trim(pg_name_i) // '_1'
             ! IC2
             call get_symbol_of_sym_plane(t(1,16),sp)
          else
             do i=7,12
                if(fexist(i)) then
                ! C211 or C221 or C231 or C212 or C222 or C232
                   if(sum(abs(t(1:3,i))) > eps) sg_name0= trim(pg_name_i) // '_1'
                ! IC211 or IC221 or IC231 or IC212 or IC222 or IC232
                   call get_symbol_of_sym_plane(t(1,i+12),sp)
                end if
             end do
          end if
       end if
       if(sp=='a' .or. sp=='b' .or. sp=='n') sp = 'c'
       sg_name0= trim(sg_name0) // '/' // sp
       sg_name_i = l // trim(sg_name0)
    case('222')   ! Orthorhombic
       if(system == 'cubic') then
          ! C2x
          sg_name0 = '2'
          if(abs(t(1,2)) > eps) sg_name0= trim(sg_name0) // '_1'
          ! C2y
          sg_name0 = trim(sg_name0) // '2'
          if(abs(t(2,3)) > eps) sg_name0= trim(sg_name0) // '_1'
          ! C2z
          sg_name0 = trim(sg_name0) // '2'
          if(abs(t(3,4)) > eps) sg_name0= trim(sg_name0) // '_1'
          sg_name_i = l // trim(sg_name0)
       else ! hexagonal
          do i=0,2
             if(fexist(10+i)) then
                ! C212 or C222 or C232 (C2x)
                sg_name0 = '2'
                if(sum(abs(t(1:3,10+i))) > eps) sg_name0= trim(sg_name0) // '_1'
                ! C211 or C221 or C231 (C2y)
                sg_name0 = trim(sg_name0) // '2'
                if(sum(abs(t(1:3,7+i))) > eps) sg_name0= trim(sg_name0) // '_1'
                exit
             end if
          end do
          ! C2 (C2z)
          sg_name0 = trim(sg_name0) // '2'
          if(sum(abs(t(1:3,4))) > eps) sg_name0= trim(sg_name0) // '_1'
          sg_name_i = l // trim(sg_name0)
       end if
    case('mm2')   ! Orthorhombic
       sg_name0 = ''
       if(system == 'cubic') then
          do i=0,2
             if(fexist(2+i)) then
             ! C2x or C2y or C2z
                j = mod(i+1,3)
                if(fexist(26+j)) then
                ! IC2y or IC2z or IC2x
                   call get_symbol_of_sym_plane(t(1,26+j),sp)
                   sg_name0= trim(sg_name0) // sp
                end if
                j = mod(i+2,3)
                if(fexist(26+j)) then
                ! IC2z or IC2x or IC2y
                   call get_symbol_of_sym_plane(t(1,26+j),sp)
                   sg_name0= trim(sg_name0) // sp
                end if
                if(fexist(40-i)) then
                ! IC2d or IC2c or IC2b
                   call get_symbol_of_sym_plane(t(1,40-i),sp)
                   sg_name0= trim(sg_name0) // sp
                   if(40-i==38.and.fexist(37)) then
                   ! IC2f
                      call get_symbol_of_sym_plane(t(1,37),sp)
                   else if(40-i==39.and.fexist(41)) then
                   ! IC2e
                      call get_symbol_of_sym_plane(t(1,41),sp)
                   else if(40-i==40.and.fexist(42)) then
                   ! IC2a
                      call get_symbol_of_sym_plane(t(1,42),sp)
                   end if
                   sg_name0= trim(sg_name0) // sp
                end if
                sg_name0 = trim(sg_name0) // '2'
                if(abs(t(1+i,2+i)) > eps) sg_name0= trim(sg_name0) // '_1'
             end if
          end do
       else ! hexagonal
          if(fexist(4)) then
          ! c2 (C2z)
             do i=0,2
                if(fexist(22+i)) then
                   ! IC212 or IC222 or IC232 (IC2x)
                   call get_symbol_of_sym_plane(t(1,22+i),sp)
                   sg_name0= trim(sg_name0) // sp
                   ! IC211 or IC221 or IC231 (IC2y)
                   call get_symbol_of_sym_plane(t(1,19+i),sp)
                   sg_name0= trim(sg_name0) // sp
                end if
             end do
             sg_name0 = trim(sg_name0) // '2'
             if(sum(abs(t(1:3,4))) > eps) sg_name0= trim(sg_name0) // '_1'
          else
             do i=0,5
                if(fexist(7+i)) then
                ! C211 or C221 or C231 (C2y)
                ! or C212 or C222 or C232 (C2x)
                   if(i<3) then
                      j=i+3+19
                   else
                      j=i-3+19
                   end if
                   ! IC212 or IC222 or IC232 (IC2x)
                   ! or IC211 or IC221 or IC231 (IC2y)
                   call get_symbol_of_sym_plane(t(1,j),sp)
                   sg_name0= trim(sg_name0) // sp
                   ! IC2 (IC2z)
                   call get_symbol_of_sym_plane(t(1,16),sp)
                   sg_name0= trim(sg_name0) // sp

                   sg_name0 = trim(sg_name0) // '2'
                   if(sum(abs(t(1:3,7+i))) > eps) &
                      & sg_name0= trim(sg_name0) // '_1'
                   exit
                end if
             end do
          end if
       end if
       sg_name_i = l // trim(sg_name0)
    case('mmm')   ! Orthorhombic
       sg_name0 = ''
       if(system == 'cubic') then
          do i=0,2
             ! IC2x or IC2y or IC2z
             call get_symbol_of_sym_plane(t(1,26+i),sp)
             sg_name0= trim(sg_name0) // sp
          end do
       else ! hexagonal
          do i=0,2
             if(fexist(22+i)) then
                ! IC212 or IC222 or IC232 (IC2x)
                call get_symbol_of_sym_plane(t(1,22+i),sp)
                sg_name0= trim(sg_name0) // sp
                ! IC211 or IC221 or IC231 (IC2y)
                call get_symbol_of_sym_plane(t(1,19+i),sp)
                sg_name0= trim(sg_name0) // sp
                exit
             end if
          end do
          ! IC2 (IC2z)
          call get_symbol_of_sym_plane(t(1,16),sp)
          sg_name0= trim(sg_name0) // sp
       end if
       sg_name_i = l // trim(sg_name0)
    case('4')     ! Tetragonal
       do i=0,2
         if(fexist(19+i)) then
          ! C4x+ or C4y+ or C4z+
            call get_screw_sub(t(1+i,19+i),4,sub)
            sg_name0= '4' // trim(sub)
            exit
         end if
       end do
       sg_name_i = l // trim(sg_name0)
    case('-4')    ! Tetragonal
       sg_name_i = l // trim(pg_name_i)
    case('4/m')   ! Tetragonal
       do i=0,2
         if(fexist(19+i)) then
          ! C4x+ or C4y+ or C4z+
            call get_screw_sub(t(1+i,19+i),4,sub)
            sg_name0= '4' // trim(sub)
          ! IC2x or IC2y or IC2z
            call get_symbol_of_sym_plane(t(1,26+i),sp)
            sg_name0= trim(sg_name0) // "/" // sp
            exit
         end if
       end do
       sg_name_i = l // trim(sg_name0)
    case('422')   ! Tetragonal
       do i=0,2
          if(fexist(19+i)) then
           ! C4x+ or C4y+ or C4z+
             call get_screw_sub(t(1+i,19+i),4,sub)
             sg_name0= '4' // trim(sub)
           ! C2x or C2y or C2z
             j = mod(i+1,3)
             call get_screw_sub(t(1+j,2+j),2,sub)
             sg_name0= trim(sg_name0) // '2' // trim(sub) // '2'
             exit
          end if
       end do
       sg_name_i = l // sg_name0
    case('4mm')   ! Tetragonal
       do i=0,2
          if(fexist(19+i)) then
           ! C4x+ or C4y+ or C4z+
             call get_screw_sub(t(1+i,19+i),4,sub)
             sg_name0= '4' // trim(sub)
           ! IC2x or IC2y or IC2z
             j = mod(i+1,3)
             call get_symbol_of_sym_plane(t(1,26+j),sp)
             sg_name0= trim(sg_name0) // sp
           ! IC2d(40) or IC2c(39) or IC2b(38)
             call get_symbol_of_sym_plane(t(1,40-i),sp)
             sg_name0= trim(sg_name0) // sp
             exit
          end if
       end do
       sg_name_i = l // sg_name0
    case('-42m') ! Tetragonal
       do i=0,2
          if(fexist(43+i)) then
           ! C4x+ or C4y+ or C4z+
             sg_name0= '-4'
             j = mod(i+1,3)
             if(fexist(2+i)) then
              ! C2x or C2y or C2z
                call get_screw_sub(t(1+j,2+j),2,sub)
                sg_name0= trim(sg_name0) // '2' // trim(sub)
              ! IC2d(40) or IC2c(39) or IC2b(38)
                call get_symbol_of_sym_plane(t(1,40-i),sp)
                sg_name0= trim(sg_name0) // sp
             else
              ! IC2x or IC2y or IC2z
                call get_symbol_of_sym_plane(t(1,26+i),sp)
                sg_name0= trim(sg_name0) // sp
              ! C2d(16) or C2c(15) or C2b(14)
                sg_name0= trim(sg_name0) // '2'
             end if
             exit
          end if
       end do
       sg_name_i = l // sg_name0
    case('4/mmm') ! Tetragonal
       do i=0,2
          if(fexist(19+i)) then
           ! C4x+ or C4y+ or C4z+
             call get_screw_sub(t(1+i,19+i),4,sub)
             sg_name0= '4' // trim(sub)
           ! IC2x+ or IC2y+ or IC2z+
             call get_symbol_of_sym_plane(t(1,26+i),sp)
             sg_name0= trim(sg_name0) // "/" // sp
           ! IC2x or IC2y or IC2z
             j = mod(i+1,3)
             call get_symbol_of_sym_plane(t(1,26+j),sp)
             sg_name0= trim(sg_name0) // sp
           ! IC2d(40) or IC2c(39) or IC2b(38)
             call get_symbol_of_sym_plane(t(1,40-i),sp)
             sg_name0= trim(sg_name0) // sp
             exit
          end if
       end do
       sg_name_i = l // sg_name0
    case('3')     ! Trigonal
       if(l=='R') then
          sg_name_i = l // pg_name_i
       else
          ! C3+
          call get_screw_sub(t(3,3),3,sub)
          sg_name_i = l // '3' // trim(sub)
       end if
    case('-3')    ! Trigonal
       sg_name_i = l // '-3'
    case('32')    ! Trigonal
       if(l=='R') then
          sg_name_i = l // pg_name_i
       else
          ! C3+
          call get_screw_sub(t(3,3),3,sub)
          sg_name0 = '3' // trim(sub)
          if(fexist(10)) then
          ! C212
             sg_name0 = trim(sg_name0) // '2'
          else
             sg_name0 = trim(sg_name0) // '1'
          end if
          if(fexist(7)) then
          ! C211
             sg_name0 = trim(sg_name0) // '2'
          else
             sg_name0 = trim(sg_name0) // '1'
          end if
          sg_name_i = l // trim(sg_name0)
       end if
    case('3m','-3m')    ! Trigonal
       if(pg_name_i == '3m') then
          sg_name0 = '3'
       else
          sg_name0 = '-3'
       end if
       if(system == 'cubic') then
          ! C31+ or C32+ or C33+ or C34+
          do i=0,4
             if(fexist(5+i)) then
                j=0
                if(i>1) j=1
                ! C2b for C31+ and C32+, or C2a for C33+ and C34+
                call get_symbol_of_sym_plane(t(1,38-j),sp)
                exit
             end if
          end do      
          sg_name0 = trim(sg_name0) // sp
       else
          if(fexist(22)) then
          ! IC212
             call get_symbol_of_sym_plane(t(1,22),sp)
             sg_name0 = trim(sg_name0) // sp
          else if(l == 'P') then
             sg_name0 = trim(sg_name0) // '1'
          end if
          if(fexist(19)) then
          ! IC211
             call get_symbol_of_sym_plane(t(1,19),sp)
             sg_name0 = trim(sg_name0) // sp
          else if(l == 'P') then
             sg_name0 = trim(sg_name0) // '1'
          end if
       end if
       sg_name_i = l // trim(sg_name0)
    case('6')     ! Hexagonal
       call get_screw_sub(t(3,2),6,sub)
       sg_name_i = l // '6' // trim(sub)
    case('-6')    ! Hexagonal
       sg_name_i = l // pg_name_i
    case('6/m')   ! Hexagonal
       call get_screw_sub(t(3,2),6,sub)
       sg_name_i = l // '6' // trim(sub) // "/m"
    case('622')   ! Hexagonal
       call get_screw_sub(t(3,2),6,sub)
       sg_name_i = l // '6' // trim(sub) // "22"
    case('6mm','6/mmm')   ! Hexagonal
       call get_screw_sub(t(3,2),6,sub)
       sg_name0 = '6' // trim(sub)
       if(pg_name_i == '6/mmm') then
          sg_name0 = trim(sg_name0) // "/m"
       end if
       ! IC212
       call get_symbol_of_sym_plane(t(1,22),sp)
       sg_name0 = trim(sg_name0) // sp
       ! IC211
       call get_symbol_of_sym_plane(t(1,19),sp)
       sg_name0 = trim(sg_name0) // sp
       sg_name_i = l // trim(sg_name0)
    case('-6m2')  ! Hexagonal
       sg_name0 = '-6'
       if(fexist(10)) then
        ! C212
          sg_name0 = trim(sg_name0) // '2'
       else
        ! IC212
          call get_symbol_of_sym_plane(t(1,22),sp)
          sg_name0 = trim(sg_name0) // sp
       end if
       if(fexist(7)) then
         ! C211
          sg_name0 = trim(sg_name0) // '2'
       else
       ! IC211
          call get_symbol_of_sym_plane(t(1,19),sp)
          sg_name0 = trim(sg_name0) // sp
       end if
       sg_name_i = l // trim(sg_name0)
    case('23')    ! Cubic
       ! C2x
       call get_screw_sub(t(1,2),2,sub)
       if(sub=='') call get_screw_sub(t(2,2),2,sub)
       if(sub=='') call get_screw_sub(t(3,2),2,sub)
       sg_name0= '2' // trim(sub) // '3'
       sg_name_i = l // trim(sg_name0)
    case('m-3','m-3m')   ! Cubic
       ! IC2x
       call get_symbol_of_sym_plane(t(1,26),sp)
       sg_name0= sp // '-3'
       if(pg_name_i == 'm-3m') then
         ! IC2a
         call get_symbol_of_sym_plane(t(1,37),sp)
         sg_name0= trim(sg_name0) // sp
       end if
       sg_name_i = l // trim(sg_name0)
    case('432')   ! Cubic
       ! C4x+
       call get_screw_sub(t(1,19),4,sub)
       sg_name0= '4' // trim(sub) // '32'
       sg_name_i = l // trim(sg_name0)
    case('-43m')  ! Cubic
       sg_name0= '-43'
       ! IC2a
       if(sum(abs(t(1:3,37))) < eps) then
          sp = 'm'
       else if(l == 'P') then
          sp = 'n'
       else if(l == 'F') then
          sp = 'c'
       else if(l == 'I') then
          sp = 'd'
       end if
       sg_name0= trim(sg_name0) // sp
       sg_name_i = l // trim(sg_name0)
    case default
    end select

  contains
    subroutine get_trans_in_bravais_system(l,t)
      character(len=1), intent(in) :: l
      real(kind=DP), intent(inout) :: t(3,48)

      integer :: i,j
      real(kind=DP) :: p2b(3,3),tt(3)
      
      p2b = 0.d0
      if(l=='R' .or. l=='P') then
         ! Hexagonal or primitive
         do i=1,3
            p2b(i,i)=1.d0
         end do
      else if(l=='A') then
         ! A-face centered
         p2b(1,1) =  1.d0
         p2b(2,2) =  0.5d0
         p2b(3,3) =  0.5d0
         p2b(2,3) =  0.5d0
         p2b(3,2) = -0.5d0
      else if(l=='B') then
         ! B-face centered
         p2b(2,2) =  1.d0
         p2b(1,1) =  0.5d0
         p2b(3,3) =  0.5d0
         p2b(3,1) =  0.5d0
         p2b(1,3) = -0.5d0
      else if(l=='C') then
         ! C-face centered
         p2b(3,3) =  1.d0
         p2b(1,1) =  0.5d0
         p2b(2,2) =  0.5d0
         p2b(1,2) =  0.5d0
         p2b(2,1) = -0.5d0
      else if(l=='F') then
         ! All-face centered
         p2b(1:3,1:3) =  0.5d0
         do i=1,3
            p2b(i,i)=0.d0
         end do
      else if(l=='I') then
         ! Body centered
         p2b(1:3,1:3) =  0.5d0
         do i=1,3
            p2b(i,i)=-0.5d0
         end do
      end if

      do j=1,48
         do i=1,3
            tt(i) = sum(p2b(i,1:3)*t(1:3,j))
         end do
         t(1:3,j) = tt(1:3)
      end do
    end subroutine get_trans_in_bravais_system

    subroutine get_symbol_of_sym_plane(t,sp)
      real(kind=DP), intent(in) :: t(3)
      character(len=1), intent(out) :: sp

      real(kind=DP), parameter :: eps = 1.d-6
      integer :: i

      if(sum(abs(t(1:3))) < eps) then
         sp = 'm'
      else if(abs(t(1))>eps.and.abs(t(2))<eps.and.abs(t(3))<eps) then
         sp = 'a'
      else if(abs(t(1))<eps.and.abs(t(2))>eps.and.abs(t(3))<eps) then
         sp = 'b'
      else if(abs(t(1))<eps.and.abs(t(2))<eps.and.abs(t(3))>eps) then
         sp = 'c'
      else
         do i=1,3
            if(abs(t(i))>eps) then
               if(abs(abs(t(i))-0.5d0) < eps) then
                  sp = 'n'
               else ! if(abs(abs(t(i))-0.25d0) < eps) then
                  sp = 'd'
               end if
               exit
           end if
        end do
      end if

    end subroutine get_symbol_of_sym_plane

    subroutine get_screw_sub(t,nr,sub)
      real(kind=DP), intent(in) :: t
      integer, intent(in) :: nr
      character(len=2), intent(out) :: sub

      real(kind=DP), parameter :: eps = 1.d-6
      integer :: ns
      ns = int(t*dble(nr)+eps)
      sub = ''
      if(ns == 1) then
        sub = '_1'
      else if(ns == 2) then
        sub = '_2'
      else if(ns == 3) then
        sub = '_3'
      else if(ns == 4) then
        sub = '_4'
      else if(ns == 5) then
        sub = '_5'
      end if
    end subroutine get_screw_sub

  end subroutine get_space_group_name

  subroutine m_CS_SG_print_space_group_name(nfout)
    integer, intent(in) :: nfout

    character(len=3) :: pg_name
    character(len=5) :: pg_name_i
    character(len=2) :: bl_name
    character(len=10) :: sg_name_i
    character(len=9) :: system
    integer :: ipri_t

    if(il>0) then
       system = 'cubic'
    else
       system = 'hexagonal'
    end if
    if(printable) then
      ipri_t = 1
    else
      ipri_t = 0
    end if

    call get_point_group_name(nfout,system,nopr,ig01,pg_name,pg_name_i)
    call get_bravais_lattice(nfout,ipri_t,altv(1,1),altv(1,2),altv(1,3),system,ig01,pg_name_i,bl_name)
    !!$call get_space_group_name(nfout,system,nopr,ig01,tau(1,1,BUCS),.true.,bl_name,pg_name_i,sg_name_i)
!!$       call get_space_group_name(nfout,system,nsym,nopr,tau(1,1,BUCS),.false.,bl_name,pg_name_i,sg_name_i)
!!$    if(.not.allocated(tau)) then
!!$       write(nfout,'(" tau is not allocated")')
!!$    else
       call get_space_group_name(nfout,system,nopr,ig01,tau(1,1,BUCS),.false.,bl_name,pg_name_i,sg_name_i)
!!$    end if

    if(printable) then
       write(nfout,'(13x,"Bravais lattice: ",a,1x,a)') bl_name
       write(nfout,'("Crystallographic point group: ",a,1x,a)') pg_name,pg_name_i
       write(nfout,'(17x,"Space group: ",a)') sg_name_i
    end if
  end subroutine m_CS_SG_print_space_group_name

  subroutine get_kpoint_symmetry(nsym,nopr,rot,kvec,nsymo,nopro,nsymo2,nopro2)
    integer, intent(in) :: nsym
    integer, intent(in) :: nopr(nsym)
    real(kind=DP), intent(in) :: rot(3,3,nsym)
    real(kind=DP), intent(in) :: kvec(3)
    integer, intent(out) :: nsymo
    integer, intent(out) :: nopro(nsym)
    integer, intent(out) :: nsymo2
    integer, intent(out) :: nopro2(nsym)

    real(kind=DP) :: rkv(3),dk(3)
    integer :: i,j
    real(kind=DP) :: eps = 1.d-6
    
    nsymo = 0
    nsymo2 = 0
    do i=1,nsym
       do j=1,3
          rkv(j) = sum(rot(j,1:3,i)*kvec(1:3))
       end do
       do j=1,3
          dk(j) = sum(altv(1:3,j)*(rkv(1:3)-kvec(1:3)))/PAI2 
       end do
       if(sum(abs(dk(1:3))) < eps) then
          nsymo2 = nsymo2 + 1
! ================================= ASMS DEBUG ================= 2013/10/03
!          nopro2(nsymo2) = nopr(i)
          nopro2(nsymo2) = i
! ================================= ASMS DEBUG ================= 2013/10/03
       end if
       call mod1(dk)
       if(sum(abs(dk(1:3))) < eps) then
          nsymo = nsymo + 1
          nopro(nsymo) = nopr(i) 
       end if
    end do

  end subroutine get_kpoint_symmetry

  subroutine vectors_length_angle(a1,a2,a3,length,angle)
    implicit none

    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    real(kind=DP), intent(out) :: length(3),angle(3)

    length(1) = sqrt(sum(a1(1:3)**2))
    length(2) = sqrt(sum(a2(1:3)**2))
    length(3) = sqrt(sum(a3(1:3)**2))

    angle(1) = acos(sum(a2(1:3)*a3(1:3))/(length(2)*length(3)))
    angle(2) = acos(sum(a3(1:3)*a1(1:3))/(length(3)*length(1)))
    angle(3) = acos(sum(a1(1:3)*a2(1:3))/(length(1)*length(2)))

  end subroutine vectors_length_angle

  function rational(a) result(b)
    real(kind=DP), intent(in) :: a
    real(kind=DP) :: b

    integer :: i,r
    real(kind=DP) :: eps = 1.d-4
    do i=1,20
       r = nint(a*i)
       b = dble(r)/dble(i)
       if(abs(a-b) < eps) exit
    end do
  end function rational

! ================================== Added by K. Tagami =========
  subroutine ktrational( a,b,ifound )
    real(kind=DP), intent(in) :: a
    real(kind=DP), intent(out) ::b
    integer, intent(inout) :: ifound

    integer :: i,r
    real(kind=DP) :: eps = 1.d-4
    ifound  = -1
    do i=1,20
       r = nint(a*i)
       b = dble(r)/dble(i)
       if(abs(a-b) < eps) then
          ifound = 0
          exit
       endif
    end do

  end subroutine ktrational
! ==================================================================

  subroutine m_CS_gen_opr_rspace_full( system, nsym, rot )
    character(len=9), intent(in) :: system
    integer, intent(in) :: nsym
    real(kind=DP), intent(out) :: rot(3,3,nsym)

    rot = 0.0d0
    if(system .eq. 'cubic') then
       call cubic_point_group
    else if(system .eq. 'hexagonal') then
       call hexagonal_point_group
    end if

  contains

    subroutine cubic_point_group
      ! local variables
      real(kind=DP) :: one=1.d0, zero=0.d0
      integer :: i,j

      ! C31+ = O5
      rot(1,3,5) = one;      rot(2,1,5) = one;      rot(3,2,5) = one

      ! C4x+ = O19
      rot(1,1,19) =  one;    rot(2,3,19) = -one;    rot(3,2,19) =  one

      do i=1,3
         rot(i,i,1) = one  ! E = O1
      end do
      do j=1,3
         do i=1,3
            rot(i,j,22) = rot(j,i,19)  ! C4x- = O22 = O19^t
            rot(i,j,9)  = rot(j,i,5)  ! C31- = O9 = O5^t
         end do
      end do

      call matrix_product(rot(1,1,19),rot(1,1,19),rot(1,1,2)) ! C2x = O2 = O19*O19
      call matrix_product(rot(1,1,5),rot(1,1,19),rot(1,1,13)) ! C2a = O13 = O5*O19
      call matrix_product(rot(1,1,19),rot(1,1,5),rot(1,1,15)) ! C2c = O15 = O19*O5

      call matrix_product(rot(1,1,2),rot(1,1,9),rot(1,1,10))  ! C32- = O10 = O2*O9
      call matrix_product(rot(1,1,13),rot(1,1,15),rot(1,1,11))! C33- = O11 = O13*O15
      call matrix_product(rot(1,1,9),rot(1,1,2),rot(1,1,12))  ! C34- = O12 = O9*O2
      call matrix_product(rot(1,1,2),rot(1,1,5),rot(1,1,8))   ! C34+ = O8 = O2*O5
      call matrix_product(rot(1,1,5),rot(1,1,2),rot(1,1,6))   ! C32+ = O6 = O5*O2
      call matrix_product(rot(1,1,15),rot(1,1,13),rot(1,1,7)) ! C31+ = O7 = O15*O13
      call matrix_product(rot(1,1,13),rot(1,1,2),rot(1,1,21)) ! C4z+ = O21 = O13*O2
      call matrix_product(rot(1,1,2),rot(1,1,13),rot(1,1,24)) ! C4z- = O24 = O2*O13
      call matrix_product(rot(1,1,15),rot(1,1,2),rot(1,1,23)) ! C4y- = O23 = O15*O2
      call matrix_product(rot(1,1,2),rot(1,1,15),rot(1,1,20)) ! C4y+ = O20 = O2*O15

      call matrix_product(rot(1,1,9),rot(1,1,7),rot(1,1,3))  ! C2y = O3 = O9*O7
      call matrix_product(rot(1,1,9),rot(1,1,8),rot(1,1,4))  ! C2z = O4 = O9*O8
      call matrix_product(rot(1,1,15),rot(1,1,6),rot(1,1,14)) ! C2b = O14 = O15*O6
      call matrix_product(rot(1,1,13),rot(1,1,7),rot(1,1,18)) ! C2f = O18 = O13*O7
      call matrix_product(rot(1,1,13),rot(1,1,8),rot(1,1,16)) ! C2d = O16 = O13*O8
      call matrix_product(rot(1,1,7),rot(1,1,24),rot(1,1,17)) ! C2e = O17 = O7*O24

      do i=1,24
         rot(1:3,1:3,i+24) = -rot(1:3,1:3,i) ! add inversion
      end do
    end subroutine cubic_point_group

    subroutine hexagonal_point_group
      ! local variables
      real(kind=DP) :: one=1.d0, zero=0.d0, half=0.5d0, r32
      integer :: i,j

      r32=sqrt(3.d0)*0.5d0

      ! C6+ = O2
      rot(1,1,2) =  half;      rot(1,2,2) = -r32;      rot(2,1,2) =  r32
      rot(2,2,2) =  half;      rot(3,3,2) =  one

      ! C222 = O11
      rot(1,1,11) = -half;      rot(1,2,11) = -r32;      rot(2,1,11) = -r32
      rot(2,2,11) =  half;      rot(3,3,11) = -one

      do i=1,3
         rot(i,i,1) = one  ! E = O1
      end do
      do j=1,3
         do i=1,3
            rot(i,j,6) = rot(j,i,2)  ! C6- = O6 = O2^t
         end do
      end do
      call matrix_product(rot(1,1,2),rot(1,1,2),rot(1,1,3))   ! C3+ = O3 = O2*O2
      call matrix_product(rot(1,1,2),rot(1,1,11),rot(1,1,9))  ! C231 = O9 = O2*O11
      call matrix_product(rot(1,1,11),rot(1,1,2),rot(1,1,7))  ! C211 = O7 = O11*O2

      do j=1,3
         do i=1,3
            rot(i,j,5) = rot(j,i,3)  ! C3- = O5 = O3^t
         end do
      end do
      call matrix_product(rot(1,1,2),rot(1,1,3),rot(1,1,4))  ! C2 = O4 = O2*O3
      call matrix_product(rot(1,1,2),rot(1,1,9),rot(1,1,10)) ! C212 = O10 = O2*O9
      call matrix_product(rot(1,1,7),rot(1,1,3),rot(1,1,8))  ! C221 = O8 = O7*O3
      call matrix_product(rot(1,1,7),rot(1,1,2),rot(1,1,12)) ! C232 = O12 = O7*O2

      do i=1,12
         rot(1:3,1:3,i+12) = -rot(1:3,1:3,i) ! add inversion
      end do

    end subroutine hexagonal_point_group

    subroutine matrix_product(a,b,c)
      real(kind=DP), intent(in) :: a(3,3),b(3,3)
      real(kind=DP), intent(out) :: c(3,3)

      integer :: i,j
      do j=1,3
         do i=1,3
            c(i,j) = sum(a(i,1:3)*b(1:3,j))
         end do
      end do
    end subroutine matrix_product

  end subroutine m_CS_gen_opr_rspace_full

  subroutine m_CS_remove_frac_translation
    use m_Crystal_Structure,  only :  tau, op, ig01

    integer :: iopr, count
    real(kind=DP) :: c1
    integer, allocatable :: ig01_wk(:)
    real(kind=DP), allocatable :: op_wk(:,:,:), tau_wk(:,:,:)

    real(kind=DP), parameter :: eps = 1.0E-4

    allocate( op_wk(3,3,nopr) );   op_wk = 0.0d0
    allocate( tau_wk(3,nopr,2) ); tau_wk = 0.0d0
    allocate( ig01_wk(nopr) );   ig01_wk = 0
!
    count = 0
    Do iopr=1, nopr
       c1 = abs( tau(1,iopr,BUCS) ) + abs( tau(2,iopr,BUCS) ) &
            &                       + abs( tau(3,iopr,BUCS) )
       if ( c1 < eps ) then
          count = count + 1
          op_wk(:,:,count) = op(:,:,iopr)
          tau_wk(:,count,:)  = tau(:,iopr,:)
          ig01_wk(count)    = ig01(iopr)
       endif
    End do
    deallocate( op );   deallocate( tau )

! ---------------------------------------------
    nopr = count
    allocate( op(3,3,nopr) );   op = 0.0d0
    allocate( tau(3,nopr,2) );  tau = 0.0d0
    ig01 = 0

    op(:,:,1:nopr) =  op_wk(:,:,1:nopr)
    tau(:,1:nopr,:) = tau_wk(:,1:nopr,:)
    ig01(1:nopr)    = ig01_wk(1:nopr)
!
    deallocate( op_wk );    deallocate( tau_wk );   deallocate( ig01_wk )

  end subroutine m_CS_remove_frac_translation

  subroutine m_CS_SG_wd_cntn(nfcntn)
    integer, intent(in) :: nfcntn
    integer :: i
    if(.not.allocated(mtprim)) return
    if(mype==0) then
      write(nfcntn, '(a)') tag_symmetry_info
      write(nfcntn,'(2i8)') mnprim,mnsym
      do i=1,mnprim
         write(nfcntn,'(3f20.15)') mtprim(1:3,i)
      enddo
      do i=1,mnsym
         write(nfcntn,'(3f20.15,l2)') mtau(1:3,i),mfsym(i)
      enddo
      if (af/=0) then
        write(nfcntn, '(a)') tag_symmetry_info_af
        write(nfcntn,'(2i8)') mnprim_af,mnsym_af
        do i=1,mnprim_af
           write(nfcntn,'(3f20.15)') mtprim_af(1:3,i)
        enddo
        do i=1,mnsym_af
           write(nfcntn,'(3f20.15,l2)') mtau_af(1:3,i),mfsym_af(i)
        enddo
      endif
    endif
  end subroutine m_CS_SG_wd_cntn

end module m_CS_SpaceGroup

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 599 $)
!
!  SUBROUINE:  Move_Ions, wd_cps_and_forces
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki   January/13/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Move_Ions
! $Id: Move_Ions.F90 599 2019-12-03 05:25:28Z ktagami $
  use m_Control_Parameters, only : iprimd, c_iteration2GDIIS &
       &                         , m_CtrlP_what_is_mdalg &
       &                         , m_CtrlP_set_gdiisoptmode &
       &                         , sw_charge_predictor,sw_wf_predictor,sw_rspace,af &
       &                         , sw_fcp, sw_betar_dot_wfs_exp, sw_precalculate_phase_vnonlocal &
       &                         , sw_optimize_coords_sametime
  use m_Const_Parameters, only   : DP, TEMPERATURE_CONTROL, VERLET &
       &, BLUEMOON, QUENCHED_CONSTRAINT, QUENCHED_MD, NORMAL_MODE_ANALYSIS &
       &, HYPERPLANE_ADAPTIVE_COORDINATE, HAC, T_CONTROL, GDIIS, ORDINA &
       &, PHONON_FORCE, CG_STROPT, STEEPEST_DESCENT, BFGS, ON, CG_STROPT2 &
       &, PT_CONTROL, P_CONTROL, L_BFGS, FIRE
  use m_Files,        only : nfenf, nfdynm,nfout
  use m_Total_Energy, only : etotal
  use m_Ionic_System, only : natm,ekina,ega,m_IS_wd_cpo_and_forc &
       &                   , m_IS_md_thermo, m_IS_md_bluem, m_IS_md_cnstr &
       &                   , m_IS_gdiis, m_IS_wd_forc, m_IS_md, m_IS_cps_to_pos &
       &                   , m_IS_cp_cps2cpo,m_IS_wd_pos_and_v &
       &                   , m_IS_phonon_force, m_IS_cg, m_IS_cg2 &
       &                   , m_IS_evaluate_v_verlet &
       &                   , m_IS_update_cps_history &
       &                   , m_IS_force_af_symmetry &
       &                   , m_IS_fire
!!$       &                   , forcmx_constraint_quench, almda, mdmode &
  use m_Force,        only : forc_l, forcmx
  use m_IterationNumbers, only : iteration_ionic,iteration
  use m_Parallelization,    only : mype
#ifdef __TIMER__
  use m_Parallelization,    only : mpi_comm_group
#endif

  use m_Realspace,          only : m_RS_resolve_mesh_soft
  use m_NonLocal_Potential, only : m_NLP_build_snl_in_rspace
  use m_PseudoPotential,    only : m_PP_alloc_radr,m_PP_dealloc_radr

! ================================ KT_add =================== 13.0B
  use m_Ionic_System,       only : m_IS_symmetrize_atom_pos
  use m_Control_Parameters,  only : sw_keep_symmetry_strict
! =========================================================== 13.0B

! === KT_add === 2014/06/10
  use m_Ionic_System,  only : sw_change_temperature_by_step, m_IS_reassgin_thermog
! ============== 2014/06/10

  use m_Fcp, only : m_Fcp_md_thermo, m_Fcp_cg, m_Fcp_cg2, m_Fcp_md, m_Fcp_gdiis &
  &               , m_Fcp_print_status

  use m_UnitCell, only : m_UnitCell_md
  use m_Control_Parameters, only :  sw_hybrid_functional, sw_rspace_hyb
  use m_RealSpace,    only : m_RS_resolve_mesh_hard, m_RS_build_qr_clm_ylm
  use m_FFT, only : fft_box_size_CD_exx,fft_box_size_CD_exx_nonpara

  use m_Ionic_System, only : m_IS_rigid_body_exists, m_IS_rb_dynamics

  use m_NonLocal_Potential, only : m_NLP_cal_i_l_exp_snl
  use m_ES_nonlocal,        only : m_ES_AtaulmnaG

  implicit none

  integer :: mdalg
  integer, save ::                optmode = QUENCHED_MD
  real(kind=DP),parameter :: c_forc2GDIIS = 0.0050d0
  integer, save ::                 iter_f = 0

#ifdef __TIMER__
  integer :: ierr
  call mpi_barrier(mpi_comm_group, ierr)
  call timer_sta(20)
#endif

  if(sw_charge_predictor==ON.or.sw_wf_predictor==ON) call m_IS_update_cps_history()

  mdalg = m_CtrlP_what_is_mdalg()

  if(mdalg == VERLET) call m_IS_evaluate_v_verlet(mdalg,forc_l)
  if(m_IS_rigid_body_exists() .and. (mdalg==VERLET.or.mdalg==QUENCHED_MD)) call m_IS_rb_dynamics(forc_l,mdalg)
  call wd_forces_cps_etotal_and_etc(mdalg,.true.) ! nfdynm  ! (Convergence_Check)
  if(mdalg /= T_CONTROL .and. mdalg /= BLUEMOON) then
     call wd_forces_cps_etotal_and_etc(mdalg,.false.) ! nfefn  ! (Convergence_Check)
  end if

  if ( sw_optimize_coords_sametime == ON ) return

! === KT_add === 2014/06/10
  if ( sw_change_temperature_by_step == ON ) then
     call m_IS_reassgin_thermog
  endif
! ============== 2014/06/10

  call m_IS_cp_cps2cpo()                 ! -> cpo_l
  mdalgorithm: select case(mdalg)
     case (GDIIS,BFGS,L_BFGS)
        optmode = m_CtrlP_set_gdiisoptmode(iteration_ionic,forcmx)
        if(optmode == QUENCHED_MD .or. optmode == STEEPEST_DESCENT) then
           call m_IS_md(optmode,forc_l)
           if(sw_fcp == ON ) call m_Fcp_md(optmode)
        else if(optmode == CG_STROPT) then
           call m_IS_cg(forc_l,etotal)
           if(sw_fcp == ON ) call m_Fcp_cg()
        else if(optmode == CG_STROPT2) then
           call m_IS_cg2(forc_l,etotal)
           if(sw_fcp == ON ) call m_Fcp_cg2()
        else
           call m_IS_gdiis(forc_l,forcmx,etotal)
           if(sw_fcp == ON ) call m_Fcp_gdiis()
!!$           if(mdmode == CNSTRA) call m_CtrlP_reset_optmode()
!!$     else if(mdalg == HAC) then
!!$        call me_nebm2(nfout,forc_l)
        end if
     case (CG_STROPT)
        call m_IS_cg(forc_l,etotal)
        if(sw_fcp == ON ) call m_Fcp_cg()
     case (CG_STROPT2)
        call m_IS_cg2(forc_l,etotal)
        if(sw_fcp == ON ) call m_Fcp_cg2()
     case (VERLET, QUENCHED_MD,STEEPEST_DESCENT)
        call m_IS_md(mdalg,forc_l) 
        if(sw_fcp == ON ) call m_Fcp_md(mdalg)
     case (FIRE)
        call m_IS_fire(forc_l)
     case (T_CONTROL)
        call m_IS_md_thermo(forc_l)
        if(sw_fcp == ON ) call m_Fcp_md_thermo()
     case (BLUEMOON)
        call m_IS_md_bluem(forc_l)
     case (QUENCHED_CONSTRAINT)
        call m_IS_md_cnstr(forc_l)
     case (PHONON_FORCE)
        call m_IS_wd_forc(forc_l)
        call m_IS_phonon_force()
     case (PT_CONTROL,P_CONTROL)
        continue
     case default
        stop ' mdalg error at (Move_Ions)'
  end select mdalgorithm

  if(sw_fcp == ON) call m_Fcp_print_status()

  if(mdalg == T_CONTROL .or. mdalg == BLUEMOON) then
     call wd_forces_cps_etotal_and_etc(mdalg,.false.) ! nfefn  ! (Convergence_Check)
  end if

!!$  call wd_etotal_etc                           ! -(contained here)
!!$  call wd_cps_and_forces()                        ! -(contained here)
  call m_IS_cps_to_pos()
  
! ================================== KT_add  =================== 13.0B
  if ( sw_keep_symmetry_strict == ON ) then
     call m_IS_symmetrize_atom_pos(nfout)        ! -> cps,pos
  endif
! ============================================================== 13.0B

  if (af/=0) call m_IS_force_af_symmetry(nfout)

  if(iprimd >= 2) call m_IS_wd_forc(forc_l)

  if(sw_rspace==ON)then
     call m_PP_alloc_radr()
     call m_RS_resolve_mesh_soft(nfout)
     call m_NLP_build_snl_in_rspace(nfout)
     call m_PP_dealloc_radr()
  endif
  if (sw_hybrid_functional==ON .and. sw_rspace_hyb==ON ) then
     call m_PP_alloc_radr()
     call m_RS_resolve_mesh_hard(nfout,fft_box_size_CD_exx,fft_box_size_CD_exx_nonpara)
     call m_RS_build_qr_clm_ylm(deriv=.true.,box_size=fft_box_size_CD_exx)
     call m_PP_dealloc_radr()
  endif
  if(sw_betar_dot_wfs_exp==ON) then
    call m_NLP_cal_i_l_exp_snl()
  endif
  if(sw_precalculate_phase_vnonlocal==ON) then
    call m_ES_AtaulmnaG(hardpart=.true.)
  endif

#ifdef __TIMER__
  call timer_end(20)
#endif
contains
!!$  subroutine wd_cps_and_forces()
!!$
!!$    if(flag_wd_nfdynm == 0) then
!!$       call m_IS_wd_speciesname_etc(nfdynm)
!!$       flag_wd_nfdynm = 1
!!$    end if
!!$    if(mype == 0) then
!!$       if(mdmode == CNSTRA) then
!!$          write(nfdynm,'(" cps and forc at (iter_ion, iter_total = " &
!!$               & ,i5,i8," ) converged_in_a_plane")') iteration_ionic, iteration
!!$       else
!!$          write(nfdynm,'(" cps and forc at (iter_ion, iter_total = " &
!!$               & ,i5,i8," )")') iteration_ionic, iteration
!!$       end if
!!$    end if
!!$
!!$    call m_IS_wd_cpo_and_forc(nfdynm,forc_l)
!!$
!!$  end subroutine wd_cps_and_forces

  integer function set_optmode()
    set_optmode = optmode
    if(optmode == QUENCHED_MD .and. forcmx <= c_forc2GDIIS) then
       if(iter_f >= 3) then
          set_optmode = GDIIS
       else
          set_optmode = QUENCHED_MD
       end if
    end if
    iter_f = iter_f + 1
  end function set_optmode

end subroutine Move_Ions

subroutine phase0_initialize(comm_world, tag, ne, nk, ng, stdout)
  use m_Const_Parameters, only : ON
  implicit none
  integer, intent(in) :: comm_world 
  integer, intent(in) :: tag
  integer, intent(in) :: ne, nk, ng
  integer, intent(in) :: stdout
  logical :: initialization_required
  call Initialization_lib(comm_world,tag,ne,nk,ng,stdout)
  call InputData_Analysis()
  call phase0_initialize_ppetc()
end subroutine phase0_initialize

subroutine phase0_initialize_ppetc()
  call Preparation(0)
  if(initialization_required())then
    call Preparation_for_mpi(1)
  endif
  call PseudoPotential_Construction
#ifdef ENABLE_ESM_PACK
  if(initialization_required())then
     call Preparation_for_ESM
  endif
#endif
  call Ewald_and_Structure_Factor
  call Initial_Electronic_Structure

!  call Initial_MD_Condition()
end subroutine phase0_initialize_ppetc

subroutine phase0_set_coordinate_xyz(coord_x, coord_y, coord_z)
  use m_Const_Parameters,   only : DP
  use m_Ionic_System,       only : natm, cps, m_IS_cps_to_pos
  real(kind=DP), intent(in),  dimension(natm) :: coord_x, coord_y, coord_z
  cps(1:natm,1) = coord_x(1:natm)
  cps(1:natm,2) = coord_y(1:natm)
  cps(1:natm,3) = coord_z(1:natm)
  call m_IS_cps_to_pos()
end subroutine phase0_set_coordinate_xyz

subroutine phase0_set_coordinate(cpsin)
  use m_Const_Parameters,   only : DP
  use m_Ionic_System,       only : m_IS_cps_to_pos, cps, pos
  use m_Ionic_System,       only : natm
  implicit none
  real(kind=DP), intent(in),  dimension(natm,3) :: cpsin
  cps  = cpsin
  call m_IS_cps_to_pos()
end subroutine phase0_set_coordinate

subroutine phase0_set_unitcell(altvin)
  use m_Const_Parameters,   only : DP, ON, DRIVER_SC_DFT
  use m_Crystal_Structure,  only : m_CS_altv_2_rltv,p2bmat,a,b,c,ca,cb,cc,il,kt_iuctype,rltv &
  &                              , altv, univol,rvol, b2pmat
  use m_Control_Parameters, only : sw_optimize_lattice, driver
  use m_IterationNumbers,   only : iteration_unit_cell, iteration_scdft
  use m_Ionic_System,       only : natm, cps, pos
  use m_Files,              only : nfout,m_Files_set_default_filenames, m_Files_rd_file_names_data
  implicit none
  real(kind=DP), intent(in),  dimension(3,3)    :: altvin
  altv = altvin
  driver = DRIVER_SC_DFT
  iteration_scdft = 2
  call altv_2_rltv(altv,rltv,univol,rvol)  ! in b_CS
  call change_of_coordinate_system(altv,pos,natm,natm,cps) !-(b_I.S.) pos -> cps
  call primitive2bravais(nfout,p2bmat,altv(:,1),altv(:,2),altv(:,3),a,b,c,ca,cb,cc,il) ! in b_CS
  call Array_Deallocate()
  call Continuation_Mode()
  call phase0_initialize_ppetc()
end subroutine phase0_set_unitcell

logical function phase0_stress_enabled()
  use m_Const_Parameters,   only : ON
  use m_Control_Parameters, only : istress
  implicit none
  phase0_stress_enabled = istress == ON
end function phase0_stress_enabled

subroutine phase0_scf(energy, force_x, force_y, force_z, stress_tensor)
  use m_Control_Parameters, only : istress
  use m_Const_Parameters,   only : DP, ON
  use m_Ionic_System,       only : natm,cps
  use m_Force,              only : forc_l
  use m_Stress,             only : m_Stress_get_curr_stress
  use m_Total_Energy,       only : etotal
  implicit none
  real(kind=DP), intent(out)                  :: energy
  real(kind=DP), intent(out), dimension(natm) :: force_x, force_y, force_z
  real(kind=DP), intent(out), dimension(3,3)  :: stress_tensor

  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Hubbard_model
  logical  :: Ending_Time
  stress_tensor=0.d0
  call Ewald_and_Structure_Factor
  ChargeDensity:    do
    call IterationNumber_Setting()
    call Renewal_of_WaveFunctions()
    call ChargeDensity_Construction(1)
    call Potential_Construction()
    call ChargeDensity_Mixing
    if(Ending_Time()) then
      return
    endif
    if(TotalEnergy_is_Divergent()) then
      return
    endif
    call Renewal_of_Potential()
    if(Hubbard_model()) then
      call Renewal_of_Hubbard_Potential()
    end if
    if(ChargeDensity_is_Converged())  then
#ifdef LIBRARY_BUILD
      call Forces_phase0()
#else
      call Forces()
#endif
      call MDIterationNumber_Setting()
      energy = etotal
      force_x(1:natm)  = forc_l(1:natm,1)
      force_y(1:natm)  = forc_l(1:natm,2)
      force_z(1:natm)  = forc_l(1:natm,3)
      if(istress==ON) then
        call Stress()
        stress_tensor = m_Stress_get_curr_stress()
      endif
      exit ChargeDensity
    endif
  enddo ChargeDensity
  call MDIterationNumber_Setting2()
  call WriteDownData_onto_Files(.false.)
end subroutine phase0_scf

subroutine phase0_energy_force_stress(energy, force, stress_tensor)
  use m_Control_Parameters, only : istress
  use m_Const_Parameters,   only : DP, ON
  use m_Ionic_System,       only : natm,cps
  use m_Force,              only : forc_l
  use m_Stress,             only : m_Stress_get_curr_stress
  use m_Total_Energy,       only : etotal
  implicit none
  real(kind=DP), intent(out)                    :: energy
  real(kind=DP), intent(out), dimension(natm,3) :: force
  real(kind=DP), intent(out), dimension(3,3)    :: stress_tensor

  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Hubbard_model
  logical  :: Ending_Time
  energy = 0.d0; force = 0.d0; stress_tensor=0.d0
  call Ewald_and_Structure_Factor
  ChargeDensity:    do
    call IterationNumber_Setting()
    call Renewal_of_WaveFunctions()
    call ChargeDensity_Construction(1)
    call Potential_Construction()
    call ChargeDensity_Mixing
    if(Ending_Time()) then
      return
    endif
    if(TotalEnergy_is_Divergent()) then
      return
    endif
    call Renewal_of_Potential()
    if(Hubbard_model()) then
      call Renewal_of_Hubbard_Potential()
    end if
    if(ChargeDensity_is_Converged())  then
#ifdef LIBRARY_BUILD
      call Forces_phase0()
#else
      call Forces()
#endif
      call post_force()
      call MDIterationNumber_Setting()
      energy = etotal
      force  = forc_l
      if(istress==ON) then
        call Stress()
        stress_tensor = m_Stress_get_curr_stress()
      endif
      exit ChargeDensity
    endif
  enddo ChargeDensity
  call MDIterationNumber_Setting2()
  call WriteDownData_onto_Files(.false.)
end subroutine phase0_energy_force_stress

subroutine phase0_finalize()
  use m_Files, only : m_Files_close_all, m_Files_close_logfile
  use m_Control_Parameters, only : m_CtrlP_wd_cpu_total
  implicit none
  call m_CtrlP_wd_cpu_total()
  call m_Files_close_all()                    ! -(m_Files)
  call PrintStatus()
  call m_Files_close_logfile()
end subroutine phase0_finalize

  subroutine Array_Deallocate()
     use m_Const_Parameters, only : OFF, ON, DRIVER_URAMP, DRIVER_SC_DFT, DRIVER_NEB
     use m_Control_Parameters, only : m_CtrlP_dealloc,sw_rebuild_pws,m_CtrlP_set_init_status, driver
     use m_Crystal_Structure, only : m_CS_dealloc
     use m_Ionic_System, only : m_IS_dealloc
     use m_PlaneWaveBasisSet, only : m_pwBS_dealloc
     use m_Parallelization, only : m_Parallel_dealloc,m_Parallel_dealloc_mpi_nlmta,m_Parallel_dealloc_mpi_exx &
                        &        , m_Parallel_cp_g1k
     use m_Kpoints, only : m_Kp_dealloc, kv3
     use m_Force, only : m_Force_dealloc
     use m_Charge_Density, only : m_CD_dealloc
     use m_XC_Potential, only : m_XC_dealloc_vxc
     use m_PseudoPotential, only : m_PP_dealloc, flg_paw
     use m_NonLocal_Potential, only : m_NLP_dealloc
     use m_Electronic_Structure, only : m_ES_dealloc
     use m_ES_WF_by_SDorCG, only : m_ESsd_dealloc
     use m_PAW_ChargeDensity, only : m_PAW_dealloc
     use m_PAW_XC_Potential, only : m_PAW_XC_dealloc_vxc
     use m_ES_wf_extrpl, only : m_ES_wf_extrpl_dealloc

! ===== KT_add ============== 13.0AS
     use m_Control_Parameters,  only : num_projectors, sw_hubbard
     use m_Orbital_Population,only: m_OP_dealloc
     use m_Electronic_Structure,  only : m_ES_dealloc_Dhub
! ============================13.0AS

! ======== KT_add ============= 2013/10/31
     use m_Control_Parameters, only: noncol, SpinOrbit_Mode
     use m_Const_Parameters,   only: Neglected, BuiltIn, ByPawPot, ZeffApprox, &
          &                          ByProjector, ReadFromPP
     use m_SpinOrbit_Potential,only: m_SO_dealloc_Dsoc, m_SO_dealloc_Mat_SOC_Strenth
! ============================= 2013/10/31

! ========= KT_add ========= 13.0U2
  use m_Control_Parameters,   only : sw_modified_TFW_functional
  use m_ThomasFermiW_Potential,  only : m_TFW_dealloc_ChgDensityBasisFn
! ========================== 13.0U2

! ====== KT_add === 2014/08/01
  use m_Orbital_QuantumNum, only : m_OP_Qnum_dealloc_array
! ================= 2014/08/01

  use m_Ldos, only : m_Ldos_dealloc

#ifdef FFTW3
  use m_FFT, only : m_FFT_finalize
#endif

     implicit none

     if (sw_rebuild_pws==OFF .or. driver == DRIVER_URAMP .or. driver == DRIVER_SC_DFT ) then
        call m_PP_dealloc()
        call m_NLP_dealloc()
        call m_Parallel_dealloc_mpi_nlmta()
        call m_Parallel_dealloc_mpi_exx()
        call m_Kp_dealloc
!        call m_ES_dealloc
!        call m_ESsd_dealloc
        return
     endif

     call m_CtrlP_dealloc
     call m_ES_dealloc
     call m_Parallel_cp_g1k(kv3)
     call m_Parallel_dealloc
     call m_CS_dealloc
     call m_IS_dealloc
  !call m_Parallel_dealloc_mpi_elec
     call m_Kp_dealloc
     call m_PP_dealloc
     call m_CD_dealloc
     call m_Force_dealloc
     call m_NLP_dealloc
     call m_ESsd_dealloc
     call m_XC_dealloc_vxc
     call m_pwBS_dealloc
     call m_PAW_dealloc
     if(flg_paw) then
         call m_PAW_XC_dealloc_vxc
     endif

! ==== KT_add ============== 2013/10/31
     if ( noncol ) then
        if ( SpinOrbit_Mode == ByPawPot .or. SpinOrbit_Mode == ZeffApprox &
             &                          .or. SpinOrbit_Mode == ReadFromPP ) then
           call m_SO_dealloc_Mat_SOC_strenth
           call m_SO_dealloc_Dsoc
        endif
        if ( SpinOrbit_Mode == ByProjector ) then
           call m_SO_dealloc_Dsoc
        endif
     endif
! ====================== 2013/10/31

! ====== KT_add ======== 13.0U2
     if ( sw_modified_TFW_functional /= OFF ) then
        call m_TFW_dealloc_ChgDensityBasisFn
     end if
! ====================== 13.0U2

! ====== KT_add =========== 13.0AS
     if (num_projectors>0)  call m_OP_dealloc
     if (sw_hubbard == ON) call m_ES_dealloc_Dhub
! ========================= 13.0AS

! ==== KT_add ==== 2014/08/01
     call m_OP_Qnum_dealloc_array
! ================ 2014/08/01

     call m_ES_wf_extrpl_dealloc()
     call m_Ldos_dealloc()
     call m_ES_wf_extrpl_dealloc()
#ifdef FFTW3
     call m_FFT_finalize()
#endif
     call m_CtrlP_set_init_status(.true.)
   end subroutine Array_Deallocate

  subroutine Continuation_Mode()
    use m_Const_Parameters,   only : COORDINATE_CONTINUATION,ON,OFF
    use m_Control_Parameters, only : icond, sw_optimize_lattice,sw_rebuild_pws
    implicit none
    logical :: unitcell_can_change
!    if(unitcell_can_change() .and. sw_rebuild_pws==OFF) return
    icond = COORDINATE_CONTINUATION
  end subroutine continuation_mode

#define WAN90_SAVE_MEMORY
#define WAN90_SKIP_FFT
#define WAN90_SPN_FORMATTED
!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 ($Rev: 110 $)
!
!  MODULE: m_Wannier90
!
!  AUTHOR(S): T. Yamamoto   May/05/2008
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Wannier90
  use m_Const_Parameters,   only : DP,PAI2,PAI4,SKIP,EXECUT,GAMMA,BUCS,CRDTYP, CMPLDP, Hartree
  use m_Control_Parameters, only : printable, kimg, nspin, neg, ipri &
    &                            , wan90_seedname, nb_wan90, LEN_TITLE
  use m_Files,              only : nfwannier 
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Kpoints,            only : kv3,vkxyz,k_symmetry
  use m_PlaneWaveBasisSet,  only : ngabc,kg1,kgp,nbase,iba,nbase_gamma
  use m_Electronic_Structure,only: neordr,zaj_l,eko_l,m_ES_WF_in_Rspace
  use m_FFT,                only : fft_box_size_WF, nfft, m_FFT_alloc_WF_work &
       &                         , m_FFT_dealloc_WF_work
  use m_Crystal_Structure,  only : univol,rltv
  use m_Parallelization,    only : mpi_comm_group,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , ista_snl, iend_snl, ierr, map_ek, nrank_k
! === KT_add === 2015/02/23, 09/02
  use m_Const_Parameters,   only : Delta07, zi, ON, UP, DOWN, BOHR
  use m_Control_Parameters,  only : ndim_spinor, sw_use_hardpart_wan90, noncol, &
       &                            spin_component_wan90
  use m_Ionic_System,  only : natm, ityp, cps, pos
  use m_PseudoPotential,   only : dk_wan, nloc, nlmta, m_PP_include_vanderbilt_pot, &
       &                          ltp, mtp, taup, ilmt, lmta, il2p, isph, iqitg, dl2p, &
       &                          qitg_wan, nqitg, phirpw, psirpw, q
  use m_Electronic_Structure,only: fsr_l, fsi_l
! ============== 2015/02/23, 09/02

! === KT_add === 2015/09/14
  use m_Const_Parameters,  only : ELECTRON, DIRECT, INVERSE
  use m_Electronic_Structure,  only : m_ES_map_wf_on_fftmesh
  use m_FFT,  only : m_FFT_WF
  use m_PlaneWaveBasisSet,  only : kg1, kg
! ============== 2015/09/14

  implicit none

  character(len=LEN_TITLE) :: comment
  logical :: calc_only_A
  real(kind=DP) :: real_lattice(3,3), recip_lattice(3,3)
  integer :: num_kp, n_proj, n_exclude, nntot, num_bands
  integer, parameter :: lmax1_pj = 3

  real(kind=DP), allocatable :: kvec(:,:) ! d(3,num_kp)
  real(kind=DP), allocatable :: centre(:,:), zaxis(:,:), xaxis(:,:) ! d(3,n_proj)
  real(kind=DP), allocatable :: zona(:) ! d(n_proj)
  integer, allocatable :: lang(:), mr(:), irf(:) ! d(n_proj)
  integer, allocatable :: exclude_bands(:) ! d(n_exclude)
  integer, allocatable :: nnlist(:,:) ! d(num_kp,nntot)
  integer, allocatable :: nncell(:,:,:) ! d(3,num_kp,nntot)
  integer, allocatable :: ib_inc(:) ! d(num_bands)

  real(kind=DP), allocatable :: projfunc(:,:,:,:) ! d(kg1,n_proj,ista_snl:iend_snl,kimg)

! ==== KT_add === 2015/04/13 & 09/02
  real(kind=DP), allocatable :: dk_unit(:,:)
  logical, allocatable :: centre_on_atom(:)

  integer, allocatable :: spn_index(:)
  real(kind=DP), allocatable :: spn_quant_dir(:,:)
! =============== 2015/04/13 & 09/02

! ==== KT_add === 2015/09/14
  integer, allocatable :: igf_wan90(:,:,:,:)
! =============== 2015/09/14

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

contains

  subroutine m_Wan90_init(nfout)
    implicit none  
    integer, intent(in) :: nfout

    character(len=15) :: dummy
 
    integer :: i, j, n
    integer :: kp, nnkp, ng1,ng2,ng3 

! == KT add == 2015/02/23
    if ( mype /= 0 ) goto 100
! ============== 2015/02/23

    open(nfwannier,file=trim(wan90_seedname)//".nnkp",status="old",form="formatted")
    read(nfwannier,'(a80)') comment

    read(nfwannier,*)

    read(nfwannier,'(a15,l)') dummy,calc_only_A

    read(nfwannier,*)

    read(nfwannier,*)
    do i=1,3
       read(nfwannier,*) real_lattice(1:3,i)
    end do
    read(nfwannier,*)

    read(nfwannier,*)

    read(nfwannier,*)
    do i=1,3
       read(nfwannier,*) recip_lattice(1:3,i)
    end do
    read(nfwannier,*)

    read(nfwannier,*)

    read(nfwannier,*)
    read(nfwannier,*) num_kp
    if(ipri>=2) write(*,'("num_kp=",i5)') num_kp
    allocate(kvec(3,num_kp))
    do i=1,num_kp
       read(nfwannier,*) kvec(1:3,i)
    end do
    read(nfwannier,*)

    read(nfwannier,*)

    read(nfwannier,*)
    read(nfwannier,*) n_proj
    if(ipri>=2) write(*,'("n_proj=",i5)') n_proj
    allocate(centre(3,n_proj))
    allocate(lang(n_proj))
    allocate(mr(n_proj))
    allocate(irf(n_proj))
    allocate(zaxis(3,n_proj))
    allocate(xaxis(3,n_proj))
    allocate(zona(n_proj))

    if ( noncol ) then
       allocate( spn_index(n_proj) )
       allocate( spn_quant_dir(3,n_proj) )
    endif

    if ( noncol ) then
       do i=1,n_proj
          read(nfwannier,*) centre(1:3,i), lang(i), mr(i), irf(i)
          read(nfwannier,*) zaxis(1:3,i), xaxis(1:3,i), zona(i)
!
          read(nfwannier,*) spn_index(i), spn_quant_dir(1:3,i)
       end do
    else
       do i=1,n_proj
          read(nfwannier,*) centre(1:3,i), lang(i), mr(i), irf(i)
          read(nfwannier,*) zaxis(1:3,i), xaxis(1:3,i), zona(i)
       end do
    endif

    read(nfwannier,*)

    read(nfwannier,*)

    read(nfwannier,*)
    read(nfwannier,*) nntot
    if(ipri>=2) write(*,'("nntot=",i5)') nntot
    allocate(nnlist(num_kp,nntot))
    allocate(nncell(3,num_kp,nntot))
    do j=1,num_kp
       do i=1,nntot
          read(nfwannier,*) kp, nnkp, ng1,ng2,ng3
          nnlist(kp,i) = nnkp
          nncell(1,kp,i) = ng1
          nncell(2,kp,i) = ng2
          nncell(3,kp,i) = ng3
      end do
    end do
    read(nfwannier,*)

    read(nfwannier,*)

    read(nfwannier,*)
    read(nfwannier,*) n_exclude
    if(ipri>=2) write(*,'("n_exclude=",i5)') n_exclude
    allocate(exclude_bands(n_exclude))
    do i=1,n_exclude
       read(nfwannier,*) exclude_bands(i)
    end do
    read(nfwannier,*)

    close(nfwannier)

! == KT add == 2015/02/23 & 09/02
100 continue
    if ( npes > 1 ) then
       call mpi_bcast( calc_only_A, 1, mpi_logical, 0, mpi_comm_group, ierr )
       call mpi_bcast( real_lattice, 3*3, mpi_double_precision, 0, &
            &          mpi_comm_group, ierr )
       call mpi_bcast( recip_lattice, 3*3, mpi_double_precision, 0, &
            &          mpi_comm_group, ierr )

       call mpi_bcast( num_kp, 1, mpi_integer, 0, mpi_comm_group, ierr )
       if ( mype /= 0 ) then
          allocate( kvec(3,num_kp) );  kvec = 0.0d0
       endif
       call mpi_bcast( kvec, 3*num_kp, mpi_double_precision, 0, &
            &          mpi_comm_group, ierr )

       call mpi_bcast( n_proj, 1, mpi_integer, 0, mpi_comm_group, ierr )
       if ( mype /= 0 ) then
          allocate(centre(3,n_proj)); allocate(zona(n_proj))
          allocate(zaxis(3,n_proj));  allocate(xaxis(3,n_proj))
          allocate(lang(n_proj));     allocate(mr(n_proj));    allocate(irf(n_proj))
       endif
       call mpi_bcast( centre, 3*n_proj, mpi_double_precision, 0, &
            &          mpi_comm_group, ierr )
       call mpi_bcast( zaxis,  3*n_proj, mpi_double_precision, 0, &
            &          mpi_comm_group, ierr )
       call mpi_bcast( xaxis,  3*n_proj, mpi_double_precision, 0, &
            &          mpi_comm_group, ierr )
       call mpi_bcast( zona,     n_proj, mpi_double_precision, 0, &
            &          mpi_comm_group, ierr )

       if ( noncol ) then
          if ( mype /= 0 ) then
             allocate( spn_index(n_proj) )
             allocate( spn_quant_dir(3,n_proj) )
          endif
          call mpi_bcast( spn_index, n_proj, mpi_integer, 0, &
               &          mpi_comm_group, ierr )
          call mpi_bcast( spn_quant_dir, 3*n_proj, mpi_double_precision, 0, &
               &          mpi_comm_group, ierr )
       endif

       call mpi_bcast( lang, n_proj, mpi_integer, 0, mpi_comm_group, ierr )
       call mpi_bcast( mr,   n_proj, mpi_integer, 0, mpi_comm_group, ierr )
       call mpi_bcast( irf,  n_proj, mpi_integer, 0, mpi_comm_group, ierr )

       call mpi_bcast( nntot, 1, mpi_integer, 0, mpi_comm_group, ierr )
       if ( mype /= 0 ) then
          allocate(nnlist(num_kp,nntot));    allocate(nncell(3,num_kp,nntot))
       endif
       call mpi_bcast( nnlist,   num_kp*nntot, mpi_integer, 0, mpi_comm_group, ierr )
       call mpi_bcast( nncell, 3*num_kp*nntot, mpi_integer, 0, mpi_comm_group, ierr )

       call mpi_bcast( n_exclude, 1, mpi_integer, 0, mpi_comm_group, ierr )
       if ( mype /= 0 ) then
          allocate(exclude_bands(n_exclude));  exclude_bands = 0
       endif
       call mpi_bcast( exclude_bands, n_exclude, mpi_integer, 0, mpi_comm_group, ierr )
    endif
! ============= 2015/02/23 & 09/02

    num_bands = nb_wan90 - n_exclude
    allocate(ib_inc(num_bands))
    n = 0
    do i=1,nb_wan90
       if(excluding_band(i)) cycle
       n = n + 1
       ib_inc(n) = i
    end do

    if ( mype == 0 ) call write_down_input(nfout)

  end subroutine m_Wan90_init

  subroutine write_down_input(nfout)
    implicit none
    integer, intent(in) :: nfout

    integer :: i,j
   
    write(nfout,'("Wannier90")')
    write(nfout,'("comment: ",a)') trim(comment)
    write(nfout,'("calc_only_A: ",l)') calc_only_A
    write(nfout,'("real_lattice")')
    do i=1,3
       write(nfout,'(3(1x,f20.8))') real_lattice(1:3,i)
    end do
    write(nfout,'("recip_lattice")')
    do i=1,3
       write(nfout,'(3(1x,f20.8))') recip_lattice(1:3,i)
    end do
    write(nfout,'("k vectors:")')
    write(nfout,'("num_kp: ",i5)') num_kp
    do i=1,num_kp
       write(nfout,'("kvec(",i5,") =",3(1x,f20.8))') i,kvec(1:3,i)
    end do
    write(nfout,'("n_proj: ",i5)') n_proj
    do i=1,n_proj
       write(nfout,'(3(1x,f20.8),3(1x,i5))') centre(1:3,i), lang(i), mr(i), irf(i)
       write(nfout,'(7(1x,f20.8))') zaxis(1:3,i), xaxis(1:3,i), zona(i)
    end do
    write(nfout,'("kp nnlist nncell(1:3)")')
    do i=1,num_kp
       do j=1,nntot
          write(nfout,'(i5,1x,i5,3(1x,i5))') i,nnlist(i,j),nncell(1:3,i,j)
       end do
    end do
    write(nfout,'("excluded bands ")')
    write(nfout,'("n_exclude: ",i5)') n_exclude
    do i=1,n_exclude
       write(nfout,'(i5)') exclude_bands(i)
    end do
    write(nfout,'("included bands ")')
    do i=1,num_bands
       write(nfout,'(i5)') ib_inc(i)
    end do

  end subroutine write_down_input

  subroutine m_Wan90_gen_amat(nfout)
!
!    Amn(k) = <Psi_mk|g_n>
!
    implicit none
    integer, intent(in) :: nfout

    real(kind=DP), allocatable :: a_mat(:,:,:,:) ! d(num_bands,n_proj,kv3,2)

    allocate(a_mat(num_bands,n_proj,kv3,2));  a_mat = 0.d0

    call contrib_softpart
    if ( sw_use_hardpart_wan90 == ON ) call contrib_hardpart

    call gather_matrix
    call print_mat

    deallocate(a_mat)

  contains

    subroutine contrib_softpart
      integer :: ik,ikpj,n,m,ib,i,mi
      integer :: ik_start, ik_skip
      real(kind=DP) :: pr,pi,zr,zi

      allocate(projfunc(kg1,n_proj,ista_snl:iend_snl,kimg))
      call m_Wan90_Projectors(nfout,kv3,vkxyz)

      ik_start = 1;  ik_skip = 1
      if ( .not. noncol ) then
         if ( nspin == 2 .and. spin_component_wan90 == DOWN ) then
            ik_start = 2
         endif
         if ( nspin == 2 ) ik_skip = 2
      endif

      do ik = ik_start, kv3, ik_skip
         if(map_k(ik) /= myrank_k) cycle ! MPI
         ikpj = (ik-1)/nspin + 1

         do n=1,n_proj
            do m=1,num_bands
               mi = ib_inc(m)
               ib = neordr(mi,ik)
               if(map_e(ib) /= myrank_e) cycle ! MPI
               if(ipri>=2) write(*,'("m=",i5," n=",i5," ik=",i5)') m,n,ik
               if(kimg==1) then
                  do i=1,iba(ik)
                     pr = projfunc(i,n,ikpj,1)
                     zr = zaj_l(i,map_z(ib),ik,1)
                     a_mat(m,n,ik,1) = a_mat(m,n,ik,1) + zr*pr
                  end do
               else
                  if(k_symmetry(ik) == GAMMA) then
                     do i=2,iba(ik)
                        pr = projfunc(i,n,ikpj,1)
                        pi = projfunc(i,n,ikpj,2)
                        zr = zaj_l(i,map_z(ib),ik,1)
                        zi = zaj_l(i,map_z(ib),ik,2)
                        a_mat(m,n,ik,1) = a_mat(m,n,ik,1) + zr*pr + zi*pi
                     end do
                     pr = projfunc(1,n,ikpj,1)
                     zr = zaj_l(1,map_z(ib),ik,1)
                     a_mat(m,n,ik,1) = a_mat(m,n,ik,1)*2.d0 + zr*pr
                  else
                     do i=1,iba(ik)
                        pr = projfunc(i,n,ikpj,1)
                        pi = projfunc(i,n,ikpj,2)
                        zr = zaj_l(i,map_z(ib),ik,1)
                        zi = zaj_l(i,map_z(ib),ik,2)
                        a_mat(m,n,ik,1) = a_mat(m,n,ik,1) + zr*pr + zi*pi
                        a_mat(m,n,ik,2) = a_mat(m,n,ik,2) + zr*pi - zi*pr
                     end do
                  end if
               end if
            end do
         end do
      end do
      deallocate(projfunc)

    end subroutine contrib_softpart

! === KT_add === 2015/02/23
    subroutine contrib_hardpart
      integer, parameter :: nmesh = 1501

      integer :: ik ,ikpj, n, m, mi, ib
      integer :: ia, it, lmt1, il1, im1, tau1, ir, nsphere, lmta1
      integer :: ik_start, ik_skip
      real(kind=DP) :: dx, dy, dz, dist
      real(kind=DP) :: coeff_w90(16), csum, ph
      complex(kind=CMPLDP) :: z1

      real(kind=DP), allocatable, dimension(:) :: radr,wos,radfunc
      complex(kind=CMPLDP), allocatable :: zph(:)

      allocate( zph(natm) ); zph = 0.0d0

      allocate(radr(nmesh),wos(nmesh),radfunc(nmesh))
      call radr_and_wos(nmesh,radr,wos) ! --> radr, wos

      ik_start = 1;  ik_skip = 1
      if ( .not. noncol ) then
         if ( nspin == 2 .and. spin_component_wan90 == DOWN ) then
            ik_start = 2
         endif
         if ( nspin == 2 ) ik_skip = 2
      endif

      do ik = ik_start, kv3, ik_skip
         if(map_k(ik) /= myrank_k) cycle ! MPI
         ikpj = (ik-1)/nspin + 1

         Do ia=1, natm
            ph = PAI2 * dot_product( pos(ia,:), vkxyz(ik,:,BUCS) )
            zph(ia) = dcmplx( cos(ph), -sin(ph) )
         End Do

         do n=1,n_proj
            call radial_function( irf(n), zona(n), nmesh, radr, radfunc )
            call deompose_sphr_into_lm( lang(n), mr(n), coeff_w90 )
!
            do m=1,num_bands
               mi = ib_inc(m)
               if ( map_e(mi) /= myrank_e ) cycle

               ib = neordr(mi,ik)

               Do ia=1, natm
                  dx = centre(1,n) -pos(ia,1)
                  dy = centre(2,n) -pos(ia,2)
                  dz = centre(3,n) -pos(ia,3)
                  dist = sqrt( dx**2 +dy**2 +dz**2 )
                  if ( dist > 1.0E-3 ) cycle
!
                  it = ityp(ia)
                  Do lmt1=1, ilmt(it)
                     il1 = ltp(lmt1,it);  im1 = mtp(lmt1,it);  tau1 = taup(lmt1,it)
                     lmta1 = lmta(lmt1,ia)
                     !
                     csum = 0.0d0
                     Do ir=1, nmesh
                        csum = csum + wos(ir) *radr(ir) *radfunc(ir) &
                             &   *( psirpw(ir,il1,tau1,it) -phirpw(ir,il1,tau1,it) )
                     End do

                     nsphere = ( il1 -1 )**2 +im1
                     csum = csum *coeff_w90( nsphere )

                     z1 = csum *zph(ia) &
                          &     *dcmplx( fsr_l(map_z(ib),lmta1,ik), &
                          &             -fsi_l(map_z(ib),lmta1,ik) )

                     a_mat(m,n,ik,1) = a_mat(m,n,ik,1) + real(z1)
                     a_mat(m,n,ik,2) = a_mat(m,n,ik,2) + aimag(z1)
                  End Do
               End Do
            End do
         End do
      End do
      deallocate( radr ); deallocate( wos ); deallocate( radfunc )
    end subroutine contrib_hardpart
! ============== 2015/02/23

    subroutine gather_matrix
      real(kind=DP), allocatable :: a_mat_mpi(:,:,:,:) ! d(num_bands,n_proj,kv3,2)

      if(npes>1) then
         allocate(a_mat_mpi(num_bands,n_proj,kv3,2))
         a_mat_mpi = a_mat
         a_mat = 0.d0
         call mpi_allreduce(a_mat_mpi,a_mat,num_bands*n_proj*kv3*2,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
         deallocate(a_mat_mpi)
      end if
    end subroutine gather_matrix

    subroutine print_mat
      integer :: ik ,m, n, ik_start, iktmp, is
      real(kind=DP) :: theta, phi
      complex(kind=CMPLDP) :: ztmp, z1
      complex(kind=CMPLDP), allocatable :: spn_weight(:,:)

      if ( mype /= 0 ) return

      open(nfwannier,file=trim(wan90_seedname)//".amn",form="formatted")
      if ( noncol ) then
         write(nfwannier,*) 'Generated by PHASE noncol'
      else
         if ( nspin == 2 ) then
            write(nfwannier,*) 'Generated by PHASE (nspin=2), comp: ', &
                 &              spin_component_wan90
         else
            write(nfwannier,*) 'Generated by PHASE'
         endif
      endif
      write(nfwannier,*) num_bands, kv3/nspin, n_proj

      if ( noncol ) then
         allocate( spn_weight(2,n_proj) ); spn_weight = 0.0d0

         Do n=1, n_proj
            theta = acos( spn_quant_dir(3,n) )
            phi = atan2( spn_quant_dir(2,n), spn_quant_dir(1,n) )
!            
            if ( spn_index(n) == 1 ) then
               spn_weight(1,n) = exp( zi *phi /2.0d0 ) *cos( theta /2.0d0 )
               spn_weight(2,n) = -exp( zi *phi /2.0d0 ) *sin( theta /2.0d0 )
            else
               spn_weight(1,n) = exp( -zi *phi /2.0d0 ) *sin( theta /2.0d0 )
               spn_weight(2,n) = exp( -zi *phi /2.0d0 ) *cos( theta /2.0d0 )
            endif
         End do

         do ik = 1, kv3, ndim_spinor
            iktmp = ( ik -1 )/ndim_spinor +1
            do n=1,n_proj
               do m=1,num_bands
                  ztmp = 0.0d0
                  Do is=1, ndim_spinor
                     z1 = dcmplx( a_mat(m,n,ik+is-1,1), a_mat(m,n,ik+is-1,2 ) )
                     ztmp = ztmp +spn_weight(is,n) *z1
                  End do

                  write(nfwannier,'(3(1x,i5),2(1x,f18.12))') m, n, iktmp, &
                       &         real(ztmp), aimag(ztmp)
               end do
            end do
         end do
         deallocate( spn_weight )

      else
         ik_start = 1
         if ( nspin == 2 .and. spin_component_wan90 == DOWN ) ik_start = 2

         do ik = ik_start, kv3, nspin
            iktmp = ( ik -1 )/nspin +1
            do n=1,n_proj
               do m=1,num_bands
                  write(nfwannier,'(3(1x,i5),2(1x,f18.12))') m, n, iktmp, &
                       &                     a_mat(m,n,ik,1:2)
               end do
            end do
         end do
      endif

      close(nfwannier)

    end subroutine print_mat

  end subroutine m_Wan90_gen_amat

  subroutine m_Wan90_Projectors(nfout,kv3,vkxyz)
    implicit none  
    integer, intent(in) :: nfout,kv3
    real(kind=DP), intent(in) :: vkxyz(kv3,3,CRDTYP)

    integer, parameter :: nmesh = 1501

    integer :: ik,ikpj,il1,ip,n,i, ia
    real(kind=DP) :: dx, dy, dz, dist
    real(kind=DP) :: fac, facr, dnorm
    real(kind=DP), allocatable, dimension(:) :: qx,qy,qz,vlength,wka,wkb
    real(kind=DP), allocatable, dimension(:) :: zcos,zsin
    real(kind=DP), allocatable, dimension(:,:) :: pf
    real(kind=DP), allocatable, dimension(:,:) :: angf
    real(kind=DP), allocatable, dimension(:) :: radr,wos,radfunc
    integer, allocatable :: lmin_pj(:) ! d(n_proj)
    integer, allocatable :: lmax_pj(:) ! d(n_proj)

    integer             :: id_sname = -1
    call tstatc0_begin('m_Wan90_Projectors ',id_sname,1)

    allocate(lmin_pj(n_proj))
    allocate(lmax_pj(n_proj))
    allocate(qx(kg1),qy(kg1),qz(kg1),vlength(kg1),wka(kg1),wkb(kg1))
    allocate(pf(kg1,lmax1_pj),angf(kg1,lmax1_pj))
    allocate(radr(nmesh),wos(nmesh),radfunc(nmesh))
    allocate(zcos(kg1),zsin(kg1))

    allocate( centre_on_atom(n_proj) ); centre_on_atom = .false.
    Do n=1, n_proj
       Loop_ia: Do ia=1, natm
          dx = centre(1,n) -pos(ia,1)
          dy = centre(2,n) -pos(ia,2)
          dz = centre(3,n) -pos(ia,3)
          dist = sqrt( dx**2 +dy**2 +dz**2 )
          if ( dist < 1.0E-3 ) then
             centre_on_atom(n) = .true.
             exit Loop_ia
          endif
       End do Loop_ia

       if ( sw_use_hardpart_wan90 == ON ) then
          if ( .not. centre_on_atom(n) ) then
             write(nfout,*) "** Warning : proj ",n
             write(nfout,*) "** In the case of sw_use_hardpart_wan90 = ON "
             write(nfout,*) "** We recommend that Localized orbitals are on atomic sites"
!             stop
          endif
       End if
    End Do

    do ip=1,n_proj
       call set_lmin_lmax(lang(ip),lmin_pj(ip),lmax_pj(ip))
       if(ipri>=2) write(*,'("ip=",i5," lmin=",i5," lmax=",i5)') ip, lmin_pj(ip), lmax_pj(ip) 
    end do

    call radr_and_wos(nmesh,radr,wos) ! --> radr, wos
    fac = PAI4/dsqrt(univol)
    do ik = 1, kv3, nspin
       if(map_k(ik) /= myrank_k) cycle                     ! MPI
       call k_plus_G_vectors(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
                           &,qx,qy,qz,vlength) ! ->(bottom_Subr.)
!!       call G_vectors(kgp,iba(ik),nbase(1,ik),ngabc,rltv,qx,qy,qz,vlength)
       ikpj = (ik-1)/nspin + 1
       do ip=1,n_proj
          if(ipri>=2) write(*,'("ikpj=",i5," ip=",i5)') ikpj,ip

          call radial_function(irf(ip),zona(ip),nmesh,radr,radfunc)
! Debug
         !! if(ik==1) then
         !! write(1000+ip,'("radr radfunc")')
         !! do n=1,nmesh
         !!    write(1000+ip,'(f20.8,1x,f20.8)') radr(n), radfunc(n)
         !! end do
         !! end if
! end Debug
          if(ipri>=2) write(*,'("debug 1")')
          angf = 0.d0
          do il1=lmin_pj(ip)+1,lmax_pj(ip)+1
             call angular_function(lang(ip),mr(ip),iba(ik),qx,qy,qz,angf)
          end do
          if(ipri>=2) write(*,'("debug 2")')
          pf = 0.d0
          do n=1,nmesh
             facr = fac*wos(n)*radr(n)**2*radfunc(n)
             do i=1,iba(ik)
                wka(i) = vlength(i)*radr(n)
             end do
             do il1=lmin_pj(ip)+1,lmax_pj(ip)+1
                call dsjnv(il1-1,iba(ik),wka,wkb)     ! -(bottom_Subr.)
                do i=1,iba(ik)
                   pf(i,il1) = pf(i,il1) + facr*wkb(i)*angf(i,il1)
                end do
             end do
          end do
          if(ipri>=2) write(*,'("debug 3")')

          !! Projector(k+G) = sum_l i^(-l) * exp(-i(k+G)*R) * PF_l(k+G) 
          call exp_KpG_dot_R(centre(1,ip),ik,kgp,iba,nbase,ngabc,vkxyz,zcos,zsin)

          if(ipri>=2) write(*,'("debug 4")')
          projfunc(1:kg1,ip,ikpj,1:kimg) = 0.d0
          do il1=lmin_pj(ip)+1,lmax_pj(ip)+1
             if(il1==1) then
                if(kimg==1) then
                   do i=1,iba(ik)
                      projfunc(i,ip,ikpj,1) = projfunc(i,ip,ikpj,1) + pf(i,il1) * zcos(i)
                   end do
                else
                   do i=1,iba(ik)
                      projfunc(i,ip,ikpj,1) = projfunc(i,ip,ikpj,1) + pf(i,il1) * zcos(i)
                      projfunc(i,ip,ikpj,2) = projfunc(i,ip,ikpj,2) - pf(i,il1) * zsin(i)
                   end do
                end if
             else if(il1==2) then
                if(kimg==1) then
                   do i=1,iba(ik)
                      projfunc(i,ip,ikpj,1) = projfunc(i,ip,ikpj,1) - pf(i,il1) * zsin(i)
                   end do
                else
                   do i=1,iba(ik)
                      projfunc(i,ip,ikpj,1) = projfunc(i,ip,ikpj,1) - pf(i,il1) * zsin(i)
                      projfunc(i,ip,ikpj,2) = projfunc(i,ip,ikpj,2) - pf(i,il1) * zcos(i)
                   end do
                end if
             else if(il1==3) then
                if(kimg==1) then
                   do i=1,iba(ik)
                      projfunc(i,ip,ikpj,1) = projfunc(i,ip,ikpj,1) - pf(i,il1) * zcos(i)
                   end do
                else
                   do i=1,iba(ik)
                      projfunc(i,ip,ikpj,1) = projfunc(i,ip,ikpj,1) - pf(i,il1) * zcos(i)
                      projfunc(i,ip,ikpj,2) = projfunc(i,ip,ikpj,2) + pf(i,il1) * zsin(i)
                   end do
                end if
             else if(il1==4) then
                if(kimg==1) then
                   do i=1,iba(ik)
                      projfunc(i,ip,ikpj,1) = projfunc(i,ip,ikpj,1) + pf(i,il1) * zsin(i)
                   end do
                else
                   do i=1,iba(ik)
                      projfunc(i,ip,ikpj,1) = projfunc(i,ip,ikpj,1) + pf(i,il1) * zsin(i)
                      projfunc(i,ip,ikpj,2) = projfunc(i,ip,ikpj,2) + pf(i,il1) * zcos(i)
                   end do
                end if
             end if
          end do
          if(ipri>=2) write(*,'("debug 5")')
! === KT_add ==== 2015/04/13
!          if ( sw_use_hardpart_wan90 == ON ) goto 1000
          if ( sw_use_hardpart_wan90 == ON .and. centre_on_atom(ip) ) goto 1000
! =============== 2015/04/13
#if 1
! Normalization
          dnorm = 0.d0
          do i=1,iba(ik)
             dnorm = dnorm + projfunc(i,ip,ikpj,1)**2 + projfunc(i,ip,ikpj,2)**2
          end do
! Debug
!!          write(nfout,'("ip=",i5," ikpj=",i5," dnorm=",f25.10," centre=",3(1x,f10.5))') &
!!           & ip,ikpj,dnorm,centre(1:3,ip)
! End Debug
          dnorm = 1.d0/sqrt(dnorm)
          if(kimg==1) then
             do i=1,iba(ik)
                projfunc(i,ip,ikpj,1) = projfunc(i,ip,ikpj,1) * dnorm
             end do
          else
             do i=1,iba(ik)
                projfunc(i,ip,ikpj,1) = projfunc(i,ip,ikpj,1) * dnorm
                projfunc(i,ip,ikpj,2) = projfunc(i,ip,ikpj,2) * dnorm
             end do
          end if
#endif
! === KT_add ==== 2015/02/28
1000      continue
! =============== 2015/02/28
      end do
    end do

    deallocate(lmin_pj)
    deallocate(lmax_pj)
    deallocate(qx,qy,qz,vlength,wka,wkb)
    deallocate(pf,angf)
    deallocate(zcos,zsin)
    deallocate(radr,wos,radfunc)

    call tstatc0_end(id_sname)
  end subroutine m_Wan90_Projectors

  subroutine radr_and_wos(nm,radr,wos)
    integer, intent(in) :: nm
    real(kind=DP), intent(out) :: radr(nm), wos(nm)

    real(kind=DP), parameter :: xh = 96.d0
    real(kind=DP), parameter :: rmax = 60.d0
    real(kind=DP) :: hn

    call rmeshs(nm,nm,xh,rmax,radr,hn) ! -(b_PP)
    call coef_simpson_integration(nm,nm,xh,radr,wos) ! -(b_PP)
  end subroutine radr_and_wos

  subroutine spherical_function(l,m,nq,qx,qy,qz,sphfunc)
    integer, intent(in) :: l,m,nq
    real(kind=DP), intent(in) :: qx(nq), qy(nq), qz(nq)
    real(kind=DP), intent(out) :: sphfunc(nq)

    if(l==0.and.m==1) then ! s
       call sphr(nq,1,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==1.and.m==1) then ! pz
       call sphr(nq,4,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==1.and.m==2) then ! px
       call sphr(nq,2,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==1.and.m==3) then ! py
       call sphr(nq,3,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==2.and.m==1) then ! dz2
       call sphr(nq,5,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==2.and.m==2) then ! dxz
       call sphr(nq,9,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==2.and.m==3) then ! dyz
       call sphr(nq,8,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==2.and.m==4) then ! dx2-y2
       call sphr(nq,6,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==2.and.m==5) then ! dxy
       call sphr(nq,7,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==3.and.m==1) then ! fz3
       call sphr(nq,10,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==3.and.m==2) then ! fxz2
       call sphr(nq,11,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==3.and.m==3) then ! fyz2
       call sphr(nq,12,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==3.and.m==4) then ! fz(x2-y2)
       call sphr(nq,13,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==3.and.m==5) then ! fxyz
       call sphr(nq,14,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==3.and.m==6) then ! fx(x2-3y2)
       call sphr(nq,15,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    else if(l==3.and.m==7) then ! fy(3x2-y2)
       call sphr(nq,16,qx,qy,qz,sphfunc)        ! -(bottom_Subr.)
    end if
  end subroutine spherical_function

  subroutine angular_function(l,m,nq,qx,qy,qz,angfunc)
    integer, intent(in) :: l,m,nq
    real(kind=DP), intent(in) :: qx(nq), qy(nq), qz(nq)
    real(kind=DP), intent(out) :: angfunc(kg1,lmax1_pj)

    real(kind=DP), allocatable :: sphfunc(:)

    allocate(sphfunc(nq))
  
    if(l>=0) then
      call spherical_function(l,m,nq,qx,qy,qz,sphfunc)
      angfunc(1:nq,1) = sphfunc(1:nq)
    else if(l==-1.and.m==1) then
      call spherical_function(0,1,nq,qx,qy,qz,sphfunc) ! s
      angfunc(1:nq,1) = sphfunc(1:nq)/sqrt(2.d0)
      call spherical_function(1,2,nq,qx,qy,qz,sphfunc) ! px
      angfunc(1:nq,2) = sphfunc(1:nq)/sqrt(2.d0)
    else if(l==-1.and.m==2) then
      call spherical_function(0,1,nq,qx,qy,qz,sphfunc) ! s
      angfunc(1:nq,1) = sphfunc(1:nq)/sqrt(2.d0)
      call spherical_function(1,2,nq,qx,qy,qz,sphfunc) ! px
      angfunc(1:nq,2) = -sphfunc(1:nq)/sqrt(2.d0)
    else if(l==-2.and.m==1) then
      call spherical_function(0,1,nq,qx,qy,qz,sphfunc) ! s
      angfunc(1:nq,1) = sphfunc(1:nq)/sqrt(3.d0)
      call spherical_function(1,2,nq,qx,qy,qz,sphfunc) ! px
      angfunc(1:nq,2) = -sphfunc(1:nq)/sqrt(6.d0)
      call spherical_function(1,3,nq,qx,qy,qz,sphfunc) ! py
      angfunc(1:nq,2) = angfunc(1:nq,2) + sphfunc(1:nq)/sqrt(2.d0)
    else if(l==-2.and.m==2) then
      call spherical_function(0,1,nq,qx,qy,qz,sphfunc) ! s
      angfunc(1:nq,1) = sphfunc(1:nq)/sqrt(3.d0)
      call spherical_function(1,2,nq,qx,qy,qz,sphfunc) ! px
      angfunc(1:nq,2) = -sphfunc(1:nq)/sqrt(6.d0)
      call spherical_function(1,3,nq,qx,qy,qz,sphfunc) ! py
      angfunc(1:nq,2) = angfunc(1:nq,2) - sphfunc(1:nq)/sqrt(2.d0)
    else if(l==-2.and.m==3) then
      call spherical_function(0,1,nq,qx,qy,qz,sphfunc) ! s
      angfunc(1:nq,1) = sphfunc(1:nq)/sqrt(3.d0)
      call spherical_function(1,2,nq,qx,qy,qz,sphfunc) ! px
      angfunc(1:nq,2) = sphfunc(1:nq)*(2.d0/sqrt(6.d0))
    else if(l==-3.and.m==1) then
      call spherical_function(0,1,nq,qx,qy,qz,sphfunc) ! s
      angfunc(1:nq,1) = sphfunc(1:nq)*0.5d0
      call spherical_function(1,2,nq,qx,qy,qz,sphfunc) ! px
      angfunc(1:nq,2) = sphfunc(1:nq)*0.5d0
      call spherical_function(1,3,nq,qx,qy,qz,sphfunc) ! py
      angfunc(1:nq,2) = angfunc(1:nq,2) + sphfunc(1:nq)*0.5d0
      call spherical_function(1,1,nq,qx,qy,qz,sphfunc) ! pz
      angfunc(1:nq,2) = angfunc(1:nq,2) + sphfunc(1:nq)*0.5d0
    else if(l==-3.and.m==2) then
      call spherical_function(0,1,nq,qx,qy,qz,sphfunc) ! s
      angfunc(1:nq,1) = sphfunc(1:nq)*0.5d0
      call spherical_function(1,2,nq,qx,qy,qz,sphfunc) ! px
      angfunc(1:nq,2) = sphfunc(1:nq)*0.5d0
      call spherical_function(1,3,nq,qx,qy,qz,sphfunc) ! py
      angfunc(1:nq,2) = angfunc(1:nq,2) - sphfunc(1:nq)*0.5d0
      call spherical_function(1,1,nq,qx,qy,qz,sphfunc) ! pz
      angfunc(1:nq,2) = angfunc(1:nq,2) - sphfunc(1:nq)*0.5d0
    else if(l==-3.and.m==3) then
      call spherical_function(0,1,nq,qx,qy,qz,sphfunc) ! s
      angfunc(1:nq,1) = sphfunc(1:nq)*0.5d0
      call spherical_function(1,2,nq,qx,qy,qz,sphfunc) ! px
      angfunc(1:nq,2) = -sphfunc(1:nq)*0.5d0
      call spherical_function(1,3,nq,qx,qy,qz,sphfunc) ! py
      angfunc(1:nq,2) = angfunc(1:nq,2) + sphfunc(1:nq)*0.5d0
      call spherical_function(1,1,nq,qx,qy,qz,sphfunc) ! pz
      angfunc(1:nq,2) = angfunc(1:nq,2) - sphfunc(1:nq)*0.5d0
    else if(l==-3.and.m==4) then
      call spherical_function(0,1,nq,qx,qy,qz,sphfunc) ! s
      angfunc(1:nq,1) = sphfunc(1:nq)*0.5d0
      call spherical_function(1,2,nq,qx,qy,qz,sphfunc) ! px
      angfunc(1:nq,2) = -sphfunc(1:nq)*0.5d0
      call spherical_function(1,3,nq,qx,qy,qz,sphfunc) ! py
      angfunc(1:nq,2) = angfunc(1:nq,2) - sphfunc(1:nq)*0.5d0
      call spherical_function(1,1,nq,qx,qy,qz,sphfunc) ! pz
      angfunc(1:nq,2) = angfunc(1:nq,2) + sphfunc(1:nq)*0.5d0
    else if(l<=-4) then
      call phase_error_with_msg(6,'Not supported for l<=-4',__LINE__,__FILE__)
    end if
    
    deallocate(sphfunc)
  end subroutine angular_function

  subroutine radial_function(irf,zona,nm,radr,radfunc)
    implicit none
    integer, intent(in) :: irf, nm
    real(kind=DP) :: zona
    real(kind=DP) :: radr(nm), radfunc(nm)

    integer :: i
    real(kind=DP) :: fac, ar, alph

    alph = zona * bohr
   
    if(irf==1) then
      fac = 2.d0 * alph**(3.d0/2.d0)
      do i=1,nm
         radfunc(i) = fac * exp(-alph*radr(i))
      end do
    else if(irf==2) then
      fac = alph**(3.d0/2.d0) / sqrt(8.d0)
      do i=1,nm
         ar = alph * radr(i)
         radfunc(i) = fac * ( 2.d0 - ar ) * exp(-0.5d0*ar)
      end do
    else if(irf==3) then
      fac = alph**(3.d0/2.d0) * sqrt(4.d0/27.d0)
      do i=1,nm
         ar = alph * radr(i)
         radfunc(i) = fac * ( 1.d0 - (2.d0/3.d0)*ar + (2.d0/27.d0)*ar*ar ) * exp(-ar/3.d0)
      end do
    end if
  end subroutine radial_function

  subroutine set_lmin_lmax(l,lmin_pj,lmax_pj)
    implicit none
    integer, intent(in) :: l
    integer, intent(out) :: lmin_pj, lmax_pj

    if(l>=0) then
       lmin_pj = 0 
       lmax_pj = 0 
    else if(l==-1.or.l==-2.or.l==-3) then
       lmin_pj = 0 
       lmax_pj = 1
    else if(l<=-4) then
       call phase_error_with_msg(6,'Not supported for l<=-4',__LINE__,__FILE__)
    end if
  end subroutine set_lmin_lmax

  subroutine exp_KpG_dot_R(centre,ik,kgp,iba,nbase,ngabc,vkxyz,zcos,zsin)
    implicit none
    real(kind=DP), intent(in) :: centre(3)
    integer, intent(in) :: ik, kgp
    integer, intent(in) :: iba(kv3), nbase(kg1,kv3), ngabc(kgp,3)
    real(kind=DP), intent(in) :: vkxyz(kv3,3,CRDTYP)
    real(kind=DP), intent(out) :: zcos(kg1), zsin(kg1)

    integer :: i
    real(kind=DP) :: ph

    do i=1,iba(ik)
       ph = PAI2 * dot_product(centre,vkxyz(ik,1:3,BUCS)+ngabc(nbase(i,ik),1:3))
       zcos(i) = cos(ph)
       zsin(i) = sin(ph)
    end do
  end subroutine exp_KpG_dot_R

  subroutine m_Wan90_wd_eig(nfout)
    implicit none
    integer, intent(in) :: nfout

    integer :: ik,m,ib,mi
    real(kind=DP) :: ek

    !!$if(npes /= 1) return
    if(mype==0) then
      open(nfwannier,file=trim(wan90_seedname)//".eig",form="formatted")
      do ik = 1, kv3
         do m=1,num_bands
            mi = ib_inc(m)
            ib = neordr(mi,ik)
            ek = eko_l(map_z(ib),ik) * hartree
            write(nfwannier,'(2(1x,i5),1x,e25.16)') m, ik, ek
         end do
      end do
      close(nfwannier)
   end if
  end subroutine m_Wan90_wd_eig

  subroutine m_Wan90_gen_mmat(nfout)
    implicit none
    integer, intent(in) :: nfout

    integer :: i,ik1,ik2,nn,n,m,ni,mi,ib1,ib2,nnc(3),ir,im
    integer :: nffth,ip,r1,r2,r3,ngrid
    integer :: id1,id2,id12
    real(kind=DP) :: rgrid(3),da(3),wr,wi,dvol,ph,sumr,sumi
    real(kind=DP), allocatable :: wf1(:), wf2(:), zcos(:), zsin(:)
    real(kind=DP), allocatable :: m_mat(:,:,:,:,:) ! d(neg,neg,kv3,nntot,2)
    real(kind=DP), allocatable :: m_mat_mpi(:,:,:,:,:) ! d(neg,neg,kv3,nntot,2)
    logical :: shift_k

    nffth = nfft/2
    ngrid = product(fft_box_size_WF(1:3,1))
    dvol = 1.d0/dble(ngrid)

    allocate(m_mat(neg,neg,kv3,nntot,2)); m_mat = 0.d0
    allocate(wf1(nfft),wf2(nfft))
    allocate(zcos(nffth),zsin(nffth))

    call m_FFT_alloc_WF_work()

    do nn=1,nntot
       do ik1=1,kv3
          ik2 = nnlist(ik1,nn)
          nnc(1:3) = nncell(1:3,ik1,nn)
          if(all(nnc(1:3) == 0)) then
             shift_k = .false.
          else
             shift_k = .true.
             ! Phase factors, exp(iG*r)
             id1 = fft_box_size_WF(1,0)
             id2 = fft_box_size_WF(2,0)
             id12 = id1*id2
             da(1:3) = 1.d0/fft_box_size_WF(1:3,1)
             do i=1,nffth
                ip = i-1
                r3 = ip/id12
                r2 = (ip-r3*id12)/id1
                r1 = ip-r2*id1-r3*id12
                rgrid(1) = dble(r1)*da(1)
                rgrid(2) = dble(r2)*da(2)
                rgrid(3) = dble(r3)*da(3)
                ph = PAI2*dot_product(nnc,rgrid)
                zcos(i) = cos(ph)
                zsin(i) = sin(ph)
             end do
          end if
          do n=1,num_bands
             ni = ib_inc(n)
             ib2 = neordr(ni,ik2)
             call m_ES_WF_in_Rspace(ik2,ib2,wf2) !-> u_n(k+b) or u_n(k')
             if(shift_k) then
                ! u_n(k+b) = exp(-iG*r) * u_n(k')
                ! k+b = k' + G
                do i=1,nffth
                   ir = 2*i-1
                   im = ir+1
                   wr = wf2(ir)
                   wi = wf2(im)
                   wf2(ir) = zcos(i)*wr + zsin(i)*wi
                   wf2(im) = zcos(i)*wi - zsin(i)*wr
                end do
             end if
             do m=1,num_bands
                mi = ib_inc(m)
                ib1 = neordr(mi,ik1)
                call m_ES_WF_in_Rspace(ik1,ib1,wf1) !-> u_m(k)
                ! <u_m(k)|u_n(k+b)>
                sumr = 0.d0
                sumi = 0.d0
                do i=1,nffth
                   ir = 2*i-1
                   im = ir+1
                   sumr = sumr + wf1(ir)*wf2(ir) + wf1(im)*wf2(im)
                   sumi = sumi + wf1(ir)*wf2(im) - wf1(im)*wf2(ir)
                end do
                m_mat(m,n,ik1,nn,1) = sumr * dvol
                m_mat(m,n,ik1,nn,2) = sumi * dvol
             end do
          end do
       end do
    end do

    call m_FFT_dealloc_WF_work()

    deallocate(wf1,wf2)
    deallocate(zcos,zsin)

    if(npes>1) then
       allocate(m_mat_mpi(num_bands,num_bands,kv3,nntot,2))
       m_mat_mpi = m_mat
       m_mat = 0.d0
       call mpi_allreduce(m_mat_mpi,m_mat,num_bands*num_bands*kv3*nntot*2,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       deallocate(m_mat_mpi)
    end if

    if(mype==0) then
       open(nfwannier,file=trim(wan90_seedname)//".mmn",form="formatted")
       write(nfwannier,*) 'Generated by PHASE'
       write(nfwannier,*) num_bands, kv3, nntot
       do ik1 = 1, kv3
          do nn=1,nntot
             ik2 = nnlist(ik1,nn)
             nnc(1:3) = nncell(1:3,ik1,nn)
             write(nfwannier,'(5(1x,i5))') ik1,ik2,nnc(1:3)
             do n=1,num_bands
                do m=1,num_bands
                   write(nfwannier,'(2(1x,f16.12))') m_mat(m,n,ik1,nn,1:2)
                end do
             end do
          end do
       end do
       close(nfwannier)
    end if

    deallocate(m_mat)
  end subroutine m_Wan90_gen_mmat

  subroutine m_Wan90_write_unk(nfout)
    implicit none
    integer, intent(in) :: nfout

    integer :: ispin, iksnl, ik, n, nffth, ngrid, ni, ib
    integer :: id1, id2, id3, id12, ip
    integer :: nd1, nd2, nd3
    integer :: i1, i2, i3
    character(len=10) :: wfnname
    real(kind=DP), allocatable :: wf(:)
    complex(kind=DP), allocatable :: zwf(:,:,:)

    id1 = fft_box_size_WF(1,0)
    id2 = fft_box_size_WF(2,0)
    id3 = fft_box_size_WF(3,0)
    id12 = id1 * id2

    nd1 = fft_box_size_WF(1,1)
    nd2 = fft_box_size_WF(2,1)
    nd3 = fft_box_size_WF(3,1)

    allocate(wf(nfft))
    allocate(zwf(id1,id2,id3))

    if(mype==0) then
       do ispin = 1, nspin
          do iksnl = 1, kv3/nspin
             ik = nspin*(iksnl-1) + ispin
             write(wfnname,'("UNK",i5.5,".",i1)') iksnl,ispin
             open(nfwannier,file=trim(wfnname),form="unformatted")
             write(nfwannier) fft_box_size_WF(1:3,1), iksnl, num_bands
             do n=1,num_bands
                ni = ib_inc(n)
                ib = neordr(ni,ik)
                call m_ES_WF_in_Rspace(ik,ib,wf)
                do i3=1,nd3 
                   do i2=1,nd2
                      do i1=1,nd1
                         ip = i1 + (i2-1)*id1 + (i3-1) * id12
                         zwf(i1,i2,i3) = cmplx(wf(2*ip-1),wf(2*ip))
                      end do
                   end do
                end do
                write(nfwannier) zwf
             end do
             close(nfwannier)
          end do
       end do
    end if

    deallocate(wf)
    deallocate(zwf)

  end subroutine m_Wan90_write_unk

! ====== KT_add ======== 2015/02/23
  subroutine m_Wan90_wd_eig_mpi(nfout)
    implicit none
    integer, intent(in) :: nfout

    integer :: ik,m,ib,mi, ik_start, iktmp
    real(kind=DP) :: ek
    real(kind=DP), allocatable :: eko_wk(:,:), eko_mpi(:,:)

    !!$if(npes /= 1) return
    if (mype==0) then
       open(nfwannier,file=trim(wan90_seedname)//".eig",form="formatted")
    endif

    if ( npes > 1 ) then
       allocate( eko_wk(  neg,kv3 ) );  eko_wk  = 0.0d0
       allocate( eko_mpi( neg,kv3 ) ); eko_mpi = 0.0d0
!
       Do ik=1, kv3, ndim_spinor
          if ( map_k(ik) /= myrank_k ) cycle
          Do ib=1, neg
             if ( map_e(ib) /= myrank_e ) cycle
             eko_mpi( ib, ik ) = eko_l( map_z(ib), ik )
          End do
       End do
       call mpi_allreduce( eko_mpi, eko_wk, neg*kv3, &
                        &  mpi_double_precision, mpi_sum,mpi_comm_group, ierr )
       deallocate( eko_mpi )
    end if

    if ( mype == 0 ) then
       ik_start = 1
       if ( .not. noncol ) then
          if ( nspin == 2 .and. spin_component_wan90 == DOWN ) then
             ik_start = 2
          endif
       endif

       do ik = ik_start, kv3, nspin
          iktmp = ( ik -1 )/nspin +1
          do m=1,num_bands
             mi = ib_inc(m)
             if ( npes > 1 ) then
                ek = eko_wk(mi,ik) *hartree
             else
                ib = neordr(mi,ik)
                ek = eko_l(map_z(ib),ik) * hartree
             endif
             write(nfwannier,'(2(1x,i5),1x,e25.16)') m, iktmp, ek
          end do
       end do
       close(nfwannier)
    endif
!
    if ( allocated(eko_wk) ) deallocate( eko_wk )

  end subroutine m_Wan90_wd_eig_mpi

  subroutine m_Wan90_gen_mmat_mpi(nfout)
    implicit none
    integer, intent(in) :: nfout

    real(kind=DP), allocatable :: m_mat(:,:,:,:,:) ! d(neg,neg,kv3,nntot,2)

#ifndef WAN90_SAVE_MEMORY
    allocate(m_mat(num_bands,num_bands,kv3,nntot,2)); m_mat = 0.d0
#else
    allocate(m_mat(num_bands,num_bands,ista_k:iend_k,nntot,2)); m_mat = 0.d0
#endif

#ifndef WAN90_SKIP_FFT
!    call contrib_softpart
    call contrib_softpart2
#else
    call m_Wan90_set_igf_wan90
    call contrib_softpart3
#endif

    if ( sw_use_hardpart_wan90 == ON ) call contrib_hardpart

    call gather_matrix
    call print_mmat

    if ( allocated( dk_unit ) ) deallocate( dk_unit )
    if ( allocated( igf_wan90 ) ) deallocate( igf_wan90 )
    deallocate(m_mat)

  contains

    subroutine contrib_softpart
      logical :: shift_k
      integer :: i,ik1,ik2,nn,n,m,ni,mi,ib1,ib2,nnc(3),ir,im
      integer :: nffth,ip,r1,r2,r3,ngrid
      integer :: id1,id2,id12
      integer :: ik_start, ik_skip, iktmp, is1
      real(kind=DP) :: rgrid(3),da(3),wr,wi,dvol,ph,sumr,sumi
      real(kind=DP), allocatable :: wf1(:), wf2(:), zcos(:), zsin(:)

      nffth = nfft/2
      ngrid = product(fft_box_size_WF(1:3,1))
      dvol = 1.d0/dble(ngrid)
    
      allocate(wf1(nfft),wf2(nfft))
      allocate(zcos(nffth),zsin(nffth))

      call m_FFT_alloc_WF_work()

      ik_start = 1;  ik_skip = 1
      if ( .not. noncol ) then
         if ( nspin == 2 .and. spin_component_wan90 == DOWN ) then
            ik_start = 2
         endif
         if ( nspin == 2 ) ik_skip = 2
      endif

      do nn=1,nntot
         do ik1 = ik_start, kv3, ik_skip
            iktmp = ( ik1 -1 )/nspin + 1
            is1 = mod( ik1 -1, nspin ) +1

            ik2 = nspin*( nnlist(iktmp,nn) -1 ) +is1

            nnc(1:3) = nncell(1:3,iktmp,nn)

            if(all(nnc(1:3) == 0)) then
               shift_k = .false.
            else
               shift_k = .true.
             ! Phase factors, exp(iG*r)
               id1 = fft_box_size_WF(1,0)
               id2 = fft_box_size_WF(2,0)
               id12 = id1*id2
               da(1:3) = 1.d0/fft_box_size_WF(1:3,1)
               do i=1,nffth
                  ip = i-1
                  r3 = ip/id12
                  r2 = (ip-r3*id12)/id1
                  r1 = ip-r2*id1-r3*id12
                  rgrid(1) = dble(r1)*da(1)
                  rgrid(2) = dble(r2)*da(2)
                  rgrid(3) = dble(r3)*da(3)
                  ph = PAI2*dot_product(nnc,rgrid)
                  zcos(i) = cos(ph)
                  zsin(i) = sin(ph)
               end do
            end if
            do n=1,num_bands
               ni = ib_inc(n)

               if ( map_ek(ni,ik2) == mype ) then
                  ib2 = neordr(ni,ik2)

                  call m_ES_WF_in_Rspace(ik2,ib2,wf2) !-> u_n(k+b) or u_n(k')
                  if(shift_k) then
                     ! u_n(k+b) = exp(-iG*r) * u_n(k')
                     ! k+b = k' + G
                     do i=1,nffth
                        ir = 2*i-1
                        im = ir+1
                        wr = wf2(ir);  wi = wf2(im)
                        wf2(ir) = zcos(i)*wr + zsin(i)*wi
                        wf2(im) = zcos(i)*wi - zsin(i)*wr
                     end do
                  end if
               endif

               call mpi_bcast( wf2, nfft, mpi_double_precision, map_ek(ni,ik2), &
                    &          mpi_comm_group, ierr )

               do m=1,num_bands
                  mi = ib_inc(m)

                  if ( map_ek(mi,ik1) /= mype ) cycle

                  ib1 = neordr(mi,ik1)

                  call m_ES_WF_in_Rspace(ik1,ib1,wf1) !-> u_m(k)
                  ! <u_m(k)|u_n(k+b)>
                  sumr = 0.d0;  sumi = 0.d0
                  do i=1,nffth
                     ir = 2*i-1
                     im = ir+1
                     sumr = sumr + wf1(ir)*wf2(ir) + wf1(im)*wf2(im)
                     sumi = sumi + wf1(ir)*wf2(im) - wf1(im)*wf2(ir)
                  end do
                  m_mat(m,n,ik1,nn,1) = sumr * dvol
                  m_mat(m,n,ik1,nn,2) = sumi * dvol
               end do
            end do
         end do
      end do

      call m_FFT_dealloc_WF_work()

      deallocate(wf1,wf2);   deallocate(zcos,zsin)

    end subroutine contrib_softpart

    subroutine contrib_softpart2          ! FFT and inverse-FFT on u_n(k+b)
      logical :: shift_k
      integer :: i,ik1,ik2,nn,n,m,ni,mi,ib1,ib2,nnc(3),ir,im
      integer :: nffth,ip,r1,r2,r3,ngrid
      integer :: id1,id2,id12
      integer :: ik_start, ik_skip, iktmp, is1
      real(kind=DP) :: rgrid(3),da(3),wr,wi,dvol,ph,sumr,sumi
      real(kind=DP), allocatable :: wf1(:), wf2(:), zcos(:), zsin(:)
      real(kind=DP), allocatable :: psi1(:,:,:,:)
      real(kind=DP), allocatable :: psi2(:,:,:,:)

      nffth = nfft/2
      ngrid = product(fft_box_size_WF(1:3,1))
      dvol = 1.d0/dble(ngrid)

      allocate(wf1(nfft),wf2(nfft))
      allocate(zcos(nffth),zsin(nffth))

      call m_FFT_alloc_WF_work()

      ik_start = 1;  ik_skip = 1
      if ( .not. noncol ) then
         if ( nspin == 2 .and. spin_component_wan90 == DOWN ) then
            ik_start = 2
         endif
         if ( nspin == 2 ) ik_skip = 2
      endif

      do nn=1,nntot
        do ik1 = ik_start, kv3, ik_skip
            iktmp = ( ik1 -1 )/nspin + 1
            is1 = mod( ik1 -1, nspin ) +1

            ik2 = nspin*( nnlist(iktmp,nn) -1 ) +is1

            nnc(1:3) = nncell(1:3,iktmp,nn)

            if(all(nnc(1:3) == 0)) then
               shift_k = .false.
            else
               shift_k = .true.
             ! Phase factors, exp(iG*r)
               id1 = fft_box_size_WF(1,0)
               id2 = fft_box_size_WF(2,0)
               id12 = id1*id2
               da(1:3) = 1.d0/fft_box_size_WF(1:3,1)
               do i=1,nffth
                  ip = i-1
                  r3 = ip/id12
                  r2 = (ip-r3*id12)/id1
                  r1 = ip-r2*id1-r3*id12
                  rgrid(1) = dble(r1)*da(1)
                  rgrid(2) = dble(r2)*da(2)
                  rgrid(3) = dble(r3)*da(3)
                  ph = PAI2*dot_product(nnc,rgrid)
                  zcos(i) = cos(ph);    zsin(i) = sin(ph)
               end do
            end if
            do n=1,num_bands
               ni = ib_inc(n)

               if ( map_ek(ni,ik2) == mype ) then
                  ib2 = neordr(ni,ik2)

                  allocate( psi2(kg1,1,ik2:ik2,kimg) ); psi2 = 0.0d0
                  psi2(1:iba(ik2),1,ik2,:) = zaj_l(1:iba(ik2),map_z(ib2),ik2,:)

                  call m_ES_map_WF_on_fftmesh( ik2, ik2, ik2, psi2, wf2 )
                  deallocate(psi2)

                  if ( shift_k ) then
                     call m_FFT_WF( ELECTRON, nfout, wf2, INVERSE, ON )
                     ! u_n(k+b) = exp(-iG*r) * u_n(k')
                     ! k+b = k' + G
                     do i=1,nffth
                        ir = 2*i-1;    im = ir+1
                        wr = wf2(ir);  wi = wf2(im)
                        wf2(ir) = zcos(i)*wr + zsin(i)*wi
                        wf2(im) = zcos(i)*wi - zsin(i)*wr
                     end do
                     call m_FFT_WF( ELECTRON, nfout, wf2, DIRECT, ON )
                     wf2 = wf2 *dvol
                  end if

               endif

               call mpi_bcast( wf2, nfft, mpi_double_precision, map_ek(ni,ik2), &
                    &          mpi_comm_group, ierr )

               do m=1,num_bands
                  mi = ib_inc(m)

                  if ( map_ek(mi,ik1) /= mype ) cycle

                  ib1 = neordr(mi,ik1)

                  allocate( psi1(kg1,1,ik1:ik1,kimg) ); psi1 = 0.0d0
                  psi1(1:iba(ik1),1,ik1,:) = zaj_l(1:iba(ik1),map_z(ib1),ik1,:)

                  call m_ES_map_WF_on_fftmesh( ik1, ik1, ik1, psi1, wf1 )
                  deallocate( psi1 )

                  ! <u_m(k)|u_n(k+b)>
                  sumr = 0.d0;  sumi = 0.d0
                  do i=1,nffth
                     ir = 2*i-1;   im = ir+1
                     sumr = sumr + wf1(ir)*wf2(ir) + wf1(im)*wf2(im)
                     sumi = sumi + wf1(ir)*wf2(im) - wf1(im)*wf2(ir)
                  end do
                  m_mat(m,n,ik1,nn,1) = sumr
                  m_mat(m,n,ik1,nn,2) = sumi

               end do
            end do
         end do
      end do

      call m_FFT_dealloc_WF_work()

      deallocate(wf1,wf2);   deallocate(zcos,zsin)

    end subroutine contrib_softpart2

    subroutine contrib_softpart3          ! does not use FFT, but displace G vector
      logical :: shift_k
      integer :: i,ik1,ik2,nn,n,m,ni,mi,ib1,ib2,nnc(3),ir,im
      integer :: nffth,ip,r1,r2,r3,ngrid
      integer :: id1,id2,id12
      integer :: ik_start, ik_skip, iktmp, is1
      real(kind=DP) :: rgrid(3),da(3),wr,wi,dvol,ph,sumr,sumi
      real(kind=DP), allocatable :: wf1(:), wf2(:), zcos(:), zsin(:)
      real(kind=DP), allocatable :: psi1(:,:,:,:)
      real(kind=DP), allocatable :: psi2(:,:,:,:)

      nffth = nfft/2
      ngrid = product(fft_box_size_WF(1:3,1))
      dvol = 1.d0/dble(ngrid)

      allocate(wf1(nfft),wf2(nfft))

      ik_start = 1;  ik_skip = 1
      if ( .not. noncol ) then
         if ( nspin == 2 .and. spin_component_wan90 == DOWN ) then
            ik_start = 2
         endif
         if ( nspin == 2 ) ik_skip = 2
      endif

      do nn=1,nntot
         do ik1 = ik_start, kv3, ik_skip
            iktmp = ( ik1 -1 )/nspin + 1
            is1 = mod( ik1 -1, nspin ) +1

            ik2 = nspin*( nnlist(iktmp,nn) -1 ) +is1

            nnc(1:3) = nncell(1:3,iktmp,nn)

            do n=1,num_bands
               ni = ib_inc(n)

               if ( map_ek(ni,ik2) == mype ) then
                  ib2 = neordr(ni,ik2)

                  allocate( psi2(kg1,1,ik2:ik2,kimg) ); psi2 = 0.0d0
                  psi2(1:iba(ik2),1,ik2,:) = zaj_l(1:iba(ik2),map_z(ib2),ik2,:)

                  call m_wan90_map_WF_on_fftmesh( ik2, ik2, ik2, psi2, wf2, &
                       &                          igf_wan90(:,nnc(1),nnc(2),nnc(3))  )
                  deallocate(psi2)
               endif

               call mpi_bcast( wf2, nfft, mpi_double_precision, map_ek(ni,ik2), &
                    &          mpi_comm_group, ierr )

               do m=1,num_bands
                  mi = ib_inc(m)

                  if ( map_ek(mi,ik1) /= mype ) cycle

                  ib1 = neordr(mi,ik1)

                  allocate( psi1(kg1,1,ik1:ik1,kimg) ); psi1 = 0.0d0
                  psi1(1:iba(ik1),1,ik1,:) = zaj_l(1:iba(ik1),map_z(ib1),ik1,:)

                  call m_ES_map_WF_on_fftmesh( ik1, ik1, ik1, psi1, wf1 )
                  deallocate( psi1 )

                  ! <u_m(k)|u_n(k+b)>
                  sumr = 0.d0;  sumi = 0.d0
                  do i=1,nffth
                     ir = 2*i-1;   im = ir+1
                     sumr = sumr + wf1(ir)*wf2(ir) + wf1(im)*wf2(im)
                     sumi = sumi + wf1(ir)*wf2(im) - wf1(im)*wf2(ir)
                  end do
                  m_mat(m,n,ik1,nn,1) = sumr
                  m_mat(m,n,ik1,nn,2) = sumi

               end do
            end do
         end do
      end do
      deallocate(wf1,wf2)

    end subroutine contrib_softpart3

    subroutine contrib_hardpart
      integer :: n, nn, ik1, ik2, nnc(3)
      integer :: myindex, m, mm, ni, mi, kk
      integer :: ib1, ib2, ia, it, mdvdb
      integer :: lmt1, il1, im1, it1, lmta1
      integer :: lmt2, il2, im2, it2, lmta2
      integer :: ilm3, iiqitg, l3
      integer :: iktmp, ik_start, ik_skip, is1

      real(kind=DP) :: ylm, dk(3), c1
      complex(kind=CMPLDP) :: wf1, wf2, z1, z2, ztmp

      integer, allocatable :: il3(:)
      real(kind=DP), allocatable :: qx(:), qy(:), qz(:)
      complex(kind=CMPLDP), allocatable :: wk_fsri(:), zph(:)

! -- init
      n = nloc;   n=(n-1)+(n-1)+1
      allocate(il3(n**2));call substitute_il3(n**2,il3)
! ---
      allocate( qx(nntot), qy(nntot), qz(nntot) )
      Do nn=1, nntot
         qx(nn) = rltv(1,1) *dk_unit(1,nn) &
              & + rltv(1,2) *dk_unit(2,nn) &
              & + rltv(1,3) *dk_unit(3,nn)
         qy(nn) = rltv(2,1) *dk_unit(1,nn) &
              & + rltv(2,2) *dk_unit(2,nn) &
              & + rltv(2,3) *dk_unit(3,nn)
         qz(nn) = rltv(3,1) *dk_unit(1,nn) &
              & + rltv(3,2) *dk_unit(2,nn) &
              & + rltv(3,3) *dk_unit(3,nn)
      End do

      allocate( wk_fsri(nlmta) ); wk_fsri = 0.0d0
      allocate( zph(natm) );  zph = 0.0d0

      ik_start = 1;  ik_skip = 1
      if ( .not. noncol ) then
         if ( nspin == 2 .and. spin_component_wan90 == DOWN ) then
            ik_start = 2
         endif
         if ( nspin == 2 ) ik_skip = 2
      endif

! -- start
      Do nn=1,nntot
         do ik1 = ik_start, kv3, ik_skip
            iktmp = ( ik1 -1 )/nspin + 1
            is1 = mod( ik1 -1, nspin ) +1

            ik2 = nspin*( nnlist(iktmp,nn) -1 ) +is1

            nnc(1:3) = nncell(1:3,iktmp,nn)

            dk(1:3) = vkxyz(ik2,1:3,BUCS) +nnc(1:3) -vkxyz(ik1,1:3,BUCS)
!
            Do ia=1, natm
               c1 = PAI2 *dot_product( nnc, pos(ia,:) )
               zph(ia) = dcmplx( cos(c1), -sin(c1) )
            End Do

            myindex = 0
            mmloop : Do mm=1, nntot
               if ( abs(dk(1)-dk_unit(1,mm)) < Delta07 &
                    &  .and. abs(dk(2)-dk_unit(2,mm) ) < Delta07 &
                    &  .and. abs(dk(3)-dk_unit(3,mm) ) < Delta07 ) then
                  myindex = mm
                  exit mmloop
               endif
            end Do mmloop
            if ( myindex == 0 ) call phase_error_with_msg(nfout,"PPPP",__LINE__,__FILE__)
!
            do n=1,num_bands
               ni = ib_inc(n)

               if ( map_ek(ni,ik2) == mype ) then
                  ib2 = neordr(ni,ik2)
                  wk_fsri(:) = dcmplx( fsr_l( map_z(ib2),:,ik2 ), &
                       &               fsi_l( map_z(ib2),:,ik2 ) )
               endif
               call mpi_bcast( wk_fsri, 2*nlmta, mpi_double_precision, &
                    &          map_ek(ni,ik2), mpi_comm_group, ierr )

               do m=1,num_bands
                  mi = ib_inc(m)

                  if ( map_ek(mi,ik1) /= mype ) cycle

                  ib1 = neordr(mi,ik1)

                  Do ia=1, natm
                     it = ityp(ia)
                     mdvdb = m_PP_include_vanderbilt_pot(it)
                     if ( mdvdb == SKIP ) cycle

                     Do lmt1=1, ilmt(it)
                        il1 = ltp(lmt1,it); it1 = taup(lmt1,it)
                        lmta1 = lmta( lmt1,ia )
                        wf1 = dcmplx( fsr_l( map_z(ib1), lmta1, ik1 ), &
                             &        fsi_l( map_z(ib1), lmta1, ik1 ) )

                        Do lmt2=1, ilmt(it)
                           il2 = ltp(lmt2,it); it2 = taup(lmt2,it)
                           lmta2 = lmta( lmt2,ia )
                           wf2 = wk_fsri(lmta2)

                           ztmp = 0.0d0
                           do kk=1,il2p(lmt1,lmt2,it)
                              ilm3 = isph(lmt1,lmt2,kk,it); l3=il3(ilm3)
                              iiqitg = iqitg(il1,it1,il2,it2,l3+1,it)
                              if ( lmt1 > lmt2 ) then      ! ad hoc
                                 iiqitg = iqitg(il2,it2,il1,it1,l3+1,it)
                              endif

                              if(iiqitg == 0) cycle
                              call sphr( 1, ilm3, &
                                   &     qx(myindex), qy(myindex), qz(myindex), ylm )

                              z1 = conjg(wf1) *wf2 *(-zi)**l3 *dl2p(lmt1,lmt2,kk,it)
                              z2 = qitg_wan( iiqitg, myindex ) *ylm
                              ztmp = ztmp +z1 *z2 *zph( ia )
                           End do
                           m_mat(m,n,ik1,nn,1) = m_mat(m,n,ik1,nn,1) &
                                &              + real(ztmp)
                           m_mat(m,n,ik1,nn,2) = m_mat(m,n,ik1,nn,2) &
                                &              + aimag(ztmp)
                        End do
                     End do
                  End do
               End Do
            End DO
         End Do
      End Do

      deallocate( il3 )
      deallocate( zph );  deallocate( qx, qy, qz )

    end subroutine contrib_hardpart

    subroutine gather_matrix
      integer :: ik1
      integer :: isize, i, j, l, m
      integer :: ireqs1, ireqr1, istatus1
      integer :: ireqs2, ireqr2, istatus2

      real(kind=DP), allocatable :: wk(:,:,:,:)
      real(kind=DP), allocatable :: m_mat_mpi(:,:,:,:,:) ! d(neg,neg,kv3,nntot,2)

#ifndef WAN90_SAVE_MEMORY
      if(npes>1) then
         allocate(m_mat_mpi(num_bands,num_bands,kv3,nntot,2))
         m_mat_mpi = m_mat
         m_mat = 0.d0
         call mpi_allreduce(m_mat_mpi,m_mat,num_bands*num_bands*kv3*nntot*2,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
         deallocate(m_mat_mpi)
      end if
#else
      call mpi_barrier( mpi_comm_group, ierr )

      if ( nrank_e > 1 ) then
         allocate(m_mat_mpi(num_bands,num_bands,ista_k:iend_k,nntot,2))
         m_mat_mpi = 0.0d0

         isize = num_bands *num_bands *(iend_k-ista_k+1) *nntot *2
         call mpi_allreduce( m_mat, m_mat_mpi, isize, mpi_double_precision, &
              &              mpi_sum, mpi_k_world(myrank_k), ierr )
         m_mat = m_mat_mpi
         deallocate(m_mat_mpi)
      endif

      if ( nrank_k > 1 ) then
         if ( mype == 0 ) then
            allocate(m_mat_mpi(num_bands,num_bands,kv3,nntot,2)); m_mat_mpi = 0.0d0
         endif
         allocate( wk(num_bands,num_bands,nntot,2) )
         isize = num_bands *num_bands *nntot *2

         Do ik1=1, kv3
            if ( map_ek(1,ik1) == mype .and. mype == 0 ) then
               m_mat_mpi(:,:,ik1,:,:) = m_mat(:,:,ik1,:,:)
            else
               if ( map_ek(1,ik1) == mype ) then
                  Do i=1, 2
                     Do j=1, nntot
                        Do l=1, num_bands
                           Do m=1, num_bands
                              wk(m,l,j,i) = m_mat(m,l,ik1,j,i)
                           End do
                        End do
                     End do
                  End do

                  call mpi_isend( wk, isize, mpi_double_precision, &
                       &          0, 0, mpi_comm_group, ireqs2, ierr )
               endif
               if ( mype == 0 ) then
                  call mpi_irecv( wk, isize, mpi_double_precision, &
                       &          map_ek(1,ik1), 0, mpi_comm_group, ireqr2, ierr )
               endif
               if ( map_ek(1,ik1) == mype ) call mpi_wait(ireqs2,istatus2,ierr)
               if ( mype == 0 )          call mpi_wait(ireqr2,istatus2,ierr)

               if ( mype == 0 ) then
                  Do i=1, 2
                     Do j=1, nntot
                        Do l=1, num_bands
                           Do m=1, num_bands
                              m_mat_mpi(m,l,ik1,j,i) = wk(m,l,j,i)
                           End do
                        End do
                     End do
                  End do
               endif

            endif
         End Do
         deallocate( wk )
!
         if ( mype == 0 ) then
            deallocate( m_mat )
            allocate( m_mat(num_bands,num_bands,kv3,nntot,2)); m_mat = 0.0d0
            m_mat = m_mat_mpi
            deallocate( m_mat_mpi )
         endif
      endif
#endif
    end subroutine gather_matrix

    subroutine print_mmat
      integer :: ik1, ik2, nn, n, m
      integer :: ik_start, iktmp, is1
      integer :: nnc(3)

      if ( mype /= 0 ) return

      open(nfwannier,file=trim(wan90_seedname)//".mmn",form="formatted")
      if ( noncol ) then
         write(nfwannier,*) 'Generated by PHASE noncol'
      else
         if ( nspin == 2 ) then
            write(nfwannier,*) 'Generated by PHASE (nspin=2), comp: ', &
                 &              spin_component_wan90
         else
            write(nfwannier,*) 'Generated by PHASE'
         endif
      endif
      write(nfwannier,*) num_bands, kv3/nspin, nntot

      if ( noncol ) then
         do ik1 = 1, kv3, nspin
            iktmp = ( ik1 -1 )/nspin + 1
            is1 = mod( ik1 -1, nspin ) +1

            do nn=1,nntot
               ik2 = nnlist(iktmp,nn)
               nnc(1:3) = nncell(1:3,iktmp,nn)
               write(nfwannier,'(5(1x,i5))') iktmp, ik2, nnc(1:3)
               do n=1,num_bands
                  do m=1,num_bands
                     write(nfwannier,'(2(1x,f16.12))') m_mat(m,n,ik1,nn,1:2) &
                          &                           +m_mat(m,n,ik1+1,nn,1:2)
                  end do
               end do
            end do
         end do

      else
         ik_start = 1
         if ( nspin == 2 .and. spin_component_wan90 == DOWN ) ik_start = 2

         do ik1 = ik_start, kv3, nspin
            iktmp = ( ik1 -1 )/nspin + 1
            is1 = mod( ik1 -1, nspin ) +1

            do nn=1,nntot
               ik2 = nnlist(iktmp,nn)
               nnc(1:3) = nncell(1:3,iktmp,nn)
               write(nfwannier,'(5(1x,i5))') iktmp, ik2, nnc(1:3)
               do n=1,num_bands
                  do m=1,num_bands
                     write(nfwannier,'(2(1x,f16.12))') m_mat(m,n,ik1,nn,1:2)
                  end do
               end do
            end do
         end do
      endif

      close(nfwannier)

    end subroutine print_mmat

  end subroutine m_Wan90_gen_mmat_mpi

  subroutine m_Wan90_write_unk_mpi(nfout)
    implicit none
    integer, intent(in) :: nfout

    integer :: ispin, iksnl, ik, n, nffth, ngrid, ni, ib
    integer :: id1, id2, id3, id12, ip
    integer :: nd1, nd2, nd3
    integer :: i1, i2, i3
    integer :: ireqs, ireqr, istatus1
    character(len=10) :: wfnname

    real(kind=DP), allocatable :: wf(:)
    complex(kind=DP), allocatable :: zwf(:,:,:)

    id1 = fft_box_size_WF(1,0)
    id2 = fft_box_size_WF(2,0)
    id3 = fft_box_size_WF(3,0)
    id12 = id1 * id2

    nd1 = fft_box_size_WF(1,1)
    nd2 = fft_box_size_WF(2,1)
    nd3 = fft_box_size_WF(3,1)

    allocate(wf(nfft))
    if ( mype == 0 ) allocate(zwf(id1,id2,id3))

    do ispin = 1, nspin
       do iksnl = 1, kv3/nspin
          ik = nspin*(iksnl-1) + ispin

          if ( mype == 0 ) then
             write(wfnname,'("UNK",i5.5,".",i1)') iksnl,ispin
             open(nfwannier,file=trim(wfnname),form="unformatted")
             write(nfwannier) fft_box_size_WF(1:3,1), iksnl, num_bands
          endif

          do n=1,num_bands
             ni = ib_inc(n)

             if ( map_ek(ni,ik) == mype .and. mype == 0 ) then
                ib = neordr(ni,ik)
                call m_ES_WF_in_Rspace(ik,ib,wf)
             else
                if ( map_ek(ni,ik) == mype ) then
                   ib = neordr(ni,ik)
                   call m_ES_WF_in_Rspace(ik,ib,wf)
                   call mpi_isend( wf, nfft, mpi_double_precision, &
                        &          0, 0, mpi_comm_group, ireqs, ierr )
                endif
                if ( mype == 0 ) then
                   call mpi_irecv( wf, nfft, mpi_double_precision, &
                        &          map_ek(ni,ik), 0, mpi_comm_group, ireqr, ierr )
                endif

                if ( map_ek(ni,ik) == mype ) call mpi_wait( ireqs,istatus1,ierr )
                if ( mype == 0 ) call mpi_wait( ireqr,istatus1,ierr )
             endif

             if ( mype == 0) then
                do i3=1,nd3
                   do i2=1,nd2
                      do i1=1,nd1
                         ip = i1 + (i2-1)*id1 + (i3-1) * id12
                         zwf(i1,i2,i3) = cmplx(wf(2*ip-1),wf(2*ip))
                      end do
                   end do
                end do
                write(nfwannier) zwf
             endif
          end do
          if ( mype == 0 ) close(nfwannier)
       end do
    end do

    deallocate(wf)
    if ( allocated(zwf) ) deallocate(zwf)

  end subroutine m_Wan90_write_unk_mpi
! ============== 2015/02/23

  logical function excluding_band(m)
    implicit none
    integer, intent(in) :: m
    
    integer :: i

    do i=1,n_exclude
       if(exclude_bands(i)==m) then
          excluding_band = .true.
          return
       end if
    end do
    excluding_band = .false.
  end function excluding_band

! ==== KT_add === 2015/02/23
  subroutine m_Wan90_set_dk_wan
    integer :: ik1, ik2, nn, nnc(3)
    real(kind=DP) :: vec(3)

    allocate( dk_unit(3,nntot) );  dk_unit = 0.0d0

    ik1 = 1
    Do nn=1, nntot
       ik2 = nspin*( nnlist(ik1,nn) -1 )+1
       nnc(1:3) = nncell(1:3,ik1,nn)

       dk_unit(1:3,nn) = vkxyz(ik2,1:3,BUCS) +nnc(1:3) -vkxyz(ik1,1:3,BUCS)
!
       vec(1) = rltv(1,1) *dk_unit(1,nn) &
            & + rltv(1,2) *dk_unit(2,nn) &
            & + rltv(1,3) *dk_unit(3,nn)
       vec(2) = rltv(2,1) *dk_unit(1,nn) &
            & + rltv(2,2) *dk_unit(2,nn) &
            & + rltv(2,3) *dk_unit(3,nn)
       vec(3) = rltv(3,1) *dk_unit(1,nn) &
            & + rltv(3,2) *dk_unit(2,nn) &
            & + rltv(3,3) *dk_unit(3,nn)
       dk_wan(nn) = sqrt( dot_product( vec(:), vec(:) ) )
    End Do
  end subroutine m_Wan90_set_dk_wan

  subroutine deompose_sphr_into_lm( l, m, vec )
    integer, intent(in) :: l, m
    real(kind=DP), intent(out) :: vec(16)
!
!    assuming xaxis and azxis  are default
!
    vec = 0.0d0

    if ( l == 0 ) then
       if ( m == 1 ) vec(1) = 1.0d0   ! s
    endif
    if ( l == 1 ) then
       if ( m == 1 ) vec(4) = 1.0d0   ! pz
       if ( m == 2 ) vec(2) = 1.0d0   ! px
       if ( m == 3 ) vec(3) = 1.0d0   ! py
    endif
    if ( l == 2 ) then
       if ( m == 1 ) vec(5) = 1.0d0   ! dz2
       if ( m == 2 ) vec(9) = 1.0d0   ! dzx
       if ( m == 3 ) vec(8) = 1.0d0   ! dyz
       if ( m == 4 ) vec(6) = 1.0d0   ! dx2-y2
       if ( m == 5 ) vec(7) = 1.0d0   ! dxy
    endif
    if ( l == 3 ) then
       if ( m == 1 ) vec(10) = 1.0d0   ! fz3
       if ( m == 2 ) vec(11) = 1.0d0   ! fxz2
       if ( m == 3 ) vec(12) = 1.0d0   ! fyz2
       if ( m == 4 ) vec(13) = 1.0d0   ! fz(x2-y2)
       if ( m == 5 ) vec(14) = 1.0d0   ! fxyz
       if ( m == 6 ) vec(15) = 1.0d0   ! fx(x2-3y2)
       if ( m == 7 ) vec(16) = 1.0d0   ! fy(3x2-y2)
    endif
    if ( l == -1 ) then
       if ( m == 1 ) then            ! sp-1
          vec(1) = 1.0d0 /sqrt(2.0d0)   ! s
          vec(2) = vec(1)               ! px
       endif
       if ( m == 2 ) then            ! sp-2
          vec(1) = 1.0d0 /sqrt(2.0d0)   ! s
          vec(2) = -vec(1)              ! px
       endif
    endif
    if ( l == -2 ) then
       if ( m == 1 ) then            ! sp2-1
          vec(1) =  1.0d0 /sqrt(3.0d0)   ! s
          vec(2) = -1.0d0 /sqrt(6.0d0)   ! px
          vec(3) =  1.0d0 /sqrt(2.0d0)   ! py
       endif
       if ( m == 2 ) then            ! sp2-2
          vec(1) =  1.0d0 /sqrt(3.0d0)   ! s
          vec(2) = -1.0d0 /sqrt(6.0d0)   ! px
          vec(3) = -1.0d0 /sqrt(2.0d0)   ! py
       endif
       if ( m == 3 ) then            ! sp2-3
          vec(1) =  1.0d0 /sqrt(3.0d0)   ! s
          vec(2) =  2.0d0 /sqrt(6.0d0)   ! px
       endif
    endif
    if ( l == -3 ) then
       if ( m == 1 ) then     ! sp3-1
          vec(1) =  1.0d0 /2.0d0    ! s
          vec(2) =  1.0d0 /2.0d0    ! px
          vec(3) =  1.0d0 /2.0d0    ! py
          vec(4) =  1.0d0 /2.0d0    ! pz
       endif
       if ( m == 2 ) then     ! sp3-2
          vec(1) =  1.0d0 /2.0d0    ! s
          vec(2) =  1.0d0 /2.0d0    ! px
          vec(3) = -1.0d0 /2.0d0    ! py
          vec(4) = -1.0d0 /2.0d0    ! pz
       endif
       if ( m == 3 ) then     ! sp3-3
          vec(1) =  1.0d0 /2.0d0    ! s
          vec(2) = -1.0d0 /2.0d0    ! px
          vec(3) =  1.0d0 /2.0d0    ! py
          vec(4) = -1.0d0 /2.0d0    ! pz
       endif
       if ( m == 4 ) then     ! sp3-4
          vec(1) =  1.0d0 /2.0d0    ! s
          vec(2) = -1.0d0 /2.0d0    ! px
          vec(3) = -1.0d0 /2.0d0    ! py
          vec(4) =  1.0d0 /2.0d0    ! pz
       endif
    endif
    if ( l == -4 ) then
       if ( m == 1 ) then      ! sp3d-1
          vec(1) =  1.0d0 /sqrt(3.0d0)
          vec(2) = -1.0d0 /sqrt(6.0d0)
          vec(3) =  1.0d0 /sqrt(2.0d0)
       endif
       if ( m == 2 ) then      ! sp3d-2
          vec(1) =  1.0d0 /sqrt(3.0d0)
          vec(2) = -1.0d0 /sqrt(6.0d0)
          vec(3) = -1.0d0 /sqrt(2.0d0)
       endif
       if ( m == 3 ) then      ! sp3d-3
          vec(1) =  1.0d0 /sqrt(3.0d0)
          vec(2) =  2.0d0 /sqrt(6.0d0)
       endif
       if ( m == 4 ) then      ! sp3d-4
          vec(4) =  1.0d0 /sqrt(2.0d0)
          vec(5) =  1.0d0 /sqrt(2.0d0)
       endif
       if ( m == 5 ) then      ! sp3d-5
          vec(4) = -1.0d0 /sqrt(2.0d0)
          vec(5) =  1.0d0 /sqrt(2.0d0)
       endif
    endif
    if ( l == -5 ) then
       if ( m == 1 ) then      ! sp3d2-1
          vec(1) =  1.0d0 /sqrt(6.0d0)
          vec(2) = -1.0d0 /sqrt(2.0d0)
          vec(5) = -1.0d0 /sqrt(12.0d0)
          vec(6) =  1.0d0 /2.0d0
       endif
       if ( m == 2 ) then      ! sp3d2-2
          vec(1) =  1.0d0 /sqrt(6.0d0)
          vec(2) =  1.0d0 /sqrt(2.0d0)
          vec(5) = -1.0d0 /sqrt(12.0d0)
          vec(6) =  1.0d0 /2.0d0
       endif
       if ( m == 3 ) then      ! sp3d2-3
          vec(1) =  1.0d0 /sqrt(6.0d0)
          vec(2) = -1.0d0 /sqrt(2.0d0)
          vec(5) = -1.0d0 /sqrt(12.0d0)
          vec(6) = -1.0d0 /2.0d0
       endif
       if ( m == 4 ) then      ! sp3d2-4
          vec(1) =  1.0d0 /sqrt(6.0d0)
          vec(2) =  1.0d0 /sqrt(2.0d0)
          vec(5) = -1.0d0 /sqrt(12.0d0)
          vec(6) = -1.0d0 /2.0d0
       endif
       if ( m == 5 ) then      ! sp3d2-5
          vec(1) =  1.0d0 /sqrt(6.0d0)
          vec(4) = -1.0d0 /sqrt(2.0d0)
          vec(5) =  1.0d0 /sqrt(3.0d0)
       endif
       if ( m == 6 ) then      ! sp3d2-6
          vec(1) =  1.0d0 /sqrt(6.0d0)
          vec(4) =  1.0d0 /sqrt(2.0d0)
          vec(5) =  1.0d0 /sqrt(3.0d0)
       endif
    endif
  end subroutine deompose_sphr_into_lm
! =========== 2015/02/23

! ==== KT_add === 2015/09/04
  subroutine m_Wan90_gen_mat_spn
    integer :: npauli = 3

    complex(kind=CMPLDP), allocatable :: spn_mat(:,:,:,:) ! d(neg,neg,kv3/nspin,3)

    allocate( spn_mat( npauli, num_bands, num_bands, kv3/ndim_spinor) ); spn_mat = 0.d0

    call contrib_softpart
    if ( sw_use_hardpart_wan90 == ON ) call contrib_hardpart

    call gather_matrix
    call print_mat

    deallocate( spn_mat )

  contains

    subroutine contrib_softpart
      integer :: ik0, ik1, ik2, iktmp, is1, is2
      integer :: ig
      integer :: m, mi, n, ni, ib1, ib2
      complex(kind=CMPLDP) :: zsum

      real(kind=DP), allocatable :: wk_zaj(:,:)
      real(kind=DP) :: c1, c2
      complex(kind=CMPLDP) :: z1, z2

      allocate( wk_zaj( kg1, kimg ) ); wk_zaj = 0.0d0

      do ik0=1, kv3, ndim_spinor
         if ( map_k(ik0) /= myrank_k ) cycle

         iktmp = ( ik0 -1 )/ndim_spinor +1

         Do is2=1, ndim_spinor
            ik2 = ik0 +is2 -1

            Do n=1, num_bands
               ni = ib_inc(n)
               ib2 = neordr(ni,ik2)

               if ( map_e(ib2) == myrank_e ) then
                  wk_zaj(1:iba(ik2),1:kimg) = zaj_l(1:iba(ik2),map_z(ib2),ik2,1:kimg)
               endif
               call mpi_bcast( wk_zaj, kg1*kimg, mpi_double_precision, map_e(ib2), &
                    &          mpi_k_world(myrank_k), ierr )

               Do is1=1, ndim_spinor
                  ik1 = ik0 +is1 -1
               
                  do m=1,num_bands
                     mi = ib_inc(m)
                     ib1 = neordr(mi,ik1)

                     if ( map_e(ib1) /= myrank_e ) cycle

                     zsum = 0.0d0

                     if ( kimg == 1 ) then
                        Do ig=1, iba(ik0)
                           c1 = zaj_l(ig,map_z(ib1),ik1,1)
                           c2 = c1 *wk_zaj(ig,1)
                           zsum = zsum +c2
                        End do
                     else
                        Do ig=1, iba(ik0)
                           z1 = dcmplx( zaj_l(ig,map_z(ib1),ik1,1), &
                                &       zaj_l(ig,map_z(ib1),ik1,2) )
                           z2 = conjg(z1) *dcmplx( wk_zaj(ig,1), wk_zaj(ig,2) )
                           zsum = zsum +z2
                        End Do
                     endif
!
                     if ( is1 == 1 .and. is2 == 1 ) then
                        spn_mat(3,m,n,iktmp) = spn_mat(3,m,n,iktmp) +zsum
                     else if ( is1 == 1 .and. is2 == 2 ) then
                        spn_mat(1,m,n,iktmp) = spn_mat(1,m,n,iktmp) +zsum
                        spn_mat(2,m,n,iktmp) = spn_mat(2,m,n,iktmp) -zsum *zi
                     else if ( is1 == 2 .and. is2 == 1 ) then
                        spn_mat(1,m,n,iktmp) = spn_mat(1,m,n,iktmp) +zsum
                        spn_mat(2,m,n,iktmp) = spn_mat(2,m,n,iktmp) +zsum *zi
                     else if ( is1 == 2 .and. is2 == 2 ) then
                        spn_mat(3,m,n,iktmp) = spn_mat(3,m,n,iktmp) -zsum
                     endif

                  end do
               end Do
            end do
         end do
      end do

    end subroutine contrib_softpart

    subroutine contrib_hardpart
      integer :: ik0, ik1, ik2, iktmp, is1, is2
      integer :: mi, m, ni, n, ib1, ib2
      integer :: ia, it, mdvdb, lmt1, lmt2, il1, il2, it1, it2
      integer :: lmta1, lmta2
      complex(kind=CMPLDP) :: zsum, wf1, wf2
      complex(kind=CMPLDP), allocatable :: wk_fsri(:)

      allocate( wk_fsri(nlmta) ); wk_fsri = 0.0d0

! -- start
      Do ik0=1, kv3, ndim_spinor
         if ( map_k(ik0) /= myrank_k ) cycle

         iktmp = ( ik0 -1 )/ndim_spinor +1

         Do is2=1, ndim_spinor
            ik2 = ik0 +is2 -1

            do n=1,num_bands
               ni = ib_inc(n)
               ib2 = neordr(ni,ik2)

               if ( map_e(ib2) == mype ) then
                  wk_fsri(:) = dcmplx( fsr_l( map_z(ib2),:,ik2 ), &
                       &               fsi_l( map_z(ib2),:,ik2 ) )
               endif
               call mpi_bcast( wk_fsri, 2*nlmta, mpi_double_precision, &
                    &          map_e(ib2), mpi_k_world(myrank_k), ierr )

               Do is1=1, ndim_spinor
                  ik1 = ik0 +is1 -1

                  do m=1,num_bands
                     mi = ib_inc(m)
                     ib1 = neordr(mi,ik1)

                     if ( map_e(ib1) /= myrank_e ) cycle
                     
                     zsum = 0.d0

                     Do ia=1, natm
                        it = ityp(ia)
                        mdvdb = m_PP_include_vanderbilt_pot(it)
                        if ( mdvdb == SKIP ) cycle

                        Do lmt1=1, ilmt(it)
                           il1 = ltp(lmt1,it); it1 = taup(lmt1,it)
                           lmta1 = lmta( lmt1,ia )
                           wf1 = dcmplx( fsr_l( map_z(ib1), lmta1, ik1 ), &
                                &        fsi_l( map_z(ib1), lmta1, ik1 ) )

                           Do lmt2=1, ilmt(it)
                              il2 = ltp(lmt2,it); it2 = taup(lmt2,it)
                              lmta2 = lmta( lmt2,ia )
                              wf2 = wk_fsri(lmta2)

                              zsum = zsum +conjg(wf1) * wf2 *q(lmt1,lmt2,it)
                           End do
                        End Do
                     End Do

                     if ( is1 == 1 .and. is2 == 1 ) then
                        spn_mat(3,m,n,iktmp) = spn_mat(3,m,n,iktmp) +zsum
                     else if ( is1 == 1 .and. is2 == 2 ) then
                        spn_mat(1,m,n,iktmp) = spn_mat(1,m,n,iktmp) +zsum
                        spn_mat(2,m,n,iktmp) = spn_mat(2,m,n,iktmp) -zsum *zi
                     else if ( is1 == 2 .and. is2 == 1 ) then
                        spn_mat(1,m,n,iktmp) = spn_mat(1,m,n,iktmp) +zsum
                        spn_mat(2,m,n,iktmp) = spn_mat(2,m,n,iktmp) +zsum *zi
                     else if ( is1 == 2 .and. is2 == 2 ) then
                        spn_mat(3,m,n,iktmp) = spn_mat(3,m,n,iktmp) -zsum
                     endif

                  End do
               End Do
            End DO
         End Do
      End Do

      deallocate( wk_fsri )

    end subroutine contrib_hardpart

    subroutine gather_matrix
      complex(kind=CMPLDP), allocatable :: spn_mat_mpi(:,:,:,:) ! d(neg,neg,kv3/nspin,3)

      if (npes>1) then
         allocate(spn_mat_mpi(npauli,num_bands,num_bands,kv3/nspin) )
         spn_mat_mpi = spn_mat
         spn_mat = 0.d0
         call mpi_allreduce( spn_mat_mpi, spn_mat, &
              &              num_bands*num_bands*kv3/nspin*npauli*2, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group,ierr )
         deallocate(spn_mat_mpi)
      end if

      call mpi_barrier( mpi_comm_world, ierr )

    end subroutine gather_matrix

    subroutine print_mat
      integer :: ik, mi, ni, ispn, num, nsize
      complex(kind=CMPLDP), allocatable :: work(:,:)

      if ( mype /= 0 ) return

      open(nfwannier,file=trim(wan90_seedname)//".spn",form="formatted")

#ifdef WAN90_SPN_FORMATTED
      write(nfwannier,*) 'Generated by PHASE noncol'
      write(nfwannier,*) num_bands, kv3/nspin

      do ik=1, kv3/nspin
         Do mi=1, num_bands
            Do ni=1, mi
               Do ispn=1, 3
                  write(nfwannier,'(2f16.12)') spn_mat(ispn,mi,ni,ik)
               End Do
            End Do
         End do
      end do
#else
      write(nfwannier) 'Generated by PHASE noncol'
      write(nfwannier) num_bands, kv3/nspin
      
      nsize = num_bands *( num_bands +1 ) /2
      allocate( work(3, nsize) ); work = 0.0d0

      Do ik=1, kv3/nspin
         num = 0
         Do mi=1, num_bands
            Do ni=1, mi
               num = num +1
               work(:,num) = spn_mat(:,mi,ni,ik)
            End Do
         End Do
         write(nfwannier) ( (work(ispn,mi),ispn=1,3), mi=1, nsize )
      End do
      deallocate( work  )
#endif

      close(nfwannier)

    end subroutine print_mat

  end subroutine m_Wan90_gen_mat_spn
! ================== 2015/09/04

! ==== KT_add ==== 2015/09/14
  subroutine m_Wan90_set_igf_wan90
    integer :: id, i
    integer :: igf1, igf2, igf3
    integer :: nx, ny, nz
    integer :: nxmin, nymin, nzmin, nxmax, nymax, nzmax
!
    nxmin = minval( nncell(1,:,:) );   nxmax = maxval( nncell(1,:,:) );  
    nymin = minval( nncell(2,:,:) );   nymax = maxval( nncell(2,:,:) );  
    nzmin = minval( nncell(3,:,:) );   nzmax = maxval( nncell(3,:,:) );  

    allocate( igf_wan90( kg, nxmin:nxmax, nymin:nymax, nzmin:nzmax ) )
    igf_wan90 = 0
!
    id = fft_box_size_WF(1,0)

    Do nx=nxmin, nxmax
       Do ny=nymin, nymax
          Do nz=nzmin, nzmax

             do i = 1, kg
                igf1 = ngabc(i,1) + 1 -nx
                igf2 = ngabc(i,2) + 1 -ny
                igf3 = ngabc(i,3) + 1 -nz
!
                if ( igf1 <= 0 ) igf1 = igf1 + fft_box_size_WF(1,1)
                if ( igf2 <= 0 ) igf2 = igf2 + fft_box_size_WF(2,1)
                if ( igf3 <= 0 ) igf3 = igf3 + fft_box_size_WF(3,1)

                igf_wan90(i,nx,ny,nz) = igf1 + (igf2-1)*id &
                     &                 + (igf3-1)*id*fft_box_size_WF(2,0)
             enddo
          End Do
       End Do
    End Do
  end subroutine m_Wan90_set_igf_wan90

  subroutine m_Wan90_map_WF_on_fftmesh(k1,k2,ik,psi_l,bfft,igf_in)
    integer, intent(in) :: k1,k2,ik
    integer, intent(in) :: igf_in(kg1)
    real(kind=DP), intent(in),dimension(kg1,1,k1:k2,kimg) :: psi_l
    real(kind=DP), intent(inout), dimension(nfft) :: bfft

    integer :: i,i1,ri, j, i2, ii

    bfft = 0.d0
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          i1 = igf_in(1)
          bfft(i1) = psi_l(1,1,ik,1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
             i = nbase(ii,ik)
             i1 = igf_in(i)
             bfft(i1) = psi_l(ii,1,ik,1)
             j = nbase_gamma(ii,2)
             i2 = igf_in(j)
             bfft(i2) =   psi_l(ii,1,ik,1)
          end do
       else if(kimg == 2) then
          i1 = 2*igf_in(1) - 1
          bfft(i1)   = psi_l(1,1,ik,1)
          bfft(i1+1) = psi_l(1,1,ik,2)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
             i = nbase(ii,ik)
             i1 = 2*igf_in(i)-1
             bfft(i1  ) = psi_l(ii,1,ik,1)
             bfft(i1+1) = psi_l(ii,1,ik,2)
             j = nbase_gamma(ii,2)
             i2 = 2*igf_in(j)-1
             bfft(i2  ) = psi_l(ii,1,ik,1)
             bfft(i2+1) = -psi_l(ii,1,ik,2)
          end do
       end if
    else
#ifdef NEC_TUNE_SMP
!CDIR NOLOOPCHG
#endif
       do ri = 1, kimg
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do i = 1, iba(ik)
             i1 = kimg*igf_in(nbase(i,ik)) + (ri - kimg)
             bfft(i1) = psi_l(i,1,ik,ri)   ! MPI
          end do
       end do
    end if
  end subroutine m_Wan90_map_WF_on_fftmesh
! ===== 2015/09/14

end module m_Wannier90

!   Multi Replica
!   Nudged Elastic Band Method
!   Nobutaka Nishikawa

module m_Replica

  use m_Ionic_System,  only : number_of_replicas
  use m_Const_Parameters,   only : DP

  type unit_cell_type

     real(kind=DP)  a, b, c, alpha, beta, gamma

  end type unit_cell_type

  type symm_type
    integer :: nopr
    real(kind=DP),pointer,dimension(:,:,:) :: op
    real(kind=DP),pointer,dimension(:,:,:) :: tau
  end type symm_type

  type image_type

     integer num_atom

     type(unit_cell_type)  unit_cell
     type(symm_type) symmetry

     real(kind=DP),pointer,dimension(:,:) :: pos, pos0, cps, cps0
     real(kind=DP),pointer,dimension(:,:) :: velocity, velocity0
     real(kind=DP),pointer,dimension(:,:) :: force, force0
     real(kind=DP),pointer,dimension(:,:) :: force_org, true_force, spring_force, tau

     real(kind=DP)  energy, energy0
     !real(8)  total_energy
     !real(8)  potential_energy

     real(8)  k_spring, k_spring0

     integer, pointer :: fix_flag(:)

     logical scf_convergence

  end type image_type

  type neb_cond_type

     integer  condition
     integer  ci_neb_start, ci_neb_end
     integer :: ci_index
     real(kind=8) :: ci_thres
     real(kind=8) :: sd_factor

     logical  climbing_image
     real(8)  k_spring_init, k_spring_min, k_spring_max

     logical k_constant
     logical k_variable
     logical k_damping
     real(8) k_damping_factor

     logical penalty_function

     integer convergence_condition
     real(8) convergence_threshold

     character(20) time_integral

     logical :: end0_energy_given
     logical :: end1_energy_given

     real(kind=8) :: dimer_thres

  end type neb_cond_type

  type neb_file_type

     character(100)  F_OUT
     character(100)  F_DYNM
     character(100)  F_ENF
     character(100)  F_CHGT
     character(100)  F_CNTN
     character(100)  F_CNTN_BIN
     character(100)  F_ZAJ
     character(100)  F_CHR

     character(100)  F_NEB_OUT

! ======================== KT_add ================= 13.0D
     character(100)  F_CNTN_BIN_PAW
! ================================================= 13.0D

     character(100)  F_OCCMAT

  end type neb_file_type

  type neb_type

     integer  number_of_images
     integer  max_iteration

     type(image_type), pointer :: image(:)
     type(neb_cond_type) :: cond
     type(neb_file_type) :: file

     integer  step
     real(kind=DP)  time
     real(kind=DP)  dt

     ! temporary
     real(kind=DP),pointer,dimension(:,:) :: energy

  end type neb_type

  type(neb_type)  neb
  integer nrank_r, mype_r
  integer, allocatable :: npes_image(:)

  logical :: first_replica_done = .false.
  real(kind=DP) :: curr_thres = 1e+30
  logical :: changed_to_cineb=.false.

  integer :: nopr_lowest
  real(kind=DP), allocatable, dimension(:,:,:) :: op_lowest,tau_lowest

  contains

  subroutine m_Replica_resolve_lowest_symmetry(nfneb)
    integer, intent(in) :: nfneb
    integer :: i,j,k,l,m,n,currindex,currsize
    integer :: icount
    real(kind=DP), allocatable, dimension(:,:,:) :: opbuf,taubuf

    currsize = neb%image(1)%symmetry%nopr
    allocate(opbuf(3,3,currsize))
    allocate(taubuf(3,currsize,2))
    allocate(op_lowest(3,3,currsize));op_lowest=neb%image(1)%symmetry%op
    allocate(tau_lowest(3,currsize,2));tau_lowest=neb%image(1)%symmetry%tau
    do i=2,neb%number_of_images
       currindex=0
       do j=1,currsize
          kloop:do k=1,neb%image(i)%symmetry%nopr
             icount = 0
             do m=1,3
                if (epsilon_equals(tau_lowest(m,j,1),neb%image(i)%symmetry%tau(m,k,1))) then
                   icount = icount+1 
                endif
                if (epsilon_equals(tau_lowest(m,j,2),neb%image(i)%symmetry%tau(m,k,2))) then
                   icount = icount+1 
                endif
                do l=1,3
                   if (epsilon_equals(op_lowest(l,m,j),neb%image(i)%symmetry%op(l,m,k))) then
                      icount = icount+1 
                   endif
                enddo
             enddo
             if (icount==15) then
               currindex = currindex+1
               opbuf(:,:,currindex) = op_lowest(:,:,j)
               taubuf(:,currindex,:) = tau_lowest(:,j,:)
               exit kloop
             endif
          enddo kloop
       enddo
       currsize = currindex
       do j=1,currsize
          op_lowest(:,:,j) = opbuf(:,:,j)
          tau_lowest(:,j,:) = taubuf(:,j,:)
       enddo
    enddo
    nopr_lowest = currsize

    write(nfneb,*) 'nopr ',nopr_lowest
    do i=1,nopr_lowest
       write(nfneb,*) 'op no. ',i
       do j=1,3
          write(nfneb,'(3f10.5)') op_lowest(j,1:3,i)
       enddo
       write(nfneb,*) 'tau no. ',i
       write(nfneb,'(6f10.5)') tau_lowest(1:3,i,1),tau_lowest(1:3,i,2)
    enddo
    deallocate(opbuf)
    deallocate(taubuf)

    contains 

    logical function epsilon_equals(a,b)
        real(kind=DP), intent(in) :: a,b
        real(kind=DP) :: eps = 1.d-8
        epsilon_equals = abs(a-b)<eps
    end function epsilon_equals

  end subroutine m_Replica_resolve_lowest_symmetry

  subroutine m_Replica_finalize()
    integer :: i,j
    do i=1,neb%number_of_images
      deallocate(neb%image(i)%pos)
      deallocate(neb%image(i)%pos0)
      deallocate(neb%image(i)%cps)
      deallocate(neb%image(i)%cps0)
      deallocate(neb%image(i)%tau)
      deallocate(neb%image(i)%force)
      deallocate(neb%image(i)%force0)
      deallocate(neb%image(i)%force_org)
      deallocate(neb%image(i)%spring_force)
      deallocate(neb%image(i)%true_force)
      deallocate(neb%image(i)%fix_flag)
      deallocate(neb%image(i)%velocity)
      deallocate(neb%image(i)%velocity0)
      deallocate(neb%image(i)%symmetry%op)
      deallocate(neb%image(i)%symmetry%tau)
    enddo
!!    deallocate(neb%energy)
    deallocate(neb%image)
  end subroutine m_Replica_finalize

  logical function FirstReplicaDone()
    FirstReplicaDone = first_replica_done
  end function FirstReplicaDone

  function get_max_force(neb,i,mode) result(fmax)
    type(neb_type), intent(in) :: neb
    integer, intent(in) :: i
    character(len=*), intent(in) :: mode
    real(kind=8) :: ftmp,fmax
    integer :: j
    fmax = 0.d0
    do j=1, neb%image(i)%num_atom
      if(neb%image(i)%fix_flag(j)==0)cycle
      if (mode=='true') then
      ftmp = dsqrt(dot_product(neb%image(i)%true_force(j,:),neb%image(i)%true_force(j,:)))
      else if (mode == 'org') then
      ftmp = dsqrt(dot_product(neb%image(i)%force_org(j,:),neb%image(i)%force_org(j,:)))
      else
      ftmp = dsqrt(dot_product(neb%image(i)%force(j,:),neb%image(i)%force(j,:)))
      endif
      if(fmax < ftmp) fmax=ftmp
    enddo
  end function get_max_force

end module m_Replica

!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
! Functions:  [Identifier: 13.1R]
!            Dielectric functions can be calculated when condition = INITIAL 
!
! Functions:  [Identifier: 13.1XI]
!            Dielectric functions can be calculated in the EXCITATION module
!
! =============================================================
subroutine Epsilon_Postscf

  use m_Const_Parameters, only : ON
  use m_Control_Parameters,  only : sw_phonon_with_epsilon, sw_excitation
  use m_Epsilon_ek,  only : sw_epsilon, auto_mode

  implicit none

     if(auto_mode/=0) sw_epsilon = on
!  if ( sw_phonon_with_epsilon == ON ) then
     if ( sw_epsilon == ON ) then
        call using_epsilon_ek
     else if ( sw_excitation == ON ) then
        call using_excitation
     endif
!  else
!     if ( sw_excitation == ON ) call using_excitation
!     if ( sw_epsilon == ON )    call using_epsilon_ek
!  endif


end subroutine Epsilon_Postscf

subroutine using_epsilon_ek

  use m_Control_Parameters, only : sw_phonon_with_epsilon
  use m_Const_Parameters,  only : on

  use m_KPoints, only : kv3, kv3_ek, m_Kp_cp_vkxyz_to_vkxyz_ek, &
       &                m_Kp_alloc_kpoints_ek
  use m_IterationNumbers, only : nk_in_the_process, nk_converged
!
  use m_Electronic_Structure, only : m_ES_cp_eko_l_to_eko_ek2, &
       &                             m_ES_alloc_eko_ek

  use m_Epsilon_ek,  only : set_dielectric_tensor
  use m_Raman,  only : m_Raman_write_dielec_tensors

  implicit none

  logical, save :: FirstFlag = .true.

  nk_in_the_process = 1
  nk_converged = kv3

  call m_Kp_alloc_kpoints_ek
  call m_Kp_cp_vkxyz_to_vkxyz_ek
  call m_ES_alloc_eko_ek
  call m_ES_cp_eko_l_to_eko_ek2
!
  if ( FirstFlag ) then
     call Initialization_Epsilon(0)
     FirstFlag = .false.
  else
     call Initialization_Epsilon(1)
  endif

  call Transition_moment_Epsilon
  call Prep_for_Calc_Epsilon
  call Calc_Epsilon
  call Calc_Nonlinear_optics

  if ( sw_phonon_with_epsilon  == ON ) then
     call set_dielectric_tensor
     call m_Raman_write_dielec_tensors
  else
     call WriteDownData_onto_Files_Eps
  endif

end subroutine Using_epsilon_ek

subroutine using_excitation
  use m_Const_Parameters,  only : ON, OFF, CMPLDP
  use m_Control_Parameters,  only : sw_phonon_with_epsilon, sw_use_add_proj, &
       &                            sw_corelevel_spectrum

  use m_Excitation,  only : m_XI_set_ilmt_val, m_XI_init_spectrum, &
       &                    m_XI_set_ngpt_XI, &
       &                    m_XI_set_qitg_XI_vv, &
       &                    m_XI_set_dl2p_XI_vv, &
       &                    m_XI_set_mat_dipole_corr_vv, &
       &                    m_XI_calc_transition_moment_vv, &
       &                    m_XI_set_RhoTilde_vv, &
       &                    m_XI_calc_spectr_fn_vv, &
       &                    m_XI_calc_spectr_tensor_vv, &
       &                    SpectrFn_vv, SpectrTensor_vv, &
       &                    m_XI_set_qitg_XI_vc, &
       &                    m_XI_set_dl2p_XI_vc, &
       &                    m_XI_set_ilmt_core, &
       &                    m_XI_set_mat_dipole_corr_vc, &
       &                    m_XI_calc_transition_moment_vc,  &
       &                    m_XI_set_RhoTilde_vc, &
       &                    m_XI_calc_spectr_fn_vc, &
       &                    m_XI_calc_transition_moment_cc,  &
       &                    m_XI_set_RhoTilde_cc, &
       &                    m_XI_dealloc_arrays, &
       &                    SpectrFn_vc, &
       &                    nstep, e_step, sw_tddft, sw_bse, &
       &                    Kernel_Coulomb, m_XI_set_Kernel_Coulomb, epsinv_omega0, &
       &                    sw_spin_decomposition, m_XI_calc_spectr_fn_vv_spindec, &
       &                    sw_write_wavederf_file, m_XI_wd_WAVEDERF

  use m_ValenceBand_Spectrum,  only : m_VBS_set_data_ppc_from_pp
  use m_CoreLevel_Spectrum,   only : m_CLS_set_data_core2val_from_pp, &
       &                             m_CLS_alloc_wfn_core_states, &
       &                             m_CLS_set_wfn_core_states, &
       &                             m_CLS_set_corelevels_virtually, &
       &                             m_CLS_set_ene_core_states

  use m_ES_nonlocal,    only : m_ES_add_betar_dot_WFs
  use m_Files,  only : nfout
  use m_Raman,  only : dielectric, m_Raman_write_dielec_tensors
  use m_Kpoints,  only : m_Kp_set_star_of_k

  implicit none

  if ( sw_phonon_with_epsilon == ON ) then        ! nmax_G == 1
     call case_phonon_with_epsilon
  else
     call case_epsilon_fn
  endif

contains

  subroutine case_phonon_with_epsilon
    logical :: First = .true.

    if ( First ) then
       call m_Kp_set_star_of_k
       call m_XI_set_ilmt_val
       call m_VBS_set_data_ppc_from_pp
       call m_XI_set_mat_dipole_corr_vv
       call m_XI_init_spectrum
       First = .false.
    endif

    if ( sw_use_add_proj == ON ) call m_ES_add_betar_dot_WFs(nfout)

    call m_XI_calc_transition_moment_vv
    call m_XI_calc_spectr_tensor_vv

#ifdef USE_ASMS_EXCITATION
    call ASMS_XI_set_dielectric_tensor( SpectrTensor_vv, dielectric )
#endif

    call m_Raman_write_dielec_tensors

  end subroutine case_phonon_with_epsilon

  subroutine case_epsilon_fn
    integer :: i

    logical :: First = .true.

    if ( First ) then
       if ( sw_write_wavederf_file == OFF ) call m_Kp_set_star_of_k
       call m_XI_set_ilmt_val
       call m_XI_set_ngpt_XI
!
       if ( sw_corelevel_spectrum == ON ) then
          call m_CLS_set_data_core2val_from_pp
          call m_CLS_alloc_wfn_core_states( .true. )
          call m_CLS_set_wfn_core_states( .true. )
!          call m_CLS_set_corelevels_virtually
          call m_CLS_set_ene_core_states
          call m_XI_set_ilmt_core
          call m_XI_set_mat_dipole_corr_vc
!
          call m_XI_set_qitg_XI_vc
          call m_XI_set_dl2p_XI_vc

          if ( sw_bse == ON ) then
             call m_VBS_set_data_ppc_from_pp
             call m_XI_set_mat_dipole_corr_vv
          endif
       else
          call m_XI_set_qitg_XI_vv
          call m_XI_set_dl2p_XI_vv
          call m_VBS_set_data_ppc_from_pp
          call m_XI_set_mat_dipole_corr_vv
       endif

       if ( sw_write_wavederf_file == OFF ) call m_XI_init_spectrum
       First = .false.
    endif

    if ( sw_use_add_proj == ON ) call m_ES_add_betar_dot_WFs(nfout)

    if ( sw_corelevel_spectrum == ON ) then
       if ( sw_bse == ON ) then
          call m_XI_calc_transition_moment_vv
          call m_XI_calc_transition_moment_vc
          call m_XI_calc_transition_moment_cc
          call m_XI_set_RhoTilde_vv
          call m_XI_set_RhoTilde_vc
          call m_XI_set_RhoTilde_cc

          call m_XI_calc_spectr_fn_vv
          call m_XI_set_Kernel_Coulomb
#ifdef USE_ASMS_EXCITATION
          call ASMS_XI_epsinv_omg0_fr_spctrfn( SpectrFn_vv, Kernel_Coulomb, &
               &                               epsinv_omega0 )
#endif

       else if ( sw_tddft == ON ) then
          call m_XI_calc_transition_moment_vc
          call m_XI_set_RhoTilde_vc
          call m_XI_calc_spectr_fn_vc
          call m_XI_set_Kernel_Coulomb
#ifdef USE_ASMS_EXCITATION
          call ASMS_XI_calc_tddft_spectrum( SpectrFn_vc, Kernel_Coulomb )
#endif
       else
          call m_XI_calc_transition_moment_vc
          call m_XI_calc_spectr_fn_vc
#ifdef USE_ASMS_EXCITATION
          call ASMS_XI_calc_indep_spectrum( SpectrFn_vc )
#endif
       endif

    else
       if ( sw_bse == ON ) then
          call m_XI_calc_transition_moment_vv
          call m_XI_set_RhoTilde_vv
          call m_XI_calc_spectr_fn_vv
          call m_XI_set_Kernel_Coulomb
#ifdef USE_ASMS_EXCITATION
          call ASMS_XI_epsinv_omg0_fr_spctrfn( SpectrFn_vv, Kernel_Coulomb, &
               &                               epsinv_omega0 )
#endif
          stop "PPP"
       else if ( sw_tddft == ON ) then
          call m_XI_calc_transition_moment_vv
          call m_XI_set_RhoTilde_vv

!!          call m_XI_calc_spectr_fn_vv
          if ( sw_spin_decomposition == ON ) then
             call m_XI_calc_spectr_fn_vv_spindec
          else
             call m_XI_calc_spectr_fn_vv
          endif

          call m_XI_set_Kernel_Coulomb
#ifdef USE_ASMS_EXCITATION
          call ASMS_XI_calc_tddft_spectrum( SpectrFn_vv, Kernel_Coulomb )
#endif
       else
          if ( sw_write_wavederf_file == ON ) then
             call m_XI_wd_WAVEDERF
          else
             call m_XI_calc_transition_moment_vv
!!            call m_XI_calc_spectr_fn_vv
             if ( sw_spin_decomposition == ON ) then
                call m_XI_calc_spectr_fn_vv_spindec
             else
                call m_XI_calc_spectr_fn_vv
             endif
#ifdef USE_ASMS_EXCITATION
             call ASMS_XI_calc_indep_spectrum( SpectrFn_vv )
#endif
          endif
       endif
    endif

  end subroutine case_epsilon_fn

end subroutine Using_excitation

         subroutine eigen_sx( n, nvec, a, lda, w, z, ldz,
     &                        m_forward, m_backward )
         use eigen_devel
         implicit NONE
*-
         integer, intent(in)    :: n, nvec, lda, ldz
         integer, intent(in), optional :: m_forward, m_backward
         real(8), intent(inout) :: a(lda,*)
         real(8), intent(out)   :: w(*), z(ldz,*)
         real(8), pointer       :: d(:), e(:), e2(:)
*-
         real(8)                :: hs0, hs1, s0, s1
         real(8)                :: ret, ret_1, ret_2, ret_3
         integer                :: m0, nb, nme
         integer                :: my_rank, world_size, INFO
*-
#if TIMER_PRINT
         hs0 = eigen_get_wtime()
#endif
*-
         nme = ((n-1)/2+1)*2
         allocate( d(1:n), e(1:nme*2), e2(1:nme*2) )
*-
         world_size = TRD_nnod
         my_rank    = TRD_inod-1
*-
#if TIMER_PRINT
         s0 = eigen_get_wtime( )
#endif

        if ( PRESENT( m_forward ) ) then
            m0 = m_forward
        else
            m0 = 48
        end if

            call eigen_prd( n, a(1,1), lda, d(1), e(1), nme, m0 )

#if TIMER_PRINT
         s1 = eigen_get_wtime( )
         if(my_rank==0)then
            ret_1 = dble(n)**3*4/3
            print*,"TRD-BLK", n, s1-s0, 1D-9*ret_1/(s1-s0), "GFLOPS"
            print*,"TRD-BLK-INFO",n," ",m0
         endif
         call flush(6)
#endif
*-
#if TIMER_PRINT
         s0 = eigen_get_wtime( )
#endif

            e2(0*nme+1:0*nme+N-1) = e(0*nme+2:0*nme+N)
            e2(0*nme+N) = 0
            e2(1*nme+1:1*nme+N-2) = e(1*nme+3:1*nme+N)
            e2(1*nme+N-1) = 0
            e2(1*nme+N) = 0
            w(1:n)=d(1:n)

            call eigen_dcx( n, w, e2, nme, z, ldz, INFO, ret_2 )

#if TIMER_PRINT
         s1 = eigen_get_wtime( )
         if(my_rank==0)then
            print*,"D&C", s1-s0, 1D-9*ret_2/(s1-s0), "GFLOPS"
         endif
         call flush(6)
#endif
*-
#if TIMER_PRINT
         s0 = eigen_get_wtime( )
#endif

        if ( PRESENT( m_backward ) ) then
            m0 = m_backward
        else
            m0 = 128
        end if

            nb = MBAND

            call eigen_trbakwyx( n, nvec, a(1,1), lda, z(1,1), ldz,
     $                   e(1+nme), m0, nb )

#if TIMER_PRINT
         s1 = eigen_get_wtime( )
         if(my_rank==0)then
            ret_3 = 2*dble(nvec)*dble(n)**2
            print*,"TRDBAK", n, s1-s0, 1D-9*ret_3/(s1-s0), "GFLOPS"
         endif
         call flush(6)
#endif
*-
#if TIMER_PRINT
         hs1 = eigen_get_wtime ( )
#endif
*
#if TIMER_PRINT
         if(my_rank==0)then
            ret = ret_1 + ret_2 + ret_3
            print*,"Total", hs1-hs0, 1D-9*ret/(hs1-hs0), "GFLOPS"
         endif
         call flush(6)
#endif
*-
         deallocate( d, e, e2 )
*-
         end subroutine  eigen_sx

!#========================================================================
!#                                                                       #
!# Software Name : PHASE/0 2019.01                                       #
!#                                                                       #
!#      Function    : EPS_prep_check                                     #
!#                                                                       #
!#                                Written by T. Hamada 2021/9/28         #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
   logical function EPS_Prep_Check()
     use m_Epsilon_ek,            only : kpt_file_mode
     use m_Parallelization,    only : mype,mpi_comm_group
     implicit none
     EPS_Prep_Check = .false.
     if(kpt_file_mode == 3) EPS_Prep_Check = .true.
   end function EPS_Prep_Check

!m_container_psicoef::eigenenergyに格納されたエネルギー準位の縮退度を求める
!Copyright (C) 2014-2015 Ryosuke Tomita

module m_degeneracy
#include "defines.F"
  use m_commons, only: nearlyEquals
  use m_container_commons, only: energy_tag, degeneracy, psicoef_t, max_num_deg_band
  use m_container_psicoef, only: num_energy_max, UP, DOWN, e_tag
  implicit none

  DOUBLE_T, parameter, private:: DEGENERACY_PRECISION = 0.001/27.2116
  integer, private:: num_energy, nspin
!一つのk点における準位の数(縮退したバンドを一つと数える、以下これを縮退点と呼ぶ)
  type(degeneracy), allocatable, target, private::deg(:,:)
!あるk点におけるバンド全体の縮退点の総数(1:nspin)
  integer, private:: num_energy_point(2)

contains
!データのリセット
  subroutine delete_degeneracy
    num_energy_point(1:2) = 0
    deallocate(deg)
  end subroutine delete_degeneracy

!縮退点の数を決定する
  subroutine new_degeneracy(num_energy_t, nspin_t, e_tag_t, is_contains_multirep)
    integer, intent(in):: num_energy_t, nspin_t
!2015/02/16 理由は不明だが、下記のe_tag引数に入っているはずのダウンスピン軌道の固有値がすべて0となってしまう。弥縫策としてcontainer_psicoefのe_tag変数をpublicにして、ここで使用する。
    type(energy_tag), intent(in):: e_tag_t(num_energy_t,nspin_t)
    logical, intent(in):: is_contains_multirep!k点の群が二次元以上の表現をもつかどうか
    integer:: ie, je, is
    
    num_energy = num_energy_t
    nspin = nspin_t
    allocate(deg(num_energy,nspin))
    deg(1:num_energy,1:nspin)%ne = 0
    num_energy_point(1:2) = 0

!一番上の縮退点
#define DEGCUR deg(num_energy_point(is),is)

!k点の群が一次元の表現のみをもつとき、すべての状態が分裂しているものとみなす。
    if(.not.is_contains_multirep) then
       do is = 1, nspin
          do ie = 1, num_energy
!縮退点の総数を加算
             num_energy_point(is) = num_energy_point(is) + 1
!縮退度を1に設定
             DEGCUR%ne = 1
!縮退点に含まれる準位にieを追加
             DEGCUR%ie(1) = ie
          end do
       end do
       return
    end if
    
    do is = 1, nspin
       ie = 1
!バンドを1からループ
       do while(ie <= num_energy)
!縮退点の総数を加算
          num_energy_point(is) = num_energy_point(is) + 1
!縮退度を1に設定
          DEGCUR%ne = 1
!縮退点に含まれる準位にieを追加
          DEGCUR%ie(DEGCUR%ne) = ie
          je = ie + 1
!ieより上に存在するバンドのループ
          do while(je <= num_energy)
!ieとjeが縮退しているとき、現在の縮退点の縮退度をインクリメントし、縮退点に含まれる準位にjeを追加する
!ieとjeが縮退していないとき、次のieのループがje+1から始まるようにする
             if((DEGCUR%ne < max_num_deg_band) .and.&
                  isDeg(ie,is,je,is)) then!縮退するとき
                DEGCUR%ne = DEGCUR%ne + 1
                DEGCUR%ie(DEGCUR%ne) = je
                if(je == num_energy) go to 20
                je = je + 1
             else!縮退しないとき
                ie = je
                go to 30
             end if
          end do
          ie = ie + 1
30        continue
       end do
20     continue
    end do
#undef DEGCUR
  contains
!準位(ie,ispin)と(je,jspin)が縮退しているとき.true.、していないとき.false.を返す
    logical function isDeg(ie, ispin, je, jspin)
      integer, intent(in):: ie, ispin, je, jspin
      isDeg = nearlyEquals(e_tag(ie,ispin)%hartree,&
           e_tag(je,jspin)%hartree,&
           DEGENERACY_PRECISION)
    end function isDeg
  end subroutine new_degeneracy

!縮退度の出力
  subroutine print_degeneracy(nfout)
    integer, intent(in):: nfout!出力装置番号
    integer:: ideg, is
    write(nfout, *) '!print_degeneracy'
    do is = 1, nspin
       do ideg = 1, num_energy_point(is)
          write(nfout, fmt = '(2(I0,1X))') ideg, deg(ideg,is)%ne
       end do
    end do
  end subroutine print_degeneracy

!波動関数の構造体に縮退度の情報を追加
  subroutine set_degeneracy(ps_t)
    type(psicoef_t), target, intent(out):: ps_t
    ps_t%num_deg_point = num_energy_point
    ps_t%deg => deg
  end subroutine set_degeneracy
end module m_degeneracy

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 599 $)
!
!  PROGRAM: EPSMAIN
!
!  AUTHOR(S): T. Hamada   MAY/8/2007
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is the main program for caclulating spectra based on the LR-TDDFT .
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

program LinearResponseMain

  use m_LinearResponse_Control, only : sw_tddft, sw_LinearResponse, sw_LongWaveLimit,&
       &                               xc_kernel_type, ALDA_R, &
       &                               tddft_eqn_type, DYSON, BS
  use m_Control_Parameters,   only : Num_q_Points 

  implicit none

  logical  :: EigenValues_are_Converged, AllKpoints_are_Calculated
  logical  :: Already_Converged
  logical  :: Ending_Time

  logical  :: all_conv = .true.
  logical  :: Additional_EndFlag = .false.

  integer i

!!  write(*,*) 'First  ', Additional_EndFlag

  call Initialization_set_ekmode_ON  ! set `ekmode' ON in m_Control_Parameters
  call Initialization(1)                ! Initialization of mpi and file-setting
  call InputData_Analysis
  Call InputData_Analysis_LR
  if ( sw_LinearResponse==1 )  Call Gen_q_Points

!--
  call Preparation(0)                ! Basis set, symmetry check etc.
  call Preparation_for_mpi(1)           ! mpi

  call PseudoPotential_Construction
  call Ewald_and_Structure_Factor    ! Calculate Structure Factor

  call Initial_Electronic_Structure()! read Charge Density, (lclchh)

  call Initialization_LR

! -------------------------- kokoga memory kuu --
  call Initialization_Spectrum
  if ( sw_LinearResponse==1 ) then
     Call Alloc_WorkArray_LR1
     Call Alloc_WorkArray_LR2
  endif
  Additional_EndFlag = .false.
!
! ------------------------------------- main -----------
  KPOINTS: do
     call KpointNumber_Setting()
     call Preparation_ek             ! (basnum)
     call Preparation_for_mpi_ek     ! mpi  -> np_g1k, mp_g1k
     call PseudoPotential_ek_Epsilon ! (kbint)                  ! Epsilon
     call Initial_WaveFunctions_ek   ! (rndzaj|rdzaj),(fsrfsi),(lclchh)

     if(.not.Already_Converged()) then
        all_conv = .false.
        SolveWaveFunctions: do
           if(Ending_Time())                 exit KPOINTS
           call IterationNumber_Setting()
           call Renewal_of_WaveFunctions()
           if(EigenValues_are_Converged())   exit SolveWaveFunctions
        enddo SolveWaveFunctions
     else
        exit KPOINTS
     end if
     Call Copy_Wfn_etc_To_WorkArray( 0 ) 

     if ( sw_LongWaveLimit==1 ) then
        Call Calc_RhoTilde_LWLimit
        if ( tddft_eqn_type == DYSON .and. xc_kernel_type == ALDA_R ) then
           call Calc_MatrixG_LWLimit
        endif
     else
        call Calc_Band_Q_Nonzero( Additional_EndFlag )
        if ( Additional_EndFlag ) then
           exit KPOINTS
        endif
        Call Calc_RhoTilde_General
        if ( tddft_eqn_type == DYSON .and. xc_kernel_type == ALDA_R ) then
           call Calc_MatrixG_General
        endif
     endif
! ===============================================
100  continue 
!
     if(AllKpoints_are_Calculated())   then
        all_conv = .true.
        exit KPOINTS
     endif

  End do KPOINTS
!  stop
!! ----
  if ( tddft_eqn_type == BS ) then
     Call Calc_Spectrum_Mol
  else
     Call Calc_Spectrum
  endif
  call Free_WorkArray_LR1
! =============
  call Postprocessing(.false.)
  call WriteDownData_onto_Files_ek()
! ---
  call Free_WorkArray_LR2

999 continue

  if ( sw_LinearResponse==1 ) then
     call Finalization_LR
     call Finalization_Spectrum
     Call Del_q_points
  endif
  call Finalization_of_mpi           ! mpi

contains

  subroutine Calc_Band_Q_Nonzero( EndFlag )
    logical, intent(inout) :: EndFlag 
    integer  :: nq

    Do nq=1, Num_Q_Points
!============================================= k - q ======== 
       call KpointNumber_Setting()
       call Preparation_ek             ! (basnum)
       call Preparation_for_mpi_ek     ! mpi  -> np_g1k, mp_g1k
       call PseudoPotential_ek_Epsilon ! (kbint)                  ! Epsilon
       call Initial_WaveFunctions_ek   ! (rndzaj|rdzaj),(fsrfsi),(lclchh)
       
       if(.not.Already_Converged()) then
          all_conv = .false.
          SolveWaveFunctions2: do
             if(Ending_Time())   then
                EndFlag = .true.
                return
             endif
             call IterationNumber_Setting()
             call Renewal_of_WaveFunctions()
             if (EigenValues_are_Converged()) then
                exit SolveWaveFunctions2
             endif
          enddo SolveWaveFunctions2
       else
          ENDFlag = .true.
          return
       end if
       ! --------
       Call Copy_Wfn_etc_To_WorkArray( 1 )
!       write(*,*) 'nk _ in _ the pro d = ', nk_in_the_process, ENDFLAG
    End do
  end subroutine Calc_Band_Q_Nonzero

end program LinearResponseMain

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: Renewal_of_pWaveFunctions
!
!  AUTHOR(S): M. Saito, T. Yamasaki   November/04/2003
!  
!  FURTHER MODIFICATION: M. Saito, March/26/2007
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!

logical function pEigenValues_are_Converged()
  use m_Files, only :                   nfout
  use m_IterationNumbers, only :        iteration_positron_wf
  use m_Control_Parameters, only :      ipripositron, pev_max_iteration
  use m_Positron_Wave_Functions, only : m_pWF_pevdff, m_pWF_wd_pev
  implicit none
  pEigenValues_are_Converged = m_pWF_pevdff()

  if(pEigenValues_are_Converged) then
     if(ipripositron >= 1) &
          & write(nfout,'(" Positron Wave Functions have converged at ",i7," -th iteration")') &
          & iteration_positron_wf
     call m_pWF_wd_pev(nfout)
  else if(iteration_positron_wf >= pev_max_iteration) then
     if(ipripositron >= 1) then
        write(nfout,'(" Positron Wave Functions have not converged")')
        write(nfout,'(" iteration_positrion_wf have reached to pev_max_iteration (= ",i5," )")') &
             & pev_max_iteration
     end if
     call m_pWF_wd_pev(nfout)
     pEigenValues_are_Converged = .true.
  end if

end function pEigenValues_are_Converged


integer function what_is_the_pcore_solver(isolver)
  use m_Const_Parameters,  only : lmSD, SD, lmMSD, MSD, lmCG, CG
  integer, intent(in) :: isolver

  if(isolver == lmSD) then
     what_is_the_pcore_solver = SD
  else if(isolver == lmMSD) then
     what_is_the_pcore_solver = MSD
!!$  else if(isolver == lmCG) then
!!$     what_is_the_core_solver = CG
  else
     what_is_the_pcore_solver = MSD
  end if
end function what_is_the_pcore_solver

!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.00                                       #
!#                                                                       #
!#      Sub Routine : Prep_for_Calc_Epsilon                              #
!#                                                                       #
!#                                Written by T. Hamada 2006/4/28         #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
! $Id: Preparation_for_Calc_Epsilon.f90 593 2019-06-20 03:47:31Z jkoga $
subroutine Prep_for_Calc_Epsilon
  use m_Epsilon_ek,      only : gen_k_points_eps_ek, calc_tm_square_eps_ek

  implicit none

  call gen_k_points_eps_ek
  call calc_tm_square_eps_ek
end subroutine Prep_for_Calc_Epsilon

       subroutine CSTAB_get_optdim(n_min, n_unroll,
     &                             delta_L1, delta_L2, n_opt)
       implicit none

       integer                :: n_min, n_unroll, delta_L1, delta_L2
       integer                :: n_opt, n_delta
       integer                :: n_opt2, n_delta2

       include 'CSTAB.h'

       integer                :: i,j,k
       logical                :: stable


       n_opt=n_min
       do

          n_opt   = (n_opt-1)/L1_WINDOW+1
          n_opt   = (n_opt/2)*2+1
          n_opt   = n_opt*L1_WINDOW

          stable  = .TRUE.
          n_delta = 0

          do i=1,INT((n_unroll*1.2-1.0)/L1_WAY+1)

             k=mod(i*n_opt+L1_LSIZE/2,L1_LSIZE)-L1_LSIZE/2
             if(abs(k)<=delta_L1/2)then
                n_delta=(delta_L1/2-k-1)/i+1
                stable = .FALSE.
                goto 10000
             end if

          end do

          do i=1,INT((n_unroll*1.2-1.0)/L2_WAY+1)

             k=mod(i*n_opt+L2_LSIZE/2,L2_LSIZE)-L2_LSIZE/2
             if(abs(k)<=delta_L2/2)then
                n_delta=(delta_L2/2-k-1)/i+1
                stable = .FALSE.
                goto 10000
             end if

          end do

10000     continue

          if ( stable ) exit
          if ( n_delta <= 0 ) n_delta = L1_WINDOW

          n_opt = n_opt + n_delta

       end do

       return
       end subroutine

       subroutine CSTAB_adjust_base(a,b,offset)
       implicit none

       real(8)                :: a(*), b(*)
       integer                :: offset

       include 'CSTAB.h'


       call get_delta(a(1),b(1),offset)
       offset=(offset/8)

       if(offset>0)then
         offset=MOD(L2_LSIZE-MOD(+offset,L2_LSIZE),L2_LSIZE)
       else
         offset=MOD(L2_LSIZE+MOD(-offset,L2_LSIZE),L2_LSIZE)
       endif

       return
       end subroutine
!
       subroutine CSTAB_adjust_page(a,b,offset)
       implicit none

       real(8)                :: a(*), b(*)
       integer                :: offset

       include 'CSTAB.h'


       call get_delta(a(1),b(1),offset)
       offset=(offset/8)
       if(offset>0)then
         offset=MOD(PAGE_LSIZE-MOD(+offset,PAGE_LSIZE),PAGE_LSIZE)
       else
         offset=MOD(PAGE_LSIZE+MOD(-offset,PAGE_LSIZE),PAGE_LSIZE)
       endif

       return
       end subroutine
!
       subroutine CSTAB_round_offset(offset)
       implicit none

       integer                :: offset

       include 'CSTAB.h'

       offset=MOD(offset,L2_LSIZE)

       return
       end subroutine
!

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: Gauss_Legendre
!
!  AUTHOR: Takenori Yamamotoi   June/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
! coded by Takenori YAMAMOTO (Univ. Tokyo) at Jun. 1, 2004
!
subroutine Gauss_Legendre(x,w,n)
! $Id: Real_space_integ.f90 570 2017-04-21 20:34:50Z yamasaki $
implicit none
!
! int root(1-x**2) * f(x) dex = sum_{i} w_i * f(x_i)
!
integer, intent(in) :: n
real(kind=8), intent(out) :: x(n),w(n)

integer, parameter :: itermax = 100
real(kind=8), parameter :: eps = 3.d-14

integer :: i,j,iter,m
real(kind=8) :: z,z1,p1,p2,p3,pp
logical :: conv

m=(n+1)/2

!!! write(*,'("m=",i3)') m

do i=1,m
   z = cos(4.d0*atan(1.d0)*(i-0.25d0)/(n+0.5d0))
   do iter=1,itermax
      p1=1.d0
      p2=0.d0
      do j=1,n
         p3=p2
         p2=p1
         p1=((2.d0*j-1.d0)*z*p2-(j-1.d0)*p3)/j
      end do
      pp=n*(z*p1-p2)/(z*z-1.d0)
      z1 = z
      z = z1 - p1/pp
      ! debug
      !  write(*,*) 'i=',i,'iter=',iter,' z=',z
      ! end debug
      if(abs(z-z1) <= eps) then
         conv = .true.
         exit
      end if
   end do
   if(.not.conv) write(6,*) 'too many iterations in Gauss_Legendre'
   x(i) = -z
   x(n+1-i) = z
   w(i) = 2.d0/((1.d0-z*z)*pp*pp)
   w(n+1-i) = w(i)
end do
      
end subroutine Gauss_Legendre

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: int_spherical_surf
!
!  AUTHOR: Takenori Yamamotoi   June/01/2004
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================
!
! coded by Takenori YAMAMOTO (Univ. Tokyo) at Jun. 1, 2004
!
subroutine int_spherical_surf(lmax,nmax,n,x,y,z,w)
! $Id: Real_space_integ.f90 570 2017-04-21 20:34:50Z yamasaki $
!
!  Int F(x,y,z) dOmega = sum_i w(i) * F(x(i),y(i),z(i))
!  ( x^2 + y^2 + z^2 = 1 )
!
!  nt = 1 + int(3*lmax/2)
!  np = 1 + 3*lmax
!  n = np*nt
!
implicit none
integer, intent(in) :: lmax,nmax
integer, intent(out) :: n
real(kind=8), intent(out) :: x(nmax),y(nmax),z(nmax),w(nmax)

integer :: i,j,m,nt,np
real(kind=8), allocatable :: xt(:),wt(:)
real(kind=8) :: pi,wp,dt,dp,p

nt = 1+int(3*lmax/2)
np = 1+3*lmax
n  = nt*np

if(nmax < n) call phase_error_with_msg(6,'nmax is too samll.',__LINE__,__FILE__)

allocate(xt(nt),wt(nt))

call Gauss_Legendre(xt,wt,nt)
! debug
!write(*,'("debug: nt=",i3))') nt
!do i=1,nt
!  write(*,'("debug:",2(1x,f10.5))') xt(i),wt(i)
!end do
! end debug

pi = 4.d0*atan(1.d0)
wp = 2.d0*pi/dble(np)
dp = 2.d0*pi/dble(np)

do i=1,nt
   do j=1,np
      m = (j-1)*nt + (i-1) + 1
      p = dp*(j-1)
      x(m)=sin(acos(xt(i)))*cos(p)
      y(m)=sin(acos(xt(i)))*sin(p)
      z(m)=xt(i)
      w(m)=wt(i)*wp
   end do
end do

deallocate(xt)
deallocate(wt)

end subroutine int_spherical_surf

      SUBROUTINE LAPACK_EIGEN2(N_GLOBAL, N, HBW, ID, D, E, LDE, Q, LDQ)
      implicit NONE

      INTEGER, intent(IN)    :: N_GLOBAL, N, HBW, ID, LDE, LDQ
      REAL(8), intent(INOUT) :: D(*), E(LDE,*), Q(LDQ,*)

      INTEGER :: i, j, info, lwork, liwork
      REAL(8) :: temp
      REAL(8), POINTER :: work(:)
      INTEGER, POINTER :: iwork(:)
      CHARACTER*1 :: JOBU, JOBVT

      DO J=1,N
      DO I=1,N
         Q(I,J)=0.0D0
      ENDDO
      ENDDO

      DO I=1,N
         Q(I,I)=D(I)
      ENDDO

      DO J=1,HBW
      DO I=1,N-J
         Q(I,I+J)=E(I,J)
         Q(I+J,I)=E(I,J)
      ENDDO
      ENDDO

      JOBU = 'V'; JOBVT= 'U'

      lwork = -1
      liwork = -1

      call dsyevd(JOBU, JOBVT, N, Q, LDQ, D(1),
     &            temp, lwork, i, liwork, info)

      lwork  = int(temp)
      liwork = i;

      allocate ( work(lwork), iwork(liwork) )

      call dsyevd(JOBU, JOBVT, N, Q, LDQ, D(1),
     &             work, lwork, iwork, liwork, info)

      deallocate ( work, iwork )

      END SUBROUTINE LAPACK_EIGEN2

!--
       subroutine send_dbl( buf, n, idest, icom )
       use MPI
       implicit NONE

       integer, intent(in)    :: n, idest, icom
       real(8), intent(inout) :: buf(1:n)

       integer                :: ierr


          call MPI_Send( buf, n, MPI_DOUBLE_PRECISION,
     &                  idest-1, 1, icom, ierr )


       return
       end subroutine  send_dbl
!--
       subroutine send_dblt( buf, n, idest, itag, icom )
       use MPI
       implicit NONE

       integer, intent(in)    :: n, idest, itag, icom
       real(8), intent(inout) :: buf(1:n)

       integer                :: ierr


          call MPI_Send( buf, n, MPI_DOUBLE_PRECISION,
     &                  idest-1, itag, icom, ierr )


       return
       end subroutine  send_dblt
!--
       subroutine isend_dbl( buf, n, idest, ireq, icom )
       use MPI
       implicit NONE

       integer, intent(in)    :: n, idest, icom
       integer, intent(inout) :: ireq
       real(8), intent(inout) :: buf(1:n)

       integer                :: ierr


          call MPI_Isend( buf, n, MPI_DOUBLE_PRECISION,
     &                   idest-1, 1, icom, ireq, ierr )


       return
       end subroutine  isend_dbl
!--
       subroutine isend_dblt( buf, n, idest, itag, ireq, icom )
       use MPI
       implicit NONE

       integer, intent(in)    :: n, idest, itag, icom
       integer, intent(inout) :: ireq
       real(8), intent(inout) :: buf(1:n)

       integer                :: ierr


          call MPI_Isend( buf, n, MPI_DOUBLE_PRECISION,
     &                   idest-1, itag, icom, ireq, ierr )


       return
       end subroutine  isend_dblt
!--
       subroutine recv_dbl( buf, n, isrc, icom )
       use MPI
       implicit NONE

       integer, intent(in)    :: n, isrc, icom
       real(8), intent(inout) :: buf(1:n)

       integer                :: ierr


          call MPI_Recv( buf, n, MPI_DOUBLE_PRECISION,
     &                  isrc-1, 1, icom, MPI_STATUS_IGNORE, ierr )


       return
       end subroutine  recv_dbl
!--
       subroutine recv_dblt( buf, n, isrc, itag, icom )
       use MPI
       implicit NONE

       integer, intent(in)    :: n, isrc, itag, icom
       real(8), intent(inout) :: buf(1:n)

       integer                :: ierr


          call MPI_Recv( buf, n, MPI_DOUBLE_PRECISION,
     &                  isrc-1, itag, icom, MPI_STATUS_IGNORE, ierr )


       return
       end subroutine  recv_dblt
!--
       subroutine irecv_dbl( buf, n, isrc, ireq, icom )
       use MPI
       implicit NONE

       integer, intent(in)    :: n, isrc, icom
       integer, intent(inout) :: ireq
       real(8), intent(inout) :: buf(1:n)

       integer                :: ierr


          call MPI_Irecv( buf, n, MPI_DOUBLE_PRECISION,
     &                   isrc-1, 1, icom, ireq, ierr )


       return
       end subroutine  irecv_dbl
!--
       subroutine irecv_dblt( buf, n, isrc, itag, ireq, icom )
       use MPI
       implicit NONE

       integer, intent(in)    :: n, isrc, itag, icom
       integer, intent(inout) :: ireq
       real(8), intent(inout) :: buf(1:n)

       integer                :: ierr


          call MPI_Irecv( buf, n, MPI_DOUBLE_PRECISION,
     &                   isrc-1, itag, icom, ireq, ierr )


       return
       end subroutine  irecv_dblt
!--
       subroutine wait_dbl( ireq )
       use MPI
       implicit NONE

       integer, intent(inout) :: ireq

       integer                :: ierr


          call MPI_Wait( ireq, MPI_STATUS_IGNORE, ierr )


       return
       end subroutine  wait_dbl
!--
       subroutine waitall_dbl( n, ireq )
       use MPI
       implicit NONE

       integer, intent(in   ) :: n
       integer, intent(inout) :: ireq(n)

       integer                :: ierr


          call MPI_Waitall( n, ireq, MPI_STATUSES_IGNORE, ierr )


       return
       end subroutine  waitall_dbl
!--
       subroutine barrier( icom )
       use MPI
       implicit NONE

       integer, intent(in)    :: icom

       integer                :: ierr


          call MPI_Barrier( icom, ierr )


       return
       end subroutine  barrier
!--
       subroutine bcast_dbl( buf, n, iroot, icom )
       use MPI
       use eigen_devel
       implicit NONE

       integer, intent(in)    :: n, iroot, icom
       real(8), intent(inout) :: buf(1:n)

       integer                :: ierr, i, j, k, tag
       integer, parameter     :: BCAST_TAG = 100000

       real(8) :: d1,d2

       integer :: my_rank, world_size, local_rank
       integer, pointer :: ireq(:)


          d1 = eigen_get_wtime( )

! On Fujitsu K and FX10 computers, the following message dividing
! on broadcasting reduces the unexpectd communication overhead
! when the message size exeeds 4096, somehow.

#if defined(__INTEL_COMPILER)
          call MPI_Bcast( buf, n, MPI_DOUBLE_PRECISION,
     &                   iroot-1, icom, ierr )
#else
       if ( icom == TRD_COMM_WORLD .OR. n <= 4096 ) then

          do i=1,n,4096
             j = MIN(n-i+1, 4096)
             call MPI_Bcast( buf(i), j, MPI_DOUBLE_PRECISION,
     &                      iroot-1, icom, ierr )
          end do

       else

          call MPI_Comm_rank( icom, my_rank, ierr )
          my_rank = my_rank + 1
          call MPI_Comm_size( icom, world_size, ierr )

#if 0
!
! Sequential algorithm
!
          if ( iroot == my_rank ) then
             allocate( ireq(1:world_size) )
             j = 0
             do i=1, world_size
                if ( i /= iroot ) then
                   j = j + 1
                   call isend_dblt( buf, n, i, i, ireq(j), icom )
                end if
             end do
             if ( j > 0 ) then
                call waitall_dbl( j, ireq )
             end if
             deallocate( ireq )
          else
             call recv_dblt( buf, n, iroot, my_rank, icom )
          end if
#else
!
! Binomial algorithm
!
          local_rank = MOD(world_size+my_rank-iroot, world_size) ! relative rank
          allocate( ireq(1:world_size) )
          i=1; j=0
          do
             if ( i >= world_size ) exit
             if ( local_rank < i ) then
                if ( local_rank+i < world_size ) then
                   k = MOD(my_rank+i-1, world_size)+1
                   j = j + 1
                   tag = BCAST_TAG + k
                   call isend_dblt( buf, n, k, tag, ireq(j), icom )
                end if
             else if ( local_rank < 2*i ) then
                   k = MOD(world_size+my_rank-i-1, world_size)+1
                   tag = BCAST_TAG + my_rank
                   call recv_dblt( buf, n, k, tag, icom )
             end if
             i = i * 2
          end do
          if ( j > 0 ) then
             call waitall_dbl( j, ireq )
          end if
          deallocate( ireq )
#endif

       end if
#endif

          d2 = eigen_get_wtime( )
          time_bcast = time_bcast + (d2-d1)


       return
       end subroutine  bcast_dbl
!--
       subroutine bcastw_dbl( buf, n, iroot, lda, px, buffer, icom )
       use MPI
       use eigen_devel
       implicit NONE

       integer, intent(in)    :: n, iroot, lda, px, icom
       real(8), intent(inout) :: buf(1:lda, 1:px)
       real(8), intent(out)   :: buffer(1:n, *)

       integer                :: ierr, i, j, k, tag
       integer, parameter     :: BCASTW_TAG = 200000

       real(8) :: d1,d2
       real(8) :: t1,t2

       integer :: my_rank, world_size, local_rank, new_type
       integer, pointer :: ireq(:)


          d1 = eigen_get_wtime( )
          if ( px == 1 ) then
             call bcast_dbl( buf, n, iroot, icom )
          else

             call MPI_Comm_size( icom, world_size, ierr )

             if ( n <= 4096 .OR. world_size < 64/px ) then
                do i=0,px-1
                   k = MOD((iroot)-1+(i), world_size)+1
                   call bcast_dbl( buf(1,i+1), n, k, icom )
                end do
                return
             end if

             call MPI_Comm_rank( icom, my_rank, ierr )
             my_rank = my_rank + 1

             allocate( ireq(1:world_size) )

             local_rank = MOD(world_size+my_rank-iroot, world_size)

             if ( local_rank ==0 ) then
                do i = 1, px-1
                   k = MOD(iroot+(i)-1, world_size)+1
                   tag = BCASTW_TAG + k
                   call irecv_dblt(buffer(1,i+1), n, k, tag,
     &                             ireq(i), icom)
                end do
                buffer(1:n, 1) = buf(1:n, 1)
                call waitall_dbl( px-1, ireq )
             else
                if ( local_rank < px ) then
                   i = local_rank + 1
                   tag = BCASTW_TAG + my_rank
                   call isend_dblt(buf(1,i), n, iroot, tag,
     &                             ireq(1), icom)
                end if
             end if

          t1 = eigen_get_wtime( )
             call bcast_dbl( buffer, n*px, iroot, icom )
          t2 = eigen_get_wtime( )

             do i=0, px-1
                if ( i /= local_rank ) then
                   buf(1:n, i+1) = buffer(1:n, i+1)
                end if
             end do

             if ( local_rank /=0 ) then
                if ( local_rank < px ) then
                   call wait_dbl( ireq(1) )
                end if
             end if

             deallocate( ireq )

          end if
          d2 = eigen_get_wtime( )
          time_bcast = time_bcast+(d2-d1)-(t2-t1)


       return
       end subroutine  bcastw_dbl
!--
       subroutine reduce_dbl( buf, wrk, n, dist, icom )
       use MPI
       use eigen_devel
       implicit NONE

       integer, intent(in)    :: n, dist, icom
       real(8), intent(inout) :: buf(1:n), wrk(1:n)

       integer                :: ierr, i, j

       real(8) :: d1,d2


          d1 = eigen_get_wtime( )

          call MPI_Allreduce( buf, wrk, n, MPI_DOUBLE_PRECISION,
     &                       MPI_SUM, icom, ierr )
          buf(1:n) = wrk(1:n)

          d2 = eigen_get_wtime( )
          time_reduce = time_reduce + (d2-d1)


       return
       end subroutine  reduce_dbl
!--
       subroutine allgather_dbl( buf, wrk, n, icom )
       use MPI
       use eigen_devel
       implicit NONE

       integer, intent(in)    :: n, icom
       real(8), intent(inout) :: buf(1:n), wrk(1:n)

       integer                :: ierr, i, j

       real(8) :: d1,d2


          d1 = eigen_get_wtime( )

          call MPI_Allgather(buf, n, MPI_DOUBLE_PRECISION,
     &                       wrk, n, MPI_DOUBLE_PRECISION,
     &                       icom, ierr)

          d2 = eigen_get_wtime( )
          time_gather = time_gather + (d2-d1)


       return
       end subroutine  allgather_dbl
!--
       subroutine datacast_dbl( u_y, u_x, u_t, u_s, n )
       use eigen_devel
       implicit NONE

       integer, intent(in)    :: n
       real(8), intent(inout) :: u_y(1:n), u_x(1:n), u_t(1:n), u_s(1:n)

       integer :: nx, ny, ic, i, j, k
       integer, pointer :: req(:)
       integer :: reqr(2), reqs(2), x_snod, y_snod
       integer :: his_rank, her_rank

       real(8) :: d1,d2
       real(8) :: e1,e2
       real(8) :: e3,e4


          d1 = eigen_get_wtime( )

          if ( x_nnod == 1 ) then
             if ( y_nnod == 1 ) then
                u_y(1:n) = u_x(1:n)
             else
                ny = (n-1)/y_nnod+1
                do i=1,ny
                   j = y_inod+y_nnod*(i-1)
                   u_y(i) = u_x(j)
                end do! i
             end if
             return
          end if

          if ( x_nnod == y_nnod ) then
             if ( x_inod == y_inod ) then
                u_y(1:n) = u_x(1:n)
             end if
             call bcast_dbl(u_y, n, y_inod, x_COMM_WORLD)
             return
          end if

          x_snod = x_nnod/n_common
          y_snod = y_nnod/n_common

          if ( p0_(x_inod) > 0 ) then

             nx = (n-1)/y_snod+1
             do i=1,nx
                j = p0_(x_inod)+y_snod*(i-1)
                k = q0_(x_inod)+x_snod*(i-1)
                u_t(i) = u_x(j)
                u_y(k) = u_x(j)
             end do

             e3 = eigen_get_wtime( )
             call allgather_dbl( u_t(1), u_s(1), nx, w_COMM_WORLD )
             e4 = eigen_get_wtime( )

             do ic=1,x_snod-1
                his_rank = MOD(x_inod-1 +x_nnod +ic*n_common,x_nnod)+1
                ny = (n-p0_(his_rank))/y_snod+1
                do i=1,ny
                   k = q0_(his_rank)+x_snod*(i-1)
                   j = (his_rank-1)*nx+i
                   u_y(k) = u_s(j)
                end do! i
             end do! ic

             e1 = eigen_get_wtime( )
             call bcast_dbl( u_y, n, z_inod, z_COMM_WORLD )
             e2 = eigen_get_wtime( )

          else

             i = MOD(y_inod-1,n_common)
             j = MOD(x_inod-1,n_common)
             ic = MOD(j-i+n_common,n_common)
             his_rank = ((x_inod-1)/n_common)*n_common + i + 1

             e1 = eigen_get_wtime( )
             call bcast_dbl( u_y, n, his_rank, z_COMM_WORLD )
             e2 = eigen_get_wtime( )

             e3 = 0; e4 = 0

          end if

9999      continue

          d2 = eigen_get_wtime( )
          time_redist = time_redist + (d2-d1) - (e2-e1) - (e4-e3)


       return
       end subroutine  datacast_dbl
!--
       subroutine datacast_dbl2(ur_y,ui_y, ur_x,ui_x, u_t,u_s, n)
       use eigen_devel
       implicit NONE

       integer, intent(in)    :: n
       real(8), intent(inout) :: ur_y(1:n), ui_y(1:n)
       real(8), intent(inout) :: ur_x(1:n), ui_x(1:n)
       real(8), intent(inout) :: u_t(1:2*n), u_s(1:2*n)

       integer :: nx, ny, ic, i, j, k
       integer, pointer :: req(:)
       integer :: reqr(2), reqs(2), x_snod, y_snod
       integer :: his_rank, her_rank

       real(8) :: d1,d2
       real(8) :: e1,e2
       real(8) :: e3,e4


          d1=eigen_get_wtime( )

          if ( x_nnod == 1 ) then
             if ( y_nnod == 1 ) then
                ur_y(1:n)=ur_x(1:n)
                ui_y(1:n)=ui_x(1:n)
             else
                ny=(n-1)/y_nnod+1
                do i=1,ny
                   j=y_inod+y_nnod*(i-1)
                   ur_y(i)=ur_x(j)
                   ui_y(i)=ui_x(j)
                end do! i
             end if
             return
          end if

          if ( x_nnod == y_nnod ) then
             if ( x_inod == y_inod ) then
                u_t(  1:  n) = ur_x(1:n)
                u_t(n+1:n+n) = ui_x(1:n)
             end if
             call bcast_dbl(u_t, 2*n, y_inod, x_COMM_WORLD)
             ur_y(1:n) = u_t(  1:  n)
             ui_y(1:n) = u_t(n+1:n+n)
             return
          end if

          x_snod = x_nnod/n_common
          y_snod = y_nnod/n_common

          if ( p0_(x_inod) > 0 ) then

             nx = (n-1)/y_snod+1
             do i=1,nx
                j = p0_(x_inod)+y_snod*(i-1)
                k = q0_(x_inod)+x_snod*(i-1)
                u_t(   i) = ur_x(j)
                u_t(nx+i) = ui_x(j)
                ur_y(k) = ur_x(j)
                ui_y(k) = ui_x(j)
             end do

             e3 = eigen_get_wtime( )
             call allgather_dbl( u_t(1), u_s(1), 2*nx, w_COMM_WORLD )
             e4 = eigen_get_wtime( )

             do ic=1,x_snod-1
                his_rank = MOD(x_inod-1 +x_nnod +ic*n_common,x_nnod)+1
                ny = (n-p0_(his_rank))/y_snod+1
                do i=1,ny
                   k = q0_(his_rank)+x_snod*(i-1)
                   j = 2*(his_rank-1)*nx+i
                   ur_y(k) = u_s(   j)
                   ui_y(k) = u_s(nx+j)
                end do! i
             end do! ic

             u_t(  1:  n) = ur_y(1:n)
             u_t(n+1:n+n) = ui_y(1:n)

             e1=eigen_get_wtime( )
             call bcast_dbl(u_t, 2*n, z_inod, z_COMM_WORLD)
             e2=eigen_get_wtime( )

          else

             i = MOD(y_inod-1,n_common)
             j = MOD(x_inod-1,n_common)
             ic = MOD(j-i+n_common,n_common)
             his_rank = ((x_inod-1)/n_common)*n_common + i + 1

             e1=eigen_get_wtime( )
             call bcast_dbl(u_s, 2*n, his_rank, z_COMM_WORLD)
             e2=eigen_get_wtime( )

             ur_y(1:n) = u_s(  1:  n)
             ui_y(1:n) = u_s(n+1:n+n)

          end if

9999      continue

          d2=eigen_get_wtime( )
          time_redist=time_redist+(d2-d1)-(e2-e1)


       return
       end subroutine  datacast_dbl2

*
*
* NOTICE : BECAUSE OF THE ACCURACY PROBLEMS,
*          DO NOT USE ANY OPTIMIZATION
*          OPTION ON THE COMPILATION PHASE.
*          IN MOST CASES, YOU MAY USE -O0.
*
*
       real(8) function machine_epsilon()
       implicit NONE

       real(8)                :: epsilon, tmp

       include 'param.h'


       epsilon = ONE
       do
          tmp = epsilon
          epsilon = epsilon * HALF
          if ( ONE + epsilon == ONE ) exit
       end do
       machine_epsilon = tmp


       return
       end function machine_epsilon

       subroutine eigen_hrd_u(
     &              ar,ai,
     &              ur_x,ui_x,
     &              ur_y,ui_y,
     &              u_t,v_t,
     &              x_root,y_root,x_pos,
     &              n,nm,nv
     &            )
!
      use communication_h, only : send_dbl
     &               , recv_dbl
     &               , reduce_dbl
     &               , bcast_dbl
     &               , datacast_dbl
!
      implicit none

      integer, intent(in)    :: nm, nv, n
      real(8), intent(in)    :: ar(1:nm)
      real(8), intent(in)    :: ai(1:nm)
      real(8), intent(inout) :: ur_x(1:nv), ur_y(1:nv)
      real(8), intent(inout) :: ui_x(1:nv), ui_y(1:nv)
      real(8), intent(inout) :: u_t(1:nv+4), v_t(1:nv+4)

      integer ::  j_1, j_2, j_3
      integer ::  x_root, x_pos
      integer ::  y_root

!...  real(8) ::  scale, theta
      real(8) ::  scale(1), theta(1)
      real(8) ::  alpha, beta, gamma(2), kappa(2)
      real(8) ::  wk1(3), wk2(3)

      include 'trd.h'


      j_2 = 1
      j_3 = n
!
! u=...
!
!     print*,"eigen_hrd_u start"
      if(y_root==my_row)then
         scale(1) = 0.0d+00
         do j_1=j_2,j_3
            scale(1) = scale(1)+abs(ar(j_1))+abs(ai(j_1))
         enddo! j_1
         call reduce_dbl(scale, theta, 1, mpi_comm_col)
         if(scale(1)/=0.0d+00)then
            alpha    = 0.0d+00
            gamma(1) = 0.0d+00
            gamma(2) = 0.0d+00
            do j_1=j_2,j_3
               u_t(j_1) = ar(j_1)/scale(1)
               v_t(j_1) = ai(j_1)/scale(1)
               alpha     = alpha+u_t(j_1)**2+v_t(j_1)**2
            enddo! j_1
            if(x_root==my_col)then
               gamma(1) = u_t(x_pos)
               gamma(2) = v_t(x_pos)
            endif
            wk1(1) = gamma(1)
            wk1(2) = gamma(2)
            wk1(3) = alpha
            call reduce_dbl(wk1, wk2, 3, mpi_comm_col)
            gamma(1) = wk1(1)
            gamma(2) = wk1(2)
            alpha    = wk1(3)
         endif
         u_t(x_pos+1) = scale(1)
         u_t(x_pos+2) = alpha
         u_t(x_pos+3) = gamma(1)
         v_t(x_pos+3) = gamma(2)
      endif
!
      if ( nprocs >= es_cluster**2 .and.
     &       size_of_col > 1 .and. es_icnod > 1 ) then
         call recv_dbl(u_t(1), 0, es_icnod-1, es_ccomm_world)
      endif
      call bcast_dbl(u_t(1), x_pos+3, y_root, mpi_comm_row)
      call bcast_dbl(v_t(1), x_pos+3, y_root, mpi_comm_row)
      if ( nprocs >= es_cluster**2 .and.
     &       size_of_col > 1 .and. es_icnod < es_ncnod ) then
         call send_dbl(u_t(1), 0, es_icnod+1, es_ccomm_world)
      endif
!
      scale(1)=u_t(x_pos+1)
      if(scale(1)/=0.0d+00)then
         alpha = u_t(x_pos+2)
         gamma(1) = u_t(x_pos+3)
         gamma(2) = v_t(x_pos+3)
         theta(1) = sqrt(alpha)
         kappa(1) = sqrt(u_t(x_pos+3)**2+v_t(x_pos+3)**2)
         ur_x(j_2:j_3) = u_t(j_2:j_3)
         ui_x(j_2:j_3) = v_t(j_2:j_3)
         if(x_root==my_col)then
            if(kappa(1)/=0.0d+00)then
               kappa(2) = 1.0d+00+theta(1)/kappa(1)
            else
               kappa(2) = 1.0d+00
            endif
            ur_x(x_pos) = kappa(2)*ur_x(x_pos)
            ui_x(x_pos) = kappa(2)*ui_x(x_pos)
         endif
         call datacast_dbl(ur_y,ur_x, u_t,v_t, x_pos)
         call datacast_dbl(ui_y,ui_x, u_t,v_t, x_pos)
         beta = alpha+kappa(1)*theta(1)
         if(x_root==my_col)then
            u_t(x_pos  ) = ur_x(x_pos  )
            v_t(x_pos  ) = ui_x(x_pos  )
         endif
         v_t(x_pos+1) = gamma(1)
         v_t(x_pos+2) = gamma(2)
         v_t(x_pos+3) = kappa(1)
         v_t(x_pos+4) = kappa(2)
         u_t(x_pos+1) = scale(1)
         u_t(x_pos+2) = alpha
         u_t(x_pos+3) = theta(1)
         u_t(x_pos+4) = beta
      endif
!     print*,"eigen_hrd_u passed"

      return
      end subroutine

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE:  width2, wd_fermi_error1, wd_fermi_error2
!
!  AUTHOR(S): N. Hamada, T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine wd_fermi_error1(nfout,emin,emax,tot,totch)
! $Id: b_Fermi.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Const_Parameters, only : DP
  implicit none
  integer,       intent(in) :: nfout
  real(kind=DP), intent(in) :: emin, emax, tot, totch
  write(nfout,'(" emin = ",f10.4,"  emax = ",f10.4)') emin, emax
  write(nfout,'("  tot = ",f10.4," totch = ",f10.4)') tot, totch
  call phase_error_with_msg(nfout,' === stop in sub.fermi_parabolic (too few of states) ==',__LINE__,__FILE__)
end subroutine wd_fermi_error1

subroutine wd_fermi_error2(nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in) :: nfout, neg, MAXITR
  real(kind=DP), intent(in) :: e1, e2,efermi, emin,emax, tot, totch
  
  write(nfout,'("     e1  = ", f10.5)') e1
  write(nfout,'("     e2  = ", f10.5)') e2
  write(nfout,'(" efermi  = ", f10.5)') efermi
  write(nfout,'("   emin  = ", f10.5, "  emax  = ",f10.5)') emin,emax
  write(nfout,'("    tot  = ", f10.5, " totch  = ",f10.5)') tot,totch
  write(nfout,'("  occup ( i = 1, ",i5,")")') neg
  write(nfout,'(" jcount exceeds MAXITR (= ",i8," (in FERMI)")') MAXITR
  call phase_error_with_msg(nfout,' stop at <wd_fermi_error2>',__LINE__,__FILE__)
end subroutine wd_fermi_error2

!!$C SUBROUTINE WIDTH2
!!$c                           @(#)width2.f 9.1 97/05/08 14:49:38 
!!$C
!!$C          1983/05/18 :   NORIAKI HAMADA
!!$C
!!$C----*----1----*----2----*----3----*----4----*----5----*----6----*----7
!!$C
subroutine width2( E,EFF,W, DOS,OCC  )
  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP), intent(in)  :: E, EFF, W
  real(kind=DP), intent(out) :: DOS, OCC
!!$C          EIGENENERGY IS BROADENED
!!$C
!!$C          E :  EIGENENERGY
!!$C          EF:  FERMI ENERGY
!!$C          W :  4*W IS BOTTOM LENGTH
!!$C          DOS    :  DENSITY OF STATES AT EF
!!$C          OCCUP :  OCUPATION FRACTION OF ELECTRON
  real(kind=DP) :: ee, ww

  if(w <= 0.0d0) STOP ' === STOP AT SUB.WIDTHE. (W<=0.0D0) ==='
#ifdef __TIMER_SUB__
!  call timer_sta(705)
#endif
  ee=(eff-e)/w
  ww=4.0d0*w
  if(ee <= -2.0d0) then
     dos    = 0.0d0
     occ  = 0.0d0
  else if(ee < -1.0d0) then
     dos    = (ee+2.0d0)**2/ww
     occ  = ((ee+2.0)**3)/(12.0d0)
  else if(ee < 1.0d0) then
     dos    = (2.0d0-ee**2)/ww
     occ  = (6.0d0+6.0d0*ee-(ee**3))/12.0d0
  else if(ee < 2.0d0) then
     dos    = ((ee-2.0d0)**2)/ww
     occ  = (12.0d0+(ee-2.0d0)**3)/12.0d0
  else
     dos    = 0.0d0
     occ  = 1.0d0
  end if
#ifdef __TIMER_SUB__
!  call timer_end(705)
#endif
end subroutine width2

! ============= KT_add =========================== 13.0E
subroutine width_fermi_dirac( ene, ef, width, dos, occ )
  use m_Const_Parameters, only : DP
  implicit none

  real(kind=DP), intent(in) :: ene, ef, width
  real(kind=DP), intent(out) :: dos, occ

  real(kind=DP) :: ee, c1, c2

  if ( width < 1.0D-10 ) call phase_error_with_msg(6,"smearing width is too small",__LINE__,__FILE__)

  ee = ( ene -ef )/width
  if(ee.gt.100)then
     occ = 0.d0
     dos = 0.d0
  else if (ee.lt.-100)then
     occ = 1.d0
     dos = 0.d0
  else
  c1 = exp( ee );   c2 = cosh( ee/2.0D0 )
!
  occ = 1.0D0 / ( 1.0D0 +c1 )
  dos = 0.25D0 / c2**2 /width
  endif

end subroutine width_fermi_dirac
! ============================================== 13.0E

subroutine width_methfessel_paxton(n,ene,ef,width,dos,occ,entropy)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in) :: n
  real(kind=DP), intent(in) :: ene, ef, width
  real(kind=DP), intent(out) :: dos, occ
  real(kind=DP), intent(out) :: entropy
  real(kind=DP) :: ee
  if ( width < 1.0D-10 ) call phase_error_with_msg(6,"smearing width is too small",__LINE__,__FILE__)

  ee = ( ene -ef )/width
  if(ee.gt.7)then
     occ = 0.d0
     dos = 0.d0
     entropy = 0.d0
  else if (ee.lt.-7)then
     occ = 1.d0
     dos = 0.d0
     entropy = 0.0d0
  else
     occ = step_function_mp(n,ee)
     dos = delta_function_mp(n,ee)
     entropy = 0.5d0*coeffA(n)*hermite_polynomial(2*n,ee)*exp(-ee*ee)
  endif

  return

  contains 

  function delta_function_mp(n,x) result(res)
    use m_Const_Parameters, only : DP
    implicit none
    integer, intent(in) :: n
    real(kind=DP), intent(in) :: x
    real(kind=DP) :: res,ex
    integer :: i
    res = 0.d0
    ex = exp(-x*x)
    do i=0,n
       res = res+coeffA(i)*hermite_polynomial(2*i,x)*ex
    enddo
  end function delta_function_mp

  function step_function_mp(n,x) result(res)
    use m_Const_Parameters, only : DP
    implicit none
    integer, intent(in) :: n
    real(kind=DP), intent(in) :: x
    real(kind=DP) :: res,an,h2n,ex
    integer :: i
    res = 0.5d0*erfc(x)
    if (n==0) return
    ex = exp(-x*x)
    do i=1,n
       an  = coeffA(i)
       h2n = hermite_polynomial(2*i-1,x)
       res = res + an*h2n*ex
    enddo
    return
  end function step_function_mp

  recursive function hermite_polynomial(n,x) result(res)
    use m_Const_Parameters, only : DP
    implicit none
    integer, intent(in) :: n
    real(kind=DP), intent(in) :: x
    real(kind=DP) :: res
    real(kind=DP) :: y1,y2
    real(kind=DP) :: x2,x3,x4,x5
    integer :: i
    if (n==0) then
      res = 1.d0
      return
    endif
    if (n==1) then
      res = 2.d0*x
      return
    endif
    if (n==2) then
      res = 4.d0*x*x-2.d0
      return
    endif
    if (n==3) then
      res = 8.d0*x*x*x-12.d0*x
      return
    endif
    if (n==4) then
      x2 = x*x
      res = x2*x2*16.d0-48.d0*x2+12.d0
      return
    endif
    if (n==5) then
      x3=x*x*x
      res = 32.d0*x3*x*x-160.d0*x3+120.d0*x
      return
    endif
    if (n==6) then
      x2 = x*x
      x3 = x2*x
      res = 64.d0*x3*x3-480.d0*x3*x+720.d0*x2-120.d0
      return
    endif
    if (n==7) then
      x3=x*x*x
      x5=x3*x*x
      res = 128.d0*x5*x*x-1344.d0*x5+3360.d0*x3-1680.d0*x
      return
    endif
    if (n==8) then
      x2 = x*x
      x3 = x2*x
      x4 = x3*x
      res = 256.d0*x4*x4-3584.d0*x3*x3+13440.d0*x4-13440.d0*x2+1680.d0
      return
    endif
    if (n==9) then
      x3 = x*x*x
      x4 = x3*x
      x5 = x4*x
      res = 512.d0*x5*x4-9216.d0*x3*x4+48384.d0*x5-80640.d0*x3+30240.d0*x
      return
    endif
    if (n==10) then
      x2 = x*x
      x3 = x2*x
      x4 = x3*x
      x5 = x4*x
      res = 1024.d0*x5*x5-23040.d0*x5*x3+161280*x3*x3-403200.d0*x4+302400.d0*x2-30240.d0
      return
    endif
    y1 = hermite_polynomial(n-1,x)
    y2 = hermite_polynomial(n-2,x)
    res  = 2.d0*x*y1-2.d0*(n-1)*y2
    return
  end function hermite_polynomial

  function coeffA(n) result(res)
    use m_Const_Parameters, only : DP,PAI
    implicit none
    integer, intent(in) :: n
    real(kind=DP) :: res
    integer :: i
    real(kind=DP) :: kaijo
    kaijo = 1
    do i=2,n
       kaijo = kaijo*i
    enddo
    res = (-1)**n/(kaijo*4**n*dsqrt(PAI))
    return
  end function coeffA

end subroutine width_methfessel_paxton

!================================================
!  Software name : STM
!  Module : m_Electronic_Structure
!  Subroutine(s) : m_ES_rd_EigenValues_etc, wd_EigenValues_etc,
!                  m_ES_rd_VLCs, m_ES_VLCS_in_Rspace_fine_mesh,
!                  m_ES_rd_WFs, m_ES_WF_in_Rspace, m_ES_WF_in_Rspace_fine_mesh
!  Author(s)     : Takahiro Yamasaki and Koichi Kato (June 7, 2004)
!
!  FURTHER MODIFICATION: Junichiro  Koga (June 24, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_Electronic_Structure
! $Id: m_Electronic_Structure.f90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  use m_ArraySize_Parameters, only : knv3, kngp, kimg, kspin, kng1 &
       &, keg
  use m_Const_Parameters,     only : SP, DP, INVERSE, ON, OFF
  use m_Files,                only : nfout,nfzaj, nfvlc
  use m_PlaneWaveBasisSet,    only : igf, igfp_l, igfpf_l, nbase, iba
  use m_FFT,                  only : FFT_WF, FFT_WF_fine &
       &                            ,nfft,nfftp,nfftpf,nlpf
  implicit none

!  real(kind=DP), dimension(kng1,keg,kimg)  :: zaj_l ! wave functions
!  real(kind=DP), dimension(kngp,kimg,kspin):: vlc_l ! local potentials
  real(kind=DP), allocatable, dimension(:,:,:)  :: zaj_l ! wave functions
  real(kind=DP), allocatable, dimension(:,:,:)  :: vlc_l ! local potentials

  real(kind=SP), pointer, dimension(:,:)   :: wf_l
  real(kind=DP), pointer, dimension(:,:)   :: vl_l
  ! A work array for reading of wave functions

!  integer, dimension(keg,knv3)        :: neordr, nrvf_ordr
!  real(DP),dimension(keg,knv3)        :: eko, occup_l
  integer, allocatable, dimension(:,:)        :: neordr, nrvf_ordr
  real(DP),allocatable, dimension(:,:)        :: eko, occup_l

  real(DP)                            :: efermi
  integer                             :: is, izaj

contains
  subroutine m_ES_rd_EigenValues_etc(nfcntn_bin)
    integer, intent(in) :: nfcntn_bin

    integer :: i, k

    allocate(zaj_l(kng1,keg,kimg))
    allocate(vlc_l(kngp,kimg,kspin))
    allocate(neordr(keg,knv3))
    allocate(nrvf_ordr(keg,knv3))
    allocate(eko(keg,knv3))
    allocate(occup_l(keg,knv3))

    read(nfcntn_bin) neordr
    read(nfcntn_bin) nrvf_ordr

    print *,' <<< neordr >>>'
    do k = 1, knv3
       print '(" ik = ",i3)',k
       print '(10i8)', (neordr(i,k),i=1,keg)
    end do
    print *,' <<< nrvf_ordr >>>'
    do k = 1, knv3
       print '(" ik = ",i3)',k
       print '(10i8)',(nrvf_ordr(i,k),i=1,keg)
    end do

    read(nfcntn_bin) eko
    print *,' <<< eko(raw) >>> '
    do k = 1, knv3
       print '(" ik = ", i3)', k
       print '(10f8.4)',(eko(i,k),i=1,keg)
    end do

    print *,' <<< eko(ordered) >>> '
    do k = 1, knv3
       print '(" ik = ", i3)', k
       print '(10f8.4)',(eko(neordr(i,k),k),i=1,keg)
    end do
       
    read(nfcntn_bin) occup_l
    read(nfcntn_bin) efermi
    print *, ' efermi = ', efermi
  end subroutine m_ES_rd_EigenValues_etc

  subroutine wd_EigenValues_etc(nfcntn_bin)
    integer, intent(in) :: nfcntn_bin
    write(nfcntn_bin) neordr,nrvf_ordr
    write(nfcntn_bin) eko
    write(nfcntn_bin) occup_l
    write(nfcntn_bin) efermi
  end subroutine wd_EigenValues_etc

  subroutine m_ES_rd_VLCs(nfvlc)
    integer, intent(in) :: nfvlc
!!$    integer       :: ri,ia

!!$    rewind nfvlc
!!$    allocate(vl_l(kngp,kimg))
    print *,' !D Reading vlc'
    print *,' nfvlc = ',nfvlc
    print *,' kngp = ', kngp
    print *,' kimg = ', kimg
!!$    read(nfvlc) vl_l
!!$    print *,' read finished vl_l '
!!$    do ri = 1, kimg
!!$       do ia = 1, kngp
!!$          vlc_l(ia, ri) = vl_l(ia, ri)
!!$       end do
!!$    end do
!!$    deallocate(vl_l)
    read(nfvlc) vlc_l
    print *,' finished m_ES_rd_VLCs '
  end subroutine m_ES_rd_VLCs

  subroutine m_ES_VLC_in_Rspace_fine_mesh(is,bfft)
    integer, intent(in)   :: is
    real(kind=DP), intent(inout), dimension(nfftpf) :: bfft

    integer :: i,i1,ri
    bfft = 0.d0
    do ri = 1, kimg
       do i = 1, kngp
          i1 = kimg*igfpf_l(i) + (ri - kimg)
          bfft(i1) = vlc_l(i,ri,is)
       end do
    end do
    write(nfout,*) 'VLC before FFT'
    write(nfout,'(2d20.8)') ( bfft(2*i-1), bfft(2*i), i=1, nlpf)
    call FFT_WF_fine(bfft,INVERSE)    !-(m_FFT)
    ! V_{loc}(G)) -> V_{loc}(r)
  end subroutine m_ES_VLC_in_Rspace_fine_mesh

  subroutine m_ES_rd_WFs(nfzaj)
    integer, intent(in) :: nfzaj
    integer       :: ib,ri

    print *,'(" !D kng1, keg = ",2i5," <<m_ES_rd_WFs>>")',kng1,keg
    print *,' !D Reading zaj'
!!$#ifdef VDB
!!$    allocate(wf_l(kng1,keg))
!!$    do ri = 1, kimg
!!$       read(nfzaj) wf_l
!!$       do ib = 1, keg
!!$          zaj_l(1:kng1,ib,ri) = wf_l(1:kng1,ib)
!!$       end do
!!$    end do
!!$#else             
    allocate(wf_l(kng1,kimg))
    do ib = 1, keg
       read(nfzaj) wf_l
       do ri = 1, kimg
          zaj_l(1:kng1,ib,1:kimg) = wf_l(1:kng1,1:kimg)
       end do
    end do
!!$#endif
    deallocate(wf_l)
!   write(nfout,*) 'WF after READ, kng1 =',kng1
!   write(nfout,*) ( zaj_l(ia,32,1), ia=1, 2000)
  end subroutine m_ES_rd_WFs

  subroutine m_ES_WF_in_Rspace(ikp,ib,bfft)
    integer, intent(in)                           :: ikp, ib
    real(kind=DP), intent(inout), dimension(nfft) :: bfft

    integer :: i,i1,ri
    bfft = 0.d0
    do ri = 1, kimg
       do i = 1, iba(ikp)
          i1 = kimg*igf(nbase(i,ikp)) + (ri - kimg)
          bfft(i1) = zaj_l(i,ib,ri)
       end do
    end do
    call FFT_WF(bfft,INVERSE,ON)    !-(m_FFT)
    ! \Psi(G) -> \Phi(r)
  end subroutine m_ES_WF_in_Rspace

  subroutine m_ES_WF_in_Rspace_fine_mesh(ikp,ib,afft)
    integer, intent(in)                             :: ikp, ib
    real(kind=DP), intent(inout), dimension(nfftpf) :: afft

    integer :: i,i1,ri
    afft = 0.d0
    do ri = 1, kimg
       do i = 1, iba(ikp)
          i1 = kimg*igfpf_l(nbase(i,ikp)) + (ri - kimg)
          afft(i1) = zaj_l(i,ib,ri)
       end do
    end do
!   write(nfout,*) 'WF before FFT, iba(ikp)=', iba(ikp)
!   write(nfout,*) ( afft(i), i=1, 100)
    call FFT_WF_fine(afft,INVERSE)    !-(m_FFT)
    ! \Psi(G) -> \Phi(r)
  end subroutine m_ES_WF_in_Rspace_fine_mesh

end module m_Electronic_Structure

module m_dimer
  use m_Parallelization, only : mype, nrank_conf, mype_conf, npes
  use m_Const_Parameters, only : DP, ON, BOHR, PAI2, SKIP_SYMMCHECK, PAI
  use m_Control_Parameters, only : printable
  use m_Crystal_Structure, only : rltv
  use m_PseudoPotential, only : flg_paw, m_PP_rd_PAW_parameters
  use m_Charge_Density,    only :  m_CD_alloc_chgsoft
  use m_Files,         only :  m_Files_open_nfcntn_bin_paw, nfout, nfcntn_bin_paw
  use m_Ionic_System,  only : neb_dt
  use m_Replica, only : neb_file_type

  implicit none

  include 'mpif.h'

  type dimer_type
    integer :: max_dimer_iteration
    integer :: natm
    real(kind=DP) :: dtheta, dR
    real(kind=DP) :: dt
    real(kind=DP), allocatable :: r0(:,:), r1(:,:), r2(:,:), for(:,:,:),f1(:,:), f2(:,:), velocity(:,:)
    real(kind=DP), allocatable :: f1para(:,:), f1perp(:,:), f2para(:,:), f2perp(:,:), fpara(:,:), fperp(:,:), fperpold(:,:)
    real(kind=DP), allocatable :: fR(:,:), f(:,:), fold(:,:), ftrans(:,:)
    integer, allocatable :: mobile(:)
    real(kind=DP), allocatable :: N(:,:), theta(:,:), thetaold(:,:), currangle(:), ene(:)
    real(kind=DP) :: curvature
    real(kind=DP) :: e, e1, e2, e0
    real(kind=DP) :: threshold
    real(kind=DP) :: max_force
    integer :: nrank_r, mype_r
    type(neb_file_type) :: file_type
  end type dimer_type

  type(dimer_type), target :: dimvars

  logical :: pp_generated = .false.
  logical :: dimer_cond_set = .false.
  logical :: standard_out_opened = .true.

  contains

  subroutine m_dm_set_pp_generated(ppg)
    logical, intent(in) :: ppg
    pp_generated = ppg
  end subroutine m_dm_set_pp_generated

  subroutine cal_scf_energy_force(i,itr)
    use m_Force, only : forc_l
    use m_Total_Energy, only : etotal
    use m_IterationNumbers, only : iteration_electronic, iteration, iteration_ionic, m_Iter_dimer_incre
    use m_Parallelization, only : m_Parallel_init_mpi_paw_3D
    use m_Const_Parameters, only : ON
    use m_Control_Parameters, only : ipriparallel, PAW_switch
    use m_Ionic_System, only : natm
    use m_PseudoPotential, only : mmesh
    integer, intent(in) :: i, itr
    logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
    logical  :: Already_Converged, Positron_bulk
    logical  :: Hubbard_model
    logical  :: Forces_are_Converged, Ending_Time, Ending_Time2, Force_errors_are_tolerable
    integer  :: ia

    if(mod(i-1,nrank_conf) == mype_conf) then
    call set_dimer_replica_parameter(i, itr)
    call set_dimer_coordinates(i)
    call Preparation(0)                   ! Basis set, symmetry check etc.
    call Preparation_for_mpi(ON)           ! mpi
    if (.not.pp_generated) then
       call PseudoPotential_Construction
       pp_generated = .true.
#ifdef ENABLE_ESM_PACK
       call Preparation_for_ESM()
#endif
    else
       if ( flg_paw ) then
!          if ( itr > 1 .or. neb%cond%condition == 1 ) then
         if( itr > 1 )then
           call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
         endif
         call m_CD_alloc_chgsoft
       endif
    endif
    if(PAW_switch==ON) call m_Parallel_init_mpi_paw_3D(nfout,ipriparallel,natm,mmesh)
! ================================================= 13.0D
    call Ewald_and_Structure_Factor
    call Initial_Electronic_Structure
    call Initial_MD_Condition

    if(.not.Already_Converged()) then
       AtomicConfiguration: do
          ChargeDensity:    do
             call IterationNumber_Setting
             call Renewal_of_WaveFunctions
             call ChargeDensity_Construction(1)
             call ChargeDensity_Mixing
             call Renewal_of_Potential
             if(Hubbard_model()) then
                call Renewal_of_Hubbard_Potential
             end if
             if(Ending_Time()) then
                exit AtomicConfiguration
             end if
             if(TotalEnergy_is_Divergent())    exit ChargeDensity                    
             if(ChargeDensity_is_Converged())  exit ChargeDensity
          enddo ChargeDensity
#ifdef LIBRARY_BUILD
          call Forces_phase0
#else
          call Forces
#endif
          exit AtomicConfiguration
       enddo AtomicConfiguration
    end if
    dimvars%for(i,:,:) = forc_l(:,:)
    dimvars%ene(i) = etotal
    write(nfout,'(a,i8,f20.10)') '!** DIMER METHOD energy for atom ',i,dimvars%ene(i)
    write(nfout,'(a,i8)')        '!** DIMER METHOD forces for atom ',i
    do ia=1, dimvars%natm
      write(nfout,'(i8,3f20.10)') ia,dimvars%for(i,ia,1:3)
    enddo
    iteration = 0
    iteration_electronic = 0
    iteration_ionic = 0
    call WriteDownData_onto_Files(.false.)
    call deallocate_array
    endif
    
    call m_Iter_dimer_incre(nfout)
  end subroutine cal_scf_energy_force

  subroutine cal_dimer_scf(itr)
    integer, intent(in) :: itr
    integer :: i, ierr
    dimvars%for=0.d0;dimvars%ene=0.d0
    do i=1,2
      call cal_scf_energy_force(i,itr)
    enddo
    if(nrank_conf>1) then
      call mpi_allreduce(mpi_in_place, dimvars%for, 2*dimvars%natm*3, mpi_double_precision, &
              mpi_sum, mpi_comm_world, ierr)
      dimvars%for = dimvars%for/dble(npes)
      call mpi_allreduce(mpi_in_place, dimvars%ene, 2, mpi_double_precision, &
              mpi_sum, mpi_comm_world, ierr)
      dimvars%ene = dimvars%ene/dble(npes)
    endif
  end subroutine cal_dimer_scf

  subroutine deallocate_array

    use m_Control_Parameters, only : m_CtrlP_set_init_status
    use m_Crystal_Structure, only : m_CS_dealloc
    use m_Ionic_System, only : m_IS_dealloc
    use m_PlaneWaveBasisSet, only : m_pwBS_dealloc
    use m_Parallelization, only : m_Parallel_dealloc, m_Parallel_dealloc_mpi_elec &
                                , m_Parallel_dealloc_mpi_fft_box, m_Parallel_dealloc_mpi_nval &
                                , m_Parallel_fft_onto_wf_dealloc_3D, m_Parallel_dealloc_mpi_kngp_B
    use m_Kpoints, only : m_Kp_dealloc
    use m_Force, only : m_Force_dealloc
    use m_Charge_Density, only : m_CD_dealloc
    use m_XC_Potential, only : m_XC_dealloc_vxc_3D
!    use m_PseudoPotential
!    use m_NonLocal_Potential,
    use m_Electronic_Structure, only : m_ES_dealloc
    use m_ES_WF_by_SDorCG, only : m_ESsd_dealloc
!    use m_ES_wf_extrpl, only : m_ES_wf_extrpl_dealloc

!  call m_CtrlP_dealloc

    call m_CS_dealloc(neb_mode=.true.)
    call m_IS_dealloc(neb_mode=.true.)
    call m_pwBS_dealloc
    call m_Parallel_dealloc(neb_mode=.true.)
    call m_Parallel_dealloc_mpi_elec
    call m_Parallel_dealloc_mpi_fft_box
    call m_Parallel_dealloc_mpi_nval
    call m_Parallel_fft_onto_wf_dealloc_3D
    call m_Parallel_dealloc_mpi_kngp_B
    call m_Kp_dealloc
    call m_Force_dealloc
    call m_CD_dealloc
    call m_XC_dealloc_vxc_3D
    !call m_PP_dealloc
    !call m_NLP_dealloc
    call m_ES_dealloc
    call m_ESsd_dealloc
    call m_CtrlP_set_init_status(.true.)

  end subroutine deallocate_array

  subroutine set_dimer_coordinates(i)
    use m_Ionic_System, only : pos, cps
    integer, intent(in) :: i
    real(kind=DP), pointer, dimension(:,:) :: r
    integer :: ia
    if(i==1) then
      r => dimvars%r1
    else
      r => dimvars%r2
    endif
    cps(:,:) = r(:,:)
    do ia = 1, dimvars%natm
       pos(ia,1:3) = matmul(transpose(rltv),r(ia,1:3))/PAI2
    end do
    if(mype == 0) then
      write(nfout,'(a,i5)') '!** DIMER METHOD coordinates for dimer ',i
      do ia=1, dimvars%natm
        write(nfout,'(i8,3f20.10)') ia,cps(ia,1:3)
      enddo
    endif
  end subroutine set_dimer_coordinates

  subroutine normalize(nsize,vec)
    integer, intent(in) :: nsize
    real(kind=DP), dimension(nsize,3), intent(inout) :: vec
    integer :: i
    real(kind=DP) :: v(3)
    vec = vec/(sqrt(sum(vec*vec)))
    return
  end subroutine normalize

  subroutine init_dimer_method()
    use m_Ionic_System, only : natm, cps_end0, cps_end1, &
            delta_theta, delta_r, dimer_max_iteration,  &
            imdtyp
    use m_Files, only : nfenf, nfdynm, F_DYNM, F_ENF, m_Files_open_files_initially
    use m_Control_Parameters, only : icond
    use m_Const_Parameters, only : CONTINUATION, INITIAL
    use m_Ionic_System, only : m_IS_wd_speciesname_etc, neb_convergence_threshold, &
            sw_random_unit_vector
    use m_Parallelization,      only : mpi_comm_group, nrank_e, nrank_k, nrank_conf, mype_conf
    integer :: i
    call alloc_dimer(natm)
    do i=1, dimvars%natm
      dimvars%mobile(i) = imdtyp(i)
      if(mype==0) write(nfout,'(a,2i8)') '!** DIMER METHOD moblie',i,dimvars%mobile(i)
    enddo
    dimvars%dR = delta_r
    dimvars%dtheta = delta_theta
    dimvars%max_dimer_iteration = dimer_max_iteration
    dimvars%threshold = neb_convergence_threshold
    if(sw_random_unit_vector==ON) then
      call random_unit_vector(dimvars%natm, dimvars%N)
      cps_end1 = cps_end0-2*dimvars%dR*dimvars%N
      call set_r1_r2(natm, cps_end0, cps_end1)
    else
      call set_r1_r2(natm, cps_end0, cps_end1)
    endif
    call m_Files_open_files_initially()
    if (mype == 0) then
      call m_IS_wd_speciesname_etc(nfdynm)
    endif

    dimvars%nrank_r = nrank_conf
    dimvars%mype_r  = mype_conf

    call set_dimer_condition()

  end subroutine init_dimer_method

  subroutine random_unit_vector(natm, N)
    integer, intent(in) :: natm
    real(kind=DP), dimension(natm,3), intent(out) :: N
    integer :: i, j
    real(kind=DP) :: x
    call random_number(x)
    do j=1,3
      do i=1,natm
        if(dimvars%mobile(i)==ON) then
          call random_number(x)
          N(i,j) = x-0.5d0
        endif
      enddo
    enddo
    call normalize(natm,N)
    return
  end subroutine random_unit_vector

  subroutine finalize_dimer_method()
    use m_Files, only : nfdynm, nfenf, m_Files_close_all, m_Files_close_logfile
    call dealloc_dimer()
    close(nfdynm)
    close(nfenf)
    call m_Files_close_all()
    call PrintStatus()
    call m_Files_close_logfile()
  end subroutine finalize_dimer_method

  subroutine alloc_dimer(natm)
    integer, intent(in) :: natm
    dimvars%natm = natm
    allocate(dimvars%r0(natm,3)) ; dimvars%r0=0.d0
    allocate(dimvars%r1(natm,3)) ; dimvars%r1=0.d0
    allocate(dimvars%r2(natm,3)) ; dimvars%r2=0.d0
    allocate(dimvars%mobile(natm)) ; dimvars%mobile=0
    allocate(dimvars%N(natm,3)) ; dimvars%N=0.d0
    allocate(dimvars%theta(natm,3)) ; dimvars%theta=0.d0
    allocate(dimvars%thetaold(natm,3)) ; dimvars%thetaold=0.d0
    allocate(dimvars%velocity(natm,3)) ; dimvars%velocity = 0.d0
    allocate(dimvars%f1perp(natm,3)) ; dimvars%f1perp = 0.d0
    allocate(dimvars%f1para(natm,3)) ; dimvars%f1para = 0.d0
    allocate(dimvars%f2perp(natm,3)) ; dimvars%f2perp = 0.d0
    allocate(dimvars%f2para(natm,3)) ; dimvars%f2para = 0.d0
    allocate(dimvars%fperp(natm,3)) ; dimvars%fperp = 0.d0
    allocate(dimvars%fperpold(natm,3)) ; dimvars%fperpold = 0.d0
    allocate(dimvars%fpara(natm,3)) ; dimvars%fpara = 0.d0
    allocate(dimvars%fR(natm,3)) ; dimvars%fR = 0.d0
    allocate(dimvars%f(natm,3)) ; dimvars%f = 0.d0
    allocate(dimvars%for(2,natm,3)) ; dimvars%for = 0.d0
    allocate(dimvars%fold(natm,3)) ; dimvars%fold = 0.d0
    allocate(dimvars%ftrans(natm,3)) ; dimvars%ftrans = 0.d0
    allocate(dimvars%currangle(natm)) ; dimvars%currangle = 0.d0
    allocate(dimvars%ene(2)) ; dimvars%ene = 0.d0
    dimvars%dR     = 0.01d0/BOHR
    dimvars%dtheta = 0.001d0
!    dimvars%dt     = 40.d0
    dimvars%dt     = neb_dt
    dimvars%max_dimer_iteration = 2000
    !pp_generated = .false.
    write(nfout,'(a,f15.5)') '!** DIMER METHOD dt',dimvars%dt
  end subroutine alloc_dimer

  subroutine set_r1_r2(natm, r1, r2)
    integer, intent(in) :: natm
    real(kind=DP), dimension(natm,3), intent(in) :: r1, r2
    integer :: i
    do i=1, dimvars%natm
      dimvars%N(i,:)  = r1(i,:)-r2(i,:)
      dimvars%r0(i,:) = 0.5d0*(r1(i,:)+r2(i,:))
    enddo
    call normalize(dimvars%natm, dimvars%N)
    if(mype==0) then
      do i=1, dimvars%natm
!        if (dimvars%mobile(i)==ON) then
          write(nfout,'(a,i10,3f10.5)') '!** DIMER METHOD vector N ',i,dimvars%N(i,1:3)
!        endif
      enddo
    endif
    call build_dimer()
  end subroutine set_r1_r2

  subroutine set_r0()
    integer :: i
    do i=1, dimvars%natm
      dimvars%r0(i,:) = 0.5d0*(dimvars%r1(i,:)+dimvars%r2(i,:))
    enddo
  end subroutine set_r0

  subroutine write_result(istep)
    use m_Files, only : nfdynm, nfenf
    integer, intent(in) :: istep
    integer :: ia
    if(mype == 0) then
      write(nfdynm,'(a,i10)') ' cps and forc at dimer iteration ',istep
      do ia=1, dimvars%natm
        write(nfdynm, '(i5, 3f15.9, 3f12.6)') ia, dimvars%r0(ia,1:3), dimvars%fR(ia,1:3)
      enddo
      write(nfenf, '(i5, f25.15, f20.10)') istep, dimvars%e0, dimvars%max_force
    endif
  end subroutine write_result

  subroutine build_dimer()
    integer :: i
    do i=1,dimvars%natm
      if(dimvars%mobile(i) == ON) then
        dimvars%r1(i,:) = dimvars%r0(i,:) + dimvars%dR * dimvars%N(i,:)
        dimvars%r2(i,:) = dimvars%r0(i,:) - dimvars%dR * dimvars%N(i,:)
      else
        dimvars%r1(i,:) = dimvars%r0(i,:)
        dimvars%r2(i,:) = dimvars%r0(i,:)
      endif
    enddo
  end subroutine build_dimer

  subroutine cal_curvature()
    integer :: i, j
    real(kind=DP) :: sm
    dimvars%curvature = 0.d0
    do i=1, dimvars%natm
!      if(dimvars%mobile(i)==ON) then
        dimvars%curvature = dimvars%curvature + dot_product(dimvars%for(2,i,:)-dimvars%for(1,i,:),dimvars%N(i,:))
!      endif
    enddo
    dimvars%curvature = 0.5d0*dimvars%curvature/dimvars%dR
    if(printable) then
      write(nfout,'(a,f15.5)') '!** DIMER METHOD curvature',dimvars%curvature
    endif
  end subroutine cal_curvature

  subroutine cal_dimer_energies()
    integer :: i
    real(kind=DP) :: fac
    dimvars%e  = dimvars%ene(1) + dimvars%ene(2)
    write(nfout,'(a,f15.5)') '!** DIMER METHOD dimer energy ',dimvars%e
    dimvars%e0 = dimvars%e*0.5d0
    fac = 0.25d0*dimvars%dR
    do i=1, dimvars%natm
!      if(dimvars%mobile(i)==ON) then
        dimvars%e0 = dimvars%e0 + fac * dot_product(dimvars%for(1,i,:)-dimvars%for(2,i,:), dimvars%N(i,:))
!      endif
    enddo
    if(printable) then
      write(nfout,'(a,f15.5)') '!** DIMER METHOD e0',dimvars%e0
    endif
  end subroutine cal_dimer_energies

  subroutine cal_dimer_forces()
    integer :: i
    do i=1, dimvars%natm
      dimvars%f1para(i,:) = dot_product(dimvars%for(1,i,:),dimvars%N(i,:))*dimvars%N(i,:)
      dimvars%f1perp(i,:) = dimvars%for(1,i,:) - dimvars%f1para(i,:)
      dimvars%f2para(i,:) = dot_product(dimvars%for(2,i,:),dimvars%N(i,:))*dimvars%N(i,:)
      dimvars%f2perp(i,:) = dimvars%for(2,i,:) - dimvars%f2para(i,:)
    enddo
    dimvars%fpara     = (dimvars%f1para + dimvars%f2para)*0.5d0
    dimvars%fperpold  = dimvars%fperp
    dimvars%fperp     = -(dimvars%f1perp - dimvars%f2perp)

    dimvars%fR(:,:) = (dimvars%for(1,:,:)+dimvars%for(2,:,:))*0.5d0

    dimvars%thetaold(:,:) = dimvars%theta(:,:)
    dimvars%theta(:,:)    = dimvars%fperp(:,:)
    call normalize(dimvars%natm, dimvars%theta)
    if(mype==0) then
      do i=1, dimvars%natm
!        if(dimvars%mobile(i)) then
          write(nfout,'(a,i8,3f20.10)') '!** DIMER METHOD theta',i,dimvars%theta(i,1:3)
!        endif
      enddo
    endif

    dimvars%fold(:,:) = dimvars%f(:,:)
    dimvars%f(:,:)    = dimvars%for(1,:,:)-dimvars%for(2,:,:)
  end subroutine cal_dimer_forces

  subroutine rotate_dimer(natm, dtheta)
    integer, intent(in) :: natm
    real(kind=DP), intent(in) :: dtheta
    integer :: i, j
    real(kind=DP) :: rot(3)
    do i=1, dimvars%natm
      if(dimvars%mobile(i) == ON) then
        rot(:) = (dimvars%N(i,:)     * cos(dtheta) &
        &      +  dimvars%theta(i,:) * sin(dtheta)) * dimvars%dR
        dimvars%r1(i,:) = dimvars%r0(i,:) + rot(:)
        dimvars%r2(i,:) = dimvars%r0(i,:) - rot(:)
      else
        dimvars%r1(i,:) = dimvars%r0(i,:)
        dimvars%r2(i,:) = dimvars%r0(i,:)
      endif
    enddo
  end subroutine rotate_dimer

  subroutine update_N()
    integer :: i
    do i=1, dimvars%natm
      dimvars%N(i,:) = dimvars%r1(i,:)-dimvars%r2(i,:)
    enddo
    call normalize(dimvars%natm, dimvars%N)
    if(printable) then
      do i=1, dimvars%natm
        write(nfout,'(a,i10,3f10.5)') '!** DIMER METHOD vector N ',i,dimvars%N(i,1:3)
      enddo
    endif
  end subroutine update_N

  subroutine translate_dimer(itr)
    use m_Ionic_System, only : ionic_mass, dimer_time_integral, imdtyp, m_IS_fire_core
    use m_Const_Parameters, only : QUENCHED_MD, FIRE, DP
    integer, intent(in) :: itr
    integer :: i, j
    real(kind=DP), dimension(3) :: ftrans, ftrans0
    real(kind=DP) :: dt, mass
    real(8), dimension(3) :: r1, vel, unitf, v1, v
    real(8) :: fmax, fabs
    real(kind=DP), allocatable, dimension(:,:) :: cpst,forct,cpdt,transfor
    integer :: ndim
    dt = dimvars%dt
    fmax = 0.d0
    allocate(transfor(dimvars%natm,3));transfor=0.d0
    do i=1, dimvars%natm
      if(dimvars%mobile(i) /= ON) cycle
      ftrans0(:) = dimvars%ftrans(i,:)
      if(dimvars%curvature>0) then
        transfor(i,:) = -dimvars%fpara(i,:)
      else 
        transfor(i,:) =  dimvars%fR(i,:)-2*dimvars%fpara(i,:)
      endif
    enddo
    if (dimer_time_integral == QUENCHED_MD) then
      do i=1, dimvars%natm
        if(dimvars%mobile(i) /= ON) cycle
        ftrans0(:) = dimvars%ftrans(i,:)
        ftrans(:)  = transfor(i,:)
        unitf=0.d0
        if(dot_product(ftrans,ftrans)/=0) unitf=ftrans/dsqrt(dot_product(ftrans,ftrans))
        v = dimvars%velocity(i,:) 
        mass = ionic_mass(i)
        v1 = v + 0.5d0*dt*(ftrans0+ftrans)/mass
        v = 0.d0
        if( dot_product(v1,unitf) >= 0.0d0) then
          v = unitf * dot_product(v1,unitf)
        else
          if (mype==0) write(nfout,'(a,i6)') 'quenched velocity of atom : ',i
        end if
        dimvars%r1(i,:) = dimvars%r1(i,:) + v(:)*dt + ftrans(:)*dt**2/mass
        dimvars%r2(i,:) = dimvars%r1(i,:) - 2*dimvars%N(i,:)*dimvars%dR
        dimvars%ftrans(i,:) = ftrans(:)
        dimvars%velocity(i,:) = v
      enddo
    else if (dimer_time_integral == FIRE) then
      ndim = dimvars%natm
      allocate(cpst(ndim,3));  cpst  = dimvars%r1
      allocate(cpdt(ndim,3));  cpdt  = dimvars%velocity
      allocate(forct(ndim,3)); forct = transfor
      call m_IS_fire_core(nfout, ndim, itr, cpst, cpdt, forct, dimvars%mobile)
      dimvars%r1       = cpst
      dimvars%r2       = dimvars%r1 - 2*dimvars%N*dimvars%dR
      dimvars%ftrans   = transfor
      dimvars%velocity = cpdt
      deallocate(cpst)
      deallocate(cpdt)
      deallocate(forct)
    else
      write(nfout,*) 'unsupported dimer_time_integral ', dimer_time_integral
      call phase_error_with_msg(nfout,'unsupported dimer_time_integral',__LINE__,__FILE__)
    endif

    fmax = 0.d0
    do i=1, dimvars%natm
      fabs = sqrt(dot_product(transfor(i,:),transfor(i,:)))
      if (fabs>fmax) fmax = fabs
    enddo
    dimvars%max_force = fmax

    deallocate(transfor)
    if(mype==0) write(nfout, '(a,f15.8)') '!** DIMER METHOD max translational force ',fmax

  end subroutine translate_dimer

  subroutine cal_dtheta(natm, deltheta)
    integer, intent(in) :: natm
    real(kind=8), intent(out) :: deltheta
    real(kind=8) :: fscalar, fscalarp, invdtheta, maxfscalar, thetat, fscalarperp, maxperp, perp
    integer :: i
    invdtheta = 1.d0/dimvars%dtheta
    deltheta = 0.d0
    maxfscalar = 0.d0
    fscalar  = 0.d0
    fscalarperp  = 0.d0
    fscalarp = 0.d0
    thetat = 0.d0
    maxperp = 0.d0
    do i=1, dimvars%natm
      fscalar = fscalar + dot_product(dimvars%fperpold(i,:), dimvars%thetaold(i,:)) &
                        + dot_product(dimvars%fperp(i,:), dimvars%theta(i,:))
      fscalarp = fscalarp + (dot_product(dimvars%f(i,:),    dimvars%theta(i,:)) -   &
                             dot_product(dimvars%fold(i,:), dimvars%thetaold(i,:))) &
               * invdtheta
!      fscalarperp = fscalarperp + dot_product(dimvars%fperpold(i,:), dimvars%thetaold(i,:)) / &
!                dimvars%dR
!      thetat = thetat + (dot_product(dimvars%f(i,:),    dimvars%theta(i,:)) +   &
!                         dot_product(dimvars%fold(i,:), dimvars%thetaold(i,:)))
    enddo
    !deltheta = -0.5d0*atan(2.d0*dimvars%dR*fscalar/abs(fscalarp))
    deltheta = -0.5d0*atan(fscalar/abs(fscalarp))
  end subroutine cal_dtheta

  subroutine dealloc_dimer()
    deallocate(dimvars%r0)
    deallocate(dimvars%r1)
    deallocate(dimvars%r2)
    deallocate(dimvars%mobile)
    deallocate(dimvars%N)
    deallocate(dimvars%theta)
    deallocate(dimvars%thetaold)
    deallocate(dimvars%velocity)
    deallocate(dimvars%f1perp)
    deallocate(dimvars%f1para)
    deallocate(dimvars%f2perp)
    deallocate(dimvars%f2para)
    deallocate(dimvars%fperp)
    deallocate(dimvars%fpara)
    deallocate(dimvars%fR)
    deallocate(dimvars%f)
    deallocate(dimvars%fold)
    deallocate(dimvars%ftrans)
  end subroutine dealloc_dimer

  subroutine m_dm_set_standard_out_opened(tf)
    logical, intent(in) :: tf
    standard_out_opened = tf
  end subroutine m_dm_set_standard_out_opened

  subroutine set_dimer_condition()
    use m_Files, only : F_OUT, F_CHGT, F_CNTN, F_CNTN_BIN, F_ZAJ, F_CHR &
            , F_CNTN_BIN_PAW, F_OCCMAT
    if(dimer_cond_set) return
    dimvars%file_type%F_OUT = trim(F_OUT)
    dimvars%file_type%F_CHGT = trim(F_CHGT)
    dimvars%file_type%F_CNTN = trim(F_CNTN)
    dimvars%file_type%F_CNTN_BIN = trim(F_CNTN_BIN)
    dimvars%file_type%F_ZAJ = trim(F_ZAJ)
    dimvars%file_type%F_CHR = trim(F_CHR)

! ======================== KT_add ================= 13.0D
    dimvars%file_type%F_CNTN_BIN_PAW = trim(F_CNTN_BIN_PAW)
! ================================================= 13.0D
    dimvars%file_type%F_OCCMAT = F_OCCMAT

    dimer_cond_set = .true.

  end subroutine set_dimer_condition

  subroutine set_dimer_replica_parameter(image_id, istep)
    use m_Const_Parameters, only : ON
    use m_Control_parameters, only : icond, ipriparadeb, sw_hubbard
    use m_IterationNumbers, only : iteration,iteration_electronic,iteration_ionic
    use m_Replica
    use m_Files
    use m_Parallelization,  only : mype

    integer, intent(in) :: image_id, istep
    character(4) image_name

    if( istep > 1 .and. icond == 0) then
       icond = 1
    end if

    write(image_name,'(a1,i3.3)') 'r', image_id
  
!    F_OUT = trim(dimvars%file_type%F_OUT)//'_'//image_name
    F_OUT = trim(dimvars%file_type%F_OUT)

! ===== KT_add === 2014/07/20
#ifdef NEB_NEW_FILENAMES
!  F_OUT = trim(F_OUT_BASE)//'_'//image_name &
!       &              //trim(F_CONF_EXTENSION)//trim(F_PARA_EXTENSION)
!    F_OUT = trim(adjustl(F_OUT_BASE)) // '_' //image_name &
!         &                             // trim(adjustl(F_PARA_EXTENSION))
    F_OUT = trim(adjustl(F_OUT_BASE)) // trim(adjustl(F_PARA_EXTENSION))
! ================ 2014/07/20
#endif

    if(.not.standard_out_opened) then
      call m_Files_open_standardout()
      standard_out_opened = .true.
    endif

  !F_DYNM = trim(dimvars%file_type%F_DYNM)//'_'//image_name
  !F_ENF = trim(dimvars%file_type%F_ENF)//'_'//image_name
    F_CHGT = trim(dimvars%file_type%F_CHGT)//'_'//image_name
    F_CNTN = trim(dimvars%file_type%F_CNTN)//'_'//image_name
    F_CNTN_BIN = trim(dimvars%file_type%F_CNTN_BIN)//'_'//image_name
    F_ZAJ = trim(dimvars%file_type%F_ZAJ)//'_'//image_name
    F_CHR = trim(dimvars%file_type%F_CHR)//'_'//image_name

! ======================== KT_add ================= 13.0D
    F_CNTN_BIN_PAW = trim(dimvars%file_type%F_CNTN_BIN_PAW)//'_'//image_name
! ================================================= 13.0D
    F_OCCMAT = trim(dimvars%file_type%F_OCCMAT)//'_'//image_name

    F_ZAJ_in      = F_ZAJ
    F_CHGT_in     = F_CHGT
    F_CNTN_BIN_in = F_CNTN_BIN
    F_CNTN_in     = F_CNTN

! ======================== KT_add ================= 13.0D
    F_CNTN_BIN_PAW_in = F_CNTN_BIN_PAW
! ================================================= 13.0D

    close(nfcntn)
    close(nfcntn_bin)
    open(nfcntn,file=trim(F_CNTN))
    open(nfcntn_bin,file=trim(F_CNTN_BIN),form='unformatted')

! ======================== KT_add ================= 13.0D
    if ( flg_paw ) then
       call m_Files_close_nfcntn_bin_paw()
       call m_Files_open_nfcntn_bin_paw()
    endif
! ================================================= 13.0D

    iteration = 0
    iteration_electronic = 0
    iteration_ionic = 0
  end subroutine set_dimer_replica_parameter

  subroutine m_dm_do_dimer_method()
    use m_Const_Parameters, only : DP

    implicit none

    integer :: idimer, i
    real(kind=DP) :: maxf
    real(kind=DP) :: deltheta

    call init_dimer_method()

    !calculate energy and force for the initial configuration
    call cal_dimer_scf(1)

    call cal_dimer_energies()
    call cal_dimer_forces()

    do idimer=1, dimvars%max_dimer_iteration
!  do idimer=1, 40
!    call cal_curvature()
      call cal_dimer_energies()
      call cal_dimer_forces()
      deltheta = dimvars%dtheta
      call rotate_dimer(dimvars%natm, deltheta)

      !calculate energy and force after test rotation
      call cal_dimer_scf(idimer+1)

      call cal_curvature()
      call cal_dimer_energies()
      call cal_dimer_forces()
      call cal_dtheta(dimvars%natm, deltheta)
      call rotate_dimer(dimvars%natm, deltheta)
      call update_N()

      !calculate energy and force after rotation
      call cal_dimer_scf(idimer+1)
      call translate_dimer(idimer)
      call set_r0()
      call write_result(idimer)
      if(dimvars%max_force<dimvars%threshold) then
        if(printable) write(nfout,'(a,f15.8)') &
        '!** DIMER METHOD reached convergence. max translational force : ',dimvars%max_force
        exit
      endif
    enddo
    call finalize_dimer_method()
  end subroutine m_dm_do_dimer_method

end module m_dimer

subroutine do_dimer_method()
  use m_dimer, only : m_dm_do_dimer_method
  implicit none
  call m_dm_do_dimer_method()
end subroutine do_dimer_method

#ifdef HIUX
*option MP(P(0))
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 635 $)
!
!  MODULE: m_Parallelization
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, August/23/2006
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
! ***************************************************************
!
! This module "m_Parallelization" is for mpi-parallelization and was
! coded by T. Yamasaki (JRCAT-ATP, Fujitsu Laboratories Ltd.) in 1999.
!
#ifdef __TIMER__
#   define __TIMER_START(a) call timer_init() ; call timer_sta(a)
#   define __TIMER_STOP     call timer_fin()
#else
#   define __TIMER_START(a)
#   define __TIMER_STOP
#endif
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_INICOMM__
#   define __TIMER_INICOMM_START_w_BARRIER(str,a)   call timer_barrier(str) ; call timer_sta(a)
#   define __TIMER_INICOMM_STOP(a)         call timer_end(a)
#else
#   define __TIMER_INICOMM_START_w_BARRIER(str,a)
#   define __TIMER_INICOMM_STOP(a)
#endif

module m_Parallelization
!   (m_Parallel)
! $Id: m_Parallelization.F90 635 2021-02-26 07:16:10Z jkoga $
  use m_Const_Parameters, only       : ON, OFF, tag_npes_etc
  use m_ErrorMessages

  implicit none
  integer :: npes, mype, nrank_e, nrank_k, nrank_g

  integer :: nrank_g1
  integer, allocatable, dimension(:) :: map_e, map_z              ! d(neg)  --> expl.1 and 5
  integer                            :: myrank_e,ista_e,iend_e,istep_e,np_e,mp_e ! --> expl.2 to 4

#ifdef NEC_TUNE_SOFT
  integer, allocatable, dimension(:) :: ista_e_smp, iend_e_smp
  integer                            :: itask
#elif NEC_TUNE_FFT
  integer                            :: itask
#endif
  integer, allocatable, dimension(:) :: nis_e, nie_e, nel_e, idisp_e   ! d(nrank_e)
  integer, allocatable, dimension(:) :: map_k                     ! d(kv3)  
  integer, allocatable, dimension(:,:):: map_ek                   ! d(neg,kv3)
  integer                            :: myrank_k,ista_k,iend_k
  integer, allocatable, dimension(:,:,:) :: map_rank_gek  ! d(nrank_g,nrank_e,nrank_k)
  integer, allocatable, dimension(:) :: nis_k,  nie_k,  nel_k


!!$#ifdef TRANSPOSE
  integer                            :: ista_g1, iend_g1, np_g1, mp_g1
  integer, allocatable, dimension(:) :: nis_g1, nie_g1, nel_g1      !d(0:nrank_g1-1)
  integer, allocatable, dimension(:) :: ista_g1k, iend_g1k, np_g1k, mp_g1k, np_g1k_prev !d(kv3)
  integer, allocatable, dimension(:) :: ista_g1k_prev, iend_g1k_prev
  integer, allocatable, dimension(:,:):: nis_g1k, nie_g1k, nel_g1k  !d(0:nrank_g1-1,kv3)

  integer                            :: ista_fs, iend_fs, np_fs, mp_fs
  integer, allocatable, dimension(:) :: nis_fs, nie_fs, nel_fs      !d(0:nrank_g-1)
  integer                            :: ista_fs_atm, iend_fs_atm, np_fs_atm, mp_fs_atm
  integer, allocatable, dimension(:) :: nis_fs_atm, nie_fs_atm, nel_fs_atm !d(0:nrank_e-1)
  integer                            :: myrank_g
  integer                            :: ista_lmta,iend_lmta
  integer, allocatable, dimension(:) :: lmta_atm

!!$#endif
  integer, allocatable, dimension(:) :: mpi_k_world  ! kd(0:nrank_k-1)
  integer, allocatable, dimension(:) :: mpi_e_world  ! kd(0:nrank_k-1)
! === DEBUG by tkato 2012/04/04 ================================================
  integer                            :: mpi_ge_world
! ==============================================================================
  integer                            :: ista_kngp, iend_kngp, np_kngp, mp_kngp
  integer                            :: ista_kngp_prev, iend_kngp_prev, np_kngp_prev
  integer, allocatable, dimension(:) :: is_kngp, ie_kngp, nel_kngp

  integer                            :: ista_kngp_gw, iend_kngp_gw, np_kngp_gw, mp_kngp_gw
  integer, allocatable, dimension(:) :: is_kngp_gw, ie_kngp_gw, nel_kngp_gw
  integer                            :: ista_kngp_exx, iend_kngp_exx, np_kngp_exx, mp_kngp_exx

  integer, allocatable, dimension(:) :: is_kngp_exx, ie_kngp_exx, nel_kngp_exx
! natm for fxyzew_l
  integer                            :: ista_atm, iend_atm, np_atm, mp_atm
  integer, allocatable, dimension(:) :: is_atm, ie_atm, nel_atm

  integer                            :: ista_atm_ke, iend_atm_ke, np_atm_ke, mp_atm_ke
  integer, allocatable, dimension(:) :: is_atm_ke, ie_atm_ke, nel_atm_ke,map_atm_ke

  integer                            :: ista_atm_f, iend_atm_f, np_atm_f, mp_atm_f
  integer, allocatable, dimension(:) :: is_atm_f, ie_atm_f, nel_atm_f

  integer                            :: ista_rspace_aug, iend_rspace_aug, np_rspace_aug, mp_rspace_aug
  integer, allocatable, dimension(:) :: ista_rspace_aug_atm, iend_rspace_aug_atm
  integer, allocatable, dimension(:) :: is_rspace_aug, ie_rspace_aug, nel_rspace_aug

  integer                            :: ista_nn,iend_nn,np_nn,mp_nn
  integer, allocatable, dimension(:) :: is_nn, ie_nn, nel_nn

  integer                            :: ista_nq, iend_nq, np_nq, mp_nq
  integer, allocatable, dimension(:) :: is_nq, ie_nq, nel_nq, map_nq, map_z_nq

!  integer                            :: ista_nval,iend_nval,np_nval,mp_nval
!  integer, allocatable, dimension(:) :: is_nval, ie_nval, nel_nval

! natm2 for s_ew in m_Ionic_System
  integer                            :: ista_atm2, iend_atm2, np_atm2, mp_atm2
  integer, allocatable, dimension(:) :: is_atm2, ie_atm2, nel_atm2

! BROYDEN or DFP MIXING METHOD
  integer                            :: ista_kgpm,iend_kgpm, np_kgpm, mp_kgpm
  integer, allocatable, dimension(:) :: is_kgpm,  ie_kgpm, nel_kgpm

! FFT BOX
  integer                            :: npes_cdfft, nrank_ggacmp, nrest_cdfft
!!$  integer                            :: myrank_cdfft, myrank_ggacmp, max_ggacmp
  integer                            :: myrank_cdfft, myrank_ggacmp
  integer, allocatable, dimension(:) :: map_ggacmp ! d(3)
  integer, allocatable, dimension(:) :: mpi_ggacmp_cross_world ! d(0:npes_cdfft-1)
  integer, allocatable, dimension(:) :: mpi_cdfft_world        ! d(0:nrank_ggacmp-1)
  integer, allocatable, dimension(:) :: map_pe2ggacmp, map_pe2cdfft    ! d(0:npes-1)

  integer                            :: ista_sfftp, iend_sfftp, np_sfftp, mp_sfftp
  integer                            :: ista_sfftph,iend_sfftph
  integer, allocatable, dimension(:) :: nis_sfftp,  nie_sfftp,  nel_sfftp, idisp_sfftp
  integer, allocatable, dimension(:) :: nis_sfftph, nie_sfftph, nel_sfftph
  integer                            :: ista_fftp, iend_fftp, np_fftp, mp_fftp
  integer                            :: ista_fftph,iend_fftph
  integer, allocatable, dimension(:) :: nis_fftp,  nie_fftp,  nel_fftp,  idisp_fftp
  integer, allocatable, dimension(:) :: nis_fftph, nie_fftph, nel_fftph, idisp_fftph
  

! NonLocalPotential snl
  integer                            :: ista_snl, iend_snl

! nbmx
  integer  :: ng_nbmx, myrank_nbmx, nrank_nbmx, np_nbmx, mp_nbmx,ista_nbmx, iend_nbmx
  integer  :: nbmx_ext
  integer, allocatable, dimension(:) :: nis_nbmx,nie_nbmx,nel_nbmx, idisp_nbmx
  integer, allocatable, dimension(:) :: mpi_nbmx_world  ! kd(0:nrank_nbmx-1)
  integer  :: ng_nbmx_k, myrank_nbmx_k, nrank_nbmx_k, np_nbmx_k, mp_nbmx_k &
       & ,ista_nbmx_k, iend_nbmx_k
  integer, allocatable, dimension(:) :: nis_nbmx_k, nie_nbmx_k, nel_nbmx_k, idisp_nbmx_k
! kg1
  integer, allocatable, dimension(:) :: mpi_nbmx_world_k  ! kd(0:nrank_nbmx_k-1)
  integer  :: np_kg1_k, mp_kg1_k, ista_kg1_k, iend_kg1_k
  integer  :: kg1_ext
  integer, allocatable, dimension(:) :: nis_kg1_k, nie_kg1_k, nel_kg1_k, idisp_kg1_k

  integer                            :: ierr
  character(len=50)                  :: workdir
  integer                            :: sw_wdir = 0

  integer                            :: mpi_comm_group
  integer                            :: color,key

  logical,save                       :: conf_para = .false.
  integer,save                       :: mype_conf = 0
  integer                            :: nrank_conf

  integer :: nrank_nvale,myrank_nvale
  integer :: ista_nvale,iend_nvale,np_nvale,mp_nvale
  integer, allocatable, dimension(:) :: nis_nvale,nie_nvale,nel_nvale
  integer, allocatable, dimension(:) :: map_nvale,map_z_nvale
  logical,private :: mpi_nvale_enabled = .false.

  integer :: nrank_kv3_ek,myrank_kv3_ek
  integer :: ista_kv3_ek,iend_kv3_ek,np_kv3_ek,mp_kv3_ek
  integer, allocatable, dimension(:) :: nis_kv3_ek,nie_kv3_ek,nel_kv3_ek
  integer, allocatable, dimension(:) :: map_kv3_ek,map_z_kv3_ek


! for nfft
  integer                            :: ista_ffth, iend_ffth, np_ffth, mp_ffth
  integer, allocatable, dimension(:) :: is_ffth, ie_ffth, nel_ffth

! whether parallelization was configured from the command line or not
  logical :: read_from_args = .false.

! 1. map_e(neg)
! rank# = map_e(ieg) : rank# is the rank number which operates ieg-th data
!  -- examples --
!  (case 1) cyclic partitioning case (assuming nrank_e == 3 and neg == 8)
!   ieg :   1   2   3   4   5   6   7   8
! rank# :   0   1   2   0   1   2   0   1
!
!  (case 2) block  partitioning case (also assuming nrank_e == 3 and neg == 8)
!   ieg :   1   2   3   4   5   6   7   8
! rank# :   0   0   0   1   1   1   2   2
!
! 2. myrank_e
!  This lets each node know its rank number according to an axis-e.
!  -- an example --
!  Assuming nrank_e == 4 and nrank_k == 2
!   #rank (or #pe)  0  1  2  3  4  5  6  7
!   myrank_e        0  1  2  3  0  1  2  3
!
! 3. ista_e, iend_e, istep_e, nis_e, nie_e
!  ista_e, iend_e : Bounds of a window which is a range 'e' runs in each nrank_e.
!  nis_e,  nie_e  : Bounds of windows. This shows all windows ranges.
!  istep_e        : = nrank_e (the cyclic partitioning case)
!                   = 1       (the block partitioning case)
!  -- examples --
!  Assuming nrank_e == 3, nrank_k == 2 and neg ==  8
!  (case 1) cyclic partitioning case
!   #rank (or #pe)  0  1  2  3  4  5
!   ista_e          1  2  3  1  2  3
!   iend_e          7  8  6  7  8  6
!   istep_e         3  3  3  3  3  3
!   nis_e(#rank)    1  2  3  1  2  3
!   nie_e(#rank)    7  8  6  7  8  6
!
!  (case 2) block partitioning case
!   #rank (or #pe)  0  1  2  3  4  5
!   ista_e          1  4  7  1  4  7
!   iend_e          3  6  8  3  6  8
!   istep_e         1  1  1  1  1  1
!   nis_e(#rank)    1  4  7  1  4  7
!   nie_e(#rank)    3  6  8  3  6  8
!
! 4. np_e, mp_e, nel_e
!  np_e is the number of elements of e which each rank_e operates
!  mp_e is the maximum of np_e's over all nodes
!  -- examples --
!  Assuming nrank_e == 3, nrank_k == 2 and neg ==  8
!   #rank (or #pe)  0  1  2  3  4  5
!   np_e            3  3  2  3  3  2
!   mp_e            3  3  3  3  3  3
!   nel_e(#rank)    3  3  2  3  3  2
!
! 5. map_z(neg)
! j = map_z(ieg) : ieg-th data is mapped on j-th position on the
!                 map_e(i)-th array. Common on all ranks
!  -- examples --
! Assuming nrank_e = 3 and neg = 8
!  (case 1) cyclic partitioning case
!   ieg    :   1   2   3   4   5   6   7   8
!  rank_e# :   0   1   2   0   1   2   0   1
!    j     :   1   1   1   2   2   2   3   3
!  (case 2) block partitioning case
!   ieg    :   1   2   3   4   5   6   7   8
!  rank_e# :   0   0   0   1   1   1   2   2
!    j     :   1   2   3   1   2   3   1   2
!
! 6. map_k(kv3)
! rank_k# = map_k(ik) : rank_k# is the rank number which operates ik-th data
!  -- an examples --
!  Assuming nrank_k == 2 and kv3 == 9)
!    ik   :   1   2   3   4   5   6   7   8   9
! rank_k# :   0   0   0   0   0   1   1   1   1
!
! 7. map_ek(neg,kv3)
! rank# = map_ek(ie,ik) : rank# is,  in the whole using nodes, the rank number which operates
!                         ie-th and -k-th data
!  -- an example --
!  Assuming nrank_e == 2, nrank_k = 2, npes == 4, neg == 8 and kv3 = 5
!  and taking block partitioning for an axis-'e'.
!   ik   : 1 1 1 1 1 1 1 1 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 4 4 4 4 4 4 4 4 5 5 5 5 5 5 5 5
!   ie   : 1 2 3 4 5 6 7 8 1 2 3 4 5 6 7 8 1 2 3 4 5 6 7 8 1 2 3 4 5 6 7 8 1 2 3 4 5 6 7 8
! rank_k#: 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
! rank_e#: 0 0 0 0 1 1 1 1 0 0 0 0 1 1 1 1 0 0 0 0 1 1 1 1 0 0 0 0 1 1 1 1 0 0 0 0 1 1 1 1
! rank#  : 0 0 0 0 1 1 1 1 0 0 0 0 1 1 1 1 0 0 0 0 1 1 1 1 2 2 2 2 3 3 3 3 2 2 2 2 3 3 3 3
!
! 8. myrank_k
!  This lets each node know its rank number according to an axis-k.
!  -- an example --
!  Assuming nrank_e == 4 and nrank_k == 2
!   #rank (or #pe)  0  1  2  3  4  5  6  7
!   myrank_k        0  0  0  0  1  1  1  1
!   myrank_e        0  1  2  3  0  1  2  3  (for reference, assuming block partitioning)
!
! 9. ista_k, iend_k
!  ista_k, iend_k : bounds of a window which is a range each nrank_k node operates
!
!10. ista_g1, iend_g1, nis_g1, nie_g1, nel_g1
!  ista_g1,iend_g1: bounds of a window which is a range 'g' runs in each nrank_e after transpose.
!  -- An example --
!  Assuming nrank_e == 3, nrank_k == 2 and kg1 == 101
!   #rank (or #pe)  0   1   2   3   4   5
!   ista_e          1  35  69   1  35  69
!   iend_e         34  68 101  34  68 101
!
!11. np_g1, mp_g1
!  np_g1 is the number of elements of 'g' which each rank_e operates
!  mp_g1 is the maximum of np_g1's over all nodes
!  -- examples --
!  Assuming nrank_e == 3, nrank_k == 2 and kg1 ==  101
!   #rank (or #pe)  0  1  2  3  4  5
!   np_g1          34 34 33 34 34 33
!   mp_g1          34 34 34 34 34 34
!
!12. mpi_k_world(0:nrank_k-1)
! Sub-group of rank_k
!
!13. ng_nbmx, myrank_nbmx, nrank_nbmx,np_nbmx, mp_nbmx, nel_nbmx(#rank_nbmx),
!    ista_nbmx, and iend_nbmx
!  np_nbmx is the number of elements of G which each rank_nbmx operates
!  mp_nbmx is the maximum of np_nbmx's over all nodes in a mpi_nbmx_world
!  -- example --
!  Assuming nbmx = 152, nrank_nbmx = 3 or 2, npe = 5, and ngnode_nbmx = 2
!  #rank (or #pe)               0   1   2   3   4
!  ng_nbmx                      0   1   0   1   0
!  myrank_nbmx                  0   0   1   1   2
!  nrank_nbmx                   3   2   3   2   3
!  np_nbmx                     51  76  51  76  50
!  mp_nbmx                     51  76  51  76  51
!  nel_nbmx(#rank_nbmx)        51  76  51  76  50
!  ista_nbmx                    1   1  52  77 103
!  iend_nbmx                   51  76 102 152 152
!
!                          ||
!
!  ng_nbmx            (      0       ) (    1    )
!  #rank ( or #node)    0    2    4       1   3
!  nrank_nbmx           3    3    3       2   2
!  myrank_nbmx          0    1    2       0   1
!    np_nbmx           51   51   50      76  76
!    mp_nbmx           51   51   51      76  76
! nel_nbmx(#rank_nbmx) 51   51   50      76  76
!    ista_nbmx          1   52  103       1  77
!    iend_nbmx         51  102  152      76 152
! 
!14. mpi_nbmx_world(0:nrank_nbmx-1)
! Sub-group of rank_nbmx
!
  include 'mpif.h'             ! MPI
  integer                            :: istatus(MPI_STATUS_SIZE)
contains

  subroutine m_Parallel_init_comm_world(init_mpi)
!!$    character :: F_OUT*13, name_mype*3
!!$    character :: name_jobstep*3
!!$    integer ::   i, js
!!$    logical ::   existence
    integer, optional, intent(in) :: init_mpi
    integer :: inimpi
    integer :: i,lenc,lencom,ntmp,numdir,np,hispe
    logical :: exist_dirlist
    character(len=50) :: buf
    character(len=50), allocatable :: workdir_array(:)

    integer, allocatable :: color(:),key(:),nproc(:)
    integer :: my_color, my_key
    integer :: maxproc, count, idir, npes1, numdir1
    logical, save :: firstcall = .true.

    workdir = ''
    inimpi=ON
    if(present(init_mpi)) inimpi = init_mpi

    if(inimpi==ON) then

    call mpi_init(ierr)
    call mpi_comm_size(mpi_comm_world, npes, ierr)
    call mpi_comm_rank(mpi_comm_world, mype, ierr)
                                    __TIMER_START(17)
#ifdef FJ_TIMER
                 call timer_sta(21)
#endif

!! Group creation
    inquire(file='dirlist',exist=exist_dirlist)
    if(.not.exist_dirlist) then

       !if(firstcall) call mpi_comm_dup(mpi_comm_world,mpi_comm_group,ierr)
      if(.not.firstcall) call mpi_comm_free(mpi_comm_group, ierr)
      call mpi_comm_dup(mpi_comm_world,mpi_comm_group,ierr)

       !!write(*,*) 'mpi_comm_world=',mpi_comm_world
       !!write(*,*) 'mpi_comm_group=',mpi_comm_group

    else
       !!write(*,*) 'dirlist exists.'
       !! switching working directory
       sw_wdir = 1

       if(mype == 0) then
          open(unit=100,file="dirlist",form='formatted')
          read(100,*) numdir
          !! debug
          !!write(*,*) 'numdir=',numdir
          allocate(workdir_array(numdir))
          ntmp=0
          do i=1,numdir
             buf(1:50) = ' '
             read(100,*,err=500,end=500) buf
             ntmp=ntmp+1
             lenc = len_trim(buf)
             buf(lenc+1:lenc+1) = '/'
             workdir_array(i) = buf
          end do
500       continue
          numdir = ntmp
          
          allocate(color(npes))
          allocate(key(npes))
          allocate(nproc(npes))

          npes1 = npes
          numdir1 = numdir
          count = 0
          my_color = 0
          do while(npes1 > 0)
             maxproc = npes1/numdir1
             if(npes1-maxproc*numdir1>0) maxproc=maxproc+1
             my_color = my_color + 1
             do i=1,maxproc
                nproc(i+count) = maxproc
                color(i+count) = my_color
                key(i+count) = i-1
             end do 
             count = count + maxproc
             npes1 = npes1 - maxproc
             numdir1 = numdir1 -1
          end do

          !!do i=1,npes
          !!   key(i) = mod(i-1,maxproc)
          !!   color(i) = (i-key(i))/maxproc
          !!end do
          !!write(*,'("nproc:",50(1x,i2))') nproc
          !!write(*,'("color:",50(1x,i2))') color
          !!write(*,'("key:",50(1x,i2))') key

          do i=1,npes
             idir = color(i)
             buf = workdir_array(idir)
             !!$write(*,*) buf(1:lenc)
             hispe = i-1
             if(mype /= hispe) then
                call MPI_Send(workdir_array(idir),50,MPI_CHARACTER &
                           & ,hispe,1,MPI_COMM_WORLD,ierr)
                call MPI_Send(color(i),1,MPI_INTEGER &
                           & ,hispe,1,MPI_COMM_WORLD,ierr)
                call MPI_Send(key(i),1,MPI_INTEGER &
                           & ,hispe,1,MPI_COMM_WORLD,ierr)
             else
                workdir = workdir_array(idir)
                my_color = color(i)
                my_key = key(i)
             end if
          end do

          deallocate(workdir_array)
       else
          call MPI_Recv(workdir,50,MPI_CHARACTER, &
                   & MPI_ANY_SOURCE,MPI_ANY_TAG,MPI_COMM_WORLD,istatus,ierr)
          call MPI_Recv(my_color,1,MPI_INTEGER, &
                   & MPI_ANY_SOURCE,MPI_ANY_TAG,MPI_COMM_WORLD,istatus,ierr)
          call MPI_Recv(my_key,1,MPI_INTEGER, &
                   & MPI_ANY_SOURCE,MPI_ANY_TAG,MPI_COMM_WORLD,istatus,ierr)
       end if
       call MPI_barrier(MPI_COMM_WORLD,ierr)
       !!write(*,*) 'workdir=',trim(workdir)
       !!my_color = mype
       !!my_key = 0
       !if(firstcall) call mpi_comm_split(MPI_COMM_WORLD,my_color,my_key,mpi_comm_group,ierr)
       if(.not.firstcall) call mpi_comm_free(mpi_comm_group, ierr)
       call mpi_comm_split(MPI_COMM_WORLD,my_color,my_key,mpi_comm_group,ierr)
       call mpi_comm_size(mpi_comm_group, npes, ierr)
       call mpi_comm_rank(mpi_comm_group, mype, ierr)
       !!write(*,*) 'mpi_comm_group=',mpi_comm_group
       !!write(*,*) 'npes=',npes
       !!write(*,*) 'myes=',mype
       !!write(*,*) 'workdir=',trim(workdir)

       !! debug
       !!call mpi_Finalize(ierr)
       !!stop 'group_creation end'

    end if
!! Group creation

    else

    call mpi_comm_size(mpi_comm_group, npes, ierr)
    call mpi_comm_rank(mpi_comm_group, mype, ierr)

    endif

    firstcall = .false.

!!$    if(npes > 1) then
!!$       write(name_mype,'(i3)') mype
!!$       do i = 1, 3
!!$          if(name_mype(i:i) == ' ') name_mype(i:i)='0'
!!$       enddo
!!$
!!$       if(mype==0) then
!!$          do js = 0, 999
!!$             write(name_jobstep,'(i3)') js
!!$             do i = 1, 3
!!$                if(name_jobstep(i:i) == ' ') name_jobstep(i:i)='0'
!!$             enddo
!!$             F_OUT = 'output'//name_jobstep
!!$             inquire(file=F_OUT, exist=existence)
!!$             if(.not.existence) goto 1001
!!$          end do
!!$1001      if(js >=1000) js = 999
!!$       end if
!!$       if(npes > 1) call mpi_bcast(js,1,mpi_integer,0,mpi_comm_world,ierr)
!!$       write(name_jobstep,'(i3)') js
!!$       do i = 1, 3
!!$          if(name_jobstep(i:i) == ' ') name_jobstep(i:i)='0'
!!$       enddo
!!$
!!$       if(mype==0) then
!!$          F_OUT = 'output'//name_jobstep
!!$       else
!!$          F_OUT = 'output'//name_jobstep//'_'//name_mype
!!$       end if
!!$    else if(npes == 1) then
!!$       do js = 0, 999
!!$          write(name_jobstep,'(i3)') js
!!$          do i = 1, 3
!!$             if(name_jobstep(i:i) == ' ') name_jobstep(i:i)='0'
!!$          enddo
!!$          F_OUT = 'output'//name_jobstep
!!$          inquire(file=F_OUT, exist=existence)
!!$          if(.not.existence) goto 1000
!!$       end do
!!$1000   continue
!!$    end if
!!$    open(6, file=F_OUT, status='unknown', form='formatted')

  end subroutine m_Parallel_init_comm_world

  subroutine m_Parallel_init_comm_group(mpi_comm_root)
!!$    character :: F_OUT*13, name_mype*3
!!$    character :: name_jobstep*3
!!$    integer ::   i, js
!!$    logical ::   existence
    integer,  intent(in) :: mpi_comm_root
    integer :: inimpi

    logical, save :: firstcall = .true.

    workdir = ''

    inimpi=ON

    if(inimpi==ON) then

      if(.not.firstcall) call mpi_comm_free(mpi_comm_group, ierr)
      call mpi_comm_dup(mpi_comm_root,mpi_comm_group,ierr)
      call MPI_barrier(mpi_comm_group,ierr)
      call mpi_comm_size(mpi_comm_group, npes, ierr)
      call mpi_comm_rank(mpi_comm_group, mype, ierr)
                                    __TIMER_START(17)
#ifdef FJ_TIMER
                 call timer_sta(21)
#endif


    else

      call mpi_comm_size(mpi_comm_group, npes, ierr)
      call mpi_comm_rank(mpi_comm_group, mype, ierr)

    endif

    firstcall = .false.

  end subroutine m_Parallel_init_comm_group

  subroutine m_Parallel_init_mpi(printable)
    logical, intent(in) :: printable
    integer   :: i
    integer, dimension(8) :: ipresent_time

!!$    call mpi_init(ierr)
!!$    call mpi_comm_size(mpi_comm_world, npes, ierr)
!!$    call mpi_comm_rank(mpi_comm_world, mype, ierr)

    call date_and_time(values=ipresent_time)

    if(printable) then
       write(6,'(" !|| program start    ",i2,":",i2,":",i2,"  ",i2,"/",i2,"/",i4)') &
            & ipresent_time(5:7),ipresent_time(3),ipresent_time(2),ipresent_time(1)
    
       write(6,'(" npes = ",i6)') npes
       write(6,'(" mype = ",i3," mpi_comm_world = ",i3)') mype,mpi_comm_group
       write(6,'(" mype = ",i3," mpi_comm_world = ",i3)') mype,mpi_comm_group
    end if

    call mpi_barrier(mpi_comm_group,ierr)
    if(printable) write(6,'(" mpi_comm_world = ",i5," mype = ",i5)') mpi_comm_group, mype
    call mpi_barrier(mpi_comm_group,ierr)

  end subroutine m_Parallel_init_mpi

  subroutine m_Parallel_get_nproc_from_arg(printable)
    logical, intent(in) :: printable
#ifndef IRIX64
    character(100) :: q1
    integer     :: narg, iargc
#endif
    integer     :: n1, n2
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.02.27 !!!!!!!!!!!!!!
    integer     :: nn , neflag, nkflag
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.02.27 !!!!!!!!!!!!!!

    if(printable) then
      if(conf_para) then
        write(6,'(a)') ''
        write(6,'(a)') '-- configuration-parallelization scheme enabled --'
        write(6,'(a,i8)')  '   nrank_config : ',nrank_conf
        write(6,'(a,i8)')  '   mype_config  : ',mype_conf
        write(6,'(a,i20)') '   communicator : ',mpi_comm_group
        write(6,'(a)') ''
      endif
      if(sw_wdir==1)then
        write(6,'(a)') ''
        write(6,'(a)') '-- directory-parallelization scheme enabled --'
        write(6,'(a)') '   current working directory : '//trim(workdir)
        write(6,'(a)') ''
      endif
!!$       write(6,'(" << m_Parallel_get_nproc_from_arg>>")')
       write(6,'(" npes = ",i6," << m_Parallel_get_nproc_from_arg>>")') npes
!!$       write(6,'(" mype = ",i3," mpi_comm_world = ",i3)') mype,mpi_comm_world
!!$       write(6,'(" mype = ",i3," mpi_comm_world = ",i3)') mype,mpi_comm_world
    end if

#ifndef IRIX64

!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.02.27 !!!!!!!!!!!!!!
    read_from_args = .false.
    if(mype==0) then

       neflag=0
       nkflag=0
       narg = iargc()
!!$       if(printable) write(6,'(" narg = ", i3)') narg

       do nn = 1,narg
          call getarg(nn,q1)

!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
          q1 = trim(adjustl(q1))
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
!!          if(index(trim(adjustl(q1)),"ne").ne.0) then

          if(q1(1:1) == "n".and. q1(2:2) == "e") then
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
             neflag = neflag+1
             if((q1(3:3) == "=".or.q1(3:3) == ":") .and. len_trim(q1(4:)).ne.0) then
                 q1 = q1(4:)
                 if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                    read(q1,*) n1
                 else
                    if(printable) write(6,*) 'wrong ne'
                    !stop "wrong ne "
                    call phase_error_with_msg(6,'wrong ne',__LINE__,__FILE__)
                 end if
             else if(q1(3:3) == "=".or. q1(3:3) == ":") then
                 call getarg(nn+1,q1)
                 if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                    read(q1,*) n1
                 else
                    if(printable) write(6,*) 'wrong ne'
                    !stop "wrong ne "
                    call phase_error_with_msg(6,'wrong ne',__LINE__,__FILE__)
                 end if
             else
                  call getarg(nn+1,q1)
                  if(q1(1:1) == ":".and. len_trim(q1(2:)).ne.0) then 
                      q1 = q1(2:)
                      if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                         read(q1,*) n1
                      else
                         if(printable) write(6,*) 'wrong ne'
                         !stop "wrong ne "
                         call phase_error_with_msg(6,'wrong ne',__LINE__,__FILE__)
                      end if
                  else if((q1(1:1) == "=".or.q1(1:1) == ":").and. len_trim(q1(2:)).eq.0) then
                      call getarg(nn+2,q1) 
                      if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                         read(q1,*) n1
                      else
                         if(printable) write(6,*) 'wrong ne'
                         !stop "wrong ne "
                         call phase_error_with_msg(6,'wrong ne',__LINE__,__FILE__)
                      end if
                   else
                      if(printable) write(6,*) 'wrong ne'
                      !stop "wrong ne "
                      call phase_error_with_msg(6,'wrong ne',__LINE__,__FILE__)
                   end if                   
             end if
          end if

!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
!!          if(index(trim(adjustl(q1)),"nk").ne.0) then

          if(q1(1:1) == "n".and. q1(2:2) == "k") then
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!

             nkflag = nkflag+1
             if((q1(3:3) == "=".or.q1(3:3) == ":") .and. len_trim(q1(4:)).ne.0) then
                 q1 = q1(4:)
                 if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                    read(q1,*) n2
                 else
                    if(printable) write(6,*) 'wrong nk'
                    !stop "wrong nk "
                    call phase_error_with_msg(6,'wrong nk',__LINE__,__FILE__)
                 end if
             else if(q1(3:3) == "=".or.q1(3:3) == ":") then
                 call getarg(nn+1,q1)
                 if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                    read(q1,*) n2
                 else
                    if(printable) write(6,*) 'wrong nk'
                    !stop "wrong nk "
                    call phase_error_with_msg(6,'wrong nk',__LINE__,__FILE__)
                 end if
             else
                  call getarg(nn+1,q1)
                  if(q1(1:1) == ":".and. len_trim(q1(2:)).ne.0) then 
                      q1 = q1(2:)
                      if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                         read(q1,*) n2
                      else
                         if(printable) write(6,*) 'wrong nk'
                         !stop "wrong nk "
                         call phase_error_with_msg(6,'wrong nk',__LINE__,__FILE__)
                      end if
                  else if((q1(1:1) == "=".or.q1(1:1) == ":").and. len_trim(q1(2:)).eq.0) then 
                      call getarg(nn+2,q1) 
                      if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                         read(q1,*) n2
                      else
                         if(printable) write(6,*) 'wrong nk'
                         !stop "wrong nk "
                         call phase_error_with_msg(6,'wrong nk',__LINE__,__FILE__)
                      end if
                   else
                      if(printable) write(6,*) 'wrong nk'
                      !stop "wrong nk "
                      call phase_error_with_msg(6,'wrong nk',__LINE__,__FILE__)
                   end if                   
             end if
          end if

       end do        


       if(neflag == 0 .or. nkflag == 0) then
!          if(printable) write(6,*) 'set default ne and nk'
          n1 = npes
          n2 = npes/n1
       else
          read_from_args = .true.
       end if

       if(neflag >= 2 .or. nkflag >= 2) then
          !if(printable) write(6,*) 'wrong ne and nk'
          !stop "wrong ne and nk "
          call phase_error_with_msg(6,'wrong ne and nk',__LINE__,__FILE__)
       end if

    end if
!  <---- ! modified by mizouchi@adv 2003.02.27 !!!!!!!!!!!!!!

    if(npes>1) call mpi_bcast(n1,1,mpi_integer,0,mpi_comm_group,ierr)
    if(npes>1) call mpi_bcast(n2,1,mpi_integer,0,mpi_comm_group,ierr)
    if(npes>1) call mpi_bcast(read_from_args,1,mpi_logical,0,mpi_comm_group,ierr)
!!$    if(printable) write(6,*) 'ne, nk = ',n1,n2
#else
    n1 = 1       ! in-chiki
    n1 = npes/2  ! in-chiki
    if(n1 == 0 .or. n1 > npes) n1 = npes
    n2 = npes/n1
#endif
    if(n1*n2 /= npes) then
       call phase_execution_error(PARALLELIZATION_INVALID_2D)
    else
       nrank_e  = n1
       nrank_k  = n2
       if(printable) then
          if(read_from_args)then
            !!$ if(mype == 0) print '(" nrank_e = ", i3)', nrank_e
            write(6,'(" nrank_e = ",i3)') nrank_e
            !!$ if(mype == 0) print '(" nrank_k = ", i3)', nrank_k
            write(6,'(" nrank_k = ",i3)') nrank_k
          endif
       end if
    end if
!!$#ifdef TRANSPOSE
    nrank_g1 = nrank_e
!!$#endif  
  end subroutine m_Parallel_get_nproc_from_arg

  subroutine m_Parallel_wd_npes_etc(nfcntn)
    integer, intent(in) :: nfcntn
    if(mype==0) then
       write(nfcntn,*) tag_npes_etc
       write(nfcntn,'(3i10)') npes,nrank_e,nrank_k
    end if
  end subroutine m_Parallel_wd_npes_etc


  subroutine m_Parallel_init_mpi_nbmx(nfout,ipri,printable,nbmx,kg1,ngnode_nbmx,flag_mpi,flag_mpi_k)
    integer, intent(in) :: nfout,ipri,nbmx, kg1, ngnode_nbmx
    logical, intent(in) :: printable,flag_mpi,flag_mpi_k
    integer             :: i, j, ip, icolor, key, np
    integer             :: newpes, newmype
    logical, save       :: firstcall=.true.
                                                  __TIMER_SUB_START(1235)

    if(.not.flag_mpi) then
! (( ng_nbmx, myrank_nbmx, nrank_nbmx, np_nbmx, mp_nbmx, ista_nbmx, iend_nbmx
       ng_nbmx = mype
       myrank_nbmx = 0
       nrank_nbmx  = 1
       np_nbmx = nbmx
       mp_nbmx = nbmx
       ista_nbmx = 1
       iend_nbmx = nbmx
       nbmx_ext = nbmx
       if(ipri >= 2 .and. printable) then
          write(nfout,'(" !|| -- parallelization parameters for nbmx --")')
          write(nfout,'(" !||  - ng_nbmx     = ",i12)') ng_nbmx
          write(nfout,'(" !||  - myrank_nbmx = ",i12)') myrank_nbmx
          write(nfout,'(" !||  - nrank_nbmx  = ",i12)') nrank_nbmx
          write(nfout,'(" !||  - nbmx, nbmx_ext = ",2i12)') nbmx, nbmx_ext
          write(nfout,'(" !||  - np_nbmx     = ",i12)') np_nbmx
          write(nfout,'(" !||  - mp_nbmx     = ",i12)') mp_nbmx
          write(nfout,'(" !||  - ista_nbmx   = ",i12)') ista_nbmx
          write(nfout,'(" !||  - iend_nbmx   = ",i12)') iend_nbmx
       end if
    else
! (( ng_nbmx, myrank_nbmx, nrank_nbmx, np_nbmx, mp_nbmx, ista_nbmx, iend_nbmx
!      , nis_nbmx, nie_nbmx, nel_nbmx, idisp_nbmx))
       ng_nbmx     = floor(mod(mype+1, ngnode_nbmx) - 0.5)
       if(ng_nbmx < 0) ng_nbmx = ng_nbmx + ngnode_nbmx
       myrank_nbmx = floor((mype+0.5)/ngnode_nbmx)
       nrank_nbmx  = (npes - ng_nbmx-1)/ngnode_nbmx + 1

       if(.not.allocated(mpi_nbmx_world)) allocate(mpi_nbmx_world(0:ngnode_nbmx-1))

       allocate(nis_nbmx(0:nrank_nbmx-1))
       allocate(nie_nbmx(0:nrank_nbmx-1))
       allocate(nel_nbmx(0:nrank_nbmx-1))
       allocate(idisp_nbmx(0:nrank_nbmx-1))

       call set_block_range4allgather(nbmx,nrank_nbmx,nel_nbmx,nis_nbmx,nie_nbmx,idisp_nbmx)
       ista_nbmx = nis_nbmx(myrank_nbmx)
       iend_nbmx = nie_nbmx(myrank_nbmx)
       np_nbmx = nel_nbmx(myrank_nbmx)
       mp_nbmx = maxval(nel_nbmx)
       nbmx_ext = mp_nbmx*nrank_nbmx

       if(ipri >= 1 .and. printable) then
          write(nfout,'(" !|| -- parallelization parameters for nbmx --")')
          write(nfout,'(" !||  - ng_nbmx     = ",i12)') ng_nbmx
          write(nfout,'(" !||  - myrank_nbmx = ",i12)') myrank_nbmx
          write(nfout,'(" !||  - nrank_nbmx  = ",i12)') nrank_nbmx
          write(nfout,'(" !||  - nbmx, nbmx_ext = ",2i12)') nbmx, nbmx_ext
          write(nfout,'(" !||  - np_nbmx     = ",i12)') np_nbmx
          write(nfout,'(" !||  - mp_nbmx     = ",i12)') mp_nbmx
          write(nfout,'(" !||  - ista_nbmx   = ",i12)') ista_nbmx
          write(nfout,'(" !||  - iend_nbmx   = ",i12)') iend_nbmx
          write(nfout,'(" !||   ( nis_nbmx )",8i10)') (nis_nbmx(i),i=0,nrank_nbmx-1)
          write(nfout,'(" !||   ( nie_nbmx )",8i10)') (nie_nbmx(i),i=0,nrank_nbmx-1)
          write(nfout,'(" !||   ( nel_nbmx )",8i10)') (nel_nbmx(i),i=0,nrank_nbmx-1)
          write(nfout,'(" !||   (idisp_nbmx)",8i10)') (idisp_nbmx(i),i=0,nrank_nbmx-1)
       end if
       
! (( mpi_nbmx_world ))
       do j = 0, ngnode_nbmx-1
          icolor = 0
          key = 0
          if(ng_nbmx == j) then
             icolor = 1
             key = myrank_nbmx
          end if
!          if(firstcall) call mpi_comm_split(mpi_comm_group, icolor, key, mpi_nbmx_world(j),ierr)
          if(.not.firstcall) call mpi_comm_free(mpi_nbmx_world(j), ierr)
          call mpi_comm_split(mpi_comm_group, icolor, key, mpi_nbmx_world(j),ierr)
          call mpi_comm_size(mpi_nbmx_world(j), newpes, ierr)
          call mpi_comm_rank(mpi_nbmx_world(j), newmype,ierr)
       end do
    end if

    if(.not.flag_mpi_k) then
! (( ng_nbmx_k, myrank_nbmx_k, nrank_nbmx_k, np_nbmx_k, mp_nbmx_k, ista_nbmx_k, iend_nbmx_k,
!    ista_kg1_k, iend_kg1_k ))
       ng_nbmx_k = myrank_k
       myrank_nbmx_k = 0
       nrank_nbmx_k  = 1
       np_nbmx_k = nbmx
       mp_nbmx_k = nbmx
       ista_nbmx_k = 1
       iend_nbmx_k = nbmx

       ista_kg1_k = 1
       iend_kg1_k = kg1
       kg1_ext = kg1 
    else
! (( ng_nbmx_k, myrank_nbmx_k, nrank_nbmx_k, np_nbmx_k, mp_nbmx_k, nel_nbmx_k,
!  , ista_nbmx_k, iend_nbmx_k,  nis_kg1_k, nie_kg1_k, nel_kg1_k, ista_kg1_k, iend_kg1_k ))
       ng_nbmx_k     = floor(mod(myrank_e+1, ngnode_nbmx) - 0.5)
       if(ng_nbmx_k < 0) ng_nbmx_k = ng_nbmx_k + ngnode_nbmx
       myrank_nbmx_k = floor((myrank_e+0.5)/ngnode_nbmx)
       nrank_nbmx_k  = (nrank_e - ng_nbmx-1)/ngnode_nbmx + 1

       allocate(nel_nbmx_k(0:nrank_nbmx_k-1))
       allocate(nis_nbmx_k(0:nrank_nbmx_k-1))
       allocate(nie_nbmx_k(0:nrank_nbmx_k-1))
       allocate(idisp_nbmx_k(0:nrank_nbmx_k-1))
       if(.not.allocated(mpi_nbmx_world_k)) then
       allocate(mpi_nbmx_world_k(0:ngnode_nbmx-1))
       endif

       call set_block_range4allgather(nbmx,nrank_nbmx_k,nel_nbmx_k,nis_nbmx_k,nie_nbmx_k,idisp_nbmx_k)
       ista_nbmx_k = nis_nbmx_k(myrank_nbmx_k)
       iend_nbmx_k = nie_nbmx_k(myrank_nbmx_k)
       np_nbmx_k = nel_nbmx_k(myrank_nbmx_k)
       mp_nbmx_k = maxval(nel_nbmx_k)
       np = mp_nbmx_k*nrank_nbmx_k
       if(np .gt. nbmx_ext) nbmx_ext = np

! (( np_kg1_k, mp_kg1_k, nel_kg1_k, ista_kg1_k, iend_kg1_k, idisp_kg1_k ))
       allocate(nel_kg1_k(0:nrank_nbmx_k-1))
       allocate(nis_kg1_k(0:nrank_nbmx_k-1))
       allocate(nie_kg1_k(0:nrank_nbmx_k-1))
       allocate(idisp_kg1_k(0:nrank_nbmx_k-1))

       call set_block_range4allgather(kg1,nrank_nbmx_k,nel_kg1_k,nis_kg1_k,nie_kg1_k,idisp_kg1_k)
       np_kg1_k = nel_kg1_k(myrank_nbmx_k)
       mp_kg1_k = maxval(nel_kg1_k)
       ista_kg1_k = nis_kg1_k(myrank_nbmx_k)
       iend_kg1_k = nie_kg1_k(myrank_nbmx_k)
       kg1_ext = mp_kg1_k*nrank_nbmx_k

       if(ipri >= 1 .and. printable) then
          write(nfout,'(" !|| -- parallelization parameters for nbmx in mpi_k_world--")')
          write(nfout,'(" !||  - ng_nbmx_k     = ",i12)') ng_nbmx_k
          write(nfout,'(" !||  - myrank_nbmx_k = ",i12)') myrank_nbmx_k
          write(nfout,'(" !||  - nrank_nbmx_k  = ",i12)') nrank_nbmx_k
          write(nfout,'(" !||  - nbmx, nbmx_ext = ",2i12)') nbmx, nbmx_ext
          write(nfout,'(" !||  - np_nbmx_k     = ",i12)') np_nbmx_k
          write(nfout,'(" !||  - mp_nbmx_k     = ",i12)') mp_nbmx_k
          write(nfout,'(" !||  - ista_nbmx_k   = ",i12)') ista_nbmx_k
          write(nfout,'(" !||  - iend_nbmx_k   = ",i12)') iend_nbmx_k
          write(nfout,'(" !||   ( nis_nbmx_k )",8i10)') (nis_nbmx_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||   ( nie_nbmx_k )",8i10)') (nie_nbmx_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||   ( nel_nbmx_k )",8i10)') (nel_nbmx_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||   (idisp_nbmx_k)",8i10)') (idisp_nbmx_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||  - kg1, kg1_ext  = ",2i12)') kg1, kg1_ext
          write(nfout,'(" !||  - np_kg1_k      = ",i12)') np_kg1_k
          write(nfout,'(" !||  - mp_kg1_k      = ",i12)') mp_kg1_k
          write(nfout,'(" !||  - ista_kg1_k    = ",i12)') ista_kg1_k
          write(nfout,'(" !||  - iend_kg1_k    = ",i12)') iend_kg1_k
          write(nfout,'(" !||   ( nis_kg1_k )",8i10)') (nis_kg1_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||   ( nie_kg1_k )",8i10)') (nie_kg1_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||   ( nel_kg1_k )",8i10)') (nel_kg1_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||   (idisp_kg1_k)",8i10)') (idisp_kg1_k(i),i=0,nrank_nbmx_k-1)
       end if
       
! (( mpi_nbmx_world ))
       do i = 0, nrank_k-1
          if(i == myrank_k) then
             do j = 0, ngnode_nbmx-1
                icolor = 0
                key = 0
                if(ng_nbmx_k == j) then
                   icolor = 1
                   key = myrank_nbmx_k
                end if
!                if(firstcall) call mpi_comm_split(mpi_k_world(myrank_k), icolor, key, mpi_nbmx_world_k(j),ierr)
                if(.not.firstcall) call mpi_comm_free(mpi_nbmx_world_k(j), ierr)
                call mpi_comm_split(mpi_k_world(myrank_k), icolor, key, mpi_nbmx_world_k(j),ierr)
                call mpi_comm_size(mpi_nbmx_world_k(j), newpes, ierr)
                call mpi_comm_rank(mpi_nbmx_world_k(j), newmype,ierr)
             end do
          end if
       end do
    end if
    firstcall = .false.
                                                  __TIMER_SUB_STOP(1235)
  end subroutine m_Parallel_init_mpi_nbmx

  subroutine set_block_range4allgather(ne,np,nel_p,nis_p,nie_p,idisp_p)
    integer, intent(in)                     :: ne ! number of total elements
    integer, intent(in)                     :: np ! number of ranks (or processors)
    integer, intent(out), dimension(0:np-1) :: nel_p,nis_p,nie_p,idisp_p

    integer :: i, j, npf

    nel_p = 0
    i = ne/np
    j = i*np
    if(j == ne) then
       nel_p = i
    else
       npf = ne/(i+1)
       nel_p(0:npf-1) = i+1
       nel_p(npf)     = ne - (i+1)*npf
    end if
    nis_p(0) = 1
    do i = 1, np-1
       nis_p(i)   = nis_p(i-1) + nel_p(i-1)
       nie_p(i-1) = nis_p(i)   - 1
    end do
    nie_p(np-1) = ne
    do i = 0, np-1
       idisp_p(i) = nis_p(i)-1
    end do
  end subroutine set_block_range4allgather

! === necessary to make 3D_Parallel, too!!! by tkato ===========================
! ==============================================================================
  subroutine m_Parallel_init_mpi_elec(nfout,ipri,printable,neg,kv3,nspin,kg1)
    integer, intent(in) :: nfout,ipri,neg, kv3, nspin, kg1
    logical, intent(in) :: printable
    logical, save       :: firstcall=.true.

#ifdef NEC_TUNE_SOFT
    character*4 F_RSVTASK
    integer :: tmp_a1,tmp_a2,tmp_b1,tmp_b2
#elif NEC_TUNE_FFT
    character*4 F_RSVTASK
#endif

    integer             :: i, j, ip, icolor, key, kv3_half

!!$! =========================================== added by K. Tagami ======== 11.0
!!$    integer ::           kv3_div
!!$! ======================================================================= 11.0

    integer             :: newpes, newmype
    logical             :: set_mapping_func
    integer, pointer, dimension(:) :: nproc2rank_k, nproc2rank_e

    integer, parameter  :: nc = 24
    integer, parameter  :: nc1 = 16
!!$    integer, parameter  :: nc2 = 18
    integer             :: i0, i1, sw_title
    character*7         :: strmap

    sw_title = 1
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| << m_Parallel_init_mpi_elec >>")')
       write(nfout,'(" !|| neg, kv3 = ",i5, i8)') neg, kv3
    end if
    if(neg <= 0 ) call phase_error_with_msg(nfout," neg is not positive value ",__LINE__,__FILE__)
    if(kv3 <= 0 ) call phase_error_with_msg(nfout," kv3 is not positive value ",__LINE__,__FILE__)

!!!!!!!!!!!!!!!!! added by mizouchi@adv 2003.02.26 !!!!!!!!!!!!!!
#ifdef IRIX64

! ====================================== modified by K. Tagami =============== 11.0
!!    if((kv3 == 1.and.nspin ==1).or.(kv3 == 2.and.nspin ==2)) then
    if ( kv3/nspin == 1 ) then
! ===========================================================================  11.0

       nrank_e  = npes
       nrank_k  = 1
       if(ipri >= 1 .and. printable) then
          write(nfout,'(" !| modified nrank_e and nrank_k due to 1 kpoint calculation  ")')
          write(nfout,'(" !| modified nrank_e = ", i4)') nrank_e
          write(nfout,'(" !| modified nrank_k = ", i4)') nrank_k
       end if
#endif
!!!!!!!!!!!!!!!!! added by mizouchi@adv 2003.02.26 !!!!!!!!!!!!!!

!    if(nrank_k > kv3) stop ' nrank_k > kv3 (m_Parallel_init_mpi_elec)'
    if(nrank_k > kv3) call phase_execution_error(PARALLELIZATION_INVALID_NK)
!!$    if(nrank_e > neg) call phase_execution_error(PARALLELIZATION_INVALID_NE) !! not here !!

    allocate(map_e(neg))
    allocate(map_z(neg))
    allocate(map_k(kv3))
    allocate(map_ek(neg,kv3))
    if(.not.allocated(mpi_k_world)) allocate(mpi_k_world(0:nrank_k-1))
    if(.not.allocated(mpi_e_world)) allocate(mpi_e_world(0:nrank_e-1))
    allocate(nis_e(0:nrank_e-1)); nis_e = neg+1
    allocate(nie_e(0:nrank_e-1)); nie_e = 0
    allocate(nel_e(0:nrank_e-1)); nel_e = 0
    allocate(idisp_e(0:nrank_e-1)); idisp_e = 0
!!$#ifdef TRANSPOSE
    allocate(nis_g1(0:nrank_g1-1)); nis_g1 = kg1 + 1
    allocate(nie_g1(0:nrank_g1-1)); nie_g1 = 0
    allocate(nel_g1(0:nrank_g1-1)); nel_g1 = 0
!!$#endif
    allocate(nis_k(0:nrank_k-1)); nis_k = 0
    allocate(nie_k(0:nrank_k-1))
    allocate(nel_k(0:nrank_k-1))

! (( myrank_e, myrank_k ))
    allocate(nproc2rank_e(0:npes-1))
    allocate(nproc2rank_k(0:npes-1))
    ip = 0
    do i = 0, nrank_k-1
       do j = 0, nrank_e-1
          nproc2rank_k(ip) = i
          nproc2rank_e(ip) = j
          ip = ip + 1
       end do
    end do
    myrank_k = nproc2rank_k(mype)
    myrank_e = nproc2rank_e(mype)
    deallocate(nproc2rank_k)
    deallocate(nproc2rank_e)
! (( map_e, nis_e, nie_e, nel_e, ista_e, iend_e, istep_e, np_e, mp_e  ))
!!$#ifdef TRANSPOSE
    set_mapping_func = .true.
    call set_block_range(neg,nrank_e,nel_e,nis_e,nie_e, set_mapping_func, map_e)
    do i = 0, nrank_e-1
       idisp_e(i) = nis_e(i)-1
    end do
    if(ipri >= 2) call wd_e_range
    istep_e = 1
!!$#else
!!$    do i = 1, neg
!!$       map_e(i) = mod(i-1,nrank_e)
!!$    end do
!!$    do i = 1, neg
!!$       ip = map_e(i)
!!$       nel_e(ip) = nel_e(ip) + 1
!!$       if(nis_e(ip) > i) nis_e(ip) = i
!!$       if(nie_e(ip) < i) nie_e(ip) = i
!!$    end do
!!$    istep_e = nrank_e
!!$
!!$#endif
    if(ipri >= 2 .and. printable) then
       strmap = "   i   "
       call wd_maparray(neg,map_e,strmap," map_e ",sw_title)
    end if

    ista_e = nis_e(myrank_e)
    iend_e = nie_e(myrank_e)
    np_e = nel_e(myrank_e)
    mp_e = maxval(nel_e)
    if(ipri==1 .and. printable) then
       if(mp_e < 100000) then
          write(nfout,'(" !|| ista_e, iend_e = ",i5,",",i5,", mp_e = ",i5,", neg = ",i12,", kv3 = ",i5 &
               & ," << m_Parallel_init_mpi_elec >>")') ista_e,iend_e,mp_e,neg,kv3
       else if(mp_e <100000000) then
          write(nfout,'(" !|| ista_e, iend_e = ",i8,",",i8,", mp_e = ",i8,", neg = ",i13,", kv3 = ",i5 &
               & ," << m_Parallel_init_mpi_elec >>")') ista_e,iend_e,mp_e,neg,kv3
       else
          write(nfout,'(" !|| ista_e, iend_e = ",i0,",",i0,", mp_e = ",i0,", neg = ",i0,", kv3 = ",i5 &
               & ," << m_Parallel_init_mpi_elec >>")') ista_e,iend_e,mp_e,neg,kv3
       end if
    end if


#ifdef NEC_TUNE_SOFT
    call getenv('F_RSVTASK',F_RSVTASK)
    read (F_RSVTASK,'(i4)') itask
    allocate(ista_e_smp(itask))
    allocate(iend_e_smp(itask))

    tmp_a1 = (iend_e-ista_e+1)/istep_e
    tmp_a2 = mod(iend_e-ista_e+1,istep_e)
    if (tmp_a2 .ne. 0) tmp_a1=tmp_a1+1
    tmp_b1 = tmp_a1/itask
    tmp_b2 = mod(tmp_a1,itask)
    if (tmp_b2 .ne. 0) tmp_b1=tmp_b1+1

    do i=1,itask
      ista_e_smp(i) = ista_e + tmp_b1 * istep_e * (i -1)
      iend_e_smp(i) = min((ista_e + tmp_b1 * istep_e * i -1),iend_e)
    end do
#elif NEC_TUNE_FFT
    call getenv('F_RSVTASK',F_RSVTASK)
    read (F_RSVTASK,'(i4)') itask
#endif

    if(ipri >= 2 .and. printable) &
         & write(nfout,'(" !|| -- ista_e, iend_e, istep_e, np_e, mp_e = ",5i6)') &
         &  ista_e,iend_e,istep_e, np_e, mp_e

! (( map_z ))
!!$#ifdef TRANSPOSE
    j = 0
    do ip = 1, nrank_e
       do i = 1, nel_e(ip-1)
          j = j + 1
          map_z(j) = i
       end do
    end do
!!$#else
!!$    ip = 1
!!$    do i = 1, neg
!!$       map_z(i) = ip
!!$       if(mod(i,nrank_e) == 0) ip = ip + 1
!!$    end do
!!$#endif
    if(ipri >= 2 .and. printable) then
       strmap = "   i   "
       call wd_maparray(neg,map_z,strmap," map_z ",sw_title)
    end if
! (( map_k, nis_k, nie_k, nel_k, ista_k, iend_k ))
    if(kv3/nspin < nrank_k) then
       if(ipri >= 1 .and. printable) then
          write(nfout,'(" ******")')
          write(nfout,'(" ** The nrank_k that you have specified is smaller than the number of k-points (kv3/nspin).")')
          write(nfout,'(" ** kv3/nspin = ",i8," nrank_k = ",i8)') kv3/nspin, nrank_k
          write(nfout,'(" ** Reduce the size of the rank for k-point division (nrank_k) &
  &                     which is set in nk= option when you run this program, please")')
          call flush(nfout)
       end if
       !stop ' ** The nrank_k that is specified is smaller than the number of generated or read k-points (=kv3/nspin).'
       call phase_error_with_msg(nfout, &
       'The nrank_k that is specified is smaller than the number of generated or read k-points (=kv3/nspin).', &
       __LINE__, __FILE__)
    end if
    if(nspin == 1) then
       set_mapping_func = .true.
       call set_block_range(kv3,nrank_k,nel_k,nis_k,nie_k, set_mapping_func,map_k)
       ista_k = nis_k(myrank_k)
       iend_k = nie_k(myrank_k)
    else if(nspin == 2) then
       set_mapping_func = .false.
       kv3_half = kv3/nspin
       call set_block_range(kv3_half,nrank_k,nel_k,nis_k,nie_k, set_mapping_func)
       nel_k = nel_k*nspin
       nie_k = nie_k*nspin
       nis_k = nis_k*nspin-1
       j = 0
       do i = 1, kv3
          if(nie_k(j) < i) j = j + 1
          map_k(i) = j
       end do
       ista_k = nis_k(myrank_k)
       iend_k = nie_k(myrank_k)
    end if

    if(ipri >= 2 .and. printable) then
       strmap = "   i   "
       call wd_maparray(kv3,map_k,strmap," map_k ",sw_title)
       write(nfout,'(" !|| -- myrank_k = ",i8)') myrank_k
       write(nfout,'(" !|| -- ista_k, iend_k = ",2i8)') ista_k,iend_k
    end if
   if(ista_k > iend_k) call phase_error_with_msg(nfout, ' !! illegal combination of ista_k, and iend_k', &
   __LINE__,__FILE__)
 
! (( map_ek ))
    do j = 1, kv3
       do i = 1, neg
          map_ek(i,j) = map_e(i) + map_k(j)*(nrank_e)
       end do
    end do

    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| --- map_ek ---")')
       sw_title = 0
       do j = 1, kv3
          write(strmap,'("ik=",i4)') j
          call wd_maparray(neg,map_ek(1,j),strmap,"map_ek ",sw_title)
       end do
    end if

!!$#ifdef TRANSPOSE
! (( ista_g1, iend_g1 ))
    set_mapping_func = .false.
    if(ipri >= 2 .and. printable) write(nfout,'(" !|| kg1 = ",i10)') kg1
    call set_block_range(kg1,nrank_e,nel_g1,nis_g1,nie_g1, set_mapping_func)
    ista_g1 = nis_g1(myrank_e)
    iend_g1 = nie_g1(myrank_e)
    np_g1   = nel_g1(myrank_e)
    mp_g1   = maxval(nel_g1) 
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| --- mis_g1,nie_g1,nel_g1 ---")')
       write(nfout,'(" !|| ( rank_e  )",15i7)')(i,i=1,nrank_e)
       write(nfout,'(" !|| ( nis_g1  )",15i7)')(nis_g1(i),i=0,nrank_e-1)
       write(nfout,'(" !|| ( nie_g1  )",15i7)')(nie_g1(i),i=0,nrank_e-1)
       write(nfout,'(" !|| ( nel_g1  )",15i7)')(nel_g1(i),i=0,nrank_e-1)
       write(nfout,'(" !|| (myrank_e = ",i3," kg1,ista_g1,iend_g1,np_g1,mp_g1 = ",5i7)') &
            & myrank_e,kg1,ista_g1,iend_g1,np_g1,mp_g1
    end if
!!$#endif

! (( mpi_k_world ))
    do j = 0, nrank_k-1
       icolor = 0
       key = 0
       do i = 0, nrank_e-1
          if(mype == i + nrank_e*j) then
             icolor = 1
             key = i
          end if
       end do
!       if(firstcall) call mpi_comm_split(mpi_comm_group, icolor, key, mpi_k_world(j),ierr)
       if(.not.firstcall) call mpi_comm_free(mpi_k_world(j), ierr)
       call mpi_comm_split(mpi_comm_group, icolor, key, mpi_k_world(j),ierr)
       call mpi_comm_size(mpi_k_world(j), newpes,ierr)
       call mpi_comm_rank(mpi_k_world(j), newmype,ierr)
!!$       print '(" mype = ",i3," newmype = ", i3," newpes = ",i3," mpi_k_world = ", i3 &
!!$            &, " icolor = ",i3," key = ",i3)' &
!!$            & ,mype,newmype, newpes,mpi_k_world(j),icolor, key
    end do

    do j=0,nrank_e-1
       icolor = myrank_e
       key = mype
!       if(firstcall) call mpi_comm_split(mpi_comm_group, icolor, key, mpi_e_world(j),ierr)
       if(.not.firstcall) call mpi_comm_free(mpi_e_world(j), ierr)
       call mpi_comm_split(mpi_comm_group, icolor, key, mpi_e_world(j),ierr)
       call mpi_comm_size(mpi_e_world(j), newpes,ierr)
       call mpi_comm_rank(mpi_e_world(j), newmype,ierr)
    enddo
    icolor = myrank_e
    key    = mype
    call mpi_comm_split(mpi_comm_group, icolor, key, mpi_ge_world, ierr)
    call mpi_comm_size(mpi_ge_world, newpes, ierr)
    call mpi_comm_rank(mpi_ge_world, newmype, ierr)
    firstcall = .false.
  contains
    subroutine wd_maparray(nelement,map_a,map_title0,map_title,sw_title)
      integer, intent(in) ::                 nelement
      integer, dimension(nelement), intent(in) :: map_a
      character*7, intent(in) ::             map_title0,map_title
      integer, intent(in) ::                 sw_title
      integer :: nca, j, i0, i1, i, iloop

      if(sw_title==1)  write(nfout,'(" !|| --- ",a7," ---")') map_title
      if(nelement < 100) then
         nca = nc      ! = 24
      else if(nelement < 1000) then
         nca = nc*3/4  ! = 18
      else if(nelement < 10000) then
         nca = nc*3/5  ! = 14
      else if(nelement < 100000) then
         nca = nc*3/6  ! = 12
      else
         nca = nc*3/9  ! = 8
      end if
      iloop = ceiling(dble(nelement)/nca)
      do j = 1, iloop
         i0 = (j-1)*nca + 1
         i1 = i0 + nca -1
         if(i1 > nelement) i1 = nelement
         if(nelement < 100) then
            write(nfout,'(" !|| (",a7,")",24i3)') map_title0,(i,i=i0,i1)
            write(nfout,'(" !|| (",a7,")",24i3)') map_title, (map_a(i),i=i0,min(nelement,i1))
         else if(nelement < 1000) then
            write(nfout,'(" !|| (",a7,")",18i4)') map_title0,(i,i=i0,i1)
            write(nfout,'(" !|| (",a7,")",18i4)') map_title, (map_a(i),i=i0,i1)
         else if(nelement < 10000) then
            write(nfout,'(" !|| (",a7,")",14i5)') map_title0,(i,i=i0,i1)
            write(nfout,'(" !|| (",a7,")",14i5)') map_title, (map_a(i),i=i0,i1)
         else if(nelement < 100000) then
            write(nfout,'(" !|| (",a7,")",12i5)') map_title0,(i,i=i0,i1)
            write(nfout,'(" !|| (",a7,")",12i5)') map_title, (map_a(i),i=i0,i1)
         else
            write(nfout,'(" !|| (",a7,")",8i9)') map_title0,(i,i=i0,i1)
            write(nfout,'(" !|| (",a7,")",8i9)') map_title, (map_a(i),i=i0,i1)
         end if
      end do
    end subroutine wd_maparray

    subroutine wd_e_range
      if(printable) then
         write(nfout,'(" !|| nrank_e")')
         write(nfout,'(" !||    i    : ",20i4)')(i,i=0,nrank_e-1)
         write(nfout,'(" !|| nis_e   : ",20i4)')(nis_e(i),i=0,nrank_e-1)
         write(nfout,'(" !|| nie_e   : ",20i4)')(nie_e(i),i=0,nrank_e-1)
         write(nfout,'(" !|| nel_e   : ",20i4)')(nel_e(i),i=0,nrank_e-1)
!!$         write(nfout,'(" !||    i : ",20i4)')(i,i=0,nrank_e-1)
!!$         write(nfout,'(" !|| nis_e : ",20i4)')(nis_e(i),i=0,nrank_e-1)
!!$         write(nfout,'(" !|| nie_e : ",20i4)')(nie_e(i),i=0,nrank_e-1)
!!$         write(nfout,'(" !|| nel_e : ",20i4)')(nel_e(i),i=0,nrank_e-1)
!!$#ifdef TRANSPOSE
         write(nfout,'(" !|| idisp_e : ",20i4)')(idisp_e(i),i=0,nrank_e-1)
!!$#endif
      end if
    end subroutine wd_e_range

  end subroutine m_Parallel_init_mpi_elec
! === necessary to make 3D_Parallel, too!!! by tkato ===========================

! ==============================================================================
  subroutine m_Parallel_dealloc_mpi_elec()

    if(allocated(map_e)) deallocate(map_e)
    if(allocated(map_z)) deallocate(map_z)
    if(allocated(map_k)) deallocate(map_k)
    if(allocated(map_ek)) deallocate(map_ek)
!fj    deallocate(mpi_k_world)
    if(allocated(nis_e)) deallocate(nis_e)
    if(allocated(nie_e)) deallocate(nie_e)
    if(allocated(nel_e)) deallocate(nel_e)
    if(allocated(idisp_e)) deallocate(idisp_e)
    if(allocated(nis_g1)) deallocate(nis_g1)
    if(allocated(nie_g1)) deallocate(nie_g1)
    if(allocated(nel_g1)) deallocate(nel_g1)
    if(allocated(nis_k)) deallocate(nis_k)
    if(allocated(nie_k)) deallocate(nie_k)
    if(allocated(nel_k)) deallocate(nel_k)

#ifdef NEC_TUNE_SOFT
    if(allocated(ista_e_smp)) deallocate(ista_e_smp)
    if(allocated(iend_e_smp)) deallocate(iend_e_smp)
#endif


  end subroutine m_Parallel_dealloc_mpi_elec

  subroutine m_Parallel_init_mpi_iba(nfout,ipri,printable,kv3,iba)
    integer, intent(in) :: nfout,ipri, kv3, iba(kv3)
    logical, intent(in) :: printable

    logical             :: set_mapping_func
    integer             :: i, ik
    integer, parameter  :: nc = 24
    integer, parameter  :: nc1 = 16

!!$#ifdef TRANSPOSE
    if(nrank_k > kv3) call phase_error_with_msg(nfout, ' nrank_k > kv3 (m_Parallel_init_mpi_elec)', __LINE__, __FILE__)

! (( ista_g1k, iend_g1k ))
    if(allocated(np_g1k)) deallocate(np_g1k);  allocate(np_g1k(kv3))
    if(allocated(mp_g1k)) deallocate(mp_g1k);  allocate(mp_g1k(kv3))
    if(allocated(ista_g1k)) deallocate(ista_g1k); allocate(ista_g1k(kv3))
    if(allocated(iend_g1k)) deallocate(iend_g1k); allocate(iend_g1k(kv3))

    if(allocated(nis_g1k)) deallocate(nis_g1k);  allocate(nis_g1k(0:nrank_g1-1,kv3))
    do ik = 1, kv3
       nis_g1k(:,ik) = iba(ik)
    end do

    if(allocated(nie_g1k)) deallocate(nie_g1k); allocate(nie_g1k(0:nrank_g1-1,kv3))
    nie_g1k = 0

    if(allocated(nel_g1k)) deallocate(nel_g1k); allocate(nel_g1k(0:nrank_g1-1,kv3))
    nel_g1k = 0

    do ik = 1, kv3
       set_mapping_func = .false.
       if((ipri >= 2 .and. printable).or. &
            & (ipri >= 1 .and. printable .and. (ik<=3 .or. ik>=kv3-2))) &
            & write(nfout,'(" !|| ik = ",i10 &
            & ," iba(",i6,") = ",i10," <<m_Parallel_init_mpi_iba>>")') ik, ik, iba(ik)

       call set_block_range(iba(ik),nrank_e,nel_g1k(0,ik),nis_g1k(0,ik) &
            & ,nie_g1k(0,ik), set_mapping_func)
       ista_g1k(ik) = nis_g1k(myrank_e,ik)
       iend_g1k(ik) = nie_g1k(myrank_e,ik)
       np_g1k(ik)   = nel_g1k(myrank_e,ik)
       mp_g1k(ik)   = maxval(nel_g1k(0:nrank_g1-1,ik)) 
       if((ipri >= 3 .and. printable) .or. &
            & (ipri >= 2 .and. printable .and. (ik<=3 .or. ik>=kv3-2))) then
          write(nfout,'(" !|| --- mis_g1k,nie_g1k,nel_g1k ---")')
          write(nfout,'(" !|| ( rank_e  )",15i7)')(i,i=1,nrank_e)
          write(nfout,'(" !|| ( nis_g1k )",15i7)')(nis_g1k(i,ik),i=0,nrank_e-1)
          write(nfout,'(" !|| ( nie_g1k )",15i7)')(nie_g1k(i,ik),i=0,nrank_e-1)
          write(nfout,'(" !|| ( nel_g1k )",15i7)')(nel_g1k(i,ik),i=0,nrank_e-1)
          write(nfout,'(" !|| (myrank_e = ",i3," iba(ik),ista_g1k,iend_g1k,np_g1k,mp_g1k = ",5i7)') &
               & myrank_e,iba(ik),ista_g1k(ik),iend_g1k(ik),np_g1k(ik),mp_g1k(ik)
       end if
       if(ipri>=1 .and. printable .and. kv3 >=7 .and. ik == 3) then
          write(nfout,'(" !||  ......")')
       end if
    end do
!!$#endif
  end subroutine m_Parallel_init_mpi_iba

  subroutine m_Parallel_end_mpi
                                                  __TIMER_STOP
    call mpi_finalize(ierr)
  end subroutine m_Parallel_end_mpi

  subroutine set_block_range(ne,np,nel_p,nis_p,nie_p,set_mapping_func,map_p)
    integer, intent(in)                     :: ne ! number of total elements
    integer, intent(in)                     :: np ! number of ranks (or processors)
    integer, intent(out), dimension(0:np-1) :: nel_p,nis_p,nie_p
    logical, intent(in)                     :: set_mapping_func
    integer, intent(out), optional, dimension(ne)  :: map_p

    integer :: j,i

    if(np == 0) call phase_error_with_msg(6,' np == 0',__LINE__,__FILE__)
    nel_p = ne/np
    j = mod(ne,np)
    do i = 0, j-1
       nel_p(i) = nel_p(i) + 1
    end do

    nis_p(0) = 1
    do i = 1, np-1
       nis_p(i)   = nis_p(i-1) + nel_p(i-1)
       nie_p(i-1) = nis_p(i) - 1
    end do
    nie_p(np-1) = ne

    if(set_mapping_func) then
       j = 0
       do i = 1, ne
          if(nie_p(j) < i) j = j + 1
          map_p(i) = j
       end do
    end if

  end subroutine set_block_range

  subroutine m_Parallel_init_mpi_kngp(nfout,ipri,kngp)
    integer, intent(in) :: nfout,ipri,kngp
    integer :: iwork, i
    if(allocated(is_kngp)) deallocate(is_kngp)
    if(allocated(ie_kngp)) deallocate(ie_kngp)
    if(allocated(nel_kngp)) deallocate(nel_kngp)
    allocate(is_kngp(0:npes-1))
    allocate(ie_kngp(0:npes-1))
    allocate(nel_kngp(0:npes-1))
    iwork = ( kngp - 1 ) / npes + 1
    do i = 0, npes-1
       is_kngp(i) = min(i*iwork+1, kngp+1)
       ie_kngp(i) = min(is_kngp(i)+iwork-1, kngp)
       nel_kngp(i) = ie_kngp(i) - is_kngp(i) + 1
    enddo
    ista_kngp = is_kngp(mype)
    iend_kngp = ie_kngp(mype)
    np_kngp   = nel_kngp(mype)
    mp_kngp   = maxval(nel_kngp)
    if(ipri==1) then
       if(mp_kngp < 100000) then
          write(nfout,'(" !|| ista_kngp, iend_kngp = ",i5,",",i5,", mp_kngp = ",i5,", kngp = ",i12&
               & ," << m_Parallel_init_mpi_kngp >>")') ista_kngp,iend_kngp,mp_kngp,kngp
       else
          write(nfout,'(" !|| ista_kngp, iend_kngp = ",i10,",",i10,", mp_kngp = ",i10,", kngp = ",i12&
               & ," << m_Parallel_init_mpi_kngp >>")') ista_kngp,iend_kngp,mp_kngp,kngp
       end if
    else if(ipri>=2) then
       write(nfout,'(" << m_Parallel_init_mpi_kngp >>")')
       write(nfout,'(" !|| kngp = ",i12)') kngp
       write(nfout,'(" !|| -- npe, is_kngp(ista_kngp),  ie_kngp(iend_kngp) --")')
       do i = 0, npes-1
          write(nfout,'(" !|| ",i0,2i10)') i,is_kngp(i),ie_kngp(i)
       end do
    end if
  end subroutine m_Parallel_init_mpi_kngp

  subroutine m_Parallel_init_mpi_kngp_prev(kngp)
    integer, intent(in) :: kngp
    integer :: iwork, i
    integer, allocatable, dimension(:) :: is_kngp,ie_kngp,nel_kngp
    allocate(is_kngp(0:npes-1))
    allocate(ie_kngp(0:npes-1))
    allocate(nel_kngp(0:npes-1))
    iwork = ( kngp - 1 ) / npes + 1
    do i = 0, npes-1
       is_kngp(i) = min(i*iwork+1, kngp+1)
       ie_kngp(i) = min(is_kngp(i)+iwork-1, kngp)
       nel_kngp(i) = ie_kngp(i) - is_kngp(i) + 1
    enddo
    ista_kngp_prev = is_kngp(mype)
    iend_kngp_prev = ie_kngp(mype)
    np_kngp_prev   = nel_kngp(mype)
    deallocate(is_kngp)
    deallocate(ie_kngp)
    deallocate(nel_kngp)
  end subroutine m_Parallel_init_mpi_kngp_prev

  subroutine m_Parallel_init_mpi_cdfft(nfout,ipri,ggacmp_parallel)
    integer, intent(in)  :: nfout,ipri,ggacmp_parallel
    integer :: i, iprilevel

    if(ggacmp_parallel == ON) then
       call split_into_ggablock_cdfft(npes,nrank_ggacmp,npes_cdfft,nrest_cdfft)
    else
       nrank_ggacmp = 1
       npes_cdfft   = npes
       nrest_cdfft  = 0
    end if
    if(ipri >= 1) write(nfout,'(" !|| ggacmp_parallel = ",i3)') ggacmp_parallel
    if(ggacmp_parallel==ON) then
       iprilevel=1
    else
       iprilevel=2
    end if
    if(ipri >= iprilevel) write(nfout,'(" !|| nrank_ggacmp, npes_cdfft, nrest_cdfft",/ &
         & ," !||   = ",3i10," <<m_Parallel_init_mpi_cdfft>>")') &
         & nrank_ggacmp, npes_cdfft, nrest_cdfft
    myrank_ggacmp = mype/npes_cdfft
    myrank_cdfft  = mype - myrank_ggacmp*npes_cdfft
    if(ipri >= iprilevel) write(nfout,'(" !|| myrank_ggacmp, myrank_cdfft",/ &
         & ," !|| = ",2i10," <<m_Parallel_init_mpi_cdfft>>")') &
         & myrank_ggacmp, myrank_cdfft
    if(allocated(map_pe2ggacmp)) deallocate(map_pe2ggacmp)
    if(allocated(map_pe2cdfft)) deallocate(map_pe2cdfft)
    allocate(map_pe2ggacmp(0:npes-1))
    allocate(map_pe2cdfft(0:npes-1))
    do i = 0, npes-1
       map_pe2ggacmp(i) = i/npes_cdfft
       map_pe2cdfft(i) = i - map_pe2ggacmp(i)*npes_cdfft
    end do
    if(ipri >= iprilevel) write(nfout,'(" !|| map_pe2ggacmp",/,99( " !|| ",10i5,/))') &
         & (map_pe2ggacmp(i),i=0,npes-1)
    if(ipri >= iprilevel) write(nfout,'(" !|| map_pe2cdfft",/,99( " !|| ",10i5,/))') &
         & (map_pe2cdfft(i),i=0,npes-1)
  end subroutine m_Parallel_init_mpi_cdfft

  subroutine m_Parallel_dealloc_mpi_gga()
    if(allocated(map_ggacmp))  deallocate(map_ggacmp)
    if(allocated(nis_fftp))    deallocate(nis_fftp)
    if(allocated(nie_fftp))    deallocate(nie_fftp)
    if(allocated(nel_fftp))    deallocate(nel_fftp)
    if(allocated(idisp_fftp))  deallocate(idisp_fftp)
    if(allocated(nis_fftph))   deallocate(nis_fftph)
    if(allocated(nie_fftph))   deallocate(nie_fftph)
    if(allocated(nel_fftph))   deallocate(nel_fftph)
    if(allocated(idisp_fftph)) deallocate(idisp_fftph)
    if(allocated(nis_sfftp))   deallocate(nis_sfftp)
    if(allocated(nie_sfftp))   deallocate(nie_sfftp)
    if(allocated(nel_sfftp))   deallocate(nel_sfftp)
    if(allocated(idisp_sfftp)) deallocate(idisp_sfftp)
    if(allocated(nis_sfftph))  deallocate(nis_sfftph)
    if(allocated(nie_sfftph))  deallocate(nie_sfftph)
    if(allocated(nel_sfftph))  deallocate(nel_sfftph)
  end subroutine m_Parallel_dealloc_mpi_gga

  subroutine m_Parallel_init_mpi_gga(nfout,ipri,printable,nfftp,nfftps)
    integer, intent(in)  :: nfout,ipri,nfftp,nfftps
    logical, intent(in)  :: printable
    integer              :: nfftph, i
    logical              :: set_mapping_func
    integer              :: icolor, key, j, newpes, newmype
    logical, save        :: firstcall = .true.
                                                  __TIMER_SUB_START(1236)
                                                  __TIMER_SUB_STOP(1236)

    allocate(map_ggacmp(3)); map_ggacmp = 0
    allocate(nis_fftp(0:npes_cdfft-1)); nis_fftp = 0
    allocate(nie_fftp(0:npes_cdfft-1)); nie_fftp = 0
    allocate(nel_fftp(0:npes_cdfft-1)); nel_fftp = 0
    allocate(idisp_fftp(0:npes_cdfft-1)); idisp_fftp = 0
    allocate(nis_fftph(0:npes_cdfft-1));nis_fftph = 0
    allocate(nie_fftph(0:npes_cdfft-1)); nie_fftph = 0
    allocate(nel_fftph(0:npes_cdfft-1)); nel_fftph = 0
    allocate(idisp_fftph(0:npes_cdfft-1)); idisp_fftph = 0
    if(.not.allocated(mpi_cdfft_world))then
    allocate(mpi_cdfft_world(0:nrank_ggacmp-1)); mpi_cdfft_world = 0
    endif
    if(.not.allocated(mpi_ggacmp_cross_world)) then
    allocate(mpi_ggacmp_cross_world(0:npes_cdfft-1)); mpi_ggacmp_cross_world = 0
    endif

    if(nrank_ggacmp > 1) then
       do i = 1, 3
          map_ggacmp(i) = i-1
       end do
    else
       map_ggacmp(1:3) = 0
    end if

    set_mapping_func = .false.
    nfftph = nfftp/2
    if(ipri >= 1) write(nfout,'(" !|| nfftp, nfftph = ",2i10," <<m_Parallel_init_mpi_gga>>")') nfftp, nfftph
    call set_block_range(nfftph,npes_cdfft,nel_fftph,nis_fftph,nie_fftph,set_mapping_func)

    ista_fftph = nis_fftph(myrank_cdfft)
    iend_fftph = nie_fftph(myrank_cdfft)

    if(ipri >= 1) write(nfout,'(" !|| ista_fftph, iend_fftph = ",2i10 &
         & ," <<m_Parallel_init_mpi_gga>>")') ista_fftph, iend_fftph

    do i = 0, npes_cdfft -1
       nis_fftp(i) = nis_fftph(i)*2 - 1
       nie_fftp(i) = nie_fftph(i)*2
       nel_fftp(i) = nel_fftph(i)*2
       idisp_fftp(i) = nis_fftp(i) - 1
       idisp_fftph(i) = nis_fftph(i) - 1
    end do
    ista_fftp = nis_fftp(myrank_cdfft)
    iend_fftp = nie_fftp(myrank_cdfft)
    mp_fftp = maxval(nel_fftp)
    np_fftp = nel_fftp(myrank_cdfft)

    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| --- nis_fftp,nie_fftp,nel_fftp,idisp_fftp ---")')
       write(nfout,'(" !||  npes_cdfft = ",i12)') npes_cdfft
       write(nfout,'(" !|| ( npe_cdfft )",10i12)') (i,i=1,npes_cdfft)
       write(nfout,'(" !|| ( nis_fftp )",10i12)') (nis_fftp(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| ( nie_fftp )",10i12)') (nie_fftp(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| ( nel_fftp )",10i12)') (nel_fftp(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| (idisp_fftp)",10i12)') (idisp_fftp(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| ( ista_fftp,  iend_fftp )",2i12)') ista_fftp, iend_fftp
       write(nfout,'(" !|| --- nis_fftph,nie_fftph,nel_fftph ---")')
       write(nfout,'(" !|| ( npe_cdfft )",10i12)') (i,i=1,npes_cdfft)
       write(nfout,'(" !|| ( nis_fftph)",10i12)') (nis_fftph(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| ( nie_fftph)",10i12)') (nie_fftph(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| ( nel_fftph)",10i12)') (nel_fftph(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| ( ista_fftph, iend_fftph)",2i12)') ista_fftph, iend_fftph
    end if

    allocate(nis_sfftp(0:npes-1)); nis_sfftp = 0
    allocate(nie_sfftp(0:npes-1)); nie_sfftp = 0
    allocate(nel_sfftp(0:npes-1)); nel_sfftp = 0
    allocate(idisp_sfftp(0:npes-1)); idisp_sfftp = 0
    allocate(nis_sfftph(0:npes-1)); nis_sfftph = 0
    allocate(nie_sfftph(0:npes-1)); nie_sfftph = 0
    allocate(nel_sfftph(0:npes-1)); nel_sfftph = 0
    set_mapping_func = .false.
    if(ipri >= 1 .and. printable) write(nfout,'(" !|| nfftp = ",i10," <<m_Parallel_init_mpi_gga>>")') nfftp

!!$    call set_block_range(nfftp,npes,nel_sfftp,nis_sfftp,nie_sfftp,set_mapping_func)
!!$    ista_sfftp = nis_sfftp(mype)
!!$    iend_sfftp = nie_sfftp(mype)
!!$    idisp_sfftp(0) = 0
!!$    do i = 1, npes-1
!!$       idisp_sfftp(i) = idisp_sfftp(i-1) + nel_sfftp(i-1)
!!$    end do

    nfftph = nfftps/2
    call set_block_range(nfftph,npes,nel_sfftph,nis_sfftph,nie_sfftph,set_mapping_func)
    ista_sfftph = nis_sfftph(mype)
    iend_sfftph = nie_sfftph(mype)

    do i = 0, npes -1
       nis_sfftp(i) = nis_sfftph(i)*2 - 1
       nie_sfftp(i) = nie_sfftph(i)*2
       nel_sfftp(i) = nel_sfftph(i)*2
       idisp_sfftp(i) = nis_sfftp(i) - 1
    end do
    ista_sfftp = nis_sfftp(mype)
    iend_sfftp = nie_sfftp(mype)
    mp_sfftp = maxval(nel_sfftp)
    np_sfftp = nel_sfftp(mype)

    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| --- nis_sfftp,nie_sfftp,nel_sfftp,idisp_sfftp ---")')
       write(nfout,'(" !|| ( npe      )",10i12)') (i,i=1,npes)
       write(nfout,'(" !|| ( nis_sfftp )",10i12)') (nis_sfftp(i),i=0,npes-1)
       write(nfout,'(" !|| ( nie_sfftp )",10i12)') (nie_sfftp(i),i=0,npes-1)
       write(nfout,'(" !|| ( nel_sfftp )",10i12)') (nel_sfftp(i),i=0,npes-1)
       write(nfout,'(" !|| (idisp_sfftp)",10i12)') (idisp_sfftp(i),i=0,npes-1)
       write(nfout,'(" !|| ( ista_sfftp,  iend_sfftp )",2i12)') ista_sfftp, iend_sfftp
       write(nfout,'(" !|| --- nis_sfftph,nie_sfftph,nel_sfftph ---")')
       write(nfout,'(" !|| ( npe       )",10i12)') (i,i=1,npes)
       write(nfout,'(" !|| ( nis_sfftph )",10i12)') (nis_sfftph(i),i=0,npes-1)
       write(nfout,'(" !|| ( nie_sfftph )",10i12)') (nie_sfftph(i),i=0,npes-1)
       write(nfout,'(" !|| ( nel_sfftph )",10i12)') (nel_sfftph(i),i=0,npes-1)
       write(nfout,'(" !|| ( ista_sfftph, iend_sfftph)",2i12)') ista_sfftph, iend_sfftph
    end if

    do j = 0, nrank_ggacmp-1
       icolor = 0
       key = 0
       if(myrank_ggacmp == j) then
          icolor = 1
          key = myrank_cdfft
       end if
!!$       do i = 0, npes_cdfft-1
!!$          if(mype == i + npes_cdfft*j) then
!!$             icolor = 1
!!$             key = i
!!$          end if
!!$       end do
!       if(firstcall) call mpi_comm_split(mpi_comm_group,icolor,key,mpi_cdfft_world(j),ierr)
       if(.not.firstcall) call mpi_comm_free(mpi_cdfft_world(j), ierr)
       call mpi_comm_split(mpi_comm_group,icolor,key,mpi_cdfft_world(j),ierr)
       call mpi_comm_size(mpi_cdfft_world(j), newpes, ierr)
       call mpi_comm_rank(mpi_cdfft_world(j), newmype, ierr)
    end do

    do j = 0, npes_cdfft-1
       icolor = 0
       key = 0
       if(myrank_cdfft == j) then
          icolor = 1
          key = myrank_ggacmp
       end if
!!$       do i = 0, nrank_ggacmp-1
!!$          if(mype == i + nrank_ggacmp*j) then
!!$             icolor = 1
!!$             key = i
!!$          end if
!!$       end do
!       if(firstcall) call mpi_comm_split(mpi_comm_group,icolor,key,mpi_ggacmp_cross_world(j),ierr)
       if(.not.firstcall) call mpi_comm_free(mpi_ggacmp_cross_world(j), ierr)
       call mpi_comm_split(mpi_comm_group,icolor,key,mpi_ggacmp_cross_world(j),ierr)
       call mpi_comm_size(mpi_ggacmp_cross_world(j),newpes,ierr)
       call mpi_comm_rank(mpi_ggacmp_cross_world(j),newmype,ierr)
       if(ipri >= 2) then
! === DEBUG by tkato 2011/07/12 ================================================
!         write(nfout,'(" !|| mype, newmype, newpes, mpi_ggacmp_cross_world = ",4i8)') &
!              & mype, newmype,newpes,mpi_ggacmp_cross_world(j)
          write(nfout,'(" !|| mype, newmype, newpes, mpi_ggacmp_cross_world = ",4i12)') &
               & mype, newmype,newpes,mpi_ggacmp_cross_world(j)
! ==============================================================================
       end if
    end do
    firstcall = .false.
  end subroutine m_Parallel_init_mpi_gga
    

  subroutine m_Parallel_init_mpi_mix(nfout,ipri,printable,kgpm)
    integer, intent(in) :: nfout,ipri,kgpm
    logical, intent(in) :: printable
    integer :: iwork, i
    allocate(is_kgpm(0:npes-1))
    allocate(ie_kgpm(0:npes-1))
    allocate(nel_kgpm(0:npes-1))
    iwork = ( kgpm - 1 ) / npes + 1
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| << init_mpi_mix >>")')
       write(nfout,'(" !|| kgpm = ",i12)') kgpm
       write(nfout,'(" !|| -- is_kgpm, ie_kgpm --")')
    end if
    do i = 0, npes-1
       is_kgpm(i) = min(i*iwork+1, kgpm+1)
       ie_kgpm(i) = min(is_kgpm(i)+iwork-1, kgpm)
       nel_kgpm(i) = ie_kgpm(i) - is_kgpm(i) + 1
       if(ipri >= 2 .and. printable) write(nfout,'(" !|| ",2i12)') is_kgpm(i),ie_kgpm(i)
    enddo
    ista_kgpm = is_kgpm(mype)
    iend_kgpm = ie_kgpm(mype)
    np_kgpm   = nel_kgpm(mype)
    mp_kgpm   = maxval(nel_kgpm)
    if(ipri == 1 .and. printable) then
       if(iend_kgpm <1000000) then
          write(nfout,'(" !|| ista_kgpm, iend_kgpm = ",i6,",",i6,", mp_kgpm = ",i6,", kgpm = ",i12 &
               & ,"  << m_Parallel_init_mpi_mix>>")') ista_kgpm,iend_kgpm,mp_kgpm,kgpm
       elseif(iend_kgpm <100000000)then
          write(nfout,'(" !|| ista_kgpm, iend_kgpm = ",i8,",",i8,", mp_kgpm = ",i8,", kgpm = ",i12 &
               & ,"  << m_Parallel_init_mpi_mix>>")') ista_kgpm,iend_kgpm,mp_kgpm,kgpm
       else
          write(nfout,'(" !|| ista_kgpm, iend_kgpm = ",i12,",",i12,", mp_kgpm = ",i12,", kgpm = ",i0 &
               & ,"  << m_Parallel_init_mpi_mix>>")') ista_kgpm,iend_kgpm,mp_kgpm,kgpm
       end if
    end if
  end subroutine m_Parallel_init_mpi_mix

  subroutine m_Parallel_init_mpi_snl(nfout,ipri,printable,nspin)
    integer, intent(in) :: nfout,ipri,nspin
    logical, intent(in) :: printable

    ista_snl = (ista_k + nspin - 1)/nspin
    iend_snl = iend_k/nspin
    if(ipri >= 1 .and. printable) then
       write(nfout,'(" !|| ista_snl, iend_snl = ",i5,",",i5," << m_Parallel_init_mpi_snl >>")') &
            & ista_snl,iend_snl
    end if
  end subroutine m_Parallel_init_mpi_snl

  subroutine m_Parallel_init_mpi_ffth(nfout,ipri,printable,nfft)
    integer, intent(in) :: nfout,ipri,nfft
    logical, intent(in) :: printable
    integer :: iwork, i, nffth
    nffth = nfft/2

    if ( .not. allocated(is_ffth) ) allocate(is_ffth(0:npes-1))
    if ( .not. allocated(ie_ffth) ) allocate(ie_ffth(0:npes-1))
    if ( .not. allocated(nel_ffth) ) allocate(nel_ffth(0:npes-1))

    iwork = ( nffth - 1 ) / npes + 1
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| << init_mpi_ffth >>")')
       write(nfout,'(" !|| nffth = ",i12)') nffth
       write(nfout,'(" !|| -- is_ffth, ie_ffth --")')
    end if
    do i = 0, npes-1
       is_ffth(i) = min(i*iwork+1, nffth+1)
       ie_ffth(i) = min(is_ffth(i)+iwork-1, nffth)
       nel_ffth(i) = ie_ffth(i) - is_ffth(i) + 1
       if(ipri >= 2 .and. printable) write(nfout,'(" !|| ",2i12)') is_ffth(i),ie_ffth(i)
    enddo
    ista_ffth = is_ffth(mype)
    iend_ffth = ie_ffth(mype)
    np_ffth   = nel_ffth(mype)
    mp_ffth   = maxval(nel_ffth)
    if(ipri == 1 .and. printable) then
       if(iend_ffth <1000) then
          write(nfout,'(" !|| ista_ffth, iend_ffth = ",i3,",",i3,", mp_ffth = ",i3,", nffth = ",i5 &
               & ,"  << m_Parallel_init_mpi_ffth >>")') ista_ffth,iend_ffth,mp_ffth,nffth
       elseif(iend_ffth <100000)then
          write(nfout,'(" !|| ista_ffth, iend_ffth = ",i5,",",i5,", mp_ffth = ",i5,", ffth = ",i6 &
               & ,"  << m_Parallel_init_mpi_ffth >>")') ista_ffth,iend_ffth,mp_ffth,nffth
       else
          write(nfout,'(" !|| ista_ffth, iend_ffth = ",i0,",",i0,", mp_atm = ",i0,", natm = ",i0 &
               & ,"  << m_Parallel_init_mpi_ffth >>")') ista_ffth,iend_ffth,mp_ffth,nffth
       end if
    end if
  end subroutine m_Parallel_init_mpi_ffth


  subroutine m_Parallel_init_mpi_nn(nfout,ipri,printable,nn)
    integer, intent(in) :: nfout,ipri,nn
    logical, intent(in) :: printable
    integer :: iwork, i,ia

    allocate(is_nn(0:nrank_e-1))
    allocate(ie_nn(0:nrank_e-1))
    allocate(nel_nn(0:nrank_e-1))
    iwork = ( nn - 1 ) / nrank_e + 1
    do i = 0, nrank_e-1
       is_nn(i) = min(i*iwork+1, nn+1)
       ie_nn(i) = min(is_nn(i)+iwork-1, nn)
       nel_nn(i) = ie_nn(i) - is_nn(i) + 1
       if(ipri >= 2 .and. printable) write(nfout,'(" !|| ",2i12)') is_nn(i),ie_nn(i)
    enddo
    ista_nn = is_nn(myrank_e)
    iend_nn = ie_nn(myrank_e)
  end subroutine m_Parallel_init_mpi_nn

  subroutine m_Parallel_init_mpi_rspace_aug(nfout,ipri,printable,natm,nmesh_rs_aug)
    integer, intent(in) :: nfout,ipri,natm
    logical, intent(in) :: printable
    integer, dimension(natm), intent(in) :: nmesh_rs_aug
    integer :: iwork, i,ia

    if(allocated(is_rspace_aug))deallocate(is_rspace_aug)
    if(allocated(ie_rspace_aug))deallocate(ie_rspace_aug)
    if(allocated(nel_rspace_aug))deallocate(nel_rspace_aug)
    if(allocated(ista_rspace_aug_atm))deallocate(ista_rspace_aug_atm)
    if(allocated(iend_rspace_aug_atm))deallocate(iend_rspace_aug_atm)
    allocate(is_rspace_aug(0:npes-1))
    allocate(ie_rspace_aug(0:npes-1))
    allocate(nel_rspace_aug(0:npes-1))
    allocate(ista_rspace_aug_atm(natm));ista_rspace_aug_atm=0
    allocate(iend_rspace_aug_atm(natm));iend_rspace_aug_atm=0
    do ia=1,natm 
    iwork = ( nmesh_rs_aug(ia) - 1 ) / npes + 1
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| << init_mpi_rspace_aug >>")')
       write(nfout,'(" !|| nmesh_rs_aug = ",i12)') nmesh_rs_aug(ia)
       write(nfout,'(" !|| -- is_rspace_aug, ie_rspace_aug --")')
    end if
    do i = 0, npes-1
       is_rspace_aug(i) = min(i*iwork+1, nmesh_rs_aug(ia)+1)
       ie_rspace_aug(i) = min(is_rspace_aug(i)+iwork-1, nmesh_rs_aug(ia))
       nel_rspace_aug(i) = ie_rspace_aug(i) - is_rspace_aug(i) + 1
       if(ipri >= 2 .and. printable) write(nfout,'(" !|| ",2i12)') is_rspace_aug(i),ie_rspace_aug(i)
    enddo
    ista_rspace_aug_atm(ia) = is_rspace_aug(mype)
    iend_rspace_aug_atm(ia) = ie_rspace_aug(mype)
    if(ipri == 1 .and. printable) then
       if(iend_rspace_aug_atm(ia) <1000) then
          write(nfout,'(" !|| ista_rspace_aug, iend_rspace_aug = ",i3,",",i3,", mp_rspace_aug = ",i3,", nmesh_rs_aug_max = ",i5 &
          & ,"  << m_Parallel_init_mpi_rspace_aug >>")') &
          & ista_rspace_aug_atm(ia),iend_rspace_aug_atm(ia),mp_rspace_aug,nmesh_rs_aug(ia)
       else
          write(nfout,'(" !|| ista_rspace_aug, iend_rspace_aug = ",i0,",",i0,", mp_rspace_aug = ",i0,", nmesh_rs_aug_max = ",i0 &
          & ,"  << m_Parallel_init_mpi_atm >>")') ista_rspace_aug_atm(ia),iend_rspace_aug_atm(ia),mp_rspace_aug,nmesh_rs_aug(ia)
       end if
    end if
    enddo
  end subroutine m_Parallel_init_mpi_rspace_aug


  subroutine m_Parallel_init_mpi_nq(nfout,ipri,printable,nq)
    integer, intent(in) :: nfout, ipri,nq
    logical, intent(in) :: printable
    integer :: i,j,ip

    allocate(is_nq(0:npes-1));ista_nq=nq+1
    allocate(ie_nq(0:npes-1));iend_nq=0
    allocate(nel_nq(0:npes-1));nel_nq=0
    allocate(map_nq(nq));map_nq=0
    allocate(map_z_nq(nq));map_z_nq=0

    call set_block_range(nq,npes,nel_nq,is_nq,ie_nq,.true.,map_nq)
    ista_nq = is_nq(mype)
    iend_nq = ie_nq(mype)
    np_nq = nel_nq(mype)
    mp_nq = maxval(nel_nq)
    j = 0
    do ip = 1, npes
       do i = 1, nel_nq(ip-1)
          j = j + 1
          map_z_nq(j) = i
       end do
    end do
  end subroutine m_Parallel_init_mpi_nq


  subroutine m_Parallel_init_mpi_atm(nfout,ipri,printable,natm)
    integer, intent(in) :: nfout,ipri,natm
    logical, intent(in) :: printable
    integer :: iwork, i

    allocate(is_atm(0:npes-1))
    allocate(ie_atm(0:npes-1))
    allocate(nel_atm(0:npes-1))
    iwork = ( natm - 1 ) / npes + 1
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| << init_mpi_atm >>")')
       write(nfout,'(" !|| natm = ",i12)') natm
       write(nfout,'(" !|| -- is_natm, ie_natm --")')
    end if
    do i = 0, npes-1
       is_atm(i) = min(i*iwork+1, natm+1)
       ie_atm(i) = min(is_atm(i)+iwork-1, natm)
       nel_atm(i) = ie_atm(i) - is_atm(i) + 1
       if(ipri >= 2 .and. printable) write(nfout,'(" !|| ",2i12)') is_atm(i),ie_atm(i)
    enddo
    ista_atm = is_atm(mype)
    iend_atm = ie_atm(mype)
    np_atm   = nel_atm(mype)
    mp_atm   = maxval(nel_atm)
! ====================================================================
    write(nfout,*) '===== m_Parallel_init_mpi_atm ====='
    write(nfout,*) 'npes: ', npes, ' = nrank_g : ',nrank_g
    write(nfout,*) 'mype: ', mype
    write(nfout,*) 'ista_atm, iend_atm, np_natm, mp_atm: ', ista_atm, iend_atm, np_atm, mp_atm
    write(nfout,*) '----- natm Decomposed as... -----'
    write(nfout,*) 'natm:  ', natm
    write(nfout,*) ' i, is_atm, ie_atm, nel_atm'
    do i = 0, npes-1
      write(nfout,*) i, is_atm(i), ie_atm(i), nel_atm(i)
    enddo
! =====================================================================
    if(ipri == 1 .and. printable) then
       if(iend_atm <1000) then
          write(nfout,'(" !|| ista_atm, iend_atm = ",i3,",",i3,", mp_atm = ",i3,", natm = ",i5 &
               & ,"  << m_Parallel_init_mpi_atm >>")') ista_atm,iend_atm,mp_atm,natm
       elseif(iend_kgpm <100000)then
          write(nfout,'(" !|| ista_atm, iend_atm = ",i5,",",i5,", mp_atm = ",i5,", natm = ",i6 &
               & ,"  << m_Parallel_init_mpi_atm >>")') ista_atm,iend_atm,mp_atm,natm
       else
          write(nfout,'(" !|| ista_atm, iend_atm = ",i0,",",i0,", mp_atm = ",i0,", natm = ",i0 &
               & ,"  << m_Parallel_init_mpi_atm >>")') ista_atm,iend_atm,mp_atm,natm
       end if
    end if
  end subroutine m_Parallel_init_mpi_atm

  subroutine m_Parallel_init_mpi_atm2(nfout,ipri,printable,natm2)
    integer, intent(in) :: nfout,ipri,natm2
    logical, intent(in) :: printable
    integer :: iwork, i
    if(allocated(is_atm2)) deallocate(is_atm2)
    if(allocated(ie_atm2)) deallocate(ie_atm2)
    if(allocated(nel_atm2)) deallocate(nel_atm2)
    allocate(is_atm2(0:npes-1))
    allocate(ie_atm2(0:npes-1))
    allocate(nel_atm2(0:npes-1))
    iwork = ( natm2 - 1 ) / npes + 1
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| << init_mpi_atm2 >>")')
       write(nfout,'(" !|| natm2 = ",i12)') natm2
       write(nfout,'(" !|| -- is_natm2, ie_natm2 --")')
    end if
    do i = 0, npes-1
       is_atm2(i) = min(i*iwork+1, natm2+1)
       ie_atm2(i) = min(is_atm2(i)+iwork-1, natm2)
       nel_atm2(i) = ie_atm2(i) - is_atm2(i) + 1
       if(ipri >= 2 .and. printable) write(nfout,'(" !|| ",2i12)') is_atm2(i),ie_atm2(i)
    enddo
    ista_atm2 = is_atm2(mype)
    iend_atm2 = ie_atm2(mype)
    np_atm2   = nel_atm2(mype)
    mp_atm2   = maxval(nel_atm2)

    if(ipri == 1 .and. printable) then
       if(iend_atm2 <1000) then
          write(nfout,'(" !|| ista_atm2, iend_atm2 = ",i3,",",i3,", mp_atm2 = ",i3,", natm2 = ",i5 &
               & ,"  << m_Parallel_init_mpi_atm2 >>")') ista_atm2,iend_atm2,mp_atm2,natm2
       elseif(iend_kgpm <100000)then
          write(nfout,'(" !|| ista_atm2, iend_atm2 = ",i5,",",i5,", mp_atm2 = ",i5,", natm2 = ",i6 &
               & ,"  << m_Parallel_init_mpi_atm2 >>")') ista_atm2,iend_atm2,mp_atm2,natm2
       else
          write(nfout,'(" !|| ista_atm2, iend_atm2 = ",i0,",",i0,", mp_atm2 = ",i0,", natm2 = ",i0 &
               & ,"  << m_Parallel_init_mpi_atm2 >>")') ista_atm2,iend_atm2,mp_atm2,natm2
       end if
    end if
  end subroutine m_Parallel_init_mpi_atm2

!!$#ifdef TRANSPOSE
  subroutine m_Parallel_init_mpi_nlmta(nfout,ipri,nlmta,nlmt,natm,lmta,ntyp,ilmt,ityp)
    integer, intent(in) :: nfout, ipri, nlmta, nlmt,natm,ntyp
!!$ASASASASAS
!!$    integer, intent(in), dimension(nlmt,ntyp) :: lmta
    integer, intent(in), dimension(nlmt,natm) :: lmta
!!$ASASASASAS
    integer, intent(in), dimension(ntyp)      :: ilmt
    integer, intent(in), dimension(natm)      :: ityp

    integer :: ip, ia, it, it0, n1, i, nsum
!!$ASASASASAS
    integer :: itmp
!!$ASASASASAS
    real(kind=8), allocatable, dimension(:) :: np
    real(kind=8) :: n_l, n_r
    allocate(np(0:nrank_e-1)); np = 0.d0
    

    if(allocated(nis_fs)) deallocate(nis_fs)
    if(allocated(nie_fs)) deallocate(nie_fs)
    if(allocated(nel_fs)) deallocate(nel_fs)
    if(allocated(nis_fs_atm)) deallocate(nis_fs_atm)
    if(allocated(nie_fs_atm)) deallocate(nie_fs_atm)
    if(allocated(nel_fs_atm)) deallocate(nel_fs_atm)
    allocate(nis_fs(0:nrank_e-1))
    allocate(nie_fs(0:nrank_e-1))
    allocate(nel_fs(0:nrank_e-1))
    allocate(nis_fs_atm(0:nrank_e-1))
    allocate(nie_fs_atm(0:nrank_e-1))
    allocate(nel_fs_atm(0:nrank_e-1))

    do ip = 1, nrank_e
       np(ip-1) = dble(nlmta)/nrank_e *ip
       if(ipri >= 2) write(nfout,'(" !|| ip = ",i5," np = ",f12.4)') ip,np(ip-1)
    end do

    ip = 0
    do ia = 1, natm
       it = ityp(ia)
!!$ASASASASAS
       itmp=ilmt(it)
       if(itmp==0)cycle
!!$ASASASASAS
       n1 = lmta(ilmt(it),ia)
       if(abs(n1-np(ip)) < 1.d-10) then
          ip = ip + 1
          nie_fs(ip-1) = n1
          nie_fs_atm(ip-1) = ia
       else if(n1 > np(ip)) then
          ip = ip+1
          if(ia == 1) then
             n_l = np(ip-1)+1
          else if(ia >= 2) then
             it0 = ityp(ia-1)
             itmp=ilmt(it0)
!!$ASASASASAS
             if(itmp/=0) n_l = np(ip-1)-lmta(ilmt(it0),ia-1)
!!$             n_l = np(ip-1)-lmta(ilmt(it0),ia-1)
!!$ASASASASAS
          end if
          n_r = n1 - np(ip-1)
          if(n_l >= n_r) then
             nie_fs(ip-1) = n1
             nie_fs_atm(ip-1) = ia
          else
             nie_fs(ip-1) = np(ip-1) - n_l
!!$ASASASASAS
!!$             if(nie_fs(ip-1) < 0) nie_fs(ip-1) = n1
             if(nie_fs(ip-1) < 0) nie_fs(ip-1) = 0
!!$ASASASASAS
             nie_fs_atm(ip-1) = ia-1
          end if
       end if
    end do
    do i = ip+1, nrank_e
       nie_fs(i-1) = nlmta
       nie_fs_atm(i-1) = natm
    end do
    nis_fs_atm(0) = 1
    nis_fs(0) = 1
    nel_fs(0) = nie_fs(0)
    nel_fs_atm(0) = nie_fs_atm(0)
    do ip = 1, nrank_e-1
       nis_fs_atm(ip) = nie_fs_atm(ip-1)+1
       nis_fs(ip)  = nie_fs(ip-1)+1
       nel_fs(ip) = nie_fs(ip) - nie_fs(ip-1)
       nel_fs_atm(ip) = nie_fs_atm(ip) - nie_fs_atm(ip-1)
    end do

    ista_fs = nis_fs(myrank_e)
    iend_fs = nie_fs(myrank_e)
    np_fs   = nel_fs(myrank_e)
    mp_fs   = maxval(nel_fs)
    ista_fs_atm = nis_fs_atm(myrank_e)
    iend_fs_atm = nie_fs_atm(myrank_e)
    np_fs_atm = nel_fs_atm(myrank_e)
    mp_fs_atm = maxval(nel_fs_atm)

    if(ipri >= 2) then
       nsum = 0
       write(nfout,'(" !||",9x,"ip",4x,"nis_fs",4x,"nie_fs",7x,"nel",11x &
         & ,"atm(nis,nie)",5x,"lmta")')
       do ip = 1, nrank_e
          it = ityp(nie_fs_atm(ip-1))
          if(nie_fs_atm(ip-1) > 0 .and. nie_fs_atm(ip-1) <= natm ) then
             write(nfout,'(" !|| ",4i10,2x,3i10)') &
                  &   ip,nis_fs(ip-1),nie_fs(ip-1),nel_fs(ip-1), nis_fs_atm(ip-1), nie_fs_atm(ip-1) &
                  & , lmta(ilmt(it),nie_fs_atm(ip-1))
          else
             write(nfout,'(" !|| ",4i10,2x,2i10)') &
                  &   ip,nis_fs(ip-1),nie_fs(ip-1),nel_fs(ip-1), nis_fs_atm(ip-1), nie_fs_atm(ip-1)
          end if

          nsum = nsum + nel_fs(ip-1)
       end do
       write(nfout,'(" !|| nsum = ", i5)') nsum

       write(nfout,'(" !|| --- nis_fs,nie_fs,nel_fs ---")')
       write(nfout,'(" !|| ( rank_e  )",15i7)')(i,i=1,nrank_e)
       write(nfout,'(" !|| ( nis_fs  )",15i7)')(nis_fs(i),i=0,nrank_e-1)
       write(nfout,'(" !|| ( nie_fs  )",15i7)')(nie_fs(i),i=0,nrank_e-1)
       write(nfout,'(" !|| ( nel_fs  )",15i7)')(nel_fs(i),i=0,nrank_e-1)
       write(nfout,'(" !|| myrank_e = ",i3 &
            & ," nlmta,ista_fs,iend_fs,np_fs,mp_fs = ",/,10x,5i7)') &
            & myrank_e,nlmta,ista_fs,iend_fs,np_fs,mp_fs

       write(nfout,'(" !|| --- nis_fs_atm,nie_fs_atm,nel_fs_atm ---")')
       write(nfout,'(" !|| ( rank_e  )",15i7)')(i,i=1,nrank_e)
       write(nfout,'(" !|| ( nis_fs_atm  )",15i7)')(nis_fs_atm(i),i=0,nrank_e-1)
       write(nfout,'(" !|| ( nie_fs_atm  )",15i7)')(nie_fs_atm(i),i=0,nrank_e-1)
       write(nfout,'(" !|| ( nel_fs_atm  )",15i7)')(nel_fs_atm(i),i=0,nrank_e-1)
       write(nfout,'(" !|| myrank_e = ",i3 &
            & ," nlmta,ista_fs_atm,iend_fs_atm,np_fs_atm,mp_fs_atm = ",/,10x,5i7)') &
            & myrank_e,nlmta,ista_fs_atm,iend_fs_atm,np_fs_atm,mp_fs_atm

    end if

    deallocate(np)
  end subroutine m_Parallel_init_mpi_nlmta
!!$#endif

  subroutine split_into_ggablock_cdfft(npes,nrank_ggacmp,npes_cdfft,nrest_cdfft)
    integer, intent(in)  :: npes
    integer, intent(out) :: nrank_ggacmp, npes_cdfft, nrest_cdfft

#ifdef _NO_GGA_SPLIT_
    nrank_ggacmp = 1
    npes_cdfft  = npes
    nrest_cdfft = 0
#else
    if(npes <= 2) then
       nrank_ggacmp = 1
       npes_cdfft  = npes
       nrest_cdfft = 0
    else
       nrank_ggacmp = 3
       npes_cdfft  = npes/nrank_ggacmp
       nrest_cdfft = npes - npes_cdfft*nrank_ggacmp
    end if
#endif
  end subroutine split_into_ggablock_cdfft
  
  subroutine m_Parallel_dealloc_mpi_nlmta()
    if(allocated(nis_fs)) deallocate(nis_fs)
    if(allocated(nie_fs)) deallocate(nie_fs)
    if(allocated(nel_fs)) deallocate(nel_fs)
    if(allocated(nis_fs_atm)) deallocate(nis_fs_atm)
    if(allocated(nie_fs_atm)) deallocate(nie_fs_atm)
    if(allocated(nel_fs_atm)) deallocate(nel_fs_atm)
  end subroutine m_Parallel_dealloc_mpi_nlmta

  subroutine m_Parallel_dealloc_mpi_exx()
    if(allocated(is_kngp_exx)) deallocate(is_kngp_exx)
    if(allocated(ie_kngp_exx)) deallocate(ie_kngp_exx)
    if(allocated(nel_kngp_exx)) deallocate(nel_kngp_exx)
  end subroutine m_Parallel_dealloc_mpi_exx

  subroutine m_Parallel_cp_g1k(kv3)
    integer, intent(in) :: kv3
    ista_kngp_prev = ista_kngp
    iend_kngp_prev = iend_kngp
  end subroutine m_Parallel_cp_g1k

  subroutine m_Parallel_dealloc(neb_mode)
    logical, intent(in), optional :: neb_mode
    logical :: neb
    neb = .false.
    if(present(neb_mode)) neb = neb_mode

    if(allocated(is_kngp)) deallocate(is_kngp)
    if(allocated(ie_kngp)) deallocate(ie_kngp)
    if(allocated(nel_kngp)) deallocate(nel_kngp)

!    if(.not.neb)then
    if(allocated(map_e)) deallocate(map_e)
    if(allocated(map_z)) deallocate(map_z)
    if(allocated(map_k)) deallocate(map_k)
    if(allocated(map_ek)) deallocate(map_ek)
!    if(allocated(mpi_k_world)) deallocate(mpi_k_world)
    if(allocated(nis_e)) deallocate(nis_e)
    if(allocated(nie_e)) deallocate(nie_e)
    if(allocated(nel_e)) deallocate(nel_e)
    if(allocated(idisp_e)) deallocate(idisp_e)
#ifdef NEC_TUNE_SOFT
    if(allocated(ista_e_smp)) deallocate(ista_e_smp)
    if(allocated(iend_e_smp)) deallocate(iend_e_smp)
#endif
    if(allocated(nis_k)) deallocate(nis_k)
    if(allocated(nie_k)) deallocate(nie_k)
    if(allocated(nel_k)) deallocate(nel_k)

    if(allocated(ista_g1k)) deallocate(ista_g1k)
    if(allocated(iend_g1k)) deallocate(iend_g1k)
    if(allocated(np_g1k)) deallocate(np_g1k)
    if(allocated(np_g1k_prev)) deallocate(np_g1k_prev)
    if(allocated(mp_g1k)) deallocate(mp_g1k)
    
    if(allocated(nis_fftp)) deallocate(nis_fftp)
    if(allocated(nie_fftp)) deallocate(nie_fftp)
    if(allocated(nel_fftp)) deallocate(nel_fftp)
    if(allocated(idisp_fftp)) deallocate(idisp_fftp)
    if(allocated(nis_fftph)) deallocate(nis_fftph)
    if(allocated(nie_fftph)) deallocate(nie_fftph)
    if(allocated(nel_fftph)) deallocate(nel_fftph)

    if(allocated(is_kgpm)) deallocate(is_kgpm)
    if(allocated(ie_kgpm)) deallocate(ie_kgpm)
    if(allocated(nel_kgpm)) deallocate(nel_kgpm)

    if(allocated(is_atm)) deallocate(is_atm)
    if(allocated(ie_atm)) deallocate(ie_atm)
    if(allocated(nel_atm)) deallocate(nel_atm)

    if(allocated(is_atm2)) deallocate(is_atm2)
    if(allocated(ie_atm2)) deallocate(ie_atm2)
    if(allocated(nel_atm2)) deallocate(nel_atm2)
!!$#ifndef TRANSPOSE
!!$    endif
!!$#endif
!!$#ifdef TRANSPOSE
    if(allocated(nis_g1)) deallocate(nis_g1)
    if(allocated(nie_g1)) deallocate(nie_g1)
    if(allocated(nel_g1)) deallocate(nel_g1)
    if(.not.neb)then
    if(allocated(nis_fs)) deallocate(nis_fs)
    if(allocated(nie_fs)) deallocate(nie_fs)
    if(allocated(nel_fs)) deallocate(nel_fs)
    if(allocated(nis_fs_atm)) deallocate(nis_fs_atm)
    if(allocated(nie_fs_atm)) deallocate(nie_fs_atm)
    if(allocated(nel_fs_atm)) deallocate(nel_fs_atm)
    endif

    if(allocated(nis_g1k)) deallocate(nis_g1k)
    if(allocated(nie_g1k)) deallocate(nie_g1k)
    if(allocated(nel_g1k)) deallocate(nel_g1k)
!!$#endif

    if(allocated(map_pe2ggacmp)) deallocate(map_pe2ggacmp)
    if(allocated(map_pe2cdfft)) deallocate(map_pe2cdfft)

!    if(.not.neb)then
    if(allocated(map_ggacmp)) deallocate(map_ggacmp)
    if(allocated(idisp_fftph)) deallocate(idisp_fftph)
!    if(allocated(mpi_cdfft_world)) deallocate(mpi_cdfft_world)
    !if(allocated(mpi_ggacmp_cross_world)) deallocate(mpi_ggacmp_cross_world)

    if(allocated(nis_sfftp)) deallocate(nis_sfftp)
    if(allocated(nie_sfftp)) deallocate(nie_sfftp)
    if(allocated(nel_sfftp)) deallocate(nel_sfftp)
    if(allocated(idisp_sfftp)) deallocate(idisp_sfftp)
    if(allocated(nis_sfftph)) deallocate(nis_sfftph)
    if(allocated(nie_sfftph)) deallocate(nie_sfftph)
    if(allocated(nel_sfftph)) deallocate(nel_sfftph)

!    if(allocated(mpi_nbmx_world)) deallocate(mpi_nbmx_world)
    if(allocated(nel_nbmx)) deallocate(nel_nbmx)
    if(allocated(nis_nbmx)) deallocate(nis_nbmx)
    if(allocated(nie_nbmx)) deallocate(nie_nbmx)
    if(allocated(idisp_nbmx)) deallocate(idisp_nbmx)

    if(allocated(nel_nbmx_k)) deallocate(nel_nbmx_k)
    if(allocated(nis_nbmx_k)) deallocate(nis_nbmx_k)
    if(allocated(nie_nbmx_k)) deallocate(nie_nbmx_k)
    if(allocated(idisp_nbmx_k)) deallocate(idisp_nbmx_k)
!    if(allocated(mpi_nbmx_world_k)) deallocate(mpi_nbmx_world_k)
    if(allocated(nel_kg1_k)) deallocate(nel_kg1_k)
    if(allocated(nis_kg1_k)) deallocate(nis_kg1_k)
    if(allocated(nie_kg1_k)) deallocate(nie_kg1_k)
    if(allocated(idisp_kg1_k)) deallocate(idisp_kg1_k)
!    endif
  end subroutine m_Parallel_dealloc

 logical function m_Parallel_resolve_conf_para()
   integer :: i,nn
   integer :: n1
   integer iargc,narg
   character(100) :: q1
   character(100) arg
   nrank_conf=-1
   m_Parallel_resolve_conf_para = .false.
   narg = iargc()
   n1 = -1
   do nn=1,narg
      call getarg(nn,q1)

!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
      q1 = trim(adjustl(q1))
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
!!          if(index(trim(adjustl(q1)),"ne").ne.0) then

      if(q1(1:1) == "n".and. (q1(2:2) == "r".or.q1(2:2) == "c" .or. q1(2:2) == "i")) then
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
         if((q1(3:3) == "=".or.q1(3:3) == ":") .and. len_trim(q1(4:)).ne.0) then
             q1 = q1(4:)
             if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                read(q1,*) n1
             else
                call phase_error_with_msg(6,"wrong nr",__LINE__,__FILE__)
             end if
         else if(q1(3:3) == "=".or. q1(3:3) == ":") then
             call getarg(nn+1,q1)
             if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                read(q1,*) n1
             else
                call phase_error_with_msg(6,"wrong nr",__LINE__,__FILE__)
             end if
         else
              call getarg(nn+1,q1)
              if(q1(1:1) == ":".and. len_trim(q1(2:)).ne.0) then 
                  q1 = q1(2:)
                  if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                     read(q1,*) n1
                  else
                     call phase_error_with_msg(6,"wrong nr",__LINE__,__FILE__)
                  end if
              else if((q1(1:1) == "=".or.q1(1:1) == ":").and. len_trim(q1(2:)).eq.0) then
                  call getarg(nn+2,q1) 
                  if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                     read(q1,*) n1
                  else
                     call phase_error_with_msg(6,"wrong nr",__LINE__,__FILE__)
                  end if
               else
                  call phase_error_with_msg(6,"wrong nr",__LINE__,__FILE__)
               end if                   
         end if
      end if
   enddo
   
   nrank_conf = n1

   if(nrank_conf>=1) m_Parallel_resolve_conf_para = .true.
   conf_para = m_Parallel_resolve_conf_para
   if(conf_para)then
     call config_parallel_init()
   endif

   contains

   subroutine config_parallel_init()
     integer :: i,j
     integer npestmp,mypetmp,icolor,ikey,mpi_err
     integer mype_e, npes_e
     integer, allocatable ::  new_comm_world(:)
     logical, save        ::  firstcall=.true.
     call mpi_init(mpi_err)
     call mpi_comm_size(mpi_comm_world,npestmp,mpi_err)
     call mpi_comm_rank(mpi_comm_world,mypetmp,mpi_err)
     allocate(new_comm_world(0:nrank_conf-1))
     do i=0,nrank_conf-1
       icolor = 0
       ikey = 0
       do j=0, npestmp/nrank_conf-1
         if(mypetmp == j + (npestmp/nrank_conf)*i ) then
           icolor = 1
           ikey = i
         end if
       end do
!       if(firstcall) call mpi_comm_split( mpi_comm_world, icolor, ikey, new_comm_world(i), mpi_err )
       if(.not.firstcall) call mpi_comm_free(new_comm_world(i), mpi_err)
       call mpi_comm_split( mpi_comm_world, icolor, ikey, new_comm_world(i), mpi_err )
     end do
 
     mype_conf = mypetmp/(npestmp/nrank_conf)
     mpi_comm_group = new_comm_world(mype_conf)
     firstcall = .false.
   end subroutine config_parallel_init

 end function m_Parallel_resolve_conf_para

  subroutine m_Parallel_init_mpi_nvale(nfout,ipri,printable,nvale)
    integer, intent(in) :: nfout, ipri,nvale
    logical, intent(in) :: printable
    integer :: i,j,ip
    nrank_nvale = nrank_e
    myrank_nvale = myrank_e
    if(mpi_nvale_enabled) call m_Parallel_dealloc_mpi_nvale()
    call m_Parallel_alloc_mpi_nvale(nvale)
    call set_block_range(nvale,nrank_nvale,nel_nvale,nis_nvale,nie_nvale,.true.,map_nvale)
    mpi_nvale_enabled = .true.
    if(ipri>=2) call wd_val_range_3D()
    ista_nvale = nis_nvale(myrank_nvale)
    iend_nvale = nie_nvale(myrank_nvale)
    np_nvale = nel_nvale(myrank_nvale)
    mp_nvale = maxval(nel_nvale)

    j = 0
    do ip = 1, nrank_nvale
       do i = 1, nel_nvale(ip-1)
          j = j + 1
          map_z_nvale(j) = i
       end do
    end do

    contains

    subroutine wd_val_range_3D()
      if(printable) then
         write(nfout,'(" !|| nrank_nvale")')
         write(nfout,'(" !||    i    : ",20i4)')(i,i=0,nrank_nvale-1)
         write(nfout,'(" !|| ista_nvale   : ",20i4)')(nis_nvale(i),i=0,nrank_nvale-1)
         write(nfout,'(" !|| iend_nvale   : ",20i4)')(nie_nvale(i),i=0,nrank_nvale-1)
         write(nfout,'(" !|| nel_nvale    : ",20i4)')(nel_nvale(i),i=0,nrank_nvale-1)
      end if
    end subroutine wd_val_range_3D
  end subroutine m_Parallel_init_mpi_nvale

  subroutine m_Parallel_alloc_mpi_nvale(nvale)
    integer, intent(in) :: nvale
    allocate(nis_nvale(0:nrank_nvale-1));ista_nvale=nvale+1
    allocate(nie_nvale(0:nrank_nvale-1));iend_nvale=0
    allocate(nel_nvale(0:nrank_nvale-1));nel_nvale=0
    allocate(map_nvale(nvale));map_nvale=0
    allocate(map_z_nvale(nvale));map_z_nvale=0
  end subroutine m_Parallel_alloc_mpi_nvale

  subroutine m_Parallel_dealloc_mpi_nvale()
    if(allocated(nis_nvale)) deallocate(nis_nvale)
    if(allocated(nie_nvale)) deallocate(nie_nvale)
    if(allocated(nel_nvale)) deallocate(nel_nvale)
    if(allocated(map_nvale)) deallocate(map_nvale)
    if(allocated(map_z_nvale)) deallocate(map_z_nvale)
    mpi_nvale_enabled = .false.
  end subroutine m_Parallel_dealloc_mpi_nvale

  subroutine m_Parallel_init_mpi_kv3_ek(nfout,ipri,printable,kv3_ek,nspin)
    integer, intent(in) :: nfout, ipri,kv3_ek,nspin
    logical, intent(in) :: printable
    integer :: i,j,ip
    integer :: siz
    siz = kv3_ek/nspin
    nrank_kv3_ek = nrank_k
    myrank_kv3_ek = myrank_k
    call m_Parallel_alloc_mpi_kv3_ek(siz)
    call set_block_range(siz,nrank_kv3_ek,nel_kv3_ek,nis_kv3_ek,nie_kv3_ek,.true.,map_kv3_ek)
    ista_kv3_ek = nis_kv3_ek(myrank_kv3_ek)
    iend_kv3_ek = nie_kv3_ek(myrank_kv3_ek)
    np_kv3_ek = nel_kv3_ek(myrank_kv3_ek)
    mp_kv3_ek = maxval(nel_kv3_ek)

    j = 0
    do ip = 1, nrank_kv3_ek
       do i = 1, nel_kv3_ek(ip-1)
          j = j + 1
          map_z_kv3_ek(j) = i
       end do
    end do
  end subroutine m_Parallel_init_mpi_kv3_ek

  subroutine m_Parallel_alloc_mpi_kv3_ek(kv3_ek)
    integer, intent(in) :: kv3_ek
    allocate(nis_kv3_ek(0:nrank_kv3_ek-1));ista_kv3_ek=kv3_ek+1
    allocate(nie_kv3_ek(0:nrank_kv3_ek-1));iend_kv3_ek=0
    allocate(nel_kv3_ek(0:nrank_kv3_ek-1));nel_kv3_ek=0
    allocate(map_kv3_ek(kv3_ek));map_kv3_ek=0
    allocate(map_z_kv3_ek(kv3_ek));map_z_kv3_ek=0
  end subroutine m_Parallel_alloc_mpi_kv3_ek


  subroutine m_Parallel_resolve_decomp(nfout,kv3,done_something)
    integer, intent(in) :: nfout,kv3
    logical, intent(out) :: done_something
    integer :: i,neng,icount,itarget,nk,ne
    integer, allocatable, dimension(:) :: cands1,cands2
    real(kind=8) :: closest,fac
    done_something = .false. 
    if(read_from_args) return    
    done_something = .true.
    neng = 1;nk=npes
    if (npes>kv3) then
       do i=kv3,1,-1
          if(mod(npes,i)==0 .and. mod(kv3,i)==0) then
            neng = npes/i
            nk = npes/neng
            exit
          endif
       enddo
    else if(npes<kv3) then
       do i=npes,1,-1
          if(mod(npes,i)==0 .and. mod(kv3,i)==0) then
            neng = npes/i
            nk = npes/neng
            exit
          endif
       enddo
    endif
    ne = neng

    nrank_k = nk
    nrank_e = ne
    if(mype==0) then
       !!$ if(mype == 0) print '(" nrank_e = ", i3)', nrank_e
       write(nfout,'(" nrank_e = ",i3)') nrank_e
       !!$ if(mype == 0) print '(" nrank_k = ", i3)', nrank_k
       write(nfout,'(" nrank_k = ",i3)') nrank_k
    endif
  end subroutine m_Parallel_resolve_decomp

end module m_Parallelization

      subroutine eigen_prd_ux(
     &              a, nm,
     &              u_x, u_y, nv,
     &              u_t, v_t, i, c, e, ne)
!$    use OMP_LIB
      use MPI
      use eigen_devel
      use eigen_libs
      implicit NONE

      integer, intent(in)    :: nm, nv, ne, i
      real(8), intent(inout) :: a(1:nm,*)
      real(8), intent(out)   :: u_x(1:nv,*), u_y(1:nv,*)
      real(8), intent(out)   :: u_t(*), v_t(*)

      include 'param.h'

      real(8), intent(out)   :: c(MBAND,MBAND), e(1:ne,*)

      real(8)                :: g_n(MBAND), a_n, anorm2, beta
      integer, parameter     :: LWK = MBAND*(MBAND+1)
      real(8)                :: t, tt(LWK), s, ss(LWK)

      real(8), save :: tsave(0:15, 0:MBAND)
      save :: tt, ss, anorm2

      integer                :: x_owner_nod, x_pos
      integer                :: y_owner_nod, y_pos
      integer                :: i_1, i_2, i_3, i_4, i_5
      integer                :: j_1, j_2, j_3, j_4, j_5
      integer                :: k_1, k_2, k_3, k_4, k_5
      integer                :: jj_1, jj_2, jj_3
      integer                :: L, LL

      real(8)                :: t11, t12, t22, tol
      real(8)                :: a1, a2
      real(8)                :: aL(MBAND,MBAND), aX(MBAND, MBAND)

!      integer, parameter     :: VLEN = 2048
      integer, parameter     :: VLEN = 512

      real(8) :: d1,d2


      L  = i-MBAND
      LL = L-MBAND

!$OMP MASTER

      c(1:MBAND, 1:MBAND) = ZERO

#if _DEBUG_
      d1=eigen_get_wtime()
#endif
      i_2 = MBAND
      i_3 = MAX(1, 1-LL)
#if 0
      do i_1=i_2,i_3,-1
!      do i_1=MBAND,1,-1
!      if ( LL + i_1 >= 1  ) then
         y_owner_nod = eigen_owner_node   (L+i_1, y_nnod, y_inod)
         x_pos       = eigen_translate_g2l(i-1,   x_nnod, x_inod)
         call bcast_dbl(a(1,i_1), x_pos, y_owner_nod, y_COMM_WORLD)
!      end if
      end do
#else
      i_1 = i_3
      y_owner_nod = eigen_owner_node   (L+i_1, y_nnod, y_inod)
      x_pos       = eigen_translate_g2l(i-1,   x_nnod, x_inod)
      call bcastw_dbl( a(1,i_1), x_pos, y_owner_nod,
     $                nm, i_2-i_3+1, u_t, y_COMM_WORLD )
#endif
#if _DEBUG_
      d2=eigen_get_wtime()
#if _DEBUG2_
      rt_ptr(1)=rt_ptr(1)+1
      rt_timer(rt_ptr(1),1)=d2-d1

      rt_ptr(2)=rt_ptr(2)+1
#endif
#endif

!$OMP END MASTER

!$OMP BARRIER

      i_2 = MBAND
      i_3 = MAX(1, 1-LL)
!OCL NOFP_RELAXED
      do i_1=i_2,i_3,-1
!      do i_1=MBAND,1,-1
!      if ( LL + i_1 >= 1  ) then

         j_2 = eigen_loop_start(1,      x_nnod, x_inod)
         j_3 = eigen_loop_end  (LL+i_1, x_nnod, x_inod)

!$       if ( omp_get_num_threads() /= 1 ) then
!$          tsave(omp_get_thread_num(), 0:i_1) = 0D0
!$       else
!$OMP MASTER
         tt(1:i_1) = ZERO
!$OMP END MASTER
!$       end if

!$OMP BARRIER

         do jj_1=j_2,j_3,VLEN; jj_2=jj_1; jj_3=MIN(jj_1+VLEN-1,j_3)

             t = 0D0
!$OMP DO
             do j_1=jj_2,jj_3
                s = a(j_1, i_1)
                u_x(j_1, i_1) = s
                t = t + s * s
             end do! j_1
!$OMP END DO
!-
!$        if ( omp_get_num_threads() /= 1 ) then
!$           tsave(omp_get_thread_num(), 0)
!$   +        = tsave(omp_get_thread_num(), 0) + t
!$        else
             tt(1) = tt(1) + t
!$        end if
!-
          do k_1=1,i_1-1
             t = 0D0
!$OMP DO
             do j_1=jj_2,jj_3
                t = t + u_x(j_1, i_1)*a(j_1, k_1)
             enddo! j_1
!$OMP END DO
!-
!$        if ( omp_get_num_threads() /= 1 ) then
!$           tsave(omp_get_thread_num(), k_1)
!$   +        = tsave(omp_get_thread_num(), k_1) + t
!$        else
             tt(k_1+1) = tt(k_1+1) + t
!$        end if
!-
          end do! k_1

         end do! jj_1

!$OMP BARRIER

!$        if ( omp_get_num_threads() /= 1 ) then
!$OMP MASTER
!$           t = 0D0
!$           do j_1=0,omp_get_num_threads()-1
!$              t = t + tsave(j_1, 0)
!$           end do
!$           tt(1) = t
!$        do k_1=1,i_1-1
!$           t = 0D0
!$           do j_1=0,omp_get_num_threads()-1
!$              t = t + tsave(j_1, k_1)
!$           end do ! j_1
!$           tt(k_1+1) = t
!$        end do ! k_1
!$OMP END MASTER
!$        end if

!$OMP BARRIER

!$OMP MASTER
         if ( i_1 == MBAND ) then
            do k_1=MBAND,1,-1
            if ( LL + k_1 >= 1  ) then
               do j_1=1,MBAND
                  x_pos    = eigen_translate_g2l(LL+j_1, x_nnod, x_inod)
                  x_owner_nod = eigen_owner_node(LL+j_1, x_nnod, x_inod)
                  if ( x_inod == x_owner_nod ) then
                     t = a(x_pos, k_1)
                  else
                     t = ZERO
                  endif
                  tt(j_1+MBAND*k_1) = t
               end do! j_1
            else
               tt(1+MBAND*k_1:MBAND+MBAND*k_1) = ZERO
            endif
            end do! k_1
#if _DEBUG_
      d1=eigen_get_wtime()
#endif
            call reduce_dbl(tt, ss, LWK, 1, x_COMM_WORLD)
#if _DEBUG_
      d2=eigen_get_wtime()
#if _DEBUG2_
      rt_timer(rt_ptr(2),2)=rt_timer(rt_ptr(2),2)+d2-d1
#endif
#endif
            do k_1=1,MBAND
               do j_1=1,MBAND
                  aL(j_1, k_1) = tt(j_1+MBAND*k_1)
               end do! j_1
            end do! k_1
         else
#if _DEBUG_
      d1=eigen_get_wtime()
#endif
            call reduce_dbl(tt, ss, i_1, 1, x_COMM_WORLD)
#if _DEBUG_
      d2=eigen_get_wtime()
#if _DEBUG2_
      rt_timer(rt_ptr(2),2)=rt_timer(rt_ptr(2),2)+d2-d1
#endif
#endif
         end if

         anorm2 = tt(1)
         do k_1=1,i_1-1
            aX(k_1, i_1) = tt(k_1+1)
         end do! k_1
!$OMP END MASTER

! // barrier to share 'anorm2'
!$OMP BARRIER

         if ( anorm2 > ZERO ) then

!$OMP MASTER
            a_n  =  aL(i_1,i_1)
            g_n(i_1)  = -SIGN(SQRT(anorm2), a_n)
            beta =  anorm2 - a_n * g_n(i_1)
            a_n  =  a_n - g_n(i_1)

            x_owner_nod = eigen_owner_node   (LL+i_1, x_nnod, x_inod)
            x_pos       = eigen_translate_g2l(LL+i_1, x_nnod, x_inod)
            if ( x_inod == x_owner_nod ) then
               u_x(x_pos, i_1) =  a_n
            end if

            do k_1=1,i_1-1
               tt(k_1) = (aX(k_1, i_1) - g_n(i_1) * aL(i_1, k_1))/ beta
            end do
!$OMP END MASTER

! // barrier to share 'tt()'
!$OMP BARRIER

!OCL NOFP_CONTRACT
            do k_1=1,i_1-1
               t = tt(k_1)
!$OMP MASTER
               do j_1=1,i_1-1
                  aL(j_1, k_1) = aL(j_1, k_1) - t * aL (j_1, i_1)
               end do! j_1
!$OMP END MASTER
!$OMP DO
             do j_1=j_2,j_3
                a (j_1, k_1) = a (j_1, k_1) - t * u_x(j_1, i_1)
             end do! j_1
!$OMP ENDDO
            end do! k_1

!$OMP MASTER
            if ( x_inod == x_owner_nod ) then
               a(x_pos, i_1) = a_n
            end if
!$OMP END MASTER

         else

!$OMP MASTER
            g_n(i_1)  = ZERO
            beta = ONE
!$OMP END MASTER

         end if

!$OMP MASTER
         e(i-MBAND+i_1, MBAND) = g_n(i_1)
         c(i_1, i_1) = ONE / beta
!$OMP END MASTER

!      end if
      end do! i_1


!$OMP MASTER

      y_owner_nod = eigen_owner_node(i, y_nnod, y_inod)
      if ( y_owner_nod == y_inod ) then
      do i_1=1,MBAND
         if ( i+i_1 > MBAND+1 ) then
           x_owner_nod = eigen_owner_node(i-MBAND-1+i_1, x_nnod, x_inod)
            if ( x_owner_nod == x_inod ) then
              x_pos = eigen_translate_g2l(i-MBAND-1+i_1, x_nnod, x_inod)
               e(i-MBAND+i_1, 1) = a(x_pos, i_1)
            end if
         end if
      end do! i_1
      end if


      i_2 = MBAND
      i_3 = MAX(1, 1-LL)
      do i_1=i_3,i_2
!      do i_1=1,MBAND
!      if ( LL + i_1 >= 1  ) then
         j_2 = eigen_loop_start(LL+i_1+1, x_nnod, x_inod)
         j_3 = eigen_loop_end  (i-1,      x_nnod, x_inod)
         u_x(j_2:j_3,i_1) = ZERO

         j_2 = eigen_loop_start(LL+i_1+1, x_nnod, x_inod)
         j_3 = eigen_loop_end  (LL+i_1+MBAND-1, x_nnod, x_inod)
         a  (j_2:j_3,i_1) = ZERO

!      end if
      end do! i_1


#if _DEBUG_
      d1=eigen_get_wtime()
#endif
      x_pos = eigen_translate_g2l(i-1, x_nnod, x_inod)
      if ( MOD(MBAND,2)==1 ) then; i_1 = 1
         call datacast_dbl (u_y(1, i_1), u_x(1, i_1),   u_t, v_t, x_pos)
      end if
      do i_1=MOD(MBAND,2)+1,MBAND,2
         call datacast_dbl2(u_y(1, i_1), u_y(1, i_1+1),
     &                      u_x(1, i_1), u_x(1, i_1+1), u_t, v_t, x_pos)
      end do! i_1
#if _DEBUG_
      d2=eigen_get_wtime()
#if _DEBUG2_
      rt_ptr(3)=rt_ptr(3)+1
      rt_timer(rt_ptr(3),3)=d2-d1
#endif
#endif

!$OMP END MASTER

!
! [u1, u2] = [a1, a2]|1 0| + [e1, e2]|a 0| - [u1, u2]|0 b|
!                    |0 1|           |0 c|           |0 0|
!
!            a = g_n(1)
!            c = g_n(2)
!            b = S1(1,2)
!
! [u1, u2]|1 b| = [a1, a2]|1 0| + [e1, e2]|a 0|
!         |  1|           |0 1|           |0 c|
!
! [u1, u2] = [a1, a2]|1 -b| + [e1, e2]|a c-ab| = A * S1 + E * S2
!                    |0  1|           |0 c   |
!
      return
      end subroutine eigen_prd_ux

      implicit double precision (a-h,o-z)

      real(8), pointer ::
     &           a(:),z(:),w(:)
      integer, parameter :: NDIM = 2

!      real(8), parameter :: PAI = 3.141592653589794D0
      real(8), parameter :: ONE = 1D0
      real(8) :: PAI
!
      include 'mpif.h'
      include 'trd.h'
!
      PAI = 4*ATAN(ONE)
!Kro  call errset(320, 256, 256, 0, 0, 320)
!
      call mpi_init(ierr)
      MPI_COMM_EIGEN=MPI_COMM_WORLD
      call mpi_comm_rank(MPI_COMM_EIGEN,i$inod,ierr)
      call mpi_comm_size(MPI_COMM_EIGEN,i$nnod,ierr)
*
      if(i$inod.eq.0)then
         open(10,file='IN')
      endif
*
      DO

         if(i$inod.eq.0)then
            read(10,*) n,m, nall, mtype
         endif

         call mpi_bcast(n,1,mpi_integer,0,MPI_COMM_EIGEN,ierr)
         if ( n < 1 .or. n > 400000 ) EXIT
         call mpi_bcast(m,1,mpi_integer,0,MPI_COMM_EIGEN,ierr)
         call mpi_bcast(nall,1,mpi_integer,0,MPI_COMM_EIGEN,ierr)
         call mpi_bcast(mtype,1,mpi_integer,0,MPI_COMM_EIGEN,ierr)


         call datacast_init(NDIM)
         NPROW = x_nnod
         NPCOL = y_nnod
! BLACS/PBLAS/SCALAPACK initialization
         CALL BLACS_PINFO( IAM, NPROCS )
         if ( NPROCS < 1 ) then
!  MPI group setup
            NPROCS = i$nnod
            IAM = i$inod
            CALL BLACS_SETUP( IAM, NPROCS )
         end if

         nx = ((n-1)/NPROW+1)
         call CSTAB_get_optdim(nx, 6, 16*4, 16*4*2, nm)
         if(i$inod.eq.0)then
            PRINT*,"N=",n, "NM=",nm
         endif
         call datacast_free(0)


!         NB  = 48
         NB  = 64+32
         nmz = ((n-1)/NPROW+1)
         nmz = ((nmz-1)/NB+1)*NB+1
         nmw = ((n-1)/NPCOL+1)
         nmw = ((nmw-1)/NB+1)*NB+1

         larray = MAX(nmz,nm)*nmw
         allocate(
     &               a(larray), z(larray),
     &               w(n),
     &               stat=istat)
         if(istat.ne.0) then
            print*,"Memory exhausted"
            call flush(6)
            EXIT
         endif
*
         call mat_set(n, a(1), nm, mtype, NDIM)
*-
         call eigen_sx(n, a(1), nm, w(1), z(1), nm, m)
*-
         if(i$inod.eq.0)then
            ax=0D0
            do i=1,n
               j=n-i
               theta=PAI*(2*j+1)/(2*n+1)
               x=5D-1/(1D0-COS(theta))
               ax=MAX(ax,ABS(w(i)-x)/ABS(x))
            enddo
            print*,"max|w(i)-w(i).true|/|w|=",ax
         endif
         call flush(6)
*-
         if(IAND(nall,4)/=0)then
            call mat_set(n, a(1), nm, mtype, NDIM)
            call ev_test_2D(n, a(1), nm, w(1), z(1), nm, t)
         endif
*
         deallocate(a)
         deallocate(z)
         deallocate(w)

      ENDDO

      if(i$inod.eq.0)then
         close(10)
      endif
*
*
      call MPI_Finalize(ierr)
      end

      subroutine flush(i)
      end

!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver. 7.00)
!
!  MODULE: m_FFT
!
!  AUTHOR(S): T. Yamasaki, K. Betsuyaku,   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!                                   , March/14/2005, April/10/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
!
  integer :: idp, idp2, idp3, nlp, nmp, nnp
  integer, private      :: istat = 0
  integer :: sw_avoiding_odd_fftbox = ON
  integer :: sw_zero_padding = ON
  real(kind=DP),private,pointer,dimension(:)               :: cfft
  complex(kind=CMPLDP),private,target,allocatable,dimension(:)    :: cw1,cw2,cw3
  real(kind=DP),private,allocatable,dimension(:)           :: trigs_WF, trigs_pWF, trigs_CD
  integer,      private,allocatable,dimension(:)           :: ifax_WF, ifax_pWF, ifax_CD
  real(kind=DP),private,allocatable, dimension(:)          :: ftw
  ! ------- Positron start
  complex(kind=CMPLDP),private,target,allocatable,dimension(:)    :: cw1_pstrn,cw2_pstrn,cw3_pstrn
  ! ------- Positron end

  include 'mpif.h'
contains 
  subroutine fft_WFCD_work_alloc
    integer :: nnl,nnm,nnn
! ----> work arrays of fft for wave functions
    nnl  = fft_box_size_WF(1,1)
    nnm  = fft_box_size_WF(2,1);  nnn  = fft_box_size_WF(3,1)
    if(ipri >= 1) write(nfout,'(" !!allocation of cw1,cw2,cw3 (fft_WFCD_work_alloc)")')
    if(kimg == 1) then
       allocate(trigs_WF(nnl+2*(nnm+nnn)), stat=istat)
       allocate(ifax_WF(60), stat=istat)
       if(ipri >= 1) write(nfout,'(" !! WF_ASLFFT <<m_FFT.fft_WFCD_work_alloc>>")')
    else if(kimg == 2) then
       allocate(trigs_WF(2*(nnl+nnm+nnn)), stat=istat)
       allocate(ifax_WF(60), stat=istat)
       if(ipri >= 1) write(nfout,'(" !! WF_ASLFFT")')
    end if
! ------- Positron start
! ----> and work arrays of fft for positron wave functions
    if(sw_positron /= OFF) then
       nnl  = fft_box_size_pWF(1,1)
       nnm  = fft_box_size_pWF(2,1);  nnn  = fft_box_size_pWF(3,1)
       if(ipri >= 1) write(nfout,'(" !!allocation of cw1_pstrn,cw2_pstrn,cw3_pstrn (fft_WFCD_work_alloc)")')
       if(kimg == 1) then
          allocate(trigs_pWF(nnl+2*(nnm+nnn)), stat=istat)
          allocate(ifax_pWF(60), stat=istat)
       else if(kimg == 2) then
          allocate(trigs_pWF(2*(nnl+nnm+nnn)), stat=istat)
          allocate(ifax_pWF(60), stat=istat)
       end if
    end if
! ------- Positron end

  end subroutine fft_WFCD_work_alloc

  subroutine m_FFT_alloc_WF_work
  end subroutine m_FFT_alloc_WF_work

  subroutine m_FFT_alloc_pWF_work()
  end subroutine m_FFT_alloc_pWF_work

  subroutine m_FFT_dealloc_WF_work
  end subroutine m_FFT_dealloc_WF_work

  subroutine m_FFT_alloc_CD_box
  end subroutine m_FFT_alloc_CD_box

  subroutine m_FFT_dealloc_CD_box
  end subroutine m_FFT_dealloc_CD_box

  subroutine m_FFT_setup(inversion_symmetry,paramset)
    integer, intent(in) :: inversion_symmetry
    logical, intent(in) :: paramset
!!$    integer :: nnl,nnm,nnn
    integer :: nx,ny,nz, ic, isize

    integer :: nfft_t
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_setup ',id_sname)


! --- fft_box_size_WF, fft_box_size_pWF ---
    if(ipri >= 1) write(nfout,*) '!FFT_WF = ASLFFT <<m_FFT_setup>>'
    if(inversion_symmetry == ON) then  ! kimg == 1
       if(mod(fft_box_size_WF(1,1),4) == 2) then
          fft_box_size_WF(1,0) = fft_box_size_WF(1,1) + 4
       else
          fft_box_size_WF(1,0) = fft_box_size_WF(1,1) + 2
       end if
       fft_box_size_WF(2:3,0) = fft_box_size_WF(2:3,1) + 1
       if(sw_positron /= OFF) then
          if(mod(fft_box_size_pWF(1,1),4) == 2) then
             fft_box_size_pWF(1,0)   = fft_box_size_pWF(1,1) + 4
          else
             fft_box_size_pWF(1,0)   = fft_box_size_pWF(1,1) + 2
          end if
          fft_box_size_pWF(2:3,0) = fft_box_size_pWF(2:3,1) + 1
       end if
    else if(inversion_symmetry == OFF) then ! kimg == 2
       fft_box_size_WF(1:3,0) = fft_box_size_WF(1:3,1) + 1
       if(sw_positron /= OFF) then
          fft_box_size_pWF(1:3,0) = fft_box_size_pWF(1:3,1) + 1
       end if
    endif
! --- fft_box_size_CD ---
    if(ipri >= 1) write(nfout,*) '!FFT_CD = MPIFFT <<m_FFT_setup>>'
    if(inversion_symmetry == ON) then  ! kimg == 1
       if(mod(fft_box_size_CD(1,1),4) == 2) then
          fft_box_size_CD_nonpara(1,0) = fft_box_size_CD(1,1) + 4
       else
          fft_box_size_CD_nonpara(1,0) = fft_box_size_CD(1,1) + 2
       end if
       fft_box_size_CD_nonpara(2:3,0) = fft_box_size_CD(2:3,1) + 1
    else if(inversion_symmetry == OFF) then ! kimg == 2
       fft_box_size_CD_nonpara(1:3,0) = fft_box_size_CD(1:3,1) + 1
    endif
!!$    if(inversion_symmetry == ON) then  ! kimg == 1
!!$       ipad = 2
!!$    else if(inversion_symmetry == OFF) then ! kimg == 2
!!$       ipad = 1
!!$    end if
!!$    fft_box_size_CD_nonpara(1,0)   = fft_box_size_CD(1,1) + ipad
!!$    fft_box_size_CD_nonpara(2:3,0) = fft_box_size_CD(2:3,1)
    nfftp_nonpara  = product(fft_box_size_CD_nonpara(1:3,0)) * (2-inversion_symmetry)

    nx = fft_box_size_CD(1,1); ny = fft_box_size_CD(2,1); nz = fft_box_size_CD(3,1)
    do ic = 1, 2
       if(ic == 1) isize = npes
       if(ic == 2) isize = npes_cdfft
       ny_d =  ny/isize
       nz_d =  nz/isize
       if(mod( ny,isize) .ne. 0) ny_d = ny_d + 1
       if(mod( nz,isize) .ne. 0) nz_d = nz_d + 1
       ly_d = ny_d;   lz_d = nz_d
       if(inversion_symmetry == ON) then  ! kimg == 1
          lx = nx + 2
       else if(inversion_symmetry == OFF) then ! kimg == 2
          lx = nx
          if(mod(lx,2) == 0)   lx = nx + ldx
       end if

       if(mod(ly_d,2) == 0) ly_d = ny_d + ldy
       if(mod(lz_d,2) == 0) lz_d = nz_d + ldz

       ly   = ly_d*isize
       lz   = lz_d*isize
       if(ic == 1) then
          fft_box_size_CD(1,0) = lx
          fft_box_size_CD(2,0) = ly
          fft_box_size_CD(3,0) = lz
          ny_ds = ny_d;          nz_ds = nz_d;          ly_ds = ly_d
          lys   = ly;            lz_ds = lz_d;          lzs   = lz
          lxs   = lx
       else
          fft_box_size_CD_c(1,0) = lx
          fft_box_size_CD_c(2,0) = ly
          fft_box_size_CD_c(3,0) = lz
       end if
    end do
    if(ipri >= 1) then
       write(nfout,'(" nx,  ny,  nz,  ny_d, nz_d  = ",5i8)') nx,ny,nz,ny_d,nz_d
       write(nfout,'("      ly,  lz,  ly_d, lz_d  = ",8x,4i8)') ly,lz,ly_d,lz_d
       write(nfout,'("                ny_ds,nz_ds = ",24x,2i8)') ny_ds, nz_ds
       write(nfout,'("      lys, lzs, ly_ds,lz_ds = ",8x,4i8)') lys,lzs,ly_ds,lz_ds
    end if

    nfft =   product(fft_box_size_WF(1:3,0)) * (2-inversion_symmetry)
    nfftp  = product(fft_box_size_CD_c(1:3,0)) * (2-inversion_symmetry)
    nfftps = product(fft_box_size_CD(1:3,0)) * (2-inversion_symmetry)

    if(ipri >= 1) call wd_FFTboxsizes(nfout)
    if(sw_positron /= OFF) &
         & nfft_pstrn = product(fft_box_size_pWF(1:3,0))*(2-inversion_symmetry)
    nfft_t = nfft
    if(sw_positron /= OFF .and. nfft_t < nfft_pstrn) nfft_t = nfft_pstrn

    if(.not. paramset) then
       call fft_WFCD_work_alloc     ! <cw[123],cw[123]_pstrn,wlp,wmp,wnp> are allocated

! Initialization of the Wave-Function FFT
       allocate(cfft(nfft_t), stat=istat) ! cfft is used only for initiallization
       if(istat /= 0) then
          if(ipri >= 1) then
             write(nfout,*) 'Allocation error for cfft in sub. m_FFT_setup'
             write(nfout,*) 'stat =', istat, 'nfft =', nfft
          end if
          stop
       end if

       call init_fft_coefficients_arrays_WF()

       deallocate(cfft,stat=istat)
       if(istat /= 0 ) then
          if(ipri >= 1) then
             write(nfout,*) 'Deallocation error for cfft in sub. m_FFT_setup'
             write(nfout,*) 'stat =', istat
          end if
          stop
       end if
    endif

    call tstatc0_end(id_sname)

  contains
    subroutine init_fft_coefficients_arrays_WF()
      use m_Parallelization,   only : itask
      integer :: id, nl, nm, nn, ierr
      integer :: id_p, nl_p, nm_p, nn_p
      real(kind=DP) :: ftw(nfft+nfft_pstrn)
      integer :: id2, id3, id_p2, id_p3

      id = fft_box_size_WF(1,0)
      id2 = fft_box_size_WF(2,0)
      id3 = fft_box_size_WF(3,0)
      nl = fft_box_size_WF(1,1)
      nm = fft_box_size_WF(2,1)
      nn = fft_box_size_WF(3,1)
      if(sw_positron /= OFF) then
         id_p = fft_box_size_pWF(1,0)
         id_p2 = fft_box_size_pWF(2,0)
         id_p3 = fft_box_size_pWF(3,0)
         nl_p = fft_box_size_pWF(1,1)
         nm_p = fft_box_size_pWF(2,1)
         nn_p = fft_box_size_pWF(3,1)
      end if

      if(kimg == 1) then
         call qfr3fb(nl,nm,nn,cfft,id,id2,id3,0,ifax_WF,trigs_WF,ftw,itask,ierr)
         if(sw_positron /= OFF) then
            call qfr3fb(nl_p,nm_p,nn_p,cfft,id_p,id_p2,id_p3,0,ifax_pWF,trigs_pWF,ftw,itask,ierr)
         endif
      else
         call hfc3fb(nl,nm,nn,cfft,id,id2,id3,0,ifax_WF,trigs_WF,ftw,itask,ierr)
         if(sw_positron /= OFF) then
            call hfc3fb(nl_p,nm_p,nn_p,cfft,id_p,id_p2,id_p3,0,ifax_pWF,trigs_pWF,ftw,itask,ierr)
         end if
      endif
    end subroutine init_fft_coefficients_arrays_WF
  end subroutine m_FFT_setup

  subroutine CDFFT_setup()
     CD_setup_is_done = YES
  end subroutine CDFFT_setup

  subroutine m_FFT_WF(electron_or_positron,nfout,afft,inverse_or_direct,switch)  ! G space --> R space
    use m_Parallelization,   only : itask
    integer, intent(in)          :: electron_or_positron
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(nfft)
    integer, intent(in)          :: inverse_or_direct
    integer, intent(in)          :: switch
    complex(kind=CMPLDP),pointer,dimension(:) :: cw1_t, cw2_t, cw3_t
    integer :: id, nl, nm, nn, ier1 = 0
    real(kind=DP) :: ftw(nfft)
    integer, dimension(2) :: flag_asl_rfft      = (/-1,  1/)
    integer, dimension(2) :: flag_asl_cfft      = (/ 1, -1/)
    integer :: id2, id3
    integer :: isw
    integer :: id_sname = -1

    if(electron_or_positron == ELECTRON) then
       id = fft_box_size_WF(1,0)
       id2 = fft_box_size_WF(2,0)
       id3 = fft_box_size_WF(3,0)
       nl = fft_box_size_WF(1,1)
       nm = fft_box_size_WF(2,1)
       nn = fft_box_size_WF(3,1)
       cw1_t=>cw1; cw2_t=>cw2; cw3_t=>cw3
    else if(electron_or_positron == POSITRON) then
       id = fft_box_size_pWF(1,0)
       id2 = fft_box_size_pWF(2,0)
       id3 = fft_box_size_pWF(3,0)
       nl = fft_box_size_pWF(1,1)
       nm = fft_box_size_pWF(2,1)
       nn = fft_box_size_pWF(3,1)
       cw1_t=>cw1_pstrn; cw2_t=>cw2_pstrn; cw3_t=>cw3_pstrn
    end if

    if(electron_or_positron == ELECTRON) then
       if(kimg == 1) then
          isw = -flag_asl_rfft(inverse_or_direct)
!!$          if(ipri >= 2) write(nfout,*) 'size(afft)=',size(afft)
!!$          if(ipri >= 2) write(nfout,*) 'isw=',isw
!!$          if(ipri >= 2) write(nfout,*) 'nl,nm,nn,id,id2,id3=',nl,nm,nn,id,id2,id3
          call qfr3bf(nl,nm,nn,afft,id,id2,id3,isw,ifax_WF,trigs_WF,ftw,itask,ier1)
       else if(kimg == 2) then
          isw = -flag_asl_cfft(inverse_or_direct)
          call hfc3bf(nl,nm,nn,afft,id,id2,id3,isw,ifax_WF,trigs_WF,ftw,itask,ier1)
       end if
    else if(electron_or_positron == POSITRON) then
       if(kimg == 1) then
          isw = -flag_asl_rfft(inverse_or_direct)
          call qfr3bf(nl,nm,nn,afft,id,id2,id3,isw,ifax_pWF,trigs_pWF,ftw,itask,ier1)
       else if(kimg == 2) then
          isw = flag_asl_cfft(inverse_or_direct)
          call hfc3bf(nl,nm,nn,afft,id,id2,id3,isw,ifax_pWF,trigs_pWF,ftw,itask,ier1)
       end if
    end if

    call sxfft_zero_padding(afft,nl,nm,nn,id,id2,id3)

    if (ier1 /= 0) then
       if(ipri>=1) write (nfout,*) ' !!(Error fft) ier1 = ',ier1
       stop
    end if
  end subroutine m_FFT_WF

 subroutine sxfft_zero_padding(afft,nl,nm,nn,nd1,nd2,nd3)
      use m_Const_Parameters, only : DP
      implicit none
      real(kind=DP), intent(out) :: afft(*)
      integer, intent(in) :: nl,nm,nn
      integer, intent(in) :: nd1,nd2,nd3
      integer :: i,j,k,ip
      integer :: nlh,ndh
      integer :: imax
      imax = nd1*nd2*nd3

      if(kimg==1) then
         nlh = nl/2
         ndh = nd1/2
         if(ipri >= 2) write(6,*) 'ASLFFT: nl,ndh=',nlh,ndh
         do j = nlh+2, ndh
            do i = 1, nd2*nn
               ip = ndh*(i-1) + j
               afft(ip*2-1) = 0.d0
               afft(ip*2) = 0.d0
            end do
         end do
         do j = nm+1, nd2
            do k = 1, nd3
               do i = 1, ndh
                  ip = i + ndh*(j-1) + ndh*nd2*(k-1)
                  afft(ip*2-1) = 0.d0
                  afft(ip*2) = 0.d0
               end do
            end do
         end do
         do k = nn+1, nd3
            do i = 1, ndh*nd2
               ip = i + ndh*nd2*(k-1)
               afft(ip*2-1) = 0.d0
               afft(ip*2) = 0.d0
            end do
         end do

      else if(kimg==2) then
         do j = nl+1, nd1
            do i = 1, nd2*nn
               ip = nd1*(i-1) + j
               afft(ip*2-1) = 0.d0
               afft(ip*2) = 0.d0
            end do
         end do
         do j = nm+1, nd2
            do k = 1, nn
               do i = 1, nl
                  ip = i + nd1*(j-1) + nd1*nd2*(k-1)
                  afft(ip*2-1) = 0.d0
                  afft(ip*2) = 0.d0
               end do
            end do
         end do
         do k = nn+1, nd3
            do i = 1, nd1*nd2
               ip = i + nd1*nd2*(k-1)
               afft(ip*2-1) = 0.d0
               afft(ip*2) = 0.d0
            end do
         end do
      end if
 end subroutine sxfft_zero_padding

 subroutine fft_CD_inverse_core(afft_CD)
      use m_Parallelization,   only : itask
!!$      real(kind=DP), intent(inout) :: afft_cd(nfftp)
      real(kind=DP), intent(inout) :: afft_cd(nfftp_nonpara)
      real(kind=DP) :: ftw(nfftp_nonpara)
      integer :: idp, idp2, idp3, nlp, nmp, nnp
      integer :: isw, ier1

      idp  = fft_box_size_CD_nonpara(1,0)
      idp2 = fft_box_size_CD_nonpara(2,0)
      idp3 = fft_box_size_CD_nonpara(3,0)
      nlp  = fft_box_size_CD(1,1)
      nmp  = fft_box_size_CD(2,1)
      nnp  = fft_box_size_CD(3,1)

      if(.not.allocated(ifax_CD)) allocate(ifax_CD(60))
      if(kimg == 1) then
         if(.not.allocated(trigs_CD)) allocate(trigs_CD(nlp+2*(nmp+nnp)))
      else if(kimg == 2) then
         if(.not.allocated(trigs_CD)) allocate(trigs_CD(2*(nlp+nmp+nnp)))
      end if

      if(kimg == 1) then
         isw =  1
         call qfr3bf(nlp,nmp,nnp,afft_CD,idp,idp2,idp3,isw,ifax_CD,trigs_CD,ftw,itask,ier1)
      else if(kimg == 2) then
         isw = -1
         call hfc3bf(nlp,nmp,nnp,afft_CD,idp,idp2,idp3,isw,ifax_CD,trigs_CD,ftw,itask,ier1)
      end if
      call sxfft_zero_padding(afft_CD,nlp,nmp,nnp,idp,idp2,idp3)
 end subroutine fft_CD_inverse_core

 subroutine fft_CD_direct_core(afft_CD)
      use m_Parallelization,   only : itask
!!$      real(kind=DP), intent(inout) :: afft_cd(nfftp)
      real(kind=DP), intent(inout) :: afft_cd(nfftp_nonpara)
      real(kind=DP) :: ftw(nfftp_nonpara)
      integer :: isw, ier1

      idp  = fft_box_size_CD_nonpara(1,0)
      idp2 = fft_box_size_CD_nonpara(2,0)
      idp3 = fft_box_size_CD_nonpara(3,0)
      nlp  = fft_box_size_CD(1,1)
      nmp  = fft_box_size_CD(2,1)
      nnp  = fft_box_size_CD(3,1)

      if(.not.allocated(ifax_CD)) allocate(ifax_CD(60))
      if(kimg == 1) then
         if(.not.allocated(trigs_CD)) allocate(trigs_CD(nlp+2*(nmp+nnp)))
      else if(kimg == 2) then
         if(.not.allocated(trigs_CD)) allocate(trigs_CD(2*(nlp+nmp+nnp)))
      end if

      if(kimg == 1) then
         isw = -1
         call qfr3bf(nlp,nmp,nnp,afft_CD,idp,idp2,idp3,isw,ifax_CD,trigs_CD,ftw,itask,ier1)
      else if(kimg == 2) then
         isw =  1
         call hfc3bf(nlp,nmp,nnp,afft_CD,idp,idp2,idp3,isw,ifax_CD,trigs_CD,ftw,itask,ier1)
      end if
      call sxfft_zero_padding(afft_CD,nlp,nmp,nnp,idp,idp2,idp3)
 end subroutine fft_CD_direct_core

#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_IODO__
#   define __TIMER_IODO_START(a)   call timer_sta(a)
#   define __TIMER_IODO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_IODO_START(a)
#   define __TIMER_IODO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif
#ifdef __TIMER_IOCOMM__
#   define __TIMER_IOCOMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_IOCOMM_START(a)       call timer_sta(a)
#   define __TIMER_IOCOMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_IOCOMM_START_w_BARRIER(str,a)
#   define __TIMER_IOCOMM_START(a)
#   define __TIMER_IOCOMM_STOP(a)
#endif

module m_KineticEnergy_Density
  use m_Control_Parameters,  only : nspin, kimg, noncol, &
       &                            use_symm_ekin_density, use_asymm_ekin_density, &
       &                            af

  use m_KPoints,             only : kv3, vkxyz
  use m_Const_Parameters,    only : DP, DIRECT, OFF, ELECTRON, DELTA, BUCS, PAI2, NO, &
       &                            ANTIFERRO
  use m_PlaneWaveBasisSet,    only : kgp, kg1, ngabc, iba, nbase, igf, kg, gr_l, &
       &                             ngpt_l, ista_k, iend_k
  use m_Crystal_Structure,    only : rltv, univol, tau, nopr
  use m_Electronic_Structure, only : zaj_l, occup_l, m_ES_WF_in_Rspace1
  use m_FFT,                  only : m_FFT_alloc_WF_work, m_FFT_dealloc_WF_work, &
       &                             nfft, m_FFT_WF, fft_box_size_WF
  use m_Parallelization,      only : np_e, map_z, map_k, myrank_k, mpi_comm_group, &
       &                             npes, ista_kngp, iend_kngp, mype
  use m_Files,                only : nfout

! === KT_add === 2014/09/19
  use m_Const_Parameters,   only : YES, NO, EXECUT, SKIP, zi, SIMPLE_CUBIC, PAI, ON
  use m_Control_Parameters,  only : m_CtrlP_cachesize, ndim_magmom, nel_ylm, &
       &                            ekin_density_type, sw_rspace_ekin_density, &
       &                            sw_calc_ekin_density_hardpart, &
       &                            sw_add_ekin_hardpart_on_Gspace
  use m_Parallelization,      only : ista_fftph, iend_fftph, ista_fftp, iend_fftp, &
       &                             nel_fftp, idisp_fftp, ierr, &
       &                             ista_e, iend_e, istep_e
  use m_Ionic_System,           only : ntyp, ityp, natm, iwei, pos
  use m_Crystal_Structure,    only : nbztyp
  use m_PseudoPotential,    only :  kina_qitg_l, kins_qitg_l, modnrm, nqitg, &
       &                            m_PP_include_vanderbilt_pot, nlmt, dl2p, &
       &                            m_PP_find_maximum_l, &
       &                            m_PP_set_index_arrays1, m_PP_set_index_arrays2, &
       &                            mmesh, nmesh, xh, rmax, ilmt, ltp, mtp, taup, &
       &                            psirpw, phirpw
  use m_PlaneWaveBasisSet,    only : ylm_l,  m_pwBS_sphrp2, igfp_l
  use m_Charge_Density,       only : hsr, chgq_l

  use m_FFT,                  only : fft_box_size_CD, nfftp_nonpara, nfftp, &
       &                             m_FFT_CD_direct_c, m_FFT_alloc_CD_box, &
       &                             m_FFT_dealloc_CD_box, m_FFT_CD_inverse_c
  use m_Realspace,            only : nmesh_rs_aug_max, nmesh_rs_aug, &
       &                             meshx_rs_aug, meshy_rs_aug, meshz_rs_aug, &
       &                             meshxyz_rs_aug, m_RS_R_minus_pos
! ============== 2014/09/19

  use m_Files,  only : nf_ekindens
  use m_Const_Parameters,   only : CMPLDP

  implicit none
  include 'mpif.h'

  real(kind=DP), allocatable, target :: ekins_l(:,:,:)  ! symmetric, positive definite
  real(kind=DP), allocatable, target :: ekina_l(:,:,:)  ! asymmetric

  real(kind=DP), allocatable, target :: ekins_old(:,:,:) 
  real(kind=DP), allocatable, target :: ekina_old(:,:,:) 

  real(kind=DP), allocatable :: kins_qrs_rspace(:,:,:,:) 
  real(kind=DP), allocatable :: kina_qrs_rspace(:,:,:,:) 

  real(kind=DP), public, pointer, dimension(:,:)        :: work

contains

  subroutine m_KE_alloc_ekin_density
    if ( use_symm_ekin_density ) then
       if ( noncol ) then
       else
          allocate( ekins_l(ista_kngp:iend_kngp,kimg,nspin) )
          allocate( ekins_old(ista_kngp:iend_kngp,kimg,nspin) )
       endif
       ekins_l = 0.0d0;   ekins_old = 0.0d0
    endif

    if ( use_asymm_ekin_density ) then
       if ( noncol ) then
       else
          allocate( ekina_l(ista_kngp:iend_kngp,kimg,nspin) )
          allocate( ekina_old(ista_kngp:iend_kngp,kimg,nspin) )
       endif
       ekina_l = 0.0d0;   ekina_old = 0.0d0
    endif
  end subroutine m_KE_alloc_ekin_density

  subroutine m_KE_dealloc_ekin_density
    if ( allocated( ekins_l ) ) deallocate( ekins_l )
    if ( allocated( ekina_l ) ) deallocate( ekina_l )
    if ( allocated( ekins_old ) ) deallocate( ekins_old )
    if ( allocated( ekina_old ) ) deallocate( ekina_old )

    if ( allocated( kins_qrs_rspace ) ) deallocate( kins_qrs_rspace )
  end subroutine m_KE_dealloc_ekin_density

  subroutine m_KE_cp_ekin_density_to_old
    if ( use_symm_ekin_density )  ekins_old = ekins_l
    if ( use_asymm_ekin_density ) ekina_old = ekina_l
  end subroutine m_KE_cp_ekin_density_to_old

  subroutine m_KE_calc_asymm_ekin_density
    ekina_l = 0.0d0

    call calc_local_part
    if ( sw_calc_ekin_density_hardpart == OFF ) return
    if ( sw_rspace_ekin_density == ON ) then
       if ( sw_add_ekin_hardpart_on_Gspace == OFF ) return
    endif

    if ( sw_rspace_ekin_density == ON ) then
       call add_hardpart_evaluated_rspace
    else
       call add_hardpart_to_ekinq_l( nfout, ndim_magmom, hsr, NO, .false. , &
            &                        kina_qitg_l, ekina_l )
    endif

  contains

    subroutine add_hardpart_evaluated_rspace
      integer :: is, ia, it, nma, ind, i
      integer :: lmt1, lmt2
      real(kind=DP) :: fac, fac0
      real(kind=DP), allocatable :: kina_tmp(:), ekina_hard(:,:)
      real(kind=DP), allocatable :: afft(:)

      call m_FFT_alloc_CD_box

      allocate( afft(ista_fftp:iend_fftp) ); afft = 0.0d0
      allocate( kina_tmp(nmesh_rs_aug_max)); kina_tmp = 0.0d0
      allocate( ekina_hard(ista_kngp:iend_kngp,kimg) ); ekina_hard = 0.0d0

      Do is=1, nspin
         afft = 0.0d0
         ekina_hard = 0.0d0

         Do ia=1, natm
            it = ityp(ia);   nma = nmesh_rs_aug(ia)        
            kina_tmp = 0.0d0

            Do lmt1=1, ilmt(it)
               Do lmt2=1, ilmt(it)
               
                  fac0=1.0d0
                  fac = hsr(ia,lmt1,lmt2,is) *fac0
                  Do i=1, nma
                     kina_tmp(i) = kina_tmp(i) &
                          &            +fac *kina_qrs_rspace(i,ia,lmt1,lmt2)
                  End do
               End do
            End do

            Do i=1, nma
               ind = meshxyz_rs_aug(i,ia)
               if ( ind >= ista_fftph .and. ind <= iend_fftph ) then
                  afft(2*ind-1) = afft(2*ind-1) +kina_tmp(i)
               endif
            End do
         End do

         afft = afft / univol

         call m_FFT_CD_direct_c( nfout, afft )         ! afft(R) -> afft(G)
         call extract_matrix_from_FFTcd_mesh( afft, ekina_hard(:,:) )
!
         ekina_l(:,:,is) = ekina_l(:,:,is) +ekina_hard(:,:)
      End Do

      call m_FFT_dealloc_CD_box
      deallocate( kina_tmp );  deallocate( afft )
      deallocate( ekina_hard )

    end subroutine add_hardpart_evaluated_rspace

    subroutine calc_local_part
      integer :: ispin, ik, ib, ixyz, ierr
      integer :: i, ig, ri, iend, i1
      real(kind=DP) :: fac, occupation, c1, c2
      real(kind=DP), allocatable :: qxyz(:,:), psi_l(:,:,:,:)
      real(kind=DP), allocatable :: afft(:), bfft(:), cfft(:)
      
      allocate(afft(nfft)); afft =0.0d0; 
      allocate(bfft(nfft)); bfft= 0.0d0
      allocate(cfft(nfft)); cfft= 0.0d0
      allocate( qxyz(kg1,3 ) ); qxyz = 0.0d0

      call m_FFT_alloc_WF_work()
    
      fac = 2.d0/(univol*kv3*product(fft_box_size_WF(1:3,1)))
      
      Do ispin=1, nspin
         afft = 0.0d0

         Do ik=ispin, kv3+ispin-nspin, nspin
            if ( map_k(ik) /= myrank_k ) cycle
            
            call k_plus_G_vectors_m( ik, kgp, kg1, kv3, iba, nbase, ngabc, rltv, &
                 &                   qxyz(:,1), qxyz(:,2), qxyz(:,3) )
            
            allocate( psi_l( kg1, np_e, ik:ik, kimg ) ); psi_l = 0.0d0
            
            Do ib = ista_e, iend_e, istep_e
               occupation = occup_l( map_z(ib),ik )
               if ( occupation < DELTA ) cycle
               
               call m_ES_WF_in_Rspace1( ista_k, iend_k, ik, ib, zaj_l, cfft )
               
               Do ig=1, iba(ik)
                  c1 = qxyz(ig,1)**2 + qxyz(ig,2)**2 + qxyz(ig,3)**2
                  psi_l(ig,map_z(ib),ik,1:2) = zaj_l(ig,map_z(ib),ik,1:2) *c1
               End Do
               call m_ES_WF_in_Rspace1( ik, ik, ik, ib, psi_l, bfft )
               
               Do i = 1, nfft-1, 2
                  c1 = bfft(i)*cfft(i)   +bfft(i+1)*cfft(i+1) 
                  c2 = bfft(i)*cfft(i+1) -bfft(i+1)*cfft(i) 
                  afft(i)   = afft(i)   + occupation *c1
                  afft(i+1) = afft(i+1) + occupation *c2
               End do
               
            End do
            deallocate( psi_l )
         End do
         !
         if ( npes > 1 ) then
            call mpi_allreduce( afft, bfft, nfft, mpi_double_precision, &
                 &              mpi_sum, mpi_comm_group, ierr )
            afft = bfft     
         end if
         call m_FFT_WF(ELECTRON,nfout,afft,DIRECT,OFF)
         !
         do ri = 1, kimg
            iend = iend_kngp
            if( iend_kngp > kg ) iend = kg
            if( ista_kngp <= iend ) then
               do i = ista_kngp, iend  !for mpi
                  i1 = kimg*igf(i) + (ri - kimg)
                  ekina_l(i,ri,ispin) = afft(i1)*fac
               end do
            endif
         end do
         
      End Do
      
      ekina_l = ekina_l /2.0d0
 
      call symmetrize_ekin( NO, ekina_l )

      deallocate( afft ); deallocate(bfft ); deallocate( cfft ); deallocate( qxyz )
      call m_FFT_dealloc_WF_work()

    end subroutine calc_local_part

  end subroutine m_KE_calc_asymm_ekin_density

  subroutine m_KE_calc_symm_ekin_density
    ekins_l = 0.0d0

    call calc_local_part

    if ( sw_calc_ekin_density_hardpart == OFF ) return

    if ( sw_rspace_ekin_density == ON ) then
       if ( sw_add_ekin_hardpart_on_Gspace == OFF ) return
    endif

    if ( sw_rspace_ekin_density == ON ) then
       call add_hardpart_evaluated_rspace
    else
       call add_hardpart_to_ekinq_l( nfout, ndim_magmom, hsr, NO, .false. , &
            &                        kins_qitg_l, ekins_l )
    endif

  contains

    subroutine add_hardpart_evaluated_rspace
      integer :: is, ia, it, nma, ind, i
      integer :: lmt1, lmt2
      real(kind=DP) :: fac, fac0
      real(kind=DP), allocatable :: kins_tmp(:), ekins_hard(:,:)
      real(kind=DP), allocatable :: afft(:)

      call m_FFT_alloc_CD_box

      allocate( afft(ista_fftp:iend_fftp) ); afft = 0.0d0
      allocate( kins_tmp(nmesh_rs_aug_max)); kins_tmp = 0.0d0
      allocate( ekins_hard(ista_kngp:iend_kngp,kimg) ); ekins_hard = 0.0d0

      Do is=1, nspin
         afft = 0.0d0
         ekins_hard = 0.0d0

         Do ia=1, natm
            it = ityp(ia);   nma = nmesh_rs_aug(ia)        
            kins_tmp = 0.0d0

            Do lmt1=1, ilmt(it)
               Do lmt2=lmt1, ilmt(it)
               
                  fac0=2.0d0
                  if (lmt1.eq.lmt2) fac0=1.d0

                  fac = hsr(ia,lmt1,lmt2,is) *fac0
                  Do i=1, nma
                     kins_tmp(i) = kins_tmp(i) &
                          &            +fac *kins_qrs_rspace(i,ia,lmt1,lmt2)
                  End do
               End do
            End do

            Do i=1, nma
               ind = meshxyz_rs_aug(i,ia)
               if ( ind >= ista_fftph .and. ind <= iend_fftph ) then
                  afft(2*ind-1) = afft(2*ind-1) +kins_tmp(i)
               endif
            End do
         End do

         afft = afft / univol

         call m_FFT_CD_direct_c( nfout, afft )         ! afft(R) -> afft(G)
         call extract_matrix_from_FFTcd_mesh( afft, ekins_hard(:,:) )
!
         ekins_l(:,:,is) = ekins_l(:,:,is) +ekins_hard(:,:)
      End Do

      call m_FFT_dealloc_CD_box
      deallocate( kins_tmp );  deallocate( afft )
      deallocate( ekins_hard )

    end subroutine add_hardpart_evaluated_rspace

    subroutine calc_local_part
      integer :: ispin, ik, ib, ixyz, ierr
      integer :: i, ig, ri, iend, i1
      real(kind=DP) :: fac, occupation
      real(kind=DP), allocatable :: qxyz(:,:), psi_l(:,:,:,:)
      real(kind=DP), allocatable :: afft(:), bfft(:)
      
      allocate(afft(nfft)); afft = 0.0d0
      allocate(bfft(nfft)); bfft= 0.0d0
      allocate( qxyz(kg1,3 ) ); qxyz = 0.0d0
    
      call m_FFT_alloc_WF_work()
    
      fac = 2.d0/(univol*kv3*product(fft_box_size_WF(1:3,1)))

      Do ispin=1, nspin
         afft = 0.0d0
       
         Do ik=ispin, kv3+ispin-nspin, nspin
!!         Do ik=ispin, kv3, nspin
            if ( map_k(ik) /= myrank_k ) cycle
            
            call k_plus_G_vectors_m( ik, kgp, kg1, kv3, iba, nbase, ngabc, rltv, &
                 &                   qxyz(:,1), qxyz(:,2), qxyz(:,3) )
          
            allocate( psi_l( kg1, np_e, ik:ik, kimg ) ); psi_l = 0.0d0

            Do ib = ista_e, iend_e, istep_e
               occupation = occup_l( map_z(ib),ik )
               if ( occupation < DELTA ) cycle
             
               Do ixyz=1, 3
                  psi_l = 0.0d0
                  if ( kimg == 1 ) then
                     call phase_error_with_msg(nfout,"kimg=1 unsupported",__LINE__,__FILE__)
                  else
                     Do ig=1, iba(ik)
                        psi_l(ig,map_z(ib),ik,2) =  zaj_l(ig,map_z(ib),ik,1) &
                             &                       *qxyz(ig,ixyz)
                        psi_l(ig,map_z(ib),ik,1) = -zaj_l(ig,map_z(ib),ik,2) &
                             &                       *qxyz(ig,ixyz)
                     End do
                  endif
                
                  bfft = 0.0d0
                  call m_ES_WF_in_Rspace1( ik, ik, ik, ib, psi_l, bfft )
                
                  Do i = 1, nfft-1, 2
                     afft(i) = afft(i) + occupation*(bfft(i)**2+bfft(i+1)**2) ! MPI
                  End do
                  
               End Do
            End do
            deallocate( psi_l )
         End do
       !
         if ( npes > 1 ) then
            call mpi_allreduce( afft, bfft, nfft, mpi_double_precision, &
                 &              mpi_sum, mpi_comm_group, ierr )
            afft = bfft   
         end if
         call m_FFT_WF(ELECTRON,nfout,afft,DIRECT,OFF)
         !
         do ri = 1, kimg
            iend = iend_kngp
            if( iend_kngp > kg ) iend = kg
            if( ista_kngp <= iend ) then
               do i = ista_kngp, iend  !for mpi
                  i1 = kimg*igf(i) + (ri - kimg)
                  ekins_l(i,ri,ispin) = afft(i1)*fac
               end do
            endif
         end do

      End Do

      ekins_l = ekins_l /2.0d0

      call symmetrize_ekin( NO, ekins_l )

      deallocate( afft ); deallocate(bfft ); deallocate( qxyz )
      call m_FFT_dealloc_WF_work()

    end subroutine calc_local_part

  end subroutine m_KE_calc_symm_ekin_density


  subroutine extract_matrix_from_FFTcd_mesh( afft, matrix )
    real(kind=DP), intent(in) :: afft(ista_fftp:iend_fftp)
    real(kind=DP), intent(out) :: matrix(ista_kngp:iend_kngp,kimg)

    integer :: ik, i, ip
    real(kind=DP) :: rinplw
    real(kind=DP), allocatable :: afft_mpi1(:)

    matrix = 0.0d0

    allocate(afft_mpi1(nfftp))
    if ( npes >1 ) then
       call mpi_allgatherv( afft, nel_fftp(mype), mpi_double_precision, &  ! MPI
            &               afft_mpi1, nel_fftp, idisp_fftp, mpi_double_precision, &
            &               mpi_comm_group, ierr )
    else
       afft_mpi1 = afft
    end if

    rinplw = 1.d0 /product(fft_box_size_CD(1:3,1))
    do ik=1, kimg
       do i=ista_kngp, iend_kngp          !for mpi
          ip = (igfp_l(i)-1)*kimg + ik
          matrix(i,ik) = afft_mpi1(ip)*rinplw
       end do
    end do

  end subroutine extract_matrix_from_FFTcd_mesh

  subroutine k_plus_G_vectors_m(ik,kgp,kg1,knv3,iba,nbase,ngabc,rltv, &
       &                        qx,qy,qz)
    integer, intent(in)        :: ik, kgp,kg1,knv3,iba(knv3),nbase(kg1,knv3)
    integer, intent(in)        :: ngabc(kgp,3)
    real(kind=DP), intent(in)  :: rltv(3,3)
    real(kind=DP), intent(out) :: qx(kg1),qy(kg1),qz(kg1)

    integer :: i, ip
    real(kind=DP) :: ga, gb, gc

    do i = 1, iba(ik)
       ip = nbase(i,ik)
       ga = vkxyz(ik,1,BUCS) + real(ngabc(ip,1),kind=DP)
       gb = vkxyz(ik,2,BUCS) + real(ngabc(ip,2),kind=DP)
       gc = vkxyz(ik,3,BUCS) + real(ngabc(ip,3),kind=DP)
       qx(i)  = rltv(1,1)*ga + rltv(1,2)*gb + rltv(1,3)*gc
       qy(i)  = rltv(2,1)*ga + rltv(2,2)*gb + rltv(2,3)*gc
       qz(i)  = rltv(3,1)*ga + rltv(3,2)*gb + rltv(3,3)*gc
    end do
  end subroutine k_plus_G_vectors_m


  subroutine symmetrize_ekin(mode,ekin)
    integer,intent(in)           :: mode 
    real(kind=DP), intent(inout) :: ekin(ista_kngp:iend_kngp,kimg,nspin)

    integer ::       ispin, ng, no, ngp, no1, no2
    real(kind=DP) :: fi, tx,ty,tz, fp, fc, fs, zcr, zci
    real(kind=DP), allocatable :: work(:,:), work2(:,:)

    allocate(work(kgp,kimg)); work = 0.d0
    allocate(work2(ista_kngp:iend_kngp,kimg)); work2 = 0.d0

    if(mode == ANTIFERRO) then
       fi = 1.d0/af
       no1 = nopr + 1; no2 = nopr + af
    else
       fi = 1.d0/nopr
       no1 = 1; no2 = nopr
    end if

    do ispin = 1, nspin, af+1
       work = 0.0d0
       call cp_ekin_to_work(ispin,ekin)     ! ekin -> work
       work2 = 0.d0                          ! initialization

       do no = no1, no2
          tx = tau(1,no,BUCS)*PAI2
          ty = tau(2,no,BUCS)*PAI2
          tz = tau(3,no,BUCS)*PAI2
          if(kimg == 1) then
             do ng = ista_kngp, iend_kngp !for mpi
                ngp = ngpt_l(ng,no)
                fp = ngabc(ngp,1)*tx + ngabc(ngp,2)*ty + ngabc(ngp,3)*tz
                work2(ng,1)        = work2(ng,1) + dcos(fp)*work(ngp,1)
             end do
          else if(kimg == 2) then
             do ng = ista_kngp, iend_kngp !for mpi
                ngp= ngpt_l(ng,no)
                fp = ngabc(ngp,1)*tx + ngabc(ngp,2)*ty + ngabc(ngp,3)*tz
                fc = dcos(fp);     fs = dsin(fp)
                zcr= work(ngp,1);  zci= work(ngp,kimg)
                work2(ng,1)        = work2(ng,1) + fc*zcr - fs*zci
                work2(ng,2)        = work2(ng,2) + fc*zci + fs*zcr
             end do
          end if
       end do
       if(mode /= ANTIFERRO) ekin(:,:,ispin) = work2(:,:)*fi
    end do

    if(mode == ANTIFERRO) ekin(:,:,nspin) = work2(:,:)*fi

    deallocate( work )
    deallocate(work2)

  contains

    subroutine cp_ekin_to_work(ispin,ekin)
      integer, intent(in) :: ispin
      real(DP),intent(in),dimension(ista_kngp:iend_kngp,kimg,nspin) :: ekin
      
      integer :: ng,ri, ierr
      real(kind=DP), allocatable, dimension(:,:) :: work_mpi
      
      do ri = 1, kimg
         do ng = ista_kngp, iend_kngp  !for mpi
            work(ng,ri) = ekin(ng,ri,ispin)
         end do
      end do
      
      if(npes >= 2) then
         allocate(work_mpi(kgp,kimg)); work_mpi = 0.d0
         call mpi_allreduce( work, work_mpi, kgp*kimg, mpi_double_precision, &
              &              mpi_sum, mpi_comm_group, ierr )
         work = work_mpi
         deallocate(work_mpi)
      end if
      
    end subroutine cp_ekin_to_work
    
  end subroutine symmetrize_ekin


  subroutine m_KE_set_modeled_ekin_density( ista_rho, iend_rho, &
       &                                    rho, grad_rho, grad2_rho, ekin_dens )
    integer,intent(in) :: ista_rho, iend_rho
    real(kind=DP), intent(in) :: rho( ista_rho:iend_rho, nspin )
    real(kind=DP), intent(in) :: grad_rho( ista_rho:iend_rho, nspin )
    real(kind=DP), intent(in) :: grad2_rho( ista_rho:iend_rho, nspin )
    real(kind=DP), intent(out) :: ekin_dens( ista_rho:iend_rho, nspin )
    
    select case ( ekin_density_type )

    case (1)
       call calc_Abramov_ekin_density( rho, grad_rho, grad2_rho, ekin_dens )

    case (2)                        ! Thomas-Fermi von Weizsacker
       call calc_TF_vWeiz_ekin_density( rho, grad_rho, grad2_rho, &
         &                              1.0d0, 1.0d0, ekin_dens )

    case (3)                        ! extended Thomas-Fermi
       call calc_Extended_TF_ekin_density( rho, grad_rho, grad2_rho, ekin_dens )

    end select

  contains

    subroutine calc_extended_TF_ekin_density( rho, grad_rho, grad2_rho, &
         &                                    ekin_dens )
      real(kind=DP), intent(in) :: rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad2_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(out) :: ekin_dens( ista_rho:iend_rho, nspin )

      integer :: is, i
      real(kind=DP) :: c1, c2, c3, kappa0, kappa2, kappa4, term1, term2, term3
      real(kind=DP), parameter :: delta1 = 1.0E-12

      c1 = (3.0d0*PAI**2)**(2.0d0/3.0d0)
      kappa0 = 3.0d0/5.0d0 *c1
      kappa2 = 1.0d0/36.0d0
      kappa4 = 1.0d0/6480.0d0/c1

      ekin_dens = 0.0d0

      Do is=1, nspin
         Do i=ista_rho, iend_rho
            c1 = rho(i,is)

            if ( c1 > delta1 ) then
               c2 =  grad_rho(i,is)/c1
               c3 = grad2_rho(i,is)/c1

               term1 = kappa0 *c1**(5.0d0/3.0d0)
               term2 = kappa2 *grad_rho(i,is)*c2
               term3 = kappa4 *c1**(1.0d0/3.0d0) &
                    &         *( 8.0d0 *c2**4 -27.0d0 *c2**2 *c3 +24.0d0 *c3**2 )

               ekin_dens(i,is) = term1 +term2 +term3
            endif
         End do
      End Do
      ekin_dens = ekin_dens /2.0d0

    end subroutine calc_extended_TF_ekin_density

    subroutine calc_TF_vWeiz_ekin_density( rho, grad_rho, grad2_rho, &
         &                                 weight_TF, weight_vWeiz, ekin_dens )
      real(kind=DP), intent(in) :: weight_TF,  weight_vWeiz
      real(kind=DP), intent(in) :: rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad2_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(out) :: ekin_dens( ista_rho:iend_rho, nspin )

      integer :: is, i
      real(kind=DP) :: c1, coeff, term1, term2, term3
      real(kind=DP), parameter :: delta1 = 1.0E-12

      coeff = 3.0d0/10.0d0 *(3.0D0*PAI**2)**( 2.0d0/3.0d0 )

      ekin_dens = 0.0d0

      Do is=1, nspin
         Do i=ista_rho, iend_rho
            c1 = rho(i,is)

            if ( c1 > delta1 ) then
               term1 = coeff *c1**(5.0d0/3.0d0)
               term2 = grad_rho(i,is)**2 /c1 /8.0d0
               ekin_dens(i,is) = weight_TF *term1 + weight_vWeiz *term2
            endif

         End do
      End Do
    end subroutine calc_TF_vWeiz_ekin_density

    subroutine calc_Abramov_ekin_density( rho, grad_rho, grad2_rho, ekin_dens )
      real(kind=DP), intent(in) :: rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad2_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(out) :: ekin_dens( ista_rho:iend_rho, nspin )

      integer :: is, i
      real(kind=DP) :: c1, c2, coeff, term1, term2, term3
      real(kind=DP), parameter :: delta1 = 1.0E-15

      coeff = 3.0d0/10.0d0 *(3.0D0*PAI**2)**( 2.0d0/3.0d0 )

      ekin_dens = 0.0d0

      Do is=1, nspin
         Do i=ista_rho, iend_rho
            c1 = rho(i,is) *nspin
            term1 = coeff *c1**(5.0d0/3.0d0) /nspin

            if ( c1 > delta1 ) then
               c2 = grad_rho(i,is) *nspin
               term2 = c2**2 /c1 /8.0 /nspin

               term2 = term2 /9.0d0
            else
               term2 = 0.0d0
            endif

            term3 = grad2_rho(i,is) /6.0d0
            term3 = term3 *1.05

            ekin_dens(i,is) = term1 + term2 + term3
         End do
      End Do
    end subroutine calc_Abramov_ekin_density

  end subroutine m_KE_set_modeled_ekin_density

! =================================== modified by K. Tagami ============ 11.0
!!  subroutine add_hardpart_to_ekinq_l(nfout,kspin,hsr)
  subroutine add_hardpart_to_ekinq_l( nfout, kspin, hsr, singlemode, &
       &                              do_symmetrization, &
       &                              kin_qitg_l, ekinq_l )
! ===================================================================== 11.0
    !  The total operation number has been reduced not only for the gamma-point
    ! but also for other k-points by T. Yamasaki in April 2006.
    !  ----
    ! (Rev) T. Yamaskai, 31, Aug, 2007
    !     1. 'call set_index_arrays1' that included a bug is replaced
    !       by 'call m_PP_set_index_arrays1', whose bug is fixed.
    !     2. 'call set_index_arrays2' is also replaced by 'call
    !       m_PP_set_index_arrays2' that can be referred from other modules.
    !     3. contained subroutines, set_index_arrays1 and set_index_arrays2 were
    !       deleted.

    integer, intent(in) :: nfout, kspin, singlemode
    logical, intent(in) :: do_symmetrization
    
! ================================ modified by K. Tagami ================= 11.0
!    real(kind=DP), intent(in), dimension(natm,nlmt,nlmt,nspin):: hsr
    real(kind=DP), intent(in), dimension(natm,nlmt,nlmt,ndim_magmom):: hsr
! ======================================================================== 11.0

    real(kind=DP), intent(in) :: kin_qitg_l( ista_kngp:iend_kngp,nqitg )
    real(kind=DP), intent(out) :: ekinq_l(ista_kngp:iend_kngp,kimg,ndim_magmom)

    real(kind=DP), pointer, dimension(:)               :: ylm
    real(kind=DP), allocatable, target, dimension(:)   :: ylm_t
    real(kind=DP), allocatable, target, dimension(:,:) :: ylm_ext

    integer :: is,it,lmt1,lmt2,n,ia,mdvdb,il1,tau1,il2,tau2,ilm3,l3,iiqitg
    real(kind=DP) :: fac !, tpos(3)

    integer :: kngp_adj, n_ialist, n_ialist0, ia_start, ia_end, n_iagroup, n_ia, ia_g

    integer, allocatable, dimension(:)                :: il3

    real(kind=DP), allocatable, dimension(:,:) :: zfcos_x, zfsin_x
    real(kind=DP), allocatable, target, dimension(:) :: zfcos, zfsin
    real(kind=DP), allocatable, dimension(:) :: work(:,:)

    integer, allocatable, dimension(:) :: ia_list
#ifdef _VECTOR_TUNING_
    real(kind=DP), allocatable, dimension(:,:,:) :: shdg_x ! d(n_ialist0,maxm,nqitg)
#else
    real(kind=DP), allocatable, dimension(:,:) :: ylm_red, qitg_red
    real(kind=DP), allocatable, dimension(:) :: ylm_sum
    real(kind=DP), allocatable, dimension(:,:,:) :: ekinq_red
    real(kind=DP), allocatable, dimension(:,:) :: shdg  ! d(max,nqitg,nspin)
    integer ::          iqm, iqmmax
    real(kind=DP) :: zdga
#endif

    integer :: m, maxm, ip, np, iq, sw_spin
    integer, parameter :: mcritical = 4*2+1
    integer, allocatable, dimension(:) :: nqitg_sp, nqitg_sp0 !d(ntyp)
    integer, allocatable, dimension(:) :: iq2l3 ! d(nqitg)
    integer, allocatable, dimension(:,:) :: nc  ! d(maxm,nqitg)
    integer :: mc ! maxval(nc)
    integer, allocatable, dimension(:,:,:) :: nc2lmt1, nc2lmt2, nc2n ! d(mc,maxm,nqitg)
! NEC tune
    integer :: ibl1,ibl2,ibsize,ncache,iwidth

! =============================== added by K. Tagami ================ 11.0
    integer :: nspin_kt, ispi_start
! =================================================================== 11.0

! =============================== added by K. Tagami =============== 11.0
    if ( singlemode == YES ) then
       ispi_start = kspin
    else
       ispi_start = 1
    endif
! ================================================================== 11.0

!!!!    if(modnrm == EXECUT) then
       call m_PP_find_maximum_l(n)   !  n-1: maximum l
       n = (n-1) + (n-1) + 1
! =============================== Modified by K. Tagami =========
!       allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)
       allocate(il3(n**2)); il3=0; call substitute_il3(n**2,il3) ! -(b_Elec..)
! ==============================================================

       allocate(nqitg_sp(ntyp)); allocate(nqitg_sp0(ntyp))
       allocate(iq2l3(nqitg))
       allocate(nc(mcritical,nqitg));nc=0
! =================================== Added by K. Tagami =======
	nqitg_sp = 0; nqitg_sp0 = 0; iq2l3 = 0
! ==============================================================
       call m_PP_set_index_arrays1(nfout,ntyp,nqitg,mcritical,n**2,il3 &
            & ,maxm,mc,nqitg_sp,nqitg_sp0,iq2l3,nc)
       allocate(nc2lmt1(mc,maxm,nqitg))
       allocate(nc2lmt2(mc,maxm,nqitg))
       allocate(nc2n(mc,maxm,nqitg))
! ==================================== Added by K. Tagami ======
       nc2lmt1 = 0;  nc2lmt2 = 0; nc2n = 0
! =============================================================
       call m_PP_set_index_arrays2(nfout,mc,maxm,nqitg,mcritical,n**2,il3,iq2l3 &
            & ,nc2lmt1,nc2lmt2,nc2n,nc) ! -> nc2lmt1, nc2lmt2, nc2n, nc

#ifdef _VECTOR_TUNING_

       n_ialist = 1
#ifdef HIUX
       n_ialist = 4
#endif
#ifdef VPP
       n_ialist = 8
#endif
#ifdef SX
       n_ialist = 8
#endif
       kngp_adj = iend_kngp - ista_kngp + 1
       if(mod(kngp_adj,2) == 0) kngp_adj = kngp_adj + 1
       allocate(zfcos_x(kngp_adj,n_ialist)); zfcos_x = 0.d0
       allocate(zfsin_x(kngp_adj,n_ialist)); zfsin_x = 0.d0
       allocate(ia_list(n_ialist)); ia_list = 0
! NEC tune
!       allocate(shdg_x(n_ialist))
       allocate(shdg_x(n_ialist,maxm,nqitg))
! ================================================ by K. Tagami =======
        shdg_x = 0.0d0
! ===================================================================

       if(n**2 > nel_Ylm) then
          allocate(ylm_ext(ista_kngp:iend_kngp,nel_Ylm+1:n**2)); ylm_ext = 0.d0
       end if
       allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
       do ilm3 = nel_Ylm+1, n**2
          call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)
          ylm_ext(:,ilm3) = ylm_t(:)
       end do

!!$       do is = 1, kspin, af+1
          do it = 1, ntyp
             mdvdb = m_PP_include_vanderbilt_pot(it)
!!!!!             if(mdvdb == SKIP) cycle

             n_ia = 0
             do ia = 1, natm
                if(ityp(ia) == it) n_ia = n_ia + 1
             end do

             if(n_ialist <=0) call phase_error_with_msg(nfout,'n_ialist is illegal <<m_Charge_Density.add_hardpart_to_ekinq_l>>'&
                                                       ,__LINE__,__FILE__)
             n_iagroup = n_ia/n_ialist + 1
             ia_start = 1

             do ia_g = 1, n_iagroup
                n_ialist0 = 0
                ia_list = 0
                AtomcountLoop: do ia = ia_start, natm
                   if(ityp(ia) == it) then
                      n_ialist0 = n_ialist0 + 1
                      ia_list(n_ialist0) = ia
                   end if
                   if(n_ialist0 >= n_ialist) exit AtomcountLoop
                end do AtomcountLoop
                ia_start = ia+1
                if(n_ialist0 >= 1 )then


! NEC tune ------------------------------------------------------------------->
!!$      ncache = (cachesize(3)*1024)*3/4
      ncache = (m_CtrlP_cachesize()*1024)*3/4
      if(ncache == 0) then
         ibsize = iend_kngp - ista_kngp + 1
      else

      iwidth = nqitg_sp(it) - nqitg_sp0(it)
      if(n_ialist0 == 1) then
         if(kimg == 1) then ! kin_qitg_l(i,iq)*ylm(iy)*zfsc1_1(iy)
           ibsize=ncache/(8*(2+iwidth))
         else ! kin_qitg_l(i,iq),ylm(iy),zfsc1_1(iy),zfsc2_1(iy)
           ibsize=ncache/(8*(3+iwidth))
         endif
      else if(n_ialist0 == 2) then
         if(kimg == 1) then ! kin_qitg_l(i,iq),ylm(iy),zfsc1_1(iy),zfsc1_2(iy)
           ibsize=ncache/(8*(3+iwidth))
         else ! kin_qitg_l(i,iq)
              ! ylm(iy),zfsc1_1(iy),zfsc1_2(iy),zfsc2_1(iy),zfsc2_2(iy)
           ibsize=ncache/(8*(5+iwidth))
         endif
      else if(n_ialist0 == 3) then
         if(kimg == 1) then ! kin_qitg_l(i,iq)
                            ! ylm(iy),zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy)
           ibsize=ncache/(8*(4+iwidth))
         else ! kin_qitg_l(i,iq),ylm(iy),zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy)
              !                      zfsc2_1(iy),zfsc2_2(iy),zfsc2_3(iy)
           ibsize=ncache/(8*(7+iwidth))
         endif
      else if(n_ialist0 == 4) then
         if(kimg == 1) then ! kin_qitg_l(i,iq)
                   ! ylm(iy),zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
           ibsize=ncache/(8*(5+iwidth))
         else ! kin_qitg_l(i,iq),ylm(iy)
              ! zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
              ! zfsc2_1(iy),zfsc2_2(iy),zfsc2_3(iy),zfsc2_4(iy)
           ibsize=ncache/(8*(9+iwidth))
         endif
      else if(n_ialist0 == 5) then
         if(kimg == 1) then ! kin_qitg_l(i,iq),ylm(iy)
               ! zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy),zfsc1_5(iy))
           ibsize=ncache/(8*(6+iwidth))
         else ! kin_qitg_l(i,iq),ylm(iy)
              ! zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy),zfsc1_5(iy)
              ! zfsc2_1(iy),zfsc2_2(iy),zfsc2_3(iy),zfsc2_4(iy),zfsc2_5(iy)
           ibsize=ncache/(8*(11+iwidth))
         endif
      else if(n_ialist0 == 6) then
         if(kimg == 1) then ! kin_qitg_l(i,iq),ylm(iy)
                 ! zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
                 ! zfsc1_5(iy),zfsc1_6(iy)
           ibsize=ncache/(8*(7+iwidth))
         else ! kin_qitg_l(i,iq),ylm(iy)
              ! zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
              ! zfsc1_5(iy),zfsc1_6(iy))
              ! zfsc2_1(iy),zfsc2_2(iy),zfsc2_3(iy),zfsc2_4(iy)
              ! zfsc2_5(iy),zfsc2_6(iy))
           ibsize=ncache/(8*(13+iwidth))
         endif
      else if(n_ialist0 == 7) then
         if(kimg == 1) then
             !  kin_qitg_l(i,iq),ylm(iy)
             !  zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
             !  zfsc1_5(iy),zfsc1_6(iy),zfsc1_7(iy)
           ibsize=ncache/(8*(8+iwidth))
         else
             !  kin_qitg_l(i,iq),ylm(iy)
             !  zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
             !  zfsc1_5(iy),zfsc1_6(iy),zfsc1_7(iy)
             !  zfsc2_1(iy),zfsc2_2(iy),zfsc2_3(iy),zfsc2_4(iy)
             !  zfsc2_5(iy),zfsc2_6(iy),zfsc2_7(iy)
           ibsize=ncache/(8*(15+iwidth))
         endif
      else if(n_ialist0 >= 8) then
         if(kimg == 1) then
             !  kin_qitg_l(i,iq),ylm(iy)
             !  zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
             !  zfsc1_5(iy),zfsc1_6(iy),zfsc1_7(iy),zfsc1_8(iy)
           ibsize=ncache/(8*(9+iwidth))
         else
            !   kin_qitg_l(i,iq),ylm(iy)
            !   zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
            !   zfsc1_5(iy),zfsc1_6(iy),zfsc1_7(iy),zfsc1_8(iy)
            !   zfsc2_1(iy),zfsc2_2(iy),zfsc2_3(iy),zfsc2_4(iy)
            !   zfsc2_5(iy),zfsc2_6(iy),zfsc2_7(iy),zfsc2_8(iy)
           ibsize=ncache/(8*(17+iwidth))
         endif
      end if
      endif
! debug
!write(6,990) 'n_ialist0,kimg,ibsize,ista_kngp,iend_kngp,iwidth=',&
!n_ialist0,kimg,ibsize,ista_kngp,iend_kngp,iwidth
!990 format(a,i2,i2,4i8)
      call calc_phase_b(natm,pos,ia_list,n_ialist0,kgp,ngabc,ista_kngp,iend_kngp,1,kngp_adj,zfcos_x,zfsin_x)
      do ibl1=ista_kngp,iend_kngp,ibsize
        ibl2=ibl1+ibsize-1
        if(ibl2.gt.iend_kngp) ibl2=iend_kngp
! NEC tune <-------------------------------------------------------------------

!!$          do ia = 1, natm
!!$             it = ityp(ia)
!!$             mdvdb = m_PP_include_vanderbilt_pot(it)
!!$             if(mdvdb == SKIP) cycle
! NEC tune (move 1 line to up)
!                   call calc_phase_b(natm,pos,ia_list,n_ialist0,kgp,ngabc,ista_kngp,iend_kngp,1,kngp_adj,zfcos_x,zfsin_x)
!!$             call calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos,zfsin)
                   ! -(b_Elec.)  -> zfcos, zfsin

! =========================== modified by K. Tagami ============= 11.0
!                do is = 1, kspin, af+1
                do is = ispi_start, kspin, af+1
! =============================================================== 11.0

! NEC tune --------------------------------------------------->
                   do iq = nqitg_sp0(it), nqitg_sp(it)
                      l3 = iq2l3(iq)
                      do m = 1, 2*l3+1
                         call sum_hsr_dot_gauntc(is,it,iq,m) ! hsr, dl2p -> shdg_x(n_ialist0)
                      end do
                   end do
! NEC tune <---------------------------------------------------

                   do iq = nqitg_sp0(it), nqitg_sp(it)
                      l3 = iq2l3(iq)
                      do m = 1, 2*l3+1
                         ilm3 = l3*l3+m
! NEC tune
!                         call sum_hsr_dot_gauntc(is,it,iq,m) ! hsr, dl2p -> shdg_x(n_ialist0)
                         if(ilm3 <= nel_Ylm) then
                            ylm => ylm_l(ista_kngp:iend_kngp,ilm3)
                         else
                            ylm => ylm_ext(ista_kngp:iend_kngp,ilm3)
                         end if
                         call add_hardpart_to_ekinq_l_core4(iq) ! iq, shdg_x, exp(-iGR), kin_qitg_l, ylm -> ekinq_l
                         !    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                      end do
                   end do
! NEC tune
                end do
             end do ! ibl1
                end if
             end do! ia_g
          end do! it 
!!$       end do! is
       deallocate(ylm_t)
       if(allocated(ylm_ext)) deallocate(ylm_ext)
       deallocate(shdg_x)
       deallocate(ia_list,zfsin_x,zfcos_x,il3)
#else

       ncache = (m_CtrlP_cachesize()*1024)*3/4
       if(ncache == 0) then
          ibsize = iend_kngp - ista_kngp + 1
       else
          iwidth = 0.d0
          do it = 1, ntyp
             iwidth = max(iwidth,nqitg_sp(it)-nqitg_sp0(it)+1)
          end do
          if(kimg == 1) then ! kin_qitg_l(i,iq)*ylm(iy)*zfsc1_1(iy)
             ibsize=ncache/(8*(iwidth + 1))
          else ! kin_qitg_l(i,iq),ylm(iy),zfsc1_1(iy),zfsc2_1(iy)
             ibsize=ncache/(8*(iwidth + 2))
          endif
       end if

       allocate(zfcos(ibsize)); zfcos = 0.d0
       allocate(zfsin(ibsize)); zfsin = 0.d0
       allocate(qitg_red(ibsize,nqitg))
       allocate(ylm_red(ibsize,n**2))
       allocate(ylm_sum(ibsize))

! =========================== modified by K. Tagami =================== 11.0
!       if(kspin == 2 .and. af == 0) then
!          sw_spin = ON
!       else
!          sw_spin = OFF
!       end if
! ===================================================================== 11.0

! ============================== added by K. Tagami ================== 11.0
       if ( noncol ) then
          nspin_kt = kspin
       else
          nspin_kt = nspin /(af+1)
       endif
! ================================================================ 11.0

       iqmmax = 0
       do it = 1, ntyp
          iqm = 0
          do iq = nqitg_sp0(it), nqitg_sp(it)
             l3 = iq2l3(iq)
             do m = 1, 2*l3+1
                iqm = iqm+1
             end do
          end do
          if(iqmmax < iqm) iqmmax = iqm
       end do

! ===================== modified by K. Tagami ============== 11.0
!       if(sw_spin == ON) then
!          allocate(ekinq_red(ibsize,kimg,2))
!          allocate(shdg(iqmmax,2))
!       else if(sw_spin == OFF) then
!          allocate(ekinq_red(ibsize,kimg,1))
!          allocate(shdg(iqmmax,1))
!       end if
! ========================================================== 11.0
! ========================= added by K. Tagami =========== 11.0
       allocate( ekinq_red( ibsize, kimg, nspin_kt ))
       allocate( shdg( iqmmax,nspin_kt ))
! ========================================================= 11.0

       do ibl1=ista_kngp,iend_kngp,ibsize
          ibl2=ibl1+ibsize-1
          if(ibl2.gt.iend_kngp) ibl2=iend_kngp
          if(ibl2.gt.kgp) ibl2 = kgp

          ekinq_red = 0.d0
          call substitute_qitgred()  ! kin_qitg_l -> qitg_red
          call substitute_ylmred() ! ylm_l, ylm_ext -> ylm_red
          do ia = 1, natm
             it = ityp(ia)
             mdvdb = m_PP_include_vanderbilt_pot(it)
!!!!             if(mdvdb == SKIP) cycle

             call calc_phase_div(ia) ! -> zfsin, zfcos

!!$             iqm = 0
!!$             do iq = nqitg_sp0(it), nqitg_sp(it)
!!$                l3 = iq2l3(iq)
!!$                do m = 1, 2*l3+1
!!$                   iqm = iqm+1
!!$                   call sum_hsr_dot_gauntc0(it,ia,iq,m,iqm) ! hsr, dl2p -> shdg
!!$                end do
!!$             end do
!!$             iqmmax = iqm

! ================================= modified by K. Tagami ========== 11.0
!             do is = 1, kspin, af+1
             do is = ispi_start, kspin, af+1
! ================================================================== 11.0

                iqm = 0
                do iq = nqitg_sp0(it), nqitg_sp(it)
                   l3 = iq2l3(iq)
                   ylm_sum = 0.d0
                   do m = 1, 2*l3+1
                      ilm3 = l3*l3+m
                      iqm = iqm+1
                      call sum_hsr_dot_gauntc0(it,ia,iq,m,iqm) ! hsr, dl2p -> shdg
                      ylm_sum(:) = ylm_sum(:) + shdg(iqm,is)*ylm_red(:,ilm3)
                   end do
                   if(mod(l3,2) == 0) then
                      zdga = real(zi**(-l3))
                      call add_hardpart_to_ekinq_l_div0(zdga,iq) ! iq, shdg_x, exp(-iGR), kin_qitg_l, ylm -> ekinq_l
                   else
                      zdga = aimag(zi**(-l3))
                      call add_hardpart_to_ekinq_l_div1(zdga,iq) ! iq, shdg_x, exp(-iGR), kin_qitg_l, ylm -> ekinq_l
                   end if
!!$                   call add_hardpart_to_ekinq_l_div(iq) ! iq, shdg_x, exp(-iGR), kin_qitg_l, ylm -> ekinq_l
                   !    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                end do
             end do
          end do
          call cp_ekinqred2ekinq()
       end do
       deallocate(ylm_sum,ylm_red,qitg_red,shdg)
       deallocate(ekinq_red)
       deallocate(zfsin,zfcos)
#endif

       deallocate(nc2n,nc2lmt2,nc2lmt1,nc,iq2l3,nqitg_sp,nqitg_sp0)
!!!    endif

    if(nbztyp >= SIMPLE_CUBIC .or. af /=0 ) then
       allocate(work(kgp,kimg))
! =========================================== Added by K. Tagami ====
        work = 0.0d0
! ===================================================================

! ==================================== modified by K. Tagami ============== 11.0
      if(nbztyp >= SIMPLE_CUBIC .and. do_symmetrization ) then
         if ( noncol ) then
!!!            call symmetrize_ekin_noncl( NO,ekinq_l )
         else
            call symmetrize_ekin( NO,ekinq_l )
         endif
      endif
! ========================================================================== 11.0
      
       deallocate(work)
    end if

  contains

#ifdef _VECTOR_TUNING_
    subroutine sum_hsr_dot_gauntc(is,it,iq,m)
      integer, intent(in) :: is,it,iq,m
      integer :: ip, lmt1, lmt2, np
      real(kind=DP) :: fac
! NEC tune
!      shdg_x(1:n_ialist0) = 0.d0
      shdg_x(1:n_ialist0,m,iq) = 0.d0
      do ip = 1, nc(m,iq)
         lmt1 = nc2lmt1(ip,m,iq)
         lmt2 = nc2lmt2(ip,m,iq)
         np = nc2n(ip,m,iq)
         fac = 2.d0; if(lmt1 == lmt2) fac = 1.d0
         do ia = 1, n_ialist0
! NEC tune
!            shdg_x(ia) = shdg_x(ia) + &
            shdg_x(ia,m,iq) = shdg_x(ia,m,iq) + &
                 & fac*iwei(ia_list(ia))*hsr(ia_list(ia),lmt1,lmt2,is)*dl2p(lmt1,lmt2,np,it)
         end do
      end do
    end subroutine sum_hsr_dot_gauntc
    subroutine add_hardpart_to_ekinq_l_core4(iq)
      integer, intent(in) :: iq
      integer       :: i,iy, ia
!!$      real(kind=DP) :: dga, flekinq, f,f2
      real(kind=DP) :: flekinq, f,f2, flekinq_1, flekinq_2, flekinq_3, flekinq_4 &
           &                            , flekinq_5, flekinq_6, flekinq_7, flekinq_8, zdga
      real(kind=DP) :: qf1,qf2, qy
!!$      real(kind=DP), pointer, dimension(:) :: zfsc1,zfsc2
      real(kind=DP), pointer, dimension(:) :: zfsc1_1,zfsc2_1, zfsc1_2, zfsc2_2 &
           &         , zfsc1_3,zfsc2_3,zfsc1_4,zfsc2_4, zfsc1_5,zfsc2_5,zfsc1_6,zfsc2_6 &
           &         , zfsc1_7,zfsc2_7,zfsc1_8,zfsc2_8
!!$      real(kind=DP), allocatable, dimension(:) :: w_f ! d(ista_kngp:iend_kngp)
!!$      if(n_ialist == 1) allocate(w_f(ista_kngp:iend_kngp))
      if(mod(l3,2) == 0) then
         if(n_ialist0 >= 1) zdga = real(zi**(-l3))
         if(kimg == 1) then
!!$            zfsc1 => zfcos
            if(n_ialist0 >= 1) zfsc1_1 => zfcos_x(:,1)
            if(n_ialist0 >= 2) zfsc1_2 => zfcos_x(:,2)
            if(n_ialist0 >= 3) zfsc1_3 => zfcos_x(:,3)
            if(n_ialist0 >= 4) zfsc1_4 => zfcos_x(:,4)
            if(n_ialist0 >= 5) zfsc1_5 => zfcos_x(:,5)
            if(n_ialist0 >= 6) zfsc1_6 => zfcos_x(:,6)
            if(n_ialist0 >= 7) zfsc1_7 => zfcos_x(:,7)
            if(n_ialist0 >= 8) zfsc1_8 => zfcos_x(:,8)
         else
!!$            f2 = -1; zfsc1 => zfcos; zfsc2 => zfsin
            f2 = -1
            if(n_ialist0 >= 1) then
               zfsc1_1 => zfcos_x(:,1); zfsc2_1 => zfsin_x(:,1)
            end if
            if(n_ialist0 >= 2) then
               zfsc1_2 => zfcos_x(:,2); zfsc2_2 => zfsin_x(:,2)
            end if
            if(n_ialist0 >= 3) then
               zfsc1_3 => zfcos_x(:,3); zfsc2_3 => zfsin_x(:,3)
            end if
            if(n_ialist0 >= 4) then
               zfsc1_4 => zfcos_x(:,4); zfsc2_4 => zfsin_x(:,4)
            end if
            if(n_ialist0 >= 5) then
               zfsc1_5 => zfcos_x(:,5); zfsc2_5 => zfsin_x(:,5)
            end if
            if(n_ialist0 >= 6) then
               zfsc1_6 => zfcos_x(:,6); zfsc2_6 => zfsin_x(:,6)
            end if
            if(n_ialist0 >= 7) then
               zfsc1_7 => zfcos_x(:,7); zfsc2_7 => zfsin_x(:,7)
            end if
            if(n_ialist0 >= 8) then
               zfsc1_8 => zfcos_x(:,8); zfsc2_8 => zfsin_x(:,8)
            end if
         end if
      else
!!$         flekinq = fac*aimag(zi**(-l3))*dga*hsr(ia,lmt1,lmt2,is)
         if(n_ialist0 >= 1) zdga = aimag(zi**(-l3))
         if(kimg == 1) then
!!$            zfsc1 => zfsin
            if(n_ialist0 >= 1) zfsc1_1 => zfsin_x(:,1)
            if(n_ialist0 >= 2) zfsc1_2 => zfsin_x(:,2)
            if(n_ialist0 >= 3) zfsc1_3 => zfsin_x(:,3)
            if(n_ialist0 >= 4) zfsc1_4 => zfsin_x(:,4)
            if(n_ialist0 >= 5) zfsc1_5 => zfsin_x(:,5)
            if(n_ialist0 >= 6) zfsc1_6 => zfsin_x(:,6)
            if(n_ialist0 >= 7) zfsc1_7 => zfsin_x(:,7)
            if(n_ialist0 >= 8) zfsc1_8 => zfsin_x(:,8)
         else
!!$            f2 = 1; zfsc1 => zfsin; zfsc2 => zfcos
            f2 = 1
            if(n_ialist0 >= 1) then
               zfsc1_1 => zfsin_x(:,1); zfsc2_1 => zfcos_x(:,1)
            end if
            if(n_ialist0 >= 2) then
               zfsc1_2 => zfsin_x(:,2); zfsc2_2 => zfcos_x(:,2)
            end if
            if(n_ialist0 >= 3) then
               zfsc1_3 => zfsin_x(:,3); zfsc2_3 => zfcos_x(:,3)
            end if
            if(n_ialist0 >= 4) then
               zfsc1_4 => zfsin_x(:,4); zfsc2_4 => zfcos_x(:,4)
            end if
            if(n_ialist0 >= 5) then
               zfsc1_5 => zfsin_x(:,5); zfsc2_5 => zfcos_x(:,5)
            end if
            if(n_ialist0 >= 6) then
               zfsc1_6 => zfsin_x(:,6); zfsc2_6 => zfcos_x(:,6)
            end if
            if(n_ialist0 >= 7) then
               zfsc1_7 => zfsin_x(:,7); zfsc2_7 => zfcos_x(:,7)
            end if
            if(n_ialist0 >= 8) then
               zfsc1_8 => zfsin_x(:,8); zfsc2_8 => zfcos_x(:,8)
            end if
         end if
      end if
! NEC tune ---------------------------------------->
!      if(n_ialist0 >= 1) flekinq_1 = zdga*shdg_x(1)
!      if(n_ialist0 >= 2) flekinq_2 = zdga*shdg_x(2)
!      if(n_ialist0 >= 3) flekinq_3 = zdga*shdg_x(3)
!      if(n_ialist0 >= 4) flekinq_4 = zdga*shdg_x(4)
!      if(n_ialist0 >= 5) flekinq_5 = zdga*shdg_x(5)
!      if(n_ialist0 >= 6) flekinq_6 = zdga*shdg_x(6)
!      if(n_ialist0 >= 7) flekinq_7 = zdga*shdg_x(7)
!      if(n_ialist0 >= 8) flekinq_8 = zdga*shdg_x(8)
! NEC tune -----------------------------------------
      if(n_ialist0 >= 1) flekinq_1 = zdga*shdg_x(1,m,iq)
      if(n_ialist0 >= 2) flekinq_2 = zdga*shdg_x(2,m,iq)
      if(n_ialist0 >= 3) flekinq_3 = zdga*shdg_x(3,m,iq)
      if(n_ialist0 >= 4) flekinq_4 = zdga*shdg_x(4,m,iq)
      if(n_ialist0 >= 5) flekinq_5 = zdga*shdg_x(5,m,iq)
      if(n_ialist0 >= 6) flekinq_6 = zdga*shdg_x(6,m,iq)
      if(n_ialist0 >= 7) flekinq_7 = zdga*shdg_x(7,m,iq)
      if(n_ialist0 >= 8) flekinq_8 = zdga*shdg_x(8,m,iq)
! NEC tune <----------------------------------------

      if(n_ialist0 == 1) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) &
                    & +flekinq_1*kin_qitg_l(i,iq)*ylm(iy)*zfsc1_1(iy)
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               f = flekinq_1*kin_qitg_l(i,iq)*ylm(iy)
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + f * zfsc1_1(iy)
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * f * zfsc2_1(iy)
            end do
         end if
      else if(n_ialist0 == 2) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &         *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) )
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &         *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) )
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &         *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) )
            end do
         end if
      else if(n_ialist0 == 3) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &     *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) )
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &     *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy))
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &     *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) + flekinq_3*zfsc2_3(iy))
            end do
         end if
      else if(n_ialist0 == 4) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *(flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy)+ flekinq_4*zfsc1_4(iy))
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy))
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) + flekinq_3*zfsc2_3(iy) + flekinq_4*zfsc2_4(iy))
            end do
         end if
      else if(n_ialist0 == 5) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *(flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy)+ flekinq_4*zfsc1_4(iy) &
                    &    +flekinq_5*zfsc1_5(iy))
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy)&
                    &     +flekinq_5*zfsc1_5(iy))
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) + flekinq_3*zfsc2_3(iy) + flekinq_4*zfsc2_4(iy)&
                    &     +flekinq_5*zfsc2_5(iy))
            end do
         end if
      else if(n_ialist0 == 6) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *(flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy)+ flekinq_4*zfsc1_4(iy) &
                    &    +flekinq_5*zfsc1_5(iy) + flekinq_6*zfsc1_6(iy))
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy)&
                    &     +flekinq_5*zfsc1_5(iy) + flekinq_6*zfsc1_6(iy))
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) + flekinq_3*zfsc2_3(iy) + flekinq_4*zfsc2_4(iy)&
                    &     +flekinq_5*zfsc2_5(iy) + flekinq_6*zfsc2_6(iy))
            end do
         end if
      else if(n_ialist0 == 7) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *(flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy) &
                    &    +flekinq_5*zfsc1_5(iy) + flekinq_6*zfsc1_6(iy) + flekinq_7*zfsc1_7(iy))
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy)&
                    &     +flekinq_5*zfsc1_5(iy) + flekinq_6*zfsc1_6(iy) + flekinq_7*zfsc1_7(iy))
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) + flekinq_3*zfsc2_3(iy) + flekinq_4*zfsc2_4(iy)&
                    &     +flekinq_5*zfsc2_5(iy) + flekinq_6*zfsc2_6(iy) + flekinq_7*zfsc2_7(iy))
            end do
         end if
      else if(n_ialist0 >= 8) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *(flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy) &
                    &    +flekinq_5*zfsc1_5(iy) + flekinq_6*zfsc1_6(iy) + flekinq_7*zfsc1_7(iy) + flekinq_8*zfsc1_8(iy))
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy)&
                    &     +flekinq_5*zfsc1_5(iy) + flekinq_6*zfsc1_6(iy) + flekinq_7*zfsc1_7(iy) + flekinq_8*zfsc1_8(iy))
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) + flekinq_3*zfsc2_3(iy) + flekinq_4*zfsc2_4(iy)&
                    &     +flekinq_5*zfsc2_5(iy) + flekinq_6*zfsc2_6(iy) + flekinq_7*zfsc2_7(iy) + flekinq_8*zfsc2_8(iy))
            end do
         end if
      end if
!!$      if(n_ialist == 1) deallocate(w_f)
    end subroutine add_hardpart_to_ekinq_l_core4
#else
    subroutine substitute_qitgred()
      integer :: iq, i
      do iq = 1, nqitg
         do i = 1, ibl2-ibl1+1
            qitg_red(i, iq) = kin_qitg_l(i+ibl1-1,iq)
         end do
      end do
    end subroutine substitute_qitgred

    subroutine substitute_ylmred
      integer :: ilm, i

      do ilm = 1, nel_Ylm
         do i = 1, ibl2-ibl1+1
            ylm_red(i,ilm) = ylm_l(i+ibl1-1,ilm)
         end do
      end do

      if(n**2 > nel_Ylm) then
         allocate(ylm_t(ibl1:ibl2)); ylm_t = 0.d0
         do ilm = nel_ylm+1, n**2
            call m_pwBS_sphrp2(ilm,rltv,ibl1,ibl2,ylm_t)
            do i = 1, ibl2-ibl1+1
               ylm_red(i,ilm) = ylm_t(i+ibl1-1)
            end do
         end do
         deallocate(ylm_t)
      end if
    end subroutine substitute_ylmred

    subroutine sum_hsr_dot_gauntc0(it,ia,iq,m,iqm)
      integer, intent(in) :: it,ia,iq,m,iqm
      integer :: ip, lmt1, lmt2, np
      real(kind=DP) :: fac

! ========================= modified by K. Tagami ====================== 11.0
!      if(sw_spin == OFF) then
!         shdg(iqm,1) = 0.d0
!         do ip = 1, nc(m,iq)
!            lmt1 = nc2lmt1(ip,m,iq)
!            lmt2 = nc2lmt2(ip,m,iq)
!            np = nc2n(ip,m,iq)
!            fac = 2.d0; if(lmt1 == lmt2) fac = 1.d0
!            shdg(iqm,1) = shdg(iqm,1) + fac*iwei(ia)*hsr(ia,lmt1,lmt2,1)*dl2p(lmt1,lmt2,np,it)
!         end do
!      else if(sw_spin == ON) then
!         shdg(iqm,1) = 0.d0; shdg(iqm,2) = 0.d0
!         do ip = 1, nc(m,iq)
!            lmt1 = nc2lmt1(ip,m,iq)
!            lmt2 = nc2lmt2(ip,m,iq)
!            np = nc2n(ip,m,iq)
!            fac = 2.d0; if(lmt1 == lmt2) fac = 1.d0
!            shdg(iqm,1) = shdg(iqm,1) + fac*iwei(ia)*hsr(ia,lmt1,lmt2,1) &
!                           &           *dl2p(lmt1,lmt2,np,it)
!            shdg(iqm,2) = shdg(iqm,2) + fac*iwei(ia)*hsr(ia,lmt1,lmt2,2) &
!                           &          *dl2p(lmt1,lmt2,np,it)
!         end do
!      end if

      shdg(iqm,:) = 0.d0

      do ip = 1, nc(m,iq)
         lmt1 = nc2lmt1(ip,m,iq);    lmt2 = nc2lmt2(ip,m,iq)
         np = nc2n(ip,m,iq)
         fac = 2.d0; if(lmt1 == lmt2) fac = 1.d0
         shdg(iqm,:) = shdg(iqm,:) &
              &  + fac *iwei(ia) *hsr(ia,lmt1,lmt2,:) *dl2p(lmt1,lmt2,np,it)
      end do
! ============================================================== 11.0

    end subroutine sum_hsr_dot_gauntc0

    subroutine calc_phase_div(ia)
      integer, intent(in) :: ia
      real(kind=DP) :: fx, fy, fz, ph
      integer :: i, iy
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do i = 1, ibl2-ibl1+1
         iy = i + ibl1 - 1
         ph = ngabc(iy,1)*fx+ngabc(iy,2)*fy+ngabc(iy,3)*fz
         zfcos(i) = dcos(ph)
         zfsin(i) = dsin(ph)
      end do
    end subroutine calc_phase_div

    subroutine add_hardpart_to_ekinq_l_div(iq)
      integer, intent(in) :: iq
      integer       :: i,iy, iy2
      real(kind=DP) :: flekinq, f,f2,  zdga, flekinq_up, flekinq_dw, f_up, f_dw
      real(kind=DP), pointer, dimension(:) :: zfsc1,zfsc2

      if(mod(l3,2) == 0) then
         zdga = real(zi**(-l3))
         if(kimg == 1) then
            zfsc1 => zfcos
         else
            f2 = -1
            zfsc1 => zfcos; zfsc2 => zfsin
         end if
      else
         zdga = aimag(zi**(-l3))
         if(kimg == 1) then
            zfsc1 => zfsin
         else
            f2 = 1
            zfsc1 => zfsin; zfsc2 => zfcos
         end if
      end if

!!$      if(sw_spin == ON) then
!!$         flekinq_up = zdga*shdg(iqm,1)
!!$         flekinq_dw = zdga*shdg(iqm,2)
!!$      else if(sw_spin == OFF) then
!!$         flekinq = zdga*shdg(iqm,1)
!!$      end if

      if(kimg == 1) then
!!$         if(sw_spin == ON) then
!!$            do i = 1, ibl2-ibl1+1
!!$               f = qitg_red(i,iq)*ylm_sum(i)*zfsc1(i)
!!$               ekinq_red(i,1,1) = ekinq_red(i,1,1) +zdga*f
!!$               ekinq_red(i,1,2) = ekinq_red(i,1,2) +zdga*f
!!$            end do
!!$         else if(sw_spin == OFF) then
         do i = 1, ibl2-ibl1+1
            ekinq_red(i,1,is) = ekinq_red(i,1,is) +zdga*qitg_red(i,iq)*ylm_sum(i)*zfsc1(i)
         end do
!!$         end if
      else
!!$         if(sw_spin == ON) then
!!$            do i = 1, ibl2-ibl1+1
!!$               f = qitg_red(i,iq)*ylm_red(i,ilm3)
!!$               ekinq_red(i,1,1) = ekinq_red(i,1,1) +      flekinq_up*f * zfsc1(i)
!!$               ekinq_red(i,2,1) = ekinq_red(i,2,1) + f2 * flekinq_up*f * zfsc2(i)
!!$               ekinq_red(i,1,2) = ekinq_red(i,1,2) +      flekinq_dw*f * zfsc1(i)
!!$               ekinq_red(i,2,2) = ekinq_red(i,2,2) + f2 * flekinq_dw*f * zfsc2(i)
!!$            end do
!!$         else if(sw_spin == OFF) then
         do i = 1, ibl2-ibl1+1
            f = zdga*qitg_red(i,iq)*ylm_sum(i)
            ekinq_red(i,1,is) = ekinq_red(i,1,is) +      f * zfsc1(i)
            ekinq_red(i,2,is) = ekinq_red(i,2,is) + f2 * f * zfsc2(i)
         end do
!!$         end if
      end if
    end subroutine add_hardpart_to_ekinq_l_div

    subroutine add_hardpart_to_ekinq_l_div0(zdga,iq)
      real(kind=DP), intent(in) :: zdga
      integer, intent(in) :: iq
      integer       :: i
      real(kind=DP) :: f

      if(kimg == 1) then
         do i = 1, ibl2-ibl1+1
            ekinq_red(i,1,is) = ekinq_red(i,1,is) +zdga*qitg_red(i,iq)*ylm_sum(i)*zfcos(i)
         end do
      else
         do i = 1, ibl2-ibl1+1
            f = zdga*qitg_red(i,iq)*ylm_sum(i)
            ekinq_red(i,1,is) = ekinq_red(i,1,is) + f * zfcos(i)
            ekinq_red(i,2,is) = ekinq_red(i,2,is) - f * zfsin(i)
         end do
      end if
    end subroutine add_hardpart_to_ekinq_l_div0

    subroutine add_hardpart_to_ekinq_l_div1(zdga,iq)
      real(kind=DP), intent(in) :: zdga
      integer, intent(in) :: iq
      integer       :: i
      real(kind=DP) :: f

      if(kimg == 1) then
         do i = 1, ibl2-ibl1+1
            ekinq_red(i,1,is) = ekinq_red(i,1,is) +zdga*qitg_red(i,iq)*ylm_sum(i)*zfsin(i)
         end do
      else
         do i = 1, ibl2-ibl1+1
            f = zdga*qitg_red(i,iq)*ylm_sum(i)
            ekinq_red(i,1,is) = ekinq_red(i,1,is) +  f * zfsin(i)
            ekinq_red(i,2,is) = ekinq_red(i,2,is) +  f * zfcos(i)
         end do
      end if
    end subroutine add_hardpart_to_ekinq_l_div1

    subroutine cp_ekinqred2ekinq()
      integer :: i, ir

! =============================== modified by K. Tagami ============= 11.0
!      if(sw_spin == ON) then
!         do ir = 1, kimg
!            do i = ibl1, ibl2
!               ekinq_l(i,ir,1) = ekinq_l(i,ir,1) + ekinq_red(i-ibl1+1,ir,1)
!               ekinq_l(i,ir,2) = ekinq_l(i,ir,2) + ekinq_red(i-ibl1+1,ir,2)
!            end do
!         end do
!      else if(sw_spin == OFF) then
!         do ir = 1, kimg
!            do i = ibl1, ibl2
!               ekinq_l(i,ir,1) = ekinq_l(i,ir,1) + ekinq_red(i-ibl1+1,ir,1)
!            end do
!         end do
!      end if

      do ir = 1, kimg
         do i = ibl1, ibl2
            ekinq_l(i,ir,:) = ekinq_l(i,ir,:) + ekinq_red(i-ibl1+1,ir,:)
         end do
      end do
! ==================================================================== 11.0

    end subroutine cp_ekinqred2ekinq
#endif
  end subroutine add_hardpart_to_ekinq_l

  subroutine m_KE_calc_kins_qrs_rspace
    integer :: imesh
    integer :: ia, it, nma
    integer :: il1, il2, im1, im2, tau1, tau2, lmt1, lmt2
    integer :: nspher1, nspher2
    integer :: ier, ir

    real(kind=DP) :: ps1, ps2, dps1, dps2
    real(kind=DP) :: ph1, ph2, dph1, dph2
    real(kind=DP) :: cosx, cosy, cosz
    real(kind=DP) :: ctmp_psi1(3), ctmp_psi2(3)
    real(kind=DP) :: ctmp_phi1(3), ctmp_phi2(3)
    real(kind=DP) :: csum_psi, csum_phi
    real(kind=DP) :: hn, inl, inm, inn

    real(kind=DP), allocatable :: cx(:), cy(:), cz(:), rdiff(:)
    real(kind=DP), allocatable :: ylm1(:), ylm2(:), dylm1(:,:), dylm2(:,:)
    real(kind=DP), allocatable :: psi1(:), psi2(:), wk_psi1(:), wk_psi2(:)
    real(kind=DP), allocatable :: phi1(:), phi2(:), wk_phi1(:), wk_phi2(:)
    real(kind=DP), allocatable :: radr(:)

    inl = 1.d0/dble(fft_box_size_CD(1,1))
    inm = 1.d0/dble(fft_box_size_CD(2,1))
    inn = 1.d0/dble(fft_box_size_CD(3,1))
    
    allocate(cx(nmesh_rs_aug_max)); cx=0.d0
    allocate(cy(nmesh_rs_aug_max)); cy=0.d0
    allocate(cz(nmesh_rs_aug_max)); cz=0.d0
    allocate(rdiff(nmesh_rs_aug_max)); rdiff=0.d0
    
    allocate(ylm1(nmesh_rs_aug_max)); ylm1 = 0.d0
    allocate(ylm2(nmesh_rs_aug_max)); ylm2 = 0.d0
    allocate(dylm1(nmesh_rs_aug_max,3)); dylm1 = 0.d0
    allocate(dylm2(nmesh_rs_aug_max,3)); dylm2 = 0.d0
    
    allocate( psi1(mmesh) ); psi1 = 0.0d0
    allocate( psi2(mmesh) ); psi2 = 0.0d0
    allocate( phi1(mmesh) ); phi1 = 0.0d0
    allocate( phi2(mmesh) ); phi2 = 0.0d0
    allocate( wk_psi1(mmesh) ); wk_psi1 = 0.0d0
    allocate( wk_psi2(mmesh) ); wk_psi2 = 0.0d0
    allocate( wk_phi1(mmesh) ); wk_phi1 = 0.0d0
    allocate( wk_phi2(mmesh) ); wk_phi2 = 0.0d0
    allocate( radr(mmesh) ); radr = 0.0d0

!    write(*,*) 'nmesh_rs_aug_max = ', nmesh_rs_aug_max
    if ( nmesh_rs_aug_max == 0 ) return

    allocate( kins_qrs_rspace( nmesh_rs_aug_max,natm,nlmt,nlmt) )
    kins_qrs_rspace = 0.0d0

    Do ia=1, natm
       it = ityp(ia)
       nma = nmesh_rs_aug(ia)

       if ( nma == 0 ) cycle

       call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
       call m_RS_R_minus_pos( pos, ia, nmesh_rs_aug_max, inl, inm, inn, &
            &                 cx, cy, cz, rdiff, &
            &                 meshx_rs_aug, meshy_rs_aug, meshz_rs_aug )
       
       Do lmt1 = 1, ilmt(it)
          il1 = ltp(lmt1,it); im1 = mtp(lmt1,it);  tau1 = taup(lmt1,it)
          nspher1 = ( il1 -1 )**2 +im1
          
          psi1(1:nmesh(it)) = psirpw(1:nmesh(it),il1,tau1,it) /radr(1:nmesh(it)) 
          phi1(1:nmesh(it)) = phirpw(1:nmesh(it),il1,tau1,it) /radr(1:nmesh(it)) 
 
          call sphr( nma, nspher1, cx(1:nma), cy(1:nma), cz(1:nma), ylm1(1:nma) )
          call sphr_diff( nma, nma, nspher1, cx(1:nma), cy(1:nma), cz(1:nma), &
               &          dylm1(1:nma,1:3) )
          call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
               &                  psi1(1:nmesh(it)), wk_psi1(1:nmesh(it) ) )
          call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
               &                  phi1(1:nmesh(it)), wk_phi1(1:nmesh(it) ) )

          Do lmt2=lmt1, ilmt(it)
             il2 = ltp(lmt2,it); im2 = mtp(lmt2,it);  tau2 = taup(lmt2,it)
             nspher2 = ( il2 -1 )**2 +im2
             
             psi2(1:nmesh(it)) = psirpw(1:nmesh(it),il2,tau2,it) /radr(1:nmesh(it))
             phi2(1:nmesh(it)) = phirpw(1:nmesh(it),il2,tau2,it) /radr(1:nmesh(it))
             
             call sphr( nma, nspher2, cx(1:nma), cy(1:nma), cz(1:nma), ylm2(1:nma) )
             call sphr_diff( nma, nma, nspher2, cx(1:nma), cy(1:nma), cz(1:nma), &
                  &          dylm2(1:nma,1:3) )
             call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
                  &                  psi2(1:nmesh(it)), wk_psi2(1:nmesh(it) ) )
             call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
                  &                  phi2(1:nmesh(it)), wk_phi2(1:nmesh(it) ) )
             
             do imesh=1,nma
                call cubic_spline( nmesh(it), radr, psi1(1:nmesh(it)),&
                     &             wk_psi1(1:nmesh(it)), rdiff(imesh), ps1, dps1 )
                call cubic_spline( nmesh(it), radr, psi2(1:nmesh(it)),&
                     &             wk_psi2(1:nmesh(it)), rdiff(imesh), ps2, dps2 )
                call cubic_spline( nmesh(it), radr, phi1(1:nmesh(it)),&
                     &             wk_phi1(1:nmesh(it)), rdiff(imesh), ph1, dph1 )
                call cubic_spline( nmesh(it), radr, phi2(1:nmesh(it)),&
                     &             wk_phi2(1:nmesh(it)), rdiff(imesh), ph2, dph2 )
                
                if (rdiff(imesh) < radr(2) ) cycle

                cosx = cx(imesh)/rdiff(imesh)
                cosy = cy(imesh)/rdiff(imesh)
                cosz = cz(imesh)/rdiff(imesh)
                
                ctmp_psi1(1) = cosx *dps1 *ylm1(imesh) +ps1 *dylm1(imesh,1)
                ctmp_psi1(2) = cosy *dps1 *ylm1(imesh) +ps1 *dylm1(imesh,2)
                ctmp_psi1(3) = cosz *dps1 *ylm1(imesh) +ps1 *dylm1(imesh,3)
                
                ctmp_psi2(1) = cosx *dps2 *ylm2(imesh) +ps2 *dylm2(imesh,1)
                ctmp_psi2(2) = cosy *dps2 *ylm2(imesh) +ps2 *dylm2(imesh,2)
                ctmp_psi2(3) = cosz *dps2 *ylm2(imesh) +ps2 *dylm2(imesh,3)
                
                ctmp_phi1(1) = cosx *dph1 *ylm1(imesh) +ph1 *dylm1(imesh,1)
                ctmp_phi1(2) = cosy *dph1 *ylm1(imesh) +ph1 *dylm1(imesh,2)
                ctmp_phi1(3) = cosz *dph1 *ylm1(imesh) +ph1 *dylm1(imesh,3)
                
                ctmp_phi2(1) = cosx *dph2 *ylm2(imesh) +ph2 *dylm2(imesh,1)
                ctmp_phi2(2) = cosy *dph2 *ylm2(imesh) +ph2 *dylm2(imesh,2)
                ctmp_phi2(3) = cosz *dph2 *ylm2(imesh) +ph2 *dylm2(imesh,3)

                csum_psi = ctmp_psi1(1) *ctmp_psi2(1) &
                     &      + ctmp_psi1(2) *ctmp_psi2(2) &
                     &      + ctmp_psi1(3) *ctmp_psi2(3) 
                csum_phi = ctmp_phi1(1) *ctmp_phi2(1) &
                     &      + ctmp_phi1(2) *ctmp_phi2(2) &
                     &      + ctmp_phi1(3) *ctmp_phi2(3)
                kins_qrs_rspace(imesh,ia,lmt1,lmt2) = ( csum_psi -csum_phi )/2.0d0
             End do
          End do
       End Do
    End Do

    deallocate( cx ); deallocate( cy ); deallocate( cz ); deallocate( rdiff )
    deallocate( ylm1 ); deallocate( ylm2 ); deallocate( dylm1 ); deallocate( dylm2 )
    deallocate( psi1 ); deallocate( psi2 ); deallocate( wk_psi1 ); deallocate( wk_psi2 )
    deallocate( phi1 ); deallocate( phi2 ); deallocate( wk_phi1 ); deallocate( wk_phi2 )
    deallocate( radr )

  end subroutine m_KE_calc_kins_qrs_rspace

  subroutine m_KE_calc_kina_qrs_rspace
    integer :: imesh
    integer :: ia, it, nma
    integer :: il1, il2, im1, im2, tau1, tau2, lmt1, lmt2
    integer :: nspher1, nspher2
    integer :: ier, ir

    real(kind=DP) :: ps1, ps2, dps1, dps2, ddps2
    real(kind=DP) :: ph1, ph2, dph1, dph2, ddph2
    real(kind=DP) :: csum_psi, csum_phi
    real(kind=DP) :: hn, inl, inm, inn

    real(kind=DP), allocatable :: cx(:), cy(:), cz(:), rdiff(:)
    real(kind=DP), allocatable :: ylm1(:), ylm2(:), dylm1(:,:), dylm2(:,:)
    real(kind=DP), allocatable :: psi1(:), psi2(:), wk_psi1(:), wk_psi2(:)
    real(kind=DP), allocatable :: phi1(:), phi2(:), wk_phi1(:), wk_phi2(:)
    real(kind=DP), allocatable :: dpsi2(:), dphi2(:), wk_dpsi2(:), wk_dphi2(:)
    real(kind=DP), allocatable :: radr(:)

    inl = 1.d0/dble(fft_box_size_CD(1,1))
    inm = 1.d0/dble(fft_box_size_CD(2,1))
    inn = 1.d0/dble(fft_box_size_CD(3,1))
    
    allocate(cx(nmesh_rs_aug_max)); cx=0.d0
    allocate(cy(nmesh_rs_aug_max)); cy=0.d0
    allocate(cz(nmesh_rs_aug_max)); cz=0.d0
    allocate(rdiff(nmesh_rs_aug_max)); rdiff=0.d0
    
    allocate(ylm1(nmesh_rs_aug_max)); ylm1 = 0.d0
    allocate(ylm2(nmesh_rs_aug_max)); ylm2 = 0.d0
    allocate(dylm1(nmesh_rs_aug_max,3)); dylm1 = 0.d0
    allocate(dylm2(nmesh_rs_aug_max,3)); dylm2 = 0.d0
    
    allocate( psi1(mmesh) ); psi1 = 0.0d0
    allocate( psi2(mmesh) ); psi2 = 0.0d0
    allocate( phi1(mmesh) ); phi1 = 0.0d0
    allocate( phi2(mmesh) ); phi2 = 0.0d0
    allocate( dpsi2(mmesh) ); dpsi2 = 0.0d0
    allocate( dphi2(mmesh) ); dphi2 = 0.0d0

    allocate( wk_psi1(mmesh) ); wk_psi1 = 0.0d0
    allocate( wk_psi2(mmesh) ); wk_psi2 = 0.0d0
    allocate( wk_phi1(mmesh) ); wk_phi1 = 0.0d0
    allocate( wk_phi2(mmesh) ); wk_phi2 = 0.0d0
    allocate( wk_dpsi2(mmesh) ); wk_dpsi2 = 0.0d0
    allocate( wk_dphi2(mmesh) ); wk_dphi2 = 0.0d0

    allocate( radr(mmesh) ); radr = 0.0d0

    allocate( kina_qrs_rspace( nmesh_rs_aug_max,natm,nlmt,nlmt) )
    kina_qrs_rspace = 0.0d0

    Do ia=1, natm
       it = ityp(ia)
       nma = nmesh_rs_aug(ia)

       call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
       call m_RS_R_minus_pos( pos, ia, nmesh_rs_aug_max, inl, inm, inn, &
            &                 cx, cy, cz, rdiff, &
            &                 meshx_rs_aug, meshy_rs_aug, meshz_rs_aug )
       
       Do lmt1 = 1, ilmt(it)
          il1 = ltp(lmt1,it); im1 = mtp(lmt1,it);  tau1 = taup(lmt1,it)
          nspher1 = ( il1 -1 )**2 +im1
          
          psi1(1:nmesh(it)) = psirpw(1:nmesh(it),il1,tau1,it) /radr(1:nmesh(it)) 
          phi1(1:nmesh(it)) = phirpw(1:nmesh(it),il1,tau1,it) /radr(1:nmesh(it)) 
 
          call sphr( nma, nspher1, cx(1:nma), cy(1:nma), cz(1:nma), ylm1(1:nma) )

          call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
               &                  psi1(1:nmesh(it)), wk_psi1(1:nmesh(it) ) )
          call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
               &                  phi1(1:nmesh(it)), wk_phi1(1:nmesh(it) ) )

          Do lmt2=1, ilmt(it)
             il2 = ltp(lmt2,it); im2 = mtp(lmt2,it);  tau2 = taup(lmt2,it)
             nspher2 = ( il2 -1 )**2 +im2
             
             psi2(1:nmesh(it)) = psirpw(1:nmesh(it),il2,tau2,it) /radr(1:nmesh(it))
             phi2(1:nmesh(it)) = phirpw(1:nmesh(it),il2,tau2,it) /radr(1:nmesh(it))
             
             call calc_diff_exp( ier,5, nmesh(it), radr, psi2, dpsi2 )
             call calc_diff_exp( ier,5, nmesh(it), radr, phi2, dphi2 )

             call sphr( nma, nspher2, cx(1:nma), cy(1:nma), cz(1:nma), ylm2(1:nma) )
             
             call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
                  &                  psi2(1:nmesh(it)), wk_psi2(1:nmesh(it) ) )
             call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
                  &                  phi2(1:nmesh(it)), wk_phi2(1:nmesh(it) ) )
             call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
                  &                  dpsi2(1:nmesh(it)), wk_dpsi2(1:nmesh(it) ) )
             call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
                  &                  dphi2(1:nmesh(it)), wk_dphi2(1:nmesh(it) ) )
             
             do imesh=1,nma
                call cubic_spline( nmesh(it), radr, psi1(1:nmesh(it)),&
                     &             wk_psi1(1:nmesh(it)), rdiff(imesh), ps1, dps1 )
                call cubic_spline( nmesh(it), radr, psi2(1:nmesh(it)),&
                     &             wk_psi2(1:nmesh(it)), rdiff(imesh), ps2, dps2 )
                call cubic_spline( nmesh(it), radr, dpsi2(1:nmesh(it)),&
                     &             wk_dpsi2(1:nmesh(it)), rdiff(imesh), dps2, ddps2 )

                call cubic_spline( nmesh(it), radr, phi1(1:nmesh(it)),&
                     &             wk_phi1(1:nmesh(it)), rdiff(imesh), ph1, dph1 )
                call cubic_spline( nmesh(it), radr, phi2(1:nmesh(it)),&
                     &             wk_phi2(1:nmesh(it)), rdiff(imesh), ph2, dph2 )
                call cubic_spline( nmesh(it), radr, dphi2(1:nmesh(it)),&
                     &             wk_dphi2(1:nmesh(it)), rdiff(imesh), dph2, ddph2 )
                
                if (rdiff(imesh) < radr(2) ) cycle

                csum_psi = ps1 *( -ddps2 -2.0d0/rdiff(imesh) *dps2 &
                     &            +il2*(il2+1.0d0)/rdiff(imesh)**2 *ps2  )&
                     &         *ylm1(imesh) *ylm2(imesh)
                csum_phi = ph1 *( -ddph2 -2.0d0/rdiff(imesh) *dph2 &
                     &            +il2*(il2+1.0d0)/rdiff(imesh)**2 *ph2  )&
                     &         *ylm1(imesh) *ylm2(imesh)
                kina_qrs_rspace(imesh,ia,lmt1,lmt2) = ( csum_psi -csum_phi )/2.0d0
             End do
          End do
       End Do
    End Do

    deallocate( cx ); deallocate( cy ); deallocate( cz ); deallocate( rdiff )
    deallocate( ylm1 ); deallocate( ylm2 ); deallocate( dylm1 ); deallocate( dylm2 )
    deallocate( psi1 ); deallocate( psi2 ); deallocate( wk_psi1 ); deallocate( wk_psi2 )
    deallocate( phi1 ); deallocate( phi2 ); deallocate( wk_phi1 ); deallocate( wk_phi2 )
    deallocate( wk_dpsi2 ); deallocate( wk_dphi2 )

    deallocate( radr )

  end subroutine m_KE_calc_kina_qrs_rspace
   
  subroutine m_KE_add_ekindens_hard_rspace( ista_rho, iend_rho, ekin_dens )
    integer, intent(in) :: ista_rho, iend_rho
    real(kind=DP), intent(inout) :: ekin_dens( ista_rho:iend_rho, nspin )

    integer :: ia, it, nma
    integer :: lmt1, lmt2, is, i, ind

    real(kind=DP) :: fac0, fac

    real(kind=DP), allocatable :: kins_tmp(:,:)

!    return

!    write(*,*) 'nffp_nonp ', nfftp_nonpara
!    write(*,*) iend_fftph
!    stop

    allocate( kins_tmp(nmesh_rs_aug_max, nspin)); kins_tmp = 0.0d0

    Do ia=1, natm
       it = ityp(ia)
       nma = nmesh_rs_aug(ia)        
       
       kins_tmp = 0.0d0
       Do lmt1=1, ilmt(it)
          Do lmt2=lmt1, ilmt(it)
             
             fac0=2.0d0
             if (lmt1.eq.lmt2) fac0=1.d0
             
             Do is=1, nspin
                fac = hsr(ia,lmt1,lmt2,is) *fac0
                
                if ( use_symm_ekin_density ) then
                   Do i=1, nma
                      kins_tmp(i,is) = kins_tmp(i,is) &
                           &            +fac *kins_qrs_rspace(i,ia,lmt1,lmt2)

                   End do
                else if ( use_asymm_ekin_density ) then
                   Do i=1, nma
                      kins_tmp(i,is) = kins_tmp(i,is) &
                           &            +fac *kina_qrs_rspace(i,ia,lmt1,lmt2)

                   End do
                endif
             End do
           End do
        End do

!        kins_tmp = kins_tmp /univol**2

        Do i=1, nma
           ind = meshxyz_rs_aug(i,ia)
           if ( ind >= ista_rho .and. ind <= iend_rho ) then
              ekin_dens(ind,1:nspin) = ekin_dens(ind,1:nspin) +kins_tmp(i,1:nspin)

!              write(900+mype,*) ind, kins_tmp(i,1)
           endif
        End do
     End Do

     deallocate( kins_tmp )

   end subroutine m_KE_add_ekindens_hard_rspace


  subroutine m_KE_wd_ekindens
    real(kind=DP), allocatable :: wk_mpi1(:,:,:), wk_mpi2(:,:,:)

    if(mype==0) rewind nf_ekindens
    if(npes > 1) then
       allocate(wk_mpi1(kgp,kimg,nspin)); wk_mpi1 = 0.d0
       allocate(wk_mpi2(kgp,kimg,nspin)); wk_mpi2 = 0.d0

       if ( use_symm_ekin_density ) then
          wk_mpi1(ista_kngp:iend_kngp,:,:) = ekins_l(ista_kngp:iend_kngp,:,:)
       else if ( use_asymm_ekin_density ) then
          wk_mpi1(ista_kngp:iend_kngp,:,:) = ekina_l(ista_kngp:iend_kngp,:,:)
       endif
       call mpi_allreduce( wk_mpi1, wk_mpi2, kgp*kimg*nspin, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )

       if(mype==0) write(nf_ekindens) wk_mpi2

       deallocate(wk_mpi1); deallocate(wk_mpi2)
    else
       if ( use_symm_ekin_density ) then
          write(nf_ekindens) ekins_l
       else if ( use_asymm_ekin_density ) then
          write(nf_ekindens) ekina_l
       end if
    endif

  end subroutine m_KE_wd_ekindens

  subroutine m_KE_rd_ekindens
    real(kind=DP), allocatable :: wk_mpi1(:,:,:)

    if(mype==0) rewind nf_ekindens
    if(npes > 1) then
       allocate(wk_mpi1(kgp,kimg,ndim_magmom)); wk_mpi1 = 0.d0

       if ( mype==0 ) read(nf_ekindens) wk_mpi1
       call mpi_bcast( wk_mpi1, kgp*kimg*ndim_magmom, mpi_double_precision, &
            &          0, mpi_comm_group, ierr )

       if ( use_symm_ekin_density ) then
          ekins_l(ista_kngp:iend_kngp,:,:) = wk_mpi1(ista_kngp:iend_kngp,:,:)
       else if ( use_asymm_ekin_density ) then
          ekina_l(ista_kngp:iend_kngp,:,:) = wk_mpi1(ista_kngp:iend_kngp,:,:)
       endif
       deallocate(wk_mpi1)
    else
       if ( use_symm_ekin_density ) then
          read(nf_ekindens) ekins_l
       else if ( use_asymm_ekin_density ) then
          read(nf_ekindens) ekina_l
       end if
    endif
  end subroutine m_KE_rd_ekindens

  subroutine m_KE_init_ekindens
    use m_Parallelization,  only :  nel_fftp, idisp_fftp, ista_fftp, iend_fftp, &
         &                          mp_fftp, nis_fftp, nie_fftp

    integer :: is, i
    real(kind=DP) :: factor
    real(kind=DP), allocatable :: afft(:), wk_l(:,:)

!    return

    call m_FFT_alloc_CD_box()
    allocate(afft(ista_fftp:iend_fftp))
    allocate(wk_l(ista_kngp:iend_kngp,kimg) )

    factor = 0.3d0 *( 6.0d0 *PAI**2 )**(2./3.)

    call set_mat_on_fftmesh_rspace( chgq_l, afft )
    Do i=ista_fftph, iend_fftph
       afft(2*i-1) =  abs( afft(2*i-1) )**(5./3.) *factor
    End Do
    call extract_matrix_from_FFTcd_mesh( afft, wk_l )

    if ( ndim_magmom == 1 .or. ndim_magmom == 4 ) then
       ekins_l(:,:,1) = wk_l(:,:)
    else
       ekins_l(:,:,1) = wk_l(:,:) /2.0d0
       ekins_l(:,:,2) = ekins_l(:,:,1)
    endif

    deallocate( afft )
    deallocate( wk_l )
    call m_FFT_dealloc_CD_box()

  contains

    subroutine set_mat_on_fftmesh_rspace( wkq_l, afft )
      real(kind=DP), intent(in) :: wkq_l(ista_kngp:iend_kngp,kimg,ndim_magmom)
      real(kind=DP), intent(out) :: afft(ista_fftp:iend_fftp)

      integer :: j, i, ip
      real(kind=DP) :: rinplw
      real(kind=DP), allocatable :: afft_mpi1(:), afft_mpi2(:), afft_mpi3(:)

      rinplw = 1.d0 /product(fft_box_size_CD(1:3,1))

      afft = 0.0d0;

      allocate(afft_mpi1(nfftp)); afft_mpi1 = 0.0d0
      if(npes >= 2) then
         allocate(afft_mpi2(mp_fftp)); afft_mpi2 = 0.0d0
         allocate(afft_mpi3(mp_fftp)); afft_mpi3 = 0.0d0
      end if
      if ( ndim_magmom == 1 .or. ndim_magmom == 4 ) then
         do j = 1, kimg
            do i = ista_kngp, iend_kngp  !for mpi
               ip = (igfp_l(i)-1)*kimg + j
               afft_mpi1(ip) = wkq_l(i,j,1)
            end do
         end do
      else
         do j = 1, kimg
            do i = ista_kngp, iend_kngp  !for mpi
               ip = (igfp_l(i)-1)*kimg + j
               afft_mpi1(ip) = wkq_l(i,j,1) +wkq_l(i,j,2)
            end do
         end do
      endif

      if (npes >= 2) then
         call mpi_barrier(mpi_comm_group,ierr)
         do j = 0, npes-1
            do i = nis_fftp(j),nie_fftp(j)
               afft_mpi2(i-nis_fftp(j)+1) = afft_mpi1(i)
            end do
            call mpi_allreduce(afft_mpi2,afft_mpi3,mp_fftp &
                 &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
            if(j == mype) then
               do i = ista_fftp, iend_fftp
                  afft(i) = afft_mpi3(i - ista_fftp + 1)
               end do
            end if
         end do
      else
         afft = afft_mpi1
      end if

      call m_FFT_CD_inverse_c(nfout,afft)        ! G-->R space
      deallocate(afft_mpi1)
      if (allocated(afft_mpi2) ) deallocate(afft_mpi2)
      if (allocated(afft_mpi3) ) deallocate(afft_mpi3)

    end subroutine set_mat_on_fftmesh_rspace

  end subroutine m_KE_init_ekindens

end module m_KineticEnergy_Density

       subroutine ev_test2(ar,ai,w,zr,zi,n,nm)
!
      use communication_h, only : eigen_init
     &               , eigen_free
!
       integer                :: n, nm
       real(8)                :: ar(*), ai(*), w(*), zr(*), zi(*)

       include 'mpif.h'
       include 'trd.h'

       call eigen_init(1)
       call MPI_Barrier(MPI_COMM_EIGEN,ierr)
       call ev_check2_body(ar(1),ai(1),w(1),zr(1),zi(1),n,nm)
       call MPI_Barrier(MPI_COMM_EIGEN,ierr)
       call eigen_free(0)

       return
       end
*
*
*
       subroutine ev_check2_body(ar,ai,w,zr,zi,n,nm)
!
      use communication_h, only : loop_c
!
       implicit double precision(a-h,o-z),integer(i-n)

       integer                :: n, nm
       real(8)                :: ar(1:nm,*), ai(1:nm,*)
       real(8)                :: w(1:n)
       real(8)                :: zr(1:nm,*), zi(1:nm,*)

       real(8)                :: b(1:n)
       real(8)                :: b1r(1:n), b1i(1:n)

       real(8)                :: m_epsilon
       real(8), external      :: machine_epsilon

       include 'mpif.h'
       include 'trd.h'
*
       m_epsilon = machine_epsilon()

*
       ra=0d0
       rz=0d0
       rr=0d0
       r =0d0
       b(1:n)=0d0

       do i=1,n,1

             i_3=MOD(i-1,nprocs)+1
             if(i_3==myrank)then
                i_1=(i-1)/nprocs+1
                do k=1,n
                   b1r(k)=zr(k,i_1)
                   b1i(k)=zi(k,i_1)
                enddo
             endif
             call MPI_Bcast(b1r(1),n,MPI_DOUBLE_PRECISION,i_3-1
     1       ,MPI_COMM_EIGEN,ierr)
             call MPI_Bcast(b1i(1),n,MPI_DOUBLE_PRECISION,i_3-1
     1       ,MPI_COMM_EIGEN,ierr)

             i_2=1
             i_3=n
             call loop_c(i_2,i_3,i_4,n, nprocs,myrank)
             do i_1=i_2,i_3
                j=(i_1-1)*nprocs+myrank
                t1=0.0D+00
                t2=0.0D+00
                s1=0.0D+00
                s2=0.0D+00
                u =0.0D+00
                do k=1,n,1
                   t1=t1+b1r(k)*ar(k,i_1) ! t = Az(i)
     &                  +b1i(k)*ai(k,i_1) ! t = Az(i)
                   t2=t2-b1r(k)*ai(k,i_1) ! t = Az(i)
     &                  +b1i(k)*ar(k,i_1) ! t = Az(i)
                   s1=s1+b1r(k)*zr(k,i_1) ! s = Zz(i)
     &                  +b1i(k)*zi(k,i_1) ! s = Zz(i)
                   s2=s2+b1r(k)*zi(k,i_1) ! s = Zz(i)
     &                  -b1i(k)*zr(k,i_1) ! s = Zz(i)
                   u =u +SQRT(ar(k,i_1)**2   ! u = |A|_1
     &                       +ai(k,i_1)**2)  ! u = |A|_1
                enddo! k
                t1=t1-w(i)*b1r(j) ! t = Az(i) - wz(i)
                t2=t2-w(i)*b1i(j) ! t = Az(i) - wz(i)
                if(i==j) s1=s1-1.0D+00 ! s = Zz(i)-1(i)
                b(i)=b(i)+SQRT(t1**2+t2**2) ! b(i)=|Az(i)-wz(i)|_1
                rz=rz+s1**2+s2**2
                ra=MAX(ra,u)
             enddo
       enddo
*>

       b1r(1:n)=b(1:n)
       call MPI_Allreduce(b,b1r,n,MPI_DOUBLE_PRECISION,
     &                    MPI_SUM,MPI_COMM_EIGEN,ierr)
       b(1:n)=b1r(1:n)
       r=ra
       call MPI_Allreduce(ra,r,1,MPI_DOUBLE_PRECISION,
     &                    MPI_MAX,MPI_COMM_EIGEN,ierr)
       ra=r
       r=rz
       call MPI_Allreduce(rz,r,1,MPI_DOUBLE_PRECISION,
     1                    MPI_SUM,MPI_COMM_EIGEN,ierr)
       rz=r

       rr=0d0
       do i=1,n
          if(b(i)>rr)then
             rr=b(i); k=i
          endif
       enddo! i

!       print*,b(1:n)

       if(myrank==1)then
          print*," "
          print*,"----- Check a calculation result. -----"
          print*,"max|Ax-wx|=",rr,k
          print*,"|A|=",ra
          print*,"epsilon=",m_epsilon
          print*,"max|Ax-wx|/Ne|A|=",rr/(n*m_epsilon*ra)
          print*,"|ZZ-I|=",SQRT(rz),rz
          print*,"---------------------------------------"
       endif
*
       return
       end

! =================================== added by K. Tagami =========== 5.0
subroutine Renewal_of_Chg_Ctrl_Param

  use m_Const_Parameters,    only  : DP, ON, OFF, YES, WHOLE
  use m_Total_Energy,         only : m_TE_what_is_edeltb_now
  use m_Ionic_System,        only : natm
  use m_Control_Parameters,  only : sw_eval_energy_before_charge, &
       &                            sw_update_charge_total, spin_density_mixfactor
!
  use m_Const_Parameters,  only : MSD, CG, SD, LMSD, LMCG,lmeazyCG, lmmsd
  use m_Control_Parameters,  only :  m_CtrlP_solver_for_WFs_now, intzaj

  use  m_IterationNumbers,    only : iteration, iteration_ionic, iteration_electronic, &
       &                             iteration_unit_cell

  use m_Control_Parameters,       only : sw_update_charge_hsr, eval_energy_before_charge
  use m_Control_Parameters,     only : sw_recomposing, sw_force_simple_mixing
  use m_Control_Parameters,     only : sw_recomposing_hsr, sw_force_simple_mixing_hsr

  use m_Files,               only : nfout
  use m_Control_Parameters,   only : printable

! =========================== KT_Test ============================== 12.5Exp
  use m_Control_Parameters,   only : sw_hybrid_functional, &
       &                             truncate_vxw_updating, sw_update_vxw, &
       &                             edelta_for_hyb_chgfix, edelta_for_hyb_convgd
! ================================================================== 12.5Exp

! ================= KT_add =================== 13.0F
  use m_Control_Parameters,   only : use_hybrid_functional, &
       &                             hybrid_calc_is_active, edelta_change_to_hybrid
! ============================================ 13.0F

  use m_CD_Mag_Moment,   only : sw_monitor_atomcharge,  m_CD_set_rad_cov_default, &
       &                        m_CD_set_rad_cov_now

  use m_Const_Parameters,  only : LINEAR, ABRUPT, STEPWISE

  use m_Crystal_Structure,  only : sw_magnetic_constraint, mag_constraint_lambda, &
       &                           damping_method_mag_constraint, &
       &                           num_intermid_lambda, &
       &                           nmax_intermid_lambda, &
       &                           edelta_change_lambda_first, &
       &                           edelta_change_lambda_last, &
       &                           max_iter_elec_mag_constraint, &
       &                           max_iter_ion_mag_constraint, &
       &                           max_iter_cell_mag_constraint, &
       &                           sw_fix_charge_after_constraint

! ================= KT_add =================== 13.0XX
  use m_Control_Parameters,   only : sw_calc_ekin_density, &
       &                             ekin_density_is_active, ekmode
! ============================================ 13.0XX

! ===== KT_add ============== 13.0U3
  use m_Control_Parameters,   only : smearing_width => width, &
       &                             smearing_width_initial => width_initial, &
       &                             method_change_smearing_width, &
       &                             nmax_intermid_width, num_intermid_width, &
       &                             edelta_change_width_first, &
       &                             edelta_change_width_last, &
       &                             sw_wf_mixing, wf_mixing_is_active, &
       &                             edelta_start_wf_mixing
! =========================== 13.0U3

  use m_Parallelization,  only : mype

  implicit none

  real(kind=DP) :: edeltab_per_atom, edeltb_per_atom, edelta

! -----------------------
!  if ( sw_monitor_atomcharge == ON ) then
!     if ( iteration_ionic >1 .and. iteration_electronic ==1 ) then
!        call m_CD_set_rad_cov_default
!        call m_CD_set_rad_cov_now
!     endif
!  endif

! ------------------
  edelta = m_TE_what_is_edeltb_now()

  edeltab_per_atom = m_TE_what_is_edeltb_now() / natm
  edeltab_per_atom = abs(edeltab_per_atom )
!
!  call update_or_fix_charge
!  call update_or_fix_charge_hardpart
!

  if ( sw_magnetic_constraint == ON ) then
     call update_lambda_mag_constraint
  endif

! =========================== KT_Test ============================== 12.5Exp
  if ( sw_hybrid_functional == ON ) then
     if ( truncate_vxw_updating ) call update_or_fix_charge_hybrid
  endif
! ================================================================== 12.5Exp
    
! ================= KT_add =================== 13.0F
  if ( use_hybrid_functional ) then

     if ( sw_hybrid_functional == ON .and. (.not. hybrid_calc_is_active) ) then
        sw_hybrid_functional = off
     endif
     if ( sw_hybrid_functional == OFF ) then
        if ( edeltab_per_atom < edelta_change_to_hybrid ) then
           sw_hybrid_functional = on
           hybrid_calc_is_active = .true.

           write(nfout,*) '****************'
           write(nfout,*) ' hybrid_calc is turned active now'
           write(nfout,*) '****************'
        endif
     endif
  end if
! ============================================ 13.0F

  if ( eval_energy_before_charge == YES ) then
    call order_energy_chg_construction
  endif

!  call update_spin_density_mixfactor
!   call update_spin_recomposing

! === KT_add ==== 13.0XX
  if ( sw_calc_ekin_density == ON ) then
     if ( edeltab_per_atom < 1.0D-2 .or. ekmode == ON ) then
!     if ( iteration_electronic > 1 ) then

        if ( .not. ekin_density_is_active ) then
           ekin_density_is_active = .true.
           write(nfout,*) "** ekin_density_is turned active"
        endif
     endif
  endif
! =============== 13.0XX

! ====== KT_add ======= 13.0U3
  if ( sw_wf_mixing == ON ) call checkif_wf_mixig_active
!
  call update_smearing_width
! ===================== 13.0U3

contains

  subroutine update_spin_recomposing
    logical, save :: first = .true.
    integer :: nstep_threshold = 15 

    integer :: sw_recomposing0 = OFF
    integer :: sw_force_simple_mixing0 = OFF
!
    if ( first ) then
       sw_recomposing0 = sw_recomposing
       sw_force_simple_mixing0 = sw_force_simple_mixing
       first = .false.
    endif
!
    if ( sw_recomposing0 == ON ) then
       if ( iteration <= nstep_threshold ) then
          sw_recomposing = ON
          sw_force_simple_mixing = ON
          sw_recomposing_hsr = ON
          sw_force_simple_mixing_hsr = ON
       else
          sw_recomposing = OFF
          sw_force_simple_mixing = OFF
          sw_recomposing_hsr = OFF
          sw_force_simple_mixing_hsr = OFF
       endif
    end if
  end subroutine update_spin_recomposing

  subroutine update_spin_density_mixfactor
    logical, save :: first = .true.
    real(kind=DP),save ::  spin_dens_mixfactor_0

    if ( first ) then
       spin_dens_mixfactor_0 = spin_density_mixfactor
       first = .false.
    endif
!
    if ( iteration <= 5 ) then
       spin_density_mixfactor = 4.0
    else
       spin_density_mixfactor = spin_dens_mixfactor_0
    endif
!
    if ( printable ) then
       write(nfout,*) '*** spin_density_mixfacotr now = ', &
            & iteration, spin_density_mixfactor
    end if
! --------------------------------------
  end subroutine update_spin_density_mixfactor

  subroutine order_energy_chg_construction
!
    real(kind=DP) :: edeltb_now
    integer :: isolver, sw_submat
    
    integer :: nsteps_for_transition = 3
    
    edeltb_now = edeltab_per_atom
    isolver = m_CtrlP_solver_for_WFs_now(iteration_electronic,iteration_ionic,intzaj &
         &                              ,edeltb_now, sw_submat)
!
    select case(isolver)
    case (SD,MSD)       
       sw_eval_energy_before_charge = OFF
    case (lmSD, lmMSD, lmCG, lmeazyCG)
       sw_eval_energy_before_charge = OFF
    case default
       if ( iteration <= nsteps_for_transition ) then
          sw_eval_energy_before_charge = OFF
       else
          sw_eval_energy_before_charge = ON
       endif
    end select
!    
    if ( printable ) then
       write(nfout,*) '*-- sw_eval_ene_before_charge now = ',  &
            &               iteration, sw_eval_energy_before_charge
    endif
  end subroutine order_energy_chg_construction

  subroutine update_or_fix_charge
    integer, save :: counter = 0

    real(kind=DP) :: ene_threshold1
    integer :: nsteps_for_fixing_charge = -2

    ene_threshold1 = 1.0E-3
    if ( iteration_electronic == 0 &
         & .or. iteration_electronic <= nsteps_for_fixing_charge ) then
       sw_update_charge_total = ON
    else
       if ( edeltab_per_atom > ene_threshold1 ) then
          sw_update_charge_total = OFF
       else
          sw_update_charge_total = ON
       endif
    endif
!
    if ( iteration <= 1 ) then
       sw_update_charge_total = ON
    else if ( iteration_electronic <= nsteps_for_fixing_charge ) then
       sw_update_charge_total = OFF
    else
       sw_update_charge_total = ON
    endif
! 
  end subroutine update_or_fix_charge

  subroutine update_or_fix_charge_hardpart
    if ( sw_update_charge_total == OFF ) then
       sw_update_charge_hsr = OFF
    else

    endif

  end subroutine update_or_fix_charge_hardpart

! =========================  KT_Test ===================== 12.5Exp
  subroutine update_or_fix_charge_hybrid
    integer :: count1 = 0
    integer :: count2 = 0

    if ( abs(edelta) < edelta_for_hyb_chgfix ) then
       count1 = count1 + 1
       if ( count1 == 3 ) then
          sw_update_charge_total = OFF
          if ( printable ) write(nfout,*) '*----- sw_update_charge_total is set OFF --'
       endif
    endif
       !
    if ( abs(edelta) < edelta_for_hyb_convgd ) then
       count2 = count2 + 1
       if ( count2 == 3 ) then
          sw_update_vxw = OFF
          if ( printable ) write(nfout,*) '*----- sw_update_vxw is set OFF --'
       endif
    endif

!
  end subroutine update_or_fix_charge_hybrid
! ========================================================= 12.5Exp

  subroutine update_lambda_mag_constraint

    integer, parameter :: succession = 3
    real(kind=DP) :: threshold( nmax_intermid_lambda +1 )
!
    integer, save :: count = 0, istep = 1

    logical, save :: First = .true.
    logical, save :: mag_constraint_is_over = .false.
    logical, save :: lambda_is_changed 
    integer, save :: sw_fix_charge_after_constr_org

    real(kind=DP), save :: lambda_org, lambda_old, lambda_00

    integer :: i, nn
    real(kind=DP) :: c1, ratio

    if ( First ) then
       lambda_org = mag_constraint_lambda; 
       lambda_old = mag_constraint_lambda
       sw_fix_charge_after_constr_org = sw_fix_charge_after_constraint
       istep = 1
       First = .false.
    else 
!       if ( iteration_unit_cell > 1 .and. iteration_ionic == 1 &
!            &                       .and. iteration_electronic == 1 ) then
!          mag_constraint_is_over = .false.
!          mag_constraint_lambda = lambda_org
!!          istep = 1;  count = 0
!       endif
       if ( iteration_electronic == 1 ) then
          mag_constraint_is_over = .false.
          mag_constraint_lambda = lambda_org
          sw_fix_charge_after_constraint = sw_fix_charge_after_constr_org
          istep = 1;  count = 0
       endif
    endif

    if ( damping_method_mag_constraint == 0 )  return

    if ( iteration_ionic > max_iter_ion_mag_constraint ) then
       mag_constraint_is_over = .true.
       mag_constraint_lambda = 0.0d0;  
    endif
    if ( iteration_unit_cell > max_iter_cell_mag_constraint ) then
       mag_constraint_is_over = .true.
       mag_constraint_lambda = 0.0d0;  
    endif

    if ( mag_constraint_is_over ) then
       if ( sw_fix_charge_after_constraint == ON ) then
          sw_update_charge_total = OFF
       endif
       return
    endif

    lambda_is_changed = .false.

! ------------------
    select case( damping_method_mag_constraint )

    case( STEPWISE )
       nn = num_intermid_lambda +1
       threshold(1)  = edelta_change_lambda_first
       threshold(nn) = edelta_change_lambda_last

       Do i=2, nn-1
          c1 = threshold(nn) *(i-1) + threshold(1) *(nn-i)
          c1 = c1 /dble(nn-1)
          threshold(i) = c1
       End do

       c1 = abs( edeltab_per_atom )
!    c1 = abs( edelta )
!
       if ( c1 < threshold( istep ) ) then
          count = count + 1
          if ( count == succession *istep ) then
             ratio = 1.0D0 - dble(istep) /dble(nn)
             mag_constraint_lambda = lambda_org *ratio

             istep = istep +1
             lambda_is_changed = .true.
          endif
       endif

       if ( istep > nn ) then
          mag_constraint_is_over = .true.
       endif

    case (ABRUPT)
       if ( iteration_electronic > max_iter_elec_mag_constraint ) then
          mag_constraint_lambda = 0.0d0
          lambda_is_changed = .true.
          mag_constraint_is_over = .true.
       endif

       c1 = abs( edeltab_per_atom )

       if ( c1 <  edelta_change_lambda_last ) then
          count = count + 1
          if ( count == succession ) then
             mag_constraint_lambda = 0.0d0
             mag_constraint_is_over = .true.
             lambda_is_changed = .true.
          endif
       endif

    case (LINEAR)
       ratio = dble( iteration_electronic ) / dble(max_iter_elec_mag_constraint)
       ratio = 1.0D0 -ratio

       if ( iteration_electronic <= max_iter_elec_mag_constraint ) then
          mag_constraint_lambda = lambda_org *ratio
          lambda_is_changed = .true.
       else
          mag_constraint_lambda = 0.0d0
          mag_constraint_is_over = .true.
       endif

       c1 = abs( edeltab_per_atom )
       if ( c1 <  edelta_change_lambda_first ) then
          count = count + 1
          if ( count == succession ) then
             mag_constraint_is_over = .true.
             lambda_is_changed = .true.
          endif
       endif
    end select

    if ( lambda_is_changed ) then
       write(nfout,*) "------ mag_constraint_lambda is changed to ", &
            &                       mag_constraint_lambda
!       write(nfout,*) 'lambda_old = ', lambda_old
    endif

    lambda_old = mag_constraint_lambda
!
  end subroutine update_lambda_mag_constraint

! === KT_add === 13.0U3
  subroutine update_smearing_width

    integer, parameter :: ntimes = 3
    real(kind=DP) :: threshold( nmax_intermid_width +1 )
!
    integer, save :: count = 0, istep = 1

    logical, save :: First = .true.
    logical, save :: width_is_changed 
    real(kind=DP), save :: width_initial, width_final, width_old

    integer :: i, nn
    real(kind=DP) :: c1, ratio

    if ( method_change_smearing_width == 0 )  return
    if ( iteration_ionic > 1 ) return

    if ( First ) then
       width_initial = smearing_width_initial
       width_final = smearing_width

       width_old = smearing_width_initial
       smearing_width = width_initial

       istep = 1
       First = .false.
    endif

    width_is_changed = .false.

! ------------------
    select case( method_change_smearing_width )

    case( STEPWISE )
       nn = num_intermid_width +1
       threshold(1)  = edelta_change_width_first
       threshold(nn) = edelta_change_width_last

       Do i=2, nn-1
          c1 = threshold(nn) *(i-1) + threshold(1) *(nn-i)
          c1 = c1 /dble(nn-1)
          threshold(i) = c1
       End do

       c1 = abs( edeltab_per_atom )
!    c1 = abs( edelta )
!
       if ( c1 < threshold( istep ) ) then
          count = count + 1
          if ( count == ntimes *istep ) then
             ratio = 1.0D0 - dble(istep) /dble(nn)
             smearing_width = width_initial *ratio &
                  &          +width_final *( 1.0d0 -ratio )

             istep = istep +1
             width_is_changed = .true.
          endif
       endif
       if ( istep > nn )  method_change_smearing_width = 0

    end select

    if ( width_is_changed ) then
       write(nfout,*) "------ smearing_width is changed to ", &
            &                       smearing_width
    endif

    width_old = smearing_width

  end subroutine update_smearing_width

  subroutine checkif_wf_mixig_active
    integer, parameter :: ntimes = 3
    real(kind=DP), parameter :: threshold1 = 1.0D1

    integer, save :: count = 0
    logical, save :: GoFlag = .false.

    if ( edelta_start_wf_mixing > threshold1 )  then
       wf_mixing_is_active = .true.
       return
    endif

    if ( .not. GoFlag ) then
       if ( edeltab_per_atom < edelta_start_wf_mixing ) then
          count = count +1
          if ( count == ntimes ) then
             GoFlag = .true.
             write(nfout,*) "** wf_mixing is trurned active"
          endif
       endif
    endif

    if ( GoFlag ) then
       wf_mixing_is_active = .true.
    else
       wf_mixing_is_active = .false.
    endif
    
  end subroutine checkif_wf_mixig_active

end subroutine Renewal_of_Chg_Ctrl_Param

!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver. 7.01)
!
!  SUBROUINE: Renewal_of_OccMat
!
!  AUTHOR(S): T. Yamamoto   June/08/2005
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!   patch 0.1 by K. Tagami @adv    2009/02/04
! 
!   patch 0.1 :  change from m_OP_occ_mat_ao to m_OP_occ_mat_ao_kt
!        
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! =========================================== modified by K. Tagami ========== 5.0
!!subroutine Renewal_of_OccMat( pmode )
subroutine Renewal_of_OccMat( flag_dm, pmode, skip )
! ============================================================================ 5.0

! $Id: Renewal_of_OccMat.F90 577 2017-12-15 05:26:08Z jkoga $
  use m_Files,               only : nfout
  use m_Const_Parameters,   only : SPHERICAL_HARMONICS, ATOMIC_ORBITAL, ON
  use m_Control_Parameters, only : num_projectors, projector_type, sw_hubbard
  use m_Kpoints,            only : kv3
  use m_Charge_Density,     only : m_CD_den_mat
! ============================================ Modified by K. Tagami ======== 0.1
!  use m_Orbital_Population,only  : m_OP_occ_mat_ylm, m_OP_occ_mat_ao &
!       &                         , m_OP_rd_occ_mat 
  use m_Orbital_Population,only  : m_OP_occ_mat_ylm, m_OP_occ_mat_ao &
       &                         , m_OP_rd_occ_mat &
       &                         , m_OP_occ_mat_ao_kt, m_OP_cp_om_to_ommix, m_OP_cp_ommix_to_omold
! =======================================

! ================================= added by K. Tagami ===================== 5.0
  use m_Control_Parameters,      only : occmat_type
  use m_Const_Parameters,       only : OccMat_Type1, OccMat_Type2
! ============================================================================ 5.0

! ================================ added by K. Tagami =============== 11.0
  use m_Control_parameters,    only : noncol
  use m_Orbital_Population,    only  : m_OP_occ_mat_ylm_noncl, &
       &                               m_OP_occ_mat_ao_kt_noncl
! ================================================================== 11.0

  implicit none
  logical, intent(in) :: flag_dm
  integer, intent(in) :: pmode
  logical, intent(in), optional :: skip
  logical :: ski
  ski = .false.
  if(present(skip)) then
     ski = skip
  endif
  if (ski) then
     call m_OP_cp_om_to_ommix(nfout,1.d0)
     call m_OP_cp_ommix_to_omold()
     return
  endif
  
#ifdef __TIMER_SUB__
  call timer_sta(735)
#endif

! ================================= modified by K. Tagami =============== 5.0
!  if(num_projectors>0 .and. sw_hubbard == ON) then
!     if(projector_type == SPHERICAL_HARMONICS) then
!        !!$write(*,*) "m_CD_occ_mat_ylm"
!        if(flag_dm) call m_CD_den_mat(nfout,kv3)
!        call m_OP_occ_mat_ylm(nfout)
!     else if(projector_type == ATOMIC_ORBITAL) then
!!!! ====================================== Modified by K. Tagami ============ 0.1
!!        call m_OP_occ_mat_ao(nfout)
!        call m_OP_occ_mat_ao_kt(nfout)
!! ============================================================
!     end if
!  end if

! ====================== modified by K. Tagami ========== 11.0
  if ( num_projectors>0 .and. sw_hubbard == ON ) then
!     select case ( occmat_type )
!     case ( OccMat_Type1 )
!        if(flag_dm) call m_CD_den_mat(nfout,kv3)
!        call m_OP_occ_mat_ylm( nfout, pmode )
!     case ( OccMat_Type2 )
!        if(flag_dm) call m_CD_den_mat(nfout,kv3)
!        call m_OP_occ_mat_ao_kt(nfout, pmode)
!     end select

     if ( noncol ) then
        select case ( occmat_type )
        case ( OccMat_Type1 )
           if(flag_dm) call m_CD_den_mat(nfout,kv3)
           call m_OP_occ_mat_ylm_noncl( nfout, pmode )
        case ( OccMat_Type2 )
           if(flag_dm) call m_CD_den_mat(nfout,kv3)
           call m_OP_occ_mat_ao_kt_noncl(nfout, pmode)
        end select
     else
        select case ( occmat_type )
        case ( OccMat_Type1 )
           if(flag_dm) call m_CD_den_mat(nfout,kv3)
           call m_OP_occ_mat_ylm( nfout, pmode )
        case ( OccMat_Type2 )
           if(flag_dm) call m_CD_den_mat(nfout,kv3)
           call m_OP_occ_mat_ao_kt(nfout, pmode)
        end select
     endif
! ========================================================= 11.0
  end if
! =========================================================================-- 5.0

#ifdef __TIMER_SUB__
  call timer_end(735)
#endif

end subroutine Renewal_of_OccMat

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MAIN PROGRAM: CPMD
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
program CPMD
! $Id: mdepmain.f90 570 2017-04-21 20:34:50Z yamasaki $
  implicit none
  logical  :: Forces_are_Converged, Ending_Time, MultiReplicaMode &
       &     ,AllForces_are_Converged

  call Initialization
  call InputData_Analysis
  MultiReplica: do
     call Preparation_ep
     call Initial_MD_Condition

     AtomicConfiguration: do
#ifdef LIBRARY_BUILD
        call Forces_phase0
#else
        call Forces
#endif
        if(Forces_are_Converged()) exit AtomicConfiguration
        call Move_Ions
        if(Ending_Time())          exit AtomicConfiguration
        call MDIterationNumber_Setting_ep
     enddo AtomicConfiguration

     call WriteDownData_onto_Files

     if(.not.MultiReplicaMode()) then
        exit MultiReplica
     else if( Ending_Time() .or. AllForces_are_Converged()) then
        exit MultiReplica
     end if

  end do MultiReplica

end program CPMD

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a collection of subroutines for calculating exchange correlation kernels.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

!------------------------------------------------------------------
!!
!!!        Calc Exchange Kernel on the mesh   ( LDAPW91)
!!
!-------------------------------------------------------------------
subroutine calc_kernel_ex_ldapw91( nspin, ispin, chgrhr_l, kernel_ex )
!
  use m_Const_Parameters,  only : PAI,DP
  use m_Parallelization,   only : ista_fftph, iend_fftph
  use m_Crystal_Structure, only : univol
!
  implicit none

  integer,intent(in)        :: nspin,ispin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_fftph:iend_fftph,ispin)
  real(kind=DP),intent(out) :: kernel_ex(ista_fftph:iend_fftph,nspin)
!------------------------- 
  if ( ispin==1 ) then
     call kernel_exchange_spinless
  else
     call kernel_exchange_polarized
  endif
  
contains

  subroutine kernel_exchange_spinless
    integer        :: is, i
    real(kind=DP)  :: ctmp1, ctmp2
!    real(kind=DP)  :: density_minimum = 1.0d-20
!    real(kind=DP)  :: density_minimum = 1.0d-6
    real(kind=DP)  :: density_minimum = 1.0d-7
!    real(kind=DP)  :: density_minimum = 1.0d-12

!!!!!!!!!!!!!!!    ctmp1 = -( 2.0d0/9.0d0/PAI )**(1./3.)
    ctmp1 = -( 1.0d0/9.0d0/PAI )**(1./3.)
! ------------------------
    do is = 1, ispin
       do i = ista_fftph, iend_fftph
          if ( chgrhr_l(i,is) < density_minimum ) cycle
          ctmp2 = chgrhr_l(i, is) **( -2.0d0/3.0d0 )
          kernel_ex( i,is ) = ctmp1 *ctmp2
       End do
    End do
! -- ZTMP --
!    ctmp2 = 0.0d0
!    Do is=1, nspin
!       do i = ista_fftph, iend_fftph
!          ctmp2 = ctmp2 + chgrhr_l( i,is )
!       End do
!    End do
!    write(*,*) 'ctmp2 = ', ctmp2 * univol / dble(iend_fftph)
!    stop
! --
  end subroutine kernel_exchange_spinless

  subroutine kernel_exchange_polarized
    integer        :: is, i
    real(kind=DP)  :: ctmp1, ctmp2
!    real(kind=DP)  :: density_minimum = 1.0d-20
!    real(kind=DP)  :: density_minimum = 1.0d-6
    real(kind=DP)  :: density_minimum = 1.0d-7
!    real(kind=DP)  :: density_minimum = 1.0d-12

    ctmp1 = -( 1.0d0/9.0d0/PAI )**(1./3.)
    do is = 1, ispin
       do i = ista_fftph, iend_fftph
          if ( chgrhr_l(i,is) < density_minimum ) cycle
          ctmp2 = ( dble(ispin) *chgrhr_l(i,is) ) **( -2.0d0/3.0d0 )
          kernel_ex( i,is ) = ctmp1 *ctmp2
       End do
    End do
    Kernel_ex = Kernel_ex * 2.0d0

  end subroutine kernel_exchange_polarized

end subroutine calc_kernel_ex_ldapw91

!------------------------------------------------------------------
!!
!!!        Calc Correlation Kernel on the mesh   ( LDAPW91)
!!
!-------------------------------------------------------------------
subroutine calc_kernel_cr_ldapw91( nspin, ispin, chgrhr_l, kernel_cr )

  use m_Const_Parameters,  only : PAI, PAI4, DP
  use m_Parallelization,   only : ista_fftph, iend_fftph

  implicit none

  integer,intent(in)        :: nspin,ispin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_fftph:iend_fftph,ispin)
  real(kind=DP),intent(out) :: kernel_cr(ista_fftph:iend_fftph,nspin,nspin)
! --
  if ( ispin==1 ) then
     call kernel_correlation_spinless
  else
     call kernel_correlation_polarized
  endif

contains
  subroutine kernel_correlation_spinless
    integer       :: i
    real(kind=DP) :: rho,rs
    real(kind=DP) :: dec_drs 
    real(kind=DP) :: d2ec_drs2
    real(kind=DP) :: c1, ctmp1
!    real(kind=DP)  :: density_minimum = 1.0d-20
!    real(kind=DP)  :: density_minimum = 1.0d-6
    real(kind=DP)  :: density_minimum = 1.0d-7
!    real(kind=DP)  :: density_minimum = 1.0d-12
  
    Do i = ista_fftph, iend_fftph

       rho  = chgrhr_l(i,1)
       if ( rho < density_minimum ) cycle

       rs   = ( 3.0d0 / PAI4 / rho )**(1.0d0/3.0d0)

       call differential_ec_rs_only( rs, dec_drs, d2ec_drs2 )
       c1 = rs /3.0d0

       ctmp1 = -c1*( 2.0d0/3.0d0 *dec_drs - c1 *d2ec_drs2 ) /rho
       kernel_cr( i,1,1 ) = ctmp1
     End do
  end subroutine kernel_correlation_spinless

  subroutine kernel_correlation_polarized
    integer       :: i, ni, nj, sgn_i, sgn_j
    real(kind=DP) :: rho, zeta, rs
    real(kind=DP) :: dec_drs, dec_dzeta
    real(kind=DP) :: d2ec_drs2, d2ec_dzeta2, d2ec_drs_dzeta
    real(kind=DP) :: c1, ctmp1, ctmp2
!!    real(kind=DP)  :: density_minimum = 1.0d-20
!    real(kind=DP)  :: density_minimum = 1.0d-6
    real(kind=DP)  :: density_minimum = 1.0d-7
!    real(kind=DP)  :: density_minimum = 1.0d-12
  
    Do i = ista_fftph, iend_fftph

       rho  = chgrhr_l(i,1) + chgrhr_l(i,2)
       if ( rho < density_minimum ) cycle

       zeta = ( chgrhr_l(i,1) - chgrhr_l(i,2) ) / rho
       rs   = ( 3.0d0 / PAI4 / rho )**(1.0d0/3.0d0)

       call differential_ec_rs_and_zeta( rs, zeta, dec_drs, dec_dzeta, &
       &                                 d2ec_drs2, d2ec_dzeta2, &
       &                                 d2ec_drs_dzeta )

       c1 = rs /3.0d0

       Do ni=1, nspin
          Do nj=1, nspin
             sgn_i = 3 - 2*ni
             sgn_j = 3 - 2*nj
             ctmp1 = -c1*( 2.0d0/3.0d0 *dec_drs - c1 *d2ec_drs2 &
                  &       -( zeta -sgn_j )*d2ec_drs_dzeta ) / rho
             ctmp2 = -( zeta -sgn_i )*( -c1*d2ec_drs_dzeta &
                  &                     -( zeta -sgn_j )*d2ec_dzeta2 )/rho
             kernel_cr( i,ni,nj ) = ctmp1 + ctmp2
           End Do
        End Do
     End do

  end subroutine kernel_correlation_polarized

  subroutine differential_ec_rs_only( rs, dec_drs, d2ec_drs2 )
    implicit none

    real(kind=DP), intent(in) :: rs
    real(kind=DP), intent(out):: dec_drs
    real(kind=DP), intent(out):: d2ec_drs2

    real(kind=DP) :: eu, deu_1, deu_2

    call derivative_ec_rs_zeta0( rs, eu, deu_1, deu_2 )
  
    dec_drs = deu_1 
    d2ec_drs2 = deu_2

  end subroutine differential_ec_rs_only

  subroutine differential_ec_rs_and_zeta( rs, zeta, dec_drs, dec_dzeta, &
       &                                  d2ec_drs2, d2ec_dzeta2, &
       &                                  d2ec_drs_dzeta )
    implicit none

    real(kind=DP), intent(in) :: rs, zeta
    real(kind=DP), intent(out):: dec_drs, dec_dzeta
    real(kind=DP), intent(out):: d2ec_drs2, d2ec_dzeta2, d2ec_drs_dzeta

    real(kind=DP) :: ctmp1, ctmp2, ctmp3, ctmp4, c1
    real(kind=DP) :: fp2_at_zeta0
    real(kind=DP) :: eu, deu_1, deu_2
    real(kind=DP) :: ep, dep_1, dep_2
    real(kind=DP) :: ac, dac_1, dac_2
    real(kind=DP) :: fzeta, dfzeta_1, dfzeta_2

    fp2_at_zeta0 = 8.0d0/9.0d0 /( 2.0d0**(4.d0/3.d0) - 2.0d0 )

    call derivative_f_zeta( zeta, fzeta, dfzeta_1, dfzeta_2 )
    call derivative_ec_rs_zeta0( rs, eu, deu_1, deu_2 )
    call derivative_ec_rs_zeta1( rs, ep, dep_1, dep_2 )
    call derivative_minusalpha_rs( rs, ac, dac_1, dac_2 )
  
    ctmp1 = zeta**2;             ! zeta**2
    ctmp2 = ctmp1*zeta;          ! zeta**3
    ctmp3 = ctmp2*zeta           ! zeta**4

    c1 = 1.0d0 - ctmp3

    dec_drs = deu_1 - dac_1 *fzeta /fp2_at_zeta0 *c1 &
         &  +( dep_1 - deu_1 ) *fzeta *ctmp3

    dec_dzeta = -ac /fp2_at_zeta0 *( dfzeta_1 *c1 - 4.0d0 *fzeta *ctmp2 ) &
         &  + ( ep - eu )*( dfzeta_1 *ctmp3 + 4.0d0 *fzeta *ctmp2 )

    d2ec_drs2 = deu_2 - dac_2 *fzeta /fp2_at_zeta0 *c1 &
         &  +( dep_2 - deu_2 ) *fzeta *ctmp3

    d2ec_dzeta2 = -ac /fp2_at_zeta0 *( dfzeta_2 *c1 -8.0d0 *dfzeta_1 *ctmp2 &
         &                            - 12.0d0 *fzeta *ctmp1 ) &
         &       +( ep -eu )*( dfzeta_2 *ctmp3 + 8.0d0 *dfzeta_1 *ctmp2 &
         &                    +12.0d0 *fzeta *ctmp1 )

    d2ec_drs_dzeta = -dac_1 /fp2_at_zeta0 *( dfzeta_1 *c1 -4.0d0*fzeta*ctmp2 )&
         &           +( dep_1 -deu_1 )*( dfzeta_1 *ctmp3 &
         &                              + 4.0d0 *fzeta * ctmp2 )

  end subroutine differential_ec_rs_and_zeta

  subroutine derivative_ec_rs_zeta0( rs, ec0, ec1, ec2 )
    implicit none
    
    real(kind=DP), intent(in) :: rs
    real(kind=DP), intent(out):: ec0, ec1, ec2
! --- const
    real(kind=DP), parameter :: p = 1.0d0
    real(kind=DP), parameter :: A  = 0.0310907d0,     alpha1 = 0.21370d0
    real(kind=DP), parameter :: beta1 = 7.5957d0,     beta2  = 3.5876d0
    real(kind=DP), parameter :: beta3 = 1.6382d0,     beta4  = 0.49294d0
! --
    call derivative_G_rs( rs, ec0, ec1, ec2, &
       &                  A, alpha1, beta1, beta2, beta3, beta4, p )

  end subroutine derivative_ec_rs_zeta0

  subroutine derivative_ec_rs_zeta1( rs, ec0, ec1, ec2 )
    implicit none
    
    real(kind=DP), intent(in) :: rs
    real(kind=DP), intent(out):: ec0, ec1, ec2
! --- const
    real(kind=DP), parameter :: p = 1.0d0
    real(kind=DP), parameter :: A  = 0.015545d0,      alpha1 = 0.20548d0
    real(kind=DP), parameter :: beta1 =14.1189d0,     beta2  = 6.1977d0
    real(kind=DP), parameter :: beta3 = 3.3662d0,     beta4  = 0.62517d0
! --
    call derivative_G_rs( rs, ec0, ec1, ec2, &
       &                  A, alpha1, beta1, beta2, beta3, beta4, p )

  end subroutine derivative_ec_rs_zeta1

  subroutine derivative_minusalpha_rs( rs, ac0, ac1, ac2 )
    implicit none
    
    real(kind=DP), intent(in) :: rs
    real(kind=DP), intent(out):: ac0, ac1, ac2
! --- const
    real(kind=DP), parameter :: p = 1.0d0
    real(kind=DP), parameter :: A  = 0.016887d0,      alpha1 = 0.11125d0
    real(kind=DP), parameter :: beta1 =10.357d0,      beta2  = 3.6231d0
    real(kind=DP), parameter :: beta3 = 0.88026d0,    beta4  = 0.49671d0
! --
    call derivative_G_rs( rs, ac0, ac1, ac2, &
       &                  A, alpha1, beta1, beta2, beta3, beta4, p )

  end subroutine derivative_minusalpha_rs

  subroutine derivative_G_rs( rs, g0, g1, g2, &
       &           A, alpha1, beta1, beta2, beta3, beta4, p )
    implicit none

    real(kind=DP), intent(in) :: rs, A, alpha1, p
    real(kind=DP), intent(in) :: beta1, beta2, beta3, beta4
    real(kind=DP), intent(out):: g0, g1, g2

    real(kind=DP) :: ctmp1, ctmp2, ctmp3, ctmp4, ctmp5, ctmp6, ctmp7
    real(kind=DP) :: c1, c2
    real(kind=DP) :: Q0, Q1, Q0p, Q1p, Q1p2

    ctmp1 = rs **(1.0d0/2.0d0 )  ! rs **(1/2)
    ctmp2 = ctmp1 *rs            ! rs **(3/2)
    ctmp3 = ctmp1 /rs            ! rs **(-1/2)   
    ctmp4 = ctmp3 /rs            ! rs **(-3/2)
    ctmp5 = rs **(p+1.0d0)       ! rs **(p+1)
    ctmp6 = ctmp5 / rs           ! rs **(p)
    ctmp7 = ctmp6 / rs           ! rs **(p-1)

    Q0   = -2.0d0 *A *( 1.0d0 + alpha1 *rs )
    Q1   =  2.0d0 *A *( beta1*ctmp1 + beta2*rs + beta3*ctmp2 +beta4*ctmp5 )
    Q1p  =  A *( beta1*ctmp3 + 2.0d0*beta2 + 3.0d0*beta3*ctmp1 &
         &       + 2.0d0*(p+1.0d0)*beta4*ctmp6 )
    Q0p  = -2.0d0 *A *alpha1

    Q1p2 =  A *( -beta1*ctmp4 + 3.0d0*beta3*ctmp3 &
         &        + 4.0d0 *p*(p+1.0d0)*beta4*ctmp7 ) / 2.0d0
    
    c1 = log( 1.0d0 + 1.0d0 /Q1 );   c2 = Q1**2 + Q1
    g0 = Q0 *c1
    g1 = -2.0d0 *A *alpha1 *c1 - Q0 *Q1p / c2

    g2 = 2.0d0 *A *alpha1 *Q1p / c2 -( Q0p*Q1p +Q0*Q1p2 )/c2 &
         & + Q0*( 2.0d0*Q1 + 1.0d0 ) *Q1p**2 / c2**2

  end subroutine derivative_G_rs

  subroutine derivative_f_zeta( zeta, f0, f1, f2 )
    implicit none

    real(kind=DP), intent(in) :: zeta
    real(kind=DP), intent(out):: f0, f1, f2

    real(kind=DP) :: ctmp_p, ctmp_m, denominator
    real(kind=DP) :: cp0, cm0, cp1, cm1, cp2, cm2

    ctmp_p = 1.0d0 + zeta;     ctmp_m = 1.0d0 - zeta

    cp0 = ctmp_p **(4.0d0/3.0d0); cm0 = ctmp_m **(4.0d0/3.0d0)
    cp1 = cp0 / ctmp_p;           cm1 = cm0 / ctmp_m
    cp2 = cp1 / ctmp_p;           cm2 = cm1 / ctmp_m

    denominator = 2.0d0 *(4.0d0/3.0d0) -2.0d0
    
    f0 = ( cp0 + cm0 - 2.0d0 ) / denominator
    f1 = ( cp1 - cm1 ) /denominator;   f1 = f1 *4.0d0/3.0d0
    f2 = ( cp2 + cm2 ) /denominator;   f2 = f2 *4.0d0/9.0d0

  end subroutine derivative_f_zeta

end subroutine calc_kernel_cr_ldapw91

!------------------------------------------------------------------
!!
!!!        Calc Exchange Kernel on the mesh   (GGAPBE96)
!!
!-------------------------------------------------------------------
subroutine calc_kernel_ex_ggapbe( nspin, ispin, chgrhr_l, grad_rho, f2or1, &
     &                            kernel_ex )

  use m_Const_Parameters,  only : PAI, PAI4, DP
  use m_Parallelization,   only : ista_fftph, iend_fftph
  use m_Crystal_Structure, only : univol

  implicit none

  integer,intent(in)        :: nspin,ispin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_fftph:iend_fftph,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_fftph:iend_fftph,nspin)
  real(kind=DP),intent(in)  :: f2or1(ista_fftph:iend_fftph)
  real(kind=DP),intent(out) :: kernel_ex(ista_fftph:iend_fftph,nspin)
!-------------------------
  if ( ispin==1 ) then
     call kernel_exchange_spinless
  else
     call kernel_exchange_polarized
  endif

contains
  
  subroutine kernel_exchange_spinless
    integer        :: is, i
    real(kind=DP)  :: ctmp1, ctmp2

!    real(kind=DP)  :: density_minimum = 1.0d-20
!    real(kind=DP)  :: density_minimum = 1.0d-6
!    real(kind=DP)  :: density_minimum = 1.0d-8
!    real(kind=DP)  :: density_minimum = 1.0d-12
    real(kind=DP)  :: density_minimum = 1.0d-5
!!
    real(kind=DP) :: fac1, fac2, rho, grho, kf, s, exunif
    real(kind=DP) :: Fx, dFx_ds, d2Fx_ds2
    real(kind=DP) :: ds_drho, d2s_drho2
! ------------------------------ start -------------
    fac1 = ( 3.0d0 *PAI**2 )**(1./3.)
    fac2 = -3.0d0 / PAI4
! ---------------------------- main ---------------
    do is = 1, ispin
       do i = ista_fftph, iend_fftph
          if ( chgrhr_l(i,is) < density_minimum ) cycle
          rho = chgrhr_l(i, is)
          grho = grad_rho(i,is)

          kf = fac1 *rho**(1./3.)
          s = grho / 2.0d0 / kf /rho

          exunif = fac2 *kf
          call derivative_Fx_s( s, Fx, dFx_ds, d2Fx_ds2 )
          call derivaitive_s_rho( rho, s, ds_drho, d2s_drho2 )

          kernel_ex(i,is ) = exunif* ( 4.0d0/9.0d0 *Fx /rho &
               &                   + 8.0d0/3.0d0 *ds_drho *dFx_ds &
               &                   + d2s_drho2   *dFx_ds *rho &
               &                   + ds_drho **2 *d2Fx_ds2 *rho )
       End do
    End do
  end subroutine kernel_exchange_spinless

  subroutine kernel_exchange_polarized
    integer        :: is, i
    real(kind=DP)  :: ctmp1, ctmp2

!    real(kind=DP)  :: density_minimum = 1.0d-20
!    real(kind=DP)  :: density_minimum = 1.0d-6
!    real(kind=DP)  :: density_minimum = 1.0d-8
    real(kind=DP)  :: density_minimum = 1.0d-12
!!
    real(kind=DP) :: fac1, fac2, rho, grho, kf, s, exunif
    real(kind=DP) :: Fx, dFx_ds, d2Fx_ds2
    real(kind=DP) :: ds_drho, d2s_drho2
! ---------------------------------start ----------------    
    fac1 = ( 3.0d0 *PAI**2 )**(1./3.)
    fac2 = -3.0d0 / PAI4
! ---------------------------------- main ---------
    do is = 1, ispin
       do i = ista_fftph, iend_fftph
          if ( chgrhr_l(i,is) < density_minimum ) cycle
          rho = chgrhr_l(i, is)*2.0d0
          grho = grad_rho(i,is)*2.0d0

          kf = fac1 *rho**(1./3.)
          s = grho / 2.0d0 / kf /rho

          exunif = fac2 *kf
          call derivative_Fx_s( s, Fx, dFx_ds, d2Fx_ds2 )
          call derivaitive_s_rho( rho, s, ds_drho, d2s_drho2 )

          kernel_ex(i,is ) = exunif* ( 4.0d0/9.0d0 *Fx /rho &
               &                   + 8.0d0/3.0d0 *ds_drho *dFx_ds &
               &                   + d2s_drho2   *dFx_ds *rho &
               &                   + ds_drho **2 *d2Fx_ds2 *rho ) *2.0d0

       End do
    End do
  end subroutine kernel_exchange_polarized

  subroutine derivaitive_s_rho( rho, s, fn1, fn2 )
    Real(kind=DP), intent(in) :: s, rho
    Real(kind=DP), intent(out) ::fn1, fn2

    fn1 = -4.0D0 /3.0D0  * s /rho               ! ds / drho
    fn2 = -7.0D0 /3.0D0  *fn1 /rho          ! d2s / drho2
  end subroutine derivaitive_s_rho

  subroutine derivative_Fx_s( s, fn0, fn1, fn2 )
    Real(kind=DP), intent(in) :: s
    Real(kind=DP), intent(out) ::fn0, fn1, fn2
    
    Real(kind=DP) :: stmp1, c1, c2
    Real(kind=DP) :: kappa, mu
    Parameter( kappa = 0.804D0,  mu = 0.21951D0 )
! --------------------------------------------    
    stmp1 = s*s
    c1 = 1.0D0 + mu *stmp1 / kappa
    c2 = 1.0D0 - 3.0d0 *mu *stmp1 / kappa
    
    fn0 = 1.0D0 + kappa - kappa / c1
    fn1 = 2.0D0 *mu *s /c1**2                         ! dFx / ds
    fn2 = 2.0D0 *mu *c2 /c1**3                        ! d2Fx / ds2
  end subroutine derivative_Fx_s

end subroutine calc_kernel_ex_ggapbe

!------------------------------------------------------------------
!!
!!!        Calc Correlation Kernel on the mesh   (GGAPBE96)
!!
!-------------------------------------------------------------------
subroutine calc_kernel_cr_ggapbe( nspin, ispin, chgrhr_l, grad_trho, f2or1, &
     &                            kernel_cr )
  use m_Const_Parameters,  only : PAI, PAI4, DP
  use m_Parallelization,   only : ista_fftph, iend_fftph
  use m_Crystal_Structure, only : univol

  implicit none

  integer,intent(in)        :: nspin,ispin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_fftph:iend_fftph,ispin)
  real(kind=DP),intent(in)  :: grad_trho(ista_fftph:iend_fftph)
  real(kind=DP),intent(in)  :: f2or1(ista_fftph:iend_fftph)
  real(kind=DP),intent(out) :: kernel_cr(ista_fftph:iend_fftph,nspin,nspin)

! --------------------------------
  Real(kind=DP) :: beta, gamma
  Parameter( beta = 0.066725D0, gamma = 0.031091D0 )
!-------------------------
  if ( ispin==1 ) then
     call kernel_correlation_spinless
  else
     call kernel_correlation_polarized
  endif

contains

  subroutine kernel_correlation_spinless
!    real(kind=DP)  :: density_minimum = 1.0d-20
!    real(kind=DP)  :: density_minimum = 1.0d-6
!    real(kind=DP)  :: density_minimum = 1.0d-8
!    real(kind=DP)  :: density_minimum = 1.0d-12
    real(kind=DP)  :: density_minimum = 1.0d-5
! ---------------
    Real(kind=DP) :: rho, grho, ks, kf, rs, t
    real(kind=DP) :: fac1, fac2
    real(kind=DP) :: ec, dec_drs, d2ec_drs2
    real(kind=DP) :: H, dH_drs_tot, d2H_drs2_tot
    Real(kind=DP) :: c1, ctmp1
! 
    integer       :: i
! ------------------------------ start ---------
    fac1 = ( 3.0d0 *PAI**2 )**(1./3.)
    fac2 = -3.0d0 / PAI4
! ----------------------------- main ------------
    Do i = ista_fftph, iend_fftph
       rho  = chgrhr_l(i,1)
       grho = grad_trho(i)

       if ( rho < density_minimum ) cycle

       kf = fac1 *rho**(1.00/3.0d0)
       ks = ( 4.0d0*kf /PAI )**(1.0d0/2.0d0)
       t = abs(grho) / 2.0d0 / ks /rho
       rs   = ( 3.0d0 / PAI4 / rho )**(1.0d0/3.0d0)

       call differential_ec_rs_only( rs, ec, dec_drs, d2ec_drs2 )
       call differeintial_HPBE_rs_only( rs, t, ec, dec_drs, d2ec_drs2, &
            &                           H, dH_drs_tot, d2H_drs2_tot )

       c1 = rs /3.0d0
       ctmp1 = -c1*( dec_drs + dH_drs_tot - c1*d2ec_drs2 - c1*d2H_drs2_tot )
       kernel_cr( i,1,1 ) = ctmp1 / rho
    End do
  end subroutine kernel_correlation_spinless
  
  subroutine kernel_correlation_polarized
    write(*,*) '!!!!!! Correlation Kernel for GGAPBE96 is not supported '
    stop
  end subroutine kernel_correlation_polarized

  subroutine differeintial_HPBE_rs_only( rs, t, ec, dec_drs, d2ec_drs2, &
       &                                 f0, f1, f2 )
     Real(kind=DP), intent(in) :: rs, t, ec, dec_drs, d2ec_drs2
     Real(kind=DP), intent(out) :: f0, f1, f2

     Real(kind=DP) :: t2, t4, At2, A2t4
     Real(kind=DP) :: dt_drs, d2t_drs2
     Real(kind=DP) :: A, dA_drs, d2A_drs2
!
     Real(kind=DP) :: dH_drs, d2H_drs2, dH_dt, d2H_dt2
     Real(kind=DP) :: d2H_drsdt
     Real(kind=DP) :: kfn, dkfn_drs, d2kfn_drs2
     Real(kind=DP) :: dkfn_dt, d2kfn_dt2
     Real(kind=DP) :: d2kfn_drsdt
!
     Real(kind=DP) :: ctmp1
     Real(kind=DP) :: phi, gphi3
! ----------------------------- experimental---------------------
     Real(kind=DP) :: prefactor1
     prefactor1 = 0.5d0
! ------------------------- start -----------------------------
     phi = 1.0d0;    gphi3 = gamma *phi**3
! -------------------------------------------------------------
     call derivative_t_rs( rs, t, dt_drs, d2t_drs2 )
     call derivative_A_rs( rs, ec, dec_drs, d2ec_drs2, A, dA_drs, d2A_drs2 )
     call derivative_kfunc1_rs_t( rs, t, A, dA_drs, d2A_drs2, &
          &                       kfn, dkfn_drs, d2kfn_drs2, &
          &                       dkfn_dt,  d2kfn_dt2, &
          &                       d2kfn_drsdt ) 
     ctmp1 = 1.0d0 +kfn
! 
     dH_drs = gphi3 * dkfn_drs / ctmp1
     d2H_drs2 = gphi3 *( -dkfn_drs**2 /ctmp1**2 + d2kfn_drs2 /ctmp1 )

     dH_dt = gphi3 *dkfn_dt / ctmp1
     d2H_dt2 = gphi3 *( -dkfn_dt**2 /ctmp1**2 + d2kfn_dt2 /ctmp1 )

     d2H_drsdt = gphi3*( -dkfn_drs *dkfn_dt /ctmp1**2 + d2kfn_drsdt /ctmp1 )
! ---------
     f0  = gphi3 *log( ctmp1 )
     f1 = dH_drs + dt_drs * dH_dt              ! total derivative
     f2 = d2H_drs2 + 2.0d0 *dt_drs *d2H_drsdt &
          & + d2t_drs2 *dH_dt + dt_drs**2 *d2H_dt2 
! ---------------------------- experimental --------
     f2 = f2 + d2t_drs2 *dH_dt *prefactor1            ! naze ? 0.5
! --------------------------------------------------
   end subroutine differeintial_HPBE_rs_only

   subroutine derivative_kfunc1_rs( rs, t, A, dA_drs, d2A_drs2, f0, f1, f2 )
     Real(kind=DP), intent(in) :: rs, t, A, dA_drs, d2A_drs2
     Real(kind=DP), intent(out) :: f0, f1, f2
!
     Real(kind=DP) :: t2, t4, At2, A2t4, A3t6
     Real(kind=DP) :: q1, q2
     Real(kind=DP) :: ctmp1, ctmp2, ctmp3
!----------------------------- start ------------
     t2 = t*t;  t4 = t2**2
     At2 = A *t2;    A2t4 = At2 **2;  A3t6 = A2t4 *At2

     q1 = 1.0D0 + At2;  q2 = q1 + A2t4
! ----
     ctmp1 = beta /gamma *t2
     ctmp2 = t2*( -2.0d0 *At2 - A2t4 )
     ctmp3 = t4*( -2.0d0 + 6.0d0 *A2t4 + 2.0d0*A3t6 )
! ---------------------------------------------
     f0 = ctmp1 * q1/q2
     f1 = ctmp1 *ctmp2 / q2**2 *dA_drs
     f2 = ctmp1 *( ctmp3 /q2**3 *dA_drs**2 + ctmp2 *d2A_drs2 )
   end subroutine derivative_kfunc1_rs

   subroutine derivative_kfunc1_rs_t( rs, t, A, dA_drs, d2A_drs2, &
        &                               kfn, dkfn_drs, d2kfn_drs2, &
        &                               dkfn_dt, d2kfn_dt2, &
        &                               d2kfn_drsdt )
     Real(kind=DP), intent(in) :: rs, t, A, dA_drs, d2A_drs2
     Real(kind=DP), intent(out) :: kfn, dkfn_drs, d2kfn_drs2
     Real(kind=DP), intent(out) :: dkfn_dt, d2kfn_dt2
     Real(kind=DP), intent(out) :: d2kfn_drsdt
!
     Real(kind=DP) :: t2, t4, At2, A2t4, A3t6
     Real(kind=DP) :: q1, q2
     Real(kind=DP) :: ctmp0, ctmp1, ctmp2, ctmp3, ctmp4, ctmp5, ctmp6
! ------------------------- start ----------------------------
     t2 = t*t;  t4 = t2**2
     At2 = A *t2;    A2t4 = At2 **2;  A3t6 = A2t4 *At2
     q1 = 1.0D0 + At2;  q2 = q1 + A2t4
! -------------
     ctmp0 = beta /gamma
     ctmp1 = ctmp0 *t2
     ctmp2 = t2*( -2.0d0 *At2 - A2t4 )
     ctmp3 = t4*( -2.0d0 + 6.0d0 *A2t4 + 2.0d0*A3t6 )
     ctmp4 = t *( 2.0d0 + 4.0d0 *At2 )
     ctmp5 = 2.0d0 + 6.0d0 *At2 - 18.0d0 *A2t4 - 20.0d0*A3t6
     ctmp6 = -12.0d0 *t *( At2 + A2t4 )
! -----------------------
     kfn = ctmp1 * q1/q2
     dkfn_drs = ctmp1 *ctmp2 / q2**2 *dA_drs
     d2kfn_drs2 = ctmp1 *( ctmp3 /q2**3 *dA_drs**2 + ctmp2 /q2**2 *d2A_drs2 )
!
     dkfn_dt = ctmp0 *ctmp4 / q2**2
     d2kfn_dt2 = ctmp0 *ctmp5 / q2**3
!
     d2kfn_drsdt = ctmp1 *ctmp6 / q2**3 *dA_drs
   end subroutine derivative_kfunc1_rs_t

   subroutine derivative_A_rs( rs, ec, dec_drs, d2ec_drs2, f0, f1, f2 )
     Real(kind=DP), intent(in) :: rs, ec, dec_drs, d2ec_drs2
     Real(kind=DP), intent(out) :: f0, f1, f2

     Real(kind=DP) :: c1, c2, c3
     Real(kind=DP) :: ctmp1, ctmp2, ctmp3
     Real(kind=DP) :: phi, gphi3
! ------------------------------ start ------------
     phi = 1.0d0;       gphi3 = gamma * phi
! ---------------------------------------------
     c1 = ec / gphi3
     c2 = exp( -c1 );    c3 = c2 -1.0D0

     ctmp1 = -beta / gamma /c3**2
     ctmp2 = -1.0d0 /gphi3 *c2
     ctmp3 = -2.0d0 *ctmp1 / c3
! --------------------------------------------------
     f0 = beta / gamma /c3            ! value of A
     f1 = ctmp1 *ctmp2 *dec_drs       ! dA/drs
     f2 = ctmp3 *ctmp2**2 *dec_drs**2  &
          & -ctmp1 *ctmp2 /gphi3 *dec_drs**2 &
          & +ctmp1 *ctmp2 *d2ec_drs2 
   end subroutine derivative_A_rs

   subroutine derivative_t_rs( rs, t, f1, f2 )
     Real(kind=DP), intent(in) :: t, rs
     Real(kind=DP), intent(out) :: f1, f2

     f1 = 3.5D0 *t / rs
     f2 = 2.5D0 *f1 /rs
   end subroutine derivative_t_rs

  subroutine differential_ec_rs_only( rs, ec, dec_drs, d2ec_drs2 )
    real(kind=DP), intent(in) :: rs
    real(kind=DP), intent(out):: ec, dec_drs
    real(kind=DP), intent(out):: d2ec_drs2
    
    real(kind=DP) :: eu, deu_1, deu_2

    call derivative_ec_rs_zeta0( rs, eu, deu_1, deu_2 )
    ec = eu;  dec_drs = deu_1;   d2ec_drs2 = deu_2
  end subroutine differential_ec_rs_only

  subroutine derivative_ec_rs_zeta0( rs, ec0, ec1, ec2 )
    real(kind=DP), intent(in) :: rs
    real(kind=DP), intent(out):: ec0, ec1, ec2
! ---------------------------- const -------------------
    real(kind=DP), parameter :: p = 1.0d0
    real(kind=DP), parameter :: A  = 0.0310907d0,     alpha1 = 0.21370d0
    real(kind=DP), parameter :: beta1 = 7.5957d0,     beta2  = 3.5876d0
    real(kind=DP), parameter :: beta3 = 1.6382d0,     beta4  = 0.49294d0
! --
    call derivative_G_rs( rs, ec0, ec1, ec2, &
       &                  A, alpha1, beta1, beta2, beta3, beta4, p )
  end subroutine derivative_ec_rs_zeta0

  subroutine derivative_G_rs( rs, g0, g1, g2, &
       &           A, alpha1, beta1, beta2, beta3, beta4, p )
    implicit none

    real(kind=DP), intent(in) :: rs, A, alpha1, p
    real(kind=DP), intent(in) :: beta1, beta2, beta3, beta4
    real(kind=DP), intent(out):: g0, g1, g2

    real(kind=DP) :: ctmp1, ctmp2, ctmp3, ctmp4, ctmp5, ctmp6, ctmp7
    real(kind=DP) :: c1, c2
    real(kind=DP) :: Q0, Q1, Q0p, Q1p, Q1p2

    ctmp1 = rs **(1.0d0/2.0d0 )  ! rs **(1/2)
    ctmp2 = ctmp1 *rs            ! rs **(3/2)
    ctmp3 = ctmp1 /rs            ! rs **(-1/2)
    ctmp4 = ctmp3 /rs            ! rs **(-3/2)
    ctmp5 = rs **(p+1.0d0)       ! rs **(p+1)
    ctmp6 = ctmp5 / rs           ! rs **(p)
    ctmp7 = ctmp6 / rs           ! rs **(p-1)

    Q0   = -2.0d0 *A *( 1.0d0 + alpha1 *rs )
    Q1   =  2.0d0 *A *( beta1*ctmp1 + beta2*rs + beta3*ctmp2 +beta4*ctmp5 )
    Q1p  =  A *( beta1*ctmp3 + 2.0d0*beta2 + 3.0d0*beta3*ctmp1 &
         &       + 2.0d0*(p+1.0d0)*beta4*ctmp6 )
    Q0p  = -2.0d0 *A *alpha1

    Q1p2 =  A *( -beta1*ctmp4 + 3.0d0*beta3*ctmp3 &
         &        + 4.0d0 *p*(p+1.0d0)*beta4*ctmp7 ) / 2.0d0

    c1 = log( 1.0d0 + 1.0d0 /Q1 );   c2 = Q1**2 + Q1
    g0 = Q0 *c1
    g1 = -2.0d0 *A *alpha1 *c1 - Q0 *Q1p / c2

    g2 = 2.0d0 *A *alpha1 *Q1p / c2 -( Q0p*Q1p +Q0*Q1p2 )/c2 &
         & + Q0*( 2.0d0*Q1 + 1.0d0 ) *Q1p**2 / c2**2
  end subroutine derivative_G_rs

end subroutine calc_kernel_cr_ggapbe

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for calculating exchange kernels on the real grid
!  based on ALDA.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_ALDA

  use m_Const_Parameters,   only : ON, OFF, DP, CMPLDP, DELTA, &
       &                           Partial_Core_Charge, &
       &                           Valence_plus_PC_Charge, &
       &                           TETRAHEDRON, PARABOLIC, &
       &                           GGA, LDA, PAI2, PAI

  use m_Control_Parameters,  only : Num_q_Points, way_of_smearing, neg, &
       &                            ipri, nspin, printable, xctype, kimg

  use m_Kpoints,                    only : kv3_ek, kv3, vkxyz_ek, qwgt_ek, &
       &                                   k_symmetry, np0, np2
  use m_LinearResponse_Control,     only  : nrd_efermi, nstep, e, nmax_G_LR, &
       &                                    vqxyz,  &
       &                                    xc_kernel_type, RPA, ALDA_G, LRC,  &
       &                                    LRC_alpha, sw_NLF, &
       &                                    spectrum_type, OPTICS, EELS, &
       &                                    scissor, eta, &
       &                                    sw_LongWaveLimit

  use m_LinearResponse_tools,  only  : occup_k, occup_kmq, &
       &                                  eko_k, &
       &                                    fsval_k, fsval_kmq, &
       &                                    wfn_k, wfn_kmq, &
       &                                    map_z_k, map_z_kmq, &
       &                                   nbase_k, nbase_kmq, &
       &                                   igf_k, igf_kmq, iba_k, iba_kmq

  use m_LinearResponse_Density,  only : RhoTilde, occup_lkt_ek

  use m_Electronic_Structure,       only : eko_ek
  use m_Crystal_Structure,    only :  rltv, univol

  use m_FFT,                  only : fft_box_size_CD, fft_box_size_CD_c, &
       &                             nfft, nfftp, &
       &                             m_FFT_CD_inverse_c, &
       &                             m_FFT_check_of_negative_CD, &
       &                             m_FFT_CD_direct_c, &
       &                             m_FFT_alloc_CD_box, &
       &                             m_FFT_dealloc_CD_box


#ifdef _MPIFFT_
  use m_FFT,                  only : m_FFT_set_cdata  &
       &                           , lx,ly,lz,ly_d,lz_d, ny_d,nz_d
  use m_PlaneWaveBasisSet,    only : igfp_l_c
#else
  use m_FFT,                  only : m_FFT_alloc_CD_box &
       &                           , m_FFT_dealloc_CD_box
#endif

  use m_Files,                 only : nfout
  use m_PlaneWaveBasisSet,    only : ngabc, igf, kg1,kg, igfp_l, kgp

  use m_Parallelization,      only : ista_kngp,iend_kngp,npes,mype, ierr, &
       & npes_cdfft, nrank_ggacmp, myrank_cdfft, &
       & myrank_ggacmp, ista_fftp, iend_fftp, ista_fftph, iend_fftp, &
       & nis_fftp, nie_fftp, nel_fftp, idisp_fftp,np_fftp,mp_fftp,  &
       & nel_fftph, idisp_fftph, nrest_cdfft, &
       & mpi_ggacmp_cross_world,mpi_cdfft_world, &
       & map_ggacmp, map_pe2ggacmp, map_pe2cdfft, mpi_comm_group, &
       & ista_fftph, iend_fftph, &
       & np_e, ista_k, iend_k, map_e, map_z, myrank_e

  use m_Charge_Density,        only : chgq_l
  use m_XC_Potential,         only : check_of_xctype
  use m_Ionic_System,         only : ntyp,natm,iwei,ityp,pos,zfm3_l
  use m_PseudoPotential,      only : itpcc,ilmt,ltp,taup,il2p,isph,iqitg, &
       & rhpcg_l, qitg_l,rhpcg_diff_l,qitg_diff_l,dl2p, &
       & m_PP_include_vanderbilt_pot, m_PP_find_maximum_l,nlmt

  use m_Timing,               only : tstatc0_begin, tstatc0_end
  

  use m_PlaneWaveBasisSet,    only : kg0, nbase
  use m_FFT,                  only : fft_box_size_WF, &
       &                             m_FFT_alloc_wf_work, &
       &                             m_FFT_dealloc_wf_work, m_FFT_wf
  use m_Const_Parameters,     only : DIRECT, ELECTRON

  use m_LinearResponse_tools,  only  : Get_WF_in_Rspace, Get_WF_in_Rspace_CD, &
       &                               fsval_k, fsval_kmq

  use m_Const_Parameters,      only : PAI4, BUCS, Bohr
  use m_IterationNumbers,     only : nk_in_the_process

  use m_Electronic_Structure,  only : zaj_l
  use m_Const_Parameters ,    only : INVERSE, DIRECT, OFF, GAMMA

  use m_LinearResponse_NonInt,   only : nband_LR, band_start_LR, band_end_LR
!
  use m_LinearResponse_Control,  only : sw_Fxc_enhanced
!
  implicit none
  include 'mpif.h'

! --------------------------- public -------------
  integer, allocatable :: igfp_LR(:)                ! d(kgp)
! -------------
  real(kind=DP), allocatable :: ker_ex(:,:), ker_cr(:,:,:)
  real(kind=DP), allocatable :: ker_xc_triplet(:,:,:),  ker_xc_singlet(:,:,:)
  real(kind=DP), allocatable :: zcos_LR(:), zsin_LR(:)
! ----------------------------------------- DYSON && ALDA_R ---
  Complex(kind=CMPLDP), allocatable :: MatrixT(:,:,:,:)
  Complex(kind=CMPLDP), allocatable :: MatrixG(:,:,:,:,:)
!                                  Matrix G =  RhoTilde * Fxc
! ---------------------------- temporary ----------
  real(kind=DP), allocatable,dimension(:):: afft     ! d(ista_fftp:iend_fftp)
! 
  real(kind=DP), private, allocatable, dimension(:,:)  :: chden_l    
  real(kind=DP), private, allocatable, dimension(:,:)  :: grad_rho
  real(kind=DP), private, allocatable, dimension(:)  :: grad_trho
#ifndef _XC_SAVE_MEMORY_
  real(kind=DP),private,allocatable,dimension(:,:,:):: cgrad_rho ! MPI d(ista_fftph:iend_fftph,3,nspin)
#else
  real(kind=DP),private,allocatable,dimension(:):: cggawk13 ! MPI d(ista_fftph:iend_fftph)
#endif
! -----------------------
  real(kind=DP),private,pointer,dimension(:,:)  :: chgrhr_l    ! MPI d(ista_fftph:iend_fftph,ispin)
! GGA arrays
  integer, private,allocatable,dimension(:)   :: inx,jnx,knx ! MPI d(ista_fftp:iend_fftp
  real(kind=DP),private, pointer, dimension(:)   :: f2or1 ! MPI d(ista_fftph,iend_fftph)
  logical,      private, dimension(3)               :: lmn_even

  integer istatus( mpi_status_size )

! ------------
contains

!------------------------------------------------------------------
!!
!!!            Alloc and Dealloc Kernels evaluated on R-space
!!
!-------------------------------------------------------------------
  subroutine m_LR_alloc_RKernels_ALDA
    Allocate( ker_ex( ista_fftph:iend_fftph,nspin ) ); ker_ex = 0.0d0
    Allocate( ker_cr( ista_fftph:iend_fftph,nspin,nspin ) ); ker_cr = 0.0d0
  end subroutine m_LR_alloc_RKernels_ALDA

  subroutine m_LR_dealloc_RKernels_ALDA
    deallocate( ker_ex, ker_cr )
  end subroutine m_LR_dealloc_RKernels_ALDA

  subroutine m_LR_alloc_phase_factor
    Allocate( zcos_LR(ista_fftph:iend_fftph) );  zcos_LR = 0.0d0
    Allocate( zsin_LR(ista_fftph:iend_fftph) );  zsin_LR = 0.0d0
  end subroutine m_LR_alloc_phase_factor

  subroutine m_LR_dealloc_phase_factor
    Deallocate( zcos_LR, zsin_LR )
  end subroutine m_LR_dealloc_phase_factor

!------------------------------------------------------------------
!!
!!!            Alloc and Dealloc in the case of DYSON && ALDA_R
!!
!-------------------------------------------------------------------
  subroutine m_LR_alloc_Matrix_G
    if ( sw_LongWaveLimit == OFF ) then
       Allocate( MatrixG( kg1, neg, np_e, kv3_ek/(Num_q_Points+1), nspin ) )
    else
       Allocate( MatrixG( kg1, neg, np_e, kv3_ek, nspin ) )
    endif
  end subroutine m_LR_alloc_Matrix_G

  subroutine m_LR_dealloc_Matrix_G
    Deallocate( MatrixG )
  end subroutine m_LR_dealloc_Matrix_G

  subroutine m_LR_alloc_Matrix_T
    if ( mype == 0 ) then
       allocate( MatrixT( nmax_G_LR, nmax_G_LR, nspin, nspin ) )
       MatrixT = 0.0d0
    endif
  end subroutine m_LR_alloc_Matrix_T

  subroutine m_LR_dealloc_Matrix_T
    if ( mype == 0 ) deallocate( MatrixT )
  end subroutine m_LR_dealloc_Matrix_T

!-------------------------------------------------------
!!
!!!       igfp for LR 
!!
!--------------------------------------------------------
  subroutine m_LR_alloc_igfp
    allocate( igfp_LR(kgp) ); igfp_LR = 0
  end subroutine m_LR_alloc_igfp

  subroutine m_LR_dealloc_igfp
    deallocate( igfp_LR )
  end subroutine m_LR_dealloc_igfp

  subroutine m_LR_set_igfp
    integer, allocatable     :: igfp_tmp(:)

    if ( npes > 1 ) then
       allocate( igfp_tmp(kgp) ); igfp_tmp = 0
       igfp_tmp( ista_kngp:iend_kngp ) = igfp_l( ista_kngp:iend_kngp )
       call mpi_allreduce( igfp_tmp, igfp_LR, kgp, mpi_integer, mpi_sum, &
            &              mpi_comm_group, ierr )
       deallocate( igfp_tmp )
    else
       igfp_LR( ista_kngp:iend_kngp ) = igfp_l( ista_kngp:iend_kngp )
    endif
  end subroutine m_LR_set_igfp

!--------------------------------------------------------
!!
!!!        Matrix T  ( DYSON && ALDA_R ) in the case of Q > 0
!!
!---------------------------------------------------------
  subroutine Calc_MatrixT_General( e_value )       
    real(kind=DP), intent(in) :: e_value

    integer               :: i,j, k, ispin, jspin
    integer               :: ik1, ik2, ik3, ib1, ib2
    integer               :: k_max, nq_max

    real(kind=DP)         :: occ1, occ2, weight
    complex(kind=CMPLDP)  :: omega1, omega2, ztmp
! 
    integer :: id_sname = -1
! -------------------------------- start -----------
    call tstatc0_begin('Calc_MatrixT ', id_sname)

    nq_max = Num_q_points
    call set_value_kmax
    omega1 = cmplx( e_value, eta );  omega2 = cmplx( e_value, -eta ); 
! --
    if ( mype == 0) MatrixT = 0.0d0
! --------------------------------- main ----------
    Do i=1, nmax_G_LR
       Do j=1, nmax_G_LR

          Do ispin=1, nspin
             Do jspin=1, nspin
                ztmp = 0.0d0

                Do k=1, k_max
                   ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
                   ik2 = ik1 + nspin
                   ik3 =  nspin*(k-1) + ispin 
                
                   weight = qwgt_ek(ik1) *nspin

                   Do ib1=band_start_LR, band_end_LR      ! unoccpuied state
                      occ1 = Occup_lkt_ek( ib1, ik1 );  
                      if ( occ1 > DELTA ) cycle
                      
                      Do ib2=band_start_LR, band_end_LR     ! occupied state
                         occ2 = Occup_lkt_ek( ib2, ik2 )  
                         if ( occ2 < DELTA ) cycle
                         if ( map_e(ib2) /= myrank_e ) cycle
                         
                         call summation_ztmp
                      End do
                   End do
                End do
                call add_ztmp_to_MatrixT
             End do
          End do
       End do
    End do
!! ----------------------------- end ------------
    if ( mype == 0 ) then
       if ( nspin==1 ) MatrixT = MatrixT *2.0d0
!!    if ( nspin==1 ) MatrixT = MatrixT *2.0d0 * 2.0d0
    endif
    call tstatc0_end(id_sname)

  contains

    subroutine set_value_kmax
      if ( way_of_smearing == TETRAHEDRON ) then
         k_max = np2
      else
         k_max = kv3_ek / ( nspin*( nq_max + 1 ))
      endif
    end subroutine set_value_kmax

    subroutine summation_ztmp
      integer :: jb2
      Real(kind=DP) :: ebi, ebj, ediff, c1
      Complex(kind=CMPLDP) :: zd1, zd2, z1, z2, gfn

      jb2 = map_z(ib2)

      ebi = Eko_ek( ib1,ik1 ); ebj = Eko_ek( ib2,ik2 )
      ediff = ebi - ebj + scissor

      zd1 = omega1 - ediff;  zd2 = omega2 + ediff
      gfn = 1.0d0 / zd1 - 1.0d0 / zd2

      z1 = RhoTilde( i, ib1, jb2, ik3 )
      z2 = MatrixG( j, ib1, jb2,  ik3, jspin )
!
      c1 = ( 1.0D0 - occ1 ) *occ2
!      ztmp = ztmp + c1 *conjg( z1 )* z2 *gfn *weight
      ztmp = ztmp + c1 *z1 * z2 *gfn *weight
    end subroutine summation_ztmp

    subroutine add_ztmp_to_MatrixT
      Complex(kind=CMPLDP) :: zsum

      if ( npes > 1 ) then
         call mpi_allreduce( ztmp, zsum, 2, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, mpi_comm_group, ierr )
         ztmp = zsum
      endif
      if ( mype == 0 ) MatrixT( i,j,ispin,jspin ) = ztmp / univol
    end subroutine add_ztmp_to_MatrixT

  end subroutine Calc_MatrixT_General

!--------------------------------------------------------
!!
!!!        Matrix T  ( DYSON && ALDA_R ) in the case of LongWaveLimit
!!
!---------------------------------------------------------
  subroutine Calc_MatrixT_LWLimit( e_value )
    real(kind=DP), intent(in) :: e_value

    integer               :: i,j, k, ispin, jspin
    integer               :: ik1, ik2, ik3, ib1, ib2
    integer               :: k_max, nq_max
    real(kind=DP)         :: occ1, occ2, weight
    complex(kind=CMPLDP)  :: omega1, omega2, ztmp
! ----
    integer :: id_sname = -1
! ------------------------------- start ---------
    call tstatc0_begin('Calc_MatrixT_LWLimit ', id_sname)
!
    nq_max = 0
    call set_value_kmax
    omega1 = cmplx( e_value, eta );  omega2 = cmplx( e_value, -eta ); 
! --
    if ( mype == 0 ) MatrixT = 0.0d0
! ------------------------------ main -----------------
    Do i=1, nmax_G_LR
       Do j=1, nmax_G_LR
           
          Do ispin=1, nspin
             Do jspin=1, nspin
                ztmp = 0.0d0

                Do k=1, k_max
                   ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
                   ik2 = ik1 + nspin
                   ik3 =  nspin*(k-1) + ispin 
                !
                   weight = qwgt_ek(ik1) *nspin

                   Do ib1=band_start_LR, band_end_LR         ! unoccpuied state
                      occ1 = Occup_lkt_ek( ib1, ik1 );  
                      if ( occ1 > DELTA ) cycle
                      
                      Do ib2=band_start_LR, band_end_LR         ! occupied state
                         occ2 = Occup_lkt_ek( ib2, ik1 )  
                         if ( occ2 < DELTA ) cycle
                         if ( map_e(ib2) /= myrank_e ) cycle

                         call summation_ztmp
                      End do
                   End do
                End do
                call add_ztmp_to_MatrixT
             End do
          End do
       End do
    End do
!! ----------------------------- end ------------
    if ( mype == 0 ) then
       if ( nspin==1 ) MatrixT = MatrixT *2.0d0
!!    if ( nspin==1 ) MatrixT = MatrixT *2.0d0 * 2.0d0
    endif
!    MatrixT = 0.0d0
    call tstatc0_end(id_sname)

  contains

    subroutine set_value_kmax
      if ( way_of_smearing == TETRAHEDRON ) then
         k_max = np2
      else
         k_max = kv3_ek / ( nspin*( nq_max + 1 ))
      endif
    end subroutine set_value_kmax

    subroutine summation_ztmp
      integer       :: jb2
      Real(kind=DP) :: ebi, ebj, ediff, c1
      Complex(kind=CMPLDP) :: zd1, zd2, z1, z2, gfn

      jb2 = map_z(ib2)

      ebi = Eko_ek( ib1,ik1 ); ebj = Eko_ek( ib2,ik1 )
      ediff = ebi - ebj + scissor
      
      zd1 = omega1 - ediff;  zd2 = omega2 + ediff
      gfn = 1.0d0 / zd1 - 1.0d0 / zd2

      z1 = RhoTilde( i, ib1, jb2, ik3 )
      z2 = MatrixG(  j, ib1, jb2, ik3, jspin )

      c1 = ( 1.0D0 - occ1 ) *occ2
      ztmp = ztmp + c1 *conjg( z1 )* z2 *gfn *weight
!!!!!!      ztmp = ztmp + c1 * z1 * z2 *gfn *weight
    end subroutine summation_ztmp

    subroutine add_ztmp_to_MatrixT
      Complex(kind=CMPLDP) :: zsum

      if ( npes > 1 ) then
         call mpi_allreduce( ztmp, zsum, 2, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, mpi_comm_group, ierr )
         ztmp = zsum
      endif
      if ( mype == 0 ) MatrixT( i,j,ispin,jspin ) = ztmp / univol
    end subroutine add_ztmp_to_MatrixT

  end subroutine Calc_MatrixT_LWLimit

!--------------------------------------------------------
!!
!!!        Matrix G   ( DYSON && ALDA_R ) in the case of Q > 0
!!
!---------------------------------------------------------
  subroutine Add_SoftPart_MatG_General
    Real(kind=DP), allocatable :: wf1(:), wf2(:), chg1r(:), chg1i(:)
    Real(kind=DP), allocatable :: wf2_mpi(:), wf_tmp(:)
    
    Real(kind=DP) :: occ1, occ2
    integer ngrid, nffth, nfftph
    integer ik, jk
    integer ib1, ib2
    integer :: id_sname = -1
! --------------------------- start ----------
    call tstatc0_begin('Add_SoftPart_MatG_General', id_sname)
! 
    ngrid = product(fft_box_size_CD(1:3,1))
    nffth  = nfft/2;    nfftph = nfftp/2
    call m_FFT_alloc_CD_box()
    call set_work_arrays()
! ---------------------------- main ------------------      
    Do ik=1, kv3
       
       Do ib1=1, neg                  ! unOccupied Band
          
          if ( nrd_efermi ==1 ) then
             occ1 = occup_k( ib1,ik )
             if ( occ1 > DELTA ) cycle
          endif
          call set_wf1()
          
          Do ib2=1, neg                ! occupied Band
             
             if ( nrd_efermi==1 ) then
                occ2 = occup_kmq( ib2,ik )
                if ( occ2 < DELTA ) cycle
             end if
             call set_wf2

             Do jk=1, kv3              ! kv3 should be equal to nspin
                call set_chg1
                call set_each_element_in_MatG
             End do
          End do
       End do
    End do
! -----------------------------------end --------------------
    call unset_work_arrays
    call m_FFT_dealloc_CD_box()
    call tstatc0_end(id_sname)

  contains

    subroutine set_work_arrays
      allocate( wf1(ista_fftp:iend_fftp) ); wf1 = 0.0d0
      allocate( wf2(ista_fftp:iend_fftp) ); wf2 = 0.0d0
      allocate( chg1r(ista_fftph:iend_fftph) ); chg1r = 0.0d0
      allocate( chg1i(ista_fftph:iend_fftph) ); chg1i = 0.0d0
      allocate( wf2_mpi(nfftp) ); wf2_mpi= 0.0d0
      if ( npes > 1 ) then
         allocate( wf_tmp(nfftp) ); wf_tmp = 0.0d0
      endif
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      deallocate( wf1, wf2 ); deallocate( chg1r, chg1i )
      deallocate( wf2_mpi )
      if ( npes > 1 ) deallocate( wf_tmp )
    end subroutine unset_work_arrays

    subroutine set_wf1()
      call  Get_WF_in_Rspace_CD( ik, ib1, wfn_k, wf1, &
           &                     nbase_k, iba_k, igfp_LR, map_z_k )
      wf1 = wf1 / sqrt(univol)
    end subroutine set_wf1

    subroutine set_wf2()
      call  Get_WF_in_Rspace_CD( ik, ib2, wfn_kmq, wf2, &
           &                     nbase_kmq, iba_kmq, igfp_LR, map_z_kmq )
      wf2 = wf2 / sqrt(univol)
    end subroutine set_wf2

    subroutine set_chg1()
      integer :: i, ip

      Do i=ista_fftph, iend_fftph
         ip = 2*i-1
         chg1r(i) = wf1(ip) *wf2(ip)   + wf1(ip+1) *wf2(ip+1)
         chg1i(i) = wf1(ip) *wf2(ip+1) - wf1(ip+1) *wf2(ip)
      End do
    end subroutine set_chg1

    subroutine set_each_element_in_MatG
      integer :: i, ip, ri
      integer :: ic1, jb2
      Real(kind=DP) :: weight

      Do i=ista_fftph,iend_fftph
         ip = 2*i-1
         weight = ker_cr( i,ik,jk )
         chg1r(i) =  weight *chg1r(i);   chg1i(i) =  weight *chg1i(i)
      End do
      wf2 = 0.0d0
      do i=ista_fftph,iend_fftph
         ip = 2*i-1
         wf2(ip)   =  chg1r(i);  wf2(ip+1) =  chg1i(i)
      end do
      call m_FFT_CD_direct_c( nfout, wf2 )   !  Rspace -> G-space 
!--
      wf2_mpi = 0.0d0
      wf2_mpi(ista_fftp:iend_fftp) = wf2(ista_fftp:iend_fftp) / dble(ngrid) *univol
      if ( npes > 1 ) then
         call mpi_allreduce( wf2_mpi, wf_tmp, nfftp, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, mpi_comm_group, ierr )
         wf2_mpi = wf_tmp
      endif
! --------------------
      if ( map_e(ib2) == myrank_e ) then
         jb2 = map_z_k(ib2)

         ic1 = ( nk_in_the_process -1 )/ ( nspin*(Num_q_Points+1) )
         Do i=1, iba_k(ik)
            ip = 2 *igfp_LR( nbase_k(i,ik) ) -1
            MatrixG( i, ib1,jb2, ik +ic1*nspin, jk ) &
                 &     = dcmplx( wf2_mpi(ip), wf2_mpi(ip+1) )
!               MatrixG( i, ib1,jb2, ik +ic1*nspin, jk ) &
!                    &     = dcmplx( wf2_mpi(ip), -wf2_mpi(ip+1) )
         Enddo
      endif
    end subroutine set_each_element_in_MatG

  end subroutine Add_SoftPart_MatG_General

!--------------------------------------------------------
!!
!!!        Matrix G   ( DYSON && ALDA_R ) in the case of LongWaveLimit
!!
!---------------------------------------------------------
  subroutine Add_SoftPart_MatG_LWLimit
    Real(kind=DP), allocatable :: wf1(:), wf2(:), chg1r(:), chg1i(:)
    Real(kind=DP), allocatable :: wf2_mpi(:), wf_tmp(:)

    Real(kind=DP) ::  occ1, occ2
    integer ngrid, nffth, nfftph
    integer ik, jk
    integer ib1, ib2
    integer :: id_sname = -1
!
    integer iii
! ------------------------------ start -------------
    call tstatc0_begin('Add_SoftPart_MatG_LWLimit ', id_sname)
! -
    ngrid = product(fft_box_size_CD(1:3,1))
    nffth  = nfft/2;    nfftph = nfftp/2
    call m_FFT_alloc_CD_box()
    call set_work_arrays()
! ------------------------------- main --------------      
    Do ik=1, kv3
       
       Do ib1=1, neg               ! unOccupied Band
          
          if ( nrd_efermi ==1 ) then
             occ1 = occup_k( ib1,ik )
             if ( occ1 > DELTA ) cycle
          endif
          call set_wf1()
!            Do iii=1, nfftp
!               write(*,*) ' wf1 i ', iii, wf1(iii)
!            End Do
!            stop

          Do ib2=1, neg                ! occupied Band
             
             if ( nrd_efermi==1 ) then
                occ2 = occup_k( ib2,ik )
                if ( occ2 < DELTA ) cycle
             end if
             call set_wf2

             Do jk=1, kv3              ! kv3 should be equal to nspin
                call set_chg1
                call set_each_element_in_MatG
             End do
          End do
       End do
    End do
! ------------------------------end ---------------
    call unset_work_arrays
    call m_FFT_dealloc_CD_box()
    call tstatc0_end(id_sname)

      Do jk=1, nmax_G_LR
         Do ib1=1, neg
            Do ib2=1, neg
               write(*,*) 'AA A ', jk, ib1, ib2, MatrixG( jk,ib1,ib2,1,1)
            End Do
         End Do
      End do
      stop
! ------------

  contains

    subroutine set_work_arrays()
      allocate( wf1(ista_fftp:iend_fftp) ); wf1 = 0.0d0
      allocate( wf2(ista_fftp:iend_fftp) ); wf2 = 0.0d0
      allocate( chg1r(ista_fftph:iend_fftph) ); chg1r = 0.0d0
      allocate( chg1i(ista_fftph:iend_fftph) ); chg1i = 0.0d0
      allocate( wf2_mpi(nfftp) ); wf2_mpi= 0.0d0
      if ( npes > 1 ) then
         allocate( wf_tmp(nfftp) ); wf_tmp = 0.0d0
      endif
    end subroutine set_work_arrays

    subroutine unset_work_arrays()
      deallocate( wf1, wf2 ); deallocate( chg1r, chg1i )
      deallocate( wf2_mpi )
      if ( npes > 1 ) deallocate( wf_tmp )
    end subroutine unset_work_arrays

    subroutine set_wf1
      call  Get_WF_in_Rspace_CD( ik, ib1, wfn_k, wf1, &
           &                     nbase_k, iba_k, igfp_LR, map_z_k )
    end subroutine set_wf1

    subroutine set_wf2
      call  Get_WF_in_Rspace_CD( ik, ib2, wfn_k, wf2, &
           &                     nbase_k, iba_k, igfp_LR,  map_z_k )
      wf2 = wf2 / sqrt(univol)
    end subroutine set_wf2

    subroutine set_chg1
      integer :: i, ip

      Do i=ista_fftph, iend_fftph
         ip = 2*i-1
         chg1r(i) = wf1(ip) *wf2(ip)   + wf1(ip+1) *wf2(ip+1)
         chg1i(i) = wf1(ip) *wf2(ip+1) - wf1(ip+1) *wf2(ip)
      End do
    end subroutine set_chg1

    subroutine set_each_element_in_MatG
      integer :: i, ip, ri
      integer :: ic1, jb2
      Real(kind=DP) :: weight

      Do i=ista_fftph,iend_fftph
         ip = 2*i-1
         weight = ker_cr( i,ik,jk )
         chg1r(i) =  weight *chg1r(i);   chg1i(i) =  weight *chg1i(i)
      End do
      wf2 = 0.0d0
      do i=ista_fftph,iend_fftph
         ip = 2*i-1
         wf2(ip)   =  chg1r(i);  wf2(ip+1) =  chg1i(i)      
      end do
      call m_FFT_CD_direct_c( nfout, wf2 )   !  Rspace -> G-space 
!--
      wf2_mpi = 0.0d0
      wf2_mpi(ista_fftp:iend_fftp) = wf2(ista_fftp:iend_fftp) / dble(ngrid) *univol
      if ( npes > 1 ) then
         call mpi_allreduce( wf2_mpi, wf_tmp, nfftp, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, mpi_comm_group, ierr )
         wf2_mpi = wf_tmp
      endif
! --------------------
      if ( map_e(ib2) == myrank_e ) then
         jb2 = map_z_k(ib2)

         ic1 = ( nk_in_the_process -1 )/ nspin
         Do i=1, iba_k(ik)
            ip = 2 *igfp_LR( nbase_k(i,ik) ) -1
            MatrixG( i, ib1,jb2, ik +ic1*nspin, jk ) &
                 &     = dcmplx( wf2_mpi(ip), wf2_mpi(ip+1) )
!            MatrixG( i, ib1,jb2, ik +ic1*nspin, jk ) &
!                 &     = dcmplx( wf2_mpi(ip), -wf2_mpi(ip+1) )
         Enddo
      endif
    end subroutine set_each_element_in_MatG

  end subroutine Add_SoftPart_MatG_LWLimit
  
!-----------------------------------------------------
!!
!!!          phase factor 
!!
!------------------------------------------------------
  subroutine calc_phase_factor
    integer i, ip, ngrid
    Real(kind=DP) :: ph, da(3), tmp_vec(3)
!
    ngrid = product( fft_box_size_CD(1:3,1) )
    da(1:3) = 1.d0 / fft_box_size_CD(1:3,1)
!
    write(*,*) 'UUUU', da(1), da(2), da(3)
!    stop
    Do i = ista_fftph, iend_fftph
       ip = 2*i - 1
        write(*,*) 'ZZZ', i
       tmp_vec(1) = dble( inx(ip) ) *da(1)
       tmp_vec(2) = dble( jnx(ip) ) *da(2)
       tmp_vec(3) = dble( knx(ip) ) *da(3)
!         write(*,*) 'YY', ip, inx(ip), jnx(ip), knx(ip)
!         write(*,*) 'YY', ip, tmp_vec(1), tmp_vec(2), tmp_vec(3)

       ph = -PAI2 * dot_product( vqxyz(1,:,BUCS), tmp_vec(:) )
       zcos_LR(i) = cos(ph);      zsin_LR(i) = sin(ph)
    End do
  end subroutine calc_phase_factor

  subroutine set_ispin_kt(ispin, input_Charge )
    integer, intent(out) :: ispin
    integer, intent(in)  :: input_Charge
    if( nspin == 2 .and. input_charge == Valence_plus_PC_Charge ) then
       ispin = 2
    else
       ispin = 1
    endif
  end subroutine set_ispin_kt

  subroutine Calc_Density_in_Rspace(ispin, input_Charge )
    integer, intent(in) :: ispin, input_Charge

    integer :: iloop
    integer jj
    Real(kind=DP) :: csum

    Do iloop = 1, ispin
       if(ipri >= 2) write(nfout,'(" ! (m_XC_cal_potential) , iloop = ",i5)') iloop
#ifdef _OLD_MAP_CHARGE_
       call map_charge_onto_a_fft_box(chgq_l)     !-(m_XC_Pot.) -> afft(*) (xcchg2)
#else
       call map_charge_onto_a_fft_box2(nfout,chgq_l)    !-(m_XC_Pot.) -> afft(*) (xcchg2)
#endif
       if(ipri >= 2) then
          write(nfout,'(" ista_fftp, iend_fftp, np_fftp, mp_fftp = ",4i8)' ) &
               & ista_fftp, iend_fftp, np_fftp, mp_fftp
       end if
       if (check_of_xctype() == GGA) then
          chden_l(ista_fftp:iend_fftp,iloop) = afft(ista_fftp:iend_fftp)
       end if

       if(myrank_ggacmp < nrank_ggacmp) then
!          write(*,*) 'DEBUG A', myrank_ggacmp, nrank_ggacmp, afft(1)*univol
          call m_FFT_CD_inverse_c(nfout,afft)  ! afft(G_sp.) -> afft(R_sp.)
          call m_FFT_check_of_negative_CD(npes_cdfft,ista_fftp,iend_fftp&
               & ,ista_fftph,iend_fftph,afft,nfout,nspin,iloop)
       end if
       if(ipri >= 2) write(nfout,'(" ! out of m_FFT_check_of_negative_CD <<m_XC_cal_potential>>")')
       call cp_afft_to_chgrhr    ! -(contained here) afft -> chgrhr_l
    End do
! ------------------------ check --
!    csum = 0.0d0
!    Do jj=1, nfftp /2
!       csum = csum + chgrhr_l(jj,1)
!    End do
!    write(*,*) 'csum = ', csum, csum * univol / dble(nfftp/2)
!    stop                       ! csum *univol /(nffph) == Nelec
! ------------------------------ gga -----
    call check_lmn_even  ! -(contained in subr. m_XC_cal_potential) ->lmn_even

    if(xctype == 'ldapw91' .or. xctype == 'ldapbe ') then
       grad_rho = 0.d0; grad_trho = 0.d0
#ifndef _XC_SAVE_MEMORY_
       cgrad_rho = 0.d0
#endif
    else
       call abs_grad_rho_up_down_total(ispin)
      !   chden_l ->
      !   |grad(rho_up(r))|,|grad(rho_down(r))|  --> grad_rho
      !   |grad(rho_up(r) + rho_down(r))|        --> grad_trho
    end if
! ----------------------------------------------
    !
   contains
    
    subroutine cp_afft_to_chgrhr
      integer  :: i

      if(myrank_ggacmp < nrank_ggacmp) then
         do i = ista_fftph, iend_fftph    ! MPI
            chgrhr_l(i,iloop) = afft(i*2-1)
         end do
      else
         do i = ista_fftph, iend_fftph    ! MPI
            chgrhr_l(i,iloop) = 0.d0
         end do
      end if

      if(ipri >= 2) then
         write(nfout,'(" !XC -- chgrhr_l -- <<cp_afft_to_chgrhr>>")')
         write(nfout,'(" !XC ",6f12.6)') (chgrhr_l(i,1),i=ista_fftph,ista_fftph+17)
         write(nfout,'(" !XC -- afft --     <<cp_afft_to_chgrhr>>")')
         write(nfout,'(" !XC ",6f12.6)') (afft(i*2-1),i=ista_fftph,ista_fftph+17)
      end if
    end subroutine cp_afft_to_chgrhr

    subroutine map_charge_onto_a_fft_box2(nfout,chgq_l)
      integer, intent(in) :: nfout
      real(DP),intent(in) :: chgq_l(ista_kngp:iend_kngp,kimg,nspin)
      real(kind=DP)      :: fac
      integer            :: mm, it, i, j
      real(kind=DP),allocatable,dimension(:)    :: tmp_s, tmp_r ! MPI d(nfftp/npes)
      real(kind=DP),allocatable,dimension(:,:)  :: chgqplus_l ! MPI d(ista_kngp:iend_kngp)
      integer, allocatable, dimension(:)        :: ip ! d(ista_kngp:iend_kngp,3)
      integer, allocatable, dimension(:)        :: igfp_s, igfp_r ! d(nfftp/npes)
      integer, allocatable, dimension(:,:)      :: igfp_ijk ! d(ista_kngp:iend_kngp+(0,1),3)
      integer, allocatable, dimension(:)        :: ipout_s, ipout_r ! d(nfftp/npes)
      integer, allocatable, dimension(:)        :: np ! d(0:npes_cdfft-1)
      integer, allocatable, dimension(:,:)      :: np_send, np_tmp ! d(ista_kngp:iend_kngp,npes)
      integer :: pe_s, pe_r, datasize_s, datasize_r, nfp, igp, nb, npc, maxdatasize
      integer :: nstart, nend, lx, lxy, ipout, j0, k, l, np0, idp, icdfft
      integer, allocatable, dimension(:) :: req_r,req_s
      
      integer :: id_sname = -1
      call tstatc0_begin('map_charge_onto_a_fft_box2 ',id_sname)

      allocate(chgqplus_l(ista_kngp:iend_kngp,kimg))

      if(input_charge == Valence_plus_PC_Charge) then
         fac = 1.d0/nspin
      else if(input_charge == Partial_Core_Charge) then
         fac = 1.d0
      else
        stop ' Error of ixc in <<<map_charge_onto_a_fft_box2>>>'
      endif

      chgqplus_l = 0.d0
      mm = 0
      do it = 1, ntyp
         if(itpcc(it) == 0) cycle
         mm = mm + 1
         do j = 1, kimg
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
!CDIR INNER
#endif
            do i = ista_kngp, iend_kngp  !for mpi
               chgqplus_l(i,j) = chgqplus_l(i,j) &
                    & + fac*zfm3_l(i,it,j)*rhpcg_l(i,mm)   !mpi
            end do
         end do
      end do

      if(input_charge == Valence_plus_PC_Charge) then
         do j = 1, kimg
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
!CDIR INNER
#endif
            do i = ista_kngp, iend_kngp  !for mpi
               chgqplus_l(i,j) = chgqplus_l(i,j) + chgq_l(i,j,iloop)
            end do
         end do
      end if

      afft = 0.d0
      if(npes > 1) then
         allocate(ip(ista_kngp:iend_kngp)); ip = -1
         allocate(np(0:npes-1)); np = 0
         allocate(np_send(0:npes-1,0:npes-1))
      end if

#ifdef _MPIFFT_
      if(mod(iend_kngp-ista_kngp+1,2) == 1) then
         allocate(igfp_ijk(ista_kngp:iend_kngp,3))
      else
         allocate(igfp_ijk(ista_kngp:iend_kngp+1,3))
      end if
      idp = fft_box_size_CD_c(1,0)
      do l = ista_kngp, iend_kngp
         np0 = igfp_l_c(l)
         i   = mod(np0-1,idp)+1
         j   = mod((np0-i)/idp, ly) + 1
         k   = (np0-i-(j-1)*idp)/(idp*ly)+1
         igfp_ijk(l,1)  = i
         igfp_ijk(l,2)  = j
         igfp_ijk(l,3)  = k
      end do
      lx     = fft_box_size_CD_c(1,0)
      lxy    = lx*ly_d
#endif

      if(npes > 1) then
         np_send = 0
         np = 0
         do k = 0, npes-1
            if(map_pe2ggacmp(k) >= nrank_ggacmp) cycle
#ifdef _MPIFFT_
            icdfft = map_pe2cdfft(k)
            nstart = icdfft*ny_d+1
            nend   = min(fft_box_size_CD(2,1),(icdfft+1)*ny_d)
            do l = ista_kngp, iend_kngp
               j   = igfp_ijk(l,2)
               if(j >= nstart .and. j <= nend) then
                  if(map_pe2ggacmp(k) == 0) ip(l) = k
                  np(k) = np(k) + 1
               end if
            end do
#else
            icdfft = mod(k,npes_cdfft)
            do l = ista_kngp, iend_kngp
               igp = (igfp_l(l)-1)*kimg+1
               if(igp >= nis_fftp(icdfft) .and. igp <= nie_fftp(icdfft)) then
                  ip(l) = map_pe2cdfft(k)
                  np(k) = np(k) + 1
               end if
            end do
#endif
            if(ipri>=2)  write(nfout,'(" np(",i5,") = ",i8)') k, np(k)
         end do

         np_send(:,mype) = np(:)  ! number element sent from mype to j
         if(npes>1) then
            allocate(np_tmp(0:npes-1,0:npes-1))
            call mpi_allreduce(np_send,np_tmp,npes*npes,mpi_integer, mpi_sum, mpi_comm_group,ierr)
            np_send = np_tmp
            deallocate(np_tmp)
         end if
         maxdatasize = 0
         do j = 0, npes-1
            do i = 0, npes-1
               if(maxdatasize < np_send(i,j)) maxdatasize = np_send(i,j)
            end do
         end do
         if(ipri>=2) write(nfout,'(" maxdatasize = ",i8)') maxdatasize
      end if

#ifdef _MPIFFT_
      allocate(ipout_s(ista_kngp:iend_kngp))
      do l = ista_kngp, iend_kngp
         i = igfp_ijk(l,1)
         j = igfp_ijk(l,2)
         k = igfp_ijk(l,3)
         icdfft = (j-1)/ny_d
         j0 = j - ny_d*icdfft
         ipout_s(l) = kimg*(i + (j0-1)*lx + (k-1)*lxy - 1)  + nis_fftp(icdfft)
      end do
#endif

      ! mype -> mype
      if(myrank_ggacmp < nrank_ggacmp) then
#ifdef _MPIFFT_
         nstart = myrank_cdfft*ny_d+1
         nend   = min(fft_box_size_CD(2,1),(myrank_cdfft+1)*ny_d)
         if(kimg == 1) then
            if(npes > 1) then
               do l = ista_kngp, iend_kngp
                  i   = igfp_ijk(l,1)
                  if(i < 1 .or. i > fft_box_size_CD(1,1)) cycle
                  j   = igfp_ijk(l,2)
                  if(j >= nstart .and. j <= nend) then
                     ipout = ipout_s(l)
                     afft(ipout) = chgqplus_l(l,1)
                  end if
               end do
            else
               do l = ista_kngp, iend_kngp
                  ipout = ipout_s(l)
                  afft(ipout) = chgqplus_l(l,1)
               end do
            end if
         else
            if(npes > 1) then
               do l = ista_kngp, iend_kngp
                  i   = igfp_ijk(l,1)
                  if(i < 1 .or. i > fft_box_size_CD(1,1)) cycle
                  j   = igfp_ijk(l,2)
                  if(j >= nstart .and. j <= nend) then
                     ipout = ipout_s(l)
                     afft(ipout)   = chgqplus_l(l,1)
                     afft(ipout+1) = chgqplus_l(l,2)
                  end if
               end do
            else
               do l = ista_kngp, iend_kngp
                  ipout = ipout_s(l)
                  afft(ipout)   = chgqplus_l(l,1)
                  afft(ipout+1) = chgqplus_l(l,2)
               end do
            end if
         end if
#else
         if(kimg == 1) then
            do l = ista_kngp, iend_kngp
               igp = igfp_l(l)
               if(igp >= ista_fftp .and. igp <= iend_fftp) then
                  afft(igp) = chgqplus_l(l,1)
               end if
            end do
         else
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
#endif
            do l = ista_kngp, iend_kngp
               igp = (igfp_l(l)-1)*kimg+1
               if(igp >= ista_fftp .and. igp <= iend_fftp) then
                  afft(igp)   = chgqplus_l(l,1)
                  afft(igp+1) = chgqplus_l(l,2)
               end if
            end do
         end if
#endif
      end if

      if(npes > 1) then
         allocate(tmp_s(maxdatasize*kimg))
         allocate(tmp_r(maxdatasize*kimg))
         allocate(igfp_s(maxdatasize),igfp_r(maxdatasize))
         allocate(req_r(npes-1))
         allocate(req_s(npes-1))
         do nb = 1, npes-1
            pe_s = mod(mype+nb,      npes)
            pe_r = mod(mype-nb+npes, npes)
#ifdef _MPIFFT_
            icdfft = map_pe2cdfft(pe_s)
#endif
            if(map_pe2ggacmp(pe_s) < nrank_ggacmp .and. np_send(pe_s,mype) > 0) then
               tmp_s = 0.d0
               igfp_s = 0
               nfp = 0
          if(kimg==1) then
               do l = ista_kngp, iend_kngp
                  if(ip(l) == map_pe2cdfft(pe_s)) then
                     nfp = nfp+1
#ifdef _MPIFFT_
                     igfp_s(nfp) = ipout_s(l)
#else
                     igfp_s(nfp) = kimg*(igfp_l(l)-1)+1
#endif
                        tmp_s(nfp) = chgqplus_l(l,1)
                  end if
               end do
          else
               do l = ista_kngp, iend_kngp
                  if(ip(l) == map_pe2cdfft(pe_s)) then
                     nfp = nfp+1
#ifdef _MPIFFT_
                     igfp_s(nfp) = ipout_s(l)
#else
                     igfp_s(nfp) = kimg*(igfp_l(l)-1)+1
#endif
                        tmp_s(2*nfp-1) = chgqplus_l(l,1)
                        tmp_s(2*nfp)   = chgqplus_l(l,2)
                  end if
               end do
          endif

               datasize_s = np_send(pe_s,mype)*kimg
               if(ipri>=2) then
                  write(nfout,'(" nb, pe_s,pe_r = ",3i8)') nb, pe_s,pe_r
                  write(nfout,'(" nfp*kimg   = ", i8)') nfp*kimg
                  write(nfout,'(" datasize_s = ",i8)') datasize_s
               end if
               if(datasize_s /= nfp*kimg) stop ' datasize_s /= nfp*kimg'
               call mpi_isend(tmp_s,datasize_s,mpi_double_precision, &
                    & pe_s, mype, mpi_comm_group,req_s(nb),ierr)
            end if
            if(myrank_ggacmp < nrank_ggacmp .and. np_send(mype,pe_r) > 0) then
               datasize_r = np_send(mype,pe_r)*kimg
               if(ipri>=2) write(nfout,'(" datasize_r = ",i8)') datasize_r
               call mpi_irecv(tmp_r,datasize_r,mpi_double_precision, &
                    & pe_r, pe_r,  mpi_comm_group,req_r(nb),ierr)
            end if
            if(map_pe2ggacmp(pe_s) < nrank_ggacmp .and. np_send(pe_s,mype) > 0) &
                 & call mpi_wait(req_s(nb),istatus,ierr) 
            if(myrank_ggacmp < nrank_ggacmp .and. np_send(mype,pe_r) > 0) &
                 & call mpi_wait(req_r(nb),istatus,ierr)
            if(ipri>=2) write(nfout,'( " tmp_s , tmp_r  completed")')

            datasize_s = np_send(pe_s,mype)
            datasize_r = np_send(mype,pe_r)
            if(map_pe2ggacmp(pe_s) < nrank_ggacmp .and. np_send(pe_s,mype) > 0) then
               call mpi_isend(igfp_s,datasize_s,mpi_integer, &
                    & pe_s, mype, mpi_comm_group, req_s(nb),ierr)
            end if
            if(myrank_ggacmp < nrank_ggacmp .and. np_send(mype,pe_r) > 0) then
               call mpi_irecv(igfp_r,datasize_r,mpi_integer, &
                    & pe_r, pe_r,  mpi_comm_group, req_r(nb),ierr)
            end if
            if(map_pe2ggacmp(pe_s) <nrank_ggacmp .and. np_send(pe_s,mype) > 0) &
                 & call mpi_wait(req_s(nb),istatus,ierr)
            if(myrank_ggacmp < nrank_ggacmp .and. np_send(mype,pe_r) > 0) &
                 & call mpi_wait(req_r(nb),istatus,ierr)
            if(ipri>=2) write(nfout,'( " igfp_s , igfp_r  completed")')

            if(myrank_ggacmp < nrank_ggacmp) then
               if(kimg == 1) then
                  do l = 1, np_send(mype,pe_r)
                     ipout = igfp_r(l)
                     afft(ipout) = tmp_r(l)
                  end do
               else
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
#endif
                  do l = 1, np_send(mype,pe_r)
                     ipout = igfp_r(l)
                     afft(ipout)   = tmp_r(2*l-1)
                     afft(ipout+1) = tmp_r(2*l)
                  end do
               end if
            end if
         end do
         deallocate(req_s, req_r)
         deallocate(igfp_r, igfp_s)
         deallocate(tmp_r,tmp_s)
      end if
#ifdef _MPIFFT_
      deallocate(ipout_s)
      deallocate(igfp_ijk)
#endif
      if(npes > 1) then
         deallocate(np_send,np, ip)
      end if
      deallocate(chgqplus_l)

      call tstatc0_end(id_sname)

    end subroutine map_charge_onto_a_fft_box2

  end subroutine Calc_Density_in_Rspace
    
  subroutine afft_allgatherv(afft_mpi0,afft)
    !  Upgraded on 19 Sep. 2006 by T. Yamasaki
    !    * MPIFFT
    real(kind=DP),intent(in),dimension(:) :: afft_mpi0(ista_fftp:iend_fftp)
    real(kind=DP),intent(out),dimension(:):: afft(nfftp)
#ifdef _MPIFFT_
    real(kind=DP), allocatable, dimension(:) :: afft_tmp
    integer  :: nstart, nend, lx, lxy, llx, lly, llxy, i, j, jj, k, ipin, ipout
    integer  :: nb, datasize, pe_s, pe_r
    integer, allocatable, dimension(:) :: req_s, req_r
    real(kind=DP), allocatable, dimension(:) :: tmp_s, tmp_r
#endif
    integer  :: id_sname = -1
!----------------------------- start ------------
    call tstatc0_begin('afft_allgatherv(in m_XC_Potential) ',id_sname)
    if(npes>=2)  call mpi_barrier(mpi_comm_group,ierr)
    
    if(npes_cdfft >= 2) then
       if(myrank_ggacmp < nrank_ggacmp) then
#ifdef _MPIFFT_
          afft = 0.d0
#ifndef _ALLREDUCE_AFFT_ALLGAHTERV_
          
          datasize = nfftp/npes_cdfft
          allocate(tmp_s(datasize)); tmp_s = 0.d0
          allocate(tmp_r(datasize)); tmp_r = 0.d0
          allocate(req_r(npes-1),req_s(npes-1))
          
          lx     = fft_box_size_CD_c(1,0)
          lxy    = lx*ly_d
          llx    = fft_box_size_CD_c(1,0)
          lly    = fft_box_size_CD_c(2,0)
          llxy   = llx*lly
          
          do i = 1, iend_fftp-ista_fftp+1
             tmp_s(i) = afft_mpi0(i+ista_fftp-1)
          end do
          
          do nb = 1, npes_cdfft-1
             pe_s = mod(myrank_cdfft+nb,           npes_cdfft)
             pe_r = mod(myrank_cdfft-nb+npes_cdfft,npes_cdfft)
             call mpi_irecv(tmp_r,datasize,mpi_double_precision, &
                  & pe_r,pe_r,        mpi_cdfft_world(myrank_ggacmp),req_r(nb),ierr)
             call mpi_isend(tmp_s,datasize,mpi_double_precision, &
                  & pe_s,myrank_cdfft,mpi_cdfft_world(myrank_ggacmp),req_s(nb),ierr)
             call mpi_wait(req_r(nb),istatus,ierr)
             call mpi_wait(req_s(nb),istatus,ierr)
             
             nstart = pe_r*ny_d+1
             nend   = min(fft_box_size_CD(2,1),(pe_r+1)*ny_d)
             
             if(kimg == 1) then
                do k = 1, fft_box_size_CD(3,1)
                   do j = nstart, nend
                      jj = j - nstart + 1
                      do i = 1, fft_box_size_CD(1,1)
                         ipin  = i + (jj-1)* lx + (k-1)* lxy
                         ipout = i + ( j-1)*llx + (k-1)*llxy
                         afft(ipout)   = tmp_r(ipin)
                      end do
                   end do
                end do
             else if(kimg == 2) then
                do k = 1, fft_box_size_CD(3,1)
                   do j = nstart, nend
                      jj = j - nstart + 1
                      do i = 1, fft_box_size_CD(1,1)
                         ipin  = 2*(i + (jj-1)* lx + (k-1)* lxy)-1
                         ipout = 2*(i + ( j-1)*llx + (k-1)*llxy)-1
                         afft(ipout)   = tmp_r(ipin)
                         afft(ipout+1) = tmp_r(ipin+1)
                      end do
                   end do
                end do
             end if
          end do
          deallocate(req_s,req_r)
          deallocate(tmp_s)
          deallocate(tmp_r)
          
! diagonal part
          nstart = myrank_cdfft*ny_d+1
          nend   = min(fft_box_size_CD(2,1),(myrank_cdfft+1)*ny_d)
!!$          allocate(afft_tmp(nfftp))
            
          if(kimg == 1) then
             do k = 1, fft_box_size_CD(3,1)
                do j = nstart, nend
                   jj = j - nstart + 1
                   do i = 1, fft_box_size_CD(1,1)
                      ipin  = ista_fftp-1 + (i + (jj-1)* lx + (k-1)* lxy)
                      ipout =               (i + ( j-1)*llx + (k-1)*llxy)
                      afft(ipout)   = afft_mpi0(ipin)
                   end do
                end do
             end do
          else if(kimg == 2) then
             do k = 1, fft_box_size_CD(3,1)
                do j = nstart, nend
                   jj = j - nstart + 1
                   do i = 1, fft_box_size_CD(1,1)
                      ipin  = ista_fftp-1 + 2*(i + (jj-1)* lx + (k-1)* lxy)-1
                      ipout =               2*(i + ( j-1)*llx + (k-1)*llxy)-1
                      afft(ipout)   = afft_mpi0(ipin)
                      afft(ipout+1) = afft_mpi0(ipin+1)
                   end do
                end do
             end do
          end if
#else
          nstart = myrank_cdfft*ny_d+1
          nend   = min(fft_box_size_CD(2,1),(myrank_cdfft+1)*ny_d)
          lx     = fft_box_size_CD_c(1,0)
          lxy    = lx*ly_d
          llx    = fft_box_size_CD_c(1,0)
          lly    = fft_box_size_CD_c(2,0)
          llxy   = llx*lly
          allocate(afft_tmp(nfftp))
          
          if(kimg == 1) then
             do k = 1, fft_box_size_CD(3,1)
                do j = nstart, nend
                   jj = j - nstart + 1
                   do i = 1, fft_box_size_CD(1,1)
                      ipin  = ista_fftp-1 + (i + (jj-1)* lx + (k-1)* lxy)
                      ipout =               (i + ( j-1)*llx + (k-1)*llxy)
                      afft(ipout)   = afft_mpi0(ipin)
                   end do
                end do
             end do
          else if(kimg == 2) then
             do k = 1, fft_box_size_CD(3,1)
                do j = nstart, nend
                   jj = j - nstart + 1
                   do i = 1, fft_box_size_CD(1,1)
                      ipin  = ista_fftp-1 + 2*(i + (jj-1)* lx + (k-1)* lxy)-1
                      ipout =               2*(i + ( j-1)*llx + (k-1)*llxy)-1
                      afft(ipout)   = afft_mpi0(ipin)
                      afft(ipout+1) = afft_mpi0(ipin+1)
                   end do
                end do
             end do
          end if
          call mpi_allreduce(afft, afft_tmp, nfftp, mpi_double_precision, mpi_sum, mpi_cdfft_world(myrank_ggacmp),ierr)
          afft = afft_tmp
#endif
          
#else
          call mpi_allgatherv(afft_mpi0,nel_fftp(myrank_cdfft),mpi_double_precision, afft,nel_fftp,idisp_fftp,&
          & mpi_double_precision,mpi_cdfft_world(myrank_ggacmp),ierr)
#endif
       end if
    else
       afft = afft_mpi0
    end if
    
    if(nrest_cdfft >= 1) then
       if(mype > npes_cdfft*nrank_ggacmp-1) then
          call mpi_recv(afft,nfftp,mpi_double_precision &
               & , mype-npes_cdfft*nrank_ggacmp,1,mpi_comm_group,istatus,ierr)
       end if
       if(mype < nrest_cdfft) then
          call mpi_send(afft,nfftp,mpi_double_precision &
               & , mype+npes_cdfft*nrank_ggacmp,1,mpi_comm_group,ierr)
       end if
    end if
    
    call tstatc0_end(id_sname)
    
  end subroutine afft_allgatherv

  subroutine xc_allocate(ispin,nfout)
    integer, intent(in)      :: ispin,nfout

    integer                  :: idp,nlp,nmp,nnp,nd2p,nd3p,ip, idph, nlph
    integer                  :: n, nn, i, j, k
#ifdef _MPIFFT_
    integer                  :: np0, j0, i2, j2, k2, n0
#endif

#ifndef _MPIFFT_
    call m_FFT_alloc_CD_box()
#endif
    allocate(afft(ista_fftp:iend_fftp));afft=0.d0
    allocate(chgrhr_l(ista_fftph:iend_fftph,ispin))    ! MPI
    allocate(f2or1(ista_fftph:iend_fftph))
 
    nlp  = fft_box_size_CD(1,1)
    nmp  = fft_box_size_CD(2,1)
    nnp  = fft_box_size_CD(3,1)
#ifdef _MPIFFT_
    idp  = fft_box_size_CD_c(1,0)
    nd2p = fft_box_size_CD_c(2,0)
    nd3p = fft_box_size_CD_c(3,0)
#else
    idp  = fft_box_size_CD(1,0)
    nd2p = fft_box_size_CD(2,0)
    nd3p = fft_box_size_CD(3,0)
#endif

    call set_f2or1(npes_cdfft,ista_fftph,iend_fftph,f2or1)

    if(check_of_xctype() == GGA) then
       allocate(inx(ista_fftp:iend_fftp)); inx = 0
       allocate(jnx(ista_fftp:iend_fftp)); jnx = 0
       allocate(knx(ista_fftp:iend_fftp)); knx = 0

!
!       write(*,*) 'Maji Maji ', inx
!       stop
#ifdef _MPIFFTTESTTEST_
       if(kimg == 1) then
          do n = ista_fftp, iend_fftp
             nn = n
             if(nn == ista_fftp-1) write(nfout,'(" n == ista_fftp-1 = ",i8)') nn
             np0 = nn - idp*ly_d*lz*myrank_cdfft
             i  = mod(np0-1,idp)+1
             j0 = mod((np0-i)/idp,ly_d) + 1
             j  = j0 + ny_d*myrank_cdfft
             k  = (np0-i-(j0-1)*idp)/(idp*ly_d) + 1
             if(i >= idp) i = i - idp
             inx(n) = i - 1;  if(2*inx(n) > nlp) inx(n) = inx(n) - nlp
             jnx(n) = j - 1;  if(2*jnx(n) > nmp) jnx(n) = jnx(n) - nmp
             knx(n) = k - 1;  if(2*knx(n) > nnp) knx(n) = knx(n) - nnp
          end do

!!$          do k = 0, nnp-1
!!$             k2 = k; if(2*k2 > nnp) k2 = k2 - nnp
!!$             do j0 = 0, min(ny_d, nmp-ny_d*myrank_cdfft)-1
!!$                j = j0 + ny_d*myrank_cdfft
!!$                j2 = j; if(2*j2 > nmp) j2 = j2 - nmp
!!$                n0 = 1+j0*idp + k*idp*ly_d + ista_fftp-1
!!$                do i = 0, nlp-1
!!$                   n = i+n0
!!$                   inx(n) = i; if(2*inx(n) > nlp) inx(n) = inx(n) - nlp
!!$                   if(n == ista_fftp-1) write(nfout,'(" n = ista_fftp-1 = ",i8)') n 
!!$                   jnx(n) = j2
!!$                   knx(n) = k2
!!$                end do
!!$             end do
!!$          end do

!!$          do i = 0, nlp-1
!!$             i2 = i; if(2*i2 > nlp) i2 = i2 - nlp
!!$             do j0 = 0, min(ny_d, nmp-ny_d*myrank_cdfft)-1
!!$                j = j0 + ny_d*myrank_cdfft
!!$                j2 = j; if(2*j2 > nmp) j2 = j2 - nmp
!!$                do k = 0, nnp/2
!!$                   n = i+1 + j0*idp + k*idp*ly_d + ista_fftp-1
!!$                   inx(n) = i2
!!$                   jnx(n) = j2
!!$                   knx(n) = k
!!$                end do
!!$                do k = nnp/2+1, nnp-1
!!$                   n = i+1 + j0*idp + k*idp*ly_d + ista_fftp-1
!!$                   inx(n) = i2
!!$                   jnx(n) = j2
!!$                   knx(n) = k - nnp
!!$                end do
!!$             end do
!!$          end do
       else if(kimg == 2) then
          do k = 0, nnp-1
             k2 = k; if(2*k2 > nnp) k2 = k2 - nnp
             do j0 = 0, min(ny_d, nmp-ny_d*myrank_cdfft)-1
                j = j0 + ny_d*myrank_cdfft
                j2 = j; if(2*j2 > nmp) j2 = j2 - nmp
                do i = 0, nlp/2
                   n = i+1 + j0*idp + k*idp*ly_d
                   nn = n*2-1 + ista_fftp-1
                   inx(nn) = i ; inx(nn+1) = i
                   jnx(nn) = j2; jnx(nn+1) = j2
                   knx(nn) = k2; knx(nn+1) = k2
                end do
                do i = nlp/2+1, nlp-1
                   n = i+1 + j0*idp + k*idp*ly_d
                   nn = n*2-1 + ista_fftp-1
                   inx(nn) = i-nlp ; inx(nn+1) = i-nlp
                   jnx(nn) = j2; jnx(nn+1) = j2
                   knx(nn) = k2; knx(nn+1) = k2
                end do
             end do
          end do
       end if
#else
       do n = ista_fftp, iend_fftp
          nn = (n+kimg-1)/kimg    ! nn = n (when kimg=1), nn = (n+1)/2 (when kimg=2)
#ifdef _MPIFFT_
!!$          if(nn == ista_fftp-1) write(nfout,'(" n == ista_fftp-1 = ",i8)') nn
          np0 = nn - idp*ly_d*lz*myrank_cdfft
          i  = mod(np0-1,idp)+1
          j0 = mod((np0-i)/idp,ly_d) + 1
          j  = j0 + ny_d*myrank_cdfft
          k  = (np0-i-(j0-1)*idp)/(idp*ly_d) + 1
          if(i >= idp) i = i - idp
#else
          i  = mod(nn,idp)
          j  = mod((nn-1)/idp,nd2p) + 1
          k  = (nn - (j-1)*idp - i)/(idp*nd2p) + 1
#endif
          inx(n) = i - 1;  if(2*inx(n) > nlp) inx(n) = inx(n) - nlp
          jnx(n) = j - 1;  if(2*jnx(n) > nmp) jnx(n) = jnx(n) - nmp
          knx(n) = k - 1;  if(2*knx(n) > nnp) knx(n) = knx(n) - nnp
       end do
#endif

!       write(*,*) 'Ua ', mype, inx(1), jnx(1), knx(1)
!       write(*,*) 'Va ', mype, inx(2), jnx(2), knx(2)
!       write(*,*) 'Ub ', mype, inx(3), jnx(3), knx(3)
!       write(*,*) 'Vb ', mype, inx(4), jnx(4), knx(4)
!       stop

       allocate(chden_l(ista_fftp:iend_fftp,nspin)); chden_l = 0.d0 
       allocate(grad_trho(ista_fftph:iend_fftph));   grad_trho = 0.0d0
       allocate(grad_rho(ista_fftph:iend_fftph,nspin)); grad_rho = 0.d0

#ifndef _XC_SAVE_MEMORY_
       if(nrank_ggacmp > 1) then
          allocate(cgrad_rho(ista_fftph:iend_fftph,myrank_ggacmp+1:myrank_ggacmp+1,nspin))  ! MPI
       else
          allocate(cgrad_rho(ista_fftph:iend_fftph,3,nspin))  ! MPI
       end if
#else
       allocate(cggawk13(ista_fftph:iend_fftph))           ! MPI
#endif
!!       allocate(dF_drho(ista_fftph:iend_fftph,nspin))      ! MPI
!!       allocate(dF_dgradrho(ista_fftph:iend_fftph,nspin))  ! MPI
    end if

  contains
    subroutine set_f2or1(npes,ista,iend,f2or1)
      integer, intent(in) :: npes,ista, iend
      real(kind=DP), intent(out), dimension(ista:iend) :: f2or1
      integer :: idph,nlph,ip,i,j,k

      if(kimg == 1) then
         idph = idp/2
         nlph = nlp/2
#ifdef _MPIFFT_
         f2or1 = 0.d0
!!$         do j = 1, min(nz_d,nnp-nz_d*myrank_cdfft)*nmp
!!$         do j = 1, min(nz_d,nnp-nz_d*myrank_cdfft)*nd2p
         do k = 1, min(nz_d, nnp-nz_d*myrank_cdfft)
            do j = 1, nmp
               do i = 1, nlph
!!$                  ip = i + idph*(j-1) + idph*ly*lz_d*myrank_cdfft
                  ip = i + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
                  f2or1(ip) = 2.d0
               end do
               ip = 1 + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
               f2or1(ip) = 1.d0
               ip = nlph+1 + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
               f2or1(ip) = 1.d0
            end do
         end do
!!$            ip = idph*(j-1) + 1 + idph*ly*lz_d*myrank_cdfft
!!$            f2or1(ip) = 1.d0
!!$            ip = idph*(j-1)+ nlph + 1 + idph*ly*lz_d*myrank_cdfft
!!$            f2or1(ip) = 1.d0
!!$         end do
#else
         f2or1 = 2.d0
         if(npes >= 2) then
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + 1
               if(ip>= ista .and. ip <= iend) f2or1(ip) = 1.d0
            end do
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + nlph + 1
               if(ip>= ista .and. ip <= iend) f2or1(ip) = 1.d0
            end do
            do j = nlph+2, idph
               do i = 1,nd2p*nnp
                  ip = idph*(i-1)+j
                  if(ip>= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p
               do k = 1, nnp
                  do i = 1, nlph
                     ip = i + idph*(j-1) + idph*nd2p*(k-1)
                     if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p
               do i = 1, idph*nd2p
                  ip = i + idph*nd2p*(k-1)
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
         else
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + 1
               f2or1(ip) = 1.d0
            end do
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + nlph + 1
               f2or1(ip) = 1.d0
            end do
            do j = nlph+2, idph
               do i = 1,nd2p*nnp
                  ip = idph*(i-1)+j
                  f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p
               do k = 1, nnp
                  do i = 1, nlph
                     ip = i + idph*(j-1) + idph*nd2p*(k-1)
                     f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p
               do i = 1, idph*nd2p
                  ip = i + idph*nd2p*(k-1)
                  f2or1(ip) = 0.d0
               end do
            end do
         end if
!!$       do i = ista, iend
!!$          if(mod(i*2,idp) == 2 .or. mod(i*2,idp) == 0) f2or1(i) = 1.d0
!!$       end do
#endif
      else
#ifdef _MPIFFT_
!!$         f2or1 = 0.d0                               ! f2or1 works to the fft data in R space.
!!$         do k = 1, min(nz_d,nnp-nz_d*myrank_cdfft)
!!$            do j = 1, nmp     ! nmp = fft_box_size_CD(2,1)
!!$               do i = 1, nlp  ! nlp = fft_box_size_CD(1,1)
!!$                  ip = i+(j-1)*idp+(k-1)*idp*nd2p+idp*nd2p*lz_d*myrank_cdfft
!!$                  f2or1(ip) = 1.d0
!!$               end do
!!$            end do
!!$         end do
         if(ipri >= 2 ) write(nfout,'(" ix kimg = 2 <<set_f2or1>>")')
         f2or1 = 1.d0
         do j = nlp+1, idp      ! x
            do i = 1, ly*nz_d
               ip = idp*(i-1)+j+ista-1
               f2or1(ip) = 0.d0
            end do
         end do
         if(ipri >= 2 ) write(nfout,'(" iy kimg = 2 <<set_f2or1>>")')
         do j = nmp+1,ly         ! y
            do k = 1, nz_d
               do i = 1, nlp
                  ip = i + idp*(j-1) + idp*ly*(k-1) + ista-1
                  f2or1(ip) = 0.d0
               end do
            end do
         end do
         if(ipri >= 2 ) write(nfout,'(" iz kimg = 2 <<set_f2or1>>")')
         do  k = nz_d+1, lz_d   ! z
            do i = 1, idp*ly
               ip = i + idp*ly*(k-1) + ista-1
               f2or1(ip) = 0.d0
            end do
         end do
#else
         f2or1 = 1.d0
         if(npes >= 2) then
            do j = nlp+1, idp    ! x
               do i = 1, nd2p*nnp
                  ip = idp*(i-1)+j
                  if(ip>= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p   ! y
               do k = 1, nnp
                  do i = 1, nlp
                     ip = i + idp*(j-1) + idp*nd2p*(k-1)
                     if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p   ! z
               do i = 1, idp*nd2p
                  ip = i + idp*nd2p*(k-1)
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
         else
            do j = nlp+1, idp    ! x
               do i = 1, nd2p*nnp
                  ip = idp*(i-1)+j
                  f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p   ! y
               do k = 1, nnp
                  do i = 1, nlp
                     ip = i + idp*(j-1) + idp*nd2p*(k-1)
                     f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p   ! z
               do i = 1, idp*nd2p
                  ip = i + idp*nd2p*(k-1)
                  f2or1(ip) = 0.d0
               end do
            end do
         end if
#endif
      end if
    end subroutine set_f2or1
  end subroutine xc_allocate

  subroutine xc_deallocate
#ifndef _MPIFFT_
    call m_FFT_dealloc_CD_box()
#endif
    deallocate(afft)
    deallocate(chgrhr_l)
    deallocate(f2or1)

    if(check_of_xctype() == GGA) then
       deallocate(inx); deallocate(jnx); deallocate(knx)
       deallocate(chden_l)
       deallocate(grad_trho)
#ifndef _XC_SAVE_MEMORY_
       deallocate(cgrad_rho)
#else
       deallocate(cggawk13)
#endif
       deallocate(grad_rho); 
!!        deallocate(dF_drho)
!!       deallocate(dF_dgradrho)

    end if
  end subroutine xc_deallocate

! ------------------------- GGA --------------------------
  subroutine abs_grad_rho_up_down_total(ispin)
    integer, intent(in) :: ispin
    real(kind=DP),allocatable,dimension(:)    :: grad_rho_c2  ! MPI d(ista_fftph:iend_fftph)
    integer  :: is, in, i
    real(kind=DP) :: x,y,z

#ifdef _DETAIL_GGA_TIMING_
    integer :: id_sname = -1
#endif
    if(nrank_ggacmp > 1) allocate(grad_rho_c2(ista_fftph:iend_fftph))    ! MPI

    do is = 1, ispin
       grad_rho(:,is) = 0.d0
       do in = 1, 3
          if(map_ggacmp(in) /= myrank_ggacmp) cycle
          call g_xyz_chden_l(in,is)        ! G_xyz * rho_{up|down}(G)-->afft
          if(ipri >= 2) call wd_small_part_of_afft_kt(34,'G space before<m_FFT_CD_inverse_c)',120, is )
          call m_FFT_CD_inverse_c(nfout,afft)! (-i)*d(rho_{up|down}(r))/d(x|y|z)
          if(ipri >= 2) call wd_small_part_of_afft_kt(34,'R space after <m_FFT_CD_inverse_c)',120, is)
#ifndef _XC_SAVE_MEMORY_
          call cp_afft_to_cgrad_rho(is,in) ! -> cgrad_rho(i,in,is) = -afft(i*2)
#endif
          call add_sq_afft_to_grad_rho(is) ! grad_rho <--  + afft**2
          if(ipri >= 2) then
             write(nfout,'(" !XC after add_sq_afft_to_grad_rho: is, in = ",2i8)') is, in
             write(nfout,'(" !XC -- grad_rho -- <<abs_grad_rho_up_down_total>>")')
             write(nfout,'(" !XC ",6f12.6)') (grad_rho(i,1),i=ista_fftph,ista_fftph+17)
             write(nfout,'(" !XC ",6f12.6)') (grad_rho(i,1),i=iend_fftph-17,iend_fftph)
#ifndef _XC_SAVE_MEMORY_
             write(nfout,'(" !XC -- cgrad_rho -- <<abs_grad_rho_up_down_total>>")')
             write(nfout,'(" !XC ",6f12.6)') (cgrad_rho(i,in,1),i=ista_fftph,ista_fftph+17)
             write(nfout,'(" !XC ",6f12.6)') (cgrad_rho(i,in,1),i=iend_fftph-17,iend_fftph)
#endif
          end if
          
       end do
       
       if(ipri >= 2) write(nfout,'(" !XC after add_sq_afft_to_grad_rho")')
! --> grad_rho_c
       if(nrank_ggacmp > 1) then
          grad_rho_c2(:) = grad_rho(:,is)
#ifdef _DETAIL_GGA_TIMING_
          call tstatc0_begin('mpi_allreduce(ggaxcp) ',id_sname)
#endif
          call mpi_allreduce(grad_rho_c2,grad_trho,iend_fftph-ista_fftph+1 &
               & ,mpi_double_precision, mpi_sum, mpi_ggacmp_cross_world(myrank_cdfft),ierr)
#ifdef _DETAIL_GGA_TIMING_
          call tstatc0_end(id_sname)
#endif
          grad_rho(:,is) = dsqrt(grad_trho(:))
       else
          grad_rho(:,is) = dsqrt(grad_rho(:,is)) ! grad_rho(s) <-- |grad(rho_s(r))|
       end if
    enddo
    if(ispin == 2) then
#ifndef _XC_SAVE_MEMORY_
       if(nrank_ggacmp > 1) then
          grad_rho_c2 = 0.d0
!!$            if(myrank_ggacmp >= 0 .and. myrank_ggacmp <=2) then
          do i = ista_fftph, iend_fftph
             x = cgrad_rho(i,myrank_ggacmp+1,1) + cgrad_rho(i,myrank_ggacmp+1,2)
             grad_rho_c2(i) = grad_rho_c2(i) + x*x
          end do
#ifdef _DETAIL_GGA_TIMING_
          call tstatc0_begin('mpi_allreduce(ggaxcp) ',id_sname)
#endif
          call mpi_allreduce(grad_rho_c2,grad_trho,iend_fftph-ista_fftph+1 &
               & , mpi_double_precision, mpi_sum, mpi_ggacmp_cross_world(myrank_cdfft),ierr)
#ifdef _DETAIL_GGA_TIMING_
          call tstatc0_end(id_sname)
#endif
          grad_trho = dsqrt(grad_trho)
       else
          do in = ista_fftph, iend_fftph
             x = cgrad_rho(in,1,1) + cgrad_rho(in,1,2)
             y = cgrad_rho(in,2,1) + cgrad_rho(in,2,2)
             z = cgrad_rho(in,3,1) + cgrad_rho(in,3,2)
             grad_trho(in) = dsqrt(x*x+y*y+z*z)
          end do
       end if
#else
       do in = 1, 3
          call g_xyz_total_chden_l(in)     ! G_xyz*(rho(G)up+rho(G)down) -> afft
          call m_FFT_CD_inverse_c(nfout,afft)!(-i)*d(rho_total(r))/d(x|y|z)
          call add_sq_afft_to_grad_trho
       end do
       grad_trho = dsqrt(grad_trho)     ! grad_trho <-- |grad(rho_total(r))|
#endif
    else
       grad_trho(:) = grad_rho(:,1)
    end if
    if(nrank_ggacmp > 1) deallocate(grad_rho_c2)
  end subroutine abs_grad_rho_up_down_total
  
  subroutine g_xyz_chden_l(in,is)
    integer, intent(in) :: in,is
    integer       :: n
    real(kind=DP) :: gxyz
    
!!$      deallocate(afft)
!!$      allocate(afft(ista_fftp:iend_fftp))

    afft = 0.d0
    do n = ista_fftp, iend_fftp  ! MPI
       gxyz = rltv(in,1)*inx(n)+rltv(in,2)*jnx(n)+rltv(in,3)*knx(n)
       afft(n) = gxyz*chden_l(n,is)
    enddo
    call boundary_zero_into_afft(in)  ! -(contained in subr. m_XC_cal_potential)
  end subroutine g_xyz_chden_l
  
  subroutine check_lmn_even
    integer             :: nlmn, i
    
    do i = 1, 3
       nlmn = fft_box_size_CD(i,1)/2
       if(2*nlmn == fft_box_size_CD(i,1)) then
          lmn_even(i) = .true.
       else
          lmn_even(i) = .false.
       end if
    end do
  end subroutine check_lmn_even
  
  subroutine boundary_zero_into_afft(in)
    integer, intent(in) :: in
    integer             :: i,j,k,nn,n,idp,nlp,nmp,nnp,nd2p, j0
    
    nlp = fft_box_size_CD(1,1)
    nmp = fft_box_size_CD(2,1)
    nnp = fft_box_size_CD(3,1)
#ifdef _MPIFFT_
    idp = fft_box_size_CD_c(1,0)
    nd2p = fft_box_size_CD_c(2,0)
#else
    idp = fft_box_size_CD(1,0)
    nd2p = fft_box_size_CD(2,0)
#endif
    
    if(kimg == 1) then
       if(lmn_even(in)) then
          if( in == 1) then
#ifdef _MPIFFT_
             do j = 1, ly_d*lz
!!$               do j0 = 1, ly_d
!!$                  do k = 1, nnp
!!$                     nn = nlp/2 + 1 + idp*(j0-1) + idp*ly_d*(k-1) + idp*ly_d*lz*myrank_cdfft
                nn = nlp/2 + 1 + idp*(j-1) + idp*ly_d*lz*myrank_cdfft
                afft(nn) = 0.d0
!!$                  end do
             end do
#else
             do j = 1, nmp      ! y
                do k = 1, nnp   ! z
!!$                  nn = nlp/2 + 1 + idp*(j-1) + idp*nmp*(k-1)
                   nn = nlp/2 + 1 + idp*(j-1) + idp*nd2p*(k-1)
                   if(nn >= ista_fftp .and. nn <= iend_fftp) afft(nn) = 0.d0
                end do
             end do
#endif
          else if( in == 2) then
#ifdef _MPIFFT_
             j0 = nmp/2 + 1 - ny_d*myrank_cdfft
             if(j0 >= 1 .and. j0 <= ny_d) then
                do i = 1, idp
                   do k = 1, nnp
                      nn = i + idp*(j0-1) + idp*ly_d*(k-1) + idp*ly_d*lz*myrank_cdfft
                      afft(nn) = 0.d0
                   end do
                end do
             end if
#else
             do i = 1, idp      ! x
                do k = 1, nnp   ! z
                   nn = i + idp*(nmp/2) + idp*nd2p*(k-1)
                   if(nn >= ista_fftp .and. nn <= iend_fftp) afft(nn) = 0.d0
                end do
             end do
#endif
          else if(in == 3) then
#ifdef _MPIFFT_
             do i = 1, idp
                do j = 1+ny_d*myrank_cdfft, min(nmp,ny_d*(myrank_cdfft+1))
                   nn = i + idp*(j-1-ny_d*myrank_cdfft) + idp*ly_d*(nnp/2) &
                        &                          + idp*ly_d*lz*myrank_cdfft
                   afft(nn) = 0.d0
                end do
             end do
#else
             do i = 1, idp      ! x
                do j = 1, nmp   ! y
                   nn = i + idp*(j-1) + idp*nd2p*(nnp/2)
                   if(nn >= ista_fftp .and. nn <= iend_fftp) afft(nn) = 0.d0
                end do
             end do
#endif
          end if
       end if
    else if(kimg == 2) then
       if(lmn_even(in)) then
          if( in == 1) then
#ifdef _MPIFFT_
             do j = 1, ly_d*lz
                nn = nlp/2 + 1 + idp*(j-1) + idp*ly_d*lz*myrank_cdfft
                n = nn*2 - 1
                afft(n) = 0.d0
                afft(n+1) = 0.d0
             end do
#else               
             do j = 1, nmp
                do k = 1, nnp
!!$                  nn = nlp/2 + 1 + idp*(j-1) + idp*nmp*(k-1)
                   nn = nlp/2 + 1 + idp*(j-1) + idp*nd2p*(k-1)
!!$                     nn = nlp/2 + 1 + idp*(j-1) -idp*ly_d*myrank_cdfft &
!!$                          & +idp*ly_d*(k-1+myrank_cdfft)
                   n  = nn*2 - 1
                   if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                   n  = nn*2
                   if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                end do
             end do
#endif
          else if( in == 2) then
#ifdef _MPIFFT_
             j0 = nmp/2 + 1 - ny_d*myrank_cdfft
             if(j0 >= 1 .and. j0 <= ny_d) then
                do i = 1, idp
                   do k = 1, nnp
                      nn = i + idp*(j0-1) + idp*ly_d*(k-1) + idp*ly_d*lz*myrank_cdfft
                      n  = nn*2 - 1
                      afft(n) = 0.d0; afft(n+1) = 0.d0
                   end do
                end do
             end if
#else
             do i = 1, idp
                do k = 1, nnp
!!$                     nn = i + idp*(nmp/2) + idp*nmp*(k-1)
                   nn = i + idp*(nmp/2) + idp*nd2p*(k-1)
                   n  = nn*2 - 1
                   if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                   n  = nn*2
                   if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                end do
             end do
#endif
          else if(in == 3) then
#ifdef _MPIFFT_
             do i = 1, idp
                do j = 1+ny_d*myrank_cdfft, min(nmp,ny_d*(myrank_cdfft+1))
                   nn = i + idp*(j-1-ny_d*myrank_cdfft) + idp*ly_d*(nnp/2) &
                        &                          + idp*ly_d*lz*myrank_cdfft
                   n  = nn*2 - 1
                   afft(n) = 0.d0
                   afft(n+1) = 0.d0
                end do
             end do
#else
             do i = 1, idp
                do j = 1, nmp
!!$                  nn = i + idp*(j-1) + idp*nmp*(nnp/2)
                   nn = i + idp*(j-1) + idp*nd2p*(nnp/2)
                   n  = nn*2 - 1
                   if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                   n  = nn*2
                   if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                end do
             end do
#endif
          end if
       end if
    end if
  end subroutine boundary_zero_into_afft
  
#ifndef _XC_SAVE_MEMORY_
  subroutine cp_afft_to_cgrad_rho(is,in)
    integer, intent(in) :: is, in
    integer :: i
    do i = ista_fftph, iend_fftph
       cgrad_rho(i,in,is) = -afft(i*2)
    end do
  end subroutine cp_afft_to_cgrad_rho
  
#endif
  
  subroutine wd_small_part_of_afft_kt( len_str,str,ne,iloop )
    integer, intent(in)        :: len_str, iloop
    character(len=len_str),intent(in) :: str
    integer, intent(in)        :: ne
    
    integer                    :: i
!!$      if(mype == 0) then
    write(nfout, *) 'afft (',str,')'
    if(nspin == 2) write(nfout,*) ' #spin = ', iloop
    if(ne*2 > np_fftp) then
       write(nfout,*)  ' all elements'
       write(nfout,'(6f12.6)') (afft(i),i=ista_fftp, iend_fftp)
    else
       write(nfout,*) ' first ',ne,' elements'
!!$            write(nfout,'(6f12.6)') (afft(i),i=1,ne)
       write(nfout,'(6f12.6)') (afft(ista_fftp-1+i),i=1,ne)
       write(nfout,*) ' last ', ne,' elements'
       write(nfout,'(6f12.6)') (afft(iend_fftp-ne+i),i=1,ne)
    endif
!!$         write(nfout,'(" iend_fftp = ",i8)') iend_fftp
!!$         write(nfout,*) ' last ', lx*2,' elements'
!!$         write(nfout,'(" j, k = ", 2i8)') ly_d+ly_d*myrank_cdfft, lz
!!$         n = 2*((ly_d-1)*lx + (lz-1)*lx*ly_d) + ista_fftp - 1
!!$         write(nfout,'(8d12.4)') (afft( n+i),i=1,lx*2)
!!$         write(nfout,'(" n+lx*2 = ",i8)') n+lx*2
!!$            end do
!!$         end do
!!$         n = 0
!!$         do i = ista_fftp, iend_fftp
!!$            if(abs(afft(i)) > 1.d-8) n = n+1
!!$         end do
!!$         write(nfout,'(" number of non-zero term of afft = ",i8)') n
!!$      end if
  end subroutine wd_small_part_of_afft_kt

  subroutine add_sq_afft_to_grad_trho
    integer   :: i
    do i = ista_fftph, iend_fftph     ! MPI
       grad_trho(i) = grad_trho(i) + afft(i*2)**2
    end do
  end subroutine add_sq_afft_to_grad_trho
  
  subroutine add_sq_afft_to_grad_rho(is)
    integer, intent(in) :: is
    integer :: i
    do i = ista_fftph, iend_fftph     ! MPI
       grad_rho(i,is) = grad_rho(i,is) + afft(i*2)**2
    end do
  end subroutine add_sq_afft_to_grad_rho
! --------------------------------------------

  subroutine Calc_Kernels_ALDA_Rspace(ispin)
    integer, intent(in) :: ispin

    integer :: i, ni, nj
! --------------------------------- start ----------    
    if ( xctype == 'ldapw91' ) then
       Call calc_kernel_ex_ldapw91( nspin, ispin, chgrhr_l, ker_ex )
       Call calc_kernel_cr_ldapw91( nspin, ispin, chgrhr_l, ker_cr )
    else if ( xctype == 'ggapbe' ) then
       Call calc_kernel_ex_ggapbe( nspin, ispin, chgrhr_l, grad_rho, f2or1, ker_ex )
       Call calc_kernel_cr_ggapbe( nspin, ispin, chgrhr_l, grad_trho, f2or1, ker_cr )
    endif
! ------------------------- Exc ni shita baao ------
!    if ( xctype == 'ggapbe' ) then
!       Call calc_kt_ex_ggapbe( nspin, ispin, chgrhr_l, grad_rho, f2or1, ker_ex )
!       Call calc_kt_cr_ggapbe( nspin, ispin, chgrhr_l, grad_trho, f2or1, ker_cr )
!    endif
! ---------------------------------------------------
!      ker_ex = 0.0d0; ker_cr = 0.0d0
    Do ni=1, ispin
       Do nj=1, ispin
          if ( ni==nj ) then
             Do i=ista_fftph, iend_fftph
                ker_cr(i,ni,nj) = ker_ex(i,ni) + ker_cr(i,ni,nj)
             End do
          endif
       End do
    End do
! ---------------------- debug ----
!    ker_cr(:,1,1) = chgrhr_l(:,1)     ! atteru.
!    return
! ----------------------- only for experimtal ---
!            see. A. Marini et al, Comp.  Phys. Comm. 180 (2009) 1392.
! 
! -----------------------------------------------
    if ( sw_Fxc_enhanced == ON ) ker_cr = ker_cr * 2.0d0
!    if ( sw_Fxc_enhanced ) ker_cr = ker_cr * PAI
  end subroutine Calc_Kernels_ALDA_Rspace

end module m_LinearResponse_ALDA

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINES: mpi_init, mpi_finalize, mpi_comm_size, mpi_comm_rank,
!              mpi_barrier, mpi_send, mpi_recv, mpi_comm_dup, mpi_comm_split,
!              mpi_bcast, mpi_allgather, mpi_allgatherv, mpi_allreduce
!              mpi_copy, getarg, mpi_dummy
!
!  AUTHOR(S): H. Tsukioka   November/02/2003
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
! $Id: mpi_dummy.F90 570 2017-04-21 20:34:50Z yamasaki $
#ifdef _NO_MPI_

subroutine mpi_init( ierr )
        integer :: ierr
        ierr = 0
end

subroutine mpi_finalize( ierr )
        integer :: ierr
        ierr = 0
end

subroutine mpi_abort(icomm, errorcode, ierr )
        integer :: icomm, errorcode, ierr
        errorcode=0
        ierr=0
end

subroutine mpi_comm_size( icomm, isize, ierr )
        integer :: icomm, isize, ierr
        isize = 1
        ierr  = 0
end

subroutine mpi_comm_rank( icomm, irank, ierr )
        integer :: icomm, irank, ierr
        irank = 0
        ierr  = 0
end

subroutine mpi_barrier( icomm, ierr )
        integer :: icomm, ierr
        ierr = 0
end

subroutine mpi_send( buf, icount, itype, idest, itag, icomm, ierr )
	integer :: icount, itype, idest, itag, icomm, ierr
	ierr = 0
end

subroutine mpi_isend( buf, icount, itype, idest, itag, icomm, irequest, ierr )
	integer :: icount, itype, idest, itag, icomm, irequest,ierr
	ierr = 0
end

subroutine mpi_recv( buf, icount, itype, isource, itag, icomm, istatus, ierr )
	integer :: icount, itype, isource, itag, icomm, istatus, ierr
	ierr = 0
end

subroutine mpi_irecv( buf, icount, itype, isource, itag, icomm, irequest, ierr )
	integer :: icount, itype, isource, itag, icomm, irequest, ierr
	ierr = 0
end

subroutine mpi_wait( irequest, istatus, ierr )
	integer :: irequest, istatus, ierr
	ierr = 0
end

subroutine mpi_comm_dup( icomm1, icomm2, ierr )
        integer :: icomm1, icomm2, ierr
        icomm2 = icomm1
        ierr  = 0
end

subroutine mpi_comm_split( icomm_in, icolor, ikey, icomm_out, ierr )
        integer :: icomm_in, icolor, ikey, icomm_out, ierr
        icomm_out = icomm_in
        ierr = 0
end

subroutine mpi_comm_free(  icomm1, ierr )
        integer :: icomm1, ierr
        ierr  = 0
end

subroutine mpi_bcast( buf, icount, itype, iroot, icomm, ierr )
	integer :: icount, itype, iroot, icomm, ierr
	ierr = 0
end

subroutine mpi_allgather( send_buf, isend_count, isend_type, &
           &  recv_buf, irecv_counts, irecv_type, icomm, ierr )
	integer    :: isend_count, isend_type
	integer    :: irecv_counts, irecv_type
	integer    :: icomm, ierr
	logical(4) :: send_buf(isend_count*2), recv_buf(isend_count*2)
	call mpi_copy( send_buf, recv_buf, isend_count, itype, ierr )
end

subroutine mpi_allgatherv( send_buf, isend_count, isend_type, &
           &  recv_buf, irecv_counts, idispls, irecv_type, icomm, ierr )
	integer    :: isend_count, isend_type
	integer    :: irecv_counts, idispls, irecv_type
	integer    :: icomm, ierr
	logical(4) :: send_buf(isend_count*2), recv_buf(isend_count*2)
	call mpi_copy( send_buf, recv_buf, isend_count, itype, ierr )
end

subroutine mpi_allreduce( send_buf, recv_buf, icount, itype, iop, icomm, ierr )
	integer    :: icount, itype, iop, icomm, ierr
	logical(4) :: send_buf(icount*2), recv_buf(icount*2)
	call mpi_copy( send_buf, recv_buf, icount, itype, ierr )
end

subroutine mpi_alltoall(send_buf,icount,itype,iroot,icomm,ierr)
    include 'mpif.h'
    integer    :: icount, itype, iroot, icomm, ierr
	logical(4) :: send_buf(icount*2)
end

subroutine mpi_copy( send_buf, recv_buf, icount, itype, ierr )
	include 'mpif.h'
	integer    :: icount, itype, ierr
	logical(4) :: send_buf(icount*2), recv_buf(icount*2)
	integer    :: i,ii
        ii = send_buf(1)
        if(ii .eq. MPI_IN_PLACE)then
            return
        endif

	if ( itype == MPI_DOUBLE_PRECISION ) then
		do i = 1, icount*2
			recv_buf(i) = send_buf(i)
		end do
		ierr = 0
	else if ( itype == MPI_INTEGER ) then
		do i = 1, icount
			recv_buf(i) = send_buf(i)
		end do
		ierr = 0
        else if ( itype == MPI_LOGICAL ) then
		do i = 1, icount
			recv_buf(i) = send_buf(i)
		end do
	else
		print *, 'Error in mpi_copy'
		print *, itype
		ierr = 1
	end if
end

subroutine mpi_sendrecv(sendbuf,sendcount,sendtype,dest,sendtag,recvbuf,recvcount,recvtype,source,recvtag,comm,status,ierr)
        integer :: sendcount,sendtype,dest,sendtag,recvcount,recvtype,source,recvtag,comm,status,ierr
        logical(4) :: sendbuf(sendcount*2),recvbuf(recvcount*2)
        call mpi_copy( sendbuf, recvbuf, sendcount, sendtype, ierr )
end

#ifndef _NO_ARG_DUMMY_
function iargc()
	iargc = 0
end

subroutine getarg(i,buf)
	integer      :: i
	character(*) :: buf
end
#endif

#else

subroutine mpi_dummy()
end

#endif

! Copyright (c) 2012, Minoru Otani <minoru.otani@aist.go.jp> 
! 
! Permission is hereby granted, free of charge, to any person 
! obtaining a copy of this software and associated documentation 
! files (the "Software"), to deal in the Software without restriction, 
! including without limitation the rights to use, copy, modify, merge, 
! publish, distribute, sublicense, and/or sell copies of the Software, 
! and to permit persons to whom the Software is furnished to do so, 
! subject to the following conditions:
 
! The above copyright notice and this permission notice shall be 
! included in all copies or substantial portions of the Software.
 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
! OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
! NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
! HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
! WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
! DEALINGS IN THE SOFTWARE.

Module ESM_VARS
  !
  ! constants
  !
  Integer, Parameter :: gstart = 2
  Real(8), Parameter :: dual = 8d0

  Integer, Parameter :: esm_nfit = 4
!  Real(8), Parameter :: esm_w = 0d0
!  Real(8), Parameter :: esm_efield = 0d0
  Real(8)            :: esm_w = 0d0
  Real(8)            :: esm_efield = 0d0

  REAL(8), Parameter :: pi  = 3.141592653589793238d0
  REAL(8), Parameter :: tpi = 2d0 * pi
  REAL(8), Parameter :: fpi = 4d0 * pi
  Real(8), Parameter :: eps8 = 1d-8

  !
  ! Parameter from input file
  !
  Integer              :: nat              ! Number of Atoms
  Real(8), Allocatable :: tau(:,:)         ! Coordinates of Atoms
  Real(8)              :: at(3,3)          ! Lattice Vectors
  Real(8)              :: alat             ! Lattice Parameter
  Integer              :: nr1x, nr2x, nr3x ! FFT Grid 
  CHARACTER (LEN=3)    :: esm_bc           ! Boundary Condition for ESM
  Logical              :: gamma_only       ! gamma only

  Real(8)              :: bg(3,3)          ! Reciprocal Lattice Vectors
  Real(8)              :: omega
  Real(8), Allocatable :: upf_zp(:)
  Real(8)              :: tpiba2, ecutwfc, gcutm
  Integer              :: nrxx

  Integer                 :: ngm, nspin
  Integer,    Allocatable :: mill(:,:), nl(:), nlm(:)
  Complex(8), Allocatable :: rhog_(:,:)
  !
  INTEGER              :: ngm_2d = 0
  INTEGER, Allocatable :: mill_2d(:,:), imill_2d(:,:)
  !

  Real(8)              :: gew=-1

  COMPLEX(8), Allocatable :: vbar(:)
  Real(8)                 :: z_wall
  Real(8)                 :: bar_height
  Real(8)                 :: bar_width
  Integer                 :: izwall=0
  INTEGER              :: communicator
  INTEGER              :: npes,mype

End Module ESM_VARS

Subroutine SetupEsmVars( inputfile )
  Use ESM_VARS
  Implicit None
  !
  Character(256), Intent(In) :: inputfile
  !
  Integer :: ig, n1, n2, n3, i
  Real(8) :: at12(3)
  Character(256) :: key
  Real(8), External :: InnerProd
  Character(2) :: atom

!
! read from input file
!
  gamma_only = .False.
  Open(10, file=inputfile, status='old')
  Do While( .True. )
     Read(10,'(A256)',end=999) key
     If( key == "nat" ) Then
        Read(10,*) nat
        If( .Not. Allocated(tau)    ) Allocate( tau(3,nat)  )
        If( .Not. Allocated(upf_zp) ) Allocate( upf_zp(nat) )
     Else If( key == "positions" ) Then
        Do i = 1, nat
           Read(10,*) atom, tau(1:3,i)
           If( atom == "H" ) upf_zp(i) = 1.0
           If( atom == "O" ) upf_zp(i) = 6.0
        End Do
     Else If( key == "lattice" ) Then
        Do i = 1, 3
           Read(10,*) at(1:3,i)
        End Do
     Else If( key == "alat" ) Then
        Read(10,*) alat
     Else If( key == "grids" ) Then
        Read(10,*) nr1x, nr2x, nr3x
     Else If( key == "ecutwfc" ) Then
        Read(10,*) ecutwfc
     Else If( key == "esm_bc" ) Then
        Read(10,*) esm_bc
     Else If( key == "gamma" ) Then
        gamma_only = .True.
     End If
  End Do
999 continue
  Close(10)

! calculate parameters
  Call OuterProd( at(1,1), at(1,2), at12 )
  omega = InnerProd( at12, at(1,3) ) * ( alat ** 3 )

  tpiba2 = ( tpi / alat ) ** 2
  gcutm = dual * ecutwfc / tpiba2

  Call MakeRecLatVec( at, bg )

  nrxx = nr1x * nr2x * nr3x

  Return
End Subroutine SetupEsmVars

Subroutine DeallocEsmVars()
  Use ESM_VARS
  Implicit None
  
  If( Allocated( tau      ) ) deAllocate( tau      )
  If( Allocated( upf_zp   ) ) deAllocate( upf_zp   )
  If( Allocated( mill     ) ) deAllocate( mill     )
  If( Allocated( nl       ) ) deAllocate( nl       )
  If( Allocated( nlm      ) ) deAllocate( nlm      )
  If( Allocated( rhog_    ) ) deAllocate( rhog_    )
  If( Allocated( mill_2d  ) ) deAllocate( mill_2d  )
  If( Allocated( imill_2d ) ) deAllocate( imill_2d )

  Return
End Subroutine DeallocEsmVars


Subroutine ReadRhog( rhogfile )
  Use ESM_VARS
  Implicit None
  !
  Character(256), Intent(In) :: rhogfile
  !
  Integer :: n1, n2, n3, ig
  
  Open(11,file=rhogfile,status='old')
  Read(11,*) ngm, nspin
  Allocate( rhog_(ngm,nspin), mill(3,ngm), nl(ngm), nlm(ngm) )
  Do ig = 1, ngm
     If( nspin==1 ) Then
        Read(11,*) n1,n2,n3,nl(ig),nlm(ig),rhog_(ig,1)
     Else
        Read(11,*) n1,n2,n3,nl(ig),nlm(ig),rhog_(ig,1:2)
     End If
     mill(1,ig) = n1
     mill(2,ig) = n2
     mill(3,ig) = n3
  End Do
  Close(11)
  Return
End Subroutine ReadRhog

SUBROUTINE esm_ggen_2d()
  Use ESM_VARS
  IMPLICIT NONE
  !
  INTEGER :: n1xh, n2xh, ng, n1, n2, ng_2d
  LOGICAL, ALLOCATABLE :: do_mill_2d(:,:)
  Real(8) :: tt,t(3)
  !
  !     Make g parallel array
  !
  n1xh = nr1x / 2
  n2xh = nr2x / 2
  ALLOCATE( do_mill_2d(-n1xh:n1xh,-n2xh:n2xh) )
  do_mill_2d(:,:) = .false.

  Do ng = 1, ngm
     n1 = mill(1,ng)
     n2 = mill(2,ng)
     do_mill_2d(n1,n2) = .true.
  End Do
  ngm_2d = COUNT( do_mill_2d )
  
  ALLOCATE( mill_2d(2,ngm_2d), imill_2d(-n1xh:n1xh,-n2xh:n2xh) )
  mill_2d(:,:) = 0
  imill_2d(:,:) = 0
  ng_2d = 1
  DO n1 = -n1xh, n1xh
  DO n2 = -n2xh, n2xh
     IF( do_mill_2d(n1,n2) ) THEN
        mill_2d(1,ng_2d) = n1
        mill_2d(2,ng_2d) = n2
        imill_2d(n1,n2) = ng_2d
        ng_2d = ng_2d + 1
     ENDIF
  ENDDO
  ENDDO
  DEALLOCATE(do_mill_2d)  

  allocate(vbar(nr3x));vbar(:) = (0.d0,0.d0)

  RETURN
END SUBROUTINE esm_ggen_2d

!-----------------------------------------------------------------------
!--------------ESM HARTREE SUBROUTINE-----------------------------------
!-----------------------------------------------------------------------
SUBROUTINE esm_hartree (rhog, ehart, aux )
  Use ESM_VARS
  IMPLICIT NONE
!#ifdef __MPI__
!  include 'mpif.h'
!#endif
  !
  COMPLEX(8) :: rhog(ngm,nspin)   !  n(G)
  REAL(8),    Intent(Out) :: ehart             !  Hartree energy
  COMPLEX(8), Intent(Out) :: aux(nrxx)         !  v_h(G)
  !
  !    here the local variables
  !
  real(8)                 :: tt, t(2), zz, gz, z0, gp, gp2, z1, kn, cc, ss, z, L, &
       z_l, z_r, eh
  integer                  :: ipol, k, k1, k2, k3, iz, ng, n1, n2, n3, &
       nz_r, nz_l, ng_2d
  complex(8),allocatable  :: rhog3(:,:), vg2(:), vg2_in(:), vg3(:,:),vg3_mpi(:,:,:)
  complex(8)              :: xc, ci, tmp, tmp1, tmp2, tmp3, tmp4, f1, f2, f3, f4, &
       a0, a1, a2, a3, c_r, c_l, s_r, s_l, rg3
  integer :: ierr,n1h,n2h
  allocate(rhog3(nr3x,ngm_2d))
  !
  ! Map to FFT mesh (nr3x,ngm_2d)
  rhog3(:,:)=(0.d0,0.d0)
  do ng=1,ngm
     n1 = mill(1,ng)
     n2 = mill(2,ng)
     ng_2d = imill_2d(n1,n2)
     n3 = mill(3,ng)+1
     IF (n3<1) n3 = n3 + nr3x
     if (nspin == 2) then
        rg3 = rhog(ng,1)+rhog(ng,2)
     else
        rg3 = rhog(ng,1)
     endif
     rhog3(n3,ng_2d)=rg3
     if ( gamma_only .and. n1==0 .and. n2==0 ) then
        n3 = -mill(3,ng)+1
        IF (n3<1) n3 = n3 + nr3x
        rhog3(n3,ng_2d)=CONJG(rg3)
     endif
  enddo

  ! End mapping
  !
  allocate(vg3(nr3x,ngm_2d))
  vg3(:,:)=(0.d0,0.d0)
  L=at(3,3)*alat
  z0=L/2.d0
  z1=z0+abs(esm_w)
  ci=(0.d0,1.d0)

!****For gp!=0 case ********************
!$omp parallel private( k1, k2, gp2, ipol, t, gp, tmp1, tmp2, vg2, iz, kn, &
!$omp                   cc, ss, tmp, vg2_in, k3, z, rg3 )
  allocate(vg2(nr3x),vg2_in(nr3x))
!$omp do
  do ng_2d = 1, ngm_2d
     k1 = mill_2d(1,ng_2d)
     k2 = mill_2d(2,ng_2d)
     if(k1==0.and.k2==0) cycle
     t(1:2) = k1 * bg (1:2, 1) + k2 * bg (1:2, 2)
     gp2 = sum( t(:) * t(:) ) * tpiba2
     gp=sqrt(gp2)
     tmp1=(0.d0,0.d0); tmp2=(0.d0,0.d0)
     vg2(:)=(0.d0,0.d0)
     do iz=1, nr3x
        if(iz<=nr3x/2) kn=dble(iz-1)     * tpi/L
        if(iz> nr3x/2) kn=dble(iz-1-nr3x) * tpi/L
        cc=cos(kn*z0)
        ss=sin(kn*z0)
        rg3=rhog3(iz,ng_2d)
        vg2(iz)=fpi*rg3/(gp**2+kn**2)
        if (esm_bc.eq.'bc1') then
           tmp1=tmp1+rg3*(cc+ci*ss)/(gp-ci*kn)
           tmp2=tmp2+rg3*(cc-ci*ss)/(gp+ci*kn)
        else if (esm_bc.eq.'bc2') then
           tmp=((gp+ci*kn)*exp(gp*(z1-z0))+(gp-ci*kn)*exp(-gp*(z1-z0)))/(2.d0*gp)
           tmp1=tmp1+rg3*(cc+ci*ss)/(gp**2+kn**2)*tmp
           tmp=((gp-ci*kn)*exp(gp*(z1-z0))+(gp+ci*kn)*exp(-gp*(z1-z0)))/(2.d0*gp)
           tmp2=tmp2+rg3*(cc-ci*ss)/(gp**2+kn**2)*tmp
        else if (esm_bc.eq.'bc3') then
           tmp=((gp+ci*kn)*exp(gp*(z1-z0))+(gp-ci*kn)*exp(-gp*(z1-z0)))/(2.d0*gp)
           tmp1=tmp1+rg3*(cc+ci*ss)/(gp**2+kn**2)*tmp
           tmp=(gp-ci*kn)/gp
           tmp2=tmp2+rg3*(cc-ci*ss)/(gp**2+kn**2)*tmp
        endif
     enddo

     vg2_in(1:nr3x)=vg2(1:nr3x)  ! Since cft_1z is not in-place
     call cft_1z(vg2_in,1,nr3x,nr3x,1,vg2)

     do iz=1,nr3x
        k3=iz-1
        if (k3.gt.nr3x/2) k3=iz-nr3x-1
        z=dble(k3)/dble(nr3x)*L
        if (esm_bc.eq.'bc1') then
           vg2(iz)=vg2(iz)-2.d0*pi/gp*(exp(gp*(z-z0))*tmp1+exp(-gp*(z+z0))*tmp2)
        else if (esm_bc.eq.'bc2') then
           vg2(iz)=vg2(iz)-fpi*(exp(gp*(z-z1))-exp(-gp*(z+3.d0*z1)))*tmp1 &
                         /(1.d0-exp(-4.d0*gp*z1)) &
                          +fpi*(exp(gp*(z-3.d0*z1))-exp(-gp*(z+z1)))*tmp2 &
                         /(1.d0-exp(-4.d0*gp*z1))
        else if (esm_bc.eq.'bc3') then
           vg2(iz)=vg2(iz)-fpi*exp(gp*(z-z1))*tmp1 &
                +tpi*(exp(gp*(z-z0-2.d0*z1))-exp(-gp*(z+z0)))*tmp2
        endif
     enddo
        
     vg2_in(1:nr3x)=vg2(1:nr3x)  ! Since cft_1z is not in-place
     call cft_1z(vg2_in,1,nr3x,nr3x,-1,vg2)
        
     vg3(1:nr3x,ng_2d)=vg2(1:nr3x)*2.d0
  enddo
!#ifdef __MPI__
!  n1h=nr1x/2;n2h=nr2x/2
!  allocate(vg3_mpi(1:nr3x,-n2h:n2h,-n1h:n1h));vg3_mpi(:,:,:)=(0.d0,0.d0)
!  do ng_2d=1,ngm_2d
!     k1 = mill_2d(1,ng_2d)
!     k2 = mill_2d(2,ng_2d)
!     vg3_mpi(:,k2,k1) = vg3(:,ng_2d)
!  enddo
!  call mpi_allreduce(MPI_IN_PLACE,vg3_mpi,nr3x*nr2x*nr1x,mpi_double_complex,mpi_sum,communicator,ierr)
!  do ng_2d=1,ngm_2d
!     k1 = mill_2d(1,ng_2d)
!     k2 = mill_2d(2,ng_2d)
!     vg3(:,ng_2d) = vg3_mpi(:,k2,k1)
!  enddo
!  deallocate(vg3_mpi)
!#endif
  deallocate(vg2,vg2_in)
!$omp end parallel  

!****For gp=0 case ********************
  ng_2d = imill_2d(0,0)
  if( ng_2d > 0 ) then
     allocate(vg2(nr3x),vg2_in(nr3x))
     tmp1=(0.d0,0.d0); tmp2=(0.d0,0.d0); tmp3=(0.d0,0.d0); tmp4=(0.d0,0.d0)
     !for smoothing
     f1=(0.d0,0.d0); f2=(0.d0,0.d0); f3=(0.d0,0.d0); f4=(0.d0,0.d0)
     nz_l=nr3x/2+1+esm_nfit
     nz_r=nr3x/2+1-esm_nfit
     z_l=dble(nz_l-1)*L/dble(nr3x)-L
     z_r=dble(nz_r-1)*L/dble(nr3x)
     !
     rg3=rhog3(1,ng_2d)
     if (esm_bc.eq.'bc1') then
        vg2(1)=-tpi*z0**2*rg3
     else if (esm_bc.eq.'bc2') then
        vg2(1)= tpi*(2.d0*z1-z0)*z0*rg3
     else if (esm_bc.eq.'bc3') then
        vg2(1)= tpi*(4.d0*z1-z0)*z0*rg3
     endif
     do iz=2,nr3x
        if(iz<=nr3x/2) kn=dble(iz-1)     *tpi/L
        if(iz> nr3x/2) kn=dble(iz-1-nr3x) *tpi/L
        cc=cos(kn*z0)
        ss=sin(kn*z0)
        rg3=rhog3(iz,ng_2d)
        if (esm_bc.eq.'bc1') then
           tmp1=tmp1+rg3*ci*(cc+ci*ss)/kn
           tmp2=tmp2+rg3*ci*(cc-ci*ss)/kn
           tmp3=tmp3+rg3*cc/kn**2
           tmp4=tmp4+(0.d0,0.d0)
        else if (esm_bc.eq.'bc2') then
           tmp1=tmp1+rg3*(cc+ci*ss)/kn**2
           tmp2=tmp2+rg3*(cc-ci*ss)/kn**2
           tmp3=tmp3+rg3*ci*cc/kn
           tmp4=tmp4+rg3*ss/kn
        else if (esm_bc.eq.'bc3') then
           tmp1=tmp1+rg3*(cc+ci*ss)/kn**2
           tmp2=tmp2+rg3*(cc-ci*ss)/kn
           tmp3=tmp3+rg3*(cc+ci*ss)/kn
           tmp4=tmp4+(0.d0,0.d0)
        endif
        vg2(iz)=fpi*rg3/(kn**2)
        !for smoothing
        c_r=cos(kn*z_r)
        s_r=sin(kn*z_r)
        c_l=cos(kn*z_l)
        s_l=sin(kn*z_l)
        f1=f1+fpi*   rg3*(c_r+ci*s_r)/kn**2
        f2=f2+fpi*   rg3*(c_l+ci*s_l)/kn**2
        f3=f3+fpi*ci*rg3*(c_r+ci*s_r)/kn
        f4=f4+fpi*ci*rg3*(c_l+ci*s_l)/kn
        !
     enddo
     
     vg2_in(1:nr3x)=vg2(1:nr3x)  ! Since cft_1z is not in-place
     call cft_1z(vg2_in,1,nr3x,nr3x,1,vg2)
     
     rg3=rhog3(1,ng_2d)
     do iz=1,nr3x
        k3=iz-1
        if (k3.gt.nr3x/2) k3=iz-nr3x-1
        z=dble(k3)/dble(nr3x)*L
        if (esm_bc.eq.'bc1') then
           vg2(iz)=vg2(iz)-tpi*z**2*rg3    &
                          -tpi*(z-z0)*tmp1 &
                          -tpi*(z+z0)*tmp2 &
                          -fpi*tmp3        &
                          +vbar(iz)
        else if (esm_bc.eq.'bc2') then
           vg2(iz)=vg2(iz)-tpi*z**2*rg3          &
                          -tpi*(z+z1)*tmp1/z1    &
                          +tpi*(z-z1)*tmp2/z1    &
                          -fpi*z*(z1-z0)/z1*tmp3 &
                          +fpi*(z1-z0)*tmp4      &
                          +vbar(iz)
        else if (esm_bc.eq.'bc3') then
           vg2(iz)=vg2(iz)-tpi*(z**2+2.d0*z*z0)*rg3 &
                          -fpi*tmp1                 &
                          -fpi*ci*(z-z0)*tmp2       &
                          -fpi*ci*(z1-z0)*tmp3      &
                          +vbar(iz)
        endif
     enddo
     !for smoothing
     if (esm_bc.eq.'bc1') then
        f1=f1-tpi*z_r**2*rg3 &
             -tpi*(z_r-z0)*tmp1 &
             -tpi*(z_r+z0)*tmp2 &
             -fpi*tmp3
        f1=f1-tpi*z0**2*rg3+vbar(nz_r)
        f2=f2-tpi*z_l**2*rg3 &
             -tpi*(z_l-z0)*tmp1 &
             -tpi*(z_l+z0)*tmp2 &
             -fpi*tmp3
        f2=f2-tpi*z0**2*rg3+vbar(nz_l)
        f3=f3-tpi*tmp1-tpi*tmp2-fpi*z_r*rg3+vbar(nz_r)
        f4=f4-tpi*tmp1-tpi*tmp2-fpi*z_l*rg3+vbar(nz_l)
     else if (esm_bc.eq.'bc2') then
        f1=f1-tpi*z_r**2*rg3 &
             -tpi*(z_r+z1)*tmp1/z1 &
             +tpi*(z_r-z1)*tmp2/z1 &
             -fpi*z*(z1-z0)/z1*tmp3 &
             +fpi  *(z1-z0)   *tmp4
        f1=f1+tpi*(2.d0*z1-z0)*z0*rg3+vbar(nz_r)
        f2=f2-tpi*z_l**2*rg3 &
             -tpi*(z_l+z1)*tmp1/z1 &
             +tpi*(z_l-z1)*tmp2/z1 &
             -fpi*z*(z1-z0)/z1*tmp3 &
             +fpi  *(z1-z0)   *tmp4
        f2=f2+tpi*(2.d0*z1-z0)*z0*rg3+vbar(nz_l)
        f3=f3-fpi*z_r*rg3-tpi*tmp1/z1+tpi*tmp2/z1-fpi*(z1-z0)/z1*tmp3+vbar(nz_r)
        f4=f4-fpi*z_l*rg3-tpi*tmp1/z1+tpi*tmp2/z1-fpi*(z1-z0)/z1*tmp3+vbar(nz_l)
     else if (esm_bc.eq.'bc3') then
        f1=f1-tpi*(z_r**2+2.d0*z_r*z0)*rg3 &
             -fpi*tmp1 &
             -fpi*ci*(z_r-z1)*tmp2 &
             -fpi*ci*(z1 -z0)*tmp3
        f1=f1+tpi*(4.d0*z1-z0)*z0*rg3+vbar(nz_r)
        f2=f2-tpi*(z_l**2+2.d0*z_l*z0)*rg3 &
             -fpi*tmp1 &
             -fpi*ci*(z_l-z1)*tmp2 &
             -fpi*ci*(z1 -z0)*tmp3
        f2=f2+tpi*(4.d0*z1-z0)*z0*rg3+vbar(nz_l)
        f3=f3-tpi*(2.d0*z_r+2.d0*z0)*rg3-fpi*ci*tmp2+vbar(nz_r)
        f4=f4-tpi*(2.d0*z_l+2.d0*z0)*rg3-fpi*ci*tmp2+vbar(nz_l)
     endif
     ! for smoothing
     !factor 2 will be multiplied later (at vg3 <= vg2)
     !f1=f1*2.d0; f2=f2*2.d0; f3=f3*2.d0; f4=f4*2.d0
     z_r=z_r
     z_l=z_l+L
     a0=(f1*z_l**2*(z_l-3.d0*z_r)+z_r*(f3*z_l**2*(-z_l+z_r) &
          +z_r*(f2*(3.d0*z_l-z_r)+f4*z_l*(-z_l+z_r))))/(z_l-z_r)**3
     a1=(f3*z_l**3+z_l*(6.d0*f1-6.d0*f2+(f3+2.d0*f4)*z_l)*z_r &
          -(2*f3+f4)*z_l*z_r**2-f4*z_r**3)/(z_l-z_r)**3
     a2=(-3*f1*(z_l+z_r)+3.d0*f2*(z_l+z_r)-(z_l-z_r)*(2*f3*z_l &
          +f4*z_l+f3*z_r+2*f4*z_r))/(z_l-z_r)**3
     a3=(2.d0*f1-2.d0*f2+(f3+f4)*(z_l-z_r))/(z_l-z_r)**3
     do iz=nz_r,nz_l
        z=dble(iz-1)/dble(nr3x)*L
        vg2(iz)=(a0+a1*z+a2*z**2+a3*z**3)
     enddo
     
     vg2_in(1:nr3x)=vg2(1:nr3x)  ! Since cft_1z is not in-place
     call cft_1z(vg2_in,1,nr3x,nr3x,-1,vg2)
     
     vg3(1:nr3x,ng_2d)=vg2(1:nr3x)*2.d0
     
!#ifdef __MPI__
!  call mpi_allreduce(MPI_IN_PLACE,vg3(1,ng_2d),nr3x,mpi_double_complex,mpi_sum,communicator,ierr)
!#endif
     deallocate(vg2,vg2_in)
  endif ! if( ng_2d > 0 )
  
! Hartree Energy
  ehart=0.d0
!$omp parallel private( ng_2d, k1, k2, k, eh )
  eh = 0d0
!$omp do
  do ng_2d = 1, ngm_2d
     k1 = mill_2d(1,ng_2d)
     k2 = mill_2d(2,ng_2d)
     eh = eh + sum( vg3(:,ng_2d)*conjg(rhog3(:,ng_2d)) )
  enddo
!$omp atomic
  ehart=ehart+eh
!$omp end parallel
  if( gamma_only ) then
     ehart = ehart * 2d0
     ng_2d = imill_2d(0,0)
     if( ng_2d > 0 ) then
        ehart = ehart - sum( vg3(:,ng_2d)*conjg(rhog3(:,ng_2d)) )
     endif
  endif
  ehart = ehart *omega*0.5d0
#ifdef __PARA
  call mp_sum( ehart, intra_pool_comm )
#endif
!#ifdef __MPI__
!  call mpi_allreduce(MPI_IN_PLACE,ehart,1,mpi_double_precision,mpi_sum,communicator,ierr)
!#endif

! Map to FFT mesh (nrxx)
  aux=0.0d0
  do ng=1,ngm
     n1 = mill(1,ng)
     n2 = mill(2,ng)
     ng_2d = imill_2d(n1,n2)
     n3 = mill(3,ng) + 1
     if (n3<1) n3 = n3 + nr3x
     aux(nl(ng))= aux(nl(ng)) + vg3(n3,ng_2d)
  enddo
  if (gamma_only) then
     do ng=1,ngm
        aux(nlm(ng))=CONJG(aux(nl(ng)))
     enddo
  endif
  deallocate (vg3,rhog3)
  
  RETURN
END SUBROUTINE esm_hartree

SUBROUTINE esm_ewald_r(alpha,ewaldr)
  Use ESM_VARS
  implicit none
  real(8),intent(in) :: alpha
  real(8),intent(out) :: ewaldr
  integer :: i
  ewaldr = 0.d0
  Call Ewald( nat, tau, upf_zp, at, alat, alpha, bg, ewaldr )
end SUBROUTINE esm_ewald_r

SUBROUTINE esm_ewald_g(alpha,ewaldg)
  Use ESM_VARS
  implicit none
  real(8),intent(in) :: alpha
  real(8),intent(out) :: ewaldg
  integer :: i
  ewaldg = 0.d0
  Call esm_ewald( upf_zp, alpha, ewaldg )
end SUBROUTINE esm_ewald_g

!-----------------------------------------------------------------------
!--------------ESM EWALD SUBROUTINE-------------------------------------
!-----------------------------------------------------------------------
SUBROUTINE esm_ewald ( charge, alpha, ewg )
!SUBROUTINE esm_ewald (  alpha, ewg )
  Use ESM_VARS
  implicit none
  !
#ifdef __MPI__
  include 'mpif.h'
#endif
  REAL(8), Intent(in)     :: charge(nat), alpha
  REAL(8), Intent(out)    :: ewg
  !
  !    here the local variables
  !
  real(8), external      :: qe_erfc, qe_erf
  real(8)                :: gp2, t(2), gp, sa, z1, z0, L
  integer                 :: k1, k2, k3, ipol, it1, it2, ng_2d, ierr
  real(8) :: tt, z, zp, kk1, kk2, g, cc1, cc2, arg1, arg2, t1, t2, ff, argmax, ew
#ifdef __OPENMP
  INTEGER :: nth, ith, omp_get_thread_num, omp_get_num_threads
#endif
  real(8) :: v0
  
  argmax=0.9*log(huge(1.d0))
  ewg=0.d0
  
  L=at(3,3)*alat
  z0=L/2.d0
  z1=z0+abs(esm_w)
  if(gew<0)then
  g=sqrt(alpha)
  else
  g=gew
  endif
  !g = sqrt(2.6)
  sa=omega/L
  
!$omp parallel private( nth, ith, ew, it1, it2, z, zp, tt, kk1, kk2, cc1, cc2, &
!$omp                   ng_2d, k1, k2, gp2, ipol, t, gp, ff, arg1, arg2, t1, t2 )
#ifdef __OPENMP
  nth=omp_get_num_threads()
  ith=omp_get_thread_num()
#endif
  ew=0d0
  do it1=1,nat
  do it2=1,it1
#ifdef __OPENMP
     if( mod( (it1-1)*it1/2+it2-1, nth) /= ith ) cycle
#endif
#ifdef __MPI__
     if( mod( (it1-1)*nat+it2-1, npes) /= mype ) cycle
#endif

     z=tau(3,it1)
     if (z.gt.at(3,3)*0.5) z=z-at(3,3)
     z=z*alat
     
     zp=tau(3,it2)
     if (zp.gt.at(3,3)*0.5) zp=zp-at(3,3)
     zp=zp*alat
     
     tt=upf_zp(it1)*upf_zp(it2)*2.0*pi/sa
     
     kk1=0.5d0*(-(z-zp)*qe_erf(g*(z-zp))-exp(-g**2*(z-zp)**2)/g/sqrt(pi))
     
     if (esm_bc.eq.'bc1') then
        kk2=0.d0
     else if (esm_bc.eq.'bc2') then
        kk2=0.5d0*(z1-z*zp/z1)
     else if (esm_bc.eq.'bc3') then
        kk2=0.5d0*(2.d0*z1-z-zp)
     endif
     
     cc1=0.d0
     cc2=0.d0
     
     if (it1.eq.it2) then
        
        do ng_2d = 1, ngm_2d
           k1 = mill_2d(1,ng_2d)
           k2 = mill_2d(2,ng_2d)
           if( k1==0 .and. k2==0 ) cycle
           
           t(1:2) = k1 * bg (1:2, 1) + k2 * bg (1:2, 2)
           gp2 = sum( t(:) * t(:) ) * tpiba2
           gp=sqrt(gp2)
           
           arg1=-gp*(z-zp)
           arg2= gp*(z-zp)
           arg1=min(arg1,argmax)
           arg2=min(arg2,argmax)
           t1=exp(arg1)*qe_erfc(gp/2.d0/g-g*(z-zp))
           t2=exp(arg2)*qe_erfc(gp/2.d0/g+g*(z-zp))
           cc1=cc1+(t1+t2)/4.d0/gp
           
           if (esm_bc.eq.'bc1') then
              cc2=0.d0
           else if (esm_bc.eq.'bc2') then
              cc2=cc2+(exp(gp*(z-zp-4.d0*z1))+exp(-gp*(z-zp+4.d0*z1)) &
                      -exp(gp*(z+zp-2.d0*z1))-exp(-gp*(z+zp+2.d0*z1)) ) &
                      /(1.d0-exp(-4.d0*gp*z1))/2.d0/gp
           else if (esm_bc.eq.'bc3') then
              cc2=cc2+(-exp(gp*(z+zp-2.d0*z1)))/2.d0/gp
           endif
           
        enddo
        
        if( gamma_only ) then
           cc1 = cc1 * 2d0
           cc2 = cc2 * 2d0
        endif
        ew=ew+tt*(cc1+cc2)
        if(gstart==2) ew=ew+tt*(kk1+kk2)
        
     else
        
        do ng_2d = 1, ngm_2d
           k1 = mill_2d(1,ng_2d)
           k2 = mill_2d(2,ng_2d)
           if( k1==0 .and. k2==0 ) cycle
           
           t(1:2) = k1 * bg (1:2, 1) + k2 * bg (1:2, 2)
           gp2 = sum( t(:) * t(:) ) * tpiba2
           gp=sqrt(gp2)
           
           ff = ( ( k1*bg(1,1)+k2*bg(1,2) ) * ( tau(1,it1)-tau(1,it2) )  &
              +   ( k1*bg(2,1)+k2*bg(2,2) ) * ( tau(2,it1)-tau(2,it2) ) ) * tpi
           arg1=-gp*(z-zp)
           arg2= gp*(z-zp)
           arg1=min(arg1,argmax)
           arg2=min(arg2,argmax)
           t1=exp(arg1)*qe_erfc(gp/2.d0/g-g*(z-zp))
           t2=exp(arg2)*qe_erfc(gp/2.d0/g+g*(z-zp))
           cc1=cc1+cos(ff)*(t1+t2)/4.d0/gp
           
           if (esm_bc.eq.'bc1') then
              cc2=0.d0
           else if (esm_bc.eq.'bc2') then
              cc2=cc2+cos(ff)*(exp(gp*(z-zp-4.d0*z1))+exp(-gp*(z-zp+4.d0*z1)) &
                              -exp(gp*(z+zp-2.d0*z1))-exp(-gp*(z+zp+2.d0*z1)) ) &
                              /(1.d0-exp(-4.d0*gp*z1))/2.d0/gp
           else if (esm_bc.eq.'bc3') then
              cc2=cc2+cos(ff)*(-exp(gp*(z+zp-2.d0*z1)))/2.d0/gp
           endif

        enddo
        
        if( gamma_only ) then
           cc1 = cc1 * 2d0
           cc2 = cc2 * 2d0
        endif
        ew=ew+tt*(cc1+cc2)*2d0
        if(gstart==2) ew=ew+tt*(kk1+kk2)*2d0
        
     endif
     
  enddo
  enddo
#ifdef __MPI__
  call mpi_allreduce(MPI_IN_PLACE,ew,1,mpi_double_precision,mpi_sum,communicator,ierr)
#endif
!$omp atomic
  ewg=ewg+ew
!$omp end parallel
  
  ewg=2.0*ewg
  
  if( gstart == 2 ) then
     do it1=1,nat
        ewg=ewg- upf_zp(it1) **2 * sqrt (8.d0 / tpi * alpha)
     enddo
  endif
  
  if(esm_bc.eq.'bc2')then
     v0=esm_efield*z1*2.d0/2.d0 ! factor 1/2: unit Ry. -> hartree
     do it1=1,nat
        z = tau(3,it1) 
        if (z.gt.at(3,3)*0.5) z=z-at(3,3)
        z=z*alat
        ewg = ewg-upf_zp(it1)*v0*(1.d0-z/z1)
     enddo
     ewg=ewg+v0**2*sa/(pi*8.d0)/z1
  endif

  return
end subroutine esm_ewald

subroutine esm_local(aux)
  Use ESM_VARS
  implicit none
  COMPLEX(8)             :: aux( nrxx )     ! aux contains v_loc_short(G) (input) and v_loc(G) (output)
  real(8),allocatable    :: agauss(:,:),bgauss(:,:) 
  integer :: it
  allocate(agauss(nat,1),bgauss(nat,1))
  do it=1,nat
     agauss(it,1)=1.d0
     bgauss(it,1)=1.d0
  enddo
  call esm_local_(nrxx,aux,nat,1,agauss,bgauss)
  deallocate(agauss,bgauss)
end subroutine esm_local

!-----------------------------------------------------------------------
!--------------ESM LOCAL POTENTIAL SUBROUTINE---------------------------
!-----------------------------------------------------------------------
subroutine esm_local_(nrx,aux,natm,ngauss,agauss,bgauss)
  Use ESM_VARS
  implicit none
#ifdef __MPI__
  include 'mpif.h'
#endif
  !
  integer,intent(in)       :: nrx
  COMPLEX(8),intent(inout) :: aux( nrx )     ! aux contains v_loc_short(G) (input) and v_loc(G) (output)
  integer, intent(in)      :: natm,ngauss
  real(8), intent(in)      :: agauss(natm,ngauss),bgauss(natm,ngauss)
  !
  !    here the local variables
  !
  complex(8),allocatable :: vloc3(:,:),vg2(:),vg2_in(:)
!  real(8), external      :: qe_erf, qe_erfc
  real(8)      :: qe_erf, qe_erfc
  real(8)                :: t(3),tt,gp,gp2,sa,z1,z0,pp,cc,ss,t1,t2, &
                            z,zp,arg11,arg12,arg21,arg22,v0,tmp,L,argmax, &
                            z_l,z_r
  integer                :: iz,ig,it,ipol,k1,k2,k3,ng,n1,n2,n3, &
                            nz_l,nz_r, ng_2d
  complex(8)             :: cs,cc1,cc2,ci,a0,a1,a2,a3,f1,f2,f3,f4
#ifdef __MPI__
  integer                :: ind,ierr
#endif

  argmax=0.9*log(huge(1.d0))
  L =at(3,3)*alat
  z0=L/2.d0
  z1=z0+abs(esm_w)
  allocate(vloc3(nr3x,ngm_2d))
  vloc3(:,:)=(0.d0,0.d0)
  sa=omega/L
  v0=esm_efield*z1*2.d0/2.d0 ! factor 1/2: unit Ry. -> hartree
  ci=(0.d0,1.d0)

! for gp!=0
!$omp parallel private( k1, k2, gp2, gp, vg2, it, tt, pp, cc, ss, cs, zp, iz, &
!$omp                   k3, z, cc1, ig, tmp, arg11, arg12, arg21, arg22, t1, t2, &
!$omp                   cc2, vg2_in )
  allocate(vg2(nr3x),vg2_in(nr3x))
  vg2(:) = (0.d0,0.d0);vg2_in(:) = (0.d0,0.d0)
!$omp do
  do ng_2d = 1, ngm_2d
#ifdef __MPI__
     if (mod(ng_2d,npes) /= mype) cycle
#endif
     k1 = mill_2d(1,ng_2d)
     k2 = mill_2d(2,ng_2d)
     if(k1==0.and.k2==0) cycle
     
     t(1:2) = k1 * bg (1:2, 1) + k2 * bg (1:2, 2)
     gp2 = sum( t(:) * t(:) ) * tpiba2
     gp=sqrt(gp2)
     
     vg2(1:nr3x)=(0.d0,0.d0)
     do it=1,nat
        tt=-fpi*upf_zp(it)/sa
        pp=-tpi*(tau(1,it)*(k1*bg(1,1)+k2*bg(1,2))+tau(2,it)*(k1*bg(2,1)+k2*bg(2,2)))
        cc=cos(pp)
        ss=sin(pp)
        cs=CMPLX ( cc, ss, kind=8 )
        zp=tau(3,it)
        if (zp.gt.at(3,3)*0.5) zp=zp-at(3,3)
        zp=zp*alat
        do iz=1,nr3x
           k3=iz-1
           if (k3.gt.nr3x/2) k3=iz-nr3x-1
           z=dble(k3)/dble(nr3x)*L
           cc1=(0.d0,0.d0)
           do ig=1,ngauss
              tmp=sqrt(agauss(it,ig))
              arg11=-gp*(z-zp)
              arg11=min(arg11,argmax)
              arg12= gp/2.d0/tmp-tmp*(z-zp)
              arg21= gp*(z-zp)
              arg21=min(arg21,argmax)
              arg22= gp/2.d0/tmp+tmp*(z-zp)
              t1=exp(arg11)*qe_erfc(arg12)
              t2=exp(arg21)*qe_erfc(arg22)
              cc1=cc1+bgauss(it,ig)*cs*(t1+t2)/4.d0/gp
           enddo
           if (esm_bc.eq.'bc1') then
              cc2=(0.d0,0.d0)
           else if (esm_bc.eq.'bc2') then
              cc2=cs*( exp(gp*(z-zp-4.d0*z1))+exp(-gp*(z-zp+4.d0*z1)) &
                      -exp(gp*(z+zp-2.d0*z1))-exp(-gp*(z+zp+2.d0*z1))) &
                      /(1.d0-exp(-4.d0*gp*z1))/2.d0/gp 
           else if (esm_bc.eq.'bc3') then
              cc2=cs*(-exp(gp*(z+zp-2.d0*z1)))/2.d0/gp
           endif
           vg2(iz) = vg2(iz) + tt*(cc1+cc2)*2.d0 ! factor 2: hartree -> Ry.
        enddo
     enddo
     vg2_in(1:nr3x)=vg2(1:nr3x)
     call cft_1z(vg2_in,1,nr3x,nr3x,-1,vg2)
     do iz=1,nr3x
        vloc3(iz,ng_2d)=vg2(iz)
     enddo
  enddo
#ifdef __MPI__
  call mpi_allreduce(MPI_IN_PLACE,vloc3,nr3x * ngm_2d,mpi_double_complex,mpi_sum,communicator,ierr)
#endif
  deallocate(vg2,vg2_in)
!$omp end parallel

  ng_2d=imill_2d(0,0)
  if( ng_2d > 0 ) then
     allocate(vg2(nr3x),vg2_in(nr3x))

     vg2(1:nr3x)=(0.d0,0.d0)
! for smoothing
     f1=0.d0; f2=0.d0; f3=0.d0; f4=0.d0
     nz_l=nr3x/2+1+esm_nfit
     nz_r=nr3x/2+1-esm_nfit
     z_l=dble(nz_l-1)*L/dble(nr3x)-L
     z_r=dble(nz_r-1)*L/dble(nr3x)
! add constant potential (capacitor term)
     do iz=1,nr3x
        k3=iz-1
        if (k3.gt.nr3x/2) k3=iz-nr3x-1
        z=dble(k3)/dble(nr3x)*L
        vg2(iz)=-0.5d0*v0*(z-z1)/z1*2.d0 ! factor 2: hartree -> Ry.
     enddo
     f1=-0.5d0*v0*(z_r-z1)/z1 ! unit: hartree
     f2=-0.5d0*v0*(z_l-z1)/z1 ! unit: hartree
     f3=-0.5d0*v0/z1 ! unit: hartree/a.u.
     f4=-0.5d0*v0/z1 ! unit: harteee/a.u.
! for gp=0
     do it=1,nat
        tt=-fpi*upf_zp(it)/sa
        zp=tau(3,it)
        if (zp.gt.at(3,3)*0.5) zp=zp-at(3,3)
        zp=zp*alat
        do iz=1,nr3x
           k3=iz-1
           if (k3.gt.nr3x/2) k3=iz-nr3x-1
           z=dble(k3)/dble(nr3x)*L
           cc1=(0.d0,0.d0) 
           do ig=1,ngauss
              tmp=sqrt(agauss(it,ig))
              cc1=cc1+bgauss(it,ig)*0.5d0*(-(z-zp)*qe_erf(tmp*(z-zp)) &
                   -exp(-tmp**2*(z-zp)**2)/tmp/sqrt(pi))
           enddo
           if (esm_bc.eq.'bc1') then
              cc2=(0.d0,0.d0)
           else if (esm_bc.eq.'bc2') then
              cc2=0.5d0*(z1-z*zp/z1)
           else if (esm_bc.eq.'bc3') then
              cc2=0.5d0*(2.d0*z1-z-zp)
           endif
           vg2(iz) = vg2(iz) + tt*(cc1+cc2)*2.d0 ! factor 2: hartree -> Ry.
        enddo
     ! smoothing cell edge potential (avoiding unphysical oscillation)
        do ig=1,ngauss
           tmp=sqrt(agauss(it,ig))
           f1=f1+tt*bgauss(it,ig)*0.5d0*(-(z_r-zp)*qe_erf(tmp*(z_r-zp)) &
                -exp(-tmp**2*(z_r-zp)**2)/tmp/sqrt(pi))
           f2=f2+tt*bgauss(it,ig)*0.5d0*(-(z_l-zp)*qe_erf(tmp*(z_l-zp)) &
                -exp(-tmp**2*(z_l-zp)**2)/tmp/sqrt(pi))
           f3=f3-tt*bgauss(it,ig)*0.5d0*qe_erf(tmp*(z_r-zp))
           f4=f4-tt*bgauss(it,ig)*0.5d0*qe_erf(tmp*(z_l-zp))
        enddo
        if(esm_bc.eq.'bc1')then
           f1=f1+tt*0.d0
           f2=f2+tt*0.d0
           f3=f3+tt*0.d0
           f4=f4+tt*0.d0
        elseif(esm_bc.eq.'bc2')then
           f1=f1+tt*0.5d0*(z1-z_r*zp/z1)
           f2=f2+tt*0.5d0*(z1-z_l*zp/z1)
           f3=f3+tt*(-0.5d0*(zp/z1))
           f4=f4+tt*(-0.5d0*(zp/z1))
        elseif(esm_bc.eq.'bc3')then
           f1=f1+tt*0.5d0*(2.d0*z1-z_r-zp)
           f2=f2+tt*0.5d0*(2.d0*z1-z_l-zp)
           f3=f3-tt*0.5d0
           f4=f4-tt*0.5d0
        endif
     enddo
     ! for smoothing
     f1=f1*2.d0; f2=f2*2.d0; f3=f3*2.d0; f4=f4*2.d0 ! factor 2: hartree -> Ry.
     z_r=z_r
     z_l=z_l+L
     a0=(f1*z_l**2*(z_l-3.d0*z_r)+z_r*(f3*z_l**2*(-z_l+z_r) &
          +z_r*(f2*(3.d0*z_l-z_r)+f4*z_l*(-z_l+z_r))))/(z_l-z_r)**3
     a1=(f3*z_l**3+z_l*(6.d0*f1-6.d0*f2+(f3+2.d0*f4)*z_l)*z_r &
          -(2*f3+f4)*z_l*z_r**2-f4*z_r**3)/(z_l-z_r)**3
     a2=(-3*f1*(z_l+z_r)+3.d0*f2*(z_l+z_r)-(z_l-z_r)*(2*f3*z_l &
          +f4*z_l+f3*z_r+2*f4*z_r))/(z_l-z_r)**3
     a3=(2.d0*f1-2.d0*f2+(f3+f4)*(z_l-z_r))/(z_l-z_r)**3
     do iz=nz_r,nz_l
        z=dble(iz-1)/dble(nr3x)*L
        vg2(iz)=(a0+a1*z+a2*z**2+a3*z**3)
     enddo
     vg2_in(1:nr3x)=vg2(1:nr3x)
     call cft_1z(vg2_in,1,nr3x,nr3x,-1,vg2)
     do iz=1,nr3x
        vloc3(iz,ng_2d)=vg2(iz)
     enddo
     
     deallocate(vg2,vg2_in)
  endif ! if( ng_2d > 0 )
  
! Map to FFT mesh (nrxx)
  do ng=1,ngm
     n1 = mill(1,ng)
     n2 = mill(2,ng)
     ng_2d = imill_2d(n1,n2)
     n3 = mill(3,ng) + 1 
     IF (n3<1) n3 = n3 + nr3x
     aux(nl(ng))= aux(nl(ng)) + vloc3(n3,ng_2d)
  enddo
  if (gamma_only) then
     do ng=1,ngm
        aux (nlm(ng))=CONJG(aux(nl(ng)))
     enddo
  endif

  deallocate(vloc3)

  return
  end subroutine esm_local_

!-----------------------------------------------------------------------
!--------------ESM EWALD-DERIVED FORCE SUBROUTINE-----------------------
!-----------------------------------------------------------------------
subroutine esm_force_ew ( alpha, forceion ) 
  Use ESM_VARS
  implicit none
#ifdef __MPI__
  include 'mpif.h'
#endif
  !
  REAL(8)                :: alpha
  REAL(8)                :: forceion(3,nat) 
  !
  !    here the local variables
  !
  real(8), external      :: qe_erfc, qe_erf
  integer  :: it1, it2, ipol, k1, k2, k3, ng_2d
  integer  :: nth, ith, omp_get_num_threads, omp_get_thread_num,ierr
  real(8) :: t1_for, t2_for, z, zp, kk1_for, kk2_for, g, gp2, gp, z1, t(2), L
  real(8) :: cx1_for, cy1_for, cz1_for, cx2_for, cy2_for, cz2_for, arg1, arg2, t1, t2, ff
  real(8) :: sa, z0, g_b,tauz1,tauz2,gt,tt,gz,argmax
  real(8), allocatable :: for(:,:), for_g(:,:)
  real(8) :: v0

  argmax=0.9*log(huge(1.d0))
  allocate(for_g(3,nat))
  for_g(:,:)=0.d0
  
  forceion(:,:)=0.d0
  L=at(3,3)*alat
  z0=L/2.d0
  z1=z0+abs(esm_w) 
  sa=omega/L
  g=sqrt(alpha)

!$omp parallel private( nth, ith, for, z, zp, t1_for, t2_for, kk1_for, kk2_for, &
!$omp                   cz1_for, cz2_for, ng_2d, k1, k2, gp2, gp, arg1, arg2, t1, t2, &
!$omp                   cx1_for, cy1_for, cx2_for, cy2_for, ff, t )
#ifdef __OPENMP
  nth=omp_get_num_threads()
  ith=omp_get_thread_num()
#endif
  allocate(for(3,nat))
  for=0d0
  do it1=1,nat
  do it2=1,nat
#ifdef __OPENMP
     if( mod( (it1-1)*nat+it2-1, nth) /= ith ) cycle
#endif
#ifdef __MPI__
     if( mod( (it1-1)*nat+it2-1, npes) /= mype ) cycle
#endif
     z=tau(3,it1)
     if (z.gt.at(3,3)*0.5) z=z-at(3,3)
     z=z*alat
     zp=tau(3,it2)
     if (zp.gt.at(3,3)*0.5) zp=zp-at(3,3)
     zp=zp*alat
     if (gamma_only) then 
        t1_for=upf_zp(it1)*upf_zp(it2)*fpi/sa*2.d0
     else
        t1_for=upf_zp(it1)*upf_zp(it2)*fpi/sa
     endif
     t2_for=upf_zp(it1)*upf_zp(it2)*fpi/sa

     kk1_for=0.5d0*qe_erf(g*(z-zp))
     if (esm_bc.eq.'bc1') then
        kk2_for=0.d0
     else if (esm_bc.eq.'bc2') then
        kk2_for=-0.5d0*(z/z1)
     else if (esm_bc.eq.'bc3') then
        kk2_for=-0.5d0
     endif
  
     if (it1.eq.it2) then
        cz1_for=0.d0
        cz2_for=0.d0
        
        do ng_2d = 1, ngm_2d
           k1 = mill_2d(1,ng_2d)
           k2 = mill_2d(2,ng_2d)
           if( k1==0 .and. k2==0 ) cycle

           t(1:2) = k1 * bg (1:2, 1) + k2 * bg (1:2, 2)
           gp2 = sum( t(:) * t(:) ) * tpiba2
           gp=sqrt(gp2)
           
           arg1=-gp*(z-zp)
           arg2= gp*(z-zp)
           arg1=min(arg1,argmax)
           arg2=min(arg2,argmax)
           t1=exp(arg1)*qe_erfc(gp/2.d0/g-g*(z-zp))
           t2=exp(arg2)*qe_erfc(gp/2.d0/g+g*(z-zp))
           cz1_for=0.d0
           if (esm_bc.eq.'bc1') then      
              cz2_for=0.d0
           else if (esm_bc.eq.'bc2') then      
              cz2_for=cz2_for - (exp(gp*(z-zp-4.d0*z1))-exp(-gp*(z-zp+4.d0*z1)) &
                                +exp(gp*(z+zp-2.d0*z1))-exp(-gp*(z+zp+2.d0*z1)) ) &
                                /(1.d0-exp(-4.d0*gp*z1))/2.d0
           else if (esm_bc.eq.'bc3') then      
              cz2_for=cz2_for - exp(gp*(z+zp-2.d0*z1))/2.d0
           endif
        enddo
        for(3,it2) = for(3,it2) + t1_for*(cz1_for+cz2_for)
        if(gstart==2) then
           for(3,it2) = for(3,it2) + t2_for*(kk1_for+kk2_for)
        endif
        
     else if (it1.gt.it2) then
        
        cx1_for=0.d0
        cy1_for=0.d0
        cz1_for=0.d0
        cx2_for=0.d0
        cy2_for=0.d0
        cz2_for=0.d0
        do ng_2d = 1, ngm_2d
           k1 = mill_2d(1,ng_2d)
           k2 = mill_2d(2,ng_2d)
           if(k1==0.and.k2==0) cycle
           
           t(1:2) = k1 * bg (1:2, 1) + k2 * bg (1:2, 2)
           gp2 = sum( t(:) * t(:) ) * tpiba2
           gp=sqrt(gp2)
           
           ff = ( ( k1*bg(1,1)+k2*bg(1,2) ) * ( tau(1,it1)-tau(1,it2) )  &
              +   ( k1*bg(2,1)+k2*bg(2,2) ) * ( tau(2,it1)-tau(2,it2) ) ) * tpi
           arg1=-gp*(z-zp)
           arg2= gp*(z-zp)
           arg1=min(arg1,argmax)
           arg2=min(arg2,argmax)
           t1=exp(arg1)*qe_erfc(gp/2.d0/g-g*(z-zp))
           t2=exp(arg2)*qe_erfc(gp/2.d0/g+g*(z-zp))
           
           cx1_for=cx1_for+sin(ff)*(t1+t2)/4.d0/gp*k1
           cy1_for=cy1_for+sin(ff)*(t1+t2)/4.d0/gp*k2
           cz1_for=cz1_for+cos(ff)*(t1-t2)/4.d0
           if (esm_bc.eq.'bc1') then
              cx2_for=0.d0
              cy2_for=0.d0
              cz2_for=0.d0
           else if (esm_bc.eq.'bc2') then
              cx2_for=cx2_for + sin(ff)*(exp(gp*(z-zp-4.d0*z1))+exp(-gp*(z-zp+4.d0*z1)) &
                                       - exp(gp*(z+zp-2.d0*z1))-exp(-gp*(z+zp+2.d0*z1)) ) &
                                       /(1.d0-exp(-4.d0*gp*z1))/2.d0/gp*k1
              cy2_for=cy2_for + sin(ff)*(exp(gp*(z-zp-4.d0*z1))+exp(-gp*(z-zp+4.d0*z1)) &
                                       - exp(gp*(z+zp-2.d0*z1))-exp(-gp*(z+zp+2.d0*z1)) ) &
                                       /(1.d0-exp(-4.d0*gp*z1))/2.d0/gp*k2
              cz2_for=cz2_for - cos(ff)*(exp(gp*(z-zp-4.d0*z1))-exp(-gp*(z-zp+4.d0*z1)) &
                                       + exp(gp*(z+zp-2.d0*z1))-exp(-gp*(z+zp+2.d0*z1)) ) &
                                       /(1.d0-exp(-4.d0*gp*z1))/2.d0
           else if (esm_bc.eq.'bc3') then
              cx2_for=cx2_for+sin(ff)*(-exp(gp*(z+zp-2.d0*z1)))/2.d0/gp*k1
              cy2_for=cy2_for+sin(ff)*(-exp(gp*(z+zp-2.d0*z1)))/2.d0/gp*k2
              cz2_for=cz2_for+cos(ff)*(-exp(gp*(z+zp-2.d0*z1)))/2.d0
           endif
        enddo
        for(1,it2)=for(1,it2)+t1_for*(cx1_for+cx2_for)
        for(2,it2)=for(2,it2)+t1_for*(cy1_for+cy2_for)
        for(3,it2)=for(3,it2)+t1_for*(cz1_for+cz2_for)
        if(gstart==2) then
           for(3,it2)=for(3,it2)+t2_for*(kk1_for+kk2_for)
        endif
        
     else if (it1.lt.it2) then
        
        cx1_for=0.d0
        cy1_for=0.d0
        cz1_for=0.d0
        cx2_for=0.d0
        cy2_for=0.d0
        cz2_for=0.d0
        do ng_2d = 1, ngm_2d
           k1 = mill_2d(1,ng_2d)
           k2 = mill_2d(2,ng_2d)
           if(k1==0.and.k2==0) cycle
           
           t(1:2) = k1 * bg (1:2, 1) + k2 * bg (1:2, 2)
           gp2 = sum( t(:) * t(:) ) * tpiba2
           gp=sqrt(gp2)
           
           ff = ( ( k1*bg(1,1)+k2*bg(1,2) ) * ( tau(1,it1)-tau(1,it2) )  &
              +   ( k1*bg(2,1)+k2*bg(2,2) ) * ( tau(2,it1)-tau(2,it2) ) ) * tpi
           arg1=-gp*(z-zp)
           arg2= gp*(z-zp)
           arg1=min(arg1,argmax)
           arg2=min(arg2,argmax)
           t1=exp(arg1)*qe_erfc(gp/2.d0/g-g*(z-zp))
           t2=exp(arg2)*qe_erfc(gp/2.d0/g+g*(z-zp))
           
           cx1_for=cx1_for+sin(ff)*(t1+t2)/4.d0/gp*k1
           cy1_for=cy1_for+sin(ff)*(t1+t2)/4.d0/gp*k2
           cz1_for=cz1_for+cos(ff)*(t1-t2)/4.d0
           if (esm_bc.eq.'bc1') then
              cx2_for=0.d0
              cy2_for=0.d0
              cz2_for=0.d0
           else if (esm_bc.eq.'bc2') then
              cx2_for=cx2_for + sin(ff)*(exp(gp*(z-zp-4.d0*z1))+exp(-gp*(z-zp+4.d0*z1)) &
                                       - exp(gp*(z+zp-2.d0*z1))-exp(-gp*(z+zp+2.d0*z1)) ) &
                                       /(1.d0-exp(-4.d0*gp*z1))/2.d0/gp*k1
              cy2_for=cy2_for + sin(ff)*(exp(gp*(z-zp-4.d0*z1))+exp(-gp*(z-zp+4.d0*z1)) &
                                       - exp(gp*(z+zp-2.d0*z1))-exp(-gp*(z+zp+2.d0*z1)) ) &
                                       /(1.d0-exp(-4.d0*gp*z1))/2.d0/gp*k2
              cz2_for=cz2_for - cos(ff)*(exp(gp*(z-zp-4.d0*z1))-exp(-gp*(z-zp+4.d0*z1)) &
                                       + exp(gp*(z+zp-2.d0*z1))-exp(-gp*(z+zp+2.d0*z1)) ) &
                                       /(1.d0-exp(-4.d0*gp*z1))/2.d0
           else if (esm_bc.eq.'bc3') then
              cx2_for=cx2_for+sin(ff)*(-exp(gp*(z+zp-2.d0*z1)))/2.d0/gp*k1
              cy2_for=cy2_for+sin(ff)*(-exp(gp*(z+zp-2.d0*z1)))/2.d0/gp*k2
              cz2_for=cz2_for+cos(ff)*(-exp(gp*(z+zp-2.d0*z1)))/2.d0
           endif
        enddo
        for(1,it2)=for(1,it2)+t1_for*(cx1_for+cx2_for)
        for(2,it2)=for(2,it2)+t1_for*(cy1_for+cy2_for)
        for(3,it2)=for(3,it2)+t1_for*(cz1_for+cz2_for)
        if(gstart==2) then
           for(3,it2)=for(3,it2)+t2_for*(kk1_for+kk2_for)
        endif
     endif
     
  enddo
  enddo
#ifdef __MPI__
  call mpi_allreduce(MPI_IN_PLACE,for,nat*3,mpi_double_precision,mpi_sum,communicator,ierr)
#endif
!$omp critical
  for_g(:,:) = for_g(:,:) + for(:,:)
!$omp end critical
  deallocate(for)
!$omp end parallel

  for_g(:,:)=2.0*for_g(:,:)

  do it1=1,nat
     forceion(1,it1)=sum( for_g(1:2,it1)*bg(1,1:2) )*sqrt(tpiba2)
     forceion(2,it1)=sum( for_g(1:2,it1)*bg(2,1:2) )*sqrt(tpiba2)
     forceion(3,it1)=for_g(3,it1)
  enddo

  if(esm_bc.eq.'bc2')then
     v0=esm_efield*z1*2.d0/2.d0 ! factor 1/2: unit Ry. -> hartree
     do it1=1,nat
        z=tau(3,it1)
        if (z.gt.at(3,3)*0.5) z=z-at(3,3)
        z=z*alat
        forceion(3,it1) = forceion(3,it1)+upf_zp(it1)*v0/z1
     enddo
  endif
  
  deallocate(for_g)
  forceion(:,:)=-forceion(:,:)

  return
end subroutine esm_force_ew

subroutine esm_force_lc ( aux, forcelc )
  Use ESM_VARS
  implicit none
  !
  COMPLEX(8)             :: aux(nrxx)       ! aux contains n(G) (input)   
  REAL(8)                :: forcelc(3,nat)
  real(8),allocatable    :: agauss(:,:),bgauss(:,:) 
  integer :: it
  allocate(agauss(nat,1),bgauss(nat,1))
  do it=1,nat
     agauss(it,1)=1.d0
     bgauss(it,1)=1.d0
  enddo
  call esm_force_lc_(nrxx,aux,forcelc,nat,1,agauss,bgauss)
  deallocate(agauss,bgauss)
end subroutine esm_force_lc

!-----------------------------------------------------------------------
!--------------ESM LOCAL POTENTIAL-DERIVED FORCE SUBROUTINE-------------
!-----------------------------------------------------------------------
subroutine esm_force_lc_ (nrx, aux, natm, forcelc, ngauss, agauss, bgauss )
  Use ESM_VARS
  implicit none
#ifdef __MPI__
  include 'mpif.h'
#endif
  !
  integer,intent(in)     :: nrx
  COMPLEX(8)             :: aux(nrx)       ! aux contains n(G) (input)   
  integer,intent(in)     :: natm
  REAL(8)                :: forcelc(3,natm)
  integer,intent(in)     :: ngauss
  real(8),intent(in)     :: agauss(natm,ngauss),bgauss(natm,ngauss)
  !
  !    here are the local variables
  !
  complex(8),allocatable :: vlocx(:), vlocy(:), vlocdz(:)
  real(8),allocatable    :: for(:,:),for_g(:,:)
  real(8), external      :: qe_erf, qe_erfc
  real(8)                :: t(3),tt,gp,gp2,sa,z1,z0,pp,cc,ss,t1,t2,z,zp,L,forcelc2(3,nat)
  real(8)                :: arg11,arg12,arg21,arg22,tmp,r1,r2,fx1,fy1,fz1,fx2,fy2,fz2,argmax
  integer                 :: iz,ig,it,ipol,k1,k2,k3,ng,n1,n2,n3,ng_2d
  complex(8),allocatable :: vg2(:),vg2_fx(:),vg2_fy(:),vg2_fz(:),rhog3(:,:),vg2_fxyz(:,:)
  complex(8)             :: cx1,cy1,cz1,cx2,cy2,cz2,cc1,cc2
#ifdef __MPI__
  integer                :: ind,ierr
#endif

  argmax=0.9*log(huge(1.d0))

! Mat to FULL FFT mesh (nr1x,nr2x,nr3x)
  allocate(rhog3(nr3x,ngm_2d))
  rhog3(:,:)=(0.d0,0.d0)
  do ng=1,ngm
      n1 = mill(1,ng)
      n2 = mill(2,ng)
      ng_2d = imill_2d(n1,n2)
      n3 = mill(3,ng) + 1
      IF (n3<1) n3 = n3 + nr3x
      rhog3(n3,ng_2d)=aux(nl(ng))
      if( gamma_only .and. n1==0 .and. n2==0 ) then
         n3 = -mill(3,ng) + 1
         IF (n3<1) n3 = n3 + nr3x
         rhog3(n3,ng_2d)=conjg(aux(nl(ng)))
      endif
  enddo

  L=at(3,3)*alat
  z0=L/2.d0
  z1=z0+abs(esm_w)

  allocate(for_g(3,nat))

  sa=omega/L
  for_g(:,:)=0.d0

!**** for gp!=0 *********
!$omp parallel private( k1, k2, gp2, gp, it, tt, pp, cc, ss, zp, iz, &
!$omp                   k3, z, cx1, cy1, cz1, tmp, arg11, arg12, arg21, arg22, &
!$omp                   t1, t2, cx2, cy2, cz2, vg2_fx, vg2_fy, vg2_fz, vg2, &
!$omp                   r1, r2, fx1, fy1, fz1, fx2, fy2, fz2, for, t )
  !allocate(for(3,nat),vg2(nr3x),vg2_fx(nr3x),vg2_fy(nr3x),vg2_fz(nr3x))
  allocate(for(3,nat),vg2(nr3x),vg2_fxyz(nr3x,3))
  for(:,:)=0.d0
!  vg2_fx(:)=(0.d0,0.d0)
!  vg2_fy(:)=(0.d0,0.d0)
!  vg2_fz(:)=(0.d0,0.d0)
!$omp do
  do ng_2d = 1, ngm_2d
#ifdef __MPI__
     if (mod(ng_2d,npes) /= mype) cycle
#endif
     k1 = mill_2d(1,ng_2d)
     k2 = mill_2d(2,ng_2d)
     if(k1==0.and.k2==0) cycle

     t(1:2) = k1 * bg (1:2, 1) + k2 * bg (1:2, 2)
     gp2 = sum( t(:) * t(:) ) * tpiba2
     gp=sqrt(gp2)
     
     do it=1,nat
        IF (gamma_only) THEN
           tt=-fpi*upf_zp(it)/sa*2.d0
        ELSE 
           tt=-fpi*upf_zp(it)/sa
        ENDIF 
        pp=-tpi*(tau(1,it)*(k1*bg(1,1)+k2*bg(1,2))+tau(2,it)*(k1*bg(2,1)+k2*bg(2,2)))
        cc=cos(pp)
        ss=sin(pp)
        zp=tau(3,it)
        if (zp.gt.at(3,3)*0.5) zp=zp-at(3,3)
        zp=zp*alat
!        vg2_fx(:)=(0.d0,0.d0)
!        vg2_fy(:)=(0.d0,0.d0)
!        vg2_fz(:)=(0.d0,0.d0)
        vg2_fxyz(:,:) = (0.d0,0.d0)
        do iz=1,nr3x
           k3=iz-1
           if (k3.gt.nr3x/2) k3=iz-nr3x-1
           z=dble(k3)/dble(nr3x)*L
           cx1=(0.d0,0.d0); cy1=(0.d0,0.d0); cz1=(0.d0,0.d0)
           do ig=1,ngauss
              tmp=sqrt(agauss(it,ig))
              arg11=-gp*(z-zp)
              arg11=min(arg11,argmax) 
              arg12= gp/2.d0/tmp-tmp*(z-zp)
              arg21= gp*(z-zp)
              arg21=min(arg21,argmax)
              arg22= gp/2.d0/tmp+tmp*(z-zp)
              t1=exp(arg11)*qe_erfc(arg12)
              t2=exp(arg21)*qe_erfc(arg22)
              cx1=cx1+bgauss(it,ig)*CMPLX(ss, -cc, kind=8) &
                   *(t1+t2)/4.d0/gp*k1
              cy1=cy1+bgauss(it,ig)*CMPLX(ss, -cc, kind=8) &
                   *(t1+t2)/4.d0/gp*k2
              cz1=cz1+bgauss(it,ig)*CMPLX(cc, ss, kind=8)  &
                   *(t1-t2)/4.d0
           enddo
           if (esm_bc.eq.'bc1') then
              cx2=(0.d0,0.d0)
              cy2=(0.d0,0.d0)
              cz2=(0.d0,0.d0)
           else if (esm_bc.eq.'bc2') then
              cx2=CMPLX(ss, -cc, kind=8)* &
                   (exp(gp*(z-zp-4.d0*z1))+exp(-gp*(z-zp+4.d0*z1)) &
                   -exp(gp*(z+zp-2.d0*z1))-exp(-gp*(z+zp+2.d0*z1))) &
                   /(1.d0-exp(-4.d0*gp*z1))/2.d0/gp*k1
              cy2=CMPLX(ss, -cc, kind=8)* &
                   (exp(gp*(z-zp-4.d0*z1))+exp(-gp*(z-zp+4.d0*z1)) &
                   -exp(gp*(z+zp-2.d0*z1))-exp(-gp*(z+zp+2.d0*z1))) &
                   /(1.d0-exp(-4.d0*gp*z1))/2.d0/gp*k2
              cz2=CMPLX(cc, ss, kind=8)* &
                   (-exp(gp*(z-zp-4.d0*z1))+exp(-gp*(z-zp+4.d0*z1)) &
                   -exp(gp*(z+zp-2.d0*z1))+exp(-gp*(z+zp+2.d0*z1))) &
                   /(1.d0-exp(-4.d0*gp*z1))/2.d0
           else if (esm_bc.eq.'bc3') then
              cx2=CMPLX(ss, -cc, kind=8)* &
                   (-exp(gp*(z+zp-2.d0*z1)))/2.d0/gp*k1
              cy2=CMPLX(ss, -cc, kind=8)* &
                   (-exp(gp*(z+zp-2.d0*z1)))/2.d0/gp*k2
              cz2=CMPLX(cc, ss, kind=8)* &
                   (-exp(gp*(z+zp-2.d0*z1)))/2.d0
           endif
!           vg2_fx(iz) = tt*(cx1+cx2)
!           vg2_fy(iz) = tt*(cy1+cy2)
!           vg2_fz(iz) = tt*(cz1+cz2)
           vg2_fxyz(iz,1) = tt*(cx1+cx2)
           vg2_fxyz(iz,2) = tt*(cy1+cy2)
           vg2_fxyz(iz,3) = tt*(cz1+cz2)
        enddo
        vg2(1:nr3x)=vg2_fxyz(1:nr3x,1)  ! Since cft_1z is not in-place
        call cft_1z(vg2,1,nr3x,nr3x,-1,vg2_fxyz(:,1))
        vg2(1:nr3x)=vg2_fxyz(1:nr3x,2)  ! Since cft_1z is not in-place
        call cft_1z(vg2,1,nr3x,nr3x,-1,vg2_fxyz(:,2))
        vg2(1:nr3x)=vg2_fxyz(1:nr3x,3)  ! Since cft_1z is not in-place
        call cft_1z(vg2,1,nr3x,nr3x,-1,vg2_fxyz(:,3))
        do iz=1,nr3x
           r1= dble(rhog3(iz,ng_2d))
           r2=aimag(rhog3(iz,ng_2d))
           fx1=dble(  vg2_fxyz(iz,1))
           fy1=dble(  vg2_fxyz(iz,2))
           fz1=dble(  vg2_fxyz(iz,3))
           fx2=aimag( vg2_fxyz(iz,1))
           fy2=aimag( vg2_fxyz(iz,2))
           fz2=aimag( vg2_fxyz(iz,3))
           for(1,it)=for(1,it)-r1*fx1-r2*fx2
           for(2,it)=for(2,it)-r1*fy1-r2*fy2
           for(3,it)=for(3,it)-r1*fz1-r2*fz2
        enddo
     enddo
  enddo
#ifdef __MPI__
  call mpi_allreduce(MPI_IN_PLACE,for,nat*3,mpi_double_precision,mpi_sum,communicator,ierr)
#endif
!$omp critical
  for_g(:,:) = for_g(:,:) + for(:,:)
!$omp end critical
  !deallocate(for,vg2,vg2_fx,vg2_fy,vg2_fz)
  deallocate(for,vg2,vg2_fxyz)
!$omp end parallel

!***** for gp==0********
  ng_2d = imill_2d(0,0)
  if( ng_2d > 0 ) then
     allocate(vg2(nr3x),vg2_fz(nr3x))

     vg2_fz(:)=(0.d0,0.d0)
     do it=1,nat
        tt=-fpi*upf_zp(it)/sa
        zp=tau(3,it)
        if (zp.gt.at(3,3)*0.5) zp=zp-at(3,3)
        zp=zp*alat
        do iz=1,nr3x
           k3=iz-1
           if (k3.gt.nr3x/2) k3=iz-nr3x-1
           z=dble(k3)/dble(nr3x)*L
           cc1=(0.d0,0.d0)
           do ig=1,ngauss
              tmp=sqrt(agauss(it,ig))
              cc1=cc1+bgauss(it,ig)*(0.5d0*qe_erf(tmp*(z-zp)))
           enddo
           if (esm_bc.eq.'bc1') then
              cc2=(0.d0,0.d0)
           else if (esm_bc.eq.'bc2') then
              cc2=-0.5d0*(z/z1)
           else if (esm_bc.eq.'bc3') then
              cc2=-0.5d0
           endif
           vg2_fz(iz) =  tt*(cc1+cc2)
        enddo
        vg2(1:nr3x)=vg2_fz(1:nr3x)  ! Since cft_1z is not in-place
        call cft_1z(vg2,1,nr3x,nr3x,-1,vg2_fz)
        do iz=1,nr3x
           r1=dble( rhog3(iz,ng_2d))
           r2=aimag(rhog3(iz,ng_2d))
           fz1=dble( vg2_fz(iz))
           fz2=aimag(vg2_fz(iz))
           for_g(3,it)=for_g(3,it)-r1*fz1-r2*fz2
        enddo
     enddo
     
     deallocate(vg2,vg2_fz)
  endif ! if( ng_2d > 0 )

!***** sum short_range part and long_range part in local potential force at cartecian coordinate

  do it=1,nat
     forcelc(1,it)=forcelc(1,it)+sum(for_g(1:2,it)*bg(1,1:2))*sqrt(tpiba2)*omega*2.d0
     forcelc(2,it)=forcelc(2,it)+sum(for_g(1:2,it)*bg(2,1:2))*sqrt(tpiba2)*omega*2.d0
     forcelc(3,it)=forcelc(3,it)+for_g(3,it)*omega*2.d0
  enddo

  deallocate(for_g,rhog3)
  return
end subroutine esm_force_lc_

!-----------------------------------------------------------------------
!--------------ESM FINAL PRINTOUT SUBROUTINE----------------------------
!-----------------------------------------------------------------------
!
! Prints out vlocal and vhartree to stdout once electrons are converged
! Format: z, rho(r), v_hartree, v_local, (v_hartree + v_local) 
!
SUBROUTINE esm_printpot ( rhog, v_h, v_l )
  Use ESM_VARS
  !
  IMPLICIT NONE
  !
  COMPLEX(8), Intent(In)  :: rhog(ngm,nspin)   !  n(G)
  COMPLEX(8), Intent(In)  :: v_h(nrxx)
  COMPLEX(8), Intent(In)  :: v_l(nrxx)
  REAL(8)                 :: charge,ehart,bohr,rydv,L,area
  COMPLEX(8), ALLOCATABLE :: work1(:,:), work2(:,:)
  Real(8)   , ALLOCATABLE :: work3(:,:)
  INTEGER                 :: iz,i,k3,ng,n1,n2,n3,n3_

  L = alat*at(3,3)
  area = (at(1,1)*at(2,2)-at(2,1)*at(1,2))*alat**2
  bohr = 0.52917720859d0
  rydv = 13.6058d0

  ! x,y average
  allocate( work1(nr3x,3), work2(nr3x,3), work3(nr3x,1:5) )
  work1(:,:) = 0d0
  work2(:,:) = 0d0
  work3(:,:) = 0d0

  do ng=1,ngm
     n1 = mill(1,ng)
     n2 = mill(2,ng)
     if( n1 == 0 .and. n2 == 0 ) then
        n3 = mill(3,ng) + 1
        if (n3<1) n3 = n3 + nr3x
        if( nspin == 2 ) then
           work1(n3,1) = rhog(ng,1) + rhog(ng,2)
        else
           work1(n3,1) = rhog(ng,1)
        endif
        if( gamma_only ) then
           n3_ = -mill(3,ng) + 1
           if (n3_<1) n3_ = n3_ + nr3x
           work1(n3_,1) = conjg( work1(n3,1) )
        endif
     endif
  enddo

  do iz = 1, nr3x
     k3 = iz - 1
     if( k3 > nr3x/2 ) k3 = k3 - nr3x
     i=1+(iz-1)*nr1x*nr2x
     work1(iz,2) = v_h(i);
     work1(iz,3) = v_l(i);
  enddo

  call cft_1z(work1(:,:),3,nr3x,nr3x,1,work2(:,:))
  work3(:,2) = DBLE( work2(:,1) ) * area
  work3(:,3) = DBLE( work2(:,2) ) * rydv / bohr
  work3(:,4) = DBLE( work2(:,3) ) * rydv / bohr

  do iz = 1, nr3x
     k3 = iz - 1
     if( k3 > nr3x/2 ) k3 = k3 - nr3x
     work3(iz,1) = dble(k3) / nr3x * L * bohr
  enddo

  work3(:,5) = work3(:,3) + work3(:,4)

! z = position along slab (A)
! rho = planar-summed charge density of slab section (e)
! v_hartree = planar-averaged hartree potential term (eV/A)
! v_local = planar-averaged local potential term (eV/A)

  write(*,*)
  write(*,'("     ESM Charge and Potential")')
  write(*,'("     ========================")' )
  write(*,*)
  write(*,'("    z (A)      rho (e)      Avg v_hartree        Avg v_local  Avg v_hart+v_loc")' )
  write(*,'("                                   (eV/A)             (eV/A)            (eV/A)")' )
  write(*,*)
  write(*,'("    ==========================================================================")' )
  do k3 = nr3x/2-nr3x+1, nr3x/2
     iz = k3 + nr3x + 1
     if( iz > nr3x ) iz = iz - nr3x
     write(*,'(f9.3,f13.5,2f19.7,f18.7)') work3(iz,1:5)
  enddo
  write(*,*)

  deallocate(work1, work2, work3)

END SUBROUTINE esm_printpot

SUBROUTINE esm_gen_vbar()
  Use ESM_VARS
  Implicit none
  integer :: i3
  real(8) :: z
  if(izwall.eq.0) bar_height=0.d0
  if(izwall.eq.1)then
     do i3=1,nr3x
        z = dble(i3-1)*at(3,3)*alat/dble(nr3x)
        if(z.gt.at(3,3)*alat/2.0d0)z=z-at(3,3)*alat
        if(z.ge.z_wall.and.z.le.z_wall+bar_width)then
           vbar(i3) = cmplx(0.5d0*(1.d0+sin(-pi/2.d0+pi/bar_width*(z-z_wall)))*bar_height,       &
           &                0.5d0*pi/bar_width*cos(-pi/2.d0+pi/bar_width*(z-z_wall))*bar_height)
        else if (z.gt.z_wall+bar_width)then
           vbar(i3) = cmplx(bar_height,0.d0)
        endif
     enddo
  endif
END SUBROUTINE esm_gen_vbar

! Copyright (c) 2012, Minoru Otani <minoru.otani@aist.go.jp> 
! 
! Permission is hereby granted, free of charge, to any person 
! obtaining a copy of this software and associated documentation 
! files (the "Software"), to deal in the Software without restriction, 
! including without limitation the rights to use, copy, modify, merge, 
! publish, distribute, sublicense, and/or sell copies of the Software, 
! and to permit persons to whom the Software is furnished to do so, 
! subject to the following conditions:
 
! The above copyright notice and this permission notice shall be 
! included in all copies or substantial portions of the Software.
 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
! OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
! NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
! HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
! WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
! DEALINGS IN THE SOFTWARE.
!-------------------------------------------------------------------

!
! Calculates Ewald energy R-space terms.
!
Subroutine Ewald( nAtom, tau, charge, at, alat, alpha, bg, ewaldr )
  Implicit None
  Integer, Intent(in) :: nAtom            ! Number of Atoms
  Real(8), Intent(in) :: tau(3,nAtom)     ! Coordinates of Atoms
  Real(8), Intent(in) :: charge(nAtom)    ! Charge of Atoms
  Real(8), Intent(in) :: at(3,3)         ! Lattice Vectors
  Real(8), Intent(in) :: alat             ! Lattice Parameter
  Real(8), Intent(in) :: alpha            ! Convergence Factor
  Real(8), Intent(in) :: bg(3,3)          ! Reciprocal Lattice Vectors

  Real(8), Intent(out) :: ewaldr          ! Real Space Ewald Energy

  Real(8), external :: Dnrm2

  ! Local Variables
  Real(8) :: rmax, rmax2, dtau(3), t(3), t2, r
  Integer :: iA, iB, i, j, k, ni, nj, nk
  rmax = 4.0d0 / sqrt (alpha) / alat
  ni = int( Dnrm2(3, bg(1,1), 1) * rmax ) + 2
  nj = int( Dnrm2(3, bg(1,2), 1) * rmax ) + 2
  nk = int( Dnrm2(3, bg(1,3), 1) * rmax ) + 2

  rmax2 = rmax * rmax
  ewaldr = 0.0d0
  Do iA = 1, nAtom
  Do iB = 1, nAtom
     dtau(:) = tau(:,iA) - tau(:,iB)
     Do i = -ni, ni
     Do j = -nj, nj
     Do k = -nk, nk
        t(:) = dtau(:) + i * at(:,1) + j * at(:,2) + k * at(:,3)
        t2 = Sum( t(:) * t(:) )
        If( t2 > rmax2 ) Cycle
        If( t2 < 1.0d-10 ) Cycle

        r = Sqrt(t2) * alat
        ewaldr = ewaldr + charge(iA) * charge(iB) &
             * Erfc( Sqrt(alpha) * r ) / r
        
     End Do
     End Do
     End Do
  End Do
  End Do

  Return
End Subroutine Ewald

! Copyright (c) 2012, Minoru Otani <minoru.otani@aist.go.jp> 
! 
! Permission is hereby granted, free of charge, to any person 
! obtaining a copy of this software and associated documentation 
! files (the "Software"), to deal in the Software without restriction, 
! including without limitation the rights to use, copy, modify, merge, 
! publish, distribute, sublicense, and/or sell copies of the Software, 
! and to permit persons to whom the Software is furnished to do so, 
! subject to the following conditions:
 
! The above copyright notice and this permission notice shall be 
! included in all copies or substantial portions of the Software.
 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
! OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
! NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
! HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
! WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
! DEALINGS IN THE SOFTWARE.
subroutine Esm_interface_map_parameters(nat_,upf_zp_,tau_,alat_,at_,nr1x_,nr2x_,nr3x_,  &
                                   &    esm_bc_,gamma_only_,ngm_,nspin_,mill_,nl_,nlm_, &
                                   &    esm_w_,esm_efield_,izwall_,z_wall_,bar_height_,bar_width_)
  use ESM_VARS
  implicit none
  integer, intent(in) :: nat_
  real(8), dimension(nat_), intent(in)   :: upf_zp_
  real(8), dimension(3,nat_), intent(in) :: tau_
  real(8), intent(in) :: alat_
  real(8), intent(in) :: at_(3,3)
  integer, intent(in) :: nr1x_,nr2x_,nr3x_
  character(len=3), intent(in) :: esm_bc_
  logical, intent(in) :: gamma_only_
  integer, intent(in) :: ngm_,nspin_
  integer, dimension(3,ngm_), intent(in) :: mill_
  integer, dimension(ngm_), intent(in) :: nl_,nlm_
  real(8), intent(in) :: esm_w_
  real(8), intent(in) :: esm_efield_
  integer, intent(in) :: izwall_
  real(8), intent(in) :: z_wall_
  real(8), intent(in) :: bar_height_
  real(8), intent(in) :: bar_width_

  Real(8) :: at12(3)
  Real(8), External :: InnerProd
  
  integer :: i,j
  Real(8) :: a1,a2,cc

  nat = nat_
  if(.not.allocated(tau)) allocate(tau(3,nat))
  if(.not.allocated(upf_zp)) allocate(upf_zp(nat))
  do i=1,nat
     do j=1,3
        tau(j,i) = tau_(j,i)
     enddo
     upf_zp(i) = upf_zp_(i)
  enddo
  alat = alat_
  at = at_
  nr1x = nr1x_
  nr2x = nr2x_
  nr3x = nr3x_
  esm_bc = esm_bc_
  gamma_only = gamma_only_
  ngm = ngm_
  nspin = nspin_
  if(.not.allocated(mill)) allocate(mill(3,ngm))
  if(.not.allocated(nl))   allocate(nl(ngm))
  if(.not.allocated(nlm))  allocate(nlm(ngm))

  mill(:,:) = mill_(:,:)
  nl(:)     = nl_(:)
  nlm(:)    = nlm_(:)

  esm_w      = esm_w_
  esm_efield = esm_efield_

  izwall     = izwall_
  z_wall     = z_wall_
  bar_height = bar_height_
  bar_width  = bar_width_

! calculate parameters
  Call OuterProd( at(1,1), at(1,2), at12 )
  omega = InnerProd( at12, at(1,3) ) * ( alat ** 3 )

!  gew = sqrt(pi/omega/(at(3,3)*alat))

  tpiba2 = ( tpi / alat ) ** 2
  !!$gcutm = dual * ecutwfc / tpiba2

  Call MakeRecLatVec( at, bg )

  nrxx = nr1x * nr2x * nr3x

  allocate(rhog_(ngm,nspin))

  call esm_ggen_2d()

  call esm_gen_vbar()

  return
end subroutine Esm_interface_map_parameters

subroutine Esm_interface_set_tau(tau_)
  use ESM_VARS
  implicit none
  real(kind=8), intent(in), dimension(3,nat) :: tau_
  integer :: i,j
  tau(:,:) = tau_(:,:)
end subroutine Esm_interface_set_tau

subroutine Esm_interface_set_communicator(comm)
  use ESM_VARS
  implicit none
  integer, intent(in) :: comm
  communicator = comm 
end subroutine Esm_interface_set_communicator

subroutine Esm_interface_set_npes_mype(np,mp)
  use ESM_VARS
  implicit none
  integer, intent(in) :: np,mp
  npes = np
  mype = mp
end subroutine Esm_interface_set_npes_mype

!=======================================================================
!
!  SOFTWARE NAME : PHASE ($Revision: 633 $)
!
!  MODULE: m_Files
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!  patch 10.1 by K. Tagami @adv    2011/06/18
!
!  patch 10.1 : addition of output file for LinearResponse Spectrum
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Files
!  $Id: m_Files.F90 633 2020-12-01 05:11:03Z jkoga $
!
!  Operations concerning to files as "open", and "close",
!  should be done in this module.
!
  use m_Control_Parameters,only : paramset, ekmode, printable, iprijobstatus,jobstatus_series, ipriparadeb &
       &                        , multiple_replica_mode, icond, ppprinted, fixed_charge_k_parallel &
       &                        , sw_cif_output, imdalg
  use m_Const_Parameters,  only : OLD, NEW_, UNKNOWN, FORMATTED &
       &                        , UNFORMATTED, check_file_name_on &
       &                        , check_file_name_off, DP, ON, GENERAL, FILE &
       &                        , YES, NO, UNIFIED, PARTITIONED, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                        , ON, OFF, INITIAL, ALL_AT_ONCE, ONE_BY_ONE &
       &                        , P_CONTROL, PT_CONTROL
  use m_ErrorMessages,     only : F_POT_FILE_NOT_EXIST, FILE_NOT_EXIST, ERROR_IN_INPUTFILE_OPENING,FILENAMES_FORMAT_ERROR &
       &                        , FILENAMES_FORMAT_ERROR_NEB, FILENAMES_NOT_EXIST,m_EMsg_Warning
  use m_Parallelization, only   : mpi_comm_group,mype,npes,ierr,workdir,sw_wdir &
       &                        , mype_conf,conf_para, nrank_conf

  implicit none
  include 'mpif.h'
  integer istatus(mpi_status_size)

  logical, public ::  file_existence_contfiles = .false.
  logical, public ::  file_existence_contfiles_when_paw_on = .false.
  logical, public ::  file_existence_3contfiles = .false.
  logical, private :: file_existence_nfcntn = .false.
  logical, private :: file_existence_nfcntn_bin = .false.
  logical, private :: file_existence_nfcntn_bin_paw = .false.  ! T.Y. 2020/02/28
  logical, private :: file_existence_nfzaj =  .false.
  logical, private :: file_existence_nfchgt = .false.
  logical, private :: file_existence_nfoccmat = .false.        ! T.Y. 2020/02/28

  integer, parameter :: min_ext_length_mype = 3
  integer, parameter ::  MAXNSP = 16
  integer  nfinp,nfpot(MAXNSP)&  ! (1 + MAXNSP) files
       & ,nfpkb,nfpd,nfppc,nfstop,nfopgr,nfmatbp,nfkpoint,nfkindex & !8 files
       & ,nfvibrate,nfzak,nf_neord,nfcnst,nfotp,nfdynm,nfenf,nfgpt & !8 files
       & ,nfchgt,nfchgo,nfchgu,nfchgs,nfout,nfcps,nffor,nfcntn &     !8 files
       & ,nfcntn_bin,nfzaj,nfrsp,nfwf1,nfwf2,nfwf3,nfeng,nfvlc &     !8 files
       & ,nfcntn_bin_stm, nfstatus &                                 !2 files
       & ,nfspg,nfkpgn  &                                            !2 files
       & ,nfdos, nfchr, nfelf, nfegrid, nfldos &                     !5 files
       & ,nfberry,nfeffchg,nfforce,nfmode,nfepsilon &                !5 files
       & ,nfepsout,nfphdos,nfoccmat,nfwfk,nfstrfrc &                 !5 files
       & ,nfwannier,nfcntn_wannier,nfpot_wannier,nfefermi &          !4 files
! --------------------T. Hamada 2021.9. -------------------- ! UVSOR
!      & ,nfnlo,nfmagopt,nfepscont   &                               !3 files UVSOR
       & ,nfnlo,nfmagopt,nfepscont,nfkptdata,nfkptepsdata &                    !5 files
! ---------------------------------------------------------- ! UVSOR
       & ,nfpstrn, nfvelec, nfeppair, nfeppair2, nfvelec_grad &      !5 files Positron
       & ,nfpsicoef, nfbandsyminput &                                !2 file
! ============================= Added by K. Tagami =========== 10.1
!       & ,nfcntn_bin_paw                                            !1 file PAW
       & ,nfcntn_bin_paw              &                              !1 file PAW
       &, nf_LR_spectra               &                              !1 file LR
! ============================================================ 10.1
       &, nfcntn_berry &
       &, nf_ekindens             &                          ! 1 file 360 metagga
       &, nfqpoint                &                          ! 1 file q-point phonon
       &, nf_core_charge_radial(MAXNSP) &                      ! MAXNSP files 500-515

! ====================== KT_add ======= 13.1R
       &, nfeps_ph &                                         ! 1 file EPS_Phonon
       &, nfoptical_coeff &                                  ! 1 file optical coeff
       &, nframan_spectra &                                  ! 1 file Raman spectra
! ===================================== 13.1R
! ===== KT_add ==== 13.1XI
       &, nf_excitation_spectra &                            ! 1 file Excitation
! ================= 13.1XI
       &, nf_mag_core &                                      ! 1 file Opencore
       &, nf_elecpot_bin, nf_elecpot_bin_ref &
                                                             ! 2 files ChargedDefect
! ====================== KT_add ======= 13.0S
       &, nfcore_energy_out, nfcore_energy_initial, nfcore_energy_final &
                                                             ! 3 files CoreLevel
! ===================================== 13.0S
       &, nfdynm_cif & ! CIF output
       &, nfwfk_sq   &   ! squared wf
       &, nfwfk_integ_mom  &  ! moment of wf ( integerated over space )
       &, nfwfk_orb_proj      &      ! orbital-projection of wf
       &, nfband_spectr_wght  &      ! spectral weight for band unfolding 
       &, nfporb_dens_mat     &      ! orbital population density matrix
       &, nfporb_rot_mat      &      ! rotation matrix of orbital population
       &, nflatconst,nfmetric & ! for pressurecontrol simulations
       &, nfdftd3par & ! parameters for DFT-D3
       &, nfchkpoint & ! checkpoint file directory
       &, nfhybridinfo & ! hybrid functional information
       &, nfscfzaj & ! WF from the preceding SCF calculation
       &, nfpos, nfcoordattr &! file from which the coordinates are read when structure.method = file
       &, nfdefaultpp &
       &, nfpwbs &
       &, nfxsf, nfn2p2, nfinp_mod &
       &, nfzaj_kall, nfkpoint_bin

  data  &
       &   nfinp,nfpot &                                               ! 31,(37,38,39,40,45,46,11-19,36)
       &  ,nfpkb,nfpd,nfppc,nfstop,nfopgr,nfmatbp,nfkpoint,nfkindex &  ! 33,34,35,49,21,22,23,24
       &  ,nfvibrate,nfzak,nf_neord,nfcnst,nfotp,nfdynm,nfenf,nfgpt &  ! 47,48,50,61,51,52,53,54
       &  ,nfchgt,nfchgo,nfchgu,nfchgs,nfout,nfcps,nffor,nfcntn &      ! 55,56,57,58, 6, 6, 6,42
       &  ,nfcntn_bin,nfzaj,nfrsp,nfwf1,nfwf2,nfwf3,nfeng,nfvlc &      ! 43,44,90,95,96,97,59,60
       &  ,nfcntn_bin_stm, nfstatus &                                  ! 62,75
       &  ,nfspg,nfkpgn &                                              ! 63,64
       &  ,nfdos, nfchr, nfelf, nfegrid, nfldos &                      ! 5 files 65,66,67,68,69
       &  ,nfberry,nfeffchg,nfforce,nfmode,nfepsilon &                 ! 5 files 70,71,72,73,74
       &  ,nfepsout,nfphdos,nfoccmat,nfwfk,nfstrfrc &                  ! 5 files 20,41,76,77,78
       &  ,nfwannier,nfcntn_wannier,nfpot_wannier,nfefermi &           ! 4 files 79,80,81,82
!-------------------- T. Hamada 2021.9.28 --------------------! UVSOR
!       &  ,nfnlo,nfmagopt,nfepsconta  &                               ! 3 files 10,30,83 !UVSOR
       &  ,nfnlo,nfmagopt,nfepscont,nfkptdata,nfkptepsdata &           ! 5 files 10,30,83,84,85  UVSOR
!------------------------------------------------------------=! UVSOR

       &  ,nfpstrn, nfvelec, nfeppair, nfeppair2, nfvelec_grad &       ! 5 files 300,310,320,322,330 Positron
       &  ,nfpsicoef, nfbandsyminput &                                 ! 2 file  340, 341
       &  ,nfcntn_bin_paw &                                            ! 1 file  321 PAW 
! ===================== Added by K. Tagami ================= 10.1
       &  ,nf_LR_spectra           &                     ! 1 file  400 Linear Response
! ========================================================== 10.1
       &  ,nfcntn_berry           &
       &  ,nf_ekindens             &                     ! 1 file 360 metagga
       &  ,nfqpoint                &                     ! 1 file 325 q-point for phonon
       &  ,nf_core_charge_radial     &             ! MAXNSP files 500-515

! ======= KT_add === 13.1R
       &   , nfeps_ph &                                  ! 1 file 407 Eps_Phonon
       &   , nfoptical_coeff &                           ! 1 file 408 optical coeff
       &   , nframan_spectra  &                          ! 1 file 409 Raman spectra
! ================== 13.1R
! ===== KT_add ==== 13.1XI
       &   , nf_excitation_spectra  &                    ! 1 file 420 Excitation spectra
! ================= 13.1XI
       &   , nf_mag_core &                               ! 1 files 378
       &   , nf_elecpot_bin, nf_elecpot_bin_ref &        ! 2 files 380, 381 defect
! ============================== KT_add ========= 13.0S
       &  ,nfcore_energy_out, nfcore_energy_initial, nfcore_energy_final &
! =============================================== 13.0S
       &  ,nfdynm_cif &
       &  ,nfwfk_sq &
       &  ,nfwfk_integ_mom &
       &  ,nfwfk_orb_proj &
       &  ,nfband_spectr_wght &
       &  ,nfporb_dens_mat, nfporb_rot_mat &
! NPT, NPH-MD
       &  ,nflatconst &
       &  ,nfmetric &
       &  ,nfdftd3par &
       &  ,nfchkpoint &
       &  ,nfhybridinfo &
       &  ,nfscfzaj &
       &  ,nfpos, nfcoordattr &
       &  ,nfdefaultpp &
       &  ,nfpwbs &
       &  ,nfxsf, nfn2p2 &
       &  , nfinp_mod, nfzaj_kall &
       &  , nfkpoint_bin  &

       &    /31,37,38,39,40,45,46 &
       & ,11,12,13,14,15,16,17,18,19,36 &
       & ,33,34,35,49,21,22,23,24 &
       & ,47,48,50,61,51,52,53,54 &
       & ,55,56,57,58, 6, 6, 6,42 &
       & ,43,44,90,95,96,97,59,60 &
       & ,62,75,63,64,65,66,67,68,69 &
       & ,70,71,72,73,74,20,41,76,77,78 &
       & ,79,80,81,82 &
! -------------------- T. Hamada 2021.9.23 --------------------
!       & ,10,30,83, 300,310,320,322,330,340,341 &
       & ,10,30,83,84, 85, 300,310,320,322,330,340,341 &
! -------------------------------------------------------------
! ================================ Added by K. Tagami ========== 10.1
       & ,321 &
       & ,400 & 
! ============================================================== 10.1
       & ,410 &
       & ,360 &
       & ,325 &
       & ,500,501,502,503,504,505,506,507,508,509,510,511,512,513,514,515 &

! =============== KT_add =========== 13.1R
       & ,407 &
       & ,408 &
       & ,409 &
! ================================== 13.1R
! =============== KT_add ====== 13.1XI
       & ,420 &
! ============================= 13.1XI
       &, 378 &           ! mag-core
       &, 380, 381 &
! =============== KT_add =========== 13.0S
       &, 370, 371, 372  &
! ================================== 13.0S
       &, 349 &
       &, 350 & 
       &, 351 &
       &, 352 &
       &, 345 &
       &, 355, 356 &
! NPT, NPH-MD
       &, 100 &
       &, 101 &
       &, 102 &
       &, 103 &
       &, 104 &
       &, 105 &
       &, 106,107 & ! dummy unit number
       &, 108 &
       &, 109 &
       &, 111 &
       &, 112 &
       &, 113 &
       &, 114 &
       &, 115 /

  integer,private,parameter :: number_of_all_files = 103 + 2*MAXNSP

  integer,private, dimension(number_of_all_files) :: n_file
  data n_file &
       &    /31,37,38,39,40,45,46 &
       & ,11,12,13,14,15,16,17,18,19,36 &
       & ,33,34,35,49,21,22,23,24 &
       & ,47,48,50,61,51,52,53,54 &
       & ,55,56,57,58, 6, 6, 6,42 &
       & ,43,44,90,95,96,97,59,60 &
       & ,62,75,63,64,65,66,67,68,69 &
       & ,70,71,72,73,74,20,41,76,77,78 &
       & ,79,80,81,82 &
! -------------------- T. Hamada 2021.9.28 --------------------
!      & ,10,30, 300,310,320,330,340 &
       & ,10,30,83,84,85,300,310,320,330,340 &
! -------------------------------------------------------------
! ===================================== Added by K. Tagami ======= 10.1
!       & ,321/
       & ,321 &
       & ,400 &
! ================================================================ 10.1
       & ,410 &
       & ,360 &
       & ,325 &
       & ,500,501,502,503,504,505,506,507,508,509,510,511,512,513,514,515 &

! =============== KT_add =========== 13.1R
       & ,407 &
       & ,408 &
       & ,409 &
! ================================== 13.1R
! =============== KT_add ====== 13.1XI
       & ,420 &
! ============================= 13.1XI
       & ,378 &          ! mag-core
       & ,380, 381 &
! ================= KT_add ======== 13.0S
       & ,370, 371, 372 &
! ================================= 13.0S
       & ,349, 350, 351, 352, 345, 355, 356 &
! NPT, NPH-MD
       & ,100, 101 &
       & ,102 &
       & ,103 &
       & ,104 &
       & ,105 &
       & ,106, 107 &
       & ,108 &
       & ,109 &
       & ,111 &
       & ,112 &
       & ,113 &
       & ,114 &
       & ,115 /

  integer,private,parameter :: stringlength_of_filenames = 261
  character(len=stringlength_of_filenames) ::  &
       &  F_INP,F_POT(MAXNSP),F_PKB,F_PD,F_PPC,F_STOP,F_OPGR &         ! 31,(37-40,45,46,11-19,36),33,34,35,49,21
       & ,F_MATBP,F_KPOINT,F_KINDEX, F_VIBRATE, F_ZAK,F_NEORD,F_CNST & ! 22,23,24,47,48,50,61
       & ,F_OTP, F_DYNM,F_ENF, F_GPT, F_CHGT, F_CHGO, F_CHGU, F_CHGS & ! 51,52,53,54,55,56,57,58
       & ,F_OUT, F_CNTN, F_CNTN_BIN, F_ZAJ, F_RSP, F_WF(3), F_ENERG  & ! 6, 42,43,44,90,95,96,97,59
       & ,F_VLC, F_CNTN_BIN_STM, F_STATUS, F_file_names_data &         ! 60,62,75
       & ,F_SPG, F_KPGN, F_DOS, F_CHR, F_ELF, F_EGRID, F_LDOS &        ! 63,64,65,66,67,68,69
       & ,F_BERRY,F_EFFCHG,F_FORCE,F_MODE,F_EPSILON &                  ! 70,71,72,73,74
       & ,F_EPSOUT,F_PHDOS,F_OCCMAT,F_WFk,F_STRFRC &                   ! 20,41,76,77,78
       & ,F_WANNIER,F_CNTN_WAN,F_POT_WAN,F_EFERMI &                    ! 79,80,81,82
! ^^^^^^^^^^^^^^^^^^^^^^^T. Hamada 2021.9.28 ---------------------------! UVSOR
!       & ,F_NLO,F_MAGOPT,F_EPSCONT                                    ! 10,30,83 UVSOR
       & ,F_NLO,F_MAGOPT,F_EPSCONT,F_KPT_DATA,F_KPTEPS_DATA &          ! 10,30,83,84,85 UVSOR
! ----------------------------------------------------------------------! UVSOR
       & ,F_PSTRN, F_VELEC, F_EPPAIR, F_EPPAIR2, F_VELEC_GRAD  &       ! 300,310,320,322,330 Positron
       & ,F_PSICOEF, F_BAND_SYM_INPUT       &                          ! 340,341 Psi_coef, Psi_coef2
! ================================== Added by K. Tagami ======= 10.1
!       & ,F_CNTN_BIN_PAW                                               ! 321 PAW
       & ,F_CNTN_BIN_PAW &                                              ! 321 PAW
       & ,F_LR_SPECTRA   &                                         ! 400 LinearResponse
! ============================================================= 10.1
       & ,F_CNTN_BERRY &
       & ,F_EKINDENS &                                             ! 360 metagga
       & ,F_QPOINT   &                                ! 325 Q-POINT
       &, F_CORE_CHARGE(MAXNSP)   &              ! 500-515         
! ================= KT_add ====== 13.1R
       &, F_EPS_PHONON &                              ! 407 EPS_Phonon
       &, F_OPTICAL_COEFF &                           ! 408 Optical Coeff
       &, F_RAMAN_SPECTRA &                           ! 409 Raman spectra
! =============================== 13.1R

! ================= KT_add ====== 13.1XI
       &, F_EXCITATION_SPECTRA &                       ! 420 Excitation spectra
! =============================== 13.1XI
       &, F_MAG_CORE &                                 ! 378 Mag OpenCore
       &, F_ELECPOT_BIN, F_ELECPOT_BIN_REF &           ! 380, 381 Defect
! ================= KT_add ====== 13.0S
       &, F_CORE_ENERGY_OUT, F_CORE_ENERGY_INITIAL,  F_CORE_ENERGY_FINAL &
! =============================== 13.0S
       &, F_DYNM_CIF, F_WFk_Squared, F_WFk_IntegMoment &
       &, F_WFK_ORB_PROJ, F_BAND_SPECTR_WGHT, F_PORB_DENS_MAT, F_PORB_ROT_MAT &
! NPT, NPH-MD
       &, F_LATCONST, F_METRIC &
       &, F_DFTD3PAR &
       &, F_CHKPNT &
       &, F_HYBRIDINFO &
       &, F_SCF_ZAJ &
       &, F_POS, F_COORD_ATTR, F_DEFAULTPP, F_PWBS &
       &, F_XSF, F_N2P2, F_INP_MOD, F_ZAJ_KALL, F_KPOINT_BIN &
       &, F_POT_ORG(MAXNSP)

  namelist/fnames/ &
       &  F_INP, F_POT, F_PKB, F_PD, F_PPC, F_STOP, F_OPGR &
       & ,F_MATBP,F_KPOINT,F_KINDEX, F_VIBRATE, F_ZAK,F_NEORD,F_CNST &
       & ,F_OTP, F_DYNM,F_ENF, F_GPT, F_CHGT, F_CHGO, F_CHGU, F_CHGS &
       & ,F_OUT, F_CNTN, F_CNTN_BIN, F_ZAJ, F_RSP,  F_WF,   F_ENERG  &
       & ,F_VLC, F_CNTN_BIN_STM, F_STATUS &
       & ,F_SPG, F_KPGN, F_DOS, F_CHR, F_ELF, F_EGRID, F_LDOS & 
       & ,F_BERRY,F_EFFCHG,F_FORCE,F_MODE,F_EPSILON &
       & ,F_EPSOUT,F_PHDOS,F_OCCMAT,F_WFk,F_STRFRC &
       & ,F_WANNIER,F_CNTN_WAN,F_POT_WAN,F_EFERMI &
!-------------------- T. Hamada 2021.9.28 -------------------- ! UVSOR
!      & ,F_NLO,F_MAGOPT,F_EPSCONTA  &                          
       & ,F_NLO,F_MAGOPT,F_EPSCONT,F_KPT_DATA,F_KPTEPS_DATA  &     
!------------------------------------------------------------- ! UVSOR
       & ,F_PSTRN, F_VELEC, F_EPPAIR, F_EPPAIR2, F_VELEC_GRAD &        ! Positron
       & ,F_PSICOEF, F_BAND_SYM_INPUT &
! ================================== Added by K. Tagami ======= 10.1
       & ,F_CNTN_BIN_PAW &
       & ,F_LR_SPECTRA   &
! ============================================================= 10.1
       & ,F_CNTN_BERRY &
       & ,F_EKINDENS &
       & ,F_QPOINT &
       &, F_CORE_CHARGE &
! ================= KT_add ====== 13.1R
       &, F_EPS_PHONON &
       &, F_OPTICAL_COEFF &
       &, F_RAMAN_SPECTRA &
! =============================== 13.1R

! ================= KT_add === 13.1XI
       &, F_EXCITATION_SPECTRA &
! ============================ 13.1XI
       &, F_MAG_CORE &
       &, F_ELECPOT_BIN, F_ELECPOT_BIN_REF &
! ================= KT_add ====== 13.0S
       &, F_CORE_ENERGY_OUT, F_CORE_ENERGY_INITIAL,  F_CORE_ENERGY_FINAL &
! =============================== 13.0S
       &, F_DYNM_CIF, F_WFk_Squared, F_Wfk_IntegMoment &
       &, F_WFK_ORB_PROJ, F_BAND_SPECTR_WGHT, F_PORB_DENS_MAT, F_PORB_ROT_MAT &
       &, F_LATCONST, F_METRIC &
       &, F_DFTD3PAR &
       &, F_CHKPNT &
       &, F_HYBRIDINFO &
       &, F_SCF_ZAJ &
       &, F_POS, F_COORD_ATTR &
       &, F_DEFAULTPP &
       &, F_PWBS &
       &, F_XSF, F_N2P2, F_INP_MOD &
       &, F_ZAJ_KALL, F_KPOINT_BIN


  logical ::             F_ZAJ_partitioned      = .false.
  logical ::             F_CHGT_partitioned     = .false.
  logical ::             F_CNTN_BIN_partitioned = .false.
  logical ::             F_CNTN_partitioned     = .false.
  logical ::             F_ZAJ_in_partitioned      = .false.
  logical ::             F_CHGT_in_partitioned     = .false.
  logical ::             F_CNTN_BIN_in_partitioned = .false.
  logical ::             F_CNTN_in_partitioned     = .false.

! ======================== KT_add ================= 13.0D
  logical ::             F_CNTN_BIN_PAW_partitioned = .false.
  logical ::             F_CNTN_BIN_PAW_in_partitioned  = .false.
! ================================================= 13.0D

  character(len=stringlength_of_filenames) &
       &  ::             F_ZAJ_filetype,      F_CHGT_filetype &
       &              ,  F_CNTN_BIN_filetype,    F_CNTN_filetype
  character(len=stringlength_of_filenames) &
       &  ::             F_ZAJ_in_filetype,   F_CHGT_in_filetype &
       &               , F_CNTN_BIN_in_filetype, F_CNTN_in_filetype

! ======================== KT_add ================= 13.0D
  character(len=stringlength_of_filenames) &
       &                 F_CNTN_BIN_PAW_filetype, F_CNTN_BIN_PAW_in_filetype
! ================================================= 13.0D

  namelist/mpifiletypes/ F_ZAJ_filetype,         F_CHGT_filetype &
       &               , F_CNTN_BIN_filetype,    F_CNTN_filetype &
       &               , F_ZAJ_in_filetype,      F_CHGT_in_filetype &
       &               , F_CNTN_BIN_in_filetype, F_CNTN_in_filetype &
! ======================== KT_add ================= 13.0D
       &               , F_CNTN_BIN_PAW_filetype, F_CNTN_BIN_PAW_in_filetype
! ================================================= 13.0D


  character(len=stringlength_of_filenames) &
       &  ::             F_ZAJ_in, F_CHGT_in, F_CNTN_BIN_in, F_CNTN_in
  character(len=stringlength_of_filenames) &
       &  ::             F_ZAJ_bak, F_CHGT_bak, F_CNTN_BIN_bak, F_CNTN_bak

! ======================== KT_add ================= 13.0D
  character(len=stringlength_of_filenames) :: F_CNTN_BIN_PAW_in
! ================================================= 13.0D

  logical, private :: fout_is_given = .false.
  character(len=stringlength_of_filenames+3) :: F_STATUS_ext
  integer, dimension(-1:1) :: nfstm

  integer nfprm
  data nfprm/93/
  character(len=stringlength_of_filenames) ::  F_PRM
  namelist/f_param_name/F_PRM

  character, private :: name_jobstep*3
  
  integer  nfimage, nfnebstop, nfneb, nfnebcntn, nfnebenf, nfnebdynm, nfpath
  data  nfimage, nfnebstop, nfneb, nfnebcntn, nfnebenf, nfnebdynm, nfpath &
	/201,202,203,204,205,206,207/
  character(len=stringlength_of_filenames) :: F_IMAGE(-1:99), F_NEB_STOP, F_NEB_OUT, F_NEB_CNTN &
         &                                  , F_NEB_ENF, F_NEB_DYNM, F_PATH
  namelist/nebfiles/ F_IMAGE, F_NEB_STOP, F_NEB_OUT, F_NEB_CNTN, F_NEB_ENF, F_NEB_DYNM, F_PATH

  character(len=5) :: prefix='_conf'

! === KT_add === 2014/07/20
  character(len=100) :: F_OUT_BASE, F_CONF_EXTENSION, F_PARA_EXTENSION
! ============== 2014/07/20

! ==== KT_add ==== 2014/07/14
  integer :: nfhypervec
  data nfhypervec /210/
  character(len=100) :: F_HYPERVEC
!
  namelist /constraints/ F_HYPERVEC

  integer :: conftag=-1


! ================ 2014/07/14
!   Following interface block is moved from subroutines of 'm_Files_open_ps_files' and 'm_Files_open_ps_file",
!  according to a report from ASMS Co.ltd, 10 March 2016.
    interface
       subroutine phase_error(ierror,nfout,nfpp,filename,line,file)
         integer,         intent(in)          :: ierror, nfout, nfpp
         character(len=*),intent(in)          :: filename
         integer,         intent(in),optional :: line
         character(len=*),intent(in),optional :: file
       end subroutine phase_error
    end interface

contains

  subroutine m_Files_set_conftag(tag)
    integer, intent(in) :: tag
    conftag = tag
  end subroutine m_Files_set_conftag

  subroutine m_Files_set_stdout(nfo)
    integer, intent(in) :: nfo
    nfout = nfo
  end subroutine m_Files_set_stdout

  subroutine m_Files_open_standardout()
    character :: name_mype*12
    integer :: name_length
    integer ::   i, js, ls, imax
    logical ::   existence

    character(len=256) :: cid,cketa, f_tmp
    integer :: iketa=2
    integer :: itmp

    if(npes > 1) then
       name_length = 12
       imax = int(log10(dble(npes-1)))+1
       if(imax < min_ext_length_mype) imax = min_ext_length_mype
       if(imax > name_length) then
          call phase_error_with_msg(nfout,' number of pes (=npes) is larger than 1,000,000,000,000',__LINE__,__FILE__)
       end if
       write(name_mype,'(i12)') mype
       do i = 1+name_length-imax, name_length
          if(name_mype(i:i) == ' ') name_mype(i:i)='0'
       enddo
    end if

    ls = len(trim(F_OUT))

! === KT_add === 2014/07/20
    F_CONF_EXTENSION = "";    F_PARA_EXTENSION = ""

    if ( mype /= 0 ) then
       F_PARA_EXTENSION = '_'//name_mype(name_length-imax+1:name_length)
    endif
! ============== 2014/07/20

    if(.not.conf_para .or. conf_para.and.mype_conf==0) then

    cid = ''
    if(conftag>=0) then
      itmp=int(log10(real(conftag)))+1
      if(itmp>2)iketa=itmp
      write(cketa,*) iketa
      write(cid,'(i'//trim(adjustl(cketa))//'.'//trim(adjustl(cketa))//')') conftag
      cid = '.'//cid
    endif
    if(ls < 1) then
       fout_is_given = .false.
       if(mype==0) then
          do js = 0, 999
             write(name_jobstep,'(i3)') js
             do i = 1, 3
                if(name_jobstep(i:i) == ' ') name_jobstep(i:i)='0'
             enddo
             F_OUT = "output"//name_jobstep//trim(cid)
             if(sw_wdir == ON) then
                inquire(file=trim(workdir)//F_OUT, exist=existence)
             else
                inquire(file=F_OUT, exist=existence)
             end if
!!$             inquire(file=F_OUT, exist=existence)

! ==== KT_add ====== 2014/07/20
#ifdef NEB_NEW_FILENAMES
             if ( .not. existence ) then
                f_tmp = trim(F_OUT) //'_conf0'
                inquire(file=f_tmp, exist=existence)
             endif
             if ( .not. existence ) then
                f_tmp = trim(F_OUT) // '_conf00'
                inquire(file=f_tmp, exist=existence)
             endif
             if ( .not. existence ) then
                f_tmp = trim(F_OUT) // '_conf000'
                inquire(file=f_tmp, exist=existence)
             endif
#endif
! ================== 2014/07/20

             if(.not.existence) goto 1001
          end do
1001      if(js >=1000) js = 999
       end if
       if(npes > 1) call mpi_bcast(js,1,mpi_integer,0,mpi_comm_group,ierr)
       write(name_jobstep,'(i3)') js
       do i = 1, 3
          if(name_jobstep(i:i) == ' ') name_jobstep(i:i)='0'
       enddo
! =========== KT_mod ==== 2014/07/20
!       if(mype==0) then
!          F_OUT = "output"//name_jobstep
!       else
!          F_OUT = "output"//name_jobstep//'_'//name_mype(name_length-imax+1:name_length)
!       end if
!
       F_OUT_BASE = "output"//name_jobstep
       if(mype==0) then
          F_OUT = trim(F_OUT_BASE) // trim(cid)
       else
          F_OUT = trim(F_OUT_BASE) // trim(F_PARA_EXTENSION) // trim(cid)
       end if
! ======================= 2014/07/20
    else
       fout_is_given = .true.
       if(mype > 0) then
! =========== KT_mod ==== 2014/07/20
!          if(ls+imax+1 > stringlength_of_filenames) then
!             F_OUT = F_OUT(1:stringlength_of_filenames-(imax+1))//'_'//name_mype(name_length-imax+1:name_length)
!          else
!             F_OUT = F_OUT(1:ls)//'_'//name_mype(name_length-imax+1:name_length)
!          end if
!
          if(ls+imax+1 > stringlength_of_filenames) then
             F_OUT_BASE = F_OUT(1:stringlength_of_filenames-(imax+1))
          else
             F_OUT_BASE = F_OUT(1:ls)
          end if
          F_OUT = trim(F_OUT_BASE) // F_PARA_EXTENSION
! ======================= 2014/07/20
       end if
    end if

    endif

    if(conf_para)then
      call mpi_bcast(F_OUT,len(F_OUT),mpi_character,0,mpi_comm_world,ierr)
      call mpi_bcast(name_jobstep,len(name_jobstep),mpi_character,0,mpi_comm_world,ierr)

! === KT_add === 2014/07/20
      call mpi_bcast(F_OUT_BASE,len(F_OUT_BASE),mpi_character,0,mpi_comm_world,ierr)
! ============== 2014/07/20

!      if(mype_conf/=0.and.mype==0) then
#ifndef NEB_NEW_FILENAMES
      if(mype_conf/=0) then
#endif
        itmp=int(log10(real(nrank_conf)))+1
        if(itmp>2)iketa=itmp
        write(cketa,*) iketa
        write(cid,'(i'//trim(adjustl(cketa))//'.'//trim(adjustl(cketa))//')') mype_conf

! ==== KT_mod === 2014/07/20
!        F_OUT = trim(F_OUT)//trim(adjustl(prefix))//cid
!
        F_CONF_EXTENSION = trim(adjustl(prefix))//cid
        F_OUT = trim(F_OUT) // F_CONF_EXTENSION
! ============== 2014/07/20

#ifndef NEB_NEW_FILENAMES
      endif
#endif

! === KT_mod === 2014/07/20
!     if(mype/=0) F_OUT = trim(F_OUT)//'_'//name_mype(name_length-imax+1:name_length)
!
      if (mype/=0) F_OUT = trim(F_OUT) // F_PARA_EXTENSION
! ============== 2014/07/20

    endif

    if(sw_wdir == ON) then
!       open(6, file=trim(workdir)//F_OUT, status='unknown', form='formatted')
       open(nfout, file=trim(workdir)//F_OUT, status='unknown', form='formatted')
    else
!       open(6, file=F_OUT, status='unknown', form='formatted')
       open(nfout, file=F_OUT, status='unknown', form='formatted')
    end if

!!$    if(printable) write(nfout,'(" length of F_OUT = ",i8)') ls
!!$    if(printable) write(nfout,'(" F_OUT = ",a32)') F_OUT

  end subroutine m_Files_open_standardout

  subroutine m_Files_open_nfvlc
    if(mype == 0) &
         & call open0(nfvlc,F_VLC,'F_VLC     ',unknown,unformatted&
         &     , check_file_name_on)
  end subroutine m_Files_open_nfvlc

  subroutine m_Files_open_nfcntn
    logical open
    inquire(unit = nfcntn, opened = open)
    if(.not.open .and. mype==0) &
         & call open0(nfcntn,F_CNTN,'F_CNTN    ',unknown,formatted&
         &     ,check_file_name_on)
  end subroutine m_Files_open_nfcntn

  subroutine m_Files_open_nfcntn_bin
    logical open
    inquire(unit = nfcntn_bin, opened = open)
    if(open .and. printable) write(nfout,'("! nfcntn_bin is already open")')
    if(printable) &
         & write(nfout,'(" F_CNTN_BIN_in = ",a40," <<m_Files_open_nfcntn_bin>>")') F_CNTN_BIN_in

    if(F_CNTN_BIN_in_partitioned) then
       if(.not.open .and. mype == 0) then
          call open0(nfcntn_bin,F_CNTN_BIN_in,'F_CNTN_BIN',unknown,unformatted&
               &     ,check_file_name_on)
       else if(.not.open .and. mype /= 0) then
          call open0(nfcntn_bin,F_CNTN_BIN_in,'F_CNTN_BIN',unknown,unformatted&
               &     ,check_file_name_off)
       end if
    else
       if(.not.open .and. mype==0) &
            & call open0(nfcntn_bin,F_CNTN_BIN_in,'F_CNTN_BIN',unknown,unformatted&
            &     ,check_file_name_on)
    end if
  end subroutine m_Files_open_nfcntn_bin

  Subroutine m_Files_reopen_nfcntn
    logical open
    inquire(unit = nfcntn, opened = open)
    if(open .and. mype == 0) close(nfcntn)
    if(mype==0) &
         & call open0(nfcntn,F_CNTN,'F_CNTN    ',unknown,formatted&
         &     ,check_file_name_on)
  end subroutine m_Files_reopen_nfcntn

  subroutine m_Files_reopen_nfcntn_bin
    logical open
    inquire(unit = nfcntn_bin, opened = open)
!!$    if(open .and. printable) write(nfout,'("! nfcntn_bin is already open")')
    if(open) close(nfcntn_bin)
    if(F_CNTN_BIN_partitioned) then
       if(mype == 0) then
          call open0(nfcntn_bin, F_CNTN_BIN, 'F_CNTN_BIN',unknown, unformatted,check_file_name_on)
       else
          call open0(nfcntn_bin, F_CNTN_BIN, 'F_CNTN_BIN',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype == 0) call open0(nfcntn_bin,F_CNTN_BIN,'F_CNTN_BIN',unknown &
            &                         ,unformatted,check_file_name_on)
    end if
  end subroutine m_Files_reopen_nfcntn_bin

  subroutine m_Files_open_nfcntn_bin_stm
    logical open
    inquire(unit = nfcntn_bin_stm, opened = open)
    if(.not.open .and. mype==0) &
         & call open0(nfcntn_bin_stm,F_CNTN_BIN_STM,'F_CNTN_STM',unknown,unformatted&
         &     ,check_file_name_on)
  end subroutine m_Files_open_nfcntn_bin_stm

  subroutine m_Files_open_nfcntn_berry()
    logical open 
    inquire(unit = nfcntn_berry, opened = open)
    if(open) write(6,'("! nfcntn_berry is already opened")')
    if(.not.open .and. mype==0) &
    & call open0(nfcntn_berry,F_CNTN_BERRY,'F_CNTN_BERRY',unknown,unformatted &
    &      ,check_file_name_off)
  end subroutine m_Files_open_nfcntn_berry

  subroutine m_Files_close_nfcntn_berry()
    if(mype==0) close(nfcntn_berry)
  end subroutine m_Files_close_nfcntn_berry

  logical function m_Files_nfcntn_bin_paw_exists()
    logical :: ex
    inquire(file=F_CNTN_BIN_PAW,exist=ex) 
    m_Files_nfcntn_bin_paw_exists = ex
  end function m_Files_nfcntn_bin_paw_exists

  logical function m_Files_nfoccmat_exists()
    logical :: ex
    inquire(file=F_OCCMAT,exist=ex) 
    m_Files_nfoccmat_exists = ex
  end function m_Files_nfoccmat_exists

  subroutine m_Files_open_nfcntn_bin_paw
    logical open
    inquire(unit = nfcntn_bin_paw, opened = open)
    if(open) write(6,'("! nfcntn_bin_paw is already open")')
    if(open) close(nfcntn_bin_paw)
    if(open) open=.false.
    if(.not.open .and. mype==0) &
         & call open0(nfcntn_bin_paw,F_CNTN_BIN_PAW,'F_CNTN_BIN_PAW',unknown,unformatted&
         &     ,check_file_name_on)
  end subroutine m_Files_open_nfcntn_bin_paw

! ======================== KT_add ================= 13.0D
  subroutine m_Files_close_nfcntn_bin_paw()
    if(mype==0) close(nfcntn_bin_paw)
  end subroutine m_Files_close_nfcntn_bin_paw

  subroutine m_Files_reopen_nfcntn_bin_paw
    logical open
    inquire(unit = nfcntn_bin_paw, opened = open)
    if(open) close(nfcntn_bin_paw)

    if(.not.open .and. mype==0) &
         & call open0(nfcntn_bin_paw,F_CNTN_BIN_PAW,'F_CNTN_BIN_PAW',unknown,unformatted&
         &     ,check_file_name_on)
  end subroutine m_Files_reopen_nfcntn_bin_paw
! ================================================= 13.0D

  subroutine m_Files_open_nfstop
    if(mype == 0) call open0(nfstop,F_STOP,'F_STOP    '&
         &                  ,unknown,formatted,check_file_name_off)       ! MPI
  end subroutine m_Files_open_nfstop

  subroutine m_Files_close_nfstop
    if(mype == 0) close(nfstop,status='keep')  ! MPI
  end subroutine m_Files_close_nfstop

  subroutine m_Files_open_nfstatus
    integer :: ls
    integer :: itmp,iketa
    character(len=256) :: suf,cketa
    integer :: ierr
    if(mype == 0) then
!!$       write(nfout,'(" !! name_jobstep = ",a3)') name_jobstep
!!$       write(nfout,*) ' !! fout_is_given = ', fout_is_given
       if(fout_is_given) then
       else
!!$          if(.not.conf_para .or. conf_para.and.mype_conf==0) then
          ls = len(trim(F_STATUS))
          if(ls+3 > stringlength_of_filenames) then
             F_STATUS = F_STATUS(1:stringlength_of_filenames-3-iketa)//name_jobstep
          else
             F_STATUS = F_STATUS(1:ls)//name_jobstep
          end if
!!$          endif
          fout_is_given = .true.
!!$ '09.11.11
          if(conf_para)then
!!$            call mpi_bcast(F_STATUS,len(F_STATUS),mpi_character,0,mpi_comm_world,ierr)

#ifndef NEB_NEW_FILENAMES
             if(mype_conf/=0) then
#endif
                iketa=2
                itmp = int(log10(real(nrank_conf)))+1
                if(itmp>2)iketa=itmp
                write(cketa,*) iketa
                write(suf,'(i'//trim(adjustl(cketa))//'.'//trim(adjustl(cketa))//')') mype_conf
                F_STATUS = trim(F_STATUS)//trim(adjustl(prefix))//trim(adjustl(suf))
#ifndef NEB_NEW_FILENAMES
             endif
#endif
          endif
!!$ '09.11.11
       end if
!!$       open(nfstatus, file=F_STATUS, status='unknown',form='formatted')
       if(sw_wdir == ON) then
          open(nfstatus, file=trim(workdir)//F_STATUS, status='unknown',form='formatted')
       else
          open(nfstatus, file=F_STATUS, status='unknown',form='formatted')
       end if
    end if
  end subroutine m_Files_open_nfstatus

  subroutine m_Files_close_nfstatus
    if(mype == 0) close(nfstatus,status='keep')  ! MPI
  end subroutine m_Files_close_nfstatus

  subroutine m_Files_open_qpoint_files(way_ksample,nbztyp)
    integer, intent(in) :: way_ksample,nbztyp
    if(way_ksample == FILE .or. nbztyp < GENERAL) then
       call open0(nfqpoint,F_QPOINT,'F_QPOINT  ', old, formatted,check_file_name_on)
    end if
  end subroutine m_Files_open_qpoint_files

  subroutine m_Files_open_kpoint_files(way_ksample,nbztyp)
    integer, intent(in) :: way_ksample,nbztyp
!!!!!!!! modified by mizouchi@adv 2003.2.21 !!!!!
!!    call open0(nfmatbp, F_MATBP, 'F_MATBP   ',unknown,formatted,check_file_name_on)
!!    call open0(nfkpoint,F_KPOINT,'F_KPOINT  ', old,   formatted,check_file_name_on)
    if(way_ksample == FILE .or. nbztyp < GENERAL) then
       call open0(nfkpoint,F_KPOINT,'F_KPOINT  ', old,   formatted,check_file_name_on)
!  <-- modified by T. Yamasaki 4th May 2003
    end if
!!!!!!!! modified by mizouchi@adv 2003.2.21 !!!!!
!!$    if(nbztyp >= GENERAL) then
!!!!!!!! modified by mizouchi@adv 2003.2.21 !!!!!
!!       call open0(nfopgr, F_OPGR, 'F_OPGR    ', old,   formatted,check_file_name_on)
!!$       call open0(nfspg,  F_SPG,  'F_SPG     ', old,   formatted,check_file_name_on)
!!$       call open0(nfkpgn, F_KPGN, 'F_KPGN    ', old,   formatted,check_file_name_on)
!!!!!!!! modified by mizouchi@adv 2003.2.21 !!!!!
!!$    end if
  end subroutine m_Files_open_kpoint_files

  subroutine m_Files_open_kpoint_bin()
#ifdef FIX_ENDIANNESS
    if(mype==0) call open0(nfkpoint_bin, F_KPOINT_BIN, 'F_KPOINT_BIN     ',unknown, &
    &  unformatted,check_file_name_on,fix_endianness=.true.)
#else
    if(mype==0) call open0(nfkpoint_bin, F_KPOINT_BIN, 'F_KPOINT_BIN     ',unknown, &
    &  unformatted,check_file_name_on)
#endif
  end subroutine m_Files_open_kpoint_bin

  subroutine m_Files_close_kpoint_bin()
    if(mype==0) close(nfkpoint_bin)
  end subroutine m_Files_close_kpoint_bin

  subroutine m_Files_open_nfspg()
    call open0(nfspg,  F_SPG,  'F_SPG     ', old,   formatted,check_file_name_on)
  end subroutine m_Files_open_nfspg

  subroutine m_Files_open_nfkindex
    call open0(nfkindex, F_KINDEX, 'F_KINDEX  ',old,formatted,check_file_name_on)
  end subroutine m_Files_open_nfkindex

  subroutine set_filenumbers_of_NFSTM
    nfstm(-1) = nfchgu
    nfstm( 0) = nfchgs
    nfstm( 1) = nfchgo
  end subroutine set_filenumbers_of_NFSTM
      
  subroutine checkfilenumbers
    if(printable) then
       write(nfout,*) ' nfstm(-1) = ', nfstm(-1)
       write(nfout,*) ' nfstm( 0) = ', nfstm( 0)
       write(nfout,*) ' nfstm( 1) = ', nfstm( 1)
    end if
  end subroutine checkfilenumbers

!!$  subroutine m_Files_set_default_filenames_paramset
!!$    F_PRM       = './m_ArraySize_Parameters.f90'
!!$  end subroutine m_Files_set_default_filenames_paramset

  subroutine m_Files_set_default_filenames
    integer :: i
    character(len=stringlength_of_filenames) :: pppath
    F_file_names_data   = "./file_names.data"
!c---------- Input files.
    call set_filenumbers_of_NFSTM
!!$    if(.not.paramset) call checkfilenumbers
    F_INP       = "./nfinp.data"
    F_POT(1)    = "./pot.01"   !  fort.37'
    F_POT(2)    = "./pot.02"   !  fort.38'
    F_POT(3)    = "./pot.03"   !  fort.39'
    F_POT(4)    = "./pot.04"   !  fort.40'
    F_POT(5)    = "./pot.05"   !  fort.45'
    F_POT(6)    = "./pot.06"   !  fort.46'
    F_POT(7)    = "./pot.07"   !  fort.11'
    F_POT(8)    = "./pot.08"   !  fort.12'
    F_POT(9)    = "./pot.09"   !  fort.13'
    F_POT(10)   = "./pot.10"   !  fort.14'
    F_POT(11)   = "./pot.11"   !  fort.15'
    F_POT(12)   = "./pot.12"   !  fort.16'
    F_POT(13)   = "./pot.13"   !  fort.17'
    F_POT(14)   = "./pot.14"   !  fort.18'
    F_POT(15)   = "./pot.15"   !  fort.19'
    F_POT(16)   = "./pot.16"   !  fort.36'
    do i=1,16
    F_POT_ORG(i) = F_POT(i)
    enddo
    F_PKB       = "./vkb.data"
    F_PD        = "./vd.data"
    F_PPC       = "./vpc.data"
    F_STOP      = "./nfstop.data"
    F_CNST      = "./nfcnst.data"
!c---------- nbztype >= 100
    F_OPGR      = "./opgr.data"
    F_MATBP     = "./matrix.BP"
    F_KPOINT    = "./kpoint.data"
    F_QPOINT    = "./qpoint.data"
    F_KINDEX    = "./f.kp0"
!!!!!!!! added by mizouchi@adv 2003.2.21 !!!!!
    F_SPG       = "./bnprp4.i5"
    F_KPGN      = "./bnkpgn.i5"
!!!!!!!! added by mizouchi@adv 2003.2.21 !!!!!
!c---------- Output files.
    F_OTP       = "./nfotp.data"
    F_DYNM      = "./nfdynm.data"
    F_DYNM_CIF  = "./nfdynm.cif"
!!$    F_FORCE     = "./nfforce.data"
    F_EGRID     = "./nfegrid.data"
    F_LDOS      = "./nfldos.data"
    F_ENF       = "./nfefn.data"
!!$    F_GPT       = "./nfgpt.data"
    F_CHGT      = "./nfchgt.data"
    F_CHGO      = "./nfchgo.data"
    F_CHGU      = "./nfchgu.data"
!#ifdef _STMIMG_EVERY_TIME_
    F_CHGS      = "./nfchgs.data"
!#endif
    F_ENERG     = "./nfenergy.data"
    F_OUT       = ""
    F_STATUS    = "./jobstatus"
!c----------- Information files
!c      F_IENG     = "./nfieng.data"
!c----------- Continue file
    F_CNTN      = "./continue.data"
    F_CNTN_BIN  = "./continue_bin.data"
    F_ZAJ       = "./zaj.data"
    F_CNTN_BIN_PAW  = "./continue_bin_paw.data"
    F_VLC       = "./nfvlc.data"
    F_CNTN_BIN_STM = "./continue_bin_stm.data"

!c----------- Work files.
    F_WF(1)     = "./ftn95.data"
    F_WF(2)     = "./ftn96.data"
    F_WF(3)     = "./ftn97.data"
!c---------------------
    if(paramset) F_PRM       = "./m_ArraySize_Parameters.f90"
    F_DOS       = "./dos.data"
    F_CHR       = "./nfchr.data"
    F_WFk       = "./nfwfk.data"
    F_WANNIER   = "./nfwannier.data"
    F_CNTN_WAN  = "./nfcontinue_wannier.data"
    F_POT_WAN   = "./nfpotential_wannier.data"
    F_ELF       = "./nfelf.data"
    F_BERRY     = "./berry.data"
    F_EFFCHG    = "./effchg.data"
    F_FORCE     = "./force.data"
    F_MODE      = "./mode.data"
    F_EPSILON   = "./epsilon.data"
    F_EPSOUT    = "./eps.data"
    F_NLO       = "./nlo.data"         ! UVSOR
    F_MAGOPT    = "./magopt.data"      ! UVSOR
    F_EPSCONT   = "./eps_continue.data"! UVSOR
!-------------------- T. Hamada 2021.9.23 -------------------- ! UVSOR
    F_KPT_DATA  = "./kpt.data"         
    F_KPTEPS_DATA = "./kpteps.data"    
!------------------------------------------------------------- ! UVSOR
    F_PHDOS     = "./phdos.data"
    F_PHDOS     = "./phdos.data"
    F_OCCMAT    = "./occmat.data"
    F_STRFRC    = "./strfrc.data"
    F_PSTRN     = "./positron.cube"
    F_VELEC     = "./electron.cube"
    F_EPPAIR    = "./ep_pair.cube"
    F_EPPAIR2   = "./ep_pair2.cube"
    F_VELEC_GRAD= "./electron_grad.cube"
    F_PSICOEF   = "./psicoef.data"
    F_BAND_SYM_INPUT = "./band_sym_input.data"
    F_EFERMI    = "./nfefermi.data"
! ---------- mpifiletypes
    F_ZAJ_filetype = "unified"
    F_CHGT_filetype = "unified"
    F_CNTN_BIN_filetype = "unified"
    F_CNTN_filetype = "unified"
    F_CNTN_BIN_PAW_filetype = "unified"
 
    F_ZAJ_in      = F_ZAJ
    F_CNTN_in     = F_CNTN
    F_CNTN_BIN_in = F_CNTN_BIN
    F_CHGT_in     = F_CHGT

    F_ZAJ_bak      = F_ZAJ
    F_CNTN_bak     = F_CNTN
    F_CNTN_BIN_bak = F_CNTN_BIN
    F_CHGT_bak     = F_CHGT
 
    F_ZAJ_in_filetype = "nogiven"
    F_CHGT_in_filetype = "nogiven"
    F_CNTN_BIN_in_filetype = "nogiven"
    F_CNTN_in_filetype = "nogiven"   

! ---------- nebfiles
    F_NEB_OUT  = "./output_neb"
    F_IMAGE(0)  = "./endpoint0.data"
    F_IMAGE(-1) = "./endpoint1.data"
    F_NEB_STOP = "./nfnebstop.data"
    F_NEB_CNTN = "./neb_continue.data"
    F_NEB_ENF = "./nfnebenf.data"
    F_NEB_DYNM = "./nfnebdynm.data"
    F_PATH = "./nfdynm.data"

! ---------- PAW continuation file
    F_CNTN_BIN_PAW          = "./continue_bin_paw.data"

! ======================== KT_add ================= 13.0D
    F_CNTN_BIN_PAW_in = F_CNTN_BIN_PAW
    F_CNTN_BIN_PAW_in_filetype = 'nogiven'
! ================================================= 13.0D

! ============================== Added by K. Tagami ======== 10.1
    F_LR_SPECTRA = "./spectrum.data"
! ========================================================== 10.1

    F_CNTN_BERRY = './continue_bin_berry.data'
    F_EKINDENS   = './ekindens_bin.data'

! ======== KT_add =========== 13.0S
    F_CORE_ENERGY_OUT = './core_energy.data'
    F_CORE_ENERGY_INITIAL = './core_energy.initial'
    F_CORE_ENERGY_FINAL   = './core_energy.final'
! =========================== 13.0S
    
! ====== KT_add === 13.1R
    F_EPS_PHONON = './nfeps_phonon.data'
    F_OPTICAL_COEFF = './nfoptical_coeff.data'
    F_RAMAN_SPECTRA = './raman_spectra.data'
! ================= 13.1R

! ====== KT_add ====== 13.1XI
    F_EXCITATION_SPECTRA = './excitation_spectra.data'
! ================= 13.1XI

! ====== KT_add === 2014/07/14/
    F_HYPERVEC = './hypervector.data'
! ================= 2014/07/14/

    F_WFk_Squared  = "./wfnsq.cube"
    F_WFk_IntegMoment   = "./wfn_integ_moment.data"
    F_WFK_ORB_PROJ    = "./wfn_orb_proj.data"

    F_BAND_SPECTR_WGHT = "./nfband_spectr_wght.data"
    F_PORB_DENS_MAT = "./porb_density_matrix.data"
    F_PORB_ROT_MAT = "./porb_rot_matrix.data"

    F_MAG_CORE = './nfmag_core.data'
    F_ELECPOT_BIN = './elecpot_bin.data'
    F_ELECPOT_BIN_REF = './elecpot_bin.data.ref'

    F_LATCONST = "./nflatconst.data"
    F_METRIC   = "./nfmetric.data"

    F_DFTD3PAR = "./dftd3par.data"

    F_CHKPNT   = "chkpnt"

    F_HYBRIDINFO   = "./nfhybridinfo.data"
    F_SCF_ZAJ   = "./zaj.data"

    F_POS = "./nfinp.data"
    F_COORD_ATTR = "./nfinp.data"

    call getenv('PHASE_PP_PATH',pppath)
    if(len(pppath)==0) then
    F_DEFAULTPP = './defaultpp.data'
    else
    F_DEFAULTPP = trim(pppath)//'/defaultpp.data'
    endif

    F_PWBS = './nfpwbs.data'

    F_XSF  = './nfdynm.xsf'
    F_N2P2 = './nfdynm.n2p2'

    F_INP_MOD = './nfinp_mod.data'

    F_ZAJ_KALL = './zaj_kall.data'

    F_KPOINT_BIN = './kpoint_bin.data'
    
  end subroutine m_Files_set_default_filenames
      
  subroutine m_Files_set_def_fname_pos(fname)
    character(len=*), intent(in) :: fname
    F_POS = fname
  end subroutine m_Files_set_def_fname_pos

  subroutine m_Files_set_def_fname_attr()
    F_COORD_ATTR = F_INP
  end subroutine m_Files_set_def_fname_attr

  subroutine m_Files_rd_file_names_data
    integer, parameter ::  nffile = 99
    logical :: existence
    integer :: iwarning

    if(sw_wdir==ON)then
       inquire(file=trim(workdir)//F_file_names_data, exist = existence)
    else
       inquire(file=F_file_names_data, exist = existence)
    endif
    if(existence) then
       call open0(nffile, F_file_names_data, "FFILENAMES", old, formatted,check_file_name_off)
       !      open(nffile,file="./file_names.data",status='unknown')
       rewind nffile
       read(nffile,NML = fnames, err = 1007, end = 1004)
1004   continue
       rewind nffile
       read(nffile,NML = nebfiles, err = 1008, end = 1005)
1005   continue
       close(nffile,status='keep')
    else
       iwarning = FILENAMES_NOT_EXIST
       if(mype==0) call m_EMsg_Warning(iwarning, nfout)
    end if

    F_ZAJ_bak      = F_ZAJ
    F_CHGT_bak     = F_CHGT
    F_CNTN_BIN_bak = F_CNTN_BIN
    F_CNTN_bak     = F_CNTN

    return
!1007 stop ' file_names.data fnames format error'
!1008 stop ' file_names.data nebfiles format error'
1007 call phase_execution_error(FILENAMES_FORMAT_ERROR)
1008 call phase_execution_error(FILENAMES_FORMAT_ERROR_NEB)
  end subroutine m_Files_rd_file_names_data

  logical function m_Files_check_nfcntn_existence()
    logical :: existence
    existence = .false.
!!$    if((.not.F_CNTN_in_partitioned .and. mype == 0) .or. F_CNTN_in_partitioned) then
    if(mype == 0) then
       if(sw_wdir == ON) then
          inquire(file=trim(workdir)//F_CNTN_in,exist = existence)
       else
          inquire(file=F_CNTN_in,exist = existence)
       end if
    end if
!!$    if(.not.F_CNTN_in_partitioned .and. npes >1) call mpi_bcast(existence,1,mpi_logical,0,mpi_comm_group,ierr)
    if(npes >1) call mpi_bcast(existence,1,mpi_logical,0,mpi_comm_group,ierr)
    m_Files_check_nfcntn_existence = existence
  end function m_Files_check_nfcntn_existence

  subroutine m_Files_check_file_existence
    integer, parameter ::  nffile = 99
    logical :: existence, existence_all
    integer, allocatable, dimension(:,:) :: file_existence !d(npes,cont files)
    integer, allocatable, dimension(:) :: file_existence_local !d(cont files)
    integer :: i, j, npartitioned_files
    character :: name_mype*12
!!!    logical :: existence
    integer :: name_length, imax
    logical, save :: firstcall_to_add_name_mype=.true.
    if(sw_wdir==ON)then
       inquire(file=trim(workdir)//F_file_names_data, exist = existence)
    else
       inquire(file=F_file_names_data, exist = existence)
    endif
    if(existence) then
       call open0(nffile, F_file_names_data, "FFILENAMES", old, formatted,check_file_name_on)
       rewind nffile
       read(nffile,NML = mpifiletypes, err = 1005, end = 1005)
    end if

    if(F_ZAJ_in_filetype == "nogiven") F_ZAJ_in_filetype = F_ZAJ_filetype
    if(F_CHGT_in_filetype == "nogiven") F_CHGT_in_filetype = F_CHGT_filetype
    if(F_CNTN_BIN_in_filetype == "nogiven") F_CNTN_BIN_in_filetype = F_CNTN_BIN_filetype
    if(F_CNTN_in_filetype == "nogiven") F_CNTN_in_filetype = F_CNTN_filetype

! ======================== KT_add ================= 13.0D
    if(F_CNTN_BIN_PAW_in_filetype == 'nogiven') &
         &            F_CNTN_BIN_PAW_in_filetype = F_CNTN_BIN_PAW_filetype
! ================================================= 13.0D

    if(printable) then
       write(nfout,'(" !! mpifiletypes is read")')
       write(nfout,'(" !! F_ZAJ_filetype         = ",a12)') F_ZAJ_filetype
       write(nfout,'(" !! F_CHGT_filetype        = ",a12)') F_CHGT_filetype
       write(nfout,'(" !! F_CNTN_BIN_filetype    = ",a12)') F_CNTN_BIN_filetype
       write(nfout,'(" !! F_CNTN_filetype        = ",a12)') F_CNTN_filetype
       write(nfout,'(" !! F_ZAJ_in_filetype      = ",a12)') F_ZAJ_in_filetype
       write(nfout,'(" !! F_CHGT_in_filetype     = ",a12)') F_CHGT_in_filetype
       write(nfout,'(" !! F_CNTN_BIN_in_filetype = ",a12)') F_CNTN_BIN_in_filetype
       write(nfout,'(" !! F_CNTN_in_filetype     = ",a12)') F_CNTN_in_filetype

! ======================== KT_add ================= 13.0D
       write(nfout,'(" !! F_CNTN_BIN_PAW_in_filetype     = ",a12)') &
            &                            F_CNTN_BIN_PAW_in_filetype
! ================================================= 13.0D
    end if

    call strncmp0('partitioned',trim(F_ZAJ_filetype),     F_ZAJ_partitioned)
    call strncmp0('partitioned',trim(F_CHGT_filetype),    F_CHGT_partitioned)
    call strncmp0('partitioned',trim(F_CNTN_BIN_filetype),F_CNTN_BIN_partitioned)
    call strncmp0('partitioned',trim(F_CNTN_filetype),    F_CNTN_partitioned)
    call strncmp0('partitioned',trim(F_ZAJ_in_filetype),     F_ZAJ_in_partitioned)
    call strncmp0('partitioned',trim(F_CHGT_in_filetype),    F_CHGT_in_partitioned)
    call strncmp0('partitioned',trim(F_CNTN_BIN_in_filetype),F_CNTN_BIN_in_partitioned)
    call strncmp0('partitioned',trim(F_CNTN_in_filetype),    F_CNTN_in_partitioned)

! ======================== KT_add ================= 13.0D
    call strncmp0('partitioned',trim(F_CNTN_BIN_PAW_in_filetype),&
         &                                  F_CNTN_BIN_PAW_in_partitioned )
! ================================================= 13.0D

    if(npes > 1) then
       if(printable) then
          write(nfout,*) '!! F_ZAJ_partitioned         = ',F_ZAJ_partitioned
          write(nfout,*) '!! F_CHGT_partitioned        = ',F_CHGT_partitioned
          write(nfout,*) '!! F_CNTN_BIN_partitioned    = ',F_CNTN_BIN_partitioned
          write(nfout,*) '!! F_CNTN_partitioned        = ',F_CNTN_partitioned
          write(nfout,*) '!! F_ZAJ_in_partitioned      = ',F_ZAJ_in_partitioned
          write(nfout,*) '!! F_CHGT_in_partitioned     = ',F_CHGT_in_partitioned
          write(nfout,*) '!! F_CNTN_BIN_in_partitioned = ',F_CNTN_BIN_in_partitioned
          write(nfout,*) '!! F_CNTN_in_partitioned     = ',F_CNTN_in_partitioned
       end if
    end if

    goto 1006
1005 continue
    if(printable) write(nfout,'(" !! mpifiletypes is not read")')
1006 continue

    F_ZAJ_in      = F_ZAJ
    F_CHGT_in     = F_CHGT
    F_CNTN_BIN_in = F_CNTN_BIN
    F_CNTN_in     = F_CNTN

! ======================== KT_add ================= 13.0D
    F_CNTN_BIN_PAW_in = F_CNTN_BIN_PAW
! ================================================= 13.0D

    if(npes > 1) then
       name_length = 12
       imax = int(log10(dble(npes-1)))+1
       if(imax < min_ext_length_mype) imax = min_ext_length_mype
       if(imax > name_length) then
          call phase_error_with_msg(nfout,' number of pes (=npes) is larger than 1,000,000,000,000',__LINE__,__FILE__)
       end if
       write(name_mype,'(i12)') mype
       do i = 1+name_length-imax, name_length
          if(name_mype(i:i) == ' ') name_mype(i:i)='0'
       enddo
!!$       do i = 1, 4
!!$          if(name_mype(i:i) == ' ') name_mype(i:i) = '0'
!!$       end do
       if(firstcall_to_add_name_mype) then
         if(F_ZAJ_partitioned)      call add_name_mype(F_ZAJ)
         if(F_CHGT_partitioned)     call add_name_mype(F_CHGT)
         if(F_CNTN_BIN_partitioned) call add_name_mype(F_CNTN_BIN)
         if(F_CNTN_partitioned)     call add_name_mype(F_CNTN)
         if(F_ZAJ_in_partitioned)      call add_name_mype(F_ZAJ_in)
         if(F_CHGT_in_partitioned)     call add_name_mype(F_CHGT_in)
         if(F_CNTN_BIN_in_partitioned) call add_name_mype(F_CNTN_BIN_in)
         if(F_CNTN_in_partitioned)     call add_name_mype(F_CNTN_in)

! ======================== KT_add ================= 13.0D
         if (F_CNTN_BIN_PAW_in_partitioned) call add_name_mype(F_CNTN_BIN_PAW_in)
! ================================================= 13.0D
         firstcall_to_add_name_mype = .false.
       endif

    end if

    if(printable) write(nfout,'(" F_POT(1) = ",a60)') F_POT(1)
    !!$ print *, ' paramset = ',paramset

    if(paramset) call read_file_names_data_paramset

!!$    file_existence_contfiles = .true.
!!$    file_existence_3contfiles = .true.

!!$    inquire(file=F_CNTN_in,exist = existence)
    if(sw_wdir == ON) then
       inquire(file=trim(workdir)//F_CNTN_in,exist = existence)
    else
       inquire(file=F_CNTN_in,exist = existence)
    end if

    if(.not.F_CNTN_in_partitioned .and. npes >1) call mpi_bcast(existence,1,mpi_logical,0,mpi_comm_group,ierr)
!!345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
!!$    if(.not.existence) file_existence_contfiles = .false.
!!$    if(.not.existence) file_existence_3contfiles = .false.
    file_existence_nfcntn = existence

!!$    inquire(file=F_CNTN_BIN_in, exist = existence)
    if(sw_wdir == ON) then
       inquire(file=trim(workdir)//F_CNTN_BIN_in, exist = existence)
    else
       inquire(file=F_CNTN_BIN_in, exist = existence)
    end if
    if(.not.F_CNTN_BIN_in_partitioned .and. npes >1) call mpi_bcast(existence,1,mpi_logical,0,mpi_comm_group,ierr)
!!$    if(.not.existence) file_existence_contfiles = .false.
    file_existence_nfcntn_bin = existence

!   -------------------------------  ! T. Y. 2020/02/28
    if(sw_wdir == ON) then
       inquire(file=trim(workdir)//F_CNTN_BIN_PAW_in,exist = existence)
    else
       inquire(file=F_CNTN_BIN_PAW_in,exist = existence)
    end if

    if(.not.F_CNTN_BIN_PAW_in_partitioned .and. npes >1) call mpi_bcast(existence,1,mpi_logical,0,mpi_comm_group,ierr)
    file_existence_nfcntn_bin_paw = existence
!   -------------------------------

    if(sw_wdir == ON) then
       inquire(file=trim(workdir)//F_ZAJ, exist = existence)
    else
       inquire(file=F_ZAJ_in, exist = existence)
    end if
    if(.not.F_ZAJ_in_partitioned .and. npes >1) call mpi_bcast(existence,1,mpi_logical,0,mpi_comm_group,ierr)
!!$    if(.not.existence) file_existence_contfiles = .false.
!!$    if(.not.existence) file_existence_3contfiles = .false.
    file_existence_nfzaj = existence

!!$    inquire(file=F_CHGT_in, exist = existence)
    if(sw_wdir == ON) then
       inquire(file=trim(workdir)//F_CHGT, exist = existence)
    else
       inquire(file=F_CHGT_in, exist = existence)
    end if
    if(.not.F_CHGT_in_partitioned .and. npes >1) call mpi_bcast(existence,1,mpi_logical,0,mpi_comm_group,ierr)
!!$    if(.not.existence) file_existence_contfiles = .false.
!!$    if(.not.existence) file_existence_3contfiles = .false.
    file_existence_nfchgt = existence

!   -------------------------------
    if(sw_wdir == ON) then
       inquire(file=trim(workdir)//F_OCCMAT,exist = existence)
    else
       inquire(file=F_OCCMAT,exist = existence)
    end if

    if(npes >1) call mpi_bcast(existence,1,mpi_logical,0,mpi_comm_group,ierr)
    file_existence_nfoccmat = existence
!   -------------------------------
    
    if(npes > 1) then
       npartitioned_files = 0
       if(F_CNTN_in_partitioned)         npartitioned_files = npartitioned_files+1
       if(F_CNTN_BIN_in_partitioned)     npartitioned_files = npartitioned_files+1
       if(F_CNTN_BIN_PAW_in_partitioned) npartitioned_files = npartitioned_files+1 
                                                             ! T. Y. 2020/02/28
       if(F_ZAJ_in_partitioned)          npartitioned_files = npartitioned_files+1
       if(F_CHGT_in_partitioned)         npartitioned_files = npartitioned_files+1
       if(printable) write(nfout,'(" !! npartitioned_files = ",i5)') npartitioned_files
       if(npartitioned_files >=1) then
          allocate(file_existence(0:npes-1,npartitioned_files))
          allocate(file_existence_local(npartitioned_files))
          file_existence_local = 0
          j = 0
          if(F_CNTN_in_partitioned ) then
             j = j+1; if(file_existence_nfcntn)     file_existence_local(j) = 1
          end if
          if(F_CNTN_BIN_in_partitioned) then
             j = j+1; if(file_existence_nfcntn_bin) file_existence_local(j) = 1
          end if
          if(F_CNTN_BIN_PAW_in_partitioned) then
             j = j+1; if(file_existence_nfcntn_bin_paw) file_existence_local(j) = 1
          end if
          if(F_ZAJ_in_partitioned) then
             j = j+1; if(file_existence_nfzaj)      file_existence_local(j) = 1
          end if
          if(F_CHGT_in_partitioned) then
             j = j+1; if(file_existence_nfchgt)     file_existence_local(j) = 1
          end if

#ifdef FFT_ALLTOALL
          call mpi_gather(file_existence_local, npartitioned_files, mpi_integer, &
                          file_existence, npartitioned_files, mpi_integer, &
                          0, mpi_comm_group, ierr)
#else
          do i = 0, npes-1
             if(i >= 1) then
                if(mype == i ) then
                   call mpi_send(file_existence_local,npartitioned_files,mpi_integer,0,1,mpi_comm_group,ierr)
                else if(mype == 0) then
                   call mpi_recv(file_existence_local,npartitioned_files,mpi_integer,i,1,mpi_comm_group,istatus,ierr)
                end if
             end if
             if(mype == 0) file_existence(i,1:npartitioned_files) = file_existence_local(1:npartitioned_files)
         end do
#endif
       end if

       if(mype == 0) then
          j = 0
          if(F_CNTN_in_partitioned) then
             j = j+1; call check_file_existence_all(j,existence_all); file_existence_nfcntn = existence_all
          end if
          if(F_CNTN_BIN_in_partitioned) then
             j = j+1; call check_file_existence_all(j,existence_all); file_existence_nfcntn_bin = existence_all
          end if
          if(F_CNTN_BIN_PAW_in_partitioned) then
             j = j+1; call check_file_existence_all(j,existence_all); file_existence_nfcntn_bin_paw = existence_all
          end if
          if(F_ZAJ_in_partitioned) then
             j = j+1; call check_file_existence_all(j,existence_all); file_existence_nfzaj = existence_all
          end if
          if(F_CHGT_in_partitioned) then
             j = j+1; call check_file_existence_all(j,existence_all); file_existence_nfchgt = existence_all
          end if
       end if

       if(npartitioned_files >= 1) then
          deallocate(file_existence_local)
          deallocate(file_existence)
       end if
    end if

    file_existence_contfiles = .true.
    file_existence_contfiles_when_paw_on = .true.
    if(.not.file_existence_nfcntn)     file_existence_contfiles = .false.
    if(printable) write(nfout,'(" file_existence_nfcntn     = ",L3," file_existence_contfiles = ",L3)') &
         & file_existence_nfcntn, file_existence_contfiles
    if(.not.file_existence_nfcntn_bin) file_existence_contfiles = .false.
    if(printable) write(nfout,'(" file_existence_nfcntn_bin = ",L3," file_existence_contfiles = ",L3)') &
         & file_existence_nfcntn_bin, file_existence_contfiles
    if(.not.file_existence_nfzaj)      file_existence_contfiles = .false.
    if(printable) write(nfout,'(" file_existence_nfzaj      = ",L3," file_existence_contfiles = ",L3)') &
         & file_existence_nfzaj, file_existence_contfiles
    if(.not.file_existence_nfchgt)     file_existence_contfiles = .false.
    if(printable) write(nfout,'(" file_existence_nfchgt     = ",L3," file_existence_contfiles = ",L3)') &
         & file_existence_nfchgt, file_existence_contfiles

    if(.not.file_existence_contfiles .or. .not.file_existence_nfcntn_bin_paw) &
         &   file_existence_contfiles_when_paw_on = .false.    ! T. Y. 2020/02/28
    if(printable)  write(nfout,&
         &  '(" file_existence_nfcntn_bin_paw = ",L3," file_existence_contfiles_when_paw_on = ",L3)') &
         &      file_existence_nfcntn_bin_paw,         file_existence_contfiles_when_paw_on  ! T. Y. 2020/02/28

    file_existence_3contfiles = .true.
    if(.not.file_existence_nfcntn)     file_existence_3contfiles = .false.
    if(.not.file_existence_nfzaj)      file_existence_3contfiles = .false.
    if(.not.file_existence_nfchgt)     file_existence_3contfiles = .false.

    if(printable) then
       write(nfout,'(" --- existence check of continue files ---")')
       call check_file_existence('F_CNTN          ',F_CNTN_in,file_existence_nfcntn)
       call check_file_existence('F_CNTN_BIN      ',F_CNTN_BIN_in,file_existence_nfcntn_bin)
       call check_file_existence('F_CNTN_BIN_PAW  ',F_CNTN_BIN_PAW_in,file_existence_nfcntn_bin_paw) ! T. Y. 2020/02/28
       call check_file_existence('F_ZAJ           ',F_ZAJ_in,file_existence_nfzaj)
       call check_file_existence('F_CHGT          ',F_CHGT_in,file_existence_nfchgt)
       call check_file_existence('contfiles       ','continue files',file_existence_contfiles)
       call check_file_existence('contfiles paw on','continue files when paw on' & ! T. Y. 2020/02/28
            &                    ,file_existence_contfiles_when_paw_on)
       call check_file_existence('3contfiles      ','3continue files',file_existence_3contfiles)
       write(nfout,'(" -----------------------------------------")')
    end if
    if(existence) close(nffile,status='keep')
  contains
    subroutine add_name_mype(F)
      character(len=*), intent(inout) :: F
      integer :: ls
      ls = len(trim(F))
!!$      if(ls+5 > stringlength_of_filenames) then
      if(ls+imax+1 > stringlength_of_filenames) then
         F = F(1:stringlength_of_filenames-(imax+1))//'_'//name_mype(name_length-imax+1:name_length)
      else
         F = F(1:ls)//'_'//name_mype(name_length-imax+1:name_length)
      end if
    end subroutine add_name_mype

    subroutine check_file_existence_all(npfile,tf)
      integer, intent(in)  :: npfile
      logical, intent(out) :: tf
      integer :: i
      tf = .true.
      do i = 0, npes-1
         if(file_existence(i,npfile) == 0) then
            tf = .false.
            exit
         end if
      end do
    end subroutine check_file_existence_all

    subroutine check_file_existence(tagname,filename,torf)
      character(len=16),intent(in) :: tagname
      character(len=*), intent(in) :: filename
      logical, intent(in) ::          torf
      integer :: ls
      character(len=12) :: exist_or_not

      if(torf) then
         exist_or_not = 'existing'
      else
         exist_or_not = 'not existing'
      end if

      ls = len(trim(filename))
      write(nfout,*) tagname," (= ",trim(filename)," ) ", trim(exist_or_not)
    end subroutine check_file_existence
  end subroutine m_Files_check_file_existence

  function m_Files_check_nfzaj_existence()
    logical m_Files_check_nfzaj_existence
    m_Files_check_nfzaj_existence = file_existence_nfzaj
  end function m_Files_check_nfzaj_existence

  function m_Files_check_nfchgt_existence()
    logical m_Files_check_nfchgt_existence
    m_Files_check_nfchgt_existence = file_existence_nfchgt
  end function m_Files_check_nfchgt_existence
  subroutine m_Files_check_file_names()
    if(printable) then
       write(nfout,'(" --- check of file_names ---")')
       call repeat_filename('F_INP     ',F_INP)
       call repeat_filename('F_POT(1)  ',F_POT(1))
       call repeat_filename('F_POT(2)  ',F_POT(2))
       call repeat_filename('F_POT(3)  ',F_POT(3))
!!$       write(nfout,'(" F_INP      = ", a60)') F_INP
!!$       write(nfout,'(" F_POT(1)   = ", a60)') F_POT(1)
!!$       write(nfout,'(" F_POT(2)   = ", a60)') F_POT(2)
!!$       write(nfout,'(" F_POT(3)   = ", a60)') F_POT(3)
!!$       call repeat_filename('F_CNST    ',F_CNST)
       call repeat_filename('F_KPOINT  ',F_KPOINT)
       call repeat_filename('F_CHGT    ',F_CHGT_in)
       call repeat_filename('F_CNTN    ',F_CNTN_in)
       call repeat_filename('F_CNTN_BIN',F_CNTN_BIN_in)
       call repeat_filename('F_ZAJ     ',F_ZAJ_in)
       call repeat_filename('F_STOP    ',F_STOP)
!!$       write(nfout,'(" F_CNST     = ", a60)') F_CNST
!!$       write(nfout,'(" F_CHGT     = ", a60)') F_CHGT
!!$!!$    write(nfout,'(" F_MATBP    = ", a60)') F_MATBP
!!$       write(nfout,'(" F_KPOINT   = ", a60)') F_KPOINT
!!$!!$       write(nfout,'(" F_KINDEX   = ", a60)') F_KINDEX
!!$       write(nfout,'(" F_CNTN     = ", a60)') F_CNTN
!!$       write(nfout,'(" F_CNTN_BIN = ", a60)') F_CNTN_BIN
!!$       write(nfout,'(" F_ZAJ      = ", a60)') F_ZAJ

!!$       if(ekmode==ON) write(nfout,'(" F_ENERG    = ", a60)') F_ENERG
       if(ekmode==ON) call repeat_filename('F_ENERG   ',F_ENERG)

       write(nfout,'(" F_NEB_OUT   = ", a60)') F_NEB_OUT
       write(nfout,'(" F_IMAGE(0)  = ", a60)') F_IMAGE(0)
       write(nfout,'(" F_IMAGE(-1) = ", a60)') F_IMAGE(-1)

! ======================== KT_mod ================= 13.0D
!!       write(nfout,'(" F_CNTN_BIN_PAW = ", a60)') F_CNTN_BIN_PAW
       call repeat_filename('F_CNTN_BIN_PAW',F_CNTN_BIN_PAW_in)
! ================================================= 13.0D

    end if
  contains
    subroutine repeat_filename(tagname,filename)
      character(len=*), intent(in) :: tagname
      character(len=*),  intent(in) :: filename
      integer :: ls
      character(len=10) :: tagname2
      ls = len(trim(tagname))
      if(ls < 10) then
         tagname2 = "          "
         tagname2 = trim(tagname)
         write(nfout,'(1x,a10,a3,a)') tagname2, " = ", trim(filename)
      else
         write(nfout,*) trim(tagname)," = ", trim(filename)
      end if
    end subroutine repeat_filename
  end subroutine m_Files_check_file_names

  subroutine read_file_names_data_paramset
    logical ::   existence
    integer, parameter :: nffile = 5
    if(sw_wdir==ON)then
      inquire(file=trim(workdir)//F_file_names_data, exist = existence)
    else
      inquire(file=F_file_names_data, exist = existence)
    endif
    if(existence) then
       call open0(nffile,F_file_names_data,'FFILENAMES',old,formatted,check_file_name_off)
       rewind nffile
       read(nffile,NML = f_param_name, err = 1004, end = 1004)
1004   continue
       close(nffile,status='keep')
    end if

  end subroutine read_file_names_data_paramset

  subroutine m_Files_echo_nfinp()
     character(len=1024) :: buf
     if(printable)then
        write(nfout,'(a)') 
        write(nfout,'(a)') ' !** contents of the input parameter file : '//trim(F_INP)
        if(sw_wdir==ON)then
           open(nfinp,file=trim(workdir)//trim(F_INP),status='old')
        else
           open(nfinp,file=trim(F_INP),status='old')
        endif
        do
           read(nfinp,'(a)',end=1000,err=1000) buf
           write(nfout,'(a)') trim(buf)
        enddo
1000    continue
        write(nfout,'(a)') ' !**'
        close(nfinp)
     endif
  end subroutine m_Files_echo_nfinp

  subroutine m_Files_swap_F_INP(mode,unum,fname)
    integer, intent(in) :: mode
    integer, intent(in) :: unum
    character(len=stringlength_of_filenames),intent(in) :: fname
    integer :: iret, f_closeInputFile, f_openInputFile, ierror
    logical :: open
    if(mode==0)then
      inquire(unit = nfinp, opened = open)
      if(open) close(nfinp,status='keep')
      iret = f_closeInputFile()
      call m_Files_open_finp(1,unum,fname)
    else if (mode==1)then
      inquire(unit = unum, opened = open)
      if(open) close(unum,status='keep')
      iret = f_closeInputFile()
      call m_Files_open_finp(1,nfinp,F_INP)
    endif
  end subroutine m_Files_swap_F_INP

  subroutine m_Files_open_finp(mode,unum,fname, verbose)
    integer, intent(in) :: mode
    integer, intent(in) :: unum
    character(len=stringlength_of_filenames),intent(in) :: fname
    logical, intent(in), optional :: verbose
    logical :: open
    integer :: iret, f_closeInputFile, f_openInputFile, ierror
    logical :: verb
    integer :: check_fname
    verb = .true.
    if(present(verbose)) verb = verbose
    if(mode == 1) then
       inquire(unit = unum, opened = open)
       if(open) close(unum,status='keep')
       if(printable.and.verb) write(nfout,'(" !!  F_INP = ",a32)') fname
!!$       iret = f_openInputFile('./testinp.data')
!!$       iret = f_openInputFile(F_INP)
       if(sw_wdir == ON) then
          iret = f_openInputFile(trim(workdir)//fname)
       else
          iret = f_openInputFile(fname)
       end if
       if( iret < 0) then
          if(printable) write(nfout,'(" !!! Error in opening of inputfile: ",a32)') fname
!!$          stop ' stop at << m_Files_reopen_nfinp >>'
       else if(iret > 0) then
          if(printable) write(nfout,'(" !!! There is something wrong in the input file: ",a32)') fname
       end if
       if(iret/=0) then
          ierror = ERROR_IN_INPUTFILE_OPENING
          if(sw_wdir == ON) then
             call phase_error(ierror,nfout,unum,trim(workdir)//fname)
          else
             call phase_error(ierror,nfout,unum,fname)
          end if
       end if
    else
       iret = f_closeInputFile()
       check_fname = check_file_name_on
       if(.not.verb) check_fname = 0
       call open0(unum, fname, 'F_INP     ',    old,   formatted,check_fname)
    end if
  end subroutine m_Files_open_finp

  subroutine m_Files_reopen_nfinp(mode)
    integer, intent(in) :: mode
    logical :: open
    integer :: iret, f_closeInputFile, f_openInputFile, ierror
    call m_Files_open_finp(mode,nfinp,F_INP)
  end subroutine m_Files_reopen_nfinp

  subroutine m_Files_reopen_nfinp_mod(mode)
    integer, intent(in) :: mode
    logical :: open
    integer :: iret, f_closeInputFile, f_openInputFile, ierror
    call m_Files_open_finp(mode, nfinp_mod, F_INP_MOD, verbose=.false.)
  end subroutine m_Files_reopen_nfinp_mod

  subroutine m_Files_close_nfinp_mod()
    logical :: op
    if(mype == 0) then
       inquire(unit = nfinp_mod, opened = op)
       if(op) close(nfinp_mod)
    end if
  end subroutine m_Files_close_nfinp_mod

#ifndef _EMPIRICAL_
  subroutine m_Files_reopen_nfzaj
    logical :: open
    inquire(unit=nfzaj,opened=open)
    if(open) close(nfzaj,status='keep')

    if(F_ZAJ_partitioned) then
       if(mype == 0) then
          call open0(nfzaj, F_ZAJ, 'F_ZAJ     ',unknown, unformatted,check_file_name_on)
       else
          call open0(nfzaj, F_ZAJ, 'F_ZAJ     ',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype==0) call open0(nfzaj, F_ZAJ, 'F_ZAJ     ',unknown, unformatted,check_file_name_on)
    end if
  end subroutine m_Files_reopen_nfzaj

  subroutine m_Files_close_nfzaj()
    if(F_ZAJ_partitioned) then
       close(nfzaj)
    else
       if(mype==0) close(nfzaj)
    end if
  end subroutine m_Files_close_nfzaj

  subroutine m_Files_reopen_nfzaj_kall
    logical :: open
    inquire(unit=nfzaj_kall,opened=open)
    if(open) close(nfzaj_kall,status='keep')
    if(mype==0) call open0(nfzaj_kall, F_ZAJ_KALL, 'F_ZAJ_KALL',unknown, unformatted,check_file_name_on)
  end subroutine m_Files_reopen_nfzaj_kall

  subroutine m_Files_close_nfzaj_kall()
    if(mype==0) close(nfzaj_kall)
  end subroutine m_Files_close_nfzaj_kall

  subroutine m_Files_reopen_nfchgt()
    logical :: open
    inquire(unit=nfchgt,opened=open)
    if(open) close(nfchgt,status='keep')

    if(F_CHGT_partitioned) then
       if(mype == 0) then
          call open0(nfchgt, F_CHGT, 'F_CHGT    ',unknown, unformatted,check_file_name_on)
       else
          call open0(nfchgt, F_CHGT, 'F_CHGT    ',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype==0) call open0(nfchgt, F_CHGT, 'F_CHGT    ',unknown, unformatted,check_file_name_on)
    end if
  end subroutine m_Files_reopen_nfchgt

#endif

  subroutine m_Files_open_nfzaj()
    if(F_ZAJ_in_partitioned) then
       if(mype == 0) then
          call open0(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_on)
       else
          call open0(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype==0) call open0(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_on)
    end if
  end subroutine m_Files_open_nfzaj

  subroutine m_Files_open_nfzaj_kall()
    if(mype==0) call open0(nfzaj_kall, F_ZAJ_KALL, 'F_ZAJ_KALL  ',unknown, unformatted,check_file_name_on)
  end subroutine m_Files_open_nfzaj_kall

  subroutine m_Files_open_nfzaj_append_kall()
    if(mype==0) call open1(nfzaj_kall, F_ZAJ_KALL, 'F_ZAJ_KALL  ',unknown, unformatted,check_file_name_on)
  end subroutine m_Files_open_nfzaj_append_kall

  subroutine m_Files_open_nfzaj_with_check()
    logical :: open
    if(F_ZAJ_in_partitioned) then
       if(mype == 0) then
          inquire(unit=nfzaj,opened=open)
          if(.not.open) call open0(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_on)
       else
          inquire(unit=nfzaj,opened=open)
          if(.not.open) call open0(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype==0) then
          inquire(unit=nfzaj,opened=open)
          if(.not.open) call open0(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_on)
       end if
    end if
! ================================ modified by K. Tagami =========== 11.0
!    if(open .and.mype==0) then
    if ( mype==0 .and. open ) then
! =================================================================== 11.0
       write(nfout,'(" nfzaj is opened")')
    end if
  end subroutine m_Files_open_nfzaj_with_check

  subroutine m_Files_open_nfzaj_append()
    if(F_ZAJ_in_partitioned) then
       if(mype == 0) then
          call open1(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_on)
       else
          call open1(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype==0) call open1(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_on)
    end if
  end subroutine m_Files_open_nfzaj_append

  subroutine m_Files_open_nfchgt()
    if(F_CHGT_in_partitioned) then
       if(mype == 0) then
          call open0(nfchgt,F_CHGT_in,'F_CHGT_in ',unknown, unformatted,check_file_name_on)
       else
          call open0(nfchgt,F_CHGT_in,'F_CHGT_in ',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype==0) call open0(nfchgt,F_CHGT_in,'F_CHGT_in ',unknown, unformatted,check_file_name_on)
    end if
  end subroutine m_Files_open_nfchgt

  subroutine m_Files_open_files_initially
    call open0(nfinp, F_INP, 'F_INP     ',    old,   formatted,check_file_name_on)

    if(ekmode==ON) then
       if(mype==0) call open0(nfeng, F_ENERG,'F_ENERG   ',unknown,formatted,check_file_name_on)
    else
       if(file_existence_contfiles) then
          if(mype==0) call open1(nfdynm,F_DYNM,'F_DYNM    ',unknown,   formatted,check_file_name_on)
          if(mype==0) call open1(nfenf, F_ENF, 'F_ENF     ',unknown,   formatted,check_file_name_on)
       else
          if(mype==0) call open0(nfdynm,F_DYNM,'F_DYNM    ',unknown,   formatted,check_file_name_on)
          if(mype==0) call open0(nfenf, F_ENF, 'F_ENF     ',unknown,   formatted,check_file_name_on)
       end if
    end if
!!$    if(mype == 0) then
!!$       if(iprijobstatus >= 1) then
!!$          F_STATUS = 'jobstatus'//name_jobstep
!!$          open(nfstatus, file=F_STATUS, status='unknown',form='formatted')
!!$       end if
!!$    end if
  end subroutine m_Files_open_files_initially

  subroutine m_Files_open_nfdynm_cif_initially
    if(.not.file_existence_contfiles) call m_Files_check_file_existence()
    if(file_existence_contfiles) then
       if(mype==0.and.sw_cif_output==ON) &
           &       call open1(nfdynm_cif,F_DYNM_CIF,'F_DYNM_CIF',unknown,formatted,check_file_name_on)
    else
       if(mype==0.and.sw_cif_output==ON) &
           &       call open0(nfdynm_cif,F_DYNM_CIF,'F_DYNM_CIF',unknown,formatted,check_file_name_on)
    end if
  end subroutine m_Files_open_nfdynm_cif_initially

  subroutine m_Files_open_dftd3par()
    logical open
    inquire(unit = nfdftd3par, opened = open)
    if(.not.open .and. mype==0) &
         & call open0(nfdftd3par,F_DFTD3PAR,'F_DFTD3PAR',unknown,formatted&
         &     ,check_file_name_on)
  end subroutine m_Files_open_dftd3par

  subroutine m_Files_close_dftd3par()
    logical open
    inquire(unit = nfdftd3par, opened = open)
    if(open .and. mype == 0) close(nfdftd3par)
  end subroutine m_Files_close_dftd3par

  subroutine m_Files_open_pcont_files_ini()
    if(.not.file_existence_contfiles) call m_Files_check_file_existence()
    if(file_existence_contfiles) then 
       if(imdalg == P_CONTROL .or. imdalg == PT_CONTROL .and. mype == 0) then
          call open1(nflatconst,F_LATCONST,'F_LATCONST',unknown,   formatted,check_file_name_on)
          call open1(nfmetric, F_METRIC,   'F_METRIC  ',unknown,   formatted,check_file_name_on)
       endif
    else
       if(imdalg == P_CONTROL .or. imdalg == PT_CONTROL .and. mype == 0)then
          call open0(nflatconst,F_LATCONST,'F_LATCONST',unknown,   formatted,check_file_name_on)
          call open0(nfmetric, F_METRIC,   'F_METRIC  ',unknown,   formatted,check_file_name_on)
          write(nflatconst,*) '#iteration a b c alpha beta gamma vol'
          write(nfmetric,*) '#iteration'
          write(nfmetric,*) '#m11 m12 m13'
          write(nfmetric,*) '#m21 m22 m23'
          write(nfmetric,*) '#m31 m32 m33'
       endif
    endif
  end subroutine m_Files_open_pcont_files_ini

  subroutine m_Files_flush_nfdynm()
    if(mype==0) then
       close(nfdynm,status='keep')
       call open1(nfdynm,F_DYNM,'F_DYNM    ',unknown,   formatted,check_file_name_on)
       if(sw_cif_output==ON)then
          close(nfdynm_cif,status='keep')
          call open1(nfdynm_cif,F_DYNM_CIF,'F_DYNM_CIF',unknown,   formatted,check_file_name_on)
       endif
    end if
  end subroutine m_Files_flush_nfdynm

  subroutine m_Files_flush_pcontrol_files
    if(mype==0)then
       close(nflatconst,status='keep')
       call open1(nflatconst,F_LATCONST,'F_LATCONST',unknown,   formatted,check_file_name_on)
       close(nfmetric,status='keep')
       call open1(nfmetric,F_METRIC,  'F_METRIC  ',unknown,   formatted,check_file_name_on)
    endif
  end subroutine m_Files_flush_pcontrol_files

  subroutine m_Files_flush_nfenf()
    if(mype==0) then
       close(nfenf,status='keep')
       call open1(nfenf, F_ENF,'F_ENF     ',unknown,   formatted,check_file_name_on)
    end if
  end subroutine m_Files_flush_nfenf

  subroutine m_Files_close_files_initial0
    logical :: open
    if(ekmode==ON) then
       if(mype==0) then
          inquire(unit=nfeng, opened=open)
          if(open) close(nfeng,status='keep')
       end if
    else
       if(mype==0) then
          inquire(unit=nfdynm,opened=open)
          if(open) close(nfdynm,status='keep')
          inquire(unit=nfenf,opened=open)
          if(open) close(nfenf,status='keep')
          if(sw_cif_output==ON)then
            inquire(unit=nfdynm_cif,opened=open)
            if(open) close(nfdynm_cif,status='keep')
          endif
          if(imdalg == P_CONTROL .or. imdalg == PT_CONTROL)then
            inquire(unit=nflatconst,opened=open)
            if(open) close(nflatconst,status='keep')
            inquire(unit=nfmetric,opened=open)
            if(open) close(nfmetric,status='keep')
          endif
       end if
    end if
  end subroutine m_Files_close_files_initial0

  subroutine m_Files_open_nfeng(icond)
    integer, intent(in) :: icond
    logical :: open
    if(mype==0) then
       inquire(unit = nfeng, opened = open)
       if(open) close(nfeng)
       if(icond == FIXED_CHARGE .or. &
            & (icond==FIXED_CHARGE_CONTINUATION .and. fixed_charge_k_parallel==ALL_AT_ONCE)) then
          call open0(nfeng, F_ENERG,'F_ENERG   ',unknown,formatted,check_file_name_on)
       else if(icond==FIXED_CHARGE_CONTINUATION .and. fixed_charge_k_parallel==ONE_BY_ONE) then
          call open1(nfeng, F_ENERG,'F_ENERG   ',unknown,formatted,check_file_name_on)
       else if(icond == INITIAL) then
          call open0(nfeng, F_ENERG,'F_ENERG   ',unknown,formatted,check_file_name_on)
       else
          call open1(nfeng, F_ENERG,'F_ENERG   ',unknown,formatted,check_file_name_on)
       end if
    end if
  end subroutine m_Files_open_nfeng

  subroutine m_Files_close_nfeng()
    logical :: open
    if(mype==0) then
       inquire(unit=nfeng, opened = open)
       if(open) close(nfeng)
    end if
  end subroutine m_Files_close_nfeng

! ===
  subroutine m_Files_open_nfwfk_orb_proj(icond)
    integer, intent(in) :: icond
    logical :: open

    if (mype==0) then
       inquire(unit = nfwfk_orb_proj, opened = open)

       if (open) close(nfwfk_orb_proj)

       if (icond == FIXED_CHARGE .or. &
            & (icond==FIXED_CHARGE_CONTINUATION &
            &   .and. fixed_charge_k_parallel==ALL_AT_ONCE)) then
          call open0( nfwfk_orb_proj, F_WFK_ORB_PROJ, 'F_WFK_ORB_PROJ',&
               &      unknown, formatted, check_file_name_on )
       else if (icond==FIXED_CHARGE_CONTINUATION &
            &        .and. fixed_charge_k_parallel==ONE_BY_ONE) then
          call open1( nfwfk_orb_proj, F_WFK_ORB_PROJ, 'F_WFK_ORB_PROJ', &
               &      unknown,formatted, check_file_name_on )
       else
          call open1( nfwfk_orb_proj, F_WFK_ORB_PROJ, 'F_WFK_ORB_PROJ', &
               &      unknown,formatted, check_file_name_on )
       end if
    end if
  end subroutine m_Files_open_nfwfk_orb_proj

  subroutine m_Files_close_nfwfk_orb_proj()
    logical :: open

    if (mype==0) then
       inquire( unit=nfwfk_orb_proj, opened = open )
       if(open) close( nfwfk_orb_proj )
    end if
  end subroutine m_Files_close_nfwfk_orb_proj

  subroutine m_Files_open_nfband_spwt(icond)
    integer, intent(in) :: icond
    logical :: open

    if (mype==0) then
       inquire(unit = nfband_spectr_wght, opened = open)

       if (open) close(nfband_spectr_wght)

       if (icond == FIXED_CHARGE .or. &
            & (icond==FIXED_CHARGE_CONTINUATION &
            &   .and. fixed_charge_k_parallel==ALL_AT_ONCE)) then
          call open0( nfband_spectr_wght, F_BAND_SPECTR_WGHT, 'F_BAND_SPECTR_WGHT',&
               &      unknown, formatted, check_file_name_on )
       else if (icond==FIXED_CHARGE_CONTINUATION &
            &        .and. fixed_charge_k_parallel==ONE_BY_ONE) then
          call open1( nfband_spectr_wght, F_BAND_SPECTR_WGHT, 'F_BAND_SPECTR_WGHT ', &
               &      unknown,formatted, check_file_name_on )
       else
          call open1( nfband_spectr_wght, F_BAND_SPECTR_WGHT, 'F_BAND_SPECTR_WGHT', &
               &      unknown,formatted, check_file_name_on )
       end if
    end if
  end subroutine m_Files_open_nfband_spwt

  subroutine m_Files_close_nfband_spwt()
    logical :: open

    if (mype==0) then
       inquire( unit=nfband_spectr_wght, opened = open )
       if(open) close( nfband_spectr_wght )
    end if
  end subroutine m_Files_close_nfband_spwt

  subroutine m_Files_open_nfporb_dens_mat(mode)
    integer, intent(in) :: mode
    logical :: open

    if (mype==0) then
       inquire(unit = nfporb_dens_mat, opened = open)
       if (open) close(nfporb_dens_mat)
       if ( mode == 0 ) then               ! write
          call open0( nfporb_dens_mat, F_PORB_DENS_MAT, 'F_PORB_DENS_MAT',&
               &      unknown, unformatted, check_file_name_on )
       else                                ! read
          call open0( nfporb_dens_mat, F_PORB_DENS_MAT, 'F_PORB_DENS_MAT',&
               &      old, unformatted, check_file_name_on )
       endif
    end if
  end subroutine m_Files_open_nfporb_dens_mat

  subroutine m_Files_close_nfporb_dens_mat()
    logical :: open

    if (mype==0) then
       inquire( unit=nfporb_dens_mat, opened = open )
       if(open) close( nfporb_dens_mat )
    end if
  end subroutine m_Files_close_nfporb_dens_mat

  subroutine m_Files_open_nfporb_rot_mat(mode)
    integer, intent(in) :: mode
    logical :: open

    if (mype==0) then
       inquire(unit = nfporb_rot_mat, opened = open)
       if (open) close(nfporb_rot_mat)
       if ( mode == 0 ) then               ! write
          call open0( nfporb_rot_mat, F_PORB_ROT_MAT, 'F_PORB_ROT_MAT',&
               &      unknown, unformatted, check_file_name_on )
       else                                ! read
          call open0( nfporb_rot_mat, F_PORB_ROT_MAT, 'F_PORB_ROT_MAT',&
               &      old, unformatted, check_file_name_on )
       endif
    end if
  end subroutine m_Files_open_nfporb_rot_mat

  subroutine m_Files_close_nfporb_rot_mat()
    logical :: open

    if (mype==0) then
       inquire( unit=nfporb_rot_mat, opened = open )
       if(open) close( nfporb_rot_mat )
    end if
  end subroutine m_Files_close_nfporb_rot_mat

! ====
  logical function m_Files_nfinp_is_opened()
    logical :: op
    integer :: ierr
    op = .false.
    if(mype == 0) then
       inquire(unit = nfinp, opened = op)
    end if
    call mpi_bcast(op,1,mpi_logical,0,mpi_comm_group,ierr)
    m_Files_nfinp_is_opened = op
  end function m_Files_nfinp_is_opened

  subroutine m_Files_close_nfinp()
    logical :: op
    if(mype == 0) then
       inquire(unit = nfinp, opened = op)
       if(op) close(nfinp)
    end if
  end subroutine m_Files_close_nfinp

  subroutine m_Files_close_nfcntn()
    logical :: op
    if(mype == 0) then
       inquire(unit = nfcntn, opened = op)
       if(op) close(nfcntn)
    end if
  end subroutine m_Files_close_nfcntn

  subroutine m_Files_open_nfdos(iter,reacid)
    integer,intent(in),optional :: iter
    integer, intent(in), optional :: reacid
    character(len=256) :: striter
    character(len=105) :: retstr,retstr0
    logical :: op
    if(mype==0)then
       inquire(unit = nfdos, opened = op)
       if(op) close(nfdos)
       if(.not.present(iter))then
           call open0(nfdos,F_DOS,'F_DOS     ',unknown,formatted,check_file_name_on)
       else
           write(striter,*) iter
           call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_DOS,retstr)
           if(present(reacid))then
              write(striter,*) reacid
              call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
              retstr = retstr0
           endif
           call open0(nfdos,retstr,'F_DOS     ',unknown,formatted,check_file_name_on)
       endif
    endif
  end subroutine m_Files_open_nfdos

  subroutine m_Files_open_nfegrid()
    if(mype==0) call open0(nfegrid,F_EGRID,'F_EGRID   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfegrid

  subroutine m_Files_open_nfldos()
    if(mype==0) then
       if(icond==FIXED_CHARGE_CONTINUATION .and. ekmode==ON)then
         call open1(nfldos,F_LDOS,'F_LDOS    ',unknown,formatted,check_file_name_on)
       else
         call open0(nfldos,F_LDOS,'F_LDOS    ',unknown,formatted,check_file_name_on)
       endif
    endif
  end subroutine m_Files_open_nfldos

  subroutine m_Files_close_nfldos()
    logical :: open
    if(mype==0) then
       inquire(unit=nfldos,opened=open)
       if(open) close(nfldos,status='keep')
    end if
  end subroutine m_Files_close_nfldos
    

!!$  subroutine m_Files_close_nfdos()
!!$    logical :: open
!!$    if(mype==0) then
!!$       inquire(unit=nfdos,opened=open)
!!$       if(open) close(nfdos,status='keep')
!!$    end if
!!$  end subroutine m_Files_close_nfdos

  subroutine m_Files_skiptoend(nf)
    integer, intent(in) :: nf
    if(mype == 0) then
1      continue
       read(nf,*, err=2, end=2)
       goto 1
2      continue
       backspace nf
    end if
  end subroutine m_Files_skiptoend

  subroutine m_Files_open_files_initially_p
    call open0(nfinp, F_INP, 'F_INP     ',    old,   formatted,check_file_name_on)
    call open0(nfprm, F_PRM, 'F_PRM     ',unknown,   formatted,check_file_name_on)
  end subroutine m_Files_open_files_initially_p


  subroutine m_Files_close_all_paramset
    close(nfinp,status='keep')
    close(nfprm,status='keep')
  end subroutine m_Files_close_all_paramset

  subroutine open0(nfile,filename,tagname,status, form, write_or_no,fix_endianness)
    integer, intent(in) :: nfile
    character(len=*), intent(in) :: filename
    character(len=*), intent(in) :: tagname
    integer, intent(in) :: status, form, write_or_no
    logical, intent(in), optional :: fix_endianness
    logical             :: open
    character(len=5) ::    torf
    character(len=14) ::   filestatus
    integer ::             ls,ierror
    logical :: existence
    logical :: endi

    character(len=50) :: wd
    endi = .false.
    if(present(fix_endianness)) endi = fix_endianness

    inquire(unit = nfile, opened = open)

    wd = workdir
!!$    write(6,'(" workdir = ",a)') workdir
    ls = min(max(index(filename,' ')-1,1),stringlength_of_filenames)

    if(.not.open) then
       inquire(file=trim(wd)//filename(1:ls), exist=existence)
       if(status==old .and. .not.existence) then
          ierror = FILE_NOT_EXIST
#ifdef DEBUG_ERRORS
          call phase_error(ierror,nfout,nfile,trim(wd)//filename(1:ls), &
               & __LINE__,__FILE__)
#else
          call phase_error(ierror,nfout,nfile,trim(wd)//filename(1:ls))
#endif
       else
          if(status==old .and. form==formatted) then
             open(nfile,file=trim(wd)//filename(1:ls), status='old', form='formatted')
          else if(status==old .and. form==unformatted) then
#ifdef FIX_ENDIANNESS
          if (endi) then
             open(nfile,file=trim(wd)//filename(1:ls), status='old', form='unformatted', &
          &  convert='little_endian')
          else
             open(nfile,file=trim(wd)//filename(1:ls), status='old', form='unformatted')
          endif
#else
             open(nfile,file=trim(wd)//filename(1:ls), status='old', form='unformatted')
#endif
          else if(status==unknown .and. form==formatted) then
             open(nfile,file=trim(wd)//filename(1:ls), status='unknown', form='formatted')
          else if(status==unknown .and. form==unformatted) then
#ifdef FIX_ENDIANNESS
          if (endi) then
             open(nfile,file=trim(wd)//filename(1:ls), status='unknown', form='unformatted', &
          &  convert='little_endian')
          else
             open(nfile,file=trim(wd)//filename(1:ls), status='unknown', form='unformatted')
          endif
#else
             open(nfile,file=trim(wd)//filename(1:ls), status='unknown', form='unformatted')
#endif
          endif
       end if
       torf = 'false'
       filestatus = 'newly opened'
    else
       torf = 'true '
       filestatus = 'already opened'
    end if

!!$    ls = len(trim(wd)//trim(filename))
    if(write_or_no == check_file_name_on .and. printable) then
       if(len(tagname) <= 10) then
          write(nfout,'(1x,a10,a3,a,a3,a)') tagname, " = ", trim(filename(1:ls))," , ",filestatus
       else
          write(nfout,'(1x,a,a3,a,a3,a)') trim(tagname), " = ", trim(filename(1:ls))," , ",filestatus
       end if
    endif
  end subroutine open0

  subroutine open1(nfile,filename,tagname,status, form, write_or_no)
    integer, intent(in) :: nfile
    character(len=*), intent(in) :: filename
    character(len=*), intent(in) :: tagname
    integer, intent(in) :: status, form, write_or_no
    logical             :: open
    character(len=5) ::    torf
    character(len=14) ::   filestatus
    integer ::             ls

    character(len=50) :: wd

    inquire(unit = nfile, opened = open)

    wd = workdir

!!$    ls = index(filename,' ')-1
!!$    ls = min(max(ls,1),stringlength_of_filenames)
    ls = min(max(index(filename,' ')-1,1),stringlength_of_filenames)

    if(.not.open) then
       if(status==old .and. form==formatted) then
          open(nfile,file=trim(wd)//filename(1:ls), status='old', form='formatted', position='append')
       else if(status==old .and. form==unformatted) then
          open(nfile,file=trim(wd)//filename(1:ls), status='old', form='unformatted', position='append')
       else if(status==unknown .and. form==formatted) then
          open(nfile,file=trim(wd)//filename(1:ls), status='unknown', form='formatted', position='append')
       else if(status==unknown .and. form==unformatted) then
          open(nfile,file=trim(wd)//filename(1:ls), status='unknown', form='unformatted', position='append')
       endif
       torf = 'false'
       filestatus = 'newly opened'
    else
       torf = 'true '
       filestatus = 'already opened'
    end if

!!$    ls = len(trim(wd)//trim(filename))
    if(write_or_no == check_file_name_on .and. printable) then
       if(len(tagname)<=10) then
          write(nfout,'(1x,a10,a3,a,a3,a)') tagname," = ",trim(filename(1:ls))," , ",filestatus
       else
          write(nfout,'(1x,a,a3,a,a3,a)') trim(tagname)," = ",trim(filename(1:ls))," , ",filestatus
       end if
    endif
  end subroutine open1

  subroutine m_Files_close_and_clear_nfstop()
    logical :: open
    inquire(unit = nfstop, opened = open)
    if(open) then
       if(sw_wdir==ON) then
          open(nfstop, file=trim(workdir)//F_STOP, status='replace', form='formatted')
       else
          open(nfstop, file=F_STOP, status='replace', form='formatted')
       end if
       close(nfstop, status='keep')
    endif
  end subroutine m_Files_close_and_clear_nfstop

  subroutine m_Files_close_all()
    integer :: i
    logical :: open
    do i = 1, number_of_all_files
       if(n_file(i) == 6) cycle
       inquire(unit = n_file(i), opened = open)
       if(open) then
          close(n_file(i),status='keep')
          if(printable) write(nfout,*) ' closed filenumber = ', n_file(i)
	  if (multiple_replica_mode == OFF) then
            if (n_file(i) == nfstop) then
!!$               open(n_file(i), file=F_STOP, status='replace', form='formatted')
               if(sw_wdir==ON) then
                  open(n_file(i), file=trim(workdir)//F_STOP, status='replace', form='formatted')
               else
                  open(n_file(i), file=F_STOP, status='replace', form='formatted')
               end if
               close(n_file(i), status='keep')
            end if
          end if
       else
	  if (multiple_replica_mode == OFF) then
            if (n_file(i) == nfstop .and. mype == 0) then
               if(sw_wdir==ON) then
                  open(n_file(i), file=trim(workdir)//F_STOP, status='replace', form='formatted')
               else
                  open(n_file(i), file=F_STOP, status='replace', form='formatted')
               end if
               close(n_file(i), status='keep')
            end if
          end if
       endif
    enddo

!!    if(final_c)then
!!$    if(.not.conf_para .or. (conf_para .and. mype_conf==0))then
!!    if(mype == 0) then
!!       close(6, status='keep')
!!    else if(ipriparadeb == 0) then
!!       close(6, status='delete')
!!    else
!!       close(6, status='keep')
!!    end if

!!$    endif
!!    endif

  end subroutine m_Files_close_all

  subroutine m_Files_close_logfile()
    if(mype == 0) then
       close(nfout, status='keep')
    else if(ipriparadeb == 0) then
       close(nfout, status='delete')
    else
       close(nfout, status='keep')
    end if
  end subroutine m_Files_close_logfile

  subroutine open_newps_files(ntyp,ierror)
    integer, intent(in)                  :: ntyp
    integer, intent(out)                 :: ierror

    integer :: it, nfp
    logical :: existence

    ierror = 0
    do it = 1, ntyp
       nfp = nfpot(it)
       if(printable) write(nfout,*) ' F_POT(it) = ', F_POT(it)
       if(sw_wdir==ON) then
          inquire(file=workdir//trim(F_POT(it)), exist=existence)
       else
          inquire(file=trim(F_POT(it)), exist=existence)
       end if
       if(.not.existence) then
          ierror = F_POT_FILE_NOT_EXIST
#ifdef DEBUG_ERRORS
          call phase_error(ierror,nfout,nfp,F_POT(it),__LINE__, __FILE__)
#else
          call phase_error(ierror,nfout,nfp,F_POT(it))
#endif
!!$          if(printable) write(nfout,'(" file F_POT(",i3,") does not exist")') it
!!$          if(printable) write(nfout,'(a100)') F_POT(it)
          goto 1001
       end if
       call open0(nfp,F_POT(it),'F_POT     ',OLD,formatted,check_file_name_on)
    enddo
1001 return
  end subroutine open_newps_files

#ifndef _EMPIRICAL_
  subroutine m_Files_open_ps_files(ivan,iatomn,ntyp,ierror)
    integer, intent(in)                  :: ntyp
    integer, intent(in), dimension(ntyp) :: ivan
    real(kind=DP), intent(in), dimension(ntyp) :: iatomn
    integer, intent(out)                 :: ierror

    integer     :: nfpp, nfp, it, n_non_vanderbilt, n_pcc, itpcc, check_file_name
    real(kind=DP) :: ival
    real(kind=DP), dimension(2)   :: alp, cc
    logical :: existence

!!$    if(ppprinted) then
!!$       check_file_name = check_file_name_off
!!$    else
!!$       check_file_name = check_file_name_on
!!$    end if
    checK_file_name = check_file_name_off

    ierror = 0
    if(mype /= 0) return
    n_non_Vanderbilt = 0
    n_pcc            = 0
    nfpp             = 0
    do it = 1, ntyp
       if(ivan(it) /= OLD) then
          nfpp = nfpp + 1
          nfp = nfpot(nfpp)
          if(printable .and. .not.ppprinted ) write(nfout,*) ' F_POT(nfpp) = ', trim(F_POT(nfpp))
          if(sw_wdir==ON)then
             inquire(file=trim(workdir)//F_POT(nfpp), exist=existence)
          else
             inquire(file=F_POT(nfpp), exist=existence)
          endif
          if(.not.existence) then
             ierror = F_POT_FILE_NOT_EXIST
#ifdef DEBUG_ERRORS
             call phase_error(ierror,nfout,nfp,F_POT(nfpp),__LINE__, __FILE__)
#else
             call phase_error(ierror,nfout,nfp,(F_POT(nfpp)))
#endif
!!$             if(printable) write(nfout,'(" file F_POT(",i3,") does not exist")') nfpp
!!$             if(printable) write(nfout,'(a100)') F_POT(nfpp)
             goto 1001
          end if
          call open0(nfp,F_POT(nfpp),'F_POT     ',OLD,formatted,check_file_name)
       else if(ivan(it) == OLD) then
          n_non_Vanderbilt = n_non_Vanderbilt + 1
          call psbhs0(nfout,nint(iatomn(it)),ival,itpcc,alp,cc)  ! -(b_PseudoPotential)
          if(itpcc == ON) n_pcc = n_pcc + 1
       endif
    enddo
    if(n_non_Vanderbilt >= 1 ) then
       call open0(nfpkb,F_PKB,'F_PKB     ',OLD,formatted,check_file_name)
       call open0(nfpd, F_PD, 'F_PD      ',OLD,formatted,check_file_name)
       rewind nfpkb
       rewind nfpd
       if(n_pcc >= 1) then
          call open0(nfppc,F_PPC,'F_PPC     ',OLD,formatted,check_file_name)
          rewind nfppc
       endif
    endif
1001 return
  end subroutine m_Files_open_ps_files

  subroutine m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
    integer, intent(in)                  :: ntyp,it
    integer, intent(in), dimension(ntyp) :: ivan
    real(kind=DP), intent(in), dimension(ntyp) :: iatomn
    integer, intent(out)                 :: ierror

    integer     ::  nfp,  n_non_vanderbilt, n_pcc, itpcc, check_file_name
    integer, save :: nfpp=0
    real(kind=DP) :: ival
    real(kind=DP), dimension(2)   :: alp, cc
    logical :: existence

!!$    if(ppprinted) then
!!$       check_file_name = check_file_name_off
!!$    else
!!$       check_file_name = check_file_name_on
!!$    end if
    checK_file_name = check_file_name_off

    ierror = 0
    if(mype /= 0) return
    n_non_Vanderbilt = 0
    n_pcc            = 0
    if(ivan(it) /= OLD) then
       nfpp = nfpp + 1
       nfp = nfpot(nfpp)
       if(printable .and. .not.ppprinted ) write(nfout,*) ' F_POT(nfpp) = ', trim(F_POT(nfpp))
       if(sw_wdir==ON)then
          inquire(file=trim(workdir)//F_POT(nfpp), exist=existence)
       else
          inquire(file=F_POT(nfpp), exist=existence)
       endif
       if(.not.existence) then
          ierror = F_POT_FILE_NOT_EXIST
#ifdef DEBUG_ERRORS
          call phase_error(ierror,nfout,nfp,F_POT(nfpp),__LINE__, __FILE__)
#else
          call phase_error(ierror,nfout,nfp,(F_POT(nfpp)))
#endif
!!$             if(printable) write(nfout,'(" file F_POT(",i3,") does not exist")') nfpp
!!$             if(printable) write(nfout,'(a100)') F_POT(nfpp)
          goto 1001
       end if
       call open0(nfp,F_POT(nfpp),'F_POT     ',OLD,formatted,check_file_name)
    else if(ivan(it) == OLD) then
       n_non_Vanderbilt = n_non_Vanderbilt + 1
       call psbhs0(nfout,nint(iatomn(it)),ival,itpcc,alp,cc)  ! -(b_PseudoPotential)
       if(itpcc == ON) n_pcc = n_pcc + 1
    endif

    if(n_non_Vanderbilt >= 1 ) then
       call open0(nfpkb,F_PKB,'F_PKB     ',OLD,formatted,check_file_name)
       call open0(nfpd, F_PD, 'F_PD      ',OLD,formatted,check_file_name)
       rewind nfpkb
       rewind nfpd
       if(n_pcc >= 1) then
          call open0(nfppc,F_PPC,'F_PPC     ',OLD,formatted,check_file_name)
          rewind nfppc
       endif
    endif

    if(it==ntyp) nfpp = 0
1001 return
  end subroutine m_Files_open_ps_file

  subroutine m_Files_close_ps_files
    integer :: i
    logical :: open
    if(mype /= 0) return
    do i = 1, MAXNSP
       inquire(unit = nfpot(i), opened = open)
       if(open) close(nfpot(i),status='keep')
    enddo
    inquire(unit = nfpkb, opened = open)
    if(open) close(nfpkb,status='keep')
    inquire(unit = nfpd,  opened = open)
    if(open) close(nfpd, status='keep')
    inquire(unit = nfppc, opened = open)
    if(open) close(nfppc,status='keep')
  end subroutine m_Files_close_ps_files

  subroutine m_Files_close_ps_file(it)
    integer, intent(in) :: it
    logical :: open
    inquire(unit = nfpot(it), opened = open)
    if(open) close(nfpot(it),status='keep')
    inquire(unit = nfpkb, opened = open)
    if(open) close(nfpkb,status='keep')
    inquire(unit = nfpd,  opened = open)
    if(open) close(nfpd, status='keep')
    inquire(unit = nfppc, opened = open)
    if(open) close(nfppc,status='keep')
  end subroutine m_Files_close_ps_file
#endif


  subroutine insert_str_before_dot(pref,origstr,retstr)
    character(len=*),intent(in) :: pref
    character(len=*),intent(in) :: origstr
    character(len=105),intent(out) :: retstr
    integer :: lenstr, ip, i
    lenstr = len_trim(origstr)
    ip = lenstr+1
    findingdot: do i = lenstr, 1, -1
      if(origstr(i:i) == '/') then
         exit findingdot
      else if(origstr(i:i) == '.') then
         ip = i-1
         exit findingdot
      end if
    end do findingdot
         
    if(ip >= 1 .and. ip <= lenstr) then
       if(ip+1 <= lenstr) then
          retstr = origstr(1:ip)//trim(adjustl(pref))//origstr(ip+1:lenstr)
       else
          retstr = origstr(1:ip)//trim(adjustl(pref))
       end if
    else
       retstr = origstr(1:lenstr)//trim(adjustl(pref))
    end if
  end subroutine insert_str_before_dot

  subroutine m_Files_open_nfchr( nspin, ispin, iter, reacid, add_core )
    integer, intent(in) :: nspin, ispin
    integer, intent(in), optional :: iter
    integer, intent(in), optional :: reacid
    logical, intent(in), optional :: add_core

    integer :: lenstr, ip, i
    character(len=105) :: F_CHRUD
    character(len=256) :: striter
    character(len=105) :: retstr,retstr0
    logical :: open
    logical :: flag_add_core

    if ( present(add_core) ) then
       flag_add_core = add_core
    else
       flag_add_core = .false.
    endif

    if(mype == 0) then
       if(nspin == 1) then
          inquire(unit=nfchr,opened=open)
          if(open) close(nfchr,status='keep')

          if(.not.present(iter)) then
             if ( .not. flag_add_core ) then
                call open0(nfchr,F_CHR,'F_CHR     ',unknown,formatted,check_file_name_on)
             else
                call insert_str_before_dot( '_ae', F_CHR, retstr )
                call open0(nfchr,retstr,'F_CHR     ',unknown,formatted,check_file_name_on)
             endif
          else
             write(striter,*) iter
             call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHR,retstr)
             if(present(reacid))then
                write(striter,*) reacid
                call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
                retstr = retstr0
             endif
             call open0(nfchr,retstr,'F_CHR     ',unknown,formatted,check_file_name_on)
          endif

       else if(nspin == 2) then
          lenstr = len_trim(F_CHR)
          ip = lenstr+1
          findingdot: do i = lenstr, 1, -1
             if(F_CHR(i:i) == '/') then
                exit findingdot
             else if(F_CHR(i:i) == '.') then
                ip = i
                exit findingdot
             end if
          end do findingdot
             
          if(ispin == 1) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRUD = F_CHR(1:ip)//'up.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRUD = F_CHR(1:ip)//'up'
                end if
             else
                F_CHRUD = F_CHR(1:lenstr)//'.up'
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRUD (up) ---'
                write(nfout,*) F_CHRUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')

             if(.not.present(iter)) then 
                if ( .not. flag_add_core ) then
                   call open0( nfchr, F_CHRUD, 'F_CHR.UP  ', unknown, &
                        &      formatted, check_file_name_on )
                else
                   call insert_str_before_dot( '_ae', F_CHRUD, retstr )
                   call open0( nfchr,retstr, 'F_CHR.UP  ', unknown, &
                        &      formatted,check_file_name_on )
                endif

             else
                write(striter,*) iter
                call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRUD,retstr)
                call open0(nfchr,retstr,'F_CHR.UP  ',unknown,formatted,check_file_name_on)
             endif
          else if(ispin == 2) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRUD = F_CHR(1:ip)//'down.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRUD = F_CHR(1:ip)//'down'
                end if
             else
                F_CHRUD = F_CHR(1:lenstr)//'.down'
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRUD (down) ---'
                write(nfout,*) F_CHRUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')

             if(.not.present(iter)) then
               if ( .not. flag_add_core ) then
                   call open0( nfchr, F_CHRUD, 'F_CHR.DOWN', unknown, &
                        &      formatted, check_file_name_on )
                else
                   call insert_str_before_dot( '_ae', F_CHRUD, retstr )
                   call open0( nfchr, retstr, 'F_CHR.DOWN', unknown, &
                        &      formatted, check_file_name_on )
                endif

             else
                write(striter,*) iter
                call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRUD,retstr)
                call open0(nfchr,retstr,'F_CHR.DOWN',unknown,formatted,check_file_name_on)
             endif
          end if

! ======= KT_add ========== 2014/06/07
          if (ispin == -1) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRUD = F_CHR(1:ip)//'tot.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRUD = F_CHR(1:ip)//'tot'
                end if
             else
                F_CHRUD = F_CHR(1:lenstr)//'.tot'
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRUD (tot) ---'
                write(nfout,*) F_CHRUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')

             if(.not.present(iter)) then 
                if ( .not. flag_add_core ) then
                   call open0( nfchr, F_CHRUD, 'F_CHR.TOT ', &
                        &      unknown, formatted, check_file_name_on )
                else
                   call insert_str_before_dot( '_ae', F_CHRUD, retstr )
                   call open0( nfchr, retstr, 'F_CHR.TOT ',unknown, &
                        &      formatted, check_file_name_on )
                endif
             else
                write(striter,*) iter
                call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRUD,retstr)
                call open0(nfchr,retstr,'F_CHR.TOT ',unknown,formatted,check_file_name_on)
             endif
          else if(ispin == -2) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRUD = F_CHR(1:ip)//'mag.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRUD = F_CHR(1:ip)//'mag'
                end if
             else
                F_CHRUD = F_CHR(1:lenstr)//'.mag'
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRUD (mag) ---'
                write(nfout,*) F_CHRUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')

             if(.not.present(iter)) then
                call open0(nfchr,F_CHRUD,'F_CHR.MAG ',unknown,formatted,check_file_name_on)
             else
                write(striter,*) iter
                call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRUD,retstr)
                call open0(nfchr,retstr,'F_CHR.MAG ',unknown,formatted,check_file_name_on)
             endif
          endif
! ========================= 2014/06/07

       end if
    end if
  end subroutine m_Files_open_nfchr

!====================================== added by K. Tagami =========== 11.0
  subroutine m_Files_open_nfchr_noncl( iloop, iter, add_core )
    integer, intent(in) :: iloop
    integer, intent(in), optional :: iter
    logical, intent(in), optional :: add_core

    integer :: lenstr, ip, i
    character(len=105) :: F_CHRMAG
    character(len=105) :: retstr,retstr0
    logical :: open
    logical :: flag_add_core

    if ( present(add_core) ) then
       flag_add_core = add_core
    else
       flag_add_core = .false.
    endif

    if(mype == 0) then

       lenstr = len_trim(F_CHR)
       ip = lenstr+1
       findingdot: do i = lenstr, 1, -1
         if(F_CHR(i:i) == '/') then
            exit findingdot
         else if(F_CHR(i:i) == '.') then
            ip = i
            exit findingdot
         end if
       end do findingdot
             
       select case (iloop)
       case(1)
           if(ip >= 1 .and. ip <= lenstr) then
              if(ip+1 <= lenstr) then
                 F_CHRMAG = F_CHR(1:ip)//'tot.'//F_CHR(ip+1:lenstr)
              else
                 F_CHRMAG = F_CHR(1:ip)//'tot'
              end if
           else
              F_CHRMAG = F_CHR(1:lenstr)//'.tot'
           end if
           if(printable) then
              write(nfout,*) ' --- F_CHRMAG (tot) ---'
              write(nfout,*) F_CHRMAG
           end if
           inquire(unit=nfchr,opened=open)
           if(open) close(nfchr,status='keep')

           if ( .not. flag_add_core ) then
              call open0( nfchr, F_CHRMAG, 'F_CHR.TOT ',unknown, &
                   &           formatted, check_file_name_on )
           else
              call insert_str_before_dot( '_ae', F_CHRMAG, retstr )
              call open0( nfchr, retstr, 'F_CHR.TOT ',unknown, &
                   &      formatted, check_file_name_on )
           endif

       case(2)
           if(ip >= 1 .and. ip <= lenstr) then
              if(ip+1 <= lenstr) then
                 F_CHRMAG = F_CHR(1:ip)//'mx.'//F_CHR(ip+1:lenstr)
              else
                 F_CHRMAG = F_CHR(1:ip)//'mx'
              end if
           else
              F_CHRMAG = F_CHR(1:lenstr)//'.mx'
           end if
           if(printable) then
              write(nfout,*) ' --- F_CHRMAG (mx) ---'
              write(nfout,*) F_CHRMAG
           end if
           inquire(unit=nfchr,opened=open)
           if(open) close(nfchr,status='keep')
           call open0( nfchr, F_CHRMAG, 'F_CHR.MX  ',unknown, &
                &           formatted, check_file_name_on )

       case(3)
           if(ip >= 1 .and. ip <= lenstr) then
              if(ip+1 <= lenstr) then
                 F_CHRMAG = F_CHR(1:ip)//'my.'//F_CHR(ip+1:lenstr)
              else
                 F_CHRMAG = F_CHR(1:ip)//'my'
              end if
           else
              F_CHRMAG = F_CHR(1:lenstr)//'.my'
           end if
           if(printable) then
              write(nfout,*) ' --- F_CHRMAG (my) ---'
              write(nfout,*) F_CHRMAG
           end if
           inquire(unit=nfchr,opened=open)
           if(open) close(nfchr,status='keep')
           call open0( nfchr, F_CHRMAG, 'F_CHR.MY  ',unknown, &
                &           formatted, check_file_name_on )

       case(4)
           if(ip >= 1 .and. ip <= lenstr) then
              if(ip+1 <= lenstr) then
                 F_CHRMAG = F_CHR(1:ip)//'mz.'//F_CHR(ip+1:lenstr)
              else
                 F_CHRMAG = F_CHR(1:ip)//'mz'
              end if
           else
              F_CHRMAG = F_CHR(1:lenstr)//'.mz'
           end if
           if(printable) then
              write(nfout,*) ' --- F_CHRMAG (mz) ---'
              write(nfout,*) F_CHRMAG
           end if
           inquire(unit=nfchr,opened=open)
           if(open) close(nfchr,status='keep')
           call open0( nfchr, F_CHRMAG, 'F_CHR.MZ  ',unknown, &
                &           formatted, check_file_name_on )
       end select
    end if
  end subroutine m_Files_open_nfchr_noncl
! ================================================================== 11.0

  subroutine m_Files_open_nfchr_pc(nspin,ispin,iw,iter,reacid)
    integer, intent(in) :: nspin, ispin, iw
    integer, intent(in),optional :: iter
    integer, intent(in),optional :: reacid
    integer :: lenstr, ip, i
    character(len=105) :: F_CHRpcUD, F_CHRpc
    character(len=256) :: striter
    character(len=105) :: retstr,retstr0
    integer, parameter :: len_nnumber = 4
    character(len=len_nnumber) :: nnumber
    logical :: open

    if(mype == 0) then
       write(nnumber,'(i4)') iw
       do i = 1, len_nnumber
          if(nnumber(i:i) == ' ') nnumber(i:i) = '0'
       end do

       lenstr = len_trim(F_CHR)
       ip = lenstr+1
       findingdot: do i = lenstr, 1, -1
          if(F_CHR(i:i) == '/') then
             exit findingdot
          else if(F_CHR(i:i) == '.') then
             ip = i
             exit findingdot
          end if
       end do findingdot

       if(nspin == 1) then
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_CHRpc = F_CHR(1:ip)//nnumber//'.'//F_CHR(ip+1:lenstr)
             else
                F_CHRpc = F_CHR(1:ip)//nnumber
             end if
          else
             F_CHRpc = F_CHR(1:lenstr)//nnumber
          end if
          inquire(unit=nfchr,opened=open)
          if(open) close(nfchr,status='keep')
          if(.not.present(iter)) then
             call open0(nfchr,F_CHRpc,'F_CHRpc   ',unknown,formatted,check_file_name_on)
          else
             write(striter,*) iter
             call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRpc,retstr)
             if(present(reacid))then
                write(striter,*) reacid
                call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
                retstr = retstr0
             endif
             call open0(nfchr,retstr,'F_CHRpc   ',unknown,formatted,check_file_name_on)
          endif

       else if(nspin == 2) then
          if(ispin == 1) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcUD = F_CHR(1:ip)//'up.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcUD = F_CHR(1:ip)//'up.'//nnumber
                end if
             else
                F_CHRpcUD = F_CHR(1:lenstr)//'.up.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcUD (up) ---'
                write(nfout,*) F_CHRpcUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             if(.not.present(iter)) then
                call open0(nfchr,F_CHRpcUD,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             else
                write(striter,*) iter
                call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRpcUD,retstr)
                if(present(reacid))then
                  write(striter,*) reacid
                  call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
                  retstr = retstr0
                endif
                call open0(nfchr,retstr,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             endif
          else if(ispin == 2) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcUD = F_CHR(1:ip)//'down.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcUD = F_CHR(1:ip)//'down.'//nnumber
                end if
             else
                F_CHRpcUD = F_CHR(1:lenstr)//'.down.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcUD (down) ---'
                write(nfout,*) F_CHRpcUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             if(.not.present(iter)) then
                 call open0(nfchr,F_CHRpcUD,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             else
                 write(striter,*) iter
                 call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRpcUD,retstr)
                 if(present(reacid))then
                   write(striter,*) reacid
                   call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
                   retstr = retstr0
                 endif
                 call open0(nfchr,retstr,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             endif
          end if
! =========== KT_add ======== 2014/06/07
          if(ispin == -1) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcUD = F_CHR(1:ip)//'tot.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcUD = F_CHR(1:ip)//'tot.'//nnumber
                end if
             else
                F_CHRpcUD = F_CHR(1:lenstr)//'.tot.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcUD (tot) ---'
                write(nfout,*) F_CHRpcUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             if(.not.present(iter)) then
                call open0(nfchr,F_CHRpcUD,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             else
                write(striter,*) iter
                call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRpcUD,retstr)
                if(present(reacid))then
                  write(striter,*) reacid
                  call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
                  retstr = retstr0
                endif
                call open0(nfchr,retstr,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             endif
          else if(ispin == -2) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcUD = F_CHR(1:ip)//'mag.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcUD = F_CHR(1:ip)//'mag.'//nnumber
                end if
             else
                F_CHRpcUD = F_CHR(1:lenstr)//'.mag.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcUD (mag) ---'
                write(nfout,*) F_CHRpcUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             if(.not.present(iter)) then
                 call open0(nfchr,F_CHRpcUD,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             else
                 write(striter,*) iter
                 call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRpcUD,retstr)
                 if(present(reacid))then
                   write(striter,*) reacid
                   call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
                   retstr = retstr0
                 endif
                 call open0(nfchr,retstr,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             endif
          end if
! =========================== 2014/06/07
       end if
    end if
  end subroutine m_Files_open_nfchr_pc

! ================================ added by K. Tagami ================== 11.0
  subroutine m_Files_open_nfchr_pc_noncl( iloop, iw, iter )
    integer, intent(in) :: iloop, iw
    integer, intent(in), optional :: iter

    integer :: lenstr, ip, i
    character(len=105) :: F_CHRpcMAG, F_CHRpc
    integer, parameter :: len_nnumber = 4
    character(len=len_nnumber) :: nnumber
    logical :: open

    if(mype == 0) then
       write(nnumber,'(i4)') iw
       do i = 1, len_nnumber
          if(nnumber(i:i) == ' ') nnumber(i:i) = '0'
       end do

       lenstr = len_trim(F_CHR)
       ip = lenstr+1
       findingdot: do i = lenstr, 1, -1
          if(F_CHR(i:i) == '/') then
             exit findingdot
          else if(F_CHR(i:i) == '.') then
             ip = i
             exit findingdot
          end if
       end do findingdot

       select case (iloop)
       case(1)
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcMAG = F_CHR(1:ip)//'tot.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcMAG = F_CHR(1:ip)//'tot.'//nnumber
                end if
             else
                F_CHRpcMAG = F_CHR(1:lenstr)//'.tot.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcMAG (tot) ---'
                write(nfout,*) F_CHRpcMAG
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             call open0( nfchr, F_CHRpcMAG, 'F_CHRpcMAG ', unknown, &
	&                formatted, check_file_name_on )

       case(2)
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcMAG = F_CHR(1:ip)//'mx.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcMAG = F_CHR(1:ip)//'mx.'//nnumber
                end if
             else
                F_CHRpcMAG = F_CHR(1:lenstr)//'.mx.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcMAG (mx) ---'
                write(nfout,*) F_CHRpcMAG
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             call open0( nfchr, F_CHRpcMAG, 'F_CHRpcMAGx ', unknown, &
	&                formatted, check_file_name_on )

       case(3)
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcMAG = F_CHR(1:ip)//'my.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcMAG = F_CHR(1:ip)//'my.'//nnumber
                end if
             else
                F_CHRpcMAG = F_CHR(1:lenstr)//'.my.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcMAG (my) ---'
                write(nfout,*) F_CHRpcMAG
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             call open0( nfchr, F_CHRpcMAG, 'F_CHRpcMAGy ', unknown, &
	&                formatted, check_file_name_on )

       case(4)
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcMAG = F_CHR(1:ip)//'mz.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcMAG = F_CHR(1:ip)//'mz.'//nnumber
                end if
             else
                F_CHRpcMAG = F_CHR(1:lenstr)//'.mz.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcMAG (tot) ---'
                write(nfout,*) F_CHRpcMAG
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             call open0( nfchr, F_CHRpcMAG, 'F_CHRpcMAGz ', unknown, &
	&                formatted, check_file_name_on )
       end select

    end if
  end subroutine m_Files_open_nfchr_pc_noncl
! ===================================================================== 11.0

  subroutine m_Files_open_nfwfk(nspin,ik,ib)
    integer, intent(in) :: nspin, ik, ib
    integer :: lenstr, ip, i, ispin, nk
    character(len=105) :: F_WFnUD, F_WFn
    integer, parameter :: len_nnumber = 4
    integer, parameter :: len_mnumber = 5
    character(len=len_nnumber) :: nnumber
    character(len=len_mnumber) :: mnumber
    logical :: open

    ispin = mod(ik-1,nspin)+1
    nk = (ik-1)/nspin+1

    if(mype == 0) then
       write(nnumber,'(i4)') nk
       do i = 1, len_nnumber
          if(nnumber(i:i) == ' ') nnumber(i:i) = '0'
       end do
       write(mnumber,'(i5)') ib
       do i = 1, len_mnumber
          if(mnumber(i:i) == ' ') mnumber(i:i) = '0'
       end do

       lenstr = len_trim(F_WFk)
       ip = lenstr+1
       findingdot: do i = lenstr, 1, -1
          if(F_WFk(i:i) == '/') then
             exit findingdot
          else if(F_WFk(i:i) == '.') then
             ip = i
             exit findingdot
          end if
       end do findingdot

       if(nspin == 1) then
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_WFn = F_WFk(1:ip)//"k"//nnumber//"n"//mnumber//'.'//F_WFk(ip+1:lenstr)
             else
                F_WFn = F_WFk(1:ip)//"k"//nnumber//"n"//mnumber
             end if
          else
             F_WFn = F_WFk(1:lenstr)//".k"//nnumber//"n"//mnumber
          end if
          inquire(unit=nfwfk,opened=open)
          if(open) close(nfwfk,status='keep')
          call open0(nfwfk,F_WFn,'F_WFn     ',unknown,formatted,check_file_name_on)

       else if(nspin == 2) then
          if(ispin == 1) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_WFnUD = F_WFk(1:ip)//'up.'//"k"//nnumber//"n"//mnumber//'.'//F_WFk(ip+1:lenstr)
                else
                   F_WFnUD = F_WFk(1:ip)//'up.'//"k"//nnumber//"n"//mnumber
                end if
             else
                F_WFnUD = F_WFk(1:lenstr)//'.up.'//"k"//nnumber//"n"//mnumber
             end if
              if(printable) then
                write(nfout,*) ' --- F_WFnUD (up) ---'
                write(nfout,*) F_WFnUD
             end if
             inquire(unit=nfwfk,opened=open)
             if(open) close(nfwfk,status='keep')
             call open0(nfwfk,F_WFnUD,'F_WFnUD   ',unknown,formatted,check_file_name_on)
          else if(ispin == 2) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_WFnUD = F_WFk(1:ip)//'down.'//"k"//nnumber//"n"//mnumber//'.'//F_WFk(ip+1:lenstr)
                else
                   F_WFnUD = F_WFk(1:ip)//'down.'//"k"//nnumber//"n"//mnumber
                end if
             else
                F_WFnUD = F_WFk(1:lenstr)//'.down.'//"k"//nnumber//"n"//mnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_WFnUD (down) ---'
                write(nfout,*) F_WFnUD
             end if
             inquire(unit=nfwfk,opened=open)
             if(open) close(nfwfk,status='keep')
             call open0(nfwfk,F_WFnUD,'F_WFnUD   ',unknown,formatted,check_file_name_on)
          end if
       end if
    end if
  end subroutine m_Files_open_nfwfk

! ==== 
  subroutine m_Files_open_nfwfksq_noncl(iloop,ik,ib)
    integer, intent(in) :: ik, ib, iloop
    integer :: lenstr, ip, i
    character(len=105) :: F_WFn_MAG
    integer, parameter :: len_nnumber = 4
    integer, parameter :: len_mnumber = 5
    character(len=len_nnumber) :: nnumber
    character(len=len_mnumber) :: mnumber
    logical :: open

    if(mype == 0) then
       write(nnumber,'(i4)') ik
       do i = 1, len_nnumber
          if(nnumber(i:i) == ' ') nnumber(i:i) = '0'
       end do
       write(mnumber,'(i5)') ib
       do i = 1, len_mnumber
          if(mnumber(i:i) == ' ') mnumber(i:i) = '0'
       end do

       lenstr = len_trim(F_WFk_squared)
       ip = lenstr+1
       findingdot: do i = lenstr, 1, -1
          if(F_WFk_squared(i:i) == '/') then
             exit findingdot
          else if(F_WFk_squared(i:i) == '.') then
             ip = i
             exit findingdot
          end if
       end do findingdot

       select case (iloop)
       case (1)
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_WFn_Mag = F_WFk_squared(1:ip)//'tot.'//"k"//nnumber//"n"//mnumber//'.'//F_WFk_squared(ip+1:lenstr)
             else
                F_WFn_Mag = F_WFk_squared(1:ip)//'tot.'//"k"//nnumber//"n"//mnumber
             end if
          else
             F_WFn_Mag = F_WFk_squared(1:lenstr)//'.tot.'//"k"//nnumber//"n"//mnumber
          end if
          if(printable) then
             write(nfout,*) ' --- F_WFn_Mag (tot) ---'
             write(nfout,*) F_WFn_Mag
          end if

          inquire(unit=nfwfk_sq,opened=open)
          if(open) close(nfwfk_sq,status='keep')

          call open0( nfwfk_sq, F_WFn_Mag, 'F_WFn_Mag  ', unknown, formatted, &
               &      check_file_name_on )

       case (2)
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_WFn_Mag = F_WFk_squared(1:ip)//'mx.'//"k"//nnumber//"n"//mnumber//'.'//F_WFk_squared(ip+1:lenstr)
             else
                F_WFn_Mag = F_WFk_squared(1:ip)//'mx.'//"k"//nnumber//"n"//mnumber
             end if
          else
             F_WFn_Mag = F_WFk_squared(1:lenstr)//'.mx.'//"k"//nnumber//"n"//mnumber
          end if
          if(printable) then
             write(nfout,*) ' --- F_WFn_Mag (mx) ---'
             write(nfout,*) F_WFn_Mag
          end if

          inquire(unit=nfwfk_sq,opened=open)
          if(open) close(nfwfk_sq,status='keep')

          call open0(nfwfk_sq,F_WFn_Mag,'F_WFn_Mag  ',unknown,formatted,check_file_name_on)

       case (3)
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_WFn_Mag = F_WFk_squared(1:ip)//'my.'//"k"//nnumber//"n"//mnumber//'.'//F_WFk_squared(ip+1:lenstr)
             else
                F_WFn_Mag = F_WFk_squared(1:ip)//'my.'//"k"//nnumber//"n"//mnumber
             end if
          else
             F_WFn_Mag = F_WFk_squared(1:lenstr)//'.my.'//"k"//nnumber//"n"//mnumber
          end if
          if(printable) then
             write(nfout,*) ' --- F_WFn_Mag (my) ---'
             write(nfout,*) F_WFn_Mag
          end if

          inquire(unit=nfwfk_sq,opened=open)
          if(open) close(nfwfk_sq,status='keep')

          call open0(nfwfk_sq,F_WFn_Mag,'F_WFn_Mag  ',unknown,formatted,check_file_name_on)

       case (4)
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_WFn_Mag = F_WFk_squared(1:ip)//'mz.'//"k"//nnumber//"n"//mnumber//'.'//F_WFk_squared(ip+1:lenstr)
             else
                F_WFn_Mag = F_WFk_squared(1:ip)//'mz.'//"k"//nnumber//"n"//mnumber
             end if
          else
             F_WFn_Mag = F_WFk_squared(1:lenstr)//'.mz.'//"k"//nnumber//"n"//mnumber
          end if
          if(printable) then
             write(nfout,*) ' --- F_WFn_Mag (mz) ---'
             write(nfout,*) F_WFn_Mag
          end if

          inquire(unit=nfwfk_sq,opened=open)
          if(open) close(nfwfk_sq,status='keep')

          call open0(nfwfk_sq,F_WFn_Mag,'F_WFn_Mag  ',unknown,formatted,check_file_name_on)
       end select
    end if
  end subroutine m_Files_open_nfwfksq_noncl

  subroutine m_Files_open_nfwfk_integ_mom(icond)
    integer, intent(in) :: icond
    logical :: open
    if(mype==0) then
       inquire(unit = nfwfk_integ_mom, opened = open)
       if(open) close(nfwfk_integ_mom)
       if(icond == FIXED_CHARGE .or. &
            & ( icond==FIXED_CHARGE_CONTINUATION &
            &       .and. fixed_charge_k_parallel==ALL_AT_ONCE ) ) then
          call open0( nfwfk_integ_mom, F_WFk_IntegMoment, 'F_WFk_IntegMoment', &
               &     unknown, formatted, check_file_name_on )
       else if(icond==FIXED_CHARGE_CONTINUATION &
            &       .and. fixed_charge_k_parallel==ONE_BY_ONE) then
          call open1( nfwfk_integ_mom, F_WFk_IntegMoment, 'F_WFk_IntegMoment', &
               &      unknown,formatted, check_file_name_on )

       else if (icond == INITIAL) then
          call open0( nfwfk_integ_mom, F_WFk_IntegMoment, 'F_WFk_IntegMoment', &
               &     unknown,formatted, check_file_name_on )
       else
          call open1( nfwfk_integ_mom,  F_WFk_IntegMoment,'F_WFk_IntegMoment', &
               &     unknown,formatted, check_file_name_on )
       end if
    end if
  end subroutine m_Files_open_nfwfk_integ_mom

  subroutine m_Files_close_nfwfk_integ_mom()
    logical :: open
    if(mype==0) then
       inquire(unit= nfwfk_integ_mom, opened = open)
       if(open) close( nfwfk_integ_mom )
    end if
  end subroutine m_Files_close_nfwfk_integ_mom
! ====

  subroutine m_Files_open_nfwannier(nspin,ispin,ib)
    integer, intent(in) :: nspin, ispin, ib
    integer :: lenstr, ip, i
    character(len=105) :: F_WFnUD, F_WFn
    integer, parameter :: len_mnumber = 5
    character(len=len_mnumber) :: mnumber
    logical :: open

    if(mype == 0) then
       write(mnumber,'(i5)') ib
       do i = 1, len_mnumber
          if(mnumber(i:i) == ' ') mnumber(i:i) = '0'
       end do

       lenstr = len_trim(F_WANNIER)
       ip = lenstr+1
       findingdot: do i = lenstr, 1, -1
          if(F_WFk(i:i) == '/') then
             exit findingdot
          else if(F_WANNIER(i:i) == '.') then
             ip = i
             exit findingdot
          end if
       end do findingdot

       if(nspin == 1) then
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_WFn = F_WANNIER(1:ip)//mnumber//'.'//F_WANNIER(ip+1:lenstr)
             else
                F_WFn = F_WANNIER(1:ip)//mnumber
             end if
          else
             F_WFn = F_WANNIER(1:lenstr)//"."//mnumber
          end if
          inquire(unit=nfwannier,opened=open)
          if(open) close(nfwannier,status='keep')
          call open0(nfwannier,F_WFn,'F_WFn     ',unknown,formatted,check_file_name_on)

       else if(nspin == 2) then
          if(ispin == 1) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_WFnUD = F_WANNIER(1:ip)//'up.'//mnumber//'.'//F_WANNIER(ip+1:lenstr)
                else
                   F_WFnUD = F_WANNIER(1:ip)//'up.'//mnumber
                end if
             else
                F_WFnUD = F_WANNIER(1:lenstr)//'.up.'//mnumber
             end if
              if(printable) then
                write(nfout,*) ' --- F_WFnUD (up) ---'
                write(nfout,*) F_WFnUD
             end if
             inquire(unit=nfwannier,opened=open)
             if(open) close(nfwannier,status='keep')
             call open0(nfwannier,F_WFnUD,'F_WFnUD   ',unknown,formatted,check_file_name_on)
          else if(ispin == 2) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_WFnUD = F_WANNIER(1:ip)//'down.'//mnumber//'.'//F_WANNIER(ip+1:lenstr)
                else
                   F_WFnUD = F_WANNIER(1:ip)//'down.'//mnumber
                end if
             else
                F_WFnUD = F_WANNIER(1:lenstr)//'.down.'//mnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_WFnUD (down) ---'
                write(nfout,*) F_WFnUD
             end if
             inquire(unit=nfwannier,opened=open)
             if(open) close(nfwannier,status='keep')
             call open0(nfwannier,F_WFnUD,'F_WFnUD   ',unknown,formatted,check_file_name_on)
          end if
       end if
    end if
  end subroutine m_Files_open_nfwannier

  subroutine m_Files_open_nfelf()
    if(mype==0) call open0(nfelf,F_ELF,'F_ELF     ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfelf

  subroutine m_Files_open_nfberry()
    if(mype==0) call open0(nfberry,F_BERRY,'F_BERRY   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfberry

  subroutine m_Files_open_nfeffchg()
    if(mype==0) call open0(nfeffchg,F_EFFCHG,'F_EFFCHG  ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfeffchg

!  subroutine m_Files_open_nfforce()
!    if(mype==0) call open0(nfforce,F_FORCE,'F_FORCE   ',unknown,formatted,check_file_name_on)
!  end subroutine m_Files_open_nfforce
  subroutine m_Files_open_nfforce(append)
    logical, intent(in) :: append
    logical :: opd
    if(mype/=0) return

    if(append) then    
     call open1(nfforce,F_FORCE,'F_FORCE   ',unknown,formatted,check_file_name_on)
    else
     inquire(file=F_FORCE, opened=opd)
     if(opd) close(nfforce)
     call open0(nfforce,F_FORCE,'F_FORCE   ',unknown,formatted,check_file_name_on)
    endif
  end subroutine m_Files_open_nfforce

! ==== KT_add === 13.1R
  subroutine m_Files_open_nfeps_phonon(append)
    logical, intent(in) :: append
    logical :: opd

    if(mype/=0) return

    if(append) then
       call open1(nfeps_ph,F_EPS_PHONON,'F_EPS_PHONON',unknown,formatted, &
            &     check_file_name_on)
    else
       inquire(file=F_EPS_PHONON, opened=opd)
       if(opd) close(nfeps_ph)
       call open0(nfeps_ph,F_EPS_PHONON,'F_EPS_PHONON',unknown,formatted,&
            &     check_file_name_on)
    endif
  end subroutine m_Files_open_nfeps_phonon

  subroutine m_Files_open_nfoptical_coeff(append)
    logical, intent(in) :: append
    logical :: opd

    if(mype/=0) return
    if(append) then
       call open1(nfoptical_coeff,F_OPTICAL_COEFF,'F_OPTICAL_Coeff',unknown,formatted,&
            &     check_file_name_on)
    else
       inquire(file=F_OPTICAL_COEFF, opened=opd)
       if(opd) close(nfoptical_coeff)
       call open0(nfoptical_coeff,F_OPTICAL_COEFF,'F_OPTICAL_Coeff',unknown,formatted,&
            &     check_file_name_on)
    endif
  end subroutine m_Files_open_nfoptical_coeff

  subroutine m_Files_open_nframan_spectra()
    if (mype==0) call open0( nframan_spectra, F_RAMAN_SPECTRA, 'F_RAMAN_SPECTRA', &
         &                   unknown, formatted, check_file_name_on )
  end subroutine m_Files_open_nframan_spectra
! =============== 13.1R

! ==== KT_add ==== 13.1XI
  subroutine m_Files_open_nf_xi_spectra()
    if (mype==0) call open0( nf_excitation_spectra, F_EXCITATION_SPECTRA, &
         &                   'F_EXCITATION_SPECTRA', &
         &                   unknown, formatted, check_file_name_on )
  end subroutine m_Files_open_nf_xi_spectra

  subroutine m_Files_close_nf_xi_spectra
    close(nf_excitation_spectra, status = 'keep')
  end subroutine m_Files_close_nf_xi_spectra
! ================ 13.1XI

  subroutine m_Files_open_nfmode()
    if(mype==0) call open0(nfmode,F_MODE,'F_MODE    ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfmode

  subroutine m_Files_open_nfepsilon()
    if(mype==0) call open0(nfepsilon,F_EPSILON,'F_EPSILON ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfepsilon

  subroutine m_Files_open_nfoccmat()
    if(mype==0) call open0(nfoccmat,F_OCCMAT,'F_OCCMAT  ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfoccmat

  subroutine m_Files_open_nfeps( name_add )
    character*(*), optional, intent(in) :: name_add
    logical open
    character(len=105) :: retstr, retstr0

    if ( .not.present(name_add) ) then
       retstr = F_EPSOUT
    else
       retstr0 = "_" // trim(name_add)
       call insert_str_before_dot( retstr0, F_EPSOUT, retstr )
    endif

    inquire(unit = nfepsout, opened = open)
    if ( .not.open .and. mype==0 ) then
       call open0( nfepsout, retstr, 'F_EPSOUT  ', unknown, &
            &      formatted, check_file_name_on )
    endif
  end subroutine m_Files_open_nfeps

  subroutine m_Files_close_nfeps
    close(nfepsout, status = 'keep')
  end subroutine m_Files_close_nfeps

  subroutine m_Files_open_nfnlo
    logical open
    inquire(unit = nfnlo, opened = open)
    if(.not.open .and. mype==0) &
         & call open0(nfnlo,F_NLO,'F_NLO     ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfnlo

  subroutine m_Files_close_nfnlo
    close(nfnlo, status = 'keep')
  end subroutine m_Files_close_nfnlo

  subroutine m_Files_open_nfmagopt
    logical open
    inquire(unit = nfmagopt, opened = open)
    if(.not.open.and.mype==0) &
         & call open0(nfmagopt,F_MAGOPT,'F_MAGOPT  ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfmagopt

  subroutine m_Files_close_nfmagopt
    close(nfmagopt, status = 'keep')
  end subroutine m_Files_close_nfmagopt

  subroutine m_Files_open_nfepscont
    logical open
    inquire(unit = nfepscont, opened = open)
    if(.not.open.and.mype==0) &
         & call open0(nfepscont,F_EPSCONT,'F_EPSCONT     ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfepscont

  subroutine m_Files_close_nfepscont
    close(nfepscont, status = 'keep')
  end subroutine m_Files_close_nfepscont

!-------------------- T. Hamada 2021.9.28 -------------------- ! UVSOR
  subroutine m_Files_open_nfkptdata
    logical open
    inquire(unit = nfkptdata, opened = open)
    if(.not.open .and. mype==0) &
   & call open0(nfkptdata,F_KPT_DATA,'F_KPT_DATA',unknown,unformatted,check_file_name_on)
  end subroutine m_Files_open_nfkptdata

  subroutine m_Files_close_nfkptdata
    close(nfkptdata, status = 'keep')
  end subroutine m_Files_close_nfkptdata

    subroutine m_Files_open_nfkptepsdata
    logical open
    inquire(unit = nfkptepsdata, opened = open)
    if(.not.open .and. mype==0) &
   & call open0(nfkptepsdata,F_KPTEPS_DATA,'F_KPTEPS_DATA',unknown,unformatted,check_file_name_on)
  end subroutine m_Files_open_nfkptepsdata

  subroutine m_Files_close_nfkptepsdata
    close(nfkptepsdata, status = 'keep')
  end subroutine m_Files_close_nfkptepsdata
! ------------------------------------------------------------ ! UVSOR

  subroutine m_Files_open_nfphdos()
    if(mype==0) call open0(nfphdos,F_PHDOS,'F_PHDOS   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfphdos
  
  subroutine m_Files_open_nfstrfrc()
    if(mype==0) call open0(nfstrfrc,F_STRFRC,'F_STRFRC  ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfstrfrc

  subroutine m_Files_open_nfcntn_wannier
    logical open
    inquire(unit = nfcntn_wannier, opened = open)
    if(.not.open .and. mype==0) &
         & call open0(nfcntn_wannier,F_CNTN_WAN,'F_CNTN_WAN',unknown,unformatted&
         &     ,check_file_name_on)
  end subroutine m_Files_open_nfcntn_wannier

  subroutine m_Files_open_nfpot_wannier
    logical open
    inquire(unit = nfpot_wannier, opened = open)
    if(.not.open .and. mype==0) &
         & call open0(nfpot_wannier,F_POT_WAN,'F_POT_WAN ',unknown,unformatted&
         &     ,check_file_name_on)
  end subroutine m_Files_open_nfpot_wannier

  subroutine m_Files_open_nfpstrn
    if(mype == 0) &
         & call open0(nfpstrn,F_PSTRN,'F_PSTRN   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfpstrn

  subroutine m_Files_open_nfPsicoef()
    if(ekmode == ON .or. (ekmode==OFF.and..not.file_existence_contfiles) .or. icond==INITIAL) then
       if(mype==0) call open0(nfpsicoef,F_PsiCoef,'F_PSICOEF ',unknown,formatted,check_file_name_on)
    else if(ekmode==OFF.and.file_existence_contfiles) then
       if(mype==0) call open1(nfpsicoef,F_PsiCoef,'F_PSICOEF ',unknown,formatted,check_file_name_on)
    end if
  end subroutine m_Files_open_nfPsicoef

  subroutine m_Files_open_nfBandSymInput()
    if((ekmode==ON .or. (ekmode==OFF.and..not.file_existence_contfiles).or.icond==INITIAL) .and. mype==0) then
       call open0(nfbandsyminput,F_Band_Sym_Input,'F_BAND_SYM_INPUT ',unknown,formatted,check_file_name_on)
    else if((ekmode==OFF.and.file_existence_contfiles) .and. mype==0) then
       call open1(nfbandsyminput,F_Band_Sym_Input,'F_BAND_SYM_INPUT ',unknown,formatted,check_file_name_on)
    end if
  end subroutine m_Files_open_nfBandSymInput

  subroutine m_Files_close_nfPsicoef()
    logical :: op
    if(mype == 0) then
       inquire(unit = nfpsicoef, opened = op)
       if(op) close(nfpsicoef)
    end if
  end subroutine m_Files_close_nfPsicoef

  subroutine m_Files_close_nfBandSymInput()
    logical :: op
    if(mype == 0) then
       inquire(unit = nfbandsyminput, opened = op)
       if(op) close(nfbandsyminput)
    end if
  end subroutine m_Files_close_nfBandSymInput

  subroutine m_Files_open_nfvelec
    if(mype == 0) &
         & call open0(nfvelec,F_VELEC,'F_VELEC   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfvelec

  subroutine m_Files_open_nfeppair
    if(mype == 0) &
         & call open0(nfeppair,F_EPPAIR,'F_EPPAIR  ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfeppair

  subroutine m_Files_open_nfeppair2
    if(mype == 0) &
         & call open0(nfeppair2,F_EPPAIR2,'F_EPPAIR2  ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfeppair2

  subroutine m_Files_open_nfvelec_grad
    if(mype == 0) &
         & call open0(nfvelec_grad,F_VELEC_GRAD,'F_VELECGRA',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfvelec_grad

  subroutine m_Files_close_nfpstrn
    logical open
    inquire(unit=nfpstrn,opened=open)
    if(open) close(nfpstrn,status='keep')
  end subroutine m_Files_close_nfpstrn

  subroutine m_Files_close_nfvelec
    logical open
    inquire(unit=nfvelec,opened=open)
    if(open) close(nfvelec,status='keep')
  end subroutine m_Files_close_nfvelec

  subroutine m_Files_close_nfeppair
    logical open
    inquire(unit=nfeppair,opened=open)
    if(open) close(nfeppair,status='keep')
  end subroutine m_Files_close_nfeppair

  subroutine m_Files_close_nfeppair2
    logical open
    inquire(unit=nfeppair2,opened=open)
    if(open) close(nfeppair2,status='keep')
  end subroutine m_Files_close_nfeppair2

  subroutine m_Files_close_nfvelec_grad
    logical open
    inquire(unit=nfvelec_grad,opened=open)
    if(open) close(nfvelec_grad,status='keep')
  end subroutine m_Files_close_nfvelec_grad

  subroutine m_Files_open_nfefermi()
    if(mype == 0) &
         & call open0(nfefermi,F_EFERMI,'F_FERMI   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfefermi

  subroutine m_Files_close_nfefermi()
    logical open
    inquire(unit=nfefermi,opened=open)
    if(open) close(nfefermi,status='keep')
  end subroutine m_Files_close_nfefermi

  subroutine m_Files_open_nfimage(i)
    integer  i
    !!$if(mype==0) call open0(nfimage,F_IMAGE(i),'F_IMAGE   ',unknown,formatted,check_file_name_on)
    call open0(nfimage,F_IMAGE(i),'F_IMAGE   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfimage


! ======================== Added by K. Tagami ================= 10.1
  subroutine m_Files_open_nf_LR()
    logical open
    inquire(unit = nf_LR_spectra, opened = open)
    if(.not.open .and. mype==0) &
      & call open0( nf_LR_spectra,F_LR_SPECTRA,'F_LR_SPECTRA   ', &
      &             unknown,formatted,check_file_name_on )
  end subroutine m_Files_open_nf_LR

  subroutine m_Files_close_nf_LR
    close(nf_LR_spectra, status = 'keep')
  end subroutine m_Files_close_nf_LR
! ============================================================= 10.1

! ====== KT_add ========== 13.0S
  subroutine m_Files_open_core_energy_file()
    logical open
    inquire(unit = nfcore_energy_out, opened = open)

    if(.not.open .and. mype==0) &
      & call open0( nfcore_energy_out, F_CORE_ENERGY_OUT, 'F_CORE_ENERGY_OUT', &
      &             unknown,formatted,check_file_name_on )
  end subroutine m_Files_open_core_energy_file

  subroutine m_Files_close_core_energy_file
    close(nfcore_energy_out, status = 'keep')
  end subroutine m_Files_close_core_energy_file

  subroutine m_Files_open_core_ene_initial()
    logical open
    inquire(unit = nfcore_energy_initial, opened = open)

    if(.not.open .and. mype==0) &
      & call open0( nfcore_energy_initial, F_CORE_ENERGY_INITIAL, &
      &            'F_CORE_ENERGY_INITIAL', &
      &             unknown,formatted,check_file_name_on )
  end subroutine m_Files_open_core_ene_initial

  subroutine m_Files_close_core_ene_initial
    close(nfcore_energy_initial, status = 'keep')
  end subroutine m_Files_close_core_ene_initial

  subroutine m_Files_open_core_ene_final()
    logical open
    inquire(unit = nfcore_energy_final, opened = open)

    if(.not.open .and. mype==0) &
      & call open0( nfcore_energy_final, F_CORE_ENERGY_FINAL, &
      &            'F_CORE_ENERGY_FINAL', &
      &             unknown,formatted,check_file_name_on )
  end subroutine m_Files_open_core_ene_final

  subroutine m_Files_close_core_ene_final
    close(nfcore_energy_final, status = 'keep')
  end subroutine m_Files_close_core_ene_final
! ======================== 13.0S

  subroutine m_Files_open_mag_opencore()
    logical open
    inquire(unit = nf_mag_core, opened = open)
    if(.not.open .and. mype==0) &
      & call open0( nf_mag_core, F_MAG_CORE, 'F_MAG_CORE', &
      &             unknown, formatted, check_file_name_on )
  end subroutine m_Files_open_mag_opencore

  subroutine m_Files_close_mag_opencore
    close(nf_mag_core, status = 'keep')
  end subroutine m_Files_close_mag_opencore

! === defect
  subroutine m_Files_open_electrosta_pot()
    logical open
    inquire(unit = nf_elecpot_bin, opened = open)
    if(.not.open .and. mype==0) &
      & call open0( nf_elecpot_bin, F_ELECPOT_BIN, 'F_ELECPOT_BIN', &
      &             unknown, unformatted, check_file_name_on )
  end subroutine m_Files_open_electrosta_pot

  subroutine m_Files_close_electrosta_pot
    close(nf_elecpot_bin, status = 'keep')
  end subroutine m_Files_close_electrosta_pot

  subroutine m_Files_open_electrosta_pot_ref()
    logical open
    inquire(unit = nf_elecpot_bin_ref, opened = open)
    if(.not.open .and. mype==0) &
      & call open0( nf_elecpot_bin_ref, F_ELECPOT_BIN_REF, 'F_ELECPOT_BIN_REF', &
      &             unknown, unformatted, check_file_name_on )
  end subroutine m_Files_open_electrosta_pot_ref

  subroutine m_Files_close_electrosta_pot_ref
    close(nf_elecpot_bin_ref, status = 'keep')
  end subroutine m_Files_close_electrosta_pot_ref
! === defect


! ==== KT_add === 2014/07/14
  subroutine m_Files_open_nfhypervec()
    if (mype==0) then
       call open0( nfhypervec, F_HYPERVEC,'F_HYPERVEC',unknown,formatted,&
            &      check_file_name_on )
    endif
  end subroutine m_Files_open_nfhypervec

  subroutine m_Files_close_nfhypervec()
    logical open
    inquire(unit=nfhypervec,opened=open)
    if(open) close(nfhypervec,status='keep')
  end subroutine m_Files_close_nfhypervec
! =============== 2014/07/14

  subroutine m_Files_open_nf_ekindens()
    logical open
    inquire(unit = nf_ekindens, opened = open)
    if (.not.open .and. mype==0) &
         & call open0( nf_ekindens, F_EKINDENS, 'F_EKINDENS',  unknown, unformatted &
         &      ,check_file_name_off )
  end subroutine m_Files_open_nf_ekindens

  subroutine m_Files_close_nf_ekindens()
    if(mype==0) close(nf_ekindens)
  end subroutine m_Files_close_nf_ekindens

  subroutine m_Files_open(nf,F_IDEN,chara)
    integer, intent(in) :: nf
    character(len=stringlength_of_filenames), intent(in) :: F_IDEN 
    character(len=*), intent(in):: chara
    if (mype==0)then 
       call open0( nf, F_IDEN,chara,unknown,formatted,&
            &      check_file_name_on )
    endif
  end subroutine m_Files_open

  subroutine m_Files_close(nf)
    integer, intent(in) :: nf
    logical open
    inquire(unit=nf,opened=open)
    if(open) close(nf,status='keep')
  end subroutine m_Files_close

  subroutine m_Files_open_nfpos()
    if (mype==0) then
       call open0( nfpos, F_POS,'F_POS',unknown,formatted,&
            &      check_file_name_on )
    endif
  end subroutine m_Files_open_nfpos

  subroutine m_Files_close_nfpos()
    logical open
    inquire(unit=nfpos,opened=open)
    if(open) close(nfpos,status='keep')
  end subroutine m_Files_close_nfpos

  subroutine m_Files_open_nfcoordattr()
    if (mype==0) then
       call open0( nfcoordattr, F_COORD_ATTR,'F_COORD_ATTR',unknown,formatted,&
            &      check_file_name_on )
    endif
  end subroutine m_Files_open_nfcoordattr

  subroutine m_Files_close_nfcoordattr()
    logical open
    inquire(unit=nfcoordattr,opened=open)
    if(open) close(nfcoordattr,status='keep')
  end subroutine m_Files_close_nfcoordattr

  subroutine m_Files_open_nfhybridinfo()
    if (mype==0) then
       call open0( nfhybridinfo, F_HYBRIDINFO,'F_HYBRIDINFO',unknown,unformatted,&
            &      check_file_name_on )
    endif
  end subroutine m_Files_open_nfhybridinfo

  subroutine m_Files_close_nfhybridinfo()
    logical open
    inquire(unit=nfhybridinfo,opened=open)
    if(open) close(nfhybridinfo,status='keep')
  end subroutine m_Files_close_nfhybridinfo

  subroutine m_Files_open_nfscfzaj()
    if (mype==0) then
       call open0( nfscfzaj, F_SCF_ZAJ,'F_SCF_ZAJ ',unknown,unformatted,&
            &      check_file_name_on )
    endif
  end subroutine m_Files_open_nfscfzaj

  subroutine m_Files_close_nfscfzaj()
    logical open
    inquire(unit=nfscfzaj,opened=open)
    if(open) close(nfscfzaj,status='keep')
  end subroutine m_Files_close_nfscfzaj

  subroutine m_Files_checkpoint_dir(update_counter)
    use m_Control_Parameters, only : cpt_nhistory,cpt_history_count
    use m_IterationNumbers, only : iteration_ionic
    logical, intent(in) :: update_counter
    character(len=10) :: cid1,cidmax,cid2
    integer :: i,nn,ierr
    if (cpt_nhistory<2) return
    if (cpt_history_count==0)then 
        if(update_counter) cpt_history_count = cpt_history_count + 1
        return
    endif

    if (cpt_history_count<cpt_nhistory)then
      cid1 = get_count_char(cpt_nhistory,cpt_history_count)
      call system('mkdir -p '//trim(adjustl(F_CHKPNT))//trim(adjustl(cid1)))
      cidmax = cid1
    else
      cidmax = get_count_char(cpt_nhistory,cpt_nhistory-1)
      nn = cpt_nhistory-1
      if(mype==0 .and. nn>=2)then
        do i=2,nn
          cid1 = get_count_char(cpt_nhistory,i)
          cid2 = get_count_char(cpt_nhistory,i-1)
          call system('cp -f '//trim(adjustl(F_CHKPNT))//trim(adjustl(cid1))//'/'//F_CHGT//' '// &
                        &  trim(adjustl(F_CHKPNT))//trim(adjustl(cid2))//'/')
          call system('cp -f '//trim(adjustl(F_CHKPNT))//trim(adjustl(cid1))//'/'//F_ZAJ//' '// &
                        &  trim(adjustl(F_CHKPNT))//trim(adjustl(cid2))//'/')
          call system('cp -f '//trim(adjustl(F_CHKPNT))//trim(adjustl(cid1))//'/'//F_CNTN//' '// &
                        &  trim(adjustl(F_CHKPNT))//trim(adjustl(cid2))//'/')
          call system('cp -f '//trim(adjustl(F_CHKPNT))//trim(adjustl(cid1))//'/'//F_CNTN_BIN//' '// &
                        &  trim(adjustl(F_CHKPNT))//trim(adjustl(cid2))//'/')
          if (m_Files_nfcntn_bin_paw_exists()) then
          call system('cp -f '//trim(adjustl(F_CHKPNT))//trim(adjustl(cid1))//'/'//F_CNTN_BIN_PAW//' '// &
                        &  trim(adjustl(F_CHKPNT))//trim(adjustl(cid2))//'/')
          endif
          if (m_Files_nfoccmat_exists()) then
          call system('cp -f '//trim(adjustl(F_CHKPNT))//trim(adjustl(cid1))//'/'//F_OCCMAT//' '// &
                        &  trim(adjustl(F_CHKPNT))//trim(adjustl(cid2))//'/')
          endif
        enddo
      endif
    endif

    if(mype==0)then
    call system('cp -f '//F_CHGT//' '//trim(adjustl(F_CHKPNT))//trim(adjustl(cidmax))//'/')
    call system('cp -f '//F_ZAJ//' '//trim(adjustl(F_CHKPNT))//trim(adjustl(cidmax))//'/')
    call system('cp -f '//F_CNTN//' '//trim(adjustl(F_CHKPNT))//trim(adjustl(cidmax))//'/')
    call system('cp -f '//F_CNTN_BIN//' '//trim(adjustl(F_CHKPNT))//trim(adjustl(cidmax))//'/')
    if (m_Files_nfcntn_bin_paw_exists()) then
      call system('cp -f '//F_CNTN_BIN_PAW//' '//trim(adjustl(F_CHKPNT))//trim(adjustl(cidmax))//'/')
    endif
    if (m_Files_nfoccmat_exists()) then
      call system('cp -f '//F_OCCMAT//' '//trim(adjustl(F_CHKPNT))//trim(adjustl(cidmax))//'/')
    endif
    endif

    if(update_counter) cpt_history_count = cpt_history_count+1
    call mpi_barrier(mpi_comm_group,ierr)

  end subroutine m_Files_checkpoint_dir

  subroutine m_Files_checkpoint_dir_neb()
    use m_Control_Parameters, only : cpt_nhistory,cpt_history_count
    use m_IterationNumbers, only : iteration_ionic
    character(len=10) :: cid1,cidmax,cid2
    integer :: i,nn,ierr
    if (cpt_nhistory<2) return
    if (cpt_history_count==0)then 
        cpt_history_count = cpt_history_count + 1
        return
    endif

    if (cpt_history_count<cpt_nhistory)then
      cid1 = get_count_char(cpt_nhistory,cpt_history_count)
      call system('mkdir -p '//trim(adjustl(F_CHKPNT))//trim(adjustl(cid1)))
      cidmax = cid1
    else
      cidmax = get_count_char(cpt_nhistory,cpt_nhistory-1)
      nn = cpt_nhistory-1
      if(mype==0 .and. nn>=2)then
        do i=2,nn
          cid1 = get_count_char(cpt_nhistory,i)
          cid2 = get_count_char(cpt_nhistory,i-1)
          call system('cp -f '//trim(adjustl(F_CHKPNT))//trim(adjustl(cid1))//'/'//F_NEB_CNTN//' '// &
                        &  trim(adjustl(F_CHKPNT))//trim(adjustl(cid2))//'/')
        enddo
      endif
    endif

    if(mype==0) call system('cp -f '//F_NEB_CNTN//' '//trim(adjustl(F_CHKPNT))//trim(adjustl(cidmax))//'/')

    cpt_history_count = cpt_history_count+1
    call mpi_barrier(mpi_comm_group,ierr)

  end subroutine m_Files_checkpoint_dir_neb

  character(len=10) function get_count_char(maxcount,currcount)
    integer, intent(in) :: maxcount,currcount
    integer :: iketa=2
    integer :: itmp
    character(len=256) :: ch
    character(len=256) :: string
    itmp=int(log10(real(maxcount)))+1
    if(itmp>2)iketa=itmp
    write(ch,*) iketa
    write(get_count_char,'(i'//trim(adjustl(ch))//'.'//trim(adjustl(ch))//')') currcount
  end function get_count_char

  subroutine m_Files_resolve_default_pp(ntyp,iatomn,xctype)
    implicit none
    integer, intent(in) :: ntyp
    real(kind=DP), dimension(ntyp), intent(in) :: iatomn
    character(len=*), intent(in) :: xctype
    integer, parameter :: max_elements = 120
    integer :: ityp
    logical :: exi
    integer :: icount
    character(len=stringlength_of_filenames) :: pppath
    character(len=stringlength_of_filenames), dimension(max_elements) :: ggapbe,ldapw91
    namelist/defaultpp/ggapbe,ldapw91
    icount = 0
    do ityp=1,ntyp
       inquire(file=F_POT(ityp),exist=exi)
       if (exi) icount = icount+1
    enddo
    if(icount==ntyp) return

    icount = 0
    do ityp=1,ntyp
       if (F_POT(ityp) /= F_POT_ORG(ityp)) icount = icount+1
    enddo
    if(icount==ntyp) return

    call getenv('PHASE_PP_PATH',pppath)
    if(len(pppath)==0) return

    include 'defaultppfiles'
    inquire(file=trim(F_DEFAULTPP),exist=exi)
    if(exi)then
      open(nfdefaultpp,file=trim(F_DEFAULTPP))
      read(nfdefaultpp,NML = defaultpp, err=30, end=10)
10    continue
      close(nfdefaultpp)
    endif

    do ityp=1,ntyp
       inquire(file=trim(F_POT(ityp)),exist=exi)
       if(.not.exi) then
          F_POT(ityp) = trim(pppath)//'/'//trim(ggapbe(int(iatomn(ityp))))
          if (xctype == 'ldapw91')then
             F_POT(ityp) = trim(pppath)//'/'//trim(ldapw91(int(iatomn(ityp))))
          endif
          write(nfout,'(a,i3,a)') ' !** default PP file adopted for element no. '&
         &                        ,ityp,' : '//trim(F_POT(ityp))
       endif
    enddo
    
    return

30  call phase_execution_error(FILENAMES_FORMAT_ERROR)
  end subroutine m_Files_resolve_default_pp

  subroutine m_Files_open_pwbs()
    logical open
    inquire(unit = nfpwbs, opened = open)
    if(.not.open .and. mype == 0) &
         & call open0(nfpwbs,F_PWBS,'F_PWBS    ',unknown,unformatted&
         &     , check_file_name_on)
  end subroutine m_Files_open_pwbs

  subroutine m_Files_close_pwbs()
    if(mype==0) close(nfpwbs)
  end subroutine m_Files_close_pwbs

  logical function m_Files_file_exists(fname)
    character(len=*) :: fname
    logical :: exi
    inquire(file=trim(fname),exist=exi)
    m_Files_file_exists = exi
  end function m_Files_file_exists

  subroutine m_Files_open_core_charge_dens(it)
    integer, intent(in) :: it
    integer :: n1

    logical open
    inquire(unit = nf_core_charge_radial(it), opened = open)
    if( .not.open) &
         & call open0( nf_core_charge_radial(it), F_CORE_CHARGE(it), &
         &             'F_CORE_CHARGE ', unknown, formatted,  &
         &             check_file_name_on )

  end subroutine m_Files_open_core_charge_dens

  subroutine m_Files_close_core_charge_dens(it)
    integer, intent(in) :: it

    close( nf_core_charge_radial(it) )
  end subroutine m_Files_close_core_charge_dens

  subroutine m_Files_open_xsf()
    use m_IterationNumbers, only : iteration_ionic
    character(len=105) :: F_XSF_id
    integer, parameter :: len_nnumber = 6
    character(len=len_nnumber) :: nnumber
    integer :: i,ip,lenstr,id
    integer :: max_nfiles = 999999
    logical open,exi,found_new_file

    if(mype==0)then
      lenstr = len_trim(F_XSF)      
      ip = lenstr+1 
      findingdot: do i = lenstr, 1, -1
        if(F_CHR(i:i) == '/') then
          exit findingdot
        else if(F_CHR(i:i) == '.') then
          ip = i
          exit findingdot
        end if
      end do findingdot
      write(nnumber,'(i6)') iteration_ionic
      do i = 1, len_nnumber
         if(nnumber(i:i) == ' ') nnumber(i:i) = '0'
      end do
      if(ip >= 1 .and. ip <= lenstr) then
        if(ip+1 <= lenstr) then
          F_XSF_id = F_XSF(1:ip)//nnumber//F_XSF(ip+1:lenstr)
        else
          F_XSF_id = F_XSF(1:ip)//nnumber
        end if
      else
        F_XSF_id = F_XSF(1:lenstr)//nnumber
      end if
      inquire(unit = nfxsf, opened = open)
      if(.not.open .and. mype == 0) &
           & call open0(nfxsf,F_XSF_id,'F_XSF',unknown,formatted&
           &     , check_file_name_on)
    endif
  end subroutine m_Files_open_xsf

  subroutine m_Files_close_xsf()
    if(mype==0) close(nfxsf)
  end subroutine m_Files_close_xsf

  subroutine m_Files_open_n2p2()
    logical open
    inquire(unit = nfn2p2, opened = open)
    if(.not.open .and. mype == 0) &
         & call open1(nfn2p2,F_N2P2,'F_N2P2',unknown,formatted&
         &     , check_file_name_on)
  end subroutine m_Files_open_n2p2

  subroutine m_Files_close_n2p2()
    if(mype==0) close(nfn2p2)
  end subroutine m_Files_close_n2p2

end module m_Files

!指標表の処理
!Copyright (C) 2014-2015 Ryosuke Tomita

module m_character_table
#include "defines.F"
  use m_commons, only: nearlyEquals, intcomp, complexguess
  use m_tspace_defines, only: irrep, character_table, group, kvector, num_imr_max, num_operator_max
  use m_tspace_commons, only: getKpointNameForTex

  implicit none
  DOUBLE_T, parameter, private:: prec = 1e-5
#define NUM_MAX_CLASS_COLUMN 6
#define TEX_GROUP_NAME(SCHNAME) (SCHNAME(1:1)//'_{'//SCHNAME(2:3)//'}')
#define TEX_CHARTITLE(K,SCHNAME,HMNAME) (trim(K)//'('//TEX_GROUP_NAME(SCHNAME)//','//trim(HMNAME)//')')
  
contains

!行列のトレースをもとめる(表現行列の指標を求めるときに用いる。)
  COMPLEX_T function get_trace(wd, dim) result(cr)
    integer, intent(in):: dim!行列の次元
    COMPLEX_T, intent(in):: wd(6,6)!複素数型行列
    integer:: i
    cr = 0d0
    do i = 1, dim
       cr = cr + wd(i,i)
    end do
  end function get_trace
  
#include "get_alknown_ctable.F90"

!2つの表現a,bが同値である、つまり表現の指標が一致するとき.true.、同値でないとき.false.を返す
  logical function is_same_imr(a, b, order)
    type(irrep), intent(in):: a, b!表現構造体
    integer, intent(in):: order!2つの表現の類の数
    integer:: m
    COMPLEX_T:: c
    is_same_imr = .true.
    do m = 1, order
       c = a%comp(m) - b%comp(m)
       is_same_imr = is_same_imr .and. &
            nearlyEquals((real(c)**2 + aimag(c)**2),0d0,prec)
    end do
    
  end function is_same_imr

!mullikenの点群から既約表現を取得し、それと一致する表現にはmullikenの既約表現の名前をつける
  subroutine repname_remake(ctab, kgp)
    type(character_table), intent(inout):: ctab!TSPACEからもとめた既約表現
    type(group), intent(in):: kgp!群
    type(character_table):: ctab_new!mullikenの表現
    integer:: iimr, jimr
    logical:: status
    ctab_new = get_alknown_ctable(kgp%schname, status)!群のシェーンフリース記号からマリケンの既約表現を取得する
    if(.not.status) return
    do iimr = 1, ctab%numimr
       do jimr = 1, ctab%numimr
          if(is_same_imr(ctab%imrs(iimr), ctab_new%imrs(jimr),&
               ctab%nclass)) then
             ctab%imrs(iimr)%name_mulliken = ctab_new%imrs(jimr)%name!mullikenの既約表現と一致するとき、mullikenの既約表現の名前を保存する。
             cycle
          end if
       end do
    end do
  end subroutine repname_remake

!TSPACE内で記憶されているk点の群における既約表現の指標を返す。TSPACE関数tsirnr, irmataを使用
  type(character_table) function get_character_table(kp, kgroup)&
       result(ch)
#define NDIM 6
    type(kvector), intent(in):: kp!k点の名前、成分など
    type(group), intent(in):: kgroup!k点の群
    integer:: dime(num_imr_max), numimr, order, ic

    ch%maxdim = 1
!TSPACE内での指標表の設定
    call tsirnr(numimr, order, dime)
    ch%nclass = kgroup%nclass
    ch%numimr = numimr
    ch%numop = order
    call setchar(ch, 0)

!群構造体から指標表構造体へ、類の名前のコピー
    do ic = 1, kgroup%nclass
       ch%class_name(ic) = kgroup%cls(ic)%name
    end do
    call repname_remake(ch, kgroup)     

  contains
    subroutine setchar(ch, istimr)
      type(character_table), intent(inout):: ch
      integer, intent(in):: istimr

      integer:: ic, i, j
      integer:: ir, mg, nd, jg(num_operator_max), jga(2, 3, num_operator_max) ! dummy
      COMPLEX_T:: cr(num_operator_max), wd(num_operator_max)
      DOUBLE_T:: dcr_inv

#define NAME(ir) ch%imrs(ir)%name
#define COMP(ir, ic) ch%imrs(ir)%comp(ic)
#define WD(i, j, ir, iopr) ch%imrs(ir)%wd(i, j, iopr)

    do ir = 1, numimr
!TSPACE内部データの読み取り
       call tsirmr(ir, 1, 1, mg, nd, jg, jga, cr, wd)
!指標表の構造体へコピー
       ch%imrs(ir + istimr)%dim = nd
       if(nd > ch%maxdim) ch%maxdim = nd
       
       do i = 1, nd
          do j = 1, nd
             call tsirme(i, j, wd)
             do ic = 1, ch%numop
                WD(i, j, ir + istimr, ic) = wd(ic)
             end do
          end do
       end do
       do ic = 1, ch%nclass
          COMP(ir + istimr,ic) = cr(kgroup%cls(ic)%ind(1))
       end do

!反転操作がある場合、その指標の二乗値を取得
       if(kgroup%inversion > 0) then
          dcr_inv = real(cr(kgroup%inversion))**2 + aimag(cr(kgroup%inversion))**2
       else
          dcr_inv = 0d0
       end if
!反転操作の指標から指標の名前を決定する
       if(.not.nearlyEquals(dcr_inv, 0d0, prec)) then
#define NUMB(ir) ((ir + 1)/2)
          if(mod(ir + istimr,2) == 0) then
             write(NAME(ir + istimr), '(A,I0,A)')&
                  '{',NUMB(ir + istimr), '}^-'
          else
             write(NAME(ir + istimr), '(A,I0,A)')&
                  '{',NUMB(ir + istimr), '}^+'
          end if
       else
          write(NAME(ir + istimr), '(A,I0,A)')&
               '{', ir + istimr, '}'
#undef NUMB
       end if
       ch%imrs(ir + istimr)%name_mulliken = ""
    enddo
  end subroutine setchar
end function get_character_table

!指標表の出力、既約表現と類にわけて出力される
  subroutine print_character_table(chtable, kgroup, nfout)
    type(character_table), intent(in):: chtable!指標表
    type(group), intent(in):: kgroup!k群
    integer, intent(in):: nfout!出力する装置番号
    integer:: ic, iimr, i, j
    write(nfout, '(A)') '##Character'
#define IMR chtable%imrs(iimr)
    do iimr = 1, chtable%numimr
       do ic = 1, chtable%nclass
          write(nfout, fmt = '(2A,1X,A24,1X)', advance = 'no')&
               '#', trim(IMR%name), trim(chtable%class_name(ic))
          write(nfout, 400) IMR%comp(ic)
       end do
       write(nfout, *)
    end do
    write(nfout, '(A)') '##Matrix'
    do iimr = 1, chtable%numimr
!       if(IMR%dim < 2) cycle
       do ic = 1, kgroup%order
          write(nfout, *) '#', trim(IMR%name), trim(kgroup%op(ic)%name), get_trace(IMR%wd(:,:,ic), IMR%dim)
          do i = 1, IMR%dim
             do j = 1, IMR%dim
                write(nfout, fmt = '(A,1X,2(I0,1X))', advance = 'no')&
                     '#', i, j
                write(nfout, 400) IMR%wd(i, j, ic)
             end do
          end do
          write(nfout, *)
       end do
    end do
#undef IMR
400 format('(',f0.8,',',f0.8,')')
  end subroutine print_character_table

!指標表をTeX形式で出力する
  subroutine print_character_table_for_TeX(cht, kgp, kp, nfout)
    type(character_table), intent(in):: cht!指標表
    type(group), intent(in):: kgp!k群
    type(kvector), intent(in):: kp!k点
    integer, intent(in):: nfout!出力する装置番号
#define WRITEA write(nfout,fmt='(a)',advance='no')

    write(nfout, *) TEX_BEGINTABLE
    write(nfout, *) TEX_ADJUST
!    write(nfout, *) TEX_CAPTION_FOR_CHARTABLE(trim(getKpointNameForTex(kp%name)))
    if(cht%nclass > NUM_MAX_CLASS_COLUMN) then
       write(nfout, '(A,I0,A)') TEX_BEGINTABULAR(cht%nclass/2+1)
       call print_table('$'//TEX_CHARTITLE(getKpointNameForTex(kp%name),kgp%schname,kgp%hmname)//'$',&
            1, cht%nclass/2)
       call print_table('', cht%nclass/2 + 1, cht%nclass)
    else
       write(nfout, '(A,I0,A)') TEX_BEGINTABULAR(cht%nclass+1)
       call print_table('$'//TEX_CHARTITLE(getKpointNameForTex(kp%name),kgp%schname,kgp%hmname)//'$',&
            1, cht%nclass)
    end if
    write(nfout, '(a)') TEX_ENDTABULAR
    call print_operator_in_class(nfout, kgp)
    write(nfout, *) TEX_ENDTABLE
    write(nfout, *)
  contains
!類と、類に属する対称操作の表の出力
    subroutine print_operator_in_class(nfout, kgp)
      integer, intent(in):: nfout
      type(group), intent(in):: kgp
      integer:: ic, iopr
      write(nfout, *) TEX_BEGINTABULAR(2)
      write(nfout, *) 'Class&Operator\\\hline'
      do ic = 1, kgp%nclass
         write(nfout, fmt = '(a)', advance = 'no')&
              trim(kgp%cls(ic)%name)//'&'//trim(kgp%op(kgp%cls(ic)%ind(1))%name)
         do iopr = 2, kgp%cls(ic)%order
            write(nfout, fmt = '(a)', advance = 'no')&
                 ','//trim(kgp%op(kgp%cls(ic)%ind(iopr))%name)
         end do
         write(nfout, *) '\\\hline'
      end do
      write(nfout, *) TEX_ENDTABULAR
    end subroutine print_operator_in_class
!類の一覧の出力
    subroutine print_class_table(isc, iec)
      integer, intent(in):: isc, iec
      integer:: ic
      do ic = isc, iec
         WRITEA '&$'//trim(cht%class_name(ic))//'$'
      end do
      write(nfout, '(a)') '\\ \hline'
    end subroutine print_class_table

!1つの既約表現の出力
!指標(複素数)を整数型複素数に変換し、その値から表示するデータを決める
    subroutine print_chars(imr, isc, iec)
      integer, intent(in):: imr, isc, iec
      type(intcomp):: icmp
      integer:: ic
      do ic = isc, iec
          WRITEA '&$'
          icmp = complexguess(cht%imrs(imr)%comp(ic))!整数型複素数の取得
          if(icmp%abs_type == 0) then!複素数の形が不明
10           write(nfout, fmt = 400, advance = 'no') cht%imrs(imr)%comp(ic)
             WRITEA '$'
             cycle
          end if

          if(icmp%abs_num == 0) then!複素数の形が不明
             WRITEA '0$'
             cycle
          end if
          
          if(icmp%arg_num == 0) then
             icmp%arg_type = 1 !arg = 0、つまり指標が正の実数のとき
          else if(icmp%arg_num == 1 .and. icmp%arg_den == 2 &
               .and. icmp%arg_type == 1) then
             icmp%arg_type = 2 !arg = pi/2、つまり指標が純虚数のとき
          else if(icmp%arg_num == 1 .and. icmp%arg_den == 2 &
               .and. icmp%arg_type == 2) then
             icmp%arg_type = 4 !arg = -pi/2、つまり指数が純虚数で、負の符号がつくとき
          else if(icmp%arg_num == 1 .and. icmp%arg_den == 1 &
               ) then
             icmp%arg_type = 3 !arg = pi、つまり指標が負の実数のとき
          else 
             icmp%arg_type = icmp%arg_type*10
          end if

          if(icmp%abs_den == 1) then !ノルムが分数でない、つまり|z|=m or sqrt(m)
             icmp%abs_type = icmp%abs_type * 10 + 1
          else
             icmp%abs_type = icmp%abs_type * 10 + 2
          end if
          
!指標のノルムが整数のとき(abs_type=11)、平方根のとき(abs_type==21)、分数のとき(abs_type==12)、平方根/整数のとき(abs_type=22)に合わせて指標のノルムだけを出力するマクロ、ただしノルムが1のときは出力する必要がないので、そのときは出力しない
#define ABSGUESS\
          select case(icmp%abs_type);\
          case (11);\
             if(icmp%abs_num /= 1) write(nfout, fmt = '(I0)', advance = 'no') icmp%abs_num;\
          case (21);\
             write(nfout, fmt = '(A,I0,A)', advance = 'no') '\sqrt{', icmp%abs_num, '}';\
          case (12);\
             write(nfout, fmt = '(A,I0,A,I0,A)', advance = 'no') '\frac{', icmp%abs_num, '}{', icmp%abs_den, '}';\
          case (22);\
             write(nfout, fmt = '(A,I0,A,I0,A)', advance = 'no') '\frac{\sqrt{', icmp%abs_num, '}}{', icmp%abs_den, '}';\
          end select
!マクロ定義終わり

          
          select case(icmp%arg_type)
          case(1)!arg = 0、指標が正の実数のとき
             ABSGUESS
             if(icmp%abs_num == 1) WRITEA '1'
          case(2)!arg = pi/2、指標が正の純虚数のとき
             ABSGUESS
             WRITEA 'i'
          case(3)!arg = pi、指標が負の実数のとき
             WRITEA '-'
             ABSGUESS
             if(icmp%abs_num == 1) WRITEA '1'
          case(4)!arg = -pi/2、指標が負の純虚数のとき
             WRITEA '-'
             ABSGUESS
             WRITEA 'i'
          case(10)!指標が複素数（純虚数でない）かつ位相が正のとき
             ABSGUESS
             write(nfout, fmt = '(A,I0,A,I0,A)', advance = 'no') 'e^{i\frac{', icmp%arg_num, '}{', icmp%arg_den, '}\pi}'
          case(20)!指標が複素数（純虚数でない）かつ位相が負のとき
             ABSGUESS
             write(nfout, fmt = '(A,I0,A,I0,A)', advance = 'no') 'e^{-i\frac{', icmp%arg_num, '}{', icmp%arg_den, '}\pi}'
#undef ABSGUESS
          case default
             go to 10
          end select
          WRITEA '$'
       end do
400 format('(',f0.8,',',f0.8,')')
     end subroutine print_chars

!指標の出力
     subroutine print_table(title, isc, iec)
       character(*), intent(in):: title
       integer, intent(in):: isc, iec
       integer:: imr

       write(nfout, fmt = '(A)', advance = 'no') title
       call print_class_table(isc, iec)

       do imr = 1, cht%numimr
          write(nfout, fmt = '(A)', advance = 'no') '$'//trim(cht%imrs(imr)%name)//'$'
          if(cht%imrs(imr)%name_mulliken /= "")&
               write(nfout, fmt = '(A)', advance = 'no') '($'//trim(cht%imrs(imr)%name_mulliken)//'$)'
          call print_chars(imr, isc, iec)
          write(nfout, '(a)') '\\ \hline'
       end do
     end subroutine print_table
  end subroutine print_character_table_for_TeX
end module m_character_table

!kベクトルおよびGベクトルに対称操作を施す処理
!Copyright (C) 2014-2015 Ryosuke Tomita 

module m_transd_vector
#include "defines.F"
#define ROTATION(rot, vec) matmul(vec, rot)
!$ use omp_lib
  use m_commons, only: equals_vector
  use m_container_commons, only: k_state, gvector_t, transd_vector_index
  use m_tspace_defines, only: group, num_operator_max

  implicit none
!transd_gv_index(1: kgroup%order): G点を回転操作Rにより変換させたときの新たなG'のインデックス。(*)そのG点がm_container_psicoef::gvectorにあるとき、そのインデックスを、ないとき-1を格納する
!transd_kv_index(1: kgroup%order): k点がBZ境界にあるとき、等価な点G = k - Rkが存在する。そのG点が~(上記*と同じ)~格納する
  type(k_state), pointer, private:: ks
  type(gvector_t), pointer, private:: gv
  integer, private, allocatable, target:: &
       transd_gv_index(:,:), transd_kv_index(:)
contains
!Gベクトルをgv_t%compから検索し、そのインデックスを返す、みつからなかったら-1が返る
  integer function find_gvector(kv, gv_t)
    integer, dimension(3), intent(in):: kv
    type(gvector_t), intent(in):: gv_t
    integer:: a
    find_gvector = -1
    do a = 1, gv_t%num
       if(equals_vector(kv, gv_t%comp(1:3, a))) then
          find_gvector = a
          exit
       endif
    enddo
  end function find_gvector

!指定したk点のtransd_kv_indexを返す
  integer function find_rotk(iopr)
    integer, intent(in):: iopr
    integer:: a, n, itmp(3), jtmp(3)

!任意のk点のインデックスは有理数、つまり共通分母整数Nと分子整数ベクトルG'で表される, k = G'/N
!G' - RG'  = Ng (defined as g, k - Rk = g)
    itmp = ks%kpoint%comp - nint(ROTATION(ks%kgroup%op(iopr)%rot, ks%kpoint%comp))
    find_rotk = -1
    n = ks%kpoint%common_denom
!g == G <=> G' == NG
    do a = 1, gv%num
       jtmp = n * gv%comp(1:3, a)
       if(equals_vector(itmp, jtmp)) then
          find_rotk = a
          exit
       endif
    enddo
  end function find_rotk

  subroutine delete_transd_vector
    if(allocated(transd_kv_index))&
         deallocate(transd_kv_index)
    if(allocated(transd_gv_index))&
         deallocate(transd_gv_index)
  end subroutine delete_transd_vector

!k点群の対称操作を指定する（任意）
  subroutine new_transd_vector(ks_t, gv_t)
    type(k_state), target, intent(in):: ks_t
    type(gvector_t), target, intent(in):: gv_t
    integer:: iopr, ig, itmp(3)
    DOUBLE_T:: rot(3,3)

    ks => ks_t
    gv => gv_t
!k点がBZ境界にあるとき、等価な点の処理が必要
    if(.not.allocated(transd_kv_index) .and. ks%kpoint%comm2bz > 1) then
       allocate(transd_kv_index(ks%kgroup%order))
       do iopr = 1, ks%kgroup%order
          transd_kv_index(iopr) = find_rotk(iopr)
       end do
    endif
    if(.not.allocated(transd_gv_index)) then
       allocate(transd_gv_index(gv%num, ks%kgroup%order))
    else
       return
    end if

!$omp parallel
    do iopr = 1, ks%kgroup%order
       rot = ks%kgroup%op(iopr)%rot
!$omp do private(itmp)
       do ig = 1, gv%num
          itmp = nint(ROTATION(rot,gv%comp(1:3,ig)))! G' = RG
          transd_gv_index(ig, iopr) = find_gvector(itmp, gv)
       end do
!$omp end do
    end do
!$omp end parallel
  end subroutine new_transd_vector

!変換されたベクトルの出力
  subroutine print_transd_vector(nfout)
    integer, intent(in):: nfout
    integer:: iopr, ig
    do iopr = 1, ks%kgroup%order
       write(nfout, *) 'K, ', ks%kgroup%op(iopr)%name
       if(ks%kpoint%comm2bz > 1)&
            write(nfout, *) transd_kv_index(iopr)
       write(nfout, *) 'G, ', ks%kgroup%op(iopr)%name
#ifdef NUM_G_DEBUG
       do ig = 1, NUM_G_DEBUG
#else
       do ig = 1, gv%num
#endif
          write(nfout, *) ig, transd_gv_index(ig, iopr)
       end do
    end do
  end subroutine print_transd_vector
 
  type(transd_vector_index) function &
       get_transd_vector_index() result(tvi)
  tvi%numop = ks%kgroup%order
  tvi%numg = gv%num
  tvi%gv => transd_gv_index
  tvi%kv => transd_kv_index
  end function get_transd_vector_index
       
end module m_transd_vector

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE: m_Const_Parameters
!
!  AUTHOR(S): T. Yamasaki and K. Mae   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
module m_ErrorMessages
! $Id: m_ErrorMessages.F90 570 2017-04-21 20:34:50Z yamasaki $
  implicit none

  integer,parameter :: NO_ERROR                   = 0
! ---
  integer,parameter :: FORMAT_ERROR               = 1101
  integer,parameter :: EOF_REACHED                = 1103
! ---
  integer,parameter :: FILE_NOT_EXIST             = 1200
  integer,parameter :: FILENAMES_NOT_EXIST        = 1201
  integer,parameter :: CONT_FILES_NOT_EXIST       = 1202
  integer,parameter :: F_POT_FILE_NOT_EXIST       = 1203
  integer,parameter :: F_ZAJ_FILE_NOT_EXIST       = 1206
  integer,parameter :: F_CHGT_FILE_NOT_EXIST      = 1207
  integer,parameter :: F_CNTN_FILE_NOT_EXIST      = 1208
  integer,parameter :: FILENAMES_FORMAT_ERROR     = 1209
  integer,parameter :: FILENAMES_FORMAT_ERROR_NEB = 1210
  integer,parameter :: ERROR_IN_INPUTFILE_OPENING = 1211
  integer,parameter :: F_CHGT_FILE_NOT_EXIST_EK   = 1212
  integer,parameter :: INVALID_CHARGE_MIXING      = 1302
  integer,parameter :: INVALID_ATOMIC_NUMBER      = 1401
  integer,parameter :: PARALLELIZATION_INVALID_2D = 2101
  integer,parameter :: PARALLELIZATION_INVALID_3D = 2102
  integer,parameter :: PARALLELIZATION_INVALID_NK = 2103
  integer,parameter :: PARALLELIZATION_INVALID_NE = 2104
! ---
  integer,parameter :: len_1101_error = 37
  character(len=len_1101_error) :: msg_format_error = "Input data format error when reading."
!!$                                                    12345678901234567890123456789012345678901234567890  
  integer,parameter :: len_1103_error = 31
  character(len=len_1103_error) :: msg_1103_error   = "Encounter the EOF when reading."
!!$                                                    12345678901234567890123456789012345678901234567890  
  integer,parameter :: len_1206_error = 48
  character(len=len_1206_error) :: msg_1204_error   = "The file for initial wavefunctions is not exist."
!!$                                                    12345678901234567890123456789012345678901234567890  
  integer,parameter :: len_1207_error = 49
  character(len=len_1207_error) :: msg_1205_error   = "The file for initial charge density is not exist."
!!$                                                    12345678901234567890123456789012345678901234567890  
  integer,parameter :: len_1211_error = 35
  character(len=len_1211_error) :: msg_1211_error   = "Error in opening of the inputfile: "
!!$                                                    12345678901234567890123456789012345678901234567890  
  integer,parameter :: len_1212_error = 46
  character(len=len_1212_error) :: msg_1212_error   = "Fixed_charge calc require charge-density file."
!!$                                                    12345678901234567890123456789012345678901234567890  
!  integer,parameter :: len_1208_error = 35
!  character(len=len_1208_error) :: msg_1208_error     = "Error in opening of the inputfile: "
! ---
  integer,parameter :: len_6100_error = 29
  character(len=len_6100_error) :: msg_6100_error     = "A CPP defintion is not proper"
  integer,parameter :: CPP_DEFINE_ERROR_1 = 6101
  integer,parameter :: len_6101_error = 31
  character(len=len_6101_error) :: msg_6101_error     = "TRANSPOSE_WITHOUT_REARRANGEMENT"
!!$                                                      1234567890123456789012345678901234567  

contains
  subroutine m_EMsg_abort01()
  end subroutine m_EMsg_abort01

  subroutine m_EMsg_Warning(iwarning, nfout)
    implicit none
    integer,intent(in) :: iwarning, nfout

    select case (iwarning)
    case (FILENAMES_NOT_EXIST)
       write(*,*) '### Warning(1201): "file_names.data" does not exist.'
       write(*,*) '                   A default set of file names is adapted.'
    case default
       write(nfout,*) '### Warning(9999)'
    end select
  end subroutine m_EMsg_Warning

end module m_ErrorMessages
  

module mod_timer
implicit none
integer, private, parameter :: num_max_routines = 100 ! Number of max routines.
integer, private, parameter :: num_max_namelen = 100 ! Max length of routine name.
integer, private :: num_of_routines = 0 ! Counter for number of routines.

character(len=num_max_namelen), private, dimension(num_max_routines) :: t_name = "" ! Array for routine name.
real(kind=8), private, dimension(num_max_routines) :: t_value = 0.0d0, ts ! Timer values.
integer, private, dimension(num_max_routines) :: call_count = 0 ! Counter of routine call.
logical, private, dimension(num_max_routines) :: timer_start = .false. ! Flag for timer is started or not.

private :: wallclock

contains

   subroutine start_timer(subroutine_name)
      character(len=*), intent(in) :: subroutine_name
      integer :: nlen
      integer :: i

      nlen=len(subroutine_name)

      do i = 1, num_of_routines
         if(subroutine_name(1:nlen) == trim(t_name(i))) then
            if(timer_start(i)) then
               write(0,*) 'Timer for ', trim(subroutine_name), ' is already started!!!'
               return
            end if
            timer_start(i) = .true.
            call_count(i) = call_count(i) + 1
            call wallclock(ts(i))
            return
         end if
      end do

      num_of_routines = num_of_routines + 1
      t_name(num_of_routines) = subroutine_name(1:nlen)
      timer_start(num_of_routines) = .true.
      call_count(num_of_routines) = call_count(num_of_routines) + 1
      call wallclock(ts(num_of_routines))

      return
   end subroutine start_timer

   subroutine stop_timer(subroutine_name)
      character(len=*), intent(in) :: subroutine_name
      integer :: nlen
      integer :: i
      real(kind=8) :: te_tmp

      call wallclock(te_tmp)

      nlen=len(subroutine_name)

      do i = 1, num_of_routines
         if(subroutine_name(1:nlen) == trim(t_name(i))) then
            if(.not. timer_start(i)) then
               write(0,*) 'Timer for ', trim(subroutine_name), ' is NOT started!!!'
               return
            end if
            timer_start(i) = .false.
            t_value(i) = t_value(i) + (te_tmp - ts(i))
            return
         end if
      end do

      write(0,*) 'Timer for ', trim(subroutine_name), ' is NOT started!!!'

      return
   end subroutine stop_timer

   subroutine print_timer(mype)
      integer, intent(in) :: mype
      integer :: i
      character(len=31) :: p_name

      write(40000+mype,'(a)') ''
      write(40000+mype,'(a)') '[Timer Output]'
      write(40000+mype,'(a)') '+-------------------------------+----------+------------+'
      write(40000+mype,'(a)') '|Timer region                   |Called    |Elapsed     |'
      write(40000+mype,'(a)') '|                               |          |Time[s]     |'
      write(40000+mype,'(a)') '+-------------------------------+----------+------------+'
      do i = 1, num_of_routines
         if(timer_start(i)) then
            write(0,*) 'Timer for ', trim(t_name(i)), ' is NOT stopped!!!'
            return
         end if
         p_name = ''
         p_name = trim(t_name(i))
         write(40000+mype,'(a,a,i10,a,f12.3,a)') '|', p_name // '|', call_count(i), '|', t_value(i), '|'
      end do
      write(40000+mype,'(a)') '+-------------------------------+----------+------------+'

      return
   end subroutine print_timer

   subroutine wallclock(t)
      real(kind=8), intent(out) :: t
      integer(kind=8) :: c, c_rate

      call system_clock(c, c_rate)

      t = dble(c)/dble(c_rate)

      return
   end subroutine wallclock

end module mod_timer

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  MODULE:  m_Total_Energy
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Total_Energy
!    ( m_TE )
! $Id: m_Total_Energy.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Charge_Density,       only : chgq_l, chgqo_l, hsr, hsro
  use m_XC_Potential,         only : vxc_l, exc,eex,ecor
  use m_Electronic_Structure, only : nrvf_ordr, occup_l, eko_l, totch &
      &                            , band_entropy, dhub &
      &                            , m_ES_eekdif_cond &
      &                            , zaj_l, vloc_esm, m_ES_what_is_evdff_now
  use m_PseudoPotential,      only : psc_l,etot1,ilmt,ltp,mtp,epc,dion, ival &
                                    , flg_paw,ipaw &
                                    , dion_hartree,dion_vxc,dion_paw &
                                    , dion_hartree_now, dion_kin_ion &
                                    , flg_symmtry,ia2ia_symmtry_op, epc_paw
  use m_PlaneWaveBasisSet,    only : gr_l,m_pwBS_kinetic_energies,iba,kg1,igfp_l
  use m_FFT,                  only : nfftps
! === DEBUG by tkato 2012/11/05 ================================================
!!$  use m_PlaneWaveBasisSet,    only : gr_l,m_pwBS_kinetic_energies_3D,iba,kg1
  use m_Parallelization,      only : np_g1k, ista_g1k, iend_g1k
! ==============================================================================
  use m_Crystal_Structure,    only : univol,nopr,op
  use m_Ionic_System,         only : ntyp,natm,natm2,iwei,ityp,zfm3_l &
      &                            , eewald, ihubbard &
      &                            , evdw, ntyp_vdw &
      &                            , num_regions, regions
  use m_Timing,               only : tstatc0_begin, tstatc0_end
!!$  use m_Control_Parameters,   only : af, kimg, ipri, nspin, edelta, neg &
  use m_Control_Parameters,   only : af, kimg, ipri, nspin, neg &
       &                           , num_extra_bands, printable, xctype, oneshot &
       &                           , width, way_of_smearing, icond &
       &                           , m_CtrlP_ntcnvg_incre &
       &                           , m_CtrlP_ntcnvg_clear &
       &                           , m_CtrlP_ntcnvg_reset &
       &                           , m_CtrlP_get_edelta &
       &                           , m_CtrlP_sub_ntcnvg_incre &
       &                           , m_CtrlP_solver_for_WFs_now &
       &                           , m_CtrlP_get_isolver_now &
       &                           , sub_delta_factor_is_given &
       &                           , sub_delta_factor &
       &                           , sw_dipole_correction, sw_screening_correction &
       &                           , sw_hubbard, proj_attribute &
       &                           , critical_ehub, delta_ehub &
       &                           , num_conduction_bands_lmm &
       &                           , sw_hybrid_functional, sw_eval_vexx, sw_retard_eigval_evaluation, sw_fef &
       &                           , in_line_minimization &
       &                           , sw_external_potential, ekmode, icond, sw_rsb, sw_output_xc_seperately &
       &                           , number_of_cdmixing_applied, cdmixing_names_applied &
       &                           , number_of_solvers_applied, solver_names_applied, len_solvername &
       &                           , sw_potential_mixing, sw_communicator_for_chg &
#ifdef ENABLE_ESM_PACK
       &                           , sw_esm &
#endif
       &                           , m_CtrlP_push_CDMixingNameApplied,sw_harris_functional &
       &                           , nsamp, convergence_criteria &
       &                           , sw_vdw_correction, vdw_method &
       &                           , order_mp
  use m_Kpoints,              only : qwgt,kv3,vkxyz,k_symmetry
  use m_IterationNumbers,     only : iteration, iteration_electronic,iteration_ionic
  use m_Parallelization,      only : mpi_comm_group,map_k,myrank_k,ierr,np_e &
       &                           , ista_kngp,iend_kngp,npes,mype &
       &                           , myrank_e, map_e, map_z   &
       &                           , ista_atm, iend_atm, myrank_g, nrank_g, nrank_e, nrank_chg &
       &                           , ista_e, iend_e, istep_e
  use m_Const_Parameters,     only : Valence_plus_PC_Charge,PAI4,UP,DOWN&
       &                           , EXC_ONLY, VXC_AND_EXC, IINCRE_CRITICAL,DP,CMPLDP &
       &                           , len_tag_total_energy, tag_total_energy &
       &                           , PARABOLIC, COLD, ON, OFF &
       &                           , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, GAMMA, DELTA &
       &                           , MDKOSUGI, MDDAVIDSON, INITIAL, CONTINUATION, COORDINATE_CONTINUATION &
       &                           , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, MATRIXDIAGON &
       &                           , DELTA_MOVING_AVERAGE, SLOPE, DELTA_V &
       &                           , VDW_DFTD3 &
       &                           , MP
  use m_Dipole,               only : edip_ion, eext_ion, vdip_l, vext_l
  use m_Screening,            only : screening
  use m_Hubbard,              only : m_Hubbard_energy
  use m_FiniteElectricField,  only : m_FEF_polarization, pmac, pmac_old
  use m_ES_ExactExchange,     only : m_ES_EXX_gather_valence_states,m_ES_EXX_energy &
       &                           , m_ES_EXX_energy2
#if 0
       &  , m_ES_EXX_gather_valence_states_k
#endif
  use m_PAW_XC_Potential,     only : m_PAW_XC_cal_potential,exc_ae,exc_ps &
       &                           , m_PAW_XC_cal_potential_sphex2,m_PAW_XC_allocation, m_PAW_XC_deallocation
!!$                                    , m_PAW_XC_cal_potential_sym
  use m_PAW_Hartree,          only : m_PAWH_get_dion_hartree_now
  use m_External_Potential,   only : espot_g
  use m_PAW_ChargeDensity,    only : calcGaussLegendreIntegration &
       &                            , calcSphericalHarmonicsExpansion

  use m_PlaneWaveBasisSet,    only : kgp, kg


! ====================================== added by K. Tagami ================ 11.0
  use m_Control_Parameters,    only : noncol, ndim_spinor, ndim_magmom, ndim_chgpot
  use m_PseudoPotential,       only : dion0_noncl, nlmt
  use m_Charge_Density,         only : hsi
  use m_ES_NonCollinear,       only : m_ES_MagMom_To_DensMat_hsr, &
       &                              m_ES_MagMom_to_DensMat_Dhub
!
  use m_Crystal_Structure,     only :  sw_magnetic_constraint
  use m_ES_Mag_Constraint,      only : m_ES_calc_MagConstraint_Energy
  use m_Hubbard,              only : m_Hubbard_energy_noncl, &
       &                             m_Hubbard_energy2_noncl, &
       &                             m_Hubbard_energy3_noncl
! ========================================================================== 11.0

! ====================================== added by K. Tagami ================ 11.0
  use m_Control_Parameters,    only : SpinOrbit_Mode
  use m_Const_Parameters,      only : ByPawPot, CMPLDP, BuiltIn, EXECUT
  use m_SpinOrbit_Potential,   only : dsoc, m_SO_set_Dsoc_potential2
  use m_SpinOrbit_RadInt,    only : m_SO_calc_SOC_strength_pawpot
  use m_PseudoPotential,      only : lmta,  m_PP_include_vanderbilt_pot, dion_scr_noncl
  use m_Electronic_Structure,   only : fsr_l, fsi_l, dhub_aimag
! ========================================================================== 11.0

! ======================= KT_add ================== 13.0E
  use m_Const_Parameters,   only : Fermi_Dirac
! ================================================= 13.0E

! =========== KT_add ========== 13.0U2
  use m_Control_Parameters,  only : sw_potential_mixing, use_metagga, vtau_exists
! ============================= 13.0U2

#ifndef DISABLE_VDWDF
  use m_vdWDF,  only : ecnl_vdwdf
#endif

  use m_Control_Parameters,  only : m_CtrlP_get_isolver_now

! === Positron SCF ==== 2015/11/28
  use m_Control_Parameters,  only : sw_positron, npeg, positron_method
  use m_Const_Parameters,   only :  positron_GGGC
  use m_epc_potential,  only : ecorr_pztr => epc, m_epc_cal_potential, vepc_l
  use m_PlaneWaveBasisSet, only : kg1_pwf
  use m_Positron_Wave_Functions,  only : pzaj, nprvf_ordr, pchg_l, pchgo_l, pev
  use m_PlaneWaveBasisSet,    only : m_pwBS_pstrn_kinetic_energies
! ==================== 2015/11/28
  use m_ES_LHXC, only : m_ESlhxc_delta_vmax

  implicit none
  include 'mpif.h'

  real(kind=DP),private          :: eband ! band energy
  real(kind=DP),private          :: eband_extendedrange
  real(kind=DP),private          :: eohxc ! exchange correlation and &
  !                                         Hartree with old charge

! ==== KT_mod === 13.0U2
!!  real(kind=DP),private          :: elocal ! local potential
  real(kind=DP)            :: elocal ! local potential
! =============== 13.0U2

  real(kind=DP),private          :: eloca1
  real(kind=DP),private          :: enonlc ! non-local
!!$  real(kind=DP),private          :: ehartr ! hartree energy with new charge
  real(kind=DP)                  :: ehartr ! hartree energy with new charge
  real(kind=DP),private          :: ekinet ! kinetic energy
  real(kind=DP),private          :: eentropy ! entropic term of free energy (-TS)

  real(kind=DP),private          :: edip   ! dipole energy
  real(kind=DP),private          :: evdip  ! dipole potential
  real(kind=DP),private          :: evext  ! external potential

  real(kind=DP),private          :: etoold ! previous total energy
  real(kind=DP),private          :: edeltb = 1.d99 ! etotal - etoold
  real(kind=DP)                  :: etotal ! total free energy: F(simga)
  real(kind=DP)                  :: etotal0 ! total energy: E(sigma=0)

  real(kind=DP)                  :: eespot ! electrostatic potential

  real(kind=DP), pointer, dimension(:,:,:) :: chgqt,chgqto
  real(kind=DP), pointer, dimension(:,:,:,:) :: hsrt,hsit
  !
  ! Free energy:
  !F(sigma) = E(sigma) - sigma*S(sigma)
  !
  ! 1. E(sigma=0) exprapolation for the cold smearing method
  !E(sigma=0) ~ (2*F(sigma)+E(sigma))/3
  !
  ! 2. E(sigma=0) exprapolation for the parabolic broadening method
  !F(sigma) = E(sigma) - sigma*S(sigma)
  !E(sigma=0) ~ (F(sigma)+E(sigma))/2
  !

  ! DFT+U
  real(kind=DP),private          :: ehub0 ! Hubbard energy
  real(kind=DP),private          :: ehub0_old = 1.d+20 ! Old Hubbard energy
  real(kind=DP),private          :: ehub1 ! Hubbard potential energy

  ! PAW
  real(kind=DP),private          :: eohxc_paw, ehartr_paw, ekin_ion_paw

  ! Hybrid functional method
  real(kind=DP),private          :: vexx,eexx

  ! Finite electric field method
  real(kind=DP),private          :: eplr  ! -EP term

! ============================== added by K. Tagami ================== 11.0
! Magnetic constraint
!
  real(kind=DP),private          :: emag0      ! magnetic constraint energy
  real(kind=DP),private          :: emag1      ! double counting energy
! ==================================================================== 11.0

! ====================================== added by K. Tagami ================ 11.0
! Spin Orbit
!
  real(kind=DP),private          :: espinorb_old, espinorb_now
! ========================================================================== 11.0

! === positron
  real(kind=DP) :: ekin_pztr, elocal_pztr, ehartr_ep, eohxc_pztr
! ===

  integer,private, parameter     :: len_str = 132
  character(len=len_str),private    ::  str

  real(kind=DP), allocatable, dimension(:) :: ehist
  integer :: ihist
  real(kind=DP) :: emova, emovaold
contains
  real(DP) function m_TE_what_is_edeltb_now()
     m_TE_what_is_edeltb_now = edeltb
  end function m_TE_what_is_edeltb_now

  subroutine m_TE_wd_total_energy_with_solvers(nfout)
    integer, intent(in) :: nfout
    logical :: display_on
    display_on = .true.
    call sumup_all_energies(nfout,exc,display_on)

  end subroutine m_TE_wd_total_energy_with_solvers


! ==== KT_add === 2015/01/30
  subroutine get_kinetic_local_energy_paw(nfout)
    integer, intent(in) :: nfout
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer :: ismax
    real(kind=DP) :: fac

    ekin_ion_paw = 0.0d0
    if ( noncol ) then
       ismax = 1
    else
       ismax = nspin
    endif
    do ispin = 1, ismax, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                if( il1 /= il2 .or. im1 /= im2) cycle
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   ekin_ion_paw = ekin_ion_paw &
                        & + fac*dion_kin_ion(lmt1,lmt2,it)*hsrt(ia,lmt1,lmt2,ispin)
                end do
             end do
          end do
       end do
    end do
    ekin_ion_paw = ekin_ion_paw*(af+1)
  end subroutine get_kinetic_local_energy_paw
! ============ 2015/01/30

  subroutine get_kinetic_energy(nfout)
    integer, intent(in) :: nfout
#ifdef __TIMER_SUB__
    call timer_sta(747)
#endif
    ekinet = eband - eohxc - eloca1 - enonlc
    if(sw_dipole_correction == ON) then
       ekinet = ekinet - evdip - evext
    end if
    if(sw_hubbard==ON) then
       ekinet = ekinet - ehub1
    end if
    if(sw_hybrid_functional == ON) then
       ekinet = ekinet - vexx
    end if
! ========================= added by K. Tagami ====================== 11.0
    if ( sw_magnetic_constraint==ON ) then
       ekinet = ekinet - emag1
    endif
! =================================================================== 11.0

! === KT_add === 2014/08/01
!!!#ifdef USE_ESPINORB
! ============== 2014/08/01

    if(ipri >= 2) then
       write(nfout,'(" !D EBAND  = ",f12.5)') eband
       write(nfout,'(" !D EOHXC  = ",f12.5)') eohxc
       write(nfout,'(" !D ELOCA1 = ",f12.5)') eloca1
       write(nfout,'(" !D ENONLC = ",f12.5)') enonlc
       if(sw_dipole_correction == ON) then
          write(nfout,'(" !D EVDIP  = ",f12.5)') evdip
          write(nfout,'(" !D EVEXT  = ",f12.5)') evext
       end if
       if(sw_hubbard==ON) write(nfout,'(" !D EHUB1  = ",f12.5)') ehub1
       if(sw_hybrid_functional == ON) write(nfout,'(" !D VEXX   = ",f12.5)') vexx
    endif
#ifdef __TIMER_SUB__
    call timer_end(747)
#endif
  end subroutine get_kinetic_energy

! === DEBUG by tkato 2012/11/05 ================================================
  subroutine get_kinetic_energy_directly(nfout)
     integer,intent(in) :: nfout
     integer :: ik,ib,ig,iadd
     real(kind=DP), allocatable, dimension(:)       :: ekin
     real(kind=DP) :: ekinet_tmp,ekinet_mpi
     allocate(ekin(1:maxval(np_g1k(:))));ekin=0.d0
     ekinet = 0.d0
     do ik=1,kv3,af+1
        call m_pwBS_kinetic_energies(ik,vkxyz,ekin)
        if(map_k(ik)/=myrank_k)cycle
        do ib=1,np_e
           ekinet_tmp=0.d0
           if (kimg==1) then
              do ig=ista_g1k(ik), iend_g1k(ik)
                 iadd = ig - ista_g1k(ik) + 1
                 ekinet_tmp = ekinet_tmp+2.d0*ekin(iadd)*zaj_l(iadd,ib,ik,1)**2
              enddo
           else if (kimg==2) then
              do ig=ista_g1k(ik), iend_g1k(ik)
                 iadd = ig - ista_g1k(ik) + 1
                 ekinet_tmp = ekinet_tmp+2.d0*ekin(iadd)*(zaj_l(iadd,ib,ik,1)**2 &
              & +zaj_l(iadd,ib,ik,2)**2)
              enddo
           endif
           if(k_symmetry(ik)==GAMMA) ekinet_tmp = ekinet_tmp*2.d0
           ekinet = ekinet+occup_l(ib,ik)/dble(kv3)*ekinet_tmp
        enddo
     enddo
     if(af==1) ekinet = ekinet*2.d0
     ekinet_mpi = 0.d0
     call mpi_allreduce(ekinet,ekinet_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
     ekinet = ekinet_mpi
     deallocate(ekin)
  end subroutine get_kinetic_energy_directly
! ==============================================================================


  
  subroutine get_xc_and_HE_of_old_CD_paw_sym
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    integer :: iopr,ja
    eohxc_paw = 0.d0
    
    do iopr=1,nopr
    
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle     ! ASMS 2015/02/06
!xocl spread do/ind_katm
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   eohxc_paw = eohxc_paw &
                        & + fac*(dion_hartree(lmt1,lmt2,ia)+ &
                                dion_vxc(lmt1,lmt2,ispin,ja))*hsrt(ja,lmt1,lmt2,ispin)
                end do
!xocl end spread
             end do
          end do
       end do
    end do
    
    end do
    eohxc_paw = eohxc_paw*(af+1)/dble(nopr)
  end subroutine get_xc_and_HE_of_old_CD_paw_sym
  
! ================================= added by K. Tagami ============= 11.0
  subroutine get_xc_HE_old_CD_paw_sym_noncl
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    integer :: iopr,ja
    eohxc_paw = 0.d0
    
    do iopr=1,nopr
    
       do ispin = 1, ndim_magmom
          do it = 1, ntyp
             if(ipaw(it)==0) cycle  

             do lmt1 = 1, ilmt(it)
                il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                do lmt2 = lmt1, ilmt(it)
                   il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                   if( il1 /= il2 .or. im1 /= im2) cycle     !! ASMS 2015/02/06
!xocl spread do/ind_katm
                   do ia = 1, natm
                      if(ityp(ia) /= it) cycle
                      ja=abs(ia2ia_symmtry_op(ia,iopr))
                      fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0

                      if ( ispin==1 ) then
                         eohxc_paw = eohxc_paw &
                              &     + fac *( dion_hartree(lmt1,lmt2,ia) &
                              &             +dion_vxc(lmt1,lmt2,ispin,ja) ) &
                              &           *hsrt(ja,lmt1,lmt2,ispin)
                      else
                         eohxc_paw = eohxc_paw &
                              &     + fac *dion_vxc(lmt1,lmt2,ispin,ja)  &
                              &           *hsrt(ja,lmt1,lmt2,ispin)
                      endif
                   end do
!xocl end spread
                end do
             end do
          end do
       end do
       
    end do
    eohxc_paw = eohxc_paw /dble(nopr)

  end subroutine get_xc_HE_old_CD_paw_sym_noncl
! ============================================================= 11.0

  
  subroutine get_hartree_energy_paw_sym
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    integer :: iopr,ja
    
    ehartr_paw = 0.d0
    
    do iopr=1,nopr
    
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle     !! ASMS 2015/02/06
!xocl spread do/ind_katm
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   ehartr_paw = ehartr_paw &
                        & + fac*dion_hartree_now(lmt1,lmt2,ja)*hsrt(ja,lmt1,lmt2,ispin)
!print *,fac*dion_hartree_now(lmt1,lmt2,ja)*hsr(ja,lmt1,lmt2,ispin)/det,det
                end do
!xocl end spread
             end do
          end do
       end do
    end do
    
    end do
    ehartr_paw = ehartr_paw*(af+1)*0.5d0/dble(nopr)
  end subroutine get_hartree_energy_paw_sym

! ============================== added by K. Tagami ============== 11.0
  subroutine get_hartree_ene_paw_sym_noncl
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    integer :: iopr,ja
    
    ehartr_paw = 0.d0
    
    do iopr=1,nopr
    
       do ispin = 1, 1
          do it = 1, ntyp
             if(ipaw(it)==0) cycle  
             do lmt1 = 1, ilmt(it)
                il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                do lmt2 = lmt1, ilmt(it)
                   il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!!                   if( il1 /= il2 .or. im1 /= im2) cycle      !! ASMS 2015/02/06
!xocl spread do/ind_katm
                   do ia = 1, natm
                      if(ityp(ia) /= it) cycle
                      ja=abs(ia2ia_symmtry_op(ia,iopr))
                      fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                      ehartr_paw = ehartr_paw &
                           & + fac*dion_hartree_now(lmt1,lmt2,ja)*hsrt(ja,lmt1,lmt2,ispin)
                   end do
!xocl end spread
                end do
             end do
          end do
       end do
    
    end do
    ehartr_paw = ehartr_paw*0.5d0/dble(nopr)

  end subroutine get_hartree_ene_paw_sym_noncl
! ================================================================= 11.0

  subroutine get_entropic_term(nfout)
    integer, intent(in) :: nfout
#ifdef __TIMER_SUB__
    call timer_sta(748)
#endif
    eentropy = -width*band_entropy
    if(ipri >= 2) then
       write(nfout,'(" !D EENTROPY = ",f20.14)') eentropy
    endif
#ifdef __TIMER_SUB__
    call timer_end(748)
#endif
  end subroutine get_entropic_term


! ============================ added by K. Tagami ========================= 11.0
  subroutine get_magnetic_constraint_energy
    if ( sw_magnetic_constraint == ON ) then
       call m_ES_calc_MagConstraint_Energy( emag1, emag0 )
    endif
  end subroutine get_magnetic_constraint_energy
! ========================================================================= 11.0


  subroutine sumup_all_energies(nfout,exc,display_on)
    integer, intent(in) :: nfout
    logical, intent(in) :: display_on
    real(kind=DP), intent(in) :: exc
    integer :: i

    real(kind=DP) :: edel
    character(len("potential_mixing")) :: tag_mixing
#ifdef __TIMER_SUB__
    call timer_sta(749)
#endif

! ===== KT_mod ==== 13.0S
!    etotal0 = ekinet+ehartr+exc+elocal+enonlc+eewald-epc
!    if(flg_paw) etotal0=etotal0-eohxc_paw+ehartr_paw+exc_ae-exc_ps
!
    if ( flg_paw ) then
#if 0
       ekin_ion_paw = enonlc -eohxc_paw      !! ??
#else
       eohxc_paw = enonlc -ekin_ion_paw      ! meaningless, this is just for output
#endif
       etotal0 = ekinet +ehartr +exc +elocal +ekin_ion_paw +eewald -epc_paw
       etotal0 = etotal0 +ehartr_paw +exc_ae -exc_ps    
    else
       etotal0 = ekinet+ehartr+exc+elocal+enonlc+eewald-epc
    endif
! ================= 13.0S

! ==== POSITRON SCF == 2015/11/28
    if ( sw_positron /= OFF ) then
       if ( positron_method == Positron_GGGC ) then
          etotal0 = etotal0 +ekin_pztr +elocal_pztr +ecorr_pztr +ehartr_ep
       endif
    endif
! =================== 2015/11/28

    if(sw_dipole_correction == ON) etotal0 = etotal0 + edip
    if(sw_hubbard == ON) etotal0 = etotal0 + ehub0
    if(sw_hybrid_functional == ON) etotal0 = etotal0 + eexx
    if(sw_fef == ON) etotal0 = etotal0 + eplr
    if(ntyp_vdw>0 .or. sw_vdw_correction == ON .and. vdw_method == VDW_DFTD3) etotal0 = etotal0 + evdw
#ifndef DISABLE_VDWDF
    if ( xctype == "vdwdf" ) etotal0 = etotal0 +ecnl_vdwdf
#endif

! =============================== added by K. Tagami =================== 11.0
    if ( sw_magnetic_constraint == ON ) etotal0 = etotal0 + emag0
! ====================================================================== 11.0

! =============================== added by K. Tagami =================== 11.0
!!!#ifdef USE_ESPINORB
!!!#endif
! ====================================================================== 11.0

    if(num_regions>0)then
       do i=1,num_regions
          if(regions(i)%tally) etotal0 = etotal0+regions(i)%energy
       enddo
    endif

    etotal = etotal0+eentropy
    call mpi_bcast(etotal,1 &
         & ,mpi_double_precision,0,mpi_comm_group,ierr)
    if(way_of_smearing == COLD) etotal0 = (2.d0*etotal+etotal0)/3.d0
    if(way_of_smearing == PARABOLIC) etotal0 = (etotal+etotal0)*0.5d0

! =============== KT_add ============================================= 13.0E
    if(way_of_smearing == Fermi_Dirac) etotal0 = (etotal+etotal0)*0.5d0
! ==================================================================== 13.0E

    if(way_of_smearing == MP)  &
    &  etotal0 = (1.d0/(dble(order_mp+2)))*(dble(order_mp+1)*etotal+etotal0)

    if(display_on .and. ipri >= 1) then
       edel = cal_edeltb()
!!$       write(nfout,600) iteration,etotal,etotal
!!$       write(nfout,600) iteration,etotal,edel
       if(number_of_cdmixing_applied<=0)  call m_CtrlP_push_CDMixingNameApplied(" ",1)
       tag_mixing = "Charge-Mixing" ;      if(sw_potential_mixing == ON) tag_mixing = "Potential-Mixing"
       if(number_of_solvers_applied == 1) then
          if(dabs(etotal) <1.e6) then
             write(nfout,91) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
!!$             write(nfout,'(" TOTAL ENERGY FOR",I6," -TH ITER=",F20.12,"  edel = ",D14.6," : SOLVER = ",A, " : ",A," = ",A)') &
!!$                  & iteration, etotal, edel, trim(solver_names_applied(1)), trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e7) then
             write(nfout,92) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e8) then
             write(nfout,93) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e9) then
             write(nfout,94) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e10) then
             write(nfout,95) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e11) then
             write(nfout,96) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e12) then
             write(nfout,97) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e13) then
             write(nfout,98) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else 
             write(nfout,99) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          end if
91        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.12,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
92        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.11,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
93        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.10,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
94        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.9,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
95        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.8,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
96        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.7,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
97        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.6,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
98        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.5,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
99        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',d20.12,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
       else if(number_of_solvers_applied == 2) then
          if(dabs(etotal) <1.e6) then
!!$             write(nfout,'(" TOTAL ENERGY FOR",I6," -TH ITER=",F20.12,"  edel = ",D14.6," : SOLVER = ",A," + ",A," : ",A," = ",A)') &
!!$                  & iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
!!$                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
             write(nfout,81) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e7) then
             write(nfout,82) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e8) then
             write(nfout,83) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e9) then
             write(nfout,84) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) < 1.e10) then
             write(nfout,85) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) < 1.e11) then
             write(nfout,86) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) < 1.e12) then
             write(nfout,87) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) < 1.e13) then
             write(nfout,88) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else
             write(nfout,89) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
!!$          else
!!$#ifdef FORTRAN2008
!!$             write(nfout,'(" TOTAL ENERGY FOR",I6," -TH ITER=",G0,"  edel = ",D14.6," : SOLVER = ",A," + ",A," : ",A," = ",A)') &
!!$#else
!!$             write(nfout,'(" TOTAL ENERGY FOR",I6," -TH ITER=",G20.13,"  edel = ",D14.6," : SOLVER = ",A," + ",A," : ",A," = ",A)') &
!!$#endif
!!$                  & iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
!!$                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          end if
81        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.12,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
82        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.11,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
83        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.10,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
84        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.9,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
85        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.8,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
86        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.7,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
87        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.6,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
88        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.5,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
89        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',d20.12,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
       else
          write(nfout,600) iteration,etotal,edel
!!$          write(nfout,*) " TOTAL ENERGY FOR ",iteration
!!$          call flush(nfout)
!!$          write(nfout,*) " -TH ITER", etotal
!!$          call flush(nfout)
!!$          write(nfout,*) "    edel = ", edel
!!$          call flush(nfout)
!!$          write(nfout,'("  TOTAL ENERGY FOR",i6," -TH ITER=",f20.8,"   edel = ",d14.6)') iteration, etotal, edel
       end if

       if(sw_output_xc_seperately==OFF)then
          if ( flg_paw ) then
             write(nfout,610) ekinet,ehartr,exc,elocal, &
                  &                   enonlc,eewald,-epc_paw,eentropy
          else
             write(nfout,610) ekinet,ehartr,exc,elocal, &
                  &                   enonlc,eewald,-epc,eentropy
          endif
       else
          if ( flg_paw ) then
             write(nfout,615) ekinet,ehartr,eex,ecor,exc,elocal, &
                  &                   enonlc,eewald,-epc_paw,eentropy
          else
             write(nfout,615) ekinet,ehartr,eex,ecor,exc,elocal, &
                  &                   enonlc,eewald,-epc,eentropy
          endif
       endif

       if(sw_dipole_correction == ON) write(nfout,630) evdip,evext,edip
       if(sw_hubbard == ON) write(nfout,640) ehub0,ehub1
       if(sw_hybrid_functional == ON.and.sw_eval_vexx==ON) write(nfout,650) vexx,eexx,eexx-vexx
       if(sw_hybrid_functional == ON.and.sw_eval_vexx==OFF) write(nfout,655) eexx
       if(sw_external_potential==ON) write(nfout,670) eespot
       if(sw_fef == ON) write(nfout,680) eplr
       if(ntyp_vdw>0 .or. sw_vdw_correction == ON .and. vdw_method == VDW_DFTD3) write(nfout,690) evdw
#ifndef DISABLE_VDWDF
       if ( xctype == "vdwdf" .and. ( .not. oneshot ) ) write(nfout,690) ecnl_vdwdf
#endif

       if(way_of_smearing == COLD .or. way_of_smearing == PARABOLIC &
            & .and. abs(eentropy)>=DELTA ) write(nfout,620) etotal0

! =============== KT_add =========================================== 13.0E
       if (way_of_smearing == Fermi_Dirac ) write(nfout,620) etotal0
! ================================================================== 13.0E

       if (way_of_smearing == MP) write(nfout,620) etotal0

! === DEBUG by tkato 2011/10/07 ================================================
!      if(flg_paw) &
!      write(nfout,650) eohxc_paw,ehartr_paw,exc_ae,exc_ps,exc_ae-exc_ps
       if(flg_paw) then
          if(dabs(exc_ae) >1.d6 .or. dabs(exc_ps)>1.d6 )then
             write(nfout,661) eohxc_paw,ehartr_paw,exc_ae,exc_ps,exc_ae-exc_ps
          else
             write(nfout,660) eohxc_paw,ehartr_paw,exc_ae,exc_ps,exc_ae-exc_ps
          end if
       end if
! ==============================================================================

! ====================================== added by K. Tagami =============== 11.0
       if ( sw_magnetic_constraint == ON ) write(nfout,700) emag0, emag1
! ========================================================================= 11.0       

! ====================================== added by K. Tagami =============== 11.0
!!#ifdef USE_ESPINORB
!!!#endif
! ========================================================================= 11.0       

       call flush(nfout)
    end if
#ifdef __TIMER_SUB__
    call timer_end(749)
#endif
600 FORMAT(' ','TOTAL ENERGY FOR',I6,' -TH ITER=',F0.12,2x,' edel = ',D14.6)
610 FORMAT(' KI=',F20.12,' HA=',F20.12,' XC=',F20.12,' LO=',F20.12,/ &
    &      ,' NL=',F20.12,' EW=',F20.12,' PC=',d20.12,' EN=',F20.12)
615 FORMAT(' KI=',F20.12,' HA=',F20.12,' EX=',d20.12,' CR=',F20.12,' XC=',F20.12,' LO=',F20.12,/ &
    &      ,' NL=',F20.12,' EW=',F20.12,' PC=',d20.12,' EN=',F20.12)
620 FORMAT(' ','PHYSICALLY CORRECT ENERGY = ',d20.12)
630 FORMAT(' VD=',F15.7,' VE=',F15.7,' ED=',F15.7)
640 FORMAT(" HE=",F15.7," HP=",F15.7)
650 FORMAT(" VEXX=",F20.12," EEXX=",F20.12," EXX-VEXX=",F20.12)
655 FORMAT(" EXX=",F20.12)
660 FORMAT(' EOHXC_PAW=',F15.7,' HA_PAW=',F15.7,/ &
            ' XC_PAW_AE=',F15.7,' XC_PAW_PS=',F15.7,/ &
            '!XC_PAW_AE-XC_PAW_PS=',F15.7)
661 FORMAT(' EOHXC_PAW=',F15.7,' HA_PAW=',F15.7,/ &
            ' XC_PAW_AE=',d20.8,' XC_PAW_PS=',d20.8,/ &
            '!XC_PAW_AE-XC_PAW_PS=',F15.7)
670 FORMAT(' ES=',F20.12)
680 FORMAT(" EP=",F20.12)
690 FORMAT(" VDW=",F20.12)

! ================================== added by K. Tagami ================== 11.0
700 FORMAT(" Emag0=",F15.7," Emag1=",F15.7)
710 FORMAT(" ESpinOrb_old=",F15.7," ESpinOrb_now=",F15.7)
720 FORMAT(" ESpinOrb=",F15.7)
! ======================================================================== 11.0

  end subroutine sumup_all_energies

  function cal_edeltb() result (res)
    real(kind=DP) :: res
    res = 1e+30
    if(convergence_criteria == DELTA_MOVING_AVERAGE) then
       res = emova-emovaold
    else if (convergence_criteria == DELTA_V )then
       res = m_ESlhxc_delta_vmax() * natm2
    else if (convergence_criteria == SLOPE )then
       res = m_TE_get_slope_of_ehist()
    else
       res = etotal - etoold
    endif
    return
  end function cal_edeltb

  logical function m_TE_is_Divergent_core(nfout)
    integer, intent(in) :: nfout
    integer :: iincre = 0

    if(iteration_electronic == 1) iincre = 0
    !edeltb = etotal - etoold
    edeltb = cal_edeltb()
    if(ipri >= 2) write(nfout,'(" ! edeltb = ",d14.6 &
	& ," hr (= ",d14.6," hr/atom ) ( iter = ",i7," )")') edeltb,edeltb/natm2,iteration

    if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
       m_TE_is_Divergent_core = .false.
       etoold = etotal
       return
    end if
    if(sw_fef == ON)then
       if(printable) write(nfout,'(a,d14.6)') ' !** delta pmac =',sum(pmac-pmac_old)/3.d0
    endif

!!$    if(edeltb > 1.d-1) then
!!$       iincre = iincre + 100
!!$    else if(edeltb > 1.d-2) then
!!$       iincre = iincre + 100
!!$    else if(edeltb >1.d-3) then
!!$       iincre = iincre + 70
!!$    else if(edeltb > 1.d-4) then
!!$       iincre = iincre + 20
!!$    else if(edeltb > 1.d-5) then
!!$       iincre = iincre + 10
!!$    else if(edeltb > 1.d-6) then
!!$       iincre = iincre + 5
!!$    else if(iincre > 0) then
!!$       iincre = iincre - 1
!!$    end if
    if(edeltb > 1.d-7 .and. iincre /= 0 .and. printable) &
         &    write(nfout,*) ' !W IINCRE is increasing as ', iincre
    if(iincre > IINCRE_CRITICAL) then
       if(printable) write(nfout,*)  ' !S IINCRE exceeds ',IINCRE_CRITICAL,'!'
       m_TE_is_Divergent_core = .true.
    else
       m_TE_is_Divergent_core = .false.
    end if
    etoold = etotal
  end function m_TE_is_Divergent_core

  subroutine m_TE_set_etotal_old
    etoold = 0.d0
  end subroutine m_TE_set_etotal_old

! --> T. Yamasaki 08 Aug. 2009 
  real(kind=DP) function m_TE_edeltb()
    m_TE_edeltb = edeltb
  end function m_TE_edeltb
! <--
  logical function m_TE_is_converged(nfout)
    integer, intent(in) :: nfout
    integer   :: ncnv
    real(kind=DP) :: edelta

    call m_CtrlP_get_edelta(edelta)

    if(dabs(edeltb) < edelta*natm2 .and. m_ES_eekdif_cond()) then
       ncnv = m_CtrlP_ntcnvg_incre()
       if(printable .and. ipri>0) write(nfout,'(" edeltb = ",d12.4, " edelta = ",d12.4 &
            & , " ntcnvg = ",i7)') edeltb, edelta, ncnv
! --> T. Yamasaki, 25 July 2008
    else if(sub_delta_factor_is_given .and. dabs(edeltb) <edelta*sub_delta_factor*natm2) then
       ncnv = m_CtrlP_sub_ntcnvg_incre()
       if(printable .and. ipri>0) write(nfout,'(" edeltb = ",d12.4, " sub_edelta = ",d12.4 &
            & , " sub_ntcnvg = ",i7)') edeltb, edelta*sub_delta_factor, ncnv
    else
! <--
       call m_CtrlP_ntcnvg_reset()! k .Mae 030808	
    end if
    m_TE_is_converged = m_CtrlP_ntcnvg_clear()
    if(m_TE_is_converged) call m_CtrlP_ntcnvg_reset()
  end function m_TE_is_converged

  function m_TE_tell_total_energy()
    real(kind=DP)::  m_TE_tell_total_energy
    m_TE_tell_total_energy = etotal
  end function m_TE_tell_total_energy

  function m_TE_tell_total_energy0()
    real(kind=DP)::  m_TE_tell_total_energy0
    m_TE_tell_total_energy0 = etotal0
  end function m_TE_tell_total_energy0

!!$! --> T. Yamasaki 17th Aug. 2009
!!$  function m_TE_tell_total_energy_mdfy()
!!$    real(kind=DP)::  m_TE_tell_total_energy_mdfy
!!$    if(sw_hubbard == ON) then
!!$       m_TE_tell_total_energy_mdfy = etotal - ehub0*0.5d0
!!$    else
!!$       m_TE_tell_total_energy_mdfy = etotal
!!$    end if
!!$  end function m_TE_tell_total_energy_mdfy
!!$! <--

  function m_TE_tell_band_energy(nfout,kv3)
    real(kind=DP)::  m_TE_tell_band_energy
    integer, intent(in) :: nfout,kv3
    integer :: ib, ik

! ============================== modified by K. Tagami ================== 11.0
!    call sum_eigenvalues(kv3)
!
    if ( noncol ) then
    else
      call sum_eigenvalues(kv3)
    endif
! ======================================================================= 11.0

    m_TE_tell_band_energy = eband
    if(ipri >= 2) then
       if(map_k(ik) == myrank_k) then
          write(nfout,'(" -- sum_eigenvalues (m_TE_tell_band_energy) --")')
          write(nfout,'("   -- num_extra_bands = ",i8)') num_extra_bands

! ========================================= modified by K. Tagami ======= 11.0
!          do ik = 1, kv3
          do ik = 1, kv3, ndim_spinor
! ====================================================================== 11.0

             write(nfout,'("  ik = ",i5)') ik
             write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
          end do
       end if
    endif
  end function m_TE_tell_band_energy

  function m_TE_tell_extended_band_energy(nfout,kv3)
    real(kind=DP)::  m_TE_tell_extended_band_energy
    integer, intent(in) :: nfout,kv3
    integer :: ib, ik

! ============================== modified by K. Tagami ================== 11.0
!    call sum_wholeeigenvalues(nfout,kv3)
!
    if ( noncol ) then
    else
      call sum_wholeeigenvalues(nfout,kv3)
    endif
! ======================================================================= 11.0

    m_TE_tell_extended_band_energy = eband_extendedrange
    if(ipri >= 2) then
       if(map_k(ik) == myrank_k) then
          write(nfout,'(" -- sum_eigenvalues (m_TE_tell_band_energy) --")')
          write(nfout,'("   -- num_conduction_bands_lmm = ",i8)') num_conduction_bands_lmm
! ========================================= modified by K. Tagami ======= 11.0
!          do ik = 1, kv3
          do ik = 1, kv3, ndim_spinor
! ======================================================================= 11.0

             write(nfout,'("  ik = ",i5)') ik
             write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
          end do
       end if
    endif
  end function m_TE_tell_extended_band_energy


  subroutine m_TE_wd_total_energy(nfcntn)
    integer, intent(in) :: nfcntn
    !!$ print *,' tag_total_energy'
    if(mype==0) then
       write(nfcntn,*) tag_total_energy
       write(nfcntn,'(2d24.16)') etotal, etoold
       !edeltb = etotal - etoold
       !edeltb = cal_edeltb()
    endif
  end subroutine m_TE_wd_total_energy

  subroutine m_TE_rd_total_energy(nfcntn)
    integer, intent(in) :: nfcntn
    logical             :: EOF_reach, tag_is_found

    if(mype==0) then
       call rewind_to_tag0(nfcntn,len_tag_total_energy,tag_total_energy &
            &, EOF_reach, tag_is_found,str,len_str)
       if(.not.tag_is_found) then
          call phase_error_with_msg(6,' tag_total_energy is not found',__LINE__,__FILE__)
       else
          read(nfcntn,*) etotal, etoold
          etoold = etotal
       end if
    endif
    call mpi_bcast(etotal,1 &
         & ,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(etoold,1 &
         & ,mpi_double_precision,0,mpi_comm_group,ierr)
  end subroutine m_TE_rd_total_energy

  logical function m_TE_Converged_Hubbard_Energy(nfout)
    integer, intent(in) :: nfout

    m_TE_Converged_Hubbard_Energy = .false.
    !!$if(ehub0 <= critical_ehub) then
    !!$   m_TE_Converged_Hubbard_Energy = .true.
    !!$   write(nfout,'(" Interation will be stoped &
    !!$   &because Hubbard energy is lower than ",f10.5,".")') critical_ehub
    !!$end if

    if(abs(ehub0-ehub0_old) <= delta_ehub) then
       m_TE_Converged_Hubbard_Energy = .true.
       write(nfout,'(" Interation will be stoped &
       &because Hubbard energy is converged within ",f10.5,".")') delta_ehub
    else
       ehub0_old = ehub0
    end if

  end function m_TE_Converged_Hubbard_Energy

!===============================================================================
!!$  subroutine m_TE_total_energy_3D(nfout,display_on,kv3)
  subroutine m_TE_total_energy(nfout,display_on,kv3)
    use m_XC_Potential,         only : m_XC_cal_potential_3D
    use m_XC_Potential_2D,         only : m_XC_cal_potential
#if 0
    use m_Control_Parameters,   only : sw_distribute_wf,force_exx_energy1
#else
    use m_Control_Parameters,   only : force_exx_energy1
#endif
    integer, intent(in) :: nfout
    logical, intent(in) :: display_on
    integer, intent(in) :: kv3
    real(kind=DP) :: edeltb_now
    real(kind=DP),allocatable,dimension(:) :: ehistmp
    integer :: isolver,sw_submat
    integer :: ih,it
    integer             :: id_sname = -1   , i
    if(sw_harris_functional == OFF)then
      chgqt => chgq_l
      chgqto => chgqo_l
      hsrt => hsr
      if(noncol) hsit => hsi
    else
      chgqt => chgqo_l
      chgqto => chgqo_l
      hsrt => hsro
      if(noncol) hsit => hsi
    endif
#ifdef __TIMER_SUB__
    call timer_sta(739)
#endif
    call tstatc0_begin('Total_Energy(including xc_pot) ',id_sname)
    call get_band_energy_3D(kv3)
    call get_xc_and_HE_of_old_CD_3D(vxc_l)
    call get_local_potential_energy_3D
    call get_hubbard_energy_3D(nfout)
    call get_nonlocal_potential_energy_3D
! === DEBUG by tkato 2012/11/07 ================================================
#if 1
    if(in_line_minimization) then
       call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge, chgqt, EXC_ONLY)
    else
       call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge, chgqt, VXC_AND_EXC)
    endif
#else
    if(in_line_minimization) then
       call m_XC_cal_potential(nfout,Valence_plus_PC_Charge, chgqt, EXC_ONLY)
    else
       call m_XC_cal_potential(nfout,Valence_plus_PC_Charge, chgqt, VXC_AND_EXC)
    endif
#endif
! ==============================================================================
#ifdef ENABLE_ESM_PACK
    if(sw_esm==OFF)then
       call get_hartree_energy_3D
    endif
#else
    call get_hartree_energy_3D
#endif
    if(sw_dipole_correction ==  ON) then
       call get_dipole_energy_3D(vdip_l,vext_l)
    end if
    if(sw_fef == ON) then
       call m_FEF_polarization(nfout,eplr)
    endif
! === Support Hybrid on 3D_Parallel by tkato 2013/02/10 ========================
    if(sw_hybrid_functional == ON) then
       if(sw_eval_vexx==ON) call m_ES_EXX_energy(vexx)
       if(icond == INITIAL .or. icond == CONTINUATION .or. icond == COORDINATE_CONTINUATION .or. &
       & ((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION)&
       &                             .and. ekmode == OFF)   ) then
          edeltb_now = m_TE_what_is_edeltb_now()/natm2
!!$     write(nfout,'(" edeltb_per_atom = ", d20.12)') edeltb_per_atom
       else
          edeltb_now = m_ES_what_is_evdff_now()
       end if
       !isolver = m_CtrlP_solver_for_WFs_now(iteration_electronic,iteration_ionic,0 &
       !&                              ,edeltb_now,sw_submat)
       isolver = m_CtrlP_get_isolver_now()
       if(sw_retard_eigval_evaluation==OFF.or.isolver==MDDAVIDSON.or.isolver==MDKOSUGI.or.force_exx_energy1) then
#if 0
          if(sw_distribute_wf==ON)then
             call m_ES_EXX_gather_valence_states_k(nfout)
          else
             call m_ES_EXX_gather_valence_states(nfout)
          endif
#else
          call m_ES_EXX_gather_valence_states(nfout)
#endif

          call m_ES_EXX_energy(eexx)
       else
          call m_ES_EXX_energy2(eexx)
       endif
    end if
    force_exx_energy1 = .false.

    if ( sw_magnetic_constraint == ON ) call get_magnetic_constraint_energy

    call get_entropic_term(nfout)
    if(flg_paw) then
       call m_PAW_XC_allocation(nfout)
#if 0
        call get_xc_and_HE_of_old_CD_paw_3D
#endif
! === DEBUG by tkato 2011/10/04 ================================================
!       call m_PAW_XC_cal_potential(nfout,EXC_ONLY,flg_symmtry)
        if(calcSphericalHarmonicsExpansion) then
           call m_PAW_XC_cal_potential_sphex2(nfout,EXC_ONLY)
        end if
        if(calcGaussLegendreIntegration)then
           call m_PAW_XC_cal_potential(nfout,EXC_ONLY,flg_symmtry)
        endif
! ==============================================================================
        call m_PAWH_get_dion_hartree_now(nfout)
        call get_hartree_energy_paw_3D
#if 1
        call get_kinetic_local_energy_paw(nfout)
#endif        
       call m_PAW_XC_deallocation(nfout)
    end if
! ==============================================================================
! === DEBUG by tkato 2012/11/05 ================================================
!   call get_kinetic_energy(nfout)
#ifdef ENABLE_ESM_PACK
    if ( sw_esm==ON .or. sw_hybrid_functional==ON .or. sw_communicator_for_chg==ON &
         &          .or. xctype=='vdwdf' .or. use_metagga ) then
       call get_kinetic_energy_directly(nfout)
    else
       if(iteration_electronic == 1) then
          call get_kinetic_energy_directly(nfout)
       else
          call get_kinetic_energy(nfout)
       end if
    endif
#else
    if ( sw_hybrid_functional==ON .or. iteration_electronic==1 &
         &       .or. xctype=='vdwdf' .or. use_metagga ) then
       call get_kinetic_energy_directly(nfout)
    else
       call get_kinetic_energy(nfout)
    endif
#endif
! ==============================================================================
    call sumup_all_energies(nfout,exc,display_on)
    if(convergence_criteria == DELTA_MOVING_AVERAGE .or. convergence_criteria == SLOPE)then
      if(iteration_electronic == 1)then
        if(.not.allocated(ehist)) then
          allocate(ehist(nsamp))
        endif
        ehist = 0.d0
        emova = 0.d0
        ihist = 0
      endif
      if(iteration_electronic<=nsamp) then
        ihist = ihist + 1
        ehist(ihist) = etotal
      else
        allocate(ehistmp(nsamp));ehistmp=ehist
        do ih = 2,nsamp
           ehist(ih-1) = ehistmp(ih)
        enddo
        ehist(nsamp) = etotal
        deallocate(ehistmp)
      endif
      call cal_moving_average()
      if(printable .and. ipri>=2)then
        write(nfout,'(a,3f20.10,i10)') '!** moving average (curr step, last step, delta/natm, ihist)',&
           & emova,emovaold,(emova-emovaold)/real(natm2),ihist
        write(nfout,'(a,10f20.10)') '!** ehist ',(ehist(it),it=1,10)
        write(nfout,'(a,f20.10)')   '!** slope ',m_TE_get_slope_of_ehist()
      endif
    endif
    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
    call timer_end(739)
#endif
  end subroutine m_TE_total_energy

  subroutine cal_moving_average()
    real(kind=DP) :: sume
    integer :: ii
    sume = 0.d0
    do ii=1,ihist 
       sume = sume + ehist(ii)
    enddo
    emovaold = emova
    emova = sume/real(ihist)
  end subroutine cal_moving_average

  function m_TE_get_slope_of_ehist() result(res)
    integer :: ii
    real(kind=DP) :: res
    real(kind=DP) :: sx,sy,sxx,sxy,syy
    sx=0.d0;sy=0.d0;sxx=0.d0;sxy=0.d0;syy=0.d0
    if(ihist == 1) then
       res = ehist(1)
       return
    endif
    do ii=1,ihist
       sx = sx + real(ii)
       sy = sy + ehist(ii)
       sxx = sxx + real(ii)*real(ii)
       sxy = sxy + ehist(ii)*real(ii)
       syy = ehist(ii)*ehist(ii)
    enddo
    res = (ihist*sxy-sx*sy)/(ihist*sxx-sx*sx)
  end function m_TE_get_slope_of_ehist

  function m_TE_get_moving_average() result(res)
    real(kind=DP) :: res
    res = emova
    return
  end function m_TE_get_moving_average

  function m_TE_get_moving_average_old() result(res)
    real(kind=DP) :: res
    res = emovaold
    return
  end function m_TE_get_moving_average_old

!===============================================================================
  subroutine get_band_energy_3D(kv3)
    use m_Parallelization,      only : mpi_kg_world
! === DEBUG by tkato 2012/04/04 ================================================
    use m_Parallelization,      only : mpi_ge_world, nrank_k
! ==============================================================================

    integer, intent(in) :: kv3
    integer             :: ib, ik
    real(kind=DP)       :: eband_mpi   ! MPI
#ifdef __TIMER_SUB__
    call timer_sta(740)
#endif
    eband = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(863)
#endif
    do ik =1, kv3, af+1
       if(map_k(ik) /= myrank_k) cycle ! MPI
       do ib = 1, np_e                 ! MPI
          eband = eband + occup_l(ib,ik)*eko_l(ib,ik)
       end do
    end do
#ifdef __TIMER_DO__
  call timer_end(863)
#endif

    if(nrank_e > 1) then
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_kg_world)
  call timer_sta(864)
#endif
       call mpi_allreduce(eband,eband_mpi,1,mpi_double_precision,mpi_sum,mpi_kg_world,ierr) !MPI
#ifdef __TIMER_COMM__
  call timer_end(864)
#endif
       eband = eband_mpi
    end if
! === DEBUG by tkato 2012/04/04 ================================================
    if(nrank_k > 1) then
       call mpi_allreduce(eband,eband_mpi,1,mpi_double_precision,mpi_sum,mpi_ge_world,ierr) !MPI
       eband = eband_mpi
    end if
! ==============================================================================
    eband = 2*eband/kv3 * (af+1)
#ifdef __TIMER_SUB__
    call timer_end(740)
#endif
  end subroutine get_band_energy_3D

!===============================================================================
  subroutine get_xc_and_HE_of_old_CD_3D(vxc_l)
    use m_Parallelization,     only : mpi_ke_world, mpi_kg_world, mpi_chg_world

    real(kind=DP), intent(in) :: vxc_l(ista_kngp:iend_kngp,kimg,nspin)
    integer ik, i, ispin
    integer ist !mpi
    real(kind=DP) :: eohxc_mpi

#ifdef __TIMER_SUB__
    call timer_sta(741)
#endif
    eohxc = 0.d0
    do ik = 1, kimg
#ifdef __TIMER_DO__
  call timer_sta(865)
#endif
       do ispin = 1, nspin
          if(sw_communicator_for_chg == OFF)then
             if(myrank_g==0) then
                eohxc = eohxc + vxc_l(1,ik,ispin)*chgqt(1,ik,ispin)
             endif
          else
             if(mype==0) then
                eohxc = eohxc + vxc_l(1,ik,ispin)*chgqt(1,ik,ispin)
             endif
          endif
       end do
#ifdef __TIMER_DO__
  call timer_end(865)
#endif
       ist = ista_kngp
       if(ist == 1) ist = 2

#ifdef __TIMER_DO__
  call timer_sta(866)
#endif
       if(nspin == 1) then
          do i = ist, iend_kngp  !for mpi
             eohxc = eohxc &
                  & + (vxc_l(i,ik,1)+PAI4*chgqto(i,ik,1)/gr_l(i)**2) &
                  &   * chgqt(i,ik,1)
          end do
       else if(nspin == 2) then
          do i = ist, iend_kngp  !for mpi
             eohxc = eohxc &
                  & +  (vxc_l(i,ik,UP)*chgqt(i,ik,UP)&
                  &   + vxc_l(i,ik,DOWN)*chgqt(i,ik,DOWN)) &
                  & + PAI4*(chgqto(i,ik,UP)+chgqto(i,ik,DOWN))&
                  & /gr_l(i)**2 &
                  &  *(chgqt(i,ik,UP)+chgqt(i,ik,DOWN))
          end do
       end if
#ifdef __TIMER_DO__
  call timer_end(866)
#endif
    end do
    if(nrank_chg > 1) then
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_chg_world)
  call timer_sta(867)
#endif
       call mpi_allreduce(eohxc,eohxc_mpi,1,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
#ifdef __TIMER_COMM__
  call timer_end(867)
#endif
       eohxc = eohxc_mpi
    end if

    eohxc = univol*eohxc
#ifdef __TIMER_SUB__
    call timer_end(741)
#endif
  end subroutine get_xc_and_HE_of_old_CD_3D

!===============================================================================
  subroutine get_local_potential_energy_3D
    use m_Parallelization,     only : mpi_ke_world, mpi_chg_world

    integer       :: ik, it, i, ig
    real(kind=DP) :: eloca1_mpi
    real(kind=DP) :: eloclr,eloclr_mpi

#ifdef __TIMER_SUB__
    call timer_sta(742)
#endif
    eloca1 = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(868)
#endif
    do ik = 1, kimg
       if(nspin == 1) then
!OCL NOFLTLD
          do it = 1,ntyp
             do i = ista_kngp, iend_kngp !for mpi
                eloca1 = eloca1 &
                     & + psc_l(i,it)*zfm3_l(i,it,ik)*chgqt(i,ik,1)
             end do
          end do
       else
!OCL NOFLTLD
          do it = 1, ntyp
             do i = ista_kngp, iend_kngp  !for mpi
                eloca1 = eloca1 &
                     &   + psc_l(i,it)*zfm3_l(i,it,ik)&
                     &             *(chgqt(i,ik,UP)+chgqt(i,ik,DOWN))
             end do
          end do
       endif
    end do
#ifdef __TIMER_DO__
  call timer_end(868)
#endif
    if(nrank_chg > 1) then
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_chg_world)
  call timer_sta(869)
#endif
       call mpi_allreduce(eloca1,eloca1_mpi,1,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
#ifdef __TIMER_COMM__
  call timer_end(869)
#endif
       eloca1 = eloca1_mpi
    end if

    eloca1    = univol*eloca1
#ifdef ENABLE_ESM_PACK
    if(sw_esm==OFF) then
       elocal    = eloca1 + etot1*totch
    else
       elocal = eloca1
    endif
#else
    elocal    = eloca1 + etot1*totch
#endif

#ifdef ENABLE_ESM_PACK
    if(sw_esm==ON)then
!add the long-range part
      eloclr=0.d0
      if(nspin.eq.1)then
        if(kimg==2)then
          do ig=ista_kngp,iend_kngp
            eloclr=eloclr+dble(vloc_esm(igfp_l(ig)))*chgqt(ig,1,1)+aimag(vloc_esm(igfp_l(ig)))*chgqt(ig,2,1)
          enddo
        else if(kimg==1)then
          do ig=ista_kngp,iend_kngp
            eloclr=eloclr+dble(vloc_esm(igfp_l(ig)))*chgqt(ig,1,1)
          enddo
        endif
      else
        if(kimg==2)then
          do ig=ista_kngp,iend_kngp
            eloclr=eloclr+dble(vloc_esm(igfp_l(ig))) &
   &                     *(chgqt(ig,1,1)+chgqt(ig,1,2)) &
   &                     +aimag(vloc_esm(igfp_l(ig))) &
   &                     *(chgqt(ig,2,1)+chgqt(ig,2,2))
          enddo                                           
        else if(kimg==1)then
          do ig=ista_kngp,iend_kngp
            eloclr=eloclr+dble(vloc_esm(igfp_l(ig))) &
   &                     *(chgqt(ig,1,1)+chgqt(ig,1,2))
          enddo                                           
        endif
      endif
      eloclr_mpi=0.d0
      call mpi_allreduce(eloclr,eloclr_mpi,1,&
      & mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
      eloclr = eloclr_mpi
      eloclr = univol*eloclr
      elocal = elocal + eloclr
    endif
#endif

#ifdef __TIMER_SUB__
    call timer_end(742)
#endif
  end subroutine get_local_potential_energy_3D

!===============================================================================
  subroutine get_hubbard_energy_3D(nfout)
    integer, intent(in) :: nfout
#ifdef __TIMER_SUB__
    call timer_sta(743)
#endif
    ehub0 = 0.d0
    ehub1 = 0.d0
    if(sw_hubbard==ON) then
      call m_Hubbard_energy(ehub0)
      call get_hubbard_potential_energy_3D(ehub1)
    end if
    if(ipri >= 2) then
       write(nfout,'(" !D EHUB0 = ",f20.14)') ehub0
       write(nfout,'(" !D EHUB1 = ",f20.14)') ehub1
    endif
#ifdef __TIMER_SUB__
    call timer_end(743)
#endif
  end subroutine get_hubbard_energy_3D

!===============================================================================
  subroutine get_hubbard_potential_energy_3D(ehub1)
    use m_Parallelization,     only : mpi_ke_world, mpi_chg_world
    real(kind=DP), intent(out) :: ehub1
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer :: ih, l1p, ierr
    real(kind=DP) :: fac, mpi
    ehub1 = 0.d0
    do ispin = 1, nspin, af+1
       do ia = ista_atm, iend_atm
          ih = ihubbard(ia)
          if(ih == 0) cycle
          it = ityp(ia)
          l1p = proj_attribute(ih)%l+1
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             if(il1 /= l1p) cycle
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                if(il2 /= l1p) cycle
                !!$if(im1 /= im2) cycle
                fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                ehub1 = ehub1 &
                      & + fac*dhub(lmt1,lmt2,ia,ispin)*hsrt(ia,lmt1,lmt2,ispin)
             end do
          end do
       end do
    end do
    if(nrank_chg > 1) then
       call mpi_allreduce(ehub1,mpi,1,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
       ehub1 = mpi
    end if
    ehub1 = ehub1*(af+1)
  end subroutine get_hubbard_potential_energy_3D

!===============================================================================
  subroutine get_nonlocal_potential_energy_3D
    use m_Parallelization,     only : mpi_ke_world, mpi_chg_world

    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia, ierr
    real(kind=DP) :: fac, mpi
#ifdef __TIMER_SUB__
    call timer_sta(744)
#endif
    enonlc = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(870)
#endif
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) then   
              do lmt1 = 1, ilmt(it)
                 il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                 do lmt2 = lmt1, ilmt(it)
                    il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                    if( il1 /= il2 .or. im1 /= im2) cycle
    !xocl spread do/ind_katm
                    do ia = ista_atm, iend_atm
                       if(ityp(ia) /= it) cycle
                       fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                       enonlc = enonlc &
                            & + fac*dion(lmt1,lmt2,it)*hsrt(ia,lmt1,lmt2,ispin)
                    end do
    !xocl end spread
                 end do
              end do
          else 
              do lmt1 = 1, ilmt(it)
                 do lmt2 = lmt1, ilmt(it)
    !xocl spread do/ind_katm
                    do ia = ista_atm, iend_atm
                       if(ityp(ia) /= it) cycle
                       fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                       enonlc = enonlc &
                            & + fac*dion_paw(lmt1,lmt2,ispin,ia)*hsrt(ia,lmt1,lmt2,ispin)
                    end do
    !xocl end spread
                 end do
              end do
          end if
       end do
    end do
#ifdef __TIMER_DO__
  call timer_end(870)
#endif
    if(nrank_g > 1) then
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_ke_world)
  call timer_sta(871)
#endif
       call mpi_allreduce(enonlc,mpi,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
#ifdef __TIMER_COMM__
  call timer_end(871)
#endif
       enonlc = mpi
    end if
    enonlc = enonlc*(af+1)
    !!$if(sw_hubbard==ON) enonlc = enonlc - ehub1
#ifdef __TIMER_SUB__
    call timer_end(744)
#endif
  end subroutine get_nonlocal_potential_energy_3D
!===============================================================================

  subroutine get_hartree_energy_3D
    use m_Parallelization,     only : mpi_ke_world, mpi_chg_world

    integer ik, i
    integer :: ist !mpi
    real(kind=DP) :: ehartr_mpi

#ifdef __TIMER_SUB__
    call timer_sta(745)
#endif
    ehartr_mpi = 0.d0
    ehartr = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(872)
#endif
    do ik = 1, kimg
       ist = ista_kngp
       if(ist == 1) ist = 2

       if(nspin == 1) then
          do i = ist, iend_kngp !for mpi
             ehartr_mpi  = ehartr_mpi + (chgqt(i,ik,1)/gr_l(i))**2
          end do
       else if(nspin == 2) then
          do i = ist, iend_kngp  !for mpi
             ehartr_mpi  = ehartr_mpi &
                  &  +((chgqt(i,ik,UP)+chgqt(i,ik,DOWN))/gr_l(i))**2
          end do
       end if
    end do
#ifdef __TIMER_DO__
  call timer_end(872)
#endif
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_chg_world)
  call timer_sta(873)
#endif
    call mpi_allreduce(ehartr_mpi,ehartr,1,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
#ifdef __TIMER_COMM__
  call timer_end(873)
#endif
    ehartr    = univol*PAI4*ehartr*0.5d0
#ifdef __TIMER_SUB__
    call timer_end(745)
#endif
  end subroutine get_hartree_energy_3D
!===============================================================================

  subroutine get_dipole_energy_3D(vdip_l,vext_l)
    use m_Parallelization,     only : mpi_ke_world, mpi_chg_world

    real(kind=DP), intent(in) :: vdip_l(ista_kngp:iend_kngp,kimg)
    real(kind=DP), intent(in) :: vext_l(ista_kngp:iend_kngp,kimg)
    integer ik, i, ispin, ierr
    integer ist !mpi
    real(kind=DP) :: evdip_mpi
    real(kind=DP) :: evext_mpi
#ifdef __TIMER_SUB__
    call timer_sta(746)
#endif

    evdip = 0.d0
    evext = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(874)
#endif
    do ik = 1, kimg
       do ispin = 1, nspin
          if(sw_communicator_for_chg == OFF)then
             if(myrank_g==0) then
                evdip = evdip + vdip_l(1,ik)*chgqt(1,ik,ispin)
                evext = evext + vext_l(1,ik)*chgqt(1,ik,ispin)
             endif
          else
             if(mype==0) then
                evdip = evdip + vdip_l(1,ik)*chgqt(1,ik,ispin)
                evext = evext + vext_l(1,ik)*chgqt(1,ik,ispin)
             endif
          endif
       end do
       ist = ista_kngp
       if(ist == 1) ist = 2

       if(nspin == 1) then
          do i = ist, iend_kngp  !for mpi
             evdip = evdip + vdip_l(i,ik)*chgqt(i,ik,1)
             evext = evext + vext_l(i,ik)*chgqt(i,ik,1)
          end do
       else if(nspin == 2) then
          do i = ist, iend_kngp  !for mpi
             evdip = evdip + vdip_l(i,ik)*(chgqt(i,ik,UP)+chgqt(i,ik,DOWN))
             evext = evext + vext_l(i,ik)*(chgqt(i,ik,UP)+chgqt(i,ik,DOWN))
          end do
       end if
    end do
#ifdef __TIMER_DO__
  call timer_end(874)
#endif
    if(nrank_chg > 1) then
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_chg_world)
  call timer_sta(875)
#endif
       call mpi_allreduce(evdip,evdip_mpi,1,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
#ifdef __TIMER_COMM__
  call timer_end(875)
#endif
       evdip =evdip_mpi
    end if
    evdip = evdip * univol
    evext = evext * univol
    edip = edip_ion + eext_ion + evdip*0.5d0 + evext
#ifdef __TIMER_SUB__
    call timer_end(746)
#endif
  end subroutine get_dipole_energy_3D
!===============================================================================

  subroutine get_xc_and_HE_of_old_CD_paw_3D
    use m_Parallelization,     only :mpi_ke_world

    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia, ierr
    real(kind=DP) :: fac,mpi
    eohxc_paw = 0.d0
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
! === DEBUG by tkato 2012/11/08 ================================================
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
! ==============================================================================
             do lmt2 = lmt1, ilmt(it)
! === DEBUG by tkato 2012/11/08 ================================================
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle      !! ASMS 2015/02/06
! ==============================================================================
!xocl spread do/ind_katm
                do ia = ista_atm,iend_atm
                   if(ityp(ia) /= it) cycle
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   eohxc_paw = eohxc_paw &
                        & + fac*(dion_hartree(lmt1,lmt2,ia)+ &
                                dion_vxc(lmt1,lmt2,ispin,ia))*hsrt(ia,lmt1,lmt2,ispin)
                end do
!xocl end spread
             end do
          end do
       end do
    end do
    if(nrank_g > 1) then
       call mpi_allreduce(eohxc_paw,mpi,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       eohxc_paw = mpi
    end if
    eohxc_paw = eohxc_paw*(af+1)
  end subroutine get_xc_and_HE_of_old_CD_paw_3D
!===============================================================================

  subroutine get_hartree_energy_paw_3D
    use m_Parallelization,     only :mpi_ke_world
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia, ierr
    real(kind=DP) :: fac, mpi
    
    ehartr_paw = 0.d0
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
! === DEBUG by tkato 2012/11/07 ================================================
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
! ==============================================================================
             do lmt2 = lmt1, ilmt(it)
! === DEBUG by tkato 2012/11/07 ================================================
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle    !! ASMS 2015/02/06
! ==============================================================================
!xocl spread do/ind_katm
                do ia = ista_atm, iend_atm
                   if(ityp(ia) /= it) cycle
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   ehartr_paw = ehartr_paw &
                        & + fac*dion_hartree_now(lmt1,lmt2,ia)*hsrt(ia,lmt1,lmt2,ispin)
                end do
!xocl end spread
             end do
          end do
       end do
    end do
    if(nrank_g > 1) then
       call mpi_allreduce(ehartr_paw,mpi,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       ehartr_paw = mpi
    end if
    ehartr_paw = ehartr_paw*(af+1)*0.5d0
  end subroutine get_hartree_energy_paw_3D
!===============================================================================

!!$  function m_TE_tell_band_energy_3D(nfout,kv3)
!!$    real(kind=DP)::  m_TE_tell_band_energy_3D
!!$    integer, intent(in) :: nfout,kv3
!!$    integer :: ib, ik
!!$    call sum_eigenvalues_3D(kv3)
!!$    m_TE_tell_band_energy_3D = eband
!!$    if(ipri >= 2) then
!!$       if(map_k(ik) == myrank_k) then
!!$          write(nfout,'(" -- sum_eigenvalues (m_TE_tell_band_energy) --")')
!!$          write(nfout,'("   -- num_extra_bands = ",i8)') num_extra_bands
!!$          do ik = 1, kv3
!!$             write(nfout,'("  ik = ",i5)') ik
!!$             write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
!!$          end do
!!$       end if
!!$    endif
!!$  end function m_TE_tell_band_energy_3D

!!$  function m_TE_tell_extended_band_energy_3D(nfout,kv3)
!!$    real(kind=DP)::  m_TE_tell_extended_band_energy_3D
!!$    integer, intent(in) :: nfout,kv3
!!$    integer :: ib, ik
!!$    call sum_wholeeigenvalues_3D(nfout,kv3)
!!$    m_TE_tell_extended_band_energy_3D = eband_extendedrange
!!$    if(ipri >= 2) then
!!$       if(map_k(ik) == myrank_k) then
!!$          write(nfout,'(" -- sum_eigenvalues (m_TE_tell_band_energy) --")')
!!$          write(nfout,'("   -- num_conduction_bands_lmm = ",i8)') num_conduction_bands_lmm
!!$          do ik = 1, kv3
!!$             write(nfout,'("  ik = ",i5)') ik
!!$             write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
!!$          end do
!!$       end if
!!$    endif
!!$  end function m_TE_tell_extended_band_energy_3D

  subroutine sum_eigenvalues(kv3)
   use m_Parallelization,     only : neg_g                   &
  &                                , mpi_kg_world
    integer, intent(in) :: kv3
    integer             :: ib, ik
    eband = 0.d0
    do ik =1, kv3, af+1
       if(map_k(ik) /= myrank_k) cycle
       do ib = 1, np_e
          if(neg_g(ib) > neg - num_extra_bands) cycle
          eband = eband + eko_l(ib,ik)*occup_l(ib,ik)
       end do
    end do
    call mpi_allreduce(MPI_IN_PLACE,eband,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    eband = 2*eband/kv3 * (af+1)
  end subroutine sum_eigenvalues

  subroutine sum_wholeeigenvalues(nfout,kv3)
   use m_Parallelization,     only : neg_g                   &
  &                                , mpi_kg_world
    integer, intent(in) :: nfout,kv3
    integer             :: ib, ik
    real(kind=DP)       :: eband_mpi   ! MPI
    integer             :: iband
    real(kind=DP)       :: weight, weight0

    if(num_conduction_bands_lmm < 0) then
       iband = neg
    else
       iband = ceiling(totch/2.0) + num_conduction_bands_lmm
    end if
    if(iband > neg - num_extra_bands) iband = neg - num_extra_bands
    eband_extendedrange = 0.d0
    weight = 0.d0; weight0 = 0.d0
    do ik =1, kv3, af+1
       weight = weight + qwgt(ik)
       if(map_k(ik) /= myrank_k) cycle ! MPI
       do ib = 1, np_e                 ! MPI
          if(ik==1 .and. ib == 1) weight0 = weight0 + occup_l(1,ik)
!!$          if(nrvf_ordr(ib,ik) > neg - num_extra_bands) cycle
!!$       if(nrvf_ordr(ib,ik) > iband) cycle
          if(neg_g(ib) > iband) cycle
          eband_extendedrange = eband_extendedrange + eko_l(ib,ik)*qwgt(ik)
       end do
    end do
    if(nrank_e > 1) then
       call mpi_allreduce(eband_extendedrange,eband_mpi,1,mpi_double_precision, &
      &                   mpi_sum,mpi_kg_world,ierr) !MPI
       eband_extendedrange = eband_mpi                  ! MPI
       call mpi_allreduce(weight0, eband_mpi,1,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
       weight0 = eband_mpi
    end if
    eband_extendedrange = (3.0-nspin) * eband_extendedrange * (af+1)
    if(ipri >= 1) then
       weight = weight * (af+1)
       write(nfout,'("   -- num_conduction_bands_lmm = ",i8)') num_conduction_bands_lmm
       write(nfout,'(" weight (sum_wholeeigenvalues) = ", f8.4, " iband = ",i10)') weight,iband
       write(nfout,'(" weight0 (occup_l)             = ", f8.4)') weight0
       write(nfout,'(" eband_extendedrange = ", f16.8, "   eband = ",f16.8)') eband_extendedrange, eband
    end if
  end subroutine sum_wholeeigenvalues

end module m_Total_Energy

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 622 $)
!
!  SUBROUINE: meta_dynamics, init_mtd
!
!  AUTHOR(S): J. Koga 2010
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!***************************************************************

! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================
#ifndef DISABLE_CONSTRAINTS
subroutine meta_dynamics()
  use m_velocity_verlet, only : m_vv_increment_md_step, m_vv_do_dynamics, m_vv_get_curr_md_step
  use m_meta_dynamics, only : m_mtd_update_bias, m_mtd_finalize
  use m_Const_Parameters, only : CONTINUATION
  use m_Control_Parameters, only : printable,icond
  use m_Files, only : nfout, F_CNTN, F_CNTN_BIN,F_CHGT,F_ZAJ,F_CNTN_bak,F_CNTN_BIN_bak,F_CHGT_bak,F_ZAJ_bak &
 &                  , F_CNTN_in, F_CNTN_BIN_in, F_CHGT_in, F_ZAJ_in &
 &                  , file_existence_contfiles, file_existence_3contfiles &
 &                  , m_Files_reopen_nfcntn, m_Files_reopen_nfcntn_bin, m_Files_reopen_nfzaj, m_Files_reopen_nfchgt
  use m_Parallelization, only : mype_conf,mpi_comm_group
  use m_PseudoPotential, only : mmesh
  use m_Ionic_System,    only : natm
  use m_Parallelization, only : m_Parallel_init_mpi_paw_3D
  use m_Control_Parameters, only : ipriparallel

  implicit none

  include 'mpif.h'

  integer :: stat, ierr
  character(len=256) :: to_string
  logical :: initialization_required

  call Preparation(0)                          ! Basis set, symmetry check etc.
  call Preparation_for_mpi(1)     ! mpi
  call init_mtd()
  call PseudoPotential_Construction
  call  m_Parallel_init_mpi_paw_3D(nfout,ipriparallel,natm,mmesh)
#ifdef ENABLE_ESM_PACK
  if(initialization_required())then
     call Preparation_for_ESM
  endif
#endif
  call Ewald_and_Structure_Factor
  call Initial_Electronic_Structure
  call Initial_MD_Condition()

  if(mype_conf>0 .and. icond==CONTINUATION .and. .not. &
 &  (file_existence_contfiles.and.file_existence_3contfiles))then
    F_CNTN = trim(F_CNTN_bak)//'_conf'//trim(to_string(mype_conf,2))
    F_CNTN_BIN = trim(F_CNTN_BIN_bak)//'_conf'//trim(to_string(mype_conf,2))
    F_CHGT = trim(F_CHGT_bak)//'_conf'//trim(to_string(mype_conf,2))
    F_ZAJ = trim(F_ZAJ_bak)//'_conf'//trim(to_string(mype_conf,2))

    F_CNTN_in = trim(F_CNTN_bak)//'_conf'//trim(to_string(mype_conf,2))
    F_CNTN_BIN_in = trim(F_CNTN_BIN_bak)//'_conf'//trim(to_string(mype_conf,2))
    F_CHGT_in = trim(F_CHGT_bak)//'_conf'//trim(to_string(mype_conf,2))
    F_ZAJ_in = trim(F_ZAJ_bak)//'_conf'//trim(to_string(mype_conf,2))

    if(printable)then
      write(nfout,'(a)') 
      write(nfout,'(a)') 'restored continuation files'
      write(nfout,'(a)') '  F_CNTN     : '//trim(F_CNTN)
      write(nfout,'(a)') '  F_CNTN_BIN : '//trim(F_CNTN_BIN)
      write(nfout,'(a)') '  F_CHGT     : '//trim(F_CHGT)
      write(nfout,'(a)') '  F_ZAJ      : '//trim(F_ZAJ)
      write(nfout,'(a)') 
    endif

    call m_Files_reopen_nfcntn()
    call m_Files_reopen_nfcntn_bin()
    call m_Files_reopen_nfzaj()
    call m_Files_reopen_nfchgt()
  endif

  bias:do
    if(.not.m_mtd_update_bias())then 
      exit bias
    endif
    md_step: do while(m_vv_increment_md_step())
      if(printable) write(nfout,'(a,i7)') 'entering MD step no. ',m_vv_get_curr_md_step()
      stat=0
      call m_vv_do_dynamics(stat)
      if(stat==2)then
        exit bias
      endif
      call postproc_md_step_mtd(printable,nfout)
      if(printable) write(nfout,'(a,i7)') 'done MD step no.     ',m_vv_get_curr_md_step()
      if(printable) write(nfout,'(a)')    ''
    enddo md_step
    call postproc_bias()
  enddo bias

  call mpi_barrier(mpi_comm_group, ierr)
  call mpi_barrier(mpi_comm_world, ierr)

  call finalize_mtd()

end subroutine meta_dynamics

subroutine postproc_md_step_mtd(printable,nfout)
  use m_velocity_verlet, only : m_vv_io_per_step
  implicit none
  logical, intent(in) :: printable
  integer, intent(in) :: nfout
  if(printable) write(nfout,'(a)') 'doing post-proc for each MD step'
  call m_vv_io_per_step()
end subroutine postproc_md_step_mtd

subroutine postproc_bias()
end subroutine postproc_bias

subroutine finalize_mtd()
  use m_routines, only : close_all_opened_files
  implicit none
  call close_all_opened_files()
  call scf_finalize()
  call dump_mtd()
end subroutine finalize_mtd

subroutine dump_mtd()
  use m_Files, only : F_CNTN, nfcntn
  use m_Parallelization, only : mype
  use m_velocity_verlet, only : m_vv_wd_vv_variables
  use m_meta_dynamics, only : m_mtd_wd_mtd
  implicit none
  if(mype/=0)return
  open(nfcntn,&
& file=F_CNTN,status='unknown',position='append')
  call m_mtd_wd_mtd(nfcntn)
  call m_vv_wd_vv_variables(nfcntn)
  close(nfcntn)
end subroutine dump_mtd

subroutine init_mtd()
  use m_Const_Parameters, only : ON,old,check_file_name_on,formatted, CONTINUATION,INITIAL
  use m_Control_Parameters, only : printable, icond
  use m_variables_for_atoms, only : m_vfa_alloc_atoms
  use m_variables_for_dynamics, only : m_vfd_init
  use m_velocity_verlet, only : m_vv_init, m_vv_parse_input, m_vv_rd_vv_variables
  use m_meta_dynamics, only : m_mtd_parse_input, m_mtd_print_status, m_mtd_rd_mtd, m_mtd_gen_bias_mode &
  &                         , m_mtd_set_bias_gen_only, m_mtd_open_mtd_files,m_mtd_wd_bias_potential &
  &                         , m_mtd_finalize
  use m_Files, only : nfinp, F_INP, nfout, open0,nfcntn, F_ZAJ_in, F_CNTN_in, F_CNTN_BIN_in, F_CHGT_in &
  &                 , F_ZAJ, F_CNTN, F_CNTN_BIN, F_CHGT, m_Files_check_file_existence &
  &                 , file_existence_contfiles, file_existence_3contfiles, F_CNTN_bak
  use m_Parallelization, only : workdir,sw_wdir, mype_conf

  implicit none
  integer ::  f_selectTop, f_selectBlock, f_openInputFile, f_closeInputFile
  integer :: iiret
  logical :: ex,op

  if(printable) write(nfout,'(a)')
  if(printable) write(nfout,'(a)') 'start initialization of meta-dynamics'
  call m_vfa_alloc_atoms()
  call m_vfd_init()

  inquire(unit=nfinp,opened=op)
  if(op)close(nfinp,status='keep')
  if(sw_wdir == ON) then
    iiret = f_openInputFile(trim(workdir)//F_INP)
  else
    iiret = f_openInputFile(F_INP)
  end if
  if( iiret < 0) then
    if(printable) write(nfout,'(" !!! Error in opening of inputfile: ",a32)') F_INP
    call phase_error_with_msg(nfout,'Error in opening of inputfile',__LINE__,__FILE__)
  else if(iiret > 0) then
    if(printable) write(nfout,'(" !!! There is something wrong in the input file: ",a32)') F_INP
  end if

  iiret = f_selectTop()

  call m_mtd_parse_input()

  if(m_mtd_gen_bias_mode())then
    call m_mtd_print_status()
    write(nfout,'(a)') ' -- generate and output the bias potential --'
    call m_mtd_wd_bias_potential()
    call m_mtd_finalize()
    write(nfout,'(a)') '... exiting.'
    stop
  else
    call m_vv_init()
    call m_vv_parse_input()

    iiret = f_selectTop()

    call m_mtd_print_status() 

!    iiret = f_closeInputFile()

    if(printable) write(nfout,'(a)') 'end initialization of meta-dynamics'
    if(printable) write(nfout,'(a)')

    if(icond==CONTINUATION)then
      if(printable) write(nfout,'(a)') 'loading continuation data for the meta-dynamics...'
      call m_vv_rd_vv_variables(nfcntn,.true.)
      call m_mtd_rd_mtd(nfcntn,file_existence_contfiles.and.file_existence_3contfiles)
      if(printable) write(nfout,'(a)') '...done'
    endif
  endif

end subroutine init_mtd
#endif
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================

      module eigen_dc
      implicit NONE

       real(8) ::  flops, dgemm_time, dgemm_dummy(1:2)
       real(8) ::  p_time0, p_time2, p_time3
       real(8) ::  p_times, p_timez, p_timer

      end module eigen_dc

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE: ChargeDensity_Construction, FermiEnergyLevel, 
!             CD_Softpart_plus_Hardpart
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!  
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine ChargeDensity_Construction(ic)
! $Id: ChargeDensity_Construction.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Total_Energy,         only : m_TE_total_energy, ehartr
  use m_Charge_Density,       only : m_CD_convergence_check &
       &                           , m_CD_softpart_3D, m_CD_hardpart &
       &                           , chgq_l &
       &                           , m_CD_hardpart_hsr
  use m_Electronic_Structure, only : metalic_system
  use m_ES_occup,             only : m_ESoc_fermi_parabolic_3D &
       &                           , m_ESoc_fermi_tetrahedron_3D &
       &                           , m_ESoc_fermi_ColdSmearing_3D &
       &                           , m_ESoc_check_num_bands &
       &                           , check_if_metalic

  use m_ES_IO,                only : m_ESIO_wd_EigenValues
  use m_Kpoints,              only : kv3
  use m_Files,                only : nfout
  use m_Crystal_Structure,    only : sw_bandgap_constraint, imag
  use m_Control_Parameters,   only : iprieigenvalue, projector_type, num_projectors &
       &                           , sw_hubbard, alpha_hubbard, icond, ekmode, occ_matrix_fix_period &
#ifdef ENABLE_ESM_PACK
       &                           , m_CtrlP_way_of_smearing,sw_esm, kimg, nspin
#else
       &                           , m_CtrlP_way_of_smearing
#endif
  use m_Const_Parameters,     only : PARABOLIC, MP, TETRAHEDRON, COLD, YES, OFF, ON &
       &                           , SPHERICAL_HARMONICS, ATOMIC_ORBITAL &
       &                           , INITIAL,CONTINUATION,FIXED_CHARGE,FIXED_CHARGE_CONTINUATION,CMPLDP
  use m_Orbital_Population,   only : m_OP_occ_mat_is_not_read

! ============================= added by K. Tagami =================== 5.0
  use m_Control_Parameters,  only : sw_eval_energy_before_charge, &
       &                            sw_update_charge_total, iprigap
! ==================================================================== 5.0
  use m_Electronic_Structure, only : fsr_gall, fsi_gall, fsr_l, fsi_l, m_ES_gather_f_3d_to_2d
  use m_Control_Parameters,   only : nspin, kimg, af
  use m_Kpoints,              only : k_symmetry
  use m_Const_Parameters,     only : GAMMA
  use m_Parallelization,      only : np_e, ista_k, iend_k, map_k, myrank_k,ista_kngp,iend_kngp,mpi_chg_world
  use m_PseudoPotential,      only : nlmta



! =========================================== added by K. Tagami ========== 11.0
  use m_Control_Parameters,      only : noncol
!!  use m_Charge_Density,        only : m_CD_hardpart_hsr_noncl, &
!!       &                              m_CD_softpart_noncl, &
!!       &                              m_CD_hardpart_noncl
!!  use m_Total_Energy,          only : m_TE_total_energy_noncl
! ========================================================================= 11.0

  use m_PlaneWaveBasisSet,       only : kgp
  use m_FFT,                     only : fft_box_size_CD

  use m_IterationNumbers, only : iteration_electronic


  use m_Const_Parameters,       only : MP, FERMI_DIRAC, LOWEST_AT_EACH_KPT
  use m_ES_Occup,               only : m_ESoc_fermi_Dirac_3D, m_ESoc_methfessel_paxton,&
       &                               m_ESoc_occup_fix_3D

! ============================= KT_add ================ 13.0U
  use m_CD_Mag_Moment,        only : m_CD_calc_ChgMagMom_in_sphere, &
       &                             m_CD_print_ChgMagmom_on_atom, &
       &                             sw_monitor_atomcharge
! ===================================================== 13.0U

! ======= KT_add ==== 13.0XX
  use m_Control_Parameters,     only : sw_calc_ekin_density, use_symm_ekin_density, &
       &                               use_asymm_ekin_density, ekin_density_is_active

  use m_KineticEnergy_Density,  only : m_KE_symm_softpart_3D, &
       &                               m_KE_cp_ekin_density_to_old
! =================== 13.0XX



  implicit none
  include 'mpif.h'

  integer, intent(in) :: ic
  logical             :: display_on, enough_bands
  complex(kind=CMPLDP),allocatable,dimension(:) :: vhar
  complex(kind=CMPLDP),allocatable, dimension(:,:) :: chgc
  integer :: ig,is,nfftcd,ierr
  integer             :: ispin, ik
#ifdef __TIMER_SUB__
  call timer_sta(701)
#endif

  if(ic == 0) display_on = .true.
  if(ic /= 0) display_on = .false.

!Fallocate(fsr_gall(np_e, nlmta, ista_k:iend_k))
!Fif(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!F   allocate(fsi_gall(np_e, nlmta, ista_k:iend_k))
!Fend if

!Fdo ispin = 1, nspin, af + 1
!F   do ik = ispin, kv3+ispin-nspin, nspin
!F      if(map_k(ik) /= myrank_k) cycle            ! MPI
!F      call m_ES_gather_f_3d_to_2d(fsr_l, fsr_gall(:,:,ik), ik)
!F      if(k_symmetry(ik) /= GAMMA) then
!F         call m_ES_gather_f_3d_to_2d(fsi_l, fsi_gall(:,:,ik), ik)
!F      endif
!F   enddo
!Fenddo

  enough_bands = m_ESoc_check_num_bands()
  if(enough_bands) then
     call FermiEnergyLevel()            ! -(contained here)
     if ( iprigap > 1 ) then
        if ( noncol ) then
        else
           call check_if_metalic( nfout, metalic_system )
        endif
     endif
  else
     if(iprieigenvalue >= 1) write(nfout,'(" the number of bands is not enough")')
     stop ' the number of bands is not enough'
  end if

! =================== added by K. Tagami ============ 5.0
  if ( sw_eval_energy_before_charge == ON ) then
     call m_TE_total_energy(nfout,display_on,kv3)
  endif
! =================================================== 5.0


! ======================== modified by K. Tagami ======= 5.0
!  if(icond == INITIAL .or. icond == CONTINUATION) then
!     call CD_Softpart_plus_Hardpart()   ! -(contained here)
!     if(ic == 0) call m_CD_conversion_check(nfout)
!  else if ((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION).and.ekmode==OFF) then
!     call m_CD_hardpart_hsr(nfout,kv3)  ! fsr_l, fsi_l -> hsr
!  end if

  if ( sw_update_charge_total == ON ) then
     if ( icond == INITIAL .or. icond == CONTINUATION ) then
        call CD_Softpart_plus_Hardpart()   ! -(contained here)
        if ( ic == 0 ) call m_CD_convergence_check(nfout)
     else if ( ( icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION ) &
          &         .and. ekmode==OFF ) then
        call m_CD_hardpart_hsr(nfout,kv3)  ! fsr_l, fsi_l -> hsr
     end if

     call Renewal_of_OccMat( .false., OFF, iteration_electronic <= occ_matrix_fix_period) ! evaluated with new om, hsr
  endif
! ========================================================= 5.0

#ifdef ENABLE_ESM_PACK
  if(sw_esm==ON)then
     nfftcd = fft_box_size_CD(1,0)*fft_box_size_CD(2,0)*fft_box_size_CD(3,0)
     allocate(vhar(nfftcd));vhar=(0.d0,0.d0)
!     allocate(chgc(iend_kngp-ista_kngp+1,nspin));chgc=(0.d0,0.d0)
     allocate(chgc(1:kgp,nspin));chgc=(0.d0,0.d0)
     if(kimg==1)then
        do ig=ista_kngp,iend_kngp
!           chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chgq_l(ig,1,1:nspin),0.d0)
           chgc(ig,1:nspin) = dcmplx(chgq_l(ig,1,1:nspin),0.d0)
        enddo
     else
        do ig=ista_kngp,iend_kngp
!           chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chgq_l(ig,1,1:nspin),chgq_l(ig,2,1:nspin))
           chgc(ig,1:nspin) = dcmplx(chgq_l(ig,1,1:nspin),chgq_l(ig,2,1:nspin))
        enddo
     endif
     call mpi_allreduce(mpi_in_place,chgc,kgp*nspin,mpi_double_complex,mpi_sum,mpi_chg_world,ierr)
     call esm_hartree(chgc,ehartr,vhar)
     ehartr  = 0.5d0*ehartr  !Ry -> Ha
     deallocate(chgc)
     deallocate(vhar)
  endif
#endif

! ======= KT_add ===== 13.0XX
!  if ( sw_calc_ekin_density == ON .and. ekin_density_is_active ) then
  if ( sw_calc_ekin_density == ON ) then
     if ( icond == INITIAL .or. icond == CONTINUATION ) then
        call m_KE_cp_ekin_density_to_old
        if ( use_symm_ekin_density )  call m_KE_symm_softpart_3D
     endif
  endif
! ==================== 13.0XX

! ============================= KT_add ================ 13.0U
  if ( sw_monitor_atomcharge == ON ) then
     call m_CD_calc_ChgMagMom_in_sphere
  endif
! ===================================================== 13.0U


  if ( sw_eval_energy_before_charge == OFF ) then
     call m_TE_total_energy(nfout,display_on,kv3)
  endif
! ======================================================== 5.0

  if(ic == 0) call m_ESIO_wd_EigenValues(nfout,iprieigenvalue,nooccupation=YES)

#ifdef __TIMER_SUB__
  call timer_end(701)
#endif
contains
  subroutine FermiEnergyLevel()
    integer :: way_of_smearing
#ifdef __TIMER_SUB__
  call timer_sta(702)
#endif
    way_of_smearing = m_CtrlP_way_of_smearing()
    if(way_of_smearing == PARABOLIC) then
       call m_ESoc_fermi_parabolic_3D(nfout)
!!$  else if(way_of_smearing == MP) then
!!$     call fermi_mesfessel_paxton(nfout)
    else if(way_of_smearing == TETRAHEDRON) then
        call m_ESoc_fermi_tetrahedron_3D(nfout)
    else if(way_of_smearing == COLD) then
        call m_ESoc_fermi_ColdSmearing_3D(nfout)

! ================ KT_add ========================= 13.0E
    else if(way_of_smearing == FERMI_DIRAC) then
        call m_ESoc_fermi_Dirac_3D(nfout)
! ================================================= 13.0E
    else if(way_of_smearing == MP) then
        call m_ESoc_methfessel_paxton(nfout)
    else if(way_of_smearing == LOWEST_AT_EACH_KPT) then
       call m_ESoc_occup_fix_3D(nfout)
    end if
#ifdef __TIMER_SUB__
  call timer_end(702)
#endif
  end subroutine FermiEnergyLevel

  subroutine CD_Softpart_plus_Hardpart
! $Id: ChargeDensity_Construction.F90 633 2020-12-01 05:11:03Z jkoga $
!fj#ifdef __TIMER_SUB__
!fj  call timer_sta(716)
!fj#endif
    call m_CD_softpart_3D(nfout,kv3)
    call m_CD_hardpart(nfout,kv3)
!fj#ifdef __TIMER_SUB__
!fj  call timer_end(716)
!fj#endif
  end subroutine CD_Softpart_plus_Hardpart


end subroutine ChargeDensity_Construction

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: Forces
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
subroutine Forces
! $Id: Forces_ep.f90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Control_Parameters, only : m_CtrlP_what_is_mdalg
  use m_Force,              only : forc_l, m_Force_stlweb
  use m_Ionic_System,       only : m_IS_evaluate_v_verlet
  implicit none
  integer :: mdalg

  call m_Force_stlweb()
  mdalg = m_CtrlP_what_is_mdalg()
  call m_IS_evaluate_v_verlet(mdalg,forc_l)
end subroutine Forces

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 577 $)
!
!  SUBROUINE: Stress
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Stress
  use m_Stress,           only : hsrd &
         &                     , m_Stress_alloc,m_Stress_ke, m_Stress_dealloc, m_Stress_hsr_diff &
         &                     , m_Stress_alloc_grinv_g, m_Stress_lclchg_diff, m_Stress_dealloc_grinv_g &
         &                     , m_Stress_xc, m_Stress_loc, m_Stress_h, m_Stress_nl, m_Stress_ew &
         &                     , m_Stress_or, m_Stress_sum, m_Stress_Hub, m_Stress_vdw &
#ifndef DISABLE_VDWDF
         &                     , m_Stress_check_g12, m_Stress_vdwdf
#else
         &                     , m_Stress_check_g12
#endif
  use m_Const_Parameters, only : Valence_plus_PC_Charge,STRESS_, CRDTYP, ON
  use m_Kpoints,          only : kv3, vkxyz
  use m_Files,            only : nfout
  use m_Control_Parameters, only: istress, sw_vdw_correction, xctype, sw_hubbard
  use m_XC_Potential,     only : m_XC_alloc_s_gga, m_XC_dealloc_s_gga, m_XC_cal_potential_3D
  use m_Charge_Density,   only : chgsoft, chgq_l, hsr

  implicit none

  if (istress == 0) return

  call m_Stress_alloc()
  call m_XC_alloc_s_gga()
  call m_Stress_ke(nfout,kv3,CRDTYP,vkxyz)
  call m_Stress_hsr_diff(nfout,kv3)
  call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l,STRESS_ &
       &   ,chgsoft,hsr,hsrd)
  call m_Stress_check_g12(nfout)
  call m_Stress_alloc_grinv_g()
  call m_Stress_lclchg_diff(nfout)
  call m_Stress_xc(nfout)
  call m_Stress_loc(nfout)
  call m_Stress_h(nfout)
  call m_Stress_dealloc_grinv_g()
  call m_Stress_nl(nfout)
  call m_Stress_ew(nfout)
  call m_Stress_or(nfout)

! =============================== Added by K. Tagami ============ p1100
  if ( sw_hubbard == ON ) call m_Stress_Hub(nfout)
! =============================================================== p1100

! =================================== KT_add ============== 13.0B
  if ( sw_vdw_correction == ON ) call m_Stress_vdw(nfout)
! ========================================================= 13.0B

#ifndef DISABLE_VDWDF
  if ( xctype == "vdwdf" ) call m_Stress_vdwdf(nfout)
#endif

  call m_Stress_sum(nfout)
  call m_Stress_dealloc()
  call m_XC_dealloc_s_gga()
end subroutine Stress

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE:  m_Force
!
!  AUTHOR(S): T. Uchiyama, T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Force
! $Id: m_Force_ep.f90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Const_Parameters,     only : DP, RELAX, BONDLENGTH_FIX, HEAT_BATH &
       &                           , WITHOUTTAG, WITHTAG
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : forccr,printable
  use m_Crystal_Structure,    only : altv,univol
  use m_Ionic_System,         only : natm,natm2,iwei,imdtyp,pos

  implicit none

!-- For Si atom --
  real(kind=DP), parameter :: a_cut = 1.8d0,sigma = 3.959164919d0, eps = 7.968005097d-2
  real(kind=DP), parameter :: bmax = sigma*a_cut
!--
  real(kind=DP),allocatable,dimension(:,:) :: forc_l !d(natm,3)
  real(kind=DP)                            :: forcmx
  real(kind=DP)                            :: etotal

contains
  subroutine m_Force_alloc()
    allocate(forc_l(natm,3))
  end subroutine m_Force_alloc

  subroutine m_Force_stlweb()
! ** Stillinger-Weber potential **
!                          T. Uchiyama,  June 6, 1998
! ** Transfer from f77 to f90 **
!                      corded by k.iwata July 30,1998
! ** Revised by T. Yamasaki, Oct. 1998
    integer, parameter :: nbd = 24
    real(kind=DP), pointer, dimension(:,:) :: posb, forc   !d(natm2,3)
    integer,       pointer, dimension(:,:) :: ipar         !d(katm*nbd,3)
    real(kind=DP) :: r1(3),r2(3)
    integer       :: npar

    integer       :: id_sname = -1
    call tstatc0_begin('stlweb ',id_sname)

    allocate(posb(natm2,3));  allocate(forc(natm2,3)); forc = 0.d0
    allocate(ipar(natm*nbd,3))

    call full_ionic_coordinates    !-(contained here) pos -> posb
    call two_body_term(npar)       !-(contained here) -> forc
    call three_body_term(nbd,npar) !-(contained here) -> forc
    call copy_back_to_forc_l       !-(contained here) forc -> forc_l
    call get_forc_maximum          !-(contained here) forc_l -> forcmx

    deallocate(ipar)
    deallocate(forc); deallocate(posb)

    call tstatc0_end(id_sname)
  contains
    subroutine full_ionic_coordinates
      integer :: i,ia

      do i = 1, natm
         posb(i,1:3)= pos(i,1:3)
      end do

      ia= natm
      do i= 1, natm
         if(iwei(i) == 2) then
            ia= ia +1
            posb(ia,1:3)= -posb(i,1:3)
         end if
      end do

      do i = 1, natm2
         posb(i,1:3) = dmod( posb(i,1:3), 1.d0 )
      end do
    end subroutine full_ionic_coordinates

! ***** 2-body term ***********************************
    subroutine two_body_term(npar)
      integer, intent(out) :: npar
!     Interaction with self-images is not included,
!   where the cell size is assumed to be larger than
!   the cutoff radius.
!
      real(kind=DP),pointer,dimension(:,:) :: femp2   !d(3,2)
      integer       :: mm, m1, m2,lx,ly,lz, j
      real(kind=DP) :: b, eemp2, cp(3)

      allocate(femp2(3,2))

      etotal = 0.d0
      mm= 0
      do m1 = 1,    natm2-1
         do m2 = m1+1, natm2
            do lx= -1, 1
               do ly= -1, 1
                  do lz= -1, 1

                     cp(1) = posb(m2,1) - posb(m1,1) + lx
                     cp(2) = posb(m2,2) - posb(m1,2) + ly
                     cp(3) = posb(m2,3) - posb(m1,3) + lz

                     r1 = matmul(altv,cp)   ! pucv -> cartesian coordinates

                     b= dsqrt( pvec( r1, r1 ))

                     if(b < bmax) then
                        mm= mm +1
                        ipar(mm,1)= m1
                        ipar(mm,2)= m2
                        ipar(mm,3)= ( lx+1 )*9 +( ly+1 )*3 +lz+1
           !  ------------------------------------------------
                        call emp2(r1,eemp2,femp2)   !-(m_Force_ep)
                        etotal= etotal +eemp2
                        do j= 1, 3
                           forc(m1,j)= forc(m1,j) +femp2(j,1)
                           forc(m2,j)= forc(m2,j) +femp2(j,2)
                        end do
           !  ------------------------------------------------
                     end if

                  end do
               end do
            end do

         end do
      end do
      npar= mm
!!$      print *,' ! npar = ', npar
      deallocate(femp2)
    end subroutine two_body_term

! ***** 3-body term **********************************
    subroutine three_body_term(nbd,npar)
      integer, intent(in) :: nbd,npar
      real(kind=DP)       :: kb(nbd),t(3,nbd)
      real(kind=DP),pointer,dimension(:,:) :: femp3   ! d(3,3)
      integer             :: m, nb, k, m1, m2, lx,ly,lz,j1,j2,j
      real(kind=DP)       :: eemp3
      logical :: over
      allocate(femp3(3,3))

      over = .false.
      do m = 1, natm2

         nb= 0
         do k= 1, npar
            if(ipar(k,1) == m .or. ipar(k,2) == m) then
               nb= nb +1
               if(nb > nbd) then
                  if(printable) write(6,'(" !warning nbd, nb = ",i8,i8)') nbd,nb 
               end if
               m1= ipar(k,1)
               m2= ipar(k,2)

               lx= ipar(k,3)/9 -1
               ly= ( ipar(k,3) -lx*9 -9 )/3 -1
               lz= ipar(k,3) -lx*9 -ly*3 -13

               if(nb <= nbd) then

               t(1,nb)= posb(m2,1) -posb(m1,1) +lx
               t(2,nb)= posb(m2,2) -posb(m1,2) +ly
               t(3,nb)= posb(m2,3) -posb(m1,3) +lz

               if(m1 == m) kb(nb)= m2
               if(m2 == m) then
                  kb(nb)= m1 
                  t(1,nb)= -t(1,nb)
                  t(2,nb)= -t(2,nb)
                  t(3,nb)= -t(3,nb)
               end if

               end if
            end if
         end do

         if(nb > nbd) over = .true.

         do j1= 1,    nb-1
            do j2= j1+1, nb

               r1 = matmul(altv,t(1:3,j1))
               r2 = matmul(altv,t(1:3,j2))

         ! -------------------------------------------------
               call emp3(r1,r2,eemp3,femp3)
               etotal= etotal +eemp3

               m1 = kb(j1)
               m2 = kb(j2)
               do j= 1, 3
                  forc(m, j)= forc(m, j) +femp3(j,1)
                  forc(m1,j)= forc(m1,j) +femp3(j,2)
                  forc(m2,j)= forc(m2,j) +femp3(j,3)
               end do
         ! -------------------------------------------------

            end do
         end do
      end do

      if(over) stop ' stop at three_body_term'

!!$      print *,' ! etotal = ' , etotal
      deallocate(femp3)
    end subroutine three_body_term

    subroutine copy_back_to_forc_l
      integer :: i, j
      do i= 1, natm
         do j= 1,3
            forc_l(i,j)= forc(i,j)
         end do
      end do
    end subroutine copy_back_to_forc_l

    subroutine get_forc_maximum
      integer       :: i
      real(kind=DP) :: fca

      forcmx = 0.d0
      do i = 1, natm
         if(imdtyp(i) == RELAX .or. imdtyp(i) == BONDLENGTH_FIX &
              & .or. imdtyp(i) > HEAT_BATH) then
            fca = dsqrt(forc_l(i,1)**2+forc_l(i,2)**2+forc_l(i,3)**2)
            if(forcmx < fca) forcmx = fca
         end if
      end do
      write(6,'(" !!f forcmx = ", f8.4," <<m_Force_stlweb.get_forc_maximum>>")') forcmx
!!$      print *, ' !D forcmx = ', forcmx
    end subroutine get_forc_maximum

  end subroutine m_Force_stlweb

! ****************************
  function pvec( a, b )
! ****************************

    real(kind=DP) :: pvec
    real(kind=DP) :: a(3), b(3)

    pvec= a(1)*b(1) +a(2)*b(2) +a(3)*b(3)

  end function pvec

! **************************************************************
  subroutine emp2(r,eemp2,femp2)   
    !   Stillinger and Weber potential,    coded by T. Miyake

    real(kind=DP),intent(in), dimension(3)   :: r
    real(kind=DP),intent(out)                :: eemp2
    real(kind=DP),intent(out),dimension(3,2) :: femp2

    real(kind=DP) :: x,y,z, rad, femp2r
    x = r(1)
    y = r(2)
    z = r(3)
    rad = dsqrt(x**2 + y**2 + z**2)

    call vemp2SiSi(rad,eemp2,femp2r)

    femp2(1,1) = - femp2r * x / rad
    femp2(2,1) = - femp2r * y / rad
    femp2(3,1) = - femp2r * z / rad
    femp2(1,2) = - femp2(1,1)
    femp2(2,2) = - femp2(2,1)
    femp2(3,2) = - femp2(3,1)

  end subroutine emp2

! ***********************************************************************
  subroutine emp3(r12,r13,eemp3,femp3)
    real(kind=DP), intent(in), dimension(3)  :: r12,r13
    real(kind=DP), intent(out)               :: eemp3
    real(kind=DP), intent(out),dimension(3,3):: femp3

    real(kind=DP) :: x12,y12,z12,x13,y13,z13

    x12 = r12(1)
    y12 = r12(2)
    z12 = r12(3)
    x13 = r13(1)
    y13 = r13(2)
    z13 = r13(3)

    call vemp3SiSiSi(x12,y12,z12,x13,y13,z13, eemp3,femp3)
  end subroutine emp3

! ***********************************************************************
!  two body contributions to Si-Si interaction 
!  Stillinger and Weber, Phys.Rev.B31,5262(1985)
!  atomic unit
  subroutine vemp2SiSi(r,eemp2,femp2r)
    real(kind=DP),intent(in)  :: r
    real(kind=DP),intent(out) :: eemp2,femp2r

    real(kind=DP),parameter   :: A = 7.049556277d0, B = 0.6022245584d0
    integer, parameter        :: p = 4, q = 0

    real(kind=DP) :: r0, f2, df2

! =======================================================================
!  begin:

    r0 = r / sigma

    if (r0 >=  a_cut) then 

       eemp2 = 0d0
       femp2r = 0d0

    else 

       f2 = A * (B*r0**(-p) - r0**(-q)) * dexp(1d0/(r0-a_cut))
       df2 = A * (-p*B*r0**(-p-1) + q*r0**(-q-1)) * &
            &  dexp(1d0/(r0-a_cut)) - &
            &  A * (B*r0**(-p) - r0**(-q)) * &
            &  dexp(1d0/(r0-a_cut)) * (r0-a_cut)**(-2)

       eemp2 = eps * f2
       femp2r = - eps * df2 / sigma

    endif

  end subroutine vemp2SiSi

! ***********************************************************************
!  three body contributions to Si-Si-Si interaction 
!  Stillinger and Weber, Phys.Rev.B31,5262(1985)
!  atomic unit
  subroutine vemp3SiSiSi(x12,y12,z12,x13,y13,z13,eemp3,femp3)
    real(kind=DP), intent(inout) :: x12,y12,z12,x13,y13,z13
    real(kind=DP), intent(out)   :: eemp3,femp3(3,3)

    real(kind=DP) :: r12,r13
    real(kind=DP) :: h,dh(3,3)

    x12 = x12 / sigma
    y12 = y12 / sigma
    z12 = z12 / sigma
    x13 = x13 / sigma
    y13 = y13 / sigma
    z13 = z13 / sigma

    r12 = dsqrt(x12**2 + y12**2 + z12**2)
    r13 = dsqrt(x13**2 + y13**2 + z13**2)

    if ((r12 < a_cut).and.(r13 < a_cut)) then 

       call sw3body(a_cut,r12,r13,x12,x13,y12,y13,z12,z13,h,dh)
       eemp3 = eps * h
       femp3 = -eps/sigma * dh
    else

        eemp3 = 0.d0
        femp3 = 0.d0

    endif

  end subroutine vemp3SiSiSi

! ***********************************************************************
!  h and its derivatives in Stillinger-Weber potential
  subroutine sw3body(a_cut,r12,r13,x12,x13,y12,y13,z12,z13, &
       &  h,dh)
    implicit none

    real(kind=DP), parameter :: lamda=21.0d0
    real(kind=DP), parameter :: gamma=1.20d0

    real(kind=DP) ::  a_cut
    real(kind=DP) ::  r12,r13,x12,y12,z12,x13,y13,z13
    real(kind=DP) ::  h,dh(3,3)
    real(kind=DP) ::  b,c

! =======================================================================
!  begin:
    b = x12*x13 + y12*y13 + z12*z13
    c = b / (r12*r13) + 1d0 / 3d0
!
    if (c.eq.0d0) then 
       h = 0d0
       dh = 0.d0
    else
       h = lamda * dexp(gamma/(r12-a_cut) + gamma/(r13-a_cut)) & 
            &  * c**2

       dh(1,1) = h * (gamma*x12/r12/(r12-a_cut)**2 + &
            &  gamma*x13/r13/(r13-a_cut)**2) &
            &  + 2d0*h/c * (-(x12+x13)/(r12*r13) - b*(r12*(-x13/r13) &
            &   +r13*(-x12/r12)) / (r12*r13)**2)
       dh(2,1) = h * (gamma*y12/r12/(r12-a_cut)**2 + &
            &  gamma*y13/r13/(r13-a_cut)**2) &
            &  + 2d0*h/c * (-(y12+y13)/(r12*r13) - b*(r12*(-y13/r13) &
            &  +r13*(-y12/r12)) / (r12*r13)**2)
       dh(3,1) = h * (gamma*z12/r12/(r12-a_cut)**2 + &
            &  gamma*z13/r13/(r13-a_cut)**2) &
            &  + 2d0*h/c * (-(z12+z13)/(r12*r13) - b*(r12*(-z13/r13) &
            &  +r13*(-z12/r12)) / (r12*r13)**2)

       dh(1,2) = h * (gamma*(-x12/r12)/(r12-a_cut)**2) & 
            & + 2d0*h/c * (x13/(r12*r13) - b*(x12/r12)/(r12**2*r13))
       dh(2,2) = h * (gamma*(-y12/r12)/(r12-a_cut)**2) &
            & + 2d0*h/c * (y13/(r12*r13) - b*(y12/r12)/(r12**2*r13))
       dh(3,2) = h * (gamma*(-z12/r12)/(r12-a_cut)**2) &
            & + 2d0*h/c * (z13/(r12*r13) - b*(z12/r12)/(r12**2*r13))

       dh(1,3) = h * (gamma*(-x13/r13)/(r13-a_cut)**2) &
            & + 2d0*h/c * (x12/(r12*r13) - b*(x13/r13)/(r12*r13**2))
       dh(2,3) = h * (gamma*(-y13/r13)/(r13-a_cut)**2) &
            & + 2d0*h/c * (y12/(r12*r13) - b*(y13/r13)/(r12*r13**2))
       dh(3,3) = h * (gamma*(-z13/r13)/(r13-a_cut)**2) & 
            & + 2d0*h/c * (z12/(r12*r13) - b*(z13/r13)/(r12*r13**2))

    endif
!
!       if (ideb == 1) write(*,*)'sw3body in'
!
  end subroutine sw3body

  logical function m_Forces_are_Converged_core()
    if(forcmx < forccr) then
       m_Forces_are_Converged_core = .true.
    else
       m_Forces_are_Converged_core = .false.
    end if
!!$    write(6,'(" !!f forcmx, forccr = ",2f12.6)') forcmx, forccr
  end function m_Forces_are_Converged_core

  subroutine m_Force_wd_force_and_cps(nf, withorwithout, cps, ndim)
    integer, intent(in) :: nf, withorwithout,ndim
    real(kind=DP), intent(in) :: cps(ndim,3)
    real(kind=DP) :: fca
    integer :: ia

    if(withorwithout == WITHOUTTAG) then
       do ia = 1, natm
          fca = dsqrt(forc_l(ia,1)**2+forc_l(ia,2)**2+forc_l(ia,3)**2)
          write(nf,'(" ",i4,3f15.9,4f12.6)') ia &
               &, cps(ia,1),cps(ia,2),cps(ia,3) &
               &, forc_l(ia,1), forc_l(ia,2), forc_l(ia,3),fca
       end do
    else if(withorwithout == WITHTAG) then
       do ia = 1, natm
          fca = dsqrt(forc_l(ia,1)**2+forc_l(ia,2)**2+forc_l(ia,3)**2)
          write(nf,'(" !forc ",i4,3f12.6,4f12.6)') ia &
               &, cps(ia,1),cps(ia,2),cps(ia,3) &
               &, forc_l(ia,1), forc_l(ia,2), forc_l(ia,3), fca
       end do
    else
       write(nf,'(" keyword in the argument list of m_Force_wd_force_and_cps is invalid")')
    end if

  end subroutine m_Force_wd_force_and_cps

  subroutine m_Force_wd_force_cps_cpd(nf, withorwithout, cps, cpd,ndim)
    integer, intent(in) :: nf, withorwithout,ndim
    real(kind=DP), intent(in) :: cps(ndim,3), cpd(ndim,3)
    integer :: ia

    if(withorwithout == WITHOUTTAG) then
       do ia = 1, natm
          write(nf,'(" ",i4,3f15.9,3f12.6, 3f12.6)') ia &
               &, cps(ia,1:3), cpd(ia,1:3), forc_l(ia,1:3)
       end do
    else if(withorwithout == WITHTAG) then
       do ia = 1, natm
          write(nf,'(" !forc ",i4,3f12.6,3f12.6,3f12.6)') ia &
               &, cps(ia,1:3),cpd(ia,1:3),forc_l(ia,1:3)
       end do
    else
       write(nf,'(" keyword in the argument list of m_Force_wd_force_cps_cpd is invalid")')
    end if

  end subroutine m_Force_wd_force_cps_cpd

end module m_Force

      implicit double precision (a-h,o-z)

      real(8), allocatable :: a(:,:),ai(:,:)
      real(8), pointer :: b(:),bi(:),c(:),ci(:),w(:)
!
      include 'mpif.h'
!
      call mpi_init(ierr)
      call mpi_comm_rank(mpi_comm_eigen,i$inod,ierr)
      call mpi_comm_size(mpi_comm_eigen,i$nnod,ierr)
*
      n=1000
      m=32
      nm=(n/2)*2+1
      allocate( a(n,n), ai(n,n) )
      allocate(
     &         b((nm)*((n-1)/i$nnod+1+nm+1)),
     &         bi((nm)*((n-1)/i$nnod+1+nm+1)),
     &         c((nm)*((n-1)/i$nnod+1+nm+1)),
     &         ci((nm)*((n-1)/i$nnod+1+nm+1)),
     &         w(nm),
     &         stat=istat )
      if(istat.ne.0) then
         print*,"Memory exhausted"
         call flush(6)
         stop
      endif
*
      call matrix_set(a,n)
      call matrix_seti(ai,n)
      call matrix_adjust_h(a,n,b,nm)
      call matrix_adjust_hi(ai,n,bi,nm)
      call eigen_h(n,b,bi,w,nm,m,0)
*
#ifdef CHECK
      call matrix_set(a,n)
      call matrix_seti(ai,n)
      call matrix_adjust_h(a,n,c,nm)
      call matrix_adjust_hi(ai,n,ci,nm)
      call ev_test2(c,ci,w,b,bi,n,nm)
#endif
*
      deallocate(a,ai,b,bi,c,ci,w)

      call MPI_Finalize(ierr)
      end

       subroutine trbakwy_body2(local_nvec, z, nmz,
     $            d, e, v, nm, m, i, ss, tt, nss, iblk,
     $            dcom, dx, dy, dz)
!$     use OMP_LIB
       use MPI
       use eigen_devel
       use eigen_libs
       use eigen_trbak
       implicit NONE
*
       integer, intent(in)    :: local_nvec, nmz, nm, m, i, nss, iblk
       real(8), intent(inout) :: z(nmz,*)
       real(8), intent(inout) :: d(*), e(*), v(nm,*)
       real(8), intent(inout) :: ss(*), tt(*), dcom, dx, dy, dz

       integer                :: i_1, i_2, i_3, i_4
       integer                :: j_1, j_2, j_3, j_4
       integer                :: i_0, m_0
       integer                :: ii
       real(8)                :: fr
       real(8)                :: ds, de
*
       integer                :: local_rank, local_size
!$     integer                :: ierr
*
       local_size = 1
       local_rank = 0
!$     local_size = omp_get_num_threads()
!$     local_rank = omp_get_thread_num()
*-
          i_2 = 1
          i_3 = local_nvec
*
          j_2 = eigen_loop_start(1,         x_nnod,x_inod)
          j_3 = eigen_loop_end  (i+m-1-iblk,x_nnod,x_inod)
!
*-
#if AT_BCAST_OVERLAP
!$     if ( DO_OVERLAP_BCAST_LEVEL == 2 ) then
!===
!$        call sync_other_than_master( TRBK_lock(1) )
!===
!$     endif
#endif
!$     if (
#if AT_BCAST_OVERLAP
!$   &       DO_OVERLAP_BCAST_LEVEL /= 2
#else
!$   &       .TRUE.
#endif
!$   &       ) then
!===
!$OMP     BARRIER
!===
!$     endif
*-
#if AT_BCAST_OVERLAP
          fr = TRBK_TIME_FR
          ii = MAX(8,int((i_3-i_2+1)*fr))
          ii = MIN(i_3-i_2+1,ii)

          fr = (TRBK_TIME_TRBK1 + TRBK_TIME_TRBK1x)
     $       / (TRBK_TIME_TRBK1 + TRBK_TIME_TRBK1x + TRBK_TIME_REDUC)
#else
          fr = 0D0
          ii = i_3-i_2+1
#endif
*-
! SM:= SM+lower(V^TV)
! SS(1:m,1:n):= SS+V(j_2:j_3,1:m)^T*Z(j_2:j_3,1:n)
          if ( local_size==1 .OR. local_rank==1 ) then
             ds = eigen_get_wtime()
          end if
          call trbk1(z, nmz,
     $               v, nm, m, ss(1+ns0), ss(1),
     $               i_2,i_2+ii-1,j_2,j_3)
          if ( local_size==1 .OR. local_rank==1 ) then
             de = eigen_get_wtime()
!$           TRBK_TIME_TRBK1 = de - ds
             dx = dx + (de - ds)
          end if
*-
*-----------------------------------------------------------------
!$OMP  BARRIER
*-----------------------------------------------------------------
*-
!$OMP  MASTER
          ds = eigen_get_wtime()
          ss(ns0-5) = TRBK_TIME_REDUC
          ss(ns0-4) = TRBK_TIME_BCAST
          ss(ns0-3) = TRBK_TIME_TRBK1
          ss(ns0-2) = TRBK_TIME_TRBK1y
          ss(ns0-1) = TRBK_TIME_TRBK2
          ss(ns0-0) = fr
          call reduce_dbl(ss(1), tt(1), ii*m+ns0,
     $         1, x_COMM_WORLD)
          TRBK_TIME_REDUC  = ss(ns0-5) / x_nnod
          TRBK_TIME_BCAST  = ss(ns0-4) / x_nnod
          TRBK_TIME_TRBK1  = ss(ns0-3) / x_nnod
          TRBK_TIME_TRBK1x = ss(ns0-2) / x_nnod
          TRBK_TIME_TRBK2  = ss(ns0-1) / x_nnod
          TRBK_TIME_FR     = ss(ns0-0) / x_nnod
          de = eigen_get_wtime()
!$        TRBK_TIME_REDUC = (de-ds)
          dcom = dcom + (de - ds)
!$OMP  END MASTER
*-
#if AT_BCAST_OVERLAP
          if ( i_3 >= i_2 + ii ) then
          if ( local_size==1 .OR. local_rank==1 ) then
             ds = eigen_get_wtime()
          end if
          call trbk1(z, nmz,
     $               v, nm, m, ss(1+ns0), ss(1),
     $               i_2+ii,i_3,j_2,j_3)
          if ( local_size==1 .OR. local_rank==1 ) then
             de = eigen_get_wtime()
             dx = dx + (de - ds)
          end if
          end if
#endif
*-
*-----------------------------------------------------------------
!$OMP  BARRIER
*-----------------------------------------------------------------
*-
#if AT_BCAST_OVERLAP
          if ( local_size==1 .OR. local_rank==1 ) then
          if ( i_3 >= i_2 + ii ) then
!$           TRBK_TIME_TRBK1y = de - ds
          else
!$           TRBK_TIME_TRBK1y = 0D0
          end if
          end if
#endif
*-
!$OMP  MASTER
#if AT_BCAST_OVERLAP
          if ( i_3 >= i_2 + ii ) then
          ds = eigen_get_wtime()
          call reduce_dbl(ss(1+ns0+ii*m), tt(1), (i_3-i_2+1-ii)*m,
     $         1, x_COMM_WORLD)
          de = eigen_get_wtime()
!$        TRBK_TIME_REDUC = TRBK_TIME_REDUC + (de-ds)
          dcom = dcom + (de - ds)
          end if
#endif
*-
          ds = eigen_get_wtime()
! SM:= D*SM
          do m_0=1,m-1
!DIR$ IVDEP
             do i_0=m_0+1,m
                ss(i_0+(m_0-1)*nsm) = ss(i_0+(m_0-1)*nsm) * d(i+i_0-1)
             end do! i_0
          end do! m_0
*-
! SS:= D*SS
          i_4 = MOD(i_3-i_2+1,4)+i_2
          do i_1=i_2,i_4-1                       ! 0
!DIR$ IVDEP
             do m_0=1,m
                ss((i_1+0-i_2)*m+m_0+ns0) =
     $          ss((i_1+0-i_2)*m+m_0+ns0) * d(i+m_0-1)
             end do! m_0
          end do! i_1
          do i_1=i_4,i_3,4                  ! 3
!DIR$ IVDEP
             do m_0=1,m
                ss((i_1+0-i_2)*m+m_0+ns0) =
     $          ss((i_1+0-i_2)*m+m_0+ns0) * d(i+m_0-1)
                ss((i_1+1-i_2)*m+m_0+ns0) =
     $          ss((i_1+1-i_2)*m+m_0+ns0) * d(i+m_0-1)
                ss((i_1+2-i_2)*m+m_0+ns0) =
     $          ss((i_1+2-i_2)*m+m_0+ns0) * d(i+m_0-1)
                ss((i_1+3-i_2)*m+m_0+ns0) =
     $          ss((i_1+3-i_2)*m+m_0+ns0) * d(i+m_0-1)
             end do! m_0
          end do! i_1
*-
#if AT_BCAST_OVERLAP
!$        if ( TRBK_SWITCHED < 4 ) then
!$           call trbk_decide_overlap_level( i )
!$        end if
#endif
*-
          de = eigen_get_wtime()
          dz = dz + (de - ds)
!$OMP  END MASTER
*-
*-----------------------------------------------------------------
!$OMP  BARRIER
*-----------------------------------------------------------------
*-
! V:= V*(I-SM)^{-1}
! Z(j_2:j_3,1:n):= Z + V(j_2:j_3,1:m)*SS(1:m,1:n)
       if ( local_size==1 .OR. local_rank==1 ) then
          ds = eigen_get_wtime()
       end if
          call trbk2( z,
     $                nmz, v, nm, m,
     $                ss(1+ns0), ss(1),
     $                i_2,i_3,j_2,j_3 )

       if ( local_size==1 .OR. local_rank==1 ) then
          de = eigen_get_wtime()
!$        TRBK_TIME_TRBK2 = de - ds
          dy = dy + (de - ds)
       end if
*-
#if AT_BCAST_OVERLAP
!$     if ( TRBK_SWITCHED < 4 ) then
!$     if ( DO_OVERLAP_BCAST_LEVEL == 0 ) then
!$OMP     BARRIER
!$     end if
!$     end if
#endif
*-
       return
       end subroutine  trbakwy_body2
!===
#if AT_BCAST_OVERLAP
!===
!$     subroutine trbk_decide_overlap_level( i )
!$     use OMP_LIB
!$     use MPI
!$     use eigen_devel
!$     use eigen_libs
!$     use eigen_trbak
!$     implicit NONE
!$     integer, intent(in)    :: i
!$     integer                :: ll0, ll1, ll2, ll_(6)
!$     real(8)                :: BCAST_TIME(0:2)
!$     real(8)                :: f0, f1
!$     integer                :: local_rank, local_size
!$     integer                :: ierr
*-
!$        local_size = omp_get_num_threads()
!$        local_rank = omp_get_thread_num()
!$
!$        if ( local_size > 1 ) then
!$
!$        TRBK_TIME_COUNTER = TRBK_TIME_COUNTER + 1
!$        if ( TRBK_TIME_COUNTER >= TRBK_TIME_NEXT ) then
!$           f0 = 1D0 * (local_size-1) / local_size
!$           f1 = 1D0 / f0
!$           if ( DO_OVERLAP_BCAST_LEVEL == 2 ) then
!$              BCAST_TIME(0) = TRBK_TIME_BCAST 
!$   $                      + TRBK_TIME_TRBK2 * f0
!$   $                      + TRBK_TIME_TRBK1 * f0
!$              BCAST_TIME(1) = MAX( TRBK_TIME_BCAST,
!$   $                        TRBK_TIME_TRBK2 )
!$   $                      + TRBK_TIME_TRBK1 * f0
!$              BCAST_TIME(2) = MAX( TRBK_TIME_BCAST,
!$   $                        TRBK_TIME_TRBK2 
!$   $                      + TRBK_TIME_TRBK1 )
!$           endif
!$           if ( DO_OVERLAP_BCAST_LEVEL == 1 ) then
!$              BCAST_TIME(0) = TRBK_TIME_BCAST 
!$   $                      + TRBK_TIME_TRBK2 * f0
!$   $                      + TRBK_TIME_TRBK1
!$              BCAST_TIME(1) = MAX( TRBK_TIME_BCAST,
!$   $                        TRBK_TIME_TRBK2 )
!$   $                      + TRBK_TIME_TRBK1
!$              BCAST_TIME(2) = MAX( TRBK_TIME_BCAST,
!$   $                        TRBK_TIME_TRBK2
!$   $                      + TRBK_TIME_TRBK1 * f1)
!$           endif
!$           if ( DO_OVERLAP_BCAST_LEVEL == 0 ) then
!$              BCAST_TIME(0) = TRBK_TIME_BCAST
!$   $                      + TRBK_TIME_TRBK2
!$   $                      + TRBK_TIME_TRBK1
!$              BCAST_TIME(1) = MAX( TRBK_TIME_BCAST,
!$   $                        TRBK_TIME_TRBK2 * f1 )
!$   $                      + TRBK_TIME_TRBK1
!$              BCAST_TIME(2) = MAX( TRBK_TIME_BCAST,
!$   $                        TRBK_TIME_TRBK2 * f1
!$   $                      + TRBK_TIME_TRBK1 * f1 )
!$           end if
!$           ll0 = DO_OVERLAP_BCAST_LEVEL
!$           ll1 = 0; do ll2 = 1, 2
!$              if ( BCAST_TIME(ll1) >= BCAST_TIME(ll2) ) then
!$                 ll1 = ll2
!$              end if
!$           end do
!$           ll_(1:3)=0; ll_(ll1+1)=1
!$           call MPI_Allreduce( ll_(1), ll_(4),
!$   $                3, MPI_INTEGER, MPI_SUM, y_COMM_WORLD, ierr )
#if OVERLAP_DECISION_TYPE==3
!               type 3 mean value
!$           ll1 = 0; do ll2 = 1, 2
!$              if ( ll_(4+ll2) > ll_(4+ll1) ) then
!$                 ll1 = ll2
!$              end if
!$           end do
#endif
#if OVERLAP_DECISION_TYPE==2
!               type 2 max value
!$           do ll2 = 0, 2
!$              if ( ll_(4+ll2) > 0 ) then
!$                 ll1 = ll2
!$              end if
!$           end do
#endif
#if OVERLAP_DECISION_TYPE==1
!               type 1 min value
!$           do ll2 = 2, 0, -1
!$              if ( ll_(4+ll2) > 0 ) then
!$                 ll1 = ll2
!$              end if
!$           end do
#endif
#if _DEBUG_
!$           if ( TRD_inod == 1 ) then
!$                 print*, i, "Overlap decision", ll0,"->",ll1,
!$   $                    BCAST_TIME(0:2)
!$           end if
#endif
!$           if ( ll1 == 0 ) then
!$              TRBK_SWITCHED = TRBK_SWITCHED + 1
!$           end if
!$           if ( ll0 .NE. ll1 ) then
!$              if ( TRBK_SWITCHED >= 8 ) then
!$                 TRBK_TIME_INTERVAL = 32
!$              else
!$                 TRBK_TIME_INTERVAL = 1
!$              end if
!$           else
!$              TRBK_TIME_INTERVAL = TRBK_TIME_INTERVAL*2
!$           end if
!$           TRBK_TIME_NEXT = TRBK_TIME_NEXT + TRBK_TIME_INTERVAL
!$           DO_OVERLAP_BCAST_LEVEL = ll1
!$        end if
!$        else
!$           DO_OVERLAP_BCAST_LEVEL = 0
!$        end if
!===
!$        call omp_set_lock( TRBK_LOCK(1) )
!$        TRBK_LOCK(2) = 0
!$        call omp_unset_lock( TRBK_LOCK(1) )
!===
*-
!$     end subroutine
#endif
*-
       subroutine trbk1(z, nmz,
     $            v, nm, m, ss, sm, i_2,i_3,j_2,j_3)
!$     use OMP_LIB
       use MPI
       use eigen_devel
       use eigen_libs
       use eigen_trbak
       implicit NONE
*
       integer, intent(in)    :: nmz, nm, m
       integer, intent(in)    :: i_2, i_3, j_2, j_3
       real(8), intent(inout) :: z(nmz,*),v(nm,*)
       real(8), intent(inout) :: ss(m,*)
*
       real(8), intent(inout) :: sm(nsm,nsm)
*
       integer                :: i_1, i_4, i_5
       integer                :: j_1, j_4, j_5
       integer                :: i_0, j_0, m_0
       integer                :: ii_2, ii_3, ii_4
*
       real(8)                :: s0, s1, s2, s3
       real(8)                :: v0, v1, v2, v3
       real(8)                :: t0
*
       integer                :: local_rank, local_size
       integer                :: ll_rank, ll_size
*
       local_size = 1
       local_rank = 0
!$     local_size = omp_get_num_threads()
!$     local_rank = omp_get_thread_num()
*-
!$     if ( (DO_OVERLAP_BCAST_LEVEL <= 1 .AND. i_2 == 1) .OR.
!$   &      local_size == 1 .OR.
!$   &      local_rank >= 1 ) then
!$        if (
!$   &       (DO_OVERLAP_BCAST_LEVEL == 2 .AND. local_size > 1) .OR.
!$   &       (i_2 > 1 .AND. local_size > 1) ) then
!$         ll_size  = local_size - 1
!$         ll_rank  = local_rank - 1
!$      else
           ll_size  = local_size
           ll_rank  = local_rank
!$      endif
*-
        if ( i_2 == 1 ) then

          do j_0=j_2,j_3,nsx; j_4=MIN(j_0+nsx-1,j_3)

             do m_0=1+ll_rank,m-1,ll_size

                i_0 = m_0 + 1
                i_4 = MOD(m-m_0-1+1,4)+i_0
                if ( i_0 == i_4 - 1 ) then
                   s0 = sm(i_0+0,m_0)
!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
                   do j_1=j_0,j_4
                      t0 = v(j_1,m_0)
                      v0 = v(j_1,i_0+0)
                      s0 = s0+v0*t0
                   end do! k
                   sm(i_0+0,m_0) = s0
                end if
                if ( i_0 == i_4 - 2 ) then
                   s0 = sm(i_0+0,m_0)
                   s1 = sm(i_0+1,m_0)
!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
                   do j_1=j_0,j_4
                      t0 = v(j_1,m_0)
                      v0 = v(j_1,i_0+0)
                      v1 = v(j_1,i_0+1)
                      s0 = s0+v0*t0
                      s1 = s1+v1*t0
                   end do! k
                   sm(i_0+0,m_0) = s0
                   sm(i_0+1,m_0) = s1
                end if
                if ( i_0 == i_4 - 3 ) then
                   s0 = sm(i_0+0,m_0)
                   s1 = sm(i_0+1,m_0)
                   s2 = sm(i_0+2,m_0)
!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
                   do j_1=j_0,j_4
                      t0 = v(j_1,m_0)
                      v0 = v(j_1,i_0+0)
                      v1 = v(j_1,i_0+1)
                      v2 = v(j_1,i_0+2)
                      s0 = s0+v0*t0
                      s1 = s1+v1*t0
                      s2 = s2+v2*t0
                   end do! k
                   sm(i_0+0,m_0) = s0
                   sm(i_0+1,m_0) = s1
                   sm(i_0+2,m_0) = s2
                end if
                do i_0=i_4,m,4              ! 3

                   s0 = sm(i_0+0,m_0)
                   s1 = sm(i_0+1,m_0)
                   s2 = sm(i_0+2,m_0)
                   s3 = sm(i_0+3,m_0)
!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
                   do j_1=j_0,j_4
                      t0 = v(j_1,m_0)
                      v0 = v(j_1,i_0+0)
                      s0 = s0+v0*t0
                      v1 = v(j_1,i_0+1)
                      s1 = s1+v1*t0
                      v2 = v(j_1,i_0+2)
                      s2 = s2+v2*t0
                      v3 = v(j_1,i_0+3)
                      s3 = s3+v3*t0
                   end do! k
                   sm(i_0+0,m_0) = s0
                   sm(i_0+1,m_0) = s1
                   sm(i_0+2,m_0) = s2
                   sm(i_0+3,m_0) = s3
                end do! i_0

             end do! m_0

          end do! j_0
*-
        end if
*-
#if defined(__INTEL_COMPILER)
        j_5 = j_3 - j_2 + 1

        do ii_2 = i_2, i_3, (1024*ll_size)

          ii_3 = MIN(ii_2+(1024*ll_size)-1,i_3)
          ii_4 = ii_2-i_2+1

          i_0 = (ii_3-ii_2) / ll_size + 1
          i_4 = i_0 * ll_rank
          i_5 = MIN(i_0, ii_3-(ii_2+i_4)+1)

          if ( m > 0 .AND. j_5 > 0 .AND. i_5 > 0 ) then

             CALL DGEMM('T','N',
     &               m, i_5, j_5,
     &               1.0D+00, v (j_2    ,1       ), nm,
     &                        z (j_2    ,ii_2+i_4), nmz,
     &               1.0D+00, ss(1      ,ii_2+i_4), m)

          endif

        end do
#else
          j_5 = j_3 - j_2 + 1

          i_5 = (i_3-i_2) / ll_size + 1
          i_4 = i_5 * ll_rank
          i_5 = MIN(i_5, i_3-(i_2+i_4)+1)

          if ( m > 0 .AND. j_5 > 0 .AND. i_5 > 0 ) then

             CALL DGEMM('T','N',
     &               m, i_5, j_5,
     &               1.0D+00, v (j_2 ,1       ), nm,
     &                        z (j_2 ,i_2+i_4), nmz,
     &               1.0D+00, ss(1   ,i_2+i_4), m)

          endif
#endif
!$     end if
*-
       return
       end subroutine  trbk1
*-
       subroutine trbk2( z,
     $            nmz,
     $            v, nm, m, ss, sm, i_2,i_3, j_2,j_3 )
!$     use OMP_LIB
       use MPI
       use eigen_devel
       use eigen_libs
       use eigen_trbak
       implicit NONE
*
       integer, intent(in)    :: nmz, nm, m
       integer, intent(in)    :: i_2, i_3, j_2, j_3
       real(8), intent(inout) :: z(nmz,*)
       real(8), intent(inout) :: v(nm,*)
       real(8), intent(inout) :: ss(m,*)
*
       real(8), intent(inout) :: sm(nsm,*)

       integer                :: i_4, i_5
       integer                :: j_1, j_4, j_5, j_6, j_7, j_8
       integer                :: i_0, j_0, m_0
*
       real(8)                :: v0, v1, v2
       real(8)                :: u0, u1
*
       integer                :: local_rank, local_size
       integer                :: ll_rank, ll_size
*
       local_size = 1
       local_rank = 0
!$     local_size = omp_get_num_threads()
!$     local_rank = omp_get_thread_num()
*
*-
          j_5 = (j_3-j_2) / local_size + 1
          j_5 = ((j_5-1)/2+1)*2
          j_4 = j_5 * local_rank
          j_5 = MIN(j_5, j_3-(j_2+j_4)+1)
          j_6 = j_2+j_4
          j_7 = j_6+j_5-1
         
          do j_0=j_6,j_7,nsx; j_8=MIN(j_0+nsx-1,j_7)

             do m_0=m,1,-2

                i_0 = m
                i_4 = MOD(m-m_0, 3)
                if ( i_4 == 1 ) then
!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
                   do j_1=j_0,j_8
                      v0 = v(j_1,i_0-0)
                      u0 =
     $                    + sm(i_0-0,m_0  ) * v0
                      u1 =
     $                    + sm(i_0-0,m_0-1) * v0
                      v(j_1,m_0  ) = v(j_1,m_0  ) + u0
                      v(j_1,m_0-1) = v(j_1,m_0-1) + u1
                   end do! j_1
                end if
                if ( i_4 == 2 ) then
!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
                   do j_1=j_0,j_8
                      v0 = v(j_1,i_0-0)
                      v1 = v(j_1,i_0-1)
                      u0 =
     $                    + sm(i_0-0,m_0  ) * v0
     $                    + sm(i_0-1,m_0  ) * v1
                      u1 =
     $                    + sm(i_0-0,m_0-1) * v0
     $                    + sm(i_0-1,m_0-1) * v1
                      v(j_1,m_0  ) = v(j_1,m_0  ) + u0
                      v(j_1,m_0-1) = v(j_1,m_0-1) + u1
                   end do! j_1
                end if

                do i_0=m-i_4,m_0+1,-3
!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
                   do j_1=j_0,j_8
                      v0 = v(j_1,i_0-0)
                      v1 = v(j_1,i_0-1)
                      v2 = v(j_1,i_0-2)
                      u0 =
     $                    + sm(i_0-0,m_0  ) * v0
     $                    + sm(i_0-1,m_0  ) * v1
     $                    + sm(i_0-2,m_0  ) * v2
                      u1 =
     $                    + sm(i_0-0,m_0-1) * v0
     $                    + sm(i_0-1,m_0-1) * v1
     $                    + sm(i_0-2,m_0-1) * v2
                      v(j_1,m_0  ) = v(j_1,m_0  ) + u0
                      v(j_1,m_0-1) = v(j_1,m_0-1) + u1
                   end do! j_1
                end do! i_0

                i_0=m_0
!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
                   do j_1=j_0,j_8
                      v0 = v(j_1,i_0-0)
                      u1 =
     $                    + sm(i_0-0,m_0-1) * v0
                      v(j_1,m_0-1) = v(j_1,m_0-1) + u1
                   end do! j_1

             end do! m_0

          end do! j_0

!$OMP BARRIER
*-
!$     if ( (DO_OVERLAP_BCAST_LEVEL == 0) .OR.
!$   &      local_size == 1 .OR.
!$   &      local_rank >= 1 ) then

!$        if ( DO_OVERLAP_BCAST_LEVEL >= 1 .AND. local_size > 1 ) then
!$           ll_size  = local_size - 1
!$           ll_rank  = local_rank - 1
!$        else
             ll_size  = local_size
             ll_rank  = local_rank
!$        endif

          j_5 = j_3 - j_2 + 1

          i_5 = (i_3-i_2) / ll_size + 1
          i_4 = i_5 * ll_rank
          i_5 = MIN(i_5, i_3-(i_2+i_4)+1)

          if ( m > 0 .AND. j_5 > 0 .AND. i_5 > 0 ) then

             CALL DGEMM('N','N',
     &               j_5, i_5, m,
     &               1.0D+00, v (j_2    ,1      ), nm,
     &                        ss(1      ,1  +i_4), m,
     &               1.0D+00, z (j_2    ,i_2+i_4), nmz)

          end if

!$     end if
*-

       return
       end subroutine  trbk2

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 626 $)
!
!  FUNCTION:  Ending_Time(), ckiter(), ChargeDensity_is_Converged(), 
!             TotalEnergy_is_Divergent(), Forces_are_Converged(), 
!             Already_Converged(), EigenValues_are_Converged(), 
!              AllKpoints_are_Calculated()
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, December/01/2003, May/16/2005,
!                                     June/04/2005, April/10/2007
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
logical function Ending_Time()
! $Id: Convergence_Check.F90 626 2020-06-03 02:18:38Z jkoga $
  use m_Const_Parameters,   only : INITIAL, CONTINUATION, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                         , MAX_SCF_ITERATION_REACHED, MAX_MDSTEPS_REACHED, FSTOP
  use m_Files,              only : nfstop,nfout,m_Files_open_nfstop,m_Files_close_nfstop
  use m_IterationNumbers,   only : iteration, iteration_ionic, iteration_electronic
  use m_Control_Parameters, only : icond, ifstop, istop, max_total_scf_iteration, max_mdstep &
       &                         , max_TS_iteration_is_given, max_mdstep_is_given, printable &
       &                         , m_CtrlP_ckcput, m_CtrlP_rd_istop, terminated_because
  use m_Parallelization,    only : mype,mpi_comm_group

  implicit none
  include 'mpif.h'                                      ! MPI

  logical  :: torf
  integer :: ierr

  torf = m_CtrlP_ckcput()
  Ending_Time = torf

  if(.not.torf) &
       & Ending_Time = ckiter()           ! -(contained here)
!  call mpi_barrier(mpi_comm_world, ierr)
  if( .not. Ending_Time) then
    call Modify_Input_Settings()
  end if
  call mpi_barrier(mpi_comm_group, ierr)
contains
  logical function ckiter()
    integer :: imax, icaseflag
! --> T. Yamasaki, 14 July 2008
    integer, parameter :: FILE_F_INP = 1, FILE_F_INP_MDSTEP = 2
! <--
    character*8 :: file_cname
    character*9 :: c_iteration
    icaseflag = 0
    ckiter = .false.
    if(icond == INITIAL .or. icond == CONTINUATION) then
       imax = max(iteration, iteration_ionic)
#ifndef _EMPIRICAL_
       if(iteration == 0) imax = 0
#endif
!                                                                                 (max_TS_iteration_is_given, max_mdstep_is_given)
       if(max_TS_iteration_is_given .and. max_mdstep_is_given) then                   ! (.true., .true.)
! --> T. Yamasaki, 07 Aug. 2009
!!$          if(max_total_scf_iteration <= imax .or. max_mdstep <= iteration_ionic) then
          if(max_total_scf_iteration <= imax .or. max_mdstep <= iteration_ionic-1) then
! <--
             ckiter = .true.
             if(max_total_scf_iteration <= imax) then
                icaseflag = FILE_F_INP
                terminated_because = MAX_SCF_ITERATION_REACHED
             else
                icaseflag = FILE_F_INP_MDSTEP
                terminated_because = MAX_MDSTEPS_REACHED
             end if
          else if(ifstop >= 1) then
             ckiter = ckiter_ifstop(imax)
             if(ckiter) terminated_because = FSTOP
          end if
       else if(.not.max_mdstep_is_given) then                                         ! (.true., .false) or (.false., .false)
          if(max_total_scf_iteration <= imax) then
             ckiter = .true.
             icaseflag = FILE_F_INP
             terminated_because = MAX_SCF_ITERATION_REACHED
          else if(ifstop >= 1) then
             ckiter = ckiter_ifstop(imax)
             if(ckiter) terminated_because = FSTOP
          end if
       else if(.not.max_TS_iteration_is_given .and. max_mdstep_is_given) then         ! (.false., .true.)
! --> T. Yamasaki, 06 Aug. 2009
!!$          if(max_mdstep <= iteration_ionic) then
          if(max_mdstep <= iteration_ionic-1) then
! <--
             ckiter = .true.
             icaseflag = FILE_F_INP_MDSTEP
             terminated_because = MAX_MDSTEPS_REACHED
          else if(ifstop >= 1 ) then
             ckiter = ckiter_ifstop(imax)
             if(ckiter) terminated_because = FSTOP
          end if
       end if


!!$       if(max_total_scf_iteration <= imax .or. max_mdstep <= iteration_ionic) then
!!$          ckiter = .true.
!!$          if(max_total_scf_iteration <= imax) then
!!$             icaseflag = FILE_F_INP
!!$          else
!!$             icaseflag = FILE_F_INP_MDSTEP
!!$          end if
!!$       else if(ifstop >= 1) then
!!$          if(mod(imax,ifstop) == 0) then
!!$             call m_Files_open_nfstop
!!$             call m_CtrlP_rd_istop(nfstop)        ! ->istop
!!$             if(istop >= 0 .and. istop <= imax) ckiter = .true.
!!$             call m_Files_close_nfstop
!!$          else
!!$             if(istop >= 0 .and. istop <= imax) ckiter = .true.
!!$          end if
!!$       end if
    else if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then

       if(iteration > max_total_scf_iteration) then
          ckiter = .true.
          icaseflag = FILE_F_INP
          terminated_because = MAX_SCF_ITERATION_REACHED
       else
          imax = max(iteration, iteration_electronic)
!!$          imax = iteration_electronic
!!$       if(imax > ek_max_iteration) then
!!$          ckiter = .true.
!!$       else
!!$          write(nfout,'(" iteration_electronic = ",i6)') iteration_electronic
!!$          write(nfout,'("  ifstop = ",i6)') ifstop
          if(ifstop >= 1) then
             ckiter = ckiter_ifstop(imax)
             if(ckiter) terminated_because = FSTOP
          end if
       end if
    end if
    if(ckiter) then
       if(icaseflag .eq. FILE_F_INP_MDSTEP) then
          file_cname = ' <F_INP>'
          imax = max_mdstep
          c_iteration = ' mdstep  '
       else if(icaseflag .eq. FILE_F_INP) then
          file_cname = ' <F_INP>'
          imax = max_total_scf_iteration
          c_iteration = 'iteration'
       else
          file_cname = '<F_STOP>'
          imax = istop
          c_iteration = 'iteration'
       end if
       if(printable) write(nfout,'(" --- This job stops because the ",a9," has exceeded " &
                              & ,i6," set in the ",a8," file ---")') c_iteration, imax,file_cname
    end if
  end function ckiter

  logical function ckiter_ifstop(imax)
    integer, intent(in) :: imax
    ckiter_ifstop = .false.
    if(mod(imax,ifstop) == 0) then
       call m_Files_open_nfstop
       call m_CtrlP_rd_istop(nfstop)        ! ->istop
       if(istop >= 0 .and. istop <= imax) ckiter_ifstop = .true.
       call m_Files_close_nfstop
    else
       if(istop >= 0 .and. istop <= imax) ckiter_ifstop = .true.
    end if

  end function ckiter_ifstop

end function Ending_Time

#ifndef _EMPIRICAL_
logical function ChargeDensity_is_Converged()
  use m_Files,          only : nfout
  use m_Const_Parameters, only : ON, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, WHOLE, INITIALLY, DP, YES &
       &                   ,     CHARGE_CONVERGED
  use m_Control_Parameters, only : printable, sw_submat_is_on, submat_is_done_this_iter, icond &
       &                     , m_CtrlP_set_renew_wf, sw_hubbard, nspin, m_CtrlP_get_edelta &
       &                     , m_CtrlP_clear_lmm_status_store &
       &                     , max_scf_iteration, max_scf_iteration_is_given &
       &                     , m_CtrlP_set_iconvergence, terminated_because, istress
  use m_Charge_Density, only : m_CD_is_converged_core
  use m_Total_Energy,   only : m_TE_is_converged &
      &                      , m_TE_Converged_Hubbard_Energy, m_TE_edeltb
  use m_ES_WF_by_submat,only : m_ESsubmat_dealloc, m_ESsubmat_reset_non_diagon
  use m_Force,          only : m_Force_get_fec_count
  use m_ES_occup,       only : m_ESoc_efermi_diff, m_ESoc_new_total_spin, m_ESoc_total_spin0
  use m_Crystal_Structure,only : sw_fix_total_spin_in, sw_fix_total_spin,spin_fix_period &
       &                     , m_CS_set_total_spin, m_CS_free_fixed_total_spin, m_CS_fix_total_spin
  use m_Ionic_System,   only : natm2
  use m_IterationNumbers, only : iteration_electronic, iteration_ionic

! ====================== added by K. Tagami ======================= 12.0Exp
  use m_Const_Parameters,    only  : ALL_AT_ONCE, EK_CONVERGED
  use m_Control_Parameters,  only : fixed_charge_k_parallel, &
       &                            m_CtrlP_set_iconvergence,xctype
! ================================================================ 12.0Exp

! ====================== KT_Test ========================================= 12.5Exp
  use m_Const_Parameters,    only  : OFF
  use m_Control_Parameters,   only : sw_hybrid_functional, &
       &                             truncate_vxw_updating, sw_update_vxw, oneshot
! ======================================================================== 12.5Exp

! === Postitron SCF === 2015/11/28
  use m_Control_Parameters,  only : sw_positron, positron_method
  use m_Const_Parameters,   only : positron_GGGC
  use m_Positron_Wave_Functions,  only : m_pWF_update_lifetime
! ===================== 2015/11/28

  use m_Const_Parameters, only : CHG_CONVERGENCE_REACHED

  implicit none
  logical, save :: renew_wf_again = .false.
  logical :: EigenValues_are_Converged
  integer ::       fec_counter
!!$  real(kind=DP) :: total_spin_new, m_ESoc_new_total_spin, m_ESoc_efermi_diff &
!!$       &          ,Delta_Efermi
  real(kind=DP) :: total_spin_new, Delta_Efermi
  logical :: totalenergy_is_converged
  real(kind=DP) :: edeltb, edelta
  real(kind=DP),parameter :: delta_efermi_lower = 0.002
  real(kind=DP),parameter :: factor_initial = 10.0
  real(kind=DP),save :: factor = factor_initial

  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
     if(EigenValues_are_Converged()) then
        ChargeDensity_is_Converged = .true.
! ==================================== added by K. Tagami ============ 12.0Exp
        if ( fixed_charge_k_parallel == ALL_AT_ONCE ) then
           call m_CtrlP_set_iconvergence(EK_CONVERGED)
        endif
! ==================================================================== 12.0Exp
     else
        ChargeDensity_is_Converged = .false.
     end if
     return
  end if

  call m_Force_get_fec_count(fec_counter)
  if(fec_counter /= 0) then
     ChargeDensity_is_Converged = .true.
     if(printable) &
          & write(nfout,'(" !Convergence_Check: fec_counter = ",i8," is not zero")') fec_counter
  else
     if(renew_wf_again) then
        ChargeDensity_is_Converged = .true.
     else
! --> T. Yamasaki 07th Aug. 2009
        totalenergy_is_converged = m_TE_is_converged(nfout)
!!$        if(m_TE_is_converged(nfout)) then
        if(totalenergy_is_converged) then
           if(nspin == 2 .and. sw_fix_total_spin == YES .and. spin_fix_period == INITIALLY) then
              ChargeDensity_is_Converged = .false.
           else
              ChargeDensity_is_Converged = m_CD_is_converged_core(nfout)
           end if
! <--
        else
           ChargeDensity_is_Converged = .false.
        endif
! --> T. Yamasaki 06th Aug. 2009
        if(nspin == 2 .and. sw_fix_total_spin == YES .and. spin_fix_period >= INITIALLY) then
! -->       17th Aug. 2009
           if(spin_fix_period.gt.1 .and. iteration_electronic>=spin_fix_period)then
              call m_CS_free_fixed_total_spin(nfout)
           else if(iteration_electronic>=20 .and. spin_fix_period==INITIALLY) then
!!$                 Delta_efermi = m_ESoc_efermi_diff()
!!$              if(totalenergy_is_converged .and. dabs(Delta_efermi) < delta_efermi_lower ) then
!!$              if(totalenergy_is_converged .and. dabs(Delta_efermi) < delta_efermi_lower ) then
!!$                 if(printable) write(nfout,'(" !** dabs(Delta_efermi) = dabs(",f16.8 &
!!$                      &                        ,") < Delta_efermi_lower = ",f16.8, " and total energy is converged")') &
!!$                      &               delta_efermi, delta_efermi_lower
!!$                 call m_CS_free_fix_total_spin(nfout) ! sw_fix_total_spin = NO
              edeltb = m_TE_edeltb()
              call m_CtrlP_get_edelta(edelta)
              if(dabs(edeltb) < edelta*natm2*factor) then
                 factor = factor/2.0
                 if(factor < 1.0) factor = 1.0
                 if(printable) write(nfout,'(" dabs(edeltb) = dabs(",f16.12,") < edelta*natm2*factor = ",f16.12)') &
                      & edeltb, edelta*natm2*factor
! -->   
                 if(iteration_ionic >= 10) then   ! This is a test case
! <--
                    Delta_efermi = m_ESoc_efermi_diff()
                    if( dabs(Delta_efermi) < delta_efermi_lower ) then
                       if(printable) write(nfout,'(" !** dabs(Delta_efermi) = dabs(",f16.8 &
                            &                        ,") < Delta_efermi_lower = ",f16.8, " and total energy is converged")') &
                            &               delta_efermi, delta_efermi_lower
                       call m_CS_free_fixed_total_spin(nfout) ! sw_fix_total_spin = NO
                    else
                       if(totalenergy_is_converged) ChargeDensity_is_Converged = m_CD_is_converged_core(nfout)
                       if(.not.ChargeDensity_is_Converged) then
                          total_spin_new = m_ESoc_new_total_spin()
                          call m_CS_set_total_spin(nfout,total_spin_new)
                       end if
                    end if
                 else
                    if(totalenergy_is_converged) ChargeDensity_is_Converged = m_CD_is_converged_core(nfout)
                    if(.not.ChargeDensity_is_Converged) then
                       total_spin_new = m_ESoc_new_total_spin()
                       call m_CS_set_total_spin(nfout,total_spin_new)
                    end if
                 end if
              end if
           end if
!!$           if(iteration_electronic>=30 .and. mod(iteration_electronic,10)==1) then
!!$              Delta_efermi = m_ESoc_efermi_diff()
!!$              if(totalenergy_is_converged .and. dabs(Delta_efermi) < delta_efermi_lower ) then
!!$                 if(printable) write(nfout,'(" !** dabs(Delta_efermi) = dabs(",f16.8 &
!!$                      &                        ,") < Delta_efermi_lower = ",f16.8, " and total energy is converged")') &
!!$                      &               delta_efermi, delta_efermi_lower
!!$                 call m_CS_free_fix_total_spin(nfout) ! sw_fix_total_spin = NO
!!$              else
!!$                 total_spin_new = m_ESoc_new_total_spin()
!!$                 call m_CS_set_total_spin(nfout,total_spin_new)
!!$              end if
!!$           end if
! <--
        end if
! <--
     end if

     if ( sw_positron /= OFF ) then
        if ( positron_method == positron_GGGC ) call m_pWF_update_lifetime
     endif

! =========================== KT_Test ================= 12.5Exp
     if ( sw_hybrid_functional == ON ) then
        if ( truncate_vxw_updating .and. sw_update_vxw == OFF ) then
           ChargeDensity_is_Converged = .true.
        end if
     end if
! ====================================================== 12.5Exp

     if(sw_hubbard == ON) then
        if(m_TE_Converged_Hubbard_Energy(nfout)) then
           ChargeDensity_is_Converged = .true.
        end if
     end if

! --> T. Yamasaki, 18th Aug. 2009
     if(max_scf_iteration_is_given) then
        if(iteration_electronic >= max_scf_iteration) then
           if( .not. ChargeDensity_is_Converged .and. istress==ON) then
             stop 'max_scf_iteration cannot be used in conjunction with stress calculations'
           endif
           ChargeDensity_is_Converged = .true.
        end if
     end if
! <--
     if(ChargeDensity_is_Converged) then
        call m_CtrlP_set_iconvergence(CHARGE_CONVERGED)
        if(renew_wf_again) then
           renew_wf_again = .false.
           call m_ESsubmat_dealloc()
        else if(sw_submat_is_on .and. .not.renew_wf_again) then
           if(.not.submat_is_done_this_iter) then
              if(printable) write(nfout,'(" !! sw_submat_is_on = .true. and renew_wf_again = .false.")')
              ChargeDensity_is_Converged = .false.
              renew_wf_again = .true.
              call m_ESsubmat_reset_non_diagon()
           end if
        else ! if(.not.sw_submat_is_on .and. .not.renew_wf_again) then
           call m_ESsubmat_dealloc()
        end if
! --> T. Yamasaki, 17th Aug. 2009
        if(nspin == 2 .and. sw_fix_total_spin_in == YES .and. spin_fix_period == INITIALLY) then
           call m_CS_fix_total_spin(nfout)
           total_spin_new = m_ESoc_total_spin0()
           call m_CS_set_total_spin(nfout,total_spin_new)
           factor = factor_initial
        end if
! <--
        call m_CtrlP_clear_lmm_status_store() ! --> T. Yamasaki, 18th Aug. 2009
#ifndef DISABLE_VDWDF
        if(xctype == 'vdwdf'.and.oneshot) call vdW_oneshot()
#endif
     end if
     call m_CtrlP_set_renew_wf(renew_wf_again)
  end if
  if(ChargeDensity_is_Converged) then
    terminated_because = CHG_CONVERGENCE_REACHED
  endif
end function ChargeDensity_is_Converged

logical function TotalEnergy_is_Divergent()
  use m_Const_Parameters, only : SCF_ITERATION
  use m_Total_Energy, only : m_TE_is_Divergent_core
  use m_Files,        only : nfout
! --> T. Yamasaki, 22nd July 2008
  use m_Control_Parameters,only : ipri,m_CtrlP_etot_1dsrch_divergent
  use m_IterationNumbers,  only : iteration_ionic, iteration_electronic
  implicit none
  call Checkpoint_File(SCF_ITERATION)
  TotalEnergy_is_Divergent = m_TE_is_Divergent_core(nfout)
  if(iteration_ionic > 1 .and. .not.TotalEnergy_is_Divergent) then
     TotalEnergy_is_Divergent = m_CtrlP_etot_1dsrch_divergent(iteration_electronic)
     if(TotalEnergy_is_Divergent) then
        if(ipri >= 1) write(nfout,'(" m_CtrlP_etot_1dsrch_divergent is .true.")')
     end if
  end if
! <--
end function TotalEnergy_is_Divergent

#endif

logical function AllForces_are_Converged()
  AllForces_are_Converged = .true.
end function AllForces_are_Converged

logical function Forces_are_Converged2()
  use m_Control_Parameters, only : sw_phonon, m_CtrlP_set_iconvergence, terminated_because
  use m_Const_Parameters, only : ON, OFF, FORCE_CONVERGED, FORCE_CONVERGENCE_REACHED &
  &                            , MAX_PHSTEPS_REACHED
  use m_Ionic_System, only : iend_phonon, istart_phonon
  use m_IterationNumbers, only : iteration_ionic
  use m_Crystal_Structure, only : m_CS_phonon_symmetry
  implicit none
  Forces_are_Converged2 = .false.
  if (sw_phonon == OFF) return
  Forces_are_Converged2 = iteration_ionic>iend_phonon-istart_phonon+1
  if(Forces_are_Converged2) then
    call m_CtrlP_set_iconvergence(FORCE_CONVERGED)
    !terminated_because = FORCE_CONVERGENCE_REACHED
    terminated_because = MAX_PHSTEPS_REACHED
  endif
  if(Forces_are_Converged2) call m_CS_phonon_symmetry(ON)
end function Forces_are_Converged2


logical function Forces_are_Converged()
  use m_Control_Parameters, only : imdalg, ipriforce, icond, sw_phonon_oneshot &
       &                         , m_CtrlP_set_iconvergence &
       &                         , m_CtrlP_what_is_mdalg,sw_optimize_lattice, sw_stress_correction &
       &                         , sw_displace_atom, terminated_because &
#ifndef _EMPIRICAL_
       &                         , m_CtrlP_renew_edelta_ontheway, m_CtrlP_edelta_final &
       &                         , m_CtrlP_reset_edelta_ontheway
#else
       &                         , m_CtrlP_renew_edelta_ontheway, m_CtrlP_edelta_final
#endif
  use m_Const_Parameters,   only : DP,QUENCHED_CONSTRAINT,BLUEMOON &
       &                         , TEMPERATURE_CONTROL, FORCE_CONVERGED &
       &                         , VERLET, CNSTRA, ORDINA, WITHOUTTAG &
       &                         , WITHTAG, PHONON_FORCE &
       &                         , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, ON, INITIAL, OFF &
       &                         , PT_CONTROL, P_CONTROL, STREVL_ITERATION, FORCE_CONVERGENCE_REACHED &
       &                         , MAX_PHSTEPS_REACHED, QUENCHED_MD
  use m_Files,              only : nfout
  use m_IterationNumbers,   only : iteration_ionic,iteration,iteration_electronic
  use m_Ionic_System,       only : constraints_exist, move_constrained_plane, apply_constant_force &
       &                         , ekina,ega,almda,mdmode &
       &                         , forcmx_constraint_quench, cps, natm &
       &                         , m_IS_force_check_md_cnstr &
       &                         , m_IS_set_mdmode_cnstra &
       &                         , m_IS_set_mdmode_ordina &
       &                         , m_IS_evaluate_v_verlet &
       &                         , m_IS_moved_distance_of_plane_is_over & ! T. Yamaksai, 29 Apr. 2021
       &                         , m_IS_iter_ionic_is_over &              ! T. Yamasaki,  9 Jun  2021
! --> T. Yamasaki, 18 July 2008
       &                         , m_IS_cnstr_is_fixed_nhp &
       &                         , m_IS_force_check_md_nhp &
       &                         , m_IS_rigid_body_converged &
       &                         , m_IS_rigid_body_exists
! <--
#ifndef _EMPIRICAL_
  use m_Phonon,             only : m_Phonon_Check_iteration
#endif
  use m_Force,              only : forcmx, forc_l &
       &                         , m_Forces_are_Converged_core
!!$       &                         , m_Forces_clear_fec_counter
  use m_Total_Energy,       only : etotal
  use m_Stress,             only : m_Stress_in_correction

  implicit none
  integer :: mdalg, iret
  logical :: unitcell_can_change

  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
     Forces_are_Converged = .true.
     return
  end if

!  if(m_Stress_in_correction(2)) then
  if(m_Stress_in_correction(2)) then
    Forces_are_Converged = .true.
    return
  endif

  call Checkpoint_File(STREVL_ITERATION)
  if(sw_displace_atom == ON) then
     Forces_are_Converged = .true.
     !return
  endif

  if(imdalg == QUENCHED_CONSTRAINT) then
     if(constraints_exist .and. move_constrained_plane) then
        if(m_IS_force_check_md_cnstr() .and. m_CtrlP_edelta_final()) then
           call m_IS_set_mdmode_cnstra()
#ifndef _EMPIRICAL_
           call m_CtrlP_reset_edelta_ontheway()
#endif
        else
           call m_IS_set_mdmode_ordina()
        end if
        Forces_are_Converged = .false.
        if( m_IS_moved_distance_of_plane_is_over()) Forces_are_Converged = .true.
     else
        call m_IS_set_mdmode_ordina()
        Forces_are_Converged = m_IS_force_check_md_cnstr()
        if(.not.m_CtrlP_edelta_final()) Forces_are_Converged = .false.
        if(ipriforce >= 3)  then
           if(Forces_are_Converged) then
              write(nfout,'(" Forces_are_Converged(2) = .true.")')
           else
              write(nfout,'(" Forces_are_Converged(2) = .false.")')
           end if
        end if
     end if
  else if(imdalg == PT_CONTROL .or. imdalg == P_CONTROL) then
     Forces_are_Converged = .true.
  else if(imdalg == TEMPERATURE_CONTROL .or. imdalg == VERLET) then
     Forces_are_Converged = .false.
#ifndef _EMPIRICAL_
  else if(imdalg == PHONON_FORCE) then
     if(sw_phonon_oneshot == ON) then
        Forces_are_Converged = .true.
     else
        Forces_are_Converged = m_Phonon_Check_iteration(iteration_ionic)
	icond = INITIAL  ! asms
     end if
#endif
  else if(imdalg /= BLUEMOON) then
     if(constraints_exist .and. move_constrained_plane) then
        if(apply_constant_force <= 0) then
           if((m_Forces_are_Converged_core() .and. m_CtrlP_edelta_final()) &
                &                        .or. m_IS_iter_ionic_is_over()) then ! This is a different
           !                                                                  line to the case of
           !                                                                 (imdalg == 
           !                                                                   QUENCHED_CONSTRAINT). 
           call m_IS_set_mdmode_cnstra()
#ifndef _EMPIRICAL_
           call m_CtrlP_reset_edelta_ontheway()
#endif
           else
              call m_IS_set_mdmode_ordina()
           end if
        else
           call m_IS_set_mdmode_ordina()
        end if
        Forces_are_Converged = .false.
        if( m_IS_moved_distance_of_plane_is_over()) Forces_are_Converged = .true. ! T. Yamasaki, 29 Apr. 2021
!  --> T. Yamasaki, 18 July 2008
     else if(constraints_exist .and. m_IS_cnstr_is_fixed_nhp()) then
        if(m_IS_force_check_md_nhp()) then
           Forces_are_Converged = .true.
        else
           Forces_are_Converged = .false.
        end if
! <--
     else
        call m_IS_set_mdmode_ordina()
        Forces_are_Converged = m_Forces_are_Converged_core()
        if(.not.m_CtrlP_edelta_final()) Forces_are_Converged = .false.
     end if
  end if
  if(Forces_are_Converged .and. m_IS_rigid_body_exists()) then
     Forces_are_Converged = m_IS_rigid_body_converged()
  endif
  if(Forces_are_Converged) call m_CtrlP_set_iconvergence(FORCE_CONVERGED)
  mdalg = m_CtrlP_what_is_mdalg()

  if(Forces_are_Converged) then
!!$     call m_Forces_clear_fec_counter()
     if(mdalg == VERLET) call m_IS_evaluate_v_verlet(mdalg,forc_l)

     call wd_forces_cps_etotal_and_etc(mdalg,.true.) ! nfdynm
     if(.not.unitcell_can_change()) then
       call wd_forces_cps_etotal_and_etc(mdalg,.false.) ! nfenf
     else if (sw_optimize_lattice==OFF .and. sw_stress_correction==ON) then
       call wd_forces_cps_etotal_and_etc(mdalg,.false.) ! nfenf
     endif
#ifndef _EMPIRICAL_
     call m_CtrlP_reset_edelta_ontheway()
#endif
     if(imdalg == PHONON_FORCE)then
       terminated_because = MAX_PHSTEPS_REACHED
     else
       terminated_because = FORCE_CONVERGENCE_REACHED
     endif
  else
     if(imdalg /= BLUEMOON .and. imdalg /= TEMPERATURE_CONTROL &
          & .and. imdalg /= VERLET .and. imdalg /= PHONON_FORCE) then 
        if(imdalg /= QUENCHED_CONSTRAINT) then
           call m_CtrlP_renew_edelta_ontheway(nfout,etotal,forcmx,iteration_ionic,iteration,iteration_electronic)
        else if(imdalg == QUENCHED_CONSTRAINT) then
           call m_CtrlP_renew_edelta_ontheway(nfout,etotal,forcmx_constraint_quench,iteration_ionic,iteration,iteration_electronic)
        end if
     end if
  end if
  write(nfout,'(" <<Forces_are_Converged>>, Forces_are_Converged = ",L4)') Forces_are_Converged
  call flush(nfout)

end function Forces_are_Converged

logical function UnitCell_Converged(force_converged)
   use m_Control_Parameters, only : sw_optimize_lattice,imdalg,m_CtrlP_reset_iconvergence,icond &
      &                           , terminated_because,sw_stress_correction
   use m_Const_Parameters, only : ON, OFF,FIXED_CHARGE,FIXED_CHARGE_CONTINUATION,UNITCELL_ITERATION &
      &                         , STRESS_CONVERGENCE_REACHED, PT_CONTROL, P_CONTROL, MAX_MDSTEPS_REACHED
   use m_UnitCell, only : m_UC_converged
   use m_Stress,   only : m_Stress_in_correction
   implicit none
   logical, intent(in) :: force_converged
   logical :: unitcell_can_change,Rightafter_stress_correction
   if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
      UnitCell_Converged = .true.
      return
   endif
   if(m_Stress_in_correction()) then
      UnitCell_Converged = .false.
      return
   endif
   if(.not.unitcell_can_change())then
      UnitCell_Converged = force_converged
      return
   endif
   if(sw_optimize_lattice==OFF .and. sw_stress_correction==ON .and. .not.m_Stress_in_correction()) then
      UnitCell_Converged = force_converged
      return
   endif
   UnitCell_Converged = m_UC_converged() .and. force_converged
   if(force_converged) call wd_forces_cps_etotal_and_etc(imdalg,.false.) ! nfenf
   if(.not.UnitCell_Converged) then
      call m_CtrlP_reset_iconvergence()
      call Checkpoint_File(UNITCELL_ITERATION)
   else
      if(imdalg == PT_CONTROL .or. imdalg == P_CONTROL) then
        terminated_because = MAX_MDSTEPS_REACHED
      else
        terminated_because = STRESS_CONVERGENCE_REACHED
      endif
   endif
end function UnitCell_Converged

subroutine wd_forces_cps_etotal_and_etc(mdalg,flag_dynm)
  use m_Const_Parameters,   only : DP,QUENCHED_CONSTRAINT, BLUEMOON &
       &                         , TEMPERATURE_CONTROL &
       &                         , VERLET, CNSTRA, WITHOUTTAG &
       &                         , WITHTAG, OFF, ON, P_CONTROL, PT_CONTROL, DRIVER_URAMP, DRIVER_SC_DFT
  use m_Files,              only : nfout, nfenf, nfdynm, m_Files_flush_nfdynm, m_Files_flush_nfenf, nfdynm_cif
  use m_IterationNumbers,   only : iteration_ionic,iteration,iteration_electronic,iteration_unit_cell &
       &                         , iteration_uramp,iteration_scdft
  use m_Parallelization,    only : mype
  use m_Control_Parameters, only : ipriforce, iprivelocity &
       &                         , m_CtrlP_flag_wd_force &
       &                         , m_CtrlP_set_flag_wd_force_1 &
       &                         , sw_optimize_lattice &
       &                         , sw_cif_output, xctype, printable, driver &
       &                         , sw_nnp_output, m_CtrlP_edelta_for_sampling, frequency_nnp &
       &                         , filetype_nnp
  use m_Force,              only : forcmx, forc_l &
       &                         , m_Force_wd_force_and_cps &
       &                         , m_Force_wd_force_cps_cpd &
!!$       &                         , m_Force_cal_absforc &
       &                         , m_Force_wd_force_and_cps_lim &
       &                         , m_Force_wd_force_cps_cpd_lim
  use m_Ionic_System,       only : ekina,ega,almda,mdmode &
       &                         , forcmx_constraint_quench, cps,cpd_l,natm &
       &                         , constraints_exist, forcmx_hyperplane_vert &
       &                         , m_IS_cnstr_is_fixed_nhp &
       &                         , m_IS_wd_speciesname_etc &
       &                         , m_IS_dump_cif &
       &                         , m_IS_dump_nnpfiles &
       &                         , m_IS_rigid_body_exists, torque_max, trans_force_max
  use m_Total_Energy,       only : etotal
  use m_Stress,             only : m_Stress_get_stressmx
  use m_XC_Potential,       only : ecor
  use m_UnitCell,           only : m_UC_get_hamiltonian,m_UC_get_curr_pressure,m_UC_get_curr_temperature

  implicit none
  integer, intent(in) :: mdalg
  logical, intent(in) :: flag_dynm

  integer, parameter :: N_FORC = 10

  integer :: flag_wd_force

  character :: cion*256,ctot*256
  integer, parameter :: big_ion=100000, big_tot=big_ion*1000
  integer :: iketa

  if(iteration_ionic<big_ion) then
     cion='i5'
  else
     iketa = int(floor(log10(dble(iteration_ionic))))+2
     write(cion,*) iketa
     cion = 'i'//trim(adjustl(cion))
  endif

  if(iteration<big_tot) then
     ctot='i8'
  else
     iketa = int(floor(log10(dble(iteration))))+2
     write(ctot,*) iketa
     ctot = 'i'//trim(adjustl(ctot))
  endif

  if(flag_dynm) then
     flag_wd_force = m_CtrlP_flag_wd_force()
     call wd_forces_and_cps(flag_wd_force)
     if(flag_wd_force == 0) call m_CtrlP_set_flag_wd_force_1()
  else
     call wd_etotal_etc()
  end if

contains
    subroutine wd_etotal_etc
    integer        :: wd_flag = 0
    real(kind=DP)  :: econst
    real(kind=DP)  :: stressmx,temp
    real(kind=DP)  :: big=10000000.d0
    if(wd_flag == 0) then
       if( m_IS_rigid_body_exists()) then

       if(mdalg == VERLET .or. mdalg == TEMPERATURE_CONTROL) then
          if(mype == 0) write(nfenf,*) &
               & ' iter_ion, iter_total, etotal, ekina, econst, forcmx, transmx, torqmx'
       else if(mdalg == BLUEMOON) then
          if(mype == 0) write(nfenf,*) &
               & ' iter_ion, iter,etotal,ekina,econst,almda,forcmx'
       else if(mdalg == P_CONTROL .or. mdalg == PT_CONTROL)then
          if(mype == 0) write(nfenf,*) &
               & ' iter_ion, iter_total, etotal, ekina, econst, forcmx, pressure, transmx, torqmx'
       else if(driver == DRIVER_URAMP) then
          if(mype == 0) write(nfenf,*) &
               & ' iter_uramp, iter_ion, iter_total, etotal, forcmx, transmx, torqmx'
       else if(driver == DRIVER_SC_DFT) then
          if(mype == 0) write(nfenf,*) &
               & ' iter_scdft, iter_ion, iter_total, etotal, forcmx, transmx, torqmx'
       else
          if(sw_optimize_lattice==OFF)then
          if(mype == 0) write(nfenf,*) ' iter_ion, iter_total, etotal, forcmx, transmx, torqmx'
          else
          if(mype == 0) write(nfenf,*) ' iter_unitcell, iter_ion, iter_total, etotal, forcmx, stressmx, transmx, torqmx'
          endif
       end if

       else

       if(mdalg == VERLET .or. mdalg == TEMPERATURE_CONTROL) then
          if(mype == 0) write(nfenf,*) &
               & ' iter_ion, iter_total, etotal, ekina, econst, forcmx'
       else if(mdalg == BLUEMOON) then
          if(mype == 0) write(nfenf,*) &
               & ' iter_ion, iter,etotal,ekina,econst,almda,forcmx'
       else if(mdalg == P_CONTROL .or. mdalg == PT_CONTROL)then
          if(mype == 0) write(nfenf,*) &
               & ' iter_ion, iter_total, etotal, ekina, econst, forcmx, pressure'
       else if(driver == DRIVER_URAMP) then
          if(mype == 0) write(nfenf,*) &
               & ' iter_uramp, iter_ion, iter_total, etotal, forcmx'
       else if(driver == DRIVER_SC_DFT) then
          if(mype == 0) write(nfenf,*) &
               & ' iter_scdft, iter_ion, iter_total, etotal, forcmx'
       else
          if(sw_optimize_lattice==OFF)then
          if(mype == 0) write(nfenf,*) ' iter_ion, iter_total, etotal, forcmx'
          else
          if(mype == 0) write(nfenf,*) ' iter_unitcell, iter_ion, iter_total, etotal, forcmx, stressmx'
          endif
       end if

       endif
       wd_flag = 1
    end if
    if(xctype=='ggapbey')then
       if(printable) then
          write(nfout,'(a)') ' !** subtracting the correlation energy from the total energy'
          write(nfout,'(a)') ' !** since xctype is ggapbey '
       endif
       etotal = etotal-ecor
    endif

    if(m_IS_rigid_body_exists()) then

    if(mdalg == VERLET .or. mdalg == TEMPERATURE_CONTROL) then
       if(mdalg == TEMPERATURE_CONTROL) then
          econst = etotal + ega
       else
          econst = etotal + ekina
       end if
       if(mype == 0) then
          if(mdmode == CNSTRA) then
             if(abs(etotal)<big)then
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',6f20.10,"  converged_in_a_plane")') &
                  & iteration_ionic, iteration, etotal, ekina, econst,  forcmx, trans_force_max, torque_max
             else
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))// &
                  & '," ",f0.10," ",f0.10," ",f0.10," ",f0.10," ",f0.10," ",f0.10"  converged_in_a_plane")') &
                  & iteration_ionic, iteration, etotal, ekina, econst,  forcmx, trans_force_max, torque_max
             endif
          else
             if(abs(etotal)<big)then
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',6f20.10)') iteration_ionic, iteration &
                  &, etotal, ekina, econst,  forcmx, trans_force_max, torque_max
             else
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))// &
                  & '," ",f0.10," ",f0.10," ",f0.10," ",f0.10," ",f0.10," ",f0.10)') iteration_ionic, iteration &
                  &, etotal, ekina, econst,  forcmx, trans_force_max, torque_max
             endif
          end if
       end if
    else if(mdalg == BLUEMOON) then
       econst = etotal + ega
       if(mype == 0) then
            if(abs(etotal)<big)then
            write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',7f20.8)') iteration_ionic, iteration &
            &, etotal, ekina, econst, almda, forcmx, trans_force_max, torque_max
            else
            write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))// &
            & '," ",f0.8," ",f0.8," ",f0.8," ",f0.8," ",f0.8," ",f0.8," ",f0.8)') iteration_ionic, iteration &
            &, etotal, ekina, econst, almda, forcmx, trans_force_max, torque_max
            endif
       endif
    else if(mdalg == QUENCHED_CONSTRAINT) then
       if(mype == 0) then
          if(mdmode == CNSTRA) then
             if(abs(etotal)<big)then
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',4f20.10," converged_in_a_plane")') &
                  & iteration_ionic, iteration, etotal, forcmx_constraint_quench, trans_force_max, torque_max
             else
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))// &
                  &'," ",f0.10," ",f0.10," ",f0.10," ",f0.10," converged_in_a_plane")') iteration_ionic, iteration &
                  &, etotal, forcmx_constraint_quench, trans_force_max, torque_max
             endif
          else
             if(abs(etotal)<big)then
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',4f20.10)') iteration_ionic, iteration &
                  &, etotal, forcmx_constraint_quench, trans_force_max, torque_max
             else
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ",f0.10," ",f0.10," ",f0.10," ",f0.10)') &
                  & iteration_ionic, iteration, etotal, forcmx_constraint_quench, trans_force_max, torque_max
             endif
          end if
       end if
    else if (mdalg == PT_CONTROL .or. mdalg == P_CONTROL) then
        econst = m_UC_get_hamiltonian()
        stressmx = m_UC_get_curr_pressure()
        temp = m_UC_get_curr_temperature()
        if(mype == 0)then
        if(abs(etotal)<big)then
        write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',7f20.10)') iteration_unit_cell, iteration &
             &, etotal, temp, econst, forcmx, stressmx, trans_force_max, torque_max
        else
        write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))// &
        &     '," ",f0.10," ",f0.10," ",f0.10," ",f0.10," ",f0.10," ",f0.10," ",f0.10)') &
        &     iteration_unit_cell, iteration, etotal, temp, econst, forcmx, stressmx, trans_force_max, torque_max
        endif
        endif
    else if (driver == DRIVER_URAMP) then
       if(mype == 0)then
          if(abs(etotal)<big)then
          write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))//',4f20.10)') &
               & iteration_uramp,iteration_ionic, iteration &
               &, etotal, forcmx, trans_force_max, torque_max
          else
          write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))// &
               & '," ",f0.10," ",f0.10," ",f0.10," ",f0.10)') iteration_uramp,iteration_ionic, iteration &
               &, etotal, forcmx, trans_force_max, torque_max
          endif
       endif
    else if (driver == DRIVER_SC_DFT) then
       if(mype == 0)then
          if(abs(etotal)<big)then
          write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))//',4f20.10)') &
               & iteration_scdft,iteration_ionic, iteration, etotal, forcmx, trans_force_max, torque_max
          else
          write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))// &
               & '," ",f0.10," ",f0.10," ",f0.10," ",f0.10)') iteration_scdft,iteration_ionic, iteration &
               &, etotal, forcmx, trans_force_max, torque_max
          endif
       endif
    else
       if(mype == 0) then
          if(mdmode == CNSTRA) then
             if(abs(etotal)<big)then
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',4f20.10," converged_in_a_plane")') &
                  &  iteration_ionic, iteration &
                  &, etotal, forcmx, trans_force_max, torque_max
             else
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//&
                  &  '," ",f0.10," ",f0.10," ",f0.10," ",f0.10," converged_in_a_plane")') iteration_ionic, iteration &
                  &, etotal, forcmx, trans_force_max, torque_max
             endif
          else
             if(sw_optimize_lattice==OFF)then
!  --> T. Yamasaki, 18 July 2008
             if(constraints_exist .and. m_IS_cnstr_is_fixed_nhp() &
                  & .and. forcmx_hyperplane_vert < forcmx ) then
                if(abs(etotal)<big)then
                write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',4f20.10)') iteration_ionic, iteration &
                     &, etotal, forcmx_hyperplane_vert, trans_force_max, torque_max
                else
                write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ",f0.10," ",f0.10," ",f0.10," ",f0.10)') &
                     &  iteration_ionic, iteration, etotal, forcmx_hyperplane_vert, trans_force_max, torque_max
                endif
             else
                if(abs(etotal)<big)then
                write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',4f20.10)') iteration_ionic, iteration &
                     &, etotal, forcmx, trans_force_max, torque_max
                else
                write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ",f0.10," ",f0.10," ",f0.10," ",f0.10)') &
                     &  iteration_ionic, iteration, etotal, forcmx, trans_force_max, torque_max
                endif
             end if
!  <--
             else
                stressmx = m_Stress_get_stressmx()
                if(stressmx>=0) then
                  if(abs(etotal)<big)then
                  write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))//',5f20.10)') &
                       & iteration_unit_cell, iteration_ionic, iteration, etotal, forcmx,stressmx, trans_force_max, torque_max
                  else
                  write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))// &
                       &  '," ",f0.10," ",f0.10," ",f0.10," ",f0.10," ",f0.10)') &
                       &  iteration_unit_cell, iteration_ionic, iteration, etotal, forcmx,stressmx, trans_force_max, torque_max
                  endif
                else
                  if(abs(etotal)<big)then
                  write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))//',4f20.10)')  &
                       &  iteration_unit_cell, iteration_ionic, iteration, etotal, forcmx, trans_force_max, torque_max
                  else
                  write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))// &
                       &  '," ",f0.10," ",f0.10," ",f0.10," ",f0.10)') iteration_unit_cell, &
                       &  iteration_ionic, iteration, etotal, forcmx, trans_force_max, torque_max
                  endif
                endif
             endif
          end if
       end if
    end if

    else

    if(mdalg == VERLET .or. mdalg == TEMPERATURE_CONTROL) then
       if(mdalg == TEMPERATURE_CONTROL) then
          econst = etotal + ega
       else
          econst = etotal + ekina
       end if
       if(mype == 0) then
          if(mdmode == CNSTRA) then
             if(abs(etotal)<big)then
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',4f20.10,"  converged_in_a_plane")') &
                  &  iteration_ionic, iteration &
                  &, etotal, ekina, econst,  forcmx
             else
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//&
                  &  '," ",f0.10," ",f0.10," ",f0.10," ",f0.10,"  converged_in_a_plane")') &
                  & iteration_ionic, iteration, etotal, ekina, econst,  forcmx
             endif
          else
             if(abs(etotal)<big)then
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',4f20.10)') iteration_ionic, iteration &
                  &, etotal, ekina, econst,  forcmx
             else
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ",f0.10," ",f0.10," ",f0.10," ",f0.10)') &
                  &  iteration_ionic, iteration, etotal, ekina, econst,  forcmx
             endif
          end if
       end if
    else if(mdalg == BLUEMOON) then
       econst = etotal + ega
       if(mype == 0) then
            if(abs(etotal)<big)then
            write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',5f20.8)') iteration_ionic, iteration &
            &, etotal, ekina, econst, almda, forcmx
            else
            write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ",f0.8," ",f0.8," ",f0.8," ",f0.8," ",f0.8)') &
            &  iteration_ionic, iteration, etotal, ekina, econst, almda, forcmx
            endif
       endif
    else if(mdalg == QUENCHED_CONSTRAINT) then
       if(mype == 0) then
          if(mdmode == CNSTRA) then
             if(abs(etotal)<big)then
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',2f20.10," converged_in_a_plane")') &
                  &  iteration_ionic, iteration, etotal, forcmx_constraint_quench
             else
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ",f0.10," ",f0.10," converged_in_a_plane")') &
                  &  iteration_ionic, iteration &
                  &, etotal, forcmx_constraint_quench
             endif
          else
             if(abs(etotal)<big)then
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',2f20.10)') iteration_ionic, iteration &
                  &, etotal, forcmx_constraint_quench
             else
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ",f0.10," ",f0.10)') &
                  &  iteration_ionic, iteration, etotal, forcmx_constraint_quench
             endif
          end if
       end if
    else if (mdalg == PT_CONTROL .or. mdalg == P_CONTROL) then
        econst = m_UC_get_hamiltonian()
        stressmx = m_UC_get_curr_pressure()
        temp = m_UC_get_curr_temperature()
        if(mype == 0)then
        if(abs(etotal)<big)then
        write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',5f20.10)') iteration_unit_cell, iteration &
             &, etotal, temp, econst, forcmx, stressmx
        else
        write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ",f0.10," ",f0.10," ",f0.10," ",f0.10," ",f0.10)') &
        &     iteration_unit_cell, iteration, etotal, temp, econst, forcmx, stressmx
        endif
        endif
    else if (driver == DRIVER_URAMP) then
       if(mype == 0)then
          if(abs(etotal)<big)then
          write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))//',2f20.10)') &
               &  iteration_uramp,iteration_ionic, iteration, etotal, forcmx
          else
          write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ",f0.10," ",f0.10)') &
               & iteration_uramp,iteration_ionic, iteration, etotal, forcmx
          endif
       endif
    else if (driver == DRIVER_SC_DFT) then
       if(mype == 0)then
          if(abs(etotal)<big)then
          write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))//',2f20.10)') &
               & iteration_scdft,iteration_ionic, iteration, etotal, forcmx
          else
          write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ",f0.10," ",f0.10)') &
               & iteration_scdft,iteration_ionic, iteration, etotal, forcmx
          endif
       endif
    else
       if(mype == 0) then
          if(mdmode == CNSTRA) then
             if(abs(etotal)<big)then
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',2f20.10," converged_in_a_plane")') &
                  & iteration_ionic, iteration, etotal, forcmx
             else
             write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ",f0.10," ",f0.10," converged_in_a_plane")') &
                  & iteration_ionic, iteration, etotal, forcmx
             endif
          else
             if(sw_optimize_lattice==OFF)then
!  --> T. Yamasaki, 18 July 2008
             if(constraints_exist .and. m_IS_cnstr_is_fixed_nhp() &
                  & .and. forcmx_hyperplane_vert < forcmx ) then
                if(abs(etotal)<big)then
                write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',2f20.10)') iteration_ionic, iteration &
                     &, etotal, forcmx_hyperplane_vert
                else
                write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ",f0.10," ",f0.10)') &
                     & iteration_ionic, iteration, etotal, forcmx_hyperplane_vert
                endif
             else
                if(abs(etotal)<big)then
                write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//',2f20.10)') iteration_ionic, iteration &
                     &, etotal, forcmx
                else
                write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ",f0.10," ",f0.10)') &
                     & iteration_ionic, iteration, etotal, forcmx
                endif
             end if
!  <--
             else
                stressmx = m_Stress_get_stressmx()
                if(stressmx>=0) then
                  if(abs(etotal)<big)then
                  write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))//',3f20.10)') &
                       & iteration_unit_cell, iteration_ionic, iteration, etotal, forcmx,stressmx
                  else
                  write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))// &
                       & '," ",f0.10," ",f0.10," ",f0.10)') iteration_unit_cell, iteration_ionic, iteration &
                       &, etotal, forcmx,stressmx
                  endif
                else
                  if(abs(etotal)<big)then
                  write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))//',2f20.10)') &
                       & iteration_unit_cell, iteration_ionic, iteration, etotal, forcmx
                  else
                  write(nfenf,'(" ",'//trim(adjustl(cion))//','//trim(adjustl(cion))//','//trim(adjustl(ctot))// &
                       & '," ",f0.10," ",f0.10)') iteration_unit_cell, iteration_ionic, iteration, etotal, forcmx
                  endif
                endif
             endif
          end if
       end if
    end if

    endif
    call m_Files_flush_nfenf()

    if(printable) write(nfout,'(a,f20.10,a)') '!** total energy for the current iteration : ',etotal,' hartree'

  end subroutine wd_etotal_etc

  subroutine wd_forces_and_cps(flag_wd_force)
    use m_Control_Parameters, only : sw_stress_correction, imdalg
!
! (iprivelocity)
!    Modified by T. Yamasaki, April/10/2007
! 
    integer, intent(in) :: flag_wd_force
    character(len=256) :: ch
!!$    real(kind=DP) :: forc_lower

    if(flag_wd_force == 0 .and. sw_stress_correction /= ON) then
       call m_IS_wd_speciesname_etc(nfdynm)
    end if

    if(mype == 0 .and. iprivelocity <= 1) then
       if(mdmode == CNSTRA) then
          write(nfdynm,'(" cps and forc at (iter_ion, iter_total = " &
               & ,'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ) converged_in_a_plane")') iteration_ionic, iteration
       else
          write(nfdynm,'(" cps and forc at (iter_ion, iter_total = " &
               & ,'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," )")') iteration_ionic, iteration
       end if
    else if(mype == 0 .and. iprivelocity >= 2) then
       if(mdmode == CNSTRA) then
          write(nfdynm,'(" cps cpd and forc at (iter_ion, iter_total = " &
               & ,'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," ) converged_in_a_plane")') iteration_ionic, iteration
       else
          if(.not.(imdalg==PT_CONTROL .or. imdalg==P_CONTROL)) then
            write(nfdynm,'(" cps cpd and forc at (iter_ion, iter_total = " &
                 & ,'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," )")') iteration_ionic, iteration
          else
            write(nfdynm,'(" cps cpd and forc at (iter_ion, iter_total = " &
                 & ,'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," )")') iteration_unit_cell, iteration
          endif
       end if
    end if

    if(iprivelocity <= 1.and.mype==0) then
       call m_Force_wd_force_and_cps(nfdynm, WITHOUTTAG, cps, natm)
    else if(iprivelocity >= 2.and.mype==0) then
       call m_Force_wd_force_cps_cpd(nfdynm, WITHOUTTAG,cps,cpd_l,natm)
    end if

    if(mype==0.and.sw_cif_output==ON)then
       write(ch,*) iteration_ionic
       call m_IS_dump_cif(nfdynm_cif,'iteration_ionic_'//trim(adjustl(ch)))
    endif

    if(sw_nnp_output == ON) then
       call m_CtrlP_edelta_for_sampling(nfout, iteration_ionic)
       if(mod(iteration_ionic,frequency_nnp)==0) then
          call m_IS_dump_nnpfiles(etotal, forc_l)
       endif
    endif

    call m_Files_flush_nfdynm()

    if(ipriforce >= 1) then
       if(mype == 0 .and. iprivelocity <= 1) then
          write(nfout,'(" !forc cps and forc at (iter_ion, iter_total = " &
               & ,'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," )")') iteration_ionic, iteration
       else if(mype == 0 .and. iprivelocity >= 2) then
          write(nfout,'(" !forc cps cpd and forc at (iter_ion, iter_total = " &
               & ,'//trim(adjustl(cion))//','//trim(adjustl(ctot))//'," )")') iteration_ionic, iteration
       end if
    end if
#ifdef _DEBUG_WRITE_
    if(ipriforce >= 1) then
#else
    if(ipriforce == 1 .and. natm > N_FORC) then
!!$       call m_Force_cal_absforc(N_FORC, forc_lower)
!!$       write(nfout,'(" forc_lower = ",e12.4)') forc_lower
       if(iprivelocity <= 1) then
          call m_Force_wd_force_and_cps_lim(nfout, WITHTAG, cps, natm, N_FORC)
       else if(iprivelocity >= 2) then
          call m_Force_wd_force_cps_cpd_lim(nfout, WITHTAG, cps,cpd_l,natm, N_FORC)
       end if
    else if(ipriforce >= 2 .or. (ipriforce == 1 .and. natm <= N_FORC) ) then
#endif
       if(iprivelocity <= 1) then
          call m_Force_wd_force_and_cps(nfout, WITHTAG, cps, natm)
       else if(iprivelocity >= 2) then
          call m_Force_wd_force_cps_cpd(nfout, WITHTAG, cps,cpd_l,natm)
       end if
    end if

  end subroutine wd_forces_and_cps

end subroutine wd_forces_cps_etotal_and_etc

#ifndef _EMPIRICAL_
logical function Force_errors_are_tolerable()
  use m_Const_Parameters,   only : OFF, ON
  use m_Files,              only : nfout
  use m_Control_Parameters, only : force_error_check_mode &
       &                         , force_error_check_rangeL, sw_phonon
!!$       &                         , m_CtrlP_what_is_mdalg
  use m_Force,              only : forcmx, m_Force_error_tolerable &
       &                         , m_Force_clear_fec_counter

  implicit none
!!$  integer :: mdalg

!!$  if(force_error_check_mode == OFF .or. forcmx < force_error_check_rangeL) then
  if(sw_phonon == ON .or. force_error_check_mode == OFF .or. forcmx < force_error_check_rangeL) then
     Force_errors_are_tolerable = .true.
     ! --> T. Yamasaki, August 8 2008
     call m_Force_clear_fec_counter()
     ! <--
  else
     if(m_Force_error_tolerable(nfout)) then
        Force_errors_are_tolerable = .true.
     else
        Force_errors_are_tolerable = .false.
     end if
  end if
  
!!$  mdalg = m_CtrlP_what_is_mdalg()
!!$  if(Force_errors_are_tolerable) call wd_forces_cps_etotal_and_etc(mdalg)
end function Force_errors_are_tolerable
#endif

logical function Already_Converged()
  use m_Control_Parameters, only : iconvergence_previous_job &
      &                          , sw_phonon, sw_calc_force, max_total_scf_iteration &
      &                          , terminated_because, icond
  use m_Const_Parameters, only :   FORCE_CONVERGED, FORCE_CONVERGENCE_REACHED &
      &                          , MAX_PHSTEPS_REACHED, WF_CONVERGENCE_REACHED &
      &                          , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION
  implicit none
  if(iconvergence_previous_job >= FORCE_CONVERGED) then
     Already_Converged = .true.
  else
     Already_Converged = .false.
  end if
  if(sw_phonon == 1 .and. sw_calc_force == 0) Already_Converged = .true.
  if(max_total_scf_iteration <= 0) Already_Converged = .true.
  if(Already_Converged) then
    if(sw_phonon==1) then
      terminated_because = MAX_PHSTEPS_REACHED
    else if (icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION) then 
      terminated_because = WF_CONVERGENCE_REACHED
    else
      terminated_because = FORCE_CONVERGENCE_REACHED
    endif
  endif
  
end function Already_Converged

logical function MultiReplicaMode()
  use m_Control_Parameters, only  : multiple_replica_mode
  use m_Ionic_System,       only  : number_of_replicas
  use m_Const_Parameters, only    : ON
  if(multiple_replica_mode == ON .and. number_of_replicas >= 2) then
     MultiReplicaMode = .true.
  else
     MultiReplicaMode = .false.
  end if
end function MultiReplicaMode

#ifndef _EMPIRICAL_
logical function EigenValues_are_Converged()
  use m_Const_Parameters,     only : EK, SCF,GRID, ON, YES, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                           , ONE_BY_ONE, OFF, WF_CONVERGENCE_REACHED
  use m_Control_Parameters,   only : ekmode,nspin,neg,max_total_scf_iteration,ipri,ipriekzaj,iprievdff &
       &                           , ek_max_iteration, sw_berry_phase, sw_ekzaj, printable, icond &
       &                           , fixed_charge_k_parallel, terminated_because, sw_dos, sw_ldos &
       &                           , sw_charge_rspace, sw_partial_charge, sw_pdos
  use m_IterationNumbers,     only : iteration_electronic, iteration, nk_converged &
       &                           , m_Iter_set_converged_nk, nkgroup, nk_in_the_process
  use m_Files,                only : nfout, nfeng, nfzaj &
       &                           , m_Files_open_nfzaj_with_check
  use m_Kpoints,              only : kv3_ek, kv3
  use m_Parallelization,      only : nrank_k, npes, ierr, mype, mpi_comm_group
  use m_Electronic_Structure, only : m_ES_eekdif, m_ES_eekdif2 &
       &                           , m_ES_cp_eko_l_to_eko_ek &
       &                           , m_ES_cp_eko_l_to_eko_ek2 &
       &                           , m_ES_wd_eko &
       &                           , m_ES_sym_comp
  use m_ES_nonlocal,          only : m_ES_phir_dot_WFs

  use m_ES_IO,                only : m_ESIO_wd_WFs_and_EVs_ek
  use m_ES_IO,                only : m_ESIO_wd_EigenValues
  use m_BerryPhase,           only : m_BP_write_wfbp, m_BP_write_wfbp_gshift

  implicit none
  include 'mpif.h'                                      ! MPI
  integer :: ipri0, kv3_t

  if(ekmode == OFF .and. &
       & (icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION) &
       & .and. fixed_charge_k_parallel == ONE_BY_ONE) then
     EigenValues_are_Converged = m_ES_eekdif2()
!!$     if(nrank_k >= 2) then
!!$        call m_ESIO_wd_EigenValues(nfout,iprievdff,nooccupation=YES)
!!$     end if
  else     
     EigenValues_are_Converged = m_ES_eekdif()
  end if

  if(sw_ekzaj==ON .and. ekmode==ON ) EigenValues_are_Converged = .true.

  if(EigenValues_are_Converged) then
!!$     if(nk_in_the_process >= kv3_ek) stop ' nk_in_the_process >= kv3_ek <<Eigenvalues_are_converged>>'
     if(printable) write(nfout,'(" Wave Functions have converged at ",i7," -th iteration")') iteration_electronic

! ===================== modified by K. Tagami ========================= 12.0Exp
!     if(nk_converged == 0 .and. mype==0) then
!!!$     write(nfeng,'(" nk_converged = ",i6)') nk_converged
!        write(nfeng,'(" num_kpoints = ",i6)') kv3_ek
!        write(nfeng,'(" num_bands   = ",i6)') neg
!        write(nfeng,'(" nspin       = ",i6)') nspin
!        write(nfeng,'(" Fermi energy level = "/)')
!     end if
!
     terminated_because = WF_CONVERGENCE_REACHED
     if ( fixed_charge_k_parallel == ONE_BY_ONE ) then
        if (nk_converged == 0 .and. mype==0) then
           write(nfeng,'(" num_kpoints = ",i6)') kv3_ek
           write(nfeng,'(" num_bands   = ",i6)') neg
           write(nfeng,'(" nspin       = ",i6)') nspin
           write(nfeng,'(" Fermi energy level = "/)')
        end if
     else
        if (nk_converged == 0 .and. mype==0) then
           write(nfeng,'(" num_kpoints = ",i6)') kv3
           write(nfeng,'(" num_bands   = ",i6)') neg
           write(nfeng,'(" nspin       = ",i6)') nspin
           write(nfeng,'(" Fermi energy level = "/)')
        end if
     endif
! ==================================================================== 12.0Exp

     if(ekmode == ON) then
! === DEBUG by tkato 2013/10/18 ================================================
!       call m_ES_cp_eko_l_to_eko_ek()
        call m_ES_cp_eko_l_to_eko_ek2()
! ==============================================================================
     else if((icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION) .and. &
           fixed_charge_k_parallel == ONE_BY_ONE) then
        call m_ES_cp_eko_l_to_eko_ek2()
     end if

     if(nrank_k >= 2) then
        call m_ESIO_wd_EigenValues(nfout,2,nooccupation=YES)
        call m_ESIO_wd_EigenValues(nfeng,2,nooccupation=YES)
     else
        call m_ES_wd_eko(nfout,mode=EK)
        call m_ES_wd_eko(nfeng,mode=EK)
     end if
!!$     if(nk_in_the_process >= kv3_ek) stop ' nk_in_the_process >= kv3_ek (2)<<Eigenvalues_are_converged>>'
  else if(iteration_electronic >= ek_max_iteration) then
!!$       & .or. iteration >= max_total_scf_iteration ) then
     if(ekmode == ON) then
! === DEBUG by tkato 2013/10/18 ================================================
!       call m_ES_cp_eko_l_to_eko_ek()
!       write(nfout,'(" m_ES_cp_eko_l_to_eko_ek")')
        call m_ES_cp_eko_l_to_eko_ek2()
! ==============================================================================
     else if((icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION) .and. &
           fixed_charge_k_parallel == ONE_BY_ONE) then
        call m_ES_cp_eko_l_to_eko_ek2()
!!$        write(nfout,'(" m_ES_cp_eko_l_to_eko_ek2")')
     end if
     if(mype == 0) then
        write(nfout,'(" Wave Functions have not converged")')
        write(nfout,'(" iteration_electronic reached to ek_max_iteration (= ",i5," )")') ek_max_iteration
     end if
     if(nrank_k >= 2) then
        call m_ESIO_wd_EigenValues(nfout,2,nooccupation=YES)
        call m_ESIO_wd_EigenValues(nfeng,2,nooccupation=YES)
     else
        call m_ES_wd_eko(nfout,mode=EK)
        call m_ES_wd_eko(nfeng,mode=EK)
     end if
     EigenValues_are_Converged = .true.
!!$     if(iteration >= max_total_scf_iteration) write(nfout,'(" iteration has reached to max_total_scf_iteration")')
     if(iteration_electronic >= ek_max_iteration .and. mype==0) & 
      & write(nfout,'(" iteration_electronic has reached to ek_max_iteration")')
  end if

! ============================== added by K. Tagami =============== 12.0Exp
  if ( fixed_charge_k_parallel /= ONE_BY_ONE ) return
! ================================================================= 12.0Exp
  if(EigenValues_are_Converged) then
     if(ipri >= 2) write(nfout,'(" ipriekzaj = ",i8," <<EigenValues_are_Converged>>")') ipriekzaj
     if(ipriekzaj >= 1 .and. ekmode /= GRID .and. sw_ekzaj/=ON) then
        call m_Files_open_nfzaj_with_check()
        call m_ESIO_wd_WFs_and_EVs_ek(nfout,nfzaj)
     end if
     if(sw_berry_phase == 1) then
        call m_BP_write_wfbp_gshift ! for the initial k-point of a strig
        call m_BP_write_wfbp
     end if
!!$     call m_Iter_set_converged_nk(nspin)
     kv3_t = min(kv3, kv3_ek-kv3*(nkgroup-1))
     call m_Iter_set_converged_nk(kv3_t)
  else
     ipri0 = iprievdff
!!$     if(nrank_k>=2) call mpi_bcast(ipri0,1,mpi_integer,0,mpi_comm_group,ierr)
     if(npes>=2)    call mpi_bcast(ipri0,1,mpi_integer,0,mpi_comm_group,ierr)
     if((ipri0 >= 1 .and. mod(iteration_electronic,10)==1) &
          .or. ipri0 >= 2 ) then
        if(printable) write(nfout,'(" iteration_electronic = ",i6)') iteration_electronic
        if(nrank_k >= 2) then
           call m_ESIO_wd_EigenValues(nfout,2,nooccupation=YES)
        else
           call m_ES_wd_eko(nfout,mode=EK)
        end if
     end if
  end if
end function EigenValues_are_Converged

logical function AllKpoints_are_Calculated()
  use m_Files,              only : nfout
  use m_Const_Parameters,   only : EK_CONVERGED
  use m_IterationNumbers,   only : nk_converged, m_Iter_nk_incre2
  use m_Control_Parameters, only : nspin, ipri, m_CtrlP_set_iconvergence
  use m_Kpoints,            only : kv3_ek

  AllKpoints_are_Calculated = .false.
  if(ipri >= 2) write(nfout,'(" !!! nk_converged = ",i8)') nk_converged
  if(nk_converged+nspin-1 >= kv3_ek) then
     AllKpoints_are_Calculated = .true.
     if(ipri >= 1) write(nfout,'(" All kpoints have been calculated ")')
  end if
  if(AllKpoints_are_Calculated) then
     call m_CtrlP_set_iconvergence(EK_CONVERGED)
     call m_Iter_nk_incre2(nspin,kv3_ek)
  end if
end function AllKpoints_are_Calculated

logical function AllKpoints_are_Converged()
  use m_Files,              only : nfout
  use m_Const_Parameters,   only : EK_CONVERGED
  use m_IterationNumbers,   only : nk_in_the_process
  use m_Control_Parameters, only : ipri, m_CtrlP_set_iconvergence
  use m_Kpoints,            only : kv3_ek

  AllKpoints_are_Converged = .false.
  if(nk_in_the_process > kv3_ek) then
     AllKpoints_are_Converged = .true.
     if(ipri >= 1) write(nfout,'(" All Kpoints have been converged")')
  end if
  if(AllKpoints_are_Converged) call m_CtrlP_set_iconvergence(EK_CONVERGED)
end function AllKpoints_are_Converged

logical function AllKpoints_are_Calculated2(nk)
  use m_Files,              only : nfout
  use m_Const_Parameters,   only : EK_CONVERGED
  use m_IterationNumbers,   only : nk_converged, nk_in_the_process, m_Iter_nk_incre2
  use m_Control_Parameters, only : ipri, nspin, m_CtrlP_set_iconvergence
  use m_Kpoints,            only : kv3_ek, kv3

  integer, intent(inout) :: nk

  nk = nk + kv3
  if(ipri >= 1) write(nfout,'(" nk, nk_in_the_process = ",2i8)') nk,nk_in_the_process
!!$  if(nk >= kv3_ek) then
!!$  if(nk_in_the_process >= kv3_ek) then
!!$  if(nk_in_the_process+kv3 >= kv3_ek) then
  if(nk_converged >= kv3_ek) then
     AllKpoints_are_Calculated2 = .true.
     call m_Iter_nk_incre2(nspin,kv3_ek) !-> nk_in_the_process
  else
     AllKpoints_are_Calculated2 = .false.
  end if
  if(AllKpoints_are_Calculated2) call m_CtrlP_set_iconvergence(EK_CONVERGED)
end function AllKpoints_are_Calculated2

subroutine Set_converged_nk()
  use m_IterationNumbers,   only : m_Iter_set_converged_nk
  use m_Control_Parameters, only : nspin
  call m_Iter_set_converged_nk(nspin)
end subroutine Set_converged_nk

logical function Already_Converged2()
  ! coded by T. Yamasaki, 31 May 2007
  use m_Const_Parameters, only : FORCE_CONVERGED
  use m_Control_Parameters, only : iconvergence, iconvergence_previous_job
  if(iconvergence >= FORCE_CONVERGED .or. iconvergence_previous_job >= FORCE_CONVERGED) then
     Already_Converged2 = .true.
  else
     Already_Converged2 = .false.
  end if
end function Already_Converged2

logical function Already_Converged_for_kgroup()
  use m_Kpoints, only           : kv3_ek, kv3
  use m_IterationNumbers, only  : nkgroup, nk_in_the_process
  use m_Control_Parameters,only : ipri,nspin
  use m_Const_Parameters, only  : EK_CONVERGED
  use m_Electronic_Structure, only : iconv_ek
  use m_Files, only             : nfout
  integer :: i
  Already_Converged_for_kgroup = .true.
  do i = nk_in_the_process, min(nk_in_the_process + kv3, kv3_ek)
     if(iconv_ek(i) < EK_CONVERGED) then
        Already_Converged_for_kgroup = .false.
        exit
     end if
  end do
  if(ipri >= 2 .and. .not.Already_Converged_for_kgroup) then
     write(nfout,'(" -- Convergence status for ek --")')
     write(nfout,'(40i2)') (iconv_ek(i),i=nk_in_the_process, min(nk_in_the_process+kv3,kv3_ek))
  end if
!!$  if(Already_Converged_for_kgroup) call m_Iter_nkgroup_incre() !-> nk_in_the_process
end function Already_Converged_for_kgroup

logical function Positron_Bulk()
  ! Coded by T. Yamasaki, 29 Oct. 2003
  use m_Const_Parameters, only :   BULK
  use m_Control_Parameters, only : sw_positron
  if(sw_positron == BULK) then
     Positron_Bulk = .true.
  else
     Positron_Bulk = .false.
  end if
end function Positron_Bulk

logical function Positron_Defect()
  ! Coded by T. Yamasaki, 11 Dec. 2005
  use m_Const_Parameters, only :   DEFECT
  use m_Control_Parameters, only : sw_positron
  if(sw_positron == DEFECT) then
     Positron_Defect = .true.
  else
     Positron_Defect = .false.
  end if
end function Positron_Defect

! ==== Positron SCF === 2015/11/28
logical function Positron_scf()
  use m_Const_Parameters, only :   OFF, Positron_CONV
  use m_Control_Parameters, only : sw_positron, positron_method

  if ( sw_positron /= OFF ) then
     if ( positron_method == Positron_CONV ) then
        Positron_scf = .false.
     else
        Positron_scf = .true.
     end if
  else
     Positron_scf = .false.
  endif
end function Positron_scf

logical function Positron_nonscf()
  use m_Const_Parameters, only :   OFF, Positron_CONV
  use m_Control_Parameters, only : sw_positron, positron_method

  if ( sw_positron /= OFF ) then
     if ( positron_method == Positron_CONV ) then
        Positron_nonscf = .true.
     else
        Positron_nonscf = .false.
     end if
  else
     Positron_nonscf = .false.
  endif
end function Positron_nonscf
! ========== 2015/11/28

logical function Structure_is_fixed()
  ! Coded by T. Yamasaki, 25 Jul. 2008
  use m_Const_Parameters, only :   ON, VERLET
  use m_Control_Parameters, only : sw_fix &
       &                         , m_CtrlP_set_iconvergence &
       &                         , m_CtrlP_what_is_mdalg
  use m_Const_Parameters,   only : FORCE_CONVERGED
  use m_Ionic_System,       only : m_IS_evaluate_v_verlet
  use m_Force,              only : forc_l
  integer :: mdalg

  if(sw_fix == ON) then
     Structure_is_fixed = .true.
  else
     Structure_is_fixed = .false.
  end if
  if(Structure_is_fixed) call m_CtrlP_set_iconvergence(FORCE_CONVERGED)
  if(Structure_is_fixed) then
     mdalg = m_CtrlP_what_is_mdalg()
     if(mdalg == VERLET) call m_IS_evaluate_v_verlet(mdalg,forc_l)
     call wd_forces_cps_etotal_and_etc(mdalg,.true.) ! nfdynm
     call wd_forces_cps_etotal_and_etc(mdalg,.false.) ! nfenf
  end if
end function Structure_is_fixed

logical function Hubbard_model()
  use m_Const_Parameters, only : ON
  use m_Control_Parameters, only : sw_hubbard
  use m_Total_Energy,   only : m_TE_Converged_Hubbard_Energy
  implicit none
  Hubbard_model=.false.
  if(sw_hubbard == ON) then
     Hubbard_model=.true.
     !!if(m_TE_Converged_Hubbard_Energy(nfout)) Hubbard_model=.false.
  end if
  !!$write(6,*) "Hubbard_model=",Hubbard_model
end function Hubbard_model
#endif

subroutine Checkpoint_File(mode)
  use m_Const_Parameters, only : DP,STREVL_ITERATION,SCF_ITERATION,UNITCELL_ITERATION,REAC_ITERATION, DRIVER_CONSTRAINT
  use m_Control_Parameters, only :  cpt_scf_iteration, cpt_nhistory, cpt_strevl_iteration, cpt_reac_iteration &
                                 &, cpt_time, cpt_unitcell_iteration, m_CtrlP_get_elpsd_time, printable, driver
  use m_IterationNumbers, only : iteration, iteration_ionic, iteration_unit_cell
  use m_Files, only : nfout
  use m_Parallelization, only : mype,mpi_comm_group
  use m_constraints, only : m_cnstr_get_id
  implicit none
  integer, intent(in) :: mode
  real(kind=DP) :: curr_time
  real(kind=DP), save :: last_time=0.d0
  logical :: write_chkpnt,lscf,lstrevl,ltime,lunit,lreac
  integer :: ierr
  write_chkpnt = .false.;lscf=.false.;lstrevl=.false.;ltime=.false.;lunit=.false.;lreac=.false.
  if (mode==SCF_ITERATION .and. cpt_scf_iteration>0) then
  if (mod(iteration,cpt_scf_iteration) == 0) then
     write_chkpnt = .true.
     lscf = .true.
  endif
  endif
  if (mode==STREVL_ITERATION .and. cpt_strevl_iteration>0) then 
  if (mod(iteration_ionic,cpt_strevl_iteration) == 0) then
     write_chkpnt = .true.
     lstrevl = .true.
  endif
  endif
  if (mode==UNITCELL_ITERATION .and. cpt_unitcell_iteration>0) then
  if (mod(iteration_unit_cell,cpt_unitcell_iteration) == 0) then
     write_chkpnt = .true.
     lunit = .true.
  endif
  endif
  if (mode==REAC_ITERATION .and. cpt_reac_iteration>0) then
  if (mod(m_cnstr_get_id(),cpt_reac_iteration) == 0) then
     write_chkpnt = .true.
     lreac = .true.
  endif
  endif
  curr_time = m_CtrlP_get_elpsd_time()
  if (cpt_time>0 .and. (curr_time-last_time)>cpt_time) then
     write_chkpnt = .true.
     ltime = .true.
     last_time = curr_time
     call mpi_barrier(mpi_comm_group,ierr)
  endif
  if(write_chkpnt) then
     call WriteDownData_onto_Files(.false.)
     if(driver == DRIVER_CONSTRAINT) call constrained_dynamics_dump()
     if(printable) then
        write(nfout,'(a)')              '!** dumped checkpoint files because '
        if (lscf)    write(nfout,'(a)') '!** iteration'
        if (lstrevl) write(nfout,'(a)') '!** iteration_ionic'
        if (lunit)   write(nfout,'(a)') '!** iteration_unitcell'
        if (lreac)   write(nfout,'(a)') '!** iteration_reac'
        if (ltime)   write(nfout,'(a)') '!** cputime'
        write(nfout,'(a)')              '!** met the criterion'
     endif
  endif
end subroutine Checkpoint_File

subroutine Modify_Input_Settings()
  use m_Files, only : m_Files_reopen_nfinp_mod, m_Files_close_nfinp_mod &
     &       , m_Files_file_exists, F_INP_MOD, nfout
  use m_Ionic_System, only : m_IS_reread_imdtyp, natm2
  use m_Control_Parameters, only : m_CtrlP_reread_edelta &
     &       , m_CtrlP_reread_max_force, m_CtrlP_reread_max_iteration &
     &       , m_CtrlP_rd_wfsolver2, m_CtrlP_rd_chargemix2 &
     &       , m_CtrlP_reread_cutoff_wf
  implicit none
  integer :: iret, f_closeInputFile
  if(.not. m_Files_file_exists(F_INP_MOD)) then
    return
  endif
  call m_Files_reopen_nfinp_mod(1)
  call m_IS_reread_imdtyp(nfout)
  call m_CtrlP_reread_edelta(nfout)
  call m_CtrlP_reread_max_force(nfout)
  call m_CtrlP_reread_max_iteration(nfout) 
  call m_CtrlP_rd_wfsolver2(nfout, natm2, .true.) 
  call m_CtrlP_rd_chargemix2(nfout, .true.) 
  call m_CtrlP_reread_cutoff_wf(nfout)
  iret = f_closeInputFile()
  call m_Files_close_nfinp_mod()
end subroutine Modify_Input_Settings

subroutine Postproc_after_SCF_convergence(nfout)
  use m_Control_Parameters, only : m_CtrlP_gmax_changed
#ifndef FFTW3
  use m_Parallelization, only : mype
#endif
  implicit none
  integer, intent(in) :: nfout

  if(m_CtrlP_gmax_changed()) then
#ifdef FFTW3
    call change_gmax()
#else
    if (mype==0) then
        write(nfout,'(a)') &
        & '!** WARN: changing gmax during execution is supported only if phase was built with FFTW3'
    endif
#endif
  endif

#ifdef FFTW3
  contains

  subroutine change_gmax()
    use m_Const_Parameters,   only : ON, OFF, LDA, EXECUT
    use m_Control_Parameters, only : gmax, gmax_buf, ipriparallel &
    & , sw_communicator_for_chg, paramset, printable, ggacmp_parallel, neg &
    & , m_CtrlP_reset_gmax_changed, noncol
    use m_PlaneWaveBasisSet, only : m_pwBS_wd_curr_pws, m_pwBS_dealloc &
    & , m_pwBS_store_prev_kg1_kgp, m_pwBS_assume_G_rhombohedron &
    & , m_pwBS_generate_G_vectors, m_pwBS_alloc_ngpt_igfp_gr, m_pwBS_calc_length_of_G &
    & , m_pwBS_G_trans_functions, m_pwBS_setup_FFTmapfunctions &
    & , n_rGv,n_rGpv,n_rGpv_reduced, n_rGv_pstrn,kgp, n_rGv_prev &
    & , n_rGpv_prev, kgp, m_pwBS_rd_prev_pws, m_pwBS_for_each_WF &
    & , m_pwBS_alloc_ylm_l, m_pwBS_sphrp_l
    use m_Parallelization,    only : m_Parallel_init_mpi_kngp_prev &
    & ,  np_g1k, m_Parallel_init_mpi_kngp, m_Parallel_init_mpi_cdfft
    use m_PseudoPotential,    only : m_PP_input_xctype, modnrm, m_PP_dealloc &
    & , m_PP_gfqwei, m_PP_set_fqwei_noncl, m_PP_init_epc
    use m_FFT,                only : m_FFT_set_box_sizes, m_FFT_setup &
    & , m_FFT_reset_CD_setup_stat
    use m_Electronic_Structure, only : m_ES_alloc_zaj_l_prev &
    & , m_ES_dealloc_zaj_l_prev, m_ES_cp_zaj_to_zaj_prev  &
#ifdef FFTW3
    & , m_ES_gen_zaj_from_prev_zaj &
#endif
    & , m_ES_dealloc, m_ES_alloc_zaj_etc, m_ES_realloc_zaj &
    & , m_ES_alloc_vlhxc, m_ES_alloc_vlhxcQ
    use m_Kpoints, only : kv3
    use m_Crystal_Structure, only : inversion_symmetry
#ifdef FFTW3
    use m_Charge_Density, only : m_CD_gen_chgq_from_prev_chgq, m_CD_dealloc_chgq, m_CD_alloc_chgq
#else
    use m_Charge_Density, only : m_CD_dealloc_chgq, m_CD_alloc_chgq
#endif
    use m_ES_initialWF, only : m_ESIW_by_randomnumbers
    use m_ES_WF_by_SDorCG, only : m_ESsd_dealloc_dzajn2, m_ESsd_dealloc_zaj_old &
    & , m_ESsd_alloc_zaj_old, m_ESsd_alloc_dzajn2
    use m_XC_Potential, only : m_XC_rst_npsend
    use m_CD_mixing, only : m_CD_force_dealloc
    use m_ES_WF_by_submat, only : m_ESsubmat_dealloc
    use m_ES_WF_by_RMM, only : m_ESrmm_dealloc_r_norm_flag, m_ESrmm_reset_r_norm_flag, m_ESrmm_reset_ng_maxmin
    use m_NonLocal_Potential, only : m_NLP_dealloc

    implicit none

    logical :: rd
    integer :: outer_or_inner, xctype_is, ggacmp_parallel_rev
    call m_pwBS_wd_curr_pws()
    call m_pwBS_rd_prev_pws(rd)
    if(.not. rd) then
      if(printable) write(nfout,'(a)') '!** failed to load pwbs info. gmax &
      &  will not be changed.'
      return
    endif

    call m_XC_rst_npsend()
    call m_FFT_reset_CD_setup_stat()
    call m_CD_force_dealloc()
    call m_ESrmm_reset_r_norm_flag()
    call m_ESrmm_reset_ng_maxmin()
    call m_ESsubmat_dealloc()
    call m_pwBS_store_prev_kg1_kgp()
    call m_pwBS_dealloc(dealloc_all = .true.)
    gmax = gmax_buf
    call m_pwBS_assume_G_rhombohedron()
    call fft_box_finding_way(outer_or_inner)
    call m_FFT_set_box_sizes(n_rGv,n_rGpv_reduced,n_rGv_pstrn,outer_or_inner) ! ->fft_box_size_WF,CD
    call m_pwBS_generate_G_vectors()    ! ->n_rGv,n_rGpv ->kgp
    call m_Parallel_init_mpi_kngp(nfout,ipriparallel,kgp)  ! -(m_Parallelization) ->ista_kngp,iend_kngp
    call m_pwBS_alloc_ngpt_igfp_gr()
    call m_pwBS_calc_length_of_G()         ! -> gr_l
    call m_pwBS_G_trans_functions()   ! -> ngpt_l: Set of G-vectors translated according to symmetry operations
    ggacmp_parallel_rev = ggacmp_parallel
    call m_Parallel_init_mpi_cdfft(nfout,ipriparallel,ggacmp_parallel_rev)
    call m_FFT_setup(inversion_symmetry,paramset) ! paramset == .false.
  call m_pwBS_setup_FFTmapfunctions()
    call m_pwBS_for_each_WF(paramset) ! -> kg1, nbase,iba (when paramset==.false.)
    call m_ES_dealloc(store_prev = .true.)
    call m_ESsd_dealloc_dzajn2()
    call m_ESsd_dealloc_zaj_old()
    call pwbs_mpi_initialization()
    call m_ES_alloc_vlhxc()
    call m_ES_alloc_vlhxcQ()
    call m_ES_alloc_zaj_etc()
    call m_ESsd_alloc_zaj_old()
    call m_ESsd_alloc_dzajn2()
    call m_ESIW_by_randomnumbers(nfout,kv3,1,neg)      ! (rndzaj) -> zaj_l
    if(modnrm == EXECUT ) then
       call m_pwBS_alloc_ylm_l()
       call m_pwBS_sphrp_l()                           ! -> ylm_l
    end if
#ifdef FFTW3
    call m_ES_gen_zaj_from_prev_zaj(nfout)
#endif
    call m_CD_dealloc_chgq(store_prev = .true.)
    call m_CD_alloc_chgq()
#ifdef FFTW3
    call m_CD_gen_chgq_from_prev_chgq(nfout)
#endif

    call m_PP_dealloc()
    call m_NLP_dealloc()
    call PseudoPotential_Construction()
    call m_PP_init_epc()
! ==================================== modified by K. Tagami ================ 11.0
!     call m_PP_gfqwei(nfout)  ! -> modnrm, fqwei, nlmta1, nlmta2
    if ( noncol ) then
       call m_PP_set_fqwei_noncl( nfout )
    else
       call m_PP_gfqwei(nfout)  ! -> modnrm, fqwei, nlmta1, nlmta2
    endif
! ======================================================================== 11.0
    call m_CtrlP_reset_gmax_changed()
  end subroutine change_gmax

  subroutine fft_box_finding_way(outer_or_inner)
    use m_Const_Parameters,  only : GENERAL, SIMPLE_CUBIC, HEXAGONAL &
      , OUTER, INNER
    use m_Crystal_Structure, only : nbztyp
    implicit none
    integer,intent(out)::  outer_or_inner
    if( nbztyp == GENERAL &
         & .or.(nbztyp >= 30 .and. nbztyp <= 32) &
         & .or.(nbztyp >= SIMPLE_CUBIC  .and. nbztyp <= HEXAGONAL)) then
       outer_or_inner = OUTER
    else
       outer_or_inner = INNER
    endif
  end subroutine fft_box_finding_way

  subroutine pwbs_mpi_initialization()
    use m_Files, only : nfout
    use m_Control_Parameters, only : noncol, printable, ipriparallel, neg, nspin, ndim_spinor
    use m_Kpoints, only : kv3
    use m_PlaneWaveBasisSet, only : kg1, iba
    use m_Parallelization, only : m_Parallel_dealloc_mpi_elec, m_Parallel_init_mpi_elec, m_Parallel_init_mpi_iba
    call m_Parallel_dealloc_mpi_elec()
    if ( noncol ) then
        call m_Parallel_init_mpi_elec( nfout, ipriparallel, printable, neg, &
             &                                   kv3, ndim_spinor, kg1 )
     else
        call m_Parallel_init_mpi_elec( nfout, ipriparallel, printable, neg, &    
             &                                   kv3, nspin, kg1 )
     endif
     call m_Parallel_init_mpi_iba(nfout,ipriparallel,printable,kv3,iba) ! -> np_g1k, mp_g1k
  end subroutine pwbs_mpi_initialization
#endif

end subroutine Postproc_after_SCF_convergence

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 612 $)
!
!  SUBROUINE: real_spherical_harmonics
!
!  AUTHOR: Takenori Yamamotoi   June/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
! coded by Takenori YAMAMOTO (Univ. Tokyo) at Jun. 1, 2004
!
subroutine real_spherical_harmonics(is,n,x,y,z,ylm,coeff)
!$Id: real_spherical_harmonics.f90 612 2020-04-25 10:36:25Z ktagami $
  integer, intent(in) :: is,n
  real(kind=8), intent(in), dimension(n)  :: x(n),y(n),z(n)
  real(kind=8), intent(out) :: ylm(n)
  real(kind=8), intent(out) :: coeff

  real(kind=8) :: a,b,c,d,e,f,g,r
  real(kind=8) :: PAI4,PAI
 
  PAI  = 4.d0*atan(1.d0)
  PAI4 = 4.d0*PAI

  if(is == 1) then
     do i=1,n        
        a = sqrt(1.d0/PAI4)
        ylm(i) = a
     end do
  else if(is == 2) then
     do i=1,n
        r=sqrt(x(i)**2+y(i)**2+z(i)**2)
        a = sqrt(3.d0/PAI4)
        ylm(i) = a*x(i)/r
     end do 
  else if(is == 3) then
     do i=1,n
        r=sqrt(x(i)**2+y(i)**2+z(i)**2)
        a = sqrt(3.d0/PAI4)
        ylm(i) = a*y(i)/r
     end do
  else if(is == 4) then
     do i=1,n
        r=sqrt(x(i)**2+y(i)**2+z(i)**2)
        a = dsqrt(3.d0/PAI4)
        ylm(i) = a*z(i)/r
     end do
  else if(is == 5) then
     do i=1,n
        a = dsqrt(5.d0/(16*PAI))
        d = z(i)**2
        e = x(i)**2+y(i)**2+d
        ylm(i) = a*(3*d-e)/e
     end do
  else if(is == 6) then
     do i=1,n
        a = dsqrt(15.d0/(16*PAI))
        b = x(i)**2
        c = y(i)**2
        e = b+c+z(i)**2
        ylm(i) = a*(b-c)/e
     end do
  else if(is == 7) then
     do i=1,n
        a = dsqrt(15.d0/PAI4)
        e = x(i)**2+y(i)**2+z(i)**2
        ylm(i) = a*x(i)*y(i)/e
     end do
  else if(is == 8) then
     do i=1,n
        a = dsqrt(15.d0/PAI4)
        e = x(i)**2+y(i)**2+z(i)**2
        ylm(i) = a*y(i)*z(i)/e
     end do
  else if(is == 9) then
     do i=1,n
        a = dsqrt(15.d0/PAI4)
        e = x(i)**2+y(i)**2+z(i)**2
        ylm(i) = a*z(i)*x(i)/e
     end do
  else if(is == 10) then
     do i=1,n
        a = dsqrt(7.d0/(16*PAI))
        d = z(i)**2
        e = x(i)**2+y(i)**2+d
        r=sqrt(e)
        f = e * r
        ylm(i) = a*z(i)*(5*d-3*e)/f
     end do
  else if(is == 11) then
     do i=1,n
        a = dsqrt(21.d0/(32*PAI))
        d = z(i)**2
        e = x(i)**2+y(i)**2+d
        r=sqrt(e)
        f = e * r
        ylm(i) = a*x(i)*(5*d-e)/f
     end do
  else if(is == 12) then
     do i=1,n
        a = dsqrt(21.d0/(32*PAI))
        d = z(i)**2
        e = x(i)**2+y(i)**2+d
        r=sqrt(e)
        f = e * r
        ylm(i) = a*y(i)*(5*d-e)/f
     end do
  else if(is == 13) then
     do i=1,n
        a = dsqrt(105.d0/(16*PAI))
        b = x(i)*x(i)
        c = y(i)*y(i)
        e = b+c+z(i)*z(i)
        r=sqrt(e)
        f = e * r
        ylm(i) = a*z(i)*(b-c)/f
     end do
  else if(is == 14) then
     do i=1,n
        r=sqrt(x(i)**2+y(i)**2+z(i)**2)
        a = dsqrt(105.d0/PAI4)
        f = r**3
        ylm(i) = a*x(i)*y(i)*z(i)/f
     end do
  else if(is == 15) then
     do i=1,n
        a = dsqrt(35.d0/(32*PAI))
        b = x(i)*x(i)
        c = y(i)*y(i)
        r=sqrt(b+c+z(i)*z(i))
        f = r**3
        ylm(i) = a*x(i)*(b-3*c)/f
     end do
  else if(is == 16) then
     do i=1,n
        a = dsqrt(35.d0/(32*pai))
        b = x(i)*x(i)
        c = y(i)*y(i)
        r=sqrt(b+c+z(i)*z(i))
        f = r**3
        ylm(i) = a*y(i)*(3*b-c)/f
     end do
  else if(is == 17) then
     do i=1,n
        a = 3.d0/8.d0/dsqrt(PAI4)
        d = z(i)*z(i)
        e = x(i)*x(i)+y(i)*y(i)+d
        r=sqrt(e)
        f = e*e
        ylm(i) = a*(5*d*(7*d-6*e)/f+3.d0)
     end do
  else if(is == 18) then
     do i=1,n
        a = 15.d0/4.d0/dsqrt(10*PAI)
        d = z(i)*z(i)
        e = x(i)*x(i)+y(i)*y(i)+d
        r=sqrt(e)
        f = e*e
        ylm(i) = a*z(i)*x(i)*(7*d-3*e)/f
     end do
  else if(is == 19) then
     do i=1,n
        a = 15.d0/4.d0/dsqrt(10.d0*PAI)
        d = z(i)*z(i)
        e = x(i)*x(i)+y(i)*y(i)+d
        r=sqrt(e)
        f = e*e
        ylm(i)= a*y(i)*z(i)*(7*d-3*e)/f
     end do
  else if(is == 20) then
     do i=1,n
        a = 15.d0/8.d0/dsqrt(5*PAI)
        b = x(i)*x(i)
        c = y(i)*y(i)
        d = z(i)*z(i)
        e = b+c+d
        f = e*e
        ylm(i) = a*(7*d-e)*(b-c)/f
     end do
  else if(is == 21) then
     do i=1,n
        a = 15.d0/4.d0/dsqrt(5*PAI)
        d = z(i)*z(i)
        e = x(i)*x(i)+y(i)*y(i)+d
        r=sqrt(e)
        f = e*e
        ylm(i) = a*(7*d-e)*x(i)*y(i)/f
     end do
  else if(is == 22) then
     do i=1,n
        a = 105.d0/4.d0/dsqrt(70*pai)
        b = x(i)*x(i)
        c = y(i)*y(i)
        f = (b+c+z(i)*z(i))**2
        ylm(i) = a*(b-3*c)*z(i)*x(i)/f
     end do
  else if(is == 23) then
     do i=1,n 
        a = 105.d0/4.d0/dsqrt(70*PAI)
        b = x(i)*x(i)
        c = y(i)*y(i)
        f = (b+c+z(i)*z(i))**2
        ylm(i) = a*(3.d0*b-c)*y(i)*z(i)/f
     end do
  else if(is == 24) then
     do i=1,n 
        a = 105.d0/16.d0/dsqrt(35*PAI)
        b = x(i)*x(i)
        c = y(i)*y(i)
        f = (b+c+z(i)*z(i))**2
        ylm(i) = a*((b-c)**2-4*b*c)/f
     end do
  else if(is == 25) then
     do i=1,n 
        a = 105.d0/4.d0/dsqrt(35*PAI)
        b = x(i)*x(i)
        c = y(i)*y(i)
        f = (b+c+z(i)*z(i))**2
        ylm(i) = a*(b-c)*x(i)*y(i)/f
     end do
  else if(is == 26) then
     do i=1,n 
        a = dsqrt(11.d0/PAI)/16.d0
        b = z(i)*z(i)
        c = x(i)*x(i)+y(i)*y(i)+b
        r = sqrt(c)
        f = r**5
        ylm(i) = a*z(i)*(63.d0*b*b-70.d0*b*c+15.d0*c*c)/f
     end do
  else if(is == 27) then
     do i=1,n 
        a = dsqrt(165.d0/PAI)/16.d0
        b = z(i)*z(i)
        c = x(i)*x(i)+y(i)*y(i)+b
        r = sqrt(c)
        f = r**5
        ylm(i) = a*x(i)*(21.d0*b*b-14.d0*b*c+c*c)/f
     end do
  else if(is == 28) then
     do i=1,n 
        a = dsqrt(165.d0/PAI)/16.d0
        b = z(i)*z(i)
        c = x(i)*x(i)+y(i)*y(i)+b
        r = sqrt(c)
        f = r**5
        ylm(i) = a*y(i)*(21.d0*b*b-14.d0*b*c+c*c)/f
     end do
  else if(is == 29) then
     do i=1,n 
        a = dsqrt(1155.d0/(64*PAI))
        b = z(i)*z(i)
        c = x(i)*x(i)
        d = y(i)*y(i)
        e = c+d
        r = sqrt(b+e)
        f = r**5
        ylm(i) = a*z(i)*(2.d0*b-e)*(c-d)/f
     end do
  else if(is == 30) then
     do i=1,n 
        a = dsqrt(1155.d0/(16.d0*PAI))
        b = z(i)*z(i)
        c = x(i)*x(i)
        d = y(i)*y(i)
        e = c+d
        r = sqrt(b+e)
        f = r**5
        ylm(i) = a*x(i)*y(i)*z(i)*(2.d0*b-e)/f
     end do
  else if(is == 31) then
     do i=1,n 
        a = dsqrt(385.d0/(512.d0*PAI))
        b = z(i)*z(i)
        c = x(i)*x(i)
        d = y(i)*y(i)
        e = c+d
        r = sqrt(b+e)
        f = r**5
        ylm(i) = a*x(i)*(8.d0*b-e)*(c-3.d0*d)/f
     end do
  else if(is == 32) then
     do i=1,n 
        a = dsqrt(385.d0/(512.d0*PAI))
        b = z(i)*z(i)
        c = x(i)*x(i)
        d = y(i)*y(i)
        e = c+d
        r = sqrt(b+e)
        f = r**5
        ylm(i) = a*y(i)*(8.d0*b-e)*(3.d0*c-d)/f
     end do
  else if(is == 33) then
     do i=1,n 
        a = dsqrt(385.d0/(256.d0*PAI))*3.d0
        b = x(i)*x(i)
        c = y(i)*y(i)
        r = sqrt(b+c+z(i)*z(i))
        f = r**5
        ylm(i) = a*z(i)*(b*b-6.d0*b*c+c*c)/f
     end do
  else if(is == 34) then
     do i=1,n 
        r=sqrt(x(i)**2+y(i)**2+z(i)**2)
        a = dsqrt(385.d0/(16.d0*PAI))*3.d0
        b = x(i)*x(i)
        c = y(i)*y(i)
        d = b-c
        r=sqrt(b+c+z(i)*z(i))
        f = r**5
        ylm(i) = a*x(i)*y(i)*z(i)*d/f
     end do
  else if(is == 35) then
     do i=1,n 
        a = dsqrt(693.d0/(512.d0*PAI))
        b = x(i)*x(i)
        c = y(i)*y(i)
        r=sqrt(b+c+z(i)**2)
        f = r**5
        ylm(i) = a*x(i)*(b*b-10.d0*b*c+5.d0*c*c)/f
     end do
  else if(is == 36) then
     do i=1,n 
        a = dsqrt(693.d0/(512.d0*PAI))
        b = y(i)*y(i)
        c = x(i)*x(i)
        r=sqrt(b+c+z(i)**2)
        f = r**5
        ylm(i) = a*y(i)*(b*b-10.d0*b*c+5.d0*c*c)/f
     end do
  else if(is == 37) then
     do i=1,n 
        a = dsqrt(13.d0/(1024.d0*PAI))
        b = z(i)*z(i)
        c = b*b
        d = c*b
        e = x(i)*x(i)+y(i)*y(i)+b
        c = c*e
        f = e*e
        b = b*f
        f = f*e
        ylm(i) = a*((231.d0*d-315.d0*c+105.d0*b)/f-5.d0)
     end do
  else if(is == 38) then
     do i=1,n 
        a = dsqrt(273.d0/(256.d0*PAI))
        b = z(i)*z(i)
        c = b*b
        e = x(i)*x(i)+y(i)*y(i)+b
        b = b*e
        d = e*e
        f = d*e
        ylm(i) = a*z(i)*x(i)*(33.d0*c-30.d0*b+5.d0*d)/f
     end do
  else if(is == 39) then
     do i=1,n 
        a = dsqrt(273.d0/(256.d0*PAI))
        b = z(i)*z(i)
        c = b*b
        e = x(i)*x(i)+y(i)*y(i)+b
        b = b*e
        d = e*e
        f = d*e
        ylm(i) = a*y(i)*z(i)*(33.d0*c-30.d0*b+5.d0*d)/f
     end do
  else if(is == 40) then
     do i=1,n 
        a = dsqrt(1365.d0/(2048.d0*PAI))
        b = z(i)*z(i)
        c = b*b
        d = x(i)*x(i)
        f = y(i)*y(i)
        e = d+f+b 
        d = d-f
        b = b*e
        g = e*e
        f = g*e
        ylm(i) = a*d*(33.d0*c-18.d0*b+g)/f
     end do
  else if(is == 41) then
     do i=1,n 
        a = dsqrt(1365.d0/(512.d0*PAI))
        b = z(i)*z(i)
        c = b*b
        e = x(i)*x(i)+y(i)*y(i)+b 
        b = b*e
        g = e*e
        f = g*e
        ylm(i) = a*x(i)*y(i)*(33.d0*c-18.d0*b+g)/f
     end do
  else if(is == 42) then
     do i=1,n 
        a = dsqrt(1365.d0/(512.d0*PAI))
        b = z(i)*z(i)
        c = x(i)*x(i)
        d = y(i)*y(i)
        e = c+d+b 
        f = e**3
        ylm(i) = a*z(i)*x(i)*(11.d0*b-3.d0*e)*(c-3.d0*d)/f
     end do
  else if(is == 43) then
     do i=1,n 
        a = dsqrt(1365.d0/(512.d0*PAI))
        b = z(i)*z(i)
        c = y(i)*y(i)
        d = x(i)*x(i)
        e = d+c+b 
        f = e**3
        ylm(i) = a*y(i)*z(i)*(11.d0*b-3.d0*e)*(3.d0*d-c)/f
     end do
  else if(is == 44) then
     do i=1,n 
        a = dsqrt(819.d0/(1024d0*PAI))
        b = x(i)*x(i)
        c = y(i)*y(i)
        d = z(i)*z(i)
        e = b+c+d
        f = e**3
        ylm(i) = a*(11.d0*d-e)*(b*b-6.d0*b*c+c*c)/f
     end do
  else if(is == 45) then
     do i=1,n 
        a = dsqrt(819.d0/(64.d0*PAI))
        b = x(i)*x(i)
        c = y(i)*y(i)
        d = z(i)*z(i)
        e = b+c+d
        f = e**3
        ylm(i) = a*x(i)*y(i)*(11.d0*d-e)*(b-c)/f
     end do
  else if(is == 46) then
     do i=1,n 
        a = dsqrt(9009.d0/(512.d0*PAI))
        b = x(i)*x(i)
        c = y(i)*y(i)
        d = z(i)*z(i)
        e = b+c+d
        f = e**3
        ylm(i) = a*z(i)*x(i)*(b*b-10.d0*b*c+5.d0*c*c)/f
     end do
  else if(is == 47) then
     do i=1,n 
        a = dsqrt(9009.d0/(512.d0*PAI))
        b = y(i)*y(i)
        c = x(i)*x(i)
        e = c+b+z(i)*z(i)
        f = e**3
        ylm(i) = a*y(i)*z(i)*(b*b-10.d0*b*c+5.d0*c*c)/f
     end do
  else if(is == 48) then
     do i=1,n 
        a = dsqrt(3003.d0/(2048.d0*PAI))
        b = x(i)*x(i)
        c = y(i)*y(i)
        e = b+c+z(i)*z(i)
        f = e**3
        ylm(i) = a*(b-c)*(b*b-14.d0*b*c+c*c)/f
     end do
  else if(is == 49) then
     do i=1,n 
        a = dsqrt(3003.d0/(2048.d0*PAI))
        b = x(i)*x(i)
        c = y(i)*y(i)
        d = b+c
        e = b+c+z(i)*z(i)
        f = e**3
        ylm(i) = a*x(i)*y(i)*(6.d0*d*d-32.d0*b*c)/f
     end do
  end if
  coeff = a
end subroutine real_spherical_harmonics

! Copyright (c) 2012, Minoru Otani <minoru.otani@aist.go.jp> 
! 
! Permission is hereby granted, free of charge, to any person 
! obtaining a copy of this software and associated documentation 
! files (the "Software"), to deal in the Software without restriction, 
! including without limitation the rights to use, copy, modify, merge, 
! publish, distribute, sublicense, and/or sell copies of the Software, 
! and to permit persons to whom the Software is furnished to do so, 
! subject to the following conditions:
 
! The above copyright notice and this permission notice shall be 
! included in all copies or substantial portions of the Software.
 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
! OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
! NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
! HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
! WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
! DEALINGS IN THE SOFTWARE.


Program EsmPack
  Use ESM_VARS
  Implicit None
  Integer :: ig, n1, n2, n3, i
  complex(8),Allocatable :: v_h(:), v_l(:), aux(:)
  Real(8), Allocatable :: force_ew(:,:), force_lc(:,:)

  Character(256) :: inputfile, rhogfile
  Integer :: argc
  Integer :: COMMAND_ARGUMENT_COUNT

  Real(8) :: ewaldr, ewaldg, ewld, ehart

  Real(8), Allocatable :: charge(:)      ! Charge of Atoms
  Real(8) :: alpha
  
  argc = COMMAND_ARGUMENT_COUNT() 
  If( argc < 2 ) Then
     Write(6,*) "Usage : EsmPack.x inputfile rhogfile"
     Stop
  End If

! Setup Variables
  Call GETARG( 1, inputfile )
  Call GETARG( 2, rhogfile  )

  Call SetupEsmVars( inputfile )

  Allocate( charge(nat) )
  charge(:) = upf_zp(:)

  Call ReadRhog( rhogfile )

  Call esm_ggen_2d( )

! Ewald 
  alpha = 2.6d0
  Call Ewald( nat, tau, charge, at, alat, alpha, bg, ewaldr )
  Call esm_ewald( charge, alpha, ewaldg )

  ewld = ewaldg + ewaldr
  
! Hartree
  allocate( v_h(nrxx) )
  Call esm_hartree (rhog_, ehart, v_h )

  write(*,*) "Ewald Energy   : ", ewld
  write(*,*) "Hartree Energy : ", ehart

  allocate( v_l(nrxx) )
  v_l(:) = 0d0
  Call esm_local (v_l)

! Ewald Force
  Allocate( force_ew(3,nat) )
  force_ew(:,:) = 0d0
  alpha = 1d0
  Call esm_force_ew ( alpha, force_ew )
  
! Local Force
  allocate( aux(nrxx) )
  aux(:) = 0d0
  Do ig = 1, ngm
     If( nspin == 1 ) aux(nl(ig)) = rhog_(ig,1)
     If( nspin == 2 ) aux(nl(ig)) = rhog_(ig,1) + rhog_(ig,2)
  End Do
  Allocate( force_lc(3,nat) )
  force_lc(:,:) = 0d0
  Call esm_force_lc ( aux, force_lc )

  write(*,*)
  write(*,*) "Ewald Force : "
  Do i = 1, nat
     write(*,*) force_ew(1:3,i)
  End Do

  write(*,*)
  write(*,*) "Local Force : "
  Do i = 1, nat
     write(*,*) force_lc(1:3,i)
  End Do

  deAllocate( charge, force_ew, force_lc )

  Call esm_printpot( rhog_, v_h, v_l )

  deallocate( v_h, v_l )

  Call DeallocEsmVars

End Program EsmPack

!================================================
!  Software name : STM
!  Module : m_FFT
!  Subroutine(s) : m_FFT_Vlocal_W_fine, m_FFT_query_inversion_symmetry
!                  m_FFT_rd_fine_fft_box_size, m_FFT_rd_fft_box_size,
!                  m_FFT_set_fft_box_size_fine, Vlocal_W, fft_phase_work_alloc
!                  fft_WF_work_alloc, fft_WF_work_dealloc, m_FFT_setup,
!                  init_fft_coefficients_arrays, WD_FFTboxsizes, FFT_WF, FFT_WF_fine,
!                  FFT_fine, FFT_CD, check_of_negative_CD, W_Vlocal_W, m_FFT_dFFT_fine,
!                  WF_2dFFT_backward, WF_dFFT_forward, substitute_afft_with_data, pr_afft
!  Author(s)     : Takahiro Yamasaki and Koichi Kato (June 7, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_FFT
! $Id: m_FFT.F90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  use m_ArraySize_Parameters, only : kimg
  use m_Const_Parameters, only : DP,CMPLDP, ON, OFF, INVERSE, DIRECT, PAI2
  use m_Control_Parameters,only: n_fc

  implicit none

  integer, dimension(0:3) :: fft_box_size_WF, fft_box_size_CD &
       &,   fft_box_size_fine
  integer                 :: nfft, nfftp, nfftpf
  integer                 :: nlpf

  complex(kind=CMPLDP), allocatable, dimension(:)    :: cw1,cw2,cw3
  complex(kind=CMPLDP), allocatable, dimension(:)    :: cw1p,cw2p,cw3p
  complex(kind=CMPLDP), allocatable, dimension(:)    :: cw1pf,cw2pf,cw3pf

  real(kind=DP), allocatable, dimension(:)           :: cfft

  real(kind=DP), allocatable, dimension(:)           :: ftw

contains
  subroutine m_FFT_Vlocal_W_fine(afft,bfft,cfft)
    real(kind=DP), intent(in),  dimension(nfftpf) :: afft,bfft
    real(kind=DP), intent(out), dimension(nfftpf) :: cfft

    integer :: i
    !  V_{local} := bfft   : real
    !  \Psi      := afft   : complex

!!$    print *, ' nfftpf = ', nfftpf
    do i = 1, nfftpf-1, 2
       cfft(i)   = bfft(i) * afft(i)
       cfft(i+1) = bfft(i) * afft(i+1)
    end do
  end subroutine M_FFT_Vlocal_W_fine

  subroutine m_FFT_query_inversion_symmetry(inversion_symmetry)
    integer,intent(out) :: inversion_symmetry
    if(kimg == 1) inversion_symmetry = ON
    if(kimg == 2) inversion_symmetry = OFF
  end subroutine m_FFT_query_inversion_symmetry

  subroutine m_FFT_rd_fine_fft_box_size(nfinp)
    integer,intent(in) :: nfinp
    read(nfinp,*) nlpf
  end subroutine m_FFT_rd_fine_fft_box_size

  subroutine m_FFT_rd_fft_box_size(nfcntn_bin)
    integer,intent(in) :: nfcntn_bin
    read(nfcntn_bin) fft_box_size_WF(1:3),fft_box_size_CD(1:3)
#ifdef DEBUG
    write(0,*) 'fft box size wf',fft_box_size_WF(1),fft_box_size_WF(2),fft_box_size_WF(3)
    write(0,*) 'fft box size cd',fft_box_size_CD(1),fft_box_size_CD(2),fft_box_size_CD(3)
#endif
  end subroutine m_FFT_rd_fft_box_size

  subroutine m_FFT_set_fft_box_size_fine
    if( kimg == 1 ) then
        nlpf = fft_box_size_CD(n_fc(1))* 0.5
    else if ( kimg == 2) then
        nlpf = fft_box_size_CD(n_fc(1))
    end if
    fft_box_size_fine(1) = fft_box_size_CD(n_fc(1))
    fft_box_size_fine(2) = fft_box_size_CD(n_fc(2))
    fft_box_size_fine(3) = fft_box_size_CD(n_fc(3))
  end subroutine m_FFT_set_fft_box_size_fine

  subroutine Vlocal_W(afft,bfft)
    real(kind=DP), intent(in),    dimension(nfft) :: afft
    real(kind=DP), intent(inout), dimension(nfft) :: bfft

    integer i
    do i = 1, nfft-1, 2
       bfft(i)   = afft(i) * bfft(i)
       bfft(i+1) = afft(i) * bfft(i+1)
    end do
    if(mod(nfft,2) == 1) bfft(nfft) = afft(nfft)*bfft(nfft)
  end subroutine Vlocal_W

  subroutine fft_phase_work_alloc
    integer :: nnl,nnm,nnn

    nnl  = fft_box_size_WF(1);  nnm  = fft_box_size_WF(2)
    nnn  = fft_box_size_WF(3)
    allocate(cw1(nnl)); allocate(cw2(nnm)); allocate(cw3(nnn))

    nnl = fft_box_size_CD(1);   nnm = fft_box_size_CD(2)
    nnn = fft_box_size_CD(3)
    allocate(cw1p(nnl)); allocate(cw2p(nnm)); allocate(cw3p(nnn))

    nnl = fft_box_size_fine(1); nnm = fft_box_size_fine(2)
    nnn = fft_box_size_fine(3)
    allocate(cw1pf(nnl));allocate(cw2pf(nnm));allocate(cw3pf(nnn))
  end subroutine fft_phase_work_alloc

  subroutine fft_WF_work_alloc
    integer nfftwk
    nfftwk = nfft
    if(nfftwk < nfftp)  nfftwk = nfftp
    if(nfftwk < nfftpf) nfftwk = nfftpf
    allocate(ftw(nfftwk))
  end subroutine fft_WF_work_alloc

  subroutine fft_WF_work_dealloc
    deallocate(ftw)
  end subroutine fft_WF_work_dealloc

  subroutine m_FFT_setup(nfout,inversion_symmetry)
    integer, intent(in)           :: nfout, inversion_symmetry

    integer :: id_sname = -1

    if(inversion_symmetry == ON) then
       fft_box_size_WF(0) = fft_box_size_WF(1) + 2
       fft_box_size_CD(0) = fft_box_size_CD(1) + 2
       fft_box_size_fine(0) = fft_box_size_fine(1) + 2
    else if(inversion_symmetry == OFF) then
       fft_box_size_WF(0) = fft_box_size_WF(1) + 1
       fft_box_size_CD(0) = fft_box_size_CD(1) + 1
       fft_box_size_fine(0) = fft_box_size_fine(1) + 1
    endif
    nfft = fft_box_size_WF(0)*fft_box_size_WF(2)*fft_box_size_WF(3)&
         &*(2-inversion_symmetry)
    nfftp= fft_box_size_CD(0)*fft_box_size_CD(2)*fft_box_size_CD(3)&
         &*(2-inversion_symmetry)
    nfftpf= fft_box_size_fine(0)*fft_box_size_fine(2)*fft_box_size_fine(3)&
         &*(2-inversion_symmetry)

    call fft_WF_work_alloc
    allocate(cfft(nfft))
    call fft_phase_work_alloc

    call init_fft_coefficients_arrays  ! -(contained here)

    deallocate(cfft)

  contains
    subroutine init_fft_coefficients_arrays
      integer id, nl, nm, nn
      id = fft_box_size_WF(0)
      nl = fft_box_size_WF(1)
      nm = fft_box_size_WF(2)
      nn = fft_box_size_WF(3)

      if(kimg == 1) then
         call jrcat_r3ft(cfft,ftw,id,nl,nm,nn,cw1,cw2,cw3,0,0,0,0)
      else
         call jrcat_c3ft(cfft,ftw,id,nl,nm,nn,cw1,cw2,cw3,0,0,0,0)
      endif

      id = fft_box_size_CD(0)
      nl = fft_box_size_CD(1)
      nm = fft_box_size_CD(2)
      nn = fft_box_size_CD(3)

      if(kimg == 1) then
         call jrcat_r3ft(cfft,ftw,id,nl,nm,nn,cw1p,cw2p,cw3p,0,0,0,0)
      else
         call jrcat_c3ft(cfft,ftw,id,nl,nm,nn,cw1p,cw2p,cw3p,0,0,0,0)
      endif

      id = fft_box_size_fine(0)
      nl = fft_box_size_fine(1)
      nm = fft_box_size_fine(2)
      nn = fft_box_size_fine(3)

      if(kimg == 1) then
         call jrcat_r3ft(cfft,ftw,id,nl,nm,nn,cw1pf,cw2pf,cw3pf,0,0,0,0)
      else
         call jrcat_c3ft(cfft,ftw,id,nl,nm,nn,cw1pf,cw2pf,cw3pf,0,0,0,0)
      endif

    end subroutine init_fft_coefficients_arrays

    subroutine WD_FFTboxsizes(nfout)
      integer, intent(in) :: nfout

      write(nfout,*) ' ---- (WF)FFT size ----'
      write(nfout,'(a44,i7)') &
           &     '  total FFT elements(including work area) = ', nfft
      write(nfout,'(a44,3i5)') &
           & ' actual FFT box size                      = ' &
           & , fft_box_size_WF(0), fft_box_size_WF(2), fft_box_size_WF(3)
      write(nfout,'(a44,3i5)') &
           & '   real FFT size                          = ' &
           & , fft_box_size_WF(1), fft_box_size_WF(2), fft_box_size_WF(3)

      write(nfout,*) ' ---- (CD)FFT size ----'
      write(nfout,'(a44,i7)') &
           & '  total FFT elements(including work area) = ', nfftp
      write(nfout,'(a44,3i5)') &
           & ' actual FFT box size                      = ' &
           & , fft_box_size_CD(0), fft_box_size_CD(2), fft_box_size_CD(3)
      write(nfout,'(a44,3i5)') &
           & '   real FFT size                          = ' &
           & , fft_box_size_CD(1), fft_box_size_CD(2), fft_box_size_CD(3)

      write(nfout,*) ' ---- (fine)FFT size ----'
      write(nfout,'(a44,i7)') &
           & '  total FFT elements(including work area) = ', nfftpf
      write(nfout,'(a44,3i5)') &
           & ' actual FFT box size                      = ' &
           & ,fft_box_size_fine(0),fft_box_size_fine(2),fft_box_size_fine(3)
      write(nfout,'(a44,3i5)') &
           & '   real FFT size                          = ' &
           & ,fft_box_size_fine(1),fft_box_size_fine(2),fft_box_size_fine(3)
    end subroutine WD_FFTboxsizes

  end subroutine m_FFT_setup

  subroutine FFT_WF(afft,inverse_or_direct,switch)  ! G space --> R space
    real(kind=DP), intent(inout) :: afft(nfft)
    integer, intent(in)          :: inverse_or_direct
    integer, intent(in)          :: switch
    integer :: id, nl, nm, nn, ier1 = 0

    integer, dimension(2) :: flag_jrcat_r3ft = (/-2,  2/)
    integer, dimension(2) :: flag_jrcat_c3ft = (/ 1, -1/)

    integer kc1, kc2, kc3

    integer :: id_sname = -1

    id = fft_box_size_WF(0)
    nl = fft_box_size_WF(1)
    nm = fft_box_size_WF(2)
    nn = fft_box_size_WF(3)

    if(switch == ON) then
       kc1 = 0;       kc2 = nm/4 + 1;       kc3 = nn/4 + 1
    else
       kc1 = 0;       kc2 = 0       ;       kc3 = 0
    endif
    if(kimg == 1) then
       call jrcat_r3ft(afft,ftw,id,nl,nm,nn,cw1,cw2,cw3,kc1,kc2,kc3&
            & ,flag_jrcat_r3ft(inverse_or_direct))
    else if(kimg == 2) then
       call jrcat_c3ft(afft,ftw,id,nl,nm,nn,cw1,cw2,cw3,kc1,kc2,kc3&
            & ,flag_jrcat_c3ft(inverse_or_direct))
    endif
    if (ier1 /= 0) then
       print *, ' !!(Error fft) ier1 = ',ier1
       stop
    end if
  end subroutine FFT_WF

  subroutine FFT_WF_fine(afft,inverse_or_direct)
    real(kind=DP), intent(inout) :: afft(nfftpf)
    integer, intent(in)          :: inverse_or_direct
!!$    call FFT_CD(afft,inverse_or_direct)
    call FFT_fine(afft,inverse_or_direct)
  end subroutine FFT_WF_fine

  subroutine FFT_fine(afft,inverse_or_direct)   ! R space --> G space
    real(kind=DP), intent(inout) :: afft(nfftpf)
    integer, intent(in)          :: inverse_or_direct

    integer :: idp,nlp, nmp, nnp, ier1 = 0, kc1 = 0, kc2 = 0, kc3 = 0
    integer :: id_sname = -1
    integer, dimension(2) :: flag_jrcat_r3ft = (/-2,  2/)
    integer, dimension(2) :: flag_jrcat_c3ft = (/ 1, -1/)

 
    idp = fft_box_size_fine(0)
    nlp = fft_box_size_fine(1)
    nmp = fft_box_size_fine(2)
    nnp = fft_box_size_fine(3)

    if(kimg == 1) then
       call jrcat_r3ft(afft,ftw,idp,nlp,nmp,nnp,cw1pf,cw2pf,cw3pf &
            & ,kc1,kc2,kc3, flag_jrcat_r3ft(inverse_or_direct))
    else if(kimg == 2) then
       call jrcat_c3ft(afft,ftw,idp,nlp,nmp,nnp,cw1pf,cw2pf,cw3pf &
            & ,kc1,kc2,kc3 ,flag_jrcat_c3ft(inverse_or_direct))
    endif

    if (ier1 /= 0) then
       print *, ' !!Error  fft(direct) ier1 = ',ier1
       stop
    end if
  end subroutine FFT_fine

  subroutine FFT_CD(afft,inverse_or_direct)   ! R space --> G space
    real(kind=DP), intent(inout) :: afft(nfftp)
    integer, intent(in)          :: inverse_or_direct

    integer :: idp,nlp, nmp, nnp, ier1 = 0, kc1 = 0, kc2 = 0, kc3 = 0
    integer :: id_sname = -1
    integer, dimension(2) :: flag_jrcat_r3ft = (/-2,  2/)
    integer, dimension(2) :: flag_jrcat_c3ft = (/ 1, -1/)


    idp = fft_box_size_CD(0)
    nlp = fft_box_size_CD(1)
    nmp = fft_box_size_CD(2)
    nnp = fft_box_size_CD(3)

    if(kimg == 1) then
       call jrcat_r3ft(afft,ftw,idp,nlp,nmp,nnp,cw1p,cw2p,cw3p,kc1,kc2,kc3&
            &, flag_jrcat_r3ft(inverse_or_direct))
    else if(kimg == 2) then
       call jrcat_c3ft(afft,ftw,idp,nlp,nmp,nnp,cw1p,cw2p,cw3p,kc1,kc2,kc3&
            & ,flag_jrcat_c3ft(inverse_or_direct))
    endif

    if (ier1 /= 0) then
       print *, ' !!Error  fft(direct) ier1 = ',ier1
       stop
    end if
  end subroutine FFT_CD

  subroutine check_of_negative_CD(afft,nfout,nspin,ispin)
    real(kind=DP), intent(inout) :: afft(nfftp)
    integer, intent(in)          :: nfout,nspin,ispin

    integer                   :: imodi, i
    integer                   :: icwarn_NEGA, icwarn_IMAG
    integer, parameter        :: MXWARN = 10
    real(kind=DP),parameter   :: chgdel = 8.d-5

    if(kimg.eq.1) then
       imodi = nfftp+10
    else if(kimg.eq.2) then
       imodi = fft_box_size_CD(0)
    end if

    icwarn_NEGA = 0
    icwarn_IMAG = 0
    do i = 1,nfftp-1,2
       if( (afft(i) <= -chgdel) .and. (mod(i+1,imodi) /= 0)) then
          icwarn_NEGA = icwarn_NEGA + 1
          if(icwarn_NEGA.le.MXWARN) then
             if(icwarn_NEGA.eq.1.and.nspin.eq.2) then
                write(nfout,*) ' #spin = ', ispin
             endif
             write(nfout,110) i,afft(i)
110          format(1h ,'**WARN CHG.DEN<0.0 AT ',I7,2D15.7,'***')
          endif
          afft(i) = 1.d-40
       else if (afft(i) <= 0.d0) then
          afft(i) = 1.d-40
       end if
       if( (abs(afft(i+1)) > chgdel).and. (mod(i+1,imodi) /= 0) ) then
          icwarn_IMAG = icwarn_IMAG + 1
          if(icwarn_IMAG.le.MXWARN) then
             if(icwarn_IMAG.eq.1.and.nspin.eq.2) then
                write(nfout,*) ' #spin = ', ispin
             endif
             write(nfout,120) i,afft(i+1)
120          format(1h ,'**WARN IMAG(CHG)>0.0 AT ',I7,2D15.7,'***')
          endif
          afft(i+1) = 0.d0
       else if (abs(afft(i+1)).gt.0.d0) then
          afft(i+1) = 0.d0
       end if
    end do
    if(icwarn_NEGA.gt.MXWARN) then
       if(nspin.eq.2) &
            &   write(nfout,*) ' #spin = ',ispin,' : 1 = UP, 2 = DOWN'
       write(nfout,*) &
            &  ' Warning of <<Negative Charge Density>> = ',icwarn_NEGA
    endif
    if(icwarn_IMAG.gt.MXWARN) then
       if(nspin.eq.2)  &
            &   write(nfout,*) ' #spin = ',ispin,' : 1 = UP, 2 = DOWN'
       write(nfout,*) &
            &  ' Warning of <<Imaginary Charge Density>> = ',icwarn_IMAG
    endif
  end subroutine check_of_negative_CD

  subroutine W_Vlocal_W(afft,bfft,eg)
    real(kind=DP), intent(in),    dimension(nfft) :: afft
    real(kind=DP), intent(inout), dimension(nfft) :: bfft
    real(kind=DP), intent(out)                 :: eg

    integer i, nl, nm, nn, id
    real(kind=DP) :: vcel, s

    id = fft_box_size_WF(0)
    nl = fft_box_size_WF(1)
    nm = fft_box_size_WF(2)
    nn = fft_box_size_WF(3)

    do i = 1, nfft-1, 2
       bfft(i) = afft(i)*(bfft(i)**2 + bfft(i+1)**2)
    end do
    vcel = 1.d0/(nl*nm*nn)
    s = 0.d0
    if(kimg == 1) then
       do i = 1, nfft-1, 2
          s = s + bfft(i)
       end do
       s = s + s
       do i = 1, nfft-1, id
          s = s - bfft(i)
       end do
       do i = id-1, nfft-1, id
          s = s - bfft(i)
       end do
    else if(kimg == 2) then
       do i = 1, nfft-1, 2
          s = s + bfft(i)
       end do
    end if
    eg = s * vcel
  end subroutine W_Vlocal_W

  subroutine m_FFT_WF_2dFFT_fine(afft,inverse_or_direct)
    real(kind=DP), intent(inout) :: afft(nfftpf)
    integer, intent(in)          :: inverse_or_direct
!	INVERSE: 1, DIRECT: 2

    integer, dimension(2) :: flag_jrcat_r2ft = (/-1, 1/)
    integer, dimension(2) :: flag_jrcat_c2ft = (/ 1, -1/)

    real(kind=DP) :: factor
    integer :: idp, nlp, nmp, nnp

    integer :: id_sname = -1


    idp = fft_box_size_fine(0)
    nlp = fft_box_size_fine(1)
    nmp = fft_box_size_fine(2)
    nnp = fft_box_size_fine(3)

    ftw = 0.d0
    if(kimg == 1) then
       call jrcat_r2ft_of_3D(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf &
            & ,flag_jrcat_r2ft(inverse_or_direct))
    else if(kimg == 2) then
       call jrcat_c2ft_of_3D(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf &
            & ,flag_jrcat_c2ft(inverse_or_direct))
    endif
    if(inverse_or_direct .eq. DIRECT) then
       factor = 1.d0/(nmp*nnp)
       afft = afft*factor
    end if

  end subroutine M_FFT_WF_2dFFT_fine

  subroutine WF_2dFFT_backward(afft)
    real(kind=DP), intent(inout) :: afft(nfftpf)

    real(kind=DP) :: factor
    integer :: idp, nlp, nmp, nnp
    integer :: id_sname = -1
    integer :: key

    key = +1

    idp = fft_box_size_fine(0)
    nlp = fft_box_size_fine(1)
    nmp = fft_box_size_fine(2)
    nnp = fft_box_size_fine(3)

    factor = 1.d0/(nmp*nnp)

    ftw = 0.d0
    if(kimg == 1) then
       call jrcat_r2ft_of_3D(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf,key)
!!$    call jrcat_r2ft_of_3D_back(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf)
    else if(kimg == 2) then
       call jrcat_c2ft_of_3D(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf,key)
!!$       call jrcat_c2ft_of_3D_back(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf)
    endif
    afft = afft*factor

  end subroutine WF_2dFFT_backward

  subroutine WF_2dFFT_forward(afft)
    real(kind=DP), intent(inout) :: afft(nfftpf)

    integer :: idp, nlp, nmp, nnp
    integer :: id_sname = -1
    integer :: key

    key = -1

    idp = fft_box_size_fine(0)
    nlp = fft_box_size_fine(1)
    nmp = fft_box_size_fine(2)
    nnp = fft_box_size_fine(3)

!!$    factor = 1.d0/(nlp*nmp*nnp)

    ftw = 0.d0
    if(kimg == 1) then
!!$       call jrcat_r1ft_of_3D_back(afft,ftw,idp,nlp,nmp,nnp,cw1pf)
!!$       call jrcat_r3ft(afft,ftw,idp,nlp,nmp,nnp,cw1pf,cw2pf,cw3pf,0,0,0,-1)
!!$    call jrcat_r2ft_of_3D_forward(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf)
       call jrcat_r2ft_of_3D(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf,key)
!!$       afft = afft*factor
    else if(kimg == 2) then
!!$       call jrcat_c1ft_of_3D_back(afft,ftw,idp,nlp,nmp,nnp,cw1p)
!!$       call jrcat_c3ft(afft,ftw,idp,nlp,nmp,nnp,cw1p,cw2p,cw3p,0,0,0,-1)
!!$    call jrcat_c2ft_of_3D_forward(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf)
       call jrcat_c2ft_of_3D(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf,key)
!!$       afft = afft*factor
    endif

  end subroutine WF_2dFFT_forward

  subroutine substitute_afft_with_data(p,q,afft)
    integer, intent(in)                           :: p,q
    real(kind=DP), intent(out), dimension(nfftpf) :: afft
    real(kind=DP), pointer, dimension(:)          :: d1,d2,d3

    integer       :: nlpfh, nlpf_t, nmpf, nnpf, i,j,k,ip,igfpf, imax
    real(kind=DP) :: phase

    nlpf_t = fft_box_size_fine(1)
    if(kimg == 1) then
       nlpfh = fft_box_size_fine(0)/2
    else
       nlpfh = fft_box_size_fine(0)
    end if
    nmpf = fft_box_size_fine(2); nnpf = fft_box_size_fine(3)

    if(kimg == 1) then
       imax = nlpfh
    else
       imax = nlpf_t
    end if

    allocate(d1(imax)); allocate(d2(nmpf)); allocate(d3(nnpf))

    do i = 1, imax
       d1(i) = (nlpf_t-i+1)/dble(nlpf_t)
    end do

    do i = 1, nmpf
       phase = PAI2*p*(i-1)/nmpf
       d2(i) = dcos(phase)
    end do

    do i = 1, nnpf
       phase = PAI2*q*(i-1)/nnpf
       d3(i) = dcos(phase)
    end do

    do k = 1, nnpf
       do j = 1, nmpf
          do i = 1, imax
             igfpf = i + (j-1)*nlpfh + (k-1)*nlpfh*nmpf
             ip = 2*igfpf-1
             afft(ip) = d1(i)*d2(j)*d3(k)
             afft(ip+1) = 0.d0
          end do
       end do
    end do

    deallocate(d1); deallocate(d2); deallocate(d3)
  end subroutine substitute_afft_with_data

  subroutine pr_afft(p,q,afft)
    integer, intent(in)                          :: p,q
    real(kind=DP), intent(in), dimension(nfftpf) :: afft

    integer :: i,j,k,imin,imax,jmin,jmax,kmin,kmax,nlpfh,nmpf
    integer, pointer, dimension(:) :: ip
    
    if(kimg == 1) then
       nlpfh = fft_box_size_fine(0)/2
    else
       nlpfh = fft_box_size_fine(0)
    end if
    nmpf  = fft_box_size_fine(2)

    imin = 1; imax = 3

    jmin = p-3; jmax = p+3
    if(jmin < 1) jmin = 1
    if(jmax > fft_box_size_fine(2)) jmax = fft_box_size_fine(2)
    allocate(ip(jmin:jmax))

    kmin = q-3; kmax = q+3
    if(kmin < 1) kmin = 1
    if(kmax > fft_box_size_fine(3)) kmax = fft_box_size_fine(3)


    print '(" p,q = ",i5,i5)',p,q
    do i = imin, imax
       print '(" i = ", i5)',i
       print '(" range : (",i5,":",i5,",",i5,":",i5,")")' &
            & , jmin,jmax,kmin,kmax
       do k = kmin, kmax
          do j = jmin, jmax
             ip(j) = 2*(i+(j-1)*nlpfh+(k-1)*nlpfh*nmpf) - 1
          end do
          print '(" (k = ",i5,")",8f10.4)',k,(afft(ip(j)),j=jmin,jmax)
       end do
    end do
  end subroutine pr_afft

end module m_FFT

      subroutine dc_redist1(n, NB, a, b, ldm, wk, lwk)
      implicit NONE

      integer, intent(in)  :: n, NB, ldm, lwk
      real(8), intent(in)  :: a(ldm, *)
      real(8), intent(out) :: b(ldm, *)
      real(8), intent(inout) :: wk(*)

      real(8), pointer     :: wk1(:, :), wk2(:, :)

      integer :: i,j,j0,k,k0,l,lx
      integer :: iNQ
      integer :: iblk, jblk
      integer :: idist, ir_size, is_size
      integer :: his_rank, her_rank
      integer, pointer :: ir_sz(:, :, :)

      integer :: NQ, NBQ

      include 'trd.h'


      iblk = (n-1)/y_nnod+1
      iblk = (iblk-1)/NB+1
      jblk = (n-1)/x_nnod+1
      jblk = (iblk-1)/NB+1


      do iNQ=1,NB

         NQ = iNQ
         NBQ = (NB-1)/NQ+1

         lx = 0
         do i=1,iblk
         do j0=1,NB,NBQ
         do idist = 1, y_nnod-1

            his_rank = MOD(y_inod-1-idist+y_nnod,y_nnod)+1
            her_rank = MOD(y_inod-1+idist+y_nnod,y_nnod)+1

            l = 0
            do j=j0,MIN(NB,j0+NBQ-1)
              K=j+((y_inod-1)+(i-1)*y_nnod)*NB
              if ( K <= n .AND. MOD(K-1,y_nnod)+1 == her_rank ) then
                 l = l + 1
              end if
            end do
            lx = MAX(l, lx)

            l = 0
            do j=j0,MIN(NB,j0+NBQ-1)
              K=j+((his_rank-1)+(i-1)*y_nnod)*NB
              if ( K <= n .AND. MOD(K-1,y_nnod)+1 == y_inod ) then
                 l = l + 1
              end if
            end do
            lx = MAX(l, lx)

            if ( lwk >= y_nnod*iblk*NQ ) then
               K = idist + ((i-1) + ((j0-1)/NBQ) * iblk) * y_nnod
               wk(K) = l
            end if

         end do
         end do
         end do

         if ( ldm*lx*2 <= lwk ) then
            exit
         end if

      end do

      allocate ( ir_sz(y_nnod, iblk, NQ) )

      if ( lwk >= y_nnod*iblk*NQ ) then

         do i=1,iblk
         do j0=1,NB,NBQ
         do idist = 1, y_nnod-1
            K = idist + ((i-1) + ((j0-1)/NBQ) * iblk) * y_nnod
            ir_sz(idist, i, (j0-1)/NBQ+1) = wk(K)
         enddo
         enddo
         enddo

      else

         do i=1,iblk
         do j0=1,NB,NBQ
         do idist = 1, y_nnod-1

            his_rank = MOD(y_inod-1-idist+y_nnod,y_nnod)+1
            l = 0
            do j=j0,MIN(NB,j0+NBQ-1)
              K=j+((his_rank-1)+(i-1)*y_nnod)*NB
              if ( K <= n .AND. MOD(K-1,y_nnod)+1 == y_inod ) then
                 l = l + 1
              end if
            end do
            ir_sz(idist,i,(j0-1)/NBQ+1) = l

         end do
         end do
         end do

      end if

      if ( ldm*lx*2 <= lwk ) then
         call dc_redist1_sub ( n, NB, a, b, ldm,
     &                       wk(1), wk(1+ldm*lx),
     &                       ir_sz, y_nnod, iblk, NBQ )
      else if ( ldm*lx <= lwk ) then
         allocate ( wk2(1:ldm, 1:lx) )
         call dc_redist1_sub ( n, NB, a, b, ldm,
     &                       wk, wk2(1,1),
     &                       ir_sz, y_nnod, iblk, NBQ )
         deallocate ( wk2 )
      else
         allocate ( wk1(1:ldm, 1:lx) )
         allocate ( wk2(1:ldm, 1:lx) )
         call dc_redist1_sub ( n, NB, a, b, ldm,
     &                       wk1(1,1), wk2(1,1),
     &                       ir_sz, y_nnod, iblk, NBQ )
         deallocate ( wk1 )
         deallocate ( wk2 )
      end if

      deallocate ( ir_sz )

      return
      end subroutine


      subroutine dc_redist1_sub(n, NB, a, b, ldm,
     $               wk1, wk2, ir_sz, l1, l2, NBQ)
      implicit NONE

      integer, intent(in)  :: n, NB, ldm, l1, l2, NBQ
      real(8), intent(in)  :: a(ldm,*)
      real(8), intent(out) :: b(ldm,*)
      real(8), intent(inout) :: wk1(ldm,*), wk2(ldm,*)
      integer, intent(in) :: ir_sz(l1,l2,*)

      integer :: i,j,j0,k,k0,l,lx
      integer :: iblk, jblk
      integer :: idist, ir_size, is_size
      integer :: iq_r, iq_s, his_rank, her_rank

      include 'trd.h'
      integer, pointer :: l_(:)

      iblk = (n-1)/y_nnod+1
      iblk = (iblk-1)/NB+1
      jblk = (n-1)/x_nnod+1
      jblk = (iblk-1)/NB+1


      allocate ( l_(0:NB) )


      do i=1,iblk
      do j0=1,NB,NBQ

!$OMP PARALLEL DO PRIVATE(j,K,K0,l)
         do j=j0,MIN(NB,j0+NBQ-1)
           K=j+((y_inod-1)+(i-1)*y_nnod)*NB
           if ( K <= n .AND. MOD(K-1,y_nnod)+1 == y_inod ) then
              K0=(K-1)/y_nnod+1
              b(1:ldm, K0) = a(1:ldm, j+NB*(i-1))
           end if
         end do
!$OMP END PARALLEL DO

      do idist = 1, y_nnod-1

         her_rank = MOD(y_inod-1+idist+y_nnod,y_nnod)+1
         his_rank = MOD(y_inod-1-idist+y_nnod,y_nnod)+1

         ir_size=ldm*ir_sz(idist,i,(j0-1)/NBQ+1)
         if ( ir_size > 0 ) then
         call irecv_dbl ( wk2, ir_size, his_rank, iq_r, y_COMM_WORLD )
         end if

         l = 0; l_(0)=0
         do j=j0,MIN(NB,j0+NBQ-1)
           K=j+((y_inod-1)+(i-1)*y_nnod)*NB
           if ( K <= n .AND. MOD(K-1,y_nnod)+1 == her_rank ) then
              l = l + 1
           end if
           l_(j-j0+1) = l
         end do
         lx = l
!$OMP PARALLEL DO PRIVATE(j,K,K0,l)
         do j=j0,MIN(NB,j0+NBQ-1)
           l = l_(j-j0)
           K=j+((y_inod-1)+(i-1)*y_nnod)*NB
           if ( K <= n .AND. MOD(K-1,y_nnod)+1 == her_rank ) then
              l = l + 1
              wk1(1:ldm, l) = a(1:ldm, j+NB*(i-1))
           end if
         end do
!$OMP END PARALLEL DO

         is_size=ldm*lx
         if ( is_size > 0 ) then
         call isend_dbl ( wk1, is_size, her_rank, iq_s, y_COMM_WORLD )
         end if

         if ( ir_size > 0 ) then
         call wait_dbl ( iq_r )

         l = 0; l_(0)=0
         do j=j0,MIN(NB,j0+NBQ-1)
           K=j+((his_rank-1)+(i-1)*y_nnod)*NB
           if ( K <= n .AND. MOD(K-1,y_nnod)+1 == y_inod ) then
              l = l + 1
           end if
           l_(j-j0+1) = l
         end do
         lx = l
!$OMP PARALLEL DO PRIVATE(j,K,K0,l)
         do j=j0,MIN(NB,j0+NBQ-1)
           l = l_(j-j0)
           K=j+((his_rank-1)+(i-1)*y_nnod)*NB
           if ( K <= n .AND. MOD(K-1,y_nnod)+1 == y_inod ) then
              l = l + 1
              K0=(K-1)/y_nnod+1
              b(1:ldm, K0) = wk2(1:ldm, l)
           end if
         end do
!$OMP END PARALLEL DO
         end if

         if ( is_size > 0 ) then
         call wait_dbl ( iq_s )
         end if

      enddo

      end do
      end do


      deallocate ( l_ )


      return
      end subroutine

module z_interface_3D

#ifdef PARA3D
  use m_PlaneWaveBasisSet,  only : kg1,iba,kgp,kg
  use m_PseudoPotential,    only : nlmta,nlmtt

  use m_Const_Parameters,   only : DP, CMPLDP, SKIP, EXECUT, ON, OFF, INVERSE, DELTA, PAI2 &
       &                         , ORTHOGONALIZATION, ORTHONORMALIZATION, NORMALIZATION &
       &                         , NORMCONSERVATION, VDB, VANDERBILT_TYPE &
       &                         , OTHER_BANDS, SAME_BAND, DELTAevdff, BUCS, SCF, EK &
       &                         , ELECTRON, GAMMA, MAPPED, NOTMAPPED, EK_CONVERGED

  use m_Parallelization,    only   : mpi_kg_world   &
       &                           , mpi_ke_world   &
       &                           , mpi_comm_group &
       &                           , ista_k_3D, iend_k_3D       &
       &                           , np_g1k_3D, nis_g1k_3D, ista_g1k_3D, iend_g1k_3D  &
       &                           , myrank_g_3D      &
       &                           , myrank_e, myrank_e_3D, nrank_e_3D      &
       &                           , nis_e_3D, np_e_3D, nis_fs_3D, np_fs_3D   & 
       &                           , np_e, nis_e, ista_k, iend_k, ista_e, iend_e   &
       &                           , map_e, map_z, mype, npes &
       &                           , ista_snl, iend_snl      &
       &                           , mpi_k_world,myrank_k   &
       &                           ,  nbs_sta, nbs_end, neg_g_all, neg_gg_all &
       &                           , ista_kngp, iend_kngp, np_kngp, mp_kngp &
       &                           , ista_kngp_3D, iend_kngp_3D, np_kngp_3D, mp_kngp_3D

  use m_Control_Parameters, only :   nblocksize_mgs          & 
       &                           , nblocksize_mgs_is_given & 
       &                           , neg, kimg, nspin
  use m_Ionic_System,       only : ntyp

  use m_Timing,              only : tstatc0_begin, tstatc0_end

!index band
  use m_Parallelization,    only   : lrank, nbsn, nbsn_sta, nbsn_end, neg_g, nbs_num, nbsn_num  

  implicit none

   integer :: id_sname=-1

contains
  subroutine decomp_zaj_l_3D(zaj_l,zaj_l_3D,ik,nrvf_ordr,sort)

  integer :: ierr,err
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

  real(kind=DP) :: zaj_l(kg1,np_e,ista_k:iend_k,kimg)
  real(kind=DP) :: zaj_l_3D(maxval(np_g1k_3D),np_e_3D,ista_k_3D:iend_k_3D,kimg)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, ik, is, js, nn, ito
  real(kind=DP), allocatable, dimension(:,:,:,:) :: t_wk1, t_wk2
  integer :: nrvf_ordr(neg,ista_k:iend_k)
  character(len=4) :: sort

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate( t_wk1(kg1,neg,ista_k:iend_k,kimg) )
   allocate( t_wk2(kg1,neg,ista_k:iend_k,kimg) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0
   zaj_l_3D = 0.0d0

   do l = 1, kimg
   do k = ista_k, iend_k
   do j = 1,np_e
   do i = 1,iba(k)
     if ((sort == "sort") .and. (k == ik)) then
     ito = nrvf_ordr(nis_e(myrank_e) + j-1,ik)
     t_wk1(i,ito,k,l) = zaj_l(i,j,k,l)
   else
     js = nis_e(myrank_e) + j-1
     t_wk1(i,js,k,l) = zaj_l(i,j,k,l)
   endif
   enddo; enddo; enddo; enddo

   nn = kg1*neg*(iend_k-ista_k+1)*kimg
   call mpi_allreduce(t_wk1,t_wk2,nn,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   do l = 1, kimg
   do k = ista_k_3D, iend_k_3D
   do j = 1, np_e_3D
        js = neg_g(j)
   do i = 1,np_g1k_3D(k)
        is = nis_g1k_3D(myrank_g_3D,k) + i-1
        zaj_l_3D(i,j,k,l) = t_wk2(is,js,k,l)
   enddo; enddo; enddo; enddo


   deallocate( t_wk1, t_wk2)

   call tstatc0_end(id_sname)

  end subroutine decomp_zaj_l_3D

!===============================================================================
  subroutine decomp_zaj_l_r_3D(zaj_l,zaj_l_3D,ik,neordr,sort)

  integer :: ierr,err
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

  real(kind=DP) :: zaj_l(kg1,np_e,ista_k:iend_k,kimg)
  real(kind=DP) :: zaj_l_3D(maxval(np_g1k_3D),np_e_3D,ista_k_3D:iend_k_3D,kimg)
  integer :: NB, nbs, lb, local_block, jj
  integer :: i, j, k, l, m, n, ik, is, js, nn, ifrom, jto
  real(kind=DP), allocatable, dimension(:,:,:,:) :: t_wk1, t_wk2,t_wk3, t_wk4
  integer :: neordr(neg,ista_k:iend_k)
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num
  character(len=2) :: c_img
  character(len=80) :: fname

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate( t_wk1(kg1,neg,ista_k_3D:iend_k_3D,kimg) )
   allocate( t_wk2(kg1,neg,ista_k_3D:iend_k_3D,kimg) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do l = 1, kimg
   do k = ista_k_3D, iend_k_3D
   do j = 1, np_e_3D
        if ((sort == "sort") .and. (k == ik)) then
             jto = neordr(neg_g(j),ik)
        else
             jto = neg_g(j)
        endif
   do i = 1,np_g1k_3D(k)
        is = nis_g1k_3D(myrank_g_3D,k) + i-1
        t_wk2(is,jto,k,l) = zaj_l_3D(i,j,k,l)
   enddo; enddo; enddo; enddo

   nn = kg1*neg*(iend_k_3D-ista_k_3D+1)*kimg
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   do l = 1, kimg
   do k = ista_k, iend_k
   do j = 1,np_e
   do i = 1,iba(k)
     js = nis_e(myrank_e) + j-1
     zaj_l(i,j,k,l) = t_wk1(i,js,k,l)
   enddo; enddo; enddo; enddo

   deallocate( t_wk1, t_wk2)

   call tstatc0_end(id_sname)

  end subroutine decomp_zaj_l_r_3D

!===============================================================================
  subroutine decomp_zaj_l_3D_ik(zaj_l,zaj_l_3D,ik,nrvf_ordr,sort)

  integer :: ierr,err
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

  real(kind=DP) :: zaj_l(kg1,np_e,ista_k:iend_k,kimg)
  real(kind=DP) :: zaj_l_3D(maxval(np_g1k_3D),np_e_3D,ista_k_3D:iend_k_3D,kimg)
  integer :: NB, nbs, lb
  integer :: i, j, l, m, n, ik, is, js, nn, ito
  real(kind=DP), allocatable, dimension(:,:,:) :: t_wk1, t_wk2
  integer :: nrvf_ordr(neg,ista_k:iend_k)
  character(len=4) :: sort

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate( t_wk1(kg1,neg,kimg) )
   allocate( t_wk2(kg1,neg,kimg) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0
!  zaj_l_3D = 0.0d0

   do l = 1, kimg
   do j = 1,np_e
   do i = 1,iba(ik)
   if ((sort == "sort")) then
     ito = nrvf_ordr(nis_e(myrank_e) + j-1,ik)
     t_wk1(i,ito,l) = zaj_l(i,j,ik,l)
   else
     js = nis_e(myrank_e) + j-1
     t_wk1(i,js,l) = zaj_l(i,j,ik,l)
   endif
   enddo; enddo; enddo

   nn = kg1*neg*kimg
   call mpi_allreduce(t_wk1,t_wk2,nn,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   do l = 1, kimg
   do j = 1, np_e_3D
        js = neg_g(j)
   do i = 1,np_g1k_3D(ik)
        is = nis_g1k_3D(myrank_g_3D,ik) + i-1
        zaj_l_3D(i,j,ik,l) = t_wk2(is,js,l)
   enddo; enddo; enddo


   deallocate( t_wk1, t_wk2)

   call tstatc0_end(id_sname)

  end subroutine decomp_zaj_l_3D_ik

!===============================================================================
  subroutine decomp_zaj_l_r_3D_ik(zaj_l,zaj_l_3D,ik,neordr,sort)

  integer :: ierr,err
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

  real(kind=DP) :: zaj_l(kg1,np_e,ista_k:iend_k,kimg)
  real(kind=DP) :: zaj_l_3D(maxval(np_g1k_3D),np_e_3D,ista_k_3D:iend_k_3D,kimg)
  integer :: NB, nbs, lb, local_block, jj
  integer :: i, j, l, m, n, ik, is, js, nn, ifrom, jto
  real(kind=DP), allocatable, dimension(:,:,:) :: t_wk1, t_wk2
  integer :: neordr(neg,ista_k:iend_k)
  character(len=4) :: sort

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate( t_wk1(kg1,neg,kimg) )
   allocate( t_wk2(kg1,neg,kimg) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do l = 1, kimg
   do j = 1, np_e_3D
        if ((sort == "sort")) then
             jto = neordr(neg_g(j),ik)
        else
             jto = neg_g(j)
        endif
   do i = 1,np_g1k_3D(ik)
        is = nis_g1k_3D(myrank_g_3D,ik) + i-1
        t_wk2(is,jto,l) = zaj_l_3D(i,j,ik,l)
   enddo; enddo; enddo

   nn = kg1*neg*kimg
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   do l = 1, kimg
   do j = 1,np_e
   do i = 1,iba(ik)
     js = nis_e(myrank_e) + j-1
     zaj_l(i,j,ik,l) = t_wk1(i,js,l)
   enddo; enddo; enddo

   deallocate( t_wk1, t_wk2)

   call tstatc0_end(id_sname)

  end subroutine decomp_zaj_l_r_3D_ik

!===============================================================================
  subroutine decomp_fsr_l_3D(fsr_l,fsr_l_3D,ik,nrvf_ordr,sort)

  integer :: ierr,err
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

  real(kind=DP) :: fsr_l(np_e,nlmta,ista_k:iend_k)
  real(kind=DP) :: fsr_l_3D(np_e_3D,np_fs_3D,ista_k_3D:iend_k_3D) 
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, ik, is, js, nn, ito
  real(kind=DP), allocatable, dimension(:,:,:) :: t_wk1, t_wk2
  integer :: nrvf_ordr(neg,ista_k:iend_k)
  character(len=4) :: sort

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate( t_wk1(neg,nlmta,ista_k:iend_k) )
   allocate( t_wk2(neg,nlmta,ista_k:iend_k) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0
   fsr_l_3D = 0.0d0

   do k = ista_k, iend_k
   do j = 1,nlmta
   do i = 1,np_e
     if ((sort == "sort") .and. (k == ik) )then
     ito = nrvf_ordr(nis_e(myrank_e) + i-1,ik)
     t_wk1(ito,j,k) = fsr_l(i,j,k)
   else
     is = nis_e(myrank_e) + i-1
     t_wk1(is,j,k) = fsr_l(i,j,k)
   endif
   enddo; enddo; enddo

   nn = neg*nlmta*(iend_k-ista_k+1)
   call mpi_allreduce(t_wk1,t_wk2,nn,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   do k = ista_k_3D, iend_k_3D
   do i = 1, np_e_3D
       is = neg_g(i)
   do j = 1,np_fs_3D
       js = nis_fs_3D(myrank_g_3D) + j-1
       fsr_l_3D(i,j,k) = t_wk2(is,js,k)
   enddo; enddo; enddo


   deallocate( t_wk1, t_wk2)

   call tstatc0_end(id_sname)

  end subroutine decomp_fsr_l_3D

!===============================================================================
  subroutine decomp_fsr_l_r_3D(fsr_l,fsr_l_3D,ik,neordr,sort,isub)

  integer :: ierr,err
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

  real(kind=DP) :: fsr_l(np_e,nlmta,ista_k:iend_k)
  real(kind=DP) :: fsr_l_3D(np_e_3D,np_fs_3D,ista_k_3D:iend_k_3D) 
  integer :: NB, nbs, lb, local_block, jj
  integer :: i, j, k, l, m, n, ik, is, js, nn, ifrom, isub, ito
  real(kind=DP), allocatable, dimension(:,:,:) :: t_wk1, t_wk2, t_wk3, t_wk4
  integer :: neordr(neg,ista_k:iend_k)
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num
  character(len=2) :: c_img
  character(len=80) :: fname

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)


   allocate( t_wk1(neg,nlmta,ista_k:iend_k) )
   allocate( t_wk2(neg,nlmta,ista_k:iend_k) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do k = ista_k_3D, iend_k_3D
   do j = 1,np_fs_3D
   do i=1,np_e_3D
        if ((sort == "sort") .and. (k == ik))then
             ito = neordr(neg_g(i),ik)
        else
             ito = neg_g(i)
        endif
           js = nis_fs_3D(myrank_g_3D) + j-1
        t_wk2(ito,js,k) = fsr_l_3D(i,j,k)
   enddo; enddo; enddo

   nn = neg*nlmta*(iend_k-ista_k+1)
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   do k = ista_k, iend_k
   do i = 1,np_e
   do j = 1,nlmta
     is = nis_e(myrank_e) + i-1
     fsr_l(i,j,k) = t_wk1(is,j,k)
   enddo; enddo; enddo

   deallocate( t_wk1, t_wk2)

   call tstatc0_end(id_sname)

  end subroutine decomp_fsr_l_r_3D

!===============================================================================
 subroutine decomp_fsr_l_2D(inn,out,ik)
  integer :: ierr,err
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI
  real(kind=DP), dimension(:,:,:) ,intent(in) :: inn
  real(kind=DP), dimension(:,:)   ,intent(out):: out
  integer(kind=4)                 ,intent(in) :: ik
  real(kind=DP), allocatable,dimension(:,:) :: send,recv
  integer(kind=4) :: i,j

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(neg,nlmta),stat=ierr)
   allocate(recv(neg,nlmta),stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send = 0.0d0
   recv = 0.0d0

   do j = ista_e, iend_e
      do i = 1,nlmta
         send(j,i) = inn(j-ista_e+1,i,ik)
      enddo
!!    send(j,1:nlmta) = inn(j-ista_e+1,1:nlmta,ik)
   enddo

   call mpi_allreduce(send,recv,neg*nlmta,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)

!  icount = 0
!  do j = 1, neg
!     if(map_e_3D(j) .eq. myrank_e_3D) then
!        icount = icount + 1
!        out(icount,1:nlmta) = recv(j,1:nlmta)
!     endif
!  enddo
   do j = 1,np_e_3d
      do i = 1,nlmta
         out(j,i) = recv(neg_g(j),i)
      enddo
!!    out(j,1:nlmta) = recv(neg_g(j),1:nlmta)
   enddo

   deallocate(send)
   deallocate(recv)

   call tstatc0_end(id_sname)

 end subroutine decomp_fsr_l_2D

!===============================================================================
 subroutine decomp_fsr_l_r_2D(inn,out,ik)
  integer :: ierr,err
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI
  real(kind=DP), dimension(:,:)   ,intent(in) :: inn
  real(kind=DP), dimension(:,:,:) ,intent(out):: out
  integer(kind=4)                 ,intent(in) :: ik
  real(kind=DP), allocatable,dimension(:,:) :: send,recv
  integer(kind=4) :: i,j

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(neg,nlmta),stat=ierr)
   allocate(recv(neg,nlmta),stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send = 0.0d0
   recv = 0.0d0

   do i = 1,nlmta
      do j = 1, np_e_3D
         send(neg_g(j),i) = inn(j,i)
      enddo
   enddo

   call mpi_allreduce(send,recv,neg*nlmta,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)

   do i = 1,nlmta
      do j = ista_e,iend_e
         out(j-ista_e+1,i,ik) = recv(j,i)
      enddo
   enddo

   deallocate(send)
   deallocate(recv)

   call tstatc0_end(id_sname)

 end subroutine decomp_fsr_l_r_2D

!===============================================================================
  subroutine decomp_eko_l_3D(inn,out,ik)
  integer :: ierr,err
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI
  real(kind=DP), dimension(:,:) ,intent(in) :: inn
  real(kind=DP), dimension(:)   ,intent(out):: out
  integer(kind=4)               ,intent(in) :: ik
  real(kind=DP), allocatable,dimension(:)   :: send,recv
  integer(kind=4) :: i

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(neg),stat=ierr)
   allocate(recv(neg),stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send = 0.0d0
   recv = 0.0d0

   do i = ista_e, iend_e
      send(i) = inn(i-ista_e+1,ik)
   enddo

   call mpi_allreduce(send,recv,neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)

   do i = 1,np_e_3D
      out(i) = recv(neg_g(i))
   enddo

   deallocate(send)
   deallocate(recv)

   call tstatc0_end(id_sname)
  endsubroutine decomp_eko_l_3D

!===============================================================================
  subroutine decomp_eko_l_3D_2(inn,out,ik,nrvf_ordr,sort)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(:,:) ,intent(in) :: inn
  real(kind=DP), dimension(:,:) ,intent(out):: out
  integer(kind=4)               ,intent(in) :: ik
  integer(kind=4),dimension(neg,ista_k_3D:iend_k_3D),intent(in) :: nrvf_ordr
  character(len=4) ,intent(in) :: sort
  real(kind=DP), allocatable,dimension(:) :: send, recv
  integer(kind=4) :: i, iadd, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(neg),stat=ierr)
   allocate(recv(neg),stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send = 0.0d0
   recv = 0.0d0

   do i = ista_e, iend_e
      if ((sort == "sort"))then
         iadd = nrvf_ordr(i,ik)
      else
         iadd = i
      endif
      send(iadd) = inn(i-ista_e+1,ik)
   enddo

   call mpi_allreduce(send,recv,neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)

   do i = 1,np_e_3D
      out(i,ik) = recv(neg_g(i))
   enddo

   deallocate(send)
   deallocate(recv)

   call tstatc0_end(id_sname)

  endsubroutine decomp_eko_l_3D_2

!===============================================================================
  subroutine decomp_eko_l_r_3D(eko_l,eko_3D,ik)
  implicit none
  include 'mpif.h'
  real(kind=DP), intent(out), dimension(np_e,   ista_k:iend_k) :: eko_l
  real(kind=DP), intent(in),  dimension(np_e_3D)               :: eko_3D
  real(kind=DP),              dimension(neg)                   :: wk1
  integer, intent(in) :: ik
  integer :: i, ncnt, ierr

  call tstatc0_begin('z_interface_3D__________________',id_sname,1)

  ncnt = neg
  wk1 = 0.0d0

  do i = 1, np_e_3D
     wk1(neg_g(i)) = eko_3D(i)
  enddo

  call mpi_allreduce(MPI_IN_PLACE,wk1,ncnt,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)

  do i = 1, np_e
     eko_l(i,ik) = wk1(i+ista_e-1)
  enddo

   call tstatc0_end(id_sname)
  endsubroutine decomp_eko_l_r_3D

!===============================================================================
  subroutine decomp_eko_l_r_3D_2(out,inn,ik,ordr,sort)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(:,:) ,intent(in) :: inn
  real(kind=DP), dimension(:,:) ,intent(out):: out
  integer(kind=4)               ,intent(in) :: ik
  integer(kind=4),dimension(neg,ista_k_3D:iend_k_3D),intent(in) :: ordr
  character(len=4), intent(in) :: sort
  real(kind=DP), allocatable,dimension(:) :: send, recv
  integer(kind=4) :: i, iadd, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(neg),stat=ierr)
   allocate(recv(neg),stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send = 0.0d0
   recv = 0.0d0
   if (myrank_g_3D == 0) then
      do i = 1, np_e_3D
         if (sort == "sort") then
            iadd = ordr(neg_g(i),ik)
         else
            iadd = neg_g(i)
         endif
         send(iadd) = inn(i,ik)
      enddo
   endif

   call mpi_allreduce(send,recv,neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)

   iadd = 0
   do i = ista_e, iend_e
      iadd = iadd + 1
      out(iadd,ik) = recv(i)
   enddo

   deallocate(send)
   deallocate(recv)

   call tstatc0_end(id_sname)

  endsubroutine decomp_eko_l_r_3D_2

!===============================================================================
  subroutine decomp_vnlph_l_3D(inn,out,ik,kimg,nrvf_ordr)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(:,:,:) ,intent(in)  :: inn
  real(kind=DP), dimension(:,:,:) ,intent(out) :: out
  integer(kind=4)                 ,intent(in) :: ik,kimg
  integer(kind=4),dimension(neg,ista_k_3D:iend_k_3D),intent(in) :: nrvf_ordr
  real(kind=DP), allocatable,dimension(:,:) :: send,recv
  integer(kind=4) :: i,j,index1,index2,ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(iba(ik),neg),stat=ierr)
   allocate(recv(iba(ik),neg),stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send = 0.0d0
   recv = 0.0d0

   do j = ista_e, iend_e
      do i = 1, iba(ik)
         send(i,nrvf_ordr(j,ik)) = inn(i,j-ista_e+1,kimg)
      enddo
   enddo

   call mpi_allreduce(send,recv,iba(ik)*neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)

   do j = 1, np_e_3D
      index1= neg_g(j)      !   local -> global
      index2 = 0
      do i = ista_g1k_3D(ik),iend_g1k_3D(ik)
         index2 = index2 + 1
         out(index2,j,kimg) = recv(i,index1)
      enddo
   enddo

   deallocate(send)
   deallocate(recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_vnlph_l_3D

!===============================================================================
  subroutine decomp_vnlph_l_r_3D(inn,out,ik,kimg)
  integer :: ierr,err
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI
  real(kind=DP), dimension(:,:,:) ,intent(in) :: inn
  real(kind=DP), dimension(:,:,:) ,intent(out):: out
  integer(kind=4)                 ,intent(in) :: ik,kimg
  real(kind=DP), allocatable,dimension(:,:) :: send,recv
  integer(kind=4) :: i,j,index1,index2
  logical :: existance
  character(len=3) :: c_num
  character(len=2) :: c_img
  character(len=80) :: fname

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(iba(ik),neg),stat=ierr)
   allocate(recv(iba(ik),neg),stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send = 0.0d0
   recv = 0.0d0

   do j = 1, np_e_3D
      index1= neg_g(j)      !   local -> global
      index2 = 0
      do i = ista_g1k_3D(ik),iend_g1k_3D(ik)
         index2 = index2 + 1
         send(i,index1) = inn(index2,j,kimg)
      enddo
   enddo

   call mpi_allreduce(send,recv,iba(ik)*neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)

   index1 = 0
   do j = ista_e, iend_e
      index1 = index1 + 1
      do i = 1, iba(ik)
         out(i,index1,kimg) = recv(i,j)
      enddo
   enddo

   deallocate(send)
   deallocate(recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_vnlph_l_r_3D

!===============================================================================
  subroutine decomp_vnlph_l_r_3D_2(inn,out,ik,kimg,nrvf_ordr,sort)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(:,:,:) ,intent(in) :: inn
  real(kind=DP), dimension(:,:,:) ,intent(out):: out
  integer(kind=4)                 ,intent(in) :: ik,kimg
  character(len=4)                ,intent(in) :: sort
  integer(kind=4),dimension(neg,ista_k_3D:iend_k_3D),intent(in) :: nrvf_ordr
  real(kind=DP), allocatable,dimension(:,:) :: send,recv
  integer(kind=4) :: i,j,index1,index2,ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(iba(ik),neg),stat=ierr)
   allocate(recv(iba(ik),neg),stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send = 0.0d0
   recv = 0.0d0

   do j = 1, np_e_3D
!     index1= neg_g(j)      !   local -> global
      if (sort == "sort") then
         index1 = nrvf_ordr(neg_g(j),ik)
      else
         index1 = neg_g(j)
      endif
      index2 = 0
      do i = ista_g1k_3D(ik),iend_g1k_3D(ik)
         index2 = index2 + 1
         send(i,index1) = inn(index2,j,kimg)
      enddo
   enddo

   call mpi_allreduce(send,recv,iba(ik)*neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)

   index1 = 0
   do j = ista_e, iend_e
      index1 = index1 + 1
      do i = 1, iba(ik)
         out(i,index1,kimg) = recv(i,j)
      enddo
   enddo

   deallocate(send)
   deallocate(recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_vnlph_l_r_3D_2

!===============================================================================
  subroutine decomp_snl_l_3D(inn,out,ik,nlmtt,iksnl)
  real(kind=DP), dimension(:,:,:) ,intent(in) :: inn
  real(kind=DP), dimension(:,:,:) ,intent(out):: out
  integer(kind=4)               ,intent(in) :: ik, nlmtt, iksnl
  integer(kind=4) :: i,j,index1

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   B_NLMTT : do i = 1,nlmtt
      index1 = 0
      B_BAND : do j = ista_g1k_3D(ik), iend_g1k_3D(ik)
        index1 = index1 + 1
!xx     out(index1,i,ik) = inn(j,i,ik)
        out(index1,i,iksnl) = inn(j,i,iksnl)
      enddo B_BAND
   enddo B_NLMTT

   call tstatc0_end(id_sname)

  end subroutine decomp_snl_l_3D

!===============================================================================
  subroutine decomp_snl_l_3D_2(inn,out,ik)
  real(kind=DP), dimension(kg1,nlmtt,ista_snl:iend_snl) ,intent(in) :: inn
  real(kind=DP), dimension(maxval(np_g1k_3D),nlmtt,ista_snl:iend_snl) ,intent(out):: out

  integer(kind=4) :: ik, iksnl
  integer(kind=4) :: i,j,index1

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

  out = 0.0d0
   K       : do iksnl = ista_snl,iend_snl
   B_NLMTT : do i = 1,nlmtt
      index1 = 0
      B_BAND : do j = ista_g1k_3D(iksnl), iend_g1k_3D(iksnl)
        index1 = index1 + 1
        out(index1,i,iksnl) = inn(j,i,iksnl)
      enddo B_BAND
   enddo B_NLMTT
   enddo K

   call tstatc0_end(id_sname)

  end subroutine decomp_snl_l_3D_2

!===============================================================================
  subroutine decomp_snl_l_r_3D(inn,out)
  real(kind=DP), dimension(:,:,:) ,intent(in) :: inn
  real(kind=DP), dimension(:,:,:) ,intent(out):: out
  real(kind=DP), allocatable,dimension(:,:,:) :: send,recv
  integer(kind=4) :: i,j,k,nn,ierr,err
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(kg1,nlmtt,ista_snl:iend_snl),stat=ierr)
   allocate(recv(kg1,nlmtt,ista_snl:iend_snl),stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send = 0.0d0
   recv = 0.0d0

   do k = ista_snl,iend_snl
    do j = 1,nlmtt
      do i = 1, np_g1k_3D(k)
        send(ista_g1k_3D(k)+i-1,j,k) = inn(i,j,k)
      enddo
    enddo
   enddo


   nn = kg1*nlmtt*(iend_snl-ista_snl+1)
   call mpi_allreduce(send,recv,nn,mpi_real8,mpi_sum, mpi_ke_world,err)

   do k = ista_snl,iend_snl
    do j = 1,nlmtt
      do i = 1, kg1
        out(i,j,k) = recv(i,j,k)
      enddo
    enddo
   enddo

   deallocate(send)
   deallocate(recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_snl_l_r_3D

!===============================================================================
  subroutine decomp_fsr_l_3D_ik(fsr_l,fsr_l_3D,ik,nrvf_ordr,sort)

  integer :: ierr,err
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

  real(kind=DP) :: fsr_l(np_e,nlmta,ista_k:iend_k)
  real(kind=DP) :: fsr_l_3D(np_e_3D,np_fs_3D,ista_k_3D:iend_k_3D) 
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, ik, is, js, nn, ito
  real(kind=DP), allocatable, dimension(:,:) :: t_wk1, t_wk2
  integer :: nrvf_ordr(neg,ista_k:iend_k)
  character(len=4) :: sort

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate( t_wk1(neg,nlmta) )
   allocate( t_wk2(neg,nlmta) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0
!  fsr_l_3D = 0.0d0

   do j = 1,nlmta
   do i = 1,np_e
   if ((sort == "sort"))then
     ito = nrvf_ordr(nis_e(myrank_e) + i-1,ik)
     t_wk1(ito,j) = fsr_l(i,j,ik)
   else
     is = nis_e(myrank_e) + i-1
     t_wk1(is,j) = fsr_l(i,j,ik)
   endif
   enddo; enddo

   nn = neg*nlmta
   call mpi_allreduce(t_wk1,t_wk2,nn,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   do i = 1, np_e_3D
       is = neg_g(i)
   do j = 1,np_fs_3D
       js = nis_fs_3D(myrank_g_3D) + j-1
       fsr_l_3D(i,j,ik) = t_wk2(is,js)
   enddo; enddo


   deallocate( t_wk1, t_wk2)

   call tstatc0_end(id_sname)

  end subroutine decomp_fsr_l_3D_ik

!===============================================================================
  subroutine decomp_fsr_l_r_3D_ik(fsr_l,fsr_l_3D,ik,neordr,sort,isub)

  integer :: ierr,err
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

  real(kind=DP) :: fsr_l(np_e,nlmta,ista_k:iend_k)
  real(kind=DP) :: fsr_l_3D(np_e_3D,np_fs_3D,ista_k_3D:iend_k_3D)
  integer :: NB, nbs, lb, local_block, jj
  integer :: i, j, ik, is, js, nn, isub, ito
  real(kind=DP), allocatable, dimension(:,:) :: t_wk1, t_wk2
  integer :: neordr(neg,ista_k:iend_k)
  character(len=4) :: sort

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate( t_wk1(neg,nlmta) )
   allocate( t_wk2(neg,nlmta) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do j = 1,np_fs_3D
   do i=1,np_e_3D
        if ((sort == "sort"))then
             ito = neordr(neg_g(i),ik)
        else
             ito = neg_g(i)
        endif
        js = nis_fs_3D(myrank_g_3D) + j-1
        t_wk2(ito,js) = fsr_l_3D(i,j,ik)
   enddo; enddo

   nn = neg*nlmta
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   do i = 1,np_e
   do j = 1,nlmta
     is = nis_e(myrank_e) + i-1
     fsr_l(i,j,ik) = t_wk1(is,j)
   enddo; enddo

   deallocate( t_wk1, t_wk2)

   call tstatc0_end(id_sname)

  end subroutine decomp_fsr_l_r_3D_ik

!===============================================================================
  subroutine replacement_zaj_ball_sequence(zaj_ball,ik,neordr,nblocksize_mgs_default)

   use m_Control_Parameters,  only : nblocksize_mgs, nblocksize_mgs_is_given

   real(kind=8),intent(inout),dimension(maxval(np_g1k_3D),neg,ista_k_3D:iend_k_3D,kimg)::zaj_ball
   integer(kind=4),intent(in)::ik, nblocksize_mgs_default
   integer(kind=4),intent(in),dimension(neg,ista_k_3D:iend_k_3D)::neordr

   real(kind=8),dimension(np_g1k_3D(ik),neg,kimg) :: work
   integer(kind=4) :: NB, nbs_num, nbsn_num, ival, icnt, i, j, k
!! integer(kind=4),dimension(neg) :: neg_g_all

    if(nblocksize_mgs_is_given) then
      NB = nblocksize_mgs
    else
      NB = nblocksize_mgs_default
    end if

    nbs_num = (neg-1) / NB + 1
    nbsn_num = (nbs_num - 1) / nrank_e_3D + 1

!!  icnt = 0
!!  do i = 1, nrank_e_3D
!!    do j = 1, nbsn_num
!!      do k = 1, NB
!!        ival = nbsn_num*NB*(j-1) + NB*(i-1) + k
!!        ival = nrank_e_3D*NB*(j-1) + NB*(i-1) + k
!!        if (ival > neg)  cycle
!!        icnt = icnt + 1
!!        if (icnt > neg)  exit
!!        neg_g_all(icnt) = ival
!!      enddo
!!    enddo
!!  enddo
!!
!!  order of eigenvalue block cyclic  ->  order of eigenvalue
!!
    do k = 1, kimg
      do j = 1, neg
        do i = 1, np_g1k_3D(ik)
          work(i,neg_g_all(j),k) = zaj_ball(i,j,ik,k)
        enddo
      enddo
    enddo
!!
!!  order of eigenvalue  ->  order of sequence
!!
    do k = 1, kimg
      do j = 1, neg
        do i = 1, np_g1k_3D(ik)
          zaj_ball(i,neordr(j,ik),ik,k) = work(i,j,k)
        enddo
      enddo
    enddo

  end subroutine replacement_zaj_ball_sequence


!===============================================================================
  subroutine replacement_zaj_ball_eigenvalue(zaj_ball,ik,nrvf_ordr)

   real(kind=8),intent(inout),dimension(maxval(np_g1k_3D),neg,ista_k_3D:iend_k_3D,kimg)::zaj_ball
   integer(kind=4),intent(in)::ik
   integer(kind=4),intent(in),dimension(neg,ista_k_3D:iend_k_3D)::nrvf_ordr

   real(kind=8),dimension(np_g1k_3D(ik),neg,kimg) :: work
   integer(kind=4) :: i, j, k

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

!!
!!  order of sequence  ->  order of eigenvalue
!!
    do k = 1, kimg
      do j = 1, neg
        do i = 1, np_g1k_3D(ik)
          work(i,nrvf_ordr(j,ik),k) = zaj_ball(i,j,ik,k)
        enddo
      enddo
    enddo
!!
!!  order of eigenvalue  ->  order of eigenvalue block cyclic
!!
    do k = 1, kimg
      do j = 1, neg
        do i = 1, np_g1k_3D(ik)
!         zaj_ball(i,j,ik,k) = work(i,neg_gg_all(j),k)
          zaj_ball(i,j,ik,k) = work(i,neg_g_all(j),k)
        enddo
      enddo
    enddo

   call tstatc0_end(id_sname)

  end subroutine replacement_zaj_ball_eigenvalue

!===============================================================================
  subroutine decomp_occup_l_3D(inn,out,ik,nrvf_ordr,sort)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(:,:) ,intent(in) :: inn
  real(kind=DP), dimension(:,:) ,intent(out):: out
  integer(kind=4)               ,intent(in) :: ik
  integer(kind=4),dimension(neg,ista_k_3D:iend_k_3D),intent(in) :: nrvf_ordr
  character(len=4) ,intent(in) :: sort
  real(kind=DP), allocatable,dimension(:) :: send, recv
  integer(kind=4) :: i, iadd, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(neg),stat=ierr)
   allocate(recv(neg),stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send = 0.0d0
   recv = 0.0d0

   do i = ista_e, iend_e
      if ((sort == "sort"))then
         iadd = nrvf_ordr(i,ik)
      else
         iadd = i
      endif
      send(iadd) = inn(i-ista_e+1,ik)
   enddo

   call mpi_allreduce(send,recv,neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)

   do i = 1,np_e_3D
      out(i,ik) = recv(neg_g(i))
   enddo

   deallocate(send)
   deallocate(recv)

   call tstatc0_end(id_sname)

  endsubroutine decomp_occup_l_3D

!===============================================================================
  subroutine decomp_occup_l_r_3D(out,inn,ik,ordr,sort)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(:,:) ,intent(in) :: inn
  real(kind=DP), dimension(:,:) ,intent(out):: out
  integer(kind=4)               ,intent(in) :: ik
  integer(kind=4),dimension(neg,ista_k_3D:iend_k_3D),intent(in) :: ordr
  character(len=4), intent(in) :: sort
  real(kind=DP), allocatable,dimension(:) :: send, recv
  integer(kind=4) :: i, iadd, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(neg),stat=ierr)
   allocate(recv(neg),stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send = 0.0d0
   recv = 0.0d0
   if (myrank_g_3D == 0) then
      do i = 1, np_e_3D
         if (sort == "sort") then
            iadd = ordr(neg_g(i),ik)
         else
            iadd = neg_g(i)
         endif
         send(iadd) = inn(i,ik)
      enddo
   endif

   call mpi_allreduce(send,recv,neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)

   iadd = 0
   do i = ista_e, iend_e
      iadd = iadd + 1
      out(iadd,ik) = recv(i)
   enddo

   deallocate(send)
   deallocate(recv)

   call tstatc0_end(id_sname)

  endsubroutine decomp_occup_l_r_3D

!===============================================================================
  subroutine decomp_vlhxc_l_3D(vlhxc_l,vlhxc_l_3D,ispin)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(ista_kngp:iend_kngp,kimg,nspin) ,intent(in) :: vlhxc_l
  real(kind=DP), dimension(ista_kngp_3D:iend_kngp_3D,kimg,nspin) ,intent(out):: vlhxc_l_3D
  integer(kind=4)               ,intent(in) :: ispin
  real(kind=DP), allocatable,dimension(:,:) :: send, recv
  integer(kind=4) :: i, ri, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp,kimg), stat=ierr)
   allocate(recv(1:kgp,kimg), stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:,:) = 0.0d0
   do ri = 1, kimg
      do i = ista_kngp, iend_kngp
         if (i > kgp) exit
         send(i,ri) = vlhxc_l(i,ri,ispin)
      end do
   end do

   call mpi_allreduce(send,recv,kgp*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)
   
   do ri = 1, kimg
      do i = ista_kngp_3D, iend_kngp_3D
         if (i > kgp) exit
         vlhxc_l_3D(i,ri,ispin) = recv(i,ri)
      end do
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_vlhxc_l_3D

!===============================================================================
  subroutine decomp_vlhxc_l_r_3D(vlhxc_l,vlhxc_l_3D,ispin)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(ista_kngp:iend_kngp,kimg,nspin) ,intent(out) :: vlhxc_l
  real(kind=DP), dimension(ista_kngp_3D:iend_kngp_3D,kimg,nspin) ,intent(in):: vlhxc_l_3D
  integer(kind=4)               ,intent(in) :: ispin
  real(kind=DP), allocatable,dimension(:,:) :: send, recv
  integer(kind=4) :: i, j, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp,kimg))
   allocate(recv(1:kgp,kimg))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:,:) = 0.0d0
!  if (myrank_e_3D == 0) then
      do j = 1, kimg
         do i = ista_kngp_3D, iend_kngp_3D
            if (i > kgp) exit
            send(i,j) = vlhxc_l_3D(i,j,ispin)
         end do
      end do
!  endif

!  call mpi_allreduce(send,recv,kgp*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)
   call mpi_allreduce(send,recv,kgp*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
   
   vlhxc_l(:,:,ispin) = 0.0d0

   do j = 1, kimg
      do i = ista_kngp, iend_kngp
         if (i > kgp) exit
         vlhxc_l(i,j,ispin) = recv(i,j)
      end do
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_vlhxc_l_r_3D

!===============================================================================
  subroutine decomp_ylm_l_3D(ylm_l,ylm_l_3D,nel_Ylm)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(ista_kngp:iend_kngp,nel_Ylm) ,intent(in) :: ylm_l
  real(kind=DP), dimension(ista_kngp_3D:iend_kngp_3D,nel_Ylm) ,intent(out):: ylm_l_3D
  integer(kind=4)               ,intent(in) :: nel_Ylm
  real(kind=DP), allocatable,dimension(:,:) :: send, recv
  integer(kind=4) :: i, j, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp,nel_Ylm), stat=ierr)
   allocate(recv(1:kgp,nel_Ylm), stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:,:) = 0.0d0
   do j = 1, nel_Ylm
      do i = ista_kngp, iend_kngp
         if (i > kgp) exit
         send(i,j) = ylm_l(i,j)
      end do
   end do

   call mpi_allreduce(send,recv,kgp*nel_Ylm,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)
   
   do j = 1, nel_Ylm
      do i = ista_kngp_3D, iend_kngp_3D
         if (i > kgp) exit
         ylm_l_3D(i,j) = recv(i,j)
      end do
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_ylm_l_3D

!===============================================================================
  subroutine decomp_qitg_l_3D(qitg_l,qitg_l_3D,nqitg)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(ista_kngp:iend_kngp,nqitg) ,intent(in) :: qitg_l
  real(kind=DP), dimension(ista_kngp_3D:iend_kngp_3D,nqitg) ,intent(out):: qitg_l_3D
  integer(kind=4)               ,intent(in) :: nqitg
  real(kind=DP), allocatable,dimension(:,:) :: send, recv
  integer(kind=4) :: i, j, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   if (nqitg == 0) return

   allocate(send(1:kgp,nqitg))
   allocate(recv(1:kgp,nqitg))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:,:) = 0.0d0
   do j = 1, nqitg
      do i = ista_kngp, iend_kngp
         if (i > kgp) exit
         send(i,j) = qitg_l(i,j)
      end do
   end do

   call mpi_allreduce(send,recv,kgp*nqitg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)
   
   do j = 1, nqitg
      do i = ista_kngp_3D, iend_kngp_3D
         if (i > kgp) exit
         qitg_l_3D(i,j) = recv(i,j)
      end do
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_qitg_l_3D

!===============================================================================
  subroutine decomp_qitg_l_r_3D(qitg_l,qitg_l_3D,nqitg)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(ista_kngp:iend_kngp,nqitg)       ,intent(out) :: qitg_l
  real(kind=DP), dimension(ista_kngp_3D:iend_kngp_3D,nqitg) ,intent(in)  :: qitg_l_3D
  integer(kind=4)               ,intent(in) :: nqitg
  real(kind=DP), allocatable,dimension(:,:) :: send, recv
  integer(kind=4) :: i, j, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp,nqitg))
   allocate(recv(1:kgp,nqitg))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:,:) = 0.0d0
   do j = 1, nqitg
      do i = ista_kngp_3D, iend_kngp_3D
         if (i > kgp) exit
         send(i,j) = qitg_l_3D(i,j)
      end do
   end do

   call mpi_allreduce(send,recv,kgp*nqitg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)

   qitg_l(:,:) = 0.0d0

   do j = 1, nqitg
      do i = ista_kngp, iend_kngp
         if (i > kgp) exit
         qitg_l(i,j) = recv(i,j)
      end do
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_qitg_l_r_3D

!===============================================================================
  subroutine decomp_zfm3_l_3D(zfm3_l,zfm3_l_3D)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(ista_kngp:iend_kngp,ntyp,kimg) ,intent(in) :: zfm3_l
  real(kind=DP), dimension(ista_kngp_3D:iend_kngp_3D,ntyp,kimg) ,intent(out):: zfm3_l_3D
  real(kind=DP), allocatable,dimension(:,:,:) :: send, recv
  integer(kind=4) :: i, j, ri, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp,ntyp,kimg))
   allocate(recv(1:kgp,ntyp,kimg))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:,:,:) = 0.0d0
   do ri = 1, kimg
      do j = 1, ntyp
         do i = ista_kngp, iend_kngp
            if (i > kgp) exit
            send(i,j,ri) = zfm3_l(i,j,ri)
         end do
      end do
   end do

   call mpi_allreduce(send,recv,kgp*ntyp*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)
   
   do ri = 1, kimg
      do j = 1, ntyp
         do i = ista_kngp_3D, iend_kngp_3D
            if (i > kgp) exit
            zfm3_l_3D(i,j,ri) = recv(i,j,ri)
         end do
      end do
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_zfm3_l_3D

!===============================================================================
  subroutine decomp_zfm3_l_r_3D(zfm3_l,zfm3_l_3D)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(ista_kngp:iend_kngp,ntyp,kimg) ,intent(out) :: zfm3_l
  real(kind=DP), dimension(ista_kngp_3D:iend_kngp_3D,ntyp,kimg) ,intent(in):: zfm3_l_3D
  real(kind=DP), allocatable,dimension(:,:,:) :: send, recv
  integer(kind=4) :: i, j, ri, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp,ntyp,kimg))
   allocate(recv(1:kgp,ntyp,kimg))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:,:,:) = 0.0d0
   do ri = 1, kimg
      do j = 1, ntyp
         do i = ista_kngp_3D, iend_kngp_3D
            if (i > kgp) exit
            send(i,j,ri) = zfm3_l_3D(i,j,ri)
         end do
      end do
   end do

   call mpi_allreduce(send,recv,kgp*ntyp*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
   
   zfm3_l(:,:,:) = 0.0d0

   do ri = 1, kimg
      do j = 1, ntyp
         do i = ista_kngp, iend_kngp
            if (i > kgp) exit
            zfm3_l(i,j,ri) = recv(i,j,ri)
         end do
      end do
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_zfm3_l_r_3D

!===============================================================================
  subroutine decomp_psc_l_3D(psc_l,psc_l_3D)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(ista_kngp:iend_kngp,ntyp) ,intent(in) :: psc_l
  real(kind=DP), dimension(ista_kngp_3D:iend_kngp_3D,ntyp) ,intent(out):: psc_l_3D
  real(kind=DP), allocatable,dimension(:,:) :: send, recv
  integer(kind=4) :: i, j, ri, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp,ntyp))
   allocate(recv(1:kgp,ntyp))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:,:) = 0.0d0
   do j = 1, ntyp
      do i = ista_kngp, iend_kngp
         if (i > kgp) exit
         send(i,j) = psc_l(i,j)
      end do
   end do

   call mpi_allreduce(send,recv,kgp*ntyp,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)
   
   do j = 1, ntyp
      do i = ista_kngp_3D, iend_kngp_3D
         if (i > kgp) exit
         psc_l_3D(i,j) = recv(i,j)
      end do
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_psc_l_3D

!===============================================================================
  subroutine decomp_psc_l_r_3D(psc_l,psc_l_3D)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(ista_kngp:iend_kngp,ntyp) ,intent(out) :: psc_l
  real(kind=DP), dimension(ista_kngp_3D:iend_kngp_3D,ntyp) ,intent(in):: psc_l_3D
  real(kind=DP), allocatable,dimension(:,:) :: send, recv
  integer(kind=4) :: i, j, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp,ntyp))
   allocate(recv(1:kgp,ntyp))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:,:) = 0.0d0
   do j = 1, ntyp
      do i = ista_kngp_3D, iend_kngp_3D
         if (i > kgp) exit
         send(i,j) = psc_l_3D(i,j)
      end do
   end do

   call mpi_allreduce(send,recv,kgp*ntyp,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
   
   psc_l(:,:) = 0.0d0

   do j = 1, ntyp
      do i = ista_kngp, iend_kngp
         if (i > kgp) exit
         psc_l(i,j) = recv(i,j)
      end do
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_psc_l_r_3D
!===============================================================================

  subroutine decomp_vdip_l_3D(vdip_l,vdip_l_3D)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(ista_kngp:iend_kngp,kimg) ,intent(in) :: vdip_l
  real(kind=DP), dimension(ista_kngp_3D:iend_kngp_3D,kimg) ,intent(out):: vdip_l_3D
  real(kind=DP), allocatable,dimension(:,:) :: send, recv
  integer(kind=4) :: i, ri, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp,kimg))
   allocate(recv(1:kgp,kimg))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:,:) = 0.0d0
   do ri = 1, kimg
      do i = ista_kngp, iend_kngp
         if (i > kgp) exit
         send(i,ri) = vdip_l(i,ri)
      end do
   end do

   call mpi_allreduce(send,recv,kgp*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)
   
   do ri = 1, kimg
      do i = ista_kngp_3D, iend_kngp_3D
         if (i > kgp) exit
         vdip_l_3D(i,ri) = recv(i,ri)
      end do
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_vdip_l_3D

!===============================================================================
  subroutine decomp_vdip_l_r_3D(vdip_l,vdip_l_3D)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(ista_kngp:iend_kngp,kimg) ,intent(out) :: vdip_l
  real(kind=DP), dimension(ista_kngp_3D:iend_kngp_3D,kimg) ,intent(in):: vdip_l_3D
  real(kind=DP), allocatable,dimension(:,:) :: send, recv
  integer(kind=4) :: i, ri, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp,kimg))
   allocate(recv(1:kgp,kimg))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:,:) = 0.0d0
   do ri = 1, kimg
      do i = ista_kngp_3D, iend_kngp_3D
         if (i > kgp) exit
         send(i,ri) = vdip_l_3D(i,ri)
      end do
   end do

   call mpi_allreduce(send,recv,kgp*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
   
   vdip_l(:,:) = 0.0d0

   do ri = 1, kimg
      do i = ista_kngp, iend_kngp
         if (i > kgp) exit
         vdip_l(i,ri) = recv(i,ri)
      end do
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_vdip_l_r_3D

!===============================================================================
  subroutine decomp_gr_l_3D(gr_l,gr_l_3D)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(ista_kngp:iend_kngp) ,intent(in) :: gr_l
  real(kind=DP), dimension(ista_kngp_3D:iend_kngp_3D) ,intent(out):: gr_l_3D
  real(kind=DP), allocatable,dimension(:) :: send, recv
  integer(kind=4) :: i, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp))
   allocate(recv(1:kgp))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:) = 0.0d0
   do i = ista_kngp, iend_kngp
      if (i > kgp) exit
      send(i) = gr_l(i)
   end do

   call mpi_allreduce(send,recv,kgp,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)
   
   do i = ista_kngp_3D, iend_kngp_3D
      if (i > kgp) exit
      gr_l_3D(i) = recv(i)
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_gr_l_3D

!===============================================================================
  subroutine decomp_gr_l_r_3D(gr_l,gr_l_3D)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(ista_kngp:iend_kngp) ,intent(out) :: gr_l
  real(kind=DP), dimension(ista_kngp_3D:iend_kngp_3D) ,intent(in):: gr_l_3D
  real(kind=DP), allocatable,dimension(:) :: send, recv
  integer(kind=4) :: i, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp))
   allocate(recv(1:kgp))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:) = 0.0d0
   do i = ista_kngp_3D, iend_kngp_3D
      if (i > kgp) exit
      send(i) = gr_l_3D(i)
   end do

   call mpi_allreduce(send,recv,kgp,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
   
   gr_l(:) = 0.0d0

   do i = ista_kngp, iend_kngp
      if (i > kgp) exit
      gr_l(i) = recv(i)
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_gr_l_r_3D

!===============================================================================
  subroutine decomp_rr_is_over_or_under_3D(rr_is_over_or_under, rr_is_over_or_under_3D, ik, nrvf_ordr, sort)
  implicit none
  include 'mpif.h'
  integer, intent(in)  :: rr_is_over_or_under   (np_e,   ista_k:iend_k)
  integer, intent(out) :: rr_is_over_or_under_3D(np_e_3D,ista_k_3D:iend_k)
  integer              :: wk1                   (neg)
  integer, intent(in) :: ik
  integer, intent(in) :: nrvf_ordr(neg, ista_k:iend_k)
  character(len=4), intent(in) :: sort
  integer :: j, l, js, jto, ncnt
  integer :: ierr

  ncnt = neg
  wk1 = 0

  if (sort == "sort") then
     do j = 1, np_e
        js = nrvf_ordr(nis_e(myrank_e) + j - 1, ik)
        wk1(js) = rr_is_over_or_under(j,ik)
     enddo
  else
     do j = 1, np_e
        js = nis_e(myrank_e) + j - 1
        wk1(js) = rr_is_over_or_under(j,ik)
     enddo
  endif

  call mpi_allreduce(MPI_IN_PLACE,wk1,ncnt,MPI_INTEGER,MPI_SUM,mpi_comm_group,ierr)

  do j = 1, np_e_3D
     jto = neg_g(j)
     rr_is_over_or_under_3D(j,ik) = wk1(jto)
  enddo

  end subroutine decomp_rr_is_over_or_under_3D

!===============================================================================
  subroutine decomp_rr_is_over_or_under_r_3D(rr_is_over_or_under, rr_is_over_or_under_3D, ik, neordr, sort)
  implicit none
  include 'mpif.h'
  integer, intent(out) :: rr_is_over_or_under   (np_e,   ista_k:iend_k)
  integer, intent(in)  :: rr_is_over_or_under_3D(np_e_3D,ista_k_3D:iend_k)
  integer              :: wk1                   (neg)
  integer, intent(in) :: ik
  integer, intent(in) :: neordr(neg, ista_k:iend_k)
  character(len=4), intent(in) :: sort
  integer :: j, l, js, jto, ncnt
  integer :: ierr

  ncnt = neg
  wk1 = 0

  if (sort == "sort") then
     do j = 1, np_e_3D
        jto =  neordr(neg_g(j), ik)
        wk1(jto) = rr_is_over_or_under_3D(j,ik)
     enddo
  else
     do j = 1, np_e_3D
        jto = neg_g(j)
        wk1(jto) = rr_is_over_or_under_3D(j,ik)
     enddo
  endif

  call mpi_allreduce(MPI_IN_PLACE,wk1,ncnt,MPI_INTEGER,MPI_SUM,mpi_kg_world,ierr)

  do j = 1, np_e
     js = nis_e(myrank_e) + j - 1
     rr_is_over_or_under(j,ik) = wk1(js)
  enddo

  end subroutine decomp_rr_is_over_or_under_r_3D

!===============================================================================
  subroutine decomp_wfsd_l_3D(wfsd_l, wfsd_l_3D, ik)
  implicit none
  include 'mpif.h'
  real(kind=DP), intent(in)  :: wfsd_l   (kg1,              np_e,   ik:ik,kimg)
  real(kind=DP), intent(out) :: wfsd_l_3D(maxval(np_g1k_3D),np_e_3D,ik:ik,kimg)
  real(kind=DP)              :: wk1      (kg1,              neg,    ik:ik,kimg)
  integer, intent(in) :: ik

  integer :: i, j, l, is, js, jto, ncnt
  integer :: ierr

  call tstatc0_begin('z_interface_3D__________________',id_sname,1)

  ncnt = kg1*neg*kimg
  wk1 = 0.0d0

  do l = 1, kimg
     do j = 1, np_e
        js = nis_e(myrank_e) + j - 1
        do i = 1, iba(ik)
            wk1(i,js,ik,l) = wfsd_l(i,j,ik,l)
  enddo; enddo; enddo

  call mpi_allreduce(MPI_IN_PLACE,wk1,ncnt,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)

  do l = 1, kimg
     do j = 1, np_e_3D
        jto = neg_g(j)
        do i = 1, np_g1k_3D(ik)
           is = nis_g1k_3D(myrank_g_3D,ik) + i - 1
           wfsd_l_3D(i,j,ik,l) = wk1(is,jto,ik,l)
  enddo; enddo; enddo

   call tstatc0_end(id_sname)

  end subroutine decomp_wfsd_l_3D

!===============================================================================
  subroutine decomp_wfsd_l_r_3D(wfsd_l, wfsd_l_3D, ik)
  implicit none
  include 'mpif.h'
  real(kind=DP), intent(out) :: wfsd_l   (kg1,              np_e,   ik:ik,kimg)
  real(kind=DP), intent(in)  :: wfsd_l_3D(maxval(np_g1k_3D),np_e_3D,ik:ik,kimg)
  real(kind=DP)              :: wk1      (kg1,              neg,    ik:ik,kimg)
  integer, intent(in) :: ik

  integer :: i, j, l, is, js, jto, ncnt
  integer :: ierr

  call tstatc0_begin('z_interface_3D__________________',id_sname,1)

  ncnt = kg1*neg*kimg
  wk1 = 0.0d0

  do l = 1, kimg
     do j = 1, np_e_3D
        jto = neg_g(j)
        do i = 1, np_g1k_3D(ik)
           is = nis_g1k_3D(myrank_g_3D,ik) + i - 1
           wk1(is,jto,ik,l) = wfsd_l_3D(i,j,ik,l)
  enddo; enddo; enddo

  call mpi_allreduce(MPI_IN_PLACE,wk1,ncnt,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)

  do l = 1, kimg
     do j = 1, np_e
        js = nis_e(myrank_e) + j - 1
        do i = 1, iba(ik)
            wfsd_l(i,j,ik,l) = wk1(i,js,ik,l)
  enddo; enddo; enddo

   call tstatc0_end(id_sname)

  end subroutine decomp_wfsd_l_r_3D

!===============================================================================
  subroutine decomp_bsdr_l_3D(bsdr_l, bsdr_l_3D, ik)
  implicit none
  include 'mpif.h'
  real(kind=DP), intent(in)  :: bsdr_l   (np_e,   nlmta,ik:ik)
  real(kind=DP), intent(out) :: bsdr_l_3D(np_e_3D,nlmta,ik:ik)
  real(kind=DP)              :: wk1      (neg,    nlmta)
  integer, intent(in) :: ik
  integer :: j, l, js, jto, ncnt
  integer :: ierr

  call tstatc0_begin('z_interface_3D__________________',id_sname,1)

  ncnt = neg*nlmta
  wk1 = 0.0d0

  do j = 1, np_e
     js = nis_e(myrank_e) + j - 1
     wk1(js,:) = bsdr_l(j,:,ik)
  enddo

  call mpi_allreduce(MPI_IN_PLACE,wk1,ncnt,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)

  do j = 1, np_e_3D
     jto = neg_g(j)
     bsdr_l_3D(j,:,ik) = wk1(jto,:)
  enddo

   call tstatc0_end(id_sname)

  end subroutine decomp_bsdr_l_3D

!===============================================================================
  subroutine decomp_zajold_l_r_3D(zajold_l, zajold_l_3D, ik, ndavid)
  implicit none
  include 'mpif.h'
  real(kind=DP), intent(out) :: zajold_l   (kg1,              np_e,   kimg,ndavid)
  real(kind=DP), intent(in)  :: zajold_l_3D(maxval(np_g1k_3D),np_e_3D,kimg,ndavid)
  real(kind=DP)              :: wk1        (kg1,              neg,    kimg,ndavid)
  integer, intent(in) :: ik, ndavid

  integer :: i, j, l, is, js, jto, ncnt
  integer :: ierr

  call tstatc0_begin('z_interface_3D__________________',id_sname,1)

  ncnt = kg1*neg*kimg*ndavid
  wk1 = 0.0d0

  do l = 1, kimg
     do j = 1, np_e_3D
        jto = neg_g(j)
        do i = 1, np_g1k_3D(ik)
           is = nis_g1k_3D(myrank_g_3D,ik) + i - 1
           wk1(is,jto,l,:) = zajold_l_3D(i,j,l,:)
  enddo; enddo; enddo

  call mpi_allreduce(MPI_IN_PLACE,wk1,ncnt,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)

  do l = 1, kimg
     do j = 1, np_e
        js = nis_e(myrank_e) + j - 1
        do i = 1, iba(ik)
            zajold_l(i,j,l,:) = wk1(i,js,l,:)
  enddo; enddo; enddo

   call tstatc0_end(id_sname)

  end subroutine decomp_zajold_l_r_3D

!===============================================================================
 subroutine decomp_ngpt_l_r_3D(ngpt_l,ngpt_l_3D,n)
  include 'mpif.h'                                      ! MPI
  integer(kind=4), dimension(ista_kngp:iend_kngp,n) ,intent(out) :: ngpt_l
  integer(kind=4), dimension(ista_kngp_3D:iend_kngp_3D,n) ,intent(in):: ngpt_l_3D
  integer(kind=4), allocatable,dimension(:,:) :: send, recv
  integer(kind=4) :: i, j, ierr,n

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp,n))
   allocate(recv(1:kgp,n))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:,:) = 0.0d0
   do j = 1, n
      do i = ista_kngp_3D, iend_kngp_3D
         if (i > kgp) exit
         send(i,j) = ngpt_l_3D(i,j)
      end do
   end do

   call mpi_allreduce(send,recv,kgp*n,MPI_integer,MPI_SUM,mpi_ke_world,ierr)

   ngpt_l(:,:) = 0.0d0

   do j = 1, n
      do i = ista_kngp, iend_kngp
         if (i > kgp) exit
         ngpt_l(i,j) = recv(i,j)
      end do
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_ngpt_l_r_3D

!===============================================================================
 subroutine decomp_ngpt_l_3D(ngpt_l,ngpt_l_3D,n)
  include 'mpif.h'                                      ! MPI
  integer(kind=4), dimension(ista_kngp:iend_kngp,n) ,intent(in) :: ngpt_l
  integer(kind=4), dimension(ista_kngp_3D:iend_kngp_3D,n) ,intent(out):: ngpt_l_3D
  integer(kind=4), allocatable,dimension(:,:) :: send, recv
  integer(kind=4) :: i, j, ierr,n

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp,n))
   allocate(recv(1:kgp,n))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:,:) = 0.0d0
   do j = 1, n
      do i = ista_kngp, iend_kngp
         if (i > kgp) exit
         send(i,j) = ngpt_l(i,j)
      end do
   end do

!   call mpi_allreduce(send,recv,kgp*n,MPI_integer,MPI_SUM,mpi_ke_world,ierr)
   call mpi_allreduce(send,recv,kgp*n,MPI_integer,MPI_SUM,mpi_k_world(myrank_k),ierr)

   ngpt_l_3D(:,:) = 0.0d0

   do j = 1, n
      do i = ista_kngp_3D, iend_kngp_3D
         if (i > kgp) exit
         ngpt_l_3D(i,j) = recv(i,j)
      end do
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_ngpt_l_3D

!===============================================================================
  subroutine decomp_igfp_l_r_3D(igfp_l,igfp_l_3D)
  include 'mpif.h'                                      ! MPI
  integer(kind=4), dimension(ista_kngp:iend_kngp) ,intent(out) :: igfp_l
  integer(kind=4), dimension(ista_kngp_3D:iend_kngp_3D) ,intent(in):: igfp_l_3D
  integer(kind=4), allocatable,dimension(:) :: send, recv
  integer(kind=4) :: i, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp))
   allocate(recv(1:kgp))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:) = 0.0d0
   do i = ista_kngp_3D, iend_kngp_3D
      if (i > kgp) exit
      send(i) = igfp_l_3D(i)
   end do

   call mpi_allreduce(send,recv,kgp,MPI_integer,MPI_SUM,mpi_ke_world,ierr)

   igfp_l(:) = 0.0d0

   do i = ista_kngp, iend_kngp
      if (i > kgp) exit
      igfp_l(i) = recv(i)
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_igfp_l_r_3D

!===============================================================================
  subroutine decomp_igfp_l_3D(igfp_l,igfp_l_3D)
  include 'mpif.h'                                      ! MPI
  integer(kind=4), dimension(ista_kngp:iend_kngp) ,intent(in) :: igfp_l
  integer(kind=4), dimension(ista_kngp_3D:iend_kngp_3D) ,intent(out):: igfp_l_3D
  integer(kind=4), allocatable,dimension(:) :: send, recv
  integer(kind=4) :: i, ierr

   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(1:kgp))
   allocate(recv(1:kgp))
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send(:) = 0.0d0
   do i = ista_kngp, iend_kngp
      if (i > kgp) exit
      send(i) = igfp_l(i)
   end do

!   call mpi_allreduce(send,recv,kgp,MPI_integer,MPI_SUM,mpi_ke_world,ierr)
   call mpi_allreduce(send,recv,kgp,MPI_integer,MPI_SUM,mpi_k_world(myrank_k),ierr)

   igfp_l_3D(:) = 0.0d0

   do i = ista_kngp_3D, iend_kngp_3D
      if (i > kgp) exit
      igfp_l_3D(i) = recv(i)
   end do

   deallocate(send,recv)

   call tstatc0_end(id_sname)

  end subroutine decomp_igfp_l_3D

!===============================================================================
  subroutine decomp_eko_l_3D_new(inn,out,ik,nrvf_ordr,sort)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(:,:) ,intent(in) :: inn
  real(kind=DP), dimension(:,:) ,intent(out):: out
  integer(kind=4)               ,intent(in) :: ik
  integer(kind=4),dimension(neg,ista_k_3D:iend_k_3D),intent(in) :: nrvf_ordr
  character(len=4) ,intent(in) :: sort
  real(kind=DP), allocatable,dimension(:) :: send, recv
  integer(kind=4) :: i, iadd, ierr

   integer :: id_sname=-1
   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(neg),stat=ierr)
   allocate(recv(neg),stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send = 0.0d0
   recv = 0.0d0

   do i = ista_e, iend_e
      if ((sort == "sort"))then
         iadd = nrvf_ordr(i,ik)
      else
         iadd = i
      endif
      send(iadd) = inn(i-ista_e+1,ik)
   enddo

   call mpi_allreduce(send,recv,neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)

   do i = 1,np_e_3D
      out(i,ik) = recv(neg_g(i))
   enddo

   deallocate(send)
   deallocate(recv)

   call tstatc0_end(id_sname)

  endsubroutine decomp_eko_l_3D_new
!===============================================================================
  subroutine decomp_eko_l_r_3D_new(out,inn,ik,ordr,sort)
  include 'mpif.h'                                      ! MPI
  real(kind=DP), dimension(:,:) ,intent(in) :: inn
  real(kind=DP), dimension(:,:) ,intent(out):: out
  integer(kind=4)               ,intent(in) :: ik
  integer(kind=4),dimension(neg,ista_k_3D:iend_k_3D),intent(in) :: ordr
  character(len=4), intent(in) :: sort
  real(kind=DP), allocatable,dimension(:) :: send, recv
  integer(kind=4) :: i, iadd, ierr

   integer :: id_sname=-1
   call tstatc0_begin('z_interface_3D__________________',id_sname,1)

   allocate(send(neg),stat=ierr)
   allocate(recv(neg),stat=ierr)
   if (ierr /= 0) then
      print *,' ERROR Not allocated : ',ierr
      stop
   endif

   send = 0.0d0
   recv = 0.0d0
   if (myrank_g_3D == 0) then
      do i = 1, np_e_3D
         if (sort == "sort") then
            iadd = ordr(neg_g(i),ik)
         else
            iadd = neg_g(i)
         endif
         send(iadd) = inn(i,ik)
      enddo
   endif

   call mpi_allreduce(send,recv,neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_k_world(myrank_k),ierr)

   iadd = 0
   do i = ista_e, iend_e
      iadd = iadd + 1
      out(iadd,ik) = recv(i)
   enddo

   deallocate(send)
   deallocate(recv)

   call tstatc0_end(id_sname)

  endsubroutine decomp_eko_l_r_3D_new
!===============================================================================

#else
  subroutine dummy()
  end subroutine dummy
#endif

end module z_interface_3D

! Copyright (c) 2012, Minoru Otani <minoru.otani@aist.go.jp> 
! 
! Permission is hereby granted, free of charge, to any person 
! obtaining a copy of this software and associated documentation 
! files (the "Software"), to deal in the Software without restriction, 
! including without limitation the rights to use, copy, modify, merge, 
! publish, distribute, sublicense, and/or sell copies of the Software, 
! and to permit persons to whom the Software is furnished to do so, 
! subject to the following conditions:
 
! The above copyright notice and this permission notice shall be 
! included in all copies or substantial portions of the Software.
 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
! OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
! NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
! HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
! WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
! DEALINGS IN THE SOFTWARE.

!-----------------------------------------------------------------
!
! Making reciprocal lattice vectors from lattice vectors
!
Subroutine MakeRecLatVec( A, B )
  Implicit None
  Real(8), intent(in ) :: A(3,3)
  Real(8), intent(out) :: B(3,3)
  Real(8), Parameter :: PI2 = 2.0d0 * 3.141592653589793238d0
  Real(8), external :: InnerProd

  Call OuterProd( A(1,2), A(1,3), B(1,1) )
  Call OuterProd( A(1,3), A(1,1), B(1,2) )
  Call OuterProd( A(1,1), A(1,2), B(1,3) )
  
  B(:,1) = B(:,1) / InnerProd( A(1,1), B(1,1) )
  B(:,2) = B(:,2) / InnerProd( A(1,2), B(1,2) )
  B(:,3) = B(:,3) / InnerProd( A(1,3), B(1,3) )

  Return
End Subroutine MakeRecLatVec

!-----------------------------------------------------------------
!
! Outer product of 3D vector
!
Subroutine OuterProd( A, B, C )
  Implicit None
  Real(8), Intent(in ) :: A(3), B(3)
  Real(8), Intent(out) :: C(3)

  C(1) = A(2) * B(3) - A(3) * B(2)
  C(2) = A(3) * B(1) - A(1) * B(3)
  C(3) = A(1) * B(2) - A(2) * B(1)

  Return
End Subroutine OuterProd

!-----------------------------------------------------------------
!
! Inner product of 3D vector
!
Function InnerProd( A, B )
  Implicit None
  Real(8), Intent(in ) :: A(3), B(3)
  Real(8) :: InnerProd

  InnerProd = Sum( A(:) * B(:) )

  Return
End Function InnerProd

!#define _DEBUG_WRITE_
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 603 $)
!
!  SUBROUINE: Renewal_of_WaveFunctions, Renew_WF_by_lmSDorlmCG,
!             check_new_solver
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!                        J. Koga,  March/01/2010
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef __TIMER__
#   define __TIMER_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_START(a)       call timer_sta(a)
#   define __TIMER_STOP(a)        call timer_end(a)
#else
#   define __TIMER_START_w_BARRIER(str,a)
#   define __TIMER_START(a)
#   define __TIMER_STOP(a)
#endif
subroutine Renewal_of_WaveFunctions()
! $Id: Renewal_of_WaveFunctions.F90 603 2020-04-07 03:25:30Z jkoga $
  use m_Control_Parameters,   only : m_CtrlP_solver_for_WFs_now &
       &                           , m_CtrlP_On_or_Off_precon_WFs &
       &                           , m_CtrlP_dtim_now &
       &                           , m_CtrlP_clear_nsolver_applied &
       &                           , m_CtrlP_push_SolverNameApplied &
       &                           , m_CtrlP_set_sw_MRCV_only &
       &                           , meg,damp,icond,iprievdff &
       &                           , intzaj,ipri,ipriwf,renew_wf_again_m_CtrlP &
       &                           , sw_ekzaj,ekmode,sw_hubbard &
       &                           , submat_before_renewal, sw_rsb &
       &                           , sw_hybrid_functional
  use m_Const_Parameters,     only : DP,SD,MSD,CG &
       &                           , lmSD, lmMSD, lmCG, lmeazyCG & ! , eazyCG
       &                           , RMM,RMM2,RMM2P,SUBMAT,MATRIXDIAGON &
       &                           , DAVIDSON, MDDAVIDSON, MDKOSUGI &
       &                           , YES, ON, OFF, NO &
       &                           , INITIAL, CONTINUATION, FIXED_CHARGE &
       &                           , FIXED_CHARGE_CONTINUATION &
       &                           , COORDINATE_CONTINUATION,INVERSE,DIRECT
  use m_IterationNumbers,     only : iteration, iteration_electronic, iteration_ionic &
       &                           , m_Iter_set_rmm_start, nk_in_the_process
  use m_Files,                only : nfout
  use m_Ionic_System,         only : natm2
  use m_ES_WF_by_SDorCG,      only : m_ESsd_alloc_wfsd, m_ESsd_dealloc_wfsd 
  use m_ES_WF_by_RMM,         only : m_ESrmm_reset_ng_maxmin &
       &                           , m_ESrmm_reset_r_norm_flag
  use m_Electronic_Structure, only : m_ES_what_is_evdff_now,zaj_l
  use m_ES_IO,                only : m_ESIO_wd_WFs_standardout

  use m_Total_Energy,         only : m_TE_what_is_edeltb_now 
  use m_Charge_Density,       only : m_CD_cp_chgq_to_chgqo
  use m_Orbital_Population,   only : m_OP_cp_ommix_to_omold
  use m_ES_WF_by_submat,      only : m_ESsubmat_Renew_WF, m_ESsubmat_alloc
#ifdef __TIMER__
  use m_Parallelization,      only : mpi_comm_group
#endif



  implicit none
  integer       :: what_is_the_core_solver
  integer       :: isolver, precon, previous_isolver = -100, sw_submat, isolver_core
  integer, save :: is_wfsd_allocated = NO
  real(kind=DP) :: dtim, edeltb_now
#ifdef __TIMER__
  integer :: ierr
#endif
  integer :: ik
  logical :: push_solver=.true.
  logical :: hybfunc=.false.

  !! For EXX test
  !! call m_ES_EXX_update(OFF)

  call m_CtrlP_clear_nsolver_applied()

  if(icond == INITIAL .or. icond == CONTINUATION .or. icond == COORDINATE_CONTINUATION .or. &
       & ((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION)&
       &                             .and. ekmode == OFF)   ) then
     edeltb_now = m_TE_what_is_edeltb_now()/natm2
!!$     write(nfout,'(" edeltb_per_atom = ", d20.12)') edeltb_per_atom
  else
     edeltb_now = m_ES_what_is_evdff_now()
  end if
  
  if(iprievdff >= 2) write(nfout,'(" edeltb_now = ",d20.10)') edeltb_now

  isolver = m_CtrlP_solver_for_WFs_now(iteration_electronic,iteration_ionic,intzaj &
       &                              ,edeltb_now, sw_submat)
  call check_new_solver  ! -(contained here) comparing isolver with previous_isolver
  !                        Especially, important for the RMM operation.
!!$  previous_isolver = isolver
! === Merge modifications from phase@63 -> phase@64. 2011/10/18 ================
  precon  = m_CtrlP_On_or_Off_precon_WFs(iteration_electronic,iteration_ionic,isolver)
! ==============================================================================
  dtim = m_CtrlP_dtim_now(iteration_electronic,iteration_ionic)
  if(iprievdff >= 2) write(nfout,'(" iter_elec, dtim = ",i6,f10.4)') &
       & iteration_electronic, dtim

! === Merge modifications from phase@63 -> phase@64. 2011/10/18 ================
#ifdef _DEBUG_WRITE_
  if(ipri>=1) write(nfout,'(" !isolver, precon = ",2i8)') isolver, precon
#endif
! ==============================================================================

  isolver_core = what_is_the_core_solver(isolver) ! -(in this file)
  if(isolver_core == CG .and. is_wfsd_allocated == NO) then
     call m_ESsd_alloc_wfsd()
     is_wfsd_allocated = YES
  else if(isolver_core /= CG .and. is_wfsd_allocated == YES) then
     call m_ESsd_dealloc_wfsd()
     is_wfsd_allocated = NO
  end if

  !! for calc. of Berry phase at the Gamma point only
  !! providing that well converged wavefunctions are supplied from nfzaj file
  if(sw_ekzaj == ON .and. ekmode == ON) then
     if(ipri >= 1) write(nfout,*) &
	& '** Returning from Renewal_of_WaveFunctions for Berry phase calculation with samping the Gamma point only **'
     return
  end if

!!$   select case(isolver)
!!$     case (lmSD, lmMSD, lmCG, lmeazyCG)
!!$        if(iteration_electronic >= 10) then
!!$           if(incre_etot_in_1dsrch >= incre_etot_in_1dsrch_limit) then
!!$              call ReadCheckPointData()
!!$           else if (flag_wdcheckpointdata >= 0) 
!!$           end if
!!$        end if
!!$     end select

!!!!BRANCH_P ORG_Parallel
!!!  if(sw_rsb==ON)then
!!!    call m_ES_RSB_alloc()
!!!    call m_ES_RSB_doit(verbose=.false.)
!!!  endif
!!!!BRANCH_P_END ORG_Parallel



!!$ if(submat_before_renewal==ON.and.previous_isolver/=MATRIXDIAGON)then
  if(submat_before_renewal==ON)then
     if((sw_submat == ON .and. &
          & (isolver /= DAVIDSON .and. isolver /= SUBMAT .and.  &
          &  isolver /= MATRIXDIAGON .and. isolver/=MDDAVIDSON .and. isolver /= MDKOSUGI)) &
          & .or.renew_wf_again_m_CtrlP ) then
!!$        if(ipri>=1)write(nfout,'(" !solver doing subspace rotation before WF renewal")')
        call exec_submat_before_or_after()  ! contained here
     end if
  end if


  if(hybfunc) sw_hybrid_functional=ON
  solver: select case(isolver)

     case (MATRIXDIAGON)
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,15)
        if(sw_hybrid_functional==ON.and.iteration==1) then
           hybfunc=.true.
           sw_hybrid_functional=OFF 
        endif
        if(.not.(ekmode==ON .and. nk_in_the_process>1)) then
          call exec_matdiagon(isolver,iteration,iteration_electronic)
          call cp_chgq_to_chgqo()
        endif
                                                  __TIMER_STOP(15)
     case (SD,MSD)
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,12)
      call exec_sd(isolver,iteration,iteration_electronic,precon,dtim)
      call cp_chgq_to_chgqo()
                                                  __TIMER_STOP(12)
     case (lmSD, lmMSD, lmCG, lmeazyCG)
        call exec_lmm(isolver,previous_isolver,precon,dtim)

     case (RMM, RMM2, RMM2P)
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,18)
        call exec_rmm(isolver,previous_isolver,precon,dtim)
        call cp_chgq_to_chgqo()
                                                  __TIMER_STOP(18)

     case (SUBMAT)
        call exec_submat(isolver)
        call cp_chgq_to_chgqo()

     case (DAVIDSON)
        call exec_davidson(isolver,precon)
        call cp_chgq_to_chgqo()

     case (MDDAVIDSON)
        call m_CtrlP_set_sw_MRCV_only(ON)      ! sw_MRCV_only = ON
        call exec_mddavidson(isolver,precon)
        call cp_chgq_to_chgqo()

     case (MDKOSUGI)
        call m_CtrlP_set_sw_MRCV_only(OFF)     ! sw_MRCV_only = OFF
        call exec_mddavidson(isolver,precon)
        call cp_chgq_to_chgqo()

     case default
        if(ipri >= 1) write(6,'(" !! isolver = ",i5)') isolver
        call error
        call phase_error_with_msg(nfout,' error at (Renewal_of_WaveFunctions)',__LINE__,__FILE__)
  end select solver

  if(submat_before_renewal/=ON) then
     if((sw_submat == ON .and.  &
          & (isolver /= DAVIDSON .and. isolver /= SUBMAT .and.  &
          &  isolver /= MATRIXDIAGON .and. isolver/=MDDAVIDSON .and. isolver /= MDKOSUGI)) &
          & .or.renew_wf_again_m_CtrlP) then
        call exec_submat_before_or_after()  ! contained here
     end if
  end if

  previous_isolver = isolver

  call m_ESIO_wd_WFs_standardout(nfout,ipriwf)

contains
  subroutine exec_submat_before_or_after()
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,14)
    if(push_solver) call m_CtrlP_push_SolverNameApplied("SUBMAT",6)
    call m_ESsubmat_alloc()

       call m_ESsubmat_renew_WF(nfout,meg,damp)

                                                  __TIMER_STOP(14)
  end subroutine exec_submat_before_or_after

  subroutine cp_chgq_to_chgqo()
    if(icond == INITIAL .or. icond == CONTINUATION) then
       call m_CD_cp_chgq_to_chgqo()
       if(sw_hubbard == ON) call m_OP_cp_ommix_to_omold()
    end if
  end subroutine cp_chgq_to_chgqo

  subroutine check_new_solver
    ! If "isolver" is not "previous_isolver", the value of "isolver" is printed.
    ! And if "isolver" is RMM?*, "iteration_rmm_start" is set in the module m_IterationNumbers
    !
    if(isolver /= previous_isolver) then
       if(ipri>=2) write(nfout,*) ' isolver = ', isolver
       if(isolver == RMM .or. isolver == RMM2 .or. isolver == RMM2P) then
          call m_Iter_set_rmm_start     ! iteration_rmm_start = iteration_electronic
          if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) &
               &  call m_ESrmm_reset_ng_maxmin()
          if(ipri >= 2) write(nfout,'(" !! iteration_rmm_start is set")')
          call m_ESrmm_reset_r_norm_flag ! ->rr_is_over_or_under(= UNDER)
       end if
    end if
  end subroutine check_new_solver

end subroutine Renewal_of_WaveFunctions

function EigenValue(ilevel)
  use m_Const_Parameters, only     : DP, Hartree
  use m_Electronic_Structure, only : m_ES_get_energy
  real(kind=DP) ::       EigenValue
  integer, intent(in) :: ilevel

  EigenValue = m_ES_get_energy(ilevel)*Hartree  ! energy unit is eV
end function EigenValue

! === EXEC_MATDIAGON ==
subroutine exec_matdiagon(isolver,iteration,iteration_electronic)
  use m_Files,                only : nfout
  use m_ES_WF_by_MatDiagon,   only : m_ESmat_solve_Hx_eq_eSx_3D
  implicit none
  integer, intent(in) :: isolver,iteration,iteration_electronic

  call push_solver_name_applied(isolver)

  call m_ESmat_solve_Hx_eq_eSx_3D(nfout,iteration,iteration_electronic)
end subroutine exec_matdiagon

! === EXEC_SD ===
subroutine exec_sd(isolver,iteration,iteration_electronic,precon,dtim)
  use m_Const_Parameters,     only : DP,ON
  use m_Files,                only : nfout
  use m_Electronic_Structure, only : m_ES_sort_eigen_values_3D
  use m_ES_WF_by_SDorCG,      only : m_ESsd_renew_WF_by_SDorCG
#ifdef __TIMER__
  use m_Parallelization,      only : mpi_comm_group
#endif
  implicit none
  integer, intent(in) :: isolver,precon,iteration,iteration_electronic
  real(kind=DP), intent(in)  :: dtim
#ifdef __TIMER__
  integer :: ierr
#endif

  call push_solver_name_applied(isolver)
     call m_ESsd_renew_WF_by_SDorCG(nfout,isolver,precon,dtim)

! ------------------- Revised by T. Yamasaki,  21 July 2009 --->>
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,6)
  call m_ES_sort_eigen_values_3D() ! -> neordr, nrvf_ordr
                                                  __TIMER_STOP(6)
! <----
end subroutine exec_sd

! === EXEC_LMM ===
subroutine exec_lmm(isolver,previous_isolver,precon,dtim)
  use m_Const_Parameters,     only : DP, DAVIDSON, ON
  use m_Files,                only : nfout
!!$  use m_Control_Parameters,   only : m_CtrlP_dtim_1dsearch_now
  use m_ES_WF_by_SDorCG,      only : m_ESsd_renew_WF_by_SDorCG, m_ESsd_evolve_WFs_again
#ifdef MEMORY_SAVE_ZAJ_OLD
  use m_Control_Parameters, only : RMM2P_is_specified
  use m_ES_WF_by_SDorCG,    only : m_ESsd_alloc_zaj_old, m_ESsd_dealloc_zaj_old
#endif
  use m_Electronic_Structure, only : m_ES_sort_eigen_values_3D
#ifdef __TIMER__
  use m_Parallelization,      only : mpi_comm_group
#endif
  implicit none
  integer, intent(in) :: isolver,previous_isolver,precon
  real(kind=DP), intent(in)  :: dtim
#ifdef __TIMER__
  integer :: ierr
#endif

  call push_solver_name_applied(isolver)
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,13)
!!$         if(icond == INITIAL .or. icond == CONTINUATION) then
#ifdef MEMORY_SAVE_ZAJ_OLD
  if(.not. RMM2P_is_specified) call m_ESsd_alloc_zaj_old()
#endif

     call Renew_WF_by_lmSDorlmCG(isolver,precon,dtim)       ! -(contained here)
#ifdef MEMORY_SAVE_ZAJ_OLD
  if(.not. RMM2P_is_specified) call m_ESsd_dealloc_zaj_old()
#endif

                                                  __TIMER_START_w_BARRIER(mpi_comm_group,6)
  call m_ES_sort_eigen_values_3D() ! -> neordr, nrvf_ordr
                                                  __TIMER_STOP(6)
! <----
                                                  __TIMER_STOP(13)

end subroutine exec_lmm

#ifdef CG_PREVIOUS
subroutine Renew_WF_by_lmSDorlmCG(isolver,precon,dtim)
  use m_Const_Parameters,     only : DP, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, BAND_ENERGY,CG &
       &                           , ORTHONORMALIZATION, CONTINUATION &
       &                           , TOTAL_ENERGY, MODIFIED_TOTAL_ENERGY, ON, INITIAL, OFF
  use m_Control_Parameters,   only : energy_evaluation, icond, sw_use_wfred, ipri &
       &                           , m_CtrlP_decide_dtim_1Dsearch, m_CtrlP_dtim_1Dsearch_now &
       &                           , sw_hybrid_functional,force_exx_energy1,sw_retard_eigval_evaluation &
       &                           , potential_update, m_CtrlP_set_in_line_minimization
  use m_Files,                only : nfout
  use m_Kpoints,              only : kv3
  use m_ES_WF_by_SDorCG,      only : m_ESsd_evolve_WFs_again &
       &                           , m_ESsd_alloc_wfred, m_ESsd_dealloc_wfred &
       &                           , m_ESsd_copy_zaj_to_zaj_old, m_ESsd_decide_CG_direction &
       &                           , m_ESsd_renew_WF_by_SDorCG   
  use m_Charge_Density,       only : m_CD_cp_chgq_to_chgqo
  use m_Total_Energy,         only : m_TE_tell_total_energy &
       &                           , m_TE_tell_total_energy0 &
       &                           , m_TE_tell_band_energy &
       &                           , m_TE_tell_extended_band_energy
  use m_ES_ExactExchange,     only : m_ES_EXX_store_wfv, m_ES_EXX_restore_wfv
  use m_IterationNumbers,     only : iteration_electronic
#ifdef __TIMER__
  use m_Parallelization,      only : mpi_comm_group
#endif
  implicit none
  integer, intent(in)         :: isolver,precon
  real(kind=DP),intent(in)    :: dtim

  real(kind=DP), dimension(3) :: etotal
  real(kind=DP), parameter    :: factor = 2
  real(kind=DP)               :: dtim_new = 0.d0, dtim_msdv
  integer                     :: isolver_core, mode

  integer                     :: energy_evaluation_lmm
  integer                     :: what_is_the_core_solver
  integer                     :: ik
#ifdef __TIMER__
  integer :: ierr
#endif

  energy_evaluation_lmm = energy_evaluation
  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) energy_evaluation_lmm = BAND_ENERGY
! <--

  isolver_core = what_is_the_core_solver(isolver) ! -(in this file)

  mode = ORTHONORMALIZATION

! ---------------- Added by T. Yamasaki, 28 June 2008, 31 Oct. 2008 ---
  if(sw_use_wfred == ON) call m_ESsd_alloc_wfred()
! ---------------------------------<<
  call m_ESsd_copy_zaj_to_zaj_old()

  call m_CtrlP_set_in_line_minimization(ON)
!!$  in_line_minimization = .true.

  if(energy_evaluation_lmm == TOTAL_ENERGY) then
     etotal(1) = m_TE_tell_total_energy()
  else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     etotal(1) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
          &                                + m_TE_tell_extended_band_energy(nfout,kv3)
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     etotal(1) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

! ==============================================================================
! === WARN!!! by tkato 2012/02/11                                            ===
! === Right after re-started, the value of "dtim_1Dsearch" is -1             ===
! === and "dtim_msdv" is over-written with "dtim" here.                      ===
! === "dtim_1Dsearch" should be stored into restart file???                  ===
! === -> Resloved on phaseUnif@97 by tkato 2012/02/18                        ===
! === Subroutine m_CtrlP_wd_dtim_previous and m_CtrlP_rd_dtim_previous       ===
! === have been added into m_Control_Parameters.F90.                         ===
! === They write/read "dtim_1Dsearch" to/from "dtim_previous" entry          ===
! === in continue.data.                                                      ===
! ==============================================================================
  dtim_msdv = m_CtrlP_dtim_1Dsearch_now(dtim)
! ==============================================================================
  if(ipri >= 2) write(nfout,'(" !! dtim_msdv = ",f8.4)') dtim_msdv

  if(isolver_core == CG) then
     call m_ESsd_decide_CG_direction(precon)  !  -> betacg
     !    ~~~~~~~~~~~~~~~~~~~~~~~~~~
     call m_ESsd_renew_WF_by_SDorCG(nfout,isolver_core,precon,dtim_msdv,iupdate=0)
     !    ~~~~~~~~~~~~~~~~~~~~~~~~~
  else
     call m_ESsd_renew_WF_by_SDorCG(nfout,isolver_core,precon,dtim_msdv,iupdate=0)
     !    ~~~~~~~~~~~~~~~~~~~~~~~~~
  end if

  if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     call m_CD_cp_chgq_to_chgqo()
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,7)
     if(sw_hybrid_functional==ON) call m_ES_EXX_store_wfv()
     call ChargeDensity_Construction(1)
                                                  __TIMER_STOP(7)
     if(energy_evaluation_lmm == TOTAL_ENERGY) then
        etotal(2) = m_TE_tell_total_energy()
     else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        etotal(2) = m_TE_tell_total_energy0() -  m_TE_tell_band_energy(nfout,kv3) &
             &                                +  m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     if(icond == INITIAL .or. icond == CONTINUATION) call m_CD_cp_chgq_to_chgqo()
     etotal(2) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

  call m_ESsd_evolve_WFs_again(nfout,isolver_core,mode,dtim_msdv,factor*dtim_msdv,iupdate=0)
  ! (msdv_grad)

  if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     if(sw_hybrid_functional==ON) call m_ES_EXX_restore_wfv()
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,7)
     call ChargeDensity_Construction(1)
                                                  __TIMER_STOP(7)
     if(energy_evaluation_lmm == TOTAL_ENERGY) then
        etotal(3) = m_TE_tell_total_energy()
     else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        etotal(3) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
             &                                + m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     etotal(3) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

  if(iteration_electronic==1)then
     etotal(1) = etotal(2);etotal(2) = etotal(3)
     call m_ESsd_evolve_WFs_again(nfout,isolver_core,mode,dtim_msdv,factor*dtim_msdv,iupdate=0)
     call ChargeDensity_Construction(1)
     if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        call ChargeDensity_Construction(1)
        if(energy_evaluation_lmm == TOTAL_ENERGY) then
           etotal(3) = m_TE_tell_total_energy()
        else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
           etotal(3) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
                &                                + m_TE_tell_extended_band_energy(nfout,kv3)
        end if
     else if(energy_evaluation_lmm == BAND_ENERGY) then
        etotal(3) = m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  endif

  dtim_new = m_CtrlP_decide_dtim_1Dsearch(nfout,etotal,dtim_msdv,factor)
  if(ipri >= 2) write(nfout,'(" etotal(1:3) = ",3f15.6," dtim_msdv, dtim_new = ",2f15.6)') etotal(1:3), dtim_msdv, dtim_new
  mode = ORTHONORMALIZATION
  if(sw_retard_eigval_evaluation==ON.and.potential_update>0) force_exx_energy1=.true.
! ------------------- Revised by T. Yamasaki,  03 July 2008, 31 Oct 2008 --->>
  if(sw_use_wfred == ON) then
     call m_ESsd_evolve_WFs_again(nfout,isolver_core,mode,dtim_msdv,dtim_new,iupdate=0)
  else
     call m_ESsd_evolve_WFs_again(nfout,isolver_core,mode,factor*dtim_msdv,dtim_new,iupdate=0)
  end if

  call m_CtrlP_set_in_line_minimization(OFF)
!!$  in_line_minimization = .false.

! ------------------------------------------------------------<<
! ---------------- Added by T. Yamasaki, 28 June 2008, 31 Oct. 2008 ---
  if(sw_use_wfred == ON) call m_ESsd_dealloc_wfred()
! ------------------------------------------------------<<
end subroutine Renew_WF_by_lmSDorlmCG
#else

subroutine Renew_WF_by_lmSDorlmCG(isolver,precon,dtim)
  use m_Const_Parameters,     only : DP, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, BAND_ENERGY &
       &                           , ORTHONORMALIZATION, INITIAL, CONTINUATION &
       &                           , TOTAL_ENERGY, MODIFIED_TOTAL_ENERGY, CG, MSD, ON, OFF

  use m_Control_Parameters,   only : m_CtrlP_decide_dtim_1Dsearch, m_CtrlP_dtim_1Dsearch_now &
       &                           , sw_hybrid_functional, ipri &
       &                           , energy_evaluation, icond, sw_use_wfred, sw_retard_eigval_evaluation &
       &                           , potential_update, force_exx_energy1, m_CtrlP_set_in_line_minimization
  use m_Files,                only : nfout
  use m_Kpoints,              only : kv3
  use m_ES_WF_by_SDorCG,      only : m_ESsd_evolve_WFs_again,  m_ESsd_decide_CG_direction &
       &                           , m_ESsd_alloc_wfred, m_ESsd_dealloc_wfred &
       &                           , m_ESsd_copy_zaj_to_zaj_old, m_ESsd_decide_CG_direction &
       &                           , m_ESsd_renew_WF_by_SDorCG   
  use m_Charge_Density,       only : m_CD_cp_chgq_to_chgqo
  use m_Total_Energy,         only : m_TE_tell_total_energy &
       &                           , m_TE_tell_total_energy0, m_TE_tell_band_energy &
       &                           , m_TE_tell_extended_band_energy
  use m_ES_ExactExchange,     only : m_ES_EXX_store_wfv, m_ES_EXX_restore_wfv
  use m_IterationNumbers,     only : iteration_electronic
  implicit none
  integer, intent(in)         :: isolver,precon
  real(kind=DP),intent(in)    :: dtim

  real(kind=DP), dimension(3) :: etotal
  real(kind=DP), parameter    :: factor = 2
  real(kind=DP)               :: dtim_new = 0.d0, dtim_msdv
  integer                     :: isolver_core, mode, isol
  integer                     :: energy_evaluation_lmm
  integer                     :: what_is_the_core_solver
  integer                     :: iupdate
  integer                     :: ispin,ik

  energy_evaluation_lmm = energy_evaluation
  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) energy_evaluation_lmm = BAND_ENERGY

  isolver_core = what_is_the_core_solver(isolver) ! -(in this file)
  isol = isolver_core
  if(isolver_core==CG) isol=MSD

  mode = ORTHONORMALIZATION
  dtim_msdv = m_CtrlP_dtim_1Dsearch_now(dtim)

  if(sw_use_wfred == ON) call m_ESsd_alloc_wfred()
  call m_ESsd_copy_zaj_to_zaj_old()

  call m_CtrlP_set_in_line_minimization(ON)
!!$  in_line_minimization = .true.

  if(energy_evaluation_lmm == TOTAL_ENERGY) then
     etotal(1) = m_TE_tell_total_energy()
  else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     etotal(1) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
          &                                + m_TE_tell_extended_band_energy(nfout,kv3)
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     etotal(1) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

  if(ipri >= 2) write(nfout,'(" !! dtim_msdv = ",f8.4)') dtim_msdv
  call m_ESsd_renew_WF_by_SDorCG(nfout,isol,precon,dtim_msdv,iupdate=0)

  if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     call m_CD_cp_chgq_to_chgqo()
     if(sw_hybrid_functional==ON) call m_ES_EXX_store_wfv()
     call ChargeDensity_Construction(1)
     if(energy_evaluation_lmm == TOTAL_ENERGY) then
        etotal(2) = m_TE_tell_total_energy()
     else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        etotal(2) = m_TE_tell_total_energy0() -  m_TE_tell_band_energy(nfout,kv3) &
             &                                +  m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     if(icond == INITIAL .or. icond == CONTINUATION) call m_CD_cp_chgq_to_chgqo()
     etotal(2) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

  call m_ESsd_evolve_WFs_again(nfout,isol,mode,dtim_msdv,factor*dtim_msdv,iupdate=0)
	 ! (msdv_grad)
  if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     if(sw_hybrid_functional==ON.and.iteration_electronic/=1) call m_ES_EXX_restore_wfv()
     call ChargeDensity_Construction(1)
     if(energy_evaluation_lmm == TOTAL_ENERGY) then
        etotal(3) = m_TE_tell_total_energy()
     else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        etotal(3) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
             &                                + m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     etotal(3) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

  if(iteration_electronic==1)then
     etotal(1) = etotal(2);etotal(2) = etotal(3)
     call m_ESsd_evolve_WFs_again(nfout,isol,mode,dtim_msdv,factor*dtim_msdv,iupdate=0)

! === ASMS DEBUG === 2015/04/13
!     call ChargeDensity_Construction(1)
     if ( icond /= FIXED_CHARGE .and. icond /= FIXED_CHARGE_CONTINUATION ) then
        call ChargeDensity_Construction(1)
     endif
! ================== 2015/04/13

     if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        if(sw_hybrid_functional==ON) call m_ES_EXX_restore_wfv()
        call ChargeDensity_Construction(1)
        if(energy_evaluation_lmm == TOTAL_ENERGY) then
           etotal(3) = m_TE_tell_total_energy()
        else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
           etotal(3) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
                &                                + m_TE_tell_extended_band_energy(nfout,kv3)
        end if
     else if(energy_evaluation_lmm == BAND_ENERGY) then
        etotal(3) = m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  endif

  dtim_new = m_CtrlP_decide_dtim_1Dsearch(nfout,etotal,dtim_msdv,factor)
  if(ipri >= 2) write(nfout,'(" etotal(1:3) = ",3f15.6," dtim_msdv, dtim_new = ",2f15.6)') etotal(1:3), dtim_msdv, dtim_new

  mode = ORTHONORMALIZATION
  if(sw_retard_eigval_evaluation==ON.and.potential_update>0) force_exx_energy1=.true.
  if(sw_use_wfred == ON) then
     call m_ESsd_evolve_WFs_again(nfout,isol,mode,dtim_msdv,dtim_new,iupdate=0)
  else
     call m_ESsd_evolve_WFs_again(nfout,isol,mode,factor*dtim_msdv,dtim_new,iupdate=0)
  end if
  if(isolver_core == CG) then
     call m_ESsd_decide_CG_direction(precon)  !  -> betacg
     !    ~~~~~~~~~~~~~~~~~~~~~~~~~~
       !call m_ESsd_renew_WF_by_SDorCG(nfout,isolver_core,precon,dtim_msdv)
     call m_ESsd_renew_WF_by_SDorCG(nfout,isolver_core,precon,1.0d0)
     !    ~~~~~~~~~~~~~~~~~~~~~~~~~
  endif
  if(sw_use_wfred == ON) call m_ESsd_dealloc_wfred()
  call m_CtrlP_set_in_line_minimization(OFF)
!!$  in_line_minimization = .false.
end subroutine Renew_WF_by_lmSDorlmCG
#endif


integer function what_is_the_core_solver(isolver)
  use m_Const_Parameters,     only : SD,MSD,CG &
       &                          , lmSD, lmMSD, lmCG, lmeazyCG, eazyCG
  implicit none
  integer, intent(in) :: isolver

  if(isolver == lmSD) then
     what_is_the_core_solver = SD
  else if(isolver == lmMSD) then
     what_is_the_core_solver = MSD
  else if(isolver == lmCG) then
     what_is_the_core_solver = CG
  else if(isolver == lmeazyCG) then
     what_is_the_core_solver = eazyCG
  else
     what_is_the_core_solver = MSD
  end if
end function what_is_the_core_solver

! === EXEC_RMM ===
subroutine exec_rmm(isolver,previous_isolver,precon,dtim)
  use m_Const_Parameters,     only : DP, DAVIDSON
  use m_Files,                only : nfout
  use m_ES_WF_by_RMM,         only : m_ESrmm_renew_WF

#ifdef MEMORY_SAVE_ZAJ_OLD
  use m_Control_Parameters, only : RMM2P_is_specified
#endif
  implicit none
  integer, intent(in) :: isolver,previous_isolver,precon
  real(kind=DP), intent(in)  :: dtim

  call push_solver_name_applied(isolver)
     call m_ESrmm_renew_WF(nfout,isolver,precon,dtim)

end subroutine exec_rmm

! === EXEC_SUBMAT ===
subroutine exec_submat(isolver)
  use m_Files,                only : nfout
  use m_Control_Parameters,    only : meg, damp
  use m_ES_WF_by_submat,       only : m_ESsubmat_Renew_WF, m_ESsubmat_alloc
  implicit none
  integer, intent(in) :: isolver
  
  call push_solver_name_applied(isolver)
  call m_ESsubmat_alloc()
     call m_ESsubmat_renew_WF(nfout,meg,damp)
end subroutine exec_submat

! === EXEC_DAVIDSON ===
subroutine exec_davidson(isolver,precon)
  use m_Files,                only : nfout
  use m_IterationNumbers,     only : iteration_electronic, iteration_ionic
  use m_ES_WF_by_Davidson,    only : m_ESdavidson_Renew_WF
  use m_ES_ortho,             only : m_ES_modified_gram_schmidt
  implicit none
  integer, intent(in) :: isolver, precon

  call push_solver_name_applied(isolver)

     if ( iteration_electronic==1 .and. iteration_ionic>1 ) then
        call m_ES_modified_gram_schmidt(nfout)
     endif
     call m_ESdavidson_Renew_WF(nfout,precon)
end subroutine exec_davidson

subroutine exec_mddavidson(isolver,precon)
  use m_Const_Parameters,     only : ON, OFF
  use m_Control_Parameters,   only : m_CtrlP_push_SolverNameApplied &
       &                           , submat_before_renewal,meg,damp, submat_GE
  use m_Files,                only : nfout
  use m_IterationNumbers,     only : iteration_electronic, iteration_ionic
  use m_ES_WF_by_ModifiedDavidson,only : m_ESmddavid_Subspace_Rotation &
       &                            ,    m_ESmddavid_Renew_WF
  use m_ES_ortho,             only : m_ES_modified_gram_schmidt
  use m_ES_WF_by_submat,      only : m_ESsubmat_Renew_WF, m_ESsubmat_alloc
  implicit none
  integer, intent(in) :: isolver,precon

#ifdef __FAPP__
    call fapp_start('exec_mddavidson',1,1)
#endif
     if(submat_before_renewal == ON) then
        if(submat_GE == OFF) then
           call m_ES_modified_gram_schmidt(nfout)
           call m_CtrlP_push_SolverNameApplied("SUBMAT",6)
           call m_ESsubmat_alloc()
           call m_ESsubmat_renew_WF(nfout,meg,damp)
        else
           call m_ESmddavid_Subspace_Rotation(nfout)
        end if
     end if
     if(submat_GE /= OFF) then
! === DEBUG by tkato 2012/11/05 ================================================
        if((iteration_electronic == 1 .and. iteration_ionic > 1)) then
           call m_ES_modified_gram_schmidt(nfout)
        end if
! ==============================================================================
     end if

     call push_solver_name_applied(isolver)
     call m_ESmddavid_Renew_WF(nfout,precon)
     if(submat_before_renewal /= ON) then
        if(submat_GE == OFF) then
           call m_ES_modified_gram_schmidt(nfout)
           call m_CtrlP_push_SolverNameApplied("SUBMAT",6)
           call m_ESsubmat_alloc()
           call m_ESsubmat_renew_WF(nfout,meg,damp)
        else
           call m_ESmddavid_Subspace_Rotation(nfout)
        end if
     end if
#ifdef __FAPP__
    call fapp_stop('exec_mddavidson',1,1)
#endif
end subroutine exec_mddavidson

subroutine push_solver_name_applied(isolver)
  use m_Const_Parameters,     only : MATRIXDIAGON, SD, MSD, lmSD, lmMSD, lmCG, lmeazyCG, RMM, RMM2 &
       &                           , RMM2P, SUBMAT, DAVIDSON, MDDAVIDSON, MDKOSUGI
  use m_Control_Parameters,   only : m_CtrlP_push_SolverNameApplied, len_solvername
  implicit none
  integer, intent(in) :: isolver
  character(len=len_solvername) :: solvername
  character*20 :: name
  integer :: len_char
  name = ""
  solver: select case(isolver)
  case (MATRIXDIAGON)
     name = "MATDIAGON"
  case (SD)
     name = "SD"
  case (MSD)
     name = "MSD"
  case (lmSD)
     name = "lmSD"
  case (lmMSD)
     name = "lmMSD"
  case (lmCG)
     name = "CG"
  case (lmeazyCG)
     name = "lmeazyCG"
  case (RMM)
     name = "RMM3"
  case (RMM2)
     name = "RMM2"
  case (RMM2P)
     name = "RMM2P"
  case (SUBMAT)
     name = "SUBMAT"   
  case (DAVIDSON)
     name = "DAVIDSON"
  case (MDDAVIDSON)
!!$     name = "MDDAVIDSON"
     name = "PKOSUGI"
  case (MDKOSUGI)
!!$     name = "MDKOSUGI"
     name = "PDAVIDSON"
  case default
     name = "notDefined"
  end select solver
  len_char = len_trim(name)
  solvername = ""
  solvername(1:min(len_char,len_solvername)) = name(1:min(len_char,len_solvername))
  call m_CtrlP_push_SolverNameApplied(solvername,min(len_char,len_solvername))
end subroutine push_solver_name_applied

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: gettod(x), dummy
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! $Id: miscellaneous.F90 570 2017-04-21 20:34:50Z yamasaki $
#ifndef VPP
#ifdef _USE_DATE_AND_TIME_
subroutine gettod(x)
  use m_Const_Parameters, only :DP
  real(kind=DP), parameter   :: milisec     = 1.d3
  real(kind=DP), parameter   :: t_mil2micro = 1.d3
  real(kind=DP), intent(out) :: x

  integer ipresent_time(8)
  real(kind=DP)       :: tstart
  real(kind=DP), save ::tstart0 = 0.d0
  data istart/0/
  data tstart/0.0/
  ! Month   1   2   3   4   5   6   7   8   9  10  11  12
  ! days   31  28  31  30  31  30  31  31  30  31  30  31
  !sumdays 31  59  90 120 151 181 212 243 273 304 334 365
  integer, dimension(12) :: sdays
  integer, parameter     :: days_to_1970 = 719460
  data sdays/0, 31, 59, 90,120,151,181,212,243,273,304,334/
  integer  :: days_from_January_1st, month, year, day, days_from_1970_to_this_year

  call date_and_time(values=ipresent_time)
  year = ipresent_time(1); month = ipresent_time(2); day = ipresent_time(3)
!!$  days_from_1970_to_this_year = year*365 + year/4 - year/100 + year/400 - days_to_1970
  days_from_January_1st = sdays(month) + day - 1
  if(month >= 3 .and. mod(year,4) == 0) &
       & days_from_January_1st = days_from_January_1st + 1
!!$  tstart =(((days_from_1970_to_this_year + days_from_January_1st*24 & !hours
  tstart =(((days_from_January_1st*24 & !hours
       & + ipresent_time(5))*60 &             !minutes
       & + ipresent_time(6))*60 &             !seconds
       & + ipresent_time(7))*milisec  &       !mili-seconds
       & + ipresent_time(8)
!!$  if(istart <= 3) then
!!$     write(6,'(" total_days_from_January_1st = ",i10)') total_days_from_January_1st
!!$     write(6,'(" ipresent_time(1-3) = ",3i10)') ipresent_time(1),ipresent_time(2),ipresent_time(3)
!!$     write(6,'(" ipresent_time(4-6) = ",3i10)') ipresent_time(4),ipresent_time(5),ipresent_time(6)
!!$     write(6,'(" ipresent_time(7-8) = ",3i10)') ipresent_time(7),ipresent_time(8)
!!$  end if

  if(istart.eq.0) tstart0 = tstart

  istart = istart + 1
  x = (tstart - tstart0)*t_mil2micro
  return
end subroutine gettod
#else
subroutine gettod(x)
  use m_Const_Parameters, only :DP
  real(kind=DP), intent(out) :: x
  integer :: count, count_rate, count_max
  integer, save :: count_prev = -1
  integer, save :: initialized = 0
  integer, save :: istart = 0
  real (kind=DP)       :: tstart
  real (kind=DP), save :: tstart0  = 0.d0
!------------------------------------------------------------------------
  character(len= 8) :: cdate
  character(len=10) :: ctime
  integer :: idate
  real(kind=DP)       :: rtime
  real(kind=DP), save :: rtime_prev = 0
  call date_and_time(date = cdate, time = ctime)
  read(cdate, '(i8)') idate
  read(ctime, '(f10.3)') rtime
  rtime = (idate - 20000000) * 1.d6 + rtime
!------------------------------------------------------------------------
  call system_clock(count, count_rate, count_max)
  if(count_prev > count) then
     if(rtime > rtime_prev) then
        initialized = initialized + 1
!        write(6,*) 'DEBUG:', count
     else
        write(6,*) 'Caution!  : Clock tamperring is detected'
        write(6,*) 'DEBUG:', count
     endif
  endif
  tstart = (count+initialized*real(count_max, kind = DP))/count_rate
!!$  if(istart <= 2) then
!!$     if(istart <= 1) write(6,'(" !@ -- system_clock check --")')
!!$     write(6,'(" !@ count, count_rate, count_max = ",3i12)') count, count_rate, count_max
!!$     write(6,'(" !@ tstart = ",d20.12)') tstart
!!$  end if
  if(istart == 0) tstart0 = tstart
  istart = istart + 1
  x  = (tstart-tstart0)*1.d6
  count_prev = count
  rtime_prev = rtime
  return
end subroutine gettod
#endif
#else
subroutine dummy
end subroutine dummy
#endif

#ifdef CRAY
function derf(x)
  implicit real*8(a-h,o-z)
  derf = erf(x)
  return
end function derf

function derfc(x)
  implicit real*8(a-h,o-z)
  derfc = erfc(x)
  return
end function derfc

#elif Linux

#ifdef _RPL_ERF_

function derf(x) result(y)
use m_Const_Parameters, only : PAI
implicit none

real(kind=8) :: y
real(kind=8), intent(in) :: x

! local variables
real(kind=8), parameter :: pi   = PAI                      ! PI
real(kind=8), parameter :: pi4  = 4.d0*pi                  ! 4*PI                    
real(kind=8), parameter :: ipi  = 0.31830988618379067153d0 ! 1/PI
real(kind=8), parameter :: sipi = 0.56418958354775628694d0 ! 1/sqrt(PI)
real(kind=8), parameter :: sipi2 = 2.d0*sipi               ! 2/sqrt(PI)
real(kind=8) :: z

z = abs(x)
if(z <= 0.1d0) then
  y = derf1(z)
else if(z < 6) then
  y = derf2(z)
else if(z <= 100) then
  y = derf3(z)
else
!  y = derf4(z)
  y = 1.d0
end if

if(x < 0.d0) y = -y

return

contains
  ! for 0 <= x <= 0.1 
  function derf1(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  ! local variables
  real(kind=8), parameter :: c1 = -1.d0/3.d0
  real(kind=8), parameter :: c2 =  0.1d0
  real(kind=8), parameter :: c3 = -1.d0/42.d0
  real(kind=8), parameter :: c4 =  1.d0/216.d0
  real(kind=8), parameter :: c5 = -1.d0/1320.d0
  real(kind=8) :: x2
  real(kind=8) :: z1,z2,z3,z4,z5
 
  x2 = x*x

  z1 = x2*x
  z2 = z1*x2
  z3 = z2*x2
  z4 = z3*x2
  z5 = z4*x2

  y = sipi2*( x + c1*z1 + c2*z2 + c3*z3 + c4*z4 + c5*z5 )

  return
  end function derf1

  ! for 0.1 <= x <= 6
  function derf2(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  y = derf3(x) + 2.d0/(exp(pi4*x)-1.d0)

  return
  end function derf2

  ! for 6 < x <= 100
  function derf3(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  ! local variables
  real(kind=8), parameter :: h(13) = (/ 0.25d0, 1.d0, 2.25d0, 4.d0, 6.25d0, 9.d0, 12.25d0, 16.d0, &
                           & 20.25d0, 25.d0, 30.25d0, 36.d0, 42.25d0 /)
  real(kind=8), parameter :: e(13) = (/ 0.7788007830714049d0, &
                           & 0.3678794411714423d0, &
                           & 0.1053992245618643d0, &
                           & 0.1831563888873418d-1, &
                           & 0.1930454136227709d-2, &
                           & 0.1234098040866796d-3, &
                           & 0.4785117392129009d-5, &
                           & 0.1125351747192591d-6, &
                           & 0.1605228055185612d-8, &
                           & 0.1388794386496402d-10, &
                           & 0.7287724095819693d-13, &
                           & 0.2319522830243569d-15, & 
                           & 0.4477732441718302d-18 /)
  real(kind=8) :: x2

  x2 = x*x
  
  y = sum(e(1:13)/(h(1:13)+x2))
  y = ipi*exp(-x2)*(0.5d0/x+x*y)
  y = 1-y

  return
  end function derf3

  ! for 100 < x
  function derf4(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  ! local variables
  real(kind=8), parameter :: c1 = -0.5d0
  real(kind=8), parameter :: c2 =  3.d0/4.d0
  real(kind=8), parameter :: c3 = -15.d0/8.d0
  real(kind=8), parameter :: c4 =  105.d0/16.d0
  real(kind=8), parameter :: c5 = -945.d0/32.d0
  real(kind=8) :: x2,xi
  real(kind=8) :: z1,z2,z3,z4,z5

  x2 = x*x
  xi = 1.d0/x
  
  z1 = xi*xi
  z2 = z1*z1
  z3 = z2*z1
  z4 = z3*z1
  z5 = z4*z1
  
  y = sipi*exp(-x2)*xi*( 1.d0 + c1*z1 + c2*z2 + c3*z3 + c4*z4 + c5*z5 )
  y = 1-y

  return
  end function derf4

end function derf
function derfc(x) result(y)
use m_Const_Parameters, only : PAI
implicit none

real(kind=8) :: y
real(kind=8), intent(in) :: x

! local variables
real(kind=8), parameter :: pi   = PAI                      ! PI
real(kind=8), parameter :: pi4  = 4.d0*pi                  ! 4*PI                    
real(kind=8), parameter :: ipi  = 0.31830988618379067153d0 ! 1/PI
real(kind=8), parameter :: sipi = 0.56418958354775628694d0 ! 1/sqrt(PI)
real(kind=8), parameter :: sipi2 = 2.d0*sipi               ! 2/sqrt(PI)
real(kind=8) :: z

z = abs(x)
if(z <= 0.1d0) then
  y = derfc1(z)
else if(z < 6) then
  y = derfc2(z)
else if(z <= 100) then
  y = derfc3(z)
else
  !y = derfc4(z)
  y = 0.d0
end if

if(x < 0.d0) y = 2.d0-y

return

contains
  ! for 0 <= x <= 0.1 
  function derfc1(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  ! local variables
  real(kind=8), parameter :: c1 = -1.d0/3.d0
  real(kind=8), parameter :: c2 =  0.1d0
  real(kind=8), parameter :: c3 = -1.d0/42.d0
  real(kind=8), parameter :: c4 =  1.d0/216.d0
  real(kind=8), parameter :: c5 = -1.d0/1320.d0
  real(kind=8) :: x2
  real(kind=8) :: z1,z2,z3,z4,z5
 
  x2 = x*x

  z1 = x2*x
  z2 = z1*x2
  z3 = z2*x2
  z4 = z3*x2
  z5 = z4*x2

  y = sipi2*( x + c1*z1 + c2*z2 + c3*z3 + c4*z4 + c5*z5 )
  y = 1-y

  return
  end function derfc1

  ! for 0.1 <= x <= 6
  function derfc2(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  y = derfc3(x) - 2.d0/(exp(pi4*x)-1.d0)

  return
  end function derfc2

  ! for 6 < x <= 100
  function derfc3(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  ! local variables
  real(kind=8), parameter :: h(13) = (/ 0.25d0, 1.d0, 2.25d0, 4.d0, 6.25d0, 9.d0, 12.25d0, 16.d0, &
                           & 20.25d0, 25.d0, 30.25d0, 36.d0, 42.25d0 /)
  real(kind=8), parameter :: e(13) = (/ 0.7788007830714049d0, &
                           & 0.3678794411714423d0, &
                           & 0.1053992245618643d0, &
                           & 0.1831563888873418d-1, &
                           & 0.1930454136227709d-2, &
                           & 0.1234098040866796d-3, &
                           & 0.4785117392129009d-5, &
                           & 0.1125351747192591d-6, &
                           & 0.1605228055185612d-8, &
                           & 0.1388794386496402d-10, &
                           & 0.7287724095819693d-13, &
                           & 0.2319522830243569d-15, & 
                           & 0.4477732441718302d-18 /)
  real(kind=8) :: x2

  x2 = x*x
  
  y = sum(e(1:13)/(h(1:13)+x2))
  y = ipi*exp(-x2)*(0.5d0/x+x*y)

  return
  end function derfc3

  ! for 100 < x
  function derfc4(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  ! local variables
  real(kind=8), parameter :: c1 = -0.5d0
  real(kind=8), parameter :: c2 =  3.d0/4.d0
  real(kind=8), parameter :: c3 = -15.d0/8.d0
  real(kind=8), parameter :: c4 =  105.d0/16.d0
  real(kind=8), parameter :: c5 = -945.d0/32.d0
  real(kind=8) :: x2,xi
  real(kind=8) :: z1,z2,z3,z4,z5

  x2 = x*x
  xi = 1.d0/x
  
  z1 = xi*xi
  z2 = z1*z1
  z3 = z2*z1
  z4 = z3*z1
  z5 = z4*z1
  
  y = sipi*exp(-x2)*xi*( 1.d0 + c1*z1 + c2*z2 + c3*z3 + c4*z4 + c5*z5 )

  return
  end function derfc4

end function derfc

#endif

#endif

#define VDW_ONESHOT_NEW

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 552 $)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  PROGRAM: vdW-Soler
!
!  AUTHOR(S): Y. Ono
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifndef DISABLE_VDWDF
subroutine vdW_scf( nspin, ispin, nfft_div_size, na, nb, nc, chgr, grad_rho, ecnl, &
     &              dFdrho, dFddrho, version_no, vflag )

  use m_Control_Parameters, only : printable, sw_use_WuGygi_method
  use m_Const_Parameters, only : DP, EXC_ONLY, ON
  use m_Files, only : nfout
  use m_Timing, only : tstatc0_begin,tstatc0_end
  use m_vdWDF, only : initialize_vdwdf_scf,build_theta,vdWdf_core,corrections, &
       &              get_dFdrho_dFddrho,finalize_vdwdf,Ecnl_12,Ecnl_3,Ecnl_3s, &
       &              univol,rinplw, ecnl_vdwdf, oneshot
  implicit none

  integer, intent(in) :: nspin,ispin,nfft_div_size,na,nb,nc
  integer, intent(in) :: version_no
  integer, intent(in) :: vflag

  real(kind=DP), dimension(nfft_div_size), intent(in) :: chgr,grad_rho
  real(kind=DP), intent(out) :: ecnl
  real(kind=DP), dimension(nfft_div_size), intent(out) :: dFdrho,dFddrho
  integer :: i,i1,i2,i3
  logical, save :: initialized=.false.
  integer :: id_sname=-1

  call tstatc0_begin('vdW_scf ',id_sname,1)
  call initialize_vdwdf_scf( nspin, ispin, nfft_div_size, na, nb, nc, chgr, grad_rho, version_no )
  call build_theta()

  if ( vflag == EXC_ONLY ) oneshot = .true.
  call vdWdf_core()
  if ( vflag == EXC_ONLY ) oneshot = .false.

  if ( sw_use_WuGygi_method == ON ) then
     ecnl = Ecnl_12
  else
     call corrections()
     ecnl = Ecnl_12 + Ecnl_3 - Ecnl_3s
  endif

  ecnl_vdwdf = ecnl

  call get_dFdrho_dFddrho(dFdrho,dFddrho)
  call finalize_vdwdf()
  call tstatc0_end(id_sname)

end subroutine vdW_scf

subroutine vdW_scf_stress( nspin, ispin, nfft_div_size, na, nb, nc, chgr, grad_rho, cgrad_rho, &
     &                     version_no, input_charge )
  use m_Const_Parameters, only : DP, Partial_Core_Charge
  use m_Timing, only : tstatc0_begin, tstatc0_end
  use m_vdWDF, only : initialize_vdwdf_stress, build_theta, vdWdf_stress_tensor_core, &
       &              finalize_vdwdf, univol,rinplw, s_cnl1, s_cnl2, s_cnl1_pc, s_cnl2_pc
  use m_Files,  only : nfout

  implicit none
  integer, intent(in) :: nspin,ispin,nfft_div_size, na,nb,nc, input_charge, version_no
  real(kind=DP), intent(in) :: chgr(nfft_div_size), grad_rho(nfft_div_size)
  real(kind=DP), intent(in) :: cgrad_rho(nfft_div_size,3)

  integer :: i,i1,i2,i3
  logical, save :: initialized=.false.
  integer :: id_sname=-1

  call tstatc0_begin('vdW_scf_stress ',id_sname,1)
  call initialize_vdwdf_stress( nspin, ispin, nfft_div_size, na, nb, nc, chgr, grad_rho, cgrad_rho, &
       &                        version_no )
  call build_theta()
  call vdWdf_stress_tensor_core()
  call finalize_vdwdf()
!
  if ( input_charge == Partial_Core_Charge ) then
     s_cnl1_pc = s_cnl1
     s_cnl2_pc = s_cnl2
  endif
  call tstatc0_end(id_sname)

end subroutine vdW_scf_stress

#ifdef VDW_ONESHOT_NEW
subroutine vdW_oneshot()
  use m_Const_Parameters,  only : Valence_plus_PC_Charge, EXC_ONLY, VXC_AND_EXC
  use m_Control_Parameters, only : len_xctype, xctype, printable, oneshot
  use m_Files,   only : nfout
  use m_Charge_Density,  only : chgq_l
  use m_XC_Potential ,  only : m_XC_cal_potential_3D
  use m_Timing, only : tstatc0_begin,tstatc0_end
  use m_Parallelization, only : mype
  use m_Total_Energy, only : etotal
  use m_vdWDF, only:  ecnl_vdwdf

  implicit none

  integer :: id_sname = -1

  call tstatc0_begin('vdW_oneshot ',id_sname,1)
  if(mype==0) then
     write(nfout,*)
     write(nfout,'(a)')    "** 'oneshot' calculation of the vdW-interaction **"
  endif
  write(nfout,*)

  oneshot = .false.
  call m_XC_cal_potential_3D( nfout, Valence_plus_PC_Charge, chgq_l, EXC_ONLY )
  oneshot = .true.


  etotal = etotal + ecnl_vdwdf

  if(printable) then
     write(nfout,'(a,f20.10,a)') '--> total energy : ',etotal,' hartree'
  endif
  write(nfout,*)

  call tstatc0_end(id_sname)

end subroutine vdW_oneshot

#else
subroutine vdW_oneshot()
  use m_Const_Parameters, only : DP
  use m_Control_Parameters, only : printable,nspin
  use m_Files, only : nfout
  use m_Parallelization, only : mype
  use m_Timing, only : tstatc0_begin,tstatc0_end
  use m_Total_Energy, only : etotal
  use m_vdWDF, only: initialize_vdwdf_oneshot,build_theta,vdWdf_core,corrections,Ecnl_12,Ecnl_3,Ecnl_3s,finalize_vdwdf
  implicit none
  integer :: is
  integer :: id_sname = -1
  real(kind=DP) :: Ecnl
  call tstatc0_begin('vdW_oneshot ',id_sname,1)
  if(mype==0) then
     write(nfout,'(a)')    "** 'oneshot' calculation of the vdW-interaction **"
  endif
  Ecnl=0.d0
  is=1
  if(nspin>1) is=-1

  call initialize_vdwdf_oneshot(is)
  call build_theta()
  call vdWdf_core()
  Ecnl = Ecnl+Ecnl_12
  call corrections()
  Ecnl = Ecnl+Ecnl_3 - Ecnl_3s
  call finalize_vdwdf()
  etotal = etotal + Ecnl
  if(printable) then
     write(nfout,'(a,f20.10,a)') 'vdW energy       : ',Ecnl,  ' hartree'
     write(nfout,'(a,f20.10,a)') '--> total energy : ',etotal,' hartree'
  endif
  call tstatc0_end(id_sname)
end subroutine vdW_oneshot
#endif

#endif

      subroutine dc_redist2(n, NB, a, lda, b, ldb, wk, lwk)
      implicit NONE

      integer, intent(in)    :: n, NB, lda, ldb, lwk
      real(8), intent(in)    :: a(lda,*)
      real(8), intent(out)   :: b(ldb,*)
      real(8), intent(inout) :: wk(lwk)

      real(8), pointer       :: wk1(:), wk2(:)
      integer, pointer       :: ir_sz(:,:)
      integer, pointer       :: l_(:)

      integer :: i,i0,j,k,k0,l,lx,m,m0
      integer :: iblk, jblk
      integer :: idist, ir_size, is_size
      integer :: his_rank, her_rank

      integer            :: PACK, MPACK

      include 'trd.h'
      include 'mpif.h'

      real(8) :: d1, d2, aa(10)


      aa = 0

      iblk = (n-1)/y_nnod+1
      jblk = (n-1)/x_nnod+1
      jblk = (jblk-1)/NB+1


      d1 = MPI_Wtime()
      allocate ( ir_sz(x_nnod,jblk) )
      d2 = MPI_Wtime()
      aa(1) = aa(1) + (d2-d1)

      d1=MPI_Wtime()

      do m = 4,1,-1
         lx = 0
         PACK = m
         do i0=1,jblk,PACK
         do idist = 1, x_nnod-1

            her_rank = MOD(x_inod-1+idist+x_nnod,x_nnod)+1
            his_rank = MOD(x_inod-1-idist+x_nnod,x_nnod)+1

            l = 0
            do i=i0,MIN(jblk,i0+PACK-1)
            do j=1,NB
              K=j+((x_inod-1)+(i-1)*x_nnod)*NB
              if ( K <= n .AND. MOD(K-1,x_nnod)+1 == her_rank ) then
                 l = l + 1
              end if
            end do
            end do

            lx = MAX(l, lx)

            l = 0
            do i=i0,MIN(jblk,i0+PACK-1)
            do j=1,NB
              K=j+((his_rank-1)+(i-1)*x_nnod)*NB
              if ( K <= n .AND. MOD(K-1,x_nnod)+1 == x_inod ) then
                 l = l + 1
              end if
            end do
            end do
            ir_sz(idist,i0) = l

            lx = MAX(l, lx)

         end do
         end do
         lx = MAX(1,lx)
         MPACK = MAX(1,lwk/(2*lx))
         MPACK = MIN(MPACK, iblk)
         if ( 2*lx*MPACK <= lwk ) EXIT
      enddo

      d2 = MPI_Wtime()
      aa(3) = aa(3) + (d2-d1)


      MPACK = MAX(1,lwk/(2*lx))
      MPACK = MIN(MPACK, iblk)
      if ( 2*lx*MPACK <= lwk ) then
         call dc_redist2_sub(n, NB, a, lda, b, ldb,
     &                       wk(1), wk(1+lx*MPACK),
     &                       ir_sz, x_nnod, PACK, MPACK, aa)
      else
      MPACK = MAX(1,lwk/(1*lx))
      MPACK = MIN(MPACK, iblk)
      if ( lx*MPACK <= lwk ) then
         d1 = MPI_Wtime()
         allocate ( wk2(1:lx*MPACK) )
         d2 = MPI_Wtime()
         aa(1) = aa(1) + (d2-d1)
         call dc_redist2_sub(n, NB, a, lda, b, ldb,
     &                       wk(1), wk2(1),
     &                       ir_sz, x_nnod, PACK, MPACK, aa)
         d1 = MPI_Wtime()
         deallocate ( wk1 )
         deallocate ( wk2 )
         d2 = MPI_Wtime()
         aa(1) = aa(1) + (d2-d1)
      else
      MPACK = MAX(1,lwk/(2*lx))
      MPACK = MIN(MPACK, iblk)
         d1 = MPI_Wtime()
         allocate ( wk1(1:lx*MPACK) )
         allocate ( wk2(1:lx*MPACK) )
         d2 = MPI_Wtime()
         aa(1) = aa(1) + (d2-d1)
         call dc_redist2_sub(n, NB, a, lda, b, ldb,
     &                       wk1(1), wk2(1),
     &                       ir_sz, x_nnod, PACK, MPACK, aa)
         d1 = MPI_Wtime()
         deallocate ( wk1 )
         deallocate ( wk2 )
         d2 = MPI_Wtime()
         aa(1) = aa(1) + (d2-d1)
      endif
      endif
      
      d1 = MPI_Wtime()
      deallocate ( ir_sz )
      d2 = MPI_Wtime()
      aa(1) = aa(1) + (d2-d1)

      if ( TRD_inod == 1 ) print *, PACK, MPACK, aa(1:6)


      end subroutine

      subroutine dc_redist2_sub(n, NB, a, lda, b, ldb,
     &                      wk1, wk2, ir_sz, ldr, PACK, MPACK, aa)
      implicit NONE

      integer, intent(in)    :: n, NB, lda, ldb, ldr, PACK, MPACK
      real(8), intent(in)    :: a(lda,*)
      real(8), intent(out)   :: b(ldb,*)
      real(8), intent(inout) :: wk1(*), wk2(*)
      integer, intent(in)    :: ir_sz(ldr,*)
      real(8), intent(inout) :: aa(*)

      integer, pointer       :: l_(:)

      integer :: i,i0,j,k,k0,l,lx,m,m0
      integer :: iblk, jblk
      integer :: idist, ir_size, is_size
      integer :: iq(2), his_rank, her_rank

      include 'trd.h'
      include 'mpif.h'

      real(8) :: d1, d2


      iblk = (n-1)/y_nnod+1
      jblk = (n-1)/x_nnod+1
      jblk = (jblk-1)/NB+1


      allocate ( l_(1:iblk+1) )

      do i0=1,jblk,PACK

            d1 = MPI_Wtime()
!$OMP PARALLEL DO private(i,j,K,K0,m)
      do m=1,iblk
         do i=i0,MIN(jblk,i0+PACK-1)
         do j=1,NB
            K=j+((x_inod-1)+(i-1)*x_nnod)*NB
            if ( K <= n .AND. MOD(K-1,x_nnod)+1 == x_inod ) then
               K0=(K-1)/x_nnod+1
               b(K0,m) = a(j+NB*(i-1),m)
            end if
         end do
         end do
      end do
!$OMP END PARALLEL DO
            d2 = MPI_Wtime()
            aa(2) = aa(2) + (d2-d1)

      do idist = 1, x_nnod-1

         her_rank = MOD(x_inod-1+idist+x_nnod,x_nnod)+1
         his_rank = MOD(x_inod-1-idist+x_nnod,x_nnod)+1


      do m0=1,iblk,MPACK

         ir_size=ir_sz(idist,i0)*MIN(iblk-m0+1,MPACK)
         if ( ir_size > 0 ) then

            d1 = MPI_Wtime()
            call irecv_dbl(wk2, ir_size, his_rank, iq(2), x_COMM_WORLD)
            d2 = MPI_Wtime()
            aa(4) = aa(4) + (d2-d1)

         end if


         l_(1)=0
!$OMP PARALLEL DO private(i,j,K,l,m)
         do m=m0,MIN(iblk,m0+MPACK-1)
            l = 0
            do i=i0,MIN(jblk,i0+PACK-1)
            do j=1,NB
               K=j+((x_inod-1)+(i-1)*x_nnod)*NB
               if ( K <= n .AND. MOD(K-1,x_nnod)+1 == her_rank ) then
                  l = l + 1
               end if
            end do
            end do
            l_(m-m0+1+1)=l
         end do
!$OMP END PARALLEL DO
         do m=m0+1,MIN(iblk,m0+MPACK-1)+1
            l=l_(m-m0+1)+l_(m-m0+1-1)
            l_(m-m0+1)=l
         end do


         is_size=l
         if ( is_size > 0 ) then

            d1 = MPI_Wtime()
!$OMP PARALLEL DO private(i,j,K,l,m)
            do m=m0,MIN(iblk,m0+MPACK-1)
               l=l_(m-m0+1)
               do i=i0,MIN(jblk,i0+PACK-1)
               do j=1,NB
                  K=j+((x_inod-1)+(i-1)*x_nnod)*NB
                  if ( K <= n .AND. MOD(K-1,x_nnod)+1 == her_rank ) then
                     l = l + 1
                     wk1(l) = a(j+NB*(i-1),m)
                  end if
               end do
               end do
            end do
!$OMP END PARALLEL DO
            d2 = MPI_Wtime()
            aa(5) = aa(5) + (d2-d1)

            d1 = MPI_Wtime()
            call isend_dbl(wk1, is_size, her_rank, iq(1), x_COMM_WORLD)
            d2 = MPI_Wtime()
            aa(4) = aa(4) + (d2-d1)

         end if


         ir_size=ir_sz(idist,i0)*MIN(iblk-m0+1,MPACK)
         if ( ir_size > 0 ) then

            l_(1)=0
!$OMP PARALLEL DO private(i,j,K,K0,l,m)
            do m=m0,MIN(iblk,m0+MPACK-1)
               l = 0
               do i=i0,MIN(jblk,i0+PACK-1)
               do j=1,NB
                  K=j+((his_rank-1)+(i-1)*x_nnod)*NB
                  if ( K <= n .AND. MOD(K-1,x_nnod)+1 == x_inod ) then
                     l = l + 1
                  end if
               end do
               end do
               l_(m-m0+1+1)=l
            end do
!$OMP END PARALLEL DO
            do m=m0+1,MIN(iblk,m0+MPACK-1)+1
               l=l_(m-m0+1)+l_(m-m0+1-1)
               l_(m-m0+1)=l
            end do

            d1 = MPI_Wtime()
            call wait_dbl(iq(2))
            d2 = MPI_Wtime()
            aa(4) = aa(4) + (d2-d1)

            d1 = MPI_Wtime()
!$OMP PARALLEL DO private(i,j,K,K0,l,m)
            do m=m0,MIN(iblk,m0+MPACK-1)
               l=l_(m-m0+1)
               do i=i0,MIN(jblk,i0+PACK-1)
               do j=1,NB
                  K=j+((his_rank-1)+(i-1)*x_nnod)*NB
                  if ( K <= n .AND. MOD(K-1,x_nnod)+1 == x_inod ) then
                     l = l + 1
                     K0=(K-1)/x_nnod+1
                     b(K0,m) = wk2(l)
                  end if
               end do
               end do
            end do
!$OMP END PARALLEL DO
            d2 = MPI_Wtime()
            aa(6) = aa(6) + (d2-d1)

         end if

         if ( is_size > 0 ) then

            d1 = MPI_Wtime()
            call wait_dbl(iq(1))
            d2 = MPI_Wtime()
            aa(4) = aa(4) + (d2-d1)

         end if

      end do

      end do

      end do

      d1 = MPI_Wtime()
      deallocate ( l_ )
      d2 = MPI_Wtime()
      aa(1) = aa(1) + (d2-d1)

      return
      end subroutine

#define FEF_ZGEMM
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 593 $)
!
!  MODULE: m_FiniteElectricField
!
!  AUTHOR(S): T. Yamamoto   Oct/01/2007
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_FiniteElectricField
! $ID: $
  use m_Const_Parameters,     only : DP, PAI, PAI2, PAI4, ON, OFF, CARTS, BUCS &
                                 & , MONKHORST_PACK, PARA, EXECUT, SKIP, DELTA
  use m_Control_Parameters,   only : iprifef, nspin, printable, elec_field &
                                 & , kimg, way_ksample, sw_check_polar, af, neg, ipriparallel
  use m_Files,                only : nfout
  use m_Crystal_Structure,    only : altv, rltv, univol, nopr, op, imag
  use m_PlaneWaveBasisSet,    only : kg1, ngabc, nbase, iba, kgp
  use m_Electronic_Structure, only : totch, zaj_l, m_ES_add_it_to_vnlph, nrvf_ordr, neordr &
                                 & , fsr_l,fsi_l, occup_l
  use m_Kpoints,              only : kv3, k_symmetry, vkxyz, mp_index, kshift
  use m_Ionic_System,         only : ntyp,natm,natm2,ityp,cps,iwei,pos
  use m_PseudoPotential,      only : ival,modnrm,dk_fef,qitg_fef &
                                 & , m_PP_include_vanderbilt_pot &
                                 & , n_non0_lmtxlmt,index_lmt1_lmt2,lmta,nlmt,ilmt, nlmta &
                                 & , ltp,taup,il2p,isph,iqitg,dl2p &
                                 & , m_PP_find_maximum_l, nlmtt
  use m_NonLocal_Potential,   only : snl
  use m_Parallelization,      only : npes,mype,map_ek,map_z, mpi_e_world, map_z, map_e, mpi_comm_group &
                                 & , map_k, myrank_k, myrank_e, mpi_ge_world, nrank_k, nrank_g, myrank_g, np_nvale
  use m_Parallelization,      only : mp_e, myrank_nval, mpi_ke_world, mpi_ge_world, mpi_kg_world &
                                 & , ista_g1k, iend_g1k, ista_fs, iend_fs, np_g1k
  use m_Parallelization,      only : mp_e, myrank_nvale, mpi_k_world, ista_nvale, iend_nvale &
                                 & , m_Parallel_init_mpi_nvale, ista_snl, iend_snl
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  implicit none
 
  integer :: ns ! the number of valence states
  integer :: msize ! maxval(mp_index)
  integer :: numef ! the number of conponents of the electric field
  integer, allocatable :: kgbpp(:,:,:,:) !d(0:n1-1,0:n2-1,0:n3-1,numef)
  integer, allocatable :: kgbpm(:,:,:,:) !d(0:n1-1,0:n2-1,0:n3-1,numef)
  integer, allocatable :: ista_kgbpp(:,:,:,:) !d(0:n1-1,0:n2-1,0:n3-1,numef)
  integer, allocatable :: iend_kgbpp(:,:,:,:) !d(0:n1-1,0:n2-1,0:n3-1,numef)
  integer, allocatable :: ista_kgbpm(:,:,:,:) !d(0:n1-1,0:n2-1,0:n3-1,numef)
  integer, allocatable :: iend_kgbpm(:,:,:,:) !d(0:n1-1,0:n2-1,0:n3-1,numef)
  integer, allocatable :: indgbp(:,:,:,:,:,:) !d(kg1,2,0:n1-1,0:n2-1,0:n3-1,numef)
  integer, allocatable :: indgbm(:,:,:,:,:,:) !d(kg1,2,0:n1-1,0:n2-1,0:n3-1,numef)
  integer :: elec_id(3)
  real(kind=DP) :: efa(3)
  complex(kind=DP), allocatable :: smat(:,:) !d(ns,ns)
  real(kind=DP), allocatable :: berry(:,:,:) !d(0:msize-1,0:msize-1,numef)
  complex(kind=DP), allocatable :: berry_det(:,:,:,:) !d(0:n1-1,0:n2-1,0:n3-1,numef)
  complex(kind=DP), allocatable, dimension(:,:,:) :: berry_dett

  integer :: nopr_trs
  integer, allocatable :: op_trs(:,:,:) !d(3,3,nopr_trs)

  integer, allocatable :: map_nnn2ik(:,:,:) !d(0:n1-1,0:n2-1,0:n3-1)
  integer, allocatable :: map_nnn2op(:,:,:) !d(0:n1-1,0:n2-1,0:n3-1)
  integer, allocatable :: map_nnn2gs(:,:,:,:) !d(3,0:n1-1,0:n2-1,0:n3-1)
  integer, allocatable :: map_ik2nnn(:,:,:) !d(3,nopr_trs,kv3) = {[n1,n2,n3]}
  logical, allocatable :: flag_op(:,:) !d(nopr_trs,kv3)

  integer :: ngmax
  integer, allocatable :: ngpt(:,:) !d(ngmax,nopr_trs)

  real(kind=DP), allocatable :: grad_fef(:,:,:,:) !d(kg1,ns,kv3,kimg)

  complex(kind=DP), private, allocatable :: ftqe(:,:,:,:) !d(nlmt,nlmt,natm,numef)

  real(kind=DP), dimension(3) :: pmac,pmac_old

  real(kind=DP), allocatable :: fsr_fef(:,:,:) ! d(nval,nlmta,kv3)
  real(kind=DP), allocatable :: fsi_fef(:,:,:) ! d(nval,nlmta,kv3)
  real(kind=DP), allocatable :: neordr_val(:,:) ! d(nval,kv3)
  real(kind=DP), allocatable :: wfv(:,:,:,:) ! d(kg1,nval,kv3,kimg)
  real(kind=DP), allocatable :: snlt(:,:,:)

  complex(kind=DP) :: cone=dcmplx(1.d0,0.d0), czero=dcmplx(0.d0,0.d0)

  include 'mpif.h'                                      ! MPI

contains

  function modp(k,m) result(ks)
    integer :: ks
    integer, intent(in) :: k,m
    if(k<0) then
       ks = k + m*(1-int(dble(k)/m-1.d-8))
    else
       ks = k - m*int(dble(k)/m+1.d-8)
    end if
  end function modp

  subroutine m_FEF_init(nfout)
    integer, intent(in) :: nfout
    integer :: ig,ik
    integer :: jj1,jj2,i1,i2,i3,j,jp,ik1,iopr1,ik2,iopr2
    integer :: ipm,ii(3)
    integer :: iopr,jg,ng(3)
    integer :: irot(3,3)
    integer :: m1,m2,m3
    integer :: igs(3)
    integer :: iwork,nn
    integer :: ierr

    call check_elec_field

    call check_kpoints
    
    write(nfout,*) 'efa=',efa(1:3)
    write(nfout,*) 'elec_id=',elec_id

    call alloc_ngpt !-> ngmax

    do iopr=1,nopr_trs
       irot(:,:) = nint(matmul(transpose(altv),matmul(op_trs(:,:,iopr),rltv))/PAI2)
       write(nfout,'("irot=",9(1x,i3))') irot(1:3,1:3)
       IG_LOOP: do ig=1,ngmax
          ng(1:3) = matmul(irot,ngabc(ig,1:3))
          do jg=1,kgp
             if(ngabc(jg,1)==ng(1).and.ngabc(jg,2)==ng(2).and.ngabc(jg,3)==ng(3)) then
                ngpt(ig,iopr) = jg
                cycle IG_LOOP
             end if
          end do
          write(nfout,*) 'Error: NOT found the rotated G'
          call phase_error_with_msg(nfout,'Error: NOT found the rotated G',__LINE__,__FILE__)
       end do IG_LOOP
    end do

    call alloc_indgb

    m1 = mp_index(1)-1
    m2 = mp_index(2)-1
    m3 = mp_index(3)-1
    do ig=1,3
       if(elec_id(ig)==0) cycle
       do i1=0,mp_index(1)-1
          do i2=0,mp_index(2)-1
             do i3=0,mp_index(3)-1
                write(nfout,*) 'i1,i2,i3,ig=',i1,i2,i3,ig
                ik1 = map_nnn2ik(i1,i2,i3)
                iopr1 = map_nnn2op(i1,i2,i3)
                ii(1) = i1
                ii(2) = i2
                ii(3) = i3
                jp = ii(ig)+1
                ipm = 0
                if(jp>=mp_index(ig)) then
                   ipm = +1
                   jp = 0
                end if
                ii(ig) = jp
                ik2 = map_nnn2ik(ii(1),ii(2),ii(3))
                iopr2 = map_nnn2op(ii(1),ii(2),ii(3))
                igs(1:3) = map_nnn2gs(1:3,ii(1),ii(2),ii(3)) - map_nnn2gs(1:3,i1,i2,i3)
                igs(ig) = igs(ig) + ipm
                write(nfout,*) 'igs=',igs
                call get_ind_of_g_plus_b(igs,i1,i2,i3,ig,elec_id(ig),ik1,iopr1,ik2,iopr2 &
                                      & ,m1,m2,m3,indgbp,kgbpp)

                ii(1) = i1
                ii(2) = i2
                ii(3) = i3
                jp = ii(ig)-1
                ipm = 0
                if(jp<0) then
                   ipm = -1
                   jp = mp_index(ig)-1
                end if
                ii(ig) = jp
                ik2 = map_nnn2ik(ii(1),ii(2),ii(3))
                iopr2 = map_nnn2op(ii(1),ii(2),ii(3))
                igs(1:3) = map_nnn2gs(1:3,ii(1),ii(2),ii(3)) - map_nnn2gs(1:3,i1,i2,i3)
                igs(ig) = igs(ig) + ipm
                write(nfout,*) 'igs=',igs
                call get_ind_of_g_plus_b(igs,i1,i2,i3,ig,elec_id(ig),ik1,iopr1,ik2,iopr2 &
                                      & ,m1,m2,m3,indgbm,kgbpm)
             end do
          end do
       end do
    end do
    call dealloc_ngpt

    do ig=1,3
       if(elec_id(ig)==0) cycle
       do i1=0,mp_index(1)-1
          do i2=0,mp_index(2)-1
             do i3=0,mp_index(3)-1
                nn = kgbpp(i1,i2,i3,elec_id(ig))
                iwork = (nn-1)/nrank_g + 1
                ista_kgbpp(i1,i2,i3,elec_id(ig)) = min(myrank_g*iwork+1, nn+1)
                iend_kgbpp(i1,i2,i3,elec_id(ig)) = min(ista_kgbpp(i1,i2,i3,elec_id(ig))+iwork-1, nn)

                nn = kgbpm(i1,i2,i3,elec_id(ig))
                iwork = (nn-1)/nrank_g + 1
                ista_kgbpm(i1,i2,i3,elec_id(ig)) = min(myrank_g*iwork+1, nn+1)
                iend_kgbpm(i1,i2,i3,elec_id(ig)) = min(ista_kgbpm(i1,i2,i3,elec_id(ig))+iwork-1, nn)
             enddo
          enddo
       enddo
    enddo

    pmac = 0.d0;pmac_old = 0.d0
  end subroutine m_FEF_init

  subroutine check_elec_field
    integer :: ig
    real(kind=8), parameter :: eps = 1.d-12
 
    elec_id(:) = 0
    numef = 0
    do ig=1,3
       efa(ig) =  dot_product(elec_field(:),altv(:,ig))
       if(abs(efa(ig))>eps) then
          numef = numef + 1
          elec_id(ig) = numef
       end if
    end do
  end subroutine check_elec_field

  subroutine check_kpoints
    integer :: i,j,jj,ik,jk
    integer :: i1,i2,i3,jj1,jj2
    integer :: iopr
    integer :: n1,n2,n3
    integer :: kn(3),kns(3)
    real(kind=8) :: rotk(3),dn,tmpk(3)
    logical :: flag_trs

    if(way_ksample /= MONKHORST_PACK) then
       write(nfout,*) 'set way_ksample = MONKHORST_PACK.'
       call phase_error_with_msg(nfout,'way_ksample /= MONKHORST_PACK.',__LINE__,__FILE__)
    end if
    do i=1,3
       if(abs(kshift(i))>1.d-12) then
          write(nfout,*) 'set kshift = 0.'
          call phase_error_with_msg(nfout,'kshit > 0',__LINE__,__FILE__)
       end if
    end do

    if(imag==PARA) then
       flag_trs = .true.
       do i=1,nopr
          if(abs(op(1,1,i)+1)<1.d-12.and. &
           & abs(op(2,2,i)+1)<1.d-12.and. &
           & abs(op(3,3,i)+1)<1.d-12) then
             flag_trs = .false.
             exit
          end if
       end do
    else
       flag_trs = .false.
    end if
    if(flag_trs) then
       nopr_trs = 2*nopr
       allocate(op_trs(3,3,nopr_trs))
       op_trs(1:3,1:3,1:nopr) = nint(op(1:3,1:3,1:nopr))
       op_trs(1:3,1:3,nopr+1:nopr_trs) = -nint(op(1:3,1:3,1:nopr))
    else
       nopr_trs = nopr
       allocate(op_trs(3,3,nopr_trs))
       op_trs = nint(op)
    end if
    write(nfout,*) 'nopr=',nopr
    write(nfout,*) 'nopr_trs=',nopr_trs

    msize = maxval(mp_index)
    n1 = mp_index(1)
    n2 = mp_index(2)
    n3 = mp_index(3)
    allocate(map_nnn2ik(0:n1-1,0:n2-1,0:n3-1)); map_nnn2ik=0
    allocate(map_nnn2op(0:n1-1,0:n2-1,0:n3-1)); map_nnn2op=0
    allocate(map_nnn2gs(3,0:n1-1,0:n2-1,0:n3-1)); map_nnn2gs=0
    allocate(map_ik2nnn(3,nopr_trs,kv3)); map_ik2nnn=-1
    allocate(flag_op(nopr_trs,kv3)); flag_op=.false.

    write(nfout,'("mp_index=",3i6)') mp_index(1:3)
!!$    write(nfout,'("i,mp_index=",2i6)') i,mp_index(i)
    do ik=1,kv3
       LOOP1: do iopr=1,nopr_trs
          tmpk = matmul(op_trs(:,:,iopr),vkxyz(ik,:,CARTS))
          rotk = matmul(transpose(altv),matmul(op_trs(:,:,iopr),vkxyz(ik,:,CARTS)))/PAI2
          write(nfout,'("rotk=",3f20.10)') rotk
          do j=1,3
             dn = mp_index(j)*rotk(j)
             kn(j) = nint(dn)
             if(abs(dn-kn(j)) > 1.d-8) cycle LOOP1
             if(kn(j)<0) then
                kns(j) = kn(j)+mp_index(j)*(1-int(dble(kn(j))/mp_index(j)-1.d-8))
             else
                kns(j) = kn(j)-mp_index(j)*int(dble(kn(j))/mp_index(j)+1.d-8)
             end if
          end do
          write(nfout,'("kn=",3(1x,i4)," kns=",3(1x,i4)," iopr=",i4)') kn(1:3),kns(1:3),iopr
          if(map_nnn2ik(kns(1),kns(2),kns(3))>0) cycle LOOP1
          map_nnn2ik(kns(1),kns(2),kns(3)) = ik
          map_nnn2op(kns(1),kns(2),kns(3)) = iopr
          map_nnn2gs(1:3,kns(1),kns(2),kns(3)) = (kns(1:3) - kn(1:3))/mp_index(1:3)
          map_ik2nnn(1:3,iopr,ik) = kns(1:3)
          flag_op(iopr,ik) = .true.
       end do LOOP1
    end do

    ! Write map func.
    do ik=1,kv3
       do iopr=1,nopr_trs
          if(flag_op(iopr,ik)) then
             write(nfout,'("ik=",i3," iopr=",i3," n1=",i3," n2=",i3," n3=",i3)') ik,iopr,map_ik2nnn(1:3,iopr,ik)
          end if
       end do
    end do
    do i1=0,mp_index(1)-1
       do i2=0,mp_index(2)-1
          do i3=0,mp_index(3)-1
             ik=map_nnn2ik(i1,i2,i3)
             iopr=map_nnn2op(i1,i2,i3)
             write(nfout,'(" n1=",i3," n2=",i3," n3=",i3,"ik=",i3," iopr=",i3," gs=",3(1x,i3))') &
            &  i1,i2,i3,ik,iopr,map_nnn2gs(1:3,i1,i2,i3)
          end do
       end do
    end do

  end subroutine check_kpoints

  subroutine alloc_ngpt
    integer :: ik
    ngmax = nbase(iba(1),1)
    do ik=2,kv3
       ngmax = max(ngmax,nbase(iba(ik),ik))
    end do
    write(nfout,*) 'ngmax=',ngmax
    write(nfout,*) 'nopr_trs=',nopr_trs
    allocate(ngpt(ngmax,nopr_trs))
  end subroutine alloc_ngpt

  subroutine dealloc_ngpt
    deallocate(ngpt)
  end subroutine dealloc_ngpt

  subroutine alloc_indgb
    integer :: m1,m2,m3
    m1 = mp_index(1)-1
    m2 = mp_index(2)-1
    m3 = mp_index(3)-1
    allocate(indgbp(kg1,2,0:m1,0:m2,0:m3,numef)); indgbp = 0
    allocate(indgbm(kg1,2,0:m1,0:m2,0:m3,numef)); indgbm = 0
    allocate(kgbpp(0:m1,0:m2,0:m3,numef))
    allocate(kgbpm(0:m1,0:m2,0:m3,numef))
    allocate(berry_det(0:m1,0:m2,0:m3,numef))
    allocate(berry(0:msize-1,0:msize-1,numef))
    allocate(ista_kgbpp(0:m1,0:m2,0:m3,numef))
    allocate(iend_kgbpp(0:m1,0:m2,0:m3,numef))
    allocate(ista_kgbpm(0:m1,0:m2,0:m3,numef))
    allocate(iend_kgbpm(0:m1,0:m2,0:m3,numef))
  end subroutine alloc_indgb

  subroutine alloc_smat
    logical, save :: first = .true.
    if(first) then
       ns = int(totch + 1.d-13)/2
       !!$write(nfout,*) 'debug FEF: ns=',ns
       write(nfout,*) 'm_FEF detected the number of valence bands; ns=',ns
       first = .false.
       call alloc_grad
    end if
    allocate(smat(ns,ns));smat = 0.d0
    grad_fef = 0.d0
  end subroutine alloc_smat

  subroutine dealloc_smat
    deallocate(smat)
  end subroutine dealloc_smat

  subroutine get_ind_of_g_plus_b(igs,n1,n2,n3,ig,id,ik1,iopr1,ik2,iopr2,m1,m2,m3,indgb,kgbp)
    implicit none
    integer, intent(in) :: igs(3),n1,n2,n3,ig,id,ik1,iopr1,ik2,iopr2,m1,m2,m3
    integer, intent(inout) :: indgb(kg1,2,0:m1,0:m2,0:m3,numef)
    integer, intent(inout) :: kgbp(0:m1,0:m2,0:m3,numef)

    ! local variables
    integer :: jj,i,j,k,l
    integer :: iga,igb,igc,jga,jgb,jgc

    jj = 0
    loop_i: do i=1,iba(ik1)
       k=ngpt(nbase(i,ik1),iopr1)
       iga = ngabc(k,1)+igs(1)
       igb = ngabc(k,2)+igs(2)
       igc = ngabc(k,3)+igs(3)
       loop_j: do j=1,iba(ik2)
          l=ngpt(nbase(j,ik2),iopr2)
          jga = ngabc(l,1)
          jgb = ngabc(l,2)
          jgc = ngabc(l,3)
          if(iga == jga .and. igb == jgb .and. igc == jgc) then
             jj = jj +1
             indgb(jj,2,n1,n2,n3,id) = i
             indgb(jj,1,n1,n2,n3,id) = j
             exit loop_j
          end if
       end do loop_j
    end do loop_i
    kgbp(n1,n2,n3,id) = jj
    write(nfout,'(a,5i8)') 'ind_of_g_plus_b:ik1,ik2,id,kgbp,kg1=',ik1,ik2,id,jj,kg1
  end subroutine get_ind_of_g_plus_b

  subroutine calc_overlap(n1,n2,n3,ik0,iopr0,gs0,ik1,iopr1,gs1,ig,id)
    integer, intent(in) :: n1,n2,n3,ik0,iopr0,ik1,iopr1,ig,id
    integer, intent(in) :: gs0(3),gs1(3)
    integer :: n,m,i,ii,jj,mm,nn
    integer :: ipm0,ipm1
    integer :: ip,it,ia,lmt1,lmt2,u,v,mdvdb
    real(kind=8) :: fnr,fni,fmr,fmi,sr,si,ph,dk(3),vk0(3),vk1(3)
    complex(kind=8) :: defchg,fac,fs1u,fs1v,fs2u,fs2v
    complex(kind=8) :: expkt(natm),csum
    complex(kind=8),allocatable,dimension(:) :: smatt
    integer :: ierr,id_sname=-1,id_sname2=-1
    call tstatc0_begin('calc_overlap  ',id_sname,1)

    if(iopr0>nopr) then
       ipm0=-1
    else
       ipm0=1
    end if
    if(iopr1>nopr) then
       ipm1=-1
    else
       ipm1=1
    end if
    allocate(smatt(ns));smatt=0.d0
    do m=1,ns
       mm = neordr_val(m,ik1)
       smatt = 0.d0
       do n=ista_nvale,iend_nvale
          nn = neordr_val(n,ik0)
          sr = 0.d0
          si = 0.d0
          do i=ista_kgbpp(n1,n2,n3,id),iend_kgbpp(n1,n2,n3,id)
             ii=indgbp(i,2,n1,n2,n3,id)
             jj=indgbp(i,1,n1,n2,n3,id)
             fnr = wfv(ii,nn,ik0,1)
             fni = wfv(ii,nn,ik0,2) * ipm0
             fmr = wfv(jj,mm,ik1,1)
             fmi = wfv(jj,mm,ik1,2) * ipm1
             sr = sr + fnr*fmr + fni*fmi
             si = si + fnr*fmi - fni*fmr
          end do
          call mpi_allreduce(mpi_in_place,sr,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
          call mpi_allreduce(mpi_in_place,si,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
          !!d$write(nfout,*) 'n,m,sr,si=',n,m,sr,si
          !smat(n,m) = dcmplx(sr,si)
          smatt(n) = dcmplx(sr,si)
       end do
       call mpi_allreduce(mpi_in_place,smatt,ns,mpi_double_complex,mpi_sum,mpi_kg_world,ierr)
       smat(:,m) = smatt(:)
    end do

    if(modnrm /= EXECUT) return
    do ia=1,natm
       ph = PAI2*dot_product(gs0-gs1,pos(ia,1:3))
       if(iopr0>1.and.iopr0<=nopr) then
          vk0 = vkxyz(ik0,1:3,CARTS) 
          dk = matmul(op_trs(:,:,iopr0),vk0) - vk0 
          ph = ph + dot_product(dk,cps(ia,1:3))
       else if(iopr0>nopr+1) then
          vk0 = vkxyz(ik0,1:3,CARTS) 
          dk = vk0 + matmul(op_trs(:,:,iopr0),vk0)
          ph = ph + dot_product(dk,cps(ia,1:3))
       end if
       if(iopr1>1.and.iopr1<=nopr) then
          vk1 = vkxyz(ik1,1:3,CARTS) 
          dk = vk1 - matmul(op_trs(:,:,iopr1),vk1)
          ph = ph + dot_product(dk,cps(ia,1:3))
       else if(iopr1>nopr+1) then
          vk1 = vkxyz(ik1,1:3,CARTS) 
          dk = -(vk1 + matmul(op_trs(:,:,iopr1),vk1))
          ph = ph + dot_product(dk,cps(ia,1:3))
       end if
       expkt(ia) = dcmplx(cos(ph),sin(ph))
    end do

    do m=1,ns
       mm = neordr_val(m,ik1)
       smatt(:) = 0.d0
       do n=ista_nvale,iend_nvale
          nn = neordr_val(n,ik0)
          defchg = dcmplx(0.d0,0.d0)
          do ia=1,natm
             it=ityp(ia)
             mdvdb = m_PP_include_vanderbilt_pot(it)
             if(mdvdb == SKIP) cycle
             csum = dcmplx(0.d0,0.d0)
             do lmt1=1,ilmt(it)
                do lmt2=1,ilmt(it)
                   u = lmta(lmt1,ia)
                   v = lmta(lmt2,ia)
                   fac   = ftqe(lmt1,lmt2,it,id)*iwei(ia)
                   fs1u  = dcmplx(fsr_fef(nn,u,ik0),-ipm0*fsi_fef(nn,u,ik0))
                   fs2v  = dcmplx(fsr_fef(mm,v,ik1),ipm1*fsi_fef(mm,v,ik1))
                   csum = csum + fac*fs1u*fs2v
                end do
             end do
             defchg = defchg +  csum * expkt(ia) * iwei(ia)
          end do
          !!smat(n,m) = smat(n,m) + defchg
          smatt(n) = defchg
       end do
       call mpi_allreduce(mpi_in_place,smatt,ns,mpi_double_complex,mpi_sum,mpi_kg_world,ierr)
       smat(:,m) = smat(:,m)+smatt(:)
    end do
    call tstatc0_end(id_sname)
  end subroutine calc_overlap

  subroutine calc_berry_phase(n1,n2,n3,id)
    integer, intent(in) :: n1,n2,n3,id

    integer :: i, info, ipiv(ns), lwork, ip, ierr
    real(kind=8) :: ph
    complex(kind=DP) :: p
    complex(kind=DP), allocatable :: work(:)
    integer :: j

    ! LU-facterize the overlap matrix
    call zgetf2(ns,ns,smat,ns,ipiv,info)
    if(info/=0) then
       write(nfout,*) 'Error(ZGETF2): INFO=',info
       call phase_error_with_msg(nfout,'Error(ZGETF2)',__LINE__,__FILE__)
    end if

    ! Get the determinant of the overlap matrix
    p = dcmplx(1.d0,0.d0)
!!    do i=1,ns
    do i=ista_nvale,iend_nvale
       p = p * smat(i,i)
    end do

    call mpi_allreduce(mpi_in_place,p,1,mpi_double_complex,mpi_prod,mpi_kg_world,ierr)
!    berry_det(n1,n2,n3,id) = p
    berry_dett(n1,n2,n3) = p
!debug
!!    write(nfout,*) 'n1,n2,n3,id,berry_det=',n1,n2,n3,id,p
!end debug

    ! Inverte the overlap matrix
    lwork = -1
    allocate(work(ns))
    call zgetri(ns,smat,ns,ipiv,work,lwork,info)
    lwork = work(1) ! optimal size of the work array
    deallocate(work)
    allocate(work(lwork))
    call zgetri(ns,smat,ns,ipiv,work,lwork,info)
    if(info/=0) then
       write(nfout,*) 'Error(ZGETRI): INFO=',info
       call phase_error_with_msg(nfout,'Error(ZGETRI)',__LINE__,__FILE__)
    end if
    deallocate(work)
  end subroutine calc_berry_phase

#ifdef FEF_ZGEMM
  subroutine  calc_grad(n1,n2,n3,ik0,iopr0,gs0,m1,m2,m3,ik1,iopr1,gs1,ig,id)
    integer, intent(in) :: n1,n2,n3,ik0,iopr0,gs0(3)
    integer, intent(in) :: m1,m2,m3,ik1,iopr1,gs1(3)
    integer, intent(in) :: ig,id

    integer :: m, n, i, ii, jj, mm, nn
    integer :: ipm0,ipm1
    integer :: ia,it,nb,mdvdb
    integer :: lmt1,lmt2,v,l1
    real(kind=DP) :: fac, sr, si, fmr, fmi
    real(kind=DP), allocatable, dimension(:,:) :: grad,gsmat
    real(kind=DP), allocatable, dimension(:,:,:) :: gsmatb
    !real(kind=DP) :: grad(kg1,kimg),gsmat(kg1,kimg)
    real(kind=DP) :: ph,ph0,ph1
    real(kind=DP) :: dk(3),vk0(3),vk1(3)
    complex(kind=DP) :: exp0,exp1,qf,ctmp
    complex(kind=DP), allocatable, dimension(:) :: expgr
    complex(kind=DP), parameter :: zi=(0.d0,1.d0)
    complex(kind=DP), allocatable, dimension(:,:) :: qfmat,snlmat,cmat
    integer :: ierr,icount,ibcount
    integer :: id_sname = -1
    call tstatc0_begin('calc_grad ',id_sname,1)

    fac = efa(ig)/PAI4*mp_index(ig)
    allocate(grad(kg1,kimg));grad = 0.d0
    if(modnrm == EXECUT) then
      allocate(gsmat(kg1,kimg));gsmat = 0.d0
      allocate(gsmatb(kg1,kimg,np_nvale));gsmatb = 0.d0
      allocate(expgr(maxval(np_g1k)));expgr = dcmplx(0.d0,0.d0)
    endif
    if(iopr0>nopr) then
       ipm0=-1
    else
       ipm0=1
    end if
    if(iopr1>nopr) then
       ipm1=-1
    else
       ipm1=1
    end if

    if(iopr0==1) then
       if(modnrm == EXECUT)then
          allocate(snlmat(np_g1k(ik0),nlmta));snlmat=dcmplx(0.d0,0.d0) 
          allocate(qfmat(nlmta,np_nvale));qfmat=dcmplx(0.d0,0.d0)
          allocate(cmat(np_g1k(ik0),np_nvale));cmat=dcmplx(0.d0,0.d0)
          icount = 0
          do ia=1,natm
             it=ityp(ia)
             mdvdb = m_PP_include_vanderbilt_pot(it)
             if(mdvdb == SKIP) cycle
             do i=ista_g1k(ik0),iend_g1k(ik0)
                nb = nbase(i,ik0)
                ph = -PAI2*dot_product(ngabc(nb,1:3),pos(ia,1:3))
                expgr(i-ista_g1k(ik0)+1) = dcmplx(cos(ph),sin(ph))
             end do
             do lmt1=1,ilmt(it)
                icount = icount+1
                do i=1,np_g1k(ik0)
                   snlmat(i,icount) = expgr(i)*snlt(i,lmt1,(ik0-1)/nspin+1)
                end do
             end do
          enddo
          ibcount = 0
          do m=ista_nvale,iend_nvale
             mm = neordr_val(m,ik1)
             ibcount = ibcount+1
             icount = 0
             do ia=1,natm
                it=ityp(ia)
                mdvdb = m_PP_include_vanderbilt_pot(it)
                if(mdvdb == SKIP) cycle
                ph1 = -PAI2*dot_product(gs1,pos(ia,1:3))
                if(iopr1>1.and.iopr1<=nopr) then
                   vk1 = vkxyz(ik1,1:3,CARTS)
                   dk = vk1 - matmul(op_trs(:,:,iopr1),vk1)
                   ph1 = ph1 + dot_product(dk,cps(ia,1:3))
                else if(iopr1>nopr+1) then
                   vk1 = vkxyz(ik1,1:3,CARTS)
                   dk = -(vk1 + matmul(op_trs(:,:,iopr1),vk1))
                   ph1 = ph1 + dot_product(dk,cps(ia,1:3))
                end if
                exp1 = exp(dcmplx(0.d0,ph1))
                do lmt1=1,ilmt(it)
                   l1 = ltp(lmt1,it)
                
                   qf = dcmplx(0.d0,0.d0)
                   do lmt2=1,ilmt(it)
                      v = lmta(lmt2,ia)
                      qf = qf + ftqe(lmt1,lmt2,it,id)*iwei(ia) &
                          & * dcmplx(fsr_fef(mm,v,ik1),ipm1*fsi_fef(mm,v,ik1))*exp1
                   end do
                   qf = qf * zi**(-l1)
                   icount = icount+1
                   qfmat(icount,ibcount) = qf
                end do
             end do
          enddo
          call zgemm('N','N',np_g1k(ik0),ibcount,icount,cone,snlmat,np_g1k(ik0),qfmat,nlmta,czero,cmat,np_g1k(ik0))
          !do i=1,np_g1k(ik0)
          !   do m=1,ibcount
          !      do lmt1=1,icount
          !         cmat(i,m) = cmat(i,m) + snlmat(i,lmt1)*qfmat(lmt1,m)
          !      enddo
          !   enddo
          !enddo
       endif
       if(modnrm == EXECUT)then
          ibcount = 0
          gsmatb = 0.d0
          do m=ista_nvale,iend_nvale
             ibcount = ibcount+1
             gsmat = 0.d0
             do i=ista_g1k(ik0),iend_g1k(ik0)
                ctmp = cmat(i-ista_g1k(ik0)+1,ibcount)
                gsmat(i,1) = gsmat(i,1) + dble(ctmp)
                gsmat(i,2) = gsmat(i,2) + dimag(ctmp)
             end do
             call mpi_allreduce(mpi_in_place,gsmat,kg1*kimg,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
             gsmatb(:,1:2,ibcount) = gsmat(:,1:2)
          enddo
       endif
       do n=1,ns
          nn = neordr_val(n,ik0)
          grad = 0.d0
          !!do m=1,ns
          ibcount = 0    
          do m=ista_nvale,iend_nvale
             sr = dble(smat(m,n))
             si = dimag(smat(m,n))
             mm = neordr_val(m,ik1)
             if(modnrm /= EXECUT) then
             !   do i=1,kgbpp(n1,n2,n3,id)
                do i=ista_kgbpp(n1,n2,n3,id),iend_kgbpp(n1,n2,n3,id)
                   ii=indgbp(i,2,n1,n2,n3,id)
                   jj=indgbp(i,1,n1,n2,n3,id)
                   fmr = wfv(jj,mm,ik1,1)
                   fmi = wfv(jj,mm,ik1,2) * ipm1
                   grad(ii,1) = grad(ii,1) - sr*fmi - si*fmr
                   grad(ii,2) = grad(ii,2) + sr*fmr - si*fmi
                end do
             else
                ibcount = ibcount+1
                do i=ista_kgbpp(n1,n2,n3,id),iend_kgbpp(n1,n2,n3,id)
                   ii=indgbp(i,2,n1,n2,n3,id)
                   jj=indgbp(i,1,n1,n2,n3,id)
                   fmr = wfv(jj,mm,ik1,1) + gsmatb(ii,1,ibcount)
                   fmi = wfv(jj,mm,ik1,2) * ipm1 + gsmatb(ii,2,ibcount)
                   grad(ii,1) = grad(ii,1) - sr*fmi - si*fmr
                   grad(ii,2) = grad(ii,2) + sr*fmr - si*fmi
                end do
             end if
          end do
          call mpi_allreduce(mpi_in_place,grad,kg1*kimg,mpi_double_precision,mpi_sum &
                &           ,mpi_ke_world,ierr)
          call mpi_allreduce(mpi_in_place,grad,kg1*kimg,mpi_double_precision,mpi_sum &
                &           ,mpi_kg_world,ierr)
          do i=1,iba(ik0)
             grad_fef(i,n,ik0,1) = grad_fef(i,n,ik0,1) + fac * grad(i,1)
             grad_fef(i,n,ik0,2) = grad_fef(i,n,ik0,2) + fac * grad(i,2)
          end do
       end do
       if(modnrm == EXECUT)then
         deallocate(snlmat)
         deallocate(qfmat)
         deallocate(cmat)
       endif
    end if

    if(iopr1==1) then
       if(modnrm == EXECUT)then
          allocate(snlmat(np_g1k(ik1),nlmta));snlmat=dcmplx(0.d0,0.d0) 
          allocate(qfmat(nlmta,np_nvale));qfmat=dcmplx(0.d0,0.d0)
          allocate(cmat(np_g1k(ik1),np_nvale));cmat=dcmplx(0.d0,0.d0)
          icount = 0
          do ia=1,natm
             it=ityp(ia)
             mdvdb = m_PP_include_vanderbilt_pot(it)
             if(mdvdb == SKIP) cycle
             do i=ista_g1k(ik1),iend_g1k(ik1)
                nb = nbase(i,ik1)
                ph = -PAI2*dot_product(ngabc(nb,1:3),pos(ia,1:3))
                expgr(i-ista_g1k(ik1)+1) = dcmplx(cos(ph),sin(ph))
             end do
             do lmt1=1,ilmt(it)
                icount = icount+1
                do i=1,np_g1k(ik1)
                   snlmat(i,icount) = expgr(i)*snlt(i,lmt1,(ik1-1)/nspin+1)
                end do
             end do
          enddo
          ibcount = 0
          do m=ista_nvale,iend_nvale
             mm = neordr_val(m,ik0)
             ibcount = ibcount+1
             icount = 0
             do ia=1,natm
                it=ityp(ia)
                mdvdb = m_PP_include_vanderbilt_pot(it)
                if(mdvdb == SKIP) cycle
                ph1 = -PAI2*dot_product(gs0,pos(ia,1:3))
                if(iopr0>1.and.iopr0<=nopr) then
                   vk1 = vkxyz(ik0,1:3,CARTS)
                   dk = vk1 - matmul(op_trs(:,:,iopr0),vk1)
                   ph1 = ph1 + dot_product(dk,cps(ia,1:3))
                else if(iopr0>nopr+1) then
                   vk1 = vkxyz(ik0,1:3,CARTS)
                   dk = -(vk1 + matmul(op_trs(:,:,iopr0),vk1))
                   ph1 = ph1 + dot_product(dk,cps(ia,1:3))
                end if
                exp1 = exp(dcmplx(0.d0,ph1))
                do lmt1=1,ilmt(it)
                   l1 = ltp(lmt1,it)
                
                   qf = dcmplx(0.d0,0.d0)
                   do lmt2=1,ilmt(it)
                      v = lmta(lmt2,ia)
                      qf = qf + dconjg(ftqe(lmt1,lmt2,it,id))*iwei(ia) &
                          & * dcmplx(fsr_fef(mm,v,ik0),ipm0*fsi_fef(mm,v,ik0))*exp1
                   end do
                   qf = qf * zi**(-l1)
                   icount = icount+1
                   qfmat(icount,ibcount) = qf
                end do
             end do
          enddo
          call zgemm('N','N',np_g1k(ik1),ibcount,icount,cone,snlmat,np_g1k(ik1),qfmat,nlmta,czero,cmat,np_g1k(ik1))
          !do i=1,np_g1k(ik1)
          !   do m=1,ibcount
          !      do lmt1=1,icount
          !         cmat(i,m) = cmat(i,m) + snlmat(i,lmt1)*qfmat(lmt1,m)
          !      enddo
          !   enddo
          !enddo
       endif
       if(modnrm == EXECUT)then
          ibcount = 0
          gsmatb = 0.d0
          do m=ista_nvale,iend_nvale
             ibcount = ibcount+1
             gsmat = 0.d0
             do i=ista_g1k(ik1),iend_g1k(ik1)
                ctmp = cmat(i-ista_g1k(ik1)+1,ibcount)
                gsmat(i,1) = gsmat(i,1) + dble(ctmp)
                gsmat(i,2) = gsmat(i,2) + dimag(ctmp)
             end do
             call mpi_allreduce(mpi_in_place,gsmat,kg1*kimg,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
             gsmatb(:,1:2,ibcount) = gsmat(:,1:2)
          enddo
       endif
       do n=1,ns
          nn = neordr_val(n,ik1)
          grad = 0.d0
!!          do m=1,ns
          ibcount = 0
          do m=ista_nvale,iend_nvale
             sr =  dble(smat(n,m))
             si = -dimag(smat(n,m))
             mm = neordr_val(m,ik0)
             if(modnrm /= EXECUT) then
                !do i=1,kgbpm(m1,m2,m3,id)
                do i=ista_kgbpm(m1,m2,m3,id),iend_kgbpm(m1,m2,m3,id)
                   ii=indgbm(i,2,m1,m2,m3,id)
                   jj=indgbm(i,1,m1,m2,m3,id)
                   fmr = wfv(jj,mm,ik0,1)
                   fmi = wfv(jj,mm,ik0,2) * ipm0
                   grad(ii,1) = grad(ii,1) + sr*fmi + si*fmr
                   grad(ii,2) = grad(ii,2) - sr*fmr + si*fmi
                end do
             else
                ibcount = ibcount+1
                do i=ista_kgbpm(m1,m2,m3,id),iend_kgbpm(m1,m2,m3,id)
                   ii=indgbm(i,2,m1,m2,m3,id)
                   jj=indgbm(i,1,m1,m2,m3,id)
                   fmr = wfv(jj,mm,ik0,1) + gsmatb(ii,1,ibcount)
                   fmi = wfv(jj,mm,ik0,2) * ipm0 + gsmatb(ii,2,ibcount)
                   grad(ii,1) = grad(ii,1) + sr*fmi + si*fmr
                   grad(ii,2) = grad(ii,2) - sr*fmr + si*fmi
                end do
             end if
          end do
          call mpi_allreduce(mpi_in_place,grad,kg1*kimg,mpi_double_precision,mpi_sum &
                &           ,mpi_ke_world,ierr)
          call mpi_allreduce(mpi_in_place,grad,kg1*kimg,mpi_double_precision,mpi_sum &
                &           ,mpi_kg_world,ierr)
          do i=1,iba(ik1)
             grad_fef(i,n,ik1,1) = grad_fef(i,n,ik1,1) + fac * grad(i,1)
             grad_fef(i,n,ik1,2) = grad_fef(i,n,ik1,2) + fac * grad(i,2)
          end do
       end do
       if(modnrm == EXECUT)then
         deallocate(snlmat)
         deallocate(qfmat)
         deallocate(cmat)
       endif
    end if
    if(modnrm == EXECUT)then
      deallocate(gsmat)
      deallocate(gsmatb)
      deallocate(expgr)
    endif
    deallocate(grad)
    call tstatc0_end(id_sname)
  end subroutine  calc_grad
#else
  subroutine  calc_grad(n1,n2,n3,ik0,iopr0,gs0,m1,m2,m3,ik1,iopr1,gs1,ig,id)
    integer, intent(in) :: n1,n2,n3,ik0,iopr0,gs0(3)
    integer, intent(in) :: m1,m2,m3,ik1,iopr1,gs1(3)
    integer, intent(in) :: ig,id

    integer :: m, n, i, ii, jj, mm, nn
    integer :: ipm0,ipm1
    integer :: ia,it,nb,mdvdb
    integer :: lmt1,lmt2,v,l1
    real(kind=DP) :: fac, sr, si, fmr, fmi
    real(kind=DP) :: grad(kg1,kimg),gsmat(kg1,kimg)
    real(kind=DP) :: ph,ph0,ph1
    real(kind=DP) :: dk(3),vk0(3),vk1(3)
    complex(kind=DP) :: exp0,exp1,qf,ctmp,expgr(kg1)
    complex(kind=DP), parameter :: zi=(0.d0,1.d0)
    integer :: ierr
    integer :: id_sname = -1
    call tstatc0_begin('calc_grad ',id_sname,1)

    fac = efa(ig)/PAI4*mp_index(ig)

    if(iopr0>nopr) then
       ipm0=-1
    else
       ipm0=1
    end if
    if(iopr1>nopr) then
       ipm1=-1
    else
       ipm1=1
    end if

    if(iopr0==1) then
       do n=1,ns
          nn = neordr_val(n,ik0)
          grad = 0.d0
          !!do m=1,ns
          do m=ista_nvale,iend_nvale
             sr = dble(smat(m,n))
             si = dimag(smat(m,n))
             mm = neordr_val(m,ik1)
             if(modnrm /= EXECUT) then
                do i=ista_kgbpp(n1,n2,n3,id),iend_kgbpp(n1,n2,n3,id)
                   ii=indgbp(i,2,n1,n2,n3,id)
                   jj=indgbp(i,1,n1,n2,n3,id)
                   fmr = wfv(jj,mm,ik1,1)
                   fmi = wfv(jj,mm,ik1,2) * ipm1
                   grad(ii,1) = grad(ii,1) - sr*fmi - si*fmr
                   grad(ii,2) = grad(ii,2) + sr*fmr - si*fmi
                end do
             else
                gsmat = dcmplx(0.d0,0.d0)
                do ia=1,natm
                   it=ityp(ia)
                   mdvdb = m_PP_include_vanderbilt_pot(it)
                   if(mdvdb == SKIP) cycle
                   ph1 = -PAI2*dot_product(gs1,pos(ia,1:3))
                   if(iopr1>1.and.iopr1<=nopr) then
                      vk1 = vkxyz(ik1,1:3,CARTS)
                      dk = vk1 - matmul(op_trs(:,:,iopr1),vk1)
                      ph1 = ph1 + dot_product(dk,cps(ia,1:3))
                   else if(iopr1>nopr+1) then
                      vk1 = vkxyz(ik1,1:3,CARTS)
                      dk = -(vk1 + matmul(op_trs(:,:,iopr1),vk1))
                      ph1 = ph1 + dot_product(dk,cps(ia,1:3))
                   end if
                   exp1 = exp(dcmplx(0.d0,ph1))
                   do i=1,iba(ik0)
                      nb = nbase(i,ik0)
                      ph = -PAI2*dot_product(ngabc(nb,1:3),pos(ia,1:3))
                      expgr(i) = dcmplx(cos(ph),sin(ph))
                   end do
                   do lmt1=1,ilmt(it)
                      l1 = ltp(lmt1,it)
                      qf = dcmplx(0.d0,0.d0)
                      do lmt2=1,ilmt(it)
                         v = lmta(lmt2,ia)
                         qf = qf + ftqe(lmt1,lmt2,it,id)*iwei(ia) &
                             & * dcmplx(fsr_fef(mm,v,ik1),ipm1*fsi_fef(mm,v,ik1))*exp1
                      end do
                      qf = qf * zi**(-l1)
                      do i=ista_g1k(ik0),iend_g1k(ik0)
                         ctmp = expgr(i)*snlt(i-ista_g1k(ik0)+1,lmt1,(ik0-1)/nspin+1)*qf
                         gsmat(i,1) = gsmat(i,1) + dble(ctmp)
                         gsmat(i,2) = gsmat(i,2) + dimag(ctmp)
                      end do
                   end do
                end do
                call mpi_allreduce(mpi_in_place,gsmat,kg1*kimg,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
                do i=ista_kgbpp(n1,n2,n3,id),iend_kgbpp(n1,n2,n3,id)
                   ii=indgbp(i,2,n1,n2,n3,id)
                   jj=indgbp(i,1,n1,n2,n3,id)
                   fmr = wfv(jj,mm,ik1,1) + gsmat(ii,1)
                   fmi = wfv(jj,mm,ik1,2) * ipm1 + gsmat(ii,2)
                   grad(ii,1) = grad(ii,1) - sr*fmi - si*fmr
                   grad(ii,2) = grad(ii,2) + sr*fmr - si*fmi
                end do
             end if
          end do
          call mpi_allreduce(mpi_in_place,grad,kg1*kimg,mpi_double_precision,mpi_sum &
                &           ,mpi_ke_world,ierr)
          call mpi_allreduce(mpi_in_place,grad,kg1*kimg,mpi_double_precision,mpi_sum &
                &           ,mpi_kg_world,ierr)
          do i=1,iba(ik0)
             grad_fef(i,n,ik0,1) = grad_fef(i,n,ik0,1) + fac * grad(i,1)
             grad_fef(i,n,ik0,2) = grad_fef(i,n,ik0,2) + fac * grad(i,2)
          end do
       end do
    end if

    if(iopr1==1) then
       do n=1,ns
          nn = neordr_val(n,ik1)
          grad = 0.d0
!!          do m=1,ns
          do m=ista_nvale,iend_nvale
             sr =  dble(smat(n,m))
             si = -dimag(smat(n,m))
             mm = neordr_val(m,ik0)
             if(modnrm /= EXECUT) then
                do i=ista_kgbpm(m1,m2,m3,id),iend_kgbpm(m1,m2,m3,id)
                   ii=indgbm(i,2,m1,m2,m3,id)
                   jj=indgbm(i,1,m1,m2,m3,id)
                   fmr = wfv(jj,mm,ik0,1)
                   fmi = wfv(jj,mm,ik0,2) * ipm0
                   grad(ii,1) = grad(ii,1) + sr*fmi + si*fmr
                   grad(ii,2) = grad(ii,2) - sr*fmr + si*fmi
                end do
             else
                gsmat = dcmplx(0.d0,0.d0)
                do ia=1,natm
                   it=ityp(ia)
                   mdvdb = m_PP_include_vanderbilt_pot(it)
                   if(mdvdb == SKIP) cycle
                   ph0 = -PAI2*dot_product(gs0,pos(ia,1:3))
                   if(iopr0>1.and.iopr0<=nopr) then
                      vk0 = vkxyz(ik0,1:3,CARTS)
                      dk = vk0 - matmul(op_trs(:,:,iopr0),vk0)
                      ph0 = ph0 + dot_product(dk,cps(ia,1:3))
                   else if(iopr0>nopr+1) then
                      vk0 = vkxyz(ik0,1:3,CARTS)
                      dk = -(vk0 + matmul(op_trs(:,:,iopr0),vk0))
                      ph0 = ph0 + dot_product(dk,cps(ia,1:3))
                   end if
                   exp0 = exp(dcmplx(0.d0,ph0))
                   do i=1,iba(ik1)
                      nb = nbase(i,ik1)
                      ph = -PAI2*dot_product(ngabc(nb,1:3),pos(ia,1:3))
                      expgr(i) = dcmplx(cos(ph),sin(ph))
                   end do
                   do lmt1=1,ilmt(it)
                      l1 = ltp(lmt1,it)
                      qf = dcmplx(0.d0,0.d0)
                      do lmt2=1,ilmt(it)
                         v = lmta(lmt2,ia)
                         qf = qf + dconjg(ftqe(lmt1,lmt2,it,id))*iwei(ia) &
                             & * dcmplx(fsr_fef(mm,v,ik0),ipm0*fsi_fef(mm,v,ik0))*exp0
                      end do
                      qf = qf * zi**(-l1)
                      do i=ista_g1k(ik1),iend_g1k(ik1)
                         ctmp = expgr(i)*snlt(i-ista_g1k(ik1)+1,lmt1,(ik1-1)/nspin+1)*qf
                         gsmat(i,1) = gsmat(i,1) + dble(ctmp)
                         gsmat(i,2) = gsmat(i,2) + dimag(ctmp)
                      end do
                   end do
                end do
                call mpi_allreduce(mpi_in_place,gsmat,kg1*kimg,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
                do i=ista_kgbpm(m1,m2,m3,id),iend_kgbpm(m1,m2,m3,id)
                   ii=indgbm(i,2,m1,m2,m3,id)
                   jj=indgbm(i,1,m1,m2,m3,id)
                   fmr = wfv(jj,mm,ik0,1) + gsmat(ii,1)
                   fmi = wfv(jj,mm,ik0,2) * ipm0 + gsmat(ii,2)
                   grad(ii,1) = grad(ii,1) + sr*fmi + si*fmr
                   grad(ii,2) = grad(ii,2) - sr*fmr + si*fmi
                end do
             end if
          end do
          call mpi_allreduce(mpi_in_place,grad,kg1*kimg,mpi_double_precision,mpi_sum &
                &           ,mpi_ke_world,ierr)
          call mpi_allreduce(mpi_in_place,grad,kg1*kimg,mpi_double_precision,mpi_sum &
                &           ,mpi_kg_world,ierr)
          do i=1,iba(ik1)
             grad_fef(i,n,ik1,1) = grad_fef(i,n,ik1,1) + fac * grad(i,1)
             grad_fef(i,n,ik1,2) = grad_fef(i,n,ik1,2) + fac * grad(i,2)
          end do
       end do
    end if
    call tstatc0_end(id_sname)
  end subroutine  calc_grad
#endif

  subroutine m_FEF_polarization(nfout,eplr)
    integer, intent(in) :: nfout
    real(kind=DP), intent(out) :: eplr

    integer :: ig,i,ia,id,ii(3)
    integer :: jj1,jj2,m1,m2,i1,i2,j
    real(kind=DP) :: bp(3),pel(3),pion(3)
    real(kind=DP) :: epel,epion
    real(kind=DP) :: fpi,ph
    complex(kind=DP) :: p
    real(kind=8), parameter :: paid2 = PAI/2


    bp(1:3) = 0.d0
    epel = 0.d0
    do ig=1,3
       id = elec_id(ig)
       if(id==0) cycle
       jj1 = mod(ig+1-1,3)+1
       jj2 = mod(ig+2-1,3)+1
       m1 = mp_index(jj1)
       m2 = mp_index(jj2)
       do i1=0,m1-1
          do i2=0,m2-1
             p = dcmplx(1.d0,0.d0)
             do j=0,mp_index(ig)-1
                ii(jj1) = i1
                ii(jj2) = i2
                ii(ig) = j
                p = p * berry_det(ii(1),ii(2),ii(3),id)
!debug
!!    write(nfout,*) 'n1,n2,n3,ig,berry_det=',ii(1),ii(2),ii(3),ig,berry_det(ii(1),ii(2),ii(3),id)
!end debug
             end do
!debug
!!    write(nfout,*) 'p=',p
!end debug
             ph = dimag(log(p))
             if(ph>paid2) then
                ph = ph - PAI
             else if(ph<-paid2) then
                ph = ph + PAI
             end if
             berry(i1,i2,id) = ph
! debug
!!             write(nfout,*) 'i1,i2,ig,ph=',i1,i2,ig,ph
! end debug
          end do
       end do
       bp(ig) = sum(berry(0:m1-1,0:m2-1,id))/(m1*m2)
       epel = epel + efa(ig)*bp(ig)
    end do
    if(nspin==1) then
       fpi = PAI
    else
       fpi = PAI2
    end if
    epel = -epel/fpi
    pel = matmul(altv,bp)/(univol*fpi)

    do i=1,3
       pion(i) = 0.d0
       do ia=1,natm
          pion(i) = pion(i) + ival(ityp(ia)) * cps(ia,i)
       end do
       epion = -dot_product(elec_field,pion)
       pion(i) = pion(i)/univol
    end do

    if(sw_check_polar==ON) then
       eplr = 0.d0
    else
       eplr = epel + epion
    end if

    write(nfout,'("BP   =",3(1x,f20.9))') bp(1:3)
    write(nfout,'("Pel  =",3(1x,f20.9))') pel(1:3)
    write(nfout,'("Pion =",3(1x,f20.9))') pion(1:3)
    write(nfout,'("Pmac =",3(1x,f20.9))') pel(1:3)+pion(1:3)
    pmac_old = pmac;pmac = pel+pion
  end subroutine m_FEF_polarization

  function get_delta_pmac() result(res)
    real(kind=DP) :: res
    res = sum(pmac - pmac_old)/3.d0
  end function get_delta_pmac

  subroutine m_FEF_build_grad
    integer :: ig,id,ik,iopr
    integer :: n1,n2,n3,ip(3)
    integer :: ik0,ik1,iopr0,iopr1
    integer :: gs0(3),gs1(3)
    integer :: ierr
    integer :: m1,m2,m3
    m1 = mp_index(1)
    m2 = mp_index(2)
    m3 = mp_index(3)
    allocate(berry_dett(0:m1-1,0:m2-1,0:m3-1))
    call gather_valence_states(nfout)

    call alloc_smat
    do ig=1,3
       id = elec_id(ig)
       if(id==0) cycle
       berry_dett = (0.d0,0.d0)
       do ik=1,kv3
          if(map_k(ik) /= myrank_k) cycle
          do iopr=1,nopr_trs
             if(.not.flag_op(iopr,ik)) cycle
             n1=map_ik2nnn(1,iopr,ik)
             n2=map_ik2nnn(2,iopr,ik)
             n3=map_ik2nnn(3,iopr,ik)
             ip(1) = n1
             ip(2) = n2
             ip(3) = n3
             ip(ig) = ip(ig) + 1
             gs1 = 0
             if(ip(ig)>=mp_index(ig)) then
                ip(ig)=0
                gs1(ig) = 1
             end if
             ik0 = map_nnn2ik(n1,n2,n3)
             !!ik0 = ik
             ik1 = map_nnn2ik(ip(1),ip(2),ip(3))
             iopr0 = map_nnn2op(n1,n2,n3)
             iopr1 = map_nnn2op(ip(1),ip(2),ip(3))
             gs0 = map_nnn2gs(1:3,n1,n2,n3)
             gs1 = gs1 + map_nnn2gs(1:3,ip(1),ip(2),ip(3))
             call calc_overlap(n1,n2,n3,ik0,iopr0,gs0,ik1,iopr1,gs1,ig,id) !=> smat
             call calc_berry_phase(n1,n2,n3,id) !=> smat,berry_det
             if(sw_check_polar==OFF) &
              & call calc_grad(n1,n2,n3,ik0,iopr0,gs0,ip(1),ip(2),ip(3),ik1,iopr1,gs1,ig,id) !=> grad_fef
          end do
       end do
       if(nrank_k>1) &
       & call mpi_allreduce(MPI_IN_PLACE,berry_dett,m1*m2*m3,mpi_double_complex,mpi_sum,mpi_ge_world,ierr)
       berry_det(:,:,:,id) = berry_dett(:,:,:)
    end do
    if(nrank_k>1) &
    & call mpi_allreduce(MPI_IN_PLACE,grad_fef,kg1*ns*kv3*kimg,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)

    call dealloc_smat
    deallocate(berry_dett)
  end subroutine m_FEF_build_grad
  
  subroutine m_FEF_add_grad_to_vnlph(ik)
    integer, intent(in) :: ik

    integer :: ib,jb,ig
    real(kind=DP),allocatable,dimension(:,:) :: gradt

    if(sw_check_polar==ON) return

    if(map_k(ik) /= myrank_k) return

    allocate(gradt(kg1,kimg));gradt=0.d0
    do ib=1,ns
       jb = neordr(ib,ik)
       if(map_e(jb) == myrank_e) then
         do ig=1,np_g1k(ik)
            gradt(ig,1:kimg) = grad_fef(ista_g1k(ik)-1+ig,ib,ik,1:kimg)
         enddo
         call m_ES_add_it_to_vnlph(ik,map_z(jb),gradt)
       endif
    end do
    deallocate(gradt)
  end subroutine m_FEF_add_grad_to_vnlph

  subroutine m_FEF_add_grad_to_vnlph_RMM(ik,jb)
    integer, intent(in) :: ik,jb

    integer :: ib

    if(sw_check_polar==ON) return

    if(map_ek(jb,ik) == mype) then
       ib = nrvf_ordr(jb,ik)
       if(ib>ns) return
       call m_ES_add_it_to_vnlph(ik,jb,grad_fef(:,ib,ik,:))
    end if
  end subroutine m_FEF_add_grad_to_vnlph_RMM

  subroutine alloc_grad
    allocate(grad_fef(kg1,ns,kv3,kimg))
  end subroutine alloc_grad

  subroutine dealloc_grad
    deallocate(grad_fef)
  end subroutine dealloc_grad

  subroutine m_FEF_Constract_of_ftq()
    ! local varialbes
    integer :: it,ik,ip,lmt1,lmt2,u,v
    integer :: il1,il2,tau1,tau2,l3
    integer :: n,ilm3,iiqitg,ig,id
    integer :: mdvdb
    integer, allocatable :: il3(:)
    real(kind=DP) :: fac
    real(kind=DP) :: dk(3),ylm,dga
    real(kind=DP) :: ftqr(numef),ftqi(numef),ftqb
    complex(kind=DP) :: zi = (0.d0,1.d0)

    if(modnrm /= EXECUT) return 

    call m_PP_find_maximum_l(n)   !  n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)
    allocate(ftqe(nlmt,nlmt,ntyp,numef)); ftqe=(0.d0,0.d0)
    TYPE: do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle TYPE
       LMT_1: do lmt1=1,ilmt(it)
          il1 = ltp(lmt1,it)
          tau1 = taup(lmt1,it)
          LMT_2: do lmt2=lmt1,ilmt(it)
             il2 = ltp(lmt2,it)
             tau2 = taup(lmt2,it)
             ftqr(1:numef) = 0.d0
             ftqi(1:numef) = 0.d0
             LM3: do n=1,il2p(lmt1,lmt2,it)
                ilm3 = isph(lmt1,lmt2,n,it); l3=il3(ilm3)
                iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                if(iiqitg == 0) cycle LM3
                do ig=1,3
                   id = elec_id(ig)
                   if(id==0) cycle
                   dk(1:3)=-rltv(1:3,ig)/mp_index(ig)
                   call sphrp2_for_Berry(ilm3,dk,ylm)
                   ftqb = qitg_fef(iiqitg,id)*dl2p(lmt1,lmt2,n,it)*ylm
                   !!$ write(6,*) 'it,lmt1,lmt2,n,id,ftqb=',it,lmt1,lmt2,n,id,ftqb
                   if(mod(l3,2)==0) then
                      ftqr(id)=ftqr(id)+real(zi**(-l3))*ftqb
                   else
                      ftqi(id)=ftqi(id)+dimag(zi**(-l3))*ftqb
                   end if
                end do
             end do LM3
             do id=1,numef
                ftqe(lmt1,lmt2,it,id) = dcmplx(ftqr(id),ftqi(id))
                ftqe(lmt2,lmt1,it,id) = ftqe(lmt1,lmt2,it,id)
             end do
          end do LMT_2
       end do LMT_1
    end do TYPE

    deallocate(il3)
  end subroutine m_FEF_Constract_of_ftq

  subroutine gather_valence_states(nfout)
    implicit none
    integer, intent(in) :: nfout

    integer :: ik,ib,ib1,ibm,irev
    real(kind=DP), allocatable :: wfv_mpi(:,:,:,:) ! d(kg1,nval,kv3,kimg)
    real(kind=DP), allocatable :: occup_val_mpi(:,:) ! d(nval,kv3)
    real(kind=DP), allocatable :: neordr_mpi(:,:) ! d(nval,kv3)
    real(kind=DP), allocatable :: fsr_mpi(:,:,:) ! d(nval,nlmta,kv3)
    real(kind=DP), allocatable :: fsi_mpi(:,:,:) ! d(nval,nlmta,kv3)
    real(kind=DP), allocatable :: wfvt(:,:)

    real(kind=DP), allocatable :: zaj_buf(:,:),zaj_buf2(:,:)
    real(kind=DP), allocatable :: fsrt(:),fsit(:)
    integer :: ig,iadd
    integer :: ip0,ip1
    integer :: ilmta,lmt,ia,it

    integer, allocatable, dimension(:) :: ista
    integer :: ierr
    integer :: iksnl
    integer,save  :: id_sname = -1
    logical, save :: firstcall = .true.

    if(firstcall)then
      allocate(snlt(maxval(np_g1k),nlmtt,kv3));snlt=0.d0
      do iksnl=ista_snl,iend_snl
        do ig=1,np_g1k(ik)
          snlt(ig,1:nlmtt,ik) = snl(ig,1:nlmtt,ik)
        enddo
      enddo
      call mpi_allreduce(mpi_in_place,snlt,maxval(np_g1k)*nlmtt*kv3/nspin &
         & ,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
      firstcall = .false.
    endif

    allocate(ista(MPI_STATUS_SIZE))

    call tstatc0_begin('gather_valence_states ',id_sname,level=1)

    ns = int(totch + 1.d-13)/2

    call m_Parallel_init_mpi_nvale(nfout,ipriparallel,printable,ns)

    if(allocated(wfv)) deallocate(wfv)
    if(allocated(neordr_val)) deallocate(neordr_val)
    !allocate(wfv(maxval(np_g1k),ns,kv3,kimg))
    allocate(wfv(kg1,ns,kv3,kimg))
    allocate(wfvt(kg1,kimg))
    if(modnrm==EXECUT)then
      allocate(fsrt(nlmta));allocate(fsit(nlmta))
      fsrt=0.d0;fsit=0.d0
    endif
    allocate(neordr_val(ns,kv3))
    wfv = 0.d0
    neordr_val = 0.d0
    if(modnrm == EXECUT) then
       if(allocated(fsr_fef)) deallocate(fsr_fef)
       if(allocated(fsi_fef)) deallocate(fsi_fef)
       allocate(fsr_fef(ns,nlmta,kv3))
       allocate(fsi_fef(ns,nlmta,kv3))
       fsr_fef = 0.d0
       fsi_fef = 0.d0
    end if
    do ik=1,kv3,af+1
       if(map_k(ik) /= myrank_k) cycle
       do ib=1,ns
          ib1 = neordr(ib,ik)
          if(map_e(ib1) == myrank_e) then
             wfvt=0.d0
             do ig=ista_g1k(ik),iend_g1k(ik)
                wfv(ig,ib1,ik,1:kimg) = zaj_l(ig-ista_g1k(ik)+1,map_z(ib1),ik,1:kimg)
!                wfvt(ig,1:kimg) = zaj_l(ig-ista_g1k(ik)+1,map_z(ib1),ik,1:kimg)
             enddo
             !call mpi_allreduce(mpi_in_place,wfvt,kg1*kimg,mpi_double_precision, mpi_sum,mpi_ke_world,ierr)
             !wfv(:,ib1,ik,:) = wfvt(:,:)
             neordr_val(ib,ik) = neordr(ib,ik)
             if(modnrm == EXECUT) then
                do ilmta=ista_fs,iend_fs
                   iadd = ilmta - ista_fs + 1
                   fsr_fef(ib1,ilmta,ik) = fsr_l(map_z(ib1),iadd,ik)
                   fsi_fef(ib1,ilmta,ik) = fsi_l(map_z(ib1),iadd,ik)
                enddo
             end if
          end if
       end do
    end do
!    call mpi_allreduce(mpi_in_place,wfv,kg1*ns*kv3*kimg,mpi_double_precision, mpi_sum,mpi_kg_world,ierr)
!    call mpi_allreduce(mpi_in_place,wfv,kg1*ns*kv3*kimg,mpi_double_precision, mpi_sum,mpi_ge_world,ierr)
    call mpi_allreduce(mpi_in_place,wfv,kg1*ns*kv3*kimg,mpi_double_precision, mpi_sum,mpi_comm_group,ierr)

    call mpi_allreduce(mpi_in_place,neordr_val,ns*kv3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
    call mpi_allreduce(mpi_in_place,neordr_val,ns*kv3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ge_world,ierr)
    deallocate(wfvt)
    if(modnrm == EXECUT) then
       allocate(fsr_mpi(ns,nlmta,kv3))
       allocate(fsi_mpi(ns,nlmta,kv3))
       call mpi_allreduce(fsr_fef,fsr_mpi,ns*nlmta*kv3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       call mpi_allreduce(fsi_fef,fsi_mpi,ns*nlmta*kv3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       fsr_fef = fsr_mpi
       fsi_fef = fsi_mpi
       deallocate(fsr_mpi)
       deallocate(fsi_mpi)
    end if

    if(modnrm==EXECUT)then
      deallocate(fsrt)
      deallocate(fsit)
    endif
    deallocate(ista)
    call tstatc0_end(id_sname)
  end subroutine gather_valence_states

end module m_FiniteElectricField

      SUBROUTINE MY_PDLAED3( ICTXT, K, N, NB, D, DROW, DCOL,
     $                    RHO, DLAMDA,
     $                    W, Z, U, LDU, BUF, INDX, INDCOL, INDROW,
     $                    INDXR, INDXC, CTOT, NPCOL_, INFO )
!$    use OMP_LIB
      use MPI
      use eigen_devel
      use eigen_dc
      implicit NONE
*
!     This routine is a modified routine of PDLAED3
!     which is contained in the ScaLAPACK
!     Modification is done by T.Imamura
*
*     .. Scalar Arguments ..
      INTEGER            DCOL, DROW, ICTXT, INFO, K, LDU, N, NB, NPCOL_
      DOUBLE PRECISION   RHO
*     ..
*     .. Array Arguments ..
      INTEGER            CTOT( 0: NPCOL_-1, 4 ), INDCOL( * ),
     $                   INDROW( * ), INDX( * ), INDXC( * ), INDXR( * )
      DOUBLE PRECISION   BUF( 1:3*K ), D( * ), DLAMDA( * ), U( LDU, * ),
     $                   W( * ), Z(1:K)
*     ..
*
*  Purpose
*  =======
*
*  MY_PDLAED3 finds the roots of the secular equation, as defined by the
*  values in D, W, and RHO, between 1 and K.  It makes the
*  appropriate calls to SLAED4
*
*  This code makes very mild assumptions about floating point
*  arithmetic. It will work on machines with a guard digit in
*  add/subtract, or on those binary machines without guard digits
*  which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or Cray-2.
*  It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  ICTXT  (global input) INTEGER
*         The BLACS context handle, indicating the global context of
*         the operation on the matrix. The context itself is global.
*
*  K      (output) INTEGER
*         The number of non-deflated eigenvalues, and the order of the
*         related secular equation. 0 <= K <=N.
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  NB      (global input) INTEGER
*          The blocking factor used to distribute the columns of the
*          matrix. NB >= 1.
*
*  D      (input/output) DOUBLE PRECISION array, dimension (N)
*         On entry, D contains the eigenvalues of the two submatrices to
*         be combined.
*         On exit, D contains the trailing (N-K) updated eigenvalues
*         (those which were deflated) sorted into increasing order.
*
*  DROW   (global input) INTEGER
*          The process row over which the first row of the matrix D is
*          distributed. 0 <= DROW < NPROW.
*
*  DCOL   (global input) INTEGER
*          The process column over which the first column of the
*          matrix D is distributed. 0 <= DCOL < NPCOL.
*
*  Q      (input/output) DOUBLE PRECISION array, dimension (LDQ, N)
*         On entry, Q contains the eigenvectors of two submatrices in
*         the two square blocks with corners at (1,1), (N1,N1)
*         and (N1+1, N1+1), (N,N).
*         On exit, Q contains the trailing (N-K) updated eigenvectors
*         (those which were deflated) in its last N-K columns.
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= max(1,NQ).
*
*  RHO    (global input/output) DOUBLE PRECISION
*         On entry, the off-diagonal element associated with the rank-1
*         cut which originally split the two submatrices which are now
*         being recombined.
*         On exit, RHO has been modified to the value required by
*         MY_PDLAED3.
*
*  DLAMDA (global output) DOUBLE PRECISION array, dimension (N)
*         A copy of the first K eigenvalues which will be used by
*         SLAED3 to form the secular equation.
*
*  W      (global output) DOUBLE PRECISION array, dimension (N)
*         The first k values of the final deflation-altered z-vector
*         which will be passed to SLAED3.
*
*  Z      (global input) DOUBLE PRECISION array, dimension (N)
*         On entry, Z contains the updating vector (the last
*         row of the first sub-eigenvector matrix and the first row of
*         the second sub-eigenvector matrix).
*         On exit, the contents of Z have been destroyed by the updating
*         process.
*
*  U     (global output) DOUBLE PRECISION array
*         global dimension (N, N), local dimension (LDU, NQ).
*         Q  contains the orthonormal eigenvectors of the symmetric
*         tridiagonal matrix.
*
*  LDU    (input) INTEGER
*         The leading dimension of the array U.
*
*  QBUF   (workspace) DOUBLE PRECISION array, dimension 3*N
*
*
*  INDX   (workspace) INTEGER array, dimension (N)
*         The permutation used to sort the contents of DLAMDA into
*         ascending order.
*
*  INDCOL (workspace) INTEGER array, dimension (N)
*
*
*  INDROW (workspace) INTEGER array, dimension (N)
*
*
*  INDXR (workspace) INTEGER array, dimension (N)
*
*
*  INDXC (workspace) INTEGER array, dimension (N)
*
*  CTOT   (workspace) INTEGER array, dimension( NPCOL, 4)
*
*  NPCOL   (global input) INTEGER
*          The total number of columns over which the distributed
*           submatrix is distributed.
*
*  INFO   (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  The algorithm failed to compute the ith eigenvalue.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            COL, GI, I, IINFO, IIU, IPD, IU, J, JJU, JU,
     $                   KK, KL, KLC, KLR, MYCOL, MYKL, MYKLR, MYROW,
     $                   NPCOL, NPROW, PDC, PDR, ROW
      DOUBLE PRECISION   AUX, TEMP
      INTEGER :: SINFO, IPD0
*     ..
*     .. Shared Scalar ..
!$    INTEGER, SAVE :: KLR_SHARED
*     .. Local Arrays ..
      REAL(8) :: SZ(1:K), SBUF(1:K)
*     ..
*     .. External Functions ..
      INTEGER            INDXG2L
      DOUBLE PRECISION   DLAMC3, DNRM2
      EXTERNAL           INDXG2L, DLAMC3, DNRM2
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, DCOPY, DGEBR2D, DGEBS2D,
     $                   DGERV2D, DGESD2D, DLAED4
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MOD, SIGN, SQRT
*     ..
      integer :: ERR_MPI
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
*     Quick return if possible
*
      IF( K.EQ.0 ) GOTO 190
*
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
      ROW = DROW
      COL = DCOL
!$OMP DO
      DO I = 1, N, NB
         ROW = MOD(DROW+(I-1)/NB, NPROW)
         COL = MOD(DCOL+(I-1)/NB, NPCOL)
         DO J = 0, NB - 1
            IF( I+J.LE.N ) THEN
               INDROW( I+J ) = ROW
               INDCOL( I+J ) = COL
            END IF
         END DO
!         ROW = MOD( ROW+1, NPROW )
!         COL = MOD( COL+1, NPCOL )
      END DO
!$OMP END DO
         ROW = MOD(DROW+(NB-1)/NB+1, NPROW)
         COL = MOD(DCOL+(NB-1)/NB+1, NPCOL)
*
      MYKL = CTOT( MYCOL, 1 ) + CTOT( MYCOL, 2 ) + CTOT( MYCOL, 3 )
      KLR = MYKL / NPROW
      IF( MYROW.EQ.DROW ) THEN
         MYKLR = KLR + MOD( MYKL, NPROW )
      ELSE
         MYKLR = KLR
      END IF
*
      PDC = 1
      COL = DCOL
      DO
         IF( MYCOL == COL ) EXIT
         PDC = PDC + CTOT( COL, 1 ) + CTOT( COL, 2 ) + CTOT( COL, 3 )
         COL = MOD( COL+1, NPCOL )
      END DO
!   30 CONTINUE
!      IF( MYCOL.NE.COL ) THEN
!         PDC = PDC + CTOT( COL, 1 ) + CTOT( COL, 2 ) + CTOT( COL, 3 )
!         COL = MOD( COL+1, NPCOL )
!         GO TO 30
!      END IF
*
      PDR = PDC
      KL = KLR + MOD( MYKL, NPROW )
      ROW = DROW
      DO
         IF( MYROW == ROW ) EXIT
         PDR = PDR + KL
         KL = KLR
         ROW = MOD( ROW+1, NPROW )
      END DO
!   40 CONTINUE
!      IF( MYROW.NE.ROW ) THEN
!         PDR = PDR + KL
!         KL = KLR
!         ROW = MOD( ROW+1, NPROW )
!         GO TO 40
!      END IF
*
*---
*
!$OMP DO
      DO I = 1, K
         DLAMDA( I ) = DLAMC3( DLAMDA( I ), DLAMDA( I ) ) - DLAMDA( I )
      END DO
!$OMP END DO
*
*---
*
      SINFO = INFO
      IF( MYKLR.GT.0 ) THEN
*
         SZ( 1:K ) = ONE

!$OMP DO
         DO I = 1, MYKLR
            KK = PDR + I - 1
            CALL DLAED4( K, KK, DLAMDA, W, SBUF, RHO, AUX, IINFO )
            BUF(K+I) = AUX
            IF( IINFO.NE.0 ) THEN
               SINFO = KK
            END IF
*
*     ..Compute part of z
*
            DO J = 1, KK - 1
               SZ( J ) = SZ( J )*( SBUF( J ) /
     $                  ( DLAMDA( J )-DLAMDA( KK ) ) )
            END DO
            SZ( KK ) = SZ( KK )*SBUF( KK )
            DO J = KK + 1, K
               SZ( J ) = SZ( J )*( SBUF( J ) /
     $                  ( DLAMDA( J )-DLAMDA( KK ) ) )
            END DO
         END DO
!$OMP END DO

!$OMP MASTER
         Z(1:K) = SZ(1:K)
!$OMP END MASTER
!$OMP BARRIER

!$       DO I = 1, OMP_GET_NUM_THREADS()-1
!$          IF ( OMP_GET_THREAD_NUM() == I ) THEN
!$             Z(1:K) = Z(1:K) * SZ(1:K)
!$          END IF
!$OMP BARRIER
!$       END DO

      ELSE

!$OMP DO
         DO I=1, K
            Z( I ) = ONE
         END DO
!$OMP END DO

      END IF
      INFO = SINFO

!$OMP MASTER
      call MPI_ALLREDUCE( Z( 1 ), BUF( 1 ),
     $                    K, MPI_DOUBLE_PRECISION,
     $                    MPI_PROD, TRD_COMM_WORLD, ERR_MPI )
!$OMP END MASTER
!$OMP BARRIER
!$OMP DO
      DO I = 1, K
         Z( I ) = SIGN( SQRT( -BUF( I ) ), W( I ) )
      END DO
!$OMP END DO
*
*---
*
!$OMP DO
      DO I = 1, MYKL
         BUF(2*K+I) = 0D0
      END DO
!$OMP END DO

      if ( myrow == drow ) then
         IPD = (2*K+1)
      else
         IPD = (2*K+1) + MOD( MYKL, NPROW )
     &                 + MOD( MYROW-DROW+NPROW, NPROW ) * KLR
      end if

      IF ( MYKLR > 0 ) THEN
!$OMP DO
         DO I = 1, MYKLR
            BUF(IPD+I-1) = BUF(K+I)
         END DO
!$OMP END DO
      END IF

!$OMP MASTER
      IF ( MYKL > 0 ) THEN
         call MPI_ALLREDUCE( BUF( 2*K+1 ), BUF( K+1 ),
     &                       MYKL, MPI_DOUBLE_PRECISION,
     &                       MPI_SUM, x_COMM_WORLD, ERR_MPI )
      END IF
!$OMP END MASTER
!$OMP BARRIER
*
*---
*
!$OMP DO
      DO I = 1, K
         BUF(2*K+I) = 0D0
      END DO
!$OMP END DO

      IPD = (2*K+1)
      DO I = 0, NPCOL - 1
         COL = MOD( DCOL+I, NPCOL )
         IF ( mycol == col ) IPD0 = IPD
         KL = CTOT( COL, 1 ) + CTOT( COL, 2 ) + CTOT( COL, 3 )
         IPD = IPD + KL
      END DO
      IPD = IPD0

      IF ( MYKL > 0 ) THEN
!$OMP DO
         DO I = 1, MYKL
            BUF(IPD+I-1) = BUF(K+I)
         END DO
!$OMP END DO
      END IF

!$OMP MASTER
      call MPI_ALLREDUCE( BUF( 2*K+1 ), BUF( K+1 ),
     &                    K, MPI_DOUBLE_PRECISION,
     &                    MPI_SUM, y_COMM_WORLD, ERR_MPI )
*
*     Copy of D at the good place
*
      KLC = 0
      KLR = 0
      DO I = 1, K
         GI = INDX( I )
         D( GI ) = BUF( K+I )
         COL = INDCOL( GI )
         ROW = INDROW( GI )
         IF( COL.EQ.MYCOL ) THEN
            KLC = KLC + 1
            INDXC( KLC ) = I
         END IF
         IF( ROW.EQ.MYROW ) THEN
            KLR = KLR + 1
            INDXR( KLR ) = I
         END IF
      END DO
*
*     Compute eigenvectors of the modified rank-1 modification.
*
!
! Since the result of KLR on the master thread is accessed from the other
! threads, it is broadcast via a shared variable KLR_SHARED hereafter.
!
!$    KLR_SHARED = KLR
!$OMP END MASTER
!$OMP BARRIER
!$    KLR = KLR_SHARED
!$OMP BARRIER
*
*---
*
      SINFO = INFO
      IF( MYKL.NE.0 ) THEN
!$OMP DO
         DO J = 1, MYKL
            KK = INDXC( J )
            JU = INDX( KK )
            JJU = INDXG2L( JU, NB, J, J, NPCOL )
            CALL DLAED4( K, KK, DLAMDA, W, SBUF, RHO, AUX, IINFO )
            IF( IINFO /= 0 ) THEN
               SINFO = KK
            END IF
            IF( K == 1 .OR. K == 2 ) THEN
               DO I = 1, KLR
                  KK = INDXR( I )
                  IU = INDX( KK )
                  IIU = INDXG2L( IU, NB, J, J, NPROW )
                  U( IIU, JJU ) = SBUF( KK )
               END DO
               CYCLE
            END IF
*
            SBUF( 1:K ) = Z( 1:K ) / SBUF( 1:K )
            TEMP = DNRM2( K, SBUF, 1 )
*
            DO I = 1, KLR
               KK = INDXR( I )
               IU = INDX( KK )
               IIU = INDXG2L( IU, NB, J, J, NPROW )
               U( IIU, JJU ) = SBUF( KK ) / TEMP
            END DO
         END DO
!$OMP END DO
      END IF
      INFO = SINFO
*
*---
*
  190 CONTINUE
*
      RETURN
*
*     End of MY_PDLAED3
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 606 $)
!
!  MODULE:  m_PlaneWaveBasisSet
!
!  AUTHOR(S): T. Yamasaki, M. Okamoto,   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, April/15/2006
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!   Revised for the GAMMA point (k=(0,0,0)) by T. Yamasaki, April 2006.
!

#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef FJ_TIMER
#   define __TIMER_FJ_START_w_BARRIER(str,a)   call mpi_barrier(str,ierr) ;   call timer_sta(a)
#   define __TIMER_FJ_START(a)   call timer_sta(a)
#   define __TIMER_FJ_STOP(a)    call timer_end(a)
#else
#   define __TIMER_FJ_START_w_BARRIER(str,a)
#   define __TIMER_FJ_START(a)
#   define __TIMER_FJ_STOP(a)
#endif
#ifdef __TIMER_INIDO__
#   define __TIMER_INIDO_START(a)   call timer_sta(a)
#   define __TIMER_INIDO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_INIDO_START(a)
#   define __TIMER_INIDO_STOP(a)
#endif

module m_PlaneWaveBasisSet
!    ( m_pwBS )
! $Id: m_PlaneWaveBasisSet.F90 606 2020-04-15 06:45:49Z ktagami $
  use m_Crystal_Structure,  only : nopr, altv,rltv, m_CS_op_in_PUCV,univol, univol_prev
  use m_Kpoints,            only : kv3,kv3_ek,vkxyz,qwgt, k_symmetry
  use m_FFT,                only : fft_box_size_WF, fft_box_size_CD, fft_box_size_pWF &
       &                        , fft_box_size_CD_c, fft_box_size_CD_nonpara, fft_box_size_WF_prev &
       &                        , fft_box_size_CD_prev, fft_box_size_CD_nonpara_prev

  use m_Files,              only : nfout
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters, only : ipri,iprifftmap,printable,gmax,gmaxp,gmaxp_reduced, gmax_positron &
       &                         , intzaj,cutoff_mix,af,neg,nel_Ylm, sw_positron &
       &                         , fixed_charge_k_parallel, sw_interpolate_wfs, neg_previous, nspin &
       &                         , sw_modified_kpoint_increment
  use m_Const_Parameters,   only : CARTS, BUCS, CRDTYP, OFF &
       &                         , SURFACE, WHOLE_BZ, SIMPLE_CUBIC &
       &                         , BCC,  FCC, DIAMOND, HEXAGONAL, ORTHORHOMBIC, RUTILE &
       &                         , C2v_SURFACE, Csy_SURFACE, GENERAL, GENERAL_LARGER, DP &
       &                         , by_matrix_diagon, by_random_numbers &
       &                         , PAI, PAI4,SMALL,MEDIUM,LARGE, DELTA, DELTA10, DELTA07 &
       &                         , SmallestPositiveNumber, GAMMA, GAMMA_base_symmetrization &
       &                         , ONE_BY_ONE, ON
  use m_Parallelization,    only : is_kngp,ie_kngp,ista_k,iend_k,ista_kngp,iend_kngp &
       &                         , npes,mype,ierr, mpi_comm_group, myrank_g, nrank_g &
       &                         , myrank_chg, nrank_chg &
       &                         , m_Parallel_init_mpi_kngp_prev_3D, ista_kngp_prev, iend_kngp_prev &
       &                         , nrank_k, nis_kv3_ek
  use m_Parallelization,    only : mpi_kg_world, mpi_ke_world, mpi_chg_world
  use m_Parallelization,    only : ista_kngp_B, iend_kngp_B
  use m_Crystal_Structure,   only : nopr, tau
  use m_Const_Parameters,    only : ANTIFERRO, PAI2
  use m_FFT,                only : fft_box_size_CD_3D

! =================== KT_add ========================= 13.0F&13.0U2
  use m_Control_Parameters,  only : sw_hybrid_functional, gmax_exx, gmaxp_exx, use_fft_exx, &
       &                            sw_modified_TFW_functional
  use m_FFT, only : fft_box_size_exx, fft_box_size_CD_exx, fft_box_size_CD_nonpara
! ==================================================== 13.0F&13.0U2

  use m_IterationNumbers, only : nkgroup

  implicit none
  include 'mpif.h'

  integer, parameter                    :: how_give_initial_zaj = 0
  integer, public,allocatable,target,dimension(:,:)  :: ngabc  !d(kgp,3)
  integer, public,allocatable,target,dimension(:,:)  :: ngabc_kngp_l
  integer, public,allocatable,target,dimension(:,:)  :: ngabc_kngp_B_l
  real(DP),allocatable, dimension(:,:)    :: fp_l
  integer, allocatable, dimension(:,:)  :: ngpt_l !d(ista_kngp:iend_kngp,nopr+af)
  real(DP),allocatable, dimension(:)    :: gr_l   !d(ista_kngp:iend_kngp)
  integer, allocatable, dimension(:)    :: igfp_l !d(ista_kngp:iend_kngp)
  integer, allocatable, dimension(:)    :: igfp_l_prev !d(ista_kngp:iend_kngp)
  integer, allocatable, dimension(:)    :: igfp_nonpara !d(ista_kngp:iend_kngp)
#ifdef _MPIFFT_
  integer, allocatable, dimension(:)    :: igfp_l_c !d(ista_kngp:iend_kngp)
#endif  
  integer, allocatable, dimension(:)    :: igf    !d(kg)
  integer, allocatable, dimension(:)    :: igf_prev
  integer, target                       :: kg, kgp, kgp_reduced, kg1_ext=0, kg1=0, kgpm &
	&                                , kg0, kg_gamma = 0, kg2_gamma = 0, kgp_reduced_prev
  integer                               :: ngshell ! depending on mype
  integer, allocatable, dimension(:,:)  :: ngshell_range ! d(ngshell,2)
  integer                               :: ngshell_GAMMA ! not depend on mype
  ! ------- Positron start
  integer ::                               kg_pwf, kg1_pwf=0
  integer, dimension(3) ::                 n_rGv_pstrn
  integer, allocatable, dimension(:) ::    igf_pstrn !d(kg_pwf)
  ! ------- Positron end

! ======= KT_add ==================================== 13.0F
  integer ::                               kg_exx, kgp_exx, kg1_exx=0,kg1p_exx=0
  integer, dimension(3) ::                 n_rGv_exx,n_rGpv_exx
  integer, allocatable, dimension(:) ::    igf_exx !d(kg_exx)
  integer, allocatable, dimension(:) ::    igfp_exx !d(kgp_exx)
! =================================================== 13.0F

! ====== KT_add ============ 13.0U2
  integer :: kg_tfw = 0
! ========================== 13.0U2

! ===== EXP_CELLOPT ==== 2015/09/24
  integer :: kg1_prev = 0
  integer :: kgp_prev = 0
! ====================== 2015/09/24

! === Band_Unfolding
  integer, allocatable :: GVec_on_refcell(:,:)
! ====

  integer, dimension(3)                 :: n_rGv
  integer, dimension(3)                 :: n_rGpv
  integer, dimension(3)                 :: n_rGpv_reduced
  integer, dimension(3)                 :: n_rGv_prev
  integer, dimension(3)                 :: n_rGpv_prev
  ! n_rG(p)v is the size of a rhombohedron that contains
  ! a sphere whose radius is 2*Gmax (Gmaxp) .

  integer, allocatable, target, dimension(:,:)  :: nbase !d(kg1_ext,kv3) PW Basis Set for each k-points
  integer, allocatable, target, dimension(:,:)  :: nbase_prev !d(kg1_ext,kv3) PW Basis Set for each k-points
  integer, allocatable, dimension(:,:)  :: nbmat ! sub PWBS for each k-points
  !                                                  d(nmatsz,ista_k:iend_k)
  integer, allocatable, dimension(:,:)  :: nbmat2! sub PWBS for each k-points
  !                                                  d(nmatsz,ista_k:iend_k)
  integer, allocatable, target, dimension(:) :: iba    !d(kv3)
  integer, allocatable, target, dimension(:) :: iba_prev    !d(kv3)
  integer, allocatable, dimension(:)    :: iba_ek !d(kv3_ek)
  integer, allocatable, dimension(:)    :: iba2   !d(kv3*how_give_initial_zaj)
  integer, allocatable, target, dimension(:,:)  :: nbase_gamma !d(kg_gamma,2)
  integer, allocatable, target, dimension(:,:)  :: nbase_gamma_prev !d(kg_gamma,2)
  integer                               :: nbmx   ! maximum # of elements in PWBSs
  real(kind=DP),private                 :: gmaxs
  integer                               :: nmatsz ! subspace Hermitian matrix size
  integer                               :: nmatsz2
  integer, dimension(3)                 :: n_rGsv
  ! n_rGhv(1:3) is the size of a rhombohedron that contains a sphare whose
  ! redius is 2*Gmaxs
  integer, allocatable, dimension(:,:,:):: igpo
  !             d(-n_rGsv(1):n_rGsv(1),-n_rGsv(2):n_rGsv(2),-n_rGsv(3):n_rGsv(3))

  real(kind=DP), dimension(6) :: ttr
  real(kind=DP), allocatable,         dimension(:,:,:) :: op_br
  real(kind=DP), allocatable, target, dimension(:,:)   :: ylm_l !d(ista_kngp:iend_kngp, nel_Ylm)

!  1-1.  m_pwBS_alloc_ylm_l            <- Initilal_Electronic_Structure
!  1-2.  m_pwBS_dealloc_ylm_l          <- Initilal_Electronic_Structure
!  1-3.  m_pwBS_alloc_igpo             <- m_ES_WF_by_MatDiagon
!  1-4.  m_pwBS_dealloc_igpo           <- m_ES_WF_by_MatDiagon
!  1-5.  alloc_nbase                   <- (3)
!  1-6.  reduce_nbase                  <- (3)
!  1-7.  alloc_iba                     <- (3)
!  1-8.  G_vectors_alloc               <- (7)
!  1-9.  m_pwBS_alloc_nbmat_and_iba2   <- m_ES_WF_by_MatDiagon
!  1-10. m_pwBS_dealloc_nbmat_and_iba2 <- m_ES_WF_by_MatDiagon
!  1-11. m_pwBS_alloc_ngpt_igfp_gr     <- Preparation
!  1-12. m_pwBS_dealloc_ngpt_igfp_gr   <- Finalization
!  2.    m_pwBS_mat_for_each_WF        <- m_ES_WF_by_MatDiagon
!  3.    m_pwBS_for_each_WF            <- Preparation
!        - wd_ngshell_range
!  4.    m_pwBS_positronWF             <- Preparation
!  5.    m_pwBS_set_gmaxs              <- m_ES_WF_by_MatDiagon
!        - check_gmax
!  6.    m_pwBS_assume_G_rhombohedron  <- Preparation
!        - size_of_Gvector_rhombohedron, - check_the_size_of_rhombohedron
!        - wd_n_rGv_and_n_rGpv
!  7.    m_pwBS_generate_G_vectors     <- Preparation
!        - get_Gvectors_in_a_gmaxp_sphere, - count_Gvectors_in_spheres
!        - adjust_n_rGv_to_2l3m5n
!  8.    m_pwBS_calc_length_of_G       <- Preparation
!  9.    m_pwBS_setup_FFTmapfunctions  <- Preparation
!  10.   m_pwBS_GminusGmapfunction     <- m_ES_WF_by_MatDiagon
!  11.   decide_g_list_size            <- (12)
!  12.   m_pwBS_G_trans_functions      <- Preparation
!        - substitute_g_list, - symmetric_G_points_using_g_list
!        - counting_error_points, - symmetric_G_points
!  13.   m_pwBS_sphrp_l                <- Initial_Electronic_Structure
!  14.   m_pwBS_sphrp2                 <- m_Chargek_Density, m_ES_Intgr_VlhxcQlm,
!                                         m_Force, m_Stress, m_XC_Potential
!  15.   m_pwBS_sphrp2_diff            <- m_Stress, m_XC_Potential, m_epc_potential
!  16.   m_pwBS_kinetic_energies       <- m_ES_WF_by_Davidson, m_ES_WF_by_RMM,
!                                         m_ES_WF_by_SDorCG, m_ES_WF_by_submat,
!                                         m_Electronic_Structure
!  17.   m_pwBS_pstrn_kinetic_energies <- m_Positron_Wave_Functions
!  18.   m_pwBS_find_min_max_G         <- m_ES_WF_by_RMM
!  19.   m_pwBS_decide_cutoff_mix      <- Preparation
!  20.   m_pwBS_wd_ngabc_etc           <- Postprocessing
!  21.   m_pwBS_increase_kg1           <- Preparation

contains
  subroutine m_pwBS_alloc_ylm_l()
    if(nel_Ylm >= 1) then
       allocate(ylm_l(ista_kngp:iend_kngp,nel_Ylm))
    end if
  end subroutine m_pwBS_alloc_ylm_l

  subroutine m_pwBS_dealloc_ylm_l()
    if(allocated(ylm_l)) deallocate(ylm_l)
  end subroutine m_pwBS_dealloc_ylm_l

  subroutine m_pwBS_alloc_igpo()
    integer :: i,j,k
    if(.not.allocated(igpo)) then
       i = n_rGsv(1); j = n_rGsv(2); k = n_rGsv(3)
       allocate(igpo(-i:i,-j:j,-k:k))
    end if
  end subroutine m_pwBS_alloc_igpo

  subroutine m_pwBS_dealloc_igpo()
    if(allocated(igpo)) deallocate(igpo)
  end subroutine m_pwBS_dealloc_igpo

  function get_kg1_ext() result (res)
    integer :: res
    if(kg1 < kg1_ext) then
      res = kg1
    else
      res = kg1_ext
    endif
  end function get_kg1_ext

  subroutine alloc_nbase
    integer :: ik
    logical :: tf
    if(.not.allocated(nbase)) then
       allocate(nbase(kg1_ext,kv3))
!!$       write(6,'(" nbase is allocated, kg1_ext = ",i8,"<<alloc_nbase>>")') kg1_ext
    else
!!$       write(6,'(" nbase has already been allocated, kg1_ext = ",i8,"<<alloc_nbase>>")') kg1_ext
    end if
    tf = .false.
    do ik = 1, kv3
       if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) then
          tf = .true.
       end if
    end do
    if(tf) then
       if(.not.allocated(nbase_gamma)) then
          allocate(nbase_gamma(kg_gamma,2)); nbase_gamma = -1
       end if
! === Debug by Intel "-check all" option! by T.Kato 2011/03/28 =================
!   end if
    else
       if(.not.allocated(nbase_gamma)) then
          allocate(nbase_gamma(1,1)); nbase_gamma = -1
       end if
    end if
! ==============================================================================
  end subroutine alloc_nbase

  subroutine reduce_nbase()
    real(kind=DP), allocatable, dimension(:,:) :: nbase_tmp
    integer :: i, k
    allocate(nbase_tmp(kg1,kv3)); nbase_tmp = 0
    do k = 1, kv3
       do i = 1, iba(k)
          nbase_tmp(i,k) = nbase(i,k)
       end do
    end do
    deallocate(nbase)
    allocate(nbase(kg1,kv3))
    nbase(:,:) = nbase_tmp(:,:)

    deallocate(nbase_tmp)
  end subroutine reduce_nbase

  subroutine alloc_iba
    if(.not.allocated(iba)) then
       allocate(iba(kv3))
       if(ipri >= 3) write(nfout,'(" iba is allocated")')
    else
       if(ipri >= 3) write(nfout,'(" iba is not allocated")')
    end if
  end subroutine alloc_iba

  subroutine G_vectors_alloc
    allocate(ngabc(kgp,3))
  end subroutine G_vectors_alloc

  subroutine m_pwBS_alloc_nbmat_and_iba2()
    if(nmatsz <= 0) call phase_error_with_msg(nfout,' nmatsz <= 0 (alloc_nbmat_and_iba2)',__LINE__,__FILE__)
    if(ipri >= 2 ) write(6,'(" nmatsz = ",i5," kv3 = ",i5," (alloc_nbmat_and_iba2)")') nmatsz,kv3
!!$    allocate(nbmat(nmatsz,ista_k:iend_k))
!!$    allocate(iba2(ista_k:iend_k))
    allocate(nbmat(nmatsz,kv3)); nbmat = 0.d0
    allocate(nbmat2(nmatsz,kv3)); nbmat2 = 0.d0
    allocate(iba2(kv3))
  end subroutine m_pwBS_alloc_nbmat_and_iba2

  subroutine m_pwBS_dealloc_nbmat_and_iba2()
    if(allocated(nbmat)) deallocate(nbmat)
    if(allocated(nbmat2)) deallocate(nbmat2)
    if(allocated(iba2))  deallocate(iba2)
  end subroutine m_pwBS_dealloc_nbmat_and_iba2


  subroutine m_pwBS_dealloc_ngpt_igfp_gr
    if(allocated(gr_l)) deallocate(gr_l)
    if(allocated(ngpt_l)) deallocate(ngpt_l)
    if(allocated(igfp_l)) deallocate(igfp_l)
#ifdef _MPIFFT_
    if(allocated(igfp_nonpara)) deallocate(igfp_nonpara)
    if(allocated(igfp_l_c)) deallocate(igfp_l_c)
#endif
    ! ------- Positron start 
    if(sw_positron /= OFF) deallocate(igf_pstrn)
    ! ------- Positron end

! ========== KT_add ========================== 13.0F
    if (sw_hybrid_functional /= OFF .and. use_fft_exx ) deallocate(igf_exx)
    if (sw_hybrid_functional /= OFF ) deallocate(igfp_exx)
! ============================================ 13.0F

  end subroutine m_pwBS_dealloc_ngpt_igfp_gr

  subroutine m_pwBS_mat_for_each_WF()
    integer          :: i,j,k,kk, icycle, istart, iend, ic, ig, max_elements, icolumn &
         &            , kk_gamma, n1,n2,n3
    real(kind=DP)    :: ga,gb,gc,grvv
    integer          :: id_sname = -1
    call tstatc0_begin('m_pwBS_mat_for_each_WF ',id_sname)

    do i = 1, kv3
       kk = 0
       if(k_symmetry(i) == GAMMA .or. k_symmetry(i) == GAMMA_base_symmetrization) then
          kk_gamma = 0
          do j = 1, kg
             n1 = ngabc(j,1); n2 = ngabc(j,2); n3 = ngabc(j,3)
             grvv = dsqrt(ttr(1)*n1*n1 + ttr(2)*n2*n2 + ttr(3)*n3*n3 &
                  &   +   ttr(4)*n1*n2 + ttr(5)*n2*n3 + ttr(6)*n3*n1)
             if(grvv <= gmaxs) then
                kk = kk + 1
                nbmat(kk,i) = j
                if(n3 >  SmallestPositiveNumber) then
                   kk_gamma = kk_gamma + 1
                else if(n3 == 0) then
                   if((n1 >= 0 .and. n2 >= 0 ) .or. (n1 < 0 .and. n2 > 0)) then
                      kk_gamma = kk_gamma + 1
                   end if
                end if
             end if
          end do
          kg2_gamma = kk_gamma
       else
          do j = 1, kg
             ga = vkxyz(i,1,BUCS) + ngabc(j,1)
             gb = vkxyz(i,2,BUCS) + ngabc(j,2)
             gc = vkxyz(i,3,BUCS) + ngabc(j,3)
             grvv = dsqrt(ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
                  &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)
             if(grvv <= gmaxs) then
                kk = kk + 1
                nbmat(kk,i) = j
             end if
          end do
       end if
       iba2(i) = kk
       if(iba2(i) < neg) then
          write(nfout,'(" iba2(",i4,") < neg = ",i4)') i,neg
          call phase_error_with_msg(nfout,' m_pwBS_mat_for_each_WF',__LINE__,__FILE__)
       end if
       if(k_symmetry(i) == GAMMA .or. k_symmetry(i) == GAMMA) then
          do j=1,iba2(i)
             nbmat2(j,i) = nbmat(j,i)
!!$             if(nbmat(j,i) == nbase_gamma(1,1)) nbmat2(j,i) = 1
!!$             if(nbmat2(j,i) == 0) then
!!$                do k=2, kg_gamma
!!$                   if(nbmat(j,i) == nbase_gamma(k,1)) then
!!$                      nbmat2(j,i) = nbase_gamma(k,1)
!!$                      exit
!!$                   else if(nbmat(j,i) == nbase_gamma(k,2)) then
!!$                      nbmat2(j,i) = nbase_gamma(k,2)
!!$                      exit
!!$                   end if
!!$                end do
!!$             end if
          end do
       else
          do j = 1, iba2(i)
             do k=1,iba(i)
                if(nbmat(j,i) == nbase(k,i)) then
                   nbmat2(j,i) = k
                   exit
                end if
             end do
          end do
       end if
       if(ipri >= 2) then
          ! --- nbmat, nbmat2 ---
          max_elements = iba2(i)
          icolumn = 10
          write(nfout,'(" !pwbs -- nbmat, nbase --")')
          write(nfout,'(" !pwbs k = ",i4," iba2= ",i6)') i,iba2(i)
          icycle = ceiling(dble(min(max_elements,iba2(i)))/icolumn)
          istart = 1
          do ic = 1, icycle
             iend = min(istart+icolumn-1,max_elements,iba2(i))
             if(ipri >= 3 .or. (ipri>=2 .and. (ic <= 3 .or. ic >= icycle-2))) then
                write(nfout,'(" ! nbmat  ",10i10)') (nbmat(ig,i),ig=istart,iend)
                write(nfout,'(" ! nbmat2 ",10i10)') (nbmat2(ig,i),ig=istart,iend)
             end if
             istart = iend+1
          end do

          ! --- nbase ---
!!$          max_elements = kg1_ext
          max_elements = iba(i)
          icolumn = 10
          write(nfout,'(" !pwbs -- nbase --")')
!!$          icycle = ceiling(dble(min(max_elements,kg1_ext))/icolumn)
          icycle = ceiling(dble(min(max_elements,iba(i)))/icolumn)
          istart = 1
          do ic = 1, icycle
!!$             iend = min(istart+icolumn-1,max_elements,kg1_ext)
             iend = min(istart+icolumn-1,max_elements,iba(i))
             if(ipri >= 2 .or. (ipri>=1 .and. (ic <= 3 .or. ic >= icycle-2))) then
                write(nfout,'(" ! nbase ",10i10)') (nbase(ig,i),ig=istart,iend)
             end if
             istart = iend+1
          end do

          ! --- nbase_gamma ---
          if(kg_gamma > 0 .and. (k_symmetry(i) == GAMMA .or. k_symmetry(i) == GAMMA_base_symmetrization)) then
             max_elements = kg_gamma
             icolumn = 6
             write(nfout,'(" !pwbs -- nbase_gamma --")')
             write(nfout,'(" !pwbs k = ",i4," kg_gamma = ",i6)') i,kg_gamma
             if(kg2_gamma > 0) write(nfout,'(" !pwbs kg2_gamma = ",i6)') kg2_gamma
             icycle = ceiling(dble(min(max_elements,kg_gamma))/icolumn)
             istart = 1
             do ic = 1, icycle
                iend = min(istart+icolumn-1,max_elements,kg_gamma)
                if(ipri >= 2 .or. (ipri>=1 .and. (ic <= 3 .or. ic >= icycle-2))) then
                   write(nfout,'(" !nbase_gamma1 (",i9,"-",i9,") ",6i10)') &
                        &  istart, iend, (nbase_gamma(ig,1),ig=istart,iend)
                   write(nfout,'(" !nbase_gamma2 (",i9,"-",i9,") ",6i10)') &
                        &  istart, iend, (nbase_gamma(ig,2),ig=istart,iend)
                end if
                istart = iend+1
             end do
          end if
       end if
    end do

    call tstatc0_end(id_sname)
  end subroutine m_pwBS_mat_for_each_WF
    
  recursive subroutine m_pwBS_for_each_WF(preallocation)
!   Revised on 19th September 2006 by T. Yamasaki
!      A finding algorism of nbase_gamma(*,2) is revised for the case that
!     ngshell_range_G's are not properly prepared.
    logical, intent(in)       :: preallocation

    integer :: jjt, i, jj, jj_gamma, j, n1, n2, n3, j2, jg, k, iloop &
         &   , j2s, j2e, jg1, jg2, kg_gamma_part, max_elements, icolumn, icycle &
         &   , istart, ic, iend, ig, idelta
    real(kind=DP)    :: ga,gb,gc, grvv, grvt, grvmx, length_start, length
    logical :: found
    integer, allocatable, dimension(:)   :: ngshell_range_G !d(ngshell_GAMMA)
    integer, allocatable, dimension(:)   :: ngbshell !d(kg0)
    integer, parameter :: CRITICAL_VECTOR_LENGTH = 10000

    integer          :: id_sname = -1
                                                     __TIMER_SUB_START(1221)
    call tstatc0_begin('m_pwBS_for_each_WF ',id_sname)

    if(ipri >= 2) then
       if(     preallocation) write(nfout,*) ' ! preallocation = .true.'
       if(.not.preallocation) write(nfout,*) ' ! preallocation = .false.'
    end if

    if(allocated(iba))then
       if(ipri >= 3) write(nfout,'(" iba is allocated <<m_pwBS_for_each_WF>>")')
    else
       if(ipri >= 3) write(nfout,'(" iba is not allocated <<m_pwBS_for_each_WF>>")')
    end if

    call alloc_iba()
    if(.not.preallocation) then
       !!$call alloc_iba()
       if(kg1_ext == 0) call m_pwBS_for_each_WF(.true.)
       call alloc_nbase()
!!$       write(6,'(" alloc_nbase")')
    else
!!$       write(6,'(" alloc_nbase is not called")')
    end if

    if(preallocation .and. ipri >= 1) write(nfout,'(/" <<< m_pwBS_for_each_WF >>>")')

    call getttr(rltv,ttr)

    if(preallocation) kg1_ext = 0; if(preallocation) nbmx = 0
    if(preallocation) kg1 = 0;

    if(preallocation) then
       jjt = 0
       grvt = 0.d0
    else if(.not.preallocation) then
       nbase = 0
    end if

    do i = 1, kv3
       if(k_symmetry(i) == GAMMA .or. k_symmetry(i) == GAMMA_base_symmetrization) then
          if(preallocation) then
             grvmx = 0.d0
             ngshell_GAMMA = 1
             length_start = 0.d0
             jj_gamma = 0
!CDIR NOVECTOR
             g_search_loop:do j = 1, kg0
                n1 = ngabc(j,1)
                n2 = ngabc(j,2)
                n3 = ngabc(j,3)
                grvv = dsqrt(ttr(1)*n1*n1 + ttr(2)*n2*n2 + ttr(3)*n3*n3 &
                     &   +   ttr(4)*n1*n2 + ttr(5)*n2*n3 + ttr(6)*n3*n1)
!!$                grvv = ( ttr(1)*n1*n1 + ttr(2)*n2*n2 + ttr(3)*n3*n3 &
!!$                     & + ttr(4)*n1*n2 + ttr(5)*n2*n3 + ttr(6)*n3*n1)
                if(grvv > length_start + DELTA10) then
!!$                if(grvv > length_start + DELTA07) then
                   ngshell_GAMMA = ngshell_GAMMA+1
                   length_start = grvv
                end if
                if(grvv > grvmx) grvmx=grvv
                if(n3 >  SmallestPositiveNumber) then
                   jj_gamma = jj_gamma + 1
                else if(n3 == 0) then
                   if((n1 >= 0 .and. n2 >= 0 ) .or. (n1 < 0 .and. n2 > 0)) then
                      jj_gamma = jj_gamma + 1
                   end if
                end if
             end do g_search_loop
!!$             grvmx = dsqrt(grvmx)

             if(ipri >= 1 ) write(nfout,'(" !pwbs ngshell_GAMMA = ",i8)') ngshell_GAMMA
             jj = kg0
!!$             kg_gamma = jj_gamma
             kg_gamma = (kg0+1)/2

             if(nbmx < kg0) nbmx = kg0
             iba(i) = kg0
             if(ipri >= 1) write(nfout,'(" !# iba(",i4,") = ",i8," (preallocation)<<m_pwBS_for_each_WF>>")')&
                  & i, iba(i)
          else if(.not.preallocation) then
             allocate(ngshell_range_G(ngshell_GAMMA))
             allocate(ngbshell(kg0))
             jj = 0
             jg = 1
             ngshell_range_G(jg) = 1
             length_start = 0.d0
             g_search_loop2:do j = 1, kg0
                n1 = ngabc(j,1)
                n2 = ngabc(j,2)
                n3 = ngabc(j,3)
                grvv = dsqrt(ttr(1)*n1*n1 + ttr(2)*n2*n2 + ttr(3)*n3*n3 &
                     &   +   ttr(4)*n1*n2 + ttr(5)*n2*n3 + ttr(6)*n3*n1)
                nbase(j,i)=j
                if(grvv > length_start + DELTA10) then
!!$                if(grvv > length_start + DELTA07) then
                   jg = jg+1
                   ngshell_range_G(jg) = j
                   length_start = grvv
                end if
                ngbshell(j) = jg
                if(n3 >  SmallestPositiveNumber) then
                   jj = jj + 1
                   nbase_gamma(jj,1) = j
                else if(n3 == 0) then
                   if((n1 >= 0 .and. n2 >= 0 ) .or. (n1 < 0 .and. n2 > 0)) then
                      jj = jj + 1
                      nbase_gamma(jj,1) = j
                   end if
                end if
             end do g_search_loop2

             do j = 1, ngshell_GAMMA-1
                if(ngshell_range_G(j+1) < ngshell_range_G(j)) then
                   write(nfout,'("!! ngshell_range order illegal <<m_pwBS_for_each_WF>>")')
                   write(nfout,'("!! j = ",i5," ngshell_range_G(j+1), ngshell_range_G(j) = ",2i8)') &
                        & ngshell_range_G(j+1), ngshell_range_G(j)
                   call phase_error_with_msg(nfout,' ngshell_range_G order is illegl << m_pwBS_for_each_WF>>', &
                   __LINE__,__FILE__)
                end if
             end do
             if(ipri >= 1) call wd_ngshell_range()

             kg_gamma_part = ceiling(dble(kg_gamma)/npes)
             if(kg_gamma_part > CRITICAL_VECTOR_LENGTH) then
                if(kg_gamma_part == 0) kg_gamma_part = 1
                jg1 = kg_gamma_part*mype + 1
                jg2 = kg_gamma_part*(mype+1)
                if(jg2 > kg_gamma) jg2 = kg_gamma
                if(ipri >= 2) write(nfout,'(" !pwBS jg1, jg2 = ", 2i5)') jg1, jg2
             else
                jg1 = 1; jg2 = kg_gamma
             end if

             nbase_gamma(1:kg_gamma,2) = 0
             if(jg1 == 1) then
                nbase_gamma(1,2) = -1
                jg1 = 2
             end if
             do jg = jg1, jg2
                j = nbase_gamma(jg,1)
                k = ngbshell(j)
                n1 = ngabc(j,1); n2 = ngabc(j,2); n3 = ngabc(j,3)
                j2s = ngshell_range_G(k)
                if(k<=ngshell_GAMMA-1) then; j2e = ngshell_range_G(k+1)-1; else; j2e = iba(i); end if ! j2e
                   idelta = 0
1003               found = .false.
                G_search: do j2 = j2s, j2e
                   if(ngabc(j2,1) == -n1 .and. ngabc(j2,2) == -n2 .and. ngabc(j2,3) == -n3) then
                      nbase_gamma(jg,2) = j2
                      if(j2 == j) nbase_gamma(jg,2) = -1
                      found = .true.
                      exit G_search
                   end if
                end do G_search
                if(.not.found) then
                   idelta = idelta + 1
                   if(k-idelta >= 1) then
                      j2s = ngshell_range_G(k-idelta)
                   else
                      j2s = 1
                   end if
                   if(k+idelta <= ngshell_GAMMA-1) then
                      j2e = ngshell_range_G(k+idelta+1)-1
                   else
                      j2e = iba(i)
                   end if
                   goto 1003
                end if
             end do
             if(npes > 1) then
                if(kg_gamma_part > CRITICAL_VECTOR_LENGTH) then
                   call mpi_allreduce(nbase_gamma(1:kg_gamma,2),ngbshell,kg_gamma,mpi_integer,mpi_sum,mpi_comm_group,ierr)
                   nbase_gamma(1:kg_gamma,2) = ngbshell(1:kg_gamma)
                end if
             end if

             if(k_symmetry(i) == GAMMA) then
                do jg = 1, kg_gamma
                   nbase(jg,i) = nbase_gamma(jg,1)
                end do
                do jg = kg_gamma+1, kg1_ext
                   nbase(jg,i) = 0
                end do
                iba(i) = kg_gamma
             end if
             deallocate(ngbshell,ngshell_range_G)
          end if
          if(k_symmetry(i) == GAMMA) then
             if(preallocation .and. kg_gamma > kg1 ) kg1 = kg_gamma
          else
!!$             if(preallocation .and. jj > kg1) kg1 = jj
             if(preallocation .and. kg0 > kg1) kg1 = kg0
          end if
       else
          if(preallocation) grvmx = 0.d0
          jj = 0
          do j = 1, kg
             ga = vkxyz(i,1,BUCS) + ngabc(j,1)
             gb = vkxyz(i,2,BUCS) + ngabc(j,2)
             gc = vkxyz(i,3,BUCS) + ngabc(j,3)
             grvv = dsqrt(ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
                  &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)
             if(grvv <= gmax) then
                jj = jj + 1
                if(preallocation .and. nbmx < j ) nbmx = j
                if(preallocation) then
                   if(grvv > grvmx) grvmx=grvv
                end if

! ===== KT_mod ===================== 13.0S [OK??]
!
!  The values of vkxyz when prealloc=true are different
!  from those values when prealloc=false
!                     ( see Preparation.F90, ekmode=on )
!
!  Thus, "jj" (when prealloc=false) may be over "kg1_ext" set when prealloc=true.
!
! ------------------------------
!                if(.not.preallocation) nbase(jj,i)=j
                if(.not.preallocation) then
                   if ( jj <= kg1_ext ) nbase(jj,i)=j
                endif
! ================================== 13.0S

             end if
          enddo
          if(preallocation) then
             if(jj > kg1) kg1 = jj
             iba(i) = jj
             jjt    = jjt + jj
             grvt   = grvt + grvmx*qwgt(i)
          end if
       end if

       if(ipri >= 3) then
          if(preallocation) then
             write(nfout,'(" !# K= ",i4," iba= ",i6," GRV= ",F12.8)') i,iba(i),grvmx
          else
             write(nfout,'(" !# K= ",i4," iba= ",i6," nbase(",i6,",",i4,")= ",i7)') &
                  & i,iba(i),iba(i),i,nbase(iba(i),i)
             if(iba(i) > kg1_ext) then
                write(nfout,'(" ! iba(",i3,") > kg1_ext (= ",i9)') i,kg1_ext
                call phase_error_with_msg(nfout,' iba(i) > kg1_ext <<m_pwBS_for_each_WF>>',__LINE__,__FILE__)
             else if(iba(i) == 0) then
                write(nfout,'(" ! iba(",i3,") = ",i6)') i,iba(i)
                call phase_error_with_msg(nfout,' iba(i) == 0 <<m_pwBS_for_each_WF>>',__LINE__,__FILE__)
             end if
             if(ipri >= 2) then
                if(kg_gamma > 0 .and.(k_symmetry(i) == GAMMA &
                     &              .or. k_symmetry(i) == GAMMA_base_symmetrization)) then
                   max_elements = kg_gamma
                   icolumn = 10
                   write(nfout,'(" !pwbs -- nbase_gamma --")')
                   write(nfout,'(" !pwbs k = ",i4," kg_gamma = ",i6)') i,kg_gamma
                   if(kg2_gamma > 0) write(nfout,'(" !pwbs kg2_gamma = ",i6)') kg2_gamma
                   icycle = ceiling(dble(min(max_elements,kg_gamma))/icolumn)
                   istart = 1
                   do ic = 1, icycle
                      iend = min(istart+icolumn-1,max_elements,kg_gamma)
                      if(ipri >= 2 .or. (ipri>=1 .and. (ic <= 3 .or. ic >= icycle-2))) then
                         write(nfout,'(" ! nbase_gamma 1 ",10i10)') (nbase_gamma(ig,1),ig=istart,iend)
                         write(nfout,'(" ! nbase_g1 (nx) ",10i10)') (ngabc(nbase_gamma(ig,1),1),ig=istart,iend)
                         write(nfout,'(" ! nbase_g1 (ny) ",10i10)') (ngabc(nbase_gamma(ig,1),2),ig=istart,iend)
                         write(nfout,'(" ! nbase_g1 (nz) ",10i10)') (ngabc(nbase_gamma(ig,1),3),ig=istart,iend)
                         write(nfout,'(" ! nbase_gamma 2 ",10i10)') (nbase_gamma(ig,2),ig=istart,iend)
                         write(nfout,'(" ! nbase_g2 (nx) ",10i10)') (ngabc(nbase_gamma(ig,2),1),ig=istart,iend)
                         write(nfout,'(" ! nbase_g2 (ny) ",10i10)') (ngabc(nbase_gamma(ig,2),2),ig=istart,iend)
                         write(nfout,'(" ! nbase_g2 (nz) ",10i10)') (ngabc(nbase_gamma(ig,2),3),ig=istart,iend)
                      end if
                      istart = iend+1
                   end do
                end if
             end if
          end if
       end if
       if(preallocation .and. jj > kg1_ext ) kg1_ext = jj
    end do ! k-point loop

    if(.not.preallocation) then
       if(kg1 < kg1_ext) then
          call reduce_nbase()
       end if
    end if

    if(ipri >= 1) then
       if(preallocation) then
          write(nfout,130) kg1_ext,kg1,nbmx
          write(nfout,140) jjt,grvt
          write(nfout,'(" !# pwbs kg_gamma = ",i8)') kg_gamma
130       format(' ','!# ** kg1_ext, kg1, nbmx (=matrix size) = ',3i8)
140       format(' ','!#  JJT(=sum(iba)) = ',I8,' MEAN GRV = ',f12.8)
          write(nfout,*)
       else
          if(ipri >= 2 .or. (ipri>=1 .and. kv3 <=10)) then
             do i = 1, kv3
                write(nfout,'(" ! iba(",i6,") = ",i6,",  nbase(",i6,",",i6,") = ",i7)') i, iba(i),iba(i),i,nbase(iba(i),i)
             end do
          else
             if(kv3 > 10) then
                do iloop = 1, 2
                   do i = (kv3-4)*(iloop-1)+1, (kv3-4)*(iloop-1)+4
                      write(nfout,'(" ! iba(",i6,") = ",i6,",  nbase(",i6,",",i6,") = ",i7)') i, iba(i),iba(i),i,nbase(iba(i),i)
                   end do
                   if(iloop == 1) write(nfout,'(" ! ......")')
                end do
             end if
          end if
       end if
    end if

    call tstatc0_end(id_sname)
                                                     __TIMER_SUB_STOP(1221)
  contains
    subroutine wd_ngshell_range
      integer :: jg, j,n1,n2,n3
      real(kind=DP) :: gr1, gr2

      write(nfout,'(" !pwbs ngshell_range_G")') 
      write(nfout,'(" !pwbs  ngshell_G, range1 - range2, nelement, gr1, gr2")')
      do jg = 1, ngshell_GAMMA
         if(ipri >= 2 .or.&
              & (ipri==1 .and. (jg <= 5 .or. jg >= ngshell_GAMMA - 4))) then
            j = ngshell_range_G(jg)
            n1 = ngabc(j,1);  n2 = ngabc(j,2);  n3 = ngabc(j,3)
            gr1 = dsqrt(ttr(1)*n1*n1 + ttr(2)*n2*n2 + ttr(3)*n3*n3 &
                 &  +   ttr(4)*n1*n2 + ttr(5)*n2*n3 + ttr(6)*n3*n1)
            if(jg == ngshell_GAMMA) then
               j = iba(i)
            else
               j = ngshell_range_G(jg+1)-1
            end if
            n1 = ngabc(j,1);  n2 = ngabc(j,2);  n3 = ngabc(j,3)
            gr2 = dsqrt(ttr(1)*n1*n1 + ttr(2)*n2*n2 + ttr(3)*n3*n3 &
                 &  +   ttr(4)*n1*n2 + ttr(5)*n2*n3 + ttr(6)*n3*n1)
            write(nfout,'(" !pwbs ",i8, " [",i8," : ",i8," ] ", i8, 2f20.8)') &
                 & jg, ngshell_range_G(jg),j &
                 & ,j-ngshell_range_G(jg)+1,gr1, gr2
         else if(ipri == 1 .and. jg == 6) then
            write(nfout,'(" !pwbs  ..........")')
         end if
      end do
      if(ipri >= 3) then
         write(nfout,'(" !pwBS -- ngbshell --")')
         write(nfout,'(5("(",i8,i6,")"))') (j,ngbshell(j),j=1,iba(i))
      end if
    end subroutine wd_ngshell_range
  end subroutine m_pwBS_for_each_WF

  ! ------- Positron start
  recursive subroutine m_pwBS_positronWF()

    integer          :: j
    real(kind=DP)    :: ga,gb,gc, grvv
    integer          :: id_sname = -1
    call tstatc0_begin('m_pwBS_positronWF ',id_sname)


    call getttr(rltv,ttr)

    kg1_pwf = 0

    do j = 1, kg_pwf
       ga = ngabc(j,1)
       gb = ngabc(j,2)
       gc = ngabc(j,3)
       grvv = dsqrt(ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &     + ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga )
       if(grvv <= gmax_positron) then
          kg1_pwf = kg1_pwf + 1
       end if
    enddo

    if(ipri>=1) write(nfout,'(" !pwbs kg1_pwf = ",i7)') kg1_pwf
    call tstatc0_end(id_sname)
  end subroutine m_pwBS_positronWF
  ! ------- Positron end

! =================== KT_add ====================== 13.0F
  recursive subroutine m_pwBS_exxWF()

    integer          :: j
    real(kind=DP)    :: ga,gb,gc, grvv
    integer          :: id_sname = -1
    call tstatc0_begin('m_pwBS_exxWF ',id_sname)

    call getttr(rltv,ttr)
    kg1_exx = 0

    do j = 1, kg_exx
       ga = ngabc(j,1);    gb = ngabc(j,2);    gc = ngabc(j,3)
       grvv = dsqrt(ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &     + ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga )
       if(grvv <= gmax_exx) then
          kg1_exx = kg1_exx + 1
       end if
    enddo

    if(ipri>=1) write(nfout,'(" !pwbs kg1_exx = ",i7)') kg1_exx
    call tstatc0_end(id_sname)

  end subroutine m_pwBS_exxWF

  recursive subroutine m_pwBS_exxCD()

    integer          :: j
    real(kind=DP)    :: ga,gb,gc, grvv
    integer          :: id_sname = -1
    call tstatc0_begin('m_pwBS_exxCD ',id_sname)

    call getttr(rltv,ttr)
    kg1p_exx = 0

    do j = 1, kgp_exx
       ga = ngabc(j,1);    gb = ngabc(j,2);    gc = ngabc(j,3)
       grvv = dsqrt(ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &     + ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga )
       if(grvv <= gmaxp_exx) then
          kg1p_exx = kg1p_exx + 1
       end if
    enddo

    if(ipri>=1) write(nfout,'(" !pwbs kg1p_exx = ",i7)') kg1p_exx
    call tstatc0_end(id_sname)

  end subroutine m_pwBS_exxCD

! ================================================ 13.0F

  subroutine m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
    integer, intent(in) ::       n_matrix_size
    real(kind=DP), intent(in) :: gmaxs_given

    real(kind=DP)    :: grvv,ga,gb,gc
    integer          :: negg,i,j,kk,nmatsz_min,counter

!!$    if(intzaj == by_matrix_diagon) then
       call check_gmax(gmaxs_given)
       gmaxs = gmaxs_given
       if(gmaxs < SmallestPositiveNumber*1.d5 .and. n_matrix_size == 0) then
          if(kg < 15000) then
             negg = kg/15
          else if(neg < 1000) then
             negg = 1000
          else
             negg = neg
          end if
          if(negg < neg) negg = neg+20
          gmaxs = 2.05*gmax*(dble(neg)/dble(kg))**(1.d0/3.d0)
          if(printable) write(nfout,*) ' ! Both gmaxs and n_matrix_size were not given'
       else if(n_matrix_size > 0) then
          if(n_matrix_size < neg) then
             negg = neg + 20
          else
             negg = n_matrix_size
          end if
          gmaxs = 2.05*gmax*(dble(neg)/dble(kg))**(1.d0/3.d0)
          if(printable) write(nfout,*) ' ! n_matrix_size is given'
       else
          negg = kg * (gmaxs/(2.05*gmax))**3
          if(negg < neg) then
             negg = neg + 20
          end if
!!$          write(6,*) ' ! gmaxs is given'
       end if
!!$       write(nfout,'(" ! negg  = ",i8)') negg
!!$       write(nfout,'(" ! gmaxs = ",f8.4)') gmaxs

       counter = 0
1      nmatsz = 0
       nmatsz_min = kg
       n_rGsv = 0
       counter = counter+1
       do i = 1, kv3
          kk = 0
          do j = 1, kg
             ga = vkxyz(i,1,BUCS) + ngabc(j,1)
             gb = vkxyz(i,2,BUCS) + ngabc(j,2)
             gc = vkxyz(i,3,BUCS) + ngabc(j,3)
             grvv = dsqrt(ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
                  &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)
             if(grvv <= gmaxs) then
                kk = kk + 1
                if(n_rGsv(1) < abs(ngabc(j,1))) n_rGsv(1) = abs(ngabc(j,1))
                if(n_rGsv(2) < abs(ngabc(j,2))) n_rGsv(2) = abs(ngabc(j,2))
                if(n_rGsv(3) < abs(ngabc(j,3))) n_rGsv(3) = abs(ngabc(j,3))
             end if
          end do
          if(kk > nmatsz) nmatsz = kk
          if(kk < nmatsz_min) nmatsz_min = kk
!!$          if(nmatsz_min < neg) exit
       end do
!!$       if(nmatsz < negg) then

!!$       write(nfout,'(" ! negg = ",i8," kg = ",i8)') negg,kg
       if(ipri >= 1) then
          write(nfout,'(" ! nmatsz = ",i8," nmatsz_min = ",i8)') nmatsz, nmatsz_min
          write(nfout,'(" ! gmaxs = ",f20.8)') gmaxs
       end if
       if(nmatsz_min < negg) then
          gmaxs = gmaxs*1.05
          if(ipri >= 1) then
             write(nfout,'(" ---- trial ",i4," ----")') counter
             write(nfout,'(" ! gmaxs is enlarged")')
          end if
          goto 1
       end if

       if(gmaxs > gmax) then
          if(ipri >= 1) write(nfout,'(" gmaxs(=",f10.4,") > gmax(=",f10.4,")")') gmaxs,gmax
          gmaxs = gmax
          if(ipri >= 1) write(nfout,'(" gmaxs is set gmax")')
       end if
       n_rGsv = 2*n_rGsv
       if(ipri >= 1) then
          write(nfout,'(" n_rGsv(1:3) = ",3i8)') n_rGsv(1:3)
          write(nfout,'(" nmatsz (m_pwBS_set_gmaxs) = ",i8)') nmatsz
       end if

  contains
    subroutine check_gmax(givenvalue)
      real(kind=DP),intent(in) :: givenvalue
      if(givenvalue < SmallestPositiveNumber*1.d5) then
         if(printable) write(nfout,'(" gmax_given is not given")')
!!$         stop ' illegal value of gmax (m_pwBS_set_gmaxs)'
      end if
    end subroutine check_gmax
  end subroutine m_pwBS_set_gmaxs

  subroutine m_pwBS_assume_G_rhombohedron
    real(kind=DP)   :: gmax2, gmax2_pstrn

! ============== KT_add ============================= 13.0F
    real(kind=DP)   :: gmax2_exx
! =================================================== 13.0F

    gmax2 = gmax*2
    call size_of_Gvector_rhombohedron  ! ->n_rGv, n_rGpv
    if(ipri >=1) call check_the_size_of_rhombohedron
  contains
    subroutine size_of_Gvector_rhombohedron
      integer i
      real(kind=DP)   :: alen
      do i = 1, 3
         alen = ( rltv(1,i)*altv(1,i) + rltv(2,i)*altv(2,i) + rltv(3,i)*altv(3,i) ) &
              & /dsqrt(altv(1,i)*altv(1,i) + altv(2,i)*altv(2,i) + altv(3,i)*altv(3,i))
         n_rGv(i)  = abs(int(gmax2/alen)) + 1
         n_rGpv(i) = abs(int(gmaxp/alen)) + 1
         n_rGpv_reduced(i) = abs(int(gmaxp_reduced/alen)) + 1
  ! ------- Positron start
         if(sw_positron /= OFF) then
            gmax2_pstrn = gmax_positron * 2
            n_rGv_pstrn(i) = abs(int(gmax2_pstrn/alen)) + 1
         end if
  ! ------- Positron end

! ============== KT_add ============================= 13.0F
         if ( sw_hybrid_functional /= OFF .and. use_fft_exx ) then
            gmax2_exx = gmax_exx * 2
            n_rGv_exx(i) = abs(int(gmax2_exx/alen)) + 1
         end if
         if ( sw_hybrid_functional /= OFF ) then
            n_rGpv_exx(i) = abs(int(gmaxp_exx/alen)) + 1
         endif
! =================================================== 13.0F

      enddo
    end subroutine size_of_Gvector_rhombohedron

    subroutine check_the_size_of_rhombohedron
      
      integer, dimension(3) :: kmax = (/0,0,0/), kmaxp = (/0,0,0/)
      real(kind=DP)         :: length_of_G
      integer i, j, k

      if(ipri >= 1) call wd_n_rGv_and_n_rGpv
      call getttr(rltv,ttr)
      Kloop: do k = - n_rGpv(3), n_rGpv(3)
         Jloop: do j = - n_rGpv(2), n_rGpv(2)
            Iloop: do i = - n_rGpv(1), n_rGpv(1)
               length_of_G = dsqrt(ttr(1)*i*i + ttr(2)*j*j + ttr(3)*k*k &
                    &            +      ttr(4)*i*j + ttr(5)*j*k + ttr(6)*k*i )
               if(length_of_G <= gmax2) then
                  if(kmax(1) < abs(i)) kmax(1) = abs(i)
                  if(kmax(2) < abs(j)) kmax(2) = abs(j)
                  if(kmax(3) < abs(k)) kmax(3) = abs(k)
               else if(length_of_G <= gmaxp) then
                  if(kmaxp(1) < abs(i)) kmaxp(1) = abs(i)
                  if(kmaxp(2) < abs(j)) kmaxp(2) = abs(j)
                  if(kmaxp(3) < abs(k)) kmaxp(3) = abs(k)
               endif
            enddo Iloop
         enddo Jloop
      enddo Kloop

      do i = 1, 3
         kmaxp(i) = max(kmax(i),kmaxp(i))
         kmax(i)  = kmax(i) + 1
         kmaxp(i) = kmaxp(i) + 1
      enddo

    end subroutine check_the_size_of_rhombohedron

    subroutine wd_n_rGv_and_n_rGpv
      if(ipri >= 1) then
         write(nfout,*) ' ! Size of rhombohedrons which contain spheres of G_vectors being smaller than gmax and gmaxp'
         write(nfout,110) n_rGv(1), n_rGv(2), n_rGv(3)
         write(nfout,111) n_rGpv(1), n_rGpv(2), n_rGpv(3)
         write(nfout,112) n_rGpv_reduced(1:3)
      end if
110   FORMAT(' ',' KNX ,KNY ,KNZ  = ',3I6)
111   FORMAT(' ',' KNXP,KNYP,KNZP = ',3I6)
112   format(' ',' knxp_reduced, knyp_reduced, knzp_reduced = ',3i6)
      if(sw_positron /= OFF .and. ipri >= 1) &
           & write(nfout,'("  knx, kny, knz (positron) = ",3i6)') n_rGv_pstrn(1:3)
    end subroutine wd_n_rGv_and_n_rGpv
  end subroutine m_pwBS_assume_G_rhombohedron



  
  subroutine m_pwBS_GminusGmapfunction()
    integer :: i,igf1,igf2,igf3
    igpo = 0
    nmatsz2 = 0
    do i = 1, kg
       igf1 = ngabc(i,1); igf2 = ngabc(i,2); igf3 = ngabc(i,3)
       if(          igf1 >= -n_rGsv(1) .and. igf1 <= n_rGsv(1) &
            & .and. igf2 >= -n_rGsv(2) .and. igf2 <= n_rGsv(2) &
            & .and. igf3 >= -n_rGsv(3) .and. igf3 <= n_rGsv(3)) then
          igpo(igf1,igf2,igf3) = i
          nmatsz2 = i
       end if
    end do
    if(ipri >= 2) write(nfout,'(" !pwbs nmatsz2 = ",i8 &
         &                ," <<m_pwBS_GminusGmapfunction>>")') nmatsz2
  end subroutine m_pwBS_GminusGmapfunction

  subroutine decide_g_list_size(nfout, mmdim1, mmdim2, mmdim3)
    integer, intent(in)   :: nfout
    integer, intent(out)  :: mmdim1, mmdim2, mmdim3
    mmdim1 = 2*n_rGpv(1)
    mmdim2 = 2*n_rGpv(2)
    mmdim3 = 2*n_rGpv(3)
    if(ipri>=1) then
       write(nfout,*) ' n_rGpv = ', n_rGpv
       write(nfout,*) ' mmdim  = ', mmdim1, mmdim2, mmdim3
    end if
  end subroutine decide_g_list_size
  


  subroutine m_pwBS_sphrp2(is,rltv,ista_ylm,iend_ylm,ylm)
    integer, intent(in) :: is
    real(kind=DP), intent(in), dimension(3,3)  :: rltv
    integer, intent(in) :: ista_ylm, iend_ylm
    real(kind=DP), intent(inout), dimension(ista_ylm:iend_ylm) :: ylm
!!$C spherical harmonics.
!!$c     Some lines are rewritten by T.Yamasaki according to Y.Morikawa's
!!$c   e-mail. at 4th May 1994

    integer :: i,ni
    real(kind=DP) a,b,c,d,e,f,gx,gy,gz
    real(kind=DP) b1x,b1y,b1z,b2x,b2y,b2z,b3x,b3y,b3z

    b1x = rltv(1,1);  b1y = rltv(2,1);  b1z = rltv(3,1)
    b2x = rltv(1,2);  b2y = rltv(2,2);  b2z = rltv(3,2)
    b3x = rltv(1,3);  b3y = rltv(2,3);  b3z = rltv(3,3)

    ni = ista_ylm
    if(ngabc(1,1) == 0 .and. ngabc(1,2) == 0 .and. ngabc(1,3) == 0) then
       if(ni == 1) then
          ni = 2
          ylm(1) = dsqrt(1.d0/PAI4)
       endif
    end if
    if(is == 1) then
       a = dsqrt(1.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          ylm(i) = a
       end do
    else if(is == 2) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          ylm(i) = a*gx/gr_l(i)
       end do
    else if(is == 3) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gy =   b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          ylm(i) = a*gy/gr_l(i)
       end do
    else if(is == 4) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gz =   b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          ylm(i) = a*gz/gr_l(i)
       end do
    else if(is == 5) then
       a = dsqrt(5.d0/(16*PAI))
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          d = gz**2
          e = gx**2+gy**2+d
          ylm(i) = a*(3*d-e)/e
       end do
    else if(is == 6) then
       a = dsqrt(15.d0/(16*PAI))
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          e = b+c+gz**2
          ylm(i) = a*(b-c)/e
       end do
    else if(is == 7) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          e = gr_l(i)**2
          ylm(i) = a*gx*gy/e
       end do
    else if(is == 8) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          e = gr_l(i)**2
          ylm(i) = a*gy*gz/e
       end do
    else if(is == 9) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          e = gr_l(i)**2
          ylm(i) = a*gz*gx/e
       end do
    else if(is == 10) then
       a = dsqrt(7.d0/(16*PAI))
       do i = ni, iend_ylm  !for mpi
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e * gr_l(i)
          ylm(i) = a*gz*(5*d-3*e)/f
       end do
    else if(is == 11) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ni, iend_ylm  !for mpi
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e * gr_l(i)
          ylm(i) = a*gx*(5*d-e)/f
       end do
    else if(is == 12) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ni, iend_ylm  !for mpi
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e * gr_l(i)
          ylm(i) = a*gy*(5*d-e)/f
       end do
    else if(is == 13) then
       a = dsqrt(105.d0/(16*PAI))
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          e = gr_l(i)**2
          f = e * gr_l(i)
          ylm(i) = a*gz*(b-c)/f
       end do
    else if(is == 14) then
       a = dsqrt(105.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          f = gr_l(i)**3
          ylm(i) = a*gx*gy*gz/f
       end do
    else if(is == 15) then
       a = dsqrt(35.d0/(32*PAI))
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          f = gr_l(i)**3
          ylm(i) = a*gx*(b-3*c)/f
       end do
    else if(is == 16) then
       a = dsqrt(35.d0/(32*pai))
       do i = ni, iend_ylm !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          f = gr_l(i)**3
          ylm(i) = a*gy*(3*b-c)/f
       end do
    else if(is == 17) then
       a = 3.d0/8.d0/dsqrt(PAI4)
       do i = ni, iend_ylm  !for mpi
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e**2
          ylm(i) = a*(5*d*(7*d-6*e)/f+3.d0)
       end do
    else if(is == 18) then
       a = 15.d0/4.d0/dsqrt(10*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e**2
          ylm(i) = a*gz*gx*(7*d-3*e)/f
       end do
    else if(is == 19) then
       a = 15.d0/4.d0/dsqrt(10.d0*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e**2
          ylm(i) = a*gy*gz*(7*d-3*e)/f
       end do
    else if(is == 20) then
       a = 15.d0/8.d0/dsqrt(5*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b+c+d
          f = e**2
          ylm(i) = a*(7*d-e)*(b-c)/f
       end do
    else if(is == 21) then
       a = 15.d0/4.d0/dsqrt(5*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e**2
          ylm(i) = a*(7*d-e)*gx*gy/f
       end do
    else if(is == 22) then
       a = 105.d0/4.d0/dsqrt(70*pai)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
          ylm(i) = a*(b-3*c)*gz*gx/f
       end do
    else if(is == 23) then
       a = 105.d0/4.d0/dsqrt(70*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
          ylm(i) = a*(3.d0*b-c)*gy*gz/f
       end do
    else if(is == 24) then
       a = 105.d0/16.d0/dsqrt(35*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
          ylm(i) = a*((b-c)**2-4*b*c)/f
       end do
    else if(is == 25) then
       a = 105.d0/4.d0/dsqrt(35*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
          ylm(i) = a*(b-c)*gx*gy/f
       end do
    end if
  end subroutine m_pwBS_sphrp2


! === necessary to make 3D_Parallel, too!!! by tkato ===========================
!!BRANCH_P ORG_Parallel
! ==============================================================================
  subroutine m_pwBS_kinetic_energies(ik,vkxyz,ekin)
    use m_Parallelization,only: np_g1k , ista_g1k
    integer, intent(in)       :: ik
    real(kind=DP), intent(in) :: vkxyz(kv3,3,CRDTYP)
    real(kind=DP), intent(out):: ekin(np_g1k(ik))

    integer i, nb
    real(kind=DP) :: ga,gb,gc
    integer       :: id_sname = -1
    call tstatc0_begin('m_pwBS_kinetic_energies ',id_sname)
    call getttr(rltv,ttr)

    do i= 1, np_g1k(ik)
       nb = nbase(i+ista_g1k(ik)-1,ik)
       ga = vkxyz(ik,1,BUCS) + ngabc(nb,1)
       gb = vkxyz(ik,2,BUCS) + ngabc(nb,2)
       gc = vkxyz(ik,3,BUCS) + ngabc(nb,3)
       ekin(i) = ( ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &  +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)*0.5d0
    end do
    call tstatc0_end(id_sname)
  end subroutine m_pwBS_kinetic_energies
! === necessary to make 3D_Parallel, too!!! by tkato ===========================
!!BRANCH_P_END ORG_Parallel
! ==============================================================================

  ! ------- Positron start
  subroutine m_pwBS_pstrn_kinetic_energies(ekin)
    real(kind=DP), intent(out):: ekin(kg1_pwf)

    integer i, nb
    real(kind=DP) :: ga,gb,gc
    integer       :: id_sname = -1
    call tstatc0_begin('m_pwBS_pstrn_kinetic_energies ',id_sname)
    call getttr(rltv,ttr)

    do i = 1, kg1_pwf
       nb = i
       ga = ngabc(nb,1)
       gb = ngabc(nb,2)
       gc = ngabc(nb,3)
       ekin(i) = ( ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &  +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)*0.5d0
    end do
    call tstatc0_end(id_sname)
  end subroutine m_pwBS_pstrn_kinetic_energies
  ! ------- Positron end

  subroutine m_pwBS_find_min_max_G(nfout,nspin,ng_max,ng_min,n_max,n_min)
    integer, intent(in)    :: nfout,nspin
    integer, intent(inout) :: ng_max, ng_min
    integer, intent(out)   :: n_max(3),n_min(3)

    integer             :: nb, ik, i

    if(ng_max == 0 .and. ng_min == 0) then
       nb = nbase(1,1)
       ng_max=max(ngabc(nb,1),ngabc(nb,2),ngabc(nb,3))
       ng_min=min(ngabc(nb,1),ngabc(nb,2),ngabc(nb,3))

       n_max(1)=ngabc(nb,1); n_max(2)=ngabc(nb,2); n_max(3)=ngabc(nb,3)
       n_min(1)=ngabc(nb,1); n_min(2)=ngabc(nb,2); n_min(3)=ngabc(nb,3)
       do ik = 1, kv3, nspin
          do i=1,iba(ik)
             nb = nbase(i,ik)
             ng_max=max(ng_max,ngabc(nb,1),ngabc(nb,2),ngabc(nb,3))
             ng_min=min(ng_min,ngabc(nb,1),ngabc(nb,2),ngabc(nb,3))
             n_max(1) = max(n_max(1), ngabc(nb,1))
             n_max(2) = max(n_max(2), ngabc(nb,2))
             n_max(3) = max(n_max(3), ngabc(nb,3))
             n_min(1) = min(n_min(1), ngabc(nb,1))
             n_min(2) = min(n_min(2), ngabc(nb,2))
             n_min(3) = min(n_min(3), ngabc(nb,3))
          end do
       end do
       if(ipri >= 1) then
          write(nfout,*) ' n_min1,n_max1 = ',n_min(1),n_max(1)
          write(nfout,*) ' n_min2,n_max2 = ',n_min(2),n_max(2)
          write(nfout,*) ' n_min3,n_max3 = ',n_min(3),n_max(3)
          write(nfout,*) ' ng_min,ng_max = ',ng_min,  ng_max
       end if
    end if
  end subroutine m_pwBS_find_min_max_G

  subroutine m_pwBS_decide_cutoff_mix
    if(cutoff_mix == SMALL) then
       kgpm = kg1_ext
    else if(cutoff_mix == MEDIUM) then
       kgpm = kg
    else if(cutoff_mix == LARGE) then 
       kgpm  = kgp
    end if
    if(mype == 0) then
      !!$ print '(" !! cutoff_mix = ",i4)', cutoff_mix
      !!$ print '(" !! kgpm       = ",i8)', kgpm
    end if
  end subroutine m_pwBS_decide_cutoff_mix

  subroutine m_pwBS_wd_ngabc_etc(nfcntn_bin)
    integer,intent(in) :: nfcntn_bin

    integer,pointer,dimension(:) :: igfp_mpi,igfp_mpi2
    integer,allocatable,dimension(:,:) :: ngabc_kngp
    integer :: i

    allocate(ngabc_kngp(kgp,3));ngabc_kngp=0.0
    do i=ista_kngp,iend_kngp
       ngabc_kngp(i,:) = ngabc_kngp_l(i,:)
    enddo
    call mpi_allreduce(mpi_in_place,ngabc_kngp,kgp*3,mpi_integer,mpi_sum &
            &            ,mpi_chg_world,ierr)
    if(mype == 0) write(nfcntn_bin) ngabc_kngp
    if(mype == 0) write(nfcntn_bin) igf
    if(npes > 1) then
       allocate(igfp_mpi(kgp));allocate(igfp_mpi2(kgp))
       igfp_mpi = 0
#ifdef _MPIFFT_
       do i = ista_kngp, iend_kngp
          igfp_mpi(i) = igfp_nonpara(i)
       end do
#else
       do i = ista_kngp, iend_kngp
          igfp_mpi(i) = igfp_l(i)
       end do
#endif
       call mpi_allreduce(igfp_mpi,igfp_mpi2,kgp,mpi_integer,mpi_sum &
            &            ,mpi_chg_world,ierr)
       if(mype == 0) write(nfcntn_bin) igfp_mpi2
    else
#ifdef _MPIFFT_
       write(nfcntn_bin) igfp_nonpara
#else
       write(nfcntn_bin) igfp_l
#endif
    end if
    if(mype == 0) write(nfcntn_bin) kg,kgp
    if(mype == 0) write(nfcntn_bin) nbase
    if(mype == 0) write(nfcntn_bin) iba
    if(mype == 0) write(nfcntn_bin) ttr
  end subroutine m_pwBS_wd_ngabc_etc

  subroutine m_pwBS_increase_kg1(iadd)
    integer, intent(in) :: iadd
    kg1 = kg1 + iadd
    kg1_ext = kg1_ext + iadd
    if(ipri >= 1) write(nfout,'(" !pwBS: kg1 is increased to be ",i9)') kg1
    if(ipri >= 1) write(nfout,'(" !pwBS: kg1_ext is increased to be ",i9)') kg1_ext
  end subroutine m_pwBS_increase_kg1

  subroutine m_pwBS_cp_iba_to_iba_ek()
     integer :: i
     if(.not.allocated(iba_ek)) allocate(iba_ek(kv3_ek))
     iba_ek = iba

     if(ipri >= 3) then
        do i = 1, kv3_ek
           write(nfout,'(" iba_ek(",i6,") = ",i6 &
                & ," <<m_pwBS_cp_iba_to_iba_ek>>")') i, iba_ek(i)
        end do
     end if

  end subroutine m_pwBS_cp_iba_to_iba_ek

  subroutine m_pwBS_cp_iba_ek_to_iba(nk)
     integer, intent(in) :: nk
     integer :: kvt, i, nks, ikt, is, kv3t

     call mpi_barrier(mpi_comm_group,ierr)
     if(allocated(iba)) then
        deallocate(iba)
        allocate(iba(kv3))
        if(ipri >= 3) write(nfout,'(" iba is allocated <<m_pwBS_cp_iba_ek_to_iba>>")')
     end if

     if(nk > kv3_ek ) then
        if(ipri >= 1) write(nfout,'(" nk = ",i6," > kv3_ek = ",i6)') nk, kv3_ek
        !stop ' nk > kv3_ek <<m_pwBS_cp_iba_ek_to_iba>>'
        write(nfout,'(a,2i10)') '!** nk > kv3_ek', nk, kv3_ek
     end if

     if(sw_modified_kpoint_increment == ON) then
       do i=0,nrank_k-1
         do is=1,nspin
           ikt = nspin*(nis_kv3_ek(i)-1)+(nkgroup-1)*nspin+is
           if(ikt>kv3_ek) ikt = kv3_ek
!           iba((i-1)*nspin+is) = iba_ek(ikt)
           iba(i*nspin+is) = iba_ek(ikt)
         enddo
       enddo
     else
       if(fixed_charge_k_parallel == ONE_BY_ONE .and. nk+kv3-1 > kv3_ek) then
          kvt = kv3_ek - nk + 1
          iba(1:kvt) = iba_ek(nk:kv3_ek)
          do i = kvt+1, kv3
             iba(i) = iba_ek(kv3_ek)
          end do
       else
          iba(1:kv3) = iba_ek(nk:nk+kv3-1)
       end if
     endif
     if(ipri >= 2) then
        do i = 1, kv3
           write(nfout,'(" iba(",i6,") = ",i6 &
                & ," <<m_pwBS_cp_iba_ek_to_iba>>")') i, iba(i)
        end do
     end if
   end subroutine m_pwBS_cp_iba_ek_to_iba

   subroutine m_pwBS_get_igfp(ista,iend,igfp,idp,idp2,nboxsize)
     integer, intent(in) :: ista,iend,idp,idp2,nboxsize(3)
     integer, intent(out),dimension(ista:iend) :: igfp

     integer :: igf1, igf2, igf3, i, nlp,nnm,nnn
     nlp = nboxsize(1)
     nnm = nboxsize(2)
     nnn = nboxsize(3)

     do i = ista, iend  !for mpi
        igf1 = ngabc(i,1) + 1
        igf2 = ngabc(i,2) + 1
        igf3 = ngabc(i,3) + 1
        if(ngabc(i,1) <= -1) igf1 = igf1 + nlp
        if(ngabc(i,2) <= -1) igf2 = igf2 + nnm
        if(ngabc(i,3) <= -1) igf3 = igf3 + nnn
        igfp(i) = igf1 + (igf2-1)*idp + (igf3-1)*idp*idp2
     end do
   end subroutine m_pwBS_get_igfp

   subroutine m_pwBS_dealloc(dealloc_all)
     logical, intent(in), optional :: dealloc_all
     logical :: dealloc, unitcell_can_change
     dealloc = unitcell_can_change()
     if(present(dealloc_all)) then
       dealloc = dealloc_all
     endif
     if(dealloc)then
        if(allocated(igf_prev)) deallocate(igf_prev)
        allocate(igf_prev(kg));igf_prev = igf

        if(allocated(nbase_prev)) deallocate(nbase_prev)
        allocate(nbase_prev(size(nbase,1),size(nbase,2)))
        nbase_prev = nbase

        if(allocated(nbase_gamma_prev)) deallocate(nbase_gamma_prev)
        if(allocated(nbase_gamma))then
          allocate(nbase_gamma_prev(size(nbase_gamma,1),size(nbase_gamma,2)))
          nbase_gamma_prev = nbase_gamma
        endif
        if(allocated(iba_prev)) deallocate(iba_prev)
        allocate(iba_prev(kv3));iba_prev = iba

        if(allocated(igfp_l_prev)) deallocate(igfp_l_prev)
        allocate(igfp_l_prev(ista_kngp:iend_kngp));igfp_l_prev = igfp_l
        kgp_reduced_prev = kgp_reduced
     endif
     if(allocated(ngabc)) deallocate(ngabc)
 
     if(allocated(ngpt_l)) deallocate(ngpt_l)
     if(allocated(igfp_l)) deallocate(igfp_l)
     if(allocated(igf)) deallocate(igf)
     if(allocated(gr_l)) deallocate(gr_l)
 
     if(allocated(ngshell_range)) deallocate(ngshell_range)
 
     if(allocated(nbase)) deallocate(nbase)
 
     if(allocated(ylm_l)) deallocate(ylm_l)

     if(allocated(nbase_gamma)) deallocate(nbase_gamma)
 
#ifdef _MPIFFT_
     if(allocated(igfp_l_c)) deallocate(igfp_l_c)
     if(allocated(igfp_nonpara)) deallocate(igfp_nonpara)
#endif

     if(allocated(iba)) deallocate(iba)

     if(allocated(ngabc_kngp_l)) deallocate(ngabc_kngp_l)
     if(allocated(fp_l)) deallocate(fp_l)
     kg1_ext = 0

   end subroutine m_pwBS_dealloc

!------------------------------------------------------------------------------
!------------------------------------------------------------------------------

  subroutine m_pwBS_kinetic_energies_3D(ik,vkxyz,ekin)

    use m_Parallelization,only: np_g1k , ista_g1k

    integer, intent(in)       :: ik
    real(kind=DP), intent(in) :: vkxyz(kv3,3,CRDTYP)
    real(kind=DP), intent(out):: ekin(np_g1k(ik))

    integer i, nb
    real(kind=DP) :: ga,gb,gc
    integer       :: id_sname = -1
    call tstatc0_begin('m_pwBS_kinetic_energies_3D ',id_sname)
    call getttr(rltv,ttr)

    do i = 1, np_g1k(ik)
       nb = nbase(i+ista_g1k(ik)-1,ik)
       ga = vkxyz(ik,1,BUCS) + ngabc(nb,1)
       gb = vkxyz(ik,2,BUCS) + ngabc(nb,2)
       gc = vkxyz(ik,3,BUCS) + ngabc(nb,3)
       ekin(i) = ( ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &  +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)*0.5d0
    end do
    call tstatc0_end(id_sname)
  end subroutine m_pwBS_kinetic_energies_3D

!------------------------------------------------------------------------------

  subroutine m_pwBS_alloc_ngpt_igfp_gr_3D
    allocate(ngpt_l(ista_kngp:iend_kngp,nopr+af)); ngpt_l = 0.d0
    allocate(igfp_l(ista_kngp:iend_kngp));         igfp_l = 0
#ifdef _MPIFFT_
    allocate(igfp_nonpara(ista_kngp:iend_kngp));   igfp_nonpara = 0
    allocate(igfp_l_c(ista_kngp:iend_kngp));       igfp_l_c = 0
#endif
    allocate(igf(kg));                                      igf = 0
    allocate(gr_l(ista_kngp:iend_kngp));           gr_l = 0.d0
    ! ------- Positron start 
   if(sw_positron /= OFF) then
      allocate(igf_pstrn(kg_pwf)) ;                        igf_pstrn = 0
   end if
    ! ------- Positron end

! ========== KT_add ========================== 13.0F
    if (sw_hybrid_functional /= OFF .and. use_fft_exx ) then
       allocate(igf_exx(kg_exx)) ; igf_exx = 0
    end if
    if (sw_hybrid_functional /= OFF) then
       allocate(igfp_exx(kgp_exx)) ; igfp_exx = 0
    endif
! ============================================ 13.0F

  end subroutine m_pwBS_alloc_ngpt_igfp_gr_3D

!------------------------------------------------------------------------------

  subroutine m_pwBS_rebuild_gr_l()
    integer :: i 
    call getttr(rltv,ttr)
    gr_l = 0.d0 
    do i = ista_kngp, iend_kngp       !for mpi
       gr_l(i) =      dsqrt(ttr(1)*ngabc_kngp_l(i,1)*ngabc_kngp_l(i,1) &
            &             + ttr(2)*ngabc_kngp_l(i,2)*ngabc_kngp_l(i,2) &
            &             + ttr(3)*ngabc_kngp_l(i,3)*ngabc_kngp_l(i,3) &
            &             + ttr(4)*ngabc_kngp_l(i,1)*ngabc_kngp_l(i,2) &
            &             + ttr(5)*ngabc_kngp_l(i,2)*ngabc_kngp_l(i,3) &
            &             + ttr(6)*ngabc_kngp_l(i,3)*ngabc_kngp_l(i,1))
    enddo
    if(ipri >= 2 ) then 
       do i = ista_kngp, iend_kngp  !for mpi
          write(nfout,'(" ", i9," = ",f10.5, 3i5)') i, gr_l(i) &
               &, ngabc_kngp_l(i,1),ngabc_kngp_l(i,2),ngabc_kngp_l(i,3)
       enddo
    end if
  end subroutine m_pwBS_rebuild_gr_l

  subroutine m_pwBS_calc_length_of_G_3D

    integer :: id_sname = -1
    integer :: i, k, ngs
    real(kind=DP) :: length_start, length

                                                     __TIMER_SUB_START(1220)

    call tstatc0_begin('m_pwBS_calc_length_of_G_3D ',id_sname)

    do i = ista_kngp, iend_kngp       !for mpi
       gr_l(i) =   dsqrt(ttr(1)*ngabc_kngp_l(i,1)*ngabc_kngp_l(i,1) &
            &             + ttr(2)*ngabc_kngp_l(i,2)*ngabc_kngp_l(i,2) &
            &             + ttr(3)*ngabc_kngp_l(i,3)*ngabc_kngp_l(i,3) &
            &             + ttr(4)*ngabc_kngp_l(i,1)*ngabc_kngp_l(i,2) &
            &             + ttr(5)*ngabc_kngp_l(i,2)*ngabc_kngp_l(i,3) &
            &             + ttr(6)*ngabc_kngp_l(i,3)*ngabc_kngp_l(i,1))
    enddo

    if(ipri >= 2 ) then
       do i = ista_kngp, iend_kngp  !for mpi
          write(nfout,'(" ", i9," = ",f10.5, 3i5)') i, gr_l(i) &
               &, ngabc_kngp_l(i,1),ngabc_kngp_l(i,2),ngabc_kngp_l(i,3)
       enddo
    end if

    ngshell = 1
    k = ista_kngp+1
    length_start = gr_l(ista_kngp)
1   continue
    shellloop: do i = k, iend_kngp
       length = gr_l(i)
       if(length > length_start + DELTA) then
          exit shellloop
       else if(i == iend_kngp) then
          go to 11
       end if
    end do shellloop
    length_start = length
    k = i
    if(k <= iend_kngp) then
       ngshell = ngshell + 1
       goto 1
    end if
11  continue
    if(ipri >= 1 ) write(nfout,'(" !pwbs  ngshell = ",i8)') ngshell

    allocate(ngshell_range(ngshell,2))
    ngs = 1
    k = ista_kngp+1
    length_start = gr_l(ista_kngp)
    ngshell_range(1,1) = ista_kngp
2   continue
    shellloop2: do i = k, iend_kngp
       length = gr_l(i)
       if(length > length_start + DELTA) then
          ngshell_range(ngs,2)   = i - 1
          if(ngs+1 <= ngshell) ngshell_range(ngs+1,1) = i
          exit shellloop2
       else if( i == iend_kngp) then
          go to 22
       end if
    end do shellloop2
    length_start = length
    k = i
    if( k <= iend_kngp) then
       ngs = ngs+1
       goto 2
    end if
22 continue
    ngshell_range(ngshell,2) = iend_kngp
    if(ipri >= 2) then
       write(nfout,'(" !pwbs ngshell_range")') 
       write(nfout,'(" !pwbs  ngshell, range1 - range2, nelement, gr")')
       do ngs = 1, ngshell
          write(nfout,'(" !pwbs ",i8, i8," - ",i8, i8, f20.8)') ngs, ngshell_range(ngs,1)&
               & ,ngshell_range(ngs,2),ngshell_range(ngs,2)-ngshell_range(ngs,1)+1,gr_l(ngshell_range(ngs,1))
       end do
    end if

    call tstatc0_end(id_sname)
                                                     __TIMER_SUB_STOP(1220)
  end subroutine m_pwBS_calc_length_of_G_3D

!------------------------------------------------------------------------------

  subroutine m_pwBS_sphrp_l_3D()

    integer :: is
    real(kind=DP), allocatable, dimension(:) :: ylm

    allocate(ylm(ista_kngp:iend_kngp))

    if(ipri >= 1) write(nfout,'(" !pwBS: nel_Ylm = ",i5," (m_pwBS_sphrp)")') nel_Ylm

    if(nel_Ylm >= 1 .and. .not.allocated(ylm_l)) call phase_error_with_msg(nfout,' ylm_l is not allocated (m_pwBS_sphrp_l)'&
                                                                          ,__LINE__,__FILE__)
    do is = 1, nel_Ylm
       call m_pwBS_sphrp2_3D(is,rltv,ista_kngp,iend_kngp,ylm)
       ylm_l(:,is) = ylm(:)
    end do

    deallocate(ylm)
  end subroutine m_pwBS_sphrp_l_3D

!------------------------------------------------------------------------------

  subroutine m_pwBS_sphrp2_3D(is,rltv,ista_ylm,iend_ylm,ylm)
    integer, intent(in) :: is
    real(kind=DP), intent(in), dimension(3,3)  :: rltv
    integer, intent(in) :: ista_ylm, iend_ylm
    real(kind=DP), intent(inout), dimension(ista_ylm:iend_ylm) :: ylm
!!$C spherical harmonics.
!!$c     Some lines are rewritten by T.Yamasaki according to Y.Morikawa's
!!$c   e-mail. at 4th May 1994

    integer :: i,ni
    real(kind=DP) a,b,c,d,e,f,gx,gy,gz
    real(kind=DP) b1x,b1y,b1z,b2x,b2y,b2z,b3x,b3y,b3z
                                                     __TIMER_SUB_START(1059)

    b1x = rltv(1,1);  b1y = rltv(2,1);  b1z = rltv(3,1)
    b2x = rltv(1,2);  b2y = rltv(2,2);  b2z = rltv(3,2)
    b3x = rltv(1,3);  b3y = rltv(2,3);  b3z = rltv(3,3)

    ni = ista_ylm
                                                     __TIMER_DO_START(1081)
    if(ngabc(1,1) == 0 .and. ngabc(1,2) == 0 .and. ngabc(1,3) == 0) then
       if(ni == 1) then
          ni = 2
          ylm(1) = dsqrt(1.d0/PAI4)
       endif
    end if
                                                     __TIMER_DO_STOP(1081)
                                                     __TIMER_DO_START(1082)
    if(is == 1) then
       a = dsqrt(1.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          ylm(i) = a
       end do
    else if(is == 2) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          ylm(i) = a*gx/gr_l(i)
       end do
    else if(is == 3) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gy =   b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          ylm(i) = a*gy/gr_l(i)
       end do
    else if(is == 4) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gz =   b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          ylm(i) = a*gz/gr_l(i)
       end do
    else if(is == 5) then
       a = dsqrt(5.d0/(16*PAI))
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2)  + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2)  + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2)  + b3z*ngabc_kngp_l(i,3)
          d = gz**2
          e = gx**2+gy**2+d
          ylm(i) = a*(3*d-e)/e
       end do
    else if(is == 6) then
       a = dsqrt(15.d0/(16*PAI))
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2)  + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2)  + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2)  + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          e = b+c+gz**2
          ylm(i) = a*(b-c)/e
       end do
    else if(is == 7) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          e = gr_l(i)**2
          ylm(i) = a*gx*gy/e
       end do
    else if(is == 8) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2)  + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2)  + b3z*ngabc_kngp_l(i,3)
          e = gr_l(i)**2
          ylm(i) = a*gy*gz/e
       end do
    else if(is == 9) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          e = gr_l(i)**2
          ylm(i) = a*gz*gx/e
       end do
    else if(is == 10) then
       a = dsqrt(7.d0/(16*PAI))
       do i = ni, iend_ylm  !for mpi
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e * gr_l(i)
          ylm(i) = a*gz*(5*d-3*e)/f
       end do
    else if(is == 11) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ni, iend_ylm  !for mpi
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2)  + b3z*ngabc_kngp_l(i,3)
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2)  + b3x*ngabc_kngp_l(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e * gr_l(i)
          ylm(i) = a*gx*(5*d-e)/f
       end do
    else if(is == 12) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ni, iend_ylm  !for mpi
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e * gr_l(i)
          ylm(i) = a*gy*(5*d-e)/f
       end do
    else if(is == 13) then
       a = dsqrt(105.d0/(16*PAI))
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          e = gr_l(i)**2
          f = e * gr_l(i)
          ylm(i) = a*gz*(b-c)/f
       end do
    else if(is == 14) then
       a = dsqrt(105.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2)  + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2)  + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2)  + b3z*ngabc_kngp_l(i,3)
          f = gr_l(i)**3
          ylm(i) = a*gx*gy*gz/f
       end do
    else if(is == 15) then
       a = dsqrt(35.d0/(32*PAI))
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          f = gr_l(i)**3
          ylm(i) = a*gx*(b-3*c)/f
       end do
    else if(is == 16) then
       a = dsqrt(35.d0/(32*pai))
       do i = ni, iend_ylm !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          f = gr_l(i)**3
          ylm(i) = a*gy*(3*b-c)/f
       end do
    else if(is == 17) then
       a = 3.d0/8.d0/dsqrt(PAI4)
       do i = ni, iend_ylm  !for mpi
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e**2
          ylm(i) = a*(5*d*(7*d-6*e)/f+3.d0)
       end do
    else if(is == 18) then
       a = 15.d0/4.d0/dsqrt(10*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e**2
          ylm(i) = a*gz*gx*(7*d-3*e)/f
       end do
    else if(is == 19) then
       a = 15.d0/4.d0/dsqrt(10.d0*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2)  + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2)  + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2)  + b3z*ngabc_kngp_l(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e**2
          ylm(i) = a*gy*gz*(7*d-3*e)/f
       end do
    else if(is == 20) then
       a = 15.d0/8.d0/dsqrt(5*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2)  + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2)  + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2)  + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b+c+d
          f = e**2
          ylm(i) = a*(7*d-e)*(b-c)/f
       end do
    else if(is == 21) then
       a = 15.d0/4.d0/dsqrt(5*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e**2
          ylm(i) = a*(7*d-e)*gx*gy/f
       end do
    else if(is == 22) then
       a = 105.d0/4.d0/dsqrt(70*pai)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
          ylm(i) = a*(b-3*c)*gz*gx/f
       end do
    else if(is == 23) then
       a = 105.d0/4.d0/dsqrt(70*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
          ylm(i) = a*(3.d0*b-c)*gy*gz/f
       end do
    else if(is == 24) then
       a = 105.d0/16.d0/dsqrt(35*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2)  + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2)  + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2)  + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
          ylm(i) = a*((b-c)**2-4*b*c)/f
       end do
    else if(is == 25) then
       a = 105.d0/4.d0/dsqrt(35*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2)  + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2)  + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2)  + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
          ylm(i) = a*(b-c)*gx*gy/f
       end do
    end if
                                                     __TIMER_DO_STOP(1082)
                                                     __TIMER_SUB_STOP(1059)
  end subroutine m_pwBS_sphrp2_3D

!------------------------------------------------------------------------------

  subroutine m_pwBS_G_trans_functions_3D
!              -> ngpt_l

    integer, pointer ,dimension(:,:,:) ::g_list
    integer :: mmdim1, mmdim2, mmdim3
    integer error_count

    if(ipri >= 2) then
       write(nfout,'(" !pwBS: nopr+af = ",i6," <<m_pwBS_G_trans_functions>>")') nopr+af
       write(nfout,'(" !pwBS: nopr, af = ",2i6,"<<m_pwBS_G_trans_functions>>")') nopr,af
    end if
    if(nopr+af > 100) call phase_error_with_msg(nfout,' !! illegal number of nopr+af',__LINE__,__FILE__)
    allocate(op_br(3,3,nopr+af))
    call m_CS_op_in_PUCV(nfout,op_br,nopr+af)
    call decide_g_list_size(nfout, mmdim1, mmdim2,mmdim3 )
    if(ipri >= 1) write(nfout,'(" !pwBS: g_list size = ",3i9)') mmdim1, mmdim2, mmdim3
    allocate(g_list(0:mmdim1,0:mmdim2,0:mmdim3))

!    call substitute_g_list
    call substitute_g_list_3D
!TS** conjecture of the symmetry point by using the list vector g_list...
!    call symmetric_G_points_using_g_list
    call symmetric_G_points_using_g_list_3D
    call counting_error_points(error_count)
    if(error_count > 0) then
       if(ipri>=1) write(nfout &
            & ,'(" !pwBS: (G_vector_transformation_functions) error_count = ",i9)') error_count
       call symmetric_G_points
    else
       if(ipri>=1) write(nfout,'(" !pwBS: (ngpt_l)s are all decided by using g_list")')
    endif

    deallocate(g_list)
    deallocate(op_br)
  contains

    subroutine substitute_g_list
      integer i, int_gx, int_gy, int_gz
      real(kind=DP) :: gxL, gyL, gzL

      g_list = 0

      if(2*n_rGpv(1)-mmdim1 /=0 .and. 2*n_rGpv(2)-mmdim2 /= 0 .and. 2*n_rGpv(3)-mmdim3 /=0) then
         gxL = 2.d0*n_rGpv(1); gyL = 2.d0*n_rGpv(2); gzL = 2.d0*n_rGpv(3)
!** (This do-loop can be vectorizable.)
!xocl spread do/ind_kngp
         do  i = 1, kgp
            int_gx = (dble(ngabc(i,1))+n_rGpv(1))/gxL*dble(mmdim1)
            int_gy = (dble(ngabc(i,2))+n_rGpv(2))/gyL*dble(mmdim2)
            int_gz = (dble(ngabc(i,3))+n_rGpv(3))/gzL*dble(mmdim3)
            int_gx = max(int_gx,0)
            int_gy = max(int_gy,0)
            int_gz = max(int_gz,0)
            g_list(int_gx,int_gy,int_gz) = i
         enddo
!xocl end spread max(g_list)
      else
!xocl spread do/ind_kngp
         do  i = 1, kgp
            int_gx = ngabc(i,1)+n_rGpv(1)
            int_gy = ngabc(i,2)+n_rGpv(2)
            int_gz = ngabc(i,3)+n_rGpv(3)
            int_gx = max(int_gx,0)
            int_gy = max(int_gy,0)
            int_gz = max(int_gz,0)
            g_list(int_gx,int_gy,int_gz) = i
         enddo
!xocl end spread max(g_list)
      endif
    end subroutine substitute_g_list

    subroutine symmetric_G_points_using_g_list
      integer i
      integer no
      real(kind=DP) :: fx,fy,fz, px,py,pz, distance
      integer       :: int_fx, int_fy, int_fz, nng
      real(kind=DP),  parameter :: epsilon = 1.0d-5
      real(kind=DP) :: gxL, gyL, gzL

      if(2*n_rGpv(1)-mmdim1 /=0 .and. 2*n_rGpv(2)-mmdim2 /= 0 .and. 2*n_rGpv(3)-mmdim3 /=0) then
         gxL = 2.d0*n_rGpv(1); gyL = 2.d0*n_rGpv(2); gzL = 2.d0*n_rGpv(3)
         do i = ista_kngp, iend_kngp  !for mpi
            do no = 1, nopr + af

               px = ngabc(i,1)
               py = ngabc(i,2)
               pz = ngabc(i,3)

               fx=op_br(1,1,no)*px +op_br(1,2,no)*py +op_br(1,3,no)*pz
               fy=op_br(2,1,no)*px +op_br(2,2,no)*py +op_br(2,3,no)*pz
               fz=op_br(3,1,no)*px +op_br(3,2,no)*py +op_br(3,3,no)*pz

               int_fx = (fx + n_rGpv(1)+epsilon)/gxL*dble(mmdim1)
               int_fy = (fy + n_rGpv(2)+epsilon)/gyL*dble(mmdim2)
               int_fz = (fz + n_rGpv(3)+epsilon)/gzL*dble(mmdim3)

               int_fx = max(int_fx,0)
               int_fy = max(int_fy,0)
               int_fz = max(int_fz,0)

               int_fx = min(int_fx,mmdim1)
               int_fy = min(int_fy,mmdim2)
               int_fz = min(int_fz,mmdim3)

               nng = g_list(int_fx,int_fy,int_fz)

               if(nng /= 0) then
                  distance =  abs(ngabc(nng,1)-fx) + abs(ngabc(nng,2)-fy) &
                       &    + abs(ngabc(nng,3)-fz)
                  if(distance < epsilon) then
                     ngpt_l(i,no) = nng
                  else
                     ngpt_l(i,no) = -1
                  end if
               else
                  ngpt_l(i,no) = -1
               end if
            enddo
         enddo
      else

         do i = ista_kngp, iend_kngp  !for mpi
            do no = 1, nopr + af

               px = ngabc(i,1)
               py = ngabc(i,2)
               pz = ngabc(i,3)

               fx=op_br(1,1,no)*px +op_br(1,2,no)*py +op_br(1,3,no)*pz
               fy=op_br(2,1,no)*px +op_br(2,2,no)*py +op_br(2,3,no)*pz
               fz=op_br(3,1,no)*px +op_br(3,2,no)*py +op_br(3,3,no)*pz

               int_fx = fx + n_rGpv(1) + epsilon
               int_fy = fy + n_rGpv(2) + epsilon
               int_fz = fz + n_rGpv(3) + epsilon

               int_fx = max(int_fx,0)
               int_fy = max(int_fy,0)
               int_fz = max(int_fz,0)

               int_fx = min(int_fx,mmdim1)
               int_fy = min(int_fy,mmdim2)
               int_fz = min(int_fz,mmdim3)

               nng = g_list(int_fx,int_fy,int_fz)

               if(nng /= 0) then
                  distance =  abs(ngabc(nng,1)-fx) + abs(ngabc(nng,2)-fy) &
                       &    + abs(ngabc(nng,3)-fz)
                  if(distance < epsilon) then
                     ngpt_l(i,no) = nng
                  else
                     ngpt_l(i,no) = -1
                  end if
               else
                  ngpt_l(i,no) = -1
               end if
            enddo
         enddo
      endif
    end subroutine symmetric_G_points_using_g_list

    subroutine counting_error_points(error_count)
      integer, intent(out) :: error_count

      integer :: i, no
      integer :: e_mpi  ! mpi
      error_count = 0

      do i = ista_kngp, iend_kngp  !for mpi
         do no=1,nopr + af
            if(ngpt_l(i,no) == -1) error_count = error_count + 1
         enddo
      enddo

      if(npes > 1 ) then
         call mpi_allreduce(error_count,e_mpi,1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
         error_count = e_mpi
      end if

    end subroutine counting_error_points

    subroutine symmetric_G_points
      integer :: ierr, i, no, loop, jstart, jend, jstep, j
      integer, parameter :: Nequiv = 50
      integer, parameter :: MAXERR = 100
      real(kind=DP) :: px,py,pz, fx,fy,fz, ff1
      ierr = 0

      do i = ista_kngp, iend_kngp  !for mpi
         px = ngabc(i,1)
         py = ngabc(i,2)
         pz = ngabc(i,3)
         do no=1,nopr + af

            if(ngpt_l(i,no).eq.-1) then

               fx=op_br(1,1,no)*px +op_br(1,2,no)*py +op_br(1,3,no)*pz
               fy=op_br(2,1,no)*px +op_br(2,2,no)*py +op_br(2,3,no)*pz
               fz=op_br(3,1,no)*px +op_br(3,2,no)*py +op_br(3,3,no)*pz
               do loop = 1, 2
                  if(loop.eq.1) then
                     jstart = i - Nequiv + 1
                     if(jstart.le.0) jstart = 1
                     jend = kgp
                     jstep = 1
                  else if(loop.eq.2) then
                     jstart = i - Nequiv
                     jend = 1
                     jstep = -1
                  endif
!*vocl loop, vi(j)
                  do j = jstart, jend, jstep
                     ff1 = abs(ngabc(j,1)-fx) +abs(ngabc(j,2)-fy) +abs(ngabc(j,3)-fz)
                     if (ff1.le.1.d-5) then
                        ngpt_l(i,no) = j
                        goto 111
                     end if
                  enddo
               enddo
               if(ipri >= 1) write(nfout,130) i,no
               ierr = ierr + 1
               if(ierr.ge.MAXERR) goto 1001
111            continue

            endif

         enddo
      enddo

130   FORMAT(' ','THERE IS NO PAIR FOR NG,NOP=',2I8)
1001  if(ierr.ge.1) then
         if(ipri >= 1 ) write(nfout,*) ' No pair was discovered for at least ',ierr &
              &       ,'s combinations'
         call phase_error_with_msg(nfout,'No pair was discovered',__LINE__,__FILE__)
      endif
      
    end subroutine symmetric_G_points
!--->for ngabc
    subroutine substitute_g_list_3D
      integer i, int_gx, int_gy, int_gz
      real(kind=DP) :: gxL, gyL, gzL

      g_list = 0

      if(2*n_rGpv(1)-mmdim1 /=0 .and. 2*n_rGpv(2)-mmdim2 /= 0 .and. 2*n_rGpv(3)-mmdim3 /=0) then
         gxL = 2.d0*n_rGpv(1); gyL = 2.d0*n_rGpv(2); gzL = 2.d0*n_rGpv(3)
!--!** (This do-loop can be vectorizable.)
!--!xocl spread do/ind_kngp
         do  i = ista_kngp, iend_kngp
            int_gx = (dble(ngabc_kngp_l(i,1))+n_rGpv(1))/gxL*dble(mmdim1)
            int_gy = (dble(ngabc_kngp_l(i,2))+n_rGpv(2))/gyL*dble(mmdim2)
            int_gz = (dble(ngabc_kngp_l(i,3))+n_rGpv(3))/gzL*dble(mmdim3)
            int_gx = max(int_gx,0)
            int_gy = max(int_gy,0)
            int_gz = max(int_gz,0)
            g_list(int_gx,int_gy,int_gz) = i
         enddo
!--!xocl end spread max(g_list)
      else
!--!xocl spread do/ind_kngp
         do  i = ista_kngp, iend_kngp
            int_gx = ngabc_kngp_l(i,1)+n_rGpv(1)
            int_gy = ngabc_kngp_l(i,2)+n_rGpv(2)
            int_gz = ngabc_kngp_l(i,3)+n_rGpv(3)
            int_gx = max(int_gx,0)
            int_gy = max(int_gy,0)
            int_gz = max(int_gz,0)
            g_list(int_gx,int_gy,int_gz) = i
         enddo
!--!xocl end spread max(g_list)
      endif
    end subroutine substitute_g_list_3D

    subroutine symmetric_G_points_using_g_list_3D
      integer i
      integer no
      real(kind=DP) :: fx,fy,fz, px,py,pz, distance
      integer       :: int_fx, int_fy, int_fz, nng
      real(kind=DP),  parameter :: epsilon = 1.0d-5
      real(kind=DP) :: gxL, gyL, gzL

      if(2*n_rGpv(1)-mmdim1 /=0 .and. 2*n_rGpv(2)-mmdim2 /= 0 .and. 2*n_rGpv(3)-mmdim3 /=0) then
         gxL = 2.d0*n_rGpv(1); gyL = 2.d0*n_rGpv(2); gzL = 2.d0*n_rGpv(3)
         do i = ista_kngp, iend_kngp  !for mpi
            do no = 1, nopr + af

               px = ngabc_kngp_l(i,1)
               py = ngabc_kngp_l(i,2)
               pz = ngabc_kngp_l(i,3)

               fx=op_br(1,1,no)*px +op_br(1,2,no)*py +op_br(1,3,no)*pz
               fy=op_br(2,1,no)*px +op_br(2,2,no)*py +op_br(2,3,no)*pz
               fz=op_br(3,1,no)*px +op_br(3,2,no)*py +op_br(3,3,no)*pz

               int_fx = (fx + n_rGpv(1)+epsilon)/gxL*dble(mmdim1)
               int_fy = (fy + n_rGpv(2)+epsilon)/gyL*dble(mmdim2)
               int_fz = (fz + n_rGpv(3)+epsilon)/gzL*dble(mmdim3)

               int_fx = max(int_fx,0)
               int_fy = max(int_fy,0)
               int_fz = max(int_fz,0)

               int_fx = min(int_fx,mmdim1)
               int_fy = min(int_fy,mmdim2)
               int_fz = min(int_fz,mmdim3)

               nng = g_list(int_fx,int_fy,int_fz)

               if(nng /= 0) then
                  distance =  abs(ngabc_kngp_l(nng,1)-fx) + abs(ngabc_kngp_l(nng,2)-fy) &
                       &    + abs(ngabc_kngp_l(nng,3)-fz)
                  if(distance < epsilon) then
                     ngpt_l(i,no) = nng
                  else
                     ngpt_l(i,no) = -1
                  end if
               else
                  ngpt_l(i,no) = -1
               end if
            enddo
         enddo
      else

         do i = ista_kngp, iend_kngp  !for mpi
            do no = 1, nopr + af

               px = ngabc_kngp_l(i,1)
               py = ngabc_kngp_l(i,2)
               pz = ngabc_kngp_l(i,3)

               fx=op_br(1,1,no)*px +op_br(1,2,no)*py +op_br(1,3,no)*pz
               fy=op_br(2,1,no)*px +op_br(2,2,no)*py +op_br(2,3,no)*pz
               fz=op_br(3,1,no)*px +op_br(3,2,no)*py +op_br(3,3,no)*pz

               int_fx = fx + n_rGpv(1) + epsilon
               int_fy = fy + n_rGpv(2) + epsilon
               int_fz = fz + n_rGpv(3) + epsilon

               int_fx = max(int_fx,0)
               int_fy = max(int_fy,0)
               int_fz = max(int_fz,0)

               int_fx = min(int_fx,mmdim1)
               int_fy = min(int_fy,mmdim2)
               int_fz = min(int_fz,mmdim3)

               nng = g_list(int_fx,int_fy,int_fz)

               if(nng /= 0) then
                  distance =  abs(ngabc_kngp_l(nng,1)-fx) + abs(ngabc_kngp_l(nng,2)-fy) &
                       &    + abs(ngabc_kngp_l(nng,3)-fz)
                  if(distance < epsilon) then
                     ngpt_l(i,no) = nng
                  else
                     ngpt_l(i,no) = -1
                  end if
               else
                  ngpt_l(i,no) = -1
               end if
            enddo
         enddo
      endif
    end subroutine symmetric_G_points_using_g_list_3D

!<---for ngabc

  end subroutine m_pwBS_G_trans_functions_3D

!------------------------------------------------------------------------------

  subroutine m_pwBS_setup_FFTmapfunctions_3D

    integer :: id, i, ii
    integer :: igf1, igf2, igf3
    integer :: id_sname = -1
    integer, parameter :: NPRINTLINE = 20
    call tstatc0_begin('m_pwBS_setup_FFTmapfunctions_3D ',id_sname)

  id = fft_box_size_WF(1,0)
  do i = 1, kg
     igf1 = ngabc(i,1) + 1
     igf2 = ngabc(i,2) + 1
     igf3 = ngabc(i,3) + 1
     if(ngabc(i,1) <= -1) igf1 = igf1 + fft_box_size_WF(1,1)
     if(ngabc(i,2) <= -1) igf2 = igf2 + fft_box_size_WF(2,1)
     if(ngabc(i,3) <= -1) igf3 = igf3 + fft_box_size_WF(3,1)
     igf(i) = igf1 + (igf2-1)*id + (igf3-1)*id*fft_box_size_WF(2,0)
  enddo

  ! ------- Positron start 
  if(sw_positron /= OFF) then
     if(    fft_box_size_WF(1,1) == fft_box_size_pWF(1,1) .and. &
          & fft_box_size_WF(2,1) == fft_box_size_pWF(2,1) .and. &
          & fft_box_size_WF(3,1) == fft_box_size_pWF(3,1) .and. &
          & kg == kg_pwf ) then
        igf_pstrn(1:kg_pwf) = igf(1:kg_pwf)
     else
        id = fft_box_size_pWF(1,0)
        do i = 1, kg_pwf
           igf1 = ngabc(i,1) + 1
           igf2 = ngabc(i,2) + 1
           igf3 = ngabc(i,3) + 1
           if(ngabc(i,1) <= -1) igf1 = igf1 + fft_box_size_pWF(1,1)
           if(ngabc(i,2) <= -1) igf2 = igf2 + fft_box_size_pWF(2,1)
           if(ngabc(i,3) <= -1) igf3 = igf3 + fft_box_size_pWF(3,1)
           igf_pstrn(i) = igf1 + (igf2-1)*id + (igf3-1)*id*fft_box_size_pWF(2,0)
        end do
     end if
  end if
    ! ------- Positron end

    id = fft_box_size_CD_3D(1,0)
    do i = ista_kngp, iend_kngp  !for mpi
       if(i <= kgp_reduced) then
       igf1 = ngabc_kngp_l(i,1) + 1
       igf2 = ngabc_kngp_l(i,2) + 1
       igf3 = ngabc_kngp_l(i,3) + 1
       if(ngabc_kngp_l(i,1) <= -1) igf1 = igf1 + fft_box_size_CD_3D(1,1)
       if(ngabc_kngp_l(i,2) <= -1) igf2 = igf2 + fft_box_size_CD_3D(2,1)
       if(ngabc_kngp_l(i,3) <= -1) igf3 = igf3 + fft_box_size_CD_3D(3,1)
       igfp_l(i) = igf1 + (igf2-1)*id + (igf3-1)*id*fft_box_size_CD_3D(2,0)
#ifdef _MPIFFT_
       igfp_l_c(i) = igf1 + fft_box_size_CD_c(1,0)*( &
            &                    (igf2-1)+ (igf3-1)*fft_box_size_CD_c(2,0))
       igfp_nonpara(i) = igf1 + fft_box_size_CD_nonpara(1,0)*( &
            &                    (igf2-1)+ (igf3-1)*fft_box_size_CD_nonpara(2,0))
#endif
       else
          igfp_l(i) = -1
#ifdef _MPIFFT_
          igfp_l_c(i) = -1
          igfp_nonpara(i) = -1
#endif
       endif
    enddo

    if(iprifftmap >= 2) then
       if(nrank_g == 0) then
          if(sw_positron == OFF) then
             write(nfout,*) ' -- ngabc(1-3),igf,igfp_l --'
             id = NPRINTLINE
             if(id > iend_kngp) id = iend_kngp
             do i = 1, id
                ii = ista_kngp + i - 1
                write(nfout,'(" ",8i8)') &
                     & i,ngabc_kngp_l(ii,1),ngabc_kngp_l(ii,2),ngabc_kngp_l(ii,3),igf(i),igfp_l(i)
             end do
          else
             write(nfout,*) ' -- ngabc(1-3),igf,igfp_l,igf_pstrn --'
             id = NPRINTLINE
             if(id > iend_kngp) id = iend_kngp
             do i = 1, id
                ii = ista_kngp + i - 1
                write(nfout,'(" ",8i8)') &
                     & i,ngabc_kngp_l(ii,1),ngabc_kngp_l(ii,2),ngabc_kngp_l(ii,3),igf(i),igfp_l(i),igf_pstrn(i)
             end do
          end if
#ifdef _MPIFFT_
          write(nfout,*) ' -- ngabc(1-3),igf,igfp_nonpara --'
          id = NPRINTLINE
          if(id > iend_kngp) id = iend_kngp
          do i = 1, id
             ii = ista_kngp + i - 1
             write(nfout,'(" ",8i8)') &
                  & i,ngabc_kngp_l(ii,1),ngabc_kngp_l(ii,2),ngabc_kngp_l(ii,3),igf(i),igfp_nonpara(i)
          end do
#endif          
       endif
       if(myrank_g == nrank_g-1) then
          id = kg-(NPRINTLINE-1)
          if(id < ista_kngp) id = ista_kngp
          if(sw_positron == OFF) then
             do i = id,kg
                write(nfout,'(" ",8i8)') &
                     & i,ngabc(i,1),ngabc(i,2),ngabc(i,3),igf(i),igfp_l(i)
             end do
          else
             if(kg > kg_pwf) kg = kg_pwf
             do i = id,kg
                write(nfout,'(" ",8i8)') &
                     & i,ngabc(i,1),ngabc(i,2),ngabc(i,3),igf(i),igfp_l(i),igf_pstrn(i)
             end do
          end if
       endif
    end if

    if ( sw_hybrid_functional /= OFF ) then
       if(    fft_box_size_WF(1,1) == fft_box_size_exx(1,1) .and. &
            & fft_box_size_WF(2,1) == fft_box_size_exx(2,1) .and. &
            & fft_box_size_WF(3,1) == fft_box_size_exx(3,1) .and. &
            & kg == kg_exx )then
          igf_exx = igf
       else
          id = fft_box_size_exx(1,0)
          do i = 1, kg_exx
             igf1 = ngabc(i,1) + 1
             igf2 = ngabc(i,2) + 1
             igf3 = ngabc(i,3) + 1
             if(ngabc(i,1) <= -1) igf1 = igf1 + fft_box_size_exx(1,1)
             if(ngabc(i,2) <= -1) igf2 = igf2 + fft_box_size_exx(2,1)
             if(ngabc(i,3) <= -1) igf3 = igf3 + fft_box_size_exx(3,1)
             igf_exx(i) = igf1 + (igf2-1)*id + (igf3-1)*id*fft_box_size_exx(2,0)
          enddo
       endif
       if(    fft_box_size_CD(1,1) == fft_box_size_CD_exx(1,1) .and. &
            & fft_box_size_CD(2,1) == fft_box_size_CD_exx(2,1) .and. &
            & fft_box_size_CD(3,1) == fft_box_size_CD_exx(3,1) .and. &
            & kgp == kgp_exx ) then
          igfp_exx(ista_kngp:iend_kngp) = igfp_l(ista_kngp:iend_kngp)
          call mpi_allreduce(MPI_IN_PLACE,igfp_exx,kgp_exx,mpi_integer,mpi_sum,mpi_chg_world,ierr)
       else
          id = fft_box_size_CD_exx(1,0)
          do i = 1, kgp_exx
!             igf1 = ngabc_kngp_l(i,1) + 1
!             igf2 = ngabc_kngp_l(i,2) + 1
!             igf3 = ngabc_kngp_l(i,3) + 1
!             if(ngabc_kngp_l(i,1) <= -1) igf1 = igf1 + fft_box_size_CD_exx(1,1)
!             if(ngabc_kngp_l(i,2) <= -1) igf2 = igf2 + fft_box_size_CD_exx(2,1)
!             if(ngabc_kngp_l(i,3) <= -1) igf3 = igf3 + fft_box_size_CD_exx(3,1)
             igf1 = ngabc(i,1) + 1
             igf2 = ngabc(i,2) + 1
             igf3 = ngabc(i,3) + 1
             if(ngabc(i,1) <= -1) igf1 = igf1 + fft_box_size_CD_exx(1,1)
             if(ngabc(i,2) <= -1) igf2 = igf2 + fft_box_size_CD_exx(2,1)
             if(ngabc(i,3) <= -1) igf3 = igf3 + fft_box_size_CD_exx(3,1)
             igfp_exx(i) = igf1 + (igf2-1)*id + (igf3-1)*id*fft_box_size_CD_exx(2,0)
          end do
       end if
    endif

    call tstatc0_end(id_sname)
  end subroutine m_pwBS_setup_FFTmapfunctions_3D

!------------------------------------------------------------------------------

  subroutine m_pwBS_sphrp2_diff_3D(is,rltv,ylmd)
!!$C derivative of spherical harmonics coded by H. Sawada 8th May 1997

    integer, intent(in) :: is
    real(kind=DP), intent(in),  dimension(3,3)                   :: rltv
    real(kind=DP), intent(out), dimension(ista_kngp:iend_kngp,3) :: ylmd

    integer       :: i,ni
    real(kind=DP) :: a,b,c,d,e,e2,e3,gr,gr3,gr5,gx,gy,gz,t
    real(kind=DP) :: b1x,b1y,b1z,b2x,b2y,b2z,b3x,b3y,b3z

    b1x = rltv(1,1);  b1y = rltv(2,1);  b1z = rltv(3,1)
    b2x = rltv(1,2);  b2y = rltv(2,2);  b2z = rltv(3,2)
    b3x = rltv(1,3);  b3y = rltv(2,3);  b3z = rltv(3,3)

    ni = ista_kngp
    if(ngabc(1,1) == 0 .and. ngabc(1,2) == 0 .and. ngabc(1,3) == 0) then
       if(ista_kngp ==1) then
          ni = 2
          ylmd(1,1) = 0.d0
          ylmd(1,2) = 0.d0
          ylmd(1,3) = 0.d0
       endif
    end if
    if(is == 1) then
       a = 0.d0
       do i = ni, iend_kngp !for mpi
          ylmd(i,1) = a
          ylmd(i,2) = a
          ylmd(i,3) = a
       end do
    else if(is == 2) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          ylmd(i,1) = a* ( -b/gr3 + 1.d0/gr )
          ylmd(i,2) = a* ( -gx*gy/gr3 )
          ylmd(i,3) = a* ( -gx*gz/gr3 )
       enddo
    else if(is == 3) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          ylmd(i,1) = a* ( -gx*gy/gr3 )
          ylmd(i,2) = a* ( -c/gr3 + 1.d0/gr )
          ylmd(i,3) = a* ( -gy*gz/gr3 )
       enddo
    else if(is == 4) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = sqrt( e )
          gr3 = gr * e
          ylmd(i,1) = a* ( -gx*gz/gr3 )
          ylmd(i,2) = a* ( -gy*gz/gr3 )
          ylmd(i,3) = a* ( -d/gr3 + 1.d0/gr )
       enddo
    else if(is == 5) then
       a = dsqrt(5.d0/(16*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          t  = 2*(3*d - e)/e2
          ylmd(i,1) = a* ( -2*gx/e - t*gx)
          ylmd(i,2) = a* ( -2*gy/e - t*gy)
          ylmd(i,3) = a* (  4*gz/e - t*gz)
       enddo
    else if(is == 6) then
       a = dsqrt(15.d0/(16*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          t = -2*(b-c)/e2
          ylmd(i,1) = a* ( t*gx + 2*gx/e )
          ylmd(i,2) = a* ( t*gy - 2*gy/e )
          ylmd(i,3) = a* ( t*gz )
       enddo
    else if(is == 7) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          ylmd(i,1) = a* ( -2*b*gy/e2 + gy/e )
          ylmd(i,2) = a* ( -2*c*gx/e2 + gx/e )
          ylmd(i,3) = a* ( -2*gx*gy*gz/e2 )
       enddo
    else if(is == 8) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          ylmd(i,1) = a* ( -2*gx*gy*gz/e2 )
          ylmd(i,2) = a* ( -2*c*gz/e2 + gz/e )
          ylmd(i,3) = a* ( -2*d*gy/e2 + gy/e )
       enddo
    else if(is == 9) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          ylmd(i,1) = a* ( -2*b*gz/e2 + gz/e )
          ylmd(i,2) = a* ( -2*gx*gy*gz/e2 )
          ylmd(i,3) = a* ( -2*d*gx/e2 + gx/e )
       enddo
    else if(is == 10) then
       a = dsqrt(7.d0/(16*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          t   = 3*(5*d-3*e)/gr5
          ylmd(i,1) = a* ( -6*gx*gz/gr3 - gx*gz*t )
          ylmd(i,2) = a* ( -6*gy*gz/gr3 - gy*gz*t )
          ylmd(i,3) = a* ( 4*d/gr3 - d*t + (5*d-3*e)/gr3 )
       enddo
    else if(is == 11) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          t   = 3*(5*d-e)/gr5
          ylmd(i,1) = a* ( -2*b/gr3      - b*t     + (5*d-e)/gr3 )
          ylmd(i,2) = a* ( -2*gx*gy/gr3  - gx*gy*t )
          ylmd(i,3) = a* ( 8*gx*gz/gr3   - gx*gz*t )
       enddo
    else if(is == 12) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          t   = 3*(5*d-e)/gr5
          ylmd(i,1) = a* ( -2*gx*gy/gr3 - gx*gy*t )
          ylmd(i,2) = a* ( -2*c/gr3     - c*t     + (5*d-e)/gr3 )
          ylmd(i,3) = a* ( 8*gy*gz/gr3  - gy*gz*t )
       enddo
    else if(is == 13) then
       a = dsqrt(105.d0/(16*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          t = 3*(b-c)/gr5
          ylmd(i,1) = a* ( -gx*gz*t + 2*gx*gz/gr3 )
          ylmd(i,2) = a* ( -gy*gz*t - 2*gy*gz/gr3 )
          ylmd(i,3) = a* ( -d*t     + (b-c)/gr3 )
       enddo
    else if(is == 14) then
       a = dsqrt(105.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          ylmd(i,1) = a* ( -3*b*gy*gz/gr5   + gy*gz/gr3 )
          ylmd(i,2) = a* ( -3*gx*c*gz/gr5   + gx*gz/gr3 )
          ylmd(i,3) = a* ( -3*gx*gy*d/gr5   + gx*gy/gr3 )
       enddo
    else if(is == 15) then
       a = dsqrt(35.d0/(32*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          t   = 3*(b-3*c)/gr5
          ylmd(i,1) = a* ( -b*t     + 3*(b-c)/gr3 )
          ylmd(i,2) = a* ( -gx*gy*t - 6*gx*gy/gr3 )
          ylmd(i,3) = a* ( -gx*gz*t )
       enddo
    else if(is == 16) then
       a = dsqrt(35.d0/(32*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          t   = 3*(3*b-c)/gr5
          ylmd(i,1) = a* ( -t*gx*gy  + 6*gx*gy/gr3 )
          ylmd(i,2) = a* ( -t*c      + 3*(b-c)/gr3 )
          ylmd(i,3) = a* ( -t*gy*gz )
       enddo
    else if(is == 17) then
       a = 3.d0/8.d0/dsqrt(PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 20*d*(7*d - 6*e)/e3
          ylmd(i,1) = a* ( -60*gx*d/e2 - t*gx )
          ylmd(i,2) = a* ( -60*gy*d/e2 - t*gy )
          ylmd(i,3) = a* ( 10*gz*d/e2  - t*gz + 10*gz*(7*d-6*e)/e2 )
       enddo
    else if(is == 18) then
       a = 15.d0/4.d0/dsqrt(10*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 4*(7*d - 3*e)/e3
          ylmd(i,1) = a* ( -6*b*gz/e2     - t*b*gz + gz*(7*d-3*e)/e2 )
          ylmd(i,2) = a* ( -6*gx*gy*gz/e2 - t*gx*gy*gz )
          ylmd(i,3) = a* ( 8*gx*d/e2      - t*gx*d + gx*(7*d-3*e)/e2 )
       enddo
    else if(is == 19) then
       a = 15.d0/4.d0/dsqrt(10*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 4*(7*d-3*e)/e3
          ylmd(i,1) = a* ( -6*gx*gy*gz/e2 - t*gx*gy*gz )
          ylmd(i,2) = a* ( -6*c*gz/e2     - t*c*gz     + gz*(7*d-3*e)/e2 )
          ylmd(i,3) = a* ( 8*gy*d/e2      - t*gy*d     + gy*(7*d-3*e)/e2 )
       enddo
    else if(is == 20) then
       a = 15.d0/8.d0/dsqrt(5*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 4*(b-c)*(7*d-e)/e3
          ylmd(i,1) = a* ( -2*gx*(b-c)/e2 - t*gx + 2*gx*(7*d-e)/e2 )
          ylmd(i,2) = a* ( -2*gy*(b-c)/e2 - t*gy - 2*gy*(7*d-e)/e2 )
          ylmd(i,3) = a* ( 12*gz*(b-c)/e2 - t*gz )
       enddo
    else if(is == 21) then
       a = 15.d0/4.d0/dsqrt(5*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 4*(7*d-e)/e3
          ylmd(i,1) = a* ( -2*b*gy/e2 - t*b*gy + gy*(7*d-e)/e2 )
          ylmd(i,2) = a* ( -2*gx*c/e2 - t*gx*c + gx*(7*d-e)/e2 )
          ylmd(i,3) = a* ( 12*gx*gy*gz/e2 - t*gx*gy*gz )
       enddo
    else if(is == 22) then
       a = 105.d0/4.d0/dsqrt(70*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 4*(b-3*c)/e3
          ylmd(i,1) = a* ( -t*b*gz     + 3*gz*(b-c)/e2 )
          ylmd(i,2) = a* ( -t*gx*gy*gz - 6*gx*gy*gz/e2 )
          ylmd(i,3) = a* ( -t*gx*d     + gx*(b-3*c)/e2 )
       enddo
    else if(is == 23) then
       a = 105.d0/4.d0/dsqrt(70*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 4*(3*b-c)/e3
          ylmd(i,1) = a* ( -t*gx*gy*gz + 6*gx*gy*gz/e2 )
          ylmd(i,2) = a* ( -t*c*gz     + 3*gz*(b-c)/e2 )
          ylmd(i,3) = a* ( -t*gy*d     + gy*(3*b-c)/e2 )
       enddo
    else if(is == 24) then
       a = 105.d0/16.d0/dsqrt(35*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t = 4*(-4*b*c+(b-c)**2)/e3
          ylmd(i,1) = a* ( -t*gx + (-8*gx*c+4*gx*(b-c))/e2 )
          ylmd(i,2) = a* ( -t*gy + (-8*b*gy-4*gy*(b-c))/e2 )
          ylmd(i,3) = a* ( -t*gz )
       enddo
    else if(is == 25) then
       a = 105.d0/4.d0/dsqrt(35*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc_kngp_l(i,1) + b2x*ngabc_kngp_l(i,2) + b3x*ngabc_kngp_l(i,3)
          gy = b1y*ngabc_kngp_l(i,1) + b2y*ngabc_kngp_l(i,2) + b3y*ngabc_kngp_l(i,3)
          gz = b1z*ngabc_kngp_l(i,1) + b2z*ngabc_kngp_l(i,2) + b3z*ngabc_kngp_l(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t = 4*(b-c)/e3
          ylmd(i,1) = a* ( -t*b*gy + gy*(3*b-c)/e2 )
          ylmd(i,2) = a* ( -t*gx*c + gx*(b-3*c)/e2 )
          ylmd(i,3) = a* ( -t*gx*gy*gz )
       enddo
    end if
  end subroutine m_pwBS_sphrp2_diff_3D

!===============================================================================
  subroutine m_pwBS_generate_G_vectors_3D

    real(kind=DP)         :: gmax2, gmax2_pstrn
    real(kind=DP), allocatable, dimension(:,:,:) :: G_length_in_cube
    real(kind=DP), allocatable, dimension(:)     :: gr_t !d(kgp)
    integer               :: id_sname = -1

!--for 3D
    integer, allocatable, dimension(:)    :: kgp_buff
    integer, allocatable, dimension(:)    :: kgp_addr
    integer, allocatable, dimension(:,:)  :: ngabc_wk  !d(kgp,3)
    real(kind=DP) :: rd
    real(kind=DP), allocatable, dimension(:)     :: gmaxp_length
    integer       :: kgp_wk,i,nn,ierr
! =========== KT_add ================================ 13.0F
    real(kind=DP)         :: gmax2_exx
! =================================================== 13.0F

      allocate(gmaxp_length(0:nrank_g))
      rd = gmaxp/(DBLE(nrank_g)**(1.0d0/3.0d0))
      do i = 1,nrank_g - 1
          gmaxp_length(i) = rd *( DBLE(i)**(1.0d0/3.0d0))
      enddo
      gmaxp_length(0) = 0
      gmaxp_length(nrank_g) = gmaxp
      allocate(kgp_buff(0:nrank_g-1))
      allocate(kgp_addr(0:nrank_g-1))
      kgp_buff = 0
      kgp_addr = 0

    call tstatc0_begin('m_pwBS_generate_G_vectors ',id_sname)

    gmax2 = gmax*2
    gmax2_pstrn = gmax_positron*2
! =========== KT_add ================================ 13.0F
    gmax2_exx = gmax_exx*2
! =================================================== 13.0F
    call adjust_n_rGv_to_2l3m5n  ! -(contained here) fft_box_size_WF,CD -> n_rGV,n_rGpv

    allocate(G_length_in_cube(2*n_rGpv(1)+3,2*n_rGpv(2)+3, 2*n_rGpv(3)+3))
                                                     __TIMER_FJ_START(42)
    call count_Gvectors_in_spheres
                                                     __TIMER_FJ_STOP(42)

    call G_vectors_alloc           ! ngabc

    allocate(ngabc_wk(kgp_wk,3))
    allocate(gr_t(kgp_wk))

!f    allocate(gr_t(kgp))

                                                     __TIMER_FJ_START(43)
    call get_Gvectors_in_a_gmaxp_sphere
                                                     __TIMER_FJ_STOP(43)

!comm
! interface for ngabc
                                                     __TIMER_FJ_START_w_BARRIER(mpi_comm_group,44)
    call mpi_allgather(kgp_wk,1,mpi_integer,kgp_buff(0),1,mpi_integer,mpi_ke_world,ierr)
      do i = 1,nrank_g-1
        kgp_addr(i) = kgp_buff(i-1) + kgp_addr(i-1)
      enddo

   call mpi_allgatherv(ngabc_wk(1,1),kgp_wk,mpi_integer,ngabc(1,1),kgp_buff,kgp_addr,mpi_integer,mpi_ke_world,ierr)
   call mpi_allgatherv(ngabc_wk(1,2),kgp_wk,mpi_integer,ngabc(1,2),kgp_buff,kgp_addr,mpi_integer,mpi_ke_world,ierr)
   call mpi_allgatherv(ngabc_wk(1,3),kgp_wk,mpi_integer,ngabc(1,3),kgp_buff,kgp_addr,mpi_integer,mpi_ke_world,ierr)
                                                     __TIMER_FJ_STOP(44)

    deallocate(kgp_buff,kgp_addr,ngabc_wk,gr_t)
!f    deallocate(gr_t)
    deallocate(G_length_in_cube)
    deallocate(gmaxp_length)

    if(ipri>=1) write(nfout,*) ' !kg  = ', kg
    if(ipri>=1) write(nfout,*) ' !kgp = ', kgp
    if(ipri>=1) write(nfout,*) ' !kgp_reduced = ',kgp_reduced

    if(sw_positron /= OFF .and. ipri>=1) write(nfout,*) ' !kg_pwf = ', kg_pwf
    call tstatc0_end(id_sname)
  contains
    subroutine get_Gvectors_in_a_gmaxp_sphere
      integer             :: i, j, k
      real(kind=DP)       :: length_of_Gvector

      call getttr(rltv,ttr)     

      kg = 0
      kgp_wk = 0
!!$      if(sw_positron /= OFF) kg_pwf = 0
                                                     __TIMER_INIDO_START(1347)
      do k = -n_rGpv(3)-1, n_rGpv(3)+1
         do j = -n_rGpv(2)-1, n_rGpv(2)+1
            do i = -n_rGpv(1)-1, n_rGpv(1)+1
               length_of_Gvector = G_length_in_cube(i+n_rGpv(1)+2,j+n_rGpv(2)+2, k+n_rGpv(3)+2)
!!$               length_of_Gvector = dsqrt(ttr(1)*i*i+ttr(2)*j*j+ttr(3)*k*k &
!!$                    &                  + ttr(4)*i*j+ttr(5)*j*k+ttr(6)*k*i)
               if(length_of_Gvector <= gmax2) kg  = kg + 1
!!$               if(sw_positron/=OFF .and. length_of_Gvector<=gmax2_pstrn) kg_pwf=kg_pwf+1
!f               if(length_of_Gvector <= gmaxp) then
     if( myrank_g == 0 ) then
               if((length_of_Gvector >= gmaxp_length(myrank_g  )) .and.  &
  &               (length_of_Gvector <= gmaxp_length(myrank_g+1)) ) then
                  kgp_wk = kgp_wk + 1
                  ngabc_wk(kgp_wk,1) = i
                  ngabc_wk(kgp_wk,2) = j
                  ngabc_wk(kgp_wk,3) = k
                  gr_t(kgp_wk) = length_of_Gvector
               endif
     else
               if((length_of_Gvector >  gmaxp_length(myrank_g  )) .and.  &
  &               (length_of_Gvector <= gmaxp_length(myrank_g+1)) ) then
                  kgp_wk = kgp_wk + 1
                  ngabc_wk(kgp_wk,1) = i
                  ngabc_wk(kgp_wk,2) = j
                  ngabc_wk(kgp_wk,3) = k
                  gr_t(kgp_wk) = length_of_Gvector
               endif
     endif
            enddo
         enddo
      enddo
                                                     __TIMER_INIDO_STOP(1347)
      if(ipri >= 2) then
         write(nfout,'(" -- gr_t -- <<m_pwBS_generate_G_vectors>>")') 
         do i = 1, min(20, kgp_wk)
! === DEBUG by tkato 2013/11/05 ================================================
!           write(nfout,'(" gr(",3i4,") = ",d12.4)') ngabc(i,1),ngabc(i,2),ngabc(i,3),gr_t(i)
            write(nfout,'(" gr(",3i4,") = ",d12.4)') ngabc_wk(i,1),ngabc_wk(i,2),ngabc_wk(i,3),gr_t(i)
! ==============================================================================
         end do
      end if

#ifdef _HEAP_SORT_
     ! Sorting G using heap sorting (M.Okamoto)
!!$      call sort_gvec_heap(ttr,kgp,kgp,ngabc)
!!$      call shellsort(nfout,ipri,ttr,kgp,kgp,ngabc)
      !!$call sort_gvec_heap2(ttr,kgp,kgp,ngabc,gr_t)
!f      call sort_gvec_heap3(ttr,kgp,kgp,ngabc,gr_t)
                                                     __TIMER_INIDO_START(1348)
      call sort_gvec_heap3(ttr,kgp_wk,kgp_wk,ngabc_wk,gr_t)
                                                     __TIMER_INIDO_STOP(1348)
      if(ipri >= 2) then
         write(nfout,'(" -- gr after (sort_gvec_heap2) -- <<m_pwBS_generate_G_vectors>>")') 
         do i = 1, min(20, kgp_wk)
! === DEBUG by tkato 2013/11/05 ================================================
!           write(nfout,'(" gr(",3i4,") = ",d12.4)') ngabc(i,1),ngabc(i,2),ngabc(i,3),gr_t(i)
            write(nfout,'(" gr(",3i4,") = ",d12.4)') ngabc_wk(i,1),ngabc_wk(i,2),ngabc_wk(i,3),gr_t(i)
! ==============================================================================
         end do
      end if
!f      call shellsort2(nfout,ipri,ttr,kgp,kgp,ngabc,gr_t)
                                                     __TIMER_INIDO_START(1349)
      call shellsort2(nfout,ipri,ttr,kgp_wk,kgp_wk,ngabc_wk,gr_t)
                                                     __TIMER_INIDO_STOP(1349)
#elif _SIMPLE_SORT_
     ! Sorting G simply (M.Okamoto)
                                                     __TIMER_INIDO_START(1350)
      call sort_gvec_simple(ttr,kgp,kgp,ngabc)
                                                     __TIMER_INIDO_STOP(1350)
#else
     ! _BLUGEL_SORT_ ! Sorting G by Blugel
!!$      call gsort(ttr,kgp,kgp,ngabc)
!!$      call shellsort(nfout,ipri,ttr,kgp,kgp,ngabc)
      call gsort2(ttr,kgp,kgp,ngabc,gr_t)
      call shellsort2(nfout,ipri,ttr,kgp,kgp,ngabc,gr_t)
#endif
      if(ipri >= 2) then
         write(nfout,'(" -- gr after sorted -- <<m_pwBS_generate_G_vectors>>")') 
         do i = 1, min(20, kgp_wk)
! === DEBUG by tkato 2013/11/05 ================================================
!           write(nfout,'(" gr(",3i4,") = ",d12.4)') ngabc(i,1),ngabc(i,2),ngabc(i,3),gr_t(i)
            write(nfout,'(" gr(",3i4,") = ",d12.4)') ngabc_wk(i,1),ngabc_wk(i,2),ngabc_wk(i,3),gr_t(i)
! ==============================================================================
         end do
      end if

    end subroutine get_Gvectors_in_a_gmaxp_sphere

    subroutine count_Gvectors_in_spheres()
      integer i, j, k
      integer, parameter  :: DP = kind(1.d0)
      real(kind=DP)       :: length_of_Gvector
      call getttr(rltv,ttr)
      kg = 0
      kgp = 0
      kgp_reduced = 0
      kg0 = 0
!f-----
      kgp_wk = 0
!------
! =========== KT_add ================================ 13.0F
      if (sw_hybrid_functional /= OFF .and. use_fft_exx ) then
         kg_exx = 0
      endif
      if (sw_hybrid_functional /= OFF ) kgp_exx = 0
! =================================================== 13.0F

! ==== KT_add ============= 13.0U2
      if ( sw_modified_TFW_functional /= OFF ) kg_tfw = 0
! ========================= 13.0U2

      if(sw_positron /= OFF) kg_pwf = 0
                                                     __TIMER_INIDO_START(1351)
      do k = -n_rGpv(3)-1, n_rGpv(3)+1
         do j = -n_rGpv(2)-1, n_rGpv(2)+1
            do i = -n_rGpv(1)-1, n_rGpv(1)+1
               length_of_Gvector = dsqrt(ttr(1)*i*i + ttr(2)*j*j &
                    &                  + ttr(3)*k*k + ttr(4)*i*j &
                    &                  + ttr(5)*j*k + ttr(6)*k*i)
               if(length_of_Gvector <= gmax2) kg = kg + 1
               if(length_of_Gvector <= gmax)  kg0 = kg0 + 1
               if(sw_positron/=OFF .and. length_of_Gvector<=gmax2_pstrn) kg_pwf=kg_pwf+1
! =========== KT_add ================================ 13.0F
               if(sw_hybrid_functional/=OFF .and. use_fft_exx ) then
                  if ( length_of_Gvector<=gmax2_exx) then
                     kg_exx = kg_exx +1
                  endif
               endif
               if(sw_hybrid_functional /= OFF) then
                  if( length_of_Gvector <= gmaxp_exx) then
                     kgp_exx = kgp_exx+1
                  endif
               endif
! =================================================== 13.0F

! ============ KT_add ========== 13.0U2
               if ( sw_modified_TFW_functional /= OFF ) then
                  if ( length_of_Gvector<= gmaxp/2 ) then
                     kg_tfw = kg_tfw +1
                  endif
               endif
! ============================== 13.0U2

               if(length_of_Gvector <= gmaxp) kgp = kgp + 1
               if(length_of_Gvector <= gmaxp_reduced) kgp_reduced = kgp_reduced + 1
               G_length_in_cube(i+n_rGpv(1)+2,j+n_rGpv(2)+2, k+n_rGpv(3)+2) = length_of_Gvector
!f-----
     if( myrank_g == 0 ) then
               if((length_of_Gvector >= gmaxp_length(myrank_g  )) .and.  &
  &               (length_of_Gvector <= gmaxp_length(myrank_g+1)) ) then
                  kgp_wk = kgp_wk + 1
               endif
     else
               if((length_of_Gvector >  gmaxp_length(myrank_g  )) .and.  &
  &               (length_of_Gvector <= gmaxp_length(myrank_g+1)) ) then
                  kgp_wk = kgp_wk + 1
               endif
     endif
!----
            enddo
         enddo
      enddo
                                                     __TIMER_INIDO_STOP(1351)
      if(ipri >= 1) then
         write(nfout,'(" !pwBS kg0, kg, kgp = ",3i10)') kg0, kg, kgp
         write(nfout,'(" !pwBS   kg0 = (#G(<=Gmax)), kg = (#G(<=2Gmax)), kgp = (#G(<=Gmaxp))")')
      end if
    end subroutine count_Gvectors_in_spheres

    subroutine adjust_n_rGv_to_2l3m5n
      integer :: i
      do i = 1, 3
         if(n_rGv(i) > fft_box_size_WF(i,1)/2) n_rGv(i)   = fft_box_size_WF(i,1)/2
         if(n_rGpv_reduced(i) > fft_box_size_CD(i,1)/2) n_rGpv(i) = fft_box_size_CD(i,1)/2
      enddo
    end subroutine adjust_n_rGv_to_2l3m5n
  end subroutine m_pwBS_generate_G_vectors_3D

  subroutine m_pwBS_sphrp_exx(is,rltv,ista_ylm,iend_ylm,gqmk,gqmkr,ylm)
    integer, intent(in) :: is
    real(kind=DP), intent(in), dimension(3,3)  :: rltv
    integer, intent(in) :: ista_ylm, iend_ylm
    real(kind=DP), intent(in), dimension(ista_ylm:iend_ylm,3) :: gqmk
    real(kind=DP), intent(inout), dimension(ista_ylm:iend_ylm) :: gqmkr
    real(kind=DP), intent(out), dimension(ista_ylm:iend_ylm) :: ylm
!!$C spherical harmonics.
!!$c     Some lines are rewritten by T.Yamasaki according to Y.Morikawa's
!!$c   e-mail. at 4th May 1994

    integer :: i,ni
    real(kind=DP) a,b,c,d,e,f,gx,gy,gz
    real(kind=DP) b1x,b1y,b1z,b2x,b2y,b2z,b3x,b3y,b3z
    real(kind=DP) :: gqmkr0

    b1x = rltv(1,1);  b1y = rltv(2,1);  b1z = rltv(3,1)
    b2x = rltv(1,2);  b2y = rltv(2,2);  b2z = rltv(3,2)
    b3x = rltv(1,3);  b3y = rltv(2,3);  b3z = rltv(3,3)

    ni = 0
    do i=ista_ylm,iend_ylm
       if(gqmkr(i) < DELTA) then
          ni = i
          gqmkr0 = gqmkr(i)
          gqmkr(i) = 1.d0
       end if
    end do

    if(is == 1) then
       a = dsqrt(1.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          ylm(i) = a
       end do
    else if(is == 2) then
       a = dsqrt(3.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          ylm(i) = a*gx/gqmkr(i)
       end do
    else if(is == 3) then
       a = dsqrt(3.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gy =   b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          ylm(i) = a*gy/gqmkr(i)
       end do
    else if(is == 4) then
       a = dsqrt(3.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gz =   b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          ylm(i) = a*gz/gqmkr(i)
       end do
    else if(is == 5) then
       a = dsqrt(5.d0/(16*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          d = gz**2
          e = gx**2+gy**2+d
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(3*d-e)/e
          if(abs(e) > tiny(e)) then
             ylm(i) = a*(3*d-e)/e
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 6) then
       a = dsqrt(15.d0/(16*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          e = b+c+gz**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(b-c)/e
          if(abs(e) > tiny(e)) then
             ylm(i) = a*(b-c)/e
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 7) then
       a = dsqrt(15.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          e = gqmkr(i)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gx*gy/e
          if(abs(e) > tiny(e)) then
             ylm(i) = a*gx*gy/e
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 8) then
       a = dsqrt(15.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          e = gqmkr(i)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gy*gz/e
          if(abs(e) > tiny(e)) then
             ylm(i) = a*gy*gz/e
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 9) then
       a = dsqrt(15.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          e = gqmkr(i)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gz*gx/e
          if(abs(e) > tiny(e)) then
             ylm(i) = a*gz*gx/e
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 10) then
       a = dsqrt(7.d0/(16*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e * gqmkr(i)
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gz*(5*d-3*e)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gz*(5*d-3*e)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 11) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e * gqmkr(i)
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gx*(5*d-e)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gx*(5*d-e)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 12) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e * gqmkr(i)
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gy*(5*d-e)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gy*(5*d-e)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 13) then
       a = dsqrt(105.d0/(16*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          e = gqmkr(i)**2
          f = e * gqmkr(i)
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gz*(b-c)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gz*(b-c)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 14) then
       a = dsqrt(105.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          f = gqmkr(i)**3
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gx*gy*gz/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gx*gy*gz/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 15) then
       a = dsqrt(35.d0/(32*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          f = gqmkr(i)**3
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gx*(b-3*c)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gx*(b-3*c)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 16) then
       a = dsqrt(35.d0/(32*pai))
       do i = ista_ylm, iend_ylm !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          f = gqmkr(i)**3
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gy*(3*b-c)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gy*(3*b-c)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 17) then
       a = 3.d0/8.d0/dsqrt(PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(5*d*(7*d-6*e)/f+3.d0)
          if(abs(f) > tiny(f)) then
             ylm(i) = a*(5*d*(7*d-6*e)/f+3.d0)
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 18) then
       a = 15.d0/4.d0/dsqrt(10*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gz*gx*(7*d-3*e)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gz*gx*(7*d-3*e)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 19) then
       a = 15.d0/4.d0/dsqrt(10.d0*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gy*gz*(7*d-3*e)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gy*gz*(7*d-3*e)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 20) then
       a = 15.d0/8.d0/dsqrt(5*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b+c+d
          f = e**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(7*d-e)*(b-c)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*(7*d-e)*(b-c)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 21) then
       a = 15.d0/4.d0/dsqrt(5*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(7*d-e)*gx*gy/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*(7*d-e)*gx*gy/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 22) then
       a = 105.d0/4.d0/dsqrt(70*pai)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(b-3*c)*gz*gx/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*(b-3*c)*gz*gx/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 23) then
       a = 105.d0/4.d0/dsqrt(70*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(3.d0*b-c)*gy*gz/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*(3.d0*b-c)*gy*gz/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 24) then
       a = 105.d0/16.d0/dsqrt(35*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*((b-c)**2-4*b*c)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*((b-c)**2-4*b*c)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 25) then
       a = 105.d0/4.d0/dsqrt(35*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(b-c)*gx*gy/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*(b-c)*gx*gy/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    end if

    if(ni > 0) then
       ylm(ni) = dsqrt(1.d0/PAI4)
       gqmkr(ni) = gqmkr0
    end if
  end subroutine m_pwBS_sphrp_exx

!----- for ngabc
  subroutine m_pwBS_set_ngabc_kngp_l_3D
    integer       :: i,j,k

    allocate(ngabc_kngp_l(ista_kngp:iend_kngp,3))
    do j = ista_kngp, iend_kngp
      ngabc_kngp_l(j,1) = ngabc(j,1)
      ngabc_kngp_l(j,2) = ngabc(j,2)
      ngabc_kngp_l(j,3) = ngabc(j,3)
    end do

  end subroutine m_pwBS_set_ngabc_kngp_l_3D

  subroutine m_pwBS_set_ngabc_3D
    integer       :: i,j,k
    integer, allocatable, dimension(:,:)    :: ngabc_kg

    if( kg .ne. kgp) then
       allocate(ngabc_kg(kg,3))
       do i = 1,kg
         ngabc_kg(i,1) = ngabc(i,1)
         ngabc_kg(i,2) = ngabc(i,2)
         ngabc_kg(i,3) = ngabc(i,3)
       end do

       deallocate(ngabc) 
       allocate(ngabc(kg,3))
       do i = 1,kg
         ngabc(i,1) = ngabc_kg(i,1)
         ngabc(i,2) = ngabc_kg(i,2)
         ngabc(i,3) = ngabc_kg(i,3)
       end do
       deallocate(ngabc_kg) 
    endif

  end subroutine m_pwBS_set_ngabc_3D

  subroutine m_pwBS_set_ngabc_B_3D
    integer       :: i,j,k
    if(allocated(ngabc_kngp_B_l)) deallocate(ngabc_kngp_B_l)
    allocate(ngabc_kngp_B_l(ista_kngp_B:iend_kngp_B,3))
    do i = ista_kngp_B, iend_kngp_B
      ngabc_kngp_B_l(i,1) = ngabc(i,1)
      ngabc_kngp_B_l(i,2) = ngabc(i,2)
      ngabc_kngp_B_l(i,3) = ngabc(i,3)
    end do

  end subroutine m_pwBS_set_ngabc_B_3D

  subroutine pre_charge_average_3D
    integer ::       no, no1, no2, ng, ngp
    real(kind=DP) :: tx,ty,tz

    no1 = 1; no2 = nopr + af

    allocate(fp_l(ista_kngp:iend_kngp,no1:no2)); fp_l = 0.d0

    do no = no1, no2
       tx = tau(1,no,BUCS)*PAI2
       ty = tau(2,no,BUCS)*PAI2
       tz = tau(3,no,BUCS)*PAI2
          do ng = ista_kngp, iend_kngp !for mpi
             ngp = ngpt_l(ng,no)
             fp_l(ng,no) = ngabc(ngp,1)*tx + ngabc(ngp,2)*ty + ngabc(ngp,3)*tz
          end do
    end do
  end subroutine pre_charge_average_3D

  subroutine m_pwBS_dealloc_ngabc
    if(allocated(ngabc)) deallocate(ngabc)
  end subroutine m_pwBS_dealloc_ngabc

! ==== EXP_CELLOPT === 2015/09/24
  subroutine m_pwBS_store_prev_kg1_kgp
    kg1_prev = kg1;   kgp_prev = kgp
    if ( mype == 0 ) then
       write(nfout,*) '** kg1_prev is ', kg1_prev
       write(nfout,*) '** kgp_prev is ', kgp_prev
    endif
  end subroutine m_pwBS_store_prev_kg1_kgp
! =================== 2015/09/24

  subroutine m_pwBS_wd_curr_pws()
    use m_Files, only : m_Files_open_pwbs, m_Files_close_pwbs, nfpwbs
    integer, allocatable, dimension(:) :: igfp_l_t
    integer :: i,ierrr
    allocate(igfp_l_t(kgp));igfp_l_t=0
    do i=ista_kngp, iend_kngp 
       igfp_l_t(i) = igfp_l(i)
    enddo
    call mpi_allreduce(mpi_in_place,igfp_l_t,kgp,mpi_integer,mpi_sum,mpi_chg_world,ierr)
    call m_Files_open_pwbs()
    if(mype==0)then
    write(nfpwbs) kg1,kg,size(nbase,1),kgp_reduced,neg
    write(nfpwbs) fft_box_size_WF
    write(nfpwbs) nbase
    if(kg_gamma>0)then
    write(nfpwbs) kg_gamma
    write(nfpwbs) nbase_gamma
    endif
    write(nfpwbs) igf
    write(nfpwbs) iba
    write(nfpwbs) fft_box_size_CD
    write(nfpwbs) fft_box_size_CD_nonpara
    write(nfpwbs) kgp
    write(nfpwbs) igfp_l_t
    write(nfpwbs) univol
    endif
    call m_Files_close_pwbs()
    deallocate(igfp_l_t)
  end subroutine m_pwBS_wd_curr_pws

  subroutine m_pwBS_rd_prev_pws(rd)
    use m_Files, only : m_Files_open_pwbs, m_Files_close_pwbs, nfpwbs, F_PWBS
    use m_Parallelization, only : m_Parallel_init_mpi_iba_3D_prev
    use m_Const_Parameters, only : ON
    use m_Control_Parameters, only : sw_communicator_for_chg
    logical, intent(out) :: rd
    integer :: i,ierr,kgtmp,kggammatmp,kgtmp2
    integer, allocatable, dimension(:) :: igfp_l_t
    logical :: logi
    rd = .false.
    inquire(file=F_PWBS,exist=logi)
    if(.not. logi) then
      if(printable) write(nfout,'(a)') '!** pwbs file '//F_PWBS//' does not exist'
      return
    endif
    call m_Files_open_pwbs()
    if(mype==0)then
    read(nfpwbs,err=100,end=100) kg1_prev,kgtmp,kgtmp2,kgp_reduced_prev,neg_previous
    read(nfpwbs,err=100,end=100) fft_box_size_WF_prev
    endif
    call mpi_bcast(kg1_prev,1,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(kgtmp,1,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(kgtmp2,1,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(kgp_reduced_prev,1,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(neg_previous,1,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(fft_box_size_WF_prev,6,mpi_integer,0,mpi_comm_group,ierr)

    if(allocated(nbase_prev)) deallocate(nbase_prev)
    allocate(nbase_prev(kgtmp2,kv3))
    if(allocated(igf_prev)) deallocate(igf_prev)
    allocate(igf_prev(kgtmp))
    if(allocated(iba_prev)) deallocate(iba_prev)
    allocate(iba_prev(kv3))
    if(mype==0) then
      read(nfpwbs,err=100,end=100) nbase_prev
    endif
    call mpi_bcast(nbase_prev,kgtmp2*kv3,mpi_integer,0,mpi_comm_group,ierr)
    if(kg_gamma>0)then
      if(mype==0) then
        read(nfpwbs,err=100,end=100) kggammatmp
      endif
      call mpi_bcast(kggammatmp,1,mpi_integer,0,mpi_comm_group,ierr)
      if(allocated(nbase_gamma_prev)) deallocate(nbase_gamma_prev)
      allocate(nbase_gamma_prev(kggammatmp,2))
      if(mype==0)then
        read(nfpwbs,err=100,end=100) nbase_gamma_prev
      endif
      call mpi_bcast(nbase_gamma_prev,kggammatmp*2,mpi_integer,0,mpi_comm_group,ierr)
    endif
    if(mype==0) then
      read(nfpwbs,err=100,end=100) igf_prev
      read(nfpwbs,err=100,end=100) iba_prev
    endif
    call mpi_bcast(igf_prev,kgtmp,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(iba_prev,kv3,mpi_integer,0,mpi_comm_group,ierr)
    call m_Parallel_init_mpi_iba_3D_prev(kv3,iba_prev)

    if(mype==0)then
      read(nfpwbs,err=100,end=100) fft_box_size_CD_prev
      read(nfpwbs,err=100,end=100) fft_box_size_CD_nonpara_prev
      read(nfpwbs,err=100,end=100) kgp_prev
    endif
    call mpi_bcast(fft_box_size_CD_prev,6,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(fft_box_size_CD_nonpara_prev,3,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(kgp_prev,1,mpi_integer,0,mpi_comm_group,ierr)
    call m_Parallel_init_mpi_kngp_prev_3D(kgp_prev,sw_communicator_for_chg==ON)
    allocate(igfp_l_t(kgp_prev));igfp_l_t=0
    if(allocated(igfp_l_prev)) deallocate(igfp_l_prev)
    allocate(igfp_l_prev(ista_kngp_prev:iend_kngp_prev));igfp_l_prev=0
    if(mype==0) read(nfpwbs,err=100,end=100) igfp_l_t
    call mpi_bcast(igfp_l_t,kgp_prev,mpi_integer,0,mpi_comm_group,ierr)
    do i=ista_kngp_prev,iend_kngp_prev
       igfp_l_prev(i) = igfp_l_t(i)
    enddo
    deallocate(igfp_l_t)
    if(mype==0) read(nfpwbs,err=100,end=100) univol_prev
    call mpi_bcast(univol_prev,1,mpi_double_precision,0,mpi_comm_group,ierr)

    call m_Files_close_pwbs()
    if(printable) write(nfout,'(a)') ' !** read pwbs from file'
    rd = .true.
    return
100 continue
    if(mype==0) write(nfout,'(a)') ' !** encountered error while reading data from '//F_PWBS
  end subroutine m_pwBS_rd_prev_pws

end module m_PlaneWaveBasisSet

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 599 $)
!
!  PROGRAM: EPSMAIN
!
!  AUTHOR(S): T. Hamada   MAY/8/2007
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!
program EPSMAIN
! $Id: epsmain.f90 599 2019-12-03 05:25:28Z ktagami $
!
  implicit none
! === DEBUG by tkato 2013/10/16 ================================================
! logical  :: EigenValues_are_Converged, AllKpoints_are_Calculated
  logical  :: EigenValues_are_Converged, AllKpoints_are_Calculated2
! ==============================================================================
  logical  :: Already_Converged
  logical  :: Ending_Time

  logical  :: all_conv = .true.
! === DEBUG by tkato 2013/10/16 ================================================
  integer :: nk = 0
! ==============================================================================
! --------------------T. Hamada 2021.9.28 --------------------
  logical  :: EPS_Prep_Check
!-------------------------------------------------------------

  call Initialization_set_ekmode_ON  ! set `ekmode' ON in m_Control_Parameters
  call Initialization(1)             ! Initialization of mpi and file-setting
  call InputData_Analysis
  call Preparation(0)                ! Basis set, symmetry check etc.
  call Preparation_for_mpi_ek        ! mpi  -> np_g1k, mp_g1k
  call Preparation_for_mpi(1)        ! mpi
  call PseudoPotential_Construction
  call Preparation_for_mpi_PAW()
  call Ewald_and_Structure_Factor    ! Calculate Structure Factor
  call Initial_Electronic_Structure()! read Charge Density, (lclchh)
  call Initialization_Epsilon(0)     ! Epsilon
  call Shift_Kpoint                  ! for Effective mass calculation  ! Epsilon

  KPOINTS: do
! === DEBUG by tkato 2013/10/16 ================================================
!    call KpointNumber_Setting()
     call KpointNumber_Setting2()
! ==============================================================================
     call Preparation_ek             ! (basnum)
     call Preparation_for_mpi_ek     ! mpi  -> np_g1k, mp_g1k
! === For epsmain by tkato 2013/11/14 ==========================================
     call epsmain_reallocate()
! ==============================================================================
     call PseudoPotential_ek_Epsilon ! (kbint)                         ! Epsilon
     call Initial_WaveFunctions_ek   ! (rndzaj|rdzaj),(fsrfsi),(lclchh)
     if(.not.Already_Converged()) then
        all_conv = .false.
        SolveWaveFunctions: do
!-------------------- T. Hamada 2021.9.28 --------------------
           if(EPS_Prep_Check())              exit KPOINTS
! ------------------------------------------------------------
           if(Ending_Time())                 exit KPOINTS
           call IterationNumber_Setting()
           call Renewal_of_WaveFunctions()
           if(EigenValues_are_Converged()) then                        ! Epsilon
              call Transition_moment_Epsilon                           ! Epsilon
              call Dealloc_Radr_and_Wos_Epsilon                        ! Epsilon
              exit SolveWaveFunctions
           end if
       enddo SolveWaveFunctions
       call Postprocessing_k()
! === DEBUG by tkato 2013/10/16 ================================================
!       if(AllKpoints_are_Calculated())  then
        if(AllKpoints_are_Calculated2(nk))  then
! ==============================================================================
           all_conv = .true.
           exit KPOINTS
        end if
     else
        exit KPOINTS
     end if
  enddo KPOINTS
!!$  else
!!$     write(6,'(" Already_Converged")')
!!$     call KpointNumber_Setting()
!!$     call Preparation_ek             ! (basnum)
!!$     call PseudoPotential_ek         ! (kbint)
!!$     call Initial_WaveFunctions_ek   ! (rndzaj|rdzaj),(fsrfsi),(lclchh)
!!$  end if

  call Postprocessing(.false.)
!-------------------- T. Hamada 2021.9.28 --------------------
!  if(all_conv.) then
  if(all_conv.or.EPS_Prep_Check()) then
!-------------------------------------------------------------
     call Reset_Kpoint                                                   ! Epsilon
     call Prep_for_Calc_Epsilon                                          ! Epsilon
     call Calc_Epsilon                                                   ! Epsilon
     call Calc_Nonlinear_optics                                          ! Epsilon
     call WriteDownData_onto_Files_Eps                                   ! Epsilon
  end if
  call WriteDownData_onto_Files_ek()
  call Finalization_of_mpi           ! mpi
end program EPSMAIN

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE:  m_Timing
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!  FURTHER MODIFICATION: T. Yamasaki, September 2009
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
!tex--\documentstyle{jarticle}
!tex--\title{module m\_Timing}
!tex--\author{T. Yamasaki}
!tex--\textwidth 480pt
!tex--\oddsidemargin -10pt
!tex--\evensidemargin 0pt
!tex--\begin{document}
!tex--\maketitle
!tex--\newenvironment{mydescription}{%
!tex--	\list{$\bullet$}{%
!tex--		\topsep 0pt \itemsep 0pt }}%
!tex--{\endlist}
!tex--
module m_Timing
!
!
! ***************************************************************
!  $Id: m_Timing.F90 570 2017-04-21 20:34:50Z yamasaki $
!
!  The first version of this module was coded by T. Yamasaki 
! (JRCAT-ATP, FUJITSU LABORATORIES Ltd.) in 1999.
!
!tex--\section{機能概要}
!tex-- サブルーチン毎、あるいは１-iteraionの時間を測定し、表示する。
!tex--\section{Using modules}
  use m_Control_Parameters, only : ipri, ipritiming, printable,num_subroutines, pcpudf &
       &                         , statistics_in_parallel, sw_flatten, sw_firstlevel_only, sw_details &
       &                         , measure_count_limit
  use m_Const_Parameters,   only : DP, ON, OFF, START,ITERATIVE,FINISH,TAG_FORMAT,TAG_LINE,TABLE,ERROR
  use m_Parallelization,    only : mpi_comm_group,npes, mype, ierr
  use m_Files,              only : nfout

  implicit none

!tex--\section{Parameters,variables,arrays}
!tex--\subsection{Public}
!tex--   none
!tex--\subsection{Private}
!tex--\begin{itemize}
!tex--      \item {\tt [MSBRNM]:} 時間測定をするsubroutineの最大数
!tex--      \item {\tt [long\_name\_size]:} 配列{\tt subroutine\_names}の各要素の制限文字数
!tex--      \item {\tt [subroutine\_names]:} suburoutine名を蓄える配列
!tex--      \item {\tt [tstart] (0:MSBRNM):} 測定開始時刻を蓄える配列
!tex--      \item {\tt [ecpu] (0:MSBRNM):} 測定した経過時間を蓄える配列。{\tt ecpu(0)}に
!tex--            はSCF１回分の経過時間が蓄えられる。
!tex--      \item {\tt [iorder] (MMSBRM):} 測定時間の大きさの順序を与える配列
!tex--      \item {\tt [n\_sub\_names]:} 測定したsubroutineの数
!tex--      \item {\tt [PCPUDF = 0.03]:} SCF-iterationの経過時間の前回の経過時間
!tex-- ({\tt ecpu\_previous})との差が{\tt PCPUDF}$\times${\tt ecpu\_previous}より大きいときに
!tex-- 測定結果を書き出す。{\tt subroutine tstatc\_wd}内で用いる。
!tex--      \item {\tt [N\_SUBROUTINES] = 10:} {\tt subroutine tstatc\_wd}で書き出すsubroutineの数の上限
!tex--\end{itemize}
!  integer, private, parameter                            :: MSBRNM         = 100
  integer, private                                       :: MSBRNM         = 100
  integer, private, parameter                            :: MSBRNM_EXT     = 10
  integer, private, parameter                            :: INCRE_MSBRNM   = 10
  integer, private, parameter                            :: long_name_size = 32
!  character(len=long_name_size),private,dimension(0:MSBRNM) :: subroutine_names
!  integer, private, dimension(0:MSBRNM)                  :: subroutine_name_length
  character(len=long_name_size),private                     :: temp_str
!  real(DP),private, dimension(0:MSBRNM)                  :: tstart=0, ecpu=0
!  integer, private, dimension(MSBRNM)                    :: iorder, counter=0
!  integer, private, dimension(MSBRNM)                    :: ilevel=-1
  character(len=long_name_size),private,allocatable      :: subroutine_names(:)
  integer, private, allocatable                          :: subroutine_name_length(:)
  real(DP),private, allocatable                          :: tstart(:), ecpu(:)
  integer, private, allocatable                          :: iorder(:), counter(:)
  integer, private, allocatable                          :: ilevel(:)
  integer, private                                       :: levelset = OFF
  integer, private                                       :: n_sub_names = 0
  real(DP),private               :: ecpu_previous = 0.d0
  real(DP),private, parameter    :: UMICRO = 1.d-6
  integer, private :: switch_of_timing = OFF
  real(DP),private :: wct_start = 0.d0
! --> T. Yamasaki, 2th Sep. 2009
  integer, private :: id_ext, id_ext_max = 0, n_allocated_subhir = 0
  integer, private, dimension(MSBRNM_EXT) :: id_ext_stack=0
  integer, private :: id_ext_pointer = 0
  type t_subhir
     integer :: id
     integer :: level
     integer :: id1
     integer :: id2
     integer :: id3
     integer :: flag
  end type t_subhir
  type(t_subhir), allocatable,  dimension(:) :: subhir
  integer,private :: level_previous,level_now=0, id123_now(1:3)=0
  real(kind=DP),private,allocatable,dimension(:) :: ecpu_ext
  integer, private, allocatable, dimension(:) :: counter_ext
  integer, private, allocatable, dimension(:) :: ip_1stlevel_subroutines
  integer :: n_1stlevel_subroutines
  integer, private, parameter :: MODE_EVALUATION = 1, MODE_WRITE = 2, MODE_SINGLE=1, MODE_PARALLEL = 2
  real(kind=DP), private :: tmp_timer_start_time=0.d0
! <--
     
!!$  real(DP),private, parameter    :: PCPUDF = 0.03
!!$  integer, private, parameter    :: N_SUBROUTINES = 20

!tex--
!tex--\section{含まれるsubroutines}
!tex-- {\tt a)tstatc0\_begin, b)tstatc0\_end, c)tstatc\_init, d)tstatc\_wd0, e)tstatc\_wd, f)tstatc\_iter}
!tex--\section{使い方}
!tex--測定したいsubroutineでは、最初に次の例のように{\tt tstatc0_begin}を呼び出し
!tex--\begin{verbatim}
!tex--    integer :: id_sname = -1
!tex--    call tstatc0_begin('FFT_WF ',id_sname)
!tex--\end{verbatim}
!tex--最後に
!tex--\begin{verbatim}
!tex--    call tstatc0_end(id_sname)
!tex--\end{verbatim}
!tex--と{\tt tstatc0_end}を呼び出す。これにより、{\tt FFT_WF}に対応する
!tex--配列に{\tt tstatc0_begin}と{\tt tstatc0_end}の間の経過時間が加えられる。
!tex--SCFの１回の経過時間は、{\tt tstatc_iter}を呼び出すことで測られる。
!tex--SCF-iterationの終りに{\tt tstatc_wd}を呼び出すと、前回の
!tex--SCF１回分の経過時間との差が3％({\tt PCPUDF})以上あれば、経過時間
!tex--の長かった方から10個(={\tt N_SUBROUTINES})の
!tex--subroutineの名前と経過時間、またその回の経過時間を出力する。
!tex--具体的には、SCF-iterationの終りに次のようにする。
!tex--\begin{verbatim}
!tex--  call tstatc_iter(iteration, first_iteration_of_this_job)
!tex--  if(iteration == first_iteration_of_this_job) then
!tex--     call tstatc_wd0
!tex--  else
!tex--     call tstatc_wd(iteration)
!tex--  end if
!tex--  call tstatc_init
!tex--\end{verbatim}
!tex--{\tt call tstatc_wd(iteration)}により次のような出力を得る。
!tex--\begin{verbatim}
!tex-- << CPU Time Consumption -- TOP  10 Subroutines (    2) >>
!tex--   1  26                           FFT_WF     1.79200(sec.) 52.58(%)
!tex--   2  31      evolve_WFs_in_MSD_direction     1.04297(sec.) 30.60(%)
!tex--   3  17                     xc_potential     0.94531(sec.) 27.74(%)
!tex--   4  19               ggaxcp(in xc_pot.)     0.89258(sec.) 26.19(%)
!tex--   5  28              energy_eigen_values     0.57715(sec.) 16.93(%)
!tex--   6  33                      CD_softpart     0.49121(sec.) 14.41(%)
!tex--   7  36   Total_Energy(including xc_pot)     0.47168(sec.) 13.84(%)
!tex--   8  18                   inverse_FFT_CD     0.23242(sec.)  6.82(%)
!tex--   9  20                    direct_FFT_CD     0.14356(sec.)  4.21(%)
!tex--  10  34                      CD_hardpart     0.13574(sec.)  3.98(%)
!tex--      Total cpu time of (        2 )-th iteration        3.40820(sec.)
!tex--\end{verbatim}
!tex--\end{document}
  include 'mpif.h'
contains

  subroutine alloc_subroutine_names_etc(n,nprev)
    integer, intent(in) :: n, nprev
    character(len=long_name_size),allocatable :: subroutine_namest(:)
    integer,  allocatable                     :: subroutine_name_lengtht(:)
    real(DP), allocatable                     :: tstartt(:), ecput(:)
    integer,  allocatable                     :: iordert(:), countert(:)
    integer,  allocatable                     :: ilevelt(:)
    if(nprev<n) then
      allocate(subroutine_namest(0:n))
      allocate(subroutine_name_lengtht(0:n))
      allocate(tstartt(0:n));tstartt=0
      allocate(ecput(0:n));ecput=0
      allocate(iordert(n))
      allocate(countert(n));countert=0
      allocate(ilevelt(n));ilevelt=-1
      subroutine_namest(0:nprev)       = subroutine_names(0:nprev)
      subroutine_name_lengtht(0:nprev) = subroutine_name_length(0:nprev)
      tstartt(0:nprev)                 = tstart(0:nprev)
      ecput(0:nprev)                   = ecpu(0:nprev)
      iordert(1:nprev)                 = iorder(1:nprev)
      countert(1:nprev)                = counter(1:nprev)
      ilevelt(1:nprev)                 = ilevel(1:nprev)
    endif
    if(allocated(subroutine_names))       deallocate(subroutine_names)
    if(allocated(subroutine_name_length)) deallocate(subroutine_name_length)
    if(allocated(tstart))                 deallocate(tstart)
    if(allocated(ecpu))                   deallocate(ecpu)
    if(allocated(iorder))                 deallocate(iorder)
    if(allocated(counter))                deallocate(counter)
    if(allocated(ilevel))                 deallocate(ilevel)
    allocate(subroutine_names(0:n))
    allocate(subroutine_name_length(0:n))
    allocate(tstart(0:n));tstart=0
    allocate(ecpu(0:n));ecpu=0
    allocate(iorder(n))
    allocate(counter(n));counter=0
    allocate(ilevel(n));ilevel=-1
    if(nprev<n) then
      subroutine_names(0:nprev)       = subroutine_namest(0:nprev)
      subroutine_name_length(0:nprev) = subroutine_name_lengtht(0:nprev)
      tstart(0:nprev)                 = tstartt(0:nprev)
      ecpu(0:nprev)                   = ecput(0:nprev)
      iorder(1:nprev)                 = iordert(1:nprev)
      counter(1:nprev)                = countert(1:nprev)
      ilevel(1:nprev)                 = ilevelt(1:nprev)
      deallocate(subroutine_namest)
      deallocate(subroutine_name_lengtht)
      deallocate(tstartt)
      deallocate(ecput)
      deallocate(iordert)
      deallocate(countert)
      deallocate(ilevelt)
    endif
  end subroutine alloc_subroutine_names_etc

  subroutine tstatc0_begin(a_sub_name,id,level)
    character(len=*), intent(in) :: a_sub_name
    integer, intent(inout) ::       id
    integer, intent(in), optional :: level

    real(kind=DP)             :: t_start
    integer                   :: i, len_str
    if(.not.allocated(subroutine_names)) then
      call alloc_subroutine_names_etc(MSBRNM,MSBRNM)
    endif

    if(switch_of_timing == OFF) then
       call gettod(wct_start)
       switch_of_timing = ON
    end if

    if(sw_firstlevel_only == ON .and. sw_details == OFF) then
         if(.not.present(level)) then
           return
         else
           if(level/=1) return
         end if
    end if
!      & (.not.present(level).or.(present(level).and.level/=1))) return

    len_str = len_trim(a_sub_name)
    if(len_str > long_name_size) len_str = long_name_size

! -- finding the pointer in subroutine_names --'
    if(id <= 0) then
       do i = 1, n_sub_names
!!$          if(a_sub_name(1:len_str) == subroutine_names(i)(1:len_str)) then
          if(  len_str == subroutine_name_length(i) .and. &
               & a_sub_name(1:len_str) == subroutine_names(i)(1:len_str)) then
             id = i
              exit
          end if
       end do
    end if
    if(id <= 0) then
       if( n_sub_names>=MSBRNM) then
         call alloc_subroutine_names_etc(MSBRNM+INCRE_MSBRNM,MSBRNM)
         if(ipritiming>=2 .and. printable) write(nfout, &
         '(" !! array size for the subroutine_names has been enlarged from",i6," to ",i6,"(->m_Timing)")') &
         MSBRNM,MSBRNM+INCRE_MSBRNM
         MSBRNM = MSBRNM+INCRE_MSBRNM
       endif
       if( n_sub_names < MSBRNM) then
          n_sub_names = n_sub_names + 1
          id          = n_sub_names
          write(subroutine_names(id),'(a32)') a_sub_name
          subroutine_name_length(id) = len_str
       else
          if(printable) write(nfout,'(" !! Size of an array of subroutine_names should be enlarged (->m_Timing)")')
       end if
    end if


    if(id >= 1 .and. id <= MSBRNM) then
       if(measure_count_limit > 0 .and. counter(id) > measure_count_limit) then
       else
          call gettod(t_start)
          tstart(id) = t_start
       end if
       if(sw_firstlevel_only == ON .or. (sw_firstlevel_only==OFF .and. sw_flatten==OFF)) then
          if(present(level) .and. ilevel(id)==-1) then
             ilevel(id) = level
             if(level/=-1 .and. levelset==OFF) levelset = ON
          end if
       end if
    end if

    if(sw_details == ON) then
       call alloc_subhir()
       call setlevels() ! --> level_now, level_previous, id123_now
       call search_id_ext() ! --> id_ext
       if(id_ext > id_ext_max) then
          subhir(id_ext)%id    = id
          subhir(id_ext)%level = level_now
          if(level_now==1) subhir(id_ext)%id1 = 0
          if(level_now>=2) subhir(id_ext)%id1 = id123_now(1)
          if(level_now>=3) subhir(id_ext)%id2 = id123_now(2)
          if(level_now>=4) subhir(id_ext)%id3 = id123_now(3)
          id_ext_max = id_ext
       end if
!!$       id_ext_pointer = min(id_ext_pointer + 1, MSBRNM_EXT)
!!$       id_ext_pointer = id_ext_pointer + 1
       id_ext_pointer = level_now
       if(id_ext_pointer <= MSBRNM_EXT) id_ext_stack(id_ext_pointer) = id_ext
    end if

    if(ipritiming >= 2 .and. printable) call wd_the_subroutine_name
!!$   if(ipri >= 2) print '(" <<< ",a32," >>>")',subroutine_names(id)
  contains
    subroutine search_id_ext()
      integer :: i
      id_ext = 0
      if(id_ext_max == 0) then
         if(id>=1) then
            id_ext = 1
         end if
      else
         if(level_now <= 1) then
            do i = 1, id_ext_max
               if(subhir(i)%id == id) then
                  id_ext = i
                  exit
               end if
            end do
         else
            do i = 1, id_ext_max
               if(subhir(i)%id == id .and. subhir(i)%level == level_now) then
!!$                  if((subhir(i)%level == level_now).and.(subhir(i)%id1 == id123_now(1))) then
                  if(subhir(i)%id1 == id123_now(1)) then
                     id_ext = i
                     exit
                  end if
               end if
            end do
         end if
         if(id_ext == 0) id_ext = id_ext_max+1
      end if
    end subroutine search_id_ext

    subroutine setlevels()
      if(present(level)) then
         level_previous = level_now
         level_now = level
         if(level_now >= 1 .and. level_now <= 3) id123_now(level_now) = id
      else
         if(level_now >= 0) then
            level_previous = level_now
            level_now = level_now+1
            if(level_now >= 1 .and. level_now <= 3) id123_now(level_now) = id
         end if
      end if
    end subroutine setlevels
      
    subroutine alloc_subhir()
      type(t_subhir), allocatable,  dimension(:) :: subhir2
      real(kind=DP),allocatable, dimension(:) :: ecpu2
      integer, allocatable, dimension(:) :: counter2
      if(.not.allocated(subhir)) then
         allocate(subhir(MSBRNM_EXT))
         do i = 1, MSBRNM_EXT
            subhir(i)%id = 0
            subhir(i)%level = 0
            subhir(i)%id1 = 0
            subhir(i)%id2 = 0
            subhir(i)%id3 = 0
            subhir(i)%flag = 0
         end do
         allocate(ecpu_ext(MSBRNM_EXT)); ecpu_ext = 0.d0
         allocate(counter_ext(MSBRNM_EXT)); counter_ext = 0
         n_allocated_subhir = MSBRNM_EXT
      else if(id_ext_max >= n_allocated_subhir) then
         allocate(subhir2(id_ext_max))
         allocate(ecpu2(id_ext_max))
         allocate(counter2(id_ext_max))
         if(allocated(subhir)) then
            subhir2 = subhir
            deallocate(subhir)
            n_allocated_subhir = n_allocated_subhir+INCRE_MSBRNM
            allocate(subhir(n_allocated_subhir))
            subhir(1:min(id_ext_max,n_allocated_subhir)) = subhir2(1:min(id_ext_max,n_allocated_subhir))
            do i = min(id_ext_max, n_allocated_subhir)+1, n_allocated_subhir
               subhir(i)%id = 0
               subhir(i)%level = 0
               subhir(i)%id1 = 0
               subhir(i)%id2 = 0
               subhir(i)%id3 = 0
               subhir(i)%flag = 0
            end do
         end if
         if(allocated(ecpu_ext)) then
            ecpu2 = ecpu_ext
            deallocate(ecpu_ext)
            allocate(ecpu_ext(n_allocated_subhir)); ecpu_ext = 0.d0
            ecpu_ext(1:min(id_ext_max,n_allocated_subhir)) = ecpu2(1:min(id_ext_max,n_allocated_subhir))
         end if
         if(allocated(counter_ext)) then
            counter2 = counter_ext
            deallocate(counter_ext)
            allocate(counter_ext(n_allocated_subhir)); counter_ext = 0
            counter_ext(1:min(id_ext_max,n_allocated_subhir)) = counter2(1:min(id_ext_max,n_allocated_subhir))
         end if
         deallocate(counter2)
         deallocate(ecpu2)
         deallocate(subhir2)
      end if
    end subroutine alloc_subhir
         
    subroutine wd_the_subroutine_name
      integer :: i, ip
      ip = long_name_size - len_str
      ip = ip / 2
      do i = 1, ip
         temp_str(i:i) = '-'
      end do
      do i = 1, len_str
         temp_str(i+ip:i+ip) = a_sub_name(i:i)
      end do
      do i = ip + len_str + 1, long_name_size
         temp_str(i:i) = '-'
      end do
      write(nfout,'(" <<<",a32,">>> (",i3,"), level_now = ",i3)') temp_str,ilevel(id), level_now
    end subroutine wd_the_subroutine_name
  end subroutine tstatc0_begin

  subroutine tstatc0_end(id)
    integer, intent(in) :: id
    real(kind=DP) :: t_end, t_used

    if(id==-1)  return

    if(measure_count_limit > 0 .and. counter(id) >measure_count_limit) then
       t_used = 0.d0
    else
       call gettod(t_end)
       t_used = t_end - tstart(id)
       ecpu(id) = ecpu(id) + t_used * UMICRO
    end if
    counter(id) = counter(id) + 1

    if(sw_details == ON) then
       if(level_now >= 1) then
          level_previous = level_now
          level_now = level_now-1
       end if
       if(id_ext_pointer >=1 .and. id_ext_pointer <= MSBRNM_ext) then
          id_ext = id_ext_stack(id_ext_pointer)
          if(id_ext >=1 .and. id_ext <= n_allocated_subhir) then
             ecpu_ext(id_ext) = ecpu_ext(id_ext) + t_used *UMICRO
             counter_ext(id_ext) = counter_ext(id_ext) + 1
          end if
       else
          id_ext = 0
       end if
!!$       id_ext_pointer = id_ext_pointer-1
       id_ext_pointer = level_now
       if(ipritiming >= 2 .and. printable) call wd_the_subroutine_name2
    end if

    if(ipritiming >= 2 .and. printable) call wd_the_subroutine_name
  contains
    subroutine wd_the_subroutine_name
      write(nfout,'(" >>>",a32,"<<<")') subroutine_names(id)
    end subroutine wd_the_subroutine_name
    subroutine wd_the_subroutine_name2
      write(nfout,'(" >>>",a32,"<<< id_ext, id_ext_pointer = ",i5,i5)') subroutine_names(id), id_ext, id_ext_pointer
    end subroutine wd_the_subroutine_name2
    
  end subroutine tstatc0_end

  subroutine tstatc_init
    tstart(1:MSBRNM) = 0.d0; ecpu(1:MSBRNM) = 0.d0; counter(1:MSBRNM) = 0
    if(sw_details == ON) then
       if(allocated(ecpu_ext)) ecpu_ext = 0.d0
       if(allocated(counter_ext)) counter_ext = 0
       id_ext_max = 0
    end if
  end subroutine tstatc_init

  subroutine tstatc_wd0
    integer :: i, ip, nsub, in, nsub0, npmax, npmin
    real(kind=DP) :: cpu_used, wct_now &
         & , cputmax, cputmin, cputmean, cputvariance, cputstddevia
    real(kind=DP), allocatable, dimension(:,:) :: ecpu_wk, ecpu_sorted
    integer, allocatable, dimension(:) :: iorder_p
    integer :: ipri0, lev, levmax, inu, j, num_sub_wd, cput_mode

    ipri0 = ipritiming
    call mpi_bcast(ipri0,1,mpi_integer,0,mpi_comm_group,ierr)
    if(ipri0<=0) return

    if(measure_count_limit > 0) call correct_ecpu() ! counter,measure_count_limit,ecpu-> ecpu
    call tsort(ecpu(1),MSBRNM,iorder)

    nsub = n_sub_names

    if(levelset == ON) then
       levmax = 2
       if(sw_firstlevel_only==ON) levmax = 1
    else
       levmax = 1
    end if

    if(statistics_in_parallel == 1 .and. npes >= 2) then
       cput_mode = MODE_PARALLEL
       if(mype == 0) then
          nsub0 = 0 
          do i = 1, nsub
             if(ecpu(iorder(i)) < UMICRO) exit
             nsub0 = i
          end do
       end if
       call mpi_bcast(nsub0,1,mpi_integer,0,mpi_comm_group,ierr)
       allocate(iorder_p(nsub0))
       if(mype == 0) iorder_p(1:nsub0) = iorder(1:nsub0)
       call mpi_bcast(iorder_p,nsub0,mpi_integer,0,mpi_comm_group,ierr)

       allocate(ecpu_wk(0:npes-1,nsub0)); ecpu_wk = 0.d0
       allocate(ecpu_sorted(0:npes-1,nsub0))
       do i = 1, nsub0
          ip = iorder_p(i)
          ecpu_wk(mype,i) = ecpu(ip)
       end do
       call mpi_allreduce(ecpu_wk, ecpu_sorted,nsub0*npes, mpi_double_precision &
            &            ,mpi_sum, mpi_comm_group,ierr)

    else
       cput_mode = MODE_SINGLE
       nsub0 = 0
       do i = 1, nsub
          if(ecpu(iorder(i)) < UMICRO) exit
          nsub0 = i
       end do
    end if

    do j = MODE_EVALUATION, MODE_WRITE
       if(j==MODE_EVALUATION) num_sub_wd = 0
       if(j==MODE_WRITE) call wd_headerlines()

       do lev = 1, levmax
          if(j==MODE_WRITE) call wd_pauseline()
          inu = 0
          do i = 1, nsub0
             if(cput_mode == MODE_PARALLEL) then
                ip = iorder_p(i)
             else if(cput_mode == MODE_SINGLE) then
                ip = iorder(i)
             end if

             if(levelset == ON) then
                if(levmax >= 2) then
                   if(.not.((lev==levmax .and. ilevel(ip)==-1) .or. (lev<levmax .and. ilevel(ip)==lev))) cycle
                else if(levmax == 1) then
                   if(ilevel(ip)/=lev) cycle
                end if
             end if
             inu = inu + 1

             if(j==MODE_WRITE) then
                if(cput_mode == MODE_PARALLEL) then
                   call cpu_statistics_in_parallel(ecpu_sorted(0,i) &
                        & ,cputmin,cputmax,cputmean,cputvariance,cputstddevia,npmax,npmin)
                   if(printable) write(nfout,'(2i5,2x,a32,f11.5,i8,4f10.4,3i5)') &
                        & i,ip,subroutine_names(ip),ecpu(ip),counter(ip) &
                        & ,cputmax,cputmin,cputmean,cputstddevia,npmax,npmin,inu
                else
                   if(printable) write(nfout,'(2i5,2x,a32,f11.5,2i8)') &
                        & i,ip,subroutine_names(ip),ecpu(ip),counter(ip), inu
                end if
             end if
          end do
          if(j==MODE_EVALUATION) num_sub_wd = num_sub_wd+inu
       end do
    end do
    if(cput_mode == MODE_PARALLEL) deallocate(iorder_p,ecpu_sorted,ecpu_wk)

!!$    else
!!$       if(printable) then
!!$          nsub0 = 0
!!$          do i = 1, nsub
!!$             if(ecpu(iorder(i)) < UMICRO) exit
!!$             nsub0 = i
!!$          end do
!!$
!!$          do j = MODE_EVALUATION, MODE_WRITE
!!$             if(j==MODE_EVALUATION) num_sub_wd = 0
!!$             if(j==MODE_WRITE) call wd_headerlines()
!!$
!!$             do lev = 1, levmax
!!$                if(j==MODE_WRITE) call wd_pauseline()
!!$                inu = 0
!!$                do i = 1, nsub0
!!$                   ip = iorder(i)
!!$                   if(levelset == ON) then
!!$                      if(levmax >= 2) then
!!$                         if(.not.((lev==levmax .and. ilevel(ip)==-1) &
!!$                              & .or. (lev<levmax .and. ilevel(ip)==lev))) cycle
!!$                      else if(levmax == 1) then
!!$                         if(ilevel(ip)/=lev) cycle
!!$                      end if
!!$                   end if
!!$                   inu = inu+1
!!$                   if(j==MODE_WRITE .and. printable) then
!!$                      write(nfout,'(2i5,2x,a32,f11.5,2i8)') &
!!$                           & i,ip,subroutine_names(ip),ecpu(ip),counter(ip), inu
!!$                   end if
!!$                end do
!!$                if(j==MODE_EVALUATION) num_sub_wd = num_sub_wd+inu
!!$             end do
!!$          end do
!!$!!$       if(sw_details == ON) then
!!!$          if(printable) then
!!!$             write(nfout,'(" --- detail flat---")')
!!!$             write(nfout,'(" id_ext_max = ", i8)') id_ext_max
!!!$             if(printable) write(nfout,'("   no",2x," id ","        subroutine name         ","  time(sec) "&
!!!$                  &               ,"  count","   level","   id1")')
!!!$             do i = 1, min(id_ext_max,100)
!!!$                inu = subhir(i)%id
!!!$                if(inu >= 1) write(nfout,'(i5,2x,i4,a32,f11.5,3i8)') i, inu,subroutine_names(inu) &
!!!$                     & , ecpu_ext(i), counter_ext(i), subhir(i)%level, subhir(i)%id1
!!!$             end do
!!!$          end if
!!!$       end if
!!$       end if
!!$    end if
    call gettod(wct_now)
    cpu_used = (wct_now - wct_start) * UMICRO
    if(printable) write(nfout,'(" <<Total elapsed CPU Time until now =",f12.5," (sec.)>>")') cpu_used
    if(sw_details == ON .and. printable) call wd_ecpu_details(0)

  contains
    subroutine wd_pauseline()
      if(levelset == ON .and. levmax>1 .and. printable) then
         if(lev < levmax) then
            write(nfout,'("    --- level ",i3," ---")') lev
         else
            write(nfout,'("    --- ---")')
         end if
      end if
    end subroutine wd_pauseline
!!$    subroutine wd_headerlines_parallel()
!!$      if(printable) then
!!$         write(nfout,'(" n_sub_names = ",i5," num_subroutines_statistics = ",i5)') n_sub_names, num_sub_wd
!!$         write(nfout,'(" << cpu time statistics >>")')
!!$      end if
!!$    end subroutine wd_headerlines_parallel
    subroutine wd_headerlines()
      if(printable) then
         write(nfout,'(" n_sub_names = ",i5," num_subroutines_statistics = ",i5)') n_sub_names, num_sub_wd
         if(num_sub_wd >=1) then
            write(nfout,'(" << cpu time statistics >>")')
            if(cput_mode==MODE_SINGLE) then
               write(nfout,'("  no "," id ",2x,"        subroutine name         ","  time(sec) "&
                    &               ,"  count","   no(2)")')
            else if(cput_mode == MODE_PARALLEL) then
               write(nfout,'("   no","   ip",2x,"        subroutine name         ","  time(sec) "&
                    &               ,"  count  ", " max_time    min       mean     stddevia" &
                    &  ," nmax nmin  no(2)")')
            end if
         end if
      end if
    end subroutine wd_headerlines

  end subroutine tstatc_wd0

  subroutine cpu_statistics_in_parallel(ecpu_sorted &
       & ,cputmin,cputmax,cputmean,cputvariance,cputstddevia,npmax,npmin)
    real(kind=DP),intent(in),dimension(0:npes-1) :: ecpu_sorted
    real(kind=DP),intent(out)     :: cputmin,cputmax,cputmean,cputvariance,cputstddevia
    integer, intent(out) :: npmax,npmin
    integer :: in

    cputmax = ecpu_sorted(0); npmax = 0
    cputmin = ecpu_sorted(0); npmin = 0
    do in = 1, npes-1
       if(cputmax < ecpu_sorted(in)) then
          cputmax = ecpu_sorted(in);   npmax = in
       end if
       if(cputmin > ecpu_sorted(in)) then
          cputmin = ecpu_sorted(in);   npmin = in
       end if
    end do
!!$          cputmax = maxval(ecpu_sorted(0:npes-1,ic))
!!$          cputmin = minval(ecpu_sorted(0:npes-1,ic))
    cputmean = 0.d0
    do in = 0, npes-1
       cputmean = cputmean + ecpu_sorted(in)
    end do
    cputmean = cputmean/npes
    cputvariance = 0.d0
    do in =0, npes-1
       cputvariance = cputvariance + (ecpu_sorted(in)-cputmean)*(ecpu_sorted(in)-cputmean)
    end do
    cputvariance = cputvariance/npes
    cputstddevia = dsqrt(cputvariance)
    
  end subroutine cpu_statistics_in_parallel

  subroutine wd_ecpu_details(iteration)
    integer, intent(in) :: iteration
    integer :: i, ip, ic, inu, ips, id, icflag

    n_1stlevel_subroutines = 0
    do i = 1, n_sub_names
       if(ilevel(i) == 1) n_1stlevel_subroutines = n_1stlevel_subroutines+1
    end do
    if(n_1stlevel_subroutines ==0) return
    allocate(ip_1stlevel_subroutines(n_1stlevel_subroutines))
    n_1stlevel_subroutines = 0
    do i = 1, n_sub_names
       ip = iorder(i)
       if(ilevel(ip) == 1) then
          n_1stlevel_subroutines = n_1stlevel_subroutines+1
          ip_1stlevel_subroutines(n_1stlevel_subroutines) = ip
       end if
    end do

    write(nfout,'("--- cputiming details BEGIN ( iteration = ",i8," ) ----")') iteration
    write(nfout,'("   no "," id ",2x,"        subroutine name         ","  time(sec) "&
         &               ,"  count","   level","   id1")')
    subhir(1:id_ext_max)%flag = 0

    icflag = 0
    do i = 1, n_1stlevel_subroutines
       ip = ip_1stlevel_subroutines(i)
       ic = 0
       do inu = 1, id_ext_max
          ips = subhir(inu)%id1
          if(subhir(inu)%level>=2 .and. ips == ip) then
             if(ecpu_ext(inu) > UMICRO) ic = ic+1
             ic = ic+1
          end if
       end do
       if(ic >=1) then
          write(nfout,'(" ",60("="))')
          write(nfout,'("  *  ",i5,2x,a32,f11.5,2i8,"    *")') ip,subroutine_names(ip), ecpu(ip),counter(ip),ilevel(ip)
          write(nfout,'(" ",60("-"))')
!!$          write(nfout,'("  ----------------------------------------")')
          ic = 0
          do inu = 1, id_ext_max
             ips = subhir(inu)%id1
             if(subhir(inu)%level>=2 .and. ips == ip) then
                if(ecpu_ext(inu) > UMICRO) then
                   ic = ic+1
                   id = subhir(inu)%id
                   if(id >=1) then
                      write(nfout,'(2i5,2x,a32,f11.5,3i8)') ic,id,subroutine_names(id) &
                           & , ecpu_ext(inu),counter_ext(inu),subhir(inu)%level, subhir(inu)%id1
                   else
                      write(nfout,'("id = ",i8," <=0")') id
                   end if
                   subhir(inu)%flag = 1
                   icflag = icflag + 1
                end if
             end if
          end do
       end if
    end do
    if(icflag < id_ext_max) then
       ic = 0
       do i = 1, id_ext_max
          if(subhir(i)%flag == 0 .and. subhir(i)%level >= 2) then
             if(ecpu_ext(i) > UMICRO) then
                ic = ic + 1
             end if
          else if(subhir(i)%flag == 0 .and. subhir(i)%level==1) then
             id = subhir(i)%id
             if(1<=id .and. id <=MSBRNM .and. ilevel(id) /= 1) then
                if(ecpu_ext(i) > UMICRO) then
                   ic = ic + 1
                end if
             end if
          end if
       end do
       if(ic>=1) then
          write(nfout,'(" === other subroutines ",40("="))')
          ic = 0
          do i = 1, id_ext_max
             icflag = 0
             if(subhir(i)%flag == 0 .and. subhir(i)%level >= 2) then
                if(ecpu_ext(i) > UMICRO) then
                   ic = ic + 1
                   id = subhir(i)%id
                   icflag = 1
                end if
             else if(subhir(i)%flag == 0 .and. subhir(i)%level<=1) then
                id = subhir(i)%id
                if(1<=id .and. id <=MSBRNM .and. ilevel(id) /= 1) then
                   if(ecpu_ext(i) > UMICRO) then
                      ic = ic + 1
                      icflag = 1
                   end if
                end if
             end if
             if(icflag == 1)  write(nfout,'(2i5,2x,a32,f11.5,3i8)') ic, id,subroutine_names(id) &
                  & , ecpu_ext(i), counter_ext(i), subhir(i)%level, subhir(i)%id1
          end do
       end if
    end if
    write(nfout,'("--- cputiming details END ( iteration = ",i8," ) ----")') iteration

    deallocate(ip_1stlevel_subroutines)
  end subroutine wd_ecpu_details

  subroutine tstatc_wd(iteration)
    integer, intent(in) :: iteration
!!$    integer i, ip, nsub, in, ic, nsub0, npmax, npmin
    integer i, ip, nsub, ic, nsub0, npmax, npmin
    real(kind=DP) :: cpudif, pecpu, wct_now, cputmax, cputmin, cputmean, cputvariance, cputstddevia
    real(kind=DP), allocatable, dimension(:,:) :: ecpu_wk, ecpu_sorted
    integer, allocatable, dimension(:) :: iorder_p
    integer :: ipri0, lev, levmax, inu, j, num_sub_wd,  cput_mode

    ipri0 = ipritiming
    call mpi_bcast(ipri0,1,mpi_integer,0,mpi_comm_group,ierr)
    if(ipri0<=0) return

    ipri0 = 0
    cpudif = dabs(ecpu(0) - ecpu_previous)
    if(cpudif < ecpu_previous * PCPUDF .or. ecpu(0) < UMICRO) ipri0=1
    call mpi_bcast(ipri0,1,mpi_integer,0,mpi_comm_group,ierr)
    if(ipri0>0) then
       goto 1001
    end if

    if(measure_count_limit > 0) call correct_ecpu() ! counter,measure_count_limit,ecpu-> ecpu
    call tsort(ecpu(1),MSBRNM,iorder)

    if(levelset == ON) then
       levmax = 2
       if(sw_firstlevel_only==ON) levmax = 1
    else
       levmax = 1
    end if
    nsub = 0
    if(sw_firstlevel_only == ON .and. levmax == 1) then
      ic = 0
       do i = 1, n_sub_names
          ip = iorder(i)
          if(ecpu(ip) < UMICRO) exit
          if(ilevel(ip) == 1) then
             ic = ic + 1
             if(ic > num_subroutines) exit
             nsub = i
          end if
       end do
    else
       nsub = min(n_sub_names, num_subroutines)
    end if

!!$    if(printable) write(nfout,'(" nsub = ",i8)') nsub

    if(statistics_in_parallel == 1 .and. npes >= 2) then
       cput_mode = MODE_PARALLEL
       call mpi_barrier(mpi_comm_group,ierr)
       if(mype == 0) then
          nsub0 = 0 
          do i = 1, nsub
             if(ecpu(iorder(i)) < UMICRO) exit
             nsub0 = i
          end do
       end if
       call mpi_bcast(nsub0,1,mpi_integer,0,mpi_comm_group,ierr)
       allocate(iorder_p(nsub0))
       if(mype == 0) iorder_p(1:nsub0) = iorder(1:nsub0)
       call mpi_bcast(iorder_p,nsub0,mpi_integer,0,mpi_comm_group,ierr)

       allocate(ecpu_wk(0:npes-1,0:nsub0)); ecpu_wk = 0.d0
       allocate(ecpu_sorted(0:npes-1,0:nsub0))
       ecpu_wk(mype,0) = ecpu(0)
       do i = 1, nsub0
          ip = iorder_p(i)
          ecpu_wk(mype,i) = ecpu(ip)
       end do
       call mpi_allreduce(ecpu_wk, ecpu_sorted,(nsub0+1)*npes, mpi_double_precision &
            &            ,mpi_sum, mpi_comm_group,ierr)
       subroutine_names(0) = " total cpu of this iteration "
       subroutine_name_length(0) = 30
       nsub0 = nsub0 + 1
    else
       cput_mode = MODE_SINGLE
       nsub0 = 0
       do i = 1, nsub
          if(ecpu(iorder(i)) < UMICRO) exit
          nsub0 = i
       end do
    end if

    do j = MODE_EVALUATION, MODE_WRITE
       if(j==MODE_EVALUATION) num_sub_wd = 0
       if(j==MODE_WRITE) call wd_headerlines()

       do lev = 1, levmax
          if(j==MODE_WRITE) call wd_pauseline()
          inu = 0
          do i = 1, nsub0
             if(cput_mode == MODE_PARALLEL) then
                if(i <= nsub0-1) then
                   ip = iorder_p(i)
                   ic = i
                else if(i == nsub0) then
                   ip = 0
                   ic = 0
                end if
             else if(cput_mode == MODE_SINGLE) then
                ip = iorder(i)
             end if
             
!!$             if(levelset == ON .and. ip/=0) then
             if(levelset == ON .and. ip>0) then
                if(levmax >= 2) then
                   if(.not.((lev==levmax .and. ilevel(ip)==-1) .or. (lev<levmax .and. ilevel(ip)==lev))) cycle
                else if(levmax == 1) then
                   if(ilevel(ip)/=lev) cycle
                end if
!!$             else if(levelset == ON .and. ip == 0) then
             else if(levelset == ON .and. ip <= 0) then
                if(lev < levmax) cycle
             end if
             inu = inu+1

             if(j==MODE_WRITE) then
                if(cput_mode == MODE_PARALLEL) then
                   call cpu_statistics_in_parallel(ecpu_sorted(0,ic) &
                        & ,cputmin,cputmax,cputmean,cputvariance,cputstddevia,npmax,npmin)
                end if
                pecpu = ecpu(ip)/ecpu(0) * 100

                if(printable) then
                   if(cput_mode == MODE_PARALLEL) then
                      if(ip /= 0) then
                         write(nfout,'(2i4,2x,a32,f10.4,f6.2,i9,4f10.4,3i5)') &
                              & ic,ip, subroutine_names(ip),ecpu(ip),pecpu,counter(ip) &
                              & ,cputmax,cputmin,cputmean,cputstddevia,npmax,npmin,inu
                      else if(ip == 0) then
                         write(nfout,'(2i4,2x,a32,f10.4,f6.1,i9,4f10.4,3i5)') &
                              & ic,ip, subroutine_names(ip),ecpu(ip),pecpu,1 &
                              & ,cputmax,cputmin,cputmean,cputstddevia,npmax,npmin,inu
                      end if
                   else
                      write(nfout,'(2i4,2x,a32,f11.5,f6.2,2i8)') &
                           & i,ip, subroutine_names(ip),ecpu(ip),pecpu,counter(ip),inu
                   end if
                end if
             end if
          end do
          if(j==MODE_EVALUATION) num_sub_wd = num_sub_wd+inu
       end do
    end do
    if(cput_mode == MODE_PARALLEL)  deallocate(iorder_p,ecpu_sorted,ecpu_wk)
!!$    else
!!$       nsub0 = 0
!!$       do i = 1, nsub
!!$          if(ecpu(iorder(i)) < UMICRO) exit
!!$          nsub0 = i
!!$       end do
!!$
!!$       do j = MODE_EVALUATION, MODE_WRITE
!!$          if(j==MODE_EVALUATION) num_sub_wd = 0
!!$          if(j==MODE_WRITE) call wd_header()
!!$          do lev = 1, levmax
!!$             if(j==MODE_WRITE) call wd_pauseline()
!!$
!!$             inu = 0
!!$             do i = 1, nsub0
!!$                ip = iorder(i)
!!$                if(levelset == ON) then
!!$                   if(levmax >= 2) then
!!$                      if(.not.((lev==levmax .and. ilevel(ip)==-1) .or. (lev<levmax .and. ilevel(ip)==lev))) cycle
!!$                   else if(levmax == 1) then
!!$                      if(ilevel(ip)/=lev) cycle
!!$                   end if
!!$                end if
!!$                inu = inu+1
!!$                if(j==MODE_WRITE) then
!!$                   pecpu = ecpu(ip)/ecpu(0) * 100
!!$
!!$                   if(printable) write(nfout,'(2i4,2x,a32,f11.5,f6.2,2i8)') &
!!$                        & i,ip, subroutine_names(ip),ecpu(ip),pecpu,counter(ip),inu
!!$                end if
!!$             end do
!!$             if(j==MODE_EVALUATION) num_sub_wd = num_sub_wd+inu
!!$          end do
!!$       end do
!!$!!!$       if(sw_details == ON .and. printable) then
!!$!!!$          write(nfout,'(" --- detail ---")')
!!$!!!$          write(nfout,'(" id_ext_max = ", i8)') id_ext_max
!!$!!!$          if(printable) write(nfout,'("   no",2x," id ","        subroutine name         ","  time(sec) "&
!!$!!!$               &               ,"  count","   level","   id1")')
!!$!!!$          do i = 1, min(id_ext_max,100)
!!$!!!$             inu = subhir(i)%id
!!$!!!$             if(inu >= 1) write(nfout,'(i5,2x,i4,a32,f11.5,3i8)') i, inu,subroutine_names(inu) &
!!$!!!$                  & , ecpu_ext(i), counter_ext(i), subhir(i)%level, subhir(i)%id1
!!$!!!$          end do
!!$!!!$       end if
!!$    end if
    call gettod(wct_now)
    cpudif = (wct_now - wct_start)*UMICRO
!!$    write(nfout,'(6x,"Total cpu time of ( ",i8," )-th iteration",4x,f11.5 &
!!$         & ,"(sec.)")') iteration, ecpu(0)
    if(printable) then
       if(iteration < 10000) then
          if(cpudif < 10**6) then
             write(nfout,'(1x,"Total cputime of ( ",i4," )-th iteration",3x,f11.5," /",f10.3 &
                  & ," (sec.)")') iteration, ecpu(0), cpudif
          else 
             write(nfout,'(1x,"Total cputime of ( ",i4," )-th iteration",3x,f11.5," /",f12.3 &
                  & ," (sec.)")') iteration, ecpu(0), cpudif
          end if
       else
          if(cpudif < 10**6) then
             write(nfout,'(1x,"Total cputime of ( ",i8," )-th iteration",1x,f11.5," /",f10.3 &
                  & ," (sec.)")') iteration, ecpu(0), cpudif
          else 
             write(nfout,'(1x,"Total cputime of ( ",i8," )-th iteration",1x,f11.5," /",f12.3 &
                  & ," (sec.)")') iteration, ecpu(0), cpudif
          end if
       end if
    end if

    if(sw_details == ON .and. printable) call wd_ecpu_details(iteration)
1001 ecpu_previous = ecpu(0)

  contains
    subroutine wd_pauseline()
      if(levelset == ON .and. levmax>1 .and. printable) then
         if(lev < levmax) then
            write(nfout,'("    --- level ",i3," ---")') lev
         else
            write(nfout,'("    --- ---")')
         end if
      end if
    end subroutine wd_pauseline

    subroutine wd_headerlines()
      integer :: num_sub
      if(printable) then
         if(cput_mode == MODE_PARALLEL) then
            num_sub = num_sub_wd-1
         else
            num_sub = num_sub_wd
         end if
         write(nfout,'(" << CPU Time Consumption -- TOP",i4," Subroutines (",i5,") >>")') &
                 &     num_sub, iteration
         if(cput_mode == MODE_PARALLEL) then
            write(nfout,'("  no "," id ",2x,"        subroutine name         ","time(sec) "&
                 &               ," r(%) ","   count  ", "max_time    min       mean     stddevia"," nmax nmin  no(2)")')
         else
            write(nfout,'("  no "," id ",2x,"        subroutine name         "," time(sec) "&
                 &               ," r(%) ","   count","   no(2)")')
         end if
      end if
    end subroutine wd_headerlines

!!$    subroutine wd_headerlines()
!!$      if(printable) then
!!$         write(nfout,'(" << CPU Time Consumption -- TOP",i4," Subroutines (",i5,") >>")') &
!!$              &     num_sub_wd, iteration
!!$         write(nfout,'("  no "," id ",2x,"        subroutine name         "," time(sec) "&
!!$              &               ," r(%) ","   count","   no(2)")')
!!$      end if
!!$    end subroutine wd_headerlines
  end subroutine tstatc_wd

  subroutine tstatc_iter(iteration, first_iteration_of_this_job)
    integer, intent(in) :: iteration, first_iteration_of_this_job
    real(kind=DP) :: t_end, t_used
#ifdef NEC_ITER_REG
    character(len=7) :: str_reg
#endif
    call gettod(t_end)
    if(iteration > first_iteration_of_this_job) then
#ifdef NEC_ITER_REG
       write(str_reg, '(A3,I4.4)') 'IT_',iteration
       call FTRACE_REGION_END(str_reg)
#endif
       t_used  = t_end - tstart(0)
       ecpu(0) = t_used * UMICRO
    end if
    tstart(0) = t_end
#ifdef NEC_ITER_REG
       write(str_reg, '(A3,I4.4)') 'IT_',iteration+1
       call FTRACE_REGION_BEGIN(str_reg)
#endif
  end subroutine tstatc_iter

  subroutine m_Timing_wd_timenow(chars)
    character(len=*), intent(in) :: chars

    integer, dimension(8) :: ipresent_time
    integer :: i, j, ilen
    integer, parameter :: max_chars = 80, max_chars0 = 55
    character(len=80) :: aline
    character(len=20) :: dateandtime = ''

    call date_and_time(values=ipresent_time)
    
    ilen = len_trim(chars)
    if(ilen > max_chars0) ilen = max_chars0

!!$    aline = ''
!!$    do i = 1, ilen
!!$       aline(i:i) = chars(i:i)
!!$    end do
!!$    write(aline(ilen+6:max_chars),'(",i2,":",i2,":",i2,"  ",i2,"/",i2,"/",i4)') &
!!$         & ipresent_time(5:7),ipresent_time(3),ipresent_time(2),ipresent_time(1)
    write(dateandtime,'(i2,":",i2,":",i2,"  ",i2,"/",i2,"/",i4)') &
         & ipresent_time(5:7),ipresent_time(3),ipresent_time(2),ipresent_time(1)
    do i = 1,20
       if(i >= 9 .and. i <= 10) cycle
       if(dateandtime(i:i) == ' ' ) dateandtime(i:i) = '0'
    end do

    aline = chars(1:ilen)//'     '//dateandtime

    write(nfout,'(a80)') aline

  end subroutine m_Timing_wd_timenow

  subroutine m_Timing_init_timer()
#ifdef HIUX
    real(kind=DP) :: time0
#endif
    call gettod(wct_start)
    switch_of_timing = ON
#ifdef HIUX
    call xclock(time0,7)
    call xclock(time0,3)
#endif
  end subroutine m_Timing_init_timer

  subroutine m_Timing_wd_status(nfstatus, jobstatus_format,jobstatus_series,status_wdmode &
       &       , iteration, iteration_ionic, iteration_electronic)
    integer, intent(in) :: nfstatus, jobstatus_format, jobstatus_series, status_wdmode &
         &               , iteration, iteration_ionic, iteration_electronic
    integer :: switch_header
    character(len=9) :: modename
    real(kind=DP) :: elapsed_time

#ifdef HIUX
    real(kind=DP) :: cpu_time
    call xclock(elapsed_time,8)
    call xclock(cpu_time,5)
#else
    real(kind=DP) :: wct_now
    call gettod(wct_now)
    elapsed_time = (wct_now - wct_start) * UMICRO
#endif
    if(status_wdmode == START) then
       modename = 'START'
    else if(status_wdmode == ITERATIVE) then
       modename = 'ITERATIVE'
    else if(status_wdmode == FINISH) then
       modename = 'FINISHED'
    else if(status_wdmode == ERROR) then
       modename = 'ERROR'
    end if
    switch_header = ON
    if(jobstatus_format == TAG_FORMAT .or. jobstatus_format == TAG_LINE) then
       switch_header = OFF
    else if(jobstatus_format == TABLE) then
       if(jobstatus_series == ON .and. status_wdmode /= START) switch_header = OFF
    else
       if(printable) write(nfout,'(" jobstatus_format (= ",i5,") is illegal")') jobstatus_format
    end if
    if(jobstatus_format == TABLE) then
#ifdef HIUX
       if(switch_header == ON) &
            & write(nfstatus,'("status     iteration  iter_ionic  iter_elec  elapsed_time  cpu_time")')
       write(nfstatus,'(a9,i11,i11,i11,f14.4,f14.4)') modename, iteration &
            & , iteration_ionic, iteration_electronic, elapsed_time, cpu_time
#else
       if(switch_header == ON) &
            & write(nfstatus,'("status     iteration  iter_ionic  iter_elec  elapsed_time")')
       write(nfstatus,'(a9,i11,i11,i11,f14.4)') modename, iteration &
            & , iteration_ionic, iteration_electronic, elapsed_time
#endif
    else if(jobstatus_format == TAG_FORMAT) then
       write(nfstatus,'(" status       = ",a14)') modename
       write(nfstatus,'(" iteration    = ",i14)') iteration
       write(nfstatus,'(" iter_ionic   = ",i14)') iteration_ionic
       write(nfstatus,'(" iter_elec    = ",i14)') iteration_electronic
       write(nfstatus,'(" elapsed_time = ",f14.4)') elapsed_time
#ifdef HIUX
       write(nfstatus,'(" cpu_time     = ",f14.4)') cpu_time
#endif
    else if(jobstatus_format == TAG_LINE) then
#ifdef HIUX
       write(nfstatus,'(" status = ",a9,", iteration = ",i10,", iter_ionic = ",i10 &
            & ,", iter_elec = ",i10,", elapsed_time = ",f14.4,", cpu_time = ",f14.4)') &
            & modename,iteration,iteration_ionic,iteration_electronic &
            &,elapsed_time, cpu_time
#else 
       write(nfstatus,'(" status = ",a9,", iteration = ",i10,", iter_ionic = ",i10 &
            & ,", iter_elec = ",i10,", elapsed_time = ",f14.4)') &
            & modename,iteration,iteration_ionic,iteration_electronic &
            &,elapsed_time
#endif
    end if

  end subroutine m_Timing_wd_status

  subroutine correct_ecpu()
    !   input  : ecpu, counter, measure_count_limit
    !      condition : measure_count_limit > 0
    !   output : ecpu, ecpu_ext
    integer :: i
    real(kind=DP) :: d, ecpu0
    if(measure_count_limit <= 0) return
    d = 1.d0/measure_count_limit
    do i = 1, MSBRNM
       if(counter(i) > measure_count_limit) then
          ecpu0 = ecpu(i) 
          ecpu(i) = ecpu(i)*counter(i)/measure_count_limit
          if(ipritiming >= 2) write(nfout,'(" id = ",i8, " ecpu new, old = ",2f8.4)') i, ecpu(i),ecpu0
       end if
    end do
    if(sw_details == ON) then
       do i = 1, n_allocated_subhir
          if(counter_ext(i) > measure_count_limit) then
             ecpu0 = ecpu_ext(i)
             ecpu_ext(i) = ecpu_ext(i)*counter_ext(i)/measure_count_limit
             if(ipritiming >= 2) write(nfout,'(" id = ",i8, " ecpu_ext new, old = ",2f8.4)') i, ecpu_ext(i),ecpu0
          end if
       end do
    end if
  end subroutine correct_ecpu

  subroutine m_Timing_initialize_tmp_timer()
     call gettod(tmp_timer_start_time)
  end subroutine m_Timing_initialize_tmp_timer

  function m_Timing_get_elapsed_time_tmp() result(res)
     real(kind=DP) :: res
     real(kind=DP) :: ct
     call gettod(ct)
     res = (ct-tmp_timer_start_time)*UMICRO
  end function m_Timing_get_elapsed_time_tmp

  subroutine m_Timing_finalize_tmp_timer()
     tmp_timer_start_time = 0.d0
  end subroutine m_Timing_finalize_tmp_timer

end module m_Timing

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE:  fft_box_finding_way, Preparation, Preparation_ek
!
!  AUTHOR(S): T. Yamasaki and H. Mizouchi   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef JRCATFFT_WS
#define _INCLUDE_EXX_
#elif FFTW3
#define _INCLUDE_EXX_
#endif

#ifdef FJ_TIMER
#   define __TIMER_FJ_START_w_BARRIER(str,a)   call mpi_barrier(str,ierr) ;   call timer_sta(a)
#   define __TIMER_FJ_START(a)   call timer_sta(a)
#   define __TIMER_FJ_STOP(a)    call timer_end(a)
#else
#   define __TIMER_FJ_START(a)
#   define __TIMER_FJ_STOP(a)
#endif

subroutine Preparation(imode)
! $Id: Preparation.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Const_Parameters,  only:DP,FILE,GENERAL,OUTER,INNER,SIMPLE_CUBIC &
       &                       ,HEXAGONAL,TETRAHEDRON &
       &                       ,INITIAL,CONTINUATION,FIXED_CHARGE &
       &                       ,FIXED_CHARGE_CONTINUATION, ON, OFF, GRID &
       &                       ,AUTOMATIC, MANUAL, PREPARATION_ONLY, LDA &
       &                       ,ALL_AT_ONCE, ONE_BY_ONE, DRIVER_NEB &
       &                       ,COORDINATE_CONTINUATION,by_matrix_diagon, MESH &
       &                       ,P_CONTROL, PT_CONTROL &
       &                       ,DRIVER_URAMP,DRIVER_SC_DFT,RETURN_AFTER_SYMMCHECK,SKIP_SYMMCHECK, DRIVER_DIMER
  use m_Parallelization,   only:mpi_comm_group &
       &                       ,m_Parallel_store_prev_np_g1k &
       &                       ,m_Parallel_init_mpi_kngp_3D &
       &                       ,m_Parallel_init_mpi_kngp_B_3D &
!F       &                       ,m_Parallel_init_mpi_kngp &
       &                       ,m_Parallel_init_mpi_cdfft &
       &                       ,m_Parallel_end_mpi,   ierr &
       &                       ,ista_kngp,iend_kngp,mype &
       &                       ,m_Parallel_resolve_decomp
  use m_Control_Parameters,only:paramset, ipriparallel, ipri, icond, ekmode &
       &                       ,gmaxs_given,n_matrix_size, sw_positron &
       &                       ,sw_ldos, fixed_charge_k_parallel &
!!$       &                       ,m_CtrlP_set_wct_start &
       &                       ,m_CtrlP_set_kimg &
       &                       ,m_CtrlP_way_of_smearing &
       &                       ,sw_pdos, sw_berry_phase, sw_phonon &
       &                       ,num_projectors, ggacmp_parallel, sw_fef &
       &                       ,sw_wannier, numk_tmp, iconv_ek_tmp, driver &
       &                       ,m_CtrlP_rd_neg_previous &
       &                       ,m_CtrlP_rd_edelta_ontheway &
       &                       ,m_CtrlP_rd_iconvergence &
       &                       ,m_CtrlP_rd_corecharge_cntnbin &
       &                       ,sw_hybrid_functional, m_CntrlP_rst_submat_call_stat &
       &                       ,sw_optimize_lattice,nhistory_stress &
       &                       ,sw_optimize_coordinates_once &
       &                       ,m_CtrlP_reset_iconvergence &
       &                       ,gmaxp, sw_rebuild_pws, way_of_smearing &
       &                       ,m_CtrlP_in_initialization &
       &                       ,m_CtrlP_reset_optmode &
       &                       ,m_CtrlP_set_npartition_david &
       &                       ,intzaj, imdalg &
       &                       ,sw_communicator_for_chg &
       &                       ,gmax,gmax_org, printable, nspin &
       &                       ,sw_charge_rspace, sw_partial_charge
#ifdef _USE_SCALAPACK_
  use m_Control_Parameters,only: m_CtrlP_set_sw_scalapack
#endif
  use m_Files,             only:nfinp,nfout,nfkpgn,nfcntn &
       &                       ,m_Files_open_kpoint_files &
       &                       ,m_Files_check_file_names &
       &                       ,m_Files_open_nfldos &
       &                       ,m_Files_close_files_initial0 &
       &                       ,m_Files_open_nfeng &
       &                       ,m_Files_open_nfcntn &
       &                       ,m_Files_reopen_nfzaj_kall &
       &                       ,nfdynm
  use m_FFT,               only:m_FFT_set_box_sizes, m_FFT_setup,fft_box_size_CD, m_FFT_reset_firstcall
  use m_PlaneWaveBasisSet, only:n_rGv,n_rGpv,n_rGpv_reduced, n_rGv_pstrn,kgp &
       &                       ,n_rGv_prev, n_rGpv_prev &
       &                       ,m_pwBS_decide_cutoff_mix &
       &                       ,m_pwBS_assume_G_rhombohedron &
       &                       ,m_pwBS_for_each_WF &
       &                       ,m_pwBS_generate_G_vectors_3D &
       &                       ,m_pwBS_G_trans_functions_3D  &
       &                       ,m_pwBS_alloc_ngpt_igfp_gr_3D &
       &                       ,m_pwBS_calc_length_of_G_3D &
       &                       ,m_pwBS_setup_FFTmapfunctions_3D &
       &                      ,m_pwBS_set_ngabc_kngp_l_3D   &
       &                      ,pre_charge_average_3D &
       &                       ,m_pwBS_positronWF &
       &                       ,m_pwBS_cp_iba_to_iba_ek &
       &                       ,m_pwBS_rebuild_gr_l, ngabc
  use m_Crystal_Structure, only:nbztyp, inversion_symmetry &
       &                       ,nbztyp_spg &
       &                       ,symmetry_method &
       &                       ,univol,altv,rltv, &
       &                           check_if_sw_inversion_is_valid &
       &                       ,m_CS_gnrt_symmetry_operations &
       &                       ,m_CS_gnrt_symm_operators_tl &
       &                       ,m_CS_alloc_op_tau &
       &                       ,m_CS_alloc_op_tau_tl &
       &                       ,symmetry_method &
       &                       ,m_CS_set_altv_prim, m_CS_set_altv_super &
       &                       ,m_CS_supercell &
       &                       ,m_CS_rd_fix_spin_status,altv &
       &                       ,m_CS_wd_op_and_tau,tau

  use m_CS_SpaceGroup,     only:m_CS_SG_auto_gnrt_sym_op &
       &                       ,m_CS_SG_print_space_group_name &
       &                       ,m_CS_remove_frac_translation
  use m_Ionic_System,      only:m_IS_alloc_napt,m_IS_symm_check_of_pos &
       &                       ,m_IS_phonon_initial_disp &
       &                       ,m_IS_phonon_init_firsthalf &
       &                       ,m_IS_phonon_init_secondhalf &
       &                       ,m_IS_phonon_set_displacement &
       &                       ,m_IS_set_napt_super, m_IS_supercell &
       &                       ,m_IS_inv_sym_off &
       &                       ,m_IS_symmetrize_atom_pos &
       &                       ,m_IS_rd_pos_and_v &
       &                       ,m_IS_natm_can_change &
       &                       ,m_IS_change_natm &
       &                       ,m_IS_wd_speciesname_etc &
       &                       ,m_IS_get_neg_incre,natm,cpd_l &
       &                       ,m_IS_gdiis_reset &
       &                       ,m_IS_CG_reset &
       &                       ,m_IS_freeze &
       &                       ,m_IS_gnrt_supercell_symmetry &
       &                       ,m_IS_rd_moved_distances_of_planes &
       &                       ,natm,ityp,iatomn,ntyp &
       &                       ,natm,ityp,iatomn,ntyp &
       &                       ,m_IS_reset_extrpl_status
  use m_PseudoPotential,   only:m_PP_input_xctype,ival,m_PP_renew_etot1
  use m_Kpoints,           only:way_ksample,kv3 &
       &                       ,m_Kp_gnrt_or_rd_k_points &
       &                       ,m_Kp_alloc_kpoints &
       &                       ,m_Kp_cr_kpoints_table &
       &                       ,m_Kp_alloc_kpoints_ek &
       &                       ,m_Kp_cp_vkxyz_to_vkxyz_ek &
       &                       ,m_Kp_realloc_kpoints &
       &                       ,m_Kp_set_mesh_super &
       &                       ,m_Kp_set_ek_group, m_Kp_realloc_kpoints2
  use m_Kpoints,           only : m_Kp_set_star_of_k, sw_force_kpt_inside_bz

  use m_Ldos,              only:m_Ldos_preparation
  use m_BerryPhase,        only:m_BP_gen_Kpoints
  use m_Orbital_Population,only: m_OP_alloc
  use m_Phonon,            only:m_Phonon_alloc_qvec, m_Phonon_set_qvec, m_Phonon_read_forces, sw_read_forces_pre
  use m_Electronic_Structure,only:m_ES_set_num_bands_super &
       &                       ,m_ES_cp_iconv, m_ES_add_neg, m_ES_reset_first_call
  use m_Wannier,           only:m_Wan_gen_weight
  use m_FiniteElectricField, only:m_FEF_init
  use m_IterationNumbers, only : m_Iter_rd_iteration_numbers,iteration_unit_cell,m_Iter_cmix_reset&
       &                       ,iteration_uramp,iteration_scdft, iteration_stress_correction, iteration_dimer
! === For restart lm+MSD! by tkato 2012/02/15 ==================================
  use m_Control_Parameters, only: m_CtrlP_rd_dtim_previous
! ==============================================================================

  use m_UnitCell, only : m_UC_doit,m_UC_get_univol_old,m_UnitCell_md
  use m_XC_Potential, only : m_XC_rst_npsend
  use m_FFT, only : m_FFT_reset_CD_setup_stat
  use m_CD_mixing, only : m_CD_force_dealloc
  use m_ES_WF_by_RMM, only : m_ESrmm_dealloc_r_norm_flag
  use m_ES_WF_by_submat, only : m_ESsubmat_dealloc


  use m_CD_Mag_Moment,      only : m_CD_alloc_rad_cov, m_CD_set_rad_cov_default, &
       &                           m_CD_set_rad_cov_now, sw_monitor_atomcharge, &
       &                           m_CD_set_sw_monitor_atomcharge, &
       &                           m_CD_set_proj_radius
! ======================================================================== 11.0&13.0U

! ================================= added by K. Tagami =================== 11.0
  use m_Control_Parameters,   only : noncol
  use m_Ionic_System,         only : m_IS_alloc_magmom_local, m_IS_init_magmom_local
  use m_CS_Magnetic,     only : m_CS_set_Magnetic_Sym, m_CS_set_inverse_operation, &
       &                        m_CS_chk_determinant_op
  use m_Crystal_Structure,   only : sw_use_magnetic_symmetry, sw_allow_frac_translation
!
  use m_CD_Mag_Moment,      only : m_CD_alloc_rad_cov, m_CD_set_rad_cov_default, &
       &                           m_CD_set_rad_cov_now
! ======================================================================== 11.0

  use m_Charge_Density,       only : m_CD_cp_chgq_to_chgqo

  use m_UnitCell,             only : m_UC_rd_cntn_data

#ifdef _INCLUDE_EXX_
! ============== KT_add ======================================= 13.0F
  use m_Control_Parameters,  only : use_fft_exx
  use m_PlaneWaveBasisSet, only : n_rGv_exx, n_rGpv_exx, m_pwBS_exxWF, m_pwBS_exxCD, m_pwBS_store_prev_kg1_kgp
  use m_FFT, only : m_FFT_set_box_size_exx, m_FFT_set_box_size_cd_exx, m_FFT_setup_exx
! ============================================================= 13.0F
#endif

! ==== KT_add ==== 13.1R
  use m_Control_Parameters,  only : sw_keep_symmetry_strict
  use m_Ionic_System, only : m_IS_symmetrize_atom_pos
  use m_Crystal_Structure, only : m_CS_read_op_tau_previous, m_CS_dealloc_op_tau
! ================ 13.1R

  use m_ES_WF_by_MatDiagon, only : m_ESmat_set_reduced_basis_mode

  use m_Control_Parameters,   only : sw_band_unfolding, howto_set_proj_radius
  use m_Band_Unfolding,       only : m_BU_set_GVec_flag_refcell

  use m_Force,                only : forc_l

  use m_Control_Parameters,   only : sw_stress_correction
  use m_Stress,               only : m_Stress_in_correction, m_Stress_decut_for_correction &
   &                               , m_Stress_correction, m_Stress_rd_cdata_4_correction, m_Stress_correction

  implicit none
  integer, intent(in) :: imode
  integer :: imd
  integer :: outer_or_inner
  include 'mpif.h'
  integer :: ggacmp_parallel_rev, xctype_is
  integer :: ne,i
  
  real(kind=DP), dimension(3,3) :: stress_tensor
  real(kind=DP) :: gmax_factor
  logical :: ini,initialization_required
  logical :: logi

  ini = initialization_required()
  if(ini) then
  call m_Files_check_file_names()
!!$  call m_CtrlP_set_wct_start       ! (ckcput)

  if(ekmode /= GRID .and. sw_phonon == OFF) then
     ! setup supercell
     call m_CS_supercell(nfout)
     call m_IS_supercell(nfout)
  end if
  if (m_IS_natm_can_change())then
     if(m_IS_change_natm()) then
        call m_IS_wd_speciesname_etc(nfdynm)
        ne = m_IS_get_neg_incre()
        call m_ES_add_neg(ne)
     endif
  endif
  endif

  if(icond==CONTINUATION .and.  m_Stress_in_correction())then
     call m_Files_open_nfcntn()
     call m_Stress_rd_cdata_4_correction(nfout,nfcntn)
     call m_Stress_correction(nfout,.true.)
  endif

  if(m_Stress_in_correction(3)) then
     gmax_factor = gmaxp/gmax
     gmax = dsqrt((gmax_org*gmax_org) + m_Stress_decut_for_correction())
     gmaxp = gmax * gmax_factor
     if(printable) then
        write(nfout,'(a,f10.5)') ' !** new cutoff : ',gmax_org*gmax_org+m_Stress_decut_for_correction()
        write(nfout,'(a,2f10.5)') ' !** new gmax and gmaxp : ',gmax,gmaxp
     endif
  endif

  if ((((sw_optimize_lattice==ON .or. imdalg == P_CONTROL .or. imdalg == PT_CONTROL) &
       & .and. iteration_unit_cell>1) .or.  &
       & ((driver == DRIVER_URAMP)  .and. (iteration_uramp>1)) .or.  &
       & ((driver == DRIVER_SC_DFT) .and. (iteration_scdft>1)) .or.  &
       & ((driver == DRIVER_DIMER)  .and. (iteration_dimer>1)) .or.  &
       & ((iteration_stress_correction<=3) .and. (iteration_stress_correction>1)))  &
       & .and. &
       & .not.(icond==CONTINUATION.and.m_CtrlP_in_initialization()))then
     if(ini)then
        call m_XC_rst_npsend()
        call m_FFT_reset_CD_setup_stat()
        call m_CD_force_dealloc()
        call m_ESrmm_dealloc_r_norm_flag()
        call m_ESsubmat_dealloc()
        call m_pwBS_store_prev_kg1_kgp()
        call m_Parallel_store_prev_np_g1k(kv3)
        call m_FFT_reset_firstcall()
        call m_ES_reset_first_call()
     endif
     call m_IS_gdiis_reset()
     call m_IS_CG_reset()
     call m_IS_reset_extrpl_status()
     call m_CtrlP_reset_optmode()
     if(sw_optimize_lattice==ON .and. sw_optimize_coordinates_once==ON)then
        call m_IS_freeze()
     endif
     if(sw_optimize_lattice == ON .and. .not. m_Stress_in_correction(3)) call m_UC_doit()
     if(imdalg == PT_CONTROL .or. imdalg == P_CONTROL) call m_UnitCell_md(forc_l)
     if(driver /= DRIVER_DIMER) call m_IS_wd_speciesname_etc(nfdynm)
  endif
!  call m_CntrlP_rst_submat_call_stat()

  if(intzaj==by_matrix_diagon) call m_ESmat_set_reduced_basis_mode(.true.)
!  if( way_ksample == MESH) call rd_spg_tetra_vars()

  if(.not.ini) then
     call m_pwBS_rebuild_gr_l()
     call m_Kp_gnrt_or_rd_k_points(nfinp,preallocation=.true.) !(kstep) -> kv3
!!$     if( m_CtrlP_way_of_smearing() == TETRAHEDRON ) call m_Kp_cr_kpoints_table() 
     if( way_ksample == MESH ) call m_Kp_cr_kpoints_table() 
     if(ipri>=1) write(nfout,'(" !** smearing_method = ",i6)') way_of_smearing

     if(sw_berry_phase == OFF) then
        call m_Kp_alloc_kpoints    ! <- kv3  -> vkxyz, qwgt
     else
        call m_BP_gen_Kpoints(preallocation=.true.) ! -> kv3
     end if
     call m_Kp_alloc_kpoints    ! with using the given value of kv3, allocate vkxyz and qwgt
     if(sw_berry_phase == ON) then
        call m_BP_gen_Kpoints(preallocation=.false.) ! -> vkxyz, qwgt
     end if
     call m_Kp_gnrt_or_rd_k_points(nfinp,preallocation=.false.) !(kstep) -> kv3

     if(imode /= SKIP_SYMMCHECK)then
       if(symmetry_method == AUTOMATIC) then
          call m_CS_SG_auto_gnrt_sym_op(paramset,nfout) ! paramset == .false.
          call m_IS_symmetrize_atom_pos(nfout) ! -> cps,pos
       else
          call m_CS_gnrt_symmetry_operations(paramset,nfout) ! paramset == .false.
          call m_CS_gnrt_symm_operators_tl(paramset,nfout) ! -(m_Crystal_Structure) -> op_tl, tau_tl
       end if

       if ( sw_phonon == OFF ) call m_IS_gnrt_supercell_symmetry(paramset,nfout)
     endif

     return
  endif

! === KT_add ==== 13.1R
  if (sw_optimize_lattice==ON.and.iteration_unit_cell>1.and. &
  &    .not.(icond==CONTINUATION.and.m_CtrlP_in_initialization()))then
     if (  sw_keep_symmetry_strict == ON ) then
        call m_CS_read_op_tau_previous
        call m_IS_symmetrize_atom_pos(nfout)
        call m_CS_dealloc_op_tau
     endif
  endif
! =============== 13.1R

! ============================== added by K. Tagami ===================== 11.0&13.0U
  if ( noncol .or. sw_use_magnetic_symmetry == ON ) then
     call m_IS_alloc_magmom_local
     call m_IS_init_magmom_local
  endif
!
  call m_CD_set_sw_monitor_atomcharge
  if ( sw_monitor_atomcharge == ON ) then
     call m_CD_alloc_rad_cov
     call m_CD_set_rad_cov_default
     call m_CD_set_rad_cov_now
  endif
! ======================================================================== 11.0&13.0U

  if(imode /= SKIP_SYMMCHECK)then
    if(symmetry_method == AUTOMATIC) then
       call m_CS_SG_auto_gnrt_sym_op(.true.,nfout) ! -(m_CS_SpaceGroup) -> nopr,af
    else
                                                     __TIMER_FJ_START(31)
     call m_CS_gnrt_symmetry_operations(.true.,nfout) ! -(m_Crystal_Structure) -> nopr,af
!!$     call m_CS_gnrt_symm_operators_tl(.true.,nfout) ! -(m_Crystal_Structure) -> nopr,af
                                                     __TIMER_FJ_STOP(31)
  end if
  call m_CS_alloc_op_tau(nfout)
  call m_CS_alloc_op_tau_tl(nfout)
  if(symmetry_method == AUTOMATIC) then
     call m_CS_SG_auto_gnrt_sym_op(paramset,nfout) ! paramset == .false.
!     if(.not. m_Stress_in_correction()) call m_IS_symmetrize_atom_pos(nfout) ! -> cps,pos
     call m_IS_symmetrize_atom_pos(nfout) ! -> cps,pos
  else
                                                     __TIMER_FJ_START(31)
     call m_CS_gnrt_symmetry_operations(paramset,nfout) ! paramset == .false.
     call m_CS_gnrt_symm_operators_tl(paramset,nfout) ! -(m_Crystal_Structure) -> nopr,af
                                                     __TIMER_FJ_STOP(31)
  end if

  call m_CS_SG_print_space_group_name(nfout)
  endif

! ============================== added by K. Tagami ===================== 11.0Ex
!  if ( noncol .and. symmetry_method /= AUTOMATIC &
!       &      .and. sw_use_magnetic_symmetry == ON ) then
!     call m_CS_set_Magnetic_Sym
!  endif
  if ( noncol ) then
     if ( sw_use_magnetic_symmetry == ON ) then
        call m_CS_set_Magnetic_Sym
     endif
  else
     call m_CS_set_Magnetic_Sym
  endif
  call m_CS_set_inverse_operation
  call m_CS_chk_determinant_op
  if ( sw_allow_frac_translation == OFF ) call m_CS_remove_frac_translation
! ======================================================================== 11.0Ex

! ============================== added by K. Tagami ===================== 12.0YAM
!  commented by T. Yamasaki 2012/12/06
!!$  call check_if_sw_inversion_is_valid( nfout )
! ======================================================================= 12.0YAM

  if(ekmode /= GRID .and. sw_phonon == ON) then
     call m_IS_inv_sym_off(nfout) ! -> inversion_symmetry
  end if
  call m_IS_alloc_napt()
                                                     __TIMER_FJ_START(31)
  if(imode /= SKIP_SYMMCHECK)then
    call m_CS_wd_op_and_tau(nfout)
  endif
  call m_IS_symm_check_of_pos()
                                                     __TIMER_FJ_STOP(31)
  if(ekmode /= GRID .and. sw_phonon == ON) then
     call m_Phonon_alloc_qvec()
     call m_Phonon_set_qvec(nfout)
     call m_CS_supercell(nfout)
     call m_IS_supercell(nfout)
     call m_IS_phonon_init_firsthalf()
     if(sw_read_forces_pre==ON) call m_Phonon_read_forces()
     call m_IS_phonon_init_secondhalf()
     call m_IS_set_napt_super
     call m_IS_phonon_initial_disp()
     call m_ES_set_num_bands_super
     call m_Kp_set_mesh_super
     if(driver .ne. DRIVER_NEB .and. icond == CONTINUATION) then
        call m_Files_open_nfcntn()
        call m_Iter_rd_iteration_numbers(nfcntn,icond)
	call m_IS_phonon_set_displacement()  ! asms
        call m_IS_rd_pos_and_v(nfcntn)
#ifndef _EMPIRICAL_
        call m_CtrlP_rd_neg_previous(nfcntn,nfout)
        call m_CtrlP_rd_edelta_ontheway(nfcntn)
#endif
! === For restart lm+MSD! by tkato 2012/02/15 ==================================
        call m_CtrlP_rd_dtim_previous(nfcntn)
! ==============================================================================
        call m_CtrlP_rd_iconvergence(nfcntn)
        call m_CtrlP_rd_corecharge_cntnbin(nfcntn) ! -> status_cntnbin_positron
        call m_CS_rd_fix_spin_status(nfcntn,nfout)  ! <-- T. Yamasaki, 18th Aug. 2009
        call m_IS_rd_moved_distances_of_planes(nfcntn) ! 19th May 2021
     end if
  end if

  call m_CtrlP_set_kimg(inversion_symmetry,nfout) ! ->kimg

  call m_pwBS_assume_G_rhombohedron() ! ->n_rGv,n_rGpv, n_rGv_pstrn
  call fft_box_finding_way(outer_or_inner)     ! -(contained here)
!!$  call m_FFT_set_box_sizes(n_rGv,n_rGpv,n_rGv_pstrn,outer_or_inner) ! ->fft_box_size_WF,CD
  call m_FFT_set_box_sizes(n_rGv,n_rGpv_reduced,n_rGv_pstrn,outer_or_inner) ! ->fft_box_size_WF,CD

#ifdef _INCLUDE_EXX_
! ================ KT_add ==================================== 13.0F
  if ( sw_hybrid_functional == ON .and. use_fft_exx ) then
     call m_FFT_set_box_size_exx( n_rGv_exx,outer_or_inner) ! ->fft_box_size_exx
  endif
  if(sw_hybrid_functional == ON ) call m_FFT_set_box_size_cd_exx( n_rGpv_exx, outer_or_inner)
! ============================================================ 13.0F
#endif

  if(ekmode /= GRID) call m_Kp_gnrt_or_rd_k_points(nfinp,preallocation=.true.) !(kstep) -> kv3
#ifdef _USE_SCALAPACK_
!  call m_CtrlP_set_sw_scalapack(printable,nfout)
#endif
  if(sw_berry_phase == OFF) then
    call m_Parallel_resolve_decomp(nfout,kv3/nspin,logi)
    if (logi) then
      call m_CtrlP_set_npartition_david(nfout)
    endif
  endif
                                                     __TIMER_FJ_START(41)
  call m_pwBS_generate_G_vectors_3D()    ! ->n_rGv,n_rGpv ->kgp
                                                     __TIMER_FJ_STOP(41)
  call m_Parallel_init_mpi_kngp_3D(nfout,ipriparallel,kgp,sw_communicator_for_chg==ON)  ! -(m_Parallelization) ->ista_kngp,iend_kngp
  call m_pwBS_set_ngabc_kngp_l_3D

!!$  if(ipri>=1) write(nfout,'(" nbztyp (nbztyp_spg) = ", i3)') nbztyp_spg
!  if(ekmode /= GRID .and. (nbztyp_spg >= GENERAL .or. way_ksample == FILE)) &
!       & call m_Files_open_kpoint_files(way_ksample,nbztyp_spg)  

  call m_pwBS_alloc_ngpt_igfp_gr_3D()
                                                     __TIMER_FJ_START(28)
  call m_pwBS_calc_length_of_G_3D()         ! -> gr_l
                                                     __TIMER_FJ_STOP(28)
  call m_pwBS_G_trans_functions_3D()   ! -> ngpt_l: Set of G-vectors translated according to symmetry operations

  ggacmp_parallel_rev = ggacmp_parallel
  call m_PP_input_xctype(xctype_is) ; if(xctype_is == LDA) ggacmp_parallel_rev = OFF
!!$  if(ipri >= 1) write(nfout,'(" ggacmp_parallel_rev = ",i3)') ggacmp_parallel_rev
  call m_Parallel_init_mpi_cdfft(nfout,ipriparallel,ggacmp_parallel_rev)
                          ! -> nrank_ggacmp, npes_cdfft, and nrest_cdfft
  call m_FFT_setup(inversion_symmetry,paramset) ! paramset == .false.

#ifdef _INCLUDE_EXX_
#ifdef FFTW3
! ================ KT_add =================================== 13.0F
  if ( sw_hybrid_functional == ON .and. use_fft_exx ) then
     call m_FFT_setup_exx( inversion_symmetry,paramset ) ! paramset == .false.
  endif
! =========================================================== 13.0F
#endif
#endif

  call m_pwBS_setup_FFTmapfunctions_3D()

  if(num_projectors>0) call m_OP_alloc()

  if(ekmode /= GRID) then
!!$     if( m_CtrlP_way_of_smearing() == TETRAHEDRON ) call m_Kp_cr_kpoints_table() 
     if( way_ksample == MESH ) call m_Kp_cr_kpoints_table() 
     if(sw_berry_phase == OFF) then
        call m_Kp_alloc_kpoints    ! <- kv3  -> vkxyz, qwgt
     else
        call m_BP_gen_Kpoints(preallocation=.true.) ! -> kv3
     end if
     call m_Kp_alloc_kpoints    ! with using the given value of kv3, allocate vkxyz and qwgt
     if(sw_berry_phase == ON) then
        call m_BP_gen_Kpoints(preallocation=.false.) ! -> vkxyz, qwgt
     end if
     call m_Kp_gnrt_or_rd_k_points(nfinp,preallocation=.false.) ! -> vkxyz, qwgt (,tk_initial)

     if(icond == PREPARATION_ONLY .or. icond == INITIAL .or. icond == CONTINUATION .or. &
        & icond==COORDINATE_CONTINUATION) then
                                                     __TIMER_FJ_START(28)
        call m_pwBS_for_each_WF(preallocation=paramset) ! -> kg1, nbase,iba (when paramset==.false.)
                                                     __TIMER_FJ_STOP(28)
     else if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
!!$        if(ekmode == OFF)&
!!$             & stop ' ! combination of ekmode and icond is illegal (Preparation)'
        call m_Files_close_files_initial0()
        call m_Files_open_nfeng(icond)
        if(ekmode == OFF .and. fixed_charge_k_parallel == ALL_AT_ONCE) then
                                                     __TIMER_FJ_START(28)
           call m_pwBS_for_each_WF(preallocation=paramset) ! -> kg1, nbase,iba (when paramset==.false.)
                                                     __TIMER_FJ_STOP(28)
           if(star_of_k()) call m_Kp_set_star_of_k
        else 
                                                     __TIMER_FJ_START(28)
           call m_pwBS_for_each_WF(preallocation=.true.) ! -> kg1, iba
                                                     __TIMER_FJ_STOP(28)
           call m_Kp_alloc_kpoints_ek()  ! -> kv3_ek (=kv3), allocate(vkxyz_ek,qwgt_ek)
           call m_Kp_cp_vkxyz_to_vkxyz_ek()
           if(star_of_k()) call m_Kp_set_star_of_k

           if(fixed_charge_k_parallel == ONE_BY_ONE) then
              call m_Kp_set_ek_group()
              call m_Kp_realloc_kpoints2()
           else
              call m_Kp_realloc_kpoints() 
           end if
           call m_pwBS_cp_iba_to_iba_ek()
           if(icond == FIXED_CHARGE_CONTINUATION) &
                & call m_ES_cp_iconv(numk_tmp,iconv_ek_tmp)
                                                     __TIMER_FJ_START(28)
           call m_pwBS_for_each_WF(preallocation=.false.) ! -> kg1, iba
                                                     __TIMER_FJ_STOP(28)
           if( icond == FIXED_CHARGE .and. &
           &  (sw_ldos==ON .or. sw_pdos==ON .or. sw_partial_charge==ON .or. sw_charge_rspace==ON)) &
           &   call m_Files_reopen_nfzaj_kall()
        end if
     else
        call phase_error_with_msg(nfout,' icond is illegal (Preparation)',__LINE__,__FILE__)
     end if
     call m_pwBS_decide_cutoff_mix()    ! ->kgpm

     if(sw_positron /= OFF) call m_pwBS_positronWF()

#ifdef _INCLUDE_EXX_
! ============= KT_add ============================= 13.0F
     if (sw_hybrid_functional == ON .and. use_fft_exx ) then
        call m_pwBS_exxWF()
        call m_pwBS_exxCD()
     endif
! ========== ======================================= 13.0F
     if(ipri>=2) write(nfout,'(" _INCLUDE_EXX_ is defined")')
#else
     if(ipri>=2) write(nfout,'(" _INCLUDE_EXX_ is not defined")')
#endif

     if(sw_ldos == ON) then
        call m_Ldos_preparation()
        call m_Files_open_nfldos()
     end if
    
     if(sw_wannier == ON) then
        call m_Wan_gen_weight(nfout)
     end if

     if(sw_fef == ON) call m_FEF_init(nfout)

  end if

!  if( way_ksample == MESH) call wd_spg_tetra_vars()

  if(imode == RETURN_AFTER_SYMMCHECK)then
    return
  endif

!!$  call m_Parallel_resolve_decomp(nfout,kv3/nspin)

  if(icond == PREPARATION_ONLY) then
     call mpi_barrier(mpi_comm_group,ierr)
     call m_Parallel_end_mpi()
     stop 'The preparation has been done.'
  end if
  call pre_charge_average_3D

  if(sw_optimize_lattice==ON.and.icond==CONTINUATION.and.sw_rebuild_pws==OFF) then
     call m_Files_open_nfcntn()
     call m_UC_rd_cntn_data(nfcntn)
  endif


  if ( sw_phonon == OFF ) call m_IS_gnrt_supercell_symmetry(paramset,nfout)

  if ( sw_band_unfolding == ON ) then
     if ( sw_force_kpt_inside_bz == OFF ) call m_BU_set_GVec_flag_refcell
  endif

  call m_Iter_cmix_reset()

contains
  subroutine fft_box_finding_way(outer_or_inner)
    integer,intent(out)::  outer_or_inner
    if( nbztyp == GENERAL &
         & .or.(nbztyp >= 30 .and. nbztyp <= 32) &
         & .or.(nbztyp >= SIMPLE_CUBIC  .and. nbztyp <= HEXAGONAL)) then
       outer_or_inner = OUTER
    else
       outer_or_inner = INNER
    endif
  end subroutine fft_box_finding_way

  function star_of_k() result(res)
    use m_Control_Parameters, only : charge_symm_mode, sw_excitation, &
  & sw_local_approx_trans_moment, sw_write_procar_file
    use m_Const_Parameters, only : ON, chg_symm_level2
    logical :: res
    res = charge_symm_mode == chg_symm_level2 .or. &
  & sw_excitation == ON .or. sw_local_approx_trans_moment == ON .or. &
  & sw_write_procar_file == ON
  end function star_of_k

end subroutine Preparation

subroutine Preparation_ek()
  use m_IterationNumbers,   only : nk_in_the_process
  use m_PlaneWaveBasisSet,  only : m_pwBS_for_each_WF, m_pwBS_cp_iba_ek_to_iba
  use m_Kpoints,            only : m_Kp_cp_vkxyz_ek_to_vkxyz
  use m_Const_Parameters,   only : ON
  use m_Control_Parameters, only : sw_dos, sw_ldos
!  use m_Ldos,               only : m_Ldos_alloc_weiwsc_etc
  
  call m_Kp_cp_vkxyz_ek_to_vkxyz(nk_in_the_process) !(kreset)
  call m_pwBS_cp_iba_ek_to_iba(nk_in_the_process)
  call m_pwBS_for_each_WF(preallocation=.false.)     !(basnum) ->(nbase)
!  if(sw_dos == ON .and. sw_ldos == ON) then
!    call m_Ldos_alloc_weiwsc_etc()
!  endif
end subroutine Preparation_ek

subroutine Preparation_grid(nk,kxyz)
  use m_Const_Parameters,only :   DP, GRID
  use m_Control_Parameters,only : ekmode 
  use m_Kpoints, only :           m_Kp_set_kv3 &
       &                        , m_Kp_alloc_kpoints &
       &                        , m_Kp_realloc_kpoints &
       &                        , m_Kp_cp_kxyz_to_vkxyz
  use m_PlaneWaveBasisSet, only : m_pwBS_for_each_WF &
       &                        , m_pwBS_increase_kg1
  implicit none
  integer, intent(in) :: nk
  real(kind=DP), dimension(3), intent(in) :: kxyz

  if(ekmode /= GRID)&
       & call phase_error_with_msg(6,' ! combination of ekmode and icond is illegal (Preparation_grid)',__LINE__,__FILE__)

  call m_Kp_set_kv3(nk)
  call m_Kp_alloc_kpoints()
  call m_Kp_cp_kxyz_to_vkxyz(nk,kxyz) ! kxyz -> vkxyz

  call m_pwBS_for_each_WF(preallocation=.true.) ! -> kg1
  call m_pwBS_increase_kg1(30)

  call m_Kp_realloc_kpoints()

end subroutine Preparation_grid

subroutine Preparation_ek_grid2(kxyz)
  use m_Const_Parameters, only : DP
  use m_PlaneWaveBasisSet,only : m_pwBS_for_each_WF
  use m_Kpoints,          only : m_Kp_cp_kxyz_to_vkxyz
  real(kind=DP),intent(in),dimension(3):: kxyz

  call m_Kp_cp_kxyz_to_vkxyz(1,kxyz)
  call m_pwBS_for_each_WF(preallocation=.false.)
end subroutine Preparation_ek_grid2

module m_ES_Mag_Constraint
! $Id: m_ES_Mag_Constraint.f90 574 2017-05-31 03:00:48Z jkoga $

  use m_Parallelization,      only : ista_kngp, iend_kngp, ierr, npes, mype, &
       &                             mpi_comm_group

  use m_PlaneWaveBasisSet,    only : ngabc, kgp, ngabc_kngp_l

  use m_PseudoPotential,    only : ilmt, nlmt, dl2p, ltp, mtp, taup, prodphi

  use m_Control_Parameters,    only : neg, ndim_spinor, ndim_magmom, noncol, kimg, &
       &                              proj_attribute, num_proj_elems, &
       &                              proj_group

  use m_Const_Parameters,  only : DP, CMPLDP, yes, PAI4, &
       &                          MAG_MOMENT_VALS_GLOBAL, MAG_MOMENT_DIREC_GLOBAL, &
       &                          MAG_MOMENT_VALS_LOCAL,  MAG_MOMENT_DIREC_LOCAL, &
       &                          MAG_MOMENT_VALS_OCCMAT, &
       &                          MAG_MOMENT_DIREC_HARDPART

  use m_Charge_Density,        only : chgq_l, chgqo_l, hsr, hsi
  use m_Ionic_System,         only : natm, ityp,  mag_direction0_atomtyp, &
       &                             magmom_local_now, mag_moment0_atomtyp, &
       &                             pos, iproj_group, mag_moment0_atoms, &
       &                             mag_moment0_atoms_is_defined, &
       &                             mag_direction0_atoms

  use m_CD_Mag_Moment,       only : rad_cov, RhoMag_on_atom

  use m_Crystal_Structure,  only : univol, rltv, altv, &
       &                           mag_constraint_type, &
       &                           mag_moment0_global, &
       &                           mag_direc0_global, &
       &                           mag_constraint_lambda

  use m_IterationNumbers,  only : iteration_electronic
  use m_Electronic_Structure,  only : vlhxc_l, vlhxcQ

  use m_Orbital_Population,    only : om, ommix

! === KT_add === 2014/08/09
  use m_Crystal_Structure,   only : Global_Quantz_Axis_Fixed
! ============== 2014/08/09

  implicit none

  include 'mpif.h'
  integer istatus(mpi_status_size)

  real(kind=DP) :: MagField_constrain_global(3)
  real(kind=DP), allocatable :: MagField_constrain_local(:,:,:)
  real(kind=DP), allocatable :: MagField_constrain_hardpart(:,:,:,:)

contains

  subroutine m_ES_add_MagConstraintPot_chgql
    if ( ndim_magmom == 1 ) return

    select case ( mag_constraint_type )
    case (MAG_MOMENT_VALS_GLOBAL)
       call case_constraint_moment_global
    case (MAG_MOMENT_DIREC_GLOBAL)
       call case_constraint_direc_global
    case (MAG_MOMENT_VALS_LOCAL)
       call case_constraint_moment_local
    case (MAG_MOMENT_DIREC_LOCAL)
       call case_constraint_direc_local
    end select

  contains

    subroutine case_constraint_moment_global
      real(kind=DP) :: MagMom(3), c1
      integer :: is, ia, it, lmt1

      if ( noncol ) then
         if ( mype == 0 ) then
            Do is=2, ndim_magmom
               MagMom(is-1) = chgq_l( 1,1,is ) *univol
            End do

            MagField_constrain_global(:) = mag_constraint_lambda &
                 &                         *( MagMom(:) -mag_moment0_global(:) )
            
            Do is=2, ndim_magmom
               vlhxc_l(1,1,is) = vlhxc_l(1,1,is) + MagField_constrain_global(is-1)
            End do
         endif

      else
         if ( mype == 0 ) then
            MagMom(1) = ( chgq_l( 1,1,1 ) -chgq_l( 1,1,2 ) )*univol
            
            MagField_constrain_global(1) = mag_constraint_lambda &
                 &                        *( MagMom(1) -mag_moment0_global(1) )

            vlhxc_l(1,1,1) = vlhxc_l(1,1,1) +MagField_constrain_global(1)
            vlhxc_l(1,1,2) = vlhxc_l(1,1,2) -MagField_constrain_global(1)
         endif

      endif

    end subroutine case_constraint_moment_global

    subroutine case_constraint_direc_global            ! only for noncol
      real(kind=DP) :: MagMom(3), MagDirec(3)
      real(kind=DP) :: c1, c2, cnorm, cnorm2
      integer :: is, ia, it, ixyz, lmt1

      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10

      if ( .not. noncol ) return

      if ( mype == 0 ) then
         Do is=2, ndim_magmom
            MagMom(is-1) = chgq_l( 1,1,is ) *univol
         End do

         cnorm2 = 0.0d0
         Do ixyz=1, 3
            cnorm2 = cnorm2 + MagMom(ixyz)**2
         End do
         cnorm = sqrt( cnorm2 )

         if ( cnorm < cnorm_lower_limit ) then
            MagField_constrain_global = 0.0d0
            return
         endif

         MagDirec = MagMom / cnorm

         Do ixyz=1, 3
            c1 = cnorm2 - MagMom(ixyz)**2
            c2 = cnorm**3
            MagField_constrain_global(ixyz) = &
                 &  mag_constraint_lambda *c1 /c2 &
                 & *( MagDirec(ixyz) - mag_direc0_global(ixyz) )
         End do

         Do is=2, ndim_magmom
            vlhxc_l(1,1,is) = vlhxc_l(1,1,is) + MagField_constrain_global(is-1)
         End do
      endif

    end subroutine case_constraint_direc_global

    subroutine case_constraint_moment_local
      real(kind=DP) :: MagMom(3), cfactor(3)
      real(kind=DP) :: rad1, fac1r, fac1i, fac2
      real(kind=DP) :: VecG(3), normG, normG3, gr, d1

      real(kind=DP), allocatable :: zfcos(:), zfsin(:)
      real(kind=DP), allocatable :: RhoMag_on_atom_mpi(:,:)

      integer :: i, j, ia, it, is, ixyz, ixyz_max, ist

      allocate(zfcos(ista_kngp:iend_kngp)); zfcos = 0.d0
      allocate(zfsin(ista_kngp:iend_kngp)); zfsin = 0.d0

      if ( noncol ) then
         ixyz_max = 3
      else
         ixyz_max = 1
      endif

      if ( allocated( MagField_constrain_local ) ) then
         deallocate( MagField_constrain_local )
      endif

      allocate( MagField_constrain_local(ista_kngp:iend_kngp, kimg, ixyz_max ))
      MagField_constrain_local = 0.0d0
!
      Do ia=1, natm
         it = ityp(ia)
         rad1 = rad_cov(ia)

         Do ixyz=1, ixyz_max
            if ( noncol ) then
               MagMom( ixyz ) = RhoMag_on_atom( ia, ixyz +1 )
            else
               MagMom( ixyz ) = RhoMag_on_atom( ia, 1 ) -RhoMag_on_atom( ia, 2 )
            endif
            
            if ( mag_moment0_atoms_is_defined ) then
               cfactor( ixyz ) = mag_constraint_lambda /univol &
                    &               *( MagMom(ixyz) -mag_moment0_atoms(ia,ixyz) )
            else
               cfactor( ixyz ) = mag_constraint_lambda /univol &
                    &               *( MagMom(ixyz) -mag_moment0_atomtyp(it,ixyz) )
            endif
               
            call calc_phase2( natm, pos, ia, kgp, ngabc_kngp_l, ista_kngp, iend_kngp, &
                 &            zfcos, zfsin )

            if ( ista_kngp == 1 ) then
               ist = 2
            else
               ist = ista_kngp
            endif

            Do i=ist, iend_kngp
               VecG(1) = rltv(1,1)*ngabc_kngp_l(i,1) +rltv(1,2)*ngabc_kngp_l(i,2) +rltv(1,3)*ngabc_kngp_l(i,3)
               VecG(2) = rltv(2,1)*ngabc_kngp_l(i,1) +rltv(2,2)*ngabc_kngp_l(i,2) +rltv(2,3)*ngabc_kngp_l(i,3)
               VecG(3) = rltv(3,1)*ngabc_kngp_l(i,1) +rltv(3,2)*ngabc_kngp_l(i,2) +rltv(3,3)*ngabc_kngp_l(i,3)
            
               normG = sqrt( VecG(1)**2 +VecG(2)**2 +VecG(3)**2 )
               normG3 = normG**3
               
               fac1r = zfcos(i); fac1i = zfsin(i)
!
               gr = normG *rad1
               fac2 = -gr *cos(gr) + sin(gr)
               fac2 = fac2 *PAI4 /normG3
!
               MagField_constrain_local( i, 1, ixyz ) &
                    & = MagField_constrain_local( i, 1, ixyz ) &
                    &   +fac1r *fac2 *cfactor( ixyz )
               if ( kimg == 2 ) then
                  MagField_constrain_local( i, 2, ixyz ) &
                       & = MagField_constrain_local( i, 2, ixyz ) &
                       &  -fac1i *fac2 *cfactor( ixyz )
               endif
            End Do

            if ( mype == 0 ) then
               fac2 = PAI4 /3.0d0 *rad1**3

               MagField_constrain_local( 1, 1, ixyz ) &
                    & = MagField_constrain_local( 1, 1, ixyz ) &
                    &   +fac2 *cfactor( ixyz )
            end if
         End Do
      End Do
!
      if ( noncol ) then
         Do i=ista_kngp, iend_kngp
            Do is=2, ndim_magmom
               vlhxc_l(i,1,is) = vlhxc_l(i,1,is) +MagField_constrain_local(i,1,is-1)
               vlhxc_l(i,2,is) = vlhxc_l(i,2,is) +MagField_constrain_local(i,2,is-1)
            End do
         End Do
      else
         Do i=ista_kngp, iend_kngp
            Do j=1, kimg
               vlhxc_l(i,j,1) = vlhxc_l(i,j,1) +MagField_constrain_local(i,j,1)
               vlhxc_l(i,j,2) = vlhxc_l(i,j,2) -MagField_constrain_local(i,j,1)
            End Do
         End Do
      endif

    end subroutine case_constraint_moment_local

    subroutine case_constraint_direc_local        
      real(kind=DP) :: MagMom(3), cfactor(3), MagDirec(3)
      real(kind=DP) :: rad1, fac1r, fac1i, fac2
      real(kind=DP) :: VecG(3), normG, normG3, gr, d1
      real(kind=DP) :: c1, c2, c3, cnorm, cnorm2,  cnorm4

      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10
!      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-4

      real(kind=DP), allocatable :: zfcos(:), zfsin(:)
      real(kind=DP), allocatable :: RhoMag_on_atom_mpi(:,:)

      integer :: i, j, ia, it, is, ixyz, ixyz_max, ist

      allocate(zfcos(ista_kngp:iend_kngp)); zfcos = 0.d0
      allocate(zfsin(ista_kngp:iend_kngp)); zfsin = 0.d0

      if ( noncol ) then
         ixyz_max = 3
      else
         ixyz_max = 1
      endif

      if ( allocated( MagField_constrain_local ) ) then
         deallocate( MagField_constrain_local )
      endif

      allocate( MagField_constrain_local(ista_kngp:iend_kngp, kimg, ixyz_max ))
      MagField_constrain_local = 0.0d0
!
      Do ia=1, natm
         it = ityp(ia)
         rad1 = rad_cov(ia)

         MagMom = 0.0d0
         Do ixyz=1, ixyz_max
            if ( noncol ) then
               MagMom( ixyz ) = RhoMag_on_atom( ia, ixyz +1 )
            else
               MagMom( ixyz ) = RhoMag_on_atom( ia, 1 ) -RhoMag_on_atom( ia, 2 )
            endif
         End do

         cnorm2 = 0.0d0
         Do ixyz=1, ixyz_max
            cnorm2 = cnorm2 + MagMom(ixyz)**2
         End do
         cnorm = sqrt( cnorm2 )

         if ( cnorm < cnorm_lower_limit ) cycle

         MagDirec = MagMom / cnorm
!

         cnorm4 = 0.0d0
         if ( mag_moment0_atoms_is_defined ) then
            Do ixyz=1, ixyz_max
               cnorm4 = cnorm4 +mag_moment0_atoms(ia,ixyz)**2
            End do
         else
            Do ixyz=1, ixyz_max
               cnorm4 = cnorm4 +mag_moment0_atomtyp(it,ixyz)**2
            End do
         endif
         cnorm4 = sqrt( cnorm4 )
!
         Do ixyz=1, ixyz_max
            if ( noncol ) then
               c1 = cnorm2 - MagMom(ixyz)**2;    c2 = cnorm**3
               if ( cnorm4 > 0.0 ) then
                  if ( mag_moment0_atoms_is_defined ) then
                     c3 = mag_constraint_lambda /univol *c1 /c2 &
                          &         *( MagDirec(ixyz) -mag_direction0_atoms(ia,ixyz) )
                  else
                     c3 = mag_constraint_lambda /univol *c1 /c2 &
                          &         *( MagDirec(ixyz) -mag_direction0_atomtyp(it,ixyz) )
                  endif
               else
                  c3 = 0.0d0
               endif
               cfactor( ixyz ) = c3
            else
               if ( cnorm4 > 0.0 ) then
                  if ( mag_moment0_atoms_is_defined ) then
                     if ( mag_moment0_atoms(ia,ixyz) > 0.0 ) then
                        c3 = 1.0d0
                     else
                        c3 = -1.0d0
                     endif
                  else
                     if ( mag_moment0_atomtyp(it,ixyz) > 0.0 ) then
                        c3 = 1.0d0
                     else
                        c3 = -1.0d0
                     endif
                  endif
                  cfactor( ixyz ) = mag_constraint_lambda /univol &
                       &               *( MagDirec(ixyz) -c3 )
               else
                  cfactor( ixyz ) = 0.0d0
               endif
            endif

!            write(2000+mype,*) "ia cfac = ", ia, cfactor(ixyz), MagDirec(1), c3
!            write(2100+mype,*) "ia  = ", ia, MagMom(ixyz), cnorm, cnorm2

            call calc_phase2( natm, pos, ia, kgp, ngabc_kngp_l, ista_kngp, iend_kngp, &
                 &            zfcos, zfsin )

            if ( ista_kngp == 1 ) then
               ist = 2
            else
               ist = ista_kngp
            endif

            Do i=ist, iend_kngp
               VecG(1) = rltv(1,1)*ngabc_kngp_l(i,1) +rltv(1,2)*ngabc_kngp_l(i,2) +rltv(1,3)*ngabc_kngp_l(i,3)
               VecG(2) = rltv(2,1)*ngabc_kngp_l(i,1) +rltv(2,2)*ngabc_kngp_l(i,2) +rltv(2,3)*ngabc_kngp_l(i,3)
               VecG(3) = rltv(3,1)*ngabc_kngp_l(i,1) +rltv(3,2)*ngabc_kngp_l(i,2) +rltv(3,3)*ngabc_kngp_l(i,3)
            
               normG = sqrt( VecG(1)**2 +VecG(2)**2 +VecG(3)**2 )
               normG3 = normG**3
               
               fac1r = zfcos(i); fac1i = zfsin(i)
!
               gr = normG *rad1
               fac2 = -gr *cos(gr) + sin(gr)
               fac2 = fac2 *PAI4 /normG3
!
               MagField_constrain_local( i, 1, ixyz ) &
                    & = MagField_constrain_local( i, 1, ixyz ) &
                    &   +fac1r *fac2 *cfactor( ixyz )
               if ( kimg == 2 ) then
                  MagField_constrain_local( i, 2, ixyz ) &
                       & = MagField_constrain_local( i, 2, ixyz ) &
                       &  -fac1i *fac2 *cfactor( ixyz )
               endif
            End Do

            if ( mype == 0 ) then
               fac2 = PAI4 /3.0d0 *rad1**3

               MagField_constrain_local( 1, 1, ixyz ) &
                    & = MagField_constrain_local( 1, 1, ixyz ) &
                    &   +fac2 *cfactor( ixyz )
            end if
         End Do
      End Do
!
      if ( noncol ) then
         Do i=ista_kngp, iend_kngp
            Do is=2, ndim_magmom
               vlhxc_l(i,1,is) = vlhxc_l(i,1,is) +MagField_constrain_local(i,1,is-1)
               vlhxc_l(i,2,is) = vlhxc_l(i,2,is) +MagField_constrain_local(i,2,is-1)
            End do
         End Do
      else
         Do i=ista_kngp, iend_kngp
            Do j=1, kimg
               vlhxc_l(i,j,1) = vlhxc_l(i,j,1) +MagField_constrain_local(i,j,1)
               vlhxc_l(i,j,2) = vlhxc_l(i,j,2) -MagField_constrain_local(i,j,1)
            End Do
         End Do
      endif

    end subroutine case_constraint_direc_local

  end subroutine m_ES_add_MagConstraintPot_chgql

  subroutine m_ES_add_MagConstraintPot_hsr
    if ( ndim_magmom == 1 ) return

    select case ( mag_constraint_type )
    case (MAG_MOMENT_VALS_OCCMAT)
       call case_constraint_moment_occmat
    case (MAG_MOMENT_DIREC_HARDPART)
       call case_constraint_direc_hardpart
    end select

  contains

    subroutine case_constraint_moment_occmat
      integer :: ia, ig, it, i, ip, ilp
      integer :: ilmt1, ilmt2, l1, l2, m1, m2, t1, t2
      integer :: ixyz, ixyz_max, is

      real(kind=DP) :: MagMom(3), cfactor(3), c1

      if ( noncol ) then
         ixyz_max = 3
      else
         ixyz_max = 1
      endif

      if ( allocated( MagField_constrain_hardpart ) ) then
         deallocate( MagField_constrain_hardpart )
      endif

      allocate( MagField_constrain_hardpart(nlmt,nlmt,natm,ixyz_max) )
      MagField_constrain_hardpart = 0.0d0
!
      do ia=1,natm
         it = ityp(ia)

         ig = iproj_group(ia)
         if(ig<1) cycle
            
         Do ixyz=1, ixyz_max
            if ( noncol ) then
               c1 = 0.0d0
               do i=1,num_proj_elems(ig)
                  ip = proj_group(i,ig)
                  Do m1=1, 2*proj_attribute(ip)%l +1
                     c1 = c1 +ommix(m1,m1,i,ia,ixyz+1)
                  End Do
               End do
               MagMom(ixyz) = c1
            else
               c1 = 0.0d0
               do i=1,num_proj_elems(ig)
                  ip = proj_group(i,ig)
                  Do m1=1, 2*proj_attribute(ip)%l +1
                     c1 = c1 +ommix(m1,m1,i,ia,1) -ommix(m1,m1,i,ia,2)
                  End Do
               End do
               MagMom(ixyz) = c1
            endif
            if ( mag_moment0_atoms_is_defined ) then
               cfactor(ixyz) = mag_constraint_lambda &
                    &               *( MagMom(ixyz) -mag_moment0_atoms(ia,ixyz) )
            else
               cfactor(ixyz) = mag_constraint_lambda &
                    &               *( MagMom(ixyz) -mag_moment0_atomtyp(it,ixyz) )
            endif
         End do

         Do ixyz=1, ixyz_max

            do i=1,num_proj_elems(ig)
               ip = proj_group(i,ig)
               it = proj_attribute(ip)%ityp
               ilp = proj_attribute(ip)%l+1
               
               do ilmt1 = 1, ilmt(it)
                  l1 = ltp(ilmt1,it); m1 = mtp(ilmt1,it); t1 = taup(ilmt1,it)
                  if ( l1 /= ilp ) cycle
                  
                  do ilmt2 = 1, ilmt(it)
                     l2 = ltp(ilmt2,it); m2 = mtp(ilmt2,it); t2 = taup(ilmt2,it)
                     if( l2 /= ilp ) cycle
                     
                     if ( m1 == m2 ) then
                        MagField_constrain_hardpart(ilmt1,ilmt2,ia,ixyz) &
                             & = MagField_constrain_hardpart(ilmt1,ilmt2,ia,ixyz) &
                             & + cfactor(ixyz) *prodphi(ip,t1,t2)
                     endif
                  end do
               end do
            end do
         End Do
      End do

      if ( noncol ) then
         Do is=2, ndim_magmom
            vlhxcQ(:,:,:,is) = vlhxcQ(:,:,:,is) &
                 &               +MagField_constrain_hardpart(:,:,:,is-1)
         End Do
      else
         vlhxcQ(:,:,:,1) = vlhxcQ(:,:,:,1) +MagField_constrain_hardpart(:,:,:,1)
         vlhxcQ(:,:,:,2) = vlhxcQ(:,:,:,2) -MagField_constrain_hardpart(:,:,:,1)
      end if

    end subroutine case_constraint_moment_occmat

    subroutine case_constraint_direc_hardpart        ! noncol only
      real(kind=DP) :: MagMom(3), MagDirec(3)
      real(kind=DP) :: c1, c2, cnorm, cnorm2
      integer :: ia, it, lmt1, lmt2, is, ixyz

      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10

      if ( .not. noncol ) return

      if ( .not. allocated( MagField_constrain_hardpart ) ) then
         allocate( MagField_constrain_hardpart(nlmt,nlmt,natm,3 ) );
      endif
!
      MagField_constrain_local = 0.0d0
!
      Do ia=1, natm
         it = ityp(ia)
         Do ixyz=1, 3
            MagMom( ixyz ) = magmom_local_now( ia,ixyz )
         End do

         cnorm2 = 0.0d0
         Do ixyz=1, 3
            cnorm2 = cnorm2 + MagMom(ixyz)**2
         End do
         cnorm = sqrt( cnorm2 )

         if ( cnorm < cnorm_lower_limit ) then
            MagField_constrain_hardpart(:,:,ia,:) = 0.0d0
            cycle
         endif

         MagDirec = MagMom / cnorm

         Do lmt1=1, ilmt(it)
            Do lmt2=1, ilmt(it)

               Do ixyz=1, 3
                  c1 = cnorm2 - MagMom(ixyz)**2
                  c2 = cnorm**3
                  MagField_constrain_hardpart(lmt1,lmt2,ia,ixyz) = &
                       &  mag_constraint_lambda *c1 /c2 &
                       & *( MagDirec(ixyz) -mag_direction0_atomtyp(it,ixyz) ) &
                       & *dl2p(lmt1,lmt2,1,it)             ! approx
               End do
            End do
         End do

         Do lmt1=1, ilmt(it)
            Do lmt2=1, ilmt(it)
               Do is=2, ndim_magmom
                  vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is) &
                       &       + MagField_constrain_hardpart(lmt1,lmt2,ia,is-1)
               End do
            End do
         End Do

      end Do

    end subroutine case_constraint_direc_hardpart

  end subroutine m_ES_add_MagConstraintPot_hsr

  subroutine m_ES_calc_MagConstraint_Energy( ene_double_counting, ene_mag_constraint )
    real(kind=DP), intent(out) :: ene_double_counting
    real(kind=DP), intent(out) :: ene_mag_constraint

    ene_double_counting = 0.0d0;      ene_mag_constraint = 0.0d0

    select case ( mag_constraint_type )

    case (MAG_MOMENT_VALS_GLOBAL)
       call case_constraint_moment_global
    case (MAG_MOMENT_DIREC_GLOBAL)
       call case_constraint_direc_global
    case (MAG_MOMENT_VALS_LOCAL)
       call case_constraint_moment_local
    case (MAG_MOMENT_DIREC_LOCAL)
       call case_constraint_direc_local

    case (MAG_MOMENT_VALS_OCCMAT)
       call case_constraint_moment_occmat
    case (MAG_MOMENT_DIREC_HARDPART)
       call case_constraint_direc_hardpart

    end select

  contains

    subroutine case_constraint_moment_global
      real(kind=DP) :: MagMom(3), c1, c2
      real(kind=DP) :: MagMomOld(3)
      integer :: is, ixyz

      if ( mype == 0 ) then

         if ( noncol ) then
            Do is=2, ndim_magmom
               MagMom(is-1) = chgq_l(  1,1,is ) *univol
!               MagMomOld(is-1) = chgqo_l(  1,1,is ) *univol
            End do
            
            c1 = 0.0d0;  c2 = 0.0d0
            Do ixyz=1, 3
               c1 = c1 + MagField_constrain_global(ixyz) *MagMom(ixyz)
               c2 = c2 + ( MagMom(ixyz) -mag_moment0_global(ixyz) )**2
            End do
         else
            MagMom(1) = ( chgq_l( 1,1,1 ) -chgq_l( 1,1,2 ) )*univol
            
            c1 = MagField_constrain_global(1) *MagMom(1)
            c2 = ( MagMom(1) -mag_moment0_global(1) )**2
         endif

         ene_double_counting = c1
         ene_mag_constraint = c2 *mag_constraint_lambda / 2.0d0
      endif

      if (npes > 1) then
         call mpi_bcast( ene_double_counting, 1, mpi_double_precision, & 
              &          0, mpi_comm_group, ierr )
         call mpi_bcast( ene_mag_constraint,  1, mpi_double_precision, &
              &          0, mpi_comm_group, ierr )
      end if

    end subroutine case_constraint_moment_global

    subroutine case_constraint_direc_global
      real(kind=DP) :: MagMom(3), MagDirec(3), c1, c2
      integer :: is, ixyz

      real(kind=DP) :: cnorm, cnorm2
      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10

      if ( mype == 0 ) then
         Do is=2, ndim_magmom
            MagMom(is-1) = chgq_l(  1,1,is ) *univol
         End do

         cnorm2 = 0.0d0
         Do ixyz=1, 3
            cnorm2 = cnorm2 + MagMom(ixyz)**2
         End do
         cnorm = sqrt( cnorm2 )

         if ( cnorm > cnorm_lower_limit ) then
            MagDirec = MagMom / cnorm

            c1 = 0.0d0;  c2 = 0.0d0
            Do ixyz=1, 3
               c1 = c1 + MagField_constrain_global(ixyz) *MagMom(ixyz)
               c2 = c2 + ( MagDirec(ixyz) -mag_direc0_global(ixyz) )**2
            End do

            ene_double_counting = c1
            ene_mag_constraint = c2 *mag_constraint_lambda /2.0d0
         endif
      endif

      if (npes > 1) then
         call mpi_bcast( ene_double_counting, 1, mpi_double_precision, & 
              &          0, mpi_comm_group, ierr )
         call mpi_bcast( ene_mag_constraint,  1, mpi_double_precision, &
              &          0, mpi_comm_group, ierr )
      end if

    end subroutine case_constraint_direc_global

    subroutine case_constraint_direc_local
      real(kind=DP) :: MagMom(3), MagDirec(3), c1, c2, c3
      integer :: i, j, ia, it, is, ixyz

      real(kind=DP) :: cnorm, cnorm2, cnorm4
      real(kind=DP) :: csum1, csum2

      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10

      csum1 = 0.0d0; csum2 = 0.0d0

      if ( noncol ) then
         Do i=ista_kngp, iend_kngp
            Do j=1, kimg
               Do ixyz=1, 3
                  csum1 = csum1 + MagField_constrain_local(i,j,ixyz)*chgq_l(i,j,ixyz+1)
               End Do
            End Do
         End Do

         Do ia=1, natm
            it = ityp(ia)
            Do ixyz=1, 3
               MagMom(ixyz) = RhoMag_on_Atom( ia,ixyz+1 )
            End do

            cnorm2 = 0.0d0
            Do ixyz=1, 3
               cnorm2 = cnorm2 + MagMom(ixyz)**2
            End do
            cnorm = sqrt( cnorm2 )

            cnorm4 = 0.0d0
            if ( mag_moment0_atoms_is_defined ) then
               Do ixyz=1, 3
                  cnorm4 = cnorm4 +mag_moment0_atoms(ia,ixyz)**2
               End do
            else
               Do ixyz=1, 3
                  cnorm4 = cnorm4 +mag_moment0_atomtyp(it,ixyz)**2
               End do
            endif
            cnorm4 = sqrt( cnorm4 )

            if ( cnorm4 > 0.0 .and. cnorm > cnorm_lower_limit ) then
               MagDirec = MagMom / cnorm
               Do ixyz=1, 3
                  csum2 = csum2 + ( MagDirec(ixyz) -mag_direction0_atomtyp(it,ixyz) )**2
               End Do
            endif
         End do

      else
         Do i=ista_kngp, iend_kngp
            Do j=1, kimg
               csum1 = csum1 + MagField_constrain_local(i,j,1) &
                    &         *( chgq_l(i,j,1) -chgq_l(i,j,2) )
            End Do
         End Do

         Do ia=1, natm
            it = ityp(ia)
            MagMom(1) = RhoMag_on_Atom( ia,1 ) -RhoMag_on_Atom( ia,2 )

            cnorm2 = 0.0d0
            Do ixyz=1, 1
               cnorm2 = cnorm2 + MagMom(ixyz)**2
            End do
            cnorm = sqrt( cnorm2 )

            cnorm4 = 0.0d0
            if ( mag_moment0_atoms_is_defined ) then
               cnorm4 = cnorm4 +mag_moment0_atoms(ia,1)**2
            else
               cnorm4 = cnorm4 +mag_moment0_atomtyp(it,1)**2
            endif

            cnorm4 = sqrt( cnorm4 )

            if ( cnorm4 > 0.0 .and. cnorm > cnorm_lower_limit ) then
               MagDirec = MagMom / cnorm
               if ( mag_moment0_atoms_is_defined ) then
                  if ( mag_moment0_atoms(ia,1) > 0.0 ) then
                     c3 = 1.0d0
                  else
                     c3 = -1.0d0
                  endif
               else
                  if ( mag_moment0_atomtyp(it,1) > 0.0 ) then
                     c3 = 1.0d0
                  else
                     c3 = -1.0d0
                  endif
               endif
               csum2 = csum2 +( MagDirec(1) -c3 )**2
            endif
         End do
      endif

      if ( npes > 1 ) then
         call mpi_allreduce( csum1, c1, 1, mpi_double_precision, &
              &              mpi_sum, mpi_comm_group, ierr )
         csum1 = c1
      endif

      ene_double_counting = csum1 *univol
      ene_mag_constraint = csum2 *mag_constraint_lambda/ 2.0d0

    end subroutine case_constraint_direc_local

    subroutine case_constraint_moment_local
      real(kind=DP) :: MagMom(3), c1, c2
      integer :: i, j, ia, it, is, ixyz

      real(kind=DP) :: csum1, csum2

      csum1 = 0.0d0; csum2 = 0.0d0

      if ( noncol ) then
         Do i=ista_kngp, iend_kngp
            Do j=1, kimg
               Do ixyz=1, 3
                  csum1 = csum1 + MagField_constrain_local(i,j,ixyz)*chgq_l(i,j,ixyz+1)
               End Do
            End Do
         End Do

         if ( mag_moment0_atoms_is_defined ) then
            Do ia=1, natm
               Do ixyz=1, 3
                  MagMom(ixyz) = RhoMag_on_Atom( ia,ixyz+1 )
                  csum2 = csum2 + ( MagMom(ixyz) -mag_moment0_atoms(ia,ixyz) )**2
               End do
            End do
         else
            Do ia=1, natm
               it = ityp(ia)
               Do ixyz=1, 3
                  MagMom(ixyz) = RhoMag_on_Atom( ia,ixyz+1 )
                  csum2 = csum2 + ( MagMom(ixyz) -mag_moment0_atomtyp(it,ixyz) )**2
               End do
            End do
         endif
      else
         Do i=ista_kngp, iend_kngp
            Do j=1, kimg
               csum1 = csum1 + MagField_constrain_local(i,j,1) &
                    &         *( chgq_l(i,j,1) -chgq_l(i,j,2) )
            End Do
         End Do

         if ( mag_moment0_atoms_is_defined ) then
            Do ia=1, natm
               MagMom(1) = RhoMag_on_Atom( ia,1 ) -RhoMag_on_Atom( ia,2 )
               csum2 = csum2 +( MagMom(1) -mag_moment0_atoms(ia,1) )**2
            End do
         else
            Do ia=1, natm
               it = ityp(ia)
               MagMom(1) = RhoMag_on_Atom( ia,1 ) -RhoMag_on_Atom( ia,2 )
               csum2 = csum2 +( MagMom(1) -mag_moment0_atomtyp(it,1) )**2
            End do
         endif
      endif

      if ( npes > 1 ) then
         call mpi_allreduce( csum1, c1, 1, mpi_double_precision, &
              &              mpi_sum, mpi_comm_group, ierr )
         csum1 = c1
      endif

      ene_double_counting = csum1 *univol
      ene_mag_constraint = csum2 *mag_constraint_lambda/ 2.0d0

    end subroutine case_constraint_moment_local

    subroutine case_constraint_moment_occmat
      integer :: ia, it, ilmt1, ilmt2, m1
      integer :: i, ig, ip, ixyz, ixyz_max
      real(kind=DP) :: MagMom(3), c1, csum1, csum2

      if ( noncol ) then
         ixyz_max = 3
      else
         ixyz_max = 1
      endif

      csum1 = 0.0d0; csum2 = 0.0d0

      if ( noncol ) then
         Do ia=1, natm
            it = ityp(ia)
            Do ixyz=1, ixyz_max
               Do ilmt1=1, ilmt(it)
                  Do ilmt2=1, ilmt(it)
                     csum1 = csum1 +MagField_constrain_hardpart(ilmt1,ilmt2,ia,ixyz) &
                          &          *hsr(ia,ilmt1,ilmt2,ixyz+1) 
                  End do
               End do
            End do
         End Do
      else
         Do ia=1, natm
            it = ityp(ia)
            Do ilmt1=1, ilmt(it)
               Do ilmt2=1, ilmt(it)
                  csum1 = csum1 +MagField_constrain_hardpart(ilmt1,ilmt2,ia,1) &
                       &          *( hsr(ia,ilmt1,ilmt2,1) -hsr(ia,ilmt1,ilmt2,2) ) 
               End Do
            End do
         End do
      endif

      Do ia=1, natm
         it = ityp(ia)
            
         ig = iproj_group(ia)
         if(ig<1) cycle
            
         if ( noncol ) then
            Do ixyz=1, ixyz_max
               c1 = 0.0d0
               do i=1,num_proj_elems(ig)
                  ip = proj_group(i,ig)
                  Do m1=1, 2*proj_attribute(ip)%l +1
                     c1 = c1 +om(m1,m1,i,ia,ixyz+1)
                  End Do
               End do
               MagMom(ixyz) = c1
            End do
         else
            c1 = 0.0d0
            do i=1,num_proj_elems(ig)
               ip = proj_group(i,ig)
               Do m1=1, 2*proj_attribute(ip)%l +1
                  c1 = c1 +om(m1,m1,i,ia,1) -om(m1,m1,i,ia,2)
               End Do
            End do
            MagMom(1) = c1
         endif

         if ( mag_moment0_atoms_is_defined ) then
            Do ixyz=1, ixyz_max
               csum2 = csum2 +( MagMom(ixyz) -mag_moment0_atoms(ia,ixyz) )**2
            End do
         else
            Do ixyz=1, ixyz_max
               csum2 = csum2 +( MagMom(ixyz) -mag_moment0_atomtyp(it,ixyz) )**2
            End do
         endif
      End Do
      ene_double_counting = csum1
      ene_mag_constraint = csum2 *mag_constraint_lambda/ 2.0d0
      
    end subroutine case_constraint_moment_occmat

    subroutine case_constraint_direc_hardpart
      real(kind=DP) :: MagMom(3), MagDirec(3), c1, c2
      integer :: ia, it, lmt1, lmt2, is, ixyz

      real(kind=DP) :: csum1, csum2
      real(kind=DP) :: cnorm, cnorm2
      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10

      csum1 = 0.0d0; csum2 = 0.0d0

      Do ia=1, natm
         it = ityp(ia)
         Do ixyz=1, 3
            MagMom(ixyz) = magmom_local_now( ia,ixyz )
         End do

         cnorm2 = 0.0d0
         Do ixyz=1, 3
            cnorm2 = cnorm2 + MagMom(ixyz)**2
         End do
         cnorm = sqrt( cnorm2 )

         if ( cnorm > cnorm_lower_limit ) then
            MagDirec = MagMom / cnorm

            Do lmt1=1, ilmt(it)
               Do lmt2=1, ilmt(it)

                  Do ixyz=1, 3
                     csum1 = csum1 + MagField_constrain_hardpart(lmt1,lmt2,ia,ixyz) &
                          &          *hsr(ia,lmt1,lmt2,ixyz +1)
                  End do
               End do
            End do

            Do ixyz=1, 3
               csum2 = csum2 + ( MagDirec(ixyz)-mag_direction0_atomtyp(it,ixyz) )**2
            End do
         endif

      End do

      ene_double_counting = csum1
      ene_mag_constraint = csum2 *mag_constraint_lambda/ 2.0d0

    end subroutine case_constraint_direc_hardpart

  end subroutine m_ES_calc_MagConstraint_Energy

! === KT_add === 2014/08/09
  subroutine m_ES_proj_magmom_G_quantz_axis
    integer :: i, j, k, is, ia
    real(kind=DP) :: ctmp1, ctmp2

! soft part
    Do k=1, kimg
       Do i=ista_kngp, iend_kngp
          ctmp1 = 0.0d0
          Do is=1, 3
             ctmp1 = ctmp1 +chgq_l(i,k,is+1) *Global_Quantz_Axis_Fixed(is)
          End do
          Do is=1, 3
             chgq_l(i,k,is+1) = ctmp1 *Global_Quantz_Axis_Fixed(is)
          End do
       End do
    End do
!
! hard part
    Do ia=1, natm
       Do i=1, nlmt
          Do j=1, nlmt
             ctmp1 = 0.0d0
             ctmp2 = 0.0d0
             Do is=1, 3
                ctmp1 = ctmp1 +hsr(ia,i,j,is+1) *Global_Quantz_Axis_Fixed(is)
                ctmp2 = ctmp2 +hsi(ia,i,j,is+1) *Global_Quantz_Axis_Fixed(is)
             End do
             Do is=1, 3
                hsr(ia,i,j,is+1) = ctmp1 *Global_Quantz_Axis_Fixed(is)
                hsi(ia,i,j,is+1) = ctmp2 *Global_Quantz_Axis_Fixed(is)
             End do
          End do
       End do
    End Do

  end subroutine m_ES_proj_magmom_G_quantz_axis
! ============== 2014/08/09

! === KT_add === 2014/09/26
  subroutine m_ES_set_magmom_zero
    integer :: is

    Do is=2, ndim_magmom
       chgq_l(:,:,is) = 0.0d0
       hsr(:,:,:,is) = 0.0d0;    
!!!!       hsi(:,:,:,is) = 0.0d0
    End do
  end subroutine m_ES_set_magmom_zero
! ============== 2014/09/26

end module m_ES_Mag_Constraint

      SUBROUTINE ZSTEQR2( COMPZ, N, D, E, Z, LDZ, NR, WORK, INFO )
*
*  -- ScaLAPACK routine (version 1.7) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     November 15, 1997
*
*     .. Scalar Arguments ..
      CHARACTER          COMPZ
      INTEGER            INFO, LDZ, N, NR
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), E( * ), WORK( * )
      COMPLEX*16         Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  ZSTEQR2 is a modified version of LAPACK routine ZSTEQR.
*  ZSTEQR2 computes all eigenvalues and, optionally, eigenvectors of a
*  symmetric tridiagonal matrix using the implicit QL or QR method.
*  ZSTEQR2 is modified from ZSTEQR to allow each ScaLAPACK process
*  running ZSTEQR2 to perform updates on a distributed matrix Q.
*  Proper usage of ZSTEQR2 can be gleaned from
*  examination of ScaLAPACK's *  PZHEEV.
*  ZSTEQR2 incorporates changes attributed to Greg Henry.
*
*  Arguments
*  =========
*
*  COMPZ   (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only.
*          = 'I':  Compute eigenvalues and eigenvectors of the
*                  tridiagonal matrix.  Z must be initialized to the
*                  identity matrix by PZLASET or ZLASET prior
*                  to entering this subroutine.
*
*  N       (input) INTEGER
*          The order of the matrix.  N >= 0.
*
*  D       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the diagonal elements of the tridiagonal matrix.
*          On exit, if INFO = 0, the eigenvalues in ascending order.
*
*  E       (input/output) DOUBLE PRECISION array, dimension (N-1)
*          On entry, the (n-1) subdiagonal elements of the tridiagonal
*          matrix.
*          On exit, E has been destroyed.
*
*  Z       (local input/local output) COMPLEX*16 array, global
*          dimension (N, N), local dimension (LDZ, NR).
*          On entry, if  COMPZ = 'V', then Z contains the orthogonal
*          matrix used in the reduction to tridiagonal form.
*          On exit, if INFO = 0, then if  COMPZ = 'V', Z contains the
*          orthonormal eigenvectors of the original symmetric matrix,
*          and if COMPZ = 'I', Z contains the orthonormal eigenvectors
*          of the symmetric tridiagonal matrix.
*          If COMPZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          eigenvectors are desired, then  LDZ >= max(1,N).
*
*  NR      (input) INTEGER
*          NR = MAX(1, NUMROC( N, NB, MYPROW, 0, NPROCS ) ).
*          If COMPZ = 'N', then NR is not referenced.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (max(1,2*N-2))
*          If COMPZ = 'N', then WORK is not referenced.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  the algorithm has failed to find all the eigenvalues in
*                a total of 30*N iterations; if INFO = i, then i
*                elements of E have not converged to zero; on exit, D
*                and E contain the elements of a symmetric tridiagonal
*                matrix which is orthogonally similar to the original
*                matrix.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TWO, THREE, HALF
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0, TWO = 2.0D0,
     $                   THREE = 3.0D0, HALF = 0.5D0 )
      COMPLEX*16         CONE
      PARAMETER          ( CONE = ( 1.0D0, 1.0D0 ) )
      INTEGER            MAXIT, NMAXLOOK
      PARAMETER          ( MAXIT = 30, NMAXLOOK = 15 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, ICOMPZ, II, ILAST, ISCALE, J, JTOT, K, L,
     $                   L1, LEND, LENDM1, LENDP1, LENDSV, LM1, LSV, M,
     $                   MM, MM1, NLOOK, NM1, NMAXIT
      DOUBLE PRECISION   ANORM, B, C, EPS, EPS2, F, G, GP, OLDEL, OLDGP,
     $                   OLDRP, P, R, RP, RT1, RT2, S, SAFMAX, SAFMIN,
     $                   SSFMAX, SSFMIN, TST, TST1
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, DLANST, DLAPY2
      EXTERNAL           LSAME, DLAMCH, DLANST, DLAPY2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLAEV2, DLARTG, DLASCL, DSTERF, XERBLA, ZLASR,
     $                   ZSWAP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SIGN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      ILAST = 0
      INFO = 0
*
      IF( LSAME( COMPZ, 'N' ) ) THEN
         ICOMPZ = 0
      ELSEIF( LSAME( COMPZ, 'I' ) ) THEN
         ICOMPZ = 1
      ELSE
         ICOMPZ = -1
      ENDIF
      IF( ICOMPZ.LT.0 ) THEN
         INFO = -1
      ELSEIF( N.LT.0 ) THEN
         INFO = -2
      ELSEIF( ICOMPZ.GT.0 .AND. LDZ.LT.MAX( 1, NR ) ) THEN
         INFO = -6
      ENDIF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZSTEQR2', -INFO )
         RETURN
      ENDIF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     If eigenvectors aren't not desired, this is faster
*
      IF( ICOMPZ.EQ.0 ) THEN
         CALL DSTERF( N, D, E, INFO )
         RETURN
      ENDIF
*
      IF( N.EQ.1 ) THEN
         Z( 1, 1 ) = CONE
         RETURN
      ENDIF
*
*     Determine the unit roundoff and over/underflow thresholds.
*
      EPS = DLAMCH( 'E' )
      EPS2 = EPS**2
      SAFMIN = DLAMCH( 'S' )
      SAFMAX = ONE / SAFMIN
      SSFMAX = SQRT( SAFMAX ) / THREE
      SSFMIN = SQRT( SAFMIN ) / EPS2
*
*     Compute the eigenvalues and eigenvectors of the tridiagonal
*     matrix.
*
      NMAXIT = N*MAXIT
      JTOT = 0
*
*     Determine where the matrix splits and choose QL or QR iteration
*     for each block, according to whether top or bottom diagonal
*     element is smaller.
*
      L1 = 1
      NM1 = N - 1
*
   10 CONTINUE
      IF( L1.GT.N )
     $   GOTO 220
      IF( L1.GT.1 )
     $   E( L1-1 ) = ZERO
      IF( L1.LE.NM1 ) THEN
         DO 20 M = L1, NM1
            TST = ABS( E( M ) )
            IF( TST.EQ.ZERO )
     $         GOTO 30
            IF( TST.LE.( SQRT( ABS( D( M ) ) )*SQRT( ABS( D( M+
     $          1 ) ) ) )*EPS ) THEN
               E( M ) = ZERO
               GOTO 30
            ENDIF
   20    CONTINUE
      ENDIF
      M = N
*
   30 CONTINUE
      L = L1
      LSV = L
      LEND = M
      LENDSV = LEND
      L1 = M + 1
      IF( LEND.EQ.L )
     $   GOTO 10
*
*     Scale submatrix in rows and columns L to LEND
*
      ANORM = DLANST( 'I', LEND-L+1, D( L ), E( L ) )
      ISCALE = 0
      IF( ANORM.EQ.ZERO )
     $   GOTO 10
      IF( ANORM.GT.SSFMAX ) THEN
         ISCALE = 1
         CALL DLASCL( 'G', 0, 0, ANORM, SSFMAX, LEND-L+1, 1, D( L ), N,
     $                INFO )
         CALL DLASCL( 'G', 0, 0, ANORM, SSFMAX, LEND-L, 1, E( L ), N,
     $                INFO )
      ELSEIF( ANORM.LT.SSFMIN ) THEN
         ISCALE = 2
         CALL DLASCL( 'G', 0, 0, ANORM, SSFMIN, LEND-L+1, 1, D( L ), N,
     $                INFO )
         CALL DLASCL( 'G', 0, 0, ANORM, SSFMIN, LEND-L, 1, E( L ), N,
     $                INFO )
      ENDIF
*
*     Choose between QL and QR iteration
*
      IF( ABS( D( LEND ) ).LT.ABS( D( L ) ) ) THEN
         LEND = LSV
         L = LENDSV
      ENDIF
*
      IF( LEND.GT.L ) THEN
*
*        QL Iteration
*
*        Look for small subdiagonal element.
*
   40    CONTINUE
         IF( L.NE.LEND ) THEN
            LENDM1 = LEND - 1
            DO 50 M = L, LENDM1
               TST = ABS( E( M ) )**2
               IF( TST.LE.( EPS2*ABS( D( M ) ) )*ABS( D( M+1 ) )+
     $             SAFMIN )GOTO 60
   50       CONTINUE
         ENDIF
*
         M = LEND
*
   60    CONTINUE
         IF( M.LT.LEND )
     $      E( M ) = ZERO
         P = D( L )
         IF( M.EQ.L )
     $      GOTO 110
*
*        If remaining matrix is 2-by-2, use DLAE2 or DLAEV2
*        to compute its eigensystem.
*
         IF( M.EQ.L+1 ) THEN
            CALL DLAEV2( D( L ), E( L ), D( L+1 ), RT1, RT2, C, S )
            WORK( L ) = C
            WORK( N-1+L ) = S
            CALL ZLASR( 'R', 'V', 'B', NR, 2, WORK( L ), WORK( N-1+L ),
     $                  Z( 1, L ), LDZ )
            D( L ) = RT1
            D( L+1 ) = RT2
            E( L ) = ZERO
            L = L + 2
            IF( L.LE.LEND )
     $         GOTO 40
            GOTO 200
         ENDIF
*
         IF( JTOT.EQ.NMAXIT )
     $      GOTO 200
         JTOT = JTOT + 1
*
*        Form shift.
*
         G = ( D( L+1 )-P ) / ( TWO*E( L ) )
         R = DLAPY2( G, ONE )
         G = D( M ) - P + ( E( L ) / ( G+SIGN( R, G ) ) )
*
         IF( ICOMPZ.EQ.0 ) THEN
*           Do not do a lookahead!
            GOTO 90
         ENDIF
*
         OLDEL = ABS( E( L ) )
         GP = G
         RP = R
         TST = ABS( E( L ) )**2
         TST = TST / ( ( EPS2*ABS( D( L ) ) )*ABS( D( L+1 ) )+SAFMIN )
*
         NLOOK = 1
         IF( ( TST.GT.ONE ) .AND. ( NLOOK.LE.NMAXLOOK ) ) THEN
   70       CONTINUE
*
*           This is the lookahead loop, going until we have
*           convergence or too many steps have been taken.
*
            S = ONE
            C = ONE
            P = ZERO
            MM1 = M - 1
            DO 80 I = MM1, L, -1
               F = S*E( I )
               B = C*E( I )
               CALL DLARTG( GP, F, C, S, RP )
               GP = D( I+1 ) - P
               RP = ( D( I )-GP )*S + TWO*C*B
               P = S*RP
               IF( I.NE.L )
     $            GP = C*RP - B
   80       CONTINUE
            OLDGP = GP
            OLDRP = RP
*           Find GP & RP for the next iteration
            IF( ABS( C*OLDRP-B ).GT.SAFMIN ) THEN
               GP = ( ( OLDGP+P )-( D( L )-P ) ) / ( TWO*( C*OLDRP-B ) )
            ELSE
*
*           Goto put in by G. Henry to fix ALPHA problem
*
               GOTO 90
*              GP = ( ( OLDGP+P )-( D( L )-P ) ) /
*    $              ( TWO*( C*OLDRP-B )+SAFMIN )
            ENDIF
            RP = DLAPY2( GP, ONE )
            GP = D( M ) - ( D( L )-P ) +
     $           ( ( C*OLDRP-B ) / ( GP+SIGN( RP, GP ) ) )
            TST1 = TST
            TST = ABS( C*OLDRP-B )**2
            TST = TST / ( ( EPS2*ABS( D( L )-P ) )*ABS( OLDGP+P )+
     $            SAFMIN )
*           Make sure that we are making progress
            IF( ABS( C*OLDRP-B ).GT.0.9D0*OLDEL ) THEN
               IF( ABS( C*OLDRP-B ).GT.OLDEL ) THEN
                  GP = G
                  RP = R
               ENDIF
               TST = HALF
            ELSE
               OLDEL = ABS( C*OLDRP-B )
            ENDIF
            NLOOK = NLOOK + 1
            IF( ( TST.GT.ONE ) .AND. ( NLOOK.LE.NMAXLOOK ) )
     $         GOTO 70
         ENDIF
*
         IF( ( TST.LE.ONE ) .AND. ( TST.NE.HALF ) .AND.
     $       ( ABS( P ).LT.EPS*ABS( D( L ) ) ) .AND.
     $       ( ILAST.EQ.L ) .AND. ( ABS( E( L ) )**2.LE.10000.0D0*
     $       ( ( EPS2*ABS( D( L ) ) )*ABS( D( L+1 ) )+SAFMIN ) ) ) THEN
*
*           Skip the current step: the subdiagonal info is just noise.
*
            M = L
            E( M ) = ZERO
            P = D( L )
            JTOT = JTOT - 1
            GOTO 110
         ENDIF
         G = GP
         R = RP
*
*        Lookahead over
*
   90    CONTINUE
*
         S = ONE
         C = ONE
         P = ZERO
*
*        Inner loop
*
         MM1 = M - 1
         DO 100 I = MM1, L, -1
            F = S*E( I )
            B = C*E( I )
            CALL DLARTG( G, F, C, S, R )
            IF( I.NE.M-1 )
     $         E( I+1 ) = R
            G = D( I+1 ) - P
            R = ( D( I )-G )*S + TWO*C*B
            P = S*R
            D( I+1 ) = G + P
            G = C*R - B
*
*           If eigenvectors are desired, then save rotations.
*
            WORK( I ) = C
            WORK( N-1+I ) = -S
*
  100    CONTINUE
*
*        If eigenvectors are desired, then apply saved rotations.
*
         MM = M - L + 1
         CALL ZLASR( 'R', 'V', 'B', NR, MM, WORK( L ), WORK( N-1+L ),
     $               Z( 1, L ), LDZ )
*
         D( L ) = D( L ) - P
         E( L ) = G
         ILAST = L
         GOTO 40
*
*        Eigenvalue found.
*
  110    CONTINUE
         D( L ) = P
*
         L = L + 1
         IF( L.LE.LEND )
     $      GOTO 40
         GOTO 200
*
      ELSE
*
*        QR Iteration
*
*        Look for small superdiagonal element.
*
  120    CONTINUE
         IF( L.NE.LEND ) THEN
            LENDP1 = LEND + 1
            DO 130 M = L, LENDP1, -1
               TST = ABS( E( M-1 ) )**2
               IF( TST.LE.( EPS2*ABS( D( M ) ) )*ABS( D( M-1 ) )+
     $             SAFMIN )GOTO 140
  130       CONTINUE
         ENDIF
*
         M = LEND
*
  140    CONTINUE
         IF( M.GT.LEND )
     $      E( M-1 ) = ZERO
         P = D( L )
         IF( M.EQ.L )
     $      GOTO 190
*
*        If remaining matrix is 2-by-2, use DLAE2 or DLAEV2
*        to compute its eigensystem.
*
         IF( M.EQ.L-1 ) THEN
            CALL DLAEV2( D( L-1 ), E( L-1 ), D( L ), RT1, RT2, C, S )
            WORK( M ) = C
            WORK( N-1+M ) = S
            CALL ZLASR( 'R', 'V', 'F', NR, 2, WORK( M ), WORK( N-1+M ),
     $                  Z( 1, L-1 ), LDZ )
            D( L-1 ) = RT1
            D( L ) = RT2
            E( L-1 ) = ZERO
            L = L - 2
            IF( L.GE.LEND )
     $         GOTO 120
            GOTO 200
         ENDIF
*
         IF( JTOT.EQ.NMAXIT )
     $      GOTO 200
         JTOT = JTOT + 1
*
*        Form shift.
*
         G = ( D( L-1 )-P ) / ( TWO*E( L-1 ) )
         R = DLAPY2( G, ONE )
         G = D( M ) - P + ( E( L-1 ) / ( G+SIGN( R, G ) ) )
*
         IF( ICOMPZ.EQ.0 ) THEN
*           Do not do a lookahead!
            GOTO 170
         ENDIF
*
         OLDEL = ABS( E( L-1 ) )
         GP = G
         RP = R
         TST = ABS( E( L-1 ) )**2
         TST = TST / ( ( EPS2*ABS( D( L ) ) )*ABS( D( L-1 ) )+SAFMIN )
         NLOOK = 1
         IF( ( TST.GT.ONE ) .AND. ( NLOOK.LE.NMAXLOOK ) ) THEN
  150       CONTINUE
*
*           This is the lookahead loop, going until we have
*           convergence or too many steps have been taken.
*
            S = ONE
            C = ONE
            P = ZERO
*
*        Inner loop
*
            LM1 = L - 1
            DO 160 I = M, LM1
               F = S*E( I )
               B = C*E( I )
               CALL DLARTG( GP, F, C, S, RP )
               GP = D( I ) - P
               RP = ( D( I+1 )-GP )*S + TWO*C*B
               P = S*RP
               IF( I.LT.LM1 )
     $            GP = C*RP - B
  160       CONTINUE
            OLDGP = GP
            OLDRP = RP
*           Find GP & RP for the next iteration
            IF( ABS( C*OLDRP-B ).GT.SAFMIN ) THEN
               GP = ( ( OLDGP+P )-( D( L )-P ) ) / ( TWO*( C*OLDRP-B ) )
            ELSE
*
*           Goto put in by G. Henry to fix ALPHA problem
*
               GOTO 170
*              GP = ( ( OLDGP+P )-( D( L )-P ) ) /
*    $              ( TWO*( C*OLDRP-B )+SAFMIN )
            ENDIF
            RP = DLAPY2( GP, ONE )
            GP = D( M ) - ( D( L )-P ) +
     $           ( ( C*OLDRP-B ) / ( GP+SIGN( RP, GP ) ) )
            TST1 = TST
            TST = ABS( ( C*OLDRP-B ) )**2
            TST = TST / ( ( EPS2*ABS( D( L )-P ) )*ABS( OLDGP+P )+
     $            SAFMIN )
*           Make sure that we are making progress
            IF( ABS( C*OLDRP-B ).GT.0.9D0*OLDEL ) THEN
               IF( ABS( C*OLDRP-B ).GT.OLDEL ) THEN
                  GP = G
                  RP = R
               ENDIF
               TST = HALF
            ELSE
               OLDEL = ABS( C*OLDRP-B )
            ENDIF
            NLOOK = NLOOK + 1
            IF( ( TST.GT.ONE ) .AND. ( NLOOK.LE.NMAXLOOK ) )
     $         GOTO 150
         ENDIF
         IF( ( TST.LE.ONE ) .AND. ( TST.NE.HALF ) .AND.
     $       ( ABS( P ).LT.EPS*ABS( D( L ) ) ) .AND.
     $       ( ILAST.EQ.L ) .AND. ( ABS( E( L-1 ) )**2.LE.10000.0D0*
     $       ( ( EPS2*ABS( D( L-1 ) ) )*ABS( D( L ) )+SAFMIN ) ) ) THEN
*
*           Skip the current step: the subdiagonal info is just noise.
*
            M = L
            E( M-1 ) = ZERO
            P = D( L )
            JTOT = JTOT - 1
            GOTO 190
         ENDIF
*
         G = GP
         R = RP
*
*        Lookahead over
*
  170    CONTINUE
*
         S = ONE
         C = ONE
         P = ZERO
         DO 180 I = M, LM1
            F = S*E( I )
            B = C*E( I )
            CALL DLARTG( G, F, C, S, R )
            IF( I.NE.M )
     $         E( I-1 ) = R
            G = D( I ) - P
            R = ( D( I+1 )-G )*S + TWO*C*B
            P = S*R
            D( I ) = G + P
            G = C*R - B
*
*           If eigenvectors are desired, then save rotations.
*
            WORK( I ) = C
            WORK( N-1+I ) = S
*
  180    CONTINUE
*
*        If eigenvectors are desired, then apply saved rotations.
*
         MM = L - M + 1
         CALL ZLASR( 'R', 'V', 'F', NR, MM, WORK( M ), WORK( N-1+M ),
     $               Z( 1, M ), LDZ )
*
         D( L ) = D( L ) - P
         E( LM1 ) = G
         ILAST = L
         GOTO 120
*
*        Eigenvalue found.
*
  190    CONTINUE
         D( L ) = P
*
         L = L - 1
         IF( L.GE.LEND )
     $      GOTO 120
         GOTO 200
*
      ENDIF
*
*     Undo scaling if necessary
*
  200 CONTINUE
      IF( ISCALE.EQ.1 ) THEN
         CALL DLASCL( 'G', 0, 0, SSFMAX, ANORM, LENDSV-LSV+1, 1,
     $                D( LSV ), N, INFO )
         CALL DLASCL( 'G', 0, 0, SSFMAX, ANORM, LENDSV-LSV, 1, E( LSV ),
     $                N, INFO )
      ELSEIF( ISCALE.EQ.2 ) THEN
         CALL DLASCL( 'G', 0, 0, SSFMIN, ANORM, LENDSV-LSV+1, 1,
     $                D( LSV ), N, INFO )
         CALL DLASCL( 'G', 0, 0, SSFMIN, ANORM, LENDSV-LSV, 1, E( LSV ),
     $                N, INFO )
      ENDIF
*
*     Check for no convergence to an eigenvalue after a total
*     of N*MAXIT iterations.
*
      IF( JTOT.LT.NMAXIT )
     $   GOTO 10
      DO 210 I = 1, N - 1
         IF( E( I ).NE.ZERO )
     $      INFO = INFO + 1
  210 CONTINUE
      GOTO 250
*
*     Order eigenvalues and eigenvectors.
*
  220 CONTINUE
*
*        Use Selection Sort to minimize swaps of eigenvectors
*
      DO 240 II = 2, N
         I = II - 1
         K = I
         P = D( I )
         DO 230 J = II, N
            IF( D( J ).LT.P ) THEN
               K = J
               P = D( J )
            ENDIF
  230    CONTINUE
         IF( K.NE.I ) THEN
            D( K ) = D( I )
            D( I ) = P
            CALL ZSWAP( NR, Z( 1, I ), 1, Z( 1, K ), 1 )
         ENDIF
  240 CONTINUE
*
  250 CONTINUE
*     WRITE( *, FMT = * )'JTOT', JTOT
      RETURN
*
*     End of DSTEQR2
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUTINE: sphrp2_for_Berry
!
!  AUTHOR(S): T. Yamamoto   May/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
  subroutine sphrp2_for_Berry(is,gv,ylm)
! $ID: $
    use m_Const_Parameters,    only : DP, PAI, PAI4
    integer, intent(in) :: is
    real(kind=DP), intent(in), dimension(3)  :: gv
    real(kind=DP), intent(out) :: ylm
!!$C spherical harmonics.
!!$c     Some lines are rewitted by T.Yamasaki according to Y.Morikawa's
!!$c   e-mail. at 4th May 1994

    real(kind=DP) :: a,b,c,d,e,f,g
    real(kind=DP) :: gx,gy,gz,gr
    real(kind=DP), parameter :: g_minimum = 1.d-10

    gx = gv(1); gy = gv(2); gz = gv(3); gr = dsqrt(gx**2+gy**2+gz**2)
    
    if(gr < g_minimum) then
      ylm = dsqrt(1.d0/PAI4)
      return
    end if

    if(is == 1) then
       a = dsqrt(1.d0/PAI4)
       ylm = a
    else if(is == 2) then
       a = dsqrt(3.d0/PAI4)
       ylm = a*gx/gr
    else if(is == 3) then
       a = dsqrt(3.d0/PAI4)
       ylm = a*gy/gr
    else if(is == 4) then
       a = dsqrt(3.d0/PAI4)
       ylm = a*gz/gr
    else if(is == 5) then
       a = dsqrt(5.d0/(16*PAI))
       d = gz**2
       e = gx**2+gy**2+d
       ylm = a*(3*d-e)/e
    else if(is == 6) then
       a = dsqrt(15.d0/(16*PAI))
       b = gx**2
       c = gy**2
       e = b+c+gz**2
       ylm = a*(b-c)/e
    else if(is == 7) then
       a = dsqrt(15.d0/PAI4)
       e = gr**2
       ylm = a*gx*gy/e
    else if(is == 8) then
       a = dsqrt(15.d0/PAI4)
       e = gr**2
       ylm = a*gy*gz/e
    else if(is == 9) then
       a = dsqrt(15.d0/PAI4)
       e = gr**2
       ylm = a*gz*gx/e
    else if(is == 10) then
       a = dsqrt(7.d0/(16*PAI))
       d = gz**2
       e = gr**2
       f = e * gr
       ylm = a*gz*(5*d-3*e)/f
    else if(is == 11) then
       a = dsqrt(21.d0/(32*PAI))
       d = gz**2
       e = gr**2
       f = e * gr
       ylm = a*gx*(5*d-e)/f
    else if(is == 12) then
       a = dsqrt(21.d0/(32*PAI))
       d = gz**2
       e = gr**2
       f = e * gr
       ylm = a*gy*(5*d-e)/f
    else if(is == 13) then
       a = dsqrt(105.d0/(16*PAI))
       b = gx**2
       c = gy**2
       e = gr**2
       f = e * gr
       ylm = a*gz*(b-c)/f
    else if(is == 14) then
       a = dsqrt(105.d0/PAI4)
       f = gr**3
       ylm = a*gx*gy*gz/f
    else if(is == 15) then
       a = dsqrt(35.d0/(32*PAI))
       b = gx**2
       c = gy**2
       f = gr**3
       ylm = a*gx*(b-3*c)/f
    else if(is == 16) then
       a = dsqrt(35.d0/(32*pai))
       b = gx**2
       c = gy**2
       f = gr**3
       ylm = a*gy*(3*b-c)/f
    else if(is == 17) then
       a = 3.d0/8.d0/dsqrt(PAI4)
       d = gz**2
       e = gr**2
       f = e**2
       ylm = a*(5*d*(7*d-6*e)/f+3.d0)
    else if(is == 18) then
       a = 15.d0/4.d0/dsqrt(10*PAI)
       d = gz**2
       e = gr**2
       f = e**2
       ylm = a*gz*gx*(7*d-3*e)/f
    else if(is == 19) then
       a = 15.d0/4.d0/dsqrt(10.d0*PAI)
       d = gz**2
       e = gr**2
       f = e**2
       ylm = a*gy*gz*(7*d-3*e)/f
    else if(is == 20) then
       a = 15.d0/8.d0/dsqrt(5*PAI)
       b = gx**2
       c = gy**2
       d = gz**2
       e = b+c+d
       f = e**2
       ylm = a*(7*d-e)*(b-c)/f
    else if(is == 21) then
       a = 15.d0/4.d0/dsqrt(5*PAI)
       d = gz**2
       e = gr**2
       f = e**2
       ylm = a*(7*d-e)*gx*gy/f
    else if(is == 22) then
       a = 105.d0/4.d0/dsqrt(70*pai)
       b = gx**2
       c = gy**2
       f = (b+c+gz**2)**2
       ylm = a*(b-3*c)*gz*gx/f
    else if(is == 23) then
       a = 105.d0/4.d0/dsqrt(70*PAI)
       b = gx**2
       c = gy**2
       f = (b+c+gz**2)**2
       ylm = a*(3.d0*b-c)*gy*gz/f
    else if(is == 24) then
       a = 105.d0/16.d0/dsqrt(35*PAI)
       b = gx**2
       c = gy**2
       f = (b+c+gz**2)**2
       ylm = a*((b-c)**2-4*b*c)/f
    else if(is == 25) then
       a = 105.d0/4.d0/dsqrt(35*PAI)
       b = gx**2
       c = gy**2
       f = (b+c+gz**2)**2
       ylm = a*(b-c)*gx*gy/f
    else if(is == 26) then
       a = dsqrt(11.d0/PAI)/16.d0
       b = gz*gz
       c = gx*gx+gy*gy+b
       f = gr**5
       ylm = a*gz*(63.d0*b*b-70.d0*b*c+15.d0*c*c)/f
    else if(is == 27) then
       a = dsqrt(165.d0/PAI)/16.d0
       b = gz*gz
       c = gx*gx+gy*gy+b
       f = gr**5
       ylm = a*gx*(21.d0*b*b-14.d0*b*c+c*c)/f
    else if(is == 28) then
       a = dsqrt(165.d0/PAI)/16.d0
       b = gz*gz
       c = gx*gx+gy*gy+b
       f = gr**5
       ylm = a*gy*(21.d0*b*b-14.d0*b*c+c*c)/f
    else if(is == 29) then
       a = dsqrt(1155.d0/(64*PAI))
       b = gz*gz
       c = gx*gx
       d = gy*gy
       e = c+d
       f = gr**5
       ylm = a*gz*(2.d0*b-e)*(c-d)/f
    else if(is == 30) then
       a = dsqrt(1155.d0/(16.d0*PAI))
       b = gz*gz
       c = gx*gx
       d = gy*gy
       e = c+d
       f = gr**5
       ylm = a*gx*gy*gz*(2.d0*b-e)/f
    else if(is == 31) then
       a = dsqrt(385.d0/(512.d0*PAI))
       b = gz*gz
       c = gx*gx
       d = gy*gy
       e = c+d
       f = gr**5
       ylm = a*gx*(8.d0*b-e)*(c-3.d0*d)/f
    else if(is == 32) then
       a = dsqrt(385.d0/(512.d0*PAI))
       b = gz*gz
       c = gx*gx
       d = gy*gy
       e = c+d
       f = gr**5
       ylm = a*gy*(8.d0*b-e)*(3.d0*c-d)/f
    else if(is == 33) then
       a = dsqrt(385.d0/(256.d0*PAI))*3.d0
       b = gx*gx
       c = gy*gy
       f = gr**5
       ylm = a*gz*(b*b-6.d0*b*c+c*c)/f
    else if(is == 34) then
       a = dsqrt(385.d0/(16.d0*PAI))*3.d0
       b = gx*gx-gy*gy
       f = gr**5
       ylm = a*gx*gy*gz*b/f
    else if(is == 35) then
       a = dsqrt(693.d0/(512.d0*PAI))
       b = gx*gx
       c = gy*gy
       f = gr**5
       ylm = a*gx*(b*b-10.d0*b*c+5.d0*c*c)/f
    else if(is == 36) then
       a = dsqrt(693.d0/(512.d0*PAI))
       b = gy*gy
       c = gx*gx
       f = gr**5
       ylm = a*gy*(b*b-10.d0*b*c+5.d0*c*c)/f
    else if(is == 37) then
       a = dsqrt(13.d0/1024.d0*PAI)
       b = gz*gz
       c = b*b
       d = c*b
       e = gx*gx+gy*gy+b
       c = c*e
       f = e*e
       b = b*f
       f = f*e
       ylm = a*((231.d0*d-315.d0*c+105.d0*b)/f-5.d0)
    else if(is == 38) then
       a = dsqrt(273.d0/(256.d0*PAI))
       b = gz*gz
       c = b*b
       e = gx*gx+gy*gy+b
       b = b*e
       d = e*e
       f = d*e
       ylm = a*gz*gx*(33.d0*c-30.d0*b+5.d0*d)/f
    else if(is == 39) then
       a = dsqrt(273.d0/(256.d0*PAI))
       b = gz*gz
       c = b*b
       e = gx*gx+gy*gy+b
       b = b*e
       d = e*e
       f = d*e
       ylm = a*gy*gz*(33.d0*c-30.d0*b+5.d0*d)/f
    else if(is == 40) then
       a = dsqrt(1365.d0/(2048.d0*PAI))
       b = gz*gz
       c = b*b
       d = gx*gx
       f = gy*gy
       e = d+f+b 
       d = d-f
       b = b*e
       g = e*e
       f = g*e
       ylm = a*d*(33.d0*c-18.d0*b+g)/f
    else if(is == 41) then
       a = dsqrt(1365.d0/(512.d0*PAI))
       b = gz*gz
       c = b*b
       e = gx*gx+gy*gy+b 
       b = b*e
       g = e*e
       f = g*e
       ylm = a*gx*gy*(33.d0*c-18.d0*b+g)/f
    else if(is == 42) then
       a = dsqrt(1365.d0/(512.d0*PAI))
       b = gz*gz
       c = gx*gx
       d = gy*gy
       e = c+d+b 
       f = e**3
       ylm = a*gz*gx*(11.d0*b-3.d0*e)*(c-3.d0*d)/f
    else if(is == 43) then
       a = dsqrt(1365.d0/(512.d0*PAI))
       b = gz*gz
       c = gy*gy
       d = gx*gx
       e = d+c+b 
       f = e**3
       ylm = a*gy*gz*(11.d0*b-3.d0*e)*(3.d0*d-c)/f
    else if(is == 44) then
       a = dsqrt(819.d0/(1024d0*PAI))
       b = gx*gx
       c = gy*gy
       d = gz*gz
       e = b+c+d
       f = e**3
       ylm = a*(11.d0*d-e)*(b*b-6.d0*b*c+c*c)/f
    else if(is == 45) then
       a = dsqrt(819.d0/(64.d0*PAI))
       b = gx*gx
       c = gy*gy
       d = gz*gz
       e = b+c+d
       f = e**3
       ylm = a*gx*gy*(11.d0*d-e)*(b-c)/f
    else if(is == 46) then
       a = dsqrt(9009.d0/(512.d0*PAI))
       b = gx*gx
       c = gy*gy
       d = gz*gz
       e = b+c+d
       f = e**3
       ylm = a*gz*gx*(b*b-10.d0*b*c+5.d0*c*c)/f
    else if(is == 47) then
       a = dsqrt(9009.d0/(512.d0*PAI))
       b = gy*gy
       c = gx*gx
       e = c+b+gz*gz
       f = e**3
       ylm = a*gy*gz*(b*b-10.d0*b*c+5.d0*c*c)/f
    else if(is == 48) then
       a = dsqrt(3003.d0/(2048.d0*PAI))
       b = gx*gx
       c = gy*gy
       e = b+c+gz*gz
       f = e**3
       ylm = a*(b-c)*(b*b-14.d0*b*c+c*c)/f
    else if(is == 49) then
       a = dsqrt(3003.d0/(2048.d0*PAI))
       b = gx*gx
       c = gy*gy
       d = b+c
       e = b+c+gz*gz
       f = e**3
       ylm = a*gx*gy*(6.d0*d*d-32.d0*b*c)/f
    end if
  end subroutine sphrp2_for_Berry

      SUBROUTINE DLAED6_INIT( )
      use dlaed6_common
      implicit NONE
*
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            MAXIT
      PARAMETER          ( MAXIT = 20 )
      DOUBLE PRECISION   ZERO, ONE, TWO, THREE, FOUR, EIGHT
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0, TWO = 2.0D0,
     $                   THREE = 3.0D0, FOUR = 4.0D0, EIGHT = 8.0D0 )
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   DSCALE( 3 ), ZSCALE( 3 )
*     ..
*     .. Local Scalars ..
      LOGICAL            SCALE
      INTEGER            I, ITER, NITER
      DOUBLE PRECISION   A, B, BASE, C, DDF, DF, ERRETM, ETA, F,
     $                   FC, SCLFAC, SCLINV,
     $                   TEMP, TEMP1, TEMP2, TEMP3, TEMP4
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, INT, LOG, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
!$OMP CRITICAL
      IF( FIRST ) THEN
         EPS = DLAMCH( 'Epsilon' )
         BASE = DLAMCH( 'Base' )
         SMALL1 = BASE**( INT( LOG( DLAMCH( 'SafMin' ) ) / LOG( BASE ) /
     $            THREE ) )
         SMINV1 = ONE / SMALL1
         SMALL2 = SMALL1*SMALL1
         SMINV2 = SMINV1*SMINV1
         FIRST = .FALSE.
      END IF
!$OMP END CRITICAL
*
      RETURN
*
*     End of DLAED6_INIT
*
      END

#if 0

#define ORIGINAL

!===============================================================================
  subroutine dump_zaj(zinn)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: zinn(kg1,np_e,ista_k:iend_k,kimg)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:,:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num
  character(len=2) :: c_img
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_zaj'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.dat1'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(kg1,neg,ista_k:iend_k,kimg) )
   allocate( t_wk2(kg1,neg,ista_k:iend_k,kimg) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do l = 1, kimg
   do k = ista_k, iend_k
   do j = 1,np_e
   do i = 1,iba(k)
     js = nis_e(myrank_e) + j-1
     t_wk2(i,js,k,l) = zinn(i,j,k,l)
   enddo
   enddo
   enddo
   enddo

   nn = kg1*neg*(iend_k-ista_k+1)*kimg
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_comm_world,err)

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_zaj'
      c_img='_1'
      if (kimg == 2) c_img='_2'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//c_img//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 4
         write(2100) kg1
         write(2100) neg
         write(2100) (iend_k-ista_k+1)
         write(2100) kimg
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_zaj

!===============================================================================
  subroutine dump_eko(eko_l)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: eko_l(np_e,ista_k:iend_k)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_eko'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(neg,ista_k:iend_k) )
   allocate( t_wk2(neg,ista_k:iend_k) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do j = ista_k, iend_k
   do i = 1,np_e
     t_wk2(ista_e+i-1,j) = eko_l(i,j)
   enddo
   enddo

   nn = neg*(iend_k-ista_k+1)
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_eko'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) neg
         write(2100) (iend_k-ista_k+1)
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_eko

!===============================================================================
  subroutine dump_occup(eko_l)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: eko_l(np_e,ista_k:iend_k)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_occup'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(neg,ista_k:iend_k) )
   allocate( t_wk2(neg,ista_k:iend_k) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do j = ista_k, iend_k
   do i = 1,np_e
     t_wk2(ista_e+i-1,j) = eko_l(i,j)
   enddo
   enddo

   nn = neg*(iend_k-ista_k+1)
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_eko'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) neg
         write(2100) (iend_k-ista_k+1)
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_occup

!===============================================================================
  subroutine dump_neordr(neordr)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: neordr(neg,ista_k:iend_k)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_neordr'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI


   if (myrank_e .eq. 0) then
      write(*,*)'called dump_neordr'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) neg
         write(2100) (iend_k-ista_k+1)
         write(2100) neordr
         close(2100)
      endif
   endif
  end subroutine dump_neordr

!===============================================================================
  subroutine dump_nrvf_ordr(nrvf_ordr)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: nrvf_ordr(neg,ista_k:iend_k)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_nrvf_ordr'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI


   if (myrank_e .eq. 0) then
      write(*,*)'called dump_nrvf_ordr'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) neg
         write(2100) (iend_k-ista_k+1)
         write(2100) nrvf_ordr
         close(2100)
      endif
   endif
  end subroutine dump_nrvf_ordr


!===============================================================================
  subroutine dump_chgq(chgq_l)

  use m_PlaneWaveBasisSet,  only : kg1, iba, kgp
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e, ista_kngp, iend_kngp
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: chgq_l(ista_kngp:iend_kngp,kimg,nspin)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_chgq'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(kgp,kimg,nspin) )
   allocate( t_wk2(kgp,kimg,nspin) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do k = 1, nspin
   do j = 1, kimg
   do i = ista_kngp, iend_kngp
     t_wk2(i,j,k) = chgq_l(i,j,k)
   enddo
   enddo
   enddo

   call mpi_allreduce(t_wk2,t_wk1,kgp*kimg*nspin,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_chgq'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 3
         write(2100) kgp
         write(2100) kimg
         write(2100) nspin
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_chgq

!===============================================================================
  subroutine dump_vxc(vxc_l)

  use m_PlaneWaveBasisSet,  only : kg1, iba, kgp
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e, ista_kngp, iend_kngp
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: vxc_l(ista_kngp:iend_kngp,kimg,nspin)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_vxc'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(kgp,kimg,nspin) )
   allocate( t_wk2(kgp,kimg,nspin) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do k = 1, nspin
   do j = 1, kimg
   do i = ista_kngp, iend_kngp
     t_wk2(i,j,k) = vxc_l(i,j,k)
   enddo
   enddo
   enddo

   call mpi_allreduce(t_wk2,t_wk1,kgp*kimg*nspin,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_vxc'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 3
         write(2100) kgp
         write(2100) kimg
         write(2100) nspin
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_vxc

!===============================================================================
  subroutine dump_vlhxcQ(vlhxcQ)

  use m_PseudoPotential,    only : nlmt
  use m_Ionic_System,       only : natm
  use m_Control_Parameters, only : nspin, kimg
  use m_IterationNumbers,   only : iteration
  use m_Parallelization,    only : myrank_e

  integer :: ierr,err

  real(kind=8),intent(in) :: vlhxcQ(nlmt,nlmt,natm,nspin)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=11) :: psuffix = 'dump_vlhxcQ'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_vlhxcQ'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 4
         write(2100) nlmt
         write(2100) nlmt
         write(2100) natm
         write(2100) nspin
         write(2100) vlhxcQ
         close(2100)
      endif
   endif
  end subroutine dump_vlhxcQ

!===============================================================================
  subroutine dump_snl(zinn)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e,mype
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup
  use m_Parallelization,    only : ista_snl, iend_snl
  use m_PseudoPotential,    only : nlmtt

  integer :: ierr,err
  real(kind=8) :: zinn(kg1,nlmtt,ista_snl:iend_snl)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, ik, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:,:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num
  character(len=2) :: c_img
  character(len=80) :: fname



#if 1
!   if (myrank_e .eq. 0) then
   if (mype .eq. 0) then
      write(*,*)'called dump snl'
      c_img='_1'
      if (kimg == 2) c_img='_2'
      do i = 0,999
         write(c_num,'(i3.3)') i
!         fname='dump_snl'//'.'//C_NUM//c_img//'.dat'
         fname='dump_snl'//'_'//C_NUM//'.data'
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 3
         write(2100) kg1
         write(2100) nlmtt
         write(2100) (iend_snl-ista_snl+1)
         write(2100) zinn
         close(2100)
      endif
   endif
#endif
  end subroutine dump_snl

!===============================================================================
  subroutine dump_qitg(qitg_l,n)

  use m_PlaneWaveBasisSet,  only : kg1, iba, kgp
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e, ista_kngp, iend_kngp
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: qitg_l(ista_kngp:iend_kngp,n)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_qitg'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(kgp,n) )
   allocate( t_wk2(kgp,n) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do j = 1, n
   do i = ista_kngp, iend_kngp
     t_wk2(i,j) = qitg_l(i,j)
   enddo
   enddo

   call mpi_allreduce(t_wk2,t_wk1,kgp*n,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_qitg'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) kgp
         write(2100) n
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_qitg

!===============================================================================
  subroutine dump_amat(amat,ix,iy)

  use m_PseudoPotential,    only : nlmt
  use m_Ionic_System,       only : natm
  use m_Control_Parameters, only : nspin, kimg
  use m_IterationNumbers,   only : iteration
  use m_Parallelization,    only : myrank_e,mype

  integer :: ierr,err

  real(kind=8),intent(in) :: amat(ix,iy)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=9) :: psuffix = 'dump_amat'

  character(len=5)  :: suffix = '.data'

   if (mype .eq. 0) then
      write(*,*)'called dump_amat'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) ix
         write(2100) iy
         write(2100) amat
         close(2100)
      endif
   endif
  end subroutine dump_amat

  subroutine dump_zajmat3D(zinn)

  use m_PlaneWaveBasisSet,  only : kg1, iba,iba2,iba,nmatsz,nmatsz2
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e_3D,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e,mype,mpi_kg_world,neg_g
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: zinn(nmatsz,np_e_3D,kimg)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num
  character(len=2) :: c_img
  character(len=80) :: fname
  character(len=9) :: psuffix = 'dump_zajm'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.data'
#else
  character(len=5)  :: suffix = '.dat1'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(nmatsz,neg,kimg) )
   allocate( t_wk2(nmatsz,neg,kimg) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do l = 1, kimg
   do j = 1,np_e_3D
   do i = 1,nmatsz
     js = neg_g(j)
     t_wk2(i,js,l) = zinn(i,j,l)
   enddo
   enddo
   enddo

   nn = nmatsz*neg*kimg
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_kg_world,err)

   if (mype .eq. 0) then
      write(*,*)'called dump_zaj'
      c_img='_1'
      if (kimg == 2) c_img='_2'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//c_img//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 3
         write(2100) nmatsz
         write(2100) neg
         write(2100) kimg
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_zajmat3D

  subroutine dump_eko3D(eko_l)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e_3D,mpi_k_world,myrank_k,map_k,ista_k_3D,iend_k_3D &
       &                         , nis_e, nie_e,mype,mpi_kg_world,neg_g
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: eko_l(np_e_3D,ista_k_3D:iend_k_3D)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_eko3'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.data'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(neg,ista_k_3D:iend_k_3D) )
   allocate( t_wk2(neg,ista_k_3D:iend_k_3D) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do j = ista_k_3D, iend_k_3D
   do i = 1,np_e_3D
     t_wk2(neg_g(i),j) = eko_l(i,j)
   enddo
   enddo

   nn = neg*(iend_k_3D-ista_k_3D+1)
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_kg_world,err)

   if (mype .eq. 0) then
      write(*,*)'called dump_eko'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) neg
         write(2100) (iend_k_3D-ista_k_3D+1)
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_eko3D


  subroutine dump_dbg(amat,ix,iy)

  use m_PseudoPotential,    only : nlmt
  use m_Ionic_System,       only : natm
  use m_Control_Parameters, only : nspin, kimg
  use m_IterationNumbers,   only : iteration
  use m_Parallelization,    only : myrank_e,mype

  integer :: ierr,err

  real(kind=8),intent(in) :: amat(ix,iy)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_dbg'

  character(len=5)  :: suffix = '.data'

   if (mype .eq. 0) then
      write(*,*)'called dump_amat'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) ix
         write(2100) iy
         write(2100) amat
         close(2100)
      endif
   endif
  end subroutine dump_dbg

  subroutine dump_dbg_int(amat,ix,iy)

  use m_PseudoPotential,    only : nlmt
  use m_Ionic_System,       only : natm
  use m_Control_Parameters, only : nspin, kimg
  use m_IterationNumbers,   only : iteration
  use m_Parallelization,    only : myrank_e,mype

  integer :: ierr,err

  integer,intent(in) :: amat(ix,iy)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_int'

  character(len=5)  :: suffix = '.data'

   if (mype .eq. 0) then
      write(*,*)'called dump_amat'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) ix
         write(2100) iy
         write(2100) amat
         close(2100)
      endif
   endif
  end subroutine dump_dbg_int

  subroutine dump_amat_c(amat,ix,iy)

  use m_PseudoPotential,    only : nlmt
  use m_Ionic_System,       only : natm
  use m_Control_Parameters, only : nspin, kimg
  use m_IterationNumbers,   only : iteration
  use m_Parallelization,    only : myrank_e,mype
  use m_Const_Parameters,    only : CMPLDP

  integer :: ierr,err

  complex(kind=CMPLDP),intent(in) :: amat(ix,iy)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=9) :: psuffix = 'dump_amat'

  character(len=5)  :: suffix = '.data'

   if (mype .eq. 0) then
      write(*,*)'called dump_amat'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) ix
         write(2100) iy
         write(2100) amat
         close(2100)
      endif
   endif
  end subroutine dump_amat_c

!===============================================================================

!===============================================================================
#ifndef ORIGINAL
  subroutine dump_many(string)
  use m_Electronic_Structure,only : zaj_l_3D,zaj_ball &
 &                                , eko_l_3D,vnlph_l_3D,nrvf_ordr,neordr &
 &                                , fsr_l_3D,fsi_l_3D ,fsr_l_2d,fsi_l_2d,fsr_l,fsi_l  &
 &                                , vlhxc_l, vlhxc_l_3D, occup_l_3D
  use m_NonLocal_Potential,  only : snl, snl_l_3D
  use m_Parallelization,     only : np_e_3D, ista_k_3D, iend_k_3D, ista_snl, iend_snl, np_g1k_3D &
 &                                , ista_kngp_3D, iend_kngp_3D
  use m_Control_Parameters,  only : neg
  use m_NonLocal_Potential,  only : snl, snl_l_3D
  use m_ES_WF_by_SDorCG,     only : zaj_old, zaj_old_3D

  character(len=32),intent(in) :: string
  integer :: i, j, k, l, m, n, is, js, nn, ifrom, IJK=40
#if 0
  write(1002,'("***** ",32a)') string

  write(1002,'("zaj_l_3D(1,:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_l_3D(1,i,1,1),i=1,np_e_3D)
  write(1002,'("zaj_l_3D(2,:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_l_3D(2,i,1,1),i=1,np_e_3D)

  if (allocated(zaj_old_3D)) then
  write(1002,'("zaj_old_3D(1,:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_old_3D(1,i,1,1),i=1,np_e_3D)
  write(1002,'("zaj_old_3D(2,:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_old_3D(2,i,1,1),i=1,np_e_3D)
  endif

  write(1002,'("zaj_ball(1,:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_ball(1,i,1,1),i=1,min(neg,IJK))
  write(1002,'("zaj_ball(2,:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_ball(2,i,1,1),i=1,min(neg,IJK))

  write(1002,'("fsr_l_3D(:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (fsr_l_3D(i,1,1),i=1,min(np_e_3D,IJK))
  write(1002,'("fsr_l_3D(:,2,1)")')
  write(1002,'(10(1x,f9.6))')  (fsr_l_3D(i,2,1),i=1,min(np_e_3D,IJK))

  write(1002,'("eko_l_3D(:,1)")')
  write(1002,'(10(1x,f9.6))')  (eko_l_3D(i,ista_k_3D),i=1,min(np_e_3D,IJK))

  write(1002,'("occup_l_3D(:,1)")')
  write(1002,'(10(1x,f9.6))')  (occup_l_3D(i,ista_k_3D),i=1,min(np_e_3D,IJK))

  write(1002,'("vnlph_l_3D(1,:,1)")')
  write(1002,'(10(1x,f9.6))')  (vnlph_l_3D(1,i,1),i=1,min(np_e_3D,IJK))
  write(1002,'("vnlph_l_3D(2,:,1)")')
  write(1002,'(10(1x,f9.6))')  (vnlph_l_3D(2,i,1),i=1,min(np_e_3D,IJK))

! write(1002,'("snl_l_3D(:,1,1)")')
! write(1002,'(10(1x,f9.6))')  (snl_l_3D(i,1,ista_snl),i=1,min(np_g1k_3D(1),IJK))
! write(1002,'("snl_l_3D(:,2,1)")')
! write(1002,'(10(1x,f9.6))')  (snl_l_3D(i,2,ista_snl),i=1,min(np_g1k_3D(1),IJK))
! write(1002,'("snl_l_3D(:,3,1)")')
! write(1002,'(10(1x,f9.6))')  (snl_l_3D(i,3,ista_snl),i=1,min(np_g1k_3D(1),IJK))

  write(1002,'("vlhxc_l_3D(:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (vlhxc_l_3D(i,1,1),i=ista_kngp_3D,min(ista_kngp_3D+IJK,iend_kngp_3D))
#endif
  end subroutine dump_many

!===============================================================================
  subroutine dump_many_ik(ik,string)
  use m_Electronic_Structure,only : zaj_l_3D,zaj_ball &
 &                                , eko_l_3D,vnlph_l_3D,nrvf_ordr,neordr &
 &                                , fsr_l_3D,fsi_l_3D ,fsr_l_2d,fsi_l_2d,fsr_l,fsi_l  &
 &                                , vlhxc_l, vlhxc_l_3D, occup_l_3D
  use m_NonLocal_Potential,  only : snl, snl_l_3D
  use m_Parallelization,     only : np_e_3D, ista_k_3D, iend_k_3D, ista_snl, iend_snl, np_g1k_3D &
 &                                , ista_kngp_3D, iend_kngp_3D
  use m_Control_Parameters,  only : neg
  use m_NonLocal_Potential,  only : snl, snl_l_3D
  use m_ES_WF_by_SDorCG,     only : zaj_old, zaj_old_3D

  character(len=32),intent(in) :: string
  integer          ,intent(in) :: ik
  integer :: i, j, k, l, m, n, is, js, nn, ifrom, IJK=40
#if 0
  write(1002,'("***** ",32a)') string

  write(1002,'("IK:",i4)') ik
  write(1002,'("zaj_l_3D(1,:,ik,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_l_3D(1,i,ik,1),i=1,np_e_3D)
  write(1002,'("zaj_l_3D(2,:,ik,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_l_3D(2,i,ik,1),i=1,np_e_3D)

  if (allocated(zaj_old_3D)) then
  write(1002,'("zaj_old_3D(1,:,ik,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_old_3D(1,i,ik,1),i=1,np_e_3D)
  write(1002,'("zaj_old_3D(2,:,ik,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_old_3D(2,i,ik,1),i=1,np_e_3D)
  endif

  write(1002,'("zaj_ball(1,:,ik,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_ball(1,i,ik,1),i=1,min(neg,IJK))
  write(1002,'("zaj_ball(2,:,ik,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_ball(2,i,ik,1),i=1,min(neg,IJK))

  write(1002,'("fsr_l_3D(:,1,ik)")')
  write(1002,'(10(1x,f9.6))')  (fsr_l_3D(i,1,ik),i=1,min(np_e_3D,IJK))
  write(1002,'("fsr_l_3D(:,2,ik)")')
  write(1002,'(10(1x,f9.6))')  (fsr_l_3D(i,2,ik),i=1,min(np_e_3D,IJK))

  write(1002,'("eko_l_3D(:,ik)")')
  write(1002,'(10(1x,f9.6))')  (eko_l_3D(i,ik),i=1,min(np_e_3D,IJK))

  write(1002,'("occup_l_3D(:,ik)")')
  write(1002,'(10(1x,f9.6))')  (occup_l_3D(i,ik),i=1,min(np_e_3D,IJK))

  write(1002,'("vnlph_l_3D(1,:,1)")')
  write(1002,'(10(1x,f9.6))')  (vnlph_l_3D(1,i,1),i=1,min(np_e_3D,IJK))
  write(1002,'("vnlph_l_3D(2,:,1)")')
  write(1002,'(10(1x,f9.6))')  (vnlph_l_3D(2,i,1),i=1,min(np_e_3D,IJK))

! write(1002,'("snl_l_3D(:,1,1)")')
! write(1002,'(10(1x,f9.6))')  (snl_l_3D(i,1,ik),i=1,min(np_g1k_3D(ik),IJK))
! write(1002,'("snl_l_3D(:,2,1)")')
! write(1002,'(10(1x,f9.6))')  (snl_l_3D(i,2,ik),i=1,min(np_g1k_3D(ik),IJK))
! write(1002,'("snl_l_3D(:,3,1)")')
! write(1002,'(10(1x,f9.6))')  (snl_l_3D(i,3,ik),i=1,min(np_g1k_3D(ik),IJK))

  write(1002,'("vlhxc_l_3D(:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (vlhxc_l_3D(i,1,1),i=ista_kngp_3D,min(ista_kngp_3D+IJK,iend_kngp_3D))
#endif
  end subroutine dump_many_ik

#endif


#endif  ! if0
!===============================================================================
  subroutine dump_fsr(zinn)

  use m_Control_Parameters, only : neg
  use m_PseudoPotential,    only : nlmta
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e,ista_fs,iend_fs,np_fs
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: zinn(np_e,np_fs,ista_k:iend_k)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existence
  character(len=3) :: c_num
  character(len=2) :: c_img
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_fsr'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.data'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(neg,nlmta,ista_k:iend_k) )
   allocate( t_wk2(neg,nlmta,ista_k:iend_k) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do k = ista_k, iend_k
   do j = 1,np_fs
   do i = 1,np_e
     js = ista_fs + j - 1
     is = ista_e  + i - 1
     t_wk2(is,js,k) = zinn(i,j,k)
   enddo
   enddo
   enddo

   nn = neg*nlmta*(iend_k-ista_k+1)
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_comm_world,err)

!   if (myrank_e .eq. 0) then
   if (mype .eq. 0) then
      write(*,*)'called dump_fsr'
      c_img='_1'
      if (kimg == 2) c_img='_2'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//c_img//suffix
         inquire(file=trim(fname), exist=existence)
         if(existence) cycle
         if(.not.existence) exit
      enddo
      if (.not.existence) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 3
         write(2100) neg
         write(2100) nlmta
         write(2100) (iend_k-ista_k+1)
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_fsr

!===============================================================================

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  MAIN PROGRAM: PHASE
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!  $Id: mdmain.F90 633 2020-12-01 05:11:03Z jkoga $
!
#ifdef FJ_TIMER
#  define __TIMER_FJ_START_w_BARRIER(str,a)  call mpi_barrier(str,ierr); call timer_sta(a)
#  define __TIMER_FJ_START(a)                call timer_sta(a)
#  define __TIMER_FJ_STOP(a)                 call timer_end(a)
#else
#  define __TIMER_FJ_START_w_BARRIER(str,a)
#  define __TIMER_FJ_START(a)
#  define __TIMER_FJ_STOP(a)
#endif
#ifdef __TIMER__
#  define __TIMER_START_w_BARRIER(str,a)  call mpi_barrier(str,ierr) ;   call timer_sta(a)
#  define __TIMER_START(a)                call timer_sta(a)
#  define __TIMER_STOP(a)                 call timer_end(a)
#else
#  define __TIMER_START_w_BARRIER(str,a)
#  define __TIMER_START(a)
#  define __TIMER_STOP(a)
#endif
!
program PHASE


  use m_Const_Parameters,    only : DRIVER_NEB,DRIVER_CONSTRAINT,DRIVER_MTD,DRIVER_SC_DFT
  use m_Parallelization,     only : mpi_comm_group


  implicit none
  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Already_Converged, Already_Converged2
  logical  :: Positron_bulk, Positron_defect, Structure_is_fixed
  logical  :: Hubbard_model
  logical  :: Forces_are_Converged, Ending_Time, Force_errors_are_tolerable,UnitCell_Converged &
  &         , Forces_are_Converged2
  logical  :: from_Initialize
  logical  :: InUeffRamping
!!$  logical  :: ChargeDensity_is_Fixed
   interface
     subroutine Initialization(init_mpi)
       integer, intent(in), optional :: init_mpi
     end subroutine Initialization
   end interface
#ifdef NEC_ITER_REG
  integer  :: count_for_ftrace
#endif

  integer :: ispin, ik, iksnl, ierR

  integer :: initmpi
  logical :: confpara
  integer :: driver
  logical :: uconv,ending_t,force_conv
  logical :: initialization_required
  
#ifdef NEC_ITER_REG
     count_for_ftrace = 0
     call FTRACE_REGION_BEGIN("INITIAL")
#endif

  confpara = Resolve_Config_Parallel()
  initmpi=1
  if(confpara) initmpi=0

  do

  ending_t = .false.
                                                  __TIMER_START(17)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,21)
!  call Initialization(init_mpi=1)
  call Initialization(initmpi)
                                                  __TIMER_FJ_STOP(21)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,22)
  call InputData_Analysis

  driver   = Resolve_Driver()

  if(ekmode()) then
    call Initialization_set_ekmode_ON()
  endif

  if (driver==DRIVER_NEB)then
#ifndef DISABLE_CONSTRAINTS
      call do_neb()
  else if (driver==DRIVER_CONSTRAINT) then
      call constrained_dynamics()
  else if (driver==DRIVER_MTD) then
      call meta_dynamics()
#endif
  else
  outer_loop:do

!  if(driver==DRIVER_SC_DFT .and. .not.Initial_SCDFTLoop()) then
!     call InputData_Analysis()
!     if(ekmode()) call Initialization_set_ekmode_ON()
!  end if
                                                  __TIMER_FJ_STOP(22)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,23)
  call Preparation(0)                  ! Basis set, symmetry check etc.
                                                  __TIMER_FJ_STOP(23)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,24)
  if(ekmode()) call Preparation_for_mpi_ek()
  if(initialization_required()) then
    call Preparation_for_mpi(1)        ! mpi
  endif
                                                  __TIMER_FJ_STOP(24)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,25)
  call PseudoPotential_Construction
                                                  __TIMER_FJ_STOP(25)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,26)
#ifdef ENABLE_ESM_PACK
  if(initialization_required())then
    call Preparation_for_ESM
  endif
#endif

  call Ewald_and_Structure_Factor
                                                  __TIMER_FJ_STOP(26)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,27)
  call Initial_Electronic_Structure
                                                  __TIMER_FJ_STOP(27)
                                                  __TIMER_STOP(17)

 
  if(ChargeDensity_is_Fixed() .and. One_by_one_in_each_rank_k()) then ! icond=2, 3
     call ekcal()  ! contained here
     exit outer_loop
  else
     call Initial_MD_Condition
#ifdef NEC_ITER_REG
     call FTRACE_REGION_END("INITIAL")
#endif

     force_conv = Already_Converged()
     if(.not.force_conv) then
#ifdef NEC_ITER_REG
        call FTRACE_REGION_BEGIN("SOLVE-FIRST")
#endif
        StressLoop: do
           AtomicConfiguration: do
              force_conv = Forces_are_Converged2()
              if(force_conv) then
                exit AtomicConfiguration
              endif
              ChargeDensity:    do

#ifdef NEC_ITER_REG
                 count_for_ftrace = count_for_ftrace + 1
                 if(count_for_ftrace .eq. 2) then
                    call FTRACE_REGION_END("SOLVE-FIRST")
                    call FTRACE_REGION_BEGIN("SOLVE-CORE")
                 end if
#endif
                 call IterationNumber_Setting

! ============================ added by K. Tagami ============- 5.0
                 call Renewal_of_Chg_Ctrl_Param
! ============================================================ 5.0
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,16)
!!$                 call ReadCheckPointData_if_needed
                 call Renewal_of_WaveFunctions
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,11)
                 call ChargeDensity_Construction(1)
                 call ChargeDensity_Mixing
                                                  __TIMER_STOP(11)
                 ending_t = Ending_Time()
                 if(ending_t)                      exit outer_loop
                 if(TotalEnergy_is_Divergent())    exit outer_loop
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,11)
                 call Renewal_of_Potential
                                                  __TIMER_STOP(11)
                 if(Hubbard_model()) then
                    call Renewal_of_Hubbard_Potential
                 end if
!!$                 call WriteCheckPointData  ! if necessary
                 if(ChargeDensity_is_Converged()) then
                                                  __TIMER_STOP(16)
                    exit ChargeDensity
                 end if
                                                  __TIMER_STOP(16)
              enddo ChargeDensity


              if(Positron_defect()) then
                 call Renewal_of_pPotential()
                 call Solve_pWaveFunctions()
              end if
              if(Structure_is_fixed()) then
                  force_conv = .true.
                  exit StressLoop
              end if
#ifdef LIBRARY_BUILD
              call Forces_phase0
#else
              call Forces
#endif
              force_conv = Forces_are_Converged()
              if(force_conv) then
                 if ( epsilon_post_scf() ) call Epsilon_PostScf
                 exit AtomicConfiguration
              endif
              if(Force_errors_are_tolerable()) then
                 call Postprocessing_during_MD()
                 call Move_Ions
                 call MDIterationNumber_Setting
                 call Ewald_and_Structure_Factor
              end if
              if(BreakMD(force_conv))then
                 exit AtomicConfiguration
              endif
           enddo AtomicConfiguration
           if(driver==DRIVER_SC_DFT) exit StressLoop
           call Stress
           exit StressLoop
        end do StressLoop



#ifdef NEC_ITER_REG
        if(count_for_ftrace .eq. 1) then
           call FTRACE_REGION_END("SOLVE-FIRST")
        else
           call FTRACE_REGION_END("SOLVE-CORE")
        end if
#endif
     end if
     if (InUeffRamping().and. .not.ending_t)then
        call MDiterationNumber_Setting3()
        if(.not.ending_t) call Array_Deallocate()
     else if (driver == DRIVER_SC_DFT.and. .not.ending_t) then
! * T.Hamada 2016.1.8 + T. Yamasaki 2016.02.21
        write(6,'(" driver = DRIVER_SC_DFT")')
        call flush(6)
        call Epsilon_Paramset
        call Epsilon_Postscf
        call setalpha_exx()
! * T.Hamada 2015.1.8
        if(Break_SC_DFT()) exit outer_loop
!!$! * T.Hamada 2015.11.4
        call SCDFTIterationNumber_Setting
        call Set_Icond
        call WriteDownData_onto_Files(.false.)
        if(.not.ending_t) call Array_Deallocate()
     else
!!$#ifdef POST3D
!!$        if(.not.InUeffRamping()) call Postprocessing(.false.)
!!$#endif
        exit outer_loop
     endif

     if(Already_Converged2() .and. .not.Positron_defect() .and. Positron_bulk()) then
#ifdef NEC_ITER_REG
        call FTRACE_REGION_BEGIN("POSITRON")
#endif
        call Renewal_of_pPotential()
        call Solve_pWaveFunctions()
#ifdef NEC_ITER_REG
        call FTRACE_REGION_END("POSITRON")
#endif
     end if

#ifdef NEC_ITER_REG
     call FTRACE_REGION_BEGIN("FINAL")
#endif
  end if

  if(ChargeDensity_is_Fixed() .and. One_by_one_in_each_rank_k()) then ! icond=2, 3
     call WriteDownData_onto_Files_ek()
  else
     call Postprocessing(.false.)
     call rttddft_main
     call WriteDownData_onto_Files(.true.)
                                                  __TIMER_FJ_STOP(39)
  end if

  enddo outer_loop

  if(.not.ending_t) call MDiterationNumber_Setting_pre()

  endif

  if (ending_t .or. OneShot()) exit

  enddo

  if(driver/=DRIVER_NEB) call Finalization_of_mpi           ! mpi
#ifdef NEC_ITER_REG
  call FTRACE_REGION_END("FINAL")
#endif
contains

  subroutine ekcal()
    use m_Epsilon_ek, only : sw_epsilon
    use m_Const_Parameters, only : ON
    logical :: AllKpoints_are_Calculated2,AllKpoints_are_Calculated, Already_Converged_for_Kgroup
    logical :: EigenValues_are_Converged, AllKpoints_are_Converged, Already_Converged
    integer :: nk
    logical :: all_conv = .true.
    nk = 0
    if(sw_epsilon == ON) then
      call Initialization_Epsilon(0)        ! Epsilon
      call Shift_Kpoint
    endif
    KPOINT_GROUP: do
       call KpointNumber_Setting2()
       if(AllKpoints_are_Converged()) exit KPOINT_GROUP
       call Preparation_ek()
       call Preparation_for_mpi_ek
       call epsmain_reallocate()
       if(sw_epsilon==ON)then
          call PseudoPotential_ek_Epsilon
       else
          call PseudoPotential_ek
       endif
       call Initial_WaveFunctions_ek
       if(.not.Already_Converged_for_kgroup()) then
          all_conv = .false.
          SolveWaveFunctions: do
             if(Ending_Time())                 exit KPOINT_GROUP
             call IterationNumber_Setting()
             call Renewal_of_WaveFunctions()
             if(EigenValues_are_Converged()) then
                if(sw_epsilon==ON)then
                   call Transition_moment_Epsilon                           ! Epsilon
                   call Dealloc_Radr_and_Wos_Epsilon                        ! Epsilon
                endif
                exit SolveWaveFunctions
             endif
          enddo SolveWaveFunctions
          call Postprocessing_k()
          if(AllKpoints_are_Calculated2(nk)) then
             all_conv = .true.
             exit KPOINT_GROUP
          endif
       else
          exit KPOINT_GROUP
       end if
    enddo KPOINT_GROUP
    call Postprocessing(.false.)
    if(all_conv.and.sw_epsilon==ON) then
      call Reset_Kpoint                                                   ! Epsilon
      call Prep_for_Calc_Epsilon                                          ! Epsilon
      call Calc_Epsilon                                                   ! Epsilon
      call Calc_Nonlinear_optics                                          ! Epsilon
      call WriteDownData_onto_Files_Eps                                   ! Epsilon
    end if
    call WriteDownData_onto_Files_ek()
  end subroutine ekcal

  logical function ChargeDensity_is_Fixed()
    use m_Control_Parameters, only : icond
    use m_Const_Parameters,   only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION
    if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
       ChargeDensity_is_Fixed = .true.
    else
       ChargeDensity_is_Fixed = .false.
    end if
  end function ChargeDensity_is_Fixed

  logical function One_by_one_in_each_rank_k()
    use m_Control_Parameters, only : fixed_charge_k_parallel
    use m_Const_Parameters,   only : ONE_BY_ONE
    if(fixed_charge_k_parallel == ONE_BY_ONE) then
       One_by_one_in_each_rank_k = .true.
    else
       One_by_one_in_each_rank_k = .false.
    end if
  end function One_by_one_in_each_rank_k


  subroutine Continuation_Mode()
    use m_Const_Parameters,   only : COORDINATE_CONTINUATION,ON,OFF
    use m_Control_Parameters, only : icond, sw_optimize_lattice,sw_rebuild_pws
    implicit none
    logical :: unitcell_can_change
    if(unitcell_can_change() .and. sw_rebuild_pws==OFF) return
    icond = COORDINATE_CONTINUATION
  end subroutine continuation_mode

  logical function BreakMD(conv)
    use m_IterationNumbers, only : iteration_ionic
    use m_Ionic_System, only : addition_frequency,m_IS_natm_can_change
    implicit none
    logical, intent(in) :: conv
    if(.not.m_IS_natm_can_change())then
       BreakMD = conv
       return
    endif
    BreakMD = mod(iteration_ionic,addition_frequency)==0
  end function BreakMD

  logical function Break_SC_DFT()
    use m_IterationNumbers, only : iteration, first_iteration_of_this_job, iteration_scdft
    use m_Control_Parameters, only : delta_epsilon, max_scdft_iteration, epsilon0, epsilon0_previous
    if(iteration-first_iteration_of_this_job <= 0 .or. iteration_scdft<=1) then
       Break_SC_DFT = .false.
    else
       if(dabs(epsilon0 - epsilon0_previous) < max(0.0, delta_epsilon)) then
          Break_SC_DFT = .true.
       else
          if(iteration_scdft > max_scdft_iteration) then
             Break_SC_DFT = .true.
          else
             Break_SC_DFT = .false.
          end if
       end if
    end if
    write(6,'(" Break_SC_DFT = ",L3)') Break_SC_DFT
    call flush(6)
  end function Break_SC_DFT

  logical function Initial_SCDFTLoop()
    use m_IterationNumbers, only : iteration_scdft, iteration_scdft_initial
    Initial_SCDFTLoop = .true.
    if(Iteration_scdft > Iteration_scdft_initial) Initial_SCDFTLoop = .false.
!!$    if(mype==0) then
       write(6,*) ' ! Iteration_scdft, iteration_scdft_initial = ', iteration_scdft,iteration_scdft_initial
       write(6,*) ' I Initial_SCDFTLoop = ',Initial_SCDFTLoop
       call flush(6)
!!$    end if
  end function Initial_SCDFTLoop

  subroutine setalpha_exx()
    use m_Control_Parameters, only : m_CtrlP_set_alpha_exx, epsilon0
    use m_Files,              only : nfout
    use m_Const_Parameters,   only : DP
    real(kind=DP) :: alpha
    alpha = 1.d0/epsilon0
    call m_CtrlP_set_alpha_exx(nfout,alpha)
  end subroutine setalpha_exx

  logical function OneShot()
    use m_Ionic_System, only : m_IS_natm_can_change
    use m_Control_Parameters, only : sw_optimize_lattice
    use m_Const_Parameters, only : OFF
    implicit none
    logical :: unitcell_can_change
    OneShot = .not.m_IS_natm_can_change()
    if(OneShot) then
        OneShot = .not.unitcell_can_change()
    endif
  end function OneShot

! === KT_add ==== 13.1R
  logical function epsilon_post_scf()
    use m_Const_Parameters,   only : ON, OFF
    use m_Epsilon_ek,  only : sw_epsilon, m_Eps_chkif_sw_epsilon
    use m_Control_Parameters, only : sw_phonon, sw_phonon_with_epsilon, &
         &                           sw_calc_dielectric_tensor, sw_excitation

    implicit none
    logical, save :: First = .true.

    epsilon_post_scf = .false.

    if ( First ) then
       call m_Eps_chkif_sw_epsilon;        First = .false.
    endif
    if ( sw_epsilon == OFF .and. sw_excitation == OFF ) return

    if ( sw_phonon == ON ) then
       if ( sw_phonon_with_epsilon == ON .and. sw_calc_dielectric_tensor == ON ) then
          epsilon_post_scf = .true.
       endif
    else
!       epsilon_post_scf = .true.
       epsilon_post_scf = .false.
    endif

  end function epsilon_post_scf

  logical function epsilon_post_proc()
    use m_Const_Parameters,   only : ON, OFF
    use m_Epsilon_ek,  only : sw_epsilon, m_Eps_chkif_sw_epsilon
    use m_Control_Parameters, only : sw_phonon, sw_phonon_with_epsilon, &
         &                           sw_calc_dielectric_tensor, sw_excitation

    implicit none
    logical, save :: First = .true.

    epsilon_post_proc = .false.

    if ( First ) then
       call m_Eps_chkif_sw_epsilon;        First = .false.
    endif
    if ( sw_epsilon == OFF .and. sw_excitation == OFF ) return

    if ( sw_phonon == ON ) then
       epsilon_post_proc = .false.
    else
       epsilon_post_proc = .true.
    endif

  end function epsilon_post_proc
! =============== 13.1R

  integer function Resolve_Driver()
    use m_Control_Parameters, only : driver
    Resolve_Driver = driver
  end function Resolve_Driver

  logical function ekmode()
    use m_Control_Parameters, only : icond,fixed_charge_k_parallel
    use m_Const_Parameters, only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION,ONE_BY_ONE
    implicit none
    ekmode = .false.
    if((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION) .and. &
    &  fixed_charge_k_parallel .eq. ONE_BY_ONE) then
       ekmode = .true.
    endif
  end function ekmode

  logical function Resolve_Config_Parallel()
    use m_Parallelization, only : m_Parallel_resolve_conf_para
    implicit none
    Resolve_Config_Parallel = m_Parallel_resolve_conf_para()
  end function Resolve_Config_Parallel

  subroutine Postprocessing_during_MD()
    use m_IterationNumbers, only : iteration_ionic
    use m_Control_Parameters, only : postproc_frequency
    if(postproc_frequency<=0) return
    if(mod(iteration_ionic,postproc_frequency)==0)then
       call Postprocessing(.true.)
    endif
  end subroutine Postprocessing_during_MD

   subroutine Set_Icond
     use m_Const_Parameters,   only : INITIAL
     use m_Control_Parameters, only : m_CtrlP_set_icond
     call m_CtrlP_set_icond(INITIAL)
   end subroutine Set_Icond

end program PHASE

  subroutine Array_Deallocate()
     use m_Const_Parameters, only : OFF, ON, DRIVER_URAMP, DRIVER_SC_DFT, DRIVER_NEB
     use m_Control_Parameters, only : m_CtrlP_dealloc,sw_rebuild_pws,m_CtrlP_set_init_status
     use m_Crystal_Structure, only : m_CS_dealloc
     use m_Ionic_System, only : m_IS_dealloc
     use m_PlaneWaveBasisSet, only : m_pwBS_dealloc
     use m_Parallelization, only : m_Parallel_dealloc,m_Parallel_dealloc_mpi_nlmta,m_Parallel_dealloc_mpi_elec &
    &                            , m_Parallel_dealloc_mpi_nval,m_Parallel_dealloc_mpi_fft_box &
    &                            , m_Parallel_dealloc_mpi_kngp_B,m_Parallel_fft_onto_wf_dealloc_3D &
    &                            , m_Parallel_dealloc_mpi_exx &
    &                            , m_Parallel_cp_g1k
     use m_Kpoints, only : m_Kp_dealloc, kv3
     use m_Force, only : m_Force_dealloc
     use m_Charge_Density, only : m_CD_dealloc
     use m_XC_Potential, only : m_XC_dealloc_vxc_3D
     use m_PseudoPotential, only : m_PP_dealloc, flg_paw
     use m_NonLocal_Potential, only : m_NLP_dealloc
     use m_Electronic_Structure, only : m_ES_dealloc
     use m_ES_WF_by_SDorCG, only : m_ESsd_dealloc
     use m_PAW_ChargeDensity, only : m_PAW_dealloc
     use m_PAW_XC_Potential, only : m_PAW_XC_dealloc_vxc
     use m_ES_wf_extrpl, only : m_ES_wf_extrpl_dealloc

! ===== KT_add ============== 13.0AS
     use m_Control_Parameters,  only : num_projectors, sw_hubbard
     use m_Orbital_Population,only: m_OP_dealloc
     use m_Electronic_Structure,  only : m_ES_dealloc_Dhub
! ============================13.0AS

! ======== KT_add ============= 2013/10/31
     use m_Control_Parameters, only: noncol, SpinOrbit_Mode, driver
     use m_Const_Parameters,   only: Neglected, BuiltIn, ByPawPot, ZeffApprox, &
          &                          ByProjector, ReadFromPP
     use m_SpinOrbit_Potential,only: m_SO_dealloc_Dsoc, m_SO_dealloc_Mat_SOC_Strenth
! ============================= 2013/10/31

! ========= KT_add ========= 13.0U2
  use m_Control_Parameters,   only : sw_modified_TFW_functional
  use m_ThomasFermiW_Potential,  only : m_TFW_dealloc_ChgDensityBasisFn
! ========================== 13.0U2

! ====== KT_add === 2014/08/01
  use m_Orbital_QuantumNum, only : m_OP_Qnum_dealloc_array
! ================= 2014/08/01

  use m_Ldos, only : m_Ldos_dealloc

#ifdef FFTW3
  use m_FFT, only : m_FFT_finalize
#endif

     implicit none

     if (sw_rebuild_pws==OFF .or. driver == DRIVER_URAMP .or. driver == DRIVER_SC_DFT ) then
        call m_PP_dealloc()
        call m_NLP_dealloc()
        call m_Parallel_dealloc_mpi_nlmta()
        call m_Parallel_dealloc_mpi_exx()
        call m_Kp_dealloc
!        call m_ES_dealloc
!        call m_ESsd_dealloc
        return
     endif

     call m_CtrlP_dealloc
     call m_ES_dealloc
     call m_pwBS_dealloc
     call m_Parallel_cp_g1k(kv3)
     call m_Parallel_dealloc
     call m_Parallel_dealloc_mpi_elec
     call m_Parallel_dealloc_mpi_fft_box
     call m_Parallel_dealloc_mpi_nval
     call m_Parallel_fft_onto_wf_dealloc_3D
     call m_Parallel_dealloc_mpi_kngp_B
     call m_CS_dealloc
     call m_IS_dealloc
  !call m_Parallel_dealloc_mpi_elec
     call m_Kp_dealloc
     call m_PP_dealloc
     call m_CD_dealloc
     call m_Force_dealloc
     call m_NLP_dealloc
     call m_ESsd_dealloc
     call m_XC_dealloc_vxc_3D
     call m_PAW_dealloc
     if(flg_paw) then
         call m_PAW_XC_dealloc_vxc
     endif

! ==== KT_add ============== 2013/10/31
     if ( noncol ) then
        if ( SpinOrbit_Mode == ByPawPot .or. SpinOrbit_Mode == ZeffApprox &
             &                          .or. SpinOrbit_Mode == ReadFromPP ) then
           call m_SO_dealloc_Mat_SOC_strenth
           call m_SO_dealloc_Dsoc
        endif
        if ( SpinOrbit_Mode == ByProjector ) then
           call m_SO_dealloc_Dsoc
        endif
     endif
! ====================== 2013/10/31

! ====== KT_add ======== 13.0U2
     if ( sw_modified_TFW_functional /= OFF ) then
        call m_TFW_dealloc_ChgDensityBasisFn
     end if
! ====================== 13.0U2

! ====== KT_add =========== 13.0AS
     if (num_projectors>0)  call m_OP_dealloc
     if (sw_hubbard == ON) call m_ES_dealloc_Dhub
! ========================= 13.0AS

! ==== KT_add ==== 2014/08/01
     call m_OP_Qnum_dealloc_array
! ================ 2014/08/01

     call m_ES_wf_extrpl_dealloc()
     call m_Ldos_dealloc()
     call m_ES_wf_extrpl_dealloc()
#ifdef FFTW3
!     call m_FFT_finalize()
#endif
     call m_CtrlP_set_init_status(.true.)
   end subroutine Array_Deallocate

      SUBROUTINE PDLAEDZ( N, N1, ID, Q, IQ, JQ, LDQ, DESCQ, Z, WORK )
*
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
      INTEGER            ID, IQ, JQ, LDQ, N, N1
*     ..
*     .. Array Arguments ..
      INTEGER            DESCQ( * )
      DOUBLE PRECISION   Q( LDQ, * ), WORK( * ), Z( * )
*     ..
*
*  Purpose
*  =======
*
*  PDLAEDZ Form the z-vector which consists of the last row of Q_1
*  and the first row of Q_2.
*  =====================================================================
*
*     .. Parameters ..
*
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
*     ..
*     .. Local Scalars ..
*
      INTEGER            COL, I, IBUF, ICTXT, IIQ, IIZ1, IIZ2, IQCOL,
     $                   IQROW, IZ, IZ1, IZ1COL, IZ1ROW, IZ2, IZ2COL,
     $                   IZ2ROW, J, JJQ, JJZ1, JJZ2, MYCOL, MYROW, N2,
     $                   NB, NBLOC, NPCOL, NPROW, NQ1, NQ2, ZSIZ
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN, MOD
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, DCOPY, DGEBR2D, DGEBS2D,
     $                   DGERV2D, DGESD2D, INFOG2L
*     ..
*     .. External Functions ..
      INTEGER            NUMROC
      EXTERNAL           NUMROC
*     ..

      REAL(8), POINTER :: TEMP(:)
      include 'mpif.h'

*     .. Executable Statements ..
*
*       This is just to keep ftnchek and toolpack/1 happy
      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN
*
      ICTXT = DESCQ( CTXT_ )
      NB = DESCQ( NB_ )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      CALL INFOG2L( ID, ID, DESCQ, NPROW, NPCOL, MYROW, MYCOL, IIQ, JJQ,
     $              IQROW, IQCOL )
      N2 = N - N1

      allocate( TEMP(1:N) )
      TEMP(1:N) = 0D0
*
*     Form z1 which consist of the last row of Q1
*
      CALL INFOG2L( IQ-1+( ID+N1-1 ), JQ-1+ID, DESCQ, NPROW, NPCOL,
     $              MYROW, MYCOL, IIZ1, JJZ1, IZ1ROW, IZ1COL )
      NQ1 = NUMROC( N1, NB, MYCOL, IZ1COL, NPCOL )
      IF( ( MYROW.EQ.IZ1ROW ) .AND. ( NQ1.NE.0 ) ) THEN
         CALL DCOPY( NQ1, Q( IIZ1, JJZ1 ), LDQ, WORK, 1 )
         I = MOD( MYCOL + NPCOL - MOD( IZ1COL, NPCOL ), NPCOL )
         NBLOC = ( NQ1-1 ) / NB + 1
!$OMP PARALLEL DO PRIVATE(J,ZSIZ,IZ1,IZ)
         DO J = 1, NBLOC
            IZ1 = (J-1)*NB
            IZ = I*NB + 1 + (J-1)*NB*NPCOL
            ZSIZ = MIN( NB, NQ1-IZ1 )
            IF ( ZSIZ > 0 ) THEN
               CALL DCOPY( ZSIZ, WORK(1+IZ1), 1, TEMP(IZ), 1)
            END IF
         END DO
!$OMP END PARALLEL DO
      END IF
*
*     Form z2 which consist of the first row of Q2
*
      CALL INFOG2L( IQ-1+( ID+N1 ), JQ-1+( ID+N1 ), DESCQ, NPROW, NPCOL,
     $              MYROW, MYCOL, IIZ2, JJZ2, IZ2ROW, IZ2COL )
      NQ2 = NUMROC( N2, NB, MYCOL, IZ2COL, NPCOL )
      IF( ( MYROW.EQ.IZ2ROW ) .AND. ( NQ2.NE.0 ) ) THEN
         CALL DCOPY( NQ2, Q( IIZ2, JJZ2 ), LDQ, WORK, 1 )
         I = MOD( MYCOL + NPCOL - MOD( IZ2COL, NPCOL ), NPCOL )
         NBLOC = ( NQ2-1 ) / NB + 1
!$OMP PARALLEL DO PRIVATE(J,ZSIZ,IZ2,IZ)
         DO J = 1, NBLOC
            IZ2 = (J-1)*NB
            IZ = NB*I + N1 + 1 + (J-1)*NB*NPCOL
            ZSIZ = MIN( NB, NQ2-IZ2 )
            IF ( ZSIZ > 0 ) THEN
              CALL DCOPY( ZSIZ, WORK(1+IZ2), 1, TEMP(IZ), 1)
            END IF
         END DO
!$OMP END PARALLEL DO
      END IF
*
*     proc(IQROW,IQCOL) broadcast Z=(Z1,Z2)
*
      call MPI_Allreduce( TEMP( 1 ), Z( 1 ), N, MPI_DOUBLE_PRECISION,
     &                       MPI_SUM, MPI_COMM_EIGEN, J)

      deallocate( TEMP )
*
      RETURN
*
*     End of PDLAEDZ
*
      END

module m_Fx_omega_PBE
 use m_Const_Parameters,  only : DP,PAI,PAIsqrt
 implicit none

 real(kind=DP), parameter :: &
                 ca =  1.0161144d0 &
               , cb = -0.37170836d0 &
               , cc = -0.077215461d0 &
               , cd =  0.57786348d0 &
               , ce = -0.051955731d0 &
               , ck = -4.d0/27.d0

 real(kind=DP), parameter :: &
                 a1 = -0.000205484d0 &
               , a2 = -0.109465240d0 &
               , a3 = -0.064078780d0 &
               , a4 = -0.008181735d0 &
               , a5 = -0.000110666d0

 real(kind=DP), parameter :: &
                 b1 =  0.006601306d0 &
               , b2 =  0.259931140d0 &
               , b3 =  0.520352224d0 &
               , b4 =  0.118551043d0 &
               , b5 =  0.046003777d0

 real(kind=DP), parameter :: pi = PAI
 real(kind=DP), parameter :: rpi = PAIsqrt

contains

 function Fx_omega(fk,s,omega)
  implicit none
  real(kind=DP) :: Fx_omega
  real(kind=DP), intent(in) :: fk,s,omega

  real(kind=DP) :: s2, alp1, alp2, bet

  s2 = s*s
  alp1 = s2 * h(s)
  alp2 = alp1 + cd
  bet = omega/fk

  Fx_omega = a1 * yjw1(alp1+b1,bet) &
           + a2 * yjw1(alp1+b2,bet) &
           + a3 * yjw2(alp1+b3,bet) &
           + a4 * yjw2(alp1+b4,bet) &
           + a5 * yjw3(alp1+b5,bet) &
           + cb * yjw1(alp2,bet) &
           + cc * (1.d0+s2*f(s)) * yjw3(alp2,bet) &
           +      (ce+s2eg(s)) * yjw5(alp2,bet)
  Fx_omega = -8.d0/9.d0 * Fx_omega
 end function Fx_omega
 
 function dFxds_omega(fk,s,omega)
  implicit none
  real(kind=DP) :: dFxds_omega
  real(kind=DP), intent(in) :: fk,s,omega

  real(kind=DP) :: s2, alp1, alp2, dalp, bet
  real(kind=DP) :: ff, gg
  real(kind=DP) :: dff, dgg

  s2 = s*s
  alp1 = s2 * h(s)
  alp2 = alp1 + cd 
  dalp = 2.d0*s*h(s) + s2*dh(s)
  bet = omega/fk
  ff = cc * (1.d0+s2*f(s))
  gg = ce+s2eg(s)
  dff = cc * ( 2.d0*s*f(s) + s2*df(s) )
  dgg = 2.d0*s*eg(s) + s2*deg(s)

  dFxds_omega = ( a1 * dyjw1a(alp1+b1,bet) &
                + a2 * dyjw1a(alp1+b2,bet) &
                + a3 * dyjw2a(alp1+b3,bet) &
                + a4 * dyjw2a(alp1+b4,bet) &
                + a5 * dyjw3a(alp1+b5,bet) &
                + cb * dyjw1a(alp2,bet) &
                + ff * dyjw3a(alp2,bet) &
                + gg * dyjw5a(alp2,bet) ) * dalp &
                + dff * yjw3(alp2,bet) &
                + dgg * yjw5(alp2,bet) 
  dFxds_omega = -8.d0/9.d0 * dFxds_omega
 end function dFxds_omega

 function kdFxdk_omega(fk,s,omega)
  implicit none
  real(kind=DP) :: kdFxdk_omega
  real(kind=DP), intent(in) :: fk,s,omega

  real(kind=DP) :: s2, alp1, alp2, bet

  s2 = s*s
  alp1 = s2 * h(s)
  alp2 = alp1 + cd
  bet = omega/fk

  kdFxdk_omega = a1 * dyjw1b(alp1+b1,bet) &
              + a2 * dyjw1b(alp1+b2,bet) &
              + a3 * dyjw2b(alp1+b3,bet) &
              + a4 * dyjw2b(alp1+b4,bet) &
              + a5 * dyjw3b(alp1+b5,bet) &
              + cb * dyjw1b(alp2,bet) &
              + cc * (1.d0+s2*f(s)) * dyjw3b(alp2,bet) &
              +      (ce+s2eg(s)) * dyjw5b(alp2,bet)
  kdFxdk_omega = 8.d0/9.d0 * bet * kdFxdk_omega
 end function kdFxdk_omega

 function k2dFxdk_omega(fk,s,omega)
  implicit none
  real(kind=DP) :: k2dFxdk_omega
  real(kind=DP), intent(in) :: fk,s,omega

  real(kind=DP) :: s2, alp1, alp2, bet

  s2 = s*s
  alp1 = s2 * h(s)
  alp2 = alp1 + cd
  bet = omega/fk

  k2dFxdk_omega = a1 * dyjw1b(alp1+b1,bet) &
              + a2 * dyjw1b(alp1+b2,bet) &
              + a3 * dyjw2b(alp1+b3,bet) &
              + a4 * dyjw2b(alp1+b4,bet) &
              + a5 * dyjw3b(alp1+b5,bet) &
              + cb * dyjw1b(alp2,bet) &
              + cc * (1.d0+s2*f(s)) * dyjw3b(alp2,bet) &
              +      (ce+s2eg(s)) * dyjw5b(alp2,bet)
  k2dFxdk_omega = 8.d0/9.d0 * omega * k2dFxdk_omega
 end function k2dFxdk_omega

 function f(s)
  implicit none
  real(kind=DP) :: f
  real(kind=DP), intent(in) :: s
 
  f = ( h(s) * (16.d0*ca**2 + 36.d0*(cb-ca*cd)) + 9.d0*ck ) / (36.d0*cc)
 end function f

 function df(s)
  implicit none
  real(kind=DP) :: df
  real(kind=DP), intent(in) :: s
 
  df = ( dh(s) * (16.d0*ca**2 + 36.d0*(cb-ca*cd)) ) / (36.d0*cc)
 end function df

 function eg(s)
  implicit none
  real(kind=DP) :: eg
  real(kind=DP), intent(in) :: s

  real(kind=DP) :: a,b,s2,t,d

  s2 = s * s

  t = cd + h(s) * s2
  d = 16.d0 * t**3.5d0

  a = sqrt(pi) * ( 15.d0*ce + t * ( 6.d0*cc*(1.d0+f(s)*s2) &
                  + 4.d0*cb*t + 8.d0*ca*t*t ) ) / d  &
      - 3.d0*pi*sqrt(ca)/4.d0 &
               * exp(9.d0*h(s)*s2/(4.d0*ca)) * erfc(1.5d0*s*sqrt(h(s)/ca))

  b = 15.d0*sqrt(pi)*s2 / d

  eg = - (3.d0*pi/4.d0+a) / b
 end function eg

 function s2eg(s)
  implicit none
  real(kind=DP) :: s2eg
  real(kind=DP), intent(in) :: s

  real(kind=DP) :: a,b,s2,t,d

  s2 = s * s

  t = cd + h(s) * s2
  d = 16.d0 * t**3.5d0

  a = sqrt(pi) * ( 15.d0*ce + t * ( 6.d0*cc*(1.d0+f(s)*s2) &
                  + 4.d0*cb*t + 8.d0*ca*t*t ) ) / d  &
      - 3.d0*pi*sqrt(ca)/4.d0 &
               * exp(9.d0*h(s)*s2/(4.d0*ca)) * erfc(1.5d0*s*sqrt(h(s)/ca))

  b = 15.d0*sqrt(pi) / d

  s2eg = - (3.d0*pi/4.d0+a) / b
 end function s2eg


 function deg(s)
  implicit none
  real(kind=DP) :: deg
  real(kind=DP), intent(in) :: s

  real(kind=DP) :: a,b,b2,s2,t,u,d
  real(kind=DP) :: da,db,dt
  real(kind=DP) :: rh

  s2 = s * s
  t = cd + h(s) * s2
  u = 1.d0 + f(s) * s2
  d = 16.d0 * t**3.5d0

  a = sqrt(pi) * ( 15.d0*ce + t * ( 6.d0*cc*(1.d0+f(s)*s2) &
                  + 4.d0*cb*t + 8.d0*ca*t*t ) ) / d  &
      - 3.d0*pi*sqrt(ca)/4.d0 &
               * exp(9.d0*h(s)*s2/(4.d0*ca)) * erfc(1.5d0*s*sqrt(h(s)/ca))
  b = 15.d0*sqrt(pi)*s2 / d
  b2 = b * b

  dt = dh(s) * s2 + 2.d0 * s * h(s)
  rh = sqrt(h(s))
  da = sqrt(pi) * ( 6.d0*cc*( df(s)*s2 + 2.d0*s*f(s) ) * t &
     &            + ( 6.d0*cc*u + 8.d0*cb*t+24.d0*ca*t*t ) * dt ) &
     &            / d &
     & - 7.d0*sqrt(pi)/32.d0 * ( 15.d0*ce + 6.d0*cc*u*t + 4.d0*cb*t*t + 8.d0*ca*t**3 ) &
     &                      * dt / t**4.5d0 &
     & - 27.d0*pi/(16.d0*sqrt(ca)) * dt * exp(9.d0*h(s)*s2/(4.d0*ca)) * erfc(1.5d0*s*sqrt(h(s)/ca)) &           
     & + 9.d0*sqrt(pi)/4.d0*( rh + 0.5d0*s*dh(s)/rh )
  db = 15.d0*sqrt(pi) * ( 2.d0*s - 3.5d0*s2*dt/t ) / d

  deg = -da/b + db*(3.d0*pi/4.d0+a)/b2 
 end function deg

 function h(s)
  implicit none
  real(kind=DP) :: h
  real(kind=DP), intent(in) :: s

  real(kind=DP) :: s2, s4
  real(kind=DP), parameter :: a1 = 0.00979681d0 &
                           , a2 = 0.0410834d0 &
                           , a3 = 0.187440d0 &
                           , a4 = 0.00120824d0 &
                           , a5 = 0.0347188d0

  s2 = s * s
  s4 = s2 * s2

  h = ( a1 * s2 + a2 * s4 ) / ( 1.d0 + s4 * (a3 + a4 * s + a5 * s2 ) )
 end function h

 function dh(s)
  implicit none
  real(kind=DP) :: dh
  real(kind=DP), intent(in) :: s

  real(kind=DP) :: s2, s4, s5, s6
  real(kind=DP), parameter :: a1 = 0.00979681d0 &
                           , a2 = 0.0410834d0 &
                           , a3 = 0.187440d0 &
                           , a4 = 0.00120824d0 &
                           , a5 = 0.0347188d0

  s2 = s * s
  s4 = s2 * s2
  s5 = s * s4
  s6 = s2 * s4

  dh = -s*( a1*( 2.d0*a3*s4 + 3.d0*a4*s5 + 4.d0*a5*s6 - 2.d0) + a2*s2*(a4*s5+2.d0*a5*s6-4.d0)) &
     &    / ( 1.d0 + s4 * (a3 + a4 * s + a5 * s2 ) )**2
 end function dh

 function yjw1(a,b)
  implicit none
  real(kind=DP) :: yjw1
  real(kind=DP), intent(in) :: a, b
  
  yjw1 = (1.d0-b/sqrt(a+b*b))/(2.d0*a)
 end function yjw1

 function dyjw1a(a,b)
  implicit none
  real(kind=DP) :: dyjw1a
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: apb2
  real(kind=DP) :: rapb2

  apb2 = a + b*b
  rapb2 = sqrt(apb2)

  dyjw1a = (b*(2.d0/rapb2+a/(apb2*rapb2))-2.d0)/(4.d0*a*a)
 end function dyjw1a

 function dyjw1b(a,b)
  implicit none
  real(kind=DP) :: dyjw1b
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: apb2

  apb2 = a + b*b

  dyjw1b = -0.5d0/apb2**1.5d0
 end function dyjw1b

 function yjw2(a,b)
  implicit none
  real(kind=DP) :: yjw2
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: ra, b2

  ra = sqrt(a)
  b2 = b * b

  yjw2 = (-ra*b+(a+b2)*acot(b/ra))/(2.d0*a**(3.d0/2.d0)*(a+b2)*rpi)
 end function yjw2

 function dyjw2a(a,b)
  implicit none
  real(kind=DP) :: dyjw2a
  real(kind=DP), intent(in) :: a, b
 
  real(kind=DP) :: ra, b2

  ra = sqrt(a)
  b2 = b * b

  dyjw2a = (ra*b*(5.d0*a+3.d0*b2)-3.d0*(a+b2)**2*acot(b/ra))/(4.d0*a**(5.d0/2.d0)*(a+b2)**2*rpi)
 end function dyjw2a

 function dyjw2b(a,b)
  implicit none
  real(kind=DP) :: dyjw2b
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: ab2

  ab2 = a + b*b

  dyjw2b = -1.d0/(sqrt(pi)*ab2*ab2)
 end function dyjw2b

 function yjw3(a,b)
  implicit none
  real(kind=DP) :: yjw3
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: b2, ab2, rab2

  b2 = b * b
  ab2 = a+b2
  rab2 = sqrt(ab2)

  yjw3 = (2.d0*b2*(-b+rab2)+a*(-3.d0*b+2.d0*rab2))/(4.d0*a*a*ab2*rab2)
 end function yjw3

 function dyjw3a(a,b)
  implicit none
  real(kind=DP) :: dyjw3a
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: a2, b2, b4, ab2, rab2

  a2 = a * a
  b2 = b * b
  b4 = b2 * b2
  ab2 = a+b2
  rab2 = sqrt(ab2)

  dyjw3a = (a2*(15.d0*b-8.d0*rab2) + 8.d0*b4*(b-rab2) - 4.d0*a*b2*(4.d0*rab2-5.d0*b))/(8.d0*a2*a*ab2*ab2*rab2)
 end function dyjw3a

 function dyjw3b(a,b)
  implicit none
  real(kind=DP) :: dyjw3b
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: ab2

  ab2 = a + b*b

  dyjw3b = -0.75d0/ab2**2.5d0
 end function dyjw3b

 function yjw5(a,b)
  implicit none
  real(kind=DP) :: yjw5
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: a2, b2, b4, ab2, rab2

  a2 = a * a
  b2 = b * b
  b4 = b2 * b2
  ab2 = a+b2
  rab2 = sqrt(ab2)

  yjw5 = (8.d0*b4*(-b+rab2)+4.d0*a*b2*(-5.d0*b+4.d0*rab2)+a2*(-15.d0*b+8.d0*rab2))/(8.d0*a2*a*ab2*ab2*rab2)
 end function yjw5

 function dyjw5a(a,b)
  implicit none
  real(kind=DP) :: dyjw5a
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: a2, a3, a4, b2, b4, b6, ab2, rab2

  a2 = a * a
  a3 = a * a2
  a4 = a2 * a2
  b2 = b * b
  b4 = b2 * b2
  b6 = b2 * b4
  ab2 = a+b2
  rab2 = sqrt(ab2)

  dyjw5a = -3.d0*( 16.d0*b6*(rab2-b) + 8.d0*a*b4*(6.d0*rab2-7.d0*b) + a3*(16.d0*rab2-35.d0*b) &
                & + 2.d0*a2*b2*(24.d0*rab2 - 35.d0*b) ) / (16.d0*a4*ab2*ab2*ab2*rab2)
 end function dyjw5a

 function dyjw5b(a,b)
  implicit none
  real(kind=DP) :: dyjw5b
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: ab2

  ab2 = a + b*b

  dyjw5b = -15.d0/(8.d0*ab2**3.5d0)
 end function dyjw5b

 function acot(a)
  implicit none
  real(kind=DP) :: acot
  real(kind=DP), intent(in) :: a
 
  acot = atan(1.d0/a)
 end function acot
 
end module m_Fx_omega_PBE

subroutine ex_omegapbe(amix,omega,nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,grad_rho,f2or1,exc,dFx_drho,dFx_dgradrho,nfft_y)
  use m_Const_Parameters,  only : DP,PAI,PAI4
  use m_Fx_omega_PBE,      only : Fx_omega, dFxds_omega, k2dFxdk_omega
  implicit none

  real(kind=DP),intent(in)  :: amix,omega
  integer,intent(in)        :: nspin,ispin,nfft_y
  integer,intent(in)        :: ista_fftph, iend_fftph
  real(kind=DP),intent(in)  :: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(in)  :: grad_rho(1:nfft_y,nspin)
  real(kind=DP),intent(in)  :: f2or1(1:nfft_y)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dFx_drho(1:nfft_y,nspin)
  real(kind=DP),intent(inout) :: dFx_dgradrho(1:nfft_y,nspin)

  real(kind=DP), parameter :: ax = -0.7385587663820224d0 !! ax = -(3/4)*(3/PI)^(1/3)
  real(kind=DP), parameter :: thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
  real(kind=DP), parameter :: th8pi = -0.1193662073189215d0

  real(kind=DP) :: facw,d,dd,fk,s,fac,f,ex,fs,ff,exd,exdd,exc0,exc1
  integer       :: is,i

!---- Spin dependency

  facw = ispin
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = 1, nfft_y
        d  = facw * chgrhr_l(i, is)
        if(abs(d) < 1.d-30) d = 1.d-30
        fk = (3*PAI*PAI*d)**thrd
        dd = facw * grad_rho(i, is)
        if(abs(d) > 1.d-05) then
           s = dd/(d*fk*2)
        else
           s = 0.d0
        end if
!-------------------------------------
        f = Fx_omega(fk,s,omega)
        ff = k2dFxdk_omega(fk,s,omega)
        if(abs(s)>1.d-10) then
           fs = dFxds_omega(fk,s,omega)
        else
           fs = 0.d0
           !!write(2000,'("s=",f20.5," f=",f20.5," ff=",f20.5)') s, f, ff
        end if
        fac = ax*d**thrd
        ex  = fac*f*d
        exd = thrd4*fac*(f-s*fs)-ff/PAI4
        exdd = th8pi*fs
!------------------------------------------     
        exc0 = ex / facw
        dFx_drho(i, is) = dFx_drho(i, is) + amix * exd 
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = dFx_dgradrho(i, is) + amix * exdd / grad_rho(i, is)
        endif
        exc1 = exc1 + exc0*f2or1(i)
        !!write(1000,'("i,f,fs,ff,d,dd,fk,s=",i8,1x,7(1x,f20.5))') i,f,fs,ff,d,dd,fk,s
     end do
     exc = exc + amix * exc1
  end do
  !!stop 'Debug: OmegaPBE'
end subroutine ex_omegapbe

! ----------------------------------
! HJS
!
! J. Chem. Phys. 128 (2008) 194105.
! ----------------------------------
subroutine ex_omegapbe_library_HJS( amix, omega, &
     &                              nspin, ispin, ista_r, iend_r, chgrhr_l, grad_rho, &
     &                              wos, exc, dFx_drho, dFx_dgradrho, pot_type )
  use m_Const_Parameters,  only : DP,PAI
  implicit none

  real(kind=DP),intent(in)  :: amix, omega
  integer,intent(in)        :: nspin,ispin,ista_r,iend_r, pot_type
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_r:iend_r,nspin)

  real(kind=DP), parameter :: ax = -0.7385587663820224d0 !! ax = -(3/4)*(3/PI)^(1/3)
  real(kind=DP), parameter :: thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
  real(kind=DP), parameter :: thpith = 3.0936677262801d0

  integer       :: is, i

  real(kind=DP) :: facw, d, dd, fac, ex, &
       &           exd, exdd, exc0, excd, excdd, exc1
  real(kind=DP) :: fx, dfx, ddfx

!---- Spin dependency

  facw = ispin
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = ista_r, iend_r
        d  = facw * chgrhr_l(i, is)
!        if(abs(d) < 1.d-30) d = 1.d-30
!        if(abs(d) < 1.d-8) d = 1.d-8
        if(abs(d) < 1.d-12) d = 1.d-12

        dd = facw * grad_rho(i, is)
        fac = ax*d**thrd

        select case (pot_type)
        case (1)         ! PBE
           call omegapbe_analytic( 1, d, dd, omega, fx, dfx, ddfx )
        case (6)         ! PBE-sol
           call omegapbe_analytic( 2, d, dd, omega, fx, dfx, ddfx )
        end select

        ex  = fac *fx *d
        exd = thrd4 *fac* fx +fac *d *dfx
        exdd = fac * d *ddfx

        exc0 = ex / facw
        dFx_drho(i, is) = dFx_drho(i, is) + amix * exd 
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = dFx_dgradrho(i, is) + amix * exdd / grad_rho(i, is)
        endif
        exc1 = exc1 + exc0*wos(i)
     end do
     exc = exc + amix * exc1
  end do

end subroutine ex_omegapbe_library_HJS

subroutine omegapbe_analytic( pot_type, rho, gradrho, omega, fx, dfx_drho, dfx_dgradrho )
  use m_Const_Parameters,  only : DP,PAI
  implicit none
  
  integer, intent(in) :: pot_type
  real(kind=DP), intent(in) :: rho, gradrho, omega
  real(kind=DP), intent(out) :: fx, dfx_drho, dfx_dgradrho
!  
#if 1
  real(kind=DP), parameter :: A_HUS =  0.757211D0
  real(kind=DP), parameter :: B_HUS = -0.106304D0
  real(kind=DP), parameter :: C_HUS = -0.118649D0
  real(kind=DP), parameter :: D_HUS =  0.609650D0
#else
  real(kind=DP), parameter :: A_HUS =  0.451606D0
  real(kind=DP), parameter :: B_HUS = -0.371708D0
  real(kind=DP), parameter :: C_HUS = -0.0772155D0
  real(kind=DP), parameter :: D_HUS =  0.577863D0
#endif
!
  real(kind=DP) :: s, kf, ds_drho, ds_dgradrho
  real(kind=DP) :: zeta, dzeta_ds, dzeta_drho, dzeta_dgradrho
  real(kind=DP) ::  eta,  deta_ds,  deta_drho,  deta_dgradrho
  real(kind=DP) :: lambda, dlambda_ds, dlambda_drho, dlambda_dgradrho
  real(kind=DP) :: hs, dhs_ds
  real(kind=DP) :: fs, dfs_ds, dfs_drho, dfs_dgradrho
  real(kind=DP) :: egs, degs_ds, degs_drho, degs_dgradrho

  real(kind=DP) :: nu, nu2, dnu_drho
  real(kind=DP) :: lam2, lam3, lam4
  real(kind=DP) :: chi, chi2, chi3, chi4, chi5
  real(kind=DP) :: dchi_drho, dchi_dgradrho

  real(kind=DP) :: c0a, c0b, c0c, c1, c2, c3, c4a, c4b, c4c, c5a, c5b, c5c
  real(kind=DP) :: dc1, dc2, dc3, dc4a, dc4b, dc4c, dc5a, dc5b, dc5c
  real(kind=DP) :: ddc1, ddc2, ddc3, ddc4a, ddc4b, ddc4c, ddc5a, ddc5b, ddc5c

  real(kind=DP) :: f1, f2, f3, f4, f5, f6
  real(kind=DP) :: df1, df2, df3, df4, df5, df6
  real(kind=DP) :: ddf1, ddf2, ddf3, ddf4, ddf5, ddf6

  integer :: i

#if 0
  if ( abs(rho) > 1.d-05) then
     kf = ( 3.0d0 *PAI *PAI *rho )**(1.0d0/3.0d0)
     s = gradrho /2.0d0 /kf /rho
     ds_drho = -4.0d0 /3.0d0 *s /rho
     ds_dgradrho = 0.5d0 /kf /rho
  else
     s = 0.d0
     ds_drho = 0.0d0
     ds_dgradrho = 0.0d0
  endif
#else
  kf = ( 3.0d0 *PAI *PAI *rho )**(1.0d0/3.0d0)
  s = gradrho /2.0d0 /kf /rho
  ds_drho = -4.0d0 /3.0d0 *s /rho
  ds_dgradrho = 0.5d0 /kf /rho
#endif
  select case (pot_type)
  case (1)
     call diff_h_case_pbe( s, hs, dhs_ds )
  case (2)
     call diff_h_case_pbesol( s, hs, dhs_ds )
  end select

  call diff_zeta_eta_lamb( s, hs, dhs_ds, zeta, dzeta_ds, eta, deta_ds, &
       &                   lambda, dlambda_ds )
  call diff_fs( s, hs, dhs_ds, fs, dfs_ds )
  call diff_egs( zeta, dzeta_ds, eta, deta_ds, lambda, dlambda_ds, fs, dfs_ds, &
       &         egs, degs_ds )

  dzeta_drho = dzeta_ds *ds_drho
  deta_drho  = deta_ds  *ds_drho
  dlambda_drho = dlambda_ds *ds_drho
  dfs_drho = dfs_ds *ds_drho
  degs_drho = degs_ds *ds_drho

  dzeta_dgradrho = dzeta_ds *ds_dgradrho
  deta_dgradrho = deta_ds *ds_dgradrho
  dlambda_dgradrho = dlambda_ds *ds_dgradrho
  dfs_dgradrho = dfs_ds *ds_dgradrho
  degs_dgradrho = degs_ds *ds_dgradrho
  
  nu = omega /kf;
  nu2 = nu *nu
  c0a = zeta +nu2;     c0b = eta  +nu2;      c0c = lambda +nu2

  chi = nu /sqrt(c0c)
  chi2 = chi *chi;   chi3 = chi2 *chi;    chi4 = chi3 *chi;   chi5 = chi4 *chi

  lam2 = lambda **2;   lam3 = lambda *lam2;   lam4 = lambda *lam3

  dnu_drho = -1.0d0 /3.0d0 *nu /rho

  dchi_drho = dnu_drho /sqrt(c0c) &
       &      -nu /2.0d0 /c0c**1.5d0 *( dlambda_drho +2.0d0 *nu *dnu_drho )
  dchi_dgradrho = -nu /2.0d0 /c0c**1.5d0 *dlambda_dgradrho

  c1 = 1.0d0 -chi
  c2 = 1.0d0 -1.5d0 *chi +0.5d0 *chi3
  c3 = 1.0d0 -15.0d0/8.0d0 *chi +5.0d0/4.0d0 *chi3 -3.0d0/8.0d0 *chi5
  c4a = sqrt(c0a);     c5a = log(nu +c4a)
  c4b = sqrt(c0b);     c5b = log(nu +c4b)
  c4c = sqrt(c0c);     c5c = log(nu +c4c)

! -----------------------
  dc1 = -dchi_drho
  dc2 = ( -1.5d0 +1.5d0 *chi2 ) *dchi_drho
  dc3 = ( -15.0d0 /8.0d0 +15.0d0 /4.0d0 *chi2 -15.0d0 /8.0d0 *chi4 ) *dchi_drho
  dc4a = 0.5d0 /c4a *( dzeta_drho    +2.0d0 *nu *dnu_drho )
  dc4b = 0.5d0 /c4b *( deta_drho     +2.0d0 *nu *dnu_drho )
  dc4c = 0.5d0 /c4c *( dlambda_drho  +2.0d0 *nu *dnu_drho )
  dc5a = ( dnu_drho +dc4a ) /( nu +c4a )
  dc5b = ( dnu_drho +dc4b ) /( nu +c4b )
  dc5c = ( dnu_drho +dc4c ) /( nu +c4c )

! ----------------------
  ddc1 = -dchi_dgradrho
  ddc2 = ( -1.5d0 +1.5d0 *chi2 ) *dchi_dgradrho
  ddc3 = ( -15.0d0 /8.0d0 +15.0d0 /4.0d0 *chi2 -15.0d0 /8.0d0 *chi4 ) *dchi_dgradrho
  ddc4a = 0.5d0 /c4a *( dzeta_dgradrho )
  ddc4b = 0.5d0 /c4b *( deta_dgradrho  ) 
  ddc4c = 0.5d0 /c4c *( dlambda_dgradrho )
  ddc5a = ( ddc4a ) /( nu +c4a )
  ddc5b = ( ddc4b ) /( nu +c4b )
  ddc5c = ( ddc4c ) /( nu +c4c )

! -------------------------
  f1 = -4.0d0 /9.0d0 *B_HUS /lambda *c1
  f2 = -4.0d0 /9.0d0 *C_HUS *fs /lam2 *c2
  f3 = -8.0d0 /9.0d0 *egs /lam3 *c3
  f4 = 2.0d0 *nu *( c4a -c4b )
  f5 = 2.0d0 *zeta *( c5a -c5c )
  f6 = -2.0d0 *eta *( c5b -c5c )

  fx = A_HUS +f1 +f2 +f3 +f4 +f5 +f6

! ------------------------------------
  df1 = dc1 /lambda - c1 /lam2 *dlambda_drho
  df1 = -4.0d0 /9.0d0 *B_HUS *df1

  df2 = dfs_drho /lam2 *c2 +fs *(-2.0d0) /lam3 *dlambda_drho *c2 +fs /lam2 *dc2
  df2 = -4.0d0 /9.0d0 *C_HUS *df2

  df3 = degs_drho /lam3 *c3 -3.0d0 *egs /lam4 *c3 *dlambda_drho +egs /lam3 *dc3
  df3 = -8.0d0 /9.0d0 *df3

  df4 = dnu_drho *( c4a -c4b ) +nu *( dc4a -dc4b )
  df4 = df4 *2.0d0

  df5 = dzeta_drho *( c5a -c5c ) +zeta *( dc5a -dc5c )
  df5 = df5 *2.0d0

  df6 = deta_drho *( c5b -c5c ) +eta *( dc5b -dc5c )
  df6 = -df6 *2.0d0

  dfx_drho = df1 +df2 +df3 +df4 +df5 +df6

! ------------------------------------
  ddf1 = ddc1 /lambda - c1 /lam2 *dlambda_dgradrho
  ddf1 = -4.0d0 /9.0d0 *B_HUS *ddf1

  ddf2 = dfs_dgradrho /lam2 *c2 +fs *(-2.0d0) /lam3 *dlambda_dgradrho *c2 +fs /lam2 *ddc2
  ddf2 = -4.0d0 /9.0d0 *C_HUS *ddf2

  ddf3 = degs_dgradrho /lam3 *c3 -3.0d0 *egs /lam4 *c3 *dlambda_dgradrho +egs /lam3 *ddc3
  ddf3 = -8.0d0 /9.0d0 *ddf3

  ddf4 = nu *( ddc4a -ddc4b )
  ddf4 = ddf4 *2.0d0

  ddf5 = dzeta_dgradrho *( c5a -c5c ) +zeta *( ddc5a -ddc5c )
  ddf5 = ddf5 *2.0d0

  ddf6 = deta_dgradrho *( c5b -c5c ) +eta *( ddc5b -ddc5c )
  ddf6 = -ddf6 *2.0d0

  dfx_dgradrho = ddf1 +ddf2 +ddf3 +ddf4 +ddf5 +ddf6

contains

  subroutine diff_egs( zeta, dzeta_ds, eta, deta_ds, lambda, dlambda_ds, fs, dfs_ds, &
       &               egs, degs_ds )
    real(kind=DP), intent(in) :: zeta, dzeta_ds
    real(kind=DP), intent(in) :: eta,  deta_ds
    real(kind=DP), intent(in) :: lambda, dlambda_ds
    real(kind=DP), intent(in) :: fs, dfs_ds
    real(kind=DP), intent(out) :: egs, degs_ds
    
    real(kind=DP) :: c1, c2, c3, c4, c5, c6, f1, df1
    
    c1 = lambda **2
    c2 = c1 *lambda
    c3 = lambda **2.5d0
    c4 = lambda **3.5d0
    c5 = sqrt(zeta)
    c6 = sqrt(eta)

    f1 = -0.4d0 *C_HUS *fs *lambda -4.0d0/15.0d0 *B_HUS *c1 -1.2d0 *A_HUS *c2 &
         & -0.8d0 *sqrt(PAI) *c4 -2.4d0 *c4 *(c5 -c6)
    
    df1 = -0.40d0 *C_HUS *( dfs_ds *lambda +fs *dlambda_ds ) &
         &     -8.0d0 /15.0d0 *B_HUS *lambda *dlambda_ds &
         &     -18.0d0 /5.0d0 *A_HUS *c1 *dlambda_ds &
         &     -14.0d0 /5.0d0 *sqrt(PAI) *c3 *dlambda_ds &
         &     -2.4d0 *( (3.5d0 *c3 *dlambda_ds)*( c5 -c6 ) &
         &              +c4*( dzeta_ds /c5 -deta_ds /c6 )/2.0d0 )
    egs = f1
    degs_ds = df1
  end subroutine diff_egs

  subroutine diff_fs( s, hs, dhs_ds, fs, dfs_ds )
    real(kind=DP), intent(in) :: s, hs, dhs_ds
    real(kind=DP), intent(out) :: fs, dfs_ds
!
    real(kind=DP) :: s0, s0_sq, s2, c1, c2, c3
    
    s0 = 2.0d0;   s0_sq = s0 *s0
    s2 =  s *s

    c1 = 1.0d0 +s2 /s0_sq 
    c2 = 1.0d0 /27.0d0 /C_HUS *s2 /c1
    c3 = 2.0d0 /27.0d0 /C_HUS *s /c1**2 

    fs = 1.0d0 -c2 -0.5d0 /C_HUS *s2 *hs
    dfs_ds = -c3 -0.5d0 /C_HUS *( 2.0d0 *s *hs +s2 *dhs_ds )
!
  end subroutine diff_fs

  subroutine diff_zeta_eta_lamb( s, hs, dhs_ds, zeta, dzeta_ds, eta, deta_ds, &
       &                         lambda, dlambda_ds )
    real(kind=DP), intent(in) :: s, hs, dhs_ds
    real(kind=DP), intent(out) :: zeta, dzeta_ds
    real(kind=DP), intent(out) :: eta,  deta_ds
    real(kind=DP), intent(out) :: lambda, dlambda_ds
    
    real(kind=DP) :: s2
    
    s2 = s *s
    zeta = s2 *hs
    eta = A_HUS +zeta
    lambda = D_HUS +zeta
    
    dzeta_ds = 2.0d0 *s *hs +s2 *dhs_ds
    deta_ds =  dzeta_ds
    dlambda_ds =  dzeta_ds
  end subroutine diff_zeta_eta_lamb

  subroutine diff_h_case_pbe( s, fout, dfout )
    real(kind=DP), intent(in) :: s
    real(kind=DP), intent(out) :: fout, dfout
!
    real(kind=DP), parameter :: a2 =  0.0159941D0
    real(kind=DP), parameter :: a3 =  0.0852995D0
    real(kind=DP), parameter :: a4 = -0.1603680D0
    real(kind=DP), parameter :: a5 =  0.1526450D0
    real(kind=DP), parameter :: a6 = -0.0971263D0
    real(kind=DP), parameter :: a7 =  0.0422061D0
    
    real(kind=DP), parameter :: b1 =  5.33319D0
    real(kind=DP), parameter :: b2 =-12.47800D0
    real(kind=DP), parameter :: b3 = 11.09880D0
    real(kind=DP), parameter :: b4 = -5.11013D0
    real(kind=DP), parameter :: b5 =  1.714680D0
    real(kind=DP), parameter :: b6 = -0.610380D0
    real(kind=DP), parameter :: b7 =  0.307555D0
    real(kind=DP), parameter :: b8 = -0.0770547D0
    real(kind=DP), parameter :: b9 =  0.0334840D0
    
    real(kind=DP) :: s2, s3, s4, s5, s6, s7, s8, s9
    real(kind=DP) :: c1, c2, c3, c4

    s2 =  s *s;     s3 = s2 *s;     s4 = s3 *s;    s5 = s4 *s;
    s6 = s5 *s;     s7 = s6 *s;     s8 = s7 *s;    s9 = s8 *s
    
    c1 = a2*s2 +a3*s3 +a4*s4 +a5*s5 +a6*s6 +a7*s7
    c2 = 1.0d0 +b1 *s &
         & +b2*s2 +b3*s3 +b4*s4 +b5*s5 +b6*s6 +b7*s7 +b8*s8 +b9 *s9
    fout = c1 /c2
!
    c3 = 2.d0 *a2 *s +3.0d0 *a3 *s2 +4.0d0 *a4 *s3 +5.0d0 *a5 *s4 +6.0d0 *a6 *s5 &
         & +7.0d0 *a7 *s6
    c4 = b1 +2.d0 *b2 *s +3.0d0 *b3 *s2 +4.0d0 *b4 *s3 +5.0d0 *b5 *s4 +6.0d0 *b6 *s5 &
         & +7.0d0 *b7 *s6 +8.0d0 *b8 *s7 +9.0d0 *b9 *s8
    
    dfout = c3 /c2 -c1 /c2**2 *c4
  end subroutine diff_h_case_pbe

  subroutine diff_h_case_pbesol( s, fout, dfout )
    real(kind=DP), intent(in) :: s
    real(kind=DP), intent(out) :: fout, dfout
!
    real(kind=DP), parameter :: a2 =  0.0047333D0
    real(kind=DP), parameter :: a3 =  0.0403304D0
    real(kind=DP), parameter :: a4 = -0.0574615D0
    real(kind=DP), parameter :: a5 =  0.0435395D0
    real(kind=DP), parameter :: a6 = -0.0216251D0
    real(kind=DP), parameter :: a7 =  0.0063721D0
    
    real(kind=DP), parameter :: b1 =  8.52056D0
    real(kind=DP), parameter :: b2 =-13.9885D0
    real(kind=DP), parameter :: b3 =  9.28583D0
    real(kind=DP), parameter :: b4 = -3.27287D0
    real(kind=DP), parameter :: b5 =  0.843499D0
    real(kind=DP), parameter :: b6 = -0.235543D0
    real(kind=DP), parameter :: b7 =  0.0847074D0
    real(kind=DP), parameter :: b8 = -0.0171561D0
    real(kind=DP), parameter :: b9 =  0.0050552D0
    
    real(kind=DP) :: s2, s3, s4, s5, s6, s7, s8, s9
    real(kind=DP) :: c1, c2, c3, c4

    s2 =  s *s;     s3 = s2 *s;     s4 = s3 *s;    s5 = s4 *s;
    s6 = s5 *s;     s7 = s6 *s;     s8 = s7 *s;    s9 = s8 *s
    
    c1 = a2*s2 +a3*s3 +a4*s4 +a5*s5 +a6*s6 +a7*s7
    c2 = 1.0d0 +b1 *s &
         & +b2*s2 +b3*s3 +b4*s4 +b5*s5 +b6*s6 +b7*s7 +b8*s8 +b9 *s9
    fout = c1 /c2
!
    c3 = 2.d0 *a2 *s +3.0d0 *a3 *s2 +4.0d0 *a4 *s3 +5.0d0 *a5 *s4 +6.0d0 *a6 *s5 &
         & +7.0d0 *a7 *s6
    c4 = b1 +2.d0 *b2 *s +3.0d0 *b3 *s2 +4.0d0 *b4 *s3 +5.0d0 *b5 *s4 +6.0d0 *b6 *s5 &
         & +7.0d0 *b7 *s6 +8.0d0 *b8 *s7 +9.0d0 *b9 *s8
    
    dfout = c3 /c2 -c1 /c2**2 *c4
  end subroutine diff_h_case_pbesol
  
end subroutine omegapbe_analytic

! ---------------------------------------
! Gau-PBE
!
! J. Chem. Phys. 135 (2011) 071103.
! ---------------------------------------
subroutine ex_gaupbe( nspin, ispin, ista_r, iend_r, chgrhr_l, grad_rho, &
     &                wos, exc, dFx_drho, dFx_dgradrho )
  use m_Const_Parameters,  only : DP,PAI
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_r:iend_r,nspin)

  real(kind=DP), parameter :: ax = -0.7385587663820224d0 !! ax = -(3/4)*(3/PI)^(1/3)
  real(kind=DP), parameter :: thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
  real(kind=DP), parameter :: thpith = 3.0936677262801d0

! ----- parameters of enhanced factor --
  real(kind=DP), parameter :: mu_pbe    = 0.2195149727645171d0
  real(kind=DP), parameter :: kappa_pbe    = 0.804d0

  real(kind=DP), parameter :: alpha_gaupbe = 0.15d0
  real(kind=DP), parameter :: beta_gaupbe = 0.24d0

  integer       :: is, i

  real(kind=DP) :: facw, d, dd, fk, s, fac, s2, mu_s2, f, ex, df_ds, &
       &           exd, exdd, exc0, excd, excdd, exc1
  real(kind=DP) :: x, dx_ds, ctmp1, df_dx
  real(kind=DP) :: df_drho, df_ddrho
  real(kind=DP) :: vald, dvald_drho, dvald_ddrho
  real(kind=DP) :: valg, dvalg_drho, dvalg_ddrho

!---- Spin dependency

  facw = ispin
#if 0
  facw = 1.0d0
  if ( nspin == 1 ) facw = 0.5d0
#endif

  exc  = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = ista_r, iend_r
        d  = facw * chgrhr_l(i, is)
        dd = facw * grad_rho(i, is)
        fk = (3.d0*PAI*PAI*d)**thrd
!!$        sk = dsqrt(4*fk/PAI)
        if(d > 1.d-05) then
           s = dd/(d*fk*2.d0)
        else
           s = 0.d0
        endif
!-------------------------------------
        fac = ax*d**thrd
        s2  = s*s

        x = mu_pbe *s2;   dx_ds = 2.0d0 *mu_pbe *s
        ctmp1 = kappa_pbe + x
        
        f = 1.0d0 +kappa_pbe *x /ctmp1
        df_dx = kappa_pbe**2 /ctmp1**2
        df_ds = dx_ds *df_dx
!
        if(d > 1.d-05) then
           df_drho = -4.0d0 /3.0d0 *s /d *df_ds
           df_ddrho = 1.0d0 /(d*fk*2.d0) *df_ds
        else
           df_drho = 0.0d0
           df_ddrho = 0.0d0
        endif
! 
        call diff_d( d, dd, s, f, df_drho, df_ddrho, vald, dvald_drho, dvald_ddrho )
        call diff_g( vald, dvald_drho, dvald_ddrho, valg, dvalg_drho, dvalg_ddrho )
        
        ex  = fac *f *d *valg
        exd = thrd4 *fac* ( f -s *df_ds ) *valg &
             &   +fac *d *f *dvalg_drho
        exdd = ax * df_ds *0.5d0 /thpith *valg &
             &   +fac *d *f *dvalg_ddrho
!------------------------------------------

#if 1
        exc0 = ex / facw
#endif
        excd = exd
        dFx_drho(i, is) = excd

        excdd = exdd
! gradient of charge density 95/12/3 H.S.
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = excdd / grad_rho(i, is)
        else
           dFx_dgradrho(i, is) = 0.d0
        endif
! gradient of charge density 95/12/3 H.S.
        exc1 = exc1 + exc0*wos(i)
     end do
     exc = exc + exc1
  end do

#if 0
  if ( nspin == 2 ) then
     exc = exc /2.0d0
  else
     dFx_drho = dFx_drho *2.0d0
     dFx_dgradrho = dFx_dgradrho *2.0d0
  endif
#endif

contains

  subroutine diff_g( d, dd_dn, dd_ddn, fout, dfout, ddfout )
    real(kind=DP), intent(in) :: d, dd_dn, dd_ddn
    real(kind=DP), intent(out) :: fout, dfout, ddfout
    !
    real(kind=DP) :: c1, c2, c3, c4, c5, c6, c7, c8
    real(kind=DP) :: e, de_dn, de_ddn
    !
    call diff_e( d, dd_dn, dd_ddn, e, de_dn, de_ddn )
    
    c1 = 4.0d0 /3.0d0 *beta_gaupbe *sqrt(PAI) /sqrt(alpha_gaupbe)
    
    c2 = sqrt(PAI) *erf( 0.5d0 /d )
    c3 = 2.0d0 *d -16.0d0 *d**3
    c4 = c2 +c3 *e -4.0d0 *d
    
    fout = 1.0d0 -c1 *d *c4
    !
    c5 = -exp( -(0.5d0 /d)**2 ) /d**2
    c6 = 2.0d0 -48.0d0 *d**2
    
    c7 = ( c5 +c6 *e -4.0d0 ) *dd_dn  +c3 *de_dn
    c8 = ( c5 +c6 *e -4.0d0 ) *dd_ddn +c3 *de_ddn
    
    dfout = -c1 *( c4 *dd_dn + d *c7 )
    ddfout = -c1 *( c4 *dd_ddn +d *c8 )
    
  end subroutine diff_g
  
  subroutine diff_e( d, dd_dn, dd_ddn, fout, dfout, ddfout )
    implicit none
    real(kind=DP), intent(in) :: d, dd_dn, dd_ddn
    real(kind=DP), intent(out) :: fout, dfout, ddfout
    !
    real(kind=DP) :: c1, c2, c3
    
    c1 = -0.25d0 /d**2
    c2 = exp( c1 )
    
    fout = c2 -1.0d0
    
    c3 = 0.50d0 /d**3
    dfout = c3 *c2 *dd_dn
    
    ddfout = c3 *c2 *dd_ddn
  end subroutine diff_e
  
  subroutine diff_d( n, dn, s, fs, dfs_dn, dfs_ddn, fout, dfout, ddfout )
    implicit none
    real(kind=DP), intent(in) :: n, dn, s, fs, dfs_dn, dfs_ddn
    real(kind=DP), intent(out) :: fout, dfout, ddfout
    !
    real(kind=DP) :: c1, c2, c3
    
    c1 = sqrt( alpha_gaupbe ) /6.0d0 /sqrt(PAI) *sqrt( -ax )
    
    fout = c1 *n**(-1.0d0/3.0d0) *sqrt(fs)
    
    c2 = -1.0d0 /3.d0 /n +dfs_dn /fs /2.0d0
    dfout = fout *c2
    
    c3 = dfs_ddn /2.0d0 /fs
    ddfout = fout *c3
    
  end subroutine diff_d

end subroutine ex_gaupbe

      subroutine tred1_u(
     &              a, nm,
     &              u_x, u_y, nv,
     &              u_t, v_t, i, c, e, ne)

      implicit NONE

      integer, intent(in)    :: nm, nv, ne, i
      real(8), intent(inout) :: a(1:nm,*)
      real(8), intent(out)   :: u_x(1:nv,*), u_y(1:nv,*)
      real(8), intent(out)   :: u_t(*), v_t(*)

      include 'trd.h'

      real(8), intent(out)   :: c(MBAND,MBAND), e(1:ne,*)

      real(8)                :: anorm2, g_n(MBAND), a_n
      real(8)                :: t, tt(2*MBAND**2), ss(2*MBAND**2)
      real(8)                :: alpha(MBAND), beta(MBAND), scale(MBAND)

      real(8), parameter     :: ZERO = 0.0D+00, ONE = 1.0D+00

      integer                :: x_owner_nod, x_pos
      integer                :: y_owner_nod, y_pos
      integer                :: i_1, i_2, i_3, i_4, i_5
      integer                :: j_1, j_2, j_3, j_4, j_5
      integer                :: k_1, k_2, k_3, k_4, k_5
      integer                :: L, LL

      real(8) :: t11, t12, t22, tol
      real(8) :: a1, a2
      real(8) :: aL(MBAND,MBAND), aX(MBAND, MBAND)
      real(8), parameter :: EPS = 2D-16


      L  = i-MBAND
      LL = L-MBAND

      alpha(1:MBAND) = ONE
      beta (1:MBAND) = ONE
      g_n  (1:MBAND) = ZERO
      scale(1:MBAND) = ZERO

      c(1:MBAND, 1:MBAND)  = ZERO


      do i_1=MBAND,1,-1
      if ( LL + i_1 >= 1  ) then

         y_owner_nod = loop_c_node     (L+i_1, y_nnod, y_inod)
         x_pos       = loop_c_g2l_depth(i-1,   x_nnod, x_inod)
         call bcast_dbl(a(1,i_1), x_pos, y_owner_nod, y_COMM_WORLD)

      end if
      end do


      aL(1:MBAND, 1:MBAND) = ZERO

      do i_1=MBAND,1,-1
      if ( LL + i_1 >= 1  ) then

         x_owner_nod = loop_c_node     (LL+i_1, x_nnod, x_inod)
         x_pos       = loop_c_g2l_depth(LL+i_1, x_nnod, x_inod)

         do j_1=MBAND,1,-1
            if ( x_inod == x_owner_nod ) then
               aL(i_1,j_1) = a(x_pos, j_1)
            endif
         end do

      end if
      end do

      j_2 = loop_c_start(1, x_nnod, x_inod)
      j_3 = loop_c_end  (L, x_nnod, x_inod)

      t11 = ZERO; t12 = ZERO; t22 = ZERO
      do j_1=j_2,j_3
         a2  =a(j_1, 2)
         a1  =a(j_1, 1)
         t22 = t22 + a2 * a2
         t12 = t12 + a1 * a2
         t11 = t11 + a1 * a1
      end do

      tt(1) =  t22
      tt(2) =  t12
      tt(3) =  t11
      tt(4) =  aL(2,2)
      tt(5) =  aL(1,2)
      tt(6) =  aL(2,1)
      tt(7) =  aL(1,1)
      call reduce_dbl(tt, ss, 7, 1, x_COMM_WORLD)
      aX(2,2) = tt(1)
      aX(1,2) = tt(2)
      aX(2,1) = aX(1,2)
      aX(1,1) = tt(3)
      aL(2,2) = tt(4)
      aL(1,2) = tt(5)
      aL(2,1) = tt(6)
      aL(1,1) = tt(7)

      do i_1=MBAND,1,-1
      if ( LL + i_1 >= 1  ) then

         j_2 = loop_c_start(1,      x_nnod, x_inod)
         j_3 = loop_c_end  (LL+i_1, x_nnod, x_inod)

         x_owner_nod = loop_c_node     (LL+i_1, x_nnod, x_inod)
         x_pos       = loop_c_g2l_depth(LL+i_1, x_nnod, x_inod)

         if ( i_1 == 2 ) then

            alpha(i_1) = aX(i_1, i_1)
            a_n        = aL(i_1, i_1)

            do j_1=j_2,j_3
               u_x(j_1, i_1) = a(j_1, i_1)
            end do
         else
            tol = 16 * aX(1, 1) * EPS
            aX(1, 1) = MAX(ZERO, aX(1, 1) - aL(2, 1)**2)
            aX(1, 2) =           aX(1, 2) - aL(2, 1)*aL(2, 2)

            alpha(i_1) = aX(i_1, i_1)
            a_n        = aL(i_1, i_1)

! Singularity found, so re-calculate norm and inner products
            if ( alpha(i_1) < tol ) then
               do j_1=j_2,j_3
                  u_x(j_1, 1) = a(j_1, 1)
               end do
               do k_1=1,MBAND
                  t = ZERO
                  do j_1=j_2,j_3
                     t = t + u_x(j_1, i_1)*u_x(j_1, k_1)
                  enddo
                  tt(1+k_1)=t
               end do
               if ( x_inod == x_owner_nod ) then
                  a_n = a(x_pos, i_1)
               else
                  a_n = ZERO
               end if
               tt(1) =  a_n
               call reduce_dbl(tt, ss, 1+MBAND, 1, x_COMM_WORLD)
               a_n        = tt(1)
               do k_1=1,MBAND
                  aX(i_1,k_1) = tt(1+k_1)
               end do
               do k_1=1,MBAND
                  if ( k_1 /= i_1 ) then
                     aX(k_1,i_1) = aX(i_1,k_1)
                  end if
               end do
               alpha(i_1) = aX(i_1,i_1)
            else
               do j_1=j_2,j_3
                  u_x(j_1, i_1) = a(j_1, i_1)
               end do
            end if

         endif

         if ( alpha(i_1) > ZERO ) then

            scale(i_1) = SQRT(alpha(i_1))
!
! scaling for evading numerical instability
!
            t = ONE / scale(i_1)
            do j_1=j_2,j_3
               u_x(j_1, i_1) = u_x(j_1, i_1) * t
            end do
            do k_1 = 1, MBAND
               aL (k_1, i_1) = aL (k_1, i_1) * t
               aX (k_1, i_1) = aX (k_1, i_1) * t
               aX (i_1, k_1) = aX (i_1, k_1) * t
            end do

            a_n          =  a_n * t
            g_n(i_1)     = -SIGN(ONE, a_n)
            beta(i_1)    =  ONE - a_n * g_n(i_1)
            aL(i_1, i_1) =  a_n - g_n(i_1)

            if ( x_inod == x_owner_nod ) then
               u_x(x_pos, i_1) =  aL(i_1, i_1)
            end if

            do k_1=1,i_1-1
               aX(k_1, i_1) = aX(k_1, i_1) - g_n(i_1) * aL(i_1, k_1)
               aX(i_1, k_1) = aX(k_1, i_1)
            end do
               aX(i_1, i_1) = 2 * beta(i_1)
            do k_1=i_1+1, MBAND
               aX(i_1, k_1) = aX(i_1, k_1) - g_n(i_1) * aL(i_1, k_1)
               aX(k_1, i_1) = aX(i_1, k_1)
            end do

            do k_1=1,i_1-1
               t            = aX(k_1, i_1) / beta(i_1)
               j_2 = loop_c_start(1,      x_nnod, x_inod)
               j_3 = loop_c_end  (LL+i_1, x_nnod, x_inod)
               do j_1=j_2,j_3
                  a (j_1, k_1) = a (j_1, k_1) - t * u_x(j_1, i_1)
               end do! j_1
               do j_1=1,i_1
                  aL(j_1, k_1) = aL(j_1, k_1) - t * aL (j_1, i_1)
               end do
               aX(k_1, i_1) = - aX(k_1, i_1)
               aX(i_1, k_1) =   aX(k_1, i_1)
            end do

         end if

      end if
      end do
!
      do i_1=1,MBAND
      if ( LL + i_1 >= 1  ) then
!
! scaling back
!
         if ( alpha(i_1) > ZERO ) then
            g_n(i_1)   = g_n(i_1)  * scale(i_1)
            beta(i_1)  = beta(i_1) * alpha(i_1)
         else
            g_n(i_1)   = ZERO
            beta(i_1)  = ONE
         endif
         j_2 = loop_c_start(1,      x_nnod, x_inod)
         j_3 = loop_c_end  (LL+i_1, x_nnod, x_inod)
         t = scale(i_1)
         do j_1=j_2,j_3
            u_x(j_1, i_1) = u_x(j_1, i_1) * t
         end do
      end if
      end do
!
      y_owner_nod = loop_c_node(i, y_nnod, y_inod)
      if ( y_owner_nod == y_inod ) then
         if ( i > 2 ) then
            x_owner_nod = loop_c_node(i-2, x_nnod, x_inod)
            if ( x_owner_nod == x_inod ) then
               x_pos = loop_c_g2l_depth(i-2, x_nnod, x_inod)
               e(i-1, 1) = a(x_pos, 1)
            end if
         end if
         if ( i > 1 ) then
            x_owner_nod = loop_c_node(i-1, x_nnod, x_inod)
            if ( x_owner_nod == x_inod ) then
               x_pos = loop_c_g2l_depth(i-1, x_nnod, x_inod)
               e(i, 1) = a(x_pos, 2)
            end if
         end if
         x_owner_nod = loop_c_node(i,   x_nnod, x_inod)
         if ( x_owner_nod == x_inod ) then
            e(i-1, 2) = g_n(1)
            e(i  , 2) = g_n(2)
         end if
      end if

      do i_1=1,MBAND
      if ( LL + i_1 >= 1  ) then
         j_2 = loop_c_start(LL+i_1+1, x_nnod, x_inod)
         j_3 = loop_c_end  (i-1,      x_nnod, x_inod)
         u_x(j_2:j_3,i_1) = ZERO

         j_3 = loop_c_end  (LL+i_1+MBAND-1, x_nnod, x_inod)
         a(1:j_3,i_1) = u_x(1:j_3,i_1)

!         x_pos = loop_c_g2l_depth(i-1, x_nnod, x_inod)
!         call datacast_dbl(u_y(1, i_1), u_x(1, i_1), u_t, v_t, x_pos)
      end if
      end do
         x_pos = loop_c_g2l_depth(i-1, x_nnod, x_inod)
      if ( MOD(MBAND,2)==1 ) then; i_1 = 1
         call datacast_dbl(u_y(1, i_1), u_x(1, i_1),   u_t, v_t, x_pos)
      end if
      do i_1=MOD(MBAND,2)+1,MBAND,2
         call datacast_dbl2(u_y(1, i_1),u_y(1, i_1+1),
     &                      u_x(1, i_1),u_x(1, i_1+1), u_t, v_t, x_pos)
      end do

      c(1:MBAND, 1:MBAND) = ZERO
      do i_1=1,MBAND
         c(i_1, i_1) = ONE / beta(i_1)
      end do
      do i_1=1,MBAND
      do j_1=1,i_1-1
         c(j_1,i_1) = aX(j_1,i_1)*scale(j_1)*scale(i_1)
      end do
      end do

      return
      end subroutine tred1_u

      SUBROUTINE ZDROT( N, CX, INCX, CY, INCY, C, S )
*
*     applies a plane rotation, where the cos and sin (c and s) are real
*     and the vectors cx and cy are complex.
*     jack dongarra, linpack, 3/11/78.
*
*     .. Scalar Arguments ..
      INTEGER            INCX, INCY, N
      DOUBLE PRECISION   C, S
*     ..
*     .. Array Arguments ..
      COMPLEX*16         CX( * ), CY( * )
*
* =====================================================================
*     ..
*     .. Local Scalars ..
      INTEGER            I, IX, IY
      COMPLEX*16         CTEMP
*     ..
*     .. Executable Statements ..
*
      IF( N.LE.0 )
     $   RETURN
      IF( INCX.EQ.1 .AND. INCY.EQ.1 )
     $   GO TO 20
*
*        code for unequal increments or equal increments not equal
*          to 1
*
      IX = 1
      IY = 1
      IF( INCX.LT.0 )
     $   IX = ( -N+1 )*INCX + 1
      IF( INCY.LT.0 )
     $   IY = ( -N+1 )*INCY + 1
      DO 10 I = 1, N
         CTEMP = C*CX( IX ) + S*CY( IY )
         CY( IY ) = C*CY( IY ) - S*CX( IX )
         CX( IX ) = CTEMP
         IX = IX + INCX
         IY = IY + INCY
   10 CONTINUE
      RETURN
*
*        code for both increments equal to 1
*
   20 CONTINUE
      DO 30 I = 1, N
         CTEMP = C*CX( I ) + S*CY( I )
         CY( I ) = C*CY( I ) - S*CX( I )
         CX( I ) = CTEMP
   30 CONTINUE
      RETURN
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: Renewal_of_pPotential
!
!  AUTHOR(S): M. Saito, T. Yamasaki   November/04/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!
subroutine Renewal_of_pPotential()

end subroutine Renewal_of_pPotential

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 599 $)
!
!  SUBROUINE: scf_initialize, scf_do_scf_and_force, scf_finalize
!
!  AUTHOR(S): J. Koga March/24/2009 
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!***************************************************************
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
!!!!!BRANCH_P ORG_Parallel
! ==============================================================================
subroutine scf_initialize()
  implicit none
  call Initialization()
  call InputData_Analysis()
  call Preparation(0)                 ! Basis set, symmetry check etc.
  call Preparation_for_mpi(1)         ! mpi
  call PseudoPotential_Construction()
  call Ewald_and_Structure_Factor()
  call Initial_Electronic_Structure()
  call Initial_MD_Condition()
end subroutine scf_initialize

subroutine scf_do_scf_and_force(exi,skip_ewald)
  implicit none
  logical, intent(out) :: exi
  logical, intent(in)  :: skip_ewald
  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Already_Converged, Already_Converged2
  logical  :: Positron_bulk, Positron_defect
  logical  :: Hubbard_model
  logical  :: Ending_Time
  logical  :: tor
  exi = .false.
  if(.not.skip_ewald) call Ewald_and_Structure_Factor()
  ChargeDensity:    do
    call IterationNumber_Setting()
    call Renewal_of_WaveFunctions()
    call ChargeDensity_Construction(1)
    call ChargeDensity_Mixing()
    if(Ending_Time()) then
      exi = .true.
      return
    endif
    if(TotalEnergy_is_Divergent()) then
      exi = .true.
      return
    endif
    call Renewal_of_Potential()
    if(Hubbard_model()) then
      call Renewal_of_Hubbard_Potential()
    end if
    if(ChargeDensity_is_Converged())  then
#ifdef LIBRARY_BUILD
      call Forces_phase0()
#else
      call Forces()
#endif
      call post_force()
      call MDIterationNumber_Setting()
      return
    endif
  enddo ChargeDensity
end subroutine scf_do_scf_and_force

subroutine post_force()
end subroutine post_force

subroutine scf_finalize()
  implicit none
  call Postprocessing(.false.)
  call WriteDownData_onto_Files(.true.)
  !call Finalization_of_mpi()          ! mpi
end subroutine scf_finalize

subroutine scf_rd_wf_and_chg(logi)
  use m_Files, only : nfout,nfzaj,nfchgt,F_ZAJ_in_partitioned &
 &                  , F_CHGT_in_partitioned, m_Files_reopen_nfchgt, m_Files_reopen_nfzaj &
 &                  , nfefermi, m_Files_open_nfefermi, m_Files_close_nfefermi,F_ZAJ,F_CHGT
  use m_ES_IO, only : m_ESIO_rd_WFs, m_ESIO_rd_Efermi
! === DEBUG by tkato 2011/11/09 ================================================
! use m_Electronic_Structure, only : m_ES_betar_dot_WFs, m_ES_energy_eigen_values
  use m_Electronic_Structure, only : m_ES_energy_eigen_values
  use m_ES_nonlocal,          only : m_ES_betar_dot_WFs
! ==============================================================================
  use m_Charge_Density, only : m_CD_rd_chgq, m_CD_wd_chgq_l_small_portion, chgq_l
  use m_XC_Potential, only: m_XC_cal_potential, vxc_l
  use m_Orbital_Population, only : m_OP_rd_occ_mat, m_OP_mix_om
  use m_Const_Parameters, only : ON, Valence_plus_PC_Charge, VXC_AND_EXC
  use m_Control_Parameters, only : printable, sw_hubbard
  use m_ES_LHXC, only : m_ESlhxc_potential
  use m_ES_Intgr_VlhxcQlm,  only : m_ESiVQ_integrate_VlhxcQlm

  logical, intent(out) :: logi
  logical :: exi
  logi = .true.
  inquire(file=trim(F_CHGT),exist=exi)
  if(.not.exi) then
    logi=.false.
    return
  endif
  inquire(file=trim(F_ZAJ),exist=exi)
  if(.not.exi)then
    logi=.false.
    return
  endif
  
  call m_Files_reopen_nfzaj()
  call m_ESIO_rd_WFs(nfout,nfzaj,F_ZAJ_in_partitioned)
  call m_Files_reopen_nfchgt()
  call m_CD_rd_chgq(nfout,nfchgt,F_CHGT_in_partitioned)

  call m_Files_open_nfefermi()
  call m_ESIO_rd_Efermi(nfout,nfefermi)
  call m_Files_close_nfefermi()

  call m_ES_betar_dot_WFs(nfout)            ! (fsrfsi) ->fsr_l

  call m_CD_wd_chgq_l_small_portion(nfout)
  call m_XC_cal_potential(nfout,Valence_plus_PC_Charge,chgq_l, VXC_AND_EXC) ! -> vxc_l
  call m_ESlhxc_potential(nfout,chgq_l,vxc_l) ! (stlhxc) ->vlhxc_l
  call m_ESiVQ_integrate_VlhxcQlm(nfout) ! (lclchh) -> vlhxcQ
  call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr

  if(sw_hubbard == ON) then
     !!$call Renewal_of_OccMat(.true.) ! -> om
     call m_OP_rd_occ_mat(nfout) ! -> om
     call m_OP_mix_om(1.d0) ! om -> ommix
     call Renewal_of_Hubbard_Potential() ! ommix -> dhub
  end if

end subroutine scf_rd_wf_and_chg
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
!!!!BRANCH_P_END ORG_Parallel
! ==============================================================================

      SUBROUTINE DSYEVX( JOBZ, RANGE, UPLO, N, A, LDA, VL, VU, IL, IU,
     $                   ABSTOL, M, W, Z, LDZ, WORK, LWORK, IWORK,
     $                   IFAIL, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, RANGE, UPLO
      INTEGER            IL, INFO, IU, LDA, LDZ, LWORK, M, N
      DOUBLE PRECISION   ABSTOL, VL, VU
*     ..
*     .. Array Arguments ..
      INTEGER            IFAIL( * ), IWORK( * )
      DOUBLE PRECISION   A( LDA, * ), W( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DSYEVX computes selected eigenvalues and, optionally, eigenvectors
*  of a real symmetric matrix A.  Eigenvalues and eigenvectors can be
*  selected by specifying either a range of values or a range of indices
*  for the desired eigenvalues.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  RANGE   (input) CHARACTER*1
*          = 'A': all eigenvalues will be found.
*          = 'V': all eigenvalues in the half-open interval (VL,VU]
*                 will be found.
*          = 'I': the IL-th through IU-th eigenvalues will be found.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA, N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of A contains the
*          upper triangular part of the matrix A.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of A contains
*          the lower triangular part of the matrix A.
*          On exit, the lower triangle (if UPLO='L') or the upper
*          triangle (if UPLO='U') of A, including the diagonal, is
*          destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  VL      (input) DOUBLE PRECISION
*  VU      (input) DOUBLE PRECISION
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues. VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  ABSTOL  (input) DOUBLE PRECISION
*          The absolute error tolerance for the eigenvalues.
*          An approximate eigenvalue is accepted as converged
*          when it is determined to lie in an interval [a,b]
*          of width less than or equal to
*
*                  ABSTOL + EPS *   max( |a|,|b| ) ,
*
*          where EPS is the machine precision.  If ABSTOL is less than
*          or equal to zero, then  EPS*|T|  will be used in its place,
*          where |T| is the 1-norm of the tridiagonal matrix obtained
*          by reducing A to tridiagonal form.
*
*          Eigenvalues will be computed most accurately when ABSTOL is
*          set to twice the underflow threshold 2*DLAMCH('S'), not zero.
*          If this routine returns with INFO>0, indicating that some
*          eigenvectors did not converge, try setting ABSTOL to
*          2*DLAMCH('S').
*
*          See "Computing Small Singular Values of Bidiagonal Matrices
*          with Guaranteed High Relative Accuracy," by Demmel and
*          Kahan, LAPACK Working Note #3.
*
*  M       (output) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          On normal exit, the first M elements contain the selected
*          eigenvalues in ascending order.
*
*  Z       (output) DOUBLE PRECISION array, dimension (LDZ, max(1,M))
*          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix A
*          corresponding to the selected eigenvalues, with the i-th
*          column of Z holding the eigenvector associated with W(i).
*          If an eigenvector fails to converge, then that column of Z
*          contains the latest approximation to the eigenvector, and the
*          index of the eigenvector is returned in IFAIL.
*          If JOBZ = 'N', then Z is not referenced.
*          Note: the user must ensure that at least max(1,M) columns are
*          supplied in the array Z; if RANGE = 'V', the exact value of M
*          is not known in advance and an upper bound must be used.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of the array WORK.  LWORK >= max(1,8*N).
*          For optimal efficiency, LWORK >= (NB+3)*N,
*          where NB is the max of the blocksize for DSYTRD and DORMTR
*          returned by ILAENV.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace) INTEGER array, dimension (5*N)
*
*  IFAIL   (output) INTEGER array, dimension (N)
*          If JOBZ = 'V', then if INFO = 0, the first M elements of
*          IFAIL are zero.  If INFO > 0, then IFAIL contains the
*          indices of the eigenvectors that failed to converge.
*          If JOBZ = 'N', then IFAIL is not referenced.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, then i eigenvectors failed to converge.
*                Their indices are stored in array IFAIL.
*
* =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLEIG, INDEIG, LOWER, LQUERY, VALEIG, WANTZ
      CHARACTER          ORDER
      INTEGER            I, IINFO, IMAX, INDD, INDE, INDEE, INDIBL,
     $                   INDISP, INDIWO, INDTAU, INDWKN, INDWRK, ISCALE,
     $                   ITMP1, J, JJ, LLWORK, LLWRKN, LOPT, LWKOPT, NB,
     $                   NSPLIT
      DOUBLE PRECISION   ABSTLL, ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN,
     $                   SIGMA, SMLNUM, TMP1, VLL, VUU
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, DLANSY
      EXTERNAL           LSAME, ILAENV, DLAMCH, DLANSY
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DLACPY, DORGTR, DORMTR, DSCAL, DSTEBZ,
     $                   DSTEIN, DSTEQR, DSTERF, DSWAP, DSYTRD, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      LOWER = LSAME( UPLO, 'L' )
      WANTZ = LSAME( JOBZ, 'V' )
      ALLEIG = LSAME( RANGE, 'A' )
      VALEIG = LSAME( RANGE, 'V' )
      INDEIG = LSAME( RANGE, 'I' )
      LQUERY = ( LWORK.EQ.-1 )
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( ALLEIG .OR. VALEIG .OR. INDEIG ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE
         IF( VALEIG ) THEN
            IF( N.GT.0 .AND. VU.LE.VL )
     $         INFO = -8
         ELSE IF( INDEIG ) THEN
            IF( IL.LT.1 .OR. IL.GT.MAX( 1, N ) ) THEN
               INFO = -9
            ELSE IF( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) THEN
               INFO = -10
            END IF
         END IF
      END IF
      IF( INFO.EQ.0 ) THEN
         IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
            INFO = -15
         ELSE IF( LWORK.LT.MAX( 1, 8*N ) .AND. .NOT.LQUERY ) THEN
            INFO = -17
         END IF
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'DSYTRD', UPLO, N, -1, -1, -1 )
         NB = MAX( NB, ILAENV( 1, 'DORMTR', UPLO, N, -1, -1, -1 ) )
         LWKOPT = ( NB+3 )*N
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSYEVX', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      M = 0
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( N.EQ.1 ) THEN
         WORK( 1 ) = 7
         IF( ALLEIG .OR. INDEIG ) THEN
            M = 1
            W( 1 ) = A( 1, 1 )
         ELSE
            IF( VL.LT.A( 1, 1 ) .AND. VU.GE.A( 1, 1 ) ) THEN
               M = 1
               W( 1 ) = A( 1, 1 )
            END IF
         END IF
         IF( WANTZ )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = DLAMCH( 'Safe minimum' )
      EPS = DLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
*
*     Scale matrix to allowable range, if necessary.
*
      ISCALE = 0
      ABSTLL = ABSTOL
      VLL = VL
      VUU = VU
      ANRM = DLANSY( 'M', UPLO, N, A, LDA, WORK )
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
      IF( ISCALE.EQ.1 ) THEN
         IF( LOWER ) THEN
            DO 10 J = 1, N
               CALL DSCAL( N-J+1, SIGMA, A( J, J ), 1 )
   10       CONTINUE
         ELSE
            DO 20 J = 1, N
               CALL DSCAL( J, SIGMA, A( 1, J ), 1 )
   20       CONTINUE
         END IF
         IF( ABSTOL.GT.0 )
     $      ABSTLL = ABSTOL*SIGMA
         IF( VALEIG ) THEN
            VLL = VL*SIGMA
            VUU = VU*SIGMA
         END IF
      END IF
*
*     Call DSYTRD to reduce symmetric matrix to tridiagonal form.
*
      INDTAU = 1
      INDE = INDTAU + N
      INDD = INDE + N
      INDWRK = INDD + N
      LLWORK = LWORK - INDWRK + 1
      CALL DSYTRD( UPLO, N, A, LDA, WORK( INDD ), WORK( INDE ),
     $             WORK( INDTAU ), WORK( INDWRK ), LLWORK, IINFO )
      LOPT = 3*N + WORK( INDWRK )
*
*     If all eigenvalues are desired and ABSTOL is less than or equal to
*     zero, then call DSTERF or DORGTR and SSTEQR.  If this fails for
*     some eigenvalue, then try DSTEBZ.
*
      IF( ( ALLEIG .OR. ( INDEIG .AND. IL.EQ.1 .AND. IU.EQ.N ) ) .AND.
     $    ( ABSTOL.LE.ZERO ) ) THEN
         CALL DCOPY( N, WORK( INDD ), 1, W, 1 )
         INDEE = INDWRK + 2*N
         IF( .NOT.WANTZ ) THEN
            CALL DCOPY( N-1, WORK( INDE ), 1, WORK( INDEE ), 1 )
            CALL DSTERF( N, W, WORK( INDEE ), INFO )
         ELSE
            CALL DLACPY( 'A', N, N, A, LDA, Z, LDZ )
            CALL DORGTR( UPLO, N, Z, LDZ, WORK( INDTAU ),
     $                   WORK( INDWRK ), LLWORK, IINFO )
            CALL DCOPY( N-1, WORK( INDE ), 1, WORK( INDEE ), 1 )
            CALL DSTEQR( JOBZ, N, W, WORK( INDEE ), Z, LDZ,
     $                   WORK( INDWRK ), INFO )
            IF( INFO.EQ.0 ) THEN
               DO 30 I = 1, N
                  IFAIL( I ) = 0
   30          CONTINUE
            END IF
         END IF
         IF( INFO.EQ.0 ) THEN
            M = N
            GO TO 40
         END IF
         INFO = 0
      END IF
*
*     Otherwise, call DSTEBZ and, if eigenvectors are desired, SSTEIN.
*
      IF( WANTZ ) THEN
         ORDER = 'B'
      ELSE
         ORDER = 'E'
      END IF
      INDIBL = 1
      INDISP = INDIBL + N
      INDIWO = INDISP + N
      CALL DSTEBZ( RANGE, ORDER, N, VLL, VUU, IL, IU, ABSTLL,
     $             WORK( INDD ), WORK( INDE ), M, NSPLIT, W,
     $             IWORK( INDIBL ), IWORK( INDISP ), WORK( INDWRK ),
     $             IWORK( INDIWO ), INFO )
*
      IF( WANTZ ) THEN
         CALL DSTEIN( N, WORK( INDD ), WORK( INDE ), M, W,
     $                IWORK( INDIBL ), IWORK( INDISP ), Z, LDZ,
     $                WORK( INDWRK ), IWORK( INDIWO ), IFAIL, INFO )
*
*        Apply orthogonal matrix used in reduction to tridiagonal
*        form to eigenvectors returned by DSTEIN.
*
         INDWKN = INDE
         LLWRKN = LWORK - INDWKN + 1
         CALL DORMTR( 'L', UPLO, 'N', N, M, A, LDA, WORK( INDTAU ), Z,
     $                LDZ, WORK( INDWKN ), LLWRKN, IINFO )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
   40 CONTINUE
      IF( ISCALE.EQ.1 ) THEN
         IF( INFO.EQ.0 ) THEN
            IMAX = M
         ELSE
            IMAX = INFO - 1
         END IF
         CALL DSCAL( IMAX, ONE / SIGMA, W, 1 )
      END IF
*
*     If eigenvalues are not in order, then sort them, along with
*     eigenvectors.
*
      IF( WANTZ ) THEN
         DO 60 J = 1, M - 1
            I = 0
            TMP1 = W( J )
            DO 50 JJ = J + 1, M
               IF( W( JJ ).LT.TMP1 ) THEN
                  I = JJ
                  TMP1 = W( JJ )
               END IF
   50       CONTINUE
*
            IF( I.NE.0 ) THEN
               ITMP1 = IWORK( INDIBL+I-1 )
               W( I ) = W( J )
               IWORK( INDIBL+I-1 ) = IWORK( INDIBL+J-1 )
               W( J ) = TMP1
               IWORK( INDIBL+J-1 ) = ITMP1
               CALL DSWAP( N, Z( 1, I ), 1, Z( 1, J ), 1 )
               IF( INFO.NE.0 ) THEN
                  ITMP1 = IFAIL( I )
                  IFAIL( I ) = IFAIL( J )
                  IFAIL( J ) = ITMP1
               END IF
            END IF
   60    CONTINUE
      END IF
*
*     Set WORK(1) to optimal workspace size.
*
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of DSYEVX
*
      END

subroutine Screening_Potential
  use m_Crystal_Structure,  only : altv,rltv
  use m_Control_Parameters, only : sw_screening_correction, screening_alpha, gmaxp
  use m_PlaneWaveBasisSet,    only : gr_l, ngabc, kgp
  use m_Parallelization,    only : ista_kngp,iend_kngp
  use m_Screening

  implicit none
  integer i

  real(8) ga,gb,gc,g(3)
  real(8) Lmin, Ltmp(3)

  !! PHASEと接続する場合には以下の文をアンコメントする
  Screening%La = position(altv(1,1),altv(2,1),altv(3,1)) ! PHASEと接続する場合
  Screening%Lb = position(altv(1,2),altv(2,2),altv(3,2)) ! PHASEと接続する場合
  Screening%Lc = position(altv(1,3),altv(2,3),altv(3,3)) ! PHASEと接続する場合
  ! カットオフ波数
  Screening%Gmax  = gmaxp      ! PHASEと接続する場合

  !---- PHASE変数kgp,ngabcのコピーを用意する。
  allocate( Screening%ngabc(kgp,3) )

  do i=1, kgp
     Screening%ngabc(i,1) = ngabc(i,1)
     Screening%ngabc(i,2) = ngabc(i,2)
     Screening%ngabc(i,3) = ngabc(i,3)
  end do

  Screening%Nk = kgp ! カットオフ半径内の波数ベクトルの総数

  ! 遮蔽パラメタ。次元は長さの逆数。単位は原子単位。[1/a.u.length]
  Ltmp(1) = length( Screening%La )
  Ltmp(2) = length( Screening%Lb )
  Ltmp(3) = length( Screening%Lc )
  Lmin = minval(Ltmp)
  Screening%alpha = screening_alpha/Lmin

  write(6,*) "screening correction..."
  write(6,*) "altv:"
  write(6,*) altv
  write(6,*) "La Lb Lc:"
  write(6,*) Screening%La, Screening%Lb, Screening%Lc
  write(6,*) "Gmax  alpha:"  
  write(6,*) Screening%Gmax, Screening%alpha, screening_alpha

  ! 遮蔽ポテンシャルの設定
  call setup_screening
  write(6,*) "Nk:"  
  write(6,*) Screening%Nk, ista_kngp,iend_kngp

  ! 遮蔽ポテンシャルの値のテスト表示
!  do i=1, Screening%Nk
!
!     ga = ngabc(i,1)
!     gb = ngabc(i,2)
!     gc = ngabc(i,3)
!     g(1) = rltv(1,1)*ga+rltv(1,2)*gb+rltv(1,3)*gc
!     g(2) = rltv(2,1)*ga+rltv(2,2)*gb+rltv(2,3)*gc
!     g(3) = rltv(3,1)*ga+rltv(3,2)*gb+rltv(3,3)*gc
!
!     write(6,'(i10,2e20.10)') i, Screening%phik(i), gr_l(i)
!     write(12,'(i10,6f11.6)') i, &
!          g, sqrt(dot_product(g,g)), &
!          gr_l(i), Screening%phik(i)
!  end do

end subroutine Screening_Potential

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 581 $)
!
!  MODULE: m_BP_Properties
!
!  AUTHOR(S): T. Yamamoto   Oct/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
! ==============
!  patch 0.1 by K. Tagami @adv    2008/10/19
!
!     patch 0.1 :  correction in the case when nspin==2
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_BerryPhase
  ! $Id: m_BerryPhase.F90 581 2018-08-01 08:38:42Z jkoga $
  use m_Const_Parameters,    only : DP, PAI, PAI2, PAI4, ON, OFF
  use m_Control_Parameters,  only : ipriberry, nspin, printable, ndim_spinor, noncol
  use m_Files,               only : nfout
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &              , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e &
       &              , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &              , map_ek, myrank_ke &
       &              , ista_g1k, iend_g1k, mpi_ke_world, mpi_chg_world &
       &              , nel_fs, nis_fs, mpi_ke_world, ista_atm, iend_atm, mpi_g_world &
#ifdef TRANSPOSE
       &              , ierr,mp_e,nis_e,nie_e,nel_e &
       &              , ista_g1,iend_g1,np_g1,mp_g1,nis_g1,nie_g1,nel_g1
#else
       &              , ierr
#endif

  implicit none
  include 'mpif.h'
  integer, private :: n1,n2,jpara
  integer, private :: ig
  integer, private :: nkvec,nkprep
  integer, private :: nstate = -1
  integer, private :: ikp = 0
  integer, private :: sw_symmetry = 2 ! 1->idetical, 2->inversion, 3->full
  integer, private :: sw_deficit = ON ! 0->off, 1->on
  real(kind=DP), private :: g(3)
  real(kind=DP), allocatable, private :: kvec(:,:) ! dim(3,nkvec)
  real(kind=DP), allocatable, private :: wgh(:) ! dim(nkprep)
  real(kind=DP), allocatable, private :: wfbp0(:,:,:,:) ! dim(kg,np_e,2,nspin)
  real(kind=DP), allocatable, private :: wfbp1(:,:,:,:) ! dim(kg,np_e,2,nspin)
  real(kind=DP), allocatable, private :: wfbp2(:,:,:,:) ! dim(kg,np_e,2,nspin)
  integer, private :: kgbp0,kgbp1,kgbp2
  complex(kind=DP), allocatable, private :: det(:,:,:) ! dim(jpara,nkprep,nspin)
  real(kind=DP) :: kshift_BP(2)
  logical, private :: ikp0 = .true.

! for the US correction
  real(kind=DP), allocatable, private :: fsr_k0(:,:,:),fsi_k0(:,:,:) ! dim(np_e,nlmta,nspin)
  real(kind=DP), allocatable, private :: fsr_k1(:,:,:),fsi_k1(:,:,:) ! dim(np_e,nlmta,nspin)
  real(kind=DP), allocatable, private :: fsr_k2(:,:,:),fsi_k2(:,:,:) ! dim(np_e,nlmta,nspin
  real(kind=DP), allocatable, private :: zfcos(:),zfsin(:) ! dim(natm)
  real(kind=DP), allocatable, private :: ftqer(:,:,:),ftqei(:,:,:) ! dim(nlmt,nlmt,natm)

! Tags
  character(len("berry_phase")),private,parameter :: tag_berry_phase = "berry_phase"
  character(len("sw_berry_phase")),private,parameter :: tag_sw_berry_phase = "sw_berry_phase"
  character(len("g_index")),private,parameter :: tag_g_index = "g_index"
  character(len("mesh")),private,parameter :: tag_mesh = "mesh"
  character(len("n1")),private,parameter :: tag_n1 = "n1"
  character(len("n2")),private,parameter :: tag_n2 = "n2"
  character(len("j")),private,parameter :: tag_j = "j"
  character(len("kshift")),private,parameter :: tag_kshift = "kshift"
  character(len("k1")),private,parameter :: tag_k1 = "k1"
  character(len("k2")),private,parameter :: tag_k2 = "k2"
  character(len("sw_symmetry")),private,parameter :: tag_sw_symmetry = "sw_symmetry"
  character(len("sw_deficit")),private,parameter :: tag_sw_deficit = "sw_deficit"

! MPI
  !integer, private :: istatus
  integer, private :: istatus(mpi_status_size)

contains

  subroutine m_BP_rd_parameters
    use m_Crystal_Structure, only : rltv
    use m_Control_Parameters,  only : icond,sw_berry_phase
    use m_Const_Parameters, only : FIXED_CHARGE,FIXED_CHARGE_CONTINUATION
    implicit none

    integer :: iret, f_selectBlock, f_getIntValue, f_getRealValue &
         & ,f_getRealVectorValue
    integer :: f_selectParentBlock, f_selectTop
    real(kind=DP) :: dret

    if(icond /= FIXED_CHARGE .and. icond /= FIXED_CHARGE_CONTINUATION) return

    iret = f_selectTop()
    if( f_selectBlock( tag_berry_phase) == 0) then
       if( f_getIntValue( tag_sw_berry_phase, iret) == 0) sw_berry_phase = iret
       if( f_getIntValue( tag_sw_symmetry, iret) == 0) sw_symmetry = iret
       if( f_getIntValue( tag_sw_deficit, iret) == 0) sw_deficit = iret
       if( f_getIntValue( tag_g_index, iret) == 0) then
          ig = iret
       else
          ig = 1 ! default value
       end if
       if( f_selectBlock( tag_mesh) == 0) then
          if( f_getIntValue( tag_n1, iret) == 0) n1 = iret
          if( f_getIntValue( tag_n2, iret) == 0) n2 = iret
          if( f_getIntValue( tag_j, iret) == 0)  jpara = iret
       else
          n1 = 4 ! default value
          n2 = 4 ! default value
          jpara = 20 ! default value
       end if
       iret = f_selectParentBlock()
       if( f_selectBlock( tag_kshift) == 0) then
          if( f_getRealValue( tag_k1, dret, '' ) == 0) kshift_BP(1) = dret
          if( f_getRealValue( tag_k2, dret, '' ) == 0) kshift_BP(2) = dret
       else
          kshift_BP(1:2) = 0.d0 ! default value
       end if
       iret = f_selectParentBlock()
    end if
    iret = f_selectParentBlock()

    if(sw_berry_phase == ON .and. printable) then
       write(nfout,'(1x,"<< Berry Phase")')
       write(nfout,'(1x,"ig=",i1,1x,"g=",3(1x,f10.5))') ig,rltv(1:3,ig)
       write(nfout,'(1x,"n1=",i3,1x,"n2=",i3,1x,"J=",i3)') n1,n2,jpara
       write(nfout,'(1x,"k1=",f8.5,1x,"k2=",f8.5)') kshift_BP(1:2)
       write(nfout,'(1x,"sw_symmetry = ",i1)') sw_symmetry
       write(nfout,'(1x,"sw_deficit = ",i1)') sw_deficit
       write(nfout,'(1x,"   Berry Phase >>")')
    end if

  end subroutine m_BP_rd_parameters

  subroutine m_BP_gen_Kpoints(preallocation)
    use m_Kpoints, only: special_kpoints, kshift, mp_index
    use m_Crystal_Structure, only : rltv, nopr, op, imag
    use m_Const_Parameters,  only : CARTS,BUCS,PARA
    use m_Kpoints, only : kv3, vkxyz, qwgt, m_Kp_alloc_kpoints
    implicit none

    logical, intent(in) :: preallocation

! local variables
    integer :: i,j,k
    integer :: printlevel = 1
    integer :: nkpoint,nsym
    integer, parameter :: nkpmax0 = 10000
    real(kind=DP) :: kpoint(3,nkpmax0), weight(nkpmax0)
    real(kind=DP) :: bmat(3,3)
    real(kind=DP) :: c(3,2),b(3,2)
    real(kind=DP) :: cdot,g2,dg,w
    real(kind=DP) :: a1(3),a2(3),a3(3),volg
    real(kind=DP) :: rot(3,3,48),rot_g(3)
    real(kind=DP) :: scaled_g(3),scaled_a3(3)
    real(kind=DP) :: theta
    real(kind=DP), parameter :: eps = 1.d-12
    logical :: sw_trs = .true. ! time reversal symmetry
    logical :: magnetic, use_trs

    use_trs = .true.

! === KT_add === 2015/03/23
    if ( sw_symmetry == 1 ) use_trs = .false.

    if ( noncol ) then
       use_trs = .false.
    else
       if ( imag /= PARA ) use_trs = .false.
    endif
! ============== 2015/03/23

    if(imag/=PARA) then
       magnetic = .true.
    else
       magnetic = .false.
    end if

    bmat(1:3,1:3)=rltv(1:3,1:3)/PAI2

    g(1:3) = bmat(1:3,ig)
    k=0
    do i=1,3
       if(i /= ig) then
          k=k+1
          b(1:3,k)=bmat(1:3,i)
       end if
    end do

    g2 = sum(g(1:3)**2)
    do k=1,2
       cdot = sum(b(1:3,k)*g(1:3))/g2 
       c(1:3,k) = b(1:3,k) - cdot*g(1:3)
    end do

    call cross(c(1,2),g,a1)
    volg = sum(c(1:3,1)*a1(1:3))
    a1(1:3)=a1(1:3)/volg
    call cross(g,c(1,1),a2)
    a2(1:3)=a2(1:3)/volg
    call cross(c(1,1),c(1,2),a3)
    a3(1:3)=a3(1:3)/volg

    nsym=0
    do i=1,nopr
       do j=1,3
          rot_g(j) = sum(op(j,1:3,i)*g(1:3))
       end do
       if(abs(rot_g(1)-g(1)) < eps .and. &
            & abs(rot_g(2)-g(2)) < eps .and. &
            & abs(rot_g(3)-g(3)) < eps ) then
          nsym=nsym+1
          rot(1:3,1:3,nsym) = op(1:3,1:3,i)
       end if
    end do

    if(preallocation .and. printable) then
       write(nfout,'(1x,"<< k-points for an area integral in Berry phase calc.")')
       write(nfout,*) 'c1 = ',c(1:3,1)
       write(nfout,*) 'c2 = ',c(1:3,2)
       write(nfout,*) 'g  = ',g(1:3)
       write(nfout,*) 'a1 = ',a1(1:3)
       write(nfout,*) 'a2 = ',a2(1:3)
       write(nfout,*) 'a3 = ',a3(1:3)
       theta = sum(a1(1:3)*a2(1:3))/(sqrt(sum(a1(1:3)**2))*sqrt(sum(a2(1:3)**2)))
       theta = acos(theta) *360.d0 /PAI2
       write(nfout,*) 'angle between a1 and a2 (deg.) =',theta
    end if

! for identical symmetry olny
    if(sw_symmetry == 1 .or. sw_symmetry == 2) then
       nsym=1
       rot(1:3,1:3,nsym) = 0.d0
       do i=1,3
          rot(i,i,nsym) = 1.d0
       end do
    end if
    if(sw_symmetry == 1) sw_trs = .false.

    mp_index(1) = n1;     mp_index(2) = n2;     mp_index(3) = 1
    kshift(1:2) = kshift_BP(1:2);     kshift(3)=0.d0

    scaled_g(1:3)  = g(1:3)/dble(100.d0)
    scaled_a3(1:3) = a3(1:3)*dble(100.d0)

    nkprep = 0

    call special_kpoints(printlevel,nfout,nsym,rot &
         & , c(1,1),c(1,2),scaled_g,a1,a2,scaled_a3 &
                                !& , c(1,1),c(1,2),g,a1,a2,a3 &
         & , nkprep,nkpmax0,kpoint,weight,magnetic,use_trs)
    if(preallocation.and.printable) then
       write(nfout,'(1x,"   k-points for an area integral in Berry phase calc. >>")')
    end if

    nkvec=nkprep*jpara
    allocate(kvec(3,nkvec))
    allocate(wgh(nkprep))

    dg = 1.d0 /dble(jpara)
    nkvec=0
    do j=1,nkprep
!!!       wgh(j) = weight(j)/dble(nspin)
       wgh(j) = weight(j) /dble( nspin /ndim_spinor )     !!! to be checked !!

       do i=1,jpara
          nkvec=nkvec+1
          kvec(1:2,nkvec) = kpoint(1:2,j)
          kvec(3,nkvec)   = dg*dble(i-1)
       end do
    end do

    !kv3 = nkvec*nspin
    !call m_Kp_alloc_kpoints

    if(.not.preallocation) then

       kv3 = nkvec
       w=1.d0/dble(kv3)
       do i=1,nkvec
          vkxyz(i,1:3,CARTS) = 0.d0
          do j=1,2
             vkxyz(i,1:3,CARTS) = vkxyz(i,1:3,CARTS)+ c(1:3,j)*kvec(j,i)
          end do
          vkxyz(i,1:3,CARTS) = vkxyz(i,1:3,CARTS)+ g(1:3)*kvec(j,i)
          vkxyz(i,1:3,CARTS) = vkxyz(i,1:3,CARTS)*PAI2
          qwgt(i) = w
       end do

       if(printable) then
          write(nfout,'("<< generated k-points")')
          do i=1,nkvec
             write(nfout,'(1x,i4," k=",3(1x,f10.5),1x," k_cart=", &
                  & 3(1x,f10.5),1x,"w= ",f10.5)') &
                  & i,kvec(1:3,i),vkxyz(i,1:3,CARTS),qwgt(i)
          end do
          write(nfout,'("   generated k-points >>")')
       end if

       if ( noncol ) then
          allocate(det(jpara,nkprep,1));det=(0.d0,0.d0)
       else
          allocate(det(jpara,nkprep,nspin));det=(0.d0,0.d0)
       endif

       call set_dk_BP()

    else
       kv3 = nkvec *nspin
       deallocate(kvec,wgh)
    end if

    !stop 'm_BP_gen_Kpoints'

  contains

    subroutine cross(a,b,c)
      implicit none
      real(kind=DP), intent(in) :: a(3),b(3)
      real(kind=DP), intent(out) :: c(3)

!local variables
      integer :: i,j,k

      c(1) = a(2)*b(3)-a(3)*b(2)
      c(2) = a(3)*b(1)-a(1)*b(3)
      c(3) = a(1)*b(2)-a(2)*b(1)

    end subroutine cross

    subroutine set_dk_BP()
      use m_PseudoPotential, only : dk_BP

      dk_BP(1) = sqrt(sum(g(1:3)**2))/ dble(jpara) *PAI2
      !dk_BP(1) = 0.d0 ! for debug of Fourier transforms
      if(printable) then
         write(nfout,*) '!** set_dk_BP: dk_BP=',dk_BP(1)
      end if

    end subroutine set_dk_BP

  end subroutine m_BP_gen_Kpoints

  subroutine calc_phase_for_Berry()
    use m_Ionic_System,        only : pos,natm

! local variables
    integer       :: ia
    real(kind=DP) :: ph

    if(.not.allocated(zfcos)) allocate(zfcos(natm),zfsin(natm))

    ! debug
    !do ia=1,natm
    !  if(printable) write(nfout,*) ia,': pos=',pos(ia,1:3)
    !end do
    !if(printable) write(nfout,*) '--- ia,zfcos,zfsin ---'
    ! end debug

    do ia=1,natm
       ph = pos(ia,ig)*PAI2
       zfcos(ia) = cos(ph)
       zfsin(ia) = sin(ph)
       ! debug
       ! if(printable) write(nfout,*) ia,zfcos(ia),zfsin(ia)
       ! end debug
    end do

  end subroutine calc_phase_for_Berry

  subroutine m_BP_calc_det()
    use m_PseudoPotential,     only : nlmta
! === DEBUG by T.Kato 2013/07/11 ===============================================
    !use m_Electronic_Structure, only : neg, neordr
    use m_Electronic_Structure, only : neordr
    use m_Control_Parameters, only : neg
! ==============================================================================

    implicit none

! local variables
    integer :: i,k,k1,k2,j1,jj1,j2,kg,nk1,nk2
    integer :: ik,is, ismax, js, istmp
    integer :: j1_mpi,j1_ordr
    real(kind=DP) :: mr(nstate,nstate),mi(nstate,nstate)
    real(kind=DP), allocatable :: mr_mpi(:,:),mi_mpi(:,:)
    real(kind=DP), allocatable :: wfbp(:,:,:,:)
    real(kind=DP), allocatable :: fsr_k(:,:,:),fsi_k(:,:,:)

! for debug
    integer :: n

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    nk1 = mod(ikp,jpara)
    nk2 = ikp/jpara +1

    if(jpara>1) then

       kg = min(kgbp1,kgbp2)

       allocate(wfbp(kgbp2,nstate,2,nspin))
       call copy_old_wfbp_to_temp_wfbp(kgbp2,wfbp2,wfbp) ! MPI

       if(sw_deficit == ON) then
          allocate(fsr_k(nstate,nlmta,nspin),fsi_k(nstate,nlmta,nspin))
          call copy_old_fs_to_temp_fs(fsr_k2,fsi_k2,fsr_k,fsi_k) ! MPI
       end if

! === KT_mod === 2015/03/23
!       SPIN: do is =1,nspin
       SPIN: do is =1, ismax
! ============== 2015/03/23

          mr = 0.d0; mi = 0.d0
          ik = is

          Do js=1, ndim_spinor
             istmp = is +js -1

             do j2=1,nstate
                do j1=1,neg
                   if (map_ek(j1,ik) /= myrank_ke) cycle
                   j1_mpi = map_z(j1)
                   j1_ordr = neordr(j1,ik)
                   
                   if (j1_ordr > nstate) cycle
                   !if(printable) write(nfout,*) '>>>> j1_ordr is lower than nstate+1.'

                   do i=ista_g1k(ik),iend_g1k(ik)
                      mr(j1_ordr,j2) = mr(j1_ordr,j2) &
                           &          + wfbp1(i,j1_mpi,1,istmp) *wfbp(i,j2,1,istmp) &
                           &          + wfbp1(i,j1_mpi,2,istmp) *wfbp(i,j2,2,istmp)
                      mi(j1_ordr,j2) = mi(j1_ordr,j2) &
                           &          - wfbp1(i,j1_mpi,2,istmp) *wfbp(i,j2,1,istmp) &
                           &          + wfbp1(i,j1_mpi,1,istmp) *wfbp(i,j2,2,istmp)
                   end do
                   if (sw_deficit == ON) &
                        & call add_deficit_term( mr(j1_ordr,j2), mi(j1_ordr,j2), &
                        &                        fsr_k1, fsi_k1, fsr_k, fsi_k, &
                        &                        j1_mpi, j2, istmp )
                end do
             end do
          end Do   ! js

          call mpi_barrier(mpi_comm_group,ierr)
          if (npes>1) then
             allocate(mr_mpi(nstate,nstate),mi_mpi(nstate,nstate))
             mr_mpi=0.d0; mi_mpi=0.d0
             call mpi_allreduce(mr,mr_mpi,nstate**2,mpi_double_precision,mpi_sum, &
                  &             mpi_comm_group,ierr)
             mr = mr_mpi
             call mpi_allreduce(mi,mi_mpi,nstate**2,mpi_double_precision,mpi_sum, &
                  &             mpi_comm_group,ierr)
             mi = mi_mpi
             deallocate(mr_mpi,mi_mpi)
          end if

          call determinant(nstate,mr,mi,det(nk1,nk2,is))

          if(ipriberry > 1 .and. printable) then
             write(nfout,'(1x,"Overlap matrix: k1=",i4," k2=",i4," is=",i4)') nk1,nk1+1,is
             write(nfout,'(1x,"ikp=",i4)') ikp
             write(nfout,'(1x,"ikprep=",i4)') nk2
             write(nfout,'(1x,"kg=",i0)') kg
             write(nfout,'(1x,"Real part:")')
             do j1=1,nstate
                write(nfout,'(50(1x,f10.5))') mr(j1,1:nstate)
             end do
             write(nfout,'(1x,"Imag part:")')
             do j1=1,nstate
                write(nfout,'(50(1x,f10.5))') mi(j1,1:nstate)
             end do
             write(nfout,'(1x,"Determinant: k1=",i4," k2=",i4," is=",i4)') nk1,nk1+1,is
             write(nfout,'("Det = ",e25.14," +i ",e25.14)') det(nk1,nk2,is)
          end if

       end do SPIN
       deallocate(wfbp)
       if(sw_deficit==ON) deallocate(fsr_k,fsi_k)

    end if

    if(nk1==jpara-1) then
       kg = min(kgbp2,kgbp0)

       allocate(wfbp(kgbp0,nstate,2,nspin))
       call copy_old_wfbp_to_temp_wfbp(kgbp0,wfbp0,wfbp) ! MPI
       if(sw_deficit == ON) then
          allocate(fsr_k(nstate,nlmta,nspin),fsi_k(nstate,nlmta,nspin))
          call copy_old_fs_to_temp_fs(fsr_k0,fsi_k0,fsr_k,fsi_k) ! MPI
       end if

! === KT_mod === 2015/03/23
!       SPIN2: do is =1,nspin
       SPIN2: do is =1, ismax
! ============== 2015/03/23

          mr =0.d0; mi=0.d0
          ik = is

          Do js=1, ndim_spinor
             istmp = is +js -1

             do j2=1,nstate
                do j1=1,neg
                   if (map_ek(j1,ik) /= myrank_ke) cycle
                   j1_mpi = map_z(j1)
                   j1_ordr = neordr(j1,ik)

                   if (j1_ordr > nstate) cycle
                !if(printable) write(nfout,*) '>>>> j1_ordr is lower than nstate+1.'
                   
                   do i=ista_g1k(ik),iend_g1k(ik)
                      mr(j1_ordr,j2) = mr(j1_ordr,j2) &
                           &          + wfbp2(i,j1_mpi,1,istmp)*wfbp(i,j2,1,istmp) &
                           &          + wfbp2(i,j1_mpi,2,istmp)*wfbp(i,j2,2,istmp)
                      mi(j1_ordr,j2) = mi(j1_ordr,j2) &
                           &          - wfbp2(i,j1_mpi,2,istmp)*wfbp(i,j2,1,istmp) &
                           &          + wfbp2(i,j1_mpi,1,istmp)*wfbp(i,j2,2,istmp)
                   end do
                   if (sw_deficit == ON) &
                        & call add_deficit_term( mr(j1_ordr,j2), mi(j1_ordr,j2), &
                        &                        fsr_k2, fsi_k2, fsr_k, fsi_k, &
                        &                        j1_mpi, j2, istmp )
                end do
             end do
          End Do

          call mpi_barrier(mpi_comm_group,ierr)

! ==================== modified by K. Tagami ========= 0.1
!          deallocate(wfbp)
!          if(sw_deficit==ON) deallocate(fsr_k,fsi_k)
! ==================================================== 0.1

          if(npes>1) then
             allocate(mr_mpi(nstate,nstate),mi_mpi(nstate,nstate))
             mr_mpi=0.d0; mi_mpi=0.d0
             call mpi_allreduce(mr,mr_mpi,nstate**2,mpi_double_precision,mpi_sum &
                  &,mpi_comm_group,ierr)
             mr = mr_mpi
             call mpi_allreduce(mi,mi_mpi,nstate**2,mpi_double_precision,mpi_sum &
                  &,mpi_comm_group,ierr)
             mi = mi_mpi
             deallocate(mr_mpi,mi_mpi)
          end if

          call determinant(nstate,mr,mi,det(jpara,nk2,is))

          if(ipriberry > 1 .and. printable) then
             write(nfout,'(1x,"Overlap matrix: k1=",i4," k2=",i4," is=",i4)') &
                  &                           jpara,jpara+1,is
             write(nfout,'(1x,"ikprep=",i4)') nk2
             write(nfout,'(1x,"Real part:")')
             do j1=1,nstate
                write(nfout,'(50(1x,f10.5))') mr(j1,1:nstate)
             end do
             write(nfout,'(1x,"Imag part:")')
             do j1=1,nstate
                write(nfout,'(50(1x,f10.5))') mi(j1,1:nstate)
             end do

! =================== modified by K. Tagami ====== 0.1
!!            write(nfout,'(1x,"Determinant: k1=",i4," k2=",i4," is=",i4)') jpara,jpara+1
              write(nfout,'(1x,"Determinant: k1=",i4," k2=",i4," is=",i4)') &
                   &                       jpara,jpara+1, is
! ================================================ 0.1
             write(nfout,'("Det = ",e25.14," +i ",e25.14)') det(jpara,nk2,is)
          end if

       end do SPIN2

! ================= Added by K. Tagami ==== 0.1
       deallocate(wfbp)
       if(sw_deficit==ON) deallocate(fsr_k,fsi_k)
! ===========================================

       if(allocated(wfbp0)) deallocate(wfbp0)
       if(allocated(wfbp1)) deallocate(wfbp1)
       if(allocated(wfbp2)) deallocate(wfbp2)
       if(allocated(fsr_k0)) deallocate(fsr_k0,fsi_k0)
       if(allocated(fsr_k1)) deallocate(fsr_k1,fsi_k1)
       if(allocated(fsr_k2)) deallocate(fsr_k2,fsi_k2)

    end if

  contains

    subroutine add_deficit_term(mr,mi,fr1,fi1,fr2,fi2,j1,j2,ispin)
      use m_Const_Parameters,    only : SKIP
      use m_Ionic_System,        only : natm, ityp
      use m_PseudoPotential,     only : index_lmt1_lmt2,lmta &
           &                        , ltp,mtp,taup,ilmt &
           &                        , qitg_BP,iqitg,isph,il2p,dl2p &
           &                        , m_PP_include_vanderbilt_pot &
           &                        , n_non0_lmtxlmt &
           &                        , nlmta
      implicit none
      real(kind=DP), intent(inout) :: mr,mi
      real(kind=DP), intent(in), dimension(np_e,nlmta,nspin) :: fr1,fi1
      real(kind=DP), intent(in), dimension(nstate,nlmta,nspin) :: fr2,fi2
      integer, intent(in) :: j1,j2,ispin

! local varialbes
      integer :: ia,it,ik,ip,lmt1,lmt2,u,v
      real(kind=DP) :: eps = 1.d-13
      real(kind=DP) :: hsr,hsi
      integer :: mdvdb

      ATOM: do ia = ista_atm,iend_atm
         it = ityp(ia)
         mdvdb = m_PP_include_vanderbilt_pot(it)
         if(mdvdb == SKIP) cycle ATOM
         ! debug
         !  if(printable) write(nfout,*) 'ia=',ia,' it=',it
         ! end debug
         LMT_1: do lmt1=1,ilmt(it)
            u = lmta(lmt1,ia)
            !LMT_2: do lmt2=lmt1,ilmt(it)
            LMT_2: do lmt2=1,ilmt(it)
               v = lmta(lmt2,ia)
               hsr = fr1(j1,u,ispin)*fr2(j2,v,ispin) + fi1(j1,u,ispin)*fi2(j2,v,ispin)
               hsi = fr1(j1,u,ispin)*fi2(j2,v,ispin) - fi1(j1,u,ispin)*fr2(j2,v,ispin)
               mr = mr + ftqer(lmt1,lmt2,ia)*hsr-ftqei(lmt1,lmt2,ia)*hsi
               mi = mi + ftqei(lmt1,lmt2,ia)*hsr+ftqer(lmt1,lmt2,ia)*hsi
               ! debug
               !if(printable) then
               !  write(nfout,*) '---- ftqe & hs ----'
               !  write(nfout,*) 'lmt1 = ',lmt1
               !  write(nfout,*) 'lmt2 = ',lmt2
               !  write(nfout,*) 'ftqe = ',ftqer(lmt1,lmt2,ia),ftqei(lmt1,lmt2,ia)
               !  write(nfout,*) 'hs   = ',hsr,hsi
               !end if
               ! end debug
            end do LMT_2
         end do LMT_1
      end do ATOM

    end subroutine add_deficit_term

  end subroutine m_BP_calc_det

  subroutine copy_old_wfbp_to_temp_wfbp(kg,old_wfbp,temp_wfbp)
! === DEBUG by T.Kato 2013/07/11 ===============================================
    !use m_Electronic_Structure, only : neg, neordr
    use m_Electronic_Structure, only : neordr
    use m_Control_Parameters, only : neg
! ==============================================================================
    integer, intent(in) :: kg
    real(kind=DP), intent(in) :: old_wfbp(kg,np_e,2,nspin)
    real(kind=DP), intent(out) :: temp_wfbp(kg,nstate,2,nspin)

! local variables
    real(kind=DP), allocatable :: tmp(:,:,:,:)
    integer :: datasize,ie,je,j
    integer :: is,ik

    !datasize = kg*mp_e*2*nspin
    !allocate(tmp(kg,mp_e,2,nspin)); tmp = 0.d0 ! MPI

    ! debug
    !if(printable) then
    !  write(nfout,*) 'copy wfbp to tmp'
    !  write(nfout,*) 'kg=',kg
    !  write(nfout,*) 'mp_e=',mp_e
    !  write(nfout,*) 'datasize = ', datasize
    !end if
    ! end debug

    !call mpi_barrier(mpi_comm_group,ierr)
    temp_wfbp = 0.d0
    do is=1,nspin
       ik = is
       do ie=1,neg
          if (map_ek(ie,ik) /= myrank_ke) cycle
          je = neordr(ie,ik)
          if(je > nstate) cycle
          temp_wfbp(1:kg,je,1:2,is) = old_wfbp(1:kg,map_z(ie),1:2,is)
       enddo
    enddo
    call mpi_allreduce(MPI_IN_PLACE,temp_wfbp,kg*nstate*2*nspin,mpi_double_precision,mpi_sum,mpi_g_world,ierr)
    !do j=0,nrank_e-1
    !   if(j==myrank_e) tmp(1:kg,1:np_e,1:2,1:nspin) = old_wfbp(1:kg,1:np_e,1:2,1:nspin)
    !   call mpi_bcast(tmp(1,1,1,1),datasize,mpi_double_precision &
    !        & ,j,mpi_k_world(myrank_k),ierr)
    !   do is=1,nspin
    !      ik=is
    !      do ie = 1, nel_e(j)
    !         je = nis_e(j)-1+ie
    !         je = neordr(je,ik)
    !         if(je > nstate) cycle
    !         temp_wfbp(1:kg,je,1:2,is) = tmp(1:kg,ie,1:2,is)
    !      end do
    !   end do
    !   call mpi_barrier(mpi_comm_group,ierr)
    !end do

    !deallocate(tmp)

!    call mpi_barrier(mpi_comm_group,ierr)

  end subroutine copy_old_wfbp_to_temp_wfbp

  subroutine copy_old_fs_to_temp_fs(old_fsr,old_fsi,temp_fsr,temp_fsi)
! === DEBUG by T.Kato 2013/07/11 ===============================================
    !use m_Electronic_Structure, only : neg, neordr
    use m_Electronic_Structure, only : neordr
    use m_Control_Parameters, only : neg
! ==============================================================================
    use m_PseudoPotential,     only : nlmta
    real(kind=DP), intent(in) :: old_fsr(np_e,nlmta,nspin),old_fsi(np_e,nlmta,nspin)
    real(kind=DP), intent(out) :: temp_fsr(nstate,nlmta,nspin),temp_fsi(nstate,nlmta,nspin)

    ! local variables
    real(kind=DP), allocatable :: tmp(:,:,:,:)
    integer :: datasize,ie,je,j
    integer :: is,ik

    temp_fsr = 0.d0;temp_fsi = 0.d0
    do is=1,nspin
       ik = is
       do ie=1,neg
          if (map_ek(ie,ik) /= myrank_ke) cycle
          je = neordr(ie,ik)
          if(je > nstate) cycle
          temp_fsr(je,1:nlmta,is) = old_fsr(map_z(ie),1:nlmta,is)
          temp_fsi(je,1:nlmta,is) = old_fsi(map_z(ie),1:nlmta,is)
       enddo
    enddo
    call mpi_allreduce(MPI_IN_PLACE,temp_fsr,nstate*nlmta*nspin,mpi_double_precision,mpi_sum,mpi_g_world,ierr)
    call mpi_allreduce(MPI_IN_PLACE,temp_fsi,nstate*nlmta*nspin,mpi_double_precision,mpi_sum,mpi_g_world,ierr)
!    datasize = mp_e*nlmta*2*nspin
!    allocate(tmp(mp_e,nlmta,2,nspin)); tmp = 0.d0 ! MPI

    ! debug
    !if(printable) then
    !  write(nfout,*) 'copy fsr,fsi to tmp'
    !  write(nfout,*) 'mp_e=',mp_e
    !  write(nfout,*) 'nlmta =',nlmta
    !  write(nfout,*) 'datasize = ', datasize
    !end if
    ! end debug

!    call mpi_barrier(mpi_comm_group,ierr)
!
!    do j=0,nrank_e-1
!       if(j==myrank_e) then
!          tmp(1:np_e,1:nlmta,1,1:nspin) = old_fsr(1:np_e,1:nlmta,1:nspin)
!          tmp(1:np_e,1:nlmta,2,1:nspin) = old_fsi(1:np_e,1:nlmta,1:nspin)
!       end if
!       call mpi_bcast(tmp(1,1,1,1),datasize,mpi_double_precision &
!            & ,j,mpi_k_world(myrank_k),ierr)
!       do is=1,nspin
!          ik=is
!          do ie = 1, nel_e(j)
!             je = nis_e(j)-1+ie
!             je = neordr(je,ik)
!             if(je > nstate) cycle
!             temp_fsr(je,1:nlmta,is) = tmp(ie,1:nlmta,1,is)
!             temp_fsi(je,1:nlmta,is) = tmp(ie,1:nlmta,2,is)
!          end do
!       end do
!       call mpi_barrier(mpi_comm_group,ierr)
!!    end do
!
!    deallocate(tmp)

  end subroutine copy_old_fs_to_temp_fs

  subroutine constract_of_ftq()
    use m_Const_Parameters,    only : SKIP,zi
    use m_Ionic_System,        only : natm, ityp
    use m_PseudoPotential,     only : index_lmt1_lmt2,lmta &
         &                        , ltp,mtp,taup,ilmt,nlmt &
         &                        , qitg_BP,iqitg,isph,il2p,dl2p &
         &                        , n_non0_lmtxlmt &
         &                        , m_PP_include_vanderbilt_pot &
         &                        , m_PP_find_maximum_l

! local varialbes
    integer :: ia,it,ik,ip,lmt1,lmt2,u,v
    real(kind=DP) :: fac
    integer :: il1,il2,tau1,tau2,l3
    integer :: n,ilm3,iiqitg
    real(kind=DP) :: dk(3),ylm,dga
    real(kind=DP) :: ftqr,ftqi,ftqb
    integer :: mdvdb
    integer, allocatable :: il3(:)

    call m_PP_find_maximum_l(n)   !  n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)

    allocate(ftqer(nlmt,nlmt,natm)); ftqer=0.d0
    allocate(ftqei(nlmt,nlmt,natm)); ftqei=0.d0

    dk(1:3) = g(1:3) /dble(jpara) *PAI2

    if(ipriberry > 0.and.printable) then
       write(nfout,*) '<< Construction of Qlmt(dk): start >>'
       write(nfout,*) 'dk = ', dk(1:3)
    end if
    ! debug
    !  do ia=1,natm
    !    it = ityp(ia)
    !    if(printable) write(nfout,'("ia=",i3," it=",i3)') ia,it
    !    do ip=1,n_non0_lmtxlmt(it)
    !    lmt1 = index_lmt1_lmt2(ip,it,1)
    !      il1 = ltp(lmt1,it)
    !      tau1 = taup(lmt1,it)
    !      lmt2 = index_lmt1_lmt2(ip,it,2)
    !      il2 = ltp(lmt2,it)
    !      tau2 = taup(lmt2,it)
    !      do n=1,il2p(lmt1,lmt2,it)
    !        ilm3 = isph(lmt1,lmt2,n,it); l3=il3(ilm3)
    !        iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
    !        if(printable) write(nfout,'("lmt1=",i3,"lmt2=",i3,"n=",i3,"q_BP=",f10.5))') lmt1,lmt2,n,qitg_BP(1,iiqitg)
    !      end do
    !    end do
    !  end do
    ! end debug

    ATOM: do ia = 1, natm
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle ATOM
       ! debug
       !  if(printable) write(nfout,*) 'ia=',ia,' it=',it
       ! end debug

       LMT_1: do lmt1=1,ilmt(it)
          il1 = ltp(lmt1,it)
          tau1 = taup(lmt1,it)
          LMT_2: do lmt2=lmt1,ilmt(it)
             il2 = ltp(lmt2,it)
             tau2 = taup(lmt2,it)
             ! debug
             !if(printable) then
             !  write(nfout,*) 'lmt1 = ',lmt1
             !  write(nfout,*) 'lmt2 = ',lmt2
             !end if
             ! end debug

             ftqr = 0.d0
             ftqi = 0.d0
             LM3: do n=1,il2p(lmt1,lmt2,it)
                ilm3 = isph(lmt1,lmt2,n,it); l3=il3(ilm3)
                iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                if(iiqitg == 0) cycle LM3
                call sphrp2_for_Berry(ilm3,dk,ylm)
                ftqb = qitg_BP(1,iiqitg)*dl2p(lmt1,lmt2,n,it)*ylm

                ! debug
                !if(printable) then
                !  write(nfout,*) '---- n = ',n,' ----'
                !  write(nfout,*) 'l3 = ',l3
                !  write(nfout,*) 'qitg_BP = ',qitg_BP(1,iiqitg)
                !  write(nfout,*) 'dl2p    = ',dl2p(lmt1,lmt2,n,it)
                !  write(nfout,*) 'ylm     = ',ylm
                !  write(nfout,*) 'ftqb    = ',ftqb
                !end if
                ! end debug
                if(mod(l3,2)==0) then
                   ftqr=ftqr+real(zi**(-l3))*ftqb
                else
                   ftqi=ftqi+dimag(zi**(-l3))*ftqb
                end if
             end do LM3
             ! remove exponetal factor
             !ftqer(lmt1,lmt2,ia) = ftqr*zfcos(ia)+ftqi*zfsin(ia)

             ftqer(lmt1,lmt2,ia) = ftqr
             ftqer(lmt2,lmt1,ia) = ftqer(lmt1,lmt2,ia)

             !ftqei(lmt1,lmt2,ia) = ftqi*zfcos(ia)-ftqr*zfsin(ia)
             ftqei(lmt1,lmt2,ia) = ftqi
             ftqei(lmt2,lmt1,ia) = ftqei(lmt1,lmt2,ia)

             ! debug
             !if(printable) then
             !  write(nfout,*) '---- ftqe ----'
             !  write(nfout,*) 'ftq  = ',ftqr,ftqi
             !  write(nfout,*) '(zfcos,zfsin) = ',zfcos(ia),zfsin(ia)
             !  write(nfout,*) 'ftqe = ',ftqer(lmt1,lmt2,ia),ftqei(lmt1,lmt2,ia)
             !end if
             ! end debug
          end do LMT_2
       end do LMT_1
    end do ATOM

    deallocate(il3)

    if(ipriberry > 0.and.printable) then
       write(nfout,*) '<< Constuction of Qlmt(dk): end >>'
    end if

  end subroutine constract_of_ftq

  subroutine BP_line_integral(phi,cphi,ikprep,ispin)
    implicit none
    real(kind=DP), intent(out) :: phi
    complex(kind=DP), intent(out) :: cphi
    integer, intent(in) :: ikprep, ispin

! local variables
    integer :: k

    cphi = cmplx(1.d0,0.d0)
    do k=1,jpara
       if(printable) write(nfout,'(1x,"Det = ",e25.12," + i ",e25.12)') &
            &                             det(k,ikprep,ispin)
       cphi = cphi*det(k,ikprep,ispin)
    end do

    phi = dimag(log(cphi))

    if(printable) then
       write(nfout,'("cphi = ",e25.12,1x,e25.12)') cphi
       write(nfout,'("phi = ",e25.12)') phi
    end if

  end subroutine BP_line_integral

  subroutine m_BP_Polarization()
    use m_Files, only : nfout, nfzaj
    use m_Electronic_Structure, only : zaj_l, occup_l
    use m_Crystal_Structure, only : univol
    use m_Control_Parameters, only : nspin
    use m_Ionic_System,        only : pos,natm

! =============================== KT_add =================== 13.0C
    use m_Ionic_System,        only : ityp
    use m_PseudoPotential, only : ival
! ========================================================== 13.0C

    implicit none

! local variables
    integer :: i,is,ia, ismax
    real(kind=DP) :: glen, polar, dir(3)
    real(kind=DP), allocatable :: phi(:,:) ! dim(nkprep)
    complex(kind=DP), allocatable :: cphi(:,:) ! dim(nkprep)
    real(kind=DP) :: fac
    real(kind=DP) :: berry_phase, berry_ion, berry_tot
    real(kind=DP) :: polar_ele, polar_ion, polar_tot, polar_max

    if(mype /= 0) return ! MPI

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    allocate(phi(nkprep,ismax),cphi(nkprep,ismax))

    do is=1,ismax
       do i=1,nkprep
          if(printable) &
               & write(nfout,'("is=",i3," ik=",i3," kprep=",2(1x,f10.5))') &
               & is,i,kvec(1:2,i*jpara)
          call BP_line_integral(phi(i,is),cphi(i,is),i,is)
       end do
    end do
    glen = sqrt(sum(g(1:3)**2))

! =============================== KT_add  =================== 13.0C
    berry_phase = 0.0d0
! =========================================================== 13.0C

    do is = 1, ismax
       berry_phase = berry_phase + sum(phi(1:nkprep,is)*wgh(1:nkprep))
    end do

    fac = 2.d0/dble(nspin)
! === KT_Add === 2015/03/23
    if ( noncol ) fac = 2.d0/dble(nspin /ndim_spinor)    !!! to be checked
! ============== 2015/03/23

    berry_phase = fac*berry_phase
    berry_phase = 4.d0*atan(tan(0.25d0*berry_phase))
    polar_ele = berry_phase/(univol*glen*PAI2)
    berry_ion = 0.d0

    do ia=1,natm
! ============================ KT_mod =================== 13.0C
!       berry_ion = berry_ion + pos(ia,ig)
       berry_ion = berry_ion + ival(ityp(ia)) *pos(ia,ig)
! ======================================================= 13.0C
    end do

    berry_ion = PAI2*berry_ion
    berry_ion = 4.d0*atan(tan(0.25d0*berry_ion))
    polar_ion = berry_ion/(univol*glen*PAI2)
    berry_tot = 4.d0*atan(tan(0.25d0*(berry_ion+berry_phase)))
    polar_tot = berry_tot/(univol*glen*PAI2)
    polar_max = 1.d0/(univol*glen)

    if(printable) then
       write(nfout,'("<< Results of Berry phase calc.")')

       do i=1,nkprep
          write(nfout,'("ik=",i3," kprep=",2(1x,f10.5))') i,kvec(1:2,i*jpara)
       end do
       write(nfout,'(1x,3x,"is",3x,"k",13x,"phi",18x,"wgh")')

       do is=1, ismax
          do i=1,nkprep
             write(nfout,'(1x,i4,1x,i4,2(1x,f20.10))') is,i,phi(i,is),wgh(i)
          end do
       end do

       dir(1:3) = g(1:3)/glen
       write(nfout,'(1x,"Unit cell volume        =",1x,e25.14)') univol
       write(nfout,'(1x,"direction of G          =",3(1x,e25.14))') dir(1:3)
       write(nfout,'(1x,"Berry phase (ele)       =",1x,e25.14)') berry_phase
       write(nfout,'(1x,"Berry phase (ion)       =",1x,e25.14)') berry_ion
       write(nfout,'(1x,"Berry phase (total)     =",1x,e25.14)') berry_tot
       write(nfout,'(1x,"Electronic polarization =",1x,e25.14)') polar_ele
       write(nfout,'(1x,"Ionic polarization      =",1x,e25.14)') polar_ion
       write(nfout,'(1x,"Total polarization      =",1x,e25.14)') polar_tot
       write(nfout,'(1x,"Maximun polarization    =",1x,e25.14)') polar_max

       write(nfout,'("   Results of Berry phase calc.>>")')
    end if

    call m_BP_write_Berry_phase(cphi,phi,nkprep)

    deallocate(phi)

  end subroutine m_BP_Polarization

  subroutine m_BP_write_Berry_phase(cphi,phi,nkprep)
    use m_Files, only : nfout, nfberry, m_Files_open_nfberry
    use m_Ionic_System, only : displaced_atom,displacement,pos,natm
    use m_Crystal_Structure, only : strain, sw_strained_cell
    implicit none
    integer, intent(in) :: nkprep
    complex(kind=DP), intent(in) :: cphi(nkprep,nspin)
    real(kind=DP), intent(in) :: phi(nkprep,nspin)

! local variables
    integer :: i,ia,is, ismax

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    call m_Files_open_nfberry()
    write(nfberry,'(3(1x,i5),3(1x,e25.14))') nkprep,ig,displaced_atom,displacement(1:3)

    do is=1, ismax
       do i=1,nkprep
          write(nfberry,'(i5,4(1x,e25.14))') i,cphi(i,is),phi(i,is),wgh(i)
       end do
    end do
    if(sw_strained_cell == ON) then
       write(nfberry,'(3(1x,e25.14))') strain(1,1:3)
       write(nfberry,'(3(1x,e25.14))') strain(2,1:3)
       write(nfberry,'(3(1x,e25.14))') strain(3,1:3)
       write(nfberry,*) natm
       do ia=1,natm
          write(nfberry,'(i7,3(1x,e25.14))') ia,pos(ia,1:3)
       end do
    end if

  end subroutine m_BP_write_Berry_phase

  subroutine m_BP_write_wfbp
    use m_Files, only : nfout, nfzaj
    use m_PlaneWaveBasisSet, only : nbase, iba, kgp, kg
    use m_Electronic_Structure, only : totch, zaj_l
    use m_Control_Parameters, only : nspin


    implicit none

! local variables
    integer :: jj,n,j,jmax,ik,ierr
    real(kind=DP), allocatable, dimension(:,:,:,:) :: zajtmp

    ! debug
    !integer :: is
    !real(kind=DP) :: norm,defi
    ! end debug

    if(nstate <= 0) nstate = int(totch + 1.d-13)/2

    if(sw_deficit == ON) then
       !  if(ikp==0) then
       if(ikp0) then
          call calc_phase_for_Berry()
          call constract_of_ftq()
          ikp0 = .false.
       end if
       call m_BP_save_betar_dot_WFs()
    end if

    if(allocated(wfbp2)) then
       if(allocated(wfbp1)) deallocate(wfbp1)
       kgbp1 = kgbp2
       allocate(wfbp1(kgbp1,np_e,2,nspin))
       wfbp1 = wfbp2
       deallocate(wfbp2)
    end if

    kgbp2 = nbase(iba(1),1)
    allocate(wfbp2(kgbp2,np_e,2,nspin))
    allocate(zajtmp(kg,np_e,nspin,2));zajtmp=0.d0
    do n=1,np_e
       do ik=1,nspin
          do j=ista_g1k(ik),iend_g1k(ik)
             zajtmp(j,n,ik,1) = zaj_l(j-ista_g1k(ik)+1,n,ik,1)
             zajtmp(j,n,ik,2) = zaj_l(j-ista_g1k(ik)+1,n,ik,2)
          enddo
       enddo
    enddo
    call mpi_allreduce(MPI_IN_PLACE,zajtmp,kg*np_e*2*nspin,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)

    if(printable) then
       write(nfout,'("<< Writing Wavefunctions for Berry Phase calc. >>")')
       !write(nfout,*) 'debug iba=',iba(1)
       !write(nfout,*) 'debug kgbp2=',kgbp2
    end if
    do n=1,np_e
       !if(printable) write(nfout,'(1x,"n=",i3)') n
       jj=1
       do j=1,kgbp2
          if(nbase(jj,1) == j) then
    !         wfbp2(j,n,1,1:nspin) = zaj_l(jj,n,1:nspin,1)
    !         wfbp2(j,n,2,1:nspin) = zaj_l(jj,n,1:nspin,2)
             wfbp2(j,n,1,1:nspin) = zajtmp(jj,n,1:nspin,1)
             wfbp2(j,n,2,1:nspin) = zajtmp(jj,n,1:nspin,2)
             jj = jj + 1
          else
             wfbp2(j,n,1,1:nspin) = 0.d0
             wfbp2(j,n,2,1:nspin) = 0.d0
          end if
          ! debug
          !if(j < 21.and.printable) write(nfout,'("j=",i2,"wfbp=",2(1x,f10.5))') &
          !   & j,wfbp2(j,n,1,is),wfbp2(j,n,2,is)
          ! end debug
       end do
    end do

    ! debug
    !if(printable) then
    !write(nfout,*) 'berry check norm: kgbp2=',kgbp2
    !do is=1,nspin
    !do n=1,np_e
    !  defi = norm_deficit(n,is)
    !  write(nfout,'(1x,"n=",i3," defi = ",f15.10)') n,defi
    !  norm = 0.d0
    !  do j=1,kgbp2
    !    norm = norm + wfbp2(j,n,1)**2 + wfbp2(j,n,2)**2
    !  end do
    !  write(nfout,'(1x,"n=",i3," norm = ",f10.5)') n,norm
    !  write(nfout,'(1x,"n=",i3," total norm = ",f15.10)') n,norm+defi
    !end do
    !end do
    !call mpi_barrier(mpi_comm_group,ierr)
    !end if
    ! end debug

    if((jpara>1 .and. mod(ikp,jpara) /= 0) .or. jpara==1)  &
         & call m_BP_calc_det()

    ikp = ikp + 1
    deallocate(zajtmp)
  contains

    function norm_deficit(n,is) result(norm)
      use m_PseudoPotential,     only : nlmta
      use m_Electronic_Structure,only : fsr_l,fsi_l ! dim(np_e,nlmta,ista_k:iend_k)
      use m_Ionic_System,        only : natm, ityp
      use m_PseudoPotential,     only : n_non0_lmtxlmt,index_lmt1_lmt2,lmta &
           &                          , ltp,mtp,ilmt,q

      real(kind=DP) :: norm ! a result

      integer, intent(in) :: n ! a band index
      integer, intent(in) :: is ! a spin index

! local varialbes
      integer :: ia,it,ik,ip,lmt1,lmt2,u,v
      real(kind=DP) :: eps = 1.d-13
      real(kind=DP) :: fac
      real(kind=DP), allocatable, dimension(:,:) :: fsr2d,fsi2d

      norm = 0.d0

      ik=is ! for ekcal mode
      allocate(fsr2d(np_e,nlmta));fsr2d=0.d0
      allocate(fsi2d(np_e,nlmta));fsi2d=0.d0
      call gather_f_3d_to_2d(fsr_l,fsr2d,ik)
      call gather_f_3d_to_2d(fsi_l,fsi2d,ik)
      do ia = 1, natm
         it = ityp(ia)
         ! debug
         !  if(printable) write(nfout,*) 'n_non0_lmtxlmt = ',n_non0_lmtxlmt(it)
         ! end debug
         LMT: do ip = 1, n_non0_lmtxlmt(it)
            lmt1 = index_lmt1_lmt2(ip,it,1)
            lmt2 = index_lmt1_lmt2(ip,it,2)
            ! debug
            !if(printable) then
            !  write(nfout,*) 'lmt1 = ',lmt1
            !  write(nfout,*) 'lmt2 = ',lmt2
            !end if
            ! end debug

            if(lmt2 < lmt1) cycle LMT
            u = lmta(lmt1,ia)
            v = lmta(lmt2,ia)
            if(ltp(lmt1,it) /= ltp(lmt2,it) .or. &
                 & mtp(lmt1,it) /= mtp(lmt2,it) ) cycle LMT
            fac = q(lmt1,lmt2,it)
            if(abs(fac) < eps) cycle LMT
            if(lmt1 /= lmt2) fac=2.d0*fac

            ! debug
            !if(printable) then
            !  write(nfout,*) 'u = ',u
            !  write(nfout,*) 'v = ',v
            !  write(nfout,*) 'fsr = ',fsr_l(n,u,ik)
            !  write(nfout,*) 'fsi = ',fsi_l(n,v,ik)
            !  write(nfout,*) 'q = ',q(lmt1,lmt2,it)
            !end if
            ! end debug
            norm = norm + &
                 & fac*(fsr2d(n,u)*fsr2d(n,v)+fsi2d(n,u)*fsi2d(n,v))
         end do LMT
      end do
      deallocate(fsr2d)
      deallocate(fsi2d)
    end function norm_deficit

  end subroutine m_BP_write_wfbp

  subroutine gather_f_3d_to_2d(in, out, ik)
    use m_PseudoPotential, only : nlmta
    use m_Parallelization, only : np_fs,nrank_g
    implicit none
    real(kind=DP), dimension(np_e, np_fs,ista_k:iend_k), intent(in)  :: in  !in_3D
    real(kind=DP), dimension(np_e, nlmta),                        intent(out) :: out !out_2D
    integer, intent(in) :: ik
    integer(kind=4) :: ierr, i
    integer :: sendcount, recvcounts(0:nrank_g-1), displs(0:nrank_g-1)
    sendcount = np_e*np_fs
    do i = 0, nrank_g - 1
       recvcounts(i) = np_e*nel_fs(i)
       displs(i)     = np_e*(nis_fs(i) - 1)
    enddo

    out=0.d0
    call mpi_allgatherv(in(1,1,ik),sendcount,        MPI_DOUBLE_PRECISION, &
                        out(1,1),  recvcounts,displs,MPI_DOUBLE_PRECISION,mpi_ke_world,ierr)
    end subroutine gather_f_3d_to_2d

  subroutine m_BP_write_wfbp_gshift
    use m_Files, only : nfout, nfzaj
    use m_PlaneWaveBasisSet, only : kgp, kg, ngabc_kngp_l, nbase, iba
    use m_Electronic_Structure, only : totch, zaj_l
    use m_Control_Parameters, only : nspin
    implicit none

! local variables
    integer :: jj,n,i,j,k,jmax,ik,ierr
    integer :: igs(3)
    integer :: iga,igb,igc,jga,jgb,jgc
    real(kind=DP), allocatable, dimension(:,:,:,:) :: zajtmp
    integer,allocatable,dimension(:,:) :: ngabc_kngp

    ! debug
    !real(kind=DP) :: norm
    ! end debug

    if(mod(ikp,jpara)/=0) return

    allocate(ngabc_kngp(kgp,3));ngabc_kngp=0.0
    do i=ista_kngp,iend_kngp
       ngabc_kngp(i,:) = ngabc_kngp_l(i,:)
    enddo
    call mpi_allreduce(mpi_in_place,ngabc_kngp,kgp*3,mpi_integer,mpi_sum &
            &            ,mpi_chg_world,ierr)

    if(nstate <= 0) nstate = int(totch + 1.d-13)/2

    igs(1:3) = 0
    do i=1,3
       if(i == ig) igs(i) = 1
    end do

    kgbp0 = 1
    jj=1
    if(printable) then
       write(nfout,'("<< Writing Wavefunctions for Berry Phase calc. >>")')
       !write(nfout,*) 'debug kgp=',kgp
       !write(nfout,*) 'debug iba=',iba(1)
    end if
    loop_i: do i=1,kgp
       iga = ngabc_kngp(i,1)+igs(1)
       igb = ngabc_kngp(i,2)+igs(2)
       igc = ngabc_kngp(i,3)+igs(3)
       if(jj>iba(1)) then
          kgbp0 =i-1
          exit loop_i
       end if
       loop_j: do j=1,iba(1)
          k=nbase(j,1)
          jga = ngabc_kngp(k,1)
          jgb = ngabc_kngp(k,2)
          jgc = ngabc_kngp(k,3)
          if(iga == jga .and. igb == jgb .and. igc == jgc) then
             jj=jj+1
             exit loop_j
          end if
       end do loop_j
    end do loop_i

    !if(printable) then
    !write(nfout,*) 'debug jj=',jj
    !write(nfout,*) 'debug kgbp0=',kgbp0
    !end if

    allocate(wfbp0(kgbp0,np_e,2,nspin)); wfbp0 = 0.d0
    allocate(zajtmp(kg,np_e,nspin,2));zajtmp=0.d0
    do n=1,np_e
       do ik=1,nspin
          do j=ista_g1k(ik),iend_g1k(ik)
             zajtmp(j,n,ik,1) = zaj_l(j-ista_g1k(ik)+1,n,ik,1)
             zajtmp(j,n,ik,2) = zaj_l(j-ista_g1k(ik)+1,n,ik,2)
          enddo
       enddo
    enddo
    call mpi_allreduce(MPI_IN_PLACE,zajtmp,kg*np_e*2*nspin,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
    do n=1,np_e
       loop_i2: do i=1,kgbp0
          iga = ngabc_kngp(i,1)+igs(1)
          igb = ngabc_kngp(i,2)+igs(2)
          igc = ngabc_kngp(i,3)+igs(3)
          loop_j2: do j=1,iba(1)
             k=nbase(j,1)
             jga = ngabc_kngp(k,1)
             jgb = ngabc_kngp(k,2)
             jgc = ngabc_kngp(k,3)
             if(iga == jga .and. igb == jgb .and. igc == jgc) then
                !wfbp0(i,n,1,1:nspin) = zaj_l(j,n,1:nspin,1)
                !wfbp0(i,n,2,1:nspin) = zaj_l(j,n,1:nspin,2)
                wfbp0(i,n,1,1:nspin) = zajtmp(j,n,1:nspin,1)
                wfbp0(i,n,2,1:nspin) = zajtmp(j,n,1:nspin,2)
                exit loop_j2
             end if
          end do loop_j2
       end do loop_i2
       ! debug
       !if(printable) then
       !do j=1,20
       !  write(nfout,'("j=",i2,"wfbp0=",2(1x,f10.5))') &
       !     & j,wfbp0(j,n,1),wfbp0(j,n,2)
       !end do
       !end if
       ! end debug
    end do
    call mpi_barrier(mpi_comm_group,ierr)
    deallocate(zajtmp)
    deallocate(ngabc_kngp)
    ! debug
    !if(printable) then
    !write(nfout,*) 'berry check norm (gshift): kgbp0=',kgbp0
    !do n=1,np_e
    !  norm = 0.d0
    !  do j=1,kgbp0
    !    norm = norm + wfbp0(j,n,1)**2 + wfbp0(j,n,2)**2
    !  end do
    !  write(nfout,'(1x,"n=",i3," norm = ",f10.5)') n,norm
    !end do
    !call mpi_barrier(mpi_comm_group,ierr)
    !end if
    ! end debug

  end subroutine m_BP_write_wfbp_gshift

  subroutine m_BP_save_betar_dot_WFs
    use m_Electronic_Structure,only : fsr_l, fsi_l ! dim(np_e,nlmta,ista_k:iend_k)
    use m_PseudoPotential,     only : nlmta, lmta, ilmt
    use m_Ionic_System,        only : natm, ityp
    implicit none

! local variables
    integer :: ik,ia,i,j,n,nkp,ikprep,is
    real(kind=DP), allocatable, dimension(:,:) :: fsr2d,fsi2d

    ik=1 ! for ekcal mode
    nkp = mod(ikp,jpara) +1
    ikprep = ikp /jpara +1

    ! debug
    !if(printable) then
    !  write(nfout,*) 'debug(m_BP_save_betar_dot_WFs)'
    !  write(nfout,*) 'nstate=',nstate
    !  write(nfout,*) 'nlmta=',nlmta
    !  write(nfout,*) 'jpara=',jpara
    !  write(nfout,*) 'nkp=',nkp
    !  write(nfout,*) 'ikprep=',ikprep
    !end if
    ! end debug
    allocate(fsr2d(np_e,nlmta));fsr2d=0.d0
    allocate(fsi2d(np_e,nlmta));fsi2d=0.d0

    if(allocated(fsr_k2)) then
       if(allocated(fsr_k1)) deallocate(fsr_k1,fsi_k1)
       allocate(fsr_k1(np_e,nlmta,nspin),fsi_k1(np_e,nlmta,nspin))
       fsr_k1 = fsr_k2
       fsi_k1 = fsi_k2
       deallocate(fsr_k2,fsi_k2)
    end if

    allocate(fsr_k2(np_e,nlmta,nspin),fsi_k2(np_e,nlmta,nspin))
    do is=1,nspin
       call gather_f_3d_to_2d(fsr_l,fsr2d,is)
       call gather_f_3d_to_2d(fsi_l,fsi2d,is)
       do i=1,nlmta
          do n=1,np_e
             fsr_k2(n,i,is) = fsr2d(n,i)
             fsi_k2(n,i,is) = fsi2d(n,i)
          end do
       end do
    end do
    if(nkp == 1) then
       allocate(fsr_k0(np_e,nlmta,nspin),fsi_k0(np_e,nlmta,nspin))
       do is=1,nspin
          call gather_f_3d_to_2d(fsr_l,fsr2d,is)
          call gather_f_3d_to_2d(fsi_l,fsi2d,is)
          do ia=1,natm
             do j=1,ilmt(ityp(ia))
                i=lmta(j,ia)
                do n=1,np_e
                   fsr_k0(n,i,is) = fsr2d(n,i)*zfcos(ia)+fsi2d(n,i)*zfsin(ia)
                   fsi_k0(n,i,is) = fsi2d(n,i)*zfcos(ia)-fsr2d(n,i)*zfsin(ia)
                end do
             end do
          end do
       end do
    end if

    deallocate(fsr2d)
    deallocate(fsi2d)

  end subroutine m_BP_save_betar_dot_WFs

  subroutine determinant(n,mr,mi,det)
    implicit none
    integer, intent(in) :: n
    real(kind=DP), intent(inout) :: mr(n,n),mi(n,n)
    complex(kind=DP), intent(out) :: det

! local variables
    integer :: i,pivot(n),parity
    real(kind=DP) :: dr,di,dt

    ! debug
    !if(printable) then
    !write(nfout,'("before LU decomposition")')
    !write(nfout,'("real part:")')
    !do i=1,n
    !   write(nfout,'(50(1x,e25.12))') mr(i,1:n)
    !end do
    !write(nfout,'("imag part:")')
    !do i=1,n
    !   write(nfout,'(50(1x,e25.12))') mi(i,1:n)
    !end do
    !end if
    ! end debug

    call LU_decomposition(n,mr,mi,pivot,parity)

    ! debug
    !if(printable) then
    !write(nfout,'("after LU decomposition")')
    !write(nfout,'("real part:")')
    !do i=1,n
    !   write(nfout,'(50(1x,e25.12))') mr(i,1:n)
    !end do
    !write(nfout,'("imag part:")')
    !do i=1,n
    !   write(nfout,'(50(1x,e25.12))') mi(i,1:n)
    !end do
    !end if
    ! end debug

    dr=1.d0
    di=0.d0
    do i=1,n
       ! debug
       !if(printable) write(nfout,'(1x,i3," mr=",e25.12," mi=",e25.12)') i,mr(i,i),mi(i,i)
       ! end debug
       dt = dr*mr(i,i) - di*mi(i,i)
       di = di*mr(i,i) + dr*mi(i,i)
       dr = dt
    end do
    det = cmplx(dr,di)
    det = parity*det

  end subroutine determinant

  subroutine LU_decomposition(n,mr,mi,pivot,parity)
    implicit none
    integer, intent(in) :: n
    real(kind=DP), intent(inout) :: mr(n,n),mi(n,n)
    integer, intent(out) :: pivot(n),parity

! local variables
    integer :: i,j,k,imax
    real(kind=DP) :: big,scaling(n)
    real(kind=DP) :: t,dr,di
    real(kind=DP) :: sumr,sumi,mt

    real(kind=DP), parameter :: eps = 3.5d-15

    parity = 1

    do i=1,n
       big = 0.d0
       do j=1,n
          t = sqrt( mr(i,j)**2 + mi(i,j)**2 )
          if(t > big)  big = t
       end do
       if(big == 0.d0) then
          if(printable) then
             write(nfout,*) 'Error(LU_decomposition): Singular matrix'
             write(nfout,*) 'i=',i
          end if
          call phase_error_with_msg(nfout,'LU_decomposition',__LINE__,__FILE__)
       else
          scaling(i) = 1.d0/big
       end if
    end do

    do j=1,n
       do i=1,j-1
          sumr=0.d0
          sumi=0.d0
          do k=1,i-1
             sumr = sumr + ( mr(i,k)*mr(k,j) - mi(i,k)*mi(k,j) )
             sumi = sumi + ( mi(i,k)*mr(k,j) + mr(i,k)*mi(k,j) )
          end do
          mr(i,j) = mr(i,j) - sumr
          mi(i,j) = mi(i,j) - sumi
       end do
       big = 0.d0
       do i=j,n
          sumr=0.d0
          sumi=0.d0
          do k=1,j-1
             sumr = sumr + ( mr(i,k)*mr(k,j) - mi(i,k)*mi(k,j) )
             sumi = sumi + ( mi(i,k)*mr(k,j) + mr(i,k)*mi(k,j) )
          end do
          sumr = mr(i,j) - sumr
          sumi = mi(i,j) - sumi
          t = scaling(i)*sqrt(sumr**2+sumi**2)
          if( t >= big) then
             big = t
             imax = i
          end if
          mr(i,j) = sumr
          mi(i,j) = sumi
       end do
       if(j /= imax) then
          do k=1,n
             dr = mr(imax,k)
             di = mi(imax,k)
             mr(imax,k) = mr(j,k)
             mi(imax,k) = mi(j,k)
             mr(j,k) = dr
             mi(j,k) = di
          end do
          parity = -parity
          scaling(imax) = scaling(j)
       end if
       pivot(j) = imax
       if( dsqrt(mr(j,j)**2+mi(j,j)**2) < eps ) then
          mr(j,j) = 0.d0
          mi(j,j) = 0.d0
       end if
       if(j /= n ) then
          t  =  mr(j,j)**2 + mi(j,j)**2
          dr =  mr(j,j)/t
          di = -mi(j,j)/t
          do i=j+1,n
             mt      = mr(i,j)*dr - mi(i,j)*di
             mi(i,j) = mi(i,j)*dr + mr(i,j)*di
             mr(i,j) = mt
          end do
       end if
    end do

  end subroutine LU_decomposition

  subroutine m_BP_wd_cntn_data()
    use m_Files, only : nfcntn_berry,m_Files_open_nfcntn_berry, &
         &              m_Files_close_nfcntn_berry,nfout
    use m_ErrorMessages, only : EOF_REACHED

    logical :: logica

    if(.not.allocated(det)) return 
    call m_Files_open_nfcntn_berry()
    rewind nfcntn_berry
    if(mype==0)then
       write(nfcntn_berry) ikp
       write(nfcntn_berry) kgbp0
       write(nfcntn_berry) kgbp1
       write(nfcntn_berry) kgbp2
       write(nfcntn_berry) det
    endif

! fsr, fsi related
    logica = allocated(fsr_k2)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_fs(fsr_k2,nfcntn_berry)

    logica = allocated(fsi_k2)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_fs(fsi_k2,nfcntn_berry)

    logica = allocated(fsr_k1)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_fs(fsr_k1,nfcntn_berry)

    logica = allocated(fsi_k1)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_fs(fsi_k1,nfcntn_berry)

    logica = allocated(fsr_k0)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_fs(fsr_k0,nfcntn_berry)

    logica = allocated(fsi_k0)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_fs(fsi_k0,nfcntn_berry)

! wf related
    logica = allocated(wfbp2)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_wf(kgbp2,wfbp2,nfcntn_berry)

    logica = allocated(wfbp1)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_wf(kgbp1,wfbp1,nfcntn_berry)

    logica = allocated(wfbp0)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_wf(kgbp0,wfbp0,nfcntn_berry)

    call m_Files_close_nfcntn_berry()

  end subroutine m_BP_wd_cntn_data

  subroutine m_BP_rd_cntn_data()
    use m_Files,           only : nfcntn_berry,m_Files_open_nfcntn_berry, &
         &                        m_Files_close_nfcntn_berry,nfout
    use m_PseudoPotential, only : nlmta
    use m_ErrorMessages,   only : EOF_REACHED

    logical :: logica

    if(.not.allocated(det)) return
    call m_Files_open_nfcntn_berry()
    rewind nfcntn_berry
    if(mype==0)then
       read(nfcntn_berry,end=9999,err=9999) ikp
       read(nfcntn_berry,end=9999,err=9999) kgbp0
       read(nfcntn_berry,end=9999,err=9999) kgbp1
       read(nfcntn_berry,end=9999,err=9999) kgbp2
       read(nfcntn_berry,end=9999,err=9999) det
    endif
    call mpi_bcast(ikp,1,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(kgbp0,1,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(kgbp1,1,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(kgbp2,1,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(det,jpara*nkprep*nspin,mpi_double_precision,0,mpi_comm_group,ierr)

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(.not.allocated(fsr_k2)) allocate(fsr_k2(np_e,nlmta,nspin))
       call read_fs(fsr_k2,nfcntn_berry,1)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(.not.allocated(fsi_k2)) allocate(fsi_k2(np_e,nlmta,nspin))
       call read_fs(fsi_k2,nfcntn_berry,2)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(.not.allocated(fsr_k1)) allocate(fsr_k1(np_e,nlmta,nspin))
       call read_fs(fsr_k1,nfcntn_berry,3)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(.not.allocated(fsi_k1)) allocate(fsi_k1(np_e,nlmta,nspin))
       call read_fs(fsi_k1,nfcntn_berry,4)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(.not.allocated(fsr_k0)) allocate(fsr_k0(np_e,nlmta,nspin))
       call read_fs(fsr_k0,nfcntn_berry,5) 
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(.not.allocated(fsi_k0)) allocate(fsi_k0(np_e,nlmta,nspin))
       call read_fs(fsi_k0,nfcntn_berry,6)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(allocated(wfbp2)) deallocate(wfbp2)
       allocate(wfbp2(kgbp2,np_e,2,nspin))
       call read_wf(kgbp2,wfbp2,nfcntn_berry,7)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if(logica) then
       if(allocated(wfbp1)) deallocate(wfbp1)
       allocate(wfbp1(kgbp1,np_e,2,nspin))
       call read_wf(kgbp1,wfbp1,nfcntn_berry,8)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if(logica) then
       if(allocated(wfbp0)) deallocate(wfbp0)
       allocate(wfbp0(kgbp0,np_e,2,nspin))
       call read_wf(kgbp0,wfbp0,nfcntn_berry,9)
    endif

    call m_Files_close_nfcntn_berry()
    return

9999 continue
    call phase_error_wo_filename(EOF_REACHED, nfout, nfcntn_berry, __LINE__, __FILE__)
  end subroutine m_BP_rd_cntn_data

  subroutine write_fs(fs,nf)
!!$  use m_Electronic_Structure, only : neg
    use m_Control_Parameters, only : neg
    use m_PseudoPotential, only : nlmta

    real(kind=DP),intent(in),dimension(np_e,nlmta,nspin) :: fs
    integer, intent(in) :: nf
    real(kind=DP),allocatable,dimension(:,:) :: f
    integer :: is,ib
    integer :: ierr

    allocate(f(nlmta,nspin));f=0.0d0
    do is=1,nspin
       do ib=1,neg 
          if(map_ek(ib,is) == mype) then
             f(:,:) = fs(map_z(ib),:,:)
             if(map_ek(ib,is)/=0) call mpi_send(f,nlmta*nspin,mpi_double_precision,0,1,mpi_comm_group,ierr)
          else if (mype==0 .and. map_ek(ib,is) /= 0)then
             call mpi_recv(f,nlmta*nspin,mpi_double_precision,map_ek(ib,is),1,mpi_comm_group,istatus,ierr)
          endif
          if(mype==0) write(nf) f
       enddo
    enddo
    deallocate(f)

  end subroutine write_fs

  subroutine read_fs(fs,nf,tag)
!!$  use m_Electronic_Structure, only : neg
    use m_Control_Parameters, only : neg
    use m_PseudoPotential, only : nlmta
    use m_ErrorMessages, only : EOF_REACHED
    use m_Files, only : nfout

    real(kind=DP),intent(out),dimension(np_e,nlmta,nspin) :: fs
    integer, intent(in) :: nf
    integer, intent(in) :: tag
    real(kind=DP),allocatable,dimension(:,:) :: f
    integer :: is,ib
    integer :: ierr

    allocate(f(nlmta,nspin));f=0.0d0
    fs = 0.d0
    do is=1,nspin
       do ib=1,neg 
          if(mype==0) read(nf,end=9999,err=9999) f
          if(mype==0 .and. map_ek(ib,is)/=0)then
             call mpi_send(f,nlmta*nspin,mpi_double_precision,map_ek(ib,is),tag,mpi_comm_group,ierr)
          else if (map_ek(ib,is)==mype .and. map_ek(ib,is) /= 0)then
             call mpi_recv(f,nlmta*nspin,mpi_double_precision,0,tag,mpi_comm_group,istatus,ierr)
          endif
          if(map_ek(ib,is) == mype) fs(map_z(ib),:,:) = f(:,:)
       enddo
    enddo
    deallocate(f)
    return

9999 continue
    call phase_error_wo_filename(EOF_REACHED, nfout, nf, __LINE__, __FILE__)

  end subroutine read_fs

  subroutine write_wf(n1,wf,nf)
    use m_Control_Parameters, only : neg

    integer, intent(in) :: n1
    real(kind=DP), dimension(n1,np_e,2,nspin),intent(in) :: wf
    integer, intent(in) :: nf
    real(kind=DP), allocatable,dimension(:,:) :: wft
    integer :: is,ib
    integer :: ierr

    allocate(wft(n1,2));wft=0.d0
    do is=1,nspin
       do ib=1,neg
          if(map_ek(ib,is) == mype)then
             wft(:,1) = wf(:,map_z(ib),1,is)
             wft(:,2) = wf(:,map_z(ib),2,is)
             if(map_ek(ib,is)/=0) call mpi_send(wft,n1*2,mpi_double_precision,0,1,mpi_comm_group,ierr)
          else if (mype==0 .and. map_ek(ib,is) /= 0) then
             call mpi_recv(wft,n1*2,mpi_double_precision,map_ek(ib,is),1,mpi_comm_group,istatus,ierr)
          endif
          if(mype==0) write(nf) wft
       enddo
    enddo
    deallocate(wft)

  end subroutine write_wf

  subroutine read_wf(n1,wf,nf,tag)
    use m_Control_Parameters, only : neg
    use m_ErrorMessages, only : EOF_REACHED
    use m_Files, only : nfout

    integer, intent(in) :: n1
    real(kind=DP), dimension(n1,np_e,2,nspin),intent(out) :: wf
    integer, intent(in) :: nf
    integer, intent(in) :: tag
    real(kind=DP), allocatable,dimension(:,:) :: wft
    integer :: is,ib
    integer :: ierr

    wf = 0.d0
    allocate(wft(n1,2));wft=0.d0
    do is=1,nspin
       do ib=1,neg
          if(mype==0) read(nf,end=9999,err=9999) wft
          if(mype==0 .and. map_ek(ib,is)/=0)then
             call mpi_send(wft,n1*2,mpi_double_precision,map_ek(ib,is),tag,mpi_comm_group,ierr)
          else if (map_ek(ib,is) == mype .and. map_ek(ib,is) /= 0) then
             call mpi_recv(wft,n1*2,mpi_double_precision,0,tag,mpi_comm_group,istatus,ierr)
          endif
          if(map_ek(ib,is) == mype) then
             wf(:,map_z(ib),1,is) = wft(:,1)
             wf(:,map_z(ib),2,is) = wft(:,2)
          endif
       enddo
    enddo
    deallocate(wft)
    return

9999 continue
    call phase_error_wo_filename(EOF_REACHED, nfout, nf, __LINE__, __FILE__)

  end subroutine read_wf

end module m_BerryPhase

!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, this module is added.
!
! Company:  ASMS Co.,Ltd.
! Functions: 
!
!     Conversion table between (n,l,t) in CIAO and (l,tau) in PHASE
!
! =============================================================

module m_Orbital_QuantumNum

  use m_Control_Parameters,  only : printable
  use m_Files,  only : nfout, nfpot
  use m_Ionic_System,   only : ntyp
  use m_Parallelization,  only : mype, mpi_comm_group, ierr

  implicit none
  include 'mpif.h'

  integer :: max_num_orb_index
  integer, allocatable :: num_orb_index_data(:)
  integer, allocatable :: qnum_n_orb_index(:,:), qnum_l_orb_index(:,:), &
       &                  qnum_t_orb_index(:,:), qnum_tau_orb_index(:,:)

contains

  subroutine m_OP_Qnum_init
    if ( allocated( num_orb_index_data ) )  deallocate( num_orb_index_data )
    allocate( num_orb_index_data(ntyp) ) ; num_orb_index_data = 0
  end subroutine m_OP_Qnum_init

  subroutine m_OP_Qnum_dealloc_array
    if ( allocated( num_orb_index_data ) ) deallocate( num_orb_index_data )
    if ( allocated( qnum_n_orb_index ) )   deallocate( qnum_n_orb_index )
    if ( allocated( qnum_l_orb_index ) )   deallocate( qnum_l_orb_index )
    if ( allocated( qnum_t_orb_index ) )   deallocate( qnum_t_orb_index )
    if ( allocated( qnum_tau_orb_index ) ) deallocate( qnum_tau_orb_index )
  end subroutine m_OP_Qnum_dealloc_array

  subroutine m_OP_Qnum_read_orbital_index
    call find_orbtital_index_data_number
    call alloc_orbital_index_data_array
    call read_orbital_index_data

  contains

    subroutine find_orbtital_index_data_number
      integer :: nfpp, it

      nfpp=0
      if(mype == 0) then
         write(nfout,*) "!** [asms extension] --- orbital index info ---"
         do it=1, ntyp
            nfpp=nfpp+1
            call find_orbital_index_section( nfpot(nfpp), nfout, it, &
                 &                           num_orb_index_data(it) )
            if (printable) then
               write(nfout,'(A,i3,A,i3)') ' !** num of orbital index. for it = ', &
                    &                     it, '  is ', num_orb_index_data(it)
            endif
         end do
      end if
      call mpi_bcast( num_orb_index_data, ntyp, mpi_integer, 0, mpi_comm_group, ierr )
      
    end subroutine find_orbtital_index_data_number
    
    subroutine find_orbital_index_section( nfp, nfout, it, num_orb_index )
      integer, intent(in) :: nfp, nfout, it
      integer, intent(out) :: num_orb_index
      
      integer :: ikey
      character(len=30)    :: line
      
      if(mype /= 0) return
      num_orb_index = 0
      
      rewind(nfp)
      Do while (.true.)
         read(nfp,'(a30)',end=20) line
         ikey = index(line,'ORBITAL-INDEX')
         if ( ikey /=0 ) then
            read(nfp,*) num_orb_index
            return
         endif
      End Do
20    if (printable) then
         write(nfout,*) "!** orbital index is not found in PP for it=", it
      endif
      
    end subroutine find_orbital_index_section

    subroutine alloc_orbital_index_data_array
      if (mype == 0) then
         max_num_orb_index = maxval( num_orb_index_data )
      endif
      call mpi_bcast( max_num_orb_index, 1,  mpi_integer, 0, mpi_comm_group, ierr )
      
      if (printable) then
         write(nfout,'(A,i3)') ' !** max_num_orb_index = ', max_num_orb_index
      endif
      
      if ( max_num_orb_index == 0 ) return
      
      allocate( qnum_n_orb_index(ntyp,max_num_orb_index) );   qnum_n_orb_index = 0
      allocate( qnum_l_orb_index(ntyp,max_num_orb_index) );   qnum_l_orb_index = 0
      allocate( qnum_t_orb_index(ntyp,max_num_orb_index) );   qnum_t_orb_index = 0
      allocate( qnum_tau_orb_index(ntyp,max_num_orb_index) ); qnum_tau_orb_index = 0

    end subroutine alloc_orbital_index_data_array
    
    subroutine read_orbital_index_data
      integer :: nfpp, it, j

      nfpp=0
      
      if ( max_num_orb_index == 0 ) return

      if (mype == 0)  then
         do it =1, ntyp
            nfpp=nfpp+1
            Do j=1, num_orb_index_data(it)
               read( nfpot(nfpp),*) qnum_n_orb_index(it,j), qnum_l_orb_index(it,j), &
                    &               qnum_t_orb_index(it,j), qnum_tau_orb_index(it,j)
            End do
         end do
      end if
      
      call mpi_bcast( qnum_n_orb_index, ntyp*max_num_orb_index, mpi_integer, 0, &
           &          mpi_comm_group, ierr )
      call mpi_bcast( qnum_l_orb_index, ntyp*max_num_orb_index, mpi_integer, 0, &
           &          mpi_comm_group, ierr )
      call mpi_bcast( qnum_t_orb_index, ntyp*max_num_orb_index, mpi_integer, 0, &
           &          mpi_comm_group, ierr )
      call mpi_bcast( qnum_tau_orb_index, ntyp*max_num_orb_index, mpi_integer, 0, &
           &          mpi_comm_group, ierr )
      
    end subroutine read_orbital_index_data

  end subroutine m_OP_Qnum_read_orbital_index

  subroutine m_OP_Qnum_orb_ind_data_num(it)
    integer, intent(in) :: it
    integer, save :: nfpp=0
    if(mype == 0) then
       write(nfout,*) "!** [asms extension] --- orbital index info ---"
       nfpp=nfpp+1
       call find_orbital_index_section( nfpot(nfpp), nfout, it, &
            &                           num_orb_index_data(it) )
       if (printable) then
          write(nfout,'(A,i3,A,i3)') ' !** num of orbital index. for it = ', &
               &                     it, '  is ', num_orb_index_data(it)
       endif
    end if

    if(it==ntyp) then
       call mpi_bcast( num_orb_index_data, ntyp, mpi_integer, 0, mpi_comm_group, ierr )
       nfpp=0
    endif

    contains

    subroutine find_orbital_index_section( nfp, nfout, it, num_orb_index )
      integer, intent(in) :: nfp, nfout, it
      integer, intent(out) :: num_orb_index
      
      integer :: ikey
      character(len=30)    :: line
      
      if(mype /= 0) return
      num_orb_index = 0
      
      rewind(nfp)
      Do while (.true.)
         read(nfp,'(a30)',end=20) line
         ikey = index(line,'ORBITAL-INDEX')
         if ( ikey /=0 ) then
            read(nfp,*) num_orb_index
            return
         endif
      End Do
20    if (printable) then
         write(nfout,*) "!** orbital index is not found in PP for it=", it
      endif
      
    end subroutine find_orbital_index_section
  end subroutine m_OP_Qnum_orb_ind_data_num

  subroutine m_OP_Qnum_alloc_orb_ind_data()
    if (mype == 0) then
       max_num_orb_index = maxval( num_orb_index_data )
    endif
    call mpi_bcast( max_num_orb_index, 1,  mpi_integer, 0, mpi_comm_group, ierr )
    
    if (printable) then
       write(nfout,'(A,i3)') ' !** max_num_orb_index = ', max_num_orb_index
    endif
    
    if ( max_num_orb_index == 0 ) return
    if(allocated(qnum_n_orb_index)) deallocate(qnum_n_orb_index) 
    if(allocated(qnum_l_orb_index)) deallocate(qnum_l_orb_index) 
    if(allocated(qnum_t_orb_index)) deallocate(qnum_t_orb_index) 
    if(allocated(qnum_tau_orb_index)) deallocate(qnum_tau_orb_index) 
    allocate( qnum_n_orb_index(ntyp,max_num_orb_index) );   qnum_n_orb_index = 0
    allocate( qnum_l_orb_index(ntyp,max_num_orb_index) );   qnum_l_orb_index = 0
    allocate( qnum_t_orb_index(ntyp,max_num_orb_index) );   qnum_t_orb_index = 0
    allocate( qnum_tau_orb_index(ntyp,max_num_orb_index) ); qnum_tau_orb_index = 0
  end subroutine m_OP_Qnum_alloc_orb_ind_data

  subroutine m_OP_Qnum_read_orbital_index_it(it)
    integer, intent(in) :: it
    integer,save :: nfpp=0
    integer ::  j

    if ( max_num_orb_index == 0 ) return

    if (mype == 0)  then
       nfpp=nfpp+1
       Do j=1, num_orb_index_data(it)
          read( nfpot(nfpp),*) qnum_n_orb_index(it,j), qnum_l_orb_index(it,j), &
               &               qnum_t_orb_index(it,j), qnum_tau_orb_index(it,j)
       End do
    end if
    if(it == ntyp) then
       call mpi_bcast( qnum_n_orb_index, ntyp*max_num_orb_index, mpi_integer, 0, &
            &          mpi_comm_group, ierr )
       call mpi_bcast( qnum_l_orb_index, ntyp*max_num_orb_index, mpi_integer, 0, &
            &          mpi_comm_group, ierr )
       call mpi_bcast( qnum_t_orb_index, ntyp*max_num_orb_index, mpi_integer, 0, &
            &          mpi_comm_group, ierr )
       call mpi_bcast( qnum_tau_orb_index, ntyp*max_num_orb_index, mpi_integer, 0, &
            &          mpi_comm_group, ierr )
       nfpp = 0
    endif
  end subroutine m_OP_Qnum_read_orbital_index_it

end module m_Orbital_QuantumNum
  

!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver. 1200)
!
!  SUBROUINE: Postprocessing
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
! ====================================
!  patch 0.1 by K. Tagami @adv    2008/08/13
!  patch 0.2 by J. Koga   @adv    2008/08/20
!  patch 0.3 by K. Tagami @adv    2008/08/26
!  patch 0.4 by K. Tagami @adv    2009/04/21
!  patch 0.5 by K. Tagami @adv    2009/05/09
!  patch 0.6 by K. Tagami @adv    2009/06/02
!
!     patch 0.1 :  using new subroutine m_ESIO_wd_ElectroStaticPot
!     patch 0.2 :  correction in wd_Header_For_Cube
!     patch 0.3 :  using new subroutine m_ESIO_wd_HartreePot
!                                       m_ESIO_wd_LocalPPot
!     patch 0.4 :  calculation of orbital_population only in case of ekmode=off
!                ( This is introduced for band calculation with DFT+U )
!     patch 0.5 :  calculation of DOS in case of DFT+U
!                ( ekcal , only trial )
!     patch 0.6 :  treatment in the case of sw_calc_force = ON
!                   ( trial )
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!$$#ifndef PARA3D
subroutine Postprocessing(ignore_convergence)
! $Id: Postprocessing.F90 634 2020-12-22 12:17:00Z ktagami $
  use m_Const_Parameters, only :   DP, ON, OFF, FORCE_CONVERGED, INITIAL, CONTINUATION &
       &                         , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                         , Gauss_distrib_func, EK, SCF &
       &                         , MESH, TETRAHEDRON, BULK, DEFECT, TOTAL &
       &                         , Valence_plus_PC_Charge &
       &                         , VXC_AND_EXC,CARTS,BUCS &
       &                         , unit_conv_byname, YES, SEPARATE, INTEGRATED &
       &                         , POLARIZATION, EFFECTIVE_CHARGE &
       &                         , PIEZOELECTRIC_CONST, PHONON_GAMMA, PHONON_DOS &
       &                         , PARABOLIC, TETRAHEDRON, COLD, DRIVER_CONSTRAINT, PAI2
  use m_Timing,             only : tstatc_wd, tstatc_init, tstatc_iter, tstatc_wd0
  use m_Control_Parameters, only : nspin,icond,sw_dos,sw_orb_popu,dos_method, ldos_method &
       &                         , iconvergence,iconvergence_previous_job &
       &                         , neg, kimg, ekmode, ipri, ipridos,partial_charge_filetype, ipritiming0 &
       &                         , sw_charge_rspace, sw_positron, sw_elf, sw_ldos, sw_cal_ldos &
       &                         , sw_berry_phase, polar_prop, sw_vibrational_modes &
       &                         , sw_lattice_dielectric_tensor, sw_dielectric_function &
       &                         , sw_lo_to_splitting, phonon_method &
       &                         , sw_int_strain_piezo_tensor &    
       &                         , sw_fine_STM_simulation, sw_deficit_charge, sw_add_xc_to_vloc  &
       &                         , sw_partial_charge, sw_phonon_oneshot &
       &                         , m_CntrlP_keep_charge_title &
       &                         , m_CntrlP_retrieve_charge_title &
       &                         , m_CntrlP_set_pcharge_title &
!!$       &                         , m_CtrlP_way_of_smearing &
       &                         , m_CntrlP_set_crtdst &
       &                         , sw_dipole,sw_layered,sw_dipole_correction &
       &                         , sw_wf_rspace, sw_rwf2, nr, rmax, center &
       &                         , ik_rwf2, ib_rwf2, sw_wannier, sw_wannier90 &
       &                         , printable, sw_xc_only, driver,sw_rsb_test &
       &                         , sw_spin_magmom_rspace, sw_write_unk_file &
       &                         , sw_diagonalize_population, crtdst_is_given &
       &                         , sw_boltztrap, boltztrap_prefix, boltztrap_header &
#ifdef __EDA__
       &                         , sw_eda &
#endif
       &                         , boltztrap_version,num_extra_bands, ekmode
  use m_IterationNumbers,   only : iteration, first_iteration_of_this_job, iteration_electronic, iteration_ionic
  use m_Crystal_Structure,  only : altv,m_CS_set_altv_prim, a,b,c, op, nopr, rltv
  use m_Ionic_System,       only : natm, natm2, ityp, iwei, iatomn, pos &
       &                         , m_IS_pack_all_ions_in_uc &
       &                         , m_IS_set_natm_prim,m_IS_set_napt_prim,speciesname
  use m_PseudoPotential,    only : ival, flg_paw
  use m_Files, only :              nfout,nfdos,nfchr,nfwfk,nfldos,nfelf &
       &                         , Nfvlc, nfcntn_bin_stm &
       &                         , m_Files_open_nfdos, m_Files_open_nfchr &
       &                         , m_Files_open_nfldos, m_Files_close_nfldos &
       &                         , m_Files_open_nfelf &
       &                         , m_Files_open_nfvlc &
       &                         , m_Files_open_nfcntn_bin_stm &
       &                         , m_Files_open_nfchr_pc &
       &                         , m_Files_skiptoend &
       &                         , m_Files_open_nfwfk
  use m_Kpoints, only :            way_ksample, kv3, kv3_ek, vkxyz, &
       &                           sw_force_kpt_inside_bz, vkxyz_ek
  use m_Parallelization, only :    mype, ista_k, iend_k, neg_g, mpi_kg_world, mpi_ge_world &
       &                         , map_k, myrank_k, np_e
  use m_PlaneWaveBasisSet,   only: kg,kgp,kg1,m_pwBS_wd_ngabc_etc
  use m_FFT,                 only: fft_box_size_WF, fft_box_size_CD &
       &                         , m_FFT_wd_box_sizes &
       &                         , m_FFT_alloc_WF_work, m_FFT_dealloc_WF_work
  use m_ES_dos, only :             m_ESdos_gaussdistrib, m_ESdos_gaussdistrib_ek &
       &                         , m_ESdos_tetrahedral &
       &                         , m_ESdos_put_dos_weight &
       &                         , m_ESdos_write_dos_header &
       &                         , m_ESdos_alloc_dos_weight
  use m_Electronic_Structure,only: efermi, vbm, metalic_system, totch &
       &                         , check_if_metalic_flag &
       &                         , neordr, nrvf_ordr &
       &                         , m_ES_wd_zaj_small_portion_3D &
       &                         , m_ES_orbital_population, m_ES_sym_comp, vlhxc_l &
       &                         , eko_ek
  use m_ES_nonlocal,         only: m_ES_phir_dot_WFs_3D

  use m_ES_occup, only :           m_ESoc_check_if_metalic, m_ESoc_set_nEwindows_pc &
       &                         , m_ESoc_keep_occup,       m_ESoc_if_elec_state &
       &                         , m_ESoc_retrieve_occup,   m_ESoc_free_nEwindows &
       &                         , m_ESoc_substitute_occup, m_ESoc_check_if_metalic
!!$       &                         , m_ESoc_fermi_parabolic, m_ESoc_fermi_tetrahedron &
!!$       &                         , m_ESoc_fermi_ColdSmearing
  use m_ES_LHXC, only :            m_ESlhxc_potential_3D
  use m_ES_IO,               only: m_ESIO_wd_EigenValues_etc &
       &                         , m_ESIO_wd_vlhxc, m_ESIO_check_energy
  use m_Charge_Density, only :     chgsoft, chgq_l, chgq_l_pc, nEwindow_ek &
       &                         , m_CD_alloc_rspace_charge &
       &                         , m_CD_dealloc_rspace_charge &
       &                         , m_CD_rspace_charge &
       &                         , m_CD_keep_chgq_l &
       &                         , m_CD_rspace_put_headermark, m_CD_rspace_put_endmark &
       &                         , m_CD_retrieve_chgq, m_CD_keep_retrieve_hsr &
       &                         , m_CD_softpart_3D, m_CD_hardpart &
       &                         , m_CD_partial_charge_ek_finalize
  use m_XC_Potential,        only: vxc_l, m_XC_cal_potential_3D
  use m_Ldos, only :               weiwsc,weilay, sw_save_ldos_weight &
       &                         , m_Ldos_cal &
       &                         , m_Ldos_cal_ek &
       &                         , m_Ldos_alloc_weiwsc_etc &
       &                         , m_Ldos_dealloc_weiwsc_etc &
       &                         , m_Ldos_what_is_n_total_ldos &
       &                         , m_Ldos_get_ldos_index  &
       &                         , m_Ldos_get_dos_weight  &
       &                         , m_Ldos_load_dos_weight
  use m_BerryPhase,  only        : m_BP_Polarization
  use m_BP_Properties, only      : m_BP_read_Berry_phase &
       &                         , m_BP_calc_Polarization &
       &                         , m_BP_calc_Effective_charge &
       &                         , m_BP_read_Effective_charge &
       &                         , m_BP_calc_piezoelectric_const
  use m_Phonon, only             : m_Phonon_read_forces &
       &                         , m_Phonon_calc_dynamical_matrix &
       &                         , m_Phonon_calc_vib_modes &
       &                         , m_Phonon_det_irr_rep &
       &                         , m_Phonon_calc_static_dielectric &
       &                         , m_Phonon_write_vib_modes &
       &                         , m_Phonon_write_epsilon &
       &                         , m_Phonon_calc_dos &
       &                         , m_Phonon_read_strain_forces &
       &                         , m_Phonon_calc_int_strain_piezo
! ======================= Added by K. Tagami ================ 0.6
  use m_Phonon, only             : sw_calc_force
! ===========================================================

! =============================== added by K. Tagami =================== 11.0
  use m_Control_Parameters,     only : noncol, ndim_magmom, &
       &                               m_CtrlP_set_pchg_title_noncl
  use m_Electronic_Structure,    only : m_ES_Orbital_population_noncl
  use m_ES_dos,                 only :  m_ESdos_gaussdistrib_noncl, &
       &                                m_ESdos_gaussdistrib_ek_noncl, &
       &                                m_ESdos_tetrahedral_noncl, &
       &                                m_ESdos_put_dos_weight_noncl, &
       &                                m_ESdos_alloc_dos_wght_noncl

! =============================== added by K. Tagami =================== 12.0Exp
  use m_Const_Parameters,    only  : ONE_BY_ONE, EK_CONVERGED, ALL_AT_ONCE
  use m_Control_Parameters,  only : fixed_charge_k_parallel
! ====================================================================== 12.0Exp

#ifndef DISABLE_CONSTRAINTS
  use m_constraints,         only : m_cnstr_reac_coords_variable,m_cnstr_get_id
  use m_velocity_verlet,     only : m_vv_get_curr_md_step
#endif


! ================= KT_add ================== 13.0E
  use m_Control_Parameters, only : m_CtrlP_way_of_smearing
  use m_Const_Parameters,  only : Fermi_Dirac
  use m_ES_dos,            only : m_ESdos_FDiracDistrib, m_ESdos_FDiracDistrib_ek
  use m_ES_occup,          only : m_ESoc_count_charge_belowEF, &
       &                          m_ESoc_count_charge_belowEF_ek
! =========================================== 13.0E

! ======== KT_add ======= 13.0S
  use m_Control_Parameters,  only : sw_calc_core_energy, sw_write_soi_on_atoms
  use m_CoreLevel_Spectrum,  only : m_CLS_calc_core_energy
  use m_SpinOrbit_Potential,  only : m_SO_print_SOC_on_atoms
! ======================= 13.0S

  use m_Crystal_Structure,  only : sw_spinorbit_second_variation
  use m_SpinOrbit_SecondVariation,  only : m_SO_calc_band_energy_socsv, &
       &                                   m_SO_init_second_variation, &
       &                                   m_SO_finalize_second_variation

  use m_Control_Parameters, only : sw_wf_squared_rspace, charge_filetype, &
       &                           sw_wf_integ_moment,  sw_calc_contact_density, &
       &                           sw_add_corecharge_rspace, sw_write_procar_file, &
       &                           sw_write_parity_file, &
       &                           sw_print_crystal_field_param, &
       &                           sw_calc_extfnv_correction, &
       &                           sw_band_unfolding, sw_calc_wf_orb_projection, &
       &                           sw_write_rotated_orbitals, sw_write_orb_dens_mat_file

  use m_Band_Unfolding,     only : m_BU_calc_spectral_weight_3D, &
       &                           m_BU_set_GVec_flag_refcell
  use m_OP_rotation,        only : m_OP_rotation_col, m_OP_rotation_noncl,  &
       &                           m_OP_wd_phirt2_rotated,  m_OP_wd_WFn_orb_proj, &
       &                           m_OP_calc_dm_col, m_OP_calc_dm_noncl

  use m_Electronic_Structure, only : eko_l
  use m_routines, only : get_unused_unitnumber

  use m_ES_ChargeState,   only : sw_write_electrostatic_pot, &
       &                         m_ESCS_wd_electrostatic_pot, &
       &                         m_ESCS_wd_extfnv_correction
  use m_Potential_Average,  only :  sw_calc_pot_avg, m_PotAvg_calc_pot_on_atoms

#ifdef __EDA__
  use m_PlaneWaveEDA, only : execute_PlaneWaveEDA, m_PW_EDA_allocation, m_PW_EDA_deallocation
#endif

  implicit none
  include 'mpif.h'

  logical, intent(in) :: ignore_convergence
  logical :: Already_Converged
  integer :: iloop, dos_method_act, i, aldos_or_layerdos, k_total, n_total_ldos, icomponent, nEwindows, it
  integer :: ik,ib
  real(kind=DP), allocatable, dimension(:,:) :: dos_weight ! d(neg,kv3|kv3_ek)

! ========================== added by K. Tagami ================ 11.0
  real(kind=DP), allocatable, dimension(:,:,:) :: dos_weight_noncl
! ============================================================== 11.0

  real(kind=DP) :: emin, emax
  real(kind=DP), allocatable :: radius(:)
  integer :: nfrwf2

  if(ignore_convergence)then
     if(printable)then
#ifndef DISABLE_CONSTRAINTS
        if(driver==DRIVER_CONSTRAINT)then
          write(nfout,'(a,i8)') ' !** running the post-processor for ionic iteration : ',m_vv_get_curr_md_step()
        else
          write(nfout,'(a,i8)') ' !** running the post-processor for ionic iteration : ',iteration_ionic
        endif
#else
        write(nfout,'(a,i8)') ' !** running the post-processor for ionic iteration : ',iteration_ionic
#endif
     endif
  endif


  call tstatc_iter(iteration, first_iteration_of_this_job)
  it = iteration
  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) it = iteration_electronic

  if(iconvergence >= FORCE_CONVERGED .or. iconvergence_previous_job >= FORCE_CONVERGED .or. ignore_convergence) then
!!$     if(sw_positron == BULK .or. sw_positron == DEFECT) then
!!$        write(nfout,'(" --- m_positron_lifetime --")')
!!$        call m_positron_lifetime()
!!$     end if

     if((icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION ) &
          & .and. fixed_charge_k_parallel == ALL_AT_ONCE ) then
        if(.not.check_if_metalic_flag) call m_ESoc_check_if_metalic(nfout)
     end if

     if(ipri >= 1) write(nfout,'(" ! totch = ",f16.8)') totch
!!$     if(efermi < -1.d+10) call FermiEnergyLevel()

     if(ipri >= 1) then
        if(vbm > -9.9d10) then
           write(nfout,'(" !  totch, efermi, vbm = ",f16.8,2f18.10,"  <<Postprocessing>>")') &
                & totch, efermi, vbm
        else
           write(nfout,'(" !  totch, efermi      = ",f16.8,f18.10,"  <<Postprocessing>>")') &
                & totch, efermi
        end if
        if(check_if_metalic_flag) then
           if(metalic_system) then
              write(nfout,'(" !  metalic_system = true")')
           else
              write(nfout,'(" !  metalic_system = false")')
           end if
        end if
     end if

     if ( m_CtrlP_way_of_smearing() == Fermi_Dirac ) then
        if ( ekmode == ON ) then
           call m_ESoc_count_charge_belowEF_ek( nfout )
        else
           call m_ESoc_count_charge_belowEF( nfout )
        endif
     endif

! -------- Population ----
     if(sw_orb_popu == ON) then
!        if ( ekmode == OFF .and. sw_calc_force == OFF .and. &
!             &  (icond /=FIXED_CHARGE .and. icond/=FIXED_CHARGE_CONTINUATION) ) then
        if ( ekmode == OFF .and. sw_calc_force == OFF) then
           call m_ES_phir_dot_WFs_3D(nfout)
           call m_ES_sym_comp(nfout)
           if ( noncol ) then
           else
              call m_ES_orbital_population(nfout)
              if ( sw_write_orb_dens_mat_file == ON ) call m_OP_calc_dm_col
              if ( sw_diagonalize_population == ON ) then
                 call m_OP_rotation_col(nfout)
                 if ( sw_write_rotated_orbitals == ON ) call m_OP_wd_phirt2_rotated
              endif
           endif
        endif
     end if

! --------- DOS ------
     if (sw_dos == ON) then
           call m_ESdos_alloc_dos_weight()
           call calc_totaldos()
     end if

! ---- LDOS ----------
!
     if ( sw_dos == ON .and. sw_ldos == ON ) then         
        if(.not.crtdst_is_given) then
           call m_CntrlP_set_crtdst(a,b,c) ! -> crtdst_aldos,crtdst_winlay
        end if
           call calc_localdos()
     end if

! ------ Charge Distrib ----
!
     if (sw_charge_rspace == ON) then
        if(Already_Converged()) then
           call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l, VXC_AND_EXC) ! -> vxc_l, afft
        end if

           call calc_spatial_chg_distrib(.false.)
           if ( sw_add_corecharge_rspace == ON ) then
              call calc_spatial_chg_distrib(.true.)
           endif
     endif

! ------ Parital Charge ---
!
     if ( sw_charge_rspace == ON .and. sw_partial_charge == ON .and. &
       &  (icond==INITIAL .or. icond==CONTINUATION)) then
           call calc_partial_charge()
     end if

     if ( sw_calc_pot_avg == ON ) call m_PotAvg_calc_pot_on_atoms
     if ( sw_charge_rspace == ON .and. icond == FIXED_CHARGE .and. ekmode == ON ) then
       call calc_spatial_chg_distrib_ek()
     endif
     if ( sw_charge_rspace == ON .and. sw_partial_charge == ON .and. &
       &  icond == FIXED_CHARGE .and. ekmode == ON ) then
           call calc_partial_charge_ek()
     endif


! ------ STM or Work function ---
!
     if (sw_fine_STM_simulation == ON) then
           call write_potential_for_STM
     endif


     if(sw_berry_phase == ON) then
        if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
           call m_BP_Polarization
        end if
     end if

  end if

! =============================== added by K. Tagami ============= 11.0
!  if ( noncol ) goto 750
! ================================================================ 11.0

  if( polar_prop == POLARIZATION .or. &
    & polar_prop == EFFECTIVE_CHARGE .or. &
    & polar_prop == PIEZOELECTRIC_CONST) then
     call m_BP_read_Berry_phase(.false.)
     call m_BP_read_Berry_phase(.true.)
  end if

  if( polar_prop == POLARIZATION ) then
     call m_BP_calc_Polarization
  else if( polar_prop == EFFECTIVE_CHARGE .or. sw_lo_to_splitting == ON &
    & .or. sw_lattice_dielectric_tensor == ON &
    & .or. sw_int_strain_piezo_tensor == ON) then
     if(sw_vibrational_modes == ON) then
        call m_CS_set_altv_prim()
        call m_IS_set_natm_prim()
        call m_IS_set_napt_prim()
! == KT_add === 2014/06/20
     else if ( polar_prop == EFFECTIVE_CHARGE ) then
        call m_IS_set_napt_prim()
! ============= 2014/06/20
     endif
     call m_BP_calc_Effective_charge
  else if( polar_prop == PIEZOELECTRIC_CONST) then
     call m_BP_calc_piezoelectric_const
  end if

  if(sw_vibrational_modes == ON .and. sw_phonon_oneshot == OFF &
    & .and. (iconvergence >= FORCE_CONVERGED .or. sw_calc_force == OFF)) then  ! asms
     call m_Phonon_read_forces()
     call m_CS_set_altv_prim()
     call m_IS_set_natm_prim()
     call m_IS_set_napt_prim()
     call m_Phonon_calc_dynamical_matrix()
     call m_Phonon_calc_vib_modes()
     call m_Phonon_det_irr_rep()
     if(phonon_method == PHONON_GAMMA .and. sw_lattice_dielectric_tensor == ON) &
       & call m_Phonon_calc_static_dielectric()
     call m_Phonon_write_vib_modes()
     if(phonon_method == PHONON_GAMMA .and. sw_dielectric_function == ON) &
       & call m_Phonon_write_epsilon()
     if(phonon_method == PHONON_DOS) call m_Phonon_calc_dos()
     if(phonon_method == PHONON_GAMMA .and. sw_int_strain_piezo_tensor == ON) then
	call m_Phonon_read_strain_forces()
        call m_Phonon_calc_int_strain_piezo()
     end if


  end if


  if ( sw_write_electrostatic_pot == ON ) then
     call m_ESCS_wd_electrostatic_pot
  endif
  if ( sw_calc_extfnv_correction == ON ) then
     call m_ESCS_wd_extfnv_correction
  endif

! ========= KT_add === 13.0S
  if ( icond < 2 .and. sw_calc_core_energy == ON ) call m_CLS_calc_core_energy
! ==================== 13.0S
  if ( .not. noncol .and. sw_spinorbit_second_variation == ON ) then
     if ( ekmode == OFF ) then
        call m_SO_init_second_variation
        call m_SO_calc_band_energy_socsv
        call m_SO_finalize_second_variation
     endif
  endif

  if ( ekmode == OFF ) then
     if ( sw_band_unfolding == ON ) then
        if ( sw_force_kpt_inside_bz == ON ) call m_BU_set_GVec_flag_refcell
        call m_BU_calc_spectral_weight_3D
     endif
     if ( sw_orb_popu == ON .and. sw_calc_wf_orb_projection == ON ) then
        call m_ES_phir_dot_WFs_3D( nfout )
        if ( sw_band_unfolding == OFF ) call m_OP_wd_WFn_orb_proj
     end if
  endif

  if(sw_boltztrap == ON)then
    call output_data_for_bt(nfout,boltztrap_prefix,boltztrap_header,boltztrap_version)
  endif

#ifdef __EDA__
  if(sw_eda == ON) then
    call m_PW_EDA_allocation()
    call execute_PlaneWaveEDA()
    call m_PW_EDA_deallocation()
  endif
#endif

  if(ipritiming0 >= 1 .and. iteration > first_iteration_of_this_job) call tstatc_wd(it)
  call tstatc_init

contains
!!$  subroutine FermiEnergyLevel()
!!$    integer :: way_of_smearing
!!$    way_of_smearing = m_CtrlP_way_of_smearing()
!!$    if(way_of_smearing == PARABOLIC) then
!!$       if(ipri>=1) write(nfout,'(" way_of_smearing = PARABOLIC <<Postprocessing>>")')
!!$       call m_ESoc_fermi_parabolic(nfout)
!!$!!$  else if(way_of_smearing == MP) then
!!$!!$     call fermi_mesfessel_paxton(nfout)
!!$    else if(way_of_smearing == TETRAHEDRON) then
!!$       if(ipri>=1) write(nfout,'(" way_of_smearing = TETRAHEDRON <<Postprocessing>>")')
!!$        call m_ESoc_fermi_tetrahedron(nfout)
!!$    else if(way_of_smearing == COLD) then
!!$       if(ipri>=1) write(nfout,'(" way_of_smearing = COLD <<Postprocessing>>")')
!!$        call m_ESoc_fermi_ColdSmearing(nfout)
!!$    end if
!!$  end subroutine FermiEnergyLevel

  subroutine calc_totaldos()

    if(.not.check_if_metalic_flag.or.ignore_convergence) call m_ESoc_check_if_metalic(nfout)
       
    if(.not.ignore_convergence)then
        call m_Files_open_nfdos()
    else
#ifndef DISABLE_CONSTRAINTS
        if(driver==DRIVER_CONSTRAINT)then 
          if(m_cnstr_reac_coords_variable())then
             call m_Files_open_nfdos(iter=m_vv_get_curr_md_step(),reacid=m_cnstr_get_id())
          else
             call m_Files_open_nfdos(iter=m_vv_get_curr_md_step())
          endif
        else
#endif
          call m_Files_open_nfdos(iter=iteration_ionic)
#ifndef DISABLE_CONSTRAINTS
        endif
#endif
    endif

    dos_method_act = dos_method
    if(dos_method_act == TETRAHEDRON .and. way_ksample /= MESH) then
       dos_method_act = Gauss_distrib_func
    end if

    if(ipridos>=1) then
       if(dos_method_act == TETRAHEDRON) then
          write(nfout,'(" dos_method_act = TETRAHEDRON")')

! ======================== KT_add ============= 13.0E
       else if ( dos_method_act == Fermi_Dirac ) then
          write(nfout,'(" dos_method_act = FERMI_DIRAC")')
! ============================================== 13.0E
       else
          write(nfout,'(" dos_method_act = Gauss_distrib_funcN")')
       end if
    end if

    icomponent = TOTAL
    if(dos_method_act == Gauss_distrib_func) then
       if(icond == INITIAL .or. icond == CONTINUATION ) then
          call m_ESdos_gaussdistrib(nfdos,icomponent)
       else if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
!  ================================ Modified by K. Tagami ====== 0.5
!          if(sw_orb_popu /= ON) &
!          & call m_ESdos_gaussdistrib_ek(nfdos,icomponent)
       if( fixed_charge_k_parallel == ONE_BY_ONE ) then
           call m_ESdos_gaussdistrib_ek(nfdos,icomponent)
       else
           call m_ESdos_gaussdistrib(nfdos,icomponent)
       endif
! ===============================================================
       end if

! ================== KT_add  ================== 13.0E
    else if ( dos_method_act == Fermi_Dirac ) then
       if(icond == INITIAL .or. icond == CONTINUATION ) then
          call m_ESdos_FDiracDistrib(nfdos,icomponent)
       else if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
           call m_ESdos_FDiracDistrib_ek(nfdos,icomponent)
       end if
! ============================================= 13.0E

    else  ! dos_method_act == Tetrahedral
       if(icond == INITIAL .or. icond == CONTINUATION ) then
          call m_ESdos_tetrahedral(nfdos,icomponent,mode=SCF)
       else if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
!  ============== Modified by K. Tagami ================== 0.5
!!          if(sw_orb_popu /= ON) &
!!!!          & call m_ESdos_tetrahedral(nfdos,icomponent,mode=EK)

! =================================== KT ======================== 12.0Exp
!             call m_ESdos_tetrahedral(nfdos,icomponent,mode=EK)
!
          if ( fixed_charge_k_parallel == ONE_BY_ONE ) then
             call m_ESdos_tetrahedral(nfdos,icomponent,mode=EK)
          else
             call m_ESdos_tetrahedral(nfdos,icomponent,mode=SCF)
          endif
! ==================================================================== 12.0Exp

! ======================================================= 0.5
       end if
    end if
!!$     call m_Files_close_nfdos()
  end subroutine calc_totaldos


  subroutine calc_localdos()
    character(len=40) :: tagwords

    if (ekmode == OFF) then
       call m_Ldos_alloc_weiwsc_etc()
       call m_Ldos_cal() !-> weiwsc, weilay
    else 
       call m_Ldos_alloc_weiwsc_etc()
       call m_Ldos_cal_ek() !-> weiwsc, weilay
    end if
    call m_Files_close_nfldos()

    if (sw_cal_ldos == ON) then
       if(sw_dos /= ON) call calc_totaldos()

       call m_Files_open_nfldos()
       dos_method_act = ldos_method
       if(dos_method_act == TETRAHEDRON .and. way_ksample /= MESH) then
          dos_method_act = Gauss_distrib_func
       end if

       n_total_ldos = m_Ldos_what_is_n_total_ldos()

       if(n_total_ldos > 0 ) then
          if(ekmode == OFF) then
             k_total = kv3
          else if(ekmode == ON) then
             k_total = kv3_ek
          end if
          allocate(dos_weight(neg,k_total))
       end if

       if(ekmode==ON) call m_Ldos_load_dos_weight()
       do i=1, n_total_ldos
!!$              write(nfout,'(" i = ",i8, " <<Postprocessing>>")') i
          call m_Ldos_get_ldos_index(i,aldos_or_layerdos,icomponent,tagwords) ! -> aldos_or_layerdos,icomponent
          call m_Ldos_get_dos_weight( aldos_or_layerdos, icomponent, nfldos,&
               &                      neg, k_total, dos_weight )     !  weiwsc or weilay -> dos_weight
          call m_ESdos_put_dos_weight( neg, k_total, dos_weight )    ! -> dos_weight (in m_ES_dos)
          call m_ESdos_write_dos_header( nfdos, aldos_or_layerdos, icomponent, tagwords )

          if (dos_method_act == Gauss_distrib_func) then
             if(icond == INITIAL .or. icond == CONTINUATION ) then
                call m_ESdos_gaussdistrib(nfdos,icomponent)
             else if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
                call m_ESdos_gaussdistrib_ek(nfdos,icomponent)
             end if

! ============================= KT_add ================= 13.0E
          else if ( dos_method_act == Fermi_Dirac ) then
             if(icond == INITIAL .or. icond == CONTINUATION ) then
                call m_ESdos_FDiracDistrib(nfdos,icomponent)
             else if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
                call m_ESdos_FDiracDistrib_ek(nfdos,icomponent)
             end if
! ====================================================== 13.0Ea

          else  ! dos_method_act = Tetrahedral
             if (icond == INITIAL .or. icond == CONTINUATION ) then
                call m_ESdos_tetrahedral(nfdos,icomponent,mode=SCF)
             else if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then

! =============================================== KT ================= 12.0Exp
!                call m_ESdos_tetrahedral(nfdos,icomponent,mode=EK)
! 
               if ( fixed_charge_k_parallel == ONE_BY_ONE ) then
                   call m_ESdos_tetrahedral(nfdos,icomponent,mode=EK)
                else
                   call m_ESdos_tetrahedral(nfdos,icomponent,mode=SCF)
                endif
! ===================================================================== 12.0Exp

             end if
          end if
       end do
    end if

    if (n_total_ldos > 0 ) deallocate(dos_weight)
    call m_Ldos_dealloc_weiwsc_etc()

  end subroutine calc_localdos


  subroutine calc_spatial_chg_distrib( flg_add_core )
    logical, intent(in) :: flg_add_core
    integer :: iloop, iloop2

    if (icond == INITIAL .or. icond == CONTINUATION) then
       call m_CD_alloc_rspace_charge()
       do iloop = 1, nspin
! ======================= KT_add === 2014/06/07
          if ( nspin == 2 .and. sw_spin_magmom_rspace == ON ) then
             iloop2 = -iloop
          else
             iloop2 = iloop
          endif
! =================================== 2014/06/07
          if ( flg_add_core .and. iloop2 == -2 ) cycle

          if(.not.ignore_convergence)then
             call m_Files_open_nfchr( nspin, iloop2, add_core=flg_add_core )
          else
#ifndef DISABLE_CONSTRAINTS
             if(driver==DRIVER_CONSTRAINT)then
                if(m_cnstr_reac_coords_variable())then
                  call m_Files_open_nfchr(nspin,iloop2,iter=m_vv_get_curr_md_step(),reacid=m_cnstr_get_id())
                else
                  call m_Files_open_nfchr(nspin,iloop2,iter=m_vv_get_curr_md_step())
                endif
             else
#endif
                call m_Files_open_nfchr(nspin,iloop2,iter=iteration_ionic)
#ifndef DISABLE_CONSTRAINTS
             endif
#endif
          endif
          call m_CD_rspace_charge(nspin,iloop2,nfchr,nfout,add_core=flg_add_core)
       end do
       call m_CD_dealloc_rspace_charge()
    endif

  end subroutine calc_spatial_chg_distrib

  subroutine calc_spatial_chg_distrib_ek()
    use m_IterationNumbers, only : m_Iter_reset_nk_in_the_process
    use m_Charge_Density, only : m_CD_softpart_3D, m_CD_hardpart, chgq_l
    use m_ES_IO, only : m_ESIO_rd_next_wfs_ek
    use m_ES_nonlocal, only : m_ES_betar_dot_WFs_4_each_k_3D
    use m_Parallelization, only : ista_kngp, iend_kngp
    use m_Files, only : m_Files_open_nfzaj_kall, nfzaj_kall
    use m_Control_Parameters, only : af
    use m_Parallelization, only : ista_kngp, iend_kngp
    use m_Electronic_Structure, only : vbm, efermi
    use m_ES_occup, only : m_ESoc_occup_under_ef
    integer :: iloop, iloop2
    integer :: nk, is
    real(kind=DP), allocatable, dimension(:,:,:) :: chgq_l_sum
    call m_CD_alloc_rspace_charge()
    allocate(chgq_l_sum(ista_kngp:iend_kngp,kimg,nspin));chgq_l_sum = 0.d0
    call m_Files_open_nfzaj_kall()
    chgq_l_sum = 0.d0
    rewind(nfzaj_kall)
    call m_Iter_reset_nk_in_the_process()
    do nk=1, kv3_ek, kv3
      call KpointNumber_Setting2()
      call Preparation_ek()
      call Preparation_for_mpi_ek()
      call epsmain_reallocate()
      call PseudoPotential_ek()
      call m_ESoc_occup_under_ef(nfout, nk)
      do is=1, nspin, af+1
        do ik=is, kv3+is-nspin, nspin
          call m_ESIO_rd_next_wfs_ek(ik, nfout, nfzaj_kall)
          if(map_k(ik) /= myrank_k) cycle
          call m_ES_betar_dot_WFs_4_each_k_3D(nfout, ik)
        enddo
      enddo
      call m_CD_softpart_3D(nfout, kv3)
      call m_CD_hardpart(nfout, kv3)
      chgq_l_sum =  chgq_l_sum + chgq_l
    enddo
    chgq_l = chgq_l_sum
    do is=1, nspin, af+1
      call m_Files_open_nfchr(nspin, is)
      call m_CD_rspace_charge(nspin,is,nfchr,nfout)
    enddo
    call m_CD_dealloc_rspace_charge()
    deallocate(chgq_l_sum)
  end subroutine calc_spatial_chg_distrib_ek
  
  subroutine calc_partial_charge_ek()
    use m_Control_Parameters, only : af
    use m_ES_occup, only : m_ESoc_set_nEwindows_pc_ek
    use m_Files, only : m_Files_open_nfzaj_kall, nfzaj_kall
    use m_IterationNumbers, only : m_Iter_reset_nk_in_the_process
    use m_ES_IO, only : m_ESIO_rd_next_wfs_ek
    use m_ES_nonlocal, only : m_ES_betar_dot_WFs_4_each_k_3D
    use m_Charge_Density, only : m_CD_softpart_3D, m_CD_hardpart, chgq_l
    use m_Parallelization, only : ista_kngp, iend_kngp
    integer :: i, iloop, iloop2
    integer :: nk, is
    real(kind=DP), allocatable, dimension(:,:,:) :: chgq_l_pc

    call m_ESoc_set_nEwindows_pc_ek(nfout,nEwindows)
    call m_ESoc_keep_occup()
    call m_CD_keep_chgq_l()
    call m_CD_keep_retrieve_hsr(.true.)
    call m_CntrlP_keep_charge_title()
    call m_Files_open_nfzaj_kall()

    allocate(chgq_l_pc(ista_kngp:iend_kngp,kimg,nspin));chgq_l_pc = 0.d0
    do i = 1, nEwindows
       if(m_ESoc_if_elec_state(nfout,i,emin,emax) /= YES) cycle
       chgq_l_pc = 0.d0
       rewind(nfzaj_kall)
       call m_Iter_reset_nk_in_the_process()
       do nk=1, kv3_ek, kv3
         call KpointNumber_Setting2()
         call Preparation_ek()
         call Preparation_for_mpi_ek()
         call epsmain_reallocate()
         call PseudoPotential_ek()
         call m_ESoc_substitute_occup(nfout,i,nk)

         do is=1, nspin, af+1
           do ik=is, kv3+is-nspin, nspin
             call m_ESIO_rd_next_wfs_ek(ik, nfout, nfzaj_kall)
             if(map_k(ik) /= myrank_k) cycle
             call m_ES_betar_dot_WFs_4_each_k_3D(nfout, ik)
           enddo
         enddo
         call m_CD_softpart_3D(nfout, kv3)
         call m_CD_hardpart(nfout, kv3)
         chgq_l_pc =  chgq_l_pc + chgq_l
       enddo
       chgq_l = chgq_l_pc
       
       call m_CD_alloc_rspace_charge()

       do iloop = 1, nspin
! =========================== KT_add === 2014/06/07
          if ( nspin == 2 .and. sw_spin_magmom_rspace == ON ) then
             iloop2 = -iloop
          else
             iloop2 = iloop
          endif
! ===================================== 2014/06/07
          call m_CntrlP_set_pcharge_title(nspin,iloop2,i,emin,emax)
          if(partial_charge_filetype == SEPARATE) then
             call m_Files_open_nfchr_pc(nspin,iloop2,i)
          else
             call m_Files_open_nfchr(nspin,iloop2)
             call m_Files_skiptoend(nfchr)
             call m_CD_rspace_put_headermark(nfchr,nspin,iloop2,i)
          end if
          call m_CD_rspace_charge(nspin,iloop2,nfchr,nfout)
          if(partial_charge_filetype == INTEGRATED) & ! /= SEPARATE
               & call m_CD_rspace_put_endmark(nfchr)
       end do
       call m_CD_dealloc_rspace_charge()
    end do
    call m_ESoc_retrieve_occup()
    call m_CD_retrieve_chgq()
    call m_CD_keep_retrieve_hsr(.false.)
    call m_CntrlP_retrieve_charge_title()
    call m_ESoc_free_nEwindows()
    deallocate(chgq_l_pc)
  end subroutine calc_partial_charge_ek


  subroutine calc_partial_charge
    integer :: i, iloop, iloop2

    if(icond == INITIAL .or. icond == CONTINUATION) then

       if(.not.check_if_metalic_flag.or.ignore_convergence) then
          call m_ESoc_check_if_metalic(nfout)
          if(ipri >= 1) then
!!$                    write(nfout,'(" !  totch, efermi, vbm = ",2f20.12,d20.8,"  <<Postprocessing>>")') &
!!$                         & totch, efermi, vbm
             if(metalic_system) then
                write(nfout,'(" !  metalic_system = true")')
             else
                write(nfout,'(" !  metalic_system = false")')
             end if
          end if
       end if

       call m_ESoc_set_nEwindows_pc(nfout,nEwindows)
       call m_ESoc_keep_occup()
       call m_CD_keep_chgq_l()
       call m_CD_keep_retrieve_hsr(.true.)
       call m_CntrlP_keep_charge_title()

       do i = 1, nEwindows
          if(m_ESoc_if_elec_state(nfout,i,emin,emax) /= YES) cycle
          call m_ESoc_substitute_occup(nfout,i)
          
          call m_CD_softpart_3D(nfout,kv3)
          call m_CD_hardpart(nfout,kv3)
          
          call m_CD_alloc_rspace_charge()

          do iloop = 1, nspin
! =========================== KT_add === 2014/06/07
             if ( nspin == 2 .and. sw_spin_magmom_rspace == ON ) then
                iloop2 = -iloop
             else
                iloop2 = iloop
             endif
! ===================================== 2014/06/07
             call m_CntrlP_set_pcharge_title(nspin,iloop2,i,emin,emax)
             if(partial_charge_filetype == SEPARATE) then
                if(.not.ignore_convergence)then
                   call m_Files_open_nfchr_pc(nspin,iloop2,i)
                else
#ifndef DISABLE_CONSTRAINTS
                   if(driver==DRIVER_CONSTRAINT)then
                      if(m_cnstr_reac_coords_variable())then
                         call m_Files_open_nfchr_pc(nspin,iloop2,i,iter=m_vv_get_curr_md_step(),reacid=m_cnstr_get_id())
                      else
                         call m_Files_open_nfchr_pc(nspin,iloop2,i,iter=m_vv_get_curr_md_step())
                      endif
                   else
#endif
                      call m_Files_open_nfchr_pc(nspin,iloop2,i,iter=iteration_ionic)
#ifndef DISABLE_CONSTRAINTS
                   endif
#endif
                endif
             else
                if(.not.ignore_convergence)then
                   call m_Files_open_nfchr(nspin,iloop2)
                else
#ifndef DISABLE_CONSTRAINTS
                   if(driver==DRIVER_CONSTRAINT)then
                      if(m_cnstr_reac_coords_variable())then
                         call m_Files_open_nfchr(nspin,iloop2,iter=m_vv_get_curr_md_step(),reacid=m_cnstr_get_id())
                      else
                         call m_Files_open_nfchr(nspin,iloop2,iter=m_vv_get_curr_md_step())
                      endif
                   else
#endif
                      call m_Files_open_nfchr(nspin,iloop2,iter=iteration_ionic)
#ifndef DISABLE_CONSTRAINTS
                   endif
#endif
                endif
                call m_Files_skiptoend(nfchr)
                call m_CD_rspace_put_headermark(nfchr,nspin,iloop2,i)
             end if
             call m_CD_rspace_charge(nspin,iloop2,nfchr,nfout)
             if(partial_charge_filetype == INTEGRATED) & ! /= SEPARATE
                  & call m_CD_rspace_put_endmark(nfchr)
          end do

          call m_CD_dealloc_rspace_charge()

       end do
       call m_ESoc_retrieve_occup()
       call m_CD_retrieve_chgq()
       call m_CD_keep_retrieve_hsr(.false.)
       call m_CntrlP_retrieve_charge_title()
       call m_ESoc_free_nEwindows()
    end if

  end subroutine calc_partial_charge



  subroutine write_potential_for_STM
    integer :: ismax

    ismax = nspin

    if (ipri >= 1) call wd_fine_STM_parameters( ismax )
    call m_Files_open_nfvlc()
    if (mype==0) rewind nfvlc

    if (sw_deficit_charge == 1) then
!       call m_XC_cal_potential_3D( nfout, Valence_plus_PC_Charge, chgq_l, VXC_AND_EXC )
!       call m_ESlhxc_potential_3D(nfout,chgq_l,vxc_l)      ! chq_l, vxc_l -> vlhxc
           if(sw_add_xc_to_vloc==ON)then
              call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l,VXC_AND_EXC) ! chgsoft -> vxc_l
           else
              vxc_l = 0.0d0
           endif
           if(sw_xc_only==ON)then
               vlhxc_l(:,:,:) = vxc_l(:,:,:)
           else
               call m_ESlhxc_potential_3D(nfout,chgq_l,vxc_l) ! chgsoft, vxc_l -> vlhxc
           endif

    else
           ! sw_deficit_charge==0
!       call m_XC_cal_potential_3D( nfout, Valence_plus_PC_Charge, chgsoft, VXC_AND_EXC )
!       call m_ESlhxc_potential_3D(nfout,chgsoft,vxc_l)     ! chgsoft, vxc_l -> vlhxc
           if(sw_add_xc_to_vloc==ON)then
              call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgsoft,VXC_AND_EXC) ! chgsoft -> vxc_l
           else
              vxc_l = 0.d0
           endif
           if(sw_xc_only==ON)then
               vlhxc_l(:,:,:) = vxc_l(:,:,:)
           else
               call m_ESlhxc_potential_3D(nfout,chgsoft,vxc_l) ! chgsoft, vxc_l -> vlhxc
           endif

    endif
    call m_ESIO_wd_vlhxc( nfvlc, ismax )

    if(ipri >= 3) call check_neordr_nrvf_ordr()
    call m_Files_open_nfcntn_bin_stm()
    if(mype==0) rewind nfcntn_bin_stm

    call wd_ArraySize_Parameters_For_STM( nfcntn_bin_stm, ismax )
    call m_ESIO_wd_EigenValues_etc(nfcntn_bin_stm,.false.,totch_flag=OFF)
    call m_pwBS_wd_ngabc_etc(nfcntn_bin_stm)
    call m_FFT_wd_box_sizes(nfcntn_bin_stm)
    call wd_Header_For_Cube(nfcntn_bin_stm)

  end subroutine write_potential_for_STM



  subroutine wd_fine_STM_parameters( ismax )
    integer, intent(in) :: ismax

    integer :: ik
    write(nfout,'(" !!STM:    kg(kng)   = ",i8)') kg
    write(nfout,'(" !!STM:    kgp(kngp) = ",i8)') kgp
    write(nfout,'(" !!STM:    kg1(kng1) = ",i8)') kg1
    write(nfout,'(" !!STM:    neg(keg)  = ",i8)') neg
    write(nfout,'(" !!STM:    kimg      = ",i8)') kimg
    write(nfout,'(" !!STM:    fft_box_size_WF(1,1)(knl)  = ",i8)') fft_box_size_WF(1,1)
    write(nfout,'(" !!STM:    fft_box_size_WF(2,1)(knm)  = ",i8)') fft_box_size_WF(2,1)
    write(nfout,'(" !!STM:    fft_box_size_WF(3,1)(knn)  = ",i8)') fft_box_size_WF(3,1)
    write(nfout,'(" !!STM:    fft_box_size_WF(1,0)(kid)  = ",i8)') fft_box_size_WF(1,0)
    write(nfout,'(" !!STM:    fft_box_size_CD(1,1)(knlp) = ",i8)') fft_box_size_CD(1,1)
    write(nfout,'(" !!STM:    fft_box_size_CD(2,1)(knmp) = ",i8)') fft_box_size_CD(2,1)
    write(nfout,'(" !!STM:    fft_box_size_CD(3,1)(knnp) = ",i8)') fft_box_size_CD(3,1)
    write(nfout,'(" !!STM:    fft_box_size_CD(1,0)(kidp) = ",i8)') fft_box_size_CD(1,0)
    write(nfout,'(" !!STM:    kv3(knv3) = ",i8)') kv3

! ====================== modiifed by K. Tagami ======================= 11.0
!    write(nfout,'(" !!STM:    nspin(kspin) = ",i8)') nspin
    write(nfout,'(" !!STM:    ndim of magmom (kspin) = ",i8)') ismax
! =================================================================== 11.0

    write(nfout,'(" !!STM:  == k-points ==")')
    write(nfout,'(" !!STM: ik",8x,"CARTS",22x,"PUCS")')
    do ik = 1, kv3
       write(nfout,'(" !!STM: ",i3,3f8.4,3x,3f8.4)') ik &
            &   , (vkxyz(ik,i,CARTS),i=1,3),(vkxyz(ik,i,BUCS) ,i=1,3)
    enddo
  end subroutine wd_fine_STM_parameters

  subroutine check_neordr_nrvf_ordr()
    integer :: i
    do i = ista_k, iend_k
       write(nfout,'(" !!Postprocessing -- neordr --, ik = ",i8)') i
       write(nfout,'(" !!Postprocessing ",10i6)') (neordr(iloop,i),iloop=1,neg)
    end do
    do i = ista_k, iend_k
       write(nfout,'(" !!Postprocessing -- nrvf_ordr --, ik = ",i8)') i
       write(nfout,'(" !!Postprocessing ",10i6)') (nrvf_ordr(iloop,i),iloop=1,neg)
    end do
  end subroutine check_neordr_nrvf_ordr

  subroutine wd_ArraySize_Parameters_For_STM( nf_bin, ismax )
    integer, intent(in) :: ismax

    integer, intent(in) :: nf_bin
    if(mype == 0) then
       write(nf_bin) kg
       write(nf_bin) kgp
       write(nf_bin) kg1
       write(nf_bin) neg
       write(nf_bin) kimg
       write(nf_bin) fft_box_size_WF(1,1)
       write(nf_bin) fft_box_size_WF(2,1)
       write(nf_bin) fft_box_size_WF(3,1)
       write(nf_bin) fft_box_size_WF(1,0)
       write(nf_bin) fft_box_size_CD(1,1)
       write(nf_bin) fft_box_size_CD(2,1)
       write(nf_bin) fft_box_size_CD(3,1)
       write(nf_bin) fft_box_size_CD(1,0)
       write(nf_bin) kv3
! ====================== modiifed by K. Tagami ======================= 11.0
!       write(nf_bin) nspin
       write(nf_bin) ismax
! ==================================================================== 11.0
    endif
  end subroutine wd_ArraySize_Parameters_For_STM

  subroutine wd_Header_For_Cube(nf_bin)
    integer, intent(in) :: nf_bin
    integer :: i, m
    real(kind=DP) :: x,y,z
    real(kind=DP),allocatable,dimension(:,:) :: cps_full
    integer, allocatable,dimension(:) :: ityp_full
    !!$real(kind=DP), dimension(3) :: r_wk    !!! K.Mae 040315

    if(mype == 0) then

      x = 0.d0; y = 0.d0; z = 0.d0
      write(nf_bin) natm2, x,y,z

      do i = 1, 3
         !!$do m = 1, 3
         !!$   ucret = unit_conv_byname( altv(m,i), r_wk(m), 'bohr', 'angstrom' )
         !!$end do
         !!$write(nf_bin) fft_box_size_CD(i,1), r_wk(1:3)/dble(fft_box_size_CD(i,1))
         write(nf_bin) fft_box_size_CD(i,1), altv(1:3,i)/dble(fft_box_size_CD(i,1))
      end do
  
      allocate(cps_full(natm2,3))
      allocate(ityp_full(natm2))
      call m_IS_pack_all_ions_in_uc(ityp_full,cps_full)
! -
!	write(*,*) 'natom 2 = ',natm2
!	stop
      do i = 1, natm2
         m = ityp_full(i)
! =========================== Modified by J, Koga ============== 0.2
!         write(nf_bin) iatomn(m), ival(m), cps_full(i,1:3)
          write(nf_bin) nint(iatomn(m)), ival(m), cps_full(i,1:3)
!          write(*,*) ' I = ',i, nint(iatomn(m)), ival(m), cps_full(i,3)
! ===========================================================
      end do
      deallocate(ityp_full,cps_full)

    endif

  end subroutine wd_Header_For_Cube

  subroutine output_data_for_bt(nfout,prefix,header,version)
    integer, intent(in) :: nfout
    character(len=*), intent(in) :: prefix,header
    integer, intent(in) :: version
    integer :: un
    integer :: i,j,k,l,ik,ie,ierr,no
    integer :: mpi_comm1,mpi_comm2
    real(DP),allocatable, dimension(:,:) :: e_wk
    real(DP), dimension(3,3) :: op_br
    real(kind=DP),allocatable,dimension(:,:) :: cps_full
    integer, allocatable, dimension(:) :: ityp_full
    integer,allocatable,dimension(:) :: neordr_ek
    integer :: ib, jb, ibo, jbo
    real(kind=DP), parameter :: delta = 1.d-12
    integer :: numk
    real(kind=DP), pointer :: vkxyz_p(:,:,:)

    mpi_comm1 = mpi_kg_world
    mpi_comm2 = mpi_ge_world
    if(ekmode == OFF) then
      numk = kv3
      vkxyz_p => vkxyz
    else if (ekmode == ON) then
      numk = kv3_ek
      vkxyz_p => vkxyz_ek
    endif
    allocate(e_wk(neg,numk));e_wk=0.d0
    if(ekmode == OFF) then
      do ik = 1, kv3                                     ! MPI
         if(map_k(ik) /= myrank_k) cycle                 ! MPI
         do ie = 1, np_e                                   ! MPI
            e_wk(neordr(neg_g(ie),ik),ik) = eko_l(ie,ik)           ! MPI
         end do
      end do
      call mpi_allreduce(MPI_IN_PLACE,e_wk,neg*kv3,mpi_double_precision,mpi_sum,mpi_comm1,ierr)
      call mpi_allreduce(MPI_IN_PLACE,e_wk,neg*kv3,mpi_double_precision,mpi_sum,mpi_comm2,ierr)
    else if (ekmode == ON) then
      allocate(neordr_ek(neg))
      do ik = 1, kv3_ek
         neordr_ek = (/(ib,ib=1,neg)/)
         do ib = 1,neg-1
            do jb = ib+1, neg
               ibo = neordr_ek(ib)
               jbo = neordr_ek(jb)
               if(eko_ek(jbo,ik) < eko_ek(ibo,ik)-delta) then
                  neordr_ek(jb) = ibo
                  neordr_ek(ib) = jbo
               end if
            end do
         end do
! Substitution eko_ek for eko in the order of thier values
         do ie = 1, neg
            e_wk(ie,ik) = eko_ek(neordr_ek(ie),ik)
         end do
      end do
      deallocate(neordr_ek)
    endif

    if(mype == 0)then
    un = get_unused_unitnumber()
    write(nfout,'(a,i5)') ' !** output data for BoltzTraP; prefix: '//trim(prefix)//', version: ',version
    if (version == 1) then
       write(nfout,'(a)') ' !** template BoltzTraP input written to: '//trim(prefix)//'.intrans'
       open(un,file=trim(prefix)//'.intrans',status='replace')
       write(un,'(a)') 'GENE                     # Format of DOS'
       write(un,'(3i4,f10.5)') 0,0,0,0.0
       write(un,'(3f10.5,i8,a)') efermi*2.0d0,0.0005,0.4,int(totch) &
          &, ' # Fermilevel (Ry), energygrid, energy span around Fermilevel, number of electrons'
       write(un,'(a)') 'CALC                     # CALC (calculate expansion coeff), NOCALC read from file'
       write(un,'(a)') '5                        # lpfac, number of latt-points per k-point'
       write(un,'(a)') 'BOLTZ                    # run mode (only BOLTZ is supported)'
       write(un,'(a)') '.15                      # (efcut) energy range of chemical potential'
       write(un,'(a)') '800. 50.                 # Tmax, temperature grid'
       write(un,'(a)') '-1.                      '// &
        &'# energyrange of bands given individual DOS output sig_xxx and dos_xxx (xxx is band number)'
       write(un,'(a)') 'HISTO'
       write(un,'(a)') '0 0 0 0 0                # For scattering model undocumented'
       write(un,'(a)') '2                        # number of'
       write(un,'(a)') '1E20 -1E20               #  fixed doping levels in cm-3'
       close(un)

       write(nfout,'(a)') ' !** eigenvalue data is written to: '//trim(prefix)//'.energy'
       open(un,file=trim(prefix)//'.energy', status='replace')
       write(un,'(a)') trim(header)
       write(un,*) numk
       do i=1,numk 
           write(un,'(3f10.5,i5)') vkxyz_p(i,1:3,BUCS),neg-num_extra_bands
           do j=1,neg-num_extra_bands
              write(un,'(f10.5)') e_wk(j,i)*2.d0 ! to Rydberg units
           enddo
       enddo
       close(un)
       write(nfout,'(a)') ' !** structure  data is written to: '//trim(prefix)//'.struct'
       open(un,file=trim(prefix)//'.struct', status='replace')
       write(un,'(a)') trim(header)
       write(un,'(3f15.5)') altv(1:3,1)
       write(un,'(3f15.5)') altv(1:3,2)
       write(un,'(3f15.5)') altv(1:3,3)
       write(un,'(i5)') nopr
       do no=1,nopr
          do i = 1, 3
             do j = 1, 3
                op_br(i,j) = 0.d0
                do l = 1,3
                   do k = 1,3
                      op_br(i,j) = op_br(i,j) &
                           &           + altv(l,i)*op(l,k,no)*rltv(k,j)
                   enddo
                enddo
                op_br(i,j) = op_br(i,j)/PAI2
             enddo
          enddo
          write(un,'(9i3)') ((nint(op_br(j,i)),j=1,3),i=1,3)
       enddo
       close(un)
    else if (version == 2)then
       !version 2 format : energy in Ryd, length in Bohr
       write(nfout,'(a)') ' !** eigenvalue data is written to: '//trim(prefix)//'.energy'
       open(un,file=trim(prefix)//'.energy',status='replace')
       write(un,'(a)') trim(header)
       write(un,'(i8,i3,f10.5)') numk,nspin,efermi*2.d0
       do i=1,numk 
           write(un,'(3f10.5,i5)') vkxyz_p(i,1:3,BUCS),neg-num_extra_bands
           do j=1,neg-num_extra_bands
              write(un,'(f10.5)') e_wk(j,i)*2.d0
           enddo
       enddo
       close(un)
       write(nfout,'(a)') ' !** structure  data is written to: '//trim(prefix)//'.struct'
       open(un,file=trim(prefix)//'.structure',status='replace')
       write(un,'(a)') trim(header)
       write(un,'(3f15.5)') altv(1:3,1)
       write(un,'(3f15.5)') altv(1:3,2)
       write(un,'(3f15.5)') altv(1:3,3)
       write(un,'(i8)') natm2
       allocate(cps_full(natm2,3))
       allocate(ityp_full(natm2))
       call m_IS_pack_all_ions_in_uc(ityp_full,cps_full)
       do i=1,natm2
          write(un,'(a,3f15.5)') speciesname(ityp_full(i)),cps_full(i,1:3)
       enddo
       close(un)
    endif
    endif
    deallocate(e_wk)
  end subroutine output_data_for_bt

end subroutine Postprocessing
!$$#endif

subroutine Postprocessing_k
!$$#ifndef PARA3D
  !  T. Yamasaki,  Feb. 2004
  use m_Const_Parameters, only :   ON, OFF
  use m_Control_Parameters, only : ekmode, sw_ldos, noncol
  use m_IterationNumbers, only :   nk_in_the_process

  use m_Crystal_Structure,  only : sw_spinorbit_second_variation
  use m_SpinOrbit_SecondVariation,  only : m_SO_calc_band_energy_socsv

  use m_Control_Parameters,    only :  sw_wf_squared_rspace, sw_wf_integ_moment, &
       &                               sw_orb_popu, sw_band_unfolding, &
       &                               sw_calc_wf_orb_projection, sw_write_parity_file, &
       &                               sw_pdos, sw_partial_charge, sw_charge_rspace
  use m_Files, only : nfout, nfzaj_kall, m_Files_open_nfzaj_append_kall
  use m_ES_IO, only : m_ESIO_wd_WFs_3D

  use m_OP_rotation,  only : m_OP_wd_WFn_orb_proj, m_OP_wd_phirt2_rotated

  use m_ES_nonlocal,  only : m_ES_phir_dot_WFs_3D

  use m_Kpoints,  only : kv3, vkxyz, sw_force_kpt_inside_bz

  use m_Band_Unfolding,       only : m_BU_calc_spectral_weight_3D, &
       &                             m_BU_set_GVec_flag_refcell

  implicit none

  if ( .not. noncol .and. sw_spinorbit_second_variation == ON ) then
     call m_SO_calc_band_energy_socsv
  endif

  if ( sw_band_unfolding == ON ) then
     if ( sw_force_kpt_inside_bz == ON ) call m_BU_set_GVec_flag_refcell
     call m_BU_calc_spectral_weight_3D
  endif


  if ( sw_orb_popu == ON .and. sw_calc_wf_orb_projection == ON ) then
     call m_ES_phir_dot_WFs_3D( nfout )
     if ( sw_band_unfolding == OFF ) call m_OP_wd_WFn_orb_proj
  endif

  if(sw_ldos == ON .or. sw_pdos == ON &
  &                .or. sw_partial_charge == ON &
  &                .or. sw_charge_rspace  == ON) then
    call m_Files_open_nfzaj_append_kall()
    call m_ESIO_wd_WFs_3D(nfout, nfzaj_kall, .false., rew=.false.)
  endif

!$$#endif
end subroutine Postprocessing_k

!================================================
!  Software name : STM
!  Subroutine(s) : Initilization, aavers
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

subroutine Initialization
! $Id: Initialization.F90,v 1.3 2004/06/26 11:43:44 yamasaki Exp $
  use m_Files       ,only : nfout &
       &                  , m_Files_set_default_filenames &
       &                  , m_Files_read_file_names_data &
       &                  , m_Files_open_files_initially
  implicit none

!    -----------
  call m_Files_set_default_filenames()
  call m_Files_read_file_names_data()
  call m_Files_open_files_initially()
end subroutine Initialization

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: Renewal_of_pWaveFunctions
!
!  AUTHOR(S): M. Saito, T. Yamasaki   November/04/2003
!  
!  FURTHER MODIFICATION: M. Saito, March/26/2007
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!
subroutine Renewal_of_pWaveFunctions()
! $Id: Renewal_of_pWaveFunctions.F90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Const_Parameters, only     :  ON, OFF, DP, ORTHONORMALIZATION &
       &                            , CG, SD, MSD, SUBMAT, MATRIXDIAGON, lmMSD, lmSD, lmCG 
  use m_IterationNumbers,     only :  iteration, iteration_positron_wf
  use m_Control_Parameters,   only :  dtim_p, ipripositron &
       &                            , m_CtrlP_dtim_p_now &
       &                            , m_CtrlP_dtim_1Dsearch_now &
       &                            , m_CtrlP_submat_for_pWFs_now &
       &                            , m_CtrlP_decide_dtim_1Dsearch &
       &                            , m_CtrlP_solver_for_pWFs_now
!!$       &                           , m_CtrlP_On_or_Off_precon_pWFs
  use m_Files, only :                 nfout
  use m_Positron_Wave_Functions,only: m_pWF_renew_WF_by_SDorCG &
       &                            , m_pWF_tell_band_energy &
       &                            , m_pWF_copy_pzaj_to_pzaj_old &
       &                            , m_pWF_wd_pzaj &
       &                            , m_pWF_submat &
       &                            , m_pWF_evolve_wfs_again

! === POSITRON SCF ===
  use m_Const_Parameters,     only : Positron_CONV, Positron_GGGC, BAND_Energy, TOTAL_Energy
  use m_Control_Parameters,   only : positron_method
  use m_Total_Energy,  only : m_TE_tell_total_energy
  use m_Positron_Wave_Functions, only : pchg_l, pchgo_l
! =====

  implicit none 
  integer :: isolver, precon, sw_submat
  real(kind=DP) :: dtim

  isolver = m_CtrlP_solver_for_pWFs_now(iteration_positron_wf)
!!$  isolver = MSD
  sw_submat = m_CtrlP_submat_for_pWFs_now(iteration_positron_wf)

  dtim = m_CtrlP_dtim_p_now(iteration_positron_wf)
  if(ipripositron >= 3) write(nfout,'(" !! dtim = ",f8.4 &
       & ," <<Renewal_of_pWaveFunctions>>")') dtim

!!$  precon = m_CtrlP_On_or_Off_precon_pWFs(iteration_electronic,iteration_ionic)
  precon = OFF
  solver: select case(isolver)
  case (SD, MSD)
     call m_pWF_renew_WF_by_SDorCG(nfout,isolver,precon,dtim)
  case (lmSD, lmMSD)
     call Renew_pWF_by_lmSDorlmCG(isolver,precon,dtim)
!!$     case (RMM, RMM2, RMM2P)
!!$        call m_pWF_renew_WF(nfout,isolver,precon,dtim)
  case default
     write(nfout,'(" !! isolver = ",i5," Renewal_of_pWaveFunctions")') isolver
     call error
     stop ' error at (Renewal_of_WaveFunctions)'
  end select solver

   if(sw_submat == ON .and. (isolver /= SUBMAT .and. isolver /= MATRIXDIAGON)) then
#ifdef TRANSPOSE
      call m_pWF_submat(nfout)
#else
     if(ipripositron >= 1) write(nfout, &
          & '(" -DTRANSPOSE is required in the makefile if you want to set SUBMAT option in the p_solvers")')
#endif
   end if

   pchgo_l = pchg_l

contains
  subroutine Renew_pWF_by_lmSDorlmCG(isolver,precon,dtim)
    integer, intent(in)         :: isolver,precon
    real(kind=DP)               :: dtim
    real(kind=DP), dimension(3) :: etotal
    real(kind=DP), parameter    :: factor = 2
    real(kind=DP)               :: dtim_new = 0.d0, dtim_msdv
    integer                     :: isolver_core, mode, what_is_the_pcore_solver

    integer ::   energy_evaluation_lmm

    if ( positron_method == Positron_CONV ) then
       energy_evaluation_lmm = BAND_ENERGY
    else if ( positron_method == Positron_GGGC ) then
       energy_evaluation_lmm = TOTAL_ENERGY
       energy_evaluation_lmm = BAND_ENERGY
    endif

    isolver_core = what_is_the_pcore_solver(isolver) ! -(in this file)

    mode = ORTHONORMALIZATION

    call m_pWF_copy_pzaj_to_pzaj_old()

    if ( energy_evaluation_lmm == TOTAL_ENERGY ) then
       etotal(1) = m_TE_tell_total_energy()
    else if ( energy_evaluation_lmm == BAND_ENERGY ) then
       etotal(1) = m_pWF_tell_band_energy()
    endif

    if(ipripositron >= 2) write(nfout,'(" !! etotal(1) = ",f10.6)') etotal(1)
    dtim_msdv = m_CtrlP_dtim_1Dsearch_now(dtim)
    if(ipripositron >= 2) write(nfout,'(" !! dtim_msdv = ",f8.4)') dtim_msdv
!!$    if(isolver_core == CG) then
!!$       call m_pWF_decide_CG_direction(precon)  !  -> betacg
!!$       !    ~~~~~~~~~~~~~~~~~~~~~~~~~~
!!$       call m_pWF_renew_WF_by_SDorCG(nfout,isolver_core,precon,dtim_msdv)
!!$       !    ~~~~~~~~~~~~~~~~~~~~~~~~~
!!$    else
    call m_pWF_renew_WF_by_SDorCG(nfout,isolver_core,precon,dtim_msdv)
       !    ~~~~~~~~~~~~~~~~~~~~~~~~~
!!$    end if

    if ( energy_evaluation_lmm == TOTAL_ENERGY ) then
       etotal(2) = m_TE_tell_total_energy()
    else if(energy_evaluation_lmm == BAND_ENERGY) then
       etotal(2) = m_pWF_tell_band_energy()
    endif

    if(ipripositron >= 2) write(nfout,'(" !! etotal(2) = ",f10.6)') etotal(2)

!!$    if(isolver_core == CG .or. isolver_core == eazyCG) mode = NORMALIZATION
    call m_pWF_evolve_WFs_again(nfout,mode,dtim_msdv,factor*dtim_msdv)

    if ( energy_evaluation_lmm == TOTAL_ENERGY ) then
       etotal(3) = m_TE_tell_total_energy()
    else if(energy_evaluation_lmm == BAND_ENERGY) then
       etotal(3) = m_pWF_tell_band_energy()
    endif

    if(ipripositron >= 2) write(nfout,'(" !! etotal(3) = ",f10.6)') etotal(3)
    dtim_new = m_CtrlP_decide_dtim_1Dsearch(nfout,etotal,dtim_msdv,factor)
    mode = ORTHONORMALIZATION
    call m_pWF_evolve_WFs_again(nfout,mode,factor*dtim_msdv,dtim_new)

  end subroutine Renew_pWF_by_lmSDorlmCG

end subroutine Renewal_of_pWaveFunctions

subroutine Solve_pWaveFunctions()
! $Id: Renewal_of_pWaveFunctions.F90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Control_parameters, only :      pev_max_iteration, ipripositron
  use m_IterationNumbers, only :        iteration_positron_wf, m_Iter_positron_incre
  use m_Files, only :                   nfout
  use m_Positron_Wave_Functions, only : m_pWF_construct_pcharge &
       &                              , m_pWF_charge_rspace, m_pWF_wd_pev &
       &                              , m_pWF_wlifetime
!!  use m_Electronic_Structure, only :    m_ES_wd_vlhxcQ
  implicit none
  logical :: pEigenValues_are_Converged

!!  call Initial_pWaveFunctions()
!!  if(ipripositron >= 2) call m_ES_wd_vlhxcQ()

  Solve_pWaveFunction: do
     call m_Iter_positron_incre()
     call Renewal_of_pWaveFunctions()
     if(pEigenValues_are_Converged()) exit Solve_pWaveFunction
     call m_pWF_construct_pcharge()
     call m_pWF_charge_rspace()
  end do Solve_pWaveFunction

  call m_pWF_construct_pcharge()
  call m_pWF_charge_rspace()
  call m_pWF_wlifetime()

contains
  logical function pIterationNumber_limit()
    if(pev_max_iteration <= iteration_positron_wf) then
       pIterationNumber_limit = .true.
    else
       pIterationNumber_limit = .false.
    end if
  end function pIterationNumber_limit
end subroutine Solve_pWaveFunctions

logical function pEigenValues_are_Converged()
  use m_Files, only :                   nfout
  use m_IterationNumbers, only :        iteration_positron_wf
  use m_Control_Parameters, only :      ipripositron, pev_max_iteration
  use m_Positron_Wave_Functions, only : m_pWF_pevdff, m_pWF_wd_pev
  implicit none
  pEigenValues_are_Converged = m_pWF_pevdff()

  if(pEigenValues_are_Converged) then
     if(ipripositron >= 1) &
          & write(nfout,'(" Positron Wave Functions have converged at ",i7," -th iteration")') &
          & iteration_positron_wf
     call m_pWF_wd_pev(nfout)
  else if(iteration_positron_wf >= pev_max_iteration) then
     if(ipripositron >= 1) then
        write(nfout,'(" Positron Wave Functions have not converged")')
        write(nfout,'(" iteration_positrion_wf have reached to pev_max_iteration (= ",i5," )")') &
             & pev_max_iteration
     end if
     call m_pWF_wd_pev(nfout)
     pEigenValues_are_Converged = .true.
  end if

end function pEigenValues_are_Converged

subroutine Initial_pWaveFunctions()
  use m_Const_Parameters, only   : by_random_numbers, by_matrix_diagon
  use m_Control_Parameters, only : intpzaj, ipripositron
  use m_Files, only :              nfout
  use m_positron_Wave_Functions, only : m_pWF_IW_by_randomnumbers &
       &                              , m_pWF_modified_gram_schmidt &
       &                              , m_pWF_energy_eigen_values &
       &                              , m_pWF_allocate_pzaj_etc &

       &                              , m_pWF_wd_pev &
       &                              , m_pWF_alloc_afft_etc &
       &                              , m_pWF_dealloc_afft_etc &
       &                              , m_pWF_wd_pzaj

! == POSITRON SCF === 2015/11/28
  use m_epc_Potential,  only : m_epc_alloc, m_epc_alloc_vlhxc_p
! =================== 2015/11/28

  implicit none

  call m_epc_alloc
  call m_epc_alloc_vlhxc_p

  call m_pWF_allocate_pzaj_etc()

  if(intpzaj == by_random_numbers) then
     call m_pWF_IW_by_randomnumbers()
     call m_pWF_wd_pzaj(nfout,'after by_randum_numbers',23)
     call m_pWF_modified_gram_schmidt()
     call m_pWF_wd_pzaj(nfout,'after modified_gram_schmidt',27)
     call m_pWF_alloc_afft_etc()
     call m_pWF_energy_eigen_values()
     call m_pWF_wd_pzaj(nfout,'after energy_eigen_values',25)
     call m_pWF_dealloc_afft_etc()
  else if(intpzaj == by_matrix_diagon) then
  end if
  if(ipripositron >= 1) write(nfout,'(" --- initial positron energy eigen values ---")')
  call m_pWF_wd_pev(nfout)

end subroutine Initial_pWaveFunctions

integer function what_is_the_pcore_solver(isolver)
  use m_Const_Parameters,  only : lmSD, SD, lmMSD, MSD, lmCG, CG
  integer, intent(in) :: isolver

  if(isolver == lmSD) then
     what_is_the_pcore_solver = SD
  else if(isolver == lmMSD) then
     what_is_the_pcore_solver = MSD
!!$  else if(isolver == lmCG) then
!!$     what_is_the_core_solver = CG
  else
     what_is_the_pcore_solver = MSD
  end if
end function what_is_the_pcore_solver

!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
! Functions:  [Identifier: 13.1R]
!            Dielectric functions can be calculated when condition = INITIAL 
!
! Functions:  [Identifier: 13.1XI]
!            Dielectric functions can be calculated in the EXCITATION module
!
! =============================================================
subroutine Epsilon_Postscf

  use m_Const_Parameters, only : ON
  use m_Control_Parameters,  only : sw_phonon_with_epsilon, sw_excitation
  use m_Epsilon_ek,  only : sw_epsilon, auto_mode

  implicit none

     if(auto_mode/=0) sw_epsilon = on
!  if ( sw_phonon_with_epsilon == ON ) then
  !   if ( sw_epsilon == ON ) then
        call using_epsilon_ek
        write(6,'(" using_epsilon_ek")')
  !   else if ( sw_excitation == ON ) then
  !      call using_excitation
  !      write(6,'(" using_excitation")')
  !   endif
!  else
!     if ( sw_excitation == ON ) call using_excitation
!     if ( sw_epsilon == ON )    call using_epsilon_ek
!  endif


end subroutine Epsilon_Postscf

subroutine using_epsilon_ek

  use m_Control_Parameters, only : sw_phonon_with_epsilon
  use m_Const_Parameters,  only : on

  use m_KPoints, only : kv3, kv3_ek, m_Kp_cp_vkxyz_to_vkxyz_ek, &
       &                m_Kp_alloc_kpoints_ek
  use m_IterationNumbers, only : nk_in_the_process, nk_converged
!
  use m_Electronic_Structure, only : m_ES_cp_eko_l_to_eko_ek2, &
       &                             m_ES_alloc_eko_ek

  use m_Epsilon_ek,  only : set_dielectric_tensor
  use m_Raman,  only : m_Raman_write_dielec_tensors

  implicit none

  logical, save :: FirstFlag = .true.

  nk_in_the_process = 1
  nk_converged = kv3

  call m_Kp_alloc_kpoints_ek
  call m_Kp_cp_vkxyz_to_vkxyz_ek
  call m_ES_alloc_eko_ek
  call m_ES_cp_eko_l_to_eko_ek2
!
  if ( FirstFlag ) then
     call Initialization_Epsilon(0)
     FirstFlag = .false.
  else
     call Initialization_Epsilon(1)
  endif

  call Transition_moment_Epsilon
  call Prep_for_Calc_Epsilon
  call Calc_Epsilon
  call Calc_Nonlinear_optics

  if ( sw_phonon_with_epsilon  == ON ) then
     call set_dielectric_tensor
     call m_Raman_write_dielec_tensors
  else
     call WriteDownData_onto_Files_Eps
  endif

end subroutine Using_epsilon_ek

!=======================================================================
!
!  SOFTWARE NAME : PHASE version 2.0
!
!  SUBROUINE: dxml_fft, mulfac, dummy_fft
!
!  AUTHOR(S): H. Katagiri   August/20/2003
!  
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!     The names of the contributors to the original version are as
!  follows. Dr. Hideki Katagiri, DR. Koichi Kato, Dr. Tsuyoshi Miyazaki,
!  Dr. Yoshitada Morikawa, Dr. Hideaki Sawada, Dr. Toshihiro Uchiyama,
!  Dr. Tsuyoshi Uda and Dr. Takahiro Yamasaki.
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!
#ifdef DECFFT
      subroutine dxml_fft(iop,id,nl,nm,nn,afft)
c $Id: decfft_ent.F,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
      implicit real*8(a-h,o-z)
      include '/usr/include/DXMLDEF.FOR'
      real*8 afft(*)
      record /DXML_d_fft_structure_3D/ fft_struct_cd,fft_struct_wd
     &     , fft_struct_pwd
      record /DXML_z_fft_structure_3D/ fft_struct_cz,fft_struct_wz
     &     , fft_struct_pwz
      save fft_struct_cd,fft_struct_wd
      save fft_struct_cz,fft_struct_wz
      save nfft_cd,nfft_cz,nfft_wd,nfft_wz
      save nbox_cd,nbox_cz,nbox_wd,nbox_wz
c ------- Positron start 
      save fft_struct_pwd,fft_struct_pwz
      save nfft_pwd,nfft_pwz
      save nbox_pwd,nbox_pwz
c ------- Positron end
c
c     IOP=1..DIRECT, IOP=2..INVERSE (REAL TRANSFORM)
c     IOP=1..INVERSE, IOP=2..DIRECT (COMPLEX TRANSFORM)
c
      entry wd_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call dfft_apply_3d('r','c','f',afft,afft,id,nm,
     $                        fft_struct_wd,1,1,1)
        else
          call dfft_apply_3d('c','r','b',afft,afft,id,nm,
     $                        fft_struct_wd,1,1,1)
          call mulfac(afft,nbox_wd,nfft_wd)
        endif
      return

      entry pwd_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call dfft_apply_3d('r','c','f',afft,afft,id,nm,
     $                        fft_struct_pwd,1,1,1)
        else
          call dfft_apply_3d('c','r','b',afft,afft,id,nm,
     $                        fft_struct_pwd,1,1,1)
          call mulfac(afft,nbox_pwd,nfft_pwd)
        endif
      return
c
      entry wz_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call zfft_apply_3d('c','c','f',afft,afft,id,nm,
     $                        fft_struct_wz,1,1,1)
        else
          call zfft_apply_3d('c','c','b',afft,afft,id,nm,
     $                        fft_struct_wz,1,1,1)
          call mulfac(afft,nbox_wz,nfft_wz)
        endif
      return
c
      entry pwz_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call zfft_apply_3d('c','c','f',afft,afft,id,nm,
     $                        fft_struct_pwz,1,1,1)
        else
          call zfft_apply_3d('c','c','b',afft,afft,id,nm,
     $                        fft_struct_pwz,1,1,1)
          call mulfac(afft,nbox_pwz,nfft_pwz)
        endif
      return
c
      entry cd_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call dfft_apply_3d('r','c','f',afft,afft,id,nm,
     $                        fft_struct_cd,1,1,1)
        else
          call dfft_apply_3d('c','r','b',afft,afft,id,nm,
     $                        fft_struct_cd,1,1,1)
          call mulfac(afft,nbox_cd,nfft_cd)
        endif
      return
c
      entry cz_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call zfft_apply_3d('c','c','b',afft,afft,id,nm,
     $                        fft_struct_cz,1,1,1)
          call mulfac(afft,nbox_cz,nfft_cz)
        else
          call zfft_apply_3d('c','c','f',afft,afft,id,nm,
     $                        fft_struct_cz,1,1,1)
        endif
      return
          
      entry wd_init(id,nl,nm,nn)
        call dfft_init_3d(nl,nm,nn,fft_struct_wd,.true.)
        nbox_wd=id*nm*nn
        nfft_wd=nl*nm*nn
        return
      entry pwd_init(id,nl,nm,nn)
        call dfft_init_3d(nl,nm,nn,fft_struct_pwd,.true.)
        nbox_pwd = id*nm*nn
        nfft_pwd = nl*nm*nn
        return
      entry wz_init(id,nl,nm,nn)
        call zfft_init_3d(nl,nm,nn,fft_struct_wz,.true.)
        nbox_wz=id*nm*nn*2
        nfft_wz=nl*nm*nn
        return
      entry pwz_init(id,nl,nm,nn)
        call zfft_init_3d(nl,nm,nn,fft_structu_pwz,.true.)
        nbox_pwz = id*nm*nn*2
        nfft_pwz = nl*nm*nn
        return
      entry cd_init(id,nl,nm,nn)
        call dfft_init_3d(nl,nm,nn,fft_struct_cd,.true.)
        nbox_cd=id*nm*nn
        nfft_cd=nl*nm*nn
        return
      entry cz_init(id,nl,nm,nn)
        call zfft_init_3d(nl,nm,nn,fft_struct_cz,.true.)
        nbox_cz=id*nm*nn*2
        nfft_cz=nl*nm*nn
        return
      end
      subroutine mulfac(afft,nbox,nfft)
      implicit real*8(a-h,o-z)
      dimension afft(nbox)
      scale=dble(nfft)
      do i=1,nbox
        afft(i)=afft(i)*scale
      enddo
      return
      end
#else
      subroutine dummy_fft()
c $Id: decfft_ent.F,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
      return
      end
#endif

!================================================
!  Software name : STM
!  Module : m_Kpoints
!  Subroutine(s) : m_Kp_rd_kv3, m_Kp_alloc, m_Kp_rd
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  FURTHER MODIFICATION: Junichiro  Koga (June 24, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_Kpoints
! $Id: m_Kpoints.f90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  use m_ArraySize_Parameters, only : knv3
  use m_Const_Parameters, only     : DP, CARTS, BUCS, CRDTYP
  use m_Timing,             only : tstatc0_begin, tstatc0_end

  implicit none

  integer                                      :: kv3   ! #sampling k-points
  integer                                      :: nspin ! nspin( 1 or 2 )
  real(kind=DP), allocatable, dimension(:,:,:) :: vkxyz ! sampling k-points

contains
  subroutine m_Kp_rd_kv3(nfinp)
    integer, intent(in) :: nfinp

    read(nfinp,*) kv3, nspin
    print *, ' kv3, nspin =', kv3, nspin
  end subroutine m_Kp_rd_kv3

  subroutine m_Kp_alloc
    allocate(vkxyz(kv3,3,CRDTYP))
  end subroutine m_Kp_alloc

  subroutine m_Kp_rd_kpoints(nfinp)
    integer, intent(in) :: nfinp
    integer             :: i, j, k

!    do i = 1, kv3 * nspin
    do i = 1, kv3
      read(nfinp,*) j, (vkxyz(i,k,CARTS),k=1,3),(vkxyz(i, k, BUCS), k=1,3)
      print *, ' k, kx, ky, kz =', i, (vkxyz(i,k,BUCS),k=1,3)
    end do
  end subroutine m_Kp_rd_kpoints

end module m_Kpoints

!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, this module is added.
!
! Company:  ASMS Co.,Ltd.
! Functions:
!
!     SpinOrbit strength (splitting) is read from GNCPP2 file
!
! =============================================================

module m_SpinOrbit_FromFile

  use m_Const_Parameters,  only : DP
  use m_Control_Parameters,  only: printable
  use m_Files, only : nfout, nfpot, m_Files_open_ps_files, m_Files_close_ps_files, &
       &              m_Files_open_ps_file, m_Files_close_ps_file
  use m_Ionic_System,  only : natm, scaling_so, ivan, iatomn
  use m_Parallelization,  only : mype, npes, mpi_comm_group, ierr
  use m_PseudoPotential,  only : ntyp, ityp, Mat_SOC_Strength_nonpaw, nloc, ntau
  use m_Orbital_QuantumNum, only : num_orb_index_data, &
       &                           qnum_n_orb_index, qnum_l_orb_index, &
       &                           qnum_t_orb_index, qnum_tau_orb_index

  use m_SpinOrbit_Potential,  only : Mat_SOC_Strength

  implicit none
  include 'mpif.h'

contains

  subroutine m_SO_set_SOC_strength_from_PP
    integer :: it, nfp, ia, ierror

    if (mype == 0) then
!       call m_Files_open_ps_files(ivan,iatomn,ntyp,ierror)
       nfp = 0
       Do it=1, ntyp
          call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
          nfp = nfp +1
          call set_soc_from_pp_file( it, nfpot(nfp) )
          call m_Files_close_ps_file(it)
       End Do
    endif

    if ( npes > 2 ) then
       call mpi_bcast( Mat_SOC_Strength_nonpaw, nloc*ntau*ntau*ntyp, &
            &          mpi_double_precision, 0, mpi_comm_group, ierr )
    endif

    Do ia=1, natm
       it = ityp(ia)
       Mat_SOC_Strength(:,:,:,ia) = Mat_SOC_Strength_nonpaw(:,:,:,it)  &
            &                       * scaling_so(it)
    End do

!    call m_Files_close_ps_files

  contains

    subroutine set_soc_from_pp_file( it, nfp )
      integer, intent(in) :: it, nfp

      integer :: ikey
      character(len=30)    :: line

      integer :: num_soc_read
      integer :: i, j1, n1, l1, t1, n2, l2, t2, tau1, tau2
      real(kind=DP) :: c1
      
      num_soc_read = 0

      rewind(nfp)
      Do while (.true.)
         read(nfp,'(a30)',end=20) line
         ikey = index(line,'SOC-VALENCE')
         if ( ikey /=0 ) then
            read(nfp,*) num_soc_read
            goto 10
         endif
      End Do
      
! ------------------
10    Do i=1, num_soc_read
         read(nfp,*) n1, l1, t1, n2, l2, t2, c1
         
         if ( l1 /= l2 ) cycle
         
         tau1 = 0;  tau2 = 0
         Do j1=1, num_orb_index_data(it)
            if ( n1 == qnum_n_orb_index(it,j1) &
                 &    .and. l1 == qnum_l_orb_index(it,j1) &
                 &    .and. t1 == qnum_t_orb_index(it,j1) ) then       
               tau1 = qnum_tau_orb_index(it,j1)
            endif
         End do
         Do j1=1, num_orb_index_data(it)
            if ( n2 == qnum_n_orb_index(it,j1) &
                 &    .and. l2 == qnum_l_orb_index(it,j1) &
                 &    .and. t2 == qnum_t_orb_index(it,j1) ) then       
               tau2 = qnum_tau_orb_index(it,j1)
            endif
         End do

         if ( tau1 ==0 .or. tau2 == 0 ) cycle
         
         Mat_SOC_Strength_nonpaw( l1 +1, tau1, tau2, it ) = c1
      End Do

      return

! ------------------
20    if (printable) then
         write(nfout,*) "!* soc strength for valence are not found in PP for it=", it
      endif

    end subroutine set_soc_from_pp_file

  end subroutine m_SO_set_SOC_strength_from_PP

end module m_SpinOrbit_FromFile

!================================================
!  Software name : STM
!  Module m_Timing
!  Subroutine(s) : tstatc0_begin, wd_the_subroutine_name, tstac0_end
!                  tstatc_init, tstatc_wd0, tstatc_wd, tstatc_iter
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_Timing
! $Id: m_Timing.f90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  use m_Const_Parameters,   only : DP
  use m_Control_Parameters, only : ipri

  implicit none

  integer, parameter :: MSBRNM         = 100
  integer, parameter :: long_name_size = 32
  character*(long_name_size), dimension(0:MSBRNM) :: subroutine_names
  character*(long_name_size)                 :: temp_str
  real(DP), dimension(0:MSBRNM)              :: tstart=0, ecpu=0
  integer, dimension(MSBRNM)  :: iorder
  integer                     :: n_sub_names = 0

  real(DP)               :: ecpu_previous = 0.d0
  real(DP), parameter    :: UMICRO = 1.d-6
  real(DP), parameter    :: PCPUDF = 0.03
  integer, parameter     :: N_SUBROUTINES = 10

contains
  subroutine tstatc0_begin(a_sub_name,id)
    character*(*), intent(in) :: a_sub_name
    integer, intent(inout)    :: id

    real(kind=DP)             :: t_start
    integer                   :: i, len

    len = len_trim(a_sub_name)

! -- finding the pointer of subroutine_names --'    
    if(id <= 0) then
       do i = 1, n_sub_names
          if(a_sub_name(1:len) == subroutine_names(i)(1:len)) then
             id = i
             exit
          end if
       end do
    end if
    if(id <= 0) then
       if( n_sub_names < MSBRNM) then
          n_sub_names = n_sub_names + 1
          id          = n_sub_names
          write(subroutine_names(id),'(a32)') a_sub_name
       else
          print *,' !! Size of an array of subroutine_names should be enlarged (->m_Timing)'
       end if
    end if

    if(ipri >= 2) call wd_the_subroutine_name
!!$   if(ipri >= 2) print '(" <<< ",a32," >>>")',subroutine_names(id)

    if(id >= 1 .and. id <= MSBRNM) then
       call gettod(t_start)
       tstart(id) = t_start
    end if
  contains
    subroutine wd_the_subroutine_name
      integer :: i, ip
      ip = long_name_size - len
      ip = ip / 2
      do i = 1, ip
         temp_str(i:i) = '-'
      end do
      do i = 1, len
         temp_str(i+ip:i+ip) = a_sub_name(i:i)
      end do
      do i = ip + len + 1, long_name_size
         temp_str(i:i) = '-'
      end do
      print '(" <<<",a32,">>>")',temp_str
    end subroutine wd_the_subroutine_name
  end subroutine tstatc0_begin

  subroutine tstatc0_end(id)
    integer, intent(in) :: id
    real(kind=DP) :: t_end, t_used

    call gettod(t_end)
    t_used = t_end - tstart(id)
    ecpu(id) = ecpu(id) + t_used * UMICRO
  end subroutine tstatc0_end

  subroutine tstatc_init
    tstart(1:MSBRNM) = 0.d0; ecpu(1:MSBRNM) = 0.d0
  end subroutine tstatc_init

  subroutine tstatc_wd0
    integer i, ip, nsub
    print '(" n_sub_names = ",i5)', n_sub_names
    print '(" << cpu time statistics >>")'

    call tsort(ecpu(1),MSBRNM,iorder)

    nsub = n_sub_names

    do i = 1, nsub
       ip = iorder(i)
       if(ecpu(ip) < UMICRO) exit
       print '(i5,2x,a32,f11.5,"(sec.)")',i,subroutine_names(ip),ecpu(ip)
    end do
  end subroutine tstatc_wd0

  subroutine tstatc_wd(iteration)
    integer, intent(in) :: iteration
    integer i, ip, nsub
    real(kind=DP) :: cpudif, pecpu

    cpudif = dabs(ecpu(0) - ecpu_previous)
    if(cpudif < ecpu_previous * PCPUDF .or. ecpu(0) < UMICRO) then
!!$       print '(" ! cpudif  = ",f20.10," ecpu_prev = ",f20.10)', cpudif, ecpu_previous
!!$       print '(" ! ecpu(0) = ",f20.10)',ecpu(0)
       goto 1001
    end if

    print '(" << CPU Time Consumption -- TOP",i4," Subroutines (",i5,") >>")' &
         & , N_SUBROUTINES, iteration
    call tsort(ecpu(1),MSBRNM,iorder)

    nsub = min(n_sub_names, N_SUBROUTINES)
    do i = 1, nsub
       ip = iorder(i)
       if(ecpu(ip) < UMICRO) exit
       pecpu = ecpu(ip)/ecpu(0) * 100
       print '(2i4,2x,a32,f11.5,"(sec.)",f6.2,"(%)")' &
            & ,i,ip, subroutine_names(ip),ecpu(ip),pecpu
    end do
    print '(6x,"Total cpu time of this iteration",4x,f11.5,"(sec.)")',ecpu(0)

1001 ecpu_previous = ecpu(0)
  end subroutine tstatc_wd

  subroutine tstatc_iter(iteration, first_iteration_of_this_job)
    integer, intent(in) :: iteration, first_iteration_of_this_job
    real(kind=DP) :: t_end, t_used
    call gettod(t_end)
    if(iteration > first_iteration_of_this_job) then
       t_used  = t_end - tstart(0)
       ecpu(0) = t_used * UMICRO
    end if
    tstart(0) = t_end
  end subroutine tstatc_iter

end module m_Timing

      subroutine papi_initialize()
      implicit NONE
      include 'f90papi.h'

      integer   :: i, flags, res

      integer, parameter :: counter_max = 10
      integer*4 :: counter_list(counter_max)
      integer   :: event_set
      integer*8 :: i_results(counter_max)
      real*8    :: fp_results(counter_max)
      integer   :: PAPI_test
      integer   :: PAPI_dummy

      character*(PAPI_MAX_STR_LEN) :: evt_name(10)
      logical      :: PAPI_ready

      common /papi_common/ PAPI_ready, event_set, PAPI_test, PAPI_dummy,
     $                     counter_list, evt_name, i_results

      res = PAPI_VER_CURRENT
      call PAPIf_library_init(res)
      if(res/=PAPI_VER_CURRENT)then
         print*,"PAPI initialize failed",res
      endif
      PAPI_ready=(res==PAPI_VER_CURRENT)
      if(PAPI_ready)then
         counter_list(1)= PAPI_TLB_DM
         evt_name(1)    ="PAPI_TLB_DM"
         counter_list(2)= PAPI_L1_DCM
         evt_name(2)    ="PAPI_L1_DCM"
         counter_list(3)= PAPI_L2_DCM
         evt_name(3)    ="PAPI_L2_DCM"
         counter_list(4)= PAPI_TLB_TL
         evt_name(4)    ="PAPI_TLB_TL"
         counter_list(5)= PAPI_TLB_IM
         evt_name(5)    ="PAPI_TLB_IM"
         counter_list(6)= PAPI_RES_STL
         evt_name(6)    ="PAPI_RES_STL"

         PAPI_test = 2

         event_set = PAPI_NULL
         call PAPIf_create_eventset(event_set, res)
         if(res/=PAPI_OK)then
            print*,"PAPI event cannot be created",res
            stop
         endif
         do i=1,PAPI_test
            call PAPIf_query_event(counter_list(i), res)
            if(res/=PAPI_OK)then
               print*,"PAPI event is not supported"
               stop
            endif
            call PAPIf_add_event(event_set, counter_list(i), res)
            if(res/=PAPI_OK)then
               print*,"PAPI event cannot be added"
               stop
            endif
         enddo
         print*,"PAPI all events are initialized"
         PAPI_ready=(res==PAPI_OK)
      endif

      end subroutine

      subroutine papi_timer_start()

      include 'f90papi.h'

      integer   :: flags, res

      integer, parameter :: counter_max = 10
      integer*4 :: counter_list(counter_max)
      integer   :: event_set
      integer*8 :: i_results(counter_max)
      real*8    :: fp_results(counter_max)
      integer   :: PAPI_test
      integer   :: PAPI_dummy

      character*(PAPI_MAX_STR_LEN) :: evt_name(10)
      logical      :: PAPI_ready

      common /papi_common/ PAPI_ready, event_set, PAPI_test, PAPI_dummy,
     $                     counter_list, evt_name, i_results

         if(PAPI_ready)then
            call PAPIf_start(event_set, res)
            if(res/=PAPI_OK)then
               print*,"ERR PAPIf_start"
            endif
         endif

      end subroutine

      subroutine papi_timer_stop()

      include 'f90papi.h'

      integer   :: flags, res

      integer, parameter :: counter_max = 10
      integer*4 :: counter_list(counter_max)
      integer   :: event_set
      integer*8 :: i_results(counter_max)
      real*8    :: fp_results(counter_max)
      integer   :: PAPI_test
      integer   :: PAPI_dummy

      character*(PAPI_MAX_STR_LEN) :: evt_name(10)
      logical      :: PAPI_ready

      common /papi_common/ PAPI_ready, event_set, PAPI_test, PAPI_dummy,
     $                     counter_list, evt_name, i_results

         if(PAPI_ready)then
            call PAPIf_stop(event_set, i_results, res)
            if(res/=PAPI_OK)then
               print*,"ERR PAPIf_stop"
            endif
         endif

      end subroutine

      subroutine papi_timer_report()

      include 'f90papi.h'

      integer   :: flags, res

      integer, parameter :: counter_max = 10
      integer*4 :: counter_list(counter_max)
      integer   :: event_set
      integer*8 :: i_results(counter_max)
      real*8    :: fp_results(counter_max)
      integer   :: PAPI_test
      integer   :: PAPI_dummy

      character*(PAPI_MAX_STR_LEN) :: evt_name(10)
      logical      :: PAPI_ready

      common /papi_common/ PAPI_ready, event_set, PAPI_test, PAPI_dummy,
     $                     counter_list, evt_name, i_results

         if(PAPI_ready)then
            print*,">>>>> PAPI result start <<<<<"
            do icc=1,PAPI_test
               print*,evt_name(icc)(1:16),i_results(icc)
            enddo
            print*,">>>>> PAPI result end   <<<<<"
         endif

      end subroutine

module m_Band_Unfolding
  use m_Const_Parameters,   only : PAI2, CARTS, DP, OFF, MAPPED, NOTMAPPED, SKIP, &
       &                           GAMMA, BUCS, CMPLDP, ON, Neglected
  use m_Control_Parameters,  only : ekmode, neg, noncol, num_extra_bands, &
       &                            ndim_spinor, kimg, flag_mpi_g_dot_r, nspin, af, &
       &                            sw_orb_popu, orb_popu_method, SpinOrbit_Mode, &
       &                            wf_orb_proj_print_format, num_proj_elems, &
       &                            proj_group, proj_attribute, &
       &                            sw_calc_wf_orb_projection, band_unfolding_active, &
       &                            tolerance_Gvec_matching

  use m_PseudoPotential,    only : modnrm, nlmta, ilmt, lmta, q, ilmt_phi, ltp_phi, &
       &                           mtp_phi, taup_phi, lmta_phi, lmtt_phi, &
       &                           ltp, mtp, taup, nlmtt_phi, nlmta_phi, &
       &                           q_phirt_pw, qorb, m_PP_tell_iorb_lmtt, &
       &                           m_PP_tell_iorb_ia_l_m_tau
  use m_Crystal_Structure,  only : altv_refcell, rltv, univol
  use m_Kpoints,  only : kv3, vkxyz, k_symmetry, kv3_ek, vkxyz_refcell
  use m_Files,        only : nfout, nfband_spectr_wght, &
       &                     m_Files_open_nfband_spwt, &
       &                     m_Files_close_nfband_spwt, nfwfk_orb_proj, &
       &                     m_Files_open_nfwfk_orb_proj, &
       &                     m_Files_close_nfwfk_orb_proj

  use m_PlaneWaveBasisSet,    only : kg, ngabc, iba, nbase, nbmx, GVec_on_refcell

  use m_Parallelization,  only : mype, npes, myrank_k, map_k, ista_e, iend_e, map_z, &
       &                         mpi_comm_group, ista_nbmx, mp_nbmx, np_nbmx, ng_nbmx, &
       &                         mpi_nbmx_world, ierr, ista_k, iend_k, np_e, istep_e, &
       &                         nrank_e

  use m_IterationNumbers,  only : nk_in_the_process
  use m_Ionic_System,   only : pos, natm, ityp, altv, iproj_group
  use m_Electronic_Structure,  only : zaj_l, neordr
  use m_ES_nonlocal,     only : zfcos, zfsin, zfcos_mpi, zfsin_mpi, &
       &                        m_ES_alloc_zfsincos, m_ES_dealloc_zfsincos, &
       &                        alloc_zfsincos_mpi, dealloc_zfsincos_mpi, &
       &                        m_ES_betar_dot_WFs_4_lmta_k, &
       &                        m_ES_alloc_arai, m_ES_dealloc_arai, &
       &                        m_ES_phir_dot_WFs_4_lmta_k, &
       &                        m_ES_betar_dot_Psi_4_each_k
  use m_NonLocal_Potential,  only : snl, phig, norm_phig

  use m_Kpoints,  only :  sw_force_kpt_inside_bz,  GvecTrans_kpt

  use m_SpinOrbit_Potential,  only :  MatU_ylm_RC_L0,  MatU_ylm_RC_L1,  MatU_ylm_RC_L2, &
       &                              MatU_ylm_RC_L3
  
  implicit none
  include 'mpif.h'

  real(kind=DP), allocatable :: fsr_filtered(:,:,:), fsi_filtered(:,:,:)
  real(kind=DP), allocatable :: compr_filtered(:,:,:,:), compi_filtered(:,:,:,:)
contains

  subroutine m_BU_set_GVec_Flag_refcell
    integer :: i, j, k, ik
    real(kind=DP) :: vec1(3), cx, cy, cz, delta

    if ( allocated( Gvec_on_refcell ) ) deallocate( Gvec_on_refcell )
    if ( sw_force_kpt_inside_bz == ON ) then
       allocate( GVec_on_refcell(kg,ista_k:iend_k) );
    else
       allocate( GVec_on_refcell(kg,1) );
    endif
    GVec_on_refcell = 0

    delta = tolerance_Gvec_matching

    if ( sw_force_kpt_inside_bz == ON ) then
       Do ik=ista_k, iend_k
          Do i=1, kg
             vec1(1) = ( ngabc(i,1) +GVecTrans_kpt(ik,1) )*rltv(1,1) &
                  &   +( ngabc(i,2) +GVecTrans_kpt(ik,2) )*rltv(1,2) &
                  &   +( ngabc(i,3) +GVecTrans_kpt(ik,3) )*rltv(1,3)
             vec1(2) = ( ngabc(i,1) +GVecTrans_kpt(ik,1) )*rltv(2,1) &
                  &   +( ngabc(i,2) +GVecTrans_kpt(ik,2) )*rltv(2,2) &
                  &   +( ngabc(i,3) +GVecTrans_kpt(ik,3) )*rltv(2,3)
             vec1(3) = ( ngabc(i,1) +GVecTrans_kpt(ik,1) )*rltv(3,1) &
                  &   +( ngabc(i,2) +GVecTrans_kpt(ik,2) )*rltv(3,2) &
                  &   +( ngabc(i,3) +GVecTrans_kpt(ik,3) )*rltv(3,3)
             cx = 0.0d0; cy = 0.0d0; cz = 0.0d0
             Do k=1, 3
                cx = cx +altv_refcell(k,1) *vec1(k)
                cy = cy +altv_refcell(k,2) *vec1(k)
                cz = cz +altv_refcell(k,3) *vec1(k)
             End Do

             cx = cx /PAI2;     cy = cy /PAI2;      cz = cz /PAI2
             cx = abs( cx -nint(cx) );
             cy = abs( cy -nint(cy) );
             cz = abs( cz -nint(cz) );

             if ( cx < delta .and. cy < delta .and. cz < delta ) then
                GVec_on_refcell(i,ik) = 1
             endif
          ENd Do
       End Do
    else
       Do i=1, kg
          vec1(1) = ngabc(i,1) *rltv(1,1) +ngabc(i,2) *rltv(1,2) +ngabc(i,3) *rltv(1,3)
          vec1(2) = ngabc(i,1) *rltv(2,1) +ngabc(i,2) *rltv(2,2) +ngabc(i,3) *rltv(2,3)
          vec1(3) = ngabc(i,1) *rltv(3,1) +ngabc(i,2) *rltv(3,2) +ngabc(i,3) *rltv(3,3)

          cx = 0.0d0; cy = 0.0d0; cz = 0.0d0
          Do k=1, 3
             cx = cx +altv_refcell(k,1) *vec1(k)
             cy = cy +altv_refcell(k,2) *vec1(k)
             cz = cz +altv_refcell(k,3) *vec1(k)
          End Do

          cx = cx /PAI2;     cy = cy /PAI2;      cz = cz /PAI2
          cx = abs( cx -nint(cx) );
          cy = abs( cy -nint(cy) );
          cz = abs( cz -nint(cz) );

          if ( cx < delta .and. cy < delta .and. cz < delta ) then
             GVec_on_refcell(i,1) = 1
          endif
       ENd Do
    endif

  end subroutine m_BU_set_GVec_Flag_refcell

  subroutine m_BU_calc_spectral_weight
    real(kind=DP), allocatable :: SpectralWeight(:,:)
    integer :: ik, ie, neg_t
    integer :: lun, j, k

    real(kind=DP) :: c1
    real(kind=DP), allocatable :: work(:,:), work2(:)
    integer, allocatable :: iwork(:,:), neordr_t(:,:)

    band_unfolding_active = .true.
    
    if ( modnrm /= SKIP ) then
       allocate( fsr_filtered(np_e,nlmta,ista_k:iend_k) )
       if( .not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate( fsi_filtered(np_e,nlmta,ista_k:iend_k)); 
       else
          allocate( fsi_filtered(1,1,1) )
       endif
       fsr_filtered = 0.0d0;     fsi_filtered = 0.d0
       call m_BU_betar_dot_WFs(nfout)
    end if
       
    allocate( SpectralWeight(neg,kv3) ); SpectralWeight = 0.0d0

    call softpart
    if ( modnrm /= SKIP ) call hardpart

    if ( npes > 1 ) then
       allocate( work(neg,kv3) ); work = 0.0d0
       call mpi_allreduce( SpectralWeight, work, kv3 *neg, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       SpectralWeight = work
       deallocate( work )
    endif

    neg_t = neg -num_extra_bands

    allocate( work2(neg) )
#if 1
    allocate( neordr_t(neg,kv3) ); neordr_t = 0
    neordr_t(:,ista_k:iend_k) = neordr(:,ista_k:iend_k)
    if ( npes > 1 ) then
       allocate( iwork(neg,kv3) )
       call mpi_allreduce( neordr_t, iwork, neg*kv3, mpi_integer, mpi_sum, &
            &              mpi_comm_group, ierr )
       neordr_t = iwork /nrank_e
       deallocate( iwork )
    endif
#endif    

    if ( mype == 0 ) then
       if ( ekmode == ON ) then
          if ( nk_in_the_process == 1 ) then
             call m_Files_open_nfband_spwt(2)
             write(nfband_spectr_wght,'(A,I8)') 'num_kpoints = ', kv3_ek /ndim_spinor
             write(nfband_spectr_wght,'(A,I8)') 'num_bands   = ', neg_t
             write(nfband_spectr_wght,'(A,I8)') 'nspin       = ', nspin /ndim_spinor
             write(nfband_spectr_wght,*)
          else
             call m_Files_open_nfband_spwt(3)
          endif
          Do ik=1, kv3, ndim_spinor
             if ( ik+nk_in_the_process -1 > kv3_ek ) cycle
             write( nfband_spectr_wght,'(A,I6,A,3F16.8,A)') &
                  &             "ik = ", ik +nk_in_the_process -1, " ( ", &
                  &              vkxyz_refcell(ik+nk_in_the_process-1,1:3,BUCS), " )"
             if ( noncol ) then
                Do ie=1, neg
#if 1
                   work2(ie) = SpectralWeight(neordr_t(ie,ik),ik) &
                        &     +SpectralWeight(neordr_t(ie,ik+1),ik+1)
#else
                   work2(ie) = SpectralWeight(ie,ik) &
                        &     +SpectralWeight(ie,ik+1)
#endif
                End Do
             else
                Do ie=1, neg
#if 1
                   work2(ie) = SpectralWeight(neordr_t(ie,ik),ik)
#else
                   work2(ie) = SpectralWeight(ie,ik)
#endif
                End Do
             endif
             write( nfband_spectr_wght,'(4f18.10)') ( work2(ie),ie=1, neg_t )
             write( nfband_spectr_wght,* )
          End Do
          call m_Files_close_nfband_spwt

       else
          call m_Files_open_nfband_spwt(2)
          write(nfband_spectr_wght,'(A,I8)') 'num_kpoints = ', kv3 /ndim_spinor
          write(nfband_spectr_wght,'(A,I8)') 'num_bands   = ', neg_t
          write(nfband_spectr_wght,'(A,I8)') 'nspin       = ', nspin /ndim_spinor
          write(nfband_spectr_wght,*)
          Do ik=1, kv3, ndim_spinor
             write( nfband_spectr_wght,'(A,I6,A,3F16.8,A)') &
                  &             "ik = ", ik, " ( ", &
                  &                      vkxyz_refcell(ik,1:3,BUCS), " )"
             if ( noncol ) then
                Do ie=1, neg
#if 1
                   work2(ie) = SpectralWeight(neordr_t(ie,ik),ik) &
                        &     +SpectralWeight(neordr_t(ie,ik+1),ik+1)
#else
                   work2(ie) = SpectralWeight(ie,ik ) &
                        &     +SpectralWeight(ie,ik+1)
#endif
                End Do
             else
                Do ie=1, neg
#if 1
                   work2(ie) = SpectralWeight(neordr_t(ie,ik),ik)
#else
                   work2(ie) = SpectralWeight(ie,ik)
#endif
                End Do
             endif
             write( nfband_spectr_wght,'(4f18.10)') ( work2(ie),ie=1, neg_t )
             write( nfband_spectr_wght,* )
          End Do
          call m_Files_close_nfband_spwt
       endif
    endif
    deallocate( work2 )
#if 1
    deallocate( neordr_t )
#endif

! -------------------------------------------    
#if 0
    if ( sw_orb_popu == ON .and. sw_calc_wf_orb_projection == ON &
         &                 .and. orb_popu_method == 2 ) then
       allocate( compr_filtered(np_e,nlmta_phi,1,ista_k:iend_k));
       if( .not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate( compi_filtered(np_e,nlmta_phi,1,ista_k:iend_k));
       else
          allocate( compi_filtered(1,1,1,1) )
       endif
       compr_filtered = 0.0d0;  compi_filtered = 0.0d0
       call m_BU_phir_dot_WFs(nfout)
       call m_BU_wd_Wfn_orb_proj
       deallocate( compr_filtered );    deallocate( compi_filtered )
    endif
#endif

    deallocate( SpectralWeight )
    if ( allocated( fsr_filtered ) ) deallocate( fsr_filtered )
    if ( allocated( fsi_filtered ) ) deallocate( fsi_filtered )

    band_unfolding_active = .false.
    
  contains

    subroutine hardpart
      integer :: ik, i, ib1, ia, it, lmt1, lmt2, p1, p2
      real(kind=DP) :: csum

      Do ik=1, kv3, ndim_spinor
         if ( map_k(ik) /= myrank_k ) cycle

         Do ie=ista_e, iend_e
            ib1 = map_z(ie)

            csum = 0.0d0
            do ia = 1, natm
               it = ityp(ia)
               do lmt1 = 1, ilmt(it)
                  p1 = lmta(lmt1,ia)
                  do lmt2 = 1, ilmt(it)
                     p2 = lmta(lmt2,ia)

                     if ( k_symmetry(ik) == GAMMA) then
                        csum = csum +fsr_filtered( ib1, p1, ik ) &
                             &      *fsr_filtered( ib1, p2, ik ) &
                             &      *q( lmt1, lmt2, it )
                     else
                        csum = csum +( fsr_filtered( ib1, p1, ik ) &
                             &        *fsr_filtered( ib1, p2, ik ) &
                             &        +fsi_filtered( ib1, p1, ik ) &
                             &        *fsi_filtered( ib1, p2, ik ) ) &
                             &      *q( lmt1, lmt2, it )
                     endif
                  end do
               end do
            end do
            SpectralWeight(ie,ik) = SpectralWeight(ie,ik) +csum 
         End Do
      End Do
         
    end subroutine hardpart

    subroutine softpart
      integer :: ik, ie, ib1, ig, ii, ierr
      real(kind=DP) :: csum, c1, c2
      
      Do ik=1, kv3, ndim_spinor
         if ( map_k(ik) /= myrank_k ) cycle
         
         Do ie=ista_e, iend_e
            ib1 = map_z(ie)
            
            csum = 0.0d0
            
            if ( kimg == 1 ) then
               Do ig=1, iba(ik)
                  ii = nbase(ig, ik )
                  if ( sw_force_kpt_inside_bz == ON ) then
                     if ( GVec_on_refcell(ii,ik) == 0 ) cycle
                  else
                     if ( GVec_on_refcell(ii,1) == 0 ) cycle
                  endif
                  c1 = zaj_l( ig, ib1, ik, 1 )
                  csum = csum + c1 **2
               End Do
            else
               Do ig=1, iba(ik)
                  ii = nbase(ig, ik )
                  if ( sw_force_kpt_inside_bz == ON ) then
                     if ( GVec_on_refcell(ii,ik) == 0 ) cycle
                  else
                     if ( GVec_on_refcell(ii,1) == 0 ) cycle
                  endif
                  c1 = zaj_l( ig, ib1, ik, 1 )
                  c2 = zaj_l( ig, ib1, ik, kimg ) 
                  csum = csum + c1 **2 +c2**2
               End Do
            endif
            SpectralWeight(ie,ik) = csum 
         End Do
      End Do
      
    end subroutine softpart

  end subroutine m_BU_calc_spectral_weight
       

  subroutine m_BU_betar_dot_WFs(nfout)
    integer, intent(in)    :: nfout
    integer :: ik

    Do ik=ista_k, iend_k
       call m_ES_betar_dot_Psi_4_each_k( nfout, zaj_l, ista_k, iend_k, ik, &
            &                            fsr_filtered, fsi_filtered )
    End Do
  end subroutine m_BU_betar_dot_WFs


  subroutine m_BU_phir_dot_WFs(nfout)
    use m_ES_nonlocal,  only : G_dot_R_map, G_dot_R_mpi

    integer, intent(in)    :: nfout

    integer ia, ik, ikphig, mapmode
    integer     :: id_sname = -1

!    call tstatc0_begin('m_BU_phir_dot_WFs ',id_sname,level=1)

!    if(ipri >= 2) write(nfout,'(" -- m_BU_phir_dot_WFs --")')
    call m_ES_alloc_zfsincos(0)
    call m_ES_alloc_arai(0)
    call alloc_zfsincos_mpi()

    do ia = 1, natm
       if ( kv3/nspin == 1 ) then
          call G_dot_R_map(ia,1);      mapmode = MAPPED
       else
          call G_dot_R_mpi(ia) ! pos(ia,1:3), ngabc -> zfcos,zfsin
          mapmode = NOTMAPPED
       endif

       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle         ! MPI

          ikphig = (ik-1)/nspin + 1
          call m_ES_phir_dot_WFs_4_lmta_k( ista_k, iend_k, ik, zaj_l, ia, ikphig, &
               &                           phig, 1, compr_filtered, compi_filtered,  &
               &                           mapmode )
       end do
    end do
    call dealloc_zfsincos_mpi()
    call m_ES_dealloc_arai()
    call m_ES_dealloc_zfsincos()

!    if ( modnrm /= SKIP ) then
       if ( orb_popu_method == 2 ) call add_overlap_phirt_psirpw
!    endif

!    call tstatc0_end(id_sname)
  end subroutine m_BU_phir_dot_WFs

  subroutine add_overlap_phirt_psirpw
    integer :: ik, ia, it, lmt1, lmt2, p, q, s
    integer :: il1, il2, im1, im2, t1, t2
    integer :: ikphig
    real(kind=DP) :: ctmp, c1

    Do ik=1, kv3
       if ( map_k(ik) /= myrank_k ) cycle

       ikphig = ( ik -1 )/nspin +1

       Do ia=1, natm
          it = ityp(ia)

          Do lmt1=1, ilmt_phi(it)
             il1=ltp_phi(lmt1,it);  im1 = mtp_phi(lmt1,it);  t1 = taup_phi(lmt1,it)
             p = lmta_phi(lmt1,ia);  s = lmtt_phi(lmt1,it)
             c1 = sqrt( norm_phig( s,ikphig ) )

             Do lmt2=1, ilmt(it)
                il2=ltp(lmt2,it);  im2 = mtp(lmt2,it);  t2 = taup(lmt2,it)
                if ( il1 /= il2 ) cycle
                if ( im1 /= im2 ) cycle

                q = lmta(lmt2,ia)
                ctmp = q_phirt_pw(il1,t1,t2,it) /c1

                if ( k_symmetry(ik) == GAMMA ) then
                   compr_filtered(:,p,1,ik) &
                        &       = compr_filtered(:,p,1,ik) &
                        &        +ctmp *fsr_filtered(:,q,ik) *sqrt(2.0d0)  ! why ?
                else
                   compr_filtered(:,p,1,ik) &
                        &    = compr_filtered(:,p,1,ik) +ctmp *fsr_filtered(:,q,ik)
                   compi_filtered(:,p,1,ik) &
                        &    = compi_filtered(:,p,1,ik) +ctmp *fsi_filtered(:,q,ik)
                endif
             End Do
          End Do
       End Do
    End Do
  end subroutine add_overlap_phirt_psirpw

  subroutine m_BU_wd_Wfn_orb_proj
    integer :: neg_t
    real(kind=DP), allocatable :: compr(:,:,:,:), compi(:,:,:,:), norm_phig_mpi(:,:)
    
    if ( ekmode == OFF ) return

    allocate(compr(neg,nlmta_phi,1,kv3));  compr = 0.d0
    allocate(compi(neg,nlmta_phi,1,kv3));  compi = 0.d0
    
    if(.not.allocated(norm_phig_mpi)) allocate(norm_phig_mpi(nlmtt_phi,kv3/nspin))
    norm_phig_mpi=0.d0

    call set_array_compri_etc

    neg_t = neg -num_extra_bands

    if ( mype == 0 ) then
       if ( nk_in_the_process == 1 ) then
          call m_Files_open_nfwfk_orb_proj(2)

          write(nfwfk_orb_proj,'(A,I8)') 'num_kpoints = ', kv3_ek /ndim_spinor
          write(nfwfk_orb_proj,'(A,I8)') 'num_bands   = ', neg_t
          write(nfwfk_orb_proj,'(A,I8)') 'nspin       = ', nspin

          write(nfwfk_orb_proj,*)
          write(nfwfk_orb_proj,'(A,I8)') 'num of orbitals = ', nlmta_phi
          write(nfwfk_orb_proj,*)
       else
          call m_Files_open_nfwfk_orb_proj(3)
       endif
    endif

    if ( SpinOrbit_Mode /= Neglected .and. wf_orb_proj_print_format == 1 ) then
       call case_with_j
    else
       call case_ordinal    ! EXPERIMENTAL 
    endif
    if ( mype == 0 ) call m_Files_close_nfwfk_orb_proj

    deallocate( compr ); deallocate( compi ); deallocate( norm_phig_mpi )
    
  contains
    
    subroutine set_array_compri_etc
      integer :: ik, ie, ib, iksnl
      integer :: iorb, lmt
      integer :: ia, il, im, tau, is
      real(kind=DP), allocatable :: compr_mpi(:,:,:,:), compi_mpi(:,:,:,:), &
           &                        norm_phig_mpi2(:,:)
      real(kind=DP), allocatable :: porb(:)

      do ik = 1, kv3
         if(map_k(ik) /= myrank_k) cycle
         iksnl = (ik-1)/nspin + 1
         
         do ie = ista_e, iend_e, istep_e
            ib = map_z(ie)
            compr(ie,1:nlmta_phi,1,ik) = compr_filtered(ib,1:nlmta_phi,1,ik)
            compi(ie,1:nlmta_phi,1,ik) = compi_filtered(ib,1:nlmta_phi,1,ik)
         end do
         norm_phig_mpi(1:nlmtt_phi,iksnl)  = norm_phig(1:nlmtt_phi,iksnl)
      end do
      
      if ( npes >1 ) then
         allocate( compr_mpi( neg, nlmta_phi, 1, kv3 ) ); compr_mpi = 0.0d0
         allocate( compi_mpi( neg, nlmta_phi, 1, kv3 ) ); compi_mpi = 0.0d0
         allocate( norm_phig_mpi2( nlmtt_phi, kv3/nspin ) )
         call mpi_allreduce( compr, compr_mpi, neg*nlmta_phi*1*kv3, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         call mpi_allreduce( compi, compi_mpi, neg*nlmta_phi*1*kv3, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         call mpi_allreduce( norm_phig_mpi, norm_phig_mpi2, nlmtt_phi*kv3/nspin, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         compr = compr_mpi;   compi = compi_mpi

         norm_phig_mpi = norm_phig_mpi2 /dble(nrank_e)

         deallocate( compr_mpi ); deallocate( compi_mpi ); 
         deallocate( norm_phig_mpi2 )
      end if
    end subroutine set_array_compri_etc

    subroutine case_ordinal
      integer :: ik, iksnl, iorb, ia, is, ib
      integer :: il, im, tau, lmtt
      real(kind=DP), allocatable :: porb(:)

      if ( mype /= 0 ) return

      allocate( porb(neg) )

      do ik = 1, kv3, ndim_spinor
         iksnl = (ik-1)/nspin + 1
         
         write(nfwfk_orb_proj,'(A,I6,A,3F16.8,A)') 'ik = ', &
              &            ik +nk_in_the_process -1, " ( ", &
              &            vkxyz_refcell(ik,1:3,BUCS), " )"
         
         do iorb = 1,nlmta_phi
            call m_PP_tell_iorb_ia_l_m_tau(iorb,ia,il,im,tau)
            if ( iproj_group(ia) == 0) cycle

            write(nfwfk_orb_proj,'(I5,3I3,A)') ia, il-1, im, tau, ' : ia, l, m, tau'
            
            call m_PP_tell_iorb_lmtt(iorb,lmtt)
            
            porb = 0.0d0
            Do is=1, ndim_spinor
               do ib = 1, neg
                  porb(ib) = porb(ib) &
                       & + ( compr(ib,iorb,1,ik+is-1)**2 &
                       &    +compi(ib,iorb,1,ik+is-1)**2 ) &
                       &     *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl) )
               end do
            End Do
!            write(nfwfk_orb_proj,'(4F18.10)') ( porb( neordr(ib,ik) ), ib=1, neg_t )
            write(nfwfk_orb_proj,'(4E18.10)') ( porb( neordr(ib,ik) ), ib=1, neg_t )
         end do
         write(nfwfk_orb_proj,*)
      end do
      deallocate( porb )

    end subroutine case_ordinal
    
    subroutine case_with_j
      integer :: ik, iksnl, ia, ig, ii, it, ilp, ll, tau, ip
      integer :: iorb, lmtt1, ib, m1
      real(kind=DP) :: c1, c2
      complex(kind=CMPLDP) :: z1, z2

      real(kind=DP), allocatable :: porb(:)
      complex(kind=CMPLDP), allocatable :: zcomp(:,:,:)

! ----------------
      if ( mype /= 0 ) return

      allocate( porb(neg) )

      Do ik=1, kv3, ndim_spinor
         write(nfwfk_orb_proj,'(A,I6,A,3F16.8,A)') 'ik = ', &
              &            ik +nk_in_the_process -1, " ( ", &
              &            vkxyz_refcell(ik,1:3,BUCS), " )"

         iksnl = ( ik -1 )/nspin +1

         Do ia=1, natm
            ig = iproj_group(ia)
            if ( ig == 0 ) cycle

            do ii=1,num_proj_elems(ig)
               ip = proj_group( ii, ig )
               it = proj_attribute(ip)%ityp
               ilp = proj_attribute(ip)%l +1
               ll = proj_attribute(ip)%l
               tau = proj_attribute(ip)%t
!
               allocate( zcomp( -ll:ll, neg, ndim_spinor ) ); zcomp = 0.0d0
               call tranform_compri_r2c_sph( ia, it, ll, tau, ik, &
                    &                        compr, compi, zcomp )

               if ( ll == 0 ) then
                  call find_iorb_from_lmt( ia, it, ll, 1, tau, iorb )
                  call m_PP_tell_iorb_lmtt( iorb, lmtt1 )

                  write(nfwfk_orb_proj,'(I5,F7.2,I3,F7.2,I3,A)') &
                       &         ia, ll+0.5d0, ll, 0.5d0, tau, ' : ia, j, l, mj, tau'
                  Do ib=1, neg
                     z1 = cmplx( compr(ib,iorb,1,ik),   compi(ib,iorb,1,ik) )
                     z2 = cmplx( compr(ib,iorb,1,ik+1), compi(ib,iorb,1,ik+1) )
                     porb(ib) = ( z1*conjg(z1) +z2*conjg(z2) ) &
                          &     *( 1.d0+qorb(iorb)/norm_phig_mpi( lmtt1, iksnl ) )
                  End Do
                  write(nfwfk_orb_proj,'(4F18.10)') &
                       &               ( porb( neordr(ib,ik) ), ib=1, neg_t )
               else
! j_up
                  Do m1=-ll -1, ll
                     c1 = dble( ll +m1 + 1 ) / dble( 2 *ll +1 )
                     c2 = dble( ll -m1 )     / dble( 2 *ll +1 )
                     c1 = sqrt(c1);  c2 = sqrt(c2)

                     call find_iorb_from_lmt( ia, it, ll, 1, tau, iorb )
                     call m_PP_tell_iorb_lmtt( iorb, lmtt1 )

                     write(nfwfk_orb_proj,'(I5,F7.2,I3,F7.2,I3,A)') &
                          &         ia, ll+0.5d0, ll, m1+0.5d0, tau, &
                          &             ' : ia, j, l, mj, tau'
                     Do ib=1, neg
                        z1 = 0.0d0
                        if ( m1 > -ll -1 ) z1 = z1 +c1 *zcomp( m1,    ib, 1 )
                        if ( m1 < ll     ) z1 = z1 +c2 *zcomp( m1 +1, ib, 2 )
                        porb(ib) = z1 *conjg(z1) &
                             &     *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt1,iksnl) )
                     End Do
                     write(nfwfk_orb_proj,'(4F18.10)') &
                          &         ( porb( neordr(ib,ik) ), ib=1, neg_t )
                  End Do
! j_down
                  Do m1=-ll+1, ll
                     c1 = dble( ll -m1 + 1 ) / dble( 2 *ll +1 )
                     c2 = dble( ll +m1 )     / dble( 2 *ll +1 )
                     c1 = sqrt(c1);  c2 = -sqrt(c2)

                     call find_iorb_from_lmt( ia, it, ll, 1, tau, iorb )
                     call m_PP_tell_iorb_lmtt( iorb, lmtt1 )

                     write(nfwfk_orb_proj,'(I5,F7.2,I3,F7.2,I3,A)') &
                          &         ia, ll-0.5d0, ll, m1-0.5d0, tau, &
                          &             ' : ia, j, l, mj, tau'
                     Do ib=1, neg
                        z1 = c1 *zcomp( m1-1, ib, 1 ) +c2 *zcomp( m1, ib, 2 )
                        porb(ib) = z1 *conjg(z1) &
                             &     *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt1,iksnl) )
                     End Do
                     write(nfwfk_orb_proj,'(4F18.10)') &
                          &         ( porb( neordr(ib,ik) ), ib=1, neg_t )
                  End Do
               end if
               deallocate( zcomp )

            End Do
         End Do
         write(nfwfk_orb_proj,*)

      End Do
      deallocate( porb )

    end subroutine case_with_j

    subroutine tranform_compri_r2c_sph( ia, it, ll, tau, ik, &
         &                              compr, compi, zcomp )
      integer, intent(in) :: ia, it, ll, tau, ik
      real(kind=DP), intent(in) :: compr( neg, nlmta_phi, 1, kv3 )
      real(kind=DP), intent(in) :: compi( neg, nlmta_phi, 1, kv3 )
      complex(kind=CMPLDP), intent(out) :: zcomp( -ll:ll, neg, ndim_spinor )

      integer :: m1, m2, ib, iorb
      complex(kind=CMPLDP) :: z1
      complex(kind=CMPLDP) :: ztmp( ndim_spinor )

      Do m1=-ll, ll
         Do m2=1, 2*ll +1
            call find_iorb_from_lmt( ia, it, ll, m2, tau, iorb )
            Do ib=1, neg
               ztmp(1) = cmplx( compr(ib,iorb,1,ik),   compi(ib,iorb,1,ik)   )
               ztmp(2) = cmplx( compr(ib,iorb,1,ik+1), compi(ib,iorb,1,ik+1) )

               if ( ll == 0 ) z1 = MatU_ylm_RC_L0( m2, m1 )
               if ( ll == 1 ) z1 = MatU_ylm_RC_L1( m2, m1 )
               if ( ll == 2 ) z1 = MatU_ylm_RC_L2( m2, m1 )
               if ( ll == 3 ) z1 = MatU_ylm_RC_L3( m2, m1 )

               zcomp(m1,ib,:) = zcomp(m1,ib,:) +z1 *ztmp(:)
            End Do
         End Do
      End Do
    end subroutine tranform_compri_r2c_sph

    subroutine find_iorb_from_lmt( ia, it, ll, mm, tau, iorb )
      integer, intent(in) :: ia, it, ll, mm, tau
      integer, intent(out) :: iorb

      integer :: lmt1, l1, m1, t1

      iorb = 0
      Do lmt1=1, ilmt_phi(it)
         l1 = ltp_phi(lmt1,it); m1 = mtp_phi(lmt1,it);  t1 = taup_phi(lmt1,it)
         if ( l1 == ll +1 .and. m1 == mm .and. t1 == tau ) then
            exit
         endif
      ENd Do
      iorb = lmta_phi( lmt1,ia )

    end subroutine find_iorb_from_lmt

  end subroutine m_BU_wd_Wfn_orb_proj

end module m_Band_Unfolding

c======================================================================c
      subroutine eigen_prd_2update(
     &      ar, nma,
     &      ur, uyr, vr, vyr, nmv,
     &      m_size, i_base)
c======================================================================c
!$    use OMP_LIB
      use eigen_devel
      use eigen_libs
      implicit NONE
c
      real(8), intent(inout) :: ar (nma, *)
      real(8), intent(in)    :: ur (nmv, *)
      real(8), intent(in)    :: uyr(nmv, *)
      real(8), intent(in)    :: vr (nmv, *)
      real(8), intent(in)    :: vyr(nmv, *)
      integer, intent(in)    :: nma, nmv, m_size, i_base
c
      include 'param.h'
c
      integer ::  i, j, k, k0, k1, k2, L, m, n

      integer ::  i_1,i_2,i_3,i_4
      integer ::  j_1,j_2,j_3,j_4

      integer ::  ii_1,ii_2,ii_3,ii_4
      integer ::  jj_1,jj_2,jj_3,jj_4

      integer ::  blk_size1, blk_size2
      integer ::  ii_step
c
      integer ::  local_rank, local_size
c
      integer, parameter :: BLAS_CHUNK = 7*8
      integer, parameter :: BLAS_NVECT = 256*3
!      integer, parameter :: BLAS_NVECT = 256*4
c
      intrinsic :: MIN, MAX
      external  :: DGEMM
c
c======================================================================c
c
      if ( i_base <= 0 ) return
c
c======================================================================c
c
      local_rank = 0
      local_size = 1
!$    local_rank = omp_get_thread_num()
!$    local_size = omp_get_num_threads()
c
      m  = m_size                               ! preserve the argument variable 
      n  = eigen_loop_end  (i_base, y_nnod, y_inod) ! local matrix size
      k0 = eigen_translate_l2g(n, y_nnod, y_inod)  ! translation to the global index

      jj_2 = 1                                  ! beggining of loop
      jj_3 = eigen_loop_end  (k0, x_nnod, x_inod)   ! end of loop

      ii_step = 0
      do j_1 = jj_2, jj_3, BLAS_NVECT
         j_4 = MIN(j_1+BLAS_NVECT-1, jj_3)      ! [j_1:j_4] available on this iteration 

         k1   = eigen_translate_l2g(j_1, x_nnod, x_inod) ! translation to the global index
         ii_2 = eigen_loop_start(k1,     y_nnod, y_inod)  ! beggining of loop
         ii_2 = MAX(1, ii_2)                          !  ** should be .GE. 1
         ii_3 = n                                     ! end of loop

         do i_1 = ii_2, ii_3, BLAS_CHUNK
            i_4 = MIN(i_1+BLAS_CHUNK-1, ii_3)   ! [i_1:i_4] available on this iteration

            k2  = eigen_translate_l2g(i_4, y_nnod, y_inod) ! translation to the global index
            j_3 = eigen_loop_end  (k2, x_nnod, x_inod) ! end of loop
            j_3 = MIN(j_4, j_3)

            i_2 = i_1; i_3 = i_4
            j_2 = j_1

            blk_size1 = j_3-j_2+1
            blk_size2 = i_3-i_2+1

            if ( blk_size1 > 0 .AND. blk_size2 > 0 ) then

               if ( MOD(ii_step, local_size) == local_rank ) then

                  call DGEMM('N','T',
     &                   blk_size1, blk_size2, m,
     &                   MINUS_ONE, ur (j_1, 1),   nmv,
     &                              vyr(i_1, 1),   nmv,
     &                   ONE,       ar (j_1, i_1), nma)
                  call DGEMM('N','T',
     &                   blk_size1, blk_size2, m,
     &                   MINUS_ONE, vr (j_1, 1),   nmv,
     &                              uyr(i_1, 1),   nmv,
     &                   ONE,       ar (j_1, i_1), nma)

               end if

               ii_step = ii_step+1

            end if

         end do ! i_1

      end do ! j_1
c-
      return
      end subroutine eigen_prd_2update
c======================================================================c

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 603 $)
!
!  MODULE: m_Electronic_Structure
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004, April/15/2006, September/02/2008
!  FURTHER MODIFICATION: T. Yamasaki, T. Uda and T. Ohno, September 2009 (MGS_DGEMM)
!  FURTHER MODIFICATION: T. Yamasaki and T. Yamamoto,   October 2009  (NONLOCAL_DGEMM)
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!

!   This module has been revised for the GAMMA point (k=(0,0,0)) by T. Yamasaki
!  in April 2006. Number of operations for the Gamma point have been tremendously
!  reduced in subroutines of m_ES_betar_dot_Wfs, m_ES_Vnonlocal_W, and
!  m_ES_modified_gram_schmidt.
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif
#ifdef __TIMER_DGEMM__
#   define __TIMER_DGEMM_START(a)  call timer_sta(a)
#   define __TIMER_DGEMM_STOP(a)   call timer_end(a)
#else
#   define __TIMER_DGEMM_START(a)
#   define __TIMER_DGEMM_STOP(a)
#endif

!  2010.03
!  the performance of the Gram-Schmidt orthonormalization procedure
!  has been tuned through a joint effort with RIKEN.

#ifndef SX
#define DGEMM__       DGEMM
#endif

#ifndef NO_MGS_DGEMM
#define MGS_DGEMM
#endif

module m_ES_ortho
  use m_Control_Parameters, only : nspin,ipri,kimg, neg, printable, af &
       &                         , m_CtrlP_cachesize &
       &                         , sw_gep & 
#ifdef SAVE_FFT_TIMES
       &                         , nblocksize_mgs, nblocksize_mgs_is_given, sw_save_fft
#else
       &                         , nblocksize_mgs, nblocksize_mgs_is_given
#endif
  use m_Const_Parameters,   only : DP, EXECUT, ON, OFF, DELTA, PAI2 &
       &                         , ORTHOGONALIZATION, ORTHONORMALIZATION, NORMALIZATION &
       &                         , NORMCONSERVATION, VDB, VANDERBILT_TYPE &
       &                         , OTHER_BANDS, SAME_BAND, GAMMA, OLD
  use m_Electronic_Structure,only: zaj_l, neordr, nrvf_ordr, fsr_l, fsi_l &
#ifdef SAVE_FFT_TIMES
 &                                , status_saved_phifftr &
#endif
       &                         , nblocksize_mgs_default
  use m_Files,              only : nfout
  use m_Kpoints,            only : kv3,k_symmetry
  use m_Parallelization,    only : mpi_comm_group,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,ista_k,iend_k &
       &                         , ierr,mp_e,nis_e,nie_e,nel_e &
       &                         , ista_g1k,iend_g1k,np_g1k,mp_g1k,nis_g1k,nel_g1k &
       &                         , np_fs, mp_fs, ista_fs, iend_fs, nis_fs, nie_fs, nel_fs  &
       &                         , myrank_g, nrank_g &
       &                         , is_ffth, ista_ffth, nel_ffth, np_ffth, mp_ffth, neg_g_all
  use m_PlaneWaveBasisSet,  only : kg1,kg,iba
  use m_PseudoPotential,    only : nlmt,nlmta,lmta,lmtt,ltp,q &
       &                         , modnrm,nac,fqwei,nlmta1,nlmta2 &
       &                         , nac_p, fqwei_p, nlmta1_p, nlmta2_p
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Electronic_Structure, only : fsr_l_2D, fsi_l_2D           &
 &                                 , fsr_ball, fsi_ball, zaj_ball           &
 &                                 , m_ES_wd_zaj_small_portion_3D
  use m_ES_nonlocal,          only : m_ES_betar_dot_WFs_4_each_k_3D
  use m_Parallelization,      only : lrank, nbsn, nbsn_sta, nbsn_end, neg_g           &
 &                                 , nbs_num, nbsn_num, nbs_sta, nbs_end              &
 &                                 , mpi_kg_world, mpi_ke_world           &
 &                                 , map_k                   &
 &                                 , mp_kngp, is_kngp, ie_kngp, np_kngp, nel_kngp     

! ================================ added by K. Tagami ================ 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor
  use m_PseudoPotential,      only : fqwei_noncl, fqwei_p_noncl
! ==================================================================== 11.0

  implicit none

  integer, private, parameter                         :: sw_timing_2ndlevel = ON

  integer                                             :: np_g1k_x     ! np_g1k_x = np_g1k(ik) | np_g1k(ik)+1
  real(kind=DP),private,allocatable,target,dimension(:,:,:)  :: psi_t  ! d(np_g1k_x,neg,kimg) a work_array for mgs
  real(kind=DP),private,allocatable,dimension(:,:)    :: p1Sp2
  integer                                             :: np_fs_x      ! np_fs_x = np_fs | np_fs+1
  real(kind=DP),private,allocatable,dimension(:,:)    :: bpr_t, bpi_t ! d(np_fs_x,neg) work arrays for mgs
#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
  real(kind=DP),private,allocatable,dimension(:)      :: psi_ii,psi_ir
  real(kind=DP),private,allocatable,dimension(:)      :: bp_ii,bp_ir
#endif
#ifdef MGS_DGEMM
!-$ tune FUJITSU for block ----->>
  real(kind=DP),private,allocatable,dimension(:,:)    :: bpr_tw1, bpr_tw2, bpi_tw1, bpi_tw2 ! d(nac_p,neg) work arrays for mgs
  integer,private                                     :: NB
#ifdef SX
  integer,private                                     :: MB, LMB
#endif
! <--
!-$ tune FUJITSU for block <<-----
#endif
! <--

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

! ============================= added by K. Tagami ================ 11.0
  real(kind=DP), private, allocatable, target :: psi_t_noncl(:,:,:,:)
  real(kind=DP), private, allocatable :: bpr_t_noncl(:,:,:)
  real(kind=DP), private, allocatable :: bpi_t_noncl(:,:,:)
  
#ifdef MGS_DGEMM
  real(kind=DP), private, allocatable :: bpr_tw1_noncl(:,:,:)
  real(kind=DP), private, allocatable :: bpr_tw2_noncl(:,:,:)
  real(kind=DP), private, allocatable :: bpi_tw1_noncl(:,:,:)
  real(kind=DP), private, allocatable :: bpi_tw2_noncl(:,:,:)
#endif
! ================================================================= 11.0

contains
!  1-18. m_ESortho_mgs_alloc
!        - mgs_vdb_alloc, - mgs_nrc_alloc
!  1-19. m_ESortho_mgs_dealloc
!        - mgs_vdb_dealloc, - mgs_nrc_dealloc
!  2-28. m_ES_modified_gram_schmidt
!  2-29. m_ES_orthogonalize_SD_to_WFs -> (2-30)
!  2-30. mgs_sd2wf_each_k_G           <- (2-29)  -> (2-34), (2-44)
!        - broadcast_fs, - Psi1SPhi2_t, - modify_bsd_and_phi_t, - alloc_phi_w_and_brd_w
!        - dealloc_phi_w_and_brd_w, - WSW, - normalize_bsd_and_phi, - Psi1SPhi2
!        - modify_bsd_and_phi
!  2-31. orthogonalize_SD             -> (2-33)
!  2-32. m_ES_MGS_4_each_k            -> (2-17), (2-33)
!        - wd_title_of_the_operation
!  2-33. mgs_4_each_k_G               <- (2-31), (2-32)  -> (2-34), (2-44)
!        - WSW_t, - normalize_bp_and_psi_t, - W1SW2_t_r
!        - modify_bp_and_psi_t_r, - substitute_jto_ib2back, - W1SW2_t
!        - modify_bp_and_psi_t, - alloc_and_brd_w, - dealloc_and_brd_w
!        - WSW, - normalize_bp_and_psi, - W1SW2, - modify_bp_and_psi
!  2-34. set_npzri                    <- (2-30), (2-33)
!  2-37. m_ES_W_transpose_back2
!  2-38. m_ES_W_transpose_r
!  2-39. m_ES_W_transpose_back_r
!  2-42. m_ES_F_transpose_r
!  2-43. m_ES_F_transpose_back_r
!   2-44. m_ES_F_transpose_r_3D
!   2-45. m_ES_F_transpose_back_r_3D
!   2-46. m_ES_W_transpose_r_3D
!   2-47. m_ES_W_transpose_back_r_3D

!  2-44. cp_bp_and_psi_2_brd_w2      <- (2-30), (2-33)

#ifdef VPP
#define _ODD_BOUNDARY_
#endif
#ifdef SX
#define _ODD_BOUNDARY_
#endif
#ifdef NEC_TUNE1
#define _ODD_BOUNDARY_
#endif


  subroutine m_ESortho_set_np_g1k_x(ik)
    integer, intent(in) :: ik
!   OUTPUT : np_g1k_x
!
!!$    np_g1k_x = np_g1k(ik) + 1
    np_g1k_x = np_g1k(ik)
  end subroutine m_ESortho_set_np_g1k_x

  subroutine m_ESortho_set_np_fs_x()
!!$    np_fs_x = np_fs + 1
    np_fs_x = np_fs
  end subroutine m_ESortho_set_np_fs_x
      
  subroutine m_ESortho_mgs_alloc(ik)
    integer, intent(in) :: ik
    call m_ESortho_set_np_g1k_x(ik) ! -> np_g1k_x
!!$    call set_np_g1k_x() ! -> np_g1k_x

    if(modnrm == EXECUT) then
       call m_ESortho_set_np_fs_x() ! -> np_fs_x
!!$       call set_np_fs_x() ! -> np_fs_x
! ============================== modified by K. Tagami ============= 11.0
!       call mgs_vdb_alloc
       call mgs_vdb_alloc(np_e)
! =================================================================== 11.0
    else
! ============================== modified by K. Tagami ============= 11.0
!       call mgs_nrc_alloc
       call mgs_nrc_alloc(np_e)
! ===================================================================== 11.0
    end if
  contains
!!$    subroutine set_np_g1k_x()
!!$!   OUTPUT : np_g1k_x
!!$!
!!$!BRANCH_P ORG_Parallel
!!$#ifdef _ODD_BOUNDARY_
!!$      if(mod(np_g1k(ik),2) == 0) then
!!$         np_g1k_x = np_g1k(ik) + 1
!!$      else
!!$         np_g1k_x = np_g1k(ik)
!!$      end if
!!$#else
!!$!BRANCH_P_END ORG_Parallel
!!$      np_g1k_x = np_g1k(ik) + 1
!!$!BRANCH_P ORG_Parallel
!!$#endif
!!$!BRANCH_P_END ORG_Parallel
!!$    end subroutine set_np_g1k_x
!!$
!!$    subroutine set_np_fs_x()
!!$
!!$!BRANCH_P ORG_Parallel
!!$#ifdef _ODD_BOUNDARY_
!!$      if(mod(np_fs,2) == 0) then
!!$         np_fs_x = np_fs+1
!!$      else
!!$         np_fs_x = np_fs
!!$      end if
!!$#else
!!$!BRANCH_P_END ORG_Parallel
!!$      np_fs_x = np_fs + 1
!!$!BRANCH_P ORG_Parallel
!!$#endif
!!$!BRANCH_P_END ORG_Parallel
!!$    end subroutine set_np_fs_x

! ============================== added by K. Tagami ================== 11.0
    subroutine mgs_vdb_alloc(neg)
      integer,intent(in) :: neg
      integer :: kimg_t

      allocate(psi_t(np_g1k_x,neg,kimg))

#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
      allocate(psi_ir(np_g1k_x))
      if(kimg == 2) allocate(psi_ii(np_g1k_x))
      if(np_g1k(ik) < np_g1k_x) then
         psi_ir(np_g1k_x) = 0.d0
         if(kimg==2) psi_ii(np_g1k_x) = 0.d0
      end if
#endif

      if((k_symmetry(ik) == GAMMA .and. kimg == 2) .or. kimg==1) then
         kimg_t = 1
      else
         kimg_t = 2
      end if
      allocate(p1Sp2(neg,kimg_t))

      if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
         kimg_t = 1
      else
         kimg_t = 2
      end if


      if(kimg_t == 1) then
         allocate(bpr_t(np_fs_x,neg))
         allocate(bpi_t(1,1))
#ifdef MGS_DGEMM
! === Debug by Intel "-check all" option! by T.Kato 2013/07/02 =================
         if(nac_p > 0) then
!  =============================================================================
         allocate(bpr_tw1(nac_p,neg))
         allocate(bpr_tw2(nac_p,neg))
         allocate(bpi_tw1(nac_p,neg))
         allocate(bpi_tw2(nac_p,neg))
!         allocate(bpi_tw1(1,1))
!         allocate(bpi_tw2(1,1))
         bpr_tw1 = 0.0
         bpr_tw2 = 0.0
! === Debug by Intel "-check all" option! by T.Kato 2013/07/02 =================
         end if
!  =============================================================================
#endif
      else
         allocate(bpr_t(np_fs_x,neg))
         allocate(bpi_t(np_fs_x,neg))
#ifdef MGS_DGEMM
! === Debug by Intel "-check all" option! by T.Kato 2013/07/02 =================
         if(nac_p > 0) then
!  =============================================================================
         allocate(bpr_tw1(nac_p,neg))
         allocate(bpr_tw2(nac_p,neg))
         allocate(bpi_tw1(nac_p,neg))
         allocate(bpi_tw2(nac_p,neg))
         bpr_tw1 = 0.0
         bpr_tw2 = 0.0
         bpi_tw1 = 0.0
         bpi_tw2 = 0.0
! === Debug by Intel "-check all" option! by T.Kato 2013/07/02 =================
         end if
!  =============================================================================
#endif
      end if

#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
      allocate(bp_ir(max(np_fs,np_g1k_x)));bp_ir=0.d0
      if(kimg_t == 2) then
         allocate(bp_ii(max(np_fs,np_g1k_x)));bp_ii=0.d0
      endif
!!$      allocate(bp_ii(np_g1k_x))
      if(np_g1k(ik) < np_g1k_x) then
         bp_ir(np_g1k(ik)+1:np_g1k_x) = 0.d0
!!$         if(kimg==2) bp_ii(np_g1k_x) = 0.d0
         if(kimg_t == 2) bp_ii(np_g1k(ik)+1:np_g1k_x) = 0.d0
!!$         bp_ii(np_g1k(ik)+1:np_g1k_x) = 0.d0
      end if
#endif
    end subroutine mgs_vdb_alloc


    subroutine mgs_nrc_alloc(neg)
      integer,intent(in) :: neg
      integer :: kimg_t
      allocate(psi_t(np_g1k_x,neg,kimg))
#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
      allocate(psi_ir(np_g1k_x))
      if(kimg==2) allocate(psi_ii(np_g1k_x))
      if(np_g1k(ik) < np_g1k_x) then
         psi_ir(np_g1k_x) = 0.d0
         if(kimg==2) psi_ii(np_g1k_x) = 0.d0
      end if
#endif

      if((k_symmetry(ik) == GAMMA .and. kimg == 2).or.kimg==1) then
         kimg_t = 1
      else
         kimg_t = 2
      end if
      allocate(p1Sp2(neg,kimg_t))
    end subroutine mgs_nrc_alloc
  end subroutine m_ESortho_mgs_alloc


  subroutine m_ESortho_mgs_dealloc()
    if(modnrm == EXECUT) then
! ================================ modified by K. Tagami ========== 11.0
!!       call mgs_vdb_dealloc()
!
       if ( noncol ) then
         call mgs_vdb_dealloc_noncl()
       else
         call mgs_vdb_dealloc()
       endif
! ================================================================= 11.0
    else
! ================================ modified by K. Tagami ========== 11.0
!       call mgs_nrc_dealloc()

       if ( noncol ) then
          call mgs_nrc_dealloc_noncl()
       else
          call mgs_nrc_dealloc()
       endif
! ==================================================================== 11.0
    end if
  contains
    subroutine mgs_vdb_dealloc()
      deallocate(bpr_t)
#ifdef MGS_DGEMM
! === Debug by Intel "-check all" option! by T.Kato 2013/07/02 =================
!     deallocate(bpr_tw1)
!     deallocate(bpr_tw2)
      if(allocated(bpr_tw1)) deallocate(bpr_tw1)
      if(allocated(bpr_tw2)) deallocate(bpr_tw2)
!  =============================================================================
#endif
      if(allocated(bpi_t)) deallocate(bpi_t)
#ifdef MGS_DGEMM
      if(allocated(bpi_tw1)) deallocate(bpi_tw1)
      if(allocated(bpi_tw2)) deallocate(bpi_tw2)
#endif
#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
      deallocate(psi_ir)
      if(kimg == 2) deallocate(psi_ii)
#endif
      deallocate(psi_t)
      deallocate(p1Sp2)
#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
      if(allocated(bp_ir)) deallocate(bp_ir)
      if(allocated(bp_ii)) deallocate(bp_ii)
#endif
    end subroutine mgs_vdb_dealloc

! ============================= added by K. Tagami ================= 11.0
    subroutine mgs_vdb_dealloc_noncl()
      deallocate(bpr_t_noncl)
#ifdef MGS_DGEMM
      deallocate(bpr_tw1_noncl)
      deallocate(bpr_tw2_noncl)
#endif
      if(allocated(bpi_t_noncl)) deallocate(bpi_t_noncl)
#ifdef MGS_DGEMM
      if(allocated(bpi_tw1_noncl)) deallocate(bpi_tw1_noncl)
      if(allocated(bpi_tw2_noncl)) deallocate(bpi_tw2_noncl)
#endif
      deallocate(psi_t_noncl)
      deallocate(p1Sp2)
!!$#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
!!$      if(mod_pot == VANDERBILT_TYPE) then
!!$         if(allocated(bp_ir)) deallocate(bp_ir)
!!$         if(allocated(bp_ii)) deallocate(bp_ii)
!!$      end if
!!$#endif
    end subroutine mgs_vdb_dealloc_noncl
! ================================================================= 11.0

    subroutine mgs_nrc_dealloc()
#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
      deallocate(psi_ir)
      if(kimg == 2) deallocate(psi_ii)
#endif
      deallocate(psi_t)
      deallocate(p1Sp2)
    end subroutine mgs_nrc_dealloc

! ============================== added by K. Tagami =============== 11.0
    subroutine mgs_nrc_dealloc_noncl()
      deallocate(psi_t_noncl)
      deallocate(p1Sp2)
    end subroutine mgs_nrc_dealloc_noncl
! ================================================================== 11.0

  end subroutine m_ESortho_mgs_dealloc

  subroutine m_ES_modified_gram_schmidt(nfout)
  use m_IterationNumbers,     only : iteration
    integer, intent(in) :: nfout
    integer :: ik

    do ik = ista_k, iend_k, af+1                            ! MPI
       if(ipri>=2) call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- before GS --",16)

       if(sw_gep == OFF .or. iteration<2)then
          call m_ES_MGS_4_each_k(nfout,ik,mode=ORTHONORMALIZATION)
       else
          call m_ES_MGS_4_each_k(nfout,ik,mode=NORMALIZATION)
       endif
       !    ~~~~~~~~~~~~~~~~~~~~~~
       if(ipri>=2) call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- after GS --",15)

    end do

  end subroutine m_ES_modified_gram_schmidt

!!$!BRANCH_P 3D_Parallel
!!$  subroutine m_ES_modified_gram_schmidt_3D(nfout)
!!$    integer, intent(in) :: nfout
!!$    integer :: ik
!!$
!!$    do ik = ista_k, iend_k, af+1                            ! MPI
!!$       if(ipri>=2) call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- before GS --",16)
!!$
!!$       call m_ES_MGS_4_each_k(nfout,ik,mode=ORTHONORMALIZATION)
!!$       !    ~~~~~~~~~~~~~~~~~~~~~~
!!$       if(ipri>=2) call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- after GS --",15)
!!$    end do
!!$
!!$  end subroutine m_ES_modified_gram_schmidt_3D
!!$!BRANCH_P_END 3D_Parallel

  subroutine m_ES_orthogonal_phi_to_WFs(ik,wfsd_l,bsdr_l,bsdi_l)
    integer, intent(in)                                     :: ik
    real(kind=DP),intent(inout),dimension(kg1,np_e,ik:ik,kimg) :: wfsd_l
    real(kind=DP),intent(inout),dimension(np_e,nlmta,ik:ik)    :: bsdr_l,bsdi_l

    integer  :: id_sname = -1, id_sname2 = -1

    call tstatc0_begin('m_ES_orthogonal_phi_to_WFs ',id_sname,1)

    call tstatc0_begin('mpi_barrier(ortho_phi_to_WFs) ',id_sname2)
    call mpi_barrier(mpi_k_world(myrank_k),ierr)
    call tstatc0_end(id_sname2)

    if(modnrm == EXECUT) then
       call mgs_phi2wf_each_k_G(ik,wfsd_l,ORTHOGONALIZATION,bsdr_l,bsdi_l,mod_pot=VDB)
    else
       call mgs_phi2wf_each_k_G(ik,wfsd_l,ORTHOGONALIZATION,mod_pot=NORMCONSERVATION)
    end if

    call tstatc0_end(id_sname)
  end subroutine m_ES_orthogonal_phi_to_WFs

  subroutine m_ES_orthogonalize_SD_to_WFs_3D(ik,to_which_band,wfsd_l,bsdr_l,bsdi_l)
    integer, intent(in)                                     :: ik,to_which_band
    real(kind=DP),intent(inout),dimension(maxval(np_g1k),np_e,ik:ik,kimg) :: wfsd_l
    real(kind=DP),intent(inout),dimension(np_e,nlmta,ik:ik)    :: bsdr_l,bsdi_l

    integer  :: id_sname = -1
    call tstatc0_begin('m_ES_orthogonalize_SD_to_WFs_3D ',id_sname)

!!$    call phi_alloc(ik)
!!$    call m_ES_mgs_alloc(ik)
    if(modnrm == EXECUT) then
       call mgs_sd2wf_each_k_G_3D(ik,to_which_band,wfsd_l,bsdr_l,bsdi_l,mod_pot=VDB)
    else
       call mgs_sd2wf_each_k_G_3D(ik,to_which_band,wfsd_l,mod_pot=NORMCONSERVATION)
    end if
    ! -(m_E.S.)   ->wfsd_l,bsdr_l,bsdi_l!!$    if(ik == iend_k) call phi_dealloc()    !-(m_E.S.)
!!$    call m_ES_mgs_dealloc

!!$    if(ik == iend_k) call phi_dealloc()    !-(m_E.S.)

    call tstatc0_end(id_sname)
  end subroutine m_ES_orthogonalize_SD_to_WFs_3D


  subroutine mgs_sd2wf_each_k_G_3D(ik,to,phi_l,bsdr_l,bsdi_l,mod_pot)
    integer, intent(in)             :: ik,to
    real(kind=DP), intent(inout)    :: phi_l(maxval(np_g1k),np_e,ik:ik,kimg)
    real(kind=DP), optional,intent(inout), dimension(np_e,nlmta,ik:ik) :: bsdr_l,bsdi_l
    integer, intent(in)             :: mod_pot
    integer               :: i

    integer :: kimg_t
    real(kind=DP),allocatable,dimension(:,:)    :: bp_w
#ifndef ZAJ_BALL_ALLREDUCE
! ==============================================================================
    real(kind=DP), allocatable, dimension(:,:,:)   :: wk_zaj !d(max_g1k,mp_e,kimg)
!!$    real(kind=DP), allocatable, dimension(:,:,:,:) :: wk_mpi

    integer :: max_g1k
    integer :: ierr, nb,kb, jb, ib

    if(nrank_e == 1) then
       zaj_ball(:,:,ik,:) = zaj_l(:,:,ik,:)
    else
       max_g1k = maxval(np_g1k(:))
       allocate(wk_zaj(max_g1k,mp_e,kimg),stat=ierr)
       do nb = 0, nrank_e-1
          if(nb == myrank_e) then
             do kb = 1, kimg
                do jb = 1, np_e
                   wk_zaj(:,jb,kb) = zaj_l(:,jb,ik,kb)
                end do
             end do
             if(np_e+1 < mp_e) wk_zaj(:,np_e+1:mp_e,:) = 0.d0
          end if
          call mpi_bcast(wk_zaj,max_g1k*mp_e*kimg,mpi_double_precision,nb,mpi_kg_world,ierr)
          do kb = 1, kimg
             do jb = nis_e(nb), nie_e(nb)
                do ib = 1, np_g1k(ik)
                   zaj_ball(ib,jb,ik,kb) = wk_zaj(ib,jb-nis_e(nb)+1,kb)
                end do
             end do
          end do
       end do
       deallocate(wk_zaj)
!!$       max_g1k = maxval(np_g1k(:))
!!$       allocate(wk_zaj(max_g1k,mp_e,kimg),stat=ierr); wk_zaj = 0.d0
!!$       allocate(wk_mpi(max_g1k,mp_e,kimg,0:nrank_e-1),stat=ierr)
!!$       do kb = 1, kimg
!!$          do jb = 1, np_e
!!$             do ib = 1, np_g1k(ik)
!!$                wk_zaj(ib,jb,kb) = zaj_l(ib,jb,ik,kb)
!!$             end do
!!$          end do
!!$       end do
!!$       call mpi_allgather(wk_zaj, max_g1k*mp_e*kimg, MPI_DOUBLE_PRECISION &
!!$            &            ,wk_mpi, max_g1k*mp_e*kimg, MPI_DOUBLE_PRECISION, mpi_kg_world, ierr )
!!$       deallocate(wk_zaj)
!!$
!!$       do nb = 0, nrank_e-1
!!$          do kb = 1, kimg
!!$             do jb = nis_e(nb), nie_e(nb)
!!$                do ib = 1, np_g1k(ik)
!!$                   zaj_ball(ib,jb,ik,kb) = wk_mpi(ib,jb-nis_e(nb)+1,kb,nb)
!!$                end do
!!$             end do
!!$          end do
!!$       end do
!!$       deallocate(wk_mpi)
    end if
! ==============================================================================
#else
! ==============================================================================
    real(kind=DP) :: wk1(maxval(np_g1k),neg,kimg)
    integer :: ierr
    if(nrank_e == 1) then
       zaj_ball(:,:,ik,:) = zaj_l(:,:,ik,:)
    else
       wk1 = 0.0d0
       do i = 1, np_e
          wk1(:,neg_g(i),:) = zaj_l(:,i,ik,:)
       end do
       call mpi_allreduce(MPI_IN_PLACE,wk1,maxval(np_g1k)*neg*kimg &
            &            ,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
       do i = 1, neg
          zaj_ball(:,i,ik,:) = wk1(:,i,:)
       end do
    end if
! ==============================================================================
#endif

    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = 2
    end if
    allocate(p1Sp2(np_e,kimg_t))
    allocate(bp_w(nlmta,kimg_t))

    do i = 1, neg
       if(mod_pot == VDB) call broadcast_fs(i)  ! (fs(ri)_l(i,*,ik)-> bp_w
       call Psi1SPhi2_t(ik,i)                      ! -(contained here) -> p1Sp2
       call modify_bsd_and_phi_t(i)                ! -(c.h.) p1Sp2,phi_t -> bsd(ri),phi_t
    end do

    deallocate(p1Sp2)
    deallocate(bp_w)
  contains
#if 0
    subroutine broadcast_fs(io)
      integer, intent(in) :: io
      integer  :: ia, i, kimg_t

      i = map_z(io) ! MPI
      if(k_symmetry(ik) == GAMMA) then
         kimg_t = 1
      else
         kimg_t = 2
      end if

      if(map_e(io) == myrank_e) then ! MPI
         if(k_symmetry(ik) == GAMMA) then
            do ia = 1, nlmta
               bp_w(ia,1) = fsr_l_2D(i,ia)
            end do
         else
            do ia = 1, nlmta
               bp_w(ia,1) = fsr_l_2D(i,ia)
               bp_w(ia,2) = fsi_l_2D(i,ia)
            end do
         end if
      end if ! MPI
      call mpi_bcast(bp_w,nlmta*kimg_t,mpi_double_precision,map_e(io),mpi_kg_world,ierr) ! MPI
    end subroutine broadcast_fs
#else
    subroutine broadcast_fs(io)
      integer, intent(in) :: io
      integer  :: ia, i, kimg_t
      integer :: sendcount, recvcounts(0:nrank_g-1), displs(0:nrank_g-1)
      real(kind=DP),allocatable,dimension(:,:) :: sendbuf
      sendcount = np_fs
      do i = 0, nrank_g - 1
         recvcounts(i) = nel_fs(i)
         displs(i)     = nis_fs(i) - 1
      enddo

      i = map_z(io) ! MPI
      if(k_symmetry(ik) == GAMMA) then
         kimg_t = 1
      else
         kimg_t = 2
      end if
      allocate(sendbuf(np_fs,kimg_t))

      if(map_e(io) == myrank_e) then ! MPI
         if(k_symmetry(ik) == GAMMA) then
            do ia = 1, np_fs
               sendbuf(ia,1) = fsr_l(i,ia,ik)
            end do
            call mpi_allgatherv(sendbuf(1,1),sendcount,        MPI_DOUBLE_PRECISION, &
                                bp_w(1,1),   recvcounts,displs,MPI_DOUBLE_PRECISION,mpi_ke_world,ierr)
         else
            do ia = 1, np_fs
               sendbuf(ia,1) = fsr_l(i,ia,ik)
               sendbuf(ia,2) = fsi_l(i,ia,ik)
            end do
            call mpi_allgatherv(sendbuf(1,1),sendcount,        MPI_DOUBLE_PRECISION, &
                                bp_w(1,1),   recvcounts,displs,MPI_DOUBLE_PRECISION,mpi_ke_world,ierr)
            call mpi_allgatherv(sendbuf(1,2),sendcount,        MPI_DOUBLE_PRECISION, &
                                bp_w(1,2),   recvcounts,displs,MPI_DOUBLE_PRECISION,mpi_ke_world,ierr)
         end if
      end if ! MPI
      call mpi_bcast(bp_w,nlmta*kimg_t,mpi_double_precision,map_e(io),mpi_kg_world,ierr) ! MPI
      deallocate(sendbuf)
    end subroutine broadcast_fs
#endif
    subroutine Psi1SPhi2_t(ik,i)
      integer, intent(in) :: ik,i

      real(kind=DP),allocatable,dimension(:,:)  :: p1Sp2_w

      integer   :: j,ia,p,q, kimg_t, iadd
      real(DP)  :: ar,ai

!!    DEBUG asms
!!    if((k_symmetry(1) == GAMMA .and. kimg == 2).or.kimg==1) then
      if((k_symmetry(ik) == GAMMA .and. kimg == 2).or.kimg==1) then
         kimg_t = 1
      else
         kimg_t = 2
      end if

      if(mod_pot == VANDERBILT_TYPE) then
         allocate(p1Sp2_w(np_e,kimg_t))
      end if

      p1Sp2 = 0.d0
      if(mod_pot == VANDERBILT_TYPE) then
         do j = 1, np_e ! MPI
            if(to == OTHER_BANDS .and. neg_g(j) == i) cycle ! MPI
            if(to == SAME_BAND .and. neg_g(j) /= i) cycle
            ar = 0.d0; if(kimg == 2) ai = 0.d0
            if(kimg == 1) then
               do ia = 1, nac
                  p = nlmta1(ia);      q = nlmta2(ia)
                  ar = ar + fqwei(ia)*(bp_w(p,1)*bsdr_l(j,q,ik) + bp_w(p,2)*bsdi_l(j,q,ik))
               end do
               p1Sp2(j,1) = ar
            else if(kimg == 2) then
               if(k_symmetry(ik) == GAMMA) then
                  do ia = 1, nac
                     p = nlmta1(ia);      q = nlmta2(ia)
                     ar = ar + fqwei(ia)*(bp_w(p,1)*bsdr_l(j,q,ik))
                  end do
                  p1Sp2(j,1) = ar
               else
                  do ia = 1, nac
                     p = nlmta1(ia);      q = nlmta2(ia)
                     ar = ar + fqwei(ia)*(bp_w(p,1)*bsdr_l(j,q,ik) + bp_w(p,2)*bsdi_l(j,q,ik))
                     ai = ai + fqwei(ia)*(bp_w(p,1)*bsdi_l(j,q,ik) - bp_w(p,2)*bsdr_l(j,q,ik))
                  end do
                  p1Sp2(j,1) = ar; p1Sp2(j,2) = ai
               end if
            end if
         end do
         p1Sp2_w = p1Sp2
         p1Sp2 = 0.d0
      end if

      do j = 1, np_e
         if(to == OTHER_BANDS .and. neg_g(j) == i) cycle
         if(to == SAME_BAND .and. neg_g(j) /= i) cycle
         if(kimg == 1) then
            do ia = ista_g1k(ik), iend_g1k(ik)
               iadd = ia - ista_g1k(ik) + 1
               p1Sp2(j,1) = p1Sp2(j,1) + zaj_ball(iadd,i,ik,1)*phi_l(iadd,j,ik,1)
            end do
            call mpi_allreduce(MPI_IN_PLACE,p1Sp2(j,1),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
         else if(kimg == 2) then
            if(k_symmetry(ik) == GAMMA) then
               do ia = max(2,ista_g1k(ik)), iend_g1k(ik)
                  iadd = ia - ista_g1k(ik) + 1
                  ar = zaj_ball(iadd,i,ik,1)
                  ai = zaj_ball(iadd,i,ik,2)
                  p1Sp2(j,1) = p1Sp2(j,1) + (ar*phi_l(iadd,j,ik,1) + ai*phi_l(iadd,j,ik,2))*2.d0
               end do
               if(ista_g1k(ik) == 1) then
! ==== DEBUG by tkato 2011/09/03 ===============================================
!                 p1Sp2(j,1) = p1Sp2(j,1) + zaj_ball(1,i,ik,1)*zaj_ball(1,neg_g(j),ik,1)
                  p1Sp2(j,1) = p1Sp2(j,1) + zaj_ball(1,i,ik,1)*phi_l(1,j,ik,1)
! ==============================================================================
               endif
               call mpi_allreduce(MPI_IN_PLACE,p1Sp2(j,1),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            else
               do ia = ista_g1k(ik), iend_g1k(ik)
                  iadd = ia - ista_g1k(ik) + 1
                  ar = zaj_ball(iadd,i,ik,1)
                  ai = zaj_ball(iadd,i,ik,2)
                  p1Sp2(j,1) = p1Sp2(j,1) + ar*phi_l(iadd,j,ik,1) + ai*phi_l(iadd,j,ik,2)
                  p1Sp2(j,2) = p1Sp2(j,2) + ar*phi_l(iadd,j,ik,2) - ai*phi_l(iadd,j,ik,1)
               end do
               call mpi_allreduce(MPI_IN_PLACE,p1Sp2(j,1),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,p1Sp2(j,2),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            end if
         end if
      end do
      if(mod_pot == VANDERBILT_TYPE) then                                ! MPI
         p1Sp2 = p1Sp2_w + p1Sp2                                         ! MPI
      endif

      if(mod_pot == VANDERBILT_TYPE) then
         deallocate(p1Sp2_w)
      end if

    end subroutine Psi1SPhi2_t

    subroutine modify_bsd_and_phi_t(i)
      integer, intent(in) :: i

      integer             :: j, ia, iadd
      real(DP)            :: sr, si

      if(mod_pot == VANDERBILT_TYPE) then
         do j = 1, np_e ! MPI
            if(to == OTHER_BANDS .and. neg_g(j) == i) cycle
            if(to == SAME_BAND .and. neg_g(j) /= i) cycle
            if(kimg == 1) then
               do ia = 1, nlmta
                  bsdr_l(j,ia,ik) = bsdr_l(j,ia,ik)-p1Sp2(j,1)*bp_w(ia,1)
                  bsdi_l(j,ia,ik) = bsdi_l(j,ia,ik)-p1Sp2(j,1)*bp_w(ia,2)
               end do
            else if(kimg == 2) then
               if(k_symmetry(ik) == GAMMA) then
                  do ia = 1, nlmta
                     sr = bp_w(ia,1)
                     bsdr_l(j,ia,ik) = bsdr_l(j,ia,ik)-p1Sp2(j,1)*sr
                  end do
               else
                  do ia = 1, nlmta
                     sr = bp_w(ia,1);  si = bp_w(ia,2)
                     bsdr_l(j,ia,ik) = bsdr_l(j,ia,ik)-p1Sp2(j,1)*sr+p1Sp2(j,2)*si
                     bsdi_l(j,ia,ik) = bsdi_l(j,ia,ik)-p1Sp2(j,1)*si-p1Sp2(j,2)*sr
                  end do
               end if
            end if
         end do
      end if

      do j = 1, np_e
         if(to == OTHER_BANDS .and. neg_g(j) == i) cycle
         if(to == SAME_BAND .and. neg_g(j) /= i) cycle
         if(kimg == 1) then
            do ia = ista_g1k(ik), iend_g1k(ik)
               iadd = ia - ista_g1k(ik) + 1
               phi_l(iadd,j,ik,1) = phi_l(iadd,j,ik,1) - p1Sp2(j,1)*zaj_ball(iadd,i,ik,1)
            end do
         else if(kimg == 2) then
            if(k_symmetry(ik) == GAMMA) then
               do ia = ista_g1k(ik), iend_g1k(ik)
                  iadd = ia - ista_g1k(ik) + 1
                  sr = zaj_ball(iadd,i,ik,1) ;  si = zaj_ball(iadd,i,ik,2)
                  phi_l(iadd,j,ik,1) = phi_l(iadd,j,ik,1) - p1Sp2(j,1)*sr
                  phi_l(iadd,j,ik,2) = phi_l(iadd,j,ik,2) - p1Sp2(j,1)*si
               end do
            else
               do ia = ista_g1k(ik), iend_g1k(ik)
                  iadd = ia - ista_g1k(ik) + 1
                  sr = zaj_ball(iadd,i,ik,1) ;  si = zaj_ball(iadd,i,ik,2)
                  phi_l(iadd,j,ik,1) = phi_l(iadd,j,ik,1) - p1Sp2(j,1)*sr+p1Sp2(j,2)*si
                  phi_l(iadd,j,ik,2) = phi_l(iadd,j,ik,2) - p1Sp2(j,1)*si-p1Sp2(j,2)*sr
               end do
            end if
         end if
      end do
    end subroutine modify_bsd_and_phi_t

  end subroutine mgs_sd2wf_each_k_G_3D


  subroutine m_ES_MGS_4_each_k(nfout,ik,mode)
    integer, intent(in) :: nfout,mode,ik ! mode={ORTHONORMALIZATION | NORMALIZATION}
    integer :: id_sname = -1,i
                                                  __TIMER_SUB_START(501)
#ifdef __FAPP__
    call fapp_start('mgs_4_each_k',1,1)
#endif
    call wd_title_of_the_operation()                        !-(c.h.)

!!$    call m_ES_mgs_alloc(ik)
    if(mode == ORTHONORMALIZATION) then
       call tstatc0_begin('modified_gram_schmidt ',id_sname,1)
    else
       call tstatc0_begin('modified_gram_schmidt (normalization only)',id_sname,1)
    endif
    if(modnrm == EXECUT) then
       call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)   ! -> fsr_l,fsi_l
       call mgs_4_each_k_G_3D(ista_k,iend_k,ik,zaj_l,mode,fsr_l,fsi_l,mod_pot=VDB)!-(m_E.S.)
       if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
       call tstatc0_end(id_sname)
!!$       if(mode==NORMALIZATION) call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   ! -> fsr_l,fsi_l
    else
       call mgs_4_each_k_G_3D(ista_k,iend_k,ik,zaj_l,mode,mod_pot=NORMCONSERVATION)!-(m_E.S.)
       if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
       call tstatc0_end(id_sname)
       call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)   ! -> fsr_l,fsi_l
    end if
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
!!$    call m_ES_mgs_dealloc
                                                  __TIMER_SUB_STOP(501)
#ifdef __FAPP__
    call fapp_stop('mgs_4_each_k',1,1)
#endif
  contains
    subroutine wd_title_of_the_operation
      integer, save :: iflag = 0
       if(iflag == 0 .and. ipri >= 2 .and. ik == 1) then
          if(modnrm == EXECUT) then
             write(nfout,*) ' <<< modified_gram_schmidt_vanderbilt_type >>>'
          else
             write(nfout,*) ' <<< modified_gram_schmidt_norm_conserve >>>'
          end if
       end if
       if(iflag == 0) iflag = 1
     end subroutine wd_title_of_the_operation
  end subroutine m_ES_MGS_4_each_k


!!$!BRANCH_P 3D_Parallel
!!$  subroutine m_ES_MGS_4_each_k_3D(nfout,ik,mode)
!!$    integer, intent(in) :: nfout,mode,ik ! mode={ORTHONORMALIZATION | NORMALIZATION}
!!$    integer :: id_sname = -1,i
!!$#ifdef __TIMER_SUB__
!!$  call timer_sta(502)
!!$#endif
!!$
!!$    call wd_title_of_the_operation()                        !-(c.h.)
!!$
!!$       call tstatc0_begin('modified_gram_schmidt ',id_sname,1)
!!$    if(modnrm == EXECUT) then
!!$       call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)   ! -> fsr_l,fsi_l
!!$       call mgs_4_each_k_G_3D(ista_k,iend_k,ik,zaj_l,mode &
!!$      &                      ,fsr_l,fsi_l,mod_pot=VDB)!-(m_E.S.)
!!$       call tstatc0_end(id_sname)
!!$    else
!!$       call mgs_4_each_k_G_3D(ista_k,iend_k,ik,zaj_l,mode &
!!$      &                      ,mod_pot=NORMCONSERVATION)!-(m_E.S.)
!!$       call tstatc0_end(id_sname)
!!$       call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)   ! -> fsr_l,fsi_l
!!$    end if
!!$
!!$#ifdef __TIMER_SUB__
!!$  call timer_end(502)
!!$#endif
!!$  contains
!!$    subroutine wd_title_of_the_operation
!!$      integer, save :: iflag = 0
!!$       if(iflag == 0 .and. ipri >= 1 .and. ik == 1) then
!!$          if(modnrm == EXECUT) then
!!$             write(nfout,*) ' <<< modified_gram_schmidt_vanderbilt_type >>>'
!!$          else
!!$             write(nfout,*) ' <<< modified_gram_schmidt_norm_conserve >>>'
!!$          end if
!!$       end if
!!$       if(iflag == 0) iflag = 1
!!$     end subroutine wd_title_of_the_operation
!!$  end subroutine m_ES_MGS_4_each_k_3D
!!$!BRANCH_P_END 3D_Parallel


  subroutine mgs_4_each_k_G_3D(k1,k2,ik,psi_l,mode,bpr_l,bpi_l,mod_pot,dryrun)
! Revised by T. Yamasaki in April 2006

    integer, intent(in)                                :: k1,k2,ik
!-F    real(kind=DP),dimension(kg1,np_e,k1:k2,kimg)      :: psi_l 
    real(kind=DP),dimension(maxval(np_g1k),np_e,k1:k2,kimg)      :: psi_l 
    integer, intent(in)                                :: mode,mod_pot
!-F    real(kind=DP),optional,dimension(np_e,nlmta,k1:k2) :: bpr_l,bpi_l
    real(kind=DP),optional,dimension(np_e,np_fs,k1:k2) :: bpr_l,bpi_l
!-F PARA3D
    logical, intent(in), optional                      :: dryrun
    integer :: nbs, local_block, L_NB_STA, L_NB_END, in, ri, iy, ix, dsize_psi, dsize_bpri
    integer :: icount, iblk, jblk, i_NB, j_NB ,iq
    real(kind=DP),allocatable,dimension(:,:,:) :: wk_psi
    real(kind=DP),allocatable,dimension(:,:,:) :: wk_bpri
    real(kind=DP),allocatable,dimension(:,:,:) :: psi_t_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpr_t_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpi_t_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpr_tw1_dia
!!$    real(kind=DP),allocatable,dimension(:,:) :: bpr_tw2_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpi_tw1_dia
!!$    real(kind=DP),allocatable,dimension(:,:) :: bpi_tw2_dia
    real(kind=DP), allocatable, dimension(:,:,:,:) :: p1Sp2_t2_NB, p1Sp2_t1_NB

    logical :: drun
    integer ::       i
    real(kind=DP) :: fr
    integer  :: kimg_t_wk
    integer :: id_sname = -1
#ifdef MGS_DGEMM
    integer ::       NB_END, NB_END2, i1, i2
!!$    real(kind=DP), allocatable, dimension(:,:) :: bpr_tw1_BLAS
    real(kind=DP), allocatable, dimension(:,:,:) :: p1Sp2_NB
    integer, save :: ibsize_print = OFF
#endif
#ifndef SX
! NEC tune ------------------------------->
    integer :: ibl1,ibl2,ibsize,ncache
    ncache = (m_CtrlP_cachesize()*1024)*3/4
! NEC tune <-------------------------------
#endif
                                                  __TIMER_SUB_START(503)

    call tstatc0_begin('mgs_4_each_k_G_3D ',id_sname)
    drun = .false.
    if(present(dryrun)) drun = dryrun

#ifdef MGS_DGEMM
    if(nblocksize_mgs_is_given) then
       NB = nblocksize_mgs
    else
       NB = nblocksize_mgs_default
    end if
    if(ipri >= 2) then
       if(ibsize_print == OFF) then
          if(nblocksize_mgs_is_given) then
             write(nfout,'(" ! nblocksize_mgs_is_given")')
          else
             write(nfout,'(" ! nblocksize_mgs_is_given is false")')
          end if
          write(nfout,'( "! NB(=nblocksize_mgs) (mgs_4_each_k_G) = ",i8)') NB
          ibsize_print = ON
       end if
    end if
#endif

#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
!-F    call m_ES_mgs_alloc(ik)
!xx   call m_ES_mgs_alloc_3D(ik)
!!$    call m_ESortho_mgs_alloc_3D(ik)
    call m_ESortho_mgs_alloc(ik)
!!$    kimg_t_wk = kimg
!!$    if(kimg==2 .and. k_symmetry(ik) == GAMMA) kimg_t_wk = 1
    kimg_t_wk = 2
    if(k_symmetry(ik) == GAMMA) kimg_t_wk = 1
#ifdef MGS_DGEMM
    allocate(p1Sp2_NB(NB,NB,kimg_t_wk))
    allocate( wk_psi(mp_g1k(ik),NB,kimg) ) ; wk_psi = 0.0d0
    allocate( psi_t_dia(np_g1k(ik),NB,kimg) )
#endif
!PARA3D
    dsize_psi = mp_g1k(ik)*NB*kimg
    if(mod_pot == VANDERBILT_TYPE) then
      if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
!!$        i = 3
        i = 2
      else
!!$        i = 6
        i = 4
      endif
      allocate( wk_bpri(i,max(mp_fs,nac_p),NB) )
      dsize_bpri = i*max(mp_fs,nac_p)*NB
    endif
    allocate( bpr_t_dia(np_fs,NB) )
    allocate( bpi_t_dia(np_fs,NB) )
    allocate( bpr_tw1_dia(nac_p,NB) )
    allocate( bpi_tw1_dia(nac_p,NB) )

    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg_t_wk == 1) then
          call m_ES_F_transpose_r_3D(k1,k2,ik,bpr_l,bpr_t)              ! bpr_l -> bpr_t
       else
          call m_ES_F_transpose_r_3D(k1,k2,ik,bpr_l,bpr_t,bpi_l,bpi_t)  ! bp[ri]_l -> bp[ri]_t
       end if
    end if

    call m_ES_W_transpose_r_3D(k1,k2,ik,psi_l,psi_t)    !-(m_E.S.) psi_ l-> psi_t
    !    This is, actually, not transpose.

     icount = (neg/NB+1)/nrank_e+1
!!$     allocate( p1Sp2_t2_NB(NB,NB,kimg_t_wk,icount) )
     allocate( p1Sp2_t1_NB(NB,NB,kimg_t_wk,icount) )

#ifdef MGS_DGEMM
    do i = 1, neg,NB
       NB_END = i + NB -1
       if( NB_END > neg ) NB_END = neg

       nbs = (i-1)/NB+1
       if(ipri>=2) &
            & write(nfout,'(" i, nbs = ",2i8, " myrank_e, lrank(nbs) = ",2i8)') i, nbs, myrank_e, lrank(nbs)
       if( myrank_e == lrank(nbs)) then
          local_block = nbsn(nbs)
          L_NB_STA = nbsn_sta(local_block)
          L_NB_END = nbsn_end(local_block)
          if(ipri>=2) write(nfout,'(" L_NB_STA, L_NB_END = ",2i8)') L_NB_STA, L_NB_END
!diagonal
                                                  __TIMER_DO_START(540)
    do i1 = L_NB_STA, L_NB_END
       if(mode == ORTHONORMALIZATION .or. mode == NORMALIZATION) then
          call WSW_t_g(ik,i1,mod_pot,fr,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t) ! fr = 1/dsqrt(<Psi(i)|S|Psi(i)>)
          if(dabs(fr-1.d0) > DELTA) &
               & call normalize_bp_and_psi_t_g(ik,i1,fr,mod_pot &
               & ,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t)
          !   |Psi(i)> = |Psi(i)> * fr,  <beta|Psi(i)> = <beta|Psi(i)> * fr
          if(mod_pot == VANDERBILT_TYPE) call cp_bpr2bprtw(i1,L_NB_END)  ! bpr_t -> bpr_tw1, bpr_tw2
       end if
       if(mode /= NORMALIZATION) then
          if(i1 == neg) cycle
          call cp_psi2psii_g(ik,i1) ! psi_t(:,i1,:) -> psi_ir,psi_ii
          call W1SW2_t_r_g(ik,i1,L_NB_END,mod_pot,psi_t,np_g1k_x,np_e,kimg) ! -> p1Sp2
          if(mod_pot == VANDERBILT_TYPE) &
               & call cp_bpr2bpi_g(kimg_t_wk, i1,bpr_t,bpi_t)  ! -> bp_ir, bp_ii
          call modify_bp_and_psi_t_r_g(ik,i1,L_NB_END,mod_pot &
               & ,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t) ! psi_t, bpr_t, pbi_t, p1Sp2 -> psi_t, bpr_t, bpi_t
       end if
    end do   ! i1-loop
                                                  __TIMER_DO_STOP(540)
! bcast 
       call cp_psi_bpri2dias_g()

       endif ! myrank_e == lrank(nbs)

    if(nrank_e > 1 ) then
                                                 __TIMER_COMM_START_w_BARRIER(mpi_kg_world,529)
       call mpi_bcast(wk_psi,dsize_psi,mpi_double_precision,lrank(nbs),mpi_kg_world,ierr)
                                                 __TIMER_COMM_STOP(529)
    endif
                                                 __TIMER_COMM_START(530)
       do ri = 1, kimg
       do iy = 1, NB
         do ix = 1, np_g1k(ik)
           psi_t_dia(ix,iy,ri) = wk_psi(ix,iy,ri)
       enddo; enddo;  enddo;
                                                 __TIMER_COMM_STOP(530)
                                                 __TIMER_DO_START(541)
       do ri = 1, kimg
!       do iy = i, NB_END
       do iy = nbs_sta(nbs), nbs_end(nbs)
         do ix = 1, np_g1k(ik)
           zaj_ball(ix,iy,ik,ri) = wk_psi(ix,iy-nbs_sta(nbs)+1,ri)
       enddo; enddo;  enddo;
                                                 __TIMER_DO_STOP(541)
       if(mod_pot == VANDERBILT_TYPE) then
          if(nrank_e > 1 ) then
                                                 __TIMER_COMM_START_w_BARRIER(mpi_kg_world,531)
              call mpi_bcast(wk_bpri,dsize_bpri,mpi_double_precision,lrank(nbs),mpi_kg_world,ierr)
                                                 __TIMER_COMM_STOP(531)
          endif
          if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
                                                 __TIMER_COMM_START(532)
             do iy = 1, NB
                do ix = 1, np_fs
                   bpr_t_dia(ix,iy) = wk_bpri(1,ix,iy)
                enddo
                do ix = 1, nac_p
                   bpr_tw1_dia(ix,iy) = wk_bpri(2,ix,iy)
!!$                   bpr_tw2_dia(ix,iy) = wk_bpri(3,ix,iy)
                enddo
             enddo
                                                 __TIMER_COMM_STOP(532)
                                                 __TIMER_DO_START(542)
              do iy = nbs_sta(nbs), nbs_end(nbs)     !       do iy = i,NB_END
                do ix = 1,np_fs
                   fsr_ball(iy,ix,ik) = wk_bpri(1,ix,iy-nbs_sta(nbs)+1)
                enddo
             enddo
                                                 __TIMER_DO_STOP(542)
          else
                                                 __TIMER_COMM_START(533)
             do iy = 1, NB
                do ix = 1, np_fs
                   bpr_t_dia(ix,iy) = wk_bpri(1,ix,iy)
                   bpi_t_dia(ix,iy) = wk_bpri(2,ix,iy)
                enddo
                do ix = 1, nac_p
                   bpr_tw1_dia(ix,iy) = wk_bpri(3,ix,iy)
!!$                   bpr_tw2_dia(ix,iy) = wk_bpri(4,ix,iy)
                   bpi_tw1_dia(ix,iy) = wk_bpri(4,ix,iy)
!!$                   bpi_tw2_dia(ix,iy) = wk_bpri(6,ix,iy)
                enddo
             enddo
                                                 __TIMER_COMM_STOP(533)
                                                 __TIMER_DO_START(543)
             do iy = nbs_sta(nbs), nbs_end(nbs)      !      do iy = i,NB_END
                do ix = 1,np_fs
                   fsr_ball(iy,ix,ik) = wk_bpri(1,ix,iy-nbs_sta(nbs)+1)
                   fsi_ball(iy,ix,ik) = wk_bpri(2,ix,iy-nbs_sta(nbs)+1)
                enddo
             enddo
                                                 __TIMER_DO_STOP(543)
          endif
       endif

!lower1
    if(mode /= NORMALIZATION) then
    icount = 0
    p1Sp2_t1_NB = 0.0d0
                                                 __TIMER_DO_START(544)
    do i2 = i+NB, neg,NB
       if(NB_END == neg) cycle
       NB_END2 = i2 + NB -1
       if( NB_END2 > neg ) NB_END2 = neg

       nbs = (i2-1)/NB+1
       if( myrank_e /= lrank(nbs)) cycle
       local_block = nbsn(nbs)
       L_NB_STA = nbsn_sta(local_block)
       L_NB_END = nbsn_end(local_block)
       if(mod_pot == VANDERBILT_TYPE) call cp_bpr2bprtw(L_NB_STA,L_NB_END)  ! bpr_t -> bpr_tw1, bpr_tw2

       call W1SW2_t_r_block_g(ik,i,L_NB_STA,p1Sp2_NB,NB_END,L_NB_END,kimg_t_wk &
            & , mod_pot,psi_t,psi_t_dia,np_g1k_x,np_e,kimg,bpr_tw1_dia,bpi_tw1_dia) ! -> p1Sp2
       icount = icount + 1

!-$ tune FUJITSU for block ----->>
!modify2010
                                                 __TIMER_COMM_START(534)
        do i_NB = 1, NB
           do iq = 1, kimg_t_wk
             do j_NB = 1,NB
               p1Sp2_t1_NB(j_NB,i_NB,iq,icount) = p1Sp2_NB(j_NB,i_NB,iq)
         end do ; enddo ; enddo
                                                 __TIMER_COMM_STOP(534)
!      if(nrank_g > 1 ) then
!       do i_NB = 1, NB
!          do iq = 1, kimg_t_wk
!            do j_NB = 1,NB
!              p1Sp2_t1_NB(j_NB,i_NB,iq,icount) = p1Sp2_NB(j_NB,i_NB,iq)
!        end do ; enddo ; enddo
!      endif
!-$ tune FUJITSU for block <<-----

    end do   ! i2-loop1
                                                 __TIMER_DO_STOP(544)

    if (NB_END /= neg ) then

! allreduce
    if(nrank_g > 1 ) then
      ix =  NB*NB*kimg_t_wk*icount
                                                 __TIMER_COMM_START_w_BARRIER(mpi_ke_world,535)
      call mpi_allreduce(MPI_IN_PLACE, p1Sp2_t1_NB,ix,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
                                                 __TIMER_COMM_STOP(535)
    endif

    endif   !(NB_END /= neg )
!lower2
    icount = 0
                                                 __TIMER_DO_START(545)
    do i2 = i+NB, neg,NB
       if(NB_END == neg) cycle
       NB_END2 = i2 + NB -1
       if( NB_END2 > neg ) NB_END2 = neg
       nbs = (i2-1)/NB+1
       if( myrank_e /= lrank(nbs)) cycle
       local_block = nbsn(nbs)
       L_NB_STA = nbsn_sta(local_block)
       L_NB_END = nbsn_end(local_block)

!modify2010
       if(nrank_g > 1 ) then
         icount =  icount+1
                                                 __TIMER_DO_START(546)
         do i_NB = 1, NB
           do iq = 1, kimg_t_wk
             do j_NB = 1, NB
               p1Sp2_NB(j_NB,i_NB,iq) = p1Sp2_t1_NB(j_NB,i_NB,iq,icount)
         end do ; enddo ; enddo
                                                 __TIMER_DO_STOP(546)
       else
         icount =  icount+1
                                                 __TIMER_DO_START(547)
         do i_NB = 1, NB
           do iq = 1, kimg_t_wk
             do j_NB = 1, NB
               p1Sp2_NB(j_NB,i_NB,iq) = p1Sp2_t1_NB(j_NB,i_NB,iq,icount)
         end do ; enddo ; enddo
                                                 __TIMER_DO_STOP(547)
       endif
!      if(nrank_g > 1 ) then
!        icount =  icount+1
!        do i_NB = 1, NB
!          do iq = 1, kimg_t_wk
!            do j_NB = 1, NB
!              p1Sp2_NB(j_NB,i_NB,iq) = p1Sp2_t2_NB(j_NB,i_NB,iq,icount)
!        end do ; enddo ; enddo
!      endif

       call modify_bp_and_psi_t_r_blk_g(ik,i,L_NB_STA,p1Sp2_NB,NB_END,L_NB_END,kimg_t_wk &
            & , mod_pot,psi_t,psi_t_dia,np_g1k_x,np_e,kimg,bpr_t,bpi_t,bpr_t_dia,bpi_t_dia)
       !                   psi_t, bpr_t, pbi_t, p1Sp2 -> psi_t, bpr_t, bpi_t
    end do   ! i2-loop2
                                                 __TIMER_DO_STOP(545)
    end if   ! lower1 (mode /= NORMALIZATION)
    end do   ! i-loop
#else
    do i = 1, neg
       if(mode == ORTHONORMALIZATION .or. mode == NORMALIZATION) then
          call WSW_t_g(ik,i,mod_pot,fr,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t) ! fr = 1/dsqrt(<Psi(i)|S|Psi(i)>)
          if(dabs(fr-1.d0) > DELTA) &
               & call normalize_bp_and_psi_t_g(ik,i,fr,mod_pot,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t)
          !   |Psi(i)> = |Psi(i)> * fr,  <beta|Psi(i)> = <beta|Psi(i)> * fr
       end if
       if(mode /= NORMALIZATION) then
          if(i == neg) cycle
          call cp_psi2psii_g(ik,i) ! psi_t(:,i,:) -> psi_ir,psi_ii
          if(mod_pot == VANDERBILT_TYPE) &
               & call cp_bpr2bpi_g(kimg_t_wk,i,bpr_t,bpi_t) ! -> bp_ir, bp_ii
          call W1SW2_t_r_g(ik,i,neg,mod_pot,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t) ! -> p1Sp2
          call modify_bp_and_psi_t_r_g(ik,i,neg,mod_pot &
               & ,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t) ! psi_t, bpr_t, pbi_t, p1Sp2 -> psi_t, bpr_t, bpi_t
       end if
    end do
#endif

    call m_ES_W_transpose_back_r_3D(k1,k2,ik,psi_l,psi_t)
    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg_t_wk == 1) then
          call m_ES_F_transpose_back_r_3D(k1,k2,ik,bpr_l,bpr_t)
       else
          call m_ES_F_transpose_back_r_3D(k1,k2,ik,bpr_l,bpr_t,bpi_l,bpi_t)
       end if
    end if
!!$    deallocate(bpi_tw2_dia,bpi_tw1_dia,bpr_tw2_dia,bpr_tw1_dia)
    deallocate(p1Sp2_t1_NB)
    deallocate(bpi_tw1_dia,bpr_tw1_dia)
    deallocate(bpi_t_dia,bpr_t_dia)
    if(mod_pot == VANDERBILT_TYPE) deallocate(wk_bpri)
#ifdef MGS_DGEMM
    deallocate(psi_t_dia)
    deallocate(wk_psi)
    deallocate(p1Sp2_NB)
#endif
#else
    integer ::       nmax, ito
    integer, allocatable, dimension(:)         :: ib2to_a, ib2back_a
    allocate(ib2to_a(neg)); allocate(ib2back_a(neg))

!xx call m_ES_mgs_alloc(ik)
!!$    call m_ESortho_mgs_alloc_3D(ik)
    call m_ESortho_mgs_alloc(ik)

!!$    if(mod_pot == VANDERBILT_TYPE) call m_ES_F_transpose(k1,k2,ik,bpr_l,bpi_l,bpr_t,bpi_t)
    if(mod_pot == VANDERBILT_TYPE) &
         & call m_ES_F_transpose_r(.false.,k1,k2,ik,bpr_l,bpr_t,bpi_l,bpi_t)
    call m_ES_W_transpose_r(.false.,k1,k2,ik,psi_l,psi_t)    !-(m_E.S.) psi_ l-> psi_t
    do i = 1, neg
       ito = neordr(i,ik)
       if(mode == ORTHONORMALIZATION .or. mode == NORMALIZATION) then
          call WSW_t_g(ik,ito,mod_pot,fr,psi_t,np_g1k_x,neg,kimg,bpr_t,bpi_t) ! fr = 1/dsqrt(<Psi(ito)|S|Psi(ito)>)
          if(dabs(fr-1.d0) > DELTA) &
               & call normalize_bp_and_psi_t_g(ik,ito,fr,mod_pot &
               & ,psi_t,np_g1k_x,neg,kimg,bpr_t,bpi_t) !
          !   |Psi(ito)> = |Psi(ito)> * fr,  <beta|Psi(ito)> = <beta|Psi(ito)> * fr
       end if
       if(mode /= NORMALIZATION) then
          call substitute_jto_ib2back(i,nmax) !-(c.h.) ->ib2to_a,ib2back_a,
          if(nmax == 0) cycle
          call W1SW2_t(i,ito) ! -> p1Sp2
          call modify_bp_and_psi_t(i,ito) ! psi_t, bpr_t, pbi_t, p1Sp2 -> psi_t, bpr_t, bpi_t
       end if
    end do

    call m_ES_W_transpose_back_r(.false.,k1,k2,ik,psi_l,psi_t)
!!$    if(mod_pot == VANDERBILT_TYPE) call m_ES_F_transpose_back(k1,k2,ik,bpr_l,bpi_l,bpr_t,bpi_t)
    if(mod_pot == VANDERBILT_TYPE) &
         & call m_ES_F_transpose_back_r(.false.,k1,k2,ik,bpr_l,bpr_t,bpi_l,bpi_t)
    deallocate(ib2back_a,ib2to_a)
#endif
!xx call m_ES_mgs_dealloc_3D()
    call m_ESortho_mgs_dealloc()
    call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(503)

!!$#else
!!$    integer, parameter :: npfsr_o = 0
!!$    integer            :: npfsi_o, npzr_o, npzi_o
!!$    integer, dimension(2) :: npzri_o
!!$    real(kind=DP)      :: fr,fi
!!$    integer            :: j, ibaik
!!$    integer                                         :: nsize_of_brd_w
!!$    real(kind=DP),allocatable, dimension(:)         :: brd_w
!!$
!!$    call alloc_and_brd_w()  ! nsize_of_brd_w, brd_w
!!$
!!$    ibaik = iba(ik)
!!$
!!$    npfsi_o = nlmta
!!$    call set_npzri(mod_pot,ik,npzr_o,npzi_o,npzri_o)  ! ->(npzr_o,npzi_o,npzri_o)
!!$
!!$    if(ipri >= 2) print '(" <<< modified_gram_schmidt_vanderbilt_type(cyclic)>>>")'
!!$    do i = 1, neg
!!$       ito = neordr(i,ik)
!!$       if(map_e(ito) == myrank_e) then               ! MPI
!!$          if(mode == ORTHONORMALIZATION .or. mode == NORMALIZATION) then
!!$             call WSW(ito,fr) !   fr = 1/dsqrt(<Psi(ito)|S|Psi(ito)>)
!!$             if(dabs(fr-1.d0) > DELTA) call normalize_bp_and_psi(ito,fr)
!!$             !   |Psi(ito)> = |Psi(ito)> * fr,  <beta|Psi(ito)> = <beta|Psi(ito)> * fr
!!$          end if
!!$          if(mode /= NORMALIZATION) &
!!$               & call cp_bp_and_psi_2_brd_w2(k1,k2,ik,ito,mod_pot &
!!$               & , bpr_l,bpi_l,psi_l,npfsr_o,npfsi_o,npzri_o,nsize_of_brd,brd_w)
!!$          !                         -(m_E.S.) (bpr_l,bpi_l),psi_l -> brd_w   MPI
!!$       end if
!!$       if(mode /= NORMALIZATION) then
!!$          call mpi_bcast(brd_w,nsize_of_brd_w,mpi_double_precision &
!!$               & ,map_e(ito),mpi_k_world(myrank_k),ierr) !MPI
!!$
!!$          do j = ista_e, iend_e, istep_e                ! MPI
!!$             if(nrvf_ordr(j,ik) <= i) cycle
!!$             call W1SW2(j,fr,fi)
!!$             call modify_bp_and_psi(j,fr,fi)
!!$          end do
!!$       end if
!!$    end do
!!$    call dealloc_and_brd_w
!!$#endif
  contains

#ifdef MGS_DGEMM
    subroutine cp_psi_bpri2dias_g()
      integer :: ri,i1,ix,iy
                                                 __TIMER_COMM_START(527)
      do ri = 1, kimg
         do i1 = L_NB_STA, L_NB_END
            iy = i1-L_NB_STA+1
            do ix = 1, np_g1k(ik)
               wk_psi(ix,iy,ri) = psi_t(ix,i1,ri)
            enddo
         enddo
      enddo
                                                 __TIMER_COMM_STOP(527)
                                                 __TIMER_COMM_START(528)
      if(mod_pot == VANDERBILT_TYPE) then
         if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
            do i1 = L_NB_STA, L_NB_END
               iy = i1-L_NB_STA+1
               do ix = 1, np_fs
                  wk_bpri(1,ix,iy) = bpr_t(ix,i1)
               enddo
               do ix = 1, nac_p
                  wk_bpri(2,ix,iy) = bpr_tw1(ix,i1)
!!$                     wk_bpri(3,ix,iy) = bpr_tw2(ix,i1)
               enddo
            enddo
         else
            do i1 = L_NB_STA, L_NB_END
               iy = i1-L_NB_STA+1
               do ix = 1, np_fs
                  wk_bpri(1,ix,iy) = bpr_t(ix,i1)
                  wk_bpri(2,ix,iy) = bpi_t(ix,i1)
               enddo
               do ix = 1, nac_p
                  wk_bpri(3,ix,iy) = bpr_tw1(ix,i1)
!!$                     wk_bpri(4,ix,iy) = bpr_tw2(ix,i1)
!!$                     wk_bpri(5,ix,iy) = bpi_tw1(ix,i1)
                  wk_bpri(4,ix,iy) = bpi_tw1(ix,i1)
!!$                     wk_bpri(6,ix,iy) = bpi_tw2(ix,i1)
               enddo
            enddo
         endif
      endif
                                                 __TIMER_COMM_STOP(528)
  end subroutine cp_psi_bpri2dias_g
#endif

#ifdef MGS_DGEMM
    subroutine cp_bpr2bprtw(i1,i2)
      integer, intent(in) :: i1,i2
      integer :: i, ia, p, q, i_last
                                                  __TIMER_SUB_START(505)
!!$      if(i1==1) then
!!$         i_last = i2
!!$      else
!!$         i_last = i1
!!$      end if
#ifdef MGS_DGEMM_DEBUG
      i_last = i1
#else
      i_last = i2
#endif
      if(k_symmetry(ik) == GAMMA) then
                                                  __TIMER_DO_START(552)
         do i = i1, i_last
            do ia = 1, nac_p
               p = nlmta1_p(ia);     q = nlmta2_p(ia)
               bpr_tw1(ia,i) = bpr_t(p,i)
               bpr_tw2(ia,i) = bpr_t(q,i)
            end do
         end do
                                                  __TIMER_DO_STOP(552)
      else
                                                  __TIMER_DO_START(553)
         do i = i1, i_last
            do ia = 1, nac_p
               p = nlmta1_p(ia);     q = nlmta2_p(ia)
               bpr_tw1(ia,i) = bpr_t(p,i)
               bpr_tw2(ia,i) = bpr_t(q,i)
               bpi_tw1(ia,i) = bpi_t(p,i)
               bpi_tw2(ia,i) = bpi_t(q,i)
            end do
         end do
                                                  __TIMER_DO_STOP(553)
      end if
                                                  __TIMER_SUB_STOP(505)
    end subroutine cp_bpr2bprtw
#endif
      
!!$    subroutine alloc_p1Sp2(n)
!!$      integer, intent(in) :: n
!!$      if(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2) then
!!$         kimg_t = 1
!!$      else
!!$         kimg_t = 2
!!$      end if
!!$      allocate(p1Sp2(n,kimg_t))
!!$    end subroutine alloc_p1Sp2
!!$
!!$    subroutine dealloc_p1Sp2
!!$      deallocate(p1Sp2)
!!$    end subroutine dealloc_p1Sp2

#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT

#else

    subroutine substitute_jto_ib2back(i,nmax)
      integer, intent(in)  :: i
      integer, intent(out) :: nmax

      integer              ::jto, j
      jto = 0
      do j = 1, neg
         if(nrvf_ordr(j,ik) <= i) cycle
         jto = jto + 1
         ib2to_a(jto)  = j
         ib2back_a(j)  = jto
      end do
      nmax = jto
      if(ipri >= 2 .and. ik == 1) then
         write(nfout,'(" <<substitute_jto_ib2back>>")')
         do j = 1, neg
            write(nfout,'(" ib2back_a(",i3,") = ",i3)') j, ib2back_a(j)
         end do
         do j = 1, nmax
            write(nfout,'(" ib2to_a(",i3,") = ",i3)') j, ib2to_a(j)
         end do
      end if
    end subroutine substitute_jto_ib2back

    subroutine W1SW2_t(i,ito)
      integer, intent(in)        :: i,ito

      integer       :: j, ia, jto, p, q, kimg_t
      real(kind=DP) :: ar, ai
      real(kind=DP), allocatable, dimension(:,:)  :: p1Sp2_t1, p1Sp2_t2             ! MPI

!!$      call alloc_p1Sp2(nmax)
      if(npes > 1) then
         if((k_symmetry(ik) == GAMMA .and. kimg==2) .or. kimg == 1) then
            kimg_t = 1
         else
            kimg_t = 2
         end if
         allocate(p1Sp2_t2(nmax,kimg_t)); p1Sp2_t2 = 0.d0                  ! MPI
         allocate(p1Sp2_t1(nmax,kimg_t)); p1Sp2_t1 = 0.d0                  ! MPI
      end if

      p1Sp2 = 0.d0

      if(mod_pot == VANDERBILT_TYPE) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(jto,ia,ar,ai,p,q)
#endif
         do jto = 1, nmax                                                 ! MPI
            j = ib2to_a(jto)                                              ! MPI
            if(kimg == 1) then
               ar = 0.d0
               do ia = 1, nac_p
                  p = nlmta1_p(ia);            q = nlmta2_p(ia)
                  ar = ar + fqwei_p(ia)*(bpr_t(p,ito)*bpr_t(q,j)+bpi_t(p,ito)*bpi_t(q,j))
               end do
               p1Sp2(jto,1) = ar
            else if(kimg == 2) then
               if(k_symmetry(ik) == GAMMA) then
                  ar = 0.d0
                  do ia = 1, nac_p
                     p = nlmta1_p(ia);         q = nlmta2_p(ia)
                     ar = ar + fqwei_p(ia)*(bpr_t(p,ito)*bpr_t(q,j))
                  end do
                  p1Sp2(jto,1) = ar
               else
                  ar = 0.d0; ai = 0.d0
                  do ia = 1, nac_p
                     p = nlmta1_p(ia);         q = nlmta2_p(ia)
                     ar = ar + fqwei_p(ia)*(bpr_t(p,ito)*bpr_t(q,j)+bpi_t(p,ito)*bpi_t(q,j))
                     ai = ai + fqwei_p(ia)*(bpr_t(p,ito)*bpi_t(q,j)-bpi_t(p,ito)*bpr_t(q,j))
                  end do
                  p1Sp2(jto,1) = ar;  p1Sp2(jto,2) = ai
               end if
            end if
         end do
      end if

      if(ipri >= 2 .and. ik == 1) then
         if(nmax > 1) then
            write(nfout,'(" <<W1SW2_t>> ik = ",i9,"  i = ",i3, " ito = ", i3)') ik,i,ito
            write(nfout,'(" (real) ",6d11.3, 99(/8x,6d11.3))') (p1Sp2(jto,1),jto=1, nmax)
            if(kimg == 2 .and. k_symmetry(ik) /= GAMMA) &
                 & write(nfout,'(" (imag) ",6d11.3, 99(/8x,6d11.3))') (p1Sp2(jto,kimg),jto=1, nmax)
         end if
      end if

      if(kimg == 1) then
         do jto = 1, nmax
            j = ib2to_a(jto)
            do ia = 1, np_g1k(ik)                                           ! MPI
               p1Sp2(jto,1) = p1Sp2(jto,1) + psi_t(ia,ito,1)*psi_t(ia,j,1 ) ! MPI
            end do
         end do
      else if(kimg == 2) then
         if(k_symmetry(ik) == GAMMA) then
            do jto = 1, nmax
               j = ib2to_a(jto)
               do ia = 2, np_g1k(ik)
                  ar  = psi_t(ia,ito,1)
                  ai  = psi_t(ia,ito,2)
                  p1Sp2(jto,1) = p1Sp2(jto,1)+(ar*psi_t(ia,j,1)+ai*psi_t(ia,j,2))*2.d0 ! MPI
               end do
!!$               if(mype /= 0) then
               if(myrank_e /= 0) then
                  ar = psi_t(1,ito,1)
                  ai = psi_t(1,ito,2)
                  p1Sp2(jto,1) = p1Sp2(jto,1) + (ar*psi_t(1,j,1) + ai*psi_t(1,j,2))*2.d0
               else
                  p1Sp2(jto,1) = p1Sp2(jto,1) + psi_t(1,ito,1)*psi_t(1,j,1)
               end if
            end do
         else
            do jto = 1, nmax
               j = ib2to_a(jto)
               do ia = 1, np_g1k(ik)                                          ! MPI
                  ar  = psi_t(ia,ito,1)
                  ai  = psi_t(ia,ito,2)
                  p1Sp2(jto,1) = p1Sp2(jto,1)+ar*psi_t(ia,j,1)+ai*psi_t(ia,j,2) ! MPI
                  p1Sp2(jto,2) = p1Sp2(jto,2)+ar*psi_t(ia,j,2)-ai*psi_t(ia,j,1) ! MPI
               end do
            end do
         end if
      end if
      if(npes > 1 ) then
         do q = 1, kimg_t
            do jto = 1, nmax
               p1Sp2_t1(jto,q) = p1Sp2(jto,q)
            end do
         end do
         call mpi_allreduce(p1Sp2_t1, p1Sp2_t2,nmax*kimg_t,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
         do q = 1, kimg_t
            do jto = 1, nmax
               p1Sp2(jto,q) = p1Sp2_t2(jto,q)
            end do
         end do
      end if

      if(ipri >= 2 .and. ik == 1) then
         if(nmax > 1) then
            write(nfout,'(" <<W1SW2_t>> ik = ",i9,"  i = ",i3, " ito = ", i3)') ik,i,ito
            write(nfout,'(" (real) ",6d11.3, 99(/8x,6d11.3))') (p1Sp2(jto,1),jto=1, nmax)
            if(kimg == 2 .and. k_symmetry(ik) /= GAMMA) &
                 & write(nfout,'(" (imag) ",6d11.3, 99(/8x,6d11.3))') (p1Sp2(jto,kimg),jto=1, nmax)
         end if
      end if

      if(nrank_e*nrank_g > 1) deallocate(p1Sp2_t1,p1Sp2_t2)
    end subroutine W1SW2_t

    subroutine modify_bp_and_psi_t(i,ito)
      integer, intent(in) :: i, ito
      integer             :: j,ia,jto
      real(kind=DP) :: sr, si

      if(mod_pot == VANDERBILT_TYPE) then
         do j = 1, neg
            if(nrvf_ordr(j,ik) <= i) cycle
            jto = ib2back_a(j)
            if(kimg == 1) then
               do ia = 1, np_fs
                  bpr_t(ia,j) = bpr_t(ia,j) - p1Sp2(jto,1)*bpr_t(ia,ito)
                  bpi_t(ia,j) = bpi_t(ia,j) - p1Sp2(jto,1)*bpi_t(ia,ito)
               end do
            else if(kimg == 2) then
               if(k_symmetry(ik) == GAMMA) then
                  do ia = 1, np_fs
                     bpr_t(ia,j) = bpr_t(ia,j) - p1Sp2(jto,1)*bpr_t(ia,ito)
                  end do
               else
                  do ia = 1, np_fs
                     sr  =  bpr_t(ia,ito);     si  =  bpi_t(ia,ito)
                     bpr_t(ia,j) = bpr_t(ia,j) - p1Sp2(jto,1)*sr+p1Sp2(jto,2)*si
                     bpi_t(ia,j) = bpi_t(ia,j) - p1Sp2(jto,1)*si-p1Sp2(jto,2)*sr
                  end do
               end if
            end if
         end do
      end if

#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!CDIR NOSYNC
!CDIR CONCUR(BY=1)
#endif
      do j = 1,neg
         if(nrvf_ordr(j,ik) <= i) cycle
         jto = ib2back_a(j)         ! <-- 99Jan19 T. Y.
         if(kimg == 1) then
            do ia = 1, np_g1k(ik)                 ! MPI
               psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(jto,1)*psi_t(ia,ito,1 )
            end do
         else if(kimg == 2) then
            if(k_symmetry(ik) == GAMMA) then
               do ia = 1, np_g1k(ik)
                  sr  =  psi_t(ia,ito,1 );   si  =  psi_t(ia,ito,2 )
                  psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(jto,1)*sr
                  psi_t(ia,j,2) = psi_t(ia,j,2) - p1Sp2(jto,1)*si
               end do
            else
               do ia = 1, np_g1k(ik)                ! MPI
                  sr  =  psi_t(ia,ito,1 );   si  =  psi_t(ia,ito,2 )
                  psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(jto,1)*sr+p1Sp2(jto,2)*si
                  psi_t(ia,j,2) = psi_t(ia,j,2) - p1Sp2(jto,1)*si-p1Sp2(jto,2)*sr
               end do
            end if
         end if
      end do
!!$      call dealloc_p1Sp2()
    end subroutine modify_bp_and_psi_t
#endif

  end subroutine mgs_4_each_k_G_3D

!!$  subroutine set_npzri(mod_pot,ik,npzr_o,npzi_o,npzri_o)
!!$    integer, intent(in)  :: mod_pot,ik
!!$    integer, intent(out) :: npzr_o, npzi_o, npzri_o(2)
!!$
!!$    if(mod_pot == NORMCONSERVATION) then
!!$       npzr_o = 0
!!$    else
!!$       if(k_symmetry(ik) == GAMMA) then
!!$          npzr_o = nlmta
!!$       else
!!$          npzr_o = nlmta * 2
!!$       end if
!!$    end if
!!$    npzi_o = npzr_o + iba(ik)
!!$    npzri_o(1) = npzr_o; npzri_o(2) = npzi_o
!!$  end subroutine set_npzri

#ifdef TRANSPOSE
!!$#endif !TRANSPOSE_ORIGINAL


#else
!! #ifdef TRANSPOSE else

#endif
!! #ifdef TRANSPOSE end

  subroutine m_ES_F_transpose_r_3D(k1,k2,ik,bpr_l,bpr_t,bpi_l,bpi_t)

    integer, intent(in)                                                :: k1,k2,ik
!-F    real(kind=DP), intent(in), dimension(np_e,nlmta,k1:k2)             :: bpr_l
!-F    real(kind=DP), intent(out),dimension(np_fs_x,neg)                  :: bpr_t
!-F    real(kind=DP), intent(in), optional,dimension(np_e,nlmta,k1:k2)    :: bpi_l
!-F    real(kind=DP), intent(out),optional,dimension(np_fs_x,neg)         :: bpi_t
    real(kind=DP), intent(in), dimension(np_e,np_fs,k1:k2)             :: bpr_l
    real(kind=DP), intent(out),dimension(np_fs_x,np_e)                  :: bpr_t
    real(kind=DP), intent(in), optional,dimension(np_e,np_fs,k1:k2)    :: bpi_l
    real(kind=DP), intent(out),optional,dimension(np_fs_x,np_e)         :: bpi_t

    real(kind=DP), allocatable, dimension(:,:,:,:) :: tmp_s,tmp_r
    integer, allocatable, dimension(:) :: req_s,req_r

    integer :: datasize, nb_proc, j, ix,iy, kimg_t, ifrom, ito
    integer :: pe_s,pe_r
    integer :: id_sname = -1
#ifdef MGS_DGEMM_DEBUG
    integer :: ia,p,q
#endif
                                                  __TIMER_SUB_START(511)

    if(k_symmetry(ik) == GAMMA) then ! assuming kimg == 2 when k_symmetry(ik) == GAMMA.
       kimg_t = 1
    else
       kimg_t = 2
    end if
                                                  __TIMER_DO_START(573)
    if(npes == 1) then
       if(kimg_t == 1) then
          if(np_fs_x > nlmta .or. neg > np_e) bpr_t = 0.d0
          do iy = 1, neg
!-F             ifrom = neordr(iy,ik)
             do ix = 1, nlmta
!-F                bpr_t(ix,iy) = bpr_l(ifrom,ix,ik)
                bpr_t(ix,iy) = bpr_l(iy,ix,ik)
             end do
          end do
       else if(kimg_t == 2) then
          if(np_fs_x > nlmta .or. neg > np_e)then
             bpr_t = 0.d0; bpi_t = 0.d0
          end if


          do iy = 1, neg
!-F             ifrom = neordr(iy,ik)
             do ix = 1, nlmta
!-F                bpr_t(ix,iy) = bpr_l(ifrom,ix,ik)
!-F                bpi_t(ix,iy) = bpi_l(ifrom,ix,ik)
                bpr_t(ix,iy) = bpr_l(iy,ix,ik)
                bpi_t(ix,iy) = bpi_l(iy,ix,ik)
             end do
          end do
       end if

#ifdef MGS_DGEMM_DEBUG
       goto 9999
#else
       return
#endif
    end if
                                                  __TIMER_DO_STOP(573)

    if(sw_timing_2ndlevel == ON) call tstatc0_begin('m_ES_F_transpose_r ',id_sname)

!-F add set work array for PARA3D
    bpr_t = 0.d0
    if(kimg_t == 2) bpi_t = 0.d0
                                                  __TIMER_DO_START(574)
    if(kimg_t == 1) then
       do iy = 1, np_e
          do ix = 1, np_fs
             bpr_t(ix,iy) = bpr_l(iy,ix,ik)
          end do
       end do
    else if(kimg_t == 2) then
       do iy = 1, np_e
          do ix = 1, np_fs
             bpr_t(ix,iy) = bpr_l(iy,ix,ik)
             bpi_t(ix,iy) = bpi_l(iy,ix,ik)
          end do
       end do
    end if
                                                  __TIMER_DO_STOP(574)
                                                  __TIMER_SUB_STOP(511)
  end subroutine m_ES_F_transpose_r_3D

  subroutine m_ES_F_transpose_back_r_3D(k1,k2,ik,bpr_l,bpr_t,bpi_l,bpi_t)

    integer, intent(in)                                                :: k1,k2,ik
!-F    real(kind=DP), intent(out),dimension(np_e,nlmta,k1:k2)             :: bpr_l
!-F    real(kind=DP), intent(in) ,dimension(np_fs_x,neg)                  :: bpr_t
!-F    real(kind=DP), intent(out),optional,dimension(np_e,nlmta,k1:k2)    :: bpi_l
!-F    real(kind=DP), intent(in) ,optional,dimension(np_fs_x,neg)         :: bpi_t
    real(kind=DP), intent(out), dimension(np_e,np_fs,k1:k2)             :: bpr_l
    real(kind=DP), intent(in),dimension(np_fs_x,np_e)                  :: bpr_t
    real(kind=DP), intent(out), optional,dimension(np_e,np_fs,k1:k2)    :: bpi_l
    real(kind=DP), intent(in),optional,dimension(np_fs_x,np_e)         :: bpi_t

    real(kind=DP), allocatable, dimension(:,:,:,:) :: tmp_s,tmp_r
    integer, allocatable, dimension(:) :: req_s,req_r

    integer :: datasize, nb_proc, j, ix,iy, kimg_t,ito,ifrom
    integer :: pe_s,pe_r
    integer :: id_sname = -1
                                                  __TIMER_SUB_START(512)

    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = 2
    end if
                                                  __TIMER_DO_START(575)
    if(npes == 1) then
       if(kimg_t == 1) then
          do iy = 1, neg
!-F             ito = neordr(iy,ik)
             do ix = 1, nlmta
!-F                bpr_l(ito,ix,ik) = bpr_t(ix,iy)
                bpr_l(iy,ix,ik) = bpr_t(ix,iy)
             end do
          end do
       else
          do iy = 1, neg
!-F             ito = neordr(iy,ik)
             do ix = 1, nlmta
!-F                bpr_l(ito,ix,ik) = bpr_t(ix,iy)
!-F                bpi_l(ito,ix,ik) = bpi_t(ix,iy)
                bpr_l(iy,ix,ik) = bpr_t(ix,iy)
                bpi_l(iy,ix,ik) = bpi_t(ix,iy)
             end do
          end do
       end if
       return
    end if
                                                  __TIMER_DO_STOP(575)

    if(sw_timing_2ndlevel == ON) call tstatc0_begin('m_ES_F_transpose_back_r_3D ',id_sname)

!-F add return work array for PARA3D
                                                  __TIMER_DO_START(576)
    if(kimg_t == 1) then
       do iy = 1, np_e
          do ix = 1, np_fs
             bpr_l(iy,ix,ik) = bpr_t(ix,iy)
          end do
       end do
    else if(kimg_t == 2) then
       do iy = 1, np_e
          do ix = 1, np_fs
             bpr_l(iy,ix,ik) = bpr_t(ix,iy)
             bpi_l(iy,ix,ik) = bpi_t(ix,iy)
          end do
       end do
    end if
                                                  __TIMER_DO_STOP(576)

    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(512)
  end subroutine m_ES_F_transpose_back_r_3D

  subroutine m_ES_W_transpose_r_3D(k1,k2,ik,psi_l,psi_t)

    integer, intent(in)                                       :: k1,k2,ik
!-F    real(kind=DP), intent(in), dimension(kg1,np_e,k1:k2,kimg) :: psi_l  ! MPI
!-F    real(kind=DP), intent(out),dimension(np_g1k_x,neg,kimg)   :: psi_t  ! MPI
    real(kind=DP), intent(in), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l  ! MPI
    real(kind=DP), intent(out),dimension(np_g1k_x,np_e,kimg)   :: psi_t  ! MPI

    real(kind=DP), allocatable, dimension(:,:,:,:) :: tmp_s,tmp_r
    integer, allocatable, dimension(:) :: req_s,req_r

    integer :: ri, datasize, nb_proc, j, ix,iy, ifrom, ito
    integer :: pe_s,pe_r
    integer :: mp_g1k_x
    integer :: id_sname = -1
                                                  __TIMER_SUB_START(513)
                                                  __TIMER_DO_START(577)
    if(npes == 1) then
       if(np_g1k(ik) > kg1 .or. neg > np_e) psi_t = 0.d0
       if(k_symmetry(ik) == GAMMA) then ! assuming kimg == 2 when k_symmetry(ik) == GAMMA.
          do iy = 1, neg
!-F             ifrom = neordr(iy,ik)
             do ix = 2, iba(ik)
!-F                psi_t(ix,iy,1) = psi_l(ix,ifrom,ik,1)
!-F                psi_t(ix,iy,2) = psi_l(ix,ifrom,ik,2)
                psi_t(ix,iy,1) = psi_l(ix,iy,ik,1)
                psi_t(ix,iy,2) = psi_l(ix,iy,ik,2)
             end do
             psi_t(1,iy,1) = psi_l(1,iy,ik,1)
             psi_t(1,iy,2) = 0.d0
          end do
       else
          do ri = 1, kimg
             do iy = 1, neg
!-F                ifrom = neordr(iy,ik)
                do ix = 1, iba(ik)
!-F                   psi_t(ix,iy,ri) = psi_l(ix,ifrom,ik,ri)
                   psi_t(ix,iy,ri) = psi_l(ix,iy,ik,ri)
                end do
             end do
          end do
       end if
       return
    end if
                                                  __TIMER_DO_STOP(577)

    if(sw_timing_2ndlevel == ON) call tstatc0_begin('m_ES_W_transpose_r_3D ',id_sname)

!-F add set work array for PARA3D
!    psi_t = 0.d0
                                                  __TIMER_DO_START(578)
    do ri = 1, kimg
       do iy = 1, np_e
          do ix = 1, np_g1k(ik)
             psi_t(ix,iy,ri) = psi_l(ix,iy,ik,ri)
          end do
       end do
    end do
                                                  __TIMER_DO_STOP(578)
                                                  __TIMER_DO_START(579)
    if(k_symmetry(ik) == GAMMA .and. myrank_g == 0 .and. kimg == 2) then
       do iy = 1, np_e
          psi_t(1,iy,2) = 0.d0
       end do
    end if
                                                  __TIMER_DO_STOP(579)

    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(513)
  end subroutine m_ES_W_transpose_r_3D

  subroutine m_ES_W_transpose_back_r_3D(k1,k2,ik,psi_l,psi_t)

    integer, intent(in)                                       :: k1,k2,ik
!-F    real(kind=DP), intent(out),dimension(kg1,np_e,k1:k2,kimg) :: psi_l
!-F    real(kind=DP), intent(in) ,dimension(np_g1k_x,neg,kimg) :: psi_t
    real(kind=DP), intent(inout), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l  
    real(kind=DP), intent(in),dimension(np_g1k_x,np_e,kimg)   :: psi_t  

    real(kind=DP), allocatable, dimension(:,:,:,:) :: tmp_s,tmp_r
    integer, allocatable, dimension(:) :: req_s,req_r

    integer :: ri, datasize, nb_proc, j, ix,iy, ifrom,ito
    integer :: pe_s,pe_r
    integer :: mp_g1k_x
    integer :: id_sname = -1
                                                  __TIMER_SUB_START(514)
                                                  __TIMER_DO_START(580)
    if(npes == 1) then
       do ri = 1, kimg
          do iy = 1, neg
!-F             ito = neordr(iy,ik)
             do ix = 1, iba(ik)
!-F                psi_l(ix,ito,ik,ri) = psi_t(ix,iy,ri)
                psi_l(ix,iy,ik,ri) = psi_t(ix,iy,ri)
             end do
          end do
       end do
       return
    end if
                                                  __TIMER_DO_STOP(580)

    if(sw_timing_2ndlevel == ON) call tstatc0_begin('m_ES_W_transpose_back_r ',id_sname)

!-F add return work array for PARA3D
                                                  __TIMER_DO_START(581)
    do ri = 1, kimg
       do iy = 1, np_e
          do ix = 1, np_g1k(ik)
             psi_l(ix,iy,ik,ri) = psi_t(ix,iy,ri)
          end do
       end do
    end do
                                                  __TIMER_DO_STOP(581)

    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(514)
  end subroutine m_ES_W_transpose_back_r_3D

! -- GLOBAL --
  subroutine WSW_t_g(ik,j,mod_pot,fr,psi_t,LA,LB,LC,bpr_t,bpi_t)
    integer, intent(in)        :: ik,j,mod_pot
    real(kind=DP), intent(out) :: fr
    integer, intent(in)        :: LA,LB,LC
    real(kind=DP),intent(in)   :: psi_t(LA,LB,LC)
    real(kind=DP),intent(in),optional :: bpr_t(:,:),bpi_t(:,:)

    integer              :: ia,p,q, i, ig1
    real(kind=DP)        :: fr1
    integer :: id_sname = -1
    if(sw_timing_2ndlevel == ON) call tstatc0_begin('WSW_t_g ',id_sname)

                                                  __TIMER_SUB_START(504)
    fr = 0.d0
    if(mod_pot == VANDERBILT_TYPE) then
       if(k_symmetry(ik) == GAMMA) then
                                                  __TIMER_DO_START(548)
          do ia = 1, nac_p
             p = nlmta1_p(ia);     q = nlmta2_p(ia)
             fr = fr+fqwei_p(ia)*(bpr_t(p,j)*bpr_t(q,j))
          end do
                                                  __TIMER_DO_STOP(548)
       else
                                                  __TIMER_DO_START(549)
          do ia = 1, nac_p
             p = nlmta1_p(ia);     q = nlmta2_p(ia)
             fr = fr+fqwei_p(ia)*(bpr_t(p,j)*bpr_t(q,j)+bpi_t(p,j)*bpi_t(q,j))
          end do
                                                  __TIMER_DO_STOP(549)
       end if
    end if

    fr1 = 0.d0
    if(kimg == 1) then
                                                  __TIMER_DO_START(550)
       do i = 1, np_g1k(ik)                       ! MPI
          fr1 = fr1 + psi_t(i,j,1)*psi_t(i,j,1)
       end do
                                                  __TIMER_DO_STOP(550)
    else if(kimg == 2) then
       ig1 = 1; if(k_symmetry(ik) == GAMMA .and. myrank_g == 0) ig1 = 2
                                                  __TIMER_DO_START(551)
       do i = ig1, np_g1k(ik)
          fr1 = fr1 + psi_t(i,j,1)*psi_t(i,j,1) + psi_t(i,j,2)*psi_t(i,j,2)
       end do
                                                  __TIMER_DO_STOP(551)
       if(k_symmetry(ik) == GAMMA) fr1 = fr1*2.d0
       if(ig1 == 2) fr1 = fr1 + (psi_t(1,j,1)*psi_t(1,j,1))
    end if
    fr = fr+fr1
    if(nrank_g > 1) then

                                                  __TIMER_COMM_START_w_BARRIER(mpi_ke_world,536)
       call mpi_allreduce(MPI_IN_PLACE,fr,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(536)
    end if
    fr = 1.d0/dsqrt(fr)
    if(ipri >= 2 .and. (ik == 1 .or. ik == 2)) then
       write(nfout,'(" ((WSW_t_g)) ik = ",i8," fr = ",f21.15)') ik, fr
    end if
                                                  __TIMER_SUB_STOP(504)
  if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
  end subroutine WSW_t_g

! -- GLOBAL --
  subroutine normalize_bp_and_psi_t_g(ik,ibo,fr,mod_pot,psi_t,LA,LB,LC &
       & ,bpr_t,bpi_t)
    integer, intent(in)        :: ik,ibo
    real(kind=DP),intent(in)   :: fr
    integer, intent(in)        :: mod_pot,LA,LB,LC
    real(kind=DP),intent(inout),dimension(LA,LB,LC) :: psi_t
    real(kind=DP),intent(inout),optional :: bpr_t(:,:),bpi_t(:,:)

    integer                    :: ia,ri
    integer :: id_sname = -1

    if(sw_timing_2ndlevel == ON) call tstatc0_begin('WSW_t_g ',id_sname)
                                                  __TIMER_SUB_START(506)
                                                  __TIMER_DO_START(554)
    if(mod_pot == VANDERBILT_TYPE) then
       if(k_symmetry(ik) == GAMMA) then
          do ia = 1, np_fs
             bpr_t(ia,ibo) = fr*bpr_t(ia,ibo)
          end do
       else
          do ia = 1, np_fs
             bpr_t(ia,ibo) = fr*bpr_t(ia,ibo)
             bpi_t(ia,ibo) = fr*bpi_t(ia,ibo)
          end do
       end if
    end if
                                                  __TIMER_DO_STOP(554)
                                                  __TIMER_DO_START(555)
    do ri = 1, kimg
!-F         psi_t(1:np_g1k(ik),ibo,ri) = fr * psi_t(1:np_g1k(ik),ibo,ri)
       psi_t(1:np_g1k(ik),ibo,ri) = fr * psi_t(1:np_g1k(ik),ibo,ri)
    end do
                                                  __TIMER_DO_STOP(555)
    if(ipri >= 2 .and. (ik == 1 .or. ik == 2)) then
       write(nfout,'(" ((normalize_bp_and_psi_t_g)) ik = ",i8," ibo = ",i8," fr = ",f21.15)') ik,ibo,fr
       write(nfout,'(6d14.6)') (psi_t(ia,ibo,1),ia=1, 6)
       if(kimg == 2) write(nfout,'(3d20.10)') (psi_t(ia,ibo,kimg),ia=1, 6)
    end if
                                                  __TIMER_SUB_STOP(506)
    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
  end subroutine normalize_bp_and_psi_t_g

! -- GLOBAL --
  subroutine cp_bpr2bpi_g(kimg_t,i,bpr_t,bpi_t)
    integer, intent(in) :: kimg_t,i
    real(kind=DP),intent(in)           :: bpr_t(:,:)
    real(kind=DP),intent(in),optional  :: bpi_t(:,:)
    integer ::  nel
    integer :: id_sname = -1
    if(sw_timing_2ndlevel == ON) call tstatc0_begin('cp_bpr2bpi_g ',id_sname)
    nel = min(np_fs,np_g1k_x)
    if(kimg_t == 1) then
       bp_ir(1:nel) = bpr_t(1:nel,i)
    else
       bp_ir(1:nel) = bpr_t(1:nel,i)
       bp_ii(1:nel) = bpi_t(1:nel,i)
    end if
    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
  end subroutine cp_bpr2bpi_g

! -- GLOBAL --
  subroutine W1SW2_t_r_g(ik,i,NB_END,mod_pot,phi_t,LA,LB,LC &
!!$#ifndef MGS_DGEMM
       & ,phifr_t,phifi_t &
!!$#endif
       & )
    integer, intent(in)        :: ik,i, NB_END,mod_pot
    integer, intent(in)        :: LA,LB,LC
    real(kind=DP),intent(in)          :: phi_t(LA,LB,LC)
!!$#ifndef MGS_DGEMM
    real(kind=DP),intent(in),optional :: phifr_t(:,:),phifi_t(:,:)
!!$#endif

! Coded by T. Yamasaki in April 2006
! Revised according to the RIKEN phase tuning project 2009, 13 Sep 2009
! This subroutine is moved out from subroutine mgs_4_each_k_G() in a contained state.

    integer       :: j, ia, jto, p, q,  kimg_t
    real(kind=DP) :: ar, ai
    real(kind=DP), allocatable, dimension(:,:)  :: p1Sp2_t2, p1Sp2_t1  ! MPI
    character*4 F_RSVTASK
    integer       :: nt, mpant, mmdnt, ipar, ist, ied, mm

    integer :: id_sname = -1, id_sname2 = -1
    integer :: myrank_g_common
#ifndef SX
    integer :: n_unroll, jmax, ia_start
    integer :: ibsize,ibl1,ibl2
    integer :: ncache
                                                  __TIMER_SUB_START(507)
    ncache = (m_CtrlP_cachesize()*1024)*3/4
#endif

    if(sw_timing_2ndlevel == ON) call tstatc0_begin('W1SW2_t_r_g ',id_sname)

    myrank_g_common = myrank_g


    if(nrank_e*nrank_g > 1) then
       if((k_symmetry(ik) == GAMMA .and. kimg==2) .or. kimg == 1) then
          kimg_t = 1
       else
          kimg_t = 2
       end if
       p = NB_END-i
       allocate(p1Sp2_t2(p,kimg_t)); p1Sp2_t2 = 0.d0                  ! MPI
       allocate(p1Sp2_t1(p,kimg_t)); p1Sp2_t1 = 0.d0                  ! MPI
    end if

    p1Sp2 = 0.d0

    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg == 1) then
#ifndef SX
! NEC tune ------------------------------->
          if(ncache.eq.0) then
             ibsize=nac_p
!f
             if(ibsize == 0) ibsize = 1
          else
             ibsize=ncache/(8*(NB_END*2+3))
          endif
                                                  __TIMER_DO_START(556)
          do ibl1=1,nac_p,ibsize
             ibl2=ibl1+ibsize-1
             if(ibl2.gt.nac_p) ibl2=nac_p
! NEC tune <-------------------------------
#endif
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(ia,ar,ai,p,q)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
#ifndef ES
!CDIR OUTERUNROLL=4
#endif
#endif
!OCL NOFLTLD
             do j = i+1, NB_END
#ifdef SX
! NEC tune ------------------------------->
                ar = 0.d0
                do ia = 1, nac_p
#ifdef MGS_DGEMM
                   ar = ar + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j)+bpi_tw1(ia,i)*bpi_tw2(ia,j))
#else
                   p = nlmta1_p(ia);            q = nlmta2_p(ia)
                   ar = ar + fqwei_p(ia)*(bp_ir(p)*phifr_t(q,j)+bp_ii(p)*phifi_t(q,j))
#endif
                end do
                p1Sp2(j,1) = ar
#else
! NEC tune <-------------------------------
                ar = p1Sp2(j,1)
                do ia = ibl1, ibl2
#ifdef MGS_DGEMM
                   ar = ar + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j)+bpi_tw1(ia,i)*bpi_tw2(ia,j))
#else
                   p = nlmta1_p(ia);            q = nlmta2_p(ia)
                   ar = ar + fqwei_p(ia)*(bp_ir(p)*phifr_t(q,j)+bp_ii(p)*phifi_t(q,j))
#endif
                end do
                p1Sp2(j,1) = ar
#endif
            end do
#ifndef SX
! NEC tune
         end do
                                                  __TIMER_DO_STOP(556)
#endif
      else if(kimg == 2) then
         if(k_symmetry(ik) == GAMMA) then
!!!$#ifdef NEC_TUNE_SMP
!!!$!CDIR PARALLEL DO private(ia,ar,p,q)
!!!$#endif
!!!$#ifdef VPP
!!!$*vocl loop, unroll(4)
!!!$#endif
!!!$!CDIR OUTERUNROLL=4
!!!$               do j = i+1, NB_END                                                ! MPI
!!!$                  ar = 0.d0
!!!$                  do ia = 1, nac_p
!!!$                     p = nlmta1_p(ia);         q = nlmta2_p(ia)
!!!$                     ar = ar + fqwei_p(ia)*(bpr_t(p,i)*bpr_t(q,j))
!!!$                  end do
!!!$                  p1Sp2(j,1) = ar
!!!$               end do
#ifdef NEC_TUNE_SMP
             call getenv('F_RSVTASK',F_RSVTASK)
             read (F_RSVTASK,'(i4)') nt
#else
             nt = 1
#endif
             mpant = (NB_END-i)/nt
             mmdnt = mod(NB_END-i,nt)

#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(mm,ist,ied,ia,j,p,q)
#endif
! NEC tune
!!#ifdef NEC_TUNE_SMP
#ifdef SX
             do ipar = 1, min(nt,NB_END-i)                                            ! SX
                IF (IPAR.LE.MMDNT) THEN                                               ! SX
                   MM = MPANT+1                                                       ! SX
                ELSE                                                                  ! SX
                   MM = MPANT                                                         ! SX
                ENDIF                                                                 ! SX
                IST = (IPAR-1)*MPANT + MIN(MMDNT+1,IPAR) + i                          ! SX
                IED = IST + mm - 1                                                    ! SX
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                do ia = 1, nac_p                                                      ! SX
                   do j = IST, IED
		     ! SX
#ifdef MGS_DGEMM
                      p1Sp2(j,1) = p1Sp2(j,1) + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j))   ! SX
#else
                      p = nlmta1_p(ia);         q = nlmta2_p(ia)                      ! SX
                      p1Sp2(j,1) = p1Sp2(j,1) + fqwei_p(ia)*(bp_ir(p)*phifr_t(q,j))   ! SX
#endif
                   end do                                                             ! SX
                end do                                                                ! SX
             end do                                                                   ! SX
#else
! NEC tune ------------------------------->
             if(ncache.eq.0) then
                ibsize=nac_p
!f
                if(ibsize == 0) ibsize = 1
             else
                ibsize=ncache/(8*(NB_END*1+2))
             endif
                                                  __TIMER_DO_START(557)
!OCL NOFLTLD
             do ibl1=1,nac_p,ibsize
                ibl2=ibl1+ibsize-1
                if(ibl2.gt.nac_p) ibl2=nac_p
                do j = i+1, NB_END
                   if(ibl1.eq.1)then
                      ar=0.0d0
                   else
                      ar=p1Sp2(j,1)
                   endif
                   do ia = ibl1, ibl2
#ifdef MGS_DGEMM
                      ar = ar + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j))
#else
                      p = nlmta1_p(ia);         q = nlmta2_p(ia)
                      ar = ar + fqwei_p(ia)*(bp_ir(p)*phifr_t(q,j))
#endif
                   end do
                   p1Sp2(j,1)=ar
                end do
             end do
                                                  __TIMER_DO_STOP(557)

! NEC tune <-------------------------------
#endif
          else      ! kimg==2 .and. k_symmetry(ik) /= GAMMA 
#ifndef SX
! NEC tune ------------------------------->
             if(ncache.eq.0) then
                ibsize=nac_p
!f
                if(ibsize == 0) ibsize = 1
             else
                ibsize=ncache/(8*(NB_END*4+3))
             endif
#ifdef DEBUG_MGS
             if(ipri >= 2) then
                write(nfout,'(" ibsize = ",i8," <<W1SW2_t_r>>")') ibsize
             end if
#endif
                                                  __TIMER_DO_START(558)
             do ibl1=1,nac_p,ibsize
                ibl2=ibl1+ibsize-1
                if(ibl2.gt.nac_p) ibl2=nac_p
! NEC tune <-------------------------------
#endif

#ifdef NEC_TUNE_SMP
#ifdef MGS_DGEMM
!CDIR PARALLEL DO private(ia,ar,ai)
#else
!CDIR PARALLEL DO private(ia,ar,ai,p,q)
#endif
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
#ifndef ES
!CDIR OUTERUNROLL=4
#endif
#endif
                do j = i+1, NB_END

#ifdef SX
                   ar = 0.d0; ai = 0.d0
                   do ia = 1, nac_p
#else
                   if(ibl1.eq.1) then
                      ar = 0.d0; ai = 0.d0
                   else
                      ar = p1Sp2(j,1)
                      ai = p1Sp2(j,2)

                   end if
                   do ia = ibl1, ibl2
#endif
#ifdef MGS_DGEMM
                      ar = ar + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j)+bpi_tw1(ia,i)*bpi_tw2(ia,j))
                      ai = ai + fqwei_p(ia)*(bpr_tw1(ia,i)*bpi_tw2(ia,j)-bpi_tw1(ia,i)*bpr_tw2(ia,j))
#else
                      p = nlmta1_p(ia);         q = nlmta2_p(ia)
                      ar = ar + fqwei_p(ia)*(bp_ir(p)*phifr_t(q,j)+bp_ii(p)*phifi_t(q,j))
                      ai = ai + fqwei_p(ia)*(bp_ir(p)*phifi_t(q,j)-bp_ii(p)*phifr_t(q,j))
#endif
                   end do
                   p1Sp2(j,1) = ar;  p1Sp2(j,2) = ai
                end do
#ifndef SX
! NEC tune
             end do
#endif
                                                  __TIMER_DO_STOP(558)
          end if
       end if
    end if
! --- <Psi_i|Psi_j> ---
    if(kimg == 1) then
#ifndef SX
! NEC tune ------------------------------------------------------------->
       if(ncache.eq.0) then
          ibsize=np_g1k(ik)
       else
          ibsize=ncache/(8*(NB_END*1+1))
       endif
                                                  __TIMER_DO_START(559)
       do ibl1=1,np_g1k(ik),ibsize
          ibl2=ibl1+ibsize-1
          if(ibl2.gt.np_g1k(ik)) ibl2=np_g1k(ik)
! NEC tune <-------------------------------------------------------------
#endif
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(ia,ar,ai,p,q)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
#ifndef ES
!CDIR OUTERUNROLL=4
#endif
#endif
          do j = i+1, NB_END
#ifdef SX
! NEC tune ------------------------------------------------------------->
             do ia = 1, np_g1k(ik)                                           ! MPI
                p1Sp2(j,1) = p1Sp2(j,1) + psi_ir(ia)*phi_t(ia,j,1 ) ! MPI
#else
             ai = p1Sp2(j,1)
             do ia = ibl1, ibl2
                ai = ai + psi_ir(ia)*phi_t(ia,j,1 ) ! MPI
! NEC tune <-------------------------------------------------------------
#endif
             end do

#ifndef SX
! NEC tune
             p1Sp2(j,1)=ai
#endif

          end do

#ifndef SX
! NEC tune
       end do
#endif
                                                  __TIMER_DO_STOP(559)

    else if(kimg == 2) then
       if(k_symmetry(ik) == GAMMA) then
!!!$            if(mype /= 0) then
!!!$#ifdef NEC_TUNE_SMP
!!!$!CDIR PARALLEL DO private(ia,ar,ai,p,q)
!!!$#endif
!!!$#ifdef VPP
!!!$*vocl loop, unroll(4)
!!!$#endif
!!!$!CDIR OUTERUNROLL=4
!!!$               do j = i+1, NB_END
!!!$                  do ia = 1, np_g1k(ik)
!!!$                     ar  = psi_t(ia,i,1)
!!!$                     ai  = psi_t(ia,i,2)
!!!$                     p1Sp2(j,1) = p1Sp2(j,1)+(ar*psi_t(ia,j,1)+ai*psi_t(ia,j,2))*2.d0 ! MPI
!!!$                  end do
!!!$               end do
#ifdef NEC_TUNE_SMP
          call getenv('F_RSVTASK',F_RSVTASK)
          read (F_RSVTASK,'(i4)') nt
#else
          nt = 1
#endif

! NEC tune
!!#ifdef NEC_TUNE_SMP
#ifdef SX
          if( (NB_END-i)/nt .lt. 256 ) then

             if(myrank_g_common /= 0) then

                do j = i+1, NB_END
                   do ia = 1, np_g1k(ik)
                      ar  = psi_ir(ia)
                      ai  = psi_ii(ia)
                      p1Sp2(j,1) = p1Sp2(j,1)+(ar*phi_t(ia,j,1)+ai*phi_t(ia,j,2))*2.d0
                   end do
                end do
             else if(myrank_g_common == 0) then

                do j = i+1, NB_END
                   do ia = 2, np_g1k(ik)
                      ar  = psi_ir(ia)
                      ai  = psi_ii(ia)
                      p1Sp2(j,1) = p1Sp2(j,1)+(ar*phi_t(ia,j,1)+ai*phi_t(ia,j,2))*2.d0
                   end do
                   p1Sp2(j,1) = p1Sp2(j,1) + psi_ir(1)*phi_t(1,j,1)
                end do
             end if

          else

             mpant = (NB_END-i)/nt
             mmdnt = mod(NB_END-i,nt)
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(mm,ist,ied,ia,j,ar,ai)
#endif
                                                  __TIMER_DO_START(560)
             do ipar = 1, min(nt,NB_END-i)
                IF (IPAR.LE.MMDNT) THEN
                   MM = MPANT+1
                ELSE
                   MM = MPANT
                ENDIF
                IST = (IPAR-1)*MPANT + MIN(MMDNT+1,IPAR) + i
                IED = IST + mm - 1
                if(myrank_g_common /= 0) then
                     !     write(*,*)'ipar, IST, IED=', ipar, IST, IED
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                   do ia = 1, np_g1k(ik)
                      do j = IST, IED
                         ar  = psi_ir(ia)
                         ai  = psi_ii(ia)
                         p1Sp2(j,1) = p1Sp2(j,1)+(ar*phi_t(ia,j,1)+ai*phi_t(ia,j,2))*2.d0
                      end do
                   end do
                else if(myrank_g_common == 0) then
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                   do ia = 2, np_g1k(ik)
                      do j = IST, IED
                         ar  = psi_ir(ia)
                         ai  = psi_ii(ia)
                         p1Sp2(j,1) = p1Sp2(j,1)+(ar*phi_t(ia,j,1)+ai*phi_t(ia,j,2))*2.d0
                      end do
                   enddo
                   do j = IST, IED
                      p1Sp2(j,1) = p1Sp2(j,1) + psi_ir(1)*phi_t(1,j,1)
                   end do
                end if
             end do
                                                  __TIMER_DO_STOP(560)
          end if
! NEC tune ------------------------------------>
#else
!!$            if(ncache.eq.0) then
!!$               ibsize=np_g1k(ik)
!!$            else
!!$               ibsize=ncache/(8*(NB_END*2+2))
!!$            endif

!!$            allocate(psi_ir(np_g1k(ik)))
!!$            allocate(psi_ii(np_g1k(ik)))
!!$            do ia = 1, np_g1k(ik)
!!$               psi_ir(ia) = psi_t(ia,i,1)
!!$               psi_ii(ia) = psi_t(ia,i,2)
!!$            end do
!!$
!!$            n_unroll = 4
!!$            jto = (NB_END-i)/n_unroll
!!$            jmax = i + n_unroll*jto

          if(sw_timing_2ndlevel == ON) call tstatc0_begin('W1SW2_t_r(core) ',id_sname2)
          if(myrank_g_common /= 0) then
             ia_start = 1
          else if(myrank_g == 0) then
             ia_start = 2
          end if

                                                  __TIMER_DO_START(561)
          do j = i+1, NB_END
             ar=p1Sp2(j,1)
             do ia = ia_start, np_g1k(ik)
                ar = ar+(psi_ir(ia)*phi_t(ia,j,1)+psi_ii(ia)*phi_t(ia,j,2))*2.d0
             end do
             if(myrank_g_common == 0) then
                ar = ar + psi_ir(1)*phi_t(1,j,1)
             endif
             p1Sp2(j,1)=ar
          end do
                                                  __TIMER_DO_STOP(561)

!!$            do j = i+1, jmax, n_unroll
!!$               do ia = ia_start, np_g1k(ik)
!!$                  ar = psi_ir(ia)*2.d0; ai = psi_ii(ia)*2.d0
!!$                  p1Sp2(j  ,1) = p1Sp2(j  ,1) + (ar*psi_t(ia,j  ,1)+ai*psi_t(ia,j  ,2))
!!$                  p1Sp2(j+1,1) = p1Sp2(j+1,1) + (ar*psi_t(ia,j+1,1)+ai*psi_t(ia,j+1,2))
!!$                  p1Sp2(j+2,1) = p1Sp2(j+2,1) + (ar*psi_t(ia,j+2,1)+ai*psi_t(ia,j+2,2))
!!$                  p1Sp2(j+3,1) = p1Sp2(j+3,1) + (ar*psi_t(ia,j+3,1)+ai*psi_t(ia,j+3,2))
!!$               end do
!!$            end do
!!$            do j = jmax+1, neg
!!$               do ia = ia_start, np_g1k(ik)
!!$                  ar = psi_ir(ia); ai = psi_ii(ia)
!!$                  p1Sp2(j  ,1) = p1Sp2(j  ,1) + (ar*psi_t(ia,j,  1)+ai*psi_t(ia,j,  2))*2.d0
!!$               end do
!!$            end do
!!$            if(mype == 0) then
!!$               do j = i+1, neg
!!$                  p1Sp2(j,1) = p1Sp2(j,1) + psi_ir(1)*psi_t(1,j, 1)
!!$               end do
!!$            end if

          if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname2)
#endif
! NEC tune <------------------------------------
       else    ! kimg==2 .and. k_symmetry(ik) /= GAMMA
#ifdef SX
! NEC tune ------------------------------------>
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(ia,ar,ai,p,q)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
#ifndef ES
!CDIR OUTERUNROLL=4
#endif
#endif
                                                  __TIMER_DO_START(562)
          do j = i+1, NB_END
             do ia = 1, np_g1k(ik)                                          ! MPI
                ar  = psi_ir(ia)
                ai  = psi_ii(ia)
                p1Sp2(j,1) = p1Sp2(j,1)+ar*phi_t(ia,j,1)+ai*phi_t(ia,j,2) ! MPI
                p1Sp2(j,2) = p1Sp2(j,2)+ar*phi_t(ia,j,2)-ai*phi_t(ia,j,1) ! MPI
             end do
          end do
                                                  __TIMER_DO_STOP(562)
#else
!!$            if(ncache.eq.0) then
          ibsize=np_g1k(ik)
!!$            else
!!$!!$               ibsize=ncache/(8*(neg*2+2))
!!$               ibsize=ncache/(8*(NB_END*2+2))
!!$            endif
!!$            allocate(psi_ir(np_g1k(ik)))
!!$            allocate(psi_ii(np_g1k(ik)))
!!$            do ia = 1, np_g1k(ik)
!!$               psi_ir(ia) = psi_iri(ia,1)
!!$               psi_ii(ia) = psi_iri(ia,2)
!!$            end do

                                                  __TIMER_DO_START(563)
          do ibl1=1,np_g1k(ik),ibsize
             ibl2=ibl1+ibsize-1
             if(ibl2.gt.np_g1k(ik)) ibl2=np_g1k(ik)
             if(sw_timing_2ndlevel == ON) call tstatc0_begin('W1SW2_t_r(core) ',id_sname2)
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(ia,ar,ai,p,q)
#endif
#ifdef NEC_TUNE2
#ifndef ES
!CDIR OUTERUNROLL=4
#define _DIRECTIVE_UNROLLING_
#endif
#endif
#ifdef _DIRECTIVE_UNROLLING_
             do j = i+1, NB_END
                ar=p1Sp2(j,1)
                ai=p1Sp2(j,2)
                do ia = ibl1, ibl2
                   ar = ar+psi_ir(ia)*phi_t(ia,j,1)+psi_ii(ia)*phi_t(ia,j,2)
                   ai = ai+psi_ir(ia)*phi_t(ia,j,2)-psi_ii(ia)*phi_t(ia,j,1)
                end do
                p1Sp2(j,1)=ar
                p1Sp2(j,2)=ai
             end do
#else
             n_unroll = 4
             jto = (NB_END-i)/n_unroll
             jmax = i + n_unroll*jto
             do j = i+1, jmax, n_unroll
                do ia = ibl1, ibl2
                   ar = psi_ir(ia); ai = psi_ii(ia)
                   p1Sp2(j,1)   = p1Sp2(j,1)  +ar*phi_t(ia,j,1)  +ai*phi_t(ia,j,2)
                   p1Sp2(j,2)   = p1Sp2(j,2)  +ar*phi_t(ia,j,2)  -ai*phi_t(ia,j,1)
                   p1Sp2(j+1,1) = p1Sp2(j+1,1)+ar*phi_t(ia,j+1,1)+ai*phi_t(ia,j+1,2)
                   p1Sp2(j+1,2) = p1Sp2(j+1,2)+ar*phi_t(ia,j+1,2)-ai*phi_t(ia,j+1,1)
                   p1Sp2(j+2,1) = p1Sp2(j+2,1)+ar*phi_t(ia,j+2,1)+ai*phi_t(ia,j+2,2)
                   p1Sp2(j+2,2) = p1Sp2(j+2,2)+ar*phi_t(ia,j+2,2)-ai*phi_t(ia,j+2,1)
                   p1Sp2(j+3,1) = p1Sp2(j+3,1)+ar*phi_t(ia,j+3,1)+ai*phi_t(ia,j+3,2)
                   p1Sp2(j+3,2) = p1Sp2(j+3,2)+ar*phi_t(ia,j+3,2)-ai*phi_t(ia,j+3,1)
                end do
             end do
             do j = jmax+1, NB_END
                do ia = 1, ibl2-ibl1+1
                   ar = psi_ir(ia); ai=psi_ii(ia)
                   p1Sp2(j,1)   = p1Sp2(j,1)   + ar*phi_t(ia,j,1)+ai*phi_t(ia,j,2)
                   p1Sp2(j,2)   = p1Sp2(j,2)   + ar*phi_t(ia,j,2)-ai*phi_t(ia,j,1) 
                end do
             end do
#endif
             if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname2)
          end do
                                                  __TIMER_DO_STOP(563)
!!$          deallocate(psi_ii, psi_ir)
! NEC tune <------------------------------------
#endif
       end if
    end if

    if(nrank_g > 1 .and. NB_END > i ) then
                                                  __TIMER_COMM_START(537)
       do q = 1, kimg_t
          do j = 1, NB_END-i
             p = j+i
             p1Sp2_t1(j,q) = p1Sp2(p,q)
          end do
       end do
                                                  __TIMER_COMM_STOP(537)
                                                  __TIMER_COMM_START_w_BARRIER(mpi_ke_world,538)
!!$         p = (neg-i)*kimg_t
!!$         call mpi_allreduce(p1Sp2_t1, p1Sp2_t2,(neg-i)*kimg_t,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
       call mpi_allreduce(p1Sp2_t1, p1Sp2_t2,(NB_END-i)*kimg_t,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(538)
                                                  __TIMER_COMM_START(539)
       do q = 1, kimg_t
          do j = 1, NB_END-i
             p = j+i
             p1Sp2(p,q) = p1Sp2_t2(j,q)
          end do
       end do
!!$         p1Sp2(:,1:kimg_t) = p1Sp2_t2(:,1:kimg_t)
                                                  __TIMER_COMM_STOP(539)
    end if

    if(ipri >= 2 .and. ik == 1) then
       write(nfout,'(" <<W1SW2_t>> ik = ",i9,"  i = ",i3)') ik,i
       write(nfout,'(" (real) ",6d11.3, 99(/8x,6d11.3))') (p1Sp2(j,1),j=i+1,NB_END)
! === DEBUG by tkato 2013/11/05 ================================================
       if(nrank_e*nrank_g > 1) then
! ==============================================================================
       if(kimg_t == 2) &
            & write(nfout,'(" (imag) ",6d11.3, 99(/8x,6d11.3))') (p1Sp2(j,kimg_t),j=i+1,NB_END)
! === DEBUG by tkato 2013/11/05 ================================================
       end if
! ==============================================================================
    end if
    if(nrank_e*nrank_g > 1) deallocate(p1Sp2_t1,p1Sp2_t2)
    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(507)
  end subroutine W1SW2_t_r_g

! -- GLOBAL --
!-$ tune FUJITSU for block ----->>
!     13th Sep 2009
#ifdef MGS_DGEMM
  subroutine W1SW2_t_r_block_g(ik,i,i2,p1Sp2_NB,NB_END,NB_END2,kimg_t_wk &
       &  ,   mod_pot,psi_t,psi_t_dia,LA,LB,LC,bpr_tw1_dia,bpi_tw1_dia)
    integer, intent(in)        :: ik,i, i2, NB_END, NB_END2, kimg_t_wk
    integer, intent(in)        :: mod_pot,LA,LB,LC
    real(kind=DP), intent(out), dimension(NB,NB,kimg_t_wk) :: p1Sp2_NB
    real(kind=DP), intent(in), dimension(LA,LB,LC)      :: psi_t
    real(kind=DP), intent(in), dimension(LA,NB,LC)      :: psi_t_dia
    real(kind=DP), intent(in), dimension(nac_p,*),optional :: bpr_tw1_dia,bpi_tw1_dia

    real(kind=DP), allocatable, dimension(:,:) :: bpr_tw1_BLAS, bpi_tw1_BLAS ! work

    integer       :: iblk, jblk, i_NB, j_NB
    integer       :: ii, ia,  M, N, LDA, LDB, p

    integer :: id_sname = -1, id_sname2 = -1
                                                  __TIMER_SUB_START(509)
    if(sw_timing_2ndlevel == ON) call tstatc0_begin('W1SW2_t_r_block_g ',id_sname)

    p1Sp2_NB = 0.0d0
    M = NB_END2-i2+1; N = NB_END-i+1
    if(mod_pot == VANDERBILT_TYPE .and. nac_p > 0) then
       allocate(bpr_tw1_BLAS(nac_p, NB))
       bpr_tw1_BLAS = 0.0
                                                  __TIMER_DO_START(570)
!OCL NOFLTLD
       do iblk = i, NB_END
          ii = iblk - i + 1
          do ia = 1, nac_p
             bpr_tw1_BLAS(ia,ii) = fqwei_p(ia)*bpr_tw1_dia(ia,ii)
          end do
       end do
                                                  __TIMER_DO_STOP(570)
       if(k_symmetry(ik) /= GAMMA) then
          allocate(bpi_tw1_BLAS(nac_p,NB))
          bpi_tw1_BLAS = 0.d0
                                                  __TIMER_DO_START(571)
          do iblk = i, NB_END
             ii = iblk - i + 1
             do ia = 1, nac_p
                bpi_tw1_BLAS(ia,ii) = fqwei_p(ia)*bpi_tw1_dia(ia,ii)
             end do
          end do
                                                  __TIMER_DO_STOP(571)
       end if

       if(kimg==1) then
                                                  __TIMER_DGEMM_START(515)
          call DGEMM__('T','N',M,N,nac_p,1.0d0,bpr_tw2(1,i2),nac_p,bpr_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,1),NB)
          call DGEMM__('T','N',M,N,nac_p,1.0d0,bpi_tw2(1,i2),nac_p,bpi_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,1),NB)
                                                  __TIMER_DGEMM_STOP(515)
!!$                     ar = ar + fqwei_p(ia)*(bpr_t(p,i)*bpr_t(q,j)+bpi_t(p,i)*bpi_t(q,j))
       else if(kimg==2 .and. k_symmetry(ik) == GAMMA) then
                                                  __TIMER_DGEMM_START(516)
          call DGEMM__('T','N',M,N,nac_p,1.0d0,bpr_tw2(1,i2),nac_p,bpr_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,1),NB)
!!$                     ar = ar + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j))
                                                  __TIMER_DGEMM_STOP(516)
       else if(kimg==2 .and. k_symmetry(ik) /= GAMMA) then
                                                  __TIMER_DGEMM_START(517)
          call DGEMM__('T','N',M,N,nac_p, 1.0d0,bpr_tw2(1,i2),nac_p,bpr_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,1),NB)
          call DGEMM__('T','N',M,N,nac_p, 1.0d0,bpi_tw2(1,i2),nac_p,bpr_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,2),NB)
          call DGEMM__('T','N',M,N,nac_p, 1.0d0,bpi_tw2(1,i2),nac_p,bpi_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,1),NB)
          call DGEMM__('T','N',M,N,nac_p,-1.0d0,bpr_tw2(1,i2),nac_p,bpi_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,2),NB)
!!$                     ar = ar + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j)+bpi_tw1(ia,i)*bpi_tw2(ia,j))
!!$                     ai = ai + fqwei_p(ia)*(bpr_tw1(ia,i)*bpi_tw2(ia,j)-bpi_tw1(ia,i)*bpr_tw2(ia,j))
                                                  __TIMER_DGEMM_STOP(517)
       end if

       if(k_symmetry(ik) /= GAMMA) deallocate(bpi_tw1_BLAS)
       deallocate(bpr_tw1_BLAS)
    end if
! --------------------------------------
    if(sw_timing_2ndlevel == ON) call tstatc0_begin('W1SW2_t_r_block_g(core) ',id_sname2)
    LDA = np_g1k_x; LDB = np_g1k_x
    if(kimg == 1) then
                                                  __TIMER_DGEMM_START(518)
       call DGEMM__('T','N',M,N,np_g1k(ik),1.0d0,psi_t(1,i2,1),LDA,psi_t_dia(1,1,1), LDB,1.0d0,p1Sp2_NB(1,1,1),NB)
                                                  __TIMER_DGEMM_STOP(518)
    else if(kimg == 2 .and. k_symmetry(ik) == GAMMA ) then
                                                  __TIMER_DGEMM_START(519)
       call DGEMM__('T','N',M,N,np_g1k(ik),2.0d0,psi_t(1,i2,1),LDA,psi_t_dia(1,1,1),LDB,1.0d0,p1Sp2_NB(1,1,1),NB)
       call DGEMM__('T','N',M,N,np_g1k(ik),2.0d0,psi_t(1,i2,2),LDA,psi_t_dia(1,1,2),LDB,1.0d0,p1Sp2_NB(1,1,1),NB)
                                                  __TIMER_DGEMM_STOP(519)
       if (myrank_g == 0 ) then
                                                  __TIMER_DO_START(572)
          do iblk = i, NB_END                !for BLAS3
             i_NB = iblk - i + 1
             do jblk = i2, NB_END2
                j_NB = jblk - i2 + 1
!f                  p1Sp2_NB(j_NB,i_NB,1) = p1Sp2_NB(j_NB,i_NB,1) &
!f                       & - (psi_t(1,iblk,1)*psi_t(1,jblk,1)+psi_t(1,iblk,2)*psi_t(1,jblk,2)*2.d0)
                p1Sp2_NB(j_NB,i_NB,1) = p1Sp2_NB(j_NB,i_NB,1) &
                     & - (psi_t_dia(1,i_NB,1)*psi_t(1,jblk,1)+psi_t_dia(1,i_NB,2)*psi_t(1,jblk,2)*2.d0)
             end do
          end do
                                                  __TIMER_DO_STOP(572)
       end if
    else  ! kimg==2 .and. k_symmetry(ik) /= GAMMA
                                                  __TIMER_DGEMM_START(520)
       call DGEMM__('T','N',M,N,np_g1k(ik), 1.0d0,psi_t(1,i2,1),LDA,psi_t_dia(1,1,1),LDB,1.0d0,p1Sp2_NB(1,1,1),NB)
       call DGEMM__('T','N',M,N,np_g1k(ik), 1.0d0,psi_t(1,i2,2),LDA,psi_t_dia(1,1,2),LDB,1.0d0,p1Sp2_NB(1,1,1),NB)
       call DGEMM__('T','N',M,N,np_g1k(ik), 1.0d0,psi_t(1,i2,2),LDA,psi_t_dia(1,1,1),LDB,1.0d0,p1Sp2_NB(1,1,2),NB)
       call DGEMM__('T','N',M,N,np_g1k(ik),-1.0d0,psi_t(1,i2,1),LDA,psi_t_dia(1,1,2),LDB,1.0d0,p1Sp2_NB(1,1,2),NB)
                                                  __TIMER_DGEMM_STOP(570)
    end if
    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname2)

!-F    if(nrank_e > 1 ) then
!-F       if(ipri>=2) then
!-F          write(nfout,'(" NB_END, NB_END2, NB_END-i+1, NB_END2-i2+1, NB, kimg_t_wk = ",6i8)') &
!-F               & NB_END, NB_END2,  NB_END-i+1, NB_END2-i2+1, NB, kimg_t_wk
!-F       end if
!-F       call mpi_allreduce(MPI_IN_PLACE,p1Sp2_NB,NB*NB*kimg_t_wk,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
!-F    end if

    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(509)
  end subroutine W1SW2_t_r_block_g
#endif
!-$ tune FUJITSU for block <<-----

! -- GLOBAL --
#ifdef MGS_DGEMM
    subroutine modify_bp_and_psi_t_r_blk_g(ik,i,i2,p1Sp2_NB,NB_END,NB_END2,kimg_t_wk &
	&   , mod_pot,psi_t,psi_t_dia,LA,LB,LC,bpr_t,bpi_t,bpr_t_dia,bpi_t_dia)
      integer, intent(in) :: ik,i,i2,mod_pot,LA,LB,LC
      real(kind=DP), intent(in),  dimension(NB,NB,kimg_t_wk) :: p1Sp2_NB
      real(kind=DP), intent(inout), dimension(LA,LB,LC) :: psi_t
      real(kind=DP), intent(in), dimension(LA,NB,LC)    :: psi_t_dia
      real(kind=DP), intent(inout), optional :: bpr_t(:,:),bpi_t(:,:)
      real(kind=DP), intent(in), optional :: bpr_t_dia(:,:),bpi_t_dia(:,:)

      integer, intent(in) :: NB_END, NB_END2, kimg_t_wk
      integer       ::  N, K, LDA, LDB, LDC
      integer :: id_sname = -1
                                                  __TIMER_SUB_START(510)
      if(i == neg) return

      if(sw_timing_2ndlevel == ON) call tstatc0_begin('modify_bp_and_psi_t_r_blk_g ',id_sname)

      N = NB_END2-i2+1
      K = NB_END-i+1

      if(mod_pot == VANDERBILT_TYPE .and. np_fs.gt.0) then
         LDA = np_fs_x; LDB = NB; LDC = np_fs_x
                                                  __TIMER_DGEMM_START(521)
         call DGEMM__('N','T',np_fs,N,K,-1.0d0,bpr_t_dia(1,1),LDA,p1Sp2_NB(1,1,1),LDB,1.0d0,bpr_t(1,i2),LDC)
                                                  __TIMER_DGEMM_STOP(521)

         if(kimg == 1 .or. (kimg==2 .and. k_symmetry(ik) /= GAMMA)) then
                                                  __TIMER_DGEMM_START(522)
            call DGEMM__('N','T',np_fs,N,K,-1.0d0,bpi_t_dia(1,1),LDA,p1Sp2_NB(1,1,1),LDB, 1.0d0,bpi_t(1,i2),LDC)
                                                  __TIMER_DGEMM_STOP(522)
         end if

         if(kimg==2 .and. k_symmetry(ik) /= GAMMA) then
                                                  __TIMER_DGEMM_START(523)
            call DGEMM__('N','T',np_fs,N,K, 1.0d0,bpi_t_dia(1,1),LDA,p1Sp2_NB(1,1,2),LDB,1.0d0,bpr_t(1,i2),LDC)
            call DGEMM__('N','T',np_fs,N,K,-1.0d0,bpr_t_dia(1,1),LDA,p1Sp2_NB(1,1,2),LDB,1.0d0,bpi_t(1,i2),LDC)
                                                  __TIMER_DGEMM_STOP(523)
         end if
      end if

      LDA = np_g1k_x; LDB = NB; LDC = np_g1k_x
      if(kimg == 1) then
                                                  __TIMER_DGEMM_START(524)
         call DGEMM__('N','T',np_g1k(ik),N,K,-1.d0,psi_t_dia(1,1,1),LDA,p1Sp2_NB(1,1,1),LDB,1.d0,psi_t(1,i2,1),LDC)
                                                  __TIMER_DGEMM_STOP(524)
      else if(kimg==2 .and. k_symmetry(ik) == GAMMA) then
                                                  __TIMER_DGEMM_START(525)
         call DGEMM__('N','T',np_g1k(ik),N,K,-1.d0,psi_t_dia(1,1,1),LDA,p1Sp2_NB(1,1,1),LDB,1.d0,psi_t(1,i2,1),LDC)
         call DGEMM__('N','T',np_g1k(ik),N,K,-1.d0,psi_t_dia(1,1,2),LDA,p1Sp2_NB(1,1,1),LDB,1.d0,psi_t(1,i2,2),LDC)
                                                  __TIMER_DGEMM_STOP(525)
      else  ! kimg == 2 .and. k_symmetry(ik) /= GAMMA
                                                  __TIMER_DGEMM_START(526)
         call DGEMM__('N','T',np_g1k(ik),N,K,-1.d0,psi_t_dia(1,1,1),LDA,p1Sp2_NB(1,1,1),LDB,1.d0,psi_t(1,i2,1),LDC)
         call DGEMM__('N','T',np_g1k(ik),N,K,-1.d0,psi_t_dia(1,1,2),LDA,p1Sp2_NB(1,1,1),LDB,1.d0,psi_t(1,i2,2),LDC)
         call DGEMM__('N','T',np_g1k(ik),N,K, 1.d0,psi_t_dia(1,1,2),LDA,p1Sp2_NB(1,1,2),LDB,1.d0,psi_t(1,i2,1),LDC)
         call DGEMM__('N','T',np_g1k(ik),N,K,-1.d0,psi_t_dia(1,1,1),LDA,p1Sp2_NB(1,1,2),LDB,1.d0,psi_t(1,i2,2),LDC)
                                                  __TIMER_DGEMM_STOP(526)
      end if
      if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(510)
    end subroutine modify_bp_and_psi_t_r_blk_g
!-$ tune FUJITSU for block <<-----
#endif

! -- GLOBAL --
  subroutine modify_bp_and_psi_t_r_g(ik,i,NB_END,mod_pot &
       & ,psi_t,LA,LB,LC,bpr_t,bpi_t)
! Coded by T. Yamasaki in April 2006
! Revised according to the RIKEN phase tuning project 2009, 13 Sep 2009
    integer, intent(in) :: ik,i, NB_END,mod_pot
    integer, intent(in) :: LA,LB,LC
    real(kind=DP),intent(inout) :: psi_t(LA,LB,LC)
    real(kind=DP),intent(inout),optional :: bpr_t(:,:),bpi_t(:,:)

    integer             :: j,ia
    real(kind=DP) :: sr, si
#ifndef SX
    real(kind=DP) :: ar, ai
#endif
#ifdef MGS_DGEMM
    integer :: p, q
#endif
    integer :: id_sname = -1
                                                  __TIMER_SUB_START(508)
    if(i == neg) return
    if(sw_timing_2ndlevel == ON) call tstatc0_begin('modify_bp_and_psi_t_r_g ',id_sname)

    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!!$!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!!$!CDIR NOSYNC
!!$!CDIR CONCUR(BY=1)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                                                  __TIMER_DO_START(564)
          do j = i+1, NB_END
#ifdef SX
             do ia = 1, np_fs
                bpr_t(ia,j) = bpr_t(ia,j) - p1Sp2(j,1)*bp_ir(ia)
                bpi_t(ia,j) = bpi_t(ia,j) - p1Sp2(j,1)*bp_ii(ia)
             end do
#else
             ar=p1Sp2(j,1)
             do ia = 1, np_fs
                bpr_t(ia,j) = bpr_t(ia,j) - ar*bp_ir(ia)
                bpi_t(ia,j) = bpi_t(ia,j) - ar*bp_ii(ia)
             end do
#endif

          end do  ! j-loop
                                                  __TIMER_DO_STOP(564)
       else if(kimg == 2) then
          if(k_symmetry(ik) == GAMMA) then
#ifdef NEC_TUNE_SMP
!!$!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!!$!CDIR NOSYNC
!!$!CDIR CONCUR(BY=1)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                                                  __TIMER_DO_START(565)
             do j = i+1, NB_END
#ifdef SX
! NEC tune ---------------------------------------------------------->
                do ia = 1, np_fs
                   bpr_t(ia,j) = bpr_t(ia,j) - p1Sp2(j,1)*bp_ir(ia)
                end do
#else
                ar=p1Sp2(j,1)
                do ia = 1, np_fs
                   bpr_t(ia,j) = bpr_t(ia,j) - ar*bp_ir(ia)
                end do
! NEC tune <----------------------------------------------------------
#endif
             end do
                                                  __TIMER_DO_STOP(565)
          else  ! kimg==2, k_symmetry(ik) /= GAMMA
#ifdef NEC_TUNE_SMP
!!$!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!!$!CDIR NOSYNC
!!$!CDIR CONCUR(BY=1)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                                                  __TIMER_DO_START(566)
             do j = i+1, NB_END
#ifdef SX
! NEC tune ---------------------------------------------------------->
                do ia = 1, np_fs
                   sr  =  bp_ir(ia);     si  =  bp_ii(ia)
                   bpr_t(ia,j) = bpr_t(ia,j) - p1Sp2(j,1)*sr+p1Sp2(j,2)*si
                   bpi_t(ia,j) = bpi_t(ia,j) - p1Sp2(j,1)*si-p1Sp2(j,2)*sr
                end do
#else
                ar=p1Sp2(j,1)
                ai=p1Sp2(j,2)
                do ia = 1, np_fs
                   sr  =  bp_ir(ia);     si  =  bp_ii(ia)
                   bpr_t(ia,j) = bpr_t(ia,j) - ar*sr+ai*si
                   bpi_t(ia,j) = bpi_t(ia,j) - ar*si-ai*sr
                end do
#endif
             end do
                                                  __TIMER_DO_STOP(566)
! NEC tune <----------------------------------------------------------
          end if
       end if
    end if

    if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!!$!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!!$!CDIR NOSYNC
!!$!CDIR CONCUR(BY=1)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                                                  __TIMER_DO_START(567)
       do j = i+1,NB_END
#ifdef SX
! NEC tune ---------------------------------------------------------->
          do ia = 1, np_g1k(ik)                 ! MPI
!!$             psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(j,1)*psi_t(ia,i,1 )
             psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(j,1)*psi_ir(ia )
          end do
#else
          ar=p1Sp2(j,1)
          do ia = 1, np_g1k(ik)
!!$             psi_t(ia,j,1) = psi_t(ia,j,1) - ar*psi_t(ia,i,1 )
             psi_t(ia,j,1) = psi_t(ia,j,1) - ar*psi_ir(ia)
          end do
! NEC tune <----------------------------------------------------------
#endif
       end do
                                                  __TIMER_DO_STOP(567)
    else if(kimg == 2) then
       if(k_symmetry(ik) == GAMMA) then
#ifdef NEC_TUNE_SMP
!!$!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!!$!CDIR NOSYNC
!!$!CDIR CONCUR(BY=1)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                                                  __TIMER_DO_START(568)
          do j = i+1,NB_END
#ifdef SX
! NEC tune ---------------------------------------------------------->
             do ia = 1, np_g1k(ik)
!!$                psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(j,1)*psi_t(ia,i,1 )
!!$                psi_t(ia,j,2) = psi_t(ia,j,2) - p1Sp2(j,1)*psi_t(ia,i,2 )
                psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(j,1)*psi_ir(ia)
                psi_t(ia,j,2) = psi_t(ia,j,2) - p1Sp2(j,1)*psi_ii(ia)
             end do
#else
             ar=p1Sp2(j,1)
             do ia = 1, np_g1k(ik)
!!$                psi_t(ia,j,1) = psi_t(ia,j,1) - ar*psi_t(ia,i,1 )
!!$                psi_t(ia,j,2) = psi_t(ia,j,2) - ar*psi_t(ia,i,2 )
                psi_t(ia,j,1) = psi_t(ia,j,1) - ar*psi_ir(ia)
                psi_t(ia,j,2) = psi_t(ia,j,2) - ar*psi_ii(ia)
             end do
! NEC tune <----------------------------------------------------------
#endif
          end do
                                                  __TIMER_DO_STOP(568)
       else   ! kimg==2 .and. k_symmetry(ik) /= GAMMA
#ifdef NEC_TUNE_SMP
!!$!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!!$!CDIR NOSYNC
!!$!CDIR CONCUR(BY=1)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                                                  __TIMER_DO_START(569)
          do j = i+1,NB_END
#ifdef SX
! NEC tune ---------------------------------------------------------->
             do ia = 1, np_g1k(ik)                ! MPI
!!$                sr  =  psi_t(ia,i,1 );   si  =  psi_t(ia,i,2 )
                sr  =  psi_ir(ia);   si  =  psi_ii(ia)
                psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(j,1)*sr+p1Sp2(j,2)*si
                psi_t(ia,j,2) = psi_t(ia,j,2) - p1Sp2(j,1)*si-p1Sp2(j,2)*sr
             end do
#else
             ar=p1Sp2(j,1)
             ai=p1Sp2(j,2)
             do ia = 1, np_g1k(ik)
!!$                sr  =  psi_t(ia,i,1 );   si  =  psi_t(ia,i,2 )
                sr  =  psi_ir(ia);   si  =  psi_ii(ia)
                psi_t(ia,j,1) = psi_t(ia,j,1) - ar*sr+ai*si
                psi_t(ia,j,2) = psi_t(ia,j,2) - ar*si-ai*sr
             end do
#endif
! NEC tune <----------------------------------------------------------
          end do
                                                  __TIMER_DO_STOP(569)
       end if
    end if
    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(508)
  end subroutine modify_bp_and_psi_t_r_g


! -- GLOBAL --
  subroutine cp_psi2psii_g(ik,i)
    integer, intent(in) :: ik,i
    psi_ir(1:np_g1k(ik)) = psi_t(1:np_g1k(ik),i,1)
    if(kimg==2) psi_ii(1:np_g1k(ik)) = psi_t(1:np_g1k(ik),i,kimg)
  end subroutine cp_psi2psii_g


  subroutine mgs_phi2wf_each_k_G(ik,phi_l,mode,bsdr_l,bsdi_l,mod_pot)
    integer, intent(in)             :: ik
!!$    real(kind=DP), intent(inout)    :: phi_l(kg1,np_e,ik:ik,kimg)
    real(kind=DP),intent(inout),dimension(maxval(np_g1k),np_e,ik:ik,kimg) :: phi_l
    integer, intent(in)             :: mode,mod_pot
    real(kind=DP), optional,intent(inout), dimension(np_e,np_fs,ik:ik) :: bsdr_l,bsdi_l
!!$    real(kind=DP), optional,intent(inout), dimension(np_e,nlmta,ik:ik) :: bsdr_l,bsdi_l

    integer :: nbs, local_block, L_NB_STA, L_NB_END, in, ri, iy, ix, dsize_psi, dsize_bpri
    integer :: icount, iblk, jblk, i_NB, j_NB ,iq
    real(kind=DP),allocatable,dimension(:,:,:) :: wk_psi
    real(kind=DP),allocatable,dimension(:,:,:) :: wk_bpri
    real(kind=DP),allocatable,dimension(:,:,:) :: psi_t_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpr_t_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpi_t_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpr_tw1_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpi_tw1_dia
    real(kind=DP), allocatable, dimension(:,:,:,:) :: p1Sp2_t2_NB, p1Sp2_t1_NB
!!$    real(kind=DP), allocatable, dimension(:,:,:) :: bsdr_lc, bsdi_lc

    integer ::       i, j

    real(kind=DP) :: fr
    integer :: kimg_t_wk

    real(kind=DP),allocatable,dimension(:,:)    :: phifr_t, phifi_t
    real(kind=DP),allocatable, dimension(:,:,:) :: phi_t ! d(maxval(np_g1k),np_e,kimg)
#ifdef MGS_DGEMM
    integer ::       NB_END, NB_END2, i1, i2
    real(kind=DP), allocatable, dimension(:,:,:) :: p1Sp2_NB
    integer, save :: ibsize_print = OFF
#endif

#ifdef TRANSPOSE_WITHOUT_REARRANGEMENT
    integer :: ierror
#endif
    integer :: ibl1,ibl2,ibsize,ncache
    integer  :: id_sname = -1, id_sname2 = -1, id_sname3 = -1, id_sname4 = -1, id_sname1 = -1
    if(sw_timing_2ndlevel == ON) call tstatc0_begin('mgs_phi2wf_each_k_G ',id_sname)

    ncache = (m_CtrlP_cachesize()*1024)*3/4


    if (sw_timing_2ndlevel == ON) call tstatc0_begin('mgs_phi2wf_each_k_G(1) ',id_sname1)

#ifdef TRANSPOSE_WITHOUT_REARRANGEMENT
    if(ipri>=1) write(nfout,'("A CPP definition of " &
         & ,"TRANSPOSE_WITHOUT_REARRANGEMENT can not be set for MDDAVIDSON")')
    ierror = CPP_DEFINE_ERROR
#ifdef DEBUG_ERRORS
    call phase_error_wo_filename(ierror,nfout,line=__LINE__,modulefile=__FILE__)
#else
    call phase_error_wo_filename(ierror,nfout)
#endif    
#endif

#ifdef MGS_DGEMM
    if(nblocksize_mgs_is_given) then
       NB = nblocksize_mgs
    else
       NB = nblocksize_mgs_default
    end if
    if(ipri >= 2) then
       if(ibsize_print == OFF) then
          if(nblocksize_mgs_is_given) then
             write(nfout,'(" ! nblocksize_mgs_is_given")')
          else
             write(nfout,'(" ! nblocksize_mgs_is_given is false")')
          end if
          write(nfout,'( "! NB(=nblocksize_mgs) (mgs_phi2wf_each_k_G) = ",i8)') NB
          ibsize_print = ON
       end if
    end if
#endif

    call m_ESortho_mgs_alloc(ik)
    kimg_t_wk = 2
    if(k_symmetry(ik) == GAMMA) kimg_t_wk = 1
#ifdef MGS_DGEMM
    allocate(p1Sp2_NB(NB,NB,kimg_t_wk))
    allocate(wk_psi(mp_g1k(ik),NB,kimg) ) ; wk_psi = 0.0d0
    allocate(psi_t_dia(np_g1k_x,NB,kimg))
#endif

    dsize_psi = mp_g1k(ik)*NB*kimg
    if(mod_pot == VANDERBILT_TYPE) then
      if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
        i = 2
      else
        i = 4
      endif
      allocate( wk_bpri(i,max(mp_fs,nac_p),NB) )
      dsize_bpri = i*max(mp_fs,nac_p)*NB
    endif
    allocate( bpr_t_dia(np_fs,NB) )
    allocate( bpi_t_dia(np_fs,NB) )
    allocate( bpr_tw1_dia(nac_p,NB) )
    allocate( bpi_tw1_dia(nac_p,NB) )

    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg_t_wk == 1) then
          call m_ES_F_transpose_r_3D(ista_k,iend_k,ik,fsr_l,bpr_t)    ! fsr_l -> bpr_t
          allocate(phifr_t(np_fs,np_e),phifi_t(1,1))
!!$          allocate(bsdr_lc(np_e,np_fs,ik:ik))
          call m_ES_F_transpose_r_3D(ik,    ik,    ik,bsdr_l,phifr_t) ! bsdr_l -> phifr_t
!!$          do i = 1, np_e
!!$             do j = ista_fs, iend_fs
!!$                bsdr_lc(i,j-ista_fs+1,ik) = bsdr_l(i,j,ik)
!!$             end do
!!$          end do
!!$          call m_ES_F_transpose_r_3D(ik,    ik,    ik,bsdr_lc,phifr_t) ! bsdr_l -> phifr_t
!!$#ifdef MGS_DGEMM
!!$          allocate(bpr_t_dia(np_fs_x,NB))
!!$#endif
       else
          call m_ES_F_transpose_r_3D(ista_k,iend_k,ik,fsr_l,bpr_t,fsi_l,bpi_t)  ! fs[ri]_l -> bp[ri]_t
          allocate(phifr_t(np_fs,np_e),phifi_t(np_fs,np_e))
!!$          allocate(bsdr_lc(np_e,np_fs,ik:ik),bsdi_lc(np_e,np_fs,ik:ik))
!!$          do i = 1, np_e
!!$             do j = ista_fs, iend_fs
!!$                bsdr_lc(i,j-ista_fs+1,ik) = bsdr_l(i,j,ik)
!!$                bsdi_lc(i,j-ista_fs+1,ik) = bsdi_l(i,j,ik)
!!$             end do
!!$          end do
          call m_ES_F_transpose_r_3D(ik,    ik,    ik,bsdr_l,phifr_t,bsdi_l,phifi_t)
!!$          call m_ES_F_transpose_r_3D(ik,    ik,    ik,bsdr_lc,phifr_t,bsdi_lc,phifi_t)
       end if
    end if

    allocate(phi_t(np_g1k_x,np_e,kimg))

    call m_ES_W_transpose_r_3D(ista_k,iend_k,ik,zaj_l,psi_t) ! zaj_l(ig,ie,ik,ri) -> psi_t(ig,ie,ri)
    call m_ES_W_transpose_r_3D(ik,    ik,    ik,phi_l,phi_t) ! phi_l(ig,ie,ik,ri) -> phi_t(ig,ie,ri)

    if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname1)

    icount = (neg/NB+1)/nrank_e+1
!!$    allocate( p1Sp2_t2_NB(NB,NB,kimg_t_wk,icount) )
    allocate( p1Sp2_t1_NB(NB,NB,kimg_t_wk,icount) )
    
#ifdef MGS_DGEMM
    do i = 1, neg,NB
       NB_END = i + NB -1
       if( NB_END > neg ) NB_END = neg

       nbs = (i-1)/NB+1
       if( myrank_e == lrank(nbs)) then
          local_block = nbsn(nbs)
          L_NB_STA = nbsn_sta(local_block)
          L_NB_END = nbsn_end(local_block)
    if (sw_timing_2ndlevel == ON) call tstatc0_begin('mgs_phi2wf_each_k_G(2) ',id_sname2)
!diagonal
          do i1 = L_NB_STA, L_NB_END
             if(mode == ORTHONORMALIZATION .or. mode == NORMALIZATION) then
                call WSW_t_g(ik,i1,mod_pot,fr,phi_t,np_g1k_x,np_e,kimg,phifr_t,phifi_t)
                if(dabs(fr-1.d0) > DELTA) &
                     & call normalize_bp_and_psi_t_g(ik,i1,fr,mod_pot &
                     &   , phi_t,np_g1k_x,np_e,kimg,phifr_t,phifi_t)
                !       |Phi(i)> = |Phi(i)> * fr,  <beta|Phi(i)> = <beta|Phi(i)> * fr
!x!!$          if(mod_pot == VANDERBILT_TYPE) call cp_bpr2bprtw(i1,L_NB_END)
             end if
             if(mod_pot == VANDERBILT_TYPE) call cp_bpr_bsdr2bprtw(i1,L_NB_END) 
             !                  phif[ri]_t, bp[ri]_t -> bpr_tw1, bpr_tw2
             if(i1 == neg) cycle
             call cp_psi2psii_g(ik,i1) ! psi_t(:,i,:) -> psi_ir,psi_ii
             if(mod_pot == VANDERBILT_TYPE) &
                  & call cp_bpr2bpi_g(kimg_t_wk,i1,bpr_t,bpi_t) ! -> bp_ir, bp_ii
             call W1SW2_t_r_g(ik,i1,L_NB_END,mod_pot,phi_t,np_g1k_x,np_e,kimg) ! -> p1Sp2
             call modify_bp_and_psi_t_r_g(ik,i1,L_NB_END,mod_pot &
                  & ,phi_t,np_g1k_x,np_e,kimg,phifr_t,phifi_t)
             !                   psi_t, bpr_t, pbi_t, p1Sp2 -> psi_t, bpr_t, bpi_t
          end do   ! i1-loop
    if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname2)
!lower

    if (sw_timing_2ndlevel == ON) call tstatc0_begin('mgs_phi2wf_each_k_G(3) ',id_sname3)
!!$    call cp_psi_bpri2dias_g(ik,i,kimg_t_wk,NB,psi_t_dia,np_g1k_x,NB,kimg &
!!$         &                 ,bpr_t_dia,bpi_t_dia,np_fs_x)
          call cp_psi_bpri2dias_g1_3D() ! -> wk_psi

       endif ! myrank_e == lrank(nbs)

       call make_diagonal()  ! wk_psi -> psi_t_dia, bp[ri]_t_dia, bp[ri]_tw1_dia

       icount = 0
       p1Sp2_t1_NB = 0.0d0

       do i2 = i+NB, neg,NB
          if(NB_END == neg) cycle
          NB_END2 = i2 + NB -1
          if( NB_END2 > neg ) NB_END2 = neg

          nbs = (i2-1)/NB+1
          if( myrank_e /= lrank(nbs)) cycle
          local_block = nbsn(nbs)
          L_NB_STA = nbsn_sta(local_block)
          L_NB_END = nbsn_end(local_block)
          if(mod_pot == VANDERBILT_TYPE) call cp_bpr_bsdr2bprtw(L_NB_STA,L_NB_END)
          !                                 phif[ri]_t, bp[ri]_t -> bpr_tw1, bpr_tw2

          call W1SW2_t_r_block_g(ik,i,L_NB_STA,p1Sp2_NB,NB_END,L_NB_END,kimg_t_wk &
               & , mod_pot,phi_t,psi_t_dia,np_g1k_x,np_e,kimg,bpr_tw1_dia,bpi_tw1_dia) ! -> p1Sp2
          !X!!$            & , mod_pot,phi_t,psi_t_dia,np_g1k_x,np_e,kimg,bpr_tw1(1,i),bpi_tw1(1,i)) ! -> p1Sp2
          icount = icount + 1

          do i_NB = 1, NB
             do iq = 1, kimg_t_wk
                do j_NB = 1,NB
                   p1Sp2_t1_NB(j_NB,i_NB,iq,icount) = p1Sp2_NB(j_NB,i_NB,iq)
          end do; enddo ; enddo
       end do ! i2-looop1

       if(NB_END /= neg) then
          if(nrank_g > 1 ) then
             ix =  NB*NB*kimg_t_wk*icount
             call mpi_allreduce(MPI_IN_PLACE,p1Sp2_t1_NB,ix &
                  & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
          endif
       endif   !(NB_END /= neg )

       icount = 0
       do i2 = i+NB, neg,NB
          if(NB_END == neg) cycle
          NB_END2 = i2 + NB -1
          if( NB_END2 > neg ) NB_END2 = neg
          nbs = (i2-1)/NB+1
          if( myrank_e /= lrank(nbs)) cycle
          local_block = nbsn(nbs)
          L_NB_STA = nbsn_sta(local_block)
          L_NB_END = nbsn_end(local_block)
!modify2010
          icount =  icount+1
          do i_NB = 1, NB
             do iq = 1, kimg_t_wk
                do j_NB = 1, NB
                   p1Sp2_NB(j_NB,i_NB,iq) = p1Sp2_t1_NB(j_NB,i_NB,iq,icount)
          end do; enddo ; enddo

          call modify_bp_and_psi_t_r_blk_g(ik,i,L_NB_STA,p1Sp2_NB,NB_END,L_NB_END,kimg_t_wk &
               & , mod_pot,phi_t,psi_t_dia,np_g1k_x,np_e,kimg,phifr_t,phifi_t,bpr_t_dia,bpi_t_dia)
          ! phi_t, phifr_t, phifi_t, p1Sp2 -> phi_t, phifr_t, phifi_t
       end do   ! i2-loop
    if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname3)
    end do   ! i-loop
#else
    do i = 1, neg
       if(mode == ORTHONORMALIZATION .or. mode == NORMALIZATION) then
          call WSW_t_g(ik,i,mod_pot,fr,phi_t,np_g1k_x,np_e,kimg,phifr_t,phifi_t)
          if(dabs(fr-1.d0) > DELTA)  &
               & call normalize_bp_and_psi_t_g(ik,i,fr,mod_pot &
               &   , phi_t,np_g1k_x,np_e,kimg,phifr_t,phifi_t)
       end if
!!$       if(mod_pot == VANDERBILT_TYPE) call cp_bpr_bsdr2bprtw(i,neg)
!!$       if(i == neg) cycle
          call cp_psi2psii_g(ik,i) ! psi_t(:,i,:) -> psi_ir,psi_ii
       if(mod_pot == VANDERBILT_TYPE) &
            & call cp_bpr2bpi_g(kimg_t_wk,i,bpr_t,bpi_t) ! -> bp_ir, bp_ii
       call W1SW2_t_r_g(ik,i,neg,mod_pot,phi_t,np_g1k_x,np_e,kimg & ! ->p1Sp2
            & ,phifr_t,phifi_t)
       call modify_bp_and_psi_t_r_g(ik,i,neg,mod_pot &
            & ,phi_t,np_g1k_x,np_e,kimg,phifr_t,phifi_t)
       ! phi_t, psi_t, phifr_t,phifi_t,bpr_t, pbi_t, p1Sp2 -> phi_t, phifr_t,phifi_t

    end do
#endif

    if (sw_timing_2ndlevel == ON) call tstatc0_begin('mgs_phi2wf_each_k_G(4) ',id_sname4)
    call m_ES_W_transpose_back_r_3D(ik,ik,ik,phi_l,phi_t)  ! phi_t -> phi_l
    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg_t_wk == 1) then
          call m_ES_F_transpose_back_r_3D(ik,ik,ik,bsdr_l,phifr_t)
!!$          call m_ES_F_transpose_back_r_3D(ik,ik,ik,bsdr_lc,phifr_t)
!!$          bsdr_l(:,:,ik) = 0.d0
!!$          do i = 1, np_e
!!$             do j = ista_fs, iend_fs
!!$                bsdr_l(i,j,ik) = bsdr_lc(i,j-ista_fs+1,ik)
!!$             end do
!!$          end do
!!$          call mpi_allreduce(MPI_IN_PLACE,bsdr_l(1,1,ik),np_e*nlmta,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
!!$          deallocate(bsdr_lc)
       else
          call m_ES_F_transpose_back_r_3D(ik,ik,ik,bsdr_l,phifr_t,bsdi_l,phifi_t)
!!$          call m_ES_F_transpose_back_r_3D(ik,ik,ik,bsdr_lc,phifr_t,bsdi_lc,phifi_t)
!!$          bsdr_l(:,:,ik) = 0.d0
!!$          bsdi_l(:,:,ik) = 0.d0
!!$          do i = 1, np_e
!!$             do j = ista_fs, iend_fs
!!$                bsdr_l(i,j,ik) = bsdr_lc(i,j-ista_fs+1,ik)
!!$                bsdi_l(i,j,ik) = bsdi_lc(i,j-ista_fs+1,ik)
!!$             end do
!!$          end do
!!$          call mpi_allreduce(MPI_IN_PLACE,bsdr_l(1,1,ik),np_e*nlmta,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
!!$          call mpi_allreduce(MPI_IN_PLACE,bsdi_l(1,1,ik),np_e*nlmta,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
!!$          deallocate(bsdr_lc,bsdi_lc)
       end if
    end if

    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg_t_wk == 1) then
          deallocate(phifr_t)
       else
          deallocate(phifr_t,phifi_t)
       end if
    end if

    deallocate(p1Sp2_t1_NB)
    deallocate(phi_t)
    deallocate(bpi_tw1_dia,bpr_tw1_dia)
    deallocate(bpi_t_dia,bpr_t_dia)
    if(mod_pot == VANDERBILT_TYPE) deallocate(wk_bpri)
#ifdef MGS_DGEMM
    deallocate(psi_t_dia)
    deallocate(wk_psi)
    deallocate(p1Sp2_NB)
#endif

    call m_ESortho_mgs_dealloc
    if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname4)
    if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
  contains
!!$#ifdef MGS_DGEMM
!!$    subroutine cp_bpr2bprtw(i1,i2)
!!$      integer, intent(in) :: i1,i2
!!$      integer :: i, ia, p, q, i_last
!!$      i_last = i2
!!$      if(k_symmetry(ik) == GAMMA) then
!!$         do i = i1, i_last
!!$            do ia = 1, nac_p
!!$               p = nlmta1_p(ia);     q = nlmta2_p(ia)
!!$               bpr_tw1(ia,i) = bpr_t(p,i)
!!$               bpr_tw2(ia,i) = bpr_t(q,i)
!!$            end do
!!$         end do
!!$      else
!!$         do i = i1, i_last
!!$            do ia = 1, nac_p
!!$               p = nlmta1_p(ia);     q = nlmta2_p(ia)
!!$               bpr_tw1(ia,i) = bpr_t(p,i)
!!$               bpr_tw2(ia,i) = bpr_t(q,i)
!!$               bpi_tw1(ia,i) = bpi_t(p,i)
!!$               bpi_tw2(ia,i) = bpi_t(q,i)
!!$            end do
!!$         end do
!!$      end if
!!$    end subroutine cp_bpr2bprtw
!!$#endif

#ifdef MGS_DGEMM
    subroutine make_diagonal()
      integer :: ri,ix,iy

      if(nrank_e > 1) then
         call mpi_bcast(wk_psi,dsize_psi,mpi_double_precision,lrank(nbs),mpi_kg_world,ierr)
      end if
      do ri = 1, kimg
         do iy = 1, NB
            do ix = 1, np_g1k(ik)
               psi_t_dia(ix,iy,ri) = wk_psi(ix,iy,ri)
            end do
         end do
      end do

      if(mod_pot == VANDERBILT_TYPE) then
         if(nrank_e > 1) then
            call mpi_bcast(wk_bpri,dsize_bpri &
                 & ,mpi_double_precision,lrank(nbs),mpi_kg_world,ierr)
         end if
         if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
            do iy = 1, NB
               do ix = 1, np_fs
                  bpr_t_dia(ix,iy) = wk_bpri(1,ix,iy)
               enddo
               do ix = 1, nac_p
                  bpr_tw1_dia(ix,iy) = wk_bpri(2,ix,iy)
               enddo
            enddo
         else
            do iy = 1, NB
               do ix = 1, np_fs
                  bpr_t_dia(ix,iy) = wk_bpri(1,ix,iy)
                  bpi_t_dia(ix,iy) = wk_bpri(2,ix,iy)
               enddo
               do ix = 1, nac_p
                  bpr_tw1_dia(ix,iy) = wk_bpri(3,ix,iy)
                  bpi_tw1_dia(ix,iy) = wk_bpri(4,ix,iy)
               enddo
            enddo
         end if
      end if
    end subroutine make_diagonal

    subroutine cp_psi_bpri2dias_g1_3D()
      integer :: ri,i1,ix,iy

      do ri = 1, kimg
         do i1 = L_NB_STA, L_NB_END
            iy = i1-L_NB_STA+1
            do ix = 1, np_g1k(ik)
               wk_psi(ix,iy,ri) = psi_t(ix,i1,ri)
            enddo
         enddo
      enddo

      if(mod_pot == VANDERBILT_TYPE) then
         if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
            do i1 = L_NB_STA, L_NB_END
               iy = i1-L_NB_STA+1
               do ix = 1, np_fs
                  wk_bpri(1,ix,iy) = bpr_t(ix,i1)
               enddo
               do ix = 1, nac_p
                  wk_bpri(2,ix,iy) = bpr_tw1(ix,i1)
               enddo
            enddo
         else
            do i1 = L_NB_STA, L_NB_END
               iy = i1-L_NB_STA+1
               do ix = 1, np_fs
                  wk_bpri(1,ix,iy) = bpr_t(ix,i1)
                  wk_bpri(2,ix,iy) = bpi_t(ix,i1)
               enddo
               do ix = 1, nac_p
                  wk_bpri(3,ix,iy) = bpr_tw1(ix,i1)
                  wk_bpri(4,ix,iy) = bpi_tw1(ix,i1)
               enddo
            enddo
         end if
      end if
    end subroutine cp_psi_bpri2dias_g1_3D

    subroutine cp_bpr_bsdr2bprtw(i1,i2)
      integer, intent(in) :: i1,i2
      integer :: i, ia, p, q, i_last
#ifdef MGS_DGEMM_DEBUG
      i_last = i1
#else
      i_last = i2
#endif
      if(k_symmetry(ik) == GAMMA) then
         do i = i1, i_last
            do ia = 1, nac_p
               p = nlmta1_p(ia);     q = nlmta2_p(ia)
               bpr_tw1(ia,i) = bpr_t(p,i)
               bpr_tw2(ia,i) = phifr_t(q,i)
            end do
         end do
      else
         do i = i1, i_last
            do ia = 1, nac_p
               p = nlmta1_p(ia);     q = nlmta2_p(ia)
               bpr_tw1(ia,i) = bpr_t(p,i)
               bpr_tw2(ia,i) = phifr_t(q,i)
               bpi_tw1(ia,i) = bpi_t(p,i)
               bpi_tw2(ia,i) = phifi_t(q,i)
!!$               bpr_tw1(ia,i) = phifr_t(p,i)
!!$               bpr_tw2(ia,i) = bpr_t(q,i)
!!$               bpi_tw1(ia,i) = phifi_t(p,i)
!!$               bpi_tw2(ia,i) = bpi_t(q,i)
            end do
         end do
      end if
    end subroutine cp_bpr_bsdr2bprtw
#endif
  end subroutine mgs_phi2wf_each_k_G

!******************** modified by RIST_16
  subroutine WSW_for_overlap_t_g(ik,ito,jto,fr,fi,bpr_t,bpi_t)
    use m_Electronic_Structure, only : fsr_l, fsi_l
    integer, intent(in)        :: ik,ito,jto
    real(kind=DP), intent(out) :: fr,fi
    real(kind=DP),intent(in),optional :: bpr_t(:,:),bpi_t(:,:)
    real(kind=DP),allocatable :: bpr(:,:),bpi(:,:)

    integer              :: ia,p,q, i, ig1,ib
    integer :: id_sname = -1
    allocate(bpr(np_fs,neg))
    if(.not.(k_symmetry(ik)==GAMMA.and.kimg == 2)) allocate(bpi(np_fs,neg))
    bpr=0.d0 
    do ib = 1,np_e
       do i = 1, np_fs
          !bpr  (i,ib) = fsr_l(ib-ista_e+1,i,ik)
          bpr  (i,neg_g(ib)) = bpr_t(ib,i)
       end do
    end do
    call mpi_allreduce(MPI_IN_PLACE,bpr,  np_fs*neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
    if(allocated(bpi)) then
      bpi=0.d0
      do ib = 1,np_e
         do i = 1, np_fs
            !bpi  (i,ib) = fsi_l(ib-ista_e+1,i,ik)
            bpi  (i,neg_g(ib)) = bpi_t(ib,i)
         end do
      end do
      call mpi_allreduce(MPI_IN_PLACE,bpi,  np_fs*neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
    endif

    fr = 0.d0
    fi = 0.d0
    if(k_symmetry(ik) == GAMMA .and. kimg == 2) then
       do ia = 1, nac_p
          p = nlmta1_p(ia);     q = nlmta2_p(ia)
          fr = fr+fqwei_p(ia)*(bpr(p,jto)*bpr(q,ito))
       end do
    else
       do ia = 1, nac_p
          p = nlmta1_p(ia);     q = nlmta2_p(ia)
          fr = fr+fqwei_p(ia)*(bpr(p,jto)*bpr(q,ito)+bpi(p,jto)*bpi(q,ito))
          fi = fi+fqwei_p(ia)*(bpr(p,jto)*bpi(q,ito)-bpi(p,jto)*bpr(q,ito))
       end do
    end if
    !call mpi_allreduce(MPI_IN_PLACE,fr,1,mpi_double_precision,MPI_SUM,mpi_ke_world,ierr)
    !if(allocated(bpi)) &
    !&  call mpi_allreduce(MPI_IN_PLACE,fi,1,mpi_double_precision,MPI_SUM,mpi_ke_world,ierr)
    deallocate(bpr)
    if(allocated(bpi)) deallocate(bpi)
  end subroutine WSW_for_overlap_t_g
end module m_ES_ortho

!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.00                                       #
!#                                                                       #
!#      Sub Routine : Transition_moment_Epsilon                          #
!#                                                                       #
!#                                Written by T. Hamada 2006/4/28         #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
!
! $Id: Transition_moment_Epsilon.f90 593 2019-06-20 03:47:31Z jkoga $
subroutine Transition_moment_Epsilon
  use m_Epsilon_ek,            only : eigen_value_ordering_eps_ek &
       &                              ,calc_transition_moment_eps_ek
  use m_Control_Parameters,  only : sw_corelevel_spectrum, sw_local_approx_trans_moment
  use m_Const_Parameters,      only : ON
  use m_CLS_dipquad,           only : m_CLS_calc_transmom_ek
  
  implicit none

  if ( sw_corelevel_spectrum == ON .and. sw_local_approx_trans_moment == ON ) then
     call m_CLS_calc_transmom_ek
  else
     call eigen_value_ordering_eps_ek
     call calc_transition_moment_eps_ek
  endif
end subroutine Transition_moment_Epsilon

      subroutine dc(n, d, e, z, ldz, INFO, RET)
!$    use omp_lib    
      implicit NONE

      integer, intent(in)           :: n, ldz
      real(8), intent(inout)        :: d(1:n), e(1:n)
      real(8), intent(out)          :: z(1:ldz,*)
      integer, intent(out)          :: info
      real(8), intent(out)          :: ret

! Parameters BLACS array descritor(the position of entry tags), etc
      INTEGER, PARAMETER            :: BLOCK_CYCLIC_2D = 1
      INTEGER, PARAMETER            :: DLEN_  = 9
      INTEGER, PARAMETER            :: DTYPE_ = 1
      INTEGER, PARAMETER            :: CTXT_  = 2
      INTEGER, PARAMETER            :: M_     = 3
      INTEGER, PARAMETER            :: N_     = 4
      INTEGER, PARAMETER            :: MB_    = 5
      INTEGER, PARAMETER            :: NB_    = 6
      INTEGER, PARAMETER            :: RSRC_  = 7
      INTEGER, PARAMETER            :: CSRC_  = 8
      INTEGER, PARAMETER            :: LLD_   = 9

      integer                       :: DESCZ( DLEN_ )
      integer                       :: DESCW( DLEN_ )

      integer                       :: i,j,nx,istat,NB,lddz,lddw
      integer                       :: NP, NQ, NPCOL, NPROW
      integer                       :: NPROCS, IAM, MYCOL, MYROW
      integer                       :: ICTXT
 
      integer                       :: world_size, my_rank, ierr
      integer                       :: TRILWMIN, LWORK, LIWORK
 
      real(8), pointer              :: work(:)
      integer, pointer              :: iwork(:)

#if defined(__INTEL_COMPILER)
      logical, parameter            :: USE_MY_REDIST = .FALSE.
#else
      logical, parameter            :: USE_MY_REDIST = .TRUE.
#endif

      integer, external             :: NUMROC

      real(8)  :: d1,d2
      real(8)  :: dd1,dd2

      include 'mpif.h'
      include 'trd.h'
      include 'DC_ADD.h'

      flops = 0D0
      dgemm_time = 0D0
      p_time0 = 0D0
      p_timer = 0D0
      p_time2 = 0D0
      p_time3 = 0D0
      p_times = 0D0
      p_timez = 0D0
 
      dd1 = MPI_Wtime()
 
      d1 = MPI_Wtime()

#ifdef PHASE
      CALL BLACS_PINFO( IAM, NPROCS )
      call datacast_init(2)
      NPROW = x_nnod
      NPCOL = y_nnod
      ICTXT = ICTXTtoDC
      MYROW = MYROWtoDC
      MYCOL = MYCOLtoDC
!     call BLACS_GET( -1, 0, ICTXT )
!     call BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
#else
! BLACS/PBLAS/SCALAPACK initialization
      CALL BLACS_PINFO( IAM, NPROCS )
      if ( NPROCS < 1 ) then
!  MPI group setup
         call MPI_COMM_SIZE( MPI_COMM_EIGEN, NPROCS, ierr )
         call MPI_COMM_RANK( MPI_COMM_EIGEN, IAM, ierr )
         CALL BLACS_SETUP( IAM, NPROCS )
      end if
      call BLACS_GET( -1, 0, ICTXT )
!     call BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      call datacast_init(2)
      NPROW = x_nnod
      NPCOL = y_nnod
!     if (myrow<0.or.myrow>nprow.or.mycol<0.or.mycol>npcol)then
         call BLACS_GRIDINIT( ICTXT, 'Column-major', nprow, npcol)
         call BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
!     endif
#endif


! BLACS array registration
!      NB = 1
!      NB = 8
!      NB = 32
!      NB = 48
      NB = 64
!      NB = 64+16
!      NB = 64+32
!      NB = 128

      NP = NUMROC( n, NB, MYROW, 0, NPROW )
      NQ = NUMROC( n, NB, MYCOL, 0, NPCOL )
      lddz = (n-1)/NPROW+1
      lddz = ((lddz-1)/NB+1)*NB
      lddw = (n-1)/NPCOL+1
      lddw = ((lddw-1)/NB+1)*NB
!
      call DESCINIT( DESCZ, n, n, NB, NB, 0, 0, ICTXT, lddz, ierr )
 
! preparing working arrays
      nx     = (N-1)/NPCOL+1
      LWORK  = MAX(1+6*N+2*NP*(NQ+MAX(NQ,NB)), lddz*lddw, ldz*nx)
      LIWORK = 2+7*n+8*NPCOL
      allocate(work(lwork), iwork(liwork), stat=istat)
      if(istat.ne.0) then
         print*,"Memory exhausted"
         call flush(6)
         call MPI_Abort( MPI_COMM_EIGEN, 1, ierr )
      end if


! Somehow, Z must be nullified (Originally next loop is not required.)
!$OMP PARALLEL DO
      do i=1, lddz*lddw
         z(i,1) = 0.0D+00
      end do
!$OMP END PARALLEL DO
      d2 = MPI_Wtime()
      IF(IAM==0)print*,"RERE0",d2-d1


!      MKL_MODE = MKL_GET_DYNAMIC()
!      call MKL_SET_DYNAMIC(0)
      d1 = MPI_Wtime()
      CALL PDSTEDC( 'I', n, d(1), e(1), z(1,1), 1, 1, DESCZ,
     $              WORK(1), LWORK, IWORK(1), LIWORK, INFO )
      d2 = MPI_Wtime()
!      call MKL_SET_DYNAMIC(MKL_MODE)

      IF(IAM==0)print*,"PDSTEDC",d2-d1

      IF(NB==1)THEN
         d1 = MPI_Wtime()
!$OMP PARALLEL private(i,j)
!$    IF ( omp_get_thread_num()==0 ) THEN
         do i=nx,1,-1
            j=(i-1)*lddz
            work(1:lddz)=z(1+j:lddz+j,1)
            z(1:lddz,i)=work(1:lddz)
         enddo
         do i=1,nx
            z(lddz+1:ldz,i)=0.0D0
         enddo
!$    ENDIF
!$    IF ( omp_get_num_threads()==1 .OR.
!$   $     omp_get_thread_num()==1 ) THEN
!         print*,TRD_inod,d(1:n)
!         call bcast_dbl( d(1), n, 1, x_COMM_WORLD )
!         call bcast_dbl( d(1), n, 1, y_COMM_WORLD )
!$    ENDIF
!$OMP END PARALLEL
         d2 = MPI_Wtime()
         IF(IAM==0)print*,"RERE1",d2-d1
      ELSE

      IF( USE_MY_REDIST )THEN
         d1 = MPI_Wtime()
         call dc_redist1( n, NB, z, work, lddz, iwork, liwork/2 )
         d2 = MPI_Wtime()
         IF(IAM==0)print*,"MY-REDIST1",d2-d1
         d1 = MPI_Wtime()
         call dc_redist2( n, NB, work, lddz, z, ldz, iwork, liwork/2 )
         d2 = MPI_Wtime()
         IF(IAM==0)print*,"MY-REDIST2",d2-d1
      ELSE
         d1 = MPI_Wtime()
         call DESCINIT( DESCW, n, n, 1, 1, 0, 0, ICTXT, ldz, ierr )
         call PDGEMR2D( n, n, z, 1, 1, DESCZ, work, 1, 1, DESCW, ICTXT )
         d2 = MPI_Wtime()
         IF(IAM==0)print*,"PDGEMR2D",d2-d1
      ENDIF

         d1 = MPI_Wtime()
!$OMP PARALLEL private(i)
!$    IF ( omp_get_thread_num()==0 ) THEN
      IF( .NOT.USE_MY_REDIST )THEN
         do i=1, ldz*nx
            z(i,1)=work(i)
         end do
      ENDIF
!$    ENDIF
!$    IF ( omp_get_num_threads()==1 .OR.
!$   $     omp_get_thread_num()==1 ) THEN
         call bcast_dbl( d(1), n, 1, x_COMM_WORLD )
         call bcast_dbl( d(1), n, 1, y_COMM_WORLD )
!$    ENDIF
!$OMP END PARALLEL
         d2 = MPI_Wtime()
         IF(IAM==0)print*,"RERE1",d2-d1
      ENDIF

!     call datacast_free(1)

! freeing working arrays
      deallocate(work)
      deallocate(iwork)

 
! BLACS/PBLAS/SCALAPACK finalize
!     call BLACS_GRIDEXIT( ICTXT )

      dd2 = MPI_Wtime()

         IF(IAM==0)print*,"DIVIDE.",p_time0
         IF(IAM==0)print*,"PDLASRT",p_timer
         IF(IAM==0)print*,"PDLAED2",p_time2
         IF(IAM==0)print*,"PDLAED3",p_time3
         IF(IAM==0)print*,"PDLAEDZ",p_timez
         IF(IAM==0)print*,"PDLASET",p_times
         IF(IAM==0)print*,"PDGEMM", dgemm_time

      ret = flops ! dgemm_time ! flops/dgemm_time

      return
      end subroutine

!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.00                                       #
!#                                                                       #
!#      Sub Routine : Reset_Kpoint                                       #
!#                                                                       #
!#                                Written by T. Hamada 2006/4/28         #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
! $Id: Reset_Kpoint.f90 376 2014-06-17 07:48:31Z jkoga $
   subroutine Reset_Kpoint
     use m_Files,                 only : nfout
     use m_Kpoints,               only : kv3_ek, vkxyz_ek
     use m_Epsilon_ek,            only : sw_mass, ikshift, vkxyz_ek_org
     use m_Control_Parameters,    only : printable
     implicit none
     if(sw_mass==0.or.ikshift==0.0d0) return
     vkxyz_ek(1:kv3_ek,1:3,1:2) = vkxyz_ek_org(1:kv3_ek,1:3,1:2)
     if(printable) write(nfout,'(1x,"!* k-points are reseted")')
   end subroutine Reset_Kpoint

       subroutine tred1(n,a,nma0,d_out,e_out,m0)
       implicit NONE

       include 'mpif.h'

       integer                :: n, nma0, m0
       integer                :: nm, m
       real(8)                :: a(*)
       real(8)                :: d_out(1:n), e_out(1:n)

       include 'trd.h'
       include 'CSTAB.h'

       integer                :: nm0, nx0
       integer                :: i_1,j_1, i, j, k, j_2, j_3
       integer                :: nx, ierr

       integer, parameter     :: nm_max_L1 = 16*4
       integer, parameter     :: nm_max_L2 = 16*4*2


       real(8)                :: d1, d2
       real(8)                :: c1, c2

       integer :: lda, ldz, nz

       nm = nma0
       m  = m0

       call datacast_init(2)

       call MPI_Barrier(TRD_COMM_WORLD,ierr)

       lda = nma0
       ldz = (n-1)/x_nnod+1
       call CSTAB_get_optdim(ldz, 6, nm_max_L1, nm_max_L2,nx)
       ldz = nx
       nz = (n-1)/y_nnod+1

          call tred1_(a, d_out, e_out, n, lda, m)

       call flush(6)

       call datacast_free(1)

       call MPI_Barrier(TRD_COMM_WORLD,ierr)

       return
       end subroutine ! tred1

       subroutine tred1_(a,d_out,e_out,n,nm,m)
       implicit NONE

       include 'mpif.h'

       integer                :: n, nm, nmx, nv, nvx, m
       real(8)                :: a(nm,*)
       real(8)                :: d_out(1:n)
       real(8)                :: e_out(1:n)

       real(8), pointer       :: u_t(:), v_t(:), d_t(:)
       real(8), pointer       :: w(:)
       real(8), pointer       :: ux_vx(:)
       real(8), pointer       :: uy_vy(:)

       include 'trd.h'
       include 'CSTAB.h'
       include 'param.h'

       real(8)                :: d1,d2
       real(8)                :: d3,d4
       integer                :: nm_orig, nx, n1, n2, n3
       integer                :: i,j,k

       integer                :: ierr, kx

       integer                :: offset1, offset2, offset3
       integer                :: offset4, offset5, offset6
       integer                :: offset7, offset8

       integer, parameter     :: nm_max_L1 = 16*4
       integer, parameter     :: nm_max_L2 = 16*4*2



          nx = (n-1)/x_nnod+1 +2
          nv = nm
          call CSTAB_get_optdim(nx, 6, nm_max_L1, nm_max_L2, nv)
          if(TRD_inod==1)then
            PRINT*,"NV=",nv, y_nnod
          endif

          allocate(
     &           w(1:nm*m+n_columns),
     &           v_t(1:MAX(2*nv,2*(n+3),2*8*m)+n_columns),
     &           u_t(1:MAX(2*nv,2*(n+3),2*8*m)+n_columns),
     &           d_t(1:nv+n_columns),
     &           ux_vx(1:nv*2*m+2*n_columns),
     &           uy_vy(1:nv*2*m+2*n_columns),
     &           stat=ierr)
          if ( ierr /= 0 ) then
             if ( TRD_inod == 1 ) print*,"Memory allocation error."
             call MPI_Abort(TRD_COMM_WORLD, 1, ierr)
          end if

          w = ZERO
          v_t = ZERO
          u_t = ZERO
          d_t = ZERO
          ux_vx = ZERO
          uy_vy = ZERO

          kx = nv*m+n_columns
          call CSTAB_adjust_base(ux_vx(1), a(1,1),offset1)
          call CSTAB_adjust_base(ux_vx(1+kx), a(1,1),offset3)
          call CSTAB_adjust_base(uy_vy(1), a(1,1),offset2)
          call CSTAB_adjust_base(uy_vy(1+kx), a(1,1),offset4)
          call CSTAB_adjust_base(u_t(1),a(1,1),offset5)
          call CSTAB_adjust_base(v_t(1),a(1,1),offset6)
          call CSTAB_adjust_base(w(1),a(1,1),offset7)
          kx = !(L1_WINDOW/8)
!     &           +(L1_WINDOW)
     &           +(L1_LSIZE/8)
!     &           +(L1_LSIZE)
     &           +(L2_LSIZE/8)
          offset1 = offset1+kx*1
          offset2 = offset2+kx*3
          offset3 = offset3+kx*5
          offset4 = offset4+kx*2
          offset5 = offset5+kx*4
          offset6 = offset6+kx*6
          offset7 = offset7+kx*0
          call CSTAB_round_offset(offset1)
          call CSTAB_round_offset(offset2)
          call CSTAB_round_offset(offset3)
          call CSTAB_round_offset(offset4)
          call CSTAB_round_offset(offset5)
          call CSTAB_round_offset(offset6)
          call CSTAB_round_offset(offset7)

!!!
          kx = nv*m+n_columns
          call MPI_Barrier(TRD_COMM_WORLD, ierr)

!$OMP PARALLEL
          call trd_body(a, nm, d_out, e_out, n, nv, m,
     &                  w(1+offset7),
     &                  ux_vx(1   +offset1),    ! u_x(1:nv,m)
     &                  uy_vy(1   +offset2),    ! u_y(1:nv,m)
     &                  ux_vx(1+kx+offset3),    ! v_x(1:nv,m)
     &                  uy_vy(1+kx+offset4),    ! v_y(1:nv,m)
     &                  u_t(1+offset5),
     &                  v_t(1+offset6),
     &                  d_t(1))
!$OMP END PARALLEL

          call MPI_Barrier(TRD_COMM_WORLD, ierr)

          deallocate(w)
          deallocate(v_t)
          deallocate(u_t)
          deallocate(d_t)
          deallocate(ux_vx)
          deallocate(uy_vy)

       return
       end subroutine ! tred1_

       subroutine trd_body(a, nm, d_out, e_out, n, nv, m_orig,
     &               w, u_x, u_y, v_x, v_y, u_t, v_t, d_t)
!$     use omp_lib
       implicit NONE

       integer                :: n, nm, nv, m_orig
       real(8)                :: a(1:nm,*)
       real(8)                :: d_out(1:n), e_out(1:n)
       real(8)                :: u_t(1:2*nv), v_t(1:2*nv)
       real(8)                :: d_t(1:nv)
       real(8)                :: w(1:nm,*), w1, w2
       real(8)                :: u_x(1:nv,*), u_y(1:nv,*)
       real(8)                :: v_x(1:nv,*), v_y(1:nv,*)

       integer, parameter     :: MBAND = 1

       real(8)                :: c(MBAND,MBAND), prod_uv
       real(8)                :: t1, t2, t3
       save                      c
       integer                :: i, j, k, l

       integer                :: y_root, y_pos
       integer                :: x_root, x_pos
       integer                :: i_1, i_2, i_3, i_4
       integer                :: j_1, j_2, j_3, j_4
       integer                :: k_1, k_2, k_3, k_4
       integer                :: l_1, l_2, l_3, l_4

       integer                :: n_left, m0, mm, m
       integer                :: i_block, i_base

       integer                :: ii

       include 'mpif.h'
       include 'trd.h'
       include 'param.h'

       real(8)      t2_reduce1, t2_reduce2
       common /t2/  t2_reduce1, t2_reduce2


       real(8)                :: d1,d2,dd(100)


       t2_reduce1 = ZERO
       t2_reduce2 = ZERO

       dd=0
       m = m_orig
!
! initialization
!
!$OMP MASTER

       if ( TRD_inod == 1 ) then
!$        if ( omp_get_thread_num() == 0 ) then
             print*,"NUM.OF.PROCESS=",TRD_nnod,"(",x_nnod,y_nnod,")"
!$           print*,"NUM.OF.THREADS=",omp_get_num_threads()
!$        endif
       endif
       call flush(6)

       call tred1_init(a(1,1), nm, n,
     &              d_out(1), e_out(1),
     &              u_t(1), v_t(1), nv)

!$OMP END MASTER

       if ( m > n ) then
          m = n
       end if

       mm = ((n-MOD(n,MBAND))-1)/m+1

!$OMP BARRIER

       do i_block=mm,MAX(1,3*(2-m)),-1

!$OMP BARRIER

          i_base = (i_block-1)*m
          m0     = MIN(m,n-i_base)

!$OMP MASTER

         call tred1_load(a(1,1), w(1,1), nm,
     &            d_t(1),
     &            u_x(1,1), u_y(1,1), v_x(1,1), v_y(1,1), nv,
     &            m0, i_base, i_block)

!$OMP END MASTER

          k_2 = m0
          k_3 = MAX(1,3*(2-i_block))

!$OMP BARRIER

          do k_1=k_2,k_3,-1; k_4=k_1-MBAND+1

!$OMP BARRIER

             i = i_base+k_1
!
! u=...
!

!$OMP MASTER
             if ( k_1 < k_2 ) then

                d1=MPI_Wtime()
!
! w':= w-uv-vu
!
                call tred1_local_2update0(
     &                  w(1,k_4), nm,
     &                  u_x(1,k_4+1), u_y(1,k_4+1),
     &                  v_x(1,k_4+1), v_y(1,k_4+1), nv,
     &                  u_x(1,k_4), c(1,1),
     &                  i_base, i+1)

                d2=MPI_Wtime()
                dd(6)=dd(6)+(d2-d1)
             else
                c(1,1) = M_ONE
             end if

             d1=MPI_Wtime()

             call tred1_u(
     &               w(1,k_4), nm,
     &               u_x(1,k_4), u_y(1,k_4), nv,
     &               u_t(1), v_t(1), i,
     &               c(1,1) )

             d2=MPI_Wtime()
             dd(1)=dd(1)+(d2-d1)
!$OMP END MASTER

!$OMP BARRIER

!$OMP MASTER

             d1=MPI_Wtime()

!$OMP END MASTER
!
! v:=Au
!
             call tred1_au(
     &               a(1,1), nm,
     &               u_x(1,k_4), u_y(1,k_4), v_x(1,k_4), nv,
     &               u_t(1), v_t(1), d_t(1),
     &               i, i_base, m0,
     &               w(1,k_4), e_out(1), c(1,1))

!$OMP BARRIER

!$     if(omp_get_num_threads()==1.OR.omp_get_thread_num()==1)then
             if ( k_1 < k_2 ) then

                call tred1_local_2update(
     &                  w(1,1), nm,
     &                  u_x(1,k_4+1), u_y(1,k_4+1),
     &                  v_x(1,k_4+1), v_y(1,k_4+1), nv,
     &                  i_base, i-1+1, i+1)

             end if
!$     endif

!$OMP BARRIER

!$OMP MASTER

             d2=MPI_Wtime()
             dd(2)=dd(2)+(d2-d1)

!
! v=v-(UV+VU)u
!
             d1=MPI_Wtime()
             call tred1_vortho(
     &               u_x(1,k_4), v_x(1,k_4),
     &               u_x(1,1), v_x(1,1), nv,
     &               u_t(1), v_t(1), prod_uv,
     &               i, i_base, m0)
             d2=MPI_Wtime()
             dd(5)=dd(5)+(d2-d1)

!
! v':= v-((u,v)/2|u|^2)u
!
             d1=MPI_Wtime()

             call tred1_v(
     &               u_x(1,k_4), v_x(1,k_4), v_y(1,k_4), nv,
     &               u_t(1), v_t(1), c(1,1), prod_uv, i)

             d2=MPI_Wtime()
             dd(4)=dd(4)+(d2-d1)

!$OMP END MASTER

!$OMP BARRIER

          end do! k_1

!$OMP BARRIER

!$OMP MASTER

          if ( i_base == 0 ) then
             k_1=k_3; k_4=k_1-MBAND+1
             i = k_1

             d1=MPI_Wtime()
!
! w':= w-uv-vu
!
             call tred1_local_2update(
     &               w(1,1), nm,
     &               u_x(1,k_4), u_y(1,k_4),
     &               v_x(1,k_4), v_y(1,k_4), nv,
     &               i_base, i, i)

             d2=MPI_Wtime()
             dd(6)=dd(6)+(d2-d1)
          end if

          call tred1_store(a(1,1), w(1,1), nm,
     &            d_t(1),
     &            m0, i_base)

!$OMP END MASTER

!$OMP BARRIER

!$OMP MASTER

          d1=MPI_Wtime()

!$OMP END MASTER
!
! A:=A-v^Tu-uT^v
!
          if ( i_block > 1 ) then
             call tred1_2update(
     &               a(1,1), nm,
     &               u_x(1,1),u_y(1,1),v_x(1,1),v_y(1,1), nv,
     &               m0, i_base)
          end if

!$OMP BARRIER

!$OMP MASTER

          d2=MPI_Wtime()
          dd(3)=dd(3)+(d2-d1)

!$OMP END MASTER

!$OMP BARRIER

       end do! i_block

!$OMP BARRIER

!$OMP MASTER

       call tred1_final(a(1,1), nm, n, d_out(1), e_out(1), u_t(1))

       if(TRD_inod==1)then
            print*,"calc (u,beta)    ",dd(1)
            print*,"mat-vec (Au)     ",dd(2),dble(n)**3*2d-9/3/dd(2)
            print*,"  COMM1/2        ",t2_reduce1,t2_reduce2
            print*,"2update (A-uv-vu)",dd(3),dble(n)**3*2d-9/3/dd(3)
            print*,"calc v           ",dd(4)
            print*,"v=v-(UV+VU)u     ",dd(5)
            print*,"UV post reduction",dd(6)
       endif
       call flush(6)

!$OMP END MASTER

       return
       end subroutine ! trd_body

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for calculating and printing spectra.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_Spectrum

  use m_Const_Parameters,           only : DP, ON, OFF, CMPLDP, DELTA, &
       &                                   BUCS, Hartree, PAI4
  use m_Control_Parameters,         only : nspin, neg
  use m_Timing,                     only : tstatc0_begin, tstatc0_end
!
!  use m_Parallelization,        only : mype, myrank_e, npes, mpi_comm_group, &
!       &                               ierr, map_e, map_z
  use m_Parallelization
  use m_Files,                      only  : nfout, nf_LR_spectra
  use m_Crystal_Structure,   only : univol, rltv
  use m_Electronic_Structure,    only : eko_ek
  use m_LinearResponse_Control,     only  : e, nmax_G_LR, &
       &                                    vqxyz,  &
       &                                    xc_kernel_type, ALDA_R,  &
       &                                    sw_NLF, & 
       &                                    spectrum_type, &
       &                                    OPTICS, PACS, EELS, IXSS, &
       &                                    e_high
  use m_LinearResponse_Density,     only :  RhoTilde, occup_lkt_ek

!  use m_IterationNumbers,     only : nk_in_the_process, nk_converged
!  use m_PlaneWaveBasisSet,    only : kg1

  use m_LinearResponse_Kernel, only : Kernel_Coulomb, Kernel_XC

  
  use m_LinearResponse_NonInt,  only : Mat_Chi0, &
       &                               nband_LR, band_start_LR, band_end_LR

  
  use m_LinearResponse_ALDA, only : MatrixT
  use m_PlaneWaveBasisSet,    only : ngabc
  use m_LinearResponse_BS,   only : MatL0, MatXi

  Implicit None
!  include 'mpif.h'

  Complex(kind=CMPLDP), allocatable :: Chi_Head(:,:)
  Complex(kind=CMPLDP), allocatable :: MatL(:,:)

contains 

!-------------------------------------------------------------
!!
!!!               Alloc /Dealloc Chi_Head
!!
! ------------------------------------------------------------
  subroutine m_LR_alloc_Chi_Head
    if ( mype == 0 ) then
       allocate( Chi_Head( nspin,nspin )  ); Chi_Head = 0.0d0
    endif
  end subroutine m_LR_alloc_Chi_Head

  subroutine m_LR_dealloc_Chi_Head
    if ( mype == 0 ) deallocate( Chi_Head )
  end subroutine m_LR_dealloc_Chi_Head

!-------------------------------------------------------------
!!
!!!               Alloc /Dealloc Matrix L of BS equation
!!
! ------------------------------------------------------------
  subroutine m_LR_Alloc_MatL
    integer :: matsize
    matsize = nband_LR**2
    if ( mype == 0 ) then
       allocate( MatL( matsize, matsize) ); MatL = 0.0D0
    endif
  end subroutine m_LR_Alloc_MatL

  subroutine m_LR_dealloc_MatL
    if ( mype == 0 ) deallocate( MatL )
  end subroutine m_LR_dealloc_MatL
!---------------------------------------------------------
!!
!!!          Solver for Dyson-like Equation
!!
!----------------------------------------------------------
  subroutine Calc_Chi_Head( ene )
    real(kind=DP), intent(in)  :: ene

    Complex(kind=CMPLDP), allocatable :: MatA( :,: ), TmpVector(:,:)
    integer :: matsize, i, j
    integer :: id_sname = -1
! ---------------------------- start --------
    if ( mype /= 0 ) return

    call tstatc0_begin('Calc_Chi_Head ', id_sname)
    call Alloc_Arrays_For_LinEq

    if ( xc_kernel_type == ALDA_R ) then
       call set_XC_contrib_GatOnida
    else
       call set_XC_contrib_default
    endif

    if ( sw_NLF == OFF ) call add_LF_effects
    if ( spectrum_type /= OPTICS ) call add_hartree_contrib_G0

    call Add_Diagonal_Elements
    call Initial_Guess_VecX
    Call Calc_LinearEq( nspin, matsize, MatA, TmpVector )
    Call Extract_ChiHead
    call Dealloc_Arrays_For_LinEq
!
!    call tstatc0_end(id_sname)
    
  contains

    subroutine Extract_ChiHead
      Chi_Head(1:nspin,1:nspin) = TmpVector(1:nspin,1:nspin)
    end subroutine Extract_ChiHead

    subroutine Alloc_Arrays_For_LinEq
      matsize = nspin *nmax_G_LR
      Allocate( MatA( matsize, matsize ) );   MatA = 0.0d0
      Allocate( TmpVector( matsize,nspin ) ); TmpVector = 0.0d0
    end subroutine Alloc_Arrays_For_LinEq

    subroutine Dealloc_Arrays_For_LinEq
      Deallocate( MatA, TmpVector )
    end subroutine Dealloc_Arrays_For_LinEq

    subroutine Set_XC_Contrib_GatOnida
      integer :: i, j, ni, nj, tmp_i, tmp_j
      Do i=1, nmax_G_LR
         Do j=1, nmax_G_LR
            Do ni=1, nspin
               Do nj=1, nspin
                  tmp_i = ( i-1 )*nspin + ni
                  tmp_j = ( j-1 )*nspin + nj
                  MatA( tmp_i, tmp_j ) = -MatrixT( i,j,ni,nj )
               End do
!               write(*,*) 'Y', i,j,ni,nj, MatA( tmp_i, tmp_j )
            End Do
         End Do
      End Do
!      stop
    end subroutine Set_XC_Contrib_GatOnida

    subroutine set_XC_contrib_default
      integer       :: i, j, k, ni, nj, nk
      integer       :: tmp_i, tmp_j, tmp_k
      complex(kind=CMPLDP) :: d1

      Do i=1, nmax_G_LR
         Do j=1, nmax_G_LR
            Do ni=1, nspin
               Do nj=1, nspin
!
                  d1 = 0.0d0
                  Do k=1, nmax_G_LR
                     Do nk=1, nspin

                        if ( ni == nk ) then
                           tmp_i = (i-1)*nspin + ni
                           tmp_j = (j-1)*nspin + nj
                           tmp_k = (k-1)*nspin + nk
                           d1 = d1 + Mat_Chi0( i,k,ni ) *Kernel_XC( k,j,nk,nj )
                        endif
                     End do
                  End do
                  MatA( tmp_i,tmp_j ) = -d1
!                  write(*,*) 'Y', i,j,ni,nj, MatA( tmp_i, tmp_j )
               End do
            End do
         End do
      End do
!      stop
    end subroutine set_XC_contrib_default

    subroutine add_LF_effects
      integer       :: i, j, ni, nj
      integer       :: tmp_i, tmp_j

      Do i=1, nmax_G_LR
         Do j=2, nmax_G_LR
!            if ( i /= j ) cycle

            Do ni=1, nspin
               Do nj=1, nspin
                  tmp_i = (i-1)*nspin + ni
                  tmp_j = (j-1)*nspin + nj

                  MatA( tmp_i,tmp_j ) = MatA( tmp_i, tmp_j ) &
                       &         - Mat_Chi0( i,j,ni ) *Kernel_Coulomb(j)

!                 write(*,*) tmp_i, tmp_j, Chi0_Full(i,j,ni)
!                 write(*,*) tmp_i, tmp_j, Kernel_Coulomb(j)
               End do
            End do
         End do
      End do
!      stop
    end subroutine add_LF_effects

    subroutine add_hartree_contrib_G0
      integer :: i, j, ni, nj, tmp_i, tmp_j
      Do i=1, nmax_G_LR
         Do j=1, 1
!            if ( i /= j ) cycle

            Do ni=1, nspin
               Do nj=1, nspin
                  tmp_i = (i-1)*nspin + ni
                  tmp_j = (j-1)*nspin + nj
                  MatA( tmp_i,tmp_j ) = MatA( tmp_i,tmp_j ) &
                       &              - Mat_Chi0( i,j,ni ) *Kernel_Coulomb(j)
               End do
            End do
         End do
      End do
    end subroutine add_hartree_contrib_G0

    subroutine Add_Diagonal_Elements
      integer  :: i, ni, tmp_i
      Do i=1, nmax_G_LR
         Do ni=1, nspin
            tmp_i = (i-1)*nspin + ni
            MatA( tmp_i,tmp_i ) = MatA( tmp_i,tmp_i )  +1.0d0
!            write(*,*) 'F ',tmp_i, MatA( tmp_i,tmp_i)
         End do
      End do
!      stop
    end subroutine Add_Diagonal_Elements

    subroutine Initial_Guess_VecX
      integer :: i, j, ni, nj, tmp_i, tmp_j

      TmpVector = 0.0d0
      Do j=1, 1
         Do nj=1, nspin
            Do i=1, nmax_G_LR
               Do ni=1, nspin
                  if ( ni==nj ) then
                     tmp_i = (i-1)*nspin + ni
                     tmp_j = (j-1)*nspin + nj
                     TmpVector(tmp_i,nj) = Mat_Chi0( i,j,ni )
                  endif
               End do
            End do
         End do
      End do
    end subroutine Initial_Guess_VecX

  end subroutine Calc_Chi_Head
  
  subroutine Calc_LinearEq( ncolumn, matsize, MatA, VecX )
    integer, intent(in)                 :: ncolumn, matsize
    complex(kind=CMPLDP), intent(inout) :: MatA( matsize, matsize )
    complex(kind=CMPLDP), intent(inout) :: VecX( matsize, ncolumn )
    
    integer                 ::  kt_info
    integer,    allocatable :: iwork(:)
    integer :: id_sname = -1
    !      
    call tstatc0_begin('Calc_Linear_Equation ', id_sname)
    !
    Allocate( iwork( matsize ) )
    Call ZGESV( matsize, ncolumn, MatA, matsize, iwork, VecX, &
         &      matsize, kt_info )
    if ( kt_info /= 0 ) write(nfout,*) 'kt_info = ', kt_info

    Deallocate( iwork )
    call tstatc0_end(id_sname)
      
  end subroutine Calc_LinearEq

!---------------------------------------------------------
!!
!!!          Limit band indices in consideraiton
!!
!----------------------------------------------------------
 subroutine set_nband_LR
    integer ispin, k, ik1, ib1
    Real(kind=DP) :: width, emin, emax, ebi
    Real(kind=DP) :: occ1, e_homo, e_lumo
    integer :: k_max
! ------------
    k_max = 1
    e_homo = -1.0D+3;   e_lumo= 1.0D+3
! --------------------------
    Do ispin=1, nspin
       Do k=1, k_max
          ik1 = nspin*(k-1) + ispin
          Do ib1=1, neg           ! unoccpuied state
             ebi = Eko_ek( ib1,ik1 )
             occ1 = Occup_lkt_ek( ib1, ik1 );
             if ( occ1 > Delta )  then
                e_homo = max( ebi, e_homo )
             else
                e_lumo = min( ebi, e_lumo )
             endif
          End do
       End do
    End do
! ----------------
!    Do ib1=1, neg
!       write(80+mype,*) ib1, eko_ek( ib1,1 ), occup_lkt_ek( ib1,1 )
!    End do
!    stop
    if ( mype == 0 ) then
       write(nfout,*) '! Highest  occupied level ', e_homo
       write(nfout,*) '! Lowest unoccupied level ', e_lumo
    endif
! ------------------------
    width = e_high
    emin = e_lumo - width; emax = e_homo + width
! --------------------------
    Do ispin=1, nspin
       Do k=1, k_max
          ik1 = nspin*(k-1) + ispin
          Do ib1=1, neg           ! unoccpuied state
             ebi = Eko_ek( ib1,ik1 )
             if ( ebi < emin ) then
                band_start_LR = ib1
             else if ( ebi < emax ) then
                band_end_LR = ib1
             endif
          End do
       End do
    End do
! -------------------- temp --------
!    band_start_LR = 6
!    band_end_LR = 7
! ----------------------------------
    nband_LR = band_end_LR - band_start_LR +1
    if ( mype == 0 ) then
       write(nfout,*) '!* band LR : start, end = ', band_start_LR, band_end_LR
    endif
  end subroutine set_nband_LR

!---------------------------------------------------------
!!
!!!          Solver for BS-like Equation
!!
!----------------------------------------------------------
  subroutine Calc_MatL
    Complex(kind=CMPLDP), allocatable :: MatA(:,:), work(:)
    integer, allocatable :: ipiv(:)
    integer matsize, lwork, info
!
    Complex(kind=CMPLDP) :: ztmp
    integer :: ix1, ix2, ib1, ib2
! ---
    matsize = nband_LR**2
    lwork = matsize
! --
    if ( mype /= 0 ) return

    allocate( MatA(matsize,matsize) ); MatA = 0.0D0
    allocate( ipiv(matsize) ); ipiv = 0
    allocate( work(lwork) ); work = 0.0d0
!
    Do ix1=1, matsize
       ib1 = ( ix1-1 ) /nband_LR +1
       ib2 = mod( ix1-1,nband_LR ) + 1
       ztmp = 0.0D0
       Do ix2=1, matsize
          MatA(ix1,ix2) = -MatL0( ib1,ib2,1 ) *MatXi(ix1,ix2) *dcmplx(0.0D0,1.0D0)
       End do
    End do
    Do ix1=1, matsize
       MatA(ix1,ix1) = MatA(ix1,ix1) + 1.0D0
    End do
!
    Call ZGETRF( matsize, matsize, MatA, matsize, ipiv, info )
    if ( info /= 0 ) write(*,*) 'INFO A2 = ', info
    Call ZGETRI( matsize, MatA, matsize, ipiv, work, lwork, info )
    if ( info /= 0 ) write(*,*) 'INFO B2 = ', info
!
    Do ix1=1,matsize
       Do ix2=1,matsize
          ib1 = ( ix2-1 ) /nband_LR +1
          ib2 = mod( ix2-1,nband_LR ) + 1
          MatL(ix1,ix2) = MatA(ix1,ix2) *MatL0(ib1,ib2,1)
       End do
    End do
    deallocate( ipiv, work )
    deallocate( MatA )

  end subroutine Calc_MatL

  subroutine Calc_Chi_Head_Mol( ene )
    real(kind=DP), intent(in) :: ene

    Complex(kind=CMPLDP) :: ztmp1, ztmp2, z0, z1, z2
    integer ix1, ix2, ib1, ib2, ib3, ib4
    integer ispin
! ---------------
    if ( npes > 1 ) call mpi_barrier( mpi_comm_group,ierr )
! --
    ztmp1 = 0.0D0
    ztmp2 = 0.0D0
    z0 = 0.0D0
    Do ix1=1, nband_LR**2
       ib1 = ( ix1-1 ) /nband_LR +1
       ib2 = mod( ix1-1,nband_LR ) + 1

       if ( mype == 0 ) z0 = MatL0( ib1, ib2, 1 )

       ib1 = ib1 + band_start_LR -1;     ib2 = ib2 + band_start_LR -1

       call set_value_z1
       ztmp1 = ztmp1 -conjg(z1) *z1 *z0 *dcmplx(0.0,1.0)

       Do ix2=1, nband_LR**2
!!!!          if ( ix1 /= ix2 ) cycle

          ib3 = ( ix2-1 ) /nband_LR +1
          ib4 = mod( ix2-1,nband_LR ) + 1
          
          ib3 = ib3 + band_start_LR -1;     ib4 = ib4 + band_start_LR -1

          call set_value_z2
          if ( mype == 0 ) then
             ztmp2 = ztmp2 -z1 *conjg(z2) * MatL( ix1,ix2 ) *dcmplx( 0.0D0, 1.0D0 )
          endif
       End do
    End do
!    if ( mype == 0 ) then
!!       write(91,*) ene*Hartree, aimag(ztmp1) /univol, aimag(ztmp2) /univol
!    endif
!--
    if ( mype == 0 ) then
       Mat_Chi0(1,1,1) = ztmp1 / univol
       Chi_Head(1,1) = ztmp2 / univol
    endif

  contains

    subroutine set_value_z1
      integer :: jb2

      if ( map_e(ib2) == myrank_e ) then
         jb2 = map_z(ib2)
         z1 = RhoTilde( 1, ib1, jb2, 1 )
      endif
      if ( npes > 1 ) then
         call mpi_bcast( z1, 2, MPI_DOUBLE_PRECISION, &
              &          map_e(ib2), mpi_comm_group, ierr )
      endif
    end subroutine set_value_z1

    subroutine set_value_z2
      integer :: jb4

      if ( map_e(ib4) == myrank_e ) then
         jb4 = map_z(ib4)
         z2 = RhoTilde( 1, ib3, jb4, 1 )
      endif
      if ( npes > 1 ) then
         call mpi_bcast( z2, 2, MPI_DOUBLE_PRECISION, &
                  &          map_e(ib4), mpi_comm_group, ierr )
      end if
    end subroutine Set_value_z2

  end subroutine Calc_Chi_Head_Mol
  
! ------------------------------------------------------------
!!
!!!         Output for Spectrum Data
!!
! ------------------------------------------------------------
  subroutine Write_Spectrum_Header
    if ( mype /= 0 ) return

    select case(spectrum_type)
    case (OPTICS)
       write(nf_LR_spectra,'("#",16x," Optical spectrum ")')
       write(nf_LR_spectra,'("#",27x," NonInteracting ",14x, "Interacting")')
       write(nf_LR_spectra,'("#",6x,"Energy[eV]", 8x, "Real",8x,"Imaginary",9x,"Real",8x,"Imaginary")')
    case (PACS)
       write(nf_LR_spectra,'("#",16x," Photo Absorption Cross Section")')
       write(nf_LR_spectra,'("#",6x,"Energy[eV]", 2x," NonInteracting ", 2x, "Interacting")')
    case (EELS)
       write(nf_LR_spectra,'("#",16x," EELS")')
       write(nf_LR_spectra,'("#",6x,"Energy[eV]", 2x," NonInteracting ", 2x, "Interacting")')
    case (IXSS)
       write(nf_LR_spectra,'("#",16x," IXSS")')
       write(nf_LR_spectra,'("#",6x,"Energy[eV]", 2x," NonInteracting ", 2x, "Interacting")')
    end select
    
  end subroutine Write_Spectrum_Header

  subroutine Write_Spectrum_Data( ene )
    real(kind=DP), intent(in) :: ene

    real(kind=DP) :: speed_of_light = 2.99792458d8          ! m/sec
    real(kind=DP) :: au_of_velocity = 2.18769126d6         ! m/sec
    
    integer :: ni, nj, i
    real(kind=DP) :: c1
    real(kind=DP) :: au_of_speed_of_light
    complex(kind=CMPLDP)      :: z0, z1, eps0, eps1
!
    real(kind=DP) :: pot_v0, ttr(6), ga, gb, gc, g2
! --------------------------------- start ------------
    if ( mype /= 0 ) return
    Call getttr (rltv,ttr)
! --------------------------------- main -------------
    pot_v0 = Kernel_Coulomb(1)
! ---------------
    Do i=1, 1
       ga = ngabc(i,1) + vqxyz( 1,1,BUCS )
       gb = ngabc(i,2) + vqxyz( 1,2,BUCS )
       gc = ngabc(i,3) + vqxyz( 1,3,BUCS )
       g2 = ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
              &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga
       c1 = 1.0d0
       pot_v0 = PAI4 / g2 *c1
    End Do
    !
    z0 = 0.0d0;    z1 = 0.0d0
    Do ni=1, nspin
       z0 = z0 + Mat_Chi0(1,1,ni)
    End do
    Do ni=1, nspin
       Do nj=1, nspin
          z1 = z1 + Chi_Head(ni,nj)
       End do
    End do
    eps0 = 1.0d0 - pot_v0 *z0;      eps1 = 1.0d0 - pot_v0 *z1
    
    select case (spectrum_type)
    case (OPTICS)
       write(nf_LR_spectra,'(5F15.6)') ene *Hartree, &
            &                          real(eps0), aimag(eps0), &
            &                          real(eps1), aimag(eps1)
    case (PACS)
       au_of_speed_of_light = speed_of_light/au_of_velocity
       c1 = univol / au_of_speed_of_light
       write(nf_LR_spectra,'(3F15.6)') ene *Hartree, &
            &                          c1 *ene *aimag(eps0), &
            &                          c1 *ene *aimag(eps1)
    case (EELS)
       write(nf_LR_spectra,'(3F15.6)') ene *Hartree, &
            &                          aimag(eps0), &
            &                          aimag(eps1)
    case (IXSS)
       c1 = -2.0d0 *univol
       write(nf_LR_spectra,'(3F15.6)') ene *Hartree, &
            &                          c1 *aimag(z0), &
            &                          c1 *aimag(z1)
    end select
  end subroutine Write_Spectrum_Data

end module m_LinearResponse_Spectrum

      SUBROUTINE MY_PDLASRT( ID, N, D, Q, IQ, JQ, DESCQ, WORK, LWORK, 
     $                    IWORK, LIWORK, INFO )
      use MPI
      use eigen_devel
      use eigen_dc
      implicit NONE
*
!     This routine is a modified routine of PDLASRT
!     which is contained in the ScaLAPACK
!     Modification is done by T.Imamura
*
*     .. Scalar Arguments ..
      CHARACTER          ID
      INTEGER            INFO, IQ, JQ, LIWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            DESCQ( * ), IWORK( * )
      DOUBLE PRECISION   D( * ), Q( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  MY_PDLASRT Sort the numbers in D in increasing order and the
*  corresponding vectors in Q.
*
*  Arguments
*  =========
*
*  ID      (global input) CHARACTER*1
*          = 'I': sort D in increasing order;
*          = 'D': sort D in decreasing order. (NOT IMPLEMENTED YET)
*
*  N       (global input) INTEGER
*          The number of columns to be operated on i.e the number of
*          columns of the distributed submatrix sub( Q ). N >= 0.
*
*  D       (global input/output) DOUBLE PRECISION array, dimmension (N)
*          On exit, the number in D are sorted in increasing order.
*
*  Q       (local input) DOUBLE PRECISION pointer into the local memory
*          to an array of dimension (LLD_Q, LOCc(JQ+N-1) ). This array
*          contains the local pieces of the distributed matrix sub( A )
*          to be copied from.
*
*  IQ      (global input) INTEGER
*          The row index in the global array A indicating the first
*          row of sub( Q ).
*
*  JQ      (global input) INTEGER
*          The column index in the global array A indicating the
*          first column of sub( Q ).
*
*  DESCQ   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix A.
*
*  WORK    (local workspace/local output) DOUBLE PRECISION array,
*          dimension (LWORK)
*  LWORK   (local or global input) INTEGER
*          The dimension of the array WORK.
*          LWORK = MAX( N, NP * ( NB + NQ ))
*          where
*          NP = NUMROC( N, NB, MYROW, IAROW, NPROW ),
*          NQ = NUMROC( N, NB, MYCOL, DESCQ( CSRC_ ), NPCOL )
*
*  IWORK   (local workspace/local output) INTEGER array,
*                                                  dimension (LIWORK)
*
*  LIWORK (local or global input) INTEGER
*          The dimension of the array IWORK.
*          LIWORK = N + 2*NB + 2*NPCOL
*
*  INFO    (global output) INTEGER
*          = 0:  successful exit
*          < 0:  If the i-th argument is an array and the j-entry had
*                an illegal value, then INFO = -(i*100+j), if the i-th
*                argument is a scalar and had an illegal value, then
*                INFO = -i.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
*     ..
*     .. Local Scalars ..
      INTEGER            CL, COL, DUMMY, I, ICTXT, IID, IIQ, INDCOL,
     $                   INDX, INDXC, INDXG, IPQ, IPQ2, IPW, IPWORK, J,
     $                   JJQ, K, L, LDQ, LEND, LIWMIN, LWMIN, MYCOL,
     $                   MYROW, NB, ND, NP, NPCOL, NPROW, NQ, PSQ, QCOL,
     $                   QTOT, SBUF
      INTEGER :: II, IWK_PSQ_MYCOL
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            INDXG2L, INDXG2P, NUMROC
      EXTERNAL           INDXG2L, INDXG2P, LSAME, NUMROC
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, CHK1MAT, PXERBLA, DCOPY,
     $                   DGERV2D, DGESD2D, DLACPY, DLAPST
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, MOD
*     ..
      integer, pointer :: RREQ(:)
      integer          :: IWK_(256)
*     .. Executable Statements ..
*
*       This is just to keep ftnchek and toolpack/1 happy
      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN
*
      IF( N.EQ.0 )
     $   RETURN
*
      CALL BLACS_GRIDINFO( DESCQ( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
*
*     Test the input parameters
*
      INFO = 0
      IF( NPROW.EQ.-1 ) THEN
         INFO = -( 600+CTXT_ )
      ELSE
         CALL CHK1MAT( N, 1, N, 1, IQ, JQ, DESCQ, 6, INFO )
         IF( INFO.EQ.0 ) THEN
            NB = DESCQ( NB_ )
            LDQ = DESCQ( LLD_ )
            NP = NUMROC( N, NB, MYROW, DESCQ( RSRC_ ), NPROW )
            NQ = NUMROC( N, NB, MYCOL, DESCQ( CSRC_ ), NPCOL )
            LWMIN = MAX( N, NP*( NB+NQ ) )
            LIWMIN = N + 2*( NB+NPCOL )
            IF( .NOT.LSAME( ID, 'I' ) ) THEN
               INFO = -1
            ELSE IF( N.LT.0 ) THEN
               INFO = -2
            ELSE IF( LWORK.LT.LWMIN ) THEN
               INFO = -9
            ELSE IF( LIWORK.LT.LIWMIN ) THEN
               INFO = -11
            END IF
         END IF
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( ICTXT, 'MY_PDLASRT', -INFO )
         RETURN
      END IF
*
*     Set Pointers
*
      INDXC = 1
      INDX = INDXC + N
      INDXG = INDX
      INDCOL = INDXG + NB
      QTOT = INDCOL + NB
      PSQ = QTOT + NPCOL
*
      IID = 1
      IPQ2 = 1
      IPW = IPQ2 + NP*NQ
*
      DUMMY = 0
      IIQ = INDXG2L( IQ, NB, DUMMY, DUMMY, NPROW )
*
      allocate ( RREQ(NPCOL) )
*
*     Sort the eigenvalues in D
*
      CALL DLAPST( 'I', N, D, IWORK( INDX ), INFO )
*
!$OMP PARALLEL DO PRIVATE(L)
      DO 10 L = 0, N - 1
         WORK( IID+L ) = D( IWORK( INDX+L ) )
         IWORK( INDXC-1+IWORK( INDX+L ) ) = IID + L
   10 CONTINUE
!$OMP END PARALLEL DO
!      CALL DCOPY( N, WORK, 1, D, 1 )
!$OMP PARALLEL DO
      DO I = 1, N
         D(I) = WORK(I)
      END DO
!$OMP END PARALLEL DO
*
      ND = 0
   20 CONTINUE
      IF( ND.LT.N ) THEN
         LEND = MIN( NB, N-ND )
         J = JQ + ND
         QCOL = INDXG2P( J, NB, DUMMY, DESCQ( CSRC_ ), NPCOL )

         K = 0
         DO 30 L = 0, LEND - 1
            I = JQ - 1 + IWORK( INDXC+ND+L )
            CL = INDXG2P( I, NB, DUMMY, DESCQ( CSRC_ ), NPCOL )
            IWORK( INDCOL+L ) = CL
            IF( MYCOL.EQ.CL ) THEN
               IWORK( INDXG+K ) = IWORK( INDXC+ND+L )
               K = K + 1
            END IF
   30    CONTINUE
*
         IF( MYCOL.EQ.QCOL ) THEN
            DO 40 CL = 0, NPCOL - 1
               IWORK( QTOT+CL ) = 0
   40       CONTINUE
*
            DO 50 L = 0, LEND - 1
               IWORK( QTOT+IWORK( INDCOL+L ) ) = IWORK( QTOT+
     $            IWORK( INDCOL+L ) ) + 1
   50       CONTINUE
*
            IWORK( PSQ ) = 1
            DO 60 CL = 1, NPCOL - 1
               IWORK( PSQ+CL ) = IWORK( PSQ+CL-1 ) + IWORK( QTOT+CL-1 )
   60       CONTINUE
*
            DO L = 0, LEND - 1
               CL = IWORK( INDCOL+L )
               I = IWORK( PSQ+CL )
               IWK_(L+1) = I
               IWORK( PSQ+CL ) = I + 1
            END DO
!$OMP PARALLEL DO PRIVATE(CL,I,JJQ,IPQ,IPWORK)
            DO L = 0, LEND - 1
               CL = IWORK( INDCOL+L )
               I = JQ + ND + L
               JJQ = INDXG2L( I, NB, DUMMY, DUMMY, NPCOL )
               IPQ = IIQ + ( JJQ-1 )*LDQ
               IPWORK = IPW + ( IWK_(L+1)-1 )*NP
               CALL DCOPY( NP, Q( IPQ ), 1, WORK( IPWORK ), 1 )
            END DO
!$OMP END PARALLEL DO
            IWORK( PSQ ) = 1
*
            DO 80 CL = 1, NPCOL - 1
               IWORK( PSQ+CL ) = IWORK( PSQ+CL-1 ) + IWORK( QTOT+CL-1 )
   80       CONTINUE
*
            IWK_PSQ_MYCOL = IWORK( PSQ+MYCOL )
!$OMP PARALLEL DO PRIVATE(I,JJQ,IPQ,IPWORK)
            DO L = 0, K - 1
               I = IWORK( INDXG+L )
               JJQ = INDXG2L( I, NB, DUMMY, DUMMY, NPCOL )
               IPQ = IPQ2 + ( JJQ-1 )*NP
               IPWORK = IPW + ( IWK_PSQ_MYCOL+L-1 )*NP
               CALL DCOPY( NP, WORK( IPWORK ), 1, WORK( IPQ ), 1 )
            END DO
!$OMP END PARALLEL DO
            IWORK( PSQ+MYCOL ) = IWK_PSQ_MYCOL + K
*
            II=0
            DO 100 CL = 1, NPCOL - 1
               COL = MOD( MYCOL+CL, NPCOL )
               SBUF = IWORK( QTOT+COL )
               IF( SBUF.NE.0 ) THEN
                  II = II + 1
                  IPWORK = IPW + ( IWORK( PSQ+COL )-1 )*NP
                  call isend_dbl( WORK( IPWORK ), NP*SBUF,
     $                        COL+1, RREQ(II), y_COMM_WORLD )
               END IF
  100       CONTINUE
            IF ( II > 0 ) call waitall_dbl( II, RREQ )
*
         ELSE
*
            IF( K.NE.0 ) THEN
               call recv_dbl( WORK( IPW ), NP*K,
     $                        QCOL+1, y_COMM_WORLD )
!$OMP PARALLEL DO PRIVATE(L,I,JJQ,IPQ,IPWORK)
               DO 110 L = 0, K - 1
                  I = JQ - 1 + IWORK( INDXG+L )
                  JJQ = INDXG2L( I, NB, DUMMY, DUMMY, NPCOL )
                  IPQ = 1 + ( JJQ-1 )*NP
                  IPWORK = IPW + L*NP
                  CALL DCOPY( NP, WORK( IPWORK ), 1, WORK( IPQ ), 1 )
  110          CONTINUE
!$OMP END PARALLEL DO
            END IF
*
         END IF
         ND = ND + NB
         GO TO 20
      END IF

      CALL DLACPY( 'Full', NP, NQ, WORK, NP, Q( IIQ ), LDQ )
      deallocate ( RREQ )
*
*     End of MY_PDLASRT
*
      END

      SUBROUTINE DLAED4( N, I, D, Z, DELTA, RHO, DLAM, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Oak Ridge National Lab, Argonne National Lab,
*     Courant Institute, NAG Ltd., and Rice University
*     December 23, 1999
*
*     .. Scalar Arguments ..
      INTEGER            I, INFO, N
      DOUBLE PRECISION   DLAM, RHO
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), DELTA( * ), Z( * )
*     ..
*
*  Purpose
*  =======
*
*  This subroutine computes the I-th updated eigenvalue of a symmetric
*  rank-one modification to a diagonal matrix whose elements are
*  given in the array d, and that
*
*             D(i) < D(j)  for  i < j
*
*  and that RHO > 0.  This is arranged by the calling routine, and is
*  no loss in generality.  The rank-one modified system is thus
*
*             diag( D )  +  RHO *  Z * Z_transpose.
*
*  where we assume the Euclidean norm of Z is 1.
*
*  The method consists of approximating the rational functions in the
*  secular equation by simpler interpolating rational functions.
*
*  Arguments
*  =========
*
*  N      (input) INTEGER
*         The length of all arrays.
*
*  I      (input) INTEGER
*         The index of the eigenvalue to be computed.  1 <= I <= N.
*
*  D      (input) DOUBLE PRECISION array, dimension (N)
*         The original eigenvalues.  It is assumed that they are in
*         order, D(I) < D(J)  for I < J.
*
*  Z      (input) DOUBLE PRECISION array, dimension (N)
*         The components of the updating vector.
*
*  DELTA  (output) DOUBLE PRECISION array, dimension (N)
*         If N .ne. 1, DELTA contains (D(j) - lambda_I) in its  j-th
*         component.  If N = 1, then DELTA(1) = 1.  The vector DELTA
*         contains the information necessary to construct the
*         eigenvectors.
*
*  RHO    (input) DOUBLE PRECISION
*         The scalar in the symmetric updating formula.
*
*  DLAM   (output) DOUBLE PRECISION
*         The computed lambda_I, the I-th updated eigenvalue.
*
*  INFO   (output) INTEGER
*         = 0:  successful exit
*         > 0:  if INFO = 1, the updating process failed.
*
*  Internal Parameters
*  ===================
*
*  Logical variable ORGATI (origin-at-i?) is used for distinguishing
*  whether D(i) or D(i+1) is treated as the origin.
*
*            ORGATI = .true.    origin at i
*            ORGATI = .false.   origin at i+1
*
*   Logical variable SWTCH3 (switch-for-3-poles?) is for noting
*   if we are working with THREE poles!
*
*   MAXIT is the maximum number of iterations allowed for each
*   eigenvalue.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ren-Cang Li, Computer Science Division, University of California
*     at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            MAXIT
      PARAMETER          ( MAXIT = 30 )
      DOUBLE PRECISION   ZERO, ONE, TWO, THREE, FOUR, EIGHT, TEN
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0, TWO = 2.0D0,
     $                   THREE = 3.0D0, FOUR = 4.0D0, EIGHT = 8.0D0,
     $                   TEN = 10.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ORGATI, SWTCH, SWTCH3
      INTEGER            II, IIM1, IIP1, IP1, ITER, J, NITER
      DOUBLE PRECISION   A, B, C, DEL, DLTLB, DLTUB, DPHI, DPSI, DW,
     $                   EPS, ERRETM, ETA, MIDPT, PHI, PREW, PSI,
     $                   RHOINV, TAU, TEMP, TEMP1, W, WK
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   ZZ( 3 )
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLAED5, DLAED6
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SQRT
*     ..
!$      REAL(8) ZZZ1(16)
!$      REAL(8) ZZZ2(16)
!$      REAL(8) ZZZ3(16)
!$      REAL(8) ZZZ4(16)
!$      REAL(8) ZZZ5(16)
!$      REAL(8) ZZZ6(16)
!$      REAL(8) ZZZ7(16)
!$      REAL(8) ZZZ8(16)
!$      REAL(8) ZZZ9(16)
!$      REAL(8) ZZZ10(16)
!$      INTEGER, EXTERNAL :: OMP_GET_NUM_THREADS
!$      INTEGER, EXTERNAL :: OMP_GET_THREAD_NUM
*     .. Executable Statements ..
*
*     Since this routine is called in an inner loop, we do no argument
*     checking.
*
*     Quick return for N=1 and 2.
*
      INFO = 0
      IF( N.EQ.1 ) THEN
*
*         Presumably, I=1 upon entry
*
         DLAM = D( 1 ) + RHO*Z( 1 )*Z( 1 )
         DELTA( 1 ) = ONE
         RETURN
      END IF
      IF( N.EQ.2 ) THEN
         CALL DLAED5( I, D, Z, DELTA, RHO, DLAM )
         RETURN
      END IF
*
*     Compute machine epsilon
*
      EPS = DLAMCH( 'Epsilon' )
      RHOINV = ONE / RHO
*
*     The case I = N
*
      IF( I.EQ.N ) THEN
*
*        Initialize some basic variables
*
         II = N - 1
         NITER = 1
*
*        Calculate initial guess
*
         MIDPT = RHO / TWO
*
*        If ||Z||_2 is not one, then TEMP should be set to
*        RHO * ||Z||_2^2 / TWO
*
!$OMP PARALLEL DO
         DO 10 J = 1, N
            DELTA( J ) = ( D( J )-D( I ) )
   10    CONTINUE
!$OMP END PARALLEL DO
         call MM_PREFETCH(DELTA(1),1)
!$OMP PARALLEL DO
         DO 11 J = 1, N
            DELTA( J ) = DELTA( J ) - MIDPT
   11    CONTINUE
!$OMP END PARALLEL DO
*
         PSI = ZERO
!$    ZZZ1(1)=PSI
!$OMP PARALLEL PRIVATE(PSI)
!$    PSI=0.0D+00
!$OMP MASTER
!$    PSI=ZZZ1(1)
!$OMP END MASTER
!$OMP DO
         DO 20 J = 1, N - 2
            PSI = PSI + Z( J )*Z( J ) / DELTA( J )
   20    CONTINUE
!$OMP ENDDO
!$    ZZZ1(OMP_GET_THREAD_NUM()+1)=PSI
!$OMP BARRIER
!$OMP MASTER
!$    PSI=0.0D+00
!$    DO J__=1,OMP_GET_NUM_THREADS()
!$     PSI=PSI+ZZZ1(J__)
!$    ENDDO
!$     ZZZ1(1)=PSI
!$OMP END MASTER
!$OMP END PARALLEL
!$     PSI=ZZZ1(1)
*
         C = RHOINV + PSI
         W = C + Z( II )*Z( II ) / DELTA( II ) +
     $       Z( N )*Z( N ) / DELTA( N )
*
         IF( W.LE.ZERO ) THEN
            TEMP = Z( N-1 )*Z( N-1 ) / ( D( N )-D( N-1 )+RHO ) +
     $             Z( N )*Z( N ) / RHO
            IF( C.LE.TEMP ) THEN
               TAU = RHO
            ELSE
               DEL = D( N ) - D( N-1 )
               A = -C*DEL + Z( N-1 )*Z( N-1 ) + Z( N )*Z( N )
               B = Z( N )*Z( N )*DEL
               IF( A.LT.ZERO ) THEN
                  TAU = TWO*B / ( SQRT( A*A+FOUR*B*C )-A )
               ELSE
                  TAU = ( A+SQRT( A*A+FOUR*B*C ) ) / ( TWO*C )
               END IF
            END IF
*
*           It can be proved that
*               D(N)+RHO/2 <= LAMBDA(N) < D(N)+TAU <= D(N)+RHO
*
            DLTLB = MIDPT
            DLTUB = RHO
         ELSE
            DEL = D( N ) - D( N-1 )
            A = -C*DEL + Z( N-1 )*Z( N-1 ) + Z( N )*Z( N )
            B = Z( N )*Z( N )*DEL
            IF( A.LT.ZERO ) THEN
               TAU = TWO*B / ( SQRT( A*A+FOUR*B*C )-A )
            ELSE
               TAU = ( A+SQRT( A*A+FOUR*B*C ) ) / ( TWO*C )
            END IF
*
*           It can be proved that
*               D(N) < D(N)+TAU < LAMBDA(N) < D(N)+RHO/2
*
            DLTLB = ZERO
            DLTUB = MIDPT
         END IF
*
!$OMP PARALLEL DO
         DO 30 J = 1, N
            DELTA( J ) = ( D( J )-D( I ) )
   30    CONTINUE
!$OMP END PARALLEL DO
         call MM_PREFETCH(DELTA(1),1)
!$OMP PARALLEL DO
         DO 31 J = 1, N
            DELTA( J ) = DELTA( J ) - TAU
   31    CONTINUE
!$OMP END PARALLEL DO
*
*        Evaluate PSI and the derivative DPSI
*
         DPSI = ZERO
         PSI = ZERO
         ERRETM = ZERO
!$    ZZZ1(1)=PSI
!$    ZZZ2(1)=DPSI
!$    ZZZ3(1)=ERRETM
!$OMP PARALLEL PRIVATE(TEMP,WK,PSI,DPSI,ERRETM)
!$    PSI=0.0D+00
!$OMP MASTER
!$    PSI=ZZZ1(1)
!$OMP END MASTER
!$    DPSI=0.0D+00
!$OMP MASTER
!$    DPSI=ZZZ2(1)
!$OMP END MASTER
!$    ERRETM=0.0D+00
!$OMP MASTER
!$    ERRETM=ZZZ3(1)
!$OMP END MASTER
!$OMP DO
         DO 40 J = 1, II
            TEMP = Z( J ) / DELTA( J )
            WK = Z( J )*TEMP
            PSI = PSI + WK
            DPSI = DPSI + TEMP*TEMP
            ERRETM = ERRETM + WK*(II+1-J)
   40    CONTINUE
!$OMP ENDDO
!$    ZZZ1(OMP_GET_THREAD_NUM()+1)=PSI
!$    ZZZ2(OMP_GET_THREAD_NUM()+1)=DPSI
!$    ZZZ3(OMP_GET_THREAD_NUM()+1)=ERRETM
!$OMP BARRIER
!$OMP MASTER
!$    PSI=0.0D+00
!$    DPSI=0.0D+00
!$    ERRETM=0.0D+00
!$    DO J__=1,OMP_GET_NUM_THREADS()
!$     PSI=PSI+ZZZ1(J__)
!$     DPSI=DPSI+ZZZ2(J__)
!$     ERRETM=ERRETM+ZZZ3(J__)
!$    ENDDO
!$     ZZZ1(1)=PSI
!$     ZZZ2(1)=DPSI
!$     ZZZ3(1)=ERRETM
!$OMP END MASTER
!$OMP END PARALLEL
!$     PSI=ZZZ1(1)
!$     DPSI=ZZZ2(1)
!$     ERRETM=ZZZ3(1)
         ERRETM = ABS( ERRETM )
*
*        Evaluate PHI and the derivative DPHI
*
         TEMP = Z( N ) / DELTA( N )
         PHI = Z( N )*TEMP
         DPHI = TEMP*TEMP
         ERRETM = EIGHT*( -PHI-PSI ) + ERRETM - PHI + RHOINV +
     $            ABS( TAU )*( DPSI+DPHI )
*
         W = RHOINV + PHI + PSI
*
*        Test for convergence
*
         IF( ABS( W ).LE.EPS*ERRETM ) THEN
            DLAM = D( I ) + TAU
            GO TO 250
         END IF
*
         IF( W.LE.ZERO ) THEN
            DLTLB = MAX( DLTLB, TAU )
         ELSE
            DLTUB = MIN( DLTUB, TAU )
         END IF
*
*        Calculate the new step
*
         NITER = NITER + 1
         C = W - DELTA( N-1 )*DPSI - DELTA( N )*DPHI
         A = ( DELTA( N-1 )+DELTA( N ) )*W -
     $       DELTA( N-1 )*DELTA( N )*( DPSI+DPHI )
         B = DELTA( N-1 )*DELTA( N )*W
         IF( C.LT.ZERO )
     $      C = ABS( C )
         IF( C.EQ.ZERO ) THEN
*          ETA = B/A
*           ETA = RHO - TAU
            ETA = DLTUB - TAU
         ELSE IF( A.GE.ZERO ) THEN
            ETA = ( A+SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
         ELSE
            ETA = TWO*B / ( A-SQRT( ABS( A*A-FOUR*B*C ) ) )
         END IF
*
*        Note, eta should be positive if w is negative, and
*        eta should be negative otherwise. However,
*        if for some reason caused by roundoff, eta*w > 0,
*        we simply use one Newton step instead. This way
*        will guarantee eta*w < 0.
*
         IF( W*ETA.GT.ZERO )
     $      ETA = -W / ( DPSI+DPHI )
         TEMP = TAU + ETA
         IF( TEMP.GT.DLTUB .OR. TEMP.LT.DLTLB ) THEN
            IF( W.LT.ZERO ) THEN
               ETA = ( DLTUB-TAU ) / TWO
            ELSE
               ETA = ( DLTLB-TAU ) / TWO
            END IF
         END IF
!$OMP PARALLEL DO
         DO 50 J = 1, N
            DELTA( J ) = DELTA( J ) - ETA
   50    CONTINUE
!$OMP END PARALLEL DO
*
         TAU = TAU + ETA
*
*        Evaluate PSI and the derivative DPSI
*
         DPSI = ZERO
         PSI = ZERO
         ERRETM = ZERO
!$    ZZZ1(1)=PSI
!$    ZZZ2(1)=DPSI
!$    ZZZ3(1)=ERRETM
!$OMP PARALLEL PRIVATE(TEMP,WK,PSI,DPSI,ERRETM)
!$    PSI=0.0D+00
!$OMP MASTER
!$    PSI=ZZZ1(1)
!$OMP END MASTER
!$    DPSI=0.0D+00
!$OMP MASTER
!$    DPSI=ZZZ2(1)
!$OMP END MASTER
!$    ERRETM=0.0D+00
!$OMP MASTER
!$    ERRETM=ZZZ3(1)
!$OMP END MASTER
!$OMP DO
         DO 60 J = 1, II
            TEMP = Z( J ) / DELTA( J )
            WK = Z( J )*TEMP
            PSI = PSI + WK
            DPSI = DPSI + TEMP*TEMP
            ERRETM = ERRETM + WK*(II+1-J)
   60    CONTINUE
!$OMP ENDDO
!$    ZZZ1(OMP_GET_THREAD_NUM()+1)=PSI
!$    ZZZ2(OMP_GET_THREAD_NUM()+1)=DPSI
!$    ZZZ3(OMP_GET_THREAD_NUM()+1)=ERRETM
!$OMP BARRIER
!$OMP MASTER
!$    PSI=0.0D+00
!$    DPSI=0.0D+00
!$    ERRETM=0.0D+00
!$    DO J__=1,OMP_GET_NUM_THREADS()
!$     PSI=PSI+ZZZ1(J__)
!$     DPSI=DPSI+ZZZ2(J__)
!$     ERRETM=ERRETM+ZZZ3(J__)
!$    ENDDO
!$     ZZZ1(1)=PSI
!$     ZZZ2(1)=DPSI
!$     ZZZ3(1)=ERRETM
!$OMP END MASTER
!$OMP END PARALLEL
!$     PSI=ZZZ1(1)
!$     DPSI=ZZZ2(1)
!$     ERRETM=ZZZ3(1)
         ERRETM = ABS( ERRETM )
*
*        Evaluate PHI and the derivative DPHI
*
         TEMP = Z( N ) / DELTA( N )
         PHI = Z( N )*TEMP
         DPHI = TEMP*TEMP
         ERRETM = EIGHT*( -PHI-PSI ) + ERRETM - PHI + RHOINV +
     $            ABS( TAU )*( DPSI+DPHI )
*
         W = RHOINV + PHI + PSI
*
*        Main loop to update the values of the array   DELTA
*
         ITER = NITER + 1
*
         DO 90 NITER = ITER, MAXIT
*
*           Test for convergence
*
            IF( ABS( W ).LE.EPS*ERRETM ) THEN
               DLAM = D( I ) + TAU
               GO TO 250
            END IF
*
            IF( W.LE.ZERO ) THEN
               DLTLB = MAX( DLTLB, TAU )
            ELSE
               DLTUB = MIN( DLTUB, TAU )
            END IF
*
*           Calculate the new step
*
            C = W - DELTA( N-1 )*DPSI - DELTA( N )*DPHI
            A = ( DELTA( N-1 )+DELTA( N ) )*W -
     $          DELTA( N-1 )*DELTA( N )*( DPSI+DPHI )
            B = DELTA( N-1 )*DELTA( N )*W
            IF( A.GE.ZERO ) THEN
               ETA = ( A+SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
            ELSE
               ETA = TWO*B / ( A-SQRT( ABS( A*A-FOUR*B*C ) ) )
            END IF
*
*           Note, eta should be positive if w is negative, and
*           eta should be negative otherwise. However,
*           if for some reason caused by roundoff, eta*w > 0,
*           we simply use one Newton step instead. This way
*           will guarantee eta*w < 0.
*
            IF( W*ETA.GT.ZERO )
     $         ETA = -W / ( DPSI+DPHI )
            TEMP = TAU + ETA
            IF( TEMP.GT.DLTUB .OR. TEMP.LT.DLTLB ) THEN
               IF( W.LT.ZERO ) THEN
                  ETA = ( DLTUB-TAU ) / TWO
               ELSE
                  ETA = ( DLTLB-TAU ) / TWO
               END IF
            END IF
!$OMP PARALLEL DO
            DO 70 J = 1, N
               DELTA( J ) = DELTA( J ) - ETA
   70       CONTINUE
!$OMP END PARALLEL DO
*
            TAU = TAU + ETA
*
*           Evaluate PSI and the derivative DPSI
*
            DPSI = ZERO
            PSI = ZERO
            ERRETM = ZERO
!$    ZZZ1(1)=PSI
!$    ZZZ2(1)=DPSI
!$    ZZZ3(1)=ERRETM
!$OMP PARALLEL PRIVATE(TEMP,WK,PSI,DPSI,ERRETM)
!$    PSI=0.0D+00
!$OMP MASTER
!$    PSI=ZZZ1(1)
!$OMP END MASTER
!$    DPSI=0.0D+00
!$OMP MASTER
!$    DPSI=ZZZ2(1)
!$OMP END MASTER
!$    ERRETM=0.0D+00
!$OMP MASTER
!$    ERRETM=ZZZ3(1)
!$OMP END MASTER
!$OMP DO
            DO 80 J = 1, II
               TEMP = Z( J ) / DELTA( J )
               WK = Z( J )*TEMP
               PSI = PSI + WK
               DPSI = DPSI + TEMP*TEMP
               ERRETM = ERRETM + WK*(II+1-J)
   80       CONTINUE
!$OMP ENDDO
!$    ZZZ1(OMP_GET_THREAD_NUM()+1)=PSI
!$    ZZZ2(OMP_GET_THREAD_NUM()+1)=DPSI
!$    ZZZ3(OMP_GET_THREAD_NUM()+1)=ERRETM
!$OMP BARRIER
!$OMP MASTER
!$    PSI=0.0D+00
!$    DPSI=0.0D+00
!$    ERRETM=0.0D+00
!$    DO J__=1,OMP_GET_NUM_THREADS()
!$     PSI=PSI+ZZZ1(J__)
!$     DPSI=DPSI+ZZZ2(J__)
!$     ERRETM=ERRETM+ZZZ3(J__)
!$    ENDDO
!$     ZZZ1(1)=PSI
!$     ZZZ2(1)=DPSI
!$     ZZZ3(1)=ERRETM
!$OMP END MASTER
!$OMP END PARALLEL
!$     PSI=ZZZ1(1)
!$     DPSI=ZZZ2(1)
!$     ERRETM=ZZZ3(1)
            ERRETM = ABS( ERRETM )
*
*           Evaluate PHI and the derivative DPHI
*
            TEMP = Z( N ) / DELTA( N )
            PHI = Z( N )*TEMP
            DPHI = TEMP*TEMP
            ERRETM = EIGHT*( -PHI-PSI ) + ERRETM - PHI + RHOINV +
     $               ABS( TAU )*( DPSI+DPHI )
*
            W = RHOINV + PHI + PSI
   90    CONTINUE
*
*        Return with INFO = 1, NITER = MAXIT and not converged
*
         INFO = 1
         DLAM = D( I ) + TAU
         GO TO 250
*
*        End for the case I = N
*
      ELSE
*
*        The case for I < N
*
         NITER = 1
         IP1 = I + 1
*
*        Calculate initial guess
*
         DEL = D( IP1 ) - D( I )
         MIDPT = DEL / TWO
!$OMP PARALLEL DO
         DO 100 J = 1, N
            DELTA( J ) = ( D( J )-D( I ) )
  100    CONTINUE
!$OMP END PARALLEL DO
         CALL MM_PREFETCH(DELTA(1),1)
!$OMP PARALLEL DO
         DO 101 J = 1, N
            DELTA( J ) = DELTA( J ) - MIDPT
  101    CONTINUE
!$OMP END PARALLEL DO
*
         PSI = ZERO
!$    ZZZ1(1)=PSI
!$OMP PARALLEL PRIVATE(PSI)
!$    PSI=0.0D+00
!$OMP MASTER
!$    PSI=ZZZ1(1)
!$OMP END MASTER
!$OMP DO
         DO 110 J = 1, I - 1
            PSI = PSI + Z( J )*Z( J ) / DELTA( J )
  110    CONTINUE
!$OMP ENDDO
!$    ZZZ1(OMP_GET_THREAD_NUM()+1)=PSI
!$OMP BARRIER
!$OMP MASTER
!$    PSI=0.0D+00
!$    DO J__=1,OMP_GET_NUM_THREADS()
!$     PSI=PSI+ZZZ1(J__)
!$    ENDDO
!$     ZZZ1(1)=PSI
!$OMP END MASTER
!$OMP END PARALLEL
!$     PSI=ZZZ1(1)
*
         PHI = ZERO
!$    ZZZ1(1)=PHI
!$OMP PARALLEL PRIVATE(PHI)
!$    PHI=0.0D+00
!$OMP MASTER
!$    PHI=ZZZ1(1)
!$OMP END MASTER
!$OMP DO
         DO 120 J = N, I + 2, -1
            PHI = PHI + Z( J )*Z( J ) / DELTA( J )
  120    CONTINUE
!$OMP ENDDO
!$    ZZZ1(OMP_GET_THREAD_NUM()+1)=PHI
!$OMP BARRIER
!$OMP MASTER
!$    PHI=0.0D+00
!$    DO J__=1,OMP_GET_NUM_THREADS()
!$     PHI=PHI+ZZZ1(J__)
!$    ENDDO
!$     ZZZ1(1)=PHI
!$OMP END MASTER
!$OMP END PARALLEL
!$     PHI=ZZZ1(1)
         C = RHOINV + PSI + PHI
         W = C + Z( I )*Z( I ) / DELTA( I ) +
     $       Z( IP1 )*Z( IP1 ) / DELTA( IP1 )
*
         IF( W.GT.ZERO ) THEN
*
*           d(i)< the ith eigenvalue < (d(i)+d(i+1))/2
*
*           We choose d(i) as origin.
*
            ORGATI = .TRUE.
            A = C*DEL + Z( I )*Z( I ) + Z( IP1 )*Z( IP1 )
            B = Z( I )*Z( I )*DEL
            IF( A.GT.ZERO ) THEN
               TAU = TWO*B / ( A+SQRT( ABS( A*A-FOUR*B*C ) ) )
            ELSE
               TAU = ( A-SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
            END IF
            DLTLB = ZERO
            DLTUB = MIDPT
         ELSE
*
*           (d(i)+d(i+1))/2 <= the ith eigenvalue < d(i+1)
*
*           We choose d(i+1) as origin.
*
            ORGATI = .FALSE.
            A = C*DEL - Z( I )*Z( I ) - Z( IP1 )*Z( IP1 )
            B = Z( IP1 )*Z( IP1 )*DEL
            IF( A.LT.ZERO ) THEN
               TAU = TWO*B / ( A-SQRT( ABS( A*A+FOUR*B*C ) ) )
            ELSE
               TAU = -( A+SQRT( ABS( A*A+FOUR*B*C ) ) ) / ( TWO*C )
            END IF
            DLTLB = -MIDPT
            DLTUB = ZERO
         END IF
*
         IF( ORGATI ) THEN
!$OMP PARALLEL DO
            DO 130 J = 1, N
               DELTA( J ) = ( D( J )-D( I ) )
  130       CONTINUE
!$OMP END PARALLEL DO
         CALL MM_PREFETCH(DELTA(1),1)
!$OMP PARALLEL DO
            DO 131 J = 1, N
               DELTA( J ) = DELTA( J ) - TAU
  131       CONTINUE
!$OMP END PARALLEL DO
         ELSE
!$OMP PARALLEL DO
            DO 140 J = 1, N
               DELTA( J ) = ( D( J )-D( IP1 ) )
  140       CONTINUE
!$OMP END PARALLEL DO
         CALL MM_PREFETCH(DELTA(1),1)
!$OMP PARALLEL DO
            DO 141 J = 1, N
               DELTA( J ) = DELTA( J ) - TAU
  141       CONTINUE
!$OMP END PARALLEL DO
         END IF
         IF( ORGATI ) THEN
            II = I
         ELSE
            II = I + 1
         END IF
         IIM1 = II - 1
         IIP1 = II + 1
*
*        Evaluate PSI and the derivative DPSI
*
         DPSI = ZERO
         PSI = ZERO
         ERRETM = ZERO
!$    ZZZ1(1)=PSI
!$    ZZZ2(1)=DPSI
!$    ZZZ3(1)=ERRETM
!$OMP PARALLEL PRIVATE(TEMP,WK,PSI,DPSI,ERRETM)
!$    PSI=0.0D+00
!$OMP MASTER
!$    PSI=ZZZ1(1)
!$OMP END MASTER
!$    DPSI=0.0D+00
!$OMP MASTER
!$    DPSI=ZZZ2(1)
!$OMP END MASTER
!$    ERRETM=0.0D+00
!$OMP MASTER
!$    ERRETM=ZZZ3(1)
!$OMP END MASTER
!$OMP DO
         DO 150 J = 1, IIM1
            TEMP = Z( J ) / DELTA( J )
            WK = Z( J )*TEMP
            PSI = PSI + WK
            DPSI = DPSI + TEMP*TEMP
            ERRETM = ERRETM + WK*(IIM1+1-J)
  150    CONTINUE
!$OMP ENDDO
!$    ZZZ1(OMP_GET_THREAD_NUM()+1)=PSI
!$    ZZZ2(OMP_GET_THREAD_NUM()+1)=DPSI
!$    ZZZ3(OMP_GET_THREAD_NUM()+1)=ERRETM
!$OMP BARRIER
!$OMP MASTER
!$    PSI=0.0D+00
!$    DPSI=0.0D+00
!$    ERRETM=0.0D+00
!$    DO J__=1,OMP_GET_NUM_THREADS()
!$     PSI=PSI+ZZZ1(J__)
!$     DPSI=DPSI+ZZZ2(J__)
!$     ERRETM=ERRETM+ZZZ3(J__)
!$    ENDDO
!$     ZZZ1(1)=PSI
!$     ZZZ2(1)=DPSI
!$     ZZZ3(1)=ERRETM
!$OMP END MASTER
!$OMP END PARALLEL
!$     PSI=ZZZ1(1)
!$     DPSI=ZZZ2(1)
!$     ERRETM=ZZZ3(1)
         ERRETM = ABS( ERRETM )
*
*        Evaluate PHI and the derivative DPHI
*
         DPHI = ZERO
         PHI = ZERO
!$    ZZZ1(1)=PHI
!$    ZZZ2(1)=DPHI
!$    ZZZ3(1)=ERRETM
!$OMP PARALLEL PRIVATE(TEMP,WK,PHI,DPHI,ERRETM)
!$    PHI=0.0D+00
!$OMP MASTER
!$    PHI=ZZZ1(1)
!$OMP END MASTER
!$    DPHI=0.0D+00
!$OMP MASTER
!$    DPHI=ZZZ2(1)
!$OMP END MASTER
!$    ERRETM=0.0D+00
!$OMP MASTER
!$    ERRETM=ZZZ3(1)
!$OMP END MASTER
!$OMP DO
         DO 160 J = N, IIP1, -1
            TEMP = Z( J ) / DELTA( J )
            WK = Z( J )*TEMP
            PHI = PHI + WK
            DPHI = DPHI + TEMP*TEMP
            ERRETM = ERRETM + WK*(J+1-IIP1)
  160    CONTINUE
!$OMP ENDDO
!$    ZZZ1(OMP_GET_THREAD_NUM()+1)=PHI
!$    ZZZ2(OMP_GET_THREAD_NUM()+1)=DPHI
!$    ZZZ3(OMP_GET_THREAD_NUM()+1)=ERRETM
!$OMP BARRIER
!$OMP MASTER
!$    PHI=0.0D+00
!$    DPHI=0.0D+00
!$    ERRETM=0.0D+00
!$    DO J__=1,OMP_GET_NUM_THREADS()
!$     PHI=PHI+ZZZ1(J__)
!$     DPHI=DPHI+ZZZ2(J__)
!$     ERRETM=ERRETM+ZZZ3(J__)
!$    ENDDO
!$     ZZZ1(1)=PHI
!$     ZZZ2(1)=DPHI
!$     ZZZ3(1)=ERRETM
!$OMP END MASTER
!$OMP END PARALLEL
!$     PHI=ZZZ1(1)
!$     DPHI=ZZZ2(1)
!$     ERRETM=ZZZ3(1)
*
         W = RHOINV + PHI + PSI
*
*        W is the value of the secular function with
*        its ii-th element removed.
*
         SWTCH3 = .FALSE.
         IF( ORGATI ) THEN
            IF( W.LT.ZERO )
     $         SWTCH3 = .TRUE.
         ELSE
            IF( W.GT.ZERO )
     $         SWTCH3 = .TRUE.
         END IF
         IF( II.EQ.1 .OR. II.EQ.N )
     $      SWTCH3 = .FALSE.
*
         TEMP = Z( II ) / DELTA( II )
         DW = DPSI + DPHI + TEMP*TEMP
         TEMP = Z( II )*TEMP
         W = W + TEMP
         ERRETM = EIGHT*( PHI-PSI ) + ERRETM + TWO*RHOINV +
     $            THREE*ABS( TEMP ) + ABS( TAU )*DW
*
*        Test for convergence
*
         IF( ABS( W ).LE.EPS*ERRETM ) THEN
            IF( ORGATI ) THEN
               DLAM = D( I ) + TAU
            ELSE
               DLAM = D( IP1 ) + TAU
            END IF
            GO TO 250
         END IF
*
         IF( W.LE.ZERO ) THEN
            DLTLB = MAX( DLTLB, TAU )
         ELSE
            DLTUB = MIN( DLTUB, TAU )
         END IF
*
*        Calculate the new step
*
         NITER = NITER + 1
         IF( .NOT.SWTCH3 ) THEN
            IF( ORGATI ) THEN
               C = W - DELTA( IP1 )*DW - ( D( I )-D( IP1 ) )*
     $             ( Z( I ) / DELTA( I ) )**2
            ELSE
               C = W - DELTA( I )*DW - ( D( IP1 )-D( I ) )*
     $             ( Z( IP1 ) / DELTA( IP1 ) )**2
            END IF
            A = ( DELTA( I )+DELTA( IP1 ) )*W -
     $          DELTA( I )*DELTA( IP1 )*DW
            B = DELTA( I )*DELTA( IP1 )*W
            IF( C.EQ.ZERO ) THEN
               IF( A.EQ.ZERO ) THEN
                  IF( ORGATI ) THEN
                     A = Z( I )*Z( I ) + DELTA( IP1 )*DELTA( IP1 )*
     $                   ( DPSI+DPHI )
                  ELSE
                     A = Z( IP1 )*Z( IP1 ) + DELTA( I )*DELTA( I )*
     $                   ( DPSI+DPHI )
                  END IF
               END IF
               ETA = B / A
            ELSE IF( A.LE.ZERO ) THEN
               ETA = ( A-SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
            ELSE
               ETA = TWO*B / ( A+SQRT( ABS( A*A-FOUR*B*C ) ) )
            END IF
         ELSE
*
*           Interpolation using THREE most relevant poles
*
            TEMP = RHOINV + PSI + PHI
            IF( ORGATI ) THEN
               TEMP1 = Z( IIM1 ) / DELTA( IIM1 )
               TEMP1 = TEMP1*TEMP1
               C = TEMP - DELTA( IIP1 )*( DPSI+DPHI ) -
     $             ( D( IIM1 )-D( IIP1 ) )*TEMP1
               ZZ( 1 ) = Z( IIM1 )*Z( IIM1 )
               ZZ( 3 ) = DELTA( IIP1 )*DELTA( IIP1 )*
     $                   ( ( DPSI-TEMP1 )+DPHI )
            ELSE
               TEMP1 = Z( IIP1 ) / DELTA( IIP1 )
               TEMP1 = TEMP1*TEMP1
               C = TEMP - DELTA( IIM1 )*( DPSI+DPHI ) -
     $             ( D( IIP1 )-D( IIM1 ) )*TEMP1
               ZZ( 1 ) = DELTA( IIM1 )*DELTA( IIM1 )*
     $                   ( DPSI+( DPHI-TEMP1 ) )
               ZZ( 3 ) = Z( IIP1 )*Z( IIP1 )
            END IF
            ZZ( 2 ) = Z( II )*Z( II )
            CALL DLAED6( NITER, ORGATI, C, DELTA( IIM1 ), ZZ, W, ETA,
     $                   INFO )
            IF( INFO.NE.0 )
     $         GO TO 250
         END IF
*
*        Note, eta should be positive if w is negative, and
*        eta should be negative otherwise. However,
*        if for some reason caused by roundoff, eta*w > 0,
*        we simply use one Newton step instead. This way
*        will guarantee eta*w < 0.
*
         IF( W*ETA.GE.ZERO )
     $      ETA = -W / DW
         TEMP = TAU + ETA
         IF( TEMP.GT.DLTUB .OR. TEMP.LT.DLTLB ) THEN
            IF( W.LT.ZERO ) THEN
               ETA = ( DLTUB-TAU ) / TWO
            ELSE
               ETA = ( DLTLB-TAU ) / TWO
            END IF
         END IF
*
         PREW = W
*
  170    CONTINUE
!$OMP PARALLEL DO
         DO 180 J = 1, N
            DELTA( J ) = DELTA( J ) - ETA
  180    CONTINUE
!$OMP END PARALLEL DO
*
*        Evaluate PSI and the derivative DPSI
*
         DPSI = ZERO
         PSI = ZERO
         ERRETM = ZERO
!$    ZZZ1(1)=PSI
!$    ZZZ2(1)=DPSI
!$    ZZZ3(1)=ERRETM
!$OMP PARALLEL PRIVATE(TEMP,WK,PSI,DPSI,ERRETM)
!$    PSI=0.0D+00
!$OMP MASTER
!$    PSI=ZZZ1(1)
!$OMP END MASTER
!$    DPSI=0.0D+00
!$OMP MASTER
!$    DPSI=ZZZ2(1)
!$OMP END MASTER
!$    ERRETM=0.0D+00
!$OMP MASTER
!$    ERRETM=ZZZ3(1)
!$OMP END MASTER
!$OMP DO
         DO 190 J = 1, IIM1
            TEMP = Z( J ) / DELTA( J )
            WK = Z( J )*TEMP
            PSI = PSI + WK
            DPSI = DPSI + TEMP*TEMP
            ERRETM = ERRETM + WK*(IIM1+1-J)
  190    CONTINUE
!$OMP ENDDO
!$    ZZZ1(OMP_GET_THREAD_NUM()+1)=PSI
!$    ZZZ2(OMP_GET_THREAD_NUM()+1)=DPSI
!$    ZZZ3(OMP_GET_THREAD_NUM()+1)=ERRETM
!$OMP BARRIER
!$OMP MASTER
!$    PSI=0.0D+00
!$    DPSI=0.0D+00
!$    ERRETM=0.0D+00
!$    DO J__=1,OMP_GET_NUM_THREADS()
!$     PSI=PSI+ZZZ1(J__)
!$     DPSI=DPSI+ZZZ2(J__)
!$     ERRETM=ERRETM+ZZZ3(J__)
!$    ENDDO
!$     ZZZ1(1)=PSI
!$     ZZZ2(1)=DPSI
!$     ZZZ3(1)=ERRETM
!$OMP END MASTER
!$OMP END PARALLEL
!$     PSI=ZZZ1(1)
!$     DPSI=ZZZ2(1)
!$     ERRETM=ZZZ3(1)
         ERRETM = ABS( ERRETM )
*
*        Evaluate PHI and the derivative DPHI
*
         DPHI = ZERO
         PHI = ZERO
!$    ZZZ1(1)=PHI
!$    ZZZ2(1)=DPHI
!$    ZZZ3(1)=ERRETM
!$OMP PARALLEL PRIVATE(TEMP,WK,PHI,DPHI,ERRETM)
!$    PHI=0.0D+00
!$OMP MASTER
!$    PHI=ZZZ1(1)
!$OMP END MASTER
!$    DPHI=0.0D+00
!$OMP MASTER
!$    DPHI=ZZZ2(1)
!$OMP END MASTER
!$    ERRETM=0.0D+00
!$OMP MASTER
!$    ERRETM=ZZZ3(1)
!$OMP END MASTER
!$OMP DO
         DO 200 J = N, IIP1, -1
            TEMP = Z( J ) / DELTA( J )
            WK = Z( J )*TEMP
            PHI = PHI + WK
            DPHI = DPHI + TEMP*TEMP
            ERRETM = ERRETM + WK*(J+1-IIP1)
  200    CONTINUE
!$OMP ENDDO
!$    ZZZ1(OMP_GET_THREAD_NUM()+1)=PHI
!$    ZZZ2(OMP_GET_THREAD_NUM()+1)=DPHI
!$    ZZZ3(OMP_GET_THREAD_NUM()+1)=ERRETM
!$OMP BARRIER
!$OMP MASTER
!$    PHI=0.0D+00
!$    DPHI=0.0D+00
!$    ERRETM=0.0D+00
!$    DO J__=1,OMP_GET_NUM_THREADS()
!$     PHI=PHI+ZZZ1(J__)
!$     DPHI=DPHI+ZZZ2(J__)
!$     ERRETM=ERRETM+ZZZ3(J__)
!$    ENDDO
!$     ZZZ1(1)=PHI
!$     ZZZ2(1)=DPHI
!$     ZZZ3(1)=ERRETM
!$OMP END MASTER
!$OMP END PARALLEL
!$     PHI=ZZZ1(1)
!$     DPHI=ZZZ2(1)
!$     ERRETM=ZZZ3(1)
*
         TEMP = Z( II ) / DELTA( II )
         DW = DPSI + DPHI + TEMP*TEMP
         TEMP = Z( II )*TEMP
         W = RHOINV + PHI + PSI + TEMP
         ERRETM = EIGHT*( PHI-PSI ) + ERRETM + TWO*RHOINV +
     $            THREE*ABS( TEMP ) + ABS( TAU+ETA )*DW
*
         SWTCH = .FALSE.
         IF( ORGATI ) THEN
            IF( -W.GT.ABS( PREW ) / TEN )
     $         SWTCH = .TRUE.
         ELSE
            IF( W.GT.ABS( PREW ) / TEN )
     $         SWTCH = .TRUE.
         END IF
*
         TAU = TAU + ETA
*
*        Main loop to update the values of the array   DELTA
*
         ITER = NITER + 1
*
         DO 240 NITER = ITER, MAXIT
*
*           Test for convergence
*
            IF( ABS( W ).LE.EPS*ERRETM ) THEN
               IF( ORGATI ) THEN
                  DLAM = D( I ) + TAU
               ELSE
                  DLAM = D( IP1 ) + TAU
               END IF
               GO TO 250
            END IF
*
            IF( W.LE.ZERO ) THEN
               DLTLB = MAX( DLTLB, TAU )
            ELSE
               DLTUB = MIN( DLTUB, TAU )
            END IF
*
*           Calculate the new step
*
            IF( .NOT.SWTCH3 ) THEN
               IF( .NOT.SWTCH ) THEN
                  IF( ORGATI ) THEN
                     C = W - DELTA( IP1 )*DW -
     $                   ( D( I )-D( IP1 ) )*( Z( I ) / DELTA( I ) )**2
                  ELSE
                     C = W - DELTA( I )*DW - ( D( IP1 )-D( I ) )*
     $                   ( Z( IP1 ) / DELTA( IP1 ) )**2
                  END IF
               ELSE
                  TEMP = Z( II ) / DELTA( II )
                  IF( ORGATI ) THEN
                     DPSI = DPSI + TEMP*TEMP
                  ELSE
                     DPHI = DPHI + TEMP*TEMP
                  END IF
                  C = W - DELTA( I )*DPSI - DELTA( IP1 )*DPHI
               END IF
               A = ( DELTA( I )+DELTA( IP1 ) )*W -
     $             DELTA( I )*DELTA( IP1 )*DW
               B = DELTA( I )*DELTA( IP1 )*W
               IF( C.EQ.ZERO ) THEN
                  IF( A.EQ.ZERO ) THEN
                     IF( .NOT.SWTCH ) THEN
                        IF( ORGATI ) THEN
                           A = Z( I )*Z( I ) + DELTA( IP1 )*
     $                         DELTA( IP1 )*( DPSI+DPHI )
                        ELSE
                           A = Z( IP1 )*Z( IP1 ) +
     $                         DELTA( I )*DELTA( I )*( DPSI+DPHI )
                        END IF
                     ELSE
                        A = DELTA( I )*DELTA( I )*DPSI +
     $                      DELTA( IP1 )*DELTA( IP1 )*DPHI
                     END IF
                  END IF
                  ETA = B / A
               ELSE IF( A.LE.ZERO ) THEN
                  ETA = ( A-SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
               ELSE
                  ETA = TWO*B / ( A+SQRT( ABS( A*A-FOUR*B*C ) ) )
               END IF
            ELSE
*
*              Interpolation using THREE most relevant poles
*
               TEMP = RHOINV + PSI + PHI
               IF( SWTCH ) THEN
                  C = TEMP - DELTA( IIM1 )*DPSI - DELTA( IIP1 )*DPHI
                  ZZ( 1 ) = DELTA( IIM1 )*DELTA( IIM1 )*DPSI
                  ZZ( 3 ) = DELTA( IIP1 )*DELTA( IIP1 )*DPHI
               ELSE
                  IF( ORGATI ) THEN
                     TEMP1 = Z( IIM1 ) / DELTA( IIM1 )
                     TEMP1 = TEMP1*TEMP1
                     C = TEMP - DELTA( IIP1 )*( DPSI+DPHI ) -
     $                   ( D( IIM1 )-D( IIP1 ) )*TEMP1
                     ZZ( 1 ) = Z( IIM1 )*Z( IIM1 )
                     ZZ( 3 ) = DELTA( IIP1 )*DELTA( IIP1 )*
     $                         ( ( DPSI-TEMP1 )+DPHI )
                  ELSE
                     TEMP1 = Z( IIP1 ) / DELTA( IIP1 )
                     TEMP1 = TEMP1*TEMP1
                     C = TEMP - DELTA( IIM1 )*( DPSI+DPHI ) -
     $                   ( D( IIP1 )-D( IIM1 ) )*TEMP1
                     ZZ( 1 ) = DELTA( IIM1 )*DELTA( IIM1 )*
     $                         ( DPSI+( DPHI-TEMP1 ) )
                     ZZ( 3 ) = Z( IIP1 )*Z( IIP1 )
                  END IF
               END IF
               CALL DLAED6( NITER, ORGATI, C, DELTA( IIM1 ), ZZ, W, ETA,
     $                      INFO )
               IF( INFO.NE.0 )
     $            GO TO 250
            END IF
*
*           Note, eta should be positive if w is negative, and
*           eta should be negative otherwise. However,
*           if for some reason caused by roundoff, eta*w > 0,
*           we simply use one Newton step instead. This way
*           will guarantee eta*w < 0.
*
            IF( W*ETA.GE.ZERO )
     $         ETA = -W / DW
            TEMP = TAU + ETA
            IF( TEMP.GT.DLTUB .OR. TEMP.LT.DLTLB ) THEN
               IF( W.LT.ZERO ) THEN
                  ETA = ( DLTUB-TAU ) / TWO
               ELSE
                  ETA = ( DLTLB-TAU ) / TWO
               END IF
            END IF
*
!$OMP PARALLEL DO
            DO 210 J = 1, N
               DELTA( J ) = DELTA( J ) - ETA
  210       CONTINUE
!$OMP END PARALLEL DO
*
            TAU = TAU + ETA
            PREW = W
*
*           Evaluate PSI and the derivative DPSI
*
            DPSI = ZERO
            PSI = ZERO
            ERRETM = ZERO
!$    ZZZ1(1)=PSI
!$    ZZZ2(1)=DPSI
!$    ZZZ3(1)=ERRETM
!$OMP PARALLEL PRIVATE(TEMP,WK,PSI,DPSI,ERRETM)
!$    PSI=0.0D+00
!$OMP MASTER
!$    PSI=ZZZ1(1)
!$OMP END MASTER
!$    DPSI=0.0D+00
!$OMP MASTER
!$    DPSI=ZZZ2(1)
!$OMP END MASTER
!$    ERRETM=0.0D+00
!$OMP MASTER
!$    ERRETM=ZZZ3(1)
!$OMP END MASTER
!$OMP DO
            DO 220 J = 1, IIM1
               TEMP = Z( J ) / DELTA( J )
               WK = Z( J )*TEMP
               PSI = PSI + WK
               DPSI = DPSI + TEMP*TEMP
               ERRETM = ERRETM + WK*(J-IIM1+1)
  220       CONTINUE
!$OMP ENDDO
!$    ZZZ1(OMP_GET_THREAD_NUM()+1)=PSI
!$    ZZZ2(OMP_GET_THREAD_NUM()+1)=DPSI
!$    ZZZ3(OMP_GET_THREAD_NUM()+1)=ERRETM
!$OMP BARRIER
!$OMP MASTER
!$    PSI=0.0D+00
!$    DPSI=0.0D+00
!$    ERRETM=0.0D+00
!$    DO J__=1,OMP_GET_NUM_THREADS()
!$     PSI=PSI+ZZZ1(J__)
!$     DPSI=DPSI+ZZZ2(J__)
!$     ERRETM=ERRETM+ZZZ3(J__)
!$    ENDDO
!$     ZZZ1(1)=PSI
!$     ZZZ2(1)=DPSI
!$     ZZZ3(1)=ERRETM
!$OMP END MASTER
!$OMP END PARALLEL
!$     PSI=ZZZ1(1)
!$     DPSI=ZZZ2(1)
!$     ERRETM=ZZZ3(1)
            ERRETM = ABS( ERRETM )
*
*           Evaluate PHI and the derivative DPHI
*
            DPHI = ZERO
            PHI = ZERO
!$    ZZZ1(1)=PHI
!$    ZZZ2(1)=DPHI
!$    ZZZ3(1)=ERRETM
!$OMP PARALLEL PRIVATE(TEMP,WK,PHI,DPHI,ERRETM)
!$    PHI=0.0D+00
!$OMP MASTER
!$    PHI=ZZZ1(1)
!$OMP END MASTER
!$    DPHI=0.0D+00
!$OMP MASTER
!$    DPHI=ZZZ2(1)
!$OMP END MASTER
!$    ERRETM=0.0D+00
!$OMP MASTER
!$    ERRETM=ZZZ3(1)
!$OMP END MASTER
!$OMP DO
            DO 230 J = N, IIP1, -1
               TEMP = Z( J ) / DELTA( J )
               WK = Z( J )*TEMP
               PHI = PHI + WK
               DPHI = DPHI + TEMP*TEMP
               ERRETM = ERRETM + WK*(J+1-IIP1)
  230       CONTINUE
!$OMP ENDDO
!$    ZZZ1(OMP_GET_THREAD_NUM()+1)=PHI
!$    ZZZ2(OMP_GET_THREAD_NUM()+1)=DPHI
!$    ZZZ3(OMP_GET_THREAD_NUM()+1)=ERRETM
!$OMP BARRIER
!$OMP MASTER
!$    PHI=0.0D+00
!$    DPHI=0.0D+00
!$    ERRETM=0.0D+00
!$    DO J__=1,OMP_GET_NUM_THREADS()
!$     PHI=PHI+ZZZ1(J__)
!$     DPHI=DPHI+ZZZ2(J__)
!$     ERRETM=ERRETM+ZZZ3(J__)
!$    ENDDO
!$     ZZZ1(1)=PHI
!$     ZZZ2(1)=DPHI
!$     ZZZ3(1)=ERRETM
!$OMP END MASTER
!$OMP END PARALLEL
!$     PHI=ZZZ1(1)
!$     DPHI=ZZZ2(1)
!$     ERRETM=ZZZ3(1)
*
            TEMP = Z( II ) / DELTA( II )
            DW = DPSI + DPHI + TEMP*TEMP
            TEMP = Z( II )*TEMP
            W = RHOINV + PHI + PSI + TEMP
            ERRETM = EIGHT*( PHI-PSI ) + ERRETM + TWO*RHOINV +
     $               THREE*ABS( TEMP ) + ABS( TAU )*DW
            IF( W*PREW.GT.ZERO .AND. ABS( W ).GT.ABS( PREW ) / TEN )
     $         SWTCH = .NOT.SWTCH
*
  240    CONTINUE
*
*        Return with INFO = 1, NITER = MAXIT and not converged
*
         INFO = 1
         IF( ORGATI ) THEN
            DLAM = D( I ) + TAU
         ELSE
            DLAM = D( IP1 ) + TAU
         END IF
*
      END IF
*
  250 CONTINUE
*
      RETURN
*
*     End of DLAED4
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: forcaf2
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!  $Id: b_Force_f77.F 570 2017-04-21 20:34:50Z yamasaki $
      subroutine forcaf2
     >     (katm,katm2,kopr,natm,nopr,napt,iwei,op,ipri,af
     =     ,fnlxyz_l
     w     ,forc_up,forc_dn )
c $Id: b_Force_f77.F 570 2017-04-21 20:34:50Z yamasaki $
c The forces of the down-spin are calculated by operating
c the anti-ferromagnetic operation to those of the up-spin.
c This subroutine is called from vnlsum.
c
c antiferromagnetic calculation is added on 9th Jul. 1996
c                                          by H.Sawada
C**********************************************************************
      implicit none

#ifdef VPP
#ifdef PARA
      include 'nproc.inc'
!xocl processor pe(npe)
!xocl subprocessor pes(npe)=pe(1:npe)
      include 'inddef_p.inc'
#endif
#endif
      integer katm,katm2,natm,kopr,nopr,iopr
     &     ,iwei(katm),napt(katm,kopr)
      integer ipri,af
      integer ia,mm,nap, j
      real*8 op(3,3,kopr)
     w     ,forc_up(katm2,3),forc_dn(katm2,3),px,py,pz
c
#ifdef PARA
      real*8 fnlxyz_l(katm_p,3)
!xocl local fnlxyz_l(/ind_katm,:)
#else
      real*8 fnlxyz_l(katm,3)
#endif

      if(ipri.ge.2) then
         print *, ' forces only for up-spin (vnlsum)'
         do 610 ia = 1, natm
!xocl spread do/ind_katm
!xocl index ia
         print '(" ia=",i3,3d15.7)',ia,(fnlxyz_l(ia,j),j=1,3)
!xocl end spread
 610     continue
      endif

      do 620 ia = 1, katm2
      forc_up(ia,1)=0.d0
      forc_up(ia,2)=0.d0
      forc_up(ia,3)=0.d0
 620  continue

!xocl spread do/ind_katm
      do 500 ia = 1, natm
      do j = 1, 3
      forc_up(ia,j) = fnlxyz_l(ia,j)
      enddo
 500  continue
!xocl end spread sum(forc_up)

      mm=0
      do 300 ia = 1, natm
      if (iwei(ia).eq.2) then
         mm=mm+1
         forc_up(natm+mm,1) = - forc_up(ia,1)
         forc_up(natm+mm,2) = - forc_up(ia,2)
         forc_up(natm+mm,3) = - forc_up(ia,3)
      end if
 300  continue

      iopr = nopr +af
      do 100 ia = 1, natm
      nap = napt(ia,iopr)
      px = forc_up(nap,1)
      py = forc_up(nap,2)
      pz = forc_up(nap,3)
      forc_dn(ia,1) = op(1,1,iopr)*px+op(2,1,iopr)*py+op(3,1,iopr)*pz
      forc_dn(ia,2) = op(1,2,iopr)*px+op(2,2,iopr)*py+op(3,2,iopr)*pz
      forc_dn(ia,3) = op(1,3,iopr)*px+op(2,3,iopr)*py+op(3,3,iopr)*pz
 100  continue

!xocl spread do/ind_katm
      do 400 ia = 1, natm
      do j = 1, 3
      fnlxyz_l(ia,j) = fnlxyz_l(ia,j) + forc_dn(ia,j)
      enddo
 400  continue
!xocl end spread

      if(ipri.ge.2) then
         print *, ' forces for up- and down-spin (vnlsum)'
         do 600 ia = 1, natm
!xocl spread do/ind_katm
!xocl index ia
         print '(" ia=",i3,3d15.7)',ia,(fnlxyz_l(ia,j),j=1,3)
!xocl end spread
 600     continue
      endif

      return
      end

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 626 $)
!
!  SUBROUINE: WriteDownData_onto_Files_ek, FermiEnergyLevel_ek()
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, December/01/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!$$#ifndef PARA3D
subroutine WriteDownData_onto_Files_ek
! $Id: WriteDownData_onto_Files_ek.f90 626 2020-06-03 02:18:38Z jkoga $
  use m_Files,               only : m_Files_open_nfcntn,m_Files_close_all &
       &                     ,nfcntn,nfchgt,nfzaj,m_Files_open_nfcntn_bin &
       &                     ,nfcntn_bin,nfout,nfeng, nfstatus &
       &                     ,F_CNTN_BIN_partitioned &
       &                     , m_Files_open_nfstatus, m_Files_skiptoend &
       &                     , m_Files_open_nfzaj_with_check, m_Files_close_logfile &
       &                     , F_ZAJ
  use m_Const_Parameters,    only: EK,SCF,YES,EK_CONVERGED,PARABOLIC,TETRAHEDRON,ON,FINISH, OFF
  use m_Timing,              only: m_Timing_wd_status
  use m_Control_parameters,  only: ipri,ipriekzaj, neg, num_extra_bands, nspin &
       &                         , iconvergence_previous_job, iprijobstatus &
       &                         , jobstatus_series, jobstatus_format &
       &                         , continuation_using_ppdata, ekmode, neg_is_enlarged&
       &                         , m_CtrlP_wd_cpu_total, m_CtrlP_wd_iconvergence &
       &                         , m_CtrlP_wd_iconv_ek &
       &                         , m_CtrlP_way_of_smearing &
       &                         , m_CtrlP_wd_numk_zajsaved &
       &                         , sw_berry_phase, sw_write_bxsf_file, sw_write_zaj
  use m_IterationNumbers,    only: iteration, iteration_ionic, iteration_electronic &
       &                         , nk_in_the_process &
       &                         , m_Iter_wd_iters_and_nk, m_Iter_electronic_reset
  use m_Parallelization,     only: mype
  use m_Kpoints,             only: kv3, kv3_ek
  use m_PseudoPotential,     only: m_PP_wd_PP_parameters_3D, m_PP_wd_betar
  use m_PlaneWaveBasisSet,   only: kgp
  use m_NonLocal_Potential,  only: m_NLP_wd_snl_3D
  use m_ES_LHXC,             only: m_ESlhxc_potential_3D
  use m_ES_IO,               only: m_ESIO_wd_EigenValues_ek &
       &                         , m_ESIO_wd_WFs_and_EVS_ek
  use m_ES_occup,            only: m_ESoc_fermi_parabolic_ek, m_ESoc_fermi_tetra_ek &
       &                         , m_ESoc_check_num_bands
  use m_Electronic_Structure,only: efermi, vbm, metalic_system, iconv_ek &
       &                         , m_ES_wd_zaj_small_portion0
  use m_ES_nonlocal,         only: m_ES_wd_fsr_fsi

! ============================== added by K. Tagami =============== 11.0
  use m_Control_Parameters,  only : noncol, ndim_spinor
! ================================================================== 11.0

! ============================== KT_Add ===================== 13.0E
  use m_Const_Parameters,     only : Fermi_Dirac
  use m_ES_occup,            only: m_ESoc_fermi_dirac_ek
! =========================================================== 13.0E

  use m_BerryPhase,          only : m_BP_wd_cntn_data

  use m_Control_Parameters,  only : sw_corelevel_spectrum,  sw_local_approx_trans_moment
  use m_CLS_dipquad,        only : m_CLS_wd_transmom_ek

  use m_Crystal_Structure,  only : sw_spinorbit_second_variation
  use m_SpinOrbit_SecondVariation,  only : m_SO_wd_EigenValues_ek_fin

  implicit none
  integer :: status_wdmode, numk_zajsaved
  logical :: Allkpoints_are_Calculated, enough_bands

  logical :: flg_wd_zaj = .true.

  flg_wd_zaj = .true.
  if ( F_ZAJ == "/dev/null" .or. sw_write_zaj == OFF ) flg_wd_zaj = .false.

  if(iconvergence_previous_job < EK_CONVERGED) then
     call m_Files_open_nfcntn                        ! -(m_Files)
     if(mype==0) rewind nfcntn
     if(ipriekzaj<=0) call m_Iter_electronic_reset()
     call m_Iter_wd_iters_and_nk(nfcntn)
     call m_CtrlP_wd_iconvergence(nfcntn)
     numk_zajsaved = min(kv3_ek,nk_in_the_process+kv3-1)
     call m_CtrlP_wd_numk_zajsaved(nfcntn,numk_zajsaved)
     call m_CtrlP_wd_iconv_ek(kv3_ek,iconv_ek,nfcntn)

     call m_ESIO_wd_EigenValues_ek(nfout,mode=SCF)

     if(continuation_using_ppdata == YES) then
        call m_Files_open_nfcntn_bin
        if(mype==0) rewind nfcntn_bin
        call m_PP_wd_PP_parameters_3D(nfout,nfcntn_bin,F_CNTN_BIN_partitioned,kgp)
        call m_PP_wd_betar(nfcntn_bin)
        call m_NLP_wd_snl_3D(nfout,nfcntn_bin,F_CNTN_BIN_partitioned,kv3)
     end if

     if(Allkpoints_are_Calculated()) then
        enough_bands = m_ESoc_check_num_bands()
        if(enough_bands) then
           call FermiEnergylevel_ek()   ! -> metalic_system?, vbm, efermi
!!$           stop ' WriteDownData_onto_Files_ek (1)'
           if(ipri >= 1) write(nfout,'(" --- efermi = ",f8.4)') efermi
        else
           if(ipri >= 1) write(nfout,'(" --- efermi can not be estimated --")')
        end if
        rewind nfeng

        if(ipri >= 1) then
! -------------------------------------
!
! --- The following modification is intended to work band.pl correctly.
! 
! =============== modified by K. Tagami ======================= 11.0
!           write(nfeng,'(" num_kpoints = ",i6)') kv3_ek
!           write(nfeng,'(" num_bands   = ",i6)') neg-num_extra_bands
!           write(nfeng,'(" nspin       = ",i6)') nspin

!!$           if ( noncol ) then
           write(nfeng,'(" num_kpoints = ",i6)') kv3_ek /ndim_spinor
           if(neg_is_enlarged) then
              write(nfeng,'(" num_bands   = ",i6)') neg-num_extra_bands
           else
              write(nfeng,'(" num_bands   = ",i6)') neg
           end if
           write(nfeng,'(" nspin       = ",i6)') nspin / ndim_spinor
!!$           else
!!$              write(nfeng,'(" num_kpoints = ",i6)') kv3_ek
!!$              write(nfeng,'(" num_bands   = ",i6)') neg-num_extra_bands
!!$              write(nfeng,'(" nspin       = ",i6)') nspin
!!$           endif
! =============================================================== 11.0
        end if

        if(enough_bands) then
           if(metalic_system) then
              if(ipri>=1) write(nfeng,'(" Fermi energy level = ",f10.6/)') efermi
           else
!!$           write(nfeng,'(" The Highest occupied band energy = ",f10.6/)') vbm
              if(ipri>=1) write(nfeng,'(" Valence band max   = ",f10.6/)') vbm
           end if
        else
           if(ipri>=1) write(nfeng,'(" Fermi energy level = unknown")')
        end if
!!$        call m_ES_wd_eko(nfeng,mode=EK)
        call m_ESIO_wd_EigenValues_ek(nfeng,mode=EK)

        if ( .not. noncol .and. sw_spinorbit_second_variation == ON ) then
           call m_SO_wd_EigenValues_ek_fin
        endif

     else
!!$     if(.not.Allkpoints_are_Calculated() .and. ipriekzaj >= 1) &
        if(ipriekzaj >= 1) then
           if(ipri >= 1) write(nfout,'(" ipriekzaj = ",i8," <<WriteDownData_onto_Files_ek>>")') ipriekzaj
           call m_Files_open_nfzaj_with_check()
           if ( flg_wd_zaj ) then
              call m_ESIO_wd_WFs_and_EVs_ek(nfout,nfzaj)
           endif
        end if
     end if
  else
     if(ipri>=1) write(nfout,'(" --- iconvergence_previous >= EK_CONVERGED ---")')
  end if
  if(sw_berry_phase==ON)then
     call m_BP_wd_cntn_data()
  endif

  if ( sw_corelevel_spectrum == ON .and. sw_local_approx_trans_moment == ON ) then
     call m_CLS_wd_transmom_ek
  endif

  call m_ES_wd_fsr_fsi()                    ! if(ipri >= 2) 
  call m_ES_wd_zaj_small_portion0(" -- WDonFiles_ek --",18)
!!$  stop ' WriteDownData_onto_Files_ek (2)'

  call m_CtrlP_wd_cpu_total()
  if(iprijobstatus >= 1) then
     call m_Files_open_nfstatus()
     if(jobstatus_series == ON) then
        call m_Files_skiptoend(nfstatus)
     else
     end if
     status_wdmode = FINISH
     call m_Timing_wd_status(nfstatus,jobstatus_format,jobstatus_series,status_wdmode &
          &                , iteration,iteration_ionic,iteration_electronic)
  end if 

  call m_Files_close_all()                    ! -(m_Files)
  call PrintStatus()
  call m_Files_close_logfile()
!!$  stop ' WriteDownData_onto_Files_ek (3)'
contains

  subroutine FermiEnergyLevel_ek()
    integer :: way_of_smearing
    way_of_smearing = m_CtrlP_way_of_smearing()
    if(way_of_smearing == PARABOLIC) then
       call m_ESoc_fermi_parabolic_ek(nfout)  ! -> efermi, metalic_system
!!$  else if(way_of_smearing == MP) then
!!$     call fermi_mesfessel_paxton(nfout)
     else if(way_of_smearing == TETRAHEDRON) then
        call m_ESoc_fermi_tetra_ek(nfout)     ! -> efermi, metalic_system

! ========================= KT_add ================= 13.0E
     else if(way_of_smearing == Fermi_Dirac) then
        call m_ESoc_fermi_dirac_ek(nfout)     ! -> efermi, metalic_system
! ================================================== 13.0E
    end if
  end subroutine FermiEnergyLevel_ek

end subroutine WriteDownData_onto_Files_ek
!$$#endif

subroutine WriteDown_totalcpu()
  use m_Control_parameters,  only: m_CtrlP_wd_cpu_total

  call m_CtrlP_wd_cpu_total()
end subroutine WriteDown_totalcpu

subroutine write_energies(mnk,nk,kxyz,ek,mnt,nt,tk,ie)
  use m_Const_Parameters, only : DP
  use m_Files, only :            nfegrid, m_Files_open_nfegrid
  implicit none

  integer, intent(in) :: mnk,nk,mnt,nt,ie
  real(kind=DP), intent(in), dimension(3,mnk) :: kxyz
  real(kind=DP), intent(in), dimension(mnk) ::   ek
  integer, intent(in), dimension(4,mnt) ::       tk

  integer :: it, ik

  call m_Files_open_nfegrid()  ! open nfegrid

  write (nfegrid,*) '$ DATA=CURVE3D NAME = ', nt

  do it = 1, nt
     if( kxyz(3,tk(1,it)) == 0.d0 .and. kxyz(3,tk(2,it)) == 0.d0 .and. &
          &       kxyz(3,tk(3,it)) == 0d0) then
        write (nfegrid,*) sngl(kxyz(1,tk(1,it))),sngl(kxyz(2,tk(1,it))),sngl(ek(tk(1,it))),tk(1,it)
        write (nfegrid,*) sngl(kxyz(1,tk(2,it))),sngl(kxyz(2,tk(2,it))),sngl(ek(tk(2,it))),tk(2,it)
        write (nfegrid,*) sngl(kxyz(1,tk(3,it))),sngl(kxyz(2,tk(3,it))),sngl(ek(tk(3,it))),tk(3,it)
     endif

     if (kxyz(3,tk(1,it)) == 0d0 .and. kxyz(3,tk(2,it)) == 0d0 .and. &
          &       kxyz(3,tk(4,it)) == 0d0) then
        write (nfegrid,*)
        write (nfegrid,*) sngl(kxyz(1,tk(1,it))),sngl(kxyz(2,tk(1,it))),sngl(ek(tk(1,it))),tk(1,it)
        write (nfegrid,*) sngl(kxyz(1,tk(2,it))),sngl(kxyz(2,tk(2,it))),sngl(ek(tk(2,it))),tk(2,it)
        write (nfegrid,*) sngl(kxyz(1,tk(4,it))),sngl(kxyz(2,tk(4,it))),sngl(ek(tk(4,it))),tk(4,it)
     endif

     if (kxyz(3,tk(1,it)) == 0d0 .and. kxyz(3,tk(3,it)) == 0d0 .and. &
          &      kxyz(3,tk(4,it)) == 0d0) then
        write (nfegrid,*)
        write (nfegrid,*) sngl(kxyz(1,tk(1,it))),sngl(kxyz(2,tk(1,it))),sngl(ek(tk(1,it))),tk(1,it)
        write (nfegrid,*) sngl(kxyz(1,tk(3,it))),sngl(kxyz(2,tk(3,it))),sngl(ek(tk(3,it))),tk(3,it)
        write (nfegrid,*) sngl(kxyz(1,tk(4,it))),sngl(kxyz(2,tk(4,it))),sngl(ek(tk(4,it))),tk(4,it)
     endif

     if (kxyz(3,tk(2,it)) == 0d0 .and. kxyz(3,tk(3,it)) == 0d0 .and. &
          &     kxyz(3,tk(4,it)) == 0d0) then
        write (nfegrid,*)
        write (nfegrid,*) sngl(kxyz(1,tk(2,it))),sngl(kxyz(2,tk(2,it))),sngl(ek(tk(2,it))),tk(2,it)
        write (nfegrid,*) sngl(kxyz(1,tk(3,it))),sngl(kxyz(2,tk(3,it))),sngl(ek(tk(3,it))),tk(3,it)
        write (nfegrid,*) sngl(kxyz(1,tk(4,it))),sngl(kxyz(2,tk(4,it))),sngl(ek(tk(4,it))),tk(4,it)
     endif
     write (nfegrid,*)
  enddo

  write (nfegrid,*) '$ end  ', ie, nk

!_____write output
  write (nfegrid,*) nk
  do ik = 1, nk
     write (nfegrid,*) kxyz(1,ik), kxyz(2,ik), kxyz(3,ik), ek(ik)
  enddo

  write (nfegrid,*) nt
  do it = 1, nt
     write (nfegrid,*) tk(1,it), tk(2,it), tk(3,it), tk(4,it)
  enddo
end subroutine write_energies

      SUBROUTINE DLAED6( KNITER, ORGATI, RHO, D, Z, FINIT, TAU, INFO )
      use dlaed6_common
      implicit NONE
*
*     This subroutine is originally included in
*     LAPACK (version 3.0)
*     Parallelization in the OpenMP thread fashion done by T.Imamura
*
*     .. Scalar Arguments ..
      LOGICAL            ORGATI
      INTEGER            INFO, KNITER
      DOUBLE PRECISION   FINIT, RHO, TAU
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( 3 ), Z( 3 )
*     ..
*
*  Purpose
*  =======
*
*  DLAED6 computes the positive or negative root (closest to the origin)
*  of
*                   z(1)        z(2)        z(3)
*  f(x) =   rho + --------- + ---------- + ---------
*                  d(1)-x      d(2)-x      d(3)-x
*
*  It is assumed that
*
*        if ORGATI = .true. the root is between d(2) and d(3);
*        otherwise it is between d(1) and d(2)
*
*  This routine will be called by DLAED4 when necessary. In most cases,
*  the root sought is the smallest in magnitude, though it might not be
*  in some extremely rare situations.
*
*  Arguments
*  =========
*
*  KNITER       (input) INTEGER
*               Refer to DLAED4 for its significance.
*
*  ORGATI       (input) LOGICAL
*               If ORGATI is true, the needed root is between d(2) and
*               d(3); otherwise it is between d(1) and d(2).  See
*               DLAED4 for further details.
*
*  RHO          (input) DOUBLE PRECISION
*               Refer to the equation f(x) above.
*
*  D            (input) DOUBLE PRECISION array, dimension (3)
*               D satisfies d(1) < d(2) < d(3).
*
*  Z            (input) DOUBLE PRECISION array, dimension (3)
*               Each of the elements in z must be positive.
*
*  FINIT        (input) DOUBLE PRECISION
*               The value of f at 0. It is more accurate than the one
*               evaluated inside this routine (if someone wants to do
*               so).
*
*  TAU          (output) DOUBLE PRECISION
*               The root of the equation f(x).
*
*  INFO         (output) INTEGER
*               = 0: successful exit
*               > 0: if INFO = 1, failure to converge
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ren-Cang Li, Computer Science Division, University of California
*     at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            MAXIT
      PARAMETER          ( MAXIT = 20 )
      DOUBLE PRECISION   ZERO, ONE, TWO, THREE, FOUR, EIGHT
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0, TWO = 2.0D0,
     $                   THREE = 3.0D0, FOUR = 4.0D0, EIGHT = 8.0D0 )
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   DSCALE( 3 ), ZSCALE( 3 )
*     ..
*     .. Local Scalars ..
      LOGICAL            SCALE
      INTEGER            I, ITER, NITER
      DOUBLE PRECISION   A, B, BASE, C, DDF, DF, ERRETM, ETA, F,
     $                   FC, SCLFAC, SCLINV,
     $                   TEMP, TEMP1, TEMP2, TEMP3, TEMP4
*     ..
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, INT, LOG, MAX, MIN, SQRT
*     ..
!=*     .. Data statements ..
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
      NITER = 1
      TAU = ZERO
      IF( KNITER.EQ.2 ) THEN
         IF( ORGATI ) THEN
            TEMP = ( D( 3 )-D( 2 ) ) / TWO
            C = RHO + Z( 1 ) / ( ( D( 1 )-D( 2 ) )-TEMP )
            A = C*( D( 2 )+D( 3 ) ) + Z( 2 ) + Z( 3 )
            B = C*D( 2 )*D( 3 ) + Z( 2 )*D( 3 ) + Z( 3 )*D( 2 )
         ELSE
            TEMP = ( D( 1 )-D( 2 ) ) / TWO
            C = RHO + Z( 3 ) / ( ( D( 3 )-D( 2 ) )-TEMP )
            A = C*( D( 1 )+D( 2 ) ) + Z( 1 ) + Z( 2 )
            B = C*D( 1 )*D( 2 ) + Z( 1 )*D( 2 ) + Z( 2 )*D( 1 )
         END IF
         TEMP = MAX( ABS( A ), ABS( B ), ABS( C ) )
         A = A / TEMP
         B = B / TEMP
         C = C / TEMP
         IF( C.EQ.ZERO ) THEN
            TAU = B / A
         ELSE IF( A.LE.ZERO ) THEN
            TAU = ( A-SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
         ELSE
            TAU = TWO*B / ( A+SQRT( ABS( A*A-FOUR*B*C ) ) )
         END IF
         TEMP = RHO + Z( 1 ) / ( D( 1 )-TAU ) +
     $          Z( 2 ) / ( D( 2 )-TAU ) + Z( 3 ) / ( D( 3 )-TAU )
         IF( ABS( FINIT ).LE.ABS( TEMP ) )
     $      TAU = ZERO
      END IF
*
*     On first call to routine, get machine parameters for
*     possible scaling to avoid overflow
*
!=!$OMP CRITICAL
!=      IF( FIRST ) THEN
!=         EPS = DLAMCH( 'Epsilon' )
!=         BASE = DLAMCH( 'Base' )
!=         SMALL1 = BASE**( INT( LOG( DLAMCH( 'SafMin' ) ) / LOG( BASE ) /
!=     $            THREE ) )
!=         SMINV1 = ONE / SMALL1
!=         SMALL2 = SMALL1*SMALL1
!=         SMINV2 = SMINV1*SMINV1
!=         FIRST = .FALSE.
!=      END IF
!=!$OMP END CRITICAL
*
*     Determine if scaling of inputs necessary to avoid overflow
*     when computing 1/TEMP**3
*
      IF( ORGATI ) THEN
         TEMP = MIN( ABS( D( 2 )-TAU ), ABS( D( 3 )-TAU ) )
      ELSE
         TEMP = MIN( ABS( D( 1 )-TAU ), ABS( D( 2 )-TAU ) )
      END IF
      SCALE = .FALSE.
      IF( TEMP.LE.SMALL1 ) THEN
         SCALE = .TRUE.
         IF( TEMP.LE.SMALL2 ) THEN
*
*        Scale up by power of radix nearest 1/SAFMIN**(2/3)
*
            SCLFAC = SMINV2
            SCLINV = SMALL2
         ELSE
*
*        Scale up by power of radix nearest 1/SAFMIN**(1/3)
*
            SCLFAC = SMINV1
            SCLINV = SMALL1
         END IF
*
*        Scaling up safe because D, Z, TAU scaled elsewhere to be O(1)
*
         DO 10 I = 1, 3
            DSCALE( I ) = D( I )*SCLFAC
            ZSCALE( I ) = Z( I )*SCLFAC
   10    CONTINUE
         TAU = TAU*SCLFAC
      ELSE
*
*        Copy D and Z to DSCALE and ZSCALE
*
         DO 20 I = 1, 3
            DSCALE( I ) = D( I )
            ZSCALE( I ) = Z( I )
   20    CONTINUE
      END IF
*
      FC = ZERO
      DF = ZERO
      DDF = ZERO
      DO 30 I = 1, 3
         TEMP = ONE / ( DSCALE( I )-TAU )
         TEMP1 = ZSCALE( I )*TEMP
         TEMP2 = TEMP1*TEMP
         TEMP3 = TEMP2*TEMP
         FC = FC + TEMP1 / DSCALE( I )
         DF = DF + TEMP2
         DDF = DDF + TEMP3
   30 CONTINUE
      F = FINIT + TAU*FC
*
      IF( ABS( F ).LE.ZERO )
     $   GO TO 60
*
*        Iteration begins
*
*     It is not hard to see that
*
*           1) Iterations will go up monotonically
*              if FINIT < 0;
*
*           2) Iterations will go down monotonically
*              if FINIT > 0.
*
      ITER = NITER + 1
*
      DO 50 NITER = ITER, MAXIT
*
         IF( ORGATI ) THEN
            TEMP1 = DSCALE( 2 ) - TAU
            TEMP2 = DSCALE( 3 ) - TAU
         ELSE
            TEMP1 = DSCALE( 1 ) - TAU
            TEMP2 = DSCALE( 2 ) - TAU
         END IF
         A = ( TEMP1+TEMP2 )*F - TEMP1*TEMP2*DF
         B = TEMP1*TEMP2*F
         C = F - ( TEMP1+TEMP2 )*DF + TEMP1*TEMP2*DDF
         TEMP = MAX( ABS( A ), ABS( B ), ABS( C ) )
         A = A / TEMP
         B = B / TEMP
         C = C / TEMP
         IF( C.EQ.ZERO ) THEN
            ETA = B / A
         ELSE IF( A.LE.ZERO ) THEN
            ETA = ( A-SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
         ELSE
            ETA = TWO*B / ( A+SQRT( ABS( A*A-FOUR*B*C ) ) )
         END IF
         IF( F*ETA.GE.ZERO ) THEN
            ETA = -F / DF
         END IF
*
         TEMP = ETA + TAU
         IF( ORGATI ) THEN
            IF( ETA.GT.ZERO .AND. TEMP.GE.DSCALE( 3 ) )
     $         ETA = ( DSCALE( 3 )-TAU ) / TWO
            IF( ETA.LT.ZERO .AND. TEMP.LE.DSCALE( 2 ) )
     $         ETA = ( DSCALE( 2 )-TAU ) / TWO
         ELSE
            IF( ETA.GT.ZERO .AND. TEMP.GE.DSCALE( 2 ) )
     $         ETA = ( DSCALE( 2 )-TAU ) / TWO
            IF( ETA.LT.ZERO .AND. TEMP.LE.DSCALE( 1 ) )
     $         ETA = ( DSCALE( 1 )-TAU ) / TWO
         END IF
         TAU = TAU + ETA
*
         FC = ZERO
         ERRETM = ZERO
         DF = ZERO
         DDF = ZERO
         DO 40 I = 1, 3
            TEMP = ONE / ( DSCALE( I )-TAU )
            TEMP1 = ZSCALE( I )*TEMP
            TEMP2 = TEMP1*TEMP
            TEMP3 = TEMP2*TEMP
            TEMP4 = TEMP1 / DSCALE( I )
            FC = FC + TEMP4
            ERRETM = ERRETM + ABS( TEMP4 )
            DF = DF + TEMP2
            DDF = DDF + TEMP3
   40    CONTINUE
         F = FINIT + TAU*FC
         ERRETM = EIGHT*( ABS( FINIT )+ABS( TAU )*ERRETM ) +
     $            ABS( TAU )*DF
         IF( ABS( F ).LE.EPS*ERRETM )
     $      GO TO 60
   50 CONTINUE
      INFO = 1
   60 CONTINUE
*
*     Undo scaling
*
      IF( SCALE )
     $   TAU = TAU*SCLINV
      RETURN
*
*     End of DLAED6
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 577 $)
!
!  SUBROUINE: Stress
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Stress
!$$#ifndef PARA3D
! $Id: Stress.F90 577 2017-12-15 05:26:08Z jkoga $
  use m_Stress,           only : hsrd &
       &                       , m_Stress_alloc          , m_Stress_dealloc &
       &                       , m_Stress_alloc_grinv_g  , m_Stress_dealloc_grinv_g &
       &                       , m_Stress_ke             , m_Stress_hsr_diff &
       &                       , m_Stress_lclchg_diff    , m_Stress_xc &
       &                       , m_Stress_loc            , m_Stress_h &
       &                       , m_Stress_nl             , m_Stress_ew &
       &                       , m_Stress_or             , m_Stress_sum &
       &                       , m_Stress_check_g12
  use m_XC_Potential,     only : m_XC_alloc_s_gga,m_XC_dealloc_s_gga ,m_XC_cal_potential
  use m_Charge_Density,   only : chgsoft, chgq_l, hsr
  use m_Kpoints,          only : kv3, vkxyz
  use m_Files,            only : nfout
  use m_Control_Parameters,only: istress
  use m_Const_Parameters, only : Valence_plus_PC_Charge,STRESS_, CRDTYP

! ================================ Added by K. Tagami ============ p1100
  use m_Stress,           only : m_Stress_Hub
! ================================================================ p1100

! ================= added by K. Tagami ==================== 11.0
  use m_Const_Parameters,       only : ON
  use m_Control_Parameters,    only : sw_hubbard, noncol
  use m_Stress,                only : m_Stress_ke_noncl, &
       &                              m_Stress_hsr_diff_noncl, &
       &                              m_Stress_lclchg_diff_noncl, &
       &                              m_Stress_xc_noncl, &
       &                              m_Stress_nl_nonclA, &
       &                              m_Stress_or_nonclA, &
       &                              m_Stress_nl_nonclB, &
       &                              m_Stress_or_nonclB, &
       &                              m_Stress_Hub_nonclA, &
       &                              m_Stress_Hub_nonclB
! ========================================================= 11.0

! =================================== KT_add ============== 13.0B
  use m_Control_Parameters,    only : sw_vdw_correction, xctype
#ifndef DISABLE_VDWDF
  use m_Stress,                only : m_Stress_vdw,m_Stress_vdwdf
#else
  use m_Stress,                only : m_Stress_vdw
#endif
 
! ========================================================= 13.0B

  implicit none

  if (istress == 0) return

  if ( noncol ) then
     call case_noncollinear
  else
     call case_collinear
  endif


! ============================ added by K. Tagami ============= 11.0
contains

  subroutine case_collinear
    call m_Stress_alloc()
    call m_XC_alloc_s_gga
    call m_Stress_ke(nfout,kv3,CRDTYP,vkxyz)
    call m_Stress_hsr_diff(nfout,kv3)
!!$  call m_M_Stress_xcfft_diff(nfout)

    call m_XC_cal_potential(nfout,Valence_plus_PC_Charge,chgq_l,STRESS_ &
         &   ,chgsoft,hsr,hsrd)
    call m_Stress_check_g12(nfout)
    call m_Stress_alloc_grinv_g()
    call m_Stress_lclchg_diff(nfout)
    call m_Stress_xc(nfout)
    call m_Stress_loc(nfout)
    call m_Stress_h(nfout)
    call m_Stress_dealloc_grinv_g()
    call m_Stress_nl(nfout)
    call m_Stress_ew(nfout)
    call m_Stress_or(nfout)

! =============================== Added by K. Tagami ============ p1100
    if ( sw_hubbard == ON ) call m_Stress_Hub(nfout)
! =============================================================== p1100

! =================================== KT_add ============== 13.0B
    if ( sw_vdw_correction == ON ) call m_Stress_vdw(nfout)
! ========================================================= 13.0B

#ifndef DISABLE_VDWDF
    if ( xctype == "vdwdf" ) call m_Stress_vdwdf(nfout)
#endif

    call m_Stress_sum(nfout)
    call m_Stress_dealloc()
    call m_XC_dealloc_s_gga()

  end subroutine case_collinear

  subroutine case_noncollinear
    call m_Stress_alloc()
    call m_XC_alloc_s_gga

    call m_Stress_ke_noncl( nfout, kv3, CRDTYP, vkxyz )
    call m_Stress_hsr_diff_noncl( nfout, kv3 )

    call m_XC_cal_potential( nfout, Valence_plus_PC_Charge, chgq_l, STRESS_,  &
         &                   chgsoft, hsr, hsrd )
    call m_Stress_check_g12(nfout)

    call m_Stress_alloc_grinv_g()

    call m_Stress_lclchg_diff_noncl(nfout)
    call m_Stress_xc_noncl(nfout)

    call m_Stress_loc(nfout)
    call m_Stress_h(nfout)

    call m_Stress_dealloc_grinv_g()

!!    call m_Stress_nl_nonclA(nfout)
    call m_Stress_nl_nonclB(nfout)

    call m_Stress_ew(nfout)

!!    call m_Stress_or_nonclA(nfout)
    call m_Stress_or_nonclB(nfout)

    if ( sw_hubbard == ON ) call m_Stress_Hub_nonclB(nfout)

! =================================== KT_add ============== 13.0B
    if ( sw_vdw_correction == ON ) call m_Stress_vdw(nfout)
! ========================================================= 13.0B

    call m_Stress_sum(nfout)
    call m_Stress_dealloc()
    call m_XC_dealloc_s_gga()

  end subroutine case_noncollinear

!$$#endif
end subroutine Stress

!================================================
!  Software name : STM
!  Module : m_Control_Parameters
!  Subroutine(s) : m_CtrlP_rd_nc_z_axis, m_CtrlP_rd_energy_range,
!                  m_CtrlP_rd_z_range, m_CtrlP_set_wct_start,
!                  m_CtrlP_rd_mixing_ratio, m_CtrlP_rd_error_limit
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.

module m_Control_Parameters
! $Id: m_Control_Parameters.F90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  use m_Files, only : nfinp_exists
  use m_Const_Parameters, only : DP
  use m_Kpoints, only : m_Kp_set_nspin
  implicit none

  integer       :: ipri
  real(DP)      :: e1, e2      ! energy range, Efermi+e1 - Efermi+e2
  integer       :: izi, izf    ! z range top and bottom
  real(kind=DP) :: rini, rfin  ! mixing ratio in iteration
  integer       :: nfin        ! rmix = rini + (rfin - rini)*(iter-1)/nfin
  integer       :: nc_z=3      ! column position of the z-component,
                               ! which is normaly 3
  integer, dimension(3) :: n_fc,n_fc_i
  real(kind=DP) :: erlmt ! error limit
  real(kind=DP) :: wct_start = 0.d0
contains
  subroutine print_help()
    write(6,'(a)') 'work function postprocessing utility for PHASE'
    write(6,'(a)') 'usage : workfunc options'
    write(6,'(a)') 'options :' 
!    write(6,'(a)') '-s  or --spin enable this option when spin is taken into account.'
    write(6,'(a)') '-z=ZAXIS  or --zaxis=ZAXIS use this option in order to specify &
              & the index for the z-axis (one of 1, 2 or 3). defaults to 3.'
    write(6,'(a)')
  end subroutine

  subroutine m_CtrlP_rd_nc_z_axis(nfinp)
    integer, intent(in) :: nfinp
    integer :: nspin
    integer :: i,narg,ieq
    character(len=32) :: arg,argval
    if(nfinp_exists)then
       read(nfinp,*) nc_z, nspin
       call m_Kp_set_nspin(nspin)
    endif
    narg = command_argument_count()
    do i=1,narg
       call get_command_argument(i,arg)
       argval = arg 
       ieq = index(arg,'=')
       if (ieq>0) then
          if(.not.(ieq.eq.len_trim(arg)-1)) then
             write(0,*) 'invalid argument : '//trim(arg)
             stop
          endif
          argval = arg(1:ieq-1)
       endif
       select case (argval)
       case('-s','--spin')
          nspin = 2
          call m_Kp_set_nspin(nspin)
       case ('-h','--help')
          call print_help()
          stop
       case ('-z','--zaxis')
          if(ieq>0) then
              read(arg(ieq+1:ieq+1),*) nc_z
          else
              if (i==narg) then
                 stop 'the -z option takes one of : 1, 2 or 3'
              endif
              call get_command_argument(i+1,arg)
              read(arg(1:1),*) nc_z
          endif
          if(nc_z<1 .or. nc_z>3) then
             stop 'the -z option takes one of : 1, 2 or 3'
          endif
       end select
    enddo
!!    print '(" nc_z = ",i5)',nc_z
    if(nc_z .eq. 1) then
       n_fc(1) = 1; n_fc(2) = 2; n_fc(3) = 3
       n_fc_i(1) = 1; n_fc_i(2) = 2; n_fc_i(3) = 3
    else if(nc_z .eq. 2) then
       n_fc(1) = 2; n_fc(2) = 3; n_fc(3) = 1
       n_fc_i(1) = 3; n_fc_i(2) = 1; n_fc_i(3) = 2
    else if(nc_z .eq. 3) then
       n_fc(1) = 3; n_fc(2) = 1; n_fc(3) = 2
       n_fc_i(1) = 2; n_fc_i(2) = 3; n_fc_i(3) = 1
    end if
  end subroutine m_CtrlP_rd_nc_z_axis

end module m_Control_Parameters

!================================================
!  Software name : STM
!  Subroutine(s) : jrcat_r2ft_of_3D_forwafd, jrcat_r1ft_of_3D_back,
!                  jrcat_r2ft_of_3D_back, jrcat_r2ft_of_3D,
!                  jrcat_c2ft_of_3D_back, jrcat_c2ft_of_3D_forward,
!                  jrcat_c2ft_of_3D
!  Author(s)     : Takahiro Yamasaki and Koichi Kato (June 7, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

      subroutine jrcat_r2ft_of_3D_forward(ca,cb,id,n1,n2,n3,cw2,cw3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
      implicit none

      integer id,n1,n2,n3
      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer  n1h, idh
      integer lp2,lp3,lp4,lp5,lp8,key

      n1h = n1/2
      idh = id/2

      key = -1

c**  cb(i1,i2,i3,2) <- CONJG(ca(2,i1,i2,i3))
      call trans_f7(ca,cb,idh,n2,n3,key)

c** Length:n3 CFFT
c**     cb -> ca
c**      X(r1,r2,r3) -> X(r1,r2,k3)

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw3,n3,idh*n2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)
c**      X(r1,r2,k3) -> X(r1,k3,r2)

      call trans_b1(ca,cb,idh,n2,n3)

c** Length:n2 CFFT
c**     cb -> ca

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw2,n2,idh*n3,lp2,lp3,lp4,lp5,lp8) 

c**  cb(2,i1,i2,i3) <- CONJG(ca(i1,i3,i2,2))
      call trans_f8(ca,cb,idh,n1h,n2,n3,key)

c**  cb(2,i1,i2,i3) -> ca(2,i1,i2,i3)
      call cp_back(cb,ca,idh,n2,n3)

      return
      end

      subroutine trans_f7(ca,cb,idh,n2,n3,key)

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2-1,0:n3-1)
      real*8 cb(  0:idh-1,0:n2-1,0:n3-1,2)
      integer key
c***
      real*8 parity

      if(key.eq.-1) then
         parity = -1.0d0
      else if(key.eq.1) then
         parity = +1.0d0
      end if

c* Packing from ca to cb
      do 10 i3=0,n3-1
      do 10 i2=0,n2-1
      do 10 i1=0,idh-1

         cb(i1,i2,i3,1) =  ca(1,i1,i2,i3) 
         cb(i1,i2,i3,2) =  ca(2,i1,i2,i3)*parity 

 10   continue

      return
      end

      subroutine trans_b1(ca,cb,mm1,n2,n3)

      implicit real*8(a-h,o-z)
      real*8 ca(0:mm1-1,0:n2-1,0:n3-1,2)
      real*8 cb(0:mm1-1,0:n3-1,0:n2-1,2)

      do 10 i3=0,n3-1
      do 10 i2=0,n2-1
      do 10 i1=0,mm1-1

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

  10  continue

      return
      end

      subroutine trans_f8(cb,ca,idh,n1h,n2,n3,key)

      implicit real*8(a-h,o-z)
      real*8 ca(2,0:idh-1,0:n2-1,0:n3-1 )
      real*8 cb(  0:idh-1,0:n3-1,0:n2-1 ,2)
      integer n1h,n2,n3,key, nm
c*
      real*8 parity
      if(key.eq.+1) then
         parity = +1.0d0
         nm = idh - 1
      else if(key.eq.-1) then
         parity = -1.0d0
         nm = n1h
      end if

      do 10 i3=0,n3-1
      do 10 i2=0,n2-1
      do 10 i1=0,nm

         ca(1,i1,i2,i3) =   cb(i1,i3,i2,1)
         ca(2,i1,i2,i3) =   cb(i1,i3,i2,2)*parity

  10  continue

      if(key .eq. -1) then
         do i3=0,n3-1
            do i2=0, n2-1
               do i1=n1h+1,idh-1
                  ca(1,i1,i2,i3) = 0.d0
                  ca(2,i1,i2,i3) = 0.d0
               enddo
            enddo
         enddo
      end if

      return
      end

      subroutine jrcat_r1ft_of_3D_back(ca,cb,id,n1,n2,n3,cw1)
c                           @(#)jrcat_ft_stm.f 1.2 99/01/16 23:56:50
      implicit none

      integer id,n1,n2,n3
      real*8 ca (2, 0:id/2-1, 0:n2-1, 0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)
      complex*16 cw1(0:n1/2-1,2)

      integer n1h,idh,mm1,kc1
      integer lp2,lp3,lp4,lp5,lp8
      
      n1h = n1/2
      idh = id/2
      mm1 = n1h +1
      kc1 = 0

c** ca(2,i1,i2,i3) -> cb(i3,i2,i1,2)
      call trans_in_b6(ca,cb,idh,n2,n3,n1h)

c**
      call trans_in_b3(cb,ca,cw1(0,2),n3*n2,n1h,kc1)

c** Length:n1h RCFFT  

      call setlp(n1h,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(ca,cb,cw1,n1h,n3*n2,lp2,lp3,lp4,lp5,lp8)

c** ca(2,i1,i2,i3) <- cb(i3,i2,i1,2)

      call trans_in_b4(cb,ca,n3,n2,idh,n1h)

      return

      end  

      subroutine jrcat_r2ft_of_3D_back(ca,cb,id,n1,n2,n3,cw2,cw3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
      implicit none

      integer id,n1,n2,n3
      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer  n1h, idh
      integer lp2,lp3,lp4,lp5,lp8,key

      n1h = n1/2
      idh = id/2

      key = +1
c** Packin from ca(2,0:idh-1,0:n2-1,0:n3-1)
c**                         to cb(0:idh-1,0:n2-1,0:n3-1,2)
      call trans_f7(ca,cb,idh,n2,n3,key)

c** Length:n3 CFFT
c**     cb -> ca
c**      X(r1,r2,r3) -> X(r1,r2,k3)

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw3,n3,idh*n2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)
c**      X(r1,r2,k3) -> X(r1,k3,r2)

      call trans_b1(ca,cb,idh,n2,n3)

c** Length:n2 CFFT
c**     cb -> ca
c**      X(r1,k3,r2) -> X(r1,k3,k2)

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw2,n2,idh*n3,lp2,lp3,lp4,lp5,lp8) 

c**  cb(2,i1,i2,i3) <- ca(i1,i3,i2,2)
      call trans_f8(ca,cb,idh,n1h,n2,n3,key)

c**  cb(2,i1,i2,i3) -> ca(2,i1,i2,i3)
      call cp_back(cb,ca,idh,n2,n3)

      return
      end

      subroutine jrcat_r2ft_of_3D(ca,cb,id,n1,n2,n3,cw2,cw3,key)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c* * key == +1 (backward FFT)
c* * key == -1 (forward FFT)
      implicit none
      integer id,n1,n2,n3,key
      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)
      integer  n1h, idh
      integer lp2,lp3,lp4,lp5,lp8

      n1h = n1/2
      idh = id/2

c** (key == +1)
c**  Packin from ca(2,0:idh-1,0:n2-1,0:n3-1)
c**                         to cb(0:idh-1,0:n2-1,0:n3-1,2)
c** (key == -1)
c**  cb(i1,i2,i3,2) <- CONJG(ca(2,i1,i2,i3))
      call trans_f7(ca,cb,idh,n2,n3,key)
c** Length:n3 CFFT
c**     cb -> ca
c**      X(r1,r2,r3) -> X(r1,r2,k3)

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw3,n3,idh*n2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)
c**      X(r1,r2,k3) -> X(r1,k3,r2)

      call trans_b1(ca,cb,idh,n2,n3)

c** Length:n2 CFFT
c**     cb -> ca
c**      X(r1,k3,r2) -> X(r1,k3,k2)

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw2,n2,idh*n3,lp2,lp3,lp4,lp5,lp8) 

c** (key == +1)  cb(2,i1,i2,i3) <- ca(i1,i3,i2,2)
c** (key == -1)  cb(2,i1,i2,i3) <- CONJG(ca(i1,i3,i2,2))
      call trans_f8(ca,cb,idh,n1h,n2,n3,key)

c**  cb(2,i1,i2,i3) -> ca(2,i1,i2,i3)
      call cp_back(cb,ca,idh,n2,n3)

      return
      end

      subroutine cp_back(cb,ca,idh,n2,n3)
      implicit real*8 (a-h,o-z)
      
      real*8 ca(2,0:idh-1,0:n2-1, 0:n3-1)
      real*8 cb(2,0:idh-1,0:n2-1, 0:n3-1)

      do i3 = 0, n3-1
        do i2 = 0, n2-1
          do i1 = 0, idh-1
            ca(1,i1,i2,i3) = cb(1,i1,i2,i3)
            ca(2,i1,i2,i3) = cb(2,i1,i2,i3)
          end do
        end do
      end do

      return
      end

      subroutine trans_b5(cb,ca,idh,n2,n3)

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1, 0:n2-1, 0:n3-1)
      real*8 cb(  0:idh-1, 0:n3-1, 0:n2-1 ,2)

      do i2 = 0, n2-1
      do i3 = 0, n3-1
      do i1 = 0, idh-1

        ca(1,i1,i2,i3) = cb(i1,i3,i2,1)
        ca(2,i1,i2,i3) = cb(i1,i3,i2,2)

      end do
      end do
      end do

      return
      end 

      subroutine trans_in_b6(ca,cb,idh,n2,n3,n1h)

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2-1, 0:n3-1)
      real*8 cb(0:n3-1, 0:n2-1, 0:n1h ,2)

      do i1 = 0, n1h-1
      do i2 = 0, n2-1
      do i3 = 0, n3-1

        cb(i3,i2,i1,1) = ca(1,i1,i2,i3)
        cb(i3,i2,i1,2) = ca(2,i1,i2,i3)

      end do
      end do
      end do

      return
      end
c --------------------------------------------------------
      subroutine jrcat_c2ft_of_3D_back(ca,cb,id,n1,n2,n3,cw2,cw3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
      implicit none
      integer id,n1,n2,n3
      real*8 ca (0:id-1,0:n2-1,0:n3-1,2)
      real*8 cb (0:id-1,0:n2-1,0:n3-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer key
      key = -1
      
      call jrcat_c2ft_of_3D(ca,cb,id,n1,n2,n3,cw2,cw3,key)
      return
      end
c --------------------------------------------------------
      subroutine jrcat_c2ft_of_3D_forward(ca,cb,id,n1,n2,n3,cw2,cw3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
      implicit none
      integer id,n1,n2,n3
      real*8 ca (0:id-1,0:n2-1,0:n3-1,2)
      real*8 cb (0:id-1,0:n2-1,0:n3-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer key
      key = +1
      
      call jrcat_c2ft_of_3D(ca,cb,id,n1,n2,n3,cw2,cw3,key)
      return
      end


      subroutine trans_bc1(ca,cb,n1,n2,n3)

      implicit real*8(a-h,o-z)
      real*8 ca(0:n1-1,0:n2-1,0:n3-1,2)
      real*8 cb(0:n1-1,0:n3-1,0:n2-1,2)

      do 10 i3=0,n3-1
      do 10 i2=0,n2-1
      do 10 i1=0,n1-1

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

  10  continue

      return
      end
c --------------------------------------------------------
      subroutine jrcat_c2ft_of_3D(ca,cb,id,n1,n2,n3,cw2,cw3,key)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
      implicit none

      integer id,n1,n2,n3,key
      real*8 ca (0:id-1,0:n2-1,0:n3-1,2)
      real*8 cb (0:id-1,0:n2-1,0:n3-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer lp2,lp3,lp4,lp5,lp8

c** Packin from ca(2,0:id-1,0:n2-1,0:n3-1)
c**                         to cb(0:id-1,0:n2-1,0:n3-1,2)
c**  if(key == -1)
c**    cb(i1,i2,i3,2) <- CONJG(ca(2,i1,i2,i3)))
c**  else if(key == +1)
c**    cb(i1,i2,i3,2) <- ca(2,i1,i2,i3)
      call trans_fb0(ca,cb,id,n1,n2,n3,key)

c** Length:n3 CFFT
c**     cb -> ca
c**      X(r1,r2,r3) -> X(r1,r2,k3)

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw3,n3,n1*n2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)
c**      X(r1,r2,k3) -> X(r1,k3,r2)

      call trans_bc1(ca,cb,n1,n2,n3)

c** Length:n2 CFFT
c**     cb -> ca
c**      X(r1,k3,r2) -> X(r1,k3,k2)

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw2,n2,n1*n3,lp2,lp3,lp4,lp5,lp8) 
c**
c**  if(key == -1)
c**    cb(i1,i2,i3,2) <- CONJG(ca(i1,i3,i2,2))
c**  else if(key == +1)
c**    cb(i1,i2,i3,2) <- ca(i1,i3,i2,2)
c**  cb(2,i1,i2,i3) <- ca(i1,i3,i2,2)
      call trans_bc5(ca,cb,id,n1,n2,n3,key)

c**  cb(2,i1,i2,i3) -> ca(2,i1,i2,i3)
      call cp_back(cb,ca,id,n2,n3)

      return
      end

      subroutine trans_bc5(ca,cb,id,n1,n2,n3,key)
      implicit none

      integer id,n1,n2,n3,key
      real*8 ca(0:n1-1, 0:n3-1, 0:n2-1, 2)
      real*8 cb(2, 0:id-1, 0:n2-1, 0:n3-1)
c
      integer i3,i2,i1
      real*8 parity

      if(key.eq.+1) then
         parity = +1.0d0
      else if(key.eq.-1) then
         parity = -1.0d0
      end if

      do i3=0,n3-1
         do i2=0,n2-1
            do i1=0,id-1
               cb(1,i1,i2,i3) = 0.d0
               cb(2,i1,i2,i3) = 0.d0
            end do
         end do
      end do

      do i2 = 0, n2-1
      do i3 = 0, n3-1
      do i1 = 0, n1-1

        cb(1,i1,i2,i3) = ca(i1,i3,i2,1)
        cb(2,i1,i2,i3) = ca(i1,i3,i2,2)*parity

      end do
      end do
      end do

      return
      end 

      subroutine trans_fb0(ca,cb,id,n1,n2,n3,key)
      implicit none
      integer id,n1,n2,n3,key
      real*8 ca(2,id,n2*n3)
      real*8 cb(n1,n2*n3,2)
c***
      integer i23,i1
      real*8 parity

      if(key.eq.+1) then
         parity = +1.0d0
      else if(key.eq.-1) then
         parity = -1.0d0
      end if

      do i23 = 1,n2*n3
         do i1 = 1,n1

            cb(i1,i23,1) =   ca(1,i1,i23) 
            cb(i1,i23,2) =   ca(2,i1,i23)*parity

         end do
      end do

      return
      end
c --------------------------------------------------------
      subroutine jrcat_r3ft(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                      kc1,kc2,kc3,key)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
c
c------------------>      for Estimation of CPU cost.
c                             by T.Yamasaki
c                               22th May. 1996
      real*8 CRTVL, PCPUDF
      parameter (CRTVL = 1.d-5, PCPUDF = 2.0)
c        CRTVL : CRItical VaLue for Division.
c        PCPUDF: Percent of CPU DiFference.
      real*8 cpu0ol,cpudif,rcpudf,ecpu,tcpu
      integer icount
      data icount/0/
      data ecpu/0.d0/
      data cpu0ol/0.d0/
      real*8 t_start, t_end, UMICRO
      parameter (UMICRO = 1.d-6)
c <-------------------------------------------
      real*8 ra   (id,n2,n3)
      real*8 work (id,n2,n3)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank

c**********************************************************************
c*   key = 0 : set up of FFT.
c*             ( Calculation of cw1,cw2 and cw3. )
c**********************************************************************
c*   n1,n2 and n3 must include radix 2, and they may include 3 or 5.
c*   id must be larger than or equal to n1 + 2.
c*
c**********************************************************************
c*  key = -1 & -2 : F.T. of real 3d array ra(0:n1-1,0:n2-1,0:n3-1) .
c**********************************************************************
c*
c*   The result(complex 'cb') is overwritten on 'ra'.
c*   ( i.e. equivalence(ra,cb) ).
c*   
c*     cb(k1,k2,k3) 
c*   = sum(ix=0:n1-1,iy=0:n2-1,iz=0:n3-1) 
c*     ra(i1,i2,i3) exp [- 2 * pai * ci *
c*                                 ( k1*i1/n1 + k2*i2/n2 + k3*i3/n3 ) ]
c*     
c*     where 0 <= k1 <= n1/2, 0 <= k2 <= n2-1, 0 <= k3 <= n3-1.
c*
c**********************************************************************
c*  key = +1 & +2: Inverse F.T. of copmplex 3d array cb(0:n1/2,0:n2-1,
c*                                                        0:n3-1) .
c**********************************************************************
c*   Transform from 'cb' to 'ra'.
c*
c**********************************************************************
c*  kc1,kc2 kc3 are integer parameters specifying the mask for
c*  input data or output data.
c*
c*     If kc1.ge.n1/2.or.kc1.lt.0, then kc1 is forced to be 0. 
c*     If kc2.ge.n2/2.or.kc2.lt.0, then kc2 is forced to be 0. 
c*     If kc3.ge.n3/2.or.kc3.lt.0, then kc3 is forced to be 0. 
c*
c**********************************************************************
c** REMARK on Mask.
c**********************************************************************
c*
c*  key = -1 : Mask is for Output data ( cb ),
c*  key = +1 : Mask is for Input  data ( cb ),
c*  key = -2 : Mask is for Input  data ( ca ),
c*  key = +2 : Mask is for Output data ( ca ),
c*
c*     where ca(0:idh/2,0:n2-1,0:n3-1) and equivalence(ra,ca).
c*
c**********************************************************************
c*     Mask for Output data:
c**********************************************************************
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is calculated.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is calculated.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2<= n2-1" 
c*     range is calculated.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3<= n3-1" 
c*     range is calculated.
c*
c**********************************************************************
c*     Mask for Input data:
c**********************************************************************
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is used to obtain real array 'ra'.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is used.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2<= n2-1" 
c*     range is used.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3<= n3-1" 
c*     range is used.
c*
c**********************************************************************
c*
c******************************************************************
c**   choose nbank = 0 or nbank = 1 
c******************************************************************
c*   nbank = 0:
c*      The transpose is normally implemented.
c*      Bank conflict may appear patriculary in Vector Computers.
c*   nbank = 1:
c*      The transpose is implemented so as to prevent
c*      the bank conflict in the case the conflict may appear.
c******************************************************************
c
      call gettod(t_start)

      nbank = 0

c**

      if(key.eq.0) then

c** set up of FFT.

         call r3ft_0(cw1,cw2,cw3,n1,n2,n3)

         goto 1001
c$$$         return

      end if

c**
      if(kc1.ge.n1/2.or.kc1.lt.0) then 
         write(6,*) 'warning in FFT: kc1 is irrelevant.'
         write(6,*) 'kc1 has changed to be 0.'
         kc1 = 0
      end if

      if(kc2.ge.n2/2.or.kc2.lt.0) then 
         write(6,*) 'warning in FFT: kc2 is irrelevant.'
         write(6,*) 'kc2 has changed to be 0.'
         kc2 = 0
      end if

      if(kc3.ge.n3/2.or.kc3.lt.0) then 
         write(6,*) 'warning in FFT: kc3 is irrelevant.'
         write(6,*) 'kc3 has changed to be 0.'
         kc3 = 0
      end if
c**

      if(key.eq.-1) then

c** Forword FFT with mask for output.

         call r3ft_f_mask_for_out(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank)

      else if(key.eq.-2) then

c** Forword FFT with mask for input.

         call r3ft_f_mask_for_in (ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank)

      else if(key.eq.+1) then

c** Backword FFT with mask for input.

         call r3ft_b_mask_for_in (ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank)

      else if(key.eq.+2) then

c** Backword FFT with mask for output.

         call r3ft_b_mask_for_out(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank)

      end if

c**  
 1001 continue

c -------->  CPU cost estimation
      call gettod(t_end)
      tcpu = (t_end - t_start)*UMICRO
      icount = icount + 1
      ecpu = ecpu + tcpu
c <-------
      
      return

      entry jrc_r3strt
      icount = 0
      ecpu = 0.d0
      return
c--------------------------
      entry jrc_r3end
      cpudif = dabs(cpu0ol - ecpu)
      if(ecpu.gt.CRTVL) then
         rcpudf = cpudif/ecpu * 100.0
      else if(cpu0ol.le.CRTVL) then
         rcpudf = 0.0
      else
         rcpudf = 100.0
      endif
c               <-- Ratio in percent of CPU time difference
c                 between previous one and present one.
      cpu0ol = ecpu

c$$$      call eqivvl(rcpudf)

      if(rcpudf.gt.PCPUDF) then
         if(icount.gt.0) then
            tcpu = ecpu/dfloat(icount)
         endif
         write(6,9001) ecpu, icount, tcpu
 9001    format(1H ,' <<CPU TIME for JRCAT_R3FT = ',f11.3
     &        ,'(Sec.) = (',i6,' *',f10.5,')>>')
      endif
      return
      end  

      subroutine r3ft_0(cw1,cw2,cw3,n1,n2,n3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

c**
      if(mod(n1,2).ne.0) then
         stop 'The first length is not an even number.'
      end if

         n1h = n1/2

         pai=3.14159265358979323846d0
         pc =2.0d0*pai/dble(n1)
         ci=(0.0d0,1.0d0)

         call setcw(cw1,n1h)
         call setcw(cw2,n2 )
         call setcw(cw3,n3 ) 

      do i=0,n1h-1
         tr=dcos(pc*dble(i))
         ti=dsin(pc*dble(i))
         cw1(i,2)=ci*dcmplx(tr,ti)
      end do   

      return
      end  

      subroutine r3ft_b_mask_for_in(ca,cb,id,n1,n2,n3,cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)
c     complex*16 ca (0:id/2-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id/2-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
         n1h = n1/2
         idh = id/2

      if(kc1.eq.0) then
           mm1 = n1h+1
c          mm1 = idh
      else
           mm1 = kc1+1
      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

c** Packin from ca(2,0:idh-1,0:n2-1,0:n3-1)
c**        to   cb(0:mm1-1,0:mm2-1,0:n3-1,2)

      call trans_in_b0(ca,cb,idh,n2,n3,mm1,mm2,kc1,kc2,kc3)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw3,n3,mm1*mm2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)

      call trans_in_b1(ca,cb,mm1,n2,mm2,n3,kc2)

c** Length:n2 CFFT    

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw2,n2,mm1*n3,lp2,lp3,lp4,lp5,lp8) 

c** cb(i3,i2,i1,2) <- ca(i1,i3,i2,2)

      call trans_in_b2(ca,cb,mm1,n2,n3,n1h)

c**
      call trans_in_b3(cb,ca,cw1(0,2),n3*n2,n1h,kc1)

c** Length:n1h RCFFT  

      call setlp(n1h,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(ca,cb,cw1,n1h,n3*n2,lp2,lp3,lp4,lp5,lp8)

c** ca(2,i1,i2,i3) <- cb(i3,i2,i1,2)

      call trans_in_b4(cb,ca,n3,n2,idh,n1h)

      return

      end  

      subroutine r3ft_b_mask_for_out(ca,cb,id,n1,n2,n3,
     &                        cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)
c     complex*16 ca (0:id/2-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id/2-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
         n1h = n1/2
         idh = id/2

      if(kc1.eq.0) then
           mm1 = n1h+1 
      else
           mm1 = kc1+1
      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

      if(kc3.eq.0) then
           mm3 = n3
      else
           mm3 = kc3*2+1
      end if

c** cb(i1,i2,i3,2) <- ca(2,i1,i2,i3)

      call trans_out_b0(ca,cb,idh,n2,n3,n1h)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw3,n3,(n1h+1)*n2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)

      call trans_out_b1(ca,cb,n1h,n2,n3,mm3,kc3)

c** Length:n2 CFFT    

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw2,n2,(n1h+1)*mm3,lp2,lp3,lp4,lp5,lp8) 

c** cb(i3,i2,i1,2) <- ca(i1,i3,i2,2)

      call trans_out_b2(ca,cb,n1h,n2,mm2,mm3,kc2)

c**
      call trans_out_b3(cb,ca,cw1(0,2),mm3*mm2,n1h)

c** Length:n1h RCFFT  

      call setlp(n1h,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(ca,cb,cw1,n1h,mm3*mm2,lp2,lp3,lp4,lp5,lp8)

c** ca(2,i1,i2,i3) <- cb(i3,i2,i1,2)

      call trans_out_b4(cb,ca,idh,n1h,n2,n3,mm2,mm3,kc1,kc2,kc3)

      return

      end  

      subroutine r3ft_f_mask_for_out(ca,cb,id,n1,n2,n3,
     &                        cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)
c     complex*16 ca (0:id/2-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id/2-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
         n1h = n1/2
         idh = id/2

      if(kc1.eq.0) then
           mm1 = n1h+1
      else
           mm1 = kc1+1
      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if
    
c**   cb(i3,i2,i1,2) <- CONJG(ca(2,i1,i2,i3))

         call trans_out_f1(ca,cb,idh,n1h,n2,n3)
 
c** Length:n1h RFFT

      call setlp(n1h,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw1,n1h,n3*n2,lp2,lp3,lp4,lp5,lp8)
      
c** Transform from 'n1h' complex to 'n1' real array. 

         call trans_out_f2(ca,cb,cw1(0,2),n3,n2,n1h,kc1) 

c**   ca(i3,k1,i2,2) <- cb(i3,i2,k1,2)

         call trans_out_f3(cb,ca,n3,n2,mm1,n1h)

c** Length:n2 CFFT  

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(ca,cb,cw2,n2,n3*mm1,lp2,lp3,lp4,lp5,lp8)

c**   ca(k1,k2,i3,2) <- cb(i3,k1,k2,2)

            call trans_out_f4(cb,ca,n3,mm1,n2,mm2,kc2)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(ca,cb,cw3,n3,mm1*mm2,lp2,lp3,lp4,lp5,lp8)

c**   ca(2,i1,i2,i3) <- CONJG(cb(i1,i2,i3,2))

         call trans_out_f5(cb,ca,idh,n1h,n2,n3,mm1,mm2,kc1,kc2,kc3)

      return

      end  

      subroutine r3ft_f_mask_for_in(ca,cb,id,n1,n2,n3,cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)

c     complex*16 ca (0:id/2-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id/2-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
         n1h = n1/2
         idh = id/2

      if(kc1.eq.0) then
           mm1 = n1h+1 
      else
           mm1 = kc1+1
      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

      if(kc3.eq.0) then
           mm3 = n3
      else
           mm3 = kc3*2+1
      end if
    
c**   cb(i3,i2,i1,2) <- CONJG(ca(2,i1,i2,i3))

         call trans_in_f1(ca,cb,idh,n1h,n2,n3,mm2,mm3,kc1,kc2,kc3)

c** Length:n1h RFFT

      call setlp(n1h,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw1,n1h,mm3*mm2,lp2,lp3,lp4,lp5,lp8)
      
c** Transform from 'n1h' complex to 'n1' real array. 

         call trans_in_f2(ca,cb,cw1(0,2),mm3,mm2,n1h) 

c**   ca(i3,k1,i2,2) <- cb(i3,i2,k1,2)

         call trans_in_f3(cb,ca,mm3,n2,mm2,n1h,kc2)

c** Length:n2 CFFT  

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(ca,cb,cw2,n2,mm3*(n1h+1),lp2,lp3,lp4,lp5,lp8)

c**   ca(k1,k2,i3,2) <- cb(i3,k1,k2,2)

            call trans_in_f4(cb,ca,n1h,n2,n3,mm3,kc3)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(ca,cb,cw3,n3,(n1h+1)*n2,lp2,lp3,lp4,lp5,lp8)

c**   ca(2,i1,i2,i3) <- CONJG(cb(i1,i2,i3,2))

         call trans_in_f5(cb,ca,idh,n1h,n2,n3)

      return

      end  

      subroutine fsb_lp235(ca,cb,cw,n,ndim,lp2,lp3,lp4,lp5,lp8)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
      implicit complex*16(a-h,o-z)

      real*8 ca(ndim*n*2),cb(ndim*n*2)
c     complex*16 ca(ndim,n),cb(ndim,n)

      complex*16 cw(0:n-1)

      k =1
      la=1

c*** RADIX 2 FFT.

      do 2 i=1,lp2
      if(k.eq.1) then
         call fsb_lp2(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp2(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*2
    2 continue

c*** RADIX 3 FFT.

      do 3 i=1,lp3
      if(k.eq.1) then
         call fsb_lp3(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp3(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*3
    3 continue

c*** RADIX 4 FFT.

      do 4 i=1,lp4
      if(k.eq.1) then
         call fsb_lp4(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp4(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*4
    4 continue

c*** RADIX 5 FFT.

      do 5 i=1,lp5
      if(k.eq.1) then
         call fsb_lp5(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp5(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*5
    5 continue

c*** RADIX 8 FFT.

      do 8 i=1,lp8
      if(k.eq.1) then
         call fsb_lp8(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp8(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*8
    8 continue
c***
      if(k.eq.+1) then

         do 100 ii=1,ndim*n*2
            cb(ii)=ca(ii)
  100    continue

      else

         do 101 ii=1,ndim*n*2
            ca(ii)=cb(ii)
  101    continue

      end if
c**
      return
      end
c---------------------------------------------
      subroutine fsb_lp2(ca,cb,cw,la,n,ndim)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c---------------------------------------------
      implicit real*8(a-h,o-z)

      real*8 ca(ndim,n,2),cb(ndim,n,2),cw(2,0:n-1)

      m=n/2
      np=(m-la)/la

      i1=m
      j1=la
      jump=la  

      do 20 l=1,la
      do 20 ii=1,ndim

         cb(ii,l   ,1)=(ca(ii,l,1)+ca(ii,l+i1,1))
         cb(ii,l   ,2)=(ca(ii,l,2)+ca(ii,l+i1,2))

         cb(ii,l+j1,1)=(ca(ii,l,1)-ca(ii,l+i1,1))
         cb(ii,l+j1,2)=(ca(ii,l,2)-ca(ii,l+i1,2))

   20 continue

      do 21 kp=1,np
      do 21 l=1,la
      do 21 ii=1,ndim

         i0=l+kp*la         
         j0=l+kp*(la+jump)         

         cb(ii,j0   ,1)=(ca(ii,i0,1)+ca(ii,i0+i1,1))
         cb(ii,j0   ,2)=(ca(ii,i0,2)+ca(ii,i0+i1,2))

         cc1r = ca(ii,i0,1)-ca(ii,i0+i1,1)
         cc1i = ca(ii,i0,2)-ca(ii,i0+i1,2)

         cb(ii,j0+j1,1)=cc1r*cw(1,kp*la) - cc1i*cw(2,kp*la)
         cb(ii,j0+j1,2)=cc1r*cw(2,kp*la) + cc1i*cw(1,kp*la)

   21 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp3(ca,cb,cw,la,n,ndim)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c---------------------------------------------
      implicit real*8(a-h,o-z)  

      real*8 ca(ndim,n,2),cb(ndim,n,2),cw(2,0:n-1)

      real*8 sin60

      m=n/3
      np=(m-la)/la

      i1=m
      i2=m*2 

      j1=la
      j2=la*2

      jump=la*2

      sin60=0.5d0*dsqrt(3.0d0)

c*    k=0 
      do 30 l=1,la
      do 30 ii=1,ndim

         ct1r=ca(ii,l+i1,1)+ca(ii,l+i2,1)
         ct1i=ca(ii,l+i1,2)+ca(ii,l+i2,2)

         ct2r=ca(ii,l   ,1)-0.5d0*ct1r       
         ct2i=ca(ii,l   ,2)-0.5d0*ct1i       

         ct3r= - sin60*(ca(ii,l+i1,2)-ca(ii,l+i2,2))
         ct3i=   sin60*(ca(ii,l+i1,1)-ca(ii,l+i2,1))

         cb(ii,l   ,1)=ca(ii,l,1)+ct1r
         cb(ii,l   ,2)=ca(ii,l,2)+ct1i

         cb(ii,l+j1,1)=(ct2r+ct3r)
         cb(ii,l+j1,2)=(ct2i+ct3i)

         cb(ii,l+j2,1)=(ct2r-ct3r)
         cb(ii,l+j2,2)=(ct2i-ct3i)

   30 continue

      do 31 kp=1,np
      do 31 l=1,la
      do 31 ii=1,ndim

         i0=l+kp*la         
         j0=l+kp*(la+jump)         

         ct1r=ca(ii,i0+i1,1)+ca(ii,i0+i2,1)
         ct1i=ca(ii,i0+i1,2)+ca(ii,i0+i2,2)

         ct2r=ca(ii,i0   ,1)-0.5d0*ct1r       
         ct2i=ca(ii,i0   ,2)-0.5d0*ct1i       

         ct3r= - sin60*(ca(ii,i0+i1,2)-ca(ii,i0+i2,2))
         ct3i=   sin60*(ca(ii,i0+i1,1)-ca(ii,i0+i2,1))

         cb(ii,j0   ,1)=ca(ii,i0,1)+ct1r
         cb(ii,j0   ,2)=ca(ii,i0,2)+ct1i

         ct4r = ct2r + ct3r
         ct4i = ct2i + ct3i

         ct5r = ct2r - ct3r
         ct5i = ct2i - ct3i

         cb(ii,j0+j1,1)=ct4r*cw(1,kp*j1) - ct4i*cw(2,kp*j1)
         cb(ii,j0+j1,2)=ct4r*cw(2,kp*j1) + ct4i*cw(1,kp*j1)

         cb(ii,j0+j2,1)=ct5r*cw(1,kp*j2) - ct5i*cw(2,kp*j2)
         cb(ii,j0+j2,2)=ct5r*cw(2,kp*j2) + ct5i*cw(1,kp*j2)

   31 continue

      return
      end

c---------------------------------------------
      subroutine fsb_lp4(ca,cb,cw,la,n,ndim)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c---------------------------------------------
      implicit real*8(a-h,o-z)

      real*8 ca(ndim,n,2),cb(ndim,n,2),cw(2,0:n-1)

         m   =n/4
         np  =(m-la)/la
         jump=la*3
   
      do 40 l=1,la
      do 40 ii=1,ndim

      cc0r = ca(ii,l  ,1)+ca(ii,l+2*M,1)
      cc0i = ca(ii,l  ,2)+ca(ii,l+2*M,2)

      cc1r = ca(ii,l+M,1)+ca(ii,l+3*M,1)
      cc1i = ca(ii,l+M,2)+ca(ii,l+3*M,2)

      cc2r = ca(ii,l  ,1)-ca(ii,l+2*M,1)
      cc2i = ca(ii,l  ,2)-ca(ii,l+2*M,2)

      cc3r = - ca(ii,l+M,2) + ca(ii,l+3*M,2)
      cc3i =   ca(ii,l+M,1) - ca(ii,l+3*M,1)

         cb(ii,l     ,1)= cc0r+cc1r
         cb(ii,l     ,2)= cc0i+cc1i

         cb(ii,l+  LA,1)= cc2r+cc3r
         cb(ii,l+  LA,2)= cc2i+cc3i

         cb(ii,l+2*LA,1)= cc0r-cc1r
         cb(ii,l+2*LA,2)= cc0i-cc1i

         cb(ii,l+3*LA,1)= cc2r-cc3r
         cb(ii,l+3*LA,2)= cc2i-cc3i

   40 continue
   
      DO 41 KP=1,NP
      DO 41 L=1,LA
      DO 41 ii=1,ndim

         I0=L+KP* LA
         J0=L+KP*(LA+JUMP)

      cc1r =  ca(ii,I0  ,1)+ca(ii,I0+2*M,1)
      cc1i =  ca(ii,I0  ,2)+ca(ii,I0+2*M,2)

      cc2r =  ca(ii,I0+M,1)+ca(ii,I0+3*M,1)
      cc2i =  ca(ii,I0+M,2)+ca(ii,I0+3*M,2)

      cc3r =  ca(ii,I0  ,1)-ca(ii,I0+2*M,1)
      cc3i =  ca(ii,I0  ,2)-ca(ii,I0+2*M,2)

      cc4r = -ca(ii,I0+M,2)+ca(ii,I0+3*M,2)
      cc4i =  ca(ii,I0+M,1)-ca(ii,I0+3*M,1)

         cc5r = cc3r + cc4r
         cc5i = cc3i + cc4i

         cc6r = cc1r - cc2r
         cc6i = cc1i - cc2i

         cc7r = cc3r - cc4r
         cc7i = cc3i - cc4i

         cb(ii,J0     ,1) = cc1r+cc2r
         cb(ii,J0     ,2) = cc1i+cc2i

         cb(ii,J0+  LA,1) = cc5r*cw(1,KP*LA  ) - cc5i*cw(2,KP*LA  )
         cb(ii,J0+  LA,2) = cc5r*cw(2,KP*LA  ) + cc5i*cw(1,KP*LA  )

         cb(ii,J0+2*LA,1) = cc6r*cw(1,KP*LA*2) - cc6i*cw(2,KP*LA*2)
         cb(ii,J0+2*LA,2) = cc6r*cw(2,KP*LA*2) + cc6i*cw(1,KP*LA*2)

         cb(ii,J0+3*LA,1) = cc7r*cw(1,KP*LA*3) - cc7i*cw(2,KP*LA*3)
         cb(ii,J0+3*LA,2) = cc7r*cw(2,KP*LA*3) + cc7i*cw(1,KP*LA*3)

   41 continue
         
      RETURN
      END

c---------------------------------------------
      subroutine fsb_lp5(ca,cb,cw,la,n,ndim)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c---------------------------------------------
      implicit real*8(a-h,o-z)

      real*8 ca(ndim,n,2),cb(ndim,n,2),cw(2,0:n-1)
      real*8 pai,sin36,sin72,r54

      m=n/5
      np  =(m-la)/la

      i1=m
      i2=m*2 
      i3=m*3 
      i4=m*4 

      j1=la
      j2=la*2
      j3=la*3
      j4=la*4

      jump=la*4

      pai  =3.14159265358979323846d0
      sin36=dsin(pai*0.2d0)
      sin72=dsin(pai*0.4d0)
      r54  =dsqrt(5.0d0)/4.0d0

c** k=0
      do 50 l=1,la
      do 50 ii=1,ndim

         ct1r=ca(ii,l+i1,1)+ca(ii,l+i4,1)
         ct1i=ca(ii,l+i1,2)+ca(ii,l+i4,2)

         ct2r=ca(ii,l+i2,1)+ca(ii,l+i3,1)
         ct2i=ca(ii,l+i2,2)+ca(ii,l+i3,2)

         ct3r=ca(ii,l+i1,1)-ca(ii,l+i4,1)
         ct3i=ca(ii,l+i1,2)-ca(ii,l+i4,2)

         ct4r=ca(ii,l+i2,1)-ca(ii,l+i3,1)
         ct4i=ca(ii,l+i2,2)-ca(ii,l+i3,2)

         ct5r=     ct1r+ct2r
         ct5i=     ct1i+ct2i

         ct6r=r54*(ct1r-ct2r)
         ct6i=r54*(ct1i-ct2i)

         ct7r=ca(ii,l   ,1)-0.25d0*ct5r
         ct7i=ca(ii,l   ,2)-0.25d0*ct5i

         ct8r=ct7r+ct6r
         ct8i=ct7i+ct6i

         ct9r=ct7r-ct6r
         ct9i=ct7i-ct6i

         ct10r=-(sin72*ct3i+sin36*ct4i)
         ct10i= (sin72*ct3r+sin36*ct4r)

         ct11r=-(sin36*ct3i-sin72*ct4i)
         ct11i= (sin36*ct3r-sin72*ct4r)

         cb(ii,l   ,1)=ca(ii,l,1)+ct5r
         cb(ii,l   ,2)=ca(ii,l,2)+ct5i

         cb(ii,l+j1,1)=(ct8r+ct10r)
         cb(ii,l+j1,2)=(ct8i+ct10i)

         cb(ii,l+j2,1)=(ct9r+ct11r)
         cb(ii,l+j2,2)=(ct9i+ct11i)

         cb(ii,l+j3,1)=(ct9r-ct11r)
         cb(ii,l+j3,2)=(ct9i-ct11i)

         cb(ii,l+j4,1)=(ct8r-ct10r)
         cb(ii,l+j4,2)=(ct8i-ct10i)

   50 continue

      do 51 kp=1,np
      do 51 l=1,la
      do 51 ii=1,ndim

         I0=L+KP* LA
         J0=L+KP*(LA+JUMP)

         ct1r=ca(ii,i0+i1,1)+ca(ii,i0+i4,1)
         ct1i=ca(ii,i0+i1,2)+ca(ii,i0+i4,2)

         ct2r=ca(ii,i0+i2,1)+ca(ii,i0+i3,1)
         ct2i=ca(ii,i0+i2,2)+ca(ii,i0+i3,2)

         ct3r=ca(ii,i0+i1,1)-ca(ii,i0+i4,1)
         ct3i=ca(ii,i0+i1,2)-ca(ii,i0+i4,2)

         ct4r=ca(ii,i0+i2,1)-ca(ii,i0+i3,1)
         ct4i=ca(ii,i0+i2,2)-ca(ii,i0+i3,2)

         ct5r=     ct1r+ct2r
         ct5i=     ct1i+ct2i

         ct6r=r54*(ct1r-ct2r)
         ct6i=r54*(ct1i-ct2i)

         ct7r=ca(ii,i0  ,1)-0.25d0*ct5r
         ct7i=ca(ii,i0  ,2)-0.25d0*ct5i

         ct8r=ct7r+ct6r
         ct8i=ct7i+ct6i

         ct9r=ct7r-ct6r
         ct9i=ct7i-ct6i

         ct10r=-(sin72*ct3i+sin36*ct4i)
         ct10i= (sin72*ct3r+sin36*ct4r)

         ct11r=-(sin36*ct3i-sin72*ct4i)
         ct11i= (sin36*ct3r-sin72*ct4r)

         ct12r = ct8r + ct10r
         ct12i = ct8i + ct10i

         ct13r = ct9r + ct11r
         ct13i = ct9i + ct11i

         ct14r = ct9r - ct11r
         ct14i = ct9i - ct11i

         ct15r = ct8r - ct10r
         ct15i = ct8i - ct10i

         cb(ii,j0   ,1)=ca(ii,i0,1)+ct5r
         cb(ii,j0   ,2)=ca(ii,i0,2)+ct5i

         cb(ii,j0+j1,1)=ct12r*cw(1,kp*j1)-ct12i*cw(2,kp*j1)
         cb(ii,j0+j1,2)=ct12r*cw(2,kp*j1)+ct12i*cw(1,kp*j1)

         cb(ii,j0+j2,1)=ct13r*cw(1,kp*j2)-ct13i*cw(2,kp*j2)
         cb(ii,j0+j2,2)=ct13r*cw(2,kp*j2)+ct13i*cw(1,kp*j2)

         cb(ii,j0+j3,1)=ct14r*cw(1,kp*j3)-ct14i*cw(2,kp*j3)
         cb(ii,j0+j3,2)=ct14r*cw(2,kp*j3)+ct14i*cw(1,kp*j3)

         cb(ii,j0+j4,1)=ct15r*cw(1,kp*j4)-ct15i*cw(2,kp*j4)
         cb(ii,j0+j4,2)=ct15r*cw(2,kp*j4)+ct15i*cw(1,kp*j4)

   51 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp8(ca,cb,cw,la,n,ndim)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c---------------------------------------------
      implicit real*8(a-h,o-z)

      real*8 CA(ndim,n,2),CB(ndim,n,2),CW(2,0:n-1)
   
         R2=0.5D0
         X=DSQRT(R2)

         M   =N/8
         NP  =(M-LA)/LA
         JUMP=LA*7

      DO 80 L=1,LA
      DO 80 ii=1,ndim

      CC0r = CA(ii,l    ,1)+CA(ii,l+4*M,1)
      CC0i = CA(ii,l    ,2)+CA(ii,l+4*M,2)

      CC1r = CA(ii,l+  M,1)+CA(ii,l+5*M,1)
      CC1i = CA(ii,l+  M,2)+CA(ii,l+5*M,2)

      CC2r = CA(ii,l+2*M,1)+CA(ii,l+6*M,1)
      CC2i = CA(ii,l+2*M,2)+CA(ii,l+6*M,2)

      CC3r = CA(ii,l+3*M,1)+CA(ii,l+7*M,1)
      CC3i = CA(ii,l+3*M,2)+CA(ii,l+7*M,2)

      CC4r = CA(ii,l    ,1)-CA(ii,l+4*M,1)
      CC4i = CA(ii,l    ,2)-CA(ii,l+4*M,2)

      CC5r = CA(ii,l+  M,1)-CA(ii,l+5*M,1)
      CC5i = CA(ii,l+  M,2)-CA(ii,l+5*M,2)

      CC6r = -CA(ii,l+2*M,2)+CA(ii,l+6*M,2)
      CC6i =  CA(ii,l+2*M,1)-CA(ii,l+6*M,1)

      CC7r = -CA(ii,l+3*M,2)+CA(ii,l+7*M,2)
      CC7i =  CA(ii,l+3*M,1)-CA(ii,l+7*M,1)

         CD0r = CC0r+CC2r
         CD0i = CC0i+CC2i

         CD1r = CC1r+CC3r
         CD1i = CC1i+CC3i

         CD2r = CC4r+CC6r
         CD2i = CC4i+CC6i

            CE1r = CC5r+CC7r
            CE1i = CC5i+CC7i

         CD3r = (CE1r-CE1i)*x
         CD3i = (CE1r+CE1i)*x

         CD4r = CC0r-CC2r
         CD4i = CC0i-CC2i

         CD5r =-(CC1i-CC3i)
         CD5i = (CC1r-CC3r)

         CD6r = CC4r-CC6r
         CD6i = CC4i-CC6i

            CE2r = CC5r-CC7r
            CE2i = CC5i-CC7i

         CD7r = (-CE2r-CE2i)*x
         CD7i = ( CE2r-CE2i)*x

      CB(ii,l     ,1) = CD0r+CD1r
      CB(ii,l     ,2) = CD0i+CD1i

      CB(ii,l+  LA,1) = CD2r+CD3r
      CB(ii,l+  LA,2) = CD2i+CD3i

      CB(ii,l+2*LA,1) = CD4r+CD5r
      CB(ii,l+2*LA,2) = CD4i+CD5i

      CB(ii,l+3*LA,1) = CD6r+CD7r
      CB(ii,l+3*LA,2) = CD6i+CD7i

      CB(ii,l+4*LA,1) = CD0r-CD1r
      CB(ii,l+4*LA,2) = CD0i-CD1i

      CB(ii,l+5*LA,1) = CD2r-CD3r
      CB(ii,l+5*LA,2) = CD2i-CD3i

      CB(ii,l+6*LA,1) = CD4r-CD5r
      CB(ii,l+6*LA,2) = CD4i-CD5i

      CB(ii,l+7*LA,1) = CD6r-CD7r
      CB(ii,l+7*LA,2) = CD6i-CD7i

   80 CONTINUE
   
      DO 81 KP=1,NP
      DO 81 L=1,LA
      DO 81 ii=1,ndim

         I0=L+KP*LA
         J0=L+KP*(LA+JUMP)

      CC0r = CA(ii,I0    ,1)+CA(ii,I0+4*M,1)
      CC0i = CA(ii,I0    ,2)+CA(ii,I0+4*M,2)

      CC1r = CA(ii,I0+  M,1)+CA(ii,I0+5*M,1)
      CC1i = CA(ii,I0+  M,2)+CA(ii,I0+5*M,2)

      CC2r = CA(ii,I0+2*M,1)+CA(ii,I0+6*M,1)
      CC2i = CA(ii,I0+2*M,2)+CA(ii,I0+6*M,2)

      CC3r = CA(ii,I0+3*M,1)+CA(ii,I0+7*M,1)
      CC3i = CA(ii,I0+3*M,2)+CA(ii,I0+7*M,2)

      CC4r = CA(ii,I0    ,1)-CA(ii,I0+4*M,1)
      CC4i = CA(ii,I0    ,2)-CA(ii,I0+4*M,2)

      CC5r = CA(ii,I0+  M,1)-CA(ii,I0+5*M,1)
      CC5i = CA(ii,I0+  M,2)-CA(ii,I0+5*M,2)

      CC6r = -CA(ii,I0+2*M,2)+CA(ii,I0+6*M,2)
      CC6i =  CA(ii,I0+2*M,1)-CA(ii,I0+6*M,1)

      CC7r = -CA(ii,I0+3*M,2)+CA(ii,I0+7*M,2)
      CC7i =  CA(ii,I0+3*M,1)-CA(ii,I0+7*M,1)

         CD0r = CC0r+CC2r
         CD0i = CC0i+CC2i

         CD1r = CC1r+CC3r
         CD1i = CC1i+CC3i

         CD2r = CC4r+CC6r
         CD2i = CC4i+CC6i

            CE1r = CC5r+CC7r
            CE1i = CC5i+CC7i

         CD3r = (CE1r-CE1i)*x
         CD3i = (CE1r+CE1i)*x

         CD4r = CC0r-CC2r
         CD4i = CC0i-CC2i

         CD5r =-(CC1i-CC3i)
         CD5i = (CC1r-CC3r)

         CD6r = CC4r-CC6r
         CD6i = CC4i-CC6i

            CE2r = CC5r-CC7r
            CE2i = CC5i-CC7i

         CD7r = (-CE2r-CE2i)*x
         CD7i = ( CE2r-CE2i)*x

      CF1r = CD2r+CD3r
      CF1i = CD2i+CD3i

      CF2r = CD4r+CD5r
      CF2i = CD4i+CD5i

      CF3r = CD6r+CD7r
      CF3i = CD6i+CD7i

      CF4r = CD0r-CD1r
      CF4i = CD0i-CD1i

      CF5r = CD2r-CD3r
      CF5i = CD2i-CD3i

      CF6r = CD4r-CD5r
      CF6i = CD4i-CD5i

      CF7r = CD6r-CD7r
      CF7i = CD6i-CD7i

      CB(ii,J0     ,1) = CD0r+CD1r
      CB(ii,J0     ,2) = CD0i+CD1i

      CB(ii,J0+  LA,1) = CF1r*CW(1,KP*LA  )-CF1i*CW(2,KP*LA  )
      CB(ii,J0+  LA,2) = CF1r*CW(2,KP*LA  )+CF1i*CW(1,KP*LA  )

      CB(ii,J0+2*LA,1) = CF2r*CW(1,KP*LA*2)-CF2i*CW(2,KP*LA*2)
      CB(ii,J0+2*LA,2) = CF2r*CW(2,KP*LA*2)+CF2i*CW(1,KP*LA*2)

      CB(ii,J0+3*LA,1) = CF3r*CW(1,KP*LA*3)-CF3i*CW(2,KP*LA*3)
      CB(ii,J0+3*LA,2) = CF3r*CW(2,KP*LA*3)+CF3i*CW(1,KP*LA*3)

      CB(ii,J0+4*LA,1) = CF4r*CW(1,KP*LA*4)-CF4i*CW(2,KP*LA*4)
      CB(ii,J0+4*LA,2) = CF4r*CW(2,KP*LA*4)+CF4i*CW(1,KP*LA*4)

      CB(ii,J0+5*LA,1) = CF5r*CW(1,KP*LA*5)-CF5i*CW(2,KP*LA*5)
      CB(ii,J0+5*LA,2) = CF5r*CW(2,KP*LA*5)+CF5i*CW(1,KP*LA*5)

      CB(ii,J0+6*LA,1) = CF6r*CW(1,KP*LA*6)-CF6i*CW(2,KP*LA*6)
      CB(ii,J0+6*LA,2) = CF6r*CW(2,KP*LA*6)+CF6i*CW(1,KP*LA*6)

      CB(ii,J0+7*LA,1) = CF7r*CW(1,KP*LA*7)-CF7i*CW(2,KP*LA*7)
      CB(ii,J0+7*LA,2) = CF7r*CW(2,KP*LA*7)+CF7i*CW(1,KP*LA*7)

   81 CONTINUE
C**
      RETURN
      END
      subroutine setcw(cw,n)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      complex*16 cw(0:n-1)

      pai=3.14159265358979323846d0
      pc =2.0d0*pai/dble(n)

      do 10 i=0,n-1
         tr=dcos(pc*dble(i))
         ti=dsin(pc*dble(i))
         cw(i)=dcmplx(tr,ti)
   10 continue

      return
      end
      subroutine setlp(n,lp2,lp3,lp4,lp5,lp8)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
      implicit real*8(a-b,d-h,o-z)

         nn =n

         lp8=0
         lp5=0
         lp4=0
         lp3=0
         lp2=0

      do while(mod(nn,8).eq.0)
         lp8=lp8+1
         nn=nn/8
      end do

      do while(mod(nn,5).eq.0)
         lp5=lp5+1
         nn=nn/5
      end do

      do while(mod(nn,4).eq.0)
         lp4=lp4+1
         nn=nn/4
      end do

      do while(mod(nn,3).eq.0)
         lp3=lp3+1
         nn=nn/3
      end do

      do while(mod(nn,2).eq.0)
         lp2=lp2+1
         nn=nn/2
      end do

c     if(lp8+lp4+lp2.eq.0) stop 'n is not an even number.'
      if(nn.ne.1) stop 'n is an improper number.'

      return
      end
      subroutine trans_in_b0(ca,cb,idh,n2,n3,mm1,mm2,kc1,kc2,kc3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2-1 ,0:n3-1)
      real*8 cb(0:mm1-1,0:mm2-1,0:n3-1,2)

c     complex*16 ca(0:idh-1,0:n2-1 ,0:n3-1)
c     complex*16 cb(0:mm1-1,0:mm2-1,0:n3-1)
c*
      if(kc1.eq.0) then
         kk1 = mm1-1
      else
         kk1 = kc1
      end if 

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if 

c*
c* Packing from ca to cb
  
      do 10 i3=0,n3-1
      do 10 i2=0,kk2
      do 10 i1=0,kk1

         cb(i1,i2,i3,1) = ca(1,i1,i2,i3) 
         cb(i1,i2,i3,2) = ca(2,i1,i2,i3) 

  10  continue

      if(kc2.ne.0) then

         nskip2 = kc2*2+1-n2

         do 20 i3=0,n3-1
         do 20 i2=n2-kc2,n2-1
         do 20 i1=0,kk1

            cb(i1,i2+nskip2,i3,1) = ca(1,i1,i2,i3) 
            cb(i1,i2+nskip2,i3,2) = ca(2,i1,i2,i3) 

  20     continue

      end if
c*
      if(kc3.ne.0) then

         do 30 i3=kc3+1,n3-kc3-1
         do 30 i2=0,mm2-1
         do 30 i1=0,mm1-1

            cb(i1,i2,i3,1) = 0.0d0
            cb(i1,i2,i3,2) = 0.0d0

  30     continue

      end if
       
c*
      return
      end
      subroutine trans_in_b1(ca,cb,mm1,n2,mm2,n3,kc2)

      implicit real*8(a-h,o-z)
      real*8 ca(0:mm1-1,0:mm2-1,0:n3-1,2)
      real*8 cb(0:mm1-1,0:n3-1 ,0:n2-1,2)

c     complex*16 ca(0:mm1-1,0:mm2-1,0:n3-1)
c     complex*16 cb(0:mm1-1,0:n3-1 ,0:n2-1)

c*
      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

c*
      do 10 i3=0,n3-1
      do 10 i2=0,kk2
      do 10 i1=0,mm1-1

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

  10  continue

c*
      if(kc2.ne.0) then

         do 20 i2=kc2+1,n2-kc2-1
         do 20 i3=0,n3-1
         do 20 i1=0,mm1-1

            cb(i1,i3,i2,1) = 0.0d0 
            cb(i1,i3,i2,2) = 0.0d0 

  20     continue

         nstep2 = kc2*2-n2+1

         do 30 i3=0,n3-1
         do 30 i2=n2-kc2,n2-1
         do 30 i1=0,mm1-1

            cb(i1,i3,i2,1) = ca(i1,i2+nstep2,i3,1)
            cb(i1,i3,i2,2) = ca(i1,i2+nstep2,i3,2)

  30     continue

      end if
c*

      return
      end
      subroutine trans_in_b2(ca,cb,mm1,n2,n3,n1h)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm1-1  ,0:n3*n2-1 ,2)
      real*8 cb(0:n3*n2-1,0:n1h     ,2)

c     real*8 cb(0:n3*n2-1,0:mm1-1   ,2)
c     complex*16 ca(0:mm1-1  ,0:n3*n2-1 )
c     complex*16 cb(0:n3*n2-1,0:mm1-1   )

         do 10 i2 = 0,n3*n2-1
         do 10 i1 = 0,mm1-1

            cb(i2,i1,1) = ca(i1,i2,1)
            cb(i2,i1,2) = ca(i1,i2,2)

 10      continue

c*
         do 20 i1 = mm1,n1h
         do 20 i2 = 0,n3*n2-1

            cb(i2,i1,1) = 0.0d0
            cb(i2,i1,2) = 0.0d0

 20      continue

c*

      return
      end 
      subroutine trans_in_b3(cb,ca,cw1,nn,n1h,kc1)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 cb(nn,0:n1h  ,2)
      real*8 ca(nn,0:n1h-1,2)

c     complex*16 cb(nn,0:idh-1)
c     complex*16 ca(nn,0:idh-1)

      real*8 cw1(2,0:n1h-1)
c     complex*16 cw1(0:n1h-1)

      real*8 r0,r1
      real*8 rr0,rr1,ri0,ri1

c*
      do 10 ii=1,nn

         r0 = cb(ii,  0,1)
         r1 = cb(ii,n1h,1)

c        r0 = dble(cb(ii,  0))
c        r1 = dble(cb(ii,n1h))

         ca(ii,0,1)= r0 + r1 
         ca(ii,0,2)= r0 - r1 

c        ca(ii,0)=dcmplx( r0 + r1 , r0 - r1 )

  10  continue

      do 20 k1=1,n1h-1
      do 20 ii=1,nn

         rr0 = cb(ii,k1,1)
         ri0 = cb(ii,k1,2)

         rr1 = cb(ii,n1h-k1,1)
         ri1 = cb(ii,n1h-k1,2)

c        rr2 = rr0 + rr1 
c        ri2 = ri0 - ri1 

         rr3 = rr0 - rr1 
         ri3 = ri0 + ri1 

         ca(ii,k1,1) = rr0 + rr1 + rr3*cw1(1,k1) - ri3*cw1(2,k1)
         ca(ii,k1,2) = ri0 - ri1 + rr3*cw1(2,k1) + ri3*cw1(1,k1)

c        ca(ii,k1)=   cb(ii,k1)+dconjg(cb(ii,n1h-k1))
c    &             + (cb(ii,k1)-dconjg(cb(ii,n1h-k1)))*cw1(k1) 

  20  continue 

      return
      end 
      subroutine trans_in_b4(cb,ca,n3,n2,idh,n1h) 
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

c**
      implicit real*8(a-h,o-z)

      real*8 cb(0:n3-1 ,0:n2-1,0:n1h-1,2)
      real*8 ca(2,0:idh-1,0:n2-1,0:n3-1 )

c     complex*16 cb(0:n3-1 ,0:n2-1,0:idh-1)
c     complex*16 ca(0:idh-1,0:n2-1,0:n3-1 )
c**
         do 10 i1=0,n1h-1
         do 10 i2=0,n2-1
         do 10 i3=0,n3-1

            ca(1,i1,i2,i3) = cb(i3,i2,i1,1)
            ca(2,i1,i2,i3) = cb(i3,i2,i1,2)

  10     continue

         do 20 i3=0,n3-1
         do 20 i2=0,n2-1
         do 20 i1=n1h,idh-1

            ca(1,i1,i2,i3) = 0.0d0
            ca(2,i1,i2,i3) = 0.0d0

  20     continue

c**
      return
      end
      subroutine trans_in_f1(ca,cb,idh,n1h,n2,n3,
     &                       mm2,mm3,kc1,kc2,kc3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2-1,0:n3-1)
      real*8 cb(0:mm3-1,0:mm2-1,0:n1h-1,2)

c***
      if(kc1.eq.0) then
         kk1 = n1h-1
      else
         kk1 = kc1
      end if

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if
c**

         do 10 i3=0,kk3
         do 10 i2=0,kk2
         do 10 i1=0,kk1

            cb(i3,i2,i1,1) =   ca(1,i1,i2,i3) 
            cb(i3,i2,i1,2) = - ca(2,i1,i2,i3) 

   10    continue

c**
      if(kc2.ne.0) then

         do 20 i3=0,kk3
         do 20 i2=n2-kc2,n2-1
         do 20 i1=0,kk1

            ii2 = i2 + mm2 - n2
            cb(i3,ii2,i1,1) =   ca(1,i1,i2,i3) 
            cb(i3,ii2,i1,2) = - ca(2,i1,i2,i3) 

   20    continue
  
      end if
c**
      if(kc3.ne.0) then

         do 30 i3=n3-kc3,n3-1
         do 30 i2=0,kk2
         do 30 i1=0,kk1

            ii3 = i3 + mm3 - n3
            cb(ii3,i2,i1,1) =   ca(1,i1,i2,i3) 
            cb(ii3,i2,i1,2) = - ca(2,i1,i2,i3) 

   30    continue

      end if
c**
      if(kc2.ne.0.and.kc3.ne.0) then

         do 40 i3=n3-kc3,n3-1
         do 40 i2=n2-kc2,n2-1
         do 40 i1=0,kk1

            ii2 = i2 + mm2 - n2
            ii3 = i3 + mm3 - n3
            cb(ii3,ii2,i1,1) =   ca(1,i1,i2,i3) 
            cb(ii3,ii2,i1,2) = - ca(2,i1,i2,i3) 

   40    continue

      end if
c**
         do 50 i1=kk1+1,n1h-1
         do 50 i2=0,mm2-1
         do 50 i3=0,mm3-1

            cb(i3,i2,i1,1) = 0.0d0
            cb(i3,i2,i1,2) = 0.0d0

   50    continue
c**

      return
      end
      subroutine trans_in_f2(ca,cb,cw1,mm3,mm2,n1h)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8 (a-h,o-z)

      real*8 ca(mm3*mm2,0:n1h-1,2)
      real*8 cb(mm3*mm2,0:n1h  ,2)
      real*8 cw1(2,0:n1h-1)

c     complex*16 ca(mm3*mm2,0:n1h)
c     complex*16 cb(mm3*mm2,0:n1h)
c     complex*16 cw1(0:n1h-1)

      real*8 rr,ri
c**
      do i32 = 1,mm3*mm2

         rr = ca(i32,0,1)
         ri = ca(i32,0,2)

c        rr = dble (ca(i32,0))
c        ri = dimag(ca(i32,0))
       
         cb(i32,0  ,1) = rr-ri
         cb(i32,n1h,1) = rr+ri

         cb(i32,0  ,2) = 0.0d0 
         cb(i32,n1h,2) = 0.0d0 

c        cb(i32,0  )=dcmplx(rr-ri,0.0d0)
c        cb(i32,n1h)=dcmplx(rr+ri,0.0d0)

      end do
c**   
      do k1  = 1,n1h-1
      do ii = 1,mm3*mm2

         rr0 = ca(ii,k1,1)
         ri0 = ca(ii,k1,2)

         rr1 = ca(ii,n1h-k1,1)
         ri1 = ca(ii,n1h-k1,2)

c        rr2 = rr0 + rr1
c        ri2 = ri0 - ri1

         rr3 = rr0 - rr1
         ri3 = ri0 + ri1

         cb(ii,k1,1) = (rr0 + rr1 + rr3*cw1(1,k1) - ri3*cw1(2,k1))*0.5d0
         cb(ii,k1,2) = (ri0 - ri1 + rr3*cw1(2,k1) + ri3*cw1(1,k1))*0.5d0


c     cb(i32,k1) = ( ca(i32,k1)+dconjg(ca(i32,n1h-k1))
c    &            +( ca(i32,k1)-dconjg(ca(i32,n1h-k1)) )*cw1(k1))
c    &            * 0.5d0

      end do
      end do

      return
      end
      subroutine trans_in_f3(cb,ca,mm3,n2,mm2,n1h,kc2)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm3-1,0:n1h,0:n2-1,2)
      real*8 cb(0:mm3-1,0:mm2-1,0:n1h,2)
c     complex*16 ca(0:mm3-1,0:idh-1,0:n2-1)
c     complex*16 cb(0:mm3-1,0:mm2-1,0:idh-1)

c***********************************************
c**   transpose between 2nd axis and 3rd axis.
c***********************************************

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2 
      end if

      do 10 i1=0,n1h
      do 10 i2=0,kk2
      do 10 i3=0,mm3-1

         ca(i3,i1,i2,1) = cb(i3,i2,i1,1)
         ca(i3,i1,i2,2) = cb(i3,i2,i1,2)

  10  continue  

c**
      if(kc2.ne.0) then

         do 30 ii2=kk2+1,n2-kc2-1
         do 30 i1=0,n1h
         do 30 i3=0,mm3-1

            ca(i3,i1,ii2,1) = 0.0d0
            ca(i3,i1,ii2,2) = 0.0d0

  30     continue  

         do 20 i1=0,n1h
         do 20 i2=kk2+1,mm2-1
         do 20 i3=0,mm3-1

            ii2 = i2 + n2 - mm2
            ca(i3,i1,ii2,1) = cb(i3,i2,i1,1)
            ca(i3,i1,ii2,2) = cb(i3,i2,i1,2)

  20     continue  

      end if
c**
      return
      end
      subroutine trans_in_f4(cb,ca,n1h,n2,n3,mm3,kc3)

      implicit real*8(a-h,o-z)

      real*8 ca((n1h+1)*n2 ,0:n3-1,2)
      real*8 cb(0:mm3-1,(n1h+1)*n2,2)
c     complex*16 ca(0:idh-1,0:n2-1 ,0:n3-1)
c     complex*16 cb(0:mm3-1,0:idh-1,0:n2-1)

c*
      if(kc3.eq.0) then
         kk3 = n3 - 1
      else
         kk3 = kc3
      end if

c     do 10 i2 =0,n2-1  
      do 10 i12 =1,(n1h+1)*n2
      do 10 i3 =0,kk3
      
         ca(i12,i3,1) = cb(i3,i12,1)
         ca(i12,i3,2) = cb(i3,i12,2)

  10  continue

c**
      if(kc3.ne.0) then

         do 20 ii3 = kk3+1,n3-kc3-1
c        do 20 i2 = 0,n2-1
         do 20 i12 =1,(n1h+1)*n2
      
            ca(i12,ii3,1) = 0.0d0
            ca(i12,ii3,2) = 0.0d0

  20     continue

c        do 30 i2 = 0,n2-1
         do 30 i12 =1,(n1h+1)*n2
         do 30 i3 = kk3+1,mm3-1
      
            ii3 = i3 + n3 - mm3 
            ca(i12,ii3,1) = cb(i3,i12,1)
            ca(i12,ii3,2) = cb(i3,i12,2)

  30     continue

      end if
c**
      return
      end


      subroutine trans_in_f5(cb,ca,idh,n1h,n2,n3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2*n3-1)
      real*8 cb(  0:n1h  ,0:n2*n3-1,2)
c     complex*16 ca(0:idh-1,0:n2-1,0:n3-1)
c     complex*16 cb(0:idh-1,0:n2-1,0:n3-1)
c*
      do 10 i23=0,n2*n3-1 
      do 10 i1=0,n1h 

         ca(1,i1,i23) =   cb(i1,i23,1)
         ca(2,i1,i23) = - cb(i1,i23,2)
c        ca(i1,i2,i3) = dconjg(cb(i1,i2,i3))

  10  continue                        

      do 20 i1=n1h+1,idh-1 
      do 20 i23=0,n2*n3-1 

         ca(1,i1,i23) = 0.0d0
         ca(2,i1,i23) = 0.0d0 

  20  continue                        

c*

      return
      end
      subroutine trans_out_b0(ca,cb,idh,n2,n3,n1h)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,n2*n3)
      real*8 cb(0:n1h,n2*n3,2)

c     complex*16 ca(0:idh*n2*n3-1)
c     complex*16 cb(0:idh*n2*n3-1)
c*
  
      do 10 ii=1,n2*n3
      do 10  i=0,n1h   

         cb(i,ii,1) = ca(1,i,ii) 
         cb(i,ii,2) = ca(2,i,ii) 

  10  continue

c*
      return
      end
      subroutine trans_out_b1(ca,cb,n1h,n2,n3,mm3,kc3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      real*8 ca(0:n1h,0:n2-1  ,0:n3-1,2)
      real*8 cb(0:n1h,0:mm3-1 ,0:n2-1,2)

c     complex*16 ca(0:idh-1,0:n2-1  ,0:n3-1)
c     complex*16 cb(0:idh-1,0:mm3-1 ,0:n2-1)

c*
      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if

c*
      do 10 i3=0,kk3
      do 10 i2=0,n2-1
      do 10 i1=0,n1h  

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

  10  continue

c*
      if(kc3.ne.0) then

         do 30 i3=n3-kc3,n3-1
         do 30 i2=0,n2-1
         do 30 i1=0,n1h   

            ii3 = i3 + mm3 - n3
            cb(i1,ii3,i2,1) = ca(i1,i2,i3,1)
            cb(i1,ii3,i2,2) = ca(i1,i2,i3,2)

  30     continue

      end if
c*

      return
      end
      subroutine trans_out_b2(ca,cb,n1h,n2,mm2,mm3,kc2)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)
      real*8 ca(0:n1h,0:mm3-1,0:n2-1 ,2)
      real*8 cb(0:mm3-1,0:mm2-1,0:n1h,2)

c     complex*16 ca(0:idh-1,0:mm3-1,0:n2-1 )
c     complex*16 cb(0:mm3-1,0:mm2-1,0:idh-1)

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2 
      end if

         do 10 i2 = 0,kk2
         do 10 i3 = 0,mm3-1
         do 10 i1 = 0,n1h   

            cb(i3,i2,i1,1) = ca(i1,i3,i2,1)
            cb(i3,i2,i1,2) = ca(i1,i3,i2,2)

 10      continue

      if(kc2.ne.0) then

         do 20 i2 = n2-kc2,n2-1
         do 20 i3 = 0,mm3-1
         do 20 i1 = 0,n1h   

            ii2 = i2 + mm2 - n2
            cb(i3,ii2,i1,1) = ca(i1,i3,i2,1)
            cb(i3,ii2,i1,2) = ca(i1,i3,i2,2)

 20      continue

      end if

      return
      end
      subroutine trans_out_b3(cb,ca,cw1,nn,n1h)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 cb(nn,0:n1h  ,2)
      real*8 ca(nn,0:n1h-1,2)
      real*8 cw1(2,0:n1h-1)

c     complex*16 cb(nn,0:n1h)
c     complex*16 ca(nn,0:n1h-1)
c     complex*16 cw1(0:n1h-1)

      real*8 r0,r1

c**
      do 10 ii=1,nn

         r0 = cb(ii,  0,1)
         r1 = cb(ii,n1h,1)

c        r0 = dble(cb(ii,  0))
c        r1 = dble(cb(ii,n1h))

         ca(ii,0,1)= r0 + r1 
         ca(ii,0,2)= r0 - r1 

c        ca(ii,0)=dcmplx( r0 + r1 , r0 - r1 )

  10  continue

      do 20 k1=1,n1h-1
      do 20 ii=1,nn

         rr0 = cb(ii,k1,1)
         ri0 = cb(ii,k1,2)

         rr1 = cb(ii,n1h-k1,1)
         ri1 = cb(ii,n1h-k1,2)

c        rr2 = rr0 + rr1
c        ri2 = ri0 - ri1

         rr3 = rr0 - rr1
         ri3 = ri0 + ri1

         ca(ii,k1,1) = rr0 + rr1 + rr3*cw1(1,k1) - ri3*cw1(2,k1)
         ca(ii,k1,2) = ri0 - ri1 + rr3*cw1(2,k1) + ri3*cw1(1,k1)

c        ca(ii,k1)=   cb(ii,k1)+dconjg(cb(ii,n1h-k1))
c    &             + (cb(ii,k1)-dconjg(cb(ii,n1h-k1)))*cw1(k1) 

  20  continue 

      return
      end 
      subroutine trans_out_b4(cb,ca,idh,n1h,n2,n3,mm2,mm3,
     &                        kc1,kc2,kc3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c**
      implicit real*8(a-h,o-z)

      real*8 cb(0:mm3-1 ,0:mm2-1,0:n1h-1,2)
      real*8 ca(2,0:idh-1 ,0:n2-1 ,0:n3-1 )

c     complex*16 cb(0:mm3-1 ,0:mm2-1,0:idh-1)
c     complex*16 ca(0:idh-1 ,0:n2-1 ,0:n3-1 )
c**
      if(kc1.eq.0) then
         kk1 = n1h-1
      else
         kk1 = kc1
      end if

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if
c**
      do 100 i3 = 0,n3-1
      do 100 i2 = 0,n2-1
      do 100 i1 = 0,idh-1

         ca(1,i1,i2,i3) = 0.0d0
         ca(2,i1,i2,i3) = 0.0d0

 100  continue

c**
      do 10 i1=0,kk1
      do 10 i2=0,kk2
      do 10 i3=0,kk3

         ca(1,i1,i2,i3) = cb(i3,i2,i1,1)
         ca(2,i1,i2,i3) = cb(i3,i2,i1,2)

  10  continue
c**
      if(kc2.ne.0) then

         do 20 i1=0,kk1
         do 20 i2=kc2+1,kc2+kc2
         do 20 i3=0,kk3

            ii2 = i2 + n2-1-kc2*2
            ca(1,i1,ii2,i3) = cb(i3,i2,i1,1)
            ca(2,i1,ii2,i3) = cb(i3,i2,i1,2)

  20     continue

      end if
c**
      if(kc3.ne.0) then

         do 30 i1=0,kk1
         do 30 i2=0,kk2
         do 30 i3=kc3+1,kc3+kc3

            ii3 = i3 + n3-1-kc3*2
            ca(1,i1,i2,ii3) = cb(i3,i2,i1,1)
            ca(2,i1,i2,ii3) = cb(i3,i2,i1,2)

  30     continue

      end if
c**
      if(kc2.ne.0.and.kc3.ne.0) then

         do 40 i1=0,kk1
         do 40 i2=kc2+1,kc2+kc2
         do 40 i3=kc3+1,kc3+kc3

            ii2 = i2 + n2-1-kc2*2
            ii3 = i3 + n3-1-kc3*2
            ca(1,i1,ii2,ii3) = cb(i3,i2,i1,1)
            ca(2,i1,ii2,ii3) = cb(i3,i2,i1,2)

  40     continue

      end if

c**
      return
      end  
      subroutine trans_out_f1(ca,cb,idh,n1h,n2,n3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2-1,0:n3-1)
      real*8 cb(0:n3-1 ,0:n2-1,0:n1h-1,2)

c     complex*16 ca(0:m1-1,0:m2-1,0:m3-1),cb(0:m3-1,0:m2-1,0:m1-1)

c***
         do 10 i3=0,n3-1
         do 10 i2=0,n2-1
         do 10 i1=0,n1h-1

            cb(i3,i2,i1,1) =   ca(1,i1,i2,i3) 
            cb(i3,i2,i1,2) = - ca(2,i1,i2,i3) 

   10    continue

      return
      end
      subroutine trans_out_f2(ca,cb,cw1,n3,n2,n1h,kc1)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(n3*n2,0:n1h-1,2)
      real*8 cb(n3*n2,0:n1h  ,2)
      real*8 cw1(2,0:n1h-1)
      real*8 rr,ri
c**
      do i32 = 1,n3*n2

         rr = ca(i32,0,1)
         ri = ca(i32,0,2)
c        rr = dble (ca(i32,0))
c        ri = dimag(ca(i32,0))

         cb(i32,0  ,1) = rr-ri
         cb(i32,n1h,1) = rr+ri

         cb(i32,0  ,2) = 0.0d0
         cb(i32,n1h,2) = 0.0d0

c        rr = dble (ca(i32,0))
c        ri = dimag(ca(i32,0))
       
c        cb(i32,0  )=dcmplx(rr-ri,0.0d0)
c        cb(i32,n1h)=dcmplx(rr+ri,0.0d0)

      end do
c**   
      if(kc1.eq.0) then
         mm = n1h-1
      else
         mm = kc1
      end if
c**
      do k1  = 1,mm
      do ii = 1,n3*n2

         rr0 = ca(ii,k1,1)
         ri0 = ca(ii,k1,2)

         rr1 = ca(ii,n1h-k1,1)
         ri1 = ca(ii,n1h-k1,2)

         rr2 = rr0 + rr1
         ri2 = ri0 - ri1

         rr3 = rr0 - rr1
         ri3 = ri0 + ri1

         cb(ii,k1,1) = ( rr2 + rr3*cw1(1,k1) - ri3*cw1(2,k1) )*0.5d0
         cb(ii,k1,2) = ( ri2 + rr3*cw1(2,k1) + ri3*cw1(1,k1) )*0.5d0

c     cb(i32,k1) = ( ca(i32,k1)+dconjg(ca(i32,n1h-k1))
c    &            +( ca(i32,k1)-dconjg(ca(i32,n1h-k1)) )*cw1(k1))
c    &            * 0.5d0

      end do
      end do

      return
      end
      subroutine trans_out_f3(cb,ca,n3,n2,mm1,n1h)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)
      real*8 ca(n3,0:mm1-1,n2,2)
      real*8 cb(n3,n2,0:n1h,2)

c***********************************************
c**   transpose between 2nd axis and 3rd axis.
c***********************************************

      do 10 i1=0,mm1-1
      do 10 i2=1,n2
      do 10 i3=1,n3

         ca(i3,i1,i2,1) = cb(i3,i2,i1,1)
         ca(i3,i1,i2,2) = cb(i3,i2,i1,2)

  10  continue  

      return
      end
      subroutine trans_out_f4(cb,ca,n3,mm1,n2,mm2,kc2)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)
      real*8 ca(0:mm1-1,0:mm2-1, 0:n3-1,2)
      real*8 cb(0:n3-1 ,0:mm1-1, 0:n2-1,2)

c*
      if(kc2.eq.0) then
         kk2 = n2 - 1
      else
         kk2 = kc2
      end if

      do 10 i2 =0,kk2  
      do 10 i1 =0,mm1-1
      do 10 i3 =0,n3-1
      
         ca(i1,i2,i3,1) = cb(i3,i1,i2,1)
         ca(i1,i2,i3,2) = cb(i3,i1,i2,2)

  10  continue

c*
      if(kc2.ne.0) then

         do 20 i2 = -kc2,-1
         do 20 i1 =    0,mm1-1
         do 20 i3 =    0,n3-1
      
            ii2 = i2 + kc2*2 + 1 
            ca(i1,ii2,i3,1) = cb(i3,i1,i2+n2,1)
            ca(i1,ii2,i3,2) = cb(i3,i1,i2+n2,2)

  20     continue

      end if

c*
      return
      end
      subroutine trans_out_f5(cb,ca,idh,n1h,n2,n3,mm1,mm2,kc1,kc2,kc3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)
      real*8 ca(2,0:idh-1,0:n2-1 ,0:n3-1 )
      real*8 cb(0:mm1-1,0:mm2-1,0:n3-1 ,2)
c*
      if(kc1.eq.0) then
           kk1 = n1h
      else
           kk1 = kc1
      end if

      if(kc2.eq.0) then
           kk2 = n2-1
      else
           kk2 = kc2
      end if

      if(kc3.eq.0) then
           kk3 = n3-1
      else
           kk3 = kc3
      end if
c*

      do 100 i3=0,n3-1 
      do 100 i2=0,n2-1 
      do 100 i1=0,idh-1 

         ca(1,i1,i2,i3) = 0.0d0
 100     ca(2,i1,i2,i3) = 0.0d0

c*

      do 10 i3=0,kk3 
      do 10 i2=0,kk2 
      do 10 i1=0,kk1 

         ca(1,i1,i2,i3) =    cb(i1,i2,i3,1)
         ca(2,i1,i2,i3) =  - cb(i1,i2,i3,2)

  10  continue 

      if(kc2.ne.0) then

         nskip2 = n2-1-kc2*2

         do 11 i3=0,kk3 
         do 11 i2=kc2+1,kc2*2 
         do 11 i1=0,kk1 

            ca(1,i1,i2+nskip2,i3) =   cb(i1,i2,i3,1)
            ca(2,i1,i2+nskip2,i3) = - cb(i1,i2,i3,2)

  11     continue 

      end if

c******************************
      if(kc3.ne.0) then
c******************************

      do 20 i3=n3-kc3,n3-1 
      do 20 i2=0,kk2 
      do 20 i1=0,kk1 

         ca(1,i1,i2,i3) =   cb(i1,i2,i3,1)
         ca(2,i1,i2,i3) = - cb(i1,i2,i3,2)

  20  continue 

      if(kc2.ne.0) then

         nskip2 = n2-1-kc2*2

         do 21 i3=n3-kc3,n3-1 
         do 21 i2=kc2+1,kc2*2 
         do 21 i1=0,kk1 

            ca(1,i1,i2+nskip2,i3) =   cb(i1,i2,i3,1)
            ca(2,i1,i2+nskip2,i3) = - cb(i1,i2,i3,2)

  21     continue 

      end if

c******************************
      end if
c******************************

      return
      end
      subroutine jrcat_c3ft(ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                      kc1,kc2,kc3,key)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

c**********************************************************************
c*    3 dimensional complex to complex FFT with mask
c*    either for input array or output array,
c*    developed by T.Sanada (sanada@think.com) on 1996.01.04.
c*    It is specified for Fujitsu VPP500.
c**********************************************************************

      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

c------------------>      for Estimation of CPU cost.
c                             by T.Yamasaki
c                               22th May. 1996
      real*8 CRTVL, PCPUDF
      parameter (CRTVL = 1.d-5, PCPUDF = 2.0)
c        CRTVL : CRItical VaLue for Division.
c        PCPUDF: Percent of CPU DiFference.
      real*8 cpu0ol,cpudif,rcpudf,ecpu,tcpu
      integer icount
      data icount/0/
      data ecpu/0.d0/
      data cpu0ol/0.d0/
      real*8 t_start, t_end, UMICRO
      parameter (UMICRO = 1.d-6)
c <-------------------------------------------

      complex*16 ca    (id,n2,n3)
      complex*16 cwork (id,n2,n3)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank

c**********************************************************************
c*   key = 0 : set up of FFT.
c*             ( Calculation of cw1,cw2 and cw3. )
c**********************************************************************
c*   n1,n2 and n3 must include radix 2, and they may include 3 or 5.
c*   id must be n1 + 2.
c*
c**********************************************************************
c*  key = -1 & -2 : F.T. of complex 3d array ca(0:n1-1,0:n2-1,0:n3-1) .
c**********************************************************************
c*
c*   The result(complex 'cb') is overwritten on 'ca'.
c*   
c*     cb(k1,k2,k3) 
c*   = sum(ix=0:n1-1,iy=0:n2-1,iz=0:n3-1) 
c*     ca(i1,i2,i3) exp [- 2 * pai * ci
c*                             * ( k1*i1/n1 + k2*i2/n2 + k3*i3/n3 ) ]
c*     
c*     where 0 <= k1 <= n1/2, 0 <= k2 <= n2-1, 0 <= k3 <= n3-1.
c*
c**********************************************************************
c*  key = +1 & +2: Inverse F.T. of copmplex 3d array cb(0:n1/2,0:n2-1
c*                                                           ,0:n3-1) .
c**********************************************************************
c*   Transform from 'cb' to 'ra'.
c*
c**********************************************************************
c*  kc1,kc2 kc3 are integer parameters specifying the mask for
c*  input data or output data.
c*
c*     If kc1.ge.n1/2.or.kc1.lt.0, then kc1 is forced to be 0. 
c*     If kc2.ge.n2/2.or.kc2.lt.0, then kc2 is forced to be 0. 
c*     If kc3.ge.n3/2.or.kc3.lt.0, then kc3 is forced to be 0. 
c*
c**********************************************************************
c** REMARK on Mask.
c**********************************************************************
c*
c*  key = -1 : Mask is for Output data ( cb ),
c*  key = +1 : Mask is for Input  data ( cb ),
c*  key = -2 : Mask is for Input  data ( ca ),
c*  key = +2 : Mask is for Output data ( ca ),
c*
c*     where ca(0:idh/2,0:n2-1,0:n3-1) and equivalence(ra,ca).
c*
c**********************************************************************
c*     Mask for Output data:
c**********************************************************************
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is calculated.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is calculated.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2<= n2-1" 
c*     range is calculated.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3<= n3-1" 
c*     range is calculated.
c*
c**********************************************************************
c*     Mask for Input data:
c**********************************************************************
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is used to obtain real array 'ra'.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is used.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2<= n2-1" 
c*     range is used.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3<= n3-1" 
c*     range is used.
c*
c**********************************************************************
c*
c******************************************************************
c**   choose nbank = 0 or nbank = 1 
c******************************************************************
c*   nbank = 0:
c*      The transpose is normally implemented.
c*      Bank conflict may appear patriculary in Vector Computers.
c*   nbank = 1:
c*      The transpose is implemented so as to prevent
c*      the bank conflict in the case the conflict may appear.
c******************************************************************
c
      call gettod(t_start)

      nbank = 0

c**

      if(key.eq.0) then

c** set up of FFT.

         call c3ft_0(cw1,cw2,cw3,n1,n2,n3)

         goto 1001
c$$$         return

      end if

c**
      if(kc1.ge.n1/2.or.kc1.lt.0) then 
         write(6,*) 'warning in FFT: kc1 is irrelevant.'
         write(6,*) 'kc1 has changed to be 0.'
         kc1 = 0
      end if

      if(kc2.ge.n2/2.or.kc2.lt.0) then 
         write(6,*) 'warning in FFT: kc2 is irrelevant.'
         write(6,*) 'kc2 has changed to be 0.'
         kc2 = 0
      end if

      if(kc3.ge.n3/2.or.kc3.lt.0) then 
         write(6,*) 'warning in FFT: kc3 is irrelevant.'
         write(6,*) 'kc3 has changed to be 0.'
         kc3 = 0
      end if

c******************************************
      if(key.eq.-1.or.key.eq.+2) then
c******************************************

c** Forword  FFT with mask for output.
c** Backword FFT with mask for output.

         call c3ft_mask_for_out(ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank,key)

c******************************************
      else 
c******************************************

c** Forword  FFT with mask for input.
c** Backword FFT with mask for input.

         call c3ft_mask_for_in (ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank,key)


c******************************************
      end if
c******************************************

 1001 continue

c -------->  CPU cost estimation
      call gettod(t_end)
      tcpu = (t_end - t_start)*UMICRO
      icount = icount + 1
      ecpu = ecpu + tcpu
c <-------

      return
      entry jrc_c3strt
      icount = 0
      ecpu = 0.d0
      return
c--------------------------
      entry jrc_c3end
      cpudif = dabs(cpu0ol - ecpu)
      if(ecpu.gt.CRTVL) then
         rcpudf = cpudif/ecpu * 100.0
      else if(cpu0ol.le.CRTVL) then
         rcpudf = 0.0
      else
         rcpudf = 100.0
      endif
c               <-- Ratio in percent of CPU time difference
c                 between previous one and present one.
      cpu0ol = ecpu

c$$$      call eqivvl(rcpudf)

      if(rcpudf.gt.PCPUDF) then
         if(icount.gt.0) then
            tcpu = ecpu/dfloat(icount)
         endif
         write(6,9001) ecpu, icount, tcpu
 9001    format(1H ,' <<CPU TIME for JRCAT_C3FT = ',f11.3
     &        ,'(Sec.) = (',i6,' *',f10.5,')>>')
      endif
      return
      end  

      subroutine c3ft_0(cw1,cw2,cw3,n1,n2,n3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

c**
         call setcw(cw1,n1)
         call setcw(cw2,n2)
         call setcw(cw3,n3) 

      return
      end  

      subroutine c3ft_mask_for_in(ca,cb,id,n1,n2,n3,cw1,cw2,cw3,
     &                            kc1,kc2,kc3,nbank,key)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (0:id-1,0:n2-1,0:n3-1,2)
      real*8 cb (0:id-1,0:n2-1,0:n3-1,2)

c     complex*16 ca (0:id-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
      if(kc1.eq.0) then
           mm1 = n1
      else
           mm1 = kc1*2+1
      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

      if(kc3.eq.0) then
           mm3 = n3
      else
           mm3 = kc3*2+1
      end if

c** Packin from ca(2,0:id-1,0:n2-1,0:n3-1) to cb(0:mm1-1,0:mm2-1,0:n3-1,2)

      call trans_in_c0(ca,cb,id,n1,n2,n3,mm1,mm2,kc1,kc2,kc3,key)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw3,n3,mm1*mm2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)

      call trans_in_c1(ca,cb,mm1,n2,mm2,n3,kc2)

c** Length:n2 CFFT    

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw2,n2,mm1*n3,lp2,lp3,lp4,lp5,lp8) 

c** cb(i3,i2,i1,2) <- ca(i1,i3,i2,2)

      call trans_in_c2(ca,cb,n1,mm1,n2,n3,kc1)

c** Length:n1 CFFT  

      call setlp(n1,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw1,n1,n3*n2,lp2,lp3,lp4,lp5,lp8)

c** cb(2,i1,i2,i3) <- ca(i3,i2,i1,2)

      call trans_in_c3(ca,cb,n3,n2,n1,id,key)

c** ca(2,i1,i2,i3) <- cb(2,i1,i2,i3)

      call trans_in_c4(cb,ca,id,n2,n3)   

      return

      end  

      subroutine c3ft_mask_for_out(ca,cb,id,n1,n2,n3,
     &                        cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank,key)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (0:id-1,0:n2-1,0:n3-1,2)
      real*8 cb (0:id-1,0:n2-1,0:n3-1,2)

c     complex*16 ca (0:id-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank

      if(kc1.eq.0) then
           mm1 = n1
      else
           mm1 = kc1*2+1
      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

      if(kc3.eq.0) then
           mm3 = n3
      else
           mm3 = kc3*2+1
      end if

c** cb(i1,i2,i3,2) <- ca(2,i1,i2,i3)

      call trans_out_c0(ca,cb,id,n1,n2,n3,key)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw3,n3,n1*n2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)

      call trans_out_c1(ca,cb,n1,n2,n3,mm3,kc3)

c** Length:n2 CFFT    

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw2,n2,n1*mm3,lp2,lp3,lp4,lp5,lp8) 

c** cb(i3,i2,i1,2) <- ca(i1,i3,i2,2)

      call trans_out_c2(ca,cb,n1,n2,mm2,mm3,kc2)

c** Length:n1 CFFT  

      call setlp(n1,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw1,n1,mm3*mm2,lp2,lp3,lp4,lp5,lp8)

c** cb(2,i1,i2,i3) <- ca(i3,i2,i1,2)

      call trans_out_c3(ca,cb,id,n1,n2,n3,mm2,mm3,kc1,kc2,kc3,key)

c** ca(2,i1,i2,i3) <- cb(2,i1,i2,i3)

      call trans_out_c4(cb,ca,id,n2,n3)

      return
      end
      subroutine trans_in_c0(ca,cb,id,n1,n2,n3,mm1,mm2,kc1,kc2,kc3,key)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:id-1 ,0:n2-1 ,0:n3-1)
      real*8 cb(0:mm1-1,0:mm2-1,0:n3-1,2)

      real*8 parity
c*
      if(kc1.eq.0) then
         kk1 = n1-1
      else
         kk1 = kc1
      end if

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if
c*
      if(key.eq.+1.or.key.eq.+2) then
         parity = +1.0d0
      else
         parity = -1.0d0
      end if

c*
      do 10 i3=0,n3-1
      do 10 i2=0,mm2-1
      do 10 i1=0,mm1-1

         cb(i1,i2,i3,1)=0.0d0
         cb(i1,i2,i3,2)=0.0d0

 10   continue
c*
      do 20 i3=0,kk3
      do 20 i2=0,kk2
      do 20 i1=0,kk1

         cb(i1,i2,i3,1) = ca(1,i1,i2,i3)
         cb(i1,i2,i3,2) = ca(2,i1,i2,i3) * parity

 20   continue

      if(kc1.ne.0) then

         do 30 i3=0,kk3
         do 30 i2=0,kk2
         do 30 i1=n1-kc1,n1-1
     
            ii1 = i1 + mm1 - n1
            cb(ii1,i2,i3,1) = ca(1,i1,i2,i3)
            cb(ii1,i2,i3,2) = ca(2,i1,i2,i3) * parity

 30      continue

      end if

      if(kc2.ne.0) then

         do 40 i3=0,kk3
         do 40 i2=n2-kc2,n2-1
         do 40 i1=0,kk1
     
            ii2 = i2 + mm2 - n2
            cb(i1,ii2,i3,1) = ca(1,i1,i2,i3)
            cb(i1,ii2,i3,2) = ca(2,i1,i2,i3) * parity

 40      continue

      end if

      if(kc3.ne.0) then

         do 50 i3=n3-kc3,n3-1
         do 50 i2=0,kk2
         do 50 i1=0,kk1
     
            ii3 = i3 
            cb(i1,i2,ii3,1) = ca(1,i1,i2,i3)
            cb(i1,i2,ii3,2) = ca(2,i1,i2,i3) * parity

 50      continue

      end if

      if(kc1.ne.0.and.kc2.ne.0) then

         do 60 i3=0,kk3
         do 60 i2=n2-kc2,n2-1
         do 60 i1=n1-kc1,n1-1
     
            ii1 = i1 + mm1 - n1
            ii2 = i2 + mm2 - n2
            cb(ii1,ii2,i3,1) = ca(1,i1,i2,i3)
            cb(ii1,ii2,i3,2) = ca(2,i1,i2,i3) * parity

 60      continue

      end if

      if(kc1.ne.0.and.kc3.ne.0) then

         do 70 i3=n3-kc3,n3-1
         do 70 i2=0,kk2
         do 70 i1=n1-kc1,n1-1
     
            ii1 = i1 + mm1 - n1
            ii3 = i3 
            cb(ii1,i2,ii3,1) = ca(1,i1,i2,i3)
            cb(ii1,i2,ii3,2) = ca(2,i1,i2,i3) * parity

 70      continue

      end if

      if(kc2.ne.0.and.kc3.ne.0) then

         do 80 i3=n3-kc3,n3-1
         do 80 i2=n2-kc2,n2-1
         do 80 i1=0,kk1
     
            ii2 = i2 + mm2 - n2
            ii3 = i3 
            cb(i1,ii2,ii3,1) = ca(1,i1,i2,i3)
            cb(i1,ii2,ii3,2) = ca(2,i1,i2,i3) * parity

 80      continue

      end if

      if(kc1.ne.0.and.kc2.ne.0.and.kc3.ne.0) then

         do 90 i3=n3-kc3,n3-1
         do 90 i2=n2-kc2,n2-1
         do 90 i1=n1-kc1,n1-1
     
            ii1 = i1 + mm1 - n1
            ii2 = i2 + mm2 - n2
            ii3 = i3 
            cb(ii1,ii2,ii3,1) = ca(1,i1,i2,i3)
            cb(ii1,ii2,ii3,2) = ca(2,i1,i2,i3) * parity

 90      continue

      end if

      return
      end
      subroutine trans_in_c1(ca,cb,mm1,n2,mm2,n3,kc2)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm1-1,0:mm2-1,0:n3-1,2)
      real*8 cb(0:mm1-1,0:n3-1 ,0:n2-1,2)

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      do 10 i3=0,n3-1
      do 10 i2=0,kk2
      do 10 i1=0,mm1-1

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

  10  continue

      if(kc2.ne.0) then

         do 20 i2=kk2+1,n2-kc2-1
         do 20 i3=0,n3-1
         do 20 i1=0,mm1-1

            cb(i1,i3,i2,1) = 0.0d0
            cb(i1,i3,i2,2) = 0.0d0

  20     continue

         do 30 i2=n2-kc2,n2-1
         do 30 i3=0,n3-1
         do 30 i1=0,mm1-1

            ii2 = i2 + mm2 - n2
            cb(i1,i3,i2,1) = ca(i1,ii2,i3,1)
            cb(i1,i3,i2,2) = ca(i1,ii2,i3,2)

  30     continue

      end if

      return
      end
      subroutine trans_in_c2(ca,cb,n1,mm1,n2,n3,kc1)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm1-1  ,0:n3*n2-1,2)
      real*8 cb(0:n3*n2-1,0:n1-1   ,2)

      if(kc1.eq.0) then
         kk1 = n1-1
      else
         kk1 = kc1
      end if

c**
      do 10 i1 = 0,kk1
      do 10 i32 = 0,n3*n2-1

         cb(i32,i1,1) = ca(i1,i32,1)
         cb(i32,i1,2) = ca(i1,i32,2)

  10  continue

      if(kc1.ne.0) then

         do 20 i1 = kk1+1,n1-kc1-1
         do 20 i32 = 0,n3*n2-1

            cb(i32,i1,1) = 0.0d0
            cb(i32,i1,2) = 0.0d0

  20     continue

         do 30 i1 = n1-kc1,n1-1
         do 30 i32 = 0,n3*n2-1

            ii1 = i1 + mm1 - n1
            cb(i32,i1,1) = ca(ii1,i32,1)
            cb(i32,i1,2) = ca(ii1,i32,2)

  30     continue

      end if

      return
      end
      subroutine trans_in_c3(ca,cb,n3,n2,n1,id,key)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(0:n3-1,0:n2-1,0:n1-1,2)
      real*8 cb(2,0:id-1,0:n2-1,0:n3-1)

      real*8 parity
c*
      if(key.eq.+1.or.key.eq.+2) then
         parity = +1.0d0
      else
         parity = -1.0d0
      end if
c*
      do 10 i3=0,n3-1
      do 10 i2=0,n2-1
      do 10 i1=n1,id-1

         cb(1,i1,i2,i3) = 0.0d0
         cb(2,i1,i2,i3) = 0.0d0

  10  continue

      do 20 i1=0,n1-1
      do 20 i2=0,n2-1
      do 20 i3=0,n3-1

         cb(1,i1,i2,i3) = ca(i3,i2,i1,1)
         cb(2,i1,i2,i3) = ca(i3,i2,i1,2) * parity

  20  continue

      return
      end

      subroutine trans_in_c4(cb,ca,id,n2,n3)   
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 cb(id*n2*n3*2)
      real*8 ca(id*n2*n3*2)

      do 10 ii=1,id*n2*n3*2

         ca(ii) = cb(ii)

 10   continue

      return
      end

      subroutine trans_out_c0(ca,cb,id,n1,n2,n3,key)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(2,id,n2*n3)
      real*8 cb(n1,n2*n3,2)

      real*8 parity
c*
      if(key.eq.+1.or.key.eq.+2) then
         parity = +1.0d0
      else
         parity = -1.0d0
      end if
c*
      do 10 i23=1,n2*n3
      do 10 i1=1,n1

         cb(i1,i23,1) = ca(1,i1,i23)
         cb(i1,i23,2) = ca(2,i1,i23) * parity

 10   continue

      return
      end 

      subroutine trans_out_c1(ca,cb,n1,n2,n3,mm3,kc3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(0:n1-1,0:n2-1 ,0:n3-1,2)
      real*8 cb(0:n1-1,0:mm3-1,0:n2-1,2)

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3  
      end if

      do 10 i3=0,kk3
      do 10 i2=0,n2-1
      do 10 i1=0,n1-1

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

 10   continue

      if(kc3.ne.0) then

         do 20 i3=n3-kc3,n3-1
         do 20 i2=0,n2-1
         do 20 i1=0,n1-1

            ii3 = i3 + mm3 - n3
            cb(i1,ii3,i2,1) = ca(i1,i2,i3,1)
            cb(i1,ii3,i2,2) = ca(i1,i2,i3,2)

 20      continue

      end if

      return
      end
      subroutine trans_out_c2(ca,cb,n1,n2,mm2,mm3,kc2)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(0:n1-1 ,0:mm3-1,0:n2-1,2)
      real*8 cb(0:mm3-1,0:mm2-1,0:n1-1,2)

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      do 10 i2 = 0,kk2
      do 10 i3 = 0,mm3-1
      do 10 i1 = 0,n1-1
   
         cb(i3,i2,i1,1) = ca(i1,i3,i2,1)
         cb(i3,i2,i1,2) = ca(i1,i3,i2,2)

  10  continue

      if(kc2.ne.0) then

      do 20 i2 = n2-kc2,n2-1
      do 20 i3 = 0,mm3-1
      do 20 i1 = 0,n1-1
   
         ii2 = i2 + mm2 - n2
         cb(i3,ii2,i1,1) = ca(i1,i3,i2,1)
         cb(i3,ii2,i1,2) = ca(i1,i3,i2,2)

  20  continue

      end if

      return
      end
      subroutine trans_out_c3(ca,cb,id,n1,n2,n3,mm2,mm3,kc1,kc2,kc3,key)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm3-1,0:mm2-1,0:n1-1,2)
      real*8 cb(2,0:id-1 ,0:n2-1 ,0:n3-1)

      real*8 parity
c*
      if(key.eq.+1.or.key.eq.+2) then
         parity = +1.0d0
      else
         parity = -1.0d0
      end if
c*

      do 1 i3=0,n3-1
      do 1 i2=0,n2-1
      do 1 i1=0,id-1

         cb(1,i1,i2,i3) = 0.0d0
         cb(2,i1,i2,i3) = 0.0d0

  1   continue

      if(kc1.eq.0) then
         kk1 = n1-1
      else
         kk1 = kc1
      end if

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if

      do 10 i1 = 0,kk1
      do 10 i3 = 0,kk3
      do 10 i2 = 0,kk2

         cb(1,i1,i2,i3) = ca(i3,i2,i1,1)
         cb(2,i1,i2,i3) = ca(i3,i2,i1,2) * parity

  10  continue

      if(kc1.ne.0) then

      do 20 i1 = n1-kc1,n1-1
      do 20 i3 = 0,kk3
      do 20 i2 = 0,kk2

         ii1 = i1
         cb(1,i1,i2,i3) = ca(i3,i2,ii1,1)
         cb(2,i1,i2,i3) = ca(i3,i2,ii1,2) * parity

  20  continue

      end if

      if(kc2.ne.0) then

      do 30 i1 = 0,kk1
      do 30 i3 = 0,kk3
      do 30 i2 = n2-kc2,n2-1

         ii2 = i2 + mm2 - n2
         cb(1,i1,i2,i3) = ca(i3,ii2,i1,1)
         cb(2,i1,i2,i3) = ca(i3,ii2,i1,2) * parity

  30  continue

      end if

      if(kc3.ne.0) then

      do 40 i1 = 0,kk1
      do 40 i3 = n3-kc3,n3-1
      do 40 i2 = 0,kk2

         ii3 = i3 + mm3 - n3
         cb(1,i1,i2,i3) = ca(ii3,i2,i1,1)
         cb(2,i1,i2,i3) = ca(ii3,i2,i1,2) * parity

  40  continue

      end if

      if(kc1.ne.0.and.kc2.ne.0) then

      do 50 i1 = n1-kc1,n1-1
      do 50 i3 = 0,kk3
      do 50 i2 = n2-kc2,n2-1

         ii1 = i1
         ii2 = i2 + mm2 - n2
         cb(1,i1,i2,i3) = ca(i3,ii2,ii1,1)
         cb(2,i1,i2,i3) = ca(i3,ii2,ii1,2) * parity

  50  continue

      end if

      if(kc1.ne.0.and.kc3.ne.0) then

      do 60 i1 = n1-kc1,n1-1
      do 60 i3 = n3-kc3,n3-1
      do 60 i2 = 0,kk2

         ii1 = i1
         ii3 = i3 + mm3 - n3
         cb(1,i1,i2,i3) = ca(ii3,i2,ii1,1)
         cb(2,i1,i2,i3) = ca(ii3,i2,ii1,2) * parity

  60  continue

      end if

      if(kc2.ne.0.and.kc3.ne.0) then

      do 70 i1 = 0,kk1
      do 70 i3 = n3-kc3,n3-1
      do 70 i2 = n2-kc2,n2-1

         ii2 = i2 + mm2 - n2
         ii3 = i3 + mm3 - n3
         cb(1,i1,i2,i3) = ca(ii3,ii2,i1,1)
         cb(2,i1,i2,i3) = ca(ii3,ii2,i1,2) * parity

  70  continue

      end if

      if(kc1.ne.0.and.kc2.ne.0.and.kc3.ne.0) then

      do 80 i1 = n1-kc1,n1-1
      do 80 i3 = n3-kc3,n3-1
      do 80 i2 = n2-kc2,n2-1

         ii1 = i1
         ii2 = i2 + mm2 - n2
         ii3 = i3 + mm3 - n3
         cb(1,i1,i2,i3) = ca(ii3,ii2,ii1,1)
         cb(2,i1,i2,i3) = ca(ii3,ii2,ii1,2) * parity

  80  continue

      end if

      return
      end
      subroutine trans_out_c4(cb,ca,id,n2,n3)
c $Id: jrcat_ft_stm.f,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $

      implicit real*8(a-h,o-z)

      real*8 ca(id*n2*n3*2)
      real*8 cb(id*n2*n3*2)

c*
      do 10 ii=1,id*n2*n3*2

         ca(ii) = cb(ii)

 10   continue

      return
      end

subroutine init_cubic_spline(n,x,y,y2)
  implicit none
  integer,intent(in) :: n
  real(kind=8), dimension(n), intent(in) :: x,y
  real(kind=8), dimension(n), intent(out) :: y2
  integer i,j
  real(kind=8) a,b
  real(kind=8), allocatable, dimension(:) :: tmp

  allocate(tmp(n));tmp=0.d0
  y2 = 0.0d0

  do i=2,n-1
    a=(x(i)-x(i-1))/(x(i+1)-x(i-1))
    b=a*y2(i-1)+2
    y2(i)=(a-1)/b
    tmp(i)=(6.d0*((y(i+1)-y(i))/(x(i+1)-x(i))-(y(i)-y(i-1)) &
    & /(x(i)-x(i-1)))/(x(i+1)-x(i-1))-a*tmp(i-1))/b
  enddo

  do j=n-1,1,-1
    y2(j) = y2(j)*y2(j+1)+tmp(j)
  enddo
  deallocate(tmp)

end subroutine init_cubic_spline

subroutine cubic_spline(n,x,y,y2,xin,yout,y1out)
  implicit none
  integer, intent(in) :: n
  real(kind=8), dimension(n), intent(in) :: x,y,y2
  real(kind=8), intent(in) :: xin
  real(kind=8), intent(out) :: yout,y1out
  real(kind=8) :: a,b,h
  integer :: i,i0,i1

  i0=1
  i1=n

  do while ( (i1-i0).gt.1 ) 
    i=(i1+i0)/2
    if (x(i).gt.xin) then
        i1=i
    else
        i0=i
    endif
  enddo

  h=x(i1)-x(i0)
  a=(x(i1)-xin)/h
  b=(xin-x(i0))/h
  yout  = a*y(i0)+b*y(i1)+((a*a*a-a)*y2(i0)+(b*b*b-b)*y2(i1))*(h**2)/6.0d0
  y1out = (y(i1)-y(i0))/h-(3.0d0*a*a-1)/6.0d0*h*y2(i0)+(3.0d0*b*b-1)/6.0d0*h*y2(i1)
end subroutine cubic_spline

function cubic_splinef(n,x,y,y2,xin,y1out) result (res)
  implicit none
  integer, intent(in) :: n
  real(kind=8), dimension(n), intent(in) :: x,y,y2
  real(kind=8), intent(in) :: xin
  real(kind=8), intent(out) :: y1out
  real(kind=8) :: a,b,h
  integer :: i,i0,i1
  real(kind=8) :: res

  i0=1
  i1=n

  do while ( (i1-i0).gt.1 ) 
    i=(i1+i0)/2
    if (x(i).gt.xin) then
        i1=i
    else
        i0=i
    endif
  enddo

  h=x(i1)-x(i0)
  a=(x(i1)-xin)/h
  b=(xin-x(i0))/h
  res  = a*y(i0)+b*y(i1)+((a*a*a-a)*y2(i0)+(b*b*b-b)*y2(i1))*(h**2)/6.0d0
  y1out = (y(i1)-y(i0))/h-(3.0d0*a*a-1)/6.0d0*h*y2(i0)+(3.0d0*b*b-1)/6.0d0*h*y2(i1)
end function cubic_splinef

subroutine init_bicubic_spline(x1a,x2a,ya,m,n,y2a)
  implicit none
  integer, intent(in) :: m,n
  real(kind(1.d0)), dimension(m), intent(in) :: x1a
  real(kind(1.d0)), dimension(n), intent(in) :: x2a
  real(kind(1.d0)), dimension(m,n), intent(in) :: ya
  real(kind(1.d0)), dimension(m,n), intent(out) :: y2a
  integer :: i,j,k
  real(kind(1.d0)), allocatable, dimension(:) :: y2tmp,ytmp

  allocate(y2tmp(n))
  allocate(ytmp(n))
  y2tmp=0.0d0;ytmp=0.0d0;y2a=0.0d0

  do j=1,m
    do k=1,n
      ytmp(k) = ya(j,k)
    enddo
    call init_cubic_spline(x2a,ytmp,n,1.e30,1.e30,y2tmp)
    do k=1,n
      y2a(j,k)=y2tmp(k)
    enddo
  enddo
  deallocate(y2tmp)
  deallocate(ytmp)
end subroutine init_bicubic_spline

subroutine init_tricubic_spline(x1a,x2a,x3a,ya,m,n,o,y2a)
  implicit none
  integer, intent(in) :: m,n,o
  real(kind(1.d0)), dimension(m), intent(in) :: x1a
  real(kind(1.d0)), dimension(n), intent(in) :: x2a
  real(kind(1.d0)), dimension(o), intent(in) :: x3a
  real(kind(1.d0)), dimension(m,n,o), intent(in) :: ya
  real(kind(1.d0)), dimension(m,n,o), intent(out) :: y2a

  integer :: i
  real(kind(1.d0)), allocatable, dimension(:,:) :: y2atmp,yatmp

  allocate(y2atmp(m,n))
  allocate(yatmp(m,n))
  y2atmp=0.0d0;yatmp=0.0d0;y2a=0.0d0

  do i=1,o
    yatmp(:,:) = ya(:,:,i)
    call init_bicubic_spline(x1a,x2a,yatmp,m,n,y2atmp)
    y2a(:,:,i) = y2atmp(:,:)
  enddo
  deallocate(y2atmp)
  deallocate(yatmp)
end subroutine init_tricubic_spline

real(kind(1.d0)) function bicubic_spline(x1a,x2a,ya,y2a,m,n,x1,x2,dy1,dy2)
  implicit none
  integer, intent(in) :: m,n
  real(kind(1.d0)), dimension(m), intent(in) :: x1a
  real(kind(1.d0)), dimension(n), intent(in) :: x2a
  real(kind(1.d0)), dimension(m,n), intent(in) :: ya,y2a
  real(kind(1.d0)), intent(in) :: x1,x2
  real(kind(1.d0)), intent(out) :: dy1,dy2

  integer j,k
  real(kind(1.d0)) :: dytmp,y1
  real(kind(1.d0)), allocatable, dimension(:) :: y2tmp, ytmp,yytmp,dytmpmat
  real(kind(1.d0)) :: cubic_splinef

  allocate(y2tmp(n))
  allocate(ytmp(n))
  allocate(yytmp(n))
  allocate(dytmpmat(n))
  y2tmp=0.0d0;ytmp=0.0d0;yytmp=0.0d0;dytmpmat=0.0d0

  do j=1,m
    ytmp(:) = ya(j,:)
    y2tmp(:) = y2a(j,:)
    yytmp(j) = cubic_splinef(n,x2a,ytmp,y2tmp,x2,dytmp)
    dytmpmat(j) = dytmp
  enddo

  dy1=0.0d0;dy2=0.0d0

!    y2tmp=0.0d0
  call init_cubic_spline(m,x1a,dytmpmat,y2tmp)
  dy2 = cubic_splinef(m,x1a,dytmpmat,y2tmp,x1,dytmp)

!    y2tmp=0.0d0
  call init_cubic_spline(m,x1a,yytmp,y2tmp)
  bicubic_spline = cubic_splinef(m,x1a,yytmp,y2tmp,x1,dy1)
  deallocate(y2tmp)
  deallocate(ytmp)
  deallocate(yytmp)
  deallocate(dytmpmat)
end function bicubic_spline

real(kind(1.d0)) function tricubic_spline(x1a,x2a,x3a,ya,y2a,m,n,o,x1,x2,x3,&
& dy1,dy2,dy3)
  implicit none
  integer, intent(in) :: m,n,o
  real(kind(1.d0)), dimension(m), intent(in) :: x1a
  real(kind(1.d0)), dimension(n), intent(in) :: x2a
  real(kind(1.d0)), dimension(o), intent(in) :: x3a
  real(kind(1.d0)), dimension(m,n,o), intent (in) :: ya
  real(kind(1.d0)), dimension(m,n,o), intent(in) :: y2a
  real(kind(1.d0)), intent(in) :: x1,x2,x3
  real(kind(1.d0)), intent(out) :: dy1,dy2,dy3

  integer j,k
  real(kind(1.d0)), allocatable, dimension(:) :: y2tmp
  real(kind(1.d0)), allocatable, dimension(:) :: yytmp
  real(kind(1.d0)), allocatable, dimension(:) :: dy1tmpmat
  real(kind(1.d0)), allocatable, dimension(:) :: dy2tmpmat
  real(kind(1.d0)) :: dy1tmp,dy2tmp,y3
  real(kind(1.d0)), allocatable, dimension(:,:) :: ytmp,y2atmp

  real(kind(1.d0)) :: bicubic_spline,cubic_splinef

  allocate(y2tmp(o))
  allocate(yytmp(o))
  allocate(dy1tmpmat(o))
  allocate(dy2tmpmat(o))
  allocate(ytmp(m,n))
  allocate(y2atmp(m,n))
  y2tmp=0.0d0;yytmp=0.0d0;dy1tmpmat=0.0d0
  dy2tmpmat=0.0d0;ytmp=0.0d0;y2atmp=0.0d0

  dy1=0.0d0;dy2=0.0d0;dy3=0.0d0
  do j=1,o
    ytmp(:,:) = ya(:,:,j)
    y2atmp(:,:) = y2a(:,:,j)
    yytmp(j) = bicubic_spline(x1a,x2a,ytmp,y2atmp,m,n,x1,x2,&
    & dy1tmp,dy2tmp)
    dy1tmpmat(j) = dy1tmp
    dy2tmpmat(j) = dy2tmp
  enddo

  call init_cubic_spline(o,x3a,dy1tmpmat,y2tmp)
  dy1 = cubic_splinef(o,x3a,dy1tmpmat,y2tmp,x3,dy1tmp)

  call init_cubic_spline(o,x3a,dy2tmpmat,y2tmp)
  dy2 = cubic_splinef(o,x3a,dy2tmpmat,y2tmp,x3,dy2tmp)

  call init_cubic_spline(o,x3a,yytmp,y2tmp)
  tricubic_spline = cubic_splinef(o,x3a,yytmp,y2tmp,x3,dy3)
  deallocate(y2tmp)
  deallocate(yytmp)
  deallocate(dy1tmpmat)
  deallocate(dy2tmpmat)
  deallocate(ytmp)
  deallocate(y2atmp)
end function tricubic_spline

module m_OP_decomp_band
  implicit none
  include 'mpif.h'
  integer istatus(mpi_status_size)

contains

  subroutine m_OP_wd_PROCAR
    use m_Control_Parameters, only : neg, nspin, ndim_spinor, ekmode, ndim_magmom
    use m_Control_Parameters, only : procar_save_memory_mode, sw_procar_full_bz, &
         &                           split_procar_file, num_procar_files_once, &
         &                           procar_sort_kpt, procar_sph_zaxis_to_magdir, &
         &                           procar_norm_zaxis_to_magdir, noncol
    use m_Const_Parameters,  only : zi, PAI, DP, CMPLDP, ON, OFF, BOHR, BUCS, HARTREE, &
         &                          GAMMA
    use m_Ionic_System,    only : ntyp, ityp, speciesname, pos, natm, &
         &                        lattice_system_from_m_CS_SG, iproj_group
    use m_PseudoPotential,   only : nlmt, ilmt, lmta, q, &
         &                          nlmta_phi, nlmtt_phi, qorb, m_PP_tell_iorb_lmtt, &
         &                          m_PP_tell_iorb_ia_l_m_tau, ilmt_phi, &
         &                          mtp_phi, lmta_phi, ltp_phi, taup_phi
    use m_PseudoPotential, only : iproj_phi, lmtt_phi, nrorb, irorb, crorb, nloc, &
         &                        nlmta_phi
    use m_Crystal_Structure, only : Global_Quantz_Axis_Fixed, sw_fix_global_quantz_axis
    use m_Crystal_structure,  only : op, nopr, altv
    use m_CD_Mag_Moment,    only : RhoMag_on_atom
    use m_Kpoints,  only : kv3, kv3_fbz, star_of_k, num_star_of_k, iopr_k_fbz_to_ibz, &
         &                 trev_k_fbz_to_ibz, vkxyz_fbz, m_Kp_set_star_of_k, &
         &                 vkxyz, k_symmetry, qwgt, kv3_ek
    use m_CS_SpaceGroup,  only : m_CS_gen_opr_rspace_full
    use m_CS_Magnetic,   only : m_CS_gen_opr_spinor_full, magmom_dir_inversion_opr_flag,&
         &                      determinant_op
    use m_Files,  only : nfout
    use m_SpinOrbit_Potential,  only : m_SO_set_MatU_ylm_RC
    use m_SpinOrbit_Potential,  only : MatU_ylm_RC_L0,  MatU_ylm_RC_L1,  &
         &                             MatU_ylm_RC_L2,  MatU_ylm_RC_L3
    use m_Parallelization,  only : ista_snl, iend_snl, ista_k, iend_k, npes, mype, &
         &                         myrank_k, myrank_e, nrank_k, mpi_comm_group, &
         &                         ista_e, iend_e, istep_e, map_k, map_z, map_e, &
         &                         mpi_e_world, mpi_k_world
    use m_IterationNumbers,     only : nk_in_the_process

    use m_Electronic_Structure,  only : compr_l, compi_l, eko_l, occup_l, efermi
    use m_Nonlocal_Potential,   only : norm_phig

    integer :: kfac, num_orbitals
    integer :: ind_max, lun, ierr

    real(kind=DP), allocatable :: compr(:,:,:,:), compi(:,:,:,:), norm_phig_mpi(:,:)
    real(kind=DP), allocatable :: eko_wk(:,:), occ_wk(:,:)
    integer, allocatable :: index_p2v(:)
    character*3, allocatable :: orb_name(:)
    complex(kind=CMPLDP), allocatable :: rotated_spinor(:,:,:)
    real(kind=DP), allocatable :: rotated_sph(:,:,:,:)

    integer :: nr, num, is, i, j
    character*4 char1
    character*72 file0, file1

    integer :: lmax, mmax

    call write_poscar

    kfac = 1;    num_orbitals = nlmta_phi *kfac
!!
    if ( noncol ) then
       if ( procar_sph_zaxis_to_magdir == ON ) then
          lmax = nloc;   mmax = 2*lmax -1
          allocate( rotated_sph(natm,lmax,mmax,mmax) ); rotated_sph = 0.0d0
          call set_rotated_sph
       else if ( procar_norm_zaxis_to_magdir == ON ) then
          lmax = 2;   mmax = 2*lmax -1
          allocate( rotated_sph(natm,lmax,mmax,mmax) ); rotated_sph = 0.0d0
          call set_rotated_sph
       endif
    endif

    if ( sw_procar_full_bz == ON ) call m_Kp_set_star_of_k

    if ( split_procar_file == ON ) then
       allocate( norm_phig_mpi(nlmtt_phi,ista_snl:iend_snl) );  norm_phig_mpi = 0.0d0
       allocate( compr( neg, num_orbitals,1, ista_k:iend_k ) ); compr = 0.0d0
       allocate( compi( neg, num_orbitals,1, ista_k:iend_k ) ); compi = 0.0d0
       call set_compri_etc_split
       if (noncol) then
          allocate( eko_wk(neg,ista_snl:iend_snl) );  eko_wk = 0.0d0
          allocate( occ_wk(neg,ista_snl:iend_snl) );  occ_wk = 0.0d0
       else
          allocate( eko_wk(neg,ista_k:iend_k) );  eko_wk = 0.0d0
          allocate( occ_wk(neg,ista_k:iend_k) );  occ_wk = 0.0d0
       endif
       call set_eko_occup_wk_split

    else
       allocate( norm_phig_mpi(nlmtt_phi,kv3/nspin) );  norm_phig_mpi = 0.0d0
       select case (procar_save_memory_mode) 
       case (0)
          allocate( compr( neg, num_orbitals,1, kv3 ) ); compr = 0.0d0
          allocate( compi( neg, num_orbitals,1, kv3 ) ); compi = 0.0d0
          call set_compri_etc
       case (1)
          if ( mype == 0 ) then
             allocate( compr( neg, num_orbitals,1, kv3 ) ); compr = 0.0d0
             allocate( compi( neg, num_orbitals,1, kv3 ) ); compi = 0.0d0
          endif
          call set_compri_etc2
       end select

       allocate( eko_wk(neg,kv3/ndim_spinor) );  eko_wk = 0.0d0
       allocate( occ_wk(neg,kv3/ndim_spinor) );  occ_wk = 0.0d0
       call set_eko_occup_wk
    endif

    ind_max = 9          ! up to d-orbital
    allocate( orb_name(ind_max) );   allocate( index_p2v(ind_max) )
    call set_orb_name(ind_max,orb_name)
    call set_index_converter_p2v(ind_max,index_p2v)

    if ( split_procar_file == ON ) then
       nr = nrank_k /num_procar_files_once +1
       num = 0
       
       lun = 10000 +myrank_k
       write(char1,'(I4.4)') myrank_k
       
       iloop: Do i=1, nr
          Do j=1, num_procar_files_once
             num = num +1             
             if ( num > npes )    goto 200
             if ( num /= myrank_k +1 ) cycle
             if ( myrank_e /= 0 )   cycle
             
             if ( noncol ) then
                allocate( rotated_spinor(natm,ndim_spinor,ndim_spinor) )
                call set_spinor_basis
                
                file0 = "PROCAR_phase"
                file1 = trim(adjustl(file0)) // '.' // char1
                open( lun, file=file1, status="unknown", form="formatted" )
                if ( sw_procar_full_bz == ON ) then
                   call write_file_noncl_fbz(lun)
                else
                   call write_file_noncl(lun)
                endif
                close(lun);   deallocate( rotated_spinor )

             else
                Do is=1, nspin
                   if ( nspin == 1 ) then
                      file0 = "PROCAR_phase"
                   else 
                      if ( is == 1 ) then
                         file0 = "PROCAR_phase.up"
                      else
                         file0 = "PROCAR_phase.dn"
                      endif
                   endif

                   file1 = trim(adjustl(file0)) // '.' // char1
                   open( lun, file=file1, status="unknown", form="formatted" )
                   if ( sw_procar_full_bz == ON ) then
                      call write_file_col_fbz(lun,is);   
                   else
                      call write_file_col(lun,is);   
                   endif
                   close(lun)
                End Do
             endif
          End Do
200       continue
          call mpi_barrier( mpi_comm_group, ierr )
       End Do iloop
       
    else if ( mype == 0 ) then
       lun = 1000
#if 0
       open( lun, file="PROCAR_phase", status="unknown", form="formatted")
#else
       if ( ekmode == OFF ) then
          open( lun, file="PROCAR_phase", status="unknown", form="formatted")
       else
          if ( nk_in_the_process == 1 ) then
             open( lun, file="PROCAR_phase", status="unknown", form="formatted")
          else
             open( lun, file="PROCAR_phase", status="unknown", form="formatted", &
                  &     position="append" )
          endif
       endif
#endif
       if ( noncol ) then
          allocate( rotated_spinor(natm,ndim_spinor,ndim_spinor) )
          call set_spinor_basis

          if ( sw_procar_full_bz == ON ) then
             if ( procar_sort_kpt == ON ) then
                call write_file_noncl_fbz_sort(lun)
             else
                call write_file_noncl_fbz(lun)
             endif
          else
             call write_file_noncl(lun)
          endif
          deallocate( rotated_spinor )

       else
          Do is=1, nspin
             if ( sw_procar_full_bz == ON ) then
                if ( procar_sort_kpt == ON ) then
                   call write_file_col_fbz_sort(lun,is)
                else
                   call write_file_col_fbz(lun,is)
                endif
             else
                call write_file_col(lun,is)
             endif
          End Do
       endif
       close(lun)

    endif

    deallocate(orb_name);  deallocate(index_p2v)
    if ( allocated(compr) ) deallocate( compr );
    if ( allocated(compi) ) deallocate( compi )
    deallocate( norm_phig_mpi )

    deallocate( eko_wk );    deallocate( occ_wk )
    if ( allocated(rotated_sph) ) deallocate( rotated_sph )

  contains

    subroutine calc_euler_angles2( axis, alpha, beta, gamma )   ! Z-Y-Z
      real(kind=DP), intent(in) :: axis(3,3)
      real(kind=DP), intent(out) :: alpha, beta, gamma
      !
      real(kind=DP) :: sigma, delta, c1, c2, c3, c4, c5
      real(kind=DP) :: mat(3,3)
      !
      mat = axis
      if ( mat(3,3) < 1.0D0 ) then
         if ( mat(3,3) > -1.0D0 ) then
            beta = acos( mat(3,3) )
            alpha = atan2( mat(2,3), mat(1,3) )
            gamma = atan2( mat(3,2), -mat(3,1) )
         else
            beta = PAI
            alpha = atan2( mat(2,1), mat(2,2) )
            gamma = 0.0D0;
         endif
      else
         beta = 0.0D0
         alpha = atan2( mat(2,1), mat(2,2) )
         gamma = 0.0D0
      endif
      !
      mat(1,1) = cos(alpha)*cos(beta)*cos(gamma) -sin(alpha)*sin(gamma)
      mat(1,2) = -cos(alpha)*cos(beta)*sin(gamma) -sin(alpha)*cos(gamma)
      mat(1,3) = cos(alpha)*sin(beta)
      mat(2,1) = sin(alpha)*cos(beta)*cos(gamma) +cos(alpha)*sin(gamma)
      mat(2,2) = -sin(alpha)*cos(beta)*sin(gamma) +cos(alpha)*cos(gamma)
      mat(2,3) = sin(alpha)*sin(beta)
      mat(3,1) = -sin(beta)*cos(gamma)
      mat(3,2) = sin(beta)*sin(gamma)
      mat(3,3) = cos(beta)
    end subroutine calc_euler_angles2

    subroutine set_rotated_sph  ! noncol
      integer :: ia, il1, im1, im2, im3, im4, val_l
      real(kind=DP) :: mx, my, mz, mnorm, c1
      real(kind=DP) :: theta, phi
      real(kind=DP) :: spn_quant_dir(3), angle(3), axis(3,3)
      complex(kind=CMPLDP) :: z1, z2, zsum
      complex(kind=CMPLDP), allocatable :: mat(:,:)

      integer :: lun
      character*72 file1

      call m_SO_set_MatU_ylm_RC
      if ( mype == 0 ) then
         lun = 1000;  file1 = './PROCAR_Rotated_Axis'
         open( lun, file=file1, status="unknown", form="formatted" )
         write(lun,'(A,4X,A,14X,A,14X,A)') " AtomID",  "X-axis", "Y-axis", "Z-axis"
      endif

      Do ia=1, natm
         if ( sw_fix_global_quantz_axis == ON ) then
            spn_quant_dir(1:3) = Global_Quantz_Axis_Fixed(1:3)
         else
            mx = RhoMag_on_atom(ia,2)
            my = RhoMag_on_atom(ia,3)
            mz = RhoMag_on_atom(ia,4)
            mnorm = sqrt( mx**2 +my**2 +mz**2 )
            if ( mnorm < 1.0D-8 ) then
               spn_quant_dir(1:2) = 0.0d0; spn_quant_dir(3) = 1.0d0
            else
               spn_quant_dir(1) = mx /mnorm
               spn_quant_dir(2) = my /mnorm
               spn_quant_dir(3) = mz /mnorm
            endif
         end if
!
         call set_rotated_axis( spn_quant_dir, axis )
         call calc_euler_angles2( axis, angle(1), angle(2), angle(3) )

         if ( mype == 0 ) then
            write(lun,'(I5)') ia
            write(lun,'(3F20.10)') axis(1,1:3)
            write(lun,'(3F20.10)') axis(2,1:3)
            write(lun,'(3F20.10)') axis(3,1:3)
         endif

         Do il1=1, lmax
            val_l = il1 -1
            allocate( mat(-val_l:val_l,-val_l:val_l) );  mat = 0.0d0
            
            Do im1=-val_l ,val_l
               Do im2=-val_l, val_l
                  call calc_small_Wigner_function( dble(val_l), dble(im1), dble(im2), &
                       &                           -angle(2), c1 )
                  z1 = exp( zi *im1 *angle(1) )
                  z2 = exp( zi *im2 *angle(3) )
                  mat(im1,im2) = z1 *c1 *z2
               End do
            End do
            
            Do im1=1, 2*val_l+1
               Do im2=1, 2*val_l +1
                  zsum = 0.0d0
                  
                  select case (val_l)
                  case (0)
                     Do im3=-val_l, val_l
                        Do im4=-val_l, val_l
                           zsum = zsum +MatU_ylm_RC_L0(im1,im3)*mat(im3,im4) &
                                &       *conjg(MatU_ylm_RC_L0(im2,im4))
                        End Do
                     End Do
                  case (1)
                     Do im3=-val_l, val_l
                        Do im4=-val_l, val_l
                           zsum = zsum +MatU_ylm_RC_L1(im1,im3)*mat(im3,im4) &
                                &       *conjg(MatU_ylm_RC_L1(im2,im4))
                        End Do
                     End Do
                  case (2)
                     Do im3=-val_l, val_l
                        Do im4=-val_l, val_l
                           zsum = zsum +MatU_ylm_RC_L2(im1,im3)*mat(im3,im4) &
                                &       *conjg(MatU_ylm_RC_L2(im2,im4))
                        End Do
                     End Do
                  case (3)
                     Do im3=-val_l, val_l
                        Do im4=-val_l, val_l
                           zsum = zsum +MatU_ylm_RC_L3(im1,im3)*mat(im3,im4) &
                                &       *conjg(MatU_ylm_RC_L3(im2,im4))
                        End Do
                     End Do
                  end select
                  rotated_sph(ia,il1,im1,im2) = zsum
               End Do
            End Do
            deallocate( mat )
         End Do
      End Do
      if ( mype == 0 ) close(lun)
#if 1
      if ( mype == 0 ) then
         lun = 1000;  file1 = './PROCAR_Rotated_Sph'
         open( lun, file=file1, status="unknown", form="formatted" )
         Do ia=1, natm
            write(lun,*) "Atom ID: ", ia
            Do il1=1, lmax
               val_l = il1 -1
               write(lun,*) "l = ", val_l
               Do im1=1, 2*val_l +1
                  Do im2=1, 2*val_l +1
                     write(lun,'(F10.4)',advance='no') rotated_sph(ia,il1,im1,im2)
                  End Do
                  write(lun,*)
               End Do
            End Do
         End Do
         close(lun)
      endif
#endif
    end subroutine set_rotated_sph

    subroutine set_rotated_axis( moment, axis )
      real(kind=DP), intent(in) :: moment(3)
      real(kind=DP), intent(out) :: axis(3,3)
!
      real(kind=DP) :: norm_xy, dx, dy, dz, th, cos_th, sin_th, c1
      real(kind=DP) :: rot_mat(3,3)
      real(kind=DP), parameter :: limit = 1.0D-6
!
! Rodrigues
      norm_xy = sqrt( moment(1)**2 +moment(2)**2 )
      if ( norm_xy < limit ) then
         axis = 0.0d0
         axis(1,1) = 1.0d0;   axis(2,2) = 1.0d0;    axis(3,3) = 1.0d0
         return
      endif
!
      dx = -moment(2)/norm_xy
      dy =  moment(1)/norm_xy
      dz =  0.0d0
!
      th = atan2( norm_xy, moment(3) )
      cos_th = cos(th);   sin_th = sin(th)
      !
      c1 = 1.0d0 -cos_th
!
!!      rot_mat(1,1) = dz*dz *c1 +cos_th
      rot_mat(1,1) = dx*dx *c1 +cos_th
      rot_mat(1,2) = dx*dy *c1 -dz *sin_th
      rot_mat(1,3) = dx*dz *c1 +dy *sin_th
      
      rot_mat(2,1) = dy*dx *c1 +dz *sin_th
      rot_mat(2,2) = dy*dy *c1 +cos_th
      rot_mat(2,3) = dy*dz *c1 -dx *sin_th
      
      rot_mat(3,1) = dz*dx *c1 -dy *sin_th
      rot_mat(3,2) = dz*dy *c1 +dx *sin_th
      rot_mat(3,3) = dz*dz *c1 +cos_th
!
      axis(1:3,1) = rot_mat(1:3,1)
      axis(1:3,2) = rot_mat(1:3,2)
      axis(1:3,3) = rot_mat(1:3,3)
    end subroutine set_rotated_axis

    subroutine write_poscar
      integer :: it, ia, num

      lun = 1000
      open( lun, file="POSCAR_phase", status="unknown", form="formatted")

      write(lun,'(X,A)') "PROCAR generated by phase"
      write(lun,'(3X,F20.16)') 1.0d0
      write(lun,'(5X,3F22.16)') altv(1:3,1) *Bohr
      write(lun,'(5X,3F22.16)') altv(1:3,2) *Bohr
      write(lun,'(5X,3F22.16)') altv(1:3,3) *Bohr
      Do it=1, ntyp
         write(lun,'(3X,A)',advance='no') speciesname(it)
      End Do
      write(lun,*)
      Do it=1, ntyp
         num = 0
         Do ia=1, natm
            if ( ityp(ia) == it ) num = num +1
         End Do
         write(lun,'(3X,I4)',advance='no') num
      End Do
      write(lun,*)

      write(lun,'(A)') "Direct"
      Do it=1, ntyp
         num = 0
         Do ia=1, natm
            if ( ityp(ia) /= it ) cycle
            write(lun,'(3F22.16)') pos(ia,1:3)
         End Do
      End Do
      write(lun,*)
      Do ia=1, natm
         write(lun,'(3F22.16)') 0.0d0, 0.0d0, 0.0d0
      End Do
      close(lun)
    end subroutine write_poscar

    subroutine set_compri_etc
      integer :: ik, iksnl, ie, ib, ierr
      real(kind=DP), allocatable :: compr_mpi(:,:,:,:), compi_mpi(:,:,:,:)
      real(kind=DP), allocatable :: norm_phig_mpi2(:,:)

      integer :: ia, it, il1, il2, im1, im2, tau1, tau2, iorb1, iorb2, lmt1, lmt2
      real(kind=DP) :: ctmp_r, ctmp_i
      real(kind=DP), allocatable :: cwork_r(:,:,:), cwork_i(:,:,:)

      if ( noncol .and. procar_sph_zaxis_to_magdir == ON ) then
         allocate( cwork_r(nlmta_phi,1,1) );  
         allocate( cwork_i(nlmta_phi,1,1) );

         do ik = 1, kv3
            if(map_k(ik) /= myrank_k) cycle
            iksnl = (ik-1)/nspin + 1
            do ie = ista_e, iend_e, istep_e
               ib = map_z(ie)
               do iorb1=1, nlmta_phi
                  cwork_r(iorb1,1,1) = compr_l(ib,iorb1,1,ik)
                  cwork_i(iorb1,1,1) = compi_l(ib,iorb1,1,ik)
               end do
               
               Do ia=1, natm
                  it = ityp(ia)
                  if (iproj_group(ia) == 0) cycle
                  
                  do lmt1=1,ilmt_phi(it)
                     il1 = ltp_phi(lmt1,it);      im1 = mtp_phi(lmt1,it)
                     tau1 = taup_phi(lmt1,it);    iorb1 = lmta_phi(lmt1,ia)
!                     immax = 2*il1 -1
                     
                     ctmp_r = 0.0d0;   ctmp_i = 0.0d0
                     do lmt2=1, ilmt_phi(it)
                        il2 = ltp_phi(lmt2,it);    im2 = mtp_phi(lmt2,it)
                        tau2 = taup_phi(lmt2,it);  iorb2 = lmta_phi(lmt2,ia)
                        if ( il1 /= il2 ) cycle
                        if ( tau1 /= tau2 ) cycle
                        ctmp_r = ctmp_r &
                             &    +rotated_sph(ia,il1,im2,im1) &
                             &                 *cwork_r(iorb2,1,1)
                        ctmp_i = ctmp_i &
                             &    +rotated_sph(ia,il1,im2,im1) &
                             &                 *cwork_i(iorb2,1,1)
                     end do
                     compr(ie,iorb1,1,ik) = ctmp_r;   compi(ie,iorb1,1,ik) = ctmp_i
                  end do
               end Do
            end do
            norm_phig_mpi(1:nlmtt_phi,iksnl)  = norm_phig(1:nlmtt_phi,iksnl)
         end do
         deallocate( cwork_r );  deallocate( cwork_i )
      else
         do ik = 1, kv3
            if(map_k(ik) /= myrank_k) cycle
            iksnl = (ik-1)/nspin + 1
            do ie = ista_e, iend_e, istep_e
               ib = map_z(ie)
               compr(ie,1:num_orbitals,1,ik) = compr_l(ib,1:num_orbitals,1,ik)
               compi(ie,1:num_orbitals,1,ik) = compi_l(ib,1:num_orbitals,1,ik)
            end do
            norm_phig_mpi(1:nlmtt_phi,iksnl)  = norm_phig(1:nlmtt_phi,iksnl)
         end do
      endif

      if ( npes >1 ) then
         allocate( compr_mpi( neg, num_orbitals, 1, kv3 ) ); compr_mpi = 0.0d0
         allocate( compi_mpi( neg, num_orbitals, 1, kv3 ) ); compi_mpi = 0.0d0
         allocate( norm_phig_mpi2( nlmtt_phi, kv3/nspin ) ); norm_phig_mpi2 = 0.0d0
         call mpi_allreduce( compr, compr_mpi, neg*num_orbitals*1*kv3, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         call mpi_allreduce( compi, compi_mpi, neg*num_orbitals*1*kv3, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         call mpi_allreduce( norm_phig_mpi, norm_phig_mpi2, nlmtt_phi*kv3/nspin, &
              &              mpi_double_precision, mpi_sum, mpi_e_world(myrank_e), ierr )
         compr = compr_mpi;   compi = compi_mpi
         norm_phig_mpi = norm_phig_mpi2 
         deallocate( compr_mpi ); deallocate( compi_mpi );
         deallocate( norm_phig_mpi2 )
      end if
    end subroutine set_compri_etc

    subroutine set_compri_etc2    ! save_memory
      integer :: ik, iksnl, ie, ib, ierr, iorb
      integer :: ia, it, il1, im1, tau1, il2, im2, tau2, iorb2, lmt2
      real(kind=DP) :: ctmp_r, ctmp_i
      real(kind=DP), allocatable :: compr_mpi(:,:,:,:), compi_mpi(:,:,:,:)
      real(kind=DP), allocatable :: norm_phig_mpi2(:,:)
      real(kind=DP), allocatable :: wkr(:,:), wkr_mpi(:,:), wki(:,:), wki_mpi(:,:)

      do ik = 1, kv3
         if(map_k(ik) /= myrank_k) cycle
         iksnl = (ik-1)/nspin + 1
         norm_phig_mpi(1:nlmtt_phi,iksnl)  = norm_phig(1:nlmtt_phi,iksnl)
      end do
      if ( npes >1 ) then
         allocate( norm_phig_mpi2( nlmtt_phi, kv3/nspin ) ); norm_phig_mpi2 = 0.0d0
         call mpi_allreduce( norm_phig_mpi, norm_phig_mpi2, nlmtt_phi*kv3/nspin, &
              &              mpi_double_precision, mpi_sum, mpi_e_world(myrank_e), ierr )
         norm_phig_mpi = norm_phig_mpi2 
         deallocate( norm_phig_mpi2 )
      end if

      allocate( wkr(neg,kv3) );    allocate( wki(neg,kv3) ); 

      Do iorb=1, num_orbitals
         wkr = 0.0d0;  wki = 0.0d0

         if ( noncol .and. procar_sph_zaxis_to_magdir == ON ) then
            call m_PP_tell_iorb_ia_l_m_tau( iorb, ia, il1, im1, tau1 )
            it = ityp(ia)

            do ik = 1, kv3
               if(map_k(ik) /= myrank_k) cycle
               iksnl = (ik-1)/nspin + 1
               do ie = ista_e, iend_e, istep_e
                  ib = map_z(ie)

                  ctmp_r = 0.0d0;   ctmp_i = 0.0d0
                  do lmt2=1, ilmt_phi(it)
                     il2 = ltp_phi(lmt2,it);    im2 = mtp_phi(lmt2,it)
                     tau2 = taup_phi(lmt2,it);  iorb2 = lmta_phi(lmt2,ia)
                     if ( il1 /= il2 ) cycle
                     if ( tau1 /= tau2 ) cycle
                     ctmp_r = ctmp_r &
                          &    +rotated_sph(ia,il1,im2,im1) &
                          &                 *compr_l(ib,iorb2,1,ik)
                     ctmp_i = ctmp_i &
                          &    +rotated_sph(ia,il1,im2,im1) &
                          &                 *compi_l(ib,iorb2,1,ik)
                  end do
                  wkr(ie,ik) = ctmp_r;    wki(ie,ik) = ctmp_i
               end do
            end do
         else
            do ik = 1, kv3
               if(map_k(ik) /= myrank_k) cycle
               iksnl = (ik-1)/nspin + 1
               do ie = ista_e, iend_e, istep_e
                  ib = map_z(ie)
                  wkr(ie,ik) = compr_l(ib,iorb,1,ik)
                  wki(ie,ik) = compi_l(ib,iorb,1,ik)
               end do
            end do
         endif

         if ( npes >1 ) then
            allocate( wkr_mpi( neg, kv3 ) ); wkr_mpi = 0.0d0
            allocate( wki_mpi( neg, kv3 ) ); wki_mpi = 0.0d0
            call mpi_allreduce( wkr, wkr_mpi, neg*kv3, &
                 &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
            call mpi_allreduce( wki, wki_mpi, neg*kv3, &
                 &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
            wkr = wkr_mpi;   wki = wki_mpi
            deallocate( wkr_mpi ); deallocate( wki_mpi );
         end if
         if ( mype == 0 ) then
            compr(:,iorb,1,:) = wkr(:,:);     compi(:,iorb,1,:) = wki(:,:)
         endif
      End Do
      deallocate( wkr );    deallocate( wki )
    end subroutine set_compri_etc2

    subroutine set_compri_etc_split
      integer :: ik, iksnl, ie, ib, ierr, iorb
      integer :: ia, it, il1, im1, tau1, il2, im2, tau2, iorb2, lmt2
      real(kind=DP) :: ctmp_r, ctmp_i
      real(kind=DP), allocatable :: compr_mpi(:,:,:,:), compi_mpi(:,:,:,:)
      real(kind=DP), allocatable :: norm_phig_mpi2(:,:)
      real(kind=DP), allocatable :: wkr(:,:), wkr_mpi(:,:), wki(:,:), wki_mpi(:,:)

      do ik = 1, kv3
         if(map_k(ik) /= myrank_k) cycle
         iksnl = (ik-1)/nspin + 1
         norm_phig_mpi(1:nlmtt_phi,iksnl)  = norm_phig(1:nlmtt_phi,iksnl)
      end do

      allocate( wkr(neg,ista_k:iend_k) );    allocate( wki(neg,ista_k:iend_k) ); 
      Do iorb=1, num_orbitals
         wkr = 0.0d0;  wki = 0.0d0

         if ( noncol .and. procar_sph_zaxis_to_magdir == ON ) then
            call m_PP_tell_iorb_ia_l_m_tau( iorb, ia, il1, im1, tau1 )
            it = ityp(ia)

            do ik = ista_k, iend_k
               iksnl = (ik-1)/nspin + 1
               do ie = ista_e, iend_e, istep_e
                  ib = map_z(ie)

                  ctmp_r = 0.0d0;   ctmp_i = 0.0d0
                  do lmt2=1, ilmt_phi(it)
                     il2 = ltp_phi(lmt2,it);    im2 = mtp_phi(lmt2,it)
                     tau2 = taup_phi(lmt2,it);  iorb2 = lmta_phi(lmt2,ia)
                     if ( il1 /= il2 ) cycle
                     if ( tau1 /= tau2 ) cycle
                     ctmp_r = ctmp_r &
                          &    +rotated_sph(ia,il1,im2,im1) &
                          &                 *compr_l(ib,iorb2,1,ik)
                     ctmp_i = ctmp_i &
                          &    +rotated_sph(ia,il1,im2,im1) &
                          &                 *compi_l(ib,iorb2,1,ik)
                  end do
                  wkr(ie,ik) = ctmp_r;    wki(ie,ik) = ctmp_i
               end do
            end do
         else
            do ik = ista_k, iend_k
               iksnl = (ik-1)/nspin + 1
               do ie = ista_e, iend_e, istep_e
                  ib = map_z(ie)
                  wkr(ie,ik) = compr_l(ib,iorb,1,ik)
                  wki(ie,ik) = compi_l(ib,iorb,1,ik)
               end do
            end do
         endif
         if ( npes >1 ) then
            allocate( wkr_mpi( neg, ista_k:iend_k ) ); wkr_mpi = 0.0d0
            allocate( wki_mpi( neg, ista_k:iend_k ) ); wki_mpi = 0.0d0
            call mpi_allreduce( wkr, wkr_mpi, neg*(iend_k-ista_k+1), &
                 &              mpi_double_precision, mpi_sum, &
                 &              mpi_k_world(myrank_k), ierr )
            call mpi_allreduce( wki, wki_mpi, neg*(iend_k-ista_k+1), &
                 &              mpi_double_precision, mpi_sum, &
                 &              mpi_k_world(myrank_k), ierr )
            wkr = wkr_mpi;   wki = wki_mpi
            deallocate( wkr_mpi ); deallocate( wki_mpi );
         end if
         compr(:,iorb,1,:) = wkr(:,:);     compi(:,iorb,1,:) = wki(:,:)
      End Do
      deallocate( wkr );    deallocate( wki )
    end subroutine set_compri_etc_split

    subroutine set_eko_occup_wk
      integer :: ik, ie, ierr, iksnl
      real(kind=DP), allocatable :: eko_mpi(:,:), occ_mpi(:,:)

      if ( noncol ) then
         do ik = 1, kv3, ndim_spinor
            if (map_k(ik) /= myrank_k) cycle
            iksnl = (ik-1)/nspin + 1
            do ie = 1, neg
               if (map_e(ie) /= myrank_e) cycle
               eko_wk(ie,iksnl) = eko_l(map_z(ie),ik)
               occ_wk(ie,iksnl) = occup_l(map_z(ie),ik)
            end do
         end do
      else
         do ik = 1, kv3
            if (map_k(ik) /= myrank_k) cycle
            do ie = 1, neg
               if (map_e(ie) /= myrank_e) cycle
               eko_wk(ie,ik) = eko_l(map_z(ie),ik)
               occ_wk(ie,ik) = occup_l(map_z(ie),ik)
            end do
         end do
      endif

      if ( npes > 1 ) then
         allocate( eko_mpi(neg,kv3/ndim_spinor) ); eko_mpi = 0.0d0
         allocate( occ_mpi(neg,kv3/ndim_spinor) ); occ_mpi = 0.0d0
         call mpi_allreduce( eko_wk, eko_mpi, neg*kv3/ndim_spinor, mpi_double_precision,&
              &              mpi_sum, mpi_comm_group, ierr )
         call mpi_allreduce( occ_wk, occ_mpi, neg*kv3/ndim_spinor, mpi_double_precision,&
              &              mpi_sum, mpi_comm_group, ierr )
         eko_wk = eko_mpi;   occ_wk = occ_mpi
         deallocate( eko_mpi );      deallocate( occ_mpi )
      endif
    end subroutine set_eko_occup_wk

    subroutine set_eko_occup_wk_split
      integer :: ik, ie, ierr, iksnl
      integer :: istart, iend
      real(kind=DP), allocatable :: eko_mpi(:,:), occ_mpi(:,:)

      if ( noncol ) then
         do ik = 1, kv3, ndim_spinor                                   
            if (map_k(ik) /= myrank_k) cycle               
            iksnl = (ik-1)/nspin + 1
            do ie = 1, neg                                
               if (map_e(ie) /= myrank_e) cycle            
               eko_wk(ie,iksnl) = eko_l(map_z(ie),ik)          
               occ_wk(ie,iksnl) = occup_l(map_z(ie),ik)        
            end do
         end do
      else
         do ik = 1, kv3                                   
            if (map_k(ik) /= myrank_k) cycle               
            do ie = 1, neg                                
               if (map_e(ie) /= myrank_e) cycle            
               eko_wk(ie,ik) = eko_l(map_z(ie),ik)          
               occ_wk(ie,ik) = occup_l(map_z(ie),ik)        
            end do
         end do
      endif

      if ( noncol ) then
         istart = ista_snl;  iend = iend_snl
      else
         istart = ista_k;  iend = iend_k
      endif
      if ( npes > 1 ) then
         allocate( eko_mpi(neg,istart:iend) ); eko_mpi = 0.0d0
         allocate( occ_mpi(neg,istart:iend) ); occ_mpi = 0.0d0
         call mpi_allreduce( eko_wk, eko_mpi, neg*(iend-istart+1), &
              &              mpi_double_precision,&
              &              mpi_sum, mpi_k_world(myrank_k), ierr )
         call mpi_allreduce( occ_wk, occ_mpi, neg*(iend-istart+1), &
              &              mpi_double_precision,&
              &              mpi_sum, mpi_k_world(myrank_k), ierr )
         eko_wk = eko_mpi;   occ_wk = occ_mpi
         deallocate( eko_mpi );      deallocate( occ_mpi )
      endif
    end subroutine set_eko_occup_wk_split

    subroutine write_file_col( lun, is )
      integer, intent(in) :: lun, is

      integer :: ik, iksnl, ia, it, ib
      integer :: lmt, il, im, tau, ip, iorb, lmtt, ind
      integer :: ikstart, ikend
      real(kind=DP) :: c1, weight
      complex(kind=CMPLDP) :: z1
      real(kind=DP), allocatable :: norm2(:,:), softpart(:,:,:)

      if ( mype ==0 .and. is==1 ) then
         write(lun,'(A)') "PROJ  (orbital) lm decomposed + phase factor"
      endif

      allocate( norm2(natm+1,ind_max+1) );    norm2 = 0.0d0
      allocate( softpart(natm,ind_max,2) );  softpart = 0.0d0

      if ( mype ==0 ) then
         write(lun,'(A,I7,5X,A,I7,5X,A,I7)') "# of k-points: ", kv3/nspin,  &
              &                              "# of bands: ", neg,  &
              &                              "# of ions:", natm
         write(lun,*)
      endif
      
      if ( split_procar_file == ON ) then
         ikstart = ista_k +is -1;    ikend = iend_k
      else
         ikstart = is;               ikend = kv3
      endif
      
      Do ik=ikstart, ikend, nspin
         iksnl = (ik-1)/nspin + 1
         write(lun,'(A,I7,A,3F16.12,3X,A,F16.12)') &
              &     " k-point", iksnl, " :", vkxyz(ik,1:3,BUCS), &
              &     " weight = ", qwgt(ik)*nspin
         write(lun,*)
         
         weight = kv3 *qwgt(ik) /dble(ndim_spinor)
         if ( nspin == 1 ) weight = weight /2.0d0
         
         Do ib=1, neg
            softpart = 0.0d0;  norm2 = 0.0d0
            
            write(lun,'(A,I5,A,F16.12,A,F16.12)') &
                 &     "band ", ib, &
                 &     " # energy ", ( eko_wk(ib,ik) -efermi )*Hartree, &
                 &     " # occ.", occ_wk(ib,ik)/weight
            write(lun,*)
            Do ia=1, natm
               it = ityp(ia)
               if(iproj_group(ia) == 0) cycle
               
               do lmt=1,ilmt_phi(it)
                  il = ltp_phi(lmt,it); im  = mtp_phi(lmt,it);
                  tau = taup_phi(lmt,it)
                  
                  ind = (il-1)**2 +im
                  iorb = lmta_phi(lmt,ia); lmtt = lmtt_phi(lmt,it)     
                  
                  z1 = dcmplx( compr(ib,iorb,1,ik), compi(ib,iorb,1,ik) )
                  c1 = z1*conjg(z1)*( 1.0d0 +qorb(iorb)/norm_phig_mpi(lmtt,iksnl) )
                  
                  norm2(ia,ind) = c1
                  softpart(ia,ind,1) = compr(ib,iorb,1,ik)
                  softpart(ia,ind,2) = compi(ib,iorb,1,ik)
               end do
            End Do
!
            Do ia=1, natm
               c1 = 0.0d0
               Do ind=1, ind_max
                  c1 = c1 +norm2(ia,ind)
               End Do
               norm2(ia,ind_max+1) = c1
            End Do
            !               
            Do ind=1, ind_max+1
               c1 = 0.0d0
               Do ia=1, natm
                  c1 = c1 +norm2(ia,ind)
               End Do
               norm2(natm+1,ind) = c1
            End Do
            
            write(lun,'(A)',advance='no') "ion "
            Do ind=1, ind_max
               write(lun,'(A,A)',advance='no') "    ", orb_name(index_p2v(ind))
            End Do
            write(lun,*) "   tot"
            
            Do ia=1, natm
               write(lun,'(I4)',advance='no') ia
               Do ind=1, ind_max
                  write(lun,'(F18.12)',advance='no') norm2(ia,index_p2v(ind))
               End Do
               write(lun,'(F18.12)',advance='no') norm2(ia,ind_max+1)
               write(lun,*)
            End Do
            
            write(lun,'(A)',advance='no') "tot "
            Do ind=1, ind_max
               write(lun,'(F18.12)',advance='no') norm2(natm+1,index_p2v(ind))
            End Do
            write(lun,'(F18.12)',advance='no') norm2(natm+1,ind_max+1)
            write(lun,*)
            
            write(lun,'(A)',advance='no') "ion "
            Do ind=1, ind_max
               write(lun,'(A,A)',advance='no') "    ", orb_name(index_p2v(ind))
            End Do
            write(lun,*) 
            
            Do ia=1, natm
               write(lun,'(I4)',advance='no') ia
               Do ind=1, ind_max
                  write(lun,'(F18.12)',advance='no') softpart(ia,index_p2v(ind),1)
               End Do
               write(lun,*)
               write(lun,'(I4)',advance='no') ia
               Do ind=1, ind_max
                  write(lun,'(F18.12)',advance='no') softpart(ia,index_p2v(ind),2)
               End Do
               write(lun,*)
            End Do
            write(lun,*)
            
         End Do
         if ( iksnl /= (kv3/nspin) ) write(lun,*)
      End Do
      deallocate(norm2); deallocate(softpart)

    end subroutine write_file_col

    subroutine write_file_col_fbz( lun, is )
      integer, intent(in) :: lun, is

      integer :: ik, iksnl, ia, it, ib, jksnl, ii
      integer :: lmt, il, im, tau, ip, iorb, lmtt, ind, lmtt2
      real(kind=DP) :: c1, weight, sign1
      complex(kind=CMPLDP) :: z1
      real(kind=DP), allocatable :: norm2(:,:), softpart(:,:,:)
      real(DP),allocatable :: crotylm(:,:,:)
      integer :: ikstart, ikend, jk, iopr, trev, mm, jorb
      real(kind=DP), allocatable :: compr_wk(:), compi_wk(:)

      if ( mype ==0 .and. is==1 ) then
         write(lun,'(A)') "PROJ  (orbital) lm decomposed + phase factor"
      endif

      allocate( norm2(natm+1,ind_max+1) );    norm2 = 0.0d0
      allocate( softpart(natm,ind_max,2) );  softpart = 0.0d0
      if ( mype ==0 ) then
         write(lun,'(A,I7,5X,A,I7,5X,A,I7)') "# of k-points: ", kv3_fbz/nspin,  &
              &                              "# of bands: ", neg,  &
              &                              "# of ions:", natm
         write(lun,*)
      endif

      if ( split_procar_file == ON ) then
         ikstart = ista_k +is -1;    ikend = iend_k
      else
         ikstart = is;               ikend = kv3
      endif

      allocate( compr_wk(nlmta_phi) )
      allocate( compi_wk(nlmta_phi) )
      
      Do ik=ikstart, ikend, nspin
         iksnl = (ik-1)/nspin + 1
         
         weight = kv3 *qwgt(ik) /dble(ndim_spinor)
         if ( nspin == 1 ) weight = weight /2.0d0
         
         Do ii=1, num_star_of_k(ik)
            jk = star_of_k(ik,ii)
            jksnl = (jk-1)/nspin + 1
            iopr = iopr_k_fbz_to_ibz(jk)
            trev = trev_k_fbz_to_ibz(jk)
            
            write(lun,'(A,I7,A,3F16.12,3X,A,F16.12)') &
                 &     " k-point", jksnl, " :", vkxyz_fbz(jk,1:3,BUCS), &
                 &     " weight = ", 1.0d0 / (kv3_fbz/nspin)
            write(lun,*)
            
            Do ib=1, neg
               softpart = 0.0d0;  norm2 = 0.0d0
               
               write(lun,'(A,I5,A,F16.12,A,F16.12)') &
                    &     "band ", ib, &
                    &     " # energy ", ( eko_wk(ib,ik) -efermi )*Hartree, &
                    &     " # occ.", occ_wk(ib,ik)/weight
               write(lun,*)
               !
               if ( k_symmetry(ik) == GAMMA ) then
               else
                  compr_wk = 0.d0;          compi_wk = 0.d0
                  do iorb=1,nlmta_phi
                     do mm=1,nrorb(iorb,iopr)
                        jorb = irorb(mm,iorb,iopr)
                        compr_wk(iorb) = compr_wk(iorb) +compr(ib,jorb,1,ik) &
                             &          *crorb(mm,iorb,iopr)
                        compi_wk(iorb) = compi_wk(iorb) +compi(ib,jorb,1,ik) &
                             &          *crorb(mm,iorb,iopr)
                     end do
                  end do
               endif
!
               Do ia=1, natm
                  it = ityp(ia)
                  if (iproj_group(ia) == 0) cycle
                  
                  do lmt=1,ilmt_phi(it)
                     il = ltp_phi(lmt,it); im  = mtp_phi(lmt,it);
                     tau = taup_phi(lmt,it)
                     ind = (il-1)**2 +im
                     iorb = lmta_phi(lmt,ia); lmtt = lmtt_phi(lmt,it)     

                     z1 = dcmplx( compr_wk(iorb), compi_wk(iorb) )

                     sign1 = 1.0d0
                     if ( trev == 1 ) sign1 = -sign1
#if 0
                     if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) sign1 = -sign1
#endif
                     if ( sign1 < .0d0 ) z1 = conjg(z1)

#if 1
                     if ( determinant_op(iopr) < 0 ) then
                        z1 = z1 *( (-1)**(il -1) )
                     endif
#endif
                     c1 = z1*conjg(z1)*( 1.0d0 +qorb(iorb)/norm_phig_mpi(lmtt,iksnl) )

                     norm2(ia,ind) = c1
                     softpart(ia,ind,1) = real( z1 )
                     softpart(ia,ind,2) = aimag( z1 )
                  end do
               End Do
!
               Do ia=1, natm
                  c1 = 0.0d0
                  Do ind=1, ind_max
                     c1 = c1 +norm2(ia,ind)
                  End Do
                  norm2(ia,ind_max+1) = c1
               End Do
!               
               Do ind=1, ind_max+1
                  c1 = 0.0d0
                  Do ia=1, natm
                     c1 = c1 +norm2(ia,ind)
                  End Do
                  norm2(natm+1,ind) = c1
               End Do

               write(lun,'(A)',advance='no') "ion "
               Do ind=1, ind_max
                  write(lun,'(A,A)',advance='no') "    ", orb_name(index_p2v(ind))
               End Do
               write(lun,*) "   tot"
               
               Do ia=1, natm
                  write(lun,'(I4)',advance='no') ia
                  Do ind=1, ind_max
                     write(lun,'(F18.12)',advance='no') norm2(ia,index_p2v(ind))
                  End Do
                  write(lun,'(F18.12)',advance='no') norm2(ia,ind_max+1)
                  write(lun,*)
               End Do

               write(lun,'(A)',advance='no') "tot "
               Do ind=1, ind_max
                  write(lun,'(F18.12)',advance='no') norm2(natm+1,index_p2v(ind))
               End Do
               write(lun,'(F18.12)',advance='no') norm2(natm+1,ind_max+1)
               write(lun,*)
               
               write(lun,'(A)',advance='no') "ion "
               Do ind=1, ind_max
                  write(lun,'(A,A)',advance='no') "    ", orb_name(index_p2v(ind))
               End Do
               write(lun,*) 
               
               Do ia=1, natm
                  write(lun,'(I4)',advance='no') ia
                  Do ind=1, ind_max
                     write(lun,'(F18.12)',advance='no') softpart(ia,index_p2v(ind),1)
                  End Do
                  write(lun,*)
                  write(lun,'(I4)',advance='no') ia
                  Do ind=1, ind_max
                     write(lun,'(F18.12)',advance='no') softpart(ia,index_p2v(ind),2)
                  End Do
                  write(lun,*)
               End Do
               write(lun,*)
               
            End Do
         End Do
         if ( iksnl /= (kv3/nspin) ) write(lun,*)
      End Do
      deallocate(norm2); deallocate(softpart)
      deallocate( compr_wk );      deallocate( compi_wk )
    end subroutine write_file_col_fbz

    subroutine write_file_col_fbz_sort( lun, is )
      integer, intent(in) :: lun, is

      integer :: ik, iksnl, ia, it, ib, jksnl, ii, iktmp
      integer :: lmt, il, im, tau, ip, iorb, lmtt, ind, lmtt2
      real(kind=DP) :: c1, weight, sign1
      complex(kind=CMPLDP) :: z1
      real(kind=DP), allocatable :: norm2(:,:), softpart(:,:,:)
      real(DP),allocatable :: crotylm(:,:,:)
      integer :: ikstart, ikend, jk, iopr, trev, mm, jorb
      real(kind=DP), allocatable :: compr_wk(:), compi_wk(:)

      if ( mype ==0 .and. is==1 ) then
         write(lun,'(A)') "PROJ  (orbital) lm decomposed + phase factor"
      endif

      allocate( norm2(natm+1,ind_max+1) );    norm2 = 0.0d0
      allocate( softpart(natm,ind_max,2) );  softpart = 0.0d0
      if ( mype ==0 ) then
         write(lun,'(A,I7,5X,A,I7,5X,A,I7)') "# of k-points: ", kv3_fbz/nspin,  &
              &                              "# of bands: ", neg,  &
              &                              "# of ions:", natm
         write(lun,*)
      endif

      if ( split_procar_file == ON ) then
         ikstart = ista_k +is -1;    ikend = iend_k
      else
         ikstart = is;               ikend = kv3
      endif

      allocate( compr_wk(nlmta_phi) )
      allocate( compi_wk(nlmta_phi) )
      
      Do jk=is, kv3_fbz, nspin

         iopr = iopr_k_fbz_to_ibz(jk)
         trev = trev_k_fbz_to_ibz(jk)
         jksnl = (jk-1)/nspin +1

         ikloop: Do ik=is, kv3, nspin
            Do ii=1, num_star_of_k(ik)
               if ( jk == star_of_k(ik,ii) ) then
                  iktmp = ik;  exit ikloop
               endif
            End Do
         end Do ikloop
         ik = iktmp

         iksnl = (ik-1)/nspin + 1
         
         weight = kv3 *qwgt(ik) /dble(ndim_spinor)
         if ( nspin == 1 ) weight = weight /2.0d0
         
         write(lun,'(A,I7,A,3F16.12,3X,A,F16.12)') &
              &     " k-point", jksnl, " :", vkxyz_fbz(jk,1:3,BUCS), &
              &     " weight = ", 1.0d0 / (kv3_fbz/nspin)
         write(lun,*)
            
         Do ib=1, neg
            softpart = 0.0d0;  norm2 = 0.0d0
            
            write(lun,'(A,I5,A,F16.12,A,F16.12)') &
                 &     "band ", ib, &
                 &     " # energy ", ( eko_wk(ib,ik) -efermi )*Hartree, &
                 &     " # occ.", occ_wk(ib,ik)/weight
            write(lun,*)
               !
            if ( k_symmetry(ik) == GAMMA ) then
            else
               compr_wk = 0.d0;          compi_wk = 0.d0
               do iorb=1,nlmta_phi
                  do mm=1,nrorb(iorb,iopr)
                     jorb = irorb(mm,iorb,iopr)
                     compr_wk(iorb) = compr_wk(iorb) +compr(ib,jorb,1,ik) &
                          &          *crorb(mm,iorb,iopr)
                     compi_wk(iorb) = compi_wk(iorb) +compi(ib,jorb,1,ik) &
                          &          *crorb(mm,iorb,iopr)
                  end do
               end do
            endif
            !
            Do ia=1, natm
               it = ityp(ia)
               if (iproj_group(ia) == 0) cycle
               
               do lmt=1,ilmt_phi(it)
                  il = ltp_phi(lmt,it); im  = mtp_phi(lmt,it);
                  tau = taup_phi(lmt,it)
                  ind = (il-1)**2 +im
                  iorb = lmta_phi(lmt,ia); lmtt = lmtt_phi(lmt,it)     
                  
                  z1 = dcmplx( compr_wk(iorb), compi_wk(iorb) )

                  sign1 = 1.0d0
                  if ( trev == 1 ) sign1 = -sign1
#if 0
                  if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) sign1 = -sign1
#endif                  
                  if ( sign1 < .0d0 ) z1 = conjg(z1)
#if 1
                  if ( determinant_op(iopr) < 0 ) then
                     z1 = z1 *( (-1)**(il -1) )
                  endif
#endif

                  c1 = z1*conjg(z1)*( 1.0d0 +qorb(iorb)/norm_phig_mpi(lmtt,iksnl) )
                  
                  norm2(ia,ind) = c1
                  softpart(ia,ind,1) = real(z1)
                  softpart(ia,ind,2) = aimag(z1)
               end do
            End Do
!
            Do ia=1, natm
               c1 = 0.0d0
               Do ind=1, ind_max
                  c1 = c1 +norm2(ia,ind)
               End Do
               norm2(ia,ind_max+1) = c1
            End Do
!               
            Do ind=1, ind_max+1
               c1 = 0.0d0
               Do ia=1, natm
                  c1 = c1 +norm2(ia,ind)
               End Do
               norm2(natm+1,ind) = c1
            End Do
            
            write(lun,'(A)',advance='no') "ion "
            Do ind=1, ind_max
               write(lun,'(A,A)',advance='no') "    ", orb_name(index_p2v(ind))
            End Do
            write(lun,*) "   tot"
            
            Do ia=1, natm
               write(lun,'(I4)',advance='no') ia
               Do ind=1, ind_max
                  write(lun,'(F18.12)',advance='no') norm2(ia,index_p2v(ind))
               End Do
               write(lun,'(F18.12)',advance='no') norm2(ia,ind_max+1)
               write(lun,*)
            End Do
            
            write(lun,'(A)',advance='no') "tot "
            Do ind=1, ind_max
               write(lun,'(F18.12)',advance='no') norm2(natm+1,index_p2v(ind))
            End Do
            write(lun,'(F18.12)',advance='no') norm2(natm+1,ind_max+1)
            write(lun,*)
            
            write(lun,'(A)',advance='no') "ion "
            Do ind=1, ind_max
               write(lun,'(A,A)',advance='no') "    ", orb_name(index_p2v(ind))
            End Do
            write(lun,*) 
            
            Do ia=1, natm
               write(lun,'(I4)',advance='no') ia
               Do ind=1, ind_max
                  write(lun,'(F18.12)',advance='no') softpart(ia,index_p2v(ind),1)
               End Do
               write(lun,*)
               write(lun,'(I4)',advance='no') ia
               Do ind=1, ind_max
                  write(lun,'(F18.12)',advance='no') softpart(ia,index_p2v(ind),2)
               End Do
               write(lun,*)
            End Do
            write(lun,*)
         End Do
         if ( jksnl /= (kv3_fbz/nspin) ) write(lun,*)
      End Do
      deallocate(norm2); deallocate(softpart)
      deallocate( compr_wk );      deallocate( compi_wk )
    end subroutine write_file_col_fbz_sort

    subroutine set_spinor_basis
      integer :: ia
      real(kind=DP) :: theta, phi, spn_quant_dir(3)
      real(kind=DP) :: mnorm, mx, my, mz

      if ( sw_fix_global_quantz_axis == ON ) then
         spn_quant_dir(1:3) = Global_Quantz_Axis_Fixed(1:3)
         theta = acos( spn_quant_dir(3) )
         phi = atan2( spn_quant_dir(2), spn_quant_dir(1) )

         Do ia=1, natm
            rotated_spinor(ia,1,1) =  exp( -zi *phi /2.0d0 ) *cos( theta /2.0d0 )
            rotated_spinor(ia,2,1) =  exp(  zi *phi /2.0d0 ) *sin( theta /2.0d0 )

            rotated_spinor(ia,1,2) = -exp( -zi *phi /2.0d0 ) *sin( theta /2.0d0 )
            rotated_spinor(ia,2,2) =  exp(  zi *phi /2.0d0 ) *cos( theta /2.0d0 )
         End Do
      else
         Do ia=1, natm
            mx = RhoMag_on_atom(ia,2)
            my = RhoMag_on_atom(ia,3)
            mz = RhoMag_on_atom(ia,4)
            mnorm = sqrt( mx**2 +my**2 +mz**2 )
            if ( mnorm < 1.0D-8 ) then
               spn_quant_dir(1) = 0.0d0
               spn_quant_dir(2) = 0.0d0
               spn_quant_dir(3) = 1.0d0

               theta = acos( spn_quant_dir(3) )
               phi = atan2( spn_quant_dir(2), spn_quant_dir(1) )
            else
               spn_quant_dir(1) = mx /mnorm
               spn_quant_dir(2) = my /mnorm
               spn_quant_dir(3) = mz /mnorm

               theta = acos( spn_quant_dir(3) )
               phi = atan2( spn_quant_dir(2), spn_quant_dir(1) )

               if ( spn_quant_dir(1)**2 +spn_quant_dir(2) < 1.0D-14 ) then
                  phi = 0.0d0
               endif
            endif

            rotated_spinor(ia,1,1) =  exp( -zi *phi /2.0d0 ) *cos( theta /2.0d0 )
            rotated_spinor(ia,2,1) =  exp(  zi *phi /2.0d0 ) *sin( theta /2.0d0 )

            rotated_spinor(ia,1,2) = -exp( -zi *phi /2.0d0 ) *sin( theta /2.0d0 )
            rotated_spinor(ia,2,2) =  exp(  zi *phi /2.0d0 ) *cos( theta /2.0d0 )
         End Do
      endif

    end subroutine set_spinor_basis

    subroutine write_file_noncl( lun )
      integer, intent(in) :: lun

      integer :: is, ik, iksnl, ia, it, ib
      integer :: lmt, il, im, tau, ip, iorb, lmtt, ind, m1, m2
      integer :: istmp, ikstart, ikend
      real(kind=DP) :: c1, c2, c3, c4, weight, vec1(3), vec2(3)
      complex(kind=CMPLDP) :: z1, z2, ztmp1, ztmp2, ztmp3, ztmp4
      complex(kind=CMPLDP) :: z1_u, z1_d, z2_u, z2_d

      real(kind=DP), allocatable :: norm2(:,:,:), softpart(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwork(:,:,:)

      if ( mype == 0 ) then
         if ( ekmode == OFF .or. nk_in_the_process == 1 ) then
            if ( procar_norm_zaxis_to_magdir == ON ) then
               write(lun,'(A)') &
                    &  "PROJ  (orbital) lm decomposed + phase factor (noncol,magdir//Z)"
            else
               write(lun,'(A)') &
                    &  "PROJ  (orbital) lm decomposed + phase factor (noncol)"
            endif
         endif
      endif

      allocate( norm2(natm+1,ind_max+1,ndim_magmom) );    norm2 = 0.0d0
      allocate( softpart(natm,ind_max,ndim_spinor,2) );  softpart = 0.0d0

      if ( mype == 0 ) then
         if ( ekmode == OFF ) then
            write(lun,'(A,I7,5X,A,I7,5X,A,I7)') "# of k-points: ", kv3/nspin,  &
              &                              "# of bands: ", neg,  &
              &                              "# of ions:", natm
            write(lun,*)
         else
            if ( nk_in_the_process == 1 ) then
               write(lun,'(A,I7,5X,A,I7,5X,A,I7)') "# of k-points: ", kv3_ek/nspin,  &
                    &                              "# of bands: ", neg,  &
                    &                              "# of ions:", natm
               write(lun,*)
            endif
         endif
      endif

      allocate( zwork(natm,ind_max,ndim_spinor) )

      if ( split_procar_file == ON ) then
         ikstart = ista_k;    ikend = iend_k
      else
         ikstart = 1;         ikend = kv3
      endif
      
      Do ik=ikstart, ikend, ndim_spinor
         iksnl = (ik-1)/ndim_spinor + 1
         write(lun,'(A,I7,A,3F16.12,3X,A,F16.12)') &
              &     " k-point", iksnl, " :", vkxyz(ik,1:3,BUCS), &
              &     " weight = ", qwgt(ik)
         write(lun,*)
            
         weight = kv3 *qwgt(ik) /dble(ndim_spinor)

         Do ib=1, neg
            softpart = 0.0d0;  norm2 = 0.0d0
               
            write(lun,'(A,I5,A,F16.12,A,F16.12)') &
                 &     "band ", ib, &
                 &     " # energy ", ( eko_wk(ib,iksnl) -efermi )*Hartree, &
                 &     " # occ.", occ_wk(ib,iksnl)/weight
            write(lun,*)
            Do ia=1, natm
               it = ityp(ia)
               if(iproj_group(ia) == 0) cycle
               
               do lmt=1,ilmt_phi(it)
                  il = ltp_phi(lmt,it); im  = mtp_phi(lmt,it);
                  tau = taup_phi(lmt,it)
                  
                  ind = (il-1)**2 +im
                  iorb = lmta_phi(lmt,ia); lmtt = lmtt_phi(lmt,it)     
                  
                  z1 = dcmplx( compr(ib,iorb,1,ik),   compi(ib,iorb,1,ik) )
                  z2 = dcmplx( compr(ib,iorb,1,ik+1), compi(ib,iorb,1,ik+1) )

                  ztmp1 =   z1*conjg(z1) +z2*conjg(z2)
                  ztmp2 =   z1*conjg(z2) +z2*conjg(z1)
                  ztmp3 = (-z1*conjg(z2) +z2*conjg(z1) )*zi
                  ztmp4 =   z1*conjg(z1) -z2*conjg(z2)

                  c1 = 1.0d0 +qorb(iorb)/norm_phig_mpi(lmtt,iksnl)
                  norm2(ia,ind,1) = ztmp1 *c1
                  norm2(ia,ind,2) = ztmp2 *c1
                  norm2(ia,ind,3) = ztmp3 *c1
                  norm2(ia,ind,4) = ztmp4 *c1

                  softpart(ia,ind,1,1) = compr(ib,iorb,1,ik)
                  softpart(ia,ind,1,2) = compi(ib,iorb,1,ik)
                  softpart(ia,ind,2,1) = compr(ib,iorb,1,ik+1)
                  softpart(ia,ind,2,2) = compi(ib,iorb,1,ik+1)
               End Do
            End Do
!!
            if ( procar_norm_zaxis_to_magdir == ON ) then
               Do ia=1, natm
                  il = 2         ! behave like p-orbital 
                  Do ind=1, ind_max
                     vec1(1:3) = norm2(ia,ind,2:4)
                     Do m1=1, 3
                        c1 = 0.0d0
                        Do m2=1, 3
                           c1 = c1 +rotated_sph(ia,il,m1,m2) *vec1(m2)
                        End Do
                        vec2(m1) = c1
                     End Do
                     norm2(ia,ind,2:4) = vec2(1:3)
                  End Do
               End Do
            endif
!
            Do ia=1, natm
               c1 = 0.0d0;   c2 = 0.0d0;    c3 = 0.0d0;   c4 = 0.0d0
               Do ind=1, ind_max
                  c1 = c1 +norm2(ia,ind,1)
                  c2 = c2 +norm2(ia,ind,2)
                  c3 = c3 +norm2(ia,ind,3)
                  c4 = c4 +norm2(ia,ind,4)
               End Do
               norm2(ia,ind_max+1,1) = c1
               norm2(ia,ind_max+1,2) = c2
               norm2(ia,ind_max+1,3) = c3
               norm2(ia,ind_max+1,4) = c4
            End Do
!               
            Do ind=1, ind_max+1
               c1 = 0.0d0;   c2 = 0.0d0;    c3 = 0.0d0;   c4 = 0.0d0
               Do ia=1, natm
                  c1 = c1 +norm2(ia,ind,1)
                  c2 = c2 +norm2(ia,ind,2)
                  c3 = c3 +norm2(ia,ind,3)
                  c4 = c4 +norm2(ia,ind,4)
               End Do
               norm2(natm+1,ind,1) = c1
               norm2(natm+1,ind,2) = c2
               norm2(natm+1,ind,3) = c3
               norm2(natm+1,ind,4) = c4
            End Do

            write(lun,'(A)',advance='no') "ion "
            Do ind=1, ind_max
               write(lun,'(A,A)',advance='no') "    ", orb_name(index_p2v(ind))
            End Do
            write(lun,*) "   tot"
            
            Do istmp=1, ndim_magmom
               Do ia=1, natm
                  write(lun,'(I4)',advance='no') ia
                  Do ind=1, ind_max
                     write(lun,'(F18.12)',advance='no') norm2(ia,index_p2v(ind),istmp)
                  End Do
                  write(lun,'(F18.12)',advance='no') norm2(ia,ind_max+1,istmp)
                  write(lun,*)
               End Do
               write(lun,'(A)',advance='no') "tot "
               Do ind=1, ind_max
                  write(lun,'(F18.12)',advance='no') &
                       &         norm2(natm+1,index_p2v(ind),istmp)
               End Do
               write(lun,'(F18.12)',advance='no') norm2(natm+1,ind_max+1,istmp)
               write(lun,*)
            End Do
            
            write(lun,'(A)',advance='no') "ion "
            Do ind=1, ind_max
               write(lun,'(A,A)',advance='no') "    ", orb_name(index_p2v(ind))
            End Do
            write(lun,*) 

            zwork = 0.0d0

            Do ia=1, natm
               Do ind=1, ind_max                
                  z1_u = dcmplx( softpart(ia,index_p2v(ind),1,1), &
                       &       softpart(ia,index_p2v(ind),1,2) )
                  z1_d = dcmplx( softpart(ia,index_p2v(ind),2,1), &
                       &       softpart(ia,index_p2v(ind),2,2) )
! 1st spinor basis
#if 1
                  z2_u = rotated_spinor(ia,1,1)
                  z2_d = rotated_spinor(ia,2,1)
#else
                  z2_u = 1.0d0
                  z2_d = 0.0d0
#endif
                  zwork(ia,ind,1) = conjg(z2_u) *z1_u +conjg(z2_d) *z1_d
! 2nd spinor basis
#if 1
                  z2_u = rotated_spinor(ia,1,2)
                  z2_d = rotated_spinor(ia,2,2)
#else
                  z2_u = 0.0d0
                  z2_d = 1.0d0
#endif
                  zwork(ia,ind,2) = conjg(z2_u) *z1_u +conjg(z2_d) *z1_d
               End do
            End Do
! =====
            Do is=1, ndim_spinor
               if ( sw_fix_global_quantz_axis == ON ) then
                  if ( is==1 ) then
                     write(lun,'(A)') "(globally major) "
                  else
                     write(lun,'(A)') "(globally minor) "
                  endif
               else
                  if ( is==1 ) then
                     write(lun,'(A)') "(locally major) "
                  else
                     write(lun,'(A)') "(locally minor) "
                  endif
               endif

               Do ia=1, natm
                  write(lun,'(I4)',advance='no') ia
                  Do ind=1, ind_max      
                     write(lun,'(F18.12)',advance='no') &
                          &       real(zwork(ia,ind,is))
                  End Do
                  write(lun,*)
                  write(lun,'(I4)',advance='no') ia
                  Do ind=1, ind_max      
                     write(lun,'(F18.12)',advance='no') &
                          &       aimag(zwork(ia,ind,is))
                  End Do
                  write(lun,*)
               End Do
! =====
            End Do
            write(lun,*)
         End Do
         if ( iksnl /= (kv3/nspin) ) write(lun,*)
      End Do
      deallocate( zwork )
      
      deallocate(norm2); deallocate(softpart)
    end subroutine write_file_noncl

    subroutine get_op_spinor( nopr, op_spinor )
      integer, intent(in) :: nopr
      complex(kind=CMPLDP) :: op_spinor(2,2,nopr)

      character(len=9) :: system
      integer :: nsym, i, j, k, l
      real(kind=DP) :: csum
      real(kind=DP), allocatable :: rot_space(:,:,:)
      complex(kind=CMPLDP), allocatable :: rot_spinor(:,:,:)

      if ( lattice_system_from_m_CS_SG == "hexagonal" ) then
         system = "hexagonal";    nsym = 24; 
      else
         system = "cubic";        nsym = 48;  
      endif

      allocate( rot_space(3,3,nsym) )
      allocate( rot_spinor(2,2,nsym) )
      call m_CS_gen_opr_rspace_full( system, nsym, rot_space )
      call m_CS_gen_opr_spinor_full( system, nsym, rot_spinor )
!
      Do i=1, nopr
         jloop: Do j=1, nsym
            csum = 0.0d0
            Do k=1, 3
               Do l=1, 3
                  csum = csum +( op(k,l,i) -rot_space(k,l,j) )**2
               End Do
            End Do
            if ( csum < 1.0D-4 ) then
               op_spinor(:,:,i) = rot_spinor(:,:,j)
               exit jloop
            endif
         End Do jloop
      End Do
      deallocate( rot_space );    deallocate( rot_spinor )
    end subroutine get_op_spinor

    subroutine write_file_noncl_fbz( lun )
      integer, intent(in) :: lun

      integer :: ik, iksnl, ia, it, ib, jksnl, is1, is2
      integer :: lmt, il, im, tau, ip, iorb, lmtt, ind, ii, m1, m2
      integer :: istmp, ikstart, ikend, jk, iopr, trev, mm, jorb
      real(kind=DP) :: c1, c2, c3, c4, weight, sign1, vec1(3), vec2(3)
      complex(kind=CMPLDP) :: z1, z2, ztmp1, ztmp2, ztmp3, ztmp4
      complex(kind=CMPLDP) :: z1_u, z1_d, z2_u, z2_d
      real(kind=DP), allocatable :: norm2(:,:,:), softpart(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwork(:,:,:), op_spinor(:,:,:)
      complex(kind=CMPLDP), allocatable :: zcomp_wk(:,:)

      if ( mype == 0 ) then
         if ( procar_norm_zaxis_to_magdir == ON ) then
            write(lun,'(A)') &
                 &  "PROJ  (orbital) lm decomposed + phase factor (noncol,magdir//Z)"
         else
            write(lun,'(A)') &
                 &  "PROJ  (orbital) lm decomposed + phase factor (noncol)"
         endif
      endif

      allocate( norm2(natm+1,ind_max+1,ndim_magmom) );    norm2 = 0.0d0
      allocate( softpart(natm,ind_max,ndim_spinor,2) );  softpart = 0.0d0

      if ( mype == 0 ) then
         write(lun,'(A,I7,5X,A,I7,5X,A,I7)') "# of k-points: ", kv3_fbz/nspin,  &
              &                              "# of bands: ", neg,  &
              &                              "# of ions:", natm
         write(lun,*)
      endif

      allocate( zwork(natm,ind_max,ndim_spinor) )

      allocate( op_spinor(2,2,nopr) )
      call get_op_spinor( nopr, op_spinor )

      if ( split_procar_file == ON ) then
         ikstart = ista_k;    ikend = iend_k
      else
         ikstart = 1;         ikend = kv3
      endif
      
      allocate( zcomp_wk(nlmta_phi,ndim_spinor) )

      Do ik=ikstart, ikend, ndim_spinor
         iksnl = (ik-1)/ndim_spinor + 1
         weight = kv3 *qwgt(ik) /dble(ndim_spinor)

         Do ii=1, num_star_of_k(ik)
            jk = star_of_k(ik,ii)
            iopr = iopr_k_fbz_to_ibz(jk)
            trev = trev_k_fbz_to_ibz(jk)
            jksnl = (jk-1)/ndim_spinor + 1

            write(lun,'(A,I7,A,3F16.12,3X,A,F16.12)') &
              &     " k-point", jksnl, " :", vkxyz_fbz(jk,1:3,BUCS), &
              &     " weight = ", 1.0d0 / (kv3_fbz/ndim_spinor)
            write(lun,*)
            
            Do ib=1, neg
               softpart = 0.0d0;  norm2 = 0.0d0
               
               write(lun,'(A,I5,A,F16.12,A,F16.12)') &
                    &     "band ", ib, &
                    &     " # energy ", ( eko_wk(ib,iksnl) -efermi )*Hartree, &
                    &     " # occ.", occ_wk(ib,iksnl)/weight
               write(lun,*)

               zcomp_wk = 0.d0;
               do is1=1, ndim_spinor
                  do iorb=1,nlmta_phi
                     Do is2=1, ndim_spinor
                        do mm=1,nrorb(iorb,iopr)
                           jorb = irorb(mm,iorb,iopr)
#if 1
                           z1 = dcmplx( compr(ib,jorb,1,ik+is2-1),&
                                &       compi(ib,jorb,1,ik+is2-1) )
                           zcomp_wk(iorb,is1) = zcomp_wk(iorb,is1) &
                                &             +z1 *crorb(mm,iorb,iopr) &
                                &             *op_spinor(is1,is2,iopr)
!                               &             *op_spinor(is2,is1,iopr)
#else
                           z1 = dcmplx( compr(ib,iorb,1,ik+is2-1),&
                                &       compi(ib,iorb,1,ik+is2-1) )
                           zcomp_wk(jorb,is1) = zcomp_wk(jorb,is1) &
                                &             +z1 *crorb(mm,iorb,iopr) &
                                &             *op_spinor(is1,is2,iopr)
#endif
                        end do
                     end do
                  end do
               end do
!!               if ( trev == 1 ) zcomp_wk = dconjg( zcomp_wk )   ! ????

               Do ia=1, natm
                  it = ityp(ia)
                  if(iproj_group(ia) == 0) cycle
                  
                  do lmt=1,ilmt_phi(it)
                     il = ltp_phi(lmt,it); im  = mtp_phi(lmt,it);
                     tau = taup_phi(lmt,it)
                     
                     ind = (il-1)**2 +im
                     iorb = lmta_phi(lmt,ia); lmtt = lmtt_phi(lmt,it)     
                  
                     sign1 = 1.0d0
                     if ( trev == 1 ) sign1 = -sign1
                     if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) sign1 = -sign1

                     if ( sign1 > 0.0d0 ) then
                        z1 = zcomp_wk(iorb,1)
                        z2 = zcomp_wk(iorb,2)
                     else
                        z1 = -conjg( zcomp_wk(iorb,2) )*zi
                        z2 =  conjg( zcomp_wk(iorb,1) )*zi
                     endif
#if 1
                     if ( determinant_op(iopr) < 0 ) then
                        z1 = z1 *( (-1)**(il -1) )
                        z2 = z2 *( (-1)**(il -1) )
                     endif
#endif
                     ztmp1 =   z1*conjg(z1) +z2*conjg(z2)
                     ztmp2 =   z1*conjg(z2) +z2*conjg(z1)
                     ztmp3 = (-z1*conjg(z2) +z2*conjg(z1) )*zi
                     ztmp4 =   z1*conjg(z1) -z2*conjg(z2)

                     c1 = 1.0d0 +qorb(iorb)/norm_phig_mpi(lmtt,iksnl)
                     norm2(ia,ind,1) = ztmp1 *c1
                     norm2(ia,ind,2) = ztmp2 *c1
                     norm2(ia,ind,3) = ztmp3 *c1
                     norm2(ia,ind,4) = ztmp4 *c1
                     
                     softpart(ia,ind,1,1) = real( z1 )
                     softpart(ia,ind,1,2) = aimag( z1 )
                     softpart(ia,ind,2,1) = real( z2 )
                     softpart(ia,ind,2,2) = aimag( z2 )
                  End Do
               End Do
!
               if ( procar_norm_zaxis_to_magdir == ON ) then
                  Do ia=1, natm
                     il = 2         ! behave like p-orbital 
                     Do ind=1, ind_max
                        vec1(1:3) = norm2(ia,ind,2:4)
                        Do m1=1, 3
                           c1 = 0.0d0
                           Do m2=1, 3
                              c1 = c1 +rotated_sph(ia,il,m1,m2) *vec1(m2)
                           End Do
                           vec2(m1) = c1
                        End Do
                        norm2(ia,ind,2:4) = vec2(1:3)
                     End Do
                  End Do
               endif

               Do ia=1, natm
                  c1 = 0.0d0;   c2 = 0.0d0;    c3 = 0.0d0;   c4 = 0.0d0
                  Do ind=1, ind_max
                     c1 = c1 +norm2(ia,ind,1)
                     c2 = c2 +norm2(ia,ind,2)
                     c3 = c3 +norm2(ia,ind,3)
                     c4 = c4 +norm2(ia,ind,4)
                  End Do
                  norm2(ia,ind_max+1,1) = c1
                  norm2(ia,ind_max+1,2) = c2
                  norm2(ia,ind_max+1,3) = c3
                  norm2(ia,ind_max+1,4) = c4
               End Do
!               
               Do ind=1, ind_max+1
                  c1 = 0.0d0;   c2 = 0.0d0;    c3 = 0.0d0;   c4 = 0.0d0
                  Do ia=1, natm
                     c1 = c1 +norm2(ia,ind,1)
                     c2 = c2 +norm2(ia,ind,2)
                     c3 = c3 +norm2(ia,ind,3)
                     c4 = c4 +norm2(ia,ind,4)
                  End Do
                  norm2(natm+1,ind,1) = c1
                  norm2(natm+1,ind,2) = c2
                  norm2(natm+1,ind,3) = c3
                  norm2(natm+1,ind,4) = c4
               End Do

               write(lun,'(A)',advance='no') "ion "
               Do ind=1, ind_max
                  write(lun,'(A,A)',advance='no') "    ", orb_name(index_p2v(ind))
               End Do
               write(lun,*) "   tot"
               
               Do istmp=1, ndim_magmom
                  Do ia=1, natm
                     write(lun,'(I4)',advance='no') ia
                     Do ind=1, ind_max
                        write(lun,'(F18.12)',advance='no') norm2(ia,index_p2v(ind),istmp)
                     End Do
                     write(lun,'(F18.12)',advance='no') norm2(ia,ind_max+1,istmp)
                     write(lun,*)
                  End Do
                  write(lun,'(A)',advance='no') "tot "
                  Do ind=1, ind_max
                     write(lun,'(F18.12)',advance='no') &
                          &         norm2(natm+1,index_p2v(ind),istmp)
                  End Do
                  write(lun,'(F18.12)',advance='no') norm2(natm+1,ind_max+1,istmp)
                  write(lun,*)
               End Do
               
               write(lun,'(A)',advance='no') "ion "
               Do ind=1, ind_max
                  write(lun,'(A,A)',advance='no') "    ", orb_name(index_p2v(ind))
               End Do
               write(lun,*) 

               zwork = 0.0d0

               Do ia=1, natm
                  Do ind=1, ind_max                
                     z1_u = dcmplx( softpart(ia,index_p2v(ind),1,1), &
                          &       softpart(ia,index_p2v(ind),1,2) )
                     z1_d = dcmplx( softpart(ia,index_p2v(ind),2,1), &
                          &       softpart(ia,index_p2v(ind),2,2) )
! 1st spinor basis
#if 1
                     z2_u = rotated_spinor(ia,1,1)
                     z2_d = rotated_spinor(ia,2,1)
#else
                     z2_u = 1.0d0
                     z2_d = 0.0d0
#endif
                     zwork(ia,ind,1) = conjg(z2_u) *z1_u +conjg(z2_d) *z1_d
! 2nd spinor basis
#if 1
                     z2_u = rotated_spinor(ia,1,2)
                     z2_d = rotated_spinor(ia,2,2)
#else
                     z2_u = 0.0d0
                     z2_d = 1.0d0
#endif
                     zwork(ia,ind,2) = conjg(z2_u) *z1_u +conjg(z2_d) *z1_d
                  End do
               End Do
! =====
               Do is1=1, ndim_spinor
                  if ( sw_fix_global_quantz_axis == ON ) then
                     if ( is1==1 ) then
                        write(lun,'(A)') "(globally major) "
                     else
                        write(lun,'(A)') "(globally minor) "
                     endif
                  else
                     if ( is1==1 ) then
                        write(lun,'(A)') "(locally major) "
                     else
                        write(lun,'(A)') "(locally minor) "
                     endif
                  endif
                  
                  Do ia=1, natm
                     write(lun,'(I4)',advance='no') ia
                     Do ind=1, ind_max      
                        write(lun,'(F18.12)',advance='no') &
                             &       real(zwork(ia,ind,is1))
                     End Do
                     write(lun,*)
                     write(lun,'(I4)',advance='no') ia
                     Do ind=1, ind_max      
                        write(lun,'(F18.12)',advance='no') &
                             &       aimag(zwork(ia,ind,is1))
                     End Do
                     write(lun,*)
                  End Do
                  ! =====
               End Do
               write(lun,*)
            End Do
         End Do
         if ( iksnl /= (kv3/nspin) ) write(lun,*)
      End Do

      deallocate( zwork )
      deallocate( op_spinor )
      deallocate(norm2); deallocate(softpart)
    end subroutine write_file_noncl_fbz

    subroutine write_file_noncl_fbz_sort( lun )
      integer, intent(in) :: lun

      integer :: ik, iksnl, ia, it, ib, jksnl, is1, is2, ii
      integer :: lmt, il, im, tau, ip, iorb, lmtt, ind, iktmp
      integer :: istmp, ikstart, ikend, jk, iopr, trev, mm, jorb
      real(kind=DP) :: c1, c2, c3, c4, weight, sign1
      complex(kind=CMPLDP) :: z1, z2, ztmp1, ztmp2, ztmp3, ztmp4
      complex(kind=CMPLDP) :: z1_u, z1_d, z2_u, z2_d
      real(kind=DP), allocatable :: norm2(:,:,:), softpart(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwork(:,:,:), op_spinor(:,:,:)
      complex(kind=CMPLDP), allocatable :: zcomp_wk(:,:)
      integer :: ipriprocar = 1

      if ( mype == 0 ) then
         if ( procar_norm_zaxis_to_magdir == ON ) then
            write(lun,'(A)') &
                 &  "PROJ  (orbital) lm decomposed + phase factor (noncol,magdir//Z)"
         else
            write(lun,'(A)') &
                 &  "PROJ  (orbital) lm decomposed + phase factor (noncol)"
         endif
      endif

      allocate( norm2(natm+1,ind_max+1,ndim_magmom) );    norm2 = 0.0d0
      allocate( softpart(natm,ind_max,ndim_spinor,2) );  softpart = 0.0d0

      if ( mype == 0 ) then
         write(lun,'(A,I7,5X,A,I7,5X,A,I7)') "# of k-points: ", kv3_fbz/nspin,  &
              &                              "# of bands: ", neg,  &
              &                              "# of ions:", natm
         write(lun,*)
      endif

      allocate( zwork(natm,ind_max,ndim_spinor) )

      allocate( op_spinor(2,2,nopr) )
      call get_op_spinor( nopr, op_spinor )
!
      if ( split_procar_file == ON ) then
         ikstart = ista_k;    ikend = iend_k
      else
         ikstart = 1;         ikend = kv3
      endif
      
      allocate( zcomp_wk(nlmta_phi,ndim_spinor) )

      Do jk=1, kv3_fbz, ndim_spinor

         iopr = iopr_k_fbz_to_ibz(jk)
         trev = trev_k_fbz_to_ibz(jk)
         jksnl = (jk-1)/ndim_spinor + 1

         ikloop: Do ik=1, kv3, ndim_spinor
            Do ii=1, num_star_of_k(ik)
               if ( jk == star_of_k(ik,ii) ) then
                  iktmp = ik;  exit ikloop
               endif
            End Do
         end Do ikloop
         ik = iktmp

         iksnl = (ik-1)/ndim_spinor + 1
         weight = kv3 *qwgt(ik) /dble(ndim_spinor)

         if ( ipriprocar > 1 ) then
            if ( mype == 0 ) then
               write(nfout,*) "jksnl :", jksnl, iksnl, iopr, trev, &
                    &     magmom_dir_inversion_opr_flag(iopr), determinant_op(iopr)
            endif
         endif

         write(lun,'(A,I7,A,3F16.12,3X,A,F16.12)') &
              &     " k-point", jksnl, " :", vkxyz_fbz(jk,1:3,BUCS), &
              &     " weight = ", 1.0d0 / (kv3_fbz/ndim_spinor)
         write(lun,*)
            
         Do ib=1, neg
            softpart = 0.0d0;  norm2 = 0.0d0
               
            write(lun,'(A,I5,A,F16.12,A,F16.12)') &
                 &     "band ", ib, &
                 &     " # energy ", ( eko_wk(ib,iksnl) -efermi )*Hartree, &
                 &     " # occ.", occ_wk(ib,iksnl)/weight
            write(lun,*)
            
            zcomp_wk = 0.d0;
            do is1=1, ndim_spinor
               do iorb=1,nlmta_phi
                  Do is2=1, ndim_spinor
                     do mm=1,nrorb(iorb,iopr)
                        jorb = irorb(mm,iorb,iopr)
#if 1
                        z1 = dcmplx( compr(ib,jorb,1,ik+is2-1),&
                                &       compi(ib,jorb,1,ik+is2-1) )
                        zcomp_wk(iorb,is1) = zcomp_wk(iorb,is1) &
                             &             +z1 *crorb(mm,iorb,iopr) &
                             &             *op_spinor(is1,is2,iopr)
!                             &             *op_spinor(is2,is1,iopr)
#else
                        z1 = dcmplx( compr(ib,iorb,1,ik+is2-1),&
                             &       compi(ib,iorb,1,ik+is2-1) )
                        zcomp_wk(jorb,is1) = zcomp_wk(jorb,is1) &
                             &             +z1 *crorb(mm,iorb,iopr) &
                             &             *op_spinor(is1,is2,iopr)
#endif
                     end do
                  end do
               end do
            end do
!!            if ( trev == 1 ) zcomp_wk = dconjg( zcomp_wk )   ! ????

            Do ia=1, natm
               it = ityp(ia)
               if(iproj_group(ia) == 0) cycle
               
               do lmt=1,ilmt_phi(it)
                  il = ltp_phi(lmt,it); im  = mtp_phi(lmt,it);
                  tau = taup_phi(lmt,it)
                  
                  ind = (il-1)**2 +im
                  iorb = lmta_phi(lmt,ia); lmtt = lmtt_phi(lmt,it)     
                  
                  sign1 = 1.0d0
                  if ( trev == 1 ) sign1 = -sign1
                  if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) sign1 = -sign1

                  if ( sign1 > 0.0d0 ) then
                     z1 = zcomp_wk(iorb,1)
                     z2 = zcomp_wk(iorb,2)
                  else
                     z1 = -conjg( zcomp_wk(iorb,2) )*zi
                     z2 =  conjg( zcomp_wk(iorb,1) )*zi
                  endif
#if 1
                  if ( determinant_op(iopr) < 0 ) then
                     z1 = z1 *( (-1)**(il -1) )
                     z2 = z2 *( (-1)**(il -1) )
                  endif
#endif
                  ztmp1 =   z1*conjg(z1) +z2*conjg(z2)
                  ztmp2 =   z1*conjg(z2) +z2*conjg(z1)
                  ztmp3 = (-z1*conjg(z2) +z2*conjg(z1) )*zi
                  ztmp4 =   z1*conjg(z1) -z2*conjg(z2)
!
                  c1 = 1.0d0 +qorb(iorb)/norm_phig_mpi(lmtt,iksnl)
                  norm2(ia,ind,1) = ztmp1 *c1
                  norm2(ia,ind,2) = ztmp2 *c1
                  norm2(ia,ind,3) = ztmp3 *c1
                  norm2(ia,ind,4) = ztmp4 *c1
                  
                  softpart(ia,ind,1,1) = real( z1 )
                  softpart(ia,ind,1,2) = aimag( z1 )
                  softpart(ia,ind,2,1) = real( z2 )
                  softpart(ia,ind,2,2) = aimag( z2 )
               End Do
            End Do
            !
            Do ia=1, natm
               c1 = 0.0d0;   c2 = 0.0d0;    c3 = 0.0d0;   c4 = 0.0d0
               Do ind=1, ind_max
                  c1 = c1 +norm2(ia,ind,1)
                  c2 = c2 +norm2(ia,ind,2)
                  c3 = c3 +norm2(ia,ind,3)
                  c4 = c4 +norm2(ia,ind,4)
               End Do
               norm2(ia,ind_max+1,1) = c1
               norm2(ia,ind_max+1,2) = c2
               norm2(ia,ind_max+1,3) = c3
               norm2(ia,ind_max+1,4) = c4
            End Do
            !               
            Do ind=1, ind_max+1
               c1 = 0.0d0;   c2 = 0.0d0;    c3 = 0.0d0;   c4 = 0.0d0
               Do ia=1, natm
                  c1 = c1 +norm2(ia,ind,1)
                  c2 = c2 +norm2(ia,ind,2)
                  c3 = c3 +norm2(ia,ind,3)
                  c4 = c4 +norm2(ia,ind,4)
               End Do
               norm2(natm+1,ind,1) = c1
               norm2(natm+1,ind,2) = c2
               norm2(natm+1,ind,3) = c3
               norm2(natm+1,ind,4) = c4
            End Do
            
            write(lun,'(A)',advance='no') "ion "
            Do ind=1, ind_max
               write(lun,'(A,A)',advance='no') "    ", orb_name(index_p2v(ind))
            End Do
            write(lun,*) "   tot"
            
            Do istmp=1, ndim_magmom
               Do ia=1, natm
                  write(lun,'(I4)',advance='no') ia
                  Do ind=1, ind_max
                     write(lun,'(F18.12)',advance='no') norm2(ia,index_p2v(ind),istmp)
                  End Do
                  write(lun,'(F18.12)',advance='no') norm2(ia,ind_max+1,istmp)
                  write(lun,*)
               End Do
               write(lun,'(A)',advance='no') "tot "
               Do ind=1, ind_max
                  write(lun,'(F18.12)',advance='no') &
                       &         norm2(natm+1,index_p2v(ind),istmp)
               End Do
               write(lun,'(F18.12)',advance='no') norm2(natm+1,ind_max+1,istmp)
               write(lun,*)
            End Do
            
            write(lun,'(A)',advance='no') "ion "
            Do ind=1, ind_max
               write(lun,'(A,A)',advance='no') "    ", orb_name(index_p2v(ind))
            End Do
            write(lun,*) 
            
            zwork = 0.0d0
            
            Do ia=1, natm
               Do ind=1, ind_max                
                  z1_u = dcmplx( softpart(ia,index_p2v(ind),1,1), &
                       &       softpart(ia,index_p2v(ind),1,2) )
                  z1_d = dcmplx( softpart(ia,index_p2v(ind),2,1), &
                       &       softpart(ia,index_p2v(ind),2,2) )
                  ! 1st spinor basis
#if 1
                  z2_u = rotated_spinor(ia,1,1)
                  z2_d = rotated_spinor(ia,2,1)
#else
                  z2_u = 1.0d0
                  z2_d = 0.0d0
#endif
                  zwork(ia,ind,1) = conjg(z2_u) *z1_u +conjg(z2_d) *z1_d
                  ! 2nd spinor basis
#if 1
                  z2_u = rotated_spinor(ia,1,2)
                  z2_d = rotated_spinor(ia,2,2)
#else
                  z2_u = 0.0d0
                  z2_d = 1.0d0
#endif
                  zwork(ia,ind,2) = conjg(z2_u) *z1_u +conjg(z2_d) *z1_d
               End do
            End Do
            ! =====
            Do is1=1, ndim_spinor
               if ( sw_fix_global_quantz_axis == ON ) then
                  if ( is1==1 ) then
                     write(lun,'(A)') "(globally major) "
                  else
                     write(lun,'(A)') "(globally minor) "
                  endif
               else
                  if ( is1==1 ) then
                     write(lun,'(A)') "(locally major) "
                  else
                     write(lun,'(A)') "(locally minor) "
                  endif
               endif
               
               Do ia=1, natm
                  write(lun,'(I4)',advance='no') ia
                  Do ind=1, ind_max      
                     write(lun,'(F18.12)',advance='no') &
                          &       real(zwork(ia,ind,is1))
                  End Do
                  write(lun,*)
                  write(lun,'(I4)',advance='no') ia
                  Do ind=1, ind_max      
                     write(lun,'(F18.12)',advance='no') &
                          &       aimag(zwork(ia,ind,is1))
                  End Do
                  write(lun,*)
               End Do
               ! =====
            End Do
            write(lun,*)
         End Do
         if ( jksnl /= (kv3_fbz/nspin) ) write(lun,*)
      End Do
      deallocate( zwork )
      deallocate( op_spinor )
      deallocate(norm2); deallocate(softpart)
    end subroutine write_file_noncl_fbz_sort

    subroutine set_index_converter_p2v( ind_max, index_p2v )
      integer, intent(in) :: ind_max
      integer, intent(out) :: index_p2v(ind_max)
!
      index_p2v(1) = 1
      index_p2v(2) = 3
      index_p2v(3) = 4
      index_p2v(4) = 2
      index_p2v(5) = 7
      index_p2v(6) = 8
      index_p2v(7) = 5
      index_p2v(8) = 9
      index_p2v(9) = 6
    end subroutine set_index_converter_p2v

    subroutine set_orb_name( ind_max, orb_name )
      integer, intent(in) :: ind_max
      character*3, intent(out) :: orb_name(ind_max)

      if ( noncol .and. procar_sph_zaxis_to_magdir == ON ) then
         orb_name(1) = "  s";     orb_name(2) = " pX";       orb_name(3) = " pY"
         orb_name(4) = " pZ";     orb_name(5) = "dZ2";       orb_name(6) = "dX2"
         orb_name(7) = "dXY";     orb_name(8) = "dYZ";       orb_name(9) = "dZX"
      else
         orb_name(1) = "  s";     orb_name(2) = " px";       orb_name(3) = " py"
         orb_name(4) = " pz";     orb_name(5) = "dz2";       orb_name(6) = "dx2"
         orb_name(7) = "dxy";     orb_name(8) = "dyz";       orb_name(9) = "dzx"
      endif
    end subroutine set_orb_name

  end subroutine m_OP_wd_PROCAR

end module m_OP_decomp_band

       subroutine mat_set( n, a, nm, mtype )
       use MPI
       use eigen_libs
       implicit NONE

       integer, intent(in)   :: n, nm, mtype
       real(8)               :: a(1:nm,*)

! Parameters BLACS array descritor(the position of entry tags), etc
       INTEGER, PARAMETER           :: BLOCK_CYCLIC_2D = 1
       INTEGER, PARAMETER           :: DLEN_  = 9
       INTEGER, PARAMETER           :: DTYPE_ = 1
       INTEGER, PARAMETER           :: CTXT_  = 2
       INTEGER, PARAMETER           :: M_     = 3
       INTEGER, PARAMETER           :: N_     = 4
       INTEGER, PARAMETER           :: MB_    = 5
       INTEGER, PARAMETER           :: NB_    = 6
       INTEGER, PARAMETER           :: RSRC_  = 7
       INTEGER, PARAMETER           :: CSRC_  = 8
       INTEGER, PARAMETER           :: LLD_   = 9

       integer                      :: DESCA( DLEN_ )
       integer                      :: NPROW, NPCOL

       real(8), pointer             :: as(:,:)
       real(8)                      :: t

       integer                      :: nnod, x_nnod, y_nnod
       integer                      :: inod, x_inod, y_inod
       integer                      :: i, i_1, i_2, i_3
       integer                      :: j, j_1, j_2, j_3
       integer                      :: nx, info, ICTXT
       integer, pointer             :: iseed(:)


          call eigen_get_procs( nnod, x_nnod, y_nnod )
          call eigen_get_id   ( inod, x_inod, y_inod )

          j_2 = eigen_loop_start( 1, x_nnod, x_inod )
          j_3 = eigen_loop_end  ( n, x_nnod, x_inod )
          i_2 = eigen_loop_start( 1, y_nnod, y_inod )
          i_3 = eigen_loop_end  ( n, y_nnod, y_inod )

          if ( mtype == 0 ) then
             do i_1 = i_2, i_3
                i = eigen_translate_l2g( i_1, y_nnod, y_inod )
                do j_1 = j_2, j_3
                   j = eigen_translate_l2g( j_1, x_nnod, x_inod )
                   a(j_1, i_1) = (n+1-Max(n+1-i,n+1-j))*1.0D+00
                end do
             end do
          end if
          if ( mtype == 1 ) then
             do i_1 = i_2, i_3
                i = eigen_translate_l2g( i_1, y_nnod, y_inod )
                do j_1 = j_2, j_3
                   j = eigen_translate_l2g( j_1, x_nnod, x_inod )
                   if ( i == j ) then
                      a(j_1, i_1) = -7.2D0
                   else
                      a(j_1, i_1) = -3.0D0/(i-j)**2
                   end if
                end do
             end do
          end if
          if ( mtype == 2 ) then

             NPROW = x_nnod
             NPCOL = y_nnod

             ICTXT = eigen_get_blacs_context( )

             CALL DESCINIT( DESCA, n, n, 1, 1, 0, 0, ICTXT, nm, INFO )

             nx = (n-1)/NPCOL+1
             allocate( as(1:nm,nx) )

             CALL RANDOM_SEED( size = i )
             allocate( iseed(i) )
             iseed(1) = inod
             CALL RANDOM_SEED( put = iseed )
             deallocate( iseed )

             do i_1 = i_2, i_3
                do j_1 = j_2, j_3
                   CALL RANDOM_NUMBER( t )
                   as(j_1, i_1) = t
                   a (j_1, i_1) = t
                end do
             end do

             CALL PDTRAN( n, n,
     &                    1D0, as, 1, 1, DESCA, 1D0, a, 1, 1, DESCA )

             deallocate( as )

          end if


       return
       end

!!
!! Last updated: 01 Feb 2011 on asahi.nims.go.jp
!! real-time electron-ion dynamics simulation
!! time-dependent density functional theory
!!
!! 12 Sep 2012, some unstable routines removed, isir, osaka univ.
!!

module m_rttddft

use m_Const_Parameters,only : &
  &  DP,PAI,PAI2,PAI4,CMPLDP,zi,ELECTRON,DIRECT,ON,OFF,BUCS,CARTS,MAPPED &
  & ,SmallestPositiveNumber
use m_Parallelization,only : &
  &  mpi_comm_group,ista_kngp,iend_kngp,npes,mype,ierr &
  & ,myrank_e,map_e,ista_e,iend_e,istep_e,myrank_k,map_k,ista_k,iend_k,np_e,map_z
use m_Control_Parameters,only : &
  &  neg,kimg,nspin,af &
  & ,sw_rttddft &
  & ,ext_ie_elec,ext_ie_hole &
  & ,ext_pulse_epsilon,ext_pulse_kx,ext_pulse_ky,ext_pulse_kz &
  & ,time_step_max,time_step_delta &
  & ,propagator_method,propagator_order
use m_Crystal_Structure,only : &
  &  altv,rltv,univol
use m_Ionic_System,only : &
  &  ntyp, iatom, ityp, iwei, natm, natm2, ityp, pos, cps
use m_FFT,only : &
  &  m_FFT_WF,m_FFT_Vlocal_W,fft_box_size_WF,nfft
use m_PseudoPotential,only : &
  &  ival,ilmt,nlmt,nlmtt,nlmta,lmta,lmtt,ltp,mtp,taup,q,dion &
  & ,nloc,ntau,ntyp,mmesh,nmesh,betar,wos,lpsmax
use m_PlaneWaveBasisSet,only : &
  &  ngabc,kg1,m_pwBS_kinetic_energies,nbase,iba,igf
use m_Kpoints,only : &
  &  kv3,vkxyz,qwgt
use m_Charge_Density,only : &
  &  m_CD_softpart,m_CD_hardpart,m_CD_rspace_charge &
  & ,m_CD_alloc_rspace_charge,m_CD_dealloc_rspace_charge &
  & ,chgq_l,hsr
!!---- phase_v800
!use m_Electronic_Structure,only : &
!  &  zaj_l,vlhxcQ,occup_l,eko_l,fsr_l,fsi_l,vlhxc_l &
!  & ,m_ES_Vlocal_in_Rspace,m_ES_WF_in_Rspace &
!  & ,m_ES_alloc_fft_related,m_ES_dealloc_fft_related,afft,bfft &
!  & ,m_ES_alloc_scss_etc,m_ES_dealloc_scss_etc,sc,ss,qc,qs &
!  & ,m_ES_Vnonlocal_W,vnlph_l,m_ES_betar_dot_WFs &
!  & ,m_ES_betar_dot_WFs_4_each_k,m_ES_betar_dot_WFs_4_lmta_k
!!---- phaseUnif
use m_Electronic_Structure,only : &
  &  zaj_l,vlhxcQ,occup_l,eko_l,fsr_l,fsi_l,vlhxc_l &
  & ,m_ES_Vlocal_in_Rspace,m_ES_WF_in_Rspace &
  & ,m_ES_alloc_fft_related,m_ES_dealloc_fft_related,afft,bfft &
  & ,vnlph_l
use m_ES_nonlocal,only : &
  &  sc,ss,qc,qs &
  & ,m_ES_Vnonlocal_W &
  & ,m_ES_alloc_scss_etc &
  & ,m_ES_dealloc_scss_etc &
  & ,m_ES_betar_dot_WFs &
  & ,m_ES_betar_dot_WFs_4_each_k &
  & ,m_ES_betar_dot_WFs_4_lmta_k
!!----
use m_NonLocal_Potential,only : &
  &  snl
use m_Files,only : &
  &  nfout,nfchr,m_Files_open_nfchr

implicit none
include 'mpif.h'

contains

!!
!!---- external impulse electric field at time=0+
!!     vector potential: A_ext(t) = [A0*r_i]*theta(t)
!!     electric field: E_ext(t) = -(dA(t)/dt)/c = -[A0*r_i]*delta(t)/c
!!     phi(r,t=0+) = exp(i*k_ext*r_i)*phi(r,t=0-)
!!
subroutine m_rttddft_init_impulse_field

  integer :: is,ik,ib,i1,ri,i,j,k,id,mm,nl,nm,nn,n1,n2,n3,nlhf,inew,jnew,knew,ip
  real(kind=DP) :: rx,ry,rz,dn1,dn2,dn3,denom
  complex(kind=CMPLDP) :: ctmp

  if(ext_pulse_epsilon==0.0.and. &
  &  ext_pulse_kx==0.0.and.ext_pulse_ky==0.0.and.ext_pulse_kz==0.0) return

  write(nfout,'(''# impulse electric field at time=0+'')')
  write(nfout,'(''# eps='',f6.3,'' kx='',f6.3,'' ky='',f6.3,'' kz='',f6.3)') &
  &  ext_pulse_epsilon,ext_pulse_kx,ext_pulse_ky,ext_pulse_kz

  call m_ES_alloc_fft_related()
  denom=1.0d0/product(fft_box_size_WF(1:3,1))
  id=fft_box_size_WF(1,0); mm=fft_box_size_WF(2,0)
  nl=fft_box_size_WF(1,1); nm=fft_box_size_WF(2,1); nn=fft_box_size_WF(3,1)
  if(kimg==1) then
    nlhf=id/2
  else
    nlhf=id
  endif

  do ik=1,kv3
  if(map_k(ik) /= myrank_k) cycle
  do ib=ista_e,iend_e,istep_e
    call m_ES_WF_in_Rspace(ik,ib,bfft)
    do k=1,nn
    do j=1,nm
    do i=1,nl
      if(kimg==1.and.i>nlhf) then
        inew=id-i
        jnew=nm+2-j
        knew=nn+2-k
        if(knew>nn) knew=knew-nn
        if(jnew>nm) jnew=jnew-nm
      else
        knew=k; jnew=j; inew=i
      endif
      ip=nlhf*mm*(knew-1)+nlhf*(jnew-1)+inew
      dn1=dble(i-1)/dble(nl)
      dn2=dble(j-1)/dble(nm)
      dn3=dble(k-1)/dble(nn)
      rx=altv(1,1)*dn1+altv(1,2)*dn2+altv(1,3)*dn3
      ry=altv(2,1)*dn1+altv(2,2)*dn2+altv(2,3)*dn3
      rz=altv(3,1)*dn1+altv(3,2)*dn2+altv(3,3)*dn3
      ctmp=cdexp(zi*ext_pulse_epsilon* &
        & (ext_pulse_kx*rx+ext_pulse_ky*ry+ext_pulse_kz*rz)) &
        & *dcmplx(bfft(ip*2-1),bfft(ip*2))
      bfft(ip*2-1)=dreal(ctmp)
      bfft(ip*2) =dimag(ctmp)
    enddo
    enddo
    enddo
    call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
    do ri=1,kimg
    do i=1,iba(ik)
      i1=kimg*igf(nbase(i,ik))+(ri-kimg)
      zaj_l(i,map_z(ib),ik,ri)=bfft(i1)*denom
    enddo
    enddo
  enddo
  enddo
  call m_ES_dealloc_fft_related() 
  call m_ES_betar_dot_WFs(nfout)

end subroutine m_rttddft_init_impulse_field


!!
!!---- electron excitation: manual occupation control at time=0+
!!     occupation(filled-band,k) <--> occupation(empty-band,k)
!!
subroutine m_rttddft_init_occup_control

  integer :: ik,ie
  real(kind=DP) :: occup_tmp1,occup_tmp2
  real(kind=DP),allocatable,dimension(:,:) :: eko_mpi,occup_mpi,tmp_mpi

  if(ext_ie_elec==0.or.ext_ie_hole==0) return

  allocate(eko_mpi(neg,kv3)) ; eko_mpi=0.0d0
  allocate(occup_mpi(neg,kv3)) ; occup_mpi=0.0d0

  if(npes >= 2) then
    allocate(tmp_mpi(neg,kv3))
!-- occup_mpi
    tmp_mpi=0.0d0
    do ik=1,kv3
      if(map_k(ik) /= myrank_k) cycle
      do ie=1,neg
        if(map_e(ie) /= myrank_e) cycle
        tmp_mpi(ie,ik)=occup_l(map_z(ie),ik)
      enddo
    enddo
    call mpi_allreduce(tmp_mpi,occup_mpi,neg*kv3 &
      & ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
!-- eko_mpi
    tmp_mpi=0.0d0
    do ik=1,kv3
      if(map_k(ik) /= myrank_k) cycle
      do ie=1,neg
        if(map_e(ie) /= myrank_e) cycle
        tmp_mpi(ie,ik)=eko_l(map_z(ie),ik)
      enddo
    enddo
    call mpi_allreduce(tmp_mpi,eko_mpi,neg*kv3 &
      & ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    deallocate(tmp_mpi)
  else
    occup_mpi=occup_l
    eko_mpi=eko_l
  endif

  if(mype==0) then
    write(nfout,'(''# time=0-'')')
    do ik=1,kv3
      write(nfout,'(''# occ ik='',i4)') ik
      write(nfout,'(10f8.4)') (occup_mpi(ie,ik),ie=1,neg)
      write(nfout,'(''# eko ik='',i4)') ik
      write(nfout,'(10f8.4)') (eko_mpi(ie,ik),ie=1,neg)
    enddo
  endif

!-- exchange occupation
  do ik=1,kv3
    occup_tmp1=occup_mpi(ext_ie_elec,ik)
    occup_tmp2=occup_mpi(ext_ie_hole,ik)
    occup_mpi(ext_ie_elec,ik)=occup_tmp2
    occup_mpi(ext_ie_hole,ik)=occup_tmp1
  enddo

  do ik=ista_k,iend_k
    do ie=1,neg
      if(map_e(ie) /= myrank_e) cycle
      occup_l(map_z(ie),ik)=occup_mpi(ie,ik)
    enddo
  enddo

  if(mype==0) then
    write(nfout,'(''# time=0+'')')
    do ik=1,kv3
      write(nfout,'(''# occ ik='',i4)') ik
      write(nfout,'(10f8.4)') (occup_mpi(ie,ik),ie=1,neg)
      write(nfout,'(''# eko ik='',i4)') ik
      write(nfout,'(10f8.4)') (eko_mpi(ie,ik),ie=1,neg)
    enddo
  endif

  deallocate(occup_mpi,eko_mpi)

end subroutine m_rttddft_init_occup_control


!!
!!---- propagator: Taylor expansion method
!!
subroutine m_rttddft_propagate_wf_by_taylor

  integer :: is,ik,ib,ie
  integer :: i,i1,iksnl,n_taylor,n_taylor_max
  real(kind=DP) :: fac,denom
  real(kind=DP),allocatable,dimension(:) :: ekin_tmp
  complex(kind=CMPLDP) :: cfac,ctmp
  complex(kind=CMPLDP),allocatable,dimension(:,:,:) :: czaj_l
  complex(kind=CMPLDP),allocatable,dimension(:) :: czaj_tmp

  allocate(czaj_l(kg1,np_e,ista_k:iend_k)); czaj_l=(0.0d0,0.0d0)
  allocate(czaj_tmp(kg1)); czaj_tmp=(0.0d0,0.0d0)
  allocate(ekin_tmp(kg1)); ekin_tmp=0.0d0

  call m_ES_alloc_fft_related() 

  if(propagator_order<0) then
    stop '** ERROR(RTTDDFT): propagator_order should be more than zero'
  endif
  n_taylor_max=propagator_order  !! input parameters (positive integer or zero)
  cfac=-zi*time_step_delta
  fac=1.0
  denom=1.0d0/product(fft_box_size_WF(1:3,1))

!!-- n=0 term
  do ik=1,kv3
    if(map_k(ik)/=myrank_k) cycle
    do ib=1,np_e
      do i=1,iba(ik)
        czaj_l(i,ib,ik)=dcmplx(zaj_l(i,ib,ik,1),(kimg-1)*zaj_l(i,ib,ik,kimg))
      enddo
    enddo
  enddo

!!-- n>1 terms
  do n_taylor=1,n_taylor_max  !! serial processing
    fac=fac/dble(n_taylor)  !! inverse of n factorial = 1/(n!)
    do is=1,nspin,af+1
      call m_ES_Vlocal_in_Rspace(is,afft)
      do ik=is,kv3-nspin+is,nspin
        if(map_k(ik)/=myrank_k) cycle
        call m_pwBS_kinetic_energies(ik,vkxyz,ekin_tmp)
        iksnl=(ik-1)/nspin+1
        call m_ES_Vnonlocal_W(ik,iksnl,is,OFF)
        do ie=ista_e,iend_e,istep_e
          ib=map_z(ie)
          czaj_tmp=(0.0d0,0.0d0)
!! T|wf>
          do i=1,iba(ik)
            czaj_tmp(i)=czaj_tmp(i) &
              +ekin_tmp(i)*dcmplx(zaj_l(i,ib,ik,1),(kimg-1)*zaj_l(i,ib,ik,kimg))
          enddo
!! V_lhxc|wf>
          call m_ES_WF_in_Rspace(ik,ie,bfft)
          call m_FFT_Vlocal_W(afft,bfft)
          call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
          do i=1,iba(ik)
            i1=igf(nbase(i,ik))
            czaj_tmp(i)=czaj_tmp(i)+dcmplx(bfft(2*i1-1),bfft(2*i1))*denom
          enddo
!! V_nonlocal|wf>
          do i=1,iba(ik)
            czaj_tmp(i)=czaj_tmp(i) &
              +dcmplx(vnlph_l(i,ib,1),(kimg-1)*vnlph_l(i,ib,kimg))
          enddo
! czaj_l=sum_n{(1/n!)(-idtH)^n|wf>} and zaj_l=(-idtH)^n|wf>
          do i=1,iba(ik)
            czaj_l(i,ib,ik)=czaj_l(i,ib,ik)+fac*cfac*czaj_tmp(i)
            zaj_l(i,ib,ik,1)=dreal(cfac*czaj_tmp(i))
            if(kimg==2) zaj_l(i,ib,ik,kimg)=dimag(cfac*czaj_tmp(i))
          enddo
        enddo
      enddo
    enddo
    call m_ES_betar_dot_WFs(nfout)
  enddo

!-- zaj_l(t+dt)=exp(-idtH)*zaj_l(t)
  do is=1,nspin,af+1
    do ik=is,kv3-nspin+is,nspin
      if(map_k(ik) /= myrank_k) cycle
      do ib=1,np_e
        do i=1,iba(ik)
          zaj_l(i,ib,ik,1)=dreal(czaj_l(i,ib,ik))
          if(kimg==2) zaj_l(i,ib,ik,kimg)=dimag(czaj_l(i,ib,ik))
        enddo
      enddo
    enddo
  enddo
  call m_ES_betar_dot_WFs(nfout)

  call m_ES_dealloc_fft_related() 
  deallocate(ekin_tmp)
  deallocate(czaj_tmp)
  deallocate(czaj_l)
end subroutine m_rttddft_propagate_wf_by_taylor

subroutine m_rttddft_T_wf(ik,ib,czaj_tmp)
  integer,intent(in) :: ik,ib
  integer :: i
  complex(kind=CMPLDP) :: ctmp
  real(kind=DP),allocatable,dimension(:) :: ekin_tmp
  complex(kind=CMPLDP),intent(inout),dimension(kg1) :: czaj_tmp
  allocate(ekin_tmp(kg1))
  call m_pwBS_kinetic_energies(ik,vkxyz,ekin_tmp)
  do i=1,iba(ik)
    czaj_tmp(i)=czaj_tmp(i)+ekin_tmp(i)*dcmplx(zaj_l(i,ib,ik,1),zaj_l(i,ib,ik,2))
  enddo
  deallocate(ekin_tmp)
end subroutine m_rttddft_T_wf

subroutine m_rttddft_Vlhxc_wf(is,ik,ib,czaj_tmp)
  integer,intent(in) :: is,ik,ib
  real(kind=DP) :: denom
  complex(kind=CMPLDP) :: ctmp
  complex(kind=CMPLDP),intent(inout),dimension(kg1) :: czaj_tmp
  integer :: i,i1
  denom=1.0d0/product(fft_box_size_WF(1:3,1))
  call m_ES_alloc_fft_related() 
  call m_ES_Vlocal_in_Rspace(is,afft)
  call m_ES_WF_in_Rspace(ik,ib,bfft)
  call m_FFT_Vlocal_W(afft,bfft)
  call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
  do i=1,iba(ik)
    i1=igf(nbase(i,ik))
    czaj_tmp(i)=czaj_tmp(i)+dcmplx(bfft(2*i1-1),bfft(2*i1))*denom
  enddo
  call m_ES_dealloc_fft_related() 
end subroutine m_rttddft_Vlhxc_wf

subroutine m_rttddft_Vnl_wf(is,ik,ib,czaj_tmp)
  integer,intent(in) :: is,ik,ib
  integer :: iksnl,i
  complex(kind=CMPLDP) :: ctmp
  complex(kind=CMPLDP),intent(inout),dimension(kg1) :: czaj_tmp
  iksnl=(ik-1)/nspin+1
  call m_ES_Vnonlocal_W(ik,iksnl,is,OFF)
  do i=1,iba(ik)
    czaj_tmp(i)=czaj_tmp(i)+dcmplx(vnlph_l(i,ib,1),vnlph_l(i,ib,2))
  enddo
end subroutine m_rttddft_Vnl_wf


!!
!!---- propagator: split operator method
!!
subroutine m_rttddft_propagate_wf_by_split(i_time)
  integer,intent(in) :: i_time
  integer :: i,n_split,n_split_max,split_order
  integer,save :: sw_tmp
  real(kind=DP) :: fac
  real(kind=DP),allocatable,dimension(:) :: pcof
  complex(kind=CMPLDP) :: cfac

  if(propagator_order/=2.and.propagator_order/=4) then
    stop '** ERROR(RT-TDDFT): invalid input propagator_order'
  endif
  split_order=propagator_order  !! input parameter (2 or 4)

  if(split_order==2) then
    n_split_max=1
    allocate(pcof(n_split_max)); pcof=0.0d0
    pcof(1)=1.0d0
  elseif(split_order==4) then
    n_split_max=5
    allocate(pcof(n_split_max)); pcof=0.0d0
    pcof(1)=1.0d0/(4.0d0-4.0d0**(1.0d0/3.0d0))
    pcof(2)=pcof(1)
    pcof(3)=1.0d0-4.0d0*pcof(1)
    pcof(4)=pcof(2)
    pcof(5)=pcof(1)
  endif

  do n_split=1,n_split_max  !! serial processing
    cfac=-0.5d0*zi*time_step_delta*pcof(n_split)
    call m_rttddft_expT_wf(cfac)
    if(i_time==1.and.n_split==1) then
      sw_tmp=1
    else
      sw_tmp=2
    endif
    call m_rttddft_expVnl_wf(cfac,sw_tmp,2)
    sw_tmp=2
    call m_rttddft_expVlhxc_wf(2.0d0*cfac)
    if(i_time==time_step_max.and.n_split==n_split_max) sw_tmp=3
    call m_rttddft_expVnl_wf(cfac,sw_tmp,1)
    call m_rttddft_expT_wf(cfac)
  enddo
  call m_ES_betar_dot_WFs(nfout)

  deallocate(pcof)
end subroutine m_rttddft_propagate_wf_by_split

subroutine m_rttddft_expT_wf(cfac)
  integer :: is,ik,ib,i
  real(kind=DP),allocatable,dimension(:) :: ekin_tmp
  complex(kind=CMPLDP),intent(in) :: cfac
  complex(kind=CMPLDP) :: ctmp
  allocate(ekin_tmp(kg1)); ekin_tmp=0.0d0

  do is=1,nspin,af+1
    do ik=is,kv3-nspin+is,nspin
      if(map_k(ik) /= myrank_k) cycle
      call m_pwBS_kinetic_energies(ik,vkxyz,ekin_tmp)
      do ib=1,np_e
        do i=1,iba(ik)
          ctmp=cdexp(cfac*ekin_tmp(i)) &
            *dcmplx(zaj_l(i,ib,ik,1),(kimg-1)*zaj_l(i,ib,ik,kimg))
          zaj_l(i,ib,ik,1)=dreal(ctmp)
          if(kimg==2) zaj_l(i,ib,ik,kimg)=dimag(ctmp)
        enddo
      enddo
    enddo
  enddo
  deallocate(ekin_tmp)

  call m_ES_betar_dot_WFs(nfout)

end subroutine m_rttddft_expT_wf

subroutine m_rttddft_expVlhxc_wf(cfac)
  integer :: is,ik,ib,i,i1,ri
  real(kind=DP) :: denom
  complex(kind=CMPLDP),intent(in) :: cfac
  complex(kind=CMPLDP) :: ctmp
  denom=1.0d0/product(fft_box_size_WF(1:3,1))
  call m_ES_alloc_fft_related()

  do is=1,nspin,af+1
    call m_ES_Vlocal_in_Rspace(is,afft)
    do ik=is,kv3-nspin+is,nspin
      if(map_k(ik)/=myrank_k) cycle
      do ib=ista_e,iend_e,istep_e
        call m_ES_WF_in_Rspace(ik,ib,bfft)

        do i=1,nfft-1,2
       !! ctmp=cdexp(cfac*dcmplx(afft(i),afft(i+1)))*dcmplx(bfft(i),bfft(i+1))
          ctmp=cdexp(cfac*afft(i))*dcmplx(bfft(i),bfft(i+1))
          bfft(i)=dreal(ctmp)
          bfft(i+1)=dimag(ctmp)
        enddo
        if(mod(nfft,2)==1) bfft(nfft)=dreal(cdexp(cfac*afft(nfft))*bfft(nfft))

        call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
        do i=1,iba(ik)
          i1=igf(nbase(i,ik))
          zaj_l(i,map_z(ib),ik,1)=bfft(2*i1-1)*denom
          if(kimg==2) zaj_l(i,map_z(ib),ik,kimg)=bfft(2*i1)*denom
        enddo

      enddo
    enddo
  enddo

  call m_ES_dealloc_fft_related() 

  call m_ES_betar_dot_WFs(nfout)

end subroutine m_rttddft_expVlhxc_wf

subroutine m_rttddft_expVnl_wf(cfac,sw_tmp,as_or_des)
  integer,intent(in) :: as_or_des,sw_tmp
  integer :: it_ss,it_ee,it_ii,ia_ss,ia_ee,ia_ii,lmt_ss,lmt_ee,lmt_ii
  integer :: is,ik,ib,it,ia,i,j,nb,nr,iksnl
  integer :: lmt1,lmtt1,lmta1,il1,im1
  integer :: lmt2,lmtt2,lmta2,il2,im2
  complex(kind=CMPLDP),intent(in) :: cfac
  complex(kind=CMPLDP) :: ctmp,ccof,ccof_tmp,ccoffs
  real(kind=DP) :: ph,f1,f2,f3,brbr_tmp
  real(kind=DP),allocatable,dimension(:,:,:,:),save :: brbr
  real(kind=DP),allocatable,dimension(:,:,:),save :: zfsin_tmp,zfcos_tmp

  if(sw_tmp==1) then
    allocate(brbr(nlmtt,nlmtt,ntyp,kv3)); brbr=0.0d0
    allocate(zfsin_tmp(kg1,kv3,natm),zfcos_tmp(kg1,kv3,natm))
    zfsin_tmp=0.0d0; zfcos_tmp=0.0d0

!-- brbr=<betar_lmt2|betar_lmt1>
    if(mype==0) write(nfout,'(''# brbr=<beta_lmt2|beta_lmt1> G-space integration'')')
    do it=1,ntyp
      do lmt2=1,ilmt(it)
        il2=ltp(lmt2,it); lmtt2=lmtt(lmt2,it)
        do lmt1=1,ilmt(it)
          il1=ltp(lmt1,it); lmtt1=lmtt(lmt1,it)
          ccof=((-zi)**(-il2+1))*(zi**(-il1+1))
          do is=1,nspin,af+1
            do ik=is,kv3-nspin+is,nspin
            ! if(map_k(ik)/=myrank_k) cycle  ! comment for debug write
              iksnl=(ik-1)/nspin+1
              ctmp=(0.0d0,0.0d0)
              do i=1,iba(ik)
                ctmp=ctmp+ccof*snl(i,lmtt2,iksnl)*snl(i,lmtt1,iksnl)
              enddo
              brbr(lmtt2,lmtt1,it,iksnl)=dreal(ctmp)
              if(cdabs(ctmp) > 1.d-7.and.mype==0) &
                write(nfout,'(3i5,2f15.7)') it,lmtt1,lmtt2,dreal(ctmp),dimag(ctmp)
            enddo
          enddo
        enddo
      enddo
    enddo

!-- phase
    do ia=1,natm
      f1=pos(ia,1)*PAI2; f2=pos(ia,2)*PAI2; f3=pos(ia,3)*PAI2
      do is=1,nspin,af+1
        do ik=is,kv3-nspin+is,nspin
          if(map_k(ik)/=myrank_k) cycle
          do i=1,iba(ik)
            if(.not.allocated(nbase)) then
              stop '** ERROR(RT-TDDFT): nbase is not allocated at split-nonlocal'
            endif
            nb=nbase(i,ik)
            ph=ngabc(nb,1)*f1+ngabc(nb,2)*f2+ngabc(nb,3)*f3
            zfsin_tmp(i,ik,ia)=dsin(ph); zfcos_tmp(i,ik,ia)=dcos(ph)
          enddo
        enddo
      enddo
    enddo
  endif

  if(as_or_des==1) then
    it_ss=1; it_ee=ntyp; it_ii=+1
    ia_ss=1; ia_ee=natm; ia_ii=+1  !! ascending
  elseif(as_or_des==2) then
    it_ss=ntyp; it_ee=1; it_ii=-1
    ia_ss=natm; ia_ee=1; ia_ii=-1  !! descending
  endif

  do it=it_ss,it_ee,it_ii
    if(as_or_des==1) then
      lmt_ss=1; lmt_ee=ilmt(it); lmt_ii=+1  !! ascending
    elseif(as_or_des==2) then
      lmt_ss=ilmt(it); lmt_ee=1; lmt_ii=-1  !! descending
    endif
    do ia=ia_ss,ia_ee,ia_ii
      if(ityp(ia)/=it) cycle

      do lmt2=lmt_ss,lmt_ee,lmt_ii
        lmta2=lmta(lmt2,it); lmtt2=lmtt(lmt2,it)
        il2=ltp(lmt2,it); im2=mtp(lmt2,it)
        do lmt1=lmt_ss,lmt_ee,lmt_ii
          lmta1=lmta(lmt1,it); lmtt1=lmtt(lmt1,it)
          il1=ltp(lmt1,it); im1=mtp(lmt1,it)

          do is=1,nspin,af+1
            if(il1==il2.and.im1==im2) then
              ccof_tmp=cfac*iwei(ia)*(dion(lmt1,lmt2,it)+vlhxcQ(lmt1,lmt2,ia,is))
            else
              ccof_tmp=cfac*iwei(ia)*vlhxcQ(lmt1,lmt2,ia,is)
            endif
            do ik=is,kv3-nspin+is,nspin
              if(map_k(ik)/=myrank_k) cycle
              iksnl=(ik-1)/nspin+1
              brbr_tmp=brbr(lmtt2,lmtt1,it,iksnl)
              if(dabs(brbr_tmp) < 1.d-8) cycle
              ccof=(cdexp(ccof_tmp*brbr_tmp)-1.0d0)/brbr_tmp
              do ib=1,np_e
                ccoffs=ccof*dcmplx(fsr_l(ib,lmta2,ik),fsi_l(ib,lmta2,ik))
                do i=1,iba(ik)
                  ctmp=dcmplx(zaj_l(i,ib,ik,1),(kimg-1)*zaj_l(i,ib,ik,kimg)) &
                    +ccoffs*dcmplx(zfcos_tmp(i,ik,ia),-zfsin_tmp(i,ik,ia)) &
                    *snl(i,lmtt1,iksnl)*(zi**(-il1+1))
                  zaj_l(i,ib,ik,1)=dreal(ctmp)
                  if(kimg==2) zaj_l(i,ib,ik,kimg)=dimag(ctmp)
                enddo
              enddo
            enddo
          enddo
          call m_ES_betar_dot_WFs(nfout)

        enddo
      enddo
    enddo
  enddo

  if(sw_tmp==3) then
    deallocate(brbr)
    deallocate(zfsin_tmp,zfcos_tmp)
  endif
end subroutine m_rttddft_expVnl_wf


!!
!!---- for debug: check normality of wavefunctions & number of electrons
!!
subroutine m_rttddft_check_wf
  integer :: is,ik,ib,i,it,ia,lmt1,lmt2,lmta1,lmta2
  real(kind=DP) :: n_ele,n_ele_mpi
  complex(kind=CMPLDP) :: ctmp
  complex(kind=CMPLDP),allocatable,dimension(:,:) :: ctmp_soft,ctmp_hard
  complex(kind=CMPLDP),allocatable,dimension(:,:) :: ctmp_soft_mpi,ctmp_hard_mpi,ctmp_mpi

  if(mype==0) write(nfout,'(''# normality of Kohn-Sham wavefunction'')')

  allocate(ctmp_soft(np_e,ista_k:iend_k)) ; ctmp_soft=(0.0d0,0.0d0)
  allocate(ctmp_hard(np_e,ista_k:iend_k)) ; ctmp_hard=(0.0d0,0.0d0)
  n_ele=0.0d0

  do ik=1,kv3
    if(map_k(ik)/=myrank_k) cycle
    do ib=1,np_e
! soft part
      do i=1,iba(ik)
        ctmp_soft(ib,ik)=ctmp_soft(ib,ik) &
          +dconjg(dcmplx(zaj_l(i,ib,ik,1),(kimg-1)*zaj_l(i,ib,ik,kimg))) &
          *dcmplx(zaj_l(i,ib,ik,1),(kimg-1)*zaj_l(i,ib,ik,kimg))
      enddo
! hard part
      do it=1,ntyp
        do ia=1,natm ; if(ityp(ia)/=it) cycle
          do lmt1=1,ilmt(it) ; lmta1=lmta(lmt1,it)
            do lmt2=1,ilmt(it) ; lmta2=lmta(lmt2,it)
              ctmp_hard(ib,ik)=ctmp_hard(ib,ik) &
              +q(lmt1,lmt2,it)*iwei(ia) &
              *dconjg(dcmplx(fsr_l(ib,lmta1,ik),fsi_l(ib,lmta1,ik))) &
              *dcmplx(fsr_l(ib,lmta2,ik),fsi_l(ib,lmta2,ik))
            enddo
          enddo
        enddo
      enddo
      n_ele=n_ele+dble(2/nspin)*qwgt(ik)*occup_l(ib,ik) &
        *dreal(ctmp_soft(ib,ik)+ctmp_hard(ib,ik))
    enddo
  enddo

  allocate(ctmp_soft_mpi(neg,kv3)) ; ctmp_soft_mpi=(0.0d0,0.0d0)
  allocate(ctmp_hard_mpi(neg,kv3)) ; ctmp_hard_mpi=(0.0d0,0.0d0)

  if(npes >= 2) then
    allocate(ctmp_mpi(neg,kv3))
! soft
    ctmp_mpi=(0.0d0,0.0d0)
    do ik=1,kv3
      if(map_k(ik)/=myrank_k) cycle
      do ib=1,neg
        if(map_e(ib)/=myrank_e) cycle
        ctmp_mpi(ib,ik)=ctmp_soft(map_z(ib),ik)
      enddo
    enddo
    call mpi_allreduce(ctmp_mpi,ctmp_soft_mpi,neg*kv3 &
      ,mpi_double_complex,mpi_sum,mpi_comm_group,ierr)
! hard
    ctmp_mpi=(0.0d0,0.0d0)
    do ik=1,kv3
      if(map_k(ik)/=myrank_k) cycle
      do ib=1,neg
        if(map_e(ib)/=myrank_e) cycle
        ctmp_mpi(ib,ik)=ctmp_hard(map_z(ib),ik)
      enddo
    enddo
    call mpi_allreduce(ctmp_mpi,ctmp_hard_mpi,neg*kv3 &
      ,mpi_double_complex,mpi_sum,mpi_comm_group,ierr)
    deallocate(ctmp_mpi)
! number of electron
    call mpi_allreduce(n_ele,n_ele_mpi,1,mpi_double_precision &
      ,mpi_sum,mpi_comm_group,ierr)
  else
    ctmp_soft_mpi=ctmp_soft
    ctmp_hard_mpi=ctmp_hard
    n_ele_mpi=n_ele
  endif

  deallocate(ctmp_soft,ctmp_hard)

  if(mype == 0) then
    do is=1,nspin,af+1
      do ik=is,kv3-nspin+is,nspin
        write(nfout,'(''# is='',i5,3x,''ik='',i5)') is,ik
        do ib=1,neg
! orthonormality of wavefunction: ctmp=<wf_ib|wf_ib>
          ctmp=ctmp_soft_mpi(ib,ik)+ctmp_hard_mpi(ib,ik)
          write(nfout,'(''# ib='',i5,'' tot='',2f10.5'' soft='',2f10.5,'' hard='',2f10.5)') &
            ib,ctmp,ctmp_soft_mpi(ib,ik),ctmp_hard_mpi(ib,ik)
        enddo
      enddo
    enddo
! number of electron
    write(nfout,'(''# number of electron  ='',f20.10)') n_ele_mpi
  endif

  deallocate(ctmp_soft_mpi,ctmp_hard_mpi)

end subroutine m_rttddft_check_wf


!!
!!---- dipole moment
!!     NOTE: Here is only valid for isolated systems,
!!     and a molecule should be located at the center of unit cell.
!!
subroutine m_rttddft_dipole
  integer :: i,ia,id,im,ip
  real(kind=DP) :: g(3),r0(3),len(3)
  real(kind=DP) :: d_ele(3),d_ion(3)
  real(kind=DP) :: d_ele_mpi(3)
  complex(kind=CMPLDP) :: ccha

  d_ele=0.0d0; d_ion=0.0d0
  r0(1)=0.0d0; r0(2)=0.0d0; r0(3)=0.0d0
  len(1)=sqrt(sum(altv(1:3,1)**2)); len(2)=sqrt(sum(altv(1:3,2)**2)); len(3)=sqrt(sum(altv(1:3,3)**2))

! electron
  do i=ista_kngp,iend_kngp
    ccha=dcmplx(chgq_l(i,1,1    ),(kimg-1)*chgq_l(i,kimg,1    )) &
      & +dcmplx(chgq_l(i,1,nspin),(kimg-1)*chgq_l(i,kimg,nspin))*(nspin-1)
    g(1)=rltv(1,1)*ngabc(i,1)+rltv(1,2)*ngabc(i,2)+rltv(1,3)*ngabc(i,3)
    g(2)=rltv(2,1)*ngabc(i,1)+rltv(2,2)*ngabc(i,2)+rltv(2,3)*ngabc(i,3)
    g(3)=rltv(3,1)*ngabc(i,1)+rltv(3,2)*ngabc(i,2)+rltv(3,3)*ngabc(i,3)
    do id=1,3
      if(id==1) then; ip=2; im=3; endif
      if(id==2) then; ip=3; im=1; endif
      if(id==3) then; ip=1; im=2; endif
      if(abs(g(ip))<1.d-10.and.abs(g(im))<1.d-10) then
        if(abs(g(id))<1.d-10) then
          d_ele(id)=d_ele(id)+len(ip)*len(im)*ccha*0.5*((r0(id)+len(id))**2.0-r0(id)**2.0)
        else
          d_ele(id)=d_ele(id)+len(ip)*len(im)*ccha &
        & *((zi*g(id)*(r0(id)+len(id))-1.0)*cdexp(zi*g(id)*(r0(id)+len(id))) &
        &  -(zi*g(id)*r0(id)-1.0)*cdexp(zi*g(id)*r0(id)))/(zi*g(id))**2.0
        endif
      endif
    enddo
  enddo
  if(npes > 1) then
    d_ele_mpi=0.0d0
    call mpi_allreduce(d_ele,d_ele_mpi,3,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    d_ele=d_ele_mpi
  endif
  d_ele=-d_ele

! ion
  do ia=1,natm
  do id=1,3
    d_ion(id)=d_ion(id)+ival(ityp(ia))*cps(ia,id)
    if(iwei(ia)/=1) &
  & d_ion(id)=d_ion(id)-ival(ityp(ia))*cps(ia,id)
  enddo
  enddo

  write(nfout,'(''P='',3f20.10)') (d_ele(id)+d_ion(id),id=1,3)
! for debug
! write(nfout,'(''# dipole moment (tot) ='',3f20.10)') (d_ele(id)+d_ion(id),id=1,3)
! write(nfout,'(''# dipole moment (ele) ='',3f20.10)') (d_ele(id),id=1,3)
! write(nfout,'(''# dipole moment (ion) ='',3f20.10)') (d_ion(id),id=1,3)

end subroutine m_rttddft_dipole


!!
!!---- current density, induced polarization, & induced vector potential
!!
subroutine m_rttddft_current
  integer :: is,ik,ib,i,nb,id
  real(kind=DP) :: g(3),fac,tmp
  complex(kind=CMPLDP) :: j_ele(3),ctmp
  complex(kind=CMPLDP) :: j_ele_mpi(3)

  real(kind=DP),save :: p_ind(3)=0.0d0
  real(kind=DP),save :: a_ind(3)=0.0d0

  j_ele=(0.0d0,0.0d0)
  do is=1,nspin,af+1
  do ik=is,kv3-nspin+is,nspin
  if(map_k(ik) /= myrank_k) cycle
  do ib=1,np_e
  fac=dble(2/nspin)*qwgt(ik)*occup_l(ib,ik)
  do i=1,iba(ik)
    nb=nbase(i,ik)
    g(1)=vkxyz(ik,1,CARTS)+rltv(1,1)*ngabc(nb,1)+rltv(1,2)*ngabc(nb,2)+rltv(1,3)*ngabc(nb,3)
    g(2)=vkxyz(ik,2,CARTS)+rltv(2,1)*ngabc(nb,1)+rltv(2,2)*ngabc(nb,2)+rltv(2,3)*ngabc(nb,3)
    g(3)=vkxyz(ik,3,CARTS)+rltv(3,1)*ngabc(nb,1)+rltv(3,2)*ngabc(nb,2)+rltv(3,3)*ngabc(nb,3)
    ctmp=fac*dconjg(dcmplx(zaj_l(i,ib,ik,1),(kimg-1)*zaj_l(i,ib,ik,kimg))) &
                 & *dcmplx(zaj_l(i,ib,ik,1),(kimg-1)*zaj_l(i,ib,ik,kimg))
    j_ele(1)=j_ele(1)+g(1)*ctmp
    j_ele(2)=j_ele(2)+g(2)*ctmp
    j_ele(3)=j_ele(3)+g(3)*ctmp
  enddo
  enddo
  enddo
  enddo
  if(npes > 1) then
    j_ele_mpi=0.0d0
    call mpi_allreduce(j_ele,j_ele_mpi,3,mpi_double_complex,mpi_sum,mpi_comm_group,ierr)
    j_ele=j_ele_mpi
  endif
  j_ele=-j_ele

  write(nfout,'(''J='',3f20.10)') (dreal(j_ele(id)),id=1,3)
! for debug
! write(nfout,'(''# total current (ele) ='',3f20.10)') (dreal(j_ele(id)),id=1,3)

  tmp=sqrt(dimag(j_ele(1))**2.+dimag(j_ele(2))**2.+dimag(j_ele(3))**2.)
  if(tmp>1.d5*SmallestPositiveNumber) &
  &  write(nfout,'(''# WARNING: Im[J(t)]='',3f20.10)') (dimag(j_ele(id)),id=1,3)


!!-- induced polarization: dP(t)/dt = j(t)/V
!  p_ind=p_ind+dreal(j_ele)*time_step_delta/univol
!  write(nfout,'(''# induced polarization (ele) ='',3f20.10)') (p_ind(id),id=1,3)
!
!!-- **** here is not reliable ****
!!-- induced vector potential: dA(t)/dt = P(t)
!  a_ind=a_ind+p_ind*time_step_delta
!  write(nfout,'(''# induced vector potential (ele) ='',3f20.10)') (a_ind(id),id=1,3)

end subroutine m_rttddft_current


!!
!!---- for debug write: eigen values & occupations
!!
subroutine m_rttddft_print_eko_occup

  integer :: ie,ik
  real(kind=DP),allocatable,dimension(:,:) :: eko_mpi,occup_mpi,tmp_mpi

  allocate(eko_mpi(neg,kv3)) ; eko_mpi=0.0d0
  allocate(occup_mpi(neg,kv3)) ; occup_mpi=0.0d0

  if(npes >= 2) then
    allocate(tmp_mpi(neg,kv3)) ; tmp_mpi=0.0d0
!-- occup mpi
    do ik=1,kv3
      if(map_k(ik) /= myrank_k) cycle
      do ie=1,neg
        if(map_e(ie) /= myrank_e) cycle
        tmp_mpi(ie,ik)=occup_l(map_z(ie),ik)
      enddo
    enddo
    call mpi_allreduce(tmp_mpi,occup_mpi,neg*kv3 &
      & ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
!-- eko mpi
    do ik=1,kv3
      if(map_k(ik) /= myrank_k) cycle
      do ie=1,neg
        if(map_e(ie) /= myrank_e) cycle
        tmp_mpi(ie,ik)=eko_l(map_z(ie),ik)
      enddo
    enddo
    call mpi_allreduce(tmp_mpi,eko_mpi,neg*kv3 &
      & ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    deallocate(tmp_mpi)
  else
    occup_mpi=occup_l
    eko_mpi=eko_l
  endif

  if(mype==0) then
    do ik=1,kv3
      write(nfout,'(''# occ ik='',i4)') ik
      write(nfout,'(10f8.4)') (occup_mpi(ie,ik),ie=1,neg)
      write(nfout,'(''# eko ik='',i4)') ik
      write(nfout,'(10f8.4)') (eko_mpi(ie,ik),ie=1,neg)
    enddo
  endif

  deallocate(occup_mpi,eko_mpi)

end subroutine m_rttddft_print_eko_occup


!!
!!---- charge density plot
!!
subroutine m_rttddft_wd_charge
  integer :: iloop
  call m_CD_alloc_rspace_charge()
  do iloop=1,nspin
    call m_Files_open_nfchr(nspin,iloop)
    call m_CD_rspace_charge(nspin,iloop,nfchr,nfout)
  enddo
  call m_CD_dealloc_rspace_charge()
end subroutine m_rttddft_wd_charge

end module m_rttddft

      subroutine eigen_hrd(
     &             n,ar,ai,lda,
     &             d_out,e_out,e2_out,
     &             tau,ldtau, m,zr,zi
     &           )
!----
      use communication_h, only : eigen_init
     &               , eigen_free
     &               , cyc1d_cyc2d
     &               , cyc2d_cyc1d
!----
      implicit none
!----
      include 'mpif.h'
!----
      integer  ::  n, lda, ldtau, m
      real(8)  ::  ar(*),ai(*)
      real(8)  ::  zr(*),zi(*)
      real(8)  ::  d_out(*),e_out(*),e2_out(*)
      real(8)  ::  tau(*)
!----
      include 'trd.h'
!----
      integer  ::  ierr
      integer  ::  n_, nm_

      real(8), pointer :: ar_(:), ai_(:)

      real(8)  :: d0, d1, d2, d3, d4

      integer  :: ldz, nz
!----
      call eigen_init(2)
!----
      d0=mpi_wtime()
      ldz = (n-1)/size_of_col+1
      nz = (n-1)/size_of_row+1
      d1=mpi_wtime()
      call cyc1d_cyc2d(n,ar,lda,zr,ldz, size_of_col, size_of_row, ierr)
      call cyc1d_cyc2d(n,ai,lda,zi,ldz, size_of_col, size_of_row, ierr)
      d2=mpi_wtime()
!----
      n_ = 0; nm_ = 1

      allocate(ar_(1),ai_(1))
      call eigen_hrd_main1(
     &       n,zr(1),zi(1),ldz,
     &       d_out(1),e_out(1),e2_out(1),tau(1),ldtau,m,
     &       ar_(1),ai_(1),n_,nm_
     &     )
      deallocate(ar_,ai_)

      d3=mpi_wtime()
      call cyc2d_cyc1d(n,ar,lda,zr,ldz, size_of_col, size_of_row, ierr)
      call cyc2d_cyc1d(n,ai,lda,zi,ldz, size_of_col, size_of_row, ierr)
      d4=mpi_wtime()
#ifdef DETAIL
      if(myrank==1) then
         print*,"  communication time in \"eigen_hrd\""
         print*,"   cyc1d_cyc2d :: ",d2-d1,"(sec)"
         print*,"   cyc2d_cyc1d :: ",d4-d3,"(sec)"
      endif
#endif
!----
      call eigen_free(1)
!----
#ifdef TIMER
      if(myrank==1)then
         print*,"Exectime of \"eigen_hrd\" routine =",d4-d0,"(sec)"
!----&            4*dble(n)**3*4/3/(s1-s0)*1d-6,"MFLOPS"
      endif
#endif

      return
      end subroutine
!----
      subroutine eigen_hrd_main1(
     &             n,ar,ai,lda,d_out,e_out,e2_out,tau,ldtau,m,
     &             ar_,ai_,n_,nm_
     &           )
!----
      implicit none
!----
      integer  ::  n,  lda, nv, ldtau, m
      real(8)  ::  ar(lda,*),ai(lda,*)
      real(8)  ::  d_out(n),e_out(n),e2_out(n)
      real(8)  ::  tau(ldtau,2)
      integer  ::  n_, nm_
      real(8)  ::  ar_(*), ai_(*)
!----
      include 'trd.h'
!----
      real(8), pointer ::  uv_x(:), uv_y(:)
      real(8), pointer ::  w(:)
      real(8), pointer ::  u_t(:), v_t(:)
      real(8), pointer ::  d_t(:)

      integer :: i,j,k
!----
      nv=lda
!----
      allocate(
     &         uv_x(4*nv*m),
     &         uv_y(4*nv*m),
     &         w(2*nv*m),
     &         u_t(1+8*2*max(nv+4,m*4)),
     &         v_t(1+8*2*max(nv+4,m*4)),
     &         d_t(nv)
     &        )
!----
      j = 0
!----
      call eigen_hrd_main2(
     &       n,ar,ai,lda,d_out,e_out,e2_out,
     &       tau,ldtau,nv,m,
     &       uv_x(1+0*nv*m), uv_x(1+1*nv*m),
     &       uv_x(1+2*nv*m), uv_x(1+3*nv*m),
     &       uv_y(1+0*nv*m), uv_y(1+1*nv*m),
     &       uv_y(1+2*nv*m), uv_y(1+3*nv*m),
     &       w(1), w(1+nv*m),
     &       u_t(1), u_t(1+8*max(nv+4,m*4)),
     &       v_t(1), v_t(1+8*max(nv+4,m*4)),
     &       d_t(1),
     &       ar_,ai_,n_,nm_
     &     )
!----
      deallocate(uv_x, uv_y, w, u_t, v_t, d_t )

      return
      end subroutine
!----
      subroutine eigen_hrd_main2(
     &             n,ar,ai,lda,d_out,e_out,e2_out,
     &             tau,ldtau,nv,m,
     &             ur_x, ui_x, vr_x, vi_x,
     &             ur_y, ui_y, vr_y, vi_y,
     &             wr, wi,
     &             ur_t, ui_t,
     &             vr_t, vi_t,
     &             d_t,
     &             ar_,ai_,n_,nm_
     &           )
!----
      use communication_h, only : reduce_dbl
     &               , bcast_dbl
     &               , get_loop_start
     &               , get_loop_end
     &               , get_owner_node
     &               , translate_l2g
     &               , translate_g2l
!----
      implicit integer         (i-n)
      implicit real(8)(a-h,o-z)
!----
      integer  ::  i,j,l,n,lda,ldtau,nv
      real(8)  ::  ar(lda,n),ai(lda,n)
      real(8)  ::  d_out(n),e_out(n),e2_out(n)
      real(8)  ::  tau(ldtau,2)
      real(8)  ::  g,h,scale
      real(8)  ::  sr,si,tr,ti
!----
      integer  ::  m_orig
      integer  ::  m,mm,m0
      integer  ::  i_block,i_base
!----
      integer  ::  y_root, y_pos
      integer  ::  x_root, x_pos
!----
      real(8)  ::  ur_x(nv,m),ui_x(nv,m)
      real(8)  ::  ur_y(nv,m),ui_y(nv,m)
      real(8)  ::  vr_x(nv,m),vi_x(nv,m)
      real(8)  ::  vr_y(nv,m),vi_y(nv,m)
      real(8)  ::  wr(nv,m),wi(nv,m)
      real(8)  ::  ur_t(1:8*max(nv+4,4*m))
      real(8)  ::  ui_t(1:8*max(nv+4,4*m))
      real(8)  ::  vr_t(1:8*max(nv+4,4*m))
      real(8)  ::  vi_t(1:8*max(nv+4,4*m))
      real(8)  ::  d_t(nv)
!----
      integer  ::  n_, nm_
      real(8)  ::  ar_(nm_,n_), ai_(nm_,n_)

      integer  :: local_rank, local_size
!----
      include 'mpif.h'
!$    include 'omp_lib.h'
      include 'trd.h'
!----
      real(8)  :: dd(10),d1,d2
!----
      dd=0d0
!----
!$omp parallel private(local_rank,local_size)
#ifdef DETAIL
!$omp master
      if ( myrank == 1 ) then
         local_rank = 0
         local_size = 1
!$       local_rank = omp_get_thread_num()
!$       local_size = omp_get_num_threads()
!$       if ( local_rank == 0 ) then
            print*,"num.of.process=",nprocs,
     &             "(",size_of_col,size_of_row,")"
!$          print*,"num.of.threads=",local_size
!$       endif
      endif
!$omp end master
#endif
      call eigen_hrd_Au(
     &       ar,ai,lda,
     &       ur_x,ui_x,ur_y,ui_y,vr_x,vi_x,
     &       ur_t,ui_t, vr_t,vi_t, d_t,
     &       -1, x_pos,y_pos, nv,k_1-k_2,
     &       ar_,ai_,n_,nm_
     &     )
      call eigen_hrd_2update(
     &       ar,ai,lda,
     &       ur_x,ui_x,ur_y,ui_y,
     &       vr_x,vi_x,vr_y,vi_y,   
     &       nv,m0,-1,
     &       ar_,ai_,n_,nm_
     &     )
!$omp end parallel

!----
      d_out(1:n)  = 0.0d0
      e_out(1:n)  = 0.0d0
      e2_out(1:n) = 0.0d0
      tau(1:n,1) = 1.0d0
      tau(1:n,2) = 0.0d0
!----
      if(diag_0>0)then
         i_2=diag_0
         i_3=((n)+size_of_row-my_row)/size_of_row
         i_4=size_of_col/n_common
         if(i_2<=n_)then
            do i_1=i_2,min(i_3,n_),i_4
               j=(i_1-1)*size_of_row+my_row
               j_1=(j-1)/size_of_col+1
               d_out(j)     = ar_(j_1,i_1)
               ai_(j_1,i_1) = 0.0d0
            enddo! i_1
            i_2=((n_-i_2)/i_4+1)*i_4+i_2
         endif
*poption indep(a,d_out)
         do i_1=i_2,i_3,i_4
            j=(i_1-1)*size_of_row+my_row
            j_1=(j-1)/size_of_col+1
            d_out(j)     = ar(j_1,i_1)
            ai(j_1,i_1)  = 0.0d0
         enddo! i_1
      endif
!----
      i_2=1
      i_3=((n)+size_of_row-my_row)/size_of_row
      do i_1=i_2,min(n_,i_3)
         j=(i_1-1)*size_of_row+my_row
         j_2=((j+1)+size_of_col-1-my_col)/size_of_col+1
         j_3=((n)+size_of_col-my_col)/size_of_col
         do j_1=j_2,nm_
            ar_(j_1,i_1) = 0.0d+00
            ai_(j_1,i_1) = 0.0d+00
         enddo! j_1
      enddo! i_1
      do i_1=max(i_2,n_+1),i_3
         j=(i_1-1)*size_of_row+my_row
         j_2=((j+1)+size_of_col-1-my_col)/size_of_col+1
         j_3=((n)+size_of_col-my_col)/size_of_col
         do j_1=j_2,lda
            ar(j_1,i_1)  = 0.0d+00
            ai(j_1,i_1)  = 0.0d+00
         enddo! j_1
      enddo! i_1
!----
      m_orig = m
      if ( m > n ) then
         m = n
      endif
      mm = (n-1)/m+1

      do  i_block = mm,max(1,3*(2-m)),-1

         i_base = (i_block-1)*m
         m0 = min(m,n-i_base)

         i = i_base + m0
         l = i_base + m0 - 1

         i_2=((i_base+1)+size_of_row-1-my_row)/size_of_row+1
         i_3=((i_base+m0)+size_of_row-my_row)/size_of_row
         j_2=1
         j_3=((i_base+m0)+size_of_col-my_col)/size_of_col

         do i_1=i_2,min(n_,i_3)
            j=(i_1-1)*size_of_row+my_row
            do j_1=j_2,min(nm_,j_3)
               wr(j_1,j-i_base) = ar_(j_1,i_1)
               wi(j_1,j-i_base) = ai_(j_1,i_1)
            enddo
            do j_1=min(nm_,j_3)+1,j_3
               wr(j_1,j-i_base) = 0.0d0+00
               wi(j_1,j-i_base) = 0.0d0+00
            enddo
         enddo
         do i_1=max(i_2,n_+1),i_3
            j=(i_1-1)*size_of_row+my_row
            do j_1=j_2,j_3
               wr(j_1,j-i_base) = ar(j_1,i_1)
               wi(j_1,j-i_base) = ai(j_1,i_1)
            enddo
         enddo
         if(diag_0>0)then
            i_2=diag_0
            i_3=((i_base+m0-1)+size_of_row-my_row)/size_of_row
            i_4=size_of_col/n_common
            if(i_2<=n_)then
               if(size_of_row==size_of_col)then
*poption indep(a,d_out)
                  do i_1=i_2,min(i_3,n_),i_4
                     d_t(i_1)     = ar_(i_1,i_1)
                     ar_(i_1,i_1) = 0.0d+00
                     ai_(i_1,i_1) = 0.0d+00
                  enddo! i_1
               else
*poption indep(a,d_out)
                  do i_1=i_2,min(i_3,n_),i_4
                     j=(i_1-1)*size_of_row+my_row
                     j_1 = (j-1)/size_of_col +1
                     d_t(i_1)     = ar_(j_1,i_1)
                     ar_(j_1,i_1) = 0.0d+00
                     ai_(j_1,i_1) = 0.0d+00
                  enddo! i_1
               endif
               i_2=((n_-i_2)/i_4+1)*i_4+i_2
            endif
            if(size_of_row==size_of_col)then
*poption indep(a,d_out)
               do i_1=i_2,i_3,i_4
                  d_t(i_1)    = ar(i_1,i_1)
                  ar(i_1,i_1) = 0.0d+00
                  ai(i_1,i_1) = 0.0d+00
               enddo! i_1
            else
*poption indep(a,d_out)
               do i_1=i_2,i_3,i_4
                  j=(i_1-1)*size_of_row+my_row
                  j_1 = (j-1)/size_of_col +1
                  d_t(i_1)    = ar(j_1,i_1)
                  ar(j_1,i_1) = 0.0d+00
                  ai(j_1,i_1) = 0.0d+00
               enddo! i_1
            endif
         endif

         k_2=m0
         k_3=max(1,3*(2-i_block))

         i=i_base+k_2
         l=i-1
         y_pos =   (i-1)/size_of_row +1
         x_pos =   (l-1)/size_of_col +1
         j_2=max(1,x_pos-m0)
         j_3=max(1,y_pos-m0)
         do  k_1 = k_3,k_2,1
            if(j_2<=x_pos)then
               ur_x(j_2:x_pos,k_1)=0.0d+00
               ui_x(j_2:x_pos,k_1)=0.0d+00
               vr_x(j_2:x_pos,k_1)=0.0d+00
               vi_x(j_2:x_pos,k_1)=0.0d+00
            endif
            if(j_3<=y_pos)then
               ur_y(j_3:y_pos,k_1)=0.0d+00
               ui_y(j_3:y_pos,k_1)=0.0d+00
               vr_y(j_3:y_pos,k_1)=0.0d+00
               vi_y(j_3:y_pos,k_1)=0.0d+00
            endif
         enddo! k_1

         do  k_1 = k_2,k_3,-1

            i = i_base+k_1
            l = i-1

            i_2 = get_loop_start(1, size_of_row,my_row)
            i_3 = get_loop_end  (l, size_of_row,my_row)
            j_2 = get_loop_start(1, size_of_col,my_col)
            j_3 = get_loop_end  (l, size_of_col,my_col)
!----
            y_root = get_owner_node (i, size_of_row,my_row)
            y_pos  = translate_g2l(i, size_of_row,my_row)

            x_root = get_owner_node (l, size_of_col,my_col)
            x_pos  = translate_g2l(l, size_of_col,my_col)

            d1=mpi_wtime()
            call eigen_hrd_u(
     &             wr(1,k_1),wi(1,k_1),
     &             ur_x(1,k_1),ui_x(1,k_1),
     &             ur_y(1,k_1),ui_y(1,k_1),
     &             ur_t(1),vr_t(1),
     &             x_root,y_root,x_pos, j_3,lda,nv
     &           )

            scale = ur_t(x_pos+1)
            if ( scale == 0.0d+00 ) then
               do j=1,x_pos
                  ur_x(j,k_1)=0.0d+00
                  ui_x(j,k_1)=0.0d+00
                  vr_x(j,k_1)=0.0d+00
                  vi_x(j,k_1)=0.0d+00
               enddo
               do j=1,y_pos
                  ur_y(j,k_1)=0.0d+00
                  ui_y(j,k_1)=0.0d+00
                  vr_y(j,k_1)=0.0d+00
                  vi_y(j,k_1)=0.0d+00
               enddo
               goto 1000
            endif
            d2=mpi_wtime()
            dd(1)=dd(1)+(d2-d1)

            if ( vr_t(x_pos+3) == 0.0d+00 ) then
               tau(l,1) = -tau(i,1)
               tau(l,2) = -tau(i,2)
               wr(x_pos,k_1) = ur_t(x_pos+3)
            else
               sr       =  vr_t(x_pos+1)
               si       =  vr_t(x_pos+2)
               tr       =  si*tau(i,2) - sr*tau(i,1)
               ti       = -sr*tau(i,2) - si*tau(i,1)
               tau(l,1) =  tr / vr_t(x_pos+3)
               tau(l,2) =  ti / vr_t(x_pos+3)
            endif

            beta  = ur_t(x_pos+4)
            if ( x_root == my_col .and. y_root == my_row ) then
               e_out(i)      = scale*ur_t(x_pos+3)
               e2_out(i)     = scale*scale*ur_t(x_pos+2)
               wr(x_pos,k_1) = scale*ur_t(x_pos)
               wi(x_pos,k_1) = scale*vr_t(x_pos)
            endif
            i_1 = get_owner_node(i, size_of_col,my_col)
            if ( i_1 == my_col .and. y_root == my_row ) then
               j_1 = translate_g2l(i, size_of_col,my_col)
               wi(j_1,k_1) = scale*sqrt(ur_t(x_pos+4))
            endif
!----
!---- v = au
!----
            d1=mpi_wtime() 
!$omp parallel
            call eigen_hrd_Au(
     &             ar(1,1),ai(1,1),lda,
     &             ur_x(1,k_1),ui_x(1,k_1),
     &             ur_y(1,k_1),ui_y(1,k_1),
     &             vr_x(1,k_1),vi_x(1,k_1),
     &             ur_t(1),ui_t(1), vr_t(1),vi_t(1),
     &             d_t(1),
     &             i_3, x_pos,y_pos, nv,k_1-k_2,
     &             ar_(1,1),ai_(1,1),n_,nm_
     &           )
!$omp end parallel

            d2=mpi_wtime() 
            dd(2)=dd(2)+d2-d1
!----
!---- v = (a+uv+vu)u = au+(vu)u+(uu)v
!----
            d1=mpi_wtime() 
            if(k_2>k_1)then
*soption unroll(2)
               do l_1=k_2,k_1+1,-1
                  j=k_2-l_1
                  sr = 0.0d+00
                  si = 0.0d+00
                  tr = 0.0d+00
                  ti = 0.0d+00
*soption unroll(4)
!dir$ ivdep
!dir$ vector always
                  do  j_1 = 1, x_pos
                     wr_x0 = ur_x(j_1,k_1)
                     wi_x0 = ui_x(j_1,k_1)
                     ur_x0 = ur_x(j_1,l_1)
                     ui_x0 = ui_x(j_1,l_1)
                     vr_x0 = vr_x(j_1,l_1)
                     vi_x0 = vi_x(j_1,l_1)

                     sr = sr
     &                      + vr_x0*wr_x0
                     sr = sr
     &                      + vi_x0*wi_x0
                     si = si
     &                      + vi_x0*wr_x0
                     si = si
     &                      - vr_x0*wi_x0
                     tr = tr
     &                      + ur_x0*wr_x0
                     tr = tr
     &                      + ui_x0*wi_x0
                     ti = ti
     &                      + ui_x0*wr_x0
                     ti = ti
     &                      - ur_x0*wi_x0
                  enddo! k
                  ur_t(4*j+1) = sr
                  ur_t(4*j+2) = si
                  ur_t(4*j+3) = tr
                  ur_t(4*j+4) = ti
               enddo! j0
               j=(k_2-k_1)*4
               call reduce_dbl(ur_t(1), vr_t(1), j, mpi_comm_col)
*soption unroll(2)
               do l_1=k_2,k_1+1,-1
                  j=k_2-l_1
                  sr = ur_t(4*j+1)
                  si = ur_t(4*j+2)
                  tr = ur_t(4*j+3)
                  ti = ur_t(4*j+4)
*soption unroll(4)
!dir$ ivdep
!dir$ vector always
                  do  j_1 = 1, x_pos
                     wr_x0 = 0
                     wi_x0 = 0
                     ur_x0 = ur_x(j_1,l_1)
                     ui_x0 = ui_x(j_1,l_1)
                     vr_x0 = vr_x(j_1,l_1)
                     vi_x0 = vi_x(j_1,l_1)

                     wr_x0 = wr_x0
     &                            - tr*vr_x0
                     wi_x0 = wi_x0
     &                            + ti*vr_x0
                     wr_x0 = wr_x0
     &                            - sr*ur_x0
                     wi_x0 = wi_x0
     &                            + si*ur_x0
                     wr_x0 = wr_x0
     &                            - ti*vi_x0
                     wi_x0 = wi_x0
     &                            - tr*vi_x0
                     wr_x0 = wr_x0
     &                            - si*ui_x0
                     wi_x0 = wi_x0
     &                            - sr*ui_x0

                     vr_x(j_1,k_1) = wr_x0+vr_x(j_1,k_1)
                     vi_x(j_1,k_1) = wi_x0+vi_x(j_1,k_1)
                  enddo! k
               enddo! j0
            endif
            d2=mpi_wtime()
            dd(5)=dd(5)+d2-d1

            d1=mpi_wtime()
            call  eigen_hrd_v(
     &              ur_x(1,k_1),ui_x(1,k_1),
     &              vr_x(1,k_1),vi_x(1,k_1),
     &              vr_y(1,k_1),vi_y(1,k_1),
     &              ur_t(1),vr_t(1),
     &              beta, j_3,x_pos,nv
     &            )
            d2=mpi_wtime()
            dd(4)=dd(4)+d2-d1

            d1=mpi_wtime()
            if(k_1>1)then

               i_2 = get_loop_start(i_base+1,     size_of_row,my_row)
               i_3 = get_loop_end  (i_base+k_1-1, size_of_row,my_row)

               do i_1=i_2,i_3

                  j   = translate_l2g(i_1, size_of_row,my_row)
                  l_1 = j-i_base

                  ur_y0=ur_y(i_1,k_1)
                  vr_y0=vr_y(i_1,k_1)
                  ui_y0=ui_y(i_1,k_1)
                  vi_y0=vi_y(i_1,k_1)

*soption unroll(4)
!dir$ ivdep
!dir$ vector always
                  do j_1=j_2,j_3

                     wr_x0 = 0
                     wi_x0 = 0
                     ur_x0 = ur_x(j_1,k_1)
                     ui_x0 = ui_x(j_1,k_1)
                     vr_x0 = vr_x(j_1,k_1)
                     vi_x0 = vi_x(j_1,k_1)

                     wr_x0 = wr_x0
     &                            - vr_x0*ur_y0
                     wi_x0 = wi_x0
     &                            - vi_x0*ur_y0
                     wr_x0 = wr_x0
     &                            - ur_x0*vr_y0
                     wi_x0 = wi_x0
     &                            - ui_x0*vr_y0
                     wr_x0 = wr_x0
     &                            - vi_x0*ui_y0
                     wi_x0 = wi_x0
     &                            + vr_x0*ui_y0
                     wr_x0 = wr_x0
     &                            - ui_x0*vi_y0
                     wi_x0 = wi_x0
     &                            + ur_x0*vi_y0

                     wr(j_1,l_1) = wr_x0+wr(j_1,l_1)
                     wi(j_1,l_1) = wi_x0+wi(j_1,l_1)

                  enddo! j_1
               enddo! i_1
            endif
            d2=mpi_wtime()
            dd(6)=dd(6)+d2-d1

1000        continue
         enddo! k_1

         i_2 = get_loop_start(i_base+1,  size_of_row,my_row)
         i_3 = get_loop_end  (i_base+m0, size_of_row,my_row)
         do i_1=i_2,min(n_,i_3)
            j   = translate_l2g(i_1, size_of_row,my_row)
            j_2 = 1
            j_3 = get_loop_end  (j, size_of_col,my_col)
            do j_1=j_2,j_3
               ar_(j_1,i_1) = wr(j_1,j-i_base)
               ai_(j_1,i_1) = wi(j_1,j-i_base)
            enddo! j_1
         enddo! i_1
         do i_1=max(i_2,n_+1),i_3
            j   = translate_l2g(i_1, size_of_row,my_row)
            j_2 = 1
            j_3 = get_loop_end  (j, size_of_col,my_col)
            do j_1=j_2,j_3
               ar(j_1,i_1) = wr(j_1,j-i_base)
               ai(j_1,i_1) = wi(j_1,j-i_base)
            enddo! j_1
         enddo! i_1

         if ( diag_0 > 0 ) then
            i_2 = diag_0
            i_3 = get_loop_end  (i_base, size_of_row,my_row)
            i_4 = size_of_col/n_common
            if ( i_2 <= n_ ) then
               if ( size_of_row == size_of_col ) then
                  do i_1=i_2,min(i_3,n_),i_4
                     j_1 = i_1
                     ar_(j_1,i_1) = d_t(i_1)
                  enddo! i_1
               else
                  do i_1=i_2,min(i_3,n_),i_4
                     j   = (i_1-1)*size_of_row+my_row
                     j_1 = (j-1)/size_of_col +1
                     ar_(j_1,i_1) = d_t(i_1)
                  enddo! i_1
               endif
               i_2=((n_-i_2)/i_4+1)*i_4+i_2
            endif
            if ( size_of_row == size_of_col ) then
               do i_1=i_2,i_3,i_4
                  j_1 = i_1
                  ar(j_1,i_1)  = d_t(i_1)
               enddo! i_1
            else
               do i_1=i_2,i_3,i_4
                  j   = (i_1-1)*size_of_row+my_row
                  j_1 = (j-1)/size_of_col +1
                  ar(j_1,i_1)  = d_t(i_1)
               enddo! i_1
            endif
         endif

         if ( i_block > 1 ) then
            i_2 = 1
!----       i_3 = get_loop_end  (i_base, size_of_row,my_row)
            i_3 = i_base
            d1=mpi_wtime() 
!$omp parallel
            call eigen_hrd_2update(
     &             ar(1,1),ai(1,1),lda,
     &             ur_x(1,1),ui_x(1,1),
     &             ur_y(1,1),ui_y(1,1),
     &             vr_x(1,1),vi_x(1,1),
     &             vr_y(1,1),vi_y(1,1),   
     &             nv,m0,i_3,
     &             ar_(1,1),ai_(1,1),n_,nm_
     &           )
!$omp end parallel
            d2=mpi_wtime() 
            dd(3)=dd(3)+d2-d1

         endif

      enddo! i_block

      if ( n >= 2 ) then
         i = 2; l = i-1
         y_root = get_owner_node (i, size_of_row,my_row)
         x_root = get_owner_node (l, size_of_col,my_col)
         if ( y_root == my_row .and. x_root == my_col ) then
            i_1 = translate_g2l(i, size_of_row,my_row)
            j_1 = translate_g2l(l, size_of_col,my_col)
            if(i_1<=n_)then
               ur_t(1) = ar_(j_1,i_1)
               ur_t(2) = ai_(j_1,i_1)
            else
               ur_t(1) = ar(j_1,i_1)
               ur_t(2) = ai(j_1,i_1)
            endif
         endif
         call bcast_dbl(ur_t(1), 2, x_root, mpi_comm_col)
         call bcast_dbl(ur_t(1), 2, y_root, mpi_comm_row)
         scale = abs(ur_t(1)) + abs(ur_t(2))

         if ( scale > 0.0d0 ) then
            sr = ur_t(1) / scale
            si = ur_t(2) / scale
            h = sr**2 + si**2
            g = sqrt(h)
            tau(l,1) =  (si * tau(i,2) - sr * tau(i,1)) / g
            tau(l,2) = -(sr * tau(i,2) + si * tau(i,1)) / g
            y_root = get_owner_node (i, size_of_row,my_row)
            x_root = get_owner_node (l, size_of_col,my_col)
            if ( y_root == my_row .and. x_root == my_col ) then
               i_1 = translate_g2l(i, size_of_row,my_row)
               j_1 = translate_g2l(l, size_of_col,my_col)
               e_out(i)  = scale * g
               e2_out(i) = scale * scale * h
               if ( i_1 <= n_ ) then
                  ar_(j_1,i_1) = scale * 2 * sr
                  ai_(j_1,i_1) = scale * 2 * si
               else
                  ar(j_1,i_1)  = scale * 2 * sr
                  ai(j_1,i_1)  = scale * 2 * si
               endif
            endif
            y_root = get_owner_node (i, size_of_row,my_row)
            x_root = get_owner_node (i, size_of_col,my_col)
            if ( y_root == my_row .and. x_root == my_col ) then
               i_1 = translate_g2l(i, size_of_row,my_row)
               j_1 = translate_g2l(i, size_of_col,my_col)
               if ( i_1 <= n_ ) then
                  ai_(j_1,i_1) = scale * sqrt(2*h)
               else
                  ai(j_1,i_1)  = scale * sqrt(2*h)
               endif
            endif
            y_root = get_owner_node (l, size_of_row,my_row)
            x_root = get_owner_node (l, size_of_col,my_col)
            if ( y_root == my_row .and. x_root == my_col ) then
               i_1 = translate_g2l(l, size_of_row,my_row)
               j_1 = translate_g2l(l, size_of_col,my_col)
               if ( i_1 <= n_ ) then
                  ai_(j_1,i_1) = 0.0d0
               else
                  ai(j_1,i_1)  = 0.0d0
               endif
            endif
         endif
      endif

      if ( diag_0 > 0 ) then
         i_2 = diag_0
         i_3 = get_loop_end  (n, size_of_row,my_row)
         i_4 = size_of_col/n_common
         if ( i_2 <= n_ ) then
         do i_1=i_2,min(i_3,n_),i_4
            j   = (i_1-1)*size_of_row+my_row
            j_1 = (j-1)/size_of_col +1
            t1           = d_out(j)
            d_out(j)     = ar_(j_1,i_1)
            ar_(j_1,i_1) = t1
         enddo! i_1
         i_2=((n_-i_2)/i_4+1)*i_4+i_2
         endif
         do i_1=i_2,i_3,i_4
            j   = (i_1-1)*size_of_row+my_row
            j_1 = (j-1)/size_of_col +1
            t1           = d_out(j)
            d_out(j)     = ar(j_1,i_1)
            ar(j_1,i_1)  = t1
         enddo! i_1
      endif

      call reduce_dbl(d_out(1), ur_t(1), n, mpi_comm_eigen)
      call reduce_dbl(e_out(1), ur_t(1), n, mpi_comm_eigen)
      call reduce_dbl(e2_out(1),ur_t(1), n, mpi_comm_eigen)

!$omp parallel
      call eigen_hrd_Au(
     &       ar,ai,lda,
     &       ur_x,ui_x,ur_y,ui_y,vr_x,vi_x,
     &       ur_t,ui_t, vr_t,vi_t, d_t,
     &       -2, x_pos,y_pos, nv,k_1-k_2,
     &       ar_,ai_,n_,nm_
     &     )
      call eigen_hrd_2update(
     &       ar,ai,lda,
     &       ur_x,ui_x,ur_y,ui_y,
     &       vr_x,vi_x,vr_y,vi_y,   
     &       nv,m0,-2,
     &       ar_,ai_,n_,nm_
     &     )
!$omp end parallel

!----
#ifdef DETAIL
      if(myrank==1)then
         print*," "
         print*,"detail of exectime in \"eigen_hrd\""
         print*,"   calc (u,beta)    ",dd(1),"(sec)"
         print*,"   mat-vec (au)     ",dd(2),"(sec)"
         print*,"   2update (a-uv-vu)",dd(3),"(sec)"
!----    print*,"   mat-vec (au)     ",dd(2),(dble(n)**3*8d-9/3)/dd(2)
!----    print*,"   2update (a-uv-vu)",dd(3),(dble(n)**3*8d-9/3)/dd(3)
         print*,"   calc v           ",dd(4),"(sec)"
         print*,"   v=v-(uv+vu)u     ",dd(5),"(sec)"
         print*,"   uv post reduction",dd(6),"(sec)"
      endif
#endif
!----
      m = m_orig

      return
      end

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: gnrt_k0_n, get_trmat1, gnrt_k0, get_trmat1, read_coordsystem,
!            ch4ksample, read_nkpnt, hexm0, fccm0, bccm0, sccm0, kpmwbz0,
!            kpmsf0, set_kfromtemporaryarray, get_trmat, read_konly,
!            down2wayksample, readk0, get_trmat, gen_gamma_p0
!
!  AUTHOR(S): T. Yamasaki, H. Mizouchi,   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! $Id: b_Kpoints.F90 570 2017-04-21 20:34:50Z yamasaki $
subroutine gen_gamma_p0(paramset,knv3,kv3,vkxyz,qwgt)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: gen_gamma_p0
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : CARTS, CRDTYP, DP
  implicit none
  logical, intent(in)        :: paramset
  integer, intent(in)        :: knv3
  integer, intent(out)       :: kv3
  real(kind=DP), intent(out) :: vkxyz(knv3,3,CRDTYP)
  real(kind=DP), intent(out) :: qwgt(knv3)

  kv3 = 1
  if(paramset) return

  vkxyz(1,1:3,CARTS) = 0.d0
  qwgt (1) = 1.d0
end subroutine gen_gamma_p0

subroutine readk0(paramset,nfout,ipri_kp,knv3,rltv,nfkpoint,nfmatbp&
     & ,kv3,vkxyz,qwgt)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: readk0
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!  FURTHER MODIFICATION: T. Yamasaki, October/10/2012
!=======================================================================

  use m_Const_Parameters, only : CARTS, CRDTYP, DP
  use m_ErrorMessages,    only : EOF_REACHED, FORMAT_ERROR
  implicit none
  logical, intent(in)        :: paramset
  integer, intent(in)        :: nfout, ipri_kp, knv3
  real(kind=DP), intent(in)  :: rltv(3,3)
  integer, intent(in)        :: nfkpoint, nfmatbp
  integer, intent(out)       :: kv3
  real(kind=DP), intent(out) :: vkxyz(knv3,3,CRDTYP),qwgt(knv3)

  real(kind=DP),dimension(3) ::fv
  real(kind=DP)              :: weightk
  integer                    :: nn,nk,nw,nwei,nv(3)
  integer                    :: fn_number_of_words
  integer,     parameter     :: len_str = 80
  character(len=len_str)     :: str
  integer                    :: ierr

  real(kind=DP), pointer, dimension(:,:) :: trmat,trbp,trpb,mat1,mat2 

  interface
     subroutine phase_error_wo_filename(ierr,nfout,nf,line,modulefile)
       integer, intent(in) :: ierr,nfout
       integer, intent(in), optional :: nf
       integer, intent(in), optional :: line
       character(len=*),intent(in), optional :: modulefile
     end subroutine phase_error_wo_filename
  end interface

  rewind nfkpoint
  call skip_commentlines(nfkpoint,ipri_kp,nfout,ierr)
  if(ierr == EOF_REACHED) then
!!$     write(nfout,'(" __LINE__ = ",i8)')  __LINE__
!!$     write(nfout,'(" __FILE__ = ",a)') __FILE__
#ifdef DEBUG_ERRORS
     call phase_error_wo_filename(ierr,nfout,nf=nfkpoint,line=__LINE__,modulefile=__FILE__)
#else
     call phase_error_wo_filename(ierr,nfout,nf=nfkpoint)
#endif
     call phase_error_with_msg(nfout,' phase_error',__LINE__,__FILE__)
  end if

  read(nfkpoint,'(a80)') str

  select case (fn_number_of_words(str))
  case (0)
     call phase_error_with_msg(nfout,' error in reading of the nfkpoint file',__LINE__,__FILE__)
  case (1)
     read(str,*) kv3
     nwei = kv3
  case (2)
     read(str,*) kv3, nwei
  case (3)
     kv3 = -1
     nwei = -1
  case default
     kv3 = -1
     nwei = -1
!!$     read(str,*) kv3, nwei
  end select
!!$  read(nfkpoint,*) kv3, nwei
  if(paramset .and. kv3 == -1) then
     kv3 = 1
     do while (.true.) 
        if(kv3 > 1) read(nfkpoint,'(a80)',end=1002,err=1002) str
        select case (fn_number_of_words(str))
        case (0,1,2)
           goto 1002
        case (3)
           read(str,*) fv(1), fv(2), fv(3)
        case (4)
           read(str,*) nv(1),nv(2),nv(3),nk
        case (5)
           read(str,*) nv(1),nv(2),nv(3),nk,nw
        case default
           read(str,*) nv(1),nv(2),nv(3),nk,nw
        end select
        kv3 = kv3+1
     end do
1002 continue
     kv3 = kv3-1 
     if(kv3 < 1) then
        call phase_error_with_msg(nfout,' kv3 is smaller than 1 in reading of nfkpoint',__LINE__,__FILE__)
     end if
  end if

  if(paramset) return

  allocate(trmat(3,3),trbp(3,3),trpb(3,3),mat1(3,3),mat2(3,3))

  call get_trmat(rltv,trbp,trpb,mat1,mat2,trmat,nfmatbp)

  if(ipri_kp >= 1) then
     write(nfout,'(" <<readk0 >>")')
     write(nfout,'(" rltv")')
     do nk = 1, 3
        write(nfout,'(3f12.6)') (rltv(nn,nk),nn=1,3)
     end do
     write(nfout,'(" trmat")')
     do nk = 1, 3
        write(nfout,'(3f12.6)') (trmat(nn,nk),nn=1,3)
     end do
  end if

  if(kv3 == -1) then
     kv3 = 1
     do while (.true.) 
        if(kv3 > 1) read(nfkpoint,'(a80)',end=1001,err=1001) str
        write(nfout,'(a80)') str
        select case (fn_number_of_words(str))
        case (0,1,2)
           goto 1001
!!$           stop ' error in reading of k-coordinates from the nfkpoint file'
        case (3)
           fv = 0.d0
           read(str,*) fv(1), fv(2), fv(3)
           write(nfout,'(" fv(1:3) = ",3f8.4)') fv(1:3)
           vkxyz(kv3,1:3,CARTS) = matmul(trmat,fv)
           if(nwei >= 1) then
              qwgt(kv3) = 1.d0/dble(nwei)
           else
              qwgt(kv3) = 1.d0
           end if
        case (4)
           read(str,*) nv(1),nv(2),nv(3),nk
           vkxyz(kv3,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
           if(nwei >= 1) then
              qwgt(kv3) = 1.d0/dble(nwei)
           else
              qwgt(kv3) = 1.d0
           end if
        case (5)
           read(str,*) nv(1),nv(2),nv(3),nk,nw
           vkxyz(kv3,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
           if(nwei >= 1) then
              qwgt(kv3) = dble(nw)/dble(nwei)
           else
              qwgt(kv3) = dble(nw)
           end if
        case default
           read(str,*) nv(1),nv(2),nv(3),nk,nw
           vkxyz(kv3,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
           if(nwei >= 1) then
              qwgt(kv3) = dble(nw)/dble(nwei)
           else
              qwgt(kv3) = dble(nw)
           end if
        end select
        kv3 = kv3+1
     end do
1001 continue
     kv3 = kv3-1 
     if(kv3 < 1) then
        call phase_error_with_msg(nfout,' kv3 is smaller than 1 in reading of nfkpoint',__LINE__,__FILE__)
     end if
     if(nwei < 1) then
        weightk = 0.d0
        do nn = 1, kv3
           weightk = weightk + qwgt(nn)
        end do
        do nn = 1, kv3
           qwgt(nn) = qwgt(nn)/weightk
        end do
     end if
  else
     do nn = 1, kv3
        read(nfkpoint,'(a80)',end=1004, err=1003) str
        select case (fn_number_of_words(str))
        case (0,1,2)
           call phase_error_with_msg(nfout,' error in reading of k-coordinates from the nfkpoint file',__LINE__,__FILE__)
        case (3)
           fv = 0.d0
           read(str,*) fv(1), fv(2), fv(3)
           vkxyz(nn,1:3,CARTS) = matmul(trmat,fv)
           qwgt(nn) = 1.d0/dble(nwei)
        case (4)
           read(str,*) nv(1),nv(2),nv(3),nk
           vkxyz(nn,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
           qwgt(nn) = 1.d0/dble(nwei)
        case (5)
           read(str,*) nv(1),nv(2),nv(3),nk,nw
           vkxyz(nn,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
           qwgt(nn) = dble(nw)/dble(nwei)
        case default
           read(str,*) nv(1),nv(2),nv(3),nk,nw
           vkxyz(nn,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
           qwgt(nn) = dble(nw)/dble(nwei)
        end select
     enddo
     goto 1010
1004 ierr = EOF_REACHED
#ifdef DEBUG_ERRORS
     call phase_error_wo_filename(ierr,nfout,nf=nfkpoint,line=__LINE__,modulefile=__FILE__)
#else
     call phase_error_wo_filename(ierr,nfout,nf=nfkpoint)
#endif

1003 ierr = FORMAT_ERROR
#ifdef DEBUG_ERRORS
     call phase_error_wo_filename(ierr,nfout,nf=nfkpoint,line=__LINE__,modulefile=__FILE__)
#else
     call phase_error_wo_filename(ierr,nfout,nf=nfkpoint)
#endif
1010 continue
  end if

  deallocate(trmat,trbp,trpb,mat1,mat2 )

  if(ipri_kp >= 1) then
     write(nfout,'(/,"  << readk0 >>")')
     write(nfout,*) ' !Total Generated Kpoints = ',kv3
     do nk = 1, kv3
        write(nfout,'(i4," ",3f12.6)') nk,(vkxyz(nk,nn,CARTS),nn=1,3)
     end do
  end if

end subroutine readk0

subroutine readk0_for_band_unfolding( paramset, nfout, ipri_kp, knv3, &
     &                                rltv_refcell, altv_supercell, &
     &                                nfkpoint,nfmatbp, kv3, vkxyz, qwgt )
  use m_Const_Parameters, only : CARTS, CRDTYP, DP, PAI2, BUCS
  use m_ErrorMessages,    only : EOF_REACHED, FORMAT_ERROR

  implicit none

  logical, intent(in)        :: paramset
  integer, intent(in)        :: nfout, ipri_kp, knv3
  real(kind=DP), intent(in)  :: rltv_refcell(3,3), altv_supercell(3,3)
  integer, intent(in)        :: nfkpoint, nfmatbp
  integer, intent(out)       :: kv3
  real(kind=DP), intent(out) :: vkxyz(knv3,3,CRDTYP),qwgt(knv3)

  real(kind=DP),dimension(3) ::fv
  real(kind=DP)              :: weightk
  integer                    :: nn,nk,nw,nwei,nv(3)
  integer                    :: fn_number_of_words
  integer,     parameter     :: len_str = 80
  character(len=len_str)     :: str
  integer                    :: ierr

  integer :: i, j, k
  real*8 c1

  real(kind=DP), pointer, dimension(:,:) :: trmat,trbp,trpb,mat1,mat2

  interface
     subroutine phase_error_wo_filename(ierr,nfout,nf,line,modulefile)
       integer, intent(in) :: ierr,nfout
       integer, intent(in), optional :: nf
       integer, intent(in), optional :: line
       character(len=*),intent(in), optional :: modulefile
     end subroutine phase_error_wo_filename
  end interface

  rewind nfkpoint
  call skip_commentlines(nfkpoint,ipri_kp,nfout,ierr)
  if(ierr == EOF_REACHED) then
!!$     write(nfout,'(" __LINE__ = ",i8)')  __LINE__
!!$     write(nfout,'(" __FILE__ = ",a)') __FILE__
#ifdef DEBUG_ERRORS
     call phase_error_wo_filename(ierr,nfout,nf=nfkpoint,line=__LINE__,modulefile=__FILE__)
#else
     call phase_error_wo_filename(ierr,nfout,nf=nfkpoint)
#endif
     call phase_error_with_msg(nfout,' phase_error',__LINE__,__FILE__)
  end if

  read(nfkpoint,'(a80)') str

  select case (fn_number_of_words(str))
  case (0)
     call phase_error_with_msg(nfout,' error in reading of the nfkpoint file',__LINE__,__FILE__)
  case (1)
     read(str,*) kv3
     nwei = kv3
  case (2)
     read(str,*) kv3, nwei
  case (3)
     kv3 = -1
     nwei = -1
  case default
     kv3 = -1
     nwei = -1
!!$     read(str,*) kv3, nwei
  end select
!!$  read(nfkpoint,*) kv3, nwei
  if(paramset .and. kv3 == -1) then
     kv3 = 1
     do while (.true.)
        if(kv3 > 1) read(nfkpoint,'(a80)',end=1002,err=1002) str
        select case (fn_number_of_words(str))
        case (0,1,2)
           goto 1002
        case (3)
           read(str,*) fv(1), fv(2), fv(3)
        case (4)
           read(str,*) nv(1),nv(2),nv(3),nk
        case (5)
           read(str,*) nv(1),nv(2),nv(3),nk,nw
        case default
           read(str,*) nv(1),nv(2),nv(3),nk,nw
        end select
        kv3 = kv3+1
     end do
1002 continue
     kv3 = kv3-1
     if(kv3 < 1) then
        call phase_error_with_msg(nfout,' kv3 is smaller than 1 in reading of nfkpoint',__LINE__,__FILE__)
     end if
  end if

  if(paramset) return

 allocate(trmat(3,3),trbp(3,3),trpb(3,3),mat1(3,3),mat2(3,3))

  call get_trmat(rltv_refcell,trbp,trpb,mat1,mat2,trmat,nfmatbp)
!
  if(ipri_kp >= 2) then
     write(nfout,'(" <<readk0_band_unfolding >>")')
     write(nfout,'(" rltv")')
     do nk = 1, 3
        write(nfout,'(3f12.6)') (rltv_refcell(nn,nk),nn=1,3)
     end do
     write(nfout,'(" trmat")')
     do nk = 1, 3
        write(nfout,'(3f12.6)') (trmat(nn,nk),nn=1,3)
     end do
  end if

  if(kv3 == -1) then
     kv3 = 1
     do while (.true.)
        if(kv3 > 1) read(nfkpoint,'(a80)',end=1001,err=1001) str
        write(nfout,'(a80)') str
        select case (fn_number_of_words(str))
        case (0,1,2)
           goto 1001
!!$           stop ' error in reading of k-coordinates from the nfkpoint file'
        case (3)
           fv = 0.d0
           read(str,*) fv(1), fv(2), fv(3)
           write(nfout,'(" fv(1:3) = ",3f8.4)') fv(1:3)
           vkxyz(kv3,1:3,CARTS) = matmul(trmat,fv)
           if(nwei >= 1) then
              qwgt(kv3) = 1.d0/dble(nwei)
           else
              qwgt(kv3) = 1.d0
           end if
        case (4)
           read(str,*) nv(1),nv(2),nv(3),nk
           vkxyz(kv3,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
           if(nwei >= 1) then
              qwgt(kv3) = 1.d0/dble(nwei)
           else
              qwgt(kv3) = 1.d0
           end if
        case (5)
           read(str,*) nv(1),nv(2),nv(3),nk,nw
           vkxyz(kv3,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
           if(nwei >= 1) then
              qwgt(kv3) = dble(nw)/dble(nwei)
           else
              qwgt(kv3) = dble(nw)
           end if
        case default
           read(str,*) nv(1),nv(2),nv(3),nk,nw
           vkxyz(kv3,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
           if(nwei >= 1) then
              qwgt(kv3) = dble(nw)/dble(nwei)
           else
              qwgt(kv3) = dble(nw)
           end if
        end select
        kv3 = kv3+1
     end do
1001 continue
     kv3 = kv3-1
     if(kv3 < 1) then
        call phase_error_with_msg(nfout,' kv3 is smaller than 1 in reading of nfkpoint',__LINE__,__FILE__)
     end if
     if(nwei < 1) then
        weightk = 0.d0
        do nn = 1, kv3
           weightk = weightk + qwgt(nn)
        end do
        do nn = 1, kv3
           qwgt(nn) = qwgt(nn)/weightk
        end do
     end if
  else
     do nn = 1, kv3
        read(nfkpoint,'(a80)',end=1004, err=1003) str
        select case (fn_number_of_words(str))
        case (0,1,2)
           call phase_error_with_msg(nfout,' error in reading of k-coordinates from the nfkpoint file',__LINE__,__FILE__)
        case (3)
           fv = 0.d0
           read(str,*) fv(1), fv(2), fv(3)
           vkxyz(nn,1:3,CARTS) = matmul(trmat,fv)
           qwgt(nn) = 1.d0/dble(nwei)
        case (4)
           read(str,*) nv(1),nv(2),nv(3),nk
           vkxyz(nn,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
           qwgt(nn) = 1.d0/dble(nwei)
        case (5)
           read(str,*) nv(1),nv(2),nv(3),nk,nw
           vkxyz(nn,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
           qwgt(nn) = dble(nw)/dble(nwei)
        case default
           read(str,*) nv(1),nv(2),nv(3),nk,nw
           vkxyz(nn,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
           qwgt(nn) = dble(nw)/dble(nwei)
        end select
     enddo
     goto 1010
1004 ierr = EOF_REACHED
#ifdef DEBUG_ERRORS
     call phase_error_wo_filename(ierr,nfout,nf=nfkpoint,line=__LINE__,modulefile=__FILE__)
#else
     call phase_error_wo_filename(ierr,nfout,nf=nfkpoint)
#endif

1003 ierr = FORMAT_ERROR
#ifdef DEBUG_ERRORS
     call phase_error_wo_filename(ierr,nfout,nf=nfkpoint,line=__LINE__,modulefile=__FILE__)
#else
     call phase_error_wo_filename(ierr,nfout,nf=nfkpoint)
#endif
1010 continue
  end if

! -- back to supercell --
  Do i=1, kv3
     Do j=1, 3
        c1 = 0.0d0
        Do k=1, 3
           c1 = c1 + altv_supercell(k,j) *vkxyz(i,k,CARTS)
        End Do
        vkxyz(i,j,BUCS) = c1 /PAI2
     End do
  End Do

  deallocate(trmat,trbp,trpb,mat1,mat2 )

  if(ipri_kp >= 2) then
     write(nfout,'(/,"  << readk0_band_unfolding >>")')
     write(nfout,*) ' !Total Generated Kpoints = ',kv3
     do nk = 1, kv3
        write(nfout,'(i4," ",3f12.6)') nk,(vkxyz(nk,nn,CARTS),nn=1,3)
     end do
  end if

end subroutine readk0_for_band_unfolding


subroutine get_trmat(rltv,trbp,trpb,mat1,mat2,trmat,nfmatbp)
  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP), intent(in), dimension(3,3) :: rltv
  real(kind=DP), dimension(3,3) ::              trbp,trpb,mat1,mat2
  real(kind=DP), intent(out), dimension(3,3) :: trmat
  integer, intent(in) :: nfmatbp
  !    make translation matrix  trpb (P -> B)
  integer  :: i
  logical :: open_check

  trbp = 0.d0
  do i = 1,3
     trbp(i,i) = 1.d0
  enddo

  inquire(unit=nfmatbp, opened = open_check)
  if(open_check) then
     rewind nfmatbp
     do i = 1, 3
        read(nfmatbp,*,end=1,err=1) trbp(i,1),trbp(i,2),trbp(i,3)
     enddo
     goto 2
1    trbp = 0.d0
     do i = 1,3
        trbp(i,i) = 1.d0
     enddo
2    continue
  end if

  call inver3n(3,trbp,trpb)

  mat1 = transpose(trpb)
  call inver3n(3,mat1,mat2)
  call matpr3(rltv,mat2,trmat)
!!$  trmat = matmul(rltv,mat2)

end subroutine get_trmat

subroutine read_konly(paramset,nfinp,nfout,knv3 &
     & ,altv,rltv,kv3,vkxyz,qwgt,str,len_str)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: read_konly
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : CARTS, CRDTYP, DP, NONAME, PAI2 &
       &                       , NODATA, BUCS
  implicit none
  logical, intent(in)        :: paramset
  integer, intent(in)        :: nfinp, nfout, knv3
  real(kind=DP), intent(in)  :: altv(3,3),rltv(3,3)
  integer, intent(out)       :: kv3
  real(kind=DP), intent(out) :: vkxyz(knv3,3,CRDTYP),qwgt(knv3)
  integer, intent(in)        :: len_str
  character(len=len_str)        :: str

  integer                    :: sw_k_coord_system
  integer                    :: ik,i,incunt,to,from

  real(kind=DP), pointer, dimension(:)   :: wka
  real(kind=DP), pointer, dimension(:,:) :: trmat

  rewind nfinp
  call down2wayksample  !-(contained here)
  read(nfinp,'(a132)') str
  call read_nkpnt(str,len_str,kv3) !-(b_Kpoints) ->kv3
  if(paramset) return

  allocate(wka(4));  allocate(trmat(3,3))

  read(nfinp,'(a132)') str
  call read_coordsystem(str,len_str,sw_k_coord_system)
  if(sw_k_coord_system == NODATA) then
     sw_k_coord_system = CARTS
  else
     read(nfinp,'(a132)') str
  end if
  do ik = 1, kv3
     call chnnm(str,len_str,4,wka,incunt)
     write(nfout,*) ' coordinates = ', wka(1),wka(2),wka(3),wka(4)
     if(incunt < 4) call phase_error_with_msg(nfout,' ! data shortage (nfinp, kpoints)',__LINE__,__FILE__)
     vkxyz(ik,1:3,sw_k_coord_system) = wka(1:3)
     qwgt(ik) = wka(4)
     if(ik < kv3) read(nfinp,'(a132)') str
  end do


  if(sw_k_coord_system == CARTS) then
     to = BUCS; from = CARTS; trmat = transpose(altv)/PAI2
  else
     to = CARTS; from = BUCS; trmat = rltv
  end if
  do ik = 1, kv3
     vkxyz(ik,1:3,to) = matmul(trmat,vkxyz(ik,1:3,from))
  end do

  do ik = 1, kv3
     write(nfout,'(i3,3f8.4,3x,3f8.4,3x,f8.4)') ik &
          &, (vkxyz(ik,i,CARTS),i=1,3) &
          &, (vkxyz(ik,i,BUCS) ,i=1,3),qwgt(ik)
  end do
  deallocate(trmat); deallocate(wka)
contains
  subroutine down2wayksample
    integer :: way_ksample_tmp

1   read(nfinp,'(a132)') str
    call ch4ksample(str,len_str,way_ksample_tmp) !-(b_Kpoints)
    if(way_ksample_tmp == NONAME) goto 1
  end subroutine down2wayksample
end subroutine read_konly

subroutine set_kfromtemporaryarray(nfout,ipri,nfmatbp,kv3_adj,kv3,kx,ky,kz,w &
     & ,rltv,vkxyz,qwgt)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: set_kfromtemporaryarray
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : CARTS, CRDTYP, DP, NONAME, PAI2 &
       &                       , NODATA, BUCS
  implicit none
  integer, intent(in) ::        nfout, ipri, nfmatbp,kv3,kv3_adj
  real(kind=DP), intent(in), dimension(kv3) :: kx,ky,kz,w
  real(kind=DP), intent(in)  :: rltv(3,3)
  real(kind=DP), intent(out) :: vkxyz(kv3_adj,3,CRDTYP),qwgt(kv3_adj)

  integer                    :: nn,nk
  real(kind=DP) :: kv(3)

  real(kind=DP), pointer, dimension(:,:) :: trmat,trbp,trpb,mat1,mat2 

  allocate(trmat(3,3))
  allocate(trbp(3,3))
  allocate(trpb(3,3))
  allocate(mat1(3,3))
  allocate(mat2(3,3))

!!$  call get_trmat  !-(contained here) ->(trmat)
  call get_trmat(rltv,trbp,trpb,mat1,mat2,trmat,nfmatbp)

  do nn = 1, kv3
     kv(1) = kx(nn); kv(2) = ky(nn); kv(3) = kz(nn)
     vkxyz(nn,1:3,CARTS) = matmul(trmat,kv)
     qwgt(nn) = w(nn)
  enddo

  deallocate(trmat)
  deallocate(trbp )
  deallocate(trpb )
  deallocate(mat1 )
  deallocate(mat2 )

  if(ipri >= 2) then
     write(nfout,'(/,"  << readk0 >>")')
     write(nfout,*) ' !Total Generated Kpoints = ',kv3
     do nk = 1, kv3
        write(nfout,'(i4," ",3f12.6)') nk,(vkxyz(nk,nn,CARTS),nn=1,3)
     end do
  end if
!!$contains
!!$  subroutine get_trmat
!!$!    make translation matrix  trpb (P -> B)
!!$    integer  :: i
!!$
!!$    rewind nfmatbp
!!$    do i = 1, 3
!!$       read(nfmatbp,*,end=1,err=1) trbp(i,1),trbp(i,2),trbp(i,3)
!!$    enddo
!!$    goto 2
!!$
!!$1   trbp = 0.d0
!!$    do i = 1,3
!!$       trbp(i,i) = 1.d0
!!$    enddo
!!$
!!$2   continue
!!$    call inver3n(3,trbp,trpb)
!!$
!!$    mat1 = transpose(trpb)
!!$    call inver3n(3,mat1,mat2)
!!$    call matpr3(rltv,mat2,trmat)
!!$
!!$  end subroutine get_trmat
end subroutine set_kfromtemporaryarray

subroutine kpmsf0(paramset,nfout,altv,rltv,ksm,knv3,kv3,vkxyz,qwgt)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: kpmsf0
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : BUCS, CARTS, CRDTYP, DP
  implicit none
  logical, intent(in)       :: paramset
  integer, intent(in)       :: nfout
  real(kind=DP), intent(in) :: altv(3,3), rltv(3,3)
  integer, intent(in)       :: ksm(3,2)
  integer, intent(in)       :: knv3
  integer, intent(out)      :: kv3
  real(kind=DP), intent(out):: vkxyz(knv3,3,CRDTYP)
  real(kind=DP), intent(out):: qwgt(knv3)

  real(kind=DP) :: fvy,fvz,dgvy,dgvz, fv2,fv3
  integer i2, i3

  if(.not.paramset) then
     if(ksm(1,1) >= 1) &
          & write(nfout,*) ' ksm(1,1) (=',ksm(1,1),') has no meaning here(kpmsf0).'
     if(ksm(1,2) >= 2) &
          & write(nfout,*) ' ksm(1,2) (=',ksm(1,2),') has no meaning here(kpmsf0).'
  end if
  fvy = ksm(2,1)*2.d0
  fvz = ksm(3,1)*2.d0
  kv3 = 0
!!$  write(nfout,*) ' !D nky, nkz = ', ksm(2,1),ksm(3,1) !nky, nkz
  dgvy=0.5d0*(rltv(2,2)/fvy+rltv(2,3)/fvz)
  dgvz=0.5d0*(rltv(3,2)/fvy+rltv(3,3)/fvz)
  do i2 = 1,ksm(2,2) ! nky2
     fv2 = (i2-ksm(2,1)-1)/fvy
     do i3 = 1,ksm(3,2) ! nkz2
        fv3 = (i3-ksm(3,1)-1)/fvz
        kv3 = kv3 + 1
!----*----*   for parameter setting 5th June '94 by Y.M.
        if(.not.paramset .and. kv3 <= knv3) then
           vkxyz(kv3,1,CARTS) = 0.D0
           vkxyz(kv3,2,CARTS) = rltv(2,2)*fv2 + rltv(2,3)*fv3 + dgvy
           vkxyz(kv3,3,CARTS) = rltv(3,2)*fv2 + rltv(3,3)*fv3 + dgvz
        end if
     end do
  end do
  if(.not.paramset) then
     qwgt(1:kv3) = 1.d0/kv3
     write(nfout,*) 'number of generated k-points=',kv3
     if(kv3 /= knv3) write(nfout,*) '**warn mm should be knv3**'
  end if

end subroutine kpmsf0

subroutine kpmwbz0(paramset,nfout,altv,rltv,ksm,knv3,kv3,vkxyz,qwgt)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: kpmwbz0
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : BUCS, CARTS, CRDTYP, DP
  implicit none
  logical, intent(in)       :: paramset
  integer, intent(in)       :: nfout
  real(kind=DP), intent(in) :: altv(3,3), rltv(3,3)
  integer, intent(in)       :: ksm(3,2)
  integer, intent(in)       :: knv3
  integer, intent(out)      :: kv3
  real(kind=DP), intent(out):: vkxyz(knv3,3,CRDTYP)
  real(kind=DP), intent(out):: qwgt(knv3)

  real(kind=DP)             :: dgv(3),fv123(3),dfv(3)
  integer                   :: i1,i2,i3

  if(ksm(1,1) == 0 &
       & .or. (     ksm(1,2) == 0 &
       &      .and. ksm(2,2) == 0 &
       &      .and. ksm(3,2) == 0)&
       ) then
     kv3 = 1
     if(paramset) return
     vkxyz(1,1:3,CARTS) = 0.d0
     return
  endif

  if(ksm(1,2) == 0) call phase_error_with_msg(nfout," ksm(1,2) == 0",__LINE__,__FILE__)
  if(ksm(2,2) == 0) call phase_error_with_msg(nfout," ksm(2,2) == 0",__LINE__,__FILE__)
  if(ksm(3,2) == 0)  call phase_error_with_msg(nfout," ksm(3,2) == 0",__LINE__,__FILE__)

  dfv(1:3) = 1.d0/(ksm(1:3,1)*2)
  kv3 = 0
  dgv = 0.5d0 * matmul(rltv,dfv)

  do i1 = 1, ksm(1,2)
     fv123(1) = (i1-ksm(1,1)-1)*dfv(1)
     do i2 = 1, ksm(2,2)
        fv123(2) = (i2-ksm(2,1)-1)*dfv(2)
        do i3 = 1, ksm(3,2)
           fv123(3) = (i3-ksm(3,1)-1)*dfv(3)
           kv3 = kv3 + 1
           if(.not.paramset .and. kv3 <= knv3) then
              vkxyz(kv3,1:3,CARTS) = matmul(rltv,fv123) + dgv
           end if
        end do
     end do
  end do

  if(.not.paramset) then
     qwgt(1:kv3) = 1.d0/kv3
  end if

  write(nfout,*) 'number of generated k-points=',kv3
  if(kv3 /= knv3) write(nfout,*) '**warning mm should be knv3**'
end subroutine kpmwbz0

subroutine sccm0(paramset,nfout,altv,rltv,ksm,knv3,kv3,vkxyz,qwgt)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: sccm0
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : BUCS, CARTS, CRDTYP, DP, PAI2
  implicit none
  logical, intent(in)       :: paramset
  integer, intent(in)       :: nfout
  real(kind=DP), intent(in) :: altv(3,3), rltv(3,3)
  integer, intent(in)       :: ksm(3,2)
  integer, intent(in)       :: knv3
  integer, intent(out)      :: kv3
  real(kind=DP), intent(out):: vkxyz(knv3,3,CRDTYP)
  real(kind=DP), intent(out):: qwgt(knv3)

  real(kind=DP)             :: h0, swgt, wgt, q(3), b
  integer                   :: ikx, iky, ikz, iq

  if(.not.paramset) b = PAI2/(altv(1,1)*2)

  h0   = 1.0d0/ksm(1,1)
  swgt = 0.0d0
  kv3  = 0

  do ikx = 0, ksm(1,1) !nkx
     q(1) = ikx*h0
     do iky = 0, ikx
        q(2) = iky*h0
        do ikz = 0,iky
           q(3) = ikz*h0
           iq = 1
           if(ikz == 0) then
              if(ikx == iky) then
                 if(ikx == 0) then
                    iq=48
                 else if(ikx == ksm(1,1)) then
                    iq=16
                 else
                    iq=4
                 end if
              else if(iky.eq.0) then
                 if(ikx.eq.ksm(1,1)) then
                    iq=16
                 else
                    iq=8
                 end if
              else if(ikx == ksm(1,1)) then
                 iq=4
              else
                 iq=2
              end if
           else if(ikx == iky) then
              if(ikz == ikx) then
                 if(ikz == ksm(1,1)) then
                    iq=48
                 else
                    iq=6
                 end if
              else if(ikx.eq.ksm(1,1)) then
                 iq=8
              else
                 iq=2
              end if
           else if(iky == ikz) then
              if(ikx == ksm(1,1)) then
                 iq=4
              else
                 iq=2
              end if
           else if(ikx == ksm(1,1)) then
              iq=2
           else
              iq=1
           end if
           wgt=48.0d0/(8.d0*iq*ksm(1,1)**3)
           swgt=swgt+wgt
           kv3 = kv3 + 1
!----*----*   for parameter setting 5th June '94 by Y.M.
           if(.not.paramset .and. kv3 <= knv3) then
              vkxyz(kv3,1:3,CARTS) = q(1:3)*b
              qwgt (kv3)           = wgt
           end if
!----*----*
        end do
     end do
  end do
  write(nfout,201) kv3,swgt
  201 format('  nktot =',i5/'  swgt  =',f20.16)
end subroutine sccm0

subroutine bccm0(paramset,nfout,altv,rltv,ksm,knv3,kv3,vkxyz,qwgt)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: bccm0
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : BUCS, CARTS, CRDTYP, DP, PAI2
  implicit none
  logical, intent(in)       :: paramset
  integer, intent(in)       :: nfout
  real(kind=DP), intent(in) :: altv(3,3), rltv(3,3)
  integer, intent(in)       :: ksm(3,2)
  integer, intent(in)       :: knv3
  integer, intent(out)      :: kv3
  real(kind=DP), intent(out):: vkxyz(knv3,3,CRDTYP)
  real(kind=DP), intent(out):: qwgt(knv3)

  integer      :: nkxh, nkx, ikx,iky,ikz,iq
  real(kind=DP) :: h0, swgt, wgt, q(3), b

  if(.not.paramset) b = PAI2/(altv(1,1)*2)

  nkxh = ksm(1,1)/2
  nkx  = nkxh+nkxh
  h0=1.0d0/nkx
  swgt=0.0d0
  KV3=0
  Loop_ikx :do ikx = 0, nkx
     q(1) = ikx*h0
     do iky = 0,ikx
        if(ikx+iky > nkx) cycle Loop_ikx
        q(2) = iky*h0
        do ikz = 0,iky
           q(3) = ikz*h0
           iq = 1
           if(ikz == 0) then
              if(ikx == iky) then
                 if(ikx == 0) then
                    iq=48
                 else if(ikx == nkxh) then
                    iq=8
                 else
                    iq=4
                 end if
              else if(iky == 0) then
                 if(ikx == nkx) then
                    iq=48
                 else
                    iq=8
                 end if
              else if(ikx+iky == nkx) then
                 iq=4
              else
                 iq=2
              end if
           else if(ikx == iky) then
              if(ikz == ikx) then
                 if(ikz == nkxh) then
                    iq=24
                 else
                    iq=6
                 end if
              else if(ikx == nkxh) then
                 iq=4
              else
                 iq=2
              end if
           else if(iky == ikz) then
              if(ikx+iky == nkx) then
                 iq=6
              else
                 iq=2
              end if
           else if(ikx+iky == nkx) then
              iq=2
           else
              iq=1
           end if
           wgt=48.0d0/dble(2*iq*nkx*nkx*nkx)
           swgt=swgt+wgt
           kv3=kv3+1
!----*----*   for parameter setting 5th June '94 by Y.M.
           if(.not.paramset .and. kv3 <= knv3) then
              Vkxyz(1:3,KV3,CARTS)=Q(1:3)*b
              qwgt(kv3)=wgt
            end if
!----*----*
         end do
      end do
  end do Loop_ikx
  write(nfout,201) kv3,swgt
201 format('  kv3 =',i5/'  swgt  =',d20.13)
end subroutine bccm0

subroutine fccm0(paramset,nfout,altv,rltv,ksm,knv3,kv3,vkxyz,qwgt)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: fccm0
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : BUCS, CARTS, CRDTYP, DP, PAI2
  implicit none
  logical, intent(in)       :: paramset
  integer, intent(in)       :: nfout
  real(kind=DP), intent(in) :: altv(3,3), rltv(3,3)
  integer, intent(in)       :: ksm(3,2)
  integer, intent(in)       :: knv3
  integer, intent(out)      :: kv3
  real(kind=DP), intent(out):: vkxyz(knv3,3,CRDTYP)
  real(kind=DP), intent(out):: qwgt(knv3)

  real(kind=DP) :: q(3),qw, h0, swgt, wgt, b
  integer       :: nkxh, nkxq, nkxh3, nkxq3, nkx,ikx,iky,ikz

!!$  print *,' altv(1,1) = ', altv(1,1)
  h0 = (altv(1,1) + altv(2,1) + altv(3,1))*0.5
  if(.not.paramset) b = PAI2/(h0*2)
  NKXH=ksm(1,1)/2
  NKXQ=NKXH/2
  if(nkxq == 0) then
     print '(" ksm(1,1) = ",i4," nkxh = ",i4," nkxq = ",i4)', ksm(1,1),nkxh,nkxq
     call phase_error_with_msg(nfout,' !! ksm(1,1) should be larger or equal to 4',__LINE__,__FILE__)
  end if
  NKXH=NKXQ+NKXQ
  NKX=NKXH+NKXH
  NKXH3=NKXH+NKXH+NKXH
  NKXQ3=NKXQ+NKXQ+NKXQ
  print *,' nkxh = ', nkxh, ' nkx = ', nkx,' nkxh3 = ', nkxh3, ' nkxq3 = ', nkxq3
  H0=1.0D0/DBLE(NKX)
  SWGT=0.0D0


  KV3=0
  do ikx = 0,nkx
     q(1) = ikx*h0
     Loop_iky :do iky = 0,ikx
        q(2) = iky*h0
        do ikz = 0,iky
           if(ikx+iky+ikz.gt.nkxh3) cycle Loop_iky
           q(3) = ikz*h0
           qw = 1.d0
           if(ikz == 0) then
              if(iky == 0) then
                 if(ikx == 0) then
                    qw=1.0d0
                 else if(ikx == nkx) then
                    qw=3.d0
                 else
                    qw=6.0d0
                 end if
              else if(ikx == iky) then
                 if(ikx == nkxq3) then
                    qw=3.5d0
                 else
                    qw=12.0d0
                 end if
              else if(ikx == nkx) then
                 if (iky == nkxh) then
                    qw=6.0d0
                 else
                    qw=12.0d0
                 end if
              else if(ikx+iky == nkxh3) then
                 qw=7.0d0
              else
                 qw=24.0d0
              end if
           else if(ikx == iky) then
              if(ikz == ikx) then
                 if(ikz == nkxh) then
                    qw=4.0d0
                 else
                    qw=8.0d0
                 end if
              else if(ikx+ikx+ikz == nkxh3) then
                 qw=12.0d0
              else
                 qw=24.0d0
              end if
           else if(ikx == nkx) then
              if(iky == ikz) then
                 if(iky == nkxq) then
                    qw=8.5d0
                 else
                    qw=12.0d0
                 end if
              else if(iky+ikz == nkxh) then
                 qw=17.0d0
              else
                 qw=24.0d0
              end if
           else if(iky == ikz) then
              if(ikx+iky+iky == nkxh3) then
                 qw=12.0d0
              else
                 qw=24.0d0
              end if
           else if(ikx+iky+ikz == nkxh3) then
              qw=24.0d0
           else
              qw=48.0d0
           end if
           wgt=qw/dble(4*nkx*nkx*nkx)
           swgt=swgt+wgt
           kv3=kv3+1
!----*----*   for parameter setting 5th June '94 by Y.M.
           if(.not.paramset .and. kv3 <= knv3) then
              vkxyz(kv3,1:3,CARTS) = q(1:3)*b
              qwgt(kv3)=wgt
           end if
!----*----*
        end do
     end do Loop_iky
  end do
  write(nfout,201) kv3,swgt
201 FORMAT('  KV3 =',I5/'  SWGT  =',D20.13)
end subroutine fccm0

subroutine hexm0(paramset,nfout,altv,rltv,ksm,knv3,kv3,vkxyz,qwgt)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: hexm0
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : BUCS, CARTS, CRDTYP, DP
  implicit none
  logical, intent(in)       :: paramset
  integer, intent(in)       :: nfout
  real(kind=DP), intent(in) :: altv(3,3), rltv(3,3)
  integer, intent(in)       :: ksm(3,2)
  integer, intent(in)       :: knv3
  integer, intent(out)      :: kv3
  real(kind=DP), intent(out):: vkxyz(knv3,3,CRDTYP)
  real(kind=DP), intent(out):: qwgt(knv3)

  real(kind=DP) :: q(3), hx, hy, wgt, swgt
  integer       :: nkxh, nkytth, nkyh, ikx, iky, ikz, iq

  if((mod(ksm(1,1),2) /= 0) .or. (mod(ksm(2,1),6) /= 0)) then
     write(nfout,*) ' ksm(1,1), ksm(2,1) err , ksm(1:2,1) =' &
          &,ksm(1,1),ksm(2,1)
     call phase_error_with_msg(nfout,'ksm(1,1), ksm(2,1) err',__LINE__,__FILE__)
  end if
  nkxh   = ksm(1,1)/2
  nkytth = (ksm(2,1)/3)*2
  nkyh   =  ksm(2,1)/2
  hx=1.0d0/ksm(1,1)
  hy=1.0d0/ksm(2,1)
  swgt=0.0d0
  kv3=0
  do ikx = 0, nkxh
     q(1) = ikx*hx
     do iky = 0,nkytth
        q(2) = iky*hy
        do ikz = 0,iky
           if((iky > ikz*2).or.(iky > ksm(2,1)-ikz)) cycle
           q(3) = ikz*hy
           iq = 1
           if((ikx == 0).or.(ikx == nkxh)) then
              if(iky == ikz) then
                 if(iky == 0) then
                    iq=24
                 else if(iky == nkyh) then
                    iq=8
                 else
                    iq=4
                 end if
              else if(iky == 2*ikz) then
                 if(iky == nkytth) then
                    iq=12
                 else
                    iq=4
                 end if
              else if(iky == ksm(2,1)-ikz) then
                 iq=4
              else
                 iq=2
              end if
           else
              if(iky == ikz) then
                 if(iky == 0) then
                    iq=12
                 else if(iky == nkyh) then
                    iq=4
                 else
                    iq=2
                 end if
              else if(iky == 2*ikz) then
                 if(iky == nkytth) then
                    iq=6
                 else
                    iq=2
                 end if
              else if(iky == ksm(2,1)-ikz) then
                 iq=2
              else
                 iq=1
              end if
           end if
!!$           wgt=24.0d0/(iq*ksm(1,1)*ksm(2,1)*ksm(2,1))
           wgt = 24.d0/(iq*product(ksm(1:3,1)))
           swgt=swgt+wgt
           kv3=kv3+1
!----*----*   for parameter setting 5th June '94 by Y.M.
           if(.not.paramset  .and. kv3 <= knv3) then
              vkxyz(kv3,1:3,CARTS) = matmul(rltv,q)
              qwgt(kv3) = wgt
           end if
!----*----*
        end do
     end do
  end do
  write(nfout,201) kv3,swgt
201 format('  kv3 =',i5/'  swgt  =',f20.16)
end subroutine hexm0

subroutine read_nkpnt(str,len_str,ikpnt)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: read_nkpnt
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  implicit none
  integer,             intent(in)  :: len_str
  character(len=len_str), intent(in)  :: str
  integer,             intent(out) :: ikpnt

  logical :: tf
  integer :: ic = 1

  call strncmp2(str,len_str,'nkpoints',8,tf)
  if(tf) then
     print *,' str(ic:len_str) = ',str(ic:len_str)
     call skip2next(str,len_str,'n',ic)
     print *,' str(ic:len_str) = ',str(ic:len_str)
     read(str(ic:len_str),*) ikpnt
  else
     call phase_error_with_msg(6,' invalid input of nkpoints',__LINE__,__FILE__)
  end if
end subroutine read_nkpnt

subroutine ch4ksample(str,len_str,way_ksample)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: ch4ksample
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : NONAME,MESH, SKPS_DIRECT_IN &
       &, GAMMA, FILE, MONKHORST_PACK
  implicit none
  character(len=*),  intent(in) :: str
  integer,        intent(in) :: len_str
  integer,        intent(out):: way_ksample

  logical :: tf
  integer :: ic

  call strncmp2(str,len_str,'way_ksample',11,tf)
  if(tf) then
     call skip2next(str,len_str,'W',ic)
     if(str(ic:ic) == 'm' .or. str(ic:ic) == 'M') then
         if(str(ic+1:ic+1) == 'o' .or. str(ic+1:ic+1) == 'O') then
            way_ksample = MONKHORST_PACK
         else if(str(ic+1:ic+1) == 'e' .or. str(ic+1:ic+1) == 'E') then
            way_ksample = MESH
         end if
     else if(str(ic:ic) == 's' .or. str(ic:ic) == 'S') then
        way_ksample = SKPS_DIRECT_IN
     else if(str(ic:ic) == 'g' .or. str(ic:ic) == 'G') then
        way_ksample = GAMMA
     else if(str(ic:ic) == 'f' .or. str(ic:ic) == 'F') then
        way_ksample = FILE
     endif
  else
     way_ksample = NONAME
  endif
end subroutine ch4ksample

subroutine read_coordsystem(str,len_str,sw_k_coord_system)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: read_coordsystem
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : NODATA, CARTS, BUCS
  implicit none
  integer,         intent(in)  :: len_str
  character(len=len_str), intent(in)  :: str
  integer,         intent(out) :: sw_k_coord_system

  logical      :: tf

  sw_k_coord_system = NODATA
  call strncmp2(str,len_str,'k_coord_system',14,tf)
  if(tf) then
     call strncmp2(str,len_str,'pucv',4,tf)
     if(tf) then
        sw_k_coord_system = BUCS
        goto 1001
     endif
     call strncmp2(str,len_str,'bucs',4,tf)
     if(tf) then
        sw_k_coord_system = BUCS
        goto 1001
     end if
     call strncmp2(str,len_str,'cart',4,tf)
     if(tf) then
        sw_k_coord_system = CARTS
     end if
  end if
1001 continue
end subroutine read_coordsystem


subroutine gnrt_k0(nbztyp_spg,altv,nx,ny,nz &
                   & ,paramset,nfout,ipri,knv3 &
                   & ,rltv,kv3,vkxyz,qwgt,nfkpgn,nfspg,ipri_kp,ipri_spg, itrs )
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: gnrt_k0
!
!  AUTHOR(S): H. Mizouchi   February/25/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : CARTS, CRDTYP, DP &
       &                       , WHOLE_BZ, SIMPLE_CUBIC &
       &                       , BCC, FCC, DIAMOND, HEXAGONAL &
       &                       , GENERAL, GENERAL_LARGER 
  implicit none
  logical, intent(in)        :: paramset
  integer, intent(in)        :: nfout, ipri, knv3 &
       &                      , nfkpgn,nfspg,ipri_kp,ipri_spg, itrs 
  real(kind=DP), intent(in)  :: rltv(3,3),altv(3,3)
  integer, intent(out)       :: kv3
  real(kind=DP), intent(out) :: vkxyz(knv3,3,CRDTYP),qwgt(knv3)

  integer                    :: nn,nk,nw,nwei,nv(3)

  real(kind=DP), pointer, dimension(:,:) :: trmat,trbp,trpb,mat1,mat2 
  integer   :: np2,np1,np0
  integer   :: nxx0,nyy0,nzz0,nxx,nyy,nzz
  integer   :: nbztyp_spg,nx,ny,nz
  integer :: lmnp0, lmnp1, lmnp2
!!$  integer :: idim, il, ngen, inv
  integer :: il
  integer :: nx1, ny1, nz1, nd
  real(kind=DP), pointer, dimension(:,:) :: pa0_wk,pb0_wk,pb_wk 
  integer,       pointer, dimension(:,:) :: ka0_wk,ka2_wk
  integer,       pointer, dimension(:)   :: ip10_wk,ip02_wk,ip12_wk &
   &                                       ,ip01_wk,ip21_wk,iu21_wk,iv21_wk,nstar2_wk &
   &                                       ,ip20_wk

  if(nbztyp_spg == GENERAL .or.nbztyp_spg == GENERAL_LARGER) then
      rewind nfkpgn
      read(nfkpgn,*) nxx0,nyy0,nzz0
      write(6,*) 'nxx0,nyy0,nzz0 desu', nxx0,nyy0,nzz0

      rewind nfspg
      read(nfspg,*) nn
      read(nfspg,*) 
!!$      read(nfspg,*) idim, il, ngen, inv
      read(nfspg,*) nw, il, nk, nn

      call nskma0(il,nxx0,nyy0,nzz0,nxx,nyy,nzz,nx1,ny1,nz1,nd)         
      lmnp0=(nxx+1)*(nyy+1)*(nzz+1)
      lmnp1=lmnp0
      lmnp2=lmnp0

      allocate(ip10_wk(lmnp0))  ; ip10_wk = 0        
      allocate(ip20_wk(lmnp0))  ; ip20_wk = 0        
      allocate(ip01_wk(lmnp1))    ; ip01_wk = 0
      allocate(ip02_wk(lmnp2))    ; ip02_wk = 0
      allocate(ip21_wk(lmnp1))    ; ip21_wk = 0
      allocate(ip12_wk(lmnp2))    ; ip12_wk = 0
      allocate(iu21_wk(lmnp1))    ; iu21_wk = 0
      allocate(iv21_wk(lmnp1))    ; iv21_wk = 0
      allocate(nstar2_wk(lmnp2))  ; nstar2_wk = 0
      allocate(pa0_wk(3,lmnp0))  ; pa0_wk = 0
      allocate(pb0_wk(3,lmnp0))  ; pb0_wk = 0
      allocate(pb_wk(3,lmnp2))  ; pb_wk = 0
      allocate(ka0_wk(4,lmnp0))  ; ka0_wk = 0
      allocate(ka2_wk(4,lmnp2))  ; ka2_wk = 0


      call setkp0(np2,np1,np0,lmnp0,lmnp1,lmnp2 &
                & ,nxx0,nyy0,nzz0,nxx,nyy,nzz &
                & ,ip10_wk,ip20_wk,ip01_wk,ip02_wk,ip21_wk,ip12_wk &
                & ,iu21_wk,iv21_wk &
                & ,nstar2_wk,pa0_wk,pb0_wk,pb_wk,ka0_wk,ka2_wk &
                & ,nfspg,ipri_kp,ipri_spg, itrs )

  else

      if(nbztyp_spg.eq.SIMPLE_CUBIC) il = 1
      if(nbztyp_spg.eq.BCC) il = 3
      if(nbztyp_spg.eq.FCC) il = 2
      if(nbztyp_spg.eq.DIAMOND) il = 2
      if(nbztyp_spg.eq.HEXAGONAL) il = 0

      call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)

      lmnp0=(nxx+1)*(nyy+1)*(nzz+1)
      lmnp1=lmnp0
      lmnp2=lmnp0

      allocate(ip10_wk(lmnp0))  ; ip10_wk = 0        
      allocate(ip20_wk(lmnp0))  ; ip20_wk = 0        
      allocate(ip01_wk(lmnp1))    ; ip01_wk = 0
      allocate(ip02_wk(lmnp2))    ; ip02_wk = 0
      allocate(ip21_wk(lmnp1))    ; ip21_wk = 0
      allocate(ip12_wk(lmnp2))    ; ip12_wk = 0
      allocate(iu21_wk(lmnp1))    ; iu21_wk = 0
      allocate(iv21_wk(lmnp1))    ; iv21_wk = 0
      allocate(nstar2_wk(lmnp2))  ; nstar2_wk = 0
      allocate(pa0_wk(3,lmnp0))  ; pa0_wk = 0
      allocate(pb0_wk(3,lmnp0))  ; pb0_wk = 0
      allocate(pb_wk(3,lmnp2))  ; pb_wk = 0
      allocate(ka0_wk(4,lmnp0))  ; ka0_wk = 0
      allocate(ka2_wk(4,lmnp2))  ; ka2_wk = 0

      call setkp0_default(nbztyp_spg,altv,nx,ny,nz &
                  & ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
                  & ,nxx,nyy,nzz &
                  & ,ip10_wk,ip20_wk,ip01_wk,ip02_wk,ip21_wk,ip12_wk &
                  & ,iu21_wk,iv21_wk &
                  & ,nstar2_wk,pa0_wk,pb0_wk,pb_wk,ka0_wk,ka2_wk &
                  & ,ipri_kp,ipri_spg, itrs )

  end if

  kv3 = np2
  nwei = np1


  if(paramset) then
     deallocate(ip10_wk)
     deallocate(ip20_wk)
     deallocate(ip01_wk)
     deallocate(ip02_wk)
     deallocate(ip21_wk)
     deallocate(ip12_wk)
     deallocate(iu21_wk)
     deallocate(iv21_wk)
     deallocate(nstar2_wk)
     deallocate(pa0_wk)
     deallocate(pb0_wk)
     deallocate(pb_wk)
     deallocate(ka0_wk)
     deallocate(ka2_wk)
     return
  endif

  allocate(trmat(3,3))
  allocate(trbp(3,3))
  allocate(trpb(3,3))
  allocate(mat1(3,3))
  allocate(mat2(3,3))

  call get_trmat1  !-(contained here) ->(trmat)

  do nn = 1, kv3
     nv(1) = ka0_wk(1,ip02_wk(nn))
     nv(2) = ka0_wk(2,ip02_wk(nn))
     nv(3) = ka0_wk(3,ip02_wk(nn))
     nk = ka0_wk(4,ip02_wk(nn))
     nw = nstar2_wk(nn)
     vkxyz(nn,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
     qwgt(nn) = dble(nw)/dble(nwei)
  enddo

  deallocate(trmat)
  deallocate(trbp )
  deallocate(trpb )
  deallocate(mat1 )
  deallocate(mat2 )


  deallocate(ip10_wk)
  deallocate(ip20_wk)
  deallocate(ip01_wk)
  deallocate(ip02_wk)
  deallocate(ip21_wk)
  deallocate(ip12_wk)
  deallocate(iu21_wk)
  deallocate(iv21_wk)
  deallocate(nstar2_wk)
  deallocate(pa0_wk)
  deallocate(pb0_wk)
  deallocate(pb_wk)
  deallocate(ka0_wk)
  deallocate(ka2_wk)



  if(ipri >= 2) then
     write(nfout,'(/,"  << gnrt_k0 >>")')
     write(nfout,*) ' !Total Generated Kpoints = ',kv3
     do nk = 1, kv3
        write(nfout,'(i4," ",3f12.6)') nk,(vkxyz(nk,nn,CARTS),nn=1,3)
     end do
  end if
contains
  subroutine get_trmat1
!    make translation matrix  trpb (P -> B)
    integer  :: i
    real(DP)           :: tab(3,3),ta1(3,48)
    integer            :: ng1,lra1(3,3,48)

!! setspg  !!

  if(nbztyp_spg == 100 .or.nbztyp_spg == 101) then
      call setspg(tab,ng1,ta1,lra1,nfspg,ipri_spg)

  else
     call setspg_default(nbztyp_spg,altv,tab,ng1,ta1,lra1,ipri_spg)
  end if

!     make translation matrix  trpb (P -> B)
  do i = 1,3
     trbp(i,1) = tab(i,1)
     trbp(i,2) = tab(i,2)
     trbp(i,3) = tab(i,3)
  end do
    goto 2

1   trbp = 0.d0
    do i = 1,3
       trbp(i,i) = 1.d0
    enddo

2   continue
    call inver3n(3,trbp,trpb)

    mat1 = transpose(trpb)
    call inver3n(3,mat1,mat2)
    call matpr3(rltv,mat2,trmat)

  end subroutine get_trmat1
end subroutine gnrt_k0


! -- subroutine gnrt_k0_n ---------------------

! ================================== modified by K. Tagami ================ 12.0A
!subroutine gnrt_k0_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
!      &              , nbztyp_spg,nx,ny,nz &
!      &              , paramset,nfout,ipri,knv3,rltv &
!      &              , kv3,vkxyz,qwgt,ipri_kp,trmat_out)
subroutine gnrt_k0_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
      &              , nbztyp_spg,nx,ny,nz &
      &              , paramset,nfout,ipri,knv3,rltv &
      &              , kv3,vkxyz,qwgt,ipri_kp,trmat_out, &
      &                gen_tetramesh_mode, use_altv_rltv, altv, itrs, &
      &                gen_name_in_carts, &
      &                knv3_fbz, kv3_fbz, vkxyz_fbz, to_ibz_from_fbz_for_kpoint )
! =========================================================================== 12.0A

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: gnrt_k0_n
!
!  AUTHOR(S): T. Yamasaki   May/31/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : CARTS, CRDTYP, DP &
       &                       , WHOLE_BZ, SIMPLE_CUBIC &
       &                       , BCC, FCC, DIAMOND, HEXAGONAL &
       &                       , GENERAL, GENERAL_LARGER 
  implicit none
  integer, intent(in) ::        il,ngen,inv
  integer, intent(in) ::        igen(ngen),jgen(2,3,ngen)
  real(kind=DP), intent(in) ::  a,b,c,ca,cb,cc
  integer, intent(in) ::        nbztyp_spg
  integer, intent(in) ::        nx,ny,nz
  real(kind=DP), intent(in)  :: rltv(3,3)
  logical, intent(in) ::        paramset
  integer, intent(in) ::        nfout, ipri, knv3 &
       &                      , ipri_kp
  integer, intent(out)       :: kv3
  real(kind=DP), intent(out) :: vkxyz(knv3,3,CRDTYP),qwgt(knv3),trmat_out(3,3)

! ======================================== added by K. Tagami =========== 12.0A
  integer, intent(in) :: gen_tetramesh_mode
  integer, intent(in) :: itrs
  logical, intent(in) :: use_altv_rltv, gen_name_in_carts
  real(kind=DP), intent(in) :: altv(3,3)
! ======================================================================== 12.0A

! === KT_add === 2014/09/30
  integer, intent(in)        :: knv3_fbz
  integer, intent(out)       :: kv3_fbz
  real(kind=DP), intent(out) :: vkxyz_fbz(knv3_fbz,3,CRDTYP)
  integer, intent(out) :: to_ibz_from_fbz_for_kpoint(knv3_fbz)
! ============== 2014/09/30

  integer                    :: nn,nk,nw,nwei,nv(3),ix,iy,iz, iix,iiy,iiz,npx,npy
  integer :: icub, ni, ip0, kx,ky,kz
  integer, dimension(8) :: ip8

  real(kind=DP), pointer, dimension(:,:) :: trmat,trbp,trpb,mat1,mat2 
  integer :: np2,np1,np0
  integer :: nxx0,nyy0,nzz0,nxx,nyy,nzz
  integer :: lmnp0, lmnp1, lmnp2
  integer :: nx1, ny1, nz1, nd
  real(kind=DP), pointer, dimension(:,:) :: pa0_wk,pb0_wk,pb_wk 
  integer,       pointer, dimension(:,:) :: ka0_wk,ka2_wk
  integer,       pointer, dimension(:)   :: ip10_wk,ip02_wk,ip12_wk &
   &                                       ,ip01_wk,ip21_wk,iu21_wk,iv21_wk,nstar2_wk &
   &                                       ,ip20_wk

  if(ipri_kp >=2 ) write(nfout,'(" <<gnrt_k0_n>>")')

  if(nbztyp_spg == GENERAL .or.nbztyp_spg == GENERAL_LARGER) then
     nxx0 = nx; nyy0 = ny; nzz0 = nz 
     write(6,*) 'nxx0,nyy0,nzz0 desu', nxx0,nyy0,nzz0

     call nskma0(il,nxx0,nyy0,nzz0,nxx,nyy,nzz,nx1,ny1,nz1,nd)         
     lmnp0=(nxx+1)*(nyy+1)*(nzz+1)
     lmnp1=lmnp0
     lmnp2=lmnp0

     allocate(ip10_wk(lmnp0))  ; ip10_wk = 0        
     allocate(ip20_wk(lmnp0))  ; ip20_wk = 0        
     allocate(ip01_wk(lmnp1))    ; ip01_wk = 0
     allocate(ip02_wk(lmnp2))    ; ip02_wk = 0
     allocate(ip21_wk(lmnp1))    ; ip21_wk = 0
     allocate(ip12_wk(lmnp2))    ; ip12_wk = 0
     allocate(iu21_wk(lmnp1))    ; iu21_wk = 0
     allocate(iv21_wk(lmnp1))    ; iv21_wk = 0
     allocate(nstar2_wk(lmnp2))  ; nstar2_wk = 0
     allocate(pa0_wk(3,lmnp0))  ; pa0_wk = 0
     allocate(pb0_wk(3,lmnp0))  ; pb0_wk = 0
     allocate(pb_wk(3,lmnp2))  ; pb_wk = 0
     allocate(ka0_wk(4,lmnp0))  ; ka0_wk = 0
     allocate(ka2_wk(4,lmnp2))  ; ka2_wk = 0

! === KT_mod === 2015/02/16
!     call setkp0_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc  &
!          &          ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
!          &          ,nxx0,nyy0,nzz0,nxx,nyy,nzz &
!          &          ,ip10_wk,ip20_wk,ip01_wk,ip02_wk,ip21_wk,ip12_wk &
!          &          ,iu21_wk,iv21_wk &
!          &          ,nstar2_wk,pa0_wk,pb0_wk,pb_wk,ka0_wk,ka2_wk &
!          &          ,ipri_kp)
!
     if ( gen_tetramesh_mode == 0 ) then
        call setkp0_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc  &
             &          ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
             &          ,nxx0,nyy0,nzz0,nxx,nyy,nzz &
             &          ,ip10_wk,ip20_wk,ip01_wk,ip02_wk,ip21_wk,ip12_wk &
             &          ,iu21_wk,iv21_wk &
             &          ,nstar2_wk,pa0_wk,pb0_wk,pb_wk,ka0_wk,ka2_wk &
             &          ,ipri_kp, itrs )
     else if ( gen_tetramesh_mode == 1 ) then
        call setkp0_n_kt(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc  &
             &          ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
             &          ,nxx0,nyy0,nzz0,nxx,nyy,nzz &
             &          ,ip10_wk,ip20_wk,ip01_wk,ip02_wk,ip21_wk,ip12_wk &
             &          ,iu21_wk,iv21_wk &
             &          ,nstar2_wk,pa0_wk,pb0_wk,pb_wk,ka0_wk,ka2_wk &
             &          ,ipri_kp, &
             &           use_altv_rltv, altv, rltv, itrs, &
             &           gen_name_in_carts )
     endif

  else

     call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)

     lmnp0=(nxx+1)*(nyy+1)*(nzz+1)
     lmnp1=lmnp0
     lmnp2=lmnp0

     allocate(ip10_wk(lmnp0))  ; ip10_wk = 0        
     allocate(ip20_wk(lmnp0))  ; ip20_wk = 0        
     allocate(ip01_wk(lmnp1))    ; ip01_wk = 0
     allocate(ip02_wk(lmnp2))    ; ip02_wk = 0
     allocate(ip21_wk(lmnp1))    ; ip21_wk = 0
     allocate(ip12_wk(lmnp2))    ; ip12_wk = 0
     allocate(iu21_wk(lmnp1))    ; iu21_wk = 0
     allocate(iv21_wk(lmnp1))    ; iv21_wk = 0
     allocate(nstar2_wk(lmnp2))  ; nstar2_wk = 0
     allocate(pa0_wk(3,lmnp0))  ; pa0_wk = 0
     allocate(pb0_wk(3,lmnp0))  ; pb0_wk = 0
     allocate(pb_wk(3,lmnp2))  ; pb_wk = 0
     allocate(ka0_wk(4,lmnp0))  ; ka0_wk = 0
!!$     allocate(ka2_wk(4,lmnp2))  ; ka2_wk = 0

! ===================================== modified by K. Tagami ========= 12.0A
!     call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
!          & ,nx,ny,nz &
!          & ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
!          & ,nxx,nyy,nzz &
!          & ,ip10_wk,ip20_wk,ip01_wk,ip02_wk,ip21_wk,ip12_wk &
!          & ,iu21_wk,iv21_wk &
!          & ,nstar2_wk,pa0_wk,pb0_wk,pb_wk,ka0_wk &
!          & ,ipri_kp)
!
     if ( gen_tetramesh_mode == 0 ) then
        call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
             & ,nx,ny,nz &
             & ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
             & ,nxx,nyy,nzz &
             & ,ip10_wk,ip20_wk,ip01_wk,ip02_wk,ip21_wk,ip12_wk &
             & ,iu21_wk,iv21_wk &
             & ,nstar2_wk,pa0_wk,pb0_wk,pb_wk,ka0_wk &
             & ,ipri_kp, itrs )
     else if ( gen_tetramesh_mode == 1 ) then
        call setkp0_default_n_kt(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
             & ,nx,ny,nz &
             & ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
             & ,nxx,nyy,nzz &
             & ,ip10_wk,ip20_wk,ip01_wk,ip02_wk,ip21_wk,ip12_wk &
             & ,iu21_wk,iv21_wk &
             & ,nstar2_wk,pa0_wk,pb0_wk,pb_wk,ka0_wk &
             & ,ipri_kp, &
             &  use_altv_rltv, altv, rltv, itrs, &
             &  gen_name_in_carts )
     else if ( gen_tetramesh_mode == 2 ) then
        call setkp0_default_n_kt2(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
             & ,nx,ny,nz &
             & ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
             & ,nxx,nyy,nzz &
             & ,ip10_wk,ip20_wk,ip01_wk,ip02_wk,ip21_wk,ip12_wk &
             & ,iu21_wk,iv21_wk &
             & ,nstar2_wk,pa0_wk,pb0_wk,pb_wk,ka0_wk &
             & ,ipri_kp, &
             &  use_altv_rltv, altv, rltv, itrs, &
             &  gen_name_in_carts )
     endif
! =========================================================================== 12.0A
  end if

  kv3 = np2
  nwei = np1

  kv3_fbz = np1

  if(paramset .and. ipri_kp >= 3) then
     allocate(trmat(3,3))
     allocate(trbp(3,3))
     allocate(trpb(3,3))
     allocate(mat1(3,3))
     allocate(mat2(3,3))

     call get_trmat1  !-(contained here) ->(trmat)

     write(nfout,'(" !! ALL vkxyz")')
     write(nfout,'(" !! nxx,nyy,nzz = ",3i8)') nxx,nyy,nzz
     do nn = 1, np0
        nv(1:3) = ka0_wk(1:3,nn)
        nk = ka0_wk(4,nn)
        ix = mod(nn-1,nxx+1)
        iy = mod((nn-ix-1)/(nxx+1),nyy+1)
        iz = (nn-ix-1-iy*(nxx+1))/((nxx+1)*(nyy+1))
        write(nfout,'(i6,6x,3f16.8,i6)') nn, matmul(trmat,nv)/dble(nk),ip20_wk(nn)
!!$        write(nfout,'(" vkxyz(1:3,",i5,") = (",3f10.6,") (",3i8,") (",3i8,") nk=",i8)') &
!!$             & nn,matmul(trmat,nv)/dble(nk), nv(1:3),ix*ny1*nz1,nx1*iy*nz1,nx1*ny1*iz,nk
     end do

     npx=nxx+1
     npy=nyy+1                                                                 
     icub = 0
     write(nfout,'(" tetrahedrons")')
     do iz = 0, nzz-1
        do iy = 0, nyy-1
           do ix = 0, nxx-1
              icub=icub+1
              ni=npx*(npy*iz+iy)+ix
              do kz=1,2
                 do ky=1,2
                    do kx=1,2
                       ip0 = ni+npx*(npy*(kz-1)+ky-1)+kx
                       ip8(kx+2*(ky-1)+4*(kz-1)) = ip0
                    end do
                 end do
              end do
!!$           write(nfout,'(" icub = ",i8)') icub
              write(nfout,'(i6," = ",i5,",",i5,",",i5,",",i5, "  (",i6,")" 8i5)') &
                   &                                            (icub-1)*6+1, ip8(1),ip8(2),ip8(4),ip8(8), icub, ip8(1:8)
              write(nfout,'(i6," = ",i5,",",i5,",",i5,",",i5)') (icub-1)*6+2, ip8(1),ip8(2),ip8(6),ip8(8)
              write(nfout,'(i6," = ",i5,",",i5,",",i5,",",i5)') (icub-1)*6+3, ip8(1),ip8(5),ip8(6),ip8(8)
              write(nfout,'(i6," = ",i5,",",i5,",",i5,",",i5)') (icub-1)*6+4, ip8(1),ip8(3),ip8(4),ip8(8)
              write(nfout,'(i6," = ",i5,",",i5,",",i5,",",i5)') (icub-1)*6+5, ip8(1),ip8(3),ip8(7),ip8(8)
              write(nfout,'(i6," = ",i5,",",i5,",",i5,",",i5)') (icub-1)*6+6, ip8(1),ip8(5),ip8(7),ip8(8)
!!$           do kz=1,2
!!$              do ky=1,2
!!$                 do kx=1,2
!!$                    ip0 = ni+npx*(npy*(kz-1)+ky-1)+kx
!!$                    iix = ix+kx-1
!!$                    iiy = iy+ky-1
!!$                    iiz = iz+kz-1
!!$                    write(nfout,'(" ip0 = ",i8,"   ->ip20 = ",i6,"   ka0_wk = ",4i6,"  (",3i6,")")') &
!!$                         & ip0,ip20_wk(ip0),ka0_wk(1:4,ip0),iix*ny1*nz1,nx1*iiy*nz1,nx1*ny1*iiz
!!$                    ip8(kx+2*(ky-1)+4*(kz-1)) = ip0
!!$                 end do
!!$              end do
!!$           end do
           end do
        end do
     end do
     write(nfout,'(" end of tetrahedrons")')
     deallocate(trmat)
     deallocate(trbp )
     deallocate(trpb )
     deallocate(mat1 )
     deallocate(mat2 )

  end if

  if(paramset) then
     deallocate(ip10_wk)
     deallocate(ip20_wk)
     deallocate(ip01_wk)
     deallocate(ip02_wk)
     deallocate(ip21_wk)
     deallocate(ip12_wk)
     deallocate(iu21_wk)
     deallocate(iv21_wk)
     deallocate(nstar2_wk)
     deallocate(pa0_wk)
     deallocate(pb0_wk)
     deallocate(pb_wk)
     deallocate(ka0_wk)
     return
  endif

  allocate(trmat(3,3))
  allocate(trbp(3,3))
  allocate(trpb(3,3))
  allocate(mat1(3,3))
  allocate(mat2(3,3))

  call get_trmat1  !-(contained here) ->(trmat)
  trmat_out = trmat

  do nn = 1, kv3
     nv(1) = ka0_wk(1,ip02_wk(nn))
     nv(2) = ka0_wk(2,ip02_wk(nn))
     nv(3) = ka0_wk(3,ip02_wk(nn))
     nk = ka0_wk(4,ip02_wk(nn))
     nw = nstar2_wk(nn)
     vkxyz(nn,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
     qwgt(nn) = dble(nw)/dble(nwei)
  end do

  Do nn=1, np1
     nv(1) = ka0_wk(1,ip01_wk(nn))
     nv(2) = ka0_wk(2,ip01_wk(nn))
     nv(3) = ka0_wk(3,ip01_wk(nn))
     nk = ka0_wk(4,ip01_wk(nn))
     vkxyz_fbz(nn,1:3,CARTS) = matmul(trmat,nv)/dble(nk)
     to_ibz_from_fbz_for_kpoint(nn) = ip21_wk(nn)
  End do

  deallocate(trmat)
  deallocate(trbp )
  deallocate(trpb )
  deallocate(mat1 )
  deallocate(mat2 )


  deallocate(ip10_wk)
  deallocate(ip20_wk)
  deallocate(ip01_wk)
  deallocate(ip02_wk)
  deallocate(ip21_wk)
  deallocate(ip12_wk)
  deallocate(iu21_wk)
  deallocate(iv21_wk)
  deallocate(nstar2_wk)
  deallocate(pa0_wk)
  deallocate(pb0_wk)
  deallocate(pb_wk)
  deallocate(ka0_wk)
  if(nbztyp_spg == GENERAL .or.nbztyp_spg == GENERAL_LARGER) deallocate(ka2_wk)

  if(ipri >= 2) then
     write(nfout,'(/,"  << gnrt_k0_n >>")')
     write(nfout,*) ' !Total Generated Kpoints = ',kv3
     do nk = 1, kv3
        write(nfout,'(i4," ",3f12.6)') nk,(vkxyz(nk,nn,CARTS),nn=1,3)
     end do
  end if
contains
  subroutine get_trmat1
!    make translation matrix  trpb (P -> B)

    call getspgtab(trbp)  ! spg+tetra

    call inver3n(3,trbp,trpb)

    mat1 = transpose(trpb)
    call inver3n(3,mat1,mat2)
    call matpr3(rltv,mat2,trmat)

  end subroutine get_trmat1
end subroutine gnrt_k0_n

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 593 $)
!
!  SUBROUINE: Finalization_of_mpi
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!      Further modification by T. Yamasaki and M. Saito,   Feb-May. 2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
subroutine Finalization_of_mpi
! $Id: Finalization_of_mpi.F90 593 2019-06-20 03:47:31Z jkoga $
  use m_Parallelization, only :       m_Parallel_end_mpi
  use m_PlaneWaveBasisSet, only :     m_pwBS_dealloc_ngpt_igfp_gr &
       &                            , m_pwBS_dealloc_ylm_l
#ifdef __EDA__
  use m_Ionic_System, only :          m_IS_dealloc_zfm3_3D &
       &                            , m_IS_dealloc_eewald_per_atom, m_IS_dealloc_zfm3_EDA
  use m_PseudoPotential, only :       m_PP_dealloc_psc_qitg_rhpcg, m_PP_dealloc_PP_per_atom_etc &
         &                            , m_PP_dealloc_paw,flg_paw
#else
  use m_Ionic_System, only :          m_IS_dealloc_zfm3_3D
  use m_PseudoPotential, only :       m_PP_dealloc_psc_qitg_rhpcg &
         &                            , m_PP_dealloc_paw,flg_paw
#endif
#ifndef PARAMSET
  use m_Charge_Density,       only : m_CD_dealloc_chgq
  use m_Electronic_Structure, only : m_ES_dealloc_vlhxc, m_ES_dealloc_vlhxcQ &
                                   , m_ES_dealloc_Dhub
  use m_ES_WF_by_SDorCG,      only : m_ESsd_dealloc_dzajn2, m_ESsd_dealloc_zaj_old
  use m_PAW_ChargeDensity,    only : m_PAWCD_dealloc
#ifdef __EDA__
  use m_XC_Potential_2D,      only : m_XC_dealloc_exc_on_a_grid
#endif
  use m_XC_Potential,         only : m_XC_dealloc_vxc_3D
#endif
#ifdef _POSITRON_
  use m_epc_potential,        only : m_epc_dealloc, m_epc_dealloc_vlhxc_p
  use m_Positron_Wave_Functions,only:m_pWF_deallocate_pzaj_etc
#endif

! ======== KT_add =============== 2013/10/31
  use m_Control_Parameters,   only : noncol, SpinOrbit_Mode
  use m_Const_Parameters,     only : Neglected, BuiltIn, ByPawPot, ZeffApprox, &
       &                             ByProjector, ReadFromPP, ON
  use m_SpinOrbit_Potential,  only : m_SO_dealloc_Dsoc, m_SO_dealloc_Mat_SOC_Strenth
! =============================== 2013/10/31


  use m_Control_Parameters,  only : sw_local_approx_trans_moment, sw_corelevel_spectrum
  use m_CLS_dipquad,         only : m_CLS_dealloc_dipquad, m_CLS_dealloc_transmom_ek
#ifdef KMATH_FFT3D
  use m_Control_Parameters,  only : sw_kmath_fft3d
  use m_Parallelization,     only : m_Parallel_kmath3d_finalize
#endif

#ifdef __EDA__
  use m_Control_Parameters,  only : sw_eda
#endif

  implicit none

  call m_pwBS_dealloc_ngpt_igfp_gr()
  call m_IS_dealloc_zfm3_3D()
  call m_PP_dealloc_psc_qitg_rhpcg()
  if(flg_paw) then
     call m_PP_dealloc_paw()
     call m_PAWCD_dealloc()
  end if
#ifndef PARAMSET
  call m_pwBS_dealloc_ylm_l()
  call m_CD_dealloc_chgq()
  call m_ESsd_dealloc_dzajn2()
  call m_ESsd_dealloc_zaj_old()
  call m_ES_dealloc_vlhxc()
  call m_ES_dealloc_vlhxcQ()
  call m_XC_dealloc_vxc_3D()
#ifdef __EDA__
  if(sw_eda==ON) then
! -----  ascat starts modifying  -----
  call m_XC_dealloc_exc_on_a_grid()
  call m_IS_dealloc_zfm3_EDA()
  call m_IS_dealloc_eewald_per_atom()
  call m_PP_dealloc_PP_per_atom_etc()
!  call m_CD_dealloc_chgq_EDA()
  endif
! -----  ascat ceases modifying  -----
#endif
#endif
#ifdef _POSITRON_
  call m_epc_dealloc()
  call m_epc_dealloc_vlhxc_p
  call m_pWF_deallocate_pzaj_etc()
#endif
  call m_ES_dealloc_Dhub()

! ==== KT_add ============== 2013/10/31
  if ( noncol ) then
     if ( SpinOrbit_Mode == ByPawPot .or. SpinOrbit_Mode == ZeffApprox &
          &                          .or. SpinOrbit_Mode == ReadFromPP ) then
        call m_SO_dealloc_Mat_SOC_strenth
        call m_SO_dealloc_Dsoc
     endif
     if ( SpinOrbit_Mode == ByProjector ) then
        call m_SO_dealloc_Dsoc
     endif
  endif
! ========================== 2013/10/31


  if ( sw_corelevel_spectrum == ON .and. sw_local_approx_trans_moment == ON ) then
     call m_CLS_dealloc_dipquad
     call m_CLS_dealloc_transmom_ek
  endif

#ifdef KMATH_FFT3D
  if(sw_kmath_fft3d==ON)then
    call m_Parallel_kmath3d_finalize()
  endif
#endif

  call m_Parallel_end_mpi           ! MPI
end subroutine Finalization_of_mpi

subroutine mpi_stop(nf)
  integer, intent(in) :: nf
  include 'mpif.h'             ! MPI
  integer :: ierror
  integer :: errorcode

  errorcode = 1000
  write(nf,*) ' ','',''
  call flush(nf)
  call mpi_abort(mpi_comm_world,errorcode,ierror)
  call mpi_finalize(ierror)
  stop
end subroutine mpi_stop

!!$#ifdef DEBUG_ERRORS
subroutine phase_error(ierrNO, nfout, nf, filename, line, modulefile)
!!$#else
!!$subroutine phase_error(ierrNO, nfout, nf, filename)
!!$#endif
  use m_Control_Parameters, only : ipri
  use m_ErrorMessages
  use m_Parallelization,    only : mpi_comm_group
  implicit none
  integer, intent(in) :: ierrNO,nfout,nf
  character(len=*), intent(in)          :: filename
!!$#ifdef DEBUG_ERRORS
  integer, intent(in),optional            :: line
  character(len=*), intent(in),optional   :: modulefile
!!$#endif

!!$  include 'mpif.h'             ! MPI

  character(len=255) :: I_name
  integer :: ierror, len_filename, i

  ierror = 0
  if(ipri>=1) then
     len_filename = min(255,len(trim(filename))) !ASMS
     do i = 1, len_filename
        I_name(i:i) = filename(i:i)
     end do
     do i = len_filename + 1 , 255 !ASMS
        I_name(i:i) = " "          !ASMS
     end do                        !ASMS

     if(ierrNO == F_POT_FILE_NOT_EXIST) then
        write(nfout,'("#### ERROR(",i4,"): No F_POT(",i3,") (=",a,")")') &
             & ierrNO, nf, trim(filename) !ASMS
     else if(ierrNO == FILE_NOT_EXIST) then
        write(nfout,'("#### ERROR(", i4, "): File (",a &
             & ,") assigned to a file no",i4," does not exist.")') &
             & ierrNO, trim(filename),nf !ASMS
     else if(ierrNO == F_ZAJ_FILE_NOT_EXIST) then    ! 1204
        write(nfout,'("#### ERROR(", i4, "):",a)') &
             & ierrNO, msg_1204_error
     else if(ierrNO == F_CHGT_FILE_NOT_EXIST) then   ! 1205
        write(nfout,'("#### ERROR(", i4, "):",a)') &
             & ierrNO, msg_1205_error
     else if(ierrNO == ERROR_IN_INPUTFILE_OPENING) then ! 1211
        write(nfout,'("#### ERROR(", i4, "):",a,a)') &
             & ierrNO, msg_1211_error, trim(filename) !ASMS
     else if(ierrNO == F_CHGT_FILE_NOT_EXIST_EK) then   ! 1212
        write(nfout,'("#### ERROR(",i4,"): F_CHGT(file no",i3,") does not exist. ",a)') &
             & ierrNO, nf, msg_1212_error
     end if
  end if

#ifdef DEBUG_ERRORS
  if(present(line)) then
     if(present(modulefile)) then
        write(nfout,'(a,i8,a)') ' PHASE experienced an error at the line ' &
             & , line, ' of source file '//trim(adjustl(modulefile))
     end if
  end if
#endif
  call flush(nfout)
!  stop ' after flush'
  call mpi_abort(mpi_comm_group,261,ierror)
  call mpi_finalize(ierror)
end subroutine phase_error

subroutine phase_error_wo_filename(ierrNO, nfout, nf, line, modulefile)

  use m_Control_Parameters, only : ipri
  use m_Parallelization,    only : mpi_comm_group
  use m_ErrorMessages

  integer, intent(in) :: ierrNO,nfout
  integer, intent(in),optional :: nf
  integer, intent(in),optional :: line
  character(len=*), intent(in),optional ::modulefile

  include 'mpif.h'             ! MPI

  logical :: I_opened
  character(len=255) :: I_name
  integer :: ierror

  ierror = 0

  if(ipri>=1) then
!!$     write(nfout,'("#### ERROR(",i4,")")') ierrNo
     if(ierrNO == EOF_REACHED) then
        if(present(nf)) then
           inquire(unit=nf, OPENED=I_opened, NAME=I_name)
           if(I_opened) then
              write(nfout,'("#### ERROR(",i4,"): EOF_reached. File No = " &
                   & ,i4,", File Name = ",a)') ierrNO, nf, trim(adjustl(I_name))
           else
              write(nfout,'("#### ERROR(",i4,"): EOF_reached. File No = " &
                   & ,i4)') ierrNO, nf
           end if
        else
           write(nfout,'("#### ERROR(",i4,"): EOF_reached. But, File No is not given.")') &
                & ierrNO
        end if
     else if(ierrNO == FORMAT_ERROR) then
        if(present(nf)) then
           inquire(unit=nf, OPENED=I_opened, NAME=I_name)
           if(I_opened) then
              write(nfout,'("#### ERROR(",i4,"): ",a," File No = ",i4," File Name = ",a)') &
                   &                     ierrNO, msg_format_error, nf, trim(adjustl(I_name))
           else
              write(nfout,'("#### ERROR(",i4,"): ",a," File No = ",i4)') &
                   &                     ierrNO, msg_format_error, nf
           end if
        else
           write(nfout,'("#### ERROR(",i4,"): ",a," But, File No is unknown.")') &
                &                     ierrNO, msg_format_error
        end if
     else if(ierrNO == CPP_DEFINE_ERROR_1) then
        write(nfout,'("#### ERROR(",i4,"): ",a)') ierrNO,msg_6100_error
        write(nfout,'("                      (",a,")")') msg_6101_error
     else
        write(nfout,'("#### ERROR(",i4,"):msg")') ierrNO
     end if
#ifdef DEBUG_ERRORS
     if(present(line)) then
        if(present(modulefile)) then
           write(nfout,'(a,i8,a)') ' PHASE aborted at the line ' &
                & , line, ' of source file '//trim(adjustl(modulefile))
        end if
     end if
#endif
  end if
  call flush(nfout)
!!$  if(mode>0) then
     call mpi_abort(mpi_comm_group,261,ierror)
     write(nfout,'(" ierror = ",i8)') ierror
!!$  end if
  call flush(nfout)
  call mpi_finalize(ierror)
  stop
end subroutine phase_error_wo_filename

subroutine phase_error_with_msg(nfout, msg, line, modulefile)
!!$#else
!!$subroutine phase_error(ierrNO, nfout, nf, filename)
!!$#endif
  use m_Control_Parameters, only : ipri, printable, iprijobstatus, jobstatus_format, jobstatus_series
  use m_Files,              only : m_Files_open_nfstatus, m_Files_skiptoend, nfstatus &
  &                              , m_Files_close_nfstatus
  use m_ErrorMessages
  use m_Parallelization,    only : mpi_comm_group, mype
  use m_Files, only : m_Files_close_all, m_Files_close_logfile
  use m_IterationNumbers,   only : iteration, iteration_ionic, iteration_electronic
  use m_Const_Parameters,   only : ON, ERROR
  use m_Timing,             only : m_Timing_wd_status

  implicit none

  integer,          intent(in)   :: nfout
  character(len=*), intent(in)   :: msg
  integer, intent(in)            :: line
  character(len=*), intent(in)   :: modulefile

!!$  include 'mpif.h'             ! MPI

  character(len=255) :: I_name
  integer :: ierror, len_filename, i
  integer :: status_wdmode

  ierror = 0
  call mpi_barrier(mpi_comm_group,ierror)
  if(mype==0) then
    write(nfout,'(a,i8,a)') ' PHASE/0 terminated abnormally at line ', line, ' of file '//trim(adjustl(modulefile))
    write(nfout,'(a)')      ' reason : '//trim(adjustl(msg))

    write(nfout,'(a)') '----------------------------------------'
    write(nfout,'(a)') ' EEEEEE  RRRRR   RRRRR    OOOO   RRRRR  '
    write(nfout,'(a)') ' E       R    R  R    R  O    O  R    R '
    write(nfout,'(a)') ' EEEEE   R    R  R    R  O    O  R    R '
    write(nfout,'(a)') ' E       RRRRR   RRRRR   O    O  RRRRR  '
    write(nfout,'(a)') ' E       R   R   R   R   O    O  R   R  '
    write(nfout,'(a)') ' EEEEEE  R    R  R    R   OOOO   R    R '
    write(nfout,'(a)') '----------------------------------------'

    write(0,'(a,i8,a)') ' PHASE/0 terminated abnormally at line ', line, ' of file '//trim(adjustl(modulefile))
    write(0,'(a)')      ' reason : '//trim(adjustl(msg))
    call flush(nfout)
    call flush(0)
  endif

  if(iprijobstatus >= 1) then
!!$     write(nfout,'(" WDD onto Files")')
     call m_Files_open_nfstatus()
     if(jobstatus_series == ON) then
!!$        switch_header = OFF
        call m_Files_skiptoend(nfstatus)
     else
!!$        switch_header = ON
     end if
     status_wdmode = ERROR
     call m_Timing_wd_status(nfstatus,jobstatus_format,jobstatus_series,status_wdmode &
          &                , iteration,iteration_ionic,iteration_electronic)
  end if
  call m_Files_close_all()
  call m_Files_close_logfile()
  call mpi_abort(mpi_comm_group,261,ierror)
  call mpi_finalize(ierror)
end subroutine phase_error_with_msg

subroutine phase_execution_error(ierrNO)
  use m_Control_Parameters, only : ipri
  use m_Parallelization,    only : mpi_comm_group, mype, ierr
  use m_Files,              only : nfout 
  use m_ErrorMessages
  use m_Const_Parameters,   only : FMAXTAGLEN

  implicit none
  integer f_check_input_duplicated_tag
  integer, intent(in) :: ierrNO
  character(len=FMAXTAGLEN) :: duplicated_block_name
  integer :: len_name,i
!!$  include 'mpif.h'             ! MPI

  if(ipri>=1 .and. mype == 0) then
     write(nfout,*)  ! BLANK LINE
     select case (ierrNO)
     case (CONT_FILES_NOT_EXIST)      ! 1209
        write(nfout,'("###ERROR(",i4,") file(s) for continuation do not exist.")') &
             & CONT_FILES_NOT_EXIST
     case (FILENAMES_FORMAT_ERROR)      ! 1209
        write(nfout,'("###ERROR(",i4,") format error in file_names.data.")') &
             & FILENAMES_FORMAT_ERROR
     case (FILENAMES_FORMAT_ERROR_NEB)  ! 1210
        write(nfout,'("###ERROR(",i4,") format error in file_names.data. (nebfiles)")') &
             & FILENAMES_FORMAT_ERROR_NEB
     case (ERROR_IN_INPUTFILE_OPENING)  ! 1211
        write(nfout,'("###ERROR(",i4,") syntax error in F_INP.")') &
             & ERROR_IN_INPUTFILE_OPENING
        if(f_check_input_duplicated_tag().ne.0) then              ! (input_interface.F90)
           call f_cp_duplicated_block_name(duplicated_block_name) ! (input_interface.F90)
           write(nfout,'(" #-- Syntax Error: Block ",a1,a,a1," is duplicately defined in F_INP.")') &
                & char(34),trim(duplicated_block_name),char(34)
        end if
     case (INVALID_CHARGE_MIXING)       ! 1302
        write(nfout,'("###ERROR(",i4,") charge-mixing in the wavefunction_solver block does not exist.")') &
             & INVALID_CHARGE_MIXING
     case (INVALID_ATOMIC_NUMBER)       ! 1401
        write(nfout,'("###ERROR(",i4,") The atomic-number is inconsistent with the pseudopotential file.")') &
             & INVALID_ATOMIC_NUMBER
     case (PARALLELIZATION_INVALID_2D)  ! 2101
        write(nfout,'("###ERROR(",i4,") Number of parallel process (npes) must be ne*nk.")')  &
             & PARALLELIZATION_INVALID_2D
     case (PARALLELIZATION_INVALID_3D)  ! 2102
        continue
     case (PARALLELIZATION_INVALID_NK)  ! 2103
        write(nfout,'("###ERROR(",i4,") Number of kpoint-parallelization is greater than number of kpoints(kv3).")') &
             & PARALLELIZATION_INVALID_NK
     case (PARALLELIZATION_INVALID_NE)  ! 2104
        write(nfout,'("###ERROR(",i4,") Number of band-parallelization is greater than number of bands(neg).")') &
             & PARALLELIZATION_INVALID_NE
     end select
  end if
  call flush(nfout)
  call mpi_barrier(mpi_comm_group,ierr)
  call mpi_abort(mpi_comm_group,275,ierrNO)
  call mpi_finalize(ierrNO)
end subroutine phase_execution_error

module m_OP_rotation
  use m_Control_Parameters,  only : nspin, ndim_chgpot, ndim_magmom, neg, ndim_spinor, &
       &                            noncol, YES, num_extra_bands, num_proj_elems, &
       &                            proj_group, proj_attribute, ipriorb_rot
  use m_Const_Parameters,    only : OFF, ON, DP, CMPLDP, GAMMA, BUCS, Bohr, PAI4, zi
  use m_Kpoints,     only : kv3, k_symmetry, kv3_ek, vkxyz
  use m_PseudoPotential,  only : nloc, ilmt_phi, lmta_phi, ltp_phi, mtp_phi, taup_phi, &
       &                         iproj_phi, lmtt_phi, qorb, nlmtt_phi, nlmta_phi, &
       &                          m_PP_tell_iorb_lmtt, m_PP_tell_iorb_ia_l_m_tau
  use m_Crystal_Structure,   only : nopr, altv
  use m_Ionic_System,    only : natm, ityp, iproj_group, if_pdos, speciesname, iatomn, &
       &                         cps, atom_key
  use m_NonLocal_Potential, only : norm_phig
  use m_Parallelization,    only : mype, map_k, map_e, myrank_k, myrank_e, map_z, npes, &
       &                           mpi_comm_group, ierr, np_e, ista_k, iend_k, &
       &                           ista_e, iend_e, istep_e, nrank_e
  use m_Electronic_Structure,  only : compr_l, compi_l, occup_l, neordr
  use m_IterationNumbers,      only : nk_in_the_process

  use m_ES_Noncollinear,   only : m_ES_set_Pauli_Matrix
  use m_SpinOrbit_Potential,  only : Mat_LS_with_real_ylm_L0, Mat_LS_with_real_ylm_L1, &
       &                             Mat_LS_with_real_ylm_L2, Mat_LS_with_real_ylm_L3, &
       &                             MatU_ylm_RC_L0, MatU_ylm_RC_L1, &
       &                             MatU_ylm_RC_L2, MatU_ylm_RC_L3

  implicit none
  include 'mpif.h'
  
  real(kind=DP), allocatable :: porb_rot_matrix_real(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: porb_rot_matrix_cmplx(:,:,:,:)

  real(kind=DP), allocatable :: compr_rot_l(:,:,:,:), compi_rot_l(:,:,:,:)

  real(kind=DP), allocatable :: score_sigma_bond(:,:,:)
  character(len=8), allocatable :: orb_irrep(:,:,:)

  real(kind=DP), allocatable :: dm(:,:,:,:,:)
  complex(kind=CMPLDP), allocatable :: dm_ssrep(:,:,:,:,:)

  complex(kind=CMPLDP), allocatable :: Jcoeff_L0(:,:), JCoeff_L1(:,:)
  complex(kind=CMPLDP), allocatable :: Jcoeff_L2(:,:), JCoeff_L3(:,:)
    
contains

! ===========================================================-
  subroutine m_OP_calc_dm_col
    use m_Control_Parameters,  only : sw_write_orb_dens_mat_file
    use m_Files,  only :  m_Files_open_nfporb_dens_mat, &
         &                m_Files_close_nfporb_dens_mat, nfporb_dens_mat

    integer :: lmax, mmax

    lmax = nloc;   mmax = 2*lmax -1

    if ( allocated(dm) ) deallocate(dm)
    allocate( dm(natm,lmax,mmax,mmax,nspin) ); dm = 0.0d0
    call set_dm
    
    if ( sw_write_orb_dens_mat_file == ON ) call save_dm

  contains

    subroutine set_dm
      integer :: ik, is, iksnl, ia, it, iopr
      integer :: il, im, im1, im2, ip, i, i1, i2
      integer :: lmt, lmt1, lmt2, lmtt, lmtt1, lmtt2
      integer :: ib

      real(kind=DP) :: fac, c1, c2, temp
      real(kind=DP), allocatable :: dm_mpi(:,:,:,:,:)

      allocate( dm_mpi(natm,lmax,mmax,mmax,nspin) ); dm_mpi = 0.0d0

      do ik = 1, kv3
         if(map_k(ik) /= myrank_k) cycle

         iksnl = (ik-1)/nspin + 1
         is = mod(ik-1,nspin) +1

         do ib = 1, neg
            if(map_e(ib) == myrank_e) then
               do ia=1,natm
                  it = ityp(ia)
                  if(iproj_group(ia) == 0) cycle

                ! diagonal part
                  do lmt=1,ilmt_phi(it)
                     il = ltp_phi(lmt,it)
                     im  = mtp_phi(lmt,it)
                     ip  = iproj_phi(lmt,it)
                     i = lmta_phi(lmt,ia)
                     lmtt = lmtt_phi(lmt,it)

                     temp = 0.d0
                     if(k_symmetry(ik) == GAMMA) then
                        do iopr = 1,nopr
                           temp = temp + compr_l(map_z(ib),i,iopr,ik)**2 /2.0 &
                                &      *(1.d0+qorb(i)/(norm_phig(lmtt,iksnl)*2.0))
                        end do
                     else
                        do iopr = 1,nopr
                           temp = temp + (  compr_l(map_z(ib),i,iopr,ik)**2 &
                                &         + compi_l(map_z(ib),i,iopr,ik)**2) &
                                &      *(1.d0+qorb(i)/norm_phig(lmtt,iksnl))
                        end do
                     end if

                     dm_mpi(ia,il,im,im,is) = dm_mpi(ia,il,im,im,is) &
                          &                  + occup_l(map_z(ib),ik)*temp/dble(nopr)
                  end do

                  ! non-diagonal part
                  do lmt2=1,ilmt_phi(it)
                     do lmt1=1,lmt2-1
                        if(ltp_phi(lmt1,it) /= ltp_phi(lmt2,it)) cycle
                        il = ltp_phi(lmt1,it)
                        ip  = iproj_phi(lmt1,it)
                        im1  = mtp_phi(lmt1,it)
                        i1 = lmta_phi(lmt1,ia)
                        im2  = mtp_phi(lmt2,it)
                        i2 = lmta_phi(lmt2,ia)

                        lmtt1 = lmtt_phi(lmt1,it);     lmtt2 = lmtt_phi(lmt2,it)

                        c1 = ( qorb(i1) +qorb(i2) ) /2.0d0      ! approx
                        c2 = sqrt(norm_phig(lmtt1,iksnl)*norm_phig(lmtt2,iksnl))

                        temp = 0.d0

                        if(k_symmetry(ik) == GAMMA) then ! dame
                           do iopr = 1,nopr
                              temp = temp &
                                   & + compr_l(map_z(ib),i1,iopr,ik) &
                                   &  *compr_l(map_z(ib),i2,iopr,ik) /2.d0 &
                                   &  *( 1.0d0 +c1 /( c2 *2.d0) )
                           end do
                        else
                           do iopr = 1,nopr
                              temp = temp &
                                   & + ( compr_l(map_z(ib),i1,iopr,ik) &
                                   &    *compr_l(map_z(ib),i2,iopr,ik) &
                                   &    +compi_l(map_z(ib),i1,iopr,ik) &
                                   &    *compi_l(map_z(ib),i2,iopr,ik) )&
                                   &  *( 1.0d0 +c1 /c2 )
                           end do
                        end if

                        dm_mpi(ia,il,im1,im2,is) = dm_mpi(ia,il,im1,im2,is) &
                             &                   + occup_l(map_z(ib),ik)*temp/dble(nopr)
                        dm_mpi(ia,il,im2,im1,is) = dm_mpi(ia,il,im1,im2,is)
                     end do
                  end do

               end do
            end if
         end do
      end do

      if ( npes > 1 ) then
         call mpi_allreduce( dm_mpi, dm, natm *lmax *mmax**2 *nspin, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
      else
         dm = dm_mpi
      endif
      deallocate( dm_mpi )

      fac = 2.d0/kv3;
      dm = fac*dm
      if(nspin == 1) dm = 0.5d0*dm

    end subroutine set_dm

    subroutine save_dm
      integer :: ia, il, immax, im, im2, is
      integer :: lun

      if ( mype /= 0 ) return

      call m_Files_open_nfporb_dens_mat(0)

      lun = nfporb_dens_mat

      Do ia=1, natm
         if (iproj_group(ia) == 0) cycle
         write(lun) ia
         Do is=1, nspin
            write(lun) is
            Do il=1, nloc
               immax = 2*il -1
               write(lun) il
               Do im=1, immax
                  write(lun) ( dm(ia,il,im2,im,is), im2=1, immax )
               End Do
            End do
         End Do
      End Do
      call m_Files_close_nfporb_dens_mat

    end subroutine save_dm

  end subroutine m_OP_calc_dm_col

  subroutine m_OP_calc_dm_noncl         ! ssrep
    use m_Control_Parameters,  only : sw_write_orb_dens_mat_file
    use m_Files,  only :  m_Files_open_nfporb_dens_mat, &
         &                m_Files_close_nfporb_dens_mat, nfporb_dens_mat

    integer :: lmax, mmax

    lmax = nloc;   mmax = 2*lmax -1

    if ( allocated(dm_ssrep) ) deallocate(dm_ssrep)
    allocate( dm_ssrep(natm,lmax,mmax,mmax,ndim_chgpot) ); dm_ssrep = 0.0d0

    call set_dm_ssrep
    if ( sw_write_orb_dens_mat_file == ON ) call save_dm_ssrep

  contains

    subroutine set_dm_ssrep
      integer :: ik, is1, is2, iksnl, ia, it, iopr
      integer :: il, im, im1, im2, ip, i, i1, i2
      integer :: lmt, lmt1, lmt2, lmtt, lmtt1, lmtt2
      integer :: ib, istmp

      real(kind=DP) :: fac, c1, c2
      complex(kind=CMPLDP) :: ztemp, z1, z2
      complex(kind=CMPLDP), allocatable :: dm_mpi(:,:,:,:,:)

      allocate( dm_mpi(natm,lmax,mmax,mmax,ndim_chgpot) ); dm_mpi = 0.0d0

      do ik = 1, kv3, ndim_spinor
         if(map_k(ik) /= myrank_k) cycle

         iksnl = (ik-1)/nspin + 1

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               istmp = ( is1 -1 )*ndim_spinor + is2
               
               do ib = 1, neg
                  if(map_e(ib) == myrank_e) then
                     do ia=1,natm
                        it = ityp(ia)
                        if(iproj_group(ia) == 0) cycle
                  
                ! diagonal part
                        do lmt=1,ilmt_phi(it)
                           il = ltp_phi(lmt,it)
                           im  = mtp_phi(lmt,it)
                           ip  = iproj_phi(lmt,it)
                           i = lmta_phi(lmt,ia)
                           lmtt = lmtt_phi(lmt,it)
                           
                           ztemp = 0.0d0
                           do iopr=1,nopr
                              z1 = dcmplx( compr_l(map_z(ib),i,iopr,ik+is1-1 ), &
                                   &       compi_l(map_z(ib),i,iopr,ik+is1-1 ) )
                              z2 = dcmplx( compr_l(map_z(ib),i,iopr,ik+is2-1 ), &
                                   &       compi_l(map_z(ib),i,iopr,ik+is2-1 ) )
                              ztemp = ztemp + z1 *conjg(z2) &
                                   &      *( 1.d0+qorb(i)/norm_phig(lmtt,iksnl) )
                           end do
                           
                           dm_mpi(ia,il,im,im,istmp) &
                                &    = dm_mpi(ia,il,im,im,istmp) &
                                &     + occup_l(map_z(ib),ik)*ztemp/dble(nopr)
                        end do
                        
                  ! non-diagonal part
                        do lmt2=1,ilmt_phi(it)
!                           do lmt1=1,lmt2-1
                           do lmt1=1,ilmt_phi(it)
                              if ( lmt1 == lmt2 ) cycle
                              if (ltp_phi(lmt1,it) /= ltp_phi(lmt2,it)) cycle

                              il = ltp_phi(lmt1,it)
                              ip  = iproj_phi(lmt1,it)
                              im1  = mtp_phi(lmt1,it)
                              i1 = lmta_phi(lmt1,ia)
                              im2  = mtp_phi(lmt2,it)
                              i2 = lmta_phi(lmt2,ia)
                              
                              lmtt1 = lmtt_phi(lmt1,it);     lmtt2 = lmtt_phi(lmt2,it)

                              c1 = ( qorb(i1) +qorb(i2) ) /2.0d0      ! approx
                              c2 = sqrt(norm_phig(lmtt1,iksnl)*norm_phig(lmtt2,iksnl))

                              ztemp = 0.d0

                              do iopr = 1,nopr
                                 z1 = dcmplx( compr_l(map_z(ib),i1,iopr,ik+is1-1 ), &
                                      &       compi_l(map_z(ib),i1,iopr,ik+is1-1 ) )
                                 z2 = dcmplx( compr_l(map_z(ib),i2,iopr,ik+is2-1 ), &
                                      &       compi_l(map_z(ib),i2,iopr,ik+is2-1 ) )
                                 ztemp = ztemp + z1 *conjg(z2) &
                                      &  *( 1.0d0 +c1 /c2 )
                              end do

                              dm_mpi(ia,il,im1,im2,istmp) &
                                   &   = dm_mpi(ia,il,im1,im2,istmp) &
                                   &    + occup_l(map_z(ib),ik)*ztemp/dble(nopr)
!                              dm_mpi(ia,il,im2,im1,istmp) &
!                                   &  = conjg( dm_mpi(ia,il,im1,im2,istmp) )
                           end do
                        end do
                     end do
                  end if
               end do
            end Do
         end Do
      end do

      if ( npes > 1 ) then
         call mpi_allreduce( dm_mpi, dm_ssrep, natm *lmax *mmax**2 *ndim_chgpot *2, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
      else
         dm_ssrep = dm_mpi
      endif
      deallocate( dm_mpi )

      fac = 2.d0/kv3
      dm_ssrep = fac*dm_ssrep

    end subroutine set_dm_ssrep

    subroutine save_dm_ssrep
      integer :: ia, il, immax, im, im2, is
      integer :: lun

      if ( mype /= 0 ) return

      call m_Files_open_nfporb_dens_mat(0)

      lun = nfporb_dens_mat

      Do ia=1, natm
         if (iproj_group(ia) == 0) cycle
         write(lun) ia
         Do is=1, ndim_chgpot
            write(lun) is
            Do il=1, nloc
               immax = 2*il -1
               write(lun) il
               Do im=1, immax
                  write(lun) ( dm_ssrep(ia,il,im2,im,is), im2=1, immax )
               End Do
            End do
         End Do
      End Do
      call m_Files_close_nfporb_dens_mat

    end subroutine save_dm_ssrep

  end subroutine m_OP_calc_dm_noncl
  ! ===========================================================-

  subroutine m_OP_rotation_col(nfout)
    use m_Control_Parameters,  only : population_diag_mode, &
         &                            sw_calc_score_sigma_bond
    use m_Const_Parameters,    only : DIAG_CHARGE_DENSITY_MATRIX, &
         &                            LOCAL_POINT_GROUP
    use m_Files,               only : m_Files_open_nfporb_rot_mat, &
         &                            m_Files_close_nfporb_rot_mat, nfporb_rot_mat 
    integer, intent(in) :: nfout

    integer:: lmax, mmax
    real(kind=DP), allocatable :: porb2(:,:,:,:)

    lmax = nloc;   mmax = 2*lmax -1

    if ( allocated(porb_rot_matrix_real) ) deallocate( porb_rot_matrix_real )

    allocate( porb_rot_matrix_real(natm,lmax,mmax,mmax) ); 
    porb_rot_matrix_real = 0.0d0

    select case (population_diag_mode)
    case (DIAG_CHARGE_DENSITY_MATRIX)
       call diagonalization
    case (LOCAL_POINT_GROUP)
       allocate( orb_irrep(natm,lmax,mmax) ) 
       call m_OP_calc_symm
    end select
    
    if ( sw_calc_score_sigma_bond == ON ) then
       allocate( score_sigma_bond(natm,lmax,mmax) );   score_sigma_bond = -99.0d0
       call m_OP_calc_score_sigma_bond
    endif

    allocate( porb2(natm,lmax,mmax,nspin) ); porb2 = 0.0d0
    call set_porb2
    call printout
    call save_porb_rot_matrix_real

!    deallocate(dm);
    deallocate(porb2)
!    deallocate(score_sigma_bond)
!    if (allocated(orb_irrep)) deallocate(orb_irrep)

  contains

    subroutine save_porb_rot_matrix_real
      integer :: ia, il, immax, im, im2
      integer :: lun

      if ( mype /= 0 ) return

      call m_Files_open_nfporb_rot_mat(0)

      lun = nfporb_rot_mat
      write(lun) DIAG_CHARGE_DENSITY_MATRIX

      Do ia=1, natm
         if (iproj_group(ia) == 0) cycle
         write(lun) ia
         Do il=1, nloc
            immax = 2*il -1
            write(lun) il
            Do im=1, immax
               write(lun) ( porb_rot_matrix_real(ia,il,im2,im), im2=1, immax )
            End do
         End Do
      End Do
      call m_Files_close_nfporb_rot_mat

    end subroutine save_porb_rot_matrix_real

    subroutine printout
      integer :: ia, it, lmt, ilmta, il, im, tau, immax
      integer :: im2
      real(kind=DP) :: pup, pdn
      
      write(nfout,*)
      write(nfout,'(" --------- Orbital population rotated ---------")')

      if ( ipriorb_rot > 1 ) then
         write(nfout,'("  ia   l   m''  element coeff (1:2*l+1) ")')
         do ia=1,natm
            if (if_pdos(ia) == OFF) cycle
            if (iproj_group(ia) == 0) cycle
            it = ityp(ia)
            
            do lmt=1,ilmt_phi(it)
               ilmta = lmta_phi(lmt,ia)
               il = ltp_phi(lmt,it);   im = mtp_phi(lmt,it);   tau = taup_phi(lmt,it)
               immax = 2*il -1
               
               if ( immax <= 5 ) then
                  write(nfout,'(3(1x,i3),4x,a)',advance="no") &
                       &             ia, il-1, im, speciesname(it)
               else
                  write(nfout,'(3(1x,i3),4x,a)') ia, il-1, im, speciesname(it)
               endif
               Do im2=1, immax
                  write(nfout,'(1x,f10.5)',advance='no') &
                       &     ( porb_rot_matrix_real(ia,il,im2,im) )
               End Do
               write(nfout,*)
            end do
         end do
         write(nfout,*)
      endif

      pup=0.d0; pdn=0.d0

      write(nfout,'(A)',advance='no') &
           &    "  ia   l   m'  t    Porb(UP)   Porb(DN)  element"
      if ( sw_calc_score_sigma_bond == ON ) then
         write(nfout,'(A)',advance='no') "  score_bond"
      endif
      if ( population_diag_mode == LOCAL_POINT_GROUP ) then
         write(nfout,'(A)') "  symmetry"
      else
         write(nfout,*)
      endif

      do ia=1,natm
         if (if_pdos(ia) == OFF) cycle
         if (iproj_group(ia) == 0) cycle
         it = ityp(ia)

         do lmt=1,ilmt_phi(it)
            ilmta = lmta_phi(lmt,ia)
            il = ltp_phi(lmt,it);  im = mtp_phi(lmt,it);  tau = taup_phi(lmt,it)
            if ( nspin == 1 ) then
               write(nfout,'(4(1x,i3),2(1x,f10.5),4x,a4)',advance='no') &
                    &        ia, il-1, im, tau, &
                    &        porb2(ia,il,im,1), porb2(ia,il,im,1), &
                    &        speciesname(it)
               if ( sw_calc_score_sigma_bond == ON ) then
                  write(nfout,'(3x,f10.5)',advance='no') score_sigma_bond(ia,il,im)
               endif
               if ( population_diag_mode == LOCAL_POINT_GROUP ) then
                  write(nfout,'(4x,a8)') orb_irrep(ia,il,im)
               else
                  write(nfout,*)
               endif
               pup = pup +porb2(ia,il,im,1)

            else
               write(nfout,'(4(1x,i3),2(1x,f10.5),4x,a4)',advance='no') &
                    &        ia, il-1, im, tau, porb2(ia,il,im,1:2), &
                    &        speciesname(it)
               if ( sw_calc_score_sigma_bond == ON ) then
                  write(nfout,'(3x,f10.5)',advance='no') score_sigma_bond(ia,il,im)
               endif
               if ( population_diag_mode == LOCAL_POINT_GROUP ) then
                  write(nfout,'(4x,a8)') orb_irrep(ia,il,im)
               else
                  write(nfout,*)
               endif
               pup = pup +porb2(ia,il,im,1)
               pdn = pdn +porb2(ia,il,im,2)
            endif
         end do
      end do
      
      if ( nspin == 1 ) then
         pdn = pup
         write(nfout,'(8x,"Total : ",3(1x,f10.5))') pup,pdn,pup+pdn
      else
         write(nfout,'(8x,"Total : ",3(1x,f10.5))') pup,pdn,pup+pdn
      endif
      write(nfout,*)

    end subroutine printout

    subroutine set_porb2
      integer :: ia, il, immax, size2, im1, im2, im3, is
      real(kind=DP) :: ctmp, cwk(ndim_chgpot)

      do ia=1,natm
         if (iproj_group(ia) == 0) cycle

         Do il=1, lmax
            immax = 2*il -1
            size2 = immax

            Do im1=1, size2
               DO is=1, ndim_magmom
                  ctmp = 0.0d0
                  Do im2=1, immax
                     Do im3=1, immax
                        ctmp = ctmp &
                             &    + porb_rot_matrix_real( ia,il,im2,im1 )  &
                             &     *dm(ia,il,im2,im3,is) &
                             &     *porb_rot_matrix_real( ia,il,im3,im1 )
                     End Do
                  End Do
                  cwk(is) = ctmp
               End DO
               porb2( ia, il, im1, 1:ndim_magmom ) = cwk(1:ndim_magmom)
            End Do
         End Do
      ENd do

    end subroutine set_porb2

    subroutine diagonalization
      integer :: is,ia,it,ig,i,ip,il, tau, im1, im2, im3
      integer :: lwork,info, immax
      real(kind=DP) :: abstol,nfound, ctmp

      integer, allocatable :: iwork(:),ifail(:)
      real(kind=DP), allocatable :: rwork(:), amat(:,:), evec(:), rvmat(:,:)
      real(kind=DP), external :: dlamch


      abstol = 2*dlamch('S')
      
     do ia=1,natm
         it = ityp(ia)
         if (iproj_group(ia) == 0) cycle

         Do il=1, lmax
            immax = 2*il -1;
            lwork = 8 *immax
            allocate( rwork(lwork) );
            allocate( iwork(5*immax) );   allocate( ifail(immax) )
            allocate( amat(immax,immax) )
            allocate( evec(immax) )
            allocate( rvmat(immax,immax) )

            amat = 0.0d0
            Do im1=1, immax
               Do im2=1, immax
                  Do is=1, ndim_magmom
                     amat(im1,im2) = amat(im1,im2) +dm(ia,il,im1,im2,is)
                  End Do
               End Do
            ENd Do
            call dsyevx( 'V', 'A', 'U', immax, amat, immax, 0.d0, 0.d0, 0, 0, &
                 &       abstol, nfound, evec, rvmat, immax, rwork, lwork, &
                 &       iwork, ifail, info )
            if (info /= 0) then
               write(nfout,*) 'dsyevx: info=',info
            end if
            Do im1=1, immax
               Do im2=1, immax
                  porb_rot_matrix_real( ia,il,im2,im1 ) = rvmat(im2,im1)
               ENd Do
            End Do

            deallocate(rwork);  deallocate(iwork);   deallocate(ifail)
            deallocate(amat);   deallocate(evec);    deallocate(rvmat)
         end do
      end do
    end subroutine diagonalization
  end subroutine m_OP_rotation_col

  subroutine m_OP_rotation_noncl(nfout)
    use m_Control_Parameters,  only : population_diag_mode, &
         &                            sw_calc_score_sigma_bond
    use m_Const_Parameters,    only : DIAG_CHARGE_DENSITY_MATRIX, &
         &                            DIAG_SPIN_DENSITY_MATRIX, &
         &                            DIAG_LS_with_t2g_octa, DIAG_LS, &
         &                            LOCAL_POINT_GROUP, LOCAL_DOUBLE_POINT_GROUP
    use m_Files,               only : m_Files_open_nfporb_rot_mat, &
         &                            m_Files_close_nfporb_rot_mat, nfporb_rot_mat 

    integer, intent(in) :: nfout

    integer:: lmax, mmax

    real(kind=DP), allocatable :: porb2(:,:,:,:)
    real(kind=DP), allocatable :: dm(:,:,:,:,:)
!
    integer :: fac, i, j
!
    lmax = nloc;   mmax = 2*lmax -1

    if ( allocated(porb_rot_matrix_real) ) deallocate( porb_rot_matrix_real )
    if ( allocated(porb_rot_matrix_cmplx) ) deallocate( porb_rot_matrix_cmplx )

    select case (population_diag_mode)
    case (LOCAL_POINT_GROUP)
       allocate( dm(natm,lmax,mmax,mmax,ndim_magmom) ); dm = 0.0d0
       call set_dm

       allocate( porb_rot_matrix_real(natm,lmax,mmax,mmax) );
       porb_rot_matrix_real = 0.0d0

       allocate( orb_irrep(natm,lmax,mmax) )
       call m_OP_calc_symm
       if ( sw_calc_score_sigma_bond == ON ) then
          allocate( score_sigma_bond(natm,lmax,mmax) );   score_sigma_bond = -99.0d0
          call m_OP_calc_score_sigma_bond
       endif

       allocate( porb2(natm,lmax,mmax,ndim_magmom) ); porb2 = 0.0d0
       call set_porb2_from_chgmag_densmat
       call printout_chg_densmat_mode
       call save_porb_rot_matrix_real

    case (LOCAL_DOUBLE_POINT_GROUP)
       fac = ndim_spinor
       allocate( porb_rot_matrix_cmplx(natm,lmax,mmax*fac,mmax*fac) );
       porb_rot_matrix_cmplx = 0.0d0

       allocate( orb_irrep(natm,lmax,mmax*fac) )
       call m_OP_calc_symm

       allocate( porb2(natm,lmax,mmax*fac,ndim_magmom) ); porb2 = 0.0d0
       call set_porb2_from_spin_densmat
       call printout_spin_densmat_mode
       call save_porb_rot_matrix_cmplx

    case (DIAG_CHARGE_DENSITY_MATRIX)
       allocate( dm(natm,lmax,mmax,mmax,ndim_magmom) ); dm = 0.0d0
       call set_dm

       allocate( porb_rot_matrix_real(natm,lmax,mmax,mmax) ); 
       porb_rot_matrix_real = 0.0d0
       call diagonalize_chg_densmat
       if ( sw_calc_score_sigma_bond == ON ) then
          allocate( score_sigma_bond(natm,lmax,mmax) );   score_sigma_bond = -99.0d0
          call m_OP_calc_score_sigma_bond
       endif

       allocate( porb2(natm,lmax,mmax,ndim_magmom) ); porb2 = 0.0d0
       call set_porb2_from_chgmag_densmat
       call printout_chg_densmat_mode
       call save_porb_rot_matrix_real

    case (DIAG_SPIN_DENSITY_MATRIX)
       fac = ndim_spinor

       allocate( porb_rot_matrix_cmplx(natm,lmax,mmax*fac,mmax*fac) ); 
       porb_rot_matrix_cmplx = 0.0d0
       call diagonalize_spin_densmat
       if ( sw_calc_score_sigma_bond == ON ) then
          allocate( score_sigma_bond(natm,lmax,mmax*fac) );  score_sigma_bond = -99.0d0
          call m_OP_calc_score_sigma_bond
       endif

       allocate( porb2(natm,lmax,mmax*fac,ndim_magmom) ); porb2 = 0.0d0
       call set_porb2_from_spin_densmat
       call printout_spin_densmat_mode
       call save_porb_rot_matrix_cmplx

    case (DIAG_LS_with_t2g_OCTA)
       fac = ndim_spinor

       allocate( dm(natm,lmax,mmax,mmax,ndim_magmom) ); dm = 0.0d0
       call set_dm

       allocate( porb_rot_matrix_real(natm,lmax,mmax,mmax) ); 
       porb_rot_matrix_real = 0.0d0
       call diagonalize_chg_densmat

       allocate( porb_rot_matrix_cmplx(natm,lmax,mmax*fac,mmax*fac) );
       porb_rot_matrix_cmplx = 0.0d0
       call set_porb_rot_matrix_jeff

       allocate( porb2(natm,lmax,mmax*fac,ndim_magmom) ); porb2 = 0.0d0
       call set_porb2_from_spin_densmat
       call printout_jeff_mode
       call save_porb_rot_matrix_cmplx

    case (DIAG_LS)
       fac = ndim_spinor

       allocate( porb_rot_matrix_cmplx(natm,lmax,mmax*fac,mmax*fac) );
       porb_rot_matrix_cmplx = 0.0d0
       call set_porb_rot_matrix_jrep3

       allocate( porb2(natm,lmax,mmax*fac,ndim_magmom) ); porb2 = 0.0d0
       call set_porb2_from_spin_densmat
       call printout_jrep_mode3
       call save_porb_rot_matrix_cmplx

    end select

!    deallocate(dm_ssrep);
    deallocate(porb2)
    if ( allocated(dm) ) deallocate(dm)

  contains

    subroutine save_porb_rot_matrix_real
      integer :: ia, il, immax, im, im2
      integer :: lun

      if ( mype /= 0 ) return

      call m_Files_open_nfporb_rot_mat(0)

      lun = nfporb_rot_mat
      write(lun) population_diag_mode

      Do ia=1, natm
         if (iproj_group(ia) == 0) cycle
         write(lun) ia
         Do il=1, nloc
            immax = 2*il -1
            write(lun) il
            Do im=1, immax
               write(lun) ( porb_rot_matrix_real(ia,il,im2,im), im2=1, immax )
            End do
         End Do
      End Do
      call m_Files_close_nfporb_rot_mat
    end subroutine save_porb_rot_matrix_real

    subroutine save_porb_rot_matrix_cmplx
      integer :: ia, il, immax, im, im2
      integer :: lun

      if ( mype /= 0 ) return

      call m_Files_open_nfporb_rot_mat(0)

      lun = nfporb_rot_mat
      write(lun) population_diag_mode

      Do ia=1, natm
         if (iproj_group(ia) == 0) cycle
         write(lun) ia
         Do il=1, nloc
            immax = 2*il -1
            write(lun) il
            Do im=1, immax*2
               write(lun) ( porb_rot_matrix_cmplx(ia,il,im2,im), im2=1, immax*2 )
            End do
         End Do
      End Do
      call m_Files_close_nfporb_rot_mat
    end subroutine save_porb_rot_matrix_cmplx

    subroutine printout_chg_densmat_mode
      integer :: ia, it, lmt, ilmta, il, im, tau, immax
      integer :: im2

      write(nfout,*)
      write(nfout,'(" --------- Orbital population rotated ---------")')

      if ( ipriorb_rot > 1 ) then
         write(nfout,'("  ia   l   m''  element coeff (1:2*l+1) ")')
         do ia=1,natm
            if (if_pdos(ia) == OFF) cycle
            if (iproj_group(ia) == 0) cycle
            it = ityp(ia)
            
            do lmt=1,ilmt_phi(it)
               ilmta = lmta_phi(lmt,ia)
               il = ltp_phi(lmt,it);   im = mtp_phi(lmt,it);   tau = taup_phi(lmt,it)
               immax = 2*il -1
               
               write(nfout,'(3(1x,i3),4x,a)') ia, il-1, im, speciesname(it)
               write(nfout,'(7(1x,f10.5))') &
                    &     ( porb_rot_matrix_real(ia,il,im2,im), im2=1, immax )
               write(nfout,*)
            end do
         end do
      endif

      write(nfout,'(A)',advance='no') &
           &  "  ia   l   m'  t    Porb(tot)  Porb(mx)   Porb(my)   Porb(mz) element"
      if ( sw_calc_score_sigma_bond == ON ) then
         write(nfout,'(A)',advance='no') "  score"
      endif
      if ( population_diag_mode == LOCAL_POINT_GROUP ) then
         write(nfout,'(A)') "  symmetry"
      else
         write(nfout,*)
      endif
      
      do ia=1,natm
         if (if_pdos(ia) == OFF) cycle
         if (iproj_group(ia) == 0) cycle
         it = ityp(ia)
       
         do lmt=1,ilmt_phi(it)
            ilmta = lmta_phi(lmt,ia)
            il = ltp_phi(lmt,it);  im = mtp_phi(lmt,it);  tau = taup_phi(lmt,it)
            write(nfout,'(4(1x,i3),4(1x,f10.5),4x,a)',advance='no') &
                 &        ia, il-1, im, tau, porb2(ia,il,im,:),speciesname(it)
            if ( sw_calc_score_sigma_bond == ON ) then
               write(nfout,'(1x,f8.4)',advance='no') score_sigma_bond(ia,il,im)
            endif
            if ( population_diag_mode == LOCAL_POINT_GROUP ) then
               write(nfout,'(2x,a8)') orb_irrep(ia,il,im)
            else
               write(nfout,*)
            endif
         end do
      end do
      write(nfout,*)
      
    end subroutine printout_chg_densmat_mode

    subroutine printout_spin_densmat_mode
      integer :: ia, it, lmt, ilmta, il, im, tau, immax
      integer :: im1, im2, is1
      real(kind=DP) ::val_j
      
      write(nfout,*)
      write(nfout,'(" --------- Orbital population rotated ---------")')
      if ( ipriorb_rot > 1 ) then
         write(nfout,'(A)') "  ia   l  ms'   element coeff (1:(2*l+1)*2) "
         do ia=1,natm
            if (if_pdos(ia) == OFF) cycle
            if (iproj_group(ia) == 0) cycle
            it = ityp(ia)
            
            do lmt=1,ilmt_phi(it)
               ilmta = lmta_phi(lmt,ia)
               il = ltp_phi(lmt,it);   im = mtp_phi(lmt,it);   tau = taup_phi(lmt,it)
               immax = 2*il -1
               
               Do is1=1, ndim_spinor
                  im1 = ndim_spinor*(im-1) +is1
                  
                  write(nfout,'(3(1x,i3),4x,a)') ia, il-1, im1, speciesname(it)
                  write(nfout,'(A)') "UP   spin component"
                  write(nfout,'(A,7(1x,f10.5))') &
                       &     "Re: ", (real(porb_rot_matrix_cmplx(ia,il,im2,im1)), &
                       &                   im2=1, immax )
                  write(nfout,'(A,7(1x,f10.5))') &
                       &     "Im: ", (aimag(porb_rot_matrix_cmplx(ia,il,im2,im1)), &
                       &                   im2=1, immax )
                  write(nfout,'(A)') "DOWN spin component"
                  write(nfout,'(A,7(1x,f10.5))') &
                       &   "Re: ", (real(porb_rot_matrix_cmplx(ia,il,immax+im2,im1)), &
                       &                 im2=1, immax )
                  write(nfout,'(A,7(1x,f10.5))') &
                       &   "Im: ", (aimag(porb_rot_matrix_cmplx(ia,il,immax+im2,im1)), &
                       &                  im2=1, immax )
                  write(nfout,*)
               end Do
            end do
         end do
      endif

      write(nfout,'(A)',advance='no') &
           & "  ia   l  ms'  t    Porb(tot)  Porb(mx)   Porb(my)   Porb(mz) element"
      if ( population_diag_mode == LOCAL_DOUBLE_POINT_GROUP ) then
         write(nfout,'(A)',advance='no')  "  j"
         write(nfout,'(A)') "   symmetry"
      else
         if ( sw_calc_score_sigma_bond == ON ) then
            write(nfout,'(A)',advance='no') "  score"
         endif
         write(nfout,*)
      endif
      do ia=1,natm
         if (if_pdos(ia) == OFF) cycle
         if (iproj_group(ia) == 0) cycle
         it = ityp(ia)
       
         do lmt=1,ilmt_phi(it)
            ilmta = lmta_phi(lmt,ia)
            il = ltp_phi(lmt,it);  im = mtp_phi(lmt,it);  tau = taup_phi(lmt,it)
            Do is1=1, ndim_spinor
               im1 = ndim_spinor*(im-1) +is1
               write(nfout,'(4(1x,i3),4(1x,f10.5),4x,a)',advance='no') &
                    &        ia, il-1, im1, tau, porb2(ia,il,im1,:),speciesname(it)
               if ( population_diag_mode == LOCAL_DOUBLE_POINT_GROUP ) then
                  if ( im1 <= 2*(il-1) ) then
                     val_j = il -1 -0.5d0
                  else
                     val_j = il -1 +0.5d0
                  endif
                  write(nfout,'(2x,i1,a2)',advance='no') nint(2*val_j),  "/2"
                  write(nfout,'(2x,a8)') orb_irrep(ia,il,im1)
               else
                  if ( sw_calc_score_sigma_bond == ON ) then
                     write(nfout,'(1x,f8.4)',advance='no') score_sigma_bond(ia,il,im1)
                  endif
                  write(nfout,*)
               endif
            End Do
         end do
      end do
      write(nfout,*)
       
    end subroutine printout_spin_densmat_mode

    subroutine printout_jeff_mode
      integer :: ia, it, lmt, ilmta, il, im, tau, immax
      integer :: im1, im2, is1
      character*18 comment

      write(nfout,*)
      write(nfout,'(" --------- Orbital population rotated ---------")')

      write(nfout,'("  ia   l   ms''  element coeff (1:(2*l+1)*2) ")')
      if ( ipriorb_rot > 1 ) then
         do ia=1,natm
            if (if_pdos(ia) == OFF) cycle
            if (iproj_group(ia) == 0) cycle
            it = ityp(ia)
            
            do lmt=1,ilmt_phi(it)
               ilmta = lmta_phi(lmt,ia)
               il = ltp_phi(lmt,it);   im = mtp_phi(lmt,it);   tau = taup_phi(lmt,it)
               immax = 2*il -1
               if ( il /= 2+1 ) cycle
               
               Do is1=1, ndim_spinor
                  im1 = ndim_spinor*(im-1) +is1
                  
                  comment = ""
                  if ( il == 2+1 ) then
                     if ( im1 <= 4 ) then
                        comment = "(t2g Jeff = 3/2)"
                     else if ( im1 <= 6 ) then
                        comment = "(t2g Jeff = 1/2)"
                     else
                        comment = "(eg)"
                     endif
                  endif
                  
                  write(nfout,'(3(1x,i3),4x,a,12x,a)') ia, il-1, im1, &
                       &                               speciesname(it), comment
                  write(nfout,'(A)') "UP   spin component"
                  write(nfout,'(A,7(1x,f10.5))') &
                       &     "Re: ", (real(porb_rot_matrix_cmplx(ia,il,im2,im1)), &
                       &                   im2=1, immax )
                  write(nfout,'(A,7(1x,f10.5))') &
                       &     "Im: ", (aimag(porb_rot_matrix_cmplx(ia,il,im2,im1)), &
                       &                   im2=1, immax )
                  write(nfout,'(A)') "DOWN spin component"
                  write(nfout,'(A,7(1x,f10.5))') &
                       &   "Re: ", (real(porb_rot_matrix_cmplx(ia,il,immax+im2,im1)), &
                       &                 im2=1, immax )
                  write(nfout,'(A,7(1x,f10.5))') &
                       &   "Im: ", (aimag(porb_rot_matrix_cmplx(ia,il,immax+im2,im1)), &
                       &                  im2=1, immax )
                  write(nfout,*)
               end Do
            end do
         end do
      endif

! ---
      write(nfout,'("  ia   l   ms''  t    Porb(tot)  Porb(mx)   Porb(my)   Porb(mz) element")')
      do ia=1,natm
         if (if_pdos(ia) == OFF) cycle
         if (iproj_group(ia) == 0) cycle
         it = ityp(ia)

         do lmt=1,ilmt_phi(it)
            ilmta = lmta_phi(lmt,ia)
            il = ltp_phi(lmt,it);  im = mtp_phi(lmt,it);  tau = taup_phi(lmt,it)
            if ( il /=2 +1 ) cycle

            Do is1=1, ndim_spinor
               im1 = ndim_spinor*(im-1) +is1

               comment = ""
               if ( il == 2+1 ) then
                  if ( im1 <= 4 ) then
                     comment = "(t2g Jeff = 3/2)"
                  else if ( im1 <= 6 ) then
                     comment = "(t2g Jeff = 1/2)"
                  else
                     comment = "(eg)"
                  endif
               endif
               write(nfout,'(4(1x,i3),4(1x,f10.5),4x,a,2x,a)') &
                    &        ia, il-1, im1, tau, porb2(ia,il,im1,:), &
                    &        speciesname(it), comment
            End Do
         end do
      end do
      write(nfout,*)

    end subroutine printout_jeff_mode

    subroutine printout_jrep_mode3
      integer :: ia, it, lmt, ilmta, il, im, tau, immax
      integer :: im1, im2, is1, my_l
      character*17 comment
      real(kind=DP) :: val_j, val_mj

      write(nfout,*)
      write(nfout,'(" --------- Orbital population rotated ---------")')

      if ( ipriorb_rot > 1 ) then
         write(nfout,'(A)') "  ia   l  ms'  element coeff (1:(2*l+1)*2) "
         do ia=1,natm
            if (if_pdos(ia) == OFF) cycle
            if (iproj_group(ia) == 0) cycle
            it = ityp(ia)
            
            do lmt=1,ilmt_phi(it)
               ilmta = lmta_phi(lmt,ia)
               il = ltp_phi(lmt,it);   im = mtp_phi(lmt,it);   tau = taup_phi(lmt,it)
               immax = 2*il -1
               
               Do is1=1, ndim_spinor
                  im1 = ndim_spinor*(im-1) +is1
                  
                  my_l = il -1
                  if ( my_l > 0 ) then
                     if ( im1 <= 2*my_l ) then
                        val_j = my_l -0.5d0;     val_mj = -val_j +(im1 -1)
                     else
                        val_j = my_l +0.5d0;     val_mj = -val_j +(im1 -2*my_l -1)
                     endif
                  else
                     val_j = my_l +0.5d0;        val_mj = -val_j +(im1 -2*my_l -1)
                  endif
                  write(comment,'(A,I1,A,I2,A)') "(j=",nint(2*val_j),"/2, mj=", &
                       &                          nint(2*val_mj), "/2)"
                  write(nfout,'(3(1x,i3),4x,a,12x,a)') ia, il-1, im1, &
                       &                               speciesname(it), comment
                  write(nfout,'(A)') "UP   spin component"
                  write(nfout,'(A,7(1x,f10.5))') &
                       &     "Re: ", (real(porb_rot_matrix_cmplx(ia,il,im2,im1)), &
                       &                   im2=1, immax )
                  write(nfout,'(A,7(1x,f10.5))') &
                       &     "Im: ", (aimag(porb_rot_matrix_cmplx(ia,il,im2,im1)), &
                       &                   im2=1, immax )
                  write(nfout,'(A)') "DOWN spin component"
                  write(nfout,'(A,7(1x,f10.5))') &
                       &   "Re: ", (real(porb_rot_matrix_cmplx(ia,il,immax+im2,im1)), &
                       &                 im2=1, immax )
                  write(nfout,'(A,7(1x,f10.5))') &
                       &   "Im: ", (aimag(porb_rot_matrix_cmplx(ia,il,immax+im2,im1)), &
                       &                  im2=1, immax )
                  write(nfout,*)
               end Do
            end do
         end do
      endif
! ---
      write(nfout,'(A,4X,A)') &
           &  "  ia   l  ms'  t    Porb(tot)  Porb(mx)   Porb(my)   Porb(mz) element", &
           &  "j     mj"
      do ia=1,natm
         if (if_pdos(ia) == OFF) cycle
         if (iproj_group(ia) == 0) cycle
         it = ityp(ia)

         do lmt=1,ilmt_phi(it)
            ilmta = lmta_phi(lmt,ia)
            il = ltp_phi(lmt,it);  im = mtp_phi(lmt,it);  tau = taup_phi(lmt,it)

            Do is1=1, ndim_spinor
               im1 = ndim_spinor*(im-1) +is1

               my_l = il -1
               if ( my_l > 0 ) then
                  if ( im1 <= 2*my_l ) then
                     val_j = my_l -0.5d0;       val_mj = -val_j +(im1 -1)
                  else
                     val_j = my_l +0.5d0;       val_mj = -val_j +(im1 -2*my_l -1)
                  endif
               else
                  val_j = my_l +0.5d0;          val_mj = -val_j +(im1 -2*my_l -1)
               endif
               write(comment,'(I1,A,I2,A)') nint(2*val_j),  "/2  ", &
                    &                       nint(2*val_mj), "/2"
               write(nfout,'(4(1x,i3),4(1x,f10.5),4x,a,2x,a,a)') &
                    &        ia, il-1, im1, tau, porb2(ia,il,im1,:), &
                    &        speciesname(it), "  ", adjustl(comment)
            End Do
         end do
      end do
      write(nfout,*)

    end subroutine printout_jrep_mode3

    subroutine set_porb_rot_matrix_jrep3
      integer :: ia, il, im1, im2, im3, im4, im0, is1, is2, istmp
      integer :: immax, lwork, info, size2
      complex(kind=CMPLDP) :: ztmp
      real(kind=DP), allocatable :: eigenval(:), rwork(:)
      complex(kind=CMPLDP), allocatable :: MatA(:,:), work(:), zwk(:,:)

      integer :: my_l, ma, m1, m2, num
      real(kind=DP) :: c1, c2, val_j, val_mj

      call set_Jcoeff_L0_L3

      Do ia=1, natm
         if (iproj_group(ia) == 0) cycle
         Do il=1, nloc
            immax = 2*il -1

            Do im0=1, immax *ndim_spinor
               Do im1=1, immax
                  Do is1=1, ndim_spinor
                     if ( il==1 ) then
                        porb_rot_matrix_cmplx(ia,il,immax*(is1-1)+im1,im0) &
                             & = JCoeff_L0(immax*(is1-1)+im1,im0)
                     else if ( il == 2 ) then
                        porb_rot_matrix_cmplx(ia,il,immax*(is1-1)+im1,im0) &
                             & = JCoeff_L1(immax*(is1-1)+im1,im0)
                     else if ( il == 3 ) then
                        porb_rot_matrix_cmplx(ia,il,immax*(is1-1)+im1,im0) &
                             & = JCoeff_L2(immax*(is1-1)+im1,im0)
                     else if ( il == 4 ) then
                        porb_rot_matrix_cmplx(ia,il,immax*(is1-1)+im1,im0) &
                             & = JCoeff_L3(immax*(is1-1)+im1,im0)
                     endif
                  End Do
               End Do
            End Do
         End Do
      End Do
      deallocate( JCoeff_L0 );      deallocate( JCoeff_L1 )
      deallocate( JCoeff_L2 );      deallocate( JCoeff_L3 )
! ---
    end subroutine set_porb_rot_matrix_jrep3

    subroutine set_porb_rot_matrix_jeff
      integer :: ia, il, im1, im2, im3, im4, im0, is1, is2, istmp
      integer :: immax_p, immax_d, lwork, info, size2
      complex(kind=CMPLDP) :: ztmp
      real(kind=DP), allocatable :: eigenval(:), rwork(:)
      complex(kind=CMPLDP), allocatable :: MatA(:,:), work(:), zwk(:,:)

      immax_p = 3;    immax_d = 5

      size2 = immax_p *ndim_spinor
      lwork = 2 *size2

      allocate( work(lwork) )
      allocate( eigenval(size2) ); eigenval = 0.0d0
      allocate( rwork( 3*size2 ) );
      allocate( MatA(size2,size2) )
      allocate( zwk(immax_p*ndim_spinor,immax_p*ndim_spinor) )

      Do ia=1, natm
         if (iproj_group(ia) == 0) cycle
         Do il=1, nloc
            if ( il /= 2+1 ) cycle
! --- t2g ----
            MatA = 0.0d0
            Do im1=1, immax_p
               Do im2=1, immax_p
                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        istmp = ( is1-1 )*ndim_spinor +is2
                        ztmp = 0.0d0
                        Do im3=1, immax_d
                           Do im4=1, immax_d
                              ztmp = ztmp +porb_rot_matrix_real(ia,il,im3,im1+2) &
                             &      *Mat_LS_with_real_ylm_L2(im3,im4,istmp) &
                             &      *porb_rot_matrix_real(ia,il,im4,im2+2)
                           End Do
                        End Do
                        MatA( immax_p*(is1-1)+im1, immax_p*(is2-1)+im2 ) = ztmp
                     End do
                  End Do
               end Do
            End Do

            call zheev( 'V', 'U', size2, MatA, size2, &
                 &       eigenval, work, lwork, rwork, info )

            Do im0=1, immax_p*ndim_spinor
               Do im1=1, immax_d
                  Do is1=1, ndim_spinor
                     ztmp = 0.0d0
                     Do im2=1, immax_p
                        ztmp = ztmp +MatA(immax_p*(is1-1)+im2,im0) &
                             &      *porb_rot_matrix_real(ia,il,im1,im2+2)
                     End Do
                     porb_rot_matrix_cmplx(ia,il,immax_d*(is1-1)+im1,im0) &
                          & = ztmp
                  End Do
               End Do
            End Do
! --- eg ----
            Do im1=immax_p+1, immax_d
               Do is1=1, ndim_spinor
                  im0 = (im1-1)*ndim_spinor+is1
                  Do im2=1, immax_d
                     porb_rot_matrix_cmplx(ia,il,immax_d*(is1-1)+im2,im0 ) &
                          & = porb_rot_matrix_real(ia,il,im2,im1-immax_p)
                  End do
               End Do
            ENd Do

         End Do
      End Do
      deallocate( MatA ); deallocate( zwk )
      deallocate( work ); deallocate( rwork ); deallocate( eigenval )
! ---
    end subroutine set_porb_rot_matrix_jeff

    subroutine set_dm
      dm(:,:,:,:,1) =   dm_ssrep(:,:,:,:,1) +dm_ssrep(:,:,:,:,4)
      dm(:,:,:,:,2) =   dm_ssrep(:,:,:,:,2) +dm_ssrep(:,:,:,:,3)
      dm(:,:,:,:,3) =  (dm_ssrep(:,:,:,:,2) -dm_ssrep(:,:,:,:,3)) *zi
      dm(:,:,:,:,4) =   dm_ssrep(:,:,:,:,1) -dm_ssrep(:,:,:,:,4)
    end subroutine set_dm

    subroutine set_porb2_from_spin_densmat
      integer :: ia, it, il, im1, im2, im3, is1, is2, is3, istmp, jj, size2, immax
      complex(kind=CMPLDP) :: PauliMatrix( ndim_magmom, ndim_spinor, ndim_spinor )
      complex(kind=CMPLDP) :: ztmp, z1, z2
      complex(kind=CMPLDP), allocatable :: zwk(:,:,:)

      call m_ES_set_Pauli_Matrix( PauliMatrix )

      do ia=1,natm
         it = ityp(ia)
         if (iproj_group(ia) == 0) cycle
         
         Do il=1, lmax
            immax = 2*il -1
            size2 = immax *ndim_spinor
            allocate( zwk(size2,size2,ndim_magmom ) ); zwk = 0.0d0

            Do jj=1, ndim_magmom
               Do im1=1, immax
                  Do im2=1, immax
                     Do is1=1, ndim_spinor
                        Do is2=1, ndim_spinor
                           ztmp = 0.0d0
                           Do is3=1, ndim_spinor
                              istmp = ( is1 -1 )*ndim_spinor + is3
                              ztmp = ztmp +dm_ssrep(ia,il,im1,im2,istmp) &
                                   &      *PauliMatrix(jj,is3,is2)
                           End Do
                           zwk(im1+immax*(is1-1),im2+immax*(is2-1),jj) &
                                &  = ztmp
                        End Do
                     End Do
                  End Do
               ENd Do
            End Do
            Do jj=1, ndim_magmom
               Do im1=1, size2
                  ztmp  = 0.0d0
                  DO is2=1, ndim_spinor
                     DO is3=1, ndim_spinor
                        Do im2=1, immax
                           Do im3=1, immax
                              z1 = porb_rot_matrix_cmplx( ia,il,immax*(is2-1)+im2,im1 )
                              z2 = porb_rot_matrix_cmplx( ia,il,immax*(is3-1)+im3,im1 )
                              ztmp = ztmp + conjg(z1) &
                                   &       *zwk(immax*(is2-1)+im2,immax*(is3-1)+im3,jj) &
                                   &       *z2
                             End Do
                          End Do
                     End Do
                  End DO
                  porb2( ia, il, im1, jj ) = ztmp
               End Do
            End Do
            deallocate( zwk )
         End Do
      End do
    end subroutine set_porb2_from_spin_densmat

    subroutine set_porb2_from_chgmag_densmat
      integer :: ia, il, immax, size2, im1, im2, im3, is
      real(kind=DP) :: ctmp, cwk(ndim_chgpot)

      do ia=1,natm
         if (iproj_group(ia) == 0) cycle
         
         Do il=1, lmax
            immax = 2*il -1
            size2 = immax
            
            Do im1=1, size2
               DO is=1, ndim_magmom
                  ctmp = 0.0d0
                  Do im2=1, immax
                     Do im3=1, immax
                        ctmp = ctmp &
                             &    + porb_rot_matrix_real( ia,il,im2,im1 )  &
                             &     *dm(ia,il,im2,im3,is) &
                             &     *porb_rot_matrix_real( ia,il,im3,im1 )
                     End Do
                  End Do
                  cwk(is) = ctmp
               End DO
               porb2( ia, il, im1, 1:ndim_magmom ) = cwk(1:ndim_magmom)
            End Do
         End Do
      ENd do
            
    end subroutine set_porb2_from_chgmag_densmat

    subroutine diagonalize_spin_densmat
      integer :: ia, il, im1, im2, is1, is2, lwork, size2, immax, istmp, info
      real(kind=DP), allocatable :: rwork(:), eigenval(:)
      complex(kind=CMPLDP), allocatable :: amat(:,:), work(:)
!
      do ia=1,natm
         if (iproj_group(ia) == 0) cycle
         
         Do il=1, lmax
            immax = 2*il -1
            size2 = immax *ndim_spinor

            lwork = 2 *size2
            
            allocate( work(lwork) )
            allocate( amat(size2,size2) ); amat = 0.0d0
            allocate( eigenval(size2) ); eigenval = 0.0d0
            allocate( rwork( 3*size2 ) );

            amat = 0.0d0
            Do im1=1, immax
               Do im2=1, immax
                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        istmp = ( is1 -1 )*ndim_spinor + is2
                        amat(im1+immax*(is1-1),im2+immax*(is2-1)) &
                             &  = dm_ssrep(ia,il,im1,im2,istmp)
                     End Do
                  End Do
               ENd Do
            End Do

            call zheev( 'V', 'U', size2, amat, size2, &
                 &       eigenval, work, lwork, rwork, info )

            if (info /= 0) then
               write(nfout,*) 'zheev : info=',info
            end if
            
            Do im1=1, size2
               Do im2=1, size2
!                  porb_rot_matrix_cmplx( ia,il,im2,im1 ) = amat(im2,im1) &
!                       &            * sqrt( eigenval(im1) )
                  porb_rot_matrix_cmplx( ia,il,im2,im1 ) = amat(im2,im1) 
               ENd Do
            End Do
! --
            deallocate( amat );
            deallocate(rwork,work)
            deallocate( eigenval );
         end do
      end do
    end subroutine diagonalize_spin_densmat

    subroutine diagonalize_chg_densmat
      integer :: ia, il, immax, size2, lwork, im1, im2, info
      real(kind=DP) :: abstol,nfound, ctmp

      integer, allocatable :: iwork(:),ifail(:)
      real(kind=DP), allocatable :: rwork(:), amat(:,:), evec(:), rvmat(:,:)
      real(kind=DP), external :: dlamch
!
      do ia=1,natm
         if (iproj_group(ia) == 0) cycle

         Do il=1, lmax
            immax = 2*il -1;
            lwork = 8 *immax
            allocate( rwork(lwork) );
            allocate( iwork(5*immax) );   allocate( ifail(immax) )
            allocate( amat(immax,immax) )
            allocate( evec(immax) )
            allocate( rvmat(immax,immax) )

            amat = 0.0d0
            Do im1=1, immax
               Do im2=1, immax
                  amat(im1,im2) = dm(ia,il,im1,im2,1)
               ENd Do
            End Do
            call dsyevx( 'V', 'A', 'U', immax, amat, immax, 0.d0, 0.d0, 0, 0, &
                 &       abstol, nfound, evec, rvmat, immax, rwork, lwork, &
                 &       iwork, ifail, info )
            if (info /= 0) then
               write(nfout,*) 'dsyevx: info=',info
            end if

            Do im1=1, immax
               Do im2=1, immax
                  porb_rot_matrix_real( ia,il,im2,im1 ) = rvmat(im2,im1)
               ENd Do
            End Do
            deallocate(rwork);  deallocate(iwork);   deallocate(ifail)
            deallocate(amat);   deallocate(evec);    deallocate(rvmat)
         end do
      end do
    end subroutine diagonalize_chg_densmat
    
  end subroutine m_OP_rotation_noncl

  subroutine m_OP_alloc_compri_rot
    use m_Control_Parameters,  only : sw_diagonalize_population, population_diag_mode
    use m_Const_Parameters,    only : DIAG_CHARGE_DENSITY_MATRIX
    integer :: num_orbitals, kfac

    kfac = 1
    if ( noncol ) then
       if ( sw_diagonalize_population == ON ) then
          if ( population_diag_mode /= DIAG_CHARGE_DENSITY_MATRIX ) then
             kfac = ndim_spinor
          endif
       endif
    endif
    num_orbitals = nlmta_phi *kfac
    allocate(compr_rot_l(np_e,num_orbitals,nopr,ista_k:iend_k))
    allocate(compi_rot_l(np_e,num_orbitals,nopr,ista_k:iend_k))
    compr_rot_l = 0.d0; compi_rot_l = 0.0d0    
    
  end subroutine m_OP_alloc_compri_rot

  subroutine m_OP_dealloc_compri_rot
    if (allocated(compr_rot_l) ) deallocate(compr_rot_l)
    if (allocated(compi_rot_l) ) deallocate(compi_rot_l)
  end subroutine m_OP_dealloc_compri_rot

  subroutine m_OP_set_compri_rot
    use m_Control_Parameters,  only : population_diag_mode
    use m_Const_Parameters,    only : DIAG_CHARGE_DENSITY_MATRIX

    if ( population_diag_mode == DIAG_CHARGE_DENSITY_MATRIX ) then
       call set_compri_rot_chgden_mode
    else
       call set_compri_rot_spnden_mode
    endif
  end subroutine m_OP_set_compri_rot

  subroutine set_compri_rot_chgden_mode
    integer :: ik, ib, ia, it, immax
    integer :: lmt1, lmt2, il1, il2, im1, im2, tau1, tau2, iorb1, iorb2
    integer :: is1, is2, jj1, jj2, istmp
    complex(kind=CMPLDP), allocatable :: ztmp(:), zwork(:,:,:)

    allocate( ztmp(nopr) )
    allocate( zwork(nlmta_phi,nopr,1) );

    do ik = 1, kv3
       if(map_k(ik) /= myrank_k) cycle

       do ib = 1, np_e
          zwork = 0.0d0;
          do iorb1=1, nlmta_phi
             zwork(iorb1,:,1) = cmplx( compr_l(ib,iorb1,:,ik), &
                  &                    compi_l(ib,iorb1,:,ik) )
          end do
          do ia=1,natm
             it = ityp(ia)
             if (iproj_group(ia) == 0) cycle

             do lmt1=1,ilmt_phi(it)
                il1 = ltp_phi(lmt1,it);      im1 = mtp_phi(lmt1,it)
                tau1 = taup_phi(lmt1,it);    iorb1 = lmta_phi(lmt1,ia)
                immax = 2*il1 -1

                ztmp = 0.0d0
                do lmt2=1, ilmt_phi(it)
                   il2 = ltp_phi(lmt2,it);    im2 = mtp_phi(lmt2,it)
                   tau2 = taup_phi(lmt2,it);  iorb2 = lmta_phi(lmt2,ia)
                   if ( il1 /= il2 ) cycle
                   if ( tau1 /= tau2 ) cycle
                   ztmp(:) = ztmp(:) &
                        &    + porb_rot_matrix_real(ia,il1,im2,im1) &
                        &                 *zwork(iorb2,:,1)
                end do
                compr_rot_l(ib,iorb1,:,ik) = real(ztmp(:))
                compi_rot_l(ib,iorb1,:,ik) = aimag(ztmp(:))
             end do
          end do
       end do
    end do
    deallocate( ztmp );      deallocate( zwork )
  end subroutine set_compri_rot_chgden_mode

  subroutine set_compri_rot_spnden_mode
    integer :: ik, ib, ia, it, immax
    integer :: lmt1, lmt2, il1, il2, im1, im2, tau1, tau2, iorb1, iorb2
    integer :: is1, is2, jj1, jj2, istmp
    complex(kind=CMPLDP), allocatable :: ztmp(:,:), zwork(:,:,:)

    allocate( ztmp(nopr,ndim_spinor) )
    allocate( zwork(nlmta_phi,nopr,ndim_spinor) );

    do ik = 1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle

       do ib = 1, np_e
          zwork = 0.0d0;
          do iorb1=1, nlmta_phi
             zwork(iorb1,1:nopr,1) = cmplx( compr_l(ib,iorb1,1:nopr,ik), &
                  &                    compi_l(ib,iorb1,1:nopr,ik) )
             zwork(iorb1,1:nopr,2) = cmplx( compr_l(ib,iorb1,1:nopr,ik+1), &
                  &                    compi_l(ib,iorb1,1:nopr,ik+1) )
          end do

          do ia=1,natm
             it = ityp(ia)
             if (iproj_group(ia) == 0) cycle

             do lmt1=1,ilmt_phi(it)
                il1 = ltp_phi(lmt1,it);      im1 = mtp_phi(lmt1,it)
                tau1 = taup_phi(lmt1,it);    iorb1 = lmta_phi(lmt1,ia)
                immax = 2*il1 -1

                Do is1=1, ndim_spinor
                   ztmp = 0.0d0;

                   do lmt2=1, ilmt_phi(it)
                      il2 = ltp_phi(lmt2,it);    im2 = mtp_phi(lmt2,it)
                      tau2 = taup_phi(lmt2,it);  iorb2 = lmta_phi(lmt2,ia)
                      if ( il1 /= il2 ) cycle
                      if ( tau1 /= tau2 ) cycle

                      Do is2=1, ndim_spinor
                         jj2 = immax*(is2-1) +im2
                         jj1 = (im1 -1)*ndim_spinor +is1
                         ztmp(:,is2) = ztmp(:,is2) &
                              &      + conjg(porb_rot_matrix_cmplx(ia,il1,jj2,jj1)) &
                              &        *zwork(iorb2,:,is2)
                      end do
                   end do
                   compr_rot_l(ib,ndim_spinor*(iorb1-1)+is1,:,ik) &
                        &          = real(ztmp(:,1))
                   compi_rot_l(ib,ndim_spinor*(iorb1-1)+is1,:,ik) &
                        &          = aimag(ztmp(:,1))
                   compr_rot_l(ib,ndim_spinor*(iorb1-1)+is1,:,ik+1) &
                        &          = real(ztmp(:,2))
                   compi_rot_l(ib,ndim_spinor*(iorb1-1)+is1,:,ik+1) &
                       &          = aimag(ztmp(:,2))
                end do
             end do
          end do
       end do
    end do
    deallocate( ztmp );    deallocate( zwork )
  end subroutine set_compri_rot_spnden_mode

! ========================================================
  subroutine m_OP_init_Wfn_orb_proj(nfout)
    use m_Control_Parameters,  only : population_diag_mode, sw_diagonalize_population, &
         &                            sw_read_orb_rot_mat_file, &
         &                            sw_calc_score_sigma_bond, &
         &                            sw_write_rotated_orbitals
    use m_Const_Parameters,    only : DIAG_CHARGE_DENSITY_MATRIX, LOCAL_POINT_GROUP
    use m_Files,   only : nfporb_dens_mat, nfporb_rot_mat, &
         &                m_Files_open_nfporb_dens_mat, m_Files_close_nfporb_dens_mat, &
         &                m_Files_open_nfporb_rot_mat, m_Files_close_nfporb_rot_mat
    
    integer, intent(in) :: nfout
    
    integer :: lmax, mmax
    
    lmax = nloc;   mmax = 2*lmax -1
    
    if ( sw_diagonalize_population == ON ) then
       if ( sw_read_orb_rot_mat_file == OFF ) then
          if ( noncol ) then
             call read_porb_dens_mat_ssrep
             call m_OP_rotation_noncl(nfout)
             deallocate(dm_ssrep)
          else
             call read_porb_dens_mat
             call m_OP_rotation_col(nfout)
             deallocate(dm)
          endif
       else
          if ( population_diag_mode == DIAG_CHARGE_DENSITY_MATRIX ) then
             call read_porb_rot_matrix_real
          else if ( population_diag_mode == LOCAL_POINT_GROUP ) then
             allocate( orb_irrep(natm,lmax,mmax) )
             call m_OP_calc_symm
          else
             if ( noncol ) call read_porb_rot_matrix_cmplx
          endif
          if ( sw_calc_score_sigma_bond == ON ) then
             if ( allocated(score_sigma_bond) ) deallocate(score_sigma_bond)
             allocate( score_sigma_bond(natm,lmax,mmax) );   score_sigma_bond = 0.0d0
             call m_OP_calc_score_sigma_bond
          endif
       endif
    endif
    if ( sw_write_rotated_orbitals == ON ) call m_OP_wd_phirt2_rotated    

  contains

    subroutine read_porb_dens_mat
      integer :: ia, il, immax, im, im2, size2, is
      integer :: lmax, mmax, lun, num
      
      lmax = nloc;   mmax = 2*lmax -1
      
      if ( allocated(dm) ) deallocate(dm)
      allocate( dm(natm,lmax,mmax,mmax,nspin) ); dm = 0.0d0
      
      if ( mype == 0 ) then
         call m_Files_open_nfporb_dens_mat(1)
         lun = nfporb_dens_mat
         
         Do ia=1, natm
            if (iproj_group(ia) == 0) cycle
            read(lun) num
            Do is=1, nspin
               read(lun) num
               Do il=1, nloc
                  immax = 2*il -1
                  read(lun) num
                  Do im=1, immax
                     read(lun) ( dm(ia,il,im2,im,is), im2=1, immax )
                  End Do
               End do
            End Do
         End Do
         call m_Files_close_nfporb_dens_mat
      endif
      size2 = natm *nloc *mmax *mmax *nspin
      call mpi_bcast( dm, size2, mpi_double_precision, &
           &          0, mpi_comm_group, ierr )
      
    end subroutine read_porb_dens_mat

    subroutine read_porb_dens_mat_ssrep
      integer :: ia, il, immax, im, im2, size2, is
      integer :: lmax, mmax, lun, num
      
      lmax = nloc;   mmax = 2*lmax -1
      
      if ( allocated(dm_ssrep) ) deallocate(dm_ssrep)
      allocate( dm_ssrep(natm,lmax,mmax,mmax,ndim_chgpot) ); dm_ssrep = 0.0d0
      
      if ( mype == 0 ) then
         call m_Files_open_nfporb_dens_mat(1)
         lun = nfporb_dens_mat
         
         Do ia=1, natm
            if (iproj_group(ia) == 0) cycle
            read(lun) num
            Do is=1, ndim_chgpot
               read(lun) num
               Do il=1, nloc
                  immax = 2*il -1
                  read(lun) num
                  Do im=1, immax
                     read(lun) ( dm_ssrep(ia,il,im2,im,is), im2=1, immax )
                  End Do
               End do
            End Do
         End Do
         call m_Files_close_nfporb_dens_mat
      endif
      size2 = natm *nloc *mmax *mmax *ndim_chgpot *2
      call mpi_bcast( dm_ssrep, size2, mpi_double_precision, &
           &          0, mpi_comm_group, ierr )
      
    end subroutine read_porb_dens_mat_ssrep

    subroutine read_porb_rot_matrix_real
      integer :: ia, il, immax, im, im2, size2, lmax, mmax, num
      integer :: lun

      lmax = nloc;   mmax = 2*lmax -1

      if ( allocated(porb_rot_matrix_real) ) deallocate( porb_rot_matrix_real )
      allocate( porb_rot_matrix_real(natm,lmax,mmax,mmax) ); 
      porb_rot_matrix_real = 0.0d0

      if ( mype == 0 ) then
         call m_Files_open_nfporb_rot_mat(1)
         lun = nfporb_rot_mat
         read(lun) num
         
         Do ia=1, natm
            if (iproj_group(ia) == 0) cycle
            read(lun) num
            Do il=1, nloc
               immax = 2*il -1
               read(lun) num
               Do im=1, immax
                  read(lun) ( porb_rot_matrix_real(ia,il,im2,im), im2=1, immax )
               End do
            End Do
         End Do
         call m_Files_close_nfporb_rot_mat
      endif
      size2 = natm *nloc *mmax *mmax
      call mpi_bcast( porb_rot_matrix_real, size2, mpi_double_precision, &
           &          0, mpi_comm_group, ierr )
!
    end subroutine read_porb_rot_matrix_real

    subroutine read_porb_rot_matrix_cmplx
      integer :: ia, il, immax, im, im2, size2, lmax, mmax, num, fac
      integer :: lun

      lmax = nloc;   mmax = 2*lmax -1
      fac = ndim_spinor

      if ( allocated(porb_rot_matrix_cmplx) ) deallocate( porb_rot_matrix_cmplx )
      allocate( porb_rot_matrix_cmplx(natm,lmax,fac*mmax,fac*mmax) ); 
      porb_rot_matrix_cmplx = 0.0d0

      if ( mype == 0 ) then
         call m_Files_open_nfporb_rot_mat(1)
         lun = nfporb_rot_mat
         read(lun) num

         Do ia=1, natm
            if (iproj_group(ia) == 0) cycle
            read(lun) num
            Do il=1, nloc
               immax = 2*il -1
               read(lun) num
               Do im=1, immax*fac
                  read(lun) ( porb_rot_matrix_cmplx(ia,il,im2,im), im2=1, immax*fac )
               End do
            End Do
         End Do
         call m_Files_close_nfporb_rot_mat
      endif

      size2 = natm *nloc *mmax *mmax *fac *fac *2
      call mpi_bcast( porb_rot_matrix_cmplx, size2, mpi_double_precision, &
           &          0, mpi_comm_group, ierr )

    end subroutine read_porb_rot_matrix_cmplx

  end subroutine m_OP_init_Wfn_orb_proj

  subroutine m_OP_wd_Wfn_orb_proj
    use m_Control_Parameters,  only : population_diag_mode, sw_diagonalize_population, &
         &                            use_rotated_compri, SpinOrbit_mode, ekmode, &
         &                            wf_orb_proj_print_format, &
         &                            sw_calc_score_sigma_bond
    use m_Const_Parameters,    only : DIAG_CHARGE_DENSITY_MATRIX, &
         &                            DIAG_SPIN_DENSITY_MATRIX, &
         &                            DIAG_LS_with_t2g_octa, DIAG_LS, zi, Neglected, &
         &                            LOCAL_POINT_GROUP
    use m_PseudoPotential, only :    nloc, ntau, iproj_phi, lmtt_phi
    use m_Files,               only : m_Files_open_nfporb_rot_mat, &
         &                            m_Files_close_nfporb_rot_mat, nfporb_rot_mat, &
         &                            nfwfk_orb_proj, &
         &                            m_Files_open_nfwfk_orb_proj, &
         &                            m_Files_close_nfwfk_orb_proj
    
    integer :: lmax, mmax
    integer :: neg_t, kfac, num_orbitals
    real(kind=DP), allocatable :: compr(:,:,:,:), compi(:,:,:,:), norm_phig_mpi(:,:)
    
    kfac = 1
    if ( sw_diagonalize_population == ON ) then
       if ( population_diag_mode /= DIAG_CHARGE_DENSITY_MATRIX ) then
          if ( noncol ) kfac = ndim_spinor
       endif
    endif

    lmax = nloc;   mmax = ( 2*lmax -1 )*kfac
    num_orbitals = nlmta_phi *kfac
    
    if ( sw_diagonalize_population == ON .and. use_rotated_compri == YES ) then
       call m_OP_alloc_compri_rot
       call m_OP_set_compri_rot
    endif
    
    allocate(compr(neg,num_orbitals,1,kv3));  compr = 0.d0
    allocate(compi(neg,num_orbitals,1,kv3));  compi = 0.d0
    if(.not.allocated(norm_phig_mpi)) allocate(norm_phig_mpi(nlmtt_phi,kv3/nspin))
    norm_phig_mpi=0.d0

    call set_array_compri_etc
    
    neg_t = neg -num_extra_bands

    if ( mype == 0 ) then
       if ( ekmode == ON ) then
          if ( nk_in_the_process == 1 ) then
             call m_Files_open_nfwfk_orb_proj(2)
             call print_header
          else
             call m_Files_open_nfwfk_orb_proj(3)
          endif
       else
          call m_Files_open_nfwfk_orb_proj(2)
          call print_header
       endif
    endif
    
    if ( sw_diagonalize_population == ON ) then
       if ( use_rotated_compri == YES ) then
          if ( population_diag_mode == DIAG_CHARGE_DENSITY_MATRIX ) then
             call case_mode1
          else 
             if ( noncol ) call case_mode2
          endif
       else
          if ( population_diag_mode == DIAG_CHARGE_DENSITY_MATRIX &
               & .or. population_diag_mode == LOCAL_POINT_GROUP ) then
             call case_mode1
          else 
             if ( noncol ) call case_mode2
          endif
       endif
    else
       if ( SpinOrbit_Mode /= Neglected .and. wf_orb_proj_print_format == 1 ) then
          call case_with_j
       else
          call case_mode1
       endif
    endif

    if ( mype == 0 ) call m_Files_close_nfwfk_orb_proj

    deallocate( compr ); deallocate( compi ); deallocate( norm_phig_mpi )

    call m_OP_dealloc_compri_rot

  contains
    
    subroutine print_header
      integer :: num, iorb, ia, il, im, tau

      num = 0
      Do iorb=1, nlmta_phi
         call m_PP_tell_iorb_ia_l_m_tau(iorb,ia,il,im,tau)
         if ( iproj_group(ia) == 0 ) cycle
         num = num +1
      End Do

      write(nfwfk_orb_proj,'(A)') '# Orbital Projection for bands '
      write(nfwfk_orb_proj,*)
      write(nfwfk_orb_proj,'(A,I8)') 'num_kpoints = ', max(kv3,kv3_ek) /ndim_spinor
      write(nfwfk_orb_proj,'(A,I8)') 'num_bands   = ', neg_t
      write(nfwfk_orb_proj,'(A,I8)') 'nspin       = ', nspin /ndim_spinor
      write(nfwfk_orb_proj,'(A,I8)') 'num of orbitals = ', num *kfac
      write(nfwfk_orb_proj,*)
    end subroutine print_header

    subroutine set_array_compri_etc
      integer :: ik, ie, ib, iksnl
      integer :: iorb, lmt
      integer :: ia, il, im, tau, is
      real(kind=DP), allocatable :: compr_mpi(:,:,:,:), compi_mpi(:,:,:,:), &
           &                        norm_phig_mpi2(:,:)
      real(kind=DP), allocatable :: porb(:)

      do ik = 1, kv3
         if(map_k(ik) /= myrank_k) cycle
         iksnl = (ik-1)/nspin + 1
         if ( sw_diagonalize_population==ON .and. use_rotated_compri==YES ) then
            do ie = ista_e, iend_e, istep_e
               ib = map_z(ie)
               compr(ie,1:num_orbitals,1,ik) = compr_rot_l(ib,1:num_orbitals,1,ik)
               compi(ie,1:num_orbitals,1,ik) = compi_rot_l(ib,1:num_orbitals,1,ik)
             end do
         else
            do ie = ista_e, iend_e, istep_e
               ib = map_z(ie)
               compr(ie,1:num_orbitals,1,ik) = compr_l(ib,1:num_orbitals,1,ik)
               compi(ie,1:num_orbitals,1,ik) = compi_l(ib,1:num_orbitals,1,ik)
             end do
         endif
         norm_phig_mpi(1:nlmtt_phi,iksnl)  = norm_phig(1:nlmtt_phi,iksnl)
      end do
      
      if ( npes >1 ) then
         allocate( compr_mpi( neg, num_orbitals, 1, kv3 ) ); compr_mpi = 0.0d0
         allocate( compi_mpi( neg, num_orbitals, 1, kv3 ) ); compi_mpi = 0.0d0
         allocate( norm_phig_mpi2( nlmtt_phi, kv3/nspin ) )
         call mpi_allreduce( compr, compr_mpi, neg*num_orbitals*1*kv3, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         call mpi_allreduce( compi, compi_mpi, neg*num_orbitals*1*kv3, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         call mpi_allreduce( norm_phig_mpi, norm_phig_mpi2, nlmtt_phi*kv3/nspin, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         compr = compr_mpi;   compi = compi_mpi
         norm_phig_mpi = norm_phig_mpi2 /dble(nrank_e)
         deallocate( compr_mpi ); deallocate( compi_mpi );
         deallocate( norm_phig_mpi2 )
      end if
    end subroutine set_array_compri_etc

! ==========
    subroutine case_mode1
      integer :: ik, iorb, ia, il, im, tau, ib
      integer :: iksnl, lmtt, it, is
      
      real(kind=DP), allocatable :: porb(:,:)
      logical, save :: First = .true.
      
      if ( mype /= 0 ) return

      if ( First ) then
         write(nfwfk_orb_proj,'(A,I3)') "population_diag_mode = ", population_diag_mode
         write(nfwfk_orb_proj,'(A)') 
         write(nfwfk_orb_proj,'(A)') "# Orbital Info."
         if ( sw_diagonalize_population == ON ) then
            write(nfwfk_orb_proj,'(A)',advance='no') &
                 &    "  iorb  ia  l  m' tau  element  key"
            if ( sw_calc_score_sigma_bond == ON ) then
               write(nfwfk_orb_proj,'(A)',advance='no') "  score_bond"
            endif
            if ( population_diag_mode == LOCAL_POINT_GROUP ) then
               write(nfwfk_orb_proj,'(A)') "  symmetry"
            else
               write(nfwfk_orb_proj,*)
            endif
         else
            write(nfwfk_orb_proj,'(A)') "  iorb  ia  l  m  tau  element  key"
         endif

         Do iorb=1, num_orbitals
            call m_PP_tell_iorb_ia_l_m_tau(iorb,ia,il,im,tau)
            if ( iproj_group(ia) == 0) cycle
            it = ityp(ia)
            if ( sw_diagonalize_population == ON ) then
               write(nfwfk_orb_proj,'(I5,I5,I3,I3,2X,I3,4X,A5,I4)',advance='no') &
                    &       iorb, ia, il-1, im, tau, speciesname(it), atom_key(ia)
               if ( sw_calc_score_sigma_bond == ON ) then
                  write(nfwfk_orb_proj,'(1X,F10.5)',advance='no') &
                    &       score_sigma_bond(ia,il,im)
               endif
               if ( population_diag_mode == LOCAL_POINT_GROUP ) then
                  write(nfwfk_orb_proj,'(5x,a8)') orb_irrep(ia,il,im)
               else
                  write(nfwfk_orb_proj,*)
               endif
            else
               write(nfwfk_orb_proj,'(I5,I5,I3,I3,I3,4X,A5,I6)') &
                    &       iorb, ia, il-1, im, tau, speciesname(it), atom_key(ia)
            endif
         End Do
         write(nfwfk_orb_proj,*)
         First = .false.
      endif
      
      allocate( porb( neg,nlmta_phi) )

      do ik = 1, kv3, ndim_spinor
         iksnl = (ik-1)/nspin + 1

         write(nfwfk_orb_proj,'(A)') "================= "
         if ( ekmode == ON ) then
            write(nfwfk_orb_proj,'(A,I6,A,3F16.8,A)') 'ik = ', &
                 &            ik +nk_in_the_process -1, " ( ", vkxyz(ik,1:3,BUCS), " )"
         else
            write(nfwfk_orb_proj,'(A,I6,A,3F16.8,A)') 'ik = ', &
                 &            ik, " ( ", vkxyz(ik,1:3,BUCS), " )"
         endif

         porb = 0.0d0
         if ( sw_diagonalize_population == OFF .or. use_rotated_compri == YES ) then
            do iorb = 1,nlmta_phi
               call m_PP_tell_iorb_lmtt(iorb,lmtt)
               Do is=1, ndim_spinor
                  do ib = 1, neg
                     porb(ib,iorb) = porb(ib,iorb) &
                       & + ( compr(ib,iorb,1,ik+is-1)**2 &
                       &    +compi(ib,iorb,1,ik+is-1)**2 ) &
                       &     *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl) )
                  end do
               end do
            End Do
         else
            call set_porb_mode1( ik, porb )
         endif
         
         do iorb = 1,nlmta_phi
            call m_PP_tell_iorb_ia_l_m_tau(iorb,ia,il,im,tau)
            if ( iproj_group(ia) == 0) cycle

            if ( sw_diagonalize_population == ON ) then
               write(nfwfk_orb_proj,'(I5,I5,3I3,A)') iorb, ia, il-1, im, tau, &
                    &                             " : iorb, ia, l, m', tau"
            else
               write(nfwfk_orb_proj,'(I5,I5,3I3,A)') iorb, ia, il-1, im, tau, &
                    &                             " : iorb, ia, l, m, tau"
            endif
            write(nfwfk_orb_proj,'(4F18.10)') ( porb(ib,iorb ), ib=1, neg_t )
         end do
         write(nfwfk_orb_proj,*)
      end do
      deallocate( porb )

    end subroutine case_mode1

    subroutine set_porb_mode1( ik, porb )
      integer, intent(in) :: ik
      real(kind=DP), intent(out) :: porb( neg,nlmta_phi*ndim_spinor )

      integer :: ia, ib, it, lmax, mmax, immax, ismax
      integer :: lmt, il, im, tau, ip, iorb, lmtt
      integer :: lmt1, lmt2, im1, im2, iorb1, iorb2, lmtt1, lmtt2
      integer :: is, is1, is2, istmp, iksnl, im3
      real(kind=DP) :: c1, c2, ctmp
      complex(kind=CMPLDP) :: ztmp, z1, z2

      complex(kind=CMPLDP), allocatable :: dm_ssrep(:,:,:,:,:)
      real(kind=DP), allocatable :: porb0(:,:,:,:), dm(:,:,:,:,:)

      lmax = nloc;   mmax = 2*lmax -1
      iksnl = (ik-1)/nspin + 1

      if ( noncol ) then
         allocate( dm_ssrep( ntau, lmax, mmax, mmax, ndim_chgpot ) );
         allocate( dm( ntau, lmax, mmax, mmax, ndim_magmom ) );
         allocate( porb0( ntau, lmax, mmax, ndim_magmom ) );
      else
         allocate( dm_ssrep( ntau, lmax, mmax, mmax, 1 ) );
         allocate( dm( ntau, lmax, mmax, mmax, 1 ) );
         allocate( porb0( ntau, lmax, mmax, 1 ) );
      endif

      ibloop: do ib=1, neg
         do ia=1,natm
            it = ityp(ia)
            if(iproj_group(ia) == 0) cycle
            
            dm_ssrep = 0.0d0;  dm = 0.0d0;  porb0 = 0.d00
            
            ! diagonal part
            do lmt=1,ilmt_phi(it)
               il = ltp_phi(lmt,it); im  = mtp_phi(lmt,it);
               tau = taup_phi(lmt,it)
               ip  = iproj_phi(lmt,it)
               iorb = lmta_phi(lmt,ia); lmtt = lmtt_phi(lmt,it)
               
               if ( noncol ) then
                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        istmp = ( is1 -1 )*ndim_spinor + is2
                        
                        z1 = dcmplx( compr(ib,iorb,1,ik+is1-1 ), &
                             &       compi(ib,iorb,1,ik+is1-1 ) )
                        z2 = dcmplx( compr(ib,iorb,1,ik+is2-1 ), &
                             &       compi(ib,iorb,1,ik+is2-1 ) )
                        ztmp = z1 *conjg(z2) &
                             &      *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl) )
                        dm_ssrep(tau,il,im,im,istmp) = dm_ssrep(tau,il,im,im,istmp) &
                             &                        +ztmp
                     end do
                  end Do
               else
                  z1 = dcmplx( compr(ib,iorb,1,ik ), &
                       &       compi(ib,iorb,1,ik ) )
                  z2 = dcmplx( compr(ib,iorb,1,ik ), &
                       &       compi(ib,iorb,1,ik ) )
                  ztmp = z1 *conjg(z2) &
                       &      *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl) )
                  dm_ssrep(tau,il,im,im,1) = dm_ssrep(tau,il,im,im,1) +ztmp
               endif
            end do
            ! non-diagonal part
            do lmt2=1,ilmt_phi(it)
               do lmt1=1,ilmt_phi(it)
                  if ( lmt1 == lmt2 ) cycle
                  if (ltp_phi(lmt1,it) /= ltp_phi(lmt2,it)) cycle
                  if (taup_phi(lmt1,it) /= taup_phi(lmt2,it)) cycle
                  
                  il = ltp_phi(lmt1,it);     tau = taup_phi(lmt1,it)
                  ip  = iproj_phi(lmt1,it)
                  im1   = mtp_phi(lmt1,it);     im2 = mtp_phi(lmt2,it); 
                  iorb1 = lmta_phi(lmt1,ia);  iorb2 = lmta_phi(lmt2,ia)
                  lmtt1 = lmtt_phi(lmt1,it);  lmtt2 = lmtt_phi(lmt2,it)
                  
                  c1 = ( qorb(iorb1) +qorb(iorb2) ) /2.0d0      ! approx
                  c2 = sqrt(norm_phig_mpi(lmtt1,iksnl)*norm_phig_mpi(lmtt2,iksnl))
                  
                  if ( noncol ) then
                     Do is1=1, ndim_spinor
                        Do is2=1, ndim_spinor
                           istmp = ( is1 -1 )*ndim_spinor + is2
                           z1 = dcmplx( compr(ib,iorb1,1,ik+is1-1 ), &
                                &       compi(ib,iorb1,1,ik+is1-1 ) )
                           z2 = dcmplx( compr(ib,iorb2,1,ik+is2-1 ), &
                                &       compi(ib,iorb2,1,ik+is2-1 ) )
                           ztmp = z1 *conjg(z2) *( 1.0d0 +c1 /c2 )
                           dm_ssrep(tau,il,im1,im2,istmp) &
                                &  = dm_ssrep(tau,il,im1,im2,istmp) + ztmp
                        end do
                     end do
                  else
                     z1 = dcmplx( compr(ib,iorb1,1,ik ), &
                          &       compi(ib,iorb1,1,ik ) )
                     z2 = dcmplx( compr(ib,iorb2,1,ik ), &
                          &       compi(ib,iorb2,1,ik ) )
                     ztmp = z1 *conjg(z2) *( 1.0d0 +c1 /c2 )
                     dm_ssrep(tau,il,im1,im2,1) = dm_ssrep(tau,il,im1,im2,1) +ztmp
                  endif
               end do
            end do
            
            if ( noncol ) then
               dm(:,:,:,:,1) =  dm_ssrep(:,:,:,:,1) +dm_ssrep(:,:,:,:,4)
               dm(:,:,:,:,2) =  dm_ssrep(:,:,:,:,2) +dm_ssrep(:,:,:,:,3)
               dm(:,:,:,:,3) = (dm_ssrep(:,:,:,:,2) -dm_ssrep(:,:,:,:,3)) *zi
               dm(:,:,:,:,4) =  dm_ssrep(:,:,:,:,1) -dm_ssrep(:,:,:,:,4)
               ismax = 1
            else
               dm(:,:,:,:,1) = dm_ssrep(:,:,:,:,1)
               ismax = 1
            endif
            ! ----
            Do tau=1, ntau
               Do il=1, lmax
                  immax = 2 *il -1
                  Do im1=1, immax
                     DO is=1, ismax
                        ctmp = 0.0d0
                        Do im2=1, immax
                           Do im3=1, immax
                              ctmp = ctmp &
                                   &    +porb_rot_matrix_real( ia,il,im2,im1 )  &
                                   &       *dm(tau,il,im2,im3,is) &
                                   &       *porb_rot_matrix_real( ia,il,im3,im1 )
                           End Do
                        End Do
                        porb0( tau, il, im1, is ) = ctmp
                     End DO
                  End DO
               End Do
            End Do
            
            Do lmt=1,ilmt_phi(it)
               il = ltp_phi(lmt,it);  im  = mtp_phi(lmt,it);  iorb = lmta_phi(lmt,ia)
               tau = taup_phi(lmt,it)
               porb( ib,iorb ) = porb0( tau, il,im,1 )
            ENd do
         End do
      End do ibloop
      deallocate( dm ); deallocate( dm_ssrep ); deallocate( porb0 )
      
    end subroutine set_porb_mode1
! ==========
    
    subroutine case_mode2
      integer :: ik, iorb1, ia, il, im, tau, iksnl, lmtt
      integer :: im0, iorb0, my_l, ib, it
      real(kind=DP) :: val_j, val_mj
      complex(kind=CMPLDP) :: z1, z2

      real(kind=DP), allocatable :: porb(:,:)
      logical, save :: First = .true.
      
      if ( mype /= 0 ) return

      if ( First ) then
         write(nfwfk_orb_proj,'(A,I3)') "population_diag_mode = ", population_diag_mode
         write(nfwfk_orb_proj,'(A)')
         write(nfwfk_orb_proj,'(A)') "# Orbital Info."

         if ( population_diag_mode == DIAG_LS ) then
            write(nfwfk_orb_proj,'(A)') &
                 &                 "  iorb  ia  l  ms'  tau elment   j    mj"

            do iorb1 = 1, nlmta_phi *ndim_spinor
               iorb0 = int( (iorb1-1)/ndim_spinor )+1
               call m_PP_tell_iorb_ia_l_m_tau(iorb0,ia,il,im0,tau)
               if ( iproj_group(ia) == 0) cycle
               im = ( im0 -1 )*ndim_spinor +mod( iorb1 -1, ndim_spinor ) +1
               it = ityp(ia);  my_l = il -1

               if ( my_l > 0 ) then
                  if ( im <= 2*my_l ) then
                     val_j = my_l -0.5d0;    val_mj = -val_j +(im -1)
                  else
                     val_j = my_l +0.5d0;    val_mj = -val_j +(im -2*my_l -1)
                  endif
               else
                  val_j = my_l +0.5d0;       val_mj = -val_j +(im -2*my_l -1)
               endif
               write(nfwfk_orb_proj,'(I5,I5,I3,I3,I3,4X,A5,X,F4.1,X,F4.1)') &
               &       iorb1, ia, il-1, im, tau, speciesname(it), &
               &       val_j, val_mj
            end do

         else
            write(nfwfk_orb_proj,'(A)',advance='no') &
                 &           "  iorb  ia  l  ms'   tau  element  key"
            if ( sw_calc_score_sigma_bond == ON ) then
               write(nfwfk_orb_proj,'(A)',advance='no') "  score_bond"
            endif
            if ( population_diag_mode == LOCAL_POINT_GROUP ) then
               write(nfwfk_orb_proj,'(A)') "  symmetry"
            else
               write(nfwfk_orb_proj,*)
            endif
            
            do iorb1 = 1, nlmta_phi *ndim_spinor
               iorb0 = int( (iorb1-1)/ndim_spinor )+1
               call m_PP_tell_iorb_ia_l_m_tau(iorb0,ia,il,im0,tau)
               if ( iproj_group(ia) == 0) cycle
               im = ( im0 -1 )*ndim_spinor +mod( iorb1 -1, ndim_spinor ) +1
               it = ityp(ia)
               write(nfwfk_orb_proj,'(I5,I5,I3,I3,I3,4X,A5,I6)') &
                    &       iorb1, ia, il-1, im, tau, speciesname(it), atom_key(ia)
               if ( sw_calc_score_sigma_bond == ON ) then
                  write(nfwfk_orb_proj,'(3X,F10.5)',advance='no') &
                    &       score_sigma_bond(ia,il,im)
               endif
               if ( population_diag_mode == LOCAL_POINT_GROUP ) then
                  write(nfwfk_orb_proj,'(5x,a8)') orb_irrep(ia,il,im)
               else
                  write(nfwfk_orb_proj,*)
               endif
            end do
         endif
         write(nfwfk_orb_proj,*) 
         First = .false.
      endif

      allocate( porb( neg,nlmta_phi*ndim_spinor ) )

      do ik = 1, kv3, ndim_spinor         
         iksnl = (ik-1)/nspin + 1

         write(nfwfk_orb_proj,'(A)') "================= "
         if ( ekmode == ON ) then
            write(nfwfk_orb_proj,'(A,I6,A,3F16.8,A)') 'ik = ', &
                 &            ik +nk_in_the_process -1, " ( ", vkxyz(ik,1:3,BUCS), " )"
         else
            write(nfwfk_orb_proj,'(A,I6,A,3F16.8,A)') 'ik = ', &
                 &            ik, " ( ", vkxyz(ik,1:3,BUCS), " )"
         endif
         
         porb = 0.0d0
         if ( use_rotated_compri == YES ) then
            do iorb1 = 1, nlmta_phi *ndim_spinor
               iorb0 = int( (iorb1-1)/ndim_spinor )+1
               call m_PP_tell_iorb_lmtt(iorb0,lmtt)
               do ib = 1, neg
                  z1 = dcmplx( compr(ib,iorb1,1,ik ),   compi(ib,iorb1,1,ik   ) )
                  z2 = dcmplx( compr(ib,iorb1,1,ik+1),  compi(ib,iorb1,1,ik+1 ) )
                  porb(ib,iorb1) = porb(ib,iorb1) &
                       &   + (z1+z2)*conjg(z1+z2) &
                       &     *( 1.d0+qorb(iorb0)/norm_phig_mpi(lmtt,iksnl) )
               end do
            end do
         else
            call set_porb_mode2( ik, porb )
         endif

         do iorb1 = 1, nlmta_phi *ndim_spinor
            iorb0 = int( (iorb1-1)/kfac )+1
            call m_PP_tell_iorb_ia_l_m_tau(iorb0,ia,il,im0,tau)
            if ( iproj_group(ia) == 0) cycle

            im = ( im0 -1 )*ndim_spinor +mod( iorb1 -1, ndim_spinor ) +1

            if ( population_diag_mode == DIAG_LS ) then
               my_l = il -1
               if ( my_l > 0 ) then
                  if ( im <= 2*my_l ) then
                     val_j = my_l -0.5d0;     val_mj = -val_j +(im -1)
                  else
                     val_j = my_l +0.5d0;     val_mj = -val_j +(im -2*my_l -1)
                  endif
               else
                  val_j = my_l +0.5d0;        val_mj = -val_j +(im -2*my_l -1)
               endif
               write(nfwfk_orb_proj,'(I5,I5, 3I3,A,A,F4.1,A,F4.1,A)') &
                    &                iorb1, ia, il-1, im, tau, &
                    &                ' : iorb, ia, l, ms'', tau', &
                    &                "     ( j= ", val_j, "  mj= ", val_mj, " )"
            else
               write(nfwfk_orb_proj,'(I5,I5,3I3,A)') &
                    &                iorb1, ia, il-1, im, tau, &
                    &                ' : iorb, ia, l, ms'', tau'
            endif
            write(nfwfk_orb_proj,'(4F18.10)') &
                 &              ( porb(ib,iorb1 ), ib=1, neg_t )
         End Do
         write(nfwfk_orb_proj,*)
      end do
      deallocate( porb )

    end subroutine case_mode2

    subroutine set_porb_mode2( ik, porb )
      integer, intent(in) :: ik
      real(kind=DP), intent(out) :: porb( neg,nlmta_phi*ndim_spinor )

      integer :: ia, ib, it, lmax, mmax, immax, ismax
      integer :: lmt, il, im, tau, ip, iorb, lmtt
      integer :: lmt1, lmt2, im1, im2, iorb1, iorb2, lmtt1, lmtt2
      integer :: is, is1, is2, is3, istmp, iksnl, im3
      real(kind=DP) :: c1, c2
      complex(kind=CMPLDP) :: ztmp, z1, z2, z3
      real(kind=DP), allocatable :: porb0(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: dm_ssrep(:,:,:,:,:), dm(:,:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk(:,:)
      complex(kind=CMPLDP) :: PauliMatrix( ndim_magmom, ndim_spinor, ndim_spinor )

      lmax = nloc;   mmax = 2*lmax -1

      allocate( dm_ssrep( ntau, lmax, mmax, mmax, ndim_chgpot ) );
      allocate( porb0( ntau, lmax, mmax*ndim_spinor, ndim_magmom ) );
      allocate( zwk( mmax*ndim_spinor, mmax*ndim_spinor ) );

      call m_ES_set_Pauli_Matrix( PauliMatrix )

      iksnl = (ik-1)/nspin + 1

      ibloop: do ib=1, neg
         do ia=1,natm
            it = ityp(ia)
            if(iproj_group(ia) == 0) cycle
            
            dm_ssrep = 0.0d0;  dm = 0.0d0;  porb0 = 0.d00
            
            ! diagonal part
            do lmt=1,ilmt_phi(it)
               il = ltp_phi(lmt,it); im  = mtp_phi(lmt,it);
               tau = taup_phi(lmt,it)
               ip  = iproj_phi(lmt,it)
               iorb = lmta_phi(lmt,ia); lmtt = lmtt_phi(lmt,it)
               
               Do is1=1, ndim_spinor
                  Do is2=1, ndim_spinor
                     istmp = ( is1 -1 )*ndim_spinor + is2
                     
                     z1 = dcmplx( compr(ib,iorb,1,ik+is1-1 ), &
                          &       compi(ib,iorb,1,ik+is1-1 ) )
                     z2 = dcmplx( compr(ib,iorb,1,ik+is2-1 ), &
                          &       compi(ib,iorb,1,ik+is2-1 ) )
                     ztmp = z1 *conjg(z2) &
                          &      *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl) )
                     dm_ssrep(tau,il,im,im,istmp) = dm_ssrep(tau,il,im,im,istmp) &
                          &                        +ztmp
                  end do
               end Do
            end do
            ! non-diagonal part
            do lmt2=1,ilmt_phi(it)
               do lmt1=1,ilmt_phi(it)
                  if ( lmt1 == lmt2 ) cycle
                  if (ltp_phi(lmt1,it) /= ltp_phi(lmt2,it)) cycle
                  if (taup_phi(lmt1,it) /= taup_phi(lmt2,it)) cycle
                  
                  il = ltp_phi(lmt1,it);     tau = taup_phi(lmt1,it)
                  ip  = iproj_phi(lmt1,it)
                  im1   = mtp_phi(lmt1,it);     im2 = mtp_phi(lmt2,it); 
                  iorb1 = lmta_phi(lmt1,ia);  iorb2 = lmta_phi(lmt2,ia)
                  lmtt1 = lmtt_phi(lmt1,it);  lmtt2 = lmtt_phi(lmt2,it)
                  
                  c1 = ( qorb(iorb1) +qorb(iorb2) ) /2.0d0      ! approx
                  c2 = sqrt(norm_phig_mpi(lmtt1,iksnl)*norm_phig_mpi(lmtt2,iksnl))
                  
                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        istmp = ( is1 -1 )*ndim_spinor + is2
                        z1 = dcmplx( compr(ib,iorb1,1,ik+is1-1 ), &
                             &       compi(ib,iorb1,1,ik+is1-1 ) )
                        z2 = dcmplx( compr(ib,iorb2,1,ik+is2-1 ), &
                             &       compi(ib,iorb2,1,ik+is2-1 ) )
                        ztmp = z1 *conjg(z2) *( 1.0d0 +c1 /c2 )
                        dm_ssrep(tau,il,im1,im2,istmp) &
                             &  = dm_ssrep(tau,il,im1,im2,istmp) + ztmp
                     end do
                  end do
               end do
            end do
            
            ismax = 1
            ! ----
            Do tau=1, ntau
               Do il=1, lmax
                  immax = 2 *il -1
                  Do is=1, ndim_magmom
                     zwk = 0.0d0
                     
                     Do im1=1, immax
                        Do im2=1, immax
                           Do is1=1, ndim_spinor
                              Do is2=1, ndim_spinor
                                 ztmp = 0.0d0
                                 Do is3=1, ndim_spinor
                                    istmp = ( is1 -1 )*ndim_spinor + is3
                                    ztmp = ztmp +dm_ssrep(tau,il,im1,im2,istmp) &
                                         &      *PauliMatrix(is,is3,is2)
                                 End Do
                                 zwk(im1+immax*(is1-1),im2+immax*(is2-1)) = ztmp
                              End Do
                           End Do
                        End Do
                     ENd Do
                     Do im1=1, immax *ndim_spinor
                        ztmp = 0.0d0
                        DO is2=1, ndim_spinor
                           DO is3=1, ndim_spinor
                              Do im2=1, immax
                                 Do im3=1, immax
                                    z1 = porb_rot_matrix_cmplx(ia,il,immax*(is2-1)+im2,im1)
                                    z2 = zwk(immax*(is2-1)+im2,immax*(is3-1)+im3) 
                                    z3 = porb_rot_matrix_cmplx(ia,il,immax*(is3-1)+im3,im1)
                                    ztmp = ztmp +conjg(z1) *z2 *z3
                                 End Do
                              End Do
                           End Do
                        End DO
                        porb0( tau, il, im1, is ) = ztmp
                     End Do
                  End Do
               End Do
            End Do
            
            Do lmt=1,ilmt_phi(it)
               il = ltp_phi(lmt,it);  im1 = mtp_phi(lmt,it);  iorb1 = lmta_phi(lmt,ia)
               tau = taup_phi(lmt,it)
               Do is1=1, ndim_spinor
                  im2 = (im1 -1)*ndim_spinor +is1
                  iorb2 = (iorb1 -1)*ndim_spinor +is1
                  porb( ib,iorb2 ) = porb0( tau, il,im2,1 )
               ENd do
            End Do
         End do
      End do ibloop
      deallocate( dm_ssrep ); deallocate( zwk ); deallocate( porb0 )

    end subroutine set_porb_mode2
! =========

    subroutine case_with_j
      integer :: ik, iksnl, ia, ig, ii, it, ilp, ll, tau, ip
      integer :: iorb, lmtt1, ib, m1
      real(kind=DP) :: c1, c2
      complex(kind=CMPLDP) :: z1, z2

      real(kind=DP), allocatable :: porb(:)
      complex(kind=CMPLDP), allocatable :: zcomp(:,:,:)

      logical, save :: First = .true.

      if ( mype /= 0 ) return

      allocate( porb(neg) )

      Do ik=1, kv3, ndim_spinor
         write(nfwfk_orb_proj,'(A)') "================= "
         if ( ekmode == ON ) then
            write(nfwfk_orb_proj,'(A,I6,A,3F16.8,A)') 'ik = ', &
                 &            ik +nk_in_the_process -1, " ( ", vkxyz(ik,1:3,BUCS), " )"
         else
            write(nfwfk_orb_proj,'(A,I6,A,3F16.8,A)') 'ik = ', &
                 &            ik, " ( ", vkxyz(ik,1:3,BUCS), " )"
         endif

         iksnl = ( ik -1 )/nspin +1

         Do ia=1, natm
            ig = iproj_group(ia)
            if ( ig == 0 ) cycle

            do ii=1,num_proj_elems(ig)
               ip = proj_group( ii, ig )
               it = proj_attribute(ip)%ityp
               ilp = proj_attribute(ip)%l +1
               ll = proj_attribute(ip)%l
               tau = proj_attribute(ip)%t
!
               allocate( zcomp( -ll:ll, neg, ndim_spinor ) ); zcomp = 0.0d0
               call tranform_compri_r2c_sph( ia, it, ll, tau, ik, &
                    &                        compr, compi, zcomp )

               if ( ll == 0 ) then
                  call find_iorb_from_lmt( ia, it, ll, 1, tau, iorb )
                  call m_PP_tell_iorb_lmtt( iorb, lmtt1 )

                  write(nfwfk_orb_proj,'(I5,F7.2,I3,F7.2,I3,A)') &
                       &         ia, ll+0.5d0, ll, 0.5d0, tau, ' : ia, j, l, mj, tau'
                  Do ib=1, neg
                     z1 = cmplx( compr(ib,iorb,1,ik),   compi(ib,iorb,1,ik) )
                     z2 = cmplx( compr(ib,iorb,1,ik+1), compi(ib,iorb,1,ik+1) )
                     porb(ib) = ( z1*conjg(z1) +z2*conjg(z2) ) &
                          &     *( 1.d0+qorb(iorb)/norm_phig_mpi( lmtt1, iksnl ) )
                  End Do
                  write(nfwfk_orb_proj,'(4F18.10)') &
                       &               ( porb( neordr(ib,ik) ), ib=1, neg_t )
               else
! j_up
                  Do m1=-ll -1, ll
                     c1 = dble( ll +m1 + 1 ) / dble( 2 *ll +1 )
                     c2 = dble( ll -m1 )     / dble( 2 *ll +1 )
                     c1 = sqrt(c1);  c2 = sqrt(c2)

                     call find_iorb_from_lmt( ia, it, ll, 1, tau, iorb )
                     call m_PP_tell_iorb_lmtt( iorb, lmtt1 )

                     write(nfwfk_orb_proj,'(I5,F7.2,I3,F7.2,I3,A)') &
                          &         ia, ll+0.5d0, ll, m1+0.5d0, tau, &
                          &             ' : ia, j, l, mj, tau'
                     Do ib=1, neg
                        z1 = 0.0d0
                        if ( m1 > -ll -1 ) z1 = z1 +c1 *zcomp( m1,    ib, 1 )
                        if ( m1 < ll     ) z1 = z1 +c2 *zcomp( m1 +1, ib, 2 )
                        porb(ib) = z1 *conjg(z1) &
                             &     *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt1,iksnl) )
                     End Do
                     write(nfwfk_orb_proj,'(4F18.10)') &
                          &         ( porb( neordr(ib,ik) ), ib=1, neg_t )
                  End Do
! j_down
                  Do m1=-ll+1, ll
                     c1 = dble( ll -m1 + 1 ) / dble( 2 *ll +1 )
                     c2 = dble( ll +m1 )     / dble( 2 *ll +1 )
                     c1 = sqrt(c1);  c2 = -sqrt(c2)

                     call find_iorb_from_lmt( ia, it, ll, 1, tau, iorb )
                     call m_PP_tell_iorb_lmtt( iorb, lmtt1 )

                     write(nfwfk_orb_proj,'(I5,F7.2,I3,F7.2,I3,A)') &
                          &         ia, ll-0.5d0, ll, m1-0.5d0, tau, &
                          &             ' : ia, j, l, mj, tau'
                     Do ib=1, neg
                        z1 = c1 *zcomp( m1-1, ib, 1 ) +c2 *zcomp( m1, ib, 2 )
                        porb(ib) = z1 *conjg(z1) &
                             &     *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt1,iksnl) )
                     End Do
                     write(nfwfk_orb_proj,'(4F18.10)') &
                          &         ( porb(ib), ib=1, neg_t )
                  End Do
               end if
               deallocate( zcomp )

            End Do
         End Do
         write(nfwfk_orb_proj,*)

      End Do
      deallocate( porb )

    end subroutine case_with_j

    subroutine tranform_compri_r2c_sph( ia, it, ll, tau, ik, &
         &                              compr, compi, zcomp )
      integer, intent(in) :: ia, it, ll, tau, ik
      real(kind=DP), intent(in) :: compr( neg, nlmta_phi, 1, kv3 )
      real(kind=DP), intent(in) :: compi( neg, nlmta_phi, 1, kv3 )
      complex(kind=CMPLDP), intent(out) :: zcomp( -ll:ll, neg, ndim_spinor )

      integer :: m1, m2, ib, iorb
      complex(kind=CMPLDP) :: z1
      complex(kind=CMPLDP) :: ztmp( ndim_spinor )

      Do m1=-ll, ll
         Do m2=1, 2*ll +1
            call find_iorb_from_lmt( ia, it, ll, m2, tau, iorb )
            Do ib=1, neg
               ztmp(1) = cmplx( compr(ib,iorb,1,ik),   compi(ib,iorb,1,ik)   )
               ztmp(2) = cmplx( compr(ib,iorb,1,ik+1), compi(ib,iorb,1,ik+1) )

               if ( ll == 0 ) z1 = MatU_ylm_RC_L0( m2, m1 )
               if ( ll == 1 ) z1 = MatU_ylm_RC_L1( m2, m1 )
               if ( ll == 2 ) z1 = MatU_ylm_RC_L2( m2, m1 )
               if ( ll == 3 ) z1 = MatU_ylm_RC_L3( m2, m1 )

               zcomp(m1,ib,:) = zcomp(m1,ib,:) +z1 *ztmp(:)
            End Do
         End Do
      End Do
    end subroutine tranform_compri_r2c_sph

    subroutine find_iorb_from_lmt( ia, it, ll, mm, tau, iorb )
      integer, intent(in) :: ia, it, ll, mm, tau
      integer, intent(out) :: iorb

      integer :: lmt1, l1, m1, t1

      iorb = 0
      Do lmt1=1, ilmt_phi(it)
         l1 = ltp_phi(lmt1,it); m1 = mtp_phi(lmt1,it);  t1 = taup_phi(lmt1,it)
         if ( l1 == ll +1 .and. m1 == mm .and. t1 == tau ) then
            exit
         endif
      ENd Do
      iorb = lmta_phi( lmt1,ia )

    end subroutine find_iorb_from_lmt

  end subroutine m_OP_wd_Wfn_orb_proj

  subroutine m_OP_wd_phirt2_rotated
    use m_PseudoPotential,  only : nlmt_phi, ilmt_phi, ltp_phi, mtp_phi, taup_phi, &
         &                         phirt, xh, radr_paw, rmax, nmesh
    use m_Ionic_System,  only : cps, pos
    use m_Control_Parameters,  only : population_diag_mode
    use m_Const_Parameters,   only : DIAG_CHARGE_DENSITY_MATRIX, &
         &                           DIAG_SPIN_DENSITY_MATRIX, DIAG_LS_with_t2g_octa, &
         &                           LOCAL_POINT_GROUP, LOCAL_DOUBLE_POINT_GROUP
!
    call change_of_coordinate_system(altv,pos,natm,natm,cps)

    select case( population_diag_mode )
    case ( DIAG_CHARGE_DENSITY_MATRIX )
       call case_spinor1_basis
    case ( DIAG_SPIN_DENSITY_MATRIX )
       call case_spinor2_basis
    case ( DIAG_LS_with_t2g_octa )
       call case_spinor2_basis
    case ( LOCAL_POINT_GROUP )
       call case_spinor1_basis
    case ( LOCAL_DOUBLE_POINT_GROUP )
       call case_spinor2_basis
    end select

  contains

    subroutine case_spinor1_basis
      integer :: ia, it
      integer :: lmt1, il1, im1, tau1, lmt2, il2, im2, tau2
      real(kind=DP) :: rcut, dx, dy, dz
      real(kind=DP) :: origin(3), vec_span(3,3)
      real(kind=DP), allocatable :: phi_on_mesh(:,:,:,:)
      real(kind=DP), allocatable :: phi2_on_mesh(:,:,:)

      real(kind=DP), allocatable :: phi_on_mesh_rot(:,:,:)

      integer :: lun = 4000
      integer :: nxmax, nymax, nzmax

      nxmax = 10;     nymax = 10;     nzmax = 10

      Do ia=1, natm
         it = ityp(ia)
         if (iproj_group(ia) == 0) cycle

         rcut = 3.0d0
         dx = rcut /nxmax;        dy = rcut /nymax;        dz = rcut /nzmax

         origin(1:3) = cps(ia,1:3) -rcut
         vec_span = 0.0d0
         vec_span(1,1) = rcut *2;   vec_span(2,2) = rcut *2;   vec_span(3,3) = rcut *2

         allocate( phi_on_mesh(nlmt_phi,-nxmax:nxmax,-nymax:nymax,-nzmax:nzmax) )
         allocate( phi_on_mesh_rot(-nxmax:nxmax,-nymax:nymax,-nzmax:nzmax) )
         allocate( phi2_on_mesh(-nxmax:nxmax,-nymax:nymax,-nzmax:nzmax) )

         call set_phirt_on_mesh( it, -nxmax, nxmax, -nymax, nymax, -nzmax, nzmax, &
              &                  dx, dy, dz, phi_on_mesh )
         ! -
         do lmt1=1,ilmt_phi(it)
            il1 = ltp_phi(lmt1,it);  im1 = mtp_phi(lmt1,it);  tau1 = taup_phi(lmt1,it)

            phi_on_mesh_rot = 0.0d0

            Do lmt2=1, ilmt_phi(it)
               il2 = ltp_phi(lmt2,it);  im2 = mtp_phi(lmt2,it);  tau2 = taup_phi(lmt2,it)
               if ( il1 /= il2 ) cycle
               if ( tau1 /= tau2 ) cycle
               phi_on_mesh_rot(:,:,:) = phi_on_mesh_rot(:,:,:) &
                    &                  +porb_rot_matrix_real(ia,il1,im2,im1) &
                    &                   *phi_on_mesh(lmt2,:,:,:)
            End Do
            phi2_on_mesh(:,:,:) = phi_on_mesh_rot(:,:,:)  &
                 &               *phi_on_mesh_rot(:,:,:)

            if ( mype == 0 ) then
               call printout_phi2( lun, ia, il1, im1, tau1, &
                    &             -nxmax, nxmax, -nymax, nymax, -nzmax, nzmax, &
                    &              origin, vec_span, phi2_on_mesh, 1 )
            endif
         End do
         deallocate( phi_on_mesh );       deallocate( phi_on_mesh_rot )
         deallocate( phi2_on_mesh )
      End Do

    end subroutine case_spinor1_basis

    subroutine case_spinor2_basis
      integer :: ia, it
      integer :: lmt1, il1, im1, tau1, lmt2, il2, im2, tau2
      integer :: j1, j2, is1, is2, immax
      real(kind=DP) :: rcut, dx, dy, dz
      real(kind=DP) :: origin(3), vec_span(3,3)
      real(kind=DP), allocatable :: phi_on_mesh(:,:,:,:)
      real(kind=DP), allocatable :: phi2_on_mesh(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: phi_on_mesh_rot(:,:,:,:)

      integer :: lun = 4000
      integer :: nxmax, nymax, nzmax

      nxmax = 10;     nymax = 10;     nzmax = 10

      Do ia=1, natm
         it = ityp(ia)
         if (iproj_group(ia) == 0) cycle

         rcut = 3.0d0
         dx = rcut /nxmax;        dy = rcut /nymax;        dz = rcut /nzmax

         origin(1:3) = cps(ia,1:3) -rcut
         vec_span = 0.0d0
         vec_span(1,1) = rcut *2;   vec_span(2,2) = rcut *2;   vec_span(3,3) = rcut *2

         allocate( phi_on_mesh(nlmt_phi,-nxmax:nxmax,-nymax:nymax,-nzmax:nzmax) )
         allocate( phi_on_mesh_rot(-nxmax:nxmax,-nymax:nymax,-nzmax:nzmax,ndim_spinor) )
         allocate( phi2_on_mesh(-nxmax:nxmax,-nymax:nymax,-nzmax:nzmax,ndim_spinor) )

         call set_phirt_on_mesh( it, -nxmax, nxmax, -nymax, nymax, -nzmax, nzmax, &
              &                  dx, dy, dz, phi_on_mesh )
         ! -
         do lmt1=1,ilmt_phi(it)
            il1 = ltp_phi(lmt1,it);  im1 = mtp_phi(lmt1,it);  tau1 = taup_phi(lmt1,it)

            if ( population_diag_mode == DIAG_LS_with_t2g_octa ) then
               if ( il1 /= 2 +1 ) cycle
            endif

            Do is1=1, ndim_spinor
               phi_on_mesh_rot = 0.0d0

               Do lmt2=1, ilmt_phi(it)
                  il2 = ltp_phi(lmt2,it);  im2 = mtp_phi(lmt2,it);
                  tau2 = taup_phi(lmt2,it)
                  immax = 2 *il2 -1
                  if ( il1 /= il2 ) cycle
                  if ( tau1 /= tau2 ) cycle
                  Do is2=1, ndim_spinor
                     j1 = ( im1 -1 )*ndim_spinor +is1
                     j2 = immax *(is2 -1) +im2

                     phi_on_mesh_rot(:,:,:,is2) = phi_on_mesh_rot(:,:,:,is2) &
                       &                        +porb_rot_matrix_cmplx(ia,il1,j2,j1)&
                       &                        *phi_on_mesh(lmt2,:,:,:)
                  End do
               End Do
#if 0
               phi2_on_mesh(:,:,:,1) = conjg( phi_on_mesh_rot(:,:,:,1) ) &
                    &                  *phi_on_mesh_rot(:,:,:,1)
               phi2_on_mesh(:,:,:,2) = conjg( phi_on_mesh_rot(:,:,:,2) ) &
                    &                  *phi_on_mesh_rot(:,:,:,2)
               if ( mype == 0 ) then
                  call printout_phi2( lun, ia, il1, j1, tau1, &
                       &             -nxmax, nxmax, -nymax, nymax, -nzmax, nzmax, &
                       &              origin, vec_span, phi2_on_mesh, 2 )
               endif
#else
               phi2_on_mesh(:,:,:,1) = conjg( phi_on_mesh_rot(:,:,:,1) ) &
                    &                  *phi_on_mesh_rot(:,:,:,1) &
                    &                +conjg( phi_on_mesh_rot(:,:,:,2) ) &
!                    &                -conjg( phi_on_mesh_rot(:,:,:,2) ) &
                    &                  *phi_on_mesh_rot(:,:,:,2)
               if ( mype == 0 ) then
                  call printout_phi2( lun, ia, il1, j1, tau1, &
                       &             -nxmax, nxmax, -nymax, nymax, -nzmax, nzmax, &
                       &              origin, vec_span, phi2_on_mesh, 1 )
               endif
#endif
            End Do
         End do
         deallocate( phi_on_mesh );       deallocate( phi_on_mesh_rot )
         deallocate( phi2_on_mesh )
      End Do

    end subroutine case_spinor2_basis

    subroutine printout_phi2( lun, ia, il, im, tau, &
         &                    nxs, nxe, nys, nye, nzs, nze, &
         &                    origin, vec_span, phi2_on_mesh, ncomp )
      integer, intent(in) :: lun, ia, il, im, tau, ncomp
      integer, intent(in) :: nxs, nxe, nys, nye, nzs, nze
      real(kind=DP), intent(in) :: phi2_on_mesh(nxs:nxe,nys:nye,nzs:nze,ncomp)
      real(kind=DP), intent(in) :: origin(3), vec_span(3,3)

      integer :: i, nx, ny, nz
      character*4 char1
      character*1 char2, char4
      character*2, char3
      character*64 file1

      write(char1,'(I4.4)') ia
      write(char2,'(I1.1)') il -1
      write(char3,'(I2.2)') im
      write(char4,'(I1.1)') tau

      file1 = "phirot_squared.ia_" // char1 // ".l_" // char2 // ".tau_" &
           &                 // char4 // ".no_" // char3 // ".xsf"
      open( unit=lun, file=file1, status="unknown", form="formatted" )

      write(lun,'(A)') 'CRYSTAL'
      write(lun,'(A)') 'PRIMVEC'
      write(lun,'(3F20.10)') altv(1:3,1) *Bohr
      write(lun,'(3F20.10)') altv(1:3,2) *Bohr
      write(lun,'(3F20.10)') altv(1:3,3) *Bohr
      write(lun,'(A)') 'CONVVEC'
      write(lun,'(3F20.10)') altv(1:3,1) *Bohr
      write(lun,'(3F20.10)') altv(1:3,2) *Bohr
      write(lun,'(3F20.10)') altv(1:3,3) *Bohr
      write(lun,'(A)') 'PRIMCOORD'
      write(lun,*) natm, 1
      Do i=1, natm
         write(lun,'(I5,3F20.10)') nint(iatomn(ityp(i))), cps(i,1:3)*Bohr
      End Do
      write(lun,'(A)') "BEGIN_BLOCK_DATAGRID_3D"
      write(lun,'(A,I6,A,I4,A,I4,A,I4,A)') &
           &    "  phi2 on mesh ( ia=", ia, ", il=", il, ", tau=", tau, &
           &                      ", no=", im,  " )"
      write(lun,'(A)') "BEGIN_DATAGRID_3D_1"
      write(lun,*) nxe -nxs +1, nye -nys +1, nze -nzs +1
      write(lun,'(3F20.10)') origin*Bohr
      write(lun,'(3F20.10)') vec_span(1:3,1) *Bohr
      write(lun,'(3F20.10)') vec_span(1:3,2) *Bohr
      write(lun,'(3F20.10)') vec_span(1:3,3) *Bohr
      write(lun,'(5F10.5)') (((phi2_on_mesh(nx,ny,nz,1),nx=nxs,nxe), &
           &                  ny=nys,nye),nz=nzs,nze)
      write(lun,'(A)') "END_DATAGRID_3D"
      if ( ncomp == 2 ) then
        write(lun,'(A)') "BEGIN_DATAGRID_3D_2"
         write(lun,*) nxe -nxs +1, nye -nys +1, nze -nzs +1
         write(lun,'(3F20.10)') origin*Bohr
         write(lun,'(3F20.10)') vec_span(1:3,1) *Bohr
         write(lun,'(3F20.10)') vec_span(1:3,2) *Bohr
         write(lun,'(3F20.10)') vec_span(1:3,3) *Bohr
         write(lun,'(5F10.5)') (((phi2_on_mesh(nx,ny,nz,2),nx=nxs,nxe), &
              &                  ny=nys,nye),nz=nzs,nze)
         write(lun,'(A)') "END_DATAGRID_3D"
      endif
      write(lun,'(A)') "END_BLOCK_DATAGRID_3D"
      close(lun)
    end subroutine printout_phi2

    subroutine set_phirt_on_mesh( it, nxs, nxe, nys, nye, nzs, nze, &
         &                        dx, dy, dz, phi_on_mesh )
      integer, intent(in) :: it, nxs, nxe, nys, nye, nzs, nze
      real(kind=DP), intent(in) :: dx, dy, dz
      real(kind=DP), intent(out) :: phi_on_mesh(nlmt_phi,nxs:nxe,nys:nye,nzs:nze)

      integer :: lmt1, il1, im1, tau1, nx, ny, nz, ind, nspher1
      real(kind=DP) :: cx, cy, cz, dist, ylm1, c1, ctmp, f1, f2
      real(kind=DP) :: dist_min = 1.0D-10

      do lmt1=1,ilmt_phi(it)
         il1 = ltp_phi(lmt1,it); im1 = mtp_phi(lmt1,it); tau1 = taup_phi(lmt1,it)

         Do nz=nzs, nze
            Do ny=nys, nye
               Do nx=nxs, nxe
                  cx = nx *dx;     cy = ny *dy;       cz = nz *dz
                  dist = sqrt(cx**2 +cy**2 +cz**2)

                  if ( dist < dist_min ) then
                     dist = dist_min
                     ind = 1
                     c1 = phirt(ind,il1,tau1,it) /radr_paw(ind,it)
                  else
                     ctmp = log( dist /rmax(it) ) *xh(it) +nmesh(it)
                     ind = int(ctmp)
                     if ( ind < 1 ) then
                        ind = 1
                        c1 = phirt(ind,il1,tau1,it) /radr_paw(ind,it)
                     else
                        f1 = ctmp -int(ctmp)
                        f2 = 1.0d0 -f1
                        c1 = ( phirt(ind,il1,tau1,it)/radr_paw(ind,it) )**f2 &
                             & *( phirt(ind+1,il1,tau1,it)/radr_paw(ind+1,it)) **f1
                     endif
                  endif
                  ! -- ylm --
                  nspher1 = ( il1 -1 )**2 +im1
                  call sphr( 1, nspher1, cx, cy, cz, ylm1 )
                  ! -------
                  phi_on_mesh(lmt1,nx,ny,nz) = c1 *ylm1
               End do
            ENd Do
         End Do
      End do
    end subroutine set_phirt_on_mesh

  end subroutine m_OP_wd_phirt2_rotated

  subroutine m_OP_calc_score_sigma_bond
    use m_Control_Parameters, only : sw_diagonalize_population, population_diag_mode
    use m_Const_Parameters,   only : DIAG_CHARGE_DENSITY_MATRIX, &
         &                           LOCAL_POINT_GROUP
    
    integer :: ia, ja, nx, ny, nz
    integer :: lmax, mmax, immax
    integer :: il, l1, im1, im2, ig, ilm1, im3, is2, kfac
    integer :: nsph_min, natom_nn
    real(kind=DP) :: vec(3), dist, dist_min, factor, c1, rcut
    complex(kind=CMPLDP) :: z1
    
    real(kind=DP), allocatable :: val_sph(:), work(:,:)
    
    kfac = 1
    if ( sw_diagonalize_population == ON ) then
       if ( population_diag_mode /= DIAG_CHARGE_DENSITY_MATRIX &
            &  .and. population_diag_mode /= LOCAL_POINT_GROUP ) then
          if ( noncol ) kfac = ndim_spinor
       endif
    endif

    lmax = nloc;   mmax = 2*lmax -1
    allocate( val_sph(mmax) )
    allocate( work(lmax,mmax*kfac) )
    
    factor = 1.2D0
    
    Do ia=1, natm
       ig = iproj_group(ia)
       if ( ig == 0 ) cycle

       dist_min = 1.0D2
       Loop_ja1: Do ja=1, natm
          Do nx=-1, 1
             Do ny=-1, 1
                Do nz=-1, 1
                   vec(1) = cps(ja,1) -cps(ia,1) &
                        &   +nx*altv(1,1) +ny*altv(1,2) +nz*altv(1,3)
                   vec(2) = cps(ja,2) -cps(ia,2) &
                        &   +nx*altv(2,1) +ny*altv(2,2) +nz*altv(2,3)
                   vec(3) = cps(ja,3) -cps(ia,3) &
                        &   +nx*altv(3,1) +ny*altv(3,2) +nz*altv(3,3)
                   dist = sqrt( vec(1)**2 +vec(2)**2 +vec(3)**2 )
                   if ( dist > 0.01 ) dist_min = min( dist, dist_min )
                ENd Do
             End Do
          End Do
       End Do Loop_ja1
       rcut = dist_min *factor
!       write(*,*) "rcut = ", ia, rcut
       
       natom_nn = 0;        work = 0.0d0
       
       Loop_ja2: Do ja=1, natm
          Do nx=-1, 1
             Do ny=-1, 1
                Do nz=-1, 1
                   vec(1) = cps(ja,1) -cps(ia,1) &
                        &   +nx*altv(1,1) +ny*altv(1,2) +nz*altv(1,3)
                   vec(2) = cps(ja,2) -cps(ia,2) &
                        &   +nx*altv(2,1) +ny*altv(2,2) +nz*altv(2,3)
                   vec(3) = cps(ja,3) -cps(ia,3) &
                        &   +nx*altv(3,1) +ny*altv(3,2) +nz*altv(3,3)
                   dist = sqrt( vec(1)**2 +vec(2)**2 +vec(3)**2 )

                   if ( dist > 0.01 .and. dist < rcut ) then
                      vec = vec /dist
                      natom_nn = natom_nn +1

                      Do il=1, lmax
                         l1 = il -1
                         nsph_min = l1**2 +1; 
                         immax = 2*l1 +1

                         Do im1=1, immax
                            ilm1 = nsph_min +im1 -1
                            call sphr( 1, ilm1, vec(1), vec(2), vec(3), val_sph(im1) )
                         End Do
                         
                         if ( sw_diagonalize_population == ON ) then
                            if ( population_diag_mode &
                                 &     == DIAG_CHARGE_DENSITY_MATRIX &
                                 & .or. population_diag_mode &
                                 &        == LOCAL_POINT_GROUP ) then
                               Do im1=1, immax      
                                  c1 = 0.0
                                  Do im2=1, immax
                                     c1 = c1 +val_sph(im2) &
                                          &  *porb_rot_matrix_real(ia,il,im2,im1)
                                  End do
                                  work(il,im1) = work(il,im1) +c1**2 /immax
                               End Do
                            else
                               Do im1=1, immax *kfac
                                  z1 = 0.0
                                  Do is2=1, ndim_spinor
                                     Do im2=1, immax
                                        im3=immax*(is2-1) +im2
                                        z1 = z1 +val_sph(im2) &
                                             &  *porb_rot_matrix_cmplx(ia,il,im3,im1)
                                     End Do
                                  End do
                                  work(il,im1) = work(il,im1) +z1*conjg(z1) /immax
                               End Do
                            endif
                         else
                            Do im1=1, immax
                               work(il,im1) = work(il,im1) +val_sph(im1)**2 /immax
                            ENd Do
                         endif
                      End Do
                   end if
                End Do
             ENd Do
          End Do

       End Do Loop_ja2
       score_sigma_bond(ia,:,:) = work(:,:) *PAI4
! -----------------------
    End Do
#if 0
!    stop
    write(*,*) "UUUU"
    Do ia=1, natm
       Do il=1, lmax
          Do im1=1, mmax
             write(*,*) ia, il, im1, score_sigma_bond(ia,il,im1)
          ENd Do
       ENd Do
    End Do
#endif
    deallocate(val_sph); deallocate(work)
    
  end subroutine m_OP_calc_score_sigma_bond

  subroutine m_OP_calc_symm
    use m_Control_Parameters, only : sw_diagonalize_population, population_diag_mode, &
         &                           ndim_spinor
    use m_Const_Parameters,   only : DIAG_CHARGE_DENSITY_MATRIX, PAI, zi, &
         &                           LOCAL_DOUBLE_POINT_GROUP
    use m_Crystal_Structure,   only : il
    use m_CS_SpaceGroup,        only : m_CS_gen_opr_rspace_full, get_point_group_name
    use m_CS_Magnetic,    only : m_CS_gen_opr_spinor_full
    use m_Files,  only : nfout
    use m_Representation,  only :  get_irr_rep, get_irr_rep_dblegrp
    use m_SpinOrbit_Potential,  only : m_SO_set_MatU_ylm_RC, &
         &                             m_SO_calc_MatLS_orb_s_to_f,&
         &                             m_SO_diagonalize_MatLS
    use m_Ionic_System,  only : ionic_mass
    
    integer, parameter :: max_nn = 8
    character(len=9) :: system
    character(len=3) :: pg_name

    integer :: nsym, nsym0, natom_nn
    integer :: lmax, mmax, kfac
    real(kind=DP) :: factor, rcut, dist_min

    integer :: ia, ig, ja
    
    real(kind=DP) :: sym_axis(3,3), angle(3)
    integer, allocatable :: Jtype(:)
    real(kind=DP), allocatable :: Jmass(:), BondVec(:,:)

    real(kind=DP), allocatable, target :: rot_space_cubic(:,:,:), rot_space_hex(:,:,:)
    real(kind=DP), pointer :: rot_space_org(:,:,:)
    real(kind=DP), allocatable :: rot_space_wk(:,:,:)
    complex(kind=CMPLDP), allocatable, target :: &
         &                     rot_spinor_cubic(:,:,:), rot_spinor_hex(:,:,:)
    complex(kind=CMPLDP), allocatable :: rot_spinor_wk(:,:,:)
    complex(kind=CMPLDP), pointer :: rot_spinor_org(:,:,:)

    logical :: flg_dblegrp
               
    flg_dblegrp = .false.
    if ( noncol .and. population_diag_mode == LOCAL_DOUBLE_POINT_GROUP ) then
       flg_dblegrp = .true.
    endif

    allocate( rot_space_cubic(3,3,48) );   allocate( rot_space_hex(3,3,24) );
    if ( flg_dblegrp ) then
       allocate( rot_spinor_cubic(2,2,48) );  allocate( rot_spinor_hex(2,2,48) )
    endif

    call m_SO_set_MatU_ylm_RC
    if ( flg_dblegrp ) call set_Jcoeff_L0_L3

    system = 'cubic';  nsym = 48
    call m_CS_gen_opr_rspace_full( system, nsym, rot_space_cubic )
    if ( flg_dblegrp ) call m_CS_gen_opr_spinor_full( system, nsym, rot_spinor_cubic )

    system = 'hexagonal';  nsym = 24
    call m_CS_gen_opr_rspace_full( system, nsym, rot_space_hex )
    if ( flg_dblegrp ) call m_CS_gen_opr_spinor_full( system, nsym, rot_spinor_hex )

    allocate( BondVec(max_nn,3) );   allocate( Jtype(max_nn) )
    allocate( Jmass(max_nn) )
    
    lmax = nloc;   mmax = 2*lmax -1;     nsym0 = nsym
       
    factor = 1.2D0
    
    Do ia=1, natm
       ig = iproj_group(ia)
       if ( ig == 0 ) cycle

       nsym = nsym0
       call calc_dist_min( ia, dist_min )
       rcut = dist_min *factor

       call set_atoms_nn( ia, rcut, max_nn, natom_nn, BondVec, Jtype )
       call check_if_hexagonal( max_nn, natom_nn, BondVec, system )

       call set_symmetry_axis( max_nn, natom_nn, BondVec, sym_axis )
       call calc_euler_angles2( sym_axis, angle(1), angle(2), angle(3) )

       if ( system == 'cubic' ) then
          nsym0 = 48;  rot_space_org => rot_space_cubic
          if ( flg_dblegrp ) rot_spinor_org => rot_spinor_cubic
       else
          nsym0 = 24;  rot_space_org => rot_space_hex
          if ( flg_dblegrp ) rot_spinor_org => rot_spinor_hex
       endif

       allocate( rot_space_wk(3,3,nsym0) )
       if ( flg_dblegrp ) allocate( rot_spinor_wk(2,2,nsym0) )
       
       if ( ipriorb_rot > 2 ) then
          write(nfout,'(A,I5)') "** Symmetry Axis of Atom :", ia
          write(nfout,'(A,3F20.10)')  'vec1 : ',sym_axis(1:3,1)
          write(nfout,'(A,3F20.10)')  'vec2 : ',sym_axis(1:3,2)
          write(nfout,'(A,3F20.10)')  'vec3 : ',sym_axis(1:3,3)
          write(nfout,'(A)') "** Euler Angles (deg.)"
          write(nfout,'(A,3F20.8)') 'alpha beta gamma :', angle(1:3) /PAI *180.0d0
          write(nfout,'(A,A)') "** local system is ", system
       endif

       if ( flg_dblegrp ) then
          call set_porb_rot_matrix_cmplx0( ia )
          call calc_local_point_group( max_nn, natom_nn, sym_axis, BondVec, Jtype, &
               &                       nsym0, nsym, pg_name, &
               &                       rot_space_org, rot_spinor_org )
          call get_orb_irrep_dblegrp( ia, pg_name )
       else
          call set_porb_rot_matrix_real0( ia )
          call calc_local_point_group( max_nn, natom_nn, sym_axis, BondVec, Jtype, &
               &                       nsym0, nsym, pg_name, &
               &                       rot_space_org )
          call get_orb_irrep( ia, pg_name )
       endif
       deallocate( rot_space_wk )
       if ( flg_dblegrp ) deallocate( rot_spinor_wk )
    End Do
    !
    deallocate( BondVec )
    deallocate( Jtype );   deallocate( Jmass )
    deallocate( rot_space_cubic );   deallocate( rot_space_hex )
    if ( flg_dblegrp ) then
       deallocate( rot_spinor_cubic );   deallocate( rot_spinor_hex )
    endif

  contains

    subroutine check_if_hexagonal( max_nn, natom_nn, BondVec, system )
      integer, intent(in) :: max_nn, natom_nn
      real(kind=DP), intent(in) :: BondVec(max_nn,3)
      character(len=9), intent(out) :: system

      integer :: i, j, k
      real(kind=DP) :: vec(3), norm

      system = 'cubic'
      Do i=1, natom_nn-2
         Do j=i+1, natom_nn-1
            Do k=j+1, natom_nn
               vec(:) = BondVec(i,:) +BondVec(j,:) +BondVec(k,:)
               norm = sqrt( vec(1)**2 +vec(2)**2 +vec(3)**2 )
               if ( norm < 1.0E-3 ) system = 'hexagonal'
            End Do
         End Do
      ENd Do
    end subroutine check_if_hexagonal

    subroutine get_orb_irrep( ia, pg_name )
      integer, intent(in) :: ia
      character(len=3), intent(in) :: pg_name
      
      real(kind=DP), allocatable :: crotylm(:,:,:) ! d(mmax,nsph,nopr)
      integer, allocatable :: iylm(:,:,:) ! d(mmax,nsph,nopr)
      integer, allocatable :: nylm(:,:) ! d(nsph,nopr)
      real(kind=DP), allocatable :: matc(:,:,:), matwk(:,:)
      real(kind=DP), allocatable :: basis_vec(:,:), porb_rot_tmp(:,:)

      integer :: rep(48,12), nrep, nsym, nd
      integer :: num_basis, nadd
      character(len=3) :: symbol_irrep(12)
      character(len=4) :: active_rep(12)

      integer :: il1, l1, im1, im2, im3, im4, immax
      integer :: iopr, isph1, isph2, nsph_min, irep, iy, irep_cand
      real(kind=DP) :: c1, fac, ctmp, norm
      
      if ( pg_name == "Dih" .or. pg_name == "Civ" ) then
         orb_irrep(ia,:,:) = pg_name // ' ' // 'NON '
         return
      else
         call get_irr_rep( pg_name, nsym, nrep, rep, symbol_irrep, active_rep )
      endif

      if(.not.allocated(crotylm)) allocate(crotylm(mmax,lmax**2,nsym))
      if(.not.allocated(iylm))    allocate(iylm(mmax,lmax**2,nsym))
      if(.not.allocated(nylm))    allocate(nylm(lmax**2,nsym))      
      
      crotylm = 0.0d0
      call get_crotylm( lmax, mmax, lmax**2, nsym, crotylm, iylm, nylm, rot_space_wk )
      
      Do il1=1, lmax
         l1 = il1 -1
         nsph_min = l1**2 +1; 
         immax = 2*l1 +1
         
         allocate( matc(immax,immax,nsym) );  matc = 0.0d0
         
         Do iopr=1, nsym
            Do im1=1, immax
               isph1 = nsph_min +im1 -1
               Do iy=1, nylm(isph1,iopr)
                  isph2 = iylm(iy,isph1,iopr)
                  im2 = isph2 -nsph_min +1
                  matc(im2,im1,iopr) = crotylm(iy,isph1,iopr)
               End Do
            End Do
         ENd Do

         num_basis = 0
         allocate( basis_vec(immax,immax) ); basis_vec = 0.0d0
         allocate( matwk(immax,immax) )
         
         Do irep=1, nrep
            nd = rep(1,irep)
            matwk = 0.0d0
            Do im1=1, immax
               Do im2=1, immax
                  ctmp = 0.0d0
                  Do iopr=1, nsym
                     fac = rep(iopr,irep)
                     c1 = matc(im2,im1,iopr)
                     ctmp = ctmp +fac *c1
                  End Do
                  norm = ctmp *dble(nd) /dble(nsym)
                  if ( abs(norm) > 1.0D-6 ) matwk(im2,im1) = norm
               End Do
            End Do
            call count_basis( immax, matwk, num_basis, basis_vec, nadd )
            Do im1=1, nadd
               orb_irrep(ia,il1,num_basis+im1) = pg_name // ' ' // symbol_irrep(irep)
            End Do
            num_basis = num_basis +nadd
         End Do
         if ( num_basis /= immax ) call phase_error_with_msg(nfout,"num_basis /= immax",__LINE__,__FILE__)
            
         allocate( porb_rot_tmp(immax,immax) )
         porb_rot_tmp(1:immax,1:immax) &
              &     = porb_rot_matrix_real(ia,il1,1:immax,1:immax)

         Do im1=1, immax
            Do im2=1, immax
               ctmp = 0.0d0
               Do im3=1, immax
                  ctmp = ctmp +basis_vec(im3,im1) *porb_rot_tmp(im2,im3)
               End Do
               porb_rot_matrix_real(ia,il1,im2,im1) = ctmp
            End Do
         End Do

         deallocate( matwk );      deallocate( matc )
         deallocate( basis_vec );  deallocate( porb_rot_tmp )
      End Do
      deallocate(crotylm);     deallocate(iylm);     deallocate(nylm)

    end subroutine get_orb_irrep

    subroutine get_orb_irrep_dblegrp( ia, pg_name )
      integer, intent(in) :: ia
      character(len=3), intent(in) :: pg_name

      real(kind=DP), allocatable :: crotylm(:,:,:) ! d(mmax,nsph,nopr)
      integer, allocatable :: iylm(:,:,:) ! d(mmax,nsph,nopr)
      integer, allocatable :: nylm(:,:) ! d(nsph,nopr)
      real(kind=DP), allocatable :: basis_vec(:,:), matwk(:,:)
      complex(kind=CMPLDP), allocatable :: matc(:,:,:), porb_rot_tmp(:,:)
      complex(kind=CMPLDP), allocatable :: zsum(:), work(:,:)

      integer :: nrep, nsym, nd, iloop, istart, iend
      integer :: num_basis, nadd

      complex(kind=CMPLDP) :: rep_dblegrp(48,2,16)
      character(len=4) :: symbol_irrep_dblegrp(16)

      integer :: il1, l1, im1, im2, im3, im4, immax, is1, is2
      integer :: iopr, isph1, isph2, nsph_min, irep, iy, irep_cand
      real(kind=DP) :: norm, max_norm
      complex(kind=CMPLDP) :: z1, ztmp, fac

      if ( pg_name == "Dih" .or. pg_name == "Civ" ) then
         orb_irrep(ia,:,:) = pg_name // ' ' // 'NON '
         return
      else
         call get_irr_rep_dblegrp( pg_name, nsym, nrep, rep_dblegrp, &
              &                    symbol_irrep_dblegrp )
      endif

      if(.not.allocated(crotylm)) allocate(crotylm(mmax,lmax**2,nsym))
      if(.not.allocated(iylm))    allocate(iylm(mmax,lmax**2,nsym))
      if(.not.allocated(nylm))    allocate(nylm(lmax**2,nsym))

      crotylm = 0.0d0
      call get_crotylm( lmax, mmax, lmax**2, nsym, crotylm, iylm, nylm, rot_space_wk )

      Do il1=1, lmax
         l1 = il1 -1
         nsph_min = l1**2 +1;
         immax = 2*l1 +1

         allocate( zsum(immax*ndim_spinor) )
         allocate( matc(immax*ndim_spinor,immax*ndim_spinor,nsym) );  matc = 0.0d0
         allocate( work(immax*ndim_spinor,immax*ndim_spinor) )

         Do iopr=1, nsym
            work = 0.0d0
            Do im1=1, immax
               isph1 = nsph_min +im1 -1
               Do iy=1, nylm(isph1,iopr)
                  isph2 = iylm(iy,isph1,iopr)
                  im2 = isph2 -nsph_min +1
                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        work( immax*(is2-1)+im2,immax*(is1-1)+im1 ) &
                             &    = crotylm(iy,isph1,iopr) *rot_spinor_wk(is2,is1,iopr)
                     End Do
                  ENd Do
               End Do
            End Do
            Do im1=1, immax*ndim_spinor
               Do im2=1, immax*ndim_spinor
                  ztmp = 0.0d0
                  Do im3=1, immax*ndim_spinor
                     Do im4=1, immax*ndim_spinor
                        select case (l1)
                        case (0)
                           ztmp = ztmp +work(im3,im4) *JCoeff_L0(im4,im2) &
                                &      *conjg(JCoeff_L0(im3,im1) )
                        case (1)
                           ztmp = ztmp +work(im3,im4) *JCoeff_L1(im4,im2) &
                           &           *conjg(JCoeff_L1(im3,im1) )
                        case (2)
                           ztmp = ztmp +work(im3,im4) *JCoeff_L2(im4,im2) &
                           &           *conjg(JCoeff_L2(im3,im1) )
                        case (3)
                           ztmp = ztmp +work(im3,im4) *JCoeff_L3(im4,im2) &
                           &           *conjg(JCoeff_L3(im3,im1) )
                        end select
                     End Do
                  End Do
                  matc( im1, im2, iopr ) = ztmp
               ENd Do
            End Do
         ENd Do
         
         num_basis = 0
         allocate( basis_vec(immax*ndim_spinor,immax*ndim_spinor) ); basis_vec = 0.0d0
         allocate( matwk(immax*ndim_spinor,immax*ndim_spinor) )

         Do iloop=1, 2
            if ( iloop == 1 ) then
               istart = 1;   iend = l1 *ndim_spinor
            else
               istart = l1 *ndim_spinor +1;  iend = immax *ndim_spinor
            endif

            Do irep=1, nrep
               nd = rep_dblegrp(1,1,irep)
               matwk = 0.0d0

               Do im1=istart, iend
                  zsum = 0.0d0
                  Do im2=istart, iend
                     Do iopr=1, nsym
                        z1 = matc(im2,im1,iopr)
                        Do is1=1, ndim_spinor
                           fac = rep_dblegrp(iopr,is1,irep)
                           if ( is1==2 ) z1 = -z1
                           zsum(im2) = zsum(im2) +z1 *fac
                        End Do
                     End Do
                  End Do
                  Do im2=istart, iend
                     norm = zsum(im2) *dble(nd) /dble(nsym*2)
                     if ( abs(norm) > 1.0D-6 ) matwk(im2,im1) = norm
                  ENd Do
               End Do

               call count_basis( immax*ndim_spinor, matwk, num_basis, basis_vec, nadd )
               
               Do im1=1, nadd
                  orb_irrep(ia,il1,num_basis+im1) = pg_name // ' ' &
                       &                           // symbol_irrep_dblegrp(irep)
               End Do
               num_basis = num_basis +nadd
            End Do
         End Do
         if ( num_basis /= immax*ndim_spinor ) call phase_error_with_msg(nfout,"num_basis /= immax*ndim_spinor"&
                                                                        ,__LINE__,__FILE__)

         allocate( porb_rot_tmp(immax*ndim_spinor,immax*ndim_spinor) )         
         porb_rot_tmp(1:immax*ndim_spinor,1:immax*ndim_spinor) &
              &  = porb_rot_matrix_cmplx(ia,il1,1:immax*ndim_spinor,1:immax*ndim_spinor)
         
         Do im1=1, immax*ndim_spinor
            Do im2=1, immax*ndim_spinor
               ztmp = 0.0d0
               Do im3=1, immax*ndim_spinor
                  ztmp = ztmp +basis_vec(im3,im1) *porb_rot_tmp(im2,im3)
               End Do
               porb_rot_matrix_cmplx(ia,il1,im2,im1) = ztmp
            End Do
         End Do
         
         deallocate( zsum );      deallocate( matc );  deallocate( work )
         deallocate( basis_vec );  deallocate( porb_rot_tmp )
         deallocate( matwk )
      End Do
      deallocate(crotylm);     deallocate(iylm);     deallocate(nylm)

    end subroutine get_orb_irrep_dblegrp         

    subroutine count_basis( ndim, mat, num_basis, basis_vec, nadd )
      integer, intent(in) :: ndim, num_basis
      real(kind=DP), intent(in) :: mat(ndim,ndim)
      integer, intent(out) :: nadd
      real(kind=DP), intent(inout) ::  basis_vec(ndim,ndim)

      integer :: i, lwork, info
      real(kind=DP), allocatable :: rwork(:), eigval(:)
      
      lwork = 8 *ndim
      allocate( eigval(ndim) );    allocate( rwork(lwork) );
      call dsyev( 'V', 'U', ndim, mat, ndim, eigval, rwork, lwork, info )
      if (info /= 0) then
         write(nfout,*) 'dsyev: info=',info
      end if
      !
      nadd = 0
      Do i=1, ndim
         if ( abs( eigval(i) -1.0 ) < 1.0D-4 ) then
            nadd = nadd +1
            basis_vec(:,num_basis+nadd) = mat(:,i)
         endif
      End do
      deallocate( rwork );  deallocate( eigval )
    end subroutine count_basis

    subroutine calc_local_point_group( max_nn, natom_nn, sym_axis, BondVec, Jtype, &
         &                             nsym0, nsym1, pg_name, rot_space, rot_spinor )
      integer, intent(in) :: max_nn, natom_nn, nsym0
      integer, intent(in) :: Jtype(natom_nn)
      real(kind=DP), intent(in) :: sym_axis(3,3)
      real(kind=DP), intent(in) :: BondVec(max_nn,3)
      integer, intent(out) :: nsym1
      character(len=3), intent(out) :: pg_name
      real(kind=DP), intent(in) :: rot_space(3,3,nsym0)
      complex(kind=CMPLDP), optional, intent(in) :: rot_spinor(2,2,nsym0)

      character(len=5) :: pg_name_i
      integer :: ja, j, k, l, iopr, found, num
      real(kind=DP) :: vec(3), c1, dist
      real(kind=DP), allocatable :: BondVec_rotated(:,:)
      integer, allocatable :: Flag(:), opr_no(:)
      
      allocate( BondVec_rotated(natom_nn,3) )
      BondVec_rotated= 0.0d0
      
      Do ja=1, natom_nn
         Do j=1, 3
            c1 = 0.0d0
            Do k=1, 3
               c1 = c1 +sym_axis(k,j) *BondVec(ja,k)
            End Do
            BondVec_rotated(ja,j) = c1
         End Do
      ENd Do
      !
      if ( ipriorb_rot > 2 ) then
         write(nfout,'(A,I5)') "** BondVec of atom :", ia
         Do ja=1, natom_nn
            write(nfout,'(I5,3F20.10)') ja, BondVec(ja,1:3)
         End Do
         write(nfout,'(A)') "BondVec rotated"
         Do ja=1, natom_nn
            write(nfout,'(I5,3F20.10)') ja, BondVec_rotated(ja,1:3)
         End Do
      endif
      !
      allocate( Flag(nsym0) );    Flag = 1
      allocate( opr_no(nsym0) );  opr_no = 0      

      Do iopr=1, nsym0
         j_loop: Do j=1, natom_nn
            vec = 0.0d0
            Do k=1, 3
               Do l=1, 3
                  vec(k) = vec(k) +rot_space(k,l,iopr) *BondVec_rotated(j,l)
               End Do
            ENd Do
            
            found = 0
            k_loop: Do k=1, natom_nn
               dist = sqrt( ( vec(1) -BondVec_rotated(k,1) )**2 &
                    &      +( vec(2) -BondVec_rotated(k,2) )**2 &
                    &      +( vec(3) -BondVec_rotated(k,3) )**2 )
               if ( dist < 1.0E-3 ) then
#if 0
                  if ( Jtype(j) == Jtype(k) ) then
#else
                  if ( Jmass(j) == Jmass(k) ) then
#endif
                     found = 1;   exit k_loop
                  endif
               endif
            End Do k_loop
            
            if ( found == 0 ) then
#if 0
               if ( natom_nn == 1 .and. Jtype(1) == ityp(ia) ) then
#else
               if ( natom_nn == 1 .and. Jmass(1) == ionic_mass(ia) ) then
#endif
                  c1 = sqrt( (vec(1) +BondVec_rotated(1,1))**2 &
                       &    +(vec(2) +BondVec_rotated(1,2))**2 &
                       &    +(vec(3) +BondVec_rotated(1,3))**2 )
                  if ( c1 < 1.0E-3 ) then
                     found = 1
                  endif
               endif
            endif
100         continue
            if ( found == 0 ) then
               Flag(iopr) = 0
            endif
         ENd Do j_loop
      End Do
       !
      num = 0
      Do iopr=1, nsym0
         if ( Flag(iopr) == 1 ) then
            num = num +1
            opr_no(num) = iopr
            rot_space_wk(:,:,num) = rot_space(:,:,iopr)
            if ( present(rot_spinor) ) rot_spinor_wk(:,:,num) = rot_spinor(:,:,iopr)
         endif
      End Do
      nsym1 = num

      call get_point_group_name( nfout, system, num, opr_no, pg_name, pg_name_i )
      if ( natom_nn == 1 ) then
         if ( pg_name == "D4h" ) pg_name = "Dih"
         if ( pg_name == "C4v" ) pg_name = "Civ"
      endif

      deallocate( BondVec_rotated )
      deallocate( Flag )
      
    end subroutine calc_local_point_group

    subroutine calc_euler_angles2( axis, alpha, beta, gamma )   ! Z-Y-Z
      real(kind=DP), intent(in) :: axis(3,3)
      real(kind=DP), intent(out) :: alpha, beta, gamma
      !
      real(kind=DP) :: sigma, delta, c1, c2, c3, c4, c5
      real(kind=DP) :: mat(3,3)
      !
      mat = axis
      if ( mat(3,3) < 1.0D0 ) then
         if ( mat(3,3) > -1.0D0 ) then
            beta = acos( mat(3,3) )
            alpha = atan2( mat(2,3), mat(1,3) )
            gamma = atan2( mat(3,2), -mat(3,1) )
         else
            beta = PAI
            alpha = atan2( mat(2,1), mat(2,2) )
            gamma = 0.0D0;
         endif
      else
         beta = 0.0D0
         alpha = atan2( mat(2,1), mat(2,2) )
         gamma = 0.0D0
      endif
      !
      mat(1,1) = cos(alpha)*cos(beta)*cos(gamma) -sin(alpha)*sin(gamma)
      mat(1,2) = -cos(alpha)*cos(beta)*sin(gamma) -sin(alpha)*cos(gamma)
      mat(1,3) = cos(alpha)*sin(beta)
      mat(2,1) = sin(alpha)*cos(beta)*cos(gamma) +cos(alpha)*sin(gamma)
      mat(2,2) = -sin(alpha)*cos(beta)*sin(gamma) +cos(alpha)*cos(gamma)
      mat(2,3) = sin(alpha)*sin(beta)
      mat(3,1) = -sin(beta)*cos(gamma)
      mat(3,2) = sin(beta)*sin(gamma)
      mat(3,3) = cos(beta)
    end subroutine calc_euler_angles2
      
    subroutine set_symmetry_axis( max_nn, natom_nn, BondVec, axis )
      integer, intent(in) :: max_nn, natom_nn
      real(kind=DP), intent(in) :: BondVec(max_nn,3)
      
      integer, parameter :: ndim = 3
      real(kind=DP), intent(out) :: axis(ndim,ndim)
      integer :: i, lwork,info, j, num_degene

      real(kind=DP) :: abstol,nfound, ctmp
      real(kind=DP) :: mass, c1, c2, c3, cos_th
      real(kind=DP) :: mat(ndim,ndim)
      real(kind=DP) :: eigval(ndim), eigvec(ndim,ndim)

      integer, allocatable :: iwork(:),ifail(:)
      real(kind=DP), allocatable :: rwork(:)
      real(kind=DP), external :: dlamch
      logical :: flag
      
      mat = 0.0d0
      Do i=1, natom_nn
         mass = 1.0d0
         mat(1,1) = mat(1,1) +mass *( BondVec(i,2)**2 +BondVec(i,3)**2 )
         mat(2,2) = mat(2,2) +mass *( BondVec(i,3)**2 +BondVec(i,1)**2 )
         mat(3,3) = mat(3,3) +mass *( BondVec(i,1)**2 +BondVec(i,2)**2 )
         mat(1,2) = mat(1,2) -mass *BondVec(i,1) *BondVec(i,2)
         mat(1,3) = mat(1,3) -mass *BondVec(i,1) *BondVec(i,3)
         mat(2,3) = mat(2,3) -mass *BondVec(i,2) *BondVec(i,3)
      End Do
      mat(2,1) = mat(1,2);      mat(3,1) = mat(1,3);      mat(3,2) = mat(2,3)

      lwork = 8 *ndim
      allocate( rwork(lwork) );
      call dsyev( 'V', 'U', ndim, mat, ndim, eigval, rwork, lwork, info )
      !
      if (info /= 0) then
         write(nfout,*) 'dsyev: info=',info
      end if
      deallocate( rwork );
      !
      num_degene = 0
      Do i=1, ndim-1
         Do j=i+1, ndim
            if ( abs(eigval(i) -eigval(j)) < 1.0D-3 ) then
               num_degene = num_degene +1
            endif
         End do
      ENd Do

      if ( ipriorb_rot > 2 ) then
         write(nfout,*) "** number of degeneracy : ", num_degene
         Do i=1, 3
            write(nfout,'(I5,3F20.10)') i, eigval(i)
         End Do
         write(nfout,*) "** eigen_vectors "
         Do i=1, 3
            write(nfout,'(A,I5,A,3F20.10)') "vec ",i, ":", mat(1:3,i)
         End Do
      endif

      select case (num_degene)
      case (0)
         axis(1:3,1:3) = mat(1:3,1:3)
      case (1)
         if ( abs(eigval(1) -eigval(2)) < 1.0D-3 ) then
            axis(1:3,3) = mat(1:3,3)
         else if ( abs(eigval(2) -eigval(3)) < 1.0D-3 ) then
            axis(1:3,3) = mat(1:3,1)
         endif

         flag = .false.
         loop1: Do i=1, natom_nn
            c2 = BondVec(i,1)*axis(1,3) +BondVec(i,2)*axis(2,3) &
                 & +BondVec(i,3)*axis(3,3)
            c3 = sqrt( BondVec(i,1)**2 +BondVec(i,2)**2 +BondVec(i,3)**2 )
            cos_th = c2 /c3
            if ( abs(cos_th) > sqrt(3.)/2. ) cycle
            axis(1:3,1) = BondVec(i,1:3) /c3 -cos_th *axis(1:3,3)

            flag = .true.
            exit loop1
         End Do loop1
         if ( .not. flag ) then
            axis(1,1) = axis(1,3) *2
            axis(2,1) = axis(2,3) *5
            axis(3,1) = -axis(3,3) *7
            c2 = axis(1,1) *axis(1,3) +axis(2,1) *axis(2,3) +axis(3,1) *axis(3,3)
            c3 = sqrt( axis(1,1)**2 +axis(2,1)**2 +axis(3,1)**2 )
            cos_th = c2 /c3
            axis(1:3,1) = axis(1:3,1) /c3 -cos_th *axis(1:3,3)
            flag = .true.
         endif
         axis(1,2) = axis(2,3)*axis(3,1) -axis(3,1)*axis(2,3)
         axis(2,2) = axis(3,3)*axis(1,1) -axis(1,1)*axis(3,3)
         axis(3,2) = axis(1,3)*axis(2,1) -axis(2,1)*axis(1,3)

      case (3)
         c1 = sqrt( BondVec(1,1)**2 +BondVec(1,2)**2 +BondVec(1,3)**2 )
         axis(1:3,1) = BondVec(1,1:3) /c1

         loop2: Do i=2, natom_nn
            c2 = BondVec(i,1)*BondVec(1,1) +BondVec(i,2)*BondVec(1,2) &
                 & +BondVec(i,3)*BondVec(1,3)
            c3 = sqrt( BondVec(i,1)**2 +BondVec(i,2)**2 +BondVec(i,3)**2 )
            cos_th = c2 /c1 /c3
            if ( cos_th < -sqrt(3.)/2. ) cycle
            axis(1:3,2) = BondVec(i,1:3) /c3 -cos_th *axis(1:3,1)
            exit loop2
         End Do loop2
         axis(1,3) = axis(2,1)*axis(3,2) -axis(3,1)*axis(2,2)
         axis(2,3) = axis(3,1)*axis(1,2) -axis(1,1)*axis(3,2)
         axis(3,3) = axis(1,1)*axis(2,2) -axis(2,1)*axis(1,2)
      end select

    end subroutine set_symmetry_axis

    subroutine calc_dist_min( ia, dist_min )
      integer, intent(in) :: ia
      real(kind=DP), intent(out) :: dist_min

      integer :: ja, nx, ny, nz
      real(kind=DP) :: vec(3), dist

      dist_min = 1.0D2
      Loop_ja1: Do ja=1, natm
         Do nx=-1, 1
            Do ny=-1, 1
               Do nz=-1, 1
                  vec(1) = cps(ja,1) -cps(ia,1) &
                       &   +nx*altv(1,1) +ny*altv(1,2) +nz*altv(1,3)
                  vec(2) = cps(ja,2) -cps(ia,2) &
                       &   +nx*altv(2,1) +ny*altv(2,2) +nz*altv(2,3)
                  vec(3) = cps(ja,3) -cps(ia,3) &
                        &   +nx*altv(3,1) +ny*altv(3,2) +nz*altv(3,3)
                  dist = sqrt( vec(1)**2 +vec(2)**2 +vec(3)**2 )
                  if ( dist > 0.01 ) dist_min = min( dist, dist_min )
               ENd Do
            End Do
         End Do
      End Do Loop_ja1
    end subroutine calc_dist_min
    
    subroutine set_atoms_nn( ia, rcut, max_nn, natom_nn, BondVec, Jtype )
      integer, intent(in) :: max_nn, ia
      real(kind=DP), intent(in) :: rcut
      integer, intent(out) :: natom_nn,  Jtype(max_nn)
      real(kind=DP), intent(out) :: BondVec(max_nn,3)
      
      integer :: ja, nx, ny, nz
      real(kind=DP) :: vec(3), dist
      
      natom_nn = 0;   BondVec = 0.0d0;  Jtype = 0
      
      Loop_ja3: Do ja=1, natm
         Do nx=-1, 1
            Do ny=-1, 1
               Do nz=-1, 1
                  vec(1) = cps(ja,1) -cps(ia,1) &
                       &   +nx*altv(1,1) +ny*altv(1,2) +nz*altv(1,3)
                  vec(2) = cps(ja,2) -cps(ia,2) &
                       &   +nx*altv(2,1) +ny*altv(2,2) +nz*altv(2,3)
                  vec(3) = cps(ja,3) -cps(ia,3) &
                       &   +nx*altv(3,1) +ny*altv(3,2) +nz*altv(3,3)
                  dist = sqrt( vec(1)**2 +vec(2)**2 +vec(3)**2 )
                  
                   if ( dist > 0.01 .and. dist < rcut ) then
                      natom_nn = natom_nn +1
                      BondVec(natom_nn,1:3) = vec(1:3)
                      Jtype(natom_nn) = ityp(ja)
                      Jmass(natom_nn) = ionic_mass(ja)
                   endif
                End Do
             ENd Do
          ENd Do
       End Do Loop_ja3
     end subroutine set_atoms_nn
    
    subroutine set_porb_rot_matrix_real0( ia )
      integer, intent(in) :: ia
      
      integer :: il1, val_l, im1, im2, im3, im4
      real(kind=DP) :: c1
      complex(kind=CMPLDP) :: z1, z2, zsum
      complex(kind=CMPLDP), allocatable :: mat(:,:)
      
      Do il1=1, lmax
         val_l = il1 -1
         allocate( mat(-val_l:val_l,-val_l:val_l) );  mat = 0.0d0
         
         Do im1=-val_l ,val_l
            Do im2=-val_l, val_l
               call calc_small_Wigner_function( dble(val_l), dble(im1), dble(im2), &
                    &                           -angle(2), c1 )
               z1 = exp( zi *im1 *angle(1) )
               z2 = exp( zi *im2 *angle(3) )
               mat(im1,im2) = z1 *c1 *z2
            End do
         End do

         Do im1=1, 2*val_l+1
            Do im2=1, 2*val_l +1
               zsum = 0.0d0

               select case (val_l)
               case (0)
                  Do im3=-val_l, val_l
                     Do im4=-val_l, val_l
                        zsum = zsum +MatU_ylm_RC_L0(im1,im3)*mat(im3,im4) &
                             &       *conjg(MatU_ylm_RC_L0(im2,im4))
                     End Do
                  End Do
               case (1)
                  Do im3=-val_l, val_l
                     Do im4=-val_l, val_l
                        zsum = zsum +MatU_ylm_RC_L1(im1,im3)*mat(im3,im4) &
                             &       *conjg(MatU_ylm_RC_L1(im2,im4))
                     End Do
                  End Do
               case (2)
                  Do im3=-val_l, val_l
                     Do im4=-val_l, val_l
                        zsum = zsum +MatU_ylm_RC_L2(im1,im3)*mat(im3,im4) &
                             &       *conjg(MatU_ylm_RC_L2(im2,im4))
                     End Do
                  End Do
               case (3)
                  Do im3=-val_l, val_l
                     Do im4=-val_l, val_l
                        zsum = zsum +MatU_ylm_RC_L3(im1,im3)*mat(im3,im4) &
                             &       *conjg(MatU_ylm_RC_L3(im2,im4))
                     End Do
                  End Do
               end select
               porb_rot_matrix_real(ia,il1,im1,im2) = zsum

            End Do
         End Do
         deallocate( mat )
      End Do
    end subroutine set_porb_rot_matrix_real0

    subroutine set_porb_rot_matrix_cmplx0( ia )
      integer, intent(in) :: ia
      
      integer :: il1, val_l, immax
      integer :: im1, im2, im3, im4, is1, is2, istmp
      real(kind=DP) :: c1
      complex(kind=CMPLDP) :: z1, z2, zsum

      real(kind=DP), allocatable :: rwk_rotmat(:,:)
      complex(kind=CMPLDP), allocatable :: mat(:,:)

      integer :: itmp2, itmp3

      Do il1=1, lmax
         val_l = il1 -1
         immax = 2 *val_l +1
         allocate( mat(-val_l:val_l,-val_l:val_l) );  mat = 0.0d0
         allocate( rwk_rotmat(immax,immax) );  rwk_rotmat = 0.0d0
         
         Do im1=-val_l ,val_l
            Do im2=-val_l, val_l
               call calc_small_Wigner_function( dble(val_l), dble(im1), dble(im2), &
                    &                           -angle(2), c1 )
               z1 = exp( zi *im1 *angle(1) )
               z2 = exp( zi *im2 *angle(3) )
               mat(im1,im2) = z1 *c1 *z2
            End do
         End do

! ----------------------------------------------------------------
         Do im1=1, 2*val_l+1
            Do im2=1, 2*val_l +1
               zsum = 0.0d0
               select case (val_l)
               case (0)
                  Do im3=-val_l, val_l
                     Do im4=-val_l, val_l
                        zsum = zsum +MatU_ylm_RC_L0(im1,im3)*mat(im3,im4) &
                             &       *conjg(MatU_ylm_RC_L0(im2,im4))
                     End Do
                  End Do
               case (1)
                  Do im3=-val_l, val_l
                     Do im4=-val_l, val_l
                        zsum = zsum +MatU_ylm_RC_L1(im1,im3)*mat(im3,im4) &
                             &       *conjg(MatU_ylm_RC_L1(im2,im4))
                     End Do
                  End Do
               case (2)
                  Do im3=-val_l, val_l
                     Do im4=-val_l, val_l
                        zsum = zsum +MatU_ylm_RC_L2(im1,im3)*mat(im3,im4) &
                             &       *conjg(MatU_ylm_RC_L2(im2,im4))
                     End Do
                  End Do
               case (3)
                  Do im3=-val_l, val_l
                     Do im4=-val_l, val_l
                        zsum = zsum +MatU_ylm_RC_L3(im1,im3)*mat(im3,im4) &
                             &       *conjg(MatU_ylm_RC_L3(im2,im4))
                     End Do
                  End Do
               end select
               rwk_rotmat(im1,im2) = zsum
            End Do
         End Do
! ----------------------------------------------------------------

         Do im1=1, immax*ndim_spinor
            Do im2=1, immax
               Do is1=1, ndim_spinor
                  zsum = 0.0d0
                  Do im3=1, immax
                     select case (val_l)
                     case (0)
                        zsum = zsum +rwk_rotmat(im3,im2) &
                             &            *JCoeff_L0(immax*(is1-1)+im3,im1)
                     case (1)
                        zsum = zsum +rwk_rotmat(im3,im2) &
                             &            *JCoeff_L1(immax*(is1-1)+im3,im1)
                     case (2)
                        zsum = zsum +rwk_rotmat(im3,im2) &
                             &            *JCoeff_L2(immax*(is1-1)+im3,im1)
                     case (3)
                        zsum = zsum +rwk_rotmat(im3,im2) &
                             &            *JCoeff_L3(immax*(is1-1)+im3,im1)
                     end select
                  End Do
                  porb_rot_matrix_cmplx(ia,il1,immax*(is1-1)+im2,im1) = zsum
               End Do
            End do
         End Do

         deallocate( mat ); deallocate( rwk_rotmat )
      End Do
    end subroutine set_porb_rot_matrix_cmplx0

  end subroutine m_OP_calc_symm
 
  subroutine set_Jcoeff_L0_L3
    integer :: il1, my_l, immax, num
    integer :: ma, m1, m2, im1
    real(kind=DP) :: val_j, val_mj, c1, c2
    
    if ( allocated( Jcoeff_L0 ) ) deallocate( Jcoeff_L0 )
    if ( allocated( Jcoeff_L1 ) ) deallocate( Jcoeff_L1 )
    if ( allocated( Jcoeff_L2 ) ) deallocate( Jcoeff_L2 )
    if ( allocated( Jcoeff_L3 ) ) deallocate( Jcoeff_L3 )
    allocate( Jcoeff_L0(1*ndim_spinor,1*ndim_spinor) ); JCoeff_L0 = 0.0d0
    allocate( Jcoeff_L1(3*ndim_spinor,3*ndim_spinor) ); JCoeff_L1 = 0.0d0
    allocate( Jcoeff_L2(5*ndim_spinor,5*ndim_spinor) ); JCoeff_L2 = 0.0d0
    allocate( Jcoeff_L3(7*ndim_spinor,7*ndim_spinor) ); JCoeff_L3 = 0.0d0
    
    Do il1=1, nloc
       immax = 2*il1 -1;     my_l = il1 -1
       
       num = 0
! j=l-1/2
       val_j = my_l -0.5d0
       if ( val_j > 0 ) then
          Do ma=-my_l+1, my_l
             val_mj = ma -0.5d0
             m1 = nint(val_mj -0.5d0);   m2 = nint(val_mj +0.5d0)
             
             c1 = dble( my_l -m1 )/( 2.0d0 *my_l +1.0d0 );  c1 = sqrt(c1)
             c2 = dble( my_l +m2 )/( 2.0d0 *my_l +1.0d0 );  c2 = -sqrt(c2)
             
             num = num +1
             Do im1=1, immax
                if ( my_l == 1 ) then
                   Jcoeff_L1(      im1,num) = c1 *MatU_ylm_RC_L1(im1,m1)
                   Jcoeff_L1(immax+im1,num) = c2 *MatU_ylm_RC_L1(im1,m2)
                else if ( my_l == 2 ) then
                   JCoeff_L2(      im1,num) = c1 *MatU_ylm_RC_L2(im1,m1)
                   JCoeff_L2(immax+im1,num) = c2 *MatU_ylm_RC_L2(im1,m2)
                else if ( my_l == 3 ) then
                   Jcoeff_L3(      im1,num) = c1 *MatU_ylm_RC_L3(im1,m1)
                   Jcoeff_L3(immax+im1,num) = c2 *MatU_ylm_RC_L3(im1,m2)
                endif
             End Do
          end Do
       endif
! j=l+1/2
       val_j = my_l +0.5d0
       Do ma=-my_l-1, my_l
          val_mj = ma +0.5d0
          m1 = nint(val_mj -0.5d0);  m2 = nint(val_mj +0.5d0)
          
          c1 = dble( my_l+m2 ) /( 2.0d0 *my_l +1.0d0 );     c1 = sqrt(c1)
          c2 = dble( my_l-m1 ) /( 2.0d0 *my_l +1.0d0 );     c2 = sqrt(c2)
          
          num = num +1
          if ( m1 >= -my_l .and. m1 <= my_l ) then
             Do im1=1, immax
                if ( my_l == 0 ) then
                   JCoeff_L0(im1,num) = c1 *MatU_ylm_RC_L0(im1,m1)
                else if ( my_l == 1 ) then
                   JCoeff_L1(im1,num) = c1 *MatU_ylm_RC_L1(im1,m1)
                else if ( my_l == 2 ) then
                   JCoeff_L2(im1,num) = c1 *MatU_ylm_RC_L2(im1,m1)
                else if ( my_l == 3 ) then
                   JCoeff_L3(im1,num) = c1 *MatU_ylm_RC_L3(im1,m1)
                endif
             End Do
          end if
          if ( m2 >= -my_l .and. m2 <= my_l ) then
             Do im1=1, immax
                if ( my_l == 0 ) then
                   JCoeff_L0(immax+im1,num) = c2 *MatU_ylm_RC_L0(im1,m2)
                else if ( my_l == 1 ) then
                   JCoeff_L1(immax+im1,num) = c2 *MatU_ylm_RC_L1(im1,m2)
                else if ( my_l == 2 ) then
                   JCoeff_L2(immax+im1,num) = c2 *MatU_ylm_RC_L2(im1,m2)
                else if ( my_l == 3 ) then
                   JCoeff_L3(immax+im1,num) = c2 *MatU_ylm_RC_L3(im1,m2)
                endif
             End Do
          end if
       end Do
    End Do
  end subroutine set_Jcoeff_L0_L3

end module m_OP_rotation

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 597 $)
!
!  MODULE:  m_ES_WF_by_submat
!
!  AUTHOR(S): Tsuyoshi Miyazaki, T. Yamasaki   August/20/2003
!             Takenori Yamamoto June/22/2005
!  FURTHER MODIFICATION: T. Yamasaki, September 2009
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
#ifdef __TIMER__
#   define __TIMER_START_w_BARRIER(str,a)  call mpi_barrier(str,ierr); call timer_sta(a)
#   define __TIMER_STOP_w_BARRIER(str,a)   call timer_sta(a); call mpi_barrier(str,ierr)
#   define __TIMER_START(a)                call timer_sta(a)
#   define __TIMER_STOP(a)                 call timer_end(a)
#else
#   define __TIMER_START_w_BARRIER(str,a)
#   define __TIMER_STOP_w_BARRIER(str,a)
#   define __TIMER_START(a)
#   define __TIMER_STOP(a)
#endif
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)  call timer_sta(a)
#   define __TIMER_DO_STOP(a)   call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_DGEMM__
#   define __TIMER_DGEMM_START(a)  call timer_sta(a)
#   define __TIMER_DGEMM_STOP(a)   call timer_end(a)
#else
#   define __TIMER_DGEMM_START(a)
#   define __TIMER_DGEMM_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif

module m_ES_WF_by_submat
! $Id: m_ES_WF_by_submat.F90 597 2019-07-26 03:08:56Z jkoga $

!!$#ifdef TRANSPOSE
#ifdef VPP
#define _ODD_BOUNDARY_
#endif
#ifdef SX
#define _ODD_BOUNDARY_
#endif
#ifdef NEC_TUNE1
#define _ODD_BOUNDARY_
#endif

#ifndef NO_SUBMAT_DGEMM
#define SUBMAT_DGEMM
#endif

  use m_Const_Parameters,    only : DP,SP,DIRECT,ON,OFF,SCF, SmallestPositiveNumber,GAMMA &
       &                          , HOUSEHOLDER, DIVIDEandCONQUER, ELECTRON, CMPLDP, OLD, INVERSE, EXECUT
  use m_Parallelization,     only : mpi_comm_group &
       &                          , myrank_e,myrank_k,map_e,map_k,ista_e,iend_e,istep_e &
       &                          , ista_k,iend_k,np_g1k,mpi_k_world,map_z &
       &                          , np_e,npes, nrank_k, nrank_e,mype &
       &                          , np_fs
  use m_Control_Parameters,  only : nspin,iprisubmat,ldiag,kimg,neg,af &
       &                          , submat_critical_ratio,printable &
       &                          , m_CtrlP_set_submat, sw_scalapack &
       &                          , method_scalapack, block_size, nprow, npcol &
       &                          , msize_submat, sw_hybrid_functional, sw_fef &
       &                          , nblocksize_submat_is_given, nblocksize_submat, nb_submat_default &
       &                          , sw_gep &
       &                          , submat_uncalled &
       &                          , sw_serial_fft                    &
       &                          , sw_keep_hloc_phi &
#ifdef SAVE_FFT_TIMES
       &                          , nb_mgs_default, sw_save_fft
#else
       &                          , nb_mgs_default
#endif
  use m_Files,               only : nfout
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_FFT,                 only : nfft,fft_box_size_WF
  use m_FFT,                 only : m_FFT_Vlocal_W, m_FFT_WF
  use m_Kpoints,             only : kv3,vkxyz, k_symmetry
  use m_PlaneWaveBasisSet,   only : kg1, iba, igf, nbase, m_pwBS_kinetic_energies
  use m_Electronic_Structure,only : zaj_l, zaj_l_buf,neordr,           nrvf_ordr &
#ifdef SAVE_FFT_TIMES
       &                          , status_saved_phifftr &
#endif
       &                          , eko_l,vnlph_l 
  use m_Electronic_Structure,only : m_ES_Vlocal_in_Rspace &
       &                          , m_ES_WF_in_Rspace &
       &                          , m_ES_wd_zaj_small_portion &
       &                          , m_ES_wd_eko &
       &                          , hlocphi_l, vtau_l
  use m_ES_nonlocal,         only : sc ,ss ,qc                                        &
 &                                , m_ES_Vnonlocal_W                                  &
 &                                , m_ES_betar_dot_WFs_4_each_k                       &
 &                                , m_ES_alloc_scss_etc                               &
 &                                , m_ES_dealloc_scss_etc
  use m_ES_ortho,            only : np_g1k_x
  use m_ES_ortho,            only : m_ES_W_transpose_r                                &
 &                                , m_ES_W_transpose_back_r                           &
 &                                , m_ES_W_transpose_back2                            &
 &                                , m_ES_W_transpose_fft_cmplx                        &
 &                                , m_ES_W_transpose_back_fft_cmplx

  use m_ES_ExactExchange,    only : m_ES_Vexx_W
  use m_FiniteElectricField, only : m_FEF_add_grad_to_vnlph

! ================================= added by K. Tagami ============== 11.0
  use m_Control_Parameters,    only : ndim_spinor, ndim_chgpot
  use m_Electronic_Structure,  only : m_ES_Vlocal_in_Rspace_noncl
  use m_FFT,                   only : m_FFT_Vlocal_W_noncl
  use m_Electronic_Structure,      only : m_ES_sort_eigen_vals_noncl
! =================================================================== 11.0

  use m_Control_Parameters,  only : use_metagga, vtau_exists
  use m_ES_WF_by_SDorCG, only : m_ES_contrib_kindens_to_vnlph

  use m_Control_Parameters, only : sw_rsb

  implicit none
  logical, allocatable, dimension(:) :: non_diagonal_part_is_small

  integer, save :: npart,npart2
  integer, allocatable, save :: isp(:),iep(:)
  integer, allocatable, save :: isp2(:),iep2(:)

  real(kind=DP), allocatable, target, dimension(:,:) :: unimat,unimat_h

  integer, private, save :: lda,occ
#ifdef SINGLE_CONTEXT
   integer, private, allocatable, save :: usermap(:,:)
#else
   integer, private, allocatable, save :: usermap(:,:,:) ! d(nprow,npcol,0:nrank_k-1)
#endif

   logical :: disable_utransform = .false.
   integer :: ierr

  include 'mpif.h'
contains
  subroutine m_ESsubmat_alloc()
    if(.not.allocated(non_diagonal_part_is_small)) then
       allocate(non_diagonal_part_is_small(kv3))
!!$       non_diagonal_part_is_small = .false.
    end if
    non_diagonal_part_is_small = .false.
  end subroutine m_ESsubmat_alloc

  subroutine m_ESsubmat_dealloc()
    if(allocated(non_diagonal_part_is_small)) deallocate(non_diagonal_part_is_small)
  end subroutine m_ESsubmat_dealloc

  subroutine m_ESsubmat_reset_non_diagon()
    if(allocated(non_diagonal_part_is_small)) non_diagonal_part_is_small = .false.
  end subroutine m_ESsubmat_reset_non_diagon

  subroutine m_ESsubmat_Renew_WF(nfout,meg,damp)
    integer, intent(in) :: nfout,meg
    real(kind=DP)       :: damp

    integer             :: ispin, iksnl, ik
    real(kind=DP), allocatable, dimension(:) ::  afft, bfft, cfft
    real(kind=DP), pointer, dimension(:) :: ekin, p, vnldi

    integer :: n_all_kpoints, n_submat, ipri0
    logical :: submat_is_done

    submat_is_done = .false.
    call m_ES_alloc_scss_etc()

    allocate(afft(nfft));   allocate(bfft(nfft))
    if ( use_metagga .and. vtau_exists ) allocate( cfft(nfft) )

    ekin => sc(1:kg1); p => ss(1:kg1); vnldi => qc(1:kg1)

    n_all_kpoints = 0
    n_submat = 0
!!$    if(m_CtrlP_ntcnvg_clear()) non_diagonal_part_is_small = .false.
    if(iprisubmat >= 2) write(nfout,'(" !! <<m_ESsubmat_Renew_WF>>")')
    call get_ipri0(iprisubmat,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)

    do ispin = 1, nspin, (af+1)
       call m_ES_Vlocal_in_Rspace(ispin,afft)      ! (ptfft1) vlhxc_l->afft
       if ( use_metagga .and. vtau_exists ) then
          call m_ES_Vlocal_in_Rspace( ispin, cfft, vtau_l )    ! r space
       endif

       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle          ! MPI
          n_all_kpoints = n_all_kpoints + 1
          if(non_diagonal_part_is_small(ik)) then
             if(iprisubmat >= 2) write(nfout,'(" !!! submat is not done for ik=",i4)') ik
             cycle
          else
             if(iprisubmat >= 2) write(nfout,'(" !!! submat is done for ik=",i4)') ik
             n_submat = n_submat + 1
             submat_is_done = .true.
          end if
          iksnl = (ik-1)/nspin + 1
          call m_ES_Vnonlocal_W(ik,iksnl,ispin,switch_of_eko_part=OFF)  ! (nonloc) ->(vnlph_l)
          if(sw_hybrid_functional==ON) call m_ES_Vexx_W(ik) ! (exx) ->(vnlph_l)
          if(sw_fef==ON) call m_FEF_add_grad_to_vnlph(ik) !->vnlph_l

          if ( use_metagga .and. vtau_exists ) then
             call m_ES_contrib_kindens_to_vnlph( ispin, ik, cfft ) ! -> vnlph_l
          endif
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin) ! (diakin) ->ekin
          call evolve_WFs_in_subspace&     !-(m_ES_WF_by_submat)
                  &(ik,iksnl,ispin,meg,damp,ekin,afft,bfft)

          if(ik==1.and.iprisubmat>= 2) &
               & call m_ES_wd_zaj_small_portion(nfout,1," -- after subspace-rotation --",30)
          call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   ! -> fsr_l,fsi_l
       enddo      ! k-point loop
    enddo      ! spin loop

    if ( allocated(cfft) ) deallocate( cfft )

!!$    if(npes > 1) then
!!$       call mpi_allreduce(n_submat,n_submat_mpi,1,mpi_integer,mpi_sum,mpi_k_world(myrank_k),ierr)
!!$       n_submat = n_submat_mpi
!!$    end if

!!  ( in case of af=1 )
    if(af /= 0) then
       call cp_eigen_values_for_af       !-(contained here)
       call expand_neordr_and_nrvf_ordr  !-(contained here)
    end if

    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)
    deallocate(bfft);   deallocate(afft)
    call m_ES_dealloc_scss_etc()
    if(iprisubmat >= 2) then
       if(submat_is_done) write(nfout,'(" !solver -- subspace_rotation is done for ",i4," of ",i4," kpoints")') &
            & n_submat, n_all_kpoints
       if(.not.submat_is_done) write(nfout,'(" !solver --  no subspace_rotation")')
    end if

    if(nrank_k > 1) then
       call mpi_allreduce(MPI_IN_PLACE, n_submat,1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
       call mpi_allreduce(MPI_IN_PLACE, n_all_kpoints,1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
    end if

    if(submat_is_done .and. n_submat < n_all_kpoints) submat_is_done = .false.
    call m_CtrlP_set_submat(submat_is_done)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine cp_eigen_values_for_af
      integer :: ik,ib
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle    ! MPI
         do ib = 1, np_e                    ! MPI
            eko_l(ib,ik+af) = eko_l(ib,ik)
         enddo
      enddo
    end subroutine cp_eigen_values_for_af

    subroutine expand_neordr_and_nrvf_ordr
      integer :: ik
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle     ! MPI
         neordr(1:neg,ik+af) = neordr(1:neg,ik)
         nrvf_ordr(1:neg,ik+af) = nrvf_ordr(1:neg,ik)
      end do
    end subroutine expand_neordr_and_nrvf_ordr

  end subroutine m_ESsubmat_Renew_WF


! ===================================== added by K. Tagami ================ 11.0
  subroutine m_ESsubmat_Renew_WF_noncl(nfout,meg,damp)
    integer, intent(in) :: nfout,meg
    real(kind=DP)       :: damp

    integer             :: is, iksnl, ik

    real(kind=DP), allocatable ::  afft_kt(:,:)
    real(kind=DP), allocatable ::  bfft_kt(:,:)

    real(kind=DP), pointer, dimension(:) :: ekin, p, vnldi

    real(kind=DP), allocatable :: vnlph_noncl(:,:,:,:)

    integer :: n_all_kpoints, n_submat, ipri0
    logical :: submat_is_done

    integer :: is1, is2, k2, istmp

    submat_is_done = .false.

    call m_ES_alloc_scss_etc()
    allocate(afft_kt(nfft,ndim_chgpot))
    allocate(bfft_kt(nfft,ndim_spinor))

    ekin => sc(1:kg1); p => ss(1:kg1); vnldi => qc(1:kg1)

    allocate(vnlph_noncl(kg1,np_e,kimg,ndim_spinor)); vnlph_noncl = 0.0d0

    n_all_kpoints = 0;     n_submat = 0

    if (iprisubmat >= 2) write(nfout,'(" !! <<m_ESsubmat_Renew_WF_noncl>>")')
    call get_ipri0(iprisubmat,ipri0)

    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)

    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )    ! (ptfft1) vlhxc_l->afft

    Do ik = 1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle          ! MPI
       iksnl = (ik-1) /ndim_spinor + 1

       n_all_kpoints = n_all_kpoints + 1

       if ( non_diagonal_part_is_small(ik) ) then
          if(iprisubmat >= 2) write(nfout,'(" !!! submat is not done for ik=",i4)') ik
          cycle
       else
          if(iprisubmat >= 2) write(nfout,'(" !!! submat is done for ik=",i4)') ik
          n_submat = n_submat + 1
          submat_is_done = .true.
       end if

       vnlph_noncl = 0.0d0

       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
            istmp = ( is1-1 )*ndim_spinor +is2
            k2 = ik +is2 -1

            call m_ES_Vnonlocal_W( k2, iksnl, istmp, switch_of_eko_part=OFF )
!!!!           call m_ES_Vnonlocal_W( k2, iksnl, istmp, switch_of_eko_part=ON )
                                                   ! (nonloc) ->(vnlph_l)
            vnlph_noncl(:,:,:,is1) = vnlph_noncl(:,:,:,is1) &
             &                     + vnlph_l(:,:,:)              
          End do
       End do

       if ( sw_hybrid_functional==ON ) call m_ES_Vexx_W(ik) ! (exx) ->(vnlph_l)

       call m_pwBS_kinetic_energies( ik, vkxyz, ekin )       ! (diakin) ->ekin

       call evolve_WFs_in_subspace_noncl( ik, meg, damp, ekin, afft_kt, bfft_kt, &
	&                                 vnlph_noncl )

       if ( ik==1 .and. iprisubmat>= 2 ) then
          Do is1=1, ndim_spinor
            call m_ES_wd_zaj_small_portion( nfout, ik+is1-1, &
                   &                        " -- after subspace-rotation --",30 )
          End do
       endif
       Do is1=1, ndim_spinor
          call m_ES_betar_dot_WFs_4_each_k( nfout,ik+is1-1 )   ! -> fsr_l,fsi_l
       End do
    End do

! ****************************************** This is important ******
    call m_ES_sort_eigen_vals_noncl()
! *******************************************************************

    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)
    deallocate(bfft_kt);   deallocate(afft_kt)

    call m_ES_dealloc_scss_etc()

    if (iprisubmat >= 2) then
       if(submat_is_done) write(nfout,'(" !solver -- subspace_rotation is done for ",i4," of ",i4," kpoints")') &
            & n_submat, n_all_kpoints
       if(.not.submat_is_done) write(nfout,'(" !solver --  no subspace_rotation")')
    end if

    if (nrank_k > 1) then
       call mpi_allreduce(MPI_IN_PLACE, n_submat,     1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
       call mpi_allreduce(MPI_IN_PLACE, n_all_kpoints,1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
    end if

    if (submat_is_done .and. n_submat < n_all_kpoints) submat_is_done = .false.
    call m_CtrlP_set_submat(submat_is_done)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

  end subroutine m_ESsubmat_Renew_WF_noncl
!======================================================================= 11.0

 subroutine evolve_WFs_in_subspace&
       &(ik,iksnl,ispin,meg,damp,ekin,afft,bfft)
!
! Revised by T. Yamasaki, September 2009 : SUBMAT_DGEMM
!
    integer, intent(in) :: ik,iksnl,ispin,meg
    real(kind=DP), intent(in)  :: damp,ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:) ::     eko_d
    real(kind=DP), allocatable,dimension(:) ::   w1hw2
    real(kind=DP), allocatable,dimension(:,:) ::   zz
    real(kind=DP), allocatable,dimension(:,:,:) :: zat_l
    real(kind=DP), allocatable,dimension(:,:,:) :: zah_l
    real(kind=DP), allocatable,dimension(:,:,:) :: zahloc_l
    real(kind=DP), allocatable,dimension(:,:,:) :: zat_wk
    real(kind=DP), allocatable,dimension(:,:,:) :: zahloc_wk

    real(kind=DP), allocatable :: amat(:,:), zmat(:,:)
!    integer, save :: lwork,lrwork,liwork,lda,occ
    integer, save :: lwork,lrwork,liwork
#ifdef _USE_SCALAPACK_
    integer, save :: lwork1,lrwork1,liwork1
    integer, save :: lwork2,lrwork2,liwork2
#endif
#ifdef SINGLE_CONTEXT
    integer, save :: ictxt, myrow, mycol
#else
    integer, save :: myrow, mycol, tmpctxt
    integer, allocatable, save :: ictxt(:) ! d(0:nrank_k-1)
#endif
    integer, dimension(9), save :: desca,descz
!#ifdef SINGLE_CONTEXT
!    integer, allocatable, save :: usermap(:,:)
!#else
!    integer, allocatable, save :: usermap(:,:,:) ! d(nprow,npcol,0:nrank_k-1)
!#endif
!!$    integer, save :: npart,npart2
!!$    integer, allocatable, save :: isp(:),iep(:)
!!$    integer, allocatable, save :: isp2(:),iep2(:)
!    logical, save :: first = .true.
    integer :: is,ie,m,jp
    integer :: msize

    integer       :: ib1,ib2,ib1to,i1,ii,ri,ib, i, kimg_t, ig1
    real(kind=DP) :: denom, eko1, eko2, ekod
    real(kind=DP) :: dr1,dr2,di1,di2, dd
    real(kind=DP) :: sum_sq_diagonal, sum_sq_non_diagonal &
         & , sum_abs_diagonal, sum_abs_non_diagonal
    integer :: id_sname = -1, id_sname2 = -1, ipri0
    integer :: max_block_size
#ifdef SUBMAT_DGEMM
    real(kind=DP),allocatable,dimension(:,:) :: w1hw2r,w1hw2i
    real(kind=DP) :: alpha, beta
#endif
! <-- T.Kokubo & D.Fukata, Feb. 2010
    integer :: ibsta, ibend, nblk1, nblk2, ibsize, ibsize2
    if(nblocksize_submat_is_given) then
      ibsize = nblocksize_submat
    else
      ibsize = nb_submat_default
    endif
! -->
    call tstatc0_begin('evolve_WFs_in_subspace ', id_sname,1)

    denom = 1.d0/product(fft_box_size_WF(1:3,1))

! (allocate)  zat_l will be divided by G-index
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if

    allocate(eko_d(neg));     eko_d = 0.d0
    allocate(eig(meg)); eig=0.d0
#ifdef _ODD_BOUNDARY_
    if(mod(np_g1k(ik),2) == 0) then
       np_g1k_x = np_g1k(ik) + 1
    else
       np_g1k_x = np_g1k(ik)
    end if
#else
    np_g1k_x = np_g1k(ik)
#endif
    allocate(zat_l(np_g1k_x,neg,kimg))
    !!$allocate(zah_l(np_g1k_x,neg,kimg))

    do ib1 = 1, neg
       if(map_e(ib1) == myrank_e) eko_d(ib1) = eko_l(map_z(ib1),ik)
    end do
    call mpi_allreduce(MPI_IN_PLACE,eko_d,neg,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
    eko1 = sum(eko_d(1:neg))

!( tenchi ) (zat_l <- zaj_l)
! --> T. Yamasaki, 28th Aug. 2009
!!$    call m_ES_W_transpose(ista_k,iend_k,ik,zaj_l,zat_l)
    call m_ES_W_transpose_r(.true.,ista_k,iend_k,ik,zaj_l,zat_l)
! <--

! (zaj_l <- H |phi> )
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(bfft,ib1to,ib,ii,i1,dr1,di1,dr2)
!CDIR CONCUR(BY=1)
#endif
    do ib1 = ista_e, iend_e, istep_e     ! MPI
       ib1to=nrvf_ordr(ib1,ik)
       if(ib1to>meg) cycle
       call m_ES_WF_in_Rspace(ik,ib1,bfft)!(swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft)-> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
       ib = map_z(ib1)                 ! MPI
       if(kimg == 1) then
          do ii=1,iba(ik)
             i1  = igf(nbase(ii,ik))
             dr1 = zaj_l(ii,ib,ik,1)
             dr2 = bfft(i1)*denom
             zaj_l(ii,ib,ik,1)= ekin(ii)*dr1+vnlph_l(ii,ib,1)+dr2
             if(sw_keep_hloc_phi==ON) hlocphi_l(ii,ib,ik,1) = ekin(ii)*dr1+dr2
          enddo
       else
          do ii=1,iba(ik)
             i1  = igf(nbase(ii,ik))
             dr1  = zaj_l(ii,ib,ik,1)
             di1  = zaj_l(ii,ib,ik,2)
             zaj_l(ii,ib,ik,1)= ekin(ii)*dr1+bfft(2*i1-1)*denom+vnlph_l(ii,ib,1)
             zaj_l(ii,ib,ik,2)= ekin(ii)*di1+bfft(2*i1  )*denom+vnlph_l(ii,ib,2)
             if(sw_keep_hloc_phi==ON) then
               hlocphi_l(ii,ib,ik,1)= ekin(ii)*dr1+bfft(2*i1-1)*denom
               hlocphi_l(ii,ib,ik,2)= ekin(ii)*di1+bfft(2*i1  )*denom
             endif
          enddo
       end if
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    end do

!( tenchi ) (zah_l <- zaj_l)
    allocate(zah_l(np_g1k_x,neg,kimg))                                 ! MPI
    allocate(zahloc_l(np_g1k_x,neg,kimg))                                 ! MPI
! --> T. Yamasaki 28th Aug. 009
!!$    call m_ES_W_transpose(ista_k,iend_k,ik,zaj_l,zah_l)
    call m_ES_W_transpose_r(.true.,ista_k,iend_k,ik,zaj_l,zah_l)
    if(sw_keep_hloc_phi==ON) &
    call m_ES_W_transpose_r(.true.,ista_k,iend_k,ik,hlocphi_l,zahloc_l)
! <--

! (make matrix elements )
#ifdef _USE_SCALAPACK_
    if(iprisubmat>=2) write(nfout,'(" sw_scalapack = ",i3," <<evolve_WFs_in_subspace>>")') sw_scalapack
    if(sw_scalapack == ON) then
       if(submat_uncalled) then
! === DEBUG by tkato 2012/01/23 ================================================
          if(block_size == 0) then
             max_block_size = int(real(meg)/real(nrank_e))
             block_size =  nb_mgs_default
             if(block_size.ge.max_block_size) block_size = max_block_size
          end if
! ==============================================================================
          call set_nprow_npcol(nprow,npcol)
#ifdef SINGLE_CONTEXT
          if(allocated(usermap)) deallocate(usermap)
          allocate(usermap(nprow,npcol))
#else
          if(allocated(ictxt)) deallocate(ictxt)
          if(allocated(usermap)) deallocate(usermap)
          allocate(ictxt(0:nrank_k-1))
          allocate(usermap(nprow,npcol,0:nrank_k-1))
#endif
!         call scalapack_setup(meg,lwork,lrwork,liwork,lda,occ,ictxt,myrow,mycol,desca,descz,usermap)
#ifdef SINGLE_CONTEXT
          call scalapack_setup(meg,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt,myrow,mycol,desca,descz,usermap)
#else
          call scalapack_setup(meg,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt(myrank_k),&
           & myrow,mycol,desca,descz,usermap)
#endif
! ===== We need more work area!!! ==============================================
          lwork1  = 10*lwork1
          lrwork1 = 10*lrwork1
          liwork1 = 10*liwork1
          lwork2  = 10*lwork2
          lrwork2 = 10*lrwork2
          liwork2 = 10*liwork2
! ==============================================================================
       end if
       allocate(amat(lda*kimg_t,occ))
       allocate(zmat(lda*kimg_t,occ))
       if(sw_rsb==ON) then
          if(.not.allocated(unimat)) then
             allocate(unimat(lda*kimg_t,occ))
             allocate(unimat_h(lda*kimg_t,occ))
          endif
       endif
    else
       allocate(zmat(meg*kimg_t,meg))
       if(sw_rsb==ON) then
          if(.not.allocated(unimat)) then
             allocate(unimat(meg*kimg_t,meg))
             allocate(unimat_h(meg*kimg_t,meg))
          endif
       endif
    end if

#else
    allocate(zmat(meg*kimg_t,meg))
    if(sw_rsb==ON) then
       if(.not.allocated(unimat)) then
          allocate(unimat(meg*kimg_t,meg))
          allocate(unimat_h(meg*kimg_t,meg))
       endif
    endif
    zmat=0.0d0
#endif
    if(submat_uncalled) then
!!$       call set_col_partition ! -> npart,isp,iep, npart2, isp2, iep2
       call set_col_partition_G(kimg_t,meg,ibsize) ! -> npart,isp,iep, npart2, isp2, iep2
       submat_uncalled = .false.
    end if

    call tstatc0_begin('evolve_WFs_in_subspace(PART1) ', id_sname2)
!!$    if(iprisubmat>=2) then
!!$       write(nfout,'(" --- neordr ---")')
!!$       write(nfout,'(" ik = ",i8)') ik
!!$       write(nfout,'(10i8)') (neordr(ib1,ik),ib1=1, neg)
!!$       write(nfout,'(" --- nrvf_ordr ---")')
!!$       write(nfout,'(" ik = ",i8)') ik
!!$       write(nfout,'(10i8)') (nrvf_ordr(ib1,ik),ib1=1, neg)
!!$    end if

    ekod = 0.d0
    sum_abs_diagonal = 0.d0
    sum_sq_diagonal = 0.d0
    sum_sq_non_diagonal = 0.d0
    sum_abs_non_diagonal = 0.d0
    PART1: do jp = 1,npart
       is = isp(jp)
       ie = iep(jp)
       msize = is*(ie-is+1) + (ie-is+1)*(ie-is)/2
       allocate(w1hw2(msize*kimg_t))
       w1hw2 = 0.d0
       if(iprisubmat>=2) then
          write(nfout,'(" jp, is, ie = ",3i8)') jp, is, ie
       end if
#ifdef SUBMAT_DGEMM
! <-- T.Kokubo & D.Fukata Feb. 2010
       nblk1 = ie-is+1
#ifdef SX
       ibsize2 = min(ie,meg)
#else
       ibsize2 = ibsize
#endif

       allocate(w1hw2r(ibsize2,nblk1)); w1hw2r = 0.d0
       if(kimg==2 .and. k_symmetry(ik) /= GAMMA) then
          allocate(w1hw2i(ibsize2,nblk1)); w1hw2i = 0.d0
       end if

       do ibsta=1,min(ie,meg), ibsize2
          ibend=min( ibsta+ibsize2-1, min(ie,meg) )
          nblk2=ibend-ibsta+1
          w1hw2r = 0.d0
          if(kimg==2 .and. k_symmetry(ik) /= GAMMA) w1hw2i = 0.d0

          if(kimg==1) then
             call dgemm('T','N',nblk2,nblk1,np_g1k(ik),1.d0,zat_l(1,ibsta,1),np_g1k_x, &
                  &     zah_l(1,is,1),np_g1k_x,1.d0,w1hw2r,ibsize2)
             do ib1 = max(is,ibsta), min(ie,meg)
                do ib2 = ibsta,min(ibend,ib1) 
                   m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                   w1hw2(m)=w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                end do
             end do
          else
             if(k_symmetry(ik) == GAMMA) then
                ig1=1;if(myrank_e==0) ig1=2
                call dgemm('T','N',nblk2,nblk1,np_g1k(ik),1.d0,zat_l(1,ibsta,1),np_g1k_x, &
                     &     zah_l(1,is,1),np_g1k_x,1.d0,w1hw2r,ibsize2)
                call dgemm('T','N',nblk2,nblk1,np_g1k(ik),1.d0,zat_l(1,ibsta,2),np_g1k_x, &
                     &     zah_l(1,is,2),np_g1k_x,1.d0,w1hw2r,ibsize2)
                w1hw2r = w1hw2r*2.d0
                if(myrank_e == 0) then
                   do ib1 = max(is,ibsta), min(ie,meg)
                      do ib2 = ibsta,min(ibend,ib1)
                         w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1) =  w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1) &
                        &                                          - 2.d0*zah_l(1,ib1,2)*zat_l(1,ib2,2)       &
                        &                                          -      zah_l(1,ib1,1)*zat_l(1,ib2,1)
                      end do
                   end do
                end if
                do ib1 = max(is,ibsta), min(ie,meg)
                   do ib2 = ibsta,min(ibend,ib1)
                      m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                      w1hw2(m)=w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                   end do
                end do
             else
                call dgemm('T','N',nblk2,nblk1,np_g1k(ik), 1.d0,zat_l(1,ibsta,1),np_g1k_x, &
                     &     zah_l(1,is,1),np_g1k_x,1.d0,w1hw2r,ibsize2)
                call dgemm('T','N',nblk2,nblk1,np_g1k(ik), 1.d0,zat_l(1,ibsta,2),np_g1k_x, &
                     &     zah_l(1,is,2),np_g1k_x,1.d0,w1hw2r,ibsize2)
                call dgemm('T','N',nblk2,nblk1,np_g1k(ik), 1.d0,zat_l(1,ibsta,2),np_g1k_x, &
                     &     zah_l(1,is,1),np_g1k_x,1.d0,w1hw2i,ibsize2)
                call dgemm('T','N',nblk2,nblk1,np_g1k(ik),-1.d0,zat_l(1,ibsta,1),np_g1k_x, &
                     &     zah_l(1,is,2),np_g1k_x,1.d0,w1hw2i,ibsize2)
                do ib1 = max(is,ibsta), min(ie,meg)
                   do ib2 = ibsta,min(ibend,ib1)
                      m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                      w1hw2(2*m-1) = w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                      w1hw2(2*m  ) = w1hw2i(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                   end do
                end do
             end if
          end if
       enddo
! -->
       if(kimg==2 .and. k_symmetry(ik) /= GAMMA) deallocate(w1hw2i)
       deallocate(w1hw2r)

#else
! parallel loop
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(ib2,ii,dr1,dr2,di1,di2,m)
!CDIR CONCUR(BY=1)
#endif
! --> T. Yamasaki 28th Aug. 2009
!   ib1to --> ib1,  instead of ib1to = neordr(ib1,ik) 
!   ib2to --> ib2
       do ib1 = is, ie
          if(ib1>meg) cycle
          do ib2 = 1, ib1
             m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
             if(kimg == 1) then
                do ii = 1, np_g1k(ik)              ! MPI
                   dr1 = zah_l(ii,ib1,1)
                   dr2 = zat_l(ii,ib2,1)
                   w1hw2(m) = w1hw2(m) + dr1*dr2
                end do
             else
                if(k_symmetry(ik) == GAMMA) then
                   dd = 0.d0
!!$                   ig1 = 1;  if(mype == 0) ig1 = 2
                   ig1 = 1;  if(myrank_e == 0) ig1 = 2
                   do ii = ig1, np_g1k(ik)            ! MPI
                      dr1 = zah_l(ii,ib1,1)
                      di1 = zah_l(ii,ib1,2)
                      dr2 = zat_l(ii,ib2,1)
                      di2 = zat_l(ii,ib2,2)
                      dd = dd + (dr1*dr2+di1*di2)*2.d0
                   end do
!!$                   if(mype == 0) dd = dd + zah_l(1,ib1,1)*zat_l(1,ib2,1)
                   if(myrank_e == 0) dd = dd + zah_l(1,ib1,1)*zat_l(1,ib2,1)
                   w1hw2(m)=dd
                else
                   do ii = 1, np_g1k(ik)             ! MPI
                      dr1 = zah_l(ii,ib1,1)
                      di1 = zah_l(ii,ib1,2)
                      dr2 = zat_l(ii,ib2,1)
                      di2 = zat_l(ii,ib2,2)
                      w1hw2(2*m-1)=w1hw2(2*m-1)+dr1*dr2+di1*di2
                      w1hw2(2*m  )=w1hw2(2*m  )+dr1*di2-di1*dr2
                   end do
                end if
             end if
          end do
       end do
#endif

       if(iprisubmat >= 2) call wd_w1hw2(" -- just after making w1hw2 --")

!! (off-diagonal matrix elements will be damped.)
       if(kimg_t == 1) then
          do ib1=max(2,is),ie
             do ib2=1,ib1-1
                m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                sum_sq_non_diagonal = sum_sq_non_diagonal + w1hw2(m)*w1hw2(m)
                sum_abs_non_diagonal = sum_abs_non_diagonal + abs(w1hw2(m))
                w1hw2(m) = damp*w1hw2(m)
             enddo
          enddo
          do ib = is, ie
             m = ib*(ib-1)/2-is*(is-1)/2+ib
             sum_sq_diagonal = sum_sq_diagonal + w1hw2(m)**2
             sum_abs_diagonal = sum_abs_diagonal + abs(w1hw2(m))
             ekod = ekod + w1hw2(m)
          end do
       else
          do ib1=max(2,is),ie
             do ib2=1,ib1-1
                m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                dd = w1hw2(2*m-1)*w1hw2(2*m-1) + w1hw2(2*m)*w1hw2(2*m)
                sum_sq_non_diagonal = sum_sq_non_diagonal + dd
                if(dd >= SmallestPositiveNumber) sum_abs_non_diagonal = sum_abs_non_diagonal + sqrt(dd)
                w1hw2(2*m-1) = damp*w1hw2(2*m-1)
                w1hw2(2*m  ) = damp*w1hw2(2*m  )

             enddo
          enddo
          do ib = is, ie
             m = ib*(ib-1)/2-is*(is-1)/2+ib
             sum_sq_diagonal = sum_sq_diagonal + w1hw2(2*m-1)**2
             sum_abs_diagonal = sum_abs_diagonal + abs(w1hw2(2*m-1))
             ekod = ekod + w1hw2(2*m-1)
          end do
       endif
       if(iprisubmat >= 2) call wd_w1hw2(" -- after damping --")

#ifdef _USE_SCALAPACK_
       if(sw_scalapack==ON) then
          call set_amat(lda,kimg_t,occ,amat,meg,nprow,npcol,block_size,usermap,is,ie,w1hw2)
       else
#endif
          call set_hmat(kimg_t,meg,is,ie,w1hw2,zmat)
#ifdef _USE_SCALAPACK_
       end if
#endif

       deallocate(w1hw2)
    end do PART1
    call tstatc0_end(id_sname2)
    deallocate(zah_l)

    sum_abs_diagonal = sum_abs_diagonal/meg
    sum_abs_non_diagonal = sum_abs_non_diagonal/(meg*(meg-1)/2)

    if(iprisubmat >= 2) then
       write(nfout,*) 'neordr for ik = ',ik
       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'nrvf_ordr for ik = ',ik
       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'eig'
       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,neg)
    endif
9002 format(5x,10i8)

!! (Diagonalization )  !!
#ifdef _USE_SCALAPACK_
     if(sw_scalapack == ON) then
        if(kimg_t == 1) then
!          call pdsyev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork,liwork)
           call pdsyev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork1,liwork1)
        else
!          call pzheev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork,lrwork,liwork)
           call pzheev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork2,lrwork2,liwork2)
        endif
     else
#endif
        if(kimg_t == 1) then
           call dsyev_driver(meg,eig,zmat)
        else
           call zheev_driver(meg,eig,zmat)
        endif
#ifdef _USE_SCALAPACK_
     endif
#endif

     if(iprisubmat >= 2) then
        write(nfout,*) 'eko_d for ik = ',ik
        write(nfout,9001) (eko_d(ib),ib=1,meg)
        write(nfout,*) 'eig for ik = ',ik
        write(nfout,9001) (eig(ib),ib=1,meg)
        !!$call wd_w1hw2(" -- after diagonalization --")
        !!$call wd_zmat(" -- after diagonalization --")
!sum eko
     end if

     call get_ipri0(iprisubmat,ipri0)
     if(ipri0>=2) then
        dr1=0.d0;dr2=0.d0
        do ib1=1,meg
           ib1to = neordr(ib1,ik)
           if(map_e(ib1to) == myrank_e) dr1=dr1+eko_l(map_z(ib1to),ik)
           dr2=dr2+eig(ib1)
        enddo
        call mpi_allreduce(MPI_IN_PLACE, dr1,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
     end if
     if(iprisubmat>=2) then
        write(nfout,*) ' sum of eko_l & eig =',dr1,dr2
        write(nfout,'(" sum_sq_diagonal , sum_sq_non_diagonal  = ",2d20.12)') sum_sq_diagonal, sum_sq_non_diagonal
        write(nfout,'(" sum_abs_diagonal ,sum_abs_non_diagonal = ",2d20.12)') sum_abs_diagonal, sum_abs_non_diagonal
     end if

!! (subspace rotation) !!
     allocate(zat_wk(np_g1k_x,meg,kimg))
     allocate(zahloc_wk(np_g1k_x,meg,kimg))
     zat_wk=0.d0
     zahloc_wk=0.d0
! <-- T.Kokubo & D.Fukata, Feb. 2010
        PART2: do jp = 1,npart2
           is = isp2(jp)
           ie = iep2(jp)
           nblk1 = ie-is+1
#ifdef SX
           ibsize2 = meg
#else
           ibsize2 = ibsize
#endif
#ifdef _USE_SCALAPACK_
     if(sw_scalapack == ON) then
           allocate(zz(meg*kimg_t,nblk1))
           call put_zmat(kimg_t,lda,occ,zmat,meg,nprow,npcol,block_size,usermap,is,ie,zz)
           if(kimg == 1) then
              call subspace_rotation_real(is,ie,zat_wk,zz,nblk1,ibsize2,ik,meg,zat_l,zahloc_wk, zahloc_l)
           else
              call subspace_rotation_imag(is,ie,kimg_t,zat_wk,zz,nblk1,ibsize2,ik,meg,zat_l,zahloc_wk, zahloc_l)
           endif
           deallocate(zz)
     else
#endif
           if(kimg == 1) then
              call subspace_rotation_real(is,ie,zat_wk,zmat(1,is),nblk1,ibsize2,ik,meg,zat_l,zahloc_wk, zahloc_l)
           else
              call subspace_rotation_imag(is,ie,kimg_t,zat_wk,zmat(1,is),nblk1,ibsize2,ik,meg,zat_l,zahloc_wk, zahloc_l)
           endif
#ifdef _USE_SCALAPACK_
     end if
#endif
        end do PART2

        if(sw_rsb==ON) then
           unimat(:,:) = zmat(:,:)
           do ib1=1,neg
              do ib2=1,neg
                 unimat_h(kimg_t*ib2-1,ib1) =  unimat(kimg_t*ib1-1,ib2)
                 unimat_h(kimg_t*ib2,  ib1) = -unimat(kimg_t*ib1,  ib2)
              enddo
           enddo
        endif
!
!#ifdef _USE_SCALAPACK_
!     if(sw_scalapack == ON) then
!        PART2: do jp = 1,npart2
!           is = isp2(jp)
!           ie = iep2(jp)
!           allocate(zz(meg*kimg_t,is:ie))
!           call put_zmat(lda,occ,zmat,meg,nprow,npcol,block_size,usermap,is,ie,zz)
!           if(kimg == 1) then
!              call subspace_rotation_real(is,ie,zat_wk,zz)
!           else
!              call subspace_rotation_imag(is,ie,zat_wk,zz)
!           endif
!           deallocate(zz)
!        end do PART2
!     else
!#endif
!        is=1; ie=meg
!        if(kimg == 1) then
!           call subspace_rotation_real(is,ie,zat_wk,zmat)
!        else
!           call subspace_rotation_imag(is,ie,zat_wk,zmat)
!        endif
!#ifdef _USE_SCALAPACK_
!     end if
!#endif
! -->
     zat_l(1:np_g1k(ik),1:meg,1:kimg) = zat_wk(1:np_g1k(ik),1:meg,1:kimg)
     if(sw_keep_hloc_phi==ON) zahloc_l(1:np_g1k(ik),1:meg,1:kimg) = zahloc_wk(1:np_g1k(ik),1:meg,1:kimg)
     deallocate(zat_wk)
     deallocate(zahloc_wk)

!! (zaj_l) by tenchi
     call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,zaj_l,zat_l)            ! zat_l -> zaj_l
     if(sw_keep_hloc_phi==ON) &
     call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,hlocphi_l,zahloc_l)            ! zat_l -> zaj_l
!!$     call m_ES_W_transpose_back2(ista_k,iend_k,ik,0,neordr,zaj_l,zat_l)
     if(meg < neg) then
        call m_ES_W_transpose_back2(ista_k,iend_k,ik,meg,neordr,zaj_l,zat_l)  ! zat_l -> zaj_l
        if(sw_keep_hloc_phi==ON) &
        call m_ES_W_transpose_back2(ista_k,iend_k,ik,meg,neordr,hlocphi_l,zahloc_l)  ! zat_l -> zaj_l
     end if
#ifdef SAVE_FFT_TIMES
     if(sw_save_fft == ON) then
        do ib = 1, np_e
           status_saved_phifftr(ib,ik) = OLD
        end do
     end if
#endif

!! (eko_l)
     if(meg < neg) then
        do ib1=meg+1,neg
           if(map_e(ib1) == myrank_e) then        ! MPI
              eko_l(map_z(ib1),ik)=eko_d(neordr(ib1,ik))
           end if
        enddo
     endif
     do ib1 = 1, meg
        if(map_e(ib1) == myrank_e) then         ! MPI
           eko_l(map_z(ib1),ik)=eig(ib1)
        end if
     end do
     if(iprisubmat >= 2) then
        eko2 = sum(eig(1:meg))
        write(nfout,1201) ik,eko1,ekod,eko2

        write(nfout,*) 'eko_l'
        write(nfout,9001) (eko_l(ib1,ik),ib1=1,meg)
     endif
1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!! (neordr & nrvf_ordr)

     neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
     nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)

! (deallocate)  
    deallocate(eko_d)
    deallocate(eig)
    deallocate(zat_l)
    !!$deallocate(zah_l)
    if(sw_scalapack==ON) deallocate(amat)
    deallocate(zmat)

! === DEBUG by tkato 2012/12/11 ================================================
    call mpi_allreduce(MPI_IN_PLACE,sum_abs_non_diagonal,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
    call mpi_allreduce(MPI_IN_PLACE,sum_abs_diagonal,    1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
! ==============================================================================
    if(.not.non_diagonal_part_is_small(ik)  &
         & .and. sum_abs_non_diagonal/sum_abs_diagonal <= submat_critical_ratio) &
         & non_diagonal_part_is_small(ik) = .true.

    if(iprisubmat >= 2) write(nfout,'(" !submat  non_diagonal/diagonal = ",d20.8)') &
         & sum_abs_non_diagonal/sum_abs_diagonal

    call tstatc0_end(id_sname)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(nrank_e>1) then
         if(myrank_e == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_w1hw2(somecomment)
      character(len=*), intent(in) :: somecomment
      integer :: ib1, ib2, neg_wd1, neg_wd2
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      neg_wd1 = 8
      neg_wd2 = 8
      if(neg_wd1 > ie) neg_wd1 = ie
      if(neg_wd2 > meg) neg_wd2 = meg
      write(nfout,'(" real part (",i8,":",i8,",1:",i8,")")') is,neg_wd1,neg_wd2
      if(kimg_t == 1) then
         do ib1=is,neg_wd1
            write(nfout,9001) (w1hw2(ib1*(ib1-1)/2-is*(is-1)/2+ib2),ib2=1,neg_wd2)
         enddo
         write(nfout,'(" real part (",i8,":",i8,",1:",i8,")")') ie-neg_wd1+1,ie, neg_wd2
         do ib1=ie-neg_wd1+1, ie
            write(nfout,9001) (w1hw2(ib1*(ib1-1)/2-is*(is-1)/2+ib2),ib2=1,neg_wd2)
         enddo
      else
         do ib1=is,neg_wd1
            write(nfout,9001) (w1hw2(2*(ib1*(ib1-1)/2-is*(is-1)/2+ib2)-1),ib2=1,neg_wd2)
         enddo
         write(nfout,'(" real part (",i8,":",i8,",1:",i8,")")') ie-neg_wd1+1,ie, neg_wd2
         do ib1=ie-neg_wd1+1, ie
            write(nfout,9001) (w1hw2(2*(ib1*(ib1-1)/2-is*(is-1)/2+ib2)-1),ib2=1,neg_wd2)
         enddo
         write(nfout,'(" imag part")')
         do ib1=is,neg_wd1
            write(nfout,9001) (w1hw2(2*(ib1*(ib1-1)/2-is*(is-1)/2+ib2)),ib2=1,neg_wd2)
         enddo
      end if
9001  format(1x,8e14.6)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_d(neordr(ib1,ik)),ib1=1,neg_wd2)
    end subroutine wd_w1hw2

#ifdef _USE_SCALAPACK_
#endif
! _USE_SCALAPACK_

  end subroutine evolve_WFs_in_subspace
!fj$$#endif

    subroutine subspace_rotation_real(is,ie,zat_wk,zz,ibsize1,ibsize2,ik,meg,zat_l,zahloc_wk,zahloc_l)
!    Revised by T. Yamasaki 1st Sep. 2009
!    modified by T.Kokubo & D.Fukata, Feb. 2010
      integer, intent(in) :: is,ie, ibsize1,ibsize2,ik,meg
      real(kind=DP), intent(inout) :: zat_wk(np_g1k_x,meg,kimg),zahloc_wk(np_g1k_x,meg,kimg)
      real(kind=DP), intent(in) :: zat_l(np_g1k_x,meg,kimg), zahloc_l(np_g1k_x,meg,kimg)
      real(kind=DP), intent(in) :: zz(meg,ibsize1)
      integer :: ibsta, ibend
      integer :: ib1,ib2
#ifdef SUBMAT_DGEMM
      integer :: nblk2
      real(kind=DP) :: alpha, beta
#endif
      integer :: id_sname = -1

      call tstatc0_begin('subspace_roation_real ', id_sname)
#ifdef SUBMAT_DGEMM
      alpha=1.d0; beta=1.d0
      do ibsta=1,meg, ibsize2
         ibend=min(ibsta+ibsize2-1,meg)
         nblk2=ibend-ibsta+1
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,1),np_g1k_x,zz(ibsta,1),meg, &
           &           beta, zat_wk(1,is,1),np_g1k_x)
            if(sw_keep_hloc_phi==ON) &
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zahloc_l(1,ibsta,1),np_g1k_x,zz(ibsta,1),meg, &
           &           beta, zahloc_wk(1,is,1),np_g1k_x)
      enddo
#else
      do ibsta=1,meg, ibsize2
         ibend=min(ibsta+ibsize2-1,meg)
         do ib2=is,ie
            do ib1=ibsta,ibend
               do ii=1,np_g1k(ik)
                  zat_wk(ii,ib2,1)=zat_wk(ii,ib2,1)+zz(ib1,ib2-is+1)*zat_l(ii,ib1,1)
               enddo
            enddo
         enddo
      enddo
#endif
      call tstatc0_end(id_sname)
    end subroutine subspace_rotation_real

    subroutine subspace_rotation_imag(is,ie,kimg_t,zat_wk,zz,ibsize1,ibsize2,ik,meg,zat_l,zahloc_wk,zahloc_l)
!    Revised by T. Yamasaki 1st Sep. 2009
!    modified by T.Kokubo & D.Fukata, Feb. 2010
      integer, intent(in) :: is,ie,kimg_t, ibsize1,ibsize2,ik,meg
      real(kind=DP), intent(inout) :: zat_wk(np_g1k_x,meg,kimg),zahloc_wk(np_g1k_x,meg,kimg)
      real(kind=DP), intent(in) :: zat_l(np_g1k_x,meg,kimg),zahloc_l(np_g1k_x,meg,kimg)
      real(kind=DP), intent(in) :: zz(meg*kimg_t,ibsize1)
      integer :: id_sname = -1
      integer :: ibsta, ibend
      integer :: ib1,ib2,ii
#ifdef SUBMAT_DGEMM
      real(kind=DP) :: alpha, beta
      integer :: nblk2
      real(kind=DP), allocatable, dimension(:,:) :: zzr,zzi
#endif

      call tstatc0_begin('subspace_roation_imag ', id_sname)

      if(k_symmetry(ik) == GAMMA) then
#ifdef SUBMAT_DGEMM
         alpha = 1.d0; beta = 1.d0
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            nblk2=ibend-ibsta+1
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,1),np_g1k_x,zz(ibsta,1),meg, beta &
                 &                         , zat_wk(1,is,1),np_g1k_x)
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,2),np_g1k_x,zz(ibsta,1),meg, beta &
                 &                         , zat_wk(1,is,2),np_g1k_x)
            if(sw_keep_hloc_phi==ON) then
              call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zahloc_l(1,ibsta,1),np_g1k_x,zz(ibsta,1),meg, beta &
                   &                         , zahloc_wk(1,is,1),np_g1k_x)
              call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zahloc_l(1,ibsta,2),np_g1k_x,zz(ibsta,1),meg, beta &
                   &                         , zahloc_wk(1,is,2),np_g1k_x)
            endif
         enddo
         !!if(iprisubmat>=2) write(nfout,'(" !!<<subspace_rotation_imag>> ibsize = ",i8)') ibsize
#else
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            do ib2=is,ie
!CDIR OUTERUNROLL=4
               do ib1=ibsta,ibend
                  dr1=zz(ib1,ib2-is+1)
                  do ii=1,np_g1k(ik)
                     zat_wk(ii,ib2,1)=zat_wk(ii,ib2,1)+dr1*zat_l(ii,ib1,1)
                     zat_wk(ii,ib2,2)=zat_wk(ii,ib2,2)+dr1*zat_l(ii,ib1,2)
                  enddo
               enddo! ib1 loop
            enddo! ib2 loop
         enddo
#endif
         if(iprisubmat >= 2) then
            do ib2 = is, ie
               write(nfout,'(" --- zat_l (input, output) ---, ib =",i5)') ib2
               write(nfout,'(" zat_l(input ) Re : ",5e14.6)') (zat_l(ii,ib2,1),ii=1,5)
               write(nfout,'(" zat_l(input ) Im : ",5e14.6)') (zat_l(ii,ib2,2),ii=1,5)
               write(nfout,'(" zat_l(output) Re : ",5e14.6)') (zat_wk(ii,ib2,1),ii=1,5)
               write(nfout,'(" zat_l(output) Im : ",5e14.6)') (zat_wk(ii,ib2,2),ii=1,5)
            end do
         end if
      else
#ifdef SUBMAT_DGEMM
         allocate(zzr(ibsize2,ibsize1)); allocate(zzi(ibsize2,ibsize1))
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            nblk2=ibend-ibsta+1
            do ib2=is,ie
               do ib1=ibsta, ibend
                  zzr(ib1-ibsta+1,ib2-is+1)=zz(2*ib1-1,ib2-is+1)
                  zzi(ib1-ibsta+1,ib2-is+1)=zz(2*ib1  ,ib2-is+1)
               end do
            end do

            alpha=1.d0; beta=1.d0
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,1),np_g1k_x,zzr,ibsize2 &
                 &     ,beta, zat_wk(1,is,1),np_g1k_x )
            if(sw_keep_hloc_phi==ON) &
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zahloc_l(1,ibsta,1),np_g1k_x,zzr,ibsize2 &
                 &     ,beta, zahloc_wk(1,is,1),np_g1k_x )
            alpha=-1.d0; beta=1.d0
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,2),np_g1k_x,zzi,ibsize2 &
                 &     ,beta, zat_wk(1,is,1),np_g1k_x )
            if(sw_keep_hloc_phi==ON) &
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zahloc_l(1,ibsta,2),np_g1k_x,zzi,ibsize2 &
                 &     ,beta, zahloc_wk(1,is,1),np_g1k_x )
            alpha=1.d0; beta=1.d0
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,2),np_g1k_x,zzr,ibsize2 &
                 &     ,beta, zat_wk(1,is,2),np_g1k_x )
            if(sw_keep_hloc_phi==ON) &
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zahloc_l(1,ibsta,2),np_g1k_x,zzr,ibsize2 &
                 &     ,beta, zahloc_wk(1,is,2),np_g1k_x )
            alpha=1.d0; beta=1.d0
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,1),np_g1k_x,zzi,ibsize2 &
                 &     ,beta, zat_wk(1,is,2),np_g1k_x )
            if(sw_keep_hloc_phi==ON) &
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zahloc_l(1,ibsta,1),np_g1k_x,zzi,ibsize2 &
                 &     ,beta, zahloc_wk(1,is,2),np_g1k_x )
         enddo
         deallocate(zzi,zzr)
#else
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            do ib2=is,ie
!CDIR OUTERUNROLL=4
               do ib1=ibsta,ibend
                  dr1=zz(2*ib1-1,ib2-is+1)
                  di1=zz(2*ib1  ,ib2-is+1)
                  do ii=1,np_g1k(ik)
                     dr2=zat_l(ii,ib1,1)
                     di2=zat_l(ii,ib1,2)
                     zat_wk(ii,ib2,1)=zat_wk(ii,ib2,1)+dr1*dr2-di1*di2
                     zat_wk(ii,ib2,2)=zat_wk(ii,ib2,2)+dr1*di2+di1*dr2
                  enddo
              enddo! ib1 loop
            enddo! ib2 loop
         enddo
#endif
       end if
       call tstatc0_end(id_sname)
    end subroutine subspace_rotation_imag

  subroutine set_col_partition_G(kimg_t,meg,ibsize)
    integer, intent(in) :: kimg_t,meg
    integer, intent(inout) :: ibsize
!!$integer,parameter :: maxmatsize = 67108864 ! 512MB
    integer :: maxmatsize
    integer :: trisize, size
    integer :: rowsize, block
    integer :: i,is,ie
    integer :: maxsize
! <-- T.Kokubo & D.Fukata, Feb. 2010
#ifdef SUBMAT_DGEMM
    integer :: ibsize_tmp, modnum
    integer,allocatable  :: tmpmem(:)
#endif
! -->

    integer :: id_sname = -1
    call tstatc0_begin('set_col_partition_G ', id_sname)

    maxmatsize = msize_submat * 1024 * 1024 / 8 ! bytes

! <-- T.Kokubo & D.Fukata, Feb. 2010
#ifdef SUBMAT_DGEMM
    ibsize_tmp = ibsize
    npart = meg/ibsize_tmp
    modnum=mod(meg,ibsize_tmp)
    if( modnum.ne.0 ) npart = npart + 1
    if(iprisubmat >= 2) write(nfout,*)' !! SUBMAT :: ibsize=', ibsize, npart

    if(allocated(isp)) deallocate(isp)
    if(allocated(iep)) deallocate(iep)
    if(allocated(tmpmem)) deallocate(tmpmem)
    do
       allocate( isp(npart)   ) ; isp=1
       allocate( iep(npart)   ) ; iep=1
       allocate( tmpmem(npart)) ; tmpmem=0
       do i=1,npart
          is = ibsize_tmp*(i-1)+1           ; isp(i)=is
          ie = min(isp(i)+ibsize_tmp-1,meg) ; iep(i)=ie
#ifdef SX
          tmpmem(i) = kimg*(is*(ie-is+1)+(ie-is+1)*(ie-is)/2) +  2*ie*(ie-is+1)
          !           <----------      w1hw2      ----------> <- w1hw2r,w1hw2i ->
#else
          tmpmem(i) = kimg*(is*(ie-is+1)+(ie-is+1)*(ie-is)/2) + 2*ibsize_tmp*(ie-is+1)
          !           <----------      w1hw2      ----------> <--- w1hw2r, w1hw2i --->
#endif
       enddo
       maxsize=maxval(tmpmem)
       if( maxsize <= maxmatsize ) exit

       ibsize_tmp = ibsize_tmp - 1
       npart = meg/ibsize_tmp
       modnum=mod(meg,ibsize_tmp)
       if( modnum.ne.0 ) npart = npart + 1
       deallocate(isp,iep,tmpmem)
    enddo
    deallocate(tmpmem)
    if( ibsize .ne. ibsize_tmp ) then
       write(nfout,*)' !! SUBMAT_DGEMM : ibsize is changed', ibsize, ' --> ', ibsize_tmp
       ibsize = ibsize_tmp
    endif
#else
    trisize = meg*(meg+1)/2*kimg_t
    if(trisize <= maxmatsize.or.sw_scalapack==OFF) then
       npart = 1
       allocate(isp(npart))
       allocate(iep(npart))
       isp(npart) = 1
       iep(npart) = meg
       maxsize  = trisize
    else
       npart = trisize/maxmatsize
       allocate(isp(npart))
       allocate(iep(npart))
       maxsize  = trisize/npart
       ie = 0 
       do i=1,npart
          is = ie+1
          ie = is
          size = 0
          do while(size*kimg_t <= maxsize)
             ie = ie+1
             size = is*(ie-is+1)+(ie-is+2)*(ie-is+1)/2
          end do
          isp(i) = is
          iep(i) = ie
          if(ie>meg) then
             npart = i
             exit
          end if
       end do
       iep(npart) = meg
    end if
!!$#endif
#endif

#ifdef SUBMAT_DGEMM
    if(allocated(isp2)) deallocate(isp2)
    if(allocated(iep2)) deallocate(iep2)
    npart2 = npart
    allocate(isp2(npart2))
    allocate(iep2(npart2))
    isp2 = isp
    iep2 = iep
#else
    if(allocated(isp2)) deallocate(isp2)
    if(allocated(iep2)) deallocate(iep2)
    rowsize = meg*kimg_t
    if(rowsize*meg<=maxmatsize.or.sw_scalapack==OFF) then
       npart2 = 1
       allocate(isp2(npart2))
       allocate(iep2(npart2))
       isp2(npart2) = 1
       iep2(npart2) = meg
       block = meg
    else
       npart2 = (rowsize*meg)/maxmatsize
       if(npart2 > meg) npart2 = meg
       block = meg/npart2
       allocate(isp2(npart2))
       allocate(iep2(npart2))
       is = 0
       ie = 0
       do i=1,npart2
          is = ie+1 
          ie = is+block-1
          if(i<=mod(meg,npart2)) ie=ie+1
          isp2(i) = is
          iep2(i) = ie
       end do
       iep2(npart2) = meg
    end if
#endif
! -->

    if(printable.and.(sw_scalapack==ON.or.iprisubmat>=2)) then
       write(nfout,*) '== col partition == '
       write(nfout,*) 'target memory(MB)=',msize_submat
       write(nfout,*) 'npart=',npart
       write(nfout,*) 'maxsize=',maxsize
       write(nfout,*) 'memory(MB)=',maxsize*8/1024/1024
       write(nfout,*) 'n, isp, iep, size'
       do i=1,npart
          is = isp(i)
          ie = iep(i)
          size = is*(ie-is+1)+(ie-is+2)*(ie-is+1)/2
          write(nfout,'(4i7)') i, is, ie, size
       end do
       write(nfout,*) 'npart2=',npart2
#ifndef SUBMAT_DGEMM
       write(nfout,*) 'block=',block
       write(nfout,*) 'memory(MB)=',block*rowsize*8/1024/1024
#endif
       write(nfout,*) 'n, isp2, iep2, block'
       do i=1,npart2
          write(nfout,'(4i7)') i, isp2(i), iep2(i), iep2(i)-isp2(i)+1
       end do
    else if(iprisubmat >=2) then
       write(nfout,'(" !target memory(MB) =",i10)') msize_submat
       write(nfout,'(" npart, npart2 = ",2i8)') npart, npart2
       write(nfout,'(" -- isp, iep --")')
       do i = 1, npart
          write(nfout,'(1x,i3," isp(",i3,"), iep(",i3,") = ",2i8)') i,i,i,isp(i),iep(i)
       end do
       write(nfout,'(" -- isp2, iep2 --")')
       do i = 1, npart
          write(nfout,'(1x,i3," isp2(",i3,"), iep2(",i3,") = ",2i8)') i,i,i,isp2(i),iep2(i)
       end do
    end if
    call tstatc0_end(id_sname)
  end subroutine set_col_partition_G


#ifdef _USE_SCALAPACK_
#endif


! ======================================= added by K. Tagami ================= 11.0
  subroutine evolve_WFs_in_subspace_noncl( ik, meg, damp, ekin, afft_kt, bfft_kt, &
	&                                  vnlph_noncl )
!
! Revised by T. Yamasaki, September 2009 : SUBMAT_DGEMM
!
    integer, intent(in) :: ik, meg
    real(kind=DP), intent(in)  :: damp,ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in)  :: vnlph_noncl(kg1,np_e,kimg,ndim_spinor)

! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:) ::     eko_d
    real(kind=DP), allocatable,dimension(:) ::   w1hw2
    real(kind=DP), allocatable,dimension(:,:) ::   zz

    real(kind=DP), allocatable,dimension(:,:,:,:) :: zat_l_noncl
    real(kind=DP), allocatable,dimension(:,:,:,:) :: zah_l_noncl

    real(kind=DP), allocatable,dimension(:,:,:,:) :: zat_wk_noncl

    real(kind=DP), allocatable :: amat(:,:), zmat(:,:)
    integer, save :: lwork,lrwork,liwork,lda,occ

#ifdef _USE_SCALAPACK_
    integer, save :: lwork1,lrwork1,liwork1
    integer, save :: lwork2,lrwork2,liwork2
#endif

#ifdef SINGLE_CONTEXT
    integer, save :: ictxt, myrow, mycol
#else
    integer, save :: myrow, mycol, tmpctxt
    integer, allocatable, save :: ictxt(:) ! d(0:nrank_k-1)
#endif
    integer, dimension(9), save :: desca,descz
#ifdef SINGLE_CONTEXT
    integer, allocatable, save :: usermap(:,:)
#else
    integer, allocatable, save :: usermap(:,:,:) ! d(nprow,npcol,0:nrank_k-1)
#endif
!!$    integer, save :: npart,npart2
!!$    integer, allocatable, save :: isp(:),iep(:)
!!$    integer, allocatable, save :: isp2(:),iep2(:)
!    logical, save :: first = .true.
    integer :: is,ie,m,jp
    integer :: msize

    integer       :: ib1,ib2,ib1to,i1,ii,ri,ib, i, kimg_t, ig1
    real(kind=DP) :: denom, eko1, eko2, ekod
    real(kind=DP) :: dr1,dr2,di1,di2, dd
    real(kind=DP) :: sum_sq_diagonal, sum_sq_non_diagonal &
         & , sum_abs_diagonal, sum_abs_non_diagonal

    integer :: k1, ispinor
    real(kind=DP) :: dd_max
    
    integer :: id_sname = -1, id_sname2 = -1, ipri0
    integer :: max_block_size
#ifdef SUBMAT_DGEMM
    real(kind=DP),allocatable,dimension(:,:) :: w1hw2r,w1hw2i
    real(kind=DP) :: alpha, beta
#endif
! <-- T.Kokubo & D.Fukata, Feb. 2010
    integer :: ibsta, ibend, nblk1, nblk2, ibsize, ibsize2

    if(nblocksize_submat_is_given) then
      ibsize = nblocksize_submat
    else
      ibsize = nb_submat_default
    endif
! -->
    call tstatc0_begin('evolve_WFs_in_subspace_noncl ', id_sname,1)

    denom = 1.d0/product(fft_box_size_WF(1:3,1))

! (allocate)  zat_l will be divided by G-index
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if

    allocate(eko_d(neg));     eko_d = 0.d0
    allocate(eig(meg)); eig=0.d0
#ifdef _ODD_BOUNDARY_
    if(mod(np_g1k(ik),2) == 0) then
       np_g1k_x = np_g1k(ik) + 1
    else
       np_g1k_x = np_g1k(ik)
    end if
#else
    np_g1k_x = np_g1k(ik)
#endif
    allocate( zat_l_noncl(np_g1k_x,neg,kimg,ndim_spinor))  
    zat_l_noncl = 0.0d0


    do ib1 = 1, neg
       if ( map_e(ib1) == myrank_e) eko_d(ib1) = eko_l(map_z(ib1),ik)  ! MPI
    end do

    call mpi_allreduce(MPI_IN_PLACE, eko_d,neg,mpi_double_precision,mpi_sum, mpi_k_world(myrank_k),ierr)

    eko1 = sum(eko_d(1:neg))

!( tenchi ) (zat_l <- zaj_l)
! --> T. Yamasaki, 28th Aug. 2009
!!$    call m_ES_W_transpose(ista_k,iend_k,ik,zaj_l,zat_l)


    Do is=1, ndim_spinor
      call m_ES_W_transpose_r(.true., ista_k, iend_k, ik+is-1, zaj_l, zat_l_noncl(:,:,:,is) )
    End do

! (zaj_l <- H |phi> )
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(bfft,ib1to,ib,ii,i1,dr1,di1,dr2)
!CDIR CONCUR(BY=1)
#endif
    do ib1 = ista_e, iend_e, istep_e     ! MPI
       ib1to=nrvf_ordr(ib1,ik)
       if(ib1to>meg) cycle

       Do is=1, ndim_spinor
         call m_ES_WF_in_Rspace( ik+is-1, ib1, bfft_kt(:,is) )   !(swffft)
       End do
       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor ) 
                                                 ! (afft, bfft)-> (bfft)
       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       ib = map_z(ib1)                 ! MPI
       if ( kimg == 1 ) then
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do ii=1,iba(ik)
               i1  = igf(nbase(ii,ik))
               dr1 = zaj_l( ii, ib, k1, 1 )
               dr2 = bfft_kt(i1,is) *denom
               zaj_l( ii, ib, k1, 1 ) = ekin(ii)*dr1 &
	&                              +vnlph_noncl( ii, ib, 1, is ) +dr2
            enddo
          End do
       else
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do ii=1,iba(ik)
               i1  = igf(nbase(ii,ik))
               dr1  = zaj_l( ii, ib, k1, 1 )
               di1  = zaj_l( ii, ib, k1, 2 ) 
               zaj_l( ii, ib, k1, 1 ) = ekin(ii)*dr1 +bfft_kt( 2*i1-1,is )*denom &
	&                              +vnlph_noncl( ii, ib, 1, is )
               zaj_l( ii, ib, k1, 2 ) = ekin(ii)*di1 +bfft_kt( 2*i1,  is )*denom &
	&                              +vnlph_noncl( ii, ib, 2, is )
            enddo
          End do
       end if
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) then
          do is =1,ndim_spinor
             k1=ik+is-1
             status_saved_phifftr(ib,k1) = OLD
          end do
       end if
#endif
    end do
! ------------------ok  -


!( tenchi ) (zah_l <- zaj_l)
    allocate( zah_l_noncl( np_g1k_x, neg, kimg, ndim_spinor ) )
    zah_l_noncl = 0.0d0     

! --> T. Yamasaki 28th Aug. 009
!!$    call m_ES_W_transpose(ista_k,iend_k,ik,zaj_l,zah_l)

    Do is=1, ndim_spinor
      call m_ES_W_transpose_r(.true., ista_k, iend_k, ik+is-1, zaj_l, zah_l_noncl(:,:,:,is) )
    End do

! <--

! (make matrix elements )
#ifdef _USE_SCALAPACK_
    if(sw_scalapack == ON) then
       if(submat_uncalled) then
! ==== ASMS 2021/03/19
          if(block_size == 0) then
             max_block_size = int(real(meg)/real(nrank_e))
             block_size =  nb_mgs_default
             if(block_size.ge.max_block_size) block_size = max_block_size
          end if
! ==== ASMS 2021/03/19
          call set_nprow_npcol(nprow,npcol)
#ifdef SINGLE_CONTEXT
          if(allocated(usermap)) deallocate(usermap)
          allocate(usermap(nprow,npcol))
#else
          if(allocated(ictxt)) deallocate(ictxt)
          if(allocated(usermap)) deallocate(usermap)
          allocate(ictxt(0:nrank_k-1))
          allocate(usermap(nprow,npcol,0:nrank_k-1))
#endif
!         call scalapack_setup(meg,lwork,lrwork,liwork,lda,occ,ictxt,myrow,mycol,desca,descz,usermap)
#ifdef SINGLE_CONTEXT
          call scalapack_setup(meg,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt,myrow,mycol,desca,descz,usermap)
#else
          call scalapack_setup(meg,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt(myrank_k),&
          & myrow,mycol,desca,descz,usermap)
#endif
! ===== We need more work area!!! ==============================================
          lwork1  = 10*lwork1
          lrwork1 = 10*lrwork1
          liwork1 = 10*liwork1
          lwork2  = 10*lwork2
          lrwork2 = 10*lrwork2
          liwork2 = 10*liwork2
! ==============================================================================
       end if
       allocate(amat(lda*kimg_t,occ))
       allocate(zmat(lda*kimg_t,occ))
    else
       allocate(zmat(meg*kimg_t,meg))
    end if
#else
    allocate(zmat(meg*kimg_t,meg))
    zmat=0.0d0
#endif
    if(submat_uncalled) then
!!$       call set_col_partition ! -> npart,isp,iep, npart2, isp2, iep2
       call set_col_partition_G(kimg_t,meg,ibsize) ! -> npart,isp,iep, npart2, isp2, iep2
       submat_uncalled = .false.
    end if

    call tstatc0_begin('evolve_WFs_in_subspace(PART1) ', id_sname2)
!!$    if(iprisubmat>=2) then
!!$       write(nfout,'(" --- neordr ---")')
!!$       write(nfout,'(" ik = ",i8)') ik
!!$       write(nfout,'(10i8)') (neordr(ib1,ik),ib1=1, neg)
!!$       write(nfout,'(" --- nrvf_ordr ---")')
!!$       write(nfout,'(" ik = ",i8)') ik
!!$       write(nfout,'(10i8)') (nrvf_ordr(ib1,ik),ib1=1, neg)
!!$    end if

    ekod = 0.d0
    sum_abs_diagonal = 0.d0
    sum_sq_diagonal = 0.d0
    sum_sq_non_diagonal = 0.d0
    sum_abs_non_diagonal = 0.d0

! ------------------------------------ part 1 -----------
    PART1: do jp = 1,npart
       is = isp(jp)
       ie = iep(jp)
       msize = is*(ie-is+1) + (ie-is+1)*(ie-is)/2
       allocate(w1hw2(msize*kimg_t))
       w1hw2 = 0.d0
       if(iprisubmat>=2) then
          write(nfout,'(" jp, is, ie = ",3i8)') jp, is, ie
       end if

#ifdef SUBMAT_DGEMM
! <-- T.Kokubo & D.Fukata Feb. 2010
       nblk1 = ie-is+1
#ifdef SX
       ibsize2 = min(ie,meg)
#else
       ibsize2 = ibsize
#endif

       allocate(w1hw2r(ibsize2,nblk1)); w1hw2r = 0.d0
       if(kimg==2 .and. k_symmetry(ik) /= GAMMA) then
          allocate(w1hw2i(ibsize2,nblk1)); w1hw2i = 0.d0
       end if

       do ibsta=1,min(ie,meg), ibsize2
          ibend=min( ibsta+ibsize2-1, min(ie,meg) )
          nblk2=ibend-ibsta+1

          w1hw2r = 0.d0
          if ( kimg==2 .and. k_symmetry(ik) /= GAMMA ) w1hw2i = 0.d0

          if ( kimg==1 ) then
             Do ispinor=1, ndim_spinor
               call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), 1.d0,&
	&                  zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x,  &
                  &        zah_l_noncl(1,is,1,ispinor),    np_g1k_x, &
                  &        1.d0, w1hw2r, ibsize2 )
             End do 

             do ib1 = max(is,ibsta), min(ie,meg)
                do ib2 = ibsta,min(ibend,ib1) 
                   m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                   w1hw2(m) = w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                end do
             end do
          else
             if ( k_symmetry(ik) == GAMMA ) then
                ig1=1
                if ( myrank_e==0 ) ig1=2

                Do ispinor=1, ndim_spinor
                  call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), 1.d0, &
	&                      zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
        &                      zah_l_noncl(1,is,1,ispinor),    np_g1k_x, &
	&                      1.d0, w1hw2r, ibsize2 )
                  call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), 1.d0, &
	&                      zat_l_noncl(1,ibsta,2,ispinor), np_g1k_x, &
        &                      zah_l_noncl(1,is,2,ispinor),    np_g1k_x, &
	&                      1.d0, w1hw2r, ibsize2 )
                End do 

                w1hw2r = w1hw2r*2.d0
                if ( myrank_e == 0 ) then
                   do ib1 = max(is,ibsta), min(ie,meg)
                      do ib2 = ibsta,min(ibend,ib1)
                         Do ispinor=1, ndim_spinor
                            w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1) &
	&                   =  w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1) &
        &                     - 2.d0 *zah_l_noncl(1,ib1,2,ispinor) &
	&                            *zat_l_noncl(1,ib2,2,ispinor) &
        &                     -       zah_l_noncl(1,ib1,1,ispinor) &
	&                            *zat_l_noncl(1,ib2,1,ispinor)
                         End do
                      end do
                   end do
                end if

                do ib1 = max(is,ibsta), min(ie,meg)
                   do ib2 = ibsta,min(ibend,ib1)
                      m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                      w1hw2(m)=w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                   end do
                end do
             else
                Do ispinor=1, ndim_spinor
                  call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), 1.d0, &
	&                     zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
        &                     zah_l_noncl(1,is,1,ispinor),    np_g1k_x, &
	&                     1.d0, w1hw2r, ibsize2 )
                  call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), 1.d0, &
	&                     zat_l_noncl(1,ibsta,2,ispinor), np_g1k_x, &
        &                     zah_l_noncl(1,is,2,ispinor),    np_g1k_x, &
	&                     1.d0, w1hw2r, ibsize2 )
                  call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), 1.d0, &
	&                     zat_l_noncl(1,ibsta,2,ispinor), np_g1k_x, &
        &                     zah_l_noncl(1,is,1,ispinor),    np_g1k_x, &
	&                     1.d0, w1hw2i, ibsize2 )
                  call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), -1.d0, &
	&                     zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
        &                     zah_l_noncl(1,is,2,ispinor),    np_g1k_x, &
	&                     1.d0, w1hw2i, ibsize2 )
                End do

                do ib1 = max(is,ibsta), min(ie,meg)
                   do ib2 = ibsta,min(ibend,ib1)
                      m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                      w1hw2(2*m-1) = w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                      w1hw2(2*m  ) = w1hw2i(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                   end do
                end do
             end if
          end if
       enddo

       if (kimg==2 .and. k_symmetry(ik) /= GAMMA) deallocate(w1hw2i)
       deallocate(w1hw2r)

#else
! parallel loop
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(ib2,ii,dr1,dr2,di1,di2,m)
!CDIR CONCUR(BY=1)
#endif
! --> T. Yamasaki 28th Aug. 2009
!   ib1to --> ib1,  instead of ib1to = neordr(ib1,ik) 
!   ib2to --> ib2
       do ib1 = is, ie
          if(ib1>meg) cycle
          do ib2 = 1, ib1
             m = ib1*(ib1-1)/2-is*(is-1)/2+ib2

             if (kimg == 1) then
	        Do ispinor=1, ndim_spinor
                  do ii = 1, np_g1k(ik)              ! MPI
                     dr1 = zah_l_noncl( ii, ib1, 1, ispinor )
                     dr2 = zat_l_noncl( ii, ib2, 1, ispinor )
                     w1hw2(m) = w1hw2(m) + dr1*dr2
                  end do
                End do
             else
                if (k_symmetry(ik) == GAMMA) then
                   dd = 0.d0
                   ig1 = 1
	           if(myrank_e == 0) ig1 = 2

                   Do ispinor=1, ndim_spinor
                     do ii = ig1, np_g1k(ik)            ! MPI
                        dr1 = zah_l_noncl( ii, ib1, 1, ispinor )
                        di1 = zah_l_noncl( ii, ib1, 2, ispinor )
                        dr2 = zat_l_noncl( ii, ib2, 1, ispinor )
                        di2 = zat_l_noncl( ii, ib2, 2, ispinor )
                        dd = dd + ( dr1*dr2 +di1*di2 )*2.d0
                     end do
                   End do

                   if ( myrank_e == 0 ) then
	              Do ispinor=1, ndim_spinor
                         dd = dd + zah_l_noncl(1,ib1,1,ispinor) &
	&                         *zat_l_noncl(1,ib2,1,ispinor)
                      End do
                   endif
                   w1hw2(m)=dd
                else
	           Do ispinor=1, ndim_spinor
                     do ii = 1, np_g1k(ik)             ! MPI
                        dr1 = zah_l_noncl( ii, ib1, 1, ispinor )
                        di1 = zah_l_noncl( ii, ib1, 2, ispinor )
                        dr2 = zat_l_noncl( ii, ib2, 1, ispinor )
                        di2 = zat_l_noncl( ii, ib2, 2, ispinor )
                        w1hw2(2*m-1)=w1hw2(2*m-1) +dr1*dr2 +di1*di2
                        w1hw2(2*m  )=w1hw2(2*m  ) +dr1*di2 -di1*dr2
                     end do
                   End do
                end if
             end if
          end do
       end do
#endif

       if (iprisubmat >= 2) call wd_w1hw2(" -- just after making w1hw2 --")

!! (off-diagonal matrix elements will be damped.)
       if (kimg_t == 1) then
          do ib1=max(2,is),ie
             do ib2=1,ib1-1
                m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                sum_sq_non_diagonal = sum_sq_non_diagonal + w1hw2(m)*w1hw2(m)
                sum_abs_non_diagonal = sum_abs_non_diagonal + abs(w1hw2(m))
                w1hw2(m) = damp*w1hw2(m)
             enddo
          enddo
          do ib = is, ie
             m = ib*(ib-1)/2-is*(is-1)/2+ib
             sum_sq_diagonal = sum_sq_diagonal + w1hw2(m)**2
             sum_abs_diagonal = sum_abs_diagonal + abs(w1hw2(m))
             ekod = ekod + w1hw2(m)
          end do
       else
          do ib1=max(2,is),ie
             do ib2=1,ib1-1
                m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                dd = w1hw2(2*m-1)*w1hw2(2*m-1) + w1hw2(2*m)*w1hw2(2*m)
                sum_sq_non_diagonal = sum_sq_non_diagonal + dd
                if(dd >= SmallestPositiveNumber) sum_abs_non_diagonal = sum_abs_non_diagonal + sqrt(dd)
                w1hw2(2*m-1) = damp*w1hw2(2*m-1)
                w1hw2(2*m  ) = damp*w1hw2(2*m  )

             enddo
          enddo
          do ib = is, ie
             m = ib*(ib-1)/2-is*(is-1)/2+ib
             sum_sq_diagonal = sum_sq_diagonal + w1hw2(2*m-1)**2
             sum_abs_diagonal = sum_abs_diagonal + abs(w1hw2(2*m-1))
             ekod = ekod + w1hw2(2*m-1)
          end do
       endif
       if(iprisubmat >= 2) call wd_w1hw2(" -- after damping --")

#ifdef _USE_SCALAPACK_
       if (sw_scalapack==ON) then
          call set_amat(lda,kimg_t,occ,amat,meg,nprow,npcol,block_size,usermap,is,ie,w1hw2)
       else
#endif
          call set_hmat(kimg_t,meg,is,ie,w1hw2,zmat)
#ifdef _USE_SCALAPACK_
       end if
#endif
       deallocate(w1hw2)
    end do PART1

    call tstatc0_end(id_sname2)

    deallocate(zah_l_noncl)

    sum_abs_diagonal = sum_abs_diagonal/meg
    sum_abs_non_diagonal = sum_abs_non_diagonal/(meg*(meg-1)/2)

    if(iprisubmat >= 2) then
       write(nfout,*) 'neordr for ik = ',ik
       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'nrvf_ordr for ik = ',ik
       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'eig'
! ===================== ktDEBUG
!       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,neg)
       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,np_e)
! =====================
    endif
9002 format(5x,10i8)


! ==============================================================

!! (Diagonalization )  !!
#ifdef _USE_SCALAPACK_
     if(sw_scalapack == ON) then
        if(kimg_t == 1) then
!          call pdsyev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork,liwork)
           call pdsyev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork1,liwork1)
        else
!          call pzheev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork,lrwork,liwork)
           call pzheev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork2,lrwork2,liwork2)
        endif
     else
#endif
        if(kimg_t == 1) then
           call dsyev_driver(meg,eig,zmat)
        else
           call zheev_driver(meg,eig,zmat)
        endif
#ifdef _USE_SCALAPACK_
     endif
#endif
!!$     if(kimg_t == 1) then
!!$       call dsyev_driver(meg,eig,zmat)
!!$     else
!!$       call zheev_driver(meg,eig,zmat)
!!$     endif
!!$#endif

     if(iprisubmat >= 2) then
        write(nfout,*) 'eko_d for ik = ',ik
        write(nfout,9001) (eko_d(ib),ib=1,meg)
        write(nfout,*) 'eig for ik = ',ik
        write(nfout,9001) (eig(ib),ib=1,meg)
        !!$call wd_w1hw2(" -- after diagonalization --")
        !!$call wd_zmat(" -- after diagonalization --")
!sum eko
     end if

     call get_ipri0(iprisubmat,ipri0)
     if(ipri0>=2) then
        dr1=0.d0;dr2=0.d0
        do ib1=1,meg
           ib1to = neordr(ib1,ik)
           if(map_e(ib1to) == myrank_e) dr1=dr1+eko_l(map_z(ib1to),ik)
           dr2=dr2+eig(ib1)
        enddo
        call mpi_allreduce(MPI_IN_PLACE, dr1,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
     end if

     if(iprisubmat>=2) then
        write(nfout,*) ' sum of eko_l & eig =',dr1,dr2
        write(nfout,'(" sum_sq_diagonal , sum_sq_non_diagonal  = ",2d20.12)') sum_sq_diagonal, sum_sq_non_diagonal
        write(nfout,'(" sum_abs_diagonal ,sum_abs_non_diagonal = ",2d20.12)') sum_abs_diagonal, sum_abs_non_diagonal
     end if

! ------

!! (subspace rotation) !!
     allocate( zat_wk_noncl( np_g1k_x, meg, kimg, ndim_spinor ))
     zat_wk_noncl = 0.d0
! <-- T.Kokubo & D.Fukata, Feb. 2010
        PART2: do jp = 1,npart2
           is = isp2(jp)
           ie = iep2(jp)
           nblk1 = ie-is+1
#ifdef SX
           ibsize2 = meg
#else
           ibsize2 = ibsize
#endif
#ifdef _USE_SCALAPACK_
     if (sw_scalapack == ON) then
           allocate(zz(meg*kimg_t,nblk1))
           call put_zmat(kimg_t,lda,occ,zmat,meg,nprow,npcol,block_size,usermap,is,ie,zz)

           if ( kimg == 1) then
              call subspace_rotation_real_noncl( is, ie, zat_wk_noncl, zz, &
	&                                        nblk1, ibsize2 )
           else
              call subspace_rotation_imag_noncl( is, ie, zat_wk_noncl, zz, &
	&                                        nblk1, ibsize2 )
           endif
           deallocate(zz)
     else
#endif
           if (kimg == 1) then
              call subspace_rotation_real_noncl( is, ie, zat_wk_noncl, zmat(1,is),&
	&                                        nblk1, ibsize2 )
           else
              call subspace_rotation_imag_noncl( is, ie, zat_wk_noncl, zmat(1,is),&
	&                                        nblk1, ibsize2 )
           endif
#ifdef _USE_SCALAPACK_
     end if
#endif
        end do PART2
!
!#ifdef _USE_SCALAPACK_
!     if(sw_scalapack == ON) then
!        PART2: do jp = 1,npart2
!           is = isp2(jp)
!           ie = iep2(jp)
!           allocate(zz(meg*kimg_t,is:ie))
!           call put_zmat(lda,occ,zmat,meg,nprow,npcol,block_size,usermap,is,ie,zz)
!           if(kimg == 1) then
!              call subspace_rotation_real(is,ie,zat_wk,zz)
!           else
!              call subspace_rotation_imag(is,ie,zat_wk,zz)
!           endif
!           deallocate(zz)
!        end do PART2
!     else
!#endif
!        is=1; ie=meg
!        if(kimg == 1) then
!           call subspace_rotation_real(is,ie,zat_wk,zmat)
!        else
!           call subspace_rotation_imag(is,ie,zat_wk,zmat)
!        endif
!#ifdef _USE_SCALAPACK_
!     end if
!#endif
! -->

     Do ispinor=1, ndim_spinor
       zat_l_noncl(1:np_g1k(ik),1:meg,1:kimg,ispinor) &
	&  = zat_wk_noncl(1:np_g1k(ik),1:meg,1:kimg,ispinor)
     End do
     deallocate(zat_wk_noncl)

!! (zaj_l) by tenchi

     Do ispinor=1, ndim_spinor
       call m_ES_W_transpose_back_r(.false., ista_k, iend_k, ik+ispinor-1, &
	&                          zaj_l, zat_l_noncl(:,:,:,ispinor) )
                                                     ! zat_l -> zaj_l
     End do 


     if (meg < neg) then
        Do ispinor=1, ndim_spinor
           call m_ES_W_transpose_back2( ista_k, iend_k, ik +ispinor -1, &
	&                               meg, neordr, zaj_l, &
	&                               zat_l_noncl(:,:,:,ispinor)  )  ! zat_l -> zaj_l
        End do
     end if

#ifdef SAVE_FFT_TIMES
     if(sw_save_fft == ON) then
        Do ispinor=1, ndim_spinor
           do ib = 1, np_e
              status_saved_phifftr(ib,ik+ispinor-1) = OLD
           end do
        end Do
     end if
#endif

!! (eko_l)
     if(meg < neg) then
        do ib1=meg+1,neg
           if(map_e(ib1) == myrank_e) then        ! MPI
              eko_l(map_z(ib1),ik)=eko_d(neordr(ib1,ik))
           end if
        enddo
     endif
     do ib1 = 1, meg
        if(map_e(ib1) == myrank_e) then         ! MPI
           eko_l(map_z(ib1),ik)=eig(ib1)
        end if
     end do
     if(iprisubmat >= 2) then
        eko2 = sum(eig(1:meg))
        write(nfout,1201) ik,eko1,ekod,eko2

        write(nfout,*) 'eko_l'
        write(nfout,9001) (eko_l(ib1,ik),ib1=1,meg)
     endif
1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!! (neordr & nrvf_ordr)

     neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
     nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)

! (deallocate)  
    deallocate(eko_d)
    deallocate(eig)
    deallocate(zat_l_noncl)

    !!$deallocate(zah_l)
    if (sw_scalapack==ON) deallocate(amat)
    deallocate(zmat)

! === DEBUG by tkato 2012/12/11 ================================================
    call mpi_allreduce(MPI_IN_PLACE,sum_abs_non_diagonal,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
    call mpi_allreduce(MPI_IN_PLACE,sum_abs_diagonal,    1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
! ==============================================================================

    if(.not.non_diagonal_part_is_small(ik)  &
         & .and. sum_abs_non_diagonal/sum_abs_diagonal <= submat_critical_ratio) &
         & non_diagonal_part_is_small(ik) = .true.

    if(iprisubmat >= 2) write(nfout,'(" !submat  non_diagonal/diagonal = ",d20.8)') &
         & sum_abs_non_diagonal/sum_abs_diagonal

    call tstatc0_end(id_sname)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(nrank_e>1) then
         if(myrank_e == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_w1hw2(somecomment)
      character(len=*), intent(in) :: somecomment
      integer :: ib1, ib2, neg_wd1, neg_wd2
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      neg_wd1 = 8
      neg_wd2 = 8
      if(neg_wd1 > ie) neg_wd1 = ie
      if(neg_wd2 > meg) neg_wd2 = meg
      write(nfout,'(" real part (",i8,":",i8,",1:",i8,")")') is,neg_wd1,neg_wd2
      if(kimg_t == 1) then
         do ib1=is,neg_wd1
            write(nfout,9001) (w1hw2(ib1*(ib1-1)/2-is*(is-1)/2+ib2),ib2=1,neg_wd2)
         enddo
         write(nfout,'(" real part (",i8,":",i8,",1:",i8,")")') ie-neg_wd1+1,ie, neg_wd2
         do ib1=ie-neg_wd1+1, ie
            write(nfout,9001) (w1hw2(ib1*(ib1-1)/2-is*(is-1)/2+ib2),ib2=1,neg_wd2)
         enddo
      else
         do ib1=is,neg_wd1
            write(nfout,9001) (w1hw2(2*(ib1*(ib1-1)/2-is*(is-1)/2+ib2)-1),ib2=1,neg_wd2)
         enddo
         write(nfout,'(" real part (",i8,":",i8,",1:",i8,")")') ie-neg_wd1+1,ie, neg_wd2
         do ib1=ie-neg_wd1+1, ie
            write(nfout,9001) (w1hw2(2*(ib1*(ib1-1)/2-is*(is-1)/2+ib2)-1),ib2=1,neg_wd2)
         enddo
         write(nfout,'(" imag part")')
         do ib1=is,neg_wd1
            write(nfout,9001) (w1hw2(2*(ib1*(ib1-1)/2-is*(is-1)/2+ib2)),ib2=1,neg_wd2)
         enddo
      end if
9001  format(1x,8e14.6)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_d(neordr(ib1,ik)),ib1=1,neg_wd2)
    end subroutine wd_w1hw2


    subroutine subspace_rotation_real_noncl( is, ie, zat_wk_noncl, zz, ibsize1, ibsize2 )

      integer, intent(in) :: is,ie, ibsize1,ibsize2
      real(kind=DP), intent(inout) :: zat_wk_noncl( np_g1k_x, meg, kimg, ndim_spinor )
      real(kind=DP), intent(in) :: zz(meg,ibsize1)
      integer :: ibsta, ibend
#ifdef SUBMAT_DGEMM
      integer :: nblk2
      real(kind=DP) :: alpha, beta
#endif
      integer :: id_sname = -1

      call tstatc0_begin('subspace_roation_real_noncl ', id_sname)

#ifdef SUBMAT_DGEMM
      alpha=1.d0; beta=1.d0
      do ibsta=1,meg, ibsize2
         ibend=min(ibsta+ibsize2-1,meg)
         nblk2=ibend-ibsta+1

         Do ispinor=1, ndim_spinor 
            call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&               zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
	&               zz(ibsta,1), meg, beta, &
	&               zat_wk_noncl(1,is,1,ispinor), np_g1k_x )
         End do
      enddo
#else
      do ibsta=1,meg, ibsize2
         ibend=min(ibsta+ibsize2-1,meg)
         do ib2=is,ie
            do ib1=ibsta,ibend
               Do ispinor=1, ndim_spinor
                 do ii=1,np_g1k(ik)
                    zat_wk_noncl( ii, ib2, 1, ispinor ) &
	&              = zat_wk_noncl( ii, ib2, 1, ispinor ) &
	&               + zz( ib1, ib2-is+1 ) *zat_l_noncl( ii, ib1, 1, ispinor )
                 enddo
               End do
            enddo
         enddo
      enddo
#endif
      call tstatc0_end(id_sname)
    end subroutine subspace_rotation_real_noncl

    subroutine subspace_rotation_imag_noncl( is, ie, zat_wk_noncl, zz, ibsize1, ibsize2 )
      integer, intent(in) :: is,ie, ibsize1,ibsize2
      real(kind=DP), intent(inout) :: zat_wk_noncl( np_g1k_x, meg, kimg, ndim_spinor )
      real(kind=DP), intent(in) :: zz(meg*kimg_t,ibsize1)
      integer :: id_sname = -1
      integer :: ibsta, ibend

      integer :: ispinor

#ifdef SUBMAT_DGEMM
      real(kind=DP) :: alpha, beta
      integer :: nblk2
      real(kind=DP), allocatable, dimension(:,:) :: zzr,zzi
#endif

      call tstatc0_begin('subspace_roation_imag_noncl ', id_sname)

!      stop

      if (k_symmetry(ik) == GAMMA) then
#ifdef SUBMAT_DGEMM
         alpha = 1.d0; beta = 1.d0
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            nblk2=ibend-ibsta+1

            Do ispinor=1, ndim_spinor
              call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&                  zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
	&                  zz(ibsta,1), meg, beta, &
        &                  zat_wk_noncl(1,is,1,ispinor), np_g1k_x )
              call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&                  zat_l_noncl(1,ibsta,2,ispinor), np_g1k_x, &
	&                  zz(ibsta,1), meg, beta, &
        &                  zat_wk_noncl(1,is,2,ispinor), np_g1k_x )
            End do
         enddo
         !!if(iprisubmat>=2) write(nfout,'(" !!<<subspace_rotation_imag>> ibsize = ",i8)') ibsize
#else
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            do ib2=is,ie
!CDIR OUTERUNROLL=4
               do ib1=ibsta,ibend
                  dr1=zz(ib1,ib2-is+1)
	          Do ispinor=1, ndim_spinor
                     do ii=1,np_g1k(ik)
                       zat_wk_noncl( ii, ib2, 1, ispinor ) &
	&               = zat_wk_noncl( ii, ib2, 1, ispinor ) &
	&                + dr1 *zat_l_noncl(ii, ib1, 1, ispinor )
                       zat_wk_noncl( ii, ib2, 2, ispinor ) &
	&               = zat_wk_noncl( ii, ib2, 2, ispinor )&
	&                + dr1 *zat_l_noncl( ii, ib1, 2, ispinor )
                     enddo
                   ENd do
               enddo! ib1 loop
            enddo! ib2 loop
         enddo
#endif
         if ( iprisubmat >= 2) then
            do ib2 = is, ie
	       Do ispinor=1, ndim_spinor
	          write(nfout,*) '*** ispinor = ', ispinor
                  write(nfout,'(" --- zat_l_noncl (input, output) ---, ib =",i5)') ib2
                  write(nfout,'(" zat_l_noncl(input ) Re : ",5e14.6)') &
	&                  ( zat_l_noncl(ii,ib2,1,ispinor),ii=1,5 )
                  write(nfout,'(" zat_l_noncl(input ) Im : ",5e14.6)') &
	&                  ( zat_l_noncl(ii,ib2,2,ispinor),ii=1,5 )
                 write(nfout,'(" zat_l_noncl(output) Re : ",5e14.6)') &
	&                  ( zat_wk_noncl(ii,ib2,1,ispinor),ii=1,5)
                 write(nfout,'(" zat_l_noncl(output) Im : ",5e14.6)') &
	&                  ( zat_wk_noncl(ii,ib2,2,ispinor),ii=1,5)
	       End do
            end do
         end if
      else
#ifdef SUBMAT_DGEMM

         allocate(zzr(ibsize2,ibsize1)); allocate(zzi(ibsize2,ibsize1))
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            nblk2=ibend-ibsta+1
            do ib2=is,ie
               do ib1=ibsta, ibend
                  zzr(ib1-ibsta+1,ib2-is+1)=zz(2*ib1-1,ib2-is+1)
                  zzi(ib1-ibsta+1,ib2-is+1)=zz(2*ib1  ,ib2-is+1)
               end do
            end do

	    Do ispinor=1, ndim_spinor
              alpha=1.d0; beta=1.d0
              call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&                 zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
	&                 zzr, ibsize2, beta, &
	&                 zat_wk_noncl(1,is,1,ispinor), np_g1k_x )

              alpha=-1.d0; beta=1.d0
              call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&                  zat_l_noncl(1,ibsta,2,ispinor), np_g1k_x, &
	&                  zzi, ibsize2, beta, &
	&                  zat_wk_noncl(1,is,1,ispinor), np_g1k_x )

              alpha=1.d0; beta=1.d0
              call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&                 zat_l_noncl(1,ibsta,2,ispinor), np_g1k_x, &
	&                 zzr, ibsize2, beta, &
	&                 zat_wk_noncl(1,is,2,ispinor), np_g1k_x )

              alpha=1.d0; beta=1.d0
              call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&                 zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
	&                 zzi, ibsize2, beta, &
	&                 zat_wk_noncl(1,is,2,ispinor), np_g1k_x )
            End do
         enddo
         deallocate(zzi,zzr)
#else
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            do ib2=is,ie
!CDIR OUTERUNROLL=4
               do ib1=ibsta,ibend
                  dr1=zz(2*ib1-1,ib2-is+1)
                  di1=zz(2*ib1  ,ib2-is+1)

	          Do ispinor=1, ndim_spinor
                    do ii=1,np_g1k(ik)
                       dr2 = zat_l_noncl( ii, ib1, 1, ispinor )
                       di2 = zat_l_noncl( ii, ib1, 2, ispinor )
                       zat_wk_noncl( ii, ib2, 1, ispinor ) &
	&                = zat_wk_noncl( ii, ib2, 1, ispinor ) +dr1*dr2 -di1*di2
                       zat_wk_noncl( ii, ib2, 2, ispinor ) &
	&                = zat_wk_noncl( ii, ib2, 2, ispinor ) +dr1*di2 +di1*dr2
                    enddo
                  End do 
               enddo! ib1 loop
            enddo! ib2 loop
         enddo
#endif
       end if
       call tstatc0_end(id_sname)
    end subroutine subspace_rotation_imag_noncl

#ifdef _USE_SCALAPACK_
#endif
! _USE_SCALAPACK_

  end subroutine evolve_WFs_in_subspace_noncl
! ==================================================================== 11.0



!!$#endif

!! ++++++++++++++++++++ global(=not contained) subroutines in this module +++++++++++++++
#ifndef _USE_DSYEVD_
  subroutine dsyev_driver(ndim,eig,w1hw2)
    integer, intent(in):: ndim
    real(kind=DP), intent(out) ,dimension(ndim) :: eig
    real(kind=DP), intent(inout) ,dimension(ndim,ndim) :: w1hw2

    integer, parameter :: PRINTLEVEL = 2
    character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
    integer :: lda
!!$    integer :: lwork,lwork_min
    integer, save :: lwork=0
    integer       :: lwork_min
    integer,parameter :: nb = 64
    integer, parameter :: lwork_huge=10**8
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    integer :: info

    integer :: id_sname = -1
    call tstatc0_begin('dsyev_driver ', id_sname)

    lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
! (define lwork)
!!$    lwork = 0
!!$    lwork_min=max(1,3*ndim-1)
    lwork_min=max(1,(nb+2)*ndim)
    if(lwork == 0) then
       lwork = -1
       allocate(work_lapack(1))
       call dsyev(JOBZ,UPLO,ndim,w1hw2,lda,eig,work_lapack,lwork,info)
       lwork = int(work_lapack(1))+1
       if(iprisubmat >= PRINTLEVEL) then
          write(nfout,'(" lwork = ",i8)') lwork
       end if
       deallocate(work_lapack)
    end if
    if(lwork < lwork_min) lwork=lwork_min
    if(lwork > lwork_huge) lwork=lwork_min
    allocate(work_lapack(lwork))
    if(iprisubmat >= PRINTLEVEL .and. lwork == lwork_min) then
       write(nfout,'(" lwork = ",i8)') lwork
       write(nfout,'(" lda, ndim = ",2i8)') lda, ndim
    end if

    call dsyev(JOBZ,UPLO,ndim,w1hw2,lda,eig,work_lapack,lwork,info)
!!$    write(*,*) 'lwork& info & suggested lwork = ',lwork,info,work_lapack(1)
    if(iprisubmat >= 2) then
       write(nfout,'(" info = ",i8)') info
    end if
!!$    lwork= int(work_lapack(1))+1
    deallocate(work_lapack)

    call tstatc0_end(id_sname)
  end subroutine dsyev_driver
#else
  subroutine dsyev_driver(ndim,eig,w1hw2)
    integer, intent(in):: ndim
    real(kind=DP), intent(out) ,dimension(ndim) :: eig
    real(kind=DP), intent(inout) ,dimension(ndim,ndim) :: w1hw2

    character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
    integer :: lda
    integer :: lwork,liwork
    complex(kind=CMPLDP),allocatable,dimension(:) :: work
    real(kind=DP),allocatable,dimension(:) :: iwork
    integer :: info

    integer :: id_sname = -1
    call tstatc0_begin('dsyev_driver ', id_sname)

    lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
! (define lwork)

    lwork  = 1 + ndim*(6+2*ndim)
    liwork = 3 + 5*ndim

    allocate(work(lwork)); work = 0.d0
    allocate(iwork(liwork)); iwork = 0.d0

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("DSYEVD")
#endif
    call dsyevd(JOBZ,UPLO,ndim,w1hw2,lda,eig,work,lwork,iwork,liwork,info)
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("DSYEVD")
#endif

    deallocate(work)
    deallocate(iwork)

    call tstatc0_end(id_sname)
  end subroutine dsyev_driver
#endif

#ifndef _USE_ZHEEVD_
  subroutine zheev_driver(ndim,eig,w1hw2)
   integer, intent(in):: ndim
   real(kind=DP), intent(out) ,dimension(ndim) :: eig
   real(kind=DP), intent(inout) ,dimension(ndim*2,ndim) :: w1hw2
   character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
   integer :: lda
   integer :: i,j
! --> T. Yamasaki 2009/07/24 revised according to a Dr. Katagiri's report
!!$   integer :: lwork,lwork_min,rwork_size
   integer :: lwork_min,rwork_size
   integer, save :: lwork = 0
! <--
   integer, parameter :: lwork_huge=10**8
   real(kind=DP),allocatable,dimension(:) :: work_lapack
   real(kind=DP),allocatable,dimension(:) :: rwork_lapack
   integer :: info

   integer :: id_sname = -1
   call tstatc0_begin('zheev_driver ', id_sname)

      lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
     JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
     UPLO = 'U'
      lwork_min=max(1,2*ndim-1)
      rwork_size=max(3*ndim-2,1)
     if(lwork < lwork_min)  lwork=lwork_min
     if(lwork > lwork_huge) lwork=lwork_min

     allocate(work_lapack(lwork*2))
     allocate(rwork_lapack(rwork_size))

     call zheev(JOBZ,UPLO,ndim,w1hw2,lda,eig,work_lapack,lwork,rwork_lapack,info)
!!$     write(*,*) 'lwork& info & suggested lwork = ',lwork,info,work_lapack(1)
     lwork= int(work_lapack(1))+1

     deallocate(work_lapack)
     deallocate(rwork_lapack)

     call tstatc0_end(id_sname)
   end subroutine zheev_driver
#else
  subroutine zheev_driver(ndim,eig,w1hw2)
   integer, intent(in):: ndim
   real(kind=DP), intent(out) ,dimension(ndim) :: eig
   real(kind=DP), intent(inout) ,dimension(ndim*2,ndim) :: w1hw2
   character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
   integer :: lda
   integer :: lwork,lrwork,liwork
   complex(kind=CMPLDP),allocatable,dimension(:) :: work
   real(kind=DP),allocatable,dimension(:) :: rwork
   real(kind=DP),allocatable,dimension(:) :: iwork
   integer :: info

   integer :: id_sname = -1
   call tstatc0_begin('zheev_driver ', id_sname)

      lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
     JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
     UPLO = 'U'
      lwork=ndim*(2+ndim)
      lrwork=1+ndim*(5+2*ndim)
      liwork=3+5*ndim

     allocate(work(lwork))
     allocate(rwork(lrwork))
     allocate(iwork(liwork))

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("ZHEEVD")
#endif
     call zheevd(JOBZ,UPLO,ndim,w1hw2,lda,eig,work,lwork,rwork,lrwork,iwork,liwork,info)
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("ZHEEVD")
#endif

     deallocate(work)
     deallocate(rwork)
     deallocate(iwork)

     call tstatc0_end(id_sname)
   end subroutine zheev_driver
#endif
! _NO_USE_ZHEEVD_


#ifndef _USE_ZHEGVXD_
  subroutine zhegvx_driver(ndim,eig,w1hw2,w1sw2)
   integer, intent(in):: ndim
   real(kind=DP), intent(out) ,dimension(ndim) :: eig
   real(kind=DP), intent(inout) ,dimension(ndim*2,ndim) :: w1hw2,w1sw2
   character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
   integer :: lda
! --> T. Yamasaki 2009/07/24 revised according to a Dr. Katagiri's report
!!$   integer :: lwork,lwork_min,rwork_size
   integer :: lwork_min,rwork_size
   integer, save :: lwork = 0
! <--
   integer, parameter :: lwork_huge=10**8
   real(kind=DP),allocatable,dimension(:) :: work_lapack
   real(kind=DP),allocatable,dimension(:) :: rwork_lapack
   integer :: info

   real(kind=DP),allocatable,dimension(:,:) :: z
   integer,allocatable,dimension(:) :: ifail
   integer,allocatable,dimension(:) :: iwork
   integer :: ITYPE,ldb,IL,IU,ldz
   integer :: i,j
   integer :: meig
   real(kind=DP) :: VL,VU,ABSTOL
   character(len=1) :: RANGE

   integer :: id_sname = -1
   call tstatc0_begin('zhegvx_driver ', id_sname)

!write(90,*) 'fail ::    zhegvx_driver'

      ITYPE=1
      RANGE='A'
      ABSTOL=-1.d0

      lda=ndim
      ldb=ndim
      ldz=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
     JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
     UPLO = 'U'

      lwork=ndim*(2+ndim)
      lwork_min=max(1,2*ndim-1)
     if(lwork < lwork_min)  lwork=lwork_min
     if(lwork > lwork_huge) lwork=lwork_min

      rwork_size=7*ndim !max(3*ndim-2,1)

     allocate(work_lapack(lwork*2))
     allocate(rwork_lapack(rwork_size))

     allocate(z(ldz*2,ndim))
     allocate(ifail(ndim))
     allocate(iwork(5*ndim))

     call zhegvx(ITYPE,JOBZ,RANGE,UPLO,ndim,w1hw2,lda,w1sw2,ldb,VL,VU,IL,IU,ABSTOL &
                ,meig,eig,z,ldz,work_lapack,lwork,rwork_lapack,iwork,ifail,info)
     w1hw2=z
     lwork= int(work_lapack(1))+1

     deallocate(work_lapack)
     deallocate(rwork_lapack)

     deallocate(z)
     deallocate(ifail)
     deallocate(iwork)

     call tstatc0_end(id_sname)
   end subroutine zhegvx_driver
#else
  subroutine zhegvx_driver(ndim,eig,w1hw2,w1sw2)
   integer, intent(in):: ndim
   real(kind=DP), intent(out) ,dimension(ndim) :: eig
   real(kind=DP), intent(inout) ,dimension(ndim*2,ndim) :: w1hw2,w1sw2
   character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
   integer :: lda
   integer :: lwork,lrwork,liwork
   complex(kind=CMPLDP),allocatable,dimension(:) :: work
   real(kind=DP),allocatable,dimension(:) :: rwork
   real(kind=DP),allocatable,dimension(:) :: iwork
   integer :: info
   integer :: meig

   complex(kind=CMPLDP),allocatable,dimension(:,:) :: z
   integer,allocatable,dimension(:) :: ifail
   integer :: ITYPE,ldb,IL,IU,ldz
   real(kind=DP) :: VL,VU,ABSTOL
   character(len=1) :: RANGE

   integer :: id_sname = -1
   call tstatc0_begin('zhegvx_driver ', id_sname)

!write(90,*) 'zhegvx_driver'

      ITYPE=1
      RANGE='A'
      ABSTOL=-1.d0

      lda=ndim
      ldb=ndim
      ldz=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
     JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
     UPLO = 'U'
      lwork=ndim*(2+ndim)
      lrwork=1+ndim*(5+2*ndim)
      liwork=5*ndim !3+5*ndim

     allocate(work(lwork))
     allocate(rwork(lrwork))
     allocate(iwork(liwork))

     allocate(z(ldz,ndim))
     allocate(ifail(ndim))

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("ZHEGVXD")
#endif
!     call zheevd(JOBZ,UPLO,ndim,w1hw2,lda,eig,work,lwork,rwork,lrwork,iwork,liwork,info)
     call zhegvx(ITYPE,JOBZ,RANGE,UPLO,ndim,w1hw2,lda,w1sw2,ldb,VL,VU,IL,IU,ABSTOL &
                ,meig,eig,z,ldz,work,lwork,rwork,iwork,ifail,info)
     w1hw2=z
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("ZHEGVXD")
#endif

     deallocate(work)
     deallocate(rwork)
     deallocate(iwork)

     deallocate(z)
     deallocate(ifail)

     call tstatc0_end(id_sname)
   end subroutine zhegvx_driver
#endif


! <-- T.Kokubo & D.Fukata, Feb. 2010
  subroutine set_hmat(kimg_t,meg,is,ie,w1hw2,zmat)
    integer, intent(in) :: kimg_t,meg,is,ie
    real(kind=DP), intent(inout) :: w1hw2(*)
    real(kind=DP), intent(out) :: zmat(meg*kimg_t,meg)
    integer, parameter         :: msize_allreduce_max = 1000000

    real(kind=DP), allocatable :: w1hw2_mpi(:), w1hw2_mpi2(:)
    integer :: i,j, msize_partitioned
    integer :: m,msize
    integer :: id_sname = -1
    call tstatc0_begin('set_hmat ', id_sname)

    msize = is*(ie-is+1) + (ie-is+1)*(ie-is)/2

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("SET_HMAT")
#endif
!! (spread sum of w1hw2)
    if(npes > 1) then
       allocate(w1hw2_mpi(msize*kimg_t))
       if(msize*kimg_t <= msize_allreduce_max) then
          if(iprisubmat >= 2) write(nfout,'(" msize*kimg_t = ",i12,",  msize_allreduce_max = ",i12," <<set_hmat>>")') &
         & msize*kimg_t, msize_allreduce_max
          call mpi_allreduce(w1hw2,w1hw2_mpi,msize*kimg_t,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
          w1hw2(1:msize*kimg_t) = w1hw2_mpi         ! MPI
       else
          if(iprisubmat >= 2)  &
               & write(nfout,'(" msize*kimg_t = ",i12," > msize_allreduce_max = ",i12," <<set_hmat>>")') &
               & msize*kimg_t, msize_allreduce_max
          allocate(w1hw2_mpi2(msize_allreduce_max))
          do j = 1, ceiling(dble(msize*kimg_t)/msize_allreduce_max)
             msize_partitioned = min(msize_allreduce_max, msize*kimg_t-(j-1)*msize_allreduce_max)
             do m = 1, msize_partitioned
                i = m + (j-1)*msize_allreduce_max
                w1hw2_mpi2(m) = w1hw2(i)
             end do
             call mpi_allreduce(MPI_IN_PLACE,w1hw2_mpi2,msize_partitioned,mpi_double_precision &
                  &                             ,mpi_sum,mpi_k_world(myrank_k),ierr)
             do m = 1, msize_partitioned
                i = m + (j-1)*msize_allreduce_max
                w1hw2_mpi(i) = w1hw2_mpi2(m)
             end do
          end do
          w1hw2(1:msize*kimg_t) = w1hw2_mpi
          deallocate(w1hw2_mpi2)
       end if
       deallocate(w1hw2_mpi)
    end if
    if(kimg_t==1) then
!CDIR PARALLEL DO PRIVATE (i,m)
       do j=is,ie
          do i=1,j
             m = j*(j-1)/2-is*(is-1)/2+i
             zmat(i,j) =  w1hw2(m)
          end do
       end do
    else
!CDIR PARALLEL DO PRIVATE (i,m)
       do j=is,ie
          do i=1,j
             m = j*(j-1)/2-is*(is-1)/2+i
             zmat(2*i-1,j) =  w1hw2(2*m-1)
             zmat(2*i  ,j) = -w1hw2(2*m)
          end do
       end do
    end if
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("SET_HMAT")
#endif
    call tstatc0_end(id_sname)
  end subroutine set_hmat
#ifdef _USE_SCALAPACK_
  subroutine set_nprow_npcol(nprow,npcol)
    integer, intent(inout) :: nprow,npcol
    logical :: cflag
    integer :: j,n

    cflag=.true.

    if(nprow*npcol /= nrank_e) then
       nprow=1
       npcol=1
       j = nrank_e

 120   continue
       if(mod(j,2) == 0) then
         j=j/2
         n=2
         call prod(cflag,n,nprow,npcol)
         goto 120
       else if(mod(j,3) == 0) then
         j=j/3
         n=3
         call prod(cflag,n,nprow,npcol)
         goto 120
       else if(mod(j,5) == 0) then
         j=j/5
         n=5
         call prod(cflag,n,nprow,npcol)
         goto 120
       else if(j == 1) then
         n=1
       else
         n=j
       end if
       call prod(cflag,n,nprow,npcol)
       write(*,'("set nprow,npcol=",2i5)') nprow,npcol
       if(printable) write(nfout,'("set nprow,npcol=",2i5)') nprow,npcol
    else
       if(iprisubmat >= 2) write(nfout,'("nprow,npcol=",2i5)') nprow,npcol
    end if
  end subroutine set_nprow_npcol
  subroutine prod(cflag,n,nr,nc)
    logical,intent(inout) :: cflag
    integer,intent(in)    :: n
    integer,intent(inout) :: nr,nc
    if(cflag) then
       nr = nr * n
    else
       nc = nc * n
    endif
    cflag= .not.cflag
  end subroutine prod
#endif


#ifdef _USE_SCALAPACK_
  subroutine set_amat(lda,kimg_t,occ,amat,ndim,nprow,npcol,nb,usermap,is,ie,w1hw2)
    integer, intent(in) :: lda,kimg_t,occ
    real(kind=DP), intent(out) :: amat(lda*kimg_t,occ)
    integer, intent(in) :: ndim,nprow,npcol,nb
#ifdef SINGLE_CONTEXT
    integer, intent(in) :: usermap(nprow,npcol)
#else
    integer, intent(in) :: usermap(nprow,npcol,0:nrank_k-1)
#endif
    integer, intent(in) :: is,ie
    real(kind=DP), intent(inout) :: w1hw2(*)

    integer :: i,j
    integer :: jj,ipcol,ilcol,ixcol
    integer :: ii,iprow,ilrow,ixrow
    integer :: m,msize
    real(kind=DP), allocatable :: w1hw2_mpi(:)
    integer :: id_sname = -1
    call tstatc0_begin('set_amat ', id_sname)

    msize = is*(ie-is+1) + (ie-is+1)*(ie-is)/2
#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("SET_AMAT")
#endif

!! (spread sum of w1hw2)
    if(npes > 1) then
       if(iprisubmat >= 2) write(nfout,'(" msize*kimg_t = ",i12," <<set_amat>>")') msize*kimg_t
       allocate(w1hw2_mpi(msize*kimg_t))
       call mpi_allreduce(w1hw2,w1hw2_mpi,msize*kimg_t,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
       w1hw2(1:msize*kimg_t) = w1hw2_mpi
       deallocate(w1hw2_mpi)
    end if

    if(kimg_t==1) then
       !!$!CDIR PARALLEL DO PRIVATE ( ipcol,ilcol,ixcol,jj,i,iprow,ilrow,ii,m)
       do j=is,ie
          ipcol = mod((j-1)/nb,npcol)
          ilcol = (j-1)/(npcol*nb)
          ixcol = mod(j-1,nb)+1
          jj = ilcol*nb+ixcol
          do i=1,j
             iprow = mod((i-1)/nb,nprow)
             ilrow = (i-1)/(nprow*nb)
             ixrow = mod(i-1,nb)+1
             ii = ilrow*nb+ixrow
#ifdef SINGLE_CONTEXT
             if(usermap(iprow+1,ipcol+1) /= mype) cycle
#else
             if(usermap(iprow+1,ipcol+1,myrank_k) /= mype) cycle
#endif
             m = j*(j-1)/2-is*(is-1)/2+i
             amat(ii,jj) =  w1hw2(m)
          end do
       end do
    else
       !!$!CDIR PARALLEL DO PRIVATE ( ipcol,ilcol,ixcol,jj,i,iprow,ilrow,ii,m)
       do j=is,ie
          ipcol = mod((j-1)/nb,npcol)
          ilcol = (j-1)/(npcol*nb)
          ixcol = mod(j-1,nb)+1
          jj = ilcol*nb+ixcol
          do i=1,j
             iprow = mod((i-1)/nb,nprow)
             ilrow = (i-1)/(nprow*nb)
             ixrow = mod(i-1,nb)+1
             ii = ilrow*nb+ixrow
#ifdef SINGLE_CONTEXT
             if(usermap(iprow+1,ipcol+1) /= mype) cycle
#else
             if(usermap(iprow+1,ipcol+1,myrank_k) /= mype) cycle
#endif
             m = j*(j-1)/2-is*(is-1)/2+i
             amat(2*ii-1,jj) =  w1hw2(2*m-1)
             amat(2*ii  ,jj) = -w1hw2(2*m)
          end do
       end do
    end if
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("SET_AMAT")
#endif
    call tstatc0_end(id_sname)
  end subroutine set_amat
#endif

#ifdef _USE_SCALAPACK_
  subroutine put_zmat(kimg_t,lda,occ,zmat,ndim,nprow,npcol,nb,usermap,is,ie,zz)
    integer, intent(in) :: kimg_t,lda,occ
    real(kind=DP), intent(in) :: zmat(lda*kimg_t,occ)
    integer, intent(in) :: ndim,nprow,npcol,nb
#ifdef SINGLE_CONTEXT
    integer, intent(in) :: usermap(nprow,npcol)
#else
    integer, intent(in) :: usermap(nprow,npcol,0:nrank_k-1)
#endif
    integer, intent(in) :: is,ie
    real(kind=DP), intent(out) :: zz(ndim*kimg_t,is:ie)

    integer :: i,j
    integer :: jj,ipcol,ilcol,ixcol
    integer :: ii,iprow,ilrow,ixrow
    integer :: jsize
    real(kind=DP), allocatable :: zz_mpi(:,:)
    integer :: id_sname = -1
    call tstatc0_begin('put_zmat ', id_sname)

    jsize = ie-is+1

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("PUT_ZMAT")
#endif
    zz = 0.d0
    if(kimg_t==1) then
       do j=is,ie
          ipcol = mod((j-1)/nb,npcol)
          ilcol = (j-1)/(npcol*nb)
          ixcol = mod(j-1,nb)+1
          jj = ilcol*nb+ixcol
          do i=1,ndim
             iprow = mod((i-1)/nb,nprow)
             ilrow = (i-1)/(nprow*nb)
             ixrow = mod(i-1,nb)+1
             ii = ilrow*nb+ixrow
#ifdef SINGLE_CONTEXT
             if(usermap(iprow+1,ipcol+1) /= mype) cycle
#else
             if(usermap(iprow+1,ipcol+1,myrank_k) /= mype) cycle
#endif
             zz(i,j) = zmat(ii,jj)
          end do
       end do
    else
       do j=is,ie
          ipcol = mod((j-1)/nb,npcol)
          ilcol = (j-1)/(npcol*nb)
          ixcol = mod(j-1,nb)+1
          jj = ilcol*nb+ixcol
          do i=1,ndim
             iprow = mod((i-1)/nb,nprow)
             ilrow = (i-1)/(nprow*nb)
             ixrow = mod(i-1,nb)+1
             ii = ilrow*nb+ixrow
#ifdef SINGLE_CONTEXT
             if(usermap(iprow+1,ipcol+1) /= mype) cycle
#else
             if(usermap(iprow+1,ipcol+1,myrank_k) /= mype) cycle
#endif
             zz(2*i-1,j) = zmat(2*ii-1,jj)
             zz(2*i  ,j) = zmat(2*ii  ,jj)
          end do
       end do
    end if
    if(npes > 1) then
       allocate(zz_mpi(ndim*kimg_t,is:ie))
       call mpi_allreduce(zz,zz_mpi,ndim*kimg_t*jsize,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       zz = zz_mpi         ! MPI
       deallocate(zz_mpi)
    end if
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("PUT_ZMAT")
#endif
    call tstatc0_end(id_sname)
  end subroutine put_zmat
#endif

! ------------------------------
#ifdef _USE_SCALAPACK_
  subroutine scalapack_setup(ndim,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt,myrow,mycol,desca,descz,usermap)
    integer, intent(in) :: ndim
#ifdef SINGLE_CONTEXT
    integer, intent(out) :: lwork1,lrwork1,liwork1,lda,occ,ictxt,myrow,mycol
#else
    integer, intent(out) :: lwork1,lrwork1,liwork1,lda,occ,ictxt(0:nrank_k-1),myrow,mycol
#endif
    integer, intent(out) :: lwork2,lrwork2,liwork2
    integer, dimension(9), intent(out) :: desca,descz
#ifdef SINGLE_CONTEXT
    integer, intent(inout) :: usermap(nprow,npcol)
#else
    integer, intent(inout) :: usermap(nprow,npcol,0:nrank_k-1)
#endif

    integer :: i,j
#ifndef SINGLE_CONTEXT
    integer :: ik, pid, blacs_pnum
    integer, save ::  tmpctxt
#endif
    integer :: nb
    integer :: np0,nq0,np,nq,iarow,iacol
    integer :: iroffa, icoffa, nrc, ldc 
    integer :: sizemqrleft, qrmem, trilwmin
    integer :: iam,nprocs,info
    integer, external :: indxg2l, indxg2p, numroc
    integer, parameter :: BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1, &
     &                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6, &
     &                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9
    integer :: id_sname = -1
    call tstatc0_begin('scalapack_setup ', id_sname)

    nb = block_size

    if(mod(ndim,nb)>0) then
       lda = ndim/nb +1
    else
       lda = ndim/nb
    end if
    occ = lda
    if(mod(lda,nprow)>0) then
       lda = lda/nprow+1
    else
       lda = lda/nprow
    end if
    if(mod(occ,npcol)>0) then
       occ = occ/npcol+1
    else
       occ = occ/npcol
    end if
    lda = lda*nb
    occ = occ*nb
    if(iprisubmat>=2) write(nfout,'("lda,occ=",2i5)') lda,occ

#ifdef SINGLE_CONTEXT
    do j=1,npcol
       do i=1,nprow
          usermap(i,j) = myrank_k*nrank_e + (j-1)*nprow + i - 1
       end do
    end do
    if(iprisubmat>=1) then
       write(nfout,'("USERMPAP")')
       do i=1,nprow
          write(nfout,'(1x,i3)') (usermap(i,j),j=1,npcol)
       end do
    end if
    call blacs_setup(iam,nprocs)
    call blacs_get(-1,0,ictxt)
    call blacs_gridmap(ictxt,usermap,nprow,nprow,npcol)
    call blacs_gridinfo(ictxt,nprow,npcol,myrow,mycol)
#else
    call blacs_setup(iam,nprocs)
    call blacs_get(0,0,tmpctxt)
    call blacs_gridinit(tmpctxt,'R',nprocs,1)
    do ik=0,nrank_k-1
       pid = ik*nrank_e
       do j=1,npcol
          do i=1,nprow
             usermap(i,j,ik) = blacs_pnum(tmpctxt,pid,0)
             pid = pid + 1
          end do
       end do
       call blacs_get(0,0,ictxt(ik))
       call blacs_gridmap(ictxt(ik),usermap(1,1,ik),nprow,nprow,npcol)
    end do
    call blacs_gridinfo(ictxt(myrank_k),nprow,npcol,myrow,mycol)
    if(iprisubmat>=1) then
       do ik=0,nrank_k-1
          write(nfout,'("USERMPAP: ik=",i5)') ik
          do i=1,nprow
             write(nfout,'(128(1x,i3))') (usermap(i,j,ik),j=1,npcol)
          end do
       end do
    end if
#endif
    if(myrow == -1) then
       if(printable) write(nfout,*) 'BLACS init failed.'
       stop 'BLACS init failed.'
    else
       if(iprisubmat>=2) write(nfout,'("nprow,npcol,myrow,mycol=",4i5)') nprow,npcol,myrow,mycol
    end if
#ifdef SINGLE_CONTEXT
    call descinit(desca,ndim,ndim,nb,nb,0,0,ictxt,lda,info)
    if(iprisubmat>=2) write(nfout,*) 'descinit for amat: info=',info
    call descinit(descz,ndim,ndim,nb,nb,0,0,ictxt,lda,info)
    if(iprisubmat>=2) write(nfout,*) 'descinit for zmat: info=',info
#else
    call descinit(desca,ndim,ndim,nb,nb,0,0,ictxt(myrank_k),lda,info)
    if(iprisubmat>=2) write(nfout,*) 'descinit for amat: info=',info
    call descinit(descz,ndim,ndim,nb,nb,0,0,ictxt(myrank_k),lda,info)
    if(iprisubmat>=2) write(nfout,*) 'descinit for zmat: info=',info
#endif

!   if(kimg_t==1) then
       ! setup for pdsyev
       if(method_scalapack==HOUSEHOLDER) then
          IROFFA = MOD( 0, nb )
          ICOFFA = MOD( 0, nb )
          iarow = INDXG2P( 1, nb, myrow, desca( RSRC_ ), nprow )
          iacol = INDXG2P( 1, nb, mycol, desca( RSRC_ ), npcol )
          np = NUMROC( ndim+iroffa, nb, myrow, iarow, nprow )
          nq = NUMROC( ndim+icoffa, nb, mycol, iacol, npcol )
          sizemqrleft = max( (nb*(nb-1))/2, (np+nq)*nb ) + nb*nb
          if(printable) write(nfout,*) 'np,nq=',np,nq
          if(printable) write(nfout,*) 'sizemqrleft=',sizemqrleft
          np0 = NUMROC( max(ndim,nb,2), nb, 0, 0, nprow )
          nq0 = NUMROC( max(ndim,nb,2), nb, 0, 0, npcol )
          nrc = NUMROC( ndim, nb, myrow, 0, nprocs)
          ldc = max( 1, nrc )
          if(printable) write(nfout,*) 'np0,nq0=',np0,nq0
          if(printable) write(nfout,*) 'nrc,ldc=',nrc,ldc
          qrmem = 2*ndim-2
          if(printable) write(nfout,'("qrmem,=",i9)') qrmem
          lwork1 = 5*ndim + ndim*ldc + max( sizemqrleft, qrmem ) + 1
          if(printable) write(nfout,'("lwork1,=",i9)') lwork1
          lrwork1 = 0
          liwork1 = 0
       else
          iarow = INDXG2P( 1, nb, myrow, desca( RSRC_ ), nprow )
          iacol = INDXG2P( 1, nb, mycol, desca( CSRC_ ), npcol )
          np0 = NUMROC( ndim, nb, myrow, iarow, nprow )
          nq0 = NUMROC( ndim, nb, mycol, iacol, npcol )
          if(printable) then
             write(nfout,*) 'iarow,iacol=',iarow,iacol
             write(nfout,*) 'np0,nq0=',np0,nq0
             write(nfout,*) 'nb_a=', desca( NB_ )
          end if
          trilwmin = 3*ndim + max( nb*( np0+1 ), 3*nb )
          lwork1 = max( 1+6*ndim+2*np0*nq0, trilwmin ) + 2*ndim
          liwork1 = 7*ndim + 8*npcol + 2
          if(printable) write(nfout,'("lwork1,liwork1,=",2i9)') lwork1,liwork1
          lrwork1 = 0
       end if
!   else
       ! setup for pzheev
       if(method_scalapack==HOUSEHOLDER) then
          np0 = NUMROC( max(ndim,nb,2), nb, 0, 0, nprow )
          nq0 = NUMROC( max(ndim,nb,2), nb, 0, 0, npcol )
          if(printable) write(nfout,*) 'np0,nq0=',np0,nq0
          lwork2 = ndim*(ndim+3) + ( np0 + nq0 + nb ) * nb
          lrwork2 = 2*ndim + 2*ndim-2
          if(printable) write(nfout,'("lwork2,lrwork2,=",3i9)') lwork2,lrwork2
          liwork2 = 0
       else
          iarow = INDXG2P( 1, nb, myrow, desca( RSRC_ ), nprow )
          iacol = INDXG2P( 1, nb, mycol, desca( CSRC_ ), npcol )
          np0 = NUMROC( ndim, nb, myrow, iarow, nprow )
          nq0 = NUMROC( ndim, nb, mycol, iacol, npcol )
          nq = NUMROC( MAX( ndim, nb, 2 ), nb, 0, 0, npcol )
          if(printable) then
             write(nfout,*) 'iarow,iacol=',iarow,iacol
             write(nfout,*) 'np0,nq0,nq=',np0,nq0,nq
             write(nfout,*) 'nb_a=', desca( NB_ )
          end if
          lwork2 = ndim + ( np0 + nq + nb ) * nb
          lrwork2 = 1 + 9*ndim + 3*np0*nq0
          liwork2 = 7*ndim + 8*npcol + 2
          if(printable) write(nfout,'("lwork2,lrwork2,liwork2,=",3i9)') lwork2,lrwork2,liwork2
       end if
!   end if

    call tstatc0_end(id_sname)
  end subroutine scalapack_setup
#endif

#ifdef _USE_SCALAPACK_
  subroutine pdsyev_driver(ndim,eig,desca,descz,lda,occ,amat,zmat,lwork,liwork)
    integer, intent(in):: ndim
    real(kind=DP), intent(out) ,dimension(ndim) :: eig
    integer, dimension(9), intent(in) :: desca,descz
    integer, intent(in) :: lda,occ
    real(kind=DP), intent(inout) ,dimension(lda,occ) :: amat
    real(kind=DP), intent(out) ,dimension(lda,occ) :: zmat
    integer, intent(in):: lwork,liwork

    character(len=1) :: JOBZ,UPLO
    real(kind=DP),allocatable,dimension(:) :: work
    integer,allocatable,dimension(:) :: iwork
    integer :: info
    integer :: id_sname = -1
    call tstatc0_begin('pdsyev_driver ', id_sname)
 
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'

    allocate(work(lwork))
    if(method_scalapack==DIVIDEandCONQUER) allocate(iwork(liwork))

    if(method_scalapack==HOUSEHOLDER) then
#ifdef NEC_ITER_REG
       call FTRACE_REGION_BEGIN("PDSYEV")
#endif
       call pdsyev(JOBZ,UPLO,ndim,amat,1,1,desca,eig,zmat,1,1 &
                & ,descz,work,lwork,info)
#ifdef NEC_ITER_REG
       call FTRACE_REGION_END("PDSYEV")
#endif
       if(iprisubmat>=2) write(nfout,*) 'pdsyev: info=',info
    else
#ifdef NEC_ITER_REG
       call FTRACE_REGION_BEGIN("PDSYEVD")
#endif
       call pdsyevd(JOBZ,UPLO,ndim,amat,1,1,desca,eig,zmat,1,1 &
                 & ,descz,work,lwork,iwork,liwork,info)
#ifdef NEC_ITER_REG
       call FTRACE_REGION_END("PDSYEVD")
#endif
       if(iprisubmat>=2) write(nfout,*) 'pdsyevd: info=',info
    end if


    deallocate(work)
    if(method_scalapack==DIVIDEandCONQUER) deallocate(iwork)

    call tstatc0_end(id_sname)
  end subroutine pdsyev_driver

  subroutine pzheev_driver(ndim,eig,desca,descz,lda,occ,amat,zmat,lwork,lrwork,liwork)
    integer, intent(in):: ndim
    real(kind=DP), intent(out) ,dimension(ndim) :: eig
    integer, dimension(9), intent(in) :: desca,descz
    integer, intent(in) :: lda,occ
    real(kind=DP), intent(inout) ,dimension(lda*2,occ) :: amat
    real(kind=DP), intent(out) ,dimension(lda*2,occ) :: zmat
    integer, intent(in):: lwork,lrwork,liwork

    character(len=1) :: JOBZ,UPLO
    complex(kind=CMPLDP),allocatable,dimension(:) :: work
    real(kind=DP),allocatable,dimension(:) :: rwork
    integer,allocatable,dimension(:) :: iwork
    integer :: info

    integer :: id_sname = -1
    call tstatc0_begin('pzheev_driver ', id_sname)
 
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'

    allocate(work(lwork))
    allocate(rwork(lrwork))
    if(method_scalapack==DIVIDEandCONQUER) allocate(iwork(liwork))

    if(method_scalapack==HOUSEHOLDER) then
#ifdef NEC_ITER_REG
       call FTRACE_REGION_BEGIN("PZHEEV")
#endif
       call pzheev(JOBZ,UPLO,ndim,amat,1,1,desca,eig,zmat,1,1 &
                & ,descz,work,lwork,rwork,lrwork,info)
#ifdef NEC_ITER_REG
       call FTRACE_REGION_END("PZHEEV")
#endif
       if(iprisubmat>=2) write(nfout,*) 'pzheev: info=',info
    else
#ifdef NEC_ITER_REG
       call FTRACE_REGION_BEGIN("PZHEEVD")
#endif
       call pzheevd(JOBZ,UPLO,ndim,amat,1,1,desca,eig,zmat,1,1 &
                 & ,descz,work,lwork,rwork,lrwork,iwork,liwork,info)
#ifdef NEC_ITER_REG
       call FTRACE_REGION_END("PZHEEVD")
#endif
       if(iprisubmat>=2) write(nfout,*) 'pzheevd: info=',info
    end if

    deallocate(work)
    deallocate(rwork)
    if(method_scalapack==DIVIDEandCONQUER) deallocate(iwork)

    call tstatc0_end(id_sname)
  end subroutine pzheev_driver
#endif
! _USE_SCALAPACK_



   subroutine m_ESsubmat_utransform_wf(imode,ik,zaj_l,update_fsr,wf_mode)
     integer, intent(in) :: imode,ik
     real(kind=DP), dimension(kg1,np_e,ista_k:iend_k,kimg),intent(inout) :: zaj_l
     logical, intent(in) :: update_fsr
     logical, intent(in) :: wf_mode
     real(kind=DP), allocatable, dimension(:,:,:) :: zat_l,zat_wk
     real(kind=DP), allocatable, dimension(:,:,:) :: zahloc_l,zahloc_wk
     real(kind=DP), allocatable, dimension(:,:) :: zz
     integer :: jp,is,ie,nblk1,ibsize2,ibsize,kimg_t
     real(kind=DP),allocatable,dimension(:,:) :: mat
     if(.not.allocated(unimat)) return
     if(disable_utransform) return
#ifdef _ODD_BOUNDARY_
     if(mod(np_g1k(ik),2) == 0) then
        np_g1k_x = np_g1k(ik) + 1
     else
        np_g1k_x = np_g1k(ik)
     end if
#else
     np_g1k_x = np_g1k(ik)
#endif
     np_g1k_x = maxval(np_g1k)

     if(k_symmetry(ik) == GAMMA) then
        kimg_t = 1
     else
        kimg_t = kimg
     end if

     if(nblocksize_submat_is_given) then
       ibsize = nblocksize_submat
     else
       ibsize = nb_submat_default
     endif

!     if(imode==DIRECT .and. wf_mode)then
!        zaj_l(1:kg1,1:np_e,ik,1:kimg) = zaj_l_buf(1:kg1,1:np_e,ik,1:kimg)
!        if(update_fsr) call m_ES_betar_dot_WFs_4_each_k(nfout,ik)
!        return
!     endif
!     if(imode==INVERSE .and. wf_mode) then
!        zaj_l_buf(1:kg1,1:np_e,ik,1:kimg) = zaj_l(1:kg1,1:np_e,ik,1:kimg)
!     endif

     allocate(zat_l(np_g1k_x,neg,kimg));zat_l=0.d0
     allocate(zahloc_l(np_g1k_x,neg,kimg))
     call m_ES_W_transpose_r(.false.,ista_k,iend_k,ik,zaj_l,zat_l)
     allocate(zat_wk(np_g1k_x,neg,kimg));zat_wk=0.d0
     allocate(zahloc_wk(np_g1k_x,neg,kimg))
     allocate(mat(neg*kimg_t,neg))
     if(imode==DIRECT)then
        mat(:,:)=unimat(:,:)
     else
        mat(:,:)=unimat_h(:,:)
     endif
! <-- T.Kokubo & D.Fukata, Feb. 2010
     PART2: do jp = 1,npart2
        is = isp2(jp)
        ie = iep2(jp)
        nblk1 = ie-is+1
#ifdef SX
        ibsize2 = neg
#else
        ibsize2 = ibsize
#endif
#ifdef _USE_SCALAPACK_
        if(sw_scalapack == ON) then
           allocate(zz(neg*kimg_t,nblk1))
           call put_zmat(kimg_t,lda,occ,mat,neg,nprow,npcol,block_size,usermap,is,ie,zz)
           if(kimg == 1) then
              call subspace_rotation_real(is,ie,zat_wk,zz,nblk1,ibsize2,ik,neg,zat_l,zahloc_wk,zahloc_l)
           else
              call subspace_rotation_imag(is,ie,kimg_t,zat_wk,zz,nblk1,ibsize2,ik,neg,zat_l,zahloc_wk,zahloc_l)
           endif
           deallocate(zz)
        else
#endif
           if(kimg == 1) then
              call subspace_rotation_real(is,ie,zat_wk,mat(1,is),nblk1,ibsize2,ik,neg,zat_l,zahloc_wk,zahloc_l)
           else
              call subspace_rotation_imag(is,ie,kimg_t,zat_wk,mat(1,is),nblk1,ibsize2,ik,neg,zat_l,zahloc_wk,zahloc_l)
           endif
#ifdef _USE_SCALAPACK_
        end if
#endif
     end do PART2
     call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,zaj_l,zat_wk)            ! zat_l -> zaj_l
     deallocate(zat_l)
     deallocate(zat_wk)
     if(update_fsr) call m_ES_betar_dot_WFs_4_each_k(nfout,ik)
   end subroutine m_ESsubmat_utransform_wf 


end module m_ES_WF_by_submat

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE: m_epc_potential
!
!  AUTHOR(S): M. Saito, T. Yamasaki   November/04/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!
!
module m_epc_potential
! $Id: m_epc_potential.F90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Electronic_Structure, only : vlhxc_l
!$$#ifndef PARA3D
  use m_PlaneWaveBasisSet,    only : ngabc,gr_l,igfp_l,igfp_nonpara,kg,kgp,kgp_reduced,ylm_l&
       &                           , m_pwBS_sphrp2,m_pwBS_sphrp2_diff
!$$#endif
#ifdef _MPIFFTTEST_
  use m_PlaneWaveBasisSet,    only : igfp_l_c
#endif
  use m_PseudoPotential,      only : itpcc,rhcg_l,rhceg_l

  use m_Crystal_Structure,    only : rltv,univol
  use m_Ionic_System,         only : ntyp,natm,iwei,ityp,pos,zfm3_l,iatomn  
  use m_FFT,                  only : fft_box_size_CD,fft_box_size_CD_nonpara,nfftp,nfftp_nonpara &
       &                           , m_FFT_CD0 &
       &                           , m_FFT_check_of_negative_CD
#ifdef _MPIFFTTEST_
  use m_FFT,                  only : m_FFT_set_cdata  &
       &                           , lx,ly,lz,ly_d,lz_d, ny_d,nz_d
#else
  use m_FFT,                  only : m_FFT_alloc_CD_box &
       &                           , m_FFT_dealloc_CD_box
#endif
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : xctype,len_xctype,ipripositron,nspin,kimg,af,nel_Ylm &
       &                           , sw_gga_p
  use m_Const_Parameters,     only : DP,DOWN,UP,Partial_Core_Charge,Valence_plus_PC_Charge,PAI4,ON &
       &                           , LDA,GGA,PAI,PAI2,VXC_AND_EXC,STRESS_,zi,SKIP, INVERSE, DIRECT
  use m_Parallelization,      only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype, ierr &
       &                           , ista_sfftp,iend_sfftp,ista_sfftph,iend_sfftph &
       &                           , nis_sfftp,nie_sfftp,nel_sfftp,idisp_sfftp,np_sfftp,mp_sfftp &
       &                           , npes_cdfft

! === Postitron SCF === 2015/11/28
  use m_Control_Parameters,  only : positron_method
  use m_Const_Parameters,   only : positron_CONV
  use m_Charge_Density,     only : chgq_l
  use m_PseudoPotential,      only : psc_l
! ===================== 2015/11/28

  implicit none

  include 'mpif.h'

  real(kind=DP), pointer :: vlhxc_p( :,:,: )

  real(kind=DP), allocatable, dimension(:,:,:) :: tchgq_l  ! d(ista_kngp:iend_kngp,kimg)
  real(kind=DP), allocatable, dimension(:,:) ::   tchgr_l  ! d(ista_sfftph:iend_sfftph,nspin)
!!$  real(kind=DP), allocatable, dimension(:) ::     p_potential_l ! d(ista_kngp:iend_kngp)
  real(kind=DP), allocatable, dimension(:,:) ::   grad_tchgr_l !d(ista_sfftph:iend_sfftph,nspin)
  real(kind=DP), allocatable, dimension(:,:) ::   chden_l !d(ista_sfftp:iend_sfftp,nspin)
  integer, private,allocatable,dimension(:)  ::   inx,jnx,knx ! MPI d(ista_sfftp:iend_sfftp)
  real(kind=DP), allocatable, dimension(:,:,:) :: vepc_l   ! d(ista_kngp:iend_kngp,kimg,nspin)  MPI

  real(kind=DP)                                :: epc

  real(kind=DP),private,allocatable,dimension(:):: afft        ! d(ista_sfftp:iend_sfftp)
  real(kind=DP),private,pointer,dimension(:)    :: afft_mpi1,afft_CD   ! MPI d(nfftp)
  real(kind=DP),private,pointer,dimension(:)    :: afft_mpi2,afft_mpi3   ! MPI d(mp_sfftp)

  real(kind=DP),private, allocatable, dimension(:)  :: f2or1 ! MPI d(ista_sfftph,iend_sfftph)
  logical,      private, dimension(3)               :: lmn_even

!   1. m_epc_alloc
!   2. m_epc_dealloc
!   3. epc_allocate
!   4. epc_deallocate
!   5. m_epc_cal_potential
!       map_charge_onto_a_fft_box
!       cp_afft_to_tchgrhr
!       check_lmn_even
!       cpafft
!       cpafft_to_vepc
!   6. check_of_pcc
!   7. afft_allgatherv


contains
  subroutine m_epc_alloc()
    integer :: idp, i, n, nn, nlp, nmp, nnp, nd2p, j, k
#ifdef _MPIFFTTEST_
    integer                  :: np0, j0, i2, j2, k2, n0
#endif

    if ( allocated(tchgq_l) ) deallocate( tchgq_l )
    if ( allocated(tchgr_l) ) deallocate( tchgr_l )
    if ( allocated( grad_tchgr_l ) ) deallocate( grad_tchgr_l )
    if ( allocated( chden_l ) ) deallocate( chden_l )
    if ( allocated( inx ) ) deallocate( inx )
    if ( allocated( jnx ) ) deallocate( jnx )
    if ( allocated( knx ) ) deallocate( knx )
    if ( allocated( vepc_l ) ) deallocate( vepc_l )
    if ( allocated( f2or1) ) deallocate( f2or1 )

    allocate(tchgq_l(ista_kngp:iend_kngp,kimg,nspin));  tchgq_l = 0.d0
    allocate(tchgr_l(ista_sfftph:iend_sfftph,nspin));     tchgr_l = 0.d0
    if(sw_gga_p == ON) then
       allocate(grad_tchgr_l(ista_sfftph:iend_sfftph,nspin));       grad_tchgr_l = 0.d0
       allocate(chden_l(ista_sfftp:iend_sfftp,nspin)); chden_l = 0.d0
       allocate(inx(ista_sfftp:iend_sfftp)); inx = 0
       allocate(jnx(ista_sfftp:iend_sfftp)); jnx = 0
       allocate(knx(ista_sfftp:iend_sfftp)); knx = 0
       nlp  = fft_box_size_CD(1,1)
       nmp  = fft_box_size_CD(2,1)
       nnp  = fft_box_size_CD(3,1)
#ifdef _MPIFFT_
       idp  = fft_box_size_CD_nonpara(1,0)
       nd2p = fft_box_size_CD_nonpara(2,0)
#elif _MPIFFTTEST_
       idp  = fft_box_size_CD_c(1,0)
       nd2p = fft_box_size_CD_c(2,0)
#else       
       idp  = fft_box_size_CD(1,0)
       nd2p = fft_box_size_CD(2,0)
#endif
       do n = ista_sfftp, iend_sfftp
          nn = (n+kimg-1)/kimg
#ifdef _MPIFFTTEST_
          np0 = nn - idp*ly_d*lz*myrank_cdfft
          i  = mod(np0-1,idp)+1
          j0 = mod((np0-i)/idp,ly_d) + 1
          j  = j0 + ny_d*myrank_cdfft
          k  = (np0-i-(j0-1)*idp)/(idp*ly_d) + 1
          if(i >= idp) i = i - idp
#else
          i  = mod(nn,idp)
          j  = mod((nn-1)/idp,nd2p) + 1
          k  = (nn - (j-1)*idp - i)/(idp*nd2p) + 1
#endif
          inx(n) = i - 1;  if(2*inx(n) > nlp) inx(n) = inx(n) - nlp
          jnx(n) = j - 1;  if(2*jnx(n) > nmp) jnx(n) = jnx(n) - nmp
          knx(n) = k - 1;  if(2*knx(n) > nnp) knx(n) = knx(n) - nnp
       end do
    end if
!!$    allocate(p_potential_l(ista_kngp:iend_kngp)); p_potential_l = 0.d0
    allocate(vepc_l(ista_kngp:iend_kngp,kimg,nspin)); vepc_l = 0.d0

    allocate(f2or1(ista_sfftph:iend_sfftph))
    if(kimg == 1) then
       f2or1 = 2.d0
#ifdef _MPIFFT_
       idp = fft_box_size_CD_nonpara(1,0)
#else
       idp = fft_box_size_CD(1,0)
#endif
       do i = ista_sfftph, iend_sfftph
          if(mod(i*2,idp) == 2 .or. mod(i*2,idp) == 0) f2or1(i) = 1.d0
       end do
    else
       f2or1 = 1.d0
    end if

  end subroutine m_epc_alloc

  subroutine m_epc_dealloc()
!!$    if(allocated(tchgq_l)) deallocate(tchgq_l)
    if(allocated(tchgr_l)) deallocate(tchgr_l)
    if(allocated(grad_tchgr_l)) deallocate(grad_tchgr_l)
    if(allocated(chden_l)) deallocate(chden_l)
    if(allocated(inx)) deallocate(inx)
    if(allocated(jnx)) deallocate(jnx)
    if(allocated(knx)) deallocate(knx)
!!$    if(allocated(p_potential_l)) deallocate(p_potential_l)
    if(allocated(f2or1)) deallocate(f2or1)
!Saito
!    if(allocated(vepc_l)) deallocate(vepc_l)
  end subroutine m_epc_dealloc

  subroutine epc_allocate()
#ifndef _MPIFFTTEST_
    call m_FFT_alloc_CD_box()
#endif
    allocate(afft(ista_sfftp:iend_sfftp))
    allocate(afft_mpi1(nfftp_nonpara))                         ! MPI
    allocate(afft_CD(nfftp_nonpara))
    if(npes >= 2) then
       allocate(afft_mpi2(mp_sfftp))                       ! MPI
       allocate(afft_mpi3(mp_sfftp))                       ! MPI
    end if

  end subroutine epc_allocate

  subroutine epc_deallocate()
    call m_FFT_dealloc_CD_box()
    deallocate(afft)
    deallocate(afft_mpi1)
    deallocate(afft_CD)
    if(npes >= 2) then
       deallocate(afft_mpi2); deallocate(afft_mpi3)
    end if
  end subroutine epc_deallocate

  subroutine m_epc_cal_potential(nfout,chgq_l)
    integer, intent(in) :: nfout
    real(kind=DP), intent(in) :: chgq_l(ista_kngp:iend_kngp,kimg,nspin)

    integer :: i, n, j, ispin, iloop, in
    real(kind=DP) :: rinplw
    real(kind=DP), allocatable, dimension(:,:) :: vepcr_l

    real(kind=DP) :: epc = 0.d0
    real(kind=DP) :: epc_mpi     ! MPI
    real(kind=DP) :: DELTA
    data DELTA/1.d-40/
#ifdef _MPIFFTTEST_
    rinplw = 1.d0/product(fft_box_size_CD_c(1:3,1))
#else
    rinplw = 1.d0/product(fft_box_size_CD(1:3,1))
#endif

!!$    do j = 1, kimg
!!$       do n = 1, ntyp
!!$          do i = ista_kngp, iend_kngp
!!$             tchgq_l(i,j,1) = tchgq_l(i,j,1) + (rhcg_l(i,n)-iatomn(n))*zfm3_l(i,n,j)
!!$          end do
!!$       end do
!!$    end do
!!$
!!$    if(nspin == 2) then
!!$       tchgq_l(:,:,2) = tchgq_l(:,:,1)*0.5d0
!!$       tchgq_l(:,:,1) = tchgq_l(:,:,2)
!!$    end if

    tchgq_l = 0.0d0
    do ispin = 1, nspin
       do j = 1, kimg
          do i = ista_kngp, iend_kngp
             tchgq_l(i,j,ispin) = tchgq_l(i,j,ispin) + chgq_l(i,j,ispin)
          end do
       end do
    end do

    if(ipripositron >= 2) then
       write(nfout,'(" -- tchgq_l, chgq_l <<m_epc_cal_potential>>")')
       do ispin = 1, nspin
          write(nfout,'(" ispin = ",i8)') ispin
          do j = 1, kimg
             write(nfout,'(" j = ",i8)') j
             do i = ista_kngp, min(ista_kngp+20,iend_kngp)
                write(nfout,'(3f10.5)') tchgq_l(i,j,ispin),chgq_l(i,j,ispin)
             end do
          end do
       end do
    end if

    call epc_allocate()

    do iloop = 1, nspin
       call map_charge_onto_a_fft_box ! tchgq_l -> afft_CD (G-space -> G-space)
       if(sw_gga_p == ON) &
            & chden_l(ista_sfftp:iend_sfftp,iloop) = afft_CD(ista_sfftp:iend_sfftp) ! G-space
       call m_FFT_CD0(nfout,afft_CD,INVERSE) ! afft -> afft (G-space representation -> r-space representation)
       afft(ista_sfftp:iend_sfftp) = afft_CD(ista_sfftp:iend_sfftp)
       call m_FFT_check_of_negative_CD(npes,ista_sfftp,iend_sfftp,ista_sfftph,iend_sfftph &
            &                         ,afft,nfout,nspin,iloop)
       call cp_afft_to_tchgrhr       ! -> tchgr_l (R-space)
    end do

    call check_lmn_even 

    if(sw_gga_p == ON) then
       do iloop = 1, nspin
          grad_tchgr_l(:,iloop) = 0.d0
          do in = 1, 3
             call g_xyz_chden_l(in,iloop) ! -> G_xyz * chden_l --> afft_CD
             call m_FFT_CD0(nfout,afft_CD,INVERSE)
             call add_sq_afft_CD_to_grad_tchgr(iloop)
          end do
          grad_tchgr_l(:,iloop) = dsqrt(grad_tchgr_l(:,iloop))
       end do
    end if

    ! ******************************************
    ! epcor_0 is the subroutine coded by Dr. Mineo Saito.
    allocate(vepcr_l(ista_sfftph:iend_sfftph,nspin))
    vepcr_l = tchgr_l
    call epcor_0(nspin,DELTA,vepcr_l,f2or1,epc)
    ! -> b_XC_Potential,  Electron-Positron CORrelation , 0-density limit

    epc = epc*univol*rinplw
    if(npes >= 2) then               ! MPI
       call mpi_allreduce(epc,epc_mpi,1,mpi_double_precision,mpi_sum &
            & ,mpi_comm_group,ierr)  ! MPI
       epc = epc_mpi                 ! MPI
    end if

    if(ipripositron >= 3) then
       write(nfout,'(" epc = ",d20.8,"<<m_epc_cal_potential>>")') epc
       write(nfout,'(" -- vepcr_l -- <<m_epc_cal_potential>>")')
       do ispin = 1, nspin
          write(nfout,'(" ispin = ",i8)') ispin
          do i = ista_sfftph, min(ista_sfftph+50,iend_sfftph)
             write(nfout,'(3f12.6)') vepcr_l(i,ispin)
          end do
       end do
    end if


    do iloop = 1, nspin
       call cpafft_CD(iloop)           ! vepcr_l -> afft_CD
       call m_FFT_CD0(nfout,afft_CD,DIRECT)
       call cpafft_CD_to_vepc(iloop)   ! afft_CD -> vepc_l
    end do
    deallocate(vepcr_l)

    if(ipripositron >= 3) then
       write(nfout,'(" -- vepc_l, rhceg_l, rhcg_l <<m_epc_cal_potential>>")')
       do n = 1, ntyp
          write(nfout,'(" ntyp = ",i8)') ntyp
          do i = ista_kngp, min(ista_kngp+20,iend_kngp)
             write(nfout,'(3f10.5)') vepc_l(i,1,1),rhceg_l(i,n), rhcg_l(i,n)
          end do
       end do
    end if
 
    do j = 1, kimg
       do n = 1, ntyp
          do i = ista_kngp, iend_kngp
             vepc_l(i,j,1) = vepc_l(i,j,1) + rhceg_l(i,n)*zfm3_l(i,n,j)
          end do
       end do
    end do

    if(nspin == 2) then
!!$       vepc_l(:,:,1) = tchgq_l(:,:,1)+tchgq_l(:,:,2)
       vepc_l(:,:,2) = vepc_l(:,:,1)
!!$       vepc_l(:,:,2) = tchgq_l(:,:,1)*0.5d0
!!$       vepc_l(:,:,1) = tchgq_l(:,:,2)
    end if

    tchgq_l=0.d0
    do j = 1, kimg
       do n = 1, ntyp
          do i = ista_kngp, iend_kngp
             tchgq_l(i,j,1) = tchgq_l(i,j,1) + (rhcg_l(i,n)-iatomn(n)/univol)*zfm3_l(i,n,j)
          end do
       end do
    end do
    if(nspin == 2) then
       tchgq_l(:,:,2) = tchgq_l(:,:,1)*0.5d0
       tchgq_l(:,:,1) = tchgq_l(:,:,2)
    end if
    do ispin = 1, nspin
       do j = 1, kimg
          do i = ista_kngp, iend_kngp
             tchgq_l(i,j,ispin) = tchgq_l(i,j,ispin) + chgq_l(i,j,ispin)
             !             write(671,*) i,tchgq_l(i,j,ispin)*univol
          end do
       end do
    end do
    call epc_deallocate()
  contains
    subroutine g_xyz_chden_l(in,is)
      integer, intent(in) :: in, is
      integer       :: n
      real(kind=DP) :: gxyz
      afft_CD = 0.d0
      do n = ista_sfftp, iend_sfftp
         gxyz = rltv(in,1)*inx(n)+rltv(in,2)*jnx(n)+rltv(in,3)*knx(n)
         afft_CD(n) = gxyz*chden_l(n,is)
      end do
      call boundary_zero_into_afft(in)
    end subroutine g_xyz_chden_l

    subroutine boundary_zero_into_afft(in)
      integer, intent(in) :: in
      integer             :: i,j,k,nn,n,idp,nlp,nmp,nnp,nd2p, j0

      nlp = fft_box_size_CD(1,1)
      nmp = fft_box_size_CD(2,1)
      nnp = fft_box_size_CD(3,1)
#ifdef _MPIFFT_
      idp  = fft_box_size_CD_nonpara(1,0)
      nd2p = fft_box_size_CD_nonpara(2,0)
#elif _MPIFFTTEST_
      idp = fft_box_size_CD_c(1,0)
      nd2p = fft_box_size_CD_c(2,0)
#else
      idp = fft_box_size_CD(1,0)
      nd2p = fft_box_size_CD(2,0)
#endif

      if(kimg == 1) then
         if(lmn_even(in)) then
            if( in == 1) then
#ifdef  MPIFFTTEST_
               do j = 1, ly_d*lz
                  nn = nlp/2 + 1 + idp*(j-1) + idp*ly_d*lz*myrank_cdfft
                  afft(nn) = 0.d0
               end do
#else
               do j = 1, nmp      ! y
                  do k = 1, nnp   ! z
                     nn = nlp/2 + 1 + idp*(j-1) + idp*nd2p*(k-1)
                     if(nn >= ista_sfftp .and. nn <= iend_sfftp) afft(nn) = 0.d0
                  end do
               end do
#endif
            else if( in == 2) then
#ifdef _MPIFFTTEST_
               j0 = nmp/2 + 1 - ny_d*myrank_cdfft
               if(j0 >= 1 .and. j0 <= ny_d) then
                  do i = 1, idp
                     do k = 1, nnp
                        nn = i + idp*(j0-1) + idp*ly_d*(k-1) + idp*ly_d*lz*myrank_cdfft
                        afft(nn) = 0.d0
                     end do
                  end do
               end if
#else
               do i = 1, idp      ! x
                  do k = 1, nnp   ! z
                     nn = i + idp*(nmp/2) + idp*nd2p*(k-1)
                     if(nn >= ista_sfftp .and. nn <= iend_sfftp) afft(nn) = 0.d0
                  end do
               end do
#endif
            else if(in == 3) then
#ifdef _MPIFFTTEST_
               do i = 1, idp
                  do j = 1+ny_d*myrank_cdfft, min(nmp,ny_d*(myrank_cdfft+1))
                     nn = i + idp*(j-1-ny_d*myrank_cdfft) + idp*ly_d*(nnp/2) &
                          &                          + idp*ly_d*lz*myrank_cdfft
                     afft(nn) = 0.d0
                  end do
               end do
#else
               do i = 1, idp      ! x
                  do j = 1, nmp   ! y
                     nn = i + idp*(j-1) + idp*nd2p*(nnp/2)
                     if(nn >= ista_sfftp .and. nn <= iend_sfftp) afft(nn) = 0.d0
                  end do
               end do
#endif
            end if
         end if
      else if(kimg == 2) then
         if(lmn_even(in)) then
            if( in == 1) then
#ifdef _MPIFFTTEST_
               do j = 1, ly_d*lz
                  nn = nlp/2 + 1 + idp*(j-1) + idp*ly_d*lz*myrank_cdfft
                  n = nn*2 - 1
                  afft(n) = 0.d0
                  afft(n+1) = 0.d0
               end do
#else               
               do j = 1, nmp
                  do k = 1, nnp
                     nn = nlp/2 + 1 + idp*(j-1) + idp*nd2p*(k-1)
                     n  = nn*2 - 1
                     if(n >= ista_sfftp .and. n <= iend_sfftp) afft(n) = 0.d0
                     n  = nn*2
                     if(n >= ista_sfftp .and. n <= iend_sfftp) afft(n) = 0.d0
                  end do
               end do
#endif
            else if( in == 2) then
#ifdef _MPIFFTTEST_
               j0 = nmp/2 + 1 - ny_d*myrank_cdfft
               if(j0 >= 1 .and. j0 <= ny_d) then
                  do i = 1, idp
                     do k = 1, nnp
                        nn = i + idp*(j0-1) + idp*ly_d*(k-1) + idp*ly_d*lz*myrank_cdfft
                        n  = nn*2 - 1
                        afft(n) = 0.d0; afft(n+1) = 0.d0
                     end do
                  end do
               end if
#else
               do i = 1, idp
                  do k = 1, nnp
                     nn = i + idp*(nmp/2) + idp*nd2p*(k-1)
                     n  = nn*2 - 1
                     if(n >= ista_sfftp .and. n <= iend_sfftp) afft(n) = 0.d0
                     n  = nn*2
                     if(n >= ista_sfftp .and. n <= iend_sfftp) afft(n) = 0.d0
                  end do
               end do
#endif
            else if(in == 3) then
#ifdef _MPIFFTTEST_
               do i = 1, idp
                  do j = 1+ny_d*myrank_cdfft, min(nmp,ny_d*(myrank_cdfft+1))
                     nn = i + idp*(j-1-ny_d*myrank_cdfft) + idp*ly_d*(nnp/2) &
                          &                          + idp*ly_d*lz*myrank_cdfft
                     n  = nn*2 - 1
                     afft(n) = 0.d0
                     afft(n+1) = 0.d0
                  end do
               end do
#else
               do i = 1, idp
                  do j = 1, nmp
!!$                  nn = i + idp*(j-1) + idp*nmp*(nnp/2)
                     nn = i + idp*(j-1) + idp*nd2p*(nnp/2)
                     n  = nn*2 - 1
                     if(n >= ista_sfftp .and. n <= iend_sfftp) afft(n) = 0.d0
                     n  = nn*2
                     if(n >= ista_sfftp .and. n <= iend_sfftp) afft(n) = 0.d0
                  end do
               end do
#endif
            end if
         end if
      end if
    end subroutine boundary_zero_into_afft

    subroutine add_sq_afft_CD_to_grad_tchgr(is)
      integer, intent(in) :: is
      integer :: i
      do i = ista_sfftph, iend_sfftph     ! MPI
         grad_tchgr_l(i,is) = grad_tchgr_l(i,is) + afft_CD(i*2)**2
      end do
    end subroutine add_sq_afft_CD_to_grad_tchgr
      
    subroutine map_charge_onto_a_fft_box
      real(kind=DP)      :: fac
      integer            :: mm, it, i, j, ip

      fac = 1.d0/nspin

      mm = 0
      afft_CD = 0.d0

      do j = 1, kimg
         do i = ista_kngp, min(kgp_reduced,iend_kngp)  !for mpi
#ifdef _MPIFFT_
            ip = (igfp_nonpara(i)-1)*kimg + j
#elif _MPIFFTTEST_
            ip = (igfp_l_c(i)-1)*kimg + j
#else
            ip = (igfp_l(i)-1)*kimg + j
#endif
            afft_CD(ip) = afft_CD(ip) + tchgq_l(i,j,iloop) !mpi
         end do
      end do

      if(npes >= 2) then
         call mpi_allreduce(afft_CD,afft_mpi1,nfftp_nonpara ,mpi_double_precision&
              &,mpi_sum,mpi_comm_group,ierr)
         afft_CD = afft_mpi1
!!$         call mpi_barrier(mpi_comm_group,ierr)
!!$         do j = 0, npes-1
!!$            do i = nis_sfftp(j),nie_sfftp(j)
!!$               afft_mpi2(i-nis_sfftp(j)+1) = afft_mpi1(i)  !
         !! afft_mpi2(mp_sfftp), afft_mpi1(1:nfftp)
!!$            end do
!!$            call mpi_allreduce(afft_mpi2,afft_mpi3,mp_sfftp !!$           
         !!      &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
!!$
!!$            if(j == mype) then
!!$!!$#ifdef _MPIFFTTEST_
!!$!!$               call m_FFT_set_scdata(afft_mpi3,afft)
!!$!!$#else
!!$               do i = ista_sfftp, iend_sfftp
!!$                  afft(i) = afft_mpi3(i - ista_sfftp + 1)
!!$               end do
!!$!!$#endif
!!$            end if
!!$         end do
!!$      else
!!$         afft = afft_mpi1
      end if

    end subroutine map_charge_onto_a_fft_box

    subroutine cp_afft_to_tchgrhr
      integer  :: i
      do i = ista_sfftph, iend_sfftph    ! MPI
         tchgr_l(i,iloop) = afft(i*2-1)
      end do

      if(ipripositron >= 2) then
         write(nfout,'(" tchgr_l")')
         do i = ista_sfftph, min(ista_sfftph+10,iend_sfftph)
            write(nfout,'(i3,f20.8)') i, tchgr_l(i,iloop)
         end do
      end if
    end subroutine cp_afft_to_tchgrhr

    subroutine check_lmn_even
      integer             :: nlmn, i

      do i = 1, 3
         nlmn = fft_box_size_CD(i,1)/2
         if(2*nlmn == fft_box_size_CD(i,1)) then
            lmn_even(i) = .true.
         else
            lmn_even(i) = .false.
         end if
      end do
    end subroutine check_lmn_even

    subroutine cpafft_CD(is)
      integer, intent(in) :: is
      integer             :: i

      afft_CD = 0.d0
      do i = ista_sfftph, iend_sfftph                  ! MPI
!!$         afft(2*i-1) = tchgr_l(i,is)
         afft_CD(2*i-1) = vepcr_l(i,is)
      end do
      if(npes > 1) then
         call mpi_allreduce(afft_CD, afft_mpi1, nfftp_nonpara , mpi_double_precision,&
              & mpi_sum, mpi_comm_group,ierr)
         afft_CD = afft_mpi1
      end if

    end subroutine cpafft_CD

    subroutine cpafft_CD_to_vepc(is)
      integer, intent(in) :: is
      integer :: i, ik, ip


!!$      if(npes >= 2) then
!!$         call afft_allgatherv(afft,afft_mpi1)
!!$      else
!!$         afft_mpi1 = afft
!!$      end if

      do ik = 1, kimg
         do i = ista_kngp, min(kgp_reduced,iend_kngp)  !for mpi
#ifdef _MPIFFT_
            ip = (igfp_nonpara(i)-1)*kimg + ik
#elif _MPIFFTTEST_
            ip = (igfp_l_c(i)-1)*kimg + ik
#else
            ip = (igfp_l(i)-1)*kimg + ik
#endif
            vepc_l(i,ik,is)   = afft_CD(ip)*rinplw
         end do
      end do
    end subroutine cpafft_CD_to_vepc

  end subroutine m_epc_cal_potential

  subroutine check_of_pcc(nopcc)
    logical, intent(out) :: nopcc
    integer              :: i

    nopcc = .true.

    do i = 1, ntyp
       if(itpcc(i) /= 0) then
          nopcc = .false.
          goto 2201
       endif
    end do

    epc = 0.d0
2201 continue
  end subroutine check_of_pcc

  subroutine afft_allgatherv(afft_mpi0,afft)
    real(kind=DP),intent(in),dimension(:) :: afft_mpi0(ista_sfftp:iend_sfftp)
    real(kind=DP),intent(out),dimension(:):: afft(nfftp_nonpara)
    integer  :: id_sname = -1
    if(npes >= 2) then
       call tstatc0_begin('afft_allgatherv(in m_epc_potential) ',id_sname)
       call mpi_allgatherv(afft_mpi0,nel_sfftp(mype),mpi_double_precision &  ! MPI
            &       ,afft,nel_sfftp,idisp_sfftp,mpi_double_precision&
            &       ,mpi_comm_group,ierr)
    else     ! npes == 1
       afft = afft_mpi0
    end if
    if(npes >= 2) call tstatc0_end(id_sname)
  end subroutine afft_allgatherv

! ==== POSITRON SCF ===== 2015/11/28
  subroutine m_epc_alloc_vlhxc_p
    if ( positron_method == positron_CONV ) then
       vlhxc_p => vlhxc_l
    else
       if ( .not. associated( vlhxc_p ) ) then
          allocate( vlhxc_p(ista_kngp:iend_kngp,kimg,nspin) )
          vlhxc_p = 0.0d0
       endif
    endif
  end subroutine m_epc_alloc_vlhxc_p
  
  subroutine m_epc_dealloc_vlhxc_p
    if ( positron_method /= positron_CONV ) then
       if ( associated( vlhxc_p ) ) deallocate( vlhxc_p )
    endif
  end subroutine m_epc_dealloc_vlhxc_p
! ======================= 2015/11/28

  subroutine m_epc_ESlhxc_potential(nfout)
    integer, intent(in)       :: nfout
!    real(kind=DP), intent(in) :: chg(ista_kngp:iend_kngp,kimg,nspin)
!    real(kind=DP), intent(in) :: vxc(ista_kngp:iend_kngp,kimg,nspin)

    integer :: is,ik,i,it
    integer :: ist
    integer :: id_sname = -1

!    call tstatc0_begin('m_ESlhxc_potential ',id_sname)

    vlhxc_p = 0.d0
    ist = ista_kngp
    if(ist == 1) ist = 2
    do is = 1, nspin
       do ik = 1, kimg
          if(mype==0) vlhxc_p(1,ik,is)   = vepc_l(1,ik,is)
          if(nspin == 1) then
             do i = ist, iend_kngp  !for mpi
                vlhxc_p(i,ik,is) = vepc_l(i,ik,is) -PAI4*tchgq_l(i,ik,is)&
                     &/gr_l(i)**2
             end do
          else if(nspin == 2) then
             do i = ist, iend_kngp  !for mpi
                vlhxc_p(i,ik,is) = vepc_l(i,ik,is) -PAI4*(tchgq_l(i,ik,UP)&
                     &+tchgq_l(i,ik,DOWN))/gr_l(i)**2
             end do
          endif
!          do it    = 1,ntyp
!             do i = ista_kngp, iend_kngp  !for mpi
!                vlhxc_p(i,ik,is) !                     & = vlhxc_p(i,ik,is)
          !+psc_l(i,it)*zfm3_l(i,it,ik)
!             end do
!          end do
       end do
    end do
!    call tstatc0_end(id_sname)
    if(ipripositron >= 3) then
       write(nfout,'(" -- vepc_l tchgq_l vlhxc_p << m_epc_ESlhxc_potential>&
            &>")')
       do is = 1, nspin
          if(nspin == 2) write(nfout,'("  ispin = ",i5)') is
          do ik = 1, kimg
             do i = ist, min(ist+20,iend_kngp)
                write(nfout,'(3f10.4)') vepc_l(i,ik,is),tchgq_l(i,ik,is)&
                     &,vlhxc_p(i,ik,is)
             end do
          end do
       end do
    end if
  end subroutine m_epc_ESlhxc_potential

! ==== POSITRON SCF ===== 2015/11/28
  subroutine m_epc_ESlhxc_potential_mod(nfout)    ! for scf
    integer, intent(in)       :: nfout

    integer :: is,ik,i,it
    integer :: ist
    integer :: id_sname = -1

    vlhxc_p = 0.d0
    ist = ista_kngp

    if(ist == 1) ist = 2
    do is = 1, nspin
       do ik = 1, kimg
          if(mype==0) vlhxc_p(1,ik,is)   = vepc_l(1,ik,is)
          if(nspin == 1) then
             do i = ist, iend_kngp  !for mpi
                vlhxc_p(i,ik,is) = vepc_l(i,ik,is) &
                     &            -PAI4 *chgq_l(i,ik,is) /gr_l(i)**2
             end do
          else if(nspin == 2) then
             do i = ist, iend_kngp  !for mpi
                vlhxc_p(i,ik,is) = vepc_l(i,ik,is) &
                     &           -PAI4*( chgq_l(i,ik,UP)&
                     &                  +chgq_l(i,ik,DOWN) )/gr_l(i)**2
             end do
          endif
          do it = 1,ntyp
             do i = ista_kngp, iend_kngp  !for mpi
                vlhxc_p(i,ik,is) = vlhxc_p(i,ik,is) &
                     &            -psc_l(i,it) *zfm3_l(i,it,ik)
             end do
          end do
       end do
    end do

  end subroutine m_epc_ESlhxc_potential_mod
! ============== 2015/11/28

end module m_epc_potential

      SUBROUTINE PDLAED3( ICTXT, K, N, NB, D, DROW, DCOL, RHO, DLAMDA,
     $                    W, Z, U, LDU, BUF, INDX, INDCOL, INDROW,
     $                    INDXR, INDXC, CTOT, NPCOL, INFO )
      USE OMP_LIB
*
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
      INTEGER            DCOL, DROW, ICTXT, INFO, K, LDU, N, NB, NPCOL
      DOUBLE PRECISION   RHO
*     ..
*     .. Array Arguments ..
      INTEGER            CTOT( 0: NPCOL-1, 4 ), INDCOL( * ),
     $                   INDROW( * ), INDX( * ), INDXC( * ), INDXR( * )
      DOUBLE PRECISION   BUF( 1:3*K ), D( * ), DLAMDA( * ), U( LDU, * ),
!      DOUBLE PRECISION   BUF( * ), D( * ), DLAMDA( * ), U( LDU, * ),
     $                   W( * ), Z(1:K)
!     $                   W( * ), Z( * )
*     ..
*
*  Purpose
*  =======
*
*  PDLAED3_X finds the roots of the secular equation, as defined by the
*  values in D, W, and RHO, between 1 and K.  It makes the
*  appropriate calls to SLAED4
*
*  This code makes very mild assumptions about floating point
*  arithmetic. It will work on machines with a guard digit in
*  add/subtract, or on those binary machines without guard digits
*  which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or Cray-2.
*  It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  ICTXT  (global input) INTEGER
*         The BLACS context handle, indicating the global context of
*         the operation on the matrix. The context itself is global.
*
*  K      (output) INTEGER
*         The number of non-deflated eigenvalues, and the order of the
*         related secular equation. 0 <= K <=N.
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  NB      (global input) INTEGER
*          The blocking factor used to distribute the columns of the
*          matrix. NB >= 1.
*
*  D      (input/output) DOUBLE PRECISION array, dimension (N)
*         On entry, D contains the eigenvalues of the two submatrices to
*         be combined.
*         On exit, D contains the trailing (N-K) updated eigenvalues
*         (those which were deflated) sorted into increasing order.
*
*  DROW   (global input) INTEGER
*          The process row over which the first row of the matrix D is
*          distributed. 0 <= DROW < NPROW.
*
*  DCOL   (global input) INTEGER
*          The process column over which the first column of the
*          matrix D is distributed. 0 <= DCOL < NPCOL.
*
*  Q      (input/output) DOUBLE PRECISION array, dimension (LDQ, N)
*         On entry, Q contains the eigenvectors of two submatrices in
*         the two square blocks with corners at (1,1), (N1,N1)
*         and (N1+1, N1+1), (N,N).
*         On exit, Q contains the trailing (N-K) updated eigenvectors
*         (those which were deflated) in its last N-K columns.
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= max(1,NQ).
*
*  RHO    (global input/output) DOUBLE PRECISION
*         On entry, the off-diagonal element associated with the rank-1
*         cut which originally split the two submatrices which are now
*         being recombined.
*         On exit, RHO has been modified to the value required by
*         PDLAED3_X.
*
*  DLAMDA (global output) DOUBLE PRECISION array, dimension (N)
*         A copy of the first K eigenvalues which will be used by
*         SLAED3 to form the secular equation.
*
*  W      (global output) DOUBLE PRECISION array, dimension (N)
*         The first k values of the final deflation-altered z-vector
*         which will be passed to SLAED3.
*
*  Z      (global input) DOUBLE PRECISION array, dimension (N)
*         On entry, Z contains the updating vector (the last
*         row of the first sub-eigenvector matrix and the first row of
*         the second sub-eigenvector matrix).
*         On exit, the contents of Z have been destroyed by the updating
*         process.
*
*  U     (global output) DOUBLE PRECISION array
*         global dimension (N, N), local dimension (LDU, NQ).
*         Q  contains the orthonormal eigenvectors of the symmetric
*         tridiagonal matrix.
*
*  LDU    (input) INTEGER
*         The leading dimension of the array U.
*
*  QBUF   (workspace) DOUBLE PRECISION array, dimension 3*N
*
*
*  INDX   (workspace) INTEGER array, dimension (N)
*         The permutation used to sort the contents of DLAMDA into
*         ascending order.
*
*  INDCOL (workspace) INTEGER array, dimension (N)
*
*
*  INDROW (workspace) INTEGER array, dimension (N)
*
*
*  INDXR (workspace) INTEGER array, dimension (N)
*
*
*  INDXC (workspace) INTEGER array, dimension (N)
*
*  CTOT   (workspace) INTEGER array, dimension( NPCOL, 4)
*
*  NPCOL   (global input) INTEGER
*          The total number of columns over which the distributed
*           submatrix is distributed.
*
*  INFO   (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  The algorithm failed to compute the ith eigenvalue.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            COL, GI, I, IINFO, IIU, IPD, IU, J, JJU, JU,
     $                   KK, KL, KLC, KLR, MYCOL, MYKL, MYKLR, MYROW,
     $                   NPROW, PDC, PDR, ROW
      DOUBLE PRECISION   AUX, TEMP
      REAL(8) :: SZ(1:K), SBUF(1:K)
      INTEGER :: SINFO
*     ..
*     .. External Functions ..
      INTEGER            INDXG2L
      DOUBLE PRECISION   DLAMC3, DNRM2
      EXTERNAL           INDXG2L, DLAMC3, DNRM2
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, DCOPY, DGEBR2D, DGEBS2D,
     $                   DGERV2D, DGESD2D, DLAED4
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MOD, SIGN, SQRT
*     ..
      include 'mpif.h'
      include 'trd.h'
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
*     Quick return if possible
*
      IF( K.EQ.0 )
     $   RETURN
*
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
      ROW = DROW
      COL = DCOL
!$OMP PARALLEL DO PRIVATE(I,J,ROW,COL)
      DO 20 I = 1, N, NB
         ROW = MOD(DROW+(I-1)/NB, NPROW)
         COL = MOD(DCOL+(I-1)/NB, NPCOL)
         DO 10 J = 0, NB - 1
            IF( I+J.LE.N ) THEN
               INDROW( I+J ) = ROW
               INDCOL( I+J ) = COL
            END IF
   10    CONTINUE
!         ROW = MOD( ROW+1, NPROW )
!         COL = MOD( COL+1, NPCOL )
   20 CONTINUE
!$OMP END PARALLEL DO
         ROW = MOD(DROW+(NB-1)/NB+1, NPROW)
         COL = MOD(DCOL+(NB-1)/NB+1, NPCOL)
*
      MYKL = CTOT( MYCOL, 1 ) + CTOT( MYCOL, 2 ) + CTOT( MYCOL, 3 )
      KLR = MYKL / NPROW
      IF( MYROW.EQ.DROW ) THEN
         MYKLR = KLR + MOD( MYKL, NPROW )
      ELSE
         MYKLR = KLR
      END IF
      PDC = 1
      COL = DCOL
   30 CONTINUE
      IF( MYCOL.NE.COL ) THEN
         PDC = PDC + CTOT( COL, 1 ) + CTOT( COL, 2 ) + CTOT( COL, 3 )
         COL = MOD( COL+1, NPCOL )
         GO TO 30
      END IF
      PDR = PDC
      KL = KLR + MOD( MYKL, NPROW )
      ROW = DROW
   40 CONTINUE
      IF( MYROW.NE.ROW ) THEN
         PDR = PDR + KL
         KL = KLR
         ROW = MOD( ROW+1, NPROW )
         GO TO 40
      END IF
*
!$OMP PARALLEL DO
      DO I = 1, K
         DLAMDA( I ) = DLAMC3( DLAMDA( I ), DLAMDA( I ) ) - DLAMDA( I )
         Z( I ) = ONE
      END DO
!$OMP END PARALLEL DO

      IF( MYKLR.GT.0 ) THEN
!-         KK = PDR
         SINFO = INFO
!$OMP PARALLEL PRIVATE(I,J,KK,IINFO,SZ,SBUF,SINFO,AUX)

         SZ( 1:K ) = ONE
!$OMP DO
         DO 80 I = 1, MYKLR
            KK = PDR + I - 1
            CALL DLAED4( K, KK, DLAMDA, W, SBUF, RHO, AUX, IINFO )
            BUF(K+I) = AUX
            IF( IINFO.NE.0 ) THEN
               SINFO = KK
            END IF
*
*     ..Compute part of z
*
            DO 60 J = 1, KK - 1
               SZ( J ) = SZ( J )*( SBUF( J ) /
     $                  ( DLAMDA( J )-DLAMDA( KK ) ) )
   60       CONTINUE
            SZ( KK ) = SZ( KK )*SBUF( KK )
            DO 70 J = KK + 1, K
               SZ( J ) = SZ( J )*( SBUF( J ) /
     $                  ( DLAMDA( J )-DLAMDA( KK ) ) )
   70       CONTINUE
!            KK = KK + 1
   80    CONTINUE
!$OMP ENDDO

!$OMP BARRIER

!$OMP MASTER
         Z(1:K) = SZ(1:K)
         INFO = SINFO
!$OMP END MASTER

!$OMP BARRIER

         DO I=1,OMP_GET_NUM_THREADS()-1
            IF ( OMP_GET_THREAD_NUM() == I ) THEN
               DO J=1,K
                  Z(J) = Z(J) * SZ(J)
               END DO
               INFO = MAX(INFO, SINFO)
            END IF
!$OMP BARRIER
         END DO

!$OMP END PARALLEL
      ELSE

         Z(1:K) = ONE

      END IF
*
      call MPI_ALLREDUCE( Z, BUF, K, MPI_DOUBLE_PRECISION,
     $                    MPI_PROD, TRD_COMM_WORLD, I )

!$OMP PARALLEL DO
      DO I = 1, K
         Z( I ) = SIGN( SQRT( -BUF( I ) ), W( I ) )
      END DO
!$OMP END PARALLEL DO
      
      IF( MYKLR.GT.0 ) THEN
         IF( MYROW.NE.DROW ) THEN
            call send_dbl( BUF( K+1 ), MYKLR,
     $                     DROW+NPROW*MYCOL+1, TRD_COMM_WORLD )
         ELSE
            IPD = 2*K + 1
            CALL DCOPY( MYKLR, BUF( K+1 ), 1, BUF( IPD ), 1 )
            IF( KLR.GT.0 ) THEN
               IPD = MYKLR + IPD
               ROW = MOD( DROW+1, NPROW )
               DO I = 1, NPROW - 1
                  call recv_dbl( BUF( IPD ), KLR,
     $                     ROW+NPROW*MYCOL+1, TRD_COMM_WORLD )
                  IPD = IPD + KLR
                  ROW = MOD( ROW+1, NPROW )
               END DO
            END IF
         END IF
      END IF
*
      IF( MYROW.EQ.DROW ) THEN
         IF( MYCOL.NE.DCOL .AND. MYKL.NE.0 ) THEN
            CALL DCOPY( MYKL, BUF( 2*K+1 ), 1, BUF( K+1 ), 1 )
            call send_dbl( BUF( K+1 ), MYKL,
     $                     MYROW+NPROW*DCOL+1, TRD_COMM_WORLD )
         ELSE IF( MYCOL.EQ.DCOL ) THEN
            IPD = 2*K + 1
            COL = DCOL
            KL = MYKL
            DO I = 1, NPCOL - 1
               IPD = IPD + KL
               COL = MOD( COL+1, NPCOL )
               KL = CTOT( COL, 1 ) + CTOT( COL, 2 ) + CTOT( COL, 3 )
               IF( KL.NE.0 ) THEN
                  call recv_dbl( BUF( IPD ), KL,
     $                     MYROW+NPROW*COL+1, TRD_COMM_WORLD )
               END IF
            END DO
            CALL DCOPY( K, BUF( 2*K+1 ), 1, BUF( K+1 ), 1 )
         END IF
      END IF
*
*     Diffusion
*
      CALL bcast_dbl( BUF(K+1), K, DROW+NPROW*DCOL+1, TRD_COMM_WORLD )
*
*     Copy of D at the good place
*
      KLC = 0
      KLR = 0
      DO 140 I = 1, K
         GI = INDX( I )
         D( GI ) = BUF( K+I )
         COL = INDCOL( GI )
         ROW = INDROW( GI )
         IF( COL.EQ.MYCOL ) THEN
            KLC = KLC + 1
            INDXC( KLC ) = I
         END IF
         IF( ROW.EQ.MYROW ) THEN
            KLR = KLR + 1
            INDXR( KLR ) = I
         END IF
  140 CONTINUE
*
*     Compute eigenvectors of the modified rank-1 modification.
*
      IF( MYKL.NE.0 ) THEN
!$OMP PARALLEL DO PRIVATE(I,J,KK,IU,JU,IIU,JJU,BUF,AUX,TEMP,IINFO)
!$+ REDUCTION(MAX:INFO)
         DO 180 J = 1, MYKL
            KK = INDXC( J )
            JU = INDX( KK )
            JJU = INDXG2L( JU, NB, J, J, NPCOL )
            CALL DLAED4( K, KK, DLAMDA, W, BUF, RHO, AUX, IINFO )
            IF( IINFO.NE.0 ) THEN
               INFO = KK
            END IF
            IF( K.EQ.1 .OR. K.EQ.2 ) THEN
               DO 150 I = 1, KLR
                  KK = INDXR( I )
                  IU = INDX( KK )
                  IIU = INDXG2L( IU, NB, J, J, NPROW )
                  U( IIU, JJU ) = BUF( KK )
  150          CONTINUE
               GO TO 180
            END IF
*
            DO 160 I = 1, K
               BUF( I ) = Z( I ) / BUF( I )
  160       CONTINUE
            TEMP = DNRM2( K, BUF, 1 )
            DO 170 I = 1, KLR
               KK = INDXR( I )
               IU = INDX( KK )
               IIU = INDXG2L( IU, NB, J, J, NPROW )
               U( IIU, JJU ) = BUF( KK ) / TEMP
  170       CONTINUE
*
  180    CONTINUE
!$OMP END PARALLEL DO
      END IF
*
  190 CONTINUE
*
      RETURN
*
*     End of PDLAED3_X
*
      END

!================================================
!  Software name : STM
!  Module : m_Crystal_Structure
!  Subroutine(s) : m_CS_rd_neg_and_zl
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_Crystal_Structure
! $Id: m_Crystal_Structure.f90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  implicit none
  integer :: neg
  real    :: zl
contains
  subroutine m_CS_rd_neg_and_zl(nfinp)
    integer, intent(in) :: nfinp
    read(nfinp,*) neg,zl
  end subroutine m_CS_rd_neg_and_zl
end module m_Crystal_Structure

program wan_iterp
  implicit none
  integer, parameter :: DP = 8
  real(kind=DP), parameter :: PAI  = 3.141592653589793238462D0
  real(kind=DP), parameter :: PAI2 = PAI*2.d0, PAI4 = PAI*4.d0
  real(kind=DP), parameter :: Hartree = 27.21139615d0

  integer :: num_wan, nrpts, num_band_kpt
  integer, allocatable :: ndegen(:), ipos(:,:)
  real(kind=DP) :: efermi
  real(kind=DP), allocatable :: kpt_band(:,:)
  complex(kind=DP), allocatable :: hmat(:,:,:)
  character(len=128) :: seedname

  if(iargc()<1) then
     stop 'wan_interp.x seedname'
  end if
  call getarg(1,seedname)

!  call read_file_nnkp
  call read_file_hr
  call read_file_kpoint
  call read_file_efermi
  call calc_energy_band

contains

  subroutine read_file_nnkp
    integer, parameter :: nfwannier = 10
    integer :: i, nkpt
    real(kind=DP) :: altv(3,3), rltv(3,3)
    real(kind=DP), allocatable :: kvec(:,:)

    open(nfwannier,file=trim(seedname)//".nnkp")
    do i=1,5
       read(nfwannier,*)
    end do
    read(nfwannier,*) altv(1:3,1)
    read(nfwannier,*) altv(1:3,2)
    read(nfwannier,*) altv(1:3,3)
    read(nfwannier,*);     read(nfwannier,*);     read(nfwannier,*)
    read(nfwannier,*) rltv(1:3,1)
    read(nfwannier,*) rltv(1:3,2)
    read(nfwannier,*) rltv(1:3,3)
    read(nfwannier,*);     read(nfwannier,*);     read(nfwannier,*)
    read(nfwannier,*) nkpt

    allocate(kvec(3,nkpt))
    do i=1,nkpt
       read(nfwannier,*) kvec(1:3,i)
    end do
    close(nfwannier)
    
    write(*,'("Lattice vectors:")')
    do i=1,3
       write(*,'(3(1x,f10.5))') altv(1:3,i)
    end do
    write(*,'("Reciprocal lattice vectors:")')
    do i=1,3
       write(*,'(3(1x,f10.5))') rltv(1:3,i)
    end do
    write(*,'("k-points: nkpt=",i5)') nkpt
    do i=1,nkpt
       write(*,'(3(1x,f10.5))') kvec(1:3,i)
    end do
!
    deallocate( kvec )

  end subroutine read_file_nnkp

  subroutine read_file_hr
    integer, parameter :: nfwannier = 10

    integer :: ir, j, i, id, jd
    real(kind=DP) :: hr, hi

    open(nfwannier,file=trim(seedname)//"_hr.dat")
    read(nfwannier,*)
    read(nfwannier,*) num_wan
    read(nfwannier,*) nrpts
    allocate(ndegen(nrpts))
    allocate(hmat(num_wan,num_wan,nrpts))
    allocate(ipos(3,nrpts))
    read(nfwannier,*) ndegen(1:nrpts)
    do ir=1,nrpts 
       do j=1,num_wan
          do i=1,num_wan
             read(nfwannier,*) ipos(1:3,ir),id,jd, hr, hi 
             hmat(i,j,ir) = cmplx(hr,hi)
          end do
       end do
    end do
    close(nfwannier)

    write(*,'("Hamiltonian matrix in the WF basis:")')
    do ir=1,nrpts 
       do j=1,num_wan
          do i=1,num_wan
             write(*,'(5i5,2f10.6)') ipos(1:3,ir),i,j,hmat(i,j,ir)
          end do
       end do
    end do
  end subroutine read_file_hr

  subroutine read_file_kpoint
    integer                    :: fn_number_of_words
    integer,     parameter     :: len_str = 80
    integer, parameter :: nfkpoint = 10

    integer :: ikx,iky,ikz,idk, nwei, i
    character(len=len_str)     :: str

    open(nfkpoint,file="kpoint.data")
    read(nfkpoint,'(a80)') str

    select case (fn_number_of_words(str))
    case (0)
       stop ' error in reading of the nfkpoint file'
    case (1)
       read(str,*) num_band_kpt
       nwei = num_band_kpt

    case (2)
       read(str,*) num_band_kpt, nwei
    end select

    write(*,*) 'num_band_kpt =', num_band_kpt

    allocate(kpt_band(3,num_band_kpt));  kpt_band = 0.0d0

    select case (fn_number_of_words(str))
    case (1)
       do i=1,num_band_kpt
          read(nfkpoint,*) kpt_band(1:3,i)
       end do
    case (2)
       do i=1,num_band_kpt
          read(nfkpoint,*) ikx,iky,ikz,idk
          kpt_band(1,i) = real(ikx)/real(idk)
          kpt_band(2,i) = real(iky)/real(idk)
          kpt_band(3,i) = real(ikz)/real(idk)
       end do
    end select

    close( nfkpoint )
  end subroutine read_file_kpoint
!
  subroutine read_file_efermi
    integer, parameter :: nfefermi = 10

    efermi = 0.d0
    open(nfefermi,file="nfefermi.data")
    read(nfefermi,*) efermi
    close(nfefermi)
  end subroutine read_file_efermi

  subroutine calc_energy_band
    integer, parameter :: nfeng = 10

    integer :: i, nspin
    real(kind=DP), allocatable :: eig(:)
    complex(kind=DP), allocatable :: umat(:,:)

    nspin = 1
    open(nfeng,file="nfenergy.data")
    write(nfeng,'(" num_kpoints = ",i6)') num_band_kpt
    write(nfeng,'(" num_bands   = ",i6)') num_wan
    write(nfeng,'(" nspin       = ",i6)') nspin
    write(nfeng,'(" Fermi energy level = ",f10.5)') efermi
    write(nfeng,*)
    
    allocate(eig(num_wan))
    allocate(umat(num_wan,num_wan))
    do i=1,num_band_kpt
       call solve_hmat_k(kpt_band(1,i),eig(1),umat(1,1))
       write(nfeng,'("=== energy_eigen_values ===")')
       write(nfeng,'(" ik = ",i6," (",3f10.6," )")') i,kpt_band(1:3,i)
       write(nfeng,'(4f18.10)') eig(1:num_wan)/Hartree
    end do
    close(nfeng)

    deallocate( hmat, umat, eig )
    
  end subroutine calc_energy_band

  subroutine solve_hmat_k(kpt,eig,umat)
    implicit none
    real(kind=DP), intent(in) :: kpt(3)
    real(kind=DP), intent(out) :: eig(num_wan)
    complex(kind=DP), intent(out) :: umat(num_wan,num_wan)
 
    integer :: i,j,ir
    real(kind=DP) :: ph
    complex(kind=DP) :: zf
    complex(kind=DP), allocatable :: hmat_k(:,:)

    character(len=1) :: JOBZ,UPLO
    integer :: lwork, lrwork, info
    complex(kind=DP),allocatable,dimension(:) :: work
    real(kind=DP),allocatable,dimension(:) :: rwork

    allocate(hmat_k(num_wan,num_wan))

    hmat_k = cmplx(0.d0,0.d0)
    do j=1,num_wan
       do i=1,num_wan
          do ir=1,nrpts
             ph = PAI2 * dot_product(kpt,real(ipos(1:3,ir),DP))
             zf = cmplx(cos(ph),sin(ph))/real(ndegen(ir),DP)
             hmat_k(i,j) = hmat_k(i,j) + zf * hmat(i,j,ir)
          end do
       end do
    end do

    JOBZ = 'V'
    UPLO = 'U'
    lwork = max(1,2*num_wan-1)
    lrwork = max(3*num_wan-2,1)

    allocate(work(lwork))
    allocate(rwork(lrwork))
    umat = hmat_k
    call zheev(JOBZ,UPLO,num_wan,umat,num_wan,eig,work,lwork,rwork,info)
    deallocate(work)
    deallocate(rwork)

    deallocate(hmat_k)
  end subroutine solve_hmat_k
  
end program wan_iterp

function fn_number_of_words(string)
  implicit none

  integer :: fn_number_of_words
  character(*),intent(in) :: string
  integer        :: ipos, lpos
  character(256) :: tmp_string
  tmp_string = string
  lpos       = len(tmp_string)
  fn_number_of_words = 0

  if (lpos == 0) goto 99

  tmp_string = adjustl(tmp_string)
  if (index(tmp_string,' ') == 1) goto 99

  do while (index(tmp_string,' ') > 1)
     fn_number_of_words = fn_number_of_words + 1
     ipos               = index(tmp_string,' ')
     if (ipos == 0) goto 99
     tmp_string = adjustl(tmp_string(ipos:lpos))
     tmp_string = adjustl(tmp_string)
  end do
99 continue

end function fn_number_of_words

!*********************************************************
!* 逆空間でのクーロン力を遮蔽するポテンシャルを作成するモジュールの
!* FFTサブモジュール
!*********************************************************

! PHASE の m_FFT.F90 からコードを拝借。
! kimg=1の空間反転対称の条件でコードを簡素化。
! 密度のFFTルーチンのみでコードを簡素化。

#ifdef CD_JRCATFFT
# define CD_JRCATFFTg
#endif

#ifdef CD_JRCATFFT_WS
# define CD_JRCATFFTg
#endif

#ifndef ASLFFT
# ifndef DECFFT
#  ifndef MKLFFT
#   ifndef FFTW3
#    ifndef CD_JRCATFFTg
#     define CD_IFFT
#    endif
#   endif
#  endif
# endif
#endif

!module m_Const_Parameters
!  integer, parameter :: DP = kind(1.d0)
!  integer, parameter :: CMPLDP = kind((1.d0, 0.d0))
!  integer, parameter :: OUTER = 1
!end module

module m_Screening_FFT
#ifdef MKLFFT
  use MKL_DFTI 
#endif

  use m_Const_Parameters, only : DP, CMPLDP, OUTER

  implicit none


  integer, dimension(3,0:1) :: fft_box_size_CD
  integer                   :: nfftp
  integer, private          :: istat = 0

  real(kind=DP),allocatable,dimension(:) :: afft_CD
#ifndef DECFFT
# ifndef MKLFFT
#  ifndef FFTW3

#   ifdef ASLFFT
  real(kind=DP),private,allocatable,dimension(:)           :: trigs_CD
  integer,      private,allocatable,dimension(:)           ::ifax_CD
#   else
  complex(kind=CMPLDP),private,allocatable,dimension(:)    :: wlp,wmp,wnp
  integer,             private,allocatable,dimension(:,:)  :: iwork
  integer, private                                         :: iopt = 0
#   endif
! /* ASLFFT */ 

#  endif
! /* FFTW3 */
# endif
! /* MKLFFT */
#endif
! /* DECFFT */

#ifdef MKLFFT
  type(DFTI_DESCRIPTOR), POINTER :: dh_CD 
  type(DFTI_DESCRIPTOR), POINTER :: dh_CD_back
  integer :: strides(4), Status
  complex(DP), allocatable :: cwork_mkl(:)
#endif

#ifdef FFTW3
  integer(8) :: plan_CD(2)
#endif

#ifdef CD_JRCATFFTg
  real(kind=DP),private,allocatable,dimension(:) :: ftw
#elif GOEDECKER_FFT
  real(kind=DP),private,allocatable,dimension(:) :: ftw
#elif SRFFT
  real(kind=DP),private,allocatable,dimension(:) :: ftw
#elif ASLFFT
  real(kind=DP),private,allocatable,dimension(:) :: ftw
#elif FFTW3
  real(kind=DP),private,allocatable,dimension(:) :: ftw
#endif

!  include 'mpif.h'
!#ifdef FFTE
!  include 'ffte.h'
!#endif

#ifdef FFTW3
  integer, parameter :: FFTW_ESTIMATE=64
#endif
contains

#ifndef DECFFT
# ifndef MKLFFT
#  ifndef FFTW3

  subroutine screening_fft_CD_work_alloc
    integer :: nid,nnl,nnm,nnn
    nid = fft_box_size_CD(1,0);  nnl = fft_box_size_CD(1,1)
    nnm = fft_box_size_CD(2,1);  nnn = fft_box_size_CD(3,1)
#   ifdef CD_IFFT
    allocate(wlp(3*nnl+7), stat=istat)
    allocate(wmp(2*nnm*(nid+1)+7), stat=istat)
    allocate(wnp(2*nnn+7), stat=istat)
    allocate(iwork(2,nnl+nnm+nnn), stat=istat)
#   elif CD_JRCATFFT
    allocate(wlp(nnl), stat=istat)
    allocate(wmp(nnm), stat=istat)
    allocate(wnp(nnn), stat=istat)
#   elif CD_JRCATFFT_WS
    allocate(wlp(nnl), stat=istat)
    allocate(wmp(nnm), stat=istat)
    allocate(wnp(nnn), stat=istat)
#   elif ASLFFT
    allocate(trigs_CD(nnl+2*(nnm+nnn)), stat=istat)
    allocate(ifax_CD(60), stat=istat)
#   endif
  end subroutine screening_fft_CD_work_alloc
#  endif 
! /* <- FFTW3 */
# endif 
! /* <- MKLFFT */
#endif 
! /* <- DECFFT */

  subroutine m_Screening_FFT_alloc_CD_box
#ifndef DECFFT
# ifndef MKLFFT
#  ifndef FFTW3
    integer :: nid,nnl,nnm,nnn
    nid  = fft_box_size_CD(1,0);  nnl  = fft_box_size_CD(1,1)
    nnm  = fft_box_size_CD(2,1);  nnn  = fft_box_size_CD(3,1)
#   ifdef CD_JRCATFFT_WS
    allocate(ftw(nfftp*2), stat=istat)
#   elif  CD_JRCATFFT
    allocate(ftw(nfftp), stat=istat)
#   elif  ASLFFT
    allocate(ftw(nfftp), stat=istat)
#   endif

#  endif
# endif
#endif
    allocate(afft_CD(nfftp), stat=istat)
  end subroutine m_Screening_FFT_alloc_CD_box

  subroutine m_Screening_FFT_dealloc_CD_box
#ifndef DECFFT
# ifndef MKLFFT
#  ifndef FFTW3
    if(allocated(ftw)) then
       deallocate(ftw, stat=istat)
    end if
#  endif
# endif
#endif
    deallocate(afft_CD, stat=istat)
  end subroutine m_Screening_FFT_dealloc_CD_box

  subroutine m_Screening_FFT_set_box_sizes(n_rGpv,outer_or_inner)
    integer,intent(in),dimension(3) :: n_rGpv
    integer,intent(in)              :: outer_or_inner

    integer :: i, ip
    do i = 1, 3
!  -- FFT box size for Charge Density --
       ip = n_rGpv(i)
#ifdef GOEDECKER_FFT
       if(mod(ip,2) == 1) ip = ip + 1
#endif
#ifdef _PFFT_
       call decomp3p_2(ip,fft_box_size_CD(i,1))
#else
       call decomp3_2(outer_or_inner,ip,fft_box_size_CD(i,1))
#endif
    end do

  end subroutine m_Screening_FFT_set_box_sizes

  subroutine decomp3_2(oi,i,j)
    integer, intent(in)  :: oi, i
    integer, intent(out) :: j
    integer :: ipm, iab, ik, imini
    imini = i*189/200+1

    if(oi == OUTER) then
       ipm = +1
    else
       ipm = -1
    endif
100 iab=-1
110 iab=iab+1
    ik= i+ipm*iab
    if(ik < imini) then
       ipm=1
       goto 100
    end if
    j = ik*2
120 continue
    if(mod(j,2) == 0) then
       j=j/2
       goto 120
    else if(mod(j,3) == 0) then
       j=j/3
       goto 120
    else if(mod(j,5) == 0) then
       j=j/5
       goto 120
    else if(j == 1) then
       goto 130
    else
       goto 110
    end if
130 ik= i+ipm*iab
    j  = ik*2
  end subroutine decomp3_2



#ifdef _PFFT_
  subroutine decomp3p_2(i,j)
    integer, intent(in)  :: i
    integer, intent(out) :: j

    integer :: iab, ik

    iab=-1
110 iab=iab+1
    ik = i+iab

    j  = ik*2
120 continue
    if(mod(j,2) == 0) then
       j=j/2
       goto 120
    else if(mod(j,3) == 0) then
       j=j/3
       goto 120
    else if(mod(j,5) == 0) then
       j=j/5
       goto 120
    else if(j == 1) then
       goto 130
    else
       goto 110
    end if
130 ik= i+iab
    j  = ik*2
  end subroutine decomp3p_2
#endif



  subroutine m_Screening_FFT_setup(inversion_symmetry,paramset)
    integer, intent(in)           :: inversion_symmetry
    logical, intent(in), optional :: paramset

    integer :: nfft_t
    integer :: id_sname = -1

#ifdef ASLFFT
    if(mod(fft_box_size_CD(1,1),4) == 2) then
       fft_box_size_CD(1,0) = fft_box_size_CD(1,1) + 4
    else
       fft_box_size_CD(1,0) = fft_box_size_CD(1,1) + 2
    end if
    fft_box_size_CD(2:3,0) = fft_box_size_CD(2:3,1) + 1
#else
    fft_box_size_CD(1,0) = fft_box_size_CD(1,1) + 2
    fft_box_size_CD(2:3,0) = fft_box_size_CD(2:3,1)

    nfftp=   product(fft_box_size_CD(1:3,0)) * (2-inversion_symmetry)
#endif
    
#ifndef DECFFT
# ifndef MKLFFT
#  ifndef FFTW3
    call screening_fft_CD_work_alloc     ! <cw[123],cw[123]_pstrn,wlp,wmp,wnp> are allocated
#  endif
# endif
#endif

! Initialization of the Charge-Density FFT
#ifndef DECFFT
# ifndef MKLFFT
       call m_Screening_FFT_alloc_CD_box()       ! <ftw> is allocated
# endif
#endif
       call init_scr_fft_coef_arrays_CD()

#ifndef DECFFT
# ifndef MKLFFT
       call m_Screening_FFT_dealloc_CD_box()
# endif
#endif

  contains

    subroutine init_scr_fft_coef_arrays_CD
      integer :: id, nl, nm, nn, ierr
#ifdef ASLFFT
      integer :: id2, id3
#endif
   !  ---> FFT for Charge density
      id = fft_box_size_CD(1,0)
#ifdef ASLFFT
      id2 = fft_box_size_CD(2,0)
      id3 = fft_box_size_CD(3,0)
#endif
      nl = fft_box_size_CD(1,1)
      nm = fft_box_size_CD(2,1)
      nn = fft_box_size_CD(3,1)
#ifdef CD_IFFT
      call r3fft(afft_CD,id,nl,nm,nn,wlp,wmp,wnp,0,0,1,ftw,ierr)
#elif DECFFT
      call cd_init(id,nl,nm,nn)
#elif MKLFFT
      Status = DftiCreateDescriptor( dh_CD, DFTI_DOUBLE, &
           & DFTI_REAL, 3, fft_box_size_CD(1,1))
      Status = DftiCreateDescriptor( dh_CD_back, DFTI_DOUBLE, &
           & DFTI_REAL, 3, fft_box_size_CD(1,1))
      Status = DftiSetValue( dh_CD, DFTI_PLACEMENT, DFTI_NOT_INPLACE)
      Status = DftiSetValue( dh_CD_back, DFTI_PLACEMENT, DFTI_NOT_INPLACE)
      Status = DftiSetValue( dh_CD, DFTI_CONJUGATE_EVEN_STORAGE, DFTI_COMPLEX_COMPLEX)
      Status = DftiSetValue( dh_CD_back, DFTI_CONJUGATE_EVEN_STORAGE, DFTI_COMPLEX_COMPLEX)
   !!$Status = DftiSetValue( dh_CD, DFTI_FORWARD_DOMAIN, DFTI_COMPLEX)
   !!$Status = DftiCopyDescriptor( dh_CD, dh_CD_back)
      strides(1) = 0
      strides(2) = 1
      strides(3) = id/2
      strides(4) = id/2*fft_box_size_CD(2,0)
      Status = DftiSetValue(dh_CD, DFTI_INPUT_STRIDES, strides)
      Status = DftiSetValue(dh_CD_back, DFTI_OUTPUT_STRIDES, strides)
      strides(1) = 0
      strides(2) = 1
      strides(3) = id
      strides(4) = id*fft_box_size_CD(2,0)
      Status = DftiSetValue(dh_CD, DFTI_OUTPUT_STRIDES, strides)
      Status = DftiSetValue(dh_CD_back, DFTI_INPUT_STRIDES, strides)
      Status = DftiCommitDescriptor( dh_CD )
      Status = DftiCommitDescriptor( dh_CD_back )
#elif FFTW3
      ! Forward FFT
      call dfftw_plan_dft_c2r_3d(plan_CD(1) &
           &                       ,nl,nm,nn &
           &                       ,afft_CD(1),afft_CD(1) &
           &                       ,FFTW_ESTIMATE)
      ! Inverse FFT
      call dfftw_plan_dft_r2c_3d(plan_CD(2) &
           &                       ,nl,nm,nn &
           &                       ,afft_CD(1),afft_CD(1) &
           &                       ,FFTW_ESTIMATE)
#elif ASLFFT
      call dfr3fb(nl,nm,nn,afft_CD,id,id2,id3,0,ifax_CD,trigs_CD,ftw,ierr)
#else
# ifdef CD_JRCATFFTg
      call jrcat_r3ft(afft_CD,ftw,id,nl,nm,nn,wlp,wmp,wnp,0,0,0,0)
# endif
#endif
    end subroutine init_scr_fft_coef_arrays_CD

  end subroutine m_Screening_FFT_setup


  subroutine m_Screening_FFT_CD_inverse(nfout,afft)  ! G space --> R space
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(1:nfftp)
    integer :: idp,nlp, nmp, nnp, ier1 = 0
    integer :: id_sname = -1
#ifdef MKLFFT
    integer :: i
#endif
#ifdef ASLFFT
    integer :: idp2,idp3
#endif

#ifdef GOEDECKER_FFT
    integer :: nd2p, nd3p, inzee, isign
#endif

#ifdef CD_JRCATFFTg
    integer :: kc1 = 0, kc2 = 0, kc3 = 0
#endif

    idp = fft_box_size_CD(1,0)
#ifdef ASLFFT
    idp2 = fft_box_size_CD(2,0)
    idp3 = fft_box_size_CD(3,0)
#endif
    nlp = fft_box_size_CD(1,1)
    nmp = fft_box_size_CD(2,1)
    nnp = fft_box_size_CD(3,1)
#ifdef GOEDECKER_FFT
    nd2p = fft_box_size_CD(2,0)
    nd3p = fft_box_size_CD(3,0)
#endif

    afft_CD = afft
#ifdef CD_JRCATFFTg
    call jrcat_r3ft(afft_CD,ftw,idp,nlp,nmp,nnp,wlp,wmp,wnp,kc1,kc2,kc3&
            & ,-2)
#endif
#ifdef DECFFT
    call cd_fft(1,idp,nmp,afft_CD)
#elif MKLFFT
    allocate(cwork_mkl(nfftp/2))
    Status = DftiComputeForward( dh_CD_back, afft_CD, cwork_mkl)
    do i=1,nfftp,2
       afft_CD(i) = dble(cwork_mkl(i/2+1))
       afft_CD(i+1) = dimag(cwork_mkl(i/2+1))
    end do
    deallocate(cwork_mkl)
#elif FFTW3
    call dfftw_execute_dft_r2c(plan_CD(2),afft_CD(1),afft_CD(1))
#endif
#ifdef ASLFFT
    call dfr3bf(nlp,nmp,nnp,afft_CD,idp,idp2,idp3,+1,ifax_CD,trigs_CD,ftw,ier1)
!!$    call sxfft_zero_padding(afft_CD,nlp,nmp,nnp,idp,idp2,idp3)
    call sxfft_zero_padding2(afft_CD,nlp,nmp,nnp,idp,idp2,idp3)
#endif
#ifdef CD_IFFT
    call r3fft(afft_CD,idp,nlp,nmp,nnp,wlp,wmp,wnp,iopt,-1,1,iwork,ier1)
#endif
    if (ier1 /= 0) then
       call phase_error_with_msg(nfout,'ier1/=0',__LINE__,__FILE__)
    end if

    afft(1:nfftp) = afft_CD(1:nfftp)

  end subroutine m_Screening_FFT_CD_inverse

#ifdef ASLFFT
subroutine sxfft_zero_padding2(afft,nl,nm,nn,nd1,nd2,nd3)
  implicit none
  real(kind=DP), intent(out) :: afft(*)
  integer, intent(in) :: nl,nm,nn
  integer, intent(in) :: nd1,nd2,nd3

  integer :: i,j,k,ip
  integer :: nlh,ndh

  integer :: imax 
  imax = nd1*nd2*nd3

  nlh = nl/2
  ndh = nd1/2
  do j = nlh+2, ndh
     do i = 1, nd2*nn
        ip = ndh*(i-1) + j
        afft(ip*2-1) = 0.d0
        afft(ip*2) = 0.d0
     end do
  end do
  do j = nm+1, nd2
     do k = 1, nd3
        do i = 1, ndh
           ip = i + ndh*(j-1) + ndh*nd2*(k-1)
           afft(ip*2-1) = 0.d0
           afft(ip*2) = 0.d0
        end do
     end do
  end do
  do k = nn+1, nd3
     do i = 1, ndh*nd2
        ip = i + ndh*nd2*(k-1)
        afft(ip*2-1) = 0.d0
        afft(ip*2) = 0.d0
     end do
  end do

end subroutine sxfft_zero_padding2
#endif

end module m_Screening_FFT

       subroutine tred1_local_2update(
     &               w, nm,
     &               ux, uy, vx, vy, nv,
     &               i_base, i, ix)
!
       implicit none
!
       integer, intent(in)    ::  nm, nv
       real(8), intent(inout) ::  w(1:nm,*)
       real(8), intent(in)    ::  ux(1:nv,*),uy(1:nv,*)
       real(8), intent(in)    ::  vx(1:nv,*),vy(1:nv,*)
       integer, intent(in)    ::  i_base, i, ix
!
       integer                ::  k_1
       integer                ::  j, k, l
!
       integer                ::  i_1, i_2, i_3, i_4
       integer                ::  j_1, j_2, j_3, j_4
       integer                ::  l_1, l_2, l_3, l_4
       integer                ::  jj_1, jj_2, jj_3, jj_4
       integer                ::  LX
!
       include 'trd.h'
       include 'param.h'
       include 'CSTAB.h'
!
       real(8)                :: u_x, v_x
       real(8)                :: uy0, vy0
       real(8)                :: uy1, vy1
       real(8)                :: uy2, vy2
       real(8)                :: uy3, vy3
       real(8)                :: w0
       real(8)                :: w1
       real(8)                :: w2
       real(8)                :: w3

          if ( i - i_base <= 1 ) return
!
          k_1 = 1
!
          LX  = L1_LSIZE*L1_WAY/16

          i_2 = loop_c_start(i_base+1, y_nnod,y_inod)
          i_3 = loop_c_end  (i-1,      y_nnod,y_inod)
          i_4 = MOD(i_3-i_2+1, 4)+i_2
          if ( i_2 > i_3 ) return
!
          L = ix - 1
          jj_2 = loop_c_start(1, x_nnod,x_inod)
          jj_3 = loop_c_end  (L, x_nnod,x_inod)

          do jj_1=jj_2,jj_3,LX
             j_2 = jj_1; j_3 = MIN(jj_1+LX-1, jj_3)
             do i_1=i_2,i_4-1                         ! 0
                j   = loop_c_l2g_depth(i_1, y_nnod,y_inod)
                l_1 = j-i_base
                uy0 = uy(i_1+0,k_1)
                vy0 = vy(i_1+0,k_1)
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
                do j_1=j_2,j_3
                   u_x = ux(j_1,k_1)
                   v_x = vx(j_1,k_1)
                   w0 = w(j_1,l_1+0*y_nnod)
                   w0 = w0
     &                    -(u_x*vy0)
                   w0 = w0
     &                    -(v_x*uy0)
                   w(j_1,l_1+0*y_nnod) = w0
                end do! j_1
             end do! l_1
             do i_1=i_4,i_3,4                     ! 3
                j   = loop_c_l2g_depth(i_1, y_nnod,y_inod)
                l_1 = j-i_base
                uy0 = uy(i_1+0,k_1)
                vy0 = vy(i_1+0,k_1)
                uy1 = uy(i_1+1,k_1)
                vy1 = vy(i_1+1,k_1)
                uy2 = uy(i_1+2,k_1)
                vy2 = vy(i_1+2,k_1)
                uy3 = uy(i_1+3,k_1)
                vy3 = vy(i_1+3,k_1)
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
                do j_1=j_2,j_3
                   u_x = ux(j_1,k_1)
                   v_x = vx(j_1,k_1)
                   w0 = w(j_1,l_1+0*y_nnod)
                   w1 = w(j_1,l_1+1*y_nnod)
                   w0 = w0
     &                    -(u_x*vy0)
                   w1 = w1
     &                    -(u_x*vy1)
                   w0 = w0
     &                    -(v_x*uy0)
                   w1 = w1
     &                    -(v_x*uy1)
                   w(j_1,l_1+0*y_nnod) = w0
                   w(j_1,l_1+1*y_nnod) = w1
                   w2 = w(j_1,l_1+2*y_nnod)
                   w3 = w(j_1,l_1+3*y_nnod)
                   w2 = w2
     &                    -(u_x*vy2)
                   w3 = w3
     &                    -(u_x*vy3)
                   w2 = w2
     &                    -(v_x*uy2)
                   w3 = w3
     &                    -(v_x*uy3)
                   w(j_1,l_1+2*y_nnod) = w2
                   w(j_1,l_1+3*y_nnod) = w3
                end do! j_1
             end do! l_1
          end do! jj_1
!
       return
       end subroutine ! tred1_local_2update

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 622 $)
!
!  SUBROUINE: Initialization_set_ekmode_ON, Initialization, aavers
!
!  AUTHORS: T. Yamasaki, K. Betsuyaku,   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Initialization_set_ekmode_ON
! $Id: Initialization.F90 622 2020-05-26 05:22:07Z jkoga $
  use m_Control_Parameters, only : m_CtrlP_set_ekmode_ON
  implicit none

  call m_CtrlP_set_ekmode_ON()
end subroutine Initialization_set_ekmode_ON

subroutine Initialization_set_ekmode_GRID
  use m_Control_Parameters, only : m_CtrlP_set_ekmode_GRID
  implicit none

  call m_CtrlP_set_ekmode_GRID()
end subroutine Initialization_set_ekmode_GRID

logical function initialization_required()
  use m_Const_Parameters, only : OFF,ON,CONTINUATION,FIXED_CHARGE_CONTINUATION,DRIVER_URAMP,DRIVER_SC_DFT,DRIVER_NEB
  use m_Control_Parameters, only : sw_optimize_lattice,sw_rebuild_pws,icond &
   & , m_CtrlP_in_initialization, driver
  use m_IterationNumbers, only : iteration_unit_cell, iteration_uramp, iteration_scdft
  use m_Ionic_System, only : m_IS_natm_can_change
  implicit none
  logical :: unitcell_can_change
  if((icond==CONTINUATION.or.icond==FIXED_CHARGE_CONTINUATION).and.m_CtrlP_in_initialization())then
     initialization_required = .true.
     return
  endif
  if( driver == DRIVER_URAMP .and. iteration_uramp > 1)then
     initialization_required = .false.
    return
  endif
  if( driver == DRIVER_SC_DFT .and. iteration_scdft > 1)then
     initialization_required = .false.
    return
  endif
  if (.not.unitcell_can_change().or.iteration_unit_cell==1) then
    initialization_required = .true.
    return
  endif
  if(m_IS_natm_can_change())then
    initialization_required = .true.
    return
  endif
  if(sw_rebuild_pws==ON) then
     initialization_required = .true.
     return
  endif

  initialization_required = .false.
end function initialization_required

subroutine Initialization_lib(mpi_comm_root, tag, ne, nk, ng, stdout)
! $Id: Initialization.F90 622 2020-05-26 05:22:07Z jkoga $
  use m_Parallelization, only : m_Parallel_init_comm_group, npes
  use m_Parallelization, only : nrank_e, nrank_k, nrank_g1, read_from_args

#ifdef _USE_SCALAPACK_
  use m_Control_Parameters,only:  m_CtrlP_set_sw_scalapack
#endif
  use m_Timing,          only : m_Timing_wd_timenow, m_Timing_init_timer
  use m_Files,           only : nfout &
       &                      , m_Files_open_standardout &
       &                      , m_Files_set_default_filenames &
       &                      , m_Files_rd_file_names_data &
       &                      , m_Files_open_files_initially &
       &                      , m_Files_check_file_existence &
       &                      , m_Files_set_conftag &
       &                      , m_Files_set_stdout
  use m_Ionic_System,    only : m_IS_initialize_mdmode
  use m_Control_Parameters,only: m_CtrlP_set_printable, printable &
       &                      , m_CtrlP_set_wct_start
  implicit none

  integer, intent(in) :: mpi_comm_root, tag, ne, nk, ng, stdout
  logical,save :: first_call=.true.
  logical :: initialization_required
  integer :: ierr

  if(.not.initialization_required()) return

!    -----------
  if(first_call)then
  call m_Files_set_conftag(tag)
  call m_Files_set_stdout(stdout)
  call m_Parallel_init_comm_group(mpi_comm_root)
  call m_CtrlP_set_printable()             !-> printable
  call m_Timing_init_timer()
  call m_Files_set_default_filenames()
  call m_Files_rd_file_names_data()
  call m_Files_open_standardout()
  if(printable) call print_title()
  if(printable) call m_Timing_wd_timenow("program start")
!  call m_Parallel_get_nproc_from_arg(printable)
  if ((ne.ge.1) .and. (nk.ge.1) .and. (npes .eq. (ne*nk))) then
    nrank_e  = ne
    nrank_k  = nk
    nrank_g1 = ne
    read_from_args = .true.
    write(nfout,'(a,3i8)') '!** np ne nk ',npes,nrank_e,nrank_k
  else
    nrank_e  = 1
    nrank_k  = 1
    nrank_g1 = 1
    read_from_args = .false.
  endif
#ifdef _USE_SCALAPACK_
  call m_CtrlP_set_sw_scalapack(printable)
#endif
  call aavers                      ! -(here)
  call m_Files_check_file_existence
  endif
  call m_Files_open_files_initially
  call m_IS_initialize_mdmode()
  if(first_call) call m_CtrlP_set_wct_start                   !  (ckcput)
!  call m_CtrlP_set_wct_start                   !  (ckcput)
!!$  call m_CtrlP_set_paramset_off
  first_call = .false.

contains
  subroutine print_title()
    integer :: i
    write(nfout,'(1x,79a)') ("*",i=1,79)
!       10        20                  40        50        60        70        80        90       100       110       120       130      140
!2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
    !                        123456789a      123456789a      123456789a      123456789a      123456789a      1234567      12345678
!!$    write(nfout,'(1x,"*",3x,"PPPPPPP   ",1x,"HH     HH ",1x,"    AA    ",1x,"   SSSSS  ",1x," EEEEEEEE ",1x,"       ",1x,"        ",3x,"*")') ! a
!!$    write(nfout,'(1x,"*",3x,"PPPPPPPP  ",1x,"HH     HH ",1x,"   AAAA   ",1x,"  SSSSSSS ",1x," EEEEEEEE ",1x,"      /",1x,"        ",3x,"*")') ! b
!!$    write(nfout,'(1x,"*",3x,"PP     PP ",1x,"HH     HH ",1x,"   AAAA   ",1x,"  SS   SS ",1x," EE       ",1x,"     //",1x,"  0000  ",3x,"*")') ! c
!!$!   write(nfout,'(1x,"*",3x,"PP     PP ",1x,"HH     HH ",1x,"  AA  AA  ",1x," SS       ",1x," EE       ",1x,"     / ",1x," 000000 ",3x,"*")') ! d
!!$    write(nfout,'(1x,"*",3x,"PP     PP ",1x,"HH     HH ",1x,"  AA  AA  ",1x," SS       ",1x," EE       ",1x,"    // ",1x,"000  000",3x,"*")') ! e
!!$    write(nfout,'(1x,"*",3x,"PP     PP ",1x,"HH     HH ",1x,"  AA  AA  ",1x," SSS      ",1x," EE       ",1x,"    /  ",1x,"00    00",3x,"*")') ! f
!!$    write(nfout,'(1x,"*",3x,"PPPPPPPP  ",1x,"HHHHHHHHH ",1x,"  AA  AA  ",1x,"  SSSSS   ",1x," EEEEEEEE ",1x,"   //  ",1x,"00    00",3x,"*")') ! g
!!$    write(nfout,'(1x,"*",3x,"PPPPPPP   ",1x,"HHHHHHHHH ",1x," AA    AA ",1x,"    SSSS  ",1x," EEEEEEEE ",1x,"   /   ",1x,"00    00",3x,"*")') ! h
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x," AA    AA ",1x,"      SSS ",1x," EE       ",1x,"   /   ",1x,"00    00",3x,"*")') ! i
!!$!   write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x," AAAAAAAA ",1x,"       SS ",1x," EE       ",1x,"  //   ",1x,"00    00",3x,"*")') ! j
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x," AAAAAAAA ",1x,"       SS ",1x," EE       ",1x,"  /    ",1x,"00    00",3x,"*")') ! k
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x,"AAAAAAAAAA",1x," SS   SSS ",1x," EE       ",1x," //    ",1x,"00    00",3x,"*")') ! l
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x,"AA      AA",1x," SSSSSSS  ",1x," EEEEEEEE ",1x," /     ",1x," 000000 ",3x,"*")') ! m
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x,"AA      AA",1x,"  SSSSS   ",1x," EEEEEEEE ",1x,"//     ",1x,"  0000  ",3x,"*")') ! n
!!$    write(nfout,'(1x,79a)') ("*",i=1,79)
    write(nfout,2011) "PPPPPPP   ","HH     HH ","    AA    ","   SSSSS  "," EEEEEEEE ","       ","        "  ! a
    write(nfout,2011) "PPPPPPPP  ","HH     HH ","   AAAA   ","  SSSSSSS "," EEEEEEEE ","      /","        "  ! b
    write(nfout,2011) "PP     PP ","HH     HH ","   AAAA   ","  SS   SS "," EE       ","     //","  0000  "  ! c
!   write(nfout,2011) "PP     PP ","HH     HH ","  AA  AA  "," SS       "," EE       ","     / "," 000000 "  ! d
    write(nfout,2011) "PP     PP ","HH     HH ","  AA  AA  "," SS       "," EE       ","    // ","000  000"  ! e
    write(nfout,2011) "PP     PP ","HH     HH ","  AA  AA  "," SSS      "," EE       ","    /  ","00    00"  ! f
    write(nfout,2011) "PPPPPPPP  ","HHHHHHHHH ","  AA  AA  ","  SSSSS   "," EEEEEEEE ","   //  ","00    00"  ! g
    write(nfout,2011) "PPPPPPP   ","HHHHHHHHH "," AA    AA ","    SSSS  "," EEEEEEEE ","   /   ","00    00"  ! h
    write(nfout,2011) "PP        ","HH     HH "," AA    AA ","      SSS "," EE       ","   /   ","00    00"  ! i
!   write(nfout,2011) "PP        ","HH     HH "," AAAAAAAA ","       SS "," EE       ","  //   ","00    00"  ! j
    write(nfout,2011) "PP        ","HH     HH "," AAAAAAAA ","       SS "," EE       ","  /    ","00    00"  ! k
    write(nfout,2011) "PP        ","HH     HH ","AAAAAAAAAA"," SS   SSS "," EE       "," //    ","00    00"  ! l
    write(nfout,2011) "PP        ","HH     HH ","AA      AA"," SSSSSSS  "," EEEEEEEE "," /     "," 000000 "  ! m
    write(nfout,2011) "PP        ","HH     HH ","AA      AA","  SSSSS   "," EEEEEEEE ","//     ","  0000  "  ! n
    write(nfout,'(1x,79a)') ("*",i=1,79)
2011 format(1x,'*',3x,a10,1x,a10,1x,a10,1x,a10,1x,a10,1x,a7,1x,a8,3x,'*')
!!$    write(nfout,'(1x,"****",10a,1x,10a,1x,10a,1x,10a,1x,10a,3x,"*")') ("**********",i=1,5)
  end subroutine print_title

  subroutine aavers
    include 'version.h' ! commit ID
    character(len=81) :: vers, system, codename
    !write(vers,'("Revision:",i5," -- ORG_Parallel --")') commit_id
!    write(vers,'("phase/0 2021.01 Revision:",i5," -- ORG_Parallel --")') commit_id
    vers = "phase/0 2023.01 Revision:"//commit_id//" -- ORG_Parallel --"
    codename = 'phaseUnif'
    system = ''

#ifdef VPP
    system = '@(#)system=vpp'
#elif DEC
    system = '@(#)system=dec'
#elif HP
    system = '@(#)system=hp'
#elif SUN
    system = '@(#)system=sun'
#elif ONYX
    system = '@(#)system=onyx'
#elif IRIX64
    system = '@(#)system=irix64'
#elif CRAY
    system = '@(#)system=crayxmp'
#elif HIUX
    system = '@(#)system=hi-ux'
#elif SX
    system = '@(#)system=sx'
#elif SP2
    system = '@(#)system=aix'
#elif Linux
#ifdef PGI
    system = '@(#)system=linux_pgi'
#else
    system = '@(#)system=linux'
#endif
#endif
    if(printable) then
!!$       write(nfout,*) ' ********************************'
!!$       write(nfout,*) ' *  PHASE/0 ver.2013.11         *'
!!$       write(nfout,*) ' *  (phaseUnif_noncol_r340rev+) *'
!!$       write(nfout,*) ' ********************************'
       write(nfout,'(a81)') trim(vers)
       write(nfout,*) trim(system)
       write(nfout,*) trim(codename)
       write(nfout,'(" --- << CPP options defined in the makefile >> --")')
#ifdef _NO_MPI_
#ifdef _OPENMP
       write(nfout,'(" Parallization: OpenMP")')
#else
       write(nfout,'(" Parallization: Serial")')
#endif
#else
#ifdef _OPENMP
       write(nfout,'(" Parallization: OpenMP and MPI")')
#else
       write(nfout,'(" Parallization: MPI")')
#endif
#endif
    end if
    if(printable) then
#ifdef TRANSPOSE
       write(nfout,'(" MGS  = TRANSPOSE")')
#elif CYCLIC
       write(nfout,'(" MGS  = CYCLIC")')
#endif
#ifdef _EMPIRICAL_
       write(nfout,'(" _EMPIRICAL_")')
#endif
#ifdef _SIMPLE_SORT_
       write(nfout,'(" SORTING = _SIMPLE_SORT_")')
#elif  _HEAP_SORT_
       write(nfout,'(" SORTING = _HEAP_SORT_")')
#endif
#ifdef DECFFT
       write(nfout,'(" FFT WF  = DECFFT")')
#elif  MKLFFT
       write(nfout,'(" FFT WF  = MKLFFT")')
#elif  FFTW3
       write(nfout,'(" FFT WF  = FFTW3")')
#elif  ACMLFFT
       write(nfout,'(" FFT WF  = ACMLFFT")')
#elif  SCSLFFT
       write(nfout,'(" FFT WF  = SCSLFFT")')
#elif  WF_SRFFT
       write(nfout,'(" FFT WF  = WF_SRFFT")')
#elif  WF_JRCATFFT
       write(nfout,'(" FFT WF  = WF_JRCATFFT")')
#elif  WF_JRCATFFT_WS
       write(nfout,'(" FFT WF  = WF_JRCATFFT_WS")')
#endif
    end if
#ifdef CD_SRFFT
    if(printable) write(nfout,'(" FFT CD  = CD_SRFFT")')
#elif CD_JRCATFFT
    if(printable) write(nfout,'(" FFT CD  = CD_JRCATFFT")')
#ifdef WF_JRCATFFT_WS
    call phase_error_with_msg(nfout,'Do NOT use WF_JRCATFFT_WS and CD_JRCATFFT at the same time',__LINE__,__FILE__)
    !if(printable) write(nfout,'(" Do NOT use WF_JRCATFFT_WS and CD_JRCATFFT at the same time")')
    !stop
#endif
#elif  CD_JRCATFFT_WS
    if(printable) write(nfout,'(" FFT CD  = CD_JRCATFFT_WS")')
#ifdef WF_JRCATFFT
    call phase_error_with_msg(nfout,'Do NOT use WF_JRCATFFT and CD_JRCATFFT_WS at the same time',__LINE__,__FILE__)
    !if(printable) write(nfout,'(" Do NOT use WF_JRCATFFT and CD_JRCATFFT_WS at the same time")')
    !stop
#endif
#elif  FFTW3
    if(printable) write(nfout,'(" FFT CD  = FFTW3")')
#endif
#ifdef NO_MGS_DGEMM
    if(printable) write(nfout,'(" NO_MGS_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_MGS_DGEMM is not defined")')
#endif
#ifdef NO_NONLOCAL_DGEMM
    if(printable) write(nfout,'(" NO_NONLOCAL_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_NONLOCAL_DGEMM is not defined")')
#endif
#ifdef NO_NONLOCAL_RMM_DGEMM
    if(printable) write(nfout,'(" NO_NONLOCAL_RMM_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_NONLOCAL_RMM_DGEMM is not defined")')
#endif
#ifdef NO_SUBMAT_DGEMM
    if(printable) write(nfout,'(" NO_SUBMAT_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_SUBMAT_DGEMM is not defined")')
#endif
#ifdef NO_FORCE_DGEMM
    if(printable) write(nfout,'(" NO_FORCE_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_FORCE_DGEMM is not defined")')
#endif
#ifdef NO_MATDIAGON_DGEMM
    if(printable) write(nfout,'(" NO_MATDIAGON_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_MATDIAGON_DGEMM is not defined")')
#endif


#ifdef LMM_PREVIOUS
    if(printable) write(nfout,'(" LMM_PREVIOUS is defined")')
#else
    if(printable) write(nfout,'(" LMM_PREVIOUS is not defined")')
#endif
    if(printable) write(nfout,'(" ----------------------------------------------")')
  end subroutine aavers
  
end subroutine Initialization_lib

subroutine Initialization(init_mpi)
! $Id: Initialization.F90 622 2020-05-26 05:22:07Z jkoga $
  use m_Parallelization, only : m_Parallel_init_comm_world, npes
  use m_Parallelization, only : m_Parallel_get_nproc_from_arg, nrank_e, nrank_k, nrank_g1, read_from_args

#ifdef _USE_SCALAPACK_
  use m_Control_Parameters,only:  m_CtrlP_set_sw_scalapack
#endif
  use m_Timing,          only : m_Timing_wd_timenow, m_Timing_init_timer
  use m_Files,           only : nfout &
       &                      , m_Files_open_standardout &
       &                      , m_Files_set_default_filenames &
       &                      , m_Files_rd_file_names_data &
       &                      , m_Files_open_files_initially &
       &                      , m_Files_check_file_existence
  use m_Ionic_System,    only : m_IS_initialize_mdmode
  use m_Control_Parameters,only: m_CtrlP_set_printable, printable &
       &                      , m_CtrlP_set_wct_start
  implicit none

  integer, optional, intent(in) :: init_mpi
  logical,save :: first_call=.true.
  logical :: initialization_required

  if(.not.initialization_required()) return

!    -----------
  if(first_call)then
  call m_Parallel_init_comm_world(init_mpi)
  call m_CtrlP_set_printable()             !-> printable
  call m_Timing_init_timer()
  call m_Files_set_default_filenames()
  call m_Files_rd_file_names_data()
  call m_Files_open_standardout()
  if(printable) call print_title()
  if(printable) call m_Timing_wd_timenow("program start")
  call m_Parallel_get_nproc_from_arg(printable)
#ifdef _USE_SCALAPACK_
  call m_CtrlP_set_sw_scalapack(printable)
#endif
  call aavers                      ! -(here)
  call m_Files_check_file_existence
  endif
  call m_Files_open_files_initially
  call m_IS_initialize_mdmode()
  if(first_call) call m_CtrlP_set_wct_start                   !  (ckcput)
!  call m_CtrlP_set_wct_start                   !  (ckcput)
!!$  call m_CtrlP_set_paramset_off
  first_call = .false.
contains
  subroutine print_title()
    integer :: i
    write(nfout,'(1x,79a)') ("*",i=1,79)
!       10        20                  40        50        60        70        80        90       100       110       120       130      140
!2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
    !                        123456789a      123456789a      123456789a      123456789a      123456789a      1234567      12345678
!!$    write(nfout,'(1x,"*",3x,"PPPPPPP   ",1x,"HH     HH ",1x,"    AA    ",1x,"   SSSSS  ",1x," EEEEEEEE ",1x,"       ",1x,"        ",3x,"*")') ! a
!!$    write(nfout,'(1x,"*",3x,"PPPPPPPP  ",1x,"HH     HH ",1x,"   AAAA   ",1x,"  SSSSSSS ",1x," EEEEEEEE ",1x,"      /",1x,"        ",3x,"*")') ! b
!!$    write(nfout,'(1x,"*",3x,"PP     PP ",1x,"HH     HH ",1x,"   AAAA   ",1x,"  SS   SS ",1x," EE       ",1x,"     //",1x,"  0000  ",3x,"*")') ! c
!!$!   write(nfout,'(1x,"*",3x,"PP     PP ",1x,"HH     HH ",1x,"  AA  AA  ",1x," SS       ",1x," EE       ",1x,"     / ",1x," 000000 ",3x,"*")') ! d
!!$    write(nfout,'(1x,"*",3x,"PP     PP ",1x,"HH     HH ",1x,"  AA  AA  ",1x," SS       ",1x," EE       ",1x,"    // ",1x,"000  000",3x,"*")') ! e
!!$    write(nfout,'(1x,"*",3x,"PP     PP ",1x,"HH     HH ",1x,"  AA  AA  ",1x," SSS      ",1x," EE       ",1x,"    /  ",1x,"00    00",3x,"*")') ! f
!!$    write(nfout,'(1x,"*",3x,"PPPPPPPP  ",1x,"HHHHHHHHH ",1x,"  AA  AA  ",1x,"  SSSSS   ",1x," EEEEEEEE ",1x,"   //  ",1x,"00    00",3x,"*")') ! g
!!$    write(nfout,'(1x,"*",3x,"PPPPPPP   ",1x,"HHHHHHHHH ",1x," AA    AA ",1x,"    SSSS  ",1x," EEEEEEEE ",1x,"   /   ",1x,"00    00",3x,"*")') ! h
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x," AA    AA ",1x,"      SSS ",1x," EE       ",1x,"   /   ",1x,"00    00",3x,"*")') ! i
!!$!   write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x," AAAAAAAA ",1x,"       SS ",1x," EE       ",1x,"  //   ",1x,"00    00",3x,"*")') ! j
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x," AAAAAAAA ",1x,"       SS ",1x," EE       ",1x,"  /    ",1x,"00    00",3x,"*")') ! k
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x,"AAAAAAAAAA",1x," SS   SSS ",1x," EE       ",1x," //    ",1x,"00    00",3x,"*")') ! l
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x,"AA      AA",1x," SSSSSSS  ",1x," EEEEEEEE ",1x," /     ",1x," 000000 ",3x,"*")') ! m
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x,"AA      AA",1x,"  SSSSS   ",1x," EEEEEEEE ",1x,"//     ",1x,"  0000  ",3x,"*")') ! n
!!$    write(nfout,'(1x,79a)') ("*",i=1,79)
    write(nfout,2011) "PPPPPPP   ","HH     HH ","    AA    ","   SSSSS  "," EEEEEEEE ","       ","        "  ! a
    write(nfout,2011) "PPPPPPPP  ","HH     HH ","   AAAA   ","  SSSSSSS "," EEEEEEEE ","      /","        "  ! b
    write(nfout,2011) "PP     PP ","HH     HH ","   AAAA   ","  SS   SS "," EE       ","     //","  0000  "  ! c
!   write(nfout,2011) "PP     PP ","HH     HH ","  AA  AA  "," SS       "," EE       ","     / "," 000000 "  ! d
    write(nfout,2011) "PP     PP ","HH     HH ","  AA  AA  "," SS       "," EE       ","    // ","000  000"  ! e
    write(nfout,2011) "PP     PP ","HH     HH ","  AA  AA  "," SSS      "," EE       ","    /  ","00    00"  ! f
    write(nfout,2011) "PPPPPPPP  ","HHHHHHHHH ","  AA  AA  ","  SSSSS   "," EEEEEEEE ","   //  ","00    00"  ! g
    write(nfout,2011) "PPPPPPP   ","HHHHHHHHH "," AA    AA ","    SSSS  "," EEEEEEEE ","   /   ","00    00"  ! h
    write(nfout,2011) "PP        ","HH     HH "," AA    AA ","      SSS "," EE       ","   /   ","00    00"  ! i
!   write(nfout,2011) "PP        ","HH     HH "," AAAAAAAA ","       SS "," EE       ","  //   ","00    00"  ! j
    write(nfout,2011) "PP        ","HH     HH "," AAAAAAAA ","       SS "," EE       ","  /    ","00    00"  ! k
    write(nfout,2011) "PP        ","HH     HH ","AAAAAAAAAA"," SS   SSS "," EE       "," //    ","00    00"  ! l
    write(nfout,2011) "PP        ","HH     HH ","AA      AA"," SSSSSSS  "," EEEEEEEE "," /     "," 000000 "  ! m
    write(nfout,2011) "PP        ","HH     HH ","AA      AA","  SSSSS   "," EEEEEEEE ","//     ","  0000  "  ! n
    write(nfout,'(1x,79a)') ("*",i=1,79)
2011 format(1x,'*',3x,a10,1x,a10,1x,a10,1x,a10,1x,a10,1x,a7,1x,a8,3x,'*')
!!$    write(nfout,'(1x,"****",10a,1x,10a,1x,10a,1x,10a,1x,10a,3x,"*")') ("**********",i=1,5)
  end subroutine print_title

  subroutine aavers
    include 'version.h' ! commit_id
    character(len=81) :: vers, system, codename
    !write(vers,'("Revision:",i5," -- ORG_Parallel --")') commit_id
!    write(vers,'("phase/0 2021.02 Revision:",i5," -- ORG_Parallel --")') commit_id
    vers = "phase/0 2023.01 Revision:"//commit_id//" -- ORG_Parallel --"
    codename = 'phaseUnif'
    system = ''

#ifdef VPP
    system = '@(#)system=vpp'
#elif DEC
    system = '@(#)system=dec'
#elif HP
    system = '@(#)system=hp'
#elif SUN
    system = '@(#)system=sun'
#elif ONYX
    system = '@(#)system=onyx'
#elif IRIX64
    system = '@(#)system=irix64'
#elif CRAY
    system = '@(#)system=crayxmp'
#elif HIUX
    system = '@(#)system=hi-ux'
#elif SX
    system = '@(#)system=sx'
#elif SP2
    system = '@(#)system=aix'
#elif Linux
#ifdef PGI
    system = '@(#)system=linux_pgi'
#else
    system = '@(#)system=linux'
#endif
#endif
    if(printable) then
!!$       write(nfout,*) ' ********************************'
!!$       write(nfout,*) ' *  PHASE/0 ver.2013.11         *'
!!$       write(nfout,*) ' *  (phaseUnif_noncol_r340rev+) *'
!!$       write(nfout,*) ' ********************************'
       write(nfout,'(a81)') trim(vers)
       write(nfout,*) trim(system)
       write(nfout,*) trim(codename)
       write(nfout,'(" --- << CPP options defined in the makefile >> --")')
#ifdef _NO_MPI_
#ifdef _OPENMP
       write(nfout,'(" Parallization: OpenMP")')
#else
       write(nfout,'(" Parallization: Serial")')
#endif
#else
#ifdef _OPENMP
       write(nfout,'(" Parallization: OpenMP and MPI")')
#else
       write(nfout,'(" Parallization: MPI")')
#endif
#endif
    end if
    if(printable) then
#ifdef TRANSPOSE
       write(nfout,'(" MGS  = TRANSPOSE")')
#elif CYCLIC
       write(nfout,'(" MGS  = CYCLIC")')
#endif
#ifdef _EMPIRICAL_
       write(nfout,'(" _EMPIRICAL_")')
#endif
#ifdef _SIMPLE_SORT_
       write(nfout,'(" SORTING = _SIMPLE_SORT_")')
#elif  _HEAP_SORT_
       write(nfout,'(" SORTING = _HEAP_SORT_")')
#endif
#ifdef DECFFT
       write(nfout,'(" FFT WF  = DECFFT")')
#elif  MKLFFT
       write(nfout,'(" FFT WF  = MKLFFT")')
#elif  FFTW3
       write(nfout,'(" FFT WF  = FFTW3")')
#elif  ACMLFFT
       write(nfout,'(" FFT WF  = ACMLFFT")')
#elif  SCSLFFT
       write(nfout,'(" FFT WF  = SCSLFFT")')
#elif  WF_SRFFT
       write(nfout,'(" FFT WF  = WF_SRFFT")')
#elif  WF_JRCATFFT
       write(nfout,'(" FFT WF  = WF_JRCATFFT")')
#elif  WF_JRCATFFT_WS
       write(nfout,'(" FFT WF  = WF_JRCATFFT_WS")')
#endif
    end if
#ifdef CD_SRFFT
    if(printable) write(nfout,'(" FFT CD  = CD_SRFFT")')
#elif CD_JRCATFFT
    if(printable) write(nfout,'(" FFT CD  = CD_JRCATFFT")')
#ifdef WF_JRCATFFT_WS
    call phase_error_with_msg(nfout,'Do NOT use WF_JRCATFFT_WS and CD_JRCATFFT at the same time',__LINE__,__FILE__)
    !stop
#endif
#elif  CD_JRCATFFT_WS
    if(printable) write(nfout,'(" FFT CD  = CD_JRCATFFT_WS")')
#ifdef WF_JRCATFFT
    call phase_error_with_msg(nfout,'Do NOT use WF_JRCATFFT and CD_JRCATFFT_WS at the same time',__LINE__,__FILE__)
    !if(printable) write(nfout,'(" Do NOT use WF_JRCATFFT and CD_JRCATFFT_WS at the same time")')
    !stop
#endif
#elif  FFTW3
    if(printable) write(nfout,'(" FFT CD  = FFTW3")')
#endif
#ifdef NO_MGS_DGEMM
    if(printable) write(nfout,'(" NO_MGS_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_MGS_DGEMM is not defined")')
#endif
#ifdef NO_NONLOCAL_DGEMM
    if(printable) write(nfout,'(" NO_NONLOCAL_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_NONLOCAL_DGEMM is not defined")')
#endif
#ifdef NO_NONLOCAL_RMM_DGEMM
    if(printable) write(nfout,'(" NO_NONLOCAL_RMM_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_NONLOCAL_RMM_DGEMM is not defined")')
#endif
#ifdef NO_SUBMAT_DGEMM
    if(printable) write(nfout,'(" NO_SUBMAT_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_SUBMAT_DGEMM is not defined")')
#endif
#ifdef NO_FORCE_DGEMM
    if(printable) write(nfout,'(" NO_FORCE_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_FORCE_DGEMM is not defined")')
#endif
#ifdef NO_MATDIAGON_DGEMM
    if(printable) write(nfout,'(" NO_MATDIAGON_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_MATDIAGON_DGEMM is not defined")')
#endif


#ifdef LMM_PREVIOUS
    if(printable) write(nfout,'(" LMM_PREVIOUS is defined")')
#else
    if(printable) write(nfout,'(" LMM_PREVIOUS is not defined")')
#endif
    if(printable) write(nfout,'(" ----------------------------------------------")')
  end subroutine aavers
  
end subroutine Initialization

      SUBROUTINE PZHEEVD( JOBZ, UPLO, N, A, IA, JA, DESCA, W, Z, IZ, JZ,
     $                    DESCZ, WORK, LWORK, RWORK, LRWORK, IWORK,
     $                    LIWORK, INFO )
*
*  -- ScaLAPACK routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     March 14, 2000 
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            IA, INFO, IZ, JA, JZ, LIWORK, LRWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            DESCA( * ), DESCZ( * ), IWORK( * )
      DOUBLE PRECISION   RWORK( * ), W( * )
      COMPLEX*16         A( * ), WORK( * ), Z( * )
*     
*
*  Purpose
*  =======
*
*  PZHEEVD computes all the eigenvalues and eigenvectors of a Hermitian
*  matrix A by using a divide and conquer algorithm.
*
*  Arguments
*  =========
*
*     NP = the number of rows local to a given process.
*     NQ = the number of columns local to a given process.
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;    (NOT IMPLEMENTED YET)
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (global input) CHARACTER*1
*          Specifies whether the upper or lower triangular part of the
*          symmetric matrix A is stored:
*          = 'U':  Upper triangular
*          = 'L':  Lower triangular
*
*  N       (global input) INTEGER
*          The number of rows and columns of the matrix A.  N >= 0.
*
*  A       (local input/workspace) block cyclic COMPLEX*16 array,
*          global dimension (N, N), local dimension ( LLD_A,
*          LOCc(JA+N-1) )
*
*          On entry, the symmetric matrix A.  If UPLO = 'U', only the
*          upper triangular part of A is used to define the elements of
*          the symmetric matrix.  If UPLO = 'L', only the lower
*          triangular part of A is used to define the elements of the
*          symmetric matrix.
*
*          On exit, the lower triangle (if UPLO='L') or the upper
*          triangle (if UPLO='U') of A, including the diagonal, is
*          destroyed.
*
*  IA      (global input) INTEGER
*          A's global row index, which points to the beginning of the
*          submatrix which is to be operated on.
*
*  JA      (global input) INTEGER
*          A's global column index, which points to the beginning of
*          the submatrix which is to be operated on.
*
*  DESCA   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix A.
*          If DESCA( CTXT_ ) is incorrect, PZHEEV cannot guarantee
*          correct error reporting.
*
*  W       (global output) DOUBLE PRECISION array, dimension (N)
*          If INFO=0, the eigenvalues in ascending order.
*
*  Z       (local output) COMPLEX*16 array,
*          global dimension (N, N),
*          local dimension ( LLD_Z, LOCc(JZ+N-1) )
*          Z contains the orthonormal eigenvectors of the matrix A.
*
*  IZ      (global input) INTEGER
*          Z's global row index, which points to the beginning of the
*          submatrix which is to be operated on.
*
*  JZ      (global input) INTEGER
*          Z's global column index, which points to the beginning of
*          the submatrix which is to be operated on.
*
*  DESCZ   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix Z.
*          DESCZ( CTXT_ ) must equal DESCA( CTXT_ )
*
*  WORK    (local workspace/output) COMPLEX*16 array,
*          dimension (LWORK)
*          On output, WORK(1) returns the workspace needed for the
*          computation.
*
*  LWORK   (local input) INTEGER
*          If eigenvectors are requested:
*            LWORK = N + ( NP0 + MQ0 + NB ) * NB,
*          with  NP0 = NUMROC( MAX( N, NB, 2 ), NB, 0, 0, NPROW )
*                MQ0 = NUMROC( MAX( N, NB, 2 ), NB, 0, 0, NPCOL )
*
*          If LWORK = -1, then LWORK is global input and a workspace
*          query is assumed; the routine calculates the size for all
*          work arrays. Each of these values is returned in the first
*          entry of the corresponding work array, and no error message
*          is issued by PXERBLA.
*
*  RWORK   (local workspace/output) DOUBLE PRECISION array,
*          dimension (LRWORK)
*          On output RWORK(1) returns the real workspace needed to
*          guarantee completion.  If the input parameters are incorrect,
*          RWORK(1) may also be incorrect.
*
*  LRWORK  (local input) INTEGER
*          Size of RWORK array.
*          RWORK >= 1 + 8*N + 2*NP*NQ,
*          NP = NUMROC( N, NB, MYROW, IAROW, NPROW )
*          NQ = NUMROC( N, NB, MYCOL, IACOL, NPCOL )
*
*  IWORK   (local workspace/output) INTEGER array, dimension (LIWORK)
*          On output IWORK(1) returns the integer workspace needed.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.
*          LIWORK = 7*N + 8*NPCOL + 2
*
*  INFO    (global output) INTEGER
*          = 0:  successful exit
*          < 0:  If the i-th argument is an array and the j-entry had
*                an illegal value, then INFO = -(i*100+j), if the i-th
*                argument is a scalar and had an illegal value, then
*                INFO = -i.
*          > 0:  If INFO = 1 through N, the i(th) eigenvalue did not
*                converge in PDLAED3.
*
*  Alignment requirements
*  ======================
*
*  The distributed submatrices sub( A ), sub( Z ) must verify
*  some alignment properties, namely the following expression
*  should be true:
*  ( MB_A.EQ.NB_A.EQ.MB_Z.EQ.NB_Z .AND. IROFFA.EQ.ICOFFA .AND.
*    IROFFA.EQ.0 .AND.IROFFA.EQ.IROFFZ. AND. IAROW.EQ.IZROW)
*    with IROFFA = MOD( IA-1, MB_A )
*     and ICOFFA = MOD( JA-1, NB_A ).
*
*  Further Details
*  ======= =======
*
*  Contributed by Francoise Tisseur, University of Manchester.
*
*  Reference:  F. Tisseur and J. Dongarra, "A Parallel Divide and
*              Conquer Algorithm for the Symmetric Eigenvalue Problem
*              on Distributed Memory Architectures",
*              SIAM J. Sci. Comput., 6:20 (1999), pp. 2223--2236.
*              (see also LAPACK Working Note 132)
*                http://www.netlib.org/lapack/lawns/lawn132.ps
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
      DOUBLE PRECISION               ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
      COMPLEX*16            CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0D+0, 0.0D+0 ),
     $                   CONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LOWER, LQUERY
      INTEGER            CSRC_A, I, IACOL, IAROW, ICOFFA, IINFO, IIZ,
     $                   INDD, INDE, INDE2, INDRWORK, INDTAU, INDWORK,
     $                   INDZ, IPR, IPZ, IROFFA, IROFFZ, ISCALE, IZCOL,
     $                   IZROW, J, JJZ, LDR, LDZ, LIWMIN, LLRWORK,
     $                   LLWORK, LRWMIN, LWMIN, MB_A, MYCOL, MYROW, NB,
     $                   NB_A, NN, NP0, NPCOL, NPROW, NQ, NQ0, OFFSET,
     $                   RSRC_A
      DOUBLE PRECISION   ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA,
     $                   SMLNUM
*     ..
*     .. Local Arrays ..
      INTEGER            DESCRZ( 9 ), IDUM1( 2 ), IDUM2( 2 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            INDXG2L, INDXG2P, NUMROC
      DOUBLE PRECISION   PZLANHE, PDLAMCH
      EXTERNAL           LSAME, INDXG2L, INDXG2P, NUMROC, PZLANHE,
     $                   PDLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, CHK1MAT, DESCINIT, INFOG2L,
     $                   PZELGET, PZHETRD, PCHK2MAT, PZLASCL, PZLASET,
     $                   PZUNMTR, PDLARED1D, PDLASET, PDSTEDC, PXERBLA,
     $                   DSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCMPLX, ICHAR, MAX, MIN, MOD, DBLE, SQRT
*     ..
*     .. Executable Statements ..
*       This is just to keep ftnchek and toolpack/1 happy
      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN
*
*     Quick return
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Test the input arguments.
*
      CALL BLACS_GRIDINFO( DESCA( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
      INFO = 0
*
      IF( NPROW.EQ.-1 ) THEN
         INFO = -( 700+CTXT_ )
      ELSE 
         CALL CHK1MAT( N, 2, N, 2, IA, JA, DESCA, 6, INFO )
         CALL CHK1MAT( N, 2, N, 2, IZ, JZ, DESCZ, 11, INFO )
         IF( INFO.EQ.0 ) THEN
            LOWER = LSAME( UPLO, 'L' )
            NB_A = DESCA( NB_ )
            MB_A = DESCA( MB_ )
            NB = NB_A
            RSRC_A = DESCA( RSRC_ )
            CSRC_A = DESCA( CSRC_ )
            IROFFA = MOD( IA-1, MB_A )
            ICOFFA = MOD( JA-1, NB_A )
            IAROW = INDXG2P( IA, NB_A, MYROW, RSRC_A, NPROW )
            IACOL = INDXG2P( JA, MB_A, MYCOL, CSRC_A, NPCOL )
            NP0 = NUMROC( N, NB, MYROW, IAROW, NPROW )
            NQ0 = NUMROC( N, NB, MYCOL, IACOL, NPCOL )
            IROFFZ = MOD( IZ-1, MB_A )
            CALL INFOG2L( IZ, JZ, DESCZ, NPROW, NPCOL, MYROW, MYCOL,
     $                    IIZ, JJZ, IZROW, IZCOL )
            LQUERY = ( LWORK.EQ.-1 .OR. LIWORK.EQ.-1 .OR. LRWORK.EQ.-1 )
*
*           Compute the total amount of space needed
*
            NN = MAX( N, NB, 2 )
            NQ = NUMROC( NN, NB, 0, 0, NPCOL )
            LWMIN = N + ( NP0+NQ+NB )*NB
            LRWMIN = 1 + 8*N + 2*NP0*NQ0
            LIWMIN = 7*N + 8*NPCOL + 2
            WORK( 1 ) = DCMPLX( LWMIN )
            RWORK( 1 ) = DBLE( LRWMIN )
            IWORK( 1 ) = LIWMIN
            IF( .NOT.LSAME( JOBZ, 'V' ) ) THEN
               INFO = -1
            ELSE IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
               INFO = -2
            ELSE IF( LWORK.LT.LWMIN .AND. LWORK.NE.-1 ) THEN
               INFO = -14
            ELSE IF( LRWORK.LT.LRWMIN .AND. LRWORK.NE.-1 ) THEN
               INFO = -16
            ELSE IF( IROFFA.NE.0 ) THEN
               INFO = -4
            ELSE IF( DESCA( MB_ ).NE.DESCA( NB_ ) ) THEN
               INFO = -( 700+NB_ )
            ELSE IF( IROFFA.NE.IROFFZ ) THEN
               INFO = -10
            ELSE IF( IAROW.NE.IZROW ) THEN
               INFO = -10
            ELSE IF( DESCA( M_ ).NE.DESCZ( M_ ) ) THEN
               INFO = -( 1200+M_ )
            ELSE IF( DESCA( N_ ).NE.DESCZ( N_ ) ) THEN
               INFO = -( 1200+N_ )
            ELSE IF( DESCA( MB_ ).NE.DESCZ( MB_ ) ) THEN
               INFO = -( 1200+MB_ )
            ELSE IF( DESCA( NB_ ).NE.DESCZ( NB_ ) ) THEN
               INFO = -( 1200+NB_ )
            ELSE IF( DESCA( RSRC_ ).NE.DESCZ( RSRC_ ) ) THEN
               INFO = -( 1200+RSRC_ )
            ELSE IF( DESCA( CTXT_ ).NE.DESCZ( CTXT_ ) ) THEN
               INFO = -( 1200+CTXT_ )
            END IF
         END IF
         IF( LOWER ) THEN
            IDUM1( 1 ) = ICHAR( 'L' )
         ELSE
            IDUM1( 1 ) = ICHAR( 'U' )
         END IF
         IDUM2( 1 ) = 2
         IF( LWORK.EQ.-1 ) THEN
            IDUM1( 2 ) = -1
         ELSE
            IDUM1( 2 ) = 1
         END IF
         IDUM2( 2 ) = 14
         CALL PCHK2MAT( N, 3, N, 3, IA, JA, DESCA, 7, N, 3, N, 3, IZ,
     $                  JZ, DESCZ, 11, 2, IDUM1, IDUM2, INFO )
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( DESCA( CTXT_ ), 'PZHEEVD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = PDLAMCH( DESCA( CTXT_ ), 'Safe minimum' )
      EPS = PDLAMCH( DESCA( CTXT_ ), 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
*
*     Set up pointers into the WORK array
*
      INDTAU = 1
      INDWORK = INDTAU + N
      LLWORK = LWORK - INDWORK + 1
*
*     Set up pointers into the RWORK array
*
      INDE = 1
      INDD = INDE + N
      INDE2 = INDD + N
      INDRWORK = INDE2 + N
      LLRWORK = LRWORK - INDRWORK + 1
*
*     Scale matrix to allowable range, if necessary.
*
      ISCALE = 0
*
      ANRM = PZLANHE( 'M', UPLO, N, A, IA, JA, DESCA,
     $       RWORK( INDRWORK ) )
*
*
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
*
      IF( ISCALE.EQ.1 ) THEN
         CALL PZLASCL( UPLO, ONE, SIGMA, N, N, A, IA, JA, DESCA, IINFO )
      END IF
*
*     Reduce Hermitian matrix to tridiagonal form.
*
      CALL PZHETRD( UPLO, N, A, IA, JA, DESCA, RWORK( INDD ),
     $              RWORK( INDE2 ), WORK( INDTAU ), WORK( INDWORK ),
     $              LLWORK, IINFO )
*
*     Copy the values of D, E to all processes
*
*     Here PxLARED1D is used to redistribute the tridiagonal matrix.
*     PxLARED1D, however, doesn't yet workMx Mawith arbritary matrix
*     distributions so we have PxELGET as a backup.
*
      OFFSET = 0
      IF( IA.EQ.1 .AND. JA.EQ.1 .AND. RSRC_A.EQ.0 .AND. CSRC_A.EQ.0 )
     $     THEN
         CALL PDLARED1D( N, IA, JA, DESCA, RWORK( INDD ), W,
     $                   RWORK( INDRWORK ), LLRWORK )
*
         CALL PDLARED1D( N, IA, JA, DESCA, RWORK( INDE2 ),
     $                   RWORK( INDE ), RWORK( INDRWORK ), LLRWORK )
         IF( .NOT.LOWER )
     $      OFFSET = 1
      ELSE
         DO 10 I = 1, N
            CALL PZELGET( 'A', ' ', WORK( INDWORK ), A, I+IA-1, I+JA-1,
     $                    DESCA )
            W( I ) = DBLE( WORK( INDWORK ) )
   10    CONTINUE
         IF( LSAME( UPLO, 'U' ) ) THEN
            DO 20 I = 1, N - 1
               CALL PZELGET( 'A', ' ', WORK( INDWORK ), A, I+IA-1, I+JA,
     $                       DESCA )
               RWORK( INDE+I-1 ) = DBLE( WORK( INDWORK ) )
   20       CONTINUE
         ELSE
            DO 30 I = 1, N - 1
               CALL PZELGET( 'A', ' ', WORK( INDWORK ), A, I+IA, I+JA-1,
     $                       DESCA )
               RWORK( INDE+I-1 ) = DBLE( WORK( INDWORK ) )
   30       CONTINUE
         END IF
      END IF
*
*     Call PDSTEDC to compute eigenvalues and eigenvectors.
*
      INDZ = INDE + N
      INDRWORK = INDZ + NP0*NQ0
      LLRWORK = LRWORK - INDRWORK + 1
      LDR = MAX( 1, NP0 )
      CALL DESCINIT( DESCRZ, DESCZ( M_ ), DESCZ( N_ ), DESCZ( MB_ ),
     $               DESCZ( NB_ ), DESCZ( RSRC_ ), DESCZ( CSRC_ ),
     $               DESCZ( CTXT_ ), LDR, INFO )
      CALL PZLASET( 'Full', N, N, CZERO, CONE, Z, IZ, JZ, DESCZ )
      CALL PDLASET( 'Full', N, N, ZERO, ONE, RWORK( INDZ ), 1, 1,
     $              DESCRZ )
      CALL PDSTEDC( 'I', N, W, RWORK( INDE+OFFSET ), RWORK( INDZ ), IZ,
     $              JZ, DESCRZ, RWORK( INDRWORK ), LLRWORK, IWORK,
     $              LIWORK, IINFO )
*
      LDZ = DESCZ( LLD_ )
      LDR = DESCRZ( LLD_ )
      IIZ = INDXG2L( IZ, NB, MYROW, MYROW, NPROW )
      JJZ = INDXG2L( JZ, NB, MYCOL, MYCOL, NPCOL )
      IPZ = IIZ + ( JJZ-1 )*LDZ
      IPR = INDZ - 1 + IIZ + ( JJZ-1 )*LDR
      DO 50 J = 0, NQ0 - 1
         DO 40 I = 0, NP0 - 1
            Z( IPZ+I+J*LDZ ) = RWORK( IPR+I+J*LDR )
   40    CONTINUE
   50 CONTINUE
*
*     Z = Q * Z
*
      CALL PZUNMTR( 'L', UPLO, 'N', N, N, A, IA, JA, DESCA,
     $              WORK( INDTAU ), Z, IZ, JZ, DESCZ, WORK( INDWORK ),
     $              LLWORK, IINFO )
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         CALL DSCAL( N, ONE / SIGMA, W, 1 )
      END IF
*
      WORK( 1 ) = DCMPLX( LWMIN )
      RWORK( 1 ) = DBLE( LRWMIN )
      IWORK( 1 ) = LIWMIN
*
      RETURN
*
*     End of PZHEEVD
*
      END

!物理定数、数学公式など
!Copyright (C) 2014-2015 Ryosuke Tomita

module m_commons
#include "defines.F"
  implicit none
!標準入力、標準出力、標準エラー出力の装置番号
  integer, parameter:: stdin = 5, stdout = 6, stderr = 0
!pi,2pi
  DOUBLE_T, parameter:: pi = acos(-1d0), pi2 = 2*pi
!3x3単位行列
  DOUBLE_T, dimension(3, 3), parameter:: &
       unit_matrix = reshape((/1., 0., 0., &
       0., 1., 0., &
       0., 0., 1./), (/3, 3/))
!複素単位
  COMPLEX_T, parameter:: zi = cmplx(0,1)
!複素数の比較(complexguess)に用いる、整数型複素数
  type intcomp
!複素数のノルム部分|z|の整数型。type==1のとき、|z|=num/den,type==2のとき、|z|=sqrt(num)/denとなるように設定する
     integer:: abs_num, abs_den, abs_type
!複素数の位相部分t=arctan(z/|z|)の整数型。type==1のとき、t=num/den*pi,type==2のとき、t=-num/den*piとなるように設定する
     integer:: arg_num, arg_den, arg_type
  end type intcomp

contains
!引き渡したファイルのパスを用いてファイルを読み込みモードで開き、引き渡した装置番号と関連付ける。開けた場合は.true.、開けなかった場合は.false.を返す。
  logical function openInput(fileno, path) result(is)
    integer, intent(in):: fileno!ファイルの装置番号
    character(*), intent(in):: path!ファイルのパス
    is = .false.
    open(fileno, file = trim(path), status = 'old', err = 100)
    is = .true.
100 return
  end function openInput

!コマンドライン引数をファイルのパスとみなし、そのファイルを開く。開けた場合は.true.、開けなかった場合は.false.を返す。
  logical function openInputFromArg(fileno) result(is)
    integer, intent(in):: fileno!ファイルの装置番号
    character(len=255):: argbuf
    integer, save:: nc = 1
    is = .false.
    if(nc > iargc()) return
    call getarg(nc, argbuf)
    nc = nc + 1
    if(.not.openInput(fileno, argbuf)) return
    is = .true.
  end function openInputFromArg

!コマンドラインからファイルを読み込みモードで開くが、失敗した時は引数のパスからファイルを読み込みモードで開く。開けた場合は.true.、開けなかった場合は.false.を返す。
  logical function openInputFromArgOrDefaultPath(fileno, path) result(is)
    integer, intent(in):: fileno!ファイルの装置番号
    character(*), intent(in):: path!コマンドラインからのファイル読み込みが失敗したときに読み込まれるファイル
    is = openInputFromArg(fileno) .or. openInput(fileno, path)
  end function openInputFromArgOrDefaultPath

!引き渡したファイルのパスを用いてファイルを書き込みモードで開き、引き渡した装置番号と関連付ける。開けた場合は.true.、開けなかった場合は.false.を返す。
  logical function openOutput(fileno, path)
    integer, intent(in):: fileno!ファイルの装置番号
    character(*), intent(in):: path!ファイルのパス
    openOutput = .false.
    open(fileno, file = trim(path), status = 'replace', err = 101)
    openOutput = .true.
101 return
  end function openOutput

!整数のベクトルが0である場合は.true.、0出ない場合は.false.を返す
  logical function is_vector_zero(kv)
    integer, dimension(3), intent(in):: kv!3次元整数ベクトル
    is_vector_zero = kv(1) == 0 .and. &
         kv(2) == 0 .and. &
         kv(3) == 0
  end function is_vector_zero

!2つの整数ベクトルが一致するとき.true.,一致しないとき.false.を返す
  logical function equals_vector(kv1, kv2)
    integer, dimension(3), intent(in):: kv1, kv2!3次元整数ベクトル1,2
    equals_vector = kv1(1) == kv2(1) .and. &
         kv1(2) == kv2(2) .and. &
         kv1(3) == kv2(3)
  end function equals_vector

!2つの3次元ベクトルの外積を計算して、3次元配列として返す
  function cross_product(a, b) result(c)
    DOUBLE_T, dimension(3), intent(in):: a, b!3次元ベクトルa,b
    DOUBLE_T, dimension(3):: c
    c(1) = a(2)*b(3) - a(3)*b(2)
    c(2) = a(3)*b(1) - a(1)*b(3)
    c(3) = a(1)*b(2) - a(2)*b(1)
  end function cross_product

!ベクトルのノルムを実数値として返す
  DOUBLE_T function norm(vect)
    DOUBLE_T, dimension(3), intent(in):: vect!ベクトル
    norm = sqrt(dot_product(vect, vect))
  end function norm

!引き渡されたベクトルを規格化する
  subroutine normalize(vect)
    DOUBLE_T, dimension(3), intent(inout):: vect!ベクトル
    vect = vect / norm(vect)
  end subroutine normalize

!格子パラメータα、β、γから規格化された格子ベクトルを求める。ただし、格子ベクトルv_1をx軸に並行であり、v_2はxy平面に存在するものとする。
!v_1 = e_x
!v_2 = cos(γ)e_x + sin(γ)e_y
!v_3 = cos(α)we_x + (cos(β)-cos(α)cos(γ))/sin(γ)e_y + g e_z
!g = sqrt(1 - cos(α)^2 - ((cos(β)-cos(α)cos(γ))/sin(γ))^2)
  function euler2vector(alpha, beta, gamma) result(v)
    DOUBLE_T, intent(in):: alpha, beta, gamma!格子パラメータ
    DOUBLE_T, dimension(3, 3):: v
    DOUBLE_T:: csc, snc, x, y, z
    csc = cos(gamma)
    snc = sin(gamma)
    v(:, 1) = (/1d0, 0d0, 0d0/)
    v(:, 2) = (/csc, snc, 0d0/)
    x = cos(alpha)
    y = (cos(beta) - x * csc)/snc
    z = sqrt(1 - x * x - y * y)
    v(:, 3) = (/x, y, z/)
  end function euler2vector

!実格子ベクトルa,b,cから逆格子ベクトルa~,b~,c~をもとめる。
!実格子ベクトルは3x3の行列として入力する。A(1:3,1)がa,A(1:3,2)がb,A(1:3,3)がcを意味する。
!逆格子ベクトルも3x3の行列として返す。。B(1:3,1)がa~,B(1:3,2)がb~,B(1:3,3)がc~を意味する。
  function get_recip_vector(A) result(B)
    DOUBLE_T, dimension(3, 3), intent(in):: A!実格子ベクトル
    DOUBLE_T, dimension(3, 3):: B!逆格子ベクトル
    DOUBLE_T:: c!実格子の体積
    B(:, 1) = cross_product(A(:, 2), A(:, 3))
    c = pi2/dot_product(A(:, 1), A(:, 1))
    B(:, 1) = b(:, 1) * c
    B(:, 2) = c * cross_product(A(:, 3), A(:, 1))
    B(:, 3) = c * cross_product(A(:, 1), A(:, 2))
  end function get_recip_vector

!実数値の比較。誤差errを含めてa,bが等しいときに.true.、異なるときに.false.を返す
!誤差errを含めてa,bが等しいとき|a-b|<errが成り立つ。
  logical function nearlyEquals(a,b,err)&
       result(o)
    DOUBLE_T, intent(in):: a, b, err!数値a,bと許容誤差err
    o = abs(a - b) < err
  end function nearlyEquals

!浮動小数点型複素数から、誤差を含めた比較を用いて整数型複素数を返す
  type(intcomp) function complexguess(z) result(iz)
#define RE real(z)
#define IM aimag(z)
#define GMAX 100
    DOUBLE_T, parameter:: err = 1e-8!許容誤差
    COMPLEX_T, intent(in):: z!浮動小数点型複素数
    integer:: inum, iden, gcd_
    DOUBLE_T:: dabs, darg
    dabs = abs(z)!複素数の実数ノルム
    darg = atan2(IM, RE)!複素数の実数位相(弧度法)
!整数ノルムの分子と分母をループさせることで実数のパターンをつくり、この実数ノルムと一致する整数ノルムを探す。分解能は1/GMAX
    ABSLOOP_NUM: do inum = -GMAX, GMAX!整数ノルムの分子のループ
       ABSLOOP_DEN: do iden = 1, GMAX!整数ノルムの分母のループ
          if(nearlyEquals(dabs, dble(inum)/iden, err)) then!type==1(|z|=num/den)に等しい場合
             gcd_ = getgcd(abs(inum), iden)
             iz%abs_num = inum/gcd_
             iz%abs_den = iden/gcd_
             iz%abs_type = 1
             go to 10
          else if (nearlyEquals(dabs, sqrt(inum+0d0)/iden, err)) then!type==2(|z|=sqrt(num)/den)に等しい場合
             gcd_ = getgcd(abs(inum), iden)
             iz%abs_num = inum/gcd_
             iz%abs_den = iden/gcd_
             iz%abs_type = 2
             go to 10
          end if
       end do ABSLOOP_DEN
    end do ABSLOOP_NUM
    iz%abs_type = 0
    return
!整数位相の分子と分母をループさせることで実数のパターンをつくり、実数位数と一致する整数位数を探す。分解能は1/GMAX
10  ARGLOOP_NUM: do inum = -GMAX, GMAX!整数位相の分子のループ
       ARGLOOP_DEN: do iden = 1, GMAX!整数位相の分母のループ
          if(nearlyEquals(darg, dble(inum)/iden*pi, err)) then!t = num/den*piのとき
             gcd_ = getgcd(abs(inum), iden)
             iz%arg_num = inum/gcd_
             iz%arg_den = iden/gcd_
             iz%arg_type = 1
             go to 20
          end if
       end do ARGLOOP_DEN
    end do ARGLOOP_NUM
    iz%arg_type = 0
    return
20  if(iz%arg_num < 0) then!num<0のとき、type==2(t=-num/den)としてnumの符号を反転する。
       iz%arg_num = -iz%arg_num
       iz%arg_type = 2
    end if
  contains
!2つの整数a,bの最大公約数を求める。
    integer function getgcd(a, b) result(c)
      integer, intent(in):: a, b
      integer:: n
      c = 1
      do n = 1, min(a,b)
         if(mod(a,n) == 0 .and. mod(b,n) == 0) c = n
      end do
    end function getgcd
#undef RE
#undef IM
  end function complexguess
end module m_commons

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE: cnstr_fcvect_work_alloc, cnstr_fcvect_work_dealloc, 
!             get_CS_and_ionic_system_data, read_ntyp_natm_natm2, read_altv, 
!             read_ncord_ninv, read_atomic_coordinates, 
!             read_iatomn_alfa_amion_etc, read_nbztyp, InputData_Analysis
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine InputData_Analysis()
! $Id: InputData_Analysis.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Files, only :             nfinp, nfout, nfcntn, file_existence_contfiles, file_existence_3contfiles &
       &                        ,file_existence_contfiles_when_paw_on &
       &                        , m_Files_open_nfcntn &
       &                        , m_Files_check_file_names &
       &                        , m_Files_reopen_nfinp &
       &                        , m_Files_reopen_nfcntn &
       &                        , F_ZAJ_in, F_CNTN_in, F_CNTN_BIN_in &
       &                        , F_CHGT_in, F_ZAJ, F_CNTN, F_CNTN_BIN &
       &                        , F_CHGT, F_CNTN_bak &
       &                        , F_CHGT_bak, F_CNTN_BIN_bak &
       &                        , F_ZAJ_bak &
       &                        , m_Files_check_file_existence &
       &                        , m_Files_check_nfcntn_existence, m_Files_echo_nfinp &
       &                        , m_Files_open_nfdynm_cif_initially &
       &                        , m_Files_open_pcont_files_ini &
       &                        , m_Files_swap_F_INP, nfpos,nfcoordattr,F_COORD_ATTR,F_POS &
       &                        , m_Files_resolve_default_pp
  use m_Crystal_Structure, only : altv,rltv,univol,rvol&
       &                        , inversion_symmetry&
       &                        , nbztyp,nbztyp_spg &
       &                        , m_CS_set_nbztyp_spg, m_CS_set_nbztyp &
       &                        , m_CS_rd_symmetry_op_etc &
       &                        , m_CS_set_default_symm_op &
       &                        , m_CS_set_abccacbcc &
       &                        , m_CS_rd_n, m_CS_rd_fix_spin_status
  use m_Ionic_System, only :      input_coordinate_system &
       &                        , ntyp, natm, natm2, nfcatm, iwei, imdtyp  &
       &                        , ityp,cnst_typ, iatomn,iatom,ivan &
       &                        , pos, cps, alfa, amion,zeta1 &
       &                        , m_IS_alloc_pos_and_v, m_IS_rd_pos_and_v &
       &                        , m_IS_alloc_iatomn_etc &
       &                        , m_IS_alloc_cnstrvectors_etc &
       &                        , m_IS_init_cnstrnt &
       &                        , m_IS_cp_works2fcvect_etc &
       &                        , m_IS_rd_n, m_IS_set_iatom &
       &                        , m_IS_rd_nrsv_stdin, m_IS_rd_T_parameters &
       &                        , m_IS_set_ionic_mass &
       &                        , m_IS_rd_diis_history &
       &                        , m_IS_natm_can_change &
       &                        , m_IS_rd_curr_atom_reservoir, m_IS_rd_n_pre, m_IS_rd_moved_distances_of_planes &
       &                        , coord_method, filetype, iatomn, ntyp &
       &                        , m_IS_rd_rigid_body
  use m_Control_Parameters, only: imdalg, paramset,icond,icond_org,nspin &
       &                        , iconvergence_previous_job, ekmode, printable &
       &                        , sw_phonon, sw_positron &
       &                        , driver, xctype &
       &                        , sw_phonon, sw_wannier90, PAW_switch &
       &                        , fixed_charge_k_parallel, neg_is_given &
       &                        , m_CtrlP_rd_parameters, m_CtrlP_rd_iconvergence &
       &                        , m_CtrlP_rd_iconv_ek &
       &                        , m_CtrlP_rd_numk_zajsaved &
       &                        , m_CtrlP_check_inputfilestyle &
       &                        , m_CtrlP_rd_control &
       &                        , m_CtrlP_rd_accuracy &
       &                        , m_CtrlP_rd_accuracy_paw_switch &     ! T. Y. 2020/02/28
       &                        , m_CtrlP_rd_accuracy_hubbard_switch & ! T. Y. 2020/02/28
       &                        , m_CtrlP_rd_driver &
#ifndef _EMPIRICAL_
       &                        , m_CtrlP_dealloc_wfsolver &
       &                        , m_CtrlP_rd_wfsolver &
       &                        , m_CtrlP_rd_chargemix &
       &                        , m_CtrlP_check_matm &
       &                        , m_CtrlP_rd_edelta_ontheway, m_CtrlP_rd_neg_previous &
#endif
       &                        , m_CtrlP_rd_struc_evol &
       &                        , m_CtrlP_rd_printlevel &
       &                        , m_CtrlP_rd_postproc &
       &                        , m_CtrlP_rd_corecharge_cntnbin, m_CtrlP_check_dos_method &
       &                        , sw_optimize_lattice ,sw_rebuild_pws,ipriinputfile &
       &                        , m_CtrlP_set_default_gmaxp, gmaxp_defined
#ifndef _EMPIRICAL_
  use m_Kpoints,            only: m_Kp_rd_way_ksample_etc, m_Kp_rd_n, m_Kp_rd_kv3
  use m_ES_dos,             only: m_ESdos_rd_pdos_param, m_ESdos_rd_pcohp_param 
#endif
  use m_Const_Parameters, only :DP, PUCV, CARTS, PAI2 &
       &, FIX, RELAX, BONDLENGTH_FIX, BONDLENGTH_FIX_1, BONDLENGTH_FIX_2 &
       &, COG_CNTR, COG_FIX_L, HEAT_BATH &
       &, FIX_IN_A_PLANE, CONTINUATION, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION,DELTA &
       &, GENERAL, GENERAL_LARGER &
       &, OLD, NEW_, GRID, ON, OFF &
       &, GDIIS, BFGS, L_BFGS &
       &, INITIAL, PREPARATION_ONLY, DRIVER_CONSTRAINT, DRIVER_NEB, DRIVER_MTD &
       &, COORDINATE_CONTINUATION, ONE_BY_ONE, ALL_AT_ONCE &
       &, P_CONTROL, PT_CONTROL &
       &, FILE, PHASE0_INPUT, PHASE0_OUTPUT
  use m_IterationNumbers, only : m_Iter_rd_iteration_numbers,m_Iter_rd_iters_and_nk,iteration_unit_cell 
#ifndef _EMPIRICAL_
  use m_Phonon,     only : m_Phonon_rd_param, m_Phonon_set_supercell
  use m_BerryPhase, only : m_BP_rd_parameters
  use m_PseudoPotential,  only : m_PP_rd_window_param

  use m_Parallelization, only : mype_conf, nrank_conf, mype, npes, mpi_comm_group, conf_para

  use m_PAW_ChargeDensity,  only : m_PAWCD_rd_ntheta_nphi
  use m_Wannier90, only : m_Wan90_init
  use m_UnitCell, only : m_UC_rd_cntn_data, m_UC_rd_md_cntn_data

!!$  use m_Parallel,   only : m_Parallel_rd_npes_etc
#endif
! === For restart lm+MSD! by tkato 2012/02/15 ==================================
  use m_Control_Parameters, only: m_CtrlP_rd_dtim_previous
! ==============================================================================

! ================================ added by K. Tagami ============== 11.0&13.0XX
  use m_Control_Parameters,    only : noncol, ndim_spinor, m_CtrlP_chkif_metagga
! =================================================================== 11.0&13.0XX

  use m_ES_occup, only : m_ES_rd_occ_ext
  use m_ErrorMessages

! ==== KT_add === 13.1XI
  use m_Excitation,  only : m_XI_read_input
! =============== 13.1XI

! === KT_add === 2014/12/29
#ifdef INIT_CHARGE_ATOM_BY_ATOM
  use m_Ionic_System, only :  m_IS_set_mag_moment0_atoms, m_IS_set_ionic_charge_atoms
#endif
! ============== 2014/12/29

  use m_ES_ChargeState,  only : m_ESCS_read_param
  use m_Potential_Average,  only : m_PotAvg_read_param

  use m_Epsilon_ek, only : m_CtrlP_rd_epsilon

#ifdef LIBXC
  use m_Control_Parameters,    only : m_CtrlP_init_xctype_libxc
#endif

  implicit none

  real(kind=DP), allocatable, dimension(:)       :: work
  integer, parameter                         :: NWK = 13
  integer                                    :: nlines
  integer,       allocatable, dimension(:)   :: ia_cnst_work    ! d(natm)
  real(kind=DP), allocatable, dimension(:,:) :: fcvect_work     ! d(natm,4)
  integer :: ierror

  integer,      parameter   :: len_str = 132
  character(len=len_str)       :: str
  character(len=260)           :: zajbuf,cntnbuf,cntn_binbuf,chgtbuf
  character(len=256) :: to_string

  integer :: iret, f_closeInputFile
  logical :: ex
  logical,save :: first_call = .true.
  logical :: initialization_required, inputfilestyle_is_new = .false.,isSCDFT
  logical :: file_existence_contfiles_t, has_uspp

  if(.not.initialization_required()) return

  if(m_CtrlP_check_inputfilestyle(nfinp) == NEW_) then
     if(printable) write(nfout,'(" !*--- input-file style = NEW")')
     inputfilestyle_is_new = .true.
     call m_Files_reopen_nfinp(1)
     if(first_call)then
        call m_CtrlP_rd_printlevel(nfout)
        if(ipriinputfile>0) call m_Files_echo_nfinp() 
        call m_CtrlP_rd_driver(nfout)
        call m_CtrlP_rd_accuracy_paw_switch(nfout)     ! T. Y. 2020/02/28
        call m_CtrlP_rd_accuracy_hubbard_switch(nfout) ! set sw_hubbard T. Y. 2020/02/28
        file_existence_contfiles_t = file_existence_contfiles
        if(PAW_switch == ON) file_existence_contfiles_t = file_existence_contfiles_when_PAW_on
        call m_CtrlP_rd_control(nfout,file_existence_contfiles_t,file_existence_3contfiles)  ! -> icond, cpumax, nmd2, ifstop, ipriekzaj
     endif
     call m_Files_open_nfdynm_cif_initially()
     if(first_call) call m_CtrlP_rd_accuracy(nfout)   ! -> neg_is_given
     call m_Phonon_rd_param(nfout)
     call m_IS_rd_n_pre(nfout)
     if(coord_method == FILE .and. filetype ==PHASE0_INPUT)then
       call m_Files_swap_F_INP(0,nfpos,F_POS)
     else if (coord_method == FILE .and. filetype == PHASE0_OUTPUT) then
       call m_Files_swap_F_INP(0,nfcoordattr,F_COORD_ATTR)
     endif
     call m_CS_rd_n(nfout)
     if(coord_method == FILE .and. filetype ==PHASE0_INPUT)then
       call m_Files_swap_F_INP(1,nfpos,F_POS)
     else if (coord_method == FILE .and. filetype == PHASE0_OUTPUT) then
       call m_Files_swap_F_INP(1,nfcoordattr,F_COORD_ATTR)
     endif
     call m_CtrlP_rd_struc_evol(nfout)
     call m_CtrlP_rd_postproc(nfout)
     call m_CtrlP_rd_epsilon(nfout)
#ifndef _EMPIRICAL_
     if(sw_wannier90==ON) call m_Wan90_init(nfout)
#endif
!     call m_CS_rd_n(nfout)
     if(coord_method == FILE .and. filetype ==PHASE0_INPUT)then
       call m_Files_swap_F_INP(0,nfpos,F_POS)
     else if (coord_method == FILE .and. filetype == PHASE0_OUTPUT) then
       call m_Files_swap_F_INP(0,nfcoordattr,F_COORD_ATTR)
     endif
     call m_IS_rd_n(nfout)
     if(coord_method == FILE .and. filetype ==PHASE0_INPUT)then
       call m_Files_swap_F_INP(1,nfpos,F_POS)
     else if (coord_method == FILE .and. filetype == PHASE0_OUTPUT) then
       call m_Files_swap_F_INP(1,nfcoordattr,F_COORD_ATTR)
     endif
     call m_IS_set_ionic_mass(nfout)
     call m_Files_resolve_default_pp(ntyp,iatomn,xctype)
     if(.not.gmaxp_defined) call m_CtrlP_set_default_gmaxp(nfout,has_uspp())

     call m_Files_open_pcont_files_ini()

#ifndef _EMPIRICAL_
     if(neg_is_given) then
        call m_CtrlP_rd_wfsolver(nfout,natm2)
        call m_CtrlP_rd_chargemix(nfout)
     end if
#endif

! === KT_add ==== 2014/12/29
#ifdef INIT_CHARGE_ATOM_BY_ATOM
     call m_IS_set_ionic_charge_atoms(nfout)
     call m_IS_set_mag_moment0_atoms(nfout)
#endif
! =============== 2014/12/29

#ifndef _EMPIRICAL_
     call m_PP_rd_window_param(nfout)
     call m_ESdos_rd_pdos_param(nfout)
     call m_ESdos_rd_pcohp_param(nfout)
     call m_CtrlP_check_matm(nfout,natm) ! rmm_precal_phase_matm

! === KT_add ===== 13.0XX
#ifdef LIBXC
     if ( xctype == "libxc") then
        call m_CtrlP_init_xctype_libxc( nfout )
     else
        call m_CtrlP_chkif_metagga(nfout)
     endif
#else
     call m_CtrlP_chkif_metagga(nfout)
#endif
! ================ 13.0XX

! === KT_add ==== 13.1XI
     call m_XI_read_input
! =============== 13.1XI

     if(ekmode /= GRID) then
        call m_Kp_rd_n(nfout)
        call m_BP_rd_parameters
     end if
#endif

     call m_ESCS_read_param
     call m_PotAvg_read_param

     call m_CtrlP_check_dos_method(nfout)

     call m_PAWCD_rd_ntheta_nphi

     call m_ES_rd_occ_ext(nfout)

     ! setup supercell

#ifndef _EMPIRICAL_
     if(sw_phonon == ON) call m_Phonon_set_supercell
#endif

     icond_org=icond
     if(driver == DRIVER_CONSTRAINT .and. conf_para .and. .not.(icond==PREPARATION_ONLY)) then
       icond=INITIAL
     endif

     if(driver == DRIVER_MTD .and.mype_conf>0)then
        zajbuf=F_ZAJ;cntnbuf=F_CNTN;cntn_binbuf=F_CNTN_BIN;chgtbuf=F_CHGT
        F_ZAJ=trim(zajbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
        F_CNTN=trim(cntnbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
        F_CNTN_BIN=trim(cntn_binbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
        F_CHGT=trim(chgtbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))

        F_ZAJ_in=trim(zajbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
        F_CNTN_in=trim(cntnbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
        F_CNTN_BIN_in=trim(cntn_binbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
        F_CHGT_in=trim(chgtbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
     endif

!!$     call parse_args()
!     call m_Files_reopen_nfinp(2)
!!$     stop '  !! stop after [call m_Files_reopen_nfinp(2) <<InputData_Analysis>>'
  else
     if(printable) write(nfout,'(" !! --- input-file style = OLD")')
     allocate(work(NWK))
     call m_CtrlP_rd_parameters(nfinp,nfout,nlines)
     call get_CS_and_ionic_system_data(nlines) !-(contained here) CS: Crystal Structure, contained here

#ifndef _EMPIRICAL_
     if(ekmode /= GRID) call m_Kp_rd_way_ksample_etc(nfinp,nlines) ! <-(nfinp-file)
#endif
     call m_CS_set_abccacbcc()
     if(nbztyp >= 2 .and. &
          & (nbztyp_spg == GENERAL .or. nbztyp_spg == GENERAL_LARGER)) then
!!$        call m_Files_open_nfspg()
!!$        call m_CS_rd_symmetry_op_etc(nfspg)
        call m_CS_rd_symmetry_op_etc(nfinp)
     else
        call m_CS_set_default_symm_op(nfout)  ! <-- nbztyp_spg
     end if
!!$     call m_CS_rd_symmetry_operations(nfinp)

     call m_IS_rd_nrsv_stdin(nfinp)   ! ->(nrsv)
     call m_IS_rd_T_parameters(imdalg,nfinp)
     !                                            ->(qmass,tkb,cprv,cpqr,forcp)
     deallocate(work)
  end if

!!$  call m_Files_check_file_existence()
  ex = file_existence_contfiles.and.file_existence_3contfiles

  if(driver==DRIVER_MTD.and.mype_conf>0 .and. .not.ex.and.icond==CONTINUATION)then
     F_CNTN=F_CNTN_bak
     F_CNTN_BIN=F_CNTN_BIN_bak
     F_CHGT=F_CHGT_bak
     F_ZAJ=F_ZAJ_bak
     F_CNTN_in=F_CNTN_bak
     F_CNTN_BIN_in=F_CNTN_BIN_bak
     F_CHGT_in=F_CHGT_bak
     F_ZAJ_in=F_ZAJ_bak
     if(printable) then
        write(nfout,'(a)') 'temporarily renamed continuation files'
        write(nfout,'(a)') '  F_CNTN     : '//trim(F_CNTN)
        write(nfout,'(a)') '  F_CNTN_BIN : '//trim(F_CNTN_BIN)
        write(nfout,'(a)') '  F_CHGT     : '//trim(F_CHGT)
        write(nfout,'(a)') '  F_ZAJ      : '//trim(F_ZAJ)
     endif
  endif

  if(driver .ne. DRIVER_NEB) then
  if(icond == CONTINUATION .or.icond==COORDINATE_CONTINUATION .or. &
       & (icond == FIXED_CHARGE_CONTINUATION .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
     if(sw_phonon == OFF) then
        if(m_Files_check_nfcntn_existence()) then
           call m_Files_open_nfcntn()
        else
           ierror = FILE_NOT_EXIST
           call phase_error(ierror, nfout, nfcntn, F_CNTN, __LINE__, __FILE__)
        end if
     endif
  endif
#ifndef DISABLE_CONSTRAINTS
  if(driver==DRIVER_CONSTRAINT) call constrained_dynamics_init(nfout)
#endif
  if(icond == CONTINUATION .or.icond==COORDINATE_CONTINUATION .or. &
       & (icond == FIXED_CHARGE_CONTINUATION .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
   if(sw_phonon == OFF) then
     if(m_Files_check_nfcntn_existence()) then
        call m_Files_open_nfcntn()
     else
        ierror = FILE_NOT_EXIST
        call phase_error(ierror, nfout, nfcntn, F_CNTN, __LINE__, __FILE__)
     end if
     call m_Iter_rd_iteration_numbers(nfcntn,icond)
     call m_IS_rd_pos_and_v(nfcntn)
     call m_IS_rd_rigid_body(nfcntn)

     call m_IS_rd_curr_atom_reservoir(nfcntn)
     if ((imdalg==GDIIS .or. imdalg==BFGS .or. imdalg==L_BFGS).and.icond.ne.COORDINATE_CONTINUATION) then
        call m_IS_rd_diis_history(nfcntn)
     endif
#ifndef _EMPIRICAL_
     if(icond==CONTINUATION) call m_CtrlP_rd_neg_previous(nfcntn,nfout)
     call m_CtrlP_rd_edelta_ontheway(nfcntn)
#endif
! === For restart lm+MSD! by tkato 2012/02/15 ==================================
   call m_CtrlP_rd_dtim_previous(nfcntn)
! ==============================================================================
     call m_CtrlP_rd_iconvergence(nfcntn)
     call m_CtrlP_rd_corecharge_cntnbin(nfcntn) ! -> status_cntnbin_positron
     call m_CS_rd_fix_spin_status(nfcntn,nfout)  ! <-- T. Yamasaki, 18th Aug. 2009
     if(icond==CONTINUATION.and.sw_optimize_lattice==ON.and.sw_rebuild_pws==ON) &
      & call m_UC_rd_cntn_data(nfcntn)
     if(icond==CONTINUATION.and.(imdalg==P_CONTROL .or. imdalg==PT_CONTROL).and.sw_rebuild_pws==ON) &
      & call m_UC_rd_md_cntn_data(nfcntn)
     if(isSCDFT()) call rd_eps0(nfcntn)
     call m_IS_rd_moved_distances_of_planes(nfcntn)
   end if
  else if(icond == FIXED_CHARGE .and. fixed_charge_k_parallel == ALL_AT_ONCE) then
     !!if( m_Files_check_nfcntn_existence()) then
     !!   call m_Files_open_nfcntn()
     !!   call m_IS_rd_pos_and_v(nfcntn)
     !!endif
  else if(icond == FIXED_CHARGE_CONTINUATION.and.fixed_charge_k_parallel == ONE_BY_ONE) then
     if(m_Files_check_nfcntn_existence()) then
        call m_Files_open_nfcntn()
     else
        ierror = FILE_NOT_EXIST
        call phase_error(ierror, nfout, nfcntn, F_CNTN, __LINE__, __FILE__)
     end if
     call m_CtrlP_rd_iconvergence(nfcntn)

! ================================================ modified by K. Tagami ======= 11.0
!     call m_Iter_rd_iters_and_nk(nfcntn,nspin)
!!$     if(fixed_charge_k_parallel == ALL_AT_ONCE) then
!!$        call m_Iter_rd_iteration_numbers(nfcntn,icond)
!!$     else if(fixed_charge_k_parallel == ONE_BY_ONE) then
     if ( noncol ) then
        call m_Iter_rd_iters_and_nk(nfcntn,ndim_spinor,nfout)
     else
        call m_Iter_rd_iters_and_nk(nfcntn,nspin,nfout)
     endif
! ============================================================================== 11.0

!!$     call m_Parallel_rd_npes_etc(nfcntn)
     call m_Kp_rd_kv3(nfcntn,nfout)
     if(sw_positron /= OFF) call m_CtrlP_rd_corecharge_cntnbin(nfcntn) ! -> status_cntnbin_positron
     call m_CtrlP_rd_iconv_ek(nfcntn,nfout)  ! -> iconv_ek_tmp
     call m_CtrlP_rd_numk_zajsaved(nfcntn,nfout) ! -> numk_zajsaved
  end if
  end if

  !!$call m_Files_check_file_names  ! for debugging 

  iret = f_closeInputFile()
  first_call = .false. 

  if(.not.neg_is_given) then
     call Check_of_Pseudopotential()  !-(PseudoPotential_Construction.F90), set neg properly

     if(inputfilestyle_is_new) then
        call m_Files_reopen_nfinp(1)
#ifndef _EMPIRICAL_
!!$        call m_CtrlP_dealloc_wfsolver()
        call m_CtrlP_rd_wfsolver(nfout,natm2)
        call m_CtrlP_rd_chargemix(nfout)
#endif
        iret = f_closeInputFile()
     else
        if(printable) then
           write(nfout,'(" !** inputfilestyle = OLD, and you cannot omit number_of_bands in the inputfile")')
        end if
        call phase_error_with_msg(nfout, 'inputfilestyle = OLD, and you cannot omit number_of_bands in the inputfile',&
       & __LINE__,__FILE__)
        !stop  'inputfilestyle = OLD, and you cannot omit number_of_bands in the inputfile'
     end if
  end if
contains
  subroutine cnstr_fcvect_work_alloc
    if(printable) write(nfout,'(" ! natm  = ",i6," << cnstr_fcvect_work_alloc >>")') natm
    allocate(ia_cnst_work(natm))
    allocate(fcvect_work(natm,4));fcvect_work = 0.d0
  end subroutine cnstr_fcvect_work_alloc

  subroutine cnstr_fcvect_work_dealloc
    if(allocated(fcvect_work)) deallocate(fcvect_work)
    if(allocated(ia_cnst_work)) deallocate(ia_cnst_work)
  end subroutine cnstr_fcvect_work_dealloc
    
  subroutine get_CS_and_ionic_system_data(nlines)
    integer, intent(in) :: nlines
!        =================
    rewind nfinp
    call read_ntyp_natm_natm2(nfinp)       ! gmax, gmaxp, ntyp, natm, natm2
    call read_altv(nfinp)                  ! altv, rltv, univol, rvol
    call read_ncord_ninv(nfinp)            ! ncord, ninv

    ! --> atomic coordinates, iwei, imdtyp, ityp, fcvect etc.
    call m_IS_alloc_pos_and_v(nfout)       ! pos, cps, cpd_l, cpo_l, iwei, imdtyp, ityp
    call cnstr_fcvect_work_alloc()          !-(InputData_Analysis) (*) ->ia_cnst_work,fcvect_work
    call read_atomic_coordinates(nfinp)      ! -> nfcatm
!!$    call m_IS_rd_atomic_coordinates(nfinp,nfout,work,ia_cnst_work,fcvect_work)      ! -> nfcatm
    call m_IS_alloc_iatomn_etc()           ! iatomn,iatom,ivan,alfa,amion,zeta1
    call m_IS_alloc_cnstrvectors_etc(imdalg) ! (fcvect,ia_cnst,gca)
    call m_IS_cp_works2fcvect_etc(imdalg,nfcatm,ia_cnst_work,fcvect_work)
    !   (fcvect_work,ia_cnst_work) ->(fcvect,ia_cnst)

    call m_IS_set_iatom(nfout)             ! -> iatom
    call read_iatomn_alfa_amion_etc(nfinp) ! iatomn,alfa,amion
    call m_IS_init_cnstrnt(natm,fcvect_work)
    call cnstr_fcvect_work_dealloc         !-(InputData_Analysis) (*)

    call skip_lines(nfinp,nlines+9)  ! nbztyp
    call read_nbztyp(nfinp)
!!$    call skip_lines(nfinp,2)  ! neg
!!$    call read_neg(nfinp)
!        =================
  end subroutine get_CS_and_ionic_system_data

  subroutine read_ntyp_natm_natm2(nfinp)
    integer, intent(in) :: nfinp
    
    real(kind=DP) :: wk1, wk2
    read(nfinp,*) wk1, wk2, ntyp, natm, natm2
    if(printable) write(nfout,100) wk1, wk2, ntyp, natm, natm2
100 format(' ',2f8.4,3i4,'   : gmax, gmaxp, ntyp, natm, natm2')
  end subroutine read_ntyp_natm_natm2

  subroutine read_altv(nfinp)
    integer, intent(in) :: nfinp
    integer      :: i,j
    do i = 1, 3
       read(nfinp,*) altv(1,i), altv(2,i), altv(3,i)
       if(printable) write(nfout,'(2H  ,3f20.10)') altv(1,i), altv(2,i), altv(3,i)
    enddo

    if(printable) write(nfout,'("      <<<RECIPROCAL LATTICE VECTOR>>>")')
    call altv_2_rltv(altv,rltv,univol,rvol)
    if(printable) write(nfout,100) ((rltv(i,j),i=1,3),j=1,3)
100 format((' ',3f18.10))
    if(printable) write(nfout,'("VOLUME OF A UNIT CELL=",2f20.10)') univol,rvol
    
  end subroutine read_altv

  subroutine read_ncord_ninv(nfinp)
    integer, intent(in) :: nfinp

    read(nfinp,*) input_coordinate_system, inversion_symmetry
    if(printable) write(nfout,120) input_coordinate_system, inversion_symmetry
120 format(' ',2i4,'   : ncord, ninv,   : iwei, imdtyp, ityp')
  end subroutine read_ncord_ninv

  subroutine read_atomic_coordinates(nfinp)
    integer, intent(in)  :: nfinp

    integer          :: i, imdt, incunt
    real(kind=DP)    :: v

    if(printable) write(nfout,'(" !! << read_atomic_coordinates >>")')
    nfcatm = 0
    do i = 1, natm
       read(nfinp,*) pos(i,1),pos(i,2),pos(i,3),iwei(i),imdtyp(i),ityp(i) 
       if(printable) write(nfout,210) pos(i,1),pos(i,2),pos(i,3),iwei(i),imdtyp(i),ityp(i)
       imdt = imdtyp(i)
       if((imdt<HEAT_BATH .and. imdt/=FIX .and. imdt/=RELAX .and.imdt/=BONDLENGTH_FIX) &
            & .or.&
            & (imdt == HEAT_BATH+BONDLENGTH_FIX_1 .or. imdt == HEAT_BATH+BONDLENGTH_FIX_2 &
            &  .or. imdt == HEAT_BATH+COG_FIX_L)) then
          nfcatm = nfcatm + 1
          if(printable) write(nfout,*)' nfcatm = ', nfcatm
          ia_cnst_work(nfcatm) = i
          if(nfcatm == 1) then
             if(imdt > HEAT_BATH) then
                cnst_typ = imdt - HEAT_BATH
             else
                cnst_typ = imdt
             end if
          end if
          backspace nfinp
          read(nfinp,'(a132)') str
          call chnnm(str,len_str,10,work,incunt)
          if(incunt == 7) then
             fcvect_work(nfcatm,1) = work(7)
          else if(incunt >= 9) then
             if(input_coordinate_system == PUCV) then
                work(11:13) = matmul(altv,work(7:9))
             else if(input_coordinate_system == CARTS) then
                work(11:13) = work(7:9)
             end if
    !        ---> Normalization of directional vectors fcvect(*,1:3).
             v = dsqrt(dot_product(work(11:13),work(11:13)))
             fcvect_work(nfcatm,1:3) = work(11:13)/v

             if(incunt == 10) fcvect_work(nfcatm,4) = work(10)
             if(printable) write(nfout,9001) nfcatm &
                  &     ,fcvect_work(nfcatm,1),fcvect_work(nfcatm,2) &
                  &     ,fcvect_work(nfcatm,3),fcvect_work(nfcatm,4)
9001         format(' Fcvect(',i4,') = ',3f8.4, d20.8)
          endif
       endif
    enddo
210 format(' ',3f18.10,i3,i6,i3)

    if(input_coordinate_system == PUCV) then
       call change_of_coordinate_system(altv,pos,natm,natm,cps) !-(b_C.S.)
    else if(input_coordinate_system == CARTS) then
       cps = pos
       rltv = transpose(rltv)/PAI2
       call change_of_coordinate_system(rltv,cps,natm,natm,pos) !-(b_C.S.)
       call altv_2_rltv(altv,rltv,univol,rvol) !-(b_Crystal_Structure)
       !                   (altv)->(rltv,univol,rvol)
    end if

    if(printable) then
       write(nfout,*) ' ! nfcatm = ', nfcatm
       write(nfout,*) ' ! cnst_typ = ', cnst_typ
    end if

!!$    call m_IS_init_cnstrnt(natm,fcvect_work)   ! ->sgmc

    if(printable) write(nfout,*) ' ! univol = ', univol
  end subroutine read_atomic_coordinates

  subroutine read_iatomn_alfa_amion_etc(nfinp)
    integer, intent(in) :: nfinp
    integer nsize
    integer i
    do i = 1, ntyp
       read(nfinp,'(a132)') str
       call chnnm(str,len_str,NWK,work,nsize)
       iatomn(i) = work(1)
       alfa(i)   = work(2)
       amion(i)  = work(3)
!!$       iloc_inputf(i)   = nint(work(4))
       ivan(i)   = nint(work(5))
       zeta1(i)  = work(6)
       if(printable) then
          if(nsize >=6 .and. dabs(zeta1(i)) > 1.d-20) then
             write(nfout,511) iatomn(i),alfa(i),amion(i),nint(work(4)),ivan(i),zeta1(i),i
          else
             write(nfout,510) iatomn(i),alfa(i),amion(i),nint(work(4)),ivan(i),i
          endif
       end if
    enddo
510 format(' ',2f8.4,f10.2, 2i2 &
         & ,' :type',i2,'iatomn,alfa,amion,iloc,ivan')
511 format(' ',2f8.4,f10.2, 2i2, f10.2 &
         & ,' :type',i2, 'iatomn,alfa,amion,iloc,ivan,zeta1')
  end subroutine read_iatomn_alfa_amion_etc

  subroutine read_nbztyp(nfinp)
    integer, intent(in) :: nfinp
    read(nfinp,*) nbztyp
    if(printable) write(6,9000) nbztyp
9000 format(' ',i3,'  : nbztyp 0-sf, 1-bk, 2-sc, 3-bcc, 4-fcc, ', &
          &                      '5-dia, 6-hex')
    call m_CS_set_nbztyp_spg() ! -> nbztyp_spg <- nbztyp
!!$    nbztyp1 = nbztyp
    if(nbztyp /= 0 .and. nbztyp /= 1 .and. nbztyp /= GENERAL .and. nbztyp /= GENERAL_LARGER) then
       call m_CS_set_nbztyp(GENERAL) ! nbztyp <- GENERAL
!!$        nbztyp = GENERAL
    end if 
  end subroutine read_nbztyp

#ifndef SX
  subroutine parse_args()
    integer :: i,narg,ieq
    character(len=32) :: arg,argval
    narg = command_argument_count()
    do i=1,narg
       call get_command_argument(i,arg)
       argval = arg 
       ieq = index(arg,'=')
       if (ieq>0) then
          if(.not.(ieq.eq.len_trim(arg)-1)) then
          call phase_error_with_msg(nfout, 'invalid argument : '//trim(arg),&
         & __LINE__,__FILE__)
          endif
          argval = arg(1:ieq-1)
       endif
       select case (argval)
       case('-p','--preparation')
          icond = PREPARATION_ONLY
       end select
    enddo
  end subroutine parse_args
#endif
end subroutine InputData_Analysis

subroutine InputData_Analysis_neb()
! $Id: InputData_Analysis.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Files, only :             nfout, nfcntn &
       &                        , m_Files_reopen_nfcntn
  use m_Ionic_System, only :      m_IS_rd_pos_and_v
  use m_Control_Parameters, only: icond,nspin &
       &                        , iconvergence_previous_job &
#ifndef _EMPIRICAL_
       &                        , m_CtrlP_rd_edelta_ontheway &
#endif
       &                        , m_CtrlP_rd_iconvergence
  use m_Const_Parameters, only :  CONTINUATION, FIXED_CHARGE_CONTINUATION
  use m_IterationNumbers, only :  m_Iter_rd_iteration_numbers,m_Iter_rd_iters_and_nk

! ============================= added by K. Tagami ==================== 11.0
  use m_Control_Parameters,    only : noncol, ndim_spinor
! ===================================================================== 11.0

  implicit none

  if(icond == CONTINUATION) then
     call m_Files_reopen_nfcntn()
     call m_Iter_rd_iteration_numbers(nfcntn,icond)
!!!!!     call m_IS_rd_pos_and_v(nfcntn)
     call m_CtrlP_rd_iconvergence(nfcntn)
#ifndef _EMPIRICAL_
     call m_CtrlP_rd_edelta_ontheway(nfcntn)
#endif
  else if(icond == FIXED_CHARGE_CONTINUATION) then
     call m_Files_reopen_nfcntn()
     call m_CtrlP_rd_iconvergence(nfcntn)
!!$     call m_Iter_rd_iters_and_nk(iconvergence_previous_job,nfcntn,nspin)

! ========================================= modified by K. Tagami ========= 11.0
!     call m_Iter_rd_iters_and_nk(nfcntn,nspin)

     if ( noncol ) then
       call m_Iter_rd_iters_and_nk(nfcntn,ndim_spinor,nfout)
     else
       call m_Iter_rd_iters_and_nk(nfcntn,nspin,nfout)
     endif
! ======================================================================== 11.0

  end if
  
end subroutine InputData_Analysis_neb

      SUBROUTINE DLAGTF( N, A, LAMBDA, B, C, TOL, D, IN, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, N
      DOUBLE PRECISION   LAMBDA, TOL
*     ..
*     .. Array Arguments ..
      INTEGER            IN( * )
      DOUBLE PRECISION   A( * ), B( * ), C( * ), D( * )
*     ..
*
*  Purpose
*  =======
*
*  DLAGTF factorizes the matrix (T - lambda*I), where T is an n by n
*  tridiagonal matrix and lambda is a scalar, as
*
*     T - lambda*I = PLU,
*
*  where P is a permutation matrix, L is a unit lower tridiagonal matrix
*  with at most one non-zero sub-diagonal elements per column and U is
*  an upper triangular matrix with at most two non-zero super-diagonal
*  elements per column.
*
*  The factorization is obtained by Gaussian elimination with partial
*  pivoting and implicit row scaling.
*
*  The parameter LAMBDA is included in the routine so that DLAGTF may
*  be used, in conjunction with DLAGTS, to obtain eigenvectors of T by
*  inverse iteration.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix T.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, A must contain the diagonal elements of T.
*
*          On exit, A is overwritten by the n diagonal elements of the
*          upper triangular matrix U of the factorization of T.
*
*  LAMBDA  (input) DOUBLE PRECISION
*          On entry, the scalar lambda.
*
*  B       (input/output) DOUBLE PRECISION array, dimension (N-1)
*          On entry, B must contain the (n-1) super-diagonal elements of
*          T.
*
*          On exit, B is overwritten by the (n-1) super-diagonal
*          elements of the matrix U of the factorization of T.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (N-1)
*          On entry, C must contain the (n-1) sub-diagonal elements of
*          T.
*
*          On exit, C is overwritten by the (n-1) sub-diagonal elements
*          of the matrix L of the factorization of T.
*
*  TOL     (input) DOUBLE PRECISION
*          On entry, a relative tolerance used to indicate whether or
*          not the matrix (T - lambda*I) is nearly singular. TOL should
*          normally be chose as approximately the largest relative error
*          in the elements of T. For example, if the elements of T are
*          correct to about 4 significant figures, then TOL should be
*          set to about 5*10**(-4). If TOL is supplied as less than eps,
*          where eps is the relative machine precision, then the value
*          eps is used in place of TOL.
*
*  D       (output) DOUBLE PRECISION array, dimension (N-2)
*          On exit, D is overwritten by the (n-2) second super-diagonal
*          elements of the matrix U of the factorization of T.
*
*  IN      (output) INTEGER array, dimension (N)
*          On exit, IN contains details of the permutation matrix P. If
*          an interchange occurred at the kth step of the elimination,
*          then IN(k) = 1, otherwise IN(k) = 0. The element IN(n)
*          returns the smallest positive integer j such that
*
*             abs( u(j,j) ).le. norm( (T - lambda*I)(j) )*TOL,
*
*          where norm( A(j) ) denotes the sum of the absolute values of
*          the jth row of the matrix A. If no such j exists then IN(n)
*          is returned as zero. If IN(n) is returned as positive, then a
*          diagonal element of U is small, indicating that
*          (T - lambda*I) is singular or nearly singular,
*
*  INFO    (output) INTEGER
*          = 0   : successful exit
*          .lt. 0: if INFO = -k, the kth argument had an illegal value
*
* =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            K
      DOUBLE PRECISION   EPS, MULT, PIV1, PIV2, SCALE1, SCALE2, TEMP, TL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
         CALL XERBLA( 'DLAGTF', -INFO )
         RETURN
      END IF
*
      IF( N.EQ.0 )
     $   RETURN
*
      A( 1 ) = A( 1 ) - LAMBDA
      IN( N ) = 0
      IF( N.EQ.1 ) THEN
         IF( A( 1 ).EQ.ZERO )
     $      IN( 1 ) = 1
         RETURN
      END IF
*
      EPS = DLAMCH( 'Epsilon' )
*
      TL = MAX( TOL, EPS )
      SCALE1 = ABS( A( 1 ) ) + ABS( B( 1 ) )
      DO 10 K = 1, N - 1
         A( K+1 ) = A( K+1 ) - LAMBDA
         SCALE2 = ABS( C( K ) ) + ABS( A( K+1 ) )
         IF( K.LT.( N-1 ) )
     $      SCALE2 = SCALE2 + ABS( B( K+1 ) )
         IF( A( K ).EQ.ZERO ) THEN
            PIV1 = ZERO
         ELSE
            PIV1 = ABS( A( K ) ) / SCALE1
         END IF
         IF( C( K ).EQ.ZERO ) THEN
            IN( K ) = 0
            PIV2 = ZERO
            SCALE1 = SCALE2
            IF( K.LT.( N-1 ) )
     $         D( K ) = ZERO
         ELSE
            PIV2 = ABS( C( K ) ) / SCALE2
            IF( PIV2.LE.PIV1 ) THEN
               IN( K ) = 0
               SCALE1 = SCALE2
               C( K ) = C( K ) / A( K )
               A( K+1 ) = A( K+1 ) - C( K )*B( K )
               IF( K.LT.( N-1 ) )
     $            D( K ) = ZERO
            ELSE
               IN( K ) = 1
               MULT = A( K ) / C( K )
               A( K ) = C( K )
               TEMP = A( K+1 )
               A( K+1 ) = B( K ) - MULT*TEMP
               IF( K.LT.( N-1 ) ) THEN
                  D( K ) = B( K+1 )
                  B( K+1 ) = -MULT*D( K )
               END IF
               B( K ) = TEMP
               C( K ) = MULT
            END IF
         END IF
         IF( ( MAX( PIV1, PIV2 ).LE.TL ) .AND. ( IN( N ).EQ.0 ) )
     $      IN( N ) = K
   10 CONTINUE
      IF( ( ABS( A( N ) ).LE.SCALE1*TL ) .AND. ( IN( N ).EQ.0 ) )
     $   IN( N ) = N
*
      RETURN
*
*     End of DLAGTF
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 594 $)
!
!  MODULE: m_ES_Intgr_VlhxcQlm
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!      Further modification by T. Yamasaki   May/17/2005
!      Further modification by T. Yamasaki   Aug/31/2007
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!

#ifdef VPP
#define _VECTOR_TUNING_
#endif
#ifdef SX
#define _VECTOR_TUNING_
#endif
#ifdef HIUX
#define _VECTOR_TUNING_
#endif

module m_ES_Intgr_VlhxcQlm
! $Id: m_ES_Intgr_VlhxcQlm.F90 594 2019-07-01 07:15:23Z jkoga $
  use m_Electronic_Structure,only : vlhxcQ, vlhxc_l, dhub
  use m_PlaneWaveBasisSet,   only : kgp,ngabc,m_pwBS_sphrp2,ylm_l
  use m_PseudoPotential,     only : ilmt,ltp,taup,isph,il2p,iqitg,qitg_l,dl2p &
       &                           ,modnrm,m_PP_find_maximum_l, nqitg, nlmt &
       &                           ,m_PP_include_vanderbilt_pot, ivanl &
       &                           ,m_PP_set_index_arrays1 &
       &                           ,m_PP_set_index_arrays2
  use m_Ionic_System,        only : ntyp, natm, ityp, pos, ihubbard
  use m_Crystal_Structure,   only : af, rltv, univol
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : nspin,iprivlhxcq,kimg,nel_Ylm, m_CtrlP_cachesize, sw_communicator_for_chg
  use m_Const_Parameters,    only : DP, PAI2, zi, SKIP, OFF
  use m_Parallelization,     only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype,ierr, np_e, mpi_chg_world
!$$#ifdef PARA3D
  use m_PlaneWaveBasisSet,   only : m_pwBS_sphrp2_3D
  use m_PlaneWaveBasisSet,   only : ngabc_kngp_l, ngabc_kngp_B_l
! ==== DEBUG by tkato 2012/04/03 ===============================================
  use m_Parallelization,     only : mpi_k_world, myrank_k
! ==============================================================================
!$$#endif

! ========================== added by K. Tagami ================== 11.0
  use m_Control_Parameters,  only : ndim_magmom
! ================================================================ 11.0

  implicit none

  include 'mpif.h'
!  52. m_ESiVQ_integrate_VlhxcQlm
#ifdef _VECTOR_TUNING_
!      - symmetrize_vlhxcq, - integrate_qitg_x_ylm, - integration_of_VlhxcQlm_core3,
#else
!      - symmetrize_vlhxcq, - integration_of_VlhxcQlm_core2,
#endif
!      - integration_of_VlhxcQlm_core
contains


  subroutine m_ESiVQ_add_dhub_to_vlhxcQ(nfout)
    integer, intent(in) :: nfout
    integer :: is,ia
! ========================================== modified by K. Tagami ======== 11.0
!    do is=1,nspin
    do is=1, ndim_magmom
! ========================================================================= 11.0
       do ia=1,natm
          if(ihubbard(ia) > 0) then
             vlhxcQ(:,:,ia,is) = vlhxcQ(:,:,ia,is)+dhub(:,:,ia,is)
          end if
       end do
    end do
  end subroutine m_ESiVQ_add_dhub_to_vlhxcQ

!$$#ifdef PARA3D
!=======================================================================
!=======================================================================
!=======================================================================
!! #define _NOPARA_KNGP_B_
  subroutine m_ESiVQ_integrate_VlhxcQlm_3D(nfout)
   use m_Parallelization,     only : ista_kngp_B , iend_kngp_B    &
  &                                , ista_atm_B, iend_atm_B, mem_atm_B &
  &                                , mpi_ke_world

    ! ***
    ! (Rev) T. Yamaskai, 31, Aug, 2007
    !     1. 'call set_index_arrays1' that included a bug is replaced
    !       by 'call m_PP_set_index_arrays1', whose bug is fixed.
    !     2. 'call set_index_arrays2' is also replaced by 'call
    !       m_PP_set_index_arrays2' that can be referred from other modules.
    !     3. contained subroutines, set_index_arrays1 and set_index_arrays2 were
    !       deleted.
    ! ***
    integer, intent(in)   :: nfout

    real(kind=DP), allocatable, dimension(:)           :: ylm_t
    real(kind=DP), allocatable, target, dimension(:,:) :: ylm_ext
    real(kind=DP), allocatable, target, dimension(:)   :: zfcos, zfsin

    integer :: ncache, ibsize, ibl1, ibl2
    real(kind=DP), allocatable, dimension(:)           :: veq ! d(ista_kngp:iend_kngp)
    real(kind=DP)                                      :: vq_ia
    real(kind=DP), allocatable, dimension(:,:)         :: qitg_red, ylm_red, vlhxc_red
    integer,       allocatable, dimension(:)           :: il3

    integer :: is,it,lmt1,lmt2,n,ilm3,l3,ia

    integer :: m, maxm, ip, np, iq
    integer, parameter :: mcritical = 4*2+1
    integer, allocatable, dimension(:) :: nqitg_sp, nqitg_sp0 !d(ntyp)
    integer, allocatable, dimension(:) :: iq2l3 ! d(nqitg)
    integer, allocatable, dimension(:,:) :: nc  ! d(maxm,nqitg)
    integer :: mc ! maxval(nc)
    integer, allocatable, dimension(:,:,:) :: nc2lmt1, nc2lmt2, nc2n ! d(mc,maxm,nqitg)

    real(kind=DP), allocatable, dimension(:,:,:,:) :: vlhxcQ_mpi ! d(nlmt,nlmt,natm,nspin)
    integer :: iab
    integer :: ista,iend
    integer :: id_sname = -1

    integer :: i, ilm
    if(modnrm == SKIP) return
    if(sw_communicator_for_chg == OFF)then
      ista = ista_kngp_B
      iend = iend_kngp_B
    else
      ista = ista_kngp
      iend = iend_kngp
    endif
!--- dummy timer --->
#ifdef __TIMER_SUB__
  call timer_sta(1061)
  call timer_end(1061)
  call timer_sta(1062)
  call timer_end(1062)
#endif

#ifdef __TIMER_DO__
  call timer_sta(1085)
  call timer_end(1085)
#endif
!<--- dummy timer ---

    call tstatc0_begin('m_ESiVQ_integrate_VlhxcQlm_3D ',id_sname)

#ifdef __TIMER_SUB__
  call timer_sta(1057)
#endif

    call m_PP_find_maximum_l(n)    ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)

    allocate(nqitg_sp(ntyp)); allocate(nqitg_sp0(ntyp))
    allocate(iq2l3(nqitg))
    allocate(nc(mcritical,nqitg));nc=0
    call m_PP_set_index_arrays1(nfout,ntyp,nqitg,mcritical,n**2,il3 &
         & ,maxm,mc,nqitg_sp,nqitg_sp0,iq2l3,nc)
    allocate(nc2lmt1(mc,maxm,nqitg))
    allocate(nc2lmt2(mc,maxm,nqitg))
    allocate(nc2n(mc,maxm,nqitg))
    call m_PP_set_index_arrays2(nfout,mc,maxm,nqitg,mcritical,n**2,il3,iq2l3 &
         & ,nc2lmt1,nc2lmt2,nc2n,nc) ! -> nc2lmt1, nc2lmt2, nc2n, nc

    if(n**2 > nel_Ylm) then
#ifndef _NOPARA_KNGP_B_
       allocate(ylm_ext(ista:iend,nel_Ylm+1:n**2));  ylm_ext = 0.d0
       allocate(ylm_t(ista:iend)); ylm_t = 0.d0
       do ilm3 = nel_Ylm+1, n**2
          call m_pwBS_sphrp2_3D(ilm3,rltv,ista,iend,ylm_t)  !(ilm3,rltv,ngabc,gr_l)->(ylm)
          ylm_ext(:,ilm3) = ylm_t(:)
       end do
#else
       allocate(ylm_ext(ista_kngp:iend_kngp,nel_Ylm+1:n**2));  ylm_ext = 0.d0
       allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
       do ilm3 = nel_Ylm+1, n**2
          call m_pwBS_sphrp2_3D(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)  !(ilm3,rltv,ngabc,gr_l)->(ylm)
          ylm_ext(:,ilm3) = ylm_t(:)
       end do
#endif
       deallocate(ylm_t)
    end if

    vlhxcQ = 0.d0

#ifndef _NOPARA_KNGP_B_
    do is = 1, nspin, af+1

       ncache = (m_CtrlP_cachesize()*1024)*3/4
       if(ncache == 0) then
          ibsize = iend-ista+1
       else
          ibsize=ncache/(8*(n**2))
       end if
       if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ibsize = ", i8)') ibsize
!f       allocate(zfcos(ibsize)); zfcos = 0.d0
!f       allocate(zfsin(ibsize)); zfsin = 0.d0
!f       allocate(veq(ibsize))
       allocate(qitg_red(ibsize,nqitg))
       allocate(vlhxc_red(ibsize,kimg))
       allocate(ylm_red(ibsize,n**2))
!$omp parallel default(none)                                                    &
!$omp   shared(ityp,natm,ivanl,nqitg_sp0,nqitg_sp,iq2l3,nc,nc2lmt1,             &
!$omp          nc2lmt2,nc2n,vlhxcQ,is,univol,dl2p,pos,ista_kngp_B,iend_kngp_B,  &
!$omp          ngabc_kngp_B_l,qitg_red,vlhxc_red,ylm_red,kimg,ibsize,mype,      &
!$omp          qitg_l,vlhxc_l,ylm_l,ylm_ext,nqitg,nel_Ylm,n,ista,iend,          &
!$omp          sw_communicator_for_chg)                                         &
!$omp   private(ibl1,ibl2,ia,it,iq,l3,m,ilm3,vq_ia,ip,lmt1,lmt2,np,zfcos,zfsin,veq,i,ilm)
#ifdef __TIMER_OMP1__
  call timer_sta(1088)
#endif
       allocate(zfcos(ibsize)); zfcos = 0.d0
       allocate(zfsin(ibsize)); zfsin = 0.d0
       allocate(veq(ibsize))
#ifdef __TIMER_OMP1__
  call timer_end(1088)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1076)
#endif
!#ifdef USE_PROF
!  call timer_sta(1076)
!#endif
!-!OCL PREFETCH_INDIRECT
       do ibl1 = ista, iend, ibsize
          ibl2 = ibl1+ibsize-1
          if(ibl2 .gt. iend) ibl2 = iend
!oo       if(iprivlhxcq >= 2) then
!oo          write(nfout,'(" !mESiVQ:    ibl1,ibl2,ibsize = ", 3i8)') ibl1, ibl2, ibsize
!oo       end if
!f          call substitute_qitgred(ibl1,ibl2)  ! qitg_l -> qitg_red
!---
!$omp do
          do iq = 1, nqitg
             do i = 1, ibl2-ibl1+1
                qitg_red(i, iq) = qitg_l(i+ibl1-1,iq)
             end do
          end do
!$omp end do
!---
!f          call substitute_vlhxcred(ibl1,ibl2) ! vlhxc_l -> vlhxc_red
!---
          if(kimg==1) then
!$omp do
             do i = 1, ibl2-ibl1+1
                vlhxc_red(i,1) = vlhxc_l(i+ibl1-1,1,is)
             end do
!$omp end do
          else if(kimg==2) then
!$omp do
             do i = 1, ibl2-ibl1+1
                vlhxc_red(i,1) = vlhxc_l(i+ibl1-1,1,is)
                vlhxc_red(i,2) = vlhxc_l(i+ibl1-1,2,is)
             end do
!$omp end do
          end if
!---
!f          call substitute_ylmred(ibl1,ibl2)   ! ylm_l, ylm_ext -> ylm_red
!$omp do
      do ilm = 1, nel_Ylm
         do i = 1, ibl2-ibl1+1
            ylm_red(i,ilm) = ylm_l(i+ibl1-1,ilm)
         end do
      end do
!$omp end do
      if(n**2 > nel_Ylm) then
         do ilm = nel_ylm+1, n**2
!$omp do
            do i = 1, ibl2-ibl1+1
               ylm_red(i,ilm) = ylm_ext(i+ibl1-1,ilm)
            end do
!$omp end do
         end do
      end if

#ifdef __TIMER_OMP1__
  call timer_sta(1087)
#endif
#ifdef __TIMER_OMP1__
  call timer_sta(1093)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1084)
#endif
!$omp do schedule(runtime)
          do ia = 1, natm
             it = ityp(ia)
             if(sum(ivanl(:,it)) == 0) cycle
!             call calc_phase_div(ia)  !   -> zfcos, zfsin
!f             call calc_phase_div_B_3D(ia)  !   -> zfcos, zfsin
#ifdef __TIMER_OMP3__
  call timer_sta(1089)
#endif
             if(sw_communicator_for_chg == OFF)then
             call calc_phase_div_B_3D(ia,zfcos,zfsin,ibsize,ibl1,ibl2)  !   -> zfcos, zfsin
             else
             call calc_phase_div_3D(ia)  !   -> zfcos, zfsin
             endif
#ifdef __TIMER_OMP3__
  call timer_end(1089)
#endif
!oo          if(iprivlhxcq >= 2) then
!oo             write(nfout,'(" !mESiVQ:    ia,  iq,  l3,   m,ilm3,  ip,lmt1,lmt2,  np")')
!oo          end if
#ifdef __TIMER_OMP2__
  call timer_sta(1095)
#endif
             do iq = nqitg_sp0(it), nqitg_sp(it)
                l3 = iq2l3(iq)
!f                call dp_Vlhxcq_exp_Q_div(iq) ! vlhxc, exp, qitg_l  -> veq
#ifdef __TIMER_OMP3__
  call timer_sta(1090)
#endif
                call dp_Vlhxcq_exp_Q_div(iq,zfcos,zfsin,veq,ibsize,l3,ibl1,ibl2) ! vlhxc, exp, qitg_l  -> veq
#ifdef __TIMER_OMP3__
  call timer_end(1090)
#endif
#ifdef __TIMER_OMP2__
  call timer_sta(1096)
#endif
                do m = 1, 2*l3+1
                   ilm3 = l3*l3+m
!f                   call veQ_dot_ylm_div(vq_ia) ! veq, ylm -> vq_ia
#ifdef __TIMER_OMP3__
  call timer_sta(1091)
#endif
                   call veQ_dot_ylm_div(vq_ia,veq,ibsize,ilm3,l3,ibl1,ibl2) ! veq, ylm -> vq_ia
#ifdef __TIMER_OMP3__
  call timer_end(1091)
#endif
!f--#ifdef __TIMER_DO__
!f--  call timer_sta(1076)
!f--#endif
#ifdef __TIMER_OMP2__
  call timer_sta(1092)
#endif
                   do ip = 1, nc(m,iq)
                      lmt1 = nc2lmt1(ip,m,iq)
                      lmt2 = nc2lmt2(ip,m,iq)
                      np = nc2n(ip,m,iq)
!oo                   if(iprivlhxcq >= 2) then
!oo                      write(nfout,'(" !mESiVQ: ",9i5)') ia, iq, l3, m, ilm3, ip, lmt1,lmt2,np
!oo                   end if
                      vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is) &
                     &                          + univol*vq_ia*dl2p(lmt1,lmt2,np,it)
                   end do
#ifdef __TIMER_OMP2__
  call timer_end(1092)
#endif
!f--#ifdef __TIMER_DO__
!f--  call timer_end(1076)
!f--#endif
                end do
#ifdef __TIMER_OMP2__
  call timer_end(1096)
#endif
             end do
#ifdef __TIMER_OMP2__
  call timer_end(1095)
#endif
          end do
!$omp end do
#ifdef __TIMER_DO__
  call timer_end(1084)
#endif
#ifdef __TIMER_OMP1__
  call timer_end(1093)
#endif
#ifdef __TIMER_OMP1__
  call timer_end(1087)
#endif
       end do
!#ifdef USE_PROF
!  call timer_end(1076)
!#endif
#ifdef __TIMER_DO__
  call timer_end(1076)
#endif
#ifdef __TIMER_OMP1__
  call timer_sta(1094)
#endif
       deallocate(veq)
       deallocate(zfsin);deallocate(zfcos)
#ifdef __TIMER_OMP1__
  call timer_end(1094)
#endif
!$omp end parallel
       deallocate(ylm_red)
       deallocate(vlhxc_red)
       deallocate(qitg_red)
!f       deallocate(veq)

!f       deallocate(zfsin);deallocate(zfcos)
    end do

    if(npes > 1) then
       allocate(vlhxcQ_mpi(nlmt,nlmt,natm,nspin)); vlhxcQ_mpi = 0.d0
! ==== DEBUG by tkato 2012/04/03 ===============================================
#if 0
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_comm_group)
  call timer_sta(1077)
#endif
       call mpi_allreduce(vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*nspin,  &
      &                   mpi_double_precision, mpi_sum, mpi_comm_group, ierr)
#else
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_k_world(myrank_k))
  call timer_sta(1077)
#endif
       if(sw_communicator_for_chg == OFF)then
       call mpi_allreduce(vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*nspin,  &
      &                   mpi_double_precision, mpi_sum, mpi_k_world(myrank_k), ierr)
       else
       call mpi_allreduce(vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*nspin,  &
      &                   mpi_double_precision, mpi_sum, mpi_chg_world, ierr)
       endif
#endif
! ==============================================================================
#ifdef __TIMER_COMM__
  call timer_end(1077)
#endif
       vlhxcQ = vlhxcQ_mpi
       deallocate(vlhxcQ_mpi)
    end if

#else

    do is = 1, nspin, af+1

       ncache = (m_CtrlP_cachesize()*1024)*3/4
       if(ncache == 0) then
          ibsize = iend_kngp-ista_kngp+1
       else
          ibsize=ncache/(8*(n**2))
       end if
       if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ibsize = ", i8)') ibsize
       allocate(zfcos(ibsize)); zfcos = 0.d0
       allocate(zfsin(ibsize)); zfsin = 0.d0
       allocate(veq(ibsize))
       allocate(qitg_red(ibsize,nqitg))
       allocate(vlhxc_red(ibsize,kimg))
       allocate(ylm_red(ibsize,n**2))
       do ibl1 = ista_kngp, iend_kngp, ibsize
          ibl2 = ibl1+ibsize-1
          if(ibl2 .gt. iend_kngp) ibl2 = iend_kngp
!oo       if(iprivlhxcq >= 2) then
!oo          write(nfout,'(" !mESiVQ:    ibl1,ibl2,ibsize = ", 3i8)') ibl1, ibl2, ibsize
!oo       end if
          call substitute_qitgred(ibl1,ibl2)  ! qitg_l -> qitg_red
          call substitute_vlhxcred(ibl1,ibl2) ! vlhxc_l -> vlhxc_red
          call substitute_ylmred(ibl1,ibl2)   ! ylm_l, ylm_ext -> ylm_red 

!!        do ia = ista_atm_B, iend_atm_B
          do iab = ista_atm_B, iend_atm_B
             ia = mem_atm_B(iab)
             it = ityp(ia)
             if(sum(ivanl(:,it)) == 0) cycle
!             call calc_phase_div(ia)  !   -> zfcos, zfsin
             call calc_phase_div_3D(ia)  !   -> zfcos, zfsin
!oo          if(iprivlhxcq >= 2) then
!oo             write(nfout,'(" !mESiVQ:    ia,  iq,  l3,   m,ilm3,  ip,lmt1,lmt2,  np")')
!oo          end if
             do iq = nqitg_sp0(it), nqitg_sp(it)
                l3 = iq2l3(iq)
!f                call dp_Vlhxcq_exp_Q_div(iq) ! vlhxc, exp, qitg_l  -> veq
                call dp_Vlhxcq_exp_Q_div(iq,zfcos,zfsin,veq,ibsize,l3,ibl1,ibl2) ! vlhxc, exp, qitg_l  -> veq
                do m = 1, 2*l3+1
                   ilm3 = l3*l3+m
!f                   call veQ_dot_ylm_div(vq_ia) ! veq, ylm -> vq_ia
                   call veQ_dot_ylm_div(vq_ia,veq,ibsize,ilm3,l3,ibl1,ibl2) ! veq, ylm -> vq_ia
#ifdef __TIMER_DO__
  call timer_sta(1078)
#endif
                   do ip = 1, nc(m,iq)
                      lmt1 = nc2lmt1(ip,m,iq)
                      lmt2 = nc2lmt2(ip,m,iq)
                      np = nc2n(ip,m,iq)
!oo                   if(iprivlhxcq >= 2) then
!oo                      write(nfout,'(" !mESiVQ: ",9i5)') ia, iq, l3, m, ilm3, ip, lmt1,lmt2,np
!oo                   end if
                      vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is) &
                     &                          + univol*vq_ia*dl2p(lmt1,lmt2,np,it)
                   end do
#ifdef __TIMER_DO__
  call timer_end(1078)
#endif
                end do
             end do
          end do
       end do
       deallocate(ylm_red)
       deallocate(vlhxc_red)
       deallocate(qitg_red)
       deallocate(veq)

       deallocate(zfsin);deallocate(zfcos)
    end do

    if(npes > 1) then
       allocate(vlhxcQ_mpi(nlmt,nlmt,natm,nspin)); vlhxcQ_mpi = 0.d0
! ==== DEBUG by tkato 2012/04/03 ===============================================
#if 0
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_comm_group)
  call timer_sta(1079)
#endif
       call mpi_allreduce(vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*nspin,  &
      &                   mpi_double_precision, mpi_sum, mpi_comm_group, ierr)
#else
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_k_world(myrank_k))
  call timer_sta(1079)
#endif
       if(sw_communicator_for_chg == OFF)then
       call mpi_allreduce(vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*nspin,  &
      &                   mpi_double_precision, mpi_sum, mpi_k_world(myrank_k), ierr)
       else
       call mpi_allreduce(vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*nspin,  &
      &                   mpi_double_precision, mpi_sum, mpi_chg_world, ierr)
       endif
#endif
! ==============================================================================
#ifdef __TIMER_COMM__
  call timer_end(1079)
#endif
       vlhxcQ = vlhxcQ_mpi
       deallocate(vlhxcQ_mpi)
    end if
#endif

!   if(nrank_g > 1) then
!      allocate(vlhxcQ_mpi(nlmt,nlmt,natm,nspin)); vlhxcQ_mpi = 0.d0
!      call mpi_allreduce(vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*nspin,  &
!     &                   mpi_double_precision, mpi_sum, mpi_ke_world, ierr)
!      call mpi_allgather(vlhxcQ_l_3D, nlmt*nlmt*nspin*np_atm_B, MPI_DOUBLE_PRECISION &
!     &                   vlhxcQ_mpi,  nlmt*nlmt*nspin*mp_atm_B, MPI_DOUBLE_PRECISION &
!     &                   mpi_ke_world, ierr )
!      vlhxcQ = vlhxcQ_mpi
!      deallocate(vlhxcQ_mpi)
!   end if

    call symmetrize_vlhxcq
    if(allocated(ylm_ext)) deallocate(ylm_ext)
    deallocate(il3)

    deallocate(nc2n,nc2lmt2,nc2lmt1,nc,iq2l3,nqitg_sp,nqitg_sp0)

    if(iprivlhxcq >= 2) then
       write(nfout,*) ' <<< m_ESiVQ_integrate_VlhxcQlm >>> vlhxcQ start'
       do is = 1, nspin, af+1
          do it = 1, natm
             write(nfout,*) ' (vlhxcQ) -- #atom = ', it
             do lmt1 = 1, ilmt(ityp(it))
                write(nfout,*) ' --- lmt1 = ', lmt1
                write(nfout,'(99(5d16.8,/))')&
                     & (vlhxcq(lmt1,lmt2,it,is),lmt2=1,ilmt(ityp(it)))
             end do
          end do
       end do
       write(nfout,*) ' <<< m_ESiVQ_integrate_VlhxcQlm >>> vlhxcQ end'
    endif
#ifdef __TIMER_SUB__
  call timer_end(1057)
#endif
    call tstatc0_end(id_sname)
  contains

    subroutine symmetrize_vlhxcq
      integer :: is, ia, it, lmt1, lmt2
#ifdef __TIMER_SUB__
  call timer_sta(1063)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1086)
#endif
      do is = 1, nspin, af+1
         do ia = 1, natm
            it = ityp(ia)
            do lmt1 = 1, ilmt(it)
               do lmt2 = lmt1+1, ilmt(it)
                  vlhxcQ(lmt2,lmt1,ia,is) = vlhxcQ(lmt1,lmt2,ia,is)
               end do
            end do
         end do
      end do
#ifdef __TIMER_DO__
  call timer_end(1086)
#endif
#ifdef __TIMER_SUB__
  call timer_end(1063)
#endif
    end subroutine symmetrize_vlhxcq

!f    subroutine substitute_qitgred()
    subroutine substitute_qitgred(ib1,ib2)
      integer, intent(in) :: ib1, ib2
      integer :: iq, i
      do iq = 1, nqitg
!f         do i = 1, ibl2-ibl1+1
!f            qitg_red(i, iq) = qitg_l(i+ibl1-1,iq)
         do i = 1, ib2-ib1+1
            qitg_red(i, iq) = qitg_l(i+ib1-1,iq)
         end do
      end do
    end subroutine substitute_qitgred

!f    subroutine substitute_vlhxcred
    subroutine substitute_vlhxcred(ib1,ib2)
      integer, intent(in) :: ib1, ib2
      integer :: i
#ifdef __TIMER_SUB__
  call timer_sta(1060)
#endif

#ifdef __TIMER_DO__
  call timer_sta(1083)
#endif
      if(kimg==1) then
!f         do i = 1, ibl2-ibl1+1
!f            vlhxc_red(i,1) = vlhxc_l(i+ibl1-1,1,is)
         do i = 1, ib2-ib1+1
            vlhxc_red(i,1) = vlhxc_l(i+ib1-1,1,is)
         end do
      else if(kimg==2) then
!f         do i = 1, ibl2-ibl1+1
!f            vlhxc_red(i,1) = vlhxc_l(i+ibl1-1,1,is)
!f            vlhxc_red(i,2) = vlhxc_l(i+ibl1-1,2,is)
         do i = 1, ib2-ib1+1
            vlhxc_red(i,1) = vlhxc_l(i+ib1-1,1,is)
            vlhxc_red(i,2) = vlhxc_l(i+ib1-1,2,is)
         end do
      end if
#ifdef __TIMER_DO__
  call timer_end(1083)
#endif
#ifdef __TIMER_SUB__
  call timer_end(1060)
#endif
    end subroutine substitute_vlhxcred

!f    subroutine substitute_ylmred
    subroutine substitute_ylmred(ib1,ib2)
      integer, intent(in) :: ib1, ib2
      integer :: ilm, i
      do ilm = 1, nel_Ylm
!f         do i = 1, ibl2-ibl1+1
!f            ylm_red(i,ilm) = ylm_l(i+ibl1-1,ilm)
         do i = 1, ib2-ib1+1
            ylm_red(i,ilm) = ylm_l(i+ib1-1,ilm)
         end do
      end do
      if(n**2 > nel_Ylm) then
         do ilm = nel_ylm+1, n**2
!f            do i = 1, ibl2-ibl1+1
!f               ylm_red(i,ilm) = ylm_ext(i+ibl1-1,ilm)
            do i = 1, ib2-ib1+1
               ylm_red(i,ilm) = ylm_ext(i+ib1-1,ilm)
            end do
         end do
      end if
    end subroutine substitute_ylmred

    subroutine calc_phase_div(ia)
      integer, intent(in) :: ia
      integer :: i, ig
      real(kind=DP) :: fx, fy, fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do i = 1, ibl2-ibl1+1
         ig = i + ibl1 - 1
         ph = ngabc(ig,1)*fx + ngabc(ig,2)*fy + ngabc(ig,3)*fz
         zfcos(i) = dcos(ph)
         zfsin(i) = dsin(ph)
      end do
    end subroutine calc_phase_div

    subroutine calc_phase_div_3D(ia)
      integer, intent(in) :: ia
      integer :: i, ig
      real(kind=DP) :: fx, fy, fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do i = 1, ibl2-ibl1+1
         ig = i + ibl1 - 1
         ph = ngabc_kngp_l(ig,1)*fx + ngabc_kngp_l(ig,2)*fy + ngabc_kngp_l(ig,3)*fz
         zfcos(i) = dcos(ph)
         zfsin(i) = dsin(ph)
      end do
    end subroutine calc_phase_div_3D

!f    subroutine calc_phase_div_B_3D(ia)
    subroutine calc_phase_div_B_3D(ia,zfcos0,zfsin0,ib,ib1,ib2)
      integer, intent(in) :: ia, ib, ib1, ib2
      real(kind=DP), intent(out) :: zfcos0(ib), zfsin0(ib)
      integer :: i, ig
      real(kind=DP) :: fx, fy, fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
!f      do i = 1, ibl2-ibl1+1
!f         ig = i + ibl1 - 1
      do i = 1, ib2-ib1+1
         ig = i + ib1 - 1
         ph = ngabc_kngp_B_l(ig,1)*fx + ngabc_kngp_B_l(ig,2)*fy + ngabc_kngp_B_l(ig,3)*fz
         zfcos0(i) = dcos(ph)
         zfsin0(i) = dsin(ph)
      end do
    end subroutine calc_phase_div_B_3D

!f    subroutine dp_Vlhxcq_exp_Q_div(iq)
    subroutine dp_Vlhxcq_exp_Q_div(iq,zfcos0,zfsin0,veq0,ib,l,ib1,ib2)
      integer, intent(in) :: iq, ib, l, ib1, ib2
      real(kind=DP), intent(out) :: veq0(ib)
      real(kind=DP), target, intent(in) :: zfcos0(ib), zfsin0(ib)
      integer       :: i
      real(kind=DP) :: f
      real(kind=DP), pointer, dimension(:) :: zfsc1, zfsc2

!f--#ifdef __TIMER_SUB__
!f--  call timer_sta(1061)
!f--#endif
      
!      if(mod(l3,2) == 0) then
      if(mod(l,2) == 0) then
         zfsc1 => zfcos0
         if(kimg == 2) zfsc2 => zfsin0
         f = -1.d0
!      else if(mod(l3,2) == 1) then
      else if(mod(l,2) == 1) then
         zfsc1 => zfsin0
         if(kimg == 2) zfsc2 => zfcos0
         f = 1.d0
      end if

!f--#ifdef __TIMER_DO__
!f--  call timer_sta(1084)
!f--#endif
      if(kimg == 1) then
!f         do i = 1, ibl2-ibl1+1
         do i = 1, ib2-ib1+1
            veq0(i) = qitg_red(i,iq)*vlhxc_red(i,1)*zfsc1(i)
         end do
      else if(kimg == 2) then
!f         do i = 1, ibl2-ibl1+1
         do i = 1, ib2-ib1+1
            veq0(i)  = qitg_red(i,iq)*(vlhxc_red(i,1)*zfsc1(i)+f*vlhxc_red(i,2)*zfsc2(i))
         end do
      end if
!f--#ifdef __TIMER_DO__
!f--  call timer_end(1084)
!f--#endif
!f--#ifdef __TIMER_SUB__
!f--  call timer_end(1061)
!f--#endif
    end subroutine dp_Vlhxcq_exp_Q_div

    subroutine veQ_dot_ylm_div(vq,veq0,ib,il,l,ib1,ib2)
      real(kind=DP), intent(out) :: vq
      integer, intent(in) :: ib, il, l, ib1, ib2
      real(kind=DP), intent(in) :: veq0(ib)

      integer       :: i
!f--#ifdef __TIMER_SUB__
!f--  call timer_sta(1062)
!f--#endif
      vq = 0.d0
!f--#ifdef __TIMER_DO__
!f--  call timer_sta(1085)
!f--#endif
!      do i = 1, ibl2-ibl1+1
!         vq = vq + veq(i)*ylm_red(i,ilm3)
      do i = 1, ib2-ib1+1
         vq = vq + veq0(i)*ylm_red(i,il)
      end do
!f--#ifdef __TIMER_DO__
!f--  call timer_end(1085)
!f--#endif

!      if(mod(l3,4) == 0) then
      if(mod(l,4) == 0) then
         vq = vq
!      else if(mod(l3,4) == 1) then
      else if(mod(l,4) == 1) then
         vq = -vq
!      else if(mod(l3,4) == 2) then
      else if(mod(l,4) == 2) then
         vq = -vq
!      else if(mod(l3,4) == 3) then
      else if(mod(l,4) == 3) then
         vq = vq
      end if
!f--#ifdef __TIMER_SUB__
!f--  call timer_end(1062)
!f--#endif
    end subroutine veQ_dot_ylm_div

  end subroutine m_ESiVQ_integrate_VlhxcQlm_3D

!$$#endif

end module m_ES_Intgr_VlhxcQlm

!TSPACE関数のラッピング、以下は構造体や定数の定義部分
!Copyright (C) 2014-2015 Ryosuke Tomita 

module m_tspace_defines
#include "defines.F"
  implicit none
!結晶学で群論を扱う上での定数
  integer, parameter:: num_operator_max = 48, num_spacegroup_max = 230,&
!既約表現の数の最大値
       num_imr_max = 12, num_class_max = 12, &
!生成元の数の最大値
       num_generator_max = 3,&
!類の位数の最大値
       num_operator_per_class_max = 8,&
!表現行列の最大次数
       dimmax = 6

!TSPACE関数tskfbzの返り値、ISINTERNALであるとき、そのk点はBZ内部に、ISOUTERのとき外部に存在する
  integer, parameter:: ISINTERNAL = 1, ISOUTER = 0

!TSPACE内の対称操作の文字列表現
  character(len=4), parameter:: &
!反転操作
       element_name_inversion = 'I',&
!Oh群での対称操作
       element_name_cubic(num_operator_max/2) =&
       (/'E   ','C2X ','C2Y ','C2Z ',&
       'C31+','C32+','C33+','C34+',&
       'C31-','C32-','C33-','C34-',&
       'C2A ','C2B ','C2C ','C2D ','C2E ','C2F ',&
       'C4X+','C4Y+','C4Z+','C4X-','C4Y-','C4Z-'/),&
!D6h群での対称操作
       element_name_hexagonal(num_operator_max/4) =&
       (/'E   ','C6+ ','C3+ ','C2  ','C3- ','C6- ',&
       'C211','C221','C231','C212','C222','C232'/)

!格子系のパラメータ
  type lattice_parameter
!格子系[PFICRH]
     character(len=NameLen):: lattice_type
     integer::&
!生成元の数
          num_generator,&
!生成元の回転操作のインデックス
          index_rotation(num_generator_max),&
!生成元の並進ベクトル
          translation(2, 3, num_generator_max)
!反転対称をもつかどうか
     logical:: isinversion
!格子パラメータ
     DOUBLE_T:: a, b, c, alpha, beta, gamma
  end type lattice_parameter

!TSPACE上で扱われるk点の情報
  type kvector
     integer::&
!k点のインデックス
          index,&
!k点の成分表示ijk(b表示)
          comp(3),&
!k点の共通分母N, kx = i/N*b1x + j/N*b2x + k/N*b3x
          common_denom,&
!comm2bz: k点とBZとの関係、内部の点(ISINTERNAL)か外部(ISOUTER)か境界(>1)か
          comm2bz
!TSPACEで名付けられるk点特有の名前
     character(len=2):: name
!isdouble: 二重表現であれば真、でなくば偽
     logical:: isdouble
  end type kvector

!適合関係に関するTSPACEから得られる情報
  type comtable
     type(kvector):: kp(2)
!群(small)Gおよび部分群(large)Hの既約表現の数
     integer:: nimr(2),&
!Hの指標をGの指標で簡約したときの係数
          comp(num_imr_max, num_imr_max)
  end type comtable

!既約表現
  type irrep
!既約表現の名前(m_characte_tableで名付ける)
     character(len=NameLen):: name, name_mulliken
!次元
     integer:: dim
!既約表現の、対称操作における指標
     COMPLEX_T:: comp(num_class_max),&
!表現行列
          wd(dimmax, dimmax, num_operator_max)
  end type irrep

!TSPACEから得られる指標表の情報
  type character_table
!群の位数および既約表現の数
     integer:: nclass, numimr, numop, maxdim
!群に属する既約表現
     type(irrep):: imrs(num_imr_max)
     character(len=NameLen):: class_name(num_class_max)
  end type character_table

!対称操作
  type operat
!対称操作の名前(m_tspace_commons::get_element_nameで名付けられる)
     character(len=NameLen):: name
     DOUBLE_T::&
!回転行列（ブラベ格子表示）
          rot(nxyz_, nxyz_),&
!並進ベクトル（ブラベ格子表示）
          tr(nxyz_),&
          vaxis(nxyz_), vang
     COMPLEX_T:: spinrot(2,2)
     integer:: index_for_gamma, index_for_all
  end type operat
  
!類
  type class
!類の名前(m_tspace_commons::get_class_nameで名付けられる)
     character(len=NameLen):: name

     integer::&
!類の位数
          order,&
!類に属する対称操作のインデックス
          ind(num_operator_per_class_max)
  end type class

!TSPACEから得られる対称操作の情報
!
  type group
     integer::&
!order: 群の位数
          order,&
!nclass:類の数
          nclass,&
!群が反転操作を含むとき、その対称操作の番号を、含まないとき0以下の値をもつ
          inversion
!群に属する類
     type(class):: cls(num_class_max)
!群に属する対称操作
     type(operat):: op(num_operator_max)
     character(len=NameLen)::&
!点群の名前(Schönflies notation)
          schname,&
!点群の名前(Hermann–Mauguin notation)
          hmname
  end type group
end module m_tspace_defines

!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.00                                       #
!#                                                                       #
!#      Sub Routine : PseudoPotential_ek_Epsilon                         #
!#                                                                       #
!#                                Written by T. Hamada 2007/5/8          #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo CISS              #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
! $Id: PseudoPotential_ek_Epsilon.f90 376 2014-06-17 07:48:31Z jkoga $
subroutine PseudoPotential_ek_Epsilon
!
! Pseudopotential_ek for ek_Epsilon
! The original program is Pseudopotential_ek in PseudoPotential_Construction
!
  use m_Const_Parameters,     only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, ON
  use m_Control_Parameters,   only : icond, sw_pdos, sw_use_add_proj
  use m_Kpoints,              only : kv3, vkxyz, kv3_previous
  use m_NonLocal_Potential,   only : m_NLP_rd_snl_3D, m_NLP_betar_dot_PWs_3D &
       &                           , m_NLP_betar_dot_PWs_diff_3D &
       &                           , m_NLP_phir_dot_PWs_3D &
       &                           , m_NLP_add_betar_dot_PWs_3D
  use m_PseudoPotential,      only : m_PP_alloc_NLP, m_PP_dealloc_NLP, m_PP_betar_calculated
  use m_IterationNumbers,     only : iteration_electronic,nk_in_the_process
  use m_Files,                only : nfout, nfcntn_bin, m_Files_open_nfcntn_bin &
       &                           , F_CNTN_BIN_in_partitioned
  implicit none

  if(icond == FIXED_CHARGE &
       & .or. (icond == FIXED_CHARGE_CONTINUATION &
       &           .and.( iteration_electronic == 0 .or. kv3_previous /= kv3))) then
     call m_PP_alloc_NLP()
     call m_NLP_betar_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> snl
     if(sw_pdos == ON) then
        call m_NLP_phir_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> phig
     end if
     if(sw_use_add_proj == ON) then
        call m_NLP_add_betar_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> snl_add
     end if
!    call m_PP_dealloc_NLP()
!!$     if(nk_in_the_process == 3) stop 'PseudoPotential_ek'
  else if(icond == FIXED_CHARGE_CONTINUATION) then
!!$     call m_Files_open_nfcntn_bin()
     call m_NLP_rd_snl_3D(nfout,nfcntn_bin,F_CNTN_BIN_in_partitioned,kv3)
  end if
end subroutine PseudoPotential_ek_Epsilon

      subroutine eigen_dch(n,d,e,z,ldz,info)
!
      use communication_h, only : eigen_init
     &               , eigen_free
     &               , bcast_dbl
     &               , cyc2d_cyc1d
!
      integer, intent(in)           :: n, ldz
      real(8), intent(inout)        :: d(1:n), e(1:n)
      real(8), intent(out)          :: z(1:ldz,*)

! parameters blacs array descritor(the position of entry tags), etc
      integer, parameter            :: block_cyclic_2d = 1
      integer, parameter            :: dlen_  = 9
      integer, parameter            :: dtype_ = 1
      integer, parameter            :: ctxt_  = 2
      integer, parameter            :: m_     = 3
      integer, parameter            :: n_     = 4
      integer, parameter            :: mb_    = 5
      integer, parameter            :: nb_    = 6
      integer, parameter            :: rsrc_  = 7
      integer, parameter            :: csrc_  = 8
      integer, parameter            :: lld_   = 9

      integer                       :: descz( dlen_ )
      integer                       :: descw( dlen_ )
 
      integer                       :: world_size, my_rank
      integer                       :: trilwmin, lwork, liwork
 
      real(8), pointer              :: work(:)
      integer, pointer              :: iwork(:)

      real(8)                       :: s0, s1, d1, d2, d3

      include 'mpif.h'
      include 'trd.h'
 
      s0=mpi_wtime()
!! blacs/pblas/scalapack initialization
!      call blacs_pinfo( iam, nprocs )
!      if ( nprocs < 1 ) then
!!  mpi group setup
!         call mpi_comm_size( mpi_comm_eigen, world_size, ierr )
!         call mpi_comm_rank( mpi_comm_eigen, my_rank, ierr )
!         nprocs = world_size
!         iam = my_rank
!         call blacs_setup( iam, nprocs )
!      end if
!      call blacs_get( -1, 0, ictxt )
!      call eigen_init(2)
      nprow = size_of_col
      npcol = size_of_row
!      call blacs_gridinit( ictxt, 'column-major', nprow, npcol )
!      call blacs_gridinfo( ictxt, nprow, npcol, myrow, mycol )
      ICTXT = ICTXTtoDC
      MYROW = MYROWtoDC
      MYCOL = MYCOLtoDC


! blacs array registration
      nb = 48
      np = numroc( n, nb, myrow, 0, nprow )
      nq = numroc( n, nb, mycol, 0, npcol )
      lddz = (n-1)/nprow+1
      lddz = ((lddz-1)/nb+1)*nb+1
      lddw = (n-1)/npcol+1
      lddw = ((lddw-1)/nb+1)*nb+1
      call descinit( descz, n, n, nb, nb, 0, 0, ictxt, lddz, info )
 
! preparing working arrays
      trilwmin = 3*n + max( nb*( np+1 ), 3*nb )
      lwork  = max( max( 1+6*n+2*np*nq, trilwmin ) + 2*n, lddz*lddw)
      liwork = 2+7*n+8*npcol
      allocate(work(lwork), iwork(liwork), stat=istat)
      if(istat /= 0) then
         print*,"memory exhausted"
         call flush(6)
         call mpi_abort( mpi_comm_eigen, 1, ierr )
      end if


! somehow, z must be nullified (originally next loop is not required.)
      z(1:lddz*lddw,1) = 0.0d+00

      call pdstedc( 'i', n, d(1), e(1), z(1,1), 1, 1, descz,
     &              work(1), lwork, iwork(1), liwork, info )

      call descinit( descw, n, n, 1, 1, 0, 0, ictxt, lddz, info )
      call pdgemr2d( n, n, z, 1, 1, descz, work, 1, 1, descw, ictxt )
      d1=mpi_wtime()
      call cyc2d_cyc1d(n,z,ldz,work,lddz, nprow, npcol, ierr)
      d2=mpi_wtime()
      call bcast_dbl( d(1), n, 1, mpi_comm_eigen )
      d3=mpi_wtime()
!      call eigen_free(2)

! freeing working arrays
      deallocate(work, iwork)

 
! blacs/pblas/scalapack finalize
!      call blacs_gridexit( ictxt )

#ifdef DETAIL
      if(myrank==1) then
         print*,"   bcast_dbl   :: ",d2-d1,"(sec)"
         print*,"   cyc2d_cyc1d :: ",d3-d2,"(sec)"
      endif
#endif
#ifdef TIMER
      s1=mpi_wtime()
      if(myrank==1)then
         print*,"Exectime of \"eigen_dch\" routine =",s1-s0,"(sec)"
      endif
#endif

      return
      end subroutine

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a collection of subroutines called in the main program.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

!--------------------------------------------------------
!!
!!!           Copy Wfns etc . 
!!
!---------------------------------------------------------
subroutine Copy_Wfn_etc_To_WorkArray( nq )
  use m_LinearResponse_tools,  only : Copy_Zaj_To, Copy_MapZ_To, &
       &                              Copy_NBase_To, Copy_IGf_To, &
       &                              Copy_Iba_To, Copy_Occups_To, &
       &                              Copy_HardPart_To, Copy_EigenVals_To
  use m_LinearResponse_tools,  only : wfn_k, wfn_kmq, map_z_k, map_z_kmq, &
       &                              nbase_k, nbase_kmq, igf_k, igf_kmq, &
       &                              iba_k, iba_kmq, occup_k, occup_kmq, &
       &                              fsval_k, fsval_kmq, &
       &                              eko_k, eko_kmq
  use m_LinearResponse_Control,  only : nrd_efermi, sw_LongWaveLimit
  use m_Const_Parameters,       only : ON, OFF

  use m_PseudoPotential,        only : modnrm
  use m_Const_Parameters,       only : EXECUT  
  use m_Timing,                     only : tstatc0_begin, tstatc0_end

  implicit none
! ----------------------------------------------------
  integer, intent(in)         ::    nq
  integer :: id_sname = -1
! ---------------------------------- start ------------
  call tstatc0_begin('Copy_Wfn_etc_To_WorkArray ', id_sname)
!
  if ( sw_LongWaveLimit == OFF ) then
     if ( nq == 0 ) then
        call Copy_Zaj_To( wfn_k );     call Copy_MapZ_To( map_z_k )
        call Copy_NBase_To( nbase_k ); call Copy_IGf_To( igf_k )
        call Copy_Iba_To( iba_k )
        if ( nrd_efermi==1 )  call Copy_Occups_To( occup_k )
        if ( modnrm==EXECUT ) call Copy_HardPart_To( fsval_k )
     else
        call Copy_Zaj_To( wfn_kmq );     call Copy_MapZ_To( map_z_kmq )
        call Copy_NBase_To( nbase_kmq ); call Copy_IGf_To( igf_kmq )
        call Copy_Iba_To( iba_kmq )
        if ( nrd_efermi==1 ) call Copy_Occups_To( occup_kmq )
        if ( modnrm==EXECUT ) call Copy_HardPart_To( fsval_kmq )
     endif
  else
     if ( nq == 0 ) then
        call Copy_Zaj_To( wfn_k );     call Copy_MapZ_To( map_z_k )
        call Copy_NBase_To( nbase_k ); call Copy_IGf_To( igf_k )
        call Copy_Iba_To( iba_k )
        if ( nrd_efermi==1 ) then
           call Copy_EigenVals_To( eko_k, occup_k )
        else
           call Copy_EigenVals_To( eko_k )
        endif
        if ( modnrm==EXECUT ) call Copy_HardPart_To( fsval_k )
     endif
  endif
  
  call tstatc0_end(id_sname)
  
end subroutine Copy_Wfn_etc_To_WorkArray

!--------------------------------------------------------
!!
!!!   Alloc and Dealloc subroutines
!!
!---------------------------------------------------------
subroutine Alloc_WorkArray_LR1
  use m_LinearResponse_tools,   only : m_LR_alloc_Array_WFns, &
       &                               m_LR_alloc_Array_MapFns,&
       &                               m_LR_alloc_Array_EigenVals, &
       &                               m_LR_alloc_Array_Occups, &
       &                               m_LR_alloc_Array_CorePart
  use m_LinearResponse_Control, only : nrd_efermi
  use m_PseudoPotential,        only : modnrm
  use m_Const_Parameters,       only : EXECUT

  implicit none

  call m_LR_alloc_Array_WFns
  call m_LR_alloc_Array_MapFns
  call m_LR_alloc_Array_EigenVals
  if ( nrd_efermi==1 ) call m_LR_alloc_Array_Occups
  if ( modnrm==EXECUT ) call m_LR_alloc_Array_CorePart
end subroutine Alloc_WorkArray_LR1

subroutine Alloc_WorkArray_LR2
  use m_LinearResponse_Density,   only : m_LR_alloc_Array_Occups_ek, &
       &                               m_LR_alloc_Array_Densities

  implicit none

  call m_LR_alloc_Array_Occups_ek
  call m_LR_alloc_Array_Densities
end subroutine Alloc_WorkArray_LR2

subroutine Free_WorkArray_LR1
  use m_LinearResponse_tools,   only : m_LR_dealloc_Array_WFns, &
       &                               m_LR_dealloc_Array_MapFns,&
       &                               m_LR_dealloc_Array_EigenVals, &
       &                               m_LR_dealloc_Array_Occups, &
       &                               m_LR_dealloc_Array_CorePart
  use m_LinearResponse_Control, only : nrd_efermi
  use m_PseudoPotential,        only : modnrm
  use m_Const_Parameters,       only : EXECUT

  implicit none

  call m_LR_dealloc_Array_WFns
  call m_LR_dealloc_Array_MapFns
  call m_LR_dealloc_Array_EigenVals
  if ( nrd_efermi==1 ) call m_LR_dealloc_Array_Occups
  if ( modnrm==EXECUT ) call m_LR_dealloc_Array_CorePart
  
end subroutine Free_WorkArray_LR1

subroutine Free_WorkArray_LR2
  use m_LinearResponse_Density,   only : m_LR_dealloc_Array_Occups_ek, &
       &                               m_LR_dealloc_Array_Densities

  implicit none
  call m_LR_dealloc_Array_Occups_ek
  call m_LR_dealloc_Array_Densities
end subroutine Free_WorkArray_LR2

!--------------------------------------------------------
!!
!!!   Generate and Delete Q point
!!
!---------------------------------------------------------
subroutine Gen_q_points
  use m_Control_Parameters,       only : Num_q_Points
  use m_LinearResponse_Control,   only : sw_tddft, vqxyz
  use m_LinearResponse_Qpt,       only : q_points_in_BUCS_CARTS

  if ( sw_tddft==1 ) then
     Num_q_Points = 1;
     allocate( vqxyz( Num_q_Points, 3, 2 ) )
     Call q_points_in_BUCS_CARTS
  endif
end subroutine Gen_q_points

subroutine Del_q_points
  use m_LinearResponse_Control,   only : vqxyz
  if ( allocated( vqxyz ) ) Deallocate( vqxyz )
end subroutine Del_q_points

!--------------------------------------------------------
!!
!!!     Initialization and Finalization 
!!
!---------------------------------------------------------
subroutine Initialization_LR
  use m_LinearResponse_Qpt,     only : m_LR_alloc_Vecs_q_plus_G, &
       &                               m_LR_set_Vecs_q_plus_G
  use m_LinearResponse_Qpt,      only : m_LR_alloc_Array_FTQVals, &
       &                                m_LR_calc_FTQ_times_Ylm
  use m_PseudoPotential,         only : modnrm
  use m_Const_Parameters,        only : EXECUT

  use m_Files,                   only : nfout
  use m_LinearResponse_Density,  only : set_ppc_data, &
       &                                Alloc_ptrans, &
       &                                nppcorr, check_PP, &
       &                                Alloc_PP_local_type, &
       &                                Alloc_PP_norm_type, &
       &                                set_ppc_data_it

  use m_Const_Parameters,        only : ON
  use m_LinearResponse_Control,  only : nrd_efermi, sw_LongWaveLimit
  use m_LinearResponse_Qpt,  only : ftqval

! 
  use m_LinearResponse_Control,  only : nmax_G_LR
  use m_PlaneWaveBasisSet,     only : kg0

  implicit none
! ---------------------------- start ----------------
  if ( nrd_efermi==1 ) call Restore_FermiEnergy
  call set_UVSOR_mode_TO( ON )
! 
  if ( nmax_G_LR > kg0 ) nmax_G_LR = kg0
!
  if ( modnrm == EXECUT ) then
     call m_LR_alloc_Array_FTQvals
     call m_LR_calc_FTQ_times_Ylm
  endif
! 
  if ( sw_LongWaveLimit==1 ) then
     call set_nppcorr_to( 2 ) 
     call Alloc_ptrans
!     if ( nppcorr>0 ) call set_ppc_data(nfout)
     if ( nppcorr>0 ) call set_ppc_data_it(nfout)
     call Alloc_PP_norm_type
     call Alloc_PP_local_type
     call check_PP(nfout)
  endif
end subroutine Initialization_LR
   
subroutine Finalization_LR
  use m_LinearResponse_Qpt,  only : m_LR_dealloc_Vecs_q_plus_G, &
       &                            m_LR_dealloc_Array_FTQVals, &
       &                            m_LR_dealloc_Qitg
  use m_PseudoPotential,         only : modnrm
  use m_Const_Parameters,        only : EXECUT
  use m_LinearResponse_Density,  only : Dealloc_Ptrans_Nppc_ilocal_etc, &
       &                                dealloc_PP_local_type, &
       &                                dealloc_PP_norm_type
  use m_LinearResponse_Control,  only : sw_LongWaveLimit
  implicit none
! ------------------------ start ----------------
  call m_LR_dealloc_Vecs_q_plus_G
  if ( modnrm == EXECUT ) then
     call m_LR_dealloc_Qitg
     call m_LR_dealloc_Array_FTQvals
  endif
  if ( sw_LongWaveLimit==1 ) then
     call Dealloc_Ptrans_Nppc_ilocal_etc
     call Dealloc_PP_norm_type
     call Dealloc_PP_local_type
  endif
end subroutine Finalization_LR


subroutine Backup_FermiEnergy
  use m_Electronic_Structure,     only : efermi
  use m_LinearResponse_Control,   only : efermi_backup

  implicit none

  efermi_backup = efermi

end subroutine Backup_FermiEnergy

subroutine Restore_FermiEnergy
  use m_Electronic_Structure,     only : efermi
  use m_LinearResponse_Control,   only : efermi_backup

  implicit none

  efermi = efermi_backup

end subroutine Restore_FermiEnergy

subroutine Set_UVSOR_mode_TO( mode )
  use m_Control_Parameters,       only : uvsormode

  implicit none
  integer, intent(in)  :: mode
  uvsormode = mode

end subroutine Set_UVSOR_mode_TO

subroutine set_nppcorr_to( value )
  use m_LinearResponse_Density, only : nppcorr
  implicit none

  integer, intent(in) :: value
  nppcorr = value

end subroutine set_nppcorr_to

!--------------------------------------------------------
!!
!!!    InputData_Analysis for Linear Response
!!
!--------------------------------------------------------
subroutine InputData_Analysis_LR
  
  use m_Files,                    only : m_Files_reopen_nfinp, nfout
  use m_LinearResponse_Control,   only : m_CtrlP_rd_LinearResponse, &
       &                                 efermi_backup, e_low, e_high, e_step, &
       &                                 nstep, nrd_efermi
  use m_Electronic_Structure,     only : efermi

  implicit none

  call m_Files_reopen_nfinp(1)
  call m_CtrlP_rd_LinearResponse(nfout)
  call m_Files_reopen_nfinp(2)
  call Setup_LinearResponse( nfout, e_low, e_high, e_step, nstep, nrd_efermi, efermi )
  call Backup_FermiEnergy

end subroutine InputData_Analysis_LR

subroutine Setup_LinearResponse( nfout, e_low, e_high, e_step, nstep,  nrd_efermi, efermi )
  use m_Control_Parameters,  only : printable, way_ksample
  use m_Const_Parameters,    only : DP, MESH
  use m_LinearResponse_Control, only : e, nistep, scissor
  use m_LinearResponse_Control, only : way_BZintegral, LORENTZIAN_B, GAUSSIAN_B, &
       &                               L_TETRAHEDRON, width, tetra_eps, eta

  implicit none

  integer, intent(in)     :: nfout
  integer, intent(inout)  :: nrd_efermi
  integer, intent(out)    :: nstep
  
  real(DP), intent(in)    :: efermi
  real(DP), intent(inout) :: e_low, e_high, e_step
  !
  integer                 :: i     
  real(DP)                :: e_range
! --------- fermi level ------------
  if(printable) write(nfout,'(1x,"!* nrd_efermi = ",i3)') nrd_efermi
  if(nrd_efermi==0) then
     if(printable) write(nfout,'(1x,"!* efermi is calculated")')
  else
     if(printable) write(nfout,'(1x,"!* efermi = ",f10.5," read from the input file")') efermi
  end if
  ! -------- -- energy range --
  call allocate_energy_range_matrix
  ! ------------ BZ Intelration --
  call BZ_integration_option  
  ! ----------- band gap correction --
  call scissor_operator_option
  
contains 
  
  subroutine allocate_energy_range_matrix
    
    integer i
    !
    if ( e_step <= 0.0d0 ) then
       e_step = 0.002d0
       if(printable) write(nfout,'(1x,"!* default photon energy step of ",f10.5," is used")') e_step
    end if
    ! set default e_low and e_high if necessary
    if ( e_low <= 0.0d0 .and. e_high <= 0.0d0 ) then
       e_low=0.0d0;   e_high=2.0d0
       if ( printable ) then
          write(nfout,'(1x,"!* lowest and highest energy is 0.0d0")')
          write(nfout,'(1x,"!* default lowest energy of ",f10.5," is used ")') e_low
          write(nfout,'(1x,"!* default highest energy of ",f10.5," is used")') e_high
       end if
    end if
    ! set e array
    e_range = ( e_high-e_low ) / e_step
    nstep = int( e_range ) + 1
    
    allocate( e(nstep) ); e = 0.0d0
       
    e(1) = e_low
    if (nstep.gt.1 ) then
       ! 2007.12.10
       do i=2, nstep
          e(i)=e(1)+e_step*(i-1)
       end do
       !         do i=2, nstep
       !            e(i)=e(i-1)+e_step
       !         end do
       ! 2007.10.12
    end if
    if (printable) write(nfout,'(1x,"!* energy range = ",f12.5," -",f12.5,1x,"au",3x," step = ",f12.5,1x,"au")') &
    & e_low,e_high, e_step
  end subroutine allocate_energy_range_matrix
  
  subroutine BZ_integration_option
    if (printable) &
         & write(nfout,'(1x,"!* way_BZintegral = ",i3)') way_BZintegral
    
    if ( printable ) then
       write(nfout,*) '!* eta = ', eta
       write(nfout,*) '!* width = ', width
    endif
    
    if (way_BZintegral==L_TETRAHEDRON) then
       ! ------------------------------------------------------------
!       write(*,*) ' Not supported '
!       stop
       call phase_error_with_msg(nfout, 'Not supported',__LINE__,__FILE__)
       ! ------------------------------------------------------------
       ! check mesh type
       if (way_ksample/=MESH) then
          if(printable) then
             write(nfout,'(1x,"!* linear tetrahedron cannot be used for way_ksample = ",i3)') way_ksample
             write(nfout,'(1x,"!* parabolic broadning is used instead ")')
          end if
          way_BZintegral = LORENTZIAN_B
          call set_default_width
       else
          ! check tetra_eps
          if(printable) &
               &  write(nfout,'(1x,"!* Brillouin zone integration method = linear tetrahedron")')
          if(tetra_eps > 0.0d0) then
             if(printable) write(nfout,'(1x,"!* tetra_eps = ",e12.5," hartree")') tetra_eps
          else
             tetra_eps = 1.0d-4
             if(printable) write(nfout,'(1x,"!* tetra_eps =<0.0d0 is read ; tetra_eps =1.0d-4 hartree is set")')
          end if
          ! check nistep
          if(nistep >= 1) then
             if(nistep > nstep) then
                nistep = nstep
                if(printable) then
                   write(nfout,'(1x,"!* nistep = ",i4," is larger than nstep = ",i4)') nistep, nstep
                   write(nfout,'(1x,"!* nistep = ",i4," is set as default.")') nstep
                end if
             else
                if(printable) write(nfout,'(1x,"!* nistep = ",i4)') nistep
             end if
          else
             if(nistep < 1) then
                nistep = nstep
                if(printable) then
                   write(nfout,'(1x,"!* nistep = ",i4," is set as default.")') nstep
                end if
             end if
          end if
       end if
    end if
    
    if (way_BZintegral/=L_TETRAHEDRON) then
       if (printable) then
          if (way_BZintegral==GAUSSIAN_B) then
             write(nfout,'(1x,"!* Brillouin zone integration method = gaussian broadning")')
             if ( width<=0.0d0 ) then
                call set_default_width
             else
                if(printable) &
                     & write(nfout,'(1x,"!* smearing width = ",f10.5)') width
             end if
          end if
          if (way_BZintegral==LORENTZIAN_B) &
               & write(nfout,'(1x,"!* Brillouin zone integration method = Lorentzian broadning")')
       end if
    end if
    
    !!       if(printable) then
    !!          write(nfout,'(1x,"!* spin = ",i3)') spin
    !!          if(spin/=BOTH) then
    !!             if(spin==MAJOR) write(nfout,'(1x,"!* integration for major spin")')
    !!             if(spin==MINOR) write(nfout,'(1x,"!* integration for minor spin")')
    !!          end if
    !!       end if
  end subroutine BZ_integration_option
  
  subroutine set_default_width
    width=0.01837451d0
    if(printable) &
         & write(nfout,'(1x,"!* default smearing width of 0.01837451 Hartree (=0.5eV) is set")')
  end subroutine set_default_width
  
  subroutine scissor_operator_option
    if(scissor/=0.0d0 .and. printable) then
       write(nfout,'(1x,"!* scissor operator = ", f10.5," Hartree ")') scissor
    end if
  end subroutine scissor_operator_option
  
end subroutine Setup_LinearResponse

       subroutine eigen_prd( n, a, nma0,
     &                  d_out, e_out, nme0, m_orig )
       use MPI
       use eigen_devel
       implicit NONE

       integer                :: n, nma0, nme0, m_orig
       integer                :: nm, ne, m
       real(8)                :: a(*)
       real(8)                :: d_out(*), e_out(*)

       include 'CSTAB.h'

       integer                :: nm0, nx0
       integer                :: i_1,j_1, i, j, k, j_2, j_3
       integer                :: nx, ierr

       integer, parameter     :: nm_max_L1 = 16*4
       integer, parameter     :: nm_max_L2 = 16*4*2


       real(8)                :: d1, d2
       real(8)                :: c1, c2

       integer :: lda, ldz, nz

       nm = nma0
       ne = nme0
       m  = m_orig

       call eigen_timer_reset( )

       lda = nma0
!       ldz = (n-1)/x_nnod+1
!       call CSTAB_get_optdim(ldz,9,nm_max_L1,nm_max_L2,nx)
!       ldz = nx
!       nz = (n-1)/y_nnod+1

       call eigen_prd_(a, lda, d_out, e_out, ne, n, m)

       call flush(6)

       call eigen_timer_print( )

       return
       end subroutine ! tred1

       subroutine eigen_prd_(a, nm, d_out, e_out, ne, n, m_orig)
       use MPI
       use eigen_devel
       implicit NONE

       integer                :: n, nm, ne, nmx, nv, nvx, m_orig
       real(8)                :: a(1:nm,*)
       real(8)                :: d_out(1:n)
       real(8)                :: e_out(1:ne,*)

       real(8), pointer       :: u_t(:), v_t(:), d_t(:)
       real(8), pointer       :: w(:)
       real(8), pointer       :: ux_vx(:)
       real(8), pointer       :: uy_vy(:)

       include 'CSTAB.h'
       include 'param.h'

       real(8)                :: d1,d2
       real(8)                :: d3,d4
       integer                :: nm_orig, nx, n1, n2, n3
       integer                :: i,j,k
       integer                :: l_uv_t

       integer                :: ierr, kx

       integer                :: offset1, offset2, offset3
       integer                :: offset4, offset5, offset6
       integer                :: offset7, offset8

       integer, parameter     :: nm_max_L1 = 16*4
       integer, parameter     :: nm_max_L2 = 16*6

#if _DEBUG_
#if _DEBUG2_
           allocate( rt_timer(1:(n-1)/2+2, 0:6) )
           rt_ptr(0:6) = 0
           rt_timer(1:(n-1)/2+2, 0:6) = 0D0
#endif
#endif

           nx = (n-1)/x_nnod+1 +2
           call CSTAB_get_optdim(nx, 6, nm_max_L1, nm_max_L2, nv)

           l_uv_t = MAX(2*nv,
     &                  2*(n+MAX(3,y_nnod/n_common)),
     &                  2*8*m_orig)
       allocate(
     &           w(1:nm*m_orig+n_columns),
     &           v_t(1:l_uv_t+n_columns),
     &           u_t(1:l_uv_t+n_columns),
     &           d_t(1:nv+n_columns),
     &           ux_vx(1:nv*2*m_orig+2*n_columns),
     &           uy_vy(1:nv*2*m_orig+2*n_columns),
     &           stat=ierr)
       if ( ierr /= 0 ) then
          if ( TRD_inod == 1 ) print*,"Memory allocation error."
          call MPI_Abort(TRD_COMM_WORLD, 1, ierr)
       end if

       w = ZERO
       v_t = ZERO
       u_t = ZERO
       d_t = ZERO
       ux_vx = ZERO
       uy_vy = ZERO

       kx = nv*m_orig+n_columns
       call CSTAB_adjust_base(ux_vx(1), a(1,1),offset1)
       call CSTAB_adjust_base(ux_vx(1+kx), a(1,1),offset3)
       call CSTAB_adjust_base(uy_vy(1), a(1,1),offset2)
       call CSTAB_adjust_base(uy_vy(1+kx), a(1,1),offset4)
       call CSTAB_adjust_base(u_t(1),a(1,1),offset5)
       call CSTAB_adjust_base(v_t(1),a(1,1),offset6)
       call CSTAB_adjust_base(w(1),a(1,1),offset7)
       kx = (L1_WINDOW/8)
!     &           +(L1_WINDOW)
!     &           +(L1_LSIZE/8)
     &           +(L1_LSIZE)
     &           +(L2_LSIZE/8)
       offset1 = offset1+kx*1
       offset2 = offset2+kx*2
       offset3 = offset3+kx*3
       offset4 = offset4+kx*4
       offset5 = offset5+kx*5
       offset6 = offset6+kx*6
       offset7 = offset7+kx*7
       call CSTAB_round_offset(offset1)
       call CSTAB_round_offset(offset2)
       call CSTAB_round_offset(offset3)
       call CSTAB_round_offset(offset4)
       call CSTAB_round_offset(offset5)
       call CSTAB_round_offset(offset6)
       call CSTAB_round_offset(offset7)

!!!
       kx = nv*m_orig+n_columns

!$OMP PARALLEL
       call eigen_prd_body(
     &               a, nm, d_out, e_out, ne,
     &               n, m_orig,
     &               w(1+offset7),
     &               ux_vx(1   +offset1),    ! u_x(1:nv,m)
     &               uy_vy(1   +offset2),    ! u_y(1:nv,m)
     &               ux_vx(1+kx+offset3),    ! v_x(1:nv,m)
     &               uy_vy(1+kx+offset4),    ! v_y(1:nv,m)
     &               u_t(1+offset5),
     &               v_t(1+offset6),
     &               d_t(1),
     &               nv)
!$OMP END PARALLEL

       deallocate(w)
       deallocate(v_t)
       deallocate(u_t)
       deallocate(d_t)
       deallocate(ux_vx)
       deallocate(uy_vy)

#if _DEBUG_
#if _DEBUG2_
           if ( TRD_inod == 1 ) then
              k=1
              do j=0,6
                 k = MAX(k, rt_ptr(j))
              end do
              do j=1,k
                 print*, j, (n-2*j)/x_nnod, rt_timer(j,0:6)
              end do
           end if
           deallocate( rt_timer )
#endif
#endif

       return
       end subroutine ! tred1_

       subroutine eigen_prd_body( a, nm, d_out, e_out, ne,
     &               n, m_orig,
     &               w, u_x, u_y, v_x, v_y, u_t, v_t, d_t, nv )
!$     use OMP_LIB
       use MPI
       use eigen_devel
       implicit NONE

       integer, intent(in)    :: n, nm, ne, nv, m_orig
       real(8)                :: a(1:nm,*)
       real(8)                :: d_out(1:n), e_out(1:ne,*)
       real(8)                :: w(1:nm,*)
       real(8)                :: u_x(1:nv,*), u_y(1:nv,*)
       real(8)                :: v_x(1:nv,*), v_y(1:nv,*)
       real(8)                :: u_t(1:2*nv), v_t(1:2*nv)
       real(8)                :: d_t(1:nv)
       real(8)                :: g_g(1:4)

       real(8), save          :: c(MBAND,MBAND) ! c is used in t4x and t6_3
       real(8)                :: t1, t2, t3
       integer                :: i, j, k, l, m

       integer                :: i_1, i_2, i_3, i_4
       integer                :: j_1, j_2, j_3, j_4
       integer                :: k_1, k_2, k_3, k_4
       integer                :: l_1, l_2, l_3, l_4

       integer                :: m0, mm
       integer                :: i_block, i_base, x_pos, y_pos

       integer                :: ii

       real(8)                :: d1,d2,dd(100)

!
! initialization
!
       dd = 0.0D+00
       m  = MIN( m_orig, n )

!$OMP MASTER

#if TIMER_PRINT
       if ( TRD_inod == 1 ) then
          print*,"NUM.OF.PROCESS=",TRD_nnod,"(",x_nnod,y_nnod,")"
!$        print*,"NUM.OF.THREADS=",omp_get_num_threads()
       endif
       call flush(6)
#endif

       call eigen_prd_init(a(1,1), nm, n,
     &         d_out(1), e_out(1,1), ne,
     &         u_t(1), v_t(1), nv)

!$OMP END MASTER

!
! main iteration to reduce the input matrix into a penta-diagonal
!
       mm = ((n-(MBAND+MOD(n,MBAND)))-1)/m+1+1

!$OMP BARRIER

       do i_block=mm,2,-1

!$OMP BARRIER

          i_base = (i_block-2)*m+(MBAND+MOD(n,MBAND))
          m0     = MIN(m,n-i_base)

!$OMP MASTER

          call eigen_prd_load(a(1,1), w(1,1), nm,
     &            d_t(1),
     &            u_x(1,1), u_y(1,1), v_x(1,1), v_y(1,1), nv,
     &            m0, i_base, i_block)

!$OMP END MASTER

          k_2 = m0
          k_3 = MAX(1,3*(2-i_block))

!$OMP BARRIER

          do k_1=k_2,k_3,-MBAND; k_4=k_1-MBAND+1

!$OMP BARRIER

             i = i_base+k_1
!
! u=...
!
!$OMP MASTER
             d1=eigen_get_wtime()
!$OMP END MASTER

             call eigen_prd_ux(
     &               w(1,k_4), nm,
     &               u_x(1,k_4), u_y(1,k_4), nv,
     &               u_t(1), v_t(1), i,
     &               c(1,1), e_out(1,1), ne)

!$OMP MASTER
             d2=eigen_get_wtime()
             dd(1)=dd(1)+(d2-d1)
#if _DEBUG_
#if _DEBUG2_
             rt_ptr(0) = rt_ptr(0) + 1
             rt_timer(rt_ptr(0),0) = d2-d1
#endif
#endif
!$OMP END MASTER
!$OMP BARRIER
!$OMP MASTER
             d1=eigen_get_wtime()
!$OMP END MASTER
!
! v:=Au
!
             call eigen_prd_au(
     &               a(1,1), nm,
     &               u_x(1,k_4), u_y(1,k_4), v_x(1,k_4), nv,
     &               u_t(1), v_t(1), d_t(1),
     &               i, i_base, m0)

!$OMP MASTER
             d2=eigen_get_wtime()
             dd(2)=dd(2)+(d2-d1)
#if _DEBUG_
#if _DEBUG2_
             rt_ptr(4) = rt_ptr(4) + 1
             rt_timer(rt_ptr(4),4) = d2-d1
#endif
#endif
!$OMP END MASTER
!$OMP BARRIER
!$OMP MASTER
             d1=eigen_get_wtime()
!$OMP END MASTER
!
! v=v-(UV+VU)u
! v':= v-((u,v)/2|u|^2)u
!
!$OMP MASTER
             call eigen_prd_vo(
     &               u_x(1,1), v_x(1,1), v_y(1,1), nv,
     &               u_t(1), v_t(1), c(1,1),
     &               i, i_base, m0)
!$OMP END MASTER

!$    if ( omp_get_thread_num() /= 0 ) then
#if USE_SYNC
!$           if ( MPI_THREAD_MODE == MPI_THREAD_SINGLE .OR.
!$   &            MPI_THREAD_MODE == MPI_THREAD_FUNNELED ) then
!$OMP MASTER
              call barrier( y_COMM_WORLD )
              call barrier( x_COMM_WORLD )
!$OMP END MASTER
!$           else
!$    if ( omp_get_thread_num() == 1 ) then
!$            call barrier( y_COMM_WORLD )
!$            call barrier( x_COMM_WORLD )
!$    end if
!$           end if
#endif
!
! following BARRIER is called from non-master threads
! and by the master thread working in eigen_prd_vo
! they (all the threads) synchronize over here.
!
!$OMP BARRIER
!
!$    end if

!$OMP MASTER
             d2=eigen_get_wtime()
             dd(5)=dd(5)+(d2-d1)
#if _DEBUG_
#if _DEBUG2_
!             rt_ptr(3) = rt_ptr(3) + 1
!             rt_timer(rt_ptr(3),3) = d2-d1
#endif
#endif
!$OMP END MASTER

!$OMP BARRIER

!$OMP MASTER
             d1=eigen_get_wtime()
!$OMP END MASTER
!
! w':= w-uv-vu
!
!$OMP MASTER
             call eigen_prd_local_2update(
     &               w(1,1), nm,
     &               u_x(1,1), u_y(1,1), v_x(1,1), v_y(1,1), nv,
     &               i_base, i)
!$OMP END MASTER

!$OMP MASTER
             d2=eigen_get_wtime()
             dd(6)=dd(6)+(d2-d1)
!$OMP END MASTER

!=!$OMP BARRIER

          end do! k_1

!$OMP BARRIER

!$OMP MASTER
          call eigen_prd_store(a(1,1), w(1,1), nm,
     &            d_t(1),
     &            m0, i_base)
!$OMP END MASTER

!$OMP BARRIER

!$OMP MASTER
          d1=eigen_get_wtime()
!$OMP END MASTER
!
! A:=A-v^Tu-uT^v
!
!          if ( i_block >= 1 ) then
             call eigen_prd_2update(
     &               a(1,1), nm,
     &               u_x(1,1), u_y(1,1), v_x(1,1), v_y(1,1), nv,
     &               m0, i_base)
!          end if

!$OMP BARRIER

!$OMP MASTER
          d2=eigen_get_wtime()
          dd(3)=dd(3)+(d2-d1)

!$OMP END MASTER

!$OMP BARRIER

       end do! i_block

!$OMP BARRIER

!$OMP MASTER

       call eigen_prd_final(a(1,1), nm, n,
     &         d_out(1), e_out(1,1), ne, u_t(1))

#if TIMER_PRINT
       if(TRD_inod==1)then
            print*,"calc (u,beta)    ",dd(1)
            print*,"mat-vec (Au)     ",dd(2),dble(n)**3*2d-9/3/dd(2)
            print*,"2update (A-uv-vu)",dd(3),dble(n)**3*2d-9/3/dd(3)
            print*,"calc v           ",dd(4)
            print*,"v=v-(UV+VU)u     ",dd(5)
            print*,"UV post reduction",dd(6)
       endif
       call flush(6)
#endif

!$OMP END MASTER

       return
       end subroutine ! trd_body

#ifdef ENABLE_ESM_PACK
subroutine Preparation_for_ESM()
    use m_Const_Parameters, only : ON,BARE,PE1,PE2,DP
    use m_Control_Parameters, only : gmaxp,kimg,nspin,sw_esm,esm_z1,esm_izwall &
  &                                , esm_iexpot,esm_z_wall,esm_bar_height,esm_bar_width, esm_e_field &
  &                                , esm_fix_ef,esm_add_elec,esm_gps,esm_gpe,ipriesm,nspin,esm_bc,esm_w &
  &                                , esm_izwall, esm_z_wall, esm_bar_height, esm_bar_width, noncol
    use m_Ionic_System, only : natm,natm2,ityp,iatomn,ntyp,ival,cps
    use m_FFT, only : fft_box_size_CD
    use m_Crystal_Structure, only : altv
    use m_Parallelization, only : npes,mype, ista_kngp, iend_kngp, mpi_comm_group
    use m_PlaneWaveBasisSet, only : ngabc,igfp_l,kgp

    implicit none
    include 'mpif.h'
    character(len=3) :: esm_bc_c
    real(kind=DP), allocatable,dimension(:) :: ival_at
    real(kind=DP), allocatable, dimension(:,:) :: cps_tmp
    integer, allocatable, dimension(:,:) :: ngabc_esm
    integer, allocatable, dimension(:) :: igfp_l_esm
    integer :: i,j,ierr
    integer :: nspin_m

    if(sw_esm/=ON) return
    if(esm_bc==BARE)then 
       esm_bc_c = 'bc1'
    else if (esm_bc == PE1) then
       esm_bc_c = 'bc2'
    else if (esm_bc == PE2) then
       esm_bc_c = 'bc3'
    endif
    allocate(ival_at(natm));ival_at=0.d0
    do i=1,natm
       ival_at(i) = ival(ityp(i))
    enddo
!    allocate(ngabc_esm(3,1:iend_kngp-ista_kngp+1));ngabc_esm=0
    allocate(ngabc_esm(3,1:kgp));ngabc_esm=0
    do i=1,3
       do j=ista_kngp,iend_kngp
          ngabc_esm(i,j) = ngabc(j,i)
       enddo
    enddo
    call mpi_allreduce(mpi_in_place,ngabc_esm,3*kgp,mpi_integer,mpi_sum,mpi_comm_group,ierr)
    allocate(cps_tmp(3,natm))
    do i=1,3
       do j=1,natm
          cps_tmp(i,j) = cps(j,i)
       enddo
    enddo
    allocate(igfp_l_esm(1:kgp));igfp_l_esm=0
    do i=ista_kngp,iend_kngp
       igfp_l_esm(i) = igfp_l(i)
    enddo
    call mpi_allreduce(mpi_in_place,igfp_l_esm,kgp,mpi_integer,mpi_sum,mpi_comm_group,ierr)

    if ( noncol ) then
       nspin_m = 1
    else
       nspin_m = nspin
    endif

    call Esm_interface_map_parameters(natm,ival_at,cps_tmp,1.0d0,altv, &
    & fft_box_size_CD(1,0),fft_box_size_CD(2,0),fft_box_size_CD(3,0),  &
    & esm_bc_c,.false.,kgp,nspin_m,ngabc_esm,                            &
    & igfp_l_esm,igfp_l_esm,esm_w,2.0d0*esm_e_field, esm_izwall,       &
    & esm_z_wall, esm_bar_height,esm_bar_width)
    call Esm_interface_set_communicator(mpi_comm_group)
    call Esm_interface_set_npes_mype(npes,mype)
    deallocate(igfp_l_esm)
    deallocate(ival_at)
    deallocate(ngabc_esm)
    deallocate(cps_tmp)
end subroutine Preparation_for_ESM
#endif

#define POST3D
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  MAIN PROGRAM: PHASE
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!  $Id: mdmain.F90 633 2020-12-01 05:11:03Z jkoga $
!
#ifdef FJ_TIMER
#  define __TIMER_FJ_START_w_BARRIER(str,a)  call mpi_barrier(str,ierr); call timer_sta(a)
#  define __TIMER_FJ_START(a)                call timer_sta(a)
#  define __TIMER_FJ_STOP(a)                 call timer_end(a)
#else
#  define __TIMER_FJ_START_w_BARRIER(str,a)
#  define __TIMER_FJ_START(a)
#  define __TIMER_FJ_STOP(a)
#endif
#ifdef __TIMER__
#  define __TIMER_START_w_BARRIER(str,a)  call mpi_barrier(str,ierr) ;   call timer_sta(a)
#  define __TIMER_START(a)                call timer_sta(a)
#  define __TIMER_STOP(a)                 call timer_end(a)
#else
#  define __TIMER_START_w_BARRIER(str,a)
#  define __TIMER_START(a)
#  define __TIMER_STOP(a)
#endif
!
program PHASE

#ifdef PARA3D
!!$  use m_Parallelization,     only : myrank_k_3D  , map_k_3D, np_e   &
!!$ &                                , ista_k       , iend_k           &
!!$ &                                , ista_kngp    , iend_kngp        &
!!$ &                                , ista_k_3D    , iend_k_3D        &
!!$ &                                , ista_kngp_3D , iend_kngp_3D     &
!!$ &                                , ista_snl, iend_snl &
!!$ &                                , np_fs_3D     , np_e_3D , np_g1k_3D 
!!$  use m_Electronic_Structure,only : zaj_l, zaj_l_3D       &
!!$ &                                , eko_l, eko_l_3D       &
!!$ &                                , fsr_l, fsr_l_3D       &
!!$ &                                , fsi_l, fsi_l_3D       &
!!$ &                                , occup_l, occup_l_3D    &
!!$ &                                , vlhxc_l, vlhxc_l_3D   &
!!$ &                                , nrvf_ordr,neordr      &
!!$ &                                , vlhxcQ
!!$  use z_interface_3D, only        : decomp_eko_l_3D       &
!!$       &                          , decomp_eko_l_3D_2     &
!!$       &                          , decomp_eko_l_r_3D     &
!!$       &                          , decomp_eko_l_r_3D_2   &
!!$       &                          , decomp_fsr_l_3D       &
!!$       &                          , decomp_fsr_l_3D_ik    &
!!$       &                          , decomp_snl_l_3D       &
!!$       &                          , decomp_snl_l_r_3D     &
!!$       &                          , decomp_snl_l_3D_2     &
!!$       &                          , decomp_zaj_l_3D       &
!!$       &                          , decomp_zaj_l_3D_ik    &
!!$       &                          , decomp_fsr_l_r_3D     &
!!$       &                          , decomp_fsr_l_r_3D_ik  &
!!$       &                          , decomp_vnlph_l_r_3D   &
!!$       &                          , decomp_vnlph_l_3D     &
!!$       &                          , decomp_zaj_l_r_3D     &
!!$       &                          , decomp_zaj_l_r_3D_ik  &
!!$       &                          , decomp_vlhxc_l_3D     &
!!$       &                          , decomp_vlhxc_l_r_3D   &
!!$       &                          , decomp_wfsd_l_3D      &
!!$       &                          , decomp_wfsd_l_r_3D    &
!!$       &                          , decomp_zfm3_l_3D      &
!!$       &                          , decomp_zfm3_l_r_3D    &
!!$       &                          , decomp_psc_l_3D       &
!!$       &                          , decomp_psc_l_r_3D     &
!!$       &                          , decomp_qitg_l_3D      &
!!$       &                          , decomp_qitg_l_r_3D    &
!!$       &                          , decomp_gr_l_3D        &
!!$       &                          , decomp_gr_l_r_3D      &
!!$       &                          , decomp_occup_l_3D     &
!!$       &                          , decomp_occup_l_r_3D   &
!!$       &                          , decomp_ngpt_l_3D      &
!!$       &                          , decomp_ngpt_l_r_3D    &
!!$       &                          , decomp_igfp_l_3D      &
!!$       &                          , decomp_igfp_l_r_3D    &
!!$       &                          , replacement_zaj_ball_eigenvalue  &
!!$       &                          , replacement_zaj_ball_sequence
!!$  use m_Parallelization,    only  : mype
!!$  use m_IterationNumbers,   only  : iteration
!!$  use m_Control_Parameters,  only : nspin,kimg,neg,af,istress,sw_fine_STM_simulation, ON &
!!$       &                          , initial_chg, sw_positron
!!$  use m_Crystal_Structure,  only : nopr
!!$  use m_Const_Parameters,    only : GAMMA, from_PSEUDOPOTENTIAL_FILE, DEFECT, BULK
!!$  use m_PlaneWaveBasisSet,   only : kg1,kg,kgp           &
!!$  &                               , gr_l   , gr_l_3D     &
!!$  &                               , ngpt_l , ngpt_l_3D   &
!!$  &                               , igfp_l , igfp_l_3D
!!$  use m_Kpoints,             only : kv3, k_symmetry
!!$  use m_PseudoPotential,     only : nlmta   , nlmtt            &
!!$ &                                , qitg_l  , qitg_l_3D  , nqitg   &
!!$ &                                , psc_l   , psc_l_3D             &
!!$ &                                , rhpcg_l , rhpcg_l_3D , ntpcc   &
!!$ &                                , qitg_diff_l  , qitg_diff_l_3D  &
!!$ &                                , psc_diff_l   , psc_diff_l_3D   &
!!$ &                                , rhpcg_diff_l , rhpcg_diff_l_3D &
!!$ &                                , rhcg_l  , rhcg_l_3D   &
!!$ &                                , rhceg_l , rhceg_l_3D  &
!!$ &                                , rhchg_l , rhchg_l_3D  &
!!$ &                                , rhvg_l  , rhvg_l_3D
!!$  use m_NonLocal_Potential,  only : snl, snl_l_3D
!!$  use m_Charge_Density,      only : chgq_l , chgq_l_3D              &
!!$       &                          , chgqo_l, chgqo_l_3D             &
!!$       &                          , chgsoft, chgsoft_3D
!!$  use m_XC_Potential,        only : vxc_l  , vxc_l_3D               &
!!$       &                          , vxcpc_l, vxcpc_l_3D
!!$  use m_Ionic_System,        only : zfm3_l, zfm3_l_3D, ntyp
#endif
  use m_Files,                only : nfout
  use m_Ionic_System,         only : natm
  use m_PseudoPotential,      only : mmesh
  use m_Parallelization,      only : m_Parallel_init_mpi_paw_3D
  use m_Control_Parameters,   only : ipriparallel

  use m_Const_Parameters,    only : DRIVER_NEB,DRIVER_CONSTRAINT,DRIVER_MTD,DRIVER_SC_DFT, DRIVER_DIMER
  use m_Parallelization,     only : mpi_comm_group

! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
use mod_timer
use m_Parallelization, only  : mype
#endif
! === TIMERTIMERTIMER ==========================================================

  implicit none
  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Already_Converged, Already_Converged2
  logical  :: Positron_bulk, Positron_defect, Structure_is_fixed
  logical  :: Hubbard_model
  logical  :: Forces_are_Converged, Ending_Time, Force_errors_are_tolerable,UnitCell_Converged &
  &         , Forces_are_Converged2
  logical  :: from_Initialize
  logical  :: InUeffRamping
!!$  logical  :: ChargeDensity_is_Fixed
   interface
     subroutine Initialization(init_mpi)
       integer, intent(in), optional :: init_mpi
     end subroutine Initialization
   end interface
#ifdef NEC_ITER_REG
  integer  :: count_for_ftrace
#endif

  integer :: ispin, ik, iksnl, ierR

  integer :: initmpi
  logical :: confpara
  integer :: driver
  logical :: uconv,ending_t,force_conv
  logical :: initialization_required
  
#ifdef NEC_ITER_REG
     count_for_ftrace = 0
     call FTRACE_REGION_BEGIN("INITIAL")
#endif

  confpara = Resolve_Config_Parallel()
  initmpi=1
  if(confpara) initmpi=0

  do

  ending_t = .false.
                                                  __TIMER_START(17)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,21)
!  call Initialization(init_mpi=1)
  call Initialization(initmpi)
                                                  __TIMER_FJ_STOP(21)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,22)
  call InputData_Analysis

  driver   = Resolve_Driver()

  if(ekmode()) then
    call Initialization_set_ekmode_ON()
  endif

  if (driver==DRIVER_NEB)then
#ifndef DISABLE_CONSTRAINTS
      call do_neb()
  else if (driver==DRIVER_DIMER) then
      call do_dimer_method()
  else if (driver==DRIVER_CONSTRAINT) then
      call constrained_dynamics()
  else if (driver==DRIVER_MTD) then
      call meta_dynamics()
#endif
  else
  outer_loop:do

!  if(driver==DRIVER_SC_DFT .and. .not.Initial_SCDFTLoop()) then
!     call InputData_Analysis()
!     if(ekmode()) call Initialization_set_ekmode_ON()
!  end if
                                                  __TIMER_FJ_STOP(22)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,23)
  call Preparation(0)                  ! Basis set, symmetry check etc.
                                                  __TIMER_FJ_STOP(23)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,24)
  if(ekmode()) call Preparation_for_mpi_ek()
  if(initialization_required()) then
    call Preparation_for_mpi(1)        ! mpi
  endif
                                                  __TIMER_FJ_STOP(24)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,25)
  call PseudoPotential_Construction
                                                  __TIMER_FJ_STOP(25)
  call  m_Parallel_init_mpi_paw_3D(nfout,ipriparallel,natm,mmesh)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,26)
#ifdef ENABLE_ESM_PACK
  if(initialization_required())then
    call Preparation_for_ESM
  endif
#endif

  call Ewald_and_Structure_Factor
                                                  __TIMER_FJ_STOP(26)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,27)
  call Initial_Electronic_Structure
                                                  __TIMER_FJ_STOP(27)
                                                  __TIMER_STOP(17)

!!  from_Initialize = .false.
!$$  from_Initialize = .true.
!$$  if(from_Initialize) call Para3d_Entry()
 
  if(ChargeDensity_is_Fixed() .and. One_by_one_in_each_rank_k()) then ! icond=2, 3
     call ekcal()  ! contained here
     exit outer_loop
  else
     call Initial_MD_Condition
#ifdef NEC_ITER_REG
     call FTRACE_REGION_END("INITIAL")
#endif

     force_conv = Already_Converged()
     if(.not.force_conv) then
#ifdef NEC_ITER_REG
        call FTRACE_REGION_BEGIN("SOLVE-FIRST")
#endif
        StressLoop: do
           AtomicConfiguration: do
              force_conv = Forces_are_Converged2()
              if(force_conv) then
                exit AtomicConfiguration
              endif
              ChargeDensity:    do

#ifdef NEC_ITER_REG
                 count_for_ftrace = count_for_ftrace + 1
                 if(count_for_ftrace .eq. 2) then
                    call FTRACE_REGION_END("SOLVE-FIRST")
                    call FTRACE_REGION_BEGIN("SOLVE-CORE")
                 end if
#endif
                 call IterationNumber_Setting

! ============================ added by K. Tagami ============- 5.0
                 call Renewal_of_Chg_Ctrl_Param
! ============================================================ 5.0
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,16)
!!$                 call ReadCheckPointData_if_needed
                 call Renewal_of_WaveFunctions
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,11)
                 call ChargeDensity_Construction(1)
                 call ChargeDensity_Mixing
                                                  __TIMER_STOP(11)
                 ending_t = Ending_Time()
                 if(ending_t)                      exit outer_loop
                 if(TotalEnergy_is_Divergent())    exit outer_loop
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,11)
                 call Renewal_of_Potential
                                                  __TIMER_STOP(11)
                 if(Hubbard_model()) then
                    call Renewal_of_Hubbard_Potential
                 end if
!!$                 call WriteCheckPointData  ! if necessary
                 if(ChargeDensity_is_Converged()) then
                                                  __TIMER_STOP(16)
                    exit ChargeDensity
                 end if
                                                  __TIMER_STOP(16)
              enddo ChargeDensity

!$$!              call PARA_3Dto2D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!

              if(Structure_is_fixed()) then
                  force_conv = .true.
                  exit StressLoop
              end if
!$$!              call PARA_2Dto3D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!
#ifdef LIBRARY_BUILD
              call Forces_phase0
#else
              call Forces
#endif
!$$!              call PARA_3Dto2D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!
              force_conv = Forces_are_Converged()
              if(force_conv) then
                 if ( epsilon_post_scf() ) call Epsilon_PostScf
                 exit AtomicConfiguration
              endif
              if(Force_errors_are_tolerable()) then
                 call Postprocessing_during_MD()
                 call Move_Ions
!$$!              call PARA_2Dto3D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!
!$$!              call PARA_3Dto2D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!
                 call MDIterationNumber_Setting
                 call Ewald_and_Structure_Factor
              end if

              if ( Enforce_Update_Cell() )  exit AtomicConfiguration

              if(BreakMD(force_conv))then
                 exit AtomicConfiguration
              endif
              call Postproc_after_SCF_convergence()
           enddo AtomicConfiguration
           if(driver==DRIVER_SC_DFT) exit StressLoop
           call Stress
           exit StressLoop
        end do StressLoop

!$$!        call PARA_3Dto2D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!


#ifdef NEC_ITER_REG
        if(count_for_ftrace .eq. 1) then
           call FTRACE_REGION_END("SOLVE-FIRST")
        else
           call FTRACE_REGION_END("SOLVE-CORE")
        end if
#endif
     end if
     if (InUeffRamping().and. .not.ending_t)then
        call MDiterationNumber_Setting3()
        if(.not.ending_t) call Array_Deallocate()
     else if (driver == DRIVER_SC_DFT.and. .not.ending_t) then
! * T.Hamada 2016.1.8 + T. Yamasaki 2016.02.21
        write(6,'(" driver = DRIVER_SC_DFT")')
        call flush(6)
        call Epsilon_Paramset
        call Epsilon_Postscf
        call setalpha_exx()
! * T.Hamada 2015.1.8
        if(Break_SC_DFT()) exit outer_loop
!!$! * T.Hamada 2015.11.4
        call SCDFTIterationNumber_Setting
        call Set_Icond
        call WriteDownData_onto_Files(.false.)
        if(.not.ending_t) call Array_Deallocate()
     else
!!$#ifdef POST3D
!!$        if(.not.InUeffRamping()) call Postprocessing(.false.)
!!$#endif
        exit outer_loop
     endif

  end if

  enddo outer_loop

  uconv = UnitCell_Converged(force_conv)
  if(.not.uconv.and..not.ending_t)then
     call MDIterationNumber_Setting2()
     call WriteDownData_onto_Files(.false.)
  else
     if(ChargeDensity_is_Fixed() .and. One_by_one_in_each_rank_k()) then ! icond=2, 3
        !call Postprocessing(.false.)
        !call WriteDownData_onto_Files_ek()
     else
       call WriteDownData_onto_Files(.false.)
#ifdef POST3D
       if(uconv) call Postprocessing(.false.)
#endif
!!$        if(driver/=DRIVER_SC_DFT) then
!!$!BRANCH_P ORG_Parallel
!!$! * T.Hamada 2016.1.8
!!$           call Epsilon_Paramset
!!$           call Epsilon_Postscf
!!$        end if
!!$! * T.Hamada 2015.1.8
!!$!BRANCH_P_END ORG_Parallel
        if ( uconv .and. epsilon_post_proc() ) call Epsilon_PostScf
        call rttddft_main
!        call WriteDownData_onto_Files(ending_t.or.uconv)
        if(ending_t .or. uconv) call final_output()
        if(uconv) exit
     end if
  endif
  if(.not.ending_t) call MDiterationNumber_Setting_pre()

#ifdef NEC_ITER_REG
     call FTRACE_REGION_BEGIN("FINAL")
#endif

!$$!        call PARA_2Dto3D()
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,39)
  if(.not.ending_t) then
     call Array_Deallocate()
     call Continuation_Mode()
  endif

  endif

  if (ending_t .or. OneShot()) exit

  enddo

  if(driver/=DRIVER_NEB) call Finalization_of_mpi           ! mpi
#ifdef NEC_ITER_REG
  call FTRACE_REGION_END("FINAL")
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call print_timer(mype)
#endif
! === TIMERTIMERTIMER ==========================================================
contains
  subroutine final_output()
    use m_Files, only : m_Files_close_all, m_Files_close_logfile
    use m_Control_Parameters, only : m_CtrlP_wd_cpu_total
    implicit none
    call m_CtrlP_wd_cpu_total()
    call m_Files_close_all()                    ! -(m_Files)
    call PrintStatus()
    call m_Files_close_logfile()
  end subroutine final_output

  subroutine ekcal()
    use m_Epsilon_ek, only : sw_epsilon
    use m_Const_Parameters, only : ON
    logical :: AllKpoints_are_Calculated2,AllKpoints_are_Calculated, Already_Converged_for_Kgroup
    logical :: EigenValues_are_Converged, AllKpoints_are_Converged, Already_Converged
    integer :: nk
    logical :: all_conv = .true.
! --------------------T. Hamada 2021.9.28 --------------------
    logical  :: EPS_Prep_Check
!-------------------------------------------------------------
    nk = 0
    if(sw_epsilon == ON) then
      call Initialization_Epsilon(0)        ! Epsilon
      call Shift_Kpoint
    endif
    KPOINT_GROUP: do
       call KpointNumber_Setting2()
       if(AllKpoints_are_Converged()) exit KPOINT_GROUP
       call Preparation_ek()
       call Preparation_for_mpi_ek
       call epsmain_reallocate()
       if(sw_epsilon==ON)then
          call PseudoPotential_ek_Epsilon
       else
          call PseudoPotential_ek
       endif
       call Initial_WaveFunctions_ek
       if(.not.Already_Converged_for_kgroup()) then
          all_conv = .false.
          SolveWaveFunctions: do
!-------------------- T. Hamada 2021.9.28 --------------------
             if(EPS_Prep_Check())              exit KPOINT_GROUP
! ------------------------------------------------------------
             if(Ending_Time())                 exit KPOINT_GROUP
             call IterationNumber_Setting()
             call Renewal_of_WaveFunctions()
             if(EigenValues_are_Converged()) then
                if(sw_epsilon==ON)then
                   call Transition_moment_Epsilon                           ! Epsilon
                   call Dealloc_Radr_and_Wos_Epsilon                        ! Epsilon
                endif
                exit SolveWaveFunctions
             endif
          enddo SolveWaveFunctions
          call Postprocessing_k()
          if(AllKpoints_are_Calculated2(nk)) then
             all_conv = .true.
             exit KPOINT_GROUP
          endif
       else
          exit KPOINT_GROUP
       end if
       call Finalization_ek()
    enddo KPOINT_GROUP
    call Postprocessing(.false.)
!-------------------- T. Hamada 2021.9.28 --------------------
    if((all_conv.and.sw_epsilon==ON) .or.EPS_Prep_Check()) then
!-------------------------------------------------------------
      call Reset_Kpoint                                                   ! Epsilon
      call Prep_for_Calc_Epsilon                                          ! Epsilon
      call Calc_Epsilon                                                   ! Epsilon
      call Calc_Nonlinear_optics                                          ! Epsilon
      call WriteDownData_onto_Files_Eps                                   ! Epsilon
    end if
    call WriteDownData_onto_Files_ek()
  end subroutine ekcal

  subroutine Finalization_ek()
    use m_Const_Parameters,   only : ON
    use m_Control_Parameters, only : sw_dos, sw_ldos
    use m_Ldos,               only : m_Ldos_dealloc_weiwsc_etc
    implicit none
!    if(sw_dos == ON .and. sw_ldos == ON) then
!      call m_Ldos_dealloc_weiwsc_etc()
!    endif
  end subroutine Finalization_ek

  logical function ChargeDensity_is_Fixed()
    use m_Control_Parameters, only : icond
    use m_Const_Parameters,   only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION
    if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
       ChargeDensity_is_Fixed = .true.
    else
       ChargeDensity_is_Fixed = .false.
    end if
  end function ChargeDensity_is_Fixed

  logical function One_by_one_in_each_rank_k()
    use m_Control_Parameters, only : fixed_charge_k_parallel
    use m_Const_Parameters,   only : ONE_BY_ONE
    if(fixed_charge_k_parallel == ONE_BY_ONE) then
       One_by_one_in_each_rank_k = .true.
    else
       One_by_one_in_each_rank_k = .false.
    end if
  end function One_by_one_in_each_rank_k

#ifdef PARA3D
!!$  subroutine Para3d_Entry()
!!$    if (allocated(vlhxc_l))    deallocate(vlhxc_l)
!!$    if (allocated(chgq_l))     deallocate(chgq_l)
!!$    if (allocated(chgqo_l))    deallocate(chgqo_l)
!!$    if(istress == ON .or. sw_fine_STM_simulation == ON) then
!!$       if (allocated(chgsoft)) deallocate(chgsoft)
!!$    end if
!!$    if (allocated(vxc_l))      deallocate(vxc_l)
!!$    if (allocated(vxcpc_l))    deallocate(vxcpc_l)
!!$    if (allocated(snl))        deallocate(snl)
!!$    if (allocated(eko_l))      deallocate(eko_l)
!!$    if (allocated(zaj_l))      deallocate(zaj_l)
!!$    if (allocated(fsr_l))      deallocate(fsr_l)
!!$    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!!$       if (allocated(fsi_l))   deallocate(fsi_l)
!!$    end if
!!$    if (allocated(occup_l))    deallocate(occup_l)
!!$    if (allocated(zfm3_l))     deallocate(zfm3_l)
!!$    if (allocated(gr_l))       deallocate(gr_l)
!!$    if (allocated(psc_l))      deallocate(psc_l)
!!$    if (allocated(qitg_l))     deallocate(qitg_l)
!!$    if (allocated(rhpcg_l))    deallocate(rhpcg_l)
!!$    if(istress==ON) then
!!$       if (allocated(psc_diff_l))      deallocate(psc_diff_l)
!!$       if (allocated(qitg_diff_l))     deallocate(qitg_diff_l)
!!$       if (allocated(rhpcg_diff_l))    deallocate(rhpcg_diff_l)
!!$    endif
!!$    if (allocated(ngpt_l))     deallocate(ngpt_l)
!!$    if (allocated(igfp_l))    deallocate(igfp_l)
!!$  end subroutine Para3d_Entry
!!$
!!$  subroutine PARA_2Dto3D()
!!$    !                timer_fj sta 37
!!$
!!$    allocate(vlhxc_l_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));             vlhxc_l_3D = 0.0d0
!!$    do ispin = 1, nspin, (af+1)
!!$       call decomp_vlhxc_l_3D(vlhxc_l,vlhxc_l_3D,ispin)
!!$    end do
!!$    deallocate(vlhxc_l)
!!$
!!$    allocate(chgq_l_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));              chgq_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       call decomp_vlhxc_l_3D(chgq_l,chgq_l_3D,ispin)
!!$    end do
!!$    deallocate(chgq_l)
!!$
!!$    allocate(chgqo_l_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));             chgqo_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       call decomp_vlhxc_l_3D(chgqo_l,chgqo_l_3D,ispin)
!!$    end do
!!$    deallocate(chgqo_l)
!!$
!!$    if(istress == ON .or. sw_fine_STM_simulation == ON) then
!!$       allocate(chgsoft_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));          chgsoft_3D = 0.0d0
!!$       do ispin = 1, nspin, (af+1)
!!$          call decomp_vlhxc_l_3D(chgsoft,chgsoft_3D,ispin)
!!$       end do
!!$       deallocate(chgsoft)
!!$    end if
!!$
!!$    allocate(vxc_l_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));               vxc_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       call decomp_vlhxc_l_3D(vxc_l,vxc_l_3D,ispin)
!!$    end do
!!$    deallocate(vxc_l)
!!$
!!$    allocate(vxcpc_l_3D(ista_kngp_3D:iend_kngp_3D,kimg));                   vxcpc_l_3D = 0.d0
!!$    deallocate(vxcpc_l)
!!$
!!$    allocate(snl_l_3D(maxval(np_g1k_3D),nlmtt,ista_snl:iend_snl));          snl_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_snl_l_3D_2(snl,snl_l_3D,ik)
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(snl)
!!$
!!$    allocate(eko_l_3D(np_e_3D,ista_k_3D:iend_k_3D));                        eko_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_eko_l_3D_2(eko_l,eko_l_3D,ik,nrvf_ordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(eko_l)
!!$
!!$    allocate(zaj_l_3D(maxval(np_g1k_3D),np_e_3D,ista_k_3D:iend_k_3D,kimg)); zaj_l_3D = 0.0d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_zaj_l_3D_ik(zaj_l,zaj_l_3D,ik,nrvf_ordr,"sort")
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(zaj_l)
!!$
!!$    allocate(fsr_l_3D(np_e_3D,np_fs_3D,ista_k_3D:iend_k_3D));               fsr_l_3D = 0.0d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_fsr_l_3D_ik(fsr_l,fsr_l_3D,ik,nrvf_ordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(fsr_l)
!!$
!!$    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!!$       allocate(fsi_l_3D(np_e_3D,np_fs_3D,ista_k_3D:iend_k_3D));            fsi_l_3D = 0.d0
!!$       do ispin = 1, nspin, (af+1)
!!$          do ik = ispin, kv3-nspin+ispin, nspin
!!$             if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$                call decomp_fsr_l_3D_ik(fsi_l,fsi_l_3D,ik,nrvf_ordr,'sort')
!!$             end if
!!$          end do
!!$       end do
!!$       deallocate(fsi_l)
!!$    end if
!!$
!!$    allocate(occup_l_3D(np_e_3D,ista_k_3D:iend_k_3D));                      occup_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_occup_l_3D(occup_l,occup_l_3D,ik,nrvf_ordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(occup_l)
!!$
!!$    allocate(zfm3_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp,kimg));               zfm3_l_3D = 0.d0
!!$    call decomp_zfm3_l_3D(zfm3_l,zfm3_l_3D)
!!$    deallocate(zfm3_l)
!!$
!!$    allocate(gr_l_3D(ista_kngp_3D:iend_kngp_3D));                           gr_l_3D =0.0d0
!!$    call decomp_gr_l_3D(gr_l,gr_l_3D)
!!$    deallocate(gr_l)
!!$
!!$    allocate(psc_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                     psc_l_3D =0.0d0
!!$    call decomp_psc_l_3D(psc_l,psc_l_3D)
!!$    deallocate(psc_l)
!!$
!!$    allocate(qitg_l_3D(ista_kngp_3D:iend_kngp_3D,nqitg));                   qitg_l_3D =0.0d0
!!$    call decomp_qitg_l_3D(qitg_l,qitg_l_3D,nqitg)
!!$    deallocate(qitg_l)
!!$
!!$    allocate(rhpcg_l_3D(ista_kngp_3D:iend_kngp_3D,ntpcc));                  rhpcg_l_3D =0.0d0
!!$    call decomp_qitg_l_3D(rhpcg_l,rhpcg_l_3D,ntpcc)
!!$    deallocate(rhpcg_l)
!!$
!!$    if(istress==ON) then
!!$       allocate(psc_diff_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));              psc_diff_l_3D =0.0d0
!!$       call decomp_psc_l_3D(psc_diff_l,psc_diff_l_3D)
!!$       deallocate(psc_diff_l)
!!$
!!$       allocate(qitg_diff_l_3D(ista_kngp_3D:iend_kngp_3D,nqitg));            qitg_diff_l_3D =0.0d0
!!$       call decomp_qitg_l_3D(qitg_diff_l,qitg_diff_l_3D,nqitg)
!!$       deallocate(qitg_diff_l)
!!$
!!$       allocate(rhpcg_diff_l_3D(ista_kngp_3D:iend_kngp_3D,ntpcc));           rhpcg_diff_l_3D =0.0d0
!!$       call decomp_qitg_l_3D(rhpcg_diff_l,rhpcg_diff_l_3D,ntpcc)
!!$       deallocate(rhpcg_diff_l)
!!$    endif
!!$
!!$    allocate(ngpt_l_3D(ista_kngp_3D:iend_kngp_3D,nopr+af));         ngpt_l_3D =0.0d0
!!$    call decomp_ngpt_l_3D(ngpt_l,ngpt_l_3D,nopr+af)
!!$    deallocate(ngpt_l)
!!$
!!$    allocate(igfp_l_3D(ista_kngp_3D:iend_kngp_3D));                 igfp_l_3D =0.0d0
!!$    call decomp_igfp_l_3D(igfp_l,igfp_l_3D)
!!$    deallocate(igfp_l)
!!$
!!$   if(initial_chg == from_PSEUDOPOTENTIAL_FILE) then
!!$      allocate(rhvg_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                     rhvg_l_3D =0.0d0
!!$      call decomp_psc_l_3D(rhvg_l,rhvg_l_3D)
!!$      deallocate(rhvg_l)
!!$   endif
!!$
!!$   if(sw_positron == BULK .or. sw_positron == DEFECT) then
!!$      allocate(rhcg_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                     rhcg_l_3D =0.0d0
!!$      allocate(rhceg_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                    rhceg_l_3D =0.0d0
!!$      allocate(rhchg_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                    rhchg_l_3D =0.0d0
!!$      call decomp_psc_l_3D(rhcg_l,rhcg_l_3D)
!!$      call decomp_psc_l_3D(rhceg_l,rhceg_l_3D)
!!$      call decomp_psc_l_3D(rhchg_l,rhchg_l_3D)
!!$      deallocate(rhcg_l)
!!$      deallocate(rhceg_l)
!!$      deallocate(rhchg_l)
!!$   endif
!!$
!!$   !                    timer_fj end 37
!!$  end subroutine PARA_2Dto3D
!!$
!!$  subroutine PARA_3Dto2D()
!!$    !                   timer_fj sta 38
!!$
!!$    allocate(vlhxc_l(ista_kngp:iend_kngp,kimg,nspin)); vlhxc_l = 0.0d0
!!$    do ispin = 1, nspin, af + 1
!!$       call decomp_vlhxc_l_r_3D(vlhxc_l,vlhxc_l_3D,ispin)
!!$    end do
!!$    deallocate(vlhxc_l_3D)
!!$
!!$    allocate(chgq_l(ista_kngp:iend_kngp,kimg,nspin)); chgq_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       call decomp_vlhxc_l_r_3D(chgq_l,chgq_l_3D,ispin)
!!$    end do
!!$    deallocate(chgq_l_3D)
!!$
!!$    allocate(chgqo_l(ista_kngp:iend_kngp,kimg,nspin)); chgqo_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       call decomp_vlhxc_l_r_3D(chgqo_l,chgqo_l_3D,ispin)
!!$    end do
!!$    deallocate(chgqo_l_3D)
!!$
!!$    if(istress == ON .or. sw_fine_STM_simulation == ON) then
!!$       allocate(chgsoft(ista_kngp:iend_kngp,kimg,nspin)) ; chgsoft = 0.0d0
!!$       do ispin = 1, nspin, af + 1
!!$          call decomp_vlhxc_l_r_3D(chgsoft,chgsoft_3D,ispin)
!!$       end do
!!$       deallocate(chgsoft_3D)
!!$    end if
!!$
!!$    allocate(vxc_l(ista_kngp:iend_kngp,kimg,nspin)); vxc_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       call decomp_vlhxc_l_r_3D(vxc_l,vxc_l_3D,ispin)
!!$    end do
!!$    deallocate(vxc_l_3D)
!!$
!!$    allocate(vxcpc_l(ista_kngp:iend_kngp,kimg)); vxcpc_l = 0.d0
!!$    deallocate(vxcpc_l_3D)
!!$
!!$    allocate(snl(kg1,nlmtt,ista_snl:iend_snl)); snl = 0.d0
!!$    call decomp_snl_l_r_3D(snl_l_3D,snl)
!!$    deallocate(snl_l_3D)
!!$
!!$    allocate(eko_l(np_e,ista_k:iend_k));                   eko_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             call decomp_eko_l_r_3D_2(eko_l,eko_l_3D,ik,neordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(eko_l_3D)
!!$
!!$    allocate(zaj_l(kg1,np_e,ista_k:iend_k,kimg));          zaj_l = 0.0d0
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             call decomp_zaj_l_r_3D_ik(zaj_l,zaj_l_3D,ik,neordr,"sort")
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(zaj_l_3D)
!!$
!!$    allocate(fsr_l(np_e,nlmta,ista_k:iend_k));             fsr_l = 0.0d0
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             call decomp_fsr_l_r_3D_ik(fsr_l,fsr_l_3D,ik,neordr,"sort",0)
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(fsr_l_3D)
!!$
!!$    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!!$       allocate(fsi_l(np_e,nlmta,ista_k:iend_k));          fsi_l = 0.d0
!!$       do ispin = 1, nspin, af + 1
!!$          do ik = ispin, kv3-nspin+ispin, nspin
!!$             if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$                call decomp_fsr_l_r_3D_ik(fsi_l,fsi_l_3D,ik,neordr,"sort",0)
!!$             end if
!!$          end do
!!$       end do
!!$       deallocate(fsi_l_3D)
!!$    end if
!!$
!!$    allocate(occup_l(np_e,ista_k:iend_k));                 occup_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             iksnl = (ik-1)/nspin + 1
!!$             call decomp_occup_l_r_3D(occup_l,occup_l_3D,ik,neordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(occup_l_3D)
!!$
!!$    allocate(zfm3_l(ista_kngp:iend_kngp,ntyp,kimg));       zfm3_l = 0.d0
!!$    call decomp_zfm3_l_r_3D(zfm3_l,zfm3_l_3D)
!!$    deallocate(zfm3_l_3D)
!!$
!!$    allocate(gr_l(ista_kngp:iend_kngp));                   gr_l =0.0d0
!!$    call decomp_gr_l_r_3D(gr_l,gr_l_3D)
!!$    deallocate(gr_l_3D)
!!$
!!$    allocate(psc_l(ista_kngp:iend_kngp,ntyp));             psc_l =0.0d0
!!$    call decomp_psc_l_r_3D(psc_l,psc_l_3D)
!!$    deallocate(psc_l_3D)
!!$
!!$    allocate(qitg_l(ista_kngp:iend_kngp,nqitg));           qitg_l =0.0d0
!!$    call decomp_qitg_l_r_3D(qitg_l,qitg_l_3D,nqitg)
!!$    deallocate(qitg_l_3D)
!!$
!!$    allocate(rhpcg_l(ista_kngp:iend_kngp,ntpcc));          rhpcg_l =0.0d0
!!$    call decomp_qitg_l_r_3D(rhpcg_l,rhpcg_l_3D,ntpcc)
!!$    deallocate(rhpcg_l_3D)
!!$
!!$    if(istress==ON) then
!!$       allocate(psc_diff_l(ista_kngp:iend_kngp,ntyp));             psc_diff_l =0.0d0
!!$       call decomp_psc_l_r_3D(psc_diff_l,psc_diff_l_3D)
!!$       deallocate(psc_diff_l_3D)
!!$
!!$       allocate(qitg_diff_l(ista_kngp:iend_kngp,nqitg));           qitg_diff_l =0.0d0
!!$       call decomp_qitg_l_r_3D(qitg_diff_l,qitg_diff_l_3D,nqitg)
!!$       deallocate(qitg_diff_l_3D)
!!$
!!$       allocate(rhpcg_diff_l(ista_kngp:iend_kngp,ntpcc));          rhpcg_diff_l =0.0d0
!!$       call decomp_qitg_l_r_3D(rhpcg_diff_l,rhpcg_diff_l_3D,ntpcc)
!!$       deallocate(rhpcg_diff_l_3D)
!!$    endif
!!$
!!$    allocate(ngpt_l(ista_kngp:iend_kngp,nopr+af));         ngpt_l =0.0d0
!!$    call decomp_ngpt_l_r_3D(ngpt_l,ngpt_l_3D,nopr+af)
!!$    deallocate(ngpt_l_3D)
!!$
!!$    allocate(igfp_l(ista_kngp:iend_kngp));                 igfp_l =0.0d0
!!$    call decomp_igfp_l_r_3D(igfp_l,igfp_l_3D)
!!$    deallocate(igfp_l_3D)
!!$
!!$   if(initial_chg == from_PSEUDOPOTENTIAL_FILE) then
!!$      allocate(rhvg_l(ista_kngp:iend_kngp,ntyp));                     rhvg_l =0.0d0
!!$      call decomp_psc_l_r_3D(rhvg_l,rhvg_l_3D)
!!$      deallocate(rhvg_l_3D)
!!$   endif
!!$
!!$   if(sw_positron == BULK .or. sw_positron == DEFECT) then
!!$      allocate(rhcg_l(ista_kngp:iend_kngp,ntyp));                     rhcg_l =0.0d0
!!$      allocate(rhceg_l(ista_kngp:iend_kngp,ntyp));                    rhceg_l =0.0d0
!!$      allocate(rhchg_l(ista_kngp:iend_kngp,ntyp));                    rhchg_l =0.0d0
!!$      call decomp_psc_l_r_3D(rhcg_l,rhcg_l_3D)
!!$      call decomp_psc_l_r_3D(rhceg_l,rhceg_l_3D)
!!$      call decomp_psc_l_r_3D(rhchg_l,rhchg_l_3D)
!!$      deallocate(rhcg_l_3D)
!!$      deallocate(rhceg_l_3D)
!!$      deallocate(rhchg_l_3D)
!!$   endif
!!$
!!$   !                timer_fj end 38
!!$  end subroutine PARA_3Dto2D
!!$
!!$  subroutine output_zaj()
!!$   integer::ispin, ik
!!$
!!$    if (.not. allocated(zaj_l)) then
!!$       allocate(zaj_l(kg1,np_e,ista_k:iend_k,kimg))
!!$    end if
!!$    zaj_l = 0.0d0
!!$
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             call decomp_zaj_l_r_3D_ik(zaj_l,zaj_l_3D,ik,neordr,"sort")
!!$          end if
!!$       end do
!!$    end do
!!$
!!$    call dump_zaj(zaj_l)
!!$
!!$    deallocate(zaj_l)
!!$
!!$  endsubroutine output_zaj
#endif

  subroutine Continuation_Mode()
    use m_Const_Parameters,   only : COORDINATE_CONTINUATION,ON,OFF
    use m_Control_Parameters, only : icond, sw_optimize_lattice,sw_rebuild_pws
    implicit none
    logical :: unitcell_can_change
    if(unitcell_can_change() .and. sw_rebuild_pws==OFF) return
    icond = COORDINATE_CONTINUATION
  end subroutine continuation_mode

  logical function Enforce_Update_Cell()
    use m_IterationNumbers,     only : iteration_unit_cell
    use m_Control_Parameters,   only : sw_optimize_coords_sametime, &
         &                             threshold_start_cellopt
    use m_Const_Parameters,     only : ON
    use m_Force,                only : forcmx

    Enforce_update_Cell = .false.
    if ( sw_optimize_coords_sametime == ON ) then
       if ( iteration_unit_cell > 1 ) then
          Enforce_update_Cell = .true.
       else
          if ( forcmx < threshold_start_cellopt ) then
             Enforce_update_Cell = .true.
          endif
       endif
    endif

  end function Enforce_Update_Cell

  logical function BreakMD(conv)
    use m_IterationNumbers, only : iteration_ionic
    use m_Ionic_System, only : addition_frequency,m_IS_natm_can_change
    implicit none
    logical, intent(in) :: conv
    if(.not.m_IS_natm_can_change())then
       BreakMD = conv
       return
    endif
    BreakMD = mod(iteration_ionic,addition_frequency)==0
  end function BreakMD

  logical function Break_SC_DFT()
    use m_IterationNumbers, only : iteration, first_iteration_of_this_job, iteration_scdft
    use m_Control_Parameters, only : delta_epsilon, max_scdft_iteration, epsilon0, epsilon0_previous
    if(iteration-first_iteration_of_this_job <= 0 .or. iteration_scdft<=1) then
       Break_SC_DFT = .false.
    else
       if(dabs(epsilon0 - epsilon0_previous) < max(0.0, delta_epsilon)) then
          Break_SC_DFT = .true.
       else
          if(iteration_scdft > max_scdft_iteration) then
             Break_SC_DFT = .true.
          else
             Break_SC_DFT = .false.
          end if
       end if
    end if
    write(6,'(" Break_SC_DFT = ",L3)') Break_SC_DFT
    call flush(6)
  end function Break_SC_DFT

  logical function Initial_SCDFTLoop()
    use m_IterationNumbers, only : iteration_scdft, iteration_scdft_initial
    Initial_SCDFTLoop = .true.
    if(Iteration_scdft > Iteration_scdft_initial) Initial_SCDFTLoop = .false.
!!$    if(mype==0) then
       write(6,*) ' ! Iteration_scdft, iteration_scdft_initial = ', iteration_scdft,iteration_scdft_initial
       write(6,*) ' I Initial_SCDFTLoop = ',Initial_SCDFTLoop
       call flush(6)
!!$    end if
  end function Initial_SCDFTLoop

  subroutine setalpha_exx()
    use m_Control_Parameters, only : m_CtrlP_set_alpha_exx, epsilon0
    use m_Files,              only : nfout
    use m_Const_Parameters,   only : DP
    real(kind=DP) :: alpha
    alpha = 1.d0/epsilon0
    call m_CtrlP_set_alpha_exx(nfout,alpha)
  end subroutine setalpha_exx

  logical function OneShot()
    use m_Ionic_System, only : m_IS_natm_can_change
    use m_Control_Parameters, only : sw_optimize_lattice
    use m_Const_Parameters, only : OFF
    implicit none
    logical :: unitcell_can_change
    OneShot = .not.m_IS_natm_can_change()
    if(OneShot) then
        OneShot = .not.unitcell_can_change()
    endif
  end function OneShot

! === KT_add ==== 13.1R
  logical function epsilon_post_scf()
    use m_Const_Parameters,   only : ON, OFF
    use m_Epsilon_ek,  only : sw_epsilon, m_Eps_chkif_sw_epsilon
    use m_Control_Parameters, only : sw_phonon, sw_phonon_with_epsilon, &
         &                           sw_calc_dielectric_tensor, sw_excitation

    implicit none
    logical, save :: First = .true.

    epsilon_post_scf = .false.

!    if ( First ) then
!       call m_Eps_chkif_sw_epsilon;        First = .false.
!    endif
    if ( sw_epsilon == OFF .and. sw_excitation == OFF ) return

    if ( sw_phonon == ON ) then
       if ( sw_phonon_with_epsilon == ON .and. sw_calc_dielectric_tensor == ON ) then
          epsilon_post_scf = .true.
       endif
    else
!       epsilon_post_scf = .true.
       epsilon_post_scf = .false.
    endif

  end function epsilon_post_scf

  logical function epsilon_post_proc()
    use m_Const_Parameters,   only : ON, OFF
    use m_Epsilon_ek,  only : sw_epsilon, m_Eps_chkif_sw_epsilon
    use m_Control_Parameters, only : sw_phonon, sw_phonon_with_epsilon, &
         &                           sw_calc_dielectric_tensor, sw_excitation

    implicit none
    logical, save :: First = .true.

    epsilon_post_proc = .false.

!    if ( First ) then
!       call m_Eps_chkif_sw_epsilon;        First = .false.
!    endif
    if ( sw_epsilon == OFF .and. sw_excitation == OFF ) return

    if ( sw_phonon == ON ) then
       epsilon_post_proc = .false.
    else
       epsilon_post_proc = .true.
    endif

  end function epsilon_post_proc
! =============== 13.1R

  integer function Resolve_Driver()
    use m_Control_Parameters, only : driver
    Resolve_Driver = driver
  end function Resolve_Driver

  logical function ekmode()
    use m_Control_Parameters, only : icond,fixed_charge_k_parallel
    use m_Const_Parameters, only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION,ONE_BY_ONE
    implicit none
    ekmode = .false.
    if((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION) .and. &
    &  fixed_charge_k_parallel .eq. ONE_BY_ONE) then
       ekmode = .true.
    endif
  end function ekmode

  logical function Resolve_Config_Parallel()
    use m_Parallelization, only : m_Parallel_resolve_conf_para
    implicit none
    Resolve_Config_Parallel = m_Parallel_resolve_conf_para()
  end function Resolve_Config_Parallel

  subroutine Postprocessing_during_MD()
    use m_IterationNumbers, only : iteration_ionic
    use m_Control_Parameters, only : postproc_frequency
    if(postproc_frequency<=0) return
    if(mod(iteration_ionic,postproc_frequency)==0)then
       call Postprocessing(.true.)
    endif
  end subroutine Postprocessing_during_MD

   subroutine Set_Icond
     use m_Const_Parameters,   only : INITIAL
     use m_Control_Parameters, only : m_CtrlP_set_icond
     call m_CtrlP_set_icond(INITIAL)
   end subroutine Set_Icond

end program PHASE

  subroutine Array_Deallocate()
     use m_Const_Parameters, only : OFF, ON, DRIVER_URAMP, DRIVER_SC_DFT, DRIVER_NEB
     use m_Control_Parameters, only : m_CtrlP_dealloc,sw_rebuild_pws,m_CtrlP_set_init_status
     use m_Crystal_Structure, only : m_CS_dealloc
     use m_Ionic_System, only : m_IS_dealloc
     use m_PlaneWaveBasisSet, only : m_pwBS_dealloc
     use m_Parallelization, only : m_Parallel_dealloc,m_Parallel_dealloc_mpi_nlmta,m_Parallel_dealloc_mpi_elec &
    &                            , m_Parallel_dealloc_mpi_nval,m_Parallel_dealloc_mpi_fft_box &
    &                            , m_Parallel_dealloc_mpi_kngp_B,m_Parallel_fft_onto_wf_dealloc_3D &
    &                            , m_Parallel_dealloc_mpi_paw_3D, m_Parallel_dealloc_mpi_exx &
    &                            , m_Parallel_cp_g1k
     use m_Kpoints, only : m_Kp_dealloc, kv3
     use m_Force, only : m_Force_dealloc
     use m_Charge_Density, only : m_CD_dealloc
     use m_XC_Potential, only : m_XC_dealloc_vxc_3D
     use m_PseudoPotential, only : m_PP_dealloc, flg_paw
     use m_NonLocal_Potential, only : m_NLP_dealloc
     use m_Electronic_Structure, only : m_ES_dealloc
     use m_ES_WF_by_SDorCG, only : m_ESsd_dealloc
     use m_PAW_ChargeDensity, only : m_PAW_dealloc
     use m_PAW_XC_Potential, only : m_PAW_XC_dealloc_vxc
     use m_ES_wf_extrpl, only : m_ES_wf_extrpl_dealloc

! ===== KT_add ============== 13.0AS
     use m_Control_Parameters,  only : num_projectors, sw_hubbard
     use m_Orbital_Population,only: m_OP_dealloc
     use m_Electronic_Structure,  only : m_ES_dealloc_Dhub
! ============================13.0AS

! ======== KT_add ============= 2013/10/31
     use m_Control_Parameters, only: noncol, SpinOrbit_Mode, driver
     use m_Const_Parameters,   only: Neglected, BuiltIn, ByPawPot, ZeffApprox, &
          &                          ByProjector, ReadFromPP
     use m_SpinOrbit_Potential,only: m_SO_dealloc_Dsoc, m_SO_dealloc_Mat_SOC_Strenth
! ============================= 2013/10/31

! ========= KT_add ========= 13.0U2
  use m_Control_Parameters,   only : sw_modified_TFW_functional
  use m_ThomasFermiW_Potential,  only : m_TFW_dealloc_ChgDensityBasisFn
! ========================== 13.0U2

! ====== KT_add === 2014/08/01
  use m_Orbital_QuantumNum, only : m_OP_Qnum_dealloc_array
! ================= 2014/08/01

  use m_Ldos, only : m_Ldos_dealloc

#ifdef FFTW3
  use m_FFT, only : m_FFT_finalize
#endif

     implicit none

     if (sw_rebuild_pws==OFF .or. driver == DRIVER_URAMP .or. driver == DRIVER_SC_DFT ) then
        call m_PP_dealloc()
        call m_NLP_dealloc()
        call m_Parallel_dealloc_mpi_nlmta()
        call m_Parallel_dealloc_mpi_exx()
        call m_Kp_dealloc
        call m_Parallel_dealloc_mpi_paw_3D()
!        call m_ES_dealloc
!        call m_ESsd_dealloc
        return
     endif

     call m_CtrlP_dealloc
     call m_ES_dealloc
     call m_pwBS_dealloc
     call m_Parallel_cp_g1k(kv3)
     call m_Parallel_dealloc
     call m_Parallel_dealloc_mpi_elec
     call m_Parallel_dealloc_mpi_fft_box
     call m_Parallel_dealloc_mpi_nval
     call m_Parallel_fft_onto_wf_dealloc_3D
     call m_Parallel_dealloc_mpi_kngp_B
     call m_CS_dealloc
     call m_IS_dealloc
  !call m_Parallel_dealloc_mpi_elec
     call m_Kp_dealloc
     call m_PP_dealloc
     call m_CD_dealloc
     call m_Force_dealloc
     call m_NLP_dealloc
     call m_ESsd_dealloc
     call m_XC_dealloc_vxc_3D
     call m_PAW_dealloc
     if(flg_paw) then
         call m_PAW_XC_dealloc_vxc
     endif

! ==== KT_add ============== 2013/10/31
     if ( noncol ) then
        if ( SpinOrbit_Mode == ByPawPot .or. SpinOrbit_Mode == ZeffApprox &
             &                          .or. SpinOrbit_Mode == ReadFromPP ) then
           call m_SO_dealloc_Mat_SOC_strenth
           call m_SO_dealloc_Dsoc
        endif
        if ( SpinOrbit_Mode == ByProjector ) then
           call m_SO_dealloc_Dsoc
        endif
     endif
! ====================== 2013/10/31

! ====== KT_add ======== 13.0U2
     if ( sw_modified_TFW_functional /= OFF ) then
        call m_TFW_dealloc_ChgDensityBasisFn
     end if
! ====================== 13.0U2

! ====== KT_add =========== 13.0AS
     if (num_projectors>0)  call m_OP_dealloc
     if (sw_hubbard == ON) call m_ES_dealloc_Dhub
! ========================= 13.0AS

! ==== KT_add ==== 2014/08/01
     call m_OP_Qnum_dealloc_array
! ================ 2014/08/01

     call m_ES_wf_extrpl_dealloc()
     call m_Ldos_dealloc()
     call m_ES_wf_extrpl_dealloc()
#ifdef FFTW3
     call m_FFT_finalize()
#endif
     call m_CtrlP_set_init_status(.true.)
   end subroutine Array_Deallocate

*
*
* NOTICE : BECAUSE OF THE ACCURACY PROBLEMS, DO NOT USE ANY OPTIMIZATION
*          OPTION ON THE COMPILATION PHASE
*
*
       real(8) function machine_epsilon()

       implicit NONE
       real(8)                :: epsilon, tmp

       epsilon = 1.0D+00
       do
          tmp = epsilon
          epsilon = epsilon*5.0D-01
          if ( 1.0D+00+epsilon == 1.0D+00 ) exit
       enddo
       machine_epsilon = tmp

       return
       end function ! machine_epsilon

module m_Potential_Average
  use m_Control_Parameters,  only : nspin, noncol, kimg
  use m_Const_Parameters,  only : DP, PAI4, OFF, ON, FMAXVALLEN, Hartree
  use m_Parallelization,  only : ista_kngp, iend_kngp, npes, mpi_comm_group, mype, &
       &                         myrank_g, mpi_chg_world
  use m_PlaneWaveBasisSet,  only : ngabc, gr_l, kgp, ngabc_kngp_l
  use m_Ionic_System,      only : natm, pos, ntyp, ityp, zfm3_l
  use m_Crystal_Structure,  only : rltv
  use m_PseudoPotential,      only : psc_l
  use m_Charge_Density,       only : chgq_l
  use m_XC_Potential,         only : vxc_l
  use m_Files,             only : nfout
  
  implicit none

  include 'mpif.h'
  integer istatus(mpi_status_size)
  
! ---
  character(len("Postprocessing")),private,parameter :: tag_postprocessing    = "postprocessing"
  character(len("potential_average")),private,parameter :: &
       &         tag_potential_average = "potential_average"
  character(len("sw_calc_pot_avg")),private,parameter :: &
       &         tag_sw_calc_pot_avg = "sw_calc_pot_avg"
  character(len("sw_add_xc_pot")),private,parameter :: &
       &         tag_sw_add_xc_pot = "sw_add_xc_pot"
  character(len("cutoff_radius")),private,parameter :: &
       &         tag_cutoff_radius = "cutoff_radius"
  character(len("weight_function")),private,parameter :: &
       &         tag_weight_function = "weight_function"

  integer :: sw_calc_pot_avg = off
  integer :: sw_add_xc_pot = off
  real(kind=DP) :: cutoff_radius = 2.0d0
  real(kind=DP) :: rad_for_pot_avg

  integer :: weight_function = 1
    
contains

  subroutine m_PotAvg_read_param
    integer, parameter :: LEN_TITLE = 80
    integer :: f_selectBlock, f_getStringValue, f_getRealValue, f_getIntValue
    integer :: f_selectParentBlock, f_selectTop

    integer :: iret
    real(kind=DP) :: dret
    character(len=FMAXVALLEN) :: rstr

    iret = f_selectTop()
 
    if ( f_selectBlock( tag_postprocessing ) == 0 ) then

       if ( f_selectBlock( tag_potential_average ) == 0 ) then
          if ( f_getIntValue( tag_sw_calc_pot_avg, iret ) == 0 ) then
             sw_calc_pot_avg = iret
          endif
          if ( f_getIntValue( tag_sw_add_xc_pot, iret ) == 0 ) then
             sw_add_xc_pot = iret
          endif
          if ( f_getIntValue( tag_weight_function, iret ) == 0 ) then
             weight_function = iret
          endif
          if ( f_getRealValue( tag_cutoff_radius, dret, 'bohr' ) == 0 ) then
             cutoff_radius = dret
          endif
          if ( mype == 0 .and. sw_calc_pot_avg == ON ) then
             write(nfout,*) "=== Info: Potential Average ==="
             write(nfout,*) "** sw_add_xc_pot is ", sw_add_xc_pot
             write(nfout,*) "** weight_function is ", weight_function
             write(nfout,*) "** cutoff_radius is ", cutoff_radius
          endif
          iret = f_selectParentBlock()
       endif
       iret = f_selectParentBlock()
    endif

  end subroutine m_PotAvg_read_param

  subroutine m_PotAvg_calc_pot_on_atoms
    integer :: ismax
    real(kind=DP), allocatable :: pot_wk(:,:,:)
    real(kind=DP), allocatable :: pot_on_atoms(:,:)

    ismax = nspin
    if ( noncol ) ismax = 1

    allocate( pot_wk(ista_kngp:iend_kngp,kimg,ismax) );  pot_wk = 0.0d0
    allocate( pot_on_atoms(natm,ismax) );                pot_on_atoms = 0.0d0

    call set_pot_Gspace( ismax, pot_wk )
    call average_pot_on_atoms( ismax, pot_wk, pot_on_atoms )    
    call print_pot_on_atoms( ismax, pot_on_atoms )

    deallocate( pot_wk )
    deallocate( pot_on_atoms )
  end subroutine m_PotAvg_calc_pot_on_atoms

  subroutine average_pot_on_atoms( ismax, pot_wk, pot_on_atoms )
    integer, intent(in) :: ismax
    real(kind=DP), intent(in) ::  pot_wk(ista_kngp:iend_kngp,kimg,ismax)
    real(kind=DP), intent(out) :: pot_on_atoms(natm,ismax)

    integer :: ia, ist, i, it, ierr, is
    real(kind=DP) :: csum, d1, fac1r, fac1i
    real(kind=DP) :: rad1, fac2, gr, normG, normG3, vecG(3), vol

    real(kind=DP), allocatable :: zfcos(:), zfsin(:)
    real(kind=DP), allocatable :: pot_on_atom(:,:), pot_mpi(:,:)

    allocate(zfcos(ista_kngp:iend_kngp)); zfcos = 0.d0
    allocate(zfsin(ista_kngp:iend_kngp)); zfsin = 0.d0

    Do ia=1, natm
       it = ityp(ia)
       call calc_phase2( natm, pos, ia, kgp, ngabc_kngp_l, ista_kngp, iend_kngp, &
            &            zfcos, zfsin )
       if ( ista_kngp == 1 ) then
          ist = 2
       else
          ist = ista_kngp
       endif
!
       select case (weight_function)
       case (0)       ! just on atoms
          Do is=1, ismax
             csum = 0.0d0
             Do i=ist, iend_kngp
                fac1r = zfcos(i);   fac1i = zfsin(i)
                if ( kimg == 1 ) then
                   d1 = pot_wk(i,1,is) *fac1r
                else
                   d1 = pot_wk(i,1,is) *fac1r -pot_wk(i,kimg,is)*fac1i
                endif
                csum = csum +d1
             End Do
             pot_on_atoms(ia,is) = csum
          End Do

       case (1)       ! rad-cut
!          rad1 = rad_for_pot_avg(it)
          rad1 = cutoff_radius
          
          Do is=1, ismax
             csum = 0.0d0
             Do i=ist, iend_kngp
                VecG(1) = rltv(1,1)*ngabc_kngp_l(i,1) +rltv(1,2)*ngabc_kngp_l(i,2) &
                     &   +rltv(1,3)*ngabc_kngp_l(i,3)
                VecG(2) = rltv(2,1)*ngabc_kngp_l(i,1) +rltv(2,2)*ngabc_kngp_l(i,2) &
                     &   +rltv(2,3)*ngabc_kngp_l(i,3)
                VecG(3) = rltv(3,1)*ngabc_kngp_l(i,1) +rltv(3,2)*ngabc_kngp_l(i,2) &
                     &   +rltv(3,3)*ngabc_kngp_l(i,3)
                normG = sqrt( VecG(1)**2 +VecG(2)**2 +VecG(3)**2 )
                normG3 = normG**3
                fac1r = zfcos(i);   fac1i = zfsin(i)
                if ( kimg == 1 ) then
                   d1 = pot_wk(i,1,is) *fac1r
                else
                   d1 = pot_wk(i,1,is) *fac1r -pot_wk(i,kimg,is)*fac1i
                endif
                gr = normG *rad1
                fac2 = -gr *cos(gr) + sin(gr)
                fac2 = fac2 *PAI4 /normG3
                csum = csum +d1 *fac2
             End Do
             if ( myrank_g == 0 ) then
                fac2 = PAI4 /3.0d0 *rad1**3
!!!                csum = csum +pot_wk(1,kimg,is) *fac2   ! ASMS 2021/03/26
                csum = csum +pot_wk(1,1,is) *fac2
             endif

             vol = PAI4 /3.0 *rad1**3
             pot_on_atoms(ia,is) = csum /vol
          End do

       case (2)       ! gaussian
!          rad1 = rad_for_pot_avg(it)
          rad1 = cutoff_radius
          Do is=1, ismax
             csum = 0.0d0
             Do i=ista_kngp, iend_kngp
                VecG(1) = rltv(1,1)*ngabc_kngp_l(i,1) +rltv(1,2)*ngabc_kngp_l(i,2) &
                     &   +rltv(1,3)*ngabc_kngp_l(i,3)
                VecG(2) = rltv(2,1)*ngabc_kngp_l(i,1) +rltv(2,2)*ngabc_kngp_l(i,2) &
                     &   +rltv(2,3)*ngabc_kngp_l(i,3)
                VecG(3) = rltv(3,1)*ngabc_kngp_l(i,1) +rltv(3,2)*ngabc_kngp_l(i,2) &
                     &   +rltv(3,3)*ngabc_kngp_l(i,3)
                normG = sqrt( VecG(1)**2 +VecG(2)**2 +VecG(3)**2 )
                fac1r = zfcos(i);   fac1i = zfsin(i)
                if ( kimg == 1 ) then
                   d1 = pot_wk(i,1,is) *fac1r
                else
                   d1 = pot_wk(i,1,is) *fac1r -pot_wk(i,kimg,is)*fac1i
                endif
                gr = normG *rad1
                fac2 = exp( -gr**2 /2.0d0 )
                csum = csum +d1 *fac2
             End Do
             pot_on_atoms(ia,is) = csum
          End Do
       end select
    End Do

    deallocate( zfcos, zfsin )

    if ( npes > 1 ) then
       allocate( pot_mpi(natm,ismax) ); pot_mpi = 0.0d0
       call mpi_allreduce( pot_on_atoms, pot_mpi, natm*ismax, &
            &              mpi_double_precision, mpi_sum, mpi_chg_world, ierr )
       pot_on_atoms = pot_mpi
       deallocate( pot_mpi )
    endif
  end subroutine average_pot_on_atoms

  subroutine print_pot_on_atoms( ismax, pot_on_atoms )
    integer, intent(in) :: ismax
    real(kind=DP), intent(in) :: pot_on_atoms(natm,ismax)

    integer :: ia, lun
    character*72 file1
    
    if ( mype /= 0 ) return

    lun = 9000
    file1 = "potential_on_atoms.data"
    open( unit=lun, file=file1, status="unknown", form="formatted" )

    if ( ismax == 1 ) then
       write(lun,'(A)') "# Potential on atoms "
       write(lun,'(A)') "#   id     pot (eV)"
       Do ia=1, natm
          write(lun,'(I5,1F15.6)') ia, pot_on_atoms(ia,1)*Hartree
       End Do
    else
       write(lun,*) "# Potential on atoms "
       write(lun,*) "#   id     pot_up (eV)    pot_dn(eV)"
       Do ia=1, natm
          write(lun,'(I5,2F15.6)') ia, pot_on_atoms(ia,1:2)*Hartree
       End Do
    endif
    close(lun)
    
  end subroutine print_pot_on_atoms

  subroutine set_pot_Gspace( ismax, pot_wk )
    integer, intent(in) :: ismax
    real(kind=DP), intent(out) :: pot_wk(ista_kngp:iend_kngp,kimg,ismax)
    integer :: ist, is, ik, i, it
    real(kind=DP) :: c1

    ist = ista_kngp
    if(ist == 1) ist = 2

    do ik = 1, kimg
       if ( nspin == 1 .or. noncol ) then 
          do i = ist, iend_kngp  !for mpi
             c1 = PAI4*chgq_l(i,ik,1)/gr_l(i)**2
             pot_wk(i,ik,1) = c1
          end do
       else if (nspin == 2) then
          do i = ist, iend_kngp  !for mpi
             c1 = PAI4*(chgq_l(i,ik,1)+chgq_l(i,ik,2))/gr_l(i)**2
             pot_wk(i,ik,1) = c1
          end do
          pot_wk(:,ik,2) = pot_wk(:,ik,1)
       endif
       do is=1, ismax
          do it = 1, ntyp
             do i = ista_kngp, iend_kngp  !for mpi
                pot_wk(i,ik,is) = pot_wk(i,ik,is) +psc_l(i,it)*zfm3_l(i,it,ik)
             end do
          end do
       end do
!
       if ( sw_add_xc_pot == ON ) then
          do is=1, ismax
             do i = ista_kngp, iend_kngp  !for mpi
                pot_wk(i,ik,is) = pot_wk(i,ik,is) +vxc_l(i,ik,is)
             end do
          end do
       endif
    end do
  end subroutine set_pot_Gspace

end module m_Potential_Average

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for setting Q-points and their related variables 
!  for the LR-TDDFT.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_Qpt

  use m_Const_Parameters,               only : DP, CARTS, BUCS, PAI, PAI2, PAI4,  ELECTRON, INVERSE, ON, OFF, CMPLDP
  use m_Crystal_Structure,              only : altv,rltv  
  use m_Files,                          only : nfout

  use m_Kpoints,                        only : kv3_ek, kv3, vkxyz_ek, qwgt_ek, & 
       &                                       vkxyz, qwgt
  use m_Control_Parameters,             only : ipri, nspin, printable

  use m_PlaneWaveBasisSet,    only : ngabc,igf,kg1,kg, iba, nbase, nbase_gamma
  use m_IterationNumbers,     only : nk_in_the_process, nk_converged

  use m_Parallelization,         only : ista_kngp, iend_kngp
  use m_PlaneWaveBasisSet,        only : kg0

! --
  use m_Control_Parameters,     only : Num_q_Points, sw_LinearResponse
  use m_PseudoPotential,        only : norm_q_plus_G_LR, &
       &                               vec_q_plus_G_LR
!
  use m_LinearResponse_Control,         only : vqxyz, vec_q, &
       &                                       nrd_efermi
  use m_LinearResponse_Control,         only : sw_tddft, sw_LongWaveLimit
  use m_LinearResponse_Control, only : nmax_G_LR, sw_LongWaveLimit, ipriqpt
! ------------------ for subroutine m_LR_kp_cr_kpoints_table ----------------------
  use m_Kpoints,                only : way_ksample, k_sample_mesh, ip20, ip2cub, iwt, &
       &                               nxyz_tetra, ip01, ip21, ip10, ip02, ip12, &
       &                               iv21, iu21
  use m_Control_Parameters,     only : ipri_kp
  use m_Const_Parameters,       only : SKPS_DIRECT_IN, WHOLE_BZ, GENERAL, &
       &                               GENERAL_LARGER
  use m_Crystal_Structure,      only : nbztyp, nbztyp_spg, il, ngen, inv, igen, jgen, &
       &                               a, b, c, ca, cb, cc
! ------------------------------- for USPP ---------
  use m_Const_Parameters,       only : SKIP, zi
  use m_PseudoPotential,        only : nmax_q_plus_G_LR, nmax_q_LR, qitg_LR, &
       &                               nqitg, nlmta, nlmt, &
       &                               m_PP_include_vanderbilt_pot, &
       &                               m_PP_find_maximum_l, &
       &                               ilmt, &
       &                               ltp, taup, il2p, isph, iqitg, dl2p
  use m_Ionic_System,           only : ntyp

! -------------------------------------------------
  Implicit None
  include 'mpif.h'

! ----------------------- for USPP ---------------
  complex(kind=CMPLDP),allocatable :: ftqval(:,:,:,:,:)
! ------------------------------------------------

contains
! ----------------------------------------------------------
  subroutine m_LR_gen_q_points
    if ( sw_tddft==ON ) then
       Num_q_Points = 1;  
       allocate( vqxyz( Num_q_Points, 3, 2 ) )
       Call q_points_in_BUCS_CARTS
    endif
  end subroutine m_LR_gen_q_points

  subroutine m_LR_del_q_points
    if ( allocated( vqxyz ) ) Deallocate( vqxyz )
  end subroutine m_LR_del_q_points

  subroutine q_points_in_BUCS_CARTS
    integer                    :: i, j
    real(kind=DP)              :: fact 
! 
    vqxyz(1,:,CARTS) = vec_q(:)
    Do i = 1, 3
       Do j = 1, Num_q_Points
          vqxyz( j,i,BUCS ) = ( altv(1,i)*vqxyz( j,1,CARTS )&
               &           +  altv(2,i) *vqxyz( j,2,CARTS)&
               &           +  altv(3,i) *vqxyz( j,3,CARTS) )/PAI2
       End Do
    End Do
! ---------------------------- check of BUCS system ---------
    Do i = 1, 3
       Do j = 1, Num_q_Points
          fact =   rltv(i,1) *vqxyz( j,1,BUCS )&
               & + rltv(i,2) *vqxyz( j,2,BUCS )&
               & + rltv(i,3) *vqxyz( j,3,BUCS )
          if ( dabs(fact - vqxyz( j,i,CARTS ) ) > 1.d-5 ) then
             if ( ipriqpt >=1 ) then
                write(nfout,*) ' !D (i = ',i,',j = ',j,')'
                write(nfout,*) vqxyz( j,i,BUCS),fact, vqxyz( j,i,CARTS)
             end if
             stop ' Coordinate transformation is invaild in LR'
          end if
       End do
    End do
  end subroutine q_points_in_BUCS_CARTS

  subroutine m_LR_set_Vecs_k_minus_q             ! ( k - q ) 
    integer i, ik, kv3_org
    integer j1, k1, ispin
    real(kind=DP), allocatable :: vkxyz_tmp( :,:,: ), qwgt_tmp(:)
! -------------------------------- start --------------
    if ( sw_LongWaveLimit==ON ) then
       write(*,*) 'stop here '
       stop
    endif
    kv3_org = kv3 / ( Num_q_Points + 1 )
    Allocate( vkxyz_tmp( kv3_org, 1:3, 1:2 ) )
    Allocate( qwgt_tmp( kv3_org ) )
! -------------------------------- main --------
    Do ik=1, kv3_org
       Do i=1, 3
          vkxyz_tmp( ik, i, CARTS )  = vkxyz( ik, i, CARTS )
          vkxyz_tmp( ik, i, BUCS )   = vkxyz( ik, i, BUCS )
       End do
       qwgt_tmp( ik ) = qwgt( ik )
    End do
! ---
    j1 = 0;     k1 = 0
!
    Do ik=1, kv3_org / nspin
       Do i=0, Num_q_Points
          Do ispin =1, nspin
             if ( i==0 ) k1 = k1 + 1
             j1 = j1 + 1

             if ( i >= 1 ) then
                vkxyz( j1, 1:3, CARTS ) = vkxyz_tmp( k1, 1:3, CARTS ) &
                     &                  + vqxyz( i, 1:3, CARTS )
                vkxyz( j1, 1:3, BUCS  ) = vkxyz_tmp( k1, 1:3, BUCS  ) &
                     &                  + vqxyz( i, 1:3, BUCS )
                qwgt( j1 ) = qwgt_tmp( k1 )
            else
                vkxyz( j1, 1:3, CARTS ) = vkxyz_tmp( k1, 1:3, CARTS )
                vkxyz( j1, 1:3, BUCS  ) = vkxyz_tmp( k1, 1:3, BUCS  )
                qwgt( j1 ) = qwgt_tmp( k1 )
            endif
          End do
       End do
    End Do
! ---------------------------------- end -------------
    Deallocate( vkxyz_tmp, qwgt_tmp )

  end subroutine m_LR_set_Vecs_k_minus_q

! --------------------------
  subroutine m_LR_alloc_Vecs_q_plus_G
    allocate( norm_q_plus_G_LR( kg0, Num_q_points ) ) ;
    allocate( vec_q_plus_G_LR( kg0, 3, Num_q_points ) ) ;
    norm_q_plus_G_LR = 0.0d0
    vec_q_plus_G_LR = 0.0d0
  end subroutine m_LR_alloc_Vecs_q_plus_G

  subroutine m_LR_dealloc_Vecs_q_plus_G
    deallocate( norm_q_plus_G_LR, vec_q_plus_G_LR )
  end subroutine m_LR_dealloc_Vecs_q_plus_G

  subroutine m_LR_set_Vecs_q_plus_G
    integer :: i, nq
!!$    real(kind=DP) :: ga, gb, gc, g2, ttr(3)
    real(kind=DP) :: ga, gb, gc, g2, ttr(6)
    real(kind=DP) :: c1, c2, c3
! ------------------------------- start --------------
    Call getttr (rltv,ttr)
! ------------------------------- main --------------
    Do nq=1, Num_q_Points
!!!!       Do i=1, nmax_G
       Do i=1, kg0
          if ( sw_LongWaveLimit == OFF ) then
             ga = real(ngabc(i,1),kind=DP) + vqxyz(nq,1,BUCS)
             gb = real(ngabc(i,2),kind=DP) + vqxyz(nq,2,BUCS)
             gc = real(ngabc(i,3),kind=DP) + vqxyz(nq,3,BUCS)
          else
             ga = real(ngabc(i,1),kind=DP) 
             gb = real(ngabc(i,2),kind=DP) 
             gc = real(ngabc(i,3),kind=DP) 
          endif
          g2 = ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
               &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga
          g2 = sqrt( g2 )

          norm_q_plus_G_LR(i,nq) = g2

          c1 = rltv(1,1)*ga +rltv(1,2)*gb +rltv(1,3)*gc
          c2 = rltv(2,1)*ga +rltv(2,2)*gb +rltv(2,3)*gc
          c3 = rltv(3,1)*ga +rltv(3,2)*gb +rltv(3,3)*gc

          vec_q_plus_G_LR(i,1,nq) = c1
          vec_q_plus_G_LR(i,2,nq) = c2
          vec_q_plus_G_LR(i,3,nq) = c3
       End do
    End do

  end subroutine m_LR_set_Vecs_q_plus_G

! -------------------------------------------------------------
!! 
!!!                          For USPP 
!!
! -------------------------------------------------------------

  subroutine m_LR_alloc_Qitg
!!!!!!!!    nmax_G_LinearResponse = nmax_G;
    nmax_q_plus_G_LR = kg0;     
    nmax_q_LR = Num_q_Points
    allocate( qitg_LR( kg0, nqitg, Num_q_Points ) );  qitg_LR = 0.0d0;
  end subroutine m_LR_alloc_Qitg

  subroutine m_LR_dealloc_Qitg
    Deallocate( qitg_LR )
  end subroutine m_LR_dealloc_Qitg

  subroutine m_LR_alloc_Array_FTQVals
    allocate( ftqval( nlmt,nlmt,ntyp,Num_q_Points, kg0 ) )
    ftqval=( 0.d0, 0.d0 )
  end subroutine m_LR_alloc_Array_FTQVals

  subroutine m_LR_Dealloc_Array_FTQVals
    deallocate( ftqval )
  end subroutine m_LR_Dealloc_Array_FTQVals

  subroutine m_LR_calc_FTQ_times_Ylm
    real(kind=DP), allocatable :: ftqr(:,:), ftqi(:,:)
    integer, allocatable :: il3(:)

    integer              :: n, it, lmt1, lmt2
    integer              :: il1, il2, tau1, tau2, ilm3
    integer              :: l3, iiqitg
    integer              :: nq, ig
    real(kind=DP)        :: dq(3), ylm, ftqb
    integer              :: mdvdb

! --------------------------------- start ----------
    call m_PP_find_maximum_l(n)   !  n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate( il3(n**2) ); call substitute_il3(n**2,il3) ! -(b_Elec..)
    allocate( ftqr( Num_q_Points, kg0 ) ); ftqr = 0.0d0
    allocate( ftqi( Num_q_Points, kg0 ) ); ftqi = 0.0d0
! ------------------------------------ main ------------
    Do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if ( mdvdb == SKIP ) cycle

       Do lmt1 = 1, ilmt(it)
          il1 = ltp(lmt1,it);   tau1 = taup(lmt1,it)

          Do lmt2 = lmt1, ilmt(it)
             il2 = ltp(lmt2,it);    tau2 = taup(lmt2,it)

             ftqr = 0.d0;    ftqi = 0.d0

             Do n=1, il2p(lmt1,lmt2,it)
                ilm3 = isph(lmt1,lmt2,n,it); l3=il3(ilm3)
                iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                if ( iiqitg==0 ) cycle

                Do nq=1, Num_q_Points
!!!                   Do ig=1, nmax_G
                   Do ig=1, kg0
                      dq(:) = vec_q_plus_G_LR( ig, :, nq )
                      call sphrp2_for_Berry( ilm3, dq, ylm )

                      ftqb = qitg_LR( ig, iiqitg, nq ) &
                           & *dl2p( lmt1,lmt2,n,it ) *ylm

                      if ( mod(l3,2)==0 ) then
                         ftqr(nq,ig) = ftqr(nq,ig) +real(zi**(-l3))*ftqb
                      else
                         ftqi(nq,ig) = ftqi(nq,ig) +dimag(zi**(-l3))*ftqb
                      end if
                   End do
                End Do
             End do

             Do nq=1, Num_q_Points
!!!                Do ig=1, nmax_G
                Do ig=1, kg0
                   ftqval(lmt1,lmt2,it,nq,ig) = dcmplx( ftqr(nq,ig),ftqi(nq,ig))
                   ftqval(lmt2,lmt1,it,nq,ig) = ftqval(lmt1,lmt2,it,nq,ig)
                End do
             End do
!
          End do
       End do
    End do
!    write(*,*) 'ftqavl = ', ftqval
!    stop
! ------------------------------- end ---------------------
    deallocate( ftqr, ftqi )
! ----------
!    Do it = 1, ntyp
!       mdvdb = m_PP_include_vanderbilt_pot(it)
!       if ( mdvdb == SKIP ) cycle

!       Do lmt1 = 1, ilmt(it)
!          Do lmt2 = 1, ilmt(it)
!             Do ig=1, nmax_G
!                write(*,*) 'copa ',lmt1,lmt2, ftqval(lmt1,lmt2,it,1,ig), ftqval(lmt2,lmt1,it,1,ig)
!             End do
!          End do
!       End do
!    End do
!    stop
  end subroutine m_LR_calc_FTQ_times_Ylm

! -------------------------------------------------
!!
!!!                        Kpoint 
!! 
! -------------------------------------------------
  subroutine m_LR_set_kp_cr_kpt_table
!    for tetrahedron method
#ifndef NO_TETRAHEDRON
!!$    integer :: nx1,ny1,nz1,nd
    integer :: nx,ny,nz
    integer :: nxx,nyy,nzz
    integer :: ill,ii,lmnp0, lmnp1, lmnp2
    real(kind=DP), pointer, dimension(:,:) :: pa0,pb0,pb
    integer,       pointer, dimension(:,:) :: ka0,ka2
    integer,       pointer, dimension(:,:) :: ip2cub_wk
    integer,       pointer, dimension(:)   :: nstar2
    
    integer :: kv3_div_tmp
    integer :: np0, np1, np2
    integer :: nx1, ny1, nz1, nd
    integer :: ipri_qp_count = 0, ipri_qp_t = 0

! ----------------------------------- start --------------
    if ( ipriqpt >= 2) write(nfout,*) '-- create k-table for tetrahedron method in LR --'
    if ( way_ksample == SKPS_DIRECT_IN ) then
        stop 'way_ksample = SKPS_DIRECT_IN case is not&
             & supportted in tetrahedron method.'
    end if
!
    kv3_div_tmp = kv3 / nspin / ( Num_q_Points + 1 )
! --------------------------------------- main ----------
    if ( nbztyp.eq.WHOLE_BZ ) then
       np0 = (k_sample_mesh(1,2)+1)*(k_sample_mesh(2,2)+1)*(k_sample_mesh(3,2)+1)
       np2 = k_sample_mesh(1,2)*k_sample_mesh(2,2)*k_sample_mesh(3,2)
       np1 = np2
       
       if ( ipriqpt>=1 ) write(nfout,'(" np0,np1,np2 in LR = ",3i6)') np0,np1,np2
       if ( np2 /= kv3_div_tmp ) then
          if ( ipriqpt >= 1 ) then
             write(nfout,*) ' np0,np1,np2 in LR',np0,np1,np2
             write(nfout,*) ' kv3_div_tmp ', kv3_div_tmp
             write(nfout,*) ' np2  /=  (kv3/nspin/(Num_q_points+1) )'
          end if
          stop
       endif
       
       allocate(ip20(np0)) ; ip20 = 0
       if ( ipriqpt>=2 ) write(nfout,'(" !kp ip20 is allocated in LR")')
       allocate(iwt(np2)) ; iwt = 0
       allocate(ip2cub(np1)) ; ip2cub = 0
       allocate(nxyz_tetra(3)) ; nxyz_tetra = 0
        
       nx=k_sample_mesh(1,2); ny=k_sample_mesh(2,2);  nz=k_sample_mesh(3,2)
       ill = 1;         lmnp0=np0;           lmnp1=np1

       allocate(ip01(np1)); ip01 = 0; 
       allocate(pa0(3,np0)) ; pa0 = 0.d0

       call nskma0(ill,nx,ny,nz,nxyz_tetra(1),nxyz_tetra(2) &
            &,nxyz_tetra(3),nx1,ny1,nz1,nd)
       call nskp00(nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
            &,nx1,ny1,nz1,nd,lmnp0,np0,pa0)

!! When nbztyp=1, ip10 in FLAPW program should be ip20 in this program !!
       call nskpbm(np0,lmnp0,lmnp1,pa0,np1,ip20,ip01)
       deallocate(pa0);     deallocate(ip01)
    else

       if ( nbztyp_spg == GENERAL .or.nbztyp_spg == GENERAL_LARGER ) then
          nx=k_sample_mesh(1,1); ny=k_sample_mesh(2,1); nz=k_sample_mesh(3,1)
          
          call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)
          lmnp0=(nxx+1)*(nyy+1)*(nzz+1);    lmnp1=lmnp0;     lmnp2=lmnp0
          
          allocate(nxyz_tetra(3)) ; nxyz_tetra = 0
          allocate(ip10(lmnp0))  ; ip10 = 0
          allocate(ip20(lmnp0))  ; ip20 = 0
          allocate(ip01(lmnp1))    ; ip01 = 0
          allocate(ip02(lmnp2))    ; ip02 = 0
          allocate(ip21(lmnp1))    ; ip21 = 0
          allocate(ip12(lmnp2))    ; ip12 = 0
          allocate(iu21(lmnp1))    ; iu21 = 0
          allocate(iv21(lmnp1))    ; iv21 = 0
          allocate(nstar2(lmnp2))  ; nstar2 = 0
          allocate(pa0(3,lmnp0))  ; pa0 = 0
          allocate(pb0(3,lmnp0))  ; pb0 = 0
          allocate(pb(3,lmnp2))  ; pb = 0
          allocate(ka0(4,lmnp0))  ; ka0 = 0
          allocate(ka2(4,lmnp2))  ; ka2 = 0

          ipri_qp_t = ipri_kp *(1-ipri_qp_count)
          if ( ipri_qp_count == 0 ) ipri_qp_count = 1
          call setkp0_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
               & ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
               & ,nx,ny,nz,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
               & ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
               & ,nstar2,pa0,pb0,pb,ka0,ka2 &
               & ,ipri_qp_t)
       else
          nx=k_sample_mesh(1,1);  ny=k_sample_mesh(2,1);   nz=k_sample_mesh(3,1)
          
          if ( ipri_kp>=2 ) write(nfout,'(" !kp nx,ny,nz = ",3i6)') nx,ny,nz
!!$           if(nbztyp_spg.eq.SIMPLE_CUBIC) il = 1
!!$           if(nbztyp_spg.eq.BCC) il = 3
!!$           if(nbztyp_spg.eq.FCC) il = 2
!!$           if(nbztyp_spg.eq.DIAMOND) il = 2
!!$           if(nbztyp_spg.eq.HEXAGONAL) il = 0

          call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)
          if ( ipri_kp>=2 ) write(nfout,'(" !kp nxx,nyy,nzz = ",3i6)') nxx,nyy,nzz
          
          lmnp0=(nxx+1)*(nyy+1)*(nzz+1);         lmnp1=lmnp0;      lmnp2=lmnp0
          
          allocate(nxyz_tetra(3)) ; nxyz_tetra = 0
          allocate(ip10(lmnp0))  ; ip10 = 0
          allocate(ip20(lmnp0))  ; ip20 = 0
          allocate(ip01(lmnp1))    ; ip01 = 0
          allocate(ip02(lmnp2))    ; ip02 = 0
          allocate(ip21(lmnp1))    ; ip21 = 0
          allocate(ip12(lmnp2))    ; ip12 = 0
          allocate(iu21(lmnp1))    ; iu21 = 0
          allocate(iv21(lmnp1))    ; iv21 = 0
          allocate(nstar2(lmnp2))  ; nstar2 = 0
          allocate(pa0(3,lmnp0))  ; pa0 = 0
          allocate(pb0(3,lmnp0))  ; pb0 = 0
          allocate(pb(3,lmnp2))  ; pb = 0
          allocate(ka0(4,lmnp0))  ; ka0 = 0
!!$          allocate(ka2(4,lmnp2))  ; ka2 = 0

!!$           call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
!!$                &               ,nbztyp_spg,altv,nx,ny,nz &
!!$                &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
!!$                &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
!!$                &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
!!$                &               ,nstar2,pa0,pb0,pb,ka0,ka2 &
!!$                &               ,ipri_kp)
          ipri_qp_t = ipri_kp*(1-ipri_qp_count)
          if ( ipri_qp_count==0 ) ipri_qp_count = 1
          call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
               &               ,nx,ny,nz &
               &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
               &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
               &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
               &               ,nstar2,pa0,pb0,pb,ka0 &
               &               ,ipri_qp_t)
          
       end if

       if ( ipri_kp>=2 ) write(nfout,'(" np0,np1,np2 = ",3i6)') np0,np1,np2
       if ( ipri_kp>=1 ) then
          write(nfout,'("!Kp nxyz_tetra(1:3) = ",3i8)') nxyz_tetra(1:3)
       end if
       
       if ( np2 /= kv3_div_tmp ) then
          if(ipri_kp>=1) then
             write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
             write(nfout,*) ' kv3_div_tmp ',kv3_div_tmp
             write(nfout,*) ' np2  /=  (kv3/nspin/(Num_Qpoints+1) )'
          end if
          stop
       endif
       
       allocate(iwt(np2)) ; iwt = 0
       allocate(ip2cub(np1)) ; ip2cub = 0
       
       deallocate(ip10); deallocate(ip01); deallocate(ip02); deallocate(ip21)
       deallocate(ip12); deallocate(iu21); deallocate(iv21)
       deallocate(nstar2); deallocate(pa0); deallocate(pb0); deallocate(pb)
       deallocate(ka0)
       if ( nbztyp_spg == GENERAL .or.nbztyp_spg == GENERAL_LARGER ) &
            & deallocate(ka2)
    end if
    
    if ( ipri_kp>=2 ) then
       write(nfout,*) 'ip20'
       write(nfout,'(" np0 = ",i8)') np0
       write(nfout,*) (ip20(ii),ii=1,np0)
       write(nfout,'(" nx1,ny1,nz1,nd = ",4i6)') nx1,ny1,nz1,nd
    end if
    
    allocate(ip2cub_wk(9,nxyz_tetra(1)*nxyz_tetra(2)*nxyz_tetra(3)))
    ip2cub_wk = 0.d0
    call wtetra &
         &  (nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3),np0,np2,ip20 &
         &  ,iwt,ip2cub &
         &  ,ip2cub_wk)
    deallocate(ip2cub_wk)
#endif
  end subroutine m_LR_set_kp_cr_kpt_table
! -------------------------------------------------------------

end module m_LinearResponse_Qpt

      subroutine  eigen_prd_au(
     &               a, nm,
     &               u_x, u_y, v_x, nv,
     &               u_t, v_t, d_t,
     &               i, i_base, m)

!$    use OMP_LIB
      use MPI
      use eigen_devel
      use eigen_libs
      use eigen_house
      implicit NONE

      integer, intent(in)    :: nm, nv, i, i_base, m
      real(8), intent(inout) :: a(1:nm,*)
      real(8), intent(inout) :: u_x(1:nv,*), u_y(1:nv,*)
      real(8), intent(inout) :: v_x(1:nv,*)
      real(8), intent(inout) :: u_t(*), v_t(1:nv,*)
      real(8), intent(in)    :: d_t(*)

      integer                :: n, blk_0
      integer                :: x_pos, y_pos
      integer                :: n1, n2, n3, n4
      integer                :: i_1, i_2, i_3
      integer                :: j_1, j_2, j_3
      integer                :: k_1, k_2, k_3
      integer                :: L

      integer                :: local_size, local_rank
      integer                :: ll_size, ll_rank

      include 'param.h'

      real(8) :: d1, d2


      local_rank = 0
      local_size = 1
!$    local_rank = omp_get_thread_num()
!$    local_size = omp_get_num_threads()

      L = i-2

      i_2 = eigen_loop_start(1, y_nnod,y_inod)
      i_3 = eigen_loop_end  (L, y_nnod,y_inod)
      j_2 = eigen_loop_start(1, x_nnod,x_inod)
      j_3 = eigen_loop_end  (L, x_nnod,x_inod)

      y_pos  = eigen_translate_g2l(i, y_nnod,y_inod)
      x_pos  = eigen_translate_g2l(L, x_nnod,x_inod)

      k_1   = i-i_base
      k_2   = m
      n     = i_3
      blk_0 = k_1-k_2


      n1 = offset1+nv*local_rank
      n2 = offset2+nv*local_rank
      n3 = offset3+nv*local_rank
      n4 = offset4+nv*local_rank

      do j_1=1,x_pos
         u0_z(j_1+n1) = ZERO
         u1_z(j_1+n3) = ZERO
      end do! j_1
      do j_1=1,y_pos
         v0_z(j_1+n2) = ZERO
         v1_z(j_1+n4) = ZERO
      end do! j_1

         call  eigen_prd_au_body1(
     &            a, nm,
     &            u_x(1,1), u_y(1,1),
     &            u_x(1,2), u_y(1,2),
     &            u0_z(1+n1), v0_z(1+n2),
     &            u1_z(1+n3), v1_z(1+n4),
     &            1, n, x_pos, y_pos, nv, blk_0
     &            ,local_rank, local_size
     &            )

!$OMP BARRIER

      call  eigen_prd_au_body2(
     &         v_x(1,1), u0_z(1+offset1), u1_z(1+offset3),
     &         v_t(1,1), v0_z(1+offset2), v1_z(1+offset4),
     &         nv, x_pos, y_pos
     &         ,local_rank, local_size
     &         )

#if USE_SYNC
!$OMP MASTER
!      if ( MIN(x_pos, y_pos) >= 4096 ) then
      call barrier( x_COMM_WORLD )
!      end if
!$OMP END MASTER
#endif

!$OMP BARRIER

!$OMP MASTER

      if ( TRD_nnod > 1 ) then
         u_t(1:y_pos) = v_t(1:y_pos,1)
         u_t(1+y_pos:2*y_pos) = v_t(1:y_pos,2)
#if _DEBUG_
         d1 = eigen_get_wtime()
#endif
         call reduce_dbl(u_t, v_t, 2*y_pos, 1, x_COMM_WORLD)
#if _DEBUG_
         d2 = eigen_get_wtime()
#if _DEBUG2_
         rt_ptr(5) = rt_ptr(5) + 1
         rt_timer(rt_ptr(5),5) = d2-d1
#endif
#endif
         v_t(1:y_pos,1) = u_t(1:y_pos)
         v_t(1:y_pos,2) = u_t(1+y_pos:2*y_pos)
      end if

!$OMP END MASTER

!$OMP BARRIER

!=!$OMP MASTER
!$    if ( local_size == 1 .OR. local_rank == 1 ) then
      call  eigen_prd_au_body3(
     &         u_x, u_y, v_x,
     &         u_t, v_t, d_t,
     &         1, n, x_pos, y_pos, nv
     &         )
!$    end if
!=!$OMP END MASTER

#if USE_SYNC
!=!$    if ( local_rank == 1 ) then
!$OMP MASTER
!      if ( MIN(x_pos, y_pos) >= 4096 ) then
      call barrier( y_COMM_WORLD )
!      end if
!$OMP END MASTER
!=!$    end if
#endif

!$OMP BARRIER

!$OMP MASTER

      if ( TRD_nnod > 1 ) then
         v_t(1:x_pos,1) = v_x(1:x_pos,1)
         v_t(1+x_pos:2*x_pos,1) = v_x(1:x_pos,2)
#if _DEBUG_
         d1 = eigen_get_wtime()
#endif
         call reduce_dbl(v_t, u_t, 2*x_pos, x_nnod, y_COMM_WORLD)
#if _DEBUG_
         d2 = eigen_get_wtime()
#if _DEBUG2_
         rt_ptr(6) = rt_ptr(6) + 1
         rt_timer(rt_ptr(6),6) = d2-d1
#endif
#endif
         v_x(1:x_pos,1) = v_t(1:x_pos,1)
         v_x(1:x_pos,2) = v_t(1+x_pos:2*x_pos,1)
      end if

!$OMP END MASTER

!$OMP BARRIER

      return
      end subroutine  eigen_prd_au

      subroutine  eigen_prd_au_body1(
     &               a, nm,
     &               u0_x, u0_y, u1_x, u1_y,
     &               u0_t, v0_t, u1_t, v1_t,
     &               n1, n2, x_pos, y_pos, nv, blk_0
     &               ,local_rank, local_size
     &               )
      use eigen_devel
      use eigen_libs
      implicit NONE

      integer, intent(in)    :: nm, nv, n1, n2
      real(8), intent(inout) :: a(1:nm,*)
      real(8), intent(inout) :: u0_x(1:nv), u0_y(1:nv)
      real(8), intent(inout) :: u1_x(1:nv), u1_y(1:nv)
      real(8), intent(inout) :: u0_t(1:nv), v0_t(1:nv)
      real(8), intent(inout) :: u1_t(1:nv), v1_t(1:nv)
      integer, intent(in)    :: blk_0
      integer                :: x_pos, y_pos
      integer                :: local_size, local_rank

      integer                :: i_0, i_1, i_2, i_3, i_4
      integer                :: j_1, j_2, j_3, j_4
      integer                :: k_1, k_2, k_3, k_4
      integer                :: l_1, l_2, l_3, l_4
      integer                :: i, j, k

      real(8)                :: v0, u0
      real(8)                :: v1, u1
      real(8)                :: w0_(0:8), w1_(0:8)
#if defined(__FUJITSU)
#define w0_(x)  w0_##x
#define w1_(x)  w1_##x
#endif
      real(8)                :: w0_0, w1_0
      real(8)                :: w0_1, w1_1
      real(8)                :: w0_2, w1_2
      real(8)                :: w0_3, w1_3
      real(8)                :: w0_4, w1_4
      real(8)                :: w0_5, w1_5
      real(8)                :: w0_6, w1_6
      real(8)                :: w0_7, w1_7
      real(8)                :: a0_0
      real(8)                :: a0_1
      real(8)                :: a0_2
      real(8)                :: a0_3
      real(8)                :: a0_4
      real(8)                :: a0_5
      real(8)                :: a0_6
      real(8)                :: a0_7
      real(8)                :: v0_t0, u0_y0
      real(8)                :: v1_t0, u1_y0
      real(8)                :: v0_t1, u0_y1
      real(8)                :: v1_t1, u1_y1
      real(8)                :: v0_t2, u0_y2
      real(8)                :: v1_t2, u1_y2
      real(8)                :: v0_t3, u0_y3
      real(8)                :: v1_t3, u1_y3
      real(8)                :: v0_t4, u0_y4
      real(8)                :: v1_t4, u1_y4
      real(8)                :: v0_t5, u0_y5
      real(8)                :: v1_t5, u1_y5
      real(8)                :: v0_t6, u0_y6
      real(8)                :: v1_t6, u1_y6
      real(8)                :: v0_t7, u0_y7
      real(8)                :: v1_t7, u1_y7

      integer                ::   LX, LY
      integer                ::   ii_1, ii_2, ii_3, ii_4, ii_5
      integer                ::   jj_1, jj_2, jj_3, jj_4, jj_5
      integer                ::   kk_1, kk_2, kk_3, kk_4, kk_5

      include 'param.h'

! for FX10 DO_UNROLL=7 is the best
#define         DO_UNROLL       7
! for FX10 DO_ITR=1 is the best
#define         DO_ITR          1
! for FX10 VLEN=(16*30) is the best
#define         VLEN            (16*30)
!#define         LX_ITR          8
!#define         LX_ITR          10
!=#define         LX_ITR           9
#define         LX_ITR           6

      i_2 = n1
      i_3 = n2

!
! v:= Au
!
      if ( blk_0 == 0 ) then
         do i_1=i_2+local_rank,i_3,local_size
            j   = eigen_translate_l2g(i_1, y_nnod,y_inod)
            j_3 = eigen_loop_end  (j, x_nnod,x_inod)
            j   = j+y_nnod*(DO_UNROLL*DO_ITR-1)
            j_4 = eigen_loop_end  (j, x_nnod,x_inod)
            do j_1=j_3+1,MIN(j_4,nm)
               a(j_1,i_1) = ZERO
            end do! j_1
         end do! i_1
!$OMP BARRIER
      end if
!
!
      LX = VLEN*LX_ITR; LY = 32*1
!
      l_2 = i_2; l_3 = i_3
      l_1 = l_2; l_4 = l_3

      k_2 = 1
      k   = eigen_translate_l2g(l_4, y_nnod,y_inod)
      k_3 = eigen_loop_end  (k-1, x_nnod,x_inod)
      do k_1=k_2,k_3,LX; k_4 = MIN(k_3,k_1+LX-1)

         j    = eigen_translate_l2g(k_1, x_nnod,x_inod)
         ii_2 = eigen_loop_start(j,y_nnod,y_inod)
         ii_2 = MAX(l_1,ii_2)
         ii_3 = l_4
         if ( ii_2 > ii_3 ) cycle
         ii_4 = MOD(ii_3-ii_2+1,DO_UNROLL*DO_ITR)+ii_2

         do i_1=ii_2+local_rank,ii_4-1,local_size

            j    = eigen_translate_l2g(i_1, y_nnod,y_inod)
            j    = j+(1-1)*y_nnod
            jj_2 = k_1
            jj_3 = eigen_loop_end  (j-1, x_nnod,x_inod)
            jj_3 = MIN(k_4,jj_3)
            if ( jj_2 > jj_3 ) cycle

            do kk_1=jj_2,jj_3,VLEN; kk_4=MIN(kk_1+VLEN-1,jj_3)

                  w0_(0) = v0_t(i_1+0)
                  w1_(0) = v1_t(i_1+0)
!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
               do j_1=kk_1,kk_4
!               do j_1=jj_2,jj_3

                  u0 = u0_x(j_1+0)
                  u1 = u1_x(j_1+0)

                  a0_0 = a(j_1+0,i_1+0)
                  w0_(0) = w0_(0)
     &                        + (a0_0*u0)
                  w1_(0) = w1_(0)
     &                        + (a0_0*u1)

               end do! j_1

                  v0_t(i_1+0) = w0_(0)
                  v1_t(i_1+0) = w1_(0)

#if defined(__INTEL_COMPILER)
               call MM_PREFETCH(a(kk_1,i_1),1)
#endif

               u0_y0 = u0_y(i_1+0)
               u1_y0 = u1_y(i_1+0)

!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
               do j_1=kk_1,kk_4
!               do j_1=jj_2,jj_3

                  v0 = ZERO
                  v1 = ZERO

                  a0_0 = a(j_1+0,i_1+0)
                  v0 = v0
     &                        + (a0_0*u0_y0)

                  v1 = v1
     &                        + (a0_0*u1_y0)

                  u0_t(j_1+0) = u0_t(j_1+0) + v0
                  u1_t(j_1+0) = u1_t(j_1+0) + v1

               end do! j_1

            enddo ! kk_1

         end do! i_1

         do i_0=ii_4+local_rank*DO_UNROLL*DO_ITR,
     &          ii_3,
     6          local_size*DO_UNROLL*DO_ITR

            j    = eigen_translate_l2g(i_0, y_nnod,y_inod)
            j    = j+(DO_UNROLL*DO_ITR-1)*y_nnod
            jj_2 = k_1
            jj_3 = eigen_loop_end  (j-1, x_nnod,x_inod)
            jj_3 = MIN(k_4,jj_3)
            if ( jj_2 > jj_3 ) cycle

            do kk_1=jj_2,jj_3,VLEN; kk_4=MIN(kk_1+VLEN-1,jj_3)

            do i_1 = i_0,i_0+DO_UNROLL*DO_ITR-1,DO_UNROLL

                  w0_(0) = v0_t(i_1+0)
                  w1_(0) = v1_t(i_1+0)
                  w0_(1) = v0_t(i_1+1)
                  w1_(1) = v1_t(i_1+1)

!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
               do j_1=kk_1,kk_4
!               do j_1=jj_2,jj_3

                  u0 = u0_x(j_1+0)
                  u1 = u1_x(j_1+0)

                  a0_0 = a(j_1+0,i_1+0)
                  a0_1 = a(j_1+0,i_1+1)

                  w0_(0) = w0_(0)
     &                        + (a0_0*u0)
                  w1_(0) = w1_(0)
     &                        + (a0_0*u1)

                  w0_(1) = w0_(1)
     &                        + (a0_1*u0)
                  w1_(1) = w1_(1)
     &                        + (a0_1*u1)

               end do! j_1

               v0_t(i_1+0) = w0_(0)
               v1_t(i_1+0) = w1_(0)
               v0_t(i_1+1) = w0_(1)
               v1_t(i_1+1) = w1_(1)

#if defined(__INTEL_COMPILER)
               call MM_PREFETCH(a(kk_1,i_1),1)
#endif

               w0_(2) = v0_t(i_1+2)
               w1_(2) = v1_t(i_1+2)
               w0_(3) = v0_t(i_1+3)
               w1_(3) = v1_t(i_1+3)
               w0_(4) = v0_t(i_1+4)
               w1_(4) = v1_t(i_1+4)
#if DO_UNROLL>=6
               w0_(5) = v0_t(i_1+5)
               w1_(5) = v1_t(i_1+5)
#endif
#if DO_UNROLL>=7
               w0_(6) = v0_t(i_1+6)
               w1_(6) = v1_t(i_1+6)
#endif
#if DO_UNROLL>=8
               w0_(7) = v0_t(i_1+7)
               w1_(7) = v1_t(i_1+7)
#endif

               u0_y0 = u0_y(i_1+0)
               u0_y1 = u0_y(i_1+1)
               u0_y2 = u0_y(i_1+2)
               u0_y3 = u0_y(i_1+3)
               u0_y4 = u0_y(i_1+4)
#if DO_UNROLL>=6
               u0_y5 = u0_y(i_1+5)
#endif
#if DO_UNROLL>=7
               u0_y6 = u0_y(i_1+6)
#endif
#if DO_UNROLL>=8
               u0_y7 = u0_y(i_1+7)
#endif
               u1_y0 = u1_y(i_1+0)
               u1_y1 = u1_y(i_1+1)
               u1_y2 = u1_y(i_1+2)
               u1_y3 = u1_y(i_1+3)
               u1_y4 = u1_y(i_1+4)
#if DO_UNROLL>=6
               u1_y5 = u1_y(i_1+5)
#endif
#if DO_UNROLL>=7
               u1_y6 = u1_y(i_1+6)
#endif
#if DO_UNROLL>=8
               u1_y7 = u1_y(i_1+7)
#endif

!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
               do j_1=kk_1,kk_4
!               do j_1=jj_2,jj_3

                  u0 = u0_x(j_1+0)
                  u1 = u1_x(j_1+0)

                  a0_0 = a(j_1+0,i_1+0)
                  a0_1 = a(j_1+0,i_1+1)

                  v0 = ZERO
                  v1 = ZERO

                  v0 = v0
     &                        + (a0_0*u0_y0)
     &                        + (a0_1*u0_y1)
                  v1 = v1
     &                        + (a0_0*u1_y0)
     &                        + (a0_1*u1_y1)

                  a0_2 = a(j_1+0,i_1+2)
                  a0_3 = a(j_1+0,i_1+3)

                  w0_(2) = w0_(2)
     &                        + (a0_2*u0)
                  w1_(2) = w1_(2)
     &                        + (a0_2*u1)
                  w0_(3) = w0_(3)
     &                        + (a0_3*u0)
                  w1_(3) = w1_(3)
     &                        + (a0_3*u1)

                  v0 = v0
     &                        + (a0_2*u0_y2)
     &                        + (a0_3*u0_y3)
                  v1 = v1
     &                        + (a0_2*u1_y2)
     &                        + (a0_3*u1_y3)

                  a0_4 = a(j_1+0,i_1+4)
#if DO_UNROLL>=6
                  a0_5 = a(j_1+0,i_1+5)
#endif

                  w0_(4) = w0_(4)
     &                        + (a0_4*u0)
                  w1_(4) = w1_(4)
     &                        + (a0_4*u1)
#if DO_UNROLL>=6
                  w0_(5) = w0_(5)
     &                        + (a0_5*u0)
                  w1_(5) = w1_(5)
     &                        + (a0_5*u1)
#endif

                  v0 = v0
     &                        + (a0_4*u0_y4)
#if DO_UNROLL>=6
     &                        + (a0_5*u0_y5)
#endif
                  v1 = v1
     &                        + (a0_4*u1_y4)
#if DO_UNROLL>=6
     &                        + (a0_5*u1_y5)
#endif

#if DO_UNROLL>=7
                  a0_6 = a(j_1+0,i_1+6)
#endif
#if DO_UNROLL>=8
                  a0_7 = a(j_1+0,i_1+7)
#endif
#if DO_UNROLL>=7
                  w0_(6) = w0_(6)
     &                        + (a0_6*u0)
                  w1_(6) = w1_(6)
     &                        + (a0_6*u1)
#endif
#if DO_UNROLL>=8
                  w0_(7) = w0_(7)
     &                        + (a0_7*u0)
                  w1_(7) = w1_(7)
     &                        + (a0_7*u1)
#endif
                  v0 = v0
#if DO_UNROLL>=7
     &                        + (a0_6*u0_y6)
#endif
#if DO_UNROLL>=8
     &                        + (a0_7*u0_y7)
#endif
                  v1 = v1
#if DO_UNROLL>=7
     &                        + (a0_6*u1_y6)
#endif
#if DO_UNROLL>=8
     &                        + (a0_7*u1_y7)
#endif

                  u0_t(j_1+0) = u0_t(j_1+0) + v0
                  u1_t(j_1+0) = u1_t(j_1+0) + v1

               end do! j_1

               v0_t(i_1+2) = w0_(2)
               v1_t(i_1+2) = w1_(2)
               v0_t(i_1+3) = w0_(3)
               v1_t(i_1+3) = w1_(3)
               v0_t(i_1+4) = w0_(4)
               v1_t(i_1+4) = w1_(4)
#if DO_UNROLL>=6
               v0_t(i_1+5) = w0_(5)
               v1_t(i_1+5) = w1_(5)
#endif
#if DO_UNROLL>=7
               v0_t(i_1+6) = w0_(6)
               v1_t(i_1+6) = w1_(6)
#endif
#if DO_UNROLL>=8
               v0_t(i_1+7) = w0_(7)
               v1_t(i_1+7) = w1_(7)
#endif

           end do! i_1
           end do! kk_1

         end do! i_0

      end do! k_1


      return
      end subroutine  eigen_prd_au_body1

      subroutine  eigen_prd_au_body2(
     &               u_t, u0_z, u1_z, v_t, v0_z, v1_z, nv,
     &               x_pos, y_pos
     &               ,local_rank, local_size
     &               )
      implicit NONE

      integer, intent(in)    :: nv, x_pos, y_pos
      real(8), intent(out)   :: u_t(1:nv,*),  v_t(1:nv,*)
      real(8), intent(in)    :: u0_z(1:nv,*), v0_z(1:nv,*)
      real(8), intent(in)    :: u1_z(1:nv,*), v1_z(1:nv,*)

      integer                :: local_rank, local_size

      integer                :: i_1, i_2, i_3, i_4
      integer                :: j_1, j_2, j_3, j_4
      integer                :: jj_1, jj_2, jj_3, jj_4
      integer                :: i, j, k

      integer, parameter     :: LX = 1024

      integer                :: ll_size, ll_rank

      ll_rank =    local_rank
      ll_size =    local_size
      if ( local_size > 1 ) then
         ll_rank =    ll_rank - 1
         ll_size =    ll_size - 1
      end if
      if ( ll_rank < 0 ) return

      jj_1 = x_pos
      jj_2 = (jj_1-1)/ll_size+1
      jj_3 =    (jj_2*(ll_rank+0)     )+1
      jj_4 = MIN(jj_2*(ll_rank+1),jj_1)

      do jj_1=jj_3,jj_4,LX
         j_3=jj_1; j_4=MIN(jj_1+LX-1,jj_4)
         if ( MOD(local_size,2) == 1 ) then
            do j_1=j_3,j_4
               u_t(j_1,1) = u0_z(j_1,1)
               u_t(j_1,2) = u1_z(j_1,1)
            end do
         else
            do j_1=j_3,j_4
               u_t(j_1,1) = u0_z(j_1,1)+u0_z(j_1,2)
               u_t(j_1,2) = u1_z(j_1,1)+u1_z(j_1,2)
            end do
         end if
         if ( local_size > 2 ) then
         do j=3-MOD(local_size,2),local_size,2
            do j_1=j_3,j_4
               u_t(j_1,1) = u_t(j_1,1)+u0_z(j_1,j+0)+u0_z(j_1,j+1)
               u_t(j_1,2) = u_t(j_1,2)+u1_z(j_1,j+0)+u1_z(j_1,j+1)
            end do
         end do
         end if
      end do

      jj_1 = y_pos
      jj_2 = (jj_1-1)/ll_size+1
      jj_3 =    (jj_2*(ll_rank+0)     )+1
      jj_4 = MIN(jj_2*(ll_rank+1),jj_1)

      do jj_1=jj_3,jj_4,LX
         j_3=jj_1; j_4=MIN(jj_1+LX-1,jj_4)
         if ( MOD(local_size,2) == 1 ) then
            do j_1=j_3,j_4
               v_t(j_1,1) = v0_z(j_1,1)
               v_t(j_1,2) = v1_z(j_1,1)
            end do
         else
            do j_1=j_3,j_4
               v_t(j_1,1) = v0_z(j_1,1)+v0_z(j_1,2)
               v_t(j_1,2) = v1_z(j_1,1)+v1_z(j_1,2)
            end do
         end if
         if ( local_size > 2 ) then
         do j=3-MOD(local_size,2),local_size,2
            do j_1=j_3,j_4
               v_t(j_1,1) = v_t(j_1,1)+v0_z(j_1,j+0)+v0_z(j_1,j+1)
               v_t(j_1,2) = v_t(j_1,2)+v1_z(j_1,j+0)+v1_z(j_1,j+1)
            end do
         end do
         end if
      end do

      return
      end subroutine  eigen_prd_au_body2

      subroutine  eigen_prd_au_body3(
     &               u_x, u_y, v_x,
     &               u_t, v_t, d_t,
     &               n1, n2, x_pos, y_pos, nv
     &               )
      use eigen_devel
      use eigen_libs
      implicit NONE

      integer, intent(in)    :: nv, n1, n2
      real(8), intent(in)    :: u_x(1:nv,*),u_y(1:nv,*)
      real(8), intent(inout) :: v_x(1:nv,*)
      real(8), intent(in)    :: u_t(1:nv,*),v_t(1:nv,*)
      real(8), intent(in)    :: d_t(1:nv)
      integer                :: x_pos, y_pos

      integer                :: i_1, i_2, i_3, i_4
      integer                :: j_1, j_2, j_3, j_4
      integer                :: i, j, k
      integer                :: nm1, nm2


      i_2 = n1
      i_3 = n2

      if ( diag_0 > 0 ) then

         j = eigen_translate_l2g(diag_0, y_nnod,y_inod)
         j = eigen_translate_g2l(j, x_nnod,x_inod)
         if ( j > nv ) return

         nm1 = y_nnod/n_common
         nm2 = x_nnod/n_common

         do i=1,MBAND

            if ( nm2 == 1 ) then
            if ( nm1 == 1 ) then
               call eigen_prd_au_body3_sub11(
     &            v_x(j,i), v_t(diag_0,i), d_t(diag_0), u_y(diag_0,i),
     &            (i_3-diag_0)/(x_nnod/n_common)+1, nm1, nm2)
            else
               call eigen_prd_au_body3_subX1(
     &            v_x(j,i), v_t(diag_0,i), d_t(diag_0), u_y(diag_0,i),
     &            (i_3-diag_0)/(x_nnod/n_common)+1, nm1, nm2)
            end if
            else
               call eigen_prd_au_body3_subXX(
     &            v_x(j,i), v_t(diag_0,i), d_t(diag_0), u_y(diag_0,i),
     &            (i_3-diag_0)/(x_nnod/n_common)+1, nm1, nm2)
            end if

          end do! i

       end if


       return
       end subroutine  eigen_prd_au_body3

      subroutine eigen_prd_au_body3_subXX(v_x,v_t,d_t,u_y, n,nm1,nm2)
      implicit NONE

      integer, intent(in)    :: n, nm1, nm2
      real(8), intent(inout) :: v_x(nm1,*)
      real(8), intent(in)    :: v_t(nm2,*)
      real(8), intent(in)    :: d_t(nm2,*)
      real(8), intent(in)    :: u_y(nm2,*)

      integer                :: i


*soption unroll(4)
!DIR$ VECTOR ALWAYS
      do i=1,n
         v_x(1,i) = v_x(1,i)+v_t(1,i)+d_t(1,i)*u_y(1,i)
      end do! i


      return
      end subroutine  eigen_prd_au_body3_subXX

      subroutine eigen_prd_au_body3_subX1(v_x,v_t,d_t,u_y, n,nm1,nm2)
      implicit NONE

      integer, intent(in)    :: n, nm1, nm2
      real(8), intent(inout) :: v_x(nm1,*)
      real(8), intent(in)    :: v_t(*)
      real(8), intent(in)    :: d_t(*)
      real(8), intent(in)    :: u_y(*)

      integer                :: i


*soption unroll(4)
!DIR$ VECTOR ALWAYS
      do i=1,n
         v_x(1,i) = v_x(1,i)+v_t(i)+d_t(i)*u_y(i)
      end do! i


      return
      end subroutine  eigen_prd_au_body3_subX1

      subroutine eigen_prd_au_body3_sub11(v_x,v_t,d_t,u_y, n,nm1,nm2)
      implicit NONE

      integer, intent(in)    :: n, nm1, nm2
      real(8), intent(inout) :: v_x(1:n)
      real(8), intent(in)    :: v_t(1:n)
      real(8), intent(in)    :: d_t(1:n)
      real(8), intent(in)    :: u_y(1:n)

      integer                :: i


*soption unroll(4)
!DIR$ VECTOR ALWAYS
      do i=1,n
         v_x(i) = v_x(i)+v_t(i)+d_t(i)*u_y(i)
      end do! i


      return
      end subroutine  eigen_prd_au_body3_sub11

          SUBROUTINE MY_PDLAED0(N, HBW, D, E, LDE, Q, IQ, JQ,
!     $                 DESCQ, WORK, IWORK, LDQ, CQ, INFO)
     $                 DESCQ, WORK, IWORK, CP, CQ, INFO)
*
        use MPI
        use eigen_devel
        use eigen_dc
        IMPLICIT NONE
        
!     This routine is a modified routine of PDLAED0
!     which is contained in the ScaLAPACK
!     Modification is done by T.Imamura
*
*     .. Scalar Arguments ..
!      INTEGER            INFO, IQ, JQ, N, LDQ, CQ, HBW, LDE
      INTEGER            INFO, IQ, JQ, N, CP, CQ, HBW, LDE
      INTEGER :: LDQ
*     ..
*     .. Array Arguments ..
      INTEGER            DESCQ( * ), IWORK( * )
      DOUBLE PRECISION   D( * ), Q( * ), WORK( * )
      DOUBLE PRECISION   E( LDE, HBW )
*     ..
*
*  Purpose
*  =======
*
*  MY_PDLAED0 computes all eigenvalues and corresponding eigenvectors of a
*  symmetric tridiagonal matrix using the divide and conquer method.
*
*
*  Arguments
*  =========
*
*  N       (global input) INTEGER
*          The order of the tridiagonal matrix T.  N >= 0.
*
*  D       (global input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the diagonal elements of the tridiagonal matrix.
*          On exit, if INFO = 0, the eigenvalues in descending order.
*
*  E1      (global input/output) DOUBLE PRECISION array, dimension (N-1)
*          On entry, the subdiagonal elements of the tridiagonal matrix.
*          On exit, E has been destroyed.

*              (added by Phuong) 
*  E2          (global input) DOUBLE PRECISION array, dimention (N-2)
*          On entry, the second subdiagonal of the matrix
*          On exit, E has been destroyed(?)


*
*  Q       (local output) DOUBLE PRECISION array,
*          global dimension (N, N),
*          local dimension ( LLD_Q, LOCc(JQ+N-1))
*          Q  contains the orthonormal eigenvectors of the symmetric
*          tridiagonal matrix.
*          On output, Q is distributed across the P processes in block
*          cyclic format.
*
*  IQ      (global input) INTEGER
*          Q's global row index, which points to the beginning of the
*          submatrix which is to be operated on.
*
*  JQ      (global input) INTEGER
*          Q's global column index, which points to the beginning of
*          the submatrix which is to be operated on.
*
*  DESCQ   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix Z.
*
*
*  WORK    (local workspace ) DOUBLE PRECISION array, dimension (LWORK)
*          LWORK = 6*N + 2*NP*NQ, with
*          NP = NUMROC( N, MB_Q, MYROW, IQROW, NPROW )
*          NQ = NUMROC( N, NB_Q, MYCOL, IQCOL, NPCOL )
*          IQROW = INDXG2P( IQ, NB_Q, MYROW, RSRC_Q, NPROW )
*          IQCOL = INDXG2P( JQ, MB_Q, MYCOL, CSRC_Q, NPCOL )
*
*  IWORK   (local workspace/output) INTEGER array, dimension (LIWORK)
*          LIWORK = 2 + 7*N + 8*NPCOL
*
*  INFO    (global output) INTEGER
*          = 0:  successful exit
*          < 0:  If the i-th argument is an array and the j-entry had
*                an illegal value, then INFO = -(i*100+j), if the i-th
*                argument is a scalar and had an illegal value, then
*                INFO = -i.
*          > 0:  The algorithm failed to compute the INFO/(N+1) th
*                eigenvalue while working on the submatrix lying in
*                global rows and columns mod(INFO,N+1).
*
*  =====================================================================
*
*     .. Parameters ..
*   
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9  )

*     ..
*     .. Local Scalars ..
      INTEGER            I, ID, IDCOL, IDROW, IID, IINFO, IIQ, IM1, IM2,
     $                   IPQ, IQCOL, IQROW, J, K, JJD, JJQ, MATSIZ,
     $                   MYCOL, MYROW, N1, NB, NBL, NBL1, NPCOL, NPROW,
     $                   SUBPBS, TSUBPBS, ISTAGE

      DOUBLE PRECISION   RHO
*       .. Local Arrays ..

!        INTEGER          DESCZ( 50 )

       real(8) :: C(HBW,HBW), S(HBW), U(HBW,HBW), VVT(HBW, HBW),
     $            VT(HBW,HBW), UUT(HBW,HBW), V(HBW+HBW, HBW)
       real(8), pointer ::  W(:)
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, DGEBR2D, DGEBS2D, DGERV2D,
     $                   DGESD2D, DSTEQR, INFOG2L, MY_PDLAED1, PXERBLA, 
     $                   MY_PDLAEDZ !, MAKELAMDAX
*     ..
*     .. External Functions ..
*     ..
      DOUBLE PRECISION               DNRM2
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MIN, MAX

      real(8) :: t1,t2,d1,d2
      integer :: MY_RANK, IC, REQ(10)
*     ..
*     .. Executable Statements ..
*
*       This is just to keep ftnchek and toolpack/1 happy
      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN


*
*     Test the input parameters.
*
      CALL BLACS_GRIDINFO( DESCQ( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )


      INFO = 0
      IF( DESCQ( NB_ ).GT.N .OR. N.LT.2 )
     $   INFO = -1
   
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( DESCQ( CTXT_ ), 'MY_PDLAED0', -INFO )
         RETURN
      END IF

*
*
      allocate( W(N) )
      NB = DESCQ( NB_ )
      LDQ = DESCQ( LLD_ )
      CALL INFOG2L( IQ, JQ, DESCQ, NPROW, NPCOL, MYROW, MYCOL, IIQ, JJQ,
     $              IQROW, IQCOL )

*
*     Determine the size and placement of the submatrices, and save in
*     the leading elements of IWORK.
*

      TSUBPBS = ( N-1 ) / NB + 1
      IWORK( 1 ) = TSUBPBS
      SUBPBS = 1
   10 CONTINUE
      IF( IWORK( SUBPBS ).GT.1 ) THEN
         DO 20 J = SUBPBS, 1, -1
            IWORK( 2*J ) = ( IWORK( J )+1 ) / 2
            IWORK( 2*J-1 ) = IWORK( J ) / 2
   20    CONTINUE
         SUBPBS = 2*SUBPBS
         GO TO 10
      END IF
      DO 30 J = 2, SUBPBS
         IWORK( J ) = IWORK( J ) + IWORK( J-1 )
   30 CONTINUE

*
*     Divide the matrix into TSUBPBS submatrices of size at most NB
*     using rank-1 modifications (cuts).
*


      DO 40 I = NB + 1, N, NB
          IM1 = I - 1
          
          C(1:HBW, 1:HBW) = 0

          DO J = 1, HBW
          DO K=1, MIN(J, N-IM1)
             C(HBW+K-J, K) = E(IM1-J+K, J)
          END DO      
          END DO

*         SVD : C = U*S*VT
          CALL DGESVD('A', 'A', HBW, HBW, C, HBW, S, U, HBW,  
     $                VT, HBW, WORK, 7*HBW, IINFO)        ! WORK size should be much larger than 7HBW

          DO  J = 1, HBW
             S(J) = SQRT(S(J))
          END DO
          DO  J = 1, HBW
          DO  K = 1, HBW
             U(K, J)  = U(K, J)  * S(J)
             VT(K,J) =  VT(K,J)  * S(K)
          END DO
          END DO

          CALL DGEMM('N', 'T', HBW, HBW, HBW, 1.0D+0, U, HBW, U, 
     $          HBW, 0.0D+0, UUT, HBW)

          CALL DGEMM('T', 'N', HBW, HBW, HBW, 1.0D+0, VT, HBW, VT, 
     $          HBW, 0.0D+0, VVT, HBW)
         
          DO J = 1, HBW
            D(IM1-HBW+J) = D(IM1-HBW+J) - UUT(J, J)
          IF  ( IM1+J <= N ) THEN
            D(IM1+J)     = D(IM1+J)     - VVT(J, J)
          END IF
          END DO
         
          DO J = 1, HBW-1
             DO  K = HBW-J, 1, -1
                E(IM1-K-J+1, J) = E(IM1-K-J+1, J) 
     $                             - UUT(HBW-K+1, 1-K+HBW-J) 
          IF  ( IM1+HBW-K+1 <= N ) THEN
                E(IM1+HBW-K-J+1,J) = E(IM1+HBW-K-J+1,J)
     $                             - VVT(HBW-K+1, 1-K+HBW-J) 
          END IF
             END DO
          END DO    


   40 CONTINUE

*
*     Solve each submatrix eigenproblem at the bottom of the divide and
*     conquer tree. D is the same on each process.
*

      d1 = MPI_WTIME()
      DO ID = 1, N, NB
         CALL INFOG2L( IQ-1+ID, JQ-1+ID, DESCQ, NPROW, NPCOL, MYROW,
     $                 MYCOL, IID, JJD, IDROW, IDCOL )
         MATSIZ = MIN( NB, N-ID+1 )
         IF( MYROW.EQ.IDROW .AND. MYCOL.EQ.IDCOL ) THEN
            IPQ = IID + ( JJD-1 )*LDQ
            
            CALL LAPACK_EIGEN2(N, MATSIZ, HBW, ID, D( ID ), 
     $                            E( ID, 1 ), LDE, Q( IPQ ), LDQ)
 
            IF( INFO.NE.0 ) THEN
               CALL PXERBLA( DESCQ( CTXT_ ), 'DSTEQR', -INFO )
               RETURN
            END IF

            WORK(ID:ID+MATSIZ-1) = D(ID:ID+MATSIZ-1)

         ELSE
            WORK(ID:ID+MATSIZ-1) = 0D0
         END IF
      END DO
      call reduce_dbl( WORK, D, N, 1, TRD_COMM_WORLD )
      D(1:N) = WORK(1:N)
      d2 = MPI_WTIME()
      p_time0 = p_time0 + (d2-d1)

*
*     Successively merge eigensystems of adjacent submatrices
*     into eigensystem for the corresponding larger matrix.
*



*     while ( SUBPBS > 1 )
*
   60 CONTINUE
      IF( SUBPBS.GT.1 ) THEN       

         IM2 = SUBPBS - 2
         DO 80 I = 0, IM2, 2   
            IF( I.EQ.0 ) THEN
               NBL = IWORK( 2 )
               NBL1 = IWORK( 1 )
               IF( NBL1.EQ.0 )
     $            GO TO 70
               ID = 1
               MATSIZ = MIN( N, NBL*NB )
               N1 = NBL1*NB
            ELSE
               NBL = IWORK( I+2 ) - IWORK( I )
               NBL1 = NBL / 2
               IF( NBL1.EQ.0 )
     $            GO TO 70
               ID = IWORK( I )*NB + 1
               MATSIZ = MIN( NB*NBL, N-ID+1 )
               N1 = NBL1*NB
            END IF

!            CALL DESCINIT( DESCZ, MATSIZ, 1, MATSIZ, 1, 0, 0,
!     $                        DESCQ(CTXT_),  MATSIZ, IINFO)    

*
*     Merge lower order eigensystems (of size N1 and MATSIZ - N1)
*     into an eigensystem of size MATSIZ.
*
            IM1 =  ID+N1 - 1

            C(1:HBW, 1:HBW) = 0

            DO J = 1, HBW
            DO K=1, MIN(J, N-IM1)
               C(HBW+K-J, K) = E(IM1-J+K, J)
            END DO
            END DO

            CALL DGESVD('A', 'A', HBW, HBW, C, HBW, S, U, HBW, VT,  
     $                  HBW, WORK, 7*HBW, IINFO)

            DO J = 1, HBW
               S(J)  = SQRT(S(J))
            END DO
            DO J = 1, HBW
            DO K = 1, HBW
               U(K, J) = U(K,J)  * S(J)
               VT(K,J) = VT(K,J) * S(K)
            END DO
            END DO

            DO K = 1, HBW
            DO J = 1, HBW
               V(J,K) = U(J,K);   V(HBW+J, K) = VT(K,J)
            END DO
            END DO


            DO K=1, HBW

               ISTAGE = MIN(K, 2)
               d1 = MPI_WTIME()
!$OMP PARALLEL
               CALL MY_PDLAEDZ(ISTAGE,
     $                       HBW, MATSIZ, N1, ID, Q, IQ, JQ, LDQ, 
     $                       DESCQ, W, WORK (1 + N), V(1,K))
!$OMP END PARALLEL
               d2 = MPI_WTIME()
               p_timez = p_timez + (d2-d1)

               RHO = DNRM2(MATSIZ, W, 1)
               IF(RHO .EQ. 0) CYCLE
               CALL DSCAL( MATSIZ, 1D0/RHO, W, 1)
               RHO = RHO * RHO

               CALL MY_PDLAED1( MATSIZ, N1, D( ID ), ID, Q, IQ, JQ,  
     $           DESCQ, RHO, WORK, IWORK( SUBPBS+1 ), W, ISTAGE, IINFO )

            END DO
    
            IF( IINFO.NE.0 ) THEN
               INFO = IINFO*( N+1 ) + ID
            END IF

   70       CONTINUE
            IWORK( I / 2+1 ) = IWORK( I+2 )
   80    CONTINUE
         SUBPBS = SUBPBS / 2

         GO TO 60

      END IF
*
*     end while
*
   90 CONTINUE

      deallocate( w )

      RETURN
*
*     End of MY_PDLAED0
*
      END

#!/bin/sh
#
BINDIR=/home/ktagami/work/ChargedDefect/Sxdefectalign/bin
#
$BINDIR/sxdefectalign --charge 2 --eps 12.88 --vdef ../electrostatic_pot.cube --vref ../../../Pristine/q_0/electrostatic_pot.cube --center 0.125,0.125,0.125 --relative --ecut 270 --qe > Log.1

#imrcolor,lincolorは2通りの指定方法(linecolor,linecolor2)のうち片方を使う
erange=" -erange -13,9"
einc="-einc 1.0"
imrfont="-imrfont Helvetica,14"
#ticsfont="-ticsfont Helvetica,12"
#imrcolor="-imrcolor #545422"
imrcolor2="-imrcolor blue"
#linecolor="-linecolor #545422"
linecolor2="-linecolor red"
imrtype="-imrtype mulliken"
#nonecross="-nonecross"
#kgrouptype="-kgrouptype HermannMauguin"
withfermi="-with_fermi ./nfefermi.data"
numimr="-numimr 0.15"
perl ~/phase/band_symm.09.2016test/perl/band_symm.pl reduce.data -linecolor red -erange -14,5 -with_fermi ./nfefermi.data -imrfont Hervetica,20 -ticsfont Helvetica,16  
#perl ~/phase/band_symm.09.2016test/perl/band_symm.pl reduce.data ${erange} ${einc} ${imrfont} ${ticsfont} ${imrcolor} ${imrcolor2} ${linecolor} ${linecolor2} ${imrtype} ${nonecross} ${kgrouptype} ${withfermi} ${numimr}
#echo "${erange} ${einc} ${imrfont} ${ticsfont} ${imrcolor} ${imrcolor2} ${linecolor} ${linecolor2} ${imrtype} ${nonecross} ${kgrouptype} ${withfermi} ${numimr}"
mv band_reduce.eps Si_03.eps

#!/bin/sh
# PHASE installer
# Copyright (C) 2007 Takenori YAMAMOTO

echo " === PHASE 3D installer ==="
while [ 0 -eq 0 ]
do

echo " Do you want to install PHASE 3D? (yes/no) [yes]"
read reply
if [ -z "${reply}" ]; then
reply="yes"
fi

# For SunOS
system=`uname`
if [ ${system} = 'SunOS' ]; then
PATH=/usr/xpg4/bin:${PATH}
cd bin
cat << 'here' > make
#!/bin/sh
dmake -m serial $*
here
chmod +x make
PATH=`pwd`:${PATH}
cd ..
fi

case ${reply} in
"yes")
cd src_phase_3d
/bin/bash configure
if [ ${?} -ne 0 ]; then
exit 1
fi
break
	;;
"no"|"exit")
exit 1
	;;
esac

done

while [ 0 -eq 0 ]
do

echo ""
echo " Do you want to edit the makefile that has been generated? (yes/no/exit) [no]"
read reply
if [ -z "${reply}" ]; then
reply="no"
fi

case ${reply} in
"no")
break
	;;
"exit")
exit 1
	;;
"yes")
while [ 0 -eq 0 ]
do

echo "Enter an editor that will be used to edit the makefile. [vi]"
read editor
if [ -z "${editor}" ]; then
editor="vi"
fi
${editor} Makefile
if [ ${?} -ne 0 ]; then
echo "Can ${editor} be used on the system?"  
continue
else
break
fi

done
	;;
*)
continue
	;;
esac
break

done


while [ 0 -eq 0 ]
do

echo " Do you want to make PHASE 3D now? (yes/no) [yes]"
read reply
if [ -z "${reply}" ]; then
reply="yes"
fi

case ${reply} in
"exit"|"no")
echo " PHASE 3D has not been made, but using the make command in the src directory you can make PHASE 3D later."
exit 0
	;;
"yes")
make all
if [ ${?} -ne 0 ]; then
exit 1
else
break
fi
	;;
esac

done

if [ ! -x phase ]; then
echo "Executable file 'phase' is not found. Probably, compilation failed."
exit 1
#elif [ ! -x ekcal ]; then
#echo "Executable file 'ekcal' is not found. Probably, compilation failed."
#exit 1
else
make install
if [ ${?} -ne 0 ]; then
exit 1
fi
make clean
if [ ${?} -ne 0 ]; then
exit 1
fi
echo "PHASE 3D was successfully installed."
fi

#cd ../test
#while [ 0 -eq 0 ]
#do

#echo "Do you want to check the installed programs? (yes/no) [no]"
#read reply
#if [ -z "${reply}" ]; then
#reply="no"
#fi

#case ${reply} in
#"yes")
#./Run.sh
#break
#	;;
#"no")
#exit 0
#	;;
#esac

#done
exit 0

#!/bin/sh -xe

cd eigen_h
make
cd ../eigen_s32
make
cd ../eigen_sx1
make
cd ../eigen_ex1
make
cd ..
ar r libEigen.a eigen_h/*.o eigen_s32/*.o eigen_sx1/*.o eigen_ex1/*.o
ranlib libEigen.a
mv eigen_*/lib* .

#!/bin/sh
for n in q_*; 
do
#    echo $n
    n1=`echo $n | sed -e 's/q_//g'`
    ene=0.0
    if [ -f $n/defect*atoms ]; then
	ene=`tail -1 $n/defect*atoms | awk '{print $NF}'`
    fi
    echo $n1 $ene
done
